#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 5151
#define SYMBOL_COUNT 308
#define ALIAS_COUNT 8
#define TOKEN_COUNT 142
#define EXTERNAL_TOKEN_COUNT 2
#define MAX_ALIAS_SEQUENCE_LENGTH 9

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_EQ = 6,
  anon_sym_as = 7,
  anon_sym_namespace = 8,
  anon_sym_LBRACE = 9,
  anon_sym_COMMA = 10,
  anon_sym_RBRACE = 11,
  anon_sym_type = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_if = 19,
  anon_sym_else = 20,
  anon_sym_switch = 21,
  anon_sym_for = 22,
  anon_sym_LPAREN = 23,
  anon_sym_RPAREN = 24,
  anon_sym_in = 25,
  anon_sym_await = 26,
  anon_sym_of = 27,
  anon_sym_while = 28,
  anon_sym_do = 29,
  anon_sym_try = 30,
  anon_sym_with = 31,
  anon_sym_break = 32,
  anon_sym_continue = 33,
  anon_sym_debugger = 34,
  anon_sym_return = 35,
  anon_sym_throw = 36,
  anon_sym_SEMI = 37,
  anon_sym_COLON = 38,
  anon_sym_case = 39,
  anon_sym_catch = 40,
  anon_sym_finally = 41,
  anon_sym_yield = 42,
  anon_sym_LBRACK = 43,
  anon_sym_RBRACK = 44,
  anon_sym_LT = 45,
  anon_sym_GT = 46,
  anon_sym_SLASH = 47,
  sym_jsx_text = 48,
  sym_jsx_identifier = 49,
  anon_sym_DOT = 50,
  anon_sym_class = 51,
  anon_sym_async = 52,
  anon_sym_function = 53,
  anon_sym_EQ_GT = 54,
  anon_sym_new = 55,
  anon_sym_PLUS_EQ = 56,
  anon_sym_DASH_EQ = 57,
  anon_sym_STAR_EQ = 58,
  anon_sym_SLASH_EQ = 59,
  anon_sym_PERCENT_EQ = 60,
  anon_sym_CARET_EQ = 61,
  anon_sym_AMP_EQ = 62,
  anon_sym_PIPE_EQ = 63,
  anon_sym_GT_GT_EQ = 64,
  anon_sym_GT_GT_GT_EQ = 65,
  anon_sym_LT_LT_EQ = 66,
  anon_sym_STAR_STAR_EQ = 67,
  anon_sym_DOT_DOT_DOT = 68,
  anon_sym_QMARK = 69,
  anon_sym_AMP_AMP = 70,
  anon_sym_PIPE_PIPE = 71,
  anon_sym_GT_GT = 72,
  anon_sym_GT_GT_GT = 73,
  anon_sym_LT_LT = 74,
  anon_sym_AMP = 75,
  anon_sym_CARET = 76,
  anon_sym_PIPE = 77,
  anon_sym_PLUS = 78,
  anon_sym_DASH = 79,
  anon_sym_PERCENT = 80,
  anon_sym_STAR_STAR = 81,
  anon_sym_LT_EQ = 82,
  anon_sym_EQ_EQ = 83,
  anon_sym_EQ_EQ_EQ = 84,
  anon_sym_BANG_EQ = 85,
  anon_sym_BANG_EQ_EQ = 86,
  anon_sym_GT_EQ = 87,
  anon_sym_instanceof = 88,
  anon_sym_BANG = 89,
  anon_sym_TILDE = 90,
  anon_sym_void = 91,
  anon_sym_delete = 92,
  anon_sym_PLUS_PLUS = 93,
  anon_sym_DASH_DASH = 94,
  anon_sym_DQUOTE = 95,
  aux_sym_string_token1 = 96,
  anon_sym_SQUOTE = 97,
  aux_sym_string_token2 = 98,
  sym_escape_sequence = 99,
  sym_comment = 100,
  anon_sym_BQUOTE = 101,
  anon_sym_DOLLAR_LBRACE = 102,
  anon_sym_SLASH2 = 103,
  sym_regex_pattern = 104,
  sym_regex_flags = 105,
  sym_number = 106,
  anon_sym_target = 107,
  anon_sym_this = 108,
  sym_super = 109,
  sym_true = 110,
  sym_false = 111,
  sym_null = 112,
  sym_undefined = 113,
  anon_sym_AT = 114,
  anon_sym_static = 115,
  anon_sym_abstract = 116,
  anon_sym_get = 117,
  anon_sym_set = 118,
  anon_sym_declare = 119,
  anon_sym_public = 120,
  anon_sym_private = 121,
  anon_sym_protected = 122,
  anon_sym_module = 123,
  anon_sym_any = 124,
  anon_sym_number = 125,
  anon_sym_boolean = 126,
  anon_sym_string = 127,
  anon_sym_symbol = 128,
  anon_sym_require = 129,
  anon_sym_implements = 130,
  anon_sym_global = 131,
  anon_sym_interface = 132,
  anon_sym_extends = 133,
  anon_sym_enum = 134,
  sym_readonly = 135,
  anon_sym_is = 136,
  anon_sym_keyof = 137,
  anon_sym_LBRACE_PIPE = 138,
  anon_sym_PIPE_RBRACE = 139,
  sym__automatic_semicolon = 140,
  sym__template_chars = 141,
  sym_program = 142,
  sym_export_statement = 143,
  sym_export_clause = 144,
  sym__import_export_specifier = 145,
  sym__declaration = 146,
  sym_import_statement = 147,
  sym_import_clause = 148,
  sym__from_clause = 149,
  sym_namespace_import = 150,
  sym_named_imports = 151,
  sym_expression_statement = 152,
  sym_variable_declaration = 153,
  sym_lexical_declaration = 154,
  sym_variable_declarator = 155,
  sym_statement_block = 156,
  sym_if_statement = 157,
  sym_switch_statement = 158,
  sym_for_statement = 159,
  sym_for_in_statement = 160,
  sym_for_of_statement = 161,
  sym_while_statement = 162,
  sym_do_statement = 163,
  sym_try_statement = 164,
  sym_with_statement = 165,
  sym_break_statement = 166,
  sym_continue_statement = 167,
  sym_debugger_statement = 168,
  sym_return_statement = 169,
  sym_throw_statement = 170,
  sym_empty_statement = 171,
  sym_labeled_statement = 172,
  sym_switch_body = 173,
  sym_switch_case = 174,
  sym_switch_default = 175,
  sym_catch_clause = 176,
  sym_finally_clause = 177,
  sym_parenthesized_expression = 178,
  sym__expression = 179,
  sym_yield_expression = 180,
  sym_object = 181,
  sym_assignment_pattern = 182,
  sym_array = 183,
  sym_jsx_element = 184,
  sym_jsx_fragment = 185,
  sym_jsx_expression = 186,
  sym_jsx_opening_element = 187,
  sym_nested_identifier = 188,
  sym_jsx_namespace_name = 189,
  sym_jsx_closing_element = 190,
  sym_jsx_self_closing_element = 191,
  sym_jsx_attribute = 192,
  sym_anonymous_class = 193,
  sym_class = 194,
  sym_class_heritage = 195,
  sym_function = 196,
  sym_arrow_function = 197,
  sym_generator_function = 198,
  sym_call_expression = 199,
  sym_new_expression = 200,
  sym_await_expression = 201,
  sym_member_expression = 202,
  sym_subscript_expression = 203,
  sym_assignment_expression = 204,
  sym_augmented_assignment_expression = 205,
  sym__initializer = 206,
  sym_spread_element = 207,
  sym_ternary_expression = 208,
  sym_binary_expression = 209,
  sym_unary_expression = 210,
  sym_update_expression = 211,
  sym_sequence_expression = 212,
  sym_string = 213,
  sym_template_string = 214,
  sym_template_substitution = 215,
  sym_regex = 216,
  sym_meta_property = 217,
  sym_this = 218,
  sym_arguments = 219,
  sym_decorator = 220,
  sym__identifier_reference = 221,
  sym_decorator_member_expression = 222,
  sym_decorator_call_expression = 223,
  sym_class_body = 224,
  sym_public_field_definition = 225,
  sym_formal_parameters = 226,
  sym_rest_parameter = 227,
  sym_method_definition = 228,
  sym_pair = 229,
  sym__property_name = 230,
  sym_computed_property_name = 231,
  sym_non_null_expression = 232,
  sym_method_signature = 233,
  sym_abstract_method_signature = 234,
  sym_function_signature = 235,
  sym_as_expression = 236,
  sym_import_require_clause = 237,
  sym_implements_clause = 238,
  sym_ambient_declaration = 239,
  sym_abstract_class = 240,
  sym_module = 241,
  sym_internal_module = 242,
  sym__module = 243,
  sym_import_alias = 244,
  sym_nested_type_identifier = 245,
  sym_interface_declaration = 246,
  sym__type_reference = 247,
  sym_extends_clause = 248,
  sym_enum_declaration = 249,
  sym_enum_body = 250,
  sym__enum_member = 251,
  sym_enum_assignment = 252,
  sym_type_alias_declaration = 253,
  sym_accessibility_modifier = 254,
  sym_required_parameter = 255,
  sym_optional_parameter = 256,
  sym_type_annotation = 257,
  sym__type = 258,
  sym_constructor_type = 259,
  sym__primary_type = 260,
  sym_generic_type = 261,
  sym_type_predicate = 262,
  sym_type_query = 263,
  sym_index_type_query = 264,
  sym_lookup_type = 265,
  sym_literal_type = 266,
  sym__number = 267,
  sym_existential_type = 268,
  sym_this_type = 269,
  sym_flow_maybe_type = 270,
  sym_parenthesized_type = 271,
  sym_predefined_type = 272,
  sym_type_arguments = 273,
  sym_object_type = 274,
  sym_property_signature = 275,
  sym_call_signature = 276,
  sym_type_parameters = 277,
  sym_type_parameter = 278,
  sym_default_type = 279,
  sym_constraint = 280,
  sym_construct_signature = 281,
  sym_index_signature = 282,
  sym_array_type = 283,
  sym_tuple_type = 284,
  sym_union_type = 285,
  sym_intersection_type = 286,
  sym_function_type = 287,
  aux_sym_program_repeat1 = 288,
  aux_sym_export_statement_repeat1 = 289,
  aux_sym_export_clause_repeat1 = 290,
  aux_sym_named_imports_repeat1 = 291,
  aux_sym_variable_declaration_repeat1 = 292,
  aux_sym_switch_body_repeat1 = 293,
  aux_sym_object_repeat1 = 294,
  aux_sym_array_repeat1 = 295,
  aux_sym_jsx_element_repeat1 = 296,
  aux_sym_jsx_opening_element_repeat1 = 297,
  aux_sym_string_repeat1 = 298,
  aux_sym_string_repeat2 = 299,
  aux_sym_template_string_repeat1 = 300,
  aux_sym_class_body_repeat1 = 301,
  aux_sym_formal_parameters_repeat1 = 302,
  aux_sym_implements_clause_repeat1 = 303,
  aux_sym_extends_clause_repeat1 = 304,
  aux_sym_enum_body_repeat1 = 305,
  aux_sym_object_type_repeat1 = 306,
  aux_sym_type_parameters_repeat1 = 307,
  alias_sym_type_identifier = 308,
  alias_sym_array_pattern = 309,
  alias_sym_shorthand_property_identifier = 310,
  alias_sym_property_identifier = 311,
  alias_sym_object_pattern = 312,
  alias_sym_import_specifier = 313,
  alias_sym_export_specifier = 314,
  alias_sym_statement_identifier = 315,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_type] = "type",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_in] = "in",
  [anon_sym_await] = "await",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [sym_jsx_text] = "jsx_text",
  [sym_jsx_identifier] = "identifier",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "?",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [anon_sym_target] = "target",
  [anon_sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_abstract] = "abstract",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_require] = "require",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_extends] = "extends",
  [anon_sym_enum] = "enum",
  [sym_readonly] = "readonly",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "_import_export_specifier",
  [sym__declaration] = "_declaration",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym_for_of_statement] = "for_of_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__expression] = "_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_array] = "array",
  [sym_jsx_element] = "jsx_element",
  [sym_jsx_fragment] = "jsx_fragment",
  [sym_jsx_expression] = "jsx_expression",
  [sym_jsx_opening_element] = "jsx_opening_element",
  [sym_nested_identifier] = "nested_identifier",
  [sym_jsx_namespace_name] = "jsx_namespace_name",
  [sym_jsx_closing_element] = "jsx_closing_element",
  [sym_jsx_self_closing_element] = "jsx_self_closing_element",
  [sym_jsx_attribute] = "jsx_attribute",
  [sym_anonymous_class] = "anonymous_class",
  [sym_class] = "class",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_arrow_function] = "arrow_function",
  [sym_generator_function] = "generator_function",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_this] = "this",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym__identifier_reference] = "_identifier_reference",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_formal_parameters] = "formal_parameters",
  [sym_rest_parameter] = "rest_parameter",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_as_expression] = "as_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class] = "abstract_class",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym__type_reference] = "_type_reference",
  [sym_extends_clause] = "extends_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym__enum_member] = "_enum_member",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym_type_annotation] = "type_annotation",
  [sym__type] = "_type",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_this_type] = "this_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_property_signature] = "property_signature",
  [sym_call_signature] = "call_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_jsx_element_repeat1] = "jsx_element_repeat1",
  [aux_sym_jsx_opening_element_repeat1] = "jsx_opening_element_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [alias_sym_type_identifier] = "type_identifier",
  [alias_sym_array_pattern] = "array_pattern",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_object_pattern] = "object_pattern",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_export_specifier] = "export_specifier",
  [alias_sym_statement_identifier] = "statement_identifier",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_jsx_text] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_this] = {
    .visible = true,
    .named = false,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [sym_readonly] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_of_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_opening_element] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_namespace_name] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_self_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier_reference] = {
    .visible = false,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__type_reference] = {
    .visible = false,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym__enum_member] = {
    .visible = false,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_this_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_opening_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[27][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = sym_identifier,
  },
  [2] = {
    [0] = alias_sym_property_identifier,
  },
  [3] = {
    [0] = alias_sym_object_pattern,
  },
  [4] = {
    [0] = alias_sym_array_pattern,
  },
  [5] = {
    [0] = alias_sym_type_identifier,
  },
  [6] = {
    [1] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_statement_identifier,
  },
  [8] = {
    [2] = alias_sym_property_identifier,
  },
  [9] = {
    [0] = sym_identifier,
    [2] = alias_sym_property_identifier,
  },
  [10] = {
    [1] = alias_sym_statement_identifier,
  },
  [11] = {
    [1] = alias_sym_type_identifier,
  },
  [12] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [13] = {
    [0] = alias_sym_shorthand_property_identifier,
  },
  [14] = {
    [1] = alias_sym_array_pattern,
  },
  [15] = {
    [1] = alias_sym_object_pattern,
  },
  [16] = {
    [2] = alias_sym_type_identifier,
  },
  [17] = {
    [1] = alias_sym_import_specifier,
  },
  [18] = {
    [2] = sym_identifier,
  },
  [19] = {
    [2] = alias_sym_array_pattern,
  },
  [20] = {
    [2] = alias_sym_object_pattern,
  },
  [21] = {
    [1] = alias_sym_export_specifier,
  },
  [22] = {
    [3] = alias_sym_property_identifier,
  },
  [23] = {
    [3] = alias_sym_array_pattern,
  },
  [24] = {
    [3] = alias_sym_object_pattern,
  },
  [25] = {
    [4] = alias_sym_array_pattern,
  },
  [26] = {
    [4] = alias_sym_object_pattern,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(15);
      if (lookahead == '/')
        ADVANCE(16);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '\\')
        ADVANCE(26);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(34);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0)
        ADVANCE(36);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(37);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 4:
      if (lookahead == '!')
        ADVANCE(38);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '{')
        ADVANCE(39);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279)
        ADVANCE(36);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=')
        ADVANCE(40);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(41);
      if (lookahead == '=')
        ADVANCE(42);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*')
        ADVANCE(43);
      if (lookahead == '=')
        ADVANCE(44);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(45);
      if (lookahead == '=')
        ADVANCE(46);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(47);
      if (lookahead == '=')
        ADVANCE(48);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.')
        ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(50);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*')
        ADVANCE(51);
      if (lookahead == '/')
        ADVANCE(52);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.')
        ADVANCE(50);
      if (lookahead == '0')
        ADVANCE(53);
      if (lookahead == 'B' ||
          lookahead == 'b')
        ADVANCE(54);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(55);
      if (lookahead == 'O' ||
          lookahead == 'o')
        ADVANCE(56);
      if (lookahead == 'X' ||
          lookahead == 'x')
        ADVANCE(57);
      if (lookahead == 'n')
        ADVANCE(58);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(59);
      if (lookahead == '=')
        ADVANCE(60);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(61);
      if (lookahead == '>')
        ADVANCE(62);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(64);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 26:
      if (lookahead == 'u')
        ADVANCE(65);
      if (lookahead == 'x')
        ADVANCE(66);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(67);
      if (lookahead != 0)
        ADVANCE(68);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=')
        ADVANCE(69);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|')
        ADVANCE(70);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=')
        ADVANCE(71);
      if (lookahead == '|')
        ADVANCE(72);
      if (lookahead == '}')
        ADVANCE(73);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 34:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(15);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(34);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\\')
        ADVANCE(36);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.')
        ADVANCE(50);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(55);
      if (lookahead == 'n')
        ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279)
        ADVANCE(36);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=')
        ADVANCE(75);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(38);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=')
        ADVANCE(76);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 49:
      if (lookahead == '.')
        ADVANCE(77);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(50);
      END_STATE();
    case 51:
      if (lookahead == '*')
        ADVANCE(78);
      if (lookahead != 0)
        ADVANCE(51);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(52);
      END_STATE();
    case 53:
      if (lookahead == 'n')
        ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(53);
      END_STATE();
    case 54:
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(79);
      END_STATE();
    case 55:
      if (lookahead == '+' ||
          lookahead == '-')
        ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(81);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(82);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(83);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=')
        ADVANCE(84);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=')
        ADVANCE(85);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=')
        ADVANCE(86);
      if (lookahead == '>')
        ADVANCE(87);
      END_STATE();
    case 65:
      if (lookahead == '{')
        ADVANCE(88);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(89);
      END_STATE();
    case 66:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(90);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(91);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*')
        ADVANCE(51);
      if (lookahead == '/')
        ADVANCE(52);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 78:
      if (lookahead == '*')
        ADVANCE(78);
      if (lookahead == '/')
        ADVANCE(92);
      if (lookahead != 0)
        ADVANCE(51);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(79);
      END_STATE();
    case 80:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(81);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(81);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(82);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(83);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=')
        ADVANCE(93);
      END_STATE();
    case 88:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(94);
      END_STATE();
    case 89:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(66);
      END_STATE();
    case 90:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(68);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(68);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 94:
      if (lookahead == '}')
        ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(94);
      END_STATE();
    case 95:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(99);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(95);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(45);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(47);
      END_STATE();
    case 99:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(50);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 102:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(104);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(102);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != ')' &&
          lookahead != '\\' &&
          lookahead != ']')
        ADVANCE(36);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(50);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*')
        ADVANCE(51);
      if (lookahead == '/')
        ADVANCE(52);
      if (lookahead == '=')
        ADVANCE(105);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 106:
      if (lookahead == '$')
        ADVANCE(107);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '\\')
        ADVANCE(26);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(109);
      END_STATE();
    case 107:
      if (lookahead == '{')
        ADVANCE(39);
      END_STATE();
    case 108:
      if (lookahead == '*')
        ADVANCE(51);
      if (lookahead == '/')
        ADVANCE(52);
      END_STATE();
    case 109:
      if (lookahead == '$')
        ADVANCE(107);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(109);
      END_STATE();
    case 110:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(117);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(110);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != '\\' &&
          lookahead != ']')
        ADVANCE(36);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(41);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*')
        ADVANCE(118);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(119);
      if (lookahead == '=')
        ADVANCE(60);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(120);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(72);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>')
        ADVANCE(121);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 122:
      if (lookahead == '\n')
        SKIP(123);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '/')
        ADVANCE(124);
      if (lookahead == '\\')
        ADVANCE(26);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(125);
      if (lookahead != 0)
        ADVANCE(126);
      END_STATE();
    case 123:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(123);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*')
        ADVANCE(127);
      if (lookahead == '/')
        ADVANCE(126);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\')
        ADVANCE(126);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(125);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\')
        ADVANCE(126);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\')
        ADVANCE(126);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*')
        ADVANCE(128);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\')
        ADVANCE(127);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*')
        ADVANCE(128);
      if (lookahead == '/')
        ADVANCE(129);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\')
        ADVANCE(127);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\')
        ADVANCE(126);
      END_STATE();
    case 130:
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(132);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(15);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(133);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(130);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 134:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(132);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '=')
        ADVANCE(135);
      if (lookahead == '>')
        ADVANCE(136);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(133);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(134);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != '%' &&
          (lookahead < '\\' || '^' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>')
        ADVANCE(62);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 137:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(132);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(15);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(138);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(137);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}')
        ADVANCE(73);
      END_STATE();
    case 139:
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(132);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(15);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(133);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(139);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 140:
      if (lookahead == '\n')
        SKIP(141);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '/')
        ADVANCE(142);
      if (lookahead == '\\')
        ADVANCE(26);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(143);
      if (lookahead != 0)
        ADVANCE(144);
      END_STATE();
    case 141:
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(141);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*')
        ADVANCE(145);
      if (lookahead == '/')
        ADVANCE(144);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(144);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '/')
        ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(143);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(144);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(144);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*')
        ADVANCE(146);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(145);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*')
        ADVANCE(146);
      if (lookahead == '/')
        ADVANCE(147);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(145);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(144);
      END_STATE();
    case 148:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(132);
      if (lookahead == '+')
        ADVANCE(149);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(150);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '=')
        ADVANCE(151);
      if (lookahead == '>')
        ADVANCE(136);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(148);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(152);
      if (lookahead != 0 &&
          (lookahead < '!' || '~' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-')
        ADVANCE(153);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(152);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279)
        ADVANCE(36);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_jsx_identifier);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(153);
      END_STATE();
    case 154:
      if (lookahead == '\n')
        SKIP(155);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '[')
        ADVANCE(156);
      if (lookahead == '\\')
        ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(158);
      if (lookahead != 0)
        ADVANCE(159);
      END_STATE();
    case 155:
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(155);
      END_STATE();
    case 156:
      if (lookahead == '\\')
        ADVANCE(160);
      if (lookahead == ']')
        ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(156);
      END_STATE();
    case 157:
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(159);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '[')
        ADVANCE(156);
      if (lookahead == '\\')
        ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(158);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(159);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[')
        ADVANCE(156);
      if (lookahead == '\\')
        ADVANCE(157);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/')
        ADVANCE(159);
      END_STATE();
    case 160:
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(156);
      END_STATE();
    case 161:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(162);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(163);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(161);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < ')' || ':' < lookahead) &&
          lookahead != '\\' &&
          lookahead != ']')
        ADVANCE(36);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(61);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(72);
      if (lookahead == '}')
        ADVANCE(73);
      END_STATE();
    case 164:
      if (lookahead == '/')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(166);
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '}')
        ADVANCE(167);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*')
        ADVANCE(168);
      if (lookahead == '/')
        ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(167);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '/')
        ADVANCE(165);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(166);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(167);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(167);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*')
        ADVANCE(170);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(51);
      if (lookahead != 0)
        ADVANCE(168);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(52);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(169);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*')
        ADVANCE(170);
      if (lookahead == '/')
        ADVANCE(92);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(51);
      if (lookahead != 0)
        ADVANCE(168);
      END_STATE();
    case 171:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(132);
      if (lookahead == '+')
        ADVANCE(149);
      if (lookahead == '-')
        ADVANCE(150);
      if (lookahead == '.')
        ADVANCE(172);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(171);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '>' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 172:
      if (lookahead == '.')
        ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(50);
      END_STATE();
    case 173:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(174);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(163);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(173);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != '\\' &&
          lookahead != ']')
        ADVANCE(36);
      END_STATE();
    case 174:
      if (lookahead == '=')
        ADVANCE(61);
      END_STATE();
    case 175:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(104);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(176);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(175);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=')
        ADVANCE(71);
      if (lookahead == '|')
        ADVANCE(72);
      END_STATE();
    case 177:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(178);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(117);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(177);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 179:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(162);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(117);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(179);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 180:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(104);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(176);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(180);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != '\\' &&
          lookahead != ']' &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 181:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(117);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(181);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != '\\' &&
          lookahead != ']' &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 182:
      if (lookahead == '/')
        ADVANCE(16);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(155);
      END_STATE();
    case 183:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(178);
      if (lookahead == '/')
        ADVANCE(104);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(162);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '|')
        ADVANCE(176);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(183);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != ']' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 184:
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(132);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '=')
        ADVANCE(151);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(138);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(184);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 185:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '=')
        ADVANCE(135);
      if (lookahead == '>')
        ADVANCE(136);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(133);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(185);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '*' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 186:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(132);
      if (lookahead == '+')
        ADVANCE(149);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(150);
      if (lookahead == '.')
        ADVANCE(99);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '=')
        ADVANCE(135);
      if (lookahead == '>')
        ADVANCE(136);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(186);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 187:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(178);
      if (lookahead == '/')
        ADVANCE(104);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(162);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(176);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(187);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 188:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(178);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(174);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(117);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(189);
      if (('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(190);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != ']' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 189:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(178);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(174);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(117);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(189);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != ']' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_regex_flags);
      if (('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(190);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279)
        ADVANCE(36);
      END_STATE();
    case 191:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(192);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(174);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(117);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(191);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || ';' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.')
        ADVANCE(49);
      END_STATE();
    case 193:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '=')
        ADVANCE(135);
      if (lookahead == '>')
        ADVANCE(136);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(133);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(193);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 194:
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '.')
        ADVANCE(178);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '=')
        ADVANCE(151);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '|')
        ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(194);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 195:
      if (lookahead == '&')
        ADVANCE(131);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(108);
      if (lookahead == '=')
        ADVANCE(135);
      if (lookahead == '>')
        ADVANCE(136);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(195);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(152);
      if (lookahead != 0 &&
          (lookahead < '!' || '~' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 196:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(178);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(174);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(117);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(197);
      if (('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(190);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 197:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(178);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(174);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(117);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(197);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 198:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(111);
      if (lookahead == '&')
        ADVANCE(112);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(113);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(178);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(114);
      if (lookahead == '=')
        ADVANCE(162);
      if (lookahead == '>')
        ADVANCE(115);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '|')
        ADVANCE(117);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(198);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 199:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(178);
      if (lookahead == '/')
        ADVANCE(104);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(162);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '|')
        ADVANCE(176);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(199);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(36);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'a')
        ADVANCE(1);
      if (lookahead == 'b')
        ADVANCE(2);
      if (lookahead == 'c')
        ADVANCE(3);
      if (lookahead == 'd')
        ADVANCE(4);
      if (lookahead == 'e')
        ADVANCE(5);
      if (lookahead == 'f')
        ADVANCE(6);
      if (lookahead == 'g')
        ADVANCE(7);
      if (lookahead == 'i')
        ADVANCE(8);
      if (lookahead == 'k')
        ADVANCE(9);
      if (lookahead == 'l')
        ADVANCE(10);
      if (lookahead == 'm')
        ADVANCE(11);
      if (lookahead == 'n')
        ADVANCE(12);
      if (lookahead == 'o')
        ADVANCE(13);
      if (lookahead == 'p')
        ADVANCE(14);
      if (lookahead == 'r')
        ADVANCE(15);
      if (lookahead == 's')
        ADVANCE(16);
      if (lookahead == 't')
        ADVANCE(17);
      if (lookahead == 'u')
        ADVANCE(18);
      if (lookahead == 'v')
        ADVANCE(19);
      if (lookahead == 'w')
        ADVANCE(20);
      if (lookahead == 'y')
        ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'b')
        ADVANCE(22);
      if (lookahead == 'n')
        ADVANCE(23);
      if (lookahead == 's')
        ADVANCE(24);
      if (lookahead == 'w')
        ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o')
        ADVANCE(26);
      if (lookahead == 'r')
        ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a')
        ADVANCE(28);
      if (lookahead == 'l')
        ADVANCE(29);
      if (lookahead == 'o')
        ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e')
        ADVANCE(31);
      if (lookahead == 'o')
        ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l')
        ADVANCE(33);
      if (lookahead == 'n')
        ADVANCE(34);
      if (lookahead == 'x')
        ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a')
        ADVANCE(36);
      if (lookahead == 'i')
        ADVANCE(37);
      if (lookahead == 'o')
        ADVANCE(38);
      if (lookahead == 'r')
        ADVANCE(39);
      if (lookahead == 'u')
        ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e')
        ADVANCE(41);
      if (lookahead == 'l')
        ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f')
        ADVANCE(43);
      if (lookahead == 'm')
        ADVANCE(44);
      if (lookahead == 'n')
        ADVANCE(45);
      if (lookahead == 's')
        ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e')
        ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e')
        ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'o')
        ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a')
        ADVANCE(50);
      if (lookahead == 'e')
        ADVANCE(51);
      if (lookahead == 'u')
        ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'f')
        ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'r')
        ADVANCE(54);
      if (lookahead == 'u')
        ADVANCE(55);
      END_STATE();
    case 15:
      if (lookahead == 'e')
        ADVANCE(56);
      END_STATE();
    case 16:
      if (lookahead == 'e')
        ADVANCE(57);
      if (lookahead == 't')
        ADVANCE(58);
      if (lookahead == 'u')
        ADVANCE(59);
      if (lookahead == 'w')
        ADVANCE(60);
      if (lookahead == 'y')
        ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'a')
        ADVANCE(62);
      if (lookahead == 'h')
        ADVANCE(63);
      if (lookahead == 'r')
        ADVANCE(64);
      if (lookahead == 'y')
        ADVANCE(65);
      END_STATE();
    case 18:
      if (lookahead == 'n')
        ADVANCE(66);
      END_STATE();
    case 19:
      if (lookahead == 'a')
        ADVANCE(67);
      if (lookahead == 'o')
        ADVANCE(68);
      END_STATE();
    case 20:
      if (lookahead == 'h')
        ADVANCE(69);
      if (lookahead == 'i')
        ADVANCE(70);
      END_STATE();
    case 21:
      if (lookahead == 'i')
        ADVANCE(71);
      END_STATE();
    case 22:
      if (lookahead == 's')
        ADVANCE(72);
      END_STATE();
    case 23:
      if (lookahead == 'y')
        ADVANCE(73);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y')
        ADVANCE(74);
      END_STATE();
    case 25:
      if (lookahead == 'a')
        ADVANCE(75);
      END_STATE();
    case 26:
      if (lookahead == 'o')
        ADVANCE(76);
      END_STATE();
    case 27:
      if (lookahead == 'e')
        ADVANCE(77);
      END_STATE();
    case 28:
      if (lookahead == 's')
        ADVANCE(78);
      if (lookahead == 't')
        ADVANCE(79);
      END_STATE();
    case 29:
      if (lookahead == 'a')
        ADVANCE(80);
      END_STATE();
    case 30:
      if (lookahead == 'n')
        ADVANCE(81);
      END_STATE();
    case 31:
      if (lookahead == 'b')
        ADVANCE(82);
      if (lookahead == 'c')
        ADVANCE(83);
      if (lookahead == 'f')
        ADVANCE(84);
      if (lookahead == 'l')
        ADVANCE(85);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's')
        ADVANCE(86);
      END_STATE();
    case 34:
      if (lookahead == 'u')
        ADVANCE(87);
      END_STATE();
    case 35:
      if (lookahead == 'p')
        ADVANCE(88);
      if (lookahead == 't')
        ADVANCE(89);
      END_STATE();
    case 36:
      if (lookahead == 'l')
        ADVANCE(90);
      END_STATE();
    case 37:
      if (lookahead == 'n')
        ADVANCE(91);
      END_STATE();
    case 38:
      if (lookahead == 'r')
        ADVANCE(92);
      END_STATE();
    case 39:
      if (lookahead == 'o')
        ADVANCE(93);
      END_STATE();
    case 40:
      if (lookahead == 'n')
        ADVANCE(94);
      END_STATE();
    case 41:
      if (lookahead == 't')
        ADVANCE(95);
      END_STATE();
    case 42:
      if (lookahead == 'o')
        ADVANCE(96);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p')
        ADVANCE(97);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's')
        ADVANCE(98);
      if (lookahead == 't')
        ADVANCE(99);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y')
        ADVANCE(100);
      END_STATE();
    case 48:
      if (lookahead == 't')
        ADVANCE(101);
      END_STATE();
    case 49:
      if (lookahead == 'd')
        ADVANCE(102);
      END_STATE();
    case 50:
      if (lookahead == 'm')
        ADVANCE(103);
      END_STATE();
    case 51:
      if (lookahead == 'w')
        ADVANCE(104);
      END_STATE();
    case 52:
      if (lookahead == 'l')
        ADVANCE(105);
      if (lookahead == 'm')
        ADVANCE(106);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 54:
      if (lookahead == 'i')
        ADVANCE(107);
      if (lookahead == 'o')
        ADVANCE(108);
      END_STATE();
    case 55:
      if (lookahead == 'b')
        ADVANCE(109);
      END_STATE();
    case 56:
      if (lookahead == 'a')
        ADVANCE(110);
      if (lookahead == 'q')
        ADVANCE(111);
      if (lookahead == 't')
        ADVANCE(112);
      END_STATE();
    case 57:
      if (lookahead == 't')
        ADVANCE(113);
      END_STATE();
    case 58:
      if (lookahead == 'a')
        ADVANCE(114);
      if (lookahead == 'r')
        ADVANCE(115);
      END_STATE();
    case 59:
      if (lookahead == 'p')
        ADVANCE(116);
      END_STATE();
    case 60:
      if (lookahead == 'i')
        ADVANCE(117);
      END_STATE();
    case 61:
      if (lookahead == 'm')
        ADVANCE(118);
      END_STATE();
    case 62:
      if (lookahead == 'r')
        ADVANCE(119);
      END_STATE();
    case 63:
      if (lookahead == 'i')
        ADVANCE(120);
      if (lookahead == 'r')
        ADVANCE(121);
      END_STATE();
    case 64:
      if (lookahead == 'u')
        ADVANCE(122);
      if (lookahead == 'y')
        ADVANCE(123);
      END_STATE();
    case 65:
      if (lookahead == 'p')
        ADVANCE(124);
      END_STATE();
    case 66:
      if (lookahead == 'd')
        ADVANCE(125);
      END_STATE();
    case 67:
      if (lookahead == 'r')
        ADVANCE(126);
      END_STATE();
    case 68:
      if (lookahead == 'i')
        ADVANCE(127);
      END_STATE();
    case 69:
      if (lookahead == 'i')
        ADVANCE(128);
      END_STATE();
    case 70:
      if (lookahead == 't')
        ADVANCE(129);
      END_STATE();
    case 71:
      if (lookahead == 'e')
        ADVANCE(130);
      END_STATE();
    case 72:
      if (lookahead == 't')
        ADVANCE(131);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 74:
      if (lookahead == 'n')
        ADVANCE(132);
      END_STATE();
    case 75:
      if (lookahead == 'i')
        ADVANCE(133);
      END_STATE();
    case 76:
      if (lookahead == 'l')
        ADVANCE(134);
      END_STATE();
    case 77:
      if (lookahead == 'a')
        ADVANCE(135);
      END_STATE();
    case 78:
      if (lookahead == 'e')
        ADVANCE(136);
      END_STATE();
    case 79:
      if (lookahead == 'c')
        ADVANCE(137);
      END_STATE();
    case 80:
      if (lookahead == 's')
        ADVANCE(138);
      END_STATE();
    case 81:
      if (lookahead == 's')
        ADVANCE(139);
      if (lookahead == 't')
        ADVANCE(140);
      END_STATE();
    case 82:
      if (lookahead == 'u')
        ADVANCE(141);
      END_STATE();
    case 83:
      if (lookahead == 'l')
        ADVANCE(142);
      END_STATE();
    case 84:
      if (lookahead == 'a')
        ADVANCE(143);
      END_STATE();
    case 85:
      if (lookahead == 'e')
        ADVANCE(144);
      END_STATE();
    case 86:
      if (lookahead == 'e')
        ADVANCE(145);
      END_STATE();
    case 87:
      if (lookahead == 'm')
        ADVANCE(146);
      END_STATE();
    case 88:
      if (lookahead == 'o')
        ADVANCE(147);
      END_STATE();
    case 89:
      if (lookahead == 'e')
        ADVANCE(148);
      END_STATE();
    case 90:
      if (lookahead == 's')
        ADVANCE(149);
      END_STATE();
    case 91:
      if (lookahead == 'a')
        ADVANCE(150);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 93:
      if (lookahead == 'm')
        ADVANCE(151);
      END_STATE();
    case 94:
      if (lookahead == 'c')
        ADVANCE(152);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 96:
      if (lookahead == 'b')
        ADVANCE(153);
      END_STATE();
    case 97:
      if (lookahead == 'l')
        ADVANCE(154);
      if (lookahead == 'o')
        ADVANCE(155);
      END_STATE();
    case 98:
      if (lookahead == 't')
        ADVANCE(156);
      END_STATE();
    case 99:
      if (lookahead == 'e')
        ADVANCE(157);
      END_STATE();
    case 100:
      if (lookahead == 'o')
        ADVANCE(158);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 102:
      if (lookahead == 'u')
        ADVANCE(159);
      END_STATE();
    case 103:
      if (lookahead == 'e')
        ADVANCE(160);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 105:
      if (lookahead == 'l')
        ADVANCE(161);
      END_STATE();
    case 106:
      if (lookahead == 'b')
        ADVANCE(162);
      END_STATE();
    case 107:
      if (lookahead == 'v')
        ADVANCE(163);
      END_STATE();
    case 108:
      if (lookahead == 't')
        ADVANCE(164);
      END_STATE();
    case 109:
      if (lookahead == 'l')
        ADVANCE(165);
      END_STATE();
    case 110:
      if (lookahead == 'd')
        ADVANCE(166);
      END_STATE();
    case 111:
      if (lookahead == 'u')
        ADVANCE(167);
      END_STATE();
    case 112:
      if (lookahead == 'u')
        ADVANCE(168);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 114:
      if (lookahead == 't')
        ADVANCE(169);
      END_STATE();
    case 115:
      if (lookahead == 'i')
        ADVANCE(170);
      END_STATE();
    case 116:
      if (lookahead == 'e')
        ADVANCE(171);
      END_STATE();
    case 117:
      if (lookahead == 't')
        ADVANCE(172);
      END_STATE();
    case 118:
      if (lookahead == 'b')
        ADVANCE(173);
      END_STATE();
    case 119:
      if (lookahead == 'g')
        ADVANCE(174);
      END_STATE();
    case 120:
      if (lookahead == 's')
        ADVANCE(175);
      END_STATE();
    case 121:
      if (lookahead == 'o')
        ADVANCE(176);
      END_STATE();
    case 122:
      if (lookahead == 'e')
        ADVANCE(177);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 124:
      if (lookahead == 'e')
        ADVANCE(178);
      END_STATE();
    case 125:
      if (lookahead == 'e')
        ADVANCE(179);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 127:
      if (lookahead == 'd')
        ADVANCE(180);
      END_STATE();
    case 128:
      if (lookahead == 'l')
        ADVANCE(181);
      END_STATE();
    case 129:
      if (lookahead == 'h')
        ADVANCE(182);
      END_STATE();
    case 130:
      if (lookahead == 'l')
        ADVANCE(183);
      END_STATE();
    case 131:
      if (lookahead == 'r')
        ADVANCE(184);
      END_STATE();
    case 132:
      if (lookahead == 'c')
        ADVANCE(185);
      END_STATE();
    case 133:
      if (lookahead == 't')
        ADVANCE(186);
      END_STATE();
    case 134:
      if (lookahead == 'e')
        ADVANCE(187);
      END_STATE();
    case 135:
      if (lookahead == 'k')
        ADVANCE(188);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 137:
      if (lookahead == 'h')
        ADVANCE(189);
      END_STATE();
    case 138:
      if (lookahead == 's')
        ADVANCE(190);
      END_STATE();
    case 139:
      if (lookahead == 't')
        ADVANCE(191);
      END_STATE();
    case 140:
      if (lookahead == 'i')
        ADVANCE(192);
      END_STATE();
    case 141:
      if (lookahead == 'g')
        ADVANCE(193);
      END_STATE();
    case 142:
      if (lookahead == 'a')
        ADVANCE(194);
      END_STATE();
    case 143:
      if (lookahead == 'u')
        ADVANCE(195);
      END_STATE();
    case 144:
      if (lookahead == 't')
        ADVANCE(196);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 147:
      if (lookahead == 'r')
        ADVANCE(197);
      END_STATE();
    case 148:
      if (lookahead == 'n')
        ADVANCE(198);
      END_STATE();
    case 149:
      if (lookahead == 'e')
        ADVANCE(199);
      END_STATE();
    case 150:
      if (lookahead == 'l')
        ADVANCE(200);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 152:
      if (lookahead == 't')
        ADVANCE(201);
      END_STATE();
    case 153:
      if (lookahead == 'a')
        ADVANCE(202);
      END_STATE();
    case 154:
      if (lookahead == 'e')
        ADVANCE(203);
      END_STATE();
    case 155:
      if (lookahead == 'r')
        ADVANCE(204);
      END_STATE();
    case 156:
      if (lookahead == 'a')
        ADVANCE(205);
      END_STATE();
    case 157:
      if (lookahead == 'r')
        ADVANCE(206);
      END_STATE();
    case 158:
      if (lookahead == 'f')
        ADVANCE(207);
      END_STATE();
    case 159:
      if (lookahead == 'l')
        ADVANCE(208);
      END_STATE();
    case 160:
      if (lookahead == 's')
        ADVANCE(209);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 162:
      if (lookahead == 'e')
        ADVANCE(210);
      END_STATE();
    case 163:
      if (lookahead == 'a')
        ADVANCE(211);
      END_STATE();
    case 164:
      if (lookahead == 'e')
        ADVANCE(212);
      END_STATE();
    case 165:
      if (lookahead == 'i')
        ADVANCE(213);
      END_STATE();
    case 166:
      if (lookahead == 'o')
        ADVANCE(214);
      END_STATE();
    case 167:
      if (lookahead == 'i')
        ADVANCE(215);
      END_STATE();
    case 168:
      if (lookahead == 'r')
        ADVANCE(216);
      END_STATE();
    case 169:
      if (lookahead == 'i')
        ADVANCE(217);
      END_STATE();
    case 170:
      if (lookahead == 'n')
        ADVANCE(218);
      END_STATE();
    case 171:
      if (lookahead == 'r')
        ADVANCE(219);
      END_STATE();
    case 172:
      if (lookahead == 'c')
        ADVANCE(220);
      END_STATE();
    case 173:
      if (lookahead == 'o')
        ADVANCE(221);
      END_STATE();
    case 174:
      if (lookahead == 'e')
        ADVANCE(222);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_this);
      END_STATE();
    case 176:
      if (lookahead == 'w')
        ADVANCE(223);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o')
        ADVANCE(224);
      END_STATE();
    case 179:
      if (lookahead == 'f')
        ADVANCE(225);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 181:
      if (lookahead == 'e')
        ADVANCE(226);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 183:
      if (lookahead == 'd')
        ADVANCE(227);
      END_STATE();
    case 184:
      if (lookahead == 'a')
        ADVANCE(228);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 187:
      if (lookahead == 'a')
        ADVANCE(229);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 192:
      if (lookahead == 'n')
        ADVANCE(230);
      END_STATE();
    case 193:
      if (lookahead == 'g')
        ADVANCE(231);
      END_STATE();
    case 194:
      if (lookahead == 'r')
        ADVANCE(232);
      END_STATE();
    case 195:
      if (lookahead == 'l')
        ADVANCE(233);
      END_STATE();
    case 196:
      if (lookahead == 'e')
        ADVANCE(234);
      END_STATE();
    case 197:
      if (lookahead == 't')
        ADVANCE(235);
      END_STATE();
    case 198:
      if (lookahead == 'd')
        ADVANCE(236);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 200:
      if (lookahead == 'l')
        ADVANCE(237);
      END_STATE();
    case 201:
      if (lookahead == 'i')
        ADVANCE(238);
      END_STATE();
    case 202:
      if (lookahead == 'l')
        ADVANCE(239);
      END_STATE();
    case 203:
      if (lookahead == 'm')
        ADVANCE(240);
      END_STATE();
    case 204:
      if (lookahead == 't')
        ADVANCE(241);
      END_STATE();
    case 205:
      if (lookahead == 'n')
        ADVANCE(242);
      END_STATE();
    case 206:
      if (lookahead == 'f')
        ADVANCE(243);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 208:
      if (lookahead == 'e')
        ADVANCE(244);
      END_STATE();
    case 209:
      if (lookahead == 'p')
        ADVANCE(245);
      END_STATE();
    case 210:
      if (lookahead == 'r')
        ADVANCE(246);
      END_STATE();
    case 211:
      if (lookahead == 't')
        ADVANCE(247);
      END_STATE();
    case 212:
      if (lookahead == 'c')
        ADVANCE(248);
      END_STATE();
    case 213:
      if (lookahead == 'c')
        ADVANCE(249);
      END_STATE();
    case 214:
      if (lookahead == 'n')
        ADVANCE(250);
      END_STATE();
    case 215:
      if (lookahead == 'r')
        ADVANCE(251);
      END_STATE();
    case 216:
      if (lookahead == 'n')
        ADVANCE(252);
      END_STATE();
    case 217:
      if (lookahead == 'c')
        ADVANCE(253);
      END_STATE();
    case 218:
      if (lookahead == 'g')
        ADVANCE(254);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 220:
      if (lookahead == 'h')
        ADVANCE(255);
      END_STATE();
    case 221:
      if (lookahead == 'l')
        ADVANCE(256);
      END_STATE();
    case 222:
      if (lookahead == 't')
        ADVANCE(257);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 224:
      if (lookahead == 'f')
        ADVANCE(258);
      END_STATE();
    case 225:
      if (lookahead == 'i')
        ADVANCE(259);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 228:
      if (lookahead == 'c')
        ADVANCE(260);
      END_STATE();
    case 229:
      if (lookahead == 'n')
        ADVANCE(261);
      END_STATE();
    case 230:
      if (lookahead == 'u')
        ADVANCE(262);
      END_STATE();
    case 231:
      if (lookahead == 'e')
        ADVANCE(263);
      END_STATE();
    case 232:
      if (lookahead == 'e')
        ADVANCE(264);
      END_STATE();
    case 233:
      if (lookahead == 't')
        ADVANCE(265);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 236:
      if (lookahead == 's')
        ADVANCE(266);
      END_STATE();
    case 237:
      if (lookahead == 'y')
        ADVANCE(267);
      END_STATE();
    case 238:
      if (lookahead == 'o')
        ADVANCE(268);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 240:
      if (lookahead == 'e')
        ADVANCE(269);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 242:
      if (lookahead == 'c')
        ADVANCE(270);
      END_STATE();
    case 243:
      if (lookahead == 'a')
        ADVANCE(271);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 245:
      if (lookahead == 'a')
        ADVANCE(272);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 247:
      if (lookahead == 'e')
        ADVANCE(273);
      END_STATE();
    case 248:
      if (lookahead == 't')
        ADVANCE(274);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 250:
      if (lookahead == 'l')
        ADVANCE(275);
      END_STATE();
    case 251:
      if (lookahead == 'e')
        ADVANCE(276);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 259:
      if (lookahead == 'n')
        ADVANCE(277);
      END_STATE();
    case 260:
      if (lookahead == 't')
        ADVANCE(278);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 262:
      if (lookahead == 'e')
        ADVANCE(279);
      END_STATE();
    case 263:
      if (lookahead == 'r')
        ADVANCE(280);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 268:
      if (lookahead == 'n')
        ADVANCE(281);
      END_STATE();
    case 269:
      if (lookahead == 'n')
        ADVANCE(282);
      END_STATE();
    case 270:
      if (lookahead == 'e')
        ADVANCE(283);
      END_STATE();
    case 271:
      if (lookahead == 'c')
        ADVANCE(284);
      END_STATE();
    case 272:
      if (lookahead == 'c')
        ADVANCE(285);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 274:
      if (lookahead == 'e')
        ADVANCE(286);
      END_STATE();
    case 275:
      if (lookahead == 'y')
        ADVANCE(287);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 277:
      if (lookahead == 'e')
        ADVANCE(288);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 282:
      if (lookahead == 't')
        ADVANCE(289);
      END_STATE();
    case 283:
      if (lookahead == 'o')
        ADVANCE(290);
      END_STATE();
    case 284:
      if (lookahead == 'e')
        ADVANCE(291);
      END_STATE();
    case 285:
      if (lookahead == 'e')
        ADVANCE(292);
      END_STATE();
    case 286:
      if (lookahead == 'd')
        ADVANCE(293);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_readonly);
      END_STATE();
    case 288:
      if (lookahead == 'd')
        ADVANCE(294);
      END_STATE();
    case 289:
      if (lookahead == 's')
        ADVANCE(295);
      END_STATE();
    case 290:
      if (lookahead == 'f')
        ADVANCE(296);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 95},
  [2] = {.lex_state = 102, .external_lex_state = 2},
  [3] = {.lex_state = 106, .external_lex_state = 3},
  [4] = {.lex_state = 95, .external_lex_state = 2},
  [5] = {.lex_state = 102, .external_lex_state = 2},
  [6] = {.lex_state = 95},
  [7] = {.lex_state = 95},
  [8] = {.lex_state = 102, .external_lex_state = 2},
  [9] = {.lex_state = 95, .external_lex_state = 2},
  [10] = {.lex_state = 95},
  [11] = {.lex_state = 110, .external_lex_state = 2},
  [12] = {.lex_state = 95, .external_lex_state = 2},
  [13] = {.lex_state = 95},
  [14] = {.lex_state = 95},
  [15] = {.lex_state = 95},
  [16] = {.lex_state = 95, .external_lex_state = 2},
  [17] = {.lex_state = 95},
  [18] = {.lex_state = 95},
  [19] = {.lex_state = 110, .external_lex_state = 2},
  [20] = {.lex_state = 110, .external_lex_state = 2},
  [21] = {.lex_state = 95},
  [22] = {.lex_state = 95},
  [23] = {.lex_state = 102, .external_lex_state = 2},
  [24] = {.lex_state = 102, .external_lex_state = 2},
  [25] = {.lex_state = 102, .external_lex_state = 2},
  [26] = {.lex_state = 95},
  [27] = {.lex_state = 122},
  [28] = {.lex_state = 95},
  [29] = {.lex_state = 130},
  [30] = {.lex_state = 134},
  [31] = {.lex_state = 102, .external_lex_state = 2},
  [32] = {.lex_state = 95},
  [33] = {.lex_state = 102, .external_lex_state = 2},
  [34] = {.lex_state = 137},
  [35] = {.lex_state = 95},
  [36] = {.lex_state = 139},
  [37] = {.lex_state = 102, .external_lex_state = 2},
  [38] = {.lex_state = 95},
  [39] = {.lex_state = 95},
  [40] = {.lex_state = 95},
  [41] = {.lex_state = 140},
  [42] = {.lex_state = 95},
  [43] = {.lex_state = 148},
  [44] = {.lex_state = 154},
  [45] = {.lex_state = 130},
  [46] = {.lex_state = 130},
  [47] = {.lex_state = 95},
  [48] = {.lex_state = 102, .external_lex_state = 2},
  [49] = {.lex_state = 95},
  [50] = {.lex_state = 95},
  [51] = {.lex_state = 95},
  [52] = {.lex_state = 95},
  [53] = {.lex_state = 161, .external_lex_state = 2},
  [54] = {.lex_state = 102, .external_lex_state = 2},
  [55] = {.lex_state = 95},
  [56] = {.lex_state = 110, .external_lex_state = 2},
  [57] = {.lex_state = 102},
  [58] = {.lex_state = 102},
  [59] = {.lex_state = 110, .external_lex_state = 2},
  [60] = {.lex_state = 161, .external_lex_state = 2},
  [61] = {.lex_state = 0},
  [62] = {.lex_state = 95, .external_lex_state = 2},
  [63] = {.lex_state = 110, .external_lex_state = 2},
  [64] = {.lex_state = 164},
  [65] = {.lex_state = 95},
  [66] = {.lex_state = 95},
  [67] = {.lex_state = 95},
  [68] = {.lex_state = 95},
  [69] = {.lex_state = 95},
  [70] = {.lex_state = 95},
  [71] = {.lex_state = 110, .external_lex_state = 2},
  [72] = {.lex_state = 95},
  [73] = {.lex_state = 110, .external_lex_state = 2},
  [74] = {.lex_state = 106, .external_lex_state = 3},
  [75] = {.lex_state = 137},
  [76] = {.lex_state = 95},
  [77] = {.lex_state = 95},
  [78] = {.lex_state = 95},
  [79] = {.lex_state = 110, .external_lex_state = 2},
  [80] = {.lex_state = 137},
  [81] = {.lex_state = 130},
  [82] = {.lex_state = 137},
  [83] = {.lex_state = 102, .external_lex_state = 2},
  [84] = {.lex_state = 137},
  [85] = {.lex_state = 102, .external_lex_state = 2},
  [86] = {.lex_state = 130},
  [87] = {.lex_state = 110, .external_lex_state = 2},
  [88] = {.lex_state = 110, .external_lex_state = 2},
  [89] = {.lex_state = 95},
  [90] = {.lex_state = 110, .external_lex_state = 2},
  [91] = {.lex_state = 137},
  [92] = {.lex_state = 95, .external_lex_state = 2},
  [93] = {.lex_state = 102, .external_lex_state = 2},
  [94] = {.lex_state = 130},
  [95] = {.lex_state = 95},
  [96] = {.lex_state = 137},
  [97] = {.lex_state = 102, .external_lex_state = 2},
  [98] = {.lex_state = 102},
  [99] = {.lex_state = 102},
  [100] = {.lex_state = 95},
  [101] = {.lex_state = 171},
  [102] = {.lex_state = 139},
  [103] = {.lex_state = 95},
  [104] = {.lex_state = 110, .external_lex_state = 2},
  [105] = {.lex_state = 137},
  [106] = {.lex_state = 110, .external_lex_state = 2},
  [107] = {.lex_state = 95, .external_lex_state = 2},
  [108] = {.lex_state = 130},
  [109] = {.lex_state = 95},
  [110] = {.lex_state = 137},
  [111] = {.lex_state = 95, .external_lex_state = 2},
  [112] = {.lex_state = 110, .external_lex_state = 2},
  [113] = {.lex_state = 95},
  [114] = {.lex_state = 95},
  [115] = {.lex_state = 110, .external_lex_state = 2},
  [116] = {.lex_state = 110, .external_lex_state = 2},
  [117] = {.lex_state = 95, .external_lex_state = 2},
  [118] = {.lex_state = 95},
  [119] = {.lex_state = 134},
  [120] = {.lex_state = 102},
  [121] = {.lex_state = 130},
  [122] = {.lex_state = 95},
  [123] = {.lex_state = 102},
  [124] = {.lex_state = 95, .external_lex_state = 2},
  [125] = {.lex_state = 95},
  [126] = {.lex_state = 95},
  [127] = {.lex_state = 173, .external_lex_state = 2},
  [128] = {.lex_state = 173, .external_lex_state = 2},
  [129] = {.lex_state = 173, .external_lex_state = 2},
  [130] = {.lex_state = 110, .external_lex_state = 2},
  [131] = {.lex_state = 173, .external_lex_state = 2},
  [132] = {.lex_state = 122},
  [133] = {.lex_state = 95},
  [134] = {.lex_state = 95},
  [135] = {.lex_state = 122},
  [136] = {.lex_state = 175},
  [137] = {.lex_state = 106, .external_lex_state = 3},
  [138] = {.lex_state = 175},
  [139] = {.lex_state = 95},
  [140] = {.lex_state = 95},
  [141] = {.lex_state = 95},
  [142] = {.lex_state = 95},
  [143] = {.lex_state = 130},
  [144] = {.lex_state = 175},
  [145] = {.lex_state = 139},
  [146] = {.lex_state = 110, .external_lex_state = 2},
  [147] = {.lex_state = 177},
  [148] = {.lex_state = 175},
  [149] = {.lex_state = 140},
  [150] = {.lex_state = 95},
  [151] = {.lex_state = 148},
  [152] = {.lex_state = 179},
  [153] = {.lex_state = 154},
  [154] = {.lex_state = 177},
  [155] = {.lex_state = 130},
  [156] = {.lex_state = 130},
  [157] = {.lex_state = 175},
  [158] = {.lex_state = 95},
  [159] = {.lex_state = 102},
  [160] = {.lex_state = 179},
  [161] = {.lex_state = 177},
  [162] = {.lex_state = 175},
  [163] = {.lex_state = 130},
  [164] = {.lex_state = 95},
  [165] = {.lex_state = 179},
  [166] = {.lex_state = 130},
  [167] = {.lex_state = 179},
  [168] = {.lex_state = 164},
  [169] = {.lex_state = 137},
  [170] = {.lex_state = 140},
  [171] = {.lex_state = 122},
  [172] = {.lex_state = 137},
  [173] = {.lex_state = 137},
  [174] = {.lex_state = 95},
  [175] = {.lex_state = 171},
  [176] = {.lex_state = 95},
  [177] = {.lex_state = 137},
  [178] = {.lex_state = 95},
  [179] = {.lex_state = 95},
  [180] = {.lex_state = 95},
  [181] = {.lex_state = 110, .external_lex_state = 2},
  [182] = {.lex_state = 102},
  [183] = {.lex_state = 95},
  [184] = {.lex_state = 95},
  [185] = {.lex_state = 95},
  [186] = {.lex_state = 95},
  [187] = {.lex_state = 130},
  [188] = {.lex_state = 95},
  [189] = {.lex_state = 95},
  [190] = {.lex_state = 134},
  [191] = {.lex_state = 95},
  [192] = {.lex_state = 95},
  [193] = {.lex_state = 137},
  [194] = {.lex_state = 102, .external_lex_state = 2},
  [195] = {.lex_state = 102, .external_lex_state = 2},
  [196] = {.lex_state = 95},
  [197] = {.lex_state = 137},
  [198] = {.lex_state = 95},
  [199] = {.lex_state = 102, .external_lex_state = 2},
  [200] = {.lex_state = 102, .external_lex_state = 2},
  [201] = {.lex_state = 130},
  [202] = {.lex_state = 102, .external_lex_state = 2},
  [203] = {.lex_state = 161, .external_lex_state = 2},
  [204] = {.lex_state = 95},
  [205] = {.lex_state = 102, .external_lex_state = 2},
  [206] = {.lex_state = 102, .external_lex_state = 2},
  [207] = {.lex_state = 102, .external_lex_state = 2},
  [208] = {.lex_state = 130},
  [209] = {.lex_state = 95},
  [210] = {.lex_state = 130},
  [211] = {.lex_state = 102, .external_lex_state = 2},
  [212] = {.lex_state = 102, .external_lex_state = 2},
  [213] = {.lex_state = 95},
  [214] = {.lex_state = 102, .external_lex_state = 2},
  [215] = {.lex_state = 95},
  [216] = {.lex_state = 110, .external_lex_state = 2},
  [217] = {.lex_state = 102, .external_lex_state = 2},
  [218] = {.lex_state = 95},
  [219] = {.lex_state = 137},
  [220] = {.lex_state = 102},
  [221] = {.lex_state = 130},
  [222] = {.lex_state = 102},
  [223] = {.lex_state = 130},
  [224] = {.lex_state = 134},
  [225] = {.lex_state = 110, .external_lex_state = 2},
  [226] = {.lex_state = 110, .external_lex_state = 2},
  [227] = {.lex_state = 95},
  [228] = {.lex_state = 180},
  [229] = {.lex_state = 95},
  [230] = {.lex_state = 180},
  [231] = {.lex_state = 95},
  [232] = {.lex_state = 95},
  [233] = {.lex_state = 95},
  [234] = {.lex_state = 180},
  [235] = {.lex_state = 180},
  [236] = {.lex_state = 180},
  [237] = {.lex_state = 95},
  [238] = {.lex_state = 102},
  [239] = {.lex_state = 181},
  [240] = {.lex_state = 130},
  [241] = {.lex_state = 180},
  [242] = {.lex_state = 95},
  [243] = {.lex_state = 102},
  [244] = {.lex_state = 139},
  [245] = {.lex_state = 181},
  [246] = {.lex_state = 180},
  [247] = {.lex_state = 95},
  [248] = {.lex_state = 139},
  [249] = {.lex_state = 181},
  [250] = {.lex_state = 130},
  [251] = {.lex_state = 181},
  [252] = {.lex_state = 181},
  [253] = {.lex_state = 102},
  [254] = {.lex_state = 102},
  [255] = {.lex_state = 139},
  [256] = {.lex_state = 95},
  [257] = {.lex_state = 95},
  [258] = {.lex_state = 102, .external_lex_state = 2},
  [259] = {.lex_state = 95},
  [260] = {.lex_state = 95},
  [261] = {.lex_state = 140},
  [262] = {.lex_state = 137},
  [263] = {.lex_state = 137},
  [264] = {.lex_state = 164},
  [265] = {.lex_state = 148},
  [266] = {.lex_state = 148},
  [267] = {.lex_state = 148},
  [268] = {.lex_state = 148},
  [269] = {.lex_state = 102},
  [270] = {.lex_state = 182},
  [271] = {.lex_state = 95},
  [272] = {.lex_state = 95},
  [273] = {.lex_state = 95},
  [274] = {.lex_state = 102},
  [275] = {.lex_state = 95},
  [276] = {.lex_state = 102, .external_lex_state = 2},
  [277] = {.lex_state = 110, .external_lex_state = 2},
  [278] = {.lex_state = 95},
  [279] = {.lex_state = 102, .external_lex_state = 2},
  [280] = {.lex_state = 95},
  [281] = {.lex_state = 95},
  [282] = {.lex_state = 102, .external_lex_state = 2},
  [283] = {.lex_state = 110},
  [284] = {.lex_state = 102, .external_lex_state = 2},
  [285] = {.lex_state = 95},
  [286] = {.lex_state = 110},
  [287] = {.lex_state = 102, .external_lex_state = 2},
  [288] = {.lex_state = 95},
  [289] = {.lex_state = 110},
  [290] = {.lex_state = 110, .external_lex_state = 2},
  [291] = {.lex_state = 183, .external_lex_state = 2},
  [292] = {.lex_state = 110, .external_lex_state = 2},
  [293] = {.lex_state = 110, .external_lex_state = 2},
  [294] = {.lex_state = 95},
  [295] = {.lex_state = 95},
  [296] = {.lex_state = 102},
  [297] = {.lex_state = 95},
  [298] = {.lex_state = 95},
  [299] = {.lex_state = 95},
  [300] = {.lex_state = 137},
  [301] = {.lex_state = 95, .external_lex_state = 2},
  [302] = {.lex_state = 102, .external_lex_state = 2},
  [303] = {.lex_state = 95},
  [304] = {.lex_state = 95},
  [305] = {.lex_state = 95},
  [306] = {.lex_state = 102, .external_lex_state = 2},
  [307] = {.lex_state = 102, .external_lex_state = 2},
  [308] = {.lex_state = 95},
  [309] = {.lex_state = 102, .external_lex_state = 2},
  [310] = {.lex_state = 95},
  [311] = {.lex_state = 95},
  [312] = {.lex_state = 110, .external_lex_state = 2},
  [313] = {.lex_state = 95},
  [314] = {.lex_state = 110, .external_lex_state = 2},
  [315] = {.lex_state = 95},
  [316] = {.lex_state = 102},
  [317] = {.lex_state = 95},
  [318] = {.lex_state = 95},
  [319] = {.lex_state = 95},
  [320] = {.lex_state = 95},
  [321] = {.lex_state = 110, .external_lex_state = 2},
  [322] = {.lex_state = 171},
  [323] = {.lex_state = 102},
  [324] = {.lex_state = 134},
  [325] = {.lex_state = 110, .external_lex_state = 2},
  [326] = {.lex_state = 95},
  [327] = {.lex_state = 95},
  [328] = {.lex_state = 95},
  [329] = {.lex_state = 95},
  [330] = {.lex_state = 95},
  [331] = {.lex_state = 95},
  [332] = {.lex_state = 171},
  [333] = {.lex_state = 110, .external_lex_state = 2},
  [334] = {.lex_state = 130},
  [335] = {.lex_state = 95},
  [336] = {.lex_state = 110, .external_lex_state = 2},
  [337] = {.lex_state = 148},
  [338] = {.lex_state = 137},
  [339] = {.lex_state = 110, .external_lex_state = 2},
  [340] = {.lex_state = 164},
  [341] = {.lex_state = 164},
  [342] = {.lex_state = 137},
  [343] = {.lex_state = 110, .external_lex_state = 2},
  [344] = {.lex_state = 110, .external_lex_state = 2},
  [345] = {.lex_state = 110, .external_lex_state = 2},
  [346] = {.lex_state = 110, .external_lex_state = 2},
  [347] = {.lex_state = 110, .external_lex_state = 2},
  [348] = {.lex_state = 137},
  [349] = {.lex_state = 183, .external_lex_state = 2},
  [350] = {.lex_state = 102},
  [351] = {.lex_state = 102},
  [352] = {.lex_state = 95},
  [353] = {.lex_state = 95},
  [354] = {.lex_state = 102},
  [355] = {.lex_state = 102},
  [356] = {.lex_state = 95},
  [357] = {.lex_state = 161},
  [358] = {.lex_state = 130},
  [359] = {.lex_state = 102},
  [360] = {.lex_state = 95},
  [361] = {.lex_state = 102},
  [362] = {.lex_state = 161},
  [363] = {.lex_state = 102},
  [364] = {.lex_state = 102},
  [365] = {.lex_state = 161},
  [366] = {.lex_state = 161},
  [367] = {.lex_state = 110, .external_lex_state = 2},
  [368] = {.lex_state = 106, .external_lex_state = 3},
  [369] = {.lex_state = 110, .external_lex_state = 2},
  [370] = {.lex_state = 110, .external_lex_state = 2},
  [371] = {.lex_state = 110, .external_lex_state = 2},
  [372] = {.lex_state = 183, .external_lex_state = 2},
  [373] = {.lex_state = 95},
  [374] = {.lex_state = 139},
  [375] = {.lex_state = 137},
  [376] = {.lex_state = 184},
  [377] = {.lex_state = 130},
  [378] = {.lex_state = 184},
  [379] = {.lex_state = 184},
  [380] = {.lex_state = 184},
  [381] = {.lex_state = 184},
  [382] = {.lex_state = 110, .external_lex_state = 2},
  [383] = {.lex_state = 130},
  [384] = {.lex_state = 102},
  [385] = {.lex_state = 102},
  [386] = {.lex_state = 95},
  [387] = {.lex_state = 95},
  [388] = {.lex_state = 95},
  [389] = {.lex_state = 137},
  [390] = {.lex_state = 171},
  [391] = {.lex_state = 102, .external_lex_state = 2},
  [392] = {.lex_state = 102, .external_lex_state = 2},
  [393] = {.lex_state = 177},
  [394] = {.lex_state = 179},
  [395] = {.lex_state = 130},
  [396] = {.lex_state = 130},
  [397] = {.lex_state = 95},
  [398] = {.lex_state = 184},
  [399] = {.lex_state = 184},
  [400] = {.lex_state = 184},
  [401] = {.lex_state = 184},
  [402] = {.lex_state = 184},
  [403] = {.lex_state = 177},
  [404] = {.lex_state = 130},
  [405] = {.lex_state = 102},
  [406] = {.lex_state = 102},
  [407] = {.lex_state = 95},
  [408] = {.lex_state = 137},
  [409] = {.lex_state = 102, .external_lex_state = 2},
  [410] = {.lex_state = 171},
  [411] = {.lex_state = 102, .external_lex_state = 2},
  [412] = {.lex_state = 102},
  [413] = {.lex_state = 102, .external_lex_state = 2},
  [414] = {.lex_state = 102},
  [415] = {.lex_state = 179},
  [416] = {.lex_state = 130},
  [417] = {.lex_state = 134},
  [418] = {.lex_state = 185},
  [419] = {.lex_state = 171},
  [420] = {.lex_state = 137},
  [421] = {.lex_state = 171},
  [422] = {.lex_state = 171},
  [423] = {.lex_state = 185},
  [424] = {.lex_state = 185},
  [425] = {.lex_state = 95},
  [426] = {.lex_state = 95},
  [427] = {.lex_state = 185},
  [428] = {.lex_state = 95},
  [429] = {.lex_state = 95},
  [430] = {.lex_state = 171},
  [431] = {.lex_state = 171},
  [432] = {.lex_state = 134},
  [433] = {.lex_state = 186},
  [434] = {.lex_state = 95},
  [435] = {.lex_state = 102},
  [436] = {.lex_state = 185},
  [437] = {.lex_state = 102},
  [438] = {.lex_state = 180},
  [439] = {.lex_state = 180},
  [440] = {.lex_state = 95},
  [441] = {.lex_state = 95},
  [442] = {.lex_state = 95},
  [443] = {.lex_state = 139},
  [444] = {.lex_state = 180},
  [445] = {.lex_state = 180},
  [446] = {.lex_state = 95},
  [447] = {.lex_state = 110, .external_lex_state = 2},
  [448] = {.lex_state = 181},
  [449] = {.lex_state = 130},
  [450] = {.lex_state = 180},
  [451] = {.lex_state = 95},
  [452] = {.lex_state = 102},
  [453] = {.lex_state = 181},
  [454] = {.lex_state = 180},
  [455] = {.lex_state = 139},
  [456] = {.lex_state = 181},
  [457] = {.lex_state = 139},
  [458] = {.lex_state = 181},
  [459] = {.lex_state = 110, .external_lex_state = 2},
  [460] = {.lex_state = 137},
  [461] = {.lex_state = 95},
  [462] = {.lex_state = 130},
  [463] = {.lex_state = 137},
  [464] = {.lex_state = 130},
  [465] = {.lex_state = 102},
  [466] = {.lex_state = 137},
  [467] = {.lex_state = 137},
  [468] = {.lex_state = 180},
  [469] = {.lex_state = 180},
  [470] = {.lex_state = 180},
  [471] = {.lex_state = 180},
  [472] = {.lex_state = 180},
  [473] = {.lex_state = 181},
  [474] = {.lex_state = 139},
  [475] = {.lex_state = 181},
  [476] = {.lex_state = 181},
  [477] = {.lex_state = 102, .external_lex_state = 2},
  [478] = {.lex_state = 95},
  [479] = {.lex_state = 95},
  [480] = {.lex_state = 102, .external_lex_state = 2},
  [481] = {.lex_state = 95},
  [482] = {.lex_state = 102, .external_lex_state = 2},
  [483] = {.lex_state = 95},
  [484] = {.lex_state = 95},
  [485] = {.lex_state = 95},
  [486] = {.lex_state = 137},
  [487] = {.lex_state = 95},
  [488] = {.lex_state = 171},
  [489] = {.lex_state = 102},
  [490] = {.lex_state = 130},
  [491] = {.lex_state = 95},
  [492] = {.lex_state = 102},
  [493] = {.lex_state = 95, .external_lex_state = 2},
  [494] = {.lex_state = 95},
  [495] = {.lex_state = 95},
  [496] = {.lex_state = 102},
  [497] = {.lex_state = 95},
  [498] = {.lex_state = 95},
  [499] = {.lex_state = 102},
  [500] = {.lex_state = 102},
  [501] = {.lex_state = 137},
  [502] = {.lex_state = 95},
  [503] = {.lex_state = 95},
  [504] = {.lex_state = 137},
  [505] = {.lex_state = 173, .external_lex_state = 2},
  [506] = {.lex_state = 173, .external_lex_state = 2},
  [507] = {.lex_state = 122},
  [508] = {.lex_state = 95},
  [509] = {.lex_state = 102, .external_lex_state = 2},
  [510] = {.lex_state = 95},
  [511] = {.lex_state = 95},
  [512] = {.lex_state = 95},
  [513] = {.lex_state = 110, .external_lex_state = 2},
  [514] = {.lex_state = 110, .external_lex_state = 2},
  [515] = {.lex_state = 177},
  [516] = {.lex_state = 122},
  [517] = {.lex_state = 95},
  [518] = {.lex_state = 95},
  [519] = {.lex_state = 95},
  [520] = {.lex_state = 95},
  [521] = {.lex_state = 95},
  [522] = {.lex_state = 177},
  [523] = {.lex_state = 177},
  [524] = {.lex_state = 106, .external_lex_state = 3},
  [525] = {.lex_state = 95},
  [526] = {.lex_state = 95},
  [527] = {.lex_state = 95},
  [528] = {.lex_state = 177},
  [529] = {.lex_state = 95},
  [530] = {.lex_state = 137},
  [531] = {.lex_state = 95},
  [532] = {.lex_state = 177},
  [533] = {.lex_state = 179},
  [534] = {.lex_state = 179},
  [535] = {.lex_state = 179},
  [536] = {.lex_state = 179},
  [537] = {.lex_state = 186},
  [538] = {.lex_state = 181},
  [539] = {.lex_state = 139},
  [540] = {.lex_state = 95},
  [541] = {.lex_state = 95},
  [542] = {.lex_state = 177},
  [543] = {.lex_state = 102},
  [544] = {.lex_state = 102},
  [545] = {.lex_state = 95},
  [546] = {.lex_state = 140},
  [547] = {.lex_state = 179},
  [548] = {.lex_state = 164},
  [549] = {.lex_state = 148},
  [550] = {.lex_state = 148},
  [551] = {.lex_state = 148},
  [552] = {.lex_state = 148},
  [553] = {.lex_state = 179},
  [554] = {.lex_state = 182},
  [555] = {.lex_state = 95},
  [556] = {.lex_state = 95},
  [557] = {.lex_state = 95},
  [558] = {.lex_state = 175},
  [559] = {.lex_state = 177},
  [560] = {.lex_state = 95},
  [561] = {.lex_state = 175},
  [562] = {.lex_state = 175},
  [563] = {.lex_state = 175},
  [564] = {.lex_state = 175},
  [565] = {.lex_state = 110},
  [566] = {.lex_state = 177},
  [567] = {.lex_state = 187},
  [568] = {.lex_state = 177},
  [569] = {.lex_state = 177},
  [570] = {.lex_state = 177},
  [571] = {.lex_state = 177},
  [572] = {.lex_state = 177},
  [573] = {.lex_state = 179},
  [574] = {.lex_state = 177},
  [575] = {.lex_state = 95},
  [576] = {.lex_state = 95},
  [577] = {.lex_state = 95},
  [578] = {.lex_state = 95},
  [579] = {.lex_state = 110, .external_lex_state = 2},
  [580] = {.lex_state = 95},
  [581] = {.lex_state = 171},
  [582] = {.lex_state = 177},
  [583] = {.lex_state = 130},
  [584] = {.lex_state = 95},
  [585] = {.lex_state = 130},
  [586] = {.lex_state = 95},
  [587] = {.lex_state = 177},
  [588] = {.lex_state = 130},
  [589] = {.lex_state = 177},
  [590] = {.lex_state = 148},
  [591] = {.lex_state = 177},
  [592] = {.lex_state = 164},
  [593] = {.lex_state = 95},
  [594] = {.lex_state = 137},
  [595] = {.lex_state = 185},
  [596] = {.lex_state = 140},
  [597] = {.lex_state = 122},
  [598] = {.lex_state = 102},
  [599] = {.lex_state = 102},
  [600] = {.lex_state = 95},
  [601] = {.lex_state = 95},
  [602] = {.lex_state = 102},
  [603] = {.lex_state = 102},
  [604] = {.lex_state = 95},
  [605] = {.lex_state = 110},
  [606] = {.lex_state = 154},
  [607] = {.lex_state = 130},
  [608] = {.lex_state = 102},
  [609] = {.lex_state = 95},
  [610] = {.lex_state = 102},
  [611] = {.lex_state = 110},
  [612] = {.lex_state = 102},
  [613] = {.lex_state = 110},
  [614] = {.lex_state = 130},
  [615] = {.lex_state = 110},
  [616] = {.lex_state = 102},
  [617] = {.lex_state = 130},
  [618] = {.lex_state = 171},
  [619] = {.lex_state = 171},
  [620] = {.lex_state = 95},
  [621] = {.lex_state = 171},
  [622] = {.lex_state = 130},
  [623] = {.lex_state = 95},
  [624] = {.lex_state = 102},
  [625] = {.lex_state = 95},
  [626] = {.lex_state = 95},
  [627] = {.lex_state = 173, .external_lex_state = 2},
  [628] = {.lex_state = 184, .external_lex_state = 2},
  [629] = {.lex_state = 95},
  [630] = {.lex_state = 95},
  [631] = {.lex_state = 184, .external_lex_state = 2},
  [632] = {.lex_state = 134, .external_lex_state = 2},
  [633] = {.lex_state = 134, .external_lex_state = 2},
  [634] = {.lex_state = 130},
  [635] = {.lex_state = 173, .external_lex_state = 2},
  [636] = {.lex_state = 140},
  [637] = {.lex_state = 130},
  [638] = {.lex_state = 130},
  [639] = {.lex_state = 122},
  [640] = {.lex_state = 102, .external_lex_state = 2},
  [641] = {.lex_state = 134, .external_lex_state = 2},
  [642] = {.lex_state = 130},
  [643] = {.lex_state = 137},
  [644] = {.lex_state = 137, .external_lex_state = 2},
  [645] = {.lex_state = 110, .external_lex_state = 2},
  [646] = {.lex_state = 95},
  [647] = {.lex_state = 95},
  [648] = {.lex_state = 95},
  [649] = {.lex_state = 137},
  [650] = {.lex_state = 95},
  [651] = {.lex_state = 95},
  [652] = {.lex_state = 95},
  [653] = {.lex_state = 95},
  [654] = {.lex_state = 102},
  [655] = {.lex_state = 95},
  [656] = {.lex_state = 137},
  [657] = {.lex_state = 95},
  [658] = {.lex_state = 110, .external_lex_state = 2},
  [659] = {.lex_state = 95},
  [660] = {.lex_state = 95},
  [661] = {.lex_state = 161, .external_lex_state = 2},
  [662] = {.lex_state = 102},
  [663] = {.lex_state = 137},
  [664] = {.lex_state = 184},
  [665] = {.lex_state = 184},
  [666] = {.lex_state = 184},
  [667] = {.lex_state = 184},
  [668] = {.lex_state = 184},
  [669] = {.lex_state = 130},
  [670] = {.lex_state = 102},
  [671] = {.lex_state = 184},
  [672] = {.lex_state = 95},
  [673] = {.lex_state = 130},
  [674] = {.lex_state = 130},
  [675] = {.lex_state = 130},
  [676] = {.lex_state = 95},
  [677] = {.lex_state = 130},
  [678] = {.lex_state = 95},
  [679] = {.lex_state = 95},
  [680] = {.lex_state = 95},
  [681] = {.lex_state = 179},
  [682] = {.lex_state = 102},
  [683] = {.lex_state = 95},
  [684] = {.lex_state = 134},
  [685] = {.lex_state = 95},
  [686] = {.lex_state = 161},
  [687] = {.lex_state = 134},
  [688] = {.lex_state = 134},
  [689] = {.lex_state = 134},
  [690] = {.lex_state = 95},
  [691] = {.lex_state = 95},
  [692] = {.lex_state = 102, .external_lex_state = 2},
  [693] = {.lex_state = 137},
  [694] = {.lex_state = 102, .external_lex_state = 2},
  [695] = {.lex_state = 102, .external_lex_state = 2},
  [696] = {.lex_state = 137},
  [697] = {.lex_state = 95},
  [698] = {.lex_state = 110, .external_lex_state = 2},
  [699] = {.lex_state = 102},
  [700] = {.lex_state = 130},
  [701] = {.lex_state = 102},
  [702] = {.lex_state = 130},
  [703] = {.lex_state = 130},
  [704] = {.lex_state = 130},
  [705] = {.lex_state = 130},
  [706] = {.lex_state = 130},
  [707] = {.lex_state = 130},
  [708] = {.lex_state = 102},
  [709] = {.lex_state = 95},
  [710] = {.lex_state = 95},
  [711] = {.lex_state = 95},
  [712] = {.lex_state = 161, .external_lex_state = 2},
  [713] = {.lex_state = 161, .external_lex_state = 2},
  [714] = {.lex_state = 102},
  [715] = {.lex_state = 137},
  [716] = {.lex_state = 95},
  [717] = {.lex_state = 95},
  [718] = {.lex_state = 180},
  [719] = {.lex_state = 95},
  [720] = {.lex_state = 95},
  [721] = {.lex_state = 171},
  [722] = {.lex_state = 181},
  [723] = {.lex_state = 180},
  [724] = {.lex_state = 180},
  [725] = {.lex_state = 180},
  [726] = {.lex_state = 180},
  [727] = {.lex_state = 180},
  [728] = {.lex_state = 180},
  [729] = {.lex_state = 95},
  [730] = {.lex_state = 180},
  [731] = {.lex_state = 95},
  [732] = {.lex_state = 181},
  [733] = {.lex_state = 180},
  [734] = {.lex_state = 181},
  [735] = {.lex_state = 181},
  [736] = {.lex_state = 180},
  [737] = {.lex_state = 102},
  [738] = {.lex_state = 102},
  [739] = {.lex_state = 181},
  [740] = {.lex_state = 181},
  [741] = {.lex_state = 180},
  [742] = {.lex_state = 180},
  [743] = {.lex_state = 180},
  [744] = {.lex_state = 180},
  [745] = {.lex_state = 180},
  [746] = {.lex_state = 181},
  [747] = {.lex_state = 139},
  [748] = {.lex_state = 102},
  [749] = {.lex_state = 139},
  [750] = {.lex_state = 95},
  [751] = {.lex_state = 95},
  [752] = {.lex_state = 95},
  [753] = {.lex_state = 95},
  [754] = {.lex_state = 95},
  [755] = {.lex_state = 95},
  [756] = {.lex_state = 171},
  [757] = {.lex_state = 130},
  [758] = {.lex_state = 110, .external_lex_state = 2},
  [759] = {.lex_state = 171},
  [760] = {.lex_state = 95},
  [761] = {.lex_state = 139},
  [762] = {.lex_state = 95},
  [763] = {.lex_state = 95},
  [764] = {.lex_state = 139},
  [765] = {.lex_state = 180},
  [766] = {.lex_state = 180},
  [767] = {.lex_state = 180},
  [768] = {.lex_state = 130},
  [769] = {.lex_state = 180},
  [770] = {.lex_state = 139},
  [771] = {.lex_state = 180},
  [772] = {.lex_state = 180},
  [773] = {.lex_state = 180},
  [774] = {.lex_state = 181},
  [775] = {.lex_state = 180},
  [776] = {.lex_state = 180},
  [777] = {.lex_state = 181},
  [778] = {.lex_state = 180},
  [779] = {.lex_state = 95},
  [780] = {.lex_state = 95},
  [781] = {.lex_state = 130},
  [782] = {.lex_state = 102},
  [783] = {.lex_state = 95},
  [784] = {.lex_state = 95},
  [785] = {.lex_state = 137},
  [786] = {.lex_state = 102, .external_lex_state = 2},
  [787] = {.lex_state = 137},
  [788] = {.lex_state = 140},
  [789] = {.lex_state = 137},
  [790] = {.lex_state = 95},
  [791] = {.lex_state = 95},
  [792] = {.lex_state = 137},
  [793] = {.lex_state = 137},
  [794] = {.lex_state = 148},
  [795] = {.lex_state = 164},
  [796] = {.lex_state = 171},
  [797] = {.lex_state = 148},
  [798] = {.lex_state = 148},
  [799] = {.lex_state = 171},
  [800] = {.lex_state = 95},
  [801] = {.lex_state = 164},
  [802] = {.lex_state = 102},
  [803] = {.lex_state = 137},
  [804] = {.lex_state = 148},
  [805] = {.lex_state = 148},
  [806] = {.lex_state = 102},
  [807] = {.lex_state = 102},
  [808] = {.lex_state = 148},
  [809] = {.lex_state = 148},
  [810] = {.lex_state = 102},
  [811] = {.lex_state = 175},
  [812] = {.lex_state = 102},
  [813] = {.lex_state = 188, .external_lex_state = 2},
  [814] = {.lex_state = 139},
  [815] = {.lex_state = 95},
  [816] = {.lex_state = 102, .external_lex_state = 2},
  [817] = {.lex_state = 95, .external_lex_state = 2},
  [818] = {.lex_state = 95},
  [819] = {.lex_state = 95},
  [820] = {.lex_state = 102},
  [821] = {.lex_state = 171},
  [822] = {.lex_state = 173, .external_lex_state = 2},
  [823] = {.lex_state = 95},
  [824] = {.lex_state = 95},
  [825] = {.lex_state = 95},
  [826] = {.lex_state = 110, .external_lex_state = 2},
  [827] = {.lex_state = 110, .external_lex_state = 2},
  [828] = {.lex_state = 110, .external_lex_state = 2},
  [829] = {.lex_state = 102},
  [830] = {.lex_state = 102},
  [831] = {.lex_state = 102},
  [832] = {.lex_state = 102},
  [833] = {.lex_state = 130},
  [834] = {.lex_state = 102},
  [835] = {.lex_state = 102},
  [836] = {.lex_state = 110},
  [837] = {.lex_state = 102},
  [838] = {.lex_state = 110},
  [839] = {.lex_state = 110},
  [840] = {.lex_state = 110},
  [841] = {.lex_state = 110},
  [842] = {.lex_state = 95},
  [843] = {.lex_state = 95},
  [844] = {.lex_state = 95},
  [845] = {.lex_state = 95},
  [846] = {.lex_state = 95},
  [847] = {.lex_state = 171},
  [848] = {.lex_state = 130},
  [849] = {.lex_state = 95},
  [850] = {.lex_state = 95, .external_lex_state = 2},
  [851] = {.lex_state = 95, .external_lex_state = 2},
  [852] = {.lex_state = 102},
  [853] = {.lex_state = 102},
  [854] = {.lex_state = 102, .external_lex_state = 2},
  [855] = {.lex_state = 102, .external_lex_state = 2},
  [856] = {.lex_state = 102, .external_lex_state = 2},
  [857] = {.lex_state = 95},
  [858] = {.lex_state = 95},
  [859] = {.lex_state = 102, .external_lex_state = 2},
  [860] = {.lex_state = 102, .external_lex_state = 2},
  [861] = {.lex_state = 95},
  [862] = {.lex_state = 110, .external_lex_state = 2},
  [863] = {.lex_state = 130},
  [864] = {.lex_state = 102, .external_lex_state = 2},
  [865] = {.lex_state = 95},
  [866] = {.lex_state = 102},
  [867] = {.lex_state = 110, .external_lex_state = 2},
  [868] = {.lex_state = 102, .external_lex_state = 2},
  [869] = {.lex_state = 110, .external_lex_state = 2},
  [870] = {.lex_state = 110, .external_lex_state = 2},
  [871] = {.lex_state = 95},
  [872] = {.lex_state = 137},
  [873] = {.lex_state = 95},
  [874] = {.lex_state = 95},
  [875] = {.lex_state = 95},
  [876] = {.lex_state = 95},
  [877] = {.lex_state = 95},
  [878] = {.lex_state = 102},
  [879] = {.lex_state = 95},
  [880] = {.lex_state = 95},
  [881] = {.lex_state = 95},
  [882] = {.lex_state = 130},
  [883] = {.lex_state = 134},
  [884] = {.lex_state = 95},
  [885] = {.lex_state = 95},
  [886] = {.lex_state = 95},
  [887] = {.lex_state = 95},
  [888] = {.lex_state = 95},
  [889] = {.lex_state = 95},
  [890] = {.lex_state = 95},
  [891] = {.lex_state = 137},
  [892] = {.lex_state = 102},
  [893] = {.lex_state = 95},
  [894] = {.lex_state = 95},
  [895] = {.lex_state = 95},
  [896] = {.lex_state = 134},
  [897] = {.lex_state = 171},
  [898] = {.lex_state = 171},
  [899] = {.lex_state = 95},
  [900] = {.lex_state = 171},
  [901] = {.lex_state = 134},
  [902] = {.lex_state = 95},
  [903] = {.lex_state = 102},
  [904] = {.lex_state = 110, .external_lex_state = 2},
  [905] = {.lex_state = 110, .external_lex_state = 2},
  [906] = {.lex_state = 110, .external_lex_state = 2},
  [907] = {.lex_state = 110, .external_lex_state = 2},
  [908] = {.lex_state = 110, .external_lex_state = 2},
  [909] = {.lex_state = 95, .external_lex_state = 2},
  [910] = {.lex_state = 102},
  [911] = {.lex_state = 102},
  [912] = {.lex_state = 95},
  [913] = {.lex_state = 95},
  [914] = {.lex_state = 102},
  [915] = {.lex_state = 102},
  [916] = {.lex_state = 95},
  [917] = {.lex_state = 110},
  [918] = {.lex_state = 130},
  [919] = {.lex_state = 102},
  [920] = {.lex_state = 95},
  [921] = {.lex_state = 102},
  [922] = {.lex_state = 110},
  [923] = {.lex_state = 102},
  [924] = {.lex_state = 110},
  [925] = {.lex_state = 110},
  [926] = {.lex_state = 110, .external_lex_state = 2},
  [927] = {.lex_state = 110, .external_lex_state = 2},
  [928] = {.lex_state = 171},
  [929] = {.lex_state = 137},
  [930] = {.lex_state = 171},
  [931] = {.lex_state = 110, .external_lex_state = 2},
  [932] = {.lex_state = 171},
  [933] = {.lex_state = 95},
  [934] = {.lex_state = 95},
  [935] = {.lex_state = 95},
  [936] = {.lex_state = 110, .external_lex_state = 2},
  [937] = {.lex_state = 110, .external_lex_state = 2},
  [938] = {.lex_state = 95},
  [939] = {.lex_state = 171},
  [940] = {.lex_state = 171},
  [941] = {.lex_state = 110, .external_lex_state = 2},
  [942] = {.lex_state = 110, .external_lex_state = 2},
  [943] = {.lex_state = 95},
  [944] = {.lex_state = 102},
  [945] = {.lex_state = 110, .external_lex_state = 2},
  [946] = {.lex_state = 110, .external_lex_state = 2},
  [947] = {.lex_state = 102},
  [948] = {.lex_state = 102, .external_lex_state = 2},
  [949] = {.lex_state = 110, .external_lex_state = 2},
  [950] = {.lex_state = 130},
  [951] = {.lex_state = 102, .external_lex_state = 2},
  [952] = {.lex_state = 95},
  [953] = {.lex_state = 95},
  [954] = {.lex_state = 137},
  [955] = {.lex_state = 102, .external_lex_state = 2},
  [956] = {.lex_state = 139},
  [957] = {.lex_state = 110, .external_lex_state = 2},
  [958] = {.lex_state = 130},
  [959] = {.lex_state = 95},
  [960] = {.lex_state = 102},
  [961] = {.lex_state = 110, .external_lex_state = 2},
  [962] = {.lex_state = 148},
  [963] = {.lex_state = 148},
  [964] = {.lex_state = 148},
  [965] = {.lex_state = 148},
  [966] = {.lex_state = 148},
  [967] = {.lex_state = 95},
  [968] = {.lex_state = 164},
  [969] = {.lex_state = 161},
  [970] = {.lex_state = 102},
  [971] = {.lex_state = 148},
  [972] = {.lex_state = 164},
  [973] = {.lex_state = 164},
  [974] = {.lex_state = 110, .external_lex_state = 2},
  [975] = {.lex_state = 164},
  [976] = {.lex_state = 137},
  [977] = {.lex_state = 95},
  [978] = {.lex_state = 95},
  [979] = {.lex_state = 95},
  [980] = {.lex_state = 95},
  [981] = {.lex_state = 95},
  [982] = {.lex_state = 95},
  [983] = {.lex_state = 161},
  [984] = {.lex_state = 161},
  [985] = {.lex_state = 102},
  [986] = {.lex_state = 102},
  [987] = {.lex_state = 161},
  [988] = {.lex_state = 161},
  [989] = {.lex_state = 102},
  [990] = {.lex_state = 102},
  [991] = {.lex_state = 102},
  [992] = {.lex_state = 102},
  [993] = {.lex_state = 102},
  [994] = {.lex_state = 161},
  [995] = {.lex_state = 95},
  [996] = {.lex_state = 95},
  [997] = {.lex_state = 95},
  [998] = {.lex_state = 95},
  [999] = {.lex_state = 95},
  [1000] = {.lex_state = 95},
  [1001] = {.lex_state = 106, .external_lex_state = 3},
  [1002] = {.lex_state = 171},
  [1003] = {.lex_state = 130},
  [1004] = {.lex_state = 95},
  [1005] = {.lex_state = 137},
  [1006] = {.lex_state = 191},
  [1007] = {.lex_state = 181},
  [1008] = {.lex_state = 139},
  [1009] = {.lex_state = 139},
  [1010] = {.lex_state = 102},
  [1011] = {.lex_state = 179},
  [1012] = {.lex_state = 130},
  [1013] = {.lex_state = 102},
  [1014] = {.lex_state = 102},
  [1015] = {.lex_state = 95},
  [1016] = {.lex_state = 134, .external_lex_state = 2},
  [1017] = {.lex_state = 184, .external_lex_state = 2},
  [1018] = {.lex_state = 171},
  [1019] = {.lex_state = 137},
  [1020] = {.lex_state = 171},
  [1021] = {.lex_state = 171},
  [1022] = {.lex_state = 184, .external_lex_state = 2},
  [1023] = {.lex_state = 184, .external_lex_state = 2},
  [1024] = {.lex_state = 95},
  [1025] = {.lex_state = 95},
  [1026] = {.lex_state = 184, .external_lex_state = 2},
  [1027] = {.lex_state = 95},
  [1028] = {.lex_state = 95},
  [1029] = {.lex_state = 171},
  [1030] = {.lex_state = 171},
  [1031] = {.lex_state = 134, .external_lex_state = 2},
  [1032] = {.lex_state = 184, .external_lex_state = 2},
  [1033] = {.lex_state = 95},
  [1034] = {.lex_state = 102},
  [1035] = {.lex_state = 184, .external_lex_state = 2},
  [1036] = {.lex_state = 102},
  [1037] = {.lex_state = 102, .external_lex_state = 2},
  [1038] = {.lex_state = 177},
  [1039] = {.lex_state = 130},
  [1040] = {.lex_state = 137},
  [1041] = {.lex_state = 177},
  [1042] = {.lex_state = 102},
  [1043] = {.lex_state = 102},
  [1044] = {.lex_state = 177},
  [1045] = {.lex_state = 102},
  [1046] = {.lex_state = 102, .external_lex_state = 2},
  [1047] = {.lex_state = 137},
  [1048] = {.lex_state = 102, .external_lex_state = 2},
  [1049] = {.lex_state = 134},
  [1050] = {.lex_state = 171},
  [1051] = {.lex_state = 171},
  [1052] = {.lex_state = 95},
  [1053] = {.lex_state = 171},
  [1054] = {.lex_state = 134},
  [1055] = {.lex_state = 95},
  [1056] = {.lex_state = 102},
  [1057] = {.lex_state = 102, .external_lex_state = 2},
  [1058] = {.lex_state = 102, .external_lex_state = 2},
  [1059] = {.lex_state = 95},
  [1060] = {.lex_state = 183, .external_lex_state = 2},
  [1061] = {.lex_state = 171},
  [1062] = {.lex_state = 95},
  [1063] = {.lex_state = 171},
  [1064] = {.lex_state = 193},
  [1065] = {.lex_state = 171},
  [1066] = {.lex_state = 185},
  [1067] = {.lex_state = 95},
  [1068] = {.lex_state = 130},
  [1069] = {.lex_state = 95},
  [1070] = {.lex_state = 130},
  [1071] = {.lex_state = 184, .external_lex_state = 2},
  [1072] = {.lex_state = 184, .external_lex_state = 2},
  [1073] = {.lex_state = 185},
  [1074] = {.lex_state = 95},
  [1075] = {.lex_state = 184, .external_lex_state = 2},
  [1076] = {.lex_state = 130},
  [1077] = {.lex_state = 95},
  [1078] = {.lex_state = 184, .external_lex_state = 2},
  [1079] = {.lex_state = 102, .external_lex_state = 2},
  [1080] = {.lex_state = 130},
  [1081] = {.lex_state = 102, .external_lex_state = 2},
  [1082] = {.lex_state = 95},
  [1083] = {.lex_state = 130},
  [1084] = {.lex_state = 171},
  [1085] = {.lex_state = 171},
  [1086] = {.lex_state = 95},
  [1087] = {.lex_state = 171},
  [1088] = {.lex_state = 130},
  [1089] = {.lex_state = 95},
  [1090] = {.lex_state = 102},
  [1091] = {.lex_state = 185},
  [1092] = {.lex_state = 185},
  [1093] = {.lex_state = 185},
  [1094] = {.lex_state = 185},
  [1095] = {.lex_state = 185},
  [1096] = {.lex_state = 95},
  [1097] = {.lex_state = 102},
  [1098] = {.lex_state = 130},
  [1099] = {.lex_state = 194},
  [1100] = {.lex_state = 194},
  [1101] = {.lex_state = 137},
  [1102] = {.lex_state = 171},
  [1103] = {.lex_state = 171},
  [1104] = {.lex_state = 171},
  [1105] = {.lex_state = 194},
  [1106] = {.lex_state = 95},
  [1107] = {.lex_state = 139},
  [1108] = {.lex_state = 95},
  [1109] = {.lex_state = 102},
  [1110] = {.lex_state = 185},
  [1111] = {.lex_state = 195},
  [1112] = {.lex_state = 171},
  [1113] = {.lex_state = 171},
  [1114] = {.lex_state = 186},
  [1115] = {.lex_state = 102},
  [1116] = {.lex_state = 171},
  [1117] = {.lex_state = 193},
  [1118] = {.lex_state = 102},
  [1119] = {.lex_state = 130},
  [1120] = {.lex_state = 171},
  [1121] = {.lex_state = 95},
  [1122] = {.lex_state = 95},
  [1123] = {.lex_state = 95},
  [1124] = {.lex_state = 95},
  [1125] = {.lex_state = 95},
  [1126] = {.lex_state = 181},
  [1127] = {.lex_state = 181},
  [1128] = {.lex_state = 181},
  [1129] = {.lex_state = 181},
  [1130] = {.lex_state = 102},
  [1131] = {.lex_state = 102},
  [1132] = {.lex_state = 181},
  [1133] = {.lex_state = 181},
  [1134] = {.lex_state = 180},
  [1135] = {.lex_state = 180},
  [1136] = {.lex_state = 180},
  [1137] = {.lex_state = 180},
  [1138] = {.lex_state = 180},
  [1139] = {.lex_state = 181},
  [1140] = {.lex_state = 95},
  [1141] = {.lex_state = 95},
  [1142] = {.lex_state = 95},
  [1143] = {.lex_state = 95},
  [1144] = {.lex_state = 95},
  [1145] = {.lex_state = 171},
  [1146] = {.lex_state = 130},
  [1147] = {.lex_state = 110, .external_lex_state = 2},
  [1148] = {.lex_state = 95},
  [1149] = {.lex_state = 139},
  [1150] = {.lex_state = 139},
  [1151] = {.lex_state = 175},
  [1152] = {.lex_state = 175},
  [1153] = {.lex_state = 95},
  [1154] = {.lex_state = 95},
  [1155] = {.lex_state = 175},
  [1156] = {.lex_state = 175},
  [1157] = {.lex_state = 95},
  [1158] = {.lex_state = 179},
  [1159] = {.lex_state = 130},
  [1160] = {.lex_state = 175},
  [1161] = {.lex_state = 95},
  [1162] = {.lex_state = 102},
  [1163] = {.lex_state = 179},
  [1164] = {.lex_state = 175},
  [1165] = {.lex_state = 179},
  [1166] = {.lex_state = 130},
  [1167] = {.lex_state = 179},
  [1168] = {.lex_state = 130},
  [1169] = {.lex_state = 137},
  [1170] = {.lex_state = 130},
  [1171] = {.lex_state = 137},
  [1172] = {.lex_state = 102},
  [1173] = {.lex_state = 102},
  [1174] = {.lex_state = 95},
  [1175] = {.lex_state = 139},
  [1176] = {.lex_state = 95},
  [1177] = {.lex_state = 95},
  [1178] = {.lex_state = 95},
  [1179] = {.lex_state = 95},
  [1180] = {.lex_state = 102},
  [1181] = {.lex_state = 95},
  [1182] = {.lex_state = 134},
  [1183] = {.lex_state = 95},
  [1184] = {.lex_state = 95},
  [1185] = {.lex_state = 95},
  [1186] = {.lex_state = 95},
  [1187] = {.lex_state = 95},
  [1188] = {.lex_state = 137},
  [1189] = {.lex_state = 95},
  [1190] = {.lex_state = 95},
  [1191] = {.lex_state = 137},
  [1192] = {.lex_state = 134, .external_lex_state = 2},
  [1193] = {.lex_state = 171},
  [1194] = {.lex_state = 171},
  [1195] = {.lex_state = 95},
  [1196] = {.lex_state = 171},
  [1197] = {.lex_state = 134, .external_lex_state = 2},
  [1198] = {.lex_state = 95},
  [1199] = {.lex_state = 102},
  [1200] = {.lex_state = 171},
  [1201] = {.lex_state = 95},
  [1202] = {.lex_state = 95},
  [1203] = {.lex_state = 102, .external_lex_state = 2},
  [1204] = {.lex_state = 95},
  [1205] = {.lex_state = 137},
  [1206] = {.lex_state = 95, .external_lex_state = 2},
  [1207] = {.lex_state = 95},
  [1208] = {.lex_state = 95},
  [1209] = {.lex_state = 102},
  [1210] = {.lex_state = 95},
  [1211] = {.lex_state = 102},
  [1212] = {.lex_state = 95},
  [1213] = {.lex_state = 102},
  [1214] = {.lex_state = 95, .external_lex_state = 2},
  [1215] = {.lex_state = 173, .external_lex_state = 2},
  [1216] = {.lex_state = 173, .external_lex_state = 2},
  [1217] = {.lex_state = 95},
  [1218] = {.lex_state = 95},
  [1219] = {.lex_state = 95},
  [1220] = {.lex_state = 95},
  [1221] = {.lex_state = 95},
  [1222] = {.lex_state = 95},
  [1223] = {.lex_state = 102, .external_lex_state = 2},
  [1224] = {.lex_state = 102},
  [1225] = {.lex_state = 102},
  [1226] = {.lex_state = 139},
  [1227] = {.lex_state = 95},
  [1228] = {.lex_state = 95},
  [1229] = {.lex_state = 95},
  [1230] = {.lex_state = 95},
  [1231] = {.lex_state = 177},
  [1232] = {.lex_state = 137},
  [1233] = {.lex_state = 177},
  [1234] = {.lex_state = 179},
  [1235] = {.lex_state = 179},
  [1236] = {.lex_state = 179},
  [1237] = {.lex_state = 179},
  [1238] = {.lex_state = 187},
  [1239] = {.lex_state = 177},
  [1240] = {.lex_state = 177},
  [1241] = {.lex_state = 179},
  [1242] = {.lex_state = 179},
  [1243] = {.lex_state = 187},
  [1244] = {.lex_state = 95},
  [1245] = {.lex_state = 95},
  [1246] = {.lex_state = 177},
  [1247] = {.lex_state = 177},
  [1248] = {.lex_state = 137},
  [1249] = {.lex_state = 177},
  [1250] = {.lex_state = 177},
  [1251] = {.lex_state = 139},
  [1252] = {.lex_state = 179},
  [1253] = {.lex_state = 130},
  [1254] = {.lex_state = 177},
  [1255] = {.lex_state = 95},
  [1256] = {.lex_state = 95},
  [1257] = {.lex_state = 95},
  [1258] = {.lex_state = 95},
  [1259] = {.lex_state = 148},
  [1260] = {.lex_state = 164},
  [1261] = {.lex_state = 102},
  [1262] = {.lex_state = 148},
  [1263] = {.lex_state = 196},
  [1264] = {.lex_state = 95},
  [1265] = {.lex_state = 95},
  [1266] = {.lex_state = 137},
  [1267] = {.lex_state = 177},
  [1268] = {.lex_state = 177},
  [1269] = {.lex_state = 177},
  [1270] = {.lex_state = 177},
  [1271] = {.lex_state = 95},
  [1272] = {.lex_state = 177},
  [1273] = {.lex_state = 179},
  [1274] = {.lex_state = 179},
  [1275] = {.lex_state = 179},
  [1276] = {.lex_state = 179},
  [1277] = {.lex_state = 110},
  [1278] = {.lex_state = 179},
  [1279] = {.lex_state = 177},
  [1280] = {.lex_state = 171},
  [1281] = {.lex_state = 137},
  [1282] = {.lex_state = 171},
  [1283] = {.lex_state = 177},
  [1284] = {.lex_state = 171},
  [1285] = {.lex_state = 95},
  [1286] = {.lex_state = 95},
  [1287] = {.lex_state = 95},
  [1288] = {.lex_state = 177},
  [1289] = {.lex_state = 177},
  [1290] = {.lex_state = 95},
  [1291] = {.lex_state = 171},
  [1292] = {.lex_state = 171},
  [1293] = {.lex_state = 177},
  [1294] = {.lex_state = 177},
  [1295] = {.lex_state = 95},
  [1296] = {.lex_state = 102},
  [1297] = {.lex_state = 177},
  [1298] = {.lex_state = 177},
  [1299] = {.lex_state = 102},
  [1300] = {.lex_state = 175},
  [1301] = {.lex_state = 177},
  [1302] = {.lex_state = 175},
  [1303] = {.lex_state = 95},
  [1304] = {.lex_state = 95},
  [1305] = {.lex_state = 137},
  [1306] = {.lex_state = 175},
  [1307] = {.lex_state = 139},
  [1308] = {.lex_state = 177},
  [1309] = {.lex_state = 130},
  [1310] = {.lex_state = 179},
  [1311] = {.lex_state = 110, .external_lex_state = 2},
  [1312] = {.lex_state = 95},
  [1313] = {.lex_state = 95},
  [1314] = {.lex_state = 148},
  [1315] = {.lex_state = 177},
  [1316] = {.lex_state = 185},
  [1317] = {.lex_state = 185},
  [1318] = {.lex_state = 95},
  [1319] = {.lex_state = 95},
  [1320] = {.lex_state = 95},
  [1321] = {.lex_state = 171},
  [1322] = {.lex_state = 95},
  [1323] = {.lex_state = 95},
  [1324] = {.lex_state = 95},
  [1325] = {.lex_state = 95},
  [1326] = {.lex_state = 102},
  [1327] = {.lex_state = 110},
  [1328] = {.lex_state = 110},
  [1329] = {.lex_state = 102},
  [1330] = {.lex_state = 102},
  [1331] = {.lex_state = 110},
  [1332] = {.lex_state = 110},
  [1333] = {.lex_state = 182},
  [1334] = {.lex_state = 102},
  [1335] = {.lex_state = 102},
  [1336] = {.lex_state = 102},
  [1337] = {.lex_state = 102},
  [1338] = {.lex_state = 102},
  [1339] = {.lex_state = 110},
  [1340] = {.lex_state = 95},
  [1341] = {.lex_state = 95},
  [1342] = {.lex_state = 95},
  [1343] = {.lex_state = 95},
  [1344] = {.lex_state = 95},
  [1345] = {.lex_state = 95},
  [1346] = {.lex_state = 171},
  [1347] = {.lex_state = 130},
  [1348] = {.lex_state = 95},
  [1349] = {.lex_state = 102},
  [1350] = {.lex_state = 171},
  [1351] = {.lex_state = 95},
  [1352] = {.lex_state = 102},
  [1353] = {.lex_state = 171},
  [1354] = {.lex_state = 171},
  [1355] = {.lex_state = 171},
  [1356] = {.lex_state = 102},
  [1357] = {.lex_state = 102},
  [1358] = {.lex_state = 171},
  [1359] = {.lex_state = 173, .external_lex_state = 2},
  [1360] = {.lex_state = 95},
  [1361] = {.lex_state = 175},
  [1362] = {.lex_state = 175},
  [1363] = {.lex_state = 95},
  [1364] = {.lex_state = 95},
  [1365] = {.lex_state = 175},
  [1366] = {.lex_state = 175},
  [1367] = {.lex_state = 95},
  [1368] = {.lex_state = 179},
  [1369] = {.lex_state = 130},
  [1370] = {.lex_state = 175},
  [1371] = {.lex_state = 95},
  [1372] = {.lex_state = 102},
  [1373] = {.lex_state = 179},
  [1374] = {.lex_state = 175},
  [1375] = {.lex_state = 179},
  [1376] = {.lex_state = 179},
  [1377] = {.lex_state = 130},
  [1378] = {.lex_state = 130},
  [1379] = {.lex_state = 95},
  [1380] = {.lex_state = 134, .external_lex_state = 2},
  [1381] = {.lex_state = 95},
  [1382] = {.lex_state = 130},
  [1383] = {.lex_state = 134, .external_lex_state = 2},
  [1384] = {.lex_state = 134, .external_lex_state = 2},
  [1385] = {.lex_state = 184, .external_lex_state = 2},
  [1386] = {.lex_state = 140},
  [1387] = {.lex_state = 134, .external_lex_state = 2},
  [1388] = {.lex_state = 95},
  [1389] = {.lex_state = 95},
  [1390] = {.lex_state = 134, .external_lex_state = 2},
  [1391] = {.lex_state = 122},
  [1392] = {.lex_state = 137},
  [1393] = {.lex_state = 134, .external_lex_state = 2},
  [1394] = {.lex_state = 102, .external_lex_state = 2},
  [1395] = {.lex_state = 95},
  [1396] = {.lex_state = 102, .external_lex_state = 2},
  [1397] = {.lex_state = 102, .external_lex_state = 2},
  [1398] = {.lex_state = 102, .external_lex_state = 2},
  [1399] = {.lex_state = 102, .external_lex_state = 2},
  [1400] = {.lex_state = 130},
  [1401] = {.lex_state = 130},
  [1402] = {.lex_state = 130},
  [1403] = {.lex_state = 173, .external_lex_state = 2},
  [1404] = {.lex_state = 137},
  [1405] = {.lex_state = 102},
  [1406] = {.lex_state = 95},
  [1407] = {.lex_state = 95},
  [1408] = {.lex_state = 137},
  [1409] = {.lex_state = 95},
  [1410] = {.lex_state = 95},
  [1411] = {.lex_state = 95, .external_lex_state = 2},
  [1412] = {.lex_state = 95},
  [1413] = {.lex_state = 95},
  [1414] = {.lex_state = 137},
  [1415] = {.lex_state = 95},
  [1416] = {.lex_state = 95},
  [1417] = {.lex_state = 102, .external_lex_state = 2},
  [1418] = {.lex_state = 102, .external_lex_state = 2},
  [1419] = {.lex_state = 95},
  [1420] = {.lex_state = 95},
  [1421] = {.lex_state = 102, .external_lex_state = 2},
  [1422] = {.lex_state = 102, .external_lex_state = 2},
  [1423] = {.lex_state = 95},
  [1424] = {.lex_state = 161, .external_lex_state = 2},
  [1425] = {.lex_state = 130},
  [1426] = {.lex_state = 102, .external_lex_state = 2},
  [1427] = {.lex_state = 95},
  [1428] = {.lex_state = 102},
  [1429] = {.lex_state = 161, .external_lex_state = 2},
  [1430] = {.lex_state = 102, .external_lex_state = 2},
  [1431] = {.lex_state = 161, .external_lex_state = 2},
  [1432] = {.lex_state = 161, .external_lex_state = 2},
  [1433] = {.lex_state = 110, .external_lex_state = 2},
  [1434] = {.lex_state = 139},
  [1435] = {.lex_state = 102},
  [1436] = {.lex_state = 175},
  [1437] = {.lex_state = 175},
  [1438] = {.lex_state = 175},
  [1439] = {.lex_state = 175},
  [1440] = {.lex_state = 175},
  [1441] = {.lex_state = 179},
  [1442] = {.lex_state = 95},
  [1443] = {.lex_state = 95},
  [1444] = {.lex_state = 130},
  [1445] = {.lex_state = 130},
  [1446] = {.lex_state = 95},
  [1447] = {.lex_state = 130},
  [1448] = {.lex_state = 102, .external_lex_state = 2},
  [1449] = {.lex_state = 95},
  [1450] = {.lex_state = 95},
  [1451] = {.lex_state = 102, .external_lex_state = 2},
  [1452] = {.lex_state = 95},
  [1453] = {.lex_state = 102, .external_lex_state = 2},
  [1454] = {.lex_state = 95},
  [1455] = {.lex_state = 137},
  [1456] = {.lex_state = 95},
  [1457] = {.lex_state = 95},
  [1458] = {.lex_state = 102, .external_lex_state = 2},
  [1459] = {.lex_state = 95},
  [1460] = {.lex_state = 95},
  [1461] = {.lex_state = 95},
  [1462] = {.lex_state = 110, .external_lex_state = 2},
  [1463] = {.lex_state = 110, .external_lex_state = 2},
  [1464] = {.lex_state = 110, .external_lex_state = 2},
  [1465] = {.lex_state = 95},
  [1466] = {.lex_state = 95},
  [1467] = {.lex_state = 130},
  [1468] = {.lex_state = 110, .external_lex_state = 2},
  [1469] = {.lex_state = 102},
  [1470] = {.lex_state = 161},
  [1471] = {.lex_state = 102},
  [1472] = {.lex_state = 95},
  [1473] = {.lex_state = 137},
  [1474] = {.lex_state = 102},
  [1475] = {.lex_state = 102},
  [1476] = {.lex_state = 181},
  [1477] = {.lex_state = 181},
  [1478] = {.lex_state = 139},
  [1479] = {.lex_state = 180},
  [1480] = {.lex_state = 181},
  [1481] = {.lex_state = 181},
  [1482] = {.lex_state = 194},
  [1483] = {.lex_state = 171},
  [1484] = {.lex_state = 171},
  [1485] = {.lex_state = 95},
  [1486] = {.lex_state = 171},
  [1487] = {.lex_state = 194},
  [1488] = {.lex_state = 95},
  [1489] = {.lex_state = 102},
  [1490] = {.lex_state = 139},
  [1491] = {.lex_state = 180},
  [1492] = {.lex_state = 139},
  [1493] = {.lex_state = 180},
  [1494] = {.lex_state = 180},
  [1495] = {.lex_state = 180},
  [1496] = {.lex_state = 180},
  [1497] = {.lex_state = 139},
  [1498] = {.lex_state = 180},
  [1499] = {.lex_state = 180},
  [1500] = {.lex_state = 139},
  [1501] = {.lex_state = 180},
  [1502] = {.lex_state = 181},
  [1503] = {.lex_state = 139},
  [1504] = {.lex_state = 180},
  [1505] = {.lex_state = 181},
  [1506] = {.lex_state = 139},
  [1507] = {.lex_state = 171},
  [1508] = {.lex_state = 139},
  [1509] = {.lex_state = 95},
  [1510] = {.lex_state = 95},
  [1511] = {.lex_state = 102},
  [1512] = {.lex_state = 130},
  [1513] = {.lex_state = 139},
  [1514] = {.lex_state = 139},
  [1515] = {.lex_state = 139},
  [1516] = {.lex_state = 181},
  [1517] = {.lex_state = 181},
  [1518] = {.lex_state = 181},
  [1519] = {.lex_state = 181},
  [1520] = {.lex_state = 181},
  [1521] = {.lex_state = 198},
  [1522] = {.lex_state = 110},
  [1523] = {.lex_state = 181},
  [1524] = {.lex_state = 171},
  [1525] = {.lex_state = 171},
  [1526] = {.lex_state = 95},
  [1527] = {.lex_state = 171},
  [1528] = {.lex_state = 95},
  [1529] = {.lex_state = 102},
  [1530] = {.lex_state = 180},
  [1531] = {.lex_state = 180},
  [1532] = {.lex_state = 95},
  [1533] = {.lex_state = 95},
  [1534] = {.lex_state = 180},
  [1535] = {.lex_state = 130},
  [1536] = {.lex_state = 139},
  [1537] = {.lex_state = 139},
  [1538] = {.lex_state = 181},
  [1539] = {.lex_state = 110, .external_lex_state = 2},
  [1540] = {.lex_state = 180},
  [1541] = {.lex_state = 180},
  [1542] = {.lex_state = 180},
  [1543] = {.lex_state = 180},
  [1544] = {.lex_state = 180},
  [1545] = {.lex_state = 181},
  [1546] = {.lex_state = 139},
  [1547] = {.lex_state = 139},
  [1548] = {.lex_state = 139},
  [1549] = {.lex_state = 139},
  [1550] = {.lex_state = 139},
  [1551] = {.lex_state = 180},
  [1552] = {.lex_state = 139},
  [1553] = {.lex_state = 139},
  [1554] = {.lex_state = 180},
  [1555] = {.lex_state = 139},
  [1556] = {.lex_state = 110, .external_lex_state = 2},
  [1557] = {.lex_state = 110, .external_lex_state = 2},
  [1558] = {.lex_state = 110, .external_lex_state = 2},
  [1559] = {.lex_state = 110, .external_lex_state = 2},
  [1560] = {.lex_state = 130},
  [1561] = {.lex_state = 95, .external_lex_state = 2},
  [1562] = {.lex_state = 173, .external_lex_state = 2},
  [1563] = {.lex_state = 137},
  [1564] = {.lex_state = 95},
  [1565] = {.lex_state = 137},
  [1566] = {.lex_state = 137},
  [1567] = {.lex_state = 137},
  [1568] = {.lex_state = 102},
  [1569] = {.lex_state = 148},
  [1570] = {.lex_state = 134},
  [1571] = {.lex_state = 95},
  [1572] = {.lex_state = 148},
  [1573] = {.lex_state = 171},
  [1574] = {.lex_state = 171},
  [1575] = {.lex_state = 95},
  [1576] = {.lex_state = 171},
  [1577] = {.lex_state = 148},
  [1578] = {.lex_state = 134},
  [1579] = {.lex_state = 95},
  [1580] = {.lex_state = 102},
  [1581] = {.lex_state = 134},
  [1582] = {.lex_state = 148},
  [1583] = {.lex_state = 110, .external_lex_state = 2},
  [1584] = {.lex_state = 148},
  [1585] = {.lex_state = 161},
  [1586] = {.lex_state = 102},
  [1587] = {.lex_state = 164},
  [1588] = {.lex_state = 102},
  [1589] = {.lex_state = 148},
  [1590] = {.lex_state = 95},
  [1591] = {.lex_state = 102},
  [1592] = {.lex_state = 148},
  [1593] = {.lex_state = 175},
  [1594] = {.lex_state = 102},
  [1595] = {.lex_state = 102},
  [1596] = {.lex_state = 102},
  [1597] = {.lex_state = 110, .external_lex_state = 2},
  [1598] = {.lex_state = 102, .external_lex_state = 2},
  [1599] = {.lex_state = 130},
  [1600] = {.lex_state = 139},
  [1601] = {.lex_state = 102, .external_lex_state = 2},
  [1602] = {.lex_state = 171},
  [1603] = {.lex_state = 102, .external_lex_state = 2},
  [1604] = {.lex_state = 137},
  [1605] = {.lex_state = 95},
  [1606] = {.lex_state = 173, .external_lex_state = 2},
  [1607] = {.lex_state = 130},
  [1608] = {.lex_state = 171},
  [1609] = {.lex_state = 171},
  [1610] = {.lex_state = 95},
  [1611] = {.lex_state = 171},
  [1612] = {.lex_state = 130},
  [1613] = {.lex_state = 95},
  [1614] = {.lex_state = 102},
  [1615] = {.lex_state = 110},
  [1616] = {.lex_state = 95},
  [1617] = {.lex_state = 95},
  [1618] = {.lex_state = 102},
  [1619] = {.lex_state = 102},
  [1620] = {.lex_state = 102},
  [1621] = {.lex_state = 102},
  [1622] = {.lex_state = 102},
  [1623] = {.lex_state = 102},
  [1624] = {.lex_state = 102},
  [1625] = {.lex_state = 95},
  [1626] = {.lex_state = 110, .external_lex_state = 2},
  [1627] = {.lex_state = 181},
  [1628] = {.lex_state = 180},
  [1629] = {.lex_state = 180},
  [1630] = {.lex_state = 180},
  [1631] = {.lex_state = 180},
  [1632] = {.lex_state = 180},
  [1633] = {.lex_state = 180},
  [1634] = {.lex_state = 181},
  [1635] = {.lex_state = 181},
  [1636] = {.lex_state = 181},
  [1637] = {.lex_state = 110},
  [1638] = {.lex_state = 110},
  [1639] = {.lex_state = 110},
  [1640] = {.lex_state = 110},
  [1641] = {.lex_state = 110},
  [1642] = {.lex_state = 110},
  [1643] = {.lex_state = 171},
  [1644] = {.lex_state = 171},
  [1645] = {.lex_state = 95},
  [1646] = {.lex_state = 171},
  [1647] = {.lex_state = 95},
  [1648] = {.lex_state = 102},
  [1649] = {.lex_state = 102},
  [1650] = {.lex_state = 198},
  [1651] = {.lex_state = 102},
  [1652] = {.lex_state = 95},
  [1653] = {.lex_state = 95},
  [1654] = {.lex_state = 137},
  [1655] = {.lex_state = 102},
  [1656] = {.lex_state = 198},
  [1657] = {.lex_state = 130},
  [1658] = {.lex_state = 110},
  [1659] = {.lex_state = 137},
  [1660] = {.lex_state = 95, .external_lex_state = 2},
  [1661] = {.lex_state = 102},
  [1662] = {.lex_state = 95, .external_lex_state = 2},
  [1663] = {.lex_state = 102},
  [1664] = {.lex_state = 95},
  [1665] = {.lex_state = 95},
  [1666] = {.lex_state = 95},
  [1667] = {.lex_state = 95},
  [1668] = {.lex_state = 95},
  [1669] = {.lex_state = 95},
  [1670] = {.lex_state = 110, .external_lex_state = 2},
  [1671] = {.lex_state = 110, .external_lex_state = 2},
  [1672] = {.lex_state = 102},
  [1673] = {.lex_state = 102},
  [1674] = {.lex_state = 110, .external_lex_state = 2},
  [1675] = {.lex_state = 110, .external_lex_state = 2},
  [1676] = {.lex_state = 102, .external_lex_state = 2},
  [1677] = {.lex_state = 102, .external_lex_state = 2},
  [1678] = {.lex_state = 102, .external_lex_state = 2},
  [1679] = {.lex_state = 102, .external_lex_state = 2},
  [1680] = {.lex_state = 102, .external_lex_state = 2},
  [1681] = {.lex_state = 110, .external_lex_state = 2},
  [1682] = {.lex_state = 95},
  [1683] = {.lex_state = 95},
  [1684] = {.lex_state = 95},
  [1685] = {.lex_state = 95},
  [1686] = {.lex_state = 95},
  [1687] = {.lex_state = 171},
  [1688] = {.lex_state = 130},
  [1689] = {.lex_state = 95},
  [1690] = {.lex_state = 95, .external_lex_state = 2},
  [1691] = {.lex_state = 102, .external_lex_state = 2},
  [1692] = {.lex_state = 95},
  [1693] = {.lex_state = 95},
  [1694] = {.lex_state = 102, .external_lex_state = 2},
  [1695] = {.lex_state = 95},
  [1696] = {.lex_state = 102, .external_lex_state = 2},
  [1697] = {.lex_state = 95},
  [1698] = {.lex_state = 95},
  [1699] = {.lex_state = 95},
  [1700] = {.lex_state = 95},
  [1701] = {.lex_state = 95},
  [1702] = {.lex_state = 102, .external_lex_state = 2},
  [1703] = {.lex_state = 95},
  [1704] = {.lex_state = 95},
  [1705] = {.lex_state = 95},
  [1706] = {.lex_state = 110, .external_lex_state = 2},
  [1707] = {.lex_state = 110, .external_lex_state = 2},
  [1708] = {.lex_state = 95},
  [1709] = {.lex_state = 95},
  [1710] = {.lex_state = 95},
  [1711] = {.lex_state = 95},
  [1712] = {.lex_state = 95},
  [1713] = {.lex_state = 95},
  [1714] = {.lex_state = 95},
  [1715] = {.lex_state = 95, .external_lex_state = 2},
  [1716] = {.lex_state = 110, .external_lex_state = 2},
  [1717] = {.lex_state = 95},
  [1718] = {.lex_state = 95},
  [1719] = {.lex_state = 173, .external_lex_state = 2},
  [1720] = {.lex_state = 110, .external_lex_state = 2},
  [1721] = {.lex_state = 171},
  [1722] = {.lex_state = 95},
  [1723] = {.lex_state = 102},
  [1724] = {.lex_state = 171},
  [1725] = {.lex_state = 171},
  [1726] = {.lex_state = 102},
  [1727] = {.lex_state = 171},
  [1728] = {.lex_state = 95},
  [1729] = {.lex_state = 95},
  [1730] = {.lex_state = 95},
  [1731] = {.lex_state = 95},
  [1732] = {.lex_state = 95},
  [1733] = {.lex_state = 95},
  [1734] = {.lex_state = 110},
  [1735] = {.lex_state = 110},
  [1736] = {.lex_state = 102},
  [1737] = {.lex_state = 102},
  [1738] = {.lex_state = 110},
  [1739] = {.lex_state = 110},
  [1740] = {.lex_state = 102},
  [1741] = {.lex_state = 102},
  [1742] = {.lex_state = 102},
  [1743] = {.lex_state = 102},
  [1744] = {.lex_state = 102},
  [1745] = {.lex_state = 110},
  [1746] = {.lex_state = 95},
  [1747] = {.lex_state = 95},
  [1748] = {.lex_state = 95},
  [1749] = {.lex_state = 95},
  [1750] = {.lex_state = 95},
  [1751] = {.lex_state = 171},
  [1752] = {.lex_state = 130},
  [1753] = {.lex_state = 95},
  [1754] = {.lex_state = 95},
  [1755] = {.lex_state = 171},
  [1756] = {.lex_state = 171},
  [1757] = {.lex_state = 95},
  [1758] = {.lex_state = 171},
  [1759] = {.lex_state = 110, .external_lex_state = 2},
  [1760] = {.lex_state = 171},
  [1761] = {.lex_state = 110, .external_lex_state = 2},
  [1762] = {.lex_state = 130},
  [1763] = {.lex_state = 173, .external_lex_state = 2},
  [1764] = {.lex_state = 102, .external_lex_state = 2},
  [1765] = {.lex_state = 130},
  [1766] = {.lex_state = 110, .external_lex_state = 2},
  [1767] = {.lex_state = 110, .external_lex_state = 2},
  [1768] = {.lex_state = 110, .external_lex_state = 2},
  [1769] = {.lex_state = 110, .external_lex_state = 2},
  [1770] = {.lex_state = 110, .external_lex_state = 2},
  [1771] = {.lex_state = 95},
  [1772] = {.lex_state = 102},
  [1773] = {.lex_state = 139},
  [1774] = {.lex_state = 110, .external_lex_state = 2},
  [1775] = {.lex_state = 171},
  [1776] = {.lex_state = 171},
  [1777] = {.lex_state = 171},
  [1778] = {.lex_state = 110, .external_lex_state = 2},
  [1779] = {.lex_state = 102},
  [1780] = {.lex_state = 130},
  [1781] = {.lex_state = 171},
  [1782] = {.lex_state = 95},
  [1783] = {.lex_state = 175},
  [1784] = {.lex_state = 175},
  [1785] = {.lex_state = 95},
  [1786] = {.lex_state = 175},
  [1787] = {.lex_state = 179},
  [1788] = {.lex_state = 179},
  [1789] = {.lex_state = 95},
  [1790] = {.lex_state = 130},
  [1791] = {.lex_state = 95},
  [1792] = {.lex_state = 102},
  [1793] = {.lex_state = 102, .external_lex_state = 2},
  [1794] = {.lex_state = 110, .external_lex_state = 2},
  [1795] = {.lex_state = 184, .external_lex_state = 2},
  [1796] = {.lex_state = 130},
  [1797] = {.lex_state = 184, .external_lex_state = 2},
  [1798] = {.lex_state = 137},
  [1799] = {.lex_state = 95},
  [1800] = {.lex_state = 184, .external_lex_state = 2},
  [1801] = {.lex_state = 184, .external_lex_state = 2},
  [1802] = {.lex_state = 184, .external_lex_state = 2},
  [1803] = {.lex_state = 130},
  [1804] = {.lex_state = 184, .external_lex_state = 2},
  [1805] = {.lex_state = 130},
  [1806] = {.lex_state = 130},
  [1807] = {.lex_state = 184, .external_lex_state = 2},
  [1808] = {.lex_state = 130},
  [1809] = {.lex_state = 180},
  [1810] = {.lex_state = 180},
  [1811] = {.lex_state = 95},
  [1812] = {.lex_state = 180},
  [1813] = {.lex_state = 181},
  [1814] = {.lex_state = 181},
  [1815] = {.lex_state = 95},
  [1816] = {.lex_state = 130},
  [1817] = {.lex_state = 95},
  [1818] = {.lex_state = 102},
  [1819] = {.lex_state = 95},
  [1820] = {.lex_state = 102},
  [1821] = {.lex_state = 102},
  [1822] = {.lex_state = 102},
  [1823] = {.lex_state = 148},
  [1824] = {.lex_state = 102},
  [1825] = {.lex_state = 102},
  [1826] = {.lex_state = 102},
  [1827] = {.lex_state = 102},
  [1828] = {.lex_state = 102},
  [1829] = {.lex_state = 102},
  [1830] = {.lex_state = 95},
  [1831] = {.lex_state = 95},
  [1832] = {.lex_state = 102},
  [1833] = {.lex_state = 102},
  [1834] = {.lex_state = 95},
  [1835] = {.lex_state = 161},
  [1836] = {.lex_state = 130},
  [1837] = {.lex_state = 102},
  [1838] = {.lex_state = 95},
  [1839] = {.lex_state = 102},
  [1840] = {.lex_state = 161},
  [1841] = {.lex_state = 102},
  [1842] = {.lex_state = 161},
  [1843] = {.lex_state = 161},
  [1844] = {.lex_state = 164},
  [1845] = {.lex_state = 148},
  [1846] = {.lex_state = 164},
  [1847] = {.lex_state = 148},
  [1848] = {.lex_state = 173, .external_lex_state = 2},
  [1849] = {.lex_state = 161},
  [1850] = {.lex_state = 161},
  [1851] = {.lex_state = 161},
  [1852] = {.lex_state = 161},
  [1853] = {.lex_state = 161},
  [1854] = {.lex_state = 161},
  [1855] = {.lex_state = 95},
  [1856] = {.lex_state = 95},
  [1857] = {.lex_state = 161},
  [1858] = {.lex_state = 161},
  [1859] = {.lex_state = 161},
  [1860] = {.lex_state = 161},
  [1861] = {.lex_state = 161},
  [1862] = {.lex_state = 110},
  [1863] = {.lex_state = 161},
  [1864] = {.lex_state = 171},
  [1865] = {.lex_state = 171},
  [1866] = {.lex_state = 95},
  [1867] = {.lex_state = 171},
  [1868] = {.lex_state = 95},
  [1869] = {.lex_state = 102},
  [1870] = {.lex_state = 102},
  [1871] = {.lex_state = 102},
  [1872] = {.lex_state = 95},
  [1873] = {.lex_state = 95},
  [1874] = {.lex_state = 102},
  [1875] = {.lex_state = 130},
  [1876] = {.lex_state = 161},
  [1877] = {.lex_state = 191},
  [1878] = {.lex_state = 139},
  [1879] = {.lex_state = 134},
  [1880] = {.lex_state = 95},
  [1881] = {.lex_state = 171},
  [1882] = {.lex_state = 171},
  [1883] = {.lex_state = 95},
  [1884] = {.lex_state = 171},
  [1885] = {.lex_state = 184, .external_lex_state = 2},
  [1886] = {.lex_state = 171},
  [1887] = {.lex_state = 184, .external_lex_state = 2},
  [1888] = {.lex_state = 130},
  [1889] = {.lex_state = 184, .external_lex_state = 2},
  [1890] = {.lex_state = 102, .external_lex_state = 2},
  [1891] = {.lex_state = 130},
  [1892] = {.lex_state = 184, .external_lex_state = 2},
  [1893] = {.lex_state = 184, .external_lex_state = 2},
  [1894] = {.lex_state = 184, .external_lex_state = 2},
  [1895] = {.lex_state = 184, .external_lex_state = 2},
  [1896] = {.lex_state = 184, .external_lex_state = 2},
  [1897] = {.lex_state = 95},
  [1898] = {.lex_state = 102},
  [1899] = {.lex_state = 139},
  [1900] = {.lex_state = 184, .external_lex_state = 2},
  [1901] = {.lex_state = 171},
  [1902] = {.lex_state = 171},
  [1903] = {.lex_state = 171},
  [1904] = {.lex_state = 184, .external_lex_state = 2},
  [1905] = {.lex_state = 102},
  [1906] = {.lex_state = 130},
  [1907] = {.lex_state = 171},
  [1908] = {.lex_state = 177},
  [1909] = {.lex_state = 177},
  [1910] = {.lex_state = 177},
  [1911] = {.lex_state = 102},
  [1912] = {.lex_state = 171},
  [1913] = {.lex_state = 95},
  [1914] = {.lex_state = 102},
  [1915] = {.lex_state = 171},
  [1916] = {.lex_state = 171},
  [1917] = {.lex_state = 102},
  [1918] = {.lex_state = 171},
  [1919] = {.lex_state = 179},
  [1920] = {.lex_state = 130},
  [1921] = {.lex_state = 171},
  [1922] = {.lex_state = 171},
  [1923] = {.lex_state = 95},
  [1924] = {.lex_state = 171},
  [1925] = {.lex_state = 130},
  [1926] = {.lex_state = 95},
  [1927] = {.lex_state = 102},
  [1928] = {.lex_state = 193},
  [1929] = {.lex_state = 171},
  [1930] = {.lex_state = 95},
  [1931] = {.lex_state = 171},
  [1932] = {.lex_state = 134},
  [1933] = {.lex_state = 95},
  [1934] = {.lex_state = 102},
  [1935] = {.lex_state = 175},
  [1936] = {.lex_state = 175},
  [1937] = {.lex_state = 175},
  [1938] = {.lex_state = 175},
  [1939] = {.lex_state = 175},
  [1940] = {.lex_state = 102, .external_lex_state = 2},
  [1941] = {.lex_state = 130},
  [1942] = {.lex_state = 184, .external_lex_state = 2},
  [1943] = {.lex_state = 130},
  [1944] = {.lex_state = 95},
  [1945] = {.lex_state = 184, .external_lex_state = 2},
  [1946] = {.lex_state = 184, .external_lex_state = 2},
  [1947] = {.lex_state = 130},
  [1948] = {.lex_state = 95},
  [1949] = {.lex_state = 102, .external_lex_state = 2},
  [1950] = {.lex_state = 95},
  [1951] = {.lex_state = 95},
  [1952] = {.lex_state = 95},
  [1953] = {.lex_state = 95},
  [1954] = {.lex_state = 95},
  [1955] = {.lex_state = 95},
  [1956] = {.lex_state = 95},
  [1957] = {.lex_state = 95},
  [1958] = {.lex_state = 95},
  [1959] = {.lex_state = 95},
  [1960] = {.lex_state = 130},
  [1961] = {.lex_state = 95},
  [1962] = {.lex_state = 95},
  [1963] = {.lex_state = 95},
  [1964] = {.lex_state = 95},
  [1965] = {.lex_state = 95},
  [1966] = {.lex_state = 134},
  [1967] = {.lex_state = 95},
  [1968] = {.lex_state = 95},
  [1969] = {.lex_state = 95},
  [1970] = {.lex_state = 102, .external_lex_state = 2},
  [1971] = {.lex_state = 95, .external_lex_state = 2},
  [1972] = {.lex_state = 95},
  [1973] = {.lex_state = 95},
  [1974] = {.lex_state = 171},
  [1975] = {.lex_state = 184, .external_lex_state = 2},
  [1976] = {.lex_state = 102, .external_lex_state = 2},
  [1977] = {.lex_state = 102, .external_lex_state = 2},
  [1978] = {.lex_state = 137},
  [1979] = {.lex_state = 185},
  [1980] = {.lex_state = 102, .external_lex_state = 2},
  [1981] = {.lex_state = 130},
  [1982] = {.lex_state = 102, .external_lex_state = 2},
  [1983] = {.lex_state = 171},
  [1984] = {.lex_state = 95},
  [1985] = {.lex_state = 102},
  [1986] = {.lex_state = 171},
  [1987] = {.lex_state = 171},
  [1988] = {.lex_state = 171},
  [1989] = {.lex_state = 185},
  [1990] = {.lex_state = 130},
  [1991] = {.lex_state = 102},
  [1992] = {.lex_state = 171},
  [1993] = {.lex_state = 102},
  [1994] = {.lex_state = 171},
  [1995] = {.lex_state = 171},
  [1996] = {.lex_state = 184, .external_lex_state = 2},
  [1997] = {.lex_state = 184, .external_lex_state = 2},
  [1998] = {.lex_state = 184, .external_lex_state = 2},
  [1999] = {.lex_state = 184, .external_lex_state = 2},
  [2000] = {.lex_state = 184, .external_lex_state = 2},
  [2001] = {.lex_state = 194},
  [2002] = {.lex_state = 184, .external_lex_state = 2},
  [2003] = {.lex_state = 130},
  [2004] = {.lex_state = 95},
  [2005] = {.lex_state = 102},
  [2006] = {.lex_state = 171},
  [2007] = {.lex_state = 185},
  [2008] = {.lex_state = 171},
  [2009] = {.lex_state = 102},
  [2010] = {.lex_state = 171},
  [2011] = {.lex_state = 185},
  [2012] = {.lex_state = 185},
  [2013] = {.lex_state = 195},
  [2014] = {.lex_state = 134},
  [2015] = {.lex_state = 186},
  [2016] = {.lex_state = 102},
  [2017] = {.lex_state = 130},
  [2018] = {.lex_state = 171},
  [2019] = {.lex_state = 185},
  [2020] = {.lex_state = 134},
  [2021] = {.lex_state = 181},
  [2022] = {.lex_state = 181},
  [2023] = {.lex_state = 181},
  [2024] = {.lex_state = 181},
  [2025] = {.lex_state = 181},
  [2026] = {.lex_state = 95},
  [2027] = {.lex_state = 95},
  [2028] = {.lex_state = 181},
  [2029] = {.lex_state = 181},
  [2030] = {.lex_state = 181},
  [2031] = {.lex_state = 181},
  [2032] = {.lex_state = 110},
  [2033] = {.lex_state = 181},
  [2034] = {.lex_state = 171},
  [2035] = {.lex_state = 171},
  [2036] = {.lex_state = 95},
  [2037] = {.lex_state = 171},
  [2038] = {.lex_state = 95},
  [2039] = {.lex_state = 102},
  [2040] = {.lex_state = 180},
  [2041] = {.lex_state = 180},
  [2042] = {.lex_state = 95},
  [2043] = {.lex_state = 95},
  [2044] = {.lex_state = 180},
  [2045] = {.lex_state = 130},
  [2046] = {.lex_state = 181},
  [2047] = {.lex_state = 110, .external_lex_state = 2},
  [2048] = {.lex_state = 95},
  [2049] = {.lex_state = 95},
  [2050] = {.lex_state = 95},
  [2051] = {.lex_state = 95},
  [2052] = {.lex_state = 95},
  [2053] = {.lex_state = 95},
  [2054] = {.lex_state = 175},
  [2055] = {.lex_state = 179},
  [2056] = {.lex_state = 179},
  [2057] = {.lex_state = 102},
  [2058] = {.lex_state = 102},
  [2059] = {.lex_state = 179},
  [2060] = {.lex_state = 179},
  [2061] = {.lex_state = 175},
  [2062] = {.lex_state = 175},
  [2063] = {.lex_state = 175},
  [2064] = {.lex_state = 175},
  [2065] = {.lex_state = 175},
  [2066] = {.lex_state = 179},
  [2067] = {.lex_state = 95},
  [2068] = {.lex_state = 95},
  [2069] = {.lex_state = 95},
  [2070] = {.lex_state = 95},
  [2071] = {.lex_state = 95},
  [2072] = {.lex_state = 95},
  [2073] = {.lex_state = 171},
  [2074] = {.lex_state = 130},
  [2075] = {.lex_state = 95},
  [2076] = {.lex_state = 130},
  [2077] = {.lex_state = 137},
  [2078] = {.lex_state = 102},
  [2079] = {.lex_state = 102},
  [2080] = {.lex_state = 137},
  [2081] = {.lex_state = 102},
  [2082] = {.lex_state = 95},
  [2083] = {.lex_state = 95},
  [2084] = {.lex_state = 95},
  [2085] = {.lex_state = 102, .external_lex_state = 2},
  [2086] = {.lex_state = 95},
  [2087] = {.lex_state = 95},
  [2088] = {.lex_state = 95},
  [2089] = {.lex_state = 110, .external_lex_state = 2},
  [2090] = {.lex_state = 110, .external_lex_state = 2},
  [2091] = {.lex_state = 95},
  [2092] = {.lex_state = 137},
  [2093] = {.lex_state = 137},
  [2094] = {.lex_state = 137},
  [2095] = {.lex_state = 137},
  [2096] = {.lex_state = 95},
  [2097] = {.lex_state = 171},
  [2098] = {.lex_state = 95},
  [2099] = {.lex_state = 102},
  [2100] = {.lex_state = 137},
  [2101] = {.lex_state = 171},
  [2102] = {.lex_state = 171},
  [2103] = {.lex_state = 102},
  [2104] = {.lex_state = 171},
  [2105] = {.lex_state = 134, .external_lex_state = 2},
  [2106] = {.lex_state = 95},
  [2107] = {.lex_state = 137},
  [2108] = {.lex_state = 137},
  [2109] = {.lex_state = 102},
  [2110] = {.lex_state = 95},
  [2111] = {.lex_state = 95},
  [2112] = {.lex_state = 102},
  [2113] = {.lex_state = 102},
  [2114] = {.lex_state = 102},
  [2115] = {.lex_state = 95},
  [2116] = {.lex_state = 95},
  [2117] = {.lex_state = 95},
  [2118] = {.lex_state = 95},
  [2119] = {.lex_state = 95},
  [2120] = {.lex_state = 95},
  [2121] = {.lex_state = 180, .external_lex_state = 2},
  [2122] = {.lex_state = 180, .external_lex_state = 2},
  [2123] = {.lex_state = 95},
  [2124] = {.lex_state = 95},
  [2125] = {.lex_state = 180, .external_lex_state = 2},
  [2126] = {.lex_state = 180, .external_lex_state = 2},
  [2127] = {.lex_state = 95},
  [2128] = {.lex_state = 181, .external_lex_state = 2},
  [2129] = {.lex_state = 130},
  [2130] = {.lex_state = 180, .external_lex_state = 2},
  [2131] = {.lex_state = 95},
  [2132] = {.lex_state = 102},
  [2133] = {.lex_state = 181, .external_lex_state = 2},
  [2134] = {.lex_state = 180, .external_lex_state = 2},
  [2135] = {.lex_state = 139},
  [2136] = {.lex_state = 181, .external_lex_state = 2},
  [2137] = {.lex_state = 181, .external_lex_state = 2},
  [2138] = {.lex_state = 180},
  [2139] = {.lex_state = 180},
  [2140] = {.lex_state = 95},
  [2141] = {.lex_state = 95},
  [2142] = {.lex_state = 180},
  [2143] = {.lex_state = 180},
  [2144] = {.lex_state = 95},
  [2145] = {.lex_state = 181},
  [2146] = {.lex_state = 130},
  [2147] = {.lex_state = 180},
  [2148] = {.lex_state = 95},
  [2149] = {.lex_state = 102},
  [2150] = {.lex_state = 181},
  [2151] = {.lex_state = 180},
  [2152] = {.lex_state = 181},
  [2153] = {.lex_state = 181},
  [2154] = {.lex_state = 95},
  [2155] = {.lex_state = 95},
  [2156] = {.lex_state = 95},
  [2157] = {.lex_state = 95},
  [2158] = {.lex_state = 181},
  [2159] = {.lex_state = 139},
  [2160] = {.lex_state = 181},
  [2161] = {.lex_state = 181, .external_lex_state = 2},
  [2162] = {.lex_state = 139},
  [2163] = {.lex_state = 181},
  [2164] = {.lex_state = 181, .external_lex_state = 2},
  [2165] = {.lex_state = 139},
  [2166] = {.lex_state = 102, .external_lex_state = 2},
  [2167] = {.lex_state = 102, .external_lex_state = 2},
  [2168] = {.lex_state = 102, .external_lex_state = 2},
  [2169] = {.lex_state = 102, .external_lex_state = 2},
  [2170] = {.lex_state = 102, .external_lex_state = 2},
  [2171] = {.lex_state = 102, .external_lex_state = 2},
  [2172] = {.lex_state = 102, .external_lex_state = 2},
  [2173] = {.lex_state = 102, .external_lex_state = 2},
  [2174] = {.lex_state = 102, .external_lex_state = 2},
  [2175] = {.lex_state = 102, .external_lex_state = 2},
  [2176] = {.lex_state = 102, .external_lex_state = 2},
  [2177] = {.lex_state = 102, .external_lex_state = 2},
  [2178] = {.lex_state = 137},
  [2179] = {.lex_state = 130},
  [2180] = {.lex_state = 177},
  [2181] = {.lex_state = 95},
  [2182] = {.lex_state = 177},
  [2183] = {.lex_state = 177},
  [2184] = {.lex_state = 187},
  [2185] = {.lex_state = 177},
  [2186] = {.lex_state = 179},
  [2187] = {.lex_state = 177},
  [2188] = {.lex_state = 179},
  [2189] = {.lex_state = 95},
  [2190] = {.lex_state = 177},
  [2191] = {.lex_state = 102},
  [2192] = {.lex_state = 148},
  [2193] = {.lex_state = 177},
  [2194] = {.lex_state = 102},
  [2195] = {.lex_state = 177},
  [2196] = {.lex_state = 95},
  [2197] = {.lex_state = 177},
  [2198] = {.lex_state = 177},
  [2199] = {.lex_state = 177},
  [2200] = {.lex_state = 181},
  [2201] = {.lex_state = 177},
  [2202] = {.lex_state = 95},
  [2203] = {.lex_state = 171},
  [2204] = {.lex_state = 95},
  [2205] = {.lex_state = 171},
  [2206] = {.lex_state = 177},
  [2207] = {.lex_state = 171},
  [2208] = {.lex_state = 177},
  [2209] = {.lex_state = 130},
  [2210] = {.lex_state = 177},
  [2211] = {.lex_state = 102, .external_lex_state = 2},
  [2212] = {.lex_state = 130},
  [2213] = {.lex_state = 177},
  [2214] = {.lex_state = 177},
  [2215] = {.lex_state = 177},
  [2216] = {.lex_state = 177},
  [2217] = {.lex_state = 177},
  [2218] = {.lex_state = 95},
  [2219] = {.lex_state = 102},
  [2220] = {.lex_state = 139},
  [2221] = {.lex_state = 177},
  [2222] = {.lex_state = 171},
  [2223] = {.lex_state = 171},
  [2224] = {.lex_state = 171},
  [2225] = {.lex_state = 177},
  [2226] = {.lex_state = 102},
  [2227] = {.lex_state = 130},
  [2228] = {.lex_state = 171},
  [2229] = {.lex_state = 95},
  [2230] = {.lex_state = 175},
  [2231] = {.lex_state = 177},
  [2232] = {.lex_state = 95},
  [2233] = {.lex_state = 95},
  [2234] = {.lex_state = 177},
  [2235] = {.lex_state = 177},
  [2236] = {.lex_state = 102},
  [2237] = {.lex_state = 102},
  [2238] = {.lex_state = 102},
  [2239] = {.lex_state = 102},
  [2240] = {.lex_state = 110},
  [2241] = {.lex_state = 110},
  [2242] = {.lex_state = 110},
  [2243] = {.lex_state = 134},
  [2244] = {.lex_state = 110},
  [2245] = {.lex_state = 175},
  [2246] = {.lex_state = 110},
  [2247] = {.lex_state = 110},
  [2248] = {.lex_state = 95},
  [2249] = {.lex_state = 95},
  [2250] = {.lex_state = 188},
  [2251] = {.lex_state = 110},
  [2252] = {.lex_state = 110},
  [2253] = {.lex_state = 130},
  [2254] = {.lex_state = 110},
  [2255] = {.lex_state = 110},
  [2256] = {.lex_state = 110},
  [2257] = {.lex_state = 110},
  [2258] = {.lex_state = 110},
  [2259] = {.lex_state = 171},
  [2260] = {.lex_state = 171},
  [2261] = {.lex_state = 95},
  [2262] = {.lex_state = 171},
  [2263] = {.lex_state = 95},
  [2264] = {.lex_state = 102},
  [2265] = {.lex_state = 102},
  [2266] = {.lex_state = 102},
  [2267] = {.lex_state = 95},
  [2268] = {.lex_state = 95},
  [2269] = {.lex_state = 102},
  [2270] = {.lex_state = 130},
  [2271] = {.lex_state = 110},
  [2272] = {.lex_state = 102},
  [2273] = {.lex_state = 171},
  [2274] = {.lex_state = 95},
  [2275] = {.lex_state = 171},
  [2276] = {.lex_state = 130},
  [2277] = {.lex_state = 95},
  [2278] = {.lex_state = 102},
  [2279] = {.lex_state = 102},
  [2280] = {.lex_state = 171},
  [2281] = {.lex_state = 130},
  [2282] = {.lex_state = 102},
  [2283] = {.lex_state = 171},
  [2284] = {.lex_state = 130},
  [2285] = {.lex_state = 173, .external_lex_state = 2},
  [2286] = {.lex_state = 95},
  [2287] = {.lex_state = 95},
  [2288] = {.lex_state = 95},
  [2289] = {.lex_state = 95},
  [2290] = {.lex_state = 95},
  [2291] = {.lex_state = 95},
  [2292] = {.lex_state = 95},
  [2293] = {.lex_state = 95},
  [2294] = {.lex_state = 179},
  [2295] = {.lex_state = 179},
  [2296] = {.lex_state = 102},
  [2297] = {.lex_state = 102},
  [2298] = {.lex_state = 179},
  [2299] = {.lex_state = 179},
  [2300] = {.lex_state = 175},
  [2301] = {.lex_state = 175},
  [2302] = {.lex_state = 175},
  [2303] = {.lex_state = 175},
  [2304] = {.lex_state = 175},
  [2305] = {.lex_state = 179},
  [2306] = {.lex_state = 95},
  [2307] = {.lex_state = 95},
  [2308] = {.lex_state = 95},
  [2309] = {.lex_state = 95},
  [2310] = {.lex_state = 184, .external_lex_state = 2},
  [2311] = {.lex_state = 95},
  [2312] = {.lex_state = 171},
  [2313] = {.lex_state = 130},
  [2314] = {.lex_state = 95},
  [2315] = {.lex_state = 95},
  [2316] = {.lex_state = 102, .external_lex_state = 2},
  [2317] = {.lex_state = 130},
  [2318] = {.lex_state = 134, .external_lex_state = 2},
  [2319] = {.lex_state = 95},
  [2320] = {.lex_state = 134, .external_lex_state = 2},
  [2321] = {.lex_state = 134, .external_lex_state = 2},
  [2322] = {.lex_state = 130},
  [2323] = {.lex_state = 134, .external_lex_state = 2},
  [2324] = {.lex_state = 102, .external_lex_state = 2},
  [2325] = {.lex_state = 102, .external_lex_state = 2},
  [2326] = {.lex_state = 102, .external_lex_state = 2},
  [2327] = {.lex_state = 184, .external_lex_state = 2},
  [2328] = {.lex_state = 130},
  [2329] = {.lex_state = 134, .external_lex_state = 2},
  [2330] = {.lex_state = 134, .external_lex_state = 2},
  [2331] = {.lex_state = 95},
  [2332] = {.lex_state = 102, .external_lex_state = 2},
  [2333] = {.lex_state = 102, .external_lex_state = 2},
  [2334] = {.lex_state = 102, .external_lex_state = 2},
  [2335] = {.lex_state = 171},
  [2336] = {.lex_state = 137},
  [2337] = {.lex_state = 137, .external_lex_state = 2},
  [2338] = {.lex_state = 130},
  [2339] = {.lex_state = 95},
  [2340] = {.lex_state = 134, .external_lex_state = 2},
  [2341] = {.lex_state = 95},
  [2342] = {.lex_state = 134, .external_lex_state = 2},
  [2343] = {.lex_state = 171},
  [2344] = {.lex_state = 137},
  [2345] = {.lex_state = 95},
  [2346] = {.lex_state = 95, .external_lex_state = 2},
  [2347] = {.lex_state = 137},
  [2348] = {.lex_state = 95},
  [2349] = {.lex_state = 137},
  [2350] = {.lex_state = 95},
  [2351] = {.lex_state = 95},
  [2352] = {.lex_state = 137},
  [2353] = {.lex_state = 95},
  [2354] = {.lex_state = 95},
  [2355] = {.lex_state = 95},
  [2356] = {.lex_state = 95},
  [2357] = {.lex_state = 95},
  [2358] = {.lex_state = 161, .external_lex_state = 2},
  [2359] = {.lex_state = 161, .external_lex_state = 2},
  [2360] = {.lex_state = 102},
  [2361] = {.lex_state = 102},
  [2362] = {.lex_state = 161, .external_lex_state = 2},
  [2363] = {.lex_state = 161, .external_lex_state = 2},
  [2364] = {.lex_state = 102, .external_lex_state = 2},
  [2365] = {.lex_state = 102, .external_lex_state = 2},
  [2366] = {.lex_state = 102, .external_lex_state = 2},
  [2367] = {.lex_state = 102, .external_lex_state = 2},
  [2368] = {.lex_state = 102, .external_lex_state = 2},
  [2369] = {.lex_state = 161, .external_lex_state = 2},
  [2370] = {.lex_state = 95},
  [2371] = {.lex_state = 95},
  [2372] = {.lex_state = 95},
  [2373] = {.lex_state = 95},
  [2374] = {.lex_state = 95},
  [2375] = {.lex_state = 171},
  [2376] = {.lex_state = 130},
  [2377] = {.lex_state = 95},
  [2378] = {.lex_state = 137},
  [2379] = {.lex_state = 181},
  [2380] = {.lex_state = 139},
  [2381] = {.lex_state = 139},
  [2382] = {.lex_state = 184},
  [2383] = {.lex_state = 95},
  [2384] = {.lex_state = 102},
  [2385] = {.lex_state = 95},
  [2386] = {.lex_state = 130},
  [2387] = {.lex_state = 130},
  [2388] = {.lex_state = 95},
  [2389] = {.lex_state = 95},
  [2390] = {.lex_state = 95},
  [2391] = {.lex_state = 95},
  [2392] = {.lex_state = 95},
  [2393] = {.lex_state = 102},
  [2394] = {.lex_state = 95},
  [2395] = {.lex_state = 134},
  [2396] = {.lex_state = 95},
  [2397] = {.lex_state = 95},
  [2398] = {.lex_state = 95},
  [2399] = {.lex_state = 95},
  [2400] = {.lex_state = 95},
  [2401] = {.lex_state = 95},
  [2402] = {.lex_state = 95},
  [2403] = {.lex_state = 95},
  [2404] = {.lex_state = 95},
  [2405] = {.lex_state = 95},
  [2406] = {.lex_state = 95},
  [2407] = {.lex_state = 102, .external_lex_state = 2},
  [2408] = {.lex_state = 102},
  [2409] = {.lex_state = 102},
  [2410] = {.lex_state = 139},
  [2411] = {.lex_state = 95},
  [2412] = {.lex_state = 95},
  [2413] = {.lex_state = 95},
  [2414] = {.lex_state = 95},
  [2415] = {.lex_state = 102},
  [2416] = {.lex_state = 130},
  [2417] = {.lex_state = 110, .external_lex_state = 2},
  [2418] = {.lex_state = 102},
  [2419] = {.lex_state = 102},
  [2420] = {.lex_state = 95},
  [2421] = {.lex_state = 95},
  [2422] = {.lex_state = 102},
  [2423] = {.lex_state = 102},
  [2424] = {.lex_state = 95},
  [2425] = {.lex_state = 110},
  [2426] = {.lex_state = 130},
  [2427] = {.lex_state = 102},
  [2428] = {.lex_state = 95},
  [2429] = {.lex_state = 102},
  [2430] = {.lex_state = 110},
  [2431] = {.lex_state = 102},
  [2432] = {.lex_state = 102},
  [2433] = {.lex_state = 110},
  [2434] = {.lex_state = 110},
  [2435] = {.lex_state = 137},
  [2436] = {.lex_state = 137},
  [2437] = {.lex_state = 102},
  [2438] = {.lex_state = 139},
  [2439] = {.lex_state = 171},
  [2440] = {.lex_state = 95},
  [2441] = {.lex_state = 102},
  [2442] = {.lex_state = 171},
  [2443] = {.lex_state = 171},
  [2444] = {.lex_state = 102},
  [2445] = {.lex_state = 171},
  [2446] = {.lex_state = 139},
  [2447] = {.lex_state = 180},
  [2448] = {.lex_state = 139},
  [2449] = {.lex_state = 180},
  [2450] = {.lex_state = 139},
  [2451] = {.lex_state = 139},
  [2452] = {.lex_state = 180},
  [2453] = {.lex_state = 139},
  [2454] = {.lex_state = 139},
  [2455] = {.lex_state = 180},
  [2456] = {.lex_state = 139},
  [2457] = {.lex_state = 139},
  [2458] = {.lex_state = 139},
  [2459] = {.lex_state = 171},
  [2460] = {.lex_state = 171},
  [2461] = {.lex_state = 95},
  [2462] = {.lex_state = 171},
  [2463] = {.lex_state = 139},
  [2464] = {.lex_state = 95},
  [2465] = {.lex_state = 102},
  [2466] = {.lex_state = 181},
  [2467] = {.lex_state = 181},
  [2468] = {.lex_state = 181},
  [2469] = {.lex_state = 139},
  [2470] = {.lex_state = 102},
  [2471] = {.lex_state = 130},
  [2472] = {.lex_state = 95},
  [2473] = {.lex_state = 171},
  [2474] = {.lex_state = 95},
  [2475] = {.lex_state = 102},
  [2476] = {.lex_state = 171},
  [2477] = {.lex_state = 171},
  [2478] = {.lex_state = 102},
  [2479] = {.lex_state = 171},
  [2480] = {.lex_state = 180},
  [2481] = {.lex_state = 180},
  [2482] = {.lex_state = 139},
  [2483] = {.lex_state = 180},
  [2484] = {.lex_state = 180},
  [2485] = {.lex_state = 180},
  [2486] = {.lex_state = 180},
  [2487] = {.lex_state = 139},
  [2488] = {.lex_state = 180},
  [2489] = {.lex_state = 180},
  [2490] = {.lex_state = 139},
  [2491] = {.lex_state = 180},
  [2492] = {.lex_state = 139},
  [2493] = {.lex_state = 139},
  [2494] = {.lex_state = 139},
  [2495] = {.lex_state = 137},
  [2496] = {.lex_state = 173, .external_lex_state = 2},
  [2497] = {.lex_state = 139},
  [2498] = {.lex_state = 110, .external_lex_state = 2},
  [2499] = {.lex_state = 102},
  [2500] = {.lex_state = 140},
  [2501] = {.lex_state = 148},
  [2502] = {.lex_state = 122},
  [2503] = {.lex_state = 148},
  [2504] = {.lex_state = 164},
  [2505] = {.lex_state = 171},
  [2506] = {.lex_state = 95},
  [2507] = {.lex_state = 102},
  [2508] = {.lex_state = 171},
  [2509] = {.lex_state = 171},
  [2510] = {.lex_state = 102},
  [2511] = {.lex_state = 171},
  [2512] = {.lex_state = 148},
  [2513] = {.lex_state = 110, .external_lex_state = 2},
  [2514] = {.lex_state = 148},
  [2515] = {.lex_state = 164},
  [2516] = {.lex_state = 148},
  [2517] = {.lex_state = 175},
  [2518] = {.lex_state = 95},
  [2519] = {.lex_state = 139},
  [2520] = {.lex_state = 139},
  [2521] = {.lex_state = 102, .external_lex_state = 2},
  [2522] = {.lex_state = 139},
  [2523] = {.lex_state = 102, .external_lex_state = 2},
  [2524] = {.lex_state = 134, .external_lex_state = 2},
  [2525] = {.lex_state = 171},
  [2526] = {.lex_state = 171},
  [2527] = {.lex_state = 95},
  [2528] = {.lex_state = 171},
  [2529] = {.lex_state = 134, .external_lex_state = 2},
  [2530] = {.lex_state = 95},
  [2531] = {.lex_state = 102},
  [2532] = {.lex_state = 173, .external_lex_state = 2},
  [2533] = {.lex_state = 171},
  [2534] = {.lex_state = 95},
  [2535] = {.lex_state = 102},
  [2536] = {.lex_state = 171},
  [2537] = {.lex_state = 171},
  [2538] = {.lex_state = 102},
  [2539] = {.lex_state = 171},
  [2540] = {.lex_state = 95},
  [2541] = {.lex_state = 95},
  [2542] = {.lex_state = 180},
  [2543] = {.lex_state = 139},
  [2544] = {.lex_state = 95},
  [2545] = {.lex_state = 171},
  [2546] = {.lex_state = 95},
  [2547] = {.lex_state = 102},
  [2548] = {.lex_state = 171},
  [2549] = {.lex_state = 171},
  [2550] = {.lex_state = 102},
  [2551] = {.lex_state = 171},
  [2552] = {.lex_state = 95},
  [2553] = {.lex_state = 102},
  [2554] = {.lex_state = 198},
  [2555] = {.lex_state = 95, .external_lex_state = 2},
  [2556] = {.lex_state = 102},
  [2557] = {.lex_state = 102},
  [2558] = {.lex_state = 102},
  [2559] = {.lex_state = 110, .external_lex_state = 2},
  [2560] = {.lex_state = 110, .external_lex_state = 2},
  [2561] = {.lex_state = 110, .external_lex_state = 2},
  [2562] = {.lex_state = 110, .external_lex_state = 2},
  [2563] = {.lex_state = 110, .external_lex_state = 2},
  [2564] = {.lex_state = 110, .external_lex_state = 2},
  [2565] = {.lex_state = 95},
  [2566] = {.lex_state = 95},
  [2567] = {.lex_state = 110, .external_lex_state = 2},
  [2568] = {.lex_state = 110, .external_lex_state = 2},
  [2569] = {.lex_state = 110, .external_lex_state = 2},
  [2570] = {.lex_state = 110, .external_lex_state = 2},
  [2571] = {.lex_state = 110},
  [2572] = {.lex_state = 110, .external_lex_state = 2},
  [2573] = {.lex_state = 171},
  [2574] = {.lex_state = 171},
  [2575] = {.lex_state = 95},
  [2576] = {.lex_state = 171},
  [2577] = {.lex_state = 95},
  [2578] = {.lex_state = 102},
  [2579] = {.lex_state = 102, .external_lex_state = 2},
  [2580] = {.lex_state = 110, .external_lex_state = 2},
  [2581] = {.lex_state = 102, .external_lex_state = 2},
  [2582] = {.lex_state = 95},
  [2583] = {.lex_state = 95},
  [2584] = {.lex_state = 137},
  [2585] = {.lex_state = 102, .external_lex_state = 2},
  [2586] = {.lex_state = 110, .external_lex_state = 2},
  [2587] = {.lex_state = 130},
  [2588] = {.lex_state = 110, .external_lex_state = 2},
  [2589] = {.lex_state = 137},
  [2590] = {.lex_state = 95},
  [2591] = {.lex_state = 95},
  [2592] = {.lex_state = 95},
  [2593] = {.lex_state = 95},
  [2594] = {.lex_state = 102},
  [2595] = {.lex_state = 95},
  [2596] = {.lex_state = 134},
  [2597] = {.lex_state = 95},
  [2598] = {.lex_state = 95},
  [2599] = {.lex_state = 95},
  [2600] = {.lex_state = 95},
  [2601] = {.lex_state = 95},
  [2602] = {.lex_state = 95},
  [2603] = {.lex_state = 95},
  [2604] = {.lex_state = 95},
  [2605] = {.lex_state = 95},
  [2606] = {.lex_state = 95},
  [2607] = {.lex_state = 95},
  [2608] = {.lex_state = 95},
  [2609] = {.lex_state = 95},
  [2610] = {.lex_state = 102, .external_lex_state = 2},
  [2611] = {.lex_state = 102},
  [2612] = {.lex_state = 102},
  [2613] = {.lex_state = 139},
  [2614] = {.lex_state = 95},
  [2615] = {.lex_state = 95},
  [2616] = {.lex_state = 95},
  [2617] = {.lex_state = 95},
  [2618] = {.lex_state = 102},
  [2619] = {.lex_state = 95},
  [2620] = {.lex_state = 95},
  [2621] = {.lex_state = 95, .external_lex_state = 2},
  [2622] = {.lex_state = 95},
  [2623] = {.lex_state = 95},
  [2624] = {.lex_state = 137},
  [2625] = {.lex_state = 173, .external_lex_state = 2},
  [2626] = {.lex_state = 95},
  [2627] = {.lex_state = 171},
  [2628] = {.lex_state = 95},
  [2629] = {.lex_state = 171},
  [2630] = {.lex_state = 134},
  [2631] = {.lex_state = 95},
  [2632] = {.lex_state = 102},
  [2633] = {.lex_state = 102},
  [2634] = {.lex_state = 171},
  [2635] = {.lex_state = 171},
  [2636] = {.lex_state = 134},
  [2637] = {.lex_state = 110},
  [2638] = {.lex_state = 110},
  [2639] = {.lex_state = 110},
  [2640] = {.lex_state = 110},
  [2641] = {.lex_state = 110},
  [2642] = {.lex_state = 110},
  [2643] = {.lex_state = 95},
  [2644] = {.lex_state = 95},
  [2645] = {.lex_state = 110},
  [2646] = {.lex_state = 110},
  [2647] = {.lex_state = 110},
  [2648] = {.lex_state = 110},
  [2649] = {.lex_state = 110},
  [2650] = {.lex_state = 110},
  [2651] = {.lex_state = 171},
  [2652] = {.lex_state = 171},
  [2653] = {.lex_state = 95},
  [2654] = {.lex_state = 171},
  [2655] = {.lex_state = 95},
  [2656] = {.lex_state = 102},
  [2657] = {.lex_state = 102},
  [2658] = {.lex_state = 102},
  [2659] = {.lex_state = 95},
  [2660] = {.lex_state = 95},
  [2661] = {.lex_state = 102},
  [2662] = {.lex_state = 130},
  [2663] = {.lex_state = 110, .external_lex_state = 2},
  [2664] = {.lex_state = 110},
  [2665] = {.lex_state = 130},
  [2666] = {.lex_state = 134},
  [2667] = {.lex_state = 110, .external_lex_state = 2},
  [2668] = {.lex_state = 110, .external_lex_state = 2},
  [2669] = {.lex_state = 102, .external_lex_state = 2},
  [2670] = {.lex_state = 137},
  [2671] = {.lex_state = 173, .external_lex_state = 2},
  [2672] = {.lex_state = 102, .external_lex_state = 2},
  [2673] = {.lex_state = 110, .external_lex_state = 2},
  [2674] = {.lex_state = 130},
  [2675] = {.lex_state = 102},
  [2676] = {.lex_state = 171},
  [2677] = {.lex_state = 110, .external_lex_state = 2},
  [2678] = {.lex_state = 110, .external_lex_state = 2},
  [2679] = {.lex_state = 110, .external_lex_state = 2},
  [2680] = {.lex_state = 130},
  [2681] = {.lex_state = 171},
  [2682] = {.lex_state = 110, .external_lex_state = 2},
  [2683] = {.lex_state = 110, .external_lex_state = 2},
  [2684] = {.lex_state = 183, .external_lex_state = 2},
  [2685] = {.lex_state = 95},
  [2686] = {.lex_state = 179},
  [2687] = {.lex_state = 175},
  [2688] = {.lex_state = 95},
  [2689] = {.lex_state = 102},
  [2690] = {.lex_state = 102},
  [2691] = {.lex_state = 95},
  [2692] = {.lex_state = 175},
  [2693] = {.lex_state = 175},
  [2694] = {.lex_state = 175},
  [2695] = {.lex_state = 175},
  [2696] = {.lex_state = 175},
  [2697] = {.lex_state = 179},
  [2698] = {.lex_state = 184, .external_lex_state = 2},
  [2699] = {.lex_state = 184, .external_lex_state = 2},
  [2700] = {.lex_state = 184, .external_lex_state = 2},
  [2701] = {.lex_state = 184, .external_lex_state = 2},
  [2702] = {.lex_state = 184, .external_lex_state = 2},
  [2703] = {.lex_state = 184, .external_lex_state = 2},
  [2704] = {.lex_state = 130},
  [2705] = {.lex_state = 130},
  [2706] = {.lex_state = 130},
  [2707] = {.lex_state = 95},
  [2708] = {.lex_state = 184, .external_lex_state = 2},
  [2709] = {.lex_state = 130},
  [2710] = {.lex_state = 184, .external_lex_state = 2},
  [2711] = {.lex_state = 184, .external_lex_state = 2},
  [2712] = {.lex_state = 130},
  [2713] = {.lex_state = 130},
  [2714] = {.lex_state = 184, .external_lex_state = 2},
  [2715] = {.lex_state = 95},
  [2716] = {.lex_state = 102, .external_lex_state = 2},
  [2717] = {.lex_state = 102, .external_lex_state = 2},
  [2718] = {.lex_state = 130},
  [2719] = {.lex_state = 95},
  [2720] = {.lex_state = 181},
  [2721] = {.lex_state = 180},
  [2722] = {.lex_state = 95},
  [2723] = {.lex_state = 102},
  [2724] = {.lex_state = 102},
  [2725] = {.lex_state = 102},
  [2726] = {.lex_state = 164},
  [2727] = {.lex_state = 102},
  [2728] = {.lex_state = 110, .external_lex_state = 2},
  [2729] = {.lex_state = 95},
  [2730] = {.lex_state = 95},
  [2731] = {.lex_state = 95},
  [2732] = {.lex_state = 95},
  [2733] = {.lex_state = 95},
  [2734] = {.lex_state = 95},
  [2735] = {.lex_state = 161},
  [2736] = {.lex_state = 161},
  [2737] = {.lex_state = 102},
  [2738] = {.lex_state = 102},
  [2739] = {.lex_state = 161},
  [2740] = {.lex_state = 161},
  [2741] = {.lex_state = 102},
  [2742] = {.lex_state = 102},
  [2743] = {.lex_state = 102},
  [2744] = {.lex_state = 102},
  [2745] = {.lex_state = 102},
  [2746] = {.lex_state = 161},
  [2747] = {.lex_state = 95},
  [2748] = {.lex_state = 95},
  [2749] = {.lex_state = 95},
  [2750] = {.lex_state = 95},
  [2751] = {.lex_state = 95},
  [2752] = {.lex_state = 171},
  [2753] = {.lex_state = 130},
  [2754] = {.lex_state = 95},
  [2755] = {.lex_state = 102},
  [2756] = {.lex_state = 102},
  [2757] = {.lex_state = 102},
  [2758] = {.lex_state = 102},
  [2759] = {.lex_state = 161},
  [2760] = {.lex_state = 161},
  [2761] = {.lex_state = 95},
  [2762] = {.lex_state = 171},
  [2763] = {.lex_state = 95},
  [2764] = {.lex_state = 102},
  [2765] = {.lex_state = 171},
  [2766] = {.lex_state = 171},
  [2767] = {.lex_state = 102},
  [2768] = {.lex_state = 171},
  [2769] = {.lex_state = 102},
  [2770] = {.lex_state = 191},
  [2771] = {.lex_state = 130},
  [2772] = {.lex_state = 134},
  [2773] = {.lex_state = 184, .external_lex_state = 2},
  [2774] = {.lex_state = 171},
  [2775] = {.lex_state = 95},
  [2776] = {.lex_state = 171},
  [2777] = {.lex_state = 134, .external_lex_state = 2},
  [2778] = {.lex_state = 95},
  [2779] = {.lex_state = 102},
  [2780] = {.lex_state = 102, .external_lex_state = 2},
  [2781] = {.lex_state = 137},
  [2782] = {.lex_state = 184, .external_lex_state = 2},
  [2783] = {.lex_state = 102, .external_lex_state = 2},
  [2784] = {.lex_state = 184, .external_lex_state = 2},
  [2785] = {.lex_state = 130},
  [2786] = {.lex_state = 95},
  [2787] = {.lex_state = 102},
  [2788] = {.lex_state = 171},
  [2789] = {.lex_state = 184, .external_lex_state = 2},
  [2790] = {.lex_state = 184, .external_lex_state = 2},
  [2791] = {.lex_state = 184, .external_lex_state = 2},
  [2792] = {.lex_state = 130},
  [2793] = {.lex_state = 171},
  [2794] = {.lex_state = 184, .external_lex_state = 2},
  [2795] = {.lex_state = 134, .external_lex_state = 2},
  [2796] = {.lex_state = 177},
  [2797] = {.lex_state = 171},
  [2798] = {.lex_state = 95},
  [2799] = {.lex_state = 171},
  [2800] = {.lex_state = 134},
  [2801] = {.lex_state = 95},
  [2802] = {.lex_state = 102},
  [2803] = {.lex_state = 102},
  [2804] = {.lex_state = 171},
  [2805] = {.lex_state = 171},
  [2806] = {.lex_state = 134},
  [2807] = {.lex_state = 171},
  [2808] = {.lex_state = 95},
  [2809] = {.lex_state = 102},
  [2810] = {.lex_state = 171},
  [2811] = {.lex_state = 185},
  [2812] = {.lex_state = 171},
  [2813] = {.lex_state = 102},
  [2814] = {.lex_state = 171},
  [2815] = {.lex_state = 95},
  [2816] = {.lex_state = 102},
  [2817] = {.lex_state = 171},
  [2818] = {.lex_state = 171},
  [2819] = {.lex_state = 102},
  [2820] = {.lex_state = 171},
  [2821] = {.lex_state = 95},
  [2822] = {.lex_state = 95},
  [2823] = {.lex_state = 137},
  [2824] = {.lex_state = 185},
  [2825] = {.lex_state = 102, .external_lex_state = 2},
  [2826] = {.lex_state = 95},
  [2827] = {.lex_state = 102, .external_lex_state = 2},
  [2828] = {.lex_state = 130},
  [2829] = {.lex_state = 184, .external_lex_state = 2},
  [2830] = {.lex_state = 95},
  [2831] = {.lex_state = 184, .external_lex_state = 2},
  [2832] = {.lex_state = 184, .external_lex_state = 2},
  [2833] = {.lex_state = 130},
  [2834] = {.lex_state = 184, .external_lex_state = 2},
  [2835] = {.lex_state = 102, .external_lex_state = 2},
  [2836] = {.lex_state = 102, .external_lex_state = 2},
  [2837] = {.lex_state = 102, .external_lex_state = 2},
  [2838] = {.lex_state = 102, .external_lex_state = 2},
  [2839] = {.lex_state = 130},
  [2840] = {.lex_state = 110, .external_lex_state = 2},
  [2841] = {.lex_state = 95},
  [2842] = {.lex_state = 102, .external_lex_state = 2},
  [2843] = {.lex_state = 95},
  [2844] = {.lex_state = 102},
  [2845] = {.lex_state = 95},
  [2846] = {.lex_state = 102, .external_lex_state = 2},
  [2847] = {.lex_state = 95, .external_lex_state = 2},
  [2848] = {.lex_state = 95},
  [2849] = {.lex_state = 95},
  [2850] = {.lex_state = 102, .external_lex_state = 2},
  [2851] = {.lex_state = 95},
  [2852] = {.lex_state = 134},
  [2853] = {.lex_state = 102},
  [2854] = {.lex_state = 95},
  [2855] = {.lex_state = 95},
  [2856] = {.lex_state = 102, .external_lex_state = 2},
  [2857] = {.lex_state = 95},
  [2858] = {.lex_state = 137, .external_lex_state = 2},
  [2859] = {.lex_state = 171},
  [2860] = {.lex_state = 171},
  [2861] = {.lex_state = 95},
  [2862] = {.lex_state = 171},
  [2863] = {.lex_state = 137, .external_lex_state = 2},
  [2864] = {.lex_state = 95},
  [2865] = {.lex_state = 102},
  [2866] = {.lex_state = 102, .external_lex_state = 2},
  [2867] = {.lex_state = 102, .external_lex_state = 2},
  [2868] = {.lex_state = 130},
  [2869] = {.lex_state = 171},
  [2870] = {.lex_state = 95},
  [2871] = {.lex_state = 171},
  [2872] = {.lex_state = 130},
  [2873] = {.lex_state = 95},
  [2874] = {.lex_state = 102},
  [2875] = {.lex_state = 102},
  [2876] = {.lex_state = 171},
  [2877] = {.lex_state = 130},
  [2878] = {.lex_state = 185},
  [2879] = {.lex_state = 130},
  [2880] = {.lex_state = 171},
  [2881] = {.lex_state = 130},
  [2882] = {.lex_state = 171},
  [2883] = {.lex_state = 134},
  [2884] = {.lex_state = 171},
  [2885] = {.lex_state = 95},
  [2886] = {.lex_state = 171},
  [2887] = {.lex_state = 139},
  [2888] = {.lex_state = 95},
  [2889] = {.lex_state = 102},
  [2890] = {.lex_state = 102},
  [2891] = {.lex_state = 171},
  [2892] = {.lex_state = 171},
  [2893] = {.lex_state = 139},
  [2894] = {.lex_state = 195},
  [2895] = {.lex_state = 171},
  [2896] = {.lex_state = 185},
  [2897] = {.lex_state = 134},
  [2898] = {.lex_state = 181},
  [2899] = {.lex_state = 181},
  [2900] = {.lex_state = 95},
  [2901] = {.lex_state = 171},
  [2902] = {.lex_state = 95},
  [2903] = {.lex_state = 102},
  [2904] = {.lex_state = 171},
  [2905] = {.lex_state = 171},
  [2906] = {.lex_state = 102},
  [2907] = {.lex_state = 171},
  [2908] = {.lex_state = 180},
  [2909] = {.lex_state = 179},
  [2910] = {.lex_state = 179},
  [2911] = {.lex_state = 179},
  [2912] = {.lex_state = 179},
  [2913] = {.lex_state = 179},
  [2914] = {.lex_state = 179},
  [2915] = {.lex_state = 95},
  [2916] = {.lex_state = 95},
  [2917] = {.lex_state = 179},
  [2918] = {.lex_state = 179},
  [2919] = {.lex_state = 179},
  [2920] = {.lex_state = 179},
  [2921] = {.lex_state = 179},
  [2922] = {.lex_state = 110},
  [2923] = {.lex_state = 179},
  [2924] = {.lex_state = 171},
  [2925] = {.lex_state = 171},
  [2926] = {.lex_state = 95},
  [2927] = {.lex_state = 171},
  [2928] = {.lex_state = 95},
  [2929] = {.lex_state = 102},
  [2930] = {.lex_state = 175},
  [2931] = {.lex_state = 175},
  [2932] = {.lex_state = 95},
  [2933] = {.lex_state = 95},
  [2934] = {.lex_state = 175},
  [2935] = {.lex_state = 130},
  [2936] = {.lex_state = 179},
  [2937] = {.lex_state = 130},
  [2938] = {.lex_state = 137},
  [2939] = {.lex_state = 102},
  [2940] = {.lex_state = 102},
  [2941] = {.lex_state = 102},
  [2942] = {.lex_state = 95},
  [2943] = {.lex_state = 95},
  [2944] = {.lex_state = 95},
  [2945] = {.lex_state = 95},
  [2946] = {.lex_state = 95},
  [2947] = {.lex_state = 95},
  [2948] = {.lex_state = 95},
  [2949] = {.lex_state = 102, .external_lex_state = 2},
  [2950] = {.lex_state = 102},
  [2951] = {.lex_state = 102},
  [2952] = {.lex_state = 139},
  [2953] = {.lex_state = 95},
  [2954] = {.lex_state = 95},
  [2955] = {.lex_state = 95},
  [2956] = {.lex_state = 95},
  [2957] = {.lex_state = 102},
  [2958] = {.lex_state = 137},
  [2959] = {.lex_state = 137},
  [2960] = {.lex_state = 171},
  [2961] = {.lex_state = 95},
  [2962] = {.lex_state = 171},
  [2963] = {.lex_state = 134, .external_lex_state = 2},
  [2964] = {.lex_state = 95},
  [2965] = {.lex_state = 102},
  [2966] = {.lex_state = 102},
  [2967] = {.lex_state = 171},
  [2968] = {.lex_state = 171},
  [2969] = {.lex_state = 134, .external_lex_state = 2},
  [2970] = {.lex_state = 137},
  [2971] = {.lex_state = 139},
  [2972] = {.lex_state = 102},
  [2973] = {.lex_state = 95},
  [2974] = {.lex_state = 95},
  [2975] = {.lex_state = 95},
  [2976] = {.lex_state = 95},
  [2977] = {.lex_state = 95},
  [2978] = {.lex_state = 181},
  [2979] = {.lex_state = 181},
  [2980] = {.lex_state = 181},
  [2981] = {.lex_state = 95},
  [2982] = {.lex_state = 95},
  [2983] = {.lex_state = 95},
  [2984] = {.lex_state = 95},
  [2985] = {.lex_state = 95},
  [2986] = {.lex_state = 95},
  [2987] = {.lex_state = 181, .external_lex_state = 2},
  [2988] = {.lex_state = 181, .external_lex_state = 2},
  [2989] = {.lex_state = 102},
  [2990] = {.lex_state = 102},
  [2991] = {.lex_state = 181, .external_lex_state = 2},
  [2992] = {.lex_state = 181, .external_lex_state = 2},
  [2993] = {.lex_state = 180, .external_lex_state = 2},
  [2994] = {.lex_state = 180, .external_lex_state = 2},
  [2995] = {.lex_state = 180, .external_lex_state = 2},
  [2996] = {.lex_state = 180, .external_lex_state = 2},
  [2997] = {.lex_state = 180, .external_lex_state = 2},
  [2998] = {.lex_state = 181, .external_lex_state = 2},
  [2999] = {.lex_state = 95},
  [3000] = {.lex_state = 95},
  [3001] = {.lex_state = 95},
  [3002] = {.lex_state = 95},
  [3003] = {.lex_state = 95},
  [3004] = {.lex_state = 171},
  [3005] = {.lex_state = 130},
  [3006] = {.lex_state = 95},
  [3007] = {.lex_state = 95},
  [3008] = {.lex_state = 95},
  [3009] = {.lex_state = 95},
  [3010] = {.lex_state = 95},
  [3011] = {.lex_state = 95},
  [3012] = {.lex_state = 95},
  [3013] = {.lex_state = 95},
  [3014] = {.lex_state = 181},
  [3015] = {.lex_state = 181},
  [3016] = {.lex_state = 102},
  [3017] = {.lex_state = 102},
  [3018] = {.lex_state = 181},
  [3019] = {.lex_state = 181},
  [3020] = {.lex_state = 180},
  [3021] = {.lex_state = 180},
  [3022] = {.lex_state = 180},
  [3023] = {.lex_state = 180},
  [3024] = {.lex_state = 180},
  [3025] = {.lex_state = 181},
  [3026] = {.lex_state = 95},
  [3027] = {.lex_state = 95},
  [3028] = {.lex_state = 95},
  [3029] = {.lex_state = 95},
  [3030] = {.lex_state = 95},
  [3031] = {.lex_state = 171},
  [3032] = {.lex_state = 130},
  [3033] = {.lex_state = 95},
  [3034] = {.lex_state = 95},
  [3035] = {.lex_state = 181},
  [3036] = {.lex_state = 139},
  [3037] = {.lex_state = 181},
  [3038] = {.lex_state = 139},
  [3039] = {.lex_state = 181},
  [3040] = {.lex_state = 139},
  [3041] = {.lex_state = 137},
  [3042] = {.lex_state = 95},
  [3043] = {.lex_state = 95},
  [3044] = {.lex_state = 95},
  [3045] = {.lex_state = 95},
  [3046] = {.lex_state = 95},
  [3047] = {.lex_state = 177},
  [3048] = {.lex_state = 177},
  [3049] = {.lex_state = 177},
  [3050] = {.lex_state = 177},
  [3051] = {.lex_state = 102},
  [3052] = {.lex_state = 177},
  [3053] = {.lex_state = 177},
  [3054] = {.lex_state = 179},
  [3055] = {.lex_state = 130},
  [3056] = {.lex_state = 177},
  [3057] = {.lex_state = 179},
  [3058] = {.lex_state = 102, .external_lex_state = 2},
  [3059] = {.lex_state = 137},
  [3060] = {.lex_state = 177},
  [3061] = {.lex_state = 102, .external_lex_state = 2},
  [3062] = {.lex_state = 177},
  [3063] = {.lex_state = 130},
  [3064] = {.lex_state = 102},
  [3065] = {.lex_state = 171},
  [3066] = {.lex_state = 177},
  [3067] = {.lex_state = 177},
  [3068] = {.lex_state = 177},
  [3069] = {.lex_state = 130},
  [3070] = {.lex_state = 171},
  [3071] = {.lex_state = 177},
  [3072] = {.lex_state = 179},
  [3073] = {.lex_state = 187},
  [3074] = {.lex_state = 95},
  [3075] = {.lex_state = 177},
  [3076] = {.lex_state = 95},
  [3077] = {.lex_state = 177},
  [3078] = {.lex_state = 177},
  [3079] = {.lex_state = 186},
  [3080] = {.lex_state = 102},
  [3081] = {.lex_state = 110},
  [3082] = {.lex_state = 110},
  [3083] = {.lex_state = 95},
  [3084] = {.lex_state = 171},
  [3085] = {.lex_state = 95},
  [3086] = {.lex_state = 102},
  [3087] = {.lex_state = 171},
  [3088] = {.lex_state = 171},
  [3089] = {.lex_state = 102},
  [3090] = {.lex_state = 171},
  [3091] = {.lex_state = 102},
  [3092] = {.lex_state = 95},
  [3093] = {.lex_state = 102},
  [3094] = {.lex_state = 171},
  [3095] = {.lex_state = 171},
  [3096] = {.lex_state = 102},
  [3097] = {.lex_state = 171},
  [3098] = {.lex_state = 171},
  [3099] = {.lex_state = 130},
  [3100] = {.lex_state = 130},
  [3101] = {.lex_state = 179},
  [3102] = {.lex_state = 179},
  [3103] = {.lex_state = 179},
  [3104] = {.lex_state = 179},
  [3105] = {.lex_state = 130},
  [3106] = {.lex_state = 179},
  [3107] = {.lex_state = 179},
  [3108] = {.lex_state = 130},
  [3109] = {.lex_state = 95},
  [3110] = {.lex_state = 95},
  [3111] = {.lex_state = 179},
  [3112] = {.lex_state = 179},
  [3113] = {.lex_state = 179},
  [3114] = {.lex_state = 179},
  [3115] = {.lex_state = 110},
  [3116] = {.lex_state = 179},
  [3117] = {.lex_state = 171},
  [3118] = {.lex_state = 171},
  [3119] = {.lex_state = 95},
  [3120] = {.lex_state = 171},
  [3121] = {.lex_state = 95},
  [3122] = {.lex_state = 102},
  [3123] = {.lex_state = 175},
  [3124] = {.lex_state = 175},
  [3125] = {.lex_state = 95},
  [3126] = {.lex_state = 95},
  [3127] = {.lex_state = 175},
  [3128] = {.lex_state = 130},
  [3129] = {.lex_state = 179},
  [3130] = {.lex_state = 102, .external_lex_state = 2},
  [3131] = {.lex_state = 137, .external_lex_state = 2},
  [3132] = {.lex_state = 95},
  [3133] = {.lex_state = 130},
  [3134] = {.lex_state = 130},
  [3135] = {.lex_state = 95},
  [3136] = {.lex_state = 134, .external_lex_state = 2},
  [3137] = {.lex_state = 102, .external_lex_state = 2},
  [3138] = {.lex_state = 102, .external_lex_state = 2},
  [3139] = {.lex_state = 102, .external_lex_state = 2},
  [3140] = {.lex_state = 95},
  [3141] = {.lex_state = 102, .external_lex_state = 2},
  [3142] = {.lex_state = 102, .external_lex_state = 2},
  [3143] = {.lex_state = 171},
  [3144] = {.lex_state = 134, .external_lex_state = 2},
  [3145] = {.lex_state = 171},
  [3146] = {.lex_state = 171},
  [3147] = {.lex_state = 95},
  [3148] = {.lex_state = 171},
  [3149] = {.lex_state = 134, .external_lex_state = 2},
  [3150] = {.lex_state = 95},
  [3151] = {.lex_state = 102},
  [3152] = {.lex_state = 137, .external_lex_state = 2},
  [3153] = {.lex_state = 137},
  [3154] = {.lex_state = 134, .external_lex_state = 2},
  [3155] = {.lex_state = 134, .external_lex_state = 2},
  [3156] = {.lex_state = 134, .external_lex_state = 2},
  [3157] = {.lex_state = 134, .external_lex_state = 2},
  [3158] = {.lex_state = 130},
  [3159] = {.lex_state = 134, .external_lex_state = 2},
  [3160] = {.lex_state = 134},
  [3161] = {.lex_state = 171},
  [3162] = {.lex_state = 171},
  [3163] = {.lex_state = 95},
  [3164] = {.lex_state = 171},
  [3165] = {.lex_state = 134},
  [3166] = {.lex_state = 137},
  [3167] = {.lex_state = 95},
  [3168] = {.lex_state = 102},
  [3169] = {.lex_state = 137},
  [3170] = {.lex_state = 137},
  [3171] = {.lex_state = 137},
  [3172] = {.lex_state = 137},
  [3173] = {.lex_state = 95},
  [3174] = {.lex_state = 161, .external_lex_state = 2},
  [3175] = {.lex_state = 161, .external_lex_state = 2},
  [3176] = {.lex_state = 161, .external_lex_state = 2},
  [3177] = {.lex_state = 161, .external_lex_state = 2},
  [3178] = {.lex_state = 161, .external_lex_state = 2},
  [3179] = {.lex_state = 95},
  [3180] = {.lex_state = 95},
  [3181] = {.lex_state = 161, .external_lex_state = 2},
  [3182] = {.lex_state = 161, .external_lex_state = 2},
  [3183] = {.lex_state = 161, .external_lex_state = 2},
  [3184] = {.lex_state = 161, .external_lex_state = 2},
  [3185] = {.lex_state = 110},
  [3186] = {.lex_state = 161, .external_lex_state = 2},
  [3187] = {.lex_state = 171},
  [3188] = {.lex_state = 171},
  [3189] = {.lex_state = 95},
  [3190] = {.lex_state = 171},
  [3191] = {.lex_state = 95},
  [3192] = {.lex_state = 102},
  [3193] = {.lex_state = 102, .external_lex_state = 2},
  [3194] = {.lex_state = 102, .external_lex_state = 2},
  [3195] = {.lex_state = 95},
  [3196] = {.lex_state = 95},
  [3197] = {.lex_state = 102, .external_lex_state = 2},
  [3198] = {.lex_state = 130},
  [3199] = {.lex_state = 161, .external_lex_state = 2},
  [3200] = {.lex_state = 137},
  [3201] = {.lex_state = 139},
  [3202] = {.lex_state = 102},
  [3203] = {.lex_state = 95},
  [3204] = {.lex_state = 95},
  [3205] = {.lex_state = 130},
  [3206] = {.lex_state = 137},
  [3207] = {.lex_state = 95},
  [3208] = {.lex_state = 102, .external_lex_state = 2},
  [3209] = {.lex_state = 95},
  [3210] = {.lex_state = 95},
  [3211] = {.lex_state = 95},
  [3212] = {.lex_state = 110, .external_lex_state = 2},
  [3213] = {.lex_state = 110, .external_lex_state = 2},
  [3214] = {.lex_state = 95},
  [3215] = {.lex_state = 95},
  [3216] = {.lex_state = 95},
  [3217] = {.lex_state = 95},
  [3218] = {.lex_state = 95},
  [3219] = {.lex_state = 95},
  [3220] = {.lex_state = 95},
  [3221] = {.lex_state = 181, .external_lex_state = 2},
  [3222] = {.lex_state = 139},
  [3223] = {.lex_state = 181},
  [3224] = {.lex_state = 95},
  [3225] = {.lex_state = 95},
  [3226] = {.lex_state = 95},
  [3227] = {.lex_state = 95},
  [3228] = {.lex_state = 181},
  [3229] = {.lex_state = 139},
  [3230] = {.lex_state = 181},
  [3231] = {.lex_state = 181, .external_lex_state = 2},
  [3232] = {.lex_state = 139},
  [3233] = {.lex_state = 181},
  [3234] = {.lex_state = 181, .external_lex_state = 2},
  [3235] = {.lex_state = 139},
  [3236] = {.lex_state = 171},
  [3237] = {.lex_state = 130},
  [3238] = {.lex_state = 95},
  [3239] = {.lex_state = 95},
  [3240] = {.lex_state = 95},
  [3241] = {.lex_state = 95},
  [3242] = {.lex_state = 95},
  [3243] = {.lex_state = 95},
  [3244] = {.lex_state = 95},
  [3245] = {.lex_state = 110},
  [3246] = {.lex_state = 110},
  [3247] = {.lex_state = 102},
  [3248] = {.lex_state = 102},
  [3249] = {.lex_state = 110},
  [3250] = {.lex_state = 110},
  [3251] = {.lex_state = 102},
  [3252] = {.lex_state = 102},
  [3253] = {.lex_state = 102},
  [3254] = {.lex_state = 102},
  [3255] = {.lex_state = 102},
  [3256] = {.lex_state = 110},
  [3257] = {.lex_state = 95},
  [3258] = {.lex_state = 95},
  [3259] = {.lex_state = 95},
  [3260] = {.lex_state = 95},
  [3261] = {.lex_state = 95},
  [3262] = {.lex_state = 95},
  [3263] = {.lex_state = 171},
  [3264] = {.lex_state = 130},
  [3265] = {.lex_state = 137},
  [3266] = {.lex_state = 95},
  [3267] = {.lex_state = 102, .external_lex_state = 2},
  [3268] = {.lex_state = 95},
  [3269] = {.lex_state = 95},
  [3270] = {.lex_state = 102, .external_lex_state = 2},
  [3271] = {.lex_state = 95},
  [3272] = {.lex_state = 102, .external_lex_state = 2},
  [3273] = {.lex_state = 95},
  [3274] = {.lex_state = 137},
  [3275] = {.lex_state = 95},
  [3276] = {.lex_state = 171},
  [3277] = {.lex_state = 95},
  [3278] = {.lex_state = 171},
  [3279] = {.lex_state = 194},
  [3280] = {.lex_state = 95},
  [3281] = {.lex_state = 102},
  [3282] = {.lex_state = 102},
  [3283] = {.lex_state = 171},
  [3284] = {.lex_state = 171},
  [3285] = {.lex_state = 194},
  [3286] = {.lex_state = 139},
  [3287] = {.lex_state = 139},
  [3288] = {.lex_state = 139},
  [3289] = {.lex_state = 139},
  [3290] = {.lex_state = 171},
  [3291] = {.lex_state = 95},
  [3292] = {.lex_state = 102},
  [3293] = {.lex_state = 171},
  [3294] = {.lex_state = 171},
  [3295] = {.lex_state = 102},
  [3296] = {.lex_state = 171},
  [3297] = {.lex_state = 181},
  [3298] = {.lex_state = 181},
  [3299] = {.lex_state = 102},
  [3300] = {.lex_state = 171},
  [3301] = {.lex_state = 171},
  [3302] = {.lex_state = 181},
  [3303] = {.lex_state = 139},
  [3304] = {.lex_state = 180},
  [3305] = {.lex_state = 139},
  [3306] = {.lex_state = 180},
  [3307] = {.lex_state = 139},
  [3308] = {.lex_state = 139},
  [3309] = {.lex_state = 180},
  [3310] = {.lex_state = 139},
  [3311] = {.lex_state = 139},
  [3312] = {.lex_state = 180},
  [3313] = {.lex_state = 139},
  [3314] = {.lex_state = 102},
  [3315] = {.lex_state = 95},
  [3316] = {.lex_state = 110, .external_lex_state = 2},
  [3317] = {.lex_state = 148},
  [3318] = {.lex_state = 140},
  [3319] = {.lex_state = 164},
  [3320] = {.lex_state = 148},
  [3321] = {.lex_state = 148},
  [3322] = {.lex_state = 148},
  [3323] = {.lex_state = 148},
  [3324] = {.lex_state = 122},
  [3325] = {.lex_state = 148},
  [3326] = {.lex_state = 148},
  [3327] = {.lex_state = 164},
  [3328] = {.lex_state = 171},
  [3329] = {.lex_state = 95},
  [3330] = {.lex_state = 171},
  [3331] = {.lex_state = 134},
  [3332] = {.lex_state = 95},
  [3333] = {.lex_state = 102},
  [3334] = {.lex_state = 102},
  [3335] = {.lex_state = 171},
  [3336] = {.lex_state = 171},
  [3337] = {.lex_state = 134},
  [3338] = {.lex_state = 139},
  [3339] = {.lex_state = 102, .external_lex_state = 2},
  [3340] = {.lex_state = 139},
  [3341] = {.lex_state = 171},
  [3342] = {.lex_state = 95},
  [3343] = {.lex_state = 102},
  [3344] = {.lex_state = 171},
  [3345] = {.lex_state = 171},
  [3346] = {.lex_state = 102},
  [3347] = {.lex_state = 171},
  [3348] = {.lex_state = 171},
  [3349] = {.lex_state = 95},
  [3350] = {.lex_state = 171},
  [3351] = {.lex_state = 130},
  [3352] = {.lex_state = 95},
  [3353] = {.lex_state = 102},
  [3354] = {.lex_state = 102},
  [3355] = {.lex_state = 171},
  [3356] = {.lex_state = 171},
  [3357] = {.lex_state = 130},
  [3358] = {.lex_state = 181},
  [3359] = {.lex_state = 110},
  [3360] = {.lex_state = 102},
  [3361] = {.lex_state = 171},
  [3362] = {.lex_state = 171},
  [3363] = {.lex_state = 110},
  [3364] = {.lex_state = 199},
  [3365] = {.lex_state = 95},
  [3366] = {.lex_state = 95, .external_lex_state = 2},
  [3367] = {.lex_state = 95},
  [3368] = {.lex_state = 110, .external_lex_state = 2},
  [3369] = {.lex_state = 110, .external_lex_state = 2},
  [3370] = {.lex_state = 95},
  [3371] = {.lex_state = 171},
  [3372] = {.lex_state = 95},
  [3373] = {.lex_state = 102},
  [3374] = {.lex_state = 171},
  [3375] = {.lex_state = 171},
  [3376] = {.lex_state = 102},
  [3377] = {.lex_state = 171},
  [3378] = {.lex_state = 95},
  [3379] = {.lex_state = 102, .external_lex_state = 2},
  [3380] = {.lex_state = 110, .external_lex_state = 2},
  [3381] = {.lex_state = 95},
  [3382] = {.lex_state = 95},
  [3383] = {.lex_state = 102, .external_lex_state = 2},
  [3384] = {.lex_state = 95},
  [3385] = {.lex_state = 95},
  [3386] = {.lex_state = 95},
  [3387] = {.lex_state = 110, .external_lex_state = 2},
  [3388] = {.lex_state = 110, .external_lex_state = 2},
  [3389] = {.lex_state = 95},
  [3390] = {.lex_state = 95},
  [3391] = {.lex_state = 95},
  [3392] = {.lex_state = 95},
  [3393] = {.lex_state = 95},
  [3394] = {.lex_state = 95},
  [3395] = {.lex_state = 95},
  [3396] = {.lex_state = 95},
  [3397] = {.lex_state = 181, .external_lex_state = 2},
  [3398] = {.lex_state = 139},
  [3399] = {.lex_state = 181},
  [3400] = {.lex_state = 95},
  [3401] = {.lex_state = 95},
  [3402] = {.lex_state = 95},
  [3403] = {.lex_state = 95},
  [3404] = {.lex_state = 181},
  [3405] = {.lex_state = 139},
  [3406] = {.lex_state = 181},
  [3407] = {.lex_state = 181, .external_lex_state = 2},
  [3408] = {.lex_state = 139},
  [3409] = {.lex_state = 181},
  [3410] = {.lex_state = 181, .external_lex_state = 2},
  [3411] = {.lex_state = 139},
  [3412] = {.lex_state = 171},
  [3413] = {.lex_state = 95, .external_lex_state = 2},
  [3414] = {.lex_state = 95},
  [3415] = {.lex_state = 173, .external_lex_state = 2},
  [3416] = {.lex_state = 95},
  [3417] = {.lex_state = 102},
  [3418] = {.lex_state = 171},
  [3419] = {.lex_state = 171},
  [3420] = {.lex_state = 102},
  [3421] = {.lex_state = 171},
  [3422] = {.lex_state = 171},
  [3423] = {.lex_state = 134},
  [3424] = {.lex_state = 134},
  [3425] = {.lex_state = 110},
  [3426] = {.lex_state = 110},
  [3427] = {.lex_state = 95},
  [3428] = {.lex_state = 171},
  [3429] = {.lex_state = 95},
  [3430] = {.lex_state = 102},
  [3431] = {.lex_state = 171},
  [3432] = {.lex_state = 171},
  [3433] = {.lex_state = 102},
  [3434] = {.lex_state = 171},
  [3435] = {.lex_state = 102},
  [3436] = {.lex_state = 110, .external_lex_state = 2},
  [3437] = {.lex_state = 110, .external_lex_state = 2},
  [3438] = {.lex_state = 186},
  [3439] = {.lex_state = 102},
  [3440] = {.lex_state = 137},
  [3441] = {.lex_state = 173, .external_lex_state = 2},
  [3442] = {.lex_state = 102, .external_lex_state = 2},
  [3443] = {.lex_state = 110, .external_lex_state = 2},
  [3444] = {.lex_state = 171},
  [3445] = {.lex_state = 110, .external_lex_state = 2},
  [3446] = {.lex_state = 110, .external_lex_state = 2},
  [3447] = {.lex_state = 110, .external_lex_state = 2},
  [3448] = {.lex_state = 175},
  [3449] = {.lex_state = 95},
  [3450] = {.lex_state = 102},
  [3451] = {.lex_state = 183, .external_lex_state = 2},
  [3452] = {.lex_state = 184, .external_lex_state = 2},
  [3453] = {.lex_state = 95},
  [3454] = {.lex_state = 102, .external_lex_state = 2},
  [3455] = {.lex_state = 130},
  [3456] = {.lex_state = 184, .external_lex_state = 2},
  [3457] = {.lex_state = 95},
  [3458] = {.lex_state = 184, .external_lex_state = 2},
  [3459] = {.lex_state = 184, .external_lex_state = 2},
  [3460] = {.lex_state = 130},
  [3461] = {.lex_state = 184, .external_lex_state = 2},
  [3462] = {.lex_state = 102, .external_lex_state = 2},
  [3463] = {.lex_state = 161, .external_lex_state = 2},
  [3464] = {.lex_state = 130},
  [3465] = {.lex_state = 102, .external_lex_state = 2},
  [3466] = {.lex_state = 95},
  [3467] = {.lex_state = 95},
  [3468] = {.lex_state = 137},
  [3469] = {.lex_state = 102, .external_lex_state = 2},
  [3470] = {.lex_state = 139},
  [3471] = {.lex_state = 161, .external_lex_state = 2},
  [3472] = {.lex_state = 130},
  [3473] = {.lex_state = 95},
  [3474] = {.lex_state = 102},
  [3475] = {.lex_state = 102, .external_lex_state = 2},
  [3476] = {.lex_state = 171},
  [3477] = {.lex_state = 130},
  [3478] = {.lex_state = 180},
  [3479] = {.lex_state = 95},
  [3480] = {.lex_state = 102},
  [3481] = {.lex_state = 164},
  [3482] = {.lex_state = 161},
  [3483] = {.lex_state = 161},
  [3484] = {.lex_state = 161},
  [3485] = {.lex_state = 161},
  [3486] = {.lex_state = 161},
  [3487] = {.lex_state = 161},
  [3488] = {.lex_state = 95},
  [3489] = {.lex_state = 95},
  [3490] = {.lex_state = 161},
  [3491] = {.lex_state = 161},
  [3492] = {.lex_state = 161},
  [3493] = {.lex_state = 161},
  [3494] = {.lex_state = 110},
  [3495] = {.lex_state = 161},
  [3496] = {.lex_state = 171},
  [3497] = {.lex_state = 171},
  [3498] = {.lex_state = 95},
  [3499] = {.lex_state = 171},
  [3500] = {.lex_state = 95},
  [3501] = {.lex_state = 102},
  [3502] = {.lex_state = 102},
  [3503] = {.lex_state = 102},
  [3504] = {.lex_state = 95},
  [3505] = {.lex_state = 95},
  [3506] = {.lex_state = 102},
  [3507] = {.lex_state = 130},
  [3508] = {.lex_state = 161},
  [3509] = {.lex_state = 164},
  [3510] = {.lex_state = 161},
  [3511] = {.lex_state = 161},
  [3512] = {.lex_state = 102},
  [3513] = {.lex_state = 171},
  [3514] = {.lex_state = 171},
  [3515] = {.lex_state = 161},
  [3516] = {.lex_state = 184, .external_lex_state = 2},
  [3517] = {.lex_state = 184, .external_lex_state = 2},
  [3518] = {.lex_state = 186},
  [3519] = {.lex_state = 102},
  [3520] = {.lex_state = 95},
  [3521] = {.lex_state = 102},
  [3522] = {.lex_state = 171},
  [3523] = {.lex_state = 171},
  [3524] = {.lex_state = 102},
  [3525] = {.lex_state = 171},
  [3526] = {.lex_state = 137},
  [3527] = {.lex_state = 184, .external_lex_state = 2},
  [3528] = {.lex_state = 102, .external_lex_state = 2},
  [3529] = {.lex_state = 184, .external_lex_state = 2},
  [3530] = {.lex_state = 184, .external_lex_state = 2},
  [3531] = {.lex_state = 171},
  [3532] = {.lex_state = 134, .external_lex_state = 2},
  [3533] = {.lex_state = 184, .external_lex_state = 2},
  [3534] = {.lex_state = 134, .external_lex_state = 2},
  [3535] = {.lex_state = 95},
  [3536] = {.lex_state = 102},
  [3537] = {.lex_state = 171},
  [3538] = {.lex_state = 171},
  [3539] = {.lex_state = 102},
  [3540] = {.lex_state = 171},
  [3541] = {.lex_state = 171},
  [3542] = {.lex_state = 134},
  [3543] = {.lex_state = 134},
  [3544] = {.lex_state = 171},
  [3545] = {.lex_state = 95},
  [3546] = {.lex_state = 171},
  [3547] = {.lex_state = 130},
  [3548] = {.lex_state = 95},
  [3549] = {.lex_state = 102},
  [3550] = {.lex_state = 102},
  [3551] = {.lex_state = 171},
  [3552] = {.lex_state = 171},
  [3553] = {.lex_state = 130},
  [3554] = {.lex_state = 102},
  [3555] = {.lex_state = 171},
  [3556] = {.lex_state = 171},
  [3557] = {.lex_state = 134},
  [3558] = {.lex_state = 130},
  [3559] = {.lex_state = 130},
  [3560] = {.lex_state = 185},
  [3561] = {.lex_state = 137},
  [3562] = {.lex_state = 102, .external_lex_state = 2},
  [3563] = {.lex_state = 95},
  [3564] = {.lex_state = 130},
  [3565] = {.lex_state = 130},
  [3566] = {.lex_state = 95},
  [3567] = {.lex_state = 184, .external_lex_state = 2},
  [3568] = {.lex_state = 102, .external_lex_state = 2},
  [3569] = {.lex_state = 102, .external_lex_state = 2},
  [3570] = {.lex_state = 102, .external_lex_state = 2},
  [3571] = {.lex_state = 102, .external_lex_state = 2},
  [3572] = {.lex_state = 130},
  [3573] = {.lex_state = 102, .external_lex_state = 2},
  [3574] = {.lex_state = 130},
  [3575] = {.lex_state = 102, .external_lex_state = 2},
  [3576] = {.lex_state = 102},
  [3577] = {.lex_state = 102, .external_lex_state = 2},
  [3578] = {.lex_state = 95, .external_lex_state = 2},
  [3579] = {.lex_state = 95},
  [3580] = {.lex_state = 102, .external_lex_state = 2},
  [3581] = {.lex_state = 95, .external_lex_state = 2},
  [3582] = {.lex_state = 95},
  [3583] = {.lex_state = 102, .external_lex_state = 2},
  [3584] = {.lex_state = 102, .external_lex_state = 2},
  [3585] = {.lex_state = 95},
  [3586] = {.lex_state = 171},
  [3587] = {.lex_state = 102},
  [3588] = {.lex_state = 95},
  [3589] = {.lex_state = 95},
  [3590] = {.lex_state = 110, .external_lex_state = 2},
  [3591] = {.lex_state = 171},
  [3592] = {.lex_state = 95},
  [3593] = {.lex_state = 102},
  [3594] = {.lex_state = 171},
  [3595] = {.lex_state = 171},
  [3596] = {.lex_state = 102},
  [3597] = {.lex_state = 171},
  [3598] = {.lex_state = 130},
  [3599] = {.lex_state = 184, .external_lex_state = 2},
  [3600] = {.lex_state = 184, .external_lex_state = 2},
  [3601] = {.lex_state = 184, .external_lex_state = 2},
  [3602] = {.lex_state = 95},
  [3603] = {.lex_state = 102},
  [3604] = {.lex_state = 171},
  [3605] = {.lex_state = 171},
  [3606] = {.lex_state = 102},
  [3607] = {.lex_state = 171},
  [3608] = {.lex_state = 171},
  [3609] = {.lex_state = 130},
  [3610] = {.lex_state = 130},
  [3611] = {.lex_state = 134},
  [3612] = {.lex_state = 95},
  [3613] = {.lex_state = 102},
  [3614] = {.lex_state = 171},
  [3615] = {.lex_state = 171},
  [3616] = {.lex_state = 102},
  [3617] = {.lex_state = 171},
  [3618] = {.lex_state = 171},
  [3619] = {.lex_state = 139},
  [3620] = {.lex_state = 139},
  [3621] = {.lex_state = 181},
  [3622] = {.lex_state = 181},
  [3623] = {.lex_state = 102},
  [3624] = {.lex_state = 171},
  [3625] = {.lex_state = 171},
  [3626] = {.lex_state = 181},
  [3627] = {.lex_state = 179},
  [3628] = {.lex_state = 179},
  [3629] = {.lex_state = 95},
  [3630] = {.lex_state = 171},
  [3631] = {.lex_state = 95},
  [3632] = {.lex_state = 102},
  [3633] = {.lex_state = 171},
  [3634] = {.lex_state = 171},
  [3635] = {.lex_state = 102},
  [3636] = {.lex_state = 171},
  [3637] = {.lex_state = 175},
  [3638] = {.lex_state = 137},
  [3639] = {.lex_state = 95},
  [3640] = {.lex_state = 95},
  [3641] = {.lex_state = 95},
  [3642] = {.lex_state = 95},
  [3643] = {.lex_state = 95},
  [3644] = {.lex_state = 95},
  [3645] = {.lex_state = 95},
  [3646] = {.lex_state = 181, .external_lex_state = 2},
  [3647] = {.lex_state = 139},
  [3648] = {.lex_state = 181},
  [3649] = {.lex_state = 95},
  [3650] = {.lex_state = 95},
  [3651] = {.lex_state = 95},
  [3652] = {.lex_state = 95},
  [3653] = {.lex_state = 181},
  [3654] = {.lex_state = 139},
  [3655] = {.lex_state = 181},
  [3656] = {.lex_state = 181, .external_lex_state = 2},
  [3657] = {.lex_state = 139},
  [3658] = {.lex_state = 181},
  [3659] = {.lex_state = 181, .external_lex_state = 2},
  [3660] = {.lex_state = 139},
  [3661] = {.lex_state = 171},
  [3662] = {.lex_state = 95},
  [3663] = {.lex_state = 102},
  [3664] = {.lex_state = 171},
  [3665] = {.lex_state = 171},
  [3666] = {.lex_state = 102},
  [3667] = {.lex_state = 171},
  [3668] = {.lex_state = 171},
  [3669] = {.lex_state = 134, .external_lex_state = 2},
  [3670] = {.lex_state = 134, .external_lex_state = 2},
  [3671] = {.lex_state = 95, .external_lex_state = 2},
  [3672] = {.lex_state = 181},
  [3673] = {.lex_state = 181},
  [3674] = {.lex_state = 181},
  [3675] = {.lex_state = 95},
  [3676] = {.lex_state = 95},
  [3677] = {.lex_state = 95},
  [3678] = {.lex_state = 181, .external_lex_state = 2},
  [3679] = {.lex_state = 181, .external_lex_state = 2},
  [3680] = {.lex_state = 181, .external_lex_state = 2},
  [3681] = {.lex_state = 181, .external_lex_state = 2},
  [3682] = {.lex_state = 181, .external_lex_state = 2},
  [3683] = {.lex_state = 181, .external_lex_state = 2},
  [3684] = {.lex_state = 95},
  [3685] = {.lex_state = 95},
  [3686] = {.lex_state = 181, .external_lex_state = 2},
  [3687] = {.lex_state = 181, .external_lex_state = 2},
  [3688] = {.lex_state = 181, .external_lex_state = 2},
  [3689] = {.lex_state = 181, .external_lex_state = 2},
  [3690] = {.lex_state = 110},
  [3691] = {.lex_state = 181, .external_lex_state = 2},
  [3692] = {.lex_state = 171},
  [3693] = {.lex_state = 171},
  [3694] = {.lex_state = 95},
  [3695] = {.lex_state = 171},
  [3696] = {.lex_state = 95},
  [3697] = {.lex_state = 102},
  [3698] = {.lex_state = 180, .external_lex_state = 2},
  [3699] = {.lex_state = 180, .external_lex_state = 2},
  [3700] = {.lex_state = 95},
  [3701] = {.lex_state = 95},
  [3702] = {.lex_state = 180, .external_lex_state = 2},
  [3703] = {.lex_state = 130},
  [3704] = {.lex_state = 137},
  [3705] = {.lex_state = 181, .external_lex_state = 2},
  [3706] = {.lex_state = 181},
  [3707] = {.lex_state = 181},
  [3708] = {.lex_state = 181},
  [3709] = {.lex_state = 181},
  [3710] = {.lex_state = 181},
  [3711] = {.lex_state = 181},
  [3712] = {.lex_state = 95},
  [3713] = {.lex_state = 95},
  [3714] = {.lex_state = 181},
  [3715] = {.lex_state = 181},
  [3716] = {.lex_state = 181},
  [3717] = {.lex_state = 181},
  [3718] = {.lex_state = 110},
  [3719] = {.lex_state = 181},
  [3720] = {.lex_state = 171},
  [3721] = {.lex_state = 171},
  [3722] = {.lex_state = 95},
  [3723] = {.lex_state = 171},
  [3724] = {.lex_state = 95},
  [3725] = {.lex_state = 102},
  [3726] = {.lex_state = 180},
  [3727] = {.lex_state = 180},
  [3728] = {.lex_state = 95},
  [3729] = {.lex_state = 95},
  [3730] = {.lex_state = 180},
  [3731] = {.lex_state = 130},
  [3732] = {.lex_state = 137},
  [3733] = {.lex_state = 181},
  [3734] = {.lex_state = 95},
  [3735] = {.lex_state = 95},
  [3736] = {.lex_state = 95},
  [3737] = {.lex_state = 137},
  [3738] = {.lex_state = 137},
  [3739] = {.lex_state = 137},
  [3740] = {.lex_state = 137},
  [3741] = {.lex_state = 137},
  [3742] = {.lex_state = 177},
  [3743] = {.lex_state = 177},
  [3744] = {.lex_state = 137},
  [3745] = {.lex_state = 177},
  [3746] = {.lex_state = 102, .external_lex_state = 2},
  [3747] = {.lex_state = 177},
  [3748] = {.lex_state = 171},
  [3749] = {.lex_state = 179},
  [3750] = {.lex_state = 177},
  [3751] = {.lex_state = 179},
  [3752] = {.lex_state = 187},
  [3753] = {.lex_state = 177},
  [3754] = {.lex_state = 177},
  [3755] = {.lex_state = 186},
  [3756] = {.lex_state = 110},
  [3757] = {.lex_state = 110},
  [3758] = {.lex_state = 102},
  [3759] = {.lex_state = 171},
  [3760] = {.lex_state = 171},
  [3761] = {.lex_state = 110},
  [3762] = {.lex_state = 102},
  [3763] = {.lex_state = 171},
  [3764] = {.lex_state = 171},
  [3765] = {.lex_state = 130},
  [3766] = {.lex_state = 130},
  [3767] = {.lex_state = 102},
  [3768] = {.lex_state = 102},
  [3769] = {.lex_state = 179},
  [3770] = {.lex_state = 179},
  [3771] = {.lex_state = 95},
  [3772] = {.lex_state = 171},
  [3773] = {.lex_state = 95},
  [3774] = {.lex_state = 102},
  [3775] = {.lex_state = 171},
  [3776] = {.lex_state = 171},
  [3777] = {.lex_state = 102},
  [3778] = {.lex_state = 171},
  [3779] = {.lex_state = 175},
  [3780] = {.lex_state = 137, .external_lex_state = 2},
  [3781] = {.lex_state = 102, .external_lex_state = 2},
  [3782] = {.lex_state = 95},
  [3783] = {.lex_state = 130},
  [3784] = {.lex_state = 102, .external_lex_state = 2},
  [3785] = {.lex_state = 102, .external_lex_state = 2},
  [3786] = {.lex_state = 102, .external_lex_state = 2},
  [3787] = {.lex_state = 134, .external_lex_state = 2},
  [3788] = {.lex_state = 171},
  [3789] = {.lex_state = 171},
  [3790] = {.lex_state = 95},
  [3791] = {.lex_state = 171},
  [3792] = {.lex_state = 134, .external_lex_state = 2},
  [3793] = {.lex_state = 95},
  [3794] = {.lex_state = 102},
  [3795] = {.lex_state = 171},
  [3796] = {.lex_state = 95},
  [3797] = {.lex_state = 102},
  [3798] = {.lex_state = 171},
  [3799] = {.lex_state = 171},
  [3800] = {.lex_state = 102},
  [3801] = {.lex_state = 171},
  [3802] = {.lex_state = 137, .external_lex_state = 2},
  [3803] = {.lex_state = 130},
  [3804] = {.lex_state = 95},
  [3805] = {.lex_state = 134, .external_lex_state = 2},
  [3806] = {.lex_state = 102, .external_lex_state = 2},
  [3807] = {.lex_state = 95},
  [3808] = {.lex_state = 171},
  [3809] = {.lex_state = 171},
  [3810] = {.lex_state = 95},
  [3811] = {.lex_state = 102},
  [3812] = {.lex_state = 171},
  [3813] = {.lex_state = 171},
  [3814] = {.lex_state = 102},
  [3815] = {.lex_state = 171},
  [3816] = {.lex_state = 137},
  [3817] = {.lex_state = 161, .external_lex_state = 2},
  [3818] = {.lex_state = 161, .external_lex_state = 2},
  [3819] = {.lex_state = 95},
  [3820] = {.lex_state = 171},
  [3821] = {.lex_state = 95},
  [3822] = {.lex_state = 102},
  [3823] = {.lex_state = 171},
  [3824] = {.lex_state = 171},
  [3825] = {.lex_state = 102},
  [3826] = {.lex_state = 171},
  [3827] = {.lex_state = 102, .external_lex_state = 2},
  [3828] = {.lex_state = 137},
  [3829] = {.lex_state = 102},
  [3830] = {.lex_state = 95},
  [3831] = {.lex_state = 95},
  [3832] = {.lex_state = 95},
  [3833] = {.lex_state = 95},
  [3834] = {.lex_state = 95},
  [3835] = {.lex_state = 95},
  [3836] = {.lex_state = 95},
  [3837] = {.lex_state = 95},
  [3838] = {.lex_state = 95},
  [3839] = {.lex_state = 102, .external_lex_state = 2},
  [3840] = {.lex_state = 102},
  [3841] = {.lex_state = 102},
  [3842] = {.lex_state = 139},
  [3843] = {.lex_state = 95},
  [3844] = {.lex_state = 95},
  [3845] = {.lex_state = 95},
  [3846] = {.lex_state = 95},
  [3847] = {.lex_state = 102},
  [3848] = {.lex_state = 95},
  [3849] = {.lex_state = 95},
  [3850] = {.lex_state = 95},
  [3851] = {.lex_state = 181},
  [3852] = {.lex_state = 181},
  [3853] = {.lex_state = 181},
  [3854] = {.lex_state = 95},
  [3855] = {.lex_state = 95},
  [3856] = {.lex_state = 181},
  [3857] = {.lex_state = 139},
  [3858] = {.lex_state = 181},
  [3859] = {.lex_state = 139},
  [3860] = {.lex_state = 181},
  [3861] = {.lex_state = 139},
  [3862] = {.lex_state = 95},
  [3863] = {.lex_state = 95},
  [3864] = {.lex_state = 95},
  [3865] = {.lex_state = 95},
  [3866] = {.lex_state = 95},
  [3867] = {.lex_state = 137},
  [3868] = {.lex_state = 171},
  [3869] = {.lex_state = 171},
  [3870] = {.lex_state = 95},
  [3871] = {.lex_state = 171},
  [3872] = {.lex_state = 137},
  [3873] = {.lex_state = 95},
  [3874] = {.lex_state = 102},
  [3875] = {.lex_state = 130},
  [3876] = {.lex_state = 110},
  [3877] = {.lex_state = 110},
  [3878] = {.lex_state = 110},
  [3879] = {.lex_state = 110},
  [3880] = {.lex_state = 110},
  [3881] = {.lex_state = 110},
  [3882] = {.lex_state = 95},
  [3883] = {.lex_state = 95},
  [3884] = {.lex_state = 110},
  [3885] = {.lex_state = 110},
  [3886] = {.lex_state = 110},
  [3887] = {.lex_state = 110},
  [3888] = {.lex_state = 110},
  [3889] = {.lex_state = 110},
  [3890] = {.lex_state = 110},
  [3891] = {.lex_state = 171},
  [3892] = {.lex_state = 171},
  [3893] = {.lex_state = 95},
  [3894] = {.lex_state = 171},
  [3895] = {.lex_state = 95},
  [3896] = {.lex_state = 102},
  [3897] = {.lex_state = 102},
  [3898] = {.lex_state = 102},
  [3899] = {.lex_state = 95},
  [3900] = {.lex_state = 95},
  [3901] = {.lex_state = 102},
  [3902] = {.lex_state = 130},
  [3903] = {.lex_state = 137},
  [3904] = {.lex_state = 110},
  [3905] = {.lex_state = 95},
  [3906] = {.lex_state = 95},
  [3907] = {.lex_state = 95},
  [3908] = {.lex_state = 95},
  [3909] = {.lex_state = 102},
  [3910] = {.lex_state = 95},
  [3911] = {.lex_state = 134},
  [3912] = {.lex_state = 95},
  [3913] = {.lex_state = 95},
  [3914] = {.lex_state = 95},
  [3915] = {.lex_state = 137},
  [3916] = {.lex_state = 95},
  [3917] = {.lex_state = 95},
  [3918] = {.lex_state = 102},
  [3919] = {.lex_state = 171},
  [3920] = {.lex_state = 171},
  [3921] = {.lex_state = 102},
  [3922] = {.lex_state = 171},
  [3923] = {.lex_state = 171},
  [3924] = {.lex_state = 194},
  [3925] = {.lex_state = 194},
  [3926] = {.lex_state = 171},
  [3927] = {.lex_state = 95},
  [3928] = {.lex_state = 171},
  [3929] = {.lex_state = 139},
  [3930] = {.lex_state = 95},
  [3931] = {.lex_state = 102},
  [3932] = {.lex_state = 102},
  [3933] = {.lex_state = 171},
  [3934] = {.lex_state = 171},
  [3935] = {.lex_state = 139},
  [3936] = {.lex_state = 171},
  [3937] = {.lex_state = 181},
  [3938] = {.lex_state = 181},
  [3939] = {.lex_state = 139},
  [3940] = {.lex_state = 139},
  [3941] = {.lex_state = 139},
  [3942] = {.lex_state = 139},
  [3943] = {.lex_state = 137},
  [3944] = {.lex_state = 148},
  [3945] = {.lex_state = 148},
  [3946] = {.lex_state = 164},
  [3947] = {.lex_state = 102},
  [3948] = {.lex_state = 148},
  [3949] = {.lex_state = 148},
  [3950] = {.lex_state = 148},
  [3951] = {.lex_state = 95},
  [3952] = {.lex_state = 102},
  [3953] = {.lex_state = 171},
  [3954] = {.lex_state = 171},
  [3955] = {.lex_state = 102},
  [3956] = {.lex_state = 171},
  [3957] = {.lex_state = 171},
  [3958] = {.lex_state = 134},
  [3959] = {.lex_state = 134},
  [3960] = {.lex_state = 102, .external_lex_state = 2},
  [3961] = {.lex_state = 139},
  [3962] = {.lex_state = 171},
  [3963] = {.lex_state = 95},
  [3964] = {.lex_state = 171},
  [3965] = {.lex_state = 134, .external_lex_state = 2},
  [3966] = {.lex_state = 95},
  [3967] = {.lex_state = 102},
  [3968] = {.lex_state = 102},
  [3969] = {.lex_state = 171},
  [3970] = {.lex_state = 171},
  [3971] = {.lex_state = 134, .external_lex_state = 2},
  [3972] = {.lex_state = 95},
  [3973] = {.lex_state = 102},
  [3974] = {.lex_state = 171},
  [3975] = {.lex_state = 171},
  [3976] = {.lex_state = 102},
  [3977] = {.lex_state = 171},
  [3978] = {.lex_state = 171},
  [3979] = {.lex_state = 130},
  [3980] = {.lex_state = 130},
  [3981] = {.lex_state = 171},
  [3982] = {.lex_state = 110},
  [3983] = {.lex_state = 110},
  [3984] = {.lex_state = 199},
  [3985] = {.lex_state = 110, .external_lex_state = 2},
  [3986] = {.lex_state = 110, .external_lex_state = 2},
  [3987] = {.lex_state = 102},
  [3988] = {.lex_state = 171},
  [3989] = {.lex_state = 171},
  [3990] = {.lex_state = 110, .external_lex_state = 2},
  [3991] = {.lex_state = 102, .external_lex_state = 2},
  [3992] = {.lex_state = 95},
  [3993] = {.lex_state = 95},
  [3994] = {.lex_state = 95},
  [3995] = {.lex_state = 95},
  [3996] = {.lex_state = 95},
  [3997] = {.lex_state = 95},
  [3998] = {.lex_state = 95},
  [3999] = {.lex_state = 95},
  [4000] = {.lex_state = 102, .external_lex_state = 2},
  [4001] = {.lex_state = 102},
  [4002] = {.lex_state = 102},
  [4003] = {.lex_state = 139},
  [4004] = {.lex_state = 95},
  [4005] = {.lex_state = 95},
  [4006] = {.lex_state = 95},
  [4007] = {.lex_state = 95},
  [4008] = {.lex_state = 102},
  [4009] = {.lex_state = 95},
  [4010] = {.lex_state = 95},
  [4011] = {.lex_state = 95},
  [4012] = {.lex_state = 181},
  [4013] = {.lex_state = 181},
  [4014] = {.lex_state = 181},
  [4015] = {.lex_state = 95},
  [4016] = {.lex_state = 95},
  [4017] = {.lex_state = 181},
  [4018] = {.lex_state = 139},
  [4019] = {.lex_state = 181},
  [4020] = {.lex_state = 139},
  [4021] = {.lex_state = 181},
  [4022] = {.lex_state = 139},
  [4023] = {.lex_state = 95},
  [4024] = {.lex_state = 95},
  [4025] = {.lex_state = 95},
  [4026] = {.lex_state = 95},
  [4027] = {.lex_state = 95},
  [4028] = {.lex_state = 130},
  [4029] = {.lex_state = 171},
  [4030] = {.lex_state = 171},
  [4031] = {.lex_state = 95},
  [4032] = {.lex_state = 171},
  [4033] = {.lex_state = 130},
  [4034] = {.lex_state = 95},
  [4035] = {.lex_state = 102},
  [4036] = {.lex_state = 102},
  [4037] = {.lex_state = 171},
  [4038] = {.lex_state = 171},
  [4039] = {.lex_state = 134},
  [4040] = {.lex_state = 134},
  [4041] = {.lex_state = 110},
  [4042] = {.lex_state = 110},
  [4043] = {.lex_state = 102},
  [4044] = {.lex_state = 171},
  [4045] = {.lex_state = 171},
  [4046] = {.lex_state = 110},
  [4047] = {.lex_state = 110, .external_lex_state = 2},
  [4048] = {.lex_state = 186},
  [4049] = {.lex_state = 173, .external_lex_state = 2},
  [4050] = {.lex_state = 137},
  [4051] = {.lex_state = 110, .external_lex_state = 2},
  [4052] = {.lex_state = 175},
  [4053] = {.lex_state = 102, .external_lex_state = 2},
  [4054] = {.lex_state = 95},
  [4055] = {.lex_state = 130},
  [4056] = {.lex_state = 130},
  [4057] = {.lex_state = 95},
  [4058] = {.lex_state = 184, .external_lex_state = 2},
  [4059] = {.lex_state = 95},
  [4060] = {.lex_state = 102, .external_lex_state = 2},
  [4061] = {.lex_state = 161, .external_lex_state = 2},
  [4062] = {.lex_state = 137},
  [4063] = {.lex_state = 161, .external_lex_state = 2},
  [4064] = {.lex_state = 95},
  [4065] = {.lex_state = 102},
  [4066] = {.lex_state = 102},
  [4067] = {.lex_state = 137, .external_lex_state = 2},
  [4068] = {.lex_state = 171},
  [4069] = {.lex_state = 171},
  [4070] = {.lex_state = 95},
  [4071] = {.lex_state = 171},
  [4072] = {.lex_state = 137, .external_lex_state = 2},
  [4073] = {.lex_state = 95},
  [4074] = {.lex_state = 102},
  [4075] = {.lex_state = 184, .external_lex_state = 2},
  [4076] = {.lex_state = 184, .external_lex_state = 2},
  [4077] = {.lex_state = 184, .external_lex_state = 2},
  [4078] = {.lex_state = 180},
  [4079] = {.lex_state = 161},
  [4080] = {.lex_state = 161},
  [4081] = {.lex_state = 95},
  [4082] = {.lex_state = 171},
  [4083] = {.lex_state = 95},
  [4084] = {.lex_state = 102},
  [4085] = {.lex_state = 171},
  [4086] = {.lex_state = 171},
  [4087] = {.lex_state = 102},
  [4088] = {.lex_state = 171},
  [4089] = {.lex_state = 102},
  [4090] = {.lex_state = 171},
  [4091] = {.lex_state = 161},
  [4092] = {.lex_state = 161},
  [4093] = {.lex_state = 184, .external_lex_state = 2},
  [4094] = {.lex_state = 186},
  [4095] = {.lex_state = 102},
  [4096] = {.lex_state = 171},
  [4097] = {.lex_state = 171},
  [4098] = {.lex_state = 134, .external_lex_state = 2},
  [4099] = {.lex_state = 184, .external_lex_state = 2},
  [4100] = {.lex_state = 137},
  [4101] = {.lex_state = 134, .external_lex_state = 2},
  [4102] = {.lex_state = 102},
  [4103] = {.lex_state = 171},
  [4104] = {.lex_state = 171},
  [4105] = {.lex_state = 134},
  [4106] = {.lex_state = 134},
  [4107] = {.lex_state = 95},
  [4108] = {.lex_state = 102},
  [4109] = {.lex_state = 171},
  [4110] = {.lex_state = 171},
  [4111] = {.lex_state = 102},
  [4112] = {.lex_state = 171},
  [4113] = {.lex_state = 171},
  [4114] = {.lex_state = 130},
  [4115] = {.lex_state = 130},
  [4116] = {.lex_state = 171},
  [4117] = {.lex_state = 134},
  [4118] = {.lex_state = 134},
  [4119] = {.lex_state = 102},
  [4120] = {.lex_state = 102},
  [4121] = {.lex_state = 185},
  [4122] = {.lex_state = 102, .external_lex_state = 2},
  [4123] = {.lex_state = 95},
  [4124] = {.lex_state = 130},
  [4125] = {.lex_state = 102, .external_lex_state = 2},
  [4126] = {.lex_state = 102, .external_lex_state = 2},
  [4127] = {.lex_state = 102, .external_lex_state = 2},
  [4128] = {.lex_state = 130},
  [4129] = {.lex_state = 102, .external_lex_state = 2},
  [4130] = {.lex_state = 102},
  [4131] = {.lex_state = 102, .external_lex_state = 2},
  [4132] = {.lex_state = 102},
  [4133] = {.lex_state = 102, .external_lex_state = 2},
  [4134] = {.lex_state = 102, .external_lex_state = 2},
  [4135] = {.lex_state = 102, .external_lex_state = 2},
  [4136] = {.lex_state = 95},
  [4137] = {.lex_state = 95},
  [4138] = {.lex_state = 102, .external_lex_state = 2},
  [4139] = {.lex_state = 134, .external_lex_state = 2},
  [4140] = {.lex_state = 171},
  [4141] = {.lex_state = 102, .external_lex_state = 2},
  [4142] = {.lex_state = 95, .external_lex_state = 2},
  [4143] = {.lex_state = 171},
  [4144] = {.lex_state = 95},
  [4145] = {.lex_state = 171},
  [4146] = {.lex_state = 137, .external_lex_state = 2},
  [4147] = {.lex_state = 95},
  [4148] = {.lex_state = 102},
  [4149] = {.lex_state = 102},
  [4150] = {.lex_state = 171},
  [4151] = {.lex_state = 171},
  [4152] = {.lex_state = 137, .external_lex_state = 2},
  [4153] = {.lex_state = 130},
  [4154] = {.lex_state = 95},
  [4155] = {.lex_state = 184, .external_lex_state = 2},
  [4156] = {.lex_state = 102},
  [4157] = {.lex_state = 171},
  [4158] = {.lex_state = 171},
  [4159] = {.lex_state = 130},
  [4160] = {.lex_state = 130},
  [4161] = {.lex_state = 102},
  [4162] = {.lex_state = 171},
  [4163] = {.lex_state = 171},
  [4164] = {.lex_state = 139},
  [4165] = {.lex_state = 139},
  [4166] = {.lex_state = 171},
  [4167] = {.lex_state = 181},
  [4168] = {.lex_state = 181},
  [4169] = {.lex_state = 179},
  [4170] = {.lex_state = 179},
  [4171] = {.lex_state = 102},
  [4172] = {.lex_state = 171},
  [4173] = {.lex_state = 171},
  [4174] = {.lex_state = 179},
  [4175] = {.lex_state = 95},
  [4176] = {.lex_state = 95},
  [4177] = {.lex_state = 95},
  [4178] = {.lex_state = 181},
  [4179] = {.lex_state = 181},
  [4180] = {.lex_state = 181},
  [4181] = {.lex_state = 95},
  [4182] = {.lex_state = 95},
  [4183] = {.lex_state = 181},
  [4184] = {.lex_state = 139},
  [4185] = {.lex_state = 181},
  [4186] = {.lex_state = 139},
  [4187] = {.lex_state = 181},
  [4188] = {.lex_state = 139},
  [4189] = {.lex_state = 95},
  [4190] = {.lex_state = 95},
  [4191] = {.lex_state = 95},
  [4192] = {.lex_state = 95},
  [4193] = {.lex_state = 95},
  [4194] = {.lex_state = 134},
  [4195] = {.lex_state = 171},
  [4196] = {.lex_state = 171},
  [4197] = {.lex_state = 95},
  [4198] = {.lex_state = 171},
  [4199] = {.lex_state = 134},
  [4200] = {.lex_state = 95},
  [4201] = {.lex_state = 102},
  [4202] = {.lex_state = 102},
  [4203] = {.lex_state = 171},
  [4204] = {.lex_state = 171},
  [4205] = {.lex_state = 134, .external_lex_state = 2},
  [4206] = {.lex_state = 134, .external_lex_state = 2},
  [4207] = {.lex_state = 95},
  [4208] = {.lex_state = 95},
  [4209] = {.lex_state = 95},
  [4210] = {.lex_state = 137},
  [4211] = {.lex_state = 137},
  [4212] = {.lex_state = 137},
  [4213] = {.lex_state = 181, .external_lex_state = 2},
  [4214] = {.lex_state = 181, .external_lex_state = 2},
  [4215] = {.lex_state = 95},
  [4216] = {.lex_state = 171},
  [4217] = {.lex_state = 95},
  [4218] = {.lex_state = 102},
  [4219] = {.lex_state = 171},
  [4220] = {.lex_state = 171},
  [4221] = {.lex_state = 102},
  [4222] = {.lex_state = 171},
  [4223] = {.lex_state = 180, .external_lex_state = 2},
  [4224] = {.lex_state = 181},
  [4225] = {.lex_state = 181},
  [4226] = {.lex_state = 95},
  [4227] = {.lex_state = 171},
  [4228] = {.lex_state = 95},
  [4229] = {.lex_state = 102},
  [4230] = {.lex_state = 171},
  [4231] = {.lex_state = 171},
  [4232] = {.lex_state = 102},
  [4233] = {.lex_state = 171},
  [4234] = {.lex_state = 180},
  [4235] = {.lex_state = 137},
  [4236] = {.lex_state = 137},
  [4237] = {.lex_state = 137},
  [4238] = {.lex_state = 177},
  [4239] = {.lex_state = 137},
  [4240] = {.lex_state = 179},
  [4241] = {.lex_state = 177},
  [4242] = {.lex_state = 171},
  [4243] = {.lex_state = 110},
  [4244] = {.lex_state = 110},
  [4245] = {.lex_state = 171},
  [4246] = {.lex_state = 130},
  [4247] = {.lex_state = 130},
  [4248] = {.lex_state = 102, .external_lex_state = 2},
  [4249] = {.lex_state = 102, .external_lex_state = 2},
  [4250] = {.lex_state = 179},
  [4251] = {.lex_state = 179},
  [4252] = {.lex_state = 102},
  [4253] = {.lex_state = 171},
  [4254] = {.lex_state = 171},
  [4255] = {.lex_state = 179},
  [4256] = {.lex_state = 137, .external_lex_state = 2},
  [4257] = {.lex_state = 102, .external_lex_state = 2},
  [4258] = {.lex_state = 95},
  [4259] = {.lex_state = 102, .external_lex_state = 2},
  [4260] = {.lex_state = 171},
  [4261] = {.lex_state = 95},
  [4262] = {.lex_state = 102},
  [4263] = {.lex_state = 171},
  [4264] = {.lex_state = 171},
  [4265] = {.lex_state = 102},
  [4266] = {.lex_state = 171},
  [4267] = {.lex_state = 171},
  [4268] = {.lex_state = 95},
  [4269] = {.lex_state = 171},
  [4270] = {.lex_state = 134, .external_lex_state = 2},
  [4271] = {.lex_state = 95},
  [4272] = {.lex_state = 102},
  [4273] = {.lex_state = 102},
  [4274] = {.lex_state = 171},
  [4275] = {.lex_state = 171},
  [4276] = {.lex_state = 134, .external_lex_state = 2},
  [4277] = {.lex_state = 130},
  [4278] = {.lex_state = 102, .external_lex_state = 2},
  [4279] = {.lex_state = 102, .external_lex_state = 2},
  [4280] = {.lex_state = 134},
  [4281] = {.lex_state = 134},
  [4282] = {.lex_state = 102},
  [4283] = {.lex_state = 171},
  [4284] = {.lex_state = 171},
  [4285] = {.lex_state = 134},
  [4286] = {.lex_state = 161, .external_lex_state = 2},
  [4287] = {.lex_state = 161, .external_lex_state = 2},
  [4288] = {.lex_state = 102},
  [4289] = {.lex_state = 171},
  [4290] = {.lex_state = 171},
  [4291] = {.lex_state = 161, .external_lex_state = 2},
  [4292] = {.lex_state = 102},
  [4293] = {.lex_state = 95},
  [4294] = {.lex_state = 95},
  [4295] = {.lex_state = 95},
  [4296] = {.lex_state = 95},
  [4297] = {.lex_state = 95},
  [4298] = {.lex_state = 95},
  [4299] = {.lex_state = 95},
  [4300] = {.lex_state = 181, .external_lex_state = 2},
  [4301] = {.lex_state = 139},
  [4302] = {.lex_state = 181},
  [4303] = {.lex_state = 95},
  [4304] = {.lex_state = 95},
  [4305] = {.lex_state = 95},
  [4306] = {.lex_state = 95},
  [4307] = {.lex_state = 181},
  [4308] = {.lex_state = 139},
  [4309] = {.lex_state = 181},
  [4310] = {.lex_state = 181, .external_lex_state = 2},
  [4311] = {.lex_state = 139},
  [4312] = {.lex_state = 181},
  [4313] = {.lex_state = 181, .external_lex_state = 2},
  [4314] = {.lex_state = 139},
  [4315] = {.lex_state = 171},
  [4316] = {.lex_state = 181},
  [4317] = {.lex_state = 181},
  [4318] = {.lex_state = 181},
  [4319] = {.lex_state = 95},
  [4320] = {.lex_state = 95},
  [4321] = {.lex_state = 95},
  [4322] = {.lex_state = 95},
  [4323] = {.lex_state = 95},
  [4324] = {.lex_state = 95},
  [4325] = {.lex_state = 171},
  [4326] = {.lex_state = 95},
  [4327] = {.lex_state = 102},
  [4328] = {.lex_state = 171},
  [4329] = {.lex_state = 171},
  [4330] = {.lex_state = 102},
  [4331] = {.lex_state = 171},
  [4332] = {.lex_state = 95},
  [4333] = {.lex_state = 110},
  [4334] = {.lex_state = 110},
  [4335] = {.lex_state = 95},
  [4336] = {.lex_state = 171},
  [4337] = {.lex_state = 95},
  [4338] = {.lex_state = 102},
  [4339] = {.lex_state = 171},
  [4340] = {.lex_state = 171},
  [4341] = {.lex_state = 102},
  [4342] = {.lex_state = 171},
  [4343] = {.lex_state = 102},
  [4344] = {.lex_state = 102, .external_lex_state = 2},
  [4345] = {.lex_state = 95},
  [4346] = {.lex_state = 95},
  [4347] = {.lex_state = 102, .external_lex_state = 2},
  [4348] = {.lex_state = 95},
  [4349] = {.lex_state = 102, .external_lex_state = 2},
  [4350] = {.lex_state = 95},
  [4351] = {.lex_state = 137},
  [4352] = {.lex_state = 95},
  [4353] = {.lex_state = 95},
  [4354] = {.lex_state = 102, .external_lex_state = 2},
  [4355] = {.lex_state = 95},
  [4356] = {.lex_state = 95},
  [4357] = {.lex_state = 95},
  [4358] = {.lex_state = 110, .external_lex_state = 2},
  [4359] = {.lex_state = 110, .external_lex_state = 2},
  [4360] = {.lex_state = 95},
  [4361] = {.lex_state = 102},
  [4362] = {.lex_state = 171},
  [4363] = {.lex_state = 171},
  [4364] = {.lex_state = 194},
  [4365] = {.lex_state = 194},
  [4366] = {.lex_state = 95},
  [4367] = {.lex_state = 102},
  [4368] = {.lex_state = 171},
  [4369] = {.lex_state = 171},
  [4370] = {.lex_state = 102},
  [4371] = {.lex_state = 171},
  [4372] = {.lex_state = 171},
  [4373] = {.lex_state = 139},
  [4374] = {.lex_state = 139},
  [4375] = {.lex_state = 181},
  [4376] = {.lex_state = 102},
  [4377] = {.lex_state = 148},
  [4378] = {.lex_state = 148},
  [4379] = {.lex_state = 102},
  [4380] = {.lex_state = 102},
  [4381] = {.lex_state = 102},
  [4382] = {.lex_state = 102},
  [4383] = {.lex_state = 102},
  [4384] = {.lex_state = 102},
  [4385] = {.lex_state = 171},
  [4386] = {.lex_state = 171},
  [4387] = {.lex_state = 134},
  [4388] = {.lex_state = 134},
  [4389] = {.lex_state = 102, .external_lex_state = 2},
  [4390] = {.lex_state = 95},
  [4391] = {.lex_state = 102},
  [4392] = {.lex_state = 171},
  [4393] = {.lex_state = 171},
  [4394] = {.lex_state = 102},
  [4395] = {.lex_state = 171},
  [4396] = {.lex_state = 171},
  [4397] = {.lex_state = 134, .external_lex_state = 2},
  [4398] = {.lex_state = 134, .external_lex_state = 2},
  [4399] = {.lex_state = 102},
  [4400] = {.lex_state = 171},
  [4401] = {.lex_state = 171},
  [4402] = {.lex_state = 130},
  [4403] = {.lex_state = 130},
  [4404] = {.lex_state = 110},
  [4405] = {.lex_state = 171},
  [4406] = {.lex_state = 110, .external_lex_state = 2},
  [4407] = {.lex_state = 110, .external_lex_state = 2},
  [4408] = {.lex_state = 102, .external_lex_state = 2},
  [4409] = {.lex_state = 95},
  [4410] = {.lex_state = 95},
  [4411] = {.lex_state = 95},
  [4412] = {.lex_state = 95},
  [4413] = {.lex_state = 95},
  [4414] = {.lex_state = 95},
  [4415] = {.lex_state = 181, .external_lex_state = 2},
  [4416] = {.lex_state = 139},
  [4417] = {.lex_state = 181},
  [4418] = {.lex_state = 95},
  [4419] = {.lex_state = 95},
  [4420] = {.lex_state = 95},
  [4421] = {.lex_state = 95},
  [4422] = {.lex_state = 181},
  [4423] = {.lex_state = 139},
  [4424] = {.lex_state = 181},
  [4425] = {.lex_state = 181, .external_lex_state = 2},
  [4426] = {.lex_state = 139},
  [4427] = {.lex_state = 181},
  [4428] = {.lex_state = 181, .external_lex_state = 2},
  [4429] = {.lex_state = 139},
  [4430] = {.lex_state = 171},
  [4431] = {.lex_state = 181},
  [4432] = {.lex_state = 181},
  [4433] = {.lex_state = 181},
  [4434] = {.lex_state = 95},
  [4435] = {.lex_state = 95},
  [4436] = {.lex_state = 95},
  [4437] = {.lex_state = 95},
  [4438] = {.lex_state = 95},
  [4439] = {.lex_state = 95},
  [4440] = {.lex_state = 171},
  [4441] = {.lex_state = 95},
  [4442] = {.lex_state = 102},
  [4443] = {.lex_state = 171},
  [4444] = {.lex_state = 171},
  [4445] = {.lex_state = 102},
  [4446] = {.lex_state = 171},
  [4447] = {.lex_state = 171},
  [4448] = {.lex_state = 134},
  [4449] = {.lex_state = 134},
  [4450] = {.lex_state = 171},
  [4451] = {.lex_state = 110},
  [4452] = {.lex_state = 110},
  [4453] = {.lex_state = 110, .external_lex_state = 2},
  [4454] = {.lex_state = 173, .external_lex_state = 2},
  [4455] = {.lex_state = 102, .external_lex_state = 2},
  [4456] = {.lex_state = 95},
  [4457] = {.lex_state = 130},
  [4458] = {.lex_state = 102, .external_lex_state = 2},
  [4459] = {.lex_state = 95},
  [4460] = {.lex_state = 102},
  [4461] = {.lex_state = 171},
  [4462] = {.lex_state = 95},
  [4463] = {.lex_state = 102},
  [4464] = {.lex_state = 171},
  [4465] = {.lex_state = 171},
  [4466] = {.lex_state = 102},
  [4467] = {.lex_state = 171},
  [4468] = {.lex_state = 130},
  [4469] = {.lex_state = 95},
  [4470] = {.lex_state = 184, .external_lex_state = 2},
  [4471] = {.lex_state = 161},
  [4472] = {.lex_state = 161},
  [4473] = {.lex_state = 102},
  [4474] = {.lex_state = 171},
  [4475] = {.lex_state = 171},
  [4476] = {.lex_state = 161},
  [4477] = {.lex_state = 161},
  [4478] = {.lex_state = 184, .external_lex_state = 2},
  [4479] = {.lex_state = 171},
  [4480] = {.lex_state = 134, .external_lex_state = 2},
  [4481] = {.lex_state = 134, .external_lex_state = 2},
  [4482] = {.lex_state = 184, .external_lex_state = 2},
  [4483] = {.lex_state = 171},
  [4484] = {.lex_state = 134},
  [4485] = {.lex_state = 134},
  [4486] = {.lex_state = 102},
  [4487] = {.lex_state = 171},
  [4488] = {.lex_state = 171},
  [4489] = {.lex_state = 130},
  [4490] = {.lex_state = 130},
  [4491] = {.lex_state = 134},
  [4492] = {.lex_state = 102, .external_lex_state = 2},
  [4493] = {.lex_state = 95},
  [4494] = {.lex_state = 102, .external_lex_state = 2},
  [4495] = {.lex_state = 102},
  [4496] = {.lex_state = 102, .external_lex_state = 2},
  [4497] = {.lex_state = 102},
  [4498] = {.lex_state = 171},
  [4499] = {.lex_state = 102, .external_lex_state = 2},
  [4500] = {.lex_state = 95},
  [4501] = {.lex_state = 102, .external_lex_state = 2},
  [4502] = {.lex_state = 134, .external_lex_state = 2},
  [4503] = {.lex_state = 102, .external_lex_state = 2},
  [4504] = {.lex_state = 102, .external_lex_state = 2},
  [4505] = {.lex_state = 95},
  [4506] = {.lex_state = 102},
  [4507] = {.lex_state = 171},
  [4508] = {.lex_state = 171},
  [4509] = {.lex_state = 102},
  [4510] = {.lex_state = 171},
  [4511] = {.lex_state = 171},
  [4512] = {.lex_state = 137, .external_lex_state = 2},
  [4513] = {.lex_state = 137, .external_lex_state = 2},
  [4514] = {.lex_state = 130},
  [4515] = {.lex_state = 102, .external_lex_state = 2},
  [4516] = {.lex_state = 171},
  [4517] = {.lex_state = 130},
  [4518] = {.lex_state = 130},
  [4519] = {.lex_state = 171},
  [4520] = {.lex_state = 139},
  [4521] = {.lex_state = 139},
  [4522] = {.lex_state = 181},
  [4523] = {.lex_state = 171},
  [4524] = {.lex_state = 179},
  [4525] = {.lex_state = 179},
  [4526] = {.lex_state = 181},
  [4527] = {.lex_state = 181},
  [4528] = {.lex_state = 181},
  [4529] = {.lex_state = 95},
  [4530] = {.lex_state = 95},
  [4531] = {.lex_state = 95},
  [4532] = {.lex_state = 95},
  [4533] = {.lex_state = 95},
  [4534] = {.lex_state = 95},
  [4535] = {.lex_state = 171},
  [4536] = {.lex_state = 95},
  [4537] = {.lex_state = 102},
  [4538] = {.lex_state = 171},
  [4539] = {.lex_state = 171},
  [4540] = {.lex_state = 102},
  [4541] = {.lex_state = 171},
  [4542] = {.lex_state = 171},
  [4543] = {.lex_state = 134, .external_lex_state = 2},
  [4544] = {.lex_state = 134, .external_lex_state = 2},
  [4545] = {.lex_state = 137},
  [4546] = {.lex_state = 137},
  [4547] = {.lex_state = 137},
  [4548] = {.lex_state = 181, .external_lex_state = 2},
  [4549] = {.lex_state = 181, .external_lex_state = 2},
  [4550] = {.lex_state = 102},
  [4551] = {.lex_state = 171},
  [4552] = {.lex_state = 171},
  [4553] = {.lex_state = 181, .external_lex_state = 2},
  [4554] = {.lex_state = 181},
  [4555] = {.lex_state = 181},
  [4556] = {.lex_state = 102},
  [4557] = {.lex_state = 171},
  [4558] = {.lex_state = 171},
  [4559] = {.lex_state = 181},
  [4560] = {.lex_state = 177},
  [4561] = {.lex_state = 110},
  [4562] = {.lex_state = 130},
  [4563] = {.lex_state = 171},
  [4564] = {.lex_state = 179},
  [4565] = {.lex_state = 179},
  [4566] = {.lex_state = 137, .external_lex_state = 2},
  [4567] = {.lex_state = 102, .external_lex_state = 2},
  [4568] = {.lex_state = 171},
  [4569] = {.lex_state = 95},
  [4570] = {.lex_state = 171},
  [4571] = {.lex_state = 134, .external_lex_state = 2},
  [4572] = {.lex_state = 95},
  [4573] = {.lex_state = 102},
  [4574] = {.lex_state = 102},
  [4575] = {.lex_state = 171},
  [4576] = {.lex_state = 171},
  [4577] = {.lex_state = 134, .external_lex_state = 2},
  [4578] = {.lex_state = 95},
  [4579] = {.lex_state = 102},
  [4580] = {.lex_state = 171},
  [4581] = {.lex_state = 171},
  [4582] = {.lex_state = 102},
  [4583] = {.lex_state = 171},
  [4584] = {.lex_state = 171},
  [4585] = {.lex_state = 134, .external_lex_state = 2},
  [4586] = {.lex_state = 134, .external_lex_state = 2},
  [4587] = {.lex_state = 95},
  [4588] = {.lex_state = 102, .external_lex_state = 2},
  [4589] = {.lex_state = 137},
  [4590] = {.lex_state = 186},
  [4591] = {.lex_state = 102},
  [4592] = {.lex_state = 171},
  [4593] = {.lex_state = 134},
  [4594] = {.lex_state = 134},
  [4595] = {.lex_state = 171},
  [4596] = {.lex_state = 161, .external_lex_state = 2},
  [4597] = {.lex_state = 161, .external_lex_state = 2},
  [4598] = {.lex_state = 102},
  [4599] = {.lex_state = 95},
  [4600] = {.lex_state = 95},
  [4601] = {.lex_state = 95},
  [4602] = {.lex_state = 181},
  [4603] = {.lex_state = 181},
  [4604] = {.lex_state = 181},
  [4605] = {.lex_state = 95},
  [4606] = {.lex_state = 95},
  [4607] = {.lex_state = 181},
  [4608] = {.lex_state = 139},
  [4609] = {.lex_state = 181},
  [4610] = {.lex_state = 139},
  [4611] = {.lex_state = 181},
  [4612] = {.lex_state = 139},
  [4613] = {.lex_state = 95},
  [4614] = {.lex_state = 95},
  [4615] = {.lex_state = 95},
  [4616] = {.lex_state = 95},
  [4617] = {.lex_state = 95},
  [4618] = {.lex_state = 137},
  [4619] = {.lex_state = 171},
  [4620] = {.lex_state = 171},
  [4621] = {.lex_state = 95},
  [4622] = {.lex_state = 171},
  [4623] = {.lex_state = 137},
  [4624] = {.lex_state = 95},
  [4625] = {.lex_state = 102},
  [4626] = {.lex_state = 95},
  [4627] = {.lex_state = 95},
  [4628] = {.lex_state = 95},
  [4629] = {.lex_state = 137},
  [4630] = {.lex_state = 102},
  [4631] = {.lex_state = 171},
  [4632] = {.lex_state = 171},
  [4633] = {.lex_state = 137},
  [4634] = {.lex_state = 95},
  [4635] = {.lex_state = 110},
  [4636] = {.lex_state = 110},
  [4637] = {.lex_state = 102},
  [4638] = {.lex_state = 171},
  [4639] = {.lex_state = 171},
  [4640] = {.lex_state = 110},
  [4641] = {.lex_state = 95},
  [4642] = {.lex_state = 95},
  [4643] = {.lex_state = 95},
  [4644] = {.lex_state = 95},
  [4645] = {.lex_state = 102},
  [4646] = {.lex_state = 95},
  [4647] = {.lex_state = 134},
  [4648] = {.lex_state = 95},
  [4649] = {.lex_state = 95},
  [4650] = {.lex_state = 95},
  [4651] = {.lex_state = 95},
  [4652] = {.lex_state = 95},
  [4653] = {.lex_state = 95},
  [4654] = {.lex_state = 95},
  [4655] = {.lex_state = 95},
  [4656] = {.lex_state = 95},
  [4657] = {.lex_state = 95},
  [4658] = {.lex_state = 95},
  [4659] = {.lex_state = 102, .external_lex_state = 2},
  [4660] = {.lex_state = 102},
  [4661] = {.lex_state = 102},
  [4662] = {.lex_state = 139},
  [4663] = {.lex_state = 95},
  [4664] = {.lex_state = 95},
  [4665] = {.lex_state = 95},
  [4666] = {.lex_state = 95},
  [4667] = {.lex_state = 102},
  [4668] = {.lex_state = 171},
  [4669] = {.lex_state = 194},
  [4670] = {.lex_state = 194},
  [4671] = {.lex_state = 102},
  [4672] = {.lex_state = 171},
  [4673] = {.lex_state = 171},
  [4674] = {.lex_state = 139},
  [4675] = {.lex_state = 139},
  [4676] = {.lex_state = 148},
  [4677] = {.lex_state = 102},
  [4678] = {.lex_state = 148},
  [4679] = {.lex_state = 148},
  [4680] = {.lex_state = 171},
  [4681] = {.lex_state = 134},
  [4682] = {.lex_state = 134},
  [4683] = {.lex_state = 102},
  [4684] = {.lex_state = 171},
  [4685] = {.lex_state = 171},
  [4686] = {.lex_state = 134, .external_lex_state = 2},
  [4687] = {.lex_state = 134, .external_lex_state = 2},
  [4688] = {.lex_state = 171},
  [4689] = {.lex_state = 130},
  [4690] = {.lex_state = 130},
  [4691] = {.lex_state = 110, .external_lex_state = 2},
  [4692] = {.lex_state = 95},
  [4693] = {.lex_state = 95},
  [4694] = {.lex_state = 95},
  [4695] = {.lex_state = 181},
  [4696] = {.lex_state = 181},
  [4697] = {.lex_state = 181},
  [4698] = {.lex_state = 95},
  [4699] = {.lex_state = 95},
  [4700] = {.lex_state = 181},
  [4701] = {.lex_state = 139},
  [4702] = {.lex_state = 181},
  [4703] = {.lex_state = 139},
  [4704] = {.lex_state = 181},
  [4705] = {.lex_state = 139},
  [4706] = {.lex_state = 95},
  [4707] = {.lex_state = 95},
  [4708] = {.lex_state = 95},
  [4709] = {.lex_state = 95},
  [4710] = {.lex_state = 95},
  [4711] = {.lex_state = 130},
  [4712] = {.lex_state = 171},
  [4713] = {.lex_state = 171},
  [4714] = {.lex_state = 95},
  [4715] = {.lex_state = 171},
  [4716] = {.lex_state = 130},
  [4717] = {.lex_state = 130},
  [4718] = {.lex_state = 95},
  [4719] = {.lex_state = 102},
  [4720] = {.lex_state = 95},
  [4721] = {.lex_state = 95},
  [4722] = {.lex_state = 95},
  [4723] = {.lex_state = 171},
  [4724] = {.lex_state = 95},
  [4725] = {.lex_state = 171},
  [4726] = {.lex_state = 130},
  [4727] = {.lex_state = 95},
  [4728] = {.lex_state = 102},
  [4729] = {.lex_state = 102},
  [4730] = {.lex_state = 171},
  [4731] = {.lex_state = 171},
  [4732] = {.lex_state = 130},
  [4733] = {.lex_state = 134},
  [4734] = {.lex_state = 110},
  [4735] = {.lex_state = 102, .external_lex_state = 2},
  [4736] = {.lex_state = 95},
  [4737] = {.lex_state = 102, .external_lex_state = 2},
  [4738] = {.lex_state = 171},
  [4739] = {.lex_state = 95},
  [4740] = {.lex_state = 171},
  [4741] = {.lex_state = 137, .external_lex_state = 2},
  [4742] = {.lex_state = 95},
  [4743] = {.lex_state = 102},
  [4744] = {.lex_state = 102},
  [4745] = {.lex_state = 171},
  [4746] = {.lex_state = 171},
  [4747] = {.lex_state = 137, .external_lex_state = 2},
  [4748] = {.lex_state = 130},
  [4749] = {.lex_state = 171},
  [4750] = {.lex_state = 161},
  [4751] = {.lex_state = 161},
  [4752] = {.lex_state = 134, .external_lex_state = 2},
  [4753] = {.lex_state = 134},
  [4754] = {.lex_state = 171},
  [4755] = {.lex_state = 130},
  [4756] = {.lex_state = 130},
  [4757] = {.lex_state = 102, .external_lex_state = 2},
  [4758] = {.lex_state = 102, .external_lex_state = 2},
  [4759] = {.lex_state = 102},
  [4760] = {.lex_state = 137, .external_lex_state = 2},
  [4761] = {.lex_state = 102, .external_lex_state = 2},
  [4762] = {.lex_state = 102, .external_lex_state = 2},
  [4763] = {.lex_state = 102},
  [4764] = {.lex_state = 171},
  [4765] = {.lex_state = 171},
  [4766] = {.lex_state = 137, .external_lex_state = 2},
  [4767] = {.lex_state = 137, .external_lex_state = 2},
  [4768] = {.lex_state = 95},
  [4769] = {.lex_state = 130},
  [4770] = {.lex_state = 139},
  [4771] = {.lex_state = 179},
  [4772] = {.lex_state = 95},
  [4773] = {.lex_state = 95},
  [4774] = {.lex_state = 95},
  [4775] = {.lex_state = 134},
  [4776] = {.lex_state = 102},
  [4777] = {.lex_state = 171},
  [4778] = {.lex_state = 171},
  [4779] = {.lex_state = 134},
  [4780] = {.lex_state = 134, .external_lex_state = 2},
  [4781] = {.lex_state = 171},
  [4782] = {.lex_state = 181, .external_lex_state = 2},
  [4783] = {.lex_state = 181, .external_lex_state = 2},
  [4784] = {.lex_state = 171},
  [4785] = {.lex_state = 181},
  [4786] = {.lex_state = 181},
  [4787] = {.lex_state = 179},
  [4788] = {.lex_state = 137, .external_lex_state = 2},
  [4789] = {.lex_state = 95},
  [4790] = {.lex_state = 102},
  [4791] = {.lex_state = 171},
  [4792] = {.lex_state = 171},
  [4793] = {.lex_state = 102},
  [4794] = {.lex_state = 171},
  [4795] = {.lex_state = 171},
  [4796] = {.lex_state = 134, .external_lex_state = 2},
  [4797] = {.lex_state = 134, .external_lex_state = 2},
  [4798] = {.lex_state = 102},
  [4799] = {.lex_state = 171},
  [4800] = {.lex_state = 171},
  [4801] = {.lex_state = 134, .external_lex_state = 2},
  [4802] = {.lex_state = 134, .external_lex_state = 2},
  [4803] = {.lex_state = 102, .external_lex_state = 2},
  [4804] = {.lex_state = 137},
  [4805] = {.lex_state = 186},
  [4806] = {.lex_state = 134},
  [4807] = {.lex_state = 161, .external_lex_state = 2},
  [4808] = {.lex_state = 181},
  [4809] = {.lex_state = 181},
  [4810] = {.lex_state = 181},
  [4811] = {.lex_state = 95},
  [4812] = {.lex_state = 95},
  [4813] = {.lex_state = 95},
  [4814] = {.lex_state = 95},
  [4815] = {.lex_state = 95},
  [4816] = {.lex_state = 95},
  [4817] = {.lex_state = 171},
  [4818] = {.lex_state = 95},
  [4819] = {.lex_state = 102},
  [4820] = {.lex_state = 171},
  [4821] = {.lex_state = 171},
  [4822] = {.lex_state = 102},
  [4823] = {.lex_state = 171},
  [4824] = {.lex_state = 171},
  [4825] = {.lex_state = 137},
  [4826] = {.lex_state = 137},
  [4827] = {.lex_state = 102},
  [4828] = {.lex_state = 171},
  [4829] = {.lex_state = 110},
  [4830] = {.lex_state = 110},
  [4831] = {.lex_state = 137},
  [4832] = {.lex_state = 95},
  [4833] = {.lex_state = 102, .external_lex_state = 2},
  [4834] = {.lex_state = 95},
  [4835] = {.lex_state = 95},
  [4836] = {.lex_state = 95},
  [4837] = {.lex_state = 110, .external_lex_state = 2},
  [4838] = {.lex_state = 110, .external_lex_state = 2},
  [4839] = {.lex_state = 95},
  [4840] = {.lex_state = 95},
  [4841] = {.lex_state = 95},
  [4842] = {.lex_state = 95},
  [4843] = {.lex_state = 95},
  [4844] = {.lex_state = 95},
  [4845] = {.lex_state = 95},
  [4846] = {.lex_state = 181, .external_lex_state = 2},
  [4847] = {.lex_state = 139},
  [4848] = {.lex_state = 181},
  [4849] = {.lex_state = 95},
  [4850] = {.lex_state = 95},
  [4851] = {.lex_state = 95},
  [4852] = {.lex_state = 95},
  [4853] = {.lex_state = 181},
  [4854] = {.lex_state = 139},
  [4855] = {.lex_state = 181},
  [4856] = {.lex_state = 181, .external_lex_state = 2},
  [4857] = {.lex_state = 139},
  [4858] = {.lex_state = 181},
  [4859] = {.lex_state = 181, .external_lex_state = 2},
  [4860] = {.lex_state = 139},
  [4861] = {.lex_state = 171},
  [4862] = {.lex_state = 194},
  [4863] = {.lex_state = 171},
  [4864] = {.lex_state = 139},
  [4865] = {.lex_state = 139},
  [4866] = {.lex_state = 148},
  [4867] = {.lex_state = 134},
  [4868] = {.lex_state = 171},
  [4869] = {.lex_state = 134, .external_lex_state = 2},
  [4870] = {.lex_state = 134, .external_lex_state = 2},
  [4871] = {.lex_state = 130},
  [4872] = {.lex_state = 181},
  [4873] = {.lex_state = 181},
  [4874] = {.lex_state = 181},
  [4875] = {.lex_state = 95},
  [4876] = {.lex_state = 95},
  [4877] = {.lex_state = 95},
  [4878] = {.lex_state = 95},
  [4879] = {.lex_state = 95},
  [4880] = {.lex_state = 95},
  [4881] = {.lex_state = 171},
  [4882] = {.lex_state = 95},
  [4883] = {.lex_state = 102},
  [4884] = {.lex_state = 171},
  [4885] = {.lex_state = 171},
  [4886] = {.lex_state = 102},
  [4887] = {.lex_state = 171},
  [4888] = {.lex_state = 95},
  [4889] = {.lex_state = 102},
  [4890] = {.lex_state = 171},
  [4891] = {.lex_state = 171},
  [4892] = {.lex_state = 102},
  [4893] = {.lex_state = 171},
  [4894] = {.lex_state = 171},
  [4895] = {.lex_state = 130},
  [4896] = {.lex_state = 130},
  [4897] = {.lex_state = 102, .external_lex_state = 2},
  [4898] = {.lex_state = 95},
  [4899] = {.lex_state = 102},
  [4900] = {.lex_state = 171},
  [4901] = {.lex_state = 171},
  [4902] = {.lex_state = 102},
  [4903] = {.lex_state = 171},
  [4904] = {.lex_state = 171},
  [4905] = {.lex_state = 137, .external_lex_state = 2},
  [4906] = {.lex_state = 137, .external_lex_state = 2},
  [4907] = {.lex_state = 95},
  [4908] = {.lex_state = 161},
  [4909] = {.lex_state = 130},
  [4910] = {.lex_state = 102, .external_lex_state = 2},
  [4911] = {.lex_state = 171},
  [4912] = {.lex_state = 137, .external_lex_state = 2},
  [4913] = {.lex_state = 137, .external_lex_state = 2},
  [4914] = {.lex_state = 102, .external_lex_state = 2},
  [4915] = {.lex_state = 171},
  [4916] = {.lex_state = 134},
  [4917] = {.lex_state = 134},
  [4918] = {.lex_state = 181, .external_lex_state = 2},
  [4919] = {.lex_state = 181},
  [4920] = {.lex_state = 102},
  [4921] = {.lex_state = 171},
  [4922] = {.lex_state = 171},
  [4923] = {.lex_state = 134, .external_lex_state = 2},
  [4924] = {.lex_state = 134, .external_lex_state = 2},
  [4925] = {.lex_state = 171},
  [4926] = {.lex_state = 134, .external_lex_state = 2},
  [4927] = {.lex_state = 134, .external_lex_state = 2},
  [4928] = {.lex_state = 137, .external_lex_state = 2},
  [4929] = {.lex_state = 137},
  [4930] = {.lex_state = 95},
  [4931] = {.lex_state = 95},
  [4932] = {.lex_state = 95},
  [4933] = {.lex_state = 137},
  [4934] = {.lex_state = 102},
  [4935] = {.lex_state = 171},
  [4936] = {.lex_state = 171},
  [4937] = {.lex_state = 137},
  [4938] = {.lex_state = 137},
  [4939] = {.lex_state = 110},
  [4940] = {.lex_state = 95},
  [4941] = {.lex_state = 95},
  [4942] = {.lex_state = 95},
  [4943] = {.lex_state = 95},
  [4944] = {.lex_state = 95},
  [4945] = {.lex_state = 95},
  [4946] = {.lex_state = 95},
  [4947] = {.lex_state = 102, .external_lex_state = 2},
  [4948] = {.lex_state = 102},
  [4949] = {.lex_state = 102},
  [4950] = {.lex_state = 139},
  [4951] = {.lex_state = 95},
  [4952] = {.lex_state = 95},
  [4953] = {.lex_state = 95},
  [4954] = {.lex_state = 95},
  [4955] = {.lex_state = 102},
  [4956] = {.lex_state = 95},
  [4957] = {.lex_state = 95},
  [4958] = {.lex_state = 95},
  [4959] = {.lex_state = 181},
  [4960] = {.lex_state = 181},
  [4961] = {.lex_state = 181},
  [4962] = {.lex_state = 95},
  [4963] = {.lex_state = 95},
  [4964] = {.lex_state = 181},
  [4965] = {.lex_state = 139},
  [4966] = {.lex_state = 181},
  [4967] = {.lex_state = 139},
  [4968] = {.lex_state = 181},
  [4969] = {.lex_state = 139},
  [4970] = {.lex_state = 95},
  [4971] = {.lex_state = 95},
  [4972] = {.lex_state = 95},
  [4973] = {.lex_state = 95},
  [4974] = {.lex_state = 95},
  [4975] = {.lex_state = 137},
  [4976] = {.lex_state = 171},
  [4977] = {.lex_state = 171},
  [4978] = {.lex_state = 95},
  [4979] = {.lex_state = 171},
  [4980] = {.lex_state = 137},
  [4981] = {.lex_state = 95},
  [4982] = {.lex_state = 102},
  [4983] = {.lex_state = 139},
  [4984] = {.lex_state = 134, .external_lex_state = 2},
  [4985] = {.lex_state = 95},
  [4986] = {.lex_state = 95},
  [4987] = {.lex_state = 95},
  [4988] = {.lex_state = 171},
  [4989] = {.lex_state = 95},
  [4990] = {.lex_state = 171},
  [4991] = {.lex_state = 130},
  [4992] = {.lex_state = 95},
  [4993] = {.lex_state = 102},
  [4994] = {.lex_state = 102},
  [4995] = {.lex_state = 171},
  [4996] = {.lex_state = 171},
  [4997] = {.lex_state = 130},
  [4998] = {.lex_state = 102},
  [4999] = {.lex_state = 171},
  [5000] = {.lex_state = 171},
  [5001] = {.lex_state = 130},
  [5002] = {.lex_state = 130},
  [5003] = {.lex_state = 102},
  [5004] = {.lex_state = 171},
  [5005] = {.lex_state = 171},
  [5006] = {.lex_state = 137, .external_lex_state = 2},
  [5007] = {.lex_state = 137, .external_lex_state = 2},
  [5008] = {.lex_state = 102, .external_lex_state = 2},
  [5009] = {.lex_state = 137, .external_lex_state = 2},
  [5010] = {.lex_state = 134},
  [5011] = {.lex_state = 171},
  [5012] = {.lex_state = 134, .external_lex_state = 2},
  [5013] = {.lex_state = 134, .external_lex_state = 2},
  [5014] = {.lex_state = 134, .external_lex_state = 2},
  [5015] = {.lex_state = 171},
  [5016] = {.lex_state = 137},
  [5017] = {.lex_state = 137},
  [5018] = {.lex_state = 95},
  [5019] = {.lex_state = 95},
  [5020] = {.lex_state = 95},
  [5021] = {.lex_state = 95},
  [5022] = {.lex_state = 95},
  [5023] = {.lex_state = 95},
  [5024] = {.lex_state = 181, .external_lex_state = 2},
  [5025] = {.lex_state = 139},
  [5026] = {.lex_state = 181},
  [5027] = {.lex_state = 95},
  [5028] = {.lex_state = 95},
  [5029] = {.lex_state = 95},
  [5030] = {.lex_state = 95},
  [5031] = {.lex_state = 181},
  [5032] = {.lex_state = 139},
  [5033] = {.lex_state = 181},
  [5034] = {.lex_state = 181, .external_lex_state = 2},
  [5035] = {.lex_state = 139},
  [5036] = {.lex_state = 181},
  [5037] = {.lex_state = 181, .external_lex_state = 2},
  [5038] = {.lex_state = 139},
  [5039] = {.lex_state = 171},
  [5040] = {.lex_state = 181},
  [5041] = {.lex_state = 181},
  [5042] = {.lex_state = 181},
  [5043] = {.lex_state = 95},
  [5044] = {.lex_state = 95},
  [5045] = {.lex_state = 95},
  [5046] = {.lex_state = 95},
  [5047] = {.lex_state = 95},
  [5048] = {.lex_state = 95},
  [5049] = {.lex_state = 171},
  [5050] = {.lex_state = 95},
  [5051] = {.lex_state = 102},
  [5052] = {.lex_state = 171},
  [5053] = {.lex_state = 171},
  [5054] = {.lex_state = 102},
  [5055] = {.lex_state = 171},
  [5056] = {.lex_state = 95},
  [5057] = {.lex_state = 102},
  [5058] = {.lex_state = 171},
  [5059] = {.lex_state = 171},
  [5060] = {.lex_state = 102},
  [5061] = {.lex_state = 171},
  [5062] = {.lex_state = 171},
  [5063] = {.lex_state = 130},
  [5064] = {.lex_state = 130},
  [5065] = {.lex_state = 171},
  [5066] = {.lex_state = 130},
  [5067] = {.lex_state = 130},
  [5068] = {.lex_state = 171},
  [5069] = {.lex_state = 137, .external_lex_state = 2},
  [5070] = {.lex_state = 137, .external_lex_state = 2},
  [5071] = {.lex_state = 134, .external_lex_state = 2},
  [5072] = {.lex_state = 137},
  [5073] = {.lex_state = 95},
  [5074] = {.lex_state = 95},
  [5075] = {.lex_state = 95},
  [5076] = {.lex_state = 181},
  [5077] = {.lex_state = 181},
  [5078] = {.lex_state = 181},
  [5079] = {.lex_state = 95},
  [5080] = {.lex_state = 95},
  [5081] = {.lex_state = 181},
  [5082] = {.lex_state = 139},
  [5083] = {.lex_state = 181},
  [5084] = {.lex_state = 139},
  [5085] = {.lex_state = 181},
  [5086] = {.lex_state = 139},
  [5087] = {.lex_state = 95},
  [5088] = {.lex_state = 95},
  [5089] = {.lex_state = 95},
  [5090] = {.lex_state = 95},
  [5091] = {.lex_state = 95},
  [5092] = {.lex_state = 137},
  [5093] = {.lex_state = 171},
  [5094] = {.lex_state = 171},
  [5095] = {.lex_state = 95},
  [5096] = {.lex_state = 171},
  [5097] = {.lex_state = 137},
  [5098] = {.lex_state = 95},
  [5099] = {.lex_state = 102},
  [5100] = {.lex_state = 95},
  [5101] = {.lex_state = 95},
  [5102] = {.lex_state = 95},
  [5103] = {.lex_state = 137},
  [5104] = {.lex_state = 102},
  [5105] = {.lex_state = 171},
  [5106] = {.lex_state = 171},
  [5107] = {.lex_state = 137},
  [5108] = {.lex_state = 102},
  [5109] = {.lex_state = 171},
  [5110] = {.lex_state = 171},
  [5111] = {.lex_state = 130},
  [5112] = {.lex_state = 130},
  [5113] = {.lex_state = 130},
  [5114] = {.lex_state = 137, .external_lex_state = 2},
  [5115] = {.lex_state = 181},
  [5116] = {.lex_state = 181},
  [5117] = {.lex_state = 181},
  [5118] = {.lex_state = 95},
  [5119] = {.lex_state = 95},
  [5120] = {.lex_state = 95},
  [5121] = {.lex_state = 95},
  [5122] = {.lex_state = 95},
  [5123] = {.lex_state = 95},
  [5124] = {.lex_state = 171},
  [5125] = {.lex_state = 95},
  [5126] = {.lex_state = 102},
  [5127] = {.lex_state = 171},
  [5128] = {.lex_state = 171},
  [5129] = {.lex_state = 102},
  [5130] = {.lex_state = 171},
  [5131] = {.lex_state = 171},
  [5132] = {.lex_state = 137},
  [5133] = {.lex_state = 137},
  [5134] = {.lex_state = 171},
  [5135] = {.lex_state = 130},
  [5136] = {.lex_state = 130},
  [5137] = {.lex_state = 95},
  [5138] = {.lex_state = 95},
  [5139] = {.lex_state = 95},
  [5140] = {.lex_state = 137},
  [5141] = {.lex_state = 102},
  [5142] = {.lex_state = 171},
  [5143] = {.lex_state = 171},
  [5144] = {.lex_state = 137},
  [5145] = {.lex_state = 137},
  [5146] = {.lex_state = 130},
  [5147] = {.lex_state = 171},
  [5148] = {.lex_state = 137},
  [5149] = {.lex_state = 137},
  [5150] = {.lex_state = 137},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
};

static bool ts_external_scanner_states[4][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [3] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [sym_readonly] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_this] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
  },
  [1] = {
    [sym_type_alias_declaration] = STATE(52),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(52),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(52),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(52),
    [sym_return_statement] = STATE(52),
    [aux_sym_program_repeat1] = STATE(52),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(52),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(52),
    [sym_switch_statement] = STATE(52),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(52),
    [sym_throw_statement] = STATE(52),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(52),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(52),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(52),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(52),
    [sym_abstract_class] = STATE(52),
    [sym_interface_declaration] = STATE(52),
    [sym_statement_block] = STATE(52),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(52),
    [sym_debugger_statement] = STATE(52),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(52),
    [sym_function] = STATE(60),
    [sym_program] = STATE(61),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(52),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(52),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(52),
    [sym_empty_statement] = STATE(52),
    [sym_import_alias] = STATE(52),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(52),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(52),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(52),
    [sym_break_statement] = STATE(52),
    [sym_labeled_statement] = STATE(52),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(52),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [sym_hash_bang_line] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [2] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(121),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [3] = {
    [aux_sym_template_string_repeat1] = STATE(74),
    [sym_template_substitution] = STATE(74),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(127),
    [sym_escape_sequence] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym__template_chars] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__automatic_semicolon] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(133),
  },
  [5] = {
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [6] = {
    [sym__identifier_reference] = STATE(81),
    [sym_decorator_member_expression] = STATE(81),
    [sym_decorator_call_expression] = STATE(82),
    [anon_sym_get] = ACTIONS(145),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_module] = ACTIONS(145),
    [anon_sym_symbol] = ACTIONS(145),
    [anon_sym_number] = ACTIONS(145),
    [anon_sym_declare] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_protected] = ACTIONS(145),
    [anon_sym_string] = ACTIONS(145),
    [anon_sym_set] = ACTIONS(145),
    [anon_sym_type] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_namespace] = ACTIONS(145),
    [anon_sym_any] = ACTIONS(145),
    [anon_sym_private] = ACTIONS(145),
    [anon_sym_boolean] = ACTIONS(145),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(145),
  },
  [7] = {
    [sym_new_expression] = STATE(87),
    [sym_augmented_assignment_expression] = STATE(87),
    [sym_unary_expression] = STATE(87),
    [sym_update_expression] = STATE(87),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(87),
    [sym_regex] = STATE(87),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(87),
    [sym_non_null_expression] = STATE(87),
    [sym_as_expression] = STATE(87),
    [sym_jsx_fragment] = STATE(87),
    [sym_yield_expression] = STATE(87),
    [sym_jsx_element] = STATE(87),
    [sym_internal_module] = STATE(87),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(87),
    [sym_await_expression] = STATE(87),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(87),
    [sym_this] = STATE(87),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(87),
    [sym_generator_function] = STATE(87),
    [sym_call_expression] = STATE(87),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(87),
    [sym_ternary_expression] = STATE(87),
    [sym_binary_expression] = STATE(87),
    [sym_template_string] = STATE(87),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(87),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(87),
    [sym_class] = STATE(87),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(157),
    [sym_true] = ACTIONS(151),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(151),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [8] = {
    [sym_new_expression] = STATE(90),
    [sym_augmented_assignment_expression] = STATE(90),
    [sym__initializer] = STATE(79),
    [sym_unary_expression] = STATE(90),
    [sym_update_expression] = STATE(90),
    [sym_regex] = STATE(90),
    [sym_meta_property] = STATE(90),
    [sym_call_signature] = STATE(58),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(90),
    [sym_non_null_expression] = STATE(90),
    [sym_yield_expression] = STATE(90),
    [sym_jsx_fragment] = STATE(90),
    [sym_jsx_element] = STATE(90),
    [sym_as_expression] = STATE(90),
    [sym_internal_module] = STATE(90),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(90),
    [sym_await_expression] = STATE(90),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(90),
    [sym_this] = STATE(90),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(90),
    [sym_generator_function] = STATE(90),
    [sym_call_expression] = STATE(90),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(90),
    [sym_ternary_expression] = STATE(90),
    [sym_binary_expression] = STATE(90),
    [sym_template_string] = STATE(90),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(90),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(90),
    [sym_class] = STATE(90),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(161),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(161),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [9] = {
    [sym__automatic_semicolon] = ACTIONS(169),
    [sym_identifier] = ACTIONS(171),
    [anon_sym_SEMI] = ACTIONS(169),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym_variable_declarator] = STATE(97),
    [sym_array] = STATE(98),
    [sym_object] = STATE(99),
    [sym_identifier] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_enum] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [11] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [12] = {
    [sym_new_expression] = STATE(106),
    [sym_augmented_assignment_expression] = STATE(106),
    [sym_unary_expression] = STATE(106),
    [sym_update_expression] = STATE(106),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(106),
    [sym_regex] = STATE(106),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(106),
    [sym_non_null_expression] = STATE(106),
    [sym_as_expression] = STATE(106),
    [sym_jsx_fragment] = STATE(106),
    [sym_yield_expression] = STATE(106),
    [sym_jsx_element] = STATE(106),
    [sym_internal_module] = STATE(106),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(106),
    [sym_await_expression] = STATE(106),
    [sym_member_expression] = STATE(54),
    [sym_sequence_expression] = STATE(107),
    [sym_string] = STATE(106),
    [sym_this] = STATE(106),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(106),
    [sym_generator_function] = STATE(106),
    [sym_call_expression] = STATE(106),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(106),
    [sym_ternary_expression] = STATE(106),
    [sym_binary_expression] = STATE(106),
    [sym_template_string] = STATE(106),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(106),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(106),
    [sym_class] = STATE(106),
    [sym__automatic_semicolon] = ACTIONS(187),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(189),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(191),
    [sym_true] = ACTIONS(189),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(189),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [13] = {
    [sym_identifier] = ACTIONS(193),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym_identifier] = ACTIONS(195),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym_new_expression] = STATE(90),
    [sym_augmented_assignment_expression] = STATE(90),
    [sym_unary_expression] = STATE(90),
    [sym_update_expression] = STATE(90),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(90),
    [sym_regex] = STATE(90),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(90),
    [sym_non_null_expression] = STATE(90),
    [sym_as_expression] = STATE(90),
    [sym_jsx_fragment] = STATE(90),
    [sym_yield_expression] = STATE(90),
    [sym_jsx_element] = STATE(90),
    [sym_internal_module] = STATE(90),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(90),
    [sym_await_expression] = STATE(90),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(90),
    [sym_this] = STATE(90),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(90),
    [sym_generator_function] = STATE(90),
    [sym_call_expression] = STATE(90),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(90),
    [sym_ternary_expression] = STATE(90),
    [sym_binary_expression] = STATE(90),
    [sym_template_string] = STATE(90),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(90),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(90),
    [sym_class] = STATE(90),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(161),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(167),
    [sym_true] = ACTIONS(161),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(161),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [16] = {
    [sym__automatic_semicolon] = ACTIONS(197),
    [sym_identifier] = ACTIONS(199),
    [anon_sym_SEMI] = ACTIONS(197),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym_new_expression] = STATE(112),
    [sym_augmented_assignment_expression] = STATE(112),
    [sym_unary_expression] = STATE(112),
    [sym_update_expression] = STATE(112),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(112),
    [sym_regex] = STATE(112),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(112),
    [sym_non_null_expression] = STATE(112),
    [sym_as_expression] = STATE(112),
    [sym_jsx_fragment] = STATE(112),
    [sym_yield_expression] = STATE(112),
    [sym_jsx_element] = STATE(112),
    [sym_internal_module] = STATE(112),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(112),
    [sym_await_expression] = STATE(112),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(112),
    [sym_this] = STATE(112),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(112),
    [sym_generator_function] = STATE(112),
    [sym_call_expression] = STATE(112),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(112),
    [sym_ternary_expression] = STATE(112),
    [sym_binary_expression] = STATE(112),
    [sym_template_string] = STATE(112),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(112),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(112),
    [sym_class] = STATE(112),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(201),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(203),
    [sym_true] = ACTIONS(201),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(201),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [18] = {
    [sym_parenthesized_expression] = STATE(114),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(207),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_SEMI] = ACTIONS(207),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym__automatic_semicolon] = ACTIONS(207),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_LT_LT] = ACTIONS(207),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_GT_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_BANG_EQ] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(207),
    [anon_sym_GT_EQ] = ACTIONS(207),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PERCENT] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_RBRACE] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_DASH_DASH] = ACTIONS(207),
    [anon_sym_EQ_EQ] = ACTIONS(209),
    [anon_sym_instanceof] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_SLASH] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(207),
    [anon_sym_CARET] = ACTIONS(207),
    [anon_sym_STAR_STAR] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_GT_GT] = ACTIONS(209),
    [anon_sym_PLUS_PLUS] = ACTIONS(207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(209),
  },
  [20] = {
    [sym_new_expression] = STATE(115),
    [sym_augmented_assignment_expression] = STATE(115),
    [sym_unary_expression] = STATE(115),
    [sym_update_expression] = STATE(115),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(115),
    [sym_regex] = STATE(115),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(115),
    [sym_non_null_expression] = STATE(115),
    [sym_as_expression] = STATE(115),
    [sym_jsx_fragment] = STATE(115),
    [sym_yield_expression] = STATE(115),
    [sym_jsx_element] = STATE(115),
    [sym_internal_module] = STATE(115),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(115),
    [sym_await_expression] = STATE(115),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(115),
    [sym_this] = STATE(115),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(115),
    [sym_generator_function] = STATE(115),
    [sym_call_expression] = STATE(115),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(115),
    [sym_ternary_expression] = STATE(115),
    [sym_binary_expression] = STATE(115),
    [sym_template_string] = STATE(115),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(115),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(115),
    [sym_class] = STATE(115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(215),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(215),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [21] = {
    [sym_new_expression] = STATE(116),
    [sym_augmented_assignment_expression] = STATE(116),
    [sym_unary_expression] = STATE(116),
    [sym_update_expression] = STATE(116),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(116),
    [sym_regex] = STATE(116),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(116),
    [sym_non_null_expression] = STATE(116),
    [sym_as_expression] = STATE(116),
    [sym_jsx_fragment] = STATE(116),
    [sym_yield_expression] = STATE(116),
    [sym_jsx_element] = STATE(116),
    [sym_internal_module] = STATE(116),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(116),
    [sym_await_expression] = STATE(116),
    [sym_member_expression] = STATE(54),
    [sym_sequence_expression] = STATE(117),
    [sym_string] = STATE(116),
    [sym_this] = STATE(116),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(116),
    [sym_generator_function] = STATE(116),
    [sym_call_expression] = STATE(116),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(116),
    [sym_ternary_expression] = STATE(116),
    [sym_binary_expression] = STATE(116),
    [sym_template_string] = STATE(116),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(116),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(116),
    [sym_class] = STATE(116),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(219),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(219),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(221),
    [sym_true] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [22] = {
    [anon_sym_class] = ACTIONS(223),
    [sym_comment] = ACTIONS(3),
  },
  [23] = {
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [24] = {
    [sym_import_require_clause] = STATE(124),
    [sym_import_clause] = STATE(125),
    [sym_named_imports] = STATE(126),
    [sym_string] = STATE(124),
    [sym__initializer] = STATE(79),
    [sym_namespace_import] = STATE(126),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(232),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_typeof] = ACTIONS(232),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(234),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [25] = {
    [sym_nested_identifier] = STATE(127),
    [sym__module] = STATE(128),
    [sym_string] = STATE(129),
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [26] = {
    [sym_new_expression] = STATE(130),
    [sym_augmented_assignment_expression] = STATE(130),
    [sym_unary_expression] = STATE(130),
    [sym_update_expression] = STATE(130),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(130),
    [sym_regex] = STATE(130),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(130),
    [sym_non_null_expression] = STATE(130),
    [sym_as_expression] = STATE(130),
    [sym_jsx_fragment] = STATE(130),
    [sym_yield_expression] = STATE(130),
    [sym_jsx_element] = STATE(130),
    [sym_internal_module] = STATE(130),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(130),
    [sym_await_expression] = STATE(130),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(130),
    [sym_this] = STATE(130),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(130),
    [sym_generator_function] = STATE(130),
    [sym_call_expression] = STATE(130),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(130),
    [sym_ternary_expression] = STATE(130),
    [sym_binary_expression] = STATE(130),
    [sym_template_string] = STATE(130),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(130),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(130),
    [sym_class] = STATE(130),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(238),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(240),
    [sym_true] = ACTIONS(238),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(238),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [27] = {
    [aux_sym_string_repeat1] = STATE(132),
    [sym_escape_sequence] = ACTIONS(242),
    [aux_sym_string_token1] = ACTIONS(242),
    [anon_sym_DQUOTE] = ACTIONS(244),
    [sym_comment] = ACTIONS(246),
  },
  [28] = {
    [anon_sym_await] = ACTIONS(248),
    [anon_sym_LPAREN] = ACTIONS(250),
    [sym_comment] = ACTIONS(3),
  },
  [29] = {
    [sym_new_expression] = STATE(160),
    [sym_augmented_assignment_expression] = STATE(160),
    [sym_unary_expression] = STATE(160),
    [sym_update_expression] = STATE(160),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(160),
    [sym_regex] = STATE(160),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(160),
    [sym_non_null_expression] = STATE(160),
    [sym_as_expression] = STATE(160),
    [sym_jsx_fragment] = STATE(160),
    [sym_yield_expression] = STATE(160),
    [sym_jsx_element] = STATE(160),
    [sym_internal_module] = STATE(160),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(160),
    [sym_await_expression] = STATE(160),
    [sym_member_expression] = STATE(162),
    [sym_spread_element] = STATE(163),
    [sym_string] = STATE(160),
    [sym_this] = STATE(160),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [aux_sym_array_repeat1] = STATE(166),
    [sym_anonymous_class] = STATE(160),
    [sym_generator_function] = STATE(160),
    [sym_call_expression] = STATE(160),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(160),
    [sym_ternary_expression] = STATE(160),
    [sym_binary_expression] = STATE(160),
    [sym_template_string] = STATE(160),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(160),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(160),
    [sym_class] = STATE(160),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(256),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(268),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(276),
    [sym_null] = ACTIONS(256),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(288),
    [sym_true] = ACTIONS(256),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(256),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [30] = {
    [sym_identifier] = ACTIONS(306),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [anon_sym_debugger] = ACTIONS(306),
    [anon_sym_symbol] = ACTIONS(306),
    [anon_sym_AT] = ACTIONS(308),
    [anon_sym_DASH] = ACTIONS(306),
    [anon_sym_void] = ACTIONS(306),
    [anon_sym_break] = ACTIONS(306),
    [anon_sym_const] = ACTIONS(306),
    [sym_super] = ACTIONS(306),
    [anon_sym_return] = ACTIONS(306),
    [anon_sym_private] = ACTIONS(306),
    [anon_sym_get] = ACTIONS(306),
    [anon_sym_RBRACE] = ACTIONS(308),
    [anon_sym_interface] = ACTIONS(306),
    [anon_sym_default] = ACTIONS(306),
    [anon_sym_enum] = ACTIONS(306),
    [anon_sym_delete] = ACTIONS(306),
    [anon_sym_continue] = ACTIONS(306),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_this] = ACTIONS(306),
    [anon_sym_yield] = ACTIONS(306),
    [sym_true] = ACTIONS(306),
    [anon_sym_throw] = ACTIONS(306),
    [anon_sym_protected] = ACTIONS(306),
    [anon_sym_abstract] = ACTIONS(306),
    [anon_sym_set] = ACTIONS(306),
    [anon_sym_type] = ACTIONS(306),
    [anon_sym_import] = ACTIONS(306),
    [anon_sym_namespace] = ACTIONS(306),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_await] = ACTIONS(306),
    [anon_sym_DQUOTE] = ACTIONS(308),
    [anon_sym_else] = ACTIONS(306),
    [anon_sym_BANG] = ACTIONS(308),
    [anon_sym_for] = ACTIONS(306),
    [anon_sym_LBRACK] = ACTIONS(308),
    [sym_false] = ACTIONS(306),
    [anon_sym_SEMI] = ACTIONS(308),
    [anon_sym_case] = ACTIONS(306),
    [anon_sym_module] = ACTIONS(306),
    [anon_sym_number] = ACTIONS(306),
    [anon_sym_class] = ACTIONS(306),
    [anon_sym_declare] = ACTIONS(306),
    [anon_sym_typeof] = ACTIONS(306),
    [anon_sym_LBRACE] = ACTIONS(308),
    [anon_sym_switch] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(308),
    [sym_null] = ACTIONS(306),
    [anon_sym_any] = ACTIONS(306),
    [anon_sym_boolean] = ACTIONS(306),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(306),
    [anon_sym_var] = ACTIONS(306),
    [anon_sym_while] = ACTIONS(306),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_try] = ACTIONS(306),
    [anon_sym_RPAREN] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(308),
    [sym_number] = ACTIONS(308),
    [anon_sym_SLASH] = ACTIONS(306),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(306),
    [anon_sym_function] = ACTIONS(306),
    [sym_undefined] = ACTIONS(306),
    [anon_sym_new] = ACTIONS(306),
    [ts_builtin_sym_end] = ACTIONS(308),
    [anon_sym_let] = ACTIONS(306),
    [anon_sym_PLUS] = ACTIONS(306),
    [anon_sym_export] = ACTIONS(306),
    [anon_sym_do] = ACTIONS(306),
    [anon_sym_TILDE] = ACTIONS(308),
    [anon_sym_with] = ACTIONS(306),
  },
  [31] = {
    [sym_nested_identifier] = STATE(169),
    [sym__module] = STATE(172),
    [sym_string] = STATE(173),
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(310),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [32] = {
    [sym_class_heritage] = STATE(178),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(181),
    [anon_sym_extends] = ACTIONS(316),
    [anon_sym_implements] = ACTIONS(318),
    [sym_identifier] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(322),
  },
  [33] = {
    [sym_type_alias_declaration] = STATE(193),
    [aux_sym_export_statement_repeat1] = STATE(192),
    [sym__declaration] = STATE(193),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(193),
    [sym_import_alias] = STATE(193),
    [sym_export_statement] = STATE(193),
    [sym_generator_function] = STATE(193),
    [sym_lexical_declaration] = STATE(193),
    [sym_internal_module] = STATE(193),
    [sym_decorator] = STATE(192),
    [sym_enum_declaration] = STATE(193),
    [sym_function] = STATE(193),
    [sym_function_signature] = STATE(193),
    [sym_variable_declaration] = STATE(193),
    [sym_abstract_class] = STATE(193),
    [sym_module] = STATE(193),
    [sym_interface_declaration] = STATE(193),
    [sym_class] = STATE(193),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(324),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(340),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_declare] = ACTIONS(344),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(354),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [34] = {
    [sym_type_alias_declaration] = STATE(219),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(219),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(219),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(219),
    [sym_return_statement] = STATE(219),
    [aux_sym_program_repeat1] = STATE(219),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [aux_sym_object_repeat1] = STATE(220),
    [sym_accessibility_modifier] = STATE(221),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(219),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(219),
    [sym_spread_element] = STATE(222),
    [sym_switch_statement] = STATE(219),
    [sym_string] = STATE(216),
    [sym_try_statement] = STATE(219),
    [sym_throw_statement] = STATE(219),
    [aux_sym_export_statement_repeat1] = STATE(223),
    [sym__property_name] = STATE(224),
    [sym_object] = STATE(225),
    [sym_ambient_declaration] = STATE(219),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(219),
    [sym_decorator] = STATE(223),
    [sym_continue_statement] = STATE(219),
    [sym_formal_parameters] = STATE(57),
    [sym_computed_property_name] = STATE(224),
    [sym_function_signature] = STATE(219),
    [sym_abstract_class] = STATE(219),
    [sym_interface_declaration] = STATE(219),
    [sym_statement_block] = STATE(219),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(219),
    [sym_debugger_statement] = STATE(219),
    [sym_method_definition] = STATE(222),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(219),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(219),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(219),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(219),
    [sym_empty_statement] = STATE(219),
    [sym_pair] = STATE(222),
    [sym_assignment_pattern] = STATE(222),
    [sym_import_alias] = STATE(219),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(219),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(219),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(219),
    [sym_break_statement] = STATE(219),
    [sym_labeled_statement] = STATE(219),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(226),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(219),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(358),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(364),
    [anon_sym_void] = ACTIONS(366),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(368),
    [anon_sym_static] = ACTIONS(370),
    [anon_sym_get] = ACTIONS(372),
    [anon_sym_RBRACE] = ACTIONS(374),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(368),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(372),
    [anon_sym_type] = ACTIONS(378),
    [anon_sym_import] = ACTIONS(380),
    [anon_sym_namespace] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_readonly] = ACTIONS(384),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(388),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(390),
    [anon_sym_number] = ACTIONS(358),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(392),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(358),
    [anon_sym_boolean] = ACTIONS(358),
    [anon_sym_async] = ACTIONS(396),
    [anon_sym_public] = ACTIONS(368),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(400),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(402),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [35] = {
    [sym_parenthesized_expression] = STATE(227),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [36] = {
    [sym_new_expression] = STATE(245),
    [sym_augmented_assignment_expression] = STATE(245),
    [sym_unary_expression] = STATE(245),
    [sym_update_expression] = STATE(245),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(245),
    [sym_regex] = STATE(245),
    [sym_type_parameters] = STATE(51),
    [sym_rest_parameter] = STATE(244),
    [sym__expression] = STATE(245),
    [sym_non_null_expression] = STATE(245),
    [sym_yield_expression] = STATE(245),
    [sym_jsx_fragment] = STATE(245),
    [sym_jsx_element] = STATE(245),
    [sym_as_expression] = STATE(245),
    [sym_internal_module] = STATE(245),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(245),
    [sym_await_expression] = STATE(245),
    [sym_member_expression] = STATE(246),
    [sym_accessibility_modifier] = STATE(247),
    [sym_required_parameter] = STATE(244),
    [sym_sequence_expression] = STATE(248),
    [sym_string] = STATE(245),
    [sym_this] = STATE(249),
    [aux_sym_export_statement_repeat1] = STATE(250),
    [sym_object] = STATE(251),
    [sym_anonymous_class] = STATE(245),
    [sym_generator_function] = STATE(245),
    [sym_call_expression] = STATE(245),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(245),
    [sym_ternary_expression] = STATE(245),
    [sym_binary_expression] = STATE(245),
    [sym_template_string] = STATE(245),
    [sym_optional_parameter] = STATE(244),
    [sym_decorator] = STATE(250),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(245),
    [sym_array] = STATE(252),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(245),
    [sym_class] = STATE(245),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
    [sym_identifier] = ACTIONS(408),
    [sym_false] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(412),
    [anon_sym_module] = ACTIONS(414),
    [anon_sym_symbol] = ACTIONS(414),
    [anon_sym_number] = ACTIONS(414),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(414),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(410),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(414),
    [anon_sym_private] = ACTIONS(424),
    [anon_sym_boolean] = ACTIONS(414),
    [anon_sym_async] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(424),
    [anon_sym_get] = ACTIONS(414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_RPAREN] = ACTIONS(428),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(430),
    [sym_true] = ACTIONS(410),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(424),
    [anon_sym_string] = ACTIONS(414),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(410),
    [anon_sym_set] = ACTIONS(414),
    [anon_sym_type] = ACTIONS(414),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(414),
    [anon_sym_export] = ACTIONS(414),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(438),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_TILDE] = ACTIONS(412),
  },
  [37] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(79),
    [sym_formal_parameters] = STATE(57),
    [sym_call_signature] = STATE(253),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(442),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(444),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(444),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(444),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(444),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_set] = ACTIONS(444),
    [anon_sym_type] = ACTIONS(444),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(444),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(444),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(444),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(444),
    [anon_sym_declare] = ACTIONS(444),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(444),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(444),
    [anon_sym_async] = ACTIONS(444),
    [anon_sym_public] = ACTIONS(444),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(444),
    [anon_sym_function] = ACTIONS(452),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(444),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [38] = {
    [sym_variable_declarator] = STATE(258),
    [sym_array] = STATE(98),
    [sym_object] = STATE(99),
    [sym_identifier] = ACTIONS(454),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [39] = {
    [sym_type_alias_declaration] = STATE(259),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(259),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(259),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(259),
    [sym_return_statement] = STATE(259),
    [aux_sym_program_repeat1] = STATE(259),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(259),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(259),
    [sym_switch_statement] = STATE(259),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(259),
    [sym_throw_statement] = STATE(259),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(259),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(259),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(259),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(259),
    [sym_abstract_class] = STATE(259),
    [sym_interface_declaration] = STATE(259),
    [sym_statement_block] = STATE(259),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(259),
    [sym_debugger_statement] = STATE(259),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(259),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(259),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(259),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(259),
    [sym_empty_statement] = STATE(259),
    [sym_import_alias] = STATE(259),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(259),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(259),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(259),
    [sym_break_statement] = STATE(259),
    [sym_labeled_statement] = STATE(259),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(259),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(456),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [40] = {
    [sym_parenthesized_expression] = STATE(260),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [41] = {
    [aux_sym_string_repeat2] = STATE(261),
    [sym_escape_sequence] = ACTIONS(458),
    [aux_sym_string_token2] = ACTIONS(458),
    [sym_comment] = ACTIONS(246),
    [anon_sym_SQUOTE] = ACTIONS(244),
  },
  [42] = {
    [sym_statement_block] = STATE(263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [43] = {
    [sym_nested_identifier] = STATE(267),
    [sym_jsx_namespace_name] = STATE(268),
    [sym_type_parameter] = STATE(269),
    [anon_sym_GT] = ACTIONS(462),
    [sym_identifier] = ACTIONS(464),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(466),
  },
  [44] = {
    [sym_regex_pattern] = ACTIONS(468),
    [sym_comment] = ACTIONS(246),
  },
  [45] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(275),
    [sym_identifier] = ACTIONS(470),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(474),
    [anon_sym_STAR] = ACTIONS(476),
    [sym_comment] = ACTIONS(3),
  },
  [46] = {
    [sym_new_expression] = STATE(277),
    [sym_augmented_assignment_expression] = STATE(289),
    [sym_unary_expression] = STATE(289),
    [sym_update_expression] = STATE(289),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(277),
    [sym_regex] = STATE(277),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(289),
    [sym_non_null_expression] = STATE(289),
    [sym_as_expression] = STATE(289),
    [sym_jsx_fragment] = STATE(289),
    [sym_yield_expression] = STATE(289),
    [sym_jsx_element] = STATE(289),
    [sym_internal_module] = STATE(289),
    [sym_function] = STATE(290),
    [sym_arrow_function] = STATE(277),
    [sym_await_expression] = STATE(289),
    [sym_member_expression] = STATE(291),
    [sym_string] = STATE(277),
    [sym_this] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(292),
    [sym_anonymous_class] = STATE(277),
    [sym_generator_function] = STATE(277),
    [sym_call_expression] = STATE(289),
    [sym_subscript_expression] = STATE(291),
    [sym_assignment_expression] = STATE(289),
    [sym_ternary_expression] = STATE(289),
    [sym_binary_expression] = STATE(289),
    [sym_template_string] = STATE(277),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(277),
    [sym_array] = STATE(293),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(289),
    [sym_class] = STATE(277),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(480),
    [sym_false] = ACTIONS(482),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(486),
    [anon_sym_symbol] = ACTIONS(486),
    [anon_sym_number] = ACTIONS(486),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(486),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(482),
    [sym_super] = ACTIONS(494),
    [anon_sym_any] = ACTIONS(486),
    [anon_sym_private] = ACTIONS(486),
    [anon_sym_boolean] = ACTIONS(486),
    [anon_sym_async] = ACTIONS(496),
    [anon_sym_public] = ACTIONS(486),
    [anon_sym_get] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(498),
    [sym_true] = ACTIONS(482),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(486),
    [anon_sym_string] = ACTIONS(486),
    [anon_sym_function] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(502),
    [sym_undefined] = ACTIONS(482),
    [anon_sym_set] = ACTIONS(486),
    [anon_sym_type] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(486),
    [anon_sym_export] = ACTIONS(486),
    [anon_sym_namespace] = ACTIONS(504),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [47] = {
    [sym_variable_declarator] = STATE(97),
    [sym_array] = STATE(98),
    [sym_object] = STATE(99),
    [sym_identifier] = ACTIONS(454),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [48] = {
    [sym_type_alias_declaration] = STATE(300),
    [aux_sym_export_statement_repeat1] = STATE(192),
    [sym__declaration] = STATE(300),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(300),
    [sym_import_alias] = STATE(300),
    [sym_export_statement] = STATE(300),
    [sym_generator_function] = STATE(300),
    [sym_export_clause] = STATE(301),
    [sym_lexical_declaration] = STATE(300),
    [sym_internal_module] = STATE(300),
    [sym_decorator] = STATE(192),
    [sym_enum_declaration] = STATE(300),
    [sym_function] = STATE(300),
    [sym_function_signature] = STATE(300),
    [sym_variable_declaration] = STATE(300),
    [sym_abstract_class] = STATE(300),
    [sym_module] = STATE(300),
    [sym_interface_declaration] = STATE(300),
    [sym_class] = STATE(300),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(508),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(511),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_as] = ACTIONS(515),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_declare] = ACTIONS(344),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(354),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [49] = {
    [sym_type_alias_declaration] = STATE(311),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(311),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(311),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(311),
    [sym_return_statement] = STATE(311),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(311),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(311),
    [sym_switch_statement] = STATE(311),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(311),
    [sym_throw_statement] = STATE(311),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(311),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(311),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(311),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(311),
    [sym_abstract_class] = STATE(311),
    [sym_interface_declaration] = STATE(311),
    [sym_statement_block] = STATE(311),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(311),
    [sym_debugger_statement] = STATE(311),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(311),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(311),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(311),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(311),
    [sym_empty_statement] = STATE(311),
    [sym_import_alias] = STATE(311),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(311),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(311),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(311),
    [sym_break_statement] = STATE(311),
    [sym_labeled_statement] = STATE(311),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(311),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [50] = {
    [sym_parenthesized_expression] = STATE(315),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [51] = {
    [sym_formal_parameters] = STATE(316),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [52] = {
    [sym_type_alias_declaration] = STATE(317),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(317),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(317),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(317),
    [sym_return_statement] = STATE(317),
    [aux_sym_program_repeat1] = STATE(317),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(317),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(317),
    [sym_switch_statement] = STATE(317),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(317),
    [sym_throw_statement] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(317),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(317),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(317),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_statement_block] = STATE(317),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(317),
    [sym_debugger_statement] = STATE(317),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(317),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(317),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(317),
    [sym_empty_statement] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(317),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(317),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(317),
    [sym_break_statement] = STATE(317),
    [sym_labeled_statement] = STATE(317),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(317),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(456),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [53] = {
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [sym_identifier] = ACTIONS(540),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [anon_sym_debugger] = ACTIONS(540),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(540),
    [anon_sym_AT] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(540),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_void] = ACTIONS(540),
    [anon_sym_break] = ACTIONS(540),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_const] = ACTIONS(540),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [sym_super] = ACTIONS(540),
    [anon_sym_return] = ACTIONS(540),
    [anon_sym_private] = ACTIONS(540),
    [anon_sym_get] = ACTIONS(540),
    [anon_sym_RBRACE] = ACTIONS(542),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_interface] = ACTIONS(540),
    [anon_sym_default] = ACTIONS(540),
    [anon_sym_enum] = ACTIONS(540),
    [anon_sym_delete] = ACTIONS(540),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_DASH_DASH] = ACTIONS(542),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_as] = ACTIONS(113),
    [anon_sym_this] = ACTIONS(540),
    [anon_sym_yield] = ACTIONS(540),
    [sym_true] = ACTIONS(540),
    [anon_sym_throw] = ACTIONS(540),
    [anon_sym_instanceof] = ACTIONS(113),
    [anon_sym_protected] = ACTIONS(540),
    [anon_sym_abstract] = ACTIONS(540),
    [anon_sym_DOT] = ACTIONS(113),
    [anon_sym_set] = ACTIONS(540),
    [anon_sym_type] = ACTIONS(540),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_import] = ACTIONS(540),
    [anon_sym_namespace] = ACTIONS(540),
    [anon_sym_PLUS_PLUS] = ACTIONS(542),
    [anon_sym_await] = ACTIONS(540),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [anon_sym_else] = ACTIONS(540),
    [anon_sym_BANG] = ACTIONS(540),
    [anon_sym_for] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(542),
    [sym_false] = ACTIONS(540),
    [anon_sym_SEMI] = ACTIONS(542),
    [anon_sym_case] = ACTIONS(540),
    [anon_sym_module] = ACTIONS(540),
    [anon_sym_number] = ACTIONS(540),
    [anon_sym_class] = ACTIONS(540),
    [anon_sym_declare] = ACTIONS(540),
    [anon_sym_typeof] = ACTIONS(540),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_switch] = ACTIONS(540),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(542),
    [sym_null] = ACTIONS(540),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_any] = ACTIONS(540),
    [anon_sym_boolean] = ACTIONS(540),
    [anon_sym_async] = ACTIONS(540),
    [anon_sym_public] = ACTIONS(540),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_var] = ACTIONS(540),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(540),
    [anon_sym_SQUOTE] = ACTIONS(542),
    [anon_sym_try] = ACTIONS(540),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(540),
    [sym_number] = ACTIONS(542),
    [anon_sym_SLASH] = ACTIONS(540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_function] = ACTIONS(540),
    [sym_undefined] = ACTIONS(540),
    [anon_sym_new] = ACTIONS(540),
    [ts_builtin_sym_end] = ACTIONS(542),
    [anon_sym_let] = ACTIONS(540),
    [anon_sym_PLUS] = ACTIONS(540),
    [anon_sym_export] = ACTIONS(540),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_do] = ACTIONS(540),
    [anon_sym_TILDE] = ACTIONS(542),
    [anon_sym_with] = ACTIONS(540),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [54] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [55] = {
    [aux_sym_export_statement_repeat1] = STATE(320),
    [sym_decorator] = STATE(320),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(544),
    [anon_sym_class] = ACTIONS(546),
    [sym_comment] = ACTIONS(3),
  },
  [56] = {
    [sym__initializer] = STATE(321),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [57] = {
    [sym_type_annotation] = STATE(323),
    [anon_sym_EQ_GT] = ACTIONS(548),
    [anon_sym_COLON] = ACTIONS(550),
    [sym_comment] = ACTIONS(3),
  },
  [58] = {
    [anon_sym_EQ_GT] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
  },
  [59] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [sym__automatic_semicolon] = ACTIONS(552),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(554),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(552),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_PIPE] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(560),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_GT_GT_GT] = ACTIONS(560),
    [anon_sym_AMP_AMP] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(566),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(582),
  },
  [60] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [sym_identifier] = ACTIONS(540),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(540),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(540),
    [anon_sym_AT] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(540),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_void] = ACTIONS(540),
    [anon_sym_break] = ACTIONS(540),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_const] = ACTIONS(540),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [sym_super] = ACTIONS(540),
    [anon_sym_return] = ACTIONS(540),
    [anon_sym_private] = ACTIONS(540),
    [anon_sym_get] = ACTIONS(540),
    [anon_sym_RBRACE] = ACTIONS(542),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_interface] = ACTIONS(540),
    [anon_sym_default] = ACTIONS(540),
    [anon_sym_enum] = ACTIONS(540),
    [anon_sym_delete] = ACTIONS(540),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_DASH_DASH] = ACTIONS(542),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_as] = ACTIONS(113),
    [anon_sym_this] = ACTIONS(540),
    [anon_sym_yield] = ACTIONS(540),
    [sym_true] = ACTIONS(540),
    [anon_sym_throw] = ACTIONS(540),
    [anon_sym_instanceof] = ACTIONS(113),
    [anon_sym_protected] = ACTIONS(540),
    [anon_sym_abstract] = ACTIONS(540),
    [anon_sym_DOT] = ACTIONS(113),
    [anon_sym_set] = ACTIONS(540),
    [anon_sym_type] = ACTIONS(540),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_import] = ACTIONS(540),
    [anon_sym_namespace] = ACTIONS(540),
    [anon_sym_PLUS_PLUS] = ACTIONS(542),
    [anon_sym_await] = ACTIONS(540),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [anon_sym_else] = ACTIONS(540),
    [anon_sym_BANG] = ACTIONS(540),
    [anon_sym_for] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(542),
    [sym_false] = ACTIONS(540),
    [anon_sym_SEMI] = ACTIONS(542),
    [anon_sym_case] = ACTIONS(540),
    [anon_sym_module] = ACTIONS(540),
    [anon_sym_number] = ACTIONS(540),
    [anon_sym_class] = ACTIONS(540),
    [anon_sym_declare] = ACTIONS(540),
    [anon_sym_typeof] = ACTIONS(540),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_switch] = ACTIONS(540),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(183),
    [sym_null] = ACTIONS(540),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_any] = ACTIONS(540),
    [anon_sym_boolean] = ACTIONS(540),
    [anon_sym_async] = ACTIONS(540),
    [anon_sym_public] = ACTIONS(540),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_var] = ACTIONS(540),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(540),
    [anon_sym_SQUOTE] = ACTIONS(542),
    [anon_sym_try] = ACTIONS(540),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(185),
    [sym_number] = ACTIONS(542),
    [anon_sym_SLASH] = ACTIONS(540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_function] = ACTIONS(540),
    [sym_undefined] = ACTIONS(540),
    [anon_sym_new] = ACTIONS(540),
    [ts_builtin_sym_end] = ACTIONS(542),
    [anon_sym_let] = ACTIONS(540),
    [anon_sym_PLUS] = ACTIONS(540),
    [anon_sym_export] = ACTIONS(540),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_do] = ACTIONS(540),
    [anon_sym_TILDE] = ACTIONS(542),
    [anon_sym_with] = ACTIONS(540),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [61] = {
    [ts_builtin_sym_end] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
  },
  [62] = {
    [sym__automatic_semicolon] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(552),
  },
  [63] = {
    [sym__initializer] = STATE(336),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [64] = {
    [sym_jsx_closing_element] = STATE(339),
    [sym_jsx_opening_element] = STATE(340),
    [aux_sym_jsx_element_repeat1] = STATE(341),
    [sym_jsx_expression] = STATE(341),
    [sym_jsx_self_closing_element] = STATE(341),
    [sym_jsx_element] = STATE(341),
    [sym_jsx_text] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(590),
  },
  [65] = {
    [sym_new_expression] = STATE(344),
    [sym_augmented_assignment_expression] = STATE(344),
    [sym_unary_expression] = STATE(344),
    [sym_update_expression] = STATE(344),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(344),
    [sym_regex] = STATE(344),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(343),
    [sym__expression] = STATE(344),
    [sym_non_null_expression] = STATE(344),
    [sym_yield_expression] = STATE(344),
    [sym_jsx_fragment] = STATE(344),
    [sym_jsx_element] = STATE(344),
    [sym_as_expression] = STATE(344),
    [sym_internal_module] = STATE(344),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(344),
    [sym_await_expression] = STATE(344),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(344),
    [sym_this] = STATE(344),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(344),
    [sym_generator_function] = STATE(344),
    [sym_call_expression] = STATE(344),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(344),
    [sym_ternary_expression] = STATE(344),
    [sym_binary_expression] = STATE(344),
    [sym_template_string] = STATE(344),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(344),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(344),
    [sym_class] = STATE(344),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(592),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(592),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(596),
    [sym_true] = ACTIONS(592),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(592),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [66] = {
    [sym_new_expression] = STATE(345),
    [sym_augmented_assignment_expression] = STATE(345),
    [sym_unary_expression] = STATE(345),
    [sym_update_expression] = STATE(345),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(345),
    [sym_regex] = STATE(345),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(345),
    [sym_non_null_expression] = STATE(345),
    [sym_as_expression] = STATE(345),
    [sym_jsx_fragment] = STATE(345),
    [sym_yield_expression] = STATE(345),
    [sym_jsx_element] = STATE(345),
    [sym_internal_module] = STATE(345),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(345),
    [sym_await_expression] = STATE(345),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(345),
    [sym_this] = STATE(345),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(345),
    [sym_generator_function] = STATE(345),
    [sym_call_expression] = STATE(345),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(345),
    [sym_ternary_expression] = STATE(345),
    [sym_binary_expression] = STATE(345),
    [sym_template_string] = STATE(345),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(345),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(345),
    [sym_class] = STATE(345),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(598),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(600),
    [sym_true] = ACTIONS(598),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(598),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [67] = {
    [sym_new_expression] = STATE(346),
    [sym_augmented_assignment_expression] = STATE(346),
    [sym_unary_expression] = STATE(346),
    [sym_update_expression] = STATE(346),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(346),
    [sym_regex] = STATE(346),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(346),
    [sym_non_null_expression] = STATE(346),
    [sym_as_expression] = STATE(346),
    [sym_jsx_fragment] = STATE(346),
    [sym_yield_expression] = STATE(346),
    [sym_jsx_element] = STATE(346),
    [sym_internal_module] = STATE(346),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(346),
    [sym_await_expression] = STATE(346),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(346),
    [sym_this] = STATE(346),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(346),
    [sym_generator_function] = STATE(346),
    [sym_call_expression] = STATE(346),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(346),
    [sym_ternary_expression] = STATE(346),
    [sym_binary_expression] = STATE(346),
    [sym_template_string] = STATE(346),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(346),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(346),
    [sym_class] = STATE(346),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(602),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(602),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(604),
    [sym_true] = ACTIONS(602),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(602),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [68] = {
    [sym_new_expression] = STATE(347),
    [sym_augmented_assignment_expression] = STATE(347),
    [sym_unary_expression] = STATE(347),
    [sym_update_expression] = STATE(347),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(347),
    [sym_non_null_expression] = STATE(347),
    [sym_as_expression] = STATE(347),
    [sym_jsx_fragment] = STATE(347),
    [sym_yield_expression] = STATE(347),
    [sym_jsx_element] = STATE(347),
    [sym_internal_module] = STATE(347),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(347),
    [sym_await_expression] = STATE(347),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(347),
    [sym_this] = STATE(347),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(347),
    [sym_generator_function] = STATE(347),
    [sym_call_expression] = STATE(347),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(347),
    [sym_ternary_expression] = STATE(347),
    [sym_binary_expression] = STATE(347),
    [sym_template_string] = STATE(347),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(347),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(347),
    [sym_class] = STATE(347),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(606),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(608),
    [sym_true] = ACTIONS(606),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(606),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [69] = {
    [sym_type_alias_declaration] = STATE(348),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(348),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(348),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(348),
    [sym_return_statement] = STATE(348),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(348),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(348),
    [sym_switch_statement] = STATE(348),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(348),
    [sym_throw_statement] = STATE(348),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(348),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(348),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(348),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(348),
    [sym_abstract_class] = STATE(348),
    [sym_interface_declaration] = STATE(348),
    [sym_statement_block] = STATE(348),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(348),
    [sym_debugger_statement] = STATE(348),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(348),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(348),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(348),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(348),
    [sym_empty_statement] = STATE(348),
    [sym_import_alias] = STATE(348),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(348),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(348),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(348),
    [sym_break_statement] = STATE(348),
    [sym_labeled_statement] = STATE(348),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(348),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [70] = {
    [sym_identifier] = ACTIONS(610),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_BANG] = ACTIONS(614),
    [anon_sym_SEMI] = ACTIONS(612),
    [anon_sym_BQUOTE] = ACTIONS(612),
    [sym__automatic_semicolon] = ACTIONS(612),
    [anon_sym_PIPE] = ACTIONS(614),
    [anon_sym_COMMA] = ACTIONS(612),
    [anon_sym_LT_LT] = ACTIONS(612),
    [anon_sym_STAR] = ACTIONS(614),
    [anon_sym_GT_GT_GT] = ACTIONS(612),
    [anon_sym_AMP_AMP] = ACTIONS(612),
    [anon_sym_DASH] = ACTIONS(614),
    [anon_sym_BANG_EQ] = ACTIONS(614),
    [anon_sym_LT_EQ] = ACTIONS(612),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_GT_EQ] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(614),
    [anon_sym_AMP] = ACTIONS(614),
    [anon_sym_PERCENT] = ACTIONS(612),
    [anon_sym_QMARK] = ACTIONS(612),
    [anon_sym_RBRACE] = ACTIONS(612),
    [anon_sym_as] = ACTIONS(612),
    [anon_sym_PIPE_PIPE] = ACTIONS(612),
    [anon_sym_DASH_DASH] = ACTIONS(612),
    [anon_sym_EQ_EQ] = ACTIONS(614),
    [anon_sym_instanceof] = ACTIONS(612),
    [anon_sym_LT] = ACTIONS(614),
    [anon_sym_RPAREN] = ACTIONS(612),
    [anon_sym_SLASH] = ACTIONS(614),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(612),
    [anon_sym_CARET] = ACTIONS(612),
    [anon_sym_STAR_STAR] = ACTIONS(612),
    [anon_sym_PLUS] = ACTIONS(614),
    [anon_sym_GT_GT] = ACTIONS(614),
    [anon_sym_PLUS_PLUS] = ACTIONS(612),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(612),
    [anon_sym_in] = ACTIONS(614),
  },
  [72] = {
    [sym_new_expression] = STATE(362),
    [sym_augmented_assignment_expression] = STATE(362),
    [sym_unary_expression] = STATE(362),
    [sym_update_expression] = STATE(362),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(362),
    [sym_regex] = STATE(362),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(362),
    [sym_non_null_expression] = STATE(362),
    [sym_as_expression] = STATE(362),
    [sym_jsx_fragment] = STATE(362),
    [sym_yield_expression] = STATE(362),
    [sym_jsx_element] = STATE(362),
    [sym_internal_module] = STATE(362),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(362),
    [sym_await_expression] = STATE(362),
    [sym_member_expression] = STATE(363),
    [sym_sequence_expression] = STATE(364),
    [sym_string] = STATE(362),
    [sym_this] = STATE(362),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(362),
    [sym_generator_function] = STATE(362),
    [sym_call_expression] = STATE(362),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(362),
    [sym_ternary_expression] = STATE(362),
    [sym_binary_expression] = STATE(362),
    [sym_template_string] = STATE(362),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(362),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(362),
    [sym_class] = STATE(362),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(620),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(620),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(634),
    [sym_true] = ACTIONS(620),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(620),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [73] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(646),
    [anon_sym_SEMI] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [sym__automatic_semicolon] = ACTIONS(644),
    [anon_sym_PIPE] = ACTIONS(646),
    [anon_sym_COMMA] = ACTIONS(644),
    [anon_sym_LT_LT] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_GT_GT_GT] = ACTIONS(644),
    [anon_sym_AMP_AMP] = ACTIONS(644),
    [anon_sym_DASH] = ACTIONS(646),
    [anon_sym_BANG_EQ] = ACTIONS(646),
    [anon_sym_LT_EQ] = ACTIONS(644),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_GT_EQ] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(646),
    [anon_sym_AMP] = ACTIONS(646),
    [anon_sym_PERCENT] = ACTIONS(644),
    [anon_sym_QMARK] = ACTIONS(644),
    [anon_sym_RBRACE] = ACTIONS(644),
    [anon_sym_as] = ACTIONS(644),
    [anon_sym_PIPE_PIPE] = ACTIONS(644),
    [anon_sym_DASH_DASH] = ACTIONS(644),
    [anon_sym_EQ_EQ] = ACTIONS(646),
    [anon_sym_instanceof] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_RPAREN] = ACTIONS(644),
    [anon_sym_SLASH] = ACTIONS(646),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(644),
    [anon_sym_CARET] = ACTIONS(644),
    [anon_sym_STAR_STAR] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_GT_GT] = ACTIONS(646),
    [anon_sym_PLUS_PLUS] = ACTIONS(644),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(644),
    [anon_sym_in] = ACTIONS(646),
  },
  [74] = {
    [aux_sym_template_string_repeat1] = STATE(368),
    [sym_template_substitution] = STATE(368),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(127),
    [sym_escape_sequence] = ACTIONS(648),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [sym__template_chars] = ACTIONS(648),
    [sym_comment] = ACTIONS(3),
  },
  [75] = {
    [sym_identifier] = ACTIONS(652),
    [anon_sym_BQUOTE] = ACTIONS(654),
    [anon_sym_debugger] = ACTIONS(652),
    [anon_sym_symbol] = ACTIONS(652),
    [anon_sym_AT] = ACTIONS(654),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(652),
    [anon_sym_break] = ACTIONS(652),
    [anon_sym_const] = ACTIONS(652),
    [sym_super] = ACTIONS(652),
    [anon_sym_return] = ACTIONS(652),
    [anon_sym_private] = ACTIONS(652),
    [anon_sym_get] = ACTIONS(652),
    [anon_sym_RBRACE] = ACTIONS(654),
    [anon_sym_interface] = ACTIONS(652),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_enum] = ACTIONS(652),
    [anon_sym_delete] = ACTIONS(652),
    [anon_sym_continue] = ACTIONS(652),
    [anon_sym_DASH_DASH] = ACTIONS(654),
    [anon_sym_if] = ACTIONS(652),
    [anon_sym_this] = ACTIONS(652),
    [anon_sym_yield] = ACTIONS(652),
    [sym_true] = ACTIONS(652),
    [anon_sym_throw] = ACTIONS(652),
    [anon_sym_protected] = ACTIONS(652),
    [anon_sym_abstract] = ACTIONS(652),
    [anon_sym_set] = ACTIONS(652),
    [anon_sym_type] = ACTIONS(652),
    [anon_sym_import] = ACTIONS(652),
    [anon_sym_namespace] = ACTIONS(652),
    [anon_sym_PLUS_PLUS] = ACTIONS(654),
    [anon_sym_await] = ACTIONS(652),
    [anon_sym_DQUOTE] = ACTIONS(654),
    [anon_sym_else] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(654),
    [anon_sym_for] = ACTIONS(652),
    [anon_sym_LBRACK] = ACTIONS(654),
    [sym_false] = ACTIONS(652),
    [anon_sym_SEMI] = ACTIONS(654),
    [anon_sym_case] = ACTIONS(652),
    [anon_sym_module] = ACTIONS(652),
    [anon_sym_number] = ACTIONS(652),
    [anon_sym_class] = ACTIONS(652),
    [anon_sym_declare] = ACTIONS(652),
    [anon_sym_typeof] = ACTIONS(652),
    [anon_sym_LBRACE] = ACTIONS(654),
    [anon_sym_switch] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(654),
    [sym_null] = ACTIONS(652),
    [anon_sym_any] = ACTIONS(652),
    [anon_sym_boolean] = ACTIONS(652),
    [anon_sym_async] = ACTIONS(652),
    [anon_sym_public] = ACTIONS(652),
    [anon_sym_var] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(652),
    [anon_sym_SQUOTE] = ACTIONS(654),
    [anon_sym_try] = ACTIONS(652),
    [anon_sym_LT] = ACTIONS(654),
    [sym_number] = ACTIONS(654),
    [anon_sym_SLASH] = ACTIONS(652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(652),
    [anon_sym_function] = ACTIONS(652),
    [sym_undefined] = ACTIONS(652),
    [anon_sym_new] = ACTIONS(652),
    [ts_builtin_sym_end] = ACTIONS(654),
    [anon_sym_let] = ACTIONS(652),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_export] = ACTIONS(652),
    [anon_sym_do] = ACTIONS(652),
    [anon_sym_TILDE] = ACTIONS(654),
    [anon_sym_with] = ACTIONS(652),
  },
  [76] = {
    [sym_new_expression] = STATE(370),
    [sym_augmented_assignment_expression] = STATE(370),
    [sym_unary_expression] = STATE(370),
    [sym_update_expression] = STATE(370),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(370),
    [sym_regex] = STATE(370),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(369),
    [sym__expression] = STATE(370),
    [sym_non_null_expression] = STATE(370),
    [sym_yield_expression] = STATE(370),
    [sym_jsx_fragment] = STATE(370),
    [sym_jsx_element] = STATE(370),
    [sym_as_expression] = STATE(370),
    [sym_internal_module] = STATE(370),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(370),
    [sym_await_expression] = STATE(370),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(370),
    [sym_this] = STATE(370),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(370),
    [sym_generator_function] = STATE(370),
    [sym_call_expression] = STATE(370),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(370),
    [sym_ternary_expression] = STATE(370),
    [sym_binary_expression] = STATE(370),
    [sym_template_string] = STATE(370),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(370),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(370),
    [sym_class] = STATE(370),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(656),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(658),
    [sym_true] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(656),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [77] = {
    [sym_new_expression] = STATE(371),
    [sym_augmented_assignment_expression] = STATE(371),
    [sym_unary_expression] = STATE(371),
    [sym_update_expression] = STATE(371),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(371),
    [sym_regex] = STATE(371),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(371),
    [sym_non_null_expression] = STATE(371),
    [sym_as_expression] = STATE(371),
    [sym_jsx_fragment] = STATE(371),
    [sym_yield_expression] = STATE(371),
    [sym_jsx_element] = STATE(371),
    [sym_internal_module] = STATE(371),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(371),
    [sym_await_expression] = STATE(371),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(371),
    [sym_this] = STATE(371),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(371),
    [sym_generator_function] = STATE(371),
    [sym_call_expression] = STATE(371),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(371),
    [sym_ternary_expression] = STATE(371),
    [sym_binary_expression] = STATE(371),
    [sym_template_string] = STATE(371),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(371),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(371),
    [sym_class] = STATE(371),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(660),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(660),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(662),
    [sym_true] = ACTIONS(660),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(660),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [78] = {
    [sym_identifier] = ACTIONS(664),
    [sym_comment] = ACTIONS(3),
  },
  [79] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_BQUOTE] = ACTIONS(666),
    [sym__automatic_semicolon] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(668),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_LT_LT] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_GT_GT_GT] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_BANG_EQ] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_DASH_DASH] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(668),
    [anon_sym_instanceof] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_RPAREN] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(668),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(668),
    [anon_sym_PLUS_PLUS] = ACTIONS(666),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(666),
    [anon_sym_in] = ACTIONS(668),
  },
  [80] = {
    [anon_sym_LBRACK] = ACTIONS(670),
    [sym_identifier] = ACTIONS(672),
    [anon_sym_module] = ACTIONS(672),
    [anon_sym_symbol] = ACTIONS(672),
    [anon_sym_number] = ACTIONS(672),
    [anon_sym_class] = ACTIONS(672),
    [anon_sym_AT] = ACTIONS(670),
    [anon_sym_declare] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(670),
    [anon_sym_LBRACE] = ACTIONS(670),
    [anon_sym_void] = ACTIONS(672),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_any] = ACTIONS(672),
    [anon_sym_private] = ACTIONS(672),
    [anon_sym_boolean] = ACTIONS(672),
    [anon_sym_static] = ACTIONS(672),
    [anon_sym_async] = ACTIONS(672),
    [anon_sym_get] = ACTIONS(672),
    [anon_sym_public] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(670),
    [anon_sym_SQUOTE] = ACTIONS(670),
    [anon_sym_this] = ACTIONS(672),
    [sym_number] = ACTIONS(670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(672),
    [anon_sym_string] = ACTIONS(672),
    [anon_sym_abstract] = ACTIONS(672),
    [anon_sym_DOT] = ACTIONS(672),
    [anon_sym_set] = ACTIONS(672),
    [anon_sym_type] = ACTIONS(672),
    [anon_sym_import] = ACTIONS(672),
    [anon_sym_export] = ACTIONS(672),
    [anon_sym_namespace] = ACTIONS(672),
    [sym_readonly] = ACTIONS(672),
    [anon_sym_DQUOTE] = ACTIONS(670),
  },
  [81] = {
    [sym_arguments] = STATE(375),
    [anon_sym_LBRACK] = ACTIONS(674),
    [sym_identifier] = ACTIONS(676),
    [anon_sym_module] = ACTIONS(676),
    [anon_sym_symbol] = ACTIONS(676),
    [anon_sym_number] = ACTIONS(676),
    [anon_sym_class] = ACTIONS(676),
    [anon_sym_AT] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(674),
    [anon_sym_LBRACE] = ACTIONS(674),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(676),
    [anon_sym_private] = ACTIONS(676),
    [anon_sym_boolean] = ACTIONS(676),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_public] = ACTIONS(676),
    [anon_sym_get] = ACTIONS(676),
    [anon_sym_this] = ACTIONS(676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(676),
    [anon_sym_string] = ACTIONS(676),
    [anon_sym_DOT] = ACTIONS(680),
    [anon_sym_set] = ACTIONS(676),
    [anon_sym_type] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(676),
    [anon_sym_export] = ACTIONS(676),
    [sym_readonly] = ACTIONS(676),
    [anon_sym_namespace] = ACTIONS(676),
  },
  [82] = {
    [anon_sym_LBRACK] = ACTIONS(674),
    [sym_identifier] = ACTIONS(676),
    [anon_sym_module] = ACTIONS(676),
    [anon_sym_symbol] = ACTIONS(676),
    [anon_sym_number] = ACTIONS(676),
    [anon_sym_class] = ACTIONS(676),
    [anon_sym_AT] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(676),
    [anon_sym_STAR] = ACTIONS(674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(674),
    [anon_sym_LBRACE] = ACTIONS(674),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_any] = ACTIONS(676),
    [anon_sym_private] = ACTIONS(676),
    [anon_sym_boolean] = ACTIONS(676),
    [anon_sym_static] = ACTIONS(676),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_get] = ACTIONS(676),
    [anon_sym_public] = ACTIONS(676),
    [anon_sym_RBRACE] = ACTIONS(674),
    [anon_sym_SQUOTE] = ACTIONS(674),
    [anon_sym_this] = ACTIONS(676),
    [sym_number] = ACTIONS(674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(676),
    [anon_sym_string] = ACTIONS(676),
    [anon_sym_abstract] = ACTIONS(676),
    [anon_sym_set] = ACTIONS(676),
    [anon_sym_type] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(676),
    [anon_sym_export] = ACTIONS(676),
    [anon_sym_namespace] = ACTIONS(676),
    [sym_readonly] = ACTIONS(676),
    [anon_sym_DQUOTE] = ACTIONS(674),
  },
  [83] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [84] = {
    [aux_sym_export_statement_repeat1] = STATE(383),
    [sym__property_name] = STATE(224),
    [sym_object] = STATE(384),
    [sym_decorator] = STATE(383),
    [sym_accessibility_modifier] = STATE(221),
    [sym_assignment_pattern] = STATE(222),
    [sym_computed_property_name] = STATE(224),
    [sym_pair] = STATE(222),
    [sym_array] = STATE(385),
    [sym_spread_element] = STATE(222),
    [sym_string] = STATE(224),
    [sym_method_definition] = STATE(222),
    [aux_sym_object_repeat1] = STATE(220),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_LBRACK] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(686),
    [anon_sym_symbol] = ACTIONS(686),
    [anon_sym_number] = ACTIONS(686),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(686),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_STAR] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_void] = ACTIONS(686),
    [anon_sym_any] = ACTIONS(686),
    [anon_sym_private] = ACTIONS(688),
    [anon_sym_boolean] = ACTIONS(686),
    [anon_sym_static] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(690),
    [anon_sym_get] = ACTIONS(692),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_public] = ACTIONS(688),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [sym_number] = ACTIONS(696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(688),
    [anon_sym_string] = ACTIONS(686),
    [anon_sym_set] = ACTIONS(692),
    [anon_sym_type] = ACTIONS(686),
    [anon_sym_import] = ACTIONS(686),
    [anon_sym_export] = ACTIONS(686),
    [sym_readonly] = ACTIONS(384),
    [anon_sym_namespace] = ACTIONS(686),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [85] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(79),
    [sym_formal_parameters] = STATE(57),
    [sym_call_signature] = STATE(253),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(442),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(444),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(444),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(444),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(444),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_set] = ACTIONS(444),
    [anon_sym_type] = ACTIONS(444),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(444),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(444),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(444),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(444),
    [anon_sym_declare] = ACTIONS(444),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(444),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(444),
    [anon_sym_async] = ACTIONS(444),
    [anon_sym_public] = ACTIONS(444),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(444),
    [anon_sym_function] = ACTIONS(698),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(444),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [86] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(275),
    [sym_identifier] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(474),
    [anon_sym_STAR] = ACTIONS(476),
    [sym_comment] = ACTIONS(3),
  },
  [87] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_SEMI] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(702),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(706),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [88] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [89] = {
    [aux_sym_export_statement_repeat1] = STATE(388),
    [sym_decorator] = STATE(388),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(546),
    [sym_comment] = ACTIONS(3),
  },
  [90] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(702),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(706),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [91] = {
    [sym_identifier] = ACTIONS(709),
    [anon_sym_BQUOTE] = ACTIONS(711),
    [anon_sym_debugger] = ACTIONS(709),
    [anon_sym_symbol] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(711),
    [anon_sym_DASH] = ACTIONS(709),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_break] = ACTIONS(709),
    [anon_sym_const] = ACTIONS(709),
    [sym_super] = ACTIONS(709),
    [anon_sym_return] = ACTIONS(709),
    [anon_sym_private] = ACTIONS(709),
    [anon_sym_get] = ACTIONS(709),
    [anon_sym_RBRACE] = ACTIONS(711),
    [anon_sym_interface] = ACTIONS(709),
    [anon_sym_default] = ACTIONS(709),
    [anon_sym_enum] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_continue] = ACTIONS(709),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_this] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [anon_sym_throw] = ACTIONS(709),
    [anon_sym_protected] = ACTIONS(709),
    [anon_sym_abstract] = ACTIONS(709),
    [anon_sym_set] = ACTIONS(709),
    [anon_sym_type] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(709),
    [anon_sym_namespace] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_await] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_else] = ACTIONS(709),
    [anon_sym_BANG] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [sym_false] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(709),
    [anon_sym_module] = ACTIONS(709),
    [anon_sym_number] = ACTIONS(709),
    [anon_sym_class] = ACTIONS(709),
    [anon_sym_declare] = ACTIONS(709),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_LBRACE] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(711),
    [sym_null] = ACTIONS(709),
    [anon_sym_any] = ACTIONS(709),
    [anon_sym_boolean] = ACTIONS(709),
    [anon_sym_async] = ACTIONS(709),
    [anon_sym_public] = ACTIONS(709),
    [anon_sym_var] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_SQUOTE] = ACTIONS(711),
    [anon_sym_try] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [sym_number] = ACTIONS(711),
    [anon_sym_SLASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(709),
    [anon_sym_function] = ACTIONS(709),
    [sym_undefined] = ACTIONS(709),
    [anon_sym_new] = ACTIONS(709),
    [ts_builtin_sym_end] = ACTIONS(711),
    [anon_sym_let] = ACTIONS(709),
    [anon_sym_PLUS] = ACTIONS(709),
    [anon_sym_export] = ACTIONS(709),
    [anon_sym_do] = ACTIONS(709),
    [anon_sym_TILDE] = ACTIONS(711),
    [anon_sym_with] = ACTIONS(709),
  },
  [92] = {
    [sym__automatic_semicolon] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(713),
  },
  [93] = {
    [sym__initializer] = STATE(391),
    [sym_type_annotation] = STATE(392),
    [sym__automatic_semicolon] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(715),
    [anon_sym_COMMA] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
  },
  [94] = {
    [sym_new_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(394),
    [sym_regex] = STATE(394),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(394),
    [sym_non_null_expression] = STATE(394),
    [sym_as_expression] = STATE(394),
    [sym_jsx_fragment] = STATE(394),
    [sym_yield_expression] = STATE(394),
    [sym_jsx_element] = STATE(394),
    [sym_internal_module] = STATE(394),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(394),
    [sym_await_expression] = STATE(394),
    [sym_member_expression] = STATE(162),
    [sym_spread_element] = STATE(395),
    [sym_string] = STATE(394),
    [sym_this] = STATE(394),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [aux_sym_array_repeat1] = STATE(396),
    [sym_anonymous_class] = STATE(394),
    [sym_generator_function] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_template_string] = STATE(394),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(394),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(394),
    [sym_class] = STATE(394),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(268),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(723),
    [sym_null] = ACTIONS(721),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(725),
    [sym_true] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(721),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [95] = {
    [sym_identifier] = ACTIONS(727),
    [sym_comment] = ACTIONS(3),
  },
  [96] = {
    [aux_sym_export_statement_repeat1] = STATE(404),
    [sym__property_name] = STATE(224),
    [sym_object] = STATE(384),
    [sym_decorator] = STATE(404),
    [sym_accessibility_modifier] = STATE(221),
    [sym_assignment_pattern] = STATE(405),
    [sym_computed_property_name] = STATE(224),
    [sym_pair] = STATE(405),
    [sym_array] = STATE(385),
    [sym_spread_element] = STATE(405),
    [sym_string] = STATE(224),
    [sym_method_definition] = STATE(405),
    [aux_sym_object_repeat1] = STATE(406),
    [sym_identifier] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(731),
    [anon_sym_symbol] = ACTIONS(731),
    [anon_sym_number] = ACTIONS(731),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_STAR] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_void] = ACTIONS(731),
    [anon_sym_any] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(733),
    [anon_sym_boolean] = ACTIONS(731),
    [anon_sym_static] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(735),
    [anon_sym_get] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(739),
    [anon_sym_public] = ACTIONS(733),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [sym_number] = ACTIONS(696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(733),
    [anon_sym_string] = ACTIONS(731),
    [anon_sym_set] = ACTIONS(737),
    [anon_sym_type] = ACTIONS(731),
    [anon_sym_import] = ACTIONS(731),
    [anon_sym_export] = ACTIONS(731),
    [sym_readonly] = ACTIONS(384),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [97] = {
    [aux_sym_variable_declaration_repeat1] = STATE(409),
    [sym__automatic_semicolon] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(741),
    [anon_sym_COMMA] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
  },
  [98] = {
    [sym__initializer] = STATE(411),
    [sym_type_annotation] = STATE(412),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
  },
  [99] = {
    [sym__initializer] = STATE(413),
    [sym_type_annotation] = STATE(414),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
  },
  [100] = {
    [sym_new_expression] = STATE(415),
    [sym_augmented_assignment_expression] = STATE(415),
    [sym_unary_expression] = STATE(415),
    [sym_update_expression] = STATE(415),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(415),
    [sym_regex] = STATE(415),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(415),
    [sym_non_null_expression] = STATE(415),
    [sym_as_expression] = STATE(415),
    [sym_jsx_fragment] = STATE(415),
    [sym_yield_expression] = STATE(415),
    [sym_jsx_element] = STATE(415),
    [sym_internal_module] = STATE(415),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(415),
    [sym_await_expression] = STATE(415),
    [sym_member_expression] = STATE(162),
    [sym_sequence_expression] = STATE(416),
    [sym_string] = STATE(415),
    [sym_this] = STATE(415),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(415),
    [sym_generator_function] = STATE(415),
    [sym_call_expression] = STATE(415),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(415),
    [sym_ternary_expression] = STATE(415),
    [sym_binary_expression] = STATE(415),
    [sym_template_string] = STATE(415),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(415),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(415),
    [sym_class] = STATE(415),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(747),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(749),
    [sym_true] = ACTIONS(747),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(747),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [101] = {
    [sym_union_type] = STATE(432),
    [sym__type] = STATE(432),
    [sym_constructor_type] = STATE(432),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(432),
    [sym_function_type] = STATE(432),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [102] = {
    [sym_new_expression] = STATE(453),
    [sym_augmented_assignment_expression] = STATE(453),
    [sym_unary_expression] = STATE(453),
    [sym_update_expression] = STATE(453),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(453),
    [sym_non_null_expression] = STATE(453),
    [sym_as_expression] = STATE(453),
    [sym_jsx_fragment] = STATE(453),
    [sym_yield_expression] = STATE(453),
    [sym_jsx_element] = STATE(453),
    [sym_internal_module] = STATE(453),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(453),
    [sym_await_expression] = STATE(453),
    [sym_member_expression] = STATE(454),
    [sym_spread_element] = STATE(455),
    [sym_string] = STATE(453),
    [sym_this] = STATE(453),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [aux_sym_array_repeat1] = STATE(457),
    [sym_anonymous_class] = STATE(453),
    [sym_generator_function] = STATE(453),
    [sym_call_expression] = STATE(453),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(453),
    [sym_ternary_expression] = STATE(453),
    [sym_binary_expression] = STATE(453),
    [sym_template_string] = STATE(453),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(453),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(453),
    [sym_class] = STATE(453),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(789),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(797),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(789),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_RPAREN] = ACTIONS(807),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(809),
    [sym_true] = ACTIONS(789),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(789),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [103] = {
    [sym_template_string] = STATE(459),
    [sym_arguments] = STATE(459),
    [anon_sym_LPAREN] = ACTIONS(183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(7),
  },
  [104] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(819),
    [anon_sym_LBRACK] = ACTIONS(819),
    [anon_sym_BANG] = ACTIONS(821),
    [anon_sym_SEMI] = ACTIONS(819),
    [anon_sym_BQUOTE] = ACTIONS(819),
    [sym__automatic_semicolon] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(821),
    [anon_sym_COMMA] = ACTIONS(819),
    [anon_sym_LT_LT] = ACTIONS(819),
    [anon_sym_STAR] = ACTIONS(821),
    [anon_sym_GT_GT_GT] = ACTIONS(819),
    [anon_sym_AMP_AMP] = ACTIONS(819),
    [anon_sym_DASH] = ACTIONS(821),
    [anon_sym_BANG_EQ] = ACTIONS(821),
    [anon_sym_LT_EQ] = ACTIONS(819),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_GT_EQ] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(821),
    [anon_sym_PERCENT] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(819),
    [anon_sym_as] = ACTIONS(819),
    [anon_sym_PIPE_PIPE] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [anon_sym_EQ_EQ] = ACTIONS(821),
    [anon_sym_instanceof] = ACTIONS(819),
    [anon_sym_LT] = ACTIONS(821),
    [anon_sym_RPAREN] = ACTIONS(819),
    [anon_sym_SLASH] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(819),
    [anon_sym_CARET] = ACTIONS(819),
    [anon_sym_STAR_STAR] = ACTIONS(819),
    [anon_sym_PLUS] = ACTIONS(821),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(819),
    [anon_sym_in] = ACTIONS(821),
  },
  [105] = {
    [sym_identifier] = ACTIONS(823),
    [anon_sym_BQUOTE] = ACTIONS(825),
    [anon_sym_debugger] = ACTIONS(823),
    [anon_sym_symbol] = ACTIONS(823),
    [anon_sym_AT] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(823),
    [anon_sym_void] = ACTIONS(823),
    [anon_sym_break] = ACTIONS(823),
    [anon_sym_const] = ACTIONS(823),
    [sym_super] = ACTIONS(823),
    [anon_sym_return] = ACTIONS(823),
    [anon_sym_private] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(823),
    [anon_sym_RBRACE] = ACTIONS(825),
    [anon_sym_interface] = ACTIONS(823),
    [anon_sym_default] = ACTIONS(823),
    [anon_sym_enum] = ACTIONS(823),
    [anon_sym_delete] = ACTIONS(823),
    [anon_sym_continue] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(825),
    [anon_sym_if] = ACTIONS(823),
    [anon_sym_this] = ACTIONS(823),
    [anon_sym_yield] = ACTIONS(823),
    [sym_true] = ACTIONS(823),
    [anon_sym_throw] = ACTIONS(823),
    [anon_sym_protected] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_set] = ACTIONS(823),
    [anon_sym_type] = ACTIONS(823),
    [anon_sym_import] = ACTIONS(823),
    [anon_sym_namespace] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(825),
    [anon_sym_await] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_else] = ACTIONS(823),
    [anon_sym_BANG] = ACTIONS(825),
    [anon_sym_for] = ACTIONS(823),
    [anon_sym_LBRACK] = ACTIONS(825),
    [sym_false] = ACTIONS(823),
    [anon_sym_SEMI] = ACTIONS(825),
    [anon_sym_case] = ACTIONS(823),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_number] = ACTIONS(823),
    [anon_sym_class] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(823),
    [anon_sym_typeof] = ACTIONS(823),
    [anon_sym_LBRACE] = ACTIONS(825),
    [anon_sym_switch] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(825),
    [sym_null] = ACTIONS(823),
    [anon_sym_any] = ACTIONS(823),
    [anon_sym_boolean] = ACTIONS(823),
    [anon_sym_async] = ACTIONS(823),
    [anon_sym_public] = ACTIONS(823),
    [anon_sym_var] = ACTIONS(823),
    [anon_sym_while] = ACTIONS(823),
    [anon_sym_SQUOTE] = ACTIONS(825),
    [anon_sym_try] = ACTIONS(823),
    [anon_sym_LT] = ACTIONS(825),
    [sym_number] = ACTIONS(825),
    [anon_sym_SLASH] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(823),
    [anon_sym_function] = ACTIONS(823),
    [sym_undefined] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(823),
    [ts_builtin_sym_end] = ACTIONS(825),
    [anon_sym_let] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(823),
    [anon_sym_export] = ACTIONS(823),
    [anon_sym_do] = ACTIONS(823),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_with] = ACTIONS(823),
  },
  [106] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym__automatic_semicolon] = ACTIONS(827),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(827),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_PIPE] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(560),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_GT_GT_GT] = ACTIONS(560),
    [anon_sym_AMP_AMP] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(566),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(582),
  },
  [107] = {
    [sym__automatic_semicolon] = ACTIONS(827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(827),
  },
  [108] = {
    [sym_type_parameters] = STATE(462),
    [sym_object_type] = STATE(463),
    [sym_extends_clause] = STATE(464),
    [anon_sym_extends] = ACTIONS(829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(777),
  },
  [109] = {
    [sym_enum_body] = STATE(466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(831),
  },
  [110] = {
    [sym_identifier] = ACTIONS(833),
    [anon_sym_BQUOTE] = ACTIONS(835),
    [anon_sym_debugger] = ACTIONS(833),
    [anon_sym_symbol] = ACTIONS(833),
    [anon_sym_AT] = ACTIONS(835),
    [anon_sym_DASH] = ACTIONS(833),
    [anon_sym_void] = ACTIONS(833),
    [anon_sym_break] = ACTIONS(833),
    [anon_sym_const] = ACTIONS(833),
    [sym_super] = ACTIONS(833),
    [anon_sym_return] = ACTIONS(833),
    [anon_sym_private] = ACTIONS(833),
    [anon_sym_get] = ACTIONS(833),
    [anon_sym_RBRACE] = ACTIONS(835),
    [anon_sym_interface] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(833),
    [anon_sym_enum] = ACTIONS(833),
    [anon_sym_delete] = ACTIONS(833),
    [anon_sym_continue] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(833),
    [anon_sym_this] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(833),
    [sym_true] = ACTIONS(833),
    [anon_sym_throw] = ACTIONS(833),
    [anon_sym_protected] = ACTIONS(833),
    [anon_sym_abstract] = ACTIONS(833),
    [anon_sym_set] = ACTIONS(833),
    [anon_sym_type] = ACTIONS(833),
    [anon_sym_import] = ACTIONS(833),
    [anon_sym_namespace] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(835),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_DQUOTE] = ACTIONS(835),
    [anon_sym_else] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(835),
    [anon_sym_for] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [sym_false] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(833),
    [anon_sym_module] = ACTIONS(833),
    [anon_sym_number] = ACTIONS(833),
    [anon_sym_class] = ACTIONS(833),
    [anon_sym_declare] = ACTIONS(833),
    [anon_sym_typeof] = ACTIONS(833),
    [anon_sym_LBRACE] = ACTIONS(835),
    [anon_sym_switch] = ACTIONS(833),
    [anon_sym_LPAREN] = ACTIONS(835),
    [sym_null] = ACTIONS(833),
    [anon_sym_any] = ACTIONS(833),
    [anon_sym_boolean] = ACTIONS(833),
    [anon_sym_async] = ACTIONS(833),
    [anon_sym_public] = ACTIONS(833),
    [anon_sym_var] = ACTIONS(833),
    [anon_sym_while] = ACTIONS(833),
    [anon_sym_SQUOTE] = ACTIONS(835),
    [anon_sym_try] = ACTIONS(833),
    [anon_sym_LT] = ACTIONS(835),
    [sym_number] = ACTIONS(835),
    [anon_sym_SLASH] = ACTIONS(833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(833),
    [anon_sym_function] = ACTIONS(833),
    [sym_undefined] = ACTIONS(833),
    [anon_sym_new] = ACTIONS(833),
    [ts_builtin_sym_end] = ACTIONS(835),
    [anon_sym_let] = ACTIONS(833),
    [anon_sym_PLUS] = ACTIONS(833),
    [anon_sym_export] = ACTIONS(833),
    [anon_sym_do] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(835),
    [anon_sym_with] = ACTIONS(833),
  },
  [111] = {
    [sym__automatic_semicolon] = ACTIONS(837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(837),
  },
  [112] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_SEMI] = ACTIONS(839),
    [anon_sym_BQUOTE] = ACTIONS(839),
    [sym__automatic_semicolon] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_instanceof] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_in] = ACTIONS(841),
  },
  [113] = {
    [sym_new_expression] = STATE(473),
    [sym_augmented_assignment_expression] = STATE(473),
    [sym_unary_expression] = STATE(473),
    [sym_update_expression] = STATE(473),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(473),
    [sym_regex] = STATE(473),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(473),
    [sym_non_null_expression] = STATE(473),
    [sym_as_expression] = STATE(473),
    [sym_jsx_fragment] = STATE(473),
    [sym_yield_expression] = STATE(473),
    [sym_jsx_element] = STATE(473),
    [sym_internal_module] = STATE(473),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(473),
    [sym_await_expression] = STATE(473),
    [sym_member_expression] = STATE(246),
    [sym_sequence_expression] = STATE(474),
    [sym_string] = STATE(473),
    [sym_this] = STATE(473),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(473),
    [sym_generator_function] = STATE(473),
    [sym_call_expression] = STATE(473),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(473),
    [sym_ternary_expression] = STATE(473),
    [sym_binary_expression] = STATE(473),
    [sym_template_string] = STATE(473),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(473),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(473),
    [sym_class] = STATE(473),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(845),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(853),
    [sym_true] = ACTIONS(845),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(845),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [114] = {
    [sym_type_alias_declaration] = STATE(484),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(484),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(484),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(484),
    [sym_return_statement] = STATE(484),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(484),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(484),
    [sym_switch_statement] = STATE(484),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(484),
    [sym_throw_statement] = STATE(484),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(484),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(484),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(484),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(484),
    [sym_abstract_class] = STATE(484),
    [sym_interface_declaration] = STATE(484),
    [sym_statement_block] = STATE(484),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(484),
    [sym_debugger_statement] = STATE(484),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(484),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(484),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(484),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(484),
    [sym_empty_statement] = STATE(484),
    [sym_import_alias] = STATE(484),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(484),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(484),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(484),
    [sym_break_statement] = STATE(484),
    [sym_labeled_statement] = STATE(484),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(484),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [115] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(871),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(871),
    [anon_sym_PIPE] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(871),
    [anon_sym_LT_LT] = ACTIONS(560),
    [anon_sym_STAR] = ACTIONS(566),
    [anon_sym_GT_GT_GT] = ACTIONS(560),
    [anon_sym_AMP_AMP] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(570),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(554),
    [anon_sym_in] = ACTIONS(125),
  },
  [116] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym__automatic_semicolon] = ACTIONS(873),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(873),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_PIPE] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(560),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_GT_GT_GT] = ACTIONS(560),
    [anon_sym_AMP_AMP] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(566),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(582),
  },
  [117] = {
    [sym__automatic_semicolon] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(873),
  },
  [118] = {
    [sym_identifier] = ACTIONS(875),
    [sym_comment] = ACTIONS(3),
  },
  [119] = {
    [sym_type_parameters] = STATE(489),
    [anon_sym_EQ] = ACTIONS(877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [120] = {
    [anon_sym_EQ] = ACTIONS(879),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_from] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
  },
  [121] = {
    [sym_import_require_clause] = STATE(493),
    [sym_import_clause] = STATE(494),
    [sym_named_imports] = STATE(126),
    [sym_string] = STATE(493),
    [sym_namespace_import] = STATE(126),
    [anon_sym_LBRACE] = ACTIONS(234),
    [sym_identifier] = ACTIONS(885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_STAR] = ACTIONS(887),
    [anon_sym_SQUOTE] = ACTIONS(87),
  },
  [122] = {
    [anon_sym_as] = ACTIONS(889),
    [sym_comment] = ACTIONS(3),
  },
  [123] = {
    [sym__import_export_specifier] = STATE(500),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_typeof] = ACTIONS(895),
    [anon_sym_COMMA] = ACTIONS(897),
    [anon_sym_type] = ACTIONS(895),
    [sym_comment] = ACTIONS(3),
  },
  [124] = {
    [sym__automatic_semicolon] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(899),
  },
  [125] = {
    [sym__from_clause] = STATE(493),
    [anon_sym_from] = ACTIONS(901),
    [sym_comment] = ACTIONS(3),
  },
  [126] = {
    [anon_sym_from] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
  },
  [127] = {
    [sym_statement_block] = STATE(505),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(903),
    [sym_identifier] = ACTIONS(905),
    [sym__automatic_semicolon] = ACTIONS(903),
    [anon_sym_BQUOTE] = ACTIONS(903),
    [anon_sym_debugger] = ACTIONS(905),
    [ts_builtin_sym_end] = ACTIONS(903),
    [anon_sym_symbol] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(905),
    [anon_sym_COMMA] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_STAR] = ACTIONS(905),
    [anon_sym_GT_GT_GT] = ACTIONS(903),
    [anon_sym_void] = ACTIONS(905),
    [anon_sym_break] = ACTIONS(905),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_GT_EQ] = ACTIONS(903),
    [sym_super] = ACTIONS(905),
    [anon_sym_return] = ACTIONS(905),
    [anon_sym_private] = ACTIONS(905),
    [anon_sym_get] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(903),
    [anon_sym_PERCENT] = ACTIONS(903),
    [anon_sym_interface] = ACTIONS(905),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_as] = ACTIONS(905),
    [anon_sym_delete] = ACTIONS(905),
    [anon_sym_continue] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_instanceof] = ACTIONS(905),
    [anon_sym_this] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(905),
    [sym_true] = ACTIONS(905),
    [anon_sym_throw] = ACTIONS(905),
    [anon_sym_enum] = ACTIONS(905),
    [anon_sym_protected] = ACTIONS(905),
    [anon_sym_abstract] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_set] = ACTIONS(905),
    [anon_sym_type] = ACTIONS(905),
    [anon_sym_STAR_STAR] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(905),
    [anon_sym_PIPE_RBRACE] = ACTIONS(903),
    [anon_sym_namespace] = ACTIONS(905),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(903),
    [anon_sym_else] = ACTIONS(905),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(903),
    [sym_false] = ACTIONS(905),
    [anon_sym_SEMI] = ACTIONS(903),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_module] = ACTIONS(905),
    [anon_sym_number] = ACTIONS(905),
    [anon_sym_class] = ACTIONS(905),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeof] = ACTIONS(905),
    [anon_sym_LT_LT] = ACTIONS(903),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(903),
    [anon_sym_switch] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(903),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym_null] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_any] = ACTIONS(905),
    [anon_sym_boolean] = ACTIONS(905),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_public] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(905),
    [anon_sym_var] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_PIPE_PIPE] = ACTIONS(903),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_SQUOTE] = ACTIONS(903),
    [anon_sym_try] = ACTIONS(905),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(903),
    [anon_sym_LT] = ACTIONS(905),
    [sym_number] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [sym_undefined] = ACTIONS(905),
    [anon_sym_new] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(903),
    [anon_sym_let] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_with] = ACTIONS(905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(903),
    [anon_sym_in] = ACTIONS(905),
  },
  [128] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(911),
    [sym_identifier] = ACTIONS(913),
    [sym__automatic_semicolon] = ACTIONS(911),
    [anon_sym_BQUOTE] = ACTIONS(911),
    [anon_sym_debugger] = ACTIONS(913),
    [ts_builtin_sym_end] = ACTIONS(911),
    [anon_sym_symbol] = ACTIONS(913),
    [anon_sym_AT] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_GT_GT_GT] = ACTIONS(911),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_break] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(913),
    [anon_sym_GT_EQ] = ACTIONS(911),
    [sym_super] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(911),
    [anon_sym_PERCENT] = ACTIONS(911),
    [anon_sym_interface] = ACTIONS(913),
    [anon_sym_default] = ACTIONS(913),
    [anon_sym_as] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_continue] = ACTIONS(913),
    [anon_sym_DASH_DASH] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(913),
    [anon_sym_instanceof] = ACTIONS(913),
    [anon_sym_this] = ACTIONS(913),
    [anon_sym_yield] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [anon_sym_throw] = ACTIONS(913),
    [anon_sym_enum] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_abstract] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_STAR_STAR] = ACTIONS(911),
    [anon_sym_import] = ACTIONS(913),
    [anon_sym_PIPE_RBRACE] = ACTIONS(911),
    [anon_sym_namespace] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(911),
    [anon_sym_await] = ACTIONS(913),
    [anon_sym_DQUOTE] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(913),
    [anon_sym_BANG] = ACTIONS(913),
    [anon_sym_for] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(911),
    [sym_false] = ACTIONS(913),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(911),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_switch] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_LPAREN] = ACTIONS(911),
    [sym_null] = ACTIONS(913),
    [anon_sym_GT] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_AMP] = ACTIONS(913),
    [anon_sym_var] = ACTIONS(913),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(911),
    [anon_sym_while] = ACTIONS(913),
    [anon_sym_SQUOTE] = ACTIONS(911),
    [anon_sym_try] = ACTIONS(913),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_RPAREN] = ACTIONS(911),
    [anon_sym_LT] = ACTIONS(913),
    [sym_number] = ACTIONS(911),
    [anon_sym_SLASH] = ACTIONS(913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_function] = ACTIONS(913),
    [sym_undefined] = ACTIONS(913),
    [anon_sym_new] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(911),
    [anon_sym_let] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_GT_GT] = ACTIONS(913),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(913),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(911),
    [anon_sym_in] = ACTIONS(913),
  },
  [129] = {
    [sym_statement_block] = STATE(505),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(903),
    [sym_identifier] = ACTIONS(905),
    [sym__automatic_semicolon] = ACTIONS(903),
    [anon_sym_BQUOTE] = ACTIONS(903),
    [anon_sym_debugger] = ACTIONS(905),
    [ts_builtin_sym_end] = ACTIONS(903),
    [anon_sym_symbol] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(905),
    [anon_sym_COMMA] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_STAR] = ACTIONS(905),
    [anon_sym_GT_GT_GT] = ACTIONS(903),
    [anon_sym_void] = ACTIONS(905),
    [anon_sym_break] = ACTIONS(905),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_const] = ACTIONS(905),
    [anon_sym_GT_EQ] = ACTIONS(903),
    [sym_super] = ACTIONS(905),
    [anon_sym_return] = ACTIONS(905),
    [anon_sym_private] = ACTIONS(905),
    [anon_sym_get] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(903),
    [anon_sym_PERCENT] = ACTIONS(903),
    [anon_sym_interface] = ACTIONS(905),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_as] = ACTIONS(905),
    [anon_sym_delete] = ACTIONS(905),
    [anon_sym_continue] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_instanceof] = ACTIONS(905),
    [anon_sym_this] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(905),
    [sym_true] = ACTIONS(905),
    [anon_sym_throw] = ACTIONS(905),
    [anon_sym_enum] = ACTIONS(905),
    [anon_sym_protected] = ACTIONS(905),
    [anon_sym_abstract] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(905),
    [anon_sym_set] = ACTIONS(905),
    [anon_sym_type] = ACTIONS(905),
    [anon_sym_STAR_STAR] = ACTIONS(903),
    [anon_sym_import] = ACTIONS(905),
    [anon_sym_PIPE_RBRACE] = ACTIONS(903),
    [anon_sym_namespace] = ACTIONS(905),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(903),
    [anon_sym_else] = ACTIONS(905),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(903),
    [sym_false] = ACTIONS(905),
    [anon_sym_SEMI] = ACTIONS(903),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_module] = ACTIONS(905),
    [anon_sym_number] = ACTIONS(905),
    [anon_sym_class] = ACTIONS(905),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeof] = ACTIONS(905),
    [anon_sym_LT_LT] = ACTIONS(903),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(903),
    [anon_sym_switch] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(903),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym_null] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_any] = ACTIONS(905),
    [anon_sym_boolean] = ACTIONS(905),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_public] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(905),
    [anon_sym_var] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_PIPE_PIPE] = ACTIONS(903),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_SQUOTE] = ACTIONS(903),
    [anon_sym_try] = ACTIONS(905),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(903),
    [anon_sym_LT] = ACTIONS(905),
    [sym_number] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [sym_undefined] = ACTIONS(905),
    [anon_sym_new] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(903),
    [anon_sym_let] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_with] = ACTIONS(905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(903),
    [anon_sym_in] = ACTIONS(905),
  },
  [130] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(915),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(560),
    [anon_sym_STAR] = ACTIONS(566),
    [anon_sym_GT_GT_GT] = ACTIONS(560),
    [anon_sym_AMP_AMP] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(570),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(554),
    [anon_sym_in] = ACTIONS(125),
  },
  [131] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(917),
    [sym__automatic_semicolon] = ACTIONS(917),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_BQUOTE] = ACTIONS(917),
    [anon_sym_debugger] = ACTIONS(919),
    [anon_sym_with] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(917),
    [anon_sym_PIPE] = ACTIONS(919),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_DASH] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(919),
    [anon_sym_GT_GT_GT] = ACTIONS(917),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_const] = ACTIONS(919),
    [anon_sym_GT_EQ] = ACTIONS(917),
    [sym_super] = ACTIONS(919),
    [anon_sym_return] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_get] = ACTIONS(919),
    [anon_sym_RBRACE] = ACTIONS(917),
    [anon_sym_PERCENT] = ACTIONS(917),
    [anon_sym_interface] = ACTIONS(919),
    [anon_sym_default] = ACTIONS(919),
    [anon_sym_as] = ACTIONS(919),
    [anon_sym_delete] = ACTIONS(919),
    [anon_sym_continue] = ACTIONS(919),
    [anon_sym_DASH_DASH] = ACTIONS(917),
    [anon_sym_if] = ACTIONS(919),
    [anon_sym_instanceof] = ACTIONS(919),
    [anon_sym_this] = ACTIONS(919),
    [anon_sym_yield] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_enum] = ACTIONS(919),
    [anon_sym_COLON] = ACTIONS(917),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_abstract] = ACTIONS(919),
    [anon_sym_DOT] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(919),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_STAR_STAR] = ACTIONS(917),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_PIPE_RBRACE] = ACTIONS(917),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_PLUS_PLUS] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(917),
    [anon_sym_else] = ACTIONS(919),
    [anon_sym_BANG] = ACTIONS(919),
    [anon_sym_for] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(917),
    [sym_false] = ACTIONS(919),
    [anon_sym_SEMI] = ACTIONS(917),
    [anon_sym_case] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_class] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_typeof] = ACTIONS(919),
    [anon_sym_LT_LT] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_AMP_AMP] = ACTIONS(917),
    [anon_sym_switch] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(917),
    [sym_null] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_async] = ACTIONS(919),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(919),
    [anon_sym_var] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(917),
    [anon_sym_PIPE_PIPE] = ACTIONS(917),
    [anon_sym_while] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(917),
    [anon_sym_try] = ACTIONS(919),
    [anon_sym_EQ_EQ] = ACTIONS(919),
    [anon_sym_RPAREN] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [sym_number] = ACTIONS(917),
    [anon_sym_SLASH] = ACTIONS(919),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(917),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(919),
    [sym_undefined] = ACTIONS(919),
    [anon_sym_CARET] = ACTIONS(917),
    [anon_sym_new] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_let] = ACTIONS(919),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_do] = ACTIONS(919),
    [anon_sym_TILDE] = ACTIONS(917),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(917),
    [anon_sym_in] = ACTIONS(919),
  },
  [132] = {
    [aux_sym_string_repeat1] = STATE(507),
    [sym_escape_sequence] = ACTIONS(921),
    [aux_sym_string_token1] = ACTIONS(921),
    [anon_sym_DQUOTE] = ACTIONS(923),
    [sym_comment] = ACTIONS(246),
  },
  [133] = {
    [anon_sym_LPAREN] = ACTIONS(925),
    [sym_comment] = ACTIONS(3),
  },
  [134] = {
    [sym_new_expression] = STATE(59),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_yield_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_internal_module] = STATE(59),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(59),
    [sym_await_expression] = STATE(59),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(512),
    [sym_variable_declaration] = STATE(512),
    [sym_sequence_expression] = STATE(62),
    [sym_string] = STATE(59),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(512),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(513),
    [sym_anonymous_class] = STATE(59),
    [sym_generator_function] = STATE(59),
    [sym_call_expression] = STATE(59),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(59),
    [sym_ternary_expression] = STATE(59),
    [sym_binary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_lexical_declaration] = STATE(512),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(514),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_identifier] = ACTIONS(927),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(931),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(929),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(15),
  },
  [135] = {
    [aux_sym_string_repeat1] = STATE(516),
    [sym_escape_sequence] = ACTIONS(933),
    [aux_sym_string_token1] = ACTIONS(933),
    [anon_sym_DQUOTE] = ACTIONS(935),
    [sym_comment] = ACTIONS(246),
  },
  [136] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(937),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(937),
    [anon_sym_AMP_EQ] = ACTIONS(937),
    [anon_sym_PLUS_EQ] = ACTIONS(937),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(937),
    [anon_sym_STAR_EQ] = ACTIONS(937),
    [anon_sym_PIPE_EQ] = ACTIONS(937),
    [anon_sym_DASH_EQ] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(937),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(937),
    [anon_sym_GT_GT_EQ] = ACTIONS(937),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(945),
  },
  [137] = {
    [aux_sym_template_string_repeat1] = STATE(524),
    [sym_template_substitution] = STATE(524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(127),
    [sym_escape_sequence] = ACTIONS(947),
    [anon_sym_BQUOTE] = ACTIONS(949),
    [sym__template_chars] = ACTIONS(947),
    [sym_comment] = ACTIONS(3),
  },
  [138] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(951),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_AMP_EQ] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(951),
    [anon_sym_STAR_EQ] = ACTIONS(951),
    [anon_sym_PIPE_EQ] = ACTIONS(951),
    [anon_sym_DASH_EQ] = ACTIONS(951),
    [anon_sym_EQ_GT] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(951),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(951),
    [anon_sym_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [139] = {
    [sym_class_heritage] = STATE(531),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(532),
    [anon_sym_extends] = ACTIONS(316),
    [anon_sym_implements] = ACTIONS(318),
    [sym_identifier] = ACTIONS(957),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(959),
  },
  [140] = {
    [sym_new_expression] = STATE(533),
    [sym_augmented_assignment_expression] = STATE(533),
    [sym_unary_expression] = STATE(533),
    [sym_update_expression] = STATE(533),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(533),
    [sym_regex] = STATE(533),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(533),
    [sym_non_null_expression] = STATE(533),
    [sym_as_expression] = STATE(533),
    [sym_jsx_fragment] = STATE(533),
    [sym_yield_expression] = STATE(533),
    [sym_jsx_element] = STATE(533),
    [sym_internal_module] = STATE(533),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(533),
    [sym_await_expression] = STATE(533),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(533),
    [sym_this] = STATE(533),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(533),
    [sym_generator_function] = STATE(533),
    [sym_call_expression] = STATE(533),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(533),
    [sym_ternary_expression] = STATE(533),
    [sym_binary_expression] = STATE(533),
    [sym_template_string] = STATE(533),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(533),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(533),
    [sym_class] = STATE(533),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(961),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(961),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(963),
    [sym_true] = ACTIONS(961),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(961),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [141] = {
    [sym_new_expression] = STATE(534),
    [sym_augmented_assignment_expression] = STATE(534),
    [sym_unary_expression] = STATE(534),
    [sym_update_expression] = STATE(534),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(534),
    [sym_regex] = STATE(534),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(534),
    [sym_non_null_expression] = STATE(534),
    [sym_as_expression] = STATE(534),
    [sym_jsx_fragment] = STATE(534),
    [sym_yield_expression] = STATE(534),
    [sym_jsx_element] = STATE(534),
    [sym_internal_module] = STATE(534),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(534),
    [sym_await_expression] = STATE(534),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(534),
    [sym_this] = STATE(534),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(534),
    [sym_generator_function] = STATE(534),
    [sym_call_expression] = STATE(534),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(534),
    [sym_ternary_expression] = STATE(534),
    [sym_binary_expression] = STATE(534),
    [sym_template_string] = STATE(534),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(534),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(534),
    [sym_class] = STATE(534),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(965),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(967),
    [sym_true] = ACTIONS(965),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(965),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [142] = {
    [sym_new_expression] = STATE(535),
    [sym_augmented_assignment_expression] = STATE(535),
    [sym_unary_expression] = STATE(535),
    [sym_update_expression] = STATE(535),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(535),
    [sym_regex] = STATE(535),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(535),
    [sym_non_null_expression] = STATE(535),
    [sym_as_expression] = STATE(535),
    [sym_jsx_fragment] = STATE(535),
    [sym_yield_expression] = STATE(535),
    [sym_jsx_element] = STATE(535),
    [sym_internal_module] = STATE(535),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(535),
    [sym_await_expression] = STATE(535),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(535),
    [sym_this] = STATE(535),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(535),
    [sym_generator_function] = STATE(535),
    [sym_call_expression] = STATE(535),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(535),
    [sym_ternary_expression] = STATE(535),
    [sym_binary_expression] = STATE(535),
    [sym_template_string] = STATE(535),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(535),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(535),
    [sym_class] = STATE(535),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(969),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(971),
    [sym_true] = ACTIONS(969),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(969),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [143] = {
    [sym_new_expression] = STATE(536),
    [sym_augmented_assignment_expression] = STATE(536),
    [sym_unary_expression] = STATE(536),
    [sym_update_expression] = STATE(536),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(536),
    [sym_regex] = STATE(536),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(536),
    [sym_non_null_expression] = STATE(536),
    [sym_as_expression] = STATE(536),
    [sym_jsx_fragment] = STATE(536),
    [sym_yield_expression] = STATE(536),
    [sym_jsx_element] = STATE(536),
    [sym_internal_module] = STATE(536),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(536),
    [sym_await_expression] = STATE(536),
    [sym_member_expression] = STATE(162),
    [sym_spread_element] = STATE(537),
    [sym_string] = STATE(536),
    [sym_this] = STATE(536),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(536),
    [sym_generator_function] = STATE(536),
    [sym_call_expression] = STATE(536),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(536),
    [sym_ternary_expression] = STATE(536),
    [sym_binary_expression] = STATE(536),
    [sym_template_string] = STATE(536),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(536),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(536),
    [sym_class] = STATE(536),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(973),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_COMMA] = ACTIONS(975),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(268),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(975),
    [sym_null] = ACTIONS(973),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(977),
    [sym_true] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(973),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [144] = {
    [sym_new_expression] = STATE(533),
    [sym_augmented_assignment_expression] = STATE(533),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(533),
    [sym_update_expression] = STATE(533),
    [sym_regex] = STATE(533),
    [sym_meta_property] = STATE(533),
    [sym_call_signature] = STATE(159),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(533),
    [sym_non_null_expression] = STATE(533),
    [sym_yield_expression] = STATE(533),
    [sym_jsx_fragment] = STATE(533),
    [sym_jsx_element] = STATE(533),
    [sym_as_expression] = STATE(533),
    [sym_internal_module] = STATE(533),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(533),
    [sym_await_expression] = STATE(533),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(533),
    [sym_this] = STATE(533),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(533),
    [sym_generator_function] = STATE(533),
    [sym_call_expression] = STATE(533),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(533),
    [sym_ternary_expression] = STATE(533),
    [sym_binary_expression] = STATE(533),
    [sym_template_string] = STATE(533),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(533),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(533),
    [sym_class] = STATE(533),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(951),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_AMP_EQ] = ACTIONS(951),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(951),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_PIPE_EQ] = ACTIONS(951),
    [anon_sym_DASH_EQ] = ACTIONS(951),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(951),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(290),
    [sym_true] = ACTIONS(961),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(951),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(961),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(135),
    [sym_null] = ACTIONS(961),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_STAR_EQ] = ACTIONS(951),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_EQ_GT] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(951),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(961),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [145] = {
    [sym_new_expression] = STATE(538),
    [sym_augmented_assignment_expression] = STATE(538),
    [sym_unary_expression] = STATE(538),
    [sym_update_expression] = STATE(538),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(538),
    [sym_regex] = STATE(538),
    [sym_type_parameters] = STATE(51),
    [sym_rest_parameter] = STATE(244),
    [sym__expression] = STATE(538),
    [sym_non_null_expression] = STATE(538),
    [sym_yield_expression] = STATE(538),
    [sym_jsx_fragment] = STATE(538),
    [sym_jsx_element] = STATE(538),
    [sym_as_expression] = STATE(538),
    [sym_internal_module] = STATE(538),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(538),
    [sym_await_expression] = STATE(538),
    [sym_member_expression] = STATE(246),
    [sym_accessibility_modifier] = STATE(247),
    [sym_required_parameter] = STATE(244),
    [sym_sequence_expression] = STATE(539),
    [sym_string] = STATE(538),
    [sym_this] = STATE(249),
    [aux_sym_export_statement_repeat1] = STATE(250),
    [sym_object] = STATE(251),
    [sym_anonymous_class] = STATE(538),
    [sym_generator_function] = STATE(538),
    [sym_call_expression] = STATE(538),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(538),
    [sym_ternary_expression] = STATE(538),
    [sym_binary_expression] = STATE(538),
    [sym_template_string] = STATE(538),
    [sym_optional_parameter] = STATE(244),
    [sym_decorator] = STATE(250),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(538),
    [sym_array] = STATE(252),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(538),
    [sym_class] = STATE(538),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
    [sym_identifier] = ACTIONS(408),
    [sym_false] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(412),
    [anon_sym_module] = ACTIONS(414),
    [anon_sym_symbol] = ACTIONS(414),
    [anon_sym_number] = ACTIONS(414),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(414),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(983),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(414),
    [anon_sym_private] = ACTIONS(424),
    [anon_sym_boolean] = ACTIONS(414),
    [anon_sym_async] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(424),
    [anon_sym_get] = ACTIONS(414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_RPAREN] = ACTIONS(428),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(985),
    [sym_true] = ACTIONS(983),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(424),
    [anon_sym_string] = ACTIONS(414),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(983),
    [anon_sym_set] = ACTIONS(414),
    [anon_sym_type] = ACTIONS(414),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(414),
    [anon_sym_export] = ACTIONS(414),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(438),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_TILDE] = ACTIONS(412),
  },
  [146] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_BANG] = ACTIONS(989),
    [anon_sym_SEMI] = ACTIONS(987),
    [anon_sym_BQUOTE] = ACTIONS(987),
    [sym__automatic_semicolon] = ACTIONS(987),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_COMMA] = ACTIONS(987),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_STAR] = ACTIONS(989),
    [anon_sym_GT_GT_GT] = ACTIONS(987),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_AMP_AMP] = ACTIONS(987),
    [anon_sym_DASH] = ACTIONS(989),
    [anon_sym_BANG_EQ] = ACTIONS(989),
    [anon_sym_LT_EQ] = ACTIONS(987),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_GT_EQ] = ACTIONS(987),
    [anon_sym_of] = ACTIONS(987),
    [anon_sym_GT] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(989),
    [anon_sym_PERCENT] = ACTIONS(987),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_RBRACE] = ACTIONS(987),
    [anon_sym_as] = ACTIONS(987),
    [anon_sym_PIPE_PIPE] = ACTIONS(987),
    [anon_sym_DASH_DASH] = ACTIONS(987),
    [anon_sym_EQ_EQ] = ACTIONS(989),
    [anon_sym_instanceof] = ACTIONS(987),
    [anon_sym_LT] = ACTIONS(989),
    [anon_sym_RPAREN] = ACTIONS(987),
    [anon_sym_SLASH] = ACTIONS(989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(987),
    [anon_sym_STAR_STAR] = ACTIONS(987),
    [anon_sym_PLUS] = ACTIONS(989),
    [anon_sym_GT_GT] = ACTIONS(989),
    [anon_sym_PLUS_PLUS] = ACTIONS(987),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(987),
    [anon_sym_in] = ACTIONS(989),
  },
  [147] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [148] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_call_signature] = STATE(543),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(951),
    [anon_sym_symbol] = ACTIONS(995),
    [anon_sym_AMP_EQ] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_void] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(951),
    [anon_sym_private] = ACTIONS(995),
    [anon_sym_PIPE_EQ] = ACTIONS(951),
    [anon_sym_DASH_EQ] = ACTIONS(951),
    [anon_sym_get] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(951),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(995),
    [anon_sym_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(995),
    [anon_sym_type] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(995),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(951),
    [anon_sym_namespace] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(995),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_number] = ACTIONS(995),
    [anon_sym_declare] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(995),
    [anon_sym_STAR_EQ] = ACTIONS(951),
    [anon_sym_boolean] = ACTIONS(995),
    [anon_sym_async] = ACTIONS(995),
    [anon_sym_public] = ACTIONS(995),
    [anon_sym_EQ_GT] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(951),
    [anon_sym_string] = ACTIONS(995),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [149] = {
    [aux_sym_string_repeat2] = STATE(546),
    [sym_escape_sequence] = ACTIONS(999),
    [aux_sym_string_token2] = ACTIONS(999),
    [sym_comment] = ACTIONS(246),
    [anon_sym_SQUOTE] = ACTIONS(935),
  },
  [150] = {
    [sym_new_expression] = STATE(547),
    [sym_augmented_assignment_expression] = STATE(547),
    [sym_unary_expression] = STATE(547),
    [sym_update_expression] = STATE(547),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(547),
    [sym_regex] = STATE(547),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(547),
    [sym_non_null_expression] = STATE(547),
    [sym_as_expression] = STATE(547),
    [sym_jsx_fragment] = STATE(547),
    [sym_yield_expression] = STATE(547),
    [sym_jsx_element] = STATE(547),
    [sym_internal_module] = STATE(547),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(547),
    [sym_await_expression] = STATE(547),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(547),
    [sym_this] = STATE(547),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(547),
    [sym_generator_function] = STATE(547),
    [sym_call_expression] = STATE(547),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(547),
    [sym_ternary_expression] = STATE(547),
    [sym_binary_expression] = STATE(547),
    [sym_template_string] = STATE(547),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(547),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(547),
    [sym_class] = STATE(547),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1001),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1003),
    [sym_true] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1001),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [151] = {
    [sym_nested_identifier] = STATE(551),
    [sym_jsx_namespace_name] = STATE(552),
    [sym_type_parameter] = STATE(269),
    [anon_sym_GT] = ACTIONS(1005),
    [sym_identifier] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1009),
  },
  [152] = {
    [sym_new_expression] = STATE(553),
    [sym_augmented_assignment_expression] = STATE(553),
    [sym_unary_expression] = STATE(553),
    [sym_update_expression] = STATE(553),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(553),
    [sym_regex] = STATE(553),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(553),
    [sym_non_null_expression] = STATE(553),
    [sym_as_expression] = STATE(553),
    [sym_jsx_fragment] = STATE(553),
    [sym_yield_expression] = STATE(553),
    [sym_jsx_element] = STATE(553),
    [sym_internal_module] = STATE(553),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(553),
    [sym_await_expression] = STATE(553),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(553),
    [sym_this] = STATE(553),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(553),
    [sym_generator_function] = STATE(553),
    [sym_call_expression] = STATE(553),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(553),
    [sym_ternary_expression] = STATE(553),
    [sym_binary_expression] = STATE(553),
    [sym_template_string] = STATE(553),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(553),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(553),
    [sym_class] = STATE(553),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(290),
    [sym_true] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(211),
    [sym_null] = ACTIONS(1011),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(1013),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1011),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [153] = {
    [sym_regex_pattern] = ACTIONS(1015),
    [sym_comment] = ACTIONS(246),
  },
  [154] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(207),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [anon_sym_PIPE] = ACTIONS(209),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_LT_LT] = ACTIONS(207),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_GT_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_BANG_EQ] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(207),
    [anon_sym_RBRACK] = ACTIONS(207),
    [anon_sym_GT_EQ] = ACTIONS(207),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(209),
    [anon_sym_PERCENT] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_RBRACE] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(207),
    [anon_sym_DASH_DASH] = ACTIONS(207),
    [anon_sym_EQ_EQ] = ACTIONS(209),
    [anon_sym_instanceof] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_SLASH] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_DOT] = ACTIONS(207),
    [anon_sym_CARET] = ACTIONS(207),
    [anon_sym_STAR_STAR] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_implements] = ACTIONS(207),
    [anon_sym_GT_GT] = ACTIONS(209),
    [anon_sym_PLUS_PLUS] = ACTIONS(207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(209),
  },
  [155] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(557),
    [sym_identifier] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(474),
    [anon_sym_STAR] = ACTIONS(1019),
    [sym_comment] = ACTIONS(3),
  },
  [156] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(1021),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(1025),
    [anon_sym_symbol] = ACTIONS(1025),
    [anon_sym_number] = ACTIONS(1025),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1025),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1025),
    [anon_sym_private] = ACTIONS(1025),
    [anon_sym_boolean] = ACTIONS(1025),
    [anon_sym_async] = ACTIONS(1029),
    [anon_sym_public] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1025),
    [anon_sym_string] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(1025),
    [anon_sym_type] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(1025),
    [anon_sym_export] = ACTIONS(1025),
    [anon_sym_namespace] = ACTIONS(1035),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [157] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(951),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_AMP_EQ] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(951),
    [anon_sym_STAR_EQ] = ACTIONS(951),
    [anon_sym_PIPE_EQ] = ACTIONS(951),
    [anon_sym_DASH_EQ] = ACTIONS(951),
    [anon_sym_EQ_GT] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(951),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(951),
    [anon_sym_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [158] = {
    [sym_new_expression] = STATE(573),
    [sym_augmented_assignment_expression] = STATE(573),
    [sym_unary_expression] = STATE(573),
    [sym_update_expression] = STATE(573),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(573),
    [sym_regex] = STATE(573),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(573),
    [sym_non_null_expression] = STATE(573),
    [sym_as_expression] = STATE(573),
    [sym_jsx_fragment] = STATE(573),
    [sym_yield_expression] = STATE(573),
    [sym_jsx_element] = STATE(573),
    [sym_internal_module] = STATE(573),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(573),
    [sym_await_expression] = STATE(573),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(573),
    [sym_this] = STATE(573),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(573),
    [sym_generator_function] = STATE(573),
    [sym_call_expression] = STATE(573),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(573),
    [sym_ternary_expression] = STATE(573),
    [sym_binary_expression] = STATE(573),
    [sym_template_string] = STATE(573),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(573),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(573),
    [sym_class] = STATE(573),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1039),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1041),
    [sym_true] = ACTIONS(1039),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1039),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [159] = {
    [anon_sym_EQ_GT] = ACTIONS(941),
    [sym_comment] = ACTIONS(3),
  },
  [160] = {
    [sym_template_string] = STATE(542),
    [aux_sym_array_repeat1] = STATE(585),
    [sym_type_arguments] = STATE(541),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(945),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_RBRACK] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [161] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [162] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(937),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(937),
    [anon_sym_AMP_EQ] = ACTIONS(937),
    [anon_sym_PLUS_EQ] = ACTIONS(937),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(937),
    [anon_sym_STAR_EQ] = ACTIONS(937),
    [anon_sym_PIPE_EQ] = ACTIONS(937),
    [anon_sym_DASH_EQ] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(937),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(937),
    [anon_sym_GT_GT_EQ] = ACTIONS(937),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [163] = {
    [aux_sym_array_repeat1] = STATE(585),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_RBRACK] = ACTIONS(1055),
    [sym_comment] = ACTIONS(3),
  },
  [164] = {
    [aux_sym_export_statement_repeat1] = STATE(388),
    [sym_decorator] = STATE(388),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
  },
  [165] = {
    [sym__initializer] = STATE(587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(945),
  },
  [166] = {
    [aux_sym_array_repeat1] = STATE(588),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_RBRACK] = ACTIONS(1055),
    [sym_comment] = ACTIONS(3),
  },
  [167] = {
    [sym__initializer] = STATE(589),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(945),
  },
  [168] = {
    [sym_jsx_closing_element] = STATE(591),
    [sym_jsx_opening_element] = STATE(340),
    [aux_sym_jsx_element_repeat1] = STATE(592),
    [sym_jsx_expression] = STATE(592),
    [sym_jsx_self_closing_element] = STATE(592),
    [sym_jsx_element] = STATE(592),
    [sym_jsx_text] = ACTIONS(1075),
    [anon_sym_LT] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(590),
  },
  [169] = {
    [sym_statement_block] = STATE(594),
    [sym_identifier] = ACTIONS(905),
    [anon_sym_BQUOTE] = ACTIONS(903),
    [anon_sym_debugger] = ACTIONS(905),
    [anon_sym_symbol] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_void] = ACTIONS(905),
    [anon_sym_break] = ACTIONS(905),
    [anon_sym_const] = ACTIONS(905),
    [sym_super] = ACTIONS(905),
    [anon_sym_return] = ACTIONS(905),
    [anon_sym_private] = ACTIONS(905),
    [anon_sym_get] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(903),
    [anon_sym_interface] = ACTIONS(905),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_enum] = ACTIONS(905),
    [anon_sym_delete] = ACTIONS(905),
    [anon_sym_continue] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_this] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(905),
    [sym_true] = ACTIONS(905),
    [anon_sym_throw] = ACTIONS(905),
    [anon_sym_protected] = ACTIONS(905),
    [anon_sym_abstract] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(1079),
    [anon_sym_set] = ACTIONS(905),
    [anon_sym_type] = ACTIONS(905),
    [anon_sym_import] = ACTIONS(905),
    [anon_sym_namespace] = ACTIONS(905),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(903),
    [anon_sym_else] = ACTIONS(905),
    [anon_sym_BANG] = ACTIONS(903),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(903),
    [sym_false] = ACTIONS(905),
    [anon_sym_SEMI] = ACTIONS(903),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_module] = ACTIONS(905),
    [anon_sym_number] = ACTIONS(905),
    [anon_sym_class] = ACTIONS(905),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeof] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_switch] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym_null] = ACTIONS(905),
    [anon_sym_any] = ACTIONS(905),
    [anon_sym_boolean] = ACTIONS(905),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_public] = ACTIONS(905),
    [anon_sym_var] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_SQUOTE] = ACTIONS(903),
    [anon_sym_try] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(903),
    [sym_number] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [sym_undefined] = ACTIONS(905),
    [anon_sym_new] = ACTIONS(905),
    [ts_builtin_sym_end] = ACTIONS(903),
    [anon_sym_let] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_with] = ACTIONS(905),
  },
  [170] = {
    [aux_sym_string_repeat2] = STATE(596),
    [sym_escape_sequence] = ACTIONS(1081),
    [aux_sym_string_token2] = ACTIONS(1081),
    [sym_comment] = ACTIONS(246),
    [anon_sym_SQUOTE] = ACTIONS(1083),
  },
  [171] = {
    [aux_sym_string_repeat1] = STATE(597),
    [sym_escape_sequence] = ACTIONS(1085),
    [aux_sym_string_token1] = ACTIONS(1085),
    [anon_sym_DQUOTE] = ACTIONS(1083),
    [sym_comment] = ACTIONS(246),
  },
  [172] = {
    [sym_identifier] = ACTIONS(1087),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [anon_sym_debugger] = ACTIONS(1087),
    [anon_sym_symbol] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1089),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_void] = ACTIONS(1087),
    [anon_sym_break] = ACTIONS(1087),
    [anon_sym_const] = ACTIONS(1087),
    [sym_super] = ACTIONS(1087),
    [anon_sym_return] = ACTIONS(1087),
    [anon_sym_private] = ACTIONS(1087),
    [anon_sym_get] = ACTIONS(1087),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_interface] = ACTIONS(1087),
    [anon_sym_default] = ACTIONS(1087),
    [anon_sym_enum] = ACTIONS(1087),
    [anon_sym_delete] = ACTIONS(1087),
    [anon_sym_continue] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [anon_sym_if] = ACTIONS(1087),
    [anon_sym_this] = ACTIONS(1087),
    [anon_sym_yield] = ACTIONS(1087),
    [sym_true] = ACTIONS(1087),
    [anon_sym_throw] = ACTIONS(1087),
    [anon_sym_protected] = ACTIONS(1087),
    [anon_sym_abstract] = ACTIONS(1087),
    [anon_sym_set] = ACTIONS(1087),
    [anon_sym_type] = ACTIONS(1087),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_namespace] = ACTIONS(1087),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_await] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [anon_sym_else] = ACTIONS(1087),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_for] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [sym_false] = ACTIONS(1087),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_case] = ACTIONS(1087),
    [anon_sym_module] = ACTIONS(1087),
    [anon_sym_number] = ACTIONS(1087),
    [anon_sym_class] = ACTIONS(1087),
    [anon_sym_declare] = ACTIONS(1087),
    [anon_sym_typeof] = ACTIONS(1087),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_switch] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [sym_null] = ACTIONS(1087),
    [anon_sym_any] = ACTIONS(1087),
    [anon_sym_boolean] = ACTIONS(1087),
    [anon_sym_async] = ACTIONS(1087),
    [anon_sym_public] = ACTIONS(1087),
    [anon_sym_var] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1087),
    [anon_sym_SQUOTE] = ACTIONS(1089),
    [anon_sym_try] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1089),
    [sym_number] = ACTIONS(1089),
    [anon_sym_SLASH] = ACTIONS(1087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1087),
    [anon_sym_function] = ACTIONS(1087),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_new] = ACTIONS(1087),
    [ts_builtin_sym_end] = ACTIONS(1089),
    [anon_sym_let] = ACTIONS(1087),
    [anon_sym_PLUS] = ACTIONS(1087),
    [anon_sym_export] = ACTIONS(1087),
    [anon_sym_do] = ACTIONS(1087),
    [anon_sym_TILDE] = ACTIONS(1089),
    [anon_sym_with] = ACTIONS(1087),
  },
  [173] = {
    [sym_statement_block] = STATE(594),
    [sym_identifier] = ACTIONS(905),
    [anon_sym_BQUOTE] = ACTIONS(903),
    [anon_sym_debugger] = ACTIONS(905),
    [anon_sym_symbol] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_void] = ACTIONS(905),
    [anon_sym_break] = ACTIONS(905),
    [anon_sym_const] = ACTIONS(905),
    [sym_super] = ACTIONS(905),
    [anon_sym_return] = ACTIONS(905),
    [anon_sym_private] = ACTIONS(905),
    [anon_sym_get] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(903),
    [anon_sym_interface] = ACTIONS(905),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_enum] = ACTIONS(905),
    [anon_sym_delete] = ACTIONS(905),
    [anon_sym_continue] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_this] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(905),
    [sym_true] = ACTIONS(905),
    [anon_sym_throw] = ACTIONS(905),
    [anon_sym_protected] = ACTIONS(905),
    [anon_sym_abstract] = ACTIONS(905),
    [anon_sym_set] = ACTIONS(905),
    [anon_sym_type] = ACTIONS(905),
    [anon_sym_import] = ACTIONS(905),
    [anon_sym_namespace] = ACTIONS(905),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_await] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(903),
    [anon_sym_else] = ACTIONS(905),
    [anon_sym_BANG] = ACTIONS(903),
    [anon_sym_for] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(903),
    [sym_false] = ACTIONS(905),
    [anon_sym_SEMI] = ACTIONS(903),
    [anon_sym_case] = ACTIONS(905),
    [anon_sym_module] = ACTIONS(905),
    [anon_sym_number] = ACTIONS(905),
    [anon_sym_class] = ACTIONS(905),
    [anon_sym_declare] = ACTIONS(905),
    [anon_sym_typeof] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_switch] = ACTIONS(905),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym_null] = ACTIONS(905),
    [anon_sym_any] = ACTIONS(905),
    [anon_sym_boolean] = ACTIONS(905),
    [anon_sym_async] = ACTIONS(905),
    [anon_sym_public] = ACTIONS(905),
    [anon_sym_var] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_SQUOTE] = ACTIONS(903),
    [anon_sym_try] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(903),
    [sym_number] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(905),
    [sym_undefined] = ACTIONS(905),
    [anon_sym_new] = ACTIONS(905),
    [ts_builtin_sym_end] = ACTIONS(903),
    [anon_sym_let] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_export] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_TILDE] = ACTIONS(903),
    [anon_sym_with] = ACTIONS(905),
  },
  [174] = {
    [sym_new_expression] = STATE(611),
    [sym_augmented_assignment_expression] = STATE(611),
    [sym_unary_expression] = STATE(611),
    [sym_update_expression] = STATE(611),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(611),
    [sym_regex] = STATE(611),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(611),
    [sym_non_null_expression] = STATE(611),
    [sym_as_expression] = STATE(611),
    [sym_jsx_fragment] = STATE(611),
    [sym_yield_expression] = STATE(611),
    [sym_jsx_element] = STATE(611),
    [sym_internal_module] = STATE(611),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(611),
    [sym_await_expression] = STATE(611),
    [sym_member_expression] = STATE(612),
    [sym_generic_type] = STATE(616),
    [sym_string] = STATE(611),
    [sym_this] = STATE(611),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_nested_type_identifier] = STATE(614),
    [sym_anonymous_class] = STATE(611),
    [sym_generator_function] = STATE(611),
    [sym_call_expression] = STATE(611),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(611),
    [sym_ternary_expression] = STATE(611),
    [sym_binary_expression] = STATE(611),
    [sym_template_string] = STATE(611),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(611),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(611),
    [sym__type_reference] = STATE(616),
    [sym_class] = STATE(611),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1093),
    [sym_false] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1095),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1109),
    [sym_true] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [175] = {
    [sym_union_type] = STATE(622),
    [sym__type] = STATE(622),
    [sym_constructor_type] = STATE(622),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(623),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(622),
    [sym_function_type] = STATE(622),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(624),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1121),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [176] = {
    [sym_class_heritage] = STATE(625),
    [sym_type_parameters] = STATE(626),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(627),
    [anon_sym_extends] = ACTIONS(1131),
    [anon_sym_implements] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(322),
  },
  [177] = {
    [sym_public_field_definition] = STATE(640),
    [sym__property_name] = STATE(641),
    [sym_decorator] = STATE(643),
    [sym_method_signature] = STATE(640),
    [sym_accessibility_modifier] = STATE(642),
    [sym_abstract_method_signature] = STATE(640),
    [sym_computed_property_name] = STATE(641),
    [aux_sym_class_body_repeat1] = STATE(643),
    [sym_index_signature] = STATE(640),
    [sym_string] = STATE(641),
    [sym_method_definition] = STATE(644),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1145),
    [anon_sym_get] = ACTIONS(1147),
    [anon_sym_RBRACE] = ACTIONS(1149),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [sym_number] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [178] = {
    [sym_class_body] = STATE(645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(322),
  },
  [179] = {
    [sym_implements_clause] = STATE(646),
    [anon_sym_implements] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1161),
  },
  [180] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1161),
  },
  [181] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym_BQUOTE] = ACTIONS(1163),
    [sym__automatic_semicolon] = ACTIONS(1163),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_COMMA] = ACTIONS(1163),
    [anon_sym_LT_LT] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_GT_GT_GT] = ACTIONS(1163),
    [anon_sym_AMP_AMP] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_BANG_EQ] = ACTIONS(1165),
    [anon_sym_LT_EQ] = ACTIONS(1163),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_GT_EQ] = ACTIONS(1163),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_QMARK] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_as] = ACTIONS(1163),
    [anon_sym_PIPE_PIPE] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1163),
    [anon_sym_EQ_EQ] = ACTIONS(1165),
    [anon_sym_instanceof] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_RPAREN] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_CARET] = ACTIONS(1163),
    [anon_sym_STAR_STAR] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_GT_GT] = ACTIONS(1165),
    [anon_sym_PLUS_PLUS] = ACTIONS(1163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1163),
    [anon_sym_in] = ACTIONS(1165),
  },
  [182] = {
    [sym_string] = STATE(173),
    [sym_nested_identifier] = STATE(169),
    [sym__module] = STATE(172),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(312),
  },
  [183] = {
    [sym_identifier] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
  },
  [184] = {
    [sym_type_alias_declaration] = STATE(193),
    [aux_sym_export_statement_repeat1] = STATE(192),
    [sym__declaration] = STATE(193),
    [sym_ambient_declaration] = STATE(193),
    [sym_import_alias] = STATE(193),
    [sym_export_statement] = STATE(193),
    [sym_generator_function] = STATE(193),
    [sym_lexical_declaration] = STATE(193),
    [sym_internal_module] = STATE(193),
    [sym_decorator] = STATE(192),
    [sym_enum_declaration] = STATE(193),
    [sym_function] = STATE(193),
    [sym_function_signature] = STATE(193),
    [sym_variable_declaration] = STATE(193),
    [sym_abstract_class] = STATE(193),
    [sym_module] = STATE(193),
    [sym_interface_declaration] = STATE(193),
    [sym_class] = STATE(193),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(340),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(344),
    [anon_sym_global] = ACTIONS(324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(354),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(346),
  },
  [185] = {
    [sym_statement_block] = STATE(649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [186] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(1173),
  },
  [187] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(653),
    [sym_identifier] = ACTIONS(1175),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(474),
    [anon_sym_STAR] = ACTIONS(1177),
    [sym_comment] = ACTIONS(3),
  },
  [188] = {
    [sym_identifier] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
  },
  [189] = {
    [sym_identifier] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
  },
  [190] = {
    [sym_type_alias_declaration] = STATE(300),
    [aux_sym_export_statement_repeat1] = STATE(192),
    [sym__declaration] = STATE(300),
    [sym_ambient_declaration] = STATE(300),
    [sym_import_alias] = STATE(300),
    [sym_export_statement] = STATE(300),
    [sym_generator_function] = STATE(300),
    [sym_export_clause] = STATE(301),
    [sym_lexical_declaration] = STATE(300),
    [sym_internal_module] = STATE(300),
    [sym_decorator] = STATE(192),
    [sym_enum_declaration] = STATE(300),
    [sym_function] = STATE(300),
    [sym_function_signature] = STATE(300),
    [sym_variable_declaration] = STATE(300),
    [sym_abstract_class] = STATE(300),
    [sym_module] = STATE(300),
    [sym_interface_declaration] = STATE(300),
    [sym_class] = STATE(300),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_as] = ACTIONS(1183),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(344),
    [anon_sym_STAR] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_EQ] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(354),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(346),
  },
  [191] = {
    [sym_string] = STATE(173),
    [sym_nested_identifier] = STATE(169),
    [sym__module] = STATE(656),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(312),
  },
  [192] = {
    [aux_sym_export_statement_repeat1] = STATE(320),
    [sym_decorator] = STATE(320),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(544),
    [anon_sym_class] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
  },
  [193] = {
    [sym_identifier] = ACTIONS(1191),
    [anon_sym_BQUOTE] = ACTIONS(1193),
    [anon_sym_debugger] = ACTIONS(1191),
    [anon_sym_symbol] = ACTIONS(1191),
    [anon_sym_AT] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_void] = ACTIONS(1191),
    [anon_sym_break] = ACTIONS(1191),
    [anon_sym_const] = ACTIONS(1191),
    [sym_super] = ACTIONS(1191),
    [anon_sym_return] = ACTIONS(1191),
    [anon_sym_private] = ACTIONS(1191),
    [anon_sym_get] = ACTIONS(1191),
    [anon_sym_RBRACE] = ACTIONS(1193),
    [anon_sym_interface] = ACTIONS(1191),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_enum] = ACTIONS(1191),
    [anon_sym_delete] = ACTIONS(1191),
    [anon_sym_continue] = ACTIONS(1191),
    [anon_sym_DASH_DASH] = ACTIONS(1193),
    [anon_sym_if] = ACTIONS(1191),
    [anon_sym_this] = ACTIONS(1191),
    [anon_sym_yield] = ACTIONS(1191),
    [sym_true] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1191),
    [anon_sym_protected] = ACTIONS(1191),
    [anon_sym_abstract] = ACTIONS(1191),
    [anon_sym_set] = ACTIONS(1191),
    [anon_sym_type] = ACTIONS(1191),
    [anon_sym_import] = ACTIONS(1191),
    [anon_sym_namespace] = ACTIONS(1191),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DQUOTE] = ACTIONS(1193),
    [anon_sym_else] = ACTIONS(1191),
    [anon_sym_BANG] = ACTIONS(1193),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_LBRACK] = ACTIONS(1193),
    [sym_false] = ACTIONS(1191),
    [anon_sym_SEMI] = ACTIONS(1193),
    [anon_sym_case] = ACTIONS(1191),
    [anon_sym_module] = ACTIONS(1191),
    [anon_sym_number] = ACTIONS(1191),
    [anon_sym_class] = ACTIONS(1191),
    [anon_sym_declare] = ACTIONS(1191),
    [anon_sym_typeof] = ACTIONS(1191),
    [anon_sym_LBRACE] = ACTIONS(1193),
    [anon_sym_switch] = ACTIONS(1191),
    [anon_sym_LPAREN] = ACTIONS(1193),
    [sym_null] = ACTIONS(1191),
    [anon_sym_any] = ACTIONS(1191),
    [anon_sym_boolean] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1191),
    [anon_sym_public] = ACTIONS(1191),
    [anon_sym_var] = ACTIONS(1191),
    [anon_sym_while] = ACTIONS(1191),
    [anon_sym_SQUOTE] = ACTIONS(1193),
    [anon_sym_try] = ACTIONS(1191),
    [anon_sym_LT] = ACTIONS(1193),
    [sym_number] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1191),
    [anon_sym_function] = ACTIONS(1191),
    [sym_undefined] = ACTIONS(1191),
    [anon_sym_new] = ACTIONS(1191),
    [ts_builtin_sym_end] = ACTIONS(1193),
    [anon_sym_let] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_export] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(1191),
    [anon_sym_TILDE] = ACTIONS(1193),
    [anon_sym_with] = ACTIONS(1191),
  },
  [194] = {
    [sym__initializer] = STATE(661),
    [aux_sym_object_repeat1] = STATE(662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(1197),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(1197),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(1202),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1205),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [195] = {
    [sym__initializer] = STATE(79),
    [aux_sym_object_repeat1] = STATE(662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [196] = {
    [sym__identifier_reference] = STATE(663),
    [sym_decorator_member_expression] = STATE(663),
    [sym_decorator_call_expression] = STATE(82),
    [anon_sym_get] = ACTIONS(145),
    [sym_identifier] = ACTIONS(1216),
    [anon_sym_module] = ACTIONS(145),
    [anon_sym_symbol] = ACTIONS(145),
    [anon_sym_number] = ACTIONS(145),
    [anon_sym_declare] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_protected] = ACTIONS(145),
    [anon_sym_string] = ACTIONS(145),
    [anon_sym_set] = ACTIONS(145),
    [anon_sym_type] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_namespace] = ACTIONS(145),
    [anon_sym_any] = ACTIONS(145),
    [anon_sym_private] = ACTIONS(145),
    [anon_sym_boolean] = ACTIONS(145),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(145),
  },
  [197] = {
    [aux_sym_export_statement_repeat1] = STATE(669),
    [sym__property_name] = STATE(224),
    [sym_object] = STATE(384),
    [sym_decorator] = STATE(669),
    [sym_accessibility_modifier] = STATE(221),
    [sym_assignment_pattern] = STATE(670),
    [sym_computed_property_name] = STATE(224),
    [sym_pair] = STATE(670),
    [sym_array] = STATE(385),
    [sym_spread_element] = STATE(670),
    [sym_string] = STATE(224),
    [sym_method_definition] = STATE(670),
    [sym_identifier] = ACTIONS(1218),
    [anon_sym_LBRACK] = ACTIONS(684),
    [anon_sym_module] = ACTIONS(1220),
    [anon_sym_symbol] = ACTIONS(1220),
    [anon_sym_number] = ACTIONS(1220),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(364),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_void] = ACTIONS(1220),
    [anon_sym_any] = ACTIONS(1220),
    [anon_sym_private] = ACTIONS(1224),
    [anon_sym_boolean] = ACTIONS(1220),
    [anon_sym_static] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(1226),
    [anon_sym_get] = ACTIONS(1228),
    [anon_sym_RBRACE] = ACTIONS(1222),
    [anon_sym_public] = ACTIONS(1224),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [sym_number] = ACTIONS(696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1224),
    [anon_sym_string] = ACTIONS(1220),
    [anon_sym_set] = ACTIONS(1228),
    [anon_sym_type] = ACTIONS(1220),
    [anon_sym_import] = ACTIONS(1220),
    [anon_sym_export] = ACTIONS(1220),
    [sym_readonly] = ACTIONS(384),
    [anon_sym_namespace] = ACTIONS(1220),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [198] = {
    [sym_string] = STATE(673),
    [sym__property_name] = STATE(673),
    [sym_computed_property_name] = STATE(673),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(1234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [199] = {
    [sym_new_expression] = STATE(90),
    [sym_augmented_assignment_expression] = STATE(90),
    [sym__initializer] = STATE(79),
    [sym_unary_expression] = STATE(90),
    [sym_update_expression] = STATE(90),
    [sym_regex] = STATE(90),
    [sym_meta_property] = STATE(90),
    [sym_call_signature] = STATE(58),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(90),
    [sym_non_null_expression] = STATE(90),
    [sym_yield_expression] = STATE(90),
    [sym_jsx_fragment] = STATE(90),
    [sym_jsx_element] = STATE(90),
    [sym_as_expression] = STATE(90),
    [sym_internal_module] = STATE(90),
    [aux_sym_object_repeat1] = STATE(662),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(90),
    [sym_await_expression] = STATE(90),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(90),
    [sym_this] = STATE(90),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(90),
    [sym_generator_function] = STATE(90),
    [sym_call_expression] = STATE(90),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(90),
    [sym_ternary_expression] = STATE(90),
    [sym_binary_expression] = STATE(90),
    [sym_template_string] = STATE(90),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(90),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(90),
    [sym_class] = STATE(90),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(161),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [200] = {
    [sym__initializer] = STATE(79),
    [aux_sym_object_repeat1] = STATE(662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1236),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(1236),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(1236),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(1236),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(1236),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(1236),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1236),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1236),
    [anon_sym_type] = ACTIONS(1236),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1236),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [sym_readonly] = ACTIONS(1236),
    [anon_sym_DQUOTE] = ACTIONS(1238),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1238),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1236),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1236),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1236),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(1236),
    [anon_sym_async] = ACTIONS(1236),
    [anon_sym_public] = ACTIONS(1236),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1211),
    [sym_number] = ACTIONS(1238),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(1236),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1236),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [201] = {
    [sym_string] = STATE(673),
    [sym__property_name] = STATE(673),
    [sym_computed_property_name] = STATE(673),
    [anon_sym_get] = ACTIONS(1240),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_async] = ACTIONS(1242),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(1234),
    [anon_sym_STAR] = ACTIONS(1244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1240),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [sym_readonly] = ACTIONS(1246),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [202] = {
    [sym__property_name] = STATE(673),
    [sym_string] = STATE(673),
    [sym__initializer] = STATE(79),
    [aux_sym_object_repeat1] = STATE(662),
    [sym_computed_property_name] = STATE(673),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1211),
    [sym_number] = ACTIONS(1234),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [203] = {
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1251),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1251),
    [anon_sym_BQUOTE] = ACTIONS(1251),
    [anon_sym_debugger] = ACTIONS(1253),
    [sym__automatic_semicolon] = ACTIONS(1251),
    [anon_sym_symbol] = ACTIONS(1253),
    [anon_sym_AT] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_COMMA] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_GT_GT_GT] = ACTIONS(1251),
    [anon_sym_EQ] = ACTIONS(1257),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_break] = ACTIONS(1253),
    [anon_sym_BANG_EQ] = ACTIONS(1257),
    [anon_sym_const] = ACTIONS(1253),
    [anon_sym_GT_EQ] = ACTIONS(1251),
    [sym_super] = ACTIONS(1253),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_private] = ACTIONS(1253),
    [anon_sym_get] = ACTIONS(1253),
    [anon_sym_RBRACE] = ACTIONS(1255),
    [anon_sym_PERCENT] = ACTIONS(1251),
    [anon_sym_interface] = ACTIONS(1253),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_enum] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_continue] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1251),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_as] = ACTIONS(1257),
    [anon_sym_this] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1253),
    [sym_true] = ACTIONS(1253),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_instanceof] = ACTIONS(1257),
    [anon_sym_protected] = ACTIONS(1253),
    [anon_sym_abstract] = ACTIONS(1253),
    [anon_sym_DOT] = ACTIONS(1257),
    [anon_sym_set] = ACTIONS(1253),
    [anon_sym_type] = ACTIONS(1253),
    [anon_sym_STAR_STAR] = ACTIONS(1251),
    [anon_sym_import] = ACTIONS(1253),
    [anon_sym_namespace] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1251),
    [anon_sym_await] = ACTIONS(1253),
    [anon_sym_DQUOTE] = ACTIONS(1255),
    [anon_sym_else] = ACTIONS(1253),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_for] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(1251),
    [sym_false] = ACTIONS(1253),
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym_case] = ACTIONS(1253),
    [anon_sym_module] = ACTIONS(1253),
    [anon_sym_number] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1253),
    [anon_sym_declare] = ACTIONS(1253),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_LT_LT] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(1255),
    [anon_sym_AMP_AMP] = ACTIONS(1251),
    [anon_sym_switch] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1251),
    [anon_sym_LPAREN] = ACTIONS(1251),
    [sym_null] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1257),
    [anon_sym_any] = ACTIONS(1253),
    [anon_sym_boolean] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_public] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1257),
    [anon_sym_var] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1251),
    [anon_sym_PIPE_PIPE] = ACTIONS(1251),
    [anon_sym_while] = ACTIONS(1253),
    [anon_sym_SQUOTE] = ACTIONS(1255),
    [anon_sym_try] = ACTIONS(1253),
    [anon_sym_EQ_EQ] = ACTIONS(1257),
    [anon_sym_LT] = ACTIONS(1257),
    [sym_number] = ACTIONS(1255),
    [anon_sym_SLASH] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1253),
    [sym_undefined] = ACTIONS(1253),
    [anon_sym_new] = ACTIONS(1253),
    [ts_builtin_sym_end] = ACTIONS(1255),
    [anon_sym_let] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_export] = ACTIONS(1253),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_do] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_with] = ACTIONS(1253),
    [anon_sym_CARET] = ACTIONS(1251),
    [anon_sym_in] = ACTIONS(1257),
  },
  [204] = {
    [sym_parenthesized_expression] = STATE(678),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [205] = {
    [sym__initializer] = STATE(79),
    [aux_sym_object_repeat1] = STATE(662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [206] = {
    [sym_import_require_clause] = STATE(124),
    [sym_import_clause] = STATE(125),
    [sym_named_imports] = STATE(126),
    [sym_string] = STATE(124),
    [sym__initializer] = STATE(79),
    [aux_sym_object_repeat1] = STATE(662),
    [sym_namespace_import] = STATE(126),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(232),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_typeof] = ACTIONS(232),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(234),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [207] = {
    [sym_nested_identifier] = STATE(127),
    [sym__module] = STATE(128),
    [sym_string] = STATE(129),
    [sym__initializer] = STATE(79),
    [aux_sym_object_repeat1] = STATE(662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [208] = {
    [sym_string] = STATE(673),
    [sym__property_name] = STATE(673),
    [sym_computed_property_name] = STATE(673),
    [anon_sym_get] = ACTIONS(1240),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(1234),
    [anon_sym_STAR] = ACTIONS(1244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1240),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1242),
  },
  [209] = {
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
  },
  [210] = {
    [sym_new_expression] = STATE(681),
    [sym_augmented_assignment_expression] = STATE(681),
    [sym_unary_expression] = STATE(681),
    [sym_update_expression] = STATE(681),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(681),
    [sym_regex] = STATE(681),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(681),
    [sym_non_null_expression] = STATE(681),
    [sym_as_expression] = STATE(681),
    [sym_jsx_fragment] = STATE(681),
    [sym_yield_expression] = STATE(681),
    [sym_jsx_element] = STATE(681),
    [sym_internal_module] = STATE(681),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(681),
    [sym_await_expression] = STATE(681),
    [sym_member_expression] = STATE(162),
    [sym_spread_element] = STATE(163),
    [sym_string] = STATE(681),
    [sym_this] = STATE(681),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [aux_sym_array_repeat1] = STATE(166),
    [sym_anonymous_class] = STATE(681),
    [sym_generator_function] = STATE(681),
    [sym_call_expression] = STATE(681),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(681),
    [sym_ternary_expression] = STATE(681),
    [sym_binary_expression] = STATE(681),
    [sym_template_string] = STATE(681),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(681),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(681),
    [sym_class] = STATE(681),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(1263),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(268),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(276),
    [sym_null] = ACTIONS(1263),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1265),
    [sym_true] = ACTIONS(1263),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1263),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [211] = {
    [sym_nested_identifier] = STATE(169),
    [sym__module] = STATE(172),
    [sym_string] = STATE(173),
    [sym__initializer] = STATE(79),
    [aux_sym_object_repeat1] = STATE(662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(310),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [212] = {
    [sym_type_alias_declaration] = STATE(193),
    [aux_sym_export_statement_repeat1] = STATE(685),
    [sym__declaration] = STATE(193),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(193),
    [sym_import_alias] = STATE(193),
    [sym_export_statement] = STATE(193),
    [sym_generator_function] = STATE(193),
    [aux_sym_object_repeat1] = STATE(662),
    [sym_lexical_declaration] = STATE(193),
    [sym_internal_module] = STATE(193),
    [sym_decorator] = STATE(685),
    [sym_enum_declaration] = STATE(193),
    [sym_function] = STATE(193),
    [sym_function_signature] = STATE(193),
    [sym_variable_declaration] = STATE(193),
    [sym_abstract_class] = STATE(193),
    [sym_module] = STATE(193),
    [sym_interface_declaration] = STATE(193),
    [sym_class] = STATE(193),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(324),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1267),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_declare] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [213] = {
    [sym_new_expression] = STATE(686),
    [sym_augmented_assignment_expression] = STATE(686),
    [sym_unary_expression] = STATE(686),
    [sym_update_expression] = STATE(686),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(686),
    [sym_regex] = STATE(686),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(686),
    [sym_non_null_expression] = STATE(686),
    [sym_as_expression] = STATE(686),
    [sym_jsx_fragment] = STATE(686),
    [sym_yield_expression] = STATE(686),
    [sym_jsx_element] = STATE(686),
    [sym_internal_module] = STATE(686),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(686),
    [sym_await_expression] = STATE(686),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(686),
    [sym_this] = STATE(686),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(686),
    [sym_generator_function] = STATE(686),
    [sym_call_expression] = STATE(686),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(686),
    [sym_ternary_expression] = STATE(686),
    [sym_binary_expression] = STATE(686),
    [sym_template_string] = STATE(686),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(686),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(686),
    [sym_class] = STATE(686),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1273),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1275),
    [sym_true] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1273),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [214] = {
    [sym__property_name] = STATE(673),
    [sym__initializer] = STATE(79),
    [sym_formal_parameters] = STATE(57),
    [sym_computed_property_name] = STATE(673),
    [sym_type_parameters] = STATE(51),
    [sym_call_signature] = STATE(253),
    [sym_string] = STATE(673),
    [aux_sym_object_repeat1] = STATE(662),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1277),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(1279),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(1281),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(1279),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(1279),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(1284),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1279),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1284),
    [anon_sym_type] = ACTIONS(1279),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1279),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1279),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1279),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(1279),
    [anon_sym_declare] = ACTIONS(1279),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1286),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1279),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(1279),
    [anon_sym_async] = ACTIONS(1279),
    [anon_sym_public] = ACTIONS(1279),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1290),
    [sym_number] = ACTIONS(1234),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(1279),
    [anon_sym_function] = ACTIONS(452),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1279),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [215] = {
    [sym_parenthesized_expression] = STATE(690),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [216] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(1294),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(1294),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(1297),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1300),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [217] = {
    [sym_type_alias_declaration] = STATE(300),
    [aux_sym_export_statement_repeat1] = STATE(685),
    [sym__declaration] = STATE(300),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(300),
    [sym_import_alias] = STATE(300),
    [sym_export_statement] = STATE(300),
    [sym_generator_function] = STATE(300),
    [sym_export_clause] = STATE(301),
    [aux_sym_object_repeat1] = STATE(662),
    [sym_lexical_declaration] = STATE(300),
    [sym_internal_module] = STATE(300),
    [sym_decorator] = STATE(685),
    [sym_enum_declaration] = STATE(300),
    [sym_function] = STATE(300),
    [sym_function_signature] = STATE(300),
    [sym_variable_declaration] = STATE(300),
    [sym_abstract_class] = STATE(300),
    [sym_module] = STATE(300),
    [sym_interface_declaration] = STATE(300),
    [sym_class] = STATE(300),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(508),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(511),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_as] = ACTIONS(515),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_declare] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [218] = {
    [sym_parenthesized_expression] = STATE(691),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [219] = {
    [sym_type_alias_declaration] = STATE(696),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(696),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(696),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(696),
    [sym_return_statement] = STATE(696),
    [aux_sym_program_repeat1] = STATE(696),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(696),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(696),
    [sym_switch_statement] = STATE(696),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(696),
    [sym_throw_statement] = STATE(696),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(696),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(696),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(696),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(696),
    [sym_abstract_class] = STATE(696),
    [sym_interface_declaration] = STATE(696),
    [sym_statement_block] = STATE(696),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(696),
    [sym_debugger_statement] = STATE(696),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(696),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(696),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(696),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(696),
    [sym_empty_statement] = STATE(696),
    [sym_import_alias] = STATE(696),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(696),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(696),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(696),
    [sym_break_statement] = STATE(696),
    [sym_labeled_statement] = STATE(696),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(696),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(1304),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [220] = {
    [aux_sym_object_repeat1] = STATE(699),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_RBRACE] = ACTIONS(1310),
    [sym_comment] = ACTIONS(3),
  },
  [221] = {
    [sym_string] = STATE(673),
    [sym__property_name] = STATE(673),
    [sym_computed_property_name] = STATE(673),
    [anon_sym_get] = ACTIONS(1240),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1242),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(1234),
    [anon_sym_STAR] = ACTIONS(1244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1240),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [sym_readonly] = ACTIONS(1246),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_static] = ACTIONS(1312),
    [anon_sym_private] = ACTIONS(1230),
  },
  [222] = {
    [aux_sym_object_repeat1] = STATE(701),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_RBRACE] = ACTIONS(1310),
    [sym_comment] = ACTIONS(3),
  },
  [223] = {
    [aux_sym_export_statement_repeat1] = STATE(706),
    [sym__property_name] = STATE(707),
    [sym_decorator] = STATE(706),
    [sym_string] = STATE(707),
    [sym_accessibility_modifier] = STATE(221),
    [sym_method_definition] = STATE(708),
    [sym_computed_property_name] = STATE(707),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_class] = ACTIONS(1314),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_STAR] = ACTIONS(364),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1316),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1318),
    [anon_sym_static] = ACTIONS(370),
    [anon_sym_get] = ACTIONS(1320),
    [anon_sym_public] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [sym_number] = ACTIONS(1322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1316),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1320),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1324),
    [sym_readonly] = ACTIONS(384),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [224] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(711),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(1328),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [225] = {
    [sym__initializer] = STATE(712),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [226] = {
    [sym__initializer] = STATE(713),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [227] = {
    [sym_switch_body] = STATE(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1330),
  },
  [228] = {
    [sym__initializer] = STATE(722),
    [sym_type_annotation] = STATE(723),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1332),
    [anon_sym_AMP_EQ] = ACTIONS(1332),
    [anon_sym_PLUS_EQ] = ACTIONS(1332),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1334),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1332),
    [anon_sym_STAR_EQ] = ACTIONS(1332),
    [anon_sym_PIPE_EQ] = ACTIONS(1332),
    [anon_sym_DASH_EQ] = ACTIONS(1332),
    [anon_sym_EQ_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(1341),
    [anon_sym_LT_LT_EQ] = ACTIONS(1332),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1344),
    [anon_sym_SLASH_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT_EQ] = ACTIONS(1332),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1347),
  },
  [229] = {
    [sym_array] = STATE(726),
    [sym_this] = STATE(727),
    [sym_object] = STATE(728),
    [anon_sym_get] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_symbol] = ACTIONS(1349),
    [anon_sym_number] = ACTIONS(1349),
    [anon_sym_declare] = ACTIONS(1349),
    [anon_sym_this] = ACTIONS(294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_protected] = ACTIONS(1349),
    [anon_sym_string] = ACTIONS(1349),
    [anon_sym_set] = ACTIONS(1349),
    [anon_sym_type] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(1349),
    [anon_sym_export] = ACTIONS(1349),
    [anon_sym_namespace] = ACTIONS(1349),
    [anon_sym_any] = ACTIONS(1349),
    [anon_sym_private] = ACTIONS(1349),
    [anon_sym_boolean] = ACTIONS(1349),
    [anon_sym_async] = ACTIONS(1349),
    [anon_sym_public] = ACTIONS(1349),
  },
  [230] = {
    [sym__initializer] = STATE(732),
    [sym_type_annotation] = STATE(733),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1353),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_AMP_EQ] = ACTIONS(1353),
    [anon_sym_PLUS_EQ] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(1353),
    [anon_sym_STAR_EQ] = ACTIONS(1353),
    [anon_sym_PIPE_EQ] = ACTIONS(1353),
    [anon_sym_DASH_EQ] = ACTIONS(1353),
    [anon_sym_EQ_GT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1360),
    [anon_sym_LT_LT_EQ] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1363),
    [anon_sym_SLASH_EQ] = ACTIONS(1353),
    [anon_sym_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1353),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [231] = {
    [sym_new_expression] = STATE(734),
    [sym_augmented_assignment_expression] = STATE(734),
    [sym_unary_expression] = STATE(734),
    [sym_update_expression] = STATE(734),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(734),
    [sym_regex] = STATE(734),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(734),
    [sym_non_null_expression] = STATE(734),
    [sym_as_expression] = STATE(734),
    [sym_jsx_fragment] = STATE(734),
    [sym_yield_expression] = STATE(734),
    [sym_jsx_element] = STATE(734),
    [sym_internal_module] = STATE(734),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(734),
    [sym_await_expression] = STATE(734),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(734),
    [sym_this] = STATE(734),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(734),
    [sym_generator_function] = STATE(734),
    [sym_call_expression] = STATE(734),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(734),
    [sym_ternary_expression] = STATE(734),
    [sym_binary_expression] = STATE(734),
    [sym_template_string] = STATE(734),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(734),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(734),
    [sym_class] = STATE(734),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(1366),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1366),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1368),
    [sym_true] = ACTIONS(1366),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1366),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [232] = {
    [sym_new_expression] = STATE(735),
    [sym_augmented_assignment_expression] = STATE(735),
    [sym_unary_expression] = STATE(735),
    [sym_update_expression] = STATE(735),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(735),
    [sym_regex] = STATE(735),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(735),
    [sym_non_null_expression] = STATE(735),
    [sym_as_expression] = STATE(735),
    [sym_jsx_fragment] = STATE(735),
    [sym_yield_expression] = STATE(735),
    [sym_jsx_element] = STATE(735),
    [sym_internal_module] = STATE(735),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(735),
    [sym_await_expression] = STATE(735),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(735),
    [sym_this] = STATE(735),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(735),
    [sym_generator_function] = STATE(735),
    [sym_call_expression] = STATE(735),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(735),
    [sym_ternary_expression] = STATE(735),
    [sym_binary_expression] = STATE(735),
    [sym_template_string] = STATE(735),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(735),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(735),
    [sym_class] = STATE(735),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1370),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1372),
    [sym_true] = ACTIONS(1370),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1370),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [233] = {
    [sym_identifier] = ACTIONS(1374),
    [sym_comment] = ACTIONS(3),
  },
  [234] = {
    [sym_new_expression] = STATE(734),
    [sym_augmented_assignment_expression] = STATE(734),
    [sym__initializer] = STATE(732),
    [sym_unary_expression] = STATE(734),
    [sym_update_expression] = STATE(734),
    [sym_regex] = STATE(734),
    [sym_meta_property] = STATE(734),
    [sym_call_signature] = STATE(243),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(734),
    [sym_non_null_expression] = STATE(734),
    [sym_yield_expression] = STATE(734),
    [sym_jsx_fragment] = STATE(734),
    [sym_jsx_element] = STATE(734),
    [sym_as_expression] = STATE(734),
    [sym_internal_module] = STATE(734),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(734),
    [sym_await_expression] = STATE(734),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(734),
    [sym_this] = STATE(734),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(734),
    [sym_generator_function] = STATE(734),
    [sym_call_expression] = STATE(734),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(734),
    [sym_ternary_expression] = STATE(734),
    [sym_binary_expression] = STATE(734),
    [sym_template_string] = STATE(734),
    [sym_type_annotation] = STATE(733),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(734),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(734),
    [sym_class] = STATE(734),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(1353),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_AMP_EQ] = ACTIONS(1353),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1353),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_PIPE_EQ] = ACTIONS(1353),
    [anon_sym_DASH_EQ] = ACTIONS(1353),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(432),
    [sym_true] = ACTIONS(1366),
    [anon_sym_COLON] = ACTIONS(1363),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1353),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(416),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(1366),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_STAR_EQ] = ACTIONS(1353),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_EQ_GT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1360),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(1368),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1353),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1366),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [235] = {
    [sym__initializer] = STATE(732),
    [sym_type_annotation] = STATE(733),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1236),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1353),
    [anon_sym_symbol] = ACTIONS(1236),
    [anon_sym_AMP_EQ] = ACTIONS(1353),
    [anon_sym_PLUS_EQ] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_void] = ACTIONS(1236),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1353),
    [anon_sym_private] = ACTIONS(1236),
    [anon_sym_PIPE_EQ] = ACTIONS(1353),
    [anon_sym_DASH_EQ] = ACTIONS(1353),
    [anon_sym_get] = ACTIONS(1236),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(1236),
    [anon_sym_COLON] = ACTIONS(1363),
    [anon_sym_protected] = ACTIONS(1236),
    [anon_sym_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(1236),
    [anon_sym_type] = ACTIONS(1236),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1353),
    [anon_sym_namespace] = ACTIONS(1236),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [sym_readonly] = ACTIONS(1236),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1238),
    [anon_sym_module] = ACTIONS(1236),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_number] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1236),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1236),
    [anon_sym_STAR_EQ] = ACTIONS(1353),
    [anon_sym_boolean] = ACTIONS(1236),
    [anon_sym_async] = ACTIONS(1236),
    [anon_sym_public] = ACTIONS(1236),
    [anon_sym_EQ_GT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1360),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1353),
    [anon_sym_string] = ACTIONS(1236),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1236),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [236] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(732),
    [sym_formal_parameters] = STATE(57),
    [sym_type_annotation] = STATE(733),
    [sym_call_signature] = STATE(737),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1353),
    [anon_sym_symbol] = ACTIONS(1378),
    [anon_sym_AMP_EQ] = ACTIONS(1353),
    [anon_sym_PLUS_EQ] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_void] = ACTIONS(1378),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1353),
    [anon_sym_private] = ACTIONS(1378),
    [anon_sym_PIPE_EQ] = ACTIONS(1353),
    [anon_sym_DASH_EQ] = ACTIONS(1353),
    [anon_sym_get] = ACTIONS(1378),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(1363),
    [anon_sym_protected] = ACTIONS(1378),
    [anon_sym_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(1378),
    [anon_sym_type] = ACTIONS(1378),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1378),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1353),
    [anon_sym_namespace] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1378),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_number] = ACTIONS(1378),
    [anon_sym_declare] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1378),
    [anon_sym_STAR_EQ] = ACTIONS(1353),
    [anon_sym_boolean] = ACTIONS(1378),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_public] = ACTIONS(1378),
    [anon_sym_EQ_GT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1360),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1353),
    [anon_sym_string] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1378),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [237] = {
    [sym_new_expression] = STATE(739),
    [sym_augmented_assignment_expression] = STATE(739),
    [sym_unary_expression] = STATE(739),
    [sym_update_expression] = STATE(739),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(739),
    [sym_regex] = STATE(739),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(739),
    [sym_non_null_expression] = STATE(739),
    [sym_as_expression] = STATE(739),
    [sym_jsx_fragment] = STATE(739),
    [sym_yield_expression] = STATE(739),
    [sym_jsx_element] = STATE(739),
    [sym_internal_module] = STATE(739),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(739),
    [sym_await_expression] = STATE(739),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(739),
    [sym_this] = STATE(739),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(739),
    [sym_generator_function] = STATE(739),
    [sym_call_expression] = STATE(739),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(739),
    [sym_ternary_expression] = STATE(739),
    [sym_binary_expression] = STATE(739),
    [sym_template_string] = STATE(739),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(739),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(739),
    [sym_class] = STATE(739),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(1380),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1380),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1382),
    [sym_true] = ACTIONS(1380),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1380),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [238] = {
    [anon_sym_COLON] = ACTIONS(1384),
    [anon_sym_EQ_GT] = ACTIONS(1384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1384),
  },
  [239] = {
    [sym_new_expression] = STATE(740),
    [sym_augmented_assignment_expression] = STATE(740),
    [sym_unary_expression] = STATE(740),
    [sym_update_expression] = STATE(740),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(740),
    [sym_regex] = STATE(740),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(740),
    [sym_non_null_expression] = STATE(740),
    [sym_as_expression] = STATE(740),
    [sym_jsx_fragment] = STATE(740),
    [sym_yield_expression] = STATE(740),
    [sym_jsx_element] = STATE(740),
    [sym_internal_module] = STATE(740),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(740),
    [sym_await_expression] = STATE(740),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(740),
    [sym_this] = STATE(740),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(740),
    [sym_generator_function] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(740),
    [sym_ternary_expression] = STATE(740),
    [sym_binary_expression] = STATE(740),
    [sym_template_string] = STATE(740),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(740),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(740),
    [sym_class] = STATE(740),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(432),
    [sym_true] = ACTIONS(1386),
    [anon_sym_COLON] = ACTIONS(211),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(416),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(1386),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1386),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_RPAREN] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(1388),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1386),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [240] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(1390),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(1392),
    [anon_sym_symbol] = ACTIONS(1392),
    [anon_sym_number] = ACTIONS(1392),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1392),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1392),
    [anon_sym_private] = ACTIONS(1392),
    [anon_sym_boolean] = ACTIONS(1392),
    [anon_sym_async] = ACTIONS(1396),
    [anon_sym_public] = ACTIONS(1392),
    [anon_sym_get] = ACTIONS(1392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1392),
    [anon_sym_string] = ACTIONS(1392),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(1392),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(1392),
    [anon_sym_export] = ACTIONS(1392),
    [anon_sym_namespace] = ACTIONS(1398),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [241] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(732),
    [sym_type_annotation] = STATE(733),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(1353),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_AMP_EQ] = ACTIONS(1353),
    [anon_sym_PLUS_EQ] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(1353),
    [anon_sym_STAR_EQ] = ACTIONS(1353),
    [anon_sym_PIPE_EQ] = ACTIONS(1353),
    [anon_sym_DASH_EQ] = ACTIONS(1353),
    [anon_sym_EQ_GT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1360),
    [anon_sym_LT_LT_EQ] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1363),
    [anon_sym_SLASH_EQ] = ACTIONS(1353),
    [anon_sym_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1353),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [242] = {
    [sym_new_expression] = STATE(746),
    [sym_augmented_assignment_expression] = STATE(746),
    [sym_unary_expression] = STATE(746),
    [sym_update_expression] = STATE(746),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(746),
    [sym_regex] = STATE(746),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(746),
    [sym_non_null_expression] = STATE(746),
    [sym_as_expression] = STATE(746),
    [sym_jsx_fragment] = STATE(746),
    [sym_yield_expression] = STATE(746),
    [sym_jsx_element] = STATE(746),
    [sym_internal_module] = STATE(746),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(746),
    [sym_await_expression] = STATE(746),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(746),
    [sym_this] = STATE(746),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(746),
    [sym_generator_function] = STATE(746),
    [sym_call_expression] = STATE(746),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(746),
    [sym_ternary_expression] = STATE(746),
    [sym_binary_expression] = STATE(746),
    [sym_template_string] = STATE(746),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(746),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(746),
    [sym_class] = STATE(746),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(1400),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1400),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1402),
    [sym_true] = ACTIONS(1400),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1400),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [243] = {
    [anon_sym_EQ_GT] = ACTIONS(1339),
    [sym_comment] = ACTIONS(3),
  },
  [244] = {
    [aux_sym_formal_parameters_repeat1] = STATE(749),
    [anon_sym_COMMA] = ACTIONS(1404),
    [anon_sym_RPAREN] = ACTIONS(1406),
    [sym_comment] = ACTIONS(3),
  },
  [245] = {
    [sym_template_string] = STATE(542),
    [sym_type_arguments] = STATE(541),
    [sym_type_annotation] = STATE(761),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(1347),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1410),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_PIPE_PIPE] = ACTIONS(1426),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1347),
    [anon_sym_instanceof] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_RPAREN] = ACTIONS(1432),
    [anon_sym_SLASH] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1434),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1426),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [246] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1332),
    [anon_sym_AMP_EQ] = ACTIONS(1332),
    [anon_sym_PLUS_EQ] = ACTIONS(1332),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1332),
    [anon_sym_STAR_EQ] = ACTIONS(1332),
    [anon_sym_PIPE_EQ] = ACTIONS(1332),
    [anon_sym_DASH_EQ] = ACTIONS(1332),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1332),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT_EQ] = ACTIONS(1332),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [247] = {
    [sym_array] = STATE(726),
    [sym_this] = STATE(727),
    [sym_object] = STATE(728),
    [anon_sym_get] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1349),
    [anon_sym_module] = ACTIONS(1349),
    [anon_sym_symbol] = ACTIONS(1349),
    [anon_sym_number] = ACTIONS(1349),
    [anon_sym_declare] = ACTIONS(1349),
    [anon_sym_this] = ACTIONS(294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1349),
    [anon_sym_protected] = ACTIONS(1349),
    [anon_sym_string] = ACTIONS(1349),
    [anon_sym_set] = ACTIONS(1349),
    [anon_sym_type] = ACTIONS(1349),
    [anon_sym_import] = ACTIONS(1349),
    [anon_sym_export] = ACTIONS(1349),
    [sym_readonly] = ACTIONS(1438),
    [anon_sym_namespace] = ACTIONS(1349),
    [anon_sym_any] = ACTIONS(1349),
    [anon_sym_private] = ACTIONS(1349),
    [anon_sym_boolean] = ACTIONS(1349),
    [anon_sym_async] = ACTIONS(1349),
  },
  [248] = {
    [anon_sym_RPAREN] = ACTIONS(1432),
    [sym_comment] = ACTIONS(3),
  },
  [249] = {
    [sym__initializer] = STATE(764),
    [sym_type_annotation] = STATE(723),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1334),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1344),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [250] = {
    [aux_sym_export_statement_repeat1] = STATE(768),
    [sym_decorator] = STATE(768),
    [sym_object] = STATE(769),
    [sym_accessibility_modifier] = STATE(247),
    [sym_required_parameter] = STATE(770),
    [sym_array] = STATE(771),
    [sym_rest_parameter] = STATE(770),
    [sym_optional_parameter] = STATE(770),
    [sym_this] = STATE(772),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_public] = ACTIONS(1446),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(1442),
    [anon_sym_number] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_class] = ACTIONS(1448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1446),
    [anon_sym_void] = ACTIONS(1442),
    [anon_sym_string] = ACTIONS(1442),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_any] = ACTIONS(1442),
    [anon_sym_private] = ACTIONS(1446),
    [anon_sym_boolean] = ACTIONS(1442),
    [anon_sym_async] = ACTIONS(1442),
  },
  [251] = {
    [sym__initializer] = STATE(774),
    [sym_type_annotation] = STATE(775),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1450),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(1453),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1450),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1344),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1347),
  },
  [252] = {
    [sym__initializer] = STATE(777),
    [sym_type_annotation] = STATE(778),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1456),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(1459),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1456),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1344),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1347),
  },
  [253] = {
    [anon_sym_EQ_GT] = ACTIONS(1462),
    [sym_comment] = ACTIONS(3),
  },
  [254] = {
    [anon_sym_EQ_GT] = ACTIONS(1464),
    [sym_comment] = ACTIONS(3),
  },
  [255] = {
    [aux_sym_export_statement_repeat1] = STATE(781),
    [sym_decorator] = STATE(781),
    [sym_object] = STATE(769),
    [sym_accessibility_modifier] = STATE(247),
    [sym_required_parameter] = STATE(244),
    [sym_array] = STATE(771),
    [sym_rest_parameter] = STATE(244),
    [sym_optional_parameter] = STATE(244),
    [sym_this] = STATE(772),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_public] = ACTIONS(1446),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(1442),
    [anon_sym_number] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_RPAREN] = ACTIONS(428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1446),
    [anon_sym_void] = ACTIONS(1442),
    [anon_sym_string] = ACTIONS(1442),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_any] = ACTIONS(1442),
    [anon_sym_private] = ACTIONS(1446),
    [anon_sym_boolean] = ACTIONS(1442),
    [anon_sym_async] = ACTIONS(1442),
  },
  [256] = {
    [sym_type_parameter] = STATE(269),
    [sym_identifier] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
  },
  [257] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(784),
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [258] = {
    [aux_sym_variable_declaration_repeat1] = STATE(786),
    [sym__automatic_semicolon] = ACTIONS(1470),
    [anon_sym_SEMI] = ACTIONS(1470),
    [anon_sym_COMMA] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
  },
  [259] = {
    [sym_type_alias_declaration] = STATE(317),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(317),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(317),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(317),
    [sym_return_statement] = STATE(317),
    [aux_sym_program_repeat1] = STATE(317),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(317),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(317),
    [sym_switch_statement] = STATE(317),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(317),
    [sym_throw_statement] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(317),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(317),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(317),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_statement_block] = STATE(317),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(317),
    [sym_debugger_statement] = STATE(317),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(317),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(317),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(317),
    [sym_empty_statement] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(317),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(317),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(317),
    [sym_break_statement] = STATE(317),
    [sym_labeled_statement] = STATE(317),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(317),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(1472),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [260] = {
    [sym_type_alias_declaration] = STATE(787),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(787),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(787),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(787),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(787),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(787),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(787),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(787),
    [sym_abstract_class] = STATE(787),
    [sym_interface_declaration] = STATE(787),
    [sym_statement_block] = STATE(787),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(787),
    [sym_debugger_statement] = STATE(787),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(787),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(787),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(787),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(787),
    [sym_empty_statement] = STATE(787),
    [sym_import_alias] = STATE(787),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(787),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(787),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_labeled_statement] = STATE(787),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(787),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [261] = {
    [aux_sym_string_repeat2] = STATE(788),
    [sym_escape_sequence] = ACTIONS(1474),
    [aux_sym_string_token2] = ACTIONS(1474),
    [sym_comment] = ACTIONS(246),
    [anon_sym_SQUOTE] = ACTIONS(923),
  },
  [262] = {
    [sym_type_alias_declaration] = STATE(219),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(219),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(219),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(219),
    [sym_return_statement] = STATE(219),
    [aux_sym_program_repeat1] = STATE(219),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(219),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(219),
    [sym_switch_statement] = STATE(219),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(219),
    [sym_throw_statement] = STATE(219),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(219),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(219),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(219),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(219),
    [sym_abstract_class] = STATE(219),
    [sym_interface_declaration] = STATE(219),
    [sym_statement_block] = STATE(219),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(219),
    [sym_debugger_statement] = STATE(219),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(219),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(219),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(219),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(219),
    [sym_empty_statement] = STATE(219),
    [sym_import_alias] = STATE(219),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(219),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(219),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(219),
    [sym_break_statement] = STATE(219),
    [sym_labeled_statement] = STATE(219),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(219),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(1476),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [263] = {
    [sym_catch_clause] = STATE(792),
    [sym_finally_clause] = STATE(793),
    [sym_identifier] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [anon_sym_debugger] = ACTIONS(1478),
    [anon_sym_symbol] = ACTIONS(1478),
    [anon_sym_AT] = ACTIONS(1480),
    [anon_sym_DASH] = ACTIONS(1478),
    [anon_sym_void] = ACTIONS(1478),
    [anon_sym_break] = ACTIONS(1478),
    [anon_sym_const] = ACTIONS(1478),
    [sym_super] = ACTIONS(1478),
    [anon_sym_return] = ACTIONS(1478),
    [anon_sym_private] = ACTIONS(1478),
    [anon_sym_get] = ACTIONS(1478),
    [anon_sym_RBRACE] = ACTIONS(1480),
    [anon_sym_interface] = ACTIONS(1478),
    [anon_sym_default] = ACTIONS(1478),
    [anon_sym_enum] = ACTIONS(1478),
    [anon_sym_delete] = ACTIONS(1478),
    [anon_sym_continue] = ACTIONS(1478),
    [anon_sym_DASH_DASH] = ACTIONS(1480),
    [anon_sym_if] = ACTIONS(1478),
    [anon_sym_this] = ACTIONS(1478),
    [anon_sym_yield] = ACTIONS(1478),
    [sym_true] = ACTIONS(1478),
    [anon_sym_throw] = ACTIONS(1478),
    [anon_sym_protected] = ACTIONS(1478),
    [anon_sym_abstract] = ACTIONS(1478),
    [anon_sym_set] = ACTIONS(1478),
    [anon_sym_type] = ACTIONS(1478),
    [anon_sym_import] = ACTIONS(1478),
    [anon_sym_namespace] = ACTIONS(1478),
    [anon_sym_PLUS_PLUS] = ACTIONS(1480),
    [anon_sym_await] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1480),
    [anon_sym_else] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1480),
    [anon_sym_for] = ACTIONS(1478),
    [anon_sym_LBRACK] = ACTIONS(1480),
    [sym_false] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1480),
    [anon_sym_case] = ACTIONS(1478),
    [anon_sym_module] = ACTIONS(1478),
    [anon_sym_number] = ACTIONS(1478),
    [anon_sym_class] = ACTIONS(1478),
    [anon_sym_declare] = ACTIONS(1478),
    [anon_sym_typeof] = ACTIONS(1478),
    [anon_sym_LBRACE] = ACTIONS(1480),
    [anon_sym_switch] = ACTIONS(1478),
    [anon_sym_LPAREN] = ACTIONS(1480),
    [sym_null] = ACTIONS(1478),
    [anon_sym_catch] = ACTIONS(1482),
    [anon_sym_any] = ACTIONS(1478),
    [anon_sym_boolean] = ACTIONS(1478),
    [anon_sym_async] = ACTIONS(1478),
    [anon_sym_public] = ACTIONS(1478),
    [anon_sym_var] = ACTIONS(1478),
    [anon_sym_while] = ACTIONS(1478),
    [anon_sym_SQUOTE] = ACTIONS(1480),
    [anon_sym_try] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(1480),
    [sym_number] = ACTIONS(1480),
    [anon_sym_SLASH] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(1484),
    [anon_sym_string] = ACTIONS(1478),
    [anon_sym_function] = ACTIONS(1478),
    [sym_undefined] = ACTIONS(1478),
    [anon_sym_new] = ACTIONS(1478),
    [ts_builtin_sym_end] = ACTIONS(1480),
    [anon_sym_let] = ACTIONS(1478),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_export] = ACTIONS(1478),
    [anon_sym_do] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1480),
    [anon_sym_with] = ACTIONS(1478),
  },
  [264] = {
    [sym_jsx_opening_element] = STATE(340),
    [aux_sym_jsx_element_repeat1] = STATE(795),
    [sym_jsx_expression] = STATE(795),
    [sym_jsx_self_closing_element] = STATE(795),
    [sym_jsx_element] = STATE(795),
    [sym_jsx_text] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(590),
  },
  [265] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(804),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_constraint] = STATE(806),
    [sym_jsx_attribute] = STATE(804),
    [sym_jsx_expression] = STATE(804),
    [sym_default_type] = STATE(807),
    [sym_type_arguments] = STATE(808),
    [anon_sym_EQ] = ACTIONS(1490),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_COLON] = ACTIONS(1494),
    [anon_sym_extends] = ACTIONS(1496),
    [anon_sym_DOT] = ACTIONS(1498),
    [sym_jsx_identifier] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(1505),
    [anon_sym_COMMA] = ACTIONS(1507),
    [anon_sym_SLASH] = ACTIONS(1509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [266] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(804),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(804),
    [sym_jsx_expression] = STATE(804),
    [anon_sym_COLON] = ACTIONS(1513),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_GT] = ACTIONS(1515),
    [sym_jsx_identifier] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [267] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(804),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(804),
    [sym_jsx_expression] = STATE(804),
    [sym_type_arguments] = STATE(808),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_DOT] = ACTIONS(1498),
    [sym_jsx_identifier] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1515),
    [anon_sym_LT] = ACTIONS(1505),
    [anon_sym_SLASH] = ACTIONS(1509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [268] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(804),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(804),
    [sym_jsx_expression] = STATE(804),
    [anon_sym_GT] = ACTIONS(1515),
    [sym_identifier] = ACTIONS(1492),
    [sym_jsx_identifier] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(1509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [269] = {
    [aux_sym_type_parameters_repeat1] = STATE(812),
    [anon_sym_COMMA] = ACTIONS(1517),
    [anon_sym_GT] = ACTIONS(1519),
    [sym_comment] = ACTIONS(3),
  },
  [270] = {
    [anon_sym_SLASH2] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
  },
  [271] = {
    [sym_type_parameters] = STATE(815),
    [sym_formal_parameters] = STATE(816),
    [sym_call_signature] = STATE(817),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [272] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(819),
    [sym_identifier] = ACTIONS(1525),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [273] = {
    [sym_formal_parameters] = STATE(820),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [274] = {
    [sym_type_annotation] = STATE(323),
    [anon_sym_COLON] = ACTIONS(1527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(548),
  },
  [275] = {
    [sym_statement_block] = STATE(822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(909),
  },
  [276] = {
    [sym__initializer] = STATE(522),
    [sym_arguments] = STATE(826),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_SEMI] = ACTIONS(1529),
    [sym__automatic_semicolon] = ACTIONS(1529),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1531),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [277] = {
    [sym_arguments] = STATE(826),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_SEMI] = ACTIONS(1529),
    [sym__automatic_semicolon] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1529),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_RBRACE] = ACTIONS(1529),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1529),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1529),
    [anon_sym_STAR_STAR] = ACTIONS(1529),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [278] = {
    [anon_sym_target] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
  },
  [279] = {
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(828),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1539),
    [sym__automatic_semicolon] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [280] = {
    [sym_new_expression] = STATE(836),
    [sym_augmented_assignment_expression] = STATE(836),
    [sym_unary_expression] = STATE(836),
    [sym_update_expression] = STATE(836),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(836),
    [sym_regex] = STATE(836),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(836),
    [sym_non_null_expression] = STATE(836),
    [sym_as_expression] = STATE(836),
    [sym_jsx_fragment] = STATE(836),
    [sym_yield_expression] = STATE(836),
    [sym_jsx_element] = STATE(836),
    [sym_internal_module] = STATE(836),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(836),
    [sym_await_expression] = STATE(836),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(836),
    [sym_this] = STATE(836),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(836),
    [sym_generator_function] = STATE(836),
    [sym_call_expression] = STATE(836),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(836),
    [sym_ternary_expression] = STATE(836),
    [sym_binary_expression] = STATE(836),
    [sym_template_string] = STATE(836),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(836),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(836),
    [sym_class] = STATE(836),
    [anon_sym_BANG] = ACTIONS(484),
    [sym_identifier] = ACTIONS(1543),
    [sym_false] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1545),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1553),
    [sym_true] = ACTIONS(1545),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
  },
  [281] = {
    [sym_new_expression] = STATE(840),
    [sym_augmented_assignment_expression] = STATE(840),
    [sym_unary_expression] = STATE(840),
    [sym_update_expression] = STATE(840),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(840),
    [sym_regex] = STATE(840),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(840),
    [sym_non_null_expression] = STATE(840),
    [sym_as_expression] = STATE(840),
    [sym_jsx_fragment] = STATE(840),
    [sym_yield_expression] = STATE(840),
    [sym_jsx_element] = STATE(840),
    [sym_internal_module] = STATE(840),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(840),
    [sym_await_expression] = STATE(840),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(840),
    [sym_this] = STATE(840),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(840),
    [sym_generator_function] = STATE(840),
    [sym_call_expression] = STATE(840),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(840),
    [sym_ternary_expression] = STATE(840),
    [sym_binary_expression] = STATE(840),
    [sym_template_string] = STATE(840),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(840),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(840),
    [sym_class] = STATE(840),
    [anon_sym_BANG] = ACTIONS(484),
    [sym_identifier] = ACTIONS(1543),
    [sym_false] = ACTIONS(1559),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1559),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1561),
    [sym_true] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1559),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
  },
  [282] = {
    [sym_new_expression] = STATE(836),
    [sym_augmented_assignment_expression] = STATE(836),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(836),
    [sym_update_expression] = STATE(836),
    [sym_regex] = STATE(836),
    [sym_meta_property] = STATE(836),
    [sym_call_signature] = STATE(835),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(836),
    [sym_non_null_expression] = STATE(836),
    [sym_yield_expression] = STATE(836),
    [sym_jsx_fragment] = STATE(836),
    [sym_jsx_element] = STATE(836),
    [sym_as_expression] = STATE(836),
    [sym_internal_module] = STATE(836),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(836),
    [sym_await_expression] = STATE(836),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(836),
    [sym_this] = STATE(836),
    [sym_arguments] = STATE(828),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(836),
    [sym_generator_function] = STATE(836),
    [sym_call_expression] = STATE(836),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(836),
    [sym_ternary_expression] = STATE(836),
    [sym_binary_expression] = STATE(836),
    [sym_template_string] = STATE(836),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(836),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(836),
    [sym_class] = STATE(836),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym__automatic_semicolon] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(500),
    [sym_true] = ACTIONS(1545),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [sym_false] = ACTIONS(1545),
    [anon_sym_SEMI] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [sym_null] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [sym_number] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [283] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [284] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_arguments] = STATE(828),
    [sym_call_signature] = STATE(253),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym__automatic_semicolon] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(442),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(444),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(444),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(444),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_protected] = ACTIONS(444),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_set] = ACTIONS(444),
    [anon_sym_type] = ACTIONS(444),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(444),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(444),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(444),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(444),
    [anon_sym_declare] = ACTIONS(444),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(444),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(444),
    [anon_sym_async] = ACTIONS(444),
    [anon_sym_public] = ACTIONS(444),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(444),
    [anon_sym_function] = ACTIONS(698),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(444),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [285] = {
    [sym_new_expression] = STATE(841),
    [sym_augmented_assignment_expression] = STATE(841),
    [sym_unary_expression] = STATE(841),
    [sym_update_expression] = STATE(841),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(841),
    [sym_regex] = STATE(841),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(841),
    [sym_non_null_expression] = STATE(841),
    [sym_as_expression] = STATE(841),
    [sym_jsx_fragment] = STATE(841),
    [sym_yield_expression] = STATE(841),
    [sym_jsx_element] = STATE(841),
    [sym_internal_module] = STATE(841),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(841),
    [sym_await_expression] = STATE(841),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(841),
    [sym_this] = STATE(841),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(841),
    [sym_generator_function] = STATE(841),
    [sym_call_expression] = STATE(841),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(841),
    [sym_ternary_expression] = STATE(841),
    [sym_binary_expression] = STATE(841),
    [sym_template_string] = STATE(841),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(841),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(841),
    [sym_class] = STATE(841),
    [anon_sym_BANG] = ACTIONS(484),
    [sym_identifier] = ACTIONS(1543),
    [sym_false] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1563),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1565),
    [sym_true] = ACTIONS(1563),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1563),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
  },
  [286] = {
    [sym_new_expression] = STATE(565),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(565),
    [sym_regex] = STATE(565),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(565),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(565),
    [sym_this] = STATE(565),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(565),
    [sym_generator_function] = STATE(565),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(565),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(565),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(565),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(500),
    [sym_true] = ACTIONS(1567),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(1567),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1567),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(1569),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [287] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(828),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1539),
    [sym__automatic_semicolon] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [288] = {
    [sym_new_expression] = STATE(565),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(565),
    [sym_regex] = STATE(565),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(565),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(565),
    [sym_this] = STATE(565),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(565),
    [sym_generator_function] = STATE(565),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(565),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(565),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(565),
    [anon_sym_BANG] = ACTIONS(484),
    [sym_identifier] = ACTIONS(1543),
    [sym_false] = ACTIONS(1567),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1567),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1569),
    [sym_true] = ACTIONS(1567),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1567),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
  },
  [289] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1571),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_in] = ACTIONS(1573),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1575),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1579),
    [anon_sym_STAR] = ACTIONS(1581),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1583),
    [anon_sym_BANG_EQ] = ACTIONS(1573),
    [anon_sym_LT_EQ] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1571),
    [anon_sym_GT] = ACTIONS(1573),
    [anon_sym_AMP] = ACTIONS(1585),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [anon_sym_as] = ACTIONS(1591),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1573),
    [anon_sym_instanceof] = ACTIONS(1571),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_SLASH] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_STAR_STAR] = ACTIONS(1595),
    [anon_sym_PLUS] = ACTIONS(1579),
    [anon_sym_GT_GT] = ACTIONS(1581),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [290] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(826),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_SEMI] = ACTIONS(1529),
    [sym__automatic_semicolon] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1529),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_RBRACE] = ACTIONS(1529),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1529),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1529),
    [anon_sym_STAR_STAR] = ACTIONS(1529),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [291] = {
    [sym__initializer] = STATE(522),
    [sym_arguments] = STATE(826),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_SEMI] = ACTIONS(1529),
    [sym__automatic_semicolon] = ACTIONS(1529),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1531),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_RBRACE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1529),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [292] = {
    [sym__initializer] = STATE(587),
    [sym_arguments] = STATE(826),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_SEMI] = ACTIONS(1529),
    [sym__automatic_semicolon] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1529),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_RBRACE] = ACTIONS(1529),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1529),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1529),
    [anon_sym_STAR_STAR] = ACTIONS(1529),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [293] = {
    [sym__initializer] = STATE(589),
    [sym_arguments] = STATE(826),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_SEMI] = ACTIONS(1529),
    [sym__automatic_semicolon] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1529),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_RBRACE] = ACTIONS(1529),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1529),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1529),
    [anon_sym_STAR_STAR] = ACTIONS(1529),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [294] = {
    [sym_string] = STATE(173),
    [sym_nested_identifier] = STATE(169),
    [sym__module] = STATE(172),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(312),
  },
  [295] = {
    [sym__from_clause] = STATE(850),
    [anon_sym_from] = ACTIONS(901),
    [sym_comment] = ACTIONS(3),
  },
  [296] = {
    [sym__import_export_specifier] = STATE(853),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_typeof] = ACTIONS(895),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_type] = ACTIONS(895),
    [sym_comment] = ACTIONS(3),
  },
  [297] = {
    [sym_new_expression] = STATE(347),
    [sym_augmented_assignment_expression] = STATE(347),
    [sym_unary_expression] = STATE(347),
    [sym_update_expression] = STATE(347),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(347),
    [sym_non_null_expression] = STATE(347),
    [sym_as_expression] = STATE(347),
    [sym_jsx_fragment] = STATE(347),
    [sym_yield_expression] = STATE(347),
    [sym_jsx_element] = STATE(347),
    [sym_internal_module] = STATE(347),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(347),
    [sym_await_expression] = STATE(347),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(347),
    [sym_this] = STATE(347),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(347),
    [sym_generator_function] = STATE(347),
    [sym_call_expression] = STATE(347),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(347),
    [sym_ternary_expression] = STATE(347),
    [sym_binary_expression] = STATE(347),
    [sym_template_string] = STATE(347),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(347),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(347),
    [sym_class] = STATE(347),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(1601),
    [sym_false] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(606),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(608),
    [sym_true] = ACTIONS(606),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(606),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [298] = {
    [sym_new_expression] = STATE(867),
    [sym_augmented_assignment_expression] = STATE(867),
    [sym_unary_expression] = STATE(867),
    [sym_update_expression] = STATE(867),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(867),
    [sym_regex] = STATE(867),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(867),
    [sym_non_null_expression] = STATE(867),
    [sym_as_expression] = STATE(867),
    [sym_jsx_fragment] = STATE(867),
    [sym_yield_expression] = STATE(867),
    [sym_jsx_element] = STATE(867),
    [sym_internal_module] = STATE(867),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(867),
    [sym_await_expression] = STATE(867),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(867),
    [sym_this] = STATE(867),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(867),
    [sym_generator_function] = STATE(867),
    [sym_call_expression] = STATE(867),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(867),
    [sym_ternary_expression] = STATE(867),
    [sym_binary_expression] = STATE(867),
    [sym_template_string] = STATE(867),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(867),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(867),
    [sym_class] = STATE(867),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(1607),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(1607),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1621),
    [sym_true] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(1607),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [299] = {
    [anon_sym_namespace] = ACTIONS(1631),
    [sym_comment] = ACTIONS(3),
  },
  [300] = {
    [sym_identifier] = ACTIONS(1633),
    [anon_sym_BQUOTE] = ACTIONS(1635),
    [anon_sym_debugger] = ACTIONS(1633),
    [anon_sym_symbol] = ACTIONS(1633),
    [anon_sym_AT] = ACTIONS(1635),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_void] = ACTIONS(1633),
    [anon_sym_break] = ACTIONS(1633),
    [anon_sym_const] = ACTIONS(1633),
    [sym_super] = ACTIONS(1633),
    [anon_sym_return] = ACTIONS(1633),
    [anon_sym_private] = ACTIONS(1633),
    [anon_sym_get] = ACTIONS(1633),
    [anon_sym_RBRACE] = ACTIONS(1635),
    [anon_sym_interface] = ACTIONS(1633),
    [anon_sym_default] = ACTIONS(1633),
    [anon_sym_enum] = ACTIONS(1633),
    [anon_sym_delete] = ACTIONS(1633),
    [anon_sym_continue] = ACTIONS(1633),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_if] = ACTIONS(1633),
    [anon_sym_this] = ACTIONS(1633),
    [anon_sym_yield] = ACTIONS(1633),
    [sym_true] = ACTIONS(1633),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_protected] = ACTIONS(1633),
    [anon_sym_abstract] = ACTIONS(1633),
    [anon_sym_set] = ACTIONS(1633),
    [anon_sym_type] = ACTIONS(1633),
    [anon_sym_import] = ACTIONS(1633),
    [anon_sym_namespace] = ACTIONS(1633),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_await] = ACTIONS(1633),
    [anon_sym_DQUOTE] = ACTIONS(1635),
    [anon_sym_else] = ACTIONS(1633),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_for] = ACTIONS(1633),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [sym_false] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym_case] = ACTIONS(1633),
    [anon_sym_module] = ACTIONS(1633),
    [anon_sym_number] = ACTIONS(1633),
    [anon_sym_class] = ACTIONS(1633),
    [anon_sym_declare] = ACTIONS(1633),
    [anon_sym_typeof] = ACTIONS(1633),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_switch] = ACTIONS(1633),
    [anon_sym_LPAREN] = ACTIONS(1635),
    [sym_null] = ACTIONS(1633),
    [anon_sym_any] = ACTIONS(1633),
    [anon_sym_boolean] = ACTIONS(1633),
    [anon_sym_async] = ACTIONS(1633),
    [anon_sym_public] = ACTIONS(1633),
    [anon_sym_var] = ACTIONS(1633),
    [anon_sym_while] = ACTIONS(1633),
    [anon_sym_SQUOTE] = ACTIONS(1635),
    [anon_sym_try] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(1635),
    [sym_number] = ACTIONS(1635),
    [anon_sym_SLASH] = ACTIONS(1633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1633),
    [anon_sym_function] = ACTIONS(1633),
    [sym_undefined] = ACTIONS(1633),
    [anon_sym_new] = ACTIONS(1633),
    [ts_builtin_sym_end] = ACTIONS(1635),
    [anon_sym_let] = ACTIONS(1633),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_export] = ACTIONS(1633),
    [anon_sym_do] = ACTIONS(1633),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_with] = ACTIONS(1633),
  },
  [301] = {
    [sym__from_clause] = STATE(850),
    [sym__automatic_semicolon] = ACTIONS(1637),
    [anon_sym_SEMI] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(901),
    [sym_comment] = ACTIONS(3),
  },
  [302] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1639),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [303] = {
    [sym_parenthesized_expression] = STATE(874),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [304] = {
    [anon_sym_class] = ACTIONS(1641),
    [sym_comment] = ACTIONS(3),
  },
  [305] = {
    [anon_sym_await] = ACTIONS(1643),
    [anon_sym_LPAREN] = ACTIONS(1645),
    [sym_comment] = ACTIONS(3),
  },
  [306] = {
    [sym_nested_identifier] = STATE(169),
    [sym__module] = STATE(172),
    [sym_string] = STATE(173),
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(310),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [307] = {
    [sym_type_alias_declaration] = STATE(193),
    [aux_sym_export_statement_repeat1] = STATE(885),
    [sym__declaration] = STATE(193),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(193),
    [sym_import_alias] = STATE(193),
    [sym_export_statement] = STATE(193),
    [sym_generator_function] = STATE(193),
    [sym_lexical_declaration] = STATE(193),
    [sym_internal_module] = STATE(193),
    [sym_decorator] = STATE(885),
    [sym_enum_declaration] = STATE(193),
    [sym_function] = STATE(193),
    [sym_function_signature] = STATE(193),
    [sym_variable_declaration] = STATE(193),
    [sym_abstract_class] = STATE(193),
    [sym_module] = STATE(193),
    [sym_interface_declaration] = STATE(193),
    [sym_class] = STATE(193),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(324),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(1647),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1651),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(1653),
    [anon_sym_declare] = ACTIONS(1655),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(1657),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(1659),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1661),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [308] = {
    [sym_parenthesized_expression] = STATE(886),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [309] = {
    [sym_type_alias_declaration] = STATE(300),
    [aux_sym_export_statement_repeat1] = STATE(885),
    [sym__declaration] = STATE(300),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(300),
    [sym_import_alias] = STATE(300),
    [sym_export_statement] = STATE(300),
    [sym_generator_function] = STATE(300),
    [sym_export_clause] = STATE(301),
    [sym_lexical_declaration] = STATE(300),
    [sym_internal_module] = STATE(300),
    [sym_decorator] = STATE(885),
    [sym_enum_declaration] = STATE(300),
    [sym_function] = STATE(300),
    [sym_function_signature] = STATE(300),
    [sym_variable_declaration] = STATE(300),
    [sym_abstract_class] = STATE(300),
    [sym_module] = STATE(300),
    [sym_interface_declaration] = STATE(300),
    [sym_class] = STATE(300),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(508),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(511),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_as] = ACTIONS(515),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(1647),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1663),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(1653),
    [anon_sym_declare] = ACTIONS(1655),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(1657),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(1659),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1661),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [310] = {
    [sym_parenthesized_expression] = STATE(888),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [311] = {
    [anon_sym_while] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
  },
  [312] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_else] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [313] = {
    [aux_sym_export_statement_repeat1] = STATE(320),
    [sym_decorator] = STATE(320),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(1667),
    [anon_sym_class] = ACTIONS(546),
    [sym_comment] = ACTIONS(3),
  },
  [314] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_else] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [315] = {
    [sym_type_alias_declaration] = STATE(891),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(891),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(891),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(891),
    [sym_return_statement] = STATE(891),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(891),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(891),
    [sym_switch_statement] = STATE(891),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(891),
    [sym_throw_statement] = STATE(891),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(891),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(891),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(891),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(891),
    [sym_abstract_class] = STATE(891),
    [sym_interface_declaration] = STATE(891),
    [sym_statement_block] = STATE(891),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(891),
    [sym_debugger_statement] = STATE(891),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(891),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(891),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(891),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(891),
    [sym_empty_statement] = STATE(891),
    [sym_import_alias] = STATE(891),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(891),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(891),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(891),
    [sym_break_statement] = STATE(891),
    [sym_labeled_statement] = STATE(891),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(891),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [316] = {
    [sym_type_annotation] = STATE(892),
    [anon_sym_EQ_GT] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(550),
    [sym_comment] = ACTIONS(3),
  },
  [317] = {
    [sym_type_alias_declaration] = STATE(317),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(317),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(317),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(317),
    [sym_return_statement] = STATE(317),
    [aux_sym_program_repeat1] = STATE(317),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(317),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(317),
    [sym_switch_statement] = STATE(317),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(317),
    [sym_throw_statement] = STATE(317),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(317),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(317),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(317),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(317),
    [sym_abstract_class] = STATE(317),
    [sym_interface_declaration] = STATE(317),
    [sym_statement_block] = STATE(317),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(317),
    [sym_debugger_statement] = STATE(317),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(317),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(317),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(317),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(317),
    [sym_empty_statement] = STATE(317),
    [sym_import_alias] = STATE(317),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(317),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(317),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(317),
    [sym_break_statement] = STATE(317),
    [sym_labeled_statement] = STATE(317),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(317),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1674),
    [anon_sym_debugger] = ACTIONS(1677),
    [anon_sym_symbol] = ACTIONS(1680),
    [anon_sym_AT] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1686),
    [anon_sym_void] = ACTIONS(1689),
    [anon_sym_break] = ACTIONS(1692),
    [anon_sym_const] = ACTIONS(1695),
    [sym_super] = ACTIONS(1698),
    [anon_sym_return] = ACTIONS(1701),
    [anon_sym_private] = ACTIONS(1680),
    [anon_sym_get] = ACTIONS(1680),
    [anon_sym_interface] = ACTIONS(1704),
    [anon_sym_enum] = ACTIONS(1707),
    [anon_sym_delete] = ACTIONS(1710),
    [anon_sym_continue] = ACTIONS(1713),
    [anon_sym_DASH_DASH] = ACTIONS(1716),
    [anon_sym_if] = ACTIONS(1719),
    [anon_sym_this] = ACTIONS(1722),
    [anon_sym_yield] = ACTIONS(1725),
    [sym_true] = ACTIONS(1728),
    [anon_sym_throw] = ACTIONS(1731),
    [anon_sym_protected] = ACTIONS(1680),
    [anon_sym_abstract] = ACTIONS(1734),
    [anon_sym_set] = ACTIONS(1680),
    [anon_sym_type] = ACTIONS(1737),
    [anon_sym_import] = ACTIONS(1740),
    [anon_sym_namespace] = ACTIONS(1743),
    [anon_sym_PLUS_PLUS] = ACTIONS(1716),
    [anon_sym_await] = ACTIONS(1746),
    [anon_sym_DQUOTE] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(1755),
    [anon_sym_LBRACK] = ACTIONS(1758),
    [sym_false] = ACTIONS(1728),
    [anon_sym_SEMI] = ACTIONS(1761),
    [anon_sym_module] = ACTIONS(1764),
    [anon_sym_number] = ACTIONS(1680),
    [anon_sym_class] = ACTIONS(1767),
    [anon_sym_declare] = ACTIONS(1770),
    [anon_sym_typeof] = ACTIONS(1710),
    [anon_sym_LBRACE] = ACTIONS(1773),
    [anon_sym_switch] = ACTIONS(1776),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [sym_null] = ACTIONS(1728),
    [anon_sym_any] = ACTIONS(1680),
    [anon_sym_boolean] = ACTIONS(1680),
    [anon_sym_async] = ACTIONS(1782),
    [anon_sym_public] = ACTIONS(1680),
    [anon_sym_var] = ACTIONS(1785),
    [anon_sym_while] = ACTIONS(1788),
    [anon_sym_SQUOTE] = ACTIONS(1791),
    [anon_sym_try] = ACTIONS(1794),
    [anon_sym_LT] = ACTIONS(1797),
    [sym_number] = ACTIONS(1800),
    [anon_sym_SLASH] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1680),
    [anon_sym_function] = ACTIONS(1806),
    [sym_undefined] = ACTIONS(1728),
    [anon_sym_new] = ACTIONS(1809),
    [ts_builtin_sym_end] = ACTIONS(1812),
    [anon_sym_let] = ACTIONS(1814),
    [anon_sym_PLUS] = ACTIONS(1686),
    [anon_sym_export] = ACTIONS(1817),
    [anon_sym_do] = ACTIONS(1820),
    [anon_sym_TILDE] = ACTIONS(1752),
    [anon_sym_with] = ACTIONS(1823),
  },
  [318] = {
    [sym_type_alias_declaration] = STATE(872),
    [aux_sym_export_statement_repeat1] = STATE(192),
    [sym__declaration] = STATE(872),
    [sym_ambient_declaration] = STATE(872),
    [sym_import_alias] = STATE(872),
    [sym_export_statement] = STATE(872),
    [sym_generator_function] = STATE(872),
    [sym_lexical_declaration] = STATE(872),
    [sym_internal_module] = STATE(872),
    [sym_decorator] = STATE(192),
    [sym_enum_declaration] = STATE(872),
    [sym_function] = STATE(872),
    [sym_function_signature] = STATE(872),
    [sym_variable_declaration] = STATE(872),
    [sym_abstract_class] = STATE(872),
    [sym_module] = STATE(872),
    [sym_interface_declaration] = STATE(872),
    [sym_class] = STATE(872),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_default] = ACTIONS(1826),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(354),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(346),
  },
  [319] = {
    [sym_class_heritage] = STATE(895),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(645),
    [anon_sym_extends] = ACTIONS(316),
    [anon_sym_implements] = ACTIONS(318),
    [sym_identifier] = ACTIONS(1828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(322),
  },
  [320] = {
    [aux_sym_export_statement_repeat1] = STATE(320),
    [sym_decorator] = STATE(320),
    [anon_sym_export] = ACTIONS(1830),
    [anon_sym_class] = ACTIONS(1830),
    [anon_sym_AT] = ACTIONS(1832),
    [sym_comment] = ACTIONS(3),
  },
  [321] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1835),
    [anon_sym_LBRACK] = ACTIONS(1835),
    [anon_sym_BANG] = ACTIONS(1837),
    [anon_sym_SEMI] = ACTIONS(1835),
    [anon_sym_BQUOTE] = ACTIONS(1835),
    [sym__automatic_semicolon] = ACTIONS(1835),
    [anon_sym_PIPE] = ACTIONS(1837),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_LT_LT] = ACTIONS(1835),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_GT_GT_GT] = ACTIONS(1835),
    [anon_sym_AMP_AMP] = ACTIONS(1835),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_BANG_EQ] = ACTIONS(1837),
    [anon_sym_LT_EQ] = ACTIONS(1835),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_GT_EQ] = ACTIONS(1835),
    [anon_sym_GT] = ACTIONS(1837),
    [anon_sym_AMP] = ACTIONS(1837),
    [anon_sym_PERCENT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_RBRACE] = ACTIONS(1835),
    [anon_sym_as] = ACTIONS(1835),
    [anon_sym_PIPE_PIPE] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_EQ_EQ] = ACTIONS(1837),
    [anon_sym_instanceof] = ACTIONS(1835),
    [anon_sym_LT] = ACTIONS(1837),
    [anon_sym_RPAREN] = ACTIONS(1835),
    [anon_sym_SLASH] = ACTIONS(1837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1835),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_STAR_STAR] = ACTIONS(1835),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_GT_GT] = ACTIONS(1837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1835),
    [anon_sym_in] = ACTIONS(1837),
  },
  [322] = {
    [sym_union_type] = STATE(901),
    [sym__type] = STATE(901),
    [sym_constructor_type] = STATE(901),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(902),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(901),
    [sym_function_type] = STATE(901),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(903),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1839),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(1845),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(1847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [323] = {
    [anon_sym_EQ_GT] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1669),
  },
  [324] = {
    [sym_identifier] = ACTIONS(1849),
    [anon_sym_BQUOTE] = ACTIONS(1851),
    [anon_sym_debugger] = ACTIONS(1849),
    [anon_sym_symbol] = ACTIONS(1849),
    [anon_sym_AT] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1849),
    [anon_sym_void] = ACTIONS(1849),
    [anon_sym_break] = ACTIONS(1849),
    [anon_sym_const] = ACTIONS(1849),
    [sym_super] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(1849),
    [anon_sym_private] = ACTIONS(1849),
    [anon_sym_get] = ACTIONS(1849),
    [anon_sym_RBRACE] = ACTIONS(1851),
    [anon_sym_interface] = ACTIONS(1849),
    [anon_sym_default] = ACTIONS(1849),
    [anon_sym_enum] = ACTIONS(1849),
    [anon_sym_delete] = ACTIONS(1849),
    [anon_sym_continue] = ACTIONS(1849),
    [anon_sym_DASH_DASH] = ACTIONS(1851),
    [anon_sym_if] = ACTIONS(1849),
    [anon_sym_this] = ACTIONS(1849),
    [anon_sym_yield] = ACTIONS(1849),
    [sym_true] = ACTIONS(1849),
    [anon_sym_throw] = ACTIONS(1849),
    [anon_sym_protected] = ACTIONS(1849),
    [anon_sym_abstract] = ACTIONS(1849),
    [anon_sym_set] = ACTIONS(1849),
    [anon_sym_type] = ACTIONS(1849),
    [anon_sym_import] = ACTIONS(1849),
    [anon_sym_namespace] = ACTIONS(1849),
    [anon_sym_PLUS_PLUS] = ACTIONS(1851),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DQUOTE] = ACTIONS(1851),
    [anon_sym_else] = ACTIONS(1849),
    [anon_sym_BANG] = ACTIONS(1851),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_LBRACK] = ACTIONS(1851),
    [sym_false] = ACTIONS(1849),
    [anon_sym_SEMI] = ACTIONS(1851),
    [anon_sym_case] = ACTIONS(1849),
    [anon_sym_module] = ACTIONS(1849),
    [anon_sym_number] = ACTIONS(1849),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_declare] = ACTIONS(1849),
    [anon_sym_typeof] = ACTIONS(1849),
    [anon_sym_LBRACE] = ACTIONS(1851),
    [anon_sym_switch] = ACTIONS(1849),
    [anon_sym_LPAREN] = ACTIONS(1851),
    [sym_null] = ACTIONS(1849),
    [anon_sym_any] = ACTIONS(1849),
    [anon_sym_boolean] = ACTIONS(1849),
    [anon_sym_async] = ACTIONS(1849),
    [anon_sym_public] = ACTIONS(1849),
    [anon_sym_var] = ACTIONS(1849),
    [anon_sym_while] = ACTIONS(1849),
    [anon_sym_SQUOTE] = ACTIONS(1851),
    [anon_sym_try] = ACTIONS(1849),
    [anon_sym_RPAREN] = ACTIONS(1851),
    [anon_sym_LT] = ACTIONS(1851),
    [sym_number] = ACTIONS(1851),
    [anon_sym_SLASH] = ACTIONS(1849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1849),
    [anon_sym_function] = ACTIONS(1849),
    [sym_undefined] = ACTIONS(1849),
    [anon_sym_new] = ACTIONS(1849),
    [ts_builtin_sym_end] = ACTIONS(1851),
    [anon_sym_let] = ACTIONS(1849),
    [anon_sym_PLUS] = ACTIONS(1849),
    [anon_sym_export] = ACTIONS(1849),
    [anon_sym_do] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1851),
    [anon_sym_with] = ACTIONS(1849),
  },
  [325] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [anon_sym_BANG] = ACTIONS(1855),
    [anon_sym_SEMI] = ACTIONS(1853),
    [anon_sym_BQUOTE] = ACTIONS(1853),
    [sym__automatic_semicolon] = ACTIONS(1853),
    [anon_sym_PIPE] = ACTIONS(1855),
    [anon_sym_COMMA] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(1853),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_GT_GT_GT] = ACTIONS(1853),
    [anon_sym_AMP_AMP] = ACTIONS(1853),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_BANG_EQ] = ACTIONS(1855),
    [anon_sym_LT_EQ] = ACTIONS(1853),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_GT_EQ] = ACTIONS(1853),
    [anon_sym_GT] = ACTIONS(1855),
    [anon_sym_AMP] = ACTIONS(1855),
    [anon_sym_PERCENT] = ACTIONS(1853),
    [anon_sym_QMARK] = ACTIONS(1853),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_as] = ACTIONS(1853),
    [anon_sym_PIPE_PIPE] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_EQ_EQ] = ACTIONS(1855),
    [anon_sym_instanceof] = ACTIONS(1853),
    [anon_sym_LT] = ACTIONS(1855),
    [anon_sym_RPAREN] = ACTIONS(1853),
    [anon_sym_SLASH] = ACTIONS(1855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1853),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_STAR_STAR] = ACTIONS(1853),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_GT_GT] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1853),
    [anon_sym_in] = ACTIONS(1855),
  },
  [326] = {
    [sym_new_expression] = STATE(904),
    [sym_augmented_assignment_expression] = STATE(904),
    [sym_unary_expression] = STATE(904),
    [sym_update_expression] = STATE(904),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(904),
    [sym_regex] = STATE(904),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(904),
    [sym_non_null_expression] = STATE(904),
    [sym_as_expression] = STATE(904),
    [sym_jsx_fragment] = STATE(904),
    [sym_yield_expression] = STATE(904),
    [sym_jsx_element] = STATE(904),
    [sym_internal_module] = STATE(904),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(904),
    [sym_await_expression] = STATE(904),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(904),
    [sym_this] = STATE(904),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(904),
    [sym_generator_function] = STATE(904),
    [sym_call_expression] = STATE(904),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(904),
    [sym_ternary_expression] = STATE(904),
    [sym_binary_expression] = STATE(904),
    [sym_template_string] = STATE(904),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(904),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(904),
    [sym_class] = STATE(904),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(1857),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1859),
    [sym_true] = ACTIONS(1857),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(1857),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [327] = {
    [sym_new_expression] = STATE(905),
    [sym_augmented_assignment_expression] = STATE(905),
    [sym_unary_expression] = STATE(905),
    [sym_update_expression] = STATE(905),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(905),
    [sym_regex] = STATE(905),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(905),
    [sym_non_null_expression] = STATE(905),
    [sym_as_expression] = STATE(905),
    [sym_jsx_fragment] = STATE(905),
    [sym_yield_expression] = STATE(905),
    [sym_jsx_element] = STATE(905),
    [sym_internal_module] = STATE(905),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(905),
    [sym_await_expression] = STATE(905),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(905),
    [sym_this] = STATE(905),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(905),
    [sym_generator_function] = STATE(905),
    [sym_call_expression] = STATE(905),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(905),
    [sym_ternary_expression] = STATE(905),
    [sym_binary_expression] = STATE(905),
    [sym_template_string] = STATE(905),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(905),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(905),
    [sym_class] = STATE(905),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(1861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(1861),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1863),
    [sym_true] = ACTIONS(1861),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(1861),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [328] = {
    [sym_new_expression] = STATE(906),
    [sym_augmented_assignment_expression] = STATE(906),
    [sym_unary_expression] = STATE(906),
    [sym_update_expression] = STATE(906),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(906),
    [sym_regex] = STATE(906),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(906),
    [sym_non_null_expression] = STATE(906),
    [sym_as_expression] = STATE(906),
    [sym_jsx_fragment] = STATE(906),
    [sym_yield_expression] = STATE(906),
    [sym_jsx_element] = STATE(906),
    [sym_internal_module] = STATE(906),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(906),
    [sym_await_expression] = STATE(906),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(906),
    [sym_this] = STATE(906),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(906),
    [sym_generator_function] = STATE(906),
    [sym_call_expression] = STATE(906),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(906),
    [sym_ternary_expression] = STATE(906),
    [sym_binary_expression] = STATE(906),
    [sym_template_string] = STATE(906),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(906),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(906),
    [sym_class] = STATE(906),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(1865),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(1865),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1867),
    [sym_true] = ACTIONS(1865),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(1865),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [329] = {
    [sym_new_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_unary_expression] = STATE(907),
    [sym_update_expression] = STATE(907),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(907),
    [sym_regex] = STATE(907),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(907),
    [sym_non_null_expression] = STATE(907),
    [sym_as_expression] = STATE(907),
    [sym_jsx_fragment] = STATE(907),
    [sym_yield_expression] = STATE(907),
    [sym_jsx_element] = STATE(907),
    [sym_internal_module] = STATE(907),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(907),
    [sym_await_expression] = STATE(907),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(907),
    [sym_this] = STATE(907),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(907),
    [sym_generator_function] = STATE(907),
    [sym_call_expression] = STATE(907),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(907),
    [sym_ternary_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_template_string] = STATE(907),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(907),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(907),
    [sym_class] = STATE(907),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(1869),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(1869),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1871),
    [sym_true] = ACTIONS(1869),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(1869),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [330] = {
    [sym_new_expression] = STATE(908),
    [sym_augmented_assignment_expression] = STATE(908),
    [sym_unary_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(908),
    [sym_regex] = STATE(908),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(908),
    [sym_non_null_expression] = STATE(908),
    [sym_as_expression] = STATE(908),
    [sym_jsx_fragment] = STATE(908),
    [sym_yield_expression] = STATE(908),
    [sym_jsx_element] = STATE(908),
    [sym_internal_module] = STATE(908),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(908),
    [sym_await_expression] = STATE(908),
    [sym_member_expression] = STATE(54),
    [sym_sequence_expression] = STATE(909),
    [sym_string] = STATE(908),
    [sym_this] = STATE(908),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(908),
    [sym_generator_function] = STATE(908),
    [sym_call_expression] = STATE(908),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(908),
    [sym_ternary_expression] = STATE(908),
    [sym_binary_expression] = STATE(908),
    [sym_template_string] = STATE(908),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(908),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(908),
    [sym_class] = STATE(908),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(1873),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(1873),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1875),
    [sym_true] = ACTIONS(1873),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(1873),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [331] = {
    [sym_new_expression] = STATE(922),
    [sym_augmented_assignment_expression] = STATE(922),
    [sym_unary_expression] = STATE(922),
    [sym_update_expression] = STATE(922),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(922),
    [sym_regex] = STATE(922),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(922),
    [sym_non_null_expression] = STATE(922),
    [sym_as_expression] = STATE(922),
    [sym_jsx_fragment] = STATE(922),
    [sym_yield_expression] = STATE(922),
    [sym_jsx_element] = STATE(922),
    [sym_internal_module] = STATE(922),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(922),
    [sym_await_expression] = STATE(922),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(922),
    [sym_this] = STATE(922),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(922),
    [sym_generator_function] = STATE(922),
    [sym_call_expression] = STATE(922),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(922),
    [sym_ternary_expression] = STATE(922),
    [sym_binary_expression] = STATE(922),
    [sym_template_string] = STATE(922),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(922),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(922),
    [sym_class] = STATE(922),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(1881),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1881),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1895),
    [sym_true] = ACTIONS(1881),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1881),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [332] = {
    [sym_union_type] = STATE(941),
    [sym__type] = STATE(941),
    [sym_constructor_type] = STATE(941),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(943),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_template_string] = STATE(945),
    [sym_intersection_type] = STATE(941),
    [sym_function_type] = STATE(941),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(947),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(1905),
    [sym_false] = ACTIONS(1907),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_keyof] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_PIPE] = ACTIONS(1923),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_boolean] = ACTIONS(1911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(1929),
    [anon_sym_QMARK] = ACTIONS(1931),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1933),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_new] = ACTIONS(1937),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [333] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(839),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_SEMI] = ACTIONS(839),
    [anon_sym_BQUOTE] = ACTIONS(839),
    [sym__automatic_semicolon] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_RBRACE] = ACTIONS(839),
    [anon_sym_as] = ACTIONS(839),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_instanceof] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_RPAREN] = ACTIONS(839),
    [anon_sym_SLASH] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_in] = ACTIONS(841),
  },
  [334] = {
    [sym_new_expression] = STATE(345),
    [sym_constructor_type] = STATE(432),
    [sym_augmented_assignment_expression] = STATE(345),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(345),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(345),
    [sym_type_parameters] = STATE(959),
    [sym_array_type] = STATE(436),
    [sym_yield_expression] = STATE(345),
    [sym_as_expression] = STATE(345),
    [sym_jsx_fragment] = STATE(345),
    [sym_internal_module] = STATE(345),
    [sym_arrow_function] = STATE(345),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(54),
    [sym_literal_type] = STATE(436),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(949),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(345),
    [sym_subscript_expression] = STATE(54),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(345),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(345),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(960),
    [sym_function_type] = STATE(432),
    [sym__type] = STATE(432),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(345),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(345),
    [sym__expression] = STATE(345),
    [sym_non_null_expression] = STATE(345),
    [sym_jsx_element] = STATE(345),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(88),
    [sym_await_expression] = STATE(345),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_this] = STATE(345),
    [sym_union_type] = STATE(432),
    [sym_anonymous_class] = STATE(345),
    [sym_call_expression] = STATE(345),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(345),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(345),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(432),
    [sym_parenthesized_expression] = STATE(345),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(345),
    [sym_class] = STATE(345),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(1939),
    [sym_false] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(1943),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(1945),
    [anon_sym_number] = ACTIONS(1945),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(1947),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_void] = ACTIONS(1953),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(1955),
    [sym_null] = ACTIONS(598),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1945),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1957),
    [sym_true] = ACTIONS(1941),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(1959),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(1945),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(598),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(1961),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [335] = {
    [sym_new_expression] = STATE(961),
    [sym_augmented_assignment_expression] = STATE(961),
    [sym_unary_expression] = STATE(961),
    [sym_update_expression] = STATE(961),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(961),
    [sym_regex] = STATE(961),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(961),
    [sym_non_null_expression] = STATE(961),
    [sym_as_expression] = STATE(961),
    [sym_jsx_fragment] = STATE(961),
    [sym_yield_expression] = STATE(961),
    [sym_jsx_element] = STATE(961),
    [sym_internal_module] = STATE(961),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(961),
    [sym_await_expression] = STATE(961),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(961),
    [sym_this] = STATE(961),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(961),
    [sym_generator_function] = STATE(961),
    [sym_call_expression] = STATE(961),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(961),
    [sym_ternary_expression] = STATE(961),
    [sym_binary_expression] = STATE(961),
    [sym_template_string] = STATE(961),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(961),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(961),
    [sym_class] = STATE(961),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(1963),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(1963),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1965),
    [sym_true] = ACTIONS(1963),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(1963),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [336] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1967),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_BANG] = ACTIONS(1969),
    [anon_sym_SEMI] = ACTIONS(1967),
    [anon_sym_BQUOTE] = ACTIONS(1967),
    [sym__automatic_semicolon] = ACTIONS(1967),
    [anon_sym_PIPE] = ACTIONS(1969),
    [anon_sym_COMMA] = ACTIONS(1967),
    [anon_sym_LT_LT] = ACTIONS(1967),
    [anon_sym_STAR] = ACTIONS(1969),
    [anon_sym_GT_GT_GT] = ACTIONS(1967),
    [anon_sym_AMP_AMP] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1969),
    [anon_sym_BANG_EQ] = ACTIONS(1969),
    [anon_sym_LT_EQ] = ACTIONS(1967),
    [anon_sym_LPAREN] = ACTIONS(1967),
    [anon_sym_GT_EQ] = ACTIONS(1967),
    [anon_sym_GT] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(1969),
    [anon_sym_PERCENT] = ACTIONS(1967),
    [anon_sym_QMARK] = ACTIONS(1967),
    [anon_sym_RBRACE] = ACTIONS(1967),
    [anon_sym_as] = ACTIONS(1967),
    [anon_sym_PIPE_PIPE] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_EQ_EQ] = ACTIONS(1969),
    [anon_sym_instanceof] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1969),
    [anon_sym_RPAREN] = ACTIONS(1967),
    [anon_sym_SLASH] = ACTIONS(1969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1967),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_STAR_STAR] = ACTIONS(1967),
    [anon_sym_PLUS] = ACTIONS(1969),
    [anon_sym_GT_GT] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1967),
    [anon_sym_in] = ACTIONS(1969),
  },
  [337] = {
    [sym_nested_identifier] = STATE(965),
    [sym_jsx_namespace_name] = STATE(966),
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(1973),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1975),
  },
  [338] = {
    [sym_new_expression] = STATE(969),
    [sym_augmented_assignment_expression] = STATE(969),
    [sym_unary_expression] = STATE(969),
    [sym_update_expression] = STATE(969),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(969),
    [sym_regex] = STATE(969),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(969),
    [sym_non_null_expression] = STATE(969),
    [sym_as_expression] = STATE(969),
    [sym_jsx_fragment] = STATE(969),
    [sym_yield_expression] = STATE(969),
    [sym_jsx_element] = STATE(969),
    [sym_internal_module] = STATE(969),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(969),
    [sym_await_expression] = STATE(969),
    [sym_member_expression] = STATE(363),
    [sym_spread_element] = STATE(970),
    [sym_sequence_expression] = STATE(970),
    [sym_string] = STATE(969),
    [sym_this] = STATE(969),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(969),
    [sym_generator_function] = STATE(969),
    [sym_call_expression] = STATE(969),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(969),
    [sym_ternary_expression] = STATE(969),
    [sym_binary_expression] = STATE(969),
    [sym_template_string] = STATE(969),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(969),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(969),
    [sym_class] = STATE(969),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(1977),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1977),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1983),
    [sym_true] = ACTIONS(1977),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [339] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_BANG] = ACTIONS(1987),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_BQUOTE] = ACTIONS(1985),
    [sym__automatic_semicolon] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_LT_LT] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_GT_GT_GT] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_BANG_EQ] = ACTIONS(1987),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_LPAREN] = ACTIONS(1985),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_GT] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1985),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_RBRACE] = ACTIONS(1985),
    [anon_sym_as] = ACTIONS(1985),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_EQ_EQ] = ACTIONS(1987),
    [anon_sym_instanceof] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_SLASH] = ACTIONS(1987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1985),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_STAR_STAR] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_GT_GT] = ACTIONS(1987),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1985),
    [anon_sym_in] = ACTIONS(1987),
  },
  [340] = {
    [sym_jsx_closing_element] = STATE(972),
    [sym_jsx_opening_element] = STATE(340),
    [aux_sym_jsx_element_repeat1] = STATE(973),
    [sym_jsx_expression] = STATE(973),
    [sym_jsx_self_closing_element] = STATE(973),
    [sym_jsx_element] = STATE(973),
    [sym_jsx_text] = ACTIONS(1989),
    [anon_sym_LT] = ACTIONS(1991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(590),
  },
  [341] = {
    [sym_jsx_closing_element] = STATE(974),
    [sym_jsx_opening_element] = STATE(340),
    [aux_sym_jsx_element_repeat1] = STATE(975),
    [sym_jsx_expression] = STATE(975),
    [sym_jsx_self_closing_element] = STATE(975),
    [sym_jsx_element] = STATE(975),
    [sym_jsx_text] = ACTIONS(1993),
    [anon_sym_LT] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(590),
  },
  [342] = {
    [sym_type_alias_declaration] = STATE(976),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(976),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(976),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(976),
    [sym_return_statement] = STATE(976),
    [aux_sym_program_repeat1] = STATE(976),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [aux_sym_object_repeat1] = STATE(220),
    [sym_accessibility_modifier] = STATE(221),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(976),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(976),
    [sym_spread_element] = STATE(222),
    [sym_switch_statement] = STATE(976),
    [sym_string] = STATE(216),
    [sym_try_statement] = STATE(976),
    [sym_throw_statement] = STATE(976),
    [aux_sym_export_statement_repeat1] = STATE(223),
    [sym__property_name] = STATE(224),
    [sym_object] = STATE(225),
    [sym_ambient_declaration] = STATE(976),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(976),
    [sym_decorator] = STATE(223),
    [sym_continue_statement] = STATE(976),
    [sym_formal_parameters] = STATE(57),
    [sym_computed_property_name] = STATE(224),
    [sym_function_signature] = STATE(976),
    [sym_abstract_class] = STATE(976),
    [sym_interface_declaration] = STATE(976),
    [sym_statement_block] = STATE(976),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(976),
    [sym_debugger_statement] = STATE(976),
    [sym_method_definition] = STATE(222),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(976),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(976),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(976),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(976),
    [sym_empty_statement] = STATE(976),
    [sym_pair] = STATE(222),
    [sym_assignment_pattern] = STATE(222),
    [sym_import_alias] = STATE(976),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(976),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(976),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(976),
    [sym_break_statement] = STATE(976),
    [sym_labeled_statement] = STATE(976),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(226),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(976),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(356),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(358),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(364),
    [anon_sym_void] = ACTIONS(366),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(368),
    [anon_sym_static] = ACTIONS(370),
    [anon_sym_get] = ACTIONS(372),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(368),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(372),
    [anon_sym_type] = ACTIONS(378),
    [anon_sym_import] = ACTIONS(380),
    [anon_sym_namespace] = ACTIONS(382),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_readonly] = ACTIONS(384),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(388),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(390),
    [anon_sym_number] = ACTIONS(358),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(392),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(358),
    [anon_sym_boolean] = ACTIONS(358),
    [anon_sym_async] = ACTIONS(396),
    [anon_sym_public] = ACTIONS(368),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(400),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(402),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [343] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_BANG] = ACTIONS(1997),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_BQUOTE] = ACTIONS(1995),
    [sym__automatic_semicolon] = ACTIONS(1995),
    [anon_sym_PIPE] = ACTIONS(1997),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT_GT] = ACTIONS(1995),
    [anon_sym_AMP_AMP] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_BANG_EQ] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_QMARK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [anon_sym_as] = ACTIONS(1995),
    [anon_sym_PIPE_PIPE] = ACTIONS(1995),
    [anon_sym_DASH_DASH] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1997),
    [anon_sym_instanceof] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1997),
    [anon_sym_PLUS_PLUS] = ACTIONS(1995),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1997),
  },
  [344] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1995),
    [anon_sym_PIPE] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(560),
    [anon_sym_STAR] = ACTIONS(566),
    [anon_sym_GT_GT_GT] = ACTIONS(560),
    [anon_sym_AMP_AMP] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(570),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(554),
    [anon_sym_in] = ACTIONS(125),
  },
  [345] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(560),
    [anon_sym_STAR] = ACTIONS(566),
    [anon_sym_GT_GT_GT] = ACTIONS(560),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [346] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(2003),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(2003),
    [anon_sym_LT_LT] = ACTIONS(560),
    [anon_sym_STAR] = ACTIONS(566),
    [anon_sym_GT_GT_GT] = ACTIONS(560),
    [anon_sym_AMP_AMP] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(570),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(554),
    [anon_sym_in] = ACTIONS(125),
  },
  [347] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(2005),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2005),
    [anon_sym_PIPE] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(2005),
    [anon_sym_LT_LT] = ACTIONS(560),
    [anon_sym_STAR] = ACTIONS(566),
    [anon_sym_GT_GT_GT] = ACTIONS(560),
    [anon_sym_AMP_AMP] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(570),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(554),
    [anon_sym_in] = ACTIONS(125),
  },
  [348] = {
    [sym_identifier] = ACTIONS(2007),
    [anon_sym_BQUOTE] = ACTIONS(2009),
    [anon_sym_debugger] = ACTIONS(2007),
    [anon_sym_symbol] = ACTIONS(2007),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_void] = ACTIONS(2007),
    [anon_sym_break] = ACTIONS(2007),
    [anon_sym_const] = ACTIONS(2007),
    [sym_super] = ACTIONS(2007),
    [anon_sym_return] = ACTIONS(2007),
    [anon_sym_private] = ACTIONS(2007),
    [anon_sym_get] = ACTIONS(2007),
    [anon_sym_RBRACE] = ACTIONS(2009),
    [anon_sym_interface] = ACTIONS(2007),
    [anon_sym_default] = ACTIONS(2007),
    [anon_sym_enum] = ACTIONS(2007),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_continue] = ACTIONS(2007),
    [anon_sym_DASH_DASH] = ACTIONS(2009),
    [anon_sym_if] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(2007),
    [anon_sym_yield] = ACTIONS(2007),
    [sym_true] = ACTIONS(2007),
    [anon_sym_throw] = ACTIONS(2007),
    [anon_sym_protected] = ACTIONS(2007),
    [anon_sym_abstract] = ACTIONS(2007),
    [anon_sym_set] = ACTIONS(2007),
    [anon_sym_type] = ACTIONS(2007),
    [anon_sym_import] = ACTIONS(2007),
    [anon_sym_namespace] = ACTIONS(2007),
    [anon_sym_PLUS_PLUS] = ACTIONS(2009),
    [anon_sym_await] = ACTIONS(2007),
    [anon_sym_DQUOTE] = ACTIONS(2009),
    [anon_sym_else] = ACTIONS(2007),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_for] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(2009),
    [sym_false] = ACTIONS(2007),
    [anon_sym_SEMI] = ACTIONS(2009),
    [anon_sym_case] = ACTIONS(2007),
    [anon_sym_module] = ACTIONS(2007),
    [anon_sym_number] = ACTIONS(2007),
    [anon_sym_class] = ACTIONS(2007),
    [anon_sym_declare] = ACTIONS(2007),
    [anon_sym_typeof] = ACTIONS(2007),
    [anon_sym_LBRACE] = ACTIONS(2009),
    [anon_sym_switch] = ACTIONS(2007),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [sym_null] = ACTIONS(2007),
    [anon_sym_any] = ACTIONS(2007),
    [anon_sym_boolean] = ACTIONS(2007),
    [anon_sym_async] = ACTIONS(2007),
    [anon_sym_public] = ACTIONS(2007),
    [anon_sym_var] = ACTIONS(2007),
    [anon_sym_while] = ACTIONS(2007),
    [anon_sym_SQUOTE] = ACTIONS(2009),
    [anon_sym_try] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2009),
    [sym_number] = ACTIONS(2009),
    [anon_sym_SLASH] = ACTIONS(2007),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2007),
    [anon_sym_function] = ACTIONS(2007),
    [sym_undefined] = ACTIONS(2007),
    [anon_sym_new] = ACTIONS(2007),
    [ts_builtin_sym_end] = ACTIONS(2009),
    [anon_sym_let] = ACTIONS(2007),
    [anon_sym_PLUS] = ACTIONS(2007),
    [anon_sym_export] = ACTIONS(2007),
    [anon_sym_do] = ACTIONS(2007),
    [anon_sym_TILDE] = ACTIONS(2009),
    [anon_sym_with] = ACTIONS(2007),
  },
  [349] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_SEMI] = ACTIONS(2011),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [sym__automatic_semicolon] = ACTIONS(2011),
    [anon_sym_PERCENT_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_AMP_EQ] = ACTIONS(2011),
    [anon_sym_PLUS_EQ] = ACTIONS(2011),
    [anon_sym_PIPE] = ACTIONS(2013),
    [anon_sym_COMMA] = ACTIONS(2011),
    [anon_sym_LT_LT] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_GT_GT_GT] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_CARET_EQ] = ACTIONS(2011),
    [anon_sym_STAR_EQ] = ACTIONS(2011),
    [anon_sym_PIPE_EQ] = ACTIONS(2011),
    [anon_sym_DASH_EQ] = ACTIONS(2011),
    [anon_sym_AMP] = ACTIONS(2013),
    [anon_sym_PERCENT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_LT_LT_EQ] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2011),
    [anon_sym_RBRACE] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_instanceof] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_RPAREN] = ACTIONS(2011),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_DOT] = ACTIONS(2011),
    [anon_sym_CARET] = ACTIONS(2013),
    [anon_sym_STAR_STAR] = ACTIONS(2013),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2013),
  },
  [350] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2015),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2015),
    [anon_sym_AMP_EQ] = ACTIONS(2015),
    [anon_sym_PLUS_EQ] = ACTIONS(2015),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(2017),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2015),
    [anon_sym_STAR_EQ] = ACTIONS(2015),
    [anon_sym_PIPE_EQ] = ACTIONS(2015),
    [anon_sym_DASH_EQ] = ACTIONS(2015),
    [anon_sym_EQ_GT] = ACTIONS(2019),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2015),
    [anon_sym_GT_GT_EQ] = ACTIONS(2015),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2015),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2021),
  },
  [351] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2023),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2023),
    [anon_sym_AMP_EQ] = ACTIONS(2023),
    [anon_sym_PLUS_EQ] = ACTIONS(2023),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2017),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(2023),
    [anon_sym_STAR_EQ] = ACTIONS(2023),
    [anon_sym_PIPE_EQ] = ACTIONS(2023),
    [anon_sym_DASH_EQ] = ACTIONS(2023),
    [anon_sym_EQ_GT] = ACTIONS(2025),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(2023),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2023),
    [anon_sym_GT_GT_EQ] = ACTIONS(2023),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2023),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [352] = {
    [sym_new_expression] = STATE(983),
    [sym_augmented_assignment_expression] = STATE(983),
    [sym_unary_expression] = STATE(983),
    [sym_update_expression] = STATE(983),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(983),
    [sym_regex] = STATE(983),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(983),
    [sym_non_null_expression] = STATE(983),
    [sym_as_expression] = STATE(983),
    [sym_jsx_fragment] = STATE(983),
    [sym_yield_expression] = STATE(983),
    [sym_jsx_element] = STATE(983),
    [sym_internal_module] = STATE(983),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(983),
    [sym_await_expression] = STATE(983),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(983),
    [sym_this] = STATE(983),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(983),
    [sym_generator_function] = STATE(983),
    [sym_call_expression] = STATE(983),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(983),
    [sym_ternary_expression] = STATE(983),
    [sym_binary_expression] = STATE(983),
    [sym_template_string] = STATE(983),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(983),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(983),
    [sym_class] = STATE(983),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(2027),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2027),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2029),
    [sym_true] = ACTIONS(2027),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2027),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [353] = {
    [sym_new_expression] = STATE(984),
    [sym_augmented_assignment_expression] = STATE(984),
    [sym_unary_expression] = STATE(984),
    [sym_update_expression] = STATE(984),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(984),
    [sym_regex] = STATE(984),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(984),
    [sym_non_null_expression] = STATE(984),
    [sym_as_expression] = STATE(984),
    [sym_jsx_fragment] = STATE(984),
    [sym_yield_expression] = STATE(984),
    [sym_jsx_element] = STATE(984),
    [sym_internal_module] = STATE(984),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(984),
    [sym_await_expression] = STATE(984),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(984),
    [sym_this] = STATE(984),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(984),
    [sym_generator_function] = STATE(984),
    [sym_call_expression] = STATE(984),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(984),
    [sym_ternary_expression] = STATE(984),
    [sym_binary_expression] = STATE(984),
    [sym_template_string] = STATE(984),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(984),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(984),
    [sym_class] = STATE(984),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2031),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2033),
    [sym_true] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [354] = {
    [sym_new_expression] = STATE(983),
    [sym_augmented_assignment_expression] = STATE(983),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(983),
    [sym_update_expression] = STATE(983),
    [sym_regex] = STATE(983),
    [sym_meta_property] = STATE(983),
    [sym_call_signature] = STATE(361),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(983),
    [sym_non_null_expression] = STATE(983),
    [sym_yield_expression] = STATE(983),
    [sym_jsx_fragment] = STATE(983),
    [sym_jsx_element] = STATE(983),
    [sym_as_expression] = STATE(983),
    [sym_internal_module] = STATE(983),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(983),
    [sym_await_expression] = STATE(983),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(983),
    [sym_this] = STATE(983),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(983),
    [sym_generator_function] = STATE(983),
    [sym_call_expression] = STATE(983),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(983),
    [sym_ternary_expression] = STATE(983),
    [sym_binary_expression] = STATE(983),
    [sym_template_string] = STATE(983),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(983),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(983),
    [sym_class] = STATE(983),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(618),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2023),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_AMP_EQ] = ACTIONS(2023),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2023),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2017),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(2023),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_PIPE_EQ] = ACTIONS(2023),
    [anon_sym_DASH_EQ] = ACTIONS(2023),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2023),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(636),
    [sym_true] = ACTIONS(2027),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_GT_GT_EQ] = ACTIONS(2023),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2023),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(624),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2027),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2023),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2027),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_STAR_EQ] = ACTIONS(2023),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_EQ_GT] = ACTIONS(2025),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(2029),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2023),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2027),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [355] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_call_signature] = STATE(985),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2035),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2023),
    [anon_sym_symbol] = ACTIONS(2037),
    [anon_sym_AMP_EQ] = ACTIONS(2023),
    [anon_sym_PLUS_EQ] = ACTIONS(2023),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2017),
    [anon_sym_void] = ACTIONS(2037),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(2023),
    [anon_sym_private] = ACTIONS(2037),
    [anon_sym_PIPE_EQ] = ACTIONS(2023),
    [anon_sym_DASH_EQ] = ACTIONS(2023),
    [anon_sym_get] = ACTIONS(2037),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2023),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(2037),
    [anon_sym_GT_GT_EQ] = ACTIONS(2023),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(2037),
    [anon_sym_type] = ACTIONS(2037),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2037),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2023),
    [anon_sym_namespace] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(2037),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2023),
    [anon_sym_number] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2037),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(2037),
    [anon_sym_STAR_EQ] = ACTIONS(2023),
    [anon_sym_boolean] = ACTIONS(2037),
    [anon_sym_async] = ACTIONS(2037),
    [anon_sym_public] = ACTIONS(2037),
    [anon_sym_EQ_GT] = ACTIONS(2025),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2023),
    [anon_sym_string] = ACTIONS(2037),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(2037),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [356] = {
    [sym_new_expression] = STATE(987),
    [sym_augmented_assignment_expression] = STATE(987),
    [sym_unary_expression] = STATE(987),
    [sym_update_expression] = STATE(987),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(987),
    [sym_regex] = STATE(987),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(987),
    [sym_non_null_expression] = STATE(987),
    [sym_as_expression] = STATE(987),
    [sym_jsx_fragment] = STATE(987),
    [sym_yield_expression] = STATE(987),
    [sym_jsx_element] = STATE(987),
    [sym_internal_module] = STATE(987),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(987),
    [sym_await_expression] = STATE(987),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(987),
    [sym_this] = STATE(987),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(987),
    [sym_generator_function] = STATE(987),
    [sym_call_expression] = STATE(987),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(987),
    [sym_ternary_expression] = STATE(987),
    [sym_binary_expression] = STATE(987),
    [sym_template_string] = STATE(987),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(987),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(987),
    [sym_class] = STATE(987),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(2039),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2039),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2041),
    [sym_true] = ACTIONS(2039),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2039),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [357] = {
    [sym_new_expression] = STATE(988),
    [sym_augmented_assignment_expression] = STATE(988),
    [sym_unary_expression] = STATE(988),
    [sym_update_expression] = STATE(988),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(988),
    [sym_regex] = STATE(988),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(988),
    [sym_non_null_expression] = STATE(988),
    [sym_as_expression] = STATE(988),
    [sym_jsx_fragment] = STATE(988),
    [sym_yield_expression] = STATE(988),
    [sym_jsx_element] = STATE(988),
    [sym_internal_module] = STATE(988),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(988),
    [sym_await_expression] = STATE(988),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(988),
    [sym_this] = STATE(988),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(988),
    [sym_generator_function] = STATE(988),
    [sym_call_expression] = STATE(988),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(988),
    [sym_ternary_expression] = STATE(988),
    [sym_binary_expression] = STATE(988),
    [sym_template_string] = STATE(988),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(988),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(988),
    [sym_class] = STATE(988),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(618),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_RBRACE] = ACTIONS(211),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(636),
    [sym_true] = ACTIONS(2043),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(624),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2043),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(2045),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2043),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [358] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(2047),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(2049),
    [anon_sym_symbol] = ACTIONS(2049),
    [anon_sym_number] = ACTIONS(2049),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2049),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2051),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2049),
    [anon_sym_private] = ACTIONS(2049),
    [anon_sym_boolean] = ACTIONS(2049),
    [anon_sym_async] = ACTIONS(2053),
    [anon_sym_public] = ACTIONS(2049),
    [anon_sym_get] = ACTIONS(2049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2049),
    [anon_sym_string] = ACTIONS(2049),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(2049),
    [anon_sym_type] = ACTIONS(2049),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(2049),
    [anon_sym_export] = ACTIONS(2049),
    [anon_sym_namespace] = ACTIONS(2055),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [359] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(2023),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2023),
    [anon_sym_AMP_EQ] = ACTIONS(2023),
    [anon_sym_PLUS_EQ] = ACTIONS(2023),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2017),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(2023),
    [anon_sym_STAR_EQ] = ACTIONS(2023),
    [anon_sym_PIPE_EQ] = ACTIONS(2023),
    [anon_sym_DASH_EQ] = ACTIONS(2023),
    [anon_sym_EQ_GT] = ACTIONS(2025),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(2023),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2023),
    [anon_sym_GT_GT_EQ] = ACTIONS(2023),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2023),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [360] = {
    [sym_new_expression] = STATE(994),
    [sym_augmented_assignment_expression] = STATE(994),
    [sym_unary_expression] = STATE(994),
    [sym_update_expression] = STATE(994),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(994),
    [sym_regex] = STATE(994),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(994),
    [sym_non_null_expression] = STATE(994),
    [sym_as_expression] = STATE(994),
    [sym_jsx_fragment] = STATE(994),
    [sym_yield_expression] = STATE(994),
    [sym_jsx_element] = STATE(994),
    [sym_internal_module] = STATE(994),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(994),
    [sym_await_expression] = STATE(994),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(994),
    [sym_this] = STATE(994),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(994),
    [sym_generator_function] = STATE(994),
    [sym_call_expression] = STATE(994),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(994),
    [sym_ternary_expression] = STATE(994),
    [sym_binary_expression] = STATE(994),
    [sym_template_string] = STATE(994),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(994),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(994),
    [sym_class] = STATE(994),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(2057),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2057),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2059),
    [sym_true] = ACTIONS(2057),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [361] = {
    [anon_sym_EQ_GT] = ACTIONS(2019),
    [sym_comment] = ACTIONS(3),
  },
  [362] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2021),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_BANG_EQ] = ACTIONS(2021),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2021),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_QMARK] = ACTIONS(2077),
    [anon_sym_RBRACE] = ACTIONS(2079),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2021),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2081),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [363] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2015),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2015),
    [anon_sym_AMP_EQ] = ACTIONS(2015),
    [anon_sym_PLUS_EQ] = ACTIONS(2015),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(2017),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2015),
    [anon_sym_STAR_EQ] = ACTIONS(2015),
    [anon_sym_PIPE_EQ] = ACTIONS(2015),
    [anon_sym_DASH_EQ] = ACTIONS(2015),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2015),
    [anon_sym_GT_GT_EQ] = ACTIONS(2015),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2015),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [364] = {
    [anon_sym_RBRACE] = ACTIONS(2079),
    [sym_comment] = ACTIONS(3),
  },
  [365] = {
    [sym__initializer] = STATE(587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(2017),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2021),
  },
  [366] = {
    [sym__initializer] = STATE(589),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(2017),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2021),
  },
  [367] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(2091),
    [anon_sym_SEMI] = ACTIONS(2089),
    [anon_sym_BQUOTE] = ACTIONS(2089),
    [sym__automatic_semicolon] = ACTIONS(2089),
    [anon_sym_PIPE] = ACTIONS(2091),
    [anon_sym_COMMA] = ACTIONS(2089),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2091),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_AMP_AMP] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2091),
    [anon_sym_LT_EQ] = ACTIONS(2089),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_GT_EQ] = ACTIONS(2089),
    [anon_sym_GT] = ACTIONS(2091),
    [anon_sym_AMP] = ACTIONS(2091),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2089),
    [anon_sym_RBRACE] = ACTIONS(2089),
    [anon_sym_as] = ACTIONS(2089),
    [anon_sym_PIPE_PIPE] = ACTIONS(2089),
    [anon_sym_DASH_DASH] = ACTIONS(2089),
    [anon_sym_EQ_EQ] = ACTIONS(2091),
    [anon_sym_instanceof] = ACTIONS(2089),
    [anon_sym_LT] = ACTIONS(2091),
    [anon_sym_RPAREN] = ACTIONS(2089),
    [anon_sym_SLASH] = ACTIONS(2091),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2089),
    [anon_sym_CARET] = ACTIONS(2089),
    [anon_sym_STAR_STAR] = ACTIONS(2089),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_GT_GT] = ACTIONS(2091),
    [anon_sym_PLUS_PLUS] = ACTIONS(2089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2089),
    [anon_sym_in] = ACTIONS(2091),
  },
  [368] = {
    [aux_sym_template_string_repeat1] = STATE(368),
    [sym_template_substitution] = STATE(368),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2093),
    [sym_escape_sequence] = ACTIONS(2096),
    [anon_sym_BQUOTE] = ACTIONS(2099),
    [sym__template_chars] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
  },
  [369] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2101),
    [anon_sym_LBRACK] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_SEMI] = ACTIONS(2101),
    [anon_sym_BQUOTE] = ACTIONS(2101),
    [sym__automatic_semicolon] = ACTIONS(2101),
    [anon_sym_PIPE] = ACTIONS(2103),
    [anon_sym_COMMA] = ACTIONS(2101),
    [anon_sym_LT_LT] = ACTIONS(2101),
    [anon_sym_STAR] = ACTIONS(2103),
    [anon_sym_GT_GT_GT] = ACTIONS(2101),
    [anon_sym_AMP_AMP] = ACTIONS(2101),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2103),
    [anon_sym_LT_EQ] = ACTIONS(2101),
    [anon_sym_LPAREN] = ACTIONS(2101),
    [anon_sym_GT_EQ] = ACTIONS(2101),
    [anon_sym_GT] = ACTIONS(2103),
    [anon_sym_AMP] = ACTIONS(2103),
    [anon_sym_PERCENT] = ACTIONS(2101),
    [anon_sym_QMARK] = ACTIONS(2101),
    [anon_sym_RBRACE] = ACTIONS(2101),
    [anon_sym_as] = ACTIONS(2101),
    [anon_sym_PIPE_PIPE] = ACTIONS(2101),
    [anon_sym_DASH_DASH] = ACTIONS(2101),
    [anon_sym_EQ_EQ] = ACTIONS(2103),
    [anon_sym_instanceof] = ACTIONS(2101),
    [anon_sym_LT] = ACTIONS(2103),
    [anon_sym_RPAREN] = ACTIONS(2101),
    [anon_sym_SLASH] = ACTIONS(2103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2101),
    [anon_sym_CARET] = ACTIONS(2101),
    [anon_sym_STAR_STAR] = ACTIONS(2101),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_GT_GT] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(2101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2101),
    [anon_sym_in] = ACTIONS(2103),
  },
  [370] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(2101),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2101),
    [anon_sym_PIPE] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(2101),
    [anon_sym_LT_LT] = ACTIONS(560),
    [anon_sym_STAR] = ACTIONS(566),
    [anon_sym_GT_GT_GT] = ACTIONS(560),
    [anon_sym_AMP_AMP] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(570),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(554),
    [anon_sym_in] = ACTIONS(125),
  },
  [371] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(2105),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2105),
    [anon_sym_PIPE] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(560),
    [anon_sym_STAR] = ACTIONS(566),
    [anon_sym_GT_GT_GT] = ACTIONS(560),
    [anon_sym_AMP_AMP] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(570),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(554),
    [anon_sym_in] = ACTIONS(125),
  },
  [372] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2107),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_BANG] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym__automatic_semicolon] = ACTIONS(2107),
    [anon_sym_PERCENT_EQ] = ACTIONS(2107),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2107),
    [anon_sym_AMP_EQ] = ACTIONS(2107),
    [anon_sym_PLUS_EQ] = ACTIONS(2107),
    [anon_sym_PIPE] = ACTIONS(2109),
    [anon_sym_COMMA] = ACTIONS(2107),
    [anon_sym_LT_LT] = ACTIONS(2109),
    [anon_sym_STAR] = ACTIONS(2109),
    [anon_sym_GT_GT_GT] = ACTIONS(2109),
    [anon_sym_EQ] = ACTIONS(2109),
    [anon_sym_AMP_AMP] = ACTIONS(2107),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_BANG_EQ] = ACTIONS(2109),
    [anon_sym_LT_EQ] = ACTIONS(2107),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_GT_EQ] = ACTIONS(2107),
    [anon_sym_GT] = ACTIONS(2109),
    [anon_sym_CARET_EQ] = ACTIONS(2107),
    [anon_sym_STAR_EQ] = ACTIONS(2107),
    [anon_sym_PIPE_EQ] = ACTIONS(2107),
    [anon_sym_DASH_EQ] = ACTIONS(2107),
    [anon_sym_AMP] = ACTIONS(2109),
    [anon_sym_PERCENT] = ACTIONS(2109),
    [anon_sym_QMARK] = ACTIONS(2107),
    [anon_sym_LT_LT_EQ] = ACTIONS(2107),
    [anon_sym_as] = ACTIONS(2107),
    [anon_sym_PIPE_PIPE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_EQ_EQ] = ACTIONS(2109),
    [anon_sym_instanceof] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_RPAREN] = ACTIONS(2107),
    [anon_sym_SLASH] = ACTIONS(2109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2107),
    [anon_sym_GT_GT_EQ] = ACTIONS(2107),
    [anon_sym_DOT] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2109),
    [anon_sym_STAR_STAR] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2107),
    [anon_sym_GT_GT] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2107),
    [anon_sym_in] = ACTIONS(2109),
  },
  [373] = {
    [sym_identifier] = ACTIONS(2111),
    [sym_comment] = ACTIONS(3),
  },
  [374] = {
    [sym_new_expression] = STATE(1007),
    [sym_augmented_assignment_expression] = STATE(1007),
    [sym_unary_expression] = STATE(1007),
    [sym_update_expression] = STATE(1007),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(1007),
    [sym_regex] = STATE(1007),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1007),
    [sym_non_null_expression] = STATE(1007),
    [sym_as_expression] = STATE(1007),
    [sym_jsx_fragment] = STATE(1007),
    [sym_yield_expression] = STATE(1007),
    [sym_jsx_element] = STATE(1007),
    [sym_internal_module] = STATE(1007),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1007),
    [sym_await_expression] = STATE(1007),
    [sym_member_expression] = STATE(454),
    [sym_spread_element] = STATE(1008),
    [sym_string] = STATE(1007),
    [sym_this] = STATE(1007),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [aux_sym_array_repeat1] = STATE(1009),
    [sym_anonymous_class] = STATE(1007),
    [sym_generator_function] = STATE(1007),
    [sym_call_expression] = STATE(1007),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(1007),
    [sym_ternary_expression] = STATE(1007),
    [sym_binary_expression] = STATE(1007),
    [sym_template_string] = STATE(1007),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1007),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1007),
    [sym_class] = STATE(1007),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(2113),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(797),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2113),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_RPAREN] = ACTIONS(2115),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2117),
    [sym_true] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2113),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [375] = {
    [anon_sym_LBRACK] = ACTIONS(2119),
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2119),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [anon_sym_this] = ACTIONS(2121),
    [sym_number] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [sym_readonly] = ACTIONS(2121),
    [anon_sym_DQUOTE] = ACTIONS(2119),
  },
  [376] = {
    [sym__initializer] = STATE(1010),
    [aux_sym_object_repeat1] = STATE(662),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_EQ] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(362),
    [sym_comment] = ACTIONS(3),
  },
  [377] = {
    [sym_new_expression] = STATE(1011),
    [sym_augmented_assignment_expression] = STATE(1011),
    [sym_unary_expression] = STATE(1011),
    [sym_update_expression] = STATE(1011),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(1011),
    [sym_regex] = STATE(1011),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1011),
    [sym_non_null_expression] = STATE(1011),
    [sym_as_expression] = STATE(1011),
    [sym_jsx_fragment] = STATE(1011),
    [sym_yield_expression] = STATE(1011),
    [sym_jsx_element] = STATE(1011),
    [sym_internal_module] = STATE(1011),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1011),
    [sym_await_expression] = STATE(1011),
    [sym_member_expression] = STATE(162),
    [sym_spread_element] = STATE(395),
    [sym_string] = STATE(1011),
    [sym_this] = STATE(1011),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [aux_sym_array_repeat1] = STATE(396),
    [sym_anonymous_class] = STATE(1011),
    [sym_generator_function] = STATE(1011),
    [sym_call_expression] = STATE(1011),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(1011),
    [sym_ternary_expression] = STATE(1011),
    [sym_binary_expression] = STATE(1011),
    [sym_template_string] = STATE(1011),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1011),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1011),
    [sym_class] = STATE(1011),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(268),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(723),
    [sym_null] = ACTIONS(2125),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2127),
    [sym_true] = ACTIONS(2125),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [378] = {
    [aux_sym_object_repeat1] = STATE(662),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(362),
    [sym_comment] = ACTIONS(3),
  },
  [379] = {
    [aux_sym_object_repeat1] = STATE(662),
    [anon_sym_LBRACK] = ACTIONS(1238),
    [sym_identifier] = ACTIONS(1236),
    [anon_sym_module] = ACTIONS(1236),
    [anon_sym_symbol] = ACTIONS(1236),
    [anon_sym_number] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1236),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_STAR] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1236),
    [anon_sym_private] = ACTIONS(1236),
    [anon_sym_boolean] = ACTIONS(1236),
    [anon_sym_async] = ACTIONS(1236),
    [anon_sym_public] = ACTIONS(1236),
    [anon_sym_get] = ACTIONS(1236),
    [anon_sym_static] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(1238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1236),
    [anon_sym_string] = ACTIONS(1236),
    [anon_sym_set] = ACTIONS(1236),
    [anon_sym_type] = ACTIONS(1236),
    [anon_sym_import] = ACTIONS(1236),
    [anon_sym_export] = ACTIONS(1236),
    [anon_sym_namespace] = ACTIONS(1236),
    [sym_readonly] = ACTIONS(1236),
    [anon_sym_DQUOTE] = ACTIONS(1238),
  },
  [380] = {
    [sym__property_name] = STATE(673),
    [sym_string] = STATE(673),
    [aux_sym_object_repeat1] = STATE(662),
    [sym_computed_property_name] = STATE(673),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_STAR] = ACTIONS(1244),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1240),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(1234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1240),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [381] = {
    [sym__property_name] = STATE(673),
    [sym_string] = STATE(673),
    [aux_sym_object_repeat1] = STATE(662),
    [sym_computed_property_name] = STATE(673),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(1234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [382] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym_BQUOTE] = ACTIONS(1251),
    [sym__automatic_semicolon] = ACTIONS(1251),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_COMMA] = ACTIONS(1251),
    [anon_sym_LT_LT] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_GT_GT_GT] = ACTIONS(1251),
    [anon_sym_EQ] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_BANG_EQ] = ACTIONS(1257),
    [anon_sym_LT_EQ] = ACTIONS(1251),
    [anon_sym_LPAREN] = ACTIONS(1251),
    [anon_sym_GT_EQ] = ACTIONS(1251),
    [anon_sym_of] = ACTIONS(1251),
    [anon_sym_GT] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1257),
    [anon_sym_PERCENT] = ACTIONS(1251),
    [anon_sym_QMARK] = ACTIONS(1251),
    [anon_sym_RBRACE] = ACTIONS(1251),
    [anon_sym_as] = ACTIONS(1251),
    [anon_sym_PIPE_PIPE] = ACTIONS(1251),
    [anon_sym_DASH_DASH] = ACTIONS(1251),
    [anon_sym_EQ_EQ] = ACTIONS(1257),
    [anon_sym_instanceof] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1257),
    [anon_sym_RPAREN] = ACTIONS(1251),
    [anon_sym_SLASH] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1251),
    [anon_sym_CARET] = ACTIONS(1251),
    [anon_sym_STAR_STAR] = ACTIONS(1251),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS_PLUS] = ACTIONS(1251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1251),
    [anon_sym_in] = ACTIONS(1257),
  },
  [383] = {
    [aux_sym_export_statement_repeat1] = STATE(1012),
    [sym__property_name] = STATE(707),
    [sym_decorator] = STATE(1012),
    [sym_string] = STATE(707),
    [sym_accessibility_modifier] = STATE(221),
    [sym_method_definition] = STATE(708),
    [sym_computed_property_name] = STATE(707),
    [anon_sym_get] = ACTIONS(1320),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1318),
    [anon_sym_static] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [sym_number] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(364),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1316),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1320),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [sym_readonly] = ACTIONS(384),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1316),
    [anon_sym_public] = ACTIONS(1316),
  },
  [384] = {
    [sym__initializer] = STATE(1013),
    [anon_sym_EQ] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
  },
  [385] = {
    [sym__initializer] = STATE(1014),
    [anon_sym_EQ] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
  },
  [386] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(784),
    [sym_identifier] = ACTIONS(2129),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [387] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(784),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [388] = {
    [aux_sym_export_statement_repeat1] = STATE(388),
    [sym_decorator] = STATE(388),
    [anon_sym_class] = ACTIONS(1830),
    [anon_sym_AT] = ACTIONS(1832),
    [sym_comment] = ACTIONS(3),
  },
  [389] = {
    [sym_identifier] = ACTIONS(2131),
    [anon_sym_BQUOTE] = ACTIONS(2133),
    [anon_sym_debugger] = ACTIONS(2131),
    [anon_sym_symbol] = ACTIONS(2131),
    [anon_sym_AT] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2131),
    [anon_sym_void] = ACTIONS(2131),
    [anon_sym_break] = ACTIONS(2131),
    [anon_sym_const] = ACTIONS(2131),
    [sym_super] = ACTIONS(2131),
    [anon_sym_return] = ACTIONS(2131),
    [anon_sym_private] = ACTIONS(2131),
    [anon_sym_get] = ACTIONS(2131),
    [anon_sym_RBRACE] = ACTIONS(2133),
    [anon_sym_interface] = ACTIONS(2131),
    [anon_sym_default] = ACTIONS(2131),
    [anon_sym_enum] = ACTIONS(2131),
    [anon_sym_delete] = ACTIONS(2131),
    [anon_sym_continue] = ACTIONS(2131),
    [anon_sym_DASH_DASH] = ACTIONS(2133),
    [anon_sym_if] = ACTIONS(2131),
    [anon_sym_this] = ACTIONS(2131),
    [anon_sym_yield] = ACTIONS(2131),
    [sym_true] = ACTIONS(2131),
    [anon_sym_throw] = ACTIONS(2131),
    [anon_sym_protected] = ACTIONS(2131),
    [anon_sym_abstract] = ACTIONS(2131),
    [anon_sym_set] = ACTIONS(2131),
    [anon_sym_type] = ACTIONS(2131),
    [anon_sym_import] = ACTIONS(2131),
    [anon_sym_namespace] = ACTIONS(2131),
    [anon_sym_PLUS_PLUS] = ACTIONS(2133),
    [anon_sym_await] = ACTIONS(2131),
    [anon_sym_DQUOTE] = ACTIONS(2133),
    [anon_sym_else] = ACTIONS(2131),
    [anon_sym_BANG] = ACTIONS(2133),
    [anon_sym_for] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2133),
    [sym_false] = ACTIONS(2131),
    [anon_sym_SEMI] = ACTIONS(2133),
    [anon_sym_case] = ACTIONS(2131),
    [anon_sym_module] = ACTIONS(2131),
    [anon_sym_number] = ACTIONS(2131),
    [anon_sym_class] = ACTIONS(2131),
    [anon_sym_declare] = ACTIONS(2131),
    [anon_sym_typeof] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2133),
    [anon_sym_switch] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2133),
    [sym_null] = ACTIONS(2131),
    [anon_sym_any] = ACTIONS(2131),
    [anon_sym_boolean] = ACTIONS(2131),
    [anon_sym_async] = ACTIONS(2131),
    [anon_sym_public] = ACTIONS(2131),
    [anon_sym_var] = ACTIONS(2131),
    [anon_sym_while] = ACTIONS(2131),
    [anon_sym_SQUOTE] = ACTIONS(2133),
    [anon_sym_try] = ACTIONS(2131),
    [anon_sym_LT] = ACTIONS(2133),
    [sym_number] = ACTIONS(2133),
    [anon_sym_SLASH] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2131),
    [anon_sym_function] = ACTIONS(2131),
    [sym_undefined] = ACTIONS(2131),
    [anon_sym_new] = ACTIONS(2131),
    [ts_builtin_sym_end] = ACTIONS(2133),
    [anon_sym_let] = ACTIONS(2131),
    [anon_sym_PLUS] = ACTIONS(2131),
    [anon_sym_export] = ACTIONS(2131),
    [anon_sym_do] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2133),
    [anon_sym_with] = ACTIONS(2131),
  },
  [390] = {
    [sym_union_type] = STATE(1031),
    [sym__type] = STATE(1031),
    [sym_constructor_type] = STATE(1031),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1033),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1031),
    [sym_function_type] = STATE(1031),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1036),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2135),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [391] = {
    [sym__automatic_semicolon] = ACTIONS(2169),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym_COMMA] = ACTIONS(2169),
    [sym_comment] = ACTIONS(3),
  },
  [392] = {
    [sym__initializer] = STATE(1037),
    [sym__automatic_semicolon] = ACTIONS(2169),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym_COMMA] = ACTIONS(2169),
    [sym_comment] = ACTIONS(3),
  },
  [393] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_in] = ACTIONS(989),
    [anon_sym_BQUOTE] = ACTIONS(987),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_COMMA] = ACTIONS(987),
    [anon_sym_DASH] = ACTIONS(989),
    [anon_sym_STAR] = ACTIONS(989),
    [anon_sym_GT_GT_GT] = ACTIONS(987),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_AMP_AMP] = ACTIONS(987),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_BANG_EQ] = ACTIONS(989),
    [anon_sym_LT_EQ] = ACTIONS(987),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_RBRACK] = ACTIONS(987),
    [anon_sym_GT_EQ] = ACTIONS(987),
    [anon_sym_GT] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_of] = ACTIONS(987),
    [anon_sym_AMP] = ACTIONS(989),
    [anon_sym_PERCENT] = ACTIONS(987),
    [anon_sym_QMARK] = ACTIONS(987),
    [anon_sym_RBRACE] = ACTIONS(987),
    [anon_sym_as] = ACTIONS(987),
    [anon_sym_PIPE_PIPE] = ACTIONS(987),
    [anon_sym_LBRACE_PIPE] = ACTIONS(987),
    [anon_sym_DASH_DASH] = ACTIONS(987),
    [anon_sym_EQ_EQ] = ACTIONS(989),
    [anon_sym_instanceof] = ACTIONS(987),
    [anon_sym_LT] = ACTIONS(989),
    [anon_sym_RPAREN] = ACTIONS(987),
    [anon_sym_SLASH] = ACTIONS(989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(987),
    [anon_sym_DOT] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(987),
    [anon_sym_STAR_STAR] = ACTIONS(987),
    [anon_sym_PLUS] = ACTIONS(989),
    [anon_sym_implements] = ACTIONS(987),
    [anon_sym_GT_GT] = ACTIONS(989),
    [anon_sym_PLUS_PLUS] = ACTIONS(987),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(987),
    [anon_sym_BANG] = ACTIONS(989),
  },
  [394] = {
    [sym_template_string] = STATE(542),
    [aux_sym_array_repeat1] = STATE(1039),
    [sym_type_arguments] = STATE(541),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(945),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_RBRACK] = ACTIONS(2171),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [395] = {
    [aux_sym_array_repeat1] = STATE(1039),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_RBRACK] = ACTIONS(2171),
    [sym_comment] = ACTIONS(3),
  },
  [396] = {
    [aux_sym_array_repeat1] = STATE(588),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_RBRACK] = ACTIONS(2171),
    [sym_comment] = ACTIONS(3),
  },
  [397] = {
    [sym_enum_body] = STATE(1040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(831),
  },
  [398] = {
    [sym__initializer] = STATE(1010),
    [aux_sym_object_repeat1] = STATE(1042),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_EQ] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(362),
    [sym_comment] = ACTIONS(3),
  },
  [399] = {
    [aux_sym_object_repeat1] = STATE(1042),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(362),
    [sym_comment] = ACTIONS(3),
  },
  [400] = {
    [aux_sym_object_repeat1] = STATE(1042),
    [anon_sym_LBRACK] = ACTIONS(1238),
    [sym_identifier] = ACTIONS(1236),
    [anon_sym_module] = ACTIONS(1236),
    [anon_sym_symbol] = ACTIONS(1236),
    [anon_sym_number] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1236),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_STAR] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1236),
    [anon_sym_private] = ACTIONS(1236),
    [anon_sym_boolean] = ACTIONS(1236),
    [anon_sym_async] = ACTIONS(1236),
    [anon_sym_public] = ACTIONS(1236),
    [anon_sym_get] = ACTIONS(1236),
    [anon_sym_static] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(1238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1236),
    [anon_sym_string] = ACTIONS(1236),
    [anon_sym_set] = ACTIONS(1236),
    [anon_sym_type] = ACTIONS(1236),
    [anon_sym_import] = ACTIONS(1236),
    [anon_sym_export] = ACTIONS(1236),
    [anon_sym_namespace] = ACTIONS(1236),
    [sym_readonly] = ACTIONS(1236),
    [anon_sym_DQUOTE] = ACTIONS(1238),
  },
  [401] = {
    [sym__property_name] = STATE(673),
    [sym_string] = STATE(673),
    [aux_sym_object_repeat1] = STATE(1042),
    [sym_computed_property_name] = STATE(673),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_STAR] = ACTIONS(1244),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1240),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(1234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1240),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [402] = {
    [sym__property_name] = STATE(673),
    [sym_string] = STATE(673),
    [aux_sym_object_repeat1] = STATE(1042),
    [sym_computed_property_name] = STATE(673),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(1234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [403] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1251),
    [anon_sym_in] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1251),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_COMMA] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_GT_GT_GT] = ACTIONS(1251),
    [anon_sym_EQ] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1251),
    [anon_sym_LT_LT] = ACTIONS(1251),
    [anon_sym_BANG_EQ] = ACTIONS(1257),
    [anon_sym_LT_EQ] = ACTIONS(1251),
    [anon_sym_LPAREN] = ACTIONS(1251),
    [anon_sym_RBRACK] = ACTIONS(1251),
    [anon_sym_GT_EQ] = ACTIONS(1251),
    [anon_sym_GT] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1257),
    [anon_sym_of] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1257),
    [anon_sym_PERCENT] = ACTIONS(1251),
    [anon_sym_QMARK] = ACTIONS(1251),
    [anon_sym_RBRACE] = ACTIONS(1251),
    [anon_sym_as] = ACTIONS(1251),
    [anon_sym_PIPE_PIPE] = ACTIONS(1251),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1251),
    [anon_sym_DASH_DASH] = ACTIONS(1251),
    [anon_sym_EQ_EQ] = ACTIONS(1257),
    [anon_sym_instanceof] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1257),
    [anon_sym_RPAREN] = ACTIONS(1251),
    [anon_sym_SLASH] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1251),
    [anon_sym_CARET] = ACTIONS(1251),
    [anon_sym_STAR_STAR] = ACTIONS(1251),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_implements] = ACTIONS(1251),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS_PLUS] = ACTIONS(1251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1257),
  },
  [404] = {
    [aux_sym_export_statement_repeat1] = STATE(1012),
    [sym__property_name] = STATE(707),
    [sym_decorator] = STATE(1012),
    [sym_string] = STATE(707),
    [sym_accessibility_modifier] = STATE(221),
    [sym_method_definition] = STATE(1043),
    [sym_computed_property_name] = STATE(707),
    [anon_sym_get] = ACTIONS(1320),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1318),
    [anon_sym_static] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [sym_number] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(364),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1316),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1320),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [sym_readonly] = ACTIONS(384),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1316),
    [anon_sym_public] = ACTIONS(1316),
  },
  [405] = {
    [aux_sym_object_repeat1] = STATE(1045),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [sym_comment] = ACTIONS(3),
  },
  [406] = {
    [aux_sym_object_repeat1] = STATE(699),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [sym_comment] = ACTIONS(3),
  },
  [407] = {
    [sym_variable_declarator] = STATE(1046),
    [sym_array] = STATE(98),
    [sym_object] = STATE(99),
    [sym_identifier] = ACTIONS(454),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [408] = {
    [sym_identifier] = ACTIONS(2177),
    [anon_sym_BQUOTE] = ACTIONS(2179),
    [anon_sym_debugger] = ACTIONS(2177),
    [anon_sym_symbol] = ACTIONS(2177),
    [anon_sym_AT] = ACTIONS(2179),
    [anon_sym_DASH] = ACTIONS(2177),
    [anon_sym_void] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2177),
    [anon_sym_const] = ACTIONS(2177),
    [sym_super] = ACTIONS(2177),
    [anon_sym_return] = ACTIONS(2177),
    [anon_sym_private] = ACTIONS(2177),
    [anon_sym_get] = ACTIONS(2177),
    [anon_sym_RBRACE] = ACTIONS(2179),
    [anon_sym_interface] = ACTIONS(2177),
    [anon_sym_default] = ACTIONS(2177),
    [anon_sym_enum] = ACTIONS(2177),
    [anon_sym_delete] = ACTIONS(2177),
    [anon_sym_continue] = ACTIONS(2177),
    [anon_sym_DASH_DASH] = ACTIONS(2179),
    [anon_sym_if] = ACTIONS(2177),
    [anon_sym_this] = ACTIONS(2177),
    [anon_sym_yield] = ACTIONS(2177),
    [sym_true] = ACTIONS(2177),
    [anon_sym_throw] = ACTIONS(2177),
    [anon_sym_protected] = ACTIONS(2177),
    [anon_sym_abstract] = ACTIONS(2177),
    [anon_sym_set] = ACTIONS(2177),
    [anon_sym_type] = ACTIONS(2177),
    [anon_sym_import] = ACTIONS(2177),
    [anon_sym_namespace] = ACTIONS(2177),
    [anon_sym_PLUS_PLUS] = ACTIONS(2179),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DQUOTE] = ACTIONS(2179),
    [anon_sym_else] = ACTIONS(2177),
    [anon_sym_BANG] = ACTIONS(2179),
    [anon_sym_for] = ACTIONS(2177),
    [anon_sym_LBRACK] = ACTIONS(2179),
    [sym_false] = ACTIONS(2177),
    [anon_sym_SEMI] = ACTIONS(2179),
    [anon_sym_case] = ACTIONS(2177),
    [anon_sym_module] = ACTIONS(2177),
    [anon_sym_number] = ACTIONS(2177),
    [anon_sym_class] = ACTIONS(2177),
    [anon_sym_declare] = ACTIONS(2177),
    [anon_sym_typeof] = ACTIONS(2177),
    [anon_sym_LBRACE] = ACTIONS(2179),
    [anon_sym_switch] = ACTIONS(2177),
    [anon_sym_LPAREN] = ACTIONS(2179),
    [sym_null] = ACTIONS(2177),
    [anon_sym_any] = ACTIONS(2177),
    [anon_sym_boolean] = ACTIONS(2177),
    [anon_sym_async] = ACTIONS(2177),
    [anon_sym_public] = ACTIONS(2177),
    [anon_sym_var] = ACTIONS(2177),
    [anon_sym_while] = ACTIONS(2177),
    [anon_sym_SQUOTE] = ACTIONS(2179),
    [anon_sym_try] = ACTIONS(2177),
    [anon_sym_LT] = ACTIONS(2179),
    [sym_number] = ACTIONS(2179),
    [anon_sym_SLASH] = ACTIONS(2177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2177),
    [anon_sym_function] = ACTIONS(2177),
    [sym_undefined] = ACTIONS(2177),
    [anon_sym_new] = ACTIONS(2177),
    [ts_builtin_sym_end] = ACTIONS(2179),
    [anon_sym_let] = ACTIONS(2177),
    [anon_sym_PLUS] = ACTIONS(2177),
    [anon_sym_export] = ACTIONS(2177),
    [anon_sym_do] = ACTIONS(2177),
    [anon_sym_TILDE] = ACTIONS(2179),
    [anon_sym_with] = ACTIONS(2177),
  },
  [409] = {
    [aux_sym_variable_declaration_repeat1] = STATE(1048),
    [sym__automatic_semicolon] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(2181),
    [anon_sym_COMMA] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
  },
  [410] = {
    [sym_union_type] = STATE(1054),
    [sym__type] = STATE(1054),
    [sym_constructor_type] = STATE(1054),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1055),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1054),
    [sym_function_type] = STATE(1054),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1056),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2183),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [411] = {
    [sym__automatic_semicolon] = ACTIONS(2193),
    [anon_sym_SEMI] = ACTIONS(2193),
    [anon_sym_COMMA] = ACTIONS(2193),
    [sym_comment] = ACTIONS(3),
  },
  [412] = {
    [sym__initializer] = STATE(1057),
    [anon_sym_EQ] = ACTIONS(717),
    [sym_comment] = ACTIONS(3),
  },
  [413] = {
    [sym__automatic_semicolon] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(2195),
    [anon_sym_COMMA] = ACTIONS(2195),
    [sym_comment] = ACTIONS(3),
  },
  [414] = {
    [sym__initializer] = STATE(1058),
    [anon_sym_EQ] = ACTIONS(717),
    [sym_comment] = ACTIONS(3),
  },
  [415] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(945),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(2197),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_RBRACK] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [416] = {
    [anon_sym_RBRACK] = ACTIONS(2199),
    [sym_comment] = ACTIONS(3),
  },
  [417] = {
    [sym_type_arguments] = STATE(1064),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_GT] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(2208),
  },
  [418] = {
    [sym_identifier] = ACTIONS(2210),
    [anon_sym_BQUOTE] = ACTIONS(2212),
    [anon_sym_debugger] = ACTIONS(2210),
    [anon_sym_symbol] = ACTIONS(2210),
    [anon_sym_AT] = ACTIONS(2212),
    [anon_sym_PIPE] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2212),
    [anon_sym_DASH] = ACTIONS(2210),
    [anon_sym_EQ] = ACTIONS(2210),
    [anon_sym_void] = ACTIONS(2210),
    [anon_sym_break] = ACTIONS(2210),
    [anon_sym_const] = ACTIONS(2210),
    [sym_super] = ACTIONS(2210),
    [anon_sym_return] = ACTIONS(2210),
    [anon_sym_private] = ACTIONS(2210),
    [anon_sym_get] = ACTIONS(2210),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_interface] = ACTIONS(2210),
    [anon_sym_default] = ACTIONS(2210),
    [anon_sym_enum] = ACTIONS(2210),
    [anon_sym_delete] = ACTIONS(2210),
    [anon_sym_continue] = ACTIONS(2210),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [anon_sym_if] = ACTIONS(2210),
    [anon_sym_this] = ACTIONS(2210),
    [anon_sym_yield] = ACTIONS(2210),
    [sym_true] = ACTIONS(2210),
    [anon_sym_throw] = ACTIONS(2210),
    [anon_sym_protected] = ACTIONS(2210),
    [anon_sym_abstract] = ACTIONS(2210),
    [anon_sym_set] = ACTIONS(2210),
    [anon_sym_type] = ACTIONS(2210),
    [anon_sym_import] = ACTIONS(2210),
    [anon_sym_namespace] = ACTIONS(2210),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_await] = ACTIONS(2210),
    [anon_sym_DQUOTE] = ACTIONS(2212),
    [anon_sym_else] = ACTIONS(2210),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_for] = ACTIONS(2210),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [sym_false] = ACTIONS(2210),
    [anon_sym_SEMI] = ACTIONS(2212),
    [anon_sym_case] = ACTIONS(2210),
    [anon_sym_module] = ACTIONS(2210),
    [anon_sym_number] = ACTIONS(2210),
    [anon_sym_class] = ACTIONS(2210),
    [anon_sym_declare] = ACTIONS(2210),
    [anon_sym_typeof] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2212),
    [anon_sym_switch] = ACTIONS(2210),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_RBRACK] = ACTIONS(2212),
    [sym_null] = ACTIONS(2210),
    [anon_sym_GT] = ACTIONS(2212),
    [anon_sym_any] = ACTIONS(2210),
    [anon_sym_boolean] = ACTIONS(2210),
    [anon_sym_async] = ACTIONS(2210),
    [anon_sym_public] = ACTIONS(2210),
    [anon_sym_EQ_GT] = ACTIONS(2212),
    [anon_sym_AMP] = ACTIONS(2212),
    [anon_sym_var] = ACTIONS(2210),
    [anon_sym_while] = ACTIONS(2210),
    [anon_sym_SQUOTE] = ACTIONS(2212),
    [anon_sym_try] = ACTIONS(2210),
    [anon_sym_RPAREN] = ACTIONS(2212),
    [anon_sym_LT] = ACTIONS(2212),
    [sym_number] = ACTIONS(2212),
    [anon_sym_SLASH] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2210),
    [anon_sym_function] = ACTIONS(2210),
    [sym_undefined] = ACTIONS(2210),
    [anon_sym_new] = ACTIONS(2210),
    [ts_builtin_sym_end] = ACTIONS(2212),
    [anon_sym_let] = ACTIONS(2210),
    [anon_sym_PLUS] = ACTIONS(2210),
    [anon_sym_export] = ACTIONS(2210),
    [anon_sym_do] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2212),
    [anon_sym_with] = ACTIONS(2210),
  },
  [419] = {
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(433),
    [sym_array_type] = STATE(1066),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym_existential_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(1066),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(1066),
    [sym_string] = STATE(418),
    [sym_tuple_type] = STATE(1066),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [sym_true] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [420] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(1079),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(1079),
    [sym_call_signature] = STATE(1079),
    [sym_export_statement] = STATE(1079),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(1079),
    [sym_index_signature] = STATE(1079),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_SEMI] = ACTIONS(2218),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(2218),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [421] = {
    [sym_union_type] = STATE(1088),
    [sym__type] = STATE(1088),
    [sym_constructor_type] = STATE(1088),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1089),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1088),
    [sym_function_type] = STATE(1088),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1090),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [422] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [423] = {
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_BQUOTE] = ACTIONS(2250),
    [anon_sym_debugger] = ACTIONS(2248),
    [anon_sym_symbol] = ACTIONS(2248),
    [anon_sym_AT] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_EQ] = ACTIONS(2248),
    [anon_sym_void] = ACTIONS(2248),
    [anon_sym_break] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [sym_super] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2248),
    [anon_sym_private] = ACTIONS(2248),
    [anon_sym_get] = ACTIONS(2248),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_interface] = ACTIONS(2248),
    [anon_sym_default] = ACTIONS(2248),
    [anon_sym_enum] = ACTIONS(2248),
    [anon_sym_delete] = ACTIONS(2248),
    [anon_sym_continue] = ACTIONS(2248),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2248),
    [anon_sym_this] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2248),
    [sym_true] = ACTIONS(2248),
    [anon_sym_throw] = ACTIONS(2248),
    [anon_sym_protected] = ACTIONS(2248),
    [anon_sym_abstract] = ACTIONS(2248),
    [anon_sym_set] = ACTIONS(2248),
    [anon_sym_type] = ACTIONS(2248),
    [anon_sym_import] = ACTIONS(2248),
    [anon_sym_namespace] = ACTIONS(2248),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_await] = ACTIONS(2248),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_else] = ACTIONS(2248),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [sym_false] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym_case] = ACTIONS(2248),
    [anon_sym_module] = ACTIONS(2248),
    [anon_sym_number] = ACTIONS(2248),
    [anon_sym_class] = ACTIONS(2248),
    [anon_sym_declare] = ACTIONS(2248),
    [anon_sym_typeof] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_switch] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_RBRACK] = ACTIONS(2250),
    [sym_null] = ACTIONS(2248),
    [anon_sym_GT] = ACTIONS(2250),
    [anon_sym_any] = ACTIONS(2248),
    [anon_sym_boolean] = ACTIONS(2248),
    [anon_sym_async] = ACTIONS(2248),
    [anon_sym_public] = ACTIONS(2248),
    [anon_sym_EQ_GT] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_while] = ACTIONS(2248),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2248),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [anon_sym_LT] = ACTIONS(2250),
    [sym_number] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(2248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2248),
    [sym_undefined] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2248),
    [ts_builtin_sym_end] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_export] = ACTIONS(2248),
    [anon_sym_do] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_with] = ACTIONS(2248),
  },
  [424] = {
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_BQUOTE] = ACTIONS(2254),
    [anon_sym_debugger] = ACTIONS(2252),
    [anon_sym_symbol] = ACTIONS(2252),
    [anon_sym_AT] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2254),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2252),
    [anon_sym_void] = ACTIONS(2252),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [sym_super] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_private] = ACTIONS(2252),
    [anon_sym_get] = ACTIONS(2252),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_interface] = ACTIONS(2252),
    [anon_sym_default] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(2252),
    [anon_sym_delete] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2252),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_this] = ACTIONS(2252),
    [anon_sym_yield] = ACTIONS(2252),
    [sym_true] = ACTIONS(2252),
    [anon_sym_throw] = ACTIONS(2252),
    [anon_sym_protected] = ACTIONS(2252),
    [anon_sym_abstract] = ACTIONS(2252),
    [anon_sym_set] = ACTIONS(2252),
    [anon_sym_type] = ACTIONS(2252),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_namespace] = ACTIONS(2252),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_await] = ACTIONS(2252),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [anon_sym_else] = ACTIONS(2252),
    [anon_sym_BANG] = ACTIONS(2254),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [sym_false] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym_case] = ACTIONS(2252),
    [anon_sym_module] = ACTIONS(2252),
    [anon_sym_number] = ACTIONS(2252),
    [anon_sym_class] = ACTIONS(2252),
    [anon_sym_declare] = ACTIONS(2252),
    [anon_sym_typeof] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_switch] = ACTIONS(2252),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [anon_sym_RBRACK] = ACTIONS(2254),
    [sym_null] = ACTIONS(2252),
    [anon_sym_GT] = ACTIONS(2254),
    [anon_sym_any] = ACTIONS(2252),
    [anon_sym_boolean] = ACTIONS(2252),
    [anon_sym_async] = ACTIONS(2252),
    [anon_sym_public] = ACTIONS(2252),
    [anon_sym_EQ_GT] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2254),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2254),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_RPAREN] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [sym_number] = ACTIONS(2254),
    [anon_sym_SLASH] = ACTIONS(2252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2252),
    [anon_sym_function] = ACTIONS(2252),
    [sym_undefined] = ACTIONS(2252),
    [anon_sym_new] = ACTIONS(2252),
    [ts_builtin_sym_end] = ACTIONS(2254),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_export] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_with] = ACTIONS(2252),
  },
  [425] = {
    [sym_nested_identifier] = STATE(1092),
    [sym_identifier] = ACTIONS(2256),
    [sym_comment] = ACTIONS(3),
  },
  [426] = {
    [sym_number] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
  },
  [427] = {
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_BQUOTE] = ACTIONS(2262),
    [anon_sym_debugger] = ACTIONS(2260),
    [anon_sym_symbol] = ACTIONS(2260),
    [anon_sym_AT] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2262),
    [anon_sym_COMMA] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_EQ] = ACTIONS(2260),
    [anon_sym_void] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [sym_super] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_private] = ACTIONS(2260),
    [anon_sym_get] = ACTIONS(2260),
    [anon_sym_RBRACE] = ACTIONS(2262),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_this] = ACTIONS(2260),
    [anon_sym_yield] = ACTIONS(2260),
    [sym_true] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_protected] = ACTIONS(2260),
    [anon_sym_abstract] = ACTIONS(2260),
    [anon_sym_set] = ACTIONS(2260),
    [anon_sym_type] = ACTIONS(2260),
    [anon_sym_import] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_await] = ACTIONS(2260),
    [anon_sym_DQUOTE] = ACTIONS(2262),
    [anon_sym_else] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [sym_false] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym_case] = ACTIONS(2260),
    [anon_sym_module] = ACTIONS(2260),
    [anon_sym_number] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_declare] = ACTIONS(2260),
    [anon_sym_typeof] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_LPAREN] = ACTIONS(2262),
    [anon_sym_RBRACK] = ACTIONS(2262),
    [sym_null] = ACTIONS(2260),
    [anon_sym_GT] = ACTIONS(2262),
    [anon_sym_any] = ACTIONS(2260),
    [anon_sym_boolean] = ACTIONS(2260),
    [anon_sym_async] = ACTIONS(2260),
    [anon_sym_public] = ACTIONS(2260),
    [anon_sym_EQ_GT] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2262),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_SQUOTE] = ACTIONS(2262),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_RPAREN] = ACTIONS(2262),
    [anon_sym_LT] = ACTIONS(2262),
    [sym_number] = ACTIONS(2262),
    [anon_sym_SLASH] = ACTIONS(2260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2260),
    [anon_sym_function] = ACTIONS(2260),
    [sym_undefined] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [ts_builtin_sym_end] = ACTIONS(2262),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_export] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_with] = ACTIONS(2260),
  },
  [428] = {
    [sym_nested_type_identifier] = STATE(1095),
    [sym_nested_identifier] = STATE(435),
    [sym_identifier] = ACTIONS(2264),
    [sym_comment] = ACTIONS(3),
  },
  [429] = {
    [sym_type_parameters] = STATE(1096),
    [sym_formal_parameters] = STATE(1097),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [430] = {
    [sym__type] = STATE(1107),
    [sym_constructor_type] = STATE(1107),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_type_parameters] = STATE(1108),
    [sym_array_type] = STATE(436),
    [sym_rest_parameter] = STATE(244),
    [sym_nested_identifier] = STATE(435),
    [sym_accessibility_modifier] = STATE(247),
    [sym_required_parameter] = STATE(244),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_this] = STATE(772),
    [sym_tuple_type] = STATE(436),
    [sym_union_type] = STATE(1107),
    [aux_sym_export_statement_repeat1] = STATE(781),
    [sym_object] = STATE(769),
    [sym_nested_type_identifier] = STATE(433),
    [sym_optional_parameter] = STATE(244),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_object_type] = STATE(436),
    [sym_decorator] = STATE(781),
    [sym_intersection_type] = STATE(1107),
    [sym_function_type] = STATE(1107),
    [sym_formal_parameters] = STATE(1109),
    [sym_array] = STATE(771),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [sym_identifier] = ACTIONS(2268),
    [sym_false] = ACTIONS(753),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(2270),
    [anon_sym_number] = ACTIONS(2270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_void] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(2270),
    [anon_sym_private] = ACTIONS(1446),
    [anon_sym_boolean] = ACTIONS(2270),
    [anon_sym_async] = ACTIONS(1442),
    [anon_sym_public] = ACTIONS(1446),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_RPAREN] = ACTIONS(428),
    [anon_sym_this] = ACTIONS(2280),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1446),
    [anon_sym_string] = ACTIONS(2270),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_new] = ACTIONS(2282),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [431] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [432] = {
    [aux_sym_implements_clause_repeat1] = STATE(1115),
    [anon_sym_GT] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_COMMA] = ACTIONS(2290),
    [sym_comment] = ACTIONS(3),
  },
  [433] = {
    [sym_type_arguments] = STATE(1117),
    [anon_sym_EQ_GT] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_EQ] = ACTIONS(2297),
    [anon_sym_RBRACK] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_GT] = ACTIONS(2292),
    [anon_sym_RPAREN] = ACTIONS(2292),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_COMMA] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2292),
  },
  [434] = {
    [sym_formal_parameters] = STATE(1118),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [435] = {
    [anon_sym_DOT] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
  },
  [436] = {
    [sym_identifier] = ACTIONS(2299),
    [anon_sym_BQUOTE] = ACTIONS(2301),
    [anon_sym_debugger] = ACTIONS(2299),
    [anon_sym_symbol] = ACTIONS(2299),
    [anon_sym_AT] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_COMMA] = ACTIONS(2301),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_EQ] = ACTIONS(2299),
    [anon_sym_void] = ACTIONS(2299),
    [anon_sym_break] = ACTIONS(2299),
    [anon_sym_const] = ACTIONS(2299),
    [sym_super] = ACTIONS(2299),
    [anon_sym_return] = ACTIONS(2299),
    [anon_sym_private] = ACTIONS(2299),
    [anon_sym_get] = ACTIONS(2299),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [anon_sym_interface] = ACTIONS(2299),
    [anon_sym_default] = ACTIONS(2299),
    [anon_sym_enum] = ACTIONS(2299),
    [anon_sym_delete] = ACTIONS(2299),
    [anon_sym_continue] = ACTIONS(2299),
    [anon_sym_DASH_DASH] = ACTIONS(2301),
    [anon_sym_if] = ACTIONS(2299),
    [anon_sym_this] = ACTIONS(2299),
    [anon_sym_yield] = ACTIONS(2299),
    [sym_true] = ACTIONS(2299),
    [anon_sym_throw] = ACTIONS(2299),
    [anon_sym_protected] = ACTIONS(2299),
    [anon_sym_abstract] = ACTIONS(2299),
    [anon_sym_set] = ACTIONS(2299),
    [anon_sym_type] = ACTIONS(2299),
    [anon_sym_import] = ACTIONS(2299),
    [anon_sym_namespace] = ACTIONS(2299),
    [anon_sym_PLUS_PLUS] = ACTIONS(2301),
    [anon_sym_await] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(2301),
    [anon_sym_else] = ACTIONS(2299),
    [anon_sym_BANG] = ACTIONS(2301),
    [anon_sym_for] = ACTIONS(2299),
    [anon_sym_LBRACK] = ACTIONS(2303),
    [sym_false] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2301),
    [anon_sym_case] = ACTIONS(2299),
    [anon_sym_module] = ACTIONS(2299),
    [anon_sym_number] = ACTIONS(2299),
    [anon_sym_class] = ACTIONS(2299),
    [anon_sym_declare] = ACTIONS(2299),
    [anon_sym_typeof] = ACTIONS(2299),
    [anon_sym_LBRACE] = ACTIONS(2301),
    [anon_sym_switch] = ACTIONS(2299),
    [anon_sym_LPAREN] = ACTIONS(2301),
    [anon_sym_RBRACK] = ACTIONS(2301),
    [sym_null] = ACTIONS(2299),
    [anon_sym_GT] = ACTIONS(2301),
    [anon_sym_any] = ACTIONS(2299),
    [anon_sym_boolean] = ACTIONS(2299),
    [anon_sym_async] = ACTIONS(2299),
    [anon_sym_public] = ACTIONS(2299),
    [anon_sym_EQ_GT] = ACTIONS(2301),
    [anon_sym_AMP] = ACTIONS(2301),
    [anon_sym_var] = ACTIONS(2299),
    [anon_sym_while] = ACTIONS(2299),
    [anon_sym_SQUOTE] = ACTIONS(2301),
    [anon_sym_try] = ACTIONS(2299),
    [anon_sym_RPAREN] = ACTIONS(2301),
    [anon_sym_LT] = ACTIONS(2301),
    [sym_number] = ACTIONS(2301),
    [anon_sym_SLASH] = ACTIONS(2299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2299),
    [anon_sym_function] = ACTIONS(2299),
    [sym_undefined] = ACTIONS(2299),
    [anon_sym_new] = ACTIONS(2299),
    [ts_builtin_sym_end] = ACTIONS(2301),
    [anon_sym_let] = ACTIONS(2299),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_export] = ACTIONS(2299),
    [anon_sym_do] = ACTIONS(2299),
    [anon_sym_TILDE] = ACTIONS(2301),
    [anon_sym_with] = ACTIONS(2299),
  },
  [437] = {
    [anon_sym_EQ_GT] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
  },
  [438] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2307),
    [anon_sym_AMP_EQ] = ACTIONS(2307),
    [anon_sym_PLUS_EQ] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2307),
    [anon_sym_STAR_EQ] = ACTIONS(2307),
    [anon_sym_PIPE_EQ] = ACTIONS(2307),
    [anon_sym_DASH_EQ] = ACTIONS(2307),
    [anon_sym_EQ_GT] = ACTIONS(2309),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2307),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT_EQ] = ACTIONS(2307),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2311),
  },
  [439] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2313),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_AMP_EQ] = ACTIONS(2313),
    [anon_sym_PLUS_EQ] = ACTIONS(2313),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(2313),
    [anon_sym_STAR_EQ] = ACTIONS(2313),
    [anon_sym_PIPE_EQ] = ACTIONS(2313),
    [anon_sym_DASH_EQ] = ACTIONS(2313),
    [anon_sym_EQ_GT] = ACTIONS(2315),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(2313),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2313),
    [anon_sym_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [440] = {
    [sym_new_expression] = STATE(1126),
    [sym_augmented_assignment_expression] = STATE(1126),
    [sym_unary_expression] = STATE(1126),
    [sym_update_expression] = STATE(1126),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(1126),
    [sym_regex] = STATE(1126),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1126),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1126),
    [sym_jsx_fragment] = STATE(1126),
    [sym_yield_expression] = STATE(1126),
    [sym_jsx_element] = STATE(1126),
    [sym_internal_module] = STATE(1126),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1126),
    [sym_await_expression] = STATE(1126),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(1126),
    [sym_this] = STATE(1126),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(1126),
    [sym_generator_function] = STATE(1126),
    [sym_call_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(1126),
    [sym_ternary_expression] = STATE(1126),
    [sym_binary_expression] = STATE(1126),
    [sym_template_string] = STATE(1126),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1126),
    [sym_class] = STATE(1126),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(2317),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2317),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2319),
    [sym_true] = ACTIONS(2317),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2317),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [441] = {
    [sym_new_expression] = STATE(1127),
    [sym_augmented_assignment_expression] = STATE(1127),
    [sym_unary_expression] = STATE(1127),
    [sym_update_expression] = STATE(1127),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(1127),
    [sym_regex] = STATE(1127),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1127),
    [sym_non_null_expression] = STATE(1127),
    [sym_as_expression] = STATE(1127),
    [sym_jsx_fragment] = STATE(1127),
    [sym_yield_expression] = STATE(1127),
    [sym_jsx_element] = STATE(1127),
    [sym_internal_module] = STATE(1127),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1127),
    [sym_await_expression] = STATE(1127),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(1127),
    [sym_this] = STATE(1127),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(1127),
    [sym_generator_function] = STATE(1127),
    [sym_call_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(1127),
    [sym_ternary_expression] = STATE(1127),
    [sym_binary_expression] = STATE(1127),
    [sym_template_string] = STATE(1127),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1127),
    [sym_class] = STATE(1127),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2321),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2323),
    [sym_true] = ACTIONS(2321),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2321),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [442] = {
    [sym_new_expression] = STATE(1128),
    [sym_augmented_assignment_expression] = STATE(1128),
    [sym_unary_expression] = STATE(1128),
    [sym_update_expression] = STATE(1128),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(1128),
    [sym_regex] = STATE(1128),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1128),
    [sym_non_null_expression] = STATE(1128),
    [sym_as_expression] = STATE(1128),
    [sym_jsx_fragment] = STATE(1128),
    [sym_yield_expression] = STATE(1128),
    [sym_jsx_element] = STATE(1128),
    [sym_internal_module] = STATE(1128),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1128),
    [sym_await_expression] = STATE(1128),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(1128),
    [sym_this] = STATE(1128),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(1128),
    [sym_generator_function] = STATE(1128),
    [sym_call_expression] = STATE(1128),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(1128),
    [sym_ternary_expression] = STATE(1128),
    [sym_binary_expression] = STATE(1128),
    [sym_template_string] = STATE(1128),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1128),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1128),
    [sym_class] = STATE(1128),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2325),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2327),
    [sym_true] = ACTIONS(2325),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2325),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [443] = {
    [sym_new_expression] = STATE(1129),
    [sym_augmented_assignment_expression] = STATE(1129),
    [sym_unary_expression] = STATE(1129),
    [sym_update_expression] = STATE(1129),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(1129),
    [sym_regex] = STATE(1129),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1129),
    [sym_non_null_expression] = STATE(1129),
    [sym_as_expression] = STATE(1129),
    [sym_jsx_fragment] = STATE(1129),
    [sym_yield_expression] = STATE(1129),
    [sym_jsx_element] = STATE(1129),
    [sym_internal_module] = STATE(1129),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1129),
    [sym_await_expression] = STATE(1129),
    [sym_member_expression] = STATE(454),
    [sym_spread_element] = STATE(537),
    [sym_string] = STATE(1129),
    [sym_this] = STATE(1129),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(1129),
    [sym_generator_function] = STATE(1129),
    [sym_call_expression] = STATE(1129),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(1129),
    [sym_ternary_expression] = STATE(1129),
    [sym_binary_expression] = STATE(1129),
    [sym_template_string] = STATE(1129),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1129),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1129),
    [sym_class] = STATE(1129),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(2329),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_COMMA] = ACTIONS(975),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(797),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2329),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_RPAREN] = ACTIONS(975),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2331),
    [sym_true] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2329),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [444] = {
    [sym_new_expression] = STATE(1126),
    [sym_augmented_assignment_expression] = STATE(1126),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(1126),
    [sym_update_expression] = STATE(1126),
    [sym_regex] = STATE(1126),
    [sym_meta_property] = STATE(1126),
    [sym_call_signature] = STATE(452),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1126),
    [sym_non_null_expression] = STATE(1126),
    [sym_yield_expression] = STATE(1126),
    [sym_jsx_fragment] = STATE(1126),
    [sym_jsx_element] = STATE(1126),
    [sym_as_expression] = STATE(1126),
    [sym_internal_module] = STATE(1126),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1126),
    [sym_await_expression] = STATE(1126),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(1126),
    [sym_this] = STATE(1126),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(1126),
    [sym_generator_function] = STATE(1126),
    [sym_call_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(1126),
    [sym_ternary_expression] = STATE(1126),
    [sym_binary_expression] = STATE(1126),
    [sym_template_string] = STATE(1126),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1126),
    [sym_class] = STATE(1126),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(787),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2313),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_AMP_EQ] = ACTIONS(2313),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2313),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(2313),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_PIPE_EQ] = ACTIONS(2313),
    [anon_sym_DASH_EQ] = ACTIONS(2313),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2313),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(811),
    [sym_true] = ACTIONS(2317),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2313),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2317),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2317),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_STAR_EQ] = ACTIONS(2313),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_EQ_GT] = ACTIONS(2315),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(2319),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2313),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2317),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [445] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_call_signature] = STATE(1130),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2333),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2313),
    [anon_sym_symbol] = ACTIONS(2335),
    [anon_sym_AMP_EQ] = ACTIONS(2313),
    [anon_sym_PLUS_EQ] = ACTIONS(2313),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_void] = ACTIONS(2335),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(2313),
    [anon_sym_private] = ACTIONS(2335),
    [anon_sym_PIPE_EQ] = ACTIONS(2313),
    [anon_sym_DASH_EQ] = ACTIONS(2313),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2313),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(2335),
    [anon_sym_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(2335),
    [anon_sym_type] = ACTIONS(2335),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2335),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2313),
    [anon_sym_namespace] = ACTIONS(2335),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(2335),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_number] = ACTIONS(2335),
    [anon_sym_declare] = ACTIONS(2335),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(2335),
    [anon_sym_STAR_EQ] = ACTIONS(2313),
    [anon_sym_boolean] = ACTIONS(2335),
    [anon_sym_async] = ACTIONS(2335),
    [anon_sym_public] = ACTIONS(2335),
    [anon_sym_EQ_GT] = ACTIONS(2315),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2313),
    [anon_sym_string] = ACTIONS(2335),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(2335),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [446] = {
    [sym_new_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1132),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_jsx_element] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(1132),
    [sym_this] = STATE(1132),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(1132),
    [sym_generator_function] = STATE(1132),
    [sym_call_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(2337),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2337),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2339),
    [sym_true] = ACTIONS(2337),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2337),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [447] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2341),
    [anon_sym_LBRACK] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_SEMI] = ACTIONS(2341),
    [anon_sym_BQUOTE] = ACTIONS(2341),
    [sym__automatic_semicolon] = ACTIONS(2341),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_COMMA] = ACTIONS(2341),
    [anon_sym_LT_LT] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_GT_GT_GT] = ACTIONS(2341),
    [anon_sym_AMP_AMP] = ACTIONS(2341),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_BANG_EQ] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2341),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [anon_sym_GT_EQ] = ACTIONS(2341),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_AMP] = ACTIONS(2343),
    [anon_sym_PERCENT] = ACTIONS(2341),
    [anon_sym_QMARK] = ACTIONS(2341),
    [anon_sym_RBRACE] = ACTIONS(2341),
    [anon_sym_as] = ACTIONS(2341),
    [anon_sym_PIPE_PIPE] = ACTIONS(2341),
    [anon_sym_DASH_DASH] = ACTIONS(2341),
    [anon_sym_EQ_EQ] = ACTIONS(2343),
    [anon_sym_instanceof] = ACTIONS(2341),
    [anon_sym_LT] = ACTIONS(2343),
    [anon_sym_RPAREN] = ACTIONS(2341),
    [anon_sym_SLASH] = ACTIONS(2343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2341),
    [anon_sym_CARET] = ACTIONS(2341),
    [anon_sym_STAR_STAR] = ACTIONS(2341),
    [anon_sym_PLUS] = ACTIONS(2343),
    [anon_sym_GT_GT] = ACTIONS(2343),
    [anon_sym_PLUS_PLUS] = ACTIONS(2341),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2341),
    [anon_sym_in] = ACTIONS(2343),
  },
  [448] = {
    [sym_new_expression] = STATE(1133),
    [sym_augmented_assignment_expression] = STATE(1133),
    [sym_unary_expression] = STATE(1133),
    [sym_update_expression] = STATE(1133),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(1133),
    [sym_regex] = STATE(1133),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1133),
    [sym_non_null_expression] = STATE(1133),
    [sym_as_expression] = STATE(1133),
    [sym_jsx_fragment] = STATE(1133),
    [sym_yield_expression] = STATE(1133),
    [sym_jsx_element] = STATE(1133),
    [sym_internal_module] = STATE(1133),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1133),
    [sym_await_expression] = STATE(1133),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(1133),
    [sym_this] = STATE(1133),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(1133),
    [sym_generator_function] = STATE(1133),
    [sym_call_expression] = STATE(1133),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(1133),
    [sym_ternary_expression] = STATE(1133),
    [sym_binary_expression] = STATE(1133),
    [sym_template_string] = STATE(1133),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1133),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1133),
    [sym_class] = STATE(1133),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(787),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(811),
    [sym_true] = ACTIONS(2345),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2345),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2345),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_RPAREN] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(2347),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2345),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [449] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(2349),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(2351),
    [anon_sym_symbol] = ACTIONS(2351),
    [anon_sym_number] = ACTIONS(2351),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2351),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2351),
    [anon_sym_private] = ACTIONS(2351),
    [anon_sym_boolean] = ACTIONS(2351),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2351),
    [anon_sym_get] = ACTIONS(2351),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2351),
    [anon_sym_string] = ACTIONS(2351),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(2351),
    [anon_sym_type] = ACTIONS(2351),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(2351),
    [anon_sym_export] = ACTIONS(2351),
    [anon_sym_namespace] = ACTIONS(2357),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [450] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(2313),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_AMP_EQ] = ACTIONS(2313),
    [anon_sym_PLUS_EQ] = ACTIONS(2313),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(2313),
    [anon_sym_STAR_EQ] = ACTIONS(2313),
    [anon_sym_PIPE_EQ] = ACTIONS(2313),
    [anon_sym_DASH_EQ] = ACTIONS(2313),
    [anon_sym_EQ_GT] = ACTIONS(2315),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(2313),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2313),
    [anon_sym_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [451] = {
    [sym_new_expression] = STATE(1139),
    [sym_augmented_assignment_expression] = STATE(1139),
    [sym_unary_expression] = STATE(1139),
    [sym_update_expression] = STATE(1139),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(1139),
    [sym_regex] = STATE(1139),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1139),
    [sym_non_null_expression] = STATE(1139),
    [sym_as_expression] = STATE(1139),
    [sym_jsx_fragment] = STATE(1139),
    [sym_yield_expression] = STATE(1139),
    [sym_jsx_element] = STATE(1139),
    [sym_internal_module] = STATE(1139),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1139),
    [sym_await_expression] = STATE(1139),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(1139),
    [sym_this] = STATE(1139),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(1139),
    [sym_generator_function] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(1139),
    [sym_ternary_expression] = STATE(1139),
    [sym_binary_expression] = STATE(1139),
    [sym_template_string] = STATE(1139),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1139),
    [sym_class] = STATE(1139),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2359),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2361),
    [sym_true] = ACTIONS(2359),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2359),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [452] = {
    [anon_sym_EQ_GT] = ACTIONS(2309),
    [sym_comment] = ACTIONS(3),
  },
  [453] = {
    [sym_template_string] = STATE(542),
    [aux_sym_array_repeat1] = STATE(1149),
    [sym_type_arguments] = STATE(541),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(2385),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [454] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2307),
    [anon_sym_AMP_EQ] = ACTIONS(2307),
    [anon_sym_PLUS_EQ] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2307),
    [anon_sym_STAR_EQ] = ACTIONS(2307),
    [anon_sym_PIPE_EQ] = ACTIONS(2307),
    [anon_sym_DASH_EQ] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2307),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT_EQ] = ACTIONS(2307),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [455] = {
    [aux_sym_array_repeat1] = STATE(1149),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_RPAREN] = ACTIONS(2385),
    [sym_comment] = ACTIONS(3),
  },
  [456] = {
    [sym__initializer] = STATE(587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2311),
  },
  [457] = {
    [aux_sym_array_repeat1] = STATE(1150),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_RPAREN] = ACTIONS(2385),
    [sym_comment] = ACTIONS(3),
  },
  [458] = {
    [sym__initializer] = STATE(589),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2311),
  },
  [459] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2389),
    [anon_sym_LBRACK] = ACTIONS(2389),
    [anon_sym_BANG] = ACTIONS(2391),
    [anon_sym_SEMI] = ACTIONS(2389),
    [anon_sym_BQUOTE] = ACTIONS(2389),
    [sym__automatic_semicolon] = ACTIONS(2389),
    [anon_sym_PIPE] = ACTIONS(2391),
    [anon_sym_COMMA] = ACTIONS(2389),
    [anon_sym_LT_LT] = ACTIONS(2389),
    [anon_sym_STAR] = ACTIONS(2391),
    [anon_sym_GT_GT_GT] = ACTIONS(2389),
    [anon_sym_AMP_AMP] = ACTIONS(2389),
    [anon_sym_DASH] = ACTIONS(2391),
    [anon_sym_BANG_EQ] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2389),
    [anon_sym_LPAREN] = ACTIONS(2389),
    [anon_sym_GT_EQ] = ACTIONS(2389),
    [anon_sym_GT] = ACTIONS(2391),
    [anon_sym_AMP] = ACTIONS(2391),
    [anon_sym_PERCENT] = ACTIONS(2389),
    [anon_sym_QMARK] = ACTIONS(2389),
    [anon_sym_RBRACE] = ACTIONS(2389),
    [anon_sym_as] = ACTIONS(2389),
    [anon_sym_PIPE_PIPE] = ACTIONS(2389),
    [anon_sym_DASH_DASH] = ACTIONS(2389),
    [anon_sym_EQ_EQ] = ACTIONS(2391),
    [anon_sym_instanceof] = ACTIONS(2389),
    [anon_sym_LT] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2389),
    [anon_sym_SLASH] = ACTIONS(2391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2389),
    [anon_sym_CARET] = ACTIONS(2389),
    [anon_sym_STAR_STAR] = ACTIONS(2389),
    [anon_sym_PLUS] = ACTIONS(2391),
    [anon_sym_GT_GT] = ACTIONS(2391),
    [anon_sym_PLUS_PLUS] = ACTIONS(2389),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2389),
    [anon_sym_in] = ACTIONS(2391),
  },
  [460] = {
    [sym_identifier] = ACTIONS(2393),
    [anon_sym_BQUOTE] = ACTIONS(2395),
    [anon_sym_debugger] = ACTIONS(2393),
    [anon_sym_symbol] = ACTIONS(2393),
    [anon_sym_AT] = ACTIONS(2395),
    [anon_sym_DASH] = ACTIONS(2393),
    [anon_sym_void] = ACTIONS(2393),
    [anon_sym_break] = ACTIONS(2393),
    [anon_sym_const] = ACTIONS(2393),
    [sym_super] = ACTIONS(2393),
    [anon_sym_return] = ACTIONS(2393),
    [anon_sym_private] = ACTIONS(2393),
    [anon_sym_get] = ACTIONS(2393),
    [anon_sym_RBRACE] = ACTIONS(2395),
    [anon_sym_interface] = ACTIONS(2393),
    [anon_sym_default] = ACTIONS(2393),
    [anon_sym_enum] = ACTIONS(2393),
    [anon_sym_delete] = ACTIONS(2393),
    [anon_sym_continue] = ACTIONS(2393),
    [anon_sym_DASH_DASH] = ACTIONS(2395),
    [anon_sym_if] = ACTIONS(2393),
    [anon_sym_this] = ACTIONS(2393),
    [anon_sym_yield] = ACTIONS(2393),
    [sym_true] = ACTIONS(2393),
    [anon_sym_throw] = ACTIONS(2393),
    [anon_sym_protected] = ACTIONS(2393),
    [anon_sym_abstract] = ACTIONS(2393),
    [anon_sym_set] = ACTIONS(2393),
    [anon_sym_type] = ACTIONS(2393),
    [anon_sym_import] = ACTIONS(2393),
    [anon_sym_namespace] = ACTIONS(2393),
    [anon_sym_PLUS_PLUS] = ACTIONS(2395),
    [anon_sym_await] = ACTIONS(2393),
    [anon_sym_DQUOTE] = ACTIONS(2395),
    [anon_sym_else] = ACTIONS(2393),
    [anon_sym_BANG] = ACTIONS(2395),
    [anon_sym_for] = ACTIONS(2393),
    [anon_sym_LBRACK] = ACTIONS(2395),
    [sym_false] = ACTIONS(2393),
    [anon_sym_SEMI] = ACTIONS(2395),
    [anon_sym_case] = ACTIONS(2393),
    [anon_sym_module] = ACTIONS(2393),
    [anon_sym_number] = ACTIONS(2393),
    [anon_sym_class] = ACTIONS(2393),
    [anon_sym_declare] = ACTIONS(2393),
    [anon_sym_typeof] = ACTIONS(2393),
    [anon_sym_LBRACE] = ACTIONS(2395),
    [anon_sym_switch] = ACTIONS(2393),
    [anon_sym_LPAREN] = ACTIONS(2395),
    [sym_null] = ACTIONS(2393),
    [anon_sym_any] = ACTIONS(2393),
    [anon_sym_boolean] = ACTIONS(2393),
    [anon_sym_async] = ACTIONS(2393),
    [anon_sym_public] = ACTIONS(2393),
    [anon_sym_var] = ACTIONS(2393),
    [anon_sym_while] = ACTIONS(2393),
    [anon_sym_SQUOTE] = ACTIONS(2395),
    [anon_sym_try] = ACTIONS(2393),
    [anon_sym_LT] = ACTIONS(2395),
    [sym_number] = ACTIONS(2395),
    [anon_sym_SLASH] = ACTIONS(2393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2393),
    [anon_sym_function] = ACTIONS(2393),
    [sym_undefined] = ACTIONS(2393),
    [anon_sym_new] = ACTIONS(2393),
    [ts_builtin_sym_end] = ACTIONS(2395),
    [anon_sym_let] = ACTIONS(2393),
    [anon_sym_PLUS] = ACTIONS(2393),
    [anon_sym_export] = ACTIONS(2393),
    [anon_sym_do] = ACTIONS(2393),
    [anon_sym_TILDE] = ACTIONS(2395),
    [anon_sym_with] = ACTIONS(2393),
  },
  [461] = {
    [sym_new_expression] = STATE(1163),
    [sym_augmented_assignment_expression] = STATE(1163),
    [sym_unary_expression] = STATE(1163),
    [sym_update_expression] = STATE(1163),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1163),
    [sym_non_null_expression] = STATE(1163),
    [sym_as_expression] = STATE(1163),
    [sym_jsx_fragment] = STATE(1163),
    [sym_yield_expression] = STATE(1163),
    [sym_jsx_element] = STATE(1163),
    [sym_internal_module] = STATE(1163),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1163),
    [sym_await_expression] = STATE(1163),
    [sym_member_expression] = STATE(1164),
    [sym_generic_type] = STATE(1168),
    [sym_string] = STATE(1163),
    [sym_this] = STATE(1163),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_nested_type_identifier] = STATE(1166),
    [sym_anonymous_class] = STATE(1163),
    [sym_generator_function] = STATE(1163),
    [sym_call_expression] = STATE(1163),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(1163),
    [sym_ternary_expression] = STATE(1163),
    [sym_binary_expression] = STATE(1163),
    [sym_template_string] = STATE(1163),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1163),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1163),
    [sym__type_reference] = STATE(1168),
    [sym_class] = STATE(1163),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(2399),
    [sym_false] = ACTIONS(2401),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2401),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2415),
    [sym_true] = ACTIONS(2401),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2401),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [462] = {
    [sym_object_type] = STATE(1169),
    [sym_extends_clause] = STATE(1170),
    [anon_sym_extends] = ACTIONS(829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(777),
  },
  [463] = {
    [sym_identifier] = ACTIONS(2425),
    [anon_sym_BQUOTE] = ACTIONS(2427),
    [anon_sym_debugger] = ACTIONS(2425),
    [anon_sym_symbol] = ACTIONS(2425),
    [anon_sym_AT] = ACTIONS(2427),
    [anon_sym_DASH] = ACTIONS(2425),
    [anon_sym_void] = ACTIONS(2425),
    [anon_sym_break] = ACTIONS(2425),
    [anon_sym_const] = ACTIONS(2425),
    [sym_super] = ACTIONS(2425),
    [anon_sym_return] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_get] = ACTIONS(2425),
    [anon_sym_RBRACE] = ACTIONS(2427),
    [anon_sym_interface] = ACTIONS(2425),
    [anon_sym_default] = ACTIONS(2425),
    [anon_sym_enum] = ACTIONS(2425),
    [anon_sym_delete] = ACTIONS(2425),
    [anon_sym_continue] = ACTIONS(2425),
    [anon_sym_DASH_DASH] = ACTIONS(2427),
    [anon_sym_if] = ACTIONS(2425),
    [anon_sym_this] = ACTIONS(2425),
    [anon_sym_yield] = ACTIONS(2425),
    [sym_true] = ACTIONS(2425),
    [anon_sym_throw] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_abstract] = ACTIONS(2425),
    [anon_sym_set] = ACTIONS(2425),
    [anon_sym_type] = ACTIONS(2425),
    [anon_sym_import] = ACTIONS(2425),
    [anon_sym_namespace] = ACTIONS(2425),
    [anon_sym_PLUS_PLUS] = ACTIONS(2427),
    [anon_sym_await] = ACTIONS(2425),
    [anon_sym_DQUOTE] = ACTIONS(2427),
    [anon_sym_else] = ACTIONS(2425),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_for] = ACTIONS(2425),
    [anon_sym_LBRACK] = ACTIONS(2427),
    [sym_false] = ACTIONS(2425),
    [anon_sym_SEMI] = ACTIONS(2427),
    [anon_sym_case] = ACTIONS(2425),
    [anon_sym_module] = ACTIONS(2425),
    [anon_sym_number] = ACTIONS(2425),
    [anon_sym_class] = ACTIONS(2425),
    [anon_sym_declare] = ACTIONS(2425),
    [anon_sym_typeof] = ACTIONS(2425),
    [anon_sym_LBRACE] = ACTIONS(2427),
    [anon_sym_switch] = ACTIONS(2425),
    [anon_sym_LPAREN] = ACTIONS(2427),
    [sym_null] = ACTIONS(2425),
    [anon_sym_any] = ACTIONS(2425),
    [anon_sym_boolean] = ACTIONS(2425),
    [anon_sym_async] = ACTIONS(2425),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_var] = ACTIONS(2425),
    [anon_sym_while] = ACTIONS(2425),
    [anon_sym_SQUOTE] = ACTIONS(2427),
    [anon_sym_try] = ACTIONS(2425),
    [anon_sym_LT] = ACTIONS(2427),
    [sym_number] = ACTIONS(2427),
    [anon_sym_SLASH] = ACTIONS(2425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2425),
    [anon_sym_function] = ACTIONS(2425),
    [sym_undefined] = ACTIONS(2425),
    [anon_sym_new] = ACTIONS(2425),
    [ts_builtin_sym_end] = ACTIONS(2427),
    [anon_sym_let] = ACTIONS(2425),
    [anon_sym_PLUS] = ACTIONS(2425),
    [anon_sym_export] = ACTIONS(2425),
    [anon_sym_do] = ACTIONS(2425),
    [anon_sym_TILDE] = ACTIONS(2427),
    [anon_sym_with] = ACTIONS(2425),
  },
  [464] = {
    [sym_object_type] = STATE(1169),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(777),
  },
  [465] = {
    [sym_computed_property_name] = STATE(1172),
    [sym__enum_member] = STATE(1173),
    [sym__property_name] = STATE(1172),
    [sym_string] = STATE(1172),
    [sym_enum_assignment] = STATE(1173),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACE] = ACTIONS(2429),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(2431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_async] = ACTIONS(1230),
  },
  [466] = {
    [sym_identifier] = ACTIONS(2433),
    [anon_sym_BQUOTE] = ACTIONS(2435),
    [anon_sym_debugger] = ACTIONS(2433),
    [anon_sym_symbol] = ACTIONS(2433),
    [anon_sym_AT] = ACTIONS(2435),
    [anon_sym_DASH] = ACTIONS(2433),
    [anon_sym_void] = ACTIONS(2433),
    [anon_sym_break] = ACTIONS(2433),
    [anon_sym_const] = ACTIONS(2433),
    [sym_super] = ACTIONS(2433),
    [anon_sym_return] = ACTIONS(2433),
    [anon_sym_private] = ACTIONS(2433),
    [anon_sym_get] = ACTIONS(2433),
    [anon_sym_RBRACE] = ACTIONS(2435),
    [anon_sym_interface] = ACTIONS(2433),
    [anon_sym_default] = ACTIONS(2433),
    [anon_sym_enum] = ACTIONS(2433),
    [anon_sym_delete] = ACTIONS(2433),
    [anon_sym_continue] = ACTIONS(2433),
    [anon_sym_DASH_DASH] = ACTIONS(2435),
    [anon_sym_if] = ACTIONS(2433),
    [anon_sym_this] = ACTIONS(2433),
    [anon_sym_yield] = ACTIONS(2433),
    [sym_true] = ACTIONS(2433),
    [anon_sym_throw] = ACTIONS(2433),
    [anon_sym_protected] = ACTIONS(2433),
    [anon_sym_abstract] = ACTIONS(2433),
    [anon_sym_set] = ACTIONS(2433),
    [anon_sym_type] = ACTIONS(2433),
    [anon_sym_import] = ACTIONS(2433),
    [anon_sym_namespace] = ACTIONS(2433),
    [anon_sym_PLUS_PLUS] = ACTIONS(2435),
    [anon_sym_await] = ACTIONS(2433),
    [anon_sym_DQUOTE] = ACTIONS(2435),
    [anon_sym_else] = ACTIONS(2433),
    [anon_sym_BANG] = ACTIONS(2435),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_LBRACK] = ACTIONS(2435),
    [sym_false] = ACTIONS(2433),
    [anon_sym_SEMI] = ACTIONS(2435),
    [anon_sym_case] = ACTIONS(2433),
    [anon_sym_module] = ACTIONS(2433),
    [anon_sym_number] = ACTIONS(2433),
    [anon_sym_class] = ACTIONS(2433),
    [anon_sym_declare] = ACTIONS(2433),
    [anon_sym_typeof] = ACTIONS(2433),
    [anon_sym_LBRACE] = ACTIONS(2435),
    [anon_sym_switch] = ACTIONS(2433),
    [anon_sym_LPAREN] = ACTIONS(2435),
    [sym_null] = ACTIONS(2433),
    [anon_sym_any] = ACTIONS(2433),
    [anon_sym_boolean] = ACTIONS(2433),
    [anon_sym_async] = ACTIONS(2433),
    [anon_sym_public] = ACTIONS(2433),
    [anon_sym_var] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2433),
    [anon_sym_SQUOTE] = ACTIONS(2435),
    [anon_sym_try] = ACTIONS(2433),
    [anon_sym_LT] = ACTIONS(2435),
    [sym_number] = ACTIONS(2435),
    [anon_sym_SLASH] = ACTIONS(2433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2433),
    [anon_sym_function] = ACTIONS(2433),
    [sym_undefined] = ACTIONS(2433),
    [anon_sym_new] = ACTIONS(2433),
    [ts_builtin_sym_end] = ACTIONS(2435),
    [anon_sym_let] = ACTIONS(2433),
    [anon_sym_PLUS] = ACTIONS(2433),
    [anon_sym_export] = ACTIONS(2433),
    [anon_sym_do] = ACTIONS(2433),
    [anon_sym_TILDE] = ACTIONS(2435),
    [anon_sym_with] = ACTIONS(2433),
  },
  [467] = {
    [sym_identifier] = ACTIONS(2437),
    [anon_sym_BQUOTE] = ACTIONS(2439),
    [anon_sym_debugger] = ACTIONS(2437),
    [anon_sym_symbol] = ACTIONS(2437),
    [anon_sym_AT] = ACTIONS(2439),
    [anon_sym_DASH] = ACTIONS(2437),
    [anon_sym_void] = ACTIONS(2437),
    [anon_sym_break] = ACTIONS(2437),
    [anon_sym_const] = ACTIONS(2437),
    [sym_super] = ACTIONS(2437),
    [anon_sym_return] = ACTIONS(2437),
    [anon_sym_private] = ACTIONS(2437),
    [anon_sym_get] = ACTIONS(2437),
    [anon_sym_RBRACE] = ACTIONS(2439),
    [anon_sym_interface] = ACTIONS(2437),
    [anon_sym_default] = ACTIONS(2437),
    [anon_sym_enum] = ACTIONS(2437),
    [anon_sym_delete] = ACTIONS(2437),
    [anon_sym_continue] = ACTIONS(2437),
    [anon_sym_DASH_DASH] = ACTIONS(2439),
    [anon_sym_if] = ACTIONS(2437),
    [anon_sym_this] = ACTIONS(2437),
    [anon_sym_yield] = ACTIONS(2437),
    [sym_true] = ACTIONS(2437),
    [anon_sym_throw] = ACTIONS(2437),
    [anon_sym_protected] = ACTIONS(2437),
    [anon_sym_abstract] = ACTIONS(2437),
    [anon_sym_set] = ACTIONS(2437),
    [anon_sym_type] = ACTIONS(2437),
    [anon_sym_import] = ACTIONS(2437),
    [anon_sym_namespace] = ACTIONS(2437),
    [anon_sym_PLUS_PLUS] = ACTIONS(2439),
    [anon_sym_await] = ACTIONS(2437),
    [anon_sym_DQUOTE] = ACTIONS(2439),
    [anon_sym_else] = ACTIONS(2437),
    [anon_sym_BANG] = ACTIONS(2439),
    [anon_sym_for] = ACTIONS(2437),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [sym_false] = ACTIONS(2437),
    [anon_sym_SEMI] = ACTIONS(2439),
    [anon_sym_case] = ACTIONS(2437),
    [anon_sym_module] = ACTIONS(2437),
    [anon_sym_number] = ACTIONS(2437),
    [anon_sym_class] = ACTIONS(2437),
    [anon_sym_declare] = ACTIONS(2437),
    [anon_sym_typeof] = ACTIONS(2437),
    [anon_sym_LBRACE] = ACTIONS(2439),
    [anon_sym_switch] = ACTIONS(2437),
    [anon_sym_LPAREN] = ACTIONS(2439),
    [sym_null] = ACTIONS(2437),
    [anon_sym_any] = ACTIONS(2437),
    [anon_sym_boolean] = ACTIONS(2437),
    [anon_sym_async] = ACTIONS(2437),
    [anon_sym_public] = ACTIONS(2437),
    [anon_sym_var] = ACTIONS(2437),
    [anon_sym_while] = ACTIONS(2437),
    [anon_sym_SQUOTE] = ACTIONS(2439),
    [anon_sym_try] = ACTIONS(2437),
    [anon_sym_LT] = ACTIONS(2439),
    [sym_number] = ACTIONS(2439),
    [anon_sym_SLASH] = ACTIONS(2437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2437),
    [anon_sym_function] = ACTIONS(2437),
    [sym_undefined] = ACTIONS(2437),
    [anon_sym_new] = ACTIONS(2437),
    [ts_builtin_sym_end] = ACTIONS(2439),
    [anon_sym_let] = ACTIONS(2437),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_export] = ACTIONS(2437),
    [anon_sym_do] = ACTIONS(2437),
    [anon_sym_TILDE] = ACTIONS(2439),
    [anon_sym_with] = ACTIONS(2437),
  },
  [468] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1332),
    [anon_sym_AMP_EQ] = ACTIONS(1332),
    [anon_sym_PLUS_EQ] = ACTIONS(1332),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1332),
    [anon_sym_STAR_EQ] = ACTIONS(1332),
    [anon_sym_PIPE_EQ] = ACTIONS(1332),
    [anon_sym_DASH_EQ] = ACTIONS(1332),
    [anon_sym_EQ_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1332),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT_EQ] = ACTIONS(1332),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1347),
  },
  [469] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1353),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_AMP_EQ] = ACTIONS(1353),
    [anon_sym_PLUS_EQ] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(1353),
    [anon_sym_STAR_EQ] = ACTIONS(1353),
    [anon_sym_PIPE_EQ] = ACTIONS(1353),
    [anon_sym_DASH_EQ] = ACTIONS(1353),
    [anon_sym_EQ_GT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_SLASH_EQ] = ACTIONS(1353),
    [anon_sym_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1353),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [470] = {
    [sym_new_expression] = STATE(734),
    [sym_augmented_assignment_expression] = STATE(734),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(734),
    [sym_update_expression] = STATE(734),
    [sym_regex] = STATE(734),
    [sym_meta_property] = STATE(734),
    [sym_call_signature] = STATE(243),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(734),
    [sym_non_null_expression] = STATE(734),
    [sym_yield_expression] = STATE(734),
    [sym_jsx_fragment] = STATE(734),
    [sym_jsx_element] = STATE(734),
    [sym_as_expression] = STATE(734),
    [sym_internal_module] = STATE(734),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(734),
    [sym_await_expression] = STATE(734),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(734),
    [sym_this] = STATE(734),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(734),
    [sym_generator_function] = STATE(734),
    [sym_call_expression] = STATE(734),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(734),
    [sym_ternary_expression] = STATE(734),
    [sym_binary_expression] = STATE(734),
    [sym_template_string] = STATE(734),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(734),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(734),
    [sym_class] = STATE(734),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(1353),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_AMP_EQ] = ACTIONS(1353),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1353),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_PIPE_EQ] = ACTIONS(1353),
    [anon_sym_DASH_EQ] = ACTIONS(1353),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(432),
    [sym_true] = ACTIONS(1366),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1353),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(416),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(1366),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_STAR_EQ] = ACTIONS(1353),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_EQ_GT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(1368),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1353),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1366),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [471] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_call_signature] = STATE(737),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1353),
    [anon_sym_symbol] = ACTIONS(1378),
    [anon_sym_AMP_EQ] = ACTIONS(1353),
    [anon_sym_PLUS_EQ] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_void] = ACTIONS(1378),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1353),
    [anon_sym_private] = ACTIONS(1378),
    [anon_sym_PIPE_EQ] = ACTIONS(1353),
    [anon_sym_DASH_EQ] = ACTIONS(1353),
    [anon_sym_get] = ACTIONS(1378),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(1378),
    [anon_sym_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(1378),
    [anon_sym_type] = ACTIONS(1378),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1378),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1353),
    [anon_sym_namespace] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1378),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_number] = ACTIONS(1378),
    [anon_sym_declare] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1378),
    [anon_sym_STAR_EQ] = ACTIONS(1353),
    [anon_sym_boolean] = ACTIONS(1378),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_public] = ACTIONS(1378),
    [anon_sym_EQ_GT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1353),
    [anon_sym_string] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1378),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [472] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(1353),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_AMP_EQ] = ACTIONS(1353),
    [anon_sym_PLUS_EQ] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(1353),
    [anon_sym_STAR_EQ] = ACTIONS(1353),
    [anon_sym_PIPE_EQ] = ACTIONS(1353),
    [anon_sym_DASH_EQ] = ACTIONS(1353),
    [anon_sym_EQ_GT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_SLASH_EQ] = ACTIONS(1353),
    [anon_sym_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1353),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [473] = {
    [sym_template_string] = STATE(542),
    [sym_type_arguments] = STATE(541),
    [sym_type_annotation] = STATE(1175),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(1347),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1410),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_PIPE_PIPE] = ACTIONS(1426),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1347),
    [anon_sym_instanceof] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_RPAREN] = ACTIONS(2441),
    [anon_sym_SLASH] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1434),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1426),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [474] = {
    [anon_sym_RPAREN] = ACTIONS(2441),
    [sym_comment] = ACTIONS(3),
  },
  [475] = {
    [sym__initializer] = STATE(587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1347),
  },
  [476] = {
    [sym__initializer] = STATE(589),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1347),
  },
  [477] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2443),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [478] = {
    [sym_parenthesized_expression] = STATE(1177),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [479] = {
    [anon_sym_await] = ACTIONS(2445),
    [anon_sym_LPAREN] = ACTIONS(2447),
    [sym_comment] = ACTIONS(3),
  },
  [480] = {
    [sym_type_alias_declaration] = STATE(193),
    [aux_sym_export_statement_repeat1] = STATE(1183),
    [sym__declaration] = STATE(193),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(193),
    [sym_import_alias] = STATE(193),
    [sym_export_statement] = STATE(193),
    [sym_generator_function] = STATE(193),
    [sym_lexical_declaration] = STATE(193),
    [sym_internal_module] = STATE(193),
    [sym_decorator] = STATE(1183),
    [sym_enum_declaration] = STATE(193),
    [sym_function] = STATE(193),
    [sym_function_signature] = STATE(193),
    [sym_variable_declaration] = STATE(193),
    [sym_abstract_class] = STATE(193),
    [sym_module] = STATE(193),
    [sym_interface_declaration] = STATE(193),
    [sym_class] = STATE(193),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(324),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(2449),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_declare] = ACTIONS(2451),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(2453),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [481] = {
    [sym_parenthesized_expression] = STATE(1184),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [482] = {
    [sym_type_alias_declaration] = STATE(300),
    [aux_sym_export_statement_repeat1] = STATE(1183),
    [sym__declaration] = STATE(300),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(300),
    [sym_import_alias] = STATE(300),
    [sym_export_statement] = STATE(300),
    [sym_generator_function] = STATE(300),
    [sym_export_clause] = STATE(301),
    [sym_lexical_declaration] = STATE(300),
    [sym_internal_module] = STATE(300),
    [sym_decorator] = STATE(1183),
    [sym_enum_declaration] = STATE(300),
    [sym_function] = STATE(300),
    [sym_function_signature] = STATE(300),
    [sym_variable_declaration] = STATE(300),
    [sym_abstract_class] = STATE(300),
    [sym_module] = STATE(300),
    [sym_interface_declaration] = STATE(300),
    [sym_class] = STATE(300),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(508),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(511),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_as] = ACTIONS(515),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_declare] = ACTIONS(2451),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(2453),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [483] = {
    [sym_parenthesized_expression] = STATE(1185),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [484] = {
    [sym_identifier] = ACTIONS(2455),
    [anon_sym_BQUOTE] = ACTIONS(2457),
    [anon_sym_debugger] = ACTIONS(2455),
    [anon_sym_symbol] = ACTIONS(2455),
    [anon_sym_AT] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2455),
    [anon_sym_void] = ACTIONS(2455),
    [anon_sym_break] = ACTIONS(2455),
    [anon_sym_const] = ACTIONS(2455),
    [sym_super] = ACTIONS(2455),
    [anon_sym_return] = ACTIONS(2455),
    [anon_sym_private] = ACTIONS(2455),
    [anon_sym_get] = ACTIONS(2455),
    [anon_sym_interface] = ACTIONS(2455),
    [anon_sym_enum] = ACTIONS(2455),
    [anon_sym_delete] = ACTIONS(2455),
    [anon_sym_continue] = ACTIONS(2455),
    [anon_sym_DASH_DASH] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2455),
    [anon_sym_this] = ACTIONS(2455),
    [anon_sym_yield] = ACTIONS(2455),
    [sym_true] = ACTIONS(2455),
    [anon_sym_throw] = ACTIONS(2455),
    [anon_sym_protected] = ACTIONS(2455),
    [anon_sym_abstract] = ACTIONS(2455),
    [anon_sym_set] = ACTIONS(2455),
    [anon_sym_type] = ACTIONS(2455),
    [anon_sym_import] = ACTIONS(2455),
    [anon_sym_namespace] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2457),
    [anon_sym_await] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [anon_sym_else] = ACTIONS(2459),
    [anon_sym_BANG] = ACTIONS(2457),
    [anon_sym_for] = ACTIONS(2455),
    [anon_sym_LBRACK] = ACTIONS(2457),
    [sym_false] = ACTIONS(2455),
    [anon_sym_SEMI] = ACTIONS(2457),
    [anon_sym_module] = ACTIONS(2455),
    [anon_sym_number] = ACTIONS(2455),
    [anon_sym_class] = ACTIONS(2455),
    [anon_sym_declare] = ACTIONS(2455),
    [anon_sym_typeof] = ACTIONS(2455),
    [anon_sym_LBRACE] = ACTIONS(2457),
    [anon_sym_switch] = ACTIONS(2455),
    [anon_sym_LPAREN] = ACTIONS(2457),
    [sym_null] = ACTIONS(2455),
    [anon_sym_any] = ACTIONS(2455),
    [anon_sym_boolean] = ACTIONS(2455),
    [anon_sym_async] = ACTIONS(2455),
    [anon_sym_public] = ACTIONS(2455),
    [anon_sym_var] = ACTIONS(2455),
    [anon_sym_while] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_try] = ACTIONS(2455),
    [anon_sym_LT] = ACTIONS(2457),
    [sym_number] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2455),
    [anon_sym_function] = ACTIONS(2455),
    [sym_undefined] = ACTIONS(2455),
    [anon_sym_new] = ACTIONS(2455),
    [ts_builtin_sym_end] = ACTIONS(2457),
    [anon_sym_let] = ACTIONS(2455),
    [anon_sym_PLUS] = ACTIONS(2455),
    [anon_sym_export] = ACTIONS(2455),
    [anon_sym_do] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2457),
    [anon_sym_with] = ACTIONS(2455),
  },
  [485] = {
    [aux_sym_export_statement_repeat1] = STATE(320),
    [sym_decorator] = STATE(320),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(2461),
    [anon_sym_class] = ACTIONS(546),
    [sym_comment] = ACTIONS(3),
  },
  [486] = {
    [sym_identifier] = ACTIONS(2463),
    [anon_sym_BQUOTE] = ACTIONS(2465),
    [anon_sym_debugger] = ACTIONS(2463),
    [anon_sym_symbol] = ACTIONS(2463),
    [anon_sym_AT] = ACTIONS(2465),
    [anon_sym_DASH] = ACTIONS(2463),
    [anon_sym_void] = ACTIONS(2463),
    [anon_sym_break] = ACTIONS(2463),
    [anon_sym_const] = ACTIONS(2463),
    [sym_super] = ACTIONS(2463),
    [anon_sym_return] = ACTIONS(2463),
    [anon_sym_private] = ACTIONS(2463),
    [anon_sym_get] = ACTIONS(2463),
    [anon_sym_RBRACE] = ACTIONS(2465),
    [anon_sym_interface] = ACTIONS(2463),
    [anon_sym_default] = ACTIONS(2463),
    [anon_sym_enum] = ACTIONS(2463),
    [anon_sym_delete] = ACTIONS(2463),
    [anon_sym_continue] = ACTIONS(2463),
    [anon_sym_DASH_DASH] = ACTIONS(2465),
    [anon_sym_if] = ACTIONS(2463),
    [anon_sym_this] = ACTIONS(2463),
    [anon_sym_yield] = ACTIONS(2463),
    [sym_true] = ACTIONS(2463),
    [anon_sym_throw] = ACTIONS(2463),
    [anon_sym_protected] = ACTIONS(2463),
    [anon_sym_abstract] = ACTIONS(2463),
    [anon_sym_set] = ACTIONS(2463),
    [anon_sym_type] = ACTIONS(2463),
    [anon_sym_import] = ACTIONS(2463),
    [anon_sym_namespace] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(2465),
    [anon_sym_await] = ACTIONS(2463),
    [anon_sym_DQUOTE] = ACTIONS(2465),
    [anon_sym_else] = ACTIONS(2463),
    [anon_sym_BANG] = ACTIONS(2465),
    [anon_sym_for] = ACTIONS(2463),
    [anon_sym_LBRACK] = ACTIONS(2465),
    [sym_false] = ACTIONS(2463),
    [anon_sym_SEMI] = ACTIONS(2465),
    [anon_sym_case] = ACTIONS(2463),
    [anon_sym_module] = ACTIONS(2463),
    [anon_sym_number] = ACTIONS(2463),
    [anon_sym_class] = ACTIONS(2463),
    [anon_sym_declare] = ACTIONS(2463),
    [anon_sym_typeof] = ACTIONS(2463),
    [anon_sym_LBRACE] = ACTIONS(2465),
    [anon_sym_switch] = ACTIONS(2463),
    [anon_sym_LPAREN] = ACTIONS(2465),
    [sym_null] = ACTIONS(2463),
    [anon_sym_any] = ACTIONS(2463),
    [anon_sym_boolean] = ACTIONS(2463),
    [anon_sym_async] = ACTIONS(2463),
    [anon_sym_public] = ACTIONS(2463),
    [anon_sym_var] = ACTIONS(2463),
    [anon_sym_while] = ACTIONS(2463),
    [anon_sym_SQUOTE] = ACTIONS(2465),
    [anon_sym_try] = ACTIONS(2463),
    [anon_sym_LT] = ACTIONS(2465),
    [sym_number] = ACTIONS(2465),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2463),
    [anon_sym_function] = ACTIONS(2463),
    [sym_undefined] = ACTIONS(2463),
    [anon_sym_new] = ACTIONS(2463),
    [ts_builtin_sym_end] = ACTIONS(2465),
    [anon_sym_let] = ACTIONS(2463),
    [anon_sym_PLUS] = ACTIONS(2463),
    [anon_sym_export] = ACTIONS(2463),
    [anon_sym_do] = ACTIONS(2463),
    [anon_sym_TILDE] = ACTIONS(2465),
    [anon_sym_with] = ACTIONS(2463),
  },
  [487] = {
    [sym_class_heritage] = STATE(1189),
    [sym_type_parameters] = STATE(1190),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(1191),
    [anon_sym_extends] = ACTIONS(1131),
    [anon_sym_implements] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2467),
  },
  [488] = {
    [sym_union_type] = STATE(1197),
    [sym__type] = STATE(1197),
    [sym_constructor_type] = STATE(1197),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1198),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1197),
    [sym_function_type] = STATE(1197),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1199),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2475),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [489] = {
    [anon_sym_EQ] = ACTIONS(2479),
    [sym_comment] = ACTIONS(3),
  },
  [490] = {
    [sym_namespace_import] = STATE(1201),
    [sym_named_imports] = STATE(1201),
    [sym_comment] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(234),
  },
  [491] = {
    [sym_nested_identifier] = STATE(1203),
    [anon_sym_require] = ACTIONS(2481),
    [sym_identifier] = ACTIONS(2483),
    [sym_comment] = ACTIONS(3),
  },
  [492] = {
    [anon_sym_EQ] = ACTIONS(2485),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_from] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
  },
  [493] = {
    [sym__automatic_semicolon] = ACTIONS(2487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(2487),
  },
  [494] = {
    [sym__from_clause] = STATE(1206),
    [anon_sym_from] = ACTIONS(901),
    [sym_comment] = ACTIONS(3),
  },
  [495] = {
    [sym_identifier] = ACTIONS(2489),
    [sym_comment] = ACTIONS(3),
  },
  [496] = {
    [anon_sym_RBRACE] = ACTIONS(2491),
    [anon_sym_COMMA] = ACTIONS(2491),
    [anon_sym_as] = ACTIONS(2493),
    [sym_comment] = ACTIONS(3),
  },
  [497] = {
    [anon_sym_from] = ACTIONS(2495),
    [sym_comment] = ACTIONS(3),
  },
  [498] = {
    [sym_identifier] = ACTIONS(2497),
    [sym_comment] = ACTIONS(3),
  },
  [499] = {
    [anon_sym_RBRACE] = ACTIONS(2499),
    [sym_comment] = ACTIONS(3),
  },
  [500] = {
    [aux_sym_named_imports_repeat1] = STATE(1213),
    [anon_sym_COMMA] = ACTIONS(2501),
    [anon_sym_RBRACE] = ACTIONS(2503),
    [sym_comment] = ACTIONS(3),
  },
  [501] = {
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_BQUOTE] = ACTIONS(2507),
    [anon_sym_debugger] = ACTIONS(2505),
    [anon_sym_symbol] = ACTIONS(2505),
    [anon_sym_AT] = ACTIONS(2507),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_void] = ACTIONS(2505),
    [anon_sym_break] = ACTIONS(2505),
    [anon_sym_const] = ACTIONS(2505),
    [sym_super] = ACTIONS(2505),
    [anon_sym_return] = ACTIONS(2505),
    [anon_sym_private] = ACTIONS(2505),
    [anon_sym_get] = ACTIONS(2505),
    [anon_sym_RBRACE] = ACTIONS(2507),
    [anon_sym_interface] = ACTIONS(2505),
    [anon_sym_default] = ACTIONS(2505),
    [anon_sym_enum] = ACTIONS(2505),
    [anon_sym_delete] = ACTIONS(2505),
    [anon_sym_continue] = ACTIONS(2505),
    [anon_sym_DASH_DASH] = ACTIONS(2507),
    [anon_sym_if] = ACTIONS(2505),
    [anon_sym_this] = ACTIONS(2505),
    [anon_sym_yield] = ACTIONS(2505),
    [sym_true] = ACTIONS(2505),
    [anon_sym_throw] = ACTIONS(2505),
    [anon_sym_protected] = ACTIONS(2505),
    [anon_sym_abstract] = ACTIONS(2505),
    [anon_sym_set] = ACTIONS(2505),
    [anon_sym_type] = ACTIONS(2505),
    [anon_sym_import] = ACTIONS(2505),
    [anon_sym_namespace] = ACTIONS(2505),
    [anon_sym_PLUS_PLUS] = ACTIONS(2507),
    [anon_sym_await] = ACTIONS(2505),
    [anon_sym_DQUOTE] = ACTIONS(2507),
    [anon_sym_else] = ACTIONS(2505),
    [anon_sym_BANG] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2505),
    [anon_sym_LBRACK] = ACTIONS(2507),
    [sym_false] = ACTIONS(2505),
    [anon_sym_SEMI] = ACTIONS(2507),
    [anon_sym_case] = ACTIONS(2505),
    [anon_sym_module] = ACTIONS(2505),
    [anon_sym_number] = ACTIONS(2505),
    [anon_sym_class] = ACTIONS(2505),
    [anon_sym_declare] = ACTIONS(2505),
    [anon_sym_typeof] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(2507),
    [anon_sym_switch] = ACTIONS(2505),
    [anon_sym_LPAREN] = ACTIONS(2507),
    [sym_null] = ACTIONS(2505),
    [anon_sym_any] = ACTIONS(2505),
    [anon_sym_boolean] = ACTIONS(2505),
    [anon_sym_async] = ACTIONS(2505),
    [anon_sym_public] = ACTIONS(2505),
    [anon_sym_var] = ACTIONS(2505),
    [anon_sym_while] = ACTIONS(2505),
    [anon_sym_SQUOTE] = ACTIONS(2507),
    [anon_sym_try] = ACTIONS(2505),
    [anon_sym_LT] = ACTIONS(2507),
    [sym_number] = ACTIONS(2507),
    [anon_sym_SLASH] = ACTIONS(2505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2505),
    [anon_sym_function] = ACTIONS(2505),
    [sym_undefined] = ACTIONS(2505),
    [anon_sym_new] = ACTIONS(2505),
    [ts_builtin_sym_end] = ACTIONS(2507),
    [anon_sym_let] = ACTIONS(2505),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_export] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2505),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_with] = ACTIONS(2505),
  },
  [502] = {
    [sym_string] = STATE(1214),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(87),
  },
  [503] = {
    [sym_identifier] = ACTIONS(2509),
    [sym_comment] = ACTIONS(3),
  },
  [504] = {
    [sym_type_alias_declaration] = STATE(976),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(976),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(976),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(976),
    [sym_return_statement] = STATE(976),
    [aux_sym_program_repeat1] = STATE(976),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(976),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(976),
    [sym_switch_statement] = STATE(976),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(976),
    [sym_throw_statement] = STATE(976),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(976),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(976),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(976),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(976),
    [sym_abstract_class] = STATE(976),
    [sym_interface_declaration] = STATE(976),
    [sym_statement_block] = STATE(976),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(976),
    [sym_debugger_statement] = STATE(976),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(976),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(976),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(976),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(976),
    [sym_empty_statement] = STATE(976),
    [sym_import_alias] = STATE(976),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(976),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(976),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(976),
    [sym_break_statement] = STATE(976),
    [sym_labeled_statement] = STATE(976),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(976),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(2511),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [505] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2513),
    [sym_identifier] = ACTIONS(2515),
    [sym__automatic_semicolon] = ACTIONS(2513),
    [anon_sym_BQUOTE] = ACTIONS(2513),
    [anon_sym_debugger] = ACTIONS(2515),
    [ts_builtin_sym_end] = ACTIONS(2513),
    [anon_sym_symbol] = ACTIONS(2515),
    [anon_sym_AT] = ACTIONS(2513),
    [anon_sym_PIPE] = ACTIONS(2515),
    [anon_sym_COMMA] = ACTIONS(2513),
    [anon_sym_DASH] = ACTIONS(2515),
    [anon_sym_STAR] = ACTIONS(2515),
    [anon_sym_GT_GT_GT] = ACTIONS(2513),
    [anon_sym_void] = ACTIONS(2515),
    [anon_sym_break] = ACTIONS(2515),
    [anon_sym_BANG_EQ] = ACTIONS(2515),
    [anon_sym_const] = ACTIONS(2515),
    [anon_sym_GT_EQ] = ACTIONS(2513),
    [sym_super] = ACTIONS(2515),
    [anon_sym_return] = ACTIONS(2515),
    [anon_sym_private] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_RBRACE] = ACTIONS(2513),
    [anon_sym_PERCENT] = ACTIONS(2513),
    [anon_sym_interface] = ACTIONS(2515),
    [anon_sym_default] = ACTIONS(2515),
    [anon_sym_as] = ACTIONS(2515),
    [anon_sym_delete] = ACTIONS(2515),
    [anon_sym_continue] = ACTIONS(2515),
    [anon_sym_DASH_DASH] = ACTIONS(2513),
    [anon_sym_if] = ACTIONS(2515),
    [anon_sym_instanceof] = ACTIONS(2515),
    [anon_sym_this] = ACTIONS(2515),
    [anon_sym_yield] = ACTIONS(2515),
    [sym_true] = ACTIONS(2515),
    [anon_sym_throw] = ACTIONS(2515),
    [anon_sym_enum] = ACTIONS(2515),
    [anon_sym_protected] = ACTIONS(2515),
    [anon_sym_abstract] = ACTIONS(2515),
    [anon_sym_DOT] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_STAR_STAR] = ACTIONS(2513),
    [anon_sym_import] = ACTIONS(2515),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2513),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_PLUS_PLUS] = ACTIONS(2513),
    [anon_sym_await] = ACTIONS(2515),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [anon_sym_else] = ACTIONS(2515),
    [anon_sym_BANG] = ACTIONS(2515),
    [anon_sym_for] = ACTIONS(2515),
    [anon_sym_LBRACK] = ACTIONS(2513),
    [sym_false] = ACTIONS(2515),
    [anon_sym_SEMI] = ACTIONS(2513),
    [anon_sym_case] = ACTIONS(2515),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_number] = ACTIONS(2515),
    [anon_sym_class] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_typeof] = ACTIONS(2515),
    [anon_sym_LT_LT] = ACTIONS(2513),
    [anon_sym_LBRACE] = ACTIONS(2513),
    [anon_sym_AMP_AMP] = ACTIONS(2513),
    [anon_sym_switch] = ACTIONS(2515),
    [anon_sym_LT_EQ] = ACTIONS(2513),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [sym_null] = ACTIONS(2515),
    [anon_sym_GT] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2515),
    [anon_sym_boolean] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2515),
    [anon_sym_AMP] = ACTIONS(2515),
    [anon_sym_var] = ACTIONS(2515),
    [anon_sym_QMARK] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2513),
    [anon_sym_while] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2513),
    [anon_sym_try] = ACTIONS(2515),
    [anon_sym_EQ_EQ] = ACTIONS(2515),
    [anon_sym_RPAREN] = ACTIONS(2513),
    [anon_sym_LT] = ACTIONS(2515),
    [sym_number] = ACTIONS(2513),
    [anon_sym_SLASH] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2515),
    [anon_sym_function] = ACTIONS(2515),
    [sym_undefined] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2515),
    [anon_sym_CARET] = ACTIONS(2513),
    [anon_sym_let] = ACTIONS(2515),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_GT_GT] = ACTIONS(2515),
    [anon_sym_do] = ACTIONS(2515),
    [anon_sym_TILDE] = ACTIONS(2513),
    [anon_sym_with] = ACTIONS(2515),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2513),
    [anon_sym_in] = ACTIONS(2515),
  },
  [506] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2517),
    [sym__automatic_semicolon] = ACTIONS(2517),
    [sym_identifier] = ACTIONS(2519),
    [anon_sym_BQUOTE] = ACTIONS(2517),
    [anon_sym_debugger] = ACTIONS(2519),
    [anon_sym_with] = ACTIONS(2519),
    [anon_sym_symbol] = ACTIONS(2519),
    [anon_sym_AT] = ACTIONS(2517),
    [anon_sym_PIPE] = ACTIONS(2519),
    [anon_sym_COMMA] = ACTIONS(2517),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_STAR] = ACTIONS(2519),
    [anon_sym_GT_GT_GT] = ACTIONS(2517),
    [anon_sym_void] = ACTIONS(2519),
    [anon_sym_break] = ACTIONS(2519),
    [anon_sym_BANG_EQ] = ACTIONS(2519),
    [anon_sym_const] = ACTIONS(2519),
    [anon_sym_GT_EQ] = ACTIONS(2517),
    [sym_super] = ACTIONS(2519),
    [anon_sym_return] = ACTIONS(2519),
    [anon_sym_private] = ACTIONS(2519),
    [anon_sym_get] = ACTIONS(2519),
    [anon_sym_RBRACE] = ACTIONS(2517),
    [anon_sym_PERCENT] = ACTIONS(2517),
    [anon_sym_interface] = ACTIONS(2519),
    [anon_sym_default] = ACTIONS(2519),
    [anon_sym_as] = ACTIONS(2519),
    [anon_sym_delete] = ACTIONS(2519),
    [anon_sym_continue] = ACTIONS(2519),
    [anon_sym_DASH_DASH] = ACTIONS(2517),
    [anon_sym_if] = ACTIONS(2519),
    [anon_sym_instanceof] = ACTIONS(2519),
    [anon_sym_this] = ACTIONS(2519),
    [anon_sym_yield] = ACTIONS(2519),
    [sym_true] = ACTIONS(2519),
    [anon_sym_throw] = ACTIONS(2519),
    [anon_sym_enum] = ACTIONS(2519),
    [anon_sym_COLON] = ACTIONS(2517),
    [anon_sym_protected] = ACTIONS(2519),
    [anon_sym_abstract] = ACTIONS(2519),
    [anon_sym_DOT] = ACTIONS(2519),
    [anon_sym_set] = ACTIONS(2519),
    [anon_sym_type] = ACTIONS(2519),
    [anon_sym_STAR_STAR] = ACTIONS(2517),
    [anon_sym_import] = ACTIONS(2519),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2517),
    [anon_sym_namespace] = ACTIONS(2519),
    [anon_sym_PLUS_PLUS] = ACTIONS(2517),
    [anon_sym_await] = ACTIONS(2519),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [anon_sym_else] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2519),
    [anon_sym_for] = ACTIONS(2519),
    [anon_sym_LBRACK] = ACTIONS(2517),
    [sym_false] = ACTIONS(2519),
    [anon_sym_SEMI] = ACTIONS(2517),
    [anon_sym_case] = ACTIONS(2519),
    [anon_sym_module] = ACTIONS(2519),
    [anon_sym_number] = ACTIONS(2519),
    [anon_sym_class] = ACTIONS(2519),
    [anon_sym_declare] = ACTIONS(2519),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LT_LT] = ACTIONS(2517),
    [anon_sym_LBRACE] = ACTIONS(2517),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_switch] = ACTIONS(2519),
    [anon_sym_LT_EQ] = ACTIONS(2517),
    [anon_sym_LPAREN] = ACTIONS(2517),
    [sym_null] = ACTIONS(2519),
    [anon_sym_GT] = ACTIONS(2519),
    [anon_sym_any] = ACTIONS(2519),
    [anon_sym_boolean] = ACTIONS(2519),
    [anon_sym_async] = ACTIONS(2519),
    [anon_sym_public] = ACTIONS(2519),
    [anon_sym_AMP] = ACTIONS(2519),
    [anon_sym_var] = ACTIONS(2519),
    [anon_sym_QMARK] = ACTIONS(2517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2517),
    [anon_sym_while] = ACTIONS(2519),
    [anon_sym_SQUOTE] = ACTIONS(2517),
    [anon_sym_try] = ACTIONS(2519),
    [anon_sym_EQ_EQ] = ACTIONS(2519),
    [anon_sym_RPAREN] = ACTIONS(2517),
    [anon_sym_LT] = ACTIONS(2519),
    [sym_number] = ACTIONS(2517),
    [anon_sym_SLASH] = ACTIONS(2519),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(2517),
    [anon_sym_string] = ACTIONS(2519),
    [anon_sym_function] = ACTIONS(2519),
    [sym_undefined] = ACTIONS(2519),
    [anon_sym_CARET] = ACTIONS(2517),
    [anon_sym_new] = ACTIONS(2519),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_let] = ACTIONS(2519),
    [anon_sym_GT_GT] = ACTIONS(2519),
    [anon_sym_export] = ACTIONS(2519),
    [anon_sym_do] = ACTIONS(2519),
    [anon_sym_TILDE] = ACTIONS(2517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2517),
    [anon_sym_in] = ACTIONS(2519),
  },
  [507] = {
    [aux_sym_string_repeat1] = STATE(507),
    [sym_escape_sequence] = ACTIONS(2521),
    [aux_sym_string_token1] = ACTIONS(2521),
    [anon_sym_DQUOTE] = ACTIONS(2524),
    [sym_comment] = ACTIONS(246),
  },
  [508] = {
    [sym_array] = STATE(1219),
    [sym_object] = STATE(1220),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(2526),
    [anon_sym_var] = ACTIONS(2528),
    [anon_sym_const] = ACTIONS(2528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_let] = ACTIONS(2528),
  },
  [509] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(2530),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2532),
  },
  [510] = {
    [sym_variable_declarator] = STATE(97),
    [sym_array] = STATE(1224),
    [sym_object] = STATE(1225),
    [sym_identifier] = ACTIONS(2534),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [511] = {
    [sym_variable_declarator] = STATE(258),
    [sym_array] = STATE(1224),
    [sym_object] = STATE(1225),
    [sym_identifier] = ACTIONS(2534),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [512] = {
    [sym_new_expression] = STATE(59),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_yield_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_internal_module] = STATE(59),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(59),
    [sym_await_expression] = STATE(59),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1226),
    [sym_sequence_expression] = STATE(62),
    [sym_string] = STATE(59),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(1226),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(59),
    [sym_generator_function] = STATE(59),
    [sym_call_expression] = STATE(59),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(59),
    [sym_ternary_expression] = STATE(59),
    [sym_binary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(59),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [513] = {
    [sym__initializer] = STATE(321),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2538),
  },
  [514] = {
    [sym__initializer] = STATE(336),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(2540),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2542),
  },
  [515] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(917),
    [anon_sym_BANG] = ACTIONS(919),
    [anon_sym_BQUOTE] = ACTIONS(917),
    [anon_sym_else] = ACTIONS(917),
    [anon_sym_PIPE] = ACTIONS(919),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_LT_LT] = ACTIONS(917),
    [anon_sym_STAR] = ACTIONS(919),
    [anon_sym_GT_GT_GT] = ACTIONS(917),
    [anon_sym_AMP_AMP] = ACTIONS(917),
    [anon_sym_DASH] = ACTIONS(919),
    [anon_sym_LBRACE] = ACTIONS(919),
    [anon_sym_BANG_EQ] = ACTIONS(919),
    [anon_sym_LT_EQ] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RBRACK] = ACTIONS(917),
    [anon_sym_GT_EQ] = ACTIONS(917),
    [anon_sym_GT] = ACTIONS(919),
    [anon_sym_EQ] = ACTIONS(919),
    [anon_sym_AMP] = ACTIONS(919),
    [anon_sym_PERCENT] = ACTIONS(917),
    [anon_sym_QMARK] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(917),
    [anon_sym_as] = ACTIONS(917),
    [anon_sym_PIPE_PIPE] = ACTIONS(917),
    [anon_sym_while] = ACTIONS(917),
    [anon_sym_DASH_DASH] = ACTIONS(917),
    [anon_sym_EQ_EQ] = ACTIONS(919),
    [anon_sym_instanceof] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(919),
    [anon_sym_RPAREN] = ACTIONS(917),
    [anon_sym_SLASH] = ACTIONS(919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(917),
    [anon_sym_COLON] = ACTIONS(917),
    [anon_sym_DOT] = ACTIONS(917),
    [anon_sym_CARET] = ACTIONS(917),
    [anon_sym_STAR_STAR] = ACTIONS(917),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_implements] = ACTIONS(917),
    [anon_sym_GT_GT] = ACTIONS(919),
    [anon_sym_PLUS_PLUS] = ACTIONS(917),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(917),
    [anon_sym_in] = ACTIONS(919),
  },
  [516] = {
    [aux_sym_string_repeat1] = STATE(507),
    [sym_escape_sequence] = ACTIONS(921),
    [aux_sym_string_token1] = ACTIONS(921),
    [anon_sym_DQUOTE] = ACTIONS(2544),
    [sym_comment] = ACTIONS(246),
  },
  [517] = {
    [sym_new_expression] = STATE(1234),
    [sym_augmented_assignment_expression] = STATE(1234),
    [sym_unary_expression] = STATE(1234),
    [sym_update_expression] = STATE(1234),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(1234),
    [sym_regex] = STATE(1234),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1233),
    [sym__expression] = STATE(1234),
    [sym_non_null_expression] = STATE(1234),
    [sym_yield_expression] = STATE(1234),
    [sym_jsx_fragment] = STATE(1234),
    [sym_jsx_element] = STATE(1234),
    [sym_as_expression] = STATE(1234),
    [sym_internal_module] = STATE(1234),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1234),
    [sym_await_expression] = STATE(1234),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(1234),
    [sym_this] = STATE(1234),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(1234),
    [sym_generator_function] = STATE(1234),
    [sym_call_expression] = STATE(1234),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(1234),
    [sym_ternary_expression] = STATE(1234),
    [sym_binary_expression] = STATE(1234),
    [sym_template_string] = STATE(1234),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1234),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1234),
    [sym_class] = STATE(1234),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2546),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2546),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2550),
    [sym_true] = ACTIONS(2546),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2546),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [518] = {
    [sym_new_expression] = STATE(1235),
    [sym_augmented_assignment_expression] = STATE(1235),
    [sym_unary_expression] = STATE(1235),
    [sym_update_expression] = STATE(1235),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(1235),
    [sym_regex] = STATE(1235),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1235),
    [sym_non_null_expression] = STATE(1235),
    [sym_as_expression] = STATE(1235),
    [sym_jsx_fragment] = STATE(1235),
    [sym_yield_expression] = STATE(1235),
    [sym_jsx_element] = STATE(1235),
    [sym_internal_module] = STATE(1235),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1235),
    [sym_await_expression] = STATE(1235),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(1235),
    [sym_this] = STATE(1235),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(1235),
    [sym_generator_function] = STATE(1235),
    [sym_call_expression] = STATE(1235),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(1235),
    [sym_ternary_expression] = STATE(1235),
    [sym_binary_expression] = STATE(1235),
    [sym_template_string] = STATE(1235),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1235),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1235),
    [sym_class] = STATE(1235),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2552),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2552),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2554),
    [sym_true] = ACTIONS(2552),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2552),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [519] = {
    [sym_new_expression] = STATE(1236),
    [sym_augmented_assignment_expression] = STATE(1236),
    [sym_unary_expression] = STATE(1236),
    [sym_update_expression] = STATE(1236),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(1236),
    [sym_regex] = STATE(1236),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1236),
    [sym_non_null_expression] = STATE(1236),
    [sym_as_expression] = STATE(1236),
    [sym_jsx_fragment] = STATE(1236),
    [sym_yield_expression] = STATE(1236),
    [sym_jsx_element] = STATE(1236),
    [sym_internal_module] = STATE(1236),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1236),
    [sym_await_expression] = STATE(1236),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(1236),
    [sym_this] = STATE(1236),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(1236),
    [sym_generator_function] = STATE(1236),
    [sym_call_expression] = STATE(1236),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(1236),
    [sym_ternary_expression] = STATE(1236),
    [sym_binary_expression] = STATE(1236),
    [sym_template_string] = STATE(1236),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1236),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1236),
    [sym_class] = STATE(1236),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2556),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2556),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2558),
    [sym_true] = ACTIONS(2556),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2556),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [520] = {
    [sym_new_expression] = STATE(1237),
    [sym_augmented_assignment_expression] = STATE(1237),
    [sym_unary_expression] = STATE(1237),
    [sym_update_expression] = STATE(1237),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(1237),
    [sym_regex] = STATE(1237),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1237),
    [sym_non_null_expression] = STATE(1237),
    [sym_as_expression] = STATE(1237),
    [sym_jsx_fragment] = STATE(1237),
    [sym_yield_expression] = STATE(1237),
    [sym_jsx_element] = STATE(1237),
    [sym_internal_module] = STATE(1237),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1237),
    [sym_await_expression] = STATE(1237),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(1237),
    [sym_this] = STATE(1237),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(1237),
    [sym_generator_function] = STATE(1237),
    [sym_call_expression] = STATE(1237),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(1237),
    [sym_ternary_expression] = STATE(1237),
    [sym_binary_expression] = STATE(1237),
    [sym_template_string] = STATE(1237),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1237),
    [sym_class] = STATE(1237),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2560),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2560),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2562),
    [sym_true] = ACTIONS(2560),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2560),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [521] = {
    [sym_identifier] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
  },
  [522] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_BANG] = ACTIONS(614),
    [anon_sym_BQUOTE] = ACTIONS(612),
    [anon_sym_PIPE] = ACTIONS(614),
    [anon_sym_COMMA] = ACTIONS(612),
    [anon_sym_LT_LT] = ACTIONS(612),
    [anon_sym_STAR] = ACTIONS(614),
    [anon_sym_GT_GT_GT] = ACTIONS(612),
    [anon_sym_AMP_AMP] = ACTIONS(612),
    [anon_sym_DASH] = ACTIONS(614),
    [anon_sym_LBRACE] = ACTIONS(614),
    [anon_sym_BANG_EQ] = ACTIONS(614),
    [anon_sym_LT_EQ] = ACTIONS(612),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_RBRACK] = ACTIONS(612),
    [anon_sym_GT_EQ] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(614),
    [anon_sym_AMP] = ACTIONS(614),
    [anon_sym_PERCENT] = ACTIONS(612),
    [anon_sym_QMARK] = ACTIONS(612),
    [anon_sym_RBRACE] = ACTIONS(612),
    [anon_sym_as] = ACTIONS(612),
    [anon_sym_PIPE_PIPE] = ACTIONS(612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(612),
    [anon_sym_DASH_DASH] = ACTIONS(612),
    [anon_sym_EQ_EQ] = ACTIONS(614),
    [anon_sym_instanceof] = ACTIONS(612),
    [anon_sym_LT] = ACTIONS(614),
    [anon_sym_RPAREN] = ACTIONS(612),
    [anon_sym_SLASH] = ACTIONS(614),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(612),
    [anon_sym_DOT] = ACTIONS(612),
    [anon_sym_CARET] = ACTIONS(612),
    [anon_sym_STAR_STAR] = ACTIONS(612),
    [anon_sym_PLUS] = ACTIONS(614),
    [anon_sym_implements] = ACTIONS(612),
    [anon_sym_GT_GT] = ACTIONS(614),
    [anon_sym_PLUS_PLUS] = ACTIONS(612),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(612),
    [anon_sym_in] = ACTIONS(614),
  },
  [523] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(646),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [anon_sym_PIPE] = ACTIONS(646),
    [anon_sym_COMMA] = ACTIONS(644),
    [anon_sym_LT_LT] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_GT_GT_GT] = ACTIONS(644),
    [anon_sym_AMP_AMP] = ACTIONS(644),
    [anon_sym_DASH] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(646),
    [anon_sym_BANG_EQ] = ACTIONS(646),
    [anon_sym_LT_EQ] = ACTIONS(644),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_RBRACK] = ACTIONS(644),
    [anon_sym_GT_EQ] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(646),
    [anon_sym_AMP] = ACTIONS(646),
    [anon_sym_PERCENT] = ACTIONS(644),
    [anon_sym_QMARK] = ACTIONS(644),
    [anon_sym_RBRACE] = ACTIONS(644),
    [anon_sym_as] = ACTIONS(644),
    [anon_sym_PIPE_PIPE] = ACTIONS(644),
    [anon_sym_LBRACE_PIPE] = ACTIONS(644),
    [anon_sym_DASH_DASH] = ACTIONS(644),
    [anon_sym_EQ_EQ] = ACTIONS(646),
    [anon_sym_instanceof] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(646),
    [anon_sym_RPAREN] = ACTIONS(644),
    [anon_sym_SLASH] = ACTIONS(646),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(644),
    [anon_sym_DOT] = ACTIONS(644),
    [anon_sym_CARET] = ACTIONS(644),
    [anon_sym_STAR_STAR] = ACTIONS(644),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_implements] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(646),
    [anon_sym_PLUS_PLUS] = ACTIONS(644),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(644),
    [anon_sym_in] = ACTIONS(646),
  },
  [524] = {
    [aux_sym_template_string_repeat1] = STATE(368),
    [sym_template_substitution] = STATE(368),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(127),
    [sym_escape_sequence] = ACTIONS(648),
    [anon_sym_BQUOTE] = ACTIONS(2566),
    [sym__template_chars] = ACTIONS(648),
    [sym_comment] = ACTIONS(3),
  },
  [525] = {
    [sym_new_expression] = STATE(1241),
    [sym_augmented_assignment_expression] = STATE(1241),
    [sym_unary_expression] = STATE(1241),
    [sym_update_expression] = STATE(1241),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(1241),
    [sym_regex] = STATE(1241),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1240),
    [sym__expression] = STATE(1241),
    [sym_non_null_expression] = STATE(1241),
    [sym_yield_expression] = STATE(1241),
    [sym_jsx_fragment] = STATE(1241),
    [sym_jsx_element] = STATE(1241),
    [sym_as_expression] = STATE(1241),
    [sym_internal_module] = STATE(1241),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1241),
    [sym_await_expression] = STATE(1241),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(1241),
    [sym_this] = STATE(1241),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(1241),
    [sym_generator_function] = STATE(1241),
    [sym_call_expression] = STATE(1241),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(1241),
    [sym_ternary_expression] = STATE(1241),
    [sym_binary_expression] = STATE(1241),
    [sym_template_string] = STATE(1241),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1241),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1241),
    [sym_class] = STATE(1241),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2568),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2568),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2570),
    [sym_true] = ACTIONS(2568),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2568),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [526] = {
    [sym_new_expression] = STATE(1242),
    [sym_augmented_assignment_expression] = STATE(1242),
    [sym_unary_expression] = STATE(1242),
    [sym_update_expression] = STATE(1242),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(1242),
    [sym_regex] = STATE(1242),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1242),
    [sym_non_null_expression] = STATE(1242),
    [sym_as_expression] = STATE(1242),
    [sym_jsx_fragment] = STATE(1242),
    [sym_yield_expression] = STATE(1242),
    [sym_jsx_element] = STATE(1242),
    [sym_internal_module] = STATE(1242),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1242),
    [sym_await_expression] = STATE(1242),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(1242),
    [sym_this] = STATE(1242),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(1242),
    [sym_generator_function] = STATE(1242),
    [sym_call_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(1242),
    [sym_ternary_expression] = STATE(1242),
    [sym_binary_expression] = STATE(1242),
    [sym_template_string] = STATE(1242),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1242),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1242),
    [sym_class] = STATE(1242),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2572),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2572),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2574),
    [sym_true] = ACTIONS(2572),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2572),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [527] = {
    [sym_identifier] = ACTIONS(2576),
    [sym_comment] = ACTIONS(3),
  },
  [528] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_BQUOTE] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(668),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_LT_LT] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_GT_GT_GT] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(668),
    [anon_sym_BANG_EQ] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_RBRACK] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_LBRACE_PIPE] = ACTIONS(666),
    [anon_sym_DASH_DASH] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(668),
    [anon_sym_instanceof] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_RPAREN] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(668),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_DOT] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_implements] = ACTIONS(666),
    [anon_sym_GT_GT] = ACTIONS(668),
    [anon_sym_PLUS_PLUS] = ACTIONS(666),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(666),
    [anon_sym_in] = ACTIONS(668),
  },
  [529] = {
    [sym_class_heritage] = STATE(1244),
    [sym_type_parameters] = STATE(1245),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(1246),
    [anon_sym_extends] = ACTIONS(1131),
    [anon_sym_implements] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(959),
  },
  [530] = {
    [sym_public_field_definition] = STATE(640),
    [sym__property_name] = STATE(641),
    [sym_decorator] = STATE(1248),
    [sym_method_signature] = STATE(640),
    [sym_accessibility_modifier] = STATE(642),
    [sym_abstract_method_signature] = STATE(640),
    [sym_computed_property_name] = STATE(641),
    [aux_sym_class_body_repeat1] = STATE(1248),
    [sym_index_signature] = STATE(640),
    [sym_string] = STATE(641),
    [sym_method_definition] = STATE(644),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1145),
    [anon_sym_get] = ACTIONS(1147),
    [anon_sym_RBRACE] = ACTIONS(2578),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [sym_number] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [531] = {
    [sym_class_body] = STATE(1249),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(959),
  },
  [532] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_BQUOTE] = ACTIONS(1163),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_COMMA] = ACTIONS(1163),
    [anon_sym_LT_LT] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_GT_GT_GT] = ACTIONS(1163),
    [anon_sym_AMP_AMP] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1165),
    [anon_sym_BANG_EQ] = ACTIONS(1165),
    [anon_sym_LT_EQ] = ACTIONS(1163),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_RBRACK] = ACTIONS(1163),
    [anon_sym_GT_EQ] = ACTIONS(1163),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_QMARK] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_as] = ACTIONS(1163),
    [anon_sym_PIPE_PIPE] = ACTIONS(1163),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1163),
    [anon_sym_EQ_EQ] = ACTIONS(1165),
    [anon_sym_instanceof] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_RPAREN] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1163),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_CARET] = ACTIONS(1163),
    [anon_sym_STAR_STAR] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_implements] = ACTIONS(1163),
    [anon_sym_GT_GT] = ACTIONS(1165),
    [anon_sym_PLUS_PLUS] = ACTIONS(1163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1163),
    [anon_sym_in] = ACTIONS(1165),
  },
  [533] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [534] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [535] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(945),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(2583),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(2583),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [536] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(945),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(2585),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(2585),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [537] = {
    [anon_sym_RPAREN] = ACTIONS(2585),
    [anon_sym_COMMA] = ACTIONS(2585),
    [anon_sym_RBRACK] = ACTIONS(2585),
    [sym_comment] = ACTIONS(3),
  },
  [538] = {
    [sym_template_string] = STATE(542),
    [sym_type_arguments] = STATE(541),
    [sym_type_annotation] = STATE(1251),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(1347),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1410),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_PIPE_PIPE] = ACTIONS(1426),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1347),
    [anon_sym_instanceof] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_RPAREN] = ACTIONS(2587),
    [anon_sym_SLASH] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1434),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1426),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [539] = {
    [anon_sym_RPAREN] = ACTIONS(2587),
    [sym_comment] = ACTIONS(3),
  },
  [540] = {
    [sym_new_expression] = STATE(1252),
    [sym_augmented_assignment_expression] = STATE(1252),
    [sym_unary_expression] = STATE(1252),
    [sym_update_expression] = STATE(1252),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(1252),
    [sym_regex] = STATE(1252),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1252),
    [sym_non_null_expression] = STATE(1252),
    [sym_as_expression] = STATE(1252),
    [sym_jsx_fragment] = STATE(1252),
    [sym_yield_expression] = STATE(1252),
    [sym_jsx_element] = STATE(1252),
    [sym_internal_module] = STATE(1252),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1252),
    [sym_await_expression] = STATE(1252),
    [sym_member_expression] = STATE(162),
    [sym_sequence_expression] = STATE(1253),
    [sym_string] = STATE(1252),
    [sym_this] = STATE(1252),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(1252),
    [sym_generator_function] = STATE(1252),
    [sym_call_expression] = STATE(1252),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(1252),
    [sym_ternary_expression] = STATE(1252),
    [sym_binary_expression] = STATE(1252),
    [sym_template_string] = STATE(1252),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1252),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1252),
    [sym_class] = STATE(1252),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2589),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2591),
    [sym_true] = ACTIONS(2589),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2589),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [541] = {
    [sym_template_string] = STATE(1254),
    [sym_arguments] = STATE(1254),
    [anon_sym_LPAREN] = ACTIONS(678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(258),
  },
  [542] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(819),
    [anon_sym_LBRACK] = ACTIONS(819),
    [anon_sym_BANG] = ACTIONS(821),
    [anon_sym_BQUOTE] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(821),
    [anon_sym_COMMA] = ACTIONS(819),
    [anon_sym_LT_LT] = ACTIONS(819),
    [anon_sym_STAR] = ACTIONS(821),
    [anon_sym_GT_GT_GT] = ACTIONS(819),
    [anon_sym_AMP_AMP] = ACTIONS(819),
    [anon_sym_DASH] = ACTIONS(821),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_BANG_EQ] = ACTIONS(821),
    [anon_sym_LT_EQ] = ACTIONS(819),
    [anon_sym_LPAREN] = ACTIONS(819),
    [anon_sym_RBRACK] = ACTIONS(819),
    [anon_sym_GT_EQ] = ACTIONS(819),
    [anon_sym_GT] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(821),
    [anon_sym_PERCENT] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(819),
    [anon_sym_as] = ACTIONS(819),
    [anon_sym_PIPE_PIPE] = ACTIONS(819),
    [anon_sym_LBRACE_PIPE] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [anon_sym_EQ_EQ] = ACTIONS(821),
    [anon_sym_instanceof] = ACTIONS(819),
    [anon_sym_LT] = ACTIONS(821),
    [anon_sym_RPAREN] = ACTIONS(819),
    [anon_sym_SLASH] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(819),
    [anon_sym_DOT] = ACTIONS(819),
    [anon_sym_CARET] = ACTIONS(819),
    [anon_sym_STAR_STAR] = ACTIONS(819),
    [anon_sym_PLUS] = ACTIONS(821),
    [anon_sym_implements] = ACTIONS(819),
    [anon_sym_GT_GT] = ACTIONS(821),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(819),
    [anon_sym_in] = ACTIONS(821),
  },
  [543] = {
    [anon_sym_EQ_GT] = ACTIONS(2593),
    [sym_comment] = ACTIONS(3),
  },
  [544] = {
    [anon_sym_EQ_GT] = ACTIONS(2595),
    [sym_comment] = ACTIONS(3),
  },
  [545] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(1258),
    [sym_identifier] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [546] = {
    [aux_sym_string_repeat2] = STATE(788),
    [sym_escape_sequence] = ACTIONS(1474),
    [aux_sym_string_token2] = ACTIONS(1474),
    [sym_comment] = ACTIONS(246),
    [anon_sym_SQUOTE] = ACTIONS(2544),
  },
  [547] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_BQUOTE] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_RBRACK] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_instanceof] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_in] = ACTIONS(841),
  },
  [548] = {
    [sym_jsx_opening_element] = STATE(340),
    [aux_sym_jsx_element_repeat1] = STATE(1260),
    [sym_jsx_expression] = STATE(1260),
    [sym_jsx_self_closing_element] = STATE(1260),
    [sym_jsx_element] = STATE(1260),
    [sym_jsx_text] = ACTIONS(2599),
    [anon_sym_LT] = ACTIONS(2601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(590),
  },
  [549] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(1262),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_constraint] = STATE(806),
    [sym_jsx_attribute] = STATE(1262),
    [sym_jsx_expression] = STATE(1262),
    [sym_default_type] = STATE(807),
    [sym_type_arguments] = STATE(808),
    [anon_sym_EQ] = ACTIONS(1490),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_COLON] = ACTIONS(1494),
    [anon_sym_extends] = ACTIONS(1496),
    [anon_sym_DOT] = ACTIONS(1498),
    [sym_jsx_identifier] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1502),
    [anon_sym_LT] = ACTIONS(1505),
    [anon_sym_COMMA] = ACTIONS(1507),
    [anon_sym_SLASH] = ACTIONS(2603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [550] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(1262),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(1262),
    [sym_jsx_expression] = STATE(1262),
    [anon_sym_COLON] = ACTIONS(1513),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_GT] = ACTIONS(1515),
    [sym_jsx_identifier] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(2603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [551] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(1262),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(1262),
    [sym_jsx_expression] = STATE(1262),
    [sym_type_arguments] = STATE(808),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_DOT] = ACTIONS(1498),
    [sym_jsx_identifier] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1515),
    [anon_sym_LT] = ACTIONS(1505),
    [anon_sym_SLASH] = ACTIONS(2603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [552] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(1262),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(1262),
    [sym_jsx_expression] = STATE(1262),
    [anon_sym_GT] = ACTIONS(1515),
    [sym_identifier] = ACTIONS(1492),
    [sym_jsx_identifier] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(2603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [553] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(871),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(871),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_in] = ACTIONS(945),
  },
  [554] = {
    [anon_sym_SLASH2] = ACTIONS(2605),
    [sym_comment] = ACTIONS(3),
  },
  [555] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(1258),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [556] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(1265),
    [sym_identifier] = ACTIONS(2607),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [557] = {
    [sym_statement_block] = STATE(1267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2609),
  },
  [558] = {
    [sym__initializer] = STATE(522),
    [sym_arguments] = STATE(1268),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_RBRACK] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1531),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [559] = {
    [sym_arguments] = STATE(1268),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_RBRACK] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1529),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_RBRACE] = ACTIONS(1529),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1529),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1529),
    [anon_sym_DOT] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1529),
    [anon_sym_STAR_STAR] = ACTIONS(1529),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_implements] = ACTIONS(1529),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [560] = {
    [anon_sym_target] = ACTIONS(2611),
    [sym_comment] = ACTIONS(3),
  },
  [561] = {
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_RBRACK] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [562] = {
    [sym_new_expression] = STATE(836),
    [sym_augmented_assignment_expression] = STATE(836),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(836),
    [sym_update_expression] = STATE(836),
    [sym_regex] = STATE(836),
    [sym_meta_property] = STATE(836),
    [sym_call_signature] = STATE(835),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(836),
    [sym_non_null_expression] = STATE(836),
    [sym_yield_expression] = STATE(836),
    [sym_jsx_fragment] = STATE(836),
    [sym_jsx_element] = STATE(836),
    [sym_as_expression] = STATE(836),
    [sym_internal_module] = STATE(836),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(836),
    [sym_await_expression] = STATE(836),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(836),
    [sym_this] = STATE(836),
    [sym_arguments] = STATE(1270),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(836),
    [sym_generator_function] = STATE(836),
    [sym_call_expression] = STATE(836),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(836),
    [sym_ternary_expression] = STATE(836),
    [sym_binary_expression] = STATE(836),
    [sym_template_string] = STATE(836),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(836),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(836),
    [sym_class] = STATE(836),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(500),
    [sym_true] = ACTIONS(1545),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [sym_false] = ACTIONS(1545),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [anon_sym_RBRACK] = ACTIONS(1539),
    [sym_null] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [sym_number] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [563] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_arguments] = STATE(1270),
    [sym_call_signature] = STATE(543),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(995),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(995),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_protected] = ACTIONS(995),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(995),
    [anon_sym_type] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(995),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(995),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(995),
    [anon_sym_declare] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [anon_sym_RBRACK] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(995),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(995),
    [anon_sym_async] = ACTIONS(995),
    [anon_sym_public] = ACTIONS(995),
    [anon_sym_EQ_GT] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(995),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [564] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_RBRACK] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [565] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1571),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(1573),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1575),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1579),
    [anon_sym_STAR] = ACTIONS(1581),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1583),
    [anon_sym_BANG_EQ] = ACTIONS(1573),
    [anon_sym_LT_EQ] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1571),
    [anon_sym_GT] = ACTIONS(1573),
    [anon_sym_AMP] = ACTIONS(1585),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [anon_sym_as] = ACTIONS(1591),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1573),
    [anon_sym_instanceof] = ACTIONS(1571),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_SLASH] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_STAR_STAR] = ACTIONS(1595),
    [anon_sym_PLUS] = ACTIONS(1579),
    [anon_sym_GT_GT] = ACTIONS(1581),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [566] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(1268),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_RBRACK] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1529),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_RBRACE] = ACTIONS(1529),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1529),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1529),
    [anon_sym_DOT] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1529),
    [anon_sym_STAR_STAR] = ACTIONS(1529),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_implements] = ACTIONS(1529),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [567] = {
    [sym__initializer] = STATE(522),
    [sym_arguments] = STATE(1268),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_RBRACK] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1531),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_RBRACE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1529),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1529),
    [anon_sym_COLON] = ACTIONS(1529),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_implements] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [568] = {
    [sym__initializer] = STATE(587),
    [sym_arguments] = STATE(1268),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_RBRACK] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1529),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_RBRACE] = ACTIONS(1529),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1529),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1529),
    [anon_sym_DOT] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1529),
    [anon_sym_STAR_STAR] = ACTIONS(1529),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_implements] = ACTIONS(1529),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [569] = {
    [sym__initializer] = STATE(589),
    [sym_arguments] = STATE(1268),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_RBRACK] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1529),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_RBRACE] = ACTIONS(1529),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1529),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1529),
    [anon_sym_DOT] = ACTIONS(1529),
    [anon_sym_CARET] = ACTIONS(1529),
    [anon_sym_STAR_STAR] = ACTIONS(1529),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_implements] = ACTIONS(1529),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [570] = {
    [sym_statement_block] = STATE(1272),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(903),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_BQUOTE] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(905),
    [anon_sym_COMMA] = ACTIONS(903),
    [anon_sym_LT_LT] = ACTIONS(903),
    [anon_sym_STAR] = ACTIONS(905),
    [anon_sym_GT_GT_GT] = ACTIONS(903),
    [anon_sym_AMP_AMP] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(2613),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(903),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RBRACK] = ACTIONS(903),
    [anon_sym_GT_EQ] = ACTIONS(903),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(903),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_RBRACE] = ACTIONS(903),
    [anon_sym_as] = ACTIONS(903),
    [anon_sym_PIPE_PIPE] = ACTIONS(903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_instanceof] = ACTIONS(903),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(903),
    [anon_sym_DOT] = ACTIONS(2615),
    [anon_sym_CARET] = ACTIONS(903),
    [anon_sym_STAR_STAR] = ACTIONS(903),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_implements] = ACTIONS(903),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(903),
    [anon_sym_in] = ACTIONS(905),
  },
  [571] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(911),
    [anon_sym_BANG] = ACTIONS(913),
    [anon_sym_BQUOTE] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(911),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_GT_GT_GT] = ACTIONS(911),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_LPAREN] = ACTIONS(911),
    [anon_sym_RBRACK] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(913),
    [anon_sym_AMP] = ACTIONS(913),
    [anon_sym_PERCENT] = ACTIONS(911),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_RBRACE] = ACTIONS(911),
    [anon_sym_as] = ACTIONS(911),
    [anon_sym_PIPE_PIPE] = ACTIONS(911),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_DASH_DASH] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_instanceof] = ACTIONS(911),
    [anon_sym_LT] = ACTIONS(913),
    [anon_sym_RPAREN] = ACTIONS(911),
    [anon_sym_SLASH] = ACTIONS(913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(911),
    [anon_sym_COLON] = ACTIONS(911),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_CARET] = ACTIONS(911),
    [anon_sym_STAR_STAR] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(911),
    [anon_sym_GT_GT] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(911),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(911),
    [anon_sym_in] = ACTIONS(913),
  },
  [572] = {
    [sym_statement_block] = STATE(1272),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(903),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_BQUOTE] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(905),
    [anon_sym_COMMA] = ACTIONS(903),
    [anon_sym_LT_LT] = ACTIONS(903),
    [anon_sym_STAR] = ACTIONS(905),
    [anon_sym_GT_GT_GT] = ACTIONS(903),
    [anon_sym_AMP_AMP] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(2613),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(903),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RBRACK] = ACTIONS(903),
    [anon_sym_GT_EQ] = ACTIONS(903),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(903),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_RBRACE] = ACTIONS(903),
    [anon_sym_as] = ACTIONS(903),
    [anon_sym_PIPE_PIPE] = ACTIONS(903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_instanceof] = ACTIONS(903),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(903),
    [anon_sym_DOT] = ACTIONS(903),
    [anon_sym_CARET] = ACTIONS(903),
    [anon_sym_STAR_STAR] = ACTIONS(903),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_implements] = ACTIONS(903),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(903),
    [anon_sym_in] = ACTIONS(905),
  },
  [573] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_in] = ACTIONS(945),
  },
  [574] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [anon_sym_BANG] = ACTIONS(1855),
    [anon_sym_BQUOTE] = ACTIONS(1853),
    [anon_sym_PIPE] = ACTIONS(1855),
    [anon_sym_COMMA] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(1853),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_GT_GT_GT] = ACTIONS(1853),
    [anon_sym_AMP_AMP] = ACTIONS(1853),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1855),
    [anon_sym_BANG_EQ] = ACTIONS(1855),
    [anon_sym_LT_EQ] = ACTIONS(1853),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_RBRACK] = ACTIONS(1853),
    [anon_sym_GT_EQ] = ACTIONS(1853),
    [anon_sym_GT] = ACTIONS(1855),
    [anon_sym_AMP] = ACTIONS(1855),
    [anon_sym_PERCENT] = ACTIONS(1853),
    [anon_sym_QMARK] = ACTIONS(1853),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_as] = ACTIONS(1853),
    [anon_sym_PIPE_PIPE] = ACTIONS(1853),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1853),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_EQ_EQ] = ACTIONS(1855),
    [anon_sym_instanceof] = ACTIONS(1853),
    [anon_sym_LT] = ACTIONS(1855),
    [anon_sym_RPAREN] = ACTIONS(1853),
    [anon_sym_SLASH] = ACTIONS(1855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1853),
    [anon_sym_DOT] = ACTIONS(1853),
    [anon_sym_CARET] = ACTIONS(1853),
    [anon_sym_STAR_STAR] = ACTIONS(1853),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_implements] = ACTIONS(1853),
    [anon_sym_GT_GT] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1853),
    [anon_sym_in] = ACTIONS(1855),
  },
  [575] = {
    [sym_new_expression] = STATE(1273),
    [sym_augmented_assignment_expression] = STATE(1273),
    [sym_unary_expression] = STATE(1273),
    [sym_update_expression] = STATE(1273),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(1273),
    [sym_regex] = STATE(1273),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1273),
    [sym_non_null_expression] = STATE(1273),
    [sym_as_expression] = STATE(1273),
    [sym_jsx_fragment] = STATE(1273),
    [sym_yield_expression] = STATE(1273),
    [sym_jsx_element] = STATE(1273),
    [sym_internal_module] = STATE(1273),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1273),
    [sym_await_expression] = STATE(1273),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(1273),
    [sym_this] = STATE(1273),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(1273),
    [sym_generator_function] = STATE(1273),
    [sym_call_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(1273),
    [sym_ternary_expression] = STATE(1273),
    [sym_binary_expression] = STATE(1273),
    [sym_template_string] = STATE(1273),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1273),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1273),
    [sym_class] = STATE(1273),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2617),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2617),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2619),
    [sym_true] = ACTIONS(2617),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2617),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [576] = {
    [sym_new_expression] = STATE(1274),
    [sym_augmented_assignment_expression] = STATE(1274),
    [sym_unary_expression] = STATE(1274),
    [sym_update_expression] = STATE(1274),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(1274),
    [sym_regex] = STATE(1274),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1274),
    [sym_non_null_expression] = STATE(1274),
    [sym_as_expression] = STATE(1274),
    [sym_jsx_fragment] = STATE(1274),
    [sym_yield_expression] = STATE(1274),
    [sym_jsx_element] = STATE(1274),
    [sym_internal_module] = STATE(1274),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1274),
    [sym_await_expression] = STATE(1274),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(1274),
    [sym_this] = STATE(1274),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(1274),
    [sym_generator_function] = STATE(1274),
    [sym_call_expression] = STATE(1274),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(1274),
    [sym_ternary_expression] = STATE(1274),
    [sym_binary_expression] = STATE(1274),
    [sym_template_string] = STATE(1274),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1274),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1274),
    [sym_class] = STATE(1274),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2621),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2621),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2623),
    [sym_true] = ACTIONS(2621),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2621),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [577] = {
    [sym_new_expression] = STATE(1275),
    [sym_augmented_assignment_expression] = STATE(1275),
    [sym_unary_expression] = STATE(1275),
    [sym_update_expression] = STATE(1275),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(1275),
    [sym_regex] = STATE(1275),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1275),
    [sym_non_null_expression] = STATE(1275),
    [sym_as_expression] = STATE(1275),
    [sym_jsx_fragment] = STATE(1275),
    [sym_yield_expression] = STATE(1275),
    [sym_jsx_element] = STATE(1275),
    [sym_internal_module] = STATE(1275),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1275),
    [sym_await_expression] = STATE(1275),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(1275),
    [sym_this] = STATE(1275),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(1275),
    [sym_generator_function] = STATE(1275),
    [sym_call_expression] = STATE(1275),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(1275),
    [sym_ternary_expression] = STATE(1275),
    [sym_binary_expression] = STATE(1275),
    [sym_template_string] = STATE(1275),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1275),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1275),
    [sym_class] = STATE(1275),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2625),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2627),
    [sym_true] = ACTIONS(2625),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2625),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [578] = {
    [sym_new_expression] = STATE(1276),
    [sym_augmented_assignment_expression] = STATE(1276),
    [sym_unary_expression] = STATE(1276),
    [sym_update_expression] = STATE(1276),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(1276),
    [sym_regex] = STATE(1276),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1276),
    [sym_non_null_expression] = STATE(1276),
    [sym_as_expression] = STATE(1276),
    [sym_jsx_fragment] = STATE(1276),
    [sym_yield_expression] = STATE(1276),
    [sym_jsx_element] = STATE(1276),
    [sym_internal_module] = STATE(1276),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1276),
    [sym_await_expression] = STATE(1276),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(1276),
    [sym_this] = STATE(1276),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(1276),
    [sym_generator_function] = STATE(1276),
    [sym_call_expression] = STATE(1276),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(1276),
    [sym_ternary_expression] = STATE(1276),
    [sym_binary_expression] = STATE(1276),
    [sym_template_string] = STATE(1276),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1276),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1276),
    [sym_class] = STATE(1276),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2629),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2629),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2631),
    [sym_true] = ACTIONS(2629),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2629),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [579] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2633),
    [anon_sym_LBRACK] = ACTIONS(2633),
    [anon_sym_BANG] = ACTIONS(2635),
    [anon_sym_SEMI] = ACTIONS(2633),
    [anon_sym_BQUOTE] = ACTIONS(2633),
    [sym__automatic_semicolon] = ACTIONS(2633),
    [anon_sym_PIPE] = ACTIONS(2635),
    [anon_sym_COMMA] = ACTIONS(2633),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_GT_GT_GT] = ACTIONS(2633),
    [anon_sym_EQ] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_BANG_EQ] = ACTIONS(2635),
    [anon_sym_LT_EQ] = ACTIONS(2633),
    [anon_sym_LPAREN] = ACTIONS(2633),
    [anon_sym_GT_EQ] = ACTIONS(2633),
    [anon_sym_of] = ACTIONS(2633),
    [anon_sym_GT] = ACTIONS(2635),
    [anon_sym_AMP] = ACTIONS(2635),
    [anon_sym_PERCENT] = ACTIONS(2633),
    [anon_sym_QMARK] = ACTIONS(2633),
    [anon_sym_RBRACE] = ACTIONS(2633),
    [anon_sym_as] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2633),
    [anon_sym_DASH_DASH] = ACTIONS(2633),
    [anon_sym_EQ_EQ] = ACTIONS(2635),
    [anon_sym_instanceof] = ACTIONS(2633),
    [anon_sym_LT] = ACTIONS(2635),
    [anon_sym_RPAREN] = ACTIONS(2633),
    [anon_sym_SLASH] = ACTIONS(2635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2633),
    [anon_sym_CARET] = ACTIONS(2633),
    [anon_sym_STAR_STAR] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_GT_GT] = ACTIONS(2635),
    [anon_sym_PLUS_PLUS] = ACTIONS(2633),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2633),
    [anon_sym_in] = ACTIONS(2635),
  },
  [580] = {
    [sym_new_expression] = STATE(1277),
    [sym_augmented_assignment_expression] = STATE(1277),
    [sym_unary_expression] = STATE(1277),
    [sym_update_expression] = STATE(1277),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(1277),
    [sym_regex] = STATE(1277),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1277),
    [sym_non_null_expression] = STATE(1277),
    [sym_as_expression] = STATE(1277),
    [sym_jsx_fragment] = STATE(1277),
    [sym_yield_expression] = STATE(1277),
    [sym_jsx_element] = STATE(1277),
    [sym_internal_module] = STATE(1277),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1277),
    [sym_await_expression] = STATE(1277),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(1277),
    [sym_this] = STATE(1277),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(1277),
    [sym_generator_function] = STATE(1277),
    [sym_call_expression] = STATE(1277),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1277),
    [sym_ternary_expression] = STATE(1277),
    [sym_binary_expression] = STATE(1277),
    [sym_template_string] = STATE(1277),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1277),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1277),
    [sym_class] = STATE(1277),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2637),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2639),
    [sym_true] = ACTIONS(2637),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2637),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [581] = {
    [sym_union_type] = STATE(1293),
    [sym__type] = STATE(1293),
    [sym_constructor_type] = STATE(1293),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1295),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_template_string] = STATE(1297),
    [sym_intersection_type] = STATE(1293),
    [sym_function_type] = STATE(1293),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1299),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(2641),
    [sym_false] = ACTIONS(2643),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_PIPE] = ACTIONS(2659),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_boolean] = ACTIONS(2647),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_QMARK] = ACTIONS(2667),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2669),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_DQUOTE] = ACTIONS(304),
  },
  [582] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(839),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_BQUOTE] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_RBRACK] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_RBRACE] = ACTIONS(839),
    [anon_sym_as] = ACTIONS(839),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_LBRACE_PIPE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_instanceof] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_RPAREN] = ACTIONS(839),
    [anon_sym_SLASH] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(839),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_implements] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_in] = ACTIONS(841),
  },
  [583] = {
    [sym_new_expression] = STATE(1235),
    [sym_constructor_type] = STATE(432),
    [sym_augmented_assignment_expression] = STATE(1235),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(1235),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(1235),
    [sym_type_parameters] = STATE(959),
    [sym_array_type] = STATE(436),
    [sym_yield_expression] = STATE(1235),
    [sym_as_expression] = STATE(1235),
    [sym_jsx_fragment] = STATE(1235),
    [sym_internal_module] = STATE(1235),
    [sym_arrow_function] = STATE(1235),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(162),
    [sym_literal_type] = STATE(436),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(1301),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(1235),
    [sym_subscript_expression] = STATE(162),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(1235),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(1235),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(960),
    [sym_function_type] = STATE(432),
    [sym__type] = STATE(432),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(1235),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(1235),
    [sym__expression] = STATE(1235),
    [sym_non_null_expression] = STATE(1235),
    [sym_jsx_element] = STATE(1235),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_await_expression] = STATE(1235),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_this] = STATE(1235),
    [sym_union_type] = STATE(432),
    [sym_anonymous_class] = STATE(1235),
    [sym_call_expression] = STATE(1235),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(1235),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(1235),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(432),
    [sym_parenthesized_expression] = STATE(1235),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1235),
    [sym_class] = STATE(1235),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(2675),
    [sym_false] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(2679),
    [anon_sym_number] = ACTIONS(2679),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(2681),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2683),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_void] = ACTIONS(2687),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [sym_null] = ACTIONS(2552),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2679),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(2679),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2691),
    [sym_true] = ACTIONS(2677),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(2693),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(2679),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2552),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(2695),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(2683),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [584] = {
    [sym_new_expression] = STATE(1310),
    [sym_augmented_assignment_expression] = STATE(1310),
    [sym_unary_expression] = STATE(1310),
    [sym_update_expression] = STATE(1310),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(1310),
    [sym_regex] = STATE(1310),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1310),
    [sym_non_null_expression] = STATE(1310),
    [sym_as_expression] = STATE(1310),
    [sym_jsx_fragment] = STATE(1310),
    [sym_yield_expression] = STATE(1310),
    [sym_jsx_element] = STATE(1310),
    [sym_internal_module] = STATE(1310),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1310),
    [sym_await_expression] = STATE(1310),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(1310),
    [sym_this] = STATE(1310),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(1310),
    [sym_generator_function] = STATE(1310),
    [sym_call_expression] = STATE(1310),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(1310),
    [sym_ternary_expression] = STATE(1310),
    [sym_binary_expression] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1310),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1310),
    [sym_class] = STATE(1310),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(2697),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2697),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2699),
    [sym_true] = ACTIONS(2697),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2697),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [585] = {
    [aux_sym_array_repeat1] = STATE(588),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_RBRACK] = ACTIONS(2701),
    [sym_comment] = ACTIONS(3),
  },
  [586] = {
    [sym_class_heritage] = STATE(1313),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(1249),
    [anon_sym_extends] = ACTIONS(316),
    [anon_sym_implements] = ACTIONS(318),
    [sym_identifier] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(959),
  },
  [587] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1835),
    [anon_sym_LBRACK] = ACTIONS(1835),
    [anon_sym_BANG] = ACTIONS(1837),
    [anon_sym_BQUOTE] = ACTIONS(1835),
    [anon_sym_PIPE] = ACTIONS(1837),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_LT_LT] = ACTIONS(1835),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_GT_GT_GT] = ACTIONS(1835),
    [anon_sym_AMP_AMP] = ACTIONS(1835),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1837),
    [anon_sym_BANG_EQ] = ACTIONS(1837),
    [anon_sym_LT_EQ] = ACTIONS(1835),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_RBRACK] = ACTIONS(1835),
    [anon_sym_GT_EQ] = ACTIONS(1835),
    [anon_sym_GT] = ACTIONS(1837),
    [anon_sym_AMP] = ACTIONS(1837),
    [anon_sym_PERCENT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_RBRACE] = ACTIONS(1835),
    [anon_sym_as] = ACTIONS(1835),
    [anon_sym_PIPE_PIPE] = ACTIONS(1835),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_EQ_EQ] = ACTIONS(1837),
    [anon_sym_instanceof] = ACTIONS(1835),
    [anon_sym_LT] = ACTIONS(1837),
    [anon_sym_RPAREN] = ACTIONS(1835),
    [anon_sym_SLASH] = ACTIONS(1837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_DOT] = ACTIONS(1835),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_STAR_STAR] = ACTIONS(1835),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_implements] = ACTIONS(1835),
    [anon_sym_GT_GT] = ACTIONS(1837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1835),
    [anon_sym_in] = ACTIONS(1837),
  },
  [588] = {
    [aux_sym_array_repeat1] = STATE(588),
    [anon_sym_COMMA] = ACTIONS(2705),
    [anon_sym_RBRACK] = ACTIONS(2585),
    [sym_comment] = ACTIONS(3),
  },
  [589] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1967),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_BANG] = ACTIONS(1969),
    [anon_sym_BQUOTE] = ACTIONS(1967),
    [anon_sym_PIPE] = ACTIONS(1969),
    [anon_sym_COMMA] = ACTIONS(1967),
    [anon_sym_LT_LT] = ACTIONS(1967),
    [anon_sym_STAR] = ACTIONS(1969),
    [anon_sym_GT_GT_GT] = ACTIONS(1967),
    [anon_sym_AMP_AMP] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(1969),
    [anon_sym_BANG_EQ] = ACTIONS(1969),
    [anon_sym_LT_EQ] = ACTIONS(1967),
    [anon_sym_LPAREN] = ACTIONS(1967),
    [anon_sym_RBRACK] = ACTIONS(1967),
    [anon_sym_GT_EQ] = ACTIONS(1967),
    [anon_sym_GT] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(1969),
    [anon_sym_PERCENT] = ACTIONS(1967),
    [anon_sym_QMARK] = ACTIONS(1967),
    [anon_sym_RBRACE] = ACTIONS(1967),
    [anon_sym_as] = ACTIONS(1967),
    [anon_sym_PIPE_PIPE] = ACTIONS(1967),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_EQ_EQ] = ACTIONS(1969),
    [anon_sym_instanceof] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1969),
    [anon_sym_RPAREN] = ACTIONS(1967),
    [anon_sym_SLASH] = ACTIONS(1969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1967),
    [anon_sym_DOT] = ACTIONS(1967),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_STAR_STAR] = ACTIONS(1967),
    [anon_sym_PLUS] = ACTIONS(1969),
    [anon_sym_implements] = ACTIONS(1967),
    [anon_sym_GT_GT] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1967),
    [anon_sym_in] = ACTIONS(1969),
  },
  [590] = {
    [sym_nested_identifier] = STATE(965),
    [sym_jsx_namespace_name] = STATE(966),
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(2708),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1975),
  },
  [591] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_BANG] = ACTIONS(1987),
    [anon_sym_BQUOTE] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_LT_LT] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_GT_GT_GT] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_LBRACE] = ACTIONS(1987),
    [anon_sym_BANG_EQ] = ACTIONS(1987),
    [anon_sym_LT_EQ] = ACTIONS(1985),
    [anon_sym_LPAREN] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1985),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_GT] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1985),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_RBRACE] = ACTIONS(1985),
    [anon_sym_as] = ACTIONS(1985),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_EQ_EQ] = ACTIONS(1987),
    [anon_sym_instanceof] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_SLASH] = ACTIONS(1987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1985),
    [anon_sym_DOT] = ACTIONS(1985),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_STAR_STAR] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_implements] = ACTIONS(1985),
    [anon_sym_GT_GT] = ACTIONS(1987),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1985),
    [anon_sym_in] = ACTIONS(1987),
  },
  [592] = {
    [sym_jsx_closing_element] = STATE(1315),
    [sym_jsx_opening_element] = STATE(340),
    [aux_sym_jsx_element_repeat1] = STATE(975),
    [sym_jsx_expression] = STATE(975),
    [sym_jsx_self_closing_element] = STATE(975),
    [sym_jsx_element] = STATE(975),
    [sym_jsx_text] = ACTIONS(1993),
    [anon_sym_LT] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(590),
  },
  [593] = {
    [sym_identifier] = ACTIONS(2710),
    [sym_comment] = ACTIONS(3),
  },
  [594] = {
    [sym_identifier] = ACTIONS(2515),
    [anon_sym_BQUOTE] = ACTIONS(2513),
    [anon_sym_debugger] = ACTIONS(2515),
    [anon_sym_symbol] = ACTIONS(2515),
    [anon_sym_AT] = ACTIONS(2513),
    [anon_sym_DASH] = ACTIONS(2515),
    [anon_sym_void] = ACTIONS(2515),
    [anon_sym_break] = ACTIONS(2515),
    [anon_sym_const] = ACTIONS(2515),
    [sym_super] = ACTIONS(2515),
    [anon_sym_return] = ACTIONS(2515),
    [anon_sym_private] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_RBRACE] = ACTIONS(2513),
    [anon_sym_interface] = ACTIONS(2515),
    [anon_sym_default] = ACTIONS(2515),
    [anon_sym_enum] = ACTIONS(2515),
    [anon_sym_delete] = ACTIONS(2515),
    [anon_sym_continue] = ACTIONS(2515),
    [anon_sym_DASH_DASH] = ACTIONS(2513),
    [anon_sym_if] = ACTIONS(2515),
    [anon_sym_this] = ACTIONS(2515),
    [anon_sym_yield] = ACTIONS(2515),
    [sym_true] = ACTIONS(2515),
    [anon_sym_throw] = ACTIONS(2515),
    [anon_sym_protected] = ACTIONS(2515),
    [anon_sym_abstract] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_import] = ACTIONS(2515),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_PLUS_PLUS] = ACTIONS(2513),
    [anon_sym_await] = ACTIONS(2515),
    [anon_sym_DQUOTE] = ACTIONS(2513),
    [anon_sym_else] = ACTIONS(2515),
    [anon_sym_BANG] = ACTIONS(2513),
    [anon_sym_for] = ACTIONS(2515),
    [anon_sym_LBRACK] = ACTIONS(2513),
    [sym_false] = ACTIONS(2515),
    [anon_sym_SEMI] = ACTIONS(2513),
    [anon_sym_case] = ACTIONS(2515),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_number] = ACTIONS(2515),
    [anon_sym_class] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_typeof] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2513),
    [anon_sym_switch] = ACTIONS(2515),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [sym_null] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2515),
    [anon_sym_boolean] = ACTIONS(2515),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2515),
    [anon_sym_var] = ACTIONS(2515),
    [anon_sym_while] = ACTIONS(2515),
    [anon_sym_SQUOTE] = ACTIONS(2513),
    [anon_sym_try] = ACTIONS(2515),
    [anon_sym_LT] = ACTIONS(2513),
    [sym_number] = ACTIONS(2513),
    [anon_sym_SLASH] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2515),
    [anon_sym_function] = ACTIONS(2515),
    [sym_undefined] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2515),
    [ts_builtin_sym_end] = ACTIONS(2513),
    [anon_sym_let] = ACTIONS(2515),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_do] = ACTIONS(2515),
    [anon_sym_TILDE] = ACTIONS(2513),
    [anon_sym_with] = ACTIONS(2515),
  },
  [595] = {
    [sym_identifier] = ACTIONS(919),
    [anon_sym_BQUOTE] = ACTIONS(917),
    [anon_sym_debugger] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(917),
    [anon_sym_PIPE] = ACTIONS(917),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_DASH] = ACTIONS(919),
    [anon_sym_EQ] = ACTIONS(919),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_break] = ACTIONS(919),
    [anon_sym_const] = ACTIONS(919),
    [sym_super] = ACTIONS(919),
    [anon_sym_return] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_get] = ACTIONS(919),
    [anon_sym_RBRACE] = ACTIONS(917),
    [anon_sym_interface] = ACTIONS(919),
    [anon_sym_default] = ACTIONS(919),
    [anon_sym_enum] = ACTIONS(919),
    [anon_sym_delete] = ACTIONS(919),
    [anon_sym_continue] = ACTIONS(919),
    [anon_sym_DASH_DASH] = ACTIONS(917),
    [anon_sym_if] = ACTIONS(919),
    [anon_sym_this] = ACTIONS(919),
    [anon_sym_yield] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_COLON] = ACTIONS(917),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_abstract] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(919),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_PLUS_PLUS] = ACTIONS(917),
    [anon_sym_await] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(917),
    [anon_sym_else] = ACTIONS(919),
    [anon_sym_BANG] = ACTIONS(917),
    [anon_sym_for] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(917),
    [sym_false] = ACTIONS(919),
    [anon_sym_SEMI] = ACTIONS(917),
    [anon_sym_case] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_class] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_typeof] = ACTIONS(919),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_switch] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_RBRACK] = ACTIONS(917),
    [sym_null] = ACTIONS(919),
    [anon_sym_GT] = ACTIONS(917),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_async] = ACTIONS(919),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_EQ_GT] = ACTIONS(917),
    [anon_sym_AMP] = ACTIONS(917),
    [anon_sym_var] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(917),
    [anon_sym_while] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(917),
    [anon_sym_try] = ACTIONS(919),
    [anon_sym_RPAREN] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(917),
    [sym_number] = ACTIONS(917),
    [anon_sym_SLASH] = ACTIONS(919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_function] = ACTIONS(919),
    [sym_undefined] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(919),
    [ts_builtin_sym_end] = ACTIONS(917),
    [anon_sym_let] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_do] = ACTIONS(919),
    [anon_sym_TILDE] = ACTIONS(917),
    [anon_sym_with] = ACTIONS(919),
  },
  [596] = {
    [aux_sym_string_repeat2] = STATE(788),
    [sym_escape_sequence] = ACTIONS(1474),
    [aux_sym_string_token2] = ACTIONS(1474),
    [sym_comment] = ACTIONS(246),
    [anon_sym_SQUOTE] = ACTIONS(2712),
  },
  [597] = {
    [aux_sym_string_repeat1] = STATE(507),
    [sym_escape_sequence] = ACTIONS(921),
    [aux_sym_string_token1] = ACTIONS(921),
    [anon_sym_DQUOTE] = ACTIONS(2712),
    [sym_comment] = ACTIONS(246),
  },
  [598] = {
    [sym__initializer] = STATE(522),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2714),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2714),
    [anon_sym_AMP_EQ] = ACTIONS(2714),
    [anon_sym_PLUS_EQ] = ACTIONS(2714),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(2716),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(2716),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(2718),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2714),
    [anon_sym_STAR_EQ] = ACTIONS(2714),
    [anon_sym_PIPE_EQ] = ACTIONS(2714),
    [anon_sym_DASH_EQ] = ACTIONS(2714),
    [anon_sym_EQ_GT] = ACTIONS(2720),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2714),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(2722),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2714),
    [anon_sym_GT_GT_EQ] = ACTIONS(2714),
    [anon_sym_DOT] = ACTIONS(2725),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(2716),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2714),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2727),
  },
  [599] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(2718),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_EQ_GT] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_implements] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [600] = {
    [sym_new_expression] = STATE(1327),
    [sym_augmented_assignment_expression] = STATE(1327),
    [sym_unary_expression] = STATE(1327),
    [sym_update_expression] = STATE(1327),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(1327),
    [sym_regex] = STATE(1327),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1327),
    [sym_non_null_expression] = STATE(1327),
    [sym_as_expression] = STATE(1327),
    [sym_jsx_fragment] = STATE(1327),
    [sym_yield_expression] = STATE(1327),
    [sym_jsx_element] = STATE(1327),
    [sym_internal_module] = STATE(1327),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1327),
    [sym_await_expression] = STATE(1327),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(1327),
    [sym_this] = STATE(1327),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(1327),
    [sym_generator_function] = STATE(1327),
    [sym_call_expression] = STATE(1327),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(1327),
    [sym_ternary_expression] = STATE(1327),
    [sym_binary_expression] = STATE(1327),
    [sym_template_string] = STATE(1327),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1327),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1327),
    [sym_class] = STATE(1327),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(2733),
    [sym_false] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2735),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2737),
    [sym_true] = ACTIONS(2735),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2735),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [601] = {
    [sym_new_expression] = STATE(1328),
    [sym_augmented_assignment_expression] = STATE(1328),
    [sym_unary_expression] = STATE(1328),
    [sym_update_expression] = STATE(1328),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(1328),
    [sym_regex] = STATE(1328),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1328),
    [sym_non_null_expression] = STATE(1328),
    [sym_as_expression] = STATE(1328),
    [sym_jsx_fragment] = STATE(1328),
    [sym_yield_expression] = STATE(1328),
    [sym_jsx_element] = STATE(1328),
    [sym_internal_module] = STATE(1328),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1328),
    [sym_await_expression] = STATE(1328),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(1328),
    [sym_this] = STATE(1328),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(1328),
    [sym_generator_function] = STATE(1328),
    [sym_call_expression] = STATE(1328),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(1328),
    [sym_ternary_expression] = STATE(1328),
    [sym_binary_expression] = STATE(1328),
    [sym_template_string] = STATE(1328),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1328),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1328),
    [sym_class] = STATE(1328),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(2733),
    [sym_false] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2739),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2741),
    [sym_true] = ACTIONS(2739),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2739),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [602] = {
    [sym_new_expression] = STATE(1327),
    [sym_augmented_assignment_expression] = STATE(1327),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(1327),
    [sym_update_expression] = STATE(1327),
    [sym_regex] = STATE(1327),
    [sym_meta_property] = STATE(1327),
    [sym_call_signature] = STATE(610),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1327),
    [sym_non_null_expression] = STATE(1327),
    [sym_yield_expression] = STATE(1327),
    [sym_jsx_fragment] = STATE(1327),
    [sym_jsx_element] = STATE(1327),
    [sym_as_expression] = STATE(1327),
    [sym_internal_module] = STATE(1327),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1327),
    [sym_await_expression] = STATE(1327),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(1327),
    [sym_this] = STATE(1327),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(1327),
    [sym_generator_function] = STATE(1327),
    [sym_call_expression] = STATE(1327),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(1327),
    [sym_ternary_expression] = STATE(1327),
    [sym_binary_expression] = STATE(1327),
    [sym_template_string] = STATE(1327),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1327),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1327),
    [sym_class] = STATE(1327),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2733),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2718),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(1111),
    [sym_true] = ACTIONS(2735),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2729),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2735),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2735),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_EQ_GT] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(2737),
    [anon_sym_SLASH] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2735),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_implements] = ACTIONS(137),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [603] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_call_signature] = STATE(1329),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2743),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_symbol] = ACTIONS(2745),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2718),
    [anon_sym_void] = ACTIONS(2745),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_private] = ACTIONS(2745),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2745),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(2745),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(2745),
    [anon_sym_type] = ACTIONS(2745),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2729),
    [anon_sym_namespace] = ACTIONS(2745),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(2745),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2745),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(2745),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_boolean] = ACTIONS(2745),
    [anon_sym_async] = ACTIONS(2745),
    [anon_sym_public] = ACTIONS(2745),
    [anon_sym_EQ_GT] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_string] = ACTIONS(2745),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_implements] = ACTIONS(137),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(2745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [604] = {
    [sym_new_expression] = STATE(1331),
    [sym_augmented_assignment_expression] = STATE(1331),
    [sym_unary_expression] = STATE(1331),
    [sym_update_expression] = STATE(1331),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(1331),
    [sym_regex] = STATE(1331),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1331),
    [sym_non_null_expression] = STATE(1331),
    [sym_as_expression] = STATE(1331),
    [sym_jsx_fragment] = STATE(1331),
    [sym_yield_expression] = STATE(1331),
    [sym_jsx_element] = STATE(1331),
    [sym_internal_module] = STATE(1331),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1331),
    [sym_await_expression] = STATE(1331),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(1331),
    [sym_this] = STATE(1331),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(1331),
    [sym_generator_function] = STATE(1331),
    [sym_call_expression] = STATE(1331),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(1331),
    [sym_ternary_expression] = STATE(1331),
    [sym_binary_expression] = STATE(1331),
    [sym_template_string] = STATE(1331),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1331),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1331),
    [sym_class] = STATE(1331),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(2733),
    [sym_false] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2747),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2749),
    [sym_true] = ACTIONS(2747),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2747),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [605] = {
    [sym_new_expression] = STATE(1332),
    [sym_augmented_assignment_expression] = STATE(1332),
    [sym_unary_expression] = STATE(1332),
    [sym_update_expression] = STATE(1332),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(1332),
    [sym_regex] = STATE(1332),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1332),
    [sym_non_null_expression] = STATE(1332),
    [sym_as_expression] = STATE(1332),
    [sym_jsx_fragment] = STATE(1332),
    [sym_yield_expression] = STATE(1332),
    [sym_jsx_element] = STATE(1332),
    [sym_internal_module] = STATE(1332),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1332),
    [sym_await_expression] = STATE(1332),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(1332),
    [sym_this] = STATE(1332),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(1332),
    [sym_generator_function] = STATE(1332),
    [sym_call_expression] = STATE(1332),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(1332),
    [sym_ternary_expression] = STATE(1332),
    [sym_binary_expression] = STATE(1332),
    [sym_template_string] = STATE(1332),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1332),
    [sym_class] = STATE(1332),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(2733),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(1111),
    [sym_true] = ACTIONS(2751),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2751),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2751),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(2753),
    [anon_sym_SLASH] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2751),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_implements] = ACTIONS(213),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [606] = {
    [sym_regex_pattern] = ACTIONS(2755),
    [sym_comment] = ACTIONS(246),
  },
  [607] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(2757),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(2759),
    [anon_sym_symbol] = ACTIONS(2759),
    [anon_sym_number] = ACTIONS(2759),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2759),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2761),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2759),
    [anon_sym_private] = ACTIONS(2759),
    [anon_sym_boolean] = ACTIONS(2759),
    [anon_sym_async] = ACTIONS(2763),
    [anon_sym_public] = ACTIONS(2759),
    [anon_sym_get] = ACTIONS(2759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2759),
    [anon_sym_string] = ACTIONS(2759),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(2759),
    [anon_sym_type] = ACTIONS(2759),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(2759),
    [anon_sym_export] = ACTIONS(2759),
    [anon_sym_namespace] = ACTIONS(2765),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [608] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(2718),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_EQ_GT] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_implements] = ACTIONS(137),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [609] = {
    [sym_new_expression] = STATE(1339),
    [sym_augmented_assignment_expression] = STATE(1339),
    [sym_unary_expression] = STATE(1339),
    [sym_update_expression] = STATE(1339),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(1339),
    [sym_regex] = STATE(1339),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1339),
    [sym_non_null_expression] = STATE(1339),
    [sym_as_expression] = STATE(1339),
    [sym_jsx_fragment] = STATE(1339),
    [sym_yield_expression] = STATE(1339),
    [sym_jsx_element] = STATE(1339),
    [sym_internal_module] = STATE(1339),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1339),
    [sym_await_expression] = STATE(1339),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(1339),
    [sym_this] = STATE(1339),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(1339),
    [sym_generator_function] = STATE(1339),
    [sym_call_expression] = STATE(1339),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(1339),
    [sym_ternary_expression] = STATE(1339),
    [sym_binary_expression] = STATE(1339),
    [sym_template_string] = STATE(1339),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1339),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1339),
    [sym_class] = STATE(1339),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(2733),
    [sym_false] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2767),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2769),
    [sym_true] = ACTIONS(2767),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2767),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [610] = {
    [anon_sym_EQ_GT] = ACTIONS(2720),
    [sym_comment] = ACTIONS(3),
  },
  [611] = {
    [sym_template_string] = STATE(542),
    [aux_sym_extends_clause_repeat1] = STATE(1349),
    [sym_type_arguments] = STATE(541),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2727),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2773),
    [anon_sym_LT_LT] = ACTIONS(2775),
    [anon_sym_COMMA] = ACTIONS(2777),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_LBRACE] = ACTIONS(2781),
    [anon_sym_GT_GT_GT] = ACTIONS(2775),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_BANG_EQ] = ACTIONS(2727),
    [anon_sym_LT_EQ] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_QMARK] = ACTIONS(2789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2727),
    [anon_sym_instanceof] = ACTIONS(2771),
    [anon_sym_LT] = ACTIONS(2795),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_STAR_STAR] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_implements] = ACTIONS(2781),
    [anon_sym_GT_GT] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2771),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [612] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2714),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2714),
    [anon_sym_AMP_EQ] = ACTIONS(2714),
    [anon_sym_PLUS_EQ] = ACTIONS(2714),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(2718),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2714),
    [anon_sym_STAR_EQ] = ACTIONS(2714),
    [anon_sym_PIPE_EQ] = ACTIONS(2714),
    [anon_sym_DASH_EQ] = ACTIONS(2714),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2714),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2714),
    [anon_sym_GT_GT_EQ] = ACTIONS(2714),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2714),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [613] = {
    [sym__initializer] = STATE(587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(2718),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2727),
  },
  [614] = {
    [sym_type_arguments] = STATE(1117),
    [anon_sym_implements] = ACTIONS(2799),
    [anon_sym_LT] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2799),
  },
  [615] = {
    [sym__initializer] = STATE(589),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(2718),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2727),
  },
  [616] = {
    [aux_sym_extends_clause_repeat1] = STATE(1349),
    [anon_sym_implements] = ACTIONS(2781),
    [anon_sym_COMMA] = ACTIONS(2777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2781),
  },
  [617] = {
    [sym_type_arguments] = STATE(1064),
    [anon_sym_is] = ACTIONS(2803),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2204),
  },
  [618] = {
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(433),
    [sym_array_type] = STATE(1066),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym_existential_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(1066),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(1066),
    [sym_string] = STATE(418),
    [sym_tuple_type] = STATE(1066),
    [sym_identifier] = ACTIONS(1121),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [sym_true] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [619] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(623),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(624),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1121),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [620] = {
    [sym_type_parameters] = STATE(1351),
    [sym_formal_parameters] = STATE(1352),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [621] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(623),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(624),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1121),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [622] = {
    [aux_sym_implements_clause_repeat1] = STATE(1356),
    [anon_sym_AMP] = ACTIONS(2805),
    [anon_sym_PIPE] = ACTIONS(2807),
    [anon_sym_COMMA] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2811),
  },
  [623] = {
    [sym_formal_parameters] = STATE(1357),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [624] = {
    [anon_sym_EQ_GT] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
  },
  [625] = {
    [sym_class_body] = STATE(1359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(322),
  },
  [626] = {
    [sym_class_heritage] = STATE(1360),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(1359),
    [anon_sym_extends] = ACTIONS(1131),
    [anon_sym_implements] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(322),
  },
  [627] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2815),
    [sym_identifier] = ACTIONS(2817),
    [sym__automatic_semicolon] = ACTIONS(2815),
    [anon_sym_BQUOTE] = ACTIONS(2815),
    [anon_sym_debugger] = ACTIONS(2817),
    [ts_builtin_sym_end] = ACTIONS(2815),
    [anon_sym_symbol] = ACTIONS(2817),
    [anon_sym_AT] = ACTIONS(2815),
    [anon_sym_PIPE] = ACTIONS(2817),
    [anon_sym_COMMA] = ACTIONS(2815),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2817),
    [anon_sym_GT_GT_GT] = ACTIONS(2815),
    [anon_sym_void] = ACTIONS(2817),
    [anon_sym_break] = ACTIONS(2817),
    [anon_sym_BANG_EQ] = ACTIONS(2817),
    [anon_sym_const] = ACTIONS(2817),
    [anon_sym_GT_EQ] = ACTIONS(2815),
    [sym_super] = ACTIONS(2817),
    [anon_sym_return] = ACTIONS(2817),
    [anon_sym_private] = ACTIONS(2817),
    [anon_sym_get] = ACTIONS(2817),
    [anon_sym_RBRACE] = ACTIONS(2815),
    [anon_sym_PERCENT] = ACTIONS(2815),
    [anon_sym_interface] = ACTIONS(2817),
    [anon_sym_default] = ACTIONS(2817),
    [anon_sym_as] = ACTIONS(2817),
    [anon_sym_delete] = ACTIONS(2817),
    [anon_sym_continue] = ACTIONS(2817),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_if] = ACTIONS(2817),
    [anon_sym_instanceof] = ACTIONS(2817),
    [anon_sym_this] = ACTIONS(2817),
    [anon_sym_yield] = ACTIONS(2817),
    [sym_true] = ACTIONS(2817),
    [anon_sym_throw] = ACTIONS(2817),
    [anon_sym_enum] = ACTIONS(2817),
    [anon_sym_protected] = ACTIONS(2817),
    [anon_sym_abstract] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(2817),
    [anon_sym_set] = ACTIONS(2817),
    [anon_sym_type] = ACTIONS(2817),
    [anon_sym_STAR_STAR] = ACTIONS(2815),
    [anon_sym_import] = ACTIONS(2817),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2815),
    [anon_sym_namespace] = ACTIONS(2817),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_await] = ACTIONS(2817),
    [anon_sym_DQUOTE] = ACTIONS(2815),
    [anon_sym_else] = ACTIONS(2817),
    [anon_sym_BANG] = ACTIONS(2817),
    [anon_sym_for] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [sym_false] = ACTIONS(2817),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym_case] = ACTIONS(2817),
    [anon_sym_module] = ACTIONS(2817),
    [anon_sym_number] = ACTIONS(2817),
    [anon_sym_class] = ACTIONS(2817),
    [anon_sym_declare] = ACTIONS(2817),
    [anon_sym_typeof] = ACTIONS(2817),
    [anon_sym_LT_LT] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_switch] = ACTIONS(2817),
    [anon_sym_LT_EQ] = ACTIONS(2815),
    [anon_sym_LPAREN] = ACTIONS(2815),
    [sym_null] = ACTIONS(2817),
    [anon_sym_GT] = ACTIONS(2817),
    [anon_sym_any] = ACTIONS(2817),
    [anon_sym_boolean] = ACTIONS(2817),
    [anon_sym_async] = ACTIONS(2817),
    [anon_sym_public] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2817),
    [anon_sym_var] = ACTIONS(2817),
    [anon_sym_QMARK] = ACTIONS(2815),
    [anon_sym_PIPE_PIPE] = ACTIONS(2815),
    [anon_sym_while] = ACTIONS(2817),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_try] = ACTIONS(2817),
    [anon_sym_EQ_EQ] = ACTIONS(2817),
    [anon_sym_RPAREN] = ACTIONS(2815),
    [anon_sym_LT] = ACTIONS(2817),
    [sym_number] = ACTIONS(2815),
    [anon_sym_SLASH] = ACTIONS(2817),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2817),
    [anon_sym_function] = ACTIONS(2817),
    [sym_undefined] = ACTIONS(2817),
    [anon_sym_new] = ACTIONS(2817),
    [anon_sym_CARET] = ACTIONS(2815),
    [anon_sym_let] = ACTIONS(2817),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_export] = ACTIONS(2817),
    [anon_sym_GT_GT] = ACTIONS(2817),
    [anon_sym_do] = ACTIONS(2817),
    [anon_sym_TILDE] = ACTIONS(2815),
    [anon_sym_with] = ACTIONS(2817),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2815),
    [anon_sym_in] = ACTIONS(2817),
  },
  [628] = {
    [anon_sym_EQ] = ACTIONS(1214),
    [anon_sym_COLON] = ACTIONS(1214),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(1214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(1214),
  },
  [629] = {
    [sym_new_expression] = STATE(1373),
    [sym_augmented_assignment_expression] = STATE(1373),
    [sym_unary_expression] = STATE(1373),
    [sym_update_expression] = STATE(1373),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(1373),
    [sym_regex] = STATE(1373),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1373),
    [sym_non_null_expression] = STATE(1373),
    [sym_as_expression] = STATE(1373),
    [sym_jsx_fragment] = STATE(1373),
    [sym_yield_expression] = STATE(1373),
    [sym_jsx_element] = STATE(1373),
    [sym_internal_module] = STATE(1373),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1373),
    [sym_await_expression] = STATE(1373),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(1373),
    [sym_this] = STATE(1373),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(1373),
    [sym_generator_function] = STATE(1373),
    [sym_call_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(1373),
    [sym_ternary_expression] = STATE(1373),
    [sym_binary_expression] = STATE(1373),
    [sym_template_string] = STATE(1373),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1373),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1373),
    [sym_class] = STATE(1373),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2821),
    [sym_false] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2825),
    [anon_sym_symbol] = ACTIONS(2825),
    [anon_sym_number] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2825),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2831),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2823),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2825),
    [anon_sym_private] = ACTIONS(2825),
    [anon_sym_boolean] = ACTIONS(2825),
    [anon_sym_async] = ACTIONS(2833),
    [anon_sym_public] = ACTIONS(2825),
    [anon_sym_get] = ACTIONS(2825),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2837),
    [sym_true] = ACTIONS(2823),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2825),
    [anon_sym_string] = ACTIONS(2825),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2823),
    [anon_sym_set] = ACTIONS(2825),
    [anon_sym_type] = ACTIONS(2825),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2825),
    [anon_sym_export] = ACTIONS(2825),
    [anon_sym_namespace] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [630] = {
    [sym_string] = STATE(1377),
    [sym__property_name] = STATE(1377),
    [sym_computed_property_name] = STATE(1377),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(2847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [631] = {
    [sym__automatic_semicolon] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1238),
    [sym_identifier] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1236),
    [anon_sym_symbol] = ACTIONS(1236),
    [anon_sym_number] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1236),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(1238),
    [anon_sym_EQ] = ACTIONS(1214),
    [anon_sym_void] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1236),
    [anon_sym_private] = ACTIONS(1236),
    [anon_sym_boolean] = ACTIONS(1236),
    [anon_sym_static] = ACTIONS(1236),
    [anon_sym_public] = ACTIONS(1236),
    [anon_sym_get] = ACTIONS(1236),
    [anon_sym_async] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(1238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1236),
    [anon_sym_string] = ACTIONS(1236),
    [anon_sym_abstract] = ACTIONS(1236),
    [anon_sym_set] = ACTIONS(1236),
    [anon_sym_type] = ACTIONS(1236),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_import] = ACTIONS(1236),
    [anon_sym_export] = ACTIONS(1236),
    [anon_sym_namespace] = ACTIONS(1236),
    [sym_readonly] = ACTIONS(1236),
    [anon_sym_DQUOTE] = ACTIONS(1238),
    [anon_sym_BANG] = ACTIONS(1214),
  },
  [632] = {
    [sym_string] = STATE(1377),
    [sym__property_name] = STATE(1377),
    [sym_computed_property_name] = STATE(1377),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(2849),
    [anon_sym_EQ] = ACTIONS(1214),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(2851),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(2847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(2851),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_BANG] = ACTIONS(1214),
  },
  [633] = {
    [sym_string] = STATE(1377),
    [sym__property_name] = STATE(1377),
    [sym_computed_property_name] = STATE(1377),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_EQ] = ACTIONS(1214),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(2847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_BANG] = ACTIONS(1214),
  },
  [634] = {
    [sym_string] = STATE(1384),
    [sym__property_name] = STATE(1384),
    [sym_computed_property_name] = STATE(1384),
    [anon_sym_get] = ACTIONS(2853),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_async] = ACTIONS(2857),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(2859),
    [anon_sym_STAR] = ACTIONS(2849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2853),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(2861),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [635] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2863),
    [sym__automatic_semicolon] = ACTIONS(2863),
    [sym_identifier] = ACTIONS(2865),
    [anon_sym_BQUOTE] = ACTIONS(2863),
    [anon_sym_debugger] = ACTIONS(2865),
    [anon_sym_with] = ACTIONS(2865),
    [anon_sym_symbol] = ACTIONS(2865),
    [anon_sym_AT] = ACTIONS(2863),
    [anon_sym_PIPE] = ACTIONS(2865),
    [anon_sym_COMMA] = ACTIONS(2863),
    [anon_sym_DASH] = ACTIONS(2865),
    [anon_sym_STAR] = ACTIONS(2865),
    [anon_sym_GT_GT_GT] = ACTIONS(2863),
    [anon_sym_void] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2865),
    [anon_sym_BANG_EQ] = ACTIONS(2865),
    [anon_sym_const] = ACTIONS(2865),
    [anon_sym_GT_EQ] = ACTIONS(2863),
    [sym_super] = ACTIONS(2865),
    [anon_sym_return] = ACTIONS(2865),
    [anon_sym_private] = ACTIONS(2865),
    [anon_sym_get] = ACTIONS(2865),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_interface] = ACTIONS(2865),
    [anon_sym_default] = ACTIONS(2865),
    [anon_sym_as] = ACTIONS(2865),
    [anon_sym_delete] = ACTIONS(2865),
    [anon_sym_continue] = ACTIONS(2865),
    [anon_sym_DASH_DASH] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2865),
    [anon_sym_instanceof] = ACTIONS(2865),
    [anon_sym_this] = ACTIONS(2865),
    [anon_sym_yield] = ACTIONS(2865),
    [sym_true] = ACTIONS(2865),
    [anon_sym_throw] = ACTIONS(2865),
    [anon_sym_enum] = ACTIONS(2865),
    [anon_sym_protected] = ACTIONS(2865),
    [anon_sym_abstract] = ACTIONS(2865),
    [anon_sym_DOT] = ACTIONS(2865),
    [anon_sym_set] = ACTIONS(2865),
    [anon_sym_type] = ACTIONS(2865),
    [anon_sym_STAR_STAR] = ACTIONS(2863),
    [anon_sym_import] = ACTIONS(2865),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2863),
    [anon_sym_namespace] = ACTIONS(2865),
    [anon_sym_PLUS_PLUS] = ACTIONS(2863),
    [anon_sym_await] = ACTIONS(2865),
    [anon_sym_DQUOTE] = ACTIONS(2863),
    [anon_sym_else] = ACTIONS(2865),
    [anon_sym_BANG] = ACTIONS(2865),
    [anon_sym_for] = ACTIONS(2865),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [sym_false] = ACTIONS(2865),
    [anon_sym_SEMI] = ACTIONS(2863),
    [anon_sym_case] = ACTIONS(2865),
    [anon_sym_module] = ACTIONS(2865),
    [anon_sym_number] = ACTIONS(2865),
    [anon_sym_class] = ACTIONS(2865),
    [anon_sym_declare] = ACTIONS(2865),
    [anon_sym_typeof] = ACTIONS(2865),
    [anon_sym_LT_LT] = ACTIONS(2863),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_switch] = ACTIONS(2865),
    [anon_sym_LT_EQ] = ACTIONS(2863),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [sym_null] = ACTIONS(2865),
    [anon_sym_GT] = ACTIONS(2865),
    [anon_sym_any] = ACTIONS(2865),
    [anon_sym_boolean] = ACTIONS(2865),
    [anon_sym_async] = ACTIONS(2865),
    [anon_sym_public] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2865),
    [anon_sym_var] = ACTIONS(2865),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2865),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_try] = ACTIONS(2865),
    [anon_sym_EQ_EQ] = ACTIONS(2865),
    [anon_sym_RPAREN] = ACTIONS(2863),
    [anon_sym_LT] = ACTIONS(2865),
    [sym_number] = ACTIONS(2863),
    [anon_sym_SLASH] = ACTIONS(2865),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(2863),
    [anon_sym_string] = ACTIONS(2865),
    [anon_sym_function] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_CARET] = ACTIONS(2863),
    [anon_sym_new] = ACTIONS(2865),
    [anon_sym_PLUS] = ACTIONS(2865),
    [anon_sym_let] = ACTIONS(2865),
    [anon_sym_GT_GT] = ACTIONS(2865),
    [anon_sym_export] = ACTIONS(2865),
    [anon_sym_do] = ACTIONS(2865),
    [anon_sym_TILDE] = ACTIONS(2863),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2863),
    [anon_sym_in] = ACTIONS(2865),
  },
  [636] = {
    [aux_sym_string_repeat2] = STATE(1386),
    [sym_escape_sequence] = ACTIONS(2867),
    [aux_sym_string_token2] = ACTIONS(2867),
    [sym_comment] = ACTIONS(246),
    [anon_sym_SQUOTE] = ACTIONS(2869),
  },
  [637] = {
    [sym_string] = STATE(1390),
    [sym__property_name] = STATE(1390),
    [sym_computed_property_name] = STATE(1390),
    [anon_sym_get] = ACTIONS(2871),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(2873),
    [anon_sym_STAR] = ACTIONS(2875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2871),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(2877),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [638] = {
    [sym_string] = STATE(1384),
    [sym__property_name] = STATE(1384),
    [sym_computed_property_name] = STATE(1384),
    [anon_sym_get] = ACTIONS(2853),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(2859),
    [anon_sym_STAR] = ACTIONS(2849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(2877),
    [anon_sym_set] = ACTIONS(2853),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_async] = ACTIONS(2857),
  },
  [639] = {
    [aux_sym_string_repeat1] = STATE(1391),
    [sym_escape_sequence] = ACTIONS(2879),
    [aux_sym_string_token1] = ACTIONS(2879),
    [anon_sym_DQUOTE] = ACTIONS(2869),
    [sym_comment] = ACTIONS(246),
  },
  [640] = {
    [sym__automatic_semicolon] = ACTIONS(2881),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
  },
  [641] = {
    [sym_type_parameters] = STATE(1395),
    [sym__initializer] = STATE(1396),
    [sym_formal_parameters] = STATE(1397),
    [sym_type_annotation] = STATE(1398),
    [sym_call_signature] = STATE(1399),
    [sym__automatic_semicolon] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(2887),
  },
  [642] = {
    [sym_string] = STATE(1384),
    [sym__property_name] = STATE(1384),
    [sym_computed_property_name] = STATE(1384),
    [anon_sym_get] = ACTIONS(2853),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_async] = ACTIONS(2857),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(2859),
    [anon_sym_STAR] = ACTIONS(2849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(2889),
    [anon_sym_set] = ACTIONS(2853),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(2891),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_private] = ACTIONS(1135),
  },
  [643] = {
    [sym_public_field_definition] = STATE(640),
    [sym__property_name] = STATE(641),
    [sym_decorator] = STATE(1404),
    [sym_method_signature] = STATE(640),
    [sym_accessibility_modifier] = STATE(642),
    [sym_abstract_method_signature] = STATE(640),
    [sym_computed_property_name] = STATE(641),
    [aux_sym_class_body_repeat1] = STATE(1404),
    [sym_index_signature] = STATE(640),
    [sym_string] = STATE(641),
    [sym_method_definition] = STATE(644),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1145),
    [anon_sym_get] = ACTIONS(1147),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [sym_number] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [644] = {
    [sym__automatic_semicolon] = ACTIONS(2881),
    [anon_sym_LBRACK] = ACTIONS(2897),
    [sym_identifier] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym_module] = ACTIONS(2899),
    [anon_sym_symbol] = ACTIONS(2899),
    [anon_sym_number] = ACTIONS(2899),
    [anon_sym_AT] = ACTIONS(2897),
    [anon_sym_declare] = ACTIONS(2899),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_void] = ACTIONS(2899),
    [anon_sym_any] = ACTIONS(2899),
    [anon_sym_private] = ACTIONS(2899),
    [anon_sym_boolean] = ACTIONS(2899),
    [anon_sym_async] = ACTIONS(2899),
    [anon_sym_public] = ACTIONS(2899),
    [anon_sym_get] = ACTIONS(2899),
    [anon_sym_RBRACE] = ACTIONS(2897),
    [anon_sym_static] = ACTIONS(2899),
    [anon_sym_SQUOTE] = ACTIONS(2897),
    [sym_number] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2899),
    [anon_sym_string] = ACTIONS(2899),
    [anon_sym_abstract] = ACTIONS(2899),
    [anon_sym_set] = ACTIONS(2899),
    [anon_sym_type] = ACTIONS(2899),
    [anon_sym_import] = ACTIONS(2899),
    [anon_sym_export] = ACTIONS(2899),
    [anon_sym_namespace] = ACTIONS(2899),
    [sym_readonly] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2897),
  },
  [645] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_BANG] = ACTIONS(2903),
    [anon_sym_SEMI] = ACTIONS(2901),
    [anon_sym_BQUOTE] = ACTIONS(2901),
    [sym__automatic_semicolon] = ACTIONS(2901),
    [anon_sym_PIPE] = ACTIONS(2903),
    [anon_sym_COMMA] = ACTIONS(2901),
    [anon_sym_LT_LT] = ACTIONS(2901),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_GT_GT_GT] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_BANG_EQ] = ACTIONS(2903),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_LPAREN] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_GT] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2903),
    [anon_sym_PERCENT] = ACTIONS(2901),
    [anon_sym_QMARK] = ACTIONS(2901),
    [anon_sym_RBRACE] = ACTIONS(2901),
    [anon_sym_as] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [anon_sym_EQ_EQ] = ACTIONS(2903),
    [anon_sym_instanceof] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_RPAREN] = ACTIONS(2901),
    [anon_sym_SLASH] = ACTIONS(2903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2901),
    [anon_sym_CARET] = ACTIONS(2901),
    [anon_sym_STAR_STAR] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_GT_GT] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2901),
    [anon_sym_in] = ACTIONS(2903),
  },
  [646] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2905),
  },
  [647] = {
    [sym_identifier] = ACTIONS(2907),
    [sym_comment] = ACTIONS(3),
  },
  [648] = {
    [sym_class_heritage] = STATE(1406),
    [sym_type_parameters] = STATE(1407),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(1408),
    [anon_sym_extends] = ACTIONS(1131),
    [anon_sym_implements] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2467),
  },
  [649] = {
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_BQUOTE] = ACTIONS(2911),
    [anon_sym_debugger] = ACTIONS(2909),
    [anon_sym_symbol] = ACTIONS(2909),
    [anon_sym_AT] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(2909),
    [anon_sym_void] = ACTIONS(2909),
    [anon_sym_break] = ACTIONS(2909),
    [anon_sym_const] = ACTIONS(2909),
    [sym_super] = ACTIONS(2909),
    [anon_sym_return] = ACTIONS(2909),
    [anon_sym_private] = ACTIONS(2909),
    [anon_sym_get] = ACTIONS(2909),
    [anon_sym_RBRACE] = ACTIONS(2911),
    [anon_sym_interface] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2909),
    [anon_sym_enum] = ACTIONS(2909),
    [anon_sym_delete] = ACTIONS(2909),
    [anon_sym_continue] = ACTIONS(2909),
    [anon_sym_DASH_DASH] = ACTIONS(2911),
    [anon_sym_if] = ACTIONS(2909),
    [anon_sym_this] = ACTIONS(2909),
    [anon_sym_yield] = ACTIONS(2909),
    [sym_true] = ACTIONS(2909),
    [anon_sym_throw] = ACTIONS(2909),
    [anon_sym_protected] = ACTIONS(2909),
    [anon_sym_abstract] = ACTIONS(2909),
    [anon_sym_set] = ACTIONS(2909),
    [anon_sym_type] = ACTIONS(2909),
    [anon_sym_import] = ACTIONS(2909),
    [anon_sym_namespace] = ACTIONS(2909),
    [anon_sym_PLUS_PLUS] = ACTIONS(2911),
    [anon_sym_await] = ACTIONS(2909),
    [anon_sym_DQUOTE] = ACTIONS(2911),
    [anon_sym_else] = ACTIONS(2909),
    [anon_sym_BANG] = ACTIONS(2911),
    [anon_sym_for] = ACTIONS(2909),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [sym_false] = ACTIONS(2909),
    [anon_sym_SEMI] = ACTIONS(2911),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_module] = ACTIONS(2909),
    [anon_sym_number] = ACTIONS(2909),
    [anon_sym_class] = ACTIONS(2909),
    [anon_sym_declare] = ACTIONS(2909),
    [anon_sym_typeof] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(2911),
    [anon_sym_switch] = ACTIONS(2909),
    [anon_sym_LPAREN] = ACTIONS(2911),
    [sym_null] = ACTIONS(2909),
    [anon_sym_any] = ACTIONS(2909),
    [anon_sym_boolean] = ACTIONS(2909),
    [anon_sym_async] = ACTIONS(2909),
    [anon_sym_public] = ACTIONS(2909),
    [anon_sym_var] = ACTIONS(2909),
    [anon_sym_while] = ACTIONS(2909),
    [anon_sym_SQUOTE] = ACTIONS(2911),
    [anon_sym_try] = ACTIONS(2909),
    [anon_sym_LT] = ACTIONS(2911),
    [sym_number] = ACTIONS(2911),
    [anon_sym_SLASH] = ACTIONS(2909),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2909),
    [anon_sym_function] = ACTIONS(2909),
    [sym_undefined] = ACTIONS(2909),
    [anon_sym_new] = ACTIONS(2909),
    [ts_builtin_sym_end] = ACTIONS(2911),
    [anon_sym_let] = ACTIONS(2909),
    [anon_sym_PLUS] = ACTIONS(2909),
    [anon_sym_export] = ACTIONS(2909),
    [anon_sym_do] = ACTIONS(2909),
    [anon_sym_TILDE] = ACTIONS(2911),
    [anon_sym_with] = ACTIONS(2909),
  },
  [650] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(1410),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [651] = {
    [sym_type_parameters] = STATE(815),
    [sym_formal_parameters] = STATE(816),
    [sym_call_signature] = STATE(1411),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [652] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(1413),
    [sym_identifier] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [653] = {
    [sym_statement_block] = STATE(1414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [654] = {
    [anon_sym_EQ] = ACTIONS(2917),
    [sym_comment] = ACTIONS(3),
  },
  [655] = {
    [sym_identifier] = ACTIONS(2919),
    [sym_comment] = ACTIONS(3),
  },
  [656] = {
    [sym_identifier] = ACTIONS(913),
    [anon_sym_BQUOTE] = ACTIONS(911),
    [anon_sym_debugger] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
    [anon_sym_AT] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_void] = ACTIONS(913),
    [anon_sym_break] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(913),
    [sym_super] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(911),
    [anon_sym_interface] = ACTIONS(913),
    [anon_sym_default] = ACTIONS(913),
    [anon_sym_enum] = ACTIONS(913),
    [anon_sym_delete] = ACTIONS(913),
    [anon_sym_continue] = ACTIONS(913),
    [anon_sym_DASH_DASH] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(913),
    [anon_sym_this] = ACTIONS(913),
    [anon_sym_yield] = ACTIONS(913),
    [sym_true] = ACTIONS(913),
    [anon_sym_throw] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_abstract] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(911),
    [anon_sym_await] = ACTIONS(913),
    [anon_sym_DQUOTE] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(913),
    [anon_sym_BANG] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(911),
    [sym_false] = ACTIONS(913),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_class] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(911),
    [anon_sym_switch] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(911),
    [sym_null] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_var] = ACTIONS(913),
    [anon_sym_while] = ACTIONS(913),
    [anon_sym_SQUOTE] = ACTIONS(911),
    [anon_sym_try] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(911),
    [sym_number] = ACTIONS(911),
    [anon_sym_SLASH] = ACTIONS(913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_function] = ACTIONS(913),
    [sym_undefined] = ACTIONS(913),
    [anon_sym_new] = ACTIONS(913),
    [ts_builtin_sym_end] = ACTIONS(911),
    [anon_sym_let] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_do] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(911),
    [anon_sym_with] = ACTIONS(913),
  },
  [657] = {
    [sym_identifier] = ACTIONS(2921),
    [sym_comment] = ACTIONS(3),
  },
  [658] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_BQUOTE] = ACTIONS(2923),
    [sym__automatic_semicolon] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2925),
    [anon_sym_COMMA] = ACTIONS(2923),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_STAR] = ACTIONS(2925),
    [anon_sym_GT_GT_GT] = ACTIONS(2923),
    [anon_sym_EQ] = ACTIONS(2925),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_BANG_EQ] = ACTIONS(2925),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2923),
    [anon_sym_of] = ACTIONS(2923),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [anon_sym_QMARK] = ACTIONS(2923),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_as] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_EQ_EQ] = ACTIONS(2925),
    [anon_sym_instanceof] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_RPAREN] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2923),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_STAR_STAR] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_GT_GT] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2923),
    [anon_sym_in] = ACTIONS(2925),
  },
  [659] = {
    [sym_new_expression] = STATE(1429),
    [sym_augmented_assignment_expression] = STATE(1429),
    [sym_unary_expression] = STATE(1429),
    [sym_update_expression] = STATE(1429),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(1429),
    [sym_regex] = STATE(1429),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1429),
    [sym_non_null_expression] = STATE(1429),
    [sym_as_expression] = STATE(1429),
    [sym_jsx_fragment] = STATE(1429),
    [sym_yield_expression] = STATE(1429),
    [sym_jsx_element] = STATE(1429),
    [sym_internal_module] = STATE(1429),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1429),
    [sym_await_expression] = STATE(1429),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(1429),
    [sym_this] = STATE(1429),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(1429),
    [sym_generator_function] = STATE(1429),
    [sym_call_expression] = STATE(1429),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(1429),
    [sym_ternary_expression] = STATE(1429),
    [sym_binary_expression] = STATE(1429),
    [sym_template_string] = STATE(1429),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1429),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(1429),
    [sym_class] = STATE(1429),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_false] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(2931),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2945),
    [sym_true] = ACTIONS(2931),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(2931),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [660] = {
    [sym_type_alias_declaration] = STATE(348),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(348),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(348),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(348),
    [sym_return_statement] = STATE(348),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(348),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(348),
    [sym_switch_statement] = STATE(348),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(348),
    [sym_throw_statement] = STATE(348),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(348),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(348),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(348),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(348),
    [sym_abstract_class] = STATE(348),
    [sym_interface_declaration] = STATE(348),
    [sym_statement_block] = STATE(348),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(348),
    [sym_debugger_statement] = STATE(348),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(348),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(348),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(348),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(348),
    [sym_empty_statement] = STATE(348),
    [sym_import_alias] = STATE(348),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(348),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(348),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(348),
    [sym_break_statement] = STATE(348),
    [sym_labeled_statement] = STATE(348),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(348),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [661] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_BANG] = ACTIONS(614),
    [anon_sym_SEMI] = ACTIONS(612),
    [anon_sym_BQUOTE] = ACTIONS(612),
    [sym__automatic_semicolon] = ACTIONS(612),
    [anon_sym_PIPE] = ACTIONS(614),
    [anon_sym_COMMA] = ACTIONS(2955),
    [anon_sym_LT_LT] = ACTIONS(612),
    [anon_sym_STAR] = ACTIONS(614),
    [anon_sym_GT_GT_GT] = ACTIONS(612),
    [anon_sym_AMP_AMP] = ACTIONS(612),
    [anon_sym_DASH] = ACTIONS(614),
    [anon_sym_BANG_EQ] = ACTIONS(614),
    [anon_sym_LT_EQ] = ACTIONS(612),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_GT_EQ] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(614),
    [anon_sym_RBRACE] = ACTIONS(2958),
    [anon_sym_AMP] = ACTIONS(614),
    [anon_sym_QMARK] = ACTIONS(612),
    [anon_sym_PERCENT] = ACTIONS(612),
    [anon_sym_as] = ACTIONS(612),
    [anon_sym_PIPE_PIPE] = ACTIONS(612),
    [anon_sym_DASH_DASH] = ACTIONS(612),
    [anon_sym_EQ_EQ] = ACTIONS(614),
    [anon_sym_instanceof] = ACTIONS(612),
    [anon_sym_LT] = ACTIONS(614),
    [anon_sym_SLASH] = ACTIONS(614),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(612),
    [anon_sym_CARET] = ACTIONS(612),
    [anon_sym_STAR_STAR] = ACTIONS(612),
    [anon_sym_PLUS] = ACTIONS(614),
    [anon_sym_GT_GT] = ACTIONS(614),
    [anon_sym_PLUS_PLUS] = ACTIONS(612),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(612),
    [anon_sym_in] = ACTIONS(614),
  },
  [662] = {
    [aux_sym_object_repeat1] = STATE(699),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_RBRACE] = ACTIONS(2960),
    [sym_comment] = ACTIONS(3),
  },
  [663] = {
    [sym_arguments] = STATE(375),
    [anon_sym_LBRACK] = ACTIONS(674),
    [sym_identifier] = ACTIONS(676),
    [anon_sym_module] = ACTIONS(676),
    [anon_sym_symbol] = ACTIONS(676),
    [anon_sym_number] = ACTIONS(676),
    [anon_sym_AT] = ACTIONS(674),
    [anon_sym_class] = ACTIONS(676),
    [anon_sym_declare] = ACTIONS(676),
    [anon_sym_STAR] = ACTIONS(674),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [anon_sym_any] = ACTIONS(676),
    [anon_sym_private] = ACTIONS(676),
    [anon_sym_boolean] = ACTIONS(676),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_public] = ACTIONS(676),
    [anon_sym_get] = ACTIONS(676),
    [anon_sym_static] = ACTIONS(676),
    [anon_sym_RBRACE] = ACTIONS(674),
    [anon_sym_SQUOTE] = ACTIONS(674),
    [sym_number] = ACTIONS(674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(676),
    [anon_sym_string] = ACTIONS(676),
    [anon_sym_abstract] = ACTIONS(676),
    [anon_sym_DOT] = ACTIONS(680),
    [anon_sym_set] = ACTIONS(676),
    [anon_sym_type] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(676),
    [anon_sym_export] = ACTIONS(676),
    [sym_readonly] = ACTIONS(676),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_DQUOTE] = ACTIONS(674),
  },
  [664] = {
    [sym__initializer] = STATE(1010),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(2964),
    [anon_sym_EQ] = ACTIONS(2123),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(2964),
    [sym_comment] = ACTIONS(3),
  },
  [665] = {
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(2964),
    [sym_comment] = ACTIONS(3),
  },
  [666] = {
    [anon_sym_LBRACK] = ACTIONS(1238),
    [sym_identifier] = ACTIONS(1236),
    [anon_sym_module] = ACTIONS(1236),
    [anon_sym_symbol] = ACTIONS(1236),
    [anon_sym_number] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1236),
    [anon_sym_COMMA] = ACTIONS(2964),
    [anon_sym_STAR] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1236),
    [anon_sym_private] = ACTIONS(1236),
    [anon_sym_boolean] = ACTIONS(1236),
    [anon_sym_async] = ACTIONS(1236),
    [anon_sym_public] = ACTIONS(1236),
    [anon_sym_get] = ACTIONS(1236),
    [anon_sym_static] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(2964),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(1238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1236),
    [anon_sym_string] = ACTIONS(1236),
    [anon_sym_set] = ACTIONS(1236),
    [anon_sym_type] = ACTIONS(1236),
    [anon_sym_import] = ACTIONS(1236),
    [anon_sym_export] = ACTIONS(1236),
    [anon_sym_namespace] = ACTIONS(1236),
    [sym_readonly] = ACTIONS(1236),
    [anon_sym_DQUOTE] = ACTIONS(1238),
  },
  [667] = {
    [sym_string] = STATE(673),
    [sym__property_name] = STATE(673),
    [sym_computed_property_name] = STATE(673),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(2964),
    [anon_sym_STAR] = ACTIONS(1244),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1240),
    [anon_sym_RBRACE] = ACTIONS(2964),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(1234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1240),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [668] = {
    [sym_string] = STATE(673),
    [sym__property_name] = STATE(673),
    [sym_computed_property_name] = STATE(673),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(2964),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(2964),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(1234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [669] = {
    [aux_sym_export_statement_repeat1] = STATE(1012),
    [sym__property_name] = STATE(707),
    [sym_decorator] = STATE(1012),
    [sym_string] = STATE(707),
    [sym_accessibility_modifier] = STATE(221),
    [sym_method_definition] = STATE(1435),
    [sym_computed_property_name] = STATE(707),
    [anon_sym_get] = ACTIONS(1320),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1318),
    [anon_sym_static] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [sym_number] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(364),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1316),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1320),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [sym_readonly] = ACTIONS(384),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1316),
    [anon_sym_public] = ACTIONS(1316),
  },
  [670] = {
    [anon_sym_COMMA] = ACTIONS(2966),
    [anon_sym_RBRACE] = ACTIONS(2966),
    [sym_comment] = ACTIONS(3),
  },
  [671] = {
    [anon_sym_EQ] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COMMA] = ACTIONS(1214),
  },
  [672] = {
    [sym_new_expression] = STATE(1441),
    [sym_augmented_assignment_expression] = STATE(1441),
    [sym_unary_expression] = STATE(1441),
    [sym_update_expression] = STATE(1441),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(1441),
    [sym_regex] = STATE(1441),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1441),
    [sym_non_null_expression] = STATE(1441),
    [sym_as_expression] = STATE(1441),
    [sym_jsx_fragment] = STATE(1441),
    [sym_yield_expression] = STATE(1441),
    [sym_jsx_element] = STATE(1441),
    [sym_internal_module] = STATE(1441),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1441),
    [sym_await_expression] = STATE(1441),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(1441),
    [sym_this] = STATE(1441),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(1441),
    [sym_generator_function] = STATE(1441),
    [sym_call_expression] = STATE(1441),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(1441),
    [sym_ternary_expression] = STATE(1441),
    [sym_binary_expression] = STATE(1441),
    [sym_template_string] = STATE(1441),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1441),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1441),
    [sym_class] = STATE(1441),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(2970),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2970),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2978),
    [sym_true] = ACTIONS(2970),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2970),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [673] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(1443),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(2982),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [674] = {
    [sym_string] = STATE(1444),
    [sym__property_name] = STATE(1444),
    [sym_computed_property_name] = STATE(1444),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(2984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [675] = {
    [sym_string] = STATE(1444),
    [sym__property_name] = STATE(1444),
    [sym_computed_property_name] = STATE(1444),
    [anon_sym_get] = ACTIONS(2986),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(2984),
    [anon_sym_STAR] = ACTIONS(2988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(2986),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(2990),
  },
  [676] = {
    [sym_string] = STATE(1444),
    [sym__property_name] = STATE(1444),
    [sym_computed_property_name] = STATE(1444),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(2984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [677] = {
    [sym_string] = STATE(1444),
    [sym__property_name] = STATE(1444),
    [sym_computed_property_name] = STATE(1444),
    [anon_sym_get] = ACTIONS(2986),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(2984),
    [anon_sym_STAR] = ACTIONS(2988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(2986),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [678] = {
    [sym_type_alias_declaration] = STATE(1455),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1455),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1455),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(1455),
    [sym_return_statement] = STATE(1455),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1455),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1455),
    [sym_switch_statement] = STATE(1455),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(1455),
    [sym_throw_statement] = STATE(1455),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(1455),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1455),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(1455),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(1455),
    [sym_abstract_class] = STATE(1455),
    [sym_interface_declaration] = STATE(1455),
    [sym_statement_block] = STATE(1455),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(1455),
    [sym_debugger_statement] = STATE(1455),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(1455),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1455),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1455),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1455),
    [sym_empty_statement] = STATE(1455),
    [sym_import_alias] = STATE(1455),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1455),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1455),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(1455),
    [sym_break_statement] = STATE(1455),
    [sym_labeled_statement] = STATE(1455),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(1455),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [679] = {
    [anon_sym_LPAREN] = ACTIONS(3006),
    [sym_comment] = ACTIONS(3),
  },
  [680] = {
    [sym_new_expression] = STATE(59),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_yield_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_internal_module] = STATE(59),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(59),
    [sym_await_expression] = STATE(59),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1461),
    [sym_variable_declaration] = STATE(1461),
    [sym_sequence_expression] = STATE(62),
    [sym_string] = STATE(59),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(1461),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1462),
    [sym_anonymous_class] = STATE(59),
    [sym_generator_function] = STATE(59),
    [sym_call_expression] = STATE(59),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(59),
    [sym_ternary_expression] = STATE(59),
    [sym_binary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_lexical_declaration] = STATE(1461),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(1463),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_identifier] = ACTIONS(3008),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(3010),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3012),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(3010),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(15),
  },
  [681] = {
    [sym_template_string] = STATE(542),
    [aux_sym_array_repeat1] = STATE(585),
    [sym_type_arguments] = STATE(541),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(945),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_RBRACK] = ACTIONS(3014),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [682] = {
    [sym_string] = STATE(173),
    [sym_nested_identifier] = STATE(169),
    [sym__module] = STATE(172),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(312),
  },
  [683] = {
    [sym_type_alias_declaration] = STATE(193),
    [aux_sym_export_statement_repeat1] = STATE(685),
    [sym__declaration] = STATE(193),
    [sym_ambient_declaration] = STATE(193),
    [sym_import_alias] = STATE(193),
    [sym_export_statement] = STATE(193),
    [sym_generator_function] = STATE(193),
    [sym_lexical_declaration] = STATE(193),
    [sym_internal_module] = STATE(193),
    [sym_decorator] = STATE(685),
    [sym_enum_declaration] = STATE(193),
    [sym_function] = STATE(193),
    [sym_function_signature] = STATE(193),
    [sym_variable_declaration] = STATE(193),
    [sym_abstract_class] = STATE(193),
    [sym_module] = STATE(193),
    [sym_interface_declaration] = STATE(193),
    [sym_class] = STATE(193),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(1267),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1269),
    [anon_sym_global] = ACTIONS(324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(346),
  },
  [684] = {
    [sym_type_alias_declaration] = STATE(300),
    [aux_sym_export_statement_repeat1] = STATE(685),
    [sym__declaration] = STATE(300),
    [sym_ambient_declaration] = STATE(300),
    [sym_import_alias] = STATE(300),
    [sym_export_statement] = STATE(300),
    [sym_generator_function] = STATE(300),
    [sym_export_clause] = STATE(301),
    [sym_lexical_declaration] = STATE(300),
    [sym_internal_module] = STATE(300),
    [sym_decorator] = STATE(685),
    [sym_enum_declaration] = STATE(300),
    [sym_function] = STATE(300),
    [sym_function_signature] = STATE(300),
    [sym_variable_declaration] = STATE(300),
    [sym_abstract_class] = STATE(300),
    [sym_module] = STATE(300),
    [sym_interface_declaration] = STATE(300),
    [sym_class] = STATE(300),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_as] = ACTIONS(1183),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1269),
    [anon_sym_STAR] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_EQ] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(346),
  },
  [685] = {
    [aux_sym_export_statement_repeat1] = STATE(320),
    [sym_decorator] = STATE(320),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(3018),
    [anon_sym_class] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
  },
  [686] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2021),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(2583),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_BANG_EQ] = ACTIONS(2021),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2021),
    [anon_sym_RBRACE] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_QMARK] = ACTIONS(2077),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2021),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2081),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [687] = {
    [anon_sym_EQ_GT] = ACTIONS(1462),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [sym_comment] = ACTIONS(3),
  },
  [688] = {
    [anon_sym_EQ_GT] = ACTIONS(1464),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [sym_comment] = ACTIONS(3),
  },
  [689] = {
    [sym_string] = STATE(1444),
    [sym__property_name] = STATE(1444),
    [sym_computed_property_name] = STATE(1444),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_EQ_GT] = ACTIONS(1464),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(2984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [690] = {
    [sym_type_alias_declaration] = STATE(787),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(787),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(787),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(787),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(787),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(787),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(787),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(787),
    [sym_abstract_class] = STATE(787),
    [sym_interface_declaration] = STATE(787),
    [sym_statement_block] = STATE(787),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(787),
    [sym_debugger_statement] = STATE(787),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(787),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(787),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(787),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(787),
    [sym_empty_statement] = STATE(787),
    [sym_import_alias] = STATE(787),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(787),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(787),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_labeled_statement] = STATE(787),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(787),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [691] = {
    [sym_type_alias_declaration] = STATE(891),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(891),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(891),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(891),
    [sym_return_statement] = STATE(891),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(891),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(891),
    [sym_switch_statement] = STATE(891),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(891),
    [sym_throw_statement] = STATE(891),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(891),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(891),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(891),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(891),
    [sym_abstract_class] = STATE(891),
    [sym_interface_declaration] = STATE(891),
    [sym_statement_block] = STATE(891),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(891),
    [sym_debugger_statement] = STATE(891),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(891),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(891),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(891),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(891),
    [sym_empty_statement] = STATE(891),
    [sym_import_alias] = STATE(891),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(891),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(891),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(891),
    [sym_break_statement] = STATE(891),
    [sym_labeled_statement] = STATE(891),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(891),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [692] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3020),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [693] = {
    [sym_identifier] = ACTIONS(3022),
    [anon_sym_BQUOTE] = ACTIONS(3024),
    [anon_sym_debugger] = ACTIONS(3022),
    [anon_sym_symbol] = ACTIONS(3022),
    [anon_sym_AT] = ACTIONS(3024),
    [anon_sym_COMMA] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3022),
    [anon_sym_void] = ACTIONS(3022),
    [anon_sym_break] = ACTIONS(3022),
    [anon_sym_const] = ACTIONS(3022),
    [sym_super] = ACTIONS(3022),
    [anon_sym_return] = ACTIONS(3022),
    [anon_sym_private] = ACTIONS(3022),
    [anon_sym_get] = ACTIONS(3022),
    [anon_sym_RBRACE] = ACTIONS(3024),
    [anon_sym_interface] = ACTIONS(3022),
    [anon_sym_default] = ACTIONS(3022),
    [anon_sym_enum] = ACTIONS(3022),
    [anon_sym_delete] = ACTIONS(3022),
    [anon_sym_continue] = ACTIONS(3022),
    [anon_sym_DASH_DASH] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3022),
    [anon_sym_this] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3022),
    [sym_true] = ACTIONS(3022),
    [anon_sym_throw] = ACTIONS(3022),
    [anon_sym_protected] = ACTIONS(3022),
    [anon_sym_abstract] = ACTIONS(3022),
    [anon_sym_set] = ACTIONS(3022),
    [anon_sym_type] = ACTIONS(3022),
    [anon_sym_import] = ACTIONS(3022),
    [anon_sym_namespace] = ACTIONS(3022),
    [anon_sym_PLUS_PLUS] = ACTIONS(3024),
    [anon_sym_await] = ACTIONS(3022),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_else] = ACTIONS(3022),
    [anon_sym_BANG] = ACTIONS(3024),
    [anon_sym_for] = ACTIONS(3022),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [sym_false] = ACTIONS(3022),
    [anon_sym_SEMI] = ACTIONS(3024),
    [anon_sym_case] = ACTIONS(3022),
    [anon_sym_module] = ACTIONS(3022),
    [anon_sym_number] = ACTIONS(3022),
    [anon_sym_class] = ACTIONS(3022),
    [anon_sym_declare] = ACTIONS(3022),
    [anon_sym_typeof] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_switch] = ACTIONS(3022),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [sym_null] = ACTIONS(3022),
    [anon_sym_catch] = ACTIONS(3022),
    [anon_sym_any] = ACTIONS(3022),
    [anon_sym_boolean] = ACTIONS(3022),
    [anon_sym_async] = ACTIONS(3022),
    [anon_sym_public] = ACTIONS(3022),
    [anon_sym_var] = ACTIONS(3022),
    [anon_sym_while] = ACTIONS(3022),
    [anon_sym_SQUOTE] = ACTIONS(3024),
    [anon_sym_try] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3024),
    [sym_number] = ACTIONS(3024),
    [anon_sym_SLASH] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(3022),
    [anon_sym_string] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3022),
    [sym_undefined] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3022),
    [ts_builtin_sym_end] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3022),
    [anon_sym_PLUS] = ACTIONS(3022),
    [anon_sym_export] = ACTIONS(3022),
    [anon_sym_do] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3024),
    [anon_sym_with] = ACTIONS(3022),
  },
  [694] = {
    [sym_type_alias_declaration] = STATE(193),
    [aux_sym_export_statement_repeat1] = STATE(685),
    [sym__declaration] = STATE(193),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(193),
    [sym_import_alias] = STATE(193),
    [sym_export_statement] = STATE(193),
    [sym_generator_function] = STATE(193),
    [sym_lexical_declaration] = STATE(193),
    [sym_internal_module] = STATE(193),
    [sym_decorator] = STATE(685),
    [sym_enum_declaration] = STATE(193),
    [sym_function] = STATE(193),
    [sym_function_signature] = STATE(193),
    [sym_variable_declaration] = STATE(193),
    [sym_abstract_class] = STATE(193),
    [sym_module] = STATE(193),
    [sym_interface_declaration] = STATE(193),
    [sym_class] = STATE(193),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(324),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1267),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_declare] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [695] = {
    [sym_type_alias_declaration] = STATE(300),
    [aux_sym_export_statement_repeat1] = STATE(685),
    [sym__declaration] = STATE(300),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(300),
    [sym_import_alias] = STATE(300),
    [sym_export_statement] = STATE(300),
    [sym_generator_function] = STATE(300),
    [sym_export_clause] = STATE(301),
    [sym_lexical_declaration] = STATE(300),
    [sym_internal_module] = STATE(300),
    [sym_decorator] = STATE(685),
    [sym_enum_declaration] = STATE(300),
    [sym_function] = STATE(300),
    [sym_function_signature] = STATE(300),
    [sym_variable_declaration] = STATE(300),
    [sym_abstract_class] = STATE(300),
    [sym_module] = STATE(300),
    [sym_interface_declaration] = STATE(300),
    [sym_class] = STATE(300),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(508),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(511),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_as] = ACTIONS(515),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_declare] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [696] = {
    [sym_type_alias_declaration] = STATE(696),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(696),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(696),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(696),
    [sym_return_statement] = STATE(696),
    [aux_sym_program_repeat1] = STATE(696),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(696),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(696),
    [sym_switch_statement] = STATE(696),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(696),
    [sym_throw_statement] = STATE(696),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(696),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(696),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(696),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(696),
    [sym_abstract_class] = STATE(696),
    [sym_interface_declaration] = STATE(696),
    [sym_statement_block] = STATE(696),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(696),
    [sym_debugger_statement] = STATE(696),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(696),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(696),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(696),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(696),
    [sym_empty_statement] = STATE(696),
    [sym_import_alias] = STATE(696),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(696),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(696),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(696),
    [sym_break_statement] = STATE(696),
    [sym_labeled_statement] = STATE(696),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(696),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(3026),
    [anon_sym_BQUOTE] = ACTIONS(1674),
    [anon_sym_debugger] = ACTIONS(1677),
    [anon_sym_symbol] = ACTIONS(1680),
    [anon_sym_AT] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1686),
    [anon_sym_void] = ACTIONS(1689),
    [anon_sym_break] = ACTIONS(1692),
    [anon_sym_const] = ACTIONS(1695),
    [sym_super] = ACTIONS(1698),
    [anon_sym_return] = ACTIONS(1701),
    [anon_sym_private] = ACTIONS(1680),
    [anon_sym_get] = ACTIONS(1680),
    [anon_sym_RBRACE] = ACTIONS(1812),
    [anon_sym_interface] = ACTIONS(1704),
    [anon_sym_enum] = ACTIONS(1707),
    [anon_sym_delete] = ACTIONS(1710),
    [anon_sym_continue] = ACTIONS(1713),
    [anon_sym_DASH_DASH] = ACTIONS(1716),
    [anon_sym_if] = ACTIONS(3029),
    [anon_sym_this] = ACTIONS(1722),
    [anon_sym_yield] = ACTIONS(1725),
    [sym_true] = ACTIONS(1728),
    [anon_sym_throw] = ACTIONS(1731),
    [anon_sym_protected] = ACTIONS(1680),
    [anon_sym_abstract] = ACTIONS(1734),
    [anon_sym_set] = ACTIONS(1680),
    [anon_sym_type] = ACTIONS(1737),
    [anon_sym_import] = ACTIONS(1740),
    [anon_sym_namespace] = ACTIONS(1743),
    [anon_sym_PLUS_PLUS] = ACTIONS(1716),
    [anon_sym_await] = ACTIONS(1746),
    [anon_sym_DQUOTE] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(1758),
    [sym_false] = ACTIONS(1728),
    [anon_sym_SEMI] = ACTIONS(1761),
    [anon_sym_module] = ACTIONS(1764),
    [anon_sym_number] = ACTIONS(1680),
    [anon_sym_class] = ACTIONS(1767),
    [anon_sym_declare] = ACTIONS(3035),
    [anon_sym_typeof] = ACTIONS(1710),
    [anon_sym_LBRACE] = ACTIONS(1773),
    [anon_sym_switch] = ACTIONS(1776),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [sym_null] = ACTIONS(1728),
    [anon_sym_any] = ACTIONS(1680),
    [anon_sym_boolean] = ACTIONS(1680),
    [anon_sym_async] = ACTIONS(1782),
    [anon_sym_public] = ACTIONS(1680),
    [anon_sym_var] = ACTIONS(1785),
    [anon_sym_while] = ACTIONS(3038),
    [anon_sym_SQUOTE] = ACTIONS(1791),
    [anon_sym_try] = ACTIONS(1794),
    [anon_sym_LT] = ACTIONS(1797),
    [sym_number] = ACTIONS(1800),
    [anon_sym_SLASH] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1680),
    [anon_sym_function] = ACTIONS(1806),
    [sym_undefined] = ACTIONS(1728),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_let] = ACTIONS(1814),
    [anon_sym_PLUS] = ACTIONS(1686),
    [anon_sym_export] = ACTIONS(3041),
    [anon_sym_do] = ACTIONS(1820),
    [anon_sym_TILDE] = ACTIONS(1752),
    [anon_sym_with] = ACTIONS(3044),
  },
  [697] = {
    [aux_sym_export_statement_repeat1] = STATE(320),
    [sym_decorator] = STATE(320),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(3018),
    [anon_sym_class] = ACTIONS(546),
    [sym_comment] = ACTIONS(3),
  },
  [698] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_BANG] = ACTIONS(3049),
    [anon_sym_SEMI] = ACTIONS(3047),
    [anon_sym_BQUOTE] = ACTIONS(3047),
    [sym__automatic_semicolon] = ACTIONS(3047),
    [anon_sym_PIPE] = ACTIONS(3049),
    [anon_sym_COMMA] = ACTIONS(3047),
    [anon_sym_LT_LT] = ACTIONS(3047),
    [anon_sym_STAR] = ACTIONS(3049),
    [anon_sym_GT_GT_GT] = ACTIONS(3047),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_BANG_EQ] = ACTIONS(3049),
    [anon_sym_LT_EQ] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_GT_EQ] = ACTIONS(3047),
    [anon_sym_of] = ACTIONS(3047),
    [anon_sym_GT] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_PERCENT] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3047),
    [anon_sym_RBRACE] = ACTIONS(3047),
    [anon_sym_as] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [anon_sym_EQ_EQ] = ACTIONS(3049),
    [anon_sym_instanceof] = ACTIONS(3047),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_RPAREN] = ACTIONS(3047),
    [anon_sym_SLASH] = ACTIONS(3049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3047),
    [anon_sym_CARET] = ACTIONS(3047),
    [anon_sym_STAR_STAR] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_GT_GT] = ACTIONS(3049),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3047),
    [anon_sym_in] = ACTIONS(3049),
  },
  [699] = {
    [aux_sym_object_repeat1] = STATE(699),
    [anon_sym_COMMA] = ACTIONS(3051),
    [anon_sym_RBRACE] = ACTIONS(2966),
    [sym_comment] = ACTIONS(3),
  },
  [700] = {
    [sym_string] = STATE(1444),
    [sym__property_name] = STATE(1444),
    [sym_computed_property_name] = STATE(1444),
    [anon_sym_get] = ACTIONS(2986),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_async] = ACTIONS(2990),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(2984),
    [anon_sym_STAR] = ACTIONS(2988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(2986),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [sym_readonly] = ACTIONS(3054),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [701] = {
    [aux_sym_object_repeat1] = STATE(699),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
  },
  [702] = {
    [sym_string] = STATE(673),
    [sym__property_name] = STATE(673),
    [sym_computed_property_name] = STATE(673),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(1234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [703] = {
    [anon_sym_LBRACK] = ACTIONS(1238),
    [sym_identifier] = ACTIONS(1236),
    [anon_sym_module] = ACTIONS(1236),
    [anon_sym_symbol] = ACTIONS(1236),
    [anon_sym_number] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1236),
    [anon_sym_STAR] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1236),
    [anon_sym_private] = ACTIONS(1236),
    [anon_sym_boolean] = ACTIONS(1236),
    [anon_sym_async] = ACTIONS(1236),
    [anon_sym_public] = ACTIONS(1236),
    [anon_sym_get] = ACTIONS(1236),
    [anon_sym_static] = ACTIONS(1236),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(1238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1236),
    [anon_sym_string] = ACTIONS(1236),
    [anon_sym_set] = ACTIONS(1236),
    [anon_sym_type] = ACTIONS(1236),
    [anon_sym_import] = ACTIONS(1236),
    [anon_sym_export] = ACTIONS(1236),
    [anon_sym_namespace] = ACTIONS(1236),
    [sym_readonly] = ACTIONS(1236),
    [anon_sym_DQUOTE] = ACTIONS(1238),
  },
  [704] = {
    [sym_type_alias_declaration] = STATE(872),
    [aux_sym_export_statement_repeat1] = STATE(685),
    [sym__declaration] = STATE(872),
    [sym_ambient_declaration] = STATE(872),
    [sym_import_alias] = STATE(872),
    [sym_export_statement] = STATE(872),
    [sym_generator_function] = STATE(872),
    [sym_lexical_declaration] = STATE(872),
    [sym_internal_module] = STATE(872),
    [sym_decorator] = STATE(685),
    [sym_enum_declaration] = STATE(872),
    [sym_function] = STATE(872),
    [sym_function_signature] = STATE(872),
    [sym_variable_declaration] = STATE(872),
    [sym_abstract_class] = STATE(872),
    [sym_module] = STATE(872),
    [sym_interface_declaration] = STATE(872),
    [sym_class] = STATE(872),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_default] = ACTIONS(1826),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(1269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(346),
  },
  [705] = {
    [sym_string] = STATE(673),
    [sym__property_name] = STATE(673),
    [sym_computed_property_name] = STATE(673),
    [anon_sym_get] = ACTIONS(1240),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(1234),
    [anon_sym_STAR] = ACTIONS(1244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1240),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [706] = {
    [aux_sym_export_statement_repeat1] = STATE(706),
    [sym_decorator] = STATE(706),
    [anon_sym_LBRACK] = ACTIONS(1830),
    [sym_identifier] = ACTIONS(3058),
    [anon_sym_module] = ACTIONS(3058),
    [anon_sym_symbol] = ACTIONS(3058),
    [anon_sym_number] = ACTIONS(3058),
    [anon_sym_AT] = ACTIONS(3060),
    [anon_sym_class] = ACTIONS(3058),
    [anon_sym_declare] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(1830),
    [anon_sym_void] = ACTIONS(3058),
    [anon_sym_any] = ACTIONS(3058),
    [anon_sym_private] = ACTIONS(3058),
    [anon_sym_boolean] = ACTIONS(3058),
    [anon_sym_async] = ACTIONS(3058),
    [anon_sym_public] = ACTIONS(3058),
    [anon_sym_get] = ACTIONS(3058),
    [anon_sym_static] = ACTIONS(3058),
    [anon_sym_SQUOTE] = ACTIONS(1830),
    [sym_number] = ACTIONS(1830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3058),
    [anon_sym_string] = ACTIONS(3058),
    [anon_sym_set] = ACTIONS(3058),
    [anon_sym_type] = ACTIONS(3058),
    [anon_sym_import] = ACTIONS(3058),
    [anon_sym_export] = ACTIONS(3058),
    [sym_readonly] = ACTIONS(3058),
    [anon_sym_namespace] = ACTIONS(3058),
    [anon_sym_DQUOTE] = ACTIONS(1830),
  },
  [707] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(711),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(1328),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [708] = {
    [aux_sym_object_repeat1] = STATE(1469),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
  },
  [709] = {
    [sym_new_expression] = STATE(1470),
    [sym_augmented_assignment_expression] = STATE(1470),
    [sym_unary_expression] = STATE(1470),
    [sym_update_expression] = STATE(1470),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(1470),
    [sym_regex] = STATE(1470),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1470),
    [sym_non_null_expression] = STATE(1470),
    [sym_as_expression] = STATE(1470),
    [sym_jsx_fragment] = STATE(1470),
    [sym_yield_expression] = STATE(1470),
    [sym_jsx_element] = STATE(1470),
    [sym_internal_module] = STATE(1470),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1470),
    [sym_await_expression] = STATE(1470),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(1470),
    [sym_this] = STATE(1470),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(1470),
    [sym_generator_function] = STATE(1470),
    [sym_call_expression] = STATE(1470),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(1470),
    [sym_ternary_expression] = STATE(1470),
    [sym_binary_expression] = STATE(1470),
    [sym_template_string] = STATE(1470),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1470),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1470),
    [sym_class] = STATE(1470),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3063),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3065),
    [sym_true] = ACTIONS(3063),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3063),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [710] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(1443),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [711] = {
    [sym_statement_block] = STATE(1471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [712] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1835),
    [anon_sym_LBRACK] = ACTIONS(1835),
    [anon_sym_BANG] = ACTIONS(1837),
    [anon_sym_SEMI] = ACTIONS(1835),
    [anon_sym_BQUOTE] = ACTIONS(1835),
    [sym__automatic_semicolon] = ACTIONS(1835),
    [anon_sym_PIPE] = ACTIONS(1837),
    [anon_sym_COMMA] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(1835),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_GT_GT_GT] = ACTIONS(1835),
    [anon_sym_AMP_AMP] = ACTIONS(1835),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_BANG_EQ] = ACTIONS(1837),
    [anon_sym_LT_EQ] = ACTIONS(1835),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_GT_EQ] = ACTIONS(1835),
    [anon_sym_GT] = ACTIONS(1837),
    [anon_sym_RBRACE] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_PERCENT] = ACTIONS(1835),
    [anon_sym_as] = ACTIONS(1835),
    [anon_sym_PIPE_PIPE] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_EQ_EQ] = ACTIONS(1837),
    [anon_sym_instanceof] = ACTIONS(1835),
    [anon_sym_LT] = ACTIONS(1837),
    [anon_sym_SLASH] = ACTIONS(1837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1835),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_STAR_STAR] = ACTIONS(1835),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_GT_GT] = ACTIONS(1837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1835),
    [anon_sym_in] = ACTIONS(1837),
  },
  [713] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1967),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_BANG] = ACTIONS(1969),
    [anon_sym_SEMI] = ACTIONS(1967),
    [anon_sym_BQUOTE] = ACTIONS(1967),
    [sym__automatic_semicolon] = ACTIONS(1967),
    [anon_sym_PIPE] = ACTIONS(1969),
    [anon_sym_COMMA] = ACTIONS(3072),
    [anon_sym_LT_LT] = ACTIONS(1967),
    [anon_sym_STAR] = ACTIONS(1969),
    [anon_sym_GT_GT_GT] = ACTIONS(1967),
    [anon_sym_AMP_AMP] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1969),
    [anon_sym_BANG_EQ] = ACTIONS(1969),
    [anon_sym_LT_EQ] = ACTIONS(1967),
    [anon_sym_LPAREN] = ACTIONS(1967),
    [anon_sym_GT_EQ] = ACTIONS(1967),
    [anon_sym_GT] = ACTIONS(1969),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [anon_sym_AMP] = ACTIONS(1969),
    [anon_sym_QMARK] = ACTIONS(1967),
    [anon_sym_PERCENT] = ACTIONS(1967),
    [anon_sym_as] = ACTIONS(1967),
    [anon_sym_PIPE_PIPE] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_EQ_EQ] = ACTIONS(1969),
    [anon_sym_instanceof] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1969),
    [anon_sym_SLASH] = ACTIONS(1969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1967),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_STAR_STAR] = ACTIONS(1967),
    [anon_sym_PLUS] = ACTIONS(1969),
    [anon_sym_GT_GT] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1967),
    [anon_sym_in] = ACTIONS(1969),
  },
  [714] = {
    [sym_switch_default] = STATE(1475),
    [aux_sym_switch_body_repeat1] = STATE(1475),
    [sym_switch_case] = STATE(1475),
    [anon_sym_RBRACE] = ACTIONS(3077),
    [anon_sym_default] = ACTIONS(3079),
    [anon_sym_case] = ACTIONS(3081),
    [sym_comment] = ACTIONS(3),
  },
  [715] = {
    [sym_identifier] = ACTIONS(3083),
    [anon_sym_BQUOTE] = ACTIONS(3085),
    [anon_sym_debugger] = ACTIONS(3083),
    [anon_sym_symbol] = ACTIONS(3083),
    [anon_sym_AT] = ACTIONS(3085),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_void] = ACTIONS(3083),
    [anon_sym_break] = ACTIONS(3083),
    [anon_sym_const] = ACTIONS(3083),
    [sym_super] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_private] = ACTIONS(3083),
    [anon_sym_get] = ACTIONS(3083),
    [anon_sym_RBRACE] = ACTIONS(3085),
    [anon_sym_interface] = ACTIONS(3083),
    [anon_sym_default] = ACTIONS(3083),
    [anon_sym_enum] = ACTIONS(3083),
    [anon_sym_delete] = ACTIONS(3083),
    [anon_sym_continue] = ACTIONS(3083),
    [anon_sym_DASH_DASH] = ACTIONS(3085),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_this] = ACTIONS(3083),
    [anon_sym_yield] = ACTIONS(3083),
    [sym_true] = ACTIONS(3083),
    [anon_sym_throw] = ACTIONS(3083),
    [anon_sym_protected] = ACTIONS(3083),
    [anon_sym_abstract] = ACTIONS(3083),
    [anon_sym_set] = ACTIONS(3083),
    [anon_sym_type] = ACTIONS(3083),
    [anon_sym_import] = ACTIONS(3083),
    [anon_sym_namespace] = ACTIONS(3083),
    [anon_sym_PLUS_PLUS] = ACTIONS(3085),
    [anon_sym_await] = ACTIONS(3083),
    [anon_sym_DQUOTE] = ACTIONS(3085),
    [anon_sym_else] = ACTIONS(3083),
    [anon_sym_BANG] = ACTIONS(3085),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [sym_false] = ACTIONS(3083),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym_case] = ACTIONS(3083),
    [anon_sym_module] = ACTIONS(3083),
    [anon_sym_number] = ACTIONS(3083),
    [anon_sym_class] = ACTIONS(3083),
    [anon_sym_declare] = ACTIONS(3083),
    [anon_sym_typeof] = ACTIONS(3083),
    [anon_sym_LBRACE] = ACTIONS(3085),
    [anon_sym_switch] = ACTIONS(3083),
    [anon_sym_LPAREN] = ACTIONS(3085),
    [sym_null] = ACTIONS(3083),
    [anon_sym_any] = ACTIONS(3083),
    [anon_sym_boolean] = ACTIONS(3083),
    [anon_sym_async] = ACTIONS(3083),
    [anon_sym_public] = ACTIONS(3083),
    [anon_sym_var] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_SQUOTE] = ACTIONS(3085),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_LT] = ACTIONS(3085),
    [sym_number] = ACTIONS(3085),
    [anon_sym_SLASH] = ACTIONS(3083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3083),
    [anon_sym_function] = ACTIONS(3083),
    [sym_undefined] = ACTIONS(3083),
    [anon_sym_new] = ACTIONS(3083),
    [ts_builtin_sym_end] = ACTIONS(3085),
    [anon_sym_let] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_export] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_TILDE] = ACTIONS(3085),
    [anon_sym_with] = ACTIONS(3083),
  },
  [716] = {
    [sym_new_expression] = STATE(1476),
    [sym_augmented_assignment_expression] = STATE(1476),
    [sym_unary_expression] = STATE(1476),
    [sym_update_expression] = STATE(1476),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(1476),
    [sym_regex] = STATE(1476),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1233),
    [sym__expression] = STATE(1476),
    [sym_non_null_expression] = STATE(1476),
    [sym_yield_expression] = STATE(1476),
    [sym_jsx_fragment] = STATE(1476),
    [sym_jsx_element] = STATE(1476),
    [sym_as_expression] = STATE(1476),
    [sym_internal_module] = STATE(1476),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1476),
    [sym_await_expression] = STATE(1476),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(1476),
    [sym_this] = STATE(1476),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(1476),
    [sym_generator_function] = STATE(1476),
    [sym_call_expression] = STATE(1476),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(1476),
    [sym_ternary_expression] = STATE(1476),
    [sym_binary_expression] = STATE(1476),
    [sym_template_string] = STATE(1476),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1476),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1476),
    [sym_class] = STATE(1476),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3087),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3089),
    [sym_true] = ACTIONS(3087),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3087),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [717] = {
    [sym_new_expression] = STATE(1477),
    [sym_augmented_assignment_expression] = STATE(1477),
    [sym_unary_expression] = STATE(1477),
    [sym_update_expression] = STATE(1477),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(1477),
    [sym_regex] = STATE(1477),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1477),
    [sym_non_null_expression] = STATE(1477),
    [sym_as_expression] = STATE(1477),
    [sym_jsx_fragment] = STATE(1477),
    [sym_yield_expression] = STATE(1477),
    [sym_jsx_element] = STATE(1477),
    [sym_internal_module] = STATE(1477),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1477),
    [sym_await_expression] = STATE(1477),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(1477),
    [sym_this] = STATE(1477),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(1477),
    [sym_generator_function] = STATE(1477),
    [sym_call_expression] = STATE(1477),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(1477),
    [sym_ternary_expression] = STATE(1477),
    [sym_binary_expression] = STATE(1477),
    [sym_template_string] = STATE(1477),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1477),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1477),
    [sym_class] = STATE(1477),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3091),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3093),
    [sym_true] = ACTIONS(3091),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3091),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [718] = {
    [sym__initializer] = STATE(1478),
    [sym_type_annotation] = STATE(1479),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(3099),
    [sym_comment] = ACTIONS(3),
  },
  [719] = {
    [sym_new_expression] = STATE(1480),
    [sym_augmented_assignment_expression] = STATE(1480),
    [sym_unary_expression] = STATE(1480),
    [sym_update_expression] = STATE(1480),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(1480),
    [sym_regex] = STATE(1480),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1480),
    [sym_non_null_expression] = STATE(1480),
    [sym_as_expression] = STATE(1480),
    [sym_jsx_fragment] = STATE(1480),
    [sym_yield_expression] = STATE(1480),
    [sym_jsx_element] = STATE(1480),
    [sym_internal_module] = STATE(1480),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1480),
    [sym_await_expression] = STATE(1480),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(1480),
    [sym_this] = STATE(1480),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(1480),
    [sym_generator_function] = STATE(1480),
    [sym_call_expression] = STATE(1480),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(1480),
    [sym_ternary_expression] = STATE(1480),
    [sym_binary_expression] = STATE(1480),
    [sym_template_string] = STATE(1480),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1480),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1480),
    [sym_class] = STATE(1480),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(3101),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3101),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3103),
    [sym_true] = ACTIONS(3101),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3101),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [720] = {
    [sym_new_expression] = STATE(1481),
    [sym_augmented_assignment_expression] = STATE(1481),
    [sym_unary_expression] = STATE(1481),
    [sym_update_expression] = STATE(1481),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(1481),
    [sym_regex] = STATE(1481),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1481),
    [sym_non_null_expression] = STATE(1481),
    [sym_as_expression] = STATE(1481),
    [sym_jsx_fragment] = STATE(1481),
    [sym_yield_expression] = STATE(1481),
    [sym_jsx_element] = STATE(1481),
    [sym_internal_module] = STATE(1481),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1481),
    [sym_await_expression] = STATE(1481),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(1481),
    [sym_this] = STATE(1481),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(1481),
    [sym_generator_function] = STATE(1481),
    [sym_call_expression] = STATE(1481),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(1481),
    [sym_ternary_expression] = STATE(1481),
    [sym_binary_expression] = STATE(1481),
    [sym_template_string] = STATE(1481),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1481),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1481),
    [sym_class] = STATE(1481),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3105),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3107),
    [sym_true] = ACTIONS(3105),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3105),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [721] = {
    [sym_union_type] = STATE(1487),
    [sym__type] = STATE(1487),
    [sym_constructor_type] = STATE(1487),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1488),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1487),
    [sym_function_type] = STATE(1487),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1489),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3109),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3113),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [722] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_BANG] = ACTIONS(614),
    [anon_sym_BQUOTE] = ACTIONS(612),
    [anon_sym_PIPE] = ACTIONS(614),
    [anon_sym_COMMA] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(612),
    [anon_sym_STAR] = ACTIONS(614),
    [anon_sym_GT_GT_GT] = ACTIONS(612),
    [anon_sym_AMP_AMP] = ACTIONS(612),
    [anon_sym_DASH] = ACTIONS(614),
    [anon_sym_BANG_EQ] = ACTIONS(614),
    [anon_sym_LT_EQ] = ACTIONS(612),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_GT_EQ] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(614),
    [anon_sym_AMP] = ACTIONS(614),
    [anon_sym_PERCENT] = ACTIONS(612),
    [anon_sym_QMARK] = ACTIONS(612),
    [anon_sym_as] = ACTIONS(612),
    [anon_sym_PIPE_PIPE] = ACTIONS(612),
    [anon_sym_DASH_DASH] = ACTIONS(612),
    [anon_sym_EQ_EQ] = ACTIONS(614),
    [anon_sym_RPAREN] = ACTIONS(3119),
    [anon_sym_LT] = ACTIONS(614),
    [anon_sym_instanceof] = ACTIONS(612),
    [anon_sym_SLASH] = ACTIONS(614),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(612),
    [anon_sym_DOT] = ACTIONS(612),
    [anon_sym_CARET] = ACTIONS(612),
    [anon_sym_STAR_STAR] = ACTIONS(612),
    [anon_sym_PLUS] = ACTIONS(614),
    [anon_sym_GT_GT] = ACTIONS(614),
    [anon_sym_PLUS_PLUS] = ACTIONS(612),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(612),
    [anon_sym_in] = ACTIONS(614),
  },
  [723] = {
    [sym__initializer] = STATE(1490),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(3122),
    [anon_sym_COMMA] = ACTIONS(3122),
    [sym_comment] = ACTIONS(3),
  },
  [724] = {
    [sym__initializer] = STATE(1492),
    [sym_type_annotation] = STATE(1493),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(3124),
    [anon_sym_QMARK] = ACTIONS(3126),
    [anon_sym_COMMA] = ACTIONS(3124),
    [sym_comment] = ACTIONS(3),
  },
  [725] = {
    [sym__initializer] = STATE(1490),
    [sym_type_annotation] = STATE(1495),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(3122),
    [anon_sym_QMARK] = ACTIONS(3128),
    [anon_sym_COMMA] = ACTIONS(3122),
    [sym_comment] = ACTIONS(3),
  },
  [726] = {
    [sym__initializer] = STATE(1497),
    [sym_type_annotation] = STATE(1498),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(3130),
    [anon_sym_QMARK] = ACTIONS(3132),
    [anon_sym_COMMA] = ACTIONS(3130),
    [sym_comment] = ACTIONS(3),
  },
  [727] = {
    [sym__initializer] = STATE(1490),
    [sym_type_annotation] = STATE(1495),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(3122),
    [anon_sym_COMMA] = ACTIONS(3122),
    [sym_comment] = ACTIONS(3),
  },
  [728] = {
    [sym__initializer] = STATE(1500),
    [sym_type_annotation] = STATE(1501),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(3134),
    [anon_sym_QMARK] = ACTIONS(3136),
    [anon_sym_COMMA] = ACTIONS(3134),
    [sym_comment] = ACTIONS(3),
  },
  [729] = {
    [sym_new_expression] = STATE(1502),
    [sym_augmented_assignment_expression] = STATE(1502),
    [sym_unary_expression] = STATE(1502),
    [sym_update_expression] = STATE(1502),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(1502),
    [sym_regex] = STATE(1502),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1240),
    [sym__expression] = STATE(1502),
    [sym_non_null_expression] = STATE(1502),
    [sym_yield_expression] = STATE(1502),
    [sym_jsx_fragment] = STATE(1502),
    [sym_jsx_element] = STATE(1502),
    [sym_as_expression] = STATE(1502),
    [sym_internal_module] = STATE(1502),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1502),
    [sym_await_expression] = STATE(1502),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(1502),
    [sym_this] = STATE(1502),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(1502),
    [sym_generator_function] = STATE(1502),
    [sym_call_expression] = STATE(1502),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(1502),
    [sym_ternary_expression] = STATE(1502),
    [sym_binary_expression] = STATE(1502),
    [sym_template_string] = STATE(1502),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1502),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1502),
    [sym_class] = STATE(1502),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3138),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3140),
    [sym_true] = ACTIONS(3138),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3138),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [730] = {
    [sym__initializer] = STATE(1503),
    [sym_type_annotation] = STATE(1504),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(3142),
    [anon_sym_COMMA] = ACTIONS(3142),
    [sym_comment] = ACTIONS(3),
  },
  [731] = {
    [sym_new_expression] = STATE(1505),
    [sym_augmented_assignment_expression] = STATE(1505),
    [sym_unary_expression] = STATE(1505),
    [sym_update_expression] = STATE(1505),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(1505),
    [sym_regex] = STATE(1505),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1505),
    [sym_non_null_expression] = STATE(1505),
    [sym_as_expression] = STATE(1505),
    [sym_jsx_fragment] = STATE(1505),
    [sym_yield_expression] = STATE(1505),
    [sym_jsx_element] = STATE(1505),
    [sym_internal_module] = STATE(1505),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1505),
    [sym_await_expression] = STATE(1505),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(1505),
    [sym_this] = STATE(1505),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(1505),
    [sym_generator_function] = STATE(1505),
    [sym_call_expression] = STATE(1505),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(1505),
    [sym_ternary_expression] = STATE(1505),
    [sym_binary_expression] = STATE(1505),
    [sym_template_string] = STATE(1505),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1505),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1505),
    [sym_class] = STATE(1505),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3144),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3146),
    [sym_true] = ACTIONS(3144),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3144),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [732] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(666),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_BQUOTE] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(668),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_LT_LT] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_GT_GT_GT] = ACTIONS(666),
    [anon_sym_AMP_AMP] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_BANG_EQ] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_QMARK] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(666),
    [anon_sym_PIPE_PIPE] = ACTIONS(666),
    [anon_sym_DASH_DASH] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(668),
    [anon_sym_RPAREN] = ACTIONS(3148),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_instanceof] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(668),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_DOT] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(668),
    [anon_sym_PLUS_PLUS] = ACTIONS(666),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(666),
    [anon_sym_in] = ACTIONS(668),
  },
  [733] = {
    [sym__initializer] = STATE(1506),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(3151),
    [anon_sym_COMMA] = ACTIONS(3151),
    [sym_comment] = ACTIONS(3),
  },
  [734] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_RPAREN] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(3153),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(702),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [735] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_RPAREN] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(3153),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(702),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [736] = {
    [sym_type_annotation] = STATE(1508),
    [anon_sym_COLON] = ACTIONS(3156),
    [anon_sym_RPAREN] = ACTIONS(3158),
    [anon_sym_COMMA] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
  },
  [737] = {
    [anon_sym_EQ_GT] = ACTIONS(3160),
    [sym_comment] = ACTIONS(3),
  },
  [738] = {
    [anon_sym_EQ_GT] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
  },
  [739] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_BQUOTE] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_RPAREN] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_instanceof] = ACTIONS(839),
    [anon_sym_SLASH] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(839),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_in] = ACTIONS(841),
  },
  [740] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1410),
    [anon_sym_COMMA] = ACTIONS(871),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1426),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_instanceof] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(871),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1426),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(1347),
  },
  [741] = {
    [sym__initializer] = STATE(522),
    [sym_arguments] = STATE(1268),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1531),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1529),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1529),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [742] = {
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_RPAREN] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [743] = {
    [sym_new_expression] = STATE(836),
    [sym_augmented_assignment_expression] = STATE(836),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(836),
    [sym_update_expression] = STATE(836),
    [sym_regex] = STATE(836),
    [sym_meta_property] = STATE(836),
    [sym_call_signature] = STATE(835),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(836),
    [sym_non_null_expression] = STATE(836),
    [sym_yield_expression] = STATE(836),
    [sym_jsx_fragment] = STATE(836),
    [sym_jsx_element] = STATE(836),
    [sym_as_expression] = STATE(836),
    [sym_internal_module] = STATE(836),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(836),
    [sym_await_expression] = STATE(836),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(836),
    [sym_this] = STATE(836),
    [sym_arguments] = STATE(1270),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(836),
    [sym_generator_function] = STATE(836),
    [sym_call_expression] = STATE(836),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(836),
    [sym_ternary_expression] = STATE(836),
    [sym_binary_expression] = STATE(836),
    [sym_template_string] = STATE(836),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(836),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(836),
    [sym_class] = STATE(836),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(500),
    [sym_true] = ACTIONS(1545),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [sym_false] = ACTIONS(1545),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [sym_null] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_RPAREN] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [sym_number] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [744] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_arguments] = STATE(1270),
    [sym_call_signature] = STATE(737),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1378),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1378),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1378),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1378),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_protected] = ACTIONS(1378),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(1378),
    [anon_sym_type] = ACTIONS(1378),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(1378),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(1378),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1378),
    [anon_sym_declare] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(1378),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1378),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_public] = ACTIONS(1378),
    [anon_sym_EQ_GT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_RPAREN] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(1378),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [745] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_RPAREN] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [746] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1410),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1426),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(915),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_instanceof] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1426),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(1347),
  },
  [747] = {
    [aux_sym_export_statement_repeat1] = STATE(1512),
    [sym_decorator] = STATE(1512),
    [sym_object] = STATE(769),
    [sym_accessibility_modifier] = STATE(247),
    [sym_required_parameter] = STATE(1513),
    [sym_array] = STATE(771),
    [sym_rest_parameter] = STATE(1513),
    [sym_optional_parameter] = STATE(1513),
    [sym_this] = STATE(772),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_public] = ACTIONS(1446),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(1442),
    [anon_sym_number] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_RPAREN] = ACTIONS(3164),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1446),
    [anon_sym_void] = ACTIONS(1442),
    [anon_sym_string] = ACTIONS(1442),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_any] = ACTIONS(1442),
    [anon_sym_private] = ACTIONS(1446),
    [anon_sym_boolean] = ACTIONS(1442),
    [anon_sym_async] = ACTIONS(1442),
  },
  [748] = {
    [anon_sym_COLON] = ACTIONS(3166),
    [anon_sym_EQ_GT] = ACTIONS(3166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3166),
  },
  [749] = {
    [aux_sym_formal_parameters_repeat1] = STATE(1515),
    [anon_sym_COMMA] = ACTIONS(3168),
    [anon_sym_RPAREN] = ACTIONS(3164),
    [sym_comment] = ACTIONS(3),
  },
  [750] = {
    [sym_new_expression] = STATE(1516),
    [sym_augmented_assignment_expression] = STATE(1516),
    [sym_unary_expression] = STATE(1516),
    [sym_update_expression] = STATE(1516),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(1516),
    [sym_regex] = STATE(1516),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1516),
    [sym_non_null_expression] = STATE(1516),
    [sym_as_expression] = STATE(1516),
    [sym_jsx_fragment] = STATE(1516),
    [sym_yield_expression] = STATE(1516),
    [sym_jsx_element] = STATE(1516),
    [sym_internal_module] = STATE(1516),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1516),
    [sym_await_expression] = STATE(1516),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(1516),
    [sym_this] = STATE(1516),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(1516),
    [sym_generator_function] = STATE(1516),
    [sym_call_expression] = STATE(1516),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(1516),
    [sym_ternary_expression] = STATE(1516),
    [sym_binary_expression] = STATE(1516),
    [sym_template_string] = STATE(1516),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1516),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1516),
    [sym_class] = STATE(1516),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3170),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3172),
    [sym_true] = ACTIONS(3170),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3170),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [751] = {
    [sym_new_expression] = STATE(1517),
    [sym_augmented_assignment_expression] = STATE(1517),
    [sym_unary_expression] = STATE(1517),
    [sym_update_expression] = STATE(1517),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(1517),
    [sym_regex] = STATE(1517),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1517),
    [sym_non_null_expression] = STATE(1517),
    [sym_as_expression] = STATE(1517),
    [sym_jsx_fragment] = STATE(1517),
    [sym_yield_expression] = STATE(1517),
    [sym_jsx_element] = STATE(1517),
    [sym_internal_module] = STATE(1517),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1517),
    [sym_await_expression] = STATE(1517),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(1517),
    [sym_this] = STATE(1517),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(1517),
    [sym_generator_function] = STATE(1517),
    [sym_call_expression] = STATE(1517),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(1517),
    [sym_ternary_expression] = STATE(1517),
    [sym_binary_expression] = STATE(1517),
    [sym_template_string] = STATE(1517),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1517),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1517),
    [sym_class] = STATE(1517),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(3174),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3174),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3176),
    [sym_true] = ACTIONS(3174),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3174),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [752] = {
    [sym_new_expression] = STATE(1518),
    [sym_augmented_assignment_expression] = STATE(1518),
    [sym_unary_expression] = STATE(1518),
    [sym_update_expression] = STATE(1518),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(1518),
    [sym_regex] = STATE(1518),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1518),
    [sym_non_null_expression] = STATE(1518),
    [sym_as_expression] = STATE(1518),
    [sym_jsx_fragment] = STATE(1518),
    [sym_yield_expression] = STATE(1518),
    [sym_jsx_element] = STATE(1518),
    [sym_internal_module] = STATE(1518),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1518),
    [sym_await_expression] = STATE(1518),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(1518),
    [sym_this] = STATE(1518),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(1518),
    [sym_generator_function] = STATE(1518),
    [sym_call_expression] = STATE(1518),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(1518),
    [sym_ternary_expression] = STATE(1518),
    [sym_binary_expression] = STATE(1518),
    [sym_template_string] = STATE(1518),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1518),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1518),
    [sym_class] = STATE(1518),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3178),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3180),
    [sym_true] = ACTIONS(3178),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3178),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [753] = {
    [sym_new_expression] = STATE(1519),
    [sym_augmented_assignment_expression] = STATE(1519),
    [sym_unary_expression] = STATE(1519),
    [sym_update_expression] = STATE(1519),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(1519),
    [sym_regex] = STATE(1519),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1519),
    [sym_non_null_expression] = STATE(1519),
    [sym_as_expression] = STATE(1519),
    [sym_jsx_fragment] = STATE(1519),
    [sym_yield_expression] = STATE(1519),
    [sym_jsx_element] = STATE(1519),
    [sym_internal_module] = STATE(1519),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1519),
    [sym_await_expression] = STATE(1519),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(1519),
    [sym_this] = STATE(1519),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(1519),
    [sym_generator_function] = STATE(1519),
    [sym_call_expression] = STATE(1519),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(1519),
    [sym_ternary_expression] = STATE(1519),
    [sym_binary_expression] = STATE(1519),
    [sym_template_string] = STATE(1519),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1519),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1519),
    [sym_class] = STATE(1519),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3182),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3184),
    [sym_true] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3182),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [754] = {
    [sym_new_expression] = STATE(1520),
    [sym_augmented_assignment_expression] = STATE(1520),
    [sym_unary_expression] = STATE(1520),
    [sym_update_expression] = STATE(1520),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(1520),
    [sym_regex] = STATE(1520),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1520),
    [sym_non_null_expression] = STATE(1520),
    [sym_as_expression] = STATE(1520),
    [sym_jsx_fragment] = STATE(1520),
    [sym_yield_expression] = STATE(1520),
    [sym_jsx_element] = STATE(1520),
    [sym_internal_module] = STATE(1520),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1520),
    [sym_await_expression] = STATE(1520),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(1521),
    [sym_string] = STATE(1520),
    [sym_this] = STATE(1520),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(1520),
    [sym_generator_function] = STATE(1520),
    [sym_call_expression] = STATE(1520),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(1520),
    [sym_ternary_expression] = STATE(1520),
    [sym_binary_expression] = STATE(1520),
    [sym_template_string] = STATE(1520),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1520),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1520),
    [sym_class] = STATE(1520),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(3186),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3186),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3188),
    [sym_true] = ACTIONS(3186),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3186),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [755] = {
    [sym_new_expression] = STATE(1522),
    [sym_augmented_assignment_expression] = STATE(1522),
    [sym_unary_expression] = STATE(1522),
    [sym_update_expression] = STATE(1522),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(1522),
    [sym_regex] = STATE(1522),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1522),
    [sym_non_null_expression] = STATE(1522),
    [sym_as_expression] = STATE(1522),
    [sym_jsx_fragment] = STATE(1522),
    [sym_yield_expression] = STATE(1522),
    [sym_jsx_element] = STATE(1522),
    [sym_internal_module] = STATE(1522),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1522),
    [sym_await_expression] = STATE(1522),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(1522),
    [sym_this] = STATE(1522),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(1522),
    [sym_generator_function] = STATE(1522),
    [sym_call_expression] = STATE(1522),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1522),
    [sym_ternary_expression] = STATE(1522),
    [sym_binary_expression] = STATE(1522),
    [sym_template_string] = STATE(1522),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1522),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1522),
    [sym_class] = STATE(1522),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(3190),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3190),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3192),
    [sym_true] = ACTIONS(3190),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3190),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [756] = {
    [sym_union_type] = STATE(1293),
    [sym__type] = STATE(1293),
    [sym_constructor_type] = STATE(1293),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1528),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_template_string] = STATE(1297),
    [sym_intersection_type] = STATE(1293),
    [sym_function_type] = STATE(1293),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1529),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3194),
    [sym_false] = ACTIONS(2643),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_PIPE] = ACTIONS(3196),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_boolean] = ACTIONS(2647),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_QMARK] = ACTIONS(3200),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2669),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_DQUOTE] = ACTIONS(304),
  },
  [757] = {
    [sym_new_expression] = STATE(1477),
    [sym_constructor_type] = STATE(432),
    [sym_augmented_assignment_expression] = STATE(1477),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(1477),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(1477),
    [sym_type_parameters] = STATE(959),
    [sym_array_type] = STATE(436),
    [sym_yield_expression] = STATE(1477),
    [sym_as_expression] = STATE(1477),
    [sym_jsx_fragment] = STATE(1477),
    [sym_internal_module] = STATE(1477),
    [sym_arrow_function] = STATE(1477),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(246),
    [sym_literal_type] = STATE(436),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(1301),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(1477),
    [sym_subscript_expression] = STATE(246),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(1477),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(1477),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(960),
    [sym_function_type] = STATE(432),
    [sym__type] = STATE(432),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(1477),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(1477),
    [sym__expression] = STATE(1477),
    [sym_non_null_expression] = STATE(1477),
    [sym_jsx_element] = STATE(1477),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_await_expression] = STATE(1477),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_this] = STATE(1477),
    [sym_union_type] = STATE(432),
    [sym_anonymous_class] = STATE(1477),
    [sym_call_expression] = STATE(1477),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(1477),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(1477),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(432),
    [sym_parenthesized_expression] = STATE(1477),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1477),
    [sym_class] = STATE(1477),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(3204),
    [sym_false] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(3206),
    [anon_sym_number] = ACTIONS(3206),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(3208),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3210),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_void] = ACTIONS(3212),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [sym_null] = ACTIONS(3091),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3206),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(3206),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2691),
    [sym_true] = ACTIONS(2677),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(2693),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(3206),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3091),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(3214),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(3210),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [758] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3216),
    [anon_sym_LBRACK] = ACTIONS(3216),
    [anon_sym_BANG] = ACTIONS(3218),
    [anon_sym_SEMI] = ACTIONS(3216),
    [anon_sym_BQUOTE] = ACTIONS(3216),
    [sym__automatic_semicolon] = ACTIONS(3216),
    [anon_sym_PIPE] = ACTIONS(3218),
    [anon_sym_COMMA] = ACTIONS(3216),
    [anon_sym_LT_LT] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_GT_GT_GT] = ACTIONS(3216),
    [anon_sym_AMP_AMP] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3218),
    [anon_sym_BANG_EQ] = ACTIONS(3218),
    [anon_sym_LT_EQ] = ACTIONS(3216),
    [anon_sym_LPAREN] = ACTIONS(3216),
    [anon_sym_GT_EQ] = ACTIONS(3216),
    [anon_sym_GT] = ACTIONS(3218),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_PERCENT] = ACTIONS(3216),
    [anon_sym_QMARK] = ACTIONS(3216),
    [anon_sym_RBRACE] = ACTIONS(3216),
    [anon_sym_as] = ACTIONS(3216),
    [anon_sym_PIPE_PIPE] = ACTIONS(3216),
    [anon_sym_DASH_DASH] = ACTIONS(3216),
    [anon_sym_EQ_EQ] = ACTIONS(3218),
    [anon_sym_instanceof] = ACTIONS(3216),
    [anon_sym_LT] = ACTIONS(3218),
    [anon_sym_RPAREN] = ACTIONS(3216),
    [anon_sym_SLASH] = ACTIONS(3218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3216),
    [anon_sym_CARET] = ACTIONS(3216),
    [anon_sym_STAR_STAR] = ACTIONS(3216),
    [anon_sym_PLUS] = ACTIONS(3218),
    [anon_sym_GT_GT] = ACTIONS(3218),
    [anon_sym_PLUS_PLUS] = ACTIONS(3216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3216),
    [anon_sym_in] = ACTIONS(3218),
  },
  [759] = {
    [sym_union_type] = STATE(1537),
    [sym__type] = STATE(1537),
    [sym_constructor_type] = STATE(1537),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1108),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1537),
    [sym_function_type] = STATE(1537),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1109),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2282),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [760] = {
    [sym_new_expression] = STATE(1538),
    [sym_augmented_assignment_expression] = STATE(1538),
    [sym_unary_expression] = STATE(1538),
    [sym_update_expression] = STATE(1538),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(1538),
    [sym_regex] = STATE(1538),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1538),
    [sym_non_null_expression] = STATE(1538),
    [sym_as_expression] = STATE(1538),
    [sym_jsx_fragment] = STATE(1538),
    [sym_yield_expression] = STATE(1538),
    [sym_jsx_element] = STATE(1538),
    [sym_internal_module] = STATE(1538),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1538),
    [sym_await_expression] = STATE(1538),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(1538),
    [sym_this] = STATE(1538),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(1538),
    [sym_generator_function] = STATE(1538),
    [sym_call_expression] = STATE(1538),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(1538),
    [sym_ternary_expression] = STATE(1538),
    [sym_binary_expression] = STATE(1538),
    [sym_template_string] = STATE(1538),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1538),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1538),
    [sym_class] = STATE(1538),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(3222),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3222),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3224),
    [sym_true] = ACTIONS(3222),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3222),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [761] = {
    [anon_sym_RPAREN] = ACTIONS(3226),
    [sym_comment] = ACTIONS(3),
  },
  [762] = {
    [sym_array] = STATE(1542),
    [sym_this] = STATE(1543),
    [sym_object] = STATE(1544),
    [anon_sym_get] = ACTIONS(3228),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(3230),
    [anon_sym_module] = ACTIONS(3228),
    [anon_sym_symbol] = ACTIONS(3228),
    [anon_sym_number] = ACTIONS(3228),
    [anon_sym_declare] = ACTIONS(3228),
    [anon_sym_this] = ACTIONS(294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_string] = ACTIONS(3228),
    [anon_sym_set] = ACTIONS(3228),
    [anon_sym_type] = ACTIONS(3228),
    [anon_sym_import] = ACTIONS(3228),
    [anon_sym_export] = ACTIONS(3228),
    [anon_sym_namespace] = ACTIONS(3228),
    [anon_sym_any] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_boolean] = ACTIONS(3228),
    [anon_sym_async] = ACTIONS(3228),
    [anon_sym_public] = ACTIONS(3228),
  },
  [763] = {
    [sym_new_expression] = STATE(1545),
    [sym_augmented_assignment_expression] = STATE(1545),
    [sym_unary_expression] = STATE(1545),
    [sym_update_expression] = STATE(1545),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(1545),
    [sym_regex] = STATE(1545),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1545),
    [sym_non_null_expression] = STATE(1545),
    [sym_as_expression] = STATE(1545),
    [sym_jsx_fragment] = STATE(1545),
    [sym_yield_expression] = STATE(1545),
    [sym_jsx_element] = STATE(1545),
    [sym_internal_module] = STATE(1545),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1545),
    [sym_await_expression] = STATE(1545),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(1545),
    [sym_this] = STATE(1545),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(1545),
    [sym_generator_function] = STATE(1545),
    [sym_call_expression] = STATE(1545),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(1545),
    [sym_ternary_expression] = STATE(1545),
    [sym_binary_expression] = STATE(1545),
    [sym_template_string] = STATE(1545),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1545),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1545),
    [sym_class] = STATE(1545),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(3232),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3232),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3234),
    [sym_true] = ACTIONS(3232),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3232),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [764] = {
    [anon_sym_COMMA] = ACTIONS(3122),
    [anon_sym_RPAREN] = ACTIONS(3122),
    [sym_comment] = ACTIONS(3),
  },
  [765] = {
    [sym__initializer] = STATE(1546),
    [sym_type_annotation] = STATE(733),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(3236),
    [anon_sym_QMARK] = ACTIONS(3238),
    [anon_sym_COMMA] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
  },
  [766] = {
    [sym__initializer] = STATE(764),
    [sym_type_annotation] = STATE(723),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(3240),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_COMMA] = ACTIONS(3240),
    [sym_comment] = ACTIONS(3),
  },
  [767] = {
    [sym__initializer] = STATE(1546),
    [sym_type_annotation] = STATE(733),
    [anon_sym_LBRACK] = ACTIONS(1238),
    [sym_identifier] = ACTIONS(1236),
    [anon_sym_module] = ACTIONS(1236),
    [anon_sym_symbol] = ACTIONS(1236),
    [anon_sym_number] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1236),
    [anon_sym_COMMA] = ACTIONS(3236),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_void] = ACTIONS(1236),
    [anon_sym_any] = ACTIONS(1236),
    [anon_sym_private] = ACTIONS(1236),
    [anon_sym_boolean] = ACTIONS(1236),
    [anon_sym_async] = ACTIONS(1236),
    [anon_sym_public] = ACTIONS(1236),
    [anon_sym_get] = ACTIONS(1236),
    [anon_sym_QMARK] = ACTIONS(3238),
    [anon_sym_RPAREN] = ACTIONS(3236),
    [anon_sym_this] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_protected] = ACTIONS(1236),
    [anon_sym_string] = ACTIONS(1236),
    [anon_sym_set] = ACTIONS(1236),
    [anon_sym_type] = ACTIONS(1236),
    [anon_sym_import] = ACTIONS(1236),
    [anon_sym_export] = ACTIONS(1236),
    [sym_readonly] = ACTIONS(1236),
    [anon_sym_namespace] = ACTIONS(1236),
  },
  [768] = {
    [aux_sym_export_statement_repeat1] = STATE(768),
    [sym_decorator] = STATE(768),
    [anon_sym_get] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(1830),
    [sym_identifier] = ACTIONS(3058),
    [sym_readonly] = ACTIONS(3058),
    [anon_sym_module] = ACTIONS(3058),
    [anon_sym_symbol] = ACTIONS(3058),
    [anon_sym_number] = ACTIONS(3058),
    [anon_sym_class] = ACTIONS(3058),
    [anon_sym_AT] = ACTIONS(1832),
    [anon_sym_this] = ACTIONS(3058),
    [anon_sym_declare] = ACTIONS(3058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1830),
    [anon_sym_LBRACE] = ACTIONS(1830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(3058),
    [anon_sym_protected] = ACTIONS(3058),
    [anon_sym_string] = ACTIONS(3058),
    [anon_sym_set] = ACTIONS(3058),
    [anon_sym_type] = ACTIONS(3058),
    [anon_sym_import] = ACTIONS(3058),
    [anon_sym_export] = ACTIONS(3058),
    [anon_sym_namespace] = ACTIONS(3058),
    [anon_sym_any] = ACTIONS(3058),
    [anon_sym_private] = ACTIONS(3058),
    [anon_sym_boolean] = ACTIONS(3058),
    [anon_sym_async] = ACTIONS(3058),
    [anon_sym_public] = ACTIONS(3058),
  },
  [769] = {
    [sym__initializer] = STATE(1547),
    [sym_type_annotation] = STATE(775),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(3244),
    [anon_sym_QMARK] = ACTIONS(3246),
    [anon_sym_COMMA] = ACTIONS(3244),
    [sym_comment] = ACTIONS(3),
  },
  [770] = {
    [aux_sym_formal_parameters_repeat1] = STATE(1548),
    [anon_sym_COMMA] = ACTIONS(3168),
    [anon_sym_RPAREN] = ACTIONS(3164),
    [sym_comment] = ACTIONS(3),
  },
  [771] = {
    [sym__initializer] = STATE(1549),
    [sym_type_annotation] = STATE(778),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(3248),
    [anon_sym_QMARK] = ACTIONS(3250),
    [anon_sym_COMMA] = ACTIONS(3248),
    [sym_comment] = ACTIONS(3),
  },
  [772] = {
    [sym__initializer] = STATE(764),
    [sym_type_annotation] = STATE(723),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(3240),
    [anon_sym_COMMA] = ACTIONS(3240),
    [sym_comment] = ACTIONS(3),
  },
  [773] = {
    [sym__initializer] = STATE(1550),
    [sym_type_annotation] = STATE(1551),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(3252),
    [anon_sym_COMMA] = ACTIONS(3252),
    [sym_comment] = ACTIONS(3),
  },
  [774] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1835),
    [anon_sym_LBRACK] = ACTIONS(1835),
    [anon_sym_BANG] = ACTIONS(1837),
    [anon_sym_BQUOTE] = ACTIONS(1835),
    [anon_sym_PIPE] = ACTIONS(1837),
    [anon_sym_COMMA] = ACTIONS(3254),
    [anon_sym_LT_LT] = ACTIONS(1835),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_GT_GT_GT] = ACTIONS(1835),
    [anon_sym_AMP_AMP] = ACTIONS(1835),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_BANG_EQ] = ACTIONS(1837),
    [anon_sym_LT_EQ] = ACTIONS(1835),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_GT_EQ] = ACTIONS(1835),
    [anon_sym_GT] = ACTIONS(1837),
    [anon_sym_AMP] = ACTIONS(1837),
    [anon_sym_PERCENT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_as] = ACTIONS(1835),
    [anon_sym_PIPE_PIPE] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_EQ_EQ] = ACTIONS(1837),
    [anon_sym_RPAREN] = ACTIONS(3254),
    [anon_sym_LT] = ACTIONS(1837),
    [anon_sym_instanceof] = ACTIONS(1835),
    [anon_sym_SLASH] = ACTIONS(1837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_DOT] = ACTIONS(1835),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_STAR_STAR] = ACTIONS(1835),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_GT_GT] = ACTIONS(1837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1835),
    [anon_sym_in] = ACTIONS(1837),
  },
  [775] = {
    [sym__initializer] = STATE(1552),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(3257),
    [anon_sym_COMMA] = ACTIONS(3257),
    [sym_comment] = ACTIONS(3),
  },
  [776] = {
    [sym__initializer] = STATE(1553),
    [sym_type_annotation] = STATE(1554),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(3259),
    [anon_sym_COMMA] = ACTIONS(3259),
    [sym_comment] = ACTIONS(3),
  },
  [777] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1967),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_BANG] = ACTIONS(1969),
    [anon_sym_BQUOTE] = ACTIONS(1967),
    [anon_sym_PIPE] = ACTIONS(1969),
    [anon_sym_COMMA] = ACTIONS(3261),
    [anon_sym_LT_LT] = ACTIONS(1967),
    [anon_sym_STAR] = ACTIONS(1969),
    [anon_sym_GT_GT_GT] = ACTIONS(1967),
    [anon_sym_AMP_AMP] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1969),
    [anon_sym_BANG_EQ] = ACTIONS(1969),
    [anon_sym_LT_EQ] = ACTIONS(1967),
    [anon_sym_LPAREN] = ACTIONS(1967),
    [anon_sym_GT_EQ] = ACTIONS(1967),
    [anon_sym_GT] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(1969),
    [anon_sym_PERCENT] = ACTIONS(1967),
    [anon_sym_QMARK] = ACTIONS(1967),
    [anon_sym_as] = ACTIONS(1967),
    [anon_sym_PIPE_PIPE] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_EQ_EQ] = ACTIONS(1969),
    [anon_sym_RPAREN] = ACTIONS(3261),
    [anon_sym_LT] = ACTIONS(1969),
    [anon_sym_instanceof] = ACTIONS(1967),
    [anon_sym_SLASH] = ACTIONS(1969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1967),
    [anon_sym_DOT] = ACTIONS(1967),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_STAR_STAR] = ACTIONS(1967),
    [anon_sym_PLUS] = ACTIONS(1969),
    [anon_sym_GT_GT] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1967),
    [anon_sym_in] = ACTIONS(1969),
  },
  [778] = {
    [sym__initializer] = STATE(1555),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(3264),
    [anon_sym_COMMA] = ACTIONS(3264),
    [sym_comment] = ACTIONS(3),
  },
  [779] = {
    [sym_new_expression] = STATE(1557),
    [sym_augmented_assignment_expression] = STATE(1557),
    [sym_unary_expression] = STATE(1557),
    [sym_update_expression] = STATE(1557),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(1557),
    [sym_regex] = STATE(1557),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1556),
    [sym__expression] = STATE(1557),
    [sym_non_null_expression] = STATE(1557),
    [sym_yield_expression] = STATE(1557),
    [sym_jsx_fragment] = STATE(1557),
    [sym_jsx_element] = STATE(1557),
    [sym_as_expression] = STATE(1557),
    [sym_internal_module] = STATE(1557),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1557),
    [sym_await_expression] = STATE(1557),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(1557),
    [sym_this] = STATE(1557),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(1557),
    [sym_generator_function] = STATE(1557),
    [sym_call_expression] = STATE(1557),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(1557),
    [sym_ternary_expression] = STATE(1557),
    [sym_binary_expression] = STATE(1557),
    [sym_template_string] = STATE(1557),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1557),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(1557),
    [sym_class] = STATE(1557),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3266),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3268),
    [sym_true] = ACTIONS(3266),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3266),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [780] = {
    [sym_new_expression] = STATE(1559),
    [sym_augmented_assignment_expression] = STATE(1559),
    [sym_unary_expression] = STATE(1559),
    [sym_update_expression] = STATE(1559),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(1559),
    [sym_regex] = STATE(1559),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1558),
    [sym__expression] = STATE(1559),
    [sym_non_null_expression] = STATE(1559),
    [sym_yield_expression] = STATE(1559),
    [sym_jsx_fragment] = STATE(1559),
    [sym_jsx_element] = STATE(1559),
    [sym_as_expression] = STATE(1559),
    [sym_internal_module] = STATE(1559),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1559),
    [sym_await_expression] = STATE(1559),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(1559),
    [sym_this] = STATE(1559),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(1559),
    [sym_generator_function] = STATE(1559),
    [sym_call_expression] = STATE(1559),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(1559),
    [sym_ternary_expression] = STATE(1559),
    [sym_binary_expression] = STATE(1559),
    [sym_template_string] = STATE(1559),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1559),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(1559),
    [sym_class] = STATE(1559),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(3270),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3270),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3272),
    [sym_true] = ACTIONS(3270),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3270),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [781] = {
    [aux_sym_export_statement_repeat1] = STATE(1560),
    [sym_decorator] = STATE(1560),
    [sym_object] = STATE(769),
    [sym_accessibility_modifier] = STATE(247),
    [sym_required_parameter] = STATE(770),
    [sym_array] = STATE(771),
    [sym_rest_parameter] = STATE(770),
    [sym_optional_parameter] = STATE(770),
    [sym_this] = STATE(772),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_public] = ACTIONS(1446),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(1442),
    [anon_sym_number] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1446),
    [anon_sym_void] = ACTIONS(1442),
    [anon_sym_string] = ACTIONS(1442),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_any] = ACTIONS(1442),
    [anon_sym_private] = ACTIONS(1446),
    [anon_sym_boolean] = ACTIONS(1442),
    [anon_sym_async] = ACTIONS(1442),
  },
  [782] = {
    [sym_default_type] = STATE(807),
    [sym_constraint] = STATE(806),
    [anon_sym_GT] = ACTIONS(1507),
    [anon_sym_EQ] = ACTIONS(1490),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_extends] = ACTIONS(3274),
    [anon_sym_COMMA] = ACTIONS(1507),
    [sym_comment] = ACTIONS(3),
  },
  [783] = {
    [sym_type_parameters] = STATE(815),
    [sym_formal_parameters] = STATE(816),
    [sym_call_signature] = STATE(1561),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [784] = {
    [sym_statement_block] = STATE(1562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(909),
  },
  [785] = {
    [sym_identifier] = ACTIONS(3276),
    [anon_sym_BQUOTE] = ACTIONS(3278),
    [anon_sym_debugger] = ACTIONS(3276),
    [anon_sym_symbol] = ACTIONS(3276),
    [anon_sym_AT] = ACTIONS(3278),
    [anon_sym_DASH] = ACTIONS(3276),
    [anon_sym_void] = ACTIONS(3276),
    [anon_sym_break] = ACTIONS(3276),
    [anon_sym_const] = ACTIONS(3276),
    [sym_super] = ACTIONS(3276),
    [anon_sym_return] = ACTIONS(3276),
    [anon_sym_private] = ACTIONS(3276),
    [anon_sym_get] = ACTIONS(3276),
    [anon_sym_RBRACE] = ACTIONS(3278),
    [anon_sym_interface] = ACTIONS(3276),
    [anon_sym_default] = ACTIONS(3276),
    [anon_sym_enum] = ACTIONS(3276),
    [anon_sym_delete] = ACTIONS(3276),
    [anon_sym_continue] = ACTIONS(3276),
    [anon_sym_DASH_DASH] = ACTIONS(3278),
    [anon_sym_if] = ACTIONS(3276),
    [anon_sym_this] = ACTIONS(3276),
    [anon_sym_yield] = ACTIONS(3276),
    [sym_true] = ACTIONS(3276),
    [anon_sym_throw] = ACTIONS(3276),
    [anon_sym_protected] = ACTIONS(3276),
    [anon_sym_abstract] = ACTIONS(3276),
    [anon_sym_set] = ACTIONS(3276),
    [anon_sym_type] = ACTIONS(3276),
    [anon_sym_import] = ACTIONS(3276),
    [anon_sym_namespace] = ACTIONS(3276),
    [anon_sym_PLUS_PLUS] = ACTIONS(3278),
    [anon_sym_await] = ACTIONS(3276),
    [anon_sym_DQUOTE] = ACTIONS(3278),
    [anon_sym_else] = ACTIONS(3276),
    [anon_sym_BANG] = ACTIONS(3278),
    [anon_sym_for] = ACTIONS(3276),
    [anon_sym_LBRACK] = ACTIONS(3278),
    [sym_false] = ACTIONS(3276),
    [anon_sym_SEMI] = ACTIONS(3278),
    [anon_sym_case] = ACTIONS(3276),
    [anon_sym_module] = ACTIONS(3276),
    [anon_sym_number] = ACTIONS(3276),
    [anon_sym_class] = ACTIONS(3276),
    [anon_sym_declare] = ACTIONS(3276),
    [anon_sym_typeof] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3278),
    [anon_sym_switch] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3278),
    [sym_null] = ACTIONS(3276),
    [anon_sym_any] = ACTIONS(3276),
    [anon_sym_boolean] = ACTIONS(3276),
    [anon_sym_async] = ACTIONS(3276),
    [anon_sym_public] = ACTIONS(3276),
    [anon_sym_var] = ACTIONS(3276),
    [anon_sym_while] = ACTIONS(3276),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [anon_sym_try] = ACTIONS(3276),
    [anon_sym_LT] = ACTIONS(3278),
    [sym_number] = ACTIONS(3278),
    [anon_sym_SLASH] = ACTIONS(3276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3276),
    [anon_sym_function] = ACTIONS(3276),
    [sym_undefined] = ACTIONS(3276),
    [anon_sym_new] = ACTIONS(3276),
    [ts_builtin_sym_end] = ACTIONS(3278),
    [anon_sym_let] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3276),
    [anon_sym_export] = ACTIONS(3276),
    [anon_sym_do] = ACTIONS(3276),
    [anon_sym_TILDE] = ACTIONS(3278),
    [anon_sym_with] = ACTIONS(3276),
  },
  [786] = {
    [aux_sym_variable_declaration_repeat1] = STATE(1048),
    [sym__automatic_semicolon] = ACTIONS(3280),
    [anon_sym_SEMI] = ACTIONS(3280),
    [anon_sym_COMMA] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
  },
  [787] = {
    [sym_identifier] = ACTIONS(3282),
    [anon_sym_BQUOTE] = ACTIONS(3284),
    [anon_sym_debugger] = ACTIONS(3282),
    [anon_sym_symbol] = ACTIONS(3282),
    [anon_sym_AT] = ACTIONS(3284),
    [anon_sym_DASH] = ACTIONS(3282),
    [anon_sym_void] = ACTIONS(3282),
    [anon_sym_break] = ACTIONS(3282),
    [anon_sym_const] = ACTIONS(3282),
    [sym_super] = ACTIONS(3282),
    [anon_sym_return] = ACTIONS(3282),
    [anon_sym_private] = ACTIONS(3282),
    [anon_sym_get] = ACTIONS(3282),
    [anon_sym_RBRACE] = ACTIONS(3284),
    [anon_sym_interface] = ACTIONS(3282),
    [anon_sym_default] = ACTIONS(3282),
    [anon_sym_enum] = ACTIONS(3282),
    [anon_sym_delete] = ACTIONS(3282),
    [anon_sym_continue] = ACTIONS(3282),
    [anon_sym_DASH_DASH] = ACTIONS(3284),
    [anon_sym_if] = ACTIONS(3282),
    [anon_sym_this] = ACTIONS(3282),
    [anon_sym_yield] = ACTIONS(3282),
    [sym_true] = ACTIONS(3282),
    [anon_sym_throw] = ACTIONS(3282),
    [anon_sym_protected] = ACTIONS(3282),
    [anon_sym_abstract] = ACTIONS(3282),
    [anon_sym_set] = ACTIONS(3282),
    [anon_sym_type] = ACTIONS(3282),
    [anon_sym_import] = ACTIONS(3282),
    [anon_sym_namespace] = ACTIONS(3282),
    [anon_sym_PLUS_PLUS] = ACTIONS(3284),
    [anon_sym_await] = ACTIONS(3282),
    [anon_sym_DQUOTE] = ACTIONS(3284),
    [anon_sym_else] = ACTIONS(3282),
    [anon_sym_BANG] = ACTIONS(3284),
    [anon_sym_for] = ACTIONS(3282),
    [anon_sym_LBRACK] = ACTIONS(3284),
    [sym_false] = ACTIONS(3282),
    [anon_sym_SEMI] = ACTIONS(3284),
    [anon_sym_case] = ACTIONS(3282),
    [anon_sym_module] = ACTIONS(3282),
    [anon_sym_number] = ACTIONS(3282),
    [anon_sym_class] = ACTIONS(3282),
    [anon_sym_declare] = ACTIONS(3282),
    [anon_sym_typeof] = ACTIONS(3282),
    [anon_sym_LBRACE] = ACTIONS(3284),
    [anon_sym_switch] = ACTIONS(3282),
    [anon_sym_LPAREN] = ACTIONS(3284),
    [sym_null] = ACTIONS(3282),
    [anon_sym_any] = ACTIONS(3282),
    [anon_sym_boolean] = ACTIONS(3282),
    [anon_sym_async] = ACTIONS(3282),
    [anon_sym_public] = ACTIONS(3282),
    [anon_sym_var] = ACTIONS(3282),
    [anon_sym_while] = ACTIONS(3282),
    [anon_sym_SQUOTE] = ACTIONS(3284),
    [anon_sym_try] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(3284),
    [sym_number] = ACTIONS(3284),
    [anon_sym_SLASH] = ACTIONS(3282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3282),
    [anon_sym_function] = ACTIONS(3282),
    [sym_undefined] = ACTIONS(3282),
    [anon_sym_new] = ACTIONS(3282),
    [ts_builtin_sym_end] = ACTIONS(3284),
    [anon_sym_let] = ACTIONS(3282),
    [anon_sym_PLUS] = ACTIONS(3282),
    [anon_sym_export] = ACTIONS(3282),
    [anon_sym_do] = ACTIONS(3282),
    [anon_sym_TILDE] = ACTIONS(3284),
    [anon_sym_with] = ACTIONS(3282),
  },
  [788] = {
    [aux_sym_string_repeat2] = STATE(788),
    [sym_escape_sequence] = ACTIONS(3286),
    [aux_sym_string_token2] = ACTIONS(3286),
    [sym_comment] = ACTIONS(246),
    [anon_sym_SQUOTE] = ACTIONS(3289),
  },
  [789] = {
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_BQUOTE] = ACTIONS(1255),
    [anon_sym_debugger] = ACTIONS(1253),
    [anon_sym_symbol] = ACTIONS(1253),
    [anon_sym_AT] = ACTIONS(1255),
    [anon_sym_COMMA] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_break] = ACTIONS(1253),
    [anon_sym_const] = ACTIONS(1253),
    [sym_super] = ACTIONS(1253),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_private] = ACTIONS(1253),
    [anon_sym_get] = ACTIONS(1253),
    [anon_sym_RBRACE] = ACTIONS(1255),
    [anon_sym_interface] = ACTIONS(1253),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_enum] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_continue] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1253),
    [sym_true] = ACTIONS(1253),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_protected] = ACTIONS(1253),
    [anon_sym_abstract] = ACTIONS(1253),
    [anon_sym_set] = ACTIONS(1253),
    [anon_sym_type] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(1253),
    [anon_sym_namespace] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_await] = ACTIONS(1253),
    [anon_sym_DQUOTE] = ACTIONS(1255),
    [anon_sym_else] = ACTIONS(1253),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_for] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(1255),
    [sym_false] = ACTIONS(1253),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym_case] = ACTIONS(1253),
    [anon_sym_module] = ACTIONS(1253),
    [anon_sym_number] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1253),
    [anon_sym_declare] = ACTIONS(1253),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1255),
    [anon_sym_switch] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(1255),
    [sym_null] = ACTIONS(1253),
    [anon_sym_catch] = ACTIONS(1253),
    [anon_sym_any] = ACTIONS(1253),
    [anon_sym_boolean] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_public] = ACTIONS(1253),
    [anon_sym_var] = ACTIONS(1253),
    [anon_sym_while] = ACTIONS(1253),
    [anon_sym_SQUOTE] = ACTIONS(1255),
    [anon_sym_try] = ACTIONS(1253),
    [anon_sym_LT] = ACTIONS(1255),
    [sym_number] = ACTIONS(1255),
    [anon_sym_SLASH] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(1253),
    [anon_sym_string] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1253),
    [sym_undefined] = ACTIONS(1253),
    [anon_sym_new] = ACTIONS(1253),
    [ts_builtin_sym_end] = ACTIONS(1255),
    [anon_sym_let] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_export] = ACTIONS(1253),
    [anon_sym_do] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_with] = ACTIONS(1253),
  },
  [790] = {
    [sym_statement_block] = STATE(1565),
    [anon_sym_LPAREN] = ACTIONS(3291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [791] = {
    [sym_statement_block] = STATE(1566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [792] = {
    [sym_finally_clause] = STATE(1567),
    [sym_identifier] = ACTIONS(3293),
    [anon_sym_BQUOTE] = ACTIONS(3295),
    [anon_sym_debugger] = ACTIONS(3293),
    [anon_sym_symbol] = ACTIONS(3293),
    [anon_sym_AT] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_void] = ACTIONS(3293),
    [anon_sym_break] = ACTIONS(3293),
    [anon_sym_const] = ACTIONS(3293),
    [sym_super] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3293),
    [anon_sym_private] = ACTIONS(3293),
    [anon_sym_get] = ACTIONS(3293),
    [anon_sym_RBRACE] = ACTIONS(3295),
    [anon_sym_interface] = ACTIONS(3293),
    [anon_sym_default] = ACTIONS(3293),
    [anon_sym_enum] = ACTIONS(3293),
    [anon_sym_delete] = ACTIONS(3293),
    [anon_sym_continue] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3295),
    [anon_sym_if] = ACTIONS(3293),
    [anon_sym_this] = ACTIONS(3293),
    [anon_sym_yield] = ACTIONS(3293),
    [sym_true] = ACTIONS(3293),
    [anon_sym_throw] = ACTIONS(3293),
    [anon_sym_protected] = ACTIONS(3293),
    [anon_sym_abstract] = ACTIONS(3293),
    [anon_sym_set] = ACTIONS(3293),
    [anon_sym_type] = ACTIONS(3293),
    [anon_sym_import] = ACTIONS(3293),
    [anon_sym_namespace] = ACTIONS(3293),
    [anon_sym_PLUS_PLUS] = ACTIONS(3295),
    [anon_sym_await] = ACTIONS(3293),
    [anon_sym_DQUOTE] = ACTIONS(3295),
    [anon_sym_else] = ACTIONS(3293),
    [anon_sym_BANG] = ACTIONS(3295),
    [anon_sym_for] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3295),
    [sym_false] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3295),
    [anon_sym_case] = ACTIONS(3293),
    [anon_sym_module] = ACTIONS(3293),
    [anon_sym_number] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_declare] = ACTIONS(3293),
    [anon_sym_typeof] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3295),
    [anon_sym_switch] = ACTIONS(3293),
    [anon_sym_LPAREN] = ACTIONS(3295),
    [sym_null] = ACTIONS(3293),
    [anon_sym_any] = ACTIONS(3293),
    [anon_sym_boolean] = ACTIONS(3293),
    [anon_sym_async] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3293),
    [anon_sym_var] = ACTIONS(3293),
    [anon_sym_while] = ACTIONS(3293),
    [anon_sym_SQUOTE] = ACTIONS(3295),
    [anon_sym_try] = ACTIONS(3293),
    [anon_sym_LT] = ACTIONS(3295),
    [sym_number] = ACTIONS(3295),
    [anon_sym_SLASH] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(1484),
    [anon_sym_string] = ACTIONS(3293),
    [anon_sym_function] = ACTIONS(3293),
    [sym_undefined] = ACTIONS(3293),
    [anon_sym_new] = ACTIONS(3293),
    [ts_builtin_sym_end] = ACTIONS(3295),
    [anon_sym_let] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3293),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_do] = ACTIONS(3293),
    [anon_sym_TILDE] = ACTIONS(3295),
    [anon_sym_with] = ACTIONS(3293),
  },
  [793] = {
    [sym_identifier] = ACTIONS(3293),
    [anon_sym_BQUOTE] = ACTIONS(3295),
    [anon_sym_debugger] = ACTIONS(3293),
    [anon_sym_symbol] = ACTIONS(3293),
    [anon_sym_AT] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_void] = ACTIONS(3293),
    [anon_sym_break] = ACTIONS(3293),
    [anon_sym_const] = ACTIONS(3293),
    [sym_super] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3293),
    [anon_sym_private] = ACTIONS(3293),
    [anon_sym_get] = ACTIONS(3293),
    [anon_sym_RBRACE] = ACTIONS(3295),
    [anon_sym_interface] = ACTIONS(3293),
    [anon_sym_default] = ACTIONS(3293),
    [anon_sym_enum] = ACTIONS(3293),
    [anon_sym_delete] = ACTIONS(3293),
    [anon_sym_continue] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3295),
    [anon_sym_if] = ACTIONS(3293),
    [anon_sym_this] = ACTIONS(3293),
    [anon_sym_yield] = ACTIONS(3293),
    [sym_true] = ACTIONS(3293),
    [anon_sym_throw] = ACTIONS(3293),
    [anon_sym_protected] = ACTIONS(3293),
    [anon_sym_abstract] = ACTIONS(3293),
    [anon_sym_set] = ACTIONS(3293),
    [anon_sym_type] = ACTIONS(3293),
    [anon_sym_import] = ACTIONS(3293),
    [anon_sym_namespace] = ACTIONS(3293),
    [anon_sym_PLUS_PLUS] = ACTIONS(3295),
    [anon_sym_await] = ACTIONS(3293),
    [anon_sym_DQUOTE] = ACTIONS(3295),
    [anon_sym_else] = ACTIONS(3293),
    [anon_sym_BANG] = ACTIONS(3295),
    [anon_sym_for] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3295),
    [sym_false] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3295),
    [anon_sym_case] = ACTIONS(3293),
    [anon_sym_module] = ACTIONS(3293),
    [anon_sym_number] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_declare] = ACTIONS(3293),
    [anon_sym_typeof] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3295),
    [anon_sym_switch] = ACTIONS(3293),
    [anon_sym_LPAREN] = ACTIONS(3295),
    [sym_null] = ACTIONS(3293),
    [anon_sym_any] = ACTIONS(3293),
    [anon_sym_boolean] = ACTIONS(3293),
    [anon_sym_async] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3293),
    [anon_sym_var] = ACTIONS(3293),
    [anon_sym_while] = ACTIONS(3293),
    [anon_sym_SQUOTE] = ACTIONS(3295),
    [anon_sym_try] = ACTIONS(3293),
    [anon_sym_LT] = ACTIONS(3295),
    [sym_number] = ACTIONS(3295),
    [anon_sym_SLASH] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3293),
    [anon_sym_function] = ACTIONS(3293),
    [sym_undefined] = ACTIONS(3293),
    [anon_sym_new] = ACTIONS(3293),
    [ts_builtin_sym_end] = ACTIONS(3295),
    [anon_sym_let] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3293),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_do] = ACTIONS(3293),
    [anon_sym_TILDE] = ACTIONS(3295),
    [anon_sym_with] = ACTIONS(3293),
  },
  [794] = {
    [sym_nested_identifier] = STATE(965),
    [sym_jsx_namespace_name] = STATE(966),
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(3297),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1975),
  },
  [795] = {
    [sym_jsx_opening_element] = STATE(340),
    [aux_sym_jsx_element_repeat1] = STATE(975),
    [sym_jsx_expression] = STATE(975),
    [sym_jsx_self_closing_element] = STATE(975),
    [sym_jsx_element] = STATE(975),
    [sym_jsx_text] = ACTIONS(1993),
    [anon_sym_LT] = ACTIONS(3299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(590),
  },
  [796] = {
    [sym_union_type] = STATE(1570),
    [sym__type] = STATE(1570),
    [sym_constructor_type] = STATE(1570),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1570),
    [sym_function_type] = STATE(1570),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [797] = {
    [anon_sym_COLON] = ACTIONS(1513),
    [sym_identifier] = ACTIONS(3301),
    [anon_sym_EQ] = ACTIONS(3303),
    [sym_jsx_identifier] = ACTIONS(3305),
    [anon_sym_GT] = ACTIONS(3305),
    [anon_sym_SLASH] = ACTIONS(3301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3305),
  },
  [798] = {
    [sym_union_type] = STATE(1578),
    [sym__type] = STATE(1578),
    [sym_constructor_type] = STATE(1578),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1579),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1578),
    [sym_function_type] = STATE(1578),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1580),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3307),
    [sym_false] = ACTIONS(753),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(3309),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(781),
    [sym_jsx_identifier] = ACTIONS(3311),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_boolean] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_this] = ACTIONS(765),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [799] = {
    [sym_union_type] = STATE(1578),
    [sym__type] = STATE(1578),
    [sym_constructor_type] = STATE(1578),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1579),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1578),
    [sym_function_type] = STATE(1578),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1580),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3319),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [800] = {
    [sym_identifier] = ACTIONS(3321),
    [sym_comment] = ACTIONS(3),
  },
  [801] = {
    [sym_jsx_text] = ACTIONS(3323),
    [anon_sym_LT] = ACTIONS(3323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3323),
  },
  [802] = {
    [anon_sym_GT] = ACTIONS(3325),
    [sym_comment] = ACTIONS(3),
  },
  [803] = {
    [sym_new_expression] = STATE(1585),
    [sym_augmented_assignment_expression] = STATE(1585),
    [sym_unary_expression] = STATE(1585),
    [sym_update_expression] = STATE(1585),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(1585),
    [sym_regex] = STATE(1585),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1585),
    [sym_non_null_expression] = STATE(1585),
    [sym_as_expression] = STATE(1585),
    [sym_jsx_fragment] = STATE(1585),
    [sym_yield_expression] = STATE(1585),
    [sym_jsx_element] = STATE(1585),
    [sym_internal_module] = STATE(1585),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1585),
    [sym_await_expression] = STATE(1585),
    [sym_member_expression] = STATE(363),
    [sym_spread_element] = STATE(1586),
    [sym_sequence_expression] = STATE(1586),
    [sym_string] = STATE(1585),
    [sym_this] = STATE(1585),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(1585),
    [sym_generator_function] = STATE(1585),
    [sym_call_expression] = STATE(1585),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(1585),
    [sym_ternary_expression] = STATE(1585),
    [sym_binary_expression] = STATE(1585),
    [sym_template_string] = STATE(1585),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1585),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1585),
    [sym_class] = STATE(1585),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(3327),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3327),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_RBRACE] = ACTIONS(3329),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3331),
    [sym_true] = ACTIONS(3327),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3327),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [804] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(1589),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(1589),
    [sym_jsx_expression] = STATE(1589),
    [anon_sym_GT] = ACTIONS(3333),
    [sym_identifier] = ACTIONS(1492),
    [sym_jsx_identifier] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(3335),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [805] = {
    [anon_sym_GT] = ACTIONS(3337),
    [sym_jsx_identifier] = ACTIONS(3337),
    [sym_identifier] = ACTIONS(3339),
    [anon_sym_EQ] = ACTIONS(3341),
    [anon_sym_SLASH] = ACTIONS(3339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3337),
  },
  [806] = {
    [sym_default_type] = STATE(1591),
    [anon_sym_GT] = ACTIONS(3343),
    [anon_sym_EQ] = ACTIONS(1490),
    [anon_sym_COMMA] = ACTIONS(3343),
    [sym_comment] = ACTIONS(3),
  },
  [807] = {
    [anon_sym_COMMA] = ACTIONS(3343),
    [anon_sym_GT] = ACTIONS(3343),
    [sym_comment] = ACTIONS(3),
  },
  [808] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(1592),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(1592),
    [sym_jsx_expression] = STATE(1592),
    [anon_sym_GT] = ACTIONS(3333),
    [sym_identifier] = ACTIONS(1492),
    [sym_jsx_identifier] = ACTIONS(1500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [809] = {
    [sym_identifier] = ACTIONS(3345),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(3311),
  },
  [810] = {
    [sym_type_parameter] = STATE(1594),
    [anon_sym_GT] = ACTIONS(3347),
    [sym_identifier] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
  },
  [811] = {
    [anon_sym_extends] = ACTIONS(3349),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3349),
    [anon_sym_EQ] = ACTIONS(3349),
    [anon_sym_implements] = ACTIONS(3349),
    [anon_sym_LPAREN] = ACTIONS(3349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3351),
  },
  [812] = {
    [aux_sym_type_parameters_repeat1] = STATE(1596),
    [anon_sym_COMMA] = ACTIONS(3353),
    [anon_sym_GT] = ACTIONS(3347),
    [sym_comment] = ACTIONS(3),
  },
  [813] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_BANG] = ACTIONS(3357),
    [anon_sym_SEMI] = ACTIONS(3355),
    [anon_sym_BQUOTE] = ACTIONS(3355),
    [sym__automatic_semicolon] = ACTIONS(3355),
    [anon_sym_PIPE] = ACTIONS(3357),
    [anon_sym_COMMA] = ACTIONS(3355),
    [anon_sym_LT_LT] = ACTIONS(3355),
    [anon_sym_STAR] = ACTIONS(3357),
    [anon_sym_GT_GT_GT] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_BANG_EQ] = ACTIONS(3357),
    [anon_sym_LT_EQ] = ACTIONS(3355),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_GT_EQ] = ACTIONS(3355),
    [anon_sym_GT] = ACTIONS(3357),
    [anon_sym_AMP] = ACTIONS(3357),
    [anon_sym_PERCENT] = ACTIONS(3355),
    [anon_sym_QMARK] = ACTIONS(3355),
    [anon_sym_RBRACE] = ACTIONS(3355),
    [anon_sym_as] = ACTIONS(3357),
    [anon_sym_PIPE_PIPE] = ACTIONS(3355),
    [anon_sym_DASH_DASH] = ACTIONS(3355),
    [anon_sym_EQ_EQ] = ACTIONS(3357),
    [anon_sym_instanceof] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_RPAREN] = ACTIONS(3355),
    [anon_sym_SLASH] = ACTIONS(3357),
    [sym_comment] = ACTIONS(3),
    [sym_regex_flags] = ACTIONS(3359),
    [anon_sym_DOT] = ACTIONS(3355),
    [anon_sym_CARET] = ACTIONS(3355),
    [anon_sym_STAR_STAR] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_GT_GT] = ACTIONS(3357),
    [anon_sym_PLUS_PLUS] = ACTIONS(3355),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3355),
    [anon_sym_in] = ACTIONS(3357),
  },
  [814] = {
    [aux_sym_export_statement_repeat1] = STATE(1599),
    [sym_decorator] = STATE(1599),
    [sym_object] = STATE(769),
    [sym_accessibility_modifier] = STATE(247),
    [sym_required_parameter] = STATE(1600),
    [sym_array] = STATE(771),
    [sym_rest_parameter] = STATE(1600),
    [sym_optional_parameter] = STATE(1600),
    [sym_this] = STATE(772),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_public] = ACTIONS(1446),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(1442),
    [anon_sym_number] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_RPAREN] = ACTIONS(3361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1446),
    [anon_sym_void] = ACTIONS(1442),
    [anon_sym_string] = ACTIONS(1442),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_any] = ACTIONS(1442),
    [anon_sym_private] = ACTIONS(1446),
    [anon_sym_boolean] = ACTIONS(1442),
    [anon_sym_async] = ACTIONS(1442),
  },
  [815] = {
    [sym_formal_parameters] = STATE(1601),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [816] = {
    [sym_type_annotation] = STATE(1603),
    [sym__automatic_semicolon] = ACTIONS(548),
    [anon_sym_COLON] = ACTIONS(3363),
    [anon_sym_SEMI] = ACTIONS(548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(548),
  },
  [817] = {
    [sym_statement_block] = STATE(1562),
    [sym__automatic_semicolon] = ACTIONS(3365),
    [anon_sym_SEMI] = ACTIONS(3365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(909),
  },
  [818] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(1605),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [819] = {
    [sym_statement_block] = STATE(1606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(909),
  },
  [820] = {
    [sym_type_annotation] = STATE(892),
    [anon_sym_COLON] = ACTIONS(1527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1669),
  },
  [821] = {
    [sym_union_type] = STATE(1612),
    [sym__type] = STATE(1612),
    [sym_constructor_type] = STATE(1612),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1613),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1612),
    [sym_function_type] = STATE(1612),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1614),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3367),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [822] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3377),
    [sym_identifier] = ACTIONS(3379),
    [sym__automatic_semicolon] = ACTIONS(3377),
    [anon_sym_BQUOTE] = ACTIONS(3377),
    [anon_sym_debugger] = ACTIONS(3379),
    [ts_builtin_sym_end] = ACTIONS(3377),
    [anon_sym_symbol] = ACTIONS(3379),
    [anon_sym_AT] = ACTIONS(3377),
    [anon_sym_PIPE] = ACTIONS(3379),
    [anon_sym_COMMA] = ACTIONS(3377),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_STAR] = ACTIONS(3379),
    [anon_sym_GT_GT_GT] = ACTIONS(3377),
    [anon_sym_void] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_BANG_EQ] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_GT_EQ] = ACTIONS(3377),
    [sym_super] = ACTIONS(3379),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_private] = ACTIONS(3379),
    [anon_sym_get] = ACTIONS(3379),
    [anon_sym_RBRACE] = ACTIONS(3377),
    [anon_sym_PERCENT] = ACTIONS(3377),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_default] = ACTIONS(3379),
    [anon_sym_as] = ACTIONS(3379),
    [anon_sym_delete] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3377),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_instanceof] = ACTIONS(3379),
    [anon_sym_this] = ACTIONS(3379),
    [anon_sym_yield] = ACTIONS(3379),
    [sym_true] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_protected] = ACTIONS(3379),
    [anon_sym_abstract] = ACTIONS(3379),
    [anon_sym_DOT] = ACTIONS(3379),
    [anon_sym_set] = ACTIONS(3379),
    [anon_sym_type] = ACTIONS(3379),
    [anon_sym_STAR_STAR] = ACTIONS(3377),
    [anon_sym_import] = ACTIONS(3379),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3377),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_PLUS_PLUS] = ACTIONS(3377),
    [anon_sym_await] = ACTIONS(3379),
    [anon_sym_DQUOTE] = ACTIONS(3377),
    [anon_sym_else] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3377),
    [sym_false] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3377),
    [anon_sym_case] = ACTIONS(3379),
    [anon_sym_module] = ACTIONS(3379),
    [anon_sym_number] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_declare] = ACTIONS(3379),
    [anon_sym_typeof] = ACTIONS(3379),
    [anon_sym_LT_LT] = ACTIONS(3377),
    [anon_sym_LBRACE] = ACTIONS(3377),
    [anon_sym_AMP_AMP] = ACTIONS(3377),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_LT_EQ] = ACTIONS(3377),
    [anon_sym_LPAREN] = ACTIONS(3377),
    [sym_null] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_any] = ACTIONS(3379),
    [anon_sym_boolean] = ACTIONS(3379),
    [anon_sym_async] = ACTIONS(3379),
    [anon_sym_public] = ACTIONS(3379),
    [anon_sym_AMP] = ACTIONS(3379),
    [anon_sym_var] = ACTIONS(3379),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_PIPE_PIPE] = ACTIONS(3377),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_SQUOTE] = ACTIONS(3377),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_EQ_EQ] = ACTIONS(3379),
    [anon_sym_RPAREN] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [sym_number] = ACTIONS(3377),
    [anon_sym_SLASH] = ACTIONS(3379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3379),
    [anon_sym_function] = ACTIONS(3379),
    [sym_undefined] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_CARET] = ACTIONS(3377),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_export] = ACTIONS(3379),
    [anon_sym_GT_GT] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_TILDE] = ACTIONS(3377),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3377),
    [anon_sym_in] = ACTIONS(3379),
  },
  [823] = {
    [sym_new_expression] = STATE(1615),
    [sym_augmented_assignment_expression] = STATE(1615),
    [sym_unary_expression] = STATE(1615),
    [sym_update_expression] = STATE(1615),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(1615),
    [sym_regex] = STATE(1615),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1615),
    [sym_non_null_expression] = STATE(1615),
    [sym_as_expression] = STATE(1615),
    [sym_jsx_fragment] = STATE(1615),
    [sym_yield_expression] = STATE(1615),
    [sym_jsx_element] = STATE(1615),
    [sym_internal_module] = STATE(1615),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1615),
    [sym_await_expression] = STATE(1615),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(1615),
    [sym_this] = STATE(1615),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(1615),
    [sym_generator_function] = STATE(1615),
    [sym_call_expression] = STATE(1615),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(1615),
    [sym_ternary_expression] = STATE(1615),
    [sym_binary_expression] = STATE(1615),
    [sym_template_string] = STATE(1615),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1615),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1615),
    [sym_class] = STATE(1615),
    [anon_sym_BANG] = ACTIONS(484),
    [sym_identifier] = ACTIONS(1543),
    [sym_false] = ACTIONS(3381),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3381),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3383),
    [sym_true] = ACTIONS(3381),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3381),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
  },
  [824] = {
    [sym_new_expression] = STATE(565),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(565),
    [sym_regex] = STATE(565),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(565),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(565),
    [sym_this] = STATE(565),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(565),
    [sym_generator_function] = STATE(565),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(565),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(565),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(565),
    [anon_sym_BANG] = ACTIONS(484),
    [sym_identifier] = ACTIONS(1543),
    [sym_false] = ACTIONS(1567),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1567),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1569),
    [sym_true] = ACTIONS(1567),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1567),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
  },
  [825] = {
    [sym_new_expression] = STATE(565),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(565),
    [sym_regex] = STATE(565),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(565),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(565),
    [sym_this] = STATE(565),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(565),
    [sym_generator_function] = STATE(565),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(565),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(565),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(565),
    [anon_sym_BANG] = ACTIONS(484),
    [sym_identifier] = ACTIONS(1543),
    [sym_false] = ACTIONS(1567),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1567),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1569),
    [sym_true] = ACTIONS(1567),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1567),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
  },
  [826] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3385),
    [anon_sym_LBRACK] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3387),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym_BQUOTE] = ACTIONS(3385),
    [sym__automatic_semicolon] = ACTIONS(3385),
    [anon_sym_PIPE] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3385),
    [anon_sym_LT_LT] = ACTIONS(3385),
    [anon_sym_STAR] = ACTIONS(3387),
    [anon_sym_GT_GT_GT] = ACTIONS(3385),
    [anon_sym_AMP_AMP] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_LT_EQ] = ACTIONS(3385),
    [anon_sym_LPAREN] = ACTIONS(3385),
    [anon_sym_GT_EQ] = ACTIONS(3385),
    [anon_sym_GT] = ACTIONS(3387),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3385),
    [anon_sym_QMARK] = ACTIONS(3385),
    [anon_sym_RBRACE] = ACTIONS(3385),
    [anon_sym_as] = ACTIONS(3385),
    [anon_sym_PIPE_PIPE] = ACTIONS(3385),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [anon_sym_EQ_EQ] = ACTIONS(3387),
    [anon_sym_instanceof] = ACTIONS(3385),
    [anon_sym_LT] = ACTIONS(3387),
    [anon_sym_RPAREN] = ACTIONS(3385),
    [anon_sym_SLASH] = ACTIONS(3387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3385),
    [anon_sym_CARET] = ACTIONS(3385),
    [anon_sym_STAR_STAR] = ACTIONS(3385),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_GT_GT] = ACTIONS(3387),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3385),
    [anon_sym_in] = ACTIONS(3387),
  },
  [827] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3389),
    [anon_sym_LBRACK] = ACTIONS(3389),
    [anon_sym_BANG] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym_BQUOTE] = ACTIONS(3389),
    [sym__automatic_semicolon] = ACTIONS(3389),
    [anon_sym_PIPE] = ACTIONS(3391),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_LT_LT] = ACTIONS(3389),
    [anon_sym_STAR] = ACTIONS(3391),
    [anon_sym_GT_GT_GT] = ACTIONS(3389),
    [anon_sym_AMP_AMP] = ACTIONS(3389),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_BANG_EQ] = ACTIONS(3391),
    [anon_sym_LT_EQ] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3389),
    [anon_sym_GT_EQ] = ACTIONS(3389),
    [anon_sym_GT] = ACTIONS(3391),
    [anon_sym_AMP] = ACTIONS(3391),
    [anon_sym_PERCENT] = ACTIONS(3389),
    [anon_sym_QMARK] = ACTIONS(3389),
    [anon_sym_RBRACE] = ACTIONS(3389),
    [anon_sym_as] = ACTIONS(3389),
    [anon_sym_PIPE_PIPE] = ACTIONS(3389),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [anon_sym_EQ_EQ] = ACTIONS(3391),
    [anon_sym_instanceof] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3391),
    [anon_sym_RPAREN] = ACTIONS(3389),
    [anon_sym_SLASH] = ACTIONS(3391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3389),
    [anon_sym_CARET] = ACTIONS(3389),
    [anon_sym_STAR_STAR] = ACTIONS(3389),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_GT_GT] = ACTIONS(3391),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3389),
    [anon_sym_in] = ACTIONS(3391),
  },
  [828] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3393),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3395),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym_BQUOTE] = ACTIONS(3393),
    [sym__automatic_semicolon] = ACTIONS(3393),
    [anon_sym_PIPE] = ACTIONS(3395),
    [anon_sym_COMMA] = ACTIONS(3393),
    [anon_sym_LT_LT] = ACTIONS(3393),
    [anon_sym_STAR] = ACTIONS(3395),
    [anon_sym_GT_GT_GT] = ACTIONS(3393),
    [anon_sym_AMP_AMP] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_BANG_EQ] = ACTIONS(3395),
    [anon_sym_LT_EQ] = ACTIONS(3393),
    [anon_sym_LPAREN] = ACTIONS(3393),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_GT] = ACTIONS(3395),
    [anon_sym_AMP] = ACTIONS(3395),
    [anon_sym_PERCENT] = ACTIONS(3393),
    [anon_sym_QMARK] = ACTIONS(3393),
    [anon_sym_RBRACE] = ACTIONS(3393),
    [anon_sym_as] = ACTIONS(3393),
    [anon_sym_PIPE_PIPE] = ACTIONS(3393),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_EQ_EQ] = ACTIONS(3395),
    [anon_sym_instanceof] = ACTIONS(3393),
    [anon_sym_LT] = ACTIONS(3395),
    [anon_sym_RPAREN] = ACTIONS(3393),
    [anon_sym_SLASH] = ACTIONS(3395),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3393),
    [anon_sym_STAR_STAR] = ACTIONS(3393),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_GT_GT] = ACTIONS(3395),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3393),
    [anon_sym_in] = ACTIONS(3395),
  },
  [829] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(3397),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1573),
  },
  [830] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [831] = {
    [sym_new_expression] = STATE(836),
    [sym_augmented_assignment_expression] = STATE(836),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(836),
    [sym_update_expression] = STATE(836),
    [sym_regex] = STATE(836),
    [sym_meta_property] = STATE(836),
    [sym_call_signature] = STATE(835),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(836),
    [sym_non_null_expression] = STATE(836),
    [sym_yield_expression] = STATE(836),
    [sym_jsx_fragment] = STATE(836),
    [sym_jsx_element] = STATE(836),
    [sym_as_expression] = STATE(836),
    [sym_internal_module] = STATE(836),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(836),
    [sym_await_expression] = STATE(836),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(836),
    [sym_this] = STATE(836),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(836),
    [sym_generator_function] = STATE(836),
    [sym_call_expression] = STATE(836),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(836),
    [sym_ternary_expression] = STATE(836),
    [sym_binary_expression] = STATE(836),
    [sym_template_string] = STATE(836),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(836),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(836),
    [sym_class] = STATE(836),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(500),
    [sym_true] = ACTIONS(1545),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(1545),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [832] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_call_signature] = STATE(1618),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(3401),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(3403),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(3403),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(3403),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(3403),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(3403),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(3403),
    [anon_sym_type] = ACTIONS(3403),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(3403),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(3403),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(3403),
    [anon_sym_declare] = ACTIONS(3403),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(3403),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(3403),
    [anon_sym_async] = ACTIONS(3403),
    [anon_sym_public] = ACTIONS(3403),
    [anon_sym_EQ_GT] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(3403),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [833] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(3405),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(3407),
    [anon_sym_symbol] = ACTIONS(3407),
    [anon_sym_number] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3407),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3407),
    [anon_sym_private] = ACTIONS(3407),
    [anon_sym_boolean] = ACTIONS(3407),
    [anon_sym_async] = ACTIONS(3411),
    [anon_sym_public] = ACTIONS(3407),
    [anon_sym_get] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3407),
    [anon_sym_string] = ACTIONS(3407),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(3407),
    [anon_sym_type] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(3407),
    [anon_sym_export] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [834] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [835] = {
    [anon_sym_EQ_GT] = ACTIONS(3397),
    [sym_comment] = ACTIONS(3),
  },
  [836] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(1591),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(3415),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [837] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [838] = {
    [sym__initializer] = STATE(587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1573),
  },
  [839] = {
    [sym__initializer] = STATE(589),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1573),
  },
  [840] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(1591),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(3415),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [841] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_BQUOTE] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_as] = ACTIONS(1591),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_instanceof] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_in] = ACTIONS(841),
  },
  [842] = {
    [sym_new_expression] = STATE(1637),
    [sym_augmented_assignment_expression] = STATE(1637),
    [sym_unary_expression] = STATE(1637),
    [sym_update_expression] = STATE(1637),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(1637),
    [sym_regex] = STATE(1637),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1637),
    [sym_non_null_expression] = STATE(1637),
    [sym_as_expression] = STATE(1637),
    [sym_jsx_fragment] = STATE(1637),
    [sym_yield_expression] = STATE(1637),
    [sym_jsx_element] = STATE(1637),
    [sym_internal_module] = STATE(1637),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1637),
    [sym_await_expression] = STATE(1637),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(1637),
    [sym_this] = STATE(1637),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(1637),
    [sym_generator_function] = STATE(1637),
    [sym_call_expression] = STATE(1637),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(1637),
    [sym_ternary_expression] = STATE(1637),
    [sym_binary_expression] = STATE(1637),
    [sym_template_string] = STATE(1637),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1637),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1637),
    [sym_class] = STATE(1637),
    [anon_sym_BANG] = ACTIONS(484),
    [sym_identifier] = ACTIONS(1543),
    [sym_false] = ACTIONS(3418),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3418),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3420),
    [sym_true] = ACTIONS(3418),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3418),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
  },
  [843] = {
    [sym_new_expression] = STATE(1638),
    [sym_augmented_assignment_expression] = STATE(1638),
    [sym_unary_expression] = STATE(1638),
    [sym_update_expression] = STATE(1638),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(1638),
    [sym_regex] = STATE(1638),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1638),
    [sym_non_null_expression] = STATE(1638),
    [sym_as_expression] = STATE(1638),
    [sym_jsx_fragment] = STATE(1638),
    [sym_yield_expression] = STATE(1638),
    [sym_jsx_element] = STATE(1638),
    [sym_internal_module] = STATE(1638),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1638),
    [sym_await_expression] = STATE(1638),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(1638),
    [sym_this] = STATE(1638),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(1638),
    [sym_generator_function] = STATE(1638),
    [sym_call_expression] = STATE(1638),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(1638),
    [sym_ternary_expression] = STATE(1638),
    [sym_binary_expression] = STATE(1638),
    [sym_template_string] = STATE(1638),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1638),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1638),
    [sym_class] = STATE(1638),
    [anon_sym_BANG] = ACTIONS(484),
    [sym_identifier] = ACTIONS(1543),
    [sym_false] = ACTIONS(3422),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3422),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3424),
    [sym_true] = ACTIONS(3422),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3422),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
  },
  [844] = {
    [sym_new_expression] = STATE(1639),
    [sym_augmented_assignment_expression] = STATE(1639),
    [sym_unary_expression] = STATE(1639),
    [sym_update_expression] = STATE(1639),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(1639),
    [sym_regex] = STATE(1639),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1639),
    [sym_non_null_expression] = STATE(1639),
    [sym_as_expression] = STATE(1639),
    [sym_jsx_fragment] = STATE(1639),
    [sym_yield_expression] = STATE(1639),
    [sym_jsx_element] = STATE(1639),
    [sym_internal_module] = STATE(1639),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1639),
    [sym_await_expression] = STATE(1639),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(1639),
    [sym_this] = STATE(1639),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(1639),
    [sym_generator_function] = STATE(1639),
    [sym_call_expression] = STATE(1639),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(1639),
    [sym_ternary_expression] = STATE(1639),
    [sym_binary_expression] = STATE(1639),
    [sym_template_string] = STATE(1639),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1639),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1639),
    [sym_class] = STATE(1639),
    [anon_sym_BANG] = ACTIONS(484),
    [sym_identifier] = ACTIONS(1543),
    [sym_false] = ACTIONS(3426),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3426),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3428),
    [sym_true] = ACTIONS(3426),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3426),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
  },
  [845] = {
    [sym_new_expression] = STATE(1640),
    [sym_augmented_assignment_expression] = STATE(1640),
    [sym_unary_expression] = STATE(1640),
    [sym_update_expression] = STATE(1640),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(1640),
    [sym_regex] = STATE(1640),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1640),
    [sym_non_null_expression] = STATE(1640),
    [sym_as_expression] = STATE(1640),
    [sym_jsx_fragment] = STATE(1640),
    [sym_yield_expression] = STATE(1640),
    [sym_jsx_element] = STATE(1640),
    [sym_internal_module] = STATE(1640),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1640),
    [sym_await_expression] = STATE(1640),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(1640),
    [sym_this] = STATE(1640),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(1640),
    [sym_generator_function] = STATE(1640),
    [sym_call_expression] = STATE(1640),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(1640),
    [sym_ternary_expression] = STATE(1640),
    [sym_binary_expression] = STATE(1640),
    [sym_template_string] = STATE(1640),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1640),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1640),
    [sym_class] = STATE(1640),
    [anon_sym_BANG] = ACTIONS(484),
    [sym_identifier] = ACTIONS(1543),
    [sym_false] = ACTIONS(3430),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3430),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3432),
    [sym_true] = ACTIONS(3430),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3430),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
  },
  [846] = {
    [sym_new_expression] = STATE(1641),
    [sym_augmented_assignment_expression] = STATE(1641),
    [sym_unary_expression] = STATE(1641),
    [sym_update_expression] = STATE(1641),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(1641),
    [sym_regex] = STATE(1641),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1641),
    [sym_non_null_expression] = STATE(1641),
    [sym_as_expression] = STATE(1641),
    [sym_jsx_fragment] = STATE(1641),
    [sym_yield_expression] = STATE(1641),
    [sym_jsx_element] = STATE(1641),
    [sym_internal_module] = STATE(1641),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1641),
    [sym_await_expression] = STATE(1641),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(1641),
    [sym_this] = STATE(1641),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(1641),
    [sym_generator_function] = STATE(1641),
    [sym_call_expression] = STATE(1641),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1641),
    [sym_ternary_expression] = STATE(1641),
    [sym_binary_expression] = STATE(1641),
    [sym_template_string] = STATE(1641),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1641),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1641),
    [sym_class] = STATE(1641),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(3434),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3434),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3436),
    [sym_true] = ACTIONS(3434),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3434),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [847] = {
    [sym_union_type] = STATE(1293),
    [sym__type] = STATE(1293),
    [sym_constructor_type] = STATE(1293),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1647),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_template_string] = STATE(1297),
    [sym_intersection_type] = STATE(1293),
    [sym_function_type] = STATE(1293),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1648),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3438),
    [sym_false] = ACTIONS(2643),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_PIPE] = ACTIONS(3440),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_boolean] = ACTIONS(2647),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3444),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2669),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_new] = ACTIONS(3446),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_DQUOTE] = ACTIONS(304),
  },
  [848] = {
    [sym_new_expression] = STATE(1615),
    [sym_constructor_type] = STATE(432),
    [sym_augmented_assignment_expression] = STATE(1615),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(1615),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(1615),
    [sym_type_parameters] = STATE(959),
    [sym_array_type] = STATE(436),
    [sym_yield_expression] = STATE(1615),
    [sym_as_expression] = STATE(1615),
    [sym_jsx_fragment] = STATE(1615),
    [sym_internal_module] = STATE(1615),
    [sym_arrow_function] = STATE(1615),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(837),
    [sym_literal_type] = STATE(436),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(1650),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(1615),
    [sym_subscript_expression] = STATE(837),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(1615),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(1615),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(960),
    [sym_function_type] = STATE(432),
    [sym__type] = STATE(432),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(1615),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(1615),
    [sym__expression] = STATE(1615),
    [sym_non_null_expression] = STATE(1615),
    [sym_jsx_element] = STATE(1615),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_await_expression] = STATE(1615),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_this] = STATE(1615),
    [sym_union_type] = STATE(432),
    [sym_anonymous_class] = STATE(1615),
    [sym_call_expression] = STATE(1615),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(1615),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(1615),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(432),
    [sym_parenthesized_expression] = STATE(1615),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1615),
    [sym_class] = STATE(1615),
    [anon_sym_BANG] = ACTIONS(484),
    [sym_identifier] = ACTIONS(3448),
    [sym_false] = ACTIONS(3450),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(3452),
    [anon_sym_number] = ACTIONS(3452),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(3454),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_void] = ACTIONS(3460),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [sym_null] = ACTIONS(3381),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3452),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(3452),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3462),
    [sym_true] = ACTIONS(3450),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(3464),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(3452),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3381),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(3466),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
  },
  [849] = {
    [sym_new_expression] = STATE(1658),
    [sym_augmented_assignment_expression] = STATE(1658),
    [sym_unary_expression] = STATE(1658),
    [sym_update_expression] = STATE(1658),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(1658),
    [sym_regex] = STATE(1658),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1658),
    [sym_non_null_expression] = STATE(1658),
    [sym_as_expression] = STATE(1658),
    [sym_jsx_fragment] = STATE(1658),
    [sym_yield_expression] = STATE(1658),
    [sym_jsx_element] = STATE(1658),
    [sym_internal_module] = STATE(1658),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1658),
    [sym_await_expression] = STATE(1658),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(1658),
    [sym_this] = STATE(1658),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(1658),
    [sym_generator_function] = STATE(1658),
    [sym_call_expression] = STATE(1658),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(1658),
    [sym_ternary_expression] = STATE(1658),
    [sym_binary_expression] = STATE(1658),
    [sym_template_string] = STATE(1658),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1658),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1658),
    [sym_class] = STATE(1658),
    [anon_sym_BANG] = ACTIONS(484),
    [sym_identifier] = ACTIONS(1543),
    [sym_false] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3468),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3470),
    [sym_true] = ACTIONS(3468),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3468),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
  },
  [850] = {
    [sym__automatic_semicolon] = ACTIONS(3472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3472),
  },
  [851] = {
    [sym__automatic_semicolon] = ACTIONS(3474),
    [anon_sym_SEMI] = ACTIONS(3474),
    [anon_sym_from] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
  },
  [852] = {
    [anon_sym_RBRACE] = ACTIONS(3476),
    [sym_comment] = ACTIONS(3),
  },
  [853] = {
    [aux_sym_export_clause_repeat1] = STATE(1663),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_RBRACE] = ACTIONS(3480),
    [sym_comment] = ACTIONS(3),
  },
  [854] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(3482),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(3482),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [855] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(3485),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3485),
    [anon_sym_AMP_EQ] = ACTIONS(3485),
    [anon_sym_PLUS_EQ] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(3485),
    [anon_sym_STAR_EQ] = ACTIONS(3485),
    [anon_sym_PIPE_EQ] = ACTIONS(3485),
    [anon_sym_DASH_EQ] = ACTIONS(3485),
    [anon_sym_EQ_GT] = ACTIONS(3489),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(3485),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3485),
    [anon_sym_GT_GT_EQ] = ACTIONS(3485),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3485),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3491),
  },
  [856] = {
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(3493),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3493),
    [anon_sym_AMP_EQ] = ACTIONS(3493),
    [anon_sym_PLUS_EQ] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(3493),
    [anon_sym_STAR_EQ] = ACTIONS(3493),
    [anon_sym_PIPE_EQ] = ACTIONS(3493),
    [anon_sym_DASH_EQ] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(3493),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3493),
    [anon_sym_GT_GT_EQ] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3493),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [857] = {
    [sym_new_expression] = STATE(1670),
    [sym_augmented_assignment_expression] = STATE(1670),
    [sym_unary_expression] = STATE(1670),
    [sym_update_expression] = STATE(1670),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(1670),
    [sym_regex] = STATE(1670),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1670),
    [sym_non_null_expression] = STATE(1670),
    [sym_as_expression] = STATE(1670),
    [sym_jsx_fragment] = STATE(1670),
    [sym_yield_expression] = STATE(1670),
    [sym_jsx_element] = STATE(1670),
    [sym_internal_module] = STATE(1670),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1670),
    [sym_await_expression] = STATE(1670),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(1670),
    [sym_this] = STATE(1670),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(1670),
    [sym_generator_function] = STATE(1670),
    [sym_call_expression] = STATE(1670),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(1670),
    [sym_ternary_expression] = STATE(1670),
    [sym_binary_expression] = STATE(1670),
    [sym_template_string] = STATE(1670),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1670),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(1670),
    [sym_class] = STATE(1670),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3497),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3499),
    [sym_true] = ACTIONS(3497),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3497),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [858] = {
    [sym_new_expression] = STATE(1671),
    [sym_augmented_assignment_expression] = STATE(1671),
    [sym_unary_expression] = STATE(1671),
    [sym_update_expression] = STATE(1671),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(1671),
    [sym_regex] = STATE(1671),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1671),
    [sym_non_null_expression] = STATE(1671),
    [sym_as_expression] = STATE(1671),
    [sym_jsx_fragment] = STATE(1671),
    [sym_yield_expression] = STATE(1671),
    [sym_jsx_element] = STATE(1671),
    [sym_internal_module] = STATE(1671),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1671),
    [sym_await_expression] = STATE(1671),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(1671),
    [sym_this] = STATE(1671),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(1671),
    [sym_generator_function] = STATE(1671),
    [sym_call_expression] = STATE(1671),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(1671),
    [sym_ternary_expression] = STATE(1671),
    [sym_binary_expression] = STATE(1671),
    [sym_template_string] = STATE(1671),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1671),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(1671),
    [sym_class] = STATE(1671),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3501),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3503),
    [sym_true] = ACTIONS(3501),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3501),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [859] = {
    [sym_new_expression] = STATE(1670),
    [sym_augmented_assignment_expression] = STATE(1670),
    [sym__initializer] = STATE(79),
    [sym_unary_expression] = STATE(1670),
    [sym_update_expression] = STATE(1670),
    [sym_regex] = STATE(1670),
    [sym_meta_property] = STATE(1670),
    [sym_call_signature] = STATE(866),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1670),
    [sym_non_null_expression] = STATE(1670),
    [sym_yield_expression] = STATE(1670),
    [sym_jsx_fragment] = STATE(1670),
    [sym_jsx_element] = STATE(1670),
    [sym_as_expression] = STATE(1670),
    [sym_internal_module] = STATE(1670),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1670),
    [sym_await_expression] = STATE(1670),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(1670),
    [sym_this] = STATE(1670),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(1670),
    [sym_generator_function] = STATE(1670),
    [sym_call_expression] = STATE(1670),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(1670),
    [sym_ternary_expression] = STATE(1670),
    [sym_binary_expression] = STATE(1670),
    [sym_template_string] = STATE(1670),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1670),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(1670),
    [sym_class] = STATE(1670),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1605),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(3493),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_AMP_EQ] = ACTIONS(3493),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(3487),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(3493),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_PIPE_EQ] = ACTIONS(3493),
    [anon_sym_DASH_EQ] = ACTIONS(3493),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(3493),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(1623),
    [sym_true] = ACTIONS(3497),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_GT_GT_EQ] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3493),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(3497),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3493),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3497),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_STAR_EQ] = ACTIONS(3493),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(3499),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3493),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3497),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [860] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(79),
    [sym_formal_parameters] = STATE(57),
    [sym_call_signature] = STATE(1672),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(3493),
    [anon_sym_symbol] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(3493),
    [anon_sym_PLUS_EQ] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(3487),
    [anon_sym_void] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(3493),
    [anon_sym_private] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(3493),
    [anon_sym_DASH_EQ] = ACTIONS(3493),
    [anon_sym_get] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(3493),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_set] = ACTIONS(3507),
    [anon_sym_type] = ACTIONS(3507),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(3507),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3493),
    [anon_sym_namespace] = ACTIONS(3507),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(3507),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3493),
    [anon_sym_number] = ACTIONS(3507),
    [anon_sym_declare] = ACTIONS(3507),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(3507),
    [anon_sym_STAR_EQ] = ACTIONS(3493),
    [anon_sym_boolean] = ACTIONS(3507),
    [anon_sym_async] = ACTIONS(3507),
    [anon_sym_public] = ACTIONS(3507),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3493),
    [anon_sym_string] = ACTIONS(3507),
    [anon_sym_function] = ACTIONS(698),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(3507),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [861] = {
    [sym_new_expression] = STATE(1674),
    [sym_augmented_assignment_expression] = STATE(1674),
    [sym_unary_expression] = STATE(1674),
    [sym_update_expression] = STATE(1674),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(1674),
    [sym_regex] = STATE(1674),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1674),
    [sym_non_null_expression] = STATE(1674),
    [sym_as_expression] = STATE(1674),
    [sym_jsx_fragment] = STATE(1674),
    [sym_yield_expression] = STATE(1674),
    [sym_jsx_element] = STATE(1674),
    [sym_internal_module] = STATE(1674),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1674),
    [sym_await_expression] = STATE(1674),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(1674),
    [sym_this] = STATE(1674),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(1674),
    [sym_generator_function] = STATE(1674),
    [sym_call_expression] = STATE(1674),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(1674),
    [sym_ternary_expression] = STATE(1674),
    [sym_binary_expression] = STATE(1674),
    [sym_template_string] = STATE(1674),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1674),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(1674),
    [sym_class] = STATE(1674),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3509),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3511),
    [sym_true] = ACTIONS(3509),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3509),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [862] = {
    [sym_new_expression] = STATE(1675),
    [sym_augmented_assignment_expression] = STATE(1675),
    [sym_unary_expression] = STATE(1675),
    [sym_update_expression] = STATE(1675),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(1675),
    [sym_regex] = STATE(1675),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1675),
    [sym_non_null_expression] = STATE(1675),
    [sym_as_expression] = STATE(1675),
    [sym_jsx_fragment] = STATE(1675),
    [sym_yield_expression] = STATE(1675),
    [sym_jsx_element] = STATE(1675),
    [sym_internal_module] = STATE(1675),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1675),
    [sym_await_expression] = STATE(1675),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(1675),
    [sym_this] = STATE(1675),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(1675),
    [sym_generator_function] = STATE(1675),
    [sym_call_expression] = STATE(1675),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(1675),
    [sym_ternary_expression] = STATE(1675),
    [sym_binary_expression] = STATE(1675),
    [sym_template_string] = STATE(1675),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1675),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(1675),
    [sym_class] = STATE(1675),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym_identifier] = ACTIONS(1605),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(1623),
    [sym_true] = ACTIONS(3513),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(3513),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3513),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(3515),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [863] = {
    [sym_new_expression] = STATE(277),
    [sym_augmented_assignment_expression] = STATE(289),
    [sym_unary_expression] = STATE(289),
    [sym_update_expression] = STATE(289),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(277),
    [sym_regex] = STATE(277),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(289),
    [sym_non_null_expression] = STATE(289),
    [sym_as_expression] = STATE(289),
    [sym_jsx_fragment] = STATE(289),
    [sym_yield_expression] = STATE(289),
    [sym_jsx_element] = STATE(289),
    [sym_internal_module] = STATE(289),
    [sym_function] = STATE(290),
    [sym_arrow_function] = STATE(277),
    [sym_await_expression] = STATE(289),
    [sym_member_expression] = STATE(291),
    [sym_string] = STATE(277),
    [sym_this] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(292),
    [sym_anonymous_class] = STATE(277),
    [sym_generator_function] = STATE(277),
    [sym_call_expression] = STATE(289),
    [sym_subscript_expression] = STATE(291),
    [sym_assignment_expression] = STATE(289),
    [sym_ternary_expression] = STATE(289),
    [sym_binary_expression] = STATE(289),
    [sym_template_string] = STATE(277),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(277),
    [sym_array] = STATE(293),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(289),
    [sym_class] = STATE(277),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(3517),
    [sym_false] = ACTIONS(482),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(3519),
    [anon_sym_symbol] = ACTIONS(3519),
    [anon_sym_number] = ACTIONS(3519),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3519),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(482),
    [sym_super] = ACTIONS(494),
    [anon_sym_any] = ACTIONS(3519),
    [anon_sym_private] = ACTIONS(3519),
    [anon_sym_boolean] = ACTIONS(3519),
    [anon_sym_async] = ACTIONS(3523),
    [anon_sym_public] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3519),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(498),
    [sym_true] = ACTIONS(482),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(3519),
    [anon_sym_string] = ACTIONS(3519),
    [anon_sym_function] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(502),
    [sym_undefined] = ACTIONS(482),
    [anon_sym_set] = ACTIONS(3519),
    [anon_sym_type] = ACTIONS(3519),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(3519),
    [anon_sym_export] = ACTIONS(3519),
    [anon_sym_namespace] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [864] = {
    [sym_nested_identifier] = STATE(127),
    [sym__module] = STATE(128),
    [sym_string] = STATE(129),
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_PERCENT_EQ] = ACTIONS(3493),
    [anon_sym_AMP_EQ] = ACTIONS(3493),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3493),
    [anon_sym_PLUS_EQ] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(3493),
    [anon_sym_STAR_EQ] = ACTIONS(3493),
    [anon_sym_PIPE_EQ] = ACTIONS(3493),
    [anon_sym_DASH_EQ] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(3493),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3493),
    [anon_sym_GT_GT_EQ] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3493),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [865] = {
    [sym_new_expression] = STATE(1681),
    [sym_augmented_assignment_expression] = STATE(1681),
    [sym_unary_expression] = STATE(1681),
    [sym_update_expression] = STATE(1681),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(1681),
    [sym_regex] = STATE(1681),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1681),
    [sym_non_null_expression] = STATE(1681),
    [sym_as_expression] = STATE(1681),
    [sym_jsx_fragment] = STATE(1681),
    [sym_yield_expression] = STATE(1681),
    [sym_jsx_element] = STATE(1681),
    [sym_internal_module] = STATE(1681),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1681),
    [sym_await_expression] = STATE(1681),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(1681),
    [sym_this] = STATE(1681),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(1681),
    [sym_generator_function] = STATE(1681),
    [sym_call_expression] = STATE(1681),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(1681),
    [sym_ternary_expression] = STATE(1681),
    [sym_binary_expression] = STATE(1681),
    [sym_template_string] = STATE(1681),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1681),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(1681),
    [sym_class] = STATE(1681),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3527),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3529),
    [sym_true] = ACTIONS(3527),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3527),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [866] = {
    [anon_sym_EQ_GT] = ACTIONS(3489),
    [sym_comment] = ACTIONS(3),
  },
  [867] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym__automatic_semicolon] = ACTIONS(3472),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3472),
    [anon_sym_in] = ACTIONS(3491),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_LT_LT] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_GT_GT_GT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_BANG_EQ] = ACTIONS(3491),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3545),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(3491),
    [anon_sym_instanceof] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3547),
    [anon_sym_STAR_STAR] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_BANG] = ACTIONS(582),
  },
  [868] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(3485),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3485),
    [anon_sym_AMP_EQ] = ACTIONS(3485),
    [anon_sym_PLUS_EQ] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(3485),
    [anon_sym_STAR_EQ] = ACTIONS(3485),
    [anon_sym_PIPE_EQ] = ACTIONS(3485),
    [anon_sym_DASH_EQ] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(3485),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3485),
    [anon_sym_GT_GT_EQ] = ACTIONS(3485),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3485),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [869] = {
    [sym__initializer] = STATE(321),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3491),
  },
  [870] = {
    [sym__initializer] = STATE(336),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3491),
  },
  [871] = {
    [sym_identifier] = ACTIONS(3555),
    [sym_comment] = ACTIONS(3),
  },
  [872] = {
    [sym_identifier] = ACTIONS(3557),
    [anon_sym_BQUOTE] = ACTIONS(3559),
    [anon_sym_debugger] = ACTIONS(3557),
    [anon_sym_symbol] = ACTIONS(3557),
    [anon_sym_AT] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(3557),
    [anon_sym_void] = ACTIONS(3557),
    [anon_sym_break] = ACTIONS(3557),
    [anon_sym_const] = ACTIONS(3557),
    [sym_super] = ACTIONS(3557),
    [anon_sym_return] = ACTIONS(3557),
    [anon_sym_private] = ACTIONS(3557),
    [anon_sym_get] = ACTIONS(3557),
    [anon_sym_RBRACE] = ACTIONS(3559),
    [anon_sym_interface] = ACTIONS(3557),
    [anon_sym_default] = ACTIONS(3557),
    [anon_sym_enum] = ACTIONS(3557),
    [anon_sym_delete] = ACTIONS(3557),
    [anon_sym_continue] = ACTIONS(3557),
    [anon_sym_DASH_DASH] = ACTIONS(3559),
    [anon_sym_if] = ACTIONS(3557),
    [anon_sym_this] = ACTIONS(3557),
    [anon_sym_yield] = ACTIONS(3557),
    [sym_true] = ACTIONS(3557),
    [anon_sym_throw] = ACTIONS(3557),
    [anon_sym_protected] = ACTIONS(3557),
    [anon_sym_abstract] = ACTIONS(3557),
    [anon_sym_set] = ACTIONS(3557),
    [anon_sym_type] = ACTIONS(3557),
    [anon_sym_import] = ACTIONS(3557),
    [anon_sym_namespace] = ACTIONS(3557),
    [anon_sym_PLUS_PLUS] = ACTIONS(3559),
    [anon_sym_await] = ACTIONS(3557),
    [anon_sym_DQUOTE] = ACTIONS(3559),
    [anon_sym_else] = ACTIONS(3557),
    [anon_sym_BANG] = ACTIONS(3559),
    [anon_sym_for] = ACTIONS(3557),
    [anon_sym_LBRACK] = ACTIONS(3559),
    [sym_false] = ACTIONS(3557),
    [anon_sym_SEMI] = ACTIONS(3559),
    [anon_sym_case] = ACTIONS(3557),
    [anon_sym_module] = ACTIONS(3557),
    [anon_sym_number] = ACTIONS(3557),
    [anon_sym_class] = ACTIONS(3557),
    [anon_sym_declare] = ACTIONS(3557),
    [anon_sym_typeof] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(3559),
    [anon_sym_switch] = ACTIONS(3557),
    [anon_sym_LPAREN] = ACTIONS(3559),
    [sym_null] = ACTIONS(3557),
    [anon_sym_any] = ACTIONS(3557),
    [anon_sym_boolean] = ACTIONS(3557),
    [anon_sym_async] = ACTIONS(3557),
    [anon_sym_public] = ACTIONS(3557),
    [anon_sym_var] = ACTIONS(3557),
    [anon_sym_while] = ACTIONS(3557),
    [anon_sym_SQUOTE] = ACTIONS(3559),
    [anon_sym_try] = ACTIONS(3557),
    [anon_sym_LT] = ACTIONS(3559),
    [sym_number] = ACTIONS(3559),
    [anon_sym_SLASH] = ACTIONS(3557),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3557),
    [anon_sym_function] = ACTIONS(3557),
    [sym_undefined] = ACTIONS(3557),
    [anon_sym_new] = ACTIONS(3557),
    [ts_builtin_sym_end] = ACTIONS(3559),
    [anon_sym_let] = ACTIONS(3557),
    [anon_sym_PLUS] = ACTIONS(3557),
    [anon_sym_export] = ACTIONS(3557),
    [anon_sym_do] = ACTIONS(3557),
    [anon_sym_TILDE] = ACTIONS(3559),
    [anon_sym_with] = ACTIONS(3557),
  },
  [873] = {
    [sym_type_alias_declaration] = STATE(348),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(348),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(348),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(348),
    [sym_return_statement] = STATE(348),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(348),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(348),
    [sym_switch_statement] = STATE(348),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(348),
    [sym_throw_statement] = STATE(348),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(348),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(348),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(348),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(348),
    [sym_abstract_class] = STATE(348),
    [sym_interface_declaration] = STATE(348),
    [sym_statement_block] = STATE(348),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(348),
    [sym_debugger_statement] = STATE(348),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(348),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(348),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(348),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(348),
    [sym_empty_statement] = STATE(348),
    [sym_import_alias] = STATE(348),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(348),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(348),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(348),
    [sym_break_statement] = STATE(348),
    [sym_labeled_statement] = STATE(348),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(348),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [874] = {
    [sym_type_alias_declaration] = STATE(1698),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1698),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1698),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(1698),
    [sym_return_statement] = STATE(1698),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1698),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1698),
    [sym_switch_statement] = STATE(1698),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(1698),
    [sym_throw_statement] = STATE(1698),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(1698),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1698),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(1698),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(1698),
    [sym_abstract_class] = STATE(1698),
    [sym_interface_declaration] = STATE(1698),
    [sym_statement_block] = STATE(1698),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(1698),
    [sym_debugger_statement] = STATE(1698),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(1698),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1698),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1698),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1698),
    [sym_empty_statement] = STATE(1698),
    [sym_import_alias] = STATE(1698),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1698),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1698),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(1698),
    [sym_break_statement] = STATE(1698),
    [sym_labeled_statement] = STATE(1698),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(1698),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [875] = {
    [sym_identifier] = ACTIONS(3575),
    [sym_comment] = ACTIONS(3),
  },
  [876] = {
    [anon_sym_LPAREN] = ACTIONS(3577),
    [sym_comment] = ACTIONS(3),
  },
  [877] = {
    [sym_new_expression] = STATE(59),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_yield_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_internal_module] = STATE(59),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(59),
    [sym_await_expression] = STATE(59),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1705),
    [sym_variable_declaration] = STATE(1705),
    [sym_sequence_expression] = STATE(62),
    [sym_string] = STATE(59),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(1705),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1706),
    [sym_anonymous_class] = STATE(59),
    [sym_generator_function] = STATE(59),
    [sym_call_expression] = STATE(59),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(59),
    [sym_ternary_expression] = STATE(59),
    [sym_binary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_lexical_declaration] = STATE(1705),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(1707),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_identifier] = ACTIONS(3579),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(3583),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(3581),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(15),
  },
  [878] = {
    [sym_string] = STATE(173),
    [sym_nested_identifier] = STATE(169),
    [sym__module] = STATE(172),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(3585),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(282),
  },
  [879] = {
    [sym_identifier] = ACTIONS(3587),
    [sym_comment] = ACTIONS(3),
  },
  [880] = {
    [sym_type_alias_declaration] = STATE(193),
    [aux_sym_export_statement_repeat1] = STATE(885),
    [sym__declaration] = STATE(193),
    [sym_ambient_declaration] = STATE(193),
    [sym_import_alias] = STATE(193),
    [sym_export_statement] = STATE(193),
    [sym_generator_function] = STATE(193),
    [sym_lexical_declaration] = STATE(193),
    [sym_internal_module] = STATE(193),
    [sym_decorator] = STATE(885),
    [sym_enum_declaration] = STATE(193),
    [sym_function] = STATE(193),
    [sym_function_signature] = STATE(193),
    [sym_variable_declaration] = STATE(193),
    [sym_abstract_class] = STATE(193),
    [sym_module] = STATE(193),
    [sym_interface_declaration] = STATE(193),
    [sym_class] = STATE(193),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(1651),
    [anon_sym_class] = ACTIONS(1653),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1655),
    [anon_sym_global] = ACTIONS(324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(1659),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(1647),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(1661),
    [anon_sym_namespace] = ACTIONS(1649),
    [anon_sym_async] = ACTIONS(1657),
  },
  [881] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(3589),
  },
  [882] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(1712),
    [sym_identifier] = ACTIONS(3591),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(474),
    [anon_sym_STAR] = ACTIONS(3593),
    [sym_comment] = ACTIONS(3),
  },
  [883] = {
    [sym_type_alias_declaration] = STATE(300),
    [aux_sym_export_statement_repeat1] = STATE(885),
    [sym__declaration] = STATE(300),
    [sym_ambient_declaration] = STATE(300),
    [sym_import_alias] = STATE(300),
    [sym_export_statement] = STATE(300),
    [sym_generator_function] = STATE(300),
    [sym_export_clause] = STATE(301),
    [sym_lexical_declaration] = STATE(300),
    [sym_internal_module] = STATE(300),
    [sym_decorator] = STATE(885),
    [sym_enum_declaration] = STATE(300),
    [sym_function] = STATE(300),
    [sym_function_signature] = STATE(300),
    [sym_variable_declaration] = STATE(300),
    [sym_abstract_class] = STATE(300),
    [sym_module] = STATE(300),
    [sym_interface_declaration] = STATE(300),
    [sym_class] = STATE(300),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(1663),
    [anon_sym_as] = ACTIONS(1183),
    [anon_sym_class] = ACTIONS(1653),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1655),
    [anon_sym_STAR] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_EQ] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(1659),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(1647),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(1661),
    [anon_sym_namespace] = ACTIONS(1649),
    [anon_sym_async] = ACTIONS(1657),
  },
  [884] = {
    [sym_string] = STATE(173),
    [sym_nested_identifier] = STATE(169),
    [sym__module] = STATE(571),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(282),
  },
  [885] = {
    [aux_sym_export_statement_repeat1] = STATE(320),
    [sym_decorator] = STATE(320),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(1667),
    [anon_sym_class] = ACTIONS(3595),
    [sym_comment] = ACTIONS(3),
  },
  [886] = {
    [sym_type_alias_declaration] = STATE(787),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(787),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(787),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(787),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(787),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(787),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(787),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(787),
    [sym_abstract_class] = STATE(787),
    [sym_interface_declaration] = STATE(787),
    [sym_statement_block] = STATE(787),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(787),
    [sym_debugger_statement] = STATE(787),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(787),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(787),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(787),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(787),
    [sym_empty_statement] = STATE(787),
    [sym_import_alias] = STATE(787),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(787),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(787),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_labeled_statement] = STATE(787),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(787),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [887] = {
    [sym_string] = STATE(173),
    [sym_nested_identifier] = STATE(169),
    [sym__module] = STATE(172),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(282),
  },
  [888] = {
    [sym_type_alias_declaration] = STATE(891),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(891),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(891),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(891),
    [sym_return_statement] = STATE(891),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(891),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(891),
    [sym_switch_statement] = STATE(891),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(891),
    [sym_throw_statement] = STATE(891),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(891),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(891),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(891),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(891),
    [sym_abstract_class] = STATE(891),
    [sym_interface_declaration] = STATE(891),
    [sym_statement_block] = STATE(891),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(891),
    [sym_debugger_statement] = STATE(891),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(891),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(891),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(891),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(891),
    [sym_empty_statement] = STATE(891),
    [sym_import_alias] = STATE(891),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(891),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(891),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(891),
    [sym_break_statement] = STATE(891),
    [sym_labeled_statement] = STATE(891),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(891),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [889] = {
    [sym_parenthesized_expression] = STATE(1715),
    [anon_sym_LPAREN] = ACTIONS(3597),
    [sym_comment] = ACTIONS(3),
  },
  [890] = {
    [sym_type_alias_declaration] = STATE(872),
    [aux_sym_export_statement_repeat1] = STATE(885),
    [sym__declaration] = STATE(872),
    [sym_ambient_declaration] = STATE(872),
    [sym_import_alias] = STATE(872),
    [sym_export_statement] = STATE(872),
    [sym_generator_function] = STATE(872),
    [sym_lexical_declaration] = STATE(872),
    [sym_internal_module] = STATE(872),
    [sym_decorator] = STATE(885),
    [sym_enum_declaration] = STATE(872),
    [sym_function] = STATE(872),
    [sym_function_signature] = STATE(872),
    [sym_variable_declaration] = STATE(872),
    [sym_abstract_class] = STATE(872),
    [sym_module] = STATE(872),
    [sym_interface_declaration] = STATE(872),
    [sym_class] = STATE(872),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_default] = ACTIONS(1826),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(1663),
    [anon_sym_class] = ACTIONS(1653),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1655),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(1659),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(1647),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(1661),
    [anon_sym_namespace] = ACTIONS(1649),
    [anon_sym_async] = ACTIONS(1657),
  },
  [891] = {
    [sym_identifier] = ACTIONS(3599),
    [anon_sym_BQUOTE] = ACTIONS(3601),
    [anon_sym_debugger] = ACTIONS(3599),
    [anon_sym_symbol] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(3601),
    [anon_sym_DASH] = ACTIONS(3599),
    [anon_sym_void] = ACTIONS(3599),
    [anon_sym_break] = ACTIONS(3599),
    [anon_sym_const] = ACTIONS(3599),
    [sym_super] = ACTIONS(3599),
    [anon_sym_return] = ACTIONS(3599),
    [anon_sym_private] = ACTIONS(3599),
    [anon_sym_get] = ACTIONS(3599),
    [anon_sym_RBRACE] = ACTIONS(3601),
    [anon_sym_interface] = ACTIONS(3599),
    [anon_sym_default] = ACTIONS(3599),
    [anon_sym_enum] = ACTIONS(3599),
    [anon_sym_delete] = ACTIONS(3599),
    [anon_sym_continue] = ACTIONS(3599),
    [anon_sym_DASH_DASH] = ACTIONS(3601),
    [anon_sym_if] = ACTIONS(3599),
    [anon_sym_this] = ACTIONS(3599),
    [anon_sym_yield] = ACTIONS(3599),
    [sym_true] = ACTIONS(3599),
    [anon_sym_throw] = ACTIONS(3599),
    [anon_sym_protected] = ACTIONS(3599),
    [anon_sym_abstract] = ACTIONS(3599),
    [anon_sym_set] = ACTIONS(3599),
    [anon_sym_type] = ACTIONS(3599),
    [anon_sym_import] = ACTIONS(3599),
    [anon_sym_namespace] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3601),
    [anon_sym_await] = ACTIONS(3599),
    [anon_sym_DQUOTE] = ACTIONS(3601),
    [anon_sym_else] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3601),
    [anon_sym_for] = ACTIONS(3599),
    [anon_sym_LBRACK] = ACTIONS(3601),
    [sym_false] = ACTIONS(3599),
    [anon_sym_SEMI] = ACTIONS(3601),
    [anon_sym_case] = ACTIONS(3599),
    [anon_sym_module] = ACTIONS(3599),
    [anon_sym_number] = ACTIONS(3599),
    [anon_sym_class] = ACTIONS(3599),
    [anon_sym_declare] = ACTIONS(3599),
    [anon_sym_typeof] = ACTIONS(3599),
    [anon_sym_LBRACE] = ACTIONS(3601),
    [anon_sym_switch] = ACTIONS(3599),
    [anon_sym_LPAREN] = ACTIONS(3601),
    [sym_null] = ACTIONS(3599),
    [anon_sym_any] = ACTIONS(3599),
    [anon_sym_boolean] = ACTIONS(3599),
    [anon_sym_async] = ACTIONS(3599),
    [anon_sym_public] = ACTIONS(3599),
    [anon_sym_var] = ACTIONS(3599),
    [anon_sym_while] = ACTIONS(3599),
    [anon_sym_SQUOTE] = ACTIONS(3601),
    [anon_sym_try] = ACTIONS(3599),
    [anon_sym_LT] = ACTIONS(3601),
    [sym_number] = ACTIONS(3601),
    [anon_sym_SLASH] = ACTIONS(3599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3599),
    [anon_sym_function] = ACTIONS(3599),
    [sym_undefined] = ACTIONS(3599),
    [anon_sym_new] = ACTIONS(3599),
    [ts_builtin_sym_end] = ACTIONS(3601),
    [anon_sym_let] = ACTIONS(3599),
    [anon_sym_PLUS] = ACTIONS(3599),
    [anon_sym_export] = ACTIONS(3599),
    [anon_sym_do] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3601),
    [anon_sym_with] = ACTIONS(3599),
  },
  [892] = {
    [anon_sym_EQ_GT] = ACTIONS(3603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3603),
  },
  [893] = {
    [sym_new_expression] = STATE(1716),
    [sym_augmented_assignment_expression] = STATE(1716),
    [sym_unary_expression] = STATE(1716),
    [sym_update_expression] = STATE(1716),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(1716),
    [sym_regex] = STATE(1716),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1716),
    [sym_non_null_expression] = STATE(1716),
    [sym_as_expression] = STATE(1716),
    [sym_jsx_fragment] = STATE(1716),
    [sym_yield_expression] = STATE(1716),
    [sym_jsx_element] = STATE(1716),
    [sym_internal_module] = STATE(1716),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1716),
    [sym_await_expression] = STATE(1716),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(1716),
    [sym_this] = STATE(1716),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(1716),
    [sym_generator_function] = STATE(1716),
    [sym_call_expression] = STATE(1716),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(1716),
    [sym_ternary_expression] = STATE(1716),
    [sym_binary_expression] = STATE(1716),
    [sym_template_string] = STATE(1716),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1716),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(1716),
    [sym_class] = STATE(1716),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(3605),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3605),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3607),
    [sym_true] = ACTIONS(3605),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3605),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [894] = {
    [sym_class_heritage] = STATE(1717),
    [sym_type_parameters] = STATE(1718),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(1719),
    [anon_sym_extends] = ACTIONS(1131),
    [anon_sym_implements] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(322),
  },
  [895] = {
    [sym_class_body] = STATE(1720),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(322),
  },
  [896] = {
    [sym_type_arguments] = STATE(1064),
    [anon_sym_EQ_GT] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(3609),
  },
  [897] = {
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(433),
    [sym_array_type] = STATE(1066),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym_existential_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(1066),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(1066),
    [sym_string] = STATE(418),
    [sym_tuple_type] = STATE(1066),
    [sym_identifier] = ACTIONS(1839),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [sym_true] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [898] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(902),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(903),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1839),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(1845),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(1847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [899] = {
    [sym_type_parameters] = STATE(1722),
    [sym_formal_parameters] = STATE(1723),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [900] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(902),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(903),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1839),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(1845),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(1847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [901] = {
    [anon_sym_EQ_GT] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_PIPE] = ACTIONS(3615),
    [sym_comment] = ACTIONS(3),
  },
  [902] = {
    [sym_formal_parameters] = STATE(1726),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [903] = {
    [anon_sym_EQ_GT] = ACTIONS(3617),
    [sym_comment] = ACTIONS(3),
  },
  [904] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(560),
    [anon_sym_STAR] = ACTIONS(566),
    [anon_sym_GT_GT_GT] = ACTIONS(560),
    [anon_sym_AMP_AMP] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(554),
    [anon_sym_in] = ACTIONS(125),
  },
  [905] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [906] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(560),
    [anon_sym_STAR] = ACTIONS(566),
    [anon_sym_GT_GT_GT] = ACTIONS(560),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_SLASH] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [907] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(560),
    [anon_sym_STAR] = ACTIONS(566),
    [anon_sym_GT_GT_GT] = ACTIONS(560),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(554),
    [anon_sym_in] = ACTIONS(125),
  },
  [908] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [sym__automatic_semicolon] = ACTIONS(3622),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(3622),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_PIPE] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(560),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_GT_GT_GT] = ACTIONS(560),
    [anon_sym_AMP_AMP] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(566),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(582),
  },
  [909] = {
    [sym__automatic_semicolon] = ACTIONS(3622),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3622),
  },
  [910] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(3624),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3624),
    [anon_sym_AMP_EQ] = ACTIONS(3624),
    [anon_sym_PLUS_EQ] = ACTIONS(3624),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(3624),
    [anon_sym_STAR_EQ] = ACTIONS(3624),
    [anon_sym_PIPE_EQ] = ACTIONS(3624),
    [anon_sym_DASH_EQ] = ACTIONS(3624),
    [anon_sym_EQ_GT] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(3624),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(3624),
    [anon_sym_GT_GT_EQ] = ACTIONS(3624),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3624),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3630),
  },
  [911] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(3632),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3632),
    [anon_sym_AMP_EQ] = ACTIONS(3632),
    [anon_sym_PLUS_EQ] = ACTIONS(3632),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(3632),
    [anon_sym_STAR_EQ] = ACTIONS(3632),
    [anon_sym_PIPE_EQ] = ACTIONS(3632),
    [anon_sym_DASH_EQ] = ACTIONS(3632),
    [anon_sym_EQ_GT] = ACTIONS(3634),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(3632),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_SLASH_EQ] = ACTIONS(3632),
    [anon_sym_GT_GT_EQ] = ACTIONS(3632),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3632),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [912] = {
    [sym_new_expression] = STATE(1734),
    [sym_augmented_assignment_expression] = STATE(1734),
    [sym_unary_expression] = STATE(1734),
    [sym_update_expression] = STATE(1734),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(1734),
    [sym_regex] = STATE(1734),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1734),
    [sym_non_null_expression] = STATE(1734),
    [sym_as_expression] = STATE(1734),
    [sym_jsx_fragment] = STATE(1734),
    [sym_yield_expression] = STATE(1734),
    [sym_jsx_element] = STATE(1734),
    [sym_internal_module] = STATE(1734),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1734),
    [sym_await_expression] = STATE(1734),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(1734),
    [sym_this] = STATE(1734),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(1734),
    [sym_generator_function] = STATE(1734),
    [sym_call_expression] = STATE(1734),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1734),
    [sym_ternary_expression] = STATE(1734),
    [sym_binary_expression] = STATE(1734),
    [sym_template_string] = STATE(1734),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1734),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1734),
    [sym_class] = STATE(1734),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(3636),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3636),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3638),
    [sym_true] = ACTIONS(3636),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3636),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [913] = {
    [sym_new_expression] = STATE(1735),
    [sym_augmented_assignment_expression] = STATE(1735),
    [sym_unary_expression] = STATE(1735),
    [sym_update_expression] = STATE(1735),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(1735),
    [sym_regex] = STATE(1735),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1735),
    [sym_non_null_expression] = STATE(1735),
    [sym_as_expression] = STATE(1735),
    [sym_jsx_fragment] = STATE(1735),
    [sym_yield_expression] = STATE(1735),
    [sym_jsx_element] = STATE(1735),
    [sym_internal_module] = STATE(1735),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1735),
    [sym_await_expression] = STATE(1735),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(1735),
    [sym_this] = STATE(1735),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(1735),
    [sym_generator_function] = STATE(1735),
    [sym_call_expression] = STATE(1735),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1735),
    [sym_ternary_expression] = STATE(1735),
    [sym_binary_expression] = STATE(1735),
    [sym_template_string] = STATE(1735),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1735),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1735),
    [sym_class] = STATE(1735),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(3640),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3640),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3642),
    [sym_true] = ACTIONS(3640),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3640),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [914] = {
    [sym_new_expression] = STATE(1734),
    [sym_augmented_assignment_expression] = STATE(1734),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(1734),
    [sym_update_expression] = STATE(1734),
    [sym_regex] = STATE(1734),
    [sym_meta_property] = STATE(1734),
    [sym_call_signature] = STATE(921),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1734),
    [sym_non_null_expression] = STATE(1734),
    [sym_yield_expression] = STATE(1734),
    [sym_jsx_fragment] = STATE(1734),
    [sym_jsx_element] = STATE(1734),
    [sym_as_expression] = STATE(1734),
    [sym_internal_module] = STATE(1734),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1734),
    [sym_await_expression] = STATE(1734),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(1734),
    [sym_this] = STATE(1734),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(1734),
    [sym_generator_function] = STATE(1734),
    [sym_call_expression] = STATE(1734),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1734),
    [sym_ternary_expression] = STATE(1734),
    [sym_binary_expression] = STATE(1734),
    [sym_template_string] = STATE(1734),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1734),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1734),
    [sym_class] = STATE(1734),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1879),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(3632),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_AMP_EQ] = ACTIONS(3632),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(3632),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(3632),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_PIPE_EQ] = ACTIONS(3632),
    [anon_sym_DASH_EQ] = ACTIONS(3632),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(3632),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(1897),
    [sym_true] = ACTIONS(3636),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_GT_GT_EQ] = ACTIONS(3632),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3632),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1885),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(3636),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3632),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3636),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_STAR_EQ] = ACTIONS(3632),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_EQ_GT] = ACTIONS(3634),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(3638),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3632),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3636),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [915] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_call_signature] = STATE(1736),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(3644),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(3632),
    [anon_sym_symbol] = ACTIONS(3646),
    [anon_sym_AMP_EQ] = ACTIONS(3632),
    [anon_sym_PLUS_EQ] = ACTIONS(3632),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_void] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(3632),
    [anon_sym_private] = ACTIONS(3646),
    [anon_sym_PIPE_EQ] = ACTIONS(3632),
    [anon_sym_DASH_EQ] = ACTIONS(3632),
    [anon_sym_get] = ACTIONS(3646),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(3632),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(3646),
    [anon_sym_GT_GT_EQ] = ACTIONS(3632),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(3646),
    [anon_sym_type] = ACTIONS(3646),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(3646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3632),
    [anon_sym_namespace] = ACTIONS(3646),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(3646),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3632),
    [anon_sym_number] = ACTIONS(3646),
    [anon_sym_declare] = ACTIONS(3646),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(3646),
    [anon_sym_STAR_EQ] = ACTIONS(3632),
    [anon_sym_boolean] = ACTIONS(3646),
    [anon_sym_async] = ACTIONS(3646),
    [anon_sym_public] = ACTIONS(3646),
    [anon_sym_EQ_GT] = ACTIONS(3634),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3632),
    [anon_sym_string] = ACTIONS(3646),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(3646),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [916] = {
    [sym_new_expression] = STATE(1738),
    [sym_augmented_assignment_expression] = STATE(1738),
    [sym_unary_expression] = STATE(1738),
    [sym_update_expression] = STATE(1738),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(1738),
    [sym_regex] = STATE(1738),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1738),
    [sym_non_null_expression] = STATE(1738),
    [sym_as_expression] = STATE(1738),
    [sym_jsx_fragment] = STATE(1738),
    [sym_yield_expression] = STATE(1738),
    [sym_jsx_element] = STATE(1738),
    [sym_internal_module] = STATE(1738),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1738),
    [sym_await_expression] = STATE(1738),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(1738),
    [sym_this] = STATE(1738),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(1738),
    [sym_generator_function] = STATE(1738),
    [sym_call_expression] = STATE(1738),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1738),
    [sym_ternary_expression] = STATE(1738),
    [sym_binary_expression] = STATE(1738),
    [sym_template_string] = STATE(1738),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1738),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1738),
    [sym_class] = STATE(1738),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3648),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3650),
    [sym_true] = ACTIONS(3648),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3648),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [917] = {
    [sym_new_expression] = STATE(1739),
    [sym_augmented_assignment_expression] = STATE(1739),
    [sym_unary_expression] = STATE(1739),
    [sym_update_expression] = STATE(1739),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(1739),
    [sym_regex] = STATE(1739),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1739),
    [sym_non_null_expression] = STATE(1739),
    [sym_as_expression] = STATE(1739),
    [sym_jsx_fragment] = STATE(1739),
    [sym_yield_expression] = STATE(1739),
    [sym_jsx_element] = STATE(1739),
    [sym_internal_module] = STATE(1739),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1739),
    [sym_await_expression] = STATE(1739),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(1739),
    [sym_this] = STATE(1739),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(1739),
    [sym_generator_function] = STATE(1739),
    [sym_call_expression] = STATE(1739),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1739),
    [sym_ternary_expression] = STATE(1739),
    [sym_binary_expression] = STATE(1739),
    [sym_template_string] = STATE(1739),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1739),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1739),
    [sym_class] = STATE(1739),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(1879),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(1897),
    [sym_true] = ACTIONS(3652),
    [anon_sym_COLON] = ACTIONS(211),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1885),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(3652),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3652),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(3654),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3652),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [918] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(3656),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(3658),
    [anon_sym_symbol] = ACTIONS(3658),
    [anon_sym_number] = ACTIONS(3658),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3658),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3660),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3658),
    [anon_sym_private] = ACTIONS(3658),
    [anon_sym_boolean] = ACTIONS(3658),
    [anon_sym_async] = ACTIONS(3662),
    [anon_sym_public] = ACTIONS(3658),
    [anon_sym_get] = ACTIONS(3658),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3658),
    [anon_sym_string] = ACTIONS(3658),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(3658),
    [anon_sym_type] = ACTIONS(3658),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(3658),
    [anon_sym_export] = ACTIONS(3658),
    [anon_sym_namespace] = ACTIONS(3664),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [919] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(3632),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3632),
    [anon_sym_AMP_EQ] = ACTIONS(3632),
    [anon_sym_PLUS_EQ] = ACTIONS(3632),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(3632),
    [anon_sym_STAR_EQ] = ACTIONS(3632),
    [anon_sym_PIPE_EQ] = ACTIONS(3632),
    [anon_sym_DASH_EQ] = ACTIONS(3632),
    [anon_sym_EQ_GT] = ACTIONS(3634),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(3632),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_SLASH_EQ] = ACTIONS(3632),
    [anon_sym_GT_GT_EQ] = ACTIONS(3632),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3632),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [920] = {
    [sym_new_expression] = STATE(1745),
    [sym_augmented_assignment_expression] = STATE(1745),
    [sym_unary_expression] = STATE(1745),
    [sym_update_expression] = STATE(1745),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(1745),
    [sym_regex] = STATE(1745),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1745),
    [sym_non_null_expression] = STATE(1745),
    [sym_as_expression] = STATE(1745),
    [sym_jsx_fragment] = STATE(1745),
    [sym_yield_expression] = STATE(1745),
    [sym_jsx_element] = STATE(1745),
    [sym_internal_module] = STATE(1745),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1745),
    [sym_await_expression] = STATE(1745),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(1745),
    [sym_this] = STATE(1745),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(1745),
    [sym_generator_function] = STATE(1745),
    [sym_call_expression] = STATE(1745),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1745),
    [sym_ternary_expression] = STATE(1745),
    [sym_binary_expression] = STATE(1745),
    [sym_template_string] = STATE(1745),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1745),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1745),
    [sym_class] = STATE(1745),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(3666),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3666),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3668),
    [sym_true] = ACTIONS(3666),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3666),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [921] = {
    [anon_sym_EQ_GT] = ACTIONS(3628),
    [sym_comment] = ACTIONS(3),
  },
  [922] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3630),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3692),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [923] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(3624),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3624),
    [anon_sym_AMP_EQ] = ACTIONS(3624),
    [anon_sym_PLUS_EQ] = ACTIONS(3624),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(3624),
    [anon_sym_STAR_EQ] = ACTIONS(3624),
    [anon_sym_PIPE_EQ] = ACTIONS(3624),
    [anon_sym_DASH_EQ] = ACTIONS(3624),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(3624),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(3624),
    [anon_sym_GT_GT_EQ] = ACTIONS(3624),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3624),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [924] = {
    [sym__initializer] = STATE(587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3630),
  },
  [925] = {
    [sym__initializer] = STATE(589),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3630),
  },
  [926] = {
    [sym_type_arguments] = STATE(1759),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(3696),
    [anon_sym_BANG] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [sym__automatic_semicolon] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_GT_GT_GT] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_is] = ACTIONS(3701),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_instanceof] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_STAR_STAR] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2204),
    [anon_sym_in] = ACTIONS(3699),
  },
  [927] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_SEMI] = ACTIONS(2212),
    [anon_sym_BQUOTE] = ACTIONS(2212),
    [sym__automatic_semicolon] = ACTIONS(2212),
    [anon_sym_PIPE] = ACTIONS(2210),
    [anon_sym_COMMA] = ACTIONS(2212),
    [anon_sym_LT_LT] = ACTIONS(2212),
    [anon_sym_STAR] = ACTIONS(2210),
    [anon_sym_GT_GT_GT] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2212),
    [anon_sym_DASH] = ACTIONS(2210),
    [anon_sym_BANG_EQ] = ACTIONS(2210),
    [anon_sym_LT_EQ] = ACTIONS(2212),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_GT_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2210),
    [anon_sym_AMP] = ACTIONS(2210),
    [anon_sym_PERCENT] = ACTIONS(2212),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_as] = ACTIONS(2212),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [anon_sym_EQ_EQ] = ACTIONS(2210),
    [anon_sym_instanceof] = ACTIONS(2212),
    [anon_sym_LT] = ACTIONS(2210),
    [anon_sym_RPAREN] = ACTIONS(2212),
    [anon_sym_SLASH] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2212),
    [anon_sym_CARET] = ACTIONS(2212),
    [anon_sym_STAR_STAR] = ACTIONS(2212),
    [anon_sym_PLUS] = ACTIONS(2210),
    [anon_sym_GT_GT] = ACTIONS(2210),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2212),
    [anon_sym_in] = ACTIONS(2210),
  },
  [928] = {
    [sym_index_type_query] = STATE(1761),
    [sym_lookup_type] = STATE(1761),
    [sym_flow_maybe_type] = STATE(1761),
    [sym_parenthesized_type] = STATE(1761),
    [sym_nested_type_identifier] = STATE(942),
    [sym_array_type] = STATE(1761),
    [sym_type_predicate] = STATE(1761),
    [sym_type_query] = STATE(1761),
    [sym_existential_type] = STATE(1761),
    [sym_this_type] = STATE(1761),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(1761),
    [sym__primary_type] = STATE(1761),
    [sym_generic_type] = STATE(1761),
    [sym_literal_type] = STATE(1761),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(1761),
    [sym_string] = STATE(927),
    [sym_tuple_type] = STATE(1761),
    [sym_identifier] = ACTIONS(1905),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(1931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [sym_true] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(3708),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [929] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(1764),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(1764),
    [sym_call_signature] = STATE(1764),
    [sym_export_statement] = STATE(1764),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(1764),
    [sym_index_signature] = STATE(1764),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_SEMI] = ACTIONS(3710),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_RBRACE] = ACTIONS(3712),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3712),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [930] = {
    [sym_union_type] = STATE(1765),
    [sym__type] = STATE(1765),
    [sym_constructor_type] = STATE(1765),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1089),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1765),
    [sym_function_type] = STATE(1765),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1090),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [931] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym_BQUOTE] = ACTIONS(2250),
    [sym__automatic_semicolon] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_LT_LT] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2248),
    [anon_sym_GT_GT_GT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_BANG_EQ] = ACTIONS(2248),
    [anon_sym_LT_EQ] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_GT_EQ] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_as] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2248),
    [anon_sym_instanceof] = ACTIONS(2250),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(2248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_STAR_STAR] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_GT_GT] = ACTIONS(2248),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2250),
    [anon_sym_in] = ACTIONS(2248),
  },
  [932] = {
    [sym_union_type] = STATE(1766),
    [sym__type] = STATE(1766),
    [sym_constructor_type] = STATE(1766),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(943),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(1766),
    [sym_function_type] = STATE(1766),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(947),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(1905),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(1931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1929),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(1937),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [933] = {
    [sym_nested_identifier] = STATE(1767),
    [sym_identifier] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
  },
  [934] = {
    [sym_nested_type_identifier] = STATE(1769),
    [sym_nested_identifier] = STATE(944),
    [sym_identifier] = ACTIONS(3716),
    [sym_comment] = ACTIONS(3),
  },
  [935] = {
    [sym_number] = ACTIONS(3718),
    [sym_comment] = ACTIONS(3),
  },
  [936] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2262),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym_BQUOTE] = ACTIONS(2262),
    [sym__automatic_semicolon] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_COMMA] = ACTIONS(2262),
    [anon_sym_LT_LT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(2260),
    [anon_sym_GT_GT_GT] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_BANG_EQ] = ACTIONS(2260),
    [anon_sym_LT_EQ] = ACTIONS(2262),
    [anon_sym_LPAREN] = ACTIONS(2262),
    [anon_sym_GT_EQ] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_PERCENT] = ACTIONS(2262),
    [anon_sym_QMARK] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2262),
    [anon_sym_as] = ACTIONS(2262),
    [anon_sym_PIPE_PIPE] = ACTIONS(2262),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_EQ_EQ] = ACTIONS(2260),
    [anon_sym_instanceof] = ACTIONS(2262),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_RPAREN] = ACTIONS(2262),
    [anon_sym_SLASH] = ACTIONS(2260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2262),
    [anon_sym_CARET] = ACTIONS(2262),
    [anon_sym_STAR_STAR] = ACTIONS(2262),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_GT_GT] = ACTIONS(2260),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2262),
    [anon_sym_in] = ACTIONS(2260),
  },
  [937] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym_BQUOTE] = ACTIONS(2254),
    [sym__automatic_semicolon] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_LT_LT] = ACTIONS(2254),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_GT_GT_GT] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT_EQ] = ACTIONS(2254),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [anon_sym_GT_EQ] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2252),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2254),
    [anon_sym_QMARK] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_as] = ACTIONS(2254),
    [anon_sym_PIPE_PIPE] = ACTIONS(2254),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_instanceof] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2252),
    [anon_sym_RPAREN] = ACTIONS(2254),
    [anon_sym_SLASH] = ACTIONS(2252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2254),
    [anon_sym_CARET] = ACTIONS(2254),
    [anon_sym_STAR_STAR] = ACTIONS(2254),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_GT_GT] = ACTIONS(2252),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2254),
    [anon_sym_in] = ACTIONS(2252),
  },
  [938] = {
    [sym_type_parameters] = STATE(1771),
    [sym_formal_parameters] = STATE(1772),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [939] = {
    [sym__type] = STATE(1773),
    [sym_constructor_type] = STATE(1773),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_type_parameters] = STATE(1108),
    [sym_array_type] = STATE(436),
    [sym_rest_parameter] = STATE(244),
    [sym_nested_identifier] = STATE(435),
    [sym_accessibility_modifier] = STATE(247),
    [sym_required_parameter] = STATE(244),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_this] = STATE(772),
    [sym_tuple_type] = STATE(436),
    [sym_union_type] = STATE(1773),
    [aux_sym_export_statement_repeat1] = STATE(781),
    [sym_object] = STATE(769),
    [sym_nested_type_identifier] = STATE(433),
    [sym_optional_parameter] = STATE(244),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_object_type] = STATE(436),
    [sym_decorator] = STATE(781),
    [sym_intersection_type] = STATE(1773),
    [sym_function_type] = STATE(1773),
    [sym_formal_parameters] = STATE(1109),
    [sym_array] = STATE(771),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [sym_identifier] = ACTIONS(2268),
    [sym_false] = ACTIONS(753),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(2270),
    [anon_sym_number] = ACTIONS(2270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_void] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(2270),
    [anon_sym_private] = ACTIONS(1446),
    [anon_sym_boolean] = ACTIONS(2270),
    [anon_sym_async] = ACTIONS(1442),
    [anon_sym_public] = ACTIONS(1446),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_RPAREN] = ACTIONS(428),
    [anon_sym_this] = ACTIONS(2280),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1446),
    [anon_sym_string] = ACTIONS(2270),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_new] = ACTIONS(2282),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [940] = {
    [sym_union_type] = STATE(1774),
    [sym__type] = STATE(1774),
    [sym_constructor_type] = STATE(1774),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(943),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(1774),
    [sym_function_type] = STATE(1774),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(947),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(1905),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(1931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1929),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(1937),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [941] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3720),
    [anon_sym_LBRACK] = ACTIONS(3720),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_SEMI] = ACTIONS(3720),
    [anon_sym_BQUOTE] = ACTIONS(3720),
    [sym__automatic_semicolon] = ACTIONS(3720),
    [anon_sym_PIPE] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3720),
    [anon_sym_LT_LT] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3722),
    [anon_sym_GT_GT_GT] = ACTIONS(3720),
    [anon_sym_AMP_AMP] = ACTIONS(3720),
    [anon_sym_DASH] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_LT_EQ] = ACTIONS(3720),
    [anon_sym_LPAREN] = ACTIONS(3720),
    [anon_sym_GT_EQ] = ACTIONS(3720),
    [anon_sym_GT] = ACTIONS(3722),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_PERCENT] = ACTIONS(3720),
    [anon_sym_QMARK] = ACTIONS(3720),
    [anon_sym_RBRACE] = ACTIONS(3720),
    [anon_sym_as] = ACTIONS(3720),
    [anon_sym_PIPE_PIPE] = ACTIONS(3720),
    [anon_sym_DASH_DASH] = ACTIONS(3720),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_instanceof] = ACTIONS(3720),
    [anon_sym_LT] = ACTIONS(3722),
    [anon_sym_RPAREN] = ACTIONS(3720),
    [anon_sym_SLASH] = ACTIONS(3722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3720),
    [anon_sym_CARET] = ACTIONS(3720),
    [anon_sym_STAR_STAR] = ACTIONS(3720),
    [anon_sym_PLUS] = ACTIONS(3722),
    [anon_sym_GT_GT] = ACTIONS(3722),
    [anon_sym_PLUS_PLUS] = ACTIONS(3720),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3720),
    [anon_sym_in] = ACTIONS(3722),
  },
  [942] = {
    [sym_type_arguments] = STATE(1778),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(3724),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_SEMI] = ACTIONS(2292),
    [anon_sym_BQUOTE] = ACTIONS(2292),
    [sym__automatic_semicolon] = ACTIONS(2292),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_COMMA] = ACTIONS(2292),
    [anon_sym_LT_LT] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2297),
    [anon_sym_GT_GT_GT] = ACTIONS(2292),
    [anon_sym_AMP_AMP] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2297),
    [anon_sym_BANG_EQ] = ACTIONS(2297),
    [anon_sym_LT_EQ] = ACTIONS(2292),
    [anon_sym_LPAREN] = ACTIONS(2292),
    [anon_sym_GT_EQ] = ACTIONS(2292),
    [anon_sym_GT] = ACTIONS(2297),
    [anon_sym_AMP] = ACTIONS(2297),
    [anon_sym_PERCENT] = ACTIONS(2292),
    [anon_sym_QMARK] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(2292),
    [anon_sym_as] = ACTIONS(2292),
    [anon_sym_PIPE_PIPE] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [anon_sym_EQ_EQ] = ACTIONS(2297),
    [anon_sym_instanceof] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(3727),
    [anon_sym_RPAREN] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2297),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2292),
    [anon_sym_CARET] = ACTIONS(2292),
    [anon_sym_STAR_STAR] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_GT_GT] = ACTIONS(2297),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2297),
  },
  [943] = {
    [sym_formal_parameters] = STATE(1779),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [944] = {
    [anon_sym_DOT] = ACTIONS(3706),
    [sym_comment] = ACTIONS(3),
  },
  [945] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3720),
    [anon_sym_LBRACK] = ACTIONS(3720),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_SEMI] = ACTIONS(3720),
    [anon_sym_BQUOTE] = ACTIONS(3720),
    [sym__automatic_semicolon] = ACTIONS(3720),
    [anon_sym_PIPE] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3720),
    [anon_sym_LT_LT] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3722),
    [anon_sym_GT_GT_GT] = ACTIONS(3720),
    [anon_sym_AMP_AMP] = ACTIONS(3720),
    [anon_sym_DASH] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_LT_EQ] = ACTIONS(3720),
    [anon_sym_LPAREN] = ACTIONS(3720),
    [anon_sym_GT_EQ] = ACTIONS(3720),
    [anon_sym_GT] = ACTIONS(3722),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_PERCENT] = ACTIONS(3720),
    [anon_sym_QMARK] = ACTIONS(3720),
    [anon_sym_RBRACE] = ACTIONS(3720),
    [anon_sym_as] = ACTIONS(3720),
    [anon_sym_PIPE_PIPE] = ACTIONS(3720),
    [anon_sym_DASH_DASH] = ACTIONS(3720),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_instanceof] = ACTIONS(3720),
    [anon_sym_LT] = ACTIONS(3722),
    [anon_sym_RPAREN] = ACTIONS(3720),
    [anon_sym_SLASH] = ACTIONS(3722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3720),
    [anon_sym_CARET] = ACTIONS(3720),
    [anon_sym_STAR_STAR] = ACTIONS(3720),
    [anon_sym_PLUS] = ACTIONS(3722),
    [anon_sym_GT_GT] = ACTIONS(3722),
    [anon_sym_PLUS_PLUS] = ACTIONS(3720),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3720),
    [anon_sym_in] = ACTIONS(3722),
  },
  [946] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2301),
    [anon_sym_LBRACK] = ACTIONS(3730),
    [anon_sym_BANG] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2301),
    [anon_sym_BQUOTE] = ACTIONS(2301),
    [sym__automatic_semicolon] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2299),
    [anon_sym_COMMA] = ACTIONS(2301),
    [anon_sym_LT_LT] = ACTIONS(2301),
    [anon_sym_STAR] = ACTIONS(2299),
    [anon_sym_GT_GT_GT] = ACTIONS(2301),
    [anon_sym_AMP_AMP] = ACTIONS(2301),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_BANG_EQ] = ACTIONS(2299),
    [anon_sym_LT_EQ] = ACTIONS(2301),
    [anon_sym_LPAREN] = ACTIONS(2301),
    [anon_sym_GT_EQ] = ACTIONS(2301),
    [anon_sym_GT] = ACTIONS(2299),
    [anon_sym_AMP] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_QMARK] = ACTIONS(2301),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [anon_sym_as] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_DASH_DASH] = ACTIONS(2301),
    [anon_sym_EQ_EQ] = ACTIONS(2299),
    [anon_sym_instanceof] = ACTIONS(2301),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_RPAREN] = ACTIONS(2301),
    [anon_sym_SLASH] = ACTIONS(2299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2301),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2301),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_GT_GT] = ACTIONS(2299),
    [anon_sym_PLUS_PLUS] = ACTIONS(2301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2301),
    [anon_sym_in] = ACTIONS(2299),
  },
  [947] = {
    [anon_sym_EQ_GT] = ACTIONS(3732),
    [sym_comment] = ACTIONS(3),
  },
  [948] = {
    [sym__initializer] = STATE(71),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_GT] = ACTIONS(3738),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [949] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3749),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_COMMA] = ACTIONS(3749),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3752),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [950] = {
    [sym_new_expression] = STATE(160),
    [sym_constructor_type] = STATE(1088),
    [sym_augmented_assignment_expression] = STATE(160),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(160),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(160),
    [sym_type_parameters] = STATE(1791),
    [sym_array_type] = STATE(436),
    [sym_yield_expression] = STATE(160),
    [sym_as_expression] = STATE(160),
    [sym_jsx_fragment] = STATE(160),
    [sym_internal_module] = STATE(160),
    [sym_arrow_function] = STATE(160),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(162),
    [sym_literal_type] = STATE(436),
    [sym_spread_element] = STATE(163),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(1788),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [aux_sym_array_repeat1] = STATE(166),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(160),
    [sym_subscript_expression] = STATE(162),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(160),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(160),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(1792),
    [sym_function_type] = STATE(1088),
    [sym__type] = STATE(1088),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(160),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(160),
    [sym__expression] = STATE(160),
    [sym_non_null_expression] = STATE(160),
    [sym_jsx_element] = STATE(160),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_await_expression] = STATE(160),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_this] = STATE(160),
    [sym_union_type] = STATE(1088),
    [sym_anonymous_class] = STATE(160),
    [sym_call_expression] = STATE(160),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(160),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(160),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1088),
    [sym_parenthesized_expression] = STATE(160),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(160),
    [sym_class] = STATE(160),
    [sym_identifier] = ACTIONS(3755),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(3757),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(2246),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_void] = ACTIONS(3761),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(3763),
    [anon_sym_yield] = ACTIONS(290),
    [sym_true] = ACTIONS(3765),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [sym_false] = ACTIONS(3765),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(3757),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(3767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(268),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [anon_sym_RBRACK] = ACTIONS(276),
    [sym_null] = ACTIONS(256),
    [anon_sym_any] = ACTIONS(3757),
    [anon_sym_boolean] = ACTIONS(3757),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(256),
    [anon_sym_new] = ACTIONS(3771),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_TILDE] = ACTIONS(252),
  },
  [951] = {
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [952] = {
    [sym_new_expression] = STATE(90),
    [sym_augmented_assignment_expression] = STATE(90),
    [sym_unary_expression] = STATE(90),
    [sym_update_expression] = STATE(90),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(90),
    [sym_regex] = STATE(90),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(90),
    [sym_non_null_expression] = STATE(90),
    [sym_as_expression] = STATE(90),
    [sym_jsx_fragment] = STATE(90),
    [sym_yield_expression] = STATE(90),
    [sym_jsx_element] = STATE(90),
    [sym_internal_module] = STATE(90),
    [sym_nested_identifier] = STATE(1092),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(90),
    [sym_await_expression] = STATE(90),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(90),
    [sym_this] = STATE(90),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(90),
    [sym_generator_function] = STATE(90),
    [sym_call_expression] = STATE(90),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(90),
    [sym_ternary_expression] = STATE(90),
    [sym_binary_expression] = STATE(90),
    [sym_template_string] = STATE(90),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(90),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(90),
    [sym_class] = STATE(90),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(3779),
    [sym_false] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(161),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(167),
    [sym_true] = ACTIONS(161),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(161),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [953] = {
    [sym_new_expression] = STATE(87),
    [sym_augmented_assignment_expression] = STATE(87),
    [sym_unary_expression] = STATE(87),
    [sym_update_expression] = STATE(87),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(87),
    [sym_regex] = STATE(87),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(87),
    [sym_non_null_expression] = STATE(87),
    [sym_as_expression] = STATE(87),
    [sym_jsx_fragment] = STATE(87),
    [sym_yield_expression] = STATE(87),
    [sym_jsx_element] = STATE(87),
    [sym_internal_module] = STATE(87),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(87),
    [sym_await_expression] = STATE(87),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(87),
    [sym_this] = STATE(87),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(87),
    [sym_generator_function] = STATE(87),
    [sym_call_expression] = STATE(87),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(87),
    [sym_ternary_expression] = STATE(87),
    [sym_binary_expression] = STATE(87),
    [sym_template_string] = STATE(87),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(87),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(87),
    [sym_class] = STATE(87),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3781),
    [sym_true] = ACTIONS(151),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(151),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [954] = {
    [aux_sym_export_statement_repeat1] = STATE(1806),
    [sym__property_name] = STATE(1807),
    [sym_object] = STATE(384),
    [sym_assignment_pattern] = STATE(222),
    [sym_pair] = STATE(222),
    [sym_method_signature] = STATE(1079),
    [sym_call_signature] = STATE(1079),
    [sym_type_parameters] = STATE(1082),
    [sym_index_signature] = STATE(1079),
    [sym_export_statement] = STATE(1079),
    [sym_method_definition] = STATE(222),
    [aux_sym_object_repeat1] = STATE(220),
    [sym_property_signature] = STATE(1079),
    [sym_decorator] = STATE(1806),
    [sym_construct_signature] = STATE(1079),
    [sym_accessibility_modifier] = STATE(1808),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1807),
    [sym_array] = STATE(385),
    [sym_spread_element] = STATE(222),
    [sym_string] = STATE(1807),
    [sym_identifier] = ACTIONS(3783),
    [anon_sym_LBRACK] = ACTIONS(3785),
    [anon_sym_SEMI] = ACTIONS(2218),
    [anon_sym_module] = ACTIONS(3787),
    [anon_sym_symbol] = ACTIONS(3787),
    [anon_sym_number] = ACTIONS(3787),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(3787),
    [anon_sym_COMMA] = ACTIONS(3789),
    [anon_sym_STAR] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_void] = ACTIONS(3787),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(3787),
    [anon_sym_private] = ACTIONS(3793),
    [anon_sym_boolean] = ACTIONS(3787),
    [anon_sym_static] = ACTIONS(3795),
    [anon_sym_async] = ACTIONS(3797),
    [anon_sym_get] = ACTIONS(3799),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_public] = ACTIONS(3793),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(3801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3793),
    [anon_sym_string] = ACTIONS(3787),
    [anon_sym_set] = ACTIONS(3799),
    [anon_sym_type] = ACTIONS(3787),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(3787),
    [anon_sym_export] = ACTIONS(3803),
    [sym_readonly] = ACTIONS(3805),
    [anon_sym_namespace] = ACTIONS(3787),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [955] = {
    [sym_new_expression] = STATE(90),
    [sym_augmented_assignment_expression] = STATE(90),
    [sym__initializer] = STATE(79),
    [sym_unary_expression] = STATE(90),
    [sym_update_expression] = STATE(90),
    [sym_regex] = STATE(90),
    [sym_meta_property] = STATE(90),
    [sym_call_signature] = STATE(58),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(90),
    [sym_non_null_expression] = STATE(90),
    [sym_yield_expression] = STATE(90),
    [sym_jsx_fragment] = STATE(90),
    [sym_jsx_element] = STATE(90),
    [sym_as_expression] = STATE(90),
    [sym_internal_module] = STATE(90),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(90),
    [sym_await_expression] = STATE(90),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(90),
    [sym_this] = STATE(90),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(90),
    [sym_generator_function] = STATE(90),
    [sym_call_expression] = STATE(90),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(90),
    [sym_ternary_expression] = STATE(90),
    [sym_binary_expression] = STATE(90),
    [sym_template_string] = STATE(90),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(90),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(90),
    [sym_class] = STATE(90),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(161),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(161),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [956] = {
    [sym_new_expression] = STATE(245),
    [sym_constructor_type] = STATE(1107),
    [sym_augmented_assignment_expression] = STATE(245),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(245),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(245),
    [sym_type_parameters] = STATE(1817),
    [sym_array_type] = STATE(436),
    [sym_rest_parameter] = STATE(244),
    [sym_yield_expression] = STATE(245),
    [sym_as_expression] = STATE(245),
    [sym_jsx_fragment] = STATE(245),
    [sym_internal_module] = STATE(245),
    [sym_accessibility_modifier] = STATE(247),
    [sym_arrow_function] = STATE(245),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(246),
    [sym_literal_type] = STATE(436),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(1814),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(250),
    [sym_object] = STATE(251),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(245),
    [sym_subscript_expression] = STATE(246),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(245),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(245),
    [sym_decorator] = STATE(250),
    [sym_formal_parameters] = STATE(1818),
    [sym_function_type] = STATE(1107),
    [sym__type] = STATE(1107),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(245),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(245),
    [sym__expression] = STATE(245),
    [sym_non_null_expression] = STATE(245),
    [sym_jsx_element] = STATE(245),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_required_parameter] = STATE(244),
    [sym_await_expression] = STATE(245),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_sequence_expression] = STATE(248),
    [sym_this] = STATE(249),
    [sym_union_type] = STATE(1107),
    [sym_anonymous_class] = STATE(245),
    [sym_optional_parameter] = STATE(244),
    [sym_call_expression] = STATE(245),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(245),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(245),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1107),
    [sym_parenthesized_expression] = STATE(245),
    [sym_array] = STATE(252),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(245),
    [sym_class] = STATE(245),
    [sym_identifier] = ACTIONS(3807),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(3809),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(2274),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_void] = ACTIONS(3813),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(424),
    [anon_sym_get] = ACTIONS(414),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_this] = ACTIONS(3815),
    [anon_sym_yield] = ACTIONS(432),
    [sym_true] = ACTIONS(3817),
    [anon_sym_protected] = ACTIONS(424),
    [anon_sym_set] = ACTIONS(414),
    [anon_sym_type] = ACTIONS(414),
    [anon_sym_import] = ACTIONS(414),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(438),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [sym_false] = ACTIONS(3817),
    [anon_sym_module] = ACTIONS(414),
    [anon_sym_number] = ACTIONS(3809),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(414),
    [anon_sym_typeof] = ACTIONS(3819),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [sym_null] = ACTIONS(410),
    [anon_sym_any] = ACTIONS(3809),
    [anon_sym_boolean] = ACTIONS(3809),
    [anon_sym_async] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(424),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_RPAREN] = ACTIONS(428),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3821),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3809),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(410),
    [anon_sym_new] = ACTIONS(3823),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_export] = ACTIONS(414),
    [anon_sym_TILDE] = ACTIONS(412),
  },
  [957] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_SEMI] = ACTIONS(207),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym__automatic_semicolon] = ACTIONS(207),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3825),
    [anon_sym_LT_LT] = ACTIONS(207),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_GT_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_BANG_EQ] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(207),
    [anon_sym_GT_EQ] = ACTIONS(207),
    [anon_sym_GT] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_RBRACE] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_DASH_DASH] = ACTIONS(207),
    [anon_sym_EQ_EQ] = ACTIONS(209),
    [anon_sym_instanceof] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_SLASH] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(207),
    [anon_sym_CARET] = ACTIONS(207),
    [anon_sym_STAR_STAR] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_GT_GT] = ACTIONS(209),
    [anon_sym_PLUS_PLUS] = ACTIONS(207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(209),
  },
  [958] = {
    [sym_new_expression] = STATE(277),
    [sym_augmented_assignment_expression] = STATE(289),
    [sym_unary_expression] = STATE(289),
    [sym_update_expression] = STATE(289),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(277),
    [sym_regex] = STATE(277),
    [sym_type_parameters] = STATE(1819),
    [sym__expression] = STATE(289),
    [sym_non_null_expression] = STATE(289),
    [sym_as_expression] = STATE(289),
    [sym_jsx_fragment] = STATE(289),
    [sym_yield_expression] = STATE(289),
    [sym_jsx_element] = STATE(289),
    [sym_internal_module] = STATE(289),
    [sym_function] = STATE(290),
    [sym_arrow_function] = STATE(277),
    [sym_await_expression] = STATE(289),
    [sym_member_expression] = STATE(291),
    [sym_string] = STATE(277),
    [sym_this] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(292),
    [sym_anonymous_class] = STATE(277),
    [sym_generator_function] = STATE(277),
    [sym_call_expression] = STATE(289),
    [sym_subscript_expression] = STATE(291),
    [sym_assignment_expression] = STATE(289),
    [sym_ternary_expression] = STATE(289),
    [sym_binary_expression] = STATE(289),
    [sym_template_string] = STATE(277),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(1820),
    [sym_parenthesized_expression] = STATE(277),
    [sym_array] = STATE(293),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(289),
    [sym_class] = STATE(277),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(480),
    [sym_false] = ACTIONS(482),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(486),
    [anon_sym_symbol] = ACTIONS(486),
    [anon_sym_number] = ACTIONS(486),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(486),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(482),
    [sym_super] = ACTIONS(494),
    [anon_sym_any] = ACTIONS(486),
    [anon_sym_private] = ACTIONS(486),
    [anon_sym_boolean] = ACTIONS(486),
    [anon_sym_async] = ACTIONS(496),
    [anon_sym_public] = ACTIONS(486),
    [anon_sym_get] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(498),
    [sym_true] = ACTIONS(482),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(486),
    [anon_sym_string] = ACTIONS(486),
    [anon_sym_function] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(502),
    [sym_undefined] = ACTIONS(482),
    [anon_sym_set] = ACTIONS(486),
    [anon_sym_type] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(486),
    [anon_sym_export] = ACTIONS(486),
    [anon_sym_namespace] = ACTIONS(504),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [959] = {
    [sym_formal_parameters] = STATE(1821),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [960] = {
    [sym_type_annotation] = STATE(323),
    [anon_sym_EQ_GT] = ACTIONS(3831),
    [anon_sym_COLON] = ACTIONS(550),
    [sym_comment] = ACTIONS(3),
  },
  [961] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [962] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(1823),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(1823),
    [sym_jsx_expression] = STATE(1823),
    [sym_type_arguments] = STATE(808),
    [anon_sym_COLON] = ACTIONS(1513),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_DOT] = ACTIONS(1498),
    [sym_jsx_identifier] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1515),
    [anon_sym_LT] = ACTIONS(1505),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [963] = {
    [sym_nested_identifier] = STATE(1826),
    [sym_jsx_namespace_name] = STATE(1827),
    [sym_identifier] = ACTIONS(3836),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(3838),
  },
  [964] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(1823),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(1823),
    [sym_jsx_expression] = STATE(1823),
    [anon_sym_COLON] = ACTIONS(1513),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_GT] = ACTIONS(1515),
    [sym_jsx_identifier] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [965] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(1823),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(1823),
    [sym_jsx_expression] = STATE(1823),
    [sym_type_arguments] = STATE(808),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_DOT] = ACTIONS(1498),
    [sym_jsx_identifier] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1515),
    [anon_sym_LT] = ACTIONS(1505),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [966] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(1823),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(1823),
    [sym_jsx_expression] = STATE(1823),
    [anon_sym_GT] = ACTIONS(1515),
    [sym_identifier] = ACTIONS(1492),
    [sym_jsx_identifier] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [967] = {
    [sym_new_expression] = STATE(1840),
    [sym_augmented_assignment_expression] = STATE(1840),
    [sym_unary_expression] = STATE(1840),
    [sym_update_expression] = STATE(1840),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(1840),
    [sym_regex] = STATE(1840),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1840),
    [sym_non_null_expression] = STATE(1840),
    [sym_as_expression] = STATE(1840),
    [sym_jsx_fragment] = STATE(1840),
    [sym_yield_expression] = STATE(1840),
    [sym_jsx_element] = STATE(1840),
    [sym_internal_module] = STATE(1840),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1840),
    [sym_await_expression] = STATE(1840),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(1840),
    [sym_this] = STATE(1840),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(1840),
    [sym_generator_function] = STATE(1840),
    [sym_call_expression] = STATE(1840),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(1840),
    [sym_ternary_expression] = STATE(1840),
    [sym_binary_expression] = STATE(1840),
    [sym_template_string] = STATE(1840),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1840),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1840),
    [sym_class] = STATE(1840),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3842),
    [sym_false] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3844),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3858),
    [sym_true] = ACTIONS(3844),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3844),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [968] = {
    [sym_jsx_text] = ACTIONS(3868),
    [anon_sym_LT] = ACTIONS(3868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3868),
  },
  [969] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2021),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_BANG_EQ] = ACTIONS(2021),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2021),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_QMARK] = ACTIONS(2077),
    [anon_sym_RBRACE] = ACTIONS(3870),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2021),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2081),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [970] = {
    [anon_sym_RBRACE] = ACTIONS(3870),
    [sym_comment] = ACTIONS(3),
  },
  [971] = {
    [sym_nested_identifier] = STATE(965),
    [sym_jsx_namespace_name] = STATE(966),
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(3872),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1975),
  },
  [972] = {
    [sym_jsx_text] = ACTIONS(1987),
    [anon_sym_LT] = ACTIONS(1987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1987),
  },
  [973] = {
    [sym_jsx_closing_element] = STATE(1846),
    [sym_jsx_opening_element] = STATE(340),
    [aux_sym_jsx_element_repeat1] = STATE(975),
    [sym_jsx_expression] = STATE(975),
    [sym_jsx_self_closing_element] = STATE(975),
    [sym_jsx_element] = STATE(975),
    [sym_jsx_text] = ACTIONS(1993),
    [anon_sym_LT] = ACTIONS(1991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(590),
  },
  [974] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3874),
    [anon_sym_LBRACK] = ACTIONS(3874),
    [anon_sym_BANG] = ACTIONS(3876),
    [anon_sym_SEMI] = ACTIONS(3874),
    [anon_sym_BQUOTE] = ACTIONS(3874),
    [sym__automatic_semicolon] = ACTIONS(3874),
    [anon_sym_PIPE] = ACTIONS(3876),
    [anon_sym_COMMA] = ACTIONS(3874),
    [anon_sym_LT_LT] = ACTIONS(3874),
    [anon_sym_STAR] = ACTIONS(3876),
    [anon_sym_GT_GT_GT] = ACTIONS(3874),
    [anon_sym_AMP_AMP] = ACTIONS(3874),
    [anon_sym_DASH] = ACTIONS(3876),
    [anon_sym_BANG_EQ] = ACTIONS(3876),
    [anon_sym_LT_EQ] = ACTIONS(3874),
    [anon_sym_LPAREN] = ACTIONS(3874),
    [anon_sym_GT_EQ] = ACTIONS(3874),
    [anon_sym_GT] = ACTIONS(3876),
    [anon_sym_AMP] = ACTIONS(3876),
    [anon_sym_PERCENT] = ACTIONS(3874),
    [anon_sym_QMARK] = ACTIONS(3874),
    [anon_sym_RBRACE] = ACTIONS(3874),
    [anon_sym_as] = ACTIONS(3874),
    [anon_sym_PIPE_PIPE] = ACTIONS(3874),
    [anon_sym_DASH_DASH] = ACTIONS(3874),
    [anon_sym_EQ_EQ] = ACTIONS(3876),
    [anon_sym_instanceof] = ACTIONS(3874),
    [anon_sym_LT] = ACTIONS(3876),
    [anon_sym_RPAREN] = ACTIONS(3874),
    [anon_sym_SLASH] = ACTIONS(3876),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3874),
    [anon_sym_CARET] = ACTIONS(3874),
    [anon_sym_STAR_STAR] = ACTIONS(3874),
    [anon_sym_PLUS] = ACTIONS(3876),
    [anon_sym_GT_GT] = ACTIONS(3876),
    [anon_sym_PLUS_PLUS] = ACTIONS(3874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3874),
    [anon_sym_in] = ACTIONS(3876),
  },
  [975] = {
    [sym_jsx_opening_element] = STATE(340),
    [aux_sym_jsx_element_repeat1] = STATE(975),
    [sym_jsx_expression] = STATE(975),
    [sym_jsx_self_closing_element] = STATE(975),
    [sym_jsx_element] = STATE(975),
    [sym_jsx_text] = ACTIONS(3878),
    [anon_sym_LT] = ACTIONS(3881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3884),
  },
  [976] = {
    [sym_type_alias_declaration] = STATE(696),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(696),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(696),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(696),
    [sym_return_statement] = STATE(696),
    [aux_sym_program_repeat1] = STATE(696),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(696),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(696),
    [sym_switch_statement] = STATE(696),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(696),
    [sym_throw_statement] = STATE(696),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(696),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(696),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(696),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(696),
    [sym_abstract_class] = STATE(696),
    [sym_interface_declaration] = STATE(696),
    [sym_statement_block] = STATE(696),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(696),
    [sym_debugger_statement] = STATE(696),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(696),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(696),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(696),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(696),
    [sym_empty_statement] = STATE(696),
    [sym_import_alias] = STATE(696),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(696),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(696),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(696),
    [sym_break_statement] = STATE(696),
    [sym_labeled_statement] = STATE(696),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(696),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(3887),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [977] = {
    [sym_new_expression] = STATE(1849),
    [sym_augmented_assignment_expression] = STATE(1849),
    [sym_unary_expression] = STATE(1849),
    [sym_update_expression] = STATE(1849),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(1849),
    [sym_regex] = STATE(1849),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1233),
    [sym__expression] = STATE(1849),
    [sym_non_null_expression] = STATE(1849),
    [sym_yield_expression] = STATE(1849),
    [sym_jsx_fragment] = STATE(1849),
    [sym_jsx_element] = STATE(1849),
    [sym_as_expression] = STATE(1849),
    [sym_internal_module] = STATE(1849),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1849),
    [sym_await_expression] = STATE(1849),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(1849),
    [sym_this] = STATE(1849),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(1849),
    [sym_generator_function] = STATE(1849),
    [sym_call_expression] = STATE(1849),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(1849),
    [sym_ternary_expression] = STATE(1849),
    [sym_binary_expression] = STATE(1849),
    [sym_template_string] = STATE(1849),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1849),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1849),
    [sym_class] = STATE(1849),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(3889),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3889),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3891),
    [sym_true] = ACTIONS(3889),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3889),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [978] = {
    [sym_new_expression] = STATE(1850),
    [sym_augmented_assignment_expression] = STATE(1850),
    [sym_unary_expression] = STATE(1850),
    [sym_update_expression] = STATE(1850),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(1850),
    [sym_regex] = STATE(1850),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1850),
    [sym_non_null_expression] = STATE(1850),
    [sym_as_expression] = STATE(1850),
    [sym_jsx_fragment] = STATE(1850),
    [sym_yield_expression] = STATE(1850),
    [sym_jsx_element] = STATE(1850),
    [sym_internal_module] = STATE(1850),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1850),
    [sym_await_expression] = STATE(1850),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(1850),
    [sym_this] = STATE(1850),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(1850),
    [sym_generator_function] = STATE(1850),
    [sym_call_expression] = STATE(1850),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(1850),
    [sym_ternary_expression] = STATE(1850),
    [sym_binary_expression] = STATE(1850),
    [sym_template_string] = STATE(1850),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1850),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1850),
    [sym_class] = STATE(1850),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3893),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3895),
    [sym_true] = ACTIONS(3893),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3893),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [979] = {
    [sym_new_expression] = STATE(1851),
    [sym_augmented_assignment_expression] = STATE(1851),
    [sym_unary_expression] = STATE(1851),
    [sym_update_expression] = STATE(1851),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(1851),
    [sym_regex] = STATE(1851),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1851),
    [sym_non_null_expression] = STATE(1851),
    [sym_as_expression] = STATE(1851),
    [sym_jsx_fragment] = STATE(1851),
    [sym_yield_expression] = STATE(1851),
    [sym_jsx_element] = STATE(1851),
    [sym_internal_module] = STATE(1851),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1851),
    [sym_await_expression] = STATE(1851),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(1851),
    [sym_this] = STATE(1851),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(1851),
    [sym_generator_function] = STATE(1851),
    [sym_call_expression] = STATE(1851),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(1851),
    [sym_ternary_expression] = STATE(1851),
    [sym_binary_expression] = STATE(1851),
    [sym_template_string] = STATE(1851),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1851),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1851),
    [sym_class] = STATE(1851),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(3897),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3897),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3899),
    [sym_true] = ACTIONS(3897),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3897),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [980] = {
    [sym_new_expression] = STATE(1852),
    [sym_augmented_assignment_expression] = STATE(1852),
    [sym_unary_expression] = STATE(1852),
    [sym_update_expression] = STATE(1852),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(1852),
    [sym_regex] = STATE(1852),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1852),
    [sym_non_null_expression] = STATE(1852),
    [sym_as_expression] = STATE(1852),
    [sym_jsx_fragment] = STATE(1852),
    [sym_yield_expression] = STATE(1852),
    [sym_jsx_element] = STATE(1852),
    [sym_internal_module] = STATE(1852),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1852),
    [sym_await_expression] = STATE(1852),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(1852),
    [sym_this] = STATE(1852),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(1852),
    [sym_generator_function] = STATE(1852),
    [sym_call_expression] = STATE(1852),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(1852),
    [sym_ternary_expression] = STATE(1852),
    [sym_binary_expression] = STATE(1852),
    [sym_template_string] = STATE(1852),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1852),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1852),
    [sym_class] = STATE(1852),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(3901),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3901),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3903),
    [sym_true] = ACTIONS(3901),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3901),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [981] = {
    [sym_new_expression] = STATE(1853),
    [sym_augmented_assignment_expression] = STATE(1853),
    [sym_unary_expression] = STATE(1853),
    [sym_update_expression] = STATE(1853),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(1853),
    [sym_regex] = STATE(1853),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1240),
    [sym__expression] = STATE(1853),
    [sym_non_null_expression] = STATE(1853),
    [sym_yield_expression] = STATE(1853),
    [sym_jsx_fragment] = STATE(1853),
    [sym_jsx_element] = STATE(1853),
    [sym_as_expression] = STATE(1853),
    [sym_internal_module] = STATE(1853),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1853),
    [sym_await_expression] = STATE(1853),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(1853),
    [sym_this] = STATE(1853),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(1853),
    [sym_generator_function] = STATE(1853),
    [sym_call_expression] = STATE(1853),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(1853),
    [sym_ternary_expression] = STATE(1853),
    [sym_binary_expression] = STATE(1853),
    [sym_template_string] = STATE(1853),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1853),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1853),
    [sym_class] = STATE(1853),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(3905),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3905),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3907),
    [sym_true] = ACTIONS(3905),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3905),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [982] = {
    [sym_new_expression] = STATE(1854),
    [sym_augmented_assignment_expression] = STATE(1854),
    [sym_unary_expression] = STATE(1854),
    [sym_update_expression] = STATE(1854),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(1854),
    [sym_regex] = STATE(1854),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1854),
    [sym_non_null_expression] = STATE(1854),
    [sym_as_expression] = STATE(1854),
    [sym_jsx_fragment] = STATE(1854),
    [sym_yield_expression] = STATE(1854),
    [sym_jsx_element] = STATE(1854),
    [sym_internal_module] = STATE(1854),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1854),
    [sym_await_expression] = STATE(1854),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(1854),
    [sym_this] = STATE(1854),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(1854),
    [sym_generator_function] = STATE(1854),
    [sym_call_expression] = STATE(1854),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(1854),
    [sym_ternary_expression] = STATE(1854),
    [sym_binary_expression] = STATE(1854),
    [sym_template_string] = STATE(1854),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1854),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1854),
    [sym_class] = STATE(1854),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(3909),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3909),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3911),
    [sym_true] = ACTIONS(3909),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3909),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [983] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_RBRACE] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(3913),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [984] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_RBRACE] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(3913),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [985] = {
    [anon_sym_EQ_GT] = ACTIONS(3916),
    [sym_comment] = ACTIONS(3),
  },
  [986] = {
    [anon_sym_EQ_GT] = ACTIONS(3918),
    [sym_comment] = ACTIONS(3),
  },
  [987] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_BQUOTE] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_RBRACE] = ACTIONS(839),
    [anon_sym_AMP] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_instanceof] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_in] = ACTIONS(841),
  },
  [988] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(871),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_BANG_EQ] = ACTIONS(2021),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2021),
    [anon_sym_RBRACE] = ACTIONS(871),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_QMARK] = ACTIONS(2077),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2021),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2081),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2021),
  },
  [989] = {
    [sym__initializer] = STATE(522),
    [sym_arguments] = STATE(1268),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1531),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_RBRACE] = ACTIONS(1529),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [990] = {
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(2025),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_RBRACE] = ACTIONS(1539),
    [anon_sym_as] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [991] = {
    [sym_new_expression] = STATE(836),
    [sym_augmented_assignment_expression] = STATE(836),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(836),
    [sym_update_expression] = STATE(836),
    [sym_regex] = STATE(836),
    [sym_meta_property] = STATE(836),
    [sym_call_signature] = STATE(835),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(836),
    [sym_non_null_expression] = STATE(836),
    [sym_yield_expression] = STATE(836),
    [sym_jsx_fragment] = STATE(836),
    [sym_jsx_element] = STATE(836),
    [sym_as_expression] = STATE(836),
    [sym_internal_module] = STATE(836),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(836),
    [sym_await_expression] = STATE(836),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(836),
    [sym_this] = STATE(836),
    [sym_arguments] = STATE(1270),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(836),
    [sym_generator_function] = STATE(836),
    [sym_call_expression] = STATE(836),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(836),
    [sym_ternary_expression] = STATE(836),
    [sym_binary_expression] = STATE(836),
    [sym_template_string] = STATE(836),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(836),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(836),
    [sym_class] = STATE(836),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_RBRACE] = ACTIONS(1539),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(500),
    [sym_true] = ACTIONS(1545),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [sym_false] = ACTIONS(1545),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [sym_null] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(2025),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [sym_number] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [992] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_arguments] = STATE(1270),
    [sym_call_signature] = STATE(985),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(2035),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(2037),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(2037),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(2037),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(2037),
    [anon_sym_RBRACE] = ACTIONS(1539),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_protected] = ACTIONS(2037),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(2037),
    [anon_sym_type] = ACTIONS(2037),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(2037),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(2037),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2037),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(2037),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(2037),
    [anon_sym_async] = ACTIONS(2037),
    [anon_sym_public] = ACTIONS(2037),
    [anon_sym_EQ_GT] = ACTIONS(2025),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(2037),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(2037),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [993] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(2025),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_RBRACE] = ACTIONS(1539),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [994] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_BANG_EQ] = ACTIONS(2021),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2021),
    [anon_sym_RBRACE] = ACTIONS(915),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_QMARK] = ACTIONS(2077),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2021),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2081),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2021),
  },
  [995] = {
    [sym_new_expression] = STATE(1857),
    [sym_augmented_assignment_expression] = STATE(1857),
    [sym_unary_expression] = STATE(1857),
    [sym_update_expression] = STATE(1857),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(1857),
    [sym_regex] = STATE(1857),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1857),
    [sym_non_null_expression] = STATE(1857),
    [sym_as_expression] = STATE(1857),
    [sym_jsx_fragment] = STATE(1857),
    [sym_yield_expression] = STATE(1857),
    [sym_jsx_element] = STATE(1857),
    [sym_internal_module] = STATE(1857),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1857),
    [sym_await_expression] = STATE(1857),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(1857),
    [sym_this] = STATE(1857),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(1857),
    [sym_generator_function] = STATE(1857),
    [sym_call_expression] = STATE(1857),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(1857),
    [sym_ternary_expression] = STATE(1857),
    [sym_binary_expression] = STATE(1857),
    [sym_template_string] = STATE(1857),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1857),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1857),
    [sym_class] = STATE(1857),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(3920),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3920),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3922),
    [sym_true] = ACTIONS(3920),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3920),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [996] = {
    [sym_new_expression] = STATE(1858),
    [sym_augmented_assignment_expression] = STATE(1858),
    [sym_unary_expression] = STATE(1858),
    [sym_update_expression] = STATE(1858),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(1858),
    [sym_regex] = STATE(1858),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1858),
    [sym_non_null_expression] = STATE(1858),
    [sym_as_expression] = STATE(1858),
    [sym_jsx_fragment] = STATE(1858),
    [sym_yield_expression] = STATE(1858),
    [sym_jsx_element] = STATE(1858),
    [sym_internal_module] = STATE(1858),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1858),
    [sym_await_expression] = STATE(1858),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(1858),
    [sym_this] = STATE(1858),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(1858),
    [sym_generator_function] = STATE(1858),
    [sym_call_expression] = STATE(1858),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(1858),
    [sym_ternary_expression] = STATE(1858),
    [sym_binary_expression] = STATE(1858),
    [sym_template_string] = STATE(1858),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1858),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1858),
    [sym_class] = STATE(1858),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(3924),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3924),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3926),
    [sym_true] = ACTIONS(3924),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3924),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [997] = {
    [sym_new_expression] = STATE(1859),
    [sym_augmented_assignment_expression] = STATE(1859),
    [sym_unary_expression] = STATE(1859),
    [sym_update_expression] = STATE(1859),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(1859),
    [sym_regex] = STATE(1859),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1859),
    [sym_non_null_expression] = STATE(1859),
    [sym_as_expression] = STATE(1859),
    [sym_jsx_fragment] = STATE(1859),
    [sym_yield_expression] = STATE(1859),
    [sym_jsx_element] = STATE(1859),
    [sym_internal_module] = STATE(1859),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1859),
    [sym_await_expression] = STATE(1859),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(1859),
    [sym_this] = STATE(1859),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(1859),
    [sym_generator_function] = STATE(1859),
    [sym_call_expression] = STATE(1859),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(1859),
    [sym_ternary_expression] = STATE(1859),
    [sym_binary_expression] = STATE(1859),
    [sym_template_string] = STATE(1859),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1859),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1859),
    [sym_class] = STATE(1859),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(3928),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3928),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3930),
    [sym_true] = ACTIONS(3928),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3928),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [998] = {
    [sym_new_expression] = STATE(1860),
    [sym_augmented_assignment_expression] = STATE(1860),
    [sym_unary_expression] = STATE(1860),
    [sym_update_expression] = STATE(1860),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(1860),
    [sym_regex] = STATE(1860),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1860),
    [sym_non_null_expression] = STATE(1860),
    [sym_as_expression] = STATE(1860),
    [sym_jsx_fragment] = STATE(1860),
    [sym_yield_expression] = STATE(1860),
    [sym_jsx_element] = STATE(1860),
    [sym_internal_module] = STATE(1860),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1860),
    [sym_await_expression] = STATE(1860),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(1860),
    [sym_this] = STATE(1860),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(1860),
    [sym_generator_function] = STATE(1860),
    [sym_call_expression] = STATE(1860),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(1860),
    [sym_ternary_expression] = STATE(1860),
    [sym_binary_expression] = STATE(1860),
    [sym_template_string] = STATE(1860),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1860),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1860),
    [sym_class] = STATE(1860),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(3932),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3932),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3934),
    [sym_true] = ACTIONS(3932),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3932),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [999] = {
    [sym_new_expression] = STATE(1861),
    [sym_augmented_assignment_expression] = STATE(1861),
    [sym_unary_expression] = STATE(1861),
    [sym_update_expression] = STATE(1861),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(1861),
    [sym_regex] = STATE(1861),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1861),
    [sym_non_null_expression] = STATE(1861),
    [sym_as_expression] = STATE(1861),
    [sym_jsx_fragment] = STATE(1861),
    [sym_yield_expression] = STATE(1861),
    [sym_jsx_element] = STATE(1861),
    [sym_internal_module] = STATE(1861),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1861),
    [sym_await_expression] = STATE(1861),
    [sym_member_expression] = STATE(363),
    [sym_sequence_expression] = STATE(1521),
    [sym_string] = STATE(1861),
    [sym_this] = STATE(1861),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(1861),
    [sym_generator_function] = STATE(1861),
    [sym_call_expression] = STATE(1861),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(1861),
    [sym_ternary_expression] = STATE(1861),
    [sym_binary_expression] = STATE(1861),
    [sym_template_string] = STATE(1861),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1861),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1861),
    [sym_class] = STATE(1861),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(3936),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3936),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3938),
    [sym_true] = ACTIONS(3936),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3936),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [1000] = {
    [sym_new_expression] = STATE(1862),
    [sym_augmented_assignment_expression] = STATE(1862),
    [sym_unary_expression] = STATE(1862),
    [sym_update_expression] = STATE(1862),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(1862),
    [sym_regex] = STATE(1862),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1862),
    [sym_non_null_expression] = STATE(1862),
    [sym_as_expression] = STATE(1862),
    [sym_jsx_fragment] = STATE(1862),
    [sym_yield_expression] = STATE(1862),
    [sym_jsx_element] = STATE(1862),
    [sym_internal_module] = STATE(1862),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1862),
    [sym_await_expression] = STATE(1862),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(1862),
    [sym_this] = STATE(1862),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(1862),
    [sym_generator_function] = STATE(1862),
    [sym_call_expression] = STATE(1862),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1862),
    [sym_ternary_expression] = STATE(1862),
    [sym_binary_expression] = STATE(1862),
    [sym_template_string] = STATE(1862),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1862),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1862),
    [sym_class] = STATE(1862),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(3940),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3940),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3942),
    [sym_true] = ACTIONS(3940),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3940),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [1001] = {
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3944),
    [sym_escape_sequence] = ACTIONS(3944),
    [anon_sym_BQUOTE] = ACTIONS(3944),
    [sym__template_chars] = ACTIONS(3944),
    [sym_comment] = ACTIONS(3),
  },
  [1002] = {
    [sym_union_type] = STATE(1293),
    [sym__type] = STATE(1293),
    [sym_constructor_type] = STATE(1293),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1868),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_template_string] = STATE(1297),
    [sym_intersection_type] = STATE(1293),
    [sym_function_type] = STATE(1293),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1869),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3946),
    [sym_false] = ACTIONS(2643),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_PIPE] = ACTIONS(3948),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_boolean] = ACTIONS(2647),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_QMARK] = ACTIONS(3952),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2669),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_DQUOTE] = ACTIONS(304),
  },
  [1003] = {
    [sym_new_expression] = STATE(1850),
    [sym_constructor_type] = STATE(432),
    [sym_augmented_assignment_expression] = STATE(1850),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(1850),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(1850),
    [sym_type_parameters] = STATE(959),
    [sym_array_type] = STATE(436),
    [sym_yield_expression] = STATE(1850),
    [sym_as_expression] = STATE(1850),
    [sym_jsx_fragment] = STATE(1850),
    [sym_internal_module] = STATE(1850),
    [sym_arrow_function] = STATE(1850),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(363),
    [sym_literal_type] = STATE(436),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(1301),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(1850),
    [sym_subscript_expression] = STATE(363),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(1850),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(1850),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(960),
    [sym_function_type] = STATE(432),
    [sym__type] = STATE(432),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(1850),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(1850),
    [sym__expression] = STATE(1850),
    [sym_non_null_expression] = STATE(1850),
    [sym_jsx_element] = STATE(1850),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_await_expression] = STATE(1850),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_this] = STATE(1850),
    [sym_union_type] = STATE(432),
    [sym_anonymous_class] = STATE(1850),
    [sym_call_expression] = STATE(1850),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(1850),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(1850),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(432),
    [sym_parenthesized_expression] = STATE(1850),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1850),
    [sym_class] = STATE(1850),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(3956),
    [sym_false] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(3958),
    [anon_sym_number] = ACTIONS(3958),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(3960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3962),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_void] = ACTIONS(3964),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [sym_null] = ACTIONS(3893),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3958),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(3958),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2691),
    [sym_true] = ACTIONS(2677),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(2693),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(3958),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3893),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(3966),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(3962),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [1004] = {
    [sym_new_expression] = STATE(1876),
    [sym_augmented_assignment_expression] = STATE(1876),
    [sym_unary_expression] = STATE(1876),
    [sym_update_expression] = STATE(1876),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(1876),
    [sym_regex] = STATE(1876),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1876),
    [sym_non_null_expression] = STATE(1876),
    [sym_as_expression] = STATE(1876),
    [sym_jsx_fragment] = STATE(1876),
    [sym_yield_expression] = STATE(1876),
    [sym_jsx_element] = STATE(1876),
    [sym_internal_module] = STATE(1876),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1876),
    [sym_await_expression] = STATE(1876),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(1876),
    [sym_this] = STATE(1876),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(1876),
    [sym_generator_function] = STATE(1876),
    [sym_call_expression] = STATE(1876),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(1876),
    [sym_ternary_expression] = STATE(1876),
    [sym_binary_expression] = STATE(1876),
    [sym_template_string] = STATE(1876),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1876),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1876),
    [sym_class] = STATE(1876),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(3968),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3968),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3970),
    [sym_true] = ACTIONS(3968),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3968),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [1005] = {
    [anon_sym_LBRACK] = ACTIONS(3972),
    [sym_identifier] = ACTIONS(3974),
    [anon_sym_module] = ACTIONS(3974),
    [anon_sym_symbol] = ACTIONS(3974),
    [anon_sym_number] = ACTIONS(3974),
    [anon_sym_class] = ACTIONS(3974),
    [anon_sym_AT] = ACTIONS(3972),
    [anon_sym_declare] = ACTIONS(3974),
    [anon_sym_STAR] = ACTIONS(3972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3972),
    [anon_sym_LBRACE] = ACTIONS(3972),
    [anon_sym_void] = ACTIONS(3974),
    [anon_sym_LPAREN] = ACTIONS(3972),
    [anon_sym_any] = ACTIONS(3974),
    [anon_sym_private] = ACTIONS(3974),
    [anon_sym_boolean] = ACTIONS(3974),
    [anon_sym_static] = ACTIONS(3974),
    [anon_sym_async] = ACTIONS(3974),
    [anon_sym_get] = ACTIONS(3974),
    [anon_sym_public] = ACTIONS(3974),
    [anon_sym_RBRACE] = ACTIONS(3972),
    [anon_sym_SQUOTE] = ACTIONS(3972),
    [anon_sym_this] = ACTIONS(3974),
    [sym_number] = ACTIONS(3972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3974),
    [anon_sym_string] = ACTIONS(3974),
    [anon_sym_abstract] = ACTIONS(3974),
    [anon_sym_DOT] = ACTIONS(3974),
    [anon_sym_set] = ACTIONS(3974),
    [anon_sym_type] = ACTIONS(3974),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_export] = ACTIONS(3974),
    [anon_sym_namespace] = ACTIONS(3974),
    [sym_readonly] = ACTIONS(3974),
    [anon_sym_DQUOTE] = ACTIONS(3972),
  },
  [1006] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(2343),
    [anon_sym_BQUOTE] = ACTIONS(2341),
    [anon_sym_symbol] = ACTIONS(2343),
    [anon_sym_AT] = ACTIONS(2341),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_COMMA] = ACTIONS(2341),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_GT_GT_GT] = ACTIONS(2341),
    [anon_sym_void] = ACTIONS(2343),
    [anon_sym_BANG_EQ] = ACTIONS(2343),
    [anon_sym_GT_EQ] = ACTIONS(2341),
    [anon_sym_private] = ACTIONS(2343),
    [anon_sym_get] = ACTIONS(2343),
    [anon_sym_RBRACE] = ACTIONS(2341),
    [anon_sym_PERCENT] = ACTIONS(2341),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2341),
    [anon_sym_as] = ACTIONS(2343),
    [anon_sym_DASH_DASH] = ACTIONS(2341),
    [anon_sym_instanceof] = ACTIONS(2343),
    [anon_sym_this] = ACTIONS(2343),
    [anon_sym_COLON] = ACTIONS(2341),
    [anon_sym_protected] = ACTIONS(2343),
    [anon_sym_DOT] = ACTIONS(2343),
    [anon_sym_set] = ACTIONS(2343),
    [anon_sym_type] = ACTIONS(2343),
    [anon_sym_STAR_STAR] = ACTIONS(2341),
    [anon_sym_import] = ACTIONS(2343),
    [sym_readonly] = ACTIONS(2343),
    [anon_sym_PLUS_PLUS] = ACTIONS(2341),
    [anon_sym_namespace] = ACTIONS(2343),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_LBRACK] = ACTIONS(2341),
    [anon_sym_module] = ACTIONS(2343),
    [anon_sym_number] = ACTIONS(2343),
    [anon_sym_class] = ACTIONS(2343),
    [anon_sym_declare] = ACTIONS(2343),
    [anon_sym_LT_LT] = ACTIONS(2341),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2341),
    [anon_sym_LBRACE] = ACTIONS(2343),
    [anon_sym_AMP_AMP] = ACTIONS(2341),
    [anon_sym_LT_EQ] = ACTIONS(2341),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [anon_sym_RBRACK] = ACTIONS(2341),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_any] = ACTIONS(2343),
    [anon_sym_boolean] = ACTIONS(2343),
    [anon_sym_async] = ACTIONS(2343),
    [anon_sym_public] = ACTIONS(2343),
    [anon_sym_AMP] = ACTIONS(2343),
    [anon_sym_QMARK] = ACTIONS(2341),
    [anon_sym_PIPE_PIPE] = ACTIONS(2341),
    [anon_sym_EQ_EQ] = ACTIONS(2343),
    [anon_sym_RPAREN] = ACTIONS(2341),
    [anon_sym_LT] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2343),
    [anon_sym_CARET] = ACTIONS(2341),
    [anon_sym_PLUS] = ACTIONS(2343),
    [anon_sym_export] = ACTIONS(2343),
    [anon_sym_GT_GT] = ACTIONS(2343),
    [anon_sym_implements] = ACTIONS(2343),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2341),
    [anon_sym_in] = ACTIONS(2343),
  },
  [1007] = {
    [sym_template_string] = STATE(542),
    [aux_sym_array_repeat1] = STATE(1878),
    [sym_type_arguments] = STATE(541),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(3976),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [1008] = {
    [aux_sym_array_repeat1] = STATE(1878),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_RPAREN] = ACTIONS(3976),
    [sym_comment] = ACTIONS(3),
  },
  [1009] = {
    [aux_sym_array_repeat1] = STATE(1150),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_RPAREN] = ACTIONS(3976),
    [sym_comment] = ACTIONS(3),
  },
  [1010] = {
    [anon_sym_COMMA] = ACTIONS(2958),
    [anon_sym_RBRACE] = ACTIONS(2958),
    [sym_comment] = ACTIONS(3),
  },
  [1011] = {
    [sym_template_string] = STATE(542),
    [aux_sym_array_repeat1] = STATE(1039),
    [sym_type_arguments] = STATE(541),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(945),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_RBRACK] = ACTIONS(3978),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [1012] = {
    [aux_sym_export_statement_repeat1] = STATE(1012),
    [sym_decorator] = STATE(1012),
    [anon_sym_get] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(1830),
    [sym_identifier] = ACTIONS(3058),
    [anon_sym_public] = ACTIONS(3058),
    [anon_sym_boolean] = ACTIONS(3058),
    [sym_readonly] = ACTIONS(3058),
    [anon_sym_module] = ACTIONS(3058),
    [anon_sym_SQUOTE] = ACTIONS(1830),
    [anon_sym_number] = ACTIONS(3058),
    [anon_sym_AT] = ACTIONS(3060),
    [anon_sym_declare] = ACTIONS(3058),
    [anon_sym_symbol] = ACTIONS(3058),
    [sym_number] = ACTIONS(1830),
    [anon_sym_STAR] = ACTIONS(1830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(3058),
    [anon_sym_protected] = ACTIONS(3058),
    [anon_sym_string] = ACTIONS(3058),
    [anon_sym_set] = ACTIONS(3058),
    [anon_sym_type] = ACTIONS(3058),
    [anon_sym_import] = ACTIONS(3058),
    [anon_sym_export] = ACTIONS(3058),
    [anon_sym_namespace] = ACTIONS(3058),
    [anon_sym_any] = ACTIONS(3058),
    [anon_sym_private] = ACTIONS(3058),
    [anon_sym_DQUOTE] = ACTIONS(1830),
    [anon_sym_static] = ACTIONS(3058),
    [anon_sym_async] = ACTIONS(3058),
  },
  [1013] = {
    [anon_sym_COMMA] = ACTIONS(3070),
    [anon_sym_RBRACE] = ACTIONS(3070),
    [sym_comment] = ACTIONS(3),
  },
  [1014] = {
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [sym_comment] = ACTIONS(3),
  },
  [1015] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(1880),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1016] = {
    [sym_type_arguments] = STATE(1885),
    [anon_sym_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_SEMI] = ACTIONS(2204),
    [sym__automatic_semicolon] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(3983),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(3985),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(3987),
  },
  [1017] = {
    [anon_sym_EQ] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [anon_sym_AMP] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2212),
    [sym__automatic_semicolon] = ACTIONS(2212),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2212),
    [anon_sym_PIPE] = ACTIONS(2210),
    [anon_sym_COMMA] = ACTIONS(2212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2212),
  },
  [1018] = {
    [sym_index_type_query] = STATE(1887),
    [sym_lookup_type] = STATE(1887),
    [sym_flow_maybe_type] = STATE(1887),
    [sym_parenthesized_type] = STATE(1887),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_array_type] = STATE(1887),
    [sym_type_predicate] = STATE(1887),
    [sym_type_query] = STATE(1887),
    [sym_existential_type] = STATE(1887),
    [sym_this_type] = STATE(1887),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1887),
    [sym__primary_type] = STATE(1887),
    [sym_generic_type] = STATE(1887),
    [sym_literal_type] = STATE(1887),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1887),
    [sym_string] = STATE(1017),
    [sym_tuple_type] = STATE(1887),
    [sym_identifier] = ACTIONS(2135),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [sym_true] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_LPAREN] = ACTIONS(3989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [1019] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(1890),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(1890),
    [sym_call_signature] = STATE(1890),
    [sym_export_statement] = STATE(1890),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(1890),
    [sym_index_signature] = STATE(1890),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_RBRACE] = ACTIONS(3993),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3993),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [1020] = {
    [sym_union_type] = STATE(1891),
    [sym__type] = STATE(1891),
    [sym_constructor_type] = STATE(1891),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1089),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1891),
    [sym_function_type] = STATE(1891),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1090),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1021] = {
    [sym_union_type] = STATE(1892),
    [sym__type] = STATE(1892),
    [sym_constructor_type] = STATE(1892),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1033),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1892),
    [sym_function_type] = STATE(1892),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1036),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2135),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [1022] = {
    [anon_sym_EQ] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_SEMI] = ACTIONS(2250),
    [sym__automatic_semicolon] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_COMMA] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2250),
  },
  [1023] = {
    [anon_sym_EQ] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2254),
    [anon_sym_SEMI] = ACTIONS(2254),
    [sym__automatic_semicolon] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2254),
  },
  [1024] = {
    [sym_nested_identifier] = STATE(1893),
    [sym_identifier] = ACTIONS(3995),
    [sym_comment] = ACTIONS(3),
  },
  [1025] = {
    [sym_number] = ACTIONS(3997),
    [sym_comment] = ACTIONS(3),
  },
  [1026] = {
    [anon_sym_EQ] = ACTIONS(2262),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2262),
    [anon_sym_SEMI] = ACTIONS(2262),
    [sym__automatic_semicolon] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2262),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_COMMA] = ACTIONS(2262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2262),
  },
  [1027] = {
    [sym_nested_type_identifier] = STATE(1896),
    [sym_nested_identifier] = STATE(1034),
    [sym_identifier] = ACTIONS(3999),
    [sym_comment] = ACTIONS(3),
  },
  [1028] = {
    [sym_type_parameters] = STATE(1897),
    [sym_formal_parameters] = STATE(1898),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1029] = {
    [sym__type] = STATE(1899),
    [sym_constructor_type] = STATE(1899),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_type_parameters] = STATE(1108),
    [sym_array_type] = STATE(436),
    [sym_rest_parameter] = STATE(244),
    [sym_nested_identifier] = STATE(435),
    [sym_accessibility_modifier] = STATE(247),
    [sym_required_parameter] = STATE(244),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_this] = STATE(772),
    [sym_tuple_type] = STATE(436),
    [sym_union_type] = STATE(1899),
    [aux_sym_export_statement_repeat1] = STATE(781),
    [sym_object] = STATE(769),
    [sym_nested_type_identifier] = STATE(433),
    [sym_optional_parameter] = STATE(244),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_object_type] = STATE(436),
    [sym_decorator] = STATE(781),
    [sym_intersection_type] = STATE(1899),
    [sym_function_type] = STATE(1899),
    [sym_formal_parameters] = STATE(1109),
    [sym_array] = STATE(771),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [sym_identifier] = ACTIONS(2268),
    [sym_false] = ACTIONS(753),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(2270),
    [anon_sym_number] = ACTIONS(2270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_void] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(2270),
    [anon_sym_private] = ACTIONS(1446),
    [anon_sym_boolean] = ACTIONS(2270),
    [anon_sym_async] = ACTIONS(1442),
    [anon_sym_public] = ACTIONS(1446),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_RPAREN] = ACTIONS(428),
    [anon_sym_this] = ACTIONS(2280),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1446),
    [anon_sym_string] = ACTIONS(2270),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_new] = ACTIONS(2282),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [1030] = {
    [sym_union_type] = STATE(1900),
    [sym__type] = STATE(1900),
    [sym_constructor_type] = STATE(1900),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1033),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1900),
    [sym_function_type] = STATE(1900),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1036),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2135),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [1031] = {
    [anon_sym_EQ] = ACTIONS(3611),
    [sym__automatic_semicolon] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(4001),
    [anon_sym_SEMI] = ACTIONS(3611),
    [anon_sym_COMMA] = ACTIONS(3611),
    [anon_sym_PIPE] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
  },
  [1032] = {
    [sym_type_arguments] = STATE(1904),
    [anon_sym_EQ] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(4005),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2292),
    [sym__automatic_semicolon] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(2292),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2292),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_COMMA] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(3985),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2292),
  },
  [1033] = {
    [sym_formal_parameters] = STATE(1905),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1034] = {
    [anon_sym_DOT] = ACTIONS(3983),
    [sym_comment] = ACTIONS(3),
  },
  [1035] = {
    [anon_sym_EQ] = ACTIONS(2301),
    [anon_sym_AMP] = ACTIONS(2301),
    [sym__automatic_semicolon] = ACTIONS(2301),
    [anon_sym_SEMI] = ACTIONS(2301),
    [anon_sym_LBRACK] = ACTIONS(4008),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2299),
    [anon_sym_COMMA] = ACTIONS(2301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2301),
  },
  [1036] = {
    [anon_sym_EQ_GT] = ACTIONS(4010),
    [sym_comment] = ACTIONS(3),
  },
  [1037] = {
    [sym__automatic_semicolon] = ACTIONS(4012),
    [anon_sym_SEMI] = ACTIONS(4012),
    [anon_sym_COMMA] = ACTIONS(4012),
    [sym_comment] = ACTIONS(3),
  },
  [1038] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2633),
    [anon_sym_LBRACK] = ACTIONS(2633),
    [anon_sym_in] = ACTIONS(2635),
    [anon_sym_BQUOTE] = ACTIONS(2633),
    [anon_sym_PIPE] = ACTIONS(2635),
    [anon_sym_COMMA] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_GT_GT_GT] = ACTIONS(2633),
    [anon_sym_EQ] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2633),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_BANG_EQ] = ACTIONS(2635),
    [anon_sym_LT_EQ] = ACTIONS(2633),
    [anon_sym_LPAREN] = ACTIONS(2633),
    [anon_sym_RBRACK] = ACTIONS(2633),
    [anon_sym_GT_EQ] = ACTIONS(2633),
    [anon_sym_GT] = ACTIONS(2635),
    [anon_sym_LBRACE] = ACTIONS(2635),
    [anon_sym_of] = ACTIONS(2633),
    [anon_sym_AMP] = ACTIONS(2635),
    [anon_sym_PERCENT] = ACTIONS(2633),
    [anon_sym_QMARK] = ACTIONS(2633),
    [anon_sym_RBRACE] = ACTIONS(2633),
    [anon_sym_as] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2633),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2633),
    [anon_sym_DASH_DASH] = ACTIONS(2633),
    [anon_sym_EQ_EQ] = ACTIONS(2635),
    [anon_sym_instanceof] = ACTIONS(2633),
    [anon_sym_LT] = ACTIONS(2635),
    [anon_sym_RPAREN] = ACTIONS(2633),
    [anon_sym_SLASH] = ACTIONS(2635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2633),
    [anon_sym_DOT] = ACTIONS(2633),
    [anon_sym_CARET] = ACTIONS(2633),
    [anon_sym_STAR_STAR] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_implements] = ACTIONS(2633),
    [anon_sym_GT_GT] = ACTIONS(2635),
    [anon_sym_PLUS_PLUS] = ACTIONS(2633),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2633),
    [anon_sym_BANG] = ACTIONS(2635),
  },
  [1039] = {
    [aux_sym_array_repeat1] = STATE(588),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_RBRACK] = ACTIONS(4014),
    [sym_comment] = ACTIONS(3),
  },
  [1040] = {
    [sym_identifier] = ACTIONS(4016),
    [anon_sym_BQUOTE] = ACTIONS(4018),
    [anon_sym_debugger] = ACTIONS(4016),
    [anon_sym_symbol] = ACTIONS(4016),
    [anon_sym_AT] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_void] = ACTIONS(4016),
    [anon_sym_break] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4016),
    [sym_super] = ACTIONS(4016),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_private] = ACTIONS(4016),
    [anon_sym_get] = ACTIONS(4016),
    [anon_sym_RBRACE] = ACTIONS(4018),
    [anon_sym_interface] = ACTIONS(4016),
    [anon_sym_default] = ACTIONS(4016),
    [anon_sym_enum] = ACTIONS(4016),
    [anon_sym_delete] = ACTIONS(4016),
    [anon_sym_continue] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4018),
    [anon_sym_if] = ACTIONS(4016),
    [anon_sym_this] = ACTIONS(4016),
    [anon_sym_yield] = ACTIONS(4016),
    [sym_true] = ACTIONS(4016),
    [anon_sym_throw] = ACTIONS(4016),
    [anon_sym_protected] = ACTIONS(4016),
    [anon_sym_abstract] = ACTIONS(4016),
    [anon_sym_set] = ACTIONS(4016),
    [anon_sym_type] = ACTIONS(4016),
    [anon_sym_import] = ACTIONS(4016),
    [anon_sym_namespace] = ACTIONS(4016),
    [anon_sym_PLUS_PLUS] = ACTIONS(4018),
    [anon_sym_await] = ACTIONS(4016),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_else] = ACTIONS(4016),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_for] = ACTIONS(4016),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [sym_false] = ACTIONS(4016),
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_case] = ACTIONS(4016),
    [anon_sym_module] = ACTIONS(4016),
    [anon_sym_number] = ACTIONS(4016),
    [anon_sym_class] = ACTIONS(4016),
    [anon_sym_declare] = ACTIONS(4016),
    [anon_sym_typeof] = ACTIONS(4016),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_switch] = ACTIONS(4016),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [sym_null] = ACTIONS(4016),
    [anon_sym_any] = ACTIONS(4016),
    [anon_sym_boolean] = ACTIONS(4016),
    [anon_sym_async] = ACTIONS(4016),
    [anon_sym_public] = ACTIONS(4016),
    [anon_sym_var] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(4016),
    [anon_sym_SQUOTE] = ACTIONS(4018),
    [anon_sym_try] = ACTIONS(4016),
    [anon_sym_LT] = ACTIONS(4018),
    [sym_number] = ACTIONS(4018),
    [anon_sym_SLASH] = ACTIONS(4016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4016),
    [anon_sym_function] = ACTIONS(4016),
    [sym_undefined] = ACTIONS(4016),
    [anon_sym_new] = ACTIONS(4016),
    [ts_builtin_sym_end] = ACTIONS(4018),
    [anon_sym_let] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_export] = ACTIONS(4016),
    [anon_sym_do] = ACTIONS(4016),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_with] = ACTIONS(4016),
  },
  [1041] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2923),
    [anon_sym_in] = ACTIONS(2925),
    [anon_sym_BQUOTE] = ACTIONS(2923),
    [anon_sym_PIPE] = ACTIONS(2925),
    [anon_sym_COMMA] = ACTIONS(2923),
    [anon_sym_DASH] = ACTIONS(2925),
    [anon_sym_STAR] = ACTIONS(2925),
    [anon_sym_GT_GT_GT] = ACTIONS(2923),
    [anon_sym_EQ] = ACTIONS(2925),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2925),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_RBRACK] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2923),
    [anon_sym_GT] = ACTIONS(2925),
    [anon_sym_LBRACE] = ACTIONS(2925),
    [anon_sym_of] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(2925),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [anon_sym_QMARK] = ACTIONS(2923),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_as] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2923),
    [anon_sym_DASH_DASH] = ACTIONS(2923),
    [anon_sym_EQ_EQ] = ACTIONS(2925),
    [anon_sym_instanceof] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_RPAREN] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2923),
    [anon_sym_DOT] = ACTIONS(2923),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_STAR_STAR] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2925),
    [anon_sym_implements] = ACTIONS(2923),
    [anon_sym_GT_GT] = ACTIONS(2925),
    [anon_sym_PLUS_PLUS] = ACTIONS(2923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG] = ACTIONS(2925),
  },
  [1042] = {
    [aux_sym_object_repeat1] = STATE(699),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_RBRACE] = ACTIONS(4020),
    [sym_comment] = ACTIONS(3),
  },
  [1043] = {
    [aux_sym_object_repeat1] = STATE(1911),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_RBRACE] = ACTIONS(4022),
    [sym_comment] = ACTIONS(3),
  },
  [1044] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_in] = ACTIONS(3049),
    [anon_sym_BQUOTE] = ACTIONS(3047),
    [anon_sym_PIPE] = ACTIONS(3049),
    [anon_sym_COMMA] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_STAR] = ACTIONS(3049),
    [anon_sym_GT_GT_GT] = ACTIONS(3047),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_LT_LT] = ACTIONS(3047),
    [anon_sym_BANG_EQ] = ACTIONS(3049),
    [anon_sym_LT_EQ] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_RBRACK] = ACTIONS(3047),
    [anon_sym_GT_EQ] = ACTIONS(3047),
    [anon_sym_GT] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_of] = ACTIONS(3047),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_PERCENT] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3047),
    [anon_sym_RBRACE] = ACTIONS(3047),
    [anon_sym_as] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3047),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [anon_sym_EQ_EQ] = ACTIONS(3049),
    [anon_sym_instanceof] = ACTIONS(3047),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_RPAREN] = ACTIONS(3047),
    [anon_sym_SLASH] = ACTIONS(3049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3047),
    [anon_sym_DOT] = ACTIONS(3047),
    [anon_sym_CARET] = ACTIONS(3047),
    [anon_sym_STAR_STAR] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_implements] = ACTIONS(3047),
    [anon_sym_GT_GT] = ACTIONS(3049),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3047),
    [anon_sym_BANG] = ACTIONS(3049),
  },
  [1045] = {
    [aux_sym_object_repeat1] = STATE(699),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_RBRACE] = ACTIONS(4022),
    [sym_comment] = ACTIONS(3),
  },
  [1046] = {
    [sym__automatic_semicolon] = ACTIONS(4024),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4024),
    [sym_comment] = ACTIONS(3),
  },
  [1047] = {
    [sym_identifier] = ACTIONS(4026),
    [anon_sym_BQUOTE] = ACTIONS(4028),
    [anon_sym_debugger] = ACTIONS(4026),
    [anon_sym_symbol] = ACTIONS(4026),
    [anon_sym_AT] = ACTIONS(4028),
    [anon_sym_DASH] = ACTIONS(4026),
    [anon_sym_void] = ACTIONS(4026),
    [anon_sym_break] = ACTIONS(4026),
    [anon_sym_const] = ACTIONS(4026),
    [sym_super] = ACTIONS(4026),
    [anon_sym_return] = ACTIONS(4026),
    [anon_sym_private] = ACTIONS(4026),
    [anon_sym_get] = ACTIONS(4026),
    [anon_sym_RBRACE] = ACTIONS(4028),
    [anon_sym_interface] = ACTIONS(4026),
    [anon_sym_default] = ACTIONS(4026),
    [anon_sym_enum] = ACTIONS(4026),
    [anon_sym_delete] = ACTIONS(4026),
    [anon_sym_continue] = ACTIONS(4026),
    [anon_sym_DASH_DASH] = ACTIONS(4028),
    [anon_sym_if] = ACTIONS(4026),
    [anon_sym_this] = ACTIONS(4026),
    [anon_sym_yield] = ACTIONS(4026),
    [sym_true] = ACTIONS(4026),
    [anon_sym_throw] = ACTIONS(4026),
    [anon_sym_protected] = ACTIONS(4026),
    [anon_sym_abstract] = ACTIONS(4026),
    [anon_sym_set] = ACTIONS(4026),
    [anon_sym_type] = ACTIONS(4026),
    [anon_sym_import] = ACTIONS(4026),
    [anon_sym_namespace] = ACTIONS(4026),
    [anon_sym_PLUS_PLUS] = ACTIONS(4028),
    [anon_sym_await] = ACTIONS(4026),
    [anon_sym_DQUOTE] = ACTIONS(4028),
    [anon_sym_else] = ACTIONS(4026),
    [anon_sym_BANG] = ACTIONS(4028),
    [anon_sym_for] = ACTIONS(4026),
    [anon_sym_LBRACK] = ACTIONS(4028),
    [sym_false] = ACTIONS(4026),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_case] = ACTIONS(4026),
    [anon_sym_module] = ACTIONS(4026),
    [anon_sym_number] = ACTIONS(4026),
    [anon_sym_class] = ACTIONS(4026),
    [anon_sym_declare] = ACTIONS(4026),
    [anon_sym_typeof] = ACTIONS(4026),
    [anon_sym_LBRACE] = ACTIONS(4028),
    [anon_sym_switch] = ACTIONS(4026),
    [anon_sym_LPAREN] = ACTIONS(4028),
    [sym_null] = ACTIONS(4026),
    [anon_sym_any] = ACTIONS(4026),
    [anon_sym_boolean] = ACTIONS(4026),
    [anon_sym_async] = ACTIONS(4026),
    [anon_sym_public] = ACTIONS(4026),
    [anon_sym_var] = ACTIONS(4026),
    [anon_sym_while] = ACTIONS(4026),
    [anon_sym_SQUOTE] = ACTIONS(4028),
    [anon_sym_try] = ACTIONS(4026),
    [anon_sym_LT] = ACTIONS(4028),
    [sym_number] = ACTIONS(4028),
    [anon_sym_SLASH] = ACTIONS(4026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4026),
    [anon_sym_function] = ACTIONS(4026),
    [sym_undefined] = ACTIONS(4026),
    [anon_sym_new] = ACTIONS(4026),
    [ts_builtin_sym_end] = ACTIONS(4028),
    [anon_sym_let] = ACTIONS(4026),
    [anon_sym_PLUS] = ACTIONS(4026),
    [anon_sym_export] = ACTIONS(4026),
    [anon_sym_do] = ACTIONS(4026),
    [anon_sym_TILDE] = ACTIONS(4028),
    [anon_sym_with] = ACTIONS(4026),
  },
  [1048] = {
    [aux_sym_variable_declaration_repeat1] = STATE(1048),
    [sym__automatic_semicolon] = ACTIONS(4024),
    [anon_sym_SEMI] = ACTIONS(4024),
    [anon_sym_COMMA] = ACTIONS(4030),
    [sym_comment] = ACTIONS(3),
  },
  [1049] = {
    [sym_type_arguments] = STATE(1064),
    [anon_sym_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(4033),
  },
  [1050] = {
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(433),
    [sym_array_type] = STATE(1066),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym_existential_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(1066),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(1066),
    [sym_string] = STATE(418),
    [sym_tuple_type] = STATE(1066),
    [sym_identifier] = ACTIONS(2183),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [sym_true] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1051] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1055),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1056),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2183),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1052] = {
    [sym_type_parameters] = STATE(1913),
    [sym_formal_parameters] = STATE(1914),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1053] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1055),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1056),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2183),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1054] = {
    [anon_sym_EQ] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4037),
    [sym_comment] = ACTIONS(3),
  },
  [1055] = {
    [sym_formal_parameters] = STATE(1917),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1056] = {
    [anon_sym_EQ_GT] = ACTIONS(4039),
    [sym_comment] = ACTIONS(3),
  },
  [1057] = {
    [sym__automatic_semicolon] = ACTIONS(4041),
    [anon_sym_SEMI] = ACTIONS(4041),
    [anon_sym_COMMA] = ACTIONS(4041),
    [sym_comment] = ACTIONS(3),
  },
  [1058] = {
    [sym__automatic_semicolon] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4043),
    [anon_sym_COMMA] = ACTIONS(4043),
    [sym_comment] = ACTIONS(3),
  },
  [1059] = {
    [sym_new_expression] = STATE(1919),
    [sym_augmented_assignment_expression] = STATE(1919),
    [sym_unary_expression] = STATE(1919),
    [sym_update_expression] = STATE(1919),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(1919),
    [sym_regex] = STATE(1919),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1919),
    [sym_non_null_expression] = STATE(1919),
    [sym_as_expression] = STATE(1919),
    [sym_jsx_fragment] = STATE(1919),
    [sym_yield_expression] = STATE(1919),
    [sym_jsx_element] = STATE(1919),
    [sym_internal_module] = STATE(1919),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1919),
    [sym_await_expression] = STATE(1919),
    [sym_member_expression] = STATE(162),
    [sym_sequence_expression] = STATE(1521),
    [sym_string] = STATE(1919),
    [sym_this] = STATE(1919),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(1919),
    [sym_generator_function] = STATE(1919),
    [sym_call_expression] = STATE(1919),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(1919),
    [sym_ternary_expression] = STATE(1919),
    [sym_binary_expression] = STATE(1919),
    [sym_template_string] = STATE(1919),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1919),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1919),
    [sym_class] = STATE(1919),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(4045),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4045),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4047),
    [sym_true] = ACTIONS(4045),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4045),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [1060] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4049),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_BANG] = ACTIONS(4051),
    [anon_sym_SEMI] = ACTIONS(4049),
    [anon_sym_BQUOTE] = ACTIONS(4049),
    [sym__automatic_semicolon] = ACTIONS(4049),
    [anon_sym_PERCENT_EQ] = ACTIONS(4049),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4049),
    [anon_sym_AMP_EQ] = ACTIONS(4049),
    [anon_sym_PLUS_EQ] = ACTIONS(4049),
    [anon_sym_PIPE] = ACTIONS(4051),
    [anon_sym_COMMA] = ACTIONS(4049),
    [anon_sym_LT_LT] = ACTIONS(4051),
    [anon_sym_STAR] = ACTIONS(4051),
    [anon_sym_GT_GT_GT] = ACTIONS(4051),
    [anon_sym_EQ] = ACTIONS(4051),
    [anon_sym_AMP_AMP] = ACTIONS(4049),
    [anon_sym_DASH] = ACTIONS(4051),
    [anon_sym_BANG_EQ] = ACTIONS(4051),
    [anon_sym_LT_EQ] = ACTIONS(4049),
    [anon_sym_LPAREN] = ACTIONS(4049),
    [anon_sym_GT_EQ] = ACTIONS(4049),
    [anon_sym_GT] = ACTIONS(4051),
    [anon_sym_CARET_EQ] = ACTIONS(4049),
    [anon_sym_STAR_EQ] = ACTIONS(4049),
    [anon_sym_PIPE_EQ] = ACTIONS(4049),
    [anon_sym_DASH_EQ] = ACTIONS(4049),
    [anon_sym_AMP] = ACTIONS(4051),
    [anon_sym_PERCENT] = ACTIONS(4051),
    [anon_sym_QMARK] = ACTIONS(4049),
    [anon_sym_LT_LT_EQ] = ACTIONS(4049),
    [anon_sym_as] = ACTIONS(4049),
    [anon_sym_PIPE_PIPE] = ACTIONS(4049),
    [anon_sym_RBRACE] = ACTIONS(4049),
    [anon_sym_DASH_DASH] = ACTIONS(4049),
    [anon_sym_EQ_EQ] = ACTIONS(4051),
    [anon_sym_instanceof] = ACTIONS(4049),
    [anon_sym_LT] = ACTIONS(4051),
    [anon_sym_RPAREN] = ACTIONS(4049),
    [anon_sym_SLASH] = ACTIONS(4051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4049),
    [anon_sym_GT_GT_EQ] = ACTIONS(4049),
    [anon_sym_DOT] = ACTIONS(4049),
    [anon_sym_CARET] = ACTIONS(4051),
    [anon_sym_STAR_STAR] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4051),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4049),
    [anon_sym_GT_GT] = ACTIONS(4051),
    [anon_sym_PLUS_PLUS] = ACTIONS(4049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4049),
    [anon_sym_in] = ACTIONS(4051),
  },
  [1061] = {
    [sym_union_type] = STATE(1925),
    [sym__type] = STATE(1925),
    [sym_constructor_type] = STATE(1925),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1926),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1925),
    [sym_function_type] = STATE(1925),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1927),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4057),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1062] = {
    [sym_identifier] = ACTIONS(4063),
    [sym_comment] = ACTIONS(3),
  },
  [1063] = {
    [sym_union_type] = STATE(1932),
    [sym__type] = STATE(1932),
    [sym_constructor_type] = STATE(1932),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1933),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1932),
    [sym_function_type] = STATE(1932),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1934),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4065),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4067),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1064] = {
    [sym_identifier] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4073),
    [anon_sym_debugger] = ACTIONS(4071),
    [anon_sym_symbol] = ACTIONS(4071),
    [anon_sym_AT] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_COMMA] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(4071),
    [anon_sym_EQ] = ACTIONS(4071),
    [anon_sym_void] = ACTIONS(4071),
    [anon_sym_break] = ACTIONS(4071),
    [anon_sym_const] = ACTIONS(4071),
    [sym_super] = ACTIONS(4071),
    [anon_sym_return] = ACTIONS(4071),
    [anon_sym_private] = ACTIONS(4071),
    [anon_sym_get] = ACTIONS(4071),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4073),
    [anon_sym_RBRACE] = ACTIONS(4073),
    [anon_sym_interface] = ACTIONS(4071),
    [anon_sym_default] = ACTIONS(4071),
    [anon_sym_enum] = ACTIONS(4071),
    [anon_sym_delete] = ACTIONS(4071),
    [anon_sym_continue] = ACTIONS(4071),
    [anon_sym_DASH_DASH] = ACTIONS(4073),
    [anon_sym_if] = ACTIONS(4071),
    [anon_sym_this] = ACTIONS(4071),
    [anon_sym_yield] = ACTIONS(4071),
    [sym_true] = ACTIONS(4071),
    [anon_sym_throw] = ACTIONS(4071),
    [anon_sym_protected] = ACTIONS(4071),
    [anon_sym_abstract] = ACTIONS(4071),
    [anon_sym_set] = ACTIONS(4071),
    [anon_sym_type] = ACTIONS(4071),
    [anon_sym_import] = ACTIONS(4071),
    [anon_sym_namespace] = ACTIONS(4071),
    [anon_sym_PLUS_PLUS] = ACTIONS(4073),
    [anon_sym_await] = ACTIONS(4071),
    [anon_sym_DQUOTE] = ACTIONS(4073),
    [anon_sym_else] = ACTIONS(4071),
    [anon_sym_BANG] = ACTIONS(4073),
    [anon_sym_for] = ACTIONS(4071),
    [anon_sym_LBRACK] = ACTIONS(4073),
    [sym_false] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_case] = ACTIONS(4071),
    [anon_sym_module] = ACTIONS(4071),
    [anon_sym_number] = ACTIONS(4071),
    [anon_sym_class] = ACTIONS(4071),
    [anon_sym_declare] = ACTIONS(4071),
    [anon_sym_typeof] = ACTIONS(4071),
    [anon_sym_LBRACE] = ACTIONS(4071),
    [anon_sym_switch] = ACTIONS(4071),
    [anon_sym_LPAREN] = ACTIONS(4073),
    [anon_sym_RBRACK] = ACTIONS(4073),
    [sym_null] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_any] = ACTIONS(4071),
    [anon_sym_boolean] = ACTIONS(4071),
    [anon_sym_async] = ACTIONS(4071),
    [anon_sym_public] = ACTIONS(4071),
    [anon_sym_EQ_GT] = ACTIONS(4073),
    [anon_sym_AMP] = ACTIONS(4073),
    [anon_sym_var] = ACTIONS(4071),
    [anon_sym_while] = ACTIONS(4071),
    [anon_sym_SQUOTE] = ACTIONS(4073),
    [anon_sym_try] = ACTIONS(4071),
    [anon_sym_RPAREN] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(4073),
    [sym_number] = ACTIONS(4073),
    [anon_sym_SLASH] = ACTIONS(4071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4071),
    [anon_sym_function] = ACTIONS(4071),
    [sym_undefined] = ACTIONS(4071),
    [anon_sym_new] = ACTIONS(4071),
    [ts_builtin_sym_end] = ACTIONS(4073),
    [anon_sym_let] = ACTIONS(4071),
    [anon_sym_PLUS] = ACTIONS(4071),
    [anon_sym_implements] = ACTIONS(4071),
    [anon_sym_export] = ACTIONS(4071),
    [anon_sym_do] = ACTIONS(4071),
    [anon_sym_TILDE] = ACTIONS(4073),
    [anon_sym_with] = ACTIONS(4071),
  },
  [1065] = {
    [sym_union_type] = STATE(1107),
    [sym__type] = STATE(1107),
    [sym_constructor_type] = STATE(1107),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1108),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1107),
    [sym_function_type] = STATE(1107),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1109),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2282),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1066] = {
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_BQUOTE] = ACTIONS(4077),
    [anon_sym_debugger] = ACTIONS(4075),
    [anon_sym_symbol] = ACTIONS(4075),
    [anon_sym_AT] = ACTIONS(4077),
    [anon_sym_PIPE] = ACTIONS(4077),
    [anon_sym_COMMA] = ACTIONS(4077),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_EQ] = ACTIONS(4075),
    [anon_sym_void] = ACTIONS(4075),
    [anon_sym_break] = ACTIONS(4075),
    [anon_sym_const] = ACTIONS(4075),
    [sym_super] = ACTIONS(4075),
    [anon_sym_return] = ACTIONS(4075),
    [anon_sym_private] = ACTIONS(4075),
    [anon_sym_get] = ACTIONS(4075),
    [anon_sym_RBRACE] = ACTIONS(4077),
    [anon_sym_interface] = ACTIONS(4075),
    [anon_sym_default] = ACTIONS(4075),
    [anon_sym_enum] = ACTIONS(4075),
    [anon_sym_delete] = ACTIONS(4075),
    [anon_sym_continue] = ACTIONS(4075),
    [anon_sym_DASH_DASH] = ACTIONS(4077),
    [anon_sym_if] = ACTIONS(4075),
    [anon_sym_this] = ACTIONS(4075),
    [anon_sym_yield] = ACTIONS(4075),
    [sym_true] = ACTIONS(4075),
    [anon_sym_throw] = ACTIONS(4075),
    [anon_sym_protected] = ACTIONS(4075),
    [anon_sym_abstract] = ACTIONS(4075),
    [anon_sym_set] = ACTIONS(4075),
    [anon_sym_type] = ACTIONS(4075),
    [anon_sym_import] = ACTIONS(4075),
    [anon_sym_namespace] = ACTIONS(4075),
    [anon_sym_PLUS_PLUS] = ACTIONS(4077),
    [anon_sym_await] = ACTIONS(4075),
    [anon_sym_DQUOTE] = ACTIONS(4077),
    [anon_sym_else] = ACTIONS(4075),
    [anon_sym_BANG] = ACTIONS(4077),
    [anon_sym_for] = ACTIONS(4075),
    [anon_sym_LBRACK] = ACTIONS(2303),
    [sym_false] = ACTIONS(4075),
    [anon_sym_SEMI] = ACTIONS(4077),
    [anon_sym_case] = ACTIONS(4075),
    [anon_sym_module] = ACTIONS(4075),
    [anon_sym_number] = ACTIONS(4075),
    [anon_sym_class] = ACTIONS(4075),
    [anon_sym_declare] = ACTIONS(4075),
    [anon_sym_typeof] = ACTIONS(4075),
    [anon_sym_LBRACE] = ACTIONS(4077),
    [anon_sym_switch] = ACTIONS(4075),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_RBRACK] = ACTIONS(4077),
    [sym_null] = ACTIONS(4075),
    [anon_sym_GT] = ACTIONS(4077),
    [anon_sym_any] = ACTIONS(4075),
    [anon_sym_boolean] = ACTIONS(4075),
    [anon_sym_async] = ACTIONS(4075),
    [anon_sym_public] = ACTIONS(4075),
    [anon_sym_EQ_GT] = ACTIONS(4077),
    [anon_sym_AMP] = ACTIONS(4077),
    [anon_sym_var] = ACTIONS(4075),
    [anon_sym_while] = ACTIONS(4075),
    [anon_sym_SQUOTE] = ACTIONS(4077),
    [anon_sym_try] = ACTIONS(4075),
    [anon_sym_RPAREN] = ACTIONS(4077),
    [anon_sym_LT] = ACTIONS(4077),
    [sym_number] = ACTIONS(4077),
    [anon_sym_SLASH] = ACTIONS(4075),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4075),
    [anon_sym_function] = ACTIONS(4075),
    [sym_undefined] = ACTIONS(4075),
    [anon_sym_new] = ACTIONS(4075),
    [ts_builtin_sym_end] = ACTIONS(4077),
    [anon_sym_let] = ACTIONS(4075),
    [anon_sym_PLUS] = ACTIONS(4075),
    [anon_sym_export] = ACTIONS(4075),
    [anon_sym_do] = ACTIONS(4075),
    [anon_sym_TILDE] = ACTIONS(4077),
    [anon_sym_with] = ACTIONS(4075),
  },
  [1067] = {
    [sym_new_expression] = STATE(1373),
    [sym_augmented_assignment_expression] = STATE(1373),
    [sym_unary_expression] = STATE(1373),
    [sym_update_expression] = STATE(1373),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(1373),
    [sym_regex] = STATE(1373),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1373),
    [sym_non_null_expression] = STATE(1373),
    [sym_as_expression] = STATE(1373),
    [sym_jsx_fragment] = STATE(1373),
    [sym_yield_expression] = STATE(1373),
    [sym_jsx_element] = STATE(1373),
    [sym_internal_module] = STATE(1373),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1373),
    [sym_await_expression] = STATE(1373),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(1373),
    [sym_this] = STATE(1373),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(1373),
    [sym_generator_function] = STATE(1373),
    [sym_call_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(1373),
    [sym_ternary_expression] = STATE(1373),
    [sym_binary_expression] = STATE(1373),
    [sym_template_string] = STATE(1373),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1373),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1373),
    [sym_class] = STATE(1373),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(4079),
    [sym_false] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4081),
    [anon_sym_symbol] = ACTIONS(4081),
    [anon_sym_number] = ACTIONS(4081),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4081),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2823),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4081),
    [anon_sym_private] = ACTIONS(4081),
    [anon_sym_boolean] = ACTIONS(4081),
    [anon_sym_async] = ACTIONS(4085),
    [anon_sym_public] = ACTIONS(4081),
    [anon_sym_get] = ACTIONS(4081),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2837),
    [sym_true] = ACTIONS(2823),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4081),
    [anon_sym_string] = ACTIONS(4081),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2823),
    [anon_sym_set] = ACTIONS(4081),
    [anon_sym_type] = ACTIONS(4081),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(4081),
    [anon_sym_export] = ACTIONS(4081),
    [anon_sym_namespace] = ACTIONS(4087),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [1068] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(1940),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(1940),
    [sym_call_signature] = STATE(1940),
    [sym_export_statement] = STATE(1940),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(1940),
    [sym_index_signature] = STATE(1940),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [1069] = {
    [sym_string] = STATE(1941),
    [sym__property_name] = STATE(1941),
    [sym_computed_property_name] = STATE(1941),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(4089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [1070] = {
    [sym_string] = STATE(1946),
    [sym__property_name] = STATE(1946),
    [sym_computed_property_name] = STATE(1946),
    [anon_sym_get] = ACTIONS(4091),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_async] = ACTIONS(4093),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(4095),
    [anon_sym_STAR] = ACTIONS(4097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(4091),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(4099),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [1071] = {
    [sym_string] = STATE(1941),
    [sym__property_name] = STATE(1941),
    [sym_computed_property_name] = STATE(1941),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(4097),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(4101),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(4089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(4101),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [1072] = {
    [sym_string] = STATE(1941),
    [sym__property_name] = STATE(1941),
    [sym_computed_property_name] = STATE(1941),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(4089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [1073] = {
    [sym_identifier] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4105),
    [anon_sym_debugger] = ACTIONS(4103),
    [anon_sym_symbol] = ACTIONS(4103),
    [anon_sym_AT] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_COMMA] = ACTIONS(4105),
    [anon_sym_DASH] = ACTIONS(4103),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_void] = ACTIONS(4103),
    [anon_sym_break] = ACTIONS(4103),
    [anon_sym_const] = ACTIONS(4103),
    [sym_super] = ACTIONS(4103),
    [anon_sym_return] = ACTIONS(4103),
    [anon_sym_private] = ACTIONS(4103),
    [anon_sym_get] = ACTIONS(4103),
    [anon_sym_RBRACE] = ACTIONS(4105),
    [anon_sym_interface] = ACTIONS(4103),
    [anon_sym_default] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4103),
    [anon_sym_delete] = ACTIONS(4103),
    [anon_sym_continue] = ACTIONS(4103),
    [anon_sym_DASH_DASH] = ACTIONS(4105),
    [anon_sym_if] = ACTIONS(4103),
    [anon_sym_this] = ACTIONS(4103),
    [anon_sym_yield] = ACTIONS(4103),
    [sym_true] = ACTIONS(4103),
    [anon_sym_throw] = ACTIONS(4103),
    [anon_sym_protected] = ACTIONS(4103),
    [anon_sym_abstract] = ACTIONS(4103),
    [anon_sym_set] = ACTIONS(4103),
    [anon_sym_type] = ACTIONS(4103),
    [anon_sym_import] = ACTIONS(4103),
    [anon_sym_namespace] = ACTIONS(4103),
    [anon_sym_PLUS_PLUS] = ACTIONS(4105),
    [anon_sym_await] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4105),
    [anon_sym_else] = ACTIONS(4103),
    [anon_sym_BANG] = ACTIONS(4105),
    [anon_sym_for] = ACTIONS(4103),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [sym_false] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_case] = ACTIONS(4103),
    [anon_sym_module] = ACTIONS(4103),
    [anon_sym_number] = ACTIONS(4103),
    [anon_sym_class] = ACTIONS(4103),
    [anon_sym_declare] = ACTIONS(4103),
    [anon_sym_typeof] = ACTIONS(4103),
    [anon_sym_LBRACE] = ACTIONS(4105),
    [anon_sym_switch] = ACTIONS(4103),
    [anon_sym_LPAREN] = ACTIONS(4105),
    [anon_sym_RBRACK] = ACTIONS(4105),
    [sym_null] = ACTIONS(4103),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_any] = ACTIONS(4103),
    [anon_sym_boolean] = ACTIONS(4103),
    [anon_sym_async] = ACTIONS(4103),
    [anon_sym_public] = ACTIONS(4103),
    [anon_sym_EQ_GT] = ACTIONS(4105),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_var] = ACTIONS(4103),
    [anon_sym_while] = ACTIONS(4103),
    [anon_sym_SQUOTE] = ACTIONS(4105),
    [anon_sym_try] = ACTIONS(4103),
    [anon_sym_RPAREN] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(4105),
    [sym_number] = ACTIONS(4105),
    [anon_sym_SLASH] = ACTIONS(4103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4103),
    [anon_sym_function] = ACTIONS(4103),
    [sym_undefined] = ACTIONS(4103),
    [anon_sym_new] = ACTIONS(4103),
    [ts_builtin_sym_end] = ACTIONS(4105),
    [anon_sym_let] = ACTIONS(4103),
    [anon_sym_PLUS] = ACTIONS(4103),
    [anon_sym_export] = ACTIONS(4103),
    [anon_sym_do] = ACTIONS(4103),
    [anon_sym_TILDE] = ACTIONS(4105),
    [anon_sym_with] = ACTIONS(4103),
  },
  [1074] = {
    [sym_type_parameters] = STATE(1948),
    [sym_formal_parameters] = STATE(1949),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1075] = {
    [sym_type_alias_declaration] = STATE(1970),
    [aux_sym_export_statement_repeat1] = STATE(1969),
    [sym__declaration] = STATE(1970),
    [sym_ambient_declaration] = STATE(1970),
    [sym_import_alias] = STATE(1970),
    [sym_export_statement] = STATE(1970),
    [sym_generator_function] = STATE(1970),
    [sym_export_clause] = STATE(1971),
    [sym_lexical_declaration] = STATE(1970),
    [sym_internal_module] = STATE(1970),
    [sym_decorator] = STATE(1969),
    [sym_enum_declaration] = STATE(1970),
    [sym_function] = STATE(1970),
    [sym_function_signature] = STATE(1970),
    [sym_variable_declaration] = STATE(1970),
    [sym_abstract_class] = STATE(1970),
    [sym_module] = STATE(1970),
    [sym_interface_declaration] = STATE(1970),
    [sym_class] = STATE(1970),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(4107),
    [anon_sym_class] = ACTIONS(4109),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_EQ] = ACTIONS(4115),
    [anon_sym_const] = ACTIONS(4117),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(4119),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_var] = ACTIONS(4121),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_interface] = ACTIONS(4123),
    [anon_sym_default] = ACTIONS(4125),
    [anon_sym_enum] = ACTIONS(4127),
    [anon_sym_as] = ACTIONS(4129),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_function] = ACTIONS(4131),
    [anon_sym_abstract] = ACTIONS(4133),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(4135),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_import] = ACTIONS(4139),
    [anon_sym_export] = ACTIONS(4141),
    [anon_sym_namespace] = ACTIONS(4143),
  },
  [1076] = {
    [sym_string] = STATE(1946),
    [sym__property_name] = STATE(1946),
    [sym_computed_property_name] = STATE(1946),
    [anon_sym_get] = ACTIONS(4091),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(4095),
    [anon_sym_STAR] = ACTIONS(4097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(4091),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_async] = ACTIONS(4093),
  },
  [1077] = {
    [aux_sym_export_statement_repeat1] = STATE(1973),
    [sym_decorator] = STATE(1973),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(4145),
    [sym_comment] = ACTIONS(3),
  },
  [1078] = {
    [sym_type_parameters] = STATE(1082),
    [sym_type_annotation] = STATE(1976),
    [sym_formal_parameters] = STATE(1081),
    [sym_call_signature] = STATE(1977),
    [sym__automatic_semicolon] = ACTIONS(4147),
    [anon_sym_RBRACE] = ACTIONS(4147),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4147),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(4147),
    [sym_comment] = ACTIONS(3),
  },
  [1079] = {
    [aux_sym_object_type_repeat1] = STATE(1980),
    [sym__automatic_semicolon] = ACTIONS(4153),
    [anon_sym_RBRACE] = ACTIONS(4155),
    [anon_sym_SEMI] = ACTIONS(4153),
    [anon_sym_COMMA] = ACTIONS(4153),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4155),
    [sym_comment] = ACTIONS(3),
  },
  [1080] = {
    [sym_string] = STATE(1946),
    [sym__property_name] = STATE(1946),
    [sym_computed_property_name] = STATE(1946),
    [anon_sym_get] = ACTIONS(4091),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_async] = ACTIONS(4093),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(4095),
    [anon_sym_STAR] = ACTIONS(4097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(4091),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(4099),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(4157),
    [anon_sym_private] = ACTIONS(1135),
  },
  [1081] = {
    [sym_type_annotation] = STATE(1603),
    [sym__automatic_semicolon] = ACTIONS(548),
    [anon_sym_RBRACE] = ACTIONS(548),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(548),
    [anon_sym_COMMA] = ACTIONS(548),
    [anon_sym_PIPE_RBRACE] = ACTIONS(548),
    [sym_comment] = ACTIONS(3),
  },
  [1082] = {
    [sym_formal_parameters] = STATE(1982),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [1083] = {
    [sym_type_arguments] = STATE(1064),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_RBRACK] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(4159),
  },
  [1084] = {
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(433),
    [sym_array_type] = STATE(1066),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym_existential_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(1066),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(1066),
    [sym_string] = STATE(418),
    [sym_tuple_type] = STATE(1066),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [sym_true] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1085] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1089),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1090),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1086] = {
    [sym_type_parameters] = STATE(1984),
    [sym_formal_parameters] = STATE(1985),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1087] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1089),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1090),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1088] = {
    [aux_sym_implements_clause_repeat1] = STATE(1990),
    [anon_sym_AMP] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_COMMA] = ACTIONS(4165),
    [anon_sym_RBRACK] = ACTIONS(4167),
    [sym_comment] = ACTIONS(3),
  },
  [1089] = {
    [sym_formal_parameters] = STATE(1991),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1090] = {
    [anon_sym_EQ_GT] = ACTIONS(4169),
    [sym_comment] = ACTIONS(3),
  },
  [1091] = {
    [sym_identifier] = ACTIONS(4171),
    [anon_sym_BQUOTE] = ACTIONS(4173),
    [anon_sym_debugger] = ACTIONS(4171),
    [anon_sym_symbol] = ACTIONS(4171),
    [anon_sym_AT] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_COMMA] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4171),
    [anon_sym_EQ] = ACTIONS(4171),
    [anon_sym_void] = ACTIONS(4171),
    [anon_sym_break] = ACTIONS(4171),
    [anon_sym_const] = ACTIONS(4171),
    [sym_super] = ACTIONS(4171),
    [anon_sym_return] = ACTIONS(4171),
    [anon_sym_private] = ACTIONS(4171),
    [anon_sym_get] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4173),
    [anon_sym_interface] = ACTIONS(4171),
    [anon_sym_default] = ACTIONS(4171),
    [anon_sym_enum] = ACTIONS(4171),
    [anon_sym_delete] = ACTIONS(4171),
    [anon_sym_continue] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4173),
    [anon_sym_if] = ACTIONS(4171),
    [anon_sym_this] = ACTIONS(4171),
    [anon_sym_yield] = ACTIONS(4171),
    [sym_true] = ACTIONS(4171),
    [anon_sym_throw] = ACTIONS(4171),
    [anon_sym_protected] = ACTIONS(4171),
    [anon_sym_abstract] = ACTIONS(4171),
    [anon_sym_set] = ACTIONS(4171),
    [anon_sym_type] = ACTIONS(4171),
    [anon_sym_import] = ACTIONS(4171),
    [anon_sym_namespace] = ACTIONS(4171),
    [anon_sym_PLUS_PLUS] = ACTIONS(4173),
    [anon_sym_await] = ACTIONS(4171),
    [anon_sym_DQUOTE] = ACTIONS(4173),
    [anon_sym_else] = ACTIONS(4171),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_for] = ACTIONS(4171),
    [anon_sym_LBRACK] = ACTIONS(4173),
    [sym_false] = ACTIONS(4171),
    [anon_sym_SEMI] = ACTIONS(4173),
    [anon_sym_case] = ACTIONS(4171),
    [anon_sym_module] = ACTIONS(4171),
    [anon_sym_number] = ACTIONS(4171),
    [anon_sym_class] = ACTIONS(4171),
    [anon_sym_declare] = ACTIONS(4171),
    [anon_sym_typeof] = ACTIONS(4171),
    [anon_sym_LBRACE] = ACTIONS(4173),
    [anon_sym_switch] = ACTIONS(4171),
    [anon_sym_LPAREN] = ACTIONS(4173),
    [anon_sym_RBRACK] = ACTIONS(4173),
    [sym_null] = ACTIONS(4171),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_any] = ACTIONS(4171),
    [anon_sym_boolean] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(4171),
    [anon_sym_public] = ACTIONS(4171),
    [anon_sym_EQ_GT] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_var] = ACTIONS(4171),
    [anon_sym_while] = ACTIONS(4171),
    [anon_sym_SQUOTE] = ACTIONS(4173),
    [anon_sym_try] = ACTIONS(4171),
    [anon_sym_RPAREN] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(4173),
    [sym_number] = ACTIONS(4173),
    [anon_sym_SLASH] = ACTIONS(4171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4171),
    [anon_sym_function] = ACTIONS(4171),
    [sym_undefined] = ACTIONS(4171),
    [anon_sym_new] = ACTIONS(4171),
    [ts_builtin_sym_end] = ACTIONS(4173),
    [anon_sym_let] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4171),
    [anon_sym_export] = ACTIONS(4171),
    [anon_sym_do] = ACTIONS(4171),
    [anon_sym_TILDE] = ACTIONS(4173),
    [anon_sym_with] = ACTIONS(4171),
  },
  [1092] = {
    [sym_identifier] = ACTIONS(4175),
    [anon_sym_BQUOTE] = ACTIONS(4177),
    [anon_sym_debugger] = ACTIONS(4175),
    [anon_sym_symbol] = ACTIONS(4175),
    [anon_sym_AT] = ACTIONS(4177),
    [anon_sym_PIPE] = ACTIONS(4177),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_EQ] = ACTIONS(4175),
    [anon_sym_void] = ACTIONS(4175),
    [anon_sym_break] = ACTIONS(4175),
    [anon_sym_const] = ACTIONS(4175),
    [sym_super] = ACTIONS(4175),
    [anon_sym_return] = ACTIONS(4175),
    [anon_sym_private] = ACTIONS(4175),
    [anon_sym_get] = ACTIONS(4175),
    [anon_sym_RBRACE] = ACTIONS(4177),
    [anon_sym_interface] = ACTIONS(4175),
    [anon_sym_default] = ACTIONS(4175),
    [anon_sym_enum] = ACTIONS(4175),
    [anon_sym_delete] = ACTIONS(4175),
    [anon_sym_continue] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4177),
    [anon_sym_if] = ACTIONS(4175),
    [anon_sym_this] = ACTIONS(4175),
    [anon_sym_yield] = ACTIONS(4175),
    [sym_true] = ACTIONS(4175),
    [anon_sym_throw] = ACTIONS(4175),
    [anon_sym_protected] = ACTIONS(4175),
    [anon_sym_abstract] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(1079),
    [anon_sym_set] = ACTIONS(4175),
    [anon_sym_type] = ACTIONS(4175),
    [anon_sym_import] = ACTIONS(4175),
    [anon_sym_namespace] = ACTIONS(4175),
    [anon_sym_PLUS_PLUS] = ACTIONS(4177),
    [anon_sym_await] = ACTIONS(4175),
    [anon_sym_DQUOTE] = ACTIONS(4177),
    [anon_sym_else] = ACTIONS(4175),
    [anon_sym_BANG] = ACTIONS(4177),
    [anon_sym_for] = ACTIONS(4175),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [sym_false] = ACTIONS(4175),
    [anon_sym_SEMI] = ACTIONS(4177),
    [anon_sym_case] = ACTIONS(4175),
    [anon_sym_module] = ACTIONS(4175),
    [anon_sym_number] = ACTIONS(4175),
    [anon_sym_class] = ACTIONS(4175),
    [anon_sym_declare] = ACTIONS(4175),
    [anon_sym_typeof] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4177),
    [anon_sym_switch] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4177),
    [anon_sym_RBRACK] = ACTIONS(4177),
    [sym_null] = ACTIONS(4175),
    [anon_sym_GT] = ACTIONS(4177),
    [anon_sym_any] = ACTIONS(4175),
    [anon_sym_boolean] = ACTIONS(4175),
    [anon_sym_async] = ACTIONS(4175),
    [anon_sym_public] = ACTIONS(4175),
    [anon_sym_EQ_GT] = ACTIONS(4177),
    [anon_sym_AMP] = ACTIONS(4177),
    [anon_sym_var] = ACTIONS(4175),
    [anon_sym_while] = ACTIONS(4175),
    [anon_sym_SQUOTE] = ACTIONS(4177),
    [anon_sym_try] = ACTIONS(4175),
    [anon_sym_RPAREN] = ACTIONS(4177),
    [anon_sym_LT] = ACTIONS(4177),
    [sym_number] = ACTIONS(4177),
    [anon_sym_SLASH] = ACTIONS(4175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4175),
    [anon_sym_function] = ACTIONS(4175),
    [sym_undefined] = ACTIONS(4175),
    [anon_sym_new] = ACTIONS(4175),
    [ts_builtin_sym_end] = ACTIONS(4177),
    [anon_sym_let] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4175),
    [anon_sym_export] = ACTIONS(4175),
    [anon_sym_do] = ACTIONS(4175),
    [anon_sym_TILDE] = ACTIONS(4177),
    [anon_sym_with] = ACTIONS(4175),
  },
  [1093] = {
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_BQUOTE] = ACTIONS(4181),
    [anon_sym_debugger] = ACTIONS(4179),
    [anon_sym_symbol] = ACTIONS(4179),
    [anon_sym_AT] = ACTIONS(4181),
    [anon_sym_PIPE] = ACTIONS(4181),
    [anon_sym_COMMA] = ACTIONS(4181),
    [anon_sym_DASH] = ACTIONS(4179),
    [anon_sym_EQ] = ACTIONS(4179),
    [anon_sym_void] = ACTIONS(4179),
    [anon_sym_break] = ACTIONS(4179),
    [anon_sym_const] = ACTIONS(4179),
    [sym_super] = ACTIONS(4179),
    [anon_sym_return] = ACTIONS(4179),
    [anon_sym_private] = ACTIONS(4179),
    [anon_sym_get] = ACTIONS(4179),
    [anon_sym_RBRACE] = ACTIONS(4181),
    [anon_sym_interface] = ACTIONS(4179),
    [anon_sym_default] = ACTIONS(4179),
    [anon_sym_enum] = ACTIONS(4179),
    [anon_sym_delete] = ACTIONS(4179),
    [anon_sym_continue] = ACTIONS(4179),
    [anon_sym_DASH_DASH] = ACTIONS(4181),
    [anon_sym_if] = ACTIONS(4179),
    [anon_sym_this] = ACTIONS(4179),
    [anon_sym_yield] = ACTIONS(4179),
    [sym_true] = ACTIONS(4179),
    [anon_sym_throw] = ACTIONS(4179),
    [anon_sym_protected] = ACTIONS(4179),
    [anon_sym_abstract] = ACTIONS(4179),
    [anon_sym_set] = ACTIONS(4179),
    [anon_sym_type] = ACTIONS(4179),
    [anon_sym_import] = ACTIONS(4179),
    [anon_sym_namespace] = ACTIONS(4179),
    [anon_sym_PLUS_PLUS] = ACTIONS(4181),
    [anon_sym_await] = ACTIONS(4179),
    [anon_sym_DQUOTE] = ACTIONS(4181),
    [anon_sym_else] = ACTIONS(4179),
    [anon_sym_BANG] = ACTIONS(4181),
    [anon_sym_for] = ACTIONS(4179),
    [anon_sym_LBRACK] = ACTIONS(4181),
    [sym_false] = ACTIONS(4179),
    [anon_sym_SEMI] = ACTIONS(4181),
    [anon_sym_case] = ACTIONS(4179),
    [anon_sym_module] = ACTIONS(4179),
    [anon_sym_number] = ACTIONS(4179),
    [anon_sym_class] = ACTIONS(4179),
    [anon_sym_declare] = ACTIONS(4179),
    [anon_sym_typeof] = ACTIONS(4179),
    [anon_sym_LBRACE] = ACTIONS(4181),
    [anon_sym_switch] = ACTIONS(4179),
    [anon_sym_LPAREN] = ACTIONS(4181),
    [anon_sym_RBRACK] = ACTIONS(4181),
    [sym_null] = ACTIONS(4179),
    [anon_sym_GT] = ACTIONS(4181),
    [anon_sym_any] = ACTIONS(4179),
    [anon_sym_boolean] = ACTIONS(4179),
    [anon_sym_async] = ACTIONS(4179),
    [anon_sym_public] = ACTIONS(4179),
    [anon_sym_EQ_GT] = ACTIONS(4181),
    [anon_sym_AMP] = ACTIONS(4181),
    [anon_sym_var] = ACTIONS(4179),
    [anon_sym_while] = ACTIONS(4179),
    [anon_sym_SQUOTE] = ACTIONS(4181),
    [anon_sym_try] = ACTIONS(4179),
    [anon_sym_RPAREN] = ACTIONS(4181),
    [anon_sym_LT] = ACTIONS(4181),
    [sym_number] = ACTIONS(4181),
    [anon_sym_SLASH] = ACTIONS(4179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4179),
    [anon_sym_function] = ACTIONS(4179),
    [sym_undefined] = ACTIONS(4179),
    [anon_sym_new] = ACTIONS(4179),
    [ts_builtin_sym_end] = ACTIONS(4181),
    [anon_sym_let] = ACTIONS(4179),
    [anon_sym_PLUS] = ACTIONS(4179),
    [anon_sym_export] = ACTIONS(4179),
    [anon_sym_do] = ACTIONS(4179),
    [anon_sym_TILDE] = ACTIONS(4181),
    [anon_sym_with] = ACTIONS(4179),
  },
  [1094] = {
    [sym_identifier] = ACTIONS(4183),
    [anon_sym_BQUOTE] = ACTIONS(4185),
    [anon_sym_debugger] = ACTIONS(4183),
    [anon_sym_symbol] = ACTIONS(4183),
    [anon_sym_AT] = ACTIONS(4185),
    [anon_sym_PIPE] = ACTIONS(4185),
    [anon_sym_COMMA] = ACTIONS(4185),
    [anon_sym_DASH] = ACTIONS(4183),
    [anon_sym_EQ] = ACTIONS(4183),
    [anon_sym_void] = ACTIONS(4183),
    [anon_sym_break] = ACTIONS(4183),
    [anon_sym_const] = ACTIONS(4183),
    [sym_super] = ACTIONS(4183),
    [anon_sym_return] = ACTIONS(4183),
    [anon_sym_private] = ACTIONS(4183),
    [anon_sym_get] = ACTIONS(4183),
    [anon_sym_RBRACE] = ACTIONS(4185),
    [anon_sym_interface] = ACTIONS(4183),
    [anon_sym_default] = ACTIONS(4183),
    [anon_sym_enum] = ACTIONS(4183),
    [anon_sym_delete] = ACTIONS(4183),
    [anon_sym_continue] = ACTIONS(4183),
    [anon_sym_DASH_DASH] = ACTIONS(4185),
    [anon_sym_if] = ACTIONS(4183),
    [anon_sym_this] = ACTIONS(4183),
    [anon_sym_yield] = ACTIONS(4183),
    [sym_true] = ACTIONS(4183),
    [anon_sym_throw] = ACTIONS(4183),
    [anon_sym_protected] = ACTIONS(4183),
    [anon_sym_abstract] = ACTIONS(4183),
    [anon_sym_DOT] = ACTIONS(4187),
    [anon_sym_set] = ACTIONS(4183),
    [anon_sym_type] = ACTIONS(4183),
    [anon_sym_import] = ACTIONS(4183),
    [anon_sym_namespace] = ACTIONS(4183),
    [anon_sym_PLUS_PLUS] = ACTIONS(4185),
    [anon_sym_await] = ACTIONS(4183),
    [anon_sym_DQUOTE] = ACTIONS(4185),
    [anon_sym_else] = ACTIONS(4183),
    [anon_sym_BANG] = ACTIONS(4185),
    [anon_sym_for] = ACTIONS(4183),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_false] = ACTIONS(4183),
    [anon_sym_SEMI] = ACTIONS(4185),
    [anon_sym_case] = ACTIONS(4183),
    [anon_sym_module] = ACTIONS(4183),
    [anon_sym_number] = ACTIONS(4183),
    [anon_sym_class] = ACTIONS(4183),
    [anon_sym_declare] = ACTIONS(4183),
    [anon_sym_typeof] = ACTIONS(4183),
    [anon_sym_LBRACE] = ACTIONS(4185),
    [anon_sym_switch] = ACTIONS(4183),
    [anon_sym_LPAREN] = ACTIONS(4185),
    [anon_sym_RBRACK] = ACTIONS(4185),
    [sym_null] = ACTIONS(4183),
    [anon_sym_GT] = ACTIONS(4185),
    [anon_sym_any] = ACTIONS(4183),
    [anon_sym_boolean] = ACTIONS(4183),
    [anon_sym_async] = ACTIONS(4183),
    [anon_sym_public] = ACTIONS(4183),
    [anon_sym_EQ_GT] = ACTIONS(4185),
    [anon_sym_AMP] = ACTIONS(4185),
    [anon_sym_var] = ACTIONS(4183),
    [anon_sym_while] = ACTIONS(4183),
    [anon_sym_SQUOTE] = ACTIONS(4185),
    [anon_sym_try] = ACTIONS(4183),
    [anon_sym_RPAREN] = ACTIONS(4185),
    [anon_sym_LT] = ACTIONS(4185),
    [sym_number] = ACTIONS(4185),
    [anon_sym_SLASH] = ACTIONS(4183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4183),
    [anon_sym_function] = ACTIONS(4183),
    [sym_undefined] = ACTIONS(4183),
    [anon_sym_new] = ACTIONS(4183),
    [ts_builtin_sym_end] = ACTIONS(4185),
    [anon_sym_let] = ACTIONS(4183),
    [anon_sym_PLUS] = ACTIONS(4183),
    [anon_sym_export] = ACTIONS(4183),
    [anon_sym_do] = ACTIONS(4183),
    [anon_sym_TILDE] = ACTIONS(4185),
    [anon_sym_with] = ACTIONS(4183),
  },
  [1095] = {
    [sym_identifier] = ACTIONS(4189),
    [anon_sym_BQUOTE] = ACTIONS(4191),
    [anon_sym_debugger] = ACTIONS(4189),
    [anon_sym_symbol] = ACTIONS(4189),
    [anon_sym_AT] = ACTIONS(4191),
    [anon_sym_PIPE] = ACTIONS(4191),
    [anon_sym_COMMA] = ACTIONS(4191),
    [anon_sym_DASH] = ACTIONS(4189),
    [anon_sym_EQ] = ACTIONS(4189),
    [anon_sym_void] = ACTIONS(4189),
    [anon_sym_break] = ACTIONS(4189),
    [anon_sym_const] = ACTIONS(4189),
    [sym_super] = ACTIONS(4189),
    [anon_sym_return] = ACTIONS(4189),
    [anon_sym_private] = ACTIONS(4189),
    [anon_sym_get] = ACTIONS(4189),
    [anon_sym_RBRACE] = ACTIONS(4191),
    [anon_sym_interface] = ACTIONS(4189),
    [anon_sym_default] = ACTIONS(4189),
    [anon_sym_enum] = ACTIONS(4189),
    [anon_sym_delete] = ACTIONS(4189),
    [anon_sym_continue] = ACTIONS(4189),
    [anon_sym_DASH_DASH] = ACTIONS(4191),
    [anon_sym_if] = ACTIONS(4189),
    [anon_sym_this] = ACTIONS(4189),
    [anon_sym_yield] = ACTIONS(4189),
    [sym_true] = ACTIONS(4189),
    [anon_sym_throw] = ACTIONS(4189),
    [anon_sym_protected] = ACTIONS(4189),
    [anon_sym_abstract] = ACTIONS(4189),
    [anon_sym_set] = ACTIONS(4189),
    [anon_sym_type] = ACTIONS(4189),
    [anon_sym_import] = ACTIONS(4189),
    [anon_sym_namespace] = ACTIONS(4189),
    [anon_sym_PLUS_PLUS] = ACTIONS(4191),
    [anon_sym_await] = ACTIONS(4189),
    [anon_sym_DQUOTE] = ACTIONS(4191),
    [anon_sym_else] = ACTIONS(4189),
    [anon_sym_BANG] = ACTIONS(4191),
    [anon_sym_for] = ACTIONS(4189),
    [anon_sym_LBRACK] = ACTIONS(4191),
    [sym_false] = ACTIONS(4189),
    [anon_sym_SEMI] = ACTIONS(4191),
    [anon_sym_case] = ACTIONS(4189),
    [anon_sym_module] = ACTIONS(4189),
    [anon_sym_number] = ACTIONS(4189),
    [anon_sym_class] = ACTIONS(4189),
    [anon_sym_declare] = ACTIONS(4189),
    [anon_sym_typeof] = ACTIONS(4189),
    [anon_sym_LBRACE] = ACTIONS(4191),
    [anon_sym_switch] = ACTIONS(4189),
    [anon_sym_LPAREN] = ACTIONS(4191),
    [anon_sym_RBRACK] = ACTIONS(4191),
    [sym_null] = ACTIONS(4189),
    [anon_sym_GT] = ACTIONS(4191),
    [anon_sym_any] = ACTIONS(4189),
    [anon_sym_boolean] = ACTIONS(4189),
    [anon_sym_async] = ACTIONS(4189),
    [anon_sym_public] = ACTIONS(4189),
    [anon_sym_EQ_GT] = ACTIONS(4191),
    [anon_sym_AMP] = ACTIONS(4191),
    [anon_sym_var] = ACTIONS(4189),
    [anon_sym_while] = ACTIONS(4189),
    [anon_sym_SQUOTE] = ACTIONS(4191),
    [anon_sym_try] = ACTIONS(4189),
    [anon_sym_RPAREN] = ACTIONS(4191),
    [anon_sym_LT] = ACTIONS(4191),
    [sym_number] = ACTIONS(4191),
    [anon_sym_SLASH] = ACTIONS(4189),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4189),
    [anon_sym_function] = ACTIONS(4189),
    [sym_undefined] = ACTIONS(4189),
    [anon_sym_new] = ACTIONS(4189),
    [ts_builtin_sym_end] = ACTIONS(4191),
    [anon_sym_let] = ACTIONS(4189),
    [anon_sym_PLUS] = ACTIONS(4189),
    [anon_sym_export] = ACTIONS(4189),
    [anon_sym_do] = ACTIONS(4189),
    [anon_sym_TILDE] = ACTIONS(4191),
    [anon_sym_with] = ACTIONS(4189),
  },
  [1096] = {
    [sym_formal_parameters] = STATE(1993),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1097] = {
    [anon_sym_EQ_GT] = ACTIONS(4193),
    [sym_comment] = ACTIONS(3),
  },
  [1098] = {
    [sym_new_expression] = STATE(394),
    [sym_constructor_type] = STATE(1088),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(394),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(394),
    [sym_type_parameters] = STATE(1791),
    [sym_array_type] = STATE(436),
    [sym_yield_expression] = STATE(394),
    [sym_as_expression] = STATE(394),
    [sym_jsx_fragment] = STATE(394),
    [sym_internal_module] = STATE(394),
    [sym_arrow_function] = STATE(394),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(162),
    [sym_literal_type] = STATE(436),
    [sym_spread_element] = STATE(395),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(1788),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [aux_sym_array_repeat1] = STATE(396),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(394),
    [sym_subscript_expression] = STATE(162),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(394),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(394),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(1792),
    [sym_function_type] = STATE(1088),
    [sym__type] = STATE(1088),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(394),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(394),
    [sym__expression] = STATE(394),
    [sym_non_null_expression] = STATE(394),
    [sym_jsx_element] = STATE(394),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_await_expression] = STATE(394),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_this] = STATE(394),
    [sym_union_type] = STATE(1088),
    [sym_anonymous_class] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(394),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(394),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1088),
    [sym_parenthesized_expression] = STATE(394),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(394),
    [sym_class] = STATE(394),
    [sym_identifier] = ACTIONS(3755),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(3757),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(2246),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_void] = ACTIONS(3761),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(3763),
    [anon_sym_yield] = ACTIONS(290),
    [sym_true] = ACTIONS(3765),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [sym_false] = ACTIONS(3765),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(3757),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(3767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(268),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [anon_sym_RBRACK] = ACTIONS(723),
    [sym_null] = ACTIONS(721),
    [anon_sym_any] = ACTIONS(3757),
    [anon_sym_boolean] = ACTIONS(3757),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(721),
    [anon_sym_new] = ACTIONS(3771),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_TILDE] = ACTIONS(252),
  },
  [1099] = {
    [sym__initializer] = STATE(764),
    [sym_type_annotation] = STATE(723),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_QMARK] = ACTIONS(3242),
    [anon_sym_RPAREN] = ACTIONS(4195),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(3240),
    [anon_sym_LT] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(4198),
  },
  [1100] = {
    [sym__initializer] = STATE(1546),
    [sym_type_annotation] = STATE(733),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_QMARK] = ACTIONS(3238),
    [anon_sym_RPAREN] = ACTIONS(4200),
    [anon_sym_PIPE] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
  },
  [1101] = {
    [aux_sym_export_statement_repeat1] = STATE(2003),
    [sym__property_name] = STATE(1807),
    [sym_object] = STATE(384),
    [sym_assignment_pattern] = STATE(405),
    [sym_pair] = STATE(405),
    [sym_method_signature] = STATE(1079),
    [sym_call_signature] = STATE(1079),
    [sym_type_parameters] = STATE(1082),
    [sym_index_signature] = STATE(1079),
    [sym_export_statement] = STATE(1079),
    [sym_method_definition] = STATE(405),
    [aux_sym_object_repeat1] = STATE(406),
    [sym_property_signature] = STATE(1079),
    [sym_decorator] = STATE(2003),
    [sym_construct_signature] = STATE(1079),
    [sym_accessibility_modifier] = STATE(1808),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1807),
    [sym_array] = STATE(385),
    [sym_spread_element] = STATE(405),
    [sym_string] = STATE(1807),
    [sym_identifier] = ACTIONS(4203),
    [anon_sym_LBRACK] = ACTIONS(3785),
    [anon_sym_SEMI] = ACTIONS(2218),
    [anon_sym_module] = ACTIONS(4205),
    [anon_sym_symbol] = ACTIONS(4205),
    [anon_sym_number] = ACTIONS(4205),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(4205),
    [anon_sym_COMMA] = ACTIONS(3789),
    [anon_sym_STAR] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_void] = ACTIONS(4205),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(4205),
    [anon_sym_private] = ACTIONS(4207),
    [anon_sym_boolean] = ACTIONS(4205),
    [anon_sym_static] = ACTIONS(3795),
    [anon_sym_async] = ACTIONS(4209),
    [anon_sym_get] = ACTIONS(4211),
    [anon_sym_RBRACE] = ACTIONS(4213),
    [anon_sym_public] = ACTIONS(4207),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(3801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4207),
    [anon_sym_string] = ACTIONS(4205),
    [anon_sym_set] = ACTIONS(4211),
    [anon_sym_type] = ACTIONS(4205),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(4205),
    [anon_sym_export] = ACTIONS(4215),
    [sym_readonly] = ACTIONS(3805),
    [anon_sym_namespace] = ACTIONS(4205),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [1102] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1108),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1109),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2282),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1103] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1108),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1109),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2282),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1104] = {
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(433),
    [sym_array_type] = STATE(1066),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym_existential_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(1066),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(1066),
    [sym_string] = STATE(418),
    [sym_tuple_type] = STATE(1066),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [sym_true] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1105] = {
    [anon_sym_EQ] = ACTIONS(207),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2254),
    [anon_sym_RPAREN] = ACTIONS(3825),
    [anon_sym_PIPE] = ACTIONS(2254),
    [anon_sym_COMMA] = ACTIONS(207),
    [sym_comment] = ACTIONS(3),
  },
  [1106] = {
    [sym_type_parameters] = STATE(2004),
    [sym_formal_parameters] = STATE(2005),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1107] = {
    [anon_sym_AMP] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(4219),
    [anon_sym_PIPE] = ACTIONS(4221),
    [sym_comment] = ACTIONS(3),
  },
  [1108] = {
    [sym_formal_parameters] = STATE(2009),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1109] = {
    [anon_sym_EQ_GT] = ACTIONS(4223),
    [sym_comment] = ACTIONS(3),
  },
  [1110] = {
    [sym_identifier] = ACTIONS(4225),
    [anon_sym_BQUOTE] = ACTIONS(4227),
    [anon_sym_debugger] = ACTIONS(4225),
    [anon_sym_symbol] = ACTIONS(4225),
    [anon_sym_AT] = ACTIONS(4227),
    [anon_sym_PIPE] = ACTIONS(4227),
    [anon_sym_COMMA] = ACTIONS(4227),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_EQ] = ACTIONS(4225),
    [anon_sym_void] = ACTIONS(4225),
    [anon_sym_break] = ACTIONS(4225),
    [anon_sym_const] = ACTIONS(4225),
    [sym_super] = ACTIONS(4225),
    [anon_sym_return] = ACTIONS(4225),
    [anon_sym_private] = ACTIONS(4225),
    [anon_sym_get] = ACTIONS(4225),
    [anon_sym_RBRACE] = ACTIONS(4227),
    [anon_sym_interface] = ACTIONS(4225),
    [anon_sym_default] = ACTIONS(4225),
    [anon_sym_enum] = ACTIONS(4225),
    [anon_sym_delete] = ACTIONS(4225),
    [anon_sym_continue] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4227),
    [anon_sym_if] = ACTIONS(4225),
    [anon_sym_this] = ACTIONS(4225),
    [anon_sym_yield] = ACTIONS(4225),
    [sym_true] = ACTIONS(4225),
    [anon_sym_throw] = ACTIONS(4225),
    [anon_sym_protected] = ACTIONS(4225),
    [anon_sym_abstract] = ACTIONS(4225),
    [anon_sym_set] = ACTIONS(4225),
    [anon_sym_type] = ACTIONS(4225),
    [anon_sym_import] = ACTIONS(4225),
    [anon_sym_namespace] = ACTIONS(4225),
    [anon_sym_PLUS_PLUS] = ACTIONS(4227),
    [anon_sym_await] = ACTIONS(4225),
    [anon_sym_DQUOTE] = ACTIONS(4227),
    [anon_sym_else] = ACTIONS(4225),
    [anon_sym_BANG] = ACTIONS(4227),
    [anon_sym_for] = ACTIONS(4225),
    [anon_sym_LBRACK] = ACTIONS(4227),
    [sym_false] = ACTIONS(4225),
    [anon_sym_SEMI] = ACTIONS(4227),
    [anon_sym_case] = ACTIONS(4225),
    [anon_sym_module] = ACTIONS(4225),
    [anon_sym_number] = ACTIONS(4225),
    [anon_sym_class] = ACTIONS(4225),
    [anon_sym_declare] = ACTIONS(4225),
    [anon_sym_typeof] = ACTIONS(4225),
    [anon_sym_LBRACE] = ACTIONS(4227),
    [anon_sym_switch] = ACTIONS(4225),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_RBRACK] = ACTIONS(4227),
    [sym_null] = ACTIONS(4225),
    [anon_sym_GT] = ACTIONS(4227),
    [anon_sym_any] = ACTIONS(4225),
    [anon_sym_boolean] = ACTIONS(4225),
    [anon_sym_async] = ACTIONS(4225),
    [anon_sym_public] = ACTIONS(4225),
    [anon_sym_EQ_GT] = ACTIONS(4227),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_var] = ACTIONS(4225),
    [anon_sym_while] = ACTIONS(4225),
    [anon_sym_SQUOTE] = ACTIONS(4227),
    [anon_sym_try] = ACTIONS(4225),
    [anon_sym_RPAREN] = ACTIONS(4227),
    [anon_sym_LT] = ACTIONS(4227),
    [sym_number] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4225),
    [anon_sym_function] = ACTIONS(4225),
    [sym_undefined] = ACTIONS(4225),
    [anon_sym_new] = ACTIONS(4225),
    [ts_builtin_sym_end] = ACTIONS(4227),
    [anon_sym_let] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_export] = ACTIONS(4225),
    [anon_sym_do] = ACTIONS(4225),
    [anon_sym_TILDE] = ACTIONS(4227),
    [anon_sym_with] = ACTIONS(4225),
  },
  [1111] = {
    [anon_sym_EQ_GT] = ACTIONS(4229),
    [sym_identifier] = ACTIONS(4231),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_BQUOTE] = ACTIONS(4229),
    [anon_sym_AMP] = ACTIONS(4229),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4229),
    [anon_sym_while] = ACTIONS(4231),
    [anon_sym_RPAREN] = ACTIONS(4229),
    [anon_sym_PIPE] = ACTIONS(4229),
    [anon_sym_COMMA] = ACTIONS(4229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4231),
    [anon_sym_EQ] = ACTIONS(4231),
    [anon_sym_LPAREN] = ACTIONS(4229),
    [anon_sym_RBRACK] = ACTIONS(4229),
    [sym_jsx_identifier] = ACTIONS(4229),
    [anon_sym_GT] = ACTIONS(4229),
  },
  [1112] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1113] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1114] = {
    [sym_union_type] = STATE(2014),
    [sym__type] = STATE(2014),
    [sym_constructor_type] = STATE(2014),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2014),
    [sym_function_type] = STATE(2014),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(4233),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_boolean] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_this] = ACTIONS(765),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [1115] = {
    [aux_sym_implements_clause_repeat1] = STATE(2016),
    [anon_sym_COMMA] = ACTIONS(4235),
    [anon_sym_GT] = ACTIONS(4233),
    [sym_comment] = ACTIONS(3),
  },
  [1116] = {
    [sym_union_type] = STATE(2017),
    [sym__type] = STATE(2017),
    [sym_constructor_type] = STATE(2017),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1926),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2017),
    [sym_function_type] = STATE(2017),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1927),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4057),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1117] = {
    [sym_identifier] = ACTIONS(4237),
    [anon_sym_BQUOTE] = ACTIONS(4239),
    [anon_sym_debugger] = ACTIONS(4237),
    [anon_sym_symbol] = ACTIONS(4237),
    [anon_sym_AT] = ACTIONS(4239),
    [anon_sym_PIPE] = ACTIONS(4239),
    [anon_sym_COMMA] = ACTIONS(4239),
    [anon_sym_DASH] = ACTIONS(4237),
    [anon_sym_EQ] = ACTIONS(4237),
    [anon_sym_void] = ACTIONS(4237),
    [anon_sym_break] = ACTIONS(4237),
    [anon_sym_const] = ACTIONS(4237),
    [sym_super] = ACTIONS(4237),
    [anon_sym_return] = ACTIONS(4237),
    [anon_sym_private] = ACTIONS(4237),
    [anon_sym_get] = ACTIONS(4237),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4239),
    [anon_sym_RBRACE] = ACTIONS(4239),
    [anon_sym_interface] = ACTIONS(4237),
    [anon_sym_default] = ACTIONS(4237),
    [anon_sym_enum] = ACTIONS(4237),
    [anon_sym_delete] = ACTIONS(4237),
    [anon_sym_continue] = ACTIONS(4237),
    [anon_sym_DASH_DASH] = ACTIONS(4239),
    [anon_sym_if] = ACTIONS(4237),
    [anon_sym_this] = ACTIONS(4237),
    [anon_sym_yield] = ACTIONS(4237),
    [sym_true] = ACTIONS(4237),
    [anon_sym_throw] = ACTIONS(4237),
    [anon_sym_protected] = ACTIONS(4237),
    [anon_sym_abstract] = ACTIONS(4237),
    [anon_sym_set] = ACTIONS(4237),
    [anon_sym_type] = ACTIONS(4237),
    [anon_sym_import] = ACTIONS(4237),
    [anon_sym_namespace] = ACTIONS(4237),
    [anon_sym_PLUS_PLUS] = ACTIONS(4239),
    [anon_sym_await] = ACTIONS(4237),
    [anon_sym_DQUOTE] = ACTIONS(4239),
    [anon_sym_else] = ACTIONS(4237),
    [anon_sym_BANG] = ACTIONS(4239),
    [anon_sym_for] = ACTIONS(4237),
    [anon_sym_LBRACK] = ACTIONS(4239),
    [sym_false] = ACTIONS(4237),
    [anon_sym_SEMI] = ACTIONS(4239),
    [anon_sym_case] = ACTIONS(4237),
    [anon_sym_module] = ACTIONS(4237),
    [anon_sym_number] = ACTIONS(4237),
    [anon_sym_class] = ACTIONS(4237),
    [anon_sym_declare] = ACTIONS(4237),
    [anon_sym_typeof] = ACTIONS(4237),
    [anon_sym_LBRACE] = ACTIONS(4237),
    [anon_sym_switch] = ACTIONS(4237),
    [anon_sym_LPAREN] = ACTIONS(4239),
    [anon_sym_RBRACK] = ACTIONS(4239),
    [sym_null] = ACTIONS(4237),
    [anon_sym_GT] = ACTIONS(4239),
    [anon_sym_any] = ACTIONS(4237),
    [anon_sym_boolean] = ACTIONS(4237),
    [anon_sym_async] = ACTIONS(4237),
    [anon_sym_public] = ACTIONS(4237),
    [anon_sym_EQ_GT] = ACTIONS(4239),
    [anon_sym_AMP] = ACTIONS(4239),
    [anon_sym_var] = ACTIONS(4237),
    [anon_sym_while] = ACTIONS(4237),
    [anon_sym_SQUOTE] = ACTIONS(4239),
    [anon_sym_try] = ACTIONS(4237),
    [anon_sym_RPAREN] = ACTIONS(4239),
    [anon_sym_LT] = ACTIONS(4239),
    [sym_number] = ACTIONS(4239),
    [anon_sym_SLASH] = ACTIONS(4237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4237),
    [anon_sym_function] = ACTIONS(4237),
    [sym_undefined] = ACTIONS(4237),
    [anon_sym_new] = ACTIONS(4237),
    [ts_builtin_sym_end] = ACTIONS(4239),
    [anon_sym_let] = ACTIONS(4237),
    [anon_sym_PLUS] = ACTIONS(4237),
    [anon_sym_implements] = ACTIONS(4237),
    [anon_sym_export] = ACTIONS(4237),
    [anon_sym_do] = ACTIONS(4237),
    [anon_sym_TILDE] = ACTIONS(4239),
    [anon_sym_with] = ACTIONS(4237),
  },
  [1118] = {
    [anon_sym_EQ_GT] = ACTIONS(4241),
    [sym_comment] = ACTIONS(3),
  },
  [1119] = {
    [anon_sym_RBRACK] = ACTIONS(4243),
    [sym_comment] = ACTIONS(3),
  },
  [1120] = {
    [sym_union_type] = STATE(2020),
    [sym__type] = STATE(2020),
    [sym_constructor_type] = STATE(2020),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2020),
    [sym_function_type] = STATE(2020),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1121] = {
    [sym_new_expression] = STATE(2021),
    [sym_augmented_assignment_expression] = STATE(2021),
    [sym_unary_expression] = STATE(2021),
    [sym_update_expression] = STATE(2021),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(2021),
    [sym_regex] = STATE(2021),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1233),
    [sym__expression] = STATE(2021),
    [sym_non_null_expression] = STATE(2021),
    [sym_yield_expression] = STATE(2021),
    [sym_jsx_fragment] = STATE(2021),
    [sym_jsx_element] = STATE(2021),
    [sym_as_expression] = STATE(2021),
    [sym_internal_module] = STATE(2021),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2021),
    [sym_await_expression] = STATE(2021),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(2021),
    [sym_this] = STATE(2021),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(2021),
    [sym_generator_function] = STATE(2021),
    [sym_call_expression] = STATE(2021),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(2021),
    [sym_ternary_expression] = STATE(2021),
    [sym_binary_expression] = STATE(2021),
    [sym_template_string] = STATE(2021),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2021),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2021),
    [sym_class] = STATE(2021),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(4245),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4245),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4247),
    [sym_true] = ACTIONS(4245),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4245),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [1122] = {
    [sym_new_expression] = STATE(2022),
    [sym_augmented_assignment_expression] = STATE(2022),
    [sym_unary_expression] = STATE(2022),
    [sym_update_expression] = STATE(2022),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(2022),
    [sym_regex] = STATE(2022),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2022),
    [sym_non_null_expression] = STATE(2022),
    [sym_as_expression] = STATE(2022),
    [sym_jsx_fragment] = STATE(2022),
    [sym_yield_expression] = STATE(2022),
    [sym_jsx_element] = STATE(2022),
    [sym_internal_module] = STATE(2022),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2022),
    [sym_await_expression] = STATE(2022),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(2022),
    [sym_this] = STATE(2022),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(2022),
    [sym_generator_function] = STATE(2022),
    [sym_call_expression] = STATE(2022),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(2022),
    [sym_ternary_expression] = STATE(2022),
    [sym_binary_expression] = STATE(2022),
    [sym_template_string] = STATE(2022),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2022),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2022),
    [sym_class] = STATE(2022),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(4249),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4249),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4251),
    [sym_true] = ACTIONS(4249),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4249),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [1123] = {
    [sym_new_expression] = STATE(2023),
    [sym_augmented_assignment_expression] = STATE(2023),
    [sym_unary_expression] = STATE(2023),
    [sym_update_expression] = STATE(2023),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(2023),
    [sym_regex] = STATE(2023),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2023),
    [sym_non_null_expression] = STATE(2023),
    [sym_as_expression] = STATE(2023),
    [sym_jsx_fragment] = STATE(2023),
    [sym_yield_expression] = STATE(2023),
    [sym_jsx_element] = STATE(2023),
    [sym_internal_module] = STATE(2023),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2023),
    [sym_await_expression] = STATE(2023),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(2023),
    [sym_this] = STATE(2023),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(2023),
    [sym_generator_function] = STATE(2023),
    [sym_call_expression] = STATE(2023),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(2023),
    [sym_ternary_expression] = STATE(2023),
    [sym_binary_expression] = STATE(2023),
    [sym_template_string] = STATE(2023),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2023),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2023),
    [sym_class] = STATE(2023),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(4253),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4253),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4255),
    [sym_true] = ACTIONS(4253),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4253),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [1124] = {
    [sym_new_expression] = STATE(2024),
    [sym_augmented_assignment_expression] = STATE(2024),
    [sym_unary_expression] = STATE(2024),
    [sym_update_expression] = STATE(2024),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(2024),
    [sym_regex] = STATE(2024),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1240),
    [sym__expression] = STATE(2024),
    [sym_non_null_expression] = STATE(2024),
    [sym_yield_expression] = STATE(2024),
    [sym_jsx_fragment] = STATE(2024),
    [sym_jsx_element] = STATE(2024),
    [sym_as_expression] = STATE(2024),
    [sym_internal_module] = STATE(2024),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2024),
    [sym_await_expression] = STATE(2024),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(2024),
    [sym_this] = STATE(2024),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(2024),
    [sym_generator_function] = STATE(2024),
    [sym_call_expression] = STATE(2024),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(2024),
    [sym_ternary_expression] = STATE(2024),
    [sym_binary_expression] = STATE(2024),
    [sym_template_string] = STATE(2024),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2024),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2024),
    [sym_class] = STATE(2024),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(4257),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4257),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4259),
    [sym_true] = ACTIONS(4257),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4257),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [1125] = {
    [sym_new_expression] = STATE(2025),
    [sym_augmented_assignment_expression] = STATE(2025),
    [sym_unary_expression] = STATE(2025),
    [sym_update_expression] = STATE(2025),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(2025),
    [sym_regex] = STATE(2025),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2025),
    [sym_non_null_expression] = STATE(2025),
    [sym_as_expression] = STATE(2025),
    [sym_jsx_fragment] = STATE(2025),
    [sym_yield_expression] = STATE(2025),
    [sym_jsx_element] = STATE(2025),
    [sym_internal_module] = STATE(2025),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2025),
    [sym_await_expression] = STATE(2025),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(2025),
    [sym_this] = STATE(2025),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(2025),
    [sym_generator_function] = STATE(2025),
    [sym_call_expression] = STATE(2025),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(2025),
    [sym_ternary_expression] = STATE(2025),
    [sym_binary_expression] = STATE(2025),
    [sym_template_string] = STATE(2025),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2025),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2025),
    [sym_class] = STATE(2025),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(4261),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4261),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4263),
    [sym_true] = ACTIONS(4261),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4261),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [1126] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_RPAREN] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(4265),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [1127] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_RPAREN] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(4265),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [1128] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(2583),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_RPAREN] = ACTIONS(2583),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [1129] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(2585),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_RPAREN] = ACTIONS(2585),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [1130] = {
    [anon_sym_EQ_GT] = ACTIONS(4268),
    [sym_comment] = ACTIONS(3),
  },
  [1131] = {
    [anon_sym_EQ_GT] = ACTIONS(4270),
    [sym_comment] = ACTIONS(3),
  },
  [1132] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_BQUOTE] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_RPAREN] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_instanceof] = ACTIONS(839),
    [anon_sym_SLASH] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_in] = ACTIONS(841),
  },
  [1133] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(871),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_RPAREN] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_in] = ACTIONS(2311),
  },
  [1134] = {
    [sym__initializer] = STATE(522),
    [sym_arguments] = STATE(1268),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(2309),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1531),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1529),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [1135] = {
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(2315),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_RPAREN] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [1136] = {
    [sym_new_expression] = STATE(836),
    [sym_augmented_assignment_expression] = STATE(836),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(836),
    [sym_update_expression] = STATE(836),
    [sym_regex] = STATE(836),
    [sym_meta_property] = STATE(836),
    [sym_call_signature] = STATE(835),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(836),
    [sym_non_null_expression] = STATE(836),
    [sym_yield_expression] = STATE(836),
    [sym_jsx_fragment] = STATE(836),
    [sym_jsx_element] = STATE(836),
    [sym_as_expression] = STATE(836),
    [sym_internal_module] = STATE(836),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(836),
    [sym_await_expression] = STATE(836),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(836),
    [sym_this] = STATE(836),
    [sym_arguments] = STATE(1270),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(836),
    [sym_generator_function] = STATE(836),
    [sym_call_expression] = STATE(836),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(836),
    [sym_ternary_expression] = STATE(836),
    [sym_binary_expression] = STATE(836),
    [sym_template_string] = STATE(836),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(836),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(836),
    [sym_class] = STATE(836),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(500),
    [sym_true] = ACTIONS(1545),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [sym_false] = ACTIONS(1545),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [sym_null] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(2315),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_RPAREN] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [sym_number] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [1137] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_arguments] = STATE(1270),
    [sym_call_signature] = STATE(1130),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(2333),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(2335),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(2335),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(2335),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_protected] = ACTIONS(2335),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(2335),
    [anon_sym_type] = ACTIONS(2335),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(2335),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(2335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(2335),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(2335),
    [anon_sym_declare] = ACTIONS(2335),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(2335),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(2335),
    [anon_sym_async] = ACTIONS(2335),
    [anon_sym_public] = ACTIONS(2335),
    [anon_sym_EQ_GT] = ACTIONS(2315),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_RPAREN] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(2335),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(2335),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [1138] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(2315),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_RPAREN] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [1139] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_RPAREN] = ACTIONS(915),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_in] = ACTIONS(2311),
  },
  [1140] = {
    [sym_new_expression] = STATE(2028),
    [sym_augmented_assignment_expression] = STATE(2028),
    [sym_unary_expression] = STATE(2028),
    [sym_update_expression] = STATE(2028),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(2028),
    [sym_regex] = STATE(2028),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2028),
    [sym_non_null_expression] = STATE(2028),
    [sym_as_expression] = STATE(2028),
    [sym_jsx_fragment] = STATE(2028),
    [sym_yield_expression] = STATE(2028),
    [sym_jsx_element] = STATE(2028),
    [sym_internal_module] = STATE(2028),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2028),
    [sym_await_expression] = STATE(2028),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(2028),
    [sym_this] = STATE(2028),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(2028),
    [sym_generator_function] = STATE(2028),
    [sym_call_expression] = STATE(2028),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(2028),
    [sym_ternary_expression] = STATE(2028),
    [sym_binary_expression] = STATE(2028),
    [sym_template_string] = STATE(2028),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2028),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2028),
    [sym_class] = STATE(2028),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4272),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4274),
    [sym_true] = ACTIONS(4272),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4272),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [1141] = {
    [sym_new_expression] = STATE(2029),
    [sym_augmented_assignment_expression] = STATE(2029),
    [sym_unary_expression] = STATE(2029),
    [sym_update_expression] = STATE(2029),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(2029),
    [sym_regex] = STATE(2029),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2029),
    [sym_non_null_expression] = STATE(2029),
    [sym_as_expression] = STATE(2029),
    [sym_jsx_fragment] = STATE(2029),
    [sym_yield_expression] = STATE(2029),
    [sym_jsx_element] = STATE(2029),
    [sym_internal_module] = STATE(2029),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2029),
    [sym_await_expression] = STATE(2029),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(2029),
    [sym_this] = STATE(2029),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(2029),
    [sym_generator_function] = STATE(2029),
    [sym_call_expression] = STATE(2029),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(2029),
    [sym_ternary_expression] = STATE(2029),
    [sym_binary_expression] = STATE(2029),
    [sym_template_string] = STATE(2029),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2029),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2029),
    [sym_class] = STATE(2029),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(4276),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4276),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4278),
    [sym_true] = ACTIONS(4276),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4276),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [1142] = {
    [sym_new_expression] = STATE(2030),
    [sym_augmented_assignment_expression] = STATE(2030),
    [sym_unary_expression] = STATE(2030),
    [sym_update_expression] = STATE(2030),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(2030),
    [sym_regex] = STATE(2030),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2030),
    [sym_non_null_expression] = STATE(2030),
    [sym_as_expression] = STATE(2030),
    [sym_jsx_fragment] = STATE(2030),
    [sym_yield_expression] = STATE(2030),
    [sym_jsx_element] = STATE(2030),
    [sym_internal_module] = STATE(2030),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2030),
    [sym_await_expression] = STATE(2030),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(2030),
    [sym_this] = STATE(2030),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(2030),
    [sym_generator_function] = STATE(2030),
    [sym_call_expression] = STATE(2030),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(2030),
    [sym_ternary_expression] = STATE(2030),
    [sym_binary_expression] = STATE(2030),
    [sym_template_string] = STATE(2030),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2030),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2030),
    [sym_class] = STATE(2030),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(4280),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4280),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4282),
    [sym_true] = ACTIONS(4280),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4280),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [1143] = {
    [sym_new_expression] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(2031),
    [sym_unary_expression] = STATE(2031),
    [sym_update_expression] = STATE(2031),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(2031),
    [sym_regex] = STATE(2031),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2031),
    [sym_non_null_expression] = STATE(2031),
    [sym_as_expression] = STATE(2031),
    [sym_jsx_fragment] = STATE(2031),
    [sym_yield_expression] = STATE(2031),
    [sym_jsx_element] = STATE(2031),
    [sym_internal_module] = STATE(2031),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2031),
    [sym_await_expression] = STATE(2031),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(2031),
    [sym_this] = STATE(2031),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(2031),
    [sym_generator_function] = STATE(2031),
    [sym_call_expression] = STATE(2031),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(2031),
    [sym_ternary_expression] = STATE(2031),
    [sym_binary_expression] = STATE(2031),
    [sym_template_string] = STATE(2031),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2031),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2031),
    [sym_class] = STATE(2031),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(4284),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4284),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4286),
    [sym_true] = ACTIONS(4284),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4284),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [1144] = {
    [sym_new_expression] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(2032),
    [sym_unary_expression] = STATE(2032),
    [sym_update_expression] = STATE(2032),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(2032),
    [sym_regex] = STATE(2032),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2032),
    [sym_non_null_expression] = STATE(2032),
    [sym_as_expression] = STATE(2032),
    [sym_jsx_fragment] = STATE(2032),
    [sym_yield_expression] = STATE(2032),
    [sym_jsx_element] = STATE(2032),
    [sym_internal_module] = STATE(2032),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2032),
    [sym_await_expression] = STATE(2032),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(2032),
    [sym_this] = STATE(2032),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(2032),
    [sym_generator_function] = STATE(2032),
    [sym_call_expression] = STATE(2032),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(2032),
    [sym_ternary_expression] = STATE(2032),
    [sym_binary_expression] = STATE(2032),
    [sym_template_string] = STATE(2032),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2032),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2032),
    [sym_class] = STATE(2032),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4288),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4290),
    [sym_true] = ACTIONS(4288),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4288),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [1145] = {
    [sym_union_type] = STATE(1293),
    [sym__type] = STATE(1293),
    [sym_constructor_type] = STATE(1293),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2038),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_template_string] = STATE(1297),
    [sym_intersection_type] = STATE(1293),
    [sym_function_type] = STATE(1293),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2039),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(4292),
    [sym_false] = ACTIONS(2643),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_PIPE] = ACTIONS(4294),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_boolean] = ACTIONS(2647),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(4296),
    [anon_sym_QMARK] = ACTIONS(4298),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2669),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_new] = ACTIONS(4300),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_DQUOTE] = ACTIONS(304),
  },
  [1146] = {
    [sym_new_expression] = STATE(2022),
    [sym_constructor_type] = STATE(432),
    [sym_augmented_assignment_expression] = STATE(2022),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(2022),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(2022),
    [sym_type_parameters] = STATE(959),
    [sym_array_type] = STATE(436),
    [sym_yield_expression] = STATE(2022),
    [sym_as_expression] = STATE(2022),
    [sym_jsx_fragment] = STATE(2022),
    [sym_internal_module] = STATE(2022),
    [sym_arrow_function] = STATE(2022),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(454),
    [sym_literal_type] = STATE(436),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(1301),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(2022),
    [sym_subscript_expression] = STATE(454),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(2022),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(2022),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(960),
    [sym_function_type] = STATE(432),
    [sym__type] = STATE(432),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(2022),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(2022),
    [sym__expression] = STATE(2022),
    [sym_non_null_expression] = STATE(2022),
    [sym_jsx_element] = STATE(2022),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_await_expression] = STATE(2022),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_this] = STATE(2022),
    [sym_union_type] = STATE(432),
    [sym_anonymous_class] = STATE(2022),
    [sym_call_expression] = STATE(2022),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(2022),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(2022),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(432),
    [sym_parenthesized_expression] = STATE(2022),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2022),
    [sym_class] = STATE(2022),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(4302),
    [sym_false] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(4304),
    [anon_sym_number] = ACTIONS(4304),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(4306),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4308),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_void] = ACTIONS(4310),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [sym_null] = ACTIONS(4249),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4304),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(4304),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2691),
    [sym_true] = ACTIONS(2677),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(2693),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(4304),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4249),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(4312),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(4308),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [1147] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4314),
    [anon_sym_LBRACK] = ACTIONS(4314),
    [anon_sym_BANG] = ACTIONS(4316),
    [anon_sym_SEMI] = ACTIONS(4314),
    [anon_sym_BQUOTE] = ACTIONS(4314),
    [sym__automatic_semicolon] = ACTIONS(4314),
    [anon_sym_PIPE] = ACTIONS(4316),
    [anon_sym_COMMA] = ACTIONS(4314),
    [anon_sym_LT_LT] = ACTIONS(4314),
    [anon_sym_STAR] = ACTIONS(4316),
    [anon_sym_GT_GT_GT] = ACTIONS(4314),
    [anon_sym_AMP_AMP] = ACTIONS(4314),
    [anon_sym_DASH] = ACTIONS(4316),
    [anon_sym_BANG_EQ] = ACTIONS(4316),
    [anon_sym_LT_EQ] = ACTIONS(4314),
    [anon_sym_LPAREN] = ACTIONS(4314),
    [anon_sym_GT_EQ] = ACTIONS(4314),
    [anon_sym_GT] = ACTIONS(4316),
    [anon_sym_AMP] = ACTIONS(4316),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_QMARK] = ACTIONS(4314),
    [anon_sym_RBRACE] = ACTIONS(4314),
    [anon_sym_as] = ACTIONS(4314),
    [anon_sym_PIPE_PIPE] = ACTIONS(4314),
    [anon_sym_DASH_DASH] = ACTIONS(4314),
    [anon_sym_EQ_EQ] = ACTIONS(4316),
    [anon_sym_instanceof] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4316),
    [anon_sym_RPAREN] = ACTIONS(4314),
    [anon_sym_SLASH] = ACTIONS(4316),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4314),
    [anon_sym_CARET] = ACTIONS(4314),
    [anon_sym_STAR_STAR] = ACTIONS(4314),
    [anon_sym_PLUS] = ACTIONS(4316),
    [anon_sym_GT_GT] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4314),
    [anon_sym_in] = ACTIONS(4316),
  },
  [1148] = {
    [sym_new_expression] = STATE(2046),
    [sym_augmented_assignment_expression] = STATE(2046),
    [sym_unary_expression] = STATE(2046),
    [sym_update_expression] = STATE(2046),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(2046),
    [sym_regex] = STATE(2046),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2046),
    [sym_non_null_expression] = STATE(2046),
    [sym_as_expression] = STATE(2046),
    [sym_jsx_fragment] = STATE(2046),
    [sym_yield_expression] = STATE(2046),
    [sym_jsx_element] = STATE(2046),
    [sym_internal_module] = STATE(2046),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2046),
    [sym_await_expression] = STATE(2046),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(2046),
    [sym_this] = STATE(2046),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(2046),
    [sym_generator_function] = STATE(2046),
    [sym_call_expression] = STATE(2046),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(2046),
    [sym_ternary_expression] = STATE(2046),
    [sym_binary_expression] = STATE(2046),
    [sym_template_string] = STATE(2046),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2046),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2046),
    [sym_class] = STATE(2046),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(4318),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4318),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4320),
    [sym_true] = ACTIONS(4318),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4318),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [1149] = {
    [aux_sym_array_repeat1] = STATE(1150),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_RPAREN] = ACTIONS(4322),
    [sym_comment] = ACTIONS(3),
  },
  [1150] = {
    [aux_sym_array_repeat1] = STATE(1150),
    [anon_sym_COMMA] = ACTIONS(4324),
    [anon_sym_RPAREN] = ACTIONS(2585),
    [sym_comment] = ACTIONS(3),
  },
  [1151] = {
    [sym__initializer] = STATE(522),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4327),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4327),
    [anon_sym_AMP_EQ] = ACTIONS(4327),
    [anon_sym_PLUS_EQ] = ACTIONS(4327),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(2716),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(4329),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4327),
    [anon_sym_STAR_EQ] = ACTIONS(4327),
    [anon_sym_PIPE_EQ] = ACTIONS(4327),
    [anon_sym_DASH_EQ] = ACTIONS(4327),
    [anon_sym_EQ_GT] = ACTIONS(4333),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2716),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4327),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4327),
    [anon_sym_GT_GT_EQ] = ACTIONS(4327),
    [anon_sym_DOT] = ACTIONS(2725),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4327),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4335),
  },
  [1152] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4337),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4337),
    [anon_sym_AMP_EQ] = ACTIONS(4337),
    [anon_sym_PLUS_EQ] = ACTIONS(4337),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4337),
    [anon_sym_STAR_EQ] = ACTIONS(4337),
    [anon_sym_PIPE_EQ] = ACTIONS(4337),
    [anon_sym_DASH_EQ] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4339),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4337),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4337),
    [anon_sym_GT_GT_EQ] = ACTIONS(4337),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4337),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1153] = {
    [sym_new_expression] = STATE(2055),
    [sym_augmented_assignment_expression] = STATE(2055),
    [sym_unary_expression] = STATE(2055),
    [sym_update_expression] = STATE(2055),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(2055),
    [sym_regex] = STATE(2055),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2055),
    [sym_non_null_expression] = STATE(2055),
    [sym_as_expression] = STATE(2055),
    [sym_jsx_fragment] = STATE(2055),
    [sym_yield_expression] = STATE(2055),
    [sym_jsx_element] = STATE(2055),
    [sym_internal_module] = STATE(2055),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2055),
    [sym_await_expression] = STATE(2055),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(2055),
    [sym_this] = STATE(2055),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(2055),
    [sym_generator_function] = STATE(2055),
    [sym_call_expression] = STATE(2055),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2055),
    [sym_ternary_expression] = STATE(2055),
    [sym_binary_expression] = STATE(2055),
    [sym_template_string] = STATE(2055),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2055),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2055),
    [sym_class] = STATE(2055),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(4341),
    [sym_false] = ACTIONS(4343),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4343),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4345),
    [sym_true] = ACTIONS(4343),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4343),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [1154] = {
    [sym_new_expression] = STATE(2056),
    [sym_augmented_assignment_expression] = STATE(2056),
    [sym_unary_expression] = STATE(2056),
    [sym_update_expression] = STATE(2056),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(2056),
    [sym_regex] = STATE(2056),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2056),
    [sym_non_null_expression] = STATE(2056),
    [sym_as_expression] = STATE(2056),
    [sym_jsx_fragment] = STATE(2056),
    [sym_yield_expression] = STATE(2056),
    [sym_jsx_element] = STATE(2056),
    [sym_internal_module] = STATE(2056),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2056),
    [sym_await_expression] = STATE(2056),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(2056),
    [sym_this] = STATE(2056),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(2056),
    [sym_generator_function] = STATE(2056),
    [sym_call_expression] = STATE(2056),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2056),
    [sym_ternary_expression] = STATE(2056),
    [sym_binary_expression] = STATE(2056),
    [sym_template_string] = STATE(2056),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2056),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2056),
    [sym_class] = STATE(2056),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(4341),
    [sym_false] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4347),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4349),
    [sym_true] = ACTIONS(4347),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4347),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [1155] = {
    [sym_new_expression] = STATE(2055),
    [sym_augmented_assignment_expression] = STATE(2055),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(2055),
    [sym_update_expression] = STATE(2055),
    [sym_regex] = STATE(2055),
    [sym_meta_property] = STATE(2055),
    [sym_call_signature] = STATE(1162),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2055),
    [sym_non_null_expression] = STATE(2055),
    [sym_yield_expression] = STATE(2055),
    [sym_jsx_fragment] = STATE(2055),
    [sym_jsx_element] = STATE(2055),
    [sym_as_expression] = STATE(2055),
    [sym_internal_module] = STATE(2055),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2055),
    [sym_await_expression] = STATE(2055),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(2055),
    [sym_this] = STATE(2055),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(2055),
    [sym_generator_function] = STATE(2055),
    [sym_call_expression] = STATE(2055),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2055),
    [sym_ternary_expression] = STATE(2055),
    [sym_binary_expression] = STATE(2055),
    [sym_template_string] = STATE(2055),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2055),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2055),
    [sym_class] = STATE(2055),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4341),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4337),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_AMP_EQ] = ACTIONS(4337),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4337),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4331),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(4337),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_PIPE_EQ] = ACTIONS(4337),
    [anon_sym_DASH_EQ] = ACTIONS(4337),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_LBRACE_PIPE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(2417),
    [sym_true] = ACTIONS(4343),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_GT_GT_EQ] = ACTIONS(4337),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4337),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(2405),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(4343),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4337),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(4351),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_STAR_EQ] = ACTIONS(4337),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_EQ_GT] = ACTIONS(4339),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(4345),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4337),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4343),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1156] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_call_signature] = STATE(2057),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4353),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4337),
    [anon_sym_symbol] = ACTIONS(4355),
    [anon_sym_AMP_EQ] = ACTIONS(4337),
    [anon_sym_PLUS_EQ] = ACTIONS(4337),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4331),
    [anon_sym_void] = ACTIONS(4355),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(4337),
    [anon_sym_private] = ACTIONS(4355),
    [anon_sym_PIPE_EQ] = ACTIONS(4337),
    [anon_sym_DASH_EQ] = ACTIONS(4337),
    [anon_sym_get] = ACTIONS(4355),
    [anon_sym_LBRACE_PIPE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(4355),
    [anon_sym_GT_GT_EQ] = ACTIONS(4337),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(4355),
    [anon_sym_type] = ACTIONS(4355),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(4355),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4337),
    [anon_sym_namespace] = ACTIONS(4355),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(4355),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4337),
    [anon_sym_number] = ACTIONS(4355),
    [anon_sym_declare] = ACTIONS(4355),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(4355),
    [anon_sym_STAR_EQ] = ACTIONS(4337),
    [anon_sym_boolean] = ACTIONS(4355),
    [anon_sym_async] = ACTIONS(4355),
    [anon_sym_public] = ACTIONS(4355),
    [anon_sym_EQ_GT] = ACTIONS(4339),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4337),
    [anon_sym_string] = ACTIONS(4355),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(4355),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1157] = {
    [sym_new_expression] = STATE(2059),
    [sym_augmented_assignment_expression] = STATE(2059),
    [sym_unary_expression] = STATE(2059),
    [sym_update_expression] = STATE(2059),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(2059),
    [sym_regex] = STATE(2059),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2059),
    [sym_non_null_expression] = STATE(2059),
    [sym_as_expression] = STATE(2059),
    [sym_jsx_fragment] = STATE(2059),
    [sym_yield_expression] = STATE(2059),
    [sym_jsx_element] = STATE(2059),
    [sym_internal_module] = STATE(2059),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2059),
    [sym_await_expression] = STATE(2059),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(2059),
    [sym_this] = STATE(2059),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(2059),
    [sym_generator_function] = STATE(2059),
    [sym_call_expression] = STATE(2059),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2059),
    [sym_ternary_expression] = STATE(2059),
    [sym_binary_expression] = STATE(2059),
    [sym_template_string] = STATE(2059),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2059),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2059),
    [sym_class] = STATE(2059),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(4341),
    [sym_false] = ACTIONS(4357),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4357),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4359),
    [sym_true] = ACTIONS(4357),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4357),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [1158] = {
    [sym_new_expression] = STATE(2060),
    [sym_augmented_assignment_expression] = STATE(2060),
    [sym_unary_expression] = STATE(2060),
    [sym_update_expression] = STATE(2060),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(2060),
    [sym_regex] = STATE(2060),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2060),
    [sym_non_null_expression] = STATE(2060),
    [sym_as_expression] = STATE(2060),
    [sym_jsx_fragment] = STATE(2060),
    [sym_yield_expression] = STATE(2060),
    [sym_jsx_element] = STATE(2060),
    [sym_internal_module] = STATE(2060),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2060),
    [sym_await_expression] = STATE(2060),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(2060),
    [sym_this] = STATE(2060),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(2060),
    [sym_generator_function] = STATE(2060),
    [sym_call_expression] = STATE(2060),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2060),
    [sym_ternary_expression] = STATE(2060),
    [sym_binary_expression] = STATE(2060),
    [sym_template_string] = STATE(2060),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2060),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2060),
    [sym_class] = STATE(2060),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(4341),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_LBRACE_PIPE] = ACTIONS(211),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(2417),
    [sym_true] = ACTIONS(4361),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(2405),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(4361),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(4351),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4361),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(4363),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4361),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [1159] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(4365),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(4367),
    [anon_sym_symbol] = ACTIONS(4367),
    [anon_sym_number] = ACTIONS(4367),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4367),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4369),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4367),
    [anon_sym_private] = ACTIONS(4367),
    [anon_sym_boolean] = ACTIONS(4367),
    [anon_sym_async] = ACTIONS(4371),
    [anon_sym_public] = ACTIONS(4367),
    [anon_sym_get] = ACTIONS(4367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4367),
    [anon_sym_string] = ACTIONS(4367),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(4367),
    [anon_sym_type] = ACTIONS(4367),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(4367),
    [anon_sym_export] = ACTIONS(4367),
    [anon_sym_namespace] = ACTIONS(4373),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [1160] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(4337),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4337),
    [anon_sym_AMP_EQ] = ACTIONS(4337),
    [anon_sym_PLUS_EQ] = ACTIONS(4337),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4337),
    [anon_sym_STAR_EQ] = ACTIONS(4337),
    [anon_sym_PIPE_EQ] = ACTIONS(4337),
    [anon_sym_DASH_EQ] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4339),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4337),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4337),
    [anon_sym_GT_GT_EQ] = ACTIONS(4337),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4337),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1161] = {
    [sym_new_expression] = STATE(2066),
    [sym_augmented_assignment_expression] = STATE(2066),
    [sym_unary_expression] = STATE(2066),
    [sym_update_expression] = STATE(2066),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(2066),
    [sym_regex] = STATE(2066),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2066),
    [sym_non_null_expression] = STATE(2066),
    [sym_as_expression] = STATE(2066),
    [sym_jsx_fragment] = STATE(2066),
    [sym_yield_expression] = STATE(2066),
    [sym_jsx_element] = STATE(2066),
    [sym_internal_module] = STATE(2066),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2066),
    [sym_await_expression] = STATE(2066),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(2066),
    [sym_this] = STATE(2066),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(2066),
    [sym_generator_function] = STATE(2066),
    [sym_call_expression] = STATE(2066),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2066),
    [sym_ternary_expression] = STATE(2066),
    [sym_binary_expression] = STATE(2066),
    [sym_template_string] = STATE(2066),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2066),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2066),
    [sym_class] = STATE(2066),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(4341),
    [sym_false] = ACTIONS(4375),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4375),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4377),
    [sym_true] = ACTIONS(4375),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4375),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [1162] = {
    [anon_sym_EQ_GT] = ACTIONS(4333),
    [sym_comment] = ACTIONS(3),
  },
  [1163] = {
    [sym_template_string] = STATE(542),
    [aux_sym_extends_clause_repeat1] = STATE(2076),
    [sym_type_arguments] = STATE(541),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4379),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(4335),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4381),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_COMMA] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_LBRACE] = ACTIONS(4389),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4391),
    [anon_sym_STAR] = ACTIONS(4393),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4379),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(4379),
    [anon_sym_GT] = ACTIONS(4335),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2781),
    [anon_sym_AMP] = ACTIONS(4395),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_PIPE_PIPE] = ACTIONS(4399),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_instanceof] = ACTIONS(4379),
    [anon_sym_LT] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4399),
    [anon_sym_STAR_STAR] = ACTIONS(4405),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_GT_GT] = ACTIONS(4393),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4379),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [1164] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4327),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4327),
    [anon_sym_AMP_EQ] = ACTIONS(4327),
    [anon_sym_PLUS_EQ] = ACTIONS(4327),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4327),
    [anon_sym_STAR_EQ] = ACTIONS(4327),
    [anon_sym_PIPE_EQ] = ACTIONS(4327),
    [anon_sym_DASH_EQ] = ACTIONS(4327),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4327),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4327),
    [anon_sym_GT_GT_EQ] = ACTIONS(4327),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4327),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [1165] = {
    [sym__initializer] = STATE(587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4335),
  },
  [1166] = {
    [sym_type_arguments] = STATE(1117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2799),
    [anon_sym_LT] = ACTIONS(1505),
    [anon_sym_COMMA] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4407),
  },
  [1167] = {
    [sym__initializer] = STATE(589),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4335),
  },
  [1168] = {
    [aux_sym_extends_clause_repeat1] = STATE(2076),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2781),
    [anon_sym_COMMA] = ACTIONS(4385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4389),
  },
  [1169] = {
    [sym_identifier] = ACTIONS(4409),
    [anon_sym_BQUOTE] = ACTIONS(4411),
    [anon_sym_debugger] = ACTIONS(4409),
    [anon_sym_symbol] = ACTIONS(4409),
    [anon_sym_AT] = ACTIONS(4411),
    [anon_sym_DASH] = ACTIONS(4409),
    [anon_sym_void] = ACTIONS(4409),
    [anon_sym_break] = ACTIONS(4409),
    [anon_sym_const] = ACTIONS(4409),
    [sym_super] = ACTIONS(4409),
    [anon_sym_return] = ACTIONS(4409),
    [anon_sym_private] = ACTIONS(4409),
    [anon_sym_get] = ACTIONS(4409),
    [anon_sym_RBRACE] = ACTIONS(4411),
    [anon_sym_interface] = ACTIONS(4409),
    [anon_sym_default] = ACTIONS(4409),
    [anon_sym_enum] = ACTIONS(4409),
    [anon_sym_delete] = ACTIONS(4409),
    [anon_sym_continue] = ACTIONS(4409),
    [anon_sym_DASH_DASH] = ACTIONS(4411),
    [anon_sym_if] = ACTIONS(4409),
    [anon_sym_this] = ACTIONS(4409),
    [anon_sym_yield] = ACTIONS(4409),
    [sym_true] = ACTIONS(4409),
    [anon_sym_throw] = ACTIONS(4409),
    [anon_sym_protected] = ACTIONS(4409),
    [anon_sym_abstract] = ACTIONS(4409),
    [anon_sym_set] = ACTIONS(4409),
    [anon_sym_type] = ACTIONS(4409),
    [anon_sym_import] = ACTIONS(4409),
    [anon_sym_namespace] = ACTIONS(4409),
    [anon_sym_PLUS_PLUS] = ACTIONS(4411),
    [anon_sym_await] = ACTIONS(4409),
    [anon_sym_DQUOTE] = ACTIONS(4411),
    [anon_sym_else] = ACTIONS(4409),
    [anon_sym_BANG] = ACTIONS(4411),
    [anon_sym_for] = ACTIONS(4409),
    [anon_sym_LBRACK] = ACTIONS(4411),
    [sym_false] = ACTIONS(4409),
    [anon_sym_SEMI] = ACTIONS(4411),
    [anon_sym_case] = ACTIONS(4409),
    [anon_sym_module] = ACTIONS(4409),
    [anon_sym_number] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(4409),
    [anon_sym_declare] = ACTIONS(4409),
    [anon_sym_typeof] = ACTIONS(4409),
    [anon_sym_LBRACE] = ACTIONS(4411),
    [anon_sym_switch] = ACTIONS(4409),
    [anon_sym_LPAREN] = ACTIONS(4411),
    [sym_null] = ACTIONS(4409),
    [anon_sym_any] = ACTIONS(4409),
    [anon_sym_boolean] = ACTIONS(4409),
    [anon_sym_async] = ACTIONS(4409),
    [anon_sym_public] = ACTIONS(4409),
    [anon_sym_var] = ACTIONS(4409),
    [anon_sym_while] = ACTIONS(4409),
    [anon_sym_SQUOTE] = ACTIONS(4411),
    [anon_sym_try] = ACTIONS(4409),
    [anon_sym_LT] = ACTIONS(4411),
    [sym_number] = ACTIONS(4411),
    [anon_sym_SLASH] = ACTIONS(4409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4409),
    [anon_sym_function] = ACTIONS(4409),
    [sym_undefined] = ACTIONS(4409),
    [anon_sym_new] = ACTIONS(4409),
    [ts_builtin_sym_end] = ACTIONS(4411),
    [anon_sym_let] = ACTIONS(4409),
    [anon_sym_PLUS] = ACTIONS(4409),
    [anon_sym_export] = ACTIONS(4409),
    [anon_sym_do] = ACTIONS(4409),
    [anon_sym_TILDE] = ACTIONS(4411),
    [anon_sym_with] = ACTIONS(4409),
  },
  [1170] = {
    [sym_object_type] = STATE(2077),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(777),
  },
  [1171] = {
    [sym_identifier] = ACTIONS(4413),
    [anon_sym_BQUOTE] = ACTIONS(4415),
    [anon_sym_debugger] = ACTIONS(4413),
    [anon_sym_symbol] = ACTIONS(4413),
    [anon_sym_AT] = ACTIONS(4415),
    [anon_sym_DASH] = ACTIONS(4413),
    [anon_sym_void] = ACTIONS(4413),
    [anon_sym_break] = ACTIONS(4413),
    [anon_sym_const] = ACTIONS(4413),
    [sym_super] = ACTIONS(4413),
    [anon_sym_return] = ACTIONS(4413),
    [anon_sym_private] = ACTIONS(4413),
    [anon_sym_get] = ACTIONS(4413),
    [anon_sym_RBRACE] = ACTIONS(4415),
    [anon_sym_interface] = ACTIONS(4413),
    [anon_sym_default] = ACTIONS(4413),
    [anon_sym_enum] = ACTIONS(4413),
    [anon_sym_delete] = ACTIONS(4413),
    [anon_sym_continue] = ACTIONS(4413),
    [anon_sym_DASH_DASH] = ACTIONS(4415),
    [anon_sym_if] = ACTIONS(4413),
    [anon_sym_this] = ACTIONS(4413),
    [anon_sym_yield] = ACTIONS(4413),
    [sym_true] = ACTIONS(4413),
    [anon_sym_throw] = ACTIONS(4413),
    [anon_sym_protected] = ACTIONS(4413),
    [anon_sym_abstract] = ACTIONS(4413),
    [anon_sym_set] = ACTIONS(4413),
    [anon_sym_type] = ACTIONS(4413),
    [anon_sym_import] = ACTIONS(4413),
    [anon_sym_namespace] = ACTIONS(4413),
    [anon_sym_PLUS_PLUS] = ACTIONS(4415),
    [anon_sym_await] = ACTIONS(4413),
    [anon_sym_DQUOTE] = ACTIONS(4415),
    [anon_sym_else] = ACTIONS(4413),
    [anon_sym_BANG] = ACTIONS(4415),
    [anon_sym_for] = ACTIONS(4413),
    [anon_sym_LBRACK] = ACTIONS(4415),
    [sym_false] = ACTIONS(4413),
    [anon_sym_SEMI] = ACTIONS(4415),
    [anon_sym_case] = ACTIONS(4413),
    [anon_sym_module] = ACTIONS(4413),
    [anon_sym_number] = ACTIONS(4413),
    [anon_sym_class] = ACTIONS(4413),
    [anon_sym_declare] = ACTIONS(4413),
    [anon_sym_typeof] = ACTIONS(4413),
    [anon_sym_LBRACE] = ACTIONS(4415),
    [anon_sym_switch] = ACTIONS(4413),
    [anon_sym_LPAREN] = ACTIONS(4415),
    [sym_null] = ACTIONS(4413),
    [anon_sym_any] = ACTIONS(4413),
    [anon_sym_boolean] = ACTIONS(4413),
    [anon_sym_async] = ACTIONS(4413),
    [anon_sym_public] = ACTIONS(4413),
    [anon_sym_var] = ACTIONS(4413),
    [anon_sym_while] = ACTIONS(4413),
    [anon_sym_SQUOTE] = ACTIONS(4415),
    [anon_sym_try] = ACTIONS(4413),
    [anon_sym_LT] = ACTIONS(4415),
    [sym_number] = ACTIONS(4415),
    [anon_sym_SLASH] = ACTIONS(4413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4413),
    [anon_sym_function] = ACTIONS(4413),
    [sym_undefined] = ACTIONS(4413),
    [anon_sym_new] = ACTIONS(4413),
    [ts_builtin_sym_end] = ACTIONS(4415),
    [anon_sym_let] = ACTIONS(4413),
    [anon_sym_PLUS] = ACTIONS(4413),
    [anon_sym_export] = ACTIONS(4413),
    [anon_sym_do] = ACTIONS(4413),
    [anon_sym_TILDE] = ACTIONS(4415),
    [anon_sym_with] = ACTIONS(4413),
  },
  [1172] = {
    [sym__initializer] = STATE(2078),
    [anon_sym_EQ] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(4417),
    [anon_sym_COMMA] = ACTIONS(4417),
    [sym_comment] = ACTIONS(3),
  },
  [1173] = {
    [aux_sym_enum_body_repeat1] = STATE(2081),
    [anon_sym_COMMA] = ACTIONS(4419),
    [anon_sym_RBRACE] = ACTIONS(4421),
    [sym_comment] = ACTIONS(3),
  },
  [1174] = {
    [sym_identifier] = ACTIONS(3218),
    [anon_sym_BQUOTE] = ACTIONS(3216),
    [anon_sym_debugger] = ACTIONS(3218),
    [anon_sym_symbol] = ACTIONS(3218),
    [anon_sym_AT] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3218),
    [anon_sym_void] = ACTIONS(3218),
    [anon_sym_break] = ACTIONS(3218),
    [anon_sym_const] = ACTIONS(3218),
    [sym_super] = ACTIONS(3218),
    [anon_sym_return] = ACTIONS(3218),
    [anon_sym_private] = ACTIONS(3218),
    [anon_sym_get] = ACTIONS(3218),
    [anon_sym_interface] = ACTIONS(3218),
    [anon_sym_enum] = ACTIONS(3218),
    [anon_sym_delete] = ACTIONS(3218),
    [anon_sym_continue] = ACTIONS(3218),
    [anon_sym_DASH_DASH] = ACTIONS(3216),
    [anon_sym_if] = ACTIONS(3218),
    [anon_sym_this] = ACTIONS(3218),
    [anon_sym_yield] = ACTIONS(3218),
    [sym_true] = ACTIONS(3218),
    [anon_sym_throw] = ACTIONS(3218),
    [anon_sym_protected] = ACTIONS(3218),
    [anon_sym_abstract] = ACTIONS(3218),
    [anon_sym_set] = ACTIONS(3218),
    [anon_sym_type] = ACTIONS(3218),
    [anon_sym_import] = ACTIONS(3218),
    [anon_sym_namespace] = ACTIONS(3218),
    [anon_sym_PLUS_PLUS] = ACTIONS(3216),
    [anon_sym_await] = ACTIONS(3218),
    [anon_sym_DQUOTE] = ACTIONS(3216),
    [anon_sym_BANG] = ACTIONS(3216),
    [anon_sym_for] = ACTIONS(3218),
    [anon_sym_LBRACK] = ACTIONS(3216),
    [sym_false] = ACTIONS(3218),
    [anon_sym_SEMI] = ACTIONS(3216),
    [anon_sym_module] = ACTIONS(3218),
    [anon_sym_number] = ACTIONS(3218),
    [anon_sym_class] = ACTIONS(3218),
    [anon_sym_declare] = ACTIONS(3218),
    [anon_sym_typeof] = ACTIONS(3218),
    [anon_sym_LBRACE] = ACTIONS(3216),
    [anon_sym_switch] = ACTIONS(3218),
    [anon_sym_LPAREN] = ACTIONS(3216),
    [sym_null] = ACTIONS(3218),
    [anon_sym_any] = ACTIONS(3218),
    [anon_sym_boolean] = ACTIONS(3218),
    [anon_sym_async] = ACTIONS(3218),
    [anon_sym_public] = ACTIONS(3218),
    [anon_sym_var] = ACTIONS(3218),
    [anon_sym_while] = ACTIONS(3218),
    [anon_sym_SQUOTE] = ACTIONS(3216),
    [anon_sym_try] = ACTIONS(3218),
    [anon_sym_LT] = ACTIONS(3216),
    [sym_number] = ACTIONS(3216),
    [anon_sym_SLASH] = ACTIONS(3218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3218),
    [anon_sym_function] = ACTIONS(3218),
    [sym_undefined] = ACTIONS(3218),
    [anon_sym_new] = ACTIONS(3218),
    [anon_sym_let] = ACTIONS(3218),
    [anon_sym_PLUS] = ACTIONS(3218),
    [anon_sym_export] = ACTIONS(3218),
    [anon_sym_do] = ACTIONS(3218),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_with] = ACTIONS(3218),
  },
  [1175] = {
    [anon_sym_RPAREN] = ACTIONS(4423),
    [sym_comment] = ACTIONS(3),
  },
  [1176] = {
    [sym_type_alias_declaration] = STATE(348),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(348),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(348),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(348),
    [sym_return_statement] = STATE(348),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(348),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(348),
    [sym_switch_statement] = STATE(348),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(348),
    [sym_throw_statement] = STATE(348),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(348),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(348),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(348),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(348),
    [sym_abstract_class] = STATE(348),
    [sym_interface_declaration] = STATE(348),
    [sym_statement_block] = STATE(348),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(348),
    [sym_debugger_statement] = STATE(348),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(348),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(348),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(348),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(348),
    [sym_empty_statement] = STATE(348),
    [sym_import_alias] = STATE(348),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(348),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(348),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(348),
    [sym_break_statement] = STATE(348),
    [sym_labeled_statement] = STATE(348),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(348),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [1177] = {
    [sym_type_alias_declaration] = STATE(2083),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(2083),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(2083),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(2083),
    [sym_return_statement] = STATE(2083),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(2083),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2083),
    [sym_switch_statement] = STATE(2083),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(2083),
    [sym_throw_statement] = STATE(2083),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(2083),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(2083),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(2083),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(2083),
    [sym_abstract_class] = STATE(2083),
    [sym_interface_declaration] = STATE(2083),
    [sym_statement_block] = STATE(2083),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(2083),
    [sym_debugger_statement] = STATE(2083),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(2083),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(2083),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(2083),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(2083),
    [sym_empty_statement] = STATE(2083),
    [sym_import_alias] = STATE(2083),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(2083),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(2083),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(2083),
    [sym_break_statement] = STATE(2083),
    [sym_labeled_statement] = STATE(2083),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(2083),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [1178] = {
    [anon_sym_LPAREN] = ACTIONS(4425),
    [sym_comment] = ACTIONS(3),
  },
  [1179] = {
    [sym_new_expression] = STATE(59),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_yield_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_internal_module] = STATE(59),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(59),
    [sym_await_expression] = STATE(59),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2088),
    [sym_variable_declaration] = STATE(2088),
    [sym_sequence_expression] = STATE(62),
    [sym_string] = STATE(59),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(2088),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2089),
    [sym_anonymous_class] = STATE(59),
    [sym_generator_function] = STATE(59),
    [sym_call_expression] = STATE(59),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(59),
    [sym_ternary_expression] = STATE(59),
    [sym_binary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_lexical_declaration] = STATE(2088),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(2090),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_identifier] = ACTIONS(4427),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(4429),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(4431),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(4429),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(15),
  },
  [1180] = {
    [sym_string] = STATE(173),
    [sym_nested_identifier] = STATE(169),
    [sym__module] = STATE(172),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(4433),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(312),
  },
  [1181] = {
    [sym_type_alias_declaration] = STATE(193),
    [aux_sym_export_statement_repeat1] = STATE(1183),
    [sym__declaration] = STATE(193),
    [sym_ambient_declaration] = STATE(193),
    [sym_import_alias] = STATE(193),
    [sym_export_statement] = STATE(193),
    [sym_generator_function] = STATE(193),
    [sym_lexical_declaration] = STATE(193),
    [sym_internal_module] = STATE(193),
    [sym_decorator] = STATE(1183),
    [sym_enum_declaration] = STATE(193),
    [sym_function] = STATE(193),
    [sym_function_signature] = STATE(193),
    [sym_variable_declaration] = STATE(193),
    [sym_abstract_class] = STATE(193),
    [sym_module] = STATE(193),
    [sym_interface_declaration] = STATE(193),
    [sym_class] = STATE(193),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(2449),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2451),
    [anon_sym_global] = ACTIONS(324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(346),
  },
  [1182] = {
    [sym_type_alias_declaration] = STATE(300),
    [aux_sym_export_statement_repeat1] = STATE(1183),
    [sym__declaration] = STATE(300),
    [sym_ambient_declaration] = STATE(300),
    [sym_import_alias] = STATE(300),
    [sym_export_statement] = STATE(300),
    [sym_generator_function] = STATE(300),
    [sym_export_clause] = STATE(301),
    [sym_lexical_declaration] = STATE(300),
    [sym_internal_module] = STATE(300),
    [sym_decorator] = STATE(1183),
    [sym_enum_declaration] = STATE(300),
    [sym_function] = STATE(300),
    [sym_function_signature] = STATE(300),
    [sym_variable_declaration] = STATE(300),
    [sym_abstract_class] = STATE(300),
    [sym_module] = STATE(300),
    [sym_interface_declaration] = STATE(300),
    [sym_class] = STATE(300),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_as] = ACTIONS(1183),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2451),
    [anon_sym_STAR] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_EQ] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(346),
  },
  [1183] = {
    [aux_sym_export_statement_repeat1] = STATE(320),
    [sym_decorator] = STATE(320),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(2461),
    [anon_sym_class] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
  },
  [1184] = {
    [sym_type_alias_declaration] = STATE(787),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(787),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(787),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(787),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(787),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(787),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(787),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(787),
    [sym_abstract_class] = STATE(787),
    [sym_interface_declaration] = STATE(787),
    [sym_statement_block] = STATE(787),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(787),
    [sym_debugger_statement] = STATE(787),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(787),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(787),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(787),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(787),
    [sym_empty_statement] = STATE(787),
    [sym_import_alias] = STATE(787),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(787),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(787),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_labeled_statement] = STATE(787),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(787),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [1185] = {
    [sym_type_alias_declaration] = STATE(891),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(891),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(891),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(891),
    [sym_return_statement] = STATE(891),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(891),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(891),
    [sym_switch_statement] = STATE(891),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(891),
    [sym_throw_statement] = STATE(891),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(891),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(891),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(891),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(891),
    [sym_abstract_class] = STATE(891),
    [sym_interface_declaration] = STATE(891),
    [sym_statement_block] = STATE(891),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(891),
    [sym_debugger_statement] = STATE(891),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(891),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(891),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(891),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(891),
    [sym_empty_statement] = STATE(891),
    [sym_import_alias] = STATE(891),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(891),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(891),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(891),
    [sym_break_statement] = STATE(891),
    [sym_labeled_statement] = STATE(891),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(891),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [1186] = {
    [sym_type_alias_declaration] = STATE(2092),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(2092),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(2092),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(2092),
    [sym_return_statement] = STATE(2092),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(2092),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2092),
    [sym_switch_statement] = STATE(2092),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(2092),
    [sym_throw_statement] = STATE(2092),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(2092),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(2092),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(2092),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(2092),
    [sym_abstract_class] = STATE(2092),
    [sym_interface_declaration] = STATE(2092),
    [sym_statement_block] = STATE(2092),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(2092),
    [sym_debugger_statement] = STATE(2092),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(2092),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(2092),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(2092),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(2092),
    [sym_empty_statement] = STATE(2092),
    [sym_import_alias] = STATE(2092),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(2092),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(2092),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(2092),
    [sym_break_statement] = STATE(2092),
    [sym_labeled_statement] = STATE(2092),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(2092),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1187] = {
    [sym_type_alias_declaration] = STATE(872),
    [aux_sym_export_statement_repeat1] = STATE(1183),
    [sym__declaration] = STATE(872),
    [sym_ambient_declaration] = STATE(872),
    [sym_import_alias] = STATE(872),
    [sym_export_statement] = STATE(872),
    [sym_generator_function] = STATE(872),
    [sym_lexical_declaration] = STATE(872),
    [sym_internal_module] = STATE(872),
    [sym_decorator] = STATE(1183),
    [sym_enum_declaration] = STATE(872),
    [sym_function] = STATE(872),
    [sym_function_signature] = STATE(872),
    [sym_variable_declaration] = STATE(872),
    [sym_abstract_class] = STATE(872),
    [sym_module] = STATE(872),
    [sym_interface_declaration] = STATE(872),
    [sym_class] = STATE(872),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_default] = ACTIONS(1826),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(346),
  },
  [1188] = {
    [sym_public_field_definition] = STATE(640),
    [sym__property_name] = STATE(641),
    [sym_decorator] = STATE(2094),
    [sym_method_signature] = STATE(640),
    [sym_accessibility_modifier] = STATE(642),
    [sym_abstract_method_signature] = STATE(640),
    [sym_computed_property_name] = STATE(641),
    [aux_sym_class_body_repeat1] = STATE(2094),
    [sym_index_signature] = STATE(640),
    [sym_string] = STATE(641),
    [sym_method_definition] = STATE(644),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1145),
    [anon_sym_get] = ACTIONS(1147),
    [anon_sym_RBRACE] = ACTIONS(4435),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [sym_number] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [1189] = {
    [sym_class_body] = STATE(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2467),
  },
  [1190] = {
    [sym_class_heritage] = STATE(2096),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(2095),
    [anon_sym_extends] = ACTIONS(1131),
    [anon_sym_implements] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2467),
  },
  [1191] = {
    [sym_identifier] = ACTIONS(4437),
    [anon_sym_BQUOTE] = ACTIONS(4439),
    [anon_sym_debugger] = ACTIONS(4437),
    [anon_sym_symbol] = ACTIONS(4437),
    [anon_sym_AT] = ACTIONS(4439),
    [anon_sym_DASH] = ACTIONS(4437),
    [anon_sym_void] = ACTIONS(4437),
    [anon_sym_break] = ACTIONS(4437),
    [anon_sym_const] = ACTIONS(4437),
    [sym_super] = ACTIONS(4437),
    [anon_sym_return] = ACTIONS(4437),
    [anon_sym_private] = ACTIONS(4437),
    [anon_sym_get] = ACTIONS(4437),
    [anon_sym_RBRACE] = ACTIONS(4439),
    [anon_sym_interface] = ACTIONS(4437),
    [anon_sym_default] = ACTIONS(4437),
    [anon_sym_enum] = ACTIONS(4437),
    [anon_sym_delete] = ACTIONS(4437),
    [anon_sym_continue] = ACTIONS(4437),
    [anon_sym_DASH_DASH] = ACTIONS(4439),
    [anon_sym_if] = ACTIONS(4437),
    [anon_sym_this] = ACTIONS(4437),
    [anon_sym_yield] = ACTIONS(4437),
    [sym_true] = ACTIONS(4437),
    [anon_sym_throw] = ACTIONS(4437),
    [anon_sym_protected] = ACTIONS(4437),
    [anon_sym_abstract] = ACTIONS(4437),
    [anon_sym_set] = ACTIONS(4437),
    [anon_sym_type] = ACTIONS(4437),
    [anon_sym_import] = ACTIONS(4437),
    [anon_sym_namespace] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4439),
    [anon_sym_await] = ACTIONS(4437),
    [anon_sym_DQUOTE] = ACTIONS(4439),
    [anon_sym_else] = ACTIONS(4437),
    [anon_sym_BANG] = ACTIONS(4439),
    [anon_sym_for] = ACTIONS(4437),
    [anon_sym_LBRACK] = ACTIONS(4439),
    [sym_false] = ACTIONS(4437),
    [anon_sym_SEMI] = ACTIONS(4439),
    [anon_sym_case] = ACTIONS(4437),
    [anon_sym_module] = ACTIONS(4437),
    [anon_sym_number] = ACTIONS(4437),
    [anon_sym_class] = ACTIONS(4437),
    [anon_sym_declare] = ACTIONS(4437),
    [anon_sym_typeof] = ACTIONS(4437),
    [anon_sym_LBRACE] = ACTIONS(4439),
    [anon_sym_switch] = ACTIONS(4437),
    [anon_sym_LPAREN] = ACTIONS(4439),
    [sym_null] = ACTIONS(4437),
    [anon_sym_any] = ACTIONS(4437),
    [anon_sym_boolean] = ACTIONS(4437),
    [anon_sym_async] = ACTIONS(4437),
    [anon_sym_public] = ACTIONS(4437),
    [anon_sym_var] = ACTIONS(4437),
    [anon_sym_while] = ACTIONS(4437),
    [anon_sym_SQUOTE] = ACTIONS(4439),
    [anon_sym_try] = ACTIONS(4437),
    [anon_sym_LT] = ACTIONS(4439),
    [sym_number] = ACTIONS(4439),
    [anon_sym_SLASH] = ACTIONS(4437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4437),
    [anon_sym_function] = ACTIONS(4437),
    [sym_undefined] = ACTIONS(4437),
    [anon_sym_new] = ACTIONS(4437),
    [ts_builtin_sym_end] = ACTIONS(4439),
    [anon_sym_let] = ACTIONS(4437),
    [anon_sym_PLUS] = ACTIONS(4437),
    [anon_sym_export] = ACTIONS(4437),
    [anon_sym_do] = ACTIONS(4437),
    [anon_sym_TILDE] = ACTIONS(4439),
    [anon_sym_with] = ACTIONS(4437),
  },
  [1192] = {
    [sym_type_arguments] = STATE(1885),
    [sym__automatic_semicolon] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(3983),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(3985),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(4441),
  },
  [1193] = {
    [sym_index_type_query] = STATE(1887),
    [sym_lookup_type] = STATE(1887),
    [sym_flow_maybe_type] = STATE(1887),
    [sym_parenthesized_type] = STATE(1887),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_array_type] = STATE(1887),
    [sym_type_predicate] = STATE(1887),
    [sym_type_query] = STATE(1887),
    [sym_existential_type] = STATE(1887),
    [sym_this_type] = STATE(1887),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1887),
    [sym__primary_type] = STATE(1887),
    [sym_generic_type] = STATE(1887),
    [sym_literal_type] = STATE(1887),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1887),
    [sym_string] = STATE(1017),
    [sym_tuple_type] = STATE(1887),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [sym_true] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_LPAREN] = ACTIONS(3989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [1194] = {
    [sym_union_type] = STATE(1892),
    [sym__type] = STATE(1892),
    [sym_constructor_type] = STATE(1892),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1198),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1892),
    [sym_function_type] = STATE(1892),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1199),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2475),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [1195] = {
    [sym_type_parameters] = STATE(2098),
    [sym_formal_parameters] = STATE(2099),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1196] = {
    [sym_union_type] = STATE(1900),
    [sym__type] = STATE(1900),
    [sym_constructor_type] = STATE(1900),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1198),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1900),
    [sym_function_type] = STATE(1900),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1199),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2475),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [1197] = {
    [sym__automatic_semicolon] = ACTIONS(4443),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_PIPE] = ACTIONS(4447),
    [anon_sym_SEMI] = ACTIONS(4443),
    [sym_comment] = ACTIONS(3),
  },
  [1198] = {
    [sym_formal_parameters] = STATE(2103),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1199] = {
    [anon_sym_EQ_GT] = ACTIONS(4449),
    [sym_comment] = ACTIONS(3),
  },
  [1200] = {
    [sym_union_type] = STATE(2105),
    [sym__type] = STATE(2105),
    [sym_constructor_type] = STATE(2105),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1198),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2105),
    [sym_function_type] = STATE(2105),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1199),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2475),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [1201] = {
    [anon_sym_from] = ACTIONS(4451),
    [sym_comment] = ACTIONS(3),
  },
  [1202] = {
    [anon_sym_LPAREN] = ACTIONS(4453),
    [sym_comment] = ACTIONS(3),
  },
  [1203] = {
    [sym__automatic_semicolon] = ACTIONS(4455),
    [anon_sym_SEMI] = ACTIONS(4455),
    [anon_sym_DOT] = ACTIONS(4457),
    [sym_comment] = ACTIONS(3),
  },
  [1204] = {
    [anon_sym_require] = ACTIONS(4459),
    [sym_comment] = ACTIONS(3),
  },
  [1205] = {
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_BQUOTE] = ACTIONS(4463),
    [anon_sym_debugger] = ACTIONS(4461),
    [anon_sym_symbol] = ACTIONS(4461),
    [anon_sym_AT] = ACTIONS(4463),
    [anon_sym_DASH] = ACTIONS(4461),
    [anon_sym_void] = ACTIONS(4461),
    [anon_sym_break] = ACTIONS(4461),
    [anon_sym_const] = ACTIONS(4461),
    [sym_super] = ACTIONS(4461),
    [anon_sym_return] = ACTIONS(4461),
    [anon_sym_private] = ACTIONS(4461),
    [anon_sym_get] = ACTIONS(4461),
    [anon_sym_RBRACE] = ACTIONS(4463),
    [anon_sym_interface] = ACTIONS(4461),
    [anon_sym_default] = ACTIONS(4461),
    [anon_sym_enum] = ACTIONS(4461),
    [anon_sym_delete] = ACTIONS(4461),
    [anon_sym_continue] = ACTIONS(4461),
    [anon_sym_DASH_DASH] = ACTIONS(4463),
    [anon_sym_if] = ACTIONS(4461),
    [anon_sym_this] = ACTIONS(4461),
    [anon_sym_yield] = ACTIONS(4461),
    [sym_true] = ACTIONS(4461),
    [anon_sym_throw] = ACTIONS(4461),
    [anon_sym_protected] = ACTIONS(4461),
    [anon_sym_abstract] = ACTIONS(4461),
    [anon_sym_set] = ACTIONS(4461),
    [anon_sym_type] = ACTIONS(4461),
    [anon_sym_import] = ACTIONS(4461),
    [anon_sym_namespace] = ACTIONS(4461),
    [anon_sym_PLUS_PLUS] = ACTIONS(4463),
    [anon_sym_await] = ACTIONS(4461),
    [anon_sym_DQUOTE] = ACTIONS(4463),
    [anon_sym_else] = ACTIONS(4461),
    [anon_sym_BANG] = ACTIONS(4463),
    [anon_sym_for] = ACTIONS(4461),
    [anon_sym_LBRACK] = ACTIONS(4463),
    [sym_false] = ACTIONS(4461),
    [anon_sym_SEMI] = ACTIONS(4463),
    [anon_sym_case] = ACTIONS(4461),
    [anon_sym_module] = ACTIONS(4461),
    [anon_sym_number] = ACTIONS(4461),
    [anon_sym_class] = ACTIONS(4461),
    [anon_sym_declare] = ACTIONS(4461),
    [anon_sym_typeof] = ACTIONS(4461),
    [anon_sym_LBRACE] = ACTIONS(4463),
    [anon_sym_switch] = ACTIONS(4461),
    [anon_sym_LPAREN] = ACTIONS(4463),
    [sym_null] = ACTIONS(4461),
    [anon_sym_any] = ACTIONS(4461),
    [anon_sym_boolean] = ACTIONS(4461),
    [anon_sym_async] = ACTIONS(4461),
    [anon_sym_public] = ACTIONS(4461),
    [anon_sym_var] = ACTIONS(4461),
    [anon_sym_while] = ACTIONS(4461),
    [anon_sym_SQUOTE] = ACTIONS(4463),
    [anon_sym_try] = ACTIONS(4461),
    [anon_sym_LT] = ACTIONS(4463),
    [sym_number] = ACTIONS(4463),
    [anon_sym_SLASH] = ACTIONS(4461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4461),
    [anon_sym_function] = ACTIONS(4461),
    [sym_undefined] = ACTIONS(4461),
    [anon_sym_new] = ACTIONS(4461),
    [ts_builtin_sym_end] = ACTIONS(4463),
    [anon_sym_let] = ACTIONS(4461),
    [anon_sym_PLUS] = ACTIONS(4461),
    [anon_sym_export] = ACTIONS(4461),
    [anon_sym_do] = ACTIONS(4461),
    [anon_sym_TILDE] = ACTIONS(4463),
    [anon_sym_with] = ACTIONS(4461),
  },
  [1206] = {
    [sym__automatic_semicolon] = ACTIONS(4465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4465),
  },
  [1207] = {
    [anon_sym_from] = ACTIONS(4467),
    [sym_comment] = ACTIONS(3),
  },
  [1208] = {
    [sym_identifier] = ACTIONS(4469),
    [sym_comment] = ACTIONS(3),
  },
  [1209] = {
    [anon_sym_RBRACE] = ACTIONS(4471),
    [anon_sym_COMMA] = ACTIONS(4471),
    [anon_sym_as] = ACTIONS(4473),
    [sym_comment] = ACTIONS(3),
  },
  [1210] = {
    [anon_sym_from] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
  },
  [1211] = {
    [sym__import_export_specifier] = STATE(2112),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(4477),
    [anon_sym_typeof] = ACTIONS(895),
    [anon_sym_type] = ACTIONS(895),
    [sym_comment] = ACTIONS(3),
  },
  [1212] = {
    [anon_sym_from] = ACTIONS(4479),
    [sym_comment] = ACTIONS(3),
  },
  [1213] = {
    [aux_sym_named_imports_repeat1] = STATE(2114),
    [anon_sym_COMMA] = ACTIONS(4481),
    [anon_sym_RBRACE] = ACTIONS(4477),
    [sym_comment] = ACTIONS(3),
  },
  [1214] = {
    [sym__automatic_semicolon] = ACTIONS(4483),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4483),
  },
  [1215] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4485),
    [sym_identifier] = ACTIONS(4487),
    [sym__automatic_semicolon] = ACTIONS(4485),
    [anon_sym_BQUOTE] = ACTIONS(4485),
    [anon_sym_debugger] = ACTIONS(4487),
    [ts_builtin_sym_end] = ACTIONS(4485),
    [anon_sym_symbol] = ACTIONS(4487),
    [anon_sym_AT] = ACTIONS(4485),
    [anon_sym_PIPE] = ACTIONS(4487),
    [anon_sym_COMMA] = ACTIONS(4485),
    [anon_sym_DASH] = ACTIONS(4487),
    [anon_sym_STAR] = ACTIONS(4487),
    [anon_sym_GT_GT_GT] = ACTIONS(4485),
    [anon_sym_void] = ACTIONS(4487),
    [anon_sym_break] = ACTIONS(4487),
    [anon_sym_BANG_EQ] = ACTIONS(4487),
    [anon_sym_const] = ACTIONS(4487),
    [anon_sym_GT_EQ] = ACTIONS(4485),
    [sym_super] = ACTIONS(4487),
    [anon_sym_return] = ACTIONS(4487),
    [anon_sym_private] = ACTIONS(4487),
    [anon_sym_get] = ACTIONS(4487),
    [anon_sym_RBRACE] = ACTIONS(4485),
    [anon_sym_PERCENT] = ACTIONS(4485),
    [anon_sym_interface] = ACTIONS(4487),
    [anon_sym_default] = ACTIONS(4487),
    [anon_sym_as] = ACTIONS(4487),
    [anon_sym_delete] = ACTIONS(4487),
    [anon_sym_continue] = ACTIONS(4487),
    [anon_sym_DASH_DASH] = ACTIONS(4485),
    [anon_sym_if] = ACTIONS(4487),
    [anon_sym_instanceof] = ACTIONS(4487),
    [anon_sym_this] = ACTIONS(4487),
    [anon_sym_yield] = ACTIONS(4487),
    [sym_true] = ACTIONS(4487),
    [anon_sym_throw] = ACTIONS(4487),
    [anon_sym_enum] = ACTIONS(4487),
    [anon_sym_protected] = ACTIONS(4487),
    [anon_sym_abstract] = ACTIONS(4487),
    [anon_sym_DOT] = ACTIONS(4487),
    [anon_sym_set] = ACTIONS(4487),
    [anon_sym_type] = ACTIONS(4487),
    [anon_sym_STAR_STAR] = ACTIONS(4485),
    [anon_sym_import] = ACTIONS(4487),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4485),
    [anon_sym_namespace] = ACTIONS(4487),
    [anon_sym_PLUS_PLUS] = ACTIONS(4485),
    [anon_sym_await] = ACTIONS(4487),
    [anon_sym_DQUOTE] = ACTIONS(4485),
    [anon_sym_else] = ACTIONS(4487),
    [anon_sym_BANG] = ACTIONS(4487),
    [anon_sym_for] = ACTIONS(4487),
    [anon_sym_LBRACK] = ACTIONS(4485),
    [sym_false] = ACTIONS(4487),
    [anon_sym_SEMI] = ACTIONS(4485),
    [anon_sym_case] = ACTIONS(4487),
    [anon_sym_module] = ACTIONS(4487),
    [anon_sym_number] = ACTIONS(4487),
    [anon_sym_class] = ACTIONS(4487),
    [anon_sym_declare] = ACTIONS(4487),
    [anon_sym_typeof] = ACTIONS(4487),
    [anon_sym_LT_LT] = ACTIONS(4485),
    [anon_sym_LBRACE] = ACTIONS(4485),
    [anon_sym_AMP_AMP] = ACTIONS(4485),
    [anon_sym_switch] = ACTIONS(4487),
    [anon_sym_LT_EQ] = ACTIONS(4485),
    [anon_sym_LPAREN] = ACTIONS(4485),
    [sym_null] = ACTIONS(4487),
    [anon_sym_GT] = ACTIONS(4487),
    [anon_sym_any] = ACTIONS(4487),
    [anon_sym_boolean] = ACTIONS(4487),
    [anon_sym_async] = ACTIONS(4487),
    [anon_sym_public] = ACTIONS(4487),
    [anon_sym_AMP] = ACTIONS(4487),
    [anon_sym_var] = ACTIONS(4487),
    [anon_sym_QMARK] = ACTIONS(4485),
    [anon_sym_PIPE_PIPE] = ACTIONS(4485),
    [anon_sym_while] = ACTIONS(4487),
    [anon_sym_SQUOTE] = ACTIONS(4485),
    [anon_sym_try] = ACTIONS(4487),
    [anon_sym_EQ_EQ] = ACTIONS(4487),
    [anon_sym_RPAREN] = ACTIONS(4485),
    [anon_sym_LT] = ACTIONS(4487),
    [sym_number] = ACTIONS(4485),
    [anon_sym_SLASH] = ACTIONS(4487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4487),
    [anon_sym_function] = ACTIONS(4487),
    [sym_undefined] = ACTIONS(4487),
    [anon_sym_new] = ACTIONS(4487),
    [anon_sym_CARET] = ACTIONS(4485),
    [anon_sym_let] = ACTIONS(4487),
    [anon_sym_PLUS] = ACTIONS(4487),
    [anon_sym_export] = ACTIONS(4487),
    [anon_sym_GT_GT] = ACTIONS(4487),
    [anon_sym_do] = ACTIONS(4487),
    [anon_sym_TILDE] = ACTIONS(4485),
    [anon_sym_with] = ACTIONS(4487),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4485),
    [anon_sym_in] = ACTIONS(4487),
  },
  [1216] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1255),
    [sym_identifier] = ACTIONS(1253),
    [sym__automatic_semicolon] = ACTIONS(1255),
    [anon_sym_BQUOTE] = ACTIONS(1255),
    [anon_sym_debugger] = ACTIONS(1253),
    [ts_builtin_sym_end] = ACTIONS(1255),
    [anon_sym_symbol] = ACTIONS(1253),
    [anon_sym_AT] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1253),
    [anon_sym_COMMA] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(1253),
    [anon_sym_GT_GT_GT] = ACTIONS(1255),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_break] = ACTIONS(1253),
    [anon_sym_BANG_EQ] = ACTIONS(1253),
    [anon_sym_const] = ACTIONS(1253),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [sym_super] = ACTIONS(1253),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_private] = ACTIONS(1253),
    [anon_sym_get] = ACTIONS(1253),
    [anon_sym_RBRACE] = ACTIONS(1255),
    [anon_sym_PERCENT] = ACTIONS(1255),
    [anon_sym_interface] = ACTIONS(1253),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_as] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_continue] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_instanceof] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1253),
    [sym_true] = ACTIONS(1253),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_enum] = ACTIONS(1253),
    [anon_sym_protected] = ACTIONS(1253),
    [anon_sym_abstract] = ACTIONS(1253),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_set] = ACTIONS(1253),
    [anon_sym_type] = ACTIONS(1253),
    [anon_sym_STAR_STAR] = ACTIONS(1255),
    [anon_sym_import] = ACTIONS(1253),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1255),
    [anon_sym_namespace] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_await] = ACTIONS(1253),
    [anon_sym_DQUOTE] = ACTIONS(1255),
    [anon_sym_else] = ACTIONS(1253),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_for] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(1255),
    [sym_false] = ACTIONS(1253),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym_case] = ACTIONS(1253),
    [anon_sym_module] = ACTIONS(1253),
    [anon_sym_number] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1253),
    [anon_sym_declare] = ACTIONS(1253),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_LT_LT] = ACTIONS(1255),
    [anon_sym_LBRACE] = ACTIONS(1255),
    [anon_sym_AMP_AMP] = ACTIONS(1255),
    [anon_sym_switch] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_LPAREN] = ACTIONS(1255),
    [sym_null] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_any] = ACTIONS(1253),
    [anon_sym_boolean] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_public] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_var] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1255),
    [anon_sym_while] = ACTIONS(1253),
    [anon_sym_SQUOTE] = ACTIONS(1255),
    [anon_sym_try] = ACTIONS(1253),
    [anon_sym_EQ_EQ] = ACTIONS(1253),
    [anon_sym_RPAREN] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(1253),
    [sym_number] = ACTIONS(1255),
    [anon_sym_SLASH] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1253),
    [sym_undefined] = ACTIONS(1253),
    [anon_sym_new] = ACTIONS(1253),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_let] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_export] = ACTIONS(1253),
    [anon_sym_GT_GT] = ACTIONS(1253),
    [anon_sym_do] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_with] = ACTIONS(1253),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1255),
    [anon_sym_in] = ACTIONS(1253),
  },
  [1217] = {
    [sym_array] = STATE(2116),
    [sym_object] = STATE(2117),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(4489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [1218] = {
    [anon_sym_of] = ACTIONS(4491),
    [sym_comment] = ACTIONS(3),
  },
  [1219] = {
    [anon_sym_of] = ACTIONS(4493),
    [sym_comment] = ACTIONS(3),
  },
  [1220] = {
    [anon_sym_of] = ACTIONS(4495),
    [sym_comment] = ACTIONS(3),
  },
  [1221] = {
    [sym_new_expression] = STATE(2133),
    [sym_augmented_assignment_expression] = STATE(2133),
    [sym_unary_expression] = STATE(2133),
    [sym_update_expression] = STATE(2133),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(2133),
    [sym_regex] = STATE(2133),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2133),
    [sym_non_null_expression] = STATE(2133),
    [sym_as_expression] = STATE(2133),
    [sym_jsx_fragment] = STATE(2133),
    [sym_yield_expression] = STATE(2133),
    [sym_jsx_element] = STATE(2133),
    [sym_internal_module] = STATE(2133),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2133),
    [sym_await_expression] = STATE(2133),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(2135),
    [sym_string] = STATE(2133),
    [sym_this] = STATE(2133),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(2133),
    [sym_generator_function] = STATE(2133),
    [sym_call_expression] = STATE(2133),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(2133),
    [sym_ternary_expression] = STATE(2133),
    [sym_binary_expression] = STATE(2133),
    [sym_template_string] = STATE(2133),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2133),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2133),
    [sym_class] = STATE(2133),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(4501),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4501),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4515),
    [sym_true] = ACTIONS(4501),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4501),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [1222] = {
    [sym_new_expression] = STATE(2150),
    [sym_augmented_assignment_expression] = STATE(2150),
    [sym_unary_expression] = STATE(2150),
    [sym_update_expression] = STATE(2150),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(2150),
    [sym_regex] = STATE(2150),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2150),
    [sym_non_null_expression] = STATE(2150),
    [sym_as_expression] = STATE(2150),
    [sym_jsx_fragment] = STATE(2150),
    [sym_yield_expression] = STATE(2150),
    [sym_jsx_element] = STATE(2150),
    [sym_internal_module] = STATE(2150),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2150),
    [sym_await_expression] = STATE(2150),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(2150),
    [sym_this] = STATE(2150),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(2150),
    [sym_generator_function] = STATE(2150),
    [sym_call_expression] = STATE(2150),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(2150),
    [sym_ternary_expression] = STATE(2150),
    [sym_binary_expression] = STATE(2150),
    [sym_template_string] = STATE(2150),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2150),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2150),
    [sym_class] = STATE(2150),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(4529),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4529),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4543),
    [sym_true] = ACTIONS(4529),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4529),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [1223] = {
    [sym__initializer] = STATE(391),
    [sym_type_annotation] = STATE(392),
    [sym__automatic_semicolon] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(715),
    [anon_sym_of] = ACTIONS(4491),
    [anon_sym_COMMA] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(4553),
  },
  [1224] = {
    [sym__initializer] = STATE(411),
    [sym_type_annotation] = STATE(412),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(745),
    [anon_sym_of] = ACTIONS(4493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(4555),
  },
  [1225] = {
    [sym__initializer] = STATE(413),
    [sym_type_annotation] = STATE(414),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(745),
    [anon_sym_of] = ACTIONS(4495),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(4557),
  },
  [1226] = {
    [sym_new_expression] = STATE(2158),
    [sym_augmented_assignment_expression] = STATE(2158),
    [sym_unary_expression] = STATE(2158),
    [sym_update_expression] = STATE(2158),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(2158),
    [sym_regex] = STATE(2158),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2158),
    [sym_non_null_expression] = STATE(2158),
    [sym_as_expression] = STATE(2158),
    [sym_jsx_fragment] = STATE(2158),
    [sym_yield_expression] = STATE(2158),
    [sym_jsx_element] = STATE(2158),
    [sym_internal_module] = STATE(2158),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2158),
    [sym_await_expression] = STATE(2158),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(2159),
    [sym_string] = STATE(2158),
    [sym_this] = STATE(2158),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(2158),
    [sym_generator_function] = STATE(2158),
    [sym_call_expression] = STATE(2158),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(2158),
    [sym_ternary_expression] = STATE(2158),
    [sym_binary_expression] = STATE(2158),
    [sym_template_string] = STATE(2158),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2158),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2158),
    [sym_class] = STATE(2158),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(4559),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4559),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_RPAREN] = ACTIONS(4561),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4563),
    [sym_true] = ACTIONS(4559),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4559),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [1227] = {
    [sym_new_expression] = STATE(2160),
    [sym_augmented_assignment_expression] = STATE(2160),
    [sym_unary_expression] = STATE(2160),
    [sym_update_expression] = STATE(2160),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(2160),
    [sym_regex] = STATE(2160),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2160),
    [sym_non_null_expression] = STATE(2160),
    [sym_as_expression] = STATE(2160),
    [sym_jsx_fragment] = STATE(2160),
    [sym_yield_expression] = STATE(2160),
    [sym_jsx_element] = STATE(2160),
    [sym_internal_module] = STATE(2160),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2160),
    [sym_await_expression] = STATE(2160),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(2160),
    [sym_this] = STATE(2160),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(2160),
    [sym_generator_function] = STATE(2160),
    [sym_call_expression] = STATE(2160),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(2160),
    [sym_ternary_expression] = STATE(2160),
    [sym_binary_expression] = STATE(2160),
    [sym_template_string] = STATE(2160),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2160),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2160),
    [sym_class] = STATE(2160),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(4565),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4565),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4567),
    [sym_true] = ACTIONS(4565),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4565),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [1228] = {
    [sym_new_expression] = STATE(2161),
    [sym_augmented_assignment_expression] = STATE(2161),
    [sym_unary_expression] = STATE(2161),
    [sym_update_expression] = STATE(2161),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(2161),
    [sym_regex] = STATE(2161),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2161),
    [sym_non_null_expression] = STATE(2161),
    [sym_as_expression] = STATE(2161),
    [sym_jsx_fragment] = STATE(2161),
    [sym_yield_expression] = STATE(2161),
    [sym_jsx_element] = STATE(2161),
    [sym_internal_module] = STATE(2161),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2161),
    [sym_await_expression] = STATE(2161),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(2162),
    [sym_string] = STATE(2161),
    [sym_this] = STATE(2161),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(2161),
    [sym_generator_function] = STATE(2161),
    [sym_call_expression] = STATE(2161),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(2161),
    [sym_ternary_expression] = STATE(2161),
    [sym_binary_expression] = STATE(2161),
    [sym_template_string] = STATE(2161),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2161),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2161),
    [sym_class] = STATE(2161),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(4569),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4569),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4571),
    [sym_true] = ACTIONS(4569),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4569),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [1229] = {
    [sym_new_expression] = STATE(2163),
    [sym_augmented_assignment_expression] = STATE(2163),
    [sym_unary_expression] = STATE(2163),
    [sym_update_expression] = STATE(2163),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(2163),
    [sym_regex] = STATE(2163),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2163),
    [sym_non_null_expression] = STATE(2163),
    [sym_as_expression] = STATE(2163),
    [sym_jsx_fragment] = STATE(2163),
    [sym_yield_expression] = STATE(2163),
    [sym_jsx_element] = STATE(2163),
    [sym_internal_module] = STATE(2163),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2163),
    [sym_await_expression] = STATE(2163),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(2163),
    [sym_this] = STATE(2163),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(2163),
    [sym_generator_function] = STATE(2163),
    [sym_call_expression] = STATE(2163),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(2163),
    [sym_ternary_expression] = STATE(2163),
    [sym_binary_expression] = STATE(2163),
    [sym_template_string] = STATE(2163),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2163),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2163),
    [sym_class] = STATE(2163),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(4573),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4573),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4575),
    [sym_true] = ACTIONS(4573),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4573),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [1230] = {
    [sym_new_expression] = STATE(2164),
    [sym_augmented_assignment_expression] = STATE(2164),
    [sym_unary_expression] = STATE(2164),
    [sym_update_expression] = STATE(2164),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(2164),
    [sym_regex] = STATE(2164),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2164),
    [sym_non_null_expression] = STATE(2164),
    [sym_as_expression] = STATE(2164),
    [sym_jsx_fragment] = STATE(2164),
    [sym_yield_expression] = STATE(2164),
    [sym_jsx_element] = STATE(2164),
    [sym_internal_module] = STATE(2164),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2164),
    [sym_await_expression] = STATE(2164),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(2165),
    [sym_string] = STATE(2164),
    [sym_this] = STATE(2164),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(2164),
    [sym_generator_function] = STATE(2164),
    [sym_call_expression] = STATE(2164),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(2164),
    [sym_ternary_expression] = STATE(2164),
    [sym_binary_expression] = STATE(2164),
    [sym_template_string] = STATE(2164),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2164),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2164),
    [sym_class] = STATE(2164),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(4577),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4577),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4579),
    [sym_true] = ACTIONS(4577),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4577),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [1231] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2517),
    [anon_sym_LBRACK] = ACTIONS(2517),
    [anon_sym_BANG] = ACTIONS(2519),
    [anon_sym_BQUOTE] = ACTIONS(2517),
    [anon_sym_else] = ACTIONS(2517),
    [anon_sym_PIPE] = ACTIONS(2519),
    [anon_sym_COMMA] = ACTIONS(2517),
    [anon_sym_LT_LT] = ACTIONS(2517),
    [anon_sym_STAR] = ACTIONS(2519),
    [anon_sym_GT_GT_GT] = ACTIONS(2517),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_LBRACE] = ACTIONS(2519),
    [anon_sym_BANG_EQ] = ACTIONS(2519),
    [anon_sym_LT_EQ] = ACTIONS(2517),
    [anon_sym_LPAREN] = ACTIONS(2517),
    [anon_sym_RBRACK] = ACTIONS(2517),
    [anon_sym_GT_EQ] = ACTIONS(2517),
    [anon_sym_GT] = ACTIONS(2519),
    [anon_sym_EQ] = ACTIONS(2519),
    [anon_sym_AMP] = ACTIONS(2519),
    [anon_sym_PERCENT] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(2517),
    [anon_sym_RBRACE] = ACTIONS(2517),
    [anon_sym_as] = ACTIONS(2517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2517),
    [anon_sym_while] = ACTIONS(2517),
    [anon_sym_DASH_DASH] = ACTIONS(2517),
    [anon_sym_EQ_EQ] = ACTIONS(2519),
    [anon_sym_instanceof] = ACTIONS(2517),
    [anon_sym_LT] = ACTIONS(2519),
    [anon_sym_RPAREN] = ACTIONS(2517),
    [anon_sym_SLASH] = ACTIONS(2519),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2517),
    [anon_sym_COLON] = ACTIONS(2517),
    [anon_sym_DOT] = ACTIONS(2517),
    [anon_sym_CARET] = ACTIONS(2517),
    [anon_sym_STAR_STAR] = ACTIONS(2517),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_implements] = ACTIONS(2517),
    [anon_sym_GT_GT] = ACTIONS(2519),
    [anon_sym_PLUS_PLUS] = ACTIONS(2517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2517),
    [anon_sym_in] = ACTIONS(2519),
  },
  [1232] = {
    [sym_type_alias_declaration] = STATE(2178),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(2178),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(2178),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(2178),
    [sym_return_statement] = STATE(2178),
    [aux_sym_program_repeat1] = STATE(2178),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [aux_sym_object_repeat1] = STATE(406),
    [sym_accessibility_modifier] = STATE(221),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(2178),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2178),
    [sym_spread_element] = STATE(405),
    [sym_switch_statement] = STATE(2178),
    [sym_string] = STATE(216),
    [sym_try_statement] = STATE(2178),
    [sym_throw_statement] = STATE(2178),
    [aux_sym_export_statement_repeat1] = STATE(2179),
    [sym__property_name] = STATE(224),
    [sym_object] = STATE(225),
    [sym_ambient_declaration] = STATE(2178),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(2178),
    [sym_decorator] = STATE(2179),
    [sym_continue_statement] = STATE(2178),
    [sym_formal_parameters] = STATE(57),
    [sym_computed_property_name] = STATE(224),
    [sym_function_signature] = STATE(2178),
    [sym_abstract_class] = STATE(2178),
    [sym_interface_declaration] = STATE(2178),
    [sym_statement_block] = STATE(2178),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(2178),
    [sym_debugger_statement] = STATE(2178),
    [sym_method_definition] = STATE(405),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(2178),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(2178),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(2178),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(2178),
    [sym_empty_statement] = STATE(2178),
    [sym_pair] = STATE(405),
    [sym_assignment_pattern] = STATE(405),
    [sym_import_alias] = STATE(2178),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(2178),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(2178),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(2178),
    [sym_break_statement] = STATE(2178),
    [sym_labeled_statement] = STATE(2178),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(226),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(2178),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(4581),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(4583),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(364),
    [anon_sym_void] = ACTIONS(4585),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(4587),
    [anon_sym_static] = ACTIONS(370),
    [anon_sym_get] = ACTIONS(4589),
    [anon_sym_RBRACE] = ACTIONS(739),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(4587),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(4589),
    [anon_sym_type] = ACTIONS(4591),
    [anon_sym_import] = ACTIONS(4593),
    [anon_sym_namespace] = ACTIONS(4595),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_readonly] = ACTIONS(384),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(388),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(4597),
    [anon_sym_number] = ACTIONS(4583),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4599),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(4583),
    [anon_sym_boolean] = ACTIONS(4583),
    [anon_sym_async] = ACTIONS(4601),
    [anon_sym_public] = ACTIONS(4587),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(400),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4583),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(4603),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [1233] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_BANG] = ACTIONS(1997),
    [anon_sym_BQUOTE] = ACTIONS(1995),
    [anon_sym_PIPE] = ACTIONS(1997),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_GT_GT_GT] = ACTIONS(1995),
    [anon_sym_AMP_AMP] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LBRACE] = ACTIONS(1997),
    [anon_sym_BANG_EQ] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(1995),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1995),
    [anon_sym_QMARK] = ACTIONS(1995),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [anon_sym_as] = ACTIONS(1995),
    [anon_sym_PIPE_PIPE] = ACTIONS(1995),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1995),
    [anon_sym_DASH_DASH] = ACTIONS(1995),
    [anon_sym_EQ_EQ] = ACTIONS(1997),
    [anon_sym_instanceof] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_CARET] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_implements] = ACTIONS(1995),
    [anon_sym_GT_GT] = ACTIONS(1997),
    [anon_sym_PLUS_PLUS] = ACTIONS(1995),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1995),
    [anon_sym_in] = ACTIONS(1997),
  },
  [1234] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_in] = ACTIONS(945),
  },
  [1235] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [1236] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(2003),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(2003),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_in] = ACTIONS(945),
  },
  [1237] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(2005),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(2005),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_in] = ACTIONS(945),
  },
  [1238] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [anon_sym_PERCENT_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_AMP_EQ] = ACTIONS(2011),
    [anon_sym_PLUS_EQ] = ACTIONS(2011),
    [anon_sym_PIPE] = ACTIONS(2013),
    [anon_sym_COMMA] = ACTIONS(2011),
    [anon_sym_LT_LT] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_GT_GT_GT] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_RBRACK] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_CARET_EQ] = ACTIONS(2011),
    [anon_sym_STAR_EQ] = ACTIONS(2011),
    [anon_sym_PIPE_EQ] = ACTIONS(2011),
    [anon_sym_DASH_EQ] = ACTIONS(2011),
    [anon_sym_AMP] = ACTIONS(2013),
    [anon_sym_PERCENT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_LT_LT_EQ] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2011),
    [anon_sym_RBRACE] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_instanceof] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_RPAREN] = ACTIONS(2011),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2011),
    [anon_sym_COLON] = ACTIONS(2011),
    [anon_sym_SLASH_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_DOT] = ACTIONS(2011),
    [anon_sym_CARET] = ACTIONS(2013),
    [anon_sym_STAR_STAR] = ACTIONS(2013),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_implements] = ACTIONS(2011),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2013),
  },
  [1239] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(2091),
    [anon_sym_BQUOTE] = ACTIONS(2089),
    [anon_sym_PIPE] = ACTIONS(2091),
    [anon_sym_COMMA] = ACTIONS(2089),
    [anon_sym_LT_LT] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2091),
    [anon_sym_GT_GT_GT] = ACTIONS(2089),
    [anon_sym_AMP_AMP] = ACTIONS(2089),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(2091),
    [anon_sym_BANG_EQ] = ACTIONS(2091),
    [anon_sym_LT_EQ] = ACTIONS(2089),
    [anon_sym_LPAREN] = ACTIONS(2089),
    [anon_sym_RBRACK] = ACTIONS(2089),
    [anon_sym_GT_EQ] = ACTIONS(2089),
    [anon_sym_GT] = ACTIONS(2091),
    [anon_sym_AMP] = ACTIONS(2091),
    [anon_sym_PERCENT] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2089),
    [anon_sym_RBRACE] = ACTIONS(2089),
    [anon_sym_as] = ACTIONS(2089),
    [anon_sym_PIPE_PIPE] = ACTIONS(2089),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2089),
    [anon_sym_DASH_DASH] = ACTIONS(2089),
    [anon_sym_EQ_EQ] = ACTIONS(2091),
    [anon_sym_instanceof] = ACTIONS(2089),
    [anon_sym_LT] = ACTIONS(2091),
    [anon_sym_RPAREN] = ACTIONS(2089),
    [anon_sym_SLASH] = ACTIONS(2091),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2089),
    [anon_sym_DOT] = ACTIONS(2089),
    [anon_sym_CARET] = ACTIONS(2089),
    [anon_sym_STAR_STAR] = ACTIONS(2089),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_implements] = ACTIONS(2089),
    [anon_sym_GT_GT] = ACTIONS(2091),
    [anon_sym_PLUS_PLUS] = ACTIONS(2089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2089),
    [anon_sym_in] = ACTIONS(2091),
  },
  [1240] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2101),
    [anon_sym_LBRACK] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_BQUOTE] = ACTIONS(2101),
    [anon_sym_PIPE] = ACTIONS(2103),
    [anon_sym_COMMA] = ACTIONS(2101),
    [anon_sym_LT_LT] = ACTIONS(2101),
    [anon_sym_STAR] = ACTIONS(2103),
    [anon_sym_GT_GT_GT] = ACTIONS(2101),
    [anon_sym_AMP_AMP] = ACTIONS(2101),
    [anon_sym_DASH] = ACTIONS(2103),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2103),
    [anon_sym_LT_EQ] = ACTIONS(2101),
    [anon_sym_LPAREN] = ACTIONS(2101),
    [anon_sym_RBRACK] = ACTIONS(2101),
    [anon_sym_GT_EQ] = ACTIONS(2101),
    [anon_sym_GT] = ACTIONS(2103),
    [anon_sym_AMP] = ACTIONS(2103),
    [anon_sym_PERCENT] = ACTIONS(2101),
    [anon_sym_QMARK] = ACTIONS(2101),
    [anon_sym_RBRACE] = ACTIONS(2101),
    [anon_sym_as] = ACTIONS(2101),
    [anon_sym_PIPE_PIPE] = ACTIONS(2101),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2101),
    [anon_sym_DASH_DASH] = ACTIONS(2101),
    [anon_sym_EQ_EQ] = ACTIONS(2103),
    [anon_sym_instanceof] = ACTIONS(2101),
    [anon_sym_LT] = ACTIONS(2103),
    [anon_sym_RPAREN] = ACTIONS(2101),
    [anon_sym_SLASH] = ACTIONS(2103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2101),
    [anon_sym_DOT] = ACTIONS(2101),
    [anon_sym_CARET] = ACTIONS(2101),
    [anon_sym_STAR_STAR] = ACTIONS(2101),
    [anon_sym_PLUS] = ACTIONS(2103),
    [anon_sym_implements] = ACTIONS(2101),
    [anon_sym_GT_GT] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(2101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2101),
    [anon_sym_in] = ACTIONS(2103),
  },
  [1241] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(2101),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(2101),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_in] = ACTIONS(945),
  },
  [1242] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(2105),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_in] = ACTIONS(945),
  },
  [1243] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2107),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_BANG] = ACTIONS(2109),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [anon_sym_PERCENT_EQ] = ACTIONS(2107),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2107),
    [anon_sym_AMP_EQ] = ACTIONS(2107),
    [anon_sym_PLUS_EQ] = ACTIONS(2107),
    [anon_sym_PIPE] = ACTIONS(2109),
    [anon_sym_COMMA] = ACTIONS(2107),
    [anon_sym_LT_LT] = ACTIONS(2109),
    [anon_sym_STAR] = ACTIONS(2109),
    [anon_sym_GT_GT_GT] = ACTIONS(2109),
    [anon_sym_EQ] = ACTIONS(2109),
    [anon_sym_AMP_AMP] = ACTIONS(2107),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_BANG_EQ] = ACTIONS(2109),
    [anon_sym_LT_EQ] = ACTIONS(2107),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_RBRACK] = ACTIONS(2107),
    [anon_sym_GT_EQ] = ACTIONS(2107),
    [anon_sym_GT] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2109),
    [anon_sym_CARET_EQ] = ACTIONS(2107),
    [anon_sym_STAR_EQ] = ACTIONS(2107),
    [anon_sym_PIPE_EQ] = ACTIONS(2107),
    [anon_sym_DASH_EQ] = ACTIONS(2107),
    [anon_sym_AMP] = ACTIONS(2109),
    [anon_sym_PERCENT] = ACTIONS(2109),
    [anon_sym_QMARK] = ACTIONS(2107),
    [anon_sym_LT_LT_EQ] = ACTIONS(2107),
    [anon_sym_as] = ACTIONS(2107),
    [anon_sym_PIPE_PIPE] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_EQ_EQ] = ACTIONS(2109),
    [anon_sym_instanceof] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_RPAREN] = ACTIONS(2107),
    [anon_sym_SLASH] = ACTIONS(2109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2107),
    [anon_sym_COLON] = ACTIONS(2107),
    [anon_sym_SLASH_EQ] = ACTIONS(2107),
    [anon_sym_GT_GT_EQ] = ACTIONS(2107),
    [anon_sym_DOT] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2109),
    [anon_sym_STAR_STAR] = ACTIONS(2109),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2107),
    [anon_sym_GT_GT] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_implements] = ACTIONS(2107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2107),
    [anon_sym_in] = ACTIONS(2109),
  },
  [1244] = {
    [sym_class_body] = STATE(2180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(959),
  },
  [1245] = {
    [sym_class_heritage] = STATE(2181),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(2180),
    [anon_sym_extends] = ACTIONS(1131),
    [anon_sym_implements] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(959),
  },
  [1246] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_BANG] = ACTIONS(2817),
    [anon_sym_BQUOTE] = ACTIONS(2815),
    [anon_sym_else] = ACTIONS(2815),
    [anon_sym_PIPE] = ACTIONS(2817),
    [anon_sym_COMMA] = ACTIONS(2815),
    [anon_sym_LT_LT] = ACTIONS(2815),
    [anon_sym_STAR] = ACTIONS(2817),
    [anon_sym_GT_GT_GT] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(2817),
    [anon_sym_BANG_EQ] = ACTIONS(2817),
    [anon_sym_LT_EQ] = ACTIONS(2815),
    [anon_sym_LPAREN] = ACTIONS(2815),
    [anon_sym_RBRACK] = ACTIONS(2815),
    [anon_sym_GT_EQ] = ACTIONS(2815),
    [anon_sym_GT] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2817),
    [anon_sym_PERCENT] = ACTIONS(2815),
    [anon_sym_QMARK] = ACTIONS(2815),
    [anon_sym_RBRACE] = ACTIONS(2815),
    [anon_sym_as] = ACTIONS(2815),
    [anon_sym_PIPE_PIPE] = ACTIONS(2815),
    [anon_sym_while] = ACTIONS(2815),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_EQ_EQ] = ACTIONS(2817),
    [anon_sym_instanceof] = ACTIONS(2815),
    [anon_sym_LT] = ACTIONS(2817),
    [anon_sym_RPAREN] = ACTIONS(2815),
    [anon_sym_SLASH] = ACTIONS(2817),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2815),
    [anon_sym_COLON] = ACTIONS(2815),
    [anon_sym_DOT] = ACTIONS(2815),
    [anon_sym_CARET] = ACTIONS(2815),
    [anon_sym_STAR_STAR] = ACTIONS(2815),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_implements] = ACTIONS(2815),
    [anon_sym_GT_GT] = ACTIONS(2817),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2815),
    [anon_sym_in] = ACTIONS(2817),
  },
  [1247] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [anon_sym_BANG] = ACTIONS(2865),
    [anon_sym_BQUOTE] = ACTIONS(2863),
    [anon_sym_else] = ACTIONS(2863),
    [anon_sym_PIPE] = ACTIONS(2865),
    [anon_sym_COMMA] = ACTIONS(2863),
    [anon_sym_LT_LT] = ACTIONS(2863),
    [anon_sym_STAR] = ACTIONS(2865),
    [anon_sym_GT_GT_GT] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(2863),
    [anon_sym_DASH] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2865),
    [anon_sym_BANG_EQ] = ACTIONS(2865),
    [anon_sym_LT_EQ] = ACTIONS(2863),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [anon_sym_RBRACK] = ACTIONS(2863),
    [anon_sym_GT_EQ] = ACTIONS(2863),
    [anon_sym_GT] = ACTIONS(2865),
    [anon_sym_AMP] = ACTIONS(2865),
    [anon_sym_PERCENT] = ACTIONS(2863),
    [anon_sym_QMARK] = ACTIONS(2863),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [anon_sym_as] = ACTIONS(2863),
    [anon_sym_PIPE_PIPE] = ACTIONS(2863),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2863),
    [anon_sym_DASH_DASH] = ACTIONS(2863),
    [anon_sym_EQ_EQ] = ACTIONS(2865),
    [anon_sym_instanceof] = ACTIONS(2863),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_RPAREN] = ACTIONS(2863),
    [anon_sym_SLASH] = ACTIONS(2865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(2863),
    [anon_sym_COLON] = ACTIONS(2863),
    [anon_sym_DOT] = ACTIONS(2863),
    [anon_sym_CARET] = ACTIONS(2863),
    [anon_sym_STAR_STAR] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2865),
    [anon_sym_implements] = ACTIONS(2863),
    [anon_sym_GT_GT] = ACTIONS(2865),
    [anon_sym_PLUS_PLUS] = ACTIONS(2863),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2863),
    [anon_sym_in] = ACTIONS(2865),
  },
  [1248] = {
    [sym_public_field_definition] = STATE(640),
    [sym__property_name] = STATE(641),
    [sym_decorator] = STATE(1404),
    [sym_method_signature] = STATE(640),
    [sym_accessibility_modifier] = STATE(642),
    [sym_abstract_method_signature] = STATE(640),
    [sym_computed_property_name] = STATE(641),
    [aux_sym_class_body_repeat1] = STATE(1404),
    [sym_index_signature] = STATE(640),
    [sym_string] = STATE(641),
    [sym_method_definition] = STATE(644),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1145),
    [anon_sym_get] = ACTIONS(1147),
    [anon_sym_RBRACE] = ACTIONS(4605),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [sym_number] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [1249] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_BANG] = ACTIONS(2903),
    [anon_sym_BQUOTE] = ACTIONS(2901),
    [anon_sym_PIPE] = ACTIONS(2903),
    [anon_sym_COMMA] = ACTIONS(2901),
    [anon_sym_LT_LT] = ACTIONS(2901),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_GT_GT_GT] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_BANG_EQ] = ACTIONS(2903),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_LPAREN] = ACTIONS(2901),
    [anon_sym_RBRACK] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_GT] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2903),
    [anon_sym_PERCENT] = ACTIONS(2901),
    [anon_sym_QMARK] = ACTIONS(2901),
    [anon_sym_RBRACE] = ACTIONS(2901),
    [anon_sym_as] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [anon_sym_EQ_EQ] = ACTIONS(2903),
    [anon_sym_instanceof] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_RPAREN] = ACTIONS(2901),
    [anon_sym_SLASH] = ACTIONS(2903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2901),
    [anon_sym_DOT] = ACTIONS(2901),
    [anon_sym_CARET] = ACTIONS(2901),
    [anon_sym_STAR_STAR] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_implements] = ACTIONS(2901),
    [anon_sym_GT_GT] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2901),
    [anon_sym_in] = ACTIONS(2903),
  },
  [1250] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3216),
    [anon_sym_LBRACK] = ACTIONS(3216),
    [anon_sym_BANG] = ACTIONS(3218),
    [anon_sym_BQUOTE] = ACTIONS(3216),
    [anon_sym_PIPE] = ACTIONS(3218),
    [anon_sym_COMMA] = ACTIONS(3216),
    [anon_sym_LT_LT] = ACTIONS(3216),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_GT_GT_GT] = ACTIONS(3216),
    [anon_sym_AMP_AMP] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3218),
    [anon_sym_LBRACE] = ACTIONS(3218),
    [anon_sym_BANG_EQ] = ACTIONS(3218),
    [anon_sym_LT_EQ] = ACTIONS(3216),
    [anon_sym_LPAREN] = ACTIONS(3216),
    [anon_sym_RBRACK] = ACTIONS(3216),
    [anon_sym_GT_EQ] = ACTIONS(3216),
    [anon_sym_GT] = ACTIONS(3218),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_PERCENT] = ACTIONS(3216),
    [anon_sym_QMARK] = ACTIONS(3216),
    [anon_sym_RBRACE] = ACTIONS(3216),
    [anon_sym_as] = ACTIONS(3216),
    [anon_sym_PIPE_PIPE] = ACTIONS(3216),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3216),
    [anon_sym_DASH_DASH] = ACTIONS(3216),
    [anon_sym_EQ_EQ] = ACTIONS(3218),
    [anon_sym_instanceof] = ACTIONS(3216),
    [anon_sym_LT] = ACTIONS(3218),
    [anon_sym_RPAREN] = ACTIONS(3216),
    [anon_sym_SLASH] = ACTIONS(3218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3216),
    [anon_sym_DOT] = ACTIONS(3216),
    [anon_sym_CARET] = ACTIONS(3216),
    [anon_sym_STAR_STAR] = ACTIONS(3216),
    [anon_sym_PLUS] = ACTIONS(3218),
    [anon_sym_implements] = ACTIONS(3216),
    [anon_sym_GT_GT] = ACTIONS(3218),
    [anon_sym_PLUS_PLUS] = ACTIONS(3216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3216),
    [anon_sym_in] = ACTIONS(3218),
  },
  [1251] = {
    [anon_sym_RPAREN] = ACTIONS(4607),
    [sym_comment] = ACTIONS(3),
  },
  [1252] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(945),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(2197),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_RBRACK] = ACTIONS(4609),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [1253] = {
    [anon_sym_RBRACK] = ACTIONS(4609),
    [sym_comment] = ACTIONS(3),
  },
  [1254] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2389),
    [anon_sym_LBRACK] = ACTIONS(2389),
    [anon_sym_BANG] = ACTIONS(2391),
    [anon_sym_BQUOTE] = ACTIONS(2389),
    [anon_sym_PIPE] = ACTIONS(2391),
    [anon_sym_COMMA] = ACTIONS(2389),
    [anon_sym_LT_LT] = ACTIONS(2389),
    [anon_sym_STAR] = ACTIONS(2391),
    [anon_sym_GT_GT_GT] = ACTIONS(2389),
    [anon_sym_AMP_AMP] = ACTIONS(2389),
    [anon_sym_DASH] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2391),
    [anon_sym_BANG_EQ] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2389),
    [anon_sym_LPAREN] = ACTIONS(2389),
    [anon_sym_RBRACK] = ACTIONS(2389),
    [anon_sym_GT_EQ] = ACTIONS(2389),
    [anon_sym_GT] = ACTIONS(2391),
    [anon_sym_AMP] = ACTIONS(2391),
    [anon_sym_PERCENT] = ACTIONS(2389),
    [anon_sym_QMARK] = ACTIONS(2389),
    [anon_sym_RBRACE] = ACTIONS(2389),
    [anon_sym_as] = ACTIONS(2389),
    [anon_sym_PIPE_PIPE] = ACTIONS(2389),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2389),
    [anon_sym_DASH_DASH] = ACTIONS(2389),
    [anon_sym_EQ_EQ] = ACTIONS(2391),
    [anon_sym_instanceof] = ACTIONS(2389),
    [anon_sym_LT] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2389),
    [anon_sym_SLASH] = ACTIONS(2391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2389),
    [anon_sym_DOT] = ACTIONS(2389),
    [anon_sym_CARET] = ACTIONS(2389),
    [anon_sym_STAR_STAR] = ACTIONS(2389),
    [anon_sym_PLUS] = ACTIONS(2391),
    [anon_sym_implements] = ACTIONS(2389),
    [anon_sym_GT_GT] = ACTIONS(2391),
    [anon_sym_PLUS_PLUS] = ACTIONS(2389),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2389),
    [anon_sym_in] = ACTIONS(2391),
  },
  [1255] = {
    [sym_new_expression] = STATE(2186),
    [sym_augmented_assignment_expression] = STATE(2186),
    [sym_unary_expression] = STATE(2186),
    [sym_update_expression] = STATE(2186),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(2186),
    [sym_regex] = STATE(2186),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2185),
    [sym__expression] = STATE(2186),
    [sym_non_null_expression] = STATE(2186),
    [sym_yield_expression] = STATE(2186),
    [sym_jsx_fragment] = STATE(2186),
    [sym_jsx_element] = STATE(2186),
    [sym_as_expression] = STATE(2186),
    [sym_internal_module] = STATE(2186),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2186),
    [sym_await_expression] = STATE(2186),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(2186),
    [sym_this] = STATE(2186),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(2186),
    [sym_generator_function] = STATE(2186),
    [sym_call_expression] = STATE(2186),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(2186),
    [sym_ternary_expression] = STATE(2186),
    [sym_binary_expression] = STATE(2186),
    [sym_template_string] = STATE(2186),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2186),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2186),
    [sym_class] = STATE(2186),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(4611),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4611),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4613),
    [sym_true] = ACTIONS(4611),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4611),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [1256] = {
    [sym_new_expression] = STATE(2188),
    [sym_augmented_assignment_expression] = STATE(2188),
    [sym_unary_expression] = STATE(2188),
    [sym_update_expression] = STATE(2188),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(2188),
    [sym_regex] = STATE(2188),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2187),
    [sym__expression] = STATE(2188),
    [sym_non_null_expression] = STATE(2188),
    [sym_yield_expression] = STATE(2188),
    [sym_jsx_fragment] = STATE(2188),
    [sym_jsx_element] = STATE(2188),
    [sym_as_expression] = STATE(2188),
    [sym_internal_module] = STATE(2188),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2188),
    [sym_await_expression] = STATE(2188),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(2188),
    [sym_this] = STATE(2188),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(2188),
    [sym_generator_function] = STATE(2188),
    [sym_call_expression] = STATE(2188),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(2188),
    [sym_ternary_expression] = STATE(2188),
    [sym_binary_expression] = STATE(2188),
    [sym_template_string] = STATE(2188),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2188),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2188),
    [sym_class] = STATE(2188),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(4615),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4615),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4617),
    [sym_true] = ACTIONS(4615),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4615),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [1257] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(2189),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1258] = {
    [sym_statement_block] = STATE(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2609),
  },
  [1259] = {
    [sym_nested_identifier] = STATE(965),
    [sym_jsx_namespace_name] = STATE(966),
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(4619),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1975),
  },
  [1260] = {
    [sym_jsx_opening_element] = STATE(340),
    [aux_sym_jsx_element_repeat1] = STATE(975),
    [sym_jsx_expression] = STATE(975),
    [sym_jsx_self_closing_element] = STATE(975),
    [sym_jsx_element] = STATE(975),
    [sym_jsx_text] = ACTIONS(1993),
    [anon_sym_LT] = ACTIONS(4621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(590),
  },
  [1261] = {
    [anon_sym_GT] = ACTIONS(4623),
    [sym_comment] = ACTIONS(3),
  },
  [1262] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(1589),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(1589),
    [sym_jsx_expression] = STATE(1589),
    [anon_sym_GT] = ACTIONS(3333),
    [sym_identifier] = ACTIONS(1492),
    [sym_jsx_identifier] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(4625),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [1263] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_BANG] = ACTIONS(3357),
    [anon_sym_BQUOTE] = ACTIONS(3355),
    [anon_sym_PIPE] = ACTIONS(3357),
    [anon_sym_COMMA] = ACTIONS(3355),
    [anon_sym_LT_LT] = ACTIONS(3355),
    [anon_sym_STAR] = ACTIONS(3357),
    [anon_sym_GT_GT_GT] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3357),
    [anon_sym_BANG_EQ] = ACTIONS(3357),
    [anon_sym_LT_EQ] = ACTIONS(3355),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_RBRACK] = ACTIONS(3355),
    [anon_sym_GT_EQ] = ACTIONS(3355),
    [anon_sym_GT] = ACTIONS(3357),
    [anon_sym_AMP] = ACTIONS(3357),
    [anon_sym_PERCENT] = ACTIONS(3355),
    [anon_sym_QMARK] = ACTIONS(3355),
    [anon_sym_RBRACE] = ACTIONS(3355),
    [anon_sym_as] = ACTIONS(3357),
    [anon_sym_PIPE_PIPE] = ACTIONS(3355),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3355),
    [anon_sym_DASH_DASH] = ACTIONS(3355),
    [anon_sym_EQ_EQ] = ACTIONS(3357),
    [anon_sym_instanceof] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_RPAREN] = ACTIONS(3355),
    [anon_sym_SLASH] = ACTIONS(3357),
    [sym_comment] = ACTIONS(3),
    [sym_regex_flags] = ACTIONS(4627),
    [anon_sym_COLON] = ACTIONS(3355),
    [anon_sym_DOT] = ACTIONS(3355),
    [anon_sym_CARET] = ACTIONS(3355),
    [anon_sym_STAR_STAR] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_GT_GT] = ACTIONS(3357),
    [anon_sym_PLUS_PLUS] = ACTIONS(3355),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3355),
    [anon_sym_in] = ACTIONS(3357),
  },
  [1264] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(2196),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1265] = {
    [sym_statement_block] = STATE(2197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2609),
  },
  [1266] = {
    [sym_type_alias_declaration] = STATE(2178),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(2178),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(2178),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(2178),
    [sym_return_statement] = STATE(2178),
    [aux_sym_program_repeat1] = STATE(2178),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(2178),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2178),
    [sym_switch_statement] = STATE(2178),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(2178),
    [sym_throw_statement] = STATE(2178),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(2178),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(2178),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(2178),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(2178),
    [sym_abstract_class] = STATE(2178),
    [sym_interface_declaration] = STATE(2178),
    [sym_statement_block] = STATE(2178),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(2178),
    [sym_debugger_statement] = STATE(2178),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(2178),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(2178),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(2178),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(2178),
    [sym_empty_statement] = STATE(2178),
    [sym_import_alias] = STATE(2178),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(2178),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(2178),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(2178),
    [sym_break_statement] = STATE(2178),
    [sym_labeled_statement] = STATE(2178),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(2178),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4629),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [1267] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3377),
    [anon_sym_LBRACK] = ACTIONS(3377),
    [anon_sym_BANG] = ACTIONS(3379),
    [anon_sym_BQUOTE] = ACTIONS(3377),
    [anon_sym_else] = ACTIONS(3377),
    [anon_sym_PIPE] = ACTIONS(3379),
    [anon_sym_COMMA] = ACTIONS(3377),
    [anon_sym_LT_LT] = ACTIONS(3377),
    [anon_sym_STAR] = ACTIONS(3379),
    [anon_sym_GT_GT_GT] = ACTIONS(3377),
    [anon_sym_AMP_AMP] = ACTIONS(3377),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3379),
    [anon_sym_BANG_EQ] = ACTIONS(3379),
    [anon_sym_LT_EQ] = ACTIONS(3377),
    [anon_sym_LPAREN] = ACTIONS(3377),
    [anon_sym_RBRACK] = ACTIONS(3377),
    [anon_sym_GT_EQ] = ACTIONS(3377),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_AMP] = ACTIONS(3379),
    [anon_sym_PERCENT] = ACTIONS(3377),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_RBRACE] = ACTIONS(3377),
    [anon_sym_as] = ACTIONS(3377),
    [anon_sym_PIPE_PIPE] = ACTIONS(3377),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_DASH_DASH] = ACTIONS(3377),
    [anon_sym_EQ_EQ] = ACTIONS(3379),
    [anon_sym_instanceof] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_RPAREN] = ACTIONS(3377),
    [anon_sym_SLASH] = ACTIONS(3379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3377),
    [anon_sym_COLON] = ACTIONS(3377),
    [anon_sym_DOT] = ACTIONS(3377),
    [anon_sym_CARET] = ACTIONS(3377),
    [anon_sym_STAR_STAR] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_implements] = ACTIONS(3377),
    [anon_sym_GT_GT] = ACTIONS(3379),
    [anon_sym_PLUS_PLUS] = ACTIONS(3377),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3377),
    [anon_sym_in] = ACTIONS(3379),
  },
  [1268] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3385),
    [anon_sym_LBRACK] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3387),
    [anon_sym_BQUOTE] = ACTIONS(3385),
    [anon_sym_PIPE] = ACTIONS(3387),
    [anon_sym_COMMA] = ACTIONS(3385),
    [anon_sym_LT_LT] = ACTIONS(3385),
    [anon_sym_STAR] = ACTIONS(3387),
    [anon_sym_GT_GT_GT] = ACTIONS(3385),
    [anon_sym_AMP_AMP] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_BANG_EQ] = ACTIONS(3387),
    [anon_sym_LT_EQ] = ACTIONS(3385),
    [anon_sym_LPAREN] = ACTIONS(3385),
    [anon_sym_RBRACK] = ACTIONS(3385),
    [anon_sym_GT_EQ] = ACTIONS(3385),
    [anon_sym_GT] = ACTIONS(3387),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_PERCENT] = ACTIONS(3385),
    [anon_sym_QMARK] = ACTIONS(3385),
    [anon_sym_RBRACE] = ACTIONS(3385),
    [anon_sym_as] = ACTIONS(3385),
    [anon_sym_PIPE_PIPE] = ACTIONS(3385),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3385),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [anon_sym_EQ_EQ] = ACTIONS(3387),
    [anon_sym_instanceof] = ACTIONS(3385),
    [anon_sym_LT] = ACTIONS(3387),
    [anon_sym_RPAREN] = ACTIONS(3385),
    [anon_sym_SLASH] = ACTIONS(3387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3385),
    [anon_sym_DOT] = ACTIONS(3385),
    [anon_sym_CARET] = ACTIONS(3385),
    [anon_sym_STAR_STAR] = ACTIONS(3385),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_implements] = ACTIONS(3385),
    [anon_sym_GT_GT] = ACTIONS(3387),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3385),
    [anon_sym_in] = ACTIONS(3387),
  },
  [1269] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3389),
    [anon_sym_LBRACK] = ACTIONS(3389),
    [anon_sym_BANG] = ACTIONS(3391),
    [anon_sym_BQUOTE] = ACTIONS(3389),
    [anon_sym_PIPE] = ACTIONS(3391),
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_LT_LT] = ACTIONS(3389),
    [anon_sym_STAR] = ACTIONS(3391),
    [anon_sym_GT_GT_GT] = ACTIONS(3389),
    [anon_sym_AMP_AMP] = ACTIONS(3389),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3391),
    [anon_sym_BANG_EQ] = ACTIONS(3391),
    [anon_sym_LT_EQ] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3389),
    [anon_sym_RBRACK] = ACTIONS(3389),
    [anon_sym_GT_EQ] = ACTIONS(3389),
    [anon_sym_GT] = ACTIONS(3391),
    [anon_sym_AMP] = ACTIONS(3391),
    [anon_sym_PERCENT] = ACTIONS(3389),
    [anon_sym_QMARK] = ACTIONS(3389),
    [anon_sym_RBRACE] = ACTIONS(3389),
    [anon_sym_as] = ACTIONS(3389),
    [anon_sym_PIPE_PIPE] = ACTIONS(3389),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3389),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [anon_sym_EQ_EQ] = ACTIONS(3391),
    [anon_sym_instanceof] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3391),
    [anon_sym_RPAREN] = ACTIONS(3389),
    [anon_sym_SLASH] = ACTIONS(3391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3389),
    [anon_sym_DOT] = ACTIONS(3389),
    [anon_sym_CARET] = ACTIONS(3389),
    [anon_sym_STAR_STAR] = ACTIONS(3389),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_implements] = ACTIONS(3389),
    [anon_sym_GT_GT] = ACTIONS(3391),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3389),
    [anon_sym_in] = ACTIONS(3391),
  },
  [1270] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3393),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3395),
    [anon_sym_BQUOTE] = ACTIONS(3393),
    [anon_sym_PIPE] = ACTIONS(3395),
    [anon_sym_COMMA] = ACTIONS(3393),
    [anon_sym_LT_LT] = ACTIONS(3393),
    [anon_sym_STAR] = ACTIONS(3395),
    [anon_sym_GT_GT_GT] = ACTIONS(3393),
    [anon_sym_AMP_AMP] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_BANG_EQ] = ACTIONS(3395),
    [anon_sym_LT_EQ] = ACTIONS(3393),
    [anon_sym_LPAREN] = ACTIONS(3393),
    [anon_sym_RBRACK] = ACTIONS(3393),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_GT] = ACTIONS(3395),
    [anon_sym_AMP] = ACTIONS(3395),
    [anon_sym_PERCENT] = ACTIONS(3393),
    [anon_sym_QMARK] = ACTIONS(3393),
    [anon_sym_RBRACE] = ACTIONS(3393),
    [anon_sym_as] = ACTIONS(3393),
    [anon_sym_PIPE_PIPE] = ACTIONS(3393),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3393),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [anon_sym_EQ_EQ] = ACTIONS(3395),
    [anon_sym_instanceof] = ACTIONS(3393),
    [anon_sym_LT] = ACTIONS(3395),
    [anon_sym_RPAREN] = ACTIONS(3393),
    [anon_sym_SLASH] = ACTIONS(3395),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3393),
    [anon_sym_DOT] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3393),
    [anon_sym_STAR_STAR] = ACTIONS(3393),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_implements] = ACTIONS(3393),
    [anon_sym_GT_GT] = ACTIONS(3395),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3393),
    [anon_sym_in] = ACTIONS(3395),
  },
  [1271] = {
    [sym_identifier] = ACTIONS(4631),
    [sym_comment] = ACTIONS(3),
  },
  [1272] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(2513),
    [anon_sym_BANG] = ACTIONS(2515),
    [anon_sym_BQUOTE] = ACTIONS(2513),
    [anon_sym_PIPE] = ACTIONS(2515),
    [anon_sym_COMMA] = ACTIONS(2513),
    [anon_sym_LT_LT] = ACTIONS(2513),
    [anon_sym_STAR] = ACTIONS(2515),
    [anon_sym_GT_GT_GT] = ACTIONS(2513),
    [anon_sym_AMP_AMP] = ACTIONS(2513),
    [anon_sym_DASH] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2515),
    [anon_sym_BANG_EQ] = ACTIONS(2515),
    [anon_sym_LT_EQ] = ACTIONS(2513),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_RBRACK] = ACTIONS(2513),
    [anon_sym_GT_EQ] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2515),
    [anon_sym_AMP] = ACTIONS(2515),
    [anon_sym_PERCENT] = ACTIONS(2513),
    [anon_sym_QMARK] = ACTIONS(2513),
    [anon_sym_RBRACE] = ACTIONS(2513),
    [anon_sym_as] = ACTIONS(2513),
    [anon_sym_PIPE_PIPE] = ACTIONS(2513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2513),
    [anon_sym_DASH_DASH] = ACTIONS(2513),
    [anon_sym_EQ_EQ] = ACTIONS(2515),
    [anon_sym_instanceof] = ACTIONS(2513),
    [anon_sym_LT] = ACTIONS(2515),
    [anon_sym_RPAREN] = ACTIONS(2513),
    [anon_sym_SLASH] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2513),
    [anon_sym_DOT] = ACTIONS(2513),
    [anon_sym_CARET] = ACTIONS(2513),
    [anon_sym_STAR_STAR] = ACTIONS(2513),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_implements] = ACTIONS(2513),
    [anon_sym_GT_GT] = ACTIONS(2515),
    [anon_sym_PLUS_PLUS] = ACTIONS(2513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2513),
    [anon_sym_in] = ACTIONS(2515),
  },
  [1273] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_in] = ACTIONS(945),
  },
  [1274] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(4633),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [1275] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(4633),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [1276] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_in] = ACTIONS(945),
  },
  [1277] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3630),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4636),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [1278] = {
    [sym_type_arguments] = STATE(2206),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(4638),
    [anon_sym_BANG] = ACTIONS(3699),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_GT_GT_GT] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_is] = ACTIONS(4641),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_RBRACK] = ACTIONS(2204),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_instanceof] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(4643),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4646),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_STAR_STAR] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2204),
    [anon_sym_in] = ACTIONS(3699),
  },
  [1279] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_BQUOTE] = ACTIONS(2212),
    [anon_sym_PIPE] = ACTIONS(2210),
    [anon_sym_COMMA] = ACTIONS(2212),
    [anon_sym_LT_LT] = ACTIONS(2212),
    [anon_sym_STAR] = ACTIONS(2210),
    [anon_sym_GT_GT_GT] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2212),
    [anon_sym_DASH] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2210),
    [anon_sym_BANG_EQ] = ACTIONS(2210),
    [anon_sym_LT_EQ] = ACTIONS(2212),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_RBRACK] = ACTIONS(2212),
    [anon_sym_GT_EQ] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2210),
    [anon_sym_AMP] = ACTIONS(2210),
    [anon_sym_PERCENT] = ACTIONS(2212),
    [anon_sym_QMARK] = ACTIONS(2212),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_as] = ACTIONS(2212),
    [anon_sym_PIPE_PIPE] = ACTIONS(2212),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2212),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [anon_sym_EQ_EQ] = ACTIONS(2210),
    [anon_sym_instanceof] = ACTIONS(2212),
    [anon_sym_LT] = ACTIONS(2210),
    [anon_sym_RPAREN] = ACTIONS(2212),
    [anon_sym_SLASH] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2212),
    [anon_sym_DOT] = ACTIONS(2212),
    [anon_sym_CARET] = ACTIONS(2212),
    [anon_sym_STAR_STAR] = ACTIONS(2212),
    [anon_sym_PLUS] = ACTIONS(2210),
    [anon_sym_implements] = ACTIONS(2212),
    [anon_sym_GT_GT] = ACTIONS(2210),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2212),
    [anon_sym_in] = ACTIONS(2210),
  },
  [1280] = {
    [sym_index_type_query] = STATE(2208),
    [sym_lookup_type] = STATE(2208),
    [sym_flow_maybe_type] = STATE(2208),
    [sym_parenthesized_type] = STATE(2208),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_array_type] = STATE(2208),
    [sym_type_predicate] = STATE(2208),
    [sym_type_query] = STATE(2208),
    [sym_existential_type] = STATE(2208),
    [sym_this_type] = STATE(2208),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(2208),
    [sym__primary_type] = STATE(2208),
    [sym_generic_type] = STATE(2208),
    [sym_literal_type] = STATE(2208),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(2208),
    [sym_string] = STATE(1279),
    [sym_tuple_type] = STATE(2208),
    [sym_identifier] = ACTIONS(2641),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(2667),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [sym_true] = ACTIONS(2643),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(4648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [1281] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(2211),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(2211),
    [sym_call_signature] = STATE(2211),
    [sym_export_statement] = STATE(2211),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(2211),
    [sym_index_signature] = STATE(2211),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_SEMI] = ACTIONS(4650),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(4650),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_RBRACE] = ACTIONS(4652),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4652),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [1282] = {
    [sym_union_type] = STATE(2212),
    [sym__type] = STATE(2212),
    [sym_constructor_type] = STATE(2212),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1089),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2212),
    [sym_function_type] = STATE(2212),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1090),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1283] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2248),
    [anon_sym_BQUOTE] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_LT_LT] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2248),
    [anon_sym_GT_GT_GT] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2248),
    [anon_sym_BANG_EQ] = ACTIONS(2248),
    [anon_sym_LT_EQ] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_RBRACK] = ACTIONS(2250),
    [anon_sym_GT_EQ] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_QMARK] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_as] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2248),
    [anon_sym_instanceof] = ACTIONS(2250),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(2248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_STAR_STAR] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_implements] = ACTIONS(2250),
    [anon_sym_GT_GT] = ACTIONS(2248),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2250),
    [anon_sym_in] = ACTIONS(2248),
  },
  [1284] = {
    [sym_union_type] = STATE(2213),
    [sym__type] = STATE(2213),
    [sym_constructor_type] = STATE(2213),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1295),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2213),
    [sym_function_type] = STATE(2213),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1299),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(2641),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(2667),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [1285] = {
    [sym_nested_identifier] = STATE(2214),
    [sym_identifier] = ACTIONS(4654),
    [sym_comment] = ACTIONS(3),
  },
  [1286] = {
    [sym_nested_type_identifier] = STATE(2216),
    [sym_nested_identifier] = STATE(1296),
    [sym_identifier] = ACTIONS(4656),
    [sym_comment] = ACTIONS(3),
  },
  [1287] = {
    [sym_number] = ACTIONS(4658),
    [sym_comment] = ACTIONS(3),
  },
  [1288] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2262),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_BQUOTE] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_COMMA] = ACTIONS(2262),
    [anon_sym_LT_LT] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(2260),
    [anon_sym_GT_GT_GT] = ACTIONS(2262),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2260),
    [anon_sym_BANG_EQ] = ACTIONS(2260),
    [anon_sym_LT_EQ] = ACTIONS(2262),
    [anon_sym_LPAREN] = ACTIONS(2262),
    [anon_sym_RBRACK] = ACTIONS(2262),
    [anon_sym_GT_EQ] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_PERCENT] = ACTIONS(2262),
    [anon_sym_QMARK] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2262),
    [anon_sym_as] = ACTIONS(2262),
    [anon_sym_PIPE_PIPE] = ACTIONS(2262),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2262),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_EQ_EQ] = ACTIONS(2260),
    [anon_sym_instanceof] = ACTIONS(2262),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_RPAREN] = ACTIONS(2262),
    [anon_sym_SLASH] = ACTIONS(2260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2262),
    [anon_sym_DOT] = ACTIONS(2262),
    [anon_sym_CARET] = ACTIONS(2262),
    [anon_sym_STAR_STAR] = ACTIONS(2262),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_implements] = ACTIONS(2262),
    [anon_sym_GT_GT] = ACTIONS(2260),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2262),
    [anon_sym_in] = ACTIONS(2260),
  },
  [1289] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_BANG] = ACTIONS(2252),
    [anon_sym_BQUOTE] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_LT_LT] = ACTIONS(2254),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_GT_GT_GT] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_BANG_EQ] = ACTIONS(2252),
    [anon_sym_LT_EQ] = ACTIONS(2254),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [anon_sym_RBRACK] = ACTIONS(2254),
    [anon_sym_GT_EQ] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2252),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2254),
    [anon_sym_QMARK] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_as] = ACTIONS(2254),
    [anon_sym_PIPE_PIPE] = ACTIONS(2254),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2254),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_EQ_EQ] = ACTIONS(2252),
    [anon_sym_instanceof] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2252),
    [anon_sym_RPAREN] = ACTIONS(2254),
    [anon_sym_SLASH] = ACTIONS(2252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2254),
    [anon_sym_DOT] = ACTIONS(2254),
    [anon_sym_CARET] = ACTIONS(2254),
    [anon_sym_STAR_STAR] = ACTIONS(2254),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_implements] = ACTIONS(2254),
    [anon_sym_GT_GT] = ACTIONS(2252),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2254),
    [anon_sym_in] = ACTIONS(2252),
  },
  [1290] = {
    [sym_type_parameters] = STATE(2218),
    [sym_formal_parameters] = STATE(2219),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1291] = {
    [sym__type] = STATE(2220),
    [sym_constructor_type] = STATE(2220),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_type_parameters] = STATE(1108),
    [sym_array_type] = STATE(436),
    [sym_rest_parameter] = STATE(244),
    [sym_nested_identifier] = STATE(435),
    [sym_accessibility_modifier] = STATE(247),
    [sym_required_parameter] = STATE(244),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_this] = STATE(772),
    [sym_tuple_type] = STATE(436),
    [sym_union_type] = STATE(2220),
    [aux_sym_export_statement_repeat1] = STATE(781),
    [sym_object] = STATE(769),
    [sym_nested_type_identifier] = STATE(433),
    [sym_optional_parameter] = STATE(244),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_object_type] = STATE(436),
    [sym_decorator] = STATE(781),
    [sym_intersection_type] = STATE(2220),
    [sym_function_type] = STATE(2220),
    [sym_formal_parameters] = STATE(1109),
    [sym_array] = STATE(771),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [sym_identifier] = ACTIONS(2268),
    [sym_false] = ACTIONS(753),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(2270),
    [anon_sym_number] = ACTIONS(2270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_void] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_any] = ACTIONS(2270),
    [anon_sym_private] = ACTIONS(1446),
    [anon_sym_boolean] = ACTIONS(2270),
    [anon_sym_async] = ACTIONS(1442),
    [anon_sym_public] = ACTIONS(1446),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_RPAREN] = ACTIONS(428),
    [anon_sym_this] = ACTIONS(2280),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1446),
    [anon_sym_string] = ACTIONS(2270),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_new] = ACTIONS(2282),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [1292] = {
    [sym_union_type] = STATE(2221),
    [sym__type] = STATE(2221),
    [sym_constructor_type] = STATE(2221),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1295),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2221),
    [sym_function_type] = STATE(2221),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1299),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(2641),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(2667),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [1293] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3720),
    [anon_sym_LBRACK] = ACTIONS(3720),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3720),
    [anon_sym_PIPE] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3720),
    [anon_sym_LT_LT] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3722),
    [anon_sym_GT_GT_GT] = ACTIONS(3720),
    [anon_sym_AMP_AMP] = ACTIONS(3720),
    [anon_sym_DASH] = ACTIONS(3722),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_LT_EQ] = ACTIONS(3720),
    [anon_sym_LPAREN] = ACTIONS(3720),
    [anon_sym_RBRACK] = ACTIONS(3720),
    [anon_sym_GT_EQ] = ACTIONS(3720),
    [anon_sym_GT] = ACTIONS(3722),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_PERCENT] = ACTIONS(3720),
    [anon_sym_QMARK] = ACTIONS(3720),
    [anon_sym_RBRACE] = ACTIONS(3720),
    [anon_sym_as] = ACTIONS(3720),
    [anon_sym_PIPE_PIPE] = ACTIONS(3720),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3720),
    [anon_sym_DASH_DASH] = ACTIONS(3720),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_instanceof] = ACTIONS(3720),
    [anon_sym_LT] = ACTIONS(3722),
    [anon_sym_RPAREN] = ACTIONS(3720),
    [anon_sym_SLASH] = ACTIONS(3722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3720),
    [anon_sym_DOT] = ACTIONS(3720),
    [anon_sym_CARET] = ACTIONS(3720),
    [anon_sym_STAR_STAR] = ACTIONS(3720),
    [anon_sym_PLUS] = ACTIONS(3722),
    [anon_sym_implements] = ACTIONS(3720),
    [anon_sym_GT_GT] = ACTIONS(3722),
    [anon_sym_PLUS_PLUS] = ACTIONS(3720),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3720),
    [anon_sym_in] = ACTIONS(3722),
  },
  [1294] = {
    [sym_type_arguments] = STATE(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(4660),
    [anon_sym_BANG] = ACTIONS(2297),
    [anon_sym_BQUOTE] = ACTIONS(2292),
    [anon_sym_PIPE] = ACTIONS(2297),
    [anon_sym_COMMA] = ACTIONS(2292),
    [anon_sym_LT_LT] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2297),
    [anon_sym_GT_GT_GT] = ACTIONS(2292),
    [anon_sym_AMP_AMP] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2297),
    [anon_sym_LBRACE] = ACTIONS(2297),
    [anon_sym_BANG_EQ] = ACTIONS(2297),
    [anon_sym_LT_EQ] = ACTIONS(2292),
    [anon_sym_LPAREN] = ACTIONS(2292),
    [anon_sym_RBRACK] = ACTIONS(2292),
    [anon_sym_GT_EQ] = ACTIONS(2292),
    [anon_sym_GT] = ACTIONS(2297),
    [anon_sym_AMP] = ACTIONS(2297),
    [anon_sym_PERCENT] = ACTIONS(2292),
    [anon_sym_QMARK] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(2292),
    [anon_sym_as] = ACTIONS(2292),
    [anon_sym_PIPE_PIPE] = ACTIONS(2292),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [anon_sym_EQ_EQ] = ACTIONS(2297),
    [anon_sym_instanceof] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(4663),
    [anon_sym_RPAREN] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2297),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym_DOT] = ACTIONS(2292),
    [anon_sym_CARET] = ACTIONS(2292),
    [anon_sym_STAR_STAR] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_implements] = ACTIONS(2292),
    [anon_sym_GT_GT] = ACTIONS(2297),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2297),
  },
  [1295] = {
    [sym_formal_parameters] = STATE(2226),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1296] = {
    [anon_sym_DOT] = ACTIONS(4646),
    [sym_comment] = ACTIONS(3),
  },
  [1297] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3720),
    [anon_sym_LBRACK] = ACTIONS(3720),
    [anon_sym_BANG] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3720),
    [anon_sym_PIPE] = ACTIONS(3722),
    [anon_sym_COMMA] = ACTIONS(3720),
    [anon_sym_LT_LT] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3722),
    [anon_sym_GT_GT_GT] = ACTIONS(3720),
    [anon_sym_AMP_AMP] = ACTIONS(3720),
    [anon_sym_DASH] = ACTIONS(3722),
    [anon_sym_LBRACE] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3722),
    [anon_sym_LT_EQ] = ACTIONS(3720),
    [anon_sym_LPAREN] = ACTIONS(3720),
    [anon_sym_RBRACK] = ACTIONS(3720),
    [anon_sym_GT_EQ] = ACTIONS(3720),
    [anon_sym_GT] = ACTIONS(3722),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_PERCENT] = ACTIONS(3720),
    [anon_sym_QMARK] = ACTIONS(3720),
    [anon_sym_RBRACE] = ACTIONS(3720),
    [anon_sym_as] = ACTIONS(3720),
    [anon_sym_PIPE_PIPE] = ACTIONS(3720),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3720),
    [anon_sym_DASH_DASH] = ACTIONS(3720),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_instanceof] = ACTIONS(3720),
    [anon_sym_LT] = ACTIONS(3722),
    [anon_sym_RPAREN] = ACTIONS(3720),
    [anon_sym_SLASH] = ACTIONS(3722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3720),
    [anon_sym_DOT] = ACTIONS(3720),
    [anon_sym_CARET] = ACTIONS(3720),
    [anon_sym_STAR_STAR] = ACTIONS(3720),
    [anon_sym_PLUS] = ACTIONS(3722),
    [anon_sym_implements] = ACTIONS(3720),
    [anon_sym_GT_GT] = ACTIONS(3722),
    [anon_sym_PLUS_PLUS] = ACTIONS(3720),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3720),
    [anon_sym_in] = ACTIONS(3722),
  },
  [1298] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2301),
    [anon_sym_LBRACK] = ACTIONS(4666),
    [anon_sym_BANG] = ACTIONS(2299),
    [anon_sym_BQUOTE] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2299),
    [anon_sym_COMMA] = ACTIONS(2301),
    [anon_sym_LT_LT] = ACTIONS(2301),
    [anon_sym_STAR] = ACTIONS(2299),
    [anon_sym_GT_GT_GT] = ACTIONS(2301),
    [anon_sym_AMP_AMP] = ACTIONS(2301),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_LBRACE] = ACTIONS(2299),
    [anon_sym_BANG_EQ] = ACTIONS(2299),
    [anon_sym_LT_EQ] = ACTIONS(2301),
    [anon_sym_LPAREN] = ACTIONS(2301),
    [anon_sym_RBRACK] = ACTIONS(2301),
    [anon_sym_GT_EQ] = ACTIONS(2301),
    [anon_sym_GT] = ACTIONS(2299),
    [anon_sym_AMP] = ACTIONS(2299),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_QMARK] = ACTIONS(2301),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [anon_sym_as] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2301),
    [anon_sym_DASH_DASH] = ACTIONS(2301),
    [anon_sym_EQ_EQ] = ACTIONS(2299),
    [anon_sym_instanceof] = ACTIONS(2301),
    [anon_sym_LT] = ACTIONS(2299),
    [anon_sym_RPAREN] = ACTIONS(2301),
    [anon_sym_SLASH] = ACTIONS(2299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2301),
    [anon_sym_DOT] = ACTIONS(2301),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2301),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_implements] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2299),
    [anon_sym_PLUS_PLUS] = ACTIONS(2301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2301),
    [anon_sym_in] = ACTIONS(2299),
  },
  [1299] = {
    [anon_sym_EQ_GT] = ACTIONS(4668),
    [sym_comment] = ACTIONS(3),
  },
  [1300] = {
    [sym__initializer] = STATE(522),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(937),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(937),
    [anon_sym_AMP_EQ] = ACTIONS(937),
    [anon_sym_PLUS_EQ] = ACTIONS(937),
    [anon_sym_PIPE] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3738),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(937),
    [anon_sym_STAR_EQ] = ACTIONS(937),
    [anon_sym_PIPE_EQ] = ACTIONS(937),
    [anon_sym_DASH_EQ] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(937),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(937),
    [anon_sym_GT_GT_EQ] = ACTIONS(937),
    [anon_sym_DOT] = ACTIONS(4670),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(945),
  },
  [1301] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3749),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_COMMA] = ACTIONS(3749),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3752),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [1302] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(951),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_AMP_EQ] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_CARET_EQ] = ACTIONS(951),
    [anon_sym_STAR_EQ] = ACTIONS(951),
    [anon_sym_PIPE_EQ] = ACTIONS(951),
    [anon_sym_DASH_EQ] = ACTIONS(951),
    [anon_sym_EQ_GT] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(951),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(951),
    [anon_sym_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1303] = {
    [sym_new_expression] = STATE(533),
    [sym_augmented_assignment_expression] = STATE(533),
    [sym_unary_expression] = STATE(533),
    [sym_update_expression] = STATE(533),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(533),
    [sym_regex] = STATE(533),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(533),
    [sym_non_null_expression] = STATE(533),
    [sym_as_expression] = STATE(533),
    [sym_jsx_fragment] = STATE(533),
    [sym_yield_expression] = STATE(533),
    [sym_jsx_element] = STATE(533),
    [sym_internal_module] = STATE(533),
    [sym_nested_identifier] = STATE(1092),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(533),
    [sym_await_expression] = STATE(533),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(533),
    [sym_this] = STATE(533),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(533),
    [sym_generator_function] = STATE(533),
    [sym_call_expression] = STATE(533),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(533),
    [sym_ternary_expression] = STATE(533),
    [sym_binary_expression] = STATE(533),
    [sym_template_string] = STATE(533),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(533),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(533),
    [sym_class] = STATE(533),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(4672),
    [sym_false] = ACTIONS(961),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(961),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(963),
    [sym_true] = ACTIONS(961),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(961),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [1304] = {
    [sym_new_expression] = STATE(534),
    [sym_augmented_assignment_expression] = STATE(534),
    [sym_unary_expression] = STATE(534),
    [sym_update_expression] = STATE(534),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(534),
    [sym_regex] = STATE(534),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(534),
    [sym_non_null_expression] = STATE(534),
    [sym_as_expression] = STATE(534),
    [sym_jsx_fragment] = STATE(534),
    [sym_yield_expression] = STATE(534),
    [sym_jsx_element] = STATE(534),
    [sym_internal_module] = STATE(534),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(534),
    [sym_await_expression] = STATE(534),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(534),
    [sym_this] = STATE(534),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(534),
    [sym_generator_function] = STATE(534),
    [sym_call_expression] = STATE(534),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(534),
    [sym_ternary_expression] = STATE(534),
    [sym_binary_expression] = STATE(534),
    [sym_template_string] = STATE(534),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(534),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(534),
    [sym_class] = STATE(534),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(965),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4674),
    [sym_true] = ACTIONS(965),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(965),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [1305] = {
    [aux_sym_export_statement_repeat1] = STATE(2003),
    [sym__property_name] = STATE(1807),
    [sym_object] = STATE(384),
    [sym_assignment_pattern] = STATE(405),
    [sym_pair] = STATE(405),
    [sym_method_signature] = STATE(1079),
    [sym_call_signature] = STATE(1079),
    [sym_type_parameters] = STATE(1082),
    [sym_index_signature] = STATE(1079),
    [sym_export_statement] = STATE(1079),
    [sym_method_definition] = STATE(405),
    [aux_sym_object_repeat1] = STATE(406),
    [sym_property_signature] = STATE(1079),
    [sym_decorator] = STATE(2003),
    [sym_construct_signature] = STATE(1079),
    [sym_accessibility_modifier] = STATE(1808),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1807),
    [sym_array] = STATE(385),
    [sym_spread_element] = STATE(405),
    [sym_string] = STATE(1807),
    [sym_identifier] = ACTIONS(4203),
    [anon_sym_LBRACK] = ACTIONS(3785),
    [anon_sym_SEMI] = ACTIONS(2218),
    [anon_sym_module] = ACTIONS(4205),
    [anon_sym_symbol] = ACTIONS(4205),
    [anon_sym_number] = ACTIONS(4205),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(4205),
    [anon_sym_COMMA] = ACTIONS(3789),
    [anon_sym_STAR] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_void] = ACTIONS(4205),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(4205),
    [anon_sym_private] = ACTIONS(4207),
    [anon_sym_boolean] = ACTIONS(4205),
    [anon_sym_static] = ACTIONS(3795),
    [anon_sym_async] = ACTIONS(4209),
    [anon_sym_get] = ACTIONS(4211),
    [anon_sym_RBRACE] = ACTIONS(739),
    [anon_sym_public] = ACTIONS(4207),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(3801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4207),
    [anon_sym_string] = ACTIONS(4205),
    [anon_sym_set] = ACTIONS(4211),
    [anon_sym_type] = ACTIONS(4205),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(4205),
    [anon_sym_export] = ACTIONS(4215),
    [sym_readonly] = ACTIONS(3805),
    [anon_sym_namespace] = ACTIONS(4205),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [1306] = {
    [sym_new_expression] = STATE(533),
    [sym_augmented_assignment_expression] = STATE(533),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(533),
    [sym_update_expression] = STATE(533),
    [sym_regex] = STATE(533),
    [sym_meta_property] = STATE(533),
    [sym_call_signature] = STATE(159),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(533),
    [sym_non_null_expression] = STATE(533),
    [sym_yield_expression] = STATE(533),
    [sym_jsx_fragment] = STATE(533),
    [sym_jsx_element] = STATE(533),
    [sym_as_expression] = STATE(533),
    [sym_internal_module] = STATE(533),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(533),
    [sym_await_expression] = STATE(533),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(533),
    [sym_this] = STATE(533),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(533),
    [sym_generator_function] = STATE(533),
    [sym_call_expression] = STATE(533),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(533),
    [sym_ternary_expression] = STATE(533),
    [sym_binary_expression] = STATE(533),
    [sym_template_string] = STATE(533),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(533),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(533),
    [sym_class] = STATE(533),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(951),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_AMP_EQ] = ACTIONS(951),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(951),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_PIPE_EQ] = ACTIONS(951),
    [anon_sym_DASH_EQ] = ACTIONS(951),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(951),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(290),
    [sym_true] = ACTIONS(961),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(951),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(961),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(135),
    [sym_null] = ACTIONS(961),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_STAR_EQ] = ACTIONS(951),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_EQ_GT] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(951),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(961),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1307] = {
    [sym_new_expression] = STATE(538),
    [sym_constructor_type] = STATE(1107),
    [sym_augmented_assignment_expression] = STATE(538),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(538),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(538),
    [sym_type_parameters] = STATE(1817),
    [sym_array_type] = STATE(436),
    [sym_rest_parameter] = STATE(244),
    [sym_yield_expression] = STATE(538),
    [sym_as_expression] = STATE(538),
    [sym_jsx_fragment] = STATE(538),
    [sym_internal_module] = STATE(538),
    [sym_accessibility_modifier] = STATE(247),
    [sym_arrow_function] = STATE(538),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(246),
    [sym_literal_type] = STATE(436),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(1814),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(250),
    [sym_object] = STATE(251),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(538),
    [sym_subscript_expression] = STATE(246),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(538),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(538),
    [sym_decorator] = STATE(250),
    [sym_formal_parameters] = STATE(1818),
    [sym_function_type] = STATE(1107),
    [sym__type] = STATE(1107),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(538),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(538),
    [sym__expression] = STATE(538),
    [sym_non_null_expression] = STATE(538),
    [sym_jsx_element] = STATE(538),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_required_parameter] = STATE(244),
    [sym_await_expression] = STATE(538),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_sequence_expression] = STATE(539),
    [sym_this] = STATE(249),
    [sym_union_type] = STATE(1107),
    [sym_anonymous_class] = STATE(538),
    [sym_optional_parameter] = STATE(244),
    [sym_call_expression] = STATE(538),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(538),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(538),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1107),
    [sym_parenthesized_expression] = STATE(538),
    [sym_array] = STATE(252),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(538),
    [sym_class] = STATE(538),
    [sym_identifier] = ACTIONS(3807),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(3809),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(2274),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_void] = ACTIONS(3813),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(424),
    [anon_sym_get] = ACTIONS(414),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_this] = ACTIONS(3815),
    [anon_sym_yield] = ACTIONS(432),
    [sym_true] = ACTIONS(3817),
    [anon_sym_protected] = ACTIONS(424),
    [anon_sym_set] = ACTIONS(414),
    [anon_sym_type] = ACTIONS(414),
    [anon_sym_import] = ACTIONS(414),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(438),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [sym_false] = ACTIONS(3817),
    [anon_sym_module] = ACTIONS(414),
    [anon_sym_number] = ACTIONS(3809),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(414),
    [anon_sym_typeof] = ACTIONS(3819),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [sym_null] = ACTIONS(983),
    [anon_sym_any] = ACTIONS(3809),
    [anon_sym_boolean] = ACTIONS(3809),
    [anon_sym_async] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(424),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_RPAREN] = ACTIONS(428),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3821),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3809),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(983),
    [anon_sym_new] = ACTIONS(3823),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_export] = ACTIONS(414),
    [anon_sym_TILDE] = ACTIONS(412),
  },
  [1308] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3825),
    [anon_sym_LT_LT] = ACTIONS(207),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_GT_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(209),
    [anon_sym_BANG_EQ] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(207),
    [anon_sym_RBRACK] = ACTIONS(207),
    [anon_sym_GT_EQ] = ACTIONS(207),
    [anon_sym_GT] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_RBRACE] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_LBRACE_PIPE] = ACTIONS(207),
    [anon_sym_DASH_DASH] = ACTIONS(207),
    [anon_sym_EQ_EQ] = ACTIONS(209),
    [anon_sym_instanceof] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_SLASH] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_DOT] = ACTIONS(207),
    [anon_sym_CARET] = ACTIONS(207),
    [anon_sym_STAR_STAR] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_implements] = ACTIONS(207),
    [anon_sym_GT_GT] = ACTIONS(209),
    [anon_sym_PLUS_PLUS] = ACTIONS(207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(209),
  },
  [1309] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(1819),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(1820),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(1021),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(1025),
    [anon_sym_symbol] = ACTIONS(1025),
    [anon_sym_number] = ACTIONS(1025),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1025),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1025),
    [anon_sym_private] = ACTIONS(1025),
    [anon_sym_boolean] = ACTIONS(1025),
    [anon_sym_async] = ACTIONS(1029),
    [anon_sym_public] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1025),
    [anon_sym_string] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(1025),
    [anon_sym_type] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(1025),
    [anon_sym_export] = ACTIONS(1025),
    [anon_sym_namespace] = ACTIONS(1035),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [1310] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(4633),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [1311] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4676),
    [anon_sym_LBRACK] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(4678),
    [anon_sym_SEMI] = ACTIONS(4676),
    [anon_sym_BQUOTE] = ACTIONS(4676),
    [sym__automatic_semicolon] = ACTIONS(4676),
    [anon_sym_PIPE] = ACTIONS(4678),
    [anon_sym_COMMA] = ACTIONS(4676),
    [anon_sym_LT_LT] = ACTIONS(4676),
    [anon_sym_STAR] = ACTIONS(4678),
    [anon_sym_GT_GT_GT] = ACTIONS(4676),
    [anon_sym_EQ] = ACTIONS(4678),
    [anon_sym_AMP_AMP] = ACTIONS(4676),
    [anon_sym_DASH] = ACTIONS(4678),
    [anon_sym_BANG_EQ] = ACTIONS(4678),
    [anon_sym_LT_EQ] = ACTIONS(4676),
    [anon_sym_LPAREN] = ACTIONS(4676),
    [anon_sym_GT_EQ] = ACTIONS(4676),
    [anon_sym_of] = ACTIONS(4676),
    [anon_sym_GT] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4676),
    [anon_sym_QMARK] = ACTIONS(4676),
    [anon_sym_RBRACE] = ACTIONS(4676),
    [anon_sym_as] = ACTIONS(4676),
    [anon_sym_PIPE_PIPE] = ACTIONS(4676),
    [anon_sym_DASH_DASH] = ACTIONS(4676),
    [anon_sym_EQ_EQ] = ACTIONS(4678),
    [anon_sym_instanceof] = ACTIONS(4676),
    [anon_sym_LT] = ACTIONS(4678),
    [anon_sym_RPAREN] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4676),
    [anon_sym_CARET] = ACTIONS(4676),
    [anon_sym_STAR_STAR] = ACTIONS(4676),
    [anon_sym_PLUS] = ACTIONS(4678),
    [anon_sym_GT_GT] = ACTIONS(4678),
    [anon_sym_PLUS_PLUS] = ACTIONS(4676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4676),
    [anon_sym_in] = ACTIONS(4678),
  },
  [1312] = {
    [sym_class_heritage] = STATE(2232),
    [sym_type_parameters] = STATE(2233),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(2234),
    [anon_sym_extends] = ACTIONS(1131),
    [anon_sym_implements] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(959),
  },
  [1313] = {
    [sym_class_body] = STATE(2235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(959),
  },
  [1314] = {
    [sym_nested_identifier] = STATE(2238),
    [sym_jsx_namespace_name] = STATE(2239),
    [sym_identifier] = ACTIONS(4680),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(4682),
  },
  [1315] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3874),
    [anon_sym_LBRACK] = ACTIONS(3874),
    [anon_sym_BANG] = ACTIONS(3876),
    [anon_sym_BQUOTE] = ACTIONS(3874),
    [anon_sym_PIPE] = ACTIONS(3876),
    [anon_sym_COMMA] = ACTIONS(3874),
    [anon_sym_LT_LT] = ACTIONS(3874),
    [anon_sym_STAR] = ACTIONS(3876),
    [anon_sym_GT_GT_GT] = ACTIONS(3874),
    [anon_sym_AMP_AMP] = ACTIONS(3874),
    [anon_sym_DASH] = ACTIONS(3876),
    [anon_sym_LBRACE] = ACTIONS(3876),
    [anon_sym_BANG_EQ] = ACTIONS(3876),
    [anon_sym_LT_EQ] = ACTIONS(3874),
    [anon_sym_LPAREN] = ACTIONS(3874),
    [anon_sym_RBRACK] = ACTIONS(3874),
    [anon_sym_GT_EQ] = ACTIONS(3874),
    [anon_sym_GT] = ACTIONS(3876),
    [anon_sym_AMP] = ACTIONS(3876),
    [anon_sym_PERCENT] = ACTIONS(3874),
    [anon_sym_QMARK] = ACTIONS(3874),
    [anon_sym_RBRACE] = ACTIONS(3874),
    [anon_sym_as] = ACTIONS(3874),
    [anon_sym_PIPE_PIPE] = ACTIONS(3874),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3874),
    [anon_sym_DASH_DASH] = ACTIONS(3874),
    [anon_sym_EQ_EQ] = ACTIONS(3876),
    [anon_sym_instanceof] = ACTIONS(3874),
    [anon_sym_LT] = ACTIONS(3876),
    [anon_sym_RPAREN] = ACTIONS(3874),
    [anon_sym_SLASH] = ACTIONS(3876),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3874),
    [anon_sym_DOT] = ACTIONS(3874),
    [anon_sym_CARET] = ACTIONS(3874),
    [anon_sym_STAR_STAR] = ACTIONS(3874),
    [anon_sym_PLUS] = ACTIONS(3876),
    [anon_sym_implements] = ACTIONS(3874),
    [anon_sym_GT_GT] = ACTIONS(3876),
    [anon_sym_PLUS_PLUS] = ACTIONS(3874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3874),
    [anon_sym_in] = ACTIONS(3876),
  },
  [1316] = {
    [sym_identifier] = ACTIONS(4487),
    [anon_sym_BQUOTE] = ACTIONS(4485),
    [anon_sym_debugger] = ACTIONS(4487),
    [anon_sym_symbol] = ACTIONS(4487),
    [anon_sym_AT] = ACTIONS(4485),
    [anon_sym_PIPE] = ACTIONS(4485),
    [anon_sym_COMMA] = ACTIONS(4485),
    [anon_sym_DASH] = ACTIONS(4487),
    [anon_sym_EQ] = ACTIONS(4487),
    [anon_sym_void] = ACTIONS(4487),
    [anon_sym_break] = ACTIONS(4487),
    [anon_sym_const] = ACTIONS(4487),
    [sym_super] = ACTIONS(4487),
    [anon_sym_return] = ACTIONS(4487),
    [anon_sym_private] = ACTIONS(4487),
    [anon_sym_get] = ACTIONS(4487),
    [anon_sym_RBRACE] = ACTIONS(4485),
    [anon_sym_interface] = ACTIONS(4487),
    [anon_sym_default] = ACTIONS(4487),
    [anon_sym_enum] = ACTIONS(4487),
    [anon_sym_delete] = ACTIONS(4487),
    [anon_sym_continue] = ACTIONS(4487),
    [anon_sym_DASH_DASH] = ACTIONS(4485),
    [anon_sym_if] = ACTIONS(4487),
    [anon_sym_this] = ACTIONS(4487),
    [anon_sym_yield] = ACTIONS(4487),
    [sym_true] = ACTIONS(4487),
    [anon_sym_throw] = ACTIONS(4487),
    [anon_sym_protected] = ACTIONS(4487),
    [anon_sym_abstract] = ACTIONS(4487),
    [anon_sym_DOT] = ACTIONS(4487),
    [anon_sym_set] = ACTIONS(4487),
    [anon_sym_type] = ACTIONS(4487),
    [anon_sym_import] = ACTIONS(4487),
    [anon_sym_namespace] = ACTIONS(4487),
    [anon_sym_PLUS_PLUS] = ACTIONS(4485),
    [anon_sym_await] = ACTIONS(4487),
    [anon_sym_DQUOTE] = ACTIONS(4485),
    [anon_sym_else] = ACTIONS(4487),
    [anon_sym_BANG] = ACTIONS(4485),
    [anon_sym_for] = ACTIONS(4487),
    [anon_sym_LBRACK] = ACTIONS(4485),
    [sym_false] = ACTIONS(4487),
    [anon_sym_SEMI] = ACTIONS(4485),
    [anon_sym_case] = ACTIONS(4487),
    [anon_sym_module] = ACTIONS(4487),
    [anon_sym_number] = ACTIONS(4487),
    [anon_sym_class] = ACTIONS(4487),
    [anon_sym_declare] = ACTIONS(4487),
    [anon_sym_typeof] = ACTIONS(4487),
    [anon_sym_LBRACE] = ACTIONS(4485),
    [anon_sym_switch] = ACTIONS(4487),
    [anon_sym_LPAREN] = ACTIONS(4485),
    [anon_sym_RBRACK] = ACTIONS(4485),
    [sym_null] = ACTIONS(4487),
    [anon_sym_GT] = ACTIONS(4485),
    [anon_sym_any] = ACTIONS(4487),
    [anon_sym_boolean] = ACTIONS(4487),
    [anon_sym_async] = ACTIONS(4487),
    [anon_sym_public] = ACTIONS(4487),
    [anon_sym_EQ_GT] = ACTIONS(4485),
    [anon_sym_AMP] = ACTIONS(4485),
    [anon_sym_var] = ACTIONS(4487),
    [anon_sym_while] = ACTIONS(4487),
    [anon_sym_SQUOTE] = ACTIONS(4485),
    [anon_sym_try] = ACTIONS(4487),
    [anon_sym_RPAREN] = ACTIONS(4485),
    [anon_sym_LT] = ACTIONS(4485),
    [sym_number] = ACTIONS(4485),
    [anon_sym_SLASH] = ACTIONS(4487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4487),
    [anon_sym_function] = ACTIONS(4487),
    [sym_undefined] = ACTIONS(4487),
    [anon_sym_new] = ACTIONS(4487),
    [ts_builtin_sym_end] = ACTIONS(4485),
    [anon_sym_let] = ACTIONS(4487),
    [anon_sym_PLUS] = ACTIONS(4487),
    [anon_sym_export] = ACTIONS(4487),
    [anon_sym_do] = ACTIONS(4487),
    [anon_sym_TILDE] = ACTIONS(4485),
    [anon_sym_with] = ACTIONS(4487),
  },
  [1317] = {
    [sym_identifier] = ACTIONS(2519),
    [anon_sym_BQUOTE] = ACTIONS(2517),
    [anon_sym_debugger] = ACTIONS(2519),
    [anon_sym_symbol] = ACTIONS(2519),
    [anon_sym_AT] = ACTIONS(2517),
    [anon_sym_PIPE] = ACTIONS(2517),
    [anon_sym_COMMA] = ACTIONS(2517),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_EQ] = ACTIONS(2519),
    [anon_sym_void] = ACTIONS(2519),
    [anon_sym_break] = ACTIONS(2519),
    [anon_sym_const] = ACTIONS(2519),
    [sym_super] = ACTIONS(2519),
    [anon_sym_return] = ACTIONS(2519),
    [anon_sym_private] = ACTIONS(2519),
    [anon_sym_get] = ACTIONS(2519),
    [anon_sym_RBRACE] = ACTIONS(2517),
    [anon_sym_interface] = ACTIONS(2519),
    [anon_sym_default] = ACTIONS(2519),
    [anon_sym_enum] = ACTIONS(2519),
    [anon_sym_delete] = ACTIONS(2519),
    [anon_sym_continue] = ACTIONS(2519),
    [anon_sym_DASH_DASH] = ACTIONS(2517),
    [anon_sym_if] = ACTIONS(2519),
    [anon_sym_this] = ACTIONS(2519),
    [anon_sym_yield] = ACTIONS(2519),
    [sym_true] = ACTIONS(2519),
    [anon_sym_throw] = ACTIONS(2519),
    [anon_sym_COLON] = ACTIONS(2517),
    [anon_sym_protected] = ACTIONS(2519),
    [anon_sym_abstract] = ACTIONS(2519),
    [anon_sym_set] = ACTIONS(2519),
    [anon_sym_type] = ACTIONS(2519),
    [anon_sym_import] = ACTIONS(2519),
    [anon_sym_namespace] = ACTIONS(2519),
    [anon_sym_PLUS_PLUS] = ACTIONS(2517),
    [anon_sym_await] = ACTIONS(2519),
    [anon_sym_DQUOTE] = ACTIONS(2517),
    [anon_sym_else] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2517),
    [anon_sym_for] = ACTIONS(2519),
    [anon_sym_LBRACK] = ACTIONS(2517),
    [sym_false] = ACTIONS(2519),
    [anon_sym_SEMI] = ACTIONS(2517),
    [anon_sym_case] = ACTIONS(2519),
    [anon_sym_module] = ACTIONS(2519),
    [anon_sym_number] = ACTIONS(2519),
    [anon_sym_class] = ACTIONS(2519),
    [anon_sym_declare] = ACTIONS(2519),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LBRACE] = ACTIONS(2517),
    [anon_sym_switch] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2517),
    [anon_sym_RBRACK] = ACTIONS(2517),
    [sym_null] = ACTIONS(2519),
    [anon_sym_GT] = ACTIONS(2517),
    [anon_sym_any] = ACTIONS(2519),
    [anon_sym_boolean] = ACTIONS(2519),
    [anon_sym_async] = ACTIONS(2519),
    [anon_sym_public] = ACTIONS(2519),
    [anon_sym_EQ_GT] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_var] = ACTIONS(2519),
    [anon_sym_QMARK] = ACTIONS(2517),
    [anon_sym_while] = ACTIONS(2519),
    [anon_sym_SQUOTE] = ACTIONS(2517),
    [anon_sym_try] = ACTIONS(2519),
    [anon_sym_RPAREN] = ACTIONS(2517),
    [anon_sym_LT] = ACTIONS(2517),
    [sym_number] = ACTIONS(2517),
    [anon_sym_SLASH] = ACTIONS(2519),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2519),
    [anon_sym_function] = ACTIONS(2519),
    [sym_undefined] = ACTIONS(2519),
    [anon_sym_new] = ACTIONS(2519),
    [ts_builtin_sym_end] = ACTIONS(2517),
    [anon_sym_let] = ACTIONS(2519),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_export] = ACTIONS(2519),
    [anon_sym_do] = ACTIONS(2519),
    [anon_sym_TILDE] = ACTIONS(2517),
    [anon_sym_with] = ACTIONS(2519),
  },
  [1318] = {
    [sym_new_expression] = STATE(2240),
    [sym_augmented_assignment_expression] = STATE(2240),
    [sym_unary_expression] = STATE(2240),
    [sym_update_expression] = STATE(2240),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(2240),
    [sym_regex] = STATE(2240),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1233),
    [sym__expression] = STATE(2240),
    [sym_non_null_expression] = STATE(2240),
    [sym_yield_expression] = STATE(2240),
    [sym_jsx_fragment] = STATE(2240),
    [sym_jsx_element] = STATE(2240),
    [sym_as_expression] = STATE(2240),
    [sym_internal_module] = STATE(2240),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2240),
    [sym_await_expression] = STATE(2240),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(2240),
    [sym_this] = STATE(2240),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(2240),
    [sym_generator_function] = STATE(2240),
    [sym_call_expression] = STATE(2240),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(2240),
    [sym_ternary_expression] = STATE(2240),
    [sym_binary_expression] = STATE(2240),
    [sym_template_string] = STATE(2240),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2240),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2240),
    [sym_class] = STATE(2240),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(2733),
    [sym_false] = ACTIONS(4684),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4684),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4686),
    [sym_true] = ACTIONS(4684),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4684),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [1319] = {
    [sym_new_expression] = STATE(2241),
    [sym_augmented_assignment_expression] = STATE(2241),
    [sym_unary_expression] = STATE(2241),
    [sym_update_expression] = STATE(2241),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(2241),
    [sym_regex] = STATE(2241),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2241),
    [sym_non_null_expression] = STATE(2241),
    [sym_as_expression] = STATE(2241),
    [sym_jsx_fragment] = STATE(2241),
    [sym_yield_expression] = STATE(2241),
    [sym_jsx_element] = STATE(2241),
    [sym_internal_module] = STATE(2241),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2241),
    [sym_await_expression] = STATE(2241),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(2241),
    [sym_this] = STATE(2241),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(2241),
    [sym_generator_function] = STATE(2241),
    [sym_call_expression] = STATE(2241),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(2241),
    [sym_ternary_expression] = STATE(2241),
    [sym_binary_expression] = STATE(2241),
    [sym_template_string] = STATE(2241),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2241),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2241),
    [sym_class] = STATE(2241),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(2733),
    [sym_false] = ACTIONS(4688),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4688),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4690),
    [sym_true] = ACTIONS(4688),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4688),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [1320] = {
    [sym_new_expression] = STATE(2242),
    [sym_augmented_assignment_expression] = STATE(2242),
    [sym_unary_expression] = STATE(2242),
    [sym_update_expression] = STATE(2242),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(2242),
    [sym_regex] = STATE(2242),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2242),
    [sym_non_null_expression] = STATE(2242),
    [sym_as_expression] = STATE(2242),
    [sym_jsx_fragment] = STATE(2242),
    [sym_yield_expression] = STATE(2242),
    [sym_jsx_element] = STATE(2242),
    [sym_internal_module] = STATE(2242),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2242),
    [sym_await_expression] = STATE(2242),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(2242),
    [sym_this] = STATE(2242),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(2242),
    [sym_generator_function] = STATE(2242),
    [sym_call_expression] = STATE(2242),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(2242),
    [sym_ternary_expression] = STATE(2242),
    [sym_binary_expression] = STATE(2242),
    [sym_template_string] = STATE(2242),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2242),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2242),
    [sym_class] = STATE(2242),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(2733),
    [sym_false] = ACTIONS(4692),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4692),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4694),
    [sym_true] = ACTIONS(4692),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4692),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [1321] = {
    [sym_union_type] = STATE(2243),
    [sym__type] = STATE(2243),
    [sym_constructor_type] = STATE(2243),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2243),
    [sym_function_type] = STATE(2243),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1322] = {
    [sym_new_expression] = STATE(2244),
    [sym_augmented_assignment_expression] = STATE(2244),
    [sym_unary_expression] = STATE(2244),
    [sym_update_expression] = STATE(2244),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(2244),
    [sym_regex] = STATE(2244),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2244),
    [sym_non_null_expression] = STATE(2244),
    [sym_as_expression] = STATE(2244),
    [sym_jsx_fragment] = STATE(2244),
    [sym_yield_expression] = STATE(2244),
    [sym_jsx_element] = STATE(2244),
    [sym_internal_module] = STATE(2244),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2244),
    [sym_await_expression] = STATE(2244),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(2244),
    [sym_this] = STATE(2244),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(2244),
    [sym_generator_function] = STATE(2244),
    [sym_call_expression] = STATE(2244),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(2244),
    [sym_ternary_expression] = STATE(2244),
    [sym_binary_expression] = STATE(2244),
    [sym_template_string] = STATE(2244),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2244),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2244),
    [sym_class] = STATE(2244),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(2733),
    [sym_false] = ACTIONS(4696),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4696),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4698),
    [sym_true] = ACTIONS(4696),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4696),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [1323] = {
    [sym_identifier] = ACTIONS(4700),
    [sym_comment] = ACTIONS(3),
  },
  [1324] = {
    [sym_new_expression] = STATE(2246),
    [sym_augmented_assignment_expression] = STATE(2246),
    [sym_unary_expression] = STATE(2246),
    [sym_update_expression] = STATE(2246),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(2246),
    [sym_regex] = STATE(2246),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1240),
    [sym__expression] = STATE(2246),
    [sym_non_null_expression] = STATE(2246),
    [sym_yield_expression] = STATE(2246),
    [sym_jsx_fragment] = STATE(2246),
    [sym_jsx_element] = STATE(2246),
    [sym_as_expression] = STATE(2246),
    [sym_internal_module] = STATE(2246),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2246),
    [sym_await_expression] = STATE(2246),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(2246),
    [sym_this] = STATE(2246),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(2246),
    [sym_generator_function] = STATE(2246),
    [sym_call_expression] = STATE(2246),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(2246),
    [sym_ternary_expression] = STATE(2246),
    [sym_binary_expression] = STATE(2246),
    [sym_template_string] = STATE(2246),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2246),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2246),
    [sym_class] = STATE(2246),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(2733),
    [sym_false] = ACTIONS(4702),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4702),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4704),
    [sym_true] = ACTIONS(4702),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4702),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [1325] = {
    [sym_new_expression] = STATE(2247),
    [sym_augmented_assignment_expression] = STATE(2247),
    [sym_unary_expression] = STATE(2247),
    [sym_update_expression] = STATE(2247),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(2247),
    [sym_regex] = STATE(2247),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2247),
    [sym_non_null_expression] = STATE(2247),
    [sym_as_expression] = STATE(2247),
    [sym_jsx_fragment] = STATE(2247),
    [sym_yield_expression] = STATE(2247),
    [sym_jsx_element] = STATE(2247),
    [sym_internal_module] = STATE(2247),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2247),
    [sym_await_expression] = STATE(2247),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(2247),
    [sym_this] = STATE(2247),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(2247),
    [sym_generator_function] = STATE(2247),
    [sym_call_expression] = STATE(2247),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(2247),
    [sym_ternary_expression] = STATE(2247),
    [sym_binary_expression] = STATE(2247),
    [sym_template_string] = STATE(2247),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2247),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2247),
    [sym_class] = STATE(2247),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(2733),
    [sym_false] = ACTIONS(4706),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4706),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4708),
    [sym_true] = ACTIONS(4706),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4706),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [1326] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2714),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2714),
    [anon_sym_AMP_EQ] = ACTIONS(2714),
    [anon_sym_PLUS_EQ] = ACTIONS(2714),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(2718),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2714),
    [anon_sym_STAR_EQ] = ACTIONS(2714),
    [anon_sym_PIPE_EQ] = ACTIONS(2714),
    [anon_sym_DASH_EQ] = ACTIONS(2714),
    [anon_sym_EQ_GT] = ACTIONS(2720),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2714),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2714),
    [anon_sym_GT_GT_EQ] = ACTIONS(2714),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2714),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2727),
  },
  [1327] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(4710),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_implements] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [1328] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(4710),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_implements] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [1329] = {
    [anon_sym_EQ_GT] = ACTIONS(4713),
    [sym_comment] = ACTIONS(3),
  },
  [1330] = {
    [anon_sym_EQ_GT] = ACTIONS(4715),
    [sym_comment] = ACTIONS(3),
  },
  [1331] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_BQUOTE] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_instanceof] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_implements] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_in] = ACTIONS(841),
  },
  [1332] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2773),
    [anon_sym_COMMA] = ACTIONS(871),
    [anon_sym_LT_LT] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_GT_GT_GT] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_BANG_EQ] = ACTIONS(2727),
    [anon_sym_LT_EQ] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_QMARK] = ACTIONS(2789),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2727),
    [anon_sym_instanceof] = ACTIONS(2771),
    [anon_sym_LT] = ACTIONS(2795),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_STAR_STAR] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_implements] = ACTIONS(871),
    [anon_sym_GT_GT] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2771),
    [anon_sym_in] = ACTIONS(2727),
  },
  [1333] = {
    [anon_sym_SLASH2] = ACTIONS(4717),
    [sym_comment] = ACTIONS(3),
  },
  [1334] = {
    [sym__initializer] = STATE(522),
    [sym_arguments] = STATE(1268),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(2720),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1531),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_implements] = ACTIONS(1529),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [1335] = {
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_implements] = ACTIONS(1539),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [1336] = {
    [sym_new_expression] = STATE(836),
    [sym_augmented_assignment_expression] = STATE(836),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(836),
    [sym_update_expression] = STATE(836),
    [sym_regex] = STATE(836),
    [sym_meta_property] = STATE(836),
    [sym_call_signature] = STATE(835),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(836),
    [sym_non_null_expression] = STATE(836),
    [sym_yield_expression] = STATE(836),
    [sym_jsx_fragment] = STATE(836),
    [sym_jsx_element] = STATE(836),
    [sym_as_expression] = STATE(836),
    [sym_internal_module] = STATE(836),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(836),
    [sym_await_expression] = STATE(836),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(836),
    [sym_this] = STATE(836),
    [sym_arguments] = STATE(1270),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(836),
    [sym_generator_function] = STATE(836),
    [sym_call_expression] = STATE(836),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(836),
    [sym_ternary_expression] = STATE(836),
    [sym_binary_expression] = STATE(836),
    [sym_template_string] = STATE(836),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(836),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(836),
    [sym_class] = STATE(836),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(500),
    [sym_true] = ACTIONS(1545),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [sym_false] = ACTIONS(1545),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [sym_null] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [sym_number] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_implements] = ACTIONS(1541),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [1337] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_arguments] = STATE(1270),
    [sym_call_signature] = STATE(1329),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(2743),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(2745),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(2745),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(2745),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(2745),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_protected] = ACTIONS(2745),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(2745),
    [anon_sym_type] = ACTIONS(2745),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(2745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(2745),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(2745),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(2745),
    [anon_sym_declare] = ACTIONS(2745),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(2745),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(2745),
    [anon_sym_async] = ACTIONS(2745),
    [anon_sym_public] = ACTIONS(2745),
    [anon_sym_EQ_GT] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(2745),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_implements] = ACTIONS(1541),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(2745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [1338] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1539),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_implements] = ACTIONS(1541),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [1339] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2773),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(915),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_GT_GT_GT] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_BANG_EQ] = ACTIONS(2727),
    [anon_sym_LT_EQ] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_QMARK] = ACTIONS(2789),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2727),
    [anon_sym_instanceof] = ACTIONS(2771),
    [anon_sym_LT] = ACTIONS(2795),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_STAR_STAR] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_implements] = ACTIONS(915),
    [anon_sym_GT_GT] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2771),
    [anon_sym_in] = ACTIONS(2727),
  },
  [1340] = {
    [sym_new_expression] = STATE(2251),
    [sym_augmented_assignment_expression] = STATE(2251),
    [sym_unary_expression] = STATE(2251),
    [sym_update_expression] = STATE(2251),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(2251),
    [sym_regex] = STATE(2251),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2251),
    [sym_non_null_expression] = STATE(2251),
    [sym_as_expression] = STATE(2251),
    [sym_jsx_fragment] = STATE(2251),
    [sym_yield_expression] = STATE(2251),
    [sym_jsx_element] = STATE(2251),
    [sym_internal_module] = STATE(2251),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2251),
    [sym_await_expression] = STATE(2251),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(2251),
    [sym_this] = STATE(2251),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(2251),
    [sym_generator_function] = STATE(2251),
    [sym_call_expression] = STATE(2251),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(2251),
    [sym_ternary_expression] = STATE(2251),
    [sym_binary_expression] = STATE(2251),
    [sym_template_string] = STATE(2251),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2251),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2251),
    [sym_class] = STATE(2251),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(2733),
    [sym_false] = ACTIONS(4719),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4719),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4721),
    [sym_true] = ACTIONS(4719),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4719),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [1341] = {
    [sym_new_expression] = STATE(2252),
    [sym_augmented_assignment_expression] = STATE(2252),
    [sym_unary_expression] = STATE(2252),
    [sym_update_expression] = STATE(2252),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(2252),
    [sym_regex] = STATE(2252),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2252),
    [sym_non_null_expression] = STATE(2252),
    [sym_as_expression] = STATE(2252),
    [sym_jsx_fragment] = STATE(2252),
    [sym_yield_expression] = STATE(2252),
    [sym_jsx_element] = STATE(2252),
    [sym_internal_module] = STATE(2252),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2252),
    [sym_await_expression] = STATE(2252),
    [sym_member_expression] = STATE(612),
    [sym_generic_type] = STATE(2253),
    [sym_string] = STATE(2252),
    [sym_this] = STATE(2252),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_nested_type_identifier] = STATE(614),
    [sym_anonymous_class] = STATE(2252),
    [sym_generator_function] = STATE(2252),
    [sym_call_expression] = STATE(2252),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(2252),
    [sym_ternary_expression] = STATE(2252),
    [sym_binary_expression] = STATE(2252),
    [sym_template_string] = STATE(2252),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2252),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2252),
    [sym__type_reference] = STATE(2253),
    [sym_class] = STATE(2252),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1093),
    [sym_false] = ACTIONS(4723),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4723),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4725),
    [sym_true] = ACTIONS(4723),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4723),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [1342] = {
    [sym_new_expression] = STATE(2254),
    [sym_augmented_assignment_expression] = STATE(2254),
    [sym_unary_expression] = STATE(2254),
    [sym_update_expression] = STATE(2254),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(2254),
    [sym_regex] = STATE(2254),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2254),
    [sym_non_null_expression] = STATE(2254),
    [sym_as_expression] = STATE(2254),
    [sym_jsx_fragment] = STATE(2254),
    [sym_yield_expression] = STATE(2254),
    [sym_jsx_element] = STATE(2254),
    [sym_internal_module] = STATE(2254),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2254),
    [sym_await_expression] = STATE(2254),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(2254),
    [sym_this] = STATE(2254),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(2254),
    [sym_generator_function] = STATE(2254),
    [sym_call_expression] = STATE(2254),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(2254),
    [sym_ternary_expression] = STATE(2254),
    [sym_binary_expression] = STATE(2254),
    [sym_template_string] = STATE(2254),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2254),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2254),
    [sym_class] = STATE(2254),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(2733),
    [sym_false] = ACTIONS(4727),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4727),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4729),
    [sym_true] = ACTIONS(4727),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4727),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [1343] = {
    [sym_new_expression] = STATE(2255),
    [sym_augmented_assignment_expression] = STATE(2255),
    [sym_unary_expression] = STATE(2255),
    [sym_update_expression] = STATE(2255),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(2255),
    [sym_regex] = STATE(2255),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2255),
    [sym_non_null_expression] = STATE(2255),
    [sym_as_expression] = STATE(2255),
    [sym_jsx_fragment] = STATE(2255),
    [sym_yield_expression] = STATE(2255),
    [sym_jsx_element] = STATE(2255),
    [sym_internal_module] = STATE(2255),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2255),
    [sym_await_expression] = STATE(2255),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(2255),
    [sym_this] = STATE(2255),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(2255),
    [sym_generator_function] = STATE(2255),
    [sym_call_expression] = STATE(2255),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(2255),
    [sym_ternary_expression] = STATE(2255),
    [sym_binary_expression] = STATE(2255),
    [sym_template_string] = STATE(2255),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2255),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2255),
    [sym_class] = STATE(2255),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(2733),
    [sym_false] = ACTIONS(4731),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4731),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4733),
    [sym_true] = ACTIONS(4731),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4731),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [1344] = {
    [sym_new_expression] = STATE(2256),
    [sym_augmented_assignment_expression] = STATE(2256),
    [sym_unary_expression] = STATE(2256),
    [sym_update_expression] = STATE(2256),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(2256),
    [sym_regex] = STATE(2256),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2256),
    [sym_non_null_expression] = STATE(2256),
    [sym_as_expression] = STATE(2256),
    [sym_jsx_fragment] = STATE(2256),
    [sym_yield_expression] = STATE(2256),
    [sym_jsx_element] = STATE(2256),
    [sym_internal_module] = STATE(2256),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2256),
    [sym_await_expression] = STATE(2256),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(2256),
    [sym_this] = STATE(2256),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(2256),
    [sym_generator_function] = STATE(2256),
    [sym_call_expression] = STATE(2256),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(2256),
    [sym_ternary_expression] = STATE(2256),
    [sym_binary_expression] = STATE(2256),
    [sym_template_string] = STATE(2256),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2256),
    [sym_class] = STATE(2256),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(2733),
    [sym_false] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4735),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4737),
    [sym_true] = ACTIONS(4735),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4735),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [1345] = {
    [sym_new_expression] = STATE(2257),
    [sym_augmented_assignment_expression] = STATE(2257),
    [sym_unary_expression] = STATE(2257),
    [sym_update_expression] = STATE(2257),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(2257),
    [sym_regex] = STATE(2257),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2257),
    [sym_non_null_expression] = STATE(2257),
    [sym_as_expression] = STATE(2257),
    [sym_jsx_fragment] = STATE(2257),
    [sym_yield_expression] = STATE(2257),
    [sym_jsx_element] = STATE(2257),
    [sym_internal_module] = STATE(2257),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2257),
    [sym_await_expression] = STATE(2257),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(2257),
    [sym_this] = STATE(2257),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(2257),
    [sym_generator_function] = STATE(2257),
    [sym_call_expression] = STATE(2257),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(2257),
    [sym_ternary_expression] = STATE(2257),
    [sym_binary_expression] = STATE(2257),
    [sym_template_string] = STATE(2257),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2257),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2257),
    [sym_class] = STATE(2257),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(4739),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4739),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4741),
    [sym_true] = ACTIONS(4739),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4739),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [1346] = {
    [sym_union_type] = STATE(1293),
    [sym__type] = STATE(1293),
    [sym_constructor_type] = STATE(1293),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2263),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_template_string] = STATE(1297),
    [sym_intersection_type] = STATE(1293),
    [sym_function_type] = STATE(1293),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2264),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(4743),
    [sym_false] = ACTIONS(2643),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_PIPE] = ACTIONS(4745),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_boolean] = ACTIONS(2647),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(4747),
    [anon_sym_QMARK] = ACTIONS(4749),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2669),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_new] = ACTIONS(4751),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_DQUOTE] = ACTIONS(304),
  },
  [1347] = {
    [sym_new_expression] = STATE(2241),
    [sym_constructor_type] = STATE(432),
    [sym_augmented_assignment_expression] = STATE(2241),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(2241),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(2241),
    [sym_type_parameters] = STATE(959),
    [sym_array_type] = STATE(436),
    [sym_yield_expression] = STATE(2241),
    [sym_as_expression] = STATE(2241),
    [sym_jsx_fragment] = STATE(2241),
    [sym_internal_module] = STATE(2241),
    [sym_arrow_function] = STATE(2241),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(612),
    [sym_literal_type] = STATE(436),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(1301),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(2241),
    [sym_subscript_expression] = STATE(612),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(2241),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(2241),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(960),
    [sym_function_type] = STATE(432),
    [sym__type] = STATE(432),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(2241),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(2241),
    [sym__expression] = STATE(2241),
    [sym_non_null_expression] = STATE(2241),
    [sym_jsx_element] = STATE(2241),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_await_expression] = STATE(2241),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_this] = STATE(2241),
    [sym_union_type] = STATE(432),
    [sym_anonymous_class] = STATE(2241),
    [sym_call_expression] = STATE(2241),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(2241),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(2241),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(432),
    [sym_parenthesized_expression] = STATE(2241),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2241),
    [sym_class] = STATE(2241),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(4753),
    [sym_false] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(4755),
    [anon_sym_number] = ACTIONS(4755),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(4757),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4759),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_void] = ACTIONS(4761),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [sym_null] = ACTIONS(4688),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4755),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(4755),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2691),
    [sym_true] = ACTIONS(2677),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(2693),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(4755),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4688),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(4763),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(4759),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [1348] = {
    [sym_new_expression] = STATE(2271),
    [sym_augmented_assignment_expression] = STATE(2271),
    [sym_unary_expression] = STATE(2271),
    [sym_update_expression] = STATE(2271),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(2271),
    [sym_regex] = STATE(2271),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2271),
    [sym_non_null_expression] = STATE(2271),
    [sym_as_expression] = STATE(2271),
    [sym_jsx_fragment] = STATE(2271),
    [sym_yield_expression] = STATE(2271),
    [sym_jsx_element] = STATE(2271),
    [sym_internal_module] = STATE(2271),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2271),
    [sym_await_expression] = STATE(2271),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(2271),
    [sym_this] = STATE(2271),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(2271),
    [sym_generator_function] = STATE(2271),
    [sym_call_expression] = STATE(2271),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(2271),
    [sym_ternary_expression] = STATE(2271),
    [sym_binary_expression] = STATE(2271),
    [sym_template_string] = STATE(2271),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2271),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2271),
    [sym_class] = STATE(2271),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(2733),
    [sym_false] = ACTIONS(4765),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4765),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4767),
    [sym_true] = ACTIONS(4765),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4765),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [1349] = {
    [aux_sym_extends_clause_repeat1] = STATE(2272),
    [anon_sym_implements] = ACTIONS(4769),
    [anon_sym_COMMA] = ACTIONS(2777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4769),
  },
  [1350] = {
    [sym_union_type] = STATE(2276),
    [sym__type] = STATE(2276),
    [sym_constructor_type] = STATE(2276),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2277),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2276),
    [sym_function_type] = STATE(2276),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2278),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1121),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4771),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4773),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1351] = {
    [sym_formal_parameters] = STATE(2279),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1352] = {
    [anon_sym_EQ_GT] = ACTIONS(4777),
    [sym_comment] = ACTIONS(3),
  },
  [1353] = {
    [sym_union_type] = STATE(2281),
    [sym__type] = STATE(2281),
    [sym_constructor_type] = STATE(2281),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(623),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2281),
    [sym_function_type] = STATE(2281),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(624),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1121),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1354] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(623),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(624),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1121),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1355] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(623),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(624),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1121),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1356] = {
    [aux_sym_implements_clause_repeat1] = STATE(2282),
    [anon_sym_COMMA] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4779),
  },
  [1357] = {
    [anon_sym_EQ_GT] = ACTIONS(4781),
    [sym_comment] = ACTIONS(3),
  },
  [1358] = {
    [sym_union_type] = STATE(2284),
    [sym__type] = STATE(2284),
    [sym_constructor_type] = STATE(2284),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(623),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2284),
    [sym_function_type] = STATE(2284),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(624),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1121),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1359] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4783),
    [sym_identifier] = ACTIONS(4785),
    [sym__automatic_semicolon] = ACTIONS(4783),
    [anon_sym_BQUOTE] = ACTIONS(4783),
    [anon_sym_debugger] = ACTIONS(4785),
    [ts_builtin_sym_end] = ACTIONS(4783),
    [anon_sym_symbol] = ACTIONS(4785),
    [anon_sym_AT] = ACTIONS(4783),
    [anon_sym_PIPE] = ACTIONS(4785),
    [anon_sym_COMMA] = ACTIONS(4783),
    [anon_sym_DASH] = ACTIONS(4785),
    [anon_sym_STAR] = ACTIONS(4785),
    [anon_sym_GT_GT_GT] = ACTIONS(4783),
    [anon_sym_void] = ACTIONS(4785),
    [anon_sym_break] = ACTIONS(4785),
    [anon_sym_BANG_EQ] = ACTIONS(4785),
    [anon_sym_const] = ACTIONS(4785),
    [anon_sym_GT_EQ] = ACTIONS(4783),
    [sym_super] = ACTIONS(4785),
    [anon_sym_return] = ACTIONS(4785),
    [anon_sym_private] = ACTIONS(4785),
    [anon_sym_get] = ACTIONS(4785),
    [anon_sym_RBRACE] = ACTIONS(4783),
    [anon_sym_PERCENT] = ACTIONS(4783),
    [anon_sym_interface] = ACTIONS(4785),
    [anon_sym_default] = ACTIONS(4785),
    [anon_sym_as] = ACTIONS(4785),
    [anon_sym_delete] = ACTIONS(4785),
    [anon_sym_continue] = ACTIONS(4785),
    [anon_sym_DASH_DASH] = ACTIONS(4783),
    [anon_sym_if] = ACTIONS(4785),
    [anon_sym_instanceof] = ACTIONS(4785),
    [anon_sym_this] = ACTIONS(4785),
    [anon_sym_yield] = ACTIONS(4785),
    [sym_true] = ACTIONS(4785),
    [anon_sym_throw] = ACTIONS(4785),
    [anon_sym_enum] = ACTIONS(4785),
    [anon_sym_protected] = ACTIONS(4785),
    [anon_sym_abstract] = ACTIONS(4785),
    [anon_sym_DOT] = ACTIONS(4785),
    [anon_sym_set] = ACTIONS(4785),
    [anon_sym_type] = ACTIONS(4785),
    [anon_sym_STAR_STAR] = ACTIONS(4783),
    [anon_sym_import] = ACTIONS(4785),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4783),
    [anon_sym_namespace] = ACTIONS(4785),
    [anon_sym_PLUS_PLUS] = ACTIONS(4783),
    [anon_sym_await] = ACTIONS(4785),
    [anon_sym_DQUOTE] = ACTIONS(4783),
    [anon_sym_else] = ACTIONS(4785),
    [anon_sym_BANG] = ACTIONS(4785),
    [anon_sym_for] = ACTIONS(4785),
    [anon_sym_LBRACK] = ACTIONS(4783),
    [sym_false] = ACTIONS(4785),
    [anon_sym_SEMI] = ACTIONS(4783),
    [anon_sym_case] = ACTIONS(4785),
    [anon_sym_module] = ACTIONS(4785),
    [anon_sym_number] = ACTIONS(4785),
    [anon_sym_class] = ACTIONS(4785),
    [anon_sym_declare] = ACTIONS(4785),
    [anon_sym_typeof] = ACTIONS(4785),
    [anon_sym_LT_LT] = ACTIONS(4783),
    [anon_sym_LBRACE] = ACTIONS(4783),
    [anon_sym_AMP_AMP] = ACTIONS(4783),
    [anon_sym_switch] = ACTIONS(4785),
    [anon_sym_LT_EQ] = ACTIONS(4783),
    [anon_sym_LPAREN] = ACTIONS(4783),
    [sym_null] = ACTIONS(4785),
    [anon_sym_GT] = ACTIONS(4785),
    [anon_sym_any] = ACTIONS(4785),
    [anon_sym_boolean] = ACTIONS(4785),
    [anon_sym_async] = ACTIONS(4785),
    [anon_sym_public] = ACTIONS(4785),
    [anon_sym_AMP] = ACTIONS(4785),
    [anon_sym_var] = ACTIONS(4785),
    [anon_sym_QMARK] = ACTIONS(4783),
    [anon_sym_PIPE_PIPE] = ACTIONS(4783),
    [anon_sym_while] = ACTIONS(4785),
    [anon_sym_SQUOTE] = ACTIONS(4783),
    [anon_sym_try] = ACTIONS(4785),
    [anon_sym_EQ_EQ] = ACTIONS(4785),
    [anon_sym_RPAREN] = ACTIONS(4783),
    [anon_sym_LT] = ACTIONS(4785),
    [sym_number] = ACTIONS(4783),
    [anon_sym_SLASH] = ACTIONS(4785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4785),
    [anon_sym_function] = ACTIONS(4785),
    [sym_undefined] = ACTIONS(4785),
    [anon_sym_new] = ACTIONS(4785),
    [anon_sym_CARET] = ACTIONS(4783),
    [anon_sym_let] = ACTIONS(4785),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_export] = ACTIONS(4785),
    [anon_sym_GT_GT] = ACTIONS(4785),
    [anon_sym_do] = ACTIONS(4785),
    [anon_sym_TILDE] = ACTIONS(4783),
    [anon_sym_with] = ACTIONS(4785),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4783),
    [anon_sym_in] = ACTIONS(4785),
  },
  [1360] = {
    [sym_class_body] = STATE(2285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(322),
  },
  [1361] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4787),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4787),
    [anon_sym_AMP_EQ] = ACTIONS(4787),
    [anon_sym_PLUS_EQ] = ACTIONS(4787),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4787),
    [anon_sym_STAR_EQ] = ACTIONS(4787),
    [anon_sym_PIPE_EQ] = ACTIONS(4787),
    [anon_sym_DASH_EQ] = ACTIONS(4787),
    [anon_sym_EQ_GT] = ACTIONS(4791),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4787),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4793),
    [anon_sym_SLASH_EQ] = ACTIONS(4787),
    [anon_sym_GT_GT_EQ] = ACTIONS(4787),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4787),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4795),
  },
  [1362] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_AMP_EQ] = ACTIONS(4797),
    [anon_sym_PLUS_EQ] = ACTIONS(4797),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4797),
    [anon_sym_STAR_EQ] = ACTIONS(4797),
    [anon_sym_PIPE_EQ] = ACTIONS(4797),
    [anon_sym_DASH_EQ] = ACTIONS(4797),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4797),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4801),
    [anon_sym_SLASH_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1363] = {
    [sym_new_expression] = STATE(2294),
    [sym_augmented_assignment_expression] = STATE(2294),
    [sym_unary_expression] = STATE(2294),
    [sym_update_expression] = STATE(2294),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(2294),
    [sym_regex] = STATE(2294),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2294),
    [sym_non_null_expression] = STATE(2294),
    [sym_as_expression] = STATE(2294),
    [sym_jsx_fragment] = STATE(2294),
    [sym_yield_expression] = STATE(2294),
    [sym_jsx_element] = STATE(2294),
    [sym_internal_module] = STATE(2294),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2294),
    [sym_await_expression] = STATE(2294),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(2294),
    [sym_this] = STATE(2294),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(2294),
    [sym_generator_function] = STATE(2294),
    [sym_call_expression] = STATE(2294),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(2294),
    [sym_ternary_expression] = STATE(2294),
    [sym_binary_expression] = STATE(2294),
    [sym_template_string] = STATE(2294),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2294),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2294),
    [sym_class] = STATE(2294),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(4803),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4803),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4805),
    [sym_true] = ACTIONS(4803),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4803),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [1364] = {
    [sym_new_expression] = STATE(2295),
    [sym_augmented_assignment_expression] = STATE(2295),
    [sym_unary_expression] = STATE(2295),
    [sym_update_expression] = STATE(2295),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(2295),
    [sym_regex] = STATE(2295),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2295),
    [sym_non_null_expression] = STATE(2295),
    [sym_as_expression] = STATE(2295),
    [sym_jsx_fragment] = STATE(2295),
    [sym_yield_expression] = STATE(2295),
    [sym_jsx_element] = STATE(2295),
    [sym_internal_module] = STATE(2295),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2295),
    [sym_await_expression] = STATE(2295),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(2295),
    [sym_this] = STATE(2295),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(2295),
    [sym_generator_function] = STATE(2295),
    [sym_call_expression] = STATE(2295),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(2295),
    [sym_ternary_expression] = STATE(2295),
    [sym_binary_expression] = STATE(2295),
    [sym_template_string] = STATE(2295),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2295),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2295),
    [sym_class] = STATE(2295),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(4807),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4807),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4809),
    [sym_true] = ACTIONS(4807),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4807),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [1365] = {
    [sym_new_expression] = STATE(2294),
    [sym_augmented_assignment_expression] = STATE(2294),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(2294),
    [sym_update_expression] = STATE(2294),
    [sym_regex] = STATE(2294),
    [sym_meta_property] = STATE(2294),
    [sym_call_signature] = STATE(1372),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2294),
    [sym_non_null_expression] = STATE(2294),
    [sym_yield_expression] = STATE(2294),
    [sym_jsx_fragment] = STATE(2294),
    [sym_jsx_element] = STATE(2294),
    [sym_as_expression] = STATE(2294),
    [sym_internal_module] = STATE(2294),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2294),
    [sym_await_expression] = STATE(2294),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(2294),
    [sym_this] = STATE(2294),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(2294),
    [sym_generator_function] = STATE(2294),
    [sym_call_expression] = STATE(2294),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(2294),
    [sym_ternary_expression] = STATE(2294),
    [sym_binary_expression] = STATE(2294),
    [sym_template_string] = STATE(2294),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2294),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2294),
    [sym_class] = STATE(2294),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2968),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4797),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_AMP_EQ] = ACTIONS(4797),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4797),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(4797),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_PIPE_EQ] = ACTIONS(4797),
    [anon_sym_DASH_EQ] = ACTIONS(4797),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4797),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(2839),
    [sym_true] = ACTIONS(4803),
    [anon_sym_COLON] = ACTIONS(4801),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4797),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(4803),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(135),
    [sym_null] = ACTIONS(4803),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_STAR_EQ] = ACTIONS(4797),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(4805),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4797),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4803),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1366] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_call_signature] = STATE(2296),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4811),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4797),
    [anon_sym_symbol] = ACTIONS(4813),
    [anon_sym_AMP_EQ] = ACTIONS(4797),
    [anon_sym_PLUS_EQ] = ACTIONS(4797),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_void] = ACTIONS(4813),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(4797),
    [anon_sym_private] = ACTIONS(4813),
    [anon_sym_PIPE_EQ] = ACTIONS(4797),
    [anon_sym_DASH_EQ] = ACTIONS(4797),
    [anon_sym_get] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4797),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(4801),
    [anon_sym_protected] = ACTIONS(4813),
    [anon_sym_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(4813),
    [anon_sym_type] = ACTIONS(4813),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(4813),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4797),
    [anon_sym_namespace] = ACTIONS(4813),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(4813),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_number] = ACTIONS(4813),
    [anon_sym_declare] = ACTIONS(4813),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(4813),
    [anon_sym_STAR_EQ] = ACTIONS(4797),
    [anon_sym_boolean] = ACTIONS(4813),
    [anon_sym_async] = ACTIONS(4813),
    [anon_sym_public] = ACTIONS(4813),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4797),
    [anon_sym_string] = ACTIONS(4813),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(4813),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1367] = {
    [sym_new_expression] = STATE(2298),
    [sym_augmented_assignment_expression] = STATE(2298),
    [sym_unary_expression] = STATE(2298),
    [sym_update_expression] = STATE(2298),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(2298),
    [sym_regex] = STATE(2298),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2298),
    [sym_non_null_expression] = STATE(2298),
    [sym_as_expression] = STATE(2298),
    [sym_jsx_fragment] = STATE(2298),
    [sym_yield_expression] = STATE(2298),
    [sym_jsx_element] = STATE(2298),
    [sym_internal_module] = STATE(2298),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2298),
    [sym_await_expression] = STATE(2298),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(2298),
    [sym_this] = STATE(2298),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(2298),
    [sym_generator_function] = STATE(2298),
    [sym_call_expression] = STATE(2298),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(2298),
    [sym_ternary_expression] = STATE(2298),
    [sym_binary_expression] = STATE(2298),
    [sym_template_string] = STATE(2298),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2298),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2298),
    [sym_class] = STATE(2298),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(4815),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4815),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4817),
    [sym_true] = ACTIONS(4815),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4815),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [1368] = {
    [sym_new_expression] = STATE(2299),
    [sym_augmented_assignment_expression] = STATE(2299),
    [sym_unary_expression] = STATE(2299),
    [sym_update_expression] = STATE(2299),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(2299),
    [sym_regex] = STATE(2299),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2299),
    [sym_non_null_expression] = STATE(2299),
    [sym_as_expression] = STATE(2299),
    [sym_jsx_fragment] = STATE(2299),
    [sym_yield_expression] = STATE(2299),
    [sym_jsx_element] = STATE(2299),
    [sym_internal_module] = STATE(2299),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2299),
    [sym_await_expression] = STATE(2299),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(2299),
    [sym_this] = STATE(2299),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(2299),
    [sym_generator_function] = STATE(2299),
    [sym_call_expression] = STATE(2299),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(2299),
    [sym_ternary_expression] = STATE(2299),
    [sym_binary_expression] = STATE(2299),
    [sym_template_string] = STATE(2299),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2299),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2299),
    [sym_class] = STATE(2299),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(2968),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(2839),
    [sym_true] = ACTIONS(4819),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(4819),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(211),
    [sym_null] = ACTIONS(4819),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(4821),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4819),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [1369] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(4823),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(4825),
    [anon_sym_symbol] = ACTIONS(4825),
    [anon_sym_number] = ACTIONS(4825),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4825),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4827),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4825),
    [anon_sym_private] = ACTIONS(4825),
    [anon_sym_boolean] = ACTIONS(4825),
    [anon_sym_async] = ACTIONS(4829),
    [anon_sym_public] = ACTIONS(4825),
    [anon_sym_get] = ACTIONS(4825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4825),
    [anon_sym_string] = ACTIONS(4825),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(4825),
    [anon_sym_type] = ACTIONS(4825),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(4825),
    [anon_sym_export] = ACTIONS(4825),
    [anon_sym_namespace] = ACTIONS(4831),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [1370] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_AMP_EQ] = ACTIONS(4797),
    [anon_sym_PLUS_EQ] = ACTIONS(4797),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4797),
    [anon_sym_STAR_EQ] = ACTIONS(4797),
    [anon_sym_PIPE_EQ] = ACTIONS(4797),
    [anon_sym_DASH_EQ] = ACTIONS(4797),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4797),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4801),
    [anon_sym_SLASH_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1371] = {
    [sym_new_expression] = STATE(2305),
    [sym_augmented_assignment_expression] = STATE(2305),
    [sym_unary_expression] = STATE(2305),
    [sym_update_expression] = STATE(2305),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(2305),
    [sym_regex] = STATE(2305),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2305),
    [sym_non_null_expression] = STATE(2305),
    [sym_as_expression] = STATE(2305),
    [sym_jsx_fragment] = STATE(2305),
    [sym_yield_expression] = STATE(2305),
    [sym_jsx_element] = STATE(2305),
    [sym_internal_module] = STATE(2305),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2305),
    [sym_await_expression] = STATE(2305),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(2305),
    [sym_this] = STATE(2305),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(2305),
    [sym_generator_function] = STATE(2305),
    [sym_call_expression] = STATE(2305),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(2305),
    [sym_ternary_expression] = STATE(2305),
    [sym_binary_expression] = STATE(2305),
    [sym_template_string] = STATE(2305),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2305),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2305),
    [sym_class] = STATE(2305),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(4833),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4833),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4835),
    [sym_true] = ACTIONS(4833),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4833),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [1372] = {
    [anon_sym_EQ_GT] = ACTIONS(4791),
    [sym_comment] = ACTIONS(3),
  },
  [1373] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(4795),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4839),
    [anon_sym_LT_LT] = ACTIONS(4841),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_GT_GT_GT] = ACTIONS(4841),
    [anon_sym_AMP_AMP] = ACTIONS(4847),
    [anon_sym_BANG_EQ] = ACTIONS(4795),
    [anon_sym_LT_EQ] = ACTIONS(4837),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(4837),
    [anon_sym_RBRACK] = ACTIONS(4849),
    [anon_sym_GT] = ACTIONS(4795),
    [anon_sym_AMP] = ACTIONS(4851),
    [anon_sym_PERCENT] = ACTIONS(4841),
    [anon_sym_QMARK] = ACTIONS(4853),
    [anon_sym_PIPE_PIPE] = ACTIONS(4855),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4795),
    [anon_sym_instanceof] = ACTIONS(4837),
    [anon_sym_LT] = ACTIONS(4859),
    [anon_sym_SLASH] = ACTIONS(4845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4855),
    [anon_sym_STAR_STAR] = ACTIONS(4861),
    [anon_sym_PLUS] = ACTIONS(4843),
    [anon_sym_GT_GT] = ACTIONS(4845),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4837),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [1374] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4787),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4787),
    [anon_sym_AMP_EQ] = ACTIONS(4787),
    [anon_sym_PLUS_EQ] = ACTIONS(4787),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4787),
    [anon_sym_STAR_EQ] = ACTIONS(4787),
    [anon_sym_PIPE_EQ] = ACTIONS(4787),
    [anon_sym_DASH_EQ] = ACTIONS(4787),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4787),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4787),
    [anon_sym_GT_GT_EQ] = ACTIONS(4787),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4787),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [1375] = {
    [sym__initializer] = STATE(587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4795),
  },
  [1376] = {
    [sym__initializer] = STATE(589),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4795),
  },
  [1377] = {
    [sym_type_parameters] = STATE(1395),
    [sym_formal_parameters] = STATE(1397),
    [sym_call_signature] = STATE(2316),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(4863),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [1378] = {
    [sym_string] = STATE(2317),
    [sym__property_name] = STATE(2317),
    [sym_computed_property_name] = STATE(2317),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(4865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [1379] = {
    [sym_string] = STATE(2317),
    [sym__property_name] = STATE(2317),
    [sym_computed_property_name] = STATE(2317),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(4865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [1380] = {
    [sym_string] = STATE(2317),
    [sym__property_name] = STATE(2317),
    [sym_computed_property_name] = STATE(2317),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_EQ] = ACTIONS(1214),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(4865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_BANG] = ACTIONS(1214),
  },
  [1381] = {
    [sym_new_expression] = STATE(1373),
    [sym_augmented_assignment_expression] = STATE(1373),
    [sym_unary_expression] = STATE(1373),
    [sym_update_expression] = STATE(1373),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(1373),
    [sym_regex] = STATE(1373),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1373),
    [sym_non_null_expression] = STATE(1373),
    [sym_as_expression] = STATE(1373),
    [sym_jsx_fragment] = STATE(1373),
    [sym_yield_expression] = STATE(1373),
    [sym_jsx_element] = STATE(1373),
    [sym_internal_module] = STATE(1373),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1373),
    [sym_await_expression] = STATE(1373),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(1373),
    [sym_this] = STATE(1373),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(1373),
    [sym_generator_function] = STATE(1373),
    [sym_call_expression] = STATE(1373),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(1373),
    [sym_ternary_expression] = STATE(1373),
    [sym_binary_expression] = STATE(1373),
    [sym_template_string] = STATE(1373),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1373),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1373),
    [sym_class] = STATE(1373),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(2823),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2823),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2837),
    [sym_true] = ACTIONS(2823),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2823),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [1382] = {
    [sym_string] = STATE(2321),
    [sym__property_name] = STATE(2321),
    [sym_computed_property_name] = STATE(2321),
    [anon_sym_get] = ACTIONS(4867),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(4869),
    [anon_sym_STAR] = ACTIONS(4871),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(4867),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_async] = ACTIONS(4873),
  },
  [1383] = {
    [sym_string] = STATE(2317),
    [sym__property_name] = STATE(2317),
    [sym_computed_property_name] = STATE(2317),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(4871),
    [anon_sym_EQ] = ACTIONS(1214),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(4875),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(4865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(4875),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_BANG] = ACTIONS(1214),
  },
  [1384] = {
    [sym_type_parameters] = STATE(1395),
    [sym__initializer] = STATE(2325),
    [sym_formal_parameters] = STATE(1397),
    [sym_type_annotation] = STATE(2326),
    [sym_call_signature] = STATE(2316),
    [sym__automatic_semicolon] = ACTIONS(4877),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(4877),
    [anon_sym_QMARK] = ACTIONS(4879),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(4877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(4881),
  },
  [1385] = {
    [sym__automatic_semicolon] = ACTIONS(917),
    [anon_sym_LBRACK] = ACTIONS(917),
    [anon_sym_AMP] = ACTIONS(917),
    [anon_sym_SEMI] = ACTIONS(917),
    [anon_sym_QMARK] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(917),
    [anon_sym_COMMA] = ACTIONS(917),
    [anon_sym_PIPE] = ACTIONS(919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_EQ] = ACTIONS(917),
    [anon_sym_COLON] = ACTIONS(917),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_PIPE_RBRACE] = ACTIONS(917),
    [anon_sym_BANG] = ACTIONS(917),
  },
  [1386] = {
    [aux_sym_string_repeat2] = STATE(788),
    [sym_escape_sequence] = ACTIONS(1474),
    [aux_sym_string_token2] = ACTIONS(1474),
    [sym_comment] = ACTIONS(246),
    [anon_sym_SQUOTE] = ACTIONS(4883),
  },
  [1387] = {
    [sym_string] = STATE(2328),
    [sym__property_name] = STATE(2328),
    [sym_computed_property_name] = STATE(2328),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_EQ] = ACTIONS(1214),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(4885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_BANG] = ACTIONS(1214),
  },
  [1388] = {
    [sym_string] = STATE(2329),
    [sym__property_name] = STATE(2329),
    [sym_computed_property_name] = STATE(2329),
    [anon_sym_get] = ACTIONS(1135),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(4887),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_async] = ACTIONS(1135),
  },
  [1389] = {
    [sym_string] = STATE(2328),
    [sym__property_name] = STATE(2328),
    [sym_computed_property_name] = STATE(2328),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(4885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [1390] = {
    [sym_type_parameters] = STATE(2331),
    [sym__initializer] = STATE(2325),
    [sym_formal_parameters] = STATE(2332),
    [sym_type_annotation] = STATE(2326),
    [sym_call_signature] = STATE(2333),
    [sym__automatic_semicolon] = ACTIONS(4877),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(4877),
    [anon_sym_QMARK] = ACTIONS(4889),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(4877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(4881),
  },
  [1391] = {
    [aux_sym_string_repeat1] = STATE(507),
    [sym_escape_sequence] = ACTIONS(921),
    [aux_sym_string_token1] = ACTIONS(921),
    [anon_sym_DQUOTE] = ACTIONS(4883),
    [sym_comment] = ACTIONS(246),
  },
  [1392] = {
    [anon_sym_LBRACK] = ACTIONS(4891),
    [sym_identifier] = ACTIONS(4893),
    [anon_sym_module] = ACTIONS(4893),
    [anon_sym_symbol] = ACTIONS(4893),
    [anon_sym_number] = ACTIONS(4893),
    [anon_sym_AT] = ACTIONS(4891),
    [anon_sym_declare] = ACTIONS(4893),
    [anon_sym_STAR] = ACTIONS(4891),
    [anon_sym_void] = ACTIONS(4893),
    [anon_sym_any] = ACTIONS(4893),
    [anon_sym_private] = ACTIONS(4893),
    [anon_sym_boolean] = ACTIONS(4893),
    [anon_sym_async] = ACTIONS(4893),
    [anon_sym_public] = ACTIONS(4893),
    [anon_sym_get] = ACTIONS(4893),
    [anon_sym_RBRACE] = ACTIONS(4891),
    [anon_sym_static] = ACTIONS(4893),
    [anon_sym_SQUOTE] = ACTIONS(4891),
    [sym_number] = ACTIONS(4891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4893),
    [anon_sym_string] = ACTIONS(4893),
    [anon_sym_abstract] = ACTIONS(4893),
    [anon_sym_set] = ACTIONS(4893),
    [anon_sym_type] = ACTIONS(4893),
    [anon_sym_import] = ACTIONS(4893),
    [anon_sym_export] = ACTIONS(4893),
    [anon_sym_namespace] = ACTIONS(4893),
    [sym_readonly] = ACTIONS(4893),
    [anon_sym_DQUOTE] = ACTIONS(4891),
  },
  [1393] = {
    [sym_type_parameters] = STATE(1395),
    [sym__initializer] = STATE(2325),
    [sym_formal_parameters] = STATE(1397),
    [sym_type_annotation] = STATE(2326),
    [sym_call_signature] = STATE(2316),
    [sym__automatic_semicolon] = ACTIONS(4877),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(4877),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(4877),
    [sym_comment] = ACTIONS(3),
  },
  [1394] = {
    [sym__initializer] = STATE(2325),
    [sym_type_annotation] = STATE(2326),
    [sym__automatic_semicolon] = ACTIONS(4877),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(4877),
    [anon_sym_COMMA] = ACTIONS(4877),
    [sym_comment] = ACTIONS(3),
  },
  [1395] = {
    [sym_formal_parameters] = STATE(2334),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [1396] = {
    [sym__automatic_semicolon] = ACTIONS(4877),
    [anon_sym_SEMI] = ACTIONS(4877),
    [anon_sym_COMMA] = ACTIONS(4877),
    [sym_comment] = ACTIONS(3),
  },
  [1397] = {
    [sym_type_annotation] = STATE(1603),
    [sym__automatic_semicolon] = ACTIONS(548),
    [anon_sym_COLON] = ACTIONS(4895),
    [anon_sym_SEMI] = ACTIONS(548),
    [anon_sym_COMMA] = ACTIONS(548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(548),
  },
  [1398] = {
    [sym__initializer] = STATE(2325),
    [sym__automatic_semicolon] = ACTIONS(4877),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(4877),
    [anon_sym_COMMA] = ACTIONS(4877),
    [sym_comment] = ACTIONS(3),
  },
  [1399] = {
    [sym_statement_block] = STATE(2337),
    [sym__automatic_semicolon] = ACTIONS(4897),
    [anon_sym_SEMI] = ACTIONS(4897),
    [anon_sym_COMMA] = ACTIONS(4897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4899),
  },
  [1400] = {
    [sym_string] = STATE(2321),
    [sym__property_name] = STATE(2321),
    [sym_computed_property_name] = STATE(2321),
    [anon_sym_get] = ACTIONS(4867),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_async] = ACTIONS(4873),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(4869),
    [anon_sym_STAR] = ACTIONS(4871),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(4867),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(4901),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [1401] = {
    [sym_string] = STATE(2321),
    [sym__property_name] = STATE(2321),
    [sym_computed_property_name] = STATE(2321),
    [anon_sym_get] = ACTIONS(4867),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(4869),
    [anon_sym_STAR] = ACTIONS(4871),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(4903),
    [anon_sym_set] = ACTIONS(4867),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_async] = ACTIONS(4873),
  },
  [1402] = {
    [sym_string] = STATE(2342),
    [sym__property_name] = STATE(2342),
    [sym_computed_property_name] = STATE(2342),
    [anon_sym_get] = ACTIONS(4905),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(4907),
    [anon_sym_STAR] = ACTIONS(4909),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(4905),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(4903),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [1403] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4911),
    [sym__automatic_semicolon] = ACTIONS(4911),
    [sym_identifier] = ACTIONS(4913),
    [anon_sym_BQUOTE] = ACTIONS(4911),
    [anon_sym_debugger] = ACTIONS(4913),
    [anon_sym_with] = ACTIONS(4913),
    [anon_sym_symbol] = ACTIONS(4913),
    [anon_sym_AT] = ACTIONS(4911),
    [anon_sym_PIPE] = ACTIONS(4913),
    [anon_sym_COMMA] = ACTIONS(4911),
    [anon_sym_DASH] = ACTIONS(4913),
    [anon_sym_STAR] = ACTIONS(4913),
    [anon_sym_GT_GT_GT] = ACTIONS(4911),
    [anon_sym_void] = ACTIONS(4913),
    [anon_sym_break] = ACTIONS(4913),
    [anon_sym_BANG_EQ] = ACTIONS(4913),
    [anon_sym_const] = ACTIONS(4913),
    [anon_sym_GT_EQ] = ACTIONS(4911),
    [sym_super] = ACTIONS(4913),
    [anon_sym_return] = ACTIONS(4913),
    [anon_sym_private] = ACTIONS(4913),
    [anon_sym_get] = ACTIONS(4913),
    [anon_sym_RBRACE] = ACTIONS(4911),
    [anon_sym_PERCENT] = ACTIONS(4911),
    [anon_sym_interface] = ACTIONS(4913),
    [anon_sym_default] = ACTIONS(4913),
    [anon_sym_as] = ACTIONS(4913),
    [anon_sym_delete] = ACTIONS(4913),
    [anon_sym_continue] = ACTIONS(4913),
    [anon_sym_DASH_DASH] = ACTIONS(4911),
    [anon_sym_if] = ACTIONS(4913),
    [anon_sym_instanceof] = ACTIONS(4913),
    [anon_sym_this] = ACTIONS(4913),
    [anon_sym_yield] = ACTIONS(4913),
    [sym_true] = ACTIONS(4913),
    [anon_sym_throw] = ACTIONS(4913),
    [anon_sym_enum] = ACTIONS(4913),
    [anon_sym_protected] = ACTIONS(4913),
    [anon_sym_abstract] = ACTIONS(4913),
    [anon_sym_DOT] = ACTIONS(4913),
    [anon_sym_set] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(4913),
    [anon_sym_STAR_STAR] = ACTIONS(4911),
    [anon_sym_import] = ACTIONS(4913),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4911),
    [anon_sym_namespace] = ACTIONS(4913),
    [anon_sym_PLUS_PLUS] = ACTIONS(4911),
    [anon_sym_await] = ACTIONS(4913),
    [anon_sym_DQUOTE] = ACTIONS(4911),
    [anon_sym_else] = ACTIONS(4913),
    [anon_sym_BANG] = ACTIONS(4913),
    [anon_sym_for] = ACTIONS(4913),
    [anon_sym_LBRACK] = ACTIONS(4911),
    [sym_false] = ACTIONS(4913),
    [anon_sym_SEMI] = ACTIONS(4911),
    [anon_sym_case] = ACTIONS(4913),
    [anon_sym_module] = ACTIONS(4913),
    [anon_sym_number] = ACTIONS(4913),
    [anon_sym_class] = ACTIONS(4913),
    [anon_sym_declare] = ACTIONS(4913),
    [anon_sym_typeof] = ACTIONS(4913),
    [anon_sym_LT_LT] = ACTIONS(4911),
    [anon_sym_LBRACE] = ACTIONS(4911),
    [anon_sym_AMP_AMP] = ACTIONS(4911),
    [anon_sym_switch] = ACTIONS(4913),
    [anon_sym_LT_EQ] = ACTIONS(4911),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_null] = ACTIONS(4913),
    [anon_sym_GT] = ACTIONS(4913),
    [anon_sym_any] = ACTIONS(4913),
    [anon_sym_boolean] = ACTIONS(4913),
    [anon_sym_async] = ACTIONS(4913),
    [anon_sym_public] = ACTIONS(4913),
    [anon_sym_AMP] = ACTIONS(4913),
    [anon_sym_var] = ACTIONS(4913),
    [anon_sym_QMARK] = ACTIONS(4911),
    [anon_sym_PIPE_PIPE] = ACTIONS(4911),
    [anon_sym_while] = ACTIONS(4913),
    [anon_sym_SQUOTE] = ACTIONS(4911),
    [anon_sym_try] = ACTIONS(4913),
    [anon_sym_EQ_EQ] = ACTIONS(4913),
    [anon_sym_RPAREN] = ACTIONS(4911),
    [anon_sym_LT] = ACTIONS(4913),
    [sym_number] = ACTIONS(4911),
    [anon_sym_SLASH] = ACTIONS(4913),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(4911),
    [anon_sym_string] = ACTIONS(4913),
    [anon_sym_function] = ACTIONS(4913),
    [sym_undefined] = ACTIONS(4913),
    [anon_sym_CARET] = ACTIONS(4911),
    [anon_sym_new] = ACTIONS(4913),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_let] = ACTIONS(4913),
    [anon_sym_GT_GT] = ACTIONS(4913),
    [anon_sym_export] = ACTIONS(4913),
    [anon_sym_do] = ACTIONS(4913),
    [anon_sym_TILDE] = ACTIONS(4911),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4911),
    [anon_sym_in] = ACTIONS(4913),
  },
  [1404] = {
    [sym_public_field_definition] = STATE(640),
    [sym__property_name] = STATE(641),
    [sym_decorator] = STATE(1404),
    [sym_method_signature] = STATE(640),
    [sym_accessibility_modifier] = STATE(642),
    [sym_abstract_method_signature] = STATE(640),
    [sym_computed_property_name] = STATE(641),
    [aux_sym_class_body_repeat1] = STATE(1404),
    [sym_index_signature] = STATE(640),
    [sym_string] = STATE(641),
    [sym_method_definition] = STATE(644),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [sym_identifier] = ACTIONS(4918),
    [anon_sym_module] = ACTIONS(4918),
    [anon_sym_symbol] = ACTIONS(4918),
    [anon_sym_number] = ACTIONS(4918),
    [anon_sym_AT] = ACTIONS(4921),
    [anon_sym_declare] = ACTIONS(4918),
    [anon_sym_STAR] = ACTIONS(4924),
    [anon_sym_void] = ACTIONS(4918),
    [anon_sym_any] = ACTIONS(4918),
    [anon_sym_private] = ACTIONS(4927),
    [anon_sym_boolean] = ACTIONS(4918),
    [anon_sym_async] = ACTIONS(4930),
    [anon_sym_public] = ACTIONS(4927),
    [anon_sym_get] = ACTIONS(4933),
    [anon_sym_RBRACE] = ACTIONS(4891),
    [anon_sym_static] = ACTIONS(4936),
    [anon_sym_SQUOTE] = ACTIONS(4939),
    [sym_number] = ACTIONS(4942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4927),
    [anon_sym_string] = ACTIONS(4918),
    [anon_sym_abstract] = ACTIONS(4945),
    [anon_sym_set] = ACTIONS(4933),
    [anon_sym_type] = ACTIONS(4918),
    [anon_sym_import] = ACTIONS(4918),
    [anon_sym_export] = ACTIONS(4918),
    [anon_sym_namespace] = ACTIONS(4918),
    [sym_readonly] = ACTIONS(4948),
    [anon_sym_DQUOTE] = ACTIONS(4951),
  },
  [1405] = {
    [anon_sym_COLON] = ACTIONS(4954),
    [sym_comment] = ACTIONS(3),
  },
  [1406] = {
    [sym_class_body] = STATE(2344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2467),
  },
  [1407] = {
    [sym_class_heritage] = STATE(2345),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(2344),
    [anon_sym_extends] = ACTIONS(1131),
    [anon_sym_implements] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2467),
  },
  [1408] = {
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_BQUOTE] = ACTIONS(2815),
    [anon_sym_debugger] = ACTIONS(2817),
    [anon_sym_symbol] = ACTIONS(2817),
    [anon_sym_AT] = ACTIONS(2815),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_void] = ACTIONS(2817),
    [anon_sym_break] = ACTIONS(2817),
    [anon_sym_const] = ACTIONS(2817),
    [sym_super] = ACTIONS(2817),
    [anon_sym_return] = ACTIONS(2817),
    [anon_sym_private] = ACTIONS(2817),
    [anon_sym_get] = ACTIONS(2817),
    [anon_sym_RBRACE] = ACTIONS(2815),
    [anon_sym_interface] = ACTIONS(2817),
    [anon_sym_default] = ACTIONS(2817),
    [anon_sym_enum] = ACTIONS(2817),
    [anon_sym_delete] = ACTIONS(2817),
    [anon_sym_continue] = ACTIONS(2817),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_if] = ACTIONS(2817),
    [anon_sym_this] = ACTIONS(2817),
    [anon_sym_yield] = ACTIONS(2817),
    [sym_true] = ACTIONS(2817),
    [anon_sym_throw] = ACTIONS(2817),
    [anon_sym_protected] = ACTIONS(2817),
    [anon_sym_abstract] = ACTIONS(2817),
    [anon_sym_set] = ACTIONS(2817),
    [anon_sym_type] = ACTIONS(2817),
    [anon_sym_import] = ACTIONS(2817),
    [anon_sym_namespace] = ACTIONS(2817),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_await] = ACTIONS(2817),
    [anon_sym_DQUOTE] = ACTIONS(2815),
    [anon_sym_else] = ACTIONS(2817),
    [anon_sym_BANG] = ACTIONS(2815),
    [anon_sym_for] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [sym_false] = ACTIONS(2817),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym_case] = ACTIONS(2817),
    [anon_sym_module] = ACTIONS(2817),
    [anon_sym_number] = ACTIONS(2817),
    [anon_sym_class] = ACTIONS(2817),
    [anon_sym_declare] = ACTIONS(2817),
    [anon_sym_typeof] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_switch] = ACTIONS(2817),
    [anon_sym_LPAREN] = ACTIONS(2815),
    [sym_null] = ACTIONS(2817),
    [anon_sym_any] = ACTIONS(2817),
    [anon_sym_boolean] = ACTIONS(2817),
    [anon_sym_async] = ACTIONS(2817),
    [anon_sym_public] = ACTIONS(2817),
    [anon_sym_var] = ACTIONS(2817),
    [anon_sym_while] = ACTIONS(2817),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_try] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(2815),
    [sym_number] = ACTIONS(2815),
    [anon_sym_SLASH] = ACTIONS(2817),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2817),
    [anon_sym_function] = ACTIONS(2817),
    [sym_undefined] = ACTIONS(2817),
    [anon_sym_new] = ACTIONS(2817),
    [ts_builtin_sym_end] = ACTIONS(2815),
    [anon_sym_let] = ACTIONS(2817),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_export] = ACTIONS(2817),
    [anon_sym_do] = ACTIONS(2817),
    [anon_sym_TILDE] = ACTIONS(2815),
    [anon_sym_with] = ACTIONS(2817),
  },
  [1409] = {
    [sym_type_parameters] = STATE(815),
    [sym_formal_parameters] = STATE(816),
    [sym_call_signature] = STATE(2346),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1410] = {
    [sym_statement_block] = STATE(2347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [1411] = {
    [sym_statement_block] = STATE(2347),
    [sym__automatic_semicolon] = ACTIONS(3365),
    [anon_sym_SEMI] = ACTIONS(3365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [1412] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(2348),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1413] = {
    [sym_statement_block] = STATE(2349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [1414] = {
    [sym_identifier] = ACTIONS(3379),
    [anon_sym_BQUOTE] = ACTIONS(3377),
    [anon_sym_debugger] = ACTIONS(3379),
    [anon_sym_symbol] = ACTIONS(3379),
    [anon_sym_AT] = ACTIONS(3377),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_void] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [sym_super] = ACTIONS(3379),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_private] = ACTIONS(3379),
    [anon_sym_get] = ACTIONS(3379),
    [anon_sym_RBRACE] = ACTIONS(3377),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_default] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [anon_sym_delete] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3377),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_this] = ACTIONS(3379),
    [anon_sym_yield] = ACTIONS(3379),
    [sym_true] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_protected] = ACTIONS(3379),
    [anon_sym_abstract] = ACTIONS(3379),
    [anon_sym_set] = ACTIONS(3379),
    [anon_sym_type] = ACTIONS(3379),
    [anon_sym_import] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_PLUS_PLUS] = ACTIONS(3377),
    [anon_sym_await] = ACTIONS(3379),
    [anon_sym_DQUOTE] = ACTIONS(3377),
    [anon_sym_else] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(3377),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3377),
    [sym_false] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3377),
    [anon_sym_case] = ACTIONS(3379),
    [anon_sym_module] = ACTIONS(3379),
    [anon_sym_number] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_declare] = ACTIONS(3379),
    [anon_sym_typeof] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3377),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_LPAREN] = ACTIONS(3377),
    [sym_null] = ACTIONS(3379),
    [anon_sym_any] = ACTIONS(3379),
    [anon_sym_boolean] = ACTIONS(3379),
    [anon_sym_async] = ACTIONS(3379),
    [anon_sym_public] = ACTIONS(3379),
    [anon_sym_var] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_SQUOTE] = ACTIONS(3377),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_LT] = ACTIONS(3377),
    [sym_number] = ACTIONS(3377),
    [anon_sym_SLASH] = ACTIONS(3379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3379),
    [anon_sym_function] = ACTIONS(3379),
    [sym_undefined] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [ts_builtin_sym_end] = ACTIONS(3377),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_export] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_TILDE] = ACTIONS(3377),
    [anon_sym_with] = ACTIONS(3379),
  },
  [1415] = {
    [sym_nested_identifier] = STATE(1203),
    [sym_identifier] = ACTIONS(4956),
    [sym_comment] = ACTIONS(3),
  },
  [1416] = {
    [sym_class_heritage] = STATE(2350),
    [sym_type_parameters] = STATE(2351),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(2352),
    [anon_sym_extends] = ACTIONS(1131),
    [anon_sym_implements] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2467),
  },
  [1417] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4958),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4958),
    [anon_sym_AMP_EQ] = ACTIONS(4958),
    [anon_sym_PLUS_EQ] = ACTIONS(4958),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4958),
    [anon_sym_STAR_EQ] = ACTIONS(4958),
    [anon_sym_PIPE_EQ] = ACTIONS(4958),
    [anon_sym_DASH_EQ] = ACTIONS(4958),
    [anon_sym_EQ_GT] = ACTIONS(4960),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4958),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4958),
    [anon_sym_GT_GT_EQ] = ACTIONS(4958),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4958),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4962),
  },
  [1418] = {
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4964),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4964),
    [anon_sym_AMP_EQ] = ACTIONS(4964),
    [anon_sym_PLUS_EQ] = ACTIONS(4964),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4964),
    [anon_sym_STAR_EQ] = ACTIONS(4964),
    [anon_sym_PIPE_EQ] = ACTIONS(4964),
    [anon_sym_DASH_EQ] = ACTIONS(4964),
    [anon_sym_EQ_GT] = ACTIONS(4966),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4964),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4964),
    [anon_sym_GT_GT_EQ] = ACTIONS(4964),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4964),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1419] = {
    [sym_new_expression] = STATE(2358),
    [sym_augmented_assignment_expression] = STATE(2358),
    [sym_unary_expression] = STATE(2358),
    [sym_update_expression] = STATE(2358),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(2358),
    [sym_regex] = STATE(2358),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2358),
    [sym_non_null_expression] = STATE(2358),
    [sym_as_expression] = STATE(2358),
    [sym_jsx_fragment] = STATE(2358),
    [sym_yield_expression] = STATE(2358),
    [sym_jsx_element] = STATE(2358),
    [sym_internal_module] = STATE(2358),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2358),
    [sym_await_expression] = STATE(2358),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(2358),
    [sym_this] = STATE(2358),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(2358),
    [sym_generator_function] = STATE(2358),
    [sym_call_expression] = STATE(2358),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(2358),
    [sym_ternary_expression] = STATE(2358),
    [sym_binary_expression] = STATE(2358),
    [sym_template_string] = STATE(2358),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2358),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2358),
    [sym_class] = STATE(2358),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_false] = ACTIONS(4968),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4968),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4970),
    [sym_true] = ACTIONS(4968),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4968),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [1420] = {
    [sym_new_expression] = STATE(2359),
    [sym_augmented_assignment_expression] = STATE(2359),
    [sym_unary_expression] = STATE(2359),
    [sym_update_expression] = STATE(2359),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(2359),
    [sym_regex] = STATE(2359),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2359),
    [sym_non_null_expression] = STATE(2359),
    [sym_as_expression] = STATE(2359),
    [sym_jsx_fragment] = STATE(2359),
    [sym_yield_expression] = STATE(2359),
    [sym_jsx_element] = STATE(2359),
    [sym_internal_module] = STATE(2359),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2359),
    [sym_await_expression] = STATE(2359),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(2359),
    [sym_this] = STATE(2359),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(2359),
    [sym_generator_function] = STATE(2359),
    [sym_call_expression] = STATE(2359),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(2359),
    [sym_ternary_expression] = STATE(2359),
    [sym_binary_expression] = STATE(2359),
    [sym_template_string] = STATE(2359),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2359),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2359),
    [sym_class] = STATE(2359),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_false] = ACTIONS(4972),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4972),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4974),
    [sym_true] = ACTIONS(4972),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4972),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [1421] = {
    [sym_new_expression] = STATE(2358),
    [sym_augmented_assignment_expression] = STATE(2358),
    [sym__initializer] = STATE(79),
    [sym_unary_expression] = STATE(2358),
    [sym_update_expression] = STATE(2358),
    [sym_regex] = STATE(2358),
    [sym_meta_property] = STATE(2358),
    [sym_call_signature] = STATE(1428),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2358),
    [sym_non_null_expression] = STATE(2358),
    [sym_yield_expression] = STATE(2358),
    [sym_jsx_fragment] = STATE(2358),
    [sym_jsx_element] = STATE(2358),
    [sym_as_expression] = STATE(2358),
    [sym_internal_module] = STATE(2358),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2358),
    [sym_await_expression] = STATE(2358),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(2358),
    [sym_this] = STATE(2358),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(2358),
    [sym_generator_function] = STATE(2358),
    [sym_call_expression] = STATE(2358),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(2358),
    [sym_ternary_expression] = STATE(2358),
    [sym_binary_expression] = STATE(2358),
    [sym_template_string] = STATE(2358),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2358),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2358),
    [sym_class] = STATE(2358),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2929),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(4964),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_AMP_EQ] = ACTIONS(4964),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4964),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1195),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(4964),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_PIPE_EQ] = ACTIONS(4964),
    [anon_sym_DASH_EQ] = ACTIONS(4964),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4964),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(2947),
    [sym_true] = ACTIONS(4968),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_GT_GT_EQ] = ACTIONS(4964),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4964),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(4968),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4964),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4968),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_STAR_EQ] = ACTIONS(4964),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_EQ_GT] = ACTIONS(4966),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(4970),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4964),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1422] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(79),
    [sym_formal_parameters] = STATE(57),
    [sym_call_signature] = STATE(2360),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4976),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4964),
    [anon_sym_symbol] = ACTIONS(4978),
    [anon_sym_AMP_EQ] = ACTIONS(4964),
    [anon_sym_PLUS_EQ] = ACTIONS(4964),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1195),
    [anon_sym_void] = ACTIONS(4978),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(4964),
    [anon_sym_private] = ACTIONS(4978),
    [anon_sym_PIPE_EQ] = ACTIONS(4964),
    [anon_sym_DASH_EQ] = ACTIONS(4964),
    [anon_sym_get] = ACTIONS(4978),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4964),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(4978),
    [anon_sym_GT_GT_EQ] = ACTIONS(4964),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_set] = ACTIONS(4978),
    [anon_sym_type] = ACTIONS(4978),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(4978),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4964),
    [anon_sym_namespace] = ACTIONS(4978),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(4978),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4964),
    [anon_sym_number] = ACTIONS(4978),
    [anon_sym_declare] = ACTIONS(4978),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(4978),
    [anon_sym_STAR_EQ] = ACTIONS(4964),
    [anon_sym_boolean] = ACTIONS(4978),
    [anon_sym_async] = ACTIONS(4978),
    [anon_sym_public] = ACTIONS(4978),
    [anon_sym_EQ_GT] = ACTIONS(4966),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4964),
    [anon_sym_string] = ACTIONS(4978),
    [anon_sym_function] = ACTIONS(698),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(4978),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1423] = {
    [sym_new_expression] = STATE(2362),
    [sym_augmented_assignment_expression] = STATE(2362),
    [sym_unary_expression] = STATE(2362),
    [sym_update_expression] = STATE(2362),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(2362),
    [sym_regex] = STATE(2362),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2362),
    [sym_non_null_expression] = STATE(2362),
    [sym_as_expression] = STATE(2362),
    [sym_jsx_fragment] = STATE(2362),
    [sym_yield_expression] = STATE(2362),
    [sym_jsx_element] = STATE(2362),
    [sym_internal_module] = STATE(2362),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2362),
    [sym_await_expression] = STATE(2362),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(2362),
    [sym_this] = STATE(2362),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(2362),
    [sym_generator_function] = STATE(2362),
    [sym_call_expression] = STATE(2362),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(2362),
    [sym_ternary_expression] = STATE(2362),
    [sym_binary_expression] = STATE(2362),
    [sym_template_string] = STATE(2362),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2362),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2362),
    [sym_class] = STATE(2362),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_false] = ACTIONS(4980),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4980),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4982),
    [sym_true] = ACTIONS(4980),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4980),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [1424] = {
    [sym_new_expression] = STATE(2363),
    [sym_augmented_assignment_expression] = STATE(2363),
    [sym_unary_expression] = STATE(2363),
    [sym_update_expression] = STATE(2363),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(2363),
    [sym_regex] = STATE(2363),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2363),
    [sym_non_null_expression] = STATE(2363),
    [sym_as_expression] = STATE(2363),
    [sym_jsx_fragment] = STATE(2363),
    [sym_yield_expression] = STATE(2363),
    [sym_jsx_element] = STATE(2363),
    [sym_internal_module] = STATE(2363),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2363),
    [sym_await_expression] = STATE(2363),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(2363),
    [sym_this] = STATE(2363),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(2363),
    [sym_generator_function] = STATE(2363),
    [sym_call_expression] = STATE(2363),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(2363),
    [sym_ternary_expression] = STATE(2363),
    [sym_binary_expression] = STATE(2363),
    [sym_template_string] = STATE(2363),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2363),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2363),
    [sym_class] = STATE(2363),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym_identifier] = ACTIONS(2929),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_RBRACE] = ACTIONS(211),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(2947),
    [sym_true] = ACTIONS(4984),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(4984),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4984),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(4986),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4984),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [1425] = {
    [sym_new_expression] = STATE(277),
    [sym_augmented_assignment_expression] = STATE(289),
    [sym_unary_expression] = STATE(289),
    [sym_update_expression] = STATE(289),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(277),
    [sym_regex] = STATE(277),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(289),
    [sym_non_null_expression] = STATE(289),
    [sym_as_expression] = STATE(289),
    [sym_jsx_fragment] = STATE(289),
    [sym_yield_expression] = STATE(289),
    [sym_jsx_element] = STATE(289),
    [sym_internal_module] = STATE(289),
    [sym_function] = STATE(290),
    [sym_arrow_function] = STATE(277),
    [sym_await_expression] = STATE(289),
    [sym_member_expression] = STATE(291),
    [sym_string] = STATE(277),
    [sym_this] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(292),
    [sym_anonymous_class] = STATE(277),
    [sym_generator_function] = STATE(277),
    [sym_call_expression] = STATE(289),
    [sym_subscript_expression] = STATE(291),
    [sym_assignment_expression] = STATE(289),
    [sym_ternary_expression] = STATE(289),
    [sym_binary_expression] = STATE(289),
    [sym_template_string] = STATE(277),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(277),
    [sym_array] = STATE(293),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(289),
    [sym_class] = STATE(277),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(482),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(4990),
    [anon_sym_symbol] = ACTIONS(4990),
    [anon_sym_number] = ACTIONS(4990),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4990),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4992),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(482),
    [sym_super] = ACTIONS(494),
    [anon_sym_any] = ACTIONS(4990),
    [anon_sym_private] = ACTIONS(4990),
    [anon_sym_boolean] = ACTIONS(4990),
    [anon_sym_async] = ACTIONS(4994),
    [anon_sym_public] = ACTIONS(4990),
    [anon_sym_get] = ACTIONS(4990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(498),
    [sym_true] = ACTIONS(482),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4990),
    [anon_sym_string] = ACTIONS(4990),
    [anon_sym_function] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(502),
    [sym_undefined] = ACTIONS(482),
    [anon_sym_set] = ACTIONS(4990),
    [anon_sym_type] = ACTIONS(4990),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(4990),
    [anon_sym_export] = ACTIONS(4990),
    [anon_sym_namespace] = ACTIONS(4996),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [1426] = {
    [sym_nested_identifier] = STATE(127),
    [sym__module] = STATE(128),
    [sym_string] = STATE(129),
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_PERCENT_EQ] = ACTIONS(4964),
    [anon_sym_AMP_EQ] = ACTIONS(4964),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4964),
    [anon_sym_PLUS_EQ] = ACTIONS(4964),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4964),
    [anon_sym_STAR_EQ] = ACTIONS(4964),
    [anon_sym_PIPE_EQ] = ACTIONS(4964),
    [anon_sym_DASH_EQ] = ACTIONS(4964),
    [anon_sym_EQ_GT] = ACTIONS(4966),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4964),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4964),
    [anon_sym_GT_GT_EQ] = ACTIONS(4964),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4964),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1427] = {
    [sym_new_expression] = STATE(2369),
    [sym_augmented_assignment_expression] = STATE(2369),
    [sym_unary_expression] = STATE(2369),
    [sym_update_expression] = STATE(2369),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(2369),
    [sym_regex] = STATE(2369),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2369),
    [sym_non_null_expression] = STATE(2369),
    [sym_as_expression] = STATE(2369),
    [sym_jsx_fragment] = STATE(2369),
    [sym_yield_expression] = STATE(2369),
    [sym_jsx_element] = STATE(2369),
    [sym_internal_module] = STATE(2369),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2369),
    [sym_await_expression] = STATE(2369),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(2369),
    [sym_this] = STATE(2369),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(2369),
    [sym_generator_function] = STATE(2369),
    [sym_call_expression] = STATE(2369),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(2369),
    [sym_ternary_expression] = STATE(2369),
    [sym_binary_expression] = STATE(2369),
    [sym_template_string] = STATE(2369),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2369),
    [sym_class] = STATE(2369),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_false] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4998),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5000),
    [sym_true] = ACTIONS(4998),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4998),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [1428] = {
    [anon_sym_EQ_GT] = ACTIONS(4960),
    [sym_comment] = ACTIONS(3),
  },
  [1429] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(2005),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2005),
    [anon_sym_PIPE] = ACTIONS(5004),
    [anon_sym_COMMA] = ACTIONS(2005),
    [anon_sym_LT_LT] = ACTIONS(5006),
    [anon_sym_STAR] = ACTIONS(5008),
    [anon_sym_GT_GT_GT] = ACTIONS(5006),
    [anon_sym_AMP_AMP] = ACTIONS(5010),
    [anon_sym_DASH] = ACTIONS(5012),
    [anon_sym_BANG_EQ] = ACTIONS(4962),
    [anon_sym_LT_EQ] = ACTIONS(5002),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(5002),
    [anon_sym_GT] = ACTIONS(4962),
    [anon_sym_RBRACE] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(5014),
    [anon_sym_QMARK] = ACTIONS(5016),
    [anon_sym_PERCENT] = ACTIONS(5006),
    [anon_sym_as] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(5020),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(4962),
    [anon_sym_instanceof] = ACTIONS(5002),
    [anon_sym_LT] = ACTIONS(5022),
    [anon_sym_SLASH] = ACTIONS(5008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(5020),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(5012),
    [anon_sym_GT_GT] = ACTIONS(5008),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5002),
    [anon_sym_in] = ACTIONS(4962),
  },
  [1430] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4958),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4958),
    [anon_sym_AMP_EQ] = ACTIONS(4958),
    [anon_sym_PLUS_EQ] = ACTIONS(4958),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4958),
    [anon_sym_STAR_EQ] = ACTIONS(4958),
    [anon_sym_PIPE_EQ] = ACTIONS(4958),
    [anon_sym_DASH_EQ] = ACTIONS(4958),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4958),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4958),
    [anon_sym_GT_GT_EQ] = ACTIONS(4958),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4958),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [1431] = {
    [sym__initializer] = STATE(321),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4962),
  },
  [1432] = {
    [sym__initializer] = STATE(336),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4962),
  },
  [1433] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5026),
    [anon_sym_LBRACK] = ACTIONS(5026),
    [anon_sym_BANG] = ACTIONS(5028),
    [anon_sym_SEMI] = ACTIONS(5026),
    [anon_sym_BQUOTE] = ACTIONS(5026),
    [sym__automatic_semicolon] = ACTIONS(5026),
    [anon_sym_PIPE] = ACTIONS(5028),
    [anon_sym_COMMA] = ACTIONS(5026),
    [anon_sym_LT_LT] = ACTIONS(5026),
    [anon_sym_STAR] = ACTIONS(5028),
    [anon_sym_GT_GT_GT] = ACTIONS(5026),
    [anon_sym_EQ] = ACTIONS(5028),
    [anon_sym_AMP_AMP] = ACTIONS(5026),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_BANG_EQ] = ACTIONS(5028),
    [anon_sym_LT_EQ] = ACTIONS(5026),
    [anon_sym_LPAREN] = ACTIONS(5026),
    [anon_sym_GT_EQ] = ACTIONS(5026),
    [anon_sym_of] = ACTIONS(5026),
    [anon_sym_GT] = ACTIONS(5028),
    [anon_sym_AMP] = ACTIONS(5028),
    [anon_sym_PERCENT] = ACTIONS(5026),
    [anon_sym_QMARK] = ACTIONS(5026),
    [anon_sym_RBRACE] = ACTIONS(5026),
    [anon_sym_as] = ACTIONS(5026),
    [anon_sym_PIPE_PIPE] = ACTIONS(5026),
    [anon_sym_DASH_DASH] = ACTIONS(5026),
    [anon_sym_EQ_EQ] = ACTIONS(5028),
    [anon_sym_instanceof] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(5028),
    [anon_sym_RPAREN] = ACTIONS(5026),
    [anon_sym_SLASH] = ACTIONS(5028),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5026),
    [anon_sym_CARET] = ACTIONS(5026),
    [anon_sym_STAR_STAR] = ACTIONS(5026),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_GT_GT] = ACTIONS(5028),
    [anon_sym_PLUS_PLUS] = ACTIONS(5026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5026),
    [anon_sym_in] = ACTIONS(5028),
  },
  [1434] = {
    [sym_new_expression] = STATE(2379),
    [sym_augmented_assignment_expression] = STATE(2379),
    [sym_unary_expression] = STATE(2379),
    [sym_update_expression] = STATE(2379),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(2379),
    [sym_regex] = STATE(2379),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2379),
    [sym_non_null_expression] = STATE(2379),
    [sym_as_expression] = STATE(2379),
    [sym_jsx_fragment] = STATE(2379),
    [sym_yield_expression] = STATE(2379),
    [sym_jsx_element] = STATE(2379),
    [sym_internal_module] = STATE(2379),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2379),
    [sym_await_expression] = STATE(2379),
    [sym_member_expression] = STATE(454),
    [sym_spread_element] = STATE(2380),
    [sym_string] = STATE(2379),
    [sym_this] = STATE(2379),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [aux_sym_array_repeat1] = STATE(2381),
    [sym_anonymous_class] = STATE(2379),
    [sym_generator_function] = STATE(2379),
    [sym_call_expression] = STATE(2379),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(2379),
    [sym_ternary_expression] = STATE(2379),
    [sym_binary_expression] = STATE(2379),
    [sym_template_string] = STATE(2379),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2379),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2379),
    [sym_class] = STATE(2379),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(5030),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(797),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5030),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_RPAREN] = ACTIONS(5032),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5034),
    [sym_true] = ACTIONS(5030),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5030),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [1435] = {
    [anon_sym_COMMA] = ACTIONS(5036),
    [anon_sym_RBRACE] = ACTIONS(5036),
    [sym_comment] = ACTIONS(3),
  },
  [1436] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4787),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4787),
    [anon_sym_AMP_EQ] = ACTIONS(4787),
    [anon_sym_PLUS_EQ] = ACTIONS(4787),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4787),
    [anon_sym_STAR_EQ] = ACTIONS(4787),
    [anon_sym_PIPE_EQ] = ACTIONS(4787),
    [anon_sym_DASH_EQ] = ACTIONS(4787),
    [anon_sym_EQ_GT] = ACTIONS(4791),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4787),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4787),
    [anon_sym_GT_GT_EQ] = ACTIONS(4787),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4787),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4795),
  },
  [1437] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_AMP_EQ] = ACTIONS(4797),
    [anon_sym_PLUS_EQ] = ACTIONS(4797),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4797),
    [anon_sym_STAR_EQ] = ACTIONS(4797),
    [anon_sym_PIPE_EQ] = ACTIONS(4797),
    [anon_sym_DASH_EQ] = ACTIONS(4797),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4797),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1438] = {
    [sym_new_expression] = STATE(2294),
    [sym_augmented_assignment_expression] = STATE(2294),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(2294),
    [sym_update_expression] = STATE(2294),
    [sym_regex] = STATE(2294),
    [sym_meta_property] = STATE(2294),
    [sym_call_signature] = STATE(1372),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2294),
    [sym_non_null_expression] = STATE(2294),
    [sym_yield_expression] = STATE(2294),
    [sym_jsx_fragment] = STATE(2294),
    [sym_jsx_element] = STATE(2294),
    [sym_as_expression] = STATE(2294),
    [sym_internal_module] = STATE(2294),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2294),
    [sym_await_expression] = STATE(2294),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(2294),
    [sym_this] = STATE(2294),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(2294),
    [sym_generator_function] = STATE(2294),
    [sym_call_expression] = STATE(2294),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(2294),
    [sym_ternary_expression] = STATE(2294),
    [sym_binary_expression] = STATE(2294),
    [sym_template_string] = STATE(2294),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2294),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2294),
    [sym_class] = STATE(2294),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2968),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4797),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_AMP_EQ] = ACTIONS(4797),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4797),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(4797),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_PIPE_EQ] = ACTIONS(4797),
    [anon_sym_DASH_EQ] = ACTIONS(4797),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4797),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(2839),
    [sym_true] = ACTIONS(4803),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4797),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(4803),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(135),
    [sym_null] = ACTIONS(4803),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_STAR_EQ] = ACTIONS(4797),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(4805),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4797),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4803),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1439] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_call_signature] = STATE(2296),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4811),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4797),
    [anon_sym_symbol] = ACTIONS(4813),
    [anon_sym_AMP_EQ] = ACTIONS(4797),
    [anon_sym_PLUS_EQ] = ACTIONS(4797),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_void] = ACTIONS(4813),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(4797),
    [anon_sym_private] = ACTIONS(4813),
    [anon_sym_PIPE_EQ] = ACTIONS(4797),
    [anon_sym_DASH_EQ] = ACTIONS(4797),
    [anon_sym_get] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4797),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(4813),
    [anon_sym_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(4813),
    [anon_sym_type] = ACTIONS(4813),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(4813),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4797),
    [anon_sym_namespace] = ACTIONS(4813),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(4813),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_number] = ACTIONS(4813),
    [anon_sym_declare] = ACTIONS(4813),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(4813),
    [anon_sym_STAR_EQ] = ACTIONS(4797),
    [anon_sym_boolean] = ACTIONS(4813),
    [anon_sym_async] = ACTIONS(4813),
    [anon_sym_public] = ACTIONS(4813),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4797),
    [anon_sym_string] = ACTIONS(4813),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(4813),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1440] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_AMP_EQ] = ACTIONS(4797),
    [anon_sym_PLUS_EQ] = ACTIONS(4797),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4797),
    [anon_sym_STAR_EQ] = ACTIONS(4797),
    [anon_sym_PIPE_EQ] = ACTIONS(4797),
    [anon_sym_DASH_EQ] = ACTIONS(4797),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4797),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1441] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(4795),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4839),
    [anon_sym_LT_LT] = ACTIONS(4841),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_GT_GT_GT] = ACTIONS(4841),
    [anon_sym_AMP_AMP] = ACTIONS(4847),
    [anon_sym_BANG_EQ] = ACTIONS(4795),
    [anon_sym_LT_EQ] = ACTIONS(4837),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(4837),
    [anon_sym_RBRACK] = ACTIONS(5038),
    [anon_sym_GT] = ACTIONS(4795),
    [anon_sym_AMP] = ACTIONS(4851),
    [anon_sym_PERCENT] = ACTIONS(4841),
    [anon_sym_QMARK] = ACTIONS(4853),
    [anon_sym_PIPE_PIPE] = ACTIONS(4855),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4795),
    [anon_sym_instanceof] = ACTIONS(4837),
    [anon_sym_LT] = ACTIONS(4859),
    [anon_sym_SLASH] = ACTIONS(4845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4855),
    [anon_sym_STAR_STAR] = ACTIONS(4861),
    [anon_sym_PLUS] = ACTIONS(4843),
    [anon_sym_GT_GT] = ACTIONS(4845),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4837),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [1442] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(2383),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1443] = {
    [sym_statement_block] = STATE(2384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [1444] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(2383),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(5040),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1445] = {
    [sym_string] = STATE(2386),
    [sym__property_name] = STATE(2386),
    [sym_computed_property_name] = STATE(2386),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [1446] = {
    [sym_string] = STATE(2386),
    [sym__property_name] = STATE(2386),
    [sym_computed_property_name] = STATE(2386),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [1447] = {
    [sym_string] = STATE(2386),
    [sym__property_name] = STATE(2386),
    [sym_computed_property_name] = STATE(2386),
    [anon_sym_get] = ACTIONS(5044),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(5042),
    [anon_sym_STAR] = ACTIONS(5046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(5044),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [1448] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5048),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [1449] = {
    [sym_parenthesized_expression] = STATE(2390),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [1450] = {
    [anon_sym_await] = ACTIONS(5050),
    [anon_sym_LPAREN] = ACTIONS(5052),
    [sym_comment] = ACTIONS(3),
  },
  [1451] = {
    [sym_type_alias_declaration] = STATE(193),
    [aux_sym_export_statement_repeat1] = STATE(2396),
    [sym__declaration] = STATE(193),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(193),
    [sym_import_alias] = STATE(193),
    [sym_export_statement] = STATE(193),
    [sym_generator_function] = STATE(193),
    [sym_lexical_declaration] = STATE(193),
    [sym_internal_module] = STATE(193),
    [sym_decorator] = STATE(2396),
    [sym_enum_declaration] = STATE(193),
    [sym_function] = STATE(193),
    [sym_function_signature] = STATE(193),
    [sym_variable_declaration] = STATE(193),
    [sym_abstract_class] = STATE(193),
    [sym_module] = STATE(193),
    [sym_interface_declaration] = STATE(193),
    [sym_class] = STATE(193),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(324),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(5054),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_declare] = ACTIONS(5056),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(5058),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1452] = {
    [sym_parenthesized_expression] = STATE(2397),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [1453] = {
    [sym_type_alias_declaration] = STATE(300),
    [aux_sym_export_statement_repeat1] = STATE(2396),
    [sym__declaration] = STATE(300),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(300),
    [sym_import_alias] = STATE(300),
    [sym_export_statement] = STATE(300),
    [sym_generator_function] = STATE(300),
    [sym_export_clause] = STATE(301),
    [sym_lexical_declaration] = STATE(300),
    [sym_internal_module] = STATE(300),
    [sym_decorator] = STATE(2396),
    [sym_enum_declaration] = STATE(300),
    [sym_function] = STATE(300),
    [sym_function_signature] = STATE(300),
    [sym_variable_declaration] = STATE(300),
    [sym_abstract_class] = STATE(300),
    [sym_module] = STATE(300),
    [sym_interface_declaration] = STATE(300),
    [sym_class] = STATE(300),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(508),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(511),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_as] = ACTIONS(515),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_declare] = ACTIONS(5056),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(5058),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1454] = {
    [sym_parenthesized_expression] = STATE(2398),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [1455] = {
    [sym_identifier] = ACTIONS(2455),
    [anon_sym_BQUOTE] = ACTIONS(2457),
    [anon_sym_debugger] = ACTIONS(2455),
    [anon_sym_symbol] = ACTIONS(2455),
    [anon_sym_AT] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2455),
    [anon_sym_void] = ACTIONS(2455),
    [anon_sym_break] = ACTIONS(2455),
    [anon_sym_const] = ACTIONS(2455),
    [sym_super] = ACTIONS(2455),
    [anon_sym_return] = ACTIONS(2455),
    [anon_sym_private] = ACTIONS(2455),
    [anon_sym_get] = ACTIONS(2455),
    [anon_sym_RBRACE] = ACTIONS(2457),
    [anon_sym_interface] = ACTIONS(2455),
    [anon_sym_enum] = ACTIONS(2455),
    [anon_sym_delete] = ACTIONS(2455),
    [anon_sym_continue] = ACTIONS(2455),
    [anon_sym_DASH_DASH] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2455),
    [anon_sym_this] = ACTIONS(2455),
    [anon_sym_yield] = ACTIONS(2455),
    [sym_true] = ACTIONS(2455),
    [anon_sym_throw] = ACTIONS(2455),
    [anon_sym_protected] = ACTIONS(2455),
    [anon_sym_abstract] = ACTIONS(2455),
    [anon_sym_set] = ACTIONS(2455),
    [anon_sym_type] = ACTIONS(2455),
    [anon_sym_import] = ACTIONS(2455),
    [anon_sym_namespace] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2457),
    [anon_sym_await] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [anon_sym_else] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(2457),
    [anon_sym_for] = ACTIONS(2455),
    [anon_sym_LBRACK] = ACTIONS(2457),
    [sym_false] = ACTIONS(2455),
    [anon_sym_SEMI] = ACTIONS(2457),
    [anon_sym_module] = ACTIONS(2455),
    [anon_sym_number] = ACTIONS(2455),
    [anon_sym_class] = ACTIONS(2455),
    [anon_sym_declare] = ACTIONS(2455),
    [anon_sym_typeof] = ACTIONS(2455),
    [anon_sym_LBRACE] = ACTIONS(2457),
    [anon_sym_switch] = ACTIONS(2455),
    [anon_sym_LPAREN] = ACTIONS(2457),
    [sym_null] = ACTIONS(2455),
    [anon_sym_any] = ACTIONS(2455),
    [anon_sym_boolean] = ACTIONS(2455),
    [anon_sym_async] = ACTIONS(2455),
    [anon_sym_public] = ACTIONS(2455),
    [anon_sym_var] = ACTIONS(2455),
    [anon_sym_while] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_try] = ACTIONS(2455),
    [anon_sym_LT] = ACTIONS(2457),
    [sym_number] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2455),
    [anon_sym_function] = ACTIONS(2455),
    [sym_undefined] = ACTIONS(2455),
    [anon_sym_new] = ACTIONS(2455),
    [anon_sym_let] = ACTIONS(2455),
    [anon_sym_PLUS] = ACTIONS(2455),
    [anon_sym_export] = ACTIONS(2455),
    [anon_sym_do] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2457),
    [anon_sym_with] = ACTIONS(2455),
  },
  [1456] = {
    [aux_sym_export_statement_repeat1] = STATE(320),
    [sym_decorator] = STATE(320),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(5062),
    [anon_sym_class] = ACTIONS(546),
    [sym_comment] = ACTIONS(3),
  },
  [1457] = {
    [sym_array] = STATE(2403),
    [sym_object] = STATE(2404),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(5064),
    [anon_sym_var] = ACTIONS(5066),
    [anon_sym_const] = ACTIONS(5066),
    [sym_comment] = ACTIONS(3),
    [anon_sym_let] = ACTIONS(5066),
  },
  [1458] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(5068),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5070),
  },
  [1459] = {
    [sym_variable_declarator] = STATE(97),
    [sym_array] = STATE(2408),
    [sym_object] = STATE(2409),
    [sym_identifier] = ACTIONS(5072),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [1460] = {
    [sym_variable_declarator] = STATE(258),
    [sym_array] = STATE(2408),
    [sym_object] = STATE(2409),
    [sym_identifier] = ACTIONS(5072),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [1461] = {
    [sym_new_expression] = STATE(59),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_yield_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_internal_module] = STATE(59),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(59),
    [sym_await_expression] = STATE(59),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2410),
    [sym_sequence_expression] = STATE(62),
    [sym_string] = STATE(59),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(2410),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(59),
    [sym_generator_function] = STATE(59),
    [sym_call_expression] = STATE(59),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(59),
    [sym_ternary_expression] = STATE(59),
    [sym_binary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(59),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [1462] = {
    [sym__initializer] = STATE(321),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(5074),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5076),
  },
  [1463] = {
    [sym__initializer] = STATE(336),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(5078),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5080),
  },
  [1464] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2633),
    [anon_sym_LBRACK] = ACTIONS(2633),
    [anon_sym_BANG] = ACTIONS(2635),
    [anon_sym_SEMI] = ACTIONS(2633),
    [anon_sym_BQUOTE] = ACTIONS(2633),
    [sym__automatic_semicolon] = ACTIONS(2633),
    [anon_sym_PIPE] = ACTIONS(2635),
    [anon_sym_COMMA] = ACTIONS(2633),
    [anon_sym_LT_LT] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_GT_GT_GT] = ACTIONS(2633),
    [anon_sym_EQ] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_BANG_EQ] = ACTIONS(2635),
    [anon_sym_LT_EQ] = ACTIONS(2633),
    [anon_sym_LPAREN] = ACTIONS(5082),
    [anon_sym_GT_EQ] = ACTIONS(2633),
    [anon_sym_GT] = ACTIONS(2635),
    [anon_sym_AMP] = ACTIONS(2635),
    [anon_sym_PERCENT] = ACTIONS(2633),
    [anon_sym_QMARK] = ACTIONS(5082),
    [anon_sym_as] = ACTIONS(2633),
    [anon_sym_PIPE_PIPE] = ACTIONS(2633),
    [anon_sym_DASH_DASH] = ACTIONS(2633),
    [anon_sym_EQ_EQ] = ACTIONS(2635),
    [anon_sym_instanceof] = ACTIONS(2633),
    [anon_sym_LT] = ACTIONS(5085),
    [anon_sym_SLASH] = ACTIONS(2635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5088),
    [anon_sym_DOT] = ACTIONS(2633),
    [anon_sym_CARET] = ACTIONS(2633),
    [anon_sym_STAR_STAR] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_GT_GT] = ACTIONS(2635),
    [anon_sym_PLUS_PLUS] = ACTIONS(2633),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2633),
    [anon_sym_in] = ACTIONS(2635),
  },
  [1465] = {
    [sym_identifier] = ACTIONS(5090),
    [sym_comment] = ACTIONS(3),
  },
  [1466] = {
    [sym_type_alias_declaration] = STATE(872),
    [aux_sym_export_statement_repeat1] = STATE(685),
    [sym__declaration] = STATE(872),
    [sym_ambient_declaration] = STATE(872),
    [sym_import_alias] = STATE(872),
    [sym_export_statement] = STATE(872),
    [sym_generator_function] = STATE(872),
    [sym_lexical_declaration] = STATE(872),
    [sym_internal_module] = STATE(872),
    [sym_decorator] = STATE(685),
    [sym_enum_declaration] = STATE(872),
    [sym_function] = STATE(872),
    [sym_function_signature] = STATE(872),
    [sym_variable_declaration] = STATE(872),
    [sym_abstract_class] = STATE(872),
    [sym_module] = STATE(872),
    [sym_interface_declaration] = STATE(872),
    [sym_class] = STATE(872),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_default] = ACTIONS(1826),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(346),
  },
  [1467] = {
    [sym_string] = STATE(2386),
    [sym__property_name] = STATE(2386),
    [sym_computed_property_name] = STATE(2386),
    [anon_sym_get] = ACTIONS(5044),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(5042),
    [anon_sym_STAR] = ACTIONS(5046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(5044),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(5092),
  },
  [1468] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5094),
    [anon_sym_LBRACK] = ACTIONS(5094),
    [anon_sym_BANG] = ACTIONS(5096),
    [anon_sym_SEMI] = ACTIONS(5094),
    [anon_sym_BQUOTE] = ACTIONS(5094),
    [sym__automatic_semicolon] = ACTIONS(5094),
    [anon_sym_PIPE] = ACTIONS(5096),
    [anon_sym_COMMA] = ACTIONS(5094),
    [anon_sym_LT_LT] = ACTIONS(5094),
    [anon_sym_STAR] = ACTIONS(5096),
    [anon_sym_GT_GT_GT] = ACTIONS(5094),
    [anon_sym_EQ] = ACTIONS(5096),
    [anon_sym_AMP_AMP] = ACTIONS(5094),
    [anon_sym_DASH] = ACTIONS(5096),
    [anon_sym_BANG_EQ] = ACTIONS(5096),
    [anon_sym_LT_EQ] = ACTIONS(5094),
    [anon_sym_LPAREN] = ACTIONS(5094),
    [anon_sym_GT_EQ] = ACTIONS(5094),
    [anon_sym_of] = ACTIONS(5094),
    [anon_sym_GT] = ACTIONS(5096),
    [anon_sym_AMP] = ACTIONS(5096),
    [anon_sym_PERCENT] = ACTIONS(5094),
    [anon_sym_QMARK] = ACTIONS(5094),
    [anon_sym_RBRACE] = ACTIONS(5094),
    [anon_sym_as] = ACTIONS(5094),
    [anon_sym_PIPE_PIPE] = ACTIONS(5094),
    [anon_sym_DASH_DASH] = ACTIONS(5094),
    [anon_sym_EQ_EQ] = ACTIONS(5096),
    [anon_sym_instanceof] = ACTIONS(5094),
    [anon_sym_LT] = ACTIONS(5096),
    [anon_sym_RPAREN] = ACTIONS(5094),
    [anon_sym_SLASH] = ACTIONS(5096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5094),
    [anon_sym_CARET] = ACTIONS(5094),
    [anon_sym_STAR_STAR] = ACTIONS(5094),
    [anon_sym_PLUS] = ACTIONS(5096),
    [anon_sym_GT_GT] = ACTIONS(5096),
    [anon_sym_PLUS_PLUS] = ACTIONS(5094),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5094),
    [anon_sym_in] = ACTIONS(5096),
  },
  [1469] = {
    [aux_sym_object_repeat1] = STATE(699),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_RBRACE] = ACTIONS(5098),
    [sym_comment] = ACTIONS(3),
  },
  [1470] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2021),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(5100),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_BANG_EQ] = ACTIONS(2021),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2021),
    [anon_sym_RBRACE] = ACTIONS(5100),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_QMARK] = ACTIONS(2077),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2021),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2081),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [1471] = {
    [anon_sym_COMMA] = ACTIONS(5102),
    [anon_sym_RBRACE] = ACTIONS(5102),
    [sym_comment] = ACTIONS(3),
  },
  [1472] = {
    [sym_new_expression] = STATE(2430),
    [sym_augmented_assignment_expression] = STATE(2430),
    [sym_unary_expression] = STATE(2430),
    [sym_update_expression] = STATE(2430),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(2430),
    [sym_regex] = STATE(2430),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2430),
    [sym_non_null_expression] = STATE(2430),
    [sym_as_expression] = STATE(2430),
    [sym_jsx_fragment] = STATE(2430),
    [sym_yield_expression] = STATE(2430),
    [sym_jsx_element] = STATE(2430),
    [sym_internal_module] = STATE(2430),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2430),
    [sym_await_expression] = STATE(2430),
    [sym_member_expression] = STATE(2431),
    [sym_sequence_expression] = STATE(2432),
    [sym_string] = STATE(2430),
    [sym_this] = STATE(2430),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(2430),
    [sym_generator_function] = STATE(2430),
    [sym_call_expression] = STATE(2430),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(2430),
    [sym_ternary_expression] = STATE(2430),
    [sym_binary_expression] = STATE(2430),
    [sym_template_string] = STATE(2430),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2430),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2430),
    [sym_class] = STATE(2430),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(5108),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5108),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5122),
    [sym_true] = ACTIONS(5108),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5108),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [1473] = {
    [sym_identifier] = ACTIONS(5132),
    [anon_sym_BQUOTE] = ACTIONS(5134),
    [anon_sym_debugger] = ACTIONS(5132),
    [anon_sym_symbol] = ACTIONS(5132),
    [anon_sym_AT] = ACTIONS(5134),
    [anon_sym_DASH] = ACTIONS(5132),
    [anon_sym_void] = ACTIONS(5132),
    [anon_sym_break] = ACTIONS(5132),
    [anon_sym_const] = ACTIONS(5132),
    [sym_super] = ACTIONS(5132),
    [anon_sym_return] = ACTIONS(5132),
    [anon_sym_private] = ACTIONS(5132),
    [anon_sym_get] = ACTIONS(5132),
    [anon_sym_RBRACE] = ACTIONS(5134),
    [anon_sym_interface] = ACTIONS(5132),
    [anon_sym_default] = ACTIONS(5132),
    [anon_sym_enum] = ACTIONS(5132),
    [anon_sym_delete] = ACTIONS(5132),
    [anon_sym_continue] = ACTIONS(5132),
    [anon_sym_DASH_DASH] = ACTIONS(5134),
    [anon_sym_if] = ACTIONS(5132),
    [anon_sym_this] = ACTIONS(5132),
    [anon_sym_yield] = ACTIONS(5132),
    [sym_true] = ACTIONS(5132),
    [anon_sym_throw] = ACTIONS(5132),
    [anon_sym_protected] = ACTIONS(5132),
    [anon_sym_abstract] = ACTIONS(5132),
    [anon_sym_set] = ACTIONS(5132),
    [anon_sym_type] = ACTIONS(5132),
    [anon_sym_import] = ACTIONS(5132),
    [anon_sym_namespace] = ACTIONS(5132),
    [anon_sym_PLUS_PLUS] = ACTIONS(5134),
    [anon_sym_await] = ACTIONS(5132),
    [anon_sym_DQUOTE] = ACTIONS(5134),
    [anon_sym_else] = ACTIONS(5132),
    [anon_sym_BANG] = ACTIONS(5134),
    [anon_sym_for] = ACTIONS(5132),
    [anon_sym_LBRACK] = ACTIONS(5134),
    [sym_false] = ACTIONS(5132),
    [anon_sym_SEMI] = ACTIONS(5134),
    [anon_sym_case] = ACTIONS(5132),
    [anon_sym_module] = ACTIONS(5132),
    [anon_sym_number] = ACTIONS(5132),
    [anon_sym_class] = ACTIONS(5132),
    [anon_sym_declare] = ACTIONS(5132),
    [anon_sym_typeof] = ACTIONS(5132),
    [anon_sym_LBRACE] = ACTIONS(5134),
    [anon_sym_switch] = ACTIONS(5132),
    [anon_sym_LPAREN] = ACTIONS(5134),
    [sym_null] = ACTIONS(5132),
    [anon_sym_any] = ACTIONS(5132),
    [anon_sym_boolean] = ACTIONS(5132),
    [anon_sym_async] = ACTIONS(5132),
    [anon_sym_public] = ACTIONS(5132),
    [anon_sym_var] = ACTIONS(5132),
    [anon_sym_while] = ACTIONS(5132),
    [anon_sym_SQUOTE] = ACTIONS(5134),
    [anon_sym_try] = ACTIONS(5132),
    [anon_sym_LT] = ACTIONS(5134),
    [sym_number] = ACTIONS(5134),
    [anon_sym_SLASH] = ACTIONS(5132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5132),
    [anon_sym_function] = ACTIONS(5132),
    [sym_undefined] = ACTIONS(5132),
    [anon_sym_new] = ACTIONS(5132),
    [ts_builtin_sym_end] = ACTIONS(5134),
    [anon_sym_let] = ACTIONS(5132),
    [anon_sym_PLUS] = ACTIONS(5132),
    [anon_sym_export] = ACTIONS(5132),
    [anon_sym_do] = ACTIONS(5132),
    [anon_sym_TILDE] = ACTIONS(5134),
    [anon_sym_with] = ACTIONS(5132),
  },
  [1474] = {
    [anon_sym_COLON] = ACTIONS(5136),
    [sym_comment] = ACTIONS(3),
  },
  [1475] = {
    [sym_switch_default] = STATE(2437),
    [aux_sym_switch_body_repeat1] = STATE(2437),
    [sym_switch_case] = STATE(2437),
    [anon_sym_RBRACE] = ACTIONS(5138),
    [anon_sym_default] = ACTIONS(3079),
    [anon_sym_case] = ACTIONS(3081),
    [sym_comment] = ACTIONS(3),
  },
  [1476] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1410),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1426),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_instanceof] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1426),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(1347),
  },
  [1477] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [1478] = {
    [anon_sym_COMMA] = ACTIONS(5140),
    [anon_sym_RPAREN] = ACTIONS(5140),
    [sym_comment] = ACTIONS(3),
  },
  [1479] = {
    [sym__initializer] = STATE(2438),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(5140),
    [anon_sym_COMMA] = ACTIONS(5140),
    [sym_comment] = ACTIONS(3),
  },
  [1480] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1410),
    [anon_sym_COMMA] = ACTIONS(2003),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1426),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(2003),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_instanceof] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2003),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1426),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(1347),
  },
  [1481] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1410),
    [anon_sym_COMMA] = ACTIONS(2005),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1426),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(2005),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_instanceof] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2005),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1426),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(1347),
  },
  [1482] = {
    [sym_type_arguments] = STATE(1064),
    [anon_sym_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_RPAREN] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(5142),
  },
  [1483] = {
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(433),
    [sym_array_type] = STATE(1066),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym_existential_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(1066),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(1066),
    [sym_string] = STATE(418),
    [sym_tuple_type] = STATE(1066),
    [sym_identifier] = ACTIONS(3109),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [sym_true] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1484] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1488),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1489),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3109),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3113),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1485] = {
    [sym_type_parameters] = STATE(2440),
    [sym_formal_parameters] = STATE(2441),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1486] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1488),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1489),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3109),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3113),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1487] = {
    [anon_sym_EQ] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(5144),
    [anon_sym_RPAREN] = ACTIONS(3611),
    [anon_sym_PIPE] = ACTIONS(5146),
    [anon_sym_COMMA] = ACTIONS(3611),
    [sym_comment] = ACTIONS(3),
  },
  [1488] = {
    [sym_formal_parameters] = STATE(2444),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1489] = {
    [anon_sym_EQ_GT] = ACTIONS(5148),
    [sym_comment] = ACTIONS(3),
  },
  [1490] = {
    [anon_sym_COMMA] = ACTIONS(5150),
    [anon_sym_RPAREN] = ACTIONS(5150),
    [sym_comment] = ACTIONS(3),
  },
  [1491] = {
    [sym__initializer] = STATE(2446),
    [sym_type_annotation] = STATE(2447),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(5152),
    [anon_sym_COMMA] = ACTIONS(5152),
    [sym_comment] = ACTIONS(3),
  },
  [1492] = {
    [anon_sym_COMMA] = ACTIONS(5154),
    [anon_sym_RPAREN] = ACTIONS(5154),
    [sym_comment] = ACTIONS(3),
  },
  [1493] = {
    [sym__initializer] = STATE(2448),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(5154),
    [anon_sym_COMMA] = ACTIONS(5154),
    [sym_comment] = ACTIONS(3),
  },
  [1494] = {
    [sym__initializer] = STATE(2438),
    [sym_type_annotation] = STATE(2449),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(5140),
    [anon_sym_COMMA] = ACTIONS(5140),
    [sym_comment] = ACTIONS(3),
  },
  [1495] = {
    [sym__initializer] = STATE(2450),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(5150),
    [anon_sym_COMMA] = ACTIONS(5150),
    [sym_comment] = ACTIONS(3),
  },
  [1496] = {
    [sym__initializer] = STATE(2451),
    [sym_type_annotation] = STATE(2452),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(5156),
    [anon_sym_COMMA] = ACTIONS(5156),
    [sym_comment] = ACTIONS(3),
  },
  [1497] = {
    [anon_sym_COMMA] = ACTIONS(5158),
    [anon_sym_RPAREN] = ACTIONS(5158),
    [sym_comment] = ACTIONS(3),
  },
  [1498] = {
    [sym__initializer] = STATE(2453),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(5158),
    [anon_sym_COMMA] = ACTIONS(5158),
    [sym_comment] = ACTIONS(3),
  },
  [1499] = {
    [sym__initializer] = STATE(2454),
    [sym_type_annotation] = STATE(2455),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(5160),
    [anon_sym_COMMA] = ACTIONS(5160),
    [sym_comment] = ACTIONS(3),
  },
  [1500] = {
    [anon_sym_COMMA] = ACTIONS(5162),
    [anon_sym_RPAREN] = ACTIONS(5162),
    [sym_comment] = ACTIONS(3),
  },
  [1501] = {
    [sym__initializer] = STATE(2456),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(5162),
    [anon_sym_COMMA] = ACTIONS(5162),
    [sym_comment] = ACTIONS(3),
  },
  [1502] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1410),
    [anon_sym_COMMA] = ACTIONS(2101),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1426),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(2101),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_instanceof] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2101),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1426),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(1347),
  },
  [1503] = {
    [anon_sym_COMMA] = ACTIONS(5164),
    [anon_sym_RPAREN] = ACTIONS(5164),
    [sym_comment] = ACTIONS(3),
  },
  [1504] = {
    [sym__initializer] = STATE(2457),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(5164),
    [anon_sym_COMMA] = ACTIONS(5164),
    [sym_comment] = ACTIONS(3),
  },
  [1505] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1410),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1426),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(2105),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_instanceof] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2105),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1426),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(1347),
  },
  [1506] = {
    [anon_sym_COMMA] = ACTIONS(5166),
    [anon_sym_RPAREN] = ACTIONS(5166),
    [sym_comment] = ACTIONS(3),
  },
  [1507] = {
    [sym_union_type] = STATE(2463),
    [sym__type] = STATE(2463),
    [sym_constructor_type] = STATE(2463),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2464),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2463),
    [sym_function_type] = STATE(2463),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2465),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(5168),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5172),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1508] = {
    [anon_sym_COMMA] = ACTIONS(5178),
    [anon_sym_RPAREN] = ACTIONS(5178),
    [sym_comment] = ACTIONS(3),
  },
  [1509] = {
    [sym_new_expression] = STATE(2466),
    [sym_augmented_assignment_expression] = STATE(2466),
    [sym_unary_expression] = STATE(2466),
    [sym_update_expression] = STATE(2466),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(2466),
    [sym_regex] = STATE(2466),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2185),
    [sym__expression] = STATE(2466),
    [sym_non_null_expression] = STATE(2466),
    [sym_yield_expression] = STATE(2466),
    [sym_jsx_fragment] = STATE(2466),
    [sym_jsx_element] = STATE(2466),
    [sym_as_expression] = STATE(2466),
    [sym_internal_module] = STATE(2466),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2466),
    [sym_await_expression] = STATE(2466),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(2466),
    [sym_this] = STATE(2466),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(2466),
    [sym_generator_function] = STATE(2466),
    [sym_call_expression] = STATE(2466),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(2466),
    [sym_ternary_expression] = STATE(2466),
    [sym_binary_expression] = STATE(2466),
    [sym_template_string] = STATE(2466),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2466),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2466),
    [sym_class] = STATE(2466),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(5180),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5180),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5182),
    [sym_true] = ACTIONS(5180),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5180),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [1510] = {
    [sym_new_expression] = STATE(2467),
    [sym_augmented_assignment_expression] = STATE(2467),
    [sym_unary_expression] = STATE(2467),
    [sym_update_expression] = STATE(2467),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(2467),
    [sym_regex] = STATE(2467),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2187),
    [sym__expression] = STATE(2467),
    [sym_non_null_expression] = STATE(2467),
    [sym_yield_expression] = STATE(2467),
    [sym_jsx_fragment] = STATE(2467),
    [sym_jsx_element] = STATE(2467),
    [sym_as_expression] = STATE(2467),
    [sym_internal_module] = STATE(2467),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2467),
    [sym_await_expression] = STATE(2467),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(2467),
    [sym_this] = STATE(2467),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(2467),
    [sym_generator_function] = STATE(2467),
    [sym_call_expression] = STATE(2467),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(2467),
    [sym_ternary_expression] = STATE(2467),
    [sym_binary_expression] = STATE(2467),
    [sym_template_string] = STATE(2467),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2467),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2467),
    [sym_class] = STATE(2467),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(5184),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5184),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5186),
    [sym_true] = ACTIONS(5184),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5184),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [1511] = {
    [anon_sym_COLON] = ACTIONS(5188),
    [anon_sym_EQ_GT] = ACTIONS(5188),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5188),
  },
  [1512] = {
    [aux_sym_export_statement_repeat1] = STATE(1560),
    [sym_decorator] = STATE(1560),
    [sym_object] = STATE(769),
    [sym_accessibility_modifier] = STATE(247),
    [sym_required_parameter] = STATE(2469),
    [sym_array] = STATE(771),
    [sym_rest_parameter] = STATE(2469),
    [sym_optional_parameter] = STATE(2469),
    [sym_this] = STATE(772),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_public] = ACTIONS(1446),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(1442),
    [anon_sym_number] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1446),
    [anon_sym_void] = ACTIONS(1442),
    [anon_sym_string] = ACTIONS(1442),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_any] = ACTIONS(1442),
    [anon_sym_private] = ACTIONS(1446),
    [anon_sym_boolean] = ACTIONS(1442),
    [anon_sym_async] = ACTIONS(1442),
  },
  [1513] = {
    [anon_sym_COMMA] = ACTIONS(5190),
    [anon_sym_RPAREN] = ACTIONS(5190),
    [sym_comment] = ACTIONS(3),
  },
  [1514] = {
    [aux_sym_export_statement_repeat1] = STATE(1512),
    [sym_decorator] = STATE(1512),
    [sym_object] = STATE(769),
    [sym_accessibility_modifier] = STATE(247),
    [sym_required_parameter] = STATE(1513),
    [sym_array] = STATE(771),
    [sym_rest_parameter] = STATE(1513),
    [sym_optional_parameter] = STATE(1513),
    [sym_this] = STATE(772),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_public] = ACTIONS(1446),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(1442),
    [anon_sym_number] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_RPAREN] = ACTIONS(5192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1446),
    [anon_sym_void] = ACTIONS(1442),
    [anon_sym_string] = ACTIONS(1442),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_any] = ACTIONS(1442),
    [anon_sym_private] = ACTIONS(1446),
    [anon_sym_boolean] = ACTIONS(1442),
    [anon_sym_async] = ACTIONS(1442),
  },
  [1515] = {
    [aux_sym_formal_parameters_repeat1] = STATE(1515),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_RPAREN] = ACTIONS(5190),
    [sym_comment] = ACTIONS(3),
  },
  [1516] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_instanceof] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(1347),
  },
  [1517] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(5197),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [1518] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(5197),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [1519] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_instanceof] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(1347),
  },
  [1520] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_RPAREN] = ACTIONS(3622),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [1521] = {
    [anon_sym_COLON] = ACTIONS(3622),
    [anon_sym_RBRACE] = ACTIONS(3622),
    [anon_sym_RPAREN] = ACTIONS(3622),
    [sym_comment] = ACTIONS(3),
    [anon_sym_RBRACK] = ACTIONS(3622),
  },
  [1522] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3630),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5200),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [1523] = {
    [sym_type_arguments] = STATE(2206),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(4638),
    [anon_sym_BANG] = ACTIONS(3699),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_GT_GT_GT] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_is] = ACTIONS(5202),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_RPAREN] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(4643),
    [anon_sym_instanceof] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(4646),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_STAR_STAR] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2204),
    [anon_sym_in] = ACTIONS(3699),
  },
  [1524] = {
    [sym_index_type_query] = STATE(2208),
    [sym_lookup_type] = STATE(2208),
    [sym_flow_maybe_type] = STATE(2208),
    [sym_parenthesized_type] = STATE(2208),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_array_type] = STATE(2208),
    [sym_type_predicate] = STATE(2208),
    [sym_type_query] = STATE(2208),
    [sym_existential_type] = STATE(2208),
    [sym_this_type] = STATE(2208),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(2208),
    [sym__primary_type] = STATE(2208),
    [sym_generic_type] = STATE(2208),
    [sym_literal_type] = STATE(2208),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(2208),
    [sym_string] = STATE(1279),
    [sym_tuple_type] = STATE(2208),
    [sym_identifier] = ACTIONS(3194),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [sym_true] = ACTIONS(2643),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(4648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [1525] = {
    [sym_union_type] = STATE(2213),
    [sym__type] = STATE(2213),
    [sym_constructor_type] = STATE(2213),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1528),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2213),
    [sym_function_type] = STATE(2213),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1529),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3194),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [1526] = {
    [sym_type_parameters] = STATE(2474),
    [sym_formal_parameters] = STATE(2475),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1527] = {
    [sym_union_type] = STATE(2221),
    [sym__type] = STATE(2221),
    [sym_constructor_type] = STATE(2221),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1528),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2221),
    [sym_function_type] = STATE(2221),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1529),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3194),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [1528] = {
    [sym_formal_parameters] = STATE(2478),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1529] = {
    [anon_sym_EQ_GT] = ACTIONS(5204),
    [sym_comment] = ACTIONS(3),
  },
  [1530] = {
    [sym__initializer] = STATE(522),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1332),
    [anon_sym_AMP_EQ] = ACTIONS(1332),
    [anon_sym_PLUS_EQ] = ACTIONS(1332),
    [anon_sym_PIPE] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(3738),
    [anon_sym_CARET_EQ] = ACTIONS(1332),
    [anon_sym_STAR_EQ] = ACTIONS(1332),
    [anon_sym_PIPE_EQ] = ACTIONS(1332),
    [anon_sym_DASH_EQ] = ACTIONS(1332),
    [anon_sym_EQ_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1332),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT_EQ] = ACTIONS(1332),
    [anon_sym_DOT] = ACTIONS(4670),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1347),
  },
  [1531] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1353),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_AMP_EQ] = ACTIONS(1353),
    [anon_sym_PLUS_EQ] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_CARET_EQ] = ACTIONS(1353),
    [anon_sym_STAR_EQ] = ACTIONS(1353),
    [anon_sym_PIPE_EQ] = ACTIONS(1353),
    [anon_sym_DASH_EQ] = ACTIONS(1353),
    [anon_sym_EQ_GT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_SLASH_EQ] = ACTIONS(1353),
    [anon_sym_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1353),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1532] = {
    [sym_new_expression] = STATE(734),
    [sym_augmented_assignment_expression] = STATE(734),
    [sym_unary_expression] = STATE(734),
    [sym_update_expression] = STATE(734),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(734),
    [sym_regex] = STATE(734),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(734),
    [sym_non_null_expression] = STATE(734),
    [sym_as_expression] = STATE(734),
    [sym_jsx_fragment] = STATE(734),
    [sym_yield_expression] = STATE(734),
    [sym_jsx_element] = STATE(734),
    [sym_internal_module] = STATE(734),
    [sym_nested_identifier] = STATE(1092),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(734),
    [sym_await_expression] = STATE(734),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(734),
    [sym_this] = STATE(734),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(734),
    [sym_generator_function] = STATE(734),
    [sym_call_expression] = STATE(734),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(734),
    [sym_ternary_expression] = STATE(734),
    [sym_binary_expression] = STATE(734),
    [sym_template_string] = STATE(734),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(734),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(734),
    [sym_class] = STATE(734),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(5206),
    [sym_false] = ACTIONS(1366),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1366),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1368),
    [sym_true] = ACTIONS(1366),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1366),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [1533] = {
    [sym_new_expression] = STATE(735),
    [sym_augmented_assignment_expression] = STATE(735),
    [sym_unary_expression] = STATE(735),
    [sym_update_expression] = STATE(735),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(735),
    [sym_regex] = STATE(735),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(735),
    [sym_non_null_expression] = STATE(735),
    [sym_as_expression] = STATE(735),
    [sym_jsx_fragment] = STATE(735),
    [sym_yield_expression] = STATE(735),
    [sym_jsx_element] = STATE(735),
    [sym_internal_module] = STATE(735),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(735),
    [sym_await_expression] = STATE(735),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(735),
    [sym_this] = STATE(735),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(735),
    [sym_generator_function] = STATE(735),
    [sym_call_expression] = STATE(735),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(735),
    [sym_ternary_expression] = STATE(735),
    [sym_binary_expression] = STATE(735),
    [sym_template_string] = STATE(735),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(735),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(735),
    [sym_class] = STATE(735),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1370),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4674),
    [sym_true] = ACTIONS(1370),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1370),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [1534] = {
    [sym_new_expression] = STATE(734),
    [sym_augmented_assignment_expression] = STATE(734),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(734),
    [sym_update_expression] = STATE(734),
    [sym_regex] = STATE(734),
    [sym_meta_property] = STATE(734),
    [sym_call_signature] = STATE(243),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(734),
    [sym_non_null_expression] = STATE(734),
    [sym_yield_expression] = STATE(734),
    [sym_jsx_fragment] = STATE(734),
    [sym_jsx_element] = STATE(734),
    [sym_as_expression] = STATE(734),
    [sym_internal_module] = STATE(734),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(734),
    [sym_await_expression] = STATE(734),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(734),
    [sym_this] = STATE(734),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(734),
    [sym_generator_function] = STATE(734),
    [sym_call_expression] = STATE(734),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(734),
    [sym_ternary_expression] = STATE(734),
    [sym_binary_expression] = STATE(734),
    [sym_template_string] = STATE(734),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(734),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(734),
    [sym_class] = STATE(734),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(1353),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_AMP_EQ] = ACTIONS(1353),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1353),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_PIPE_EQ] = ACTIONS(1353),
    [anon_sym_DASH_EQ] = ACTIONS(1353),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(432),
    [sym_true] = ACTIONS(1366),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1353),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(416),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(1366),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_STAR_EQ] = ACTIONS(1353),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_EQ_GT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(1368),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1353),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1366),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1535] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(1819),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(1820),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(1390),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(1392),
    [anon_sym_symbol] = ACTIONS(1392),
    [anon_sym_number] = ACTIONS(1392),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1392),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1392),
    [anon_sym_private] = ACTIONS(1392),
    [anon_sym_boolean] = ACTIONS(1392),
    [anon_sym_async] = ACTIONS(1396),
    [anon_sym_public] = ACTIONS(1392),
    [anon_sym_get] = ACTIONS(1392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1392),
    [anon_sym_string] = ACTIONS(1392),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(1392),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(1392),
    [anon_sym_export] = ACTIONS(1392),
    [anon_sym_namespace] = ACTIONS(1398),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [1536] = {
    [sym_type_arguments] = STATE(1064),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_RPAREN] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(4198),
  },
  [1537] = {
    [anon_sym_AMP] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(3611),
    [anon_sym_PIPE] = ACTIONS(4221),
    [sym_comment] = ACTIONS(3),
  },
  [1538] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(5197),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [1539] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5208),
    [anon_sym_LBRACK] = ACTIONS(5208),
    [anon_sym_BANG] = ACTIONS(5210),
    [anon_sym_SEMI] = ACTIONS(5208),
    [anon_sym_BQUOTE] = ACTIONS(5208),
    [sym__automatic_semicolon] = ACTIONS(5208),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_COMMA] = ACTIONS(5208),
    [anon_sym_LT_LT] = ACTIONS(5208),
    [anon_sym_STAR] = ACTIONS(5210),
    [anon_sym_GT_GT_GT] = ACTIONS(5208),
    [anon_sym_AMP_AMP] = ACTIONS(5208),
    [anon_sym_DASH] = ACTIONS(5210),
    [anon_sym_BANG_EQ] = ACTIONS(5210),
    [anon_sym_LT_EQ] = ACTIONS(5208),
    [anon_sym_LPAREN] = ACTIONS(5208),
    [anon_sym_GT_EQ] = ACTIONS(5208),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5208),
    [anon_sym_QMARK] = ACTIONS(5208),
    [anon_sym_RBRACE] = ACTIONS(5208),
    [anon_sym_as] = ACTIONS(5208),
    [anon_sym_PIPE_PIPE] = ACTIONS(5208),
    [anon_sym_DASH_DASH] = ACTIONS(5208),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_instanceof] = ACTIONS(5208),
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_RPAREN] = ACTIONS(5208),
    [anon_sym_SLASH] = ACTIONS(5210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5208),
    [anon_sym_CARET] = ACTIONS(5208),
    [anon_sym_STAR_STAR] = ACTIONS(5208),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_GT_GT] = ACTIONS(5210),
    [anon_sym_PLUS_PLUS] = ACTIONS(5208),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5208),
    [anon_sym_in] = ACTIONS(5210),
  },
  [1540] = {
    [sym__initializer] = STATE(2482),
    [sym_type_annotation] = STATE(2483),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(5214),
    [anon_sym_COMMA] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
  },
  [1541] = {
    [sym__initializer] = STATE(2450),
    [sym_type_annotation] = STATE(2485),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(5150),
    [anon_sym_QMARK] = ACTIONS(5216),
    [anon_sym_COMMA] = ACTIONS(5150),
    [sym_comment] = ACTIONS(3),
  },
  [1542] = {
    [sym__initializer] = STATE(2487),
    [sym_type_annotation] = STATE(2488),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(5218),
    [anon_sym_QMARK] = ACTIONS(5220),
    [anon_sym_COMMA] = ACTIONS(5218),
    [sym_comment] = ACTIONS(3),
  },
  [1543] = {
    [sym__initializer] = STATE(2450),
    [sym_type_annotation] = STATE(2485),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(5150),
    [anon_sym_COMMA] = ACTIONS(5150),
    [sym_comment] = ACTIONS(3),
  },
  [1544] = {
    [sym__initializer] = STATE(2490),
    [sym_type_annotation] = STATE(2491),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(5222),
    [anon_sym_QMARK] = ACTIONS(5224),
    [anon_sym_COMMA] = ACTIONS(5222),
    [sym_comment] = ACTIONS(3),
  },
  [1545] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(2005),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_RPAREN] = ACTIONS(2005),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [1546] = {
    [anon_sym_COMMA] = ACTIONS(3151),
    [anon_sym_RPAREN] = ACTIONS(3151),
    [sym_comment] = ACTIONS(3),
  },
  [1547] = {
    [anon_sym_COMMA] = ACTIONS(3257),
    [anon_sym_RPAREN] = ACTIONS(3257),
    [sym_comment] = ACTIONS(3),
  },
  [1548] = {
    [aux_sym_formal_parameters_repeat1] = STATE(1515),
    [anon_sym_COMMA] = ACTIONS(5226),
    [anon_sym_RPAREN] = ACTIONS(5192),
    [sym_comment] = ACTIONS(3),
  },
  [1549] = {
    [anon_sym_COMMA] = ACTIONS(3264),
    [anon_sym_RPAREN] = ACTIONS(3264),
    [sym_comment] = ACTIONS(3),
  },
  [1550] = {
    [anon_sym_COMMA] = ACTIONS(5228),
    [anon_sym_RPAREN] = ACTIONS(5228),
    [sym_comment] = ACTIONS(3),
  },
  [1551] = {
    [sym__initializer] = STATE(2493),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(5228),
    [anon_sym_COMMA] = ACTIONS(5228),
    [sym_comment] = ACTIONS(3),
  },
  [1552] = {
    [anon_sym_COMMA] = ACTIONS(5230),
    [anon_sym_RPAREN] = ACTIONS(5230),
    [sym_comment] = ACTIONS(3),
  },
  [1553] = {
    [anon_sym_COMMA] = ACTIONS(5232),
    [anon_sym_RPAREN] = ACTIONS(5232),
    [sym_comment] = ACTIONS(3),
  },
  [1554] = {
    [sym__initializer] = STATE(2494),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(5232),
    [anon_sym_COMMA] = ACTIONS(5232),
    [sym_comment] = ACTIONS(3),
  },
  [1555] = {
    [anon_sym_COMMA] = ACTIONS(5234),
    [anon_sym_RPAREN] = ACTIONS(5234),
    [sym_comment] = ACTIONS(3),
  },
  [1556] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5236),
    [anon_sym_LBRACK] = ACTIONS(5236),
    [anon_sym_BANG] = ACTIONS(5238),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym_BQUOTE] = ACTIONS(5236),
    [sym__automatic_semicolon] = ACTIONS(5236),
    [anon_sym_PIPE] = ACTIONS(5238),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_LT_LT] = ACTIONS(5236),
    [anon_sym_STAR] = ACTIONS(5238),
    [anon_sym_GT_GT_GT] = ACTIONS(5236),
    [anon_sym_AMP_AMP] = ACTIONS(5236),
    [anon_sym_DASH] = ACTIONS(5238),
    [anon_sym_BANG_EQ] = ACTIONS(5238),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_LPAREN] = ACTIONS(5236),
    [anon_sym_GT_EQ] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5238),
    [anon_sym_AMP] = ACTIONS(5238),
    [anon_sym_PERCENT] = ACTIONS(5236),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [anon_sym_as] = ACTIONS(5236),
    [anon_sym_PIPE_PIPE] = ACTIONS(5236),
    [anon_sym_DASH_DASH] = ACTIONS(5236),
    [anon_sym_EQ_EQ] = ACTIONS(5238),
    [anon_sym_instanceof] = ACTIONS(5236),
    [anon_sym_LT] = ACTIONS(5238),
    [anon_sym_RPAREN] = ACTIONS(5236),
    [anon_sym_SLASH] = ACTIONS(5238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5236),
    [anon_sym_CARET] = ACTIONS(5236),
    [anon_sym_STAR_STAR] = ACTIONS(5236),
    [anon_sym_PLUS] = ACTIONS(5238),
    [anon_sym_GT_GT] = ACTIONS(5238),
    [anon_sym_PLUS_PLUS] = ACTIONS(5236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5236),
    [anon_sym_in] = ACTIONS(5238),
  },
  [1557] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(5236),
    [anon_sym_PIPE] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_LT_LT] = ACTIONS(560),
    [anon_sym_STAR] = ACTIONS(566),
    [anon_sym_GT_GT_GT] = ACTIONS(560),
    [anon_sym_AMP_AMP] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(570),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(554),
    [anon_sym_in] = ACTIONS(125),
  },
  [1558] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5240),
    [anon_sym_LBRACK] = ACTIONS(5240),
    [anon_sym_BANG] = ACTIONS(5242),
    [anon_sym_SEMI] = ACTIONS(5240),
    [anon_sym_BQUOTE] = ACTIONS(5240),
    [sym__automatic_semicolon] = ACTIONS(5240),
    [anon_sym_PIPE] = ACTIONS(5242),
    [anon_sym_COMMA] = ACTIONS(5240),
    [anon_sym_LT_LT] = ACTIONS(5240),
    [anon_sym_STAR] = ACTIONS(5242),
    [anon_sym_GT_GT_GT] = ACTIONS(5240),
    [anon_sym_AMP_AMP] = ACTIONS(5240),
    [anon_sym_DASH] = ACTIONS(5242),
    [anon_sym_BANG_EQ] = ACTIONS(5242),
    [anon_sym_LT_EQ] = ACTIONS(5240),
    [anon_sym_LPAREN] = ACTIONS(5240),
    [anon_sym_GT_EQ] = ACTIONS(5240),
    [anon_sym_GT] = ACTIONS(5242),
    [anon_sym_AMP] = ACTIONS(5242),
    [anon_sym_PERCENT] = ACTIONS(5240),
    [anon_sym_QMARK] = ACTIONS(5240),
    [anon_sym_RBRACE] = ACTIONS(5240),
    [anon_sym_as] = ACTIONS(5240),
    [anon_sym_PIPE_PIPE] = ACTIONS(5240),
    [anon_sym_DASH_DASH] = ACTIONS(5240),
    [anon_sym_EQ_EQ] = ACTIONS(5242),
    [anon_sym_instanceof] = ACTIONS(5240),
    [anon_sym_LT] = ACTIONS(5242),
    [anon_sym_RPAREN] = ACTIONS(5240),
    [anon_sym_SLASH] = ACTIONS(5242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5240),
    [anon_sym_CARET] = ACTIONS(5240),
    [anon_sym_STAR_STAR] = ACTIONS(5240),
    [anon_sym_PLUS] = ACTIONS(5242),
    [anon_sym_GT_GT] = ACTIONS(5242),
    [anon_sym_PLUS_PLUS] = ACTIONS(5240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5240),
    [anon_sym_in] = ACTIONS(5242),
  },
  [1559] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(5240),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(5240),
    [anon_sym_PIPE] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(5240),
    [anon_sym_LT_LT] = ACTIONS(560),
    [anon_sym_STAR] = ACTIONS(566),
    [anon_sym_GT_GT_GT] = ACTIONS(560),
    [anon_sym_AMP_AMP] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(570),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(554),
    [anon_sym_in] = ACTIONS(125),
  },
  [1560] = {
    [aux_sym_export_statement_repeat1] = STATE(1560),
    [sym_decorator] = STATE(1560),
    [anon_sym_get] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(1830),
    [sym_identifier] = ACTIONS(3058),
    [sym_readonly] = ACTIONS(3058),
    [anon_sym_module] = ACTIONS(3058),
    [anon_sym_symbol] = ACTIONS(3058),
    [anon_sym_number] = ACTIONS(3058),
    [anon_sym_AT] = ACTIONS(1832),
    [anon_sym_declare] = ACTIONS(3058),
    [anon_sym_this] = ACTIONS(3058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1830),
    [anon_sym_LBRACE] = ACTIONS(1830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(3058),
    [anon_sym_protected] = ACTIONS(3058),
    [anon_sym_string] = ACTIONS(3058),
    [anon_sym_set] = ACTIONS(3058),
    [anon_sym_type] = ACTIONS(3058),
    [anon_sym_import] = ACTIONS(3058),
    [anon_sym_export] = ACTIONS(3058),
    [anon_sym_namespace] = ACTIONS(3058),
    [anon_sym_any] = ACTIONS(3058),
    [anon_sym_private] = ACTIONS(3058),
    [anon_sym_boolean] = ACTIONS(3058),
    [anon_sym_async] = ACTIONS(3058),
    [anon_sym_public] = ACTIONS(3058),
  },
  [1561] = {
    [sym_statement_block] = STATE(2496),
    [sym__automatic_semicolon] = ACTIONS(5244),
    [anon_sym_SEMI] = ACTIONS(5244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(909),
  },
  [1562] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5246),
    [sym_identifier] = ACTIONS(5248),
    [sym__automatic_semicolon] = ACTIONS(5246),
    [anon_sym_BQUOTE] = ACTIONS(5246),
    [anon_sym_debugger] = ACTIONS(5248),
    [ts_builtin_sym_end] = ACTIONS(5246),
    [anon_sym_symbol] = ACTIONS(5248),
    [anon_sym_AT] = ACTIONS(5246),
    [anon_sym_PIPE] = ACTIONS(5248),
    [anon_sym_COMMA] = ACTIONS(5246),
    [anon_sym_DASH] = ACTIONS(5248),
    [anon_sym_STAR] = ACTIONS(5248),
    [anon_sym_GT_GT_GT] = ACTIONS(5246),
    [anon_sym_void] = ACTIONS(5248),
    [anon_sym_break] = ACTIONS(5248),
    [anon_sym_BANG_EQ] = ACTIONS(5248),
    [anon_sym_const] = ACTIONS(5248),
    [anon_sym_GT_EQ] = ACTIONS(5246),
    [sym_super] = ACTIONS(5248),
    [anon_sym_return] = ACTIONS(5248),
    [anon_sym_private] = ACTIONS(5248),
    [anon_sym_get] = ACTIONS(5248),
    [anon_sym_RBRACE] = ACTIONS(5246),
    [anon_sym_PERCENT] = ACTIONS(5246),
    [anon_sym_interface] = ACTIONS(5248),
    [anon_sym_default] = ACTIONS(5248),
    [anon_sym_as] = ACTIONS(5248),
    [anon_sym_delete] = ACTIONS(5248),
    [anon_sym_continue] = ACTIONS(5248),
    [anon_sym_DASH_DASH] = ACTIONS(5246),
    [anon_sym_if] = ACTIONS(5248),
    [anon_sym_instanceof] = ACTIONS(5248),
    [anon_sym_this] = ACTIONS(5248),
    [anon_sym_yield] = ACTIONS(5248),
    [sym_true] = ACTIONS(5248),
    [anon_sym_throw] = ACTIONS(5248),
    [anon_sym_enum] = ACTIONS(5248),
    [anon_sym_protected] = ACTIONS(5248),
    [anon_sym_abstract] = ACTIONS(5248),
    [anon_sym_DOT] = ACTIONS(5248),
    [anon_sym_set] = ACTIONS(5248),
    [anon_sym_type] = ACTIONS(5248),
    [anon_sym_STAR_STAR] = ACTIONS(5246),
    [anon_sym_import] = ACTIONS(5248),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5246),
    [anon_sym_namespace] = ACTIONS(5248),
    [anon_sym_PLUS_PLUS] = ACTIONS(5246),
    [anon_sym_await] = ACTIONS(5248),
    [anon_sym_DQUOTE] = ACTIONS(5246),
    [anon_sym_else] = ACTIONS(5248),
    [anon_sym_BANG] = ACTIONS(5248),
    [anon_sym_for] = ACTIONS(5248),
    [anon_sym_LBRACK] = ACTIONS(5246),
    [sym_false] = ACTIONS(5248),
    [anon_sym_SEMI] = ACTIONS(5246),
    [anon_sym_case] = ACTIONS(5248),
    [anon_sym_module] = ACTIONS(5248),
    [anon_sym_number] = ACTIONS(5248),
    [anon_sym_class] = ACTIONS(5248),
    [anon_sym_declare] = ACTIONS(5248),
    [anon_sym_typeof] = ACTIONS(5248),
    [anon_sym_LT_LT] = ACTIONS(5246),
    [anon_sym_LBRACE] = ACTIONS(5246),
    [anon_sym_AMP_AMP] = ACTIONS(5246),
    [anon_sym_switch] = ACTIONS(5248),
    [anon_sym_LT_EQ] = ACTIONS(5246),
    [anon_sym_LPAREN] = ACTIONS(5246),
    [sym_null] = ACTIONS(5248),
    [anon_sym_GT] = ACTIONS(5248),
    [anon_sym_any] = ACTIONS(5248),
    [anon_sym_boolean] = ACTIONS(5248),
    [anon_sym_async] = ACTIONS(5248),
    [anon_sym_public] = ACTIONS(5248),
    [anon_sym_AMP] = ACTIONS(5248),
    [anon_sym_var] = ACTIONS(5248),
    [anon_sym_QMARK] = ACTIONS(5246),
    [anon_sym_PIPE_PIPE] = ACTIONS(5246),
    [anon_sym_while] = ACTIONS(5248),
    [anon_sym_SQUOTE] = ACTIONS(5246),
    [anon_sym_try] = ACTIONS(5248),
    [anon_sym_EQ_EQ] = ACTIONS(5248),
    [anon_sym_RPAREN] = ACTIONS(5246),
    [anon_sym_LT] = ACTIONS(5248),
    [sym_number] = ACTIONS(5246),
    [anon_sym_SLASH] = ACTIONS(5248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5248),
    [anon_sym_function] = ACTIONS(5248),
    [sym_undefined] = ACTIONS(5248),
    [anon_sym_new] = ACTIONS(5248),
    [anon_sym_CARET] = ACTIONS(5246),
    [anon_sym_let] = ACTIONS(5248),
    [anon_sym_PLUS] = ACTIONS(5248),
    [anon_sym_export] = ACTIONS(5248),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_do] = ACTIONS(5248),
    [anon_sym_TILDE] = ACTIONS(5246),
    [anon_sym_with] = ACTIONS(5248),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5246),
    [anon_sym_in] = ACTIONS(5248),
  },
  [1563] = {
    [sym_identifier] = ACTIONS(5250),
    [anon_sym_BQUOTE] = ACTIONS(5252),
    [anon_sym_debugger] = ACTIONS(5250),
    [anon_sym_symbol] = ACTIONS(5250),
    [anon_sym_AT] = ACTIONS(5252),
    [anon_sym_DASH] = ACTIONS(5250),
    [anon_sym_void] = ACTIONS(5250),
    [anon_sym_break] = ACTIONS(5250),
    [anon_sym_const] = ACTIONS(5250),
    [sym_super] = ACTIONS(5250),
    [anon_sym_return] = ACTIONS(5250),
    [anon_sym_private] = ACTIONS(5250),
    [anon_sym_get] = ACTIONS(5250),
    [anon_sym_RBRACE] = ACTIONS(5252),
    [anon_sym_interface] = ACTIONS(5250),
    [anon_sym_default] = ACTIONS(5250),
    [anon_sym_enum] = ACTIONS(5250),
    [anon_sym_delete] = ACTIONS(5250),
    [anon_sym_continue] = ACTIONS(5250),
    [anon_sym_DASH_DASH] = ACTIONS(5252),
    [anon_sym_if] = ACTIONS(5250),
    [anon_sym_this] = ACTIONS(5250),
    [anon_sym_yield] = ACTIONS(5250),
    [sym_true] = ACTIONS(5250),
    [anon_sym_throw] = ACTIONS(5250),
    [anon_sym_protected] = ACTIONS(5250),
    [anon_sym_abstract] = ACTIONS(5250),
    [anon_sym_set] = ACTIONS(5250),
    [anon_sym_type] = ACTIONS(5250),
    [anon_sym_import] = ACTIONS(5250),
    [anon_sym_namespace] = ACTIONS(5250),
    [anon_sym_PLUS_PLUS] = ACTIONS(5252),
    [anon_sym_await] = ACTIONS(5250),
    [anon_sym_DQUOTE] = ACTIONS(5252),
    [anon_sym_else] = ACTIONS(5250),
    [anon_sym_BANG] = ACTIONS(5252),
    [anon_sym_for] = ACTIONS(5250),
    [anon_sym_LBRACK] = ACTIONS(5252),
    [sym_false] = ACTIONS(5250),
    [anon_sym_SEMI] = ACTIONS(5252),
    [anon_sym_case] = ACTIONS(5250),
    [anon_sym_module] = ACTIONS(5250),
    [anon_sym_number] = ACTIONS(5250),
    [anon_sym_class] = ACTIONS(5250),
    [anon_sym_declare] = ACTIONS(5250),
    [anon_sym_typeof] = ACTIONS(5250),
    [anon_sym_LBRACE] = ACTIONS(5252),
    [anon_sym_switch] = ACTIONS(5250),
    [anon_sym_LPAREN] = ACTIONS(5252),
    [sym_null] = ACTIONS(5250),
    [anon_sym_any] = ACTIONS(5250),
    [anon_sym_boolean] = ACTIONS(5250),
    [anon_sym_async] = ACTIONS(5250),
    [anon_sym_public] = ACTIONS(5250),
    [anon_sym_var] = ACTIONS(5250),
    [anon_sym_while] = ACTIONS(5250),
    [anon_sym_SQUOTE] = ACTIONS(5252),
    [anon_sym_try] = ACTIONS(5250),
    [anon_sym_LT] = ACTIONS(5252),
    [sym_number] = ACTIONS(5252),
    [anon_sym_SLASH] = ACTIONS(5250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5250),
    [anon_sym_function] = ACTIONS(5250),
    [sym_undefined] = ACTIONS(5250),
    [anon_sym_new] = ACTIONS(5250),
    [ts_builtin_sym_end] = ACTIONS(5252),
    [anon_sym_let] = ACTIONS(5250),
    [anon_sym_PLUS] = ACTIONS(5250),
    [anon_sym_export] = ACTIONS(5250),
    [anon_sym_do] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5252),
    [anon_sym_with] = ACTIONS(5250),
  },
  [1564] = {
    [sym_identifier] = ACTIONS(5254),
    [sym_comment] = ACTIONS(3),
  },
  [1565] = {
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_BQUOTE] = ACTIONS(5258),
    [anon_sym_debugger] = ACTIONS(5256),
    [anon_sym_symbol] = ACTIONS(5256),
    [anon_sym_AT] = ACTIONS(5258),
    [anon_sym_DASH] = ACTIONS(5256),
    [anon_sym_void] = ACTIONS(5256),
    [anon_sym_break] = ACTIONS(5256),
    [anon_sym_const] = ACTIONS(5256),
    [sym_super] = ACTIONS(5256),
    [anon_sym_return] = ACTIONS(5256),
    [anon_sym_private] = ACTIONS(5256),
    [anon_sym_get] = ACTIONS(5256),
    [anon_sym_RBRACE] = ACTIONS(5258),
    [anon_sym_interface] = ACTIONS(5256),
    [anon_sym_default] = ACTIONS(5256),
    [anon_sym_enum] = ACTIONS(5256),
    [anon_sym_delete] = ACTIONS(5256),
    [anon_sym_continue] = ACTIONS(5256),
    [anon_sym_DASH_DASH] = ACTIONS(5258),
    [anon_sym_if] = ACTIONS(5256),
    [anon_sym_this] = ACTIONS(5256),
    [anon_sym_yield] = ACTIONS(5256),
    [sym_true] = ACTIONS(5256),
    [anon_sym_throw] = ACTIONS(5256),
    [anon_sym_protected] = ACTIONS(5256),
    [anon_sym_abstract] = ACTIONS(5256),
    [anon_sym_set] = ACTIONS(5256),
    [anon_sym_type] = ACTIONS(5256),
    [anon_sym_import] = ACTIONS(5256),
    [anon_sym_namespace] = ACTIONS(5256),
    [anon_sym_PLUS_PLUS] = ACTIONS(5258),
    [anon_sym_await] = ACTIONS(5256),
    [anon_sym_DQUOTE] = ACTIONS(5258),
    [anon_sym_else] = ACTIONS(5256),
    [anon_sym_BANG] = ACTIONS(5258),
    [anon_sym_for] = ACTIONS(5256),
    [anon_sym_LBRACK] = ACTIONS(5258),
    [sym_false] = ACTIONS(5256),
    [anon_sym_SEMI] = ACTIONS(5258),
    [anon_sym_case] = ACTIONS(5256),
    [anon_sym_module] = ACTIONS(5256),
    [anon_sym_number] = ACTIONS(5256),
    [anon_sym_class] = ACTIONS(5256),
    [anon_sym_declare] = ACTIONS(5256),
    [anon_sym_typeof] = ACTIONS(5256),
    [anon_sym_LBRACE] = ACTIONS(5258),
    [anon_sym_switch] = ACTIONS(5256),
    [anon_sym_LPAREN] = ACTIONS(5258),
    [sym_null] = ACTIONS(5256),
    [anon_sym_any] = ACTIONS(5256),
    [anon_sym_boolean] = ACTIONS(5256),
    [anon_sym_async] = ACTIONS(5256),
    [anon_sym_public] = ACTIONS(5256),
    [anon_sym_var] = ACTIONS(5256),
    [anon_sym_while] = ACTIONS(5256),
    [anon_sym_SQUOTE] = ACTIONS(5258),
    [anon_sym_try] = ACTIONS(5256),
    [anon_sym_LT] = ACTIONS(5258),
    [sym_number] = ACTIONS(5258),
    [anon_sym_SLASH] = ACTIONS(5256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(5256),
    [anon_sym_string] = ACTIONS(5256),
    [anon_sym_function] = ACTIONS(5256),
    [sym_undefined] = ACTIONS(5256),
    [anon_sym_new] = ACTIONS(5256),
    [ts_builtin_sym_end] = ACTIONS(5258),
    [anon_sym_let] = ACTIONS(5256),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_export] = ACTIONS(5256),
    [anon_sym_do] = ACTIONS(5256),
    [anon_sym_TILDE] = ACTIONS(5258),
    [anon_sym_with] = ACTIONS(5256),
  },
  [1566] = {
    [sym_identifier] = ACTIONS(5260),
    [anon_sym_BQUOTE] = ACTIONS(5262),
    [anon_sym_debugger] = ACTIONS(5260),
    [anon_sym_symbol] = ACTIONS(5260),
    [anon_sym_AT] = ACTIONS(5262),
    [anon_sym_DASH] = ACTIONS(5260),
    [anon_sym_void] = ACTIONS(5260),
    [anon_sym_break] = ACTIONS(5260),
    [anon_sym_const] = ACTIONS(5260),
    [sym_super] = ACTIONS(5260),
    [anon_sym_return] = ACTIONS(5260),
    [anon_sym_private] = ACTIONS(5260),
    [anon_sym_get] = ACTIONS(5260),
    [anon_sym_RBRACE] = ACTIONS(5262),
    [anon_sym_interface] = ACTIONS(5260),
    [anon_sym_default] = ACTIONS(5260),
    [anon_sym_enum] = ACTIONS(5260),
    [anon_sym_delete] = ACTIONS(5260),
    [anon_sym_continue] = ACTIONS(5260),
    [anon_sym_DASH_DASH] = ACTIONS(5262),
    [anon_sym_if] = ACTIONS(5260),
    [anon_sym_this] = ACTIONS(5260),
    [anon_sym_yield] = ACTIONS(5260),
    [sym_true] = ACTIONS(5260),
    [anon_sym_throw] = ACTIONS(5260),
    [anon_sym_protected] = ACTIONS(5260),
    [anon_sym_abstract] = ACTIONS(5260),
    [anon_sym_set] = ACTIONS(5260),
    [anon_sym_type] = ACTIONS(5260),
    [anon_sym_import] = ACTIONS(5260),
    [anon_sym_namespace] = ACTIONS(5260),
    [anon_sym_PLUS_PLUS] = ACTIONS(5262),
    [anon_sym_await] = ACTIONS(5260),
    [anon_sym_DQUOTE] = ACTIONS(5262),
    [anon_sym_else] = ACTIONS(5260),
    [anon_sym_BANG] = ACTIONS(5262),
    [anon_sym_for] = ACTIONS(5260),
    [anon_sym_LBRACK] = ACTIONS(5262),
    [sym_false] = ACTIONS(5260),
    [anon_sym_SEMI] = ACTIONS(5262),
    [anon_sym_case] = ACTIONS(5260),
    [anon_sym_module] = ACTIONS(5260),
    [anon_sym_number] = ACTIONS(5260),
    [anon_sym_class] = ACTIONS(5260),
    [anon_sym_declare] = ACTIONS(5260),
    [anon_sym_typeof] = ACTIONS(5260),
    [anon_sym_LBRACE] = ACTIONS(5262),
    [anon_sym_switch] = ACTIONS(5260),
    [anon_sym_LPAREN] = ACTIONS(5262),
    [sym_null] = ACTIONS(5260),
    [anon_sym_any] = ACTIONS(5260),
    [anon_sym_boolean] = ACTIONS(5260),
    [anon_sym_async] = ACTIONS(5260),
    [anon_sym_public] = ACTIONS(5260),
    [anon_sym_var] = ACTIONS(5260),
    [anon_sym_while] = ACTIONS(5260),
    [anon_sym_SQUOTE] = ACTIONS(5262),
    [anon_sym_try] = ACTIONS(5260),
    [anon_sym_LT] = ACTIONS(5262),
    [sym_number] = ACTIONS(5262),
    [anon_sym_SLASH] = ACTIONS(5260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5260),
    [anon_sym_function] = ACTIONS(5260),
    [sym_undefined] = ACTIONS(5260),
    [anon_sym_new] = ACTIONS(5260),
    [ts_builtin_sym_end] = ACTIONS(5262),
    [anon_sym_let] = ACTIONS(5260),
    [anon_sym_PLUS] = ACTIONS(5260),
    [anon_sym_export] = ACTIONS(5260),
    [anon_sym_do] = ACTIONS(5260),
    [anon_sym_TILDE] = ACTIONS(5262),
    [anon_sym_with] = ACTIONS(5260),
  },
  [1567] = {
    [sym_identifier] = ACTIONS(5264),
    [anon_sym_BQUOTE] = ACTIONS(5266),
    [anon_sym_debugger] = ACTIONS(5264),
    [anon_sym_symbol] = ACTIONS(5264),
    [anon_sym_AT] = ACTIONS(5266),
    [anon_sym_DASH] = ACTIONS(5264),
    [anon_sym_void] = ACTIONS(5264),
    [anon_sym_break] = ACTIONS(5264),
    [anon_sym_const] = ACTIONS(5264),
    [sym_super] = ACTIONS(5264),
    [anon_sym_return] = ACTIONS(5264),
    [anon_sym_private] = ACTIONS(5264),
    [anon_sym_get] = ACTIONS(5264),
    [anon_sym_RBRACE] = ACTIONS(5266),
    [anon_sym_interface] = ACTIONS(5264),
    [anon_sym_default] = ACTIONS(5264),
    [anon_sym_enum] = ACTIONS(5264),
    [anon_sym_delete] = ACTIONS(5264),
    [anon_sym_continue] = ACTIONS(5264),
    [anon_sym_DASH_DASH] = ACTIONS(5266),
    [anon_sym_if] = ACTIONS(5264),
    [anon_sym_this] = ACTIONS(5264),
    [anon_sym_yield] = ACTIONS(5264),
    [sym_true] = ACTIONS(5264),
    [anon_sym_throw] = ACTIONS(5264),
    [anon_sym_protected] = ACTIONS(5264),
    [anon_sym_abstract] = ACTIONS(5264),
    [anon_sym_set] = ACTIONS(5264),
    [anon_sym_type] = ACTIONS(5264),
    [anon_sym_import] = ACTIONS(5264),
    [anon_sym_namespace] = ACTIONS(5264),
    [anon_sym_PLUS_PLUS] = ACTIONS(5266),
    [anon_sym_await] = ACTIONS(5264),
    [anon_sym_DQUOTE] = ACTIONS(5266),
    [anon_sym_else] = ACTIONS(5264),
    [anon_sym_BANG] = ACTIONS(5266),
    [anon_sym_for] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(5266),
    [sym_false] = ACTIONS(5264),
    [anon_sym_SEMI] = ACTIONS(5266),
    [anon_sym_case] = ACTIONS(5264),
    [anon_sym_module] = ACTIONS(5264),
    [anon_sym_number] = ACTIONS(5264),
    [anon_sym_class] = ACTIONS(5264),
    [anon_sym_declare] = ACTIONS(5264),
    [anon_sym_typeof] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(5266),
    [anon_sym_switch] = ACTIONS(5264),
    [anon_sym_LPAREN] = ACTIONS(5266),
    [sym_null] = ACTIONS(5264),
    [anon_sym_any] = ACTIONS(5264),
    [anon_sym_boolean] = ACTIONS(5264),
    [anon_sym_async] = ACTIONS(5264),
    [anon_sym_public] = ACTIONS(5264),
    [anon_sym_var] = ACTIONS(5264),
    [anon_sym_while] = ACTIONS(5264),
    [anon_sym_SQUOTE] = ACTIONS(5266),
    [anon_sym_try] = ACTIONS(5264),
    [anon_sym_LT] = ACTIONS(5266),
    [sym_number] = ACTIONS(5266),
    [anon_sym_SLASH] = ACTIONS(5264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5264),
    [anon_sym_function] = ACTIONS(5264),
    [sym_undefined] = ACTIONS(5264),
    [anon_sym_new] = ACTIONS(5264),
    [ts_builtin_sym_end] = ACTIONS(5266),
    [anon_sym_let] = ACTIONS(5264),
    [anon_sym_PLUS] = ACTIONS(5264),
    [anon_sym_export] = ACTIONS(5264),
    [anon_sym_do] = ACTIONS(5264),
    [anon_sym_TILDE] = ACTIONS(5266),
    [anon_sym_with] = ACTIONS(5264),
  },
  [1568] = {
    [anon_sym_GT] = ACTIONS(5268),
    [sym_comment] = ACTIONS(3),
  },
  [1569] = {
    [sym_nested_identifier] = STATE(965),
    [sym_jsx_namespace_name] = STATE(966),
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(5270),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1975),
  },
  [1570] = {
    [anon_sym_GT] = ACTIONS(5272),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_COMMA] = ACTIONS(5272),
    [sym_comment] = ACTIONS(3),
  },
  [1571] = {
    [sym_jsx_fragment] = STATE(2503),
    [sym_jsx_opening_element] = STATE(2504),
    [sym_string] = STATE(2503),
    [sym_jsx_expression] = STATE(2503),
    [sym_jsx_self_closing_element] = STATE(2503),
    [sym_jsx_element] = STATE(2503),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_LT] = ACTIONS(5274),
    [anon_sym_DQUOTE] = ACTIONS(5276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(5278),
  },
  [1572] = {
    [sym_type_arguments] = STATE(1064),
    [anon_sym_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2204),
    [sym_identifier] = ACTIONS(5280),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_is] = ACTIONS(5282),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(5284),
    [anon_sym_GT] = ACTIONS(5286),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(5280),
    [anon_sym_LT] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(5284),
  },
  [1573] = {
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(433),
    [sym_array_type] = STATE(1066),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym_existential_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(1066),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(1066),
    [sym_string] = STATE(418),
    [sym_tuple_type] = STATE(1066),
    [sym_identifier] = ACTIONS(3319),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [sym_true] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1574] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1579),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1580),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3319),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1575] = {
    [sym_type_parameters] = STATE(2506),
    [sym_formal_parameters] = STATE(2507),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1576] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1579),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1580),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3319),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1577] = {
    [anon_sym_GT] = ACTIONS(5284),
    [sym_jsx_identifier] = ACTIONS(5284),
    [sym_identifier] = ACTIONS(5280),
    [anon_sym_EQ] = ACTIONS(5284),
    [anon_sym_SLASH] = ACTIONS(5280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5284),
  },
  [1578] = {
    [anon_sym_EQ] = ACTIONS(5289),
    [anon_sym_GT] = ACTIONS(5289),
    [anon_sym_AMP] = ACTIONS(5291),
    [anon_sym_PIPE] = ACTIONS(5293),
    [anon_sym_COMMA] = ACTIONS(5289),
    [sym_comment] = ACTIONS(3),
  },
  [1579] = {
    [sym_formal_parameters] = STATE(2510),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1580] = {
    [anon_sym_EQ_GT] = ACTIONS(5295),
    [sym_comment] = ACTIONS(3),
  },
  [1581] = {
    [sym_type_arguments] = STATE(1064),
    [anon_sym_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_GT] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(5297),
  },
  [1582] = {
    [sym_identifier] = ACTIONS(4487),
    [anon_sym_DOT] = ACTIONS(4485),
    [sym_jsx_identifier] = ACTIONS(4485),
    [anon_sym_GT] = ACTIONS(4485),
    [anon_sym_LT] = ACTIONS(4485),
    [anon_sym_SLASH] = ACTIONS(4487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4485),
  },
  [1583] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5299),
    [anon_sym_LBRACK] = ACTIONS(5299),
    [anon_sym_BANG] = ACTIONS(5301),
    [anon_sym_SEMI] = ACTIONS(5299),
    [anon_sym_BQUOTE] = ACTIONS(5299),
    [sym__automatic_semicolon] = ACTIONS(5299),
    [anon_sym_PIPE] = ACTIONS(5301),
    [anon_sym_COMMA] = ACTIONS(5299),
    [anon_sym_LT_LT] = ACTIONS(5299),
    [anon_sym_STAR] = ACTIONS(5301),
    [anon_sym_GT_GT_GT] = ACTIONS(5299),
    [anon_sym_AMP_AMP] = ACTIONS(5299),
    [anon_sym_DASH] = ACTIONS(5301),
    [anon_sym_BANG_EQ] = ACTIONS(5301),
    [anon_sym_LT_EQ] = ACTIONS(5299),
    [anon_sym_LPAREN] = ACTIONS(5299),
    [anon_sym_GT_EQ] = ACTIONS(5299),
    [anon_sym_GT] = ACTIONS(5301),
    [anon_sym_AMP] = ACTIONS(5301),
    [anon_sym_PERCENT] = ACTIONS(5299),
    [anon_sym_QMARK] = ACTIONS(5299),
    [anon_sym_RBRACE] = ACTIONS(5299),
    [anon_sym_as] = ACTIONS(5299),
    [anon_sym_PIPE_PIPE] = ACTIONS(5299),
    [anon_sym_DASH_DASH] = ACTIONS(5299),
    [anon_sym_EQ_EQ] = ACTIONS(5301),
    [anon_sym_instanceof] = ACTIONS(5299),
    [anon_sym_LT] = ACTIONS(5301),
    [anon_sym_RPAREN] = ACTIONS(5299),
    [anon_sym_SLASH] = ACTIONS(5301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5299),
    [anon_sym_CARET] = ACTIONS(5299),
    [anon_sym_STAR_STAR] = ACTIONS(5299),
    [anon_sym_PLUS] = ACTIONS(5301),
    [anon_sym_GT_GT] = ACTIONS(5301),
    [anon_sym_PLUS_PLUS] = ACTIONS(5299),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5299),
    [anon_sym_in] = ACTIONS(5301),
  },
  [1584] = {
    [anon_sym_GT] = ACTIONS(5303),
    [sym_jsx_identifier] = ACTIONS(5303),
    [sym_identifier] = ACTIONS(3868),
    [anon_sym_SLASH] = ACTIONS(3868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5303),
  },
  [1585] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2021),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_BANG_EQ] = ACTIONS(2021),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2021),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_QMARK] = ACTIONS(2077),
    [anon_sym_RBRACE] = ACTIONS(5305),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2021),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2081),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [1586] = {
    [anon_sym_RBRACE] = ACTIONS(5305),
    [sym_comment] = ACTIONS(3),
  },
  [1587] = {
    [sym_jsx_text] = ACTIONS(5307),
    [anon_sym_LT] = ACTIONS(5307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5307),
  },
  [1588] = {
    [anon_sym_GT] = ACTIONS(5309),
    [sym_comment] = ACTIONS(3),
  },
  [1589] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(1589),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(1589),
    [sym_jsx_expression] = STATE(1589),
    [anon_sym_GT] = ACTIONS(5311),
    [sym_jsx_identifier] = ACTIONS(5313),
    [sym_identifier] = ACTIONS(5316),
    [anon_sym_SLASH] = ACTIONS(5319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5321),
  },
  [1590] = {
    [sym_jsx_fragment] = STATE(2514),
    [sym_jsx_opening_element] = STATE(2504),
    [sym_string] = STATE(2514),
    [sym_jsx_expression] = STATE(2514),
    [sym_jsx_self_closing_element] = STATE(2514),
    [sym_jsx_element] = STATE(2514),
    [anon_sym_LBRACE] = ACTIONS(1511),
    [anon_sym_LT] = ACTIONS(5274),
    [anon_sym_DQUOTE] = ACTIONS(5276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(5278),
  },
  [1591] = {
    [anon_sym_COMMA] = ACTIONS(5324),
    [anon_sym_GT] = ACTIONS(5324),
    [sym_comment] = ACTIONS(3),
  },
  [1592] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(2516),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(2516),
    [sym_jsx_expression] = STATE(2516),
    [anon_sym_GT] = ACTIONS(5326),
    [sym_identifier] = ACTIONS(1492),
    [sym_jsx_identifier] = ACTIONS(1500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [1593] = {
    [anon_sym_extends] = ACTIONS(5328),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5328),
    [anon_sym_EQ] = ACTIONS(5328),
    [anon_sym_implements] = ACTIONS(5328),
    [anon_sym_LPAREN] = ACTIONS(5328),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5330),
  },
  [1594] = {
    [anon_sym_COMMA] = ACTIONS(5332),
    [anon_sym_GT] = ACTIONS(5332),
    [sym_comment] = ACTIONS(3),
  },
  [1595] = {
    [sym_type_parameter] = STATE(1594),
    [anon_sym_GT] = ACTIONS(5334),
    [sym_identifier] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
  },
  [1596] = {
    [aux_sym_type_parameters_repeat1] = STATE(1596),
    [anon_sym_COMMA] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(5332),
    [sym_comment] = ACTIONS(3),
  },
  [1597] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5339),
    [anon_sym_LBRACK] = ACTIONS(5339),
    [anon_sym_BANG] = ACTIONS(5341),
    [anon_sym_SEMI] = ACTIONS(5339),
    [anon_sym_BQUOTE] = ACTIONS(5339),
    [sym__automatic_semicolon] = ACTIONS(5339),
    [anon_sym_PIPE] = ACTIONS(5341),
    [anon_sym_COMMA] = ACTIONS(5339),
    [anon_sym_LT_LT] = ACTIONS(5339),
    [anon_sym_STAR] = ACTIONS(5341),
    [anon_sym_GT_GT_GT] = ACTIONS(5339),
    [anon_sym_AMP_AMP] = ACTIONS(5339),
    [anon_sym_DASH] = ACTIONS(5341),
    [anon_sym_BANG_EQ] = ACTIONS(5341),
    [anon_sym_LT_EQ] = ACTIONS(5339),
    [anon_sym_LPAREN] = ACTIONS(5339),
    [anon_sym_GT_EQ] = ACTIONS(5339),
    [anon_sym_GT] = ACTIONS(5341),
    [anon_sym_AMP] = ACTIONS(5341),
    [anon_sym_PERCENT] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5339),
    [anon_sym_RBRACE] = ACTIONS(5339),
    [anon_sym_as] = ACTIONS(5339),
    [anon_sym_PIPE_PIPE] = ACTIONS(5339),
    [anon_sym_DASH_DASH] = ACTIONS(5339),
    [anon_sym_EQ_EQ] = ACTIONS(5341),
    [anon_sym_instanceof] = ACTIONS(5339),
    [anon_sym_LT] = ACTIONS(5341),
    [anon_sym_RPAREN] = ACTIONS(5339),
    [anon_sym_SLASH] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5339),
    [anon_sym_CARET] = ACTIONS(5339),
    [anon_sym_STAR_STAR] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(5341),
    [anon_sym_GT_GT] = ACTIONS(5341),
    [anon_sym_PLUS_PLUS] = ACTIONS(5339),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5339),
    [anon_sym_in] = ACTIONS(5341),
  },
  [1598] = {
    [anon_sym_COLON] = ACTIONS(1384),
    [sym__automatic_semicolon] = ACTIONS(1384),
    [anon_sym_RBRACE] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1384),
    [anon_sym_COMMA] = ACTIONS(1384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1384),
  },
  [1599] = {
    [aux_sym_export_statement_repeat1] = STATE(1560),
    [sym_decorator] = STATE(1560),
    [sym_object] = STATE(769),
    [sym_accessibility_modifier] = STATE(247),
    [sym_required_parameter] = STATE(2519),
    [sym_array] = STATE(771),
    [sym_rest_parameter] = STATE(2519),
    [sym_optional_parameter] = STATE(2519),
    [sym_this] = STATE(772),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_public] = ACTIONS(1446),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(1442),
    [anon_sym_number] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1446),
    [anon_sym_void] = ACTIONS(1442),
    [anon_sym_string] = ACTIONS(1442),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_any] = ACTIONS(1442),
    [anon_sym_private] = ACTIONS(1446),
    [anon_sym_boolean] = ACTIONS(1442),
    [anon_sym_async] = ACTIONS(1442),
  },
  [1600] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2522),
    [anon_sym_COMMA] = ACTIONS(5343),
    [anon_sym_RPAREN] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
  },
  [1601] = {
    [sym_type_annotation] = STATE(2523),
    [sym__automatic_semicolon] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(3363),
    [anon_sym_SEMI] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1669),
  },
  [1602] = {
    [sym_union_type] = STATE(2529),
    [sym__type] = STATE(2529),
    [sym_constructor_type] = STATE(2529),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2530),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2529),
    [sym_function_type] = STATE(2529),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2531),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5347),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5353),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [1603] = {
    [sym__automatic_semicolon] = ACTIONS(1669),
    [anon_sym_RBRACE] = ACTIONS(1669),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1669),
    [anon_sym_SEMI] = ACTIONS(1669),
    [anon_sym_COMMA] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1669),
  },
  [1604] = {
    [sym_identifier] = ACTIONS(5357),
    [anon_sym_BQUOTE] = ACTIONS(5359),
    [anon_sym_debugger] = ACTIONS(5357),
    [anon_sym_symbol] = ACTIONS(5357),
    [anon_sym_AT] = ACTIONS(5359),
    [anon_sym_DASH] = ACTIONS(5357),
    [anon_sym_void] = ACTIONS(5357),
    [anon_sym_break] = ACTIONS(5357),
    [anon_sym_const] = ACTIONS(5357),
    [sym_super] = ACTIONS(5357),
    [anon_sym_return] = ACTIONS(5357),
    [anon_sym_private] = ACTIONS(5357),
    [anon_sym_get] = ACTIONS(5357),
    [anon_sym_RBRACE] = ACTIONS(5359),
    [anon_sym_interface] = ACTIONS(5357),
    [anon_sym_default] = ACTIONS(5357),
    [anon_sym_enum] = ACTIONS(5357),
    [anon_sym_delete] = ACTIONS(5357),
    [anon_sym_continue] = ACTIONS(5357),
    [anon_sym_DASH_DASH] = ACTIONS(5359),
    [anon_sym_if] = ACTIONS(5357),
    [anon_sym_this] = ACTIONS(5357),
    [anon_sym_yield] = ACTIONS(5357),
    [sym_true] = ACTIONS(5357),
    [anon_sym_throw] = ACTIONS(5357),
    [anon_sym_protected] = ACTIONS(5357),
    [anon_sym_abstract] = ACTIONS(5357),
    [anon_sym_set] = ACTIONS(5357),
    [anon_sym_type] = ACTIONS(5357),
    [anon_sym_import] = ACTIONS(5357),
    [anon_sym_namespace] = ACTIONS(5357),
    [anon_sym_PLUS_PLUS] = ACTIONS(5359),
    [anon_sym_await] = ACTIONS(5357),
    [anon_sym_DQUOTE] = ACTIONS(5359),
    [anon_sym_else] = ACTIONS(5357),
    [anon_sym_BANG] = ACTIONS(5359),
    [anon_sym_for] = ACTIONS(5357),
    [anon_sym_LBRACK] = ACTIONS(5359),
    [sym_false] = ACTIONS(5357),
    [anon_sym_SEMI] = ACTIONS(5359),
    [anon_sym_case] = ACTIONS(5357),
    [anon_sym_module] = ACTIONS(5357),
    [anon_sym_number] = ACTIONS(5357),
    [anon_sym_class] = ACTIONS(5357),
    [anon_sym_declare] = ACTIONS(5357),
    [anon_sym_typeof] = ACTIONS(5357),
    [anon_sym_LBRACE] = ACTIONS(5359),
    [anon_sym_switch] = ACTIONS(5357),
    [anon_sym_LPAREN] = ACTIONS(5359),
    [sym_null] = ACTIONS(5357),
    [anon_sym_any] = ACTIONS(5357),
    [anon_sym_boolean] = ACTIONS(5357),
    [anon_sym_async] = ACTIONS(5357),
    [anon_sym_public] = ACTIONS(5357),
    [anon_sym_var] = ACTIONS(5357),
    [anon_sym_while] = ACTIONS(5357),
    [anon_sym_SQUOTE] = ACTIONS(5359),
    [anon_sym_try] = ACTIONS(5357),
    [anon_sym_LT] = ACTIONS(5359),
    [sym_number] = ACTIONS(5359),
    [anon_sym_SLASH] = ACTIONS(5357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5357),
    [anon_sym_function] = ACTIONS(5357),
    [sym_undefined] = ACTIONS(5357),
    [anon_sym_new] = ACTIONS(5357),
    [ts_builtin_sym_end] = ACTIONS(5359),
    [anon_sym_let] = ACTIONS(5357),
    [anon_sym_PLUS] = ACTIONS(5357),
    [anon_sym_export] = ACTIONS(5357),
    [anon_sym_do] = ACTIONS(5357),
    [anon_sym_TILDE] = ACTIONS(5359),
    [anon_sym_with] = ACTIONS(5357),
  },
  [1605] = {
    [sym_statement_block] = STATE(2532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(909),
  },
  [1606] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5361),
    [sym_identifier] = ACTIONS(5363),
    [sym__automatic_semicolon] = ACTIONS(5361),
    [anon_sym_BQUOTE] = ACTIONS(5361),
    [anon_sym_debugger] = ACTIONS(5363),
    [ts_builtin_sym_end] = ACTIONS(5361),
    [anon_sym_symbol] = ACTIONS(5363),
    [anon_sym_AT] = ACTIONS(5361),
    [anon_sym_PIPE] = ACTIONS(5363),
    [anon_sym_COMMA] = ACTIONS(5361),
    [anon_sym_DASH] = ACTIONS(5363),
    [anon_sym_STAR] = ACTIONS(5363),
    [anon_sym_GT_GT_GT] = ACTIONS(5361),
    [anon_sym_void] = ACTIONS(5363),
    [anon_sym_break] = ACTIONS(5363),
    [anon_sym_BANG_EQ] = ACTIONS(5363),
    [anon_sym_const] = ACTIONS(5363),
    [anon_sym_GT_EQ] = ACTIONS(5361),
    [sym_super] = ACTIONS(5363),
    [anon_sym_return] = ACTIONS(5363),
    [anon_sym_private] = ACTIONS(5363),
    [anon_sym_get] = ACTIONS(5363),
    [anon_sym_RBRACE] = ACTIONS(5361),
    [anon_sym_PERCENT] = ACTIONS(5361),
    [anon_sym_interface] = ACTIONS(5363),
    [anon_sym_default] = ACTIONS(5363),
    [anon_sym_as] = ACTIONS(5363),
    [anon_sym_delete] = ACTIONS(5363),
    [anon_sym_continue] = ACTIONS(5363),
    [anon_sym_DASH_DASH] = ACTIONS(5361),
    [anon_sym_if] = ACTIONS(5363),
    [anon_sym_instanceof] = ACTIONS(5363),
    [anon_sym_this] = ACTIONS(5363),
    [anon_sym_yield] = ACTIONS(5363),
    [sym_true] = ACTIONS(5363),
    [anon_sym_throw] = ACTIONS(5363),
    [anon_sym_enum] = ACTIONS(5363),
    [anon_sym_protected] = ACTIONS(5363),
    [anon_sym_abstract] = ACTIONS(5363),
    [anon_sym_DOT] = ACTIONS(5363),
    [anon_sym_set] = ACTIONS(5363),
    [anon_sym_type] = ACTIONS(5363),
    [anon_sym_STAR_STAR] = ACTIONS(5361),
    [anon_sym_import] = ACTIONS(5363),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5361),
    [anon_sym_namespace] = ACTIONS(5363),
    [anon_sym_PLUS_PLUS] = ACTIONS(5361),
    [anon_sym_await] = ACTIONS(5363),
    [anon_sym_DQUOTE] = ACTIONS(5361),
    [anon_sym_else] = ACTIONS(5363),
    [anon_sym_BANG] = ACTIONS(5363),
    [anon_sym_for] = ACTIONS(5363),
    [anon_sym_LBRACK] = ACTIONS(5361),
    [sym_false] = ACTIONS(5363),
    [anon_sym_SEMI] = ACTIONS(5361),
    [anon_sym_case] = ACTIONS(5363),
    [anon_sym_module] = ACTIONS(5363),
    [anon_sym_number] = ACTIONS(5363),
    [anon_sym_class] = ACTIONS(5363),
    [anon_sym_declare] = ACTIONS(5363),
    [anon_sym_typeof] = ACTIONS(5363),
    [anon_sym_LT_LT] = ACTIONS(5361),
    [anon_sym_LBRACE] = ACTIONS(5361),
    [anon_sym_AMP_AMP] = ACTIONS(5361),
    [anon_sym_switch] = ACTIONS(5363),
    [anon_sym_LT_EQ] = ACTIONS(5361),
    [anon_sym_LPAREN] = ACTIONS(5361),
    [sym_null] = ACTIONS(5363),
    [anon_sym_GT] = ACTIONS(5363),
    [anon_sym_any] = ACTIONS(5363),
    [anon_sym_boolean] = ACTIONS(5363),
    [anon_sym_async] = ACTIONS(5363),
    [anon_sym_public] = ACTIONS(5363),
    [anon_sym_AMP] = ACTIONS(5363),
    [anon_sym_var] = ACTIONS(5363),
    [anon_sym_QMARK] = ACTIONS(5361),
    [anon_sym_PIPE_PIPE] = ACTIONS(5361),
    [anon_sym_while] = ACTIONS(5363),
    [anon_sym_SQUOTE] = ACTIONS(5361),
    [anon_sym_try] = ACTIONS(5363),
    [anon_sym_EQ_EQ] = ACTIONS(5363),
    [anon_sym_RPAREN] = ACTIONS(5361),
    [anon_sym_LT] = ACTIONS(5363),
    [sym_number] = ACTIONS(5361),
    [anon_sym_SLASH] = ACTIONS(5363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5363),
    [anon_sym_function] = ACTIONS(5363),
    [sym_undefined] = ACTIONS(5363),
    [anon_sym_new] = ACTIONS(5363),
    [anon_sym_CARET] = ACTIONS(5361),
    [anon_sym_let] = ACTIONS(5363),
    [anon_sym_PLUS] = ACTIONS(5363),
    [anon_sym_export] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_do] = ACTIONS(5363),
    [anon_sym_TILDE] = ACTIONS(5361),
    [anon_sym_with] = ACTIONS(5363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5361),
    [anon_sym_in] = ACTIONS(5363),
  },
  [1607] = {
    [sym_type_arguments] = STATE(1064),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(5365),
  },
  [1608] = {
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(433),
    [sym_array_type] = STATE(1066),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym_existential_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(1066),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(1066),
    [sym_string] = STATE(418),
    [sym_tuple_type] = STATE(1066),
    [sym_identifier] = ACTIONS(3367),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [sym_true] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1609] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1613),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1614),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3367),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1610] = {
    [sym_type_parameters] = STATE(2534),
    [sym_formal_parameters] = STATE(2535),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1611] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1613),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1614),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3367),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1612] = {
    [anon_sym_AMP] = ACTIONS(5367),
    [anon_sym_PIPE] = ACTIONS(5369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3611),
  },
  [1613] = {
    [sym_formal_parameters] = STATE(2538),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1614] = {
    [anon_sym_EQ_GT] = ACTIONS(5371),
    [sym_comment] = ACTIONS(3),
  },
  [1615] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1579),
    [anon_sym_STAR] = ACTIONS(1581),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1591),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_SLASH] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1595),
    [anon_sym_PLUS] = ACTIONS(1579),
    [anon_sym_GT_GT] = ACTIONS(1581),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [1616] = {
    [sym_new_expression] = STATE(565),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(565),
    [sym_regex] = STATE(565),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1233),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(565),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(565),
    [sym_this] = STATE(565),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(565),
    [sym_generator_function] = STATE(565),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(565),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(565),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(565),
    [anon_sym_BANG] = ACTIONS(484),
    [sym_identifier] = ACTIONS(1543),
    [sym_false] = ACTIONS(1567),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1567),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1569),
    [sym_true] = ACTIONS(1567),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1567),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
  },
  [1617] = {
    [sym_new_expression] = STATE(565),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(565),
    [sym_regex] = STATE(565),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1240),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(565),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(565),
    [sym_this] = STATE(565),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(565),
    [sym_generator_function] = STATE(565),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(565),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(565),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(565),
    [anon_sym_BANG] = ACTIONS(484),
    [sym_identifier] = ACTIONS(1543),
    [sym_false] = ACTIONS(1567),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1567),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1569),
    [sym_true] = ACTIONS(1567),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1567),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
  },
  [1618] = {
    [anon_sym_EQ_GT] = ACTIONS(5373),
    [sym_comment] = ACTIONS(3),
  },
  [1619] = {
    [anon_sym_EQ_GT] = ACTIONS(5375),
    [sym_comment] = ACTIONS(3),
  },
  [1620] = {
    [sym__initializer] = STATE(522),
    [sym_arguments] = STATE(1268),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(3397),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1531),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [1621] = {
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [1622] = {
    [sym_new_expression] = STATE(836),
    [sym_augmented_assignment_expression] = STATE(836),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(836),
    [sym_update_expression] = STATE(836),
    [sym_regex] = STATE(836),
    [sym_meta_property] = STATE(836),
    [sym_call_signature] = STATE(835),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(836),
    [sym_non_null_expression] = STATE(836),
    [sym_yield_expression] = STATE(836),
    [sym_jsx_fragment] = STATE(836),
    [sym_jsx_element] = STATE(836),
    [sym_as_expression] = STATE(836),
    [sym_internal_module] = STATE(836),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(836),
    [sym_await_expression] = STATE(836),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(836),
    [sym_this] = STATE(836),
    [sym_arguments] = STATE(1270),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(836),
    [sym_generator_function] = STATE(836),
    [sym_call_expression] = STATE(836),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(836),
    [sym_ternary_expression] = STATE(836),
    [sym_binary_expression] = STATE(836),
    [sym_template_string] = STATE(836),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(836),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(836),
    [sym_class] = STATE(836),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(500),
    [sym_true] = ACTIONS(1545),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [sym_false] = ACTIONS(1545),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [sym_null] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [sym_number] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [1623] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_arguments] = STATE(1270),
    [sym_call_signature] = STATE(1618),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(3401),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(3403),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(3403),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(3403),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(3403),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_protected] = ACTIONS(3403),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(3403),
    [anon_sym_type] = ACTIONS(3403),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(3403),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(3403),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(3403),
    [anon_sym_declare] = ACTIONS(3403),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(3403),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(3403),
    [anon_sym_async] = ACTIONS(3403),
    [anon_sym_public] = ACTIONS(3403),
    [anon_sym_EQ_GT] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(3403),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [1624] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [1625] = {
    [sym_new_expression] = STATE(1128),
    [sym_augmented_assignment_expression] = STATE(1128),
    [sym_unary_expression] = STATE(1128),
    [sym_update_expression] = STATE(1128),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(1128),
    [sym_regex] = STATE(1128),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1128),
    [sym_non_null_expression] = STATE(1128),
    [sym_as_expression] = STATE(1128),
    [sym_jsx_fragment] = STATE(1128),
    [sym_yield_expression] = STATE(1128),
    [sym_jsx_element] = STATE(1128),
    [sym_internal_module] = STATE(1128),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1128),
    [sym_await_expression] = STATE(1128),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(1128),
    [sym_this] = STATE(1128),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(1128),
    [sym_generator_function] = STATE(1128),
    [sym_call_expression] = STATE(1128),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(1128),
    [sym_ternary_expression] = STATE(1128),
    [sym_binary_expression] = STATE(1128),
    [sym_template_string] = STATE(1128),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1128),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1128),
    [sym_class] = STATE(1128),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(5377),
    [sym_false] = ACTIONS(2325),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2325),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2327),
    [sym_true] = ACTIONS(2325),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2325),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [1626] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2341),
    [anon_sym_LBRACK] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_SEMI] = ACTIONS(2341),
    [anon_sym_BQUOTE] = ACTIONS(2341),
    [sym__automatic_semicolon] = ACTIONS(2341),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_COMMA] = ACTIONS(2341),
    [anon_sym_LT_LT] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_GT_GT_GT] = ACTIONS(2341),
    [anon_sym_AMP_AMP] = ACTIONS(2341),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_BANG_EQ] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2341),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [anon_sym_GT_EQ] = ACTIONS(2341),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_EQ_GT] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(2343),
    [anon_sym_PERCENT] = ACTIONS(2341),
    [anon_sym_QMARK] = ACTIONS(2341),
    [anon_sym_RBRACE] = ACTIONS(2341),
    [anon_sym_as] = ACTIONS(2341),
    [anon_sym_PIPE_PIPE] = ACTIONS(2341),
    [anon_sym_DASH_DASH] = ACTIONS(2341),
    [anon_sym_EQ_EQ] = ACTIONS(2343),
    [anon_sym_instanceof] = ACTIONS(2341),
    [anon_sym_LT] = ACTIONS(2343),
    [anon_sym_RPAREN] = ACTIONS(2341),
    [anon_sym_SLASH] = ACTIONS(2343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1384),
    [anon_sym_DOT] = ACTIONS(2341),
    [anon_sym_CARET] = ACTIONS(2341),
    [anon_sym_STAR_STAR] = ACTIONS(2341),
    [anon_sym_PLUS] = ACTIONS(2343),
    [anon_sym_GT_GT] = ACTIONS(2343),
    [anon_sym_PLUS_PLUS] = ACTIONS(2341),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2341),
    [anon_sym_in] = ACTIONS(2343),
  },
  [1627] = {
    [sym_template_string] = STATE(542),
    [aux_sym_array_repeat1] = STATE(1149),
    [sym_type_arguments] = STATE(541),
    [sym_type_annotation] = STATE(1251),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(1347),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1410),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_COMMA] = ACTIONS(5379),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_PIPE_PIPE] = ACTIONS(1426),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1347),
    [anon_sym_instanceof] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_RPAREN] = ACTIONS(2385),
    [anon_sym_SLASH] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1434),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1426),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [1628] = {
    [sym__initializer] = STATE(722),
    [sym_type_annotation] = STATE(723),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2307),
    [anon_sym_AMP_EQ] = ACTIONS(2307),
    [anon_sym_PLUS_EQ] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1334),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2307),
    [anon_sym_STAR_EQ] = ACTIONS(2307),
    [anon_sym_PIPE_EQ] = ACTIONS(2307),
    [anon_sym_DASH_EQ] = ACTIONS(2307),
    [anon_sym_EQ_GT] = ACTIONS(2309),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(1341),
    [anon_sym_LT_LT_EQ] = ACTIONS(2307),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_SLASH_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT_EQ] = ACTIONS(2307),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2311),
  },
  [1629] = {
    [sym__initializer] = STATE(732),
    [sym_type_annotation] = STATE(733),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2313),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_AMP_EQ] = ACTIONS(2313),
    [anon_sym_PLUS_EQ] = ACTIONS(2313),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(2313),
    [anon_sym_STAR_EQ] = ACTIONS(2313),
    [anon_sym_PIPE_EQ] = ACTIONS(2313),
    [anon_sym_DASH_EQ] = ACTIONS(2313),
    [anon_sym_EQ_GT] = ACTIONS(2315),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1360),
    [anon_sym_LT_LT_EQ] = ACTIONS(2313),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_SLASH_EQ] = ACTIONS(2313),
    [anon_sym_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1630] = {
    [sym_new_expression] = STATE(1126),
    [sym_augmented_assignment_expression] = STATE(1126),
    [sym__initializer] = STATE(732),
    [sym_unary_expression] = STATE(1126),
    [sym_update_expression] = STATE(1126),
    [sym_regex] = STATE(1126),
    [sym_meta_property] = STATE(1126),
    [sym_call_signature] = STATE(452),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1126),
    [sym_non_null_expression] = STATE(1126),
    [sym_yield_expression] = STATE(1126),
    [sym_jsx_fragment] = STATE(1126),
    [sym_jsx_element] = STATE(1126),
    [sym_as_expression] = STATE(1126),
    [sym_internal_module] = STATE(1126),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1126),
    [sym_await_expression] = STATE(1126),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(1126),
    [sym_this] = STATE(1126),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(1126),
    [sym_generator_function] = STATE(1126),
    [sym_call_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(1126),
    [sym_ternary_expression] = STATE(1126),
    [sym_binary_expression] = STATE(1126),
    [sym_template_string] = STATE(1126),
    [sym_type_annotation] = STATE(733),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1126),
    [sym_class] = STATE(1126),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(787),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2313),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_AMP_EQ] = ACTIONS(2313),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2313),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(2313),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_PIPE_EQ] = ACTIONS(2313),
    [anon_sym_DASH_EQ] = ACTIONS(2313),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2313),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(811),
    [sym_true] = ACTIONS(2317),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2313),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2317),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2317),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_STAR_EQ] = ACTIONS(2313),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_EQ_GT] = ACTIONS(2315),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1360),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(2319),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2313),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2317),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1631] = {
    [sym__initializer] = STATE(732),
    [sym_type_annotation] = STATE(733),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1236),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2313),
    [anon_sym_symbol] = ACTIONS(1236),
    [anon_sym_AMP_EQ] = ACTIONS(2313),
    [anon_sym_PLUS_EQ] = ACTIONS(2313),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_void] = ACTIONS(1236),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(2313),
    [anon_sym_private] = ACTIONS(1236),
    [anon_sym_PIPE_EQ] = ACTIONS(2313),
    [anon_sym_DASH_EQ] = ACTIONS(2313),
    [anon_sym_get] = ACTIONS(1236),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2313),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(1236),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_protected] = ACTIONS(1236),
    [anon_sym_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(1236),
    [anon_sym_type] = ACTIONS(1236),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2313),
    [anon_sym_namespace] = ACTIONS(1236),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [sym_readonly] = ACTIONS(1236),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1238),
    [anon_sym_module] = ACTIONS(1236),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_number] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1236),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1236),
    [anon_sym_STAR_EQ] = ACTIONS(2313),
    [anon_sym_boolean] = ACTIONS(1236),
    [anon_sym_async] = ACTIONS(1236),
    [anon_sym_public] = ACTIONS(1236),
    [anon_sym_EQ_GT] = ACTIONS(2315),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1360),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2313),
    [anon_sym_string] = ACTIONS(1236),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1236),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1632] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(732),
    [sym_formal_parameters] = STATE(57),
    [sym_type_annotation] = STATE(733),
    [sym_call_signature] = STATE(1130),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2333),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2313),
    [anon_sym_symbol] = ACTIONS(2335),
    [anon_sym_AMP_EQ] = ACTIONS(2313),
    [anon_sym_PLUS_EQ] = ACTIONS(2313),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_void] = ACTIONS(2335),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(2313),
    [anon_sym_private] = ACTIONS(2335),
    [anon_sym_PIPE_EQ] = ACTIONS(2313),
    [anon_sym_DASH_EQ] = ACTIONS(2313),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2313),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_protected] = ACTIONS(2335),
    [anon_sym_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(2335),
    [anon_sym_type] = ACTIONS(2335),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2335),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2313),
    [anon_sym_namespace] = ACTIONS(2335),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(2335),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_number] = ACTIONS(2335),
    [anon_sym_declare] = ACTIONS(2335),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(2335),
    [anon_sym_STAR_EQ] = ACTIONS(2313),
    [anon_sym_boolean] = ACTIONS(2335),
    [anon_sym_async] = ACTIONS(2335),
    [anon_sym_public] = ACTIONS(2335),
    [anon_sym_EQ_GT] = ACTIONS(2315),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1360),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2313),
    [anon_sym_string] = ACTIONS(2335),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(2335),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1633] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(732),
    [sym_type_annotation] = STATE(733),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(2313),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_AMP_EQ] = ACTIONS(2313),
    [anon_sym_PLUS_EQ] = ACTIONS(2313),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(2313),
    [anon_sym_STAR_EQ] = ACTIONS(2313),
    [anon_sym_PIPE_EQ] = ACTIONS(2313),
    [anon_sym_DASH_EQ] = ACTIONS(2313),
    [anon_sym_EQ_GT] = ACTIONS(2315),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1360),
    [anon_sym_LT_LT_EQ] = ACTIONS(2313),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_SLASH_EQ] = ACTIONS(2313),
    [anon_sym_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1634] = {
    [sym__initializer] = STATE(764),
    [sym_type_annotation] = STATE(723),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1334),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [1635] = {
    [sym__initializer] = STATE(774),
    [sym_type_annotation] = STATE(775),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1450),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(1453),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1450),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2311),
  },
  [1636] = {
    [sym__initializer] = STATE(777),
    [sym_type_annotation] = STATE(778),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1456),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(1459),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1456),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2311),
  },
  [1637] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1571),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1579),
    [anon_sym_STAR] = ACTIONS(1581),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1583),
    [anon_sym_BANG_EQ] = ACTIONS(1573),
    [anon_sym_LT_EQ] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1571),
    [anon_sym_GT] = ACTIONS(1573),
    [anon_sym_AMP] = ACTIONS(1585),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1591),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1573),
    [anon_sym_instanceof] = ACTIONS(1571),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_SLASH] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1595),
    [anon_sym_PLUS] = ACTIONS(1579),
    [anon_sym_GT_GT] = ACTIONS(1581),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1571),
    [anon_sym_in] = ACTIONS(1573),
  },
  [1638] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1591),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(5381),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1595),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [1639] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(1581),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1591),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(5381),
    [anon_sym_SLASH] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1595),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(1581),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [1640] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1571),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1579),
    [anon_sym_STAR] = ACTIONS(1581),
    [anon_sym_GT_GT_GT] = ACTIONS(1577),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1573),
    [anon_sym_LT_EQ] = ACTIONS(1571),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1571),
    [anon_sym_GT] = ACTIONS(1573),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1591),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1573),
    [anon_sym_instanceof] = ACTIONS(1571),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_SLASH] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1595),
    [anon_sym_PLUS] = ACTIONS(1579),
    [anon_sym_GT_GT] = ACTIONS(1581),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1571),
    [anon_sym_in] = ACTIONS(1573),
  },
  [1641] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3630),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5384),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [1642] = {
    [sym_type_arguments] = STATE(2206),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(4638),
    [anon_sym_BANG] = ACTIONS(3699),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(3699),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_GT_GT_GT] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(5386),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_instanceof] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(4643),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4646),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_STAR_STAR] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2204),
    [anon_sym_in] = ACTIONS(3699),
  },
  [1643] = {
    [sym_index_type_query] = STATE(2208),
    [sym_lookup_type] = STATE(2208),
    [sym_flow_maybe_type] = STATE(2208),
    [sym_parenthesized_type] = STATE(2208),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_array_type] = STATE(2208),
    [sym_type_predicate] = STATE(2208),
    [sym_type_query] = STATE(2208),
    [sym_existential_type] = STATE(2208),
    [sym_this_type] = STATE(2208),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(2208),
    [sym__primary_type] = STATE(2208),
    [sym_generic_type] = STATE(2208),
    [sym_literal_type] = STATE(2208),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(2208),
    [sym_string] = STATE(1279),
    [sym_tuple_type] = STATE(2208),
    [sym_identifier] = ACTIONS(3438),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3444),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [sym_true] = ACTIONS(2643),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(4648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [1644] = {
    [sym_union_type] = STATE(2213),
    [sym__type] = STATE(2213),
    [sym_constructor_type] = STATE(2213),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1647),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2213),
    [sym_function_type] = STATE(2213),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1648),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3438),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3444),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3446),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [1645] = {
    [sym_type_parameters] = STATE(2546),
    [sym_formal_parameters] = STATE(2547),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1646] = {
    [sym_union_type] = STATE(2221),
    [sym__type] = STATE(2221),
    [sym_constructor_type] = STATE(2221),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1647),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2221),
    [sym_function_type] = STATE(2221),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1648),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3438),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3444),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3446),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [1647] = {
    [sym_formal_parameters] = STATE(2550),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1648] = {
    [anon_sym_EQ_GT] = ACTIONS(5388),
    [sym_comment] = ACTIONS(3),
  },
  [1649] = {
    [sym__initializer] = STATE(522),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(3738),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_GT] = ACTIONS(3738),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(3397),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(5390),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1573),
  },
  [1650] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3749),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(2212),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3752),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [1651] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1652] = {
    [sym_new_expression] = STATE(836),
    [sym_augmented_assignment_expression] = STATE(836),
    [sym_unary_expression] = STATE(836),
    [sym_update_expression] = STATE(836),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(836),
    [sym_regex] = STATE(836),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(836),
    [sym_non_null_expression] = STATE(836),
    [sym_as_expression] = STATE(836),
    [sym_jsx_fragment] = STATE(836),
    [sym_yield_expression] = STATE(836),
    [sym_jsx_element] = STATE(836),
    [sym_internal_module] = STATE(836),
    [sym_nested_identifier] = STATE(1092),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(836),
    [sym_await_expression] = STATE(836),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(836),
    [sym_this] = STATE(836),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(836),
    [sym_generator_function] = STATE(836),
    [sym_call_expression] = STATE(836),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(836),
    [sym_ternary_expression] = STATE(836),
    [sym_binary_expression] = STATE(836),
    [sym_template_string] = STATE(836),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(836),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(836),
    [sym_class] = STATE(836),
    [anon_sym_BANG] = ACTIONS(484),
    [sym_identifier] = ACTIONS(5392),
    [sym_false] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1545),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1553),
    [sym_true] = ACTIONS(1545),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
  },
  [1653] = {
    [sym_new_expression] = STATE(840),
    [sym_augmented_assignment_expression] = STATE(840),
    [sym_unary_expression] = STATE(840),
    [sym_update_expression] = STATE(840),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(840),
    [sym_regex] = STATE(840),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(840),
    [sym_non_null_expression] = STATE(840),
    [sym_as_expression] = STATE(840),
    [sym_jsx_fragment] = STATE(840),
    [sym_yield_expression] = STATE(840),
    [sym_jsx_element] = STATE(840),
    [sym_internal_module] = STATE(840),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(840),
    [sym_await_expression] = STATE(840),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(840),
    [sym_this] = STATE(840),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(840),
    [sym_generator_function] = STATE(840),
    [sym_call_expression] = STATE(840),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(840),
    [sym_ternary_expression] = STATE(840),
    [sym_binary_expression] = STATE(840),
    [sym_template_string] = STATE(840),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(840),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(840),
    [sym_class] = STATE(840),
    [anon_sym_BANG] = ACTIONS(484),
    [sym_identifier] = ACTIONS(1543),
    [sym_false] = ACTIONS(1559),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1559),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4674),
    [sym_true] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1559),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
  },
  [1654] = {
    [aux_sym_export_statement_repeat1] = STATE(2003),
    [sym__property_name] = STATE(1807),
    [sym_object] = STATE(384),
    [sym_assignment_pattern] = STATE(405),
    [sym_pair] = STATE(405),
    [sym_method_signature] = STATE(1079),
    [sym_call_signature] = STATE(1079),
    [sym_type_parameters] = STATE(1082),
    [sym_index_signature] = STATE(1079),
    [sym_export_statement] = STATE(1079),
    [sym_method_definition] = STATE(405),
    [aux_sym_object_repeat1] = STATE(406),
    [sym_property_signature] = STATE(1079),
    [sym_decorator] = STATE(2003),
    [sym_construct_signature] = STATE(1079),
    [sym_accessibility_modifier] = STATE(1808),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1807),
    [sym_array] = STATE(385),
    [sym_spread_element] = STATE(405),
    [sym_string] = STATE(1807),
    [sym_identifier] = ACTIONS(4203),
    [anon_sym_LBRACK] = ACTIONS(3785),
    [anon_sym_SEMI] = ACTIONS(2218),
    [anon_sym_module] = ACTIONS(4205),
    [anon_sym_symbol] = ACTIONS(4205),
    [anon_sym_number] = ACTIONS(4205),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(4205),
    [anon_sym_COMMA] = ACTIONS(3789),
    [anon_sym_STAR] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_void] = ACTIONS(4205),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(4205),
    [anon_sym_private] = ACTIONS(4207),
    [anon_sym_boolean] = ACTIONS(4205),
    [anon_sym_static] = ACTIONS(3795),
    [anon_sym_async] = ACTIONS(4209),
    [anon_sym_get] = ACTIONS(4211),
    [anon_sym_RBRACE] = ACTIONS(5394),
    [anon_sym_public] = ACTIONS(4207),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(3801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4207),
    [anon_sym_string] = ACTIONS(4205),
    [anon_sym_set] = ACTIONS(4211),
    [anon_sym_type] = ACTIONS(4205),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(4205),
    [anon_sym_export] = ACTIONS(4215),
    [sym_readonly] = ACTIONS(3805),
    [anon_sym_namespace] = ACTIONS(4205),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [1655] = {
    [sym_new_expression] = STATE(836),
    [sym_augmented_assignment_expression] = STATE(836),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(836),
    [sym_update_expression] = STATE(836),
    [sym_regex] = STATE(836),
    [sym_meta_property] = STATE(836),
    [sym_call_signature] = STATE(835),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(836),
    [sym_non_null_expression] = STATE(836),
    [sym_yield_expression] = STATE(836),
    [sym_jsx_fragment] = STATE(836),
    [sym_jsx_element] = STATE(836),
    [sym_as_expression] = STATE(836),
    [sym_internal_module] = STATE(836),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(836),
    [sym_await_expression] = STATE(836),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(836),
    [sym_this] = STATE(836),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(836),
    [sym_generator_function] = STATE(836),
    [sym_call_expression] = STATE(836),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(836),
    [sym_ternary_expression] = STATE(836),
    [sym_binary_expression] = STATE(836),
    [sym_template_string] = STATE(836),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(836),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(836),
    [sym_class] = STATE(836),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(500),
    [sym_true] = ACTIONS(1545),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(488),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(1545),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1656] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_LT_LT] = ACTIONS(207),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_GT_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_BANG_EQ] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(207),
    [anon_sym_GT_EQ] = ACTIONS(207),
    [anon_sym_RBRACK] = ACTIONS(207),
    [anon_sym_GT] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_RBRACE] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_DASH_DASH] = ACTIONS(207),
    [anon_sym_EQ_EQ] = ACTIONS(209),
    [anon_sym_instanceof] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_RPAREN] = ACTIONS(207),
    [anon_sym_SLASH] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_DOT] = ACTIONS(207),
    [anon_sym_CARET] = ACTIONS(207),
    [anon_sym_STAR_STAR] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_GT_GT] = ACTIONS(209),
    [anon_sym_PLUS_PLUS] = ACTIONS(207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(209),
  },
  [1657] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(1819),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(1820),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(3405),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(3407),
    [anon_sym_symbol] = ACTIONS(3407),
    [anon_sym_number] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3407),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3407),
    [anon_sym_private] = ACTIONS(3407),
    [anon_sym_boolean] = ACTIONS(3407),
    [anon_sym_async] = ACTIONS(3411),
    [anon_sym_public] = ACTIONS(3407),
    [anon_sym_get] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3407),
    [anon_sym_string] = ACTIONS(3407),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(3407),
    [anon_sym_type] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(3407),
    [anon_sym_export] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [1658] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(1591),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(5381),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [1659] = {
    [sym_identifier] = ACTIONS(5396),
    [anon_sym_BQUOTE] = ACTIONS(5398),
    [anon_sym_debugger] = ACTIONS(5396),
    [anon_sym_symbol] = ACTIONS(5396),
    [anon_sym_AT] = ACTIONS(5398),
    [anon_sym_DASH] = ACTIONS(5396),
    [anon_sym_void] = ACTIONS(5396),
    [anon_sym_break] = ACTIONS(5396),
    [anon_sym_const] = ACTIONS(5396),
    [sym_super] = ACTIONS(5396),
    [anon_sym_return] = ACTIONS(5396),
    [anon_sym_private] = ACTIONS(5396),
    [anon_sym_get] = ACTIONS(5396),
    [anon_sym_RBRACE] = ACTIONS(5398),
    [anon_sym_interface] = ACTIONS(5396),
    [anon_sym_default] = ACTIONS(5396),
    [anon_sym_enum] = ACTIONS(5396),
    [anon_sym_delete] = ACTIONS(5396),
    [anon_sym_continue] = ACTIONS(5396),
    [anon_sym_DASH_DASH] = ACTIONS(5398),
    [anon_sym_if] = ACTIONS(5396),
    [anon_sym_this] = ACTIONS(5396),
    [anon_sym_yield] = ACTIONS(5396),
    [sym_true] = ACTIONS(5396),
    [anon_sym_throw] = ACTIONS(5396),
    [anon_sym_protected] = ACTIONS(5396),
    [anon_sym_abstract] = ACTIONS(5396),
    [anon_sym_set] = ACTIONS(5396),
    [anon_sym_type] = ACTIONS(5396),
    [anon_sym_import] = ACTIONS(5396),
    [anon_sym_namespace] = ACTIONS(5396),
    [anon_sym_PLUS_PLUS] = ACTIONS(5398),
    [anon_sym_await] = ACTIONS(5396),
    [anon_sym_DQUOTE] = ACTIONS(5398),
    [anon_sym_else] = ACTIONS(5396),
    [anon_sym_BANG] = ACTIONS(5398),
    [anon_sym_for] = ACTIONS(5396),
    [anon_sym_LBRACK] = ACTIONS(5398),
    [sym_false] = ACTIONS(5396),
    [anon_sym_SEMI] = ACTIONS(5398),
    [anon_sym_case] = ACTIONS(5396),
    [anon_sym_module] = ACTIONS(5396),
    [anon_sym_number] = ACTIONS(5396),
    [anon_sym_class] = ACTIONS(5396),
    [anon_sym_declare] = ACTIONS(5396),
    [anon_sym_typeof] = ACTIONS(5396),
    [anon_sym_LBRACE] = ACTIONS(5398),
    [anon_sym_switch] = ACTIONS(5396),
    [anon_sym_LPAREN] = ACTIONS(5398),
    [sym_null] = ACTIONS(5396),
    [anon_sym_any] = ACTIONS(5396),
    [anon_sym_boolean] = ACTIONS(5396),
    [anon_sym_async] = ACTIONS(5396),
    [anon_sym_public] = ACTIONS(5396),
    [anon_sym_var] = ACTIONS(5396),
    [anon_sym_while] = ACTIONS(5396),
    [anon_sym_SQUOTE] = ACTIONS(5398),
    [anon_sym_try] = ACTIONS(5396),
    [anon_sym_LT] = ACTIONS(5398),
    [sym_number] = ACTIONS(5398),
    [anon_sym_SLASH] = ACTIONS(5396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5396),
    [anon_sym_function] = ACTIONS(5396),
    [sym_undefined] = ACTIONS(5396),
    [anon_sym_new] = ACTIONS(5396),
    [ts_builtin_sym_end] = ACTIONS(5398),
    [anon_sym_let] = ACTIONS(5396),
    [anon_sym_PLUS] = ACTIONS(5396),
    [anon_sym_export] = ACTIONS(5396),
    [anon_sym_do] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5398),
    [anon_sym_with] = ACTIONS(5396),
  },
  [1660] = {
    [sym__automatic_semicolon] = ACTIONS(5400),
    [anon_sym_SEMI] = ACTIONS(5400),
    [anon_sym_from] = ACTIONS(5400),
    [sym_comment] = ACTIONS(3),
  },
  [1661] = {
    [sym__import_export_specifier] = STATE(2556),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(5402),
    [anon_sym_typeof] = ACTIONS(895),
    [anon_sym_type] = ACTIONS(895),
    [sym_comment] = ACTIONS(3),
  },
  [1662] = {
    [sym__automatic_semicolon] = ACTIONS(5404),
    [anon_sym_SEMI] = ACTIONS(5404),
    [anon_sym_from] = ACTIONS(5404),
    [sym_comment] = ACTIONS(3),
  },
  [1663] = {
    [aux_sym_export_clause_repeat1] = STATE(2558),
    [anon_sym_COMMA] = ACTIONS(5406),
    [anon_sym_RBRACE] = ACTIONS(5402),
    [sym_comment] = ACTIONS(3),
  },
  [1664] = {
    [sym_new_expression] = STATE(2559),
    [sym_augmented_assignment_expression] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_update_expression] = STATE(2559),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(2559),
    [sym_regex] = STATE(2559),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(343),
    [sym__expression] = STATE(2559),
    [sym_non_null_expression] = STATE(2559),
    [sym_yield_expression] = STATE(2559),
    [sym_jsx_fragment] = STATE(2559),
    [sym_jsx_element] = STATE(2559),
    [sym_as_expression] = STATE(2559),
    [sym_internal_module] = STATE(2559),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2559),
    [sym_await_expression] = STATE(2559),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(2559),
    [sym_this] = STATE(2559),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(2559),
    [sym_generator_function] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_template_string] = STATE(2559),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2559),
    [sym_class] = STATE(2559),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(5408),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5408),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5410),
    [sym_true] = ACTIONS(5408),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5408),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [1665] = {
    [sym_new_expression] = STATE(2560),
    [sym_augmented_assignment_expression] = STATE(2560),
    [sym_unary_expression] = STATE(2560),
    [sym_update_expression] = STATE(2560),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(2560),
    [sym_regex] = STATE(2560),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2560),
    [sym_non_null_expression] = STATE(2560),
    [sym_as_expression] = STATE(2560),
    [sym_jsx_fragment] = STATE(2560),
    [sym_yield_expression] = STATE(2560),
    [sym_jsx_element] = STATE(2560),
    [sym_internal_module] = STATE(2560),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2560),
    [sym_await_expression] = STATE(2560),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(2560),
    [sym_this] = STATE(2560),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(2560),
    [sym_generator_function] = STATE(2560),
    [sym_call_expression] = STATE(2560),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(2560),
    [sym_ternary_expression] = STATE(2560),
    [sym_binary_expression] = STATE(2560),
    [sym_template_string] = STATE(2560),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2560),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2560),
    [sym_class] = STATE(2560),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(5412),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5412),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5414),
    [sym_true] = ACTIONS(5412),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5412),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [1666] = {
    [sym_new_expression] = STATE(2561),
    [sym_augmented_assignment_expression] = STATE(2561),
    [sym_unary_expression] = STATE(2561),
    [sym_update_expression] = STATE(2561),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(2561),
    [sym_regex] = STATE(2561),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2561),
    [sym_non_null_expression] = STATE(2561),
    [sym_as_expression] = STATE(2561),
    [sym_jsx_fragment] = STATE(2561),
    [sym_yield_expression] = STATE(2561),
    [sym_jsx_element] = STATE(2561),
    [sym_internal_module] = STATE(2561),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2561),
    [sym_await_expression] = STATE(2561),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(2561),
    [sym_this] = STATE(2561),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(2561),
    [sym_generator_function] = STATE(2561),
    [sym_call_expression] = STATE(2561),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(2561),
    [sym_ternary_expression] = STATE(2561),
    [sym_binary_expression] = STATE(2561),
    [sym_template_string] = STATE(2561),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2561),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2561),
    [sym_class] = STATE(2561),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(5416),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5416),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5418),
    [sym_true] = ACTIONS(5416),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5416),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [1667] = {
    [sym_new_expression] = STATE(2562),
    [sym_augmented_assignment_expression] = STATE(2562),
    [sym_unary_expression] = STATE(2562),
    [sym_update_expression] = STATE(2562),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(2562),
    [sym_regex] = STATE(2562),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2562),
    [sym_non_null_expression] = STATE(2562),
    [sym_as_expression] = STATE(2562),
    [sym_jsx_fragment] = STATE(2562),
    [sym_yield_expression] = STATE(2562),
    [sym_jsx_element] = STATE(2562),
    [sym_internal_module] = STATE(2562),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2562),
    [sym_await_expression] = STATE(2562),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(2562),
    [sym_this] = STATE(2562),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(2562),
    [sym_generator_function] = STATE(2562),
    [sym_call_expression] = STATE(2562),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(2562),
    [sym_ternary_expression] = STATE(2562),
    [sym_binary_expression] = STATE(2562),
    [sym_template_string] = STATE(2562),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2562),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2562),
    [sym_class] = STATE(2562),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(5420),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5420),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5422),
    [sym_true] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5420),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [1668] = {
    [sym_new_expression] = STATE(2563),
    [sym_augmented_assignment_expression] = STATE(2563),
    [sym_unary_expression] = STATE(2563),
    [sym_update_expression] = STATE(2563),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(2563),
    [sym_regex] = STATE(2563),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(369),
    [sym__expression] = STATE(2563),
    [sym_non_null_expression] = STATE(2563),
    [sym_yield_expression] = STATE(2563),
    [sym_jsx_fragment] = STATE(2563),
    [sym_jsx_element] = STATE(2563),
    [sym_as_expression] = STATE(2563),
    [sym_internal_module] = STATE(2563),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2563),
    [sym_await_expression] = STATE(2563),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(2563),
    [sym_this] = STATE(2563),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(2563),
    [sym_generator_function] = STATE(2563),
    [sym_call_expression] = STATE(2563),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(2563),
    [sym_ternary_expression] = STATE(2563),
    [sym_binary_expression] = STATE(2563),
    [sym_template_string] = STATE(2563),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2563),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2563),
    [sym_class] = STATE(2563),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(5424),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5424),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5426),
    [sym_true] = ACTIONS(5424),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5424),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [1669] = {
    [sym_new_expression] = STATE(2564),
    [sym_augmented_assignment_expression] = STATE(2564),
    [sym_unary_expression] = STATE(2564),
    [sym_update_expression] = STATE(2564),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(2564),
    [sym_regex] = STATE(2564),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2564),
    [sym_non_null_expression] = STATE(2564),
    [sym_as_expression] = STATE(2564),
    [sym_jsx_fragment] = STATE(2564),
    [sym_yield_expression] = STATE(2564),
    [sym_jsx_element] = STATE(2564),
    [sym_internal_module] = STATE(2564),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2564),
    [sym_await_expression] = STATE(2564),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(2564),
    [sym_this] = STATE(2564),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(2564),
    [sym_generator_function] = STATE(2564),
    [sym_call_expression] = STATE(2564),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(2564),
    [sym_ternary_expression] = STATE(2564),
    [sym_binary_expression] = STATE(2564),
    [sym_template_string] = STATE(2564),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2564),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2564),
    [sym_class] = STATE(2564),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(5428),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5428),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5430),
    [sym_true] = ACTIONS(5428),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5428),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [1670] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(702),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(5432),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [1671] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_SEMI] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(702),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(5432),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [1672] = {
    [anon_sym_EQ_GT] = ACTIONS(5435),
    [sym_comment] = ACTIONS(3),
  },
  [1673] = {
    [anon_sym_EQ_GT] = ACTIONS(5437),
    [sym_comment] = ACTIONS(3),
  },
  [1674] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_SEMI] = ACTIONS(839),
    [anon_sym_BQUOTE] = ACTIONS(839),
    [sym__automatic_semicolon] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_instanceof] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_in] = ACTIONS(841),
  },
  [1675] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(871),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(871),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_LT_LT] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_GT_GT_GT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_BANG_EQ] = ACTIONS(3491),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3545),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(3491),
    [anon_sym_instanceof] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3547),
    [anon_sym_STAR_STAR] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3491),
  },
  [1676] = {
    [sym__initializer] = STATE(522),
    [sym_arguments] = STATE(826),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_SEMI] = ACTIONS(1529),
    [sym__automatic_semicolon] = ACTIONS(1529),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(3489),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1531),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [1677] = {
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(828),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1539),
    [sym__automatic_semicolon] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [1678] = {
    [sym_new_expression] = STATE(836),
    [sym_augmented_assignment_expression] = STATE(836),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(836),
    [sym_update_expression] = STATE(836),
    [sym_regex] = STATE(836),
    [sym_meta_property] = STATE(836),
    [sym_call_signature] = STATE(835),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(836),
    [sym_non_null_expression] = STATE(836),
    [sym_yield_expression] = STATE(836),
    [sym_jsx_fragment] = STATE(836),
    [sym_jsx_element] = STATE(836),
    [sym_as_expression] = STATE(836),
    [sym_internal_module] = STATE(836),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(836),
    [sym_await_expression] = STATE(836),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(836),
    [sym_this] = STATE(836),
    [sym_arguments] = STATE(828),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(836),
    [sym_generator_function] = STATE(836),
    [sym_call_expression] = STATE(836),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(836),
    [sym_ternary_expression] = STATE(836),
    [sym_binary_expression] = STATE(836),
    [sym_template_string] = STATE(836),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(836),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(836),
    [sym_class] = STATE(836),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym__automatic_semicolon] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(500),
    [sym_true] = ACTIONS(1545),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [sym_false] = ACTIONS(1545),
    [anon_sym_SEMI] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [sym_null] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [sym_number] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [1679] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_arguments] = STATE(828),
    [sym_call_signature] = STATE(1672),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym__automatic_semicolon] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(3507),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(3507),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_protected] = ACTIONS(3507),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_set] = ACTIONS(3507),
    [anon_sym_type] = ACTIONS(3507),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(3507),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(3507),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(3507),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(3507),
    [anon_sym_declare] = ACTIONS(3507),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(3507),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(3507),
    [anon_sym_async] = ACTIONS(3507),
    [anon_sym_public] = ACTIONS(3507),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(3507),
    [anon_sym_function] = ACTIONS(698),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(3507),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [1680] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(828),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1539),
    [sym__automatic_semicolon] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [1681] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(915),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_LT_LT] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_GT_GT_GT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_BANG_EQ] = ACTIONS(3491),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3545),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(3491),
    [anon_sym_instanceof] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3547),
    [anon_sym_STAR_STAR] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3491),
  },
  [1682] = {
    [sym_new_expression] = STATE(2567),
    [sym_augmented_assignment_expression] = STATE(2567),
    [sym_unary_expression] = STATE(2567),
    [sym_update_expression] = STATE(2567),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(2567),
    [sym_regex] = STATE(2567),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2567),
    [sym_non_null_expression] = STATE(2567),
    [sym_as_expression] = STATE(2567),
    [sym_jsx_fragment] = STATE(2567),
    [sym_yield_expression] = STATE(2567),
    [sym_jsx_element] = STATE(2567),
    [sym_internal_module] = STATE(2567),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2567),
    [sym_await_expression] = STATE(2567),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(2567),
    [sym_this] = STATE(2567),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(2567),
    [sym_generator_function] = STATE(2567),
    [sym_call_expression] = STATE(2567),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(2567),
    [sym_ternary_expression] = STATE(2567),
    [sym_binary_expression] = STATE(2567),
    [sym_template_string] = STATE(2567),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2567),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2567),
    [sym_class] = STATE(2567),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(5439),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5439),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5441),
    [sym_true] = ACTIONS(5439),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5439),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [1683] = {
    [sym_new_expression] = STATE(2568),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(2568),
    [sym_regex] = STATE(2568),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2568),
    [sym_non_null_expression] = STATE(2568),
    [sym_as_expression] = STATE(2568),
    [sym_jsx_fragment] = STATE(2568),
    [sym_yield_expression] = STATE(2568),
    [sym_jsx_element] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(2568),
    [sym_this] = STATE(2568),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(2568),
    [sym_generator_function] = STATE(2568),
    [sym_call_expression] = STATE(2568),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(2568),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_template_string] = STATE(2568),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2568),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2568),
    [sym_class] = STATE(2568),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(5443),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5443),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5445),
    [sym_true] = ACTIONS(5443),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5443),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [1684] = {
    [sym_new_expression] = STATE(2569),
    [sym_augmented_assignment_expression] = STATE(2569),
    [sym_unary_expression] = STATE(2569),
    [sym_update_expression] = STATE(2569),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(2569),
    [sym_regex] = STATE(2569),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2569),
    [sym_non_null_expression] = STATE(2569),
    [sym_as_expression] = STATE(2569),
    [sym_jsx_fragment] = STATE(2569),
    [sym_yield_expression] = STATE(2569),
    [sym_jsx_element] = STATE(2569),
    [sym_internal_module] = STATE(2569),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2569),
    [sym_await_expression] = STATE(2569),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(2569),
    [sym_this] = STATE(2569),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(2569),
    [sym_generator_function] = STATE(2569),
    [sym_call_expression] = STATE(2569),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(2569),
    [sym_ternary_expression] = STATE(2569),
    [sym_binary_expression] = STATE(2569),
    [sym_template_string] = STATE(2569),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2569),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2569),
    [sym_class] = STATE(2569),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(5447),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5447),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5449),
    [sym_true] = ACTIONS(5447),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5447),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [1685] = {
    [sym_new_expression] = STATE(2570),
    [sym_augmented_assignment_expression] = STATE(2570),
    [sym_unary_expression] = STATE(2570),
    [sym_update_expression] = STATE(2570),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(2570),
    [sym_regex] = STATE(2570),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2570),
    [sym_non_null_expression] = STATE(2570),
    [sym_as_expression] = STATE(2570),
    [sym_jsx_fragment] = STATE(2570),
    [sym_yield_expression] = STATE(2570),
    [sym_jsx_element] = STATE(2570),
    [sym_internal_module] = STATE(2570),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2570),
    [sym_await_expression] = STATE(2570),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(2570),
    [sym_this] = STATE(2570),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(2570),
    [sym_generator_function] = STATE(2570),
    [sym_call_expression] = STATE(2570),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(2570),
    [sym_ternary_expression] = STATE(2570),
    [sym_binary_expression] = STATE(2570),
    [sym_template_string] = STATE(2570),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2570),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2570),
    [sym_class] = STATE(2570),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(5451),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5451),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5453),
    [sym_true] = ACTIONS(5451),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5451),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [1686] = {
    [sym_new_expression] = STATE(2571),
    [sym_augmented_assignment_expression] = STATE(2571),
    [sym_unary_expression] = STATE(2571),
    [sym_update_expression] = STATE(2571),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(2571),
    [sym_regex] = STATE(2571),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2571),
    [sym_non_null_expression] = STATE(2571),
    [sym_as_expression] = STATE(2571),
    [sym_jsx_fragment] = STATE(2571),
    [sym_yield_expression] = STATE(2571),
    [sym_jsx_element] = STATE(2571),
    [sym_internal_module] = STATE(2571),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2571),
    [sym_await_expression] = STATE(2571),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(2571),
    [sym_this] = STATE(2571),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(2571),
    [sym_generator_function] = STATE(2571),
    [sym_call_expression] = STATE(2571),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(2571),
    [sym_ternary_expression] = STATE(2571),
    [sym_binary_expression] = STATE(2571),
    [sym_template_string] = STATE(2571),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2571),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2571),
    [sym_class] = STATE(2571),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(5455),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5455),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5457),
    [sym_true] = ACTIONS(5455),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5455),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [1687] = {
    [sym_union_type] = STATE(941),
    [sym__type] = STATE(941),
    [sym_constructor_type] = STATE(941),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(2577),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_template_string] = STATE(945),
    [sym_intersection_type] = STATE(941),
    [sym_function_type] = STATE(941),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(2578),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(5459),
    [sym_false] = ACTIONS(1907),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_keyof] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_PIPE] = ACTIONS(5461),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_boolean] = ACTIONS(1911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(5463),
    [anon_sym_QMARK] = ACTIONS(5465),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1933),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_new] = ACTIONS(5467),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [1688] = {
    [sym_new_expression] = STATE(2560),
    [sym_constructor_type] = STATE(432),
    [sym_augmented_assignment_expression] = STATE(2560),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(2560),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(2560),
    [sym_type_parameters] = STATE(959),
    [sym_array_type] = STATE(436),
    [sym_yield_expression] = STATE(2560),
    [sym_as_expression] = STATE(2560),
    [sym_jsx_fragment] = STATE(2560),
    [sym_internal_module] = STATE(2560),
    [sym_arrow_function] = STATE(2560),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(868),
    [sym_literal_type] = STATE(436),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(2580),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(2560),
    [sym_subscript_expression] = STATE(868),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(2560),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(2560),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(960),
    [sym_function_type] = STATE(432),
    [sym__type] = STATE(432),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(2560),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(2560),
    [sym__expression] = STATE(2560),
    [sym_non_null_expression] = STATE(2560),
    [sym_jsx_element] = STATE(2560),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(88),
    [sym_await_expression] = STATE(2560),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_this] = STATE(2560),
    [sym_union_type] = STATE(432),
    [sym_anonymous_class] = STATE(2560),
    [sym_call_expression] = STATE(2560),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(2560),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(2560),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(432),
    [sym_parenthesized_expression] = STATE(2560),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2560),
    [sym_class] = STATE(2560),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(5469),
    [sym_false] = ACTIONS(5471),
    [anon_sym_LBRACK] = ACTIONS(1943),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(5473),
    [anon_sym_number] = ACTIONS(5473),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(5475),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5477),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(5479),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_void] = ACTIONS(5481),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(1955),
    [sym_null] = ACTIONS(5412),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(5473),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(5473),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5483),
    [sym_true] = ACTIONS(5471),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(5485),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(5473),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5412),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(5487),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(5477),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [1689] = {
    [sym_new_expression] = STATE(2588),
    [sym_augmented_assignment_expression] = STATE(2588),
    [sym_unary_expression] = STATE(2588),
    [sym_update_expression] = STATE(2588),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(2588),
    [sym_regex] = STATE(2588),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2588),
    [sym_non_null_expression] = STATE(2588),
    [sym_as_expression] = STATE(2588),
    [sym_jsx_fragment] = STATE(2588),
    [sym_yield_expression] = STATE(2588),
    [sym_jsx_element] = STATE(2588),
    [sym_internal_module] = STATE(2588),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2588),
    [sym_await_expression] = STATE(2588),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(2588),
    [sym_this] = STATE(2588),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(2588),
    [sym_generator_function] = STATE(2588),
    [sym_call_expression] = STATE(2588),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(2588),
    [sym_ternary_expression] = STATE(2588),
    [sym_binary_expression] = STATE(2588),
    [sym_template_string] = STATE(2588),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2588),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2588),
    [sym_class] = STATE(2588),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(5489),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5489),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5491),
    [sym_true] = ACTIONS(5489),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5489),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [1690] = {
    [sym__automatic_semicolon] = ACTIONS(5493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(5493),
  },
  [1691] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5495),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [1692] = {
    [sym_parenthesized_expression] = STATE(2591),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [1693] = {
    [anon_sym_await] = ACTIONS(5497),
    [anon_sym_LPAREN] = ACTIONS(5499),
    [sym_comment] = ACTIONS(3),
  },
  [1694] = {
    [sym_type_alias_declaration] = STATE(193),
    [aux_sym_export_statement_repeat1] = STATE(2597),
    [sym__declaration] = STATE(193),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(193),
    [sym_import_alias] = STATE(193),
    [sym_export_statement] = STATE(193),
    [sym_generator_function] = STATE(193),
    [sym_lexical_declaration] = STATE(193),
    [sym_internal_module] = STATE(193),
    [sym_decorator] = STATE(2597),
    [sym_enum_declaration] = STATE(193),
    [sym_function] = STATE(193),
    [sym_function_signature] = STATE(193),
    [sym_variable_declaration] = STATE(193),
    [sym_abstract_class] = STATE(193),
    [sym_module] = STATE(193),
    [sym_interface_declaration] = STATE(193),
    [sym_class] = STATE(193),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(324),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(1647),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(5501),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(1653),
    [anon_sym_declare] = ACTIONS(5503),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(1657),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(1659),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(5505),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1695] = {
    [sym_parenthesized_expression] = STATE(2598),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [1696] = {
    [sym_type_alias_declaration] = STATE(300),
    [aux_sym_export_statement_repeat1] = STATE(2597),
    [sym__declaration] = STATE(300),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(300),
    [sym_import_alias] = STATE(300),
    [sym_export_statement] = STATE(300),
    [sym_generator_function] = STATE(300),
    [sym_export_clause] = STATE(301),
    [sym_lexical_declaration] = STATE(300),
    [sym_internal_module] = STATE(300),
    [sym_decorator] = STATE(2597),
    [sym_enum_declaration] = STATE(300),
    [sym_function] = STATE(300),
    [sym_function_signature] = STATE(300),
    [sym_variable_declaration] = STATE(300),
    [sym_abstract_class] = STATE(300),
    [sym_module] = STATE(300),
    [sym_interface_declaration] = STATE(300),
    [sym_class] = STATE(300),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(508),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(511),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_as] = ACTIONS(515),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(1647),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1649),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1663),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(1653),
    [anon_sym_declare] = ACTIONS(5503),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(1657),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(1659),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(5505),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1697] = {
    [sym_parenthesized_expression] = STATE(2599),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [1698] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(2457),
    [anon_sym_else] = ACTIONS(5507),
  },
  [1699] = {
    [aux_sym_export_statement_repeat1] = STATE(320),
    [sym_decorator] = STATE(320),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(5509),
    [anon_sym_class] = ACTIONS(546),
    [sym_comment] = ACTIONS(3),
  },
  [1700] = {
    [sym_class_heritage] = STATE(2602),
    [sym_type_parameters] = STATE(2603),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(1191),
    [anon_sym_extends] = ACTIONS(1131),
    [anon_sym_implements] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(959),
  },
  [1701] = {
    [sym_array] = STATE(2606),
    [sym_object] = STATE(2607),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(5511),
    [anon_sym_var] = ACTIONS(5513),
    [anon_sym_const] = ACTIONS(5513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_let] = ACTIONS(5513),
  },
  [1702] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(5515),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5517),
  },
  [1703] = {
    [sym_variable_declarator] = STATE(97),
    [sym_array] = STATE(2611),
    [sym_object] = STATE(2612),
    [sym_identifier] = ACTIONS(5519),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [1704] = {
    [sym_variable_declarator] = STATE(258),
    [sym_array] = STATE(2611),
    [sym_object] = STATE(2612),
    [sym_identifier] = ACTIONS(5519),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [1705] = {
    [sym_new_expression] = STATE(59),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_yield_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_internal_module] = STATE(59),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(59),
    [sym_await_expression] = STATE(59),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2613),
    [sym_sequence_expression] = STATE(62),
    [sym_string] = STATE(59),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(2613),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(59),
    [sym_generator_function] = STATE(59),
    [sym_call_expression] = STATE(59),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(59),
    [sym_ternary_expression] = STATE(59),
    [sym_binary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(59),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [1706] = {
    [sym__initializer] = STATE(321),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(5521),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5523),
  },
  [1707] = {
    [sym__initializer] = STATE(336),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(5525),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5527),
  },
  [1708] = {
    [sym_identifier] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
  },
  [1709] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(2620),
    [sym_identifier] = ACTIONS(5531),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1710] = {
    [sym_type_parameters] = STATE(815),
    [sym_formal_parameters] = STATE(816),
    [sym_call_signature] = STATE(2621),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1711] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(2623),
    [sym_identifier] = ACTIONS(5533),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1712] = {
    [sym_statement_block] = STATE(1267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [1713] = {
    [sym_identifier] = ACTIONS(5535),
    [sym_comment] = ACTIONS(3),
  },
  [1714] = {
    [sym_new_expression] = STATE(245),
    [sym_augmented_assignment_expression] = STATE(245),
    [sym_unary_expression] = STATE(245),
    [sym_update_expression] = STATE(245),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(245),
    [sym_regex] = STATE(245),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(245),
    [sym_non_null_expression] = STATE(245),
    [sym_as_expression] = STATE(245),
    [sym_jsx_fragment] = STATE(245),
    [sym_yield_expression] = STATE(245),
    [sym_jsx_element] = STATE(245),
    [sym_internal_module] = STATE(245),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(245),
    [sym_await_expression] = STATE(245),
    [sym_member_expression] = STATE(246),
    [sym_sequence_expression] = STATE(248),
    [sym_string] = STATE(245),
    [sym_this] = STATE(245),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(245),
    [sym_generator_function] = STATE(245),
    [sym_call_expression] = STATE(245),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(245),
    [sym_ternary_expression] = STATE(245),
    [sym_binary_expression] = STATE(245),
    [sym_template_string] = STATE(245),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(245),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(245),
    [sym_class] = STATE(245),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(410),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(430),
    [sym_true] = ACTIONS(410),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(410),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [1715] = {
    [sym__automatic_semicolon] = ACTIONS(5537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(5537),
  },
  [1716] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym__automatic_semicolon] = ACTIONS(5493),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(5493),
    [anon_sym_in] = ACTIONS(3491),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_LT_LT] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_GT_GT_GT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_BANG_EQ] = ACTIONS(3491),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3545),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(3491),
    [anon_sym_instanceof] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3547),
    [anon_sym_STAR_STAR] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_BANG] = ACTIONS(582),
  },
  [1717] = {
    [sym_class_body] = STATE(2625),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(322),
  },
  [1718] = {
    [sym_class_heritage] = STATE(2626),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(2625),
    [anon_sym_extends] = ACTIONS(1131),
    [anon_sym_implements] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(322),
  },
  [1719] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5539),
    [sym_identifier] = ACTIONS(5541),
    [sym__automatic_semicolon] = ACTIONS(5539),
    [anon_sym_BQUOTE] = ACTIONS(5539),
    [anon_sym_debugger] = ACTIONS(5541),
    [ts_builtin_sym_end] = ACTIONS(5539),
    [anon_sym_symbol] = ACTIONS(5541),
    [anon_sym_AT] = ACTIONS(5539),
    [anon_sym_PIPE] = ACTIONS(5541),
    [anon_sym_COMMA] = ACTIONS(5539),
    [anon_sym_DASH] = ACTIONS(5541),
    [anon_sym_STAR] = ACTIONS(5541),
    [anon_sym_GT_GT_GT] = ACTIONS(5539),
    [anon_sym_void] = ACTIONS(5541),
    [anon_sym_break] = ACTIONS(5541),
    [anon_sym_BANG_EQ] = ACTIONS(5541),
    [anon_sym_const] = ACTIONS(5541),
    [anon_sym_GT_EQ] = ACTIONS(5539),
    [sym_super] = ACTIONS(5541),
    [anon_sym_return] = ACTIONS(5541),
    [anon_sym_private] = ACTIONS(5541),
    [anon_sym_get] = ACTIONS(5541),
    [anon_sym_RBRACE] = ACTIONS(5539),
    [anon_sym_PERCENT] = ACTIONS(5539),
    [anon_sym_interface] = ACTIONS(5541),
    [anon_sym_default] = ACTIONS(5541),
    [anon_sym_as] = ACTIONS(5541),
    [anon_sym_delete] = ACTIONS(5541),
    [anon_sym_continue] = ACTIONS(5541),
    [anon_sym_DASH_DASH] = ACTIONS(5539),
    [anon_sym_if] = ACTIONS(5541),
    [anon_sym_instanceof] = ACTIONS(5541),
    [anon_sym_this] = ACTIONS(5541),
    [anon_sym_yield] = ACTIONS(5541),
    [sym_true] = ACTIONS(5541),
    [anon_sym_throw] = ACTIONS(5541),
    [anon_sym_enum] = ACTIONS(5541),
    [anon_sym_protected] = ACTIONS(5541),
    [anon_sym_abstract] = ACTIONS(5541),
    [anon_sym_DOT] = ACTIONS(5541),
    [anon_sym_set] = ACTIONS(5541),
    [anon_sym_type] = ACTIONS(5541),
    [anon_sym_STAR_STAR] = ACTIONS(5539),
    [anon_sym_import] = ACTIONS(5541),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5539),
    [anon_sym_namespace] = ACTIONS(5541),
    [anon_sym_PLUS_PLUS] = ACTIONS(5539),
    [anon_sym_await] = ACTIONS(5541),
    [anon_sym_DQUOTE] = ACTIONS(5539),
    [anon_sym_else] = ACTIONS(5541),
    [anon_sym_BANG] = ACTIONS(5541),
    [anon_sym_for] = ACTIONS(5541),
    [anon_sym_LBRACK] = ACTIONS(5539),
    [sym_false] = ACTIONS(5541),
    [anon_sym_SEMI] = ACTIONS(5539),
    [anon_sym_case] = ACTIONS(5541),
    [anon_sym_module] = ACTIONS(5541),
    [anon_sym_number] = ACTIONS(5541),
    [anon_sym_class] = ACTIONS(5541),
    [anon_sym_declare] = ACTIONS(5541),
    [anon_sym_typeof] = ACTIONS(5541),
    [anon_sym_LT_LT] = ACTIONS(5539),
    [anon_sym_LBRACE] = ACTIONS(5539),
    [anon_sym_AMP_AMP] = ACTIONS(5539),
    [anon_sym_switch] = ACTIONS(5541),
    [anon_sym_LT_EQ] = ACTIONS(5539),
    [anon_sym_LPAREN] = ACTIONS(5539),
    [sym_null] = ACTIONS(5541),
    [anon_sym_GT] = ACTIONS(5541),
    [anon_sym_any] = ACTIONS(5541),
    [anon_sym_boolean] = ACTIONS(5541),
    [anon_sym_async] = ACTIONS(5541),
    [anon_sym_public] = ACTIONS(5541),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_var] = ACTIONS(5541),
    [anon_sym_QMARK] = ACTIONS(5539),
    [anon_sym_PIPE_PIPE] = ACTIONS(5539),
    [anon_sym_while] = ACTIONS(5541),
    [anon_sym_SQUOTE] = ACTIONS(5539),
    [anon_sym_try] = ACTIONS(5541),
    [anon_sym_EQ_EQ] = ACTIONS(5541),
    [anon_sym_RPAREN] = ACTIONS(5539),
    [anon_sym_LT] = ACTIONS(5541),
    [sym_number] = ACTIONS(5539),
    [anon_sym_SLASH] = ACTIONS(5541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5541),
    [anon_sym_function] = ACTIONS(5541),
    [sym_undefined] = ACTIONS(5541),
    [anon_sym_new] = ACTIONS(5541),
    [anon_sym_CARET] = ACTIONS(5539),
    [anon_sym_let] = ACTIONS(5541),
    [anon_sym_PLUS] = ACTIONS(5541),
    [anon_sym_export] = ACTIONS(5541),
    [anon_sym_GT_GT] = ACTIONS(5541),
    [anon_sym_do] = ACTIONS(5541),
    [anon_sym_TILDE] = ACTIONS(5539),
    [anon_sym_with] = ACTIONS(5541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5539),
    [anon_sym_in] = ACTIONS(5541),
  },
  [1720] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5543),
    [anon_sym_LBRACK] = ACTIONS(5543),
    [anon_sym_BANG] = ACTIONS(5545),
    [anon_sym_SEMI] = ACTIONS(5543),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [sym__automatic_semicolon] = ACTIONS(5543),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_COMMA] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5543),
    [anon_sym_STAR] = ACTIONS(5545),
    [anon_sym_GT_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_DASH] = ACTIONS(5545),
    [anon_sym_BANG_EQ] = ACTIONS(5545),
    [anon_sym_LT_EQ] = ACTIONS(5543),
    [anon_sym_LPAREN] = ACTIONS(5543),
    [anon_sym_GT_EQ] = ACTIONS(5543),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5545),
    [anon_sym_PERCENT] = ACTIONS(5543),
    [anon_sym_QMARK] = ACTIONS(5543),
    [anon_sym_RBRACE] = ACTIONS(5543),
    [anon_sym_as] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_DASH_DASH] = ACTIONS(5543),
    [anon_sym_EQ_EQ] = ACTIONS(5545),
    [anon_sym_instanceof] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_RPAREN] = ACTIONS(5543),
    [anon_sym_SLASH] = ACTIONS(5545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5543),
    [anon_sym_CARET] = ACTIONS(5543),
    [anon_sym_STAR_STAR] = ACTIONS(5543),
    [anon_sym_PLUS] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5545),
    [anon_sym_PLUS_PLUS] = ACTIONS(5543),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5543),
    [anon_sym_in] = ACTIONS(5545),
  },
  [1721] = {
    [sym_union_type] = STATE(2630),
    [sym__type] = STATE(2630),
    [sym_constructor_type] = STATE(2630),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2631),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2630),
    [sym_function_type] = STATE(2630),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2632),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1839),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5549),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1722] = {
    [sym_formal_parameters] = STATE(2633),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1723] = {
    [anon_sym_EQ_GT] = ACTIONS(5553),
    [sym_comment] = ACTIONS(3),
  },
  [1724] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(902),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(903),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1839),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(1845),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(1847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1725] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(902),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(903),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1839),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(1845),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(1847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1726] = {
    [anon_sym_EQ_GT] = ACTIONS(5555),
    [sym_comment] = ACTIONS(3),
  },
  [1727] = {
    [sym_union_type] = STATE(2636),
    [sym__type] = STATE(2636),
    [sym_constructor_type] = STATE(2636),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(902),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2636),
    [sym_function_type] = STATE(2636),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(903),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1839),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(1845),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(1847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1728] = {
    [sym_new_expression] = STATE(2637),
    [sym_augmented_assignment_expression] = STATE(2637),
    [sym_unary_expression] = STATE(2637),
    [sym_update_expression] = STATE(2637),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(2637),
    [sym_regex] = STATE(2637),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1233),
    [sym__expression] = STATE(2637),
    [sym_non_null_expression] = STATE(2637),
    [sym_yield_expression] = STATE(2637),
    [sym_jsx_fragment] = STATE(2637),
    [sym_jsx_element] = STATE(2637),
    [sym_as_expression] = STATE(2637),
    [sym_internal_module] = STATE(2637),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2637),
    [sym_await_expression] = STATE(2637),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(2637),
    [sym_this] = STATE(2637),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(2637),
    [sym_generator_function] = STATE(2637),
    [sym_call_expression] = STATE(2637),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(2637),
    [sym_ternary_expression] = STATE(2637),
    [sym_binary_expression] = STATE(2637),
    [sym_template_string] = STATE(2637),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2637),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2637),
    [sym_class] = STATE(2637),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(5557),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5557),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5559),
    [sym_true] = ACTIONS(5557),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5557),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [1729] = {
    [sym_new_expression] = STATE(2638),
    [sym_augmented_assignment_expression] = STATE(2638),
    [sym_unary_expression] = STATE(2638),
    [sym_update_expression] = STATE(2638),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(2638),
    [sym_regex] = STATE(2638),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2638),
    [sym_non_null_expression] = STATE(2638),
    [sym_as_expression] = STATE(2638),
    [sym_jsx_fragment] = STATE(2638),
    [sym_yield_expression] = STATE(2638),
    [sym_jsx_element] = STATE(2638),
    [sym_internal_module] = STATE(2638),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2638),
    [sym_await_expression] = STATE(2638),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(2638),
    [sym_this] = STATE(2638),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(2638),
    [sym_generator_function] = STATE(2638),
    [sym_call_expression] = STATE(2638),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(2638),
    [sym_ternary_expression] = STATE(2638),
    [sym_binary_expression] = STATE(2638),
    [sym_template_string] = STATE(2638),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2638),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2638),
    [sym_class] = STATE(2638),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(5561),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5561),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5563),
    [sym_true] = ACTIONS(5561),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5561),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [1730] = {
    [sym_new_expression] = STATE(2639),
    [sym_augmented_assignment_expression] = STATE(2639),
    [sym_unary_expression] = STATE(2639),
    [sym_update_expression] = STATE(2639),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(2639),
    [sym_regex] = STATE(2639),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2639),
    [sym_non_null_expression] = STATE(2639),
    [sym_as_expression] = STATE(2639),
    [sym_jsx_fragment] = STATE(2639),
    [sym_yield_expression] = STATE(2639),
    [sym_jsx_element] = STATE(2639),
    [sym_internal_module] = STATE(2639),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2639),
    [sym_await_expression] = STATE(2639),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(2639),
    [sym_this] = STATE(2639),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(2639),
    [sym_generator_function] = STATE(2639),
    [sym_call_expression] = STATE(2639),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(2639),
    [sym_ternary_expression] = STATE(2639),
    [sym_binary_expression] = STATE(2639),
    [sym_template_string] = STATE(2639),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2639),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2639),
    [sym_class] = STATE(2639),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(5565),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5565),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5567),
    [sym_true] = ACTIONS(5565),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5565),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [1731] = {
    [sym_new_expression] = STATE(2640),
    [sym_augmented_assignment_expression] = STATE(2640),
    [sym_unary_expression] = STATE(2640),
    [sym_update_expression] = STATE(2640),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(2640),
    [sym_regex] = STATE(2640),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2640),
    [sym_non_null_expression] = STATE(2640),
    [sym_as_expression] = STATE(2640),
    [sym_jsx_fragment] = STATE(2640),
    [sym_yield_expression] = STATE(2640),
    [sym_jsx_element] = STATE(2640),
    [sym_internal_module] = STATE(2640),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2640),
    [sym_await_expression] = STATE(2640),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(2640),
    [sym_this] = STATE(2640),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(2640),
    [sym_generator_function] = STATE(2640),
    [sym_call_expression] = STATE(2640),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(2640),
    [sym_ternary_expression] = STATE(2640),
    [sym_binary_expression] = STATE(2640),
    [sym_template_string] = STATE(2640),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2640),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2640),
    [sym_class] = STATE(2640),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(5569),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5569),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5571),
    [sym_true] = ACTIONS(5569),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5569),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [1732] = {
    [sym_new_expression] = STATE(2641),
    [sym_augmented_assignment_expression] = STATE(2641),
    [sym_unary_expression] = STATE(2641),
    [sym_update_expression] = STATE(2641),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(2641),
    [sym_regex] = STATE(2641),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1240),
    [sym__expression] = STATE(2641),
    [sym_non_null_expression] = STATE(2641),
    [sym_yield_expression] = STATE(2641),
    [sym_jsx_fragment] = STATE(2641),
    [sym_jsx_element] = STATE(2641),
    [sym_as_expression] = STATE(2641),
    [sym_internal_module] = STATE(2641),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2641),
    [sym_await_expression] = STATE(2641),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(2641),
    [sym_this] = STATE(2641),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(2641),
    [sym_generator_function] = STATE(2641),
    [sym_call_expression] = STATE(2641),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(2641),
    [sym_ternary_expression] = STATE(2641),
    [sym_binary_expression] = STATE(2641),
    [sym_template_string] = STATE(2641),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2641),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2641),
    [sym_class] = STATE(2641),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(5573),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5573),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5575),
    [sym_true] = ACTIONS(5573),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5573),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [1733] = {
    [sym_new_expression] = STATE(2642),
    [sym_augmented_assignment_expression] = STATE(2642),
    [sym_unary_expression] = STATE(2642),
    [sym_update_expression] = STATE(2642),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(2642),
    [sym_regex] = STATE(2642),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2642),
    [sym_non_null_expression] = STATE(2642),
    [sym_as_expression] = STATE(2642),
    [sym_jsx_fragment] = STATE(2642),
    [sym_yield_expression] = STATE(2642),
    [sym_jsx_element] = STATE(2642),
    [sym_internal_module] = STATE(2642),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2642),
    [sym_await_expression] = STATE(2642),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(2642),
    [sym_this] = STATE(2642),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(2642),
    [sym_generator_function] = STATE(2642),
    [sym_call_expression] = STATE(2642),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(2642),
    [sym_ternary_expression] = STATE(2642),
    [sym_binary_expression] = STATE(2642),
    [sym_template_string] = STATE(2642),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2642),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2642),
    [sym_class] = STATE(2642),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(5577),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5577),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5579),
    [sym_true] = ACTIONS(5577),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5577),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [1734] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(5581),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(702),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [1735] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(5581),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(702),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [1736] = {
    [anon_sym_EQ_GT] = ACTIONS(5584),
    [sym_comment] = ACTIONS(3),
  },
  [1737] = {
    [anon_sym_EQ_GT] = ACTIONS(5586),
    [sym_comment] = ACTIONS(3),
  },
  [1738] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_BQUOTE] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_instanceof] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(839),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_in] = ACTIONS(841),
  },
  [1739] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(871),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3630),
  },
  [1740] = {
    [sym__initializer] = STATE(522),
    [sym_arguments] = STATE(1268),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1531),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1529),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [1741] = {
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(3634),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [1742] = {
    [sym_new_expression] = STATE(836),
    [sym_augmented_assignment_expression] = STATE(836),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(836),
    [sym_update_expression] = STATE(836),
    [sym_regex] = STATE(836),
    [sym_meta_property] = STATE(836),
    [sym_call_signature] = STATE(835),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(836),
    [sym_non_null_expression] = STATE(836),
    [sym_yield_expression] = STATE(836),
    [sym_jsx_fragment] = STATE(836),
    [sym_jsx_element] = STATE(836),
    [sym_as_expression] = STATE(836),
    [sym_internal_module] = STATE(836),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(836),
    [sym_await_expression] = STATE(836),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(836),
    [sym_this] = STATE(836),
    [sym_arguments] = STATE(1270),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(836),
    [sym_generator_function] = STATE(836),
    [sym_call_expression] = STATE(836),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(836),
    [sym_ternary_expression] = STATE(836),
    [sym_binary_expression] = STATE(836),
    [sym_template_string] = STATE(836),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(836),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(836),
    [sym_class] = STATE(836),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(500),
    [sym_true] = ACTIONS(1545),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [sym_false] = ACTIONS(1545),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [sym_null] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(3634),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [sym_number] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [1743] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_arguments] = STATE(1270),
    [sym_call_signature] = STATE(1736),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(3644),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(3646),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(3646),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(3646),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_protected] = ACTIONS(3646),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(3646),
    [anon_sym_type] = ACTIONS(3646),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(3646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(3646),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(3646),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(3646),
    [anon_sym_declare] = ACTIONS(3646),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(3646),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(3646),
    [anon_sym_async] = ACTIONS(3646),
    [anon_sym_public] = ACTIONS(3646),
    [anon_sym_EQ_GT] = ACTIONS(3634),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(3646),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(3646),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [1744] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(3634),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [1745] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3630),
  },
  [1746] = {
    [sym_new_expression] = STATE(2645),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(2645),
    [sym_regex] = STATE(2645),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2645),
    [sym_non_null_expression] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_jsx_fragment] = STATE(2645),
    [sym_yield_expression] = STATE(2645),
    [sym_jsx_element] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(2645),
    [sym_this] = STATE(2645),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(2645),
    [sym_generator_function] = STATE(2645),
    [sym_call_expression] = STATE(2645),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(2645),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_template_string] = STATE(2645),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2645),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2645),
    [sym_class] = STATE(2645),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(5588),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5588),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5590),
    [sym_true] = ACTIONS(5588),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5588),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [1747] = {
    [sym_new_expression] = STATE(2646),
    [sym_augmented_assignment_expression] = STATE(2646),
    [sym_unary_expression] = STATE(2646),
    [sym_update_expression] = STATE(2646),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(2646),
    [sym_regex] = STATE(2646),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2646),
    [sym_non_null_expression] = STATE(2646),
    [sym_as_expression] = STATE(2646),
    [sym_jsx_fragment] = STATE(2646),
    [sym_yield_expression] = STATE(2646),
    [sym_jsx_element] = STATE(2646),
    [sym_internal_module] = STATE(2646),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2646),
    [sym_await_expression] = STATE(2646),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(2646),
    [sym_this] = STATE(2646),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(2646),
    [sym_generator_function] = STATE(2646),
    [sym_call_expression] = STATE(2646),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(2646),
    [sym_ternary_expression] = STATE(2646),
    [sym_binary_expression] = STATE(2646),
    [sym_template_string] = STATE(2646),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2646),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2646),
    [sym_class] = STATE(2646),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5592),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5594),
    [sym_true] = ACTIONS(5592),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5592),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [1748] = {
    [sym_new_expression] = STATE(2647),
    [sym_augmented_assignment_expression] = STATE(2647),
    [sym_unary_expression] = STATE(2647),
    [sym_update_expression] = STATE(2647),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(2647),
    [sym_regex] = STATE(2647),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2647),
    [sym_non_null_expression] = STATE(2647),
    [sym_as_expression] = STATE(2647),
    [sym_jsx_fragment] = STATE(2647),
    [sym_yield_expression] = STATE(2647),
    [sym_jsx_element] = STATE(2647),
    [sym_internal_module] = STATE(2647),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2647),
    [sym_await_expression] = STATE(2647),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(2647),
    [sym_this] = STATE(2647),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(2647),
    [sym_generator_function] = STATE(2647),
    [sym_call_expression] = STATE(2647),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(2647),
    [sym_ternary_expression] = STATE(2647),
    [sym_binary_expression] = STATE(2647),
    [sym_template_string] = STATE(2647),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2647),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2647),
    [sym_class] = STATE(2647),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(5596),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5596),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5598),
    [sym_true] = ACTIONS(5596),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5596),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [1749] = {
    [sym_new_expression] = STATE(2648),
    [sym_augmented_assignment_expression] = STATE(2648),
    [sym_unary_expression] = STATE(2648),
    [sym_update_expression] = STATE(2648),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(2648),
    [sym_regex] = STATE(2648),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2648),
    [sym_non_null_expression] = STATE(2648),
    [sym_as_expression] = STATE(2648),
    [sym_jsx_fragment] = STATE(2648),
    [sym_yield_expression] = STATE(2648),
    [sym_jsx_element] = STATE(2648),
    [sym_internal_module] = STATE(2648),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2648),
    [sym_await_expression] = STATE(2648),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(2648),
    [sym_this] = STATE(2648),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(2648),
    [sym_generator_function] = STATE(2648),
    [sym_call_expression] = STATE(2648),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(2648),
    [sym_ternary_expression] = STATE(2648),
    [sym_binary_expression] = STATE(2648),
    [sym_template_string] = STATE(2648),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2648),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2648),
    [sym_class] = STATE(2648),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(5600),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5600),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5602),
    [sym_true] = ACTIONS(5600),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5600),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [1750] = {
    [sym_new_expression] = STATE(2649),
    [sym_augmented_assignment_expression] = STATE(2649),
    [sym_unary_expression] = STATE(2649),
    [sym_update_expression] = STATE(2649),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(2649),
    [sym_regex] = STATE(2649),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2649),
    [sym_non_null_expression] = STATE(2649),
    [sym_as_expression] = STATE(2649),
    [sym_jsx_fragment] = STATE(2649),
    [sym_yield_expression] = STATE(2649),
    [sym_jsx_element] = STATE(2649),
    [sym_internal_module] = STATE(2649),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2649),
    [sym_await_expression] = STATE(2649),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(2649),
    [sym_this] = STATE(2649),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(2649),
    [sym_generator_function] = STATE(2649),
    [sym_call_expression] = STATE(2649),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(2649),
    [sym_ternary_expression] = STATE(2649),
    [sym_binary_expression] = STATE(2649),
    [sym_template_string] = STATE(2649),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2649),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2649),
    [sym_class] = STATE(2649),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(5604),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5604),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5606),
    [sym_true] = ACTIONS(5604),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5604),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [1751] = {
    [sym_union_type] = STATE(1293),
    [sym__type] = STATE(1293),
    [sym_constructor_type] = STATE(1293),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2655),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_template_string] = STATE(1297),
    [sym_intersection_type] = STATE(1293),
    [sym_function_type] = STATE(1293),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2656),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(5608),
    [sym_false] = ACTIONS(2643),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_PIPE] = ACTIONS(5610),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_boolean] = ACTIONS(2647),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(5612),
    [anon_sym_QMARK] = ACTIONS(5614),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2669),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_new] = ACTIONS(5616),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_DQUOTE] = ACTIONS(304),
  },
  [1752] = {
    [sym_new_expression] = STATE(2638),
    [sym_constructor_type] = STATE(432),
    [sym_augmented_assignment_expression] = STATE(2638),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(2638),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(2638),
    [sym_type_parameters] = STATE(959),
    [sym_array_type] = STATE(436),
    [sym_yield_expression] = STATE(2638),
    [sym_as_expression] = STATE(2638),
    [sym_jsx_fragment] = STATE(2638),
    [sym_internal_module] = STATE(2638),
    [sym_arrow_function] = STATE(2638),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(923),
    [sym_literal_type] = STATE(436),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(1650),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(2638),
    [sym_subscript_expression] = STATE(923),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(2638),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(2638),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(960),
    [sym_function_type] = STATE(432),
    [sym__type] = STATE(432),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(2638),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(2638),
    [sym__expression] = STATE(2638),
    [sym_non_null_expression] = STATE(2638),
    [sym_jsx_element] = STATE(2638),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_await_expression] = STATE(2638),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_this] = STATE(2638),
    [sym_union_type] = STATE(432),
    [sym_anonymous_class] = STATE(2638),
    [sym_call_expression] = STATE(2638),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(2638),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(2638),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(432),
    [sym_parenthesized_expression] = STATE(2638),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2638),
    [sym_class] = STATE(2638),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(5618),
    [sym_false] = ACTIONS(3450),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(5620),
    [anon_sym_number] = ACTIONS(5620),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(5622),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5624),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_void] = ACTIONS(5626),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [sym_null] = ACTIONS(5561),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5620),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(5620),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3462),
    [sym_true] = ACTIONS(3450),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(3464),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(5620),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5561),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(5628),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(5624),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [1753] = {
    [sym_new_expression] = STATE(2663),
    [sym_augmented_assignment_expression] = STATE(2663),
    [sym_unary_expression] = STATE(2663),
    [sym_update_expression] = STATE(2663),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(2663),
    [sym_regex] = STATE(2663),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2663),
    [sym_non_null_expression] = STATE(2663),
    [sym_as_expression] = STATE(2663),
    [sym_jsx_fragment] = STATE(2663),
    [sym_yield_expression] = STATE(2663),
    [sym_jsx_element] = STATE(2663),
    [sym_internal_module] = STATE(2663),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2663),
    [sym_await_expression] = STATE(2663),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(2663),
    [sym_this] = STATE(2663),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(2663),
    [sym_generator_function] = STATE(2663),
    [sym_call_expression] = STATE(2663),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(2663),
    [sym_ternary_expression] = STATE(2663),
    [sym_binary_expression] = STATE(2663),
    [sym_template_string] = STATE(2663),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2663),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2663),
    [sym_class] = STATE(2663),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(5630),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5630),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5632),
    [sym_true] = ACTIONS(5630),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5630),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [1754] = {
    [sym_new_expression] = STATE(2664),
    [sym_augmented_assignment_expression] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_update_expression] = STATE(2664),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(2664),
    [sym_regex] = STATE(2664),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2664),
    [sym_non_null_expression] = STATE(2664),
    [sym_as_expression] = STATE(2664),
    [sym_jsx_fragment] = STATE(2664),
    [sym_yield_expression] = STATE(2664),
    [sym_jsx_element] = STATE(2664),
    [sym_internal_module] = STATE(2664),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2664),
    [sym_await_expression] = STATE(2664),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(2664),
    [sym_this] = STATE(2664),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(2664),
    [sym_generator_function] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_template_string] = STATE(2664),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2664),
    [sym_class] = STATE(2664),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(5634),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5634),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5636),
    [sym_true] = ACTIONS(5634),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5634),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [1755] = {
    [sym_union_type] = STATE(2665),
    [sym__type] = STATE(2665),
    [sym_constructor_type] = STATE(2665),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1926),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2665),
    [sym_function_type] = STATE(2665),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1927),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4057),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1756] = {
    [sym_union_type] = STATE(2666),
    [sym__type] = STATE(2666),
    [sym_constructor_type] = STATE(2666),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2666),
    [sym_function_type] = STATE(2666),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1757] = {
    [sym_identifier] = ACTIONS(5638),
    [sym_comment] = ACTIONS(3),
  },
  [1758] = {
    [sym_union_type] = STATE(2668),
    [sym__type] = STATE(2668),
    [sym_constructor_type] = STATE(2668),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(943),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(2668),
    [sym_function_type] = STATE(2668),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(947),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(1905),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(1931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1929),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(1937),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [1759] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4073),
    [anon_sym_LBRACK] = ACTIONS(4073),
    [anon_sym_BANG] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_BQUOTE] = ACTIONS(4073),
    [sym__automatic_semicolon] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_COMMA] = ACTIONS(4073),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(4071),
    [anon_sym_GT_GT_GT] = ACTIONS(4073),
    [anon_sym_AMP_AMP] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(4071),
    [anon_sym_BANG_EQ] = ACTIONS(4071),
    [anon_sym_LT_EQ] = ACTIONS(4073),
    [anon_sym_LPAREN] = ACTIONS(4073),
    [anon_sym_GT_EQ] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4071),
    [anon_sym_PERCENT] = ACTIONS(4073),
    [anon_sym_QMARK] = ACTIONS(4073),
    [anon_sym_RBRACE] = ACTIONS(4073),
    [anon_sym_as] = ACTIONS(4073),
    [anon_sym_PIPE_PIPE] = ACTIONS(4073),
    [anon_sym_DASH_DASH] = ACTIONS(4073),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_instanceof] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_RPAREN] = ACTIONS(4073),
    [anon_sym_SLASH] = ACTIONS(4071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4073),
    [anon_sym_CARET] = ACTIONS(4073),
    [anon_sym_STAR_STAR] = ACTIONS(4073),
    [anon_sym_PLUS] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_PLUS_PLUS] = ACTIONS(4073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4073),
    [anon_sym_in] = ACTIONS(4071),
  },
  [1760] = {
    [sym_union_type] = STATE(1773),
    [sym__type] = STATE(1773),
    [sym_constructor_type] = STATE(1773),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1108),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1773),
    [sym_function_type] = STATE(1773),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1109),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2282),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1761] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4077),
    [anon_sym_LBRACK] = ACTIONS(3730),
    [anon_sym_BANG] = ACTIONS(4075),
    [anon_sym_SEMI] = ACTIONS(4077),
    [anon_sym_BQUOTE] = ACTIONS(4077),
    [sym__automatic_semicolon] = ACTIONS(4077),
    [anon_sym_PIPE] = ACTIONS(4075),
    [anon_sym_COMMA] = ACTIONS(4077),
    [anon_sym_LT_LT] = ACTIONS(4077),
    [anon_sym_STAR] = ACTIONS(4075),
    [anon_sym_GT_GT_GT] = ACTIONS(4077),
    [anon_sym_AMP_AMP] = ACTIONS(4077),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_BANG_EQ] = ACTIONS(4075),
    [anon_sym_LT_EQ] = ACTIONS(4077),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_GT_EQ] = ACTIONS(4077),
    [anon_sym_GT] = ACTIONS(4075),
    [anon_sym_AMP] = ACTIONS(4075),
    [anon_sym_PERCENT] = ACTIONS(4077),
    [anon_sym_QMARK] = ACTIONS(4077),
    [anon_sym_RBRACE] = ACTIONS(4077),
    [anon_sym_as] = ACTIONS(4077),
    [anon_sym_PIPE_PIPE] = ACTIONS(4077),
    [anon_sym_DASH_DASH] = ACTIONS(4077),
    [anon_sym_EQ_EQ] = ACTIONS(4075),
    [anon_sym_instanceof] = ACTIONS(4077),
    [anon_sym_LT] = ACTIONS(4075),
    [anon_sym_RPAREN] = ACTIONS(4077),
    [anon_sym_SLASH] = ACTIONS(4075),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4077),
    [anon_sym_CARET] = ACTIONS(4077),
    [anon_sym_STAR_STAR] = ACTIONS(4077),
    [anon_sym_PLUS] = ACTIONS(4075),
    [anon_sym_GT_GT] = ACTIONS(4075),
    [anon_sym_PLUS_PLUS] = ACTIONS(4077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4077),
    [anon_sym_in] = ACTIONS(4075),
  },
  [1762] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(2669),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(2669),
    [sym_call_signature] = STATE(2669),
    [sym_export_statement] = STATE(2669),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(2669),
    [sym_index_signature] = STATE(2669),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [1763] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_BANG] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_BQUOTE] = ACTIONS(4105),
    [sym__automatic_semicolon] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4103),
    [anon_sym_COMMA] = ACTIONS(4105),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_STAR] = ACTIONS(4103),
    [anon_sym_GT_GT_GT] = ACTIONS(4105),
    [anon_sym_AMP_AMP] = ACTIONS(4105),
    [anon_sym_DASH] = ACTIONS(4103),
    [anon_sym_BANG_EQ] = ACTIONS(4103),
    [anon_sym_LT_EQ] = ACTIONS(4105),
    [anon_sym_LPAREN] = ACTIONS(4105),
    [anon_sym_GT_EQ] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4103),
    [anon_sym_PERCENT] = ACTIONS(4105),
    [anon_sym_QMARK] = ACTIONS(4105),
    [anon_sym_RBRACE] = ACTIONS(4105),
    [anon_sym_as] = ACTIONS(4105),
    [anon_sym_PIPE_PIPE] = ACTIONS(4105),
    [anon_sym_DASH_DASH] = ACTIONS(4105),
    [anon_sym_EQ_EQ] = ACTIONS(4103),
    [anon_sym_instanceof] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(4103),
    [anon_sym_RPAREN] = ACTIONS(4105),
    [anon_sym_SLASH] = ACTIONS(4103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(4105),
    [anon_sym_STAR_STAR] = ACTIONS(4105),
    [anon_sym_PLUS] = ACTIONS(4103),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_PLUS_PLUS] = ACTIONS(4105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4105),
    [anon_sym_in] = ACTIONS(4103),
  },
  [1764] = {
    [aux_sym_object_type_repeat1] = STATE(2672),
    [sym__automatic_semicolon] = ACTIONS(5640),
    [anon_sym_RBRACE] = ACTIONS(5642),
    [anon_sym_SEMI] = ACTIONS(5640),
    [anon_sym_COMMA] = ACTIONS(5640),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5642),
    [sym_comment] = ACTIONS(3),
  },
  [1765] = {
    [aux_sym_implements_clause_repeat1] = STATE(2674),
    [anon_sym_AMP] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_COMMA] = ACTIONS(4165),
    [anon_sym_RBRACK] = ACTIONS(5644),
    [sym_comment] = ACTIONS(3),
  },
  [1766] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4173),
    [anon_sym_BANG] = ACTIONS(4171),
    [anon_sym_SEMI] = ACTIONS(4173),
    [anon_sym_BQUOTE] = ACTIONS(4173),
    [sym__automatic_semicolon] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_COMMA] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4171),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_AMP_AMP] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4173),
    [anon_sym_LPAREN] = ACTIONS(4173),
    [anon_sym_GT_EQ] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4171),
    [anon_sym_AMP] = ACTIONS(4171),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_QMARK] = ACTIONS(4173),
    [anon_sym_RBRACE] = ACTIONS(4173),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_PIPE_PIPE] = ACTIONS(4173),
    [anon_sym_DASH_DASH] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_instanceof] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(4171),
    [anon_sym_RPAREN] = ACTIONS(4173),
    [anon_sym_SLASH] = ACTIONS(4171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_STAR_STAR] = ACTIONS(4173),
    [anon_sym_PLUS] = ACTIONS(4171),
    [anon_sym_GT_GT] = ACTIONS(4171),
    [anon_sym_PLUS_PLUS] = ACTIONS(4173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4173),
    [anon_sym_in] = ACTIONS(4171),
  },
  [1767] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4177),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(4175),
    [anon_sym_SEMI] = ACTIONS(4177),
    [anon_sym_BQUOTE] = ACTIONS(4177),
    [sym__automatic_semicolon] = ACTIONS(4177),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_LT_LT] = ACTIONS(4177),
    [anon_sym_STAR] = ACTIONS(4175),
    [anon_sym_GT_GT_GT] = ACTIONS(4177),
    [anon_sym_AMP_AMP] = ACTIONS(4177),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4177),
    [anon_sym_LPAREN] = ACTIONS(4177),
    [anon_sym_GT_EQ] = ACTIONS(4177),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(4177),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_RBRACE] = ACTIONS(4177),
    [anon_sym_as] = ACTIONS(4177),
    [anon_sym_PIPE_PIPE] = ACTIONS(4177),
    [anon_sym_DASH_DASH] = ACTIONS(4177),
    [anon_sym_EQ_EQ] = ACTIONS(4175),
    [anon_sym_instanceof] = ACTIONS(4177),
    [anon_sym_LT] = ACTIONS(4175),
    [anon_sym_RPAREN] = ACTIONS(4177),
    [anon_sym_SLASH] = ACTIONS(4175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4457),
    [anon_sym_CARET] = ACTIONS(4177),
    [anon_sym_STAR_STAR] = ACTIONS(4177),
    [anon_sym_PLUS] = ACTIONS(4175),
    [anon_sym_GT_GT] = ACTIONS(4175),
    [anon_sym_PLUS_PLUS] = ACTIONS(4177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4177),
    [anon_sym_in] = ACTIONS(4175),
  },
  [1768] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4185),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [anon_sym_BANG] = ACTIONS(4183),
    [anon_sym_SEMI] = ACTIONS(4185),
    [anon_sym_BQUOTE] = ACTIONS(4185),
    [sym__automatic_semicolon] = ACTIONS(4185),
    [anon_sym_PIPE] = ACTIONS(4183),
    [anon_sym_COMMA] = ACTIONS(4185),
    [anon_sym_LT_LT] = ACTIONS(4185),
    [anon_sym_STAR] = ACTIONS(4183),
    [anon_sym_GT_GT_GT] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4185),
    [anon_sym_DASH] = ACTIONS(4183),
    [anon_sym_BANG_EQ] = ACTIONS(4183),
    [anon_sym_LT_EQ] = ACTIONS(4185),
    [anon_sym_LPAREN] = ACTIONS(4185),
    [anon_sym_GT_EQ] = ACTIONS(4185),
    [anon_sym_GT] = ACTIONS(4183),
    [anon_sym_AMP] = ACTIONS(4183),
    [anon_sym_PERCENT] = ACTIONS(4185),
    [anon_sym_QMARK] = ACTIONS(4185),
    [anon_sym_RBRACE] = ACTIONS(4185),
    [anon_sym_as] = ACTIONS(4185),
    [anon_sym_PIPE_PIPE] = ACTIONS(4185),
    [anon_sym_DASH_DASH] = ACTIONS(4185),
    [anon_sym_EQ_EQ] = ACTIONS(4183),
    [anon_sym_instanceof] = ACTIONS(4185),
    [anon_sym_LT] = ACTIONS(4183),
    [anon_sym_RPAREN] = ACTIONS(4185),
    [anon_sym_SLASH] = ACTIONS(4183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(4185),
    [anon_sym_STAR_STAR] = ACTIONS(4185),
    [anon_sym_PLUS] = ACTIONS(4183),
    [anon_sym_GT_GT] = ACTIONS(4183),
    [anon_sym_PLUS_PLUS] = ACTIONS(4185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4185),
    [anon_sym_in] = ACTIONS(4183),
  },
  [1769] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4191),
    [anon_sym_LBRACK] = ACTIONS(4191),
    [anon_sym_BANG] = ACTIONS(4189),
    [anon_sym_SEMI] = ACTIONS(4191),
    [anon_sym_BQUOTE] = ACTIONS(4191),
    [sym__automatic_semicolon] = ACTIONS(4191),
    [anon_sym_PIPE] = ACTIONS(4189),
    [anon_sym_COMMA] = ACTIONS(4191),
    [anon_sym_LT_LT] = ACTIONS(4191),
    [anon_sym_STAR] = ACTIONS(4189),
    [anon_sym_GT_GT_GT] = ACTIONS(4191),
    [anon_sym_AMP_AMP] = ACTIONS(4191),
    [anon_sym_DASH] = ACTIONS(4189),
    [anon_sym_BANG_EQ] = ACTIONS(4189),
    [anon_sym_LT_EQ] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(4191),
    [anon_sym_GT_EQ] = ACTIONS(4191),
    [anon_sym_GT] = ACTIONS(4189),
    [anon_sym_AMP] = ACTIONS(4189),
    [anon_sym_PERCENT] = ACTIONS(4191),
    [anon_sym_QMARK] = ACTIONS(4191),
    [anon_sym_RBRACE] = ACTIONS(4191),
    [anon_sym_as] = ACTIONS(4191),
    [anon_sym_PIPE_PIPE] = ACTIONS(4191),
    [anon_sym_DASH_DASH] = ACTIONS(4191),
    [anon_sym_EQ_EQ] = ACTIONS(4189),
    [anon_sym_instanceof] = ACTIONS(4191),
    [anon_sym_LT] = ACTIONS(4189),
    [anon_sym_RPAREN] = ACTIONS(4191),
    [anon_sym_SLASH] = ACTIONS(4189),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4191),
    [anon_sym_CARET] = ACTIONS(4191),
    [anon_sym_STAR_STAR] = ACTIONS(4191),
    [anon_sym_PLUS] = ACTIONS(4189),
    [anon_sym_GT_GT] = ACTIONS(4189),
    [anon_sym_PLUS_PLUS] = ACTIONS(4191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4191),
    [anon_sym_in] = ACTIONS(4189),
  },
  [1770] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4181),
    [anon_sym_LBRACK] = ACTIONS(4181),
    [anon_sym_BANG] = ACTIONS(4179),
    [anon_sym_SEMI] = ACTIONS(4181),
    [anon_sym_BQUOTE] = ACTIONS(4181),
    [sym__automatic_semicolon] = ACTIONS(4181),
    [anon_sym_PIPE] = ACTIONS(4179),
    [anon_sym_COMMA] = ACTIONS(4181),
    [anon_sym_LT_LT] = ACTIONS(4181),
    [anon_sym_STAR] = ACTIONS(4179),
    [anon_sym_GT_GT_GT] = ACTIONS(4181),
    [anon_sym_AMP_AMP] = ACTIONS(4181),
    [anon_sym_DASH] = ACTIONS(4179),
    [anon_sym_BANG_EQ] = ACTIONS(4179),
    [anon_sym_LT_EQ] = ACTIONS(4181),
    [anon_sym_LPAREN] = ACTIONS(4181),
    [anon_sym_GT_EQ] = ACTIONS(4181),
    [anon_sym_GT] = ACTIONS(4179),
    [anon_sym_AMP] = ACTIONS(4179),
    [anon_sym_PERCENT] = ACTIONS(4181),
    [anon_sym_QMARK] = ACTIONS(4181),
    [anon_sym_RBRACE] = ACTIONS(4181),
    [anon_sym_as] = ACTIONS(4181),
    [anon_sym_PIPE_PIPE] = ACTIONS(4181),
    [anon_sym_DASH_DASH] = ACTIONS(4181),
    [anon_sym_EQ_EQ] = ACTIONS(4179),
    [anon_sym_instanceof] = ACTIONS(4181),
    [anon_sym_LT] = ACTIONS(4179),
    [anon_sym_RPAREN] = ACTIONS(4181),
    [anon_sym_SLASH] = ACTIONS(4179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4181),
    [anon_sym_CARET] = ACTIONS(4181),
    [anon_sym_STAR_STAR] = ACTIONS(4181),
    [anon_sym_PLUS] = ACTIONS(4179),
    [anon_sym_GT_GT] = ACTIONS(4179),
    [anon_sym_PLUS_PLUS] = ACTIONS(4181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4181),
    [anon_sym_in] = ACTIONS(4179),
  },
  [1771] = {
    [sym_formal_parameters] = STATE(2675),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1772] = {
    [anon_sym_EQ_GT] = ACTIONS(5646),
    [sym_comment] = ACTIONS(3),
  },
  [1773] = {
    [anon_sym_AMP] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(5648),
    [anon_sym_PIPE] = ACTIONS(4221),
    [sym_comment] = ACTIONS(3),
  },
  [1774] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(4225),
    [anon_sym_SEMI] = ACTIONS(4227),
    [anon_sym_BQUOTE] = ACTIONS(4227),
    [sym__automatic_semicolon] = ACTIONS(4227),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_COMMA] = ACTIONS(4227),
    [anon_sym_LT_LT] = ACTIONS(4227),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_GT_GT_GT] = ACTIONS(4227),
    [anon_sym_AMP_AMP] = ACTIONS(4227),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_BANG_EQ] = ACTIONS(4225),
    [anon_sym_LT_EQ] = ACTIONS(4227),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_GT_EQ] = ACTIONS(4227),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4227),
    [anon_sym_QMARK] = ACTIONS(4227),
    [anon_sym_RBRACE] = ACTIONS(4227),
    [anon_sym_as] = ACTIONS(4227),
    [anon_sym_PIPE_PIPE] = ACTIONS(4227),
    [anon_sym_DASH_DASH] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4225),
    [anon_sym_instanceof] = ACTIONS(4227),
    [anon_sym_LT] = ACTIONS(4225),
    [anon_sym_RPAREN] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4227),
    [anon_sym_CARET] = ACTIONS(4227),
    [anon_sym_STAR_STAR] = ACTIONS(4227),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_PLUS_PLUS] = ACTIONS(4227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4227),
    [anon_sym_in] = ACTIONS(4225),
  },
  [1775] = {
    [sym_union_type] = STATE(2678),
    [sym__type] = STATE(2678),
    [sym_constructor_type] = STATE(2678),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(943),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(2678),
    [sym_function_type] = STATE(2678),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(947),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(1905),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(1931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1929),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(1937),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [1776] = {
    [sym_union_type] = STATE(2679),
    [sym__type] = STATE(2679),
    [sym_constructor_type] = STATE(2679),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(943),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(2679),
    [sym_function_type] = STATE(2679),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(947),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(1905),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(1931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1929),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(1937),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [1777] = {
    [sym_union_type] = STATE(2680),
    [sym__type] = STATE(2680),
    [sym_constructor_type] = STATE(2680),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1926),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2680),
    [sym_function_type] = STATE(2680),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1927),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4057),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1778] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4239),
    [anon_sym_LBRACK] = ACTIONS(4239),
    [anon_sym_BANG] = ACTIONS(4237),
    [anon_sym_SEMI] = ACTIONS(4239),
    [anon_sym_BQUOTE] = ACTIONS(4239),
    [sym__automatic_semicolon] = ACTIONS(4239),
    [anon_sym_PIPE] = ACTIONS(4237),
    [anon_sym_COMMA] = ACTIONS(4239),
    [anon_sym_LT_LT] = ACTIONS(4239),
    [anon_sym_STAR] = ACTIONS(4237),
    [anon_sym_GT_GT_GT] = ACTIONS(4239),
    [anon_sym_AMP_AMP] = ACTIONS(4239),
    [anon_sym_DASH] = ACTIONS(4237),
    [anon_sym_BANG_EQ] = ACTIONS(4237),
    [anon_sym_LT_EQ] = ACTIONS(4239),
    [anon_sym_LPAREN] = ACTIONS(4239),
    [anon_sym_GT_EQ] = ACTIONS(4239),
    [anon_sym_GT] = ACTIONS(4237),
    [anon_sym_AMP] = ACTIONS(4237),
    [anon_sym_PERCENT] = ACTIONS(4239),
    [anon_sym_QMARK] = ACTIONS(4239),
    [anon_sym_RBRACE] = ACTIONS(4239),
    [anon_sym_as] = ACTIONS(4239),
    [anon_sym_PIPE_PIPE] = ACTIONS(4239),
    [anon_sym_DASH_DASH] = ACTIONS(4239),
    [anon_sym_EQ_EQ] = ACTIONS(4237),
    [anon_sym_instanceof] = ACTIONS(4239),
    [anon_sym_LT] = ACTIONS(4237),
    [anon_sym_RPAREN] = ACTIONS(4239),
    [anon_sym_SLASH] = ACTIONS(4237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4239),
    [anon_sym_CARET] = ACTIONS(4239),
    [anon_sym_STAR_STAR] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4237),
    [anon_sym_GT_GT] = ACTIONS(4237),
    [anon_sym_PLUS_PLUS] = ACTIONS(4239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4239),
    [anon_sym_in] = ACTIONS(4237),
  },
  [1779] = {
    [anon_sym_EQ_GT] = ACTIONS(5650),
    [sym_comment] = ACTIONS(3),
  },
  [1780] = {
    [anon_sym_RBRACK] = ACTIONS(5652),
    [sym_comment] = ACTIONS(3),
  },
  [1781] = {
    [sym_union_type] = STATE(2683),
    [sym__type] = STATE(2683),
    [sym_constructor_type] = STATE(2683),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(943),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(2683),
    [sym_function_type] = STATE(2683),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(947),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(1905),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(1931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1929),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(1937),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [1782] = {
    [sym_identifier] = ACTIONS(5654),
    [sym_comment] = ACTIONS(3),
  },
  [1783] = {
    [sym__initializer] = STATE(522),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(937),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(937),
    [anon_sym_AMP_EQ] = ACTIONS(937),
    [anon_sym_PLUS_EQ] = ACTIONS(937),
    [anon_sym_PIPE] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(3741),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(937),
    [anon_sym_STAR_EQ] = ACTIONS(937),
    [anon_sym_PIPE_EQ] = ACTIONS(937),
    [anon_sym_DASH_EQ] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(937),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(937),
    [anon_sym_GT_GT_EQ] = ACTIONS(937),
    [anon_sym_DOT] = ACTIONS(5656),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(945),
  },
  [1784] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(951),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_AMP_EQ] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(3773),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(951),
    [anon_sym_STAR_EQ] = ACTIONS(951),
    [anon_sym_PIPE_EQ] = ACTIONS(951),
    [anon_sym_DASH_EQ] = ACTIONS(951),
    [anon_sym_EQ_GT] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(951),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(951),
    [anon_sym_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1785] = {
    [sym_new_expression] = STATE(534),
    [sym_augmented_assignment_expression] = STATE(534),
    [sym_unary_expression] = STATE(534),
    [sym_update_expression] = STATE(534),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(534),
    [sym_regex] = STATE(534),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(534),
    [sym_non_null_expression] = STATE(534),
    [sym_as_expression] = STATE(534),
    [sym_jsx_fragment] = STATE(534),
    [sym_yield_expression] = STATE(534),
    [sym_jsx_element] = STATE(534),
    [sym_internal_module] = STATE(534),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(534),
    [sym_await_expression] = STATE(534),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(534),
    [sym_this] = STATE(534),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(534),
    [sym_generator_function] = STATE(534),
    [sym_call_expression] = STATE(534),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(534),
    [sym_ternary_expression] = STATE(534),
    [sym_binary_expression] = STATE(534),
    [sym_template_string] = STATE(534),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(534),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(534),
    [sym_class] = STATE(534),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(965),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5658),
    [sym_true] = ACTIONS(965),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(965),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [1786] = {
    [sym_new_expression] = STATE(533),
    [sym_augmented_assignment_expression] = STATE(533),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(533),
    [sym_update_expression] = STATE(533),
    [sym_regex] = STATE(533),
    [sym_meta_property] = STATE(533),
    [sym_call_signature] = STATE(159),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(533),
    [sym_non_null_expression] = STATE(533),
    [sym_yield_expression] = STATE(533),
    [sym_jsx_fragment] = STATE(533),
    [sym_jsx_element] = STATE(533),
    [sym_as_expression] = STATE(533),
    [sym_internal_module] = STATE(533),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(533),
    [sym_await_expression] = STATE(533),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(533),
    [sym_this] = STATE(533),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(533),
    [sym_generator_function] = STATE(533),
    [sym_call_expression] = STATE(533),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(533),
    [sym_ternary_expression] = STATE(533),
    [sym_binary_expression] = STATE(533),
    [sym_template_string] = STATE(533),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(533),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(533),
    [sym_class] = STATE(533),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(951),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_AMP_EQ] = ACTIONS(951),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(951),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_PIPE_EQ] = ACTIONS(951),
    [anon_sym_DASH_EQ] = ACTIONS(951),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(951),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(290),
    [sym_true] = ACTIONS(961),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(951),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(961),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(3773),
    [sym_null] = ACTIONS(961),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_STAR_EQ] = ACTIONS(951),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_EQ_GT] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(951),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(961),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1787] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3825),
    [anon_sym_LT_LT] = ACTIONS(207),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_GT_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_BANG_EQ] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(207),
    [anon_sym_RBRACK] = ACTIONS(3825),
    [anon_sym_GT_EQ] = ACTIONS(207),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_DASH_DASH] = ACTIONS(207),
    [anon_sym_EQ_EQ] = ACTIONS(209),
    [anon_sym_instanceof] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(207),
    [anon_sym_CARET] = ACTIONS(207),
    [anon_sym_STAR_STAR] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_GT_GT] = ACTIONS(209),
    [anon_sym_PLUS_PLUS] = ACTIONS(207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(209),
  },
  [1788] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3749),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_COMMA] = ACTIONS(3749),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(3749),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(3752),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [1789] = {
    [sym_new_expression] = STATE(533),
    [sym_augmented_assignment_expression] = STATE(533),
    [sym_unary_expression] = STATE(533),
    [sym_update_expression] = STATE(533),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(533),
    [sym_regex] = STATE(533),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(533),
    [sym_non_null_expression] = STATE(533),
    [sym_as_expression] = STATE(533),
    [sym_jsx_fragment] = STATE(533),
    [sym_yield_expression] = STATE(533),
    [sym_jsx_element] = STATE(533),
    [sym_internal_module] = STATE(533),
    [sym_nested_identifier] = STATE(1092),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(533),
    [sym_await_expression] = STATE(533),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(533),
    [sym_this] = STATE(533),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(533),
    [sym_generator_function] = STATE(533),
    [sym_call_expression] = STATE(533),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(533),
    [sym_ternary_expression] = STATE(533),
    [sym_binary_expression] = STATE(533),
    [sym_template_string] = STATE(533),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(533),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(533),
    [sym_class] = STATE(533),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(5660),
    [sym_false] = ACTIONS(961),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(961),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(963),
    [sym_true] = ACTIONS(961),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(961),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [1790] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(2688),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(2689),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(1021),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(1025),
    [anon_sym_symbol] = ACTIONS(1025),
    [anon_sym_number] = ACTIONS(1025),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1025),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1025),
    [anon_sym_private] = ACTIONS(1025),
    [anon_sym_boolean] = ACTIONS(1025),
    [anon_sym_async] = ACTIONS(1029),
    [anon_sym_public] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1025),
    [anon_sym_string] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(1025),
    [anon_sym_type] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(1025),
    [anon_sym_export] = ACTIONS(1025),
    [anon_sym_namespace] = ACTIONS(1035),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [1791] = {
    [sym_formal_parameters] = STATE(2690),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1792] = {
    [sym_type_annotation] = STATE(323),
    [anon_sym_EQ_GT] = ACTIONS(5662),
    [anon_sym_COLON] = ACTIONS(550),
    [sym_comment] = ACTIONS(3),
  },
  [1793] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [1794] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4181),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(4179),
    [anon_sym_COMMA] = ACTIONS(4181),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(4179),
    [anon_sym_AMP] = ACTIONS(4179),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [1795] = {
    [sym__initializer] = STATE(1010),
    [aux_sym_object_repeat1] = STATE(662),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_EQ] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(362),
    [sym_comment] = ACTIONS(3),
  },
  [1796] = {
    [sym_new_expression] = STATE(2697),
    [sym_augmented_assignment_expression] = STATE(2697),
    [sym_unary_expression] = STATE(2697),
    [sym_update_expression] = STATE(2697),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(2697),
    [sym_regex] = STATE(2697),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2697),
    [sym_non_null_expression] = STATE(2697),
    [sym_as_expression] = STATE(2697),
    [sym_jsx_fragment] = STATE(2697),
    [sym_yield_expression] = STATE(2697),
    [sym_jsx_element] = STATE(2697),
    [sym_internal_module] = STATE(2697),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2697),
    [sym_await_expression] = STATE(2697),
    [sym_member_expression] = STATE(162),
    [sym_spread_element] = STATE(395),
    [sym_string] = STATE(2697),
    [sym_this] = STATE(2697),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [aux_sym_array_repeat1] = STATE(396),
    [sym_anonymous_class] = STATE(2697),
    [sym_generator_function] = STATE(2697),
    [sym_call_expression] = STATE(2697),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(2697),
    [sym_ternary_expression] = STATE(2697),
    [sym_binary_expression] = STATE(2697),
    [sym_template_string] = STATE(2697),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2697),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2697),
    [sym_class] = STATE(2697),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(5667),
    [sym_false] = ACTIONS(5669),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5671),
    [anon_sym_symbol] = ACTIONS(5671),
    [anon_sym_number] = ACTIONS(5671),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5671),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(268),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_void] = ACTIONS(5673),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(723),
    [sym_null] = ACTIONS(5669),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5671),
    [anon_sym_private] = ACTIONS(5671),
    [anon_sym_boolean] = ACTIONS(5671),
    [anon_sym_async] = ACTIONS(5675),
    [anon_sym_public] = ACTIONS(5671),
    [anon_sym_get] = ACTIONS(5671),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5677),
    [sym_true] = ACTIONS(5669),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5671),
    [anon_sym_string] = ACTIONS(5671),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5669),
    [anon_sym_set] = ACTIONS(5671),
    [anon_sym_type] = ACTIONS(5671),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(5671),
    [anon_sym_export] = ACTIONS(5671),
    [anon_sym_namespace] = ACTIONS(5679),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [1797] = {
    [aux_sym_object_repeat1] = STATE(662),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(362),
    [sym_comment] = ACTIONS(3),
  },
  [1798] = {
    [aux_sym_export_statement_repeat1] = STATE(2704),
    [sym__property_name] = STATE(1807),
    [sym_object] = STATE(384),
    [sym_assignment_pattern] = STATE(670),
    [sym_pair] = STATE(670),
    [sym_method_signature] = STATE(1940),
    [sym_call_signature] = STATE(1940),
    [sym_type_parameters] = STATE(1082),
    [sym_index_signature] = STATE(1940),
    [sym_export_statement] = STATE(1940),
    [sym_method_definition] = STATE(670),
    [sym_property_signature] = STATE(1940),
    [sym_decorator] = STATE(2704),
    [sym_construct_signature] = STATE(1940),
    [sym_accessibility_modifier] = STATE(1808),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1807),
    [sym_array] = STATE(385),
    [sym_spread_element] = STATE(670),
    [sym_string] = STATE(1807),
    [sym_identifier] = ACTIONS(5681),
    [anon_sym_LBRACK] = ACTIONS(3785),
    [anon_sym_module] = ACTIONS(5683),
    [anon_sym_symbol] = ACTIONS(5683),
    [anon_sym_number] = ACTIONS(5683),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(5683),
    [anon_sym_COMMA] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_void] = ACTIONS(5683),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(5683),
    [anon_sym_private] = ACTIONS(5685),
    [anon_sym_boolean] = ACTIONS(5683),
    [anon_sym_static] = ACTIONS(3795),
    [anon_sym_async] = ACTIONS(5687),
    [anon_sym_get] = ACTIONS(5689),
    [anon_sym_RBRACE] = ACTIONS(1222),
    [anon_sym_public] = ACTIONS(5685),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(3801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(5685),
    [anon_sym_string] = ACTIONS(5683),
    [anon_sym_set] = ACTIONS(5689),
    [anon_sym_type] = ACTIONS(5683),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(5683),
    [anon_sym_export] = ACTIONS(5691),
    [sym_readonly] = ACTIONS(3805),
    [anon_sym_namespace] = ACTIONS(5683),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [1799] = {
    [sym_string] = STATE(2705),
    [sym__property_name] = STATE(2705),
    [sym_computed_property_name] = STATE(2705),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(5693),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [1800] = {
    [aux_sym_object_repeat1] = STATE(662),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1238),
    [sym_identifier] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1236),
    [anon_sym_symbol] = ACTIONS(1236),
    [anon_sym_number] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1236),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_STAR] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1236),
    [anon_sym_private] = ACTIONS(1236),
    [anon_sym_boolean] = ACTIONS(1236),
    [anon_sym_async] = ACTIONS(1236),
    [anon_sym_public] = ACTIONS(1236),
    [anon_sym_get] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_static] = ACTIONS(1236),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(1238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1236),
    [anon_sym_string] = ACTIONS(1236),
    [anon_sym_set] = ACTIONS(1236),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1236),
    [anon_sym_import] = ACTIONS(1236),
    [anon_sym_export] = ACTIONS(1236),
    [anon_sym_namespace] = ACTIONS(1236),
    [sym_readonly] = ACTIONS(1236),
    [anon_sym_DQUOTE] = ACTIONS(1238),
  },
  [1801] = {
    [sym__property_name] = STATE(2705),
    [sym_string] = STATE(2705),
    [aux_sym_object_repeat1] = STATE(662),
    [sym_computed_property_name] = STATE(2705),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_STAR] = ACTIONS(5695),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(5697),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(5693),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(5697),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [1802] = {
    [sym__property_name] = STATE(2705),
    [sym_string] = STATE(2705),
    [aux_sym_object_repeat1] = STATE(662),
    [sym_computed_property_name] = STATE(2705),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(5693),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [1803] = {
    [sym_string] = STATE(2711),
    [sym__property_name] = STATE(2711),
    [sym_computed_property_name] = STATE(2711),
    [anon_sym_get] = ACTIONS(5699),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_async] = ACTIONS(5701),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(5703),
    [anon_sym_STAR] = ACTIONS(5695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(5699),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(5705),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [1804] = {
    [sym_type_alias_declaration] = STATE(1970),
    [aux_sym_export_statement_repeat1] = STATE(1969),
    [sym__declaration] = STATE(1970),
    [sym_ambient_declaration] = STATE(1970),
    [sym_import_alias] = STATE(1970),
    [sym_export_statement] = STATE(1970),
    [sym_generator_function] = STATE(1970),
    [sym_export_clause] = STATE(1971),
    [aux_sym_object_repeat1] = STATE(662),
    [sym_lexical_declaration] = STATE(1970),
    [sym_internal_module] = STATE(1970),
    [sym_decorator] = STATE(1969),
    [sym_enum_declaration] = STATE(1970),
    [sym_function] = STATE(1970),
    [sym_function_signature] = STATE(1970),
    [sym_variable_declaration] = STATE(1970),
    [sym_abstract_class] = STATE(1970),
    [sym_module] = STATE(1970),
    [sym_interface_declaration] = STATE(1970),
    [sym_class] = STATE(1970),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(4107),
    [anon_sym_class] = ACTIONS(4109),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_EQ] = ACTIONS(4115),
    [anon_sym_const] = ACTIONS(4117),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(4119),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_var] = ACTIONS(4121),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_interface] = ACTIONS(4123),
    [anon_sym_default] = ACTIONS(4125),
    [anon_sym_enum] = ACTIONS(4127),
    [anon_sym_as] = ACTIONS(4129),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_function] = ACTIONS(4131),
    [anon_sym_abstract] = ACTIONS(4133),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(4135),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_import] = ACTIONS(4139),
    [anon_sym_export] = ACTIONS(4141),
    [anon_sym_namespace] = ACTIONS(4143),
  },
  [1805] = {
    [sym_string] = STATE(2711),
    [sym__property_name] = STATE(2711),
    [sym_computed_property_name] = STATE(2711),
    [anon_sym_get] = ACTIONS(5699),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(5703),
    [anon_sym_STAR] = ACTIONS(5695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(5699),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_async] = ACTIONS(5701),
  },
  [1806] = {
    [aux_sym_export_statement_repeat1] = STATE(1012),
    [sym__property_name] = STATE(707),
    [sym_decorator] = STATE(1012),
    [sym_string] = STATE(707),
    [sym_accessibility_modifier] = STATE(221),
    [sym_method_definition] = STATE(708),
    [sym_computed_property_name] = STATE(707),
    [anon_sym_get] = ACTIONS(1320),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1318),
    [anon_sym_static] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [sym_number] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(364),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1316),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1320),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(5707),
    [sym_readonly] = ACTIONS(384),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1316),
    [anon_sym_public] = ACTIONS(1316),
  },
  [1807] = {
    [sym_type_parameters] = STATE(2715),
    [sym_type_annotation] = STATE(1976),
    [sym_formal_parameters] = STATE(2716),
    [sym_call_signature] = STATE(2717),
    [sym__automatic_semicolon] = ACTIONS(4147),
    [anon_sym_RBRACE] = ACTIONS(4147),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_SEMI] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(5711),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4147),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(4147),
    [sym_comment] = ACTIONS(3),
  },
  [1808] = {
    [sym_string] = STATE(2711),
    [sym__property_name] = STATE(2711),
    [sym_computed_property_name] = STATE(2711),
    [anon_sym_get] = ACTIONS(5699),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_async] = ACTIONS(5701),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(5703),
    [anon_sym_STAR] = ACTIONS(5695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(5699),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(5705),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(5713),
    [anon_sym_private] = ACTIONS(1135),
  },
  [1809] = {
    [sym__initializer] = STATE(722),
    [sym_type_annotation] = STATE(723),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1332),
    [anon_sym_AMP_EQ] = ACTIONS(1332),
    [anon_sym_PLUS_EQ] = ACTIONS(1332),
    [anon_sym_PIPE] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(1334),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(4198),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1332),
    [anon_sym_STAR_EQ] = ACTIONS(1332),
    [anon_sym_PIPE_EQ] = ACTIONS(1332),
    [anon_sym_DASH_EQ] = ACTIONS(1332),
    [anon_sym_EQ_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(1341),
    [anon_sym_LT_LT_EQ] = ACTIONS(1332),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(5715),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1344),
    [anon_sym_SLASH_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT_EQ] = ACTIONS(1332),
    [anon_sym_DOT] = ACTIONS(5719),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1347),
  },
  [1810] = {
    [sym__initializer] = STATE(732),
    [sym_type_annotation] = STATE(733),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1353),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_AMP_EQ] = ACTIONS(1353),
    [anon_sym_PLUS_EQ] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(1353),
    [anon_sym_STAR_EQ] = ACTIONS(1353),
    [anon_sym_PIPE_EQ] = ACTIONS(1353),
    [anon_sym_DASH_EQ] = ACTIONS(1353),
    [anon_sym_EQ_GT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1360),
    [anon_sym_LT_LT_EQ] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(5721),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1363),
    [anon_sym_SLASH_EQ] = ACTIONS(1353),
    [anon_sym_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1353),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1811] = {
    [sym_new_expression] = STATE(735),
    [sym_augmented_assignment_expression] = STATE(735),
    [sym_unary_expression] = STATE(735),
    [sym_update_expression] = STATE(735),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(735),
    [sym_regex] = STATE(735),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(735),
    [sym_non_null_expression] = STATE(735),
    [sym_as_expression] = STATE(735),
    [sym_jsx_fragment] = STATE(735),
    [sym_yield_expression] = STATE(735),
    [sym_jsx_element] = STATE(735),
    [sym_internal_module] = STATE(735),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(735),
    [sym_await_expression] = STATE(735),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(735),
    [sym_this] = STATE(735),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(735),
    [sym_generator_function] = STATE(735),
    [sym_call_expression] = STATE(735),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(735),
    [sym_ternary_expression] = STATE(735),
    [sym_binary_expression] = STATE(735),
    [sym_template_string] = STATE(735),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(735),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(735),
    [sym_class] = STATE(735),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1370),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5725),
    [sym_true] = ACTIONS(1370),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1370),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [1812] = {
    [sym_new_expression] = STATE(734),
    [sym_augmented_assignment_expression] = STATE(734),
    [sym__initializer] = STATE(732),
    [sym_unary_expression] = STATE(734),
    [sym_update_expression] = STATE(734),
    [sym_regex] = STATE(734),
    [sym_meta_property] = STATE(734),
    [sym_call_signature] = STATE(243),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(734),
    [sym_non_null_expression] = STATE(734),
    [sym_yield_expression] = STATE(734),
    [sym_jsx_fragment] = STATE(734),
    [sym_jsx_element] = STATE(734),
    [sym_as_expression] = STATE(734),
    [sym_internal_module] = STATE(734),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(734),
    [sym_await_expression] = STATE(734),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(734),
    [sym_this] = STATE(734),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(734),
    [sym_generator_function] = STATE(734),
    [sym_call_expression] = STATE(734),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(734),
    [sym_ternary_expression] = STATE(734),
    [sym_binary_expression] = STATE(734),
    [sym_template_string] = STATE(734),
    [sym_type_annotation] = STATE(733),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(734),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(734),
    [sym_class] = STATE(734),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(1353),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_AMP_EQ] = ACTIONS(1353),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1353),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_PIPE_EQ] = ACTIONS(1353),
    [anon_sym_DASH_EQ] = ACTIONS(1353),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(432),
    [sym_true] = ACTIONS(1366),
    [anon_sym_COLON] = ACTIONS(1363),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1353),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(416),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(1366),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_STAR_EQ] = ACTIONS(1353),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_EQ_GT] = ACTIONS(1358),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(1360),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(5721),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(1368),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1353),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1366),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1813] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(207),
    [anon_sym_LT_LT] = ACTIONS(207),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_GT_GT_GT] = ACTIONS(207),
    [anon_sym_EQ] = ACTIONS(209),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_BANG_EQ] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(207),
    [anon_sym_GT_EQ] = ACTIONS(207),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_DASH_DASH] = ACTIONS(207),
    [anon_sym_EQ_EQ] = ACTIONS(209),
    [anon_sym_RPAREN] = ACTIONS(3825),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_instanceof] = ACTIONS(207),
    [anon_sym_SLASH] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(207),
    [anon_sym_DOT] = ACTIONS(207),
    [anon_sym_CARET] = ACTIONS(207),
    [anon_sym_STAR_STAR] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_GT_GT] = ACTIONS(209),
    [anon_sym_PLUS_PLUS] = ACTIONS(207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(209),
  },
  [1814] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3749),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(3752),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(3749),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [1815] = {
    [sym_new_expression] = STATE(734),
    [sym_augmented_assignment_expression] = STATE(734),
    [sym_unary_expression] = STATE(734),
    [sym_update_expression] = STATE(734),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(734),
    [sym_regex] = STATE(734),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(734),
    [sym_non_null_expression] = STATE(734),
    [sym_as_expression] = STATE(734),
    [sym_jsx_fragment] = STATE(734),
    [sym_yield_expression] = STATE(734),
    [sym_jsx_element] = STATE(734),
    [sym_internal_module] = STATE(734),
    [sym_nested_identifier] = STATE(1092),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(734),
    [sym_await_expression] = STATE(734),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(734),
    [sym_this] = STATE(734),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(734),
    [sym_generator_function] = STATE(734),
    [sym_call_expression] = STATE(734),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(734),
    [sym_ternary_expression] = STATE(734),
    [sym_binary_expression] = STATE(734),
    [sym_template_string] = STATE(734),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(734),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(734),
    [sym_class] = STATE(734),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(5727),
    [sym_false] = ACTIONS(1366),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1366),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1368),
    [sym_true] = ACTIONS(1366),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1366),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [1816] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(2722),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(2723),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(1390),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(1392),
    [anon_sym_symbol] = ACTIONS(1392),
    [anon_sym_number] = ACTIONS(1392),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1392),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1392),
    [anon_sym_private] = ACTIONS(1392),
    [anon_sym_boolean] = ACTIONS(1392),
    [anon_sym_async] = ACTIONS(1396),
    [anon_sym_public] = ACTIONS(1392),
    [anon_sym_get] = ACTIONS(1392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1392),
    [anon_sym_string] = ACTIONS(1392),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(1392),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(1392),
    [anon_sym_export] = ACTIONS(1392),
    [anon_sym_namespace] = ACTIONS(1398),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [1817] = {
    [sym_formal_parameters] = STATE(2724),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1818] = {
    [sym_type_annotation] = STATE(323),
    [anon_sym_EQ_GT] = ACTIONS(5729),
    [anon_sym_COLON] = ACTIONS(550),
    [sym_comment] = ACTIONS(3),
  },
  [1819] = {
    [sym_formal_parameters] = STATE(2725),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1820] = {
    [sym_type_annotation] = STATE(323),
    [anon_sym_EQ_GT] = ACTIONS(5732),
    [anon_sym_COLON] = ACTIONS(550),
    [sym_comment] = ACTIONS(3),
  },
  [1821] = {
    [sym_type_annotation] = STATE(892),
    [anon_sym_EQ_GT] = ACTIONS(5735),
    [anon_sym_COLON] = ACTIONS(550),
    [sym_comment] = ACTIONS(3),
  },
  [1822] = {
    [anon_sym_GT] = ACTIONS(5738),
    [sym_comment] = ACTIONS(3),
  },
  [1823] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(1589),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(1589),
    [sym_jsx_expression] = STATE(1589),
    [anon_sym_GT] = ACTIONS(3333),
    [sym_identifier] = ACTIONS(1492),
    [sym_jsx_identifier] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(5740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [1824] = {
    [anon_sym_COLON] = ACTIONS(1513),
    [anon_sym_GT] = ACTIONS(5742),
    [anon_sym_DOT] = ACTIONS(5744),
    [sym_comment] = ACTIONS(3),
  },
  [1825] = {
    [anon_sym_COLON] = ACTIONS(1513),
    [anon_sym_GT] = ACTIONS(5742),
    [sym_comment] = ACTIONS(3),
  },
  [1826] = {
    [anon_sym_DOT] = ACTIONS(5744),
    [anon_sym_GT] = ACTIONS(5742),
    [sym_comment] = ACTIONS(3),
  },
  [1827] = {
    [anon_sym_GT] = ACTIONS(5742),
    [sym_comment] = ACTIONS(3),
  },
  [1828] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(5746),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5746),
    [anon_sym_AMP_EQ] = ACTIONS(5746),
    [anon_sym_PLUS_EQ] = ACTIONS(5746),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(5748),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(5746),
    [anon_sym_STAR_EQ] = ACTIONS(5746),
    [anon_sym_PIPE_EQ] = ACTIONS(5746),
    [anon_sym_DASH_EQ] = ACTIONS(5746),
    [anon_sym_EQ_GT] = ACTIONS(5750),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(5746),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5746),
    [anon_sym_GT_GT_EQ] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5746),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5752),
  },
  [1829] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(5754),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5754),
    [anon_sym_AMP_EQ] = ACTIONS(5754),
    [anon_sym_PLUS_EQ] = ACTIONS(5754),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(5748),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(5754),
    [anon_sym_STAR_EQ] = ACTIONS(5754),
    [anon_sym_PIPE_EQ] = ACTIONS(5754),
    [anon_sym_DASH_EQ] = ACTIONS(5754),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(5754),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5754),
    [anon_sym_GT_GT_EQ] = ACTIONS(5754),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1830] = {
    [sym_new_expression] = STATE(2735),
    [sym_augmented_assignment_expression] = STATE(2735),
    [sym_unary_expression] = STATE(2735),
    [sym_update_expression] = STATE(2735),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(2735),
    [sym_regex] = STATE(2735),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2735),
    [sym_non_null_expression] = STATE(2735),
    [sym_as_expression] = STATE(2735),
    [sym_jsx_fragment] = STATE(2735),
    [sym_yield_expression] = STATE(2735),
    [sym_jsx_element] = STATE(2735),
    [sym_internal_module] = STATE(2735),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2735),
    [sym_await_expression] = STATE(2735),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(2735),
    [sym_this] = STATE(2735),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(2735),
    [sym_generator_function] = STATE(2735),
    [sym_call_expression] = STATE(2735),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(2735),
    [sym_ternary_expression] = STATE(2735),
    [sym_binary_expression] = STATE(2735),
    [sym_template_string] = STATE(2735),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2735),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2735),
    [sym_class] = STATE(2735),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3842),
    [sym_false] = ACTIONS(5758),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5758),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5760),
    [sym_true] = ACTIONS(5758),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5758),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [1831] = {
    [sym_new_expression] = STATE(2736),
    [sym_augmented_assignment_expression] = STATE(2736),
    [sym_unary_expression] = STATE(2736),
    [sym_update_expression] = STATE(2736),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(2736),
    [sym_regex] = STATE(2736),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2736),
    [sym_non_null_expression] = STATE(2736),
    [sym_as_expression] = STATE(2736),
    [sym_jsx_fragment] = STATE(2736),
    [sym_yield_expression] = STATE(2736),
    [sym_jsx_element] = STATE(2736),
    [sym_internal_module] = STATE(2736),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2736),
    [sym_await_expression] = STATE(2736),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(2736),
    [sym_this] = STATE(2736),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(2736),
    [sym_generator_function] = STATE(2736),
    [sym_call_expression] = STATE(2736),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(2736),
    [sym_ternary_expression] = STATE(2736),
    [sym_binary_expression] = STATE(2736),
    [sym_template_string] = STATE(2736),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2736),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2736),
    [sym_class] = STATE(2736),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3842),
    [sym_false] = ACTIONS(5762),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5762),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5764),
    [sym_true] = ACTIONS(5762),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5762),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [1832] = {
    [sym_new_expression] = STATE(2735),
    [sym_augmented_assignment_expression] = STATE(2735),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(2735),
    [sym_update_expression] = STATE(2735),
    [sym_regex] = STATE(2735),
    [sym_meta_property] = STATE(2735),
    [sym_call_signature] = STATE(1839),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2735),
    [sym_non_null_expression] = STATE(2735),
    [sym_yield_expression] = STATE(2735),
    [sym_jsx_fragment] = STATE(2735),
    [sym_jsx_element] = STATE(2735),
    [sym_as_expression] = STATE(2735),
    [sym_internal_module] = STATE(2735),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2735),
    [sym_await_expression] = STATE(2735),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(2735),
    [sym_this] = STATE(2735),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(2735),
    [sym_generator_function] = STATE(2735),
    [sym_call_expression] = STATE(2735),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(2735),
    [sym_ternary_expression] = STATE(2735),
    [sym_binary_expression] = STATE(2735),
    [sym_template_string] = STATE(2735),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2735),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2735),
    [sym_class] = STATE(2735),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(3842),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(5754),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_AMP_EQ] = ACTIONS(5754),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(5754),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(5748),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(5754),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_PIPE_EQ] = ACTIONS(5754),
    [anon_sym_DASH_EQ] = ACTIONS(5754),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(5754),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(3860),
    [sym_true] = ACTIONS(5758),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_GT_GT_EQ] = ACTIONS(5754),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5754),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(3848),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(5758),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5754),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5758),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_STAR_EQ] = ACTIONS(5754),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(5760),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5754),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5758),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1833] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_call_signature] = STATE(2737),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(5766),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(5754),
    [anon_sym_symbol] = ACTIONS(5768),
    [anon_sym_AMP_EQ] = ACTIONS(5754),
    [anon_sym_PLUS_EQ] = ACTIONS(5754),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(5748),
    [anon_sym_void] = ACTIONS(5768),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(5754),
    [anon_sym_private] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(5754),
    [anon_sym_DASH_EQ] = ACTIONS(5754),
    [anon_sym_get] = ACTIONS(5768),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(5754),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(5768),
    [anon_sym_GT_GT_EQ] = ACTIONS(5754),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(5768),
    [anon_sym_type] = ACTIONS(5768),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(5768),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5754),
    [anon_sym_namespace] = ACTIONS(5768),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(5768),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5754),
    [anon_sym_number] = ACTIONS(5768),
    [anon_sym_declare] = ACTIONS(5768),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(5768),
    [anon_sym_STAR_EQ] = ACTIONS(5754),
    [anon_sym_boolean] = ACTIONS(5768),
    [anon_sym_async] = ACTIONS(5768),
    [anon_sym_public] = ACTIONS(5768),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5754),
    [anon_sym_string] = ACTIONS(5768),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(5768),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1834] = {
    [sym_new_expression] = STATE(2739),
    [sym_augmented_assignment_expression] = STATE(2739),
    [sym_unary_expression] = STATE(2739),
    [sym_update_expression] = STATE(2739),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(2739),
    [sym_regex] = STATE(2739),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2739),
    [sym_non_null_expression] = STATE(2739),
    [sym_as_expression] = STATE(2739),
    [sym_jsx_fragment] = STATE(2739),
    [sym_yield_expression] = STATE(2739),
    [sym_jsx_element] = STATE(2739),
    [sym_internal_module] = STATE(2739),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2739),
    [sym_await_expression] = STATE(2739),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(2739),
    [sym_this] = STATE(2739),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(2739),
    [sym_generator_function] = STATE(2739),
    [sym_call_expression] = STATE(2739),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(2739),
    [sym_ternary_expression] = STATE(2739),
    [sym_binary_expression] = STATE(2739),
    [sym_template_string] = STATE(2739),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2739),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2739),
    [sym_class] = STATE(2739),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3842),
    [sym_false] = ACTIONS(5770),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5770),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5772),
    [sym_true] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5770),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [1835] = {
    [sym_new_expression] = STATE(2740),
    [sym_augmented_assignment_expression] = STATE(2740),
    [sym_unary_expression] = STATE(2740),
    [sym_update_expression] = STATE(2740),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(2740),
    [sym_regex] = STATE(2740),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2740),
    [sym_non_null_expression] = STATE(2740),
    [sym_as_expression] = STATE(2740),
    [sym_jsx_fragment] = STATE(2740),
    [sym_yield_expression] = STATE(2740),
    [sym_jsx_element] = STATE(2740),
    [sym_internal_module] = STATE(2740),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2740),
    [sym_await_expression] = STATE(2740),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(2740),
    [sym_this] = STATE(2740),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(2740),
    [sym_generator_function] = STATE(2740),
    [sym_call_expression] = STATE(2740),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(2740),
    [sym_ternary_expression] = STATE(2740),
    [sym_binary_expression] = STATE(2740),
    [sym_template_string] = STATE(2740),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2740),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2740),
    [sym_class] = STATE(2740),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(3842),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_RBRACE] = ACTIONS(211),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(3860),
    [sym_true] = ACTIONS(5774),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(3848),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(5774),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5774),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(5776),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5774),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [1836] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(5778),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(5780),
    [anon_sym_symbol] = ACTIONS(5780),
    [anon_sym_number] = ACTIONS(5780),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5780),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(5782),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5780),
    [anon_sym_private] = ACTIONS(5780),
    [anon_sym_boolean] = ACTIONS(5780),
    [anon_sym_async] = ACTIONS(5784),
    [anon_sym_public] = ACTIONS(5780),
    [anon_sym_get] = ACTIONS(5780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5780),
    [anon_sym_string] = ACTIONS(5780),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(5780),
    [anon_sym_type] = ACTIONS(5780),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(5780),
    [anon_sym_export] = ACTIONS(5780),
    [anon_sym_namespace] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [1837] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(5754),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5754),
    [anon_sym_AMP_EQ] = ACTIONS(5754),
    [anon_sym_PLUS_EQ] = ACTIONS(5754),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(5748),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(5754),
    [anon_sym_STAR_EQ] = ACTIONS(5754),
    [anon_sym_PIPE_EQ] = ACTIONS(5754),
    [anon_sym_DASH_EQ] = ACTIONS(5754),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(5754),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5754),
    [anon_sym_GT_GT_EQ] = ACTIONS(5754),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1838] = {
    [sym_new_expression] = STATE(2746),
    [sym_augmented_assignment_expression] = STATE(2746),
    [sym_unary_expression] = STATE(2746),
    [sym_update_expression] = STATE(2746),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(2746),
    [sym_regex] = STATE(2746),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2746),
    [sym_non_null_expression] = STATE(2746),
    [sym_as_expression] = STATE(2746),
    [sym_jsx_fragment] = STATE(2746),
    [sym_yield_expression] = STATE(2746),
    [sym_jsx_element] = STATE(2746),
    [sym_internal_module] = STATE(2746),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2746),
    [sym_await_expression] = STATE(2746),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(2746),
    [sym_this] = STATE(2746),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(2746),
    [sym_generator_function] = STATE(2746),
    [sym_call_expression] = STATE(2746),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(2746),
    [sym_ternary_expression] = STATE(2746),
    [sym_binary_expression] = STATE(2746),
    [sym_template_string] = STATE(2746),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2746),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2746),
    [sym_class] = STATE(2746),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3842),
    [sym_false] = ACTIONS(5788),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5788),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5790),
    [sym_true] = ACTIONS(5788),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5788),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [1839] = {
    [anon_sym_EQ_GT] = ACTIONS(5750),
    [sym_comment] = ACTIONS(3),
  },
  [1840] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5792),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(5752),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(5794),
    [anon_sym_LT_LT] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(5800),
    [anon_sym_GT_GT_GT] = ACTIONS(5796),
    [anon_sym_AMP_AMP] = ACTIONS(5802),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(5792),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_RBRACE] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [anon_sym_QMARK] = ACTIONS(5806),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_as] = ACTIONS(5810),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_instanceof] = ACTIONS(5792),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(5808),
    [anon_sym_STAR_STAR] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5798),
    [anon_sym_GT_GT] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5792),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [1841] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(5746),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5746),
    [anon_sym_AMP_EQ] = ACTIONS(5746),
    [anon_sym_PLUS_EQ] = ACTIONS(5746),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(5748),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(5746),
    [anon_sym_STAR_EQ] = ACTIONS(5746),
    [anon_sym_PIPE_EQ] = ACTIONS(5746),
    [anon_sym_DASH_EQ] = ACTIONS(5746),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(5746),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5746),
    [anon_sym_GT_GT_EQ] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5746),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [1842] = {
    [sym__initializer] = STATE(587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(5748),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5752),
  },
  [1843] = {
    [sym__initializer] = STATE(589),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(5748),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5752),
  },
  [1844] = {
    [sym_jsx_text] = ACTIONS(5816),
    [anon_sym_LT] = ACTIONS(5816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5816),
  },
  [1845] = {
    [sym_nested_identifier] = STATE(2757),
    [sym_jsx_namespace_name] = STATE(2758),
    [sym_identifier] = ACTIONS(5818),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(5820),
  },
  [1846] = {
    [sym_jsx_text] = ACTIONS(3876),
    [anon_sym_LT] = ACTIONS(3876),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3876),
  },
  [1847] = {
    [sym_nested_identifier] = STATE(965),
    [sym_jsx_namespace_name] = STATE(966),
    [sym_identifier] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1975),
  },
  [1848] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3024),
    [sym__automatic_semicolon] = ACTIONS(3024),
    [sym_identifier] = ACTIONS(3022),
    [anon_sym_BQUOTE] = ACTIONS(3024),
    [anon_sym_debugger] = ACTIONS(3022),
    [anon_sym_with] = ACTIONS(3022),
    [anon_sym_symbol] = ACTIONS(3022),
    [anon_sym_AT] = ACTIONS(3024),
    [anon_sym_PIPE] = ACTIONS(3022),
    [anon_sym_COMMA] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3022),
    [anon_sym_GT_GT_GT] = ACTIONS(3024),
    [anon_sym_void] = ACTIONS(3022),
    [anon_sym_break] = ACTIONS(3022),
    [anon_sym_BANG_EQ] = ACTIONS(3022),
    [anon_sym_const] = ACTIONS(3022),
    [anon_sym_GT_EQ] = ACTIONS(3024),
    [sym_super] = ACTIONS(3022),
    [anon_sym_return] = ACTIONS(3022),
    [anon_sym_private] = ACTIONS(3022),
    [anon_sym_get] = ACTIONS(3022),
    [anon_sym_RBRACE] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3024),
    [anon_sym_interface] = ACTIONS(3022),
    [anon_sym_default] = ACTIONS(3022),
    [anon_sym_as] = ACTIONS(3022),
    [anon_sym_delete] = ACTIONS(3022),
    [anon_sym_continue] = ACTIONS(3022),
    [anon_sym_DASH_DASH] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3022),
    [anon_sym_instanceof] = ACTIONS(3022),
    [anon_sym_this] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3022),
    [sym_true] = ACTIONS(3022),
    [anon_sym_throw] = ACTIONS(3022),
    [anon_sym_enum] = ACTIONS(3022),
    [anon_sym_protected] = ACTIONS(3022),
    [anon_sym_abstract] = ACTIONS(3022),
    [anon_sym_DOT] = ACTIONS(3022),
    [anon_sym_set] = ACTIONS(3022),
    [anon_sym_type] = ACTIONS(3022),
    [anon_sym_STAR_STAR] = ACTIONS(3024),
    [anon_sym_import] = ACTIONS(3022),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3024),
    [anon_sym_namespace] = ACTIONS(3022),
    [anon_sym_PLUS_PLUS] = ACTIONS(3024),
    [anon_sym_await] = ACTIONS(3022),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_else] = ACTIONS(3022),
    [anon_sym_BANG] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3022),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [sym_false] = ACTIONS(3022),
    [anon_sym_SEMI] = ACTIONS(3024),
    [anon_sym_case] = ACTIONS(3022),
    [anon_sym_module] = ACTIONS(3022),
    [anon_sym_number] = ACTIONS(3022),
    [anon_sym_class] = ACTIONS(3022),
    [anon_sym_declare] = ACTIONS(3022),
    [anon_sym_typeof] = ACTIONS(3022),
    [anon_sym_LT_LT] = ACTIONS(3024),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_switch] = ACTIONS(3022),
    [anon_sym_LT_EQ] = ACTIONS(3024),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [sym_null] = ACTIONS(3022),
    [anon_sym_GT] = ACTIONS(3022),
    [anon_sym_any] = ACTIONS(3022),
    [anon_sym_boolean] = ACTIONS(3022),
    [anon_sym_async] = ACTIONS(3022),
    [anon_sym_public] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3022),
    [anon_sym_var] = ACTIONS(3022),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_PIPE_PIPE] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3022),
    [anon_sym_SQUOTE] = ACTIONS(3024),
    [anon_sym_try] = ACTIONS(3022),
    [anon_sym_EQ_EQ] = ACTIONS(3022),
    [anon_sym_RPAREN] = ACTIONS(3024),
    [anon_sym_LT] = ACTIONS(3022),
    [sym_number] = ACTIONS(3024),
    [anon_sym_SLASH] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(3024),
    [anon_sym_string] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3022),
    [sym_undefined] = ACTIONS(3022),
    [anon_sym_CARET] = ACTIONS(3024),
    [anon_sym_new] = ACTIONS(3022),
    [anon_sym_PLUS] = ACTIONS(3022),
    [anon_sym_let] = ACTIONS(3022),
    [anon_sym_GT_GT] = ACTIONS(3022),
    [anon_sym_export] = ACTIONS(3022),
    [anon_sym_do] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3024),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3024),
    [anon_sym_in] = ACTIONS(3022),
  },
  [1849] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_BANG_EQ] = ACTIONS(2021),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2021),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_QMARK] = ACTIONS(2077),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2021),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2081),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2021),
  },
  [1850] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [1851] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(2003),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_BANG_EQ] = ACTIONS(2021),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2021),
    [anon_sym_RBRACE] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_QMARK] = ACTIONS(2077),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2021),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2081),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2021),
  },
  [1852] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(2005),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_BANG_EQ] = ACTIONS(2021),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2021),
    [anon_sym_RBRACE] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_QMARK] = ACTIONS(2077),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2021),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2081),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2021),
  },
  [1853] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(2101),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_BANG_EQ] = ACTIONS(2021),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2021),
    [anon_sym_RBRACE] = ACTIONS(2101),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_QMARK] = ACTIONS(2077),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2021),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2081),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2021),
  },
  [1854] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_BANG_EQ] = ACTIONS(2021),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2021),
    [anon_sym_RBRACE] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_QMARK] = ACTIONS(2077),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2021),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2081),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2021),
  },
  [1855] = {
    [sym_new_expression] = STATE(2759),
    [sym_augmented_assignment_expression] = STATE(2759),
    [sym_unary_expression] = STATE(2759),
    [sym_update_expression] = STATE(2759),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(2759),
    [sym_regex] = STATE(2759),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2185),
    [sym__expression] = STATE(2759),
    [sym_non_null_expression] = STATE(2759),
    [sym_yield_expression] = STATE(2759),
    [sym_jsx_fragment] = STATE(2759),
    [sym_jsx_element] = STATE(2759),
    [sym_as_expression] = STATE(2759),
    [sym_internal_module] = STATE(2759),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2759),
    [sym_await_expression] = STATE(2759),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(2759),
    [sym_this] = STATE(2759),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(2759),
    [sym_generator_function] = STATE(2759),
    [sym_call_expression] = STATE(2759),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(2759),
    [sym_ternary_expression] = STATE(2759),
    [sym_binary_expression] = STATE(2759),
    [sym_template_string] = STATE(2759),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2759),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2759),
    [sym_class] = STATE(2759),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5822),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5824),
    [sym_true] = ACTIONS(5822),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5822),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [1856] = {
    [sym_new_expression] = STATE(2760),
    [sym_augmented_assignment_expression] = STATE(2760),
    [sym_unary_expression] = STATE(2760),
    [sym_update_expression] = STATE(2760),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(2760),
    [sym_regex] = STATE(2760),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2187),
    [sym__expression] = STATE(2760),
    [sym_non_null_expression] = STATE(2760),
    [sym_yield_expression] = STATE(2760),
    [sym_jsx_fragment] = STATE(2760),
    [sym_jsx_element] = STATE(2760),
    [sym_as_expression] = STATE(2760),
    [sym_internal_module] = STATE(2760),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2760),
    [sym_await_expression] = STATE(2760),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(2760),
    [sym_this] = STATE(2760),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(2760),
    [sym_generator_function] = STATE(2760),
    [sym_call_expression] = STATE(2760),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(2760),
    [sym_ternary_expression] = STATE(2760),
    [sym_binary_expression] = STATE(2760),
    [sym_template_string] = STATE(2760),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2760),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2760),
    [sym_class] = STATE(2760),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(5826),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5826),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5828),
    [sym_true] = ACTIONS(5826),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5826),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [1857] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_BANG_EQ] = ACTIONS(2021),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2021),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2021),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2021),
  },
  [1858] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(5830),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [1859] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(5830),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [1860] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_BANG_EQ] = ACTIONS(2021),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2021),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2021),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2021),
  },
  [1861] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2021),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2071),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_BANG_EQ] = ACTIONS(2021),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2021),
    [anon_sym_RBRACE] = ACTIONS(3622),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_QMARK] = ACTIONS(2077),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2021),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2081),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [1862] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3630),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5833),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [1863] = {
    [sym_type_arguments] = STATE(2206),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(4638),
    [anon_sym_BANG] = ACTIONS(3699),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_GT_GT_GT] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_is] = ACTIONS(5835),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_instanceof] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(4643),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4646),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_STAR_STAR] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2204),
    [anon_sym_in] = ACTIONS(3699),
  },
  [1864] = {
    [sym_index_type_query] = STATE(2208),
    [sym_lookup_type] = STATE(2208),
    [sym_flow_maybe_type] = STATE(2208),
    [sym_parenthesized_type] = STATE(2208),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_array_type] = STATE(2208),
    [sym_type_predicate] = STATE(2208),
    [sym_type_query] = STATE(2208),
    [sym_existential_type] = STATE(2208),
    [sym_this_type] = STATE(2208),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(2208),
    [sym__primary_type] = STATE(2208),
    [sym_generic_type] = STATE(2208),
    [sym_literal_type] = STATE(2208),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(2208),
    [sym_string] = STATE(1279),
    [sym_tuple_type] = STATE(2208),
    [sym_identifier] = ACTIONS(3946),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3952),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [sym_true] = ACTIONS(2643),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(4648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [1865] = {
    [sym_union_type] = STATE(2213),
    [sym__type] = STATE(2213),
    [sym_constructor_type] = STATE(2213),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1868),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2213),
    [sym_function_type] = STATE(2213),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1869),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3946),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3952),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [1866] = {
    [sym_type_parameters] = STATE(2763),
    [sym_formal_parameters] = STATE(2764),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1867] = {
    [sym_union_type] = STATE(2221),
    [sym__type] = STATE(2221),
    [sym_constructor_type] = STATE(2221),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1868),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2221),
    [sym_function_type] = STATE(2221),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1869),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3946),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3952),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [1868] = {
    [sym_formal_parameters] = STATE(2767),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1869] = {
    [anon_sym_EQ_GT] = ACTIONS(5837),
    [sym_comment] = ACTIONS(3),
  },
  [1870] = {
    [sym__initializer] = STATE(522),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2015),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2015),
    [anon_sym_AMP_EQ] = ACTIONS(2015),
    [anon_sym_PLUS_EQ] = ACTIONS(2015),
    [anon_sym_PIPE] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(2017),
    [anon_sym_GT] = ACTIONS(3738),
    [anon_sym_CARET_EQ] = ACTIONS(2015),
    [anon_sym_STAR_EQ] = ACTIONS(2015),
    [anon_sym_PIPE_EQ] = ACTIONS(2015),
    [anon_sym_DASH_EQ] = ACTIONS(2015),
    [anon_sym_EQ_GT] = ACTIONS(2019),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2015),
    [anon_sym_GT_GT_EQ] = ACTIONS(2015),
    [anon_sym_DOT] = ACTIONS(4670),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2015),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2021),
  },
  [1871] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2023),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2023),
    [anon_sym_AMP_EQ] = ACTIONS(2023),
    [anon_sym_PLUS_EQ] = ACTIONS(2023),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2017),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_CARET_EQ] = ACTIONS(2023),
    [anon_sym_STAR_EQ] = ACTIONS(2023),
    [anon_sym_PIPE_EQ] = ACTIONS(2023),
    [anon_sym_DASH_EQ] = ACTIONS(2023),
    [anon_sym_EQ_GT] = ACTIONS(2025),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(2023),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2023),
    [anon_sym_GT_GT_EQ] = ACTIONS(2023),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2023),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1872] = {
    [sym_new_expression] = STATE(983),
    [sym_augmented_assignment_expression] = STATE(983),
    [sym_unary_expression] = STATE(983),
    [sym_update_expression] = STATE(983),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(983),
    [sym_regex] = STATE(983),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(983),
    [sym_non_null_expression] = STATE(983),
    [sym_as_expression] = STATE(983),
    [sym_jsx_fragment] = STATE(983),
    [sym_yield_expression] = STATE(983),
    [sym_jsx_element] = STATE(983),
    [sym_internal_module] = STATE(983),
    [sym_nested_identifier] = STATE(1092),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(983),
    [sym_await_expression] = STATE(983),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(983),
    [sym_this] = STATE(983),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(983),
    [sym_generator_function] = STATE(983),
    [sym_call_expression] = STATE(983),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(983),
    [sym_ternary_expression] = STATE(983),
    [sym_binary_expression] = STATE(983),
    [sym_template_string] = STATE(983),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(983),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(983),
    [sym_class] = STATE(983),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(5839),
    [sym_false] = ACTIONS(2027),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2027),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2029),
    [sym_true] = ACTIONS(2027),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2027),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [1873] = {
    [sym_new_expression] = STATE(984),
    [sym_augmented_assignment_expression] = STATE(984),
    [sym_unary_expression] = STATE(984),
    [sym_update_expression] = STATE(984),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(984),
    [sym_regex] = STATE(984),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(984),
    [sym_non_null_expression] = STATE(984),
    [sym_as_expression] = STATE(984),
    [sym_jsx_fragment] = STATE(984),
    [sym_yield_expression] = STATE(984),
    [sym_jsx_element] = STATE(984),
    [sym_internal_module] = STATE(984),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(984),
    [sym_await_expression] = STATE(984),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(984),
    [sym_this] = STATE(984),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(984),
    [sym_generator_function] = STATE(984),
    [sym_call_expression] = STATE(984),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(984),
    [sym_ternary_expression] = STATE(984),
    [sym_binary_expression] = STATE(984),
    [sym_template_string] = STATE(984),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(984),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(984),
    [sym_class] = STATE(984),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2031),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4674),
    [sym_true] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [1874] = {
    [sym_new_expression] = STATE(983),
    [sym_augmented_assignment_expression] = STATE(983),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(983),
    [sym_update_expression] = STATE(983),
    [sym_regex] = STATE(983),
    [sym_meta_property] = STATE(983),
    [sym_call_signature] = STATE(361),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(983),
    [sym_non_null_expression] = STATE(983),
    [sym_yield_expression] = STATE(983),
    [sym_jsx_fragment] = STATE(983),
    [sym_jsx_element] = STATE(983),
    [sym_as_expression] = STATE(983),
    [sym_internal_module] = STATE(983),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(983),
    [sym_await_expression] = STATE(983),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(983),
    [sym_this] = STATE(983),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(983),
    [sym_generator_function] = STATE(983),
    [sym_call_expression] = STATE(983),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(983),
    [sym_ternary_expression] = STATE(983),
    [sym_binary_expression] = STATE(983),
    [sym_template_string] = STATE(983),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(983),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(983),
    [sym_class] = STATE(983),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(618),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2023),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_AMP_EQ] = ACTIONS(2023),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2023),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2017),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(2023),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_PIPE_EQ] = ACTIONS(2023),
    [anon_sym_DASH_EQ] = ACTIONS(2023),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2023),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(636),
    [sym_true] = ACTIONS(2027),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_GT_GT_EQ] = ACTIONS(2023),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2023),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(624),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2027),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2023),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2027),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_STAR_EQ] = ACTIONS(2023),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_EQ_GT] = ACTIONS(2025),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(2029),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2023),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2027),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1875] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(1819),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(1820),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(2047),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(2049),
    [anon_sym_symbol] = ACTIONS(2049),
    [anon_sym_number] = ACTIONS(2049),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2049),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2051),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2049),
    [anon_sym_private] = ACTIONS(2049),
    [anon_sym_boolean] = ACTIONS(2049),
    [anon_sym_async] = ACTIONS(2053),
    [anon_sym_public] = ACTIONS(2049),
    [anon_sym_get] = ACTIONS(2049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2049),
    [anon_sym_string] = ACTIONS(2049),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(2049),
    [anon_sym_type] = ACTIONS(2049),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(2049),
    [anon_sym_export] = ACTIONS(2049),
    [anon_sym_namespace] = ACTIONS(2055),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [1876] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(5830),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [1877] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4314),
    [sym_identifier] = ACTIONS(4316),
    [anon_sym_BQUOTE] = ACTIONS(4314),
    [anon_sym_symbol] = ACTIONS(4316),
    [anon_sym_AT] = ACTIONS(4314),
    [anon_sym_PIPE] = ACTIONS(4316),
    [anon_sym_COMMA] = ACTIONS(4314),
    [anon_sym_DASH] = ACTIONS(4316),
    [anon_sym_STAR] = ACTIONS(4316),
    [anon_sym_GT_GT_GT] = ACTIONS(4314),
    [anon_sym_void] = ACTIONS(4316),
    [anon_sym_BANG_EQ] = ACTIONS(4316),
    [anon_sym_GT_EQ] = ACTIONS(4314),
    [anon_sym_private] = ACTIONS(4316),
    [anon_sym_get] = ACTIONS(4316),
    [anon_sym_RBRACE] = ACTIONS(4314),
    [anon_sym_PERCENT] = ACTIONS(4314),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4314),
    [anon_sym_as] = ACTIONS(4316),
    [anon_sym_DASH_DASH] = ACTIONS(4314),
    [anon_sym_instanceof] = ACTIONS(4316),
    [anon_sym_this] = ACTIONS(4316),
    [anon_sym_COLON] = ACTIONS(4314),
    [anon_sym_protected] = ACTIONS(4316),
    [anon_sym_DOT] = ACTIONS(4316),
    [anon_sym_set] = ACTIONS(4316),
    [anon_sym_type] = ACTIONS(4316),
    [anon_sym_STAR_STAR] = ACTIONS(4314),
    [anon_sym_import] = ACTIONS(4316),
    [sym_readonly] = ACTIONS(4316),
    [anon_sym_PLUS_PLUS] = ACTIONS(4314),
    [anon_sym_namespace] = ACTIONS(4316),
    [anon_sym_BANG] = ACTIONS(4316),
    [anon_sym_LBRACK] = ACTIONS(4314),
    [anon_sym_module] = ACTIONS(4316),
    [anon_sym_number] = ACTIONS(4316),
    [anon_sym_class] = ACTIONS(4316),
    [anon_sym_declare] = ACTIONS(4316),
    [anon_sym_LT_LT] = ACTIONS(4314),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4314),
    [anon_sym_LBRACE] = ACTIONS(4316),
    [anon_sym_AMP_AMP] = ACTIONS(4314),
    [anon_sym_LT_EQ] = ACTIONS(4314),
    [anon_sym_LPAREN] = ACTIONS(4314),
    [anon_sym_RBRACK] = ACTIONS(4314),
    [anon_sym_GT] = ACTIONS(4316),
    [anon_sym_any] = ACTIONS(4316),
    [anon_sym_boolean] = ACTIONS(4316),
    [anon_sym_async] = ACTIONS(4316),
    [anon_sym_public] = ACTIONS(4316),
    [anon_sym_AMP] = ACTIONS(4316),
    [anon_sym_QMARK] = ACTIONS(4314),
    [anon_sym_PIPE_PIPE] = ACTIONS(4314),
    [anon_sym_EQ_EQ] = ACTIONS(4316),
    [anon_sym_RPAREN] = ACTIONS(4314),
    [anon_sym_LT] = ACTIONS(4316),
    [anon_sym_SLASH] = ACTIONS(4316),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4316),
    [anon_sym_CARET] = ACTIONS(4314),
    [anon_sym_PLUS] = ACTIONS(4316),
    [anon_sym_export] = ACTIONS(4316),
    [anon_sym_GT_GT] = ACTIONS(4316),
    [anon_sym_implements] = ACTIONS(4316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4314),
    [anon_sym_in] = ACTIONS(4316),
  },
  [1878] = {
    [aux_sym_array_repeat1] = STATE(1150),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_RPAREN] = ACTIONS(5841),
    [sym_comment] = ACTIONS(3),
  },
  [1879] = {
    [anon_sym_EQ] = ACTIONS(2633),
    [anon_sym_COLON] = ACTIONS(5088),
    [anon_sym_LT] = ACTIONS(5088),
    [anon_sym_QMARK] = ACTIONS(5088),
    [anon_sym_LPAREN] = ACTIONS(5088),
    [sym_comment] = ACTIONS(3),
  },
  [1880] = {
    [sym_statement_block] = STATE(2496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(909),
  },
  [1881] = {
    [sym_union_type] = STATE(2771),
    [sym__type] = STATE(2771),
    [sym_constructor_type] = STATE(2771),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1926),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2771),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1927),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4057),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1882] = {
    [sym_union_type] = STATE(2772),
    [sym__type] = STATE(2772),
    [sym_constructor_type] = STATE(2772),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2772),
    [sym_function_type] = STATE(2772),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1883] = {
    [sym_identifier] = ACTIONS(5843),
    [sym_comment] = ACTIONS(3),
  },
  [1884] = {
    [sym_union_type] = STATE(2777),
    [sym__type] = STATE(2777),
    [sym_constructor_type] = STATE(2777),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2778),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2777),
    [sym_function_type] = STATE(2777),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2779),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2135),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5845),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5847),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [1885] = {
    [anon_sym_EQ] = ACTIONS(4073),
    [anon_sym_LBRACK] = ACTIONS(4073),
    [anon_sym_AMP] = ACTIONS(4073),
    [anon_sym_SEMI] = ACTIONS(4073),
    [sym__automatic_semicolon] = ACTIONS(4073),
    [anon_sym_RBRACE] = ACTIONS(4073),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_COMMA] = ACTIONS(4073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4073),
  },
  [1886] = {
    [sym_union_type] = STATE(1899),
    [sym__type] = STATE(1899),
    [sym_constructor_type] = STATE(1899),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1108),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1899),
    [sym_function_type] = STATE(1899),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1109),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2282),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1887] = {
    [anon_sym_EQ] = ACTIONS(4077),
    [anon_sym_LBRACK] = ACTIONS(4008),
    [anon_sym_AMP] = ACTIONS(4077),
    [anon_sym_SEMI] = ACTIONS(4077),
    [sym__automatic_semicolon] = ACTIONS(4077),
    [anon_sym_RBRACE] = ACTIONS(4077),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4077),
    [anon_sym_PIPE] = ACTIONS(4075),
    [anon_sym_COMMA] = ACTIONS(4077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4077),
  },
  [1888] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(2780),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(2780),
    [sym_call_signature] = STATE(2780),
    [sym_export_statement] = STATE(2780),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(2780),
    [sym_index_signature] = STATE(2780),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [1889] = {
    [anon_sym_EQ] = ACTIONS(4105),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_SEMI] = ACTIONS(4105),
    [sym__automatic_semicolon] = ACTIONS(4105),
    [anon_sym_RBRACE] = ACTIONS(4105),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4103),
    [anon_sym_COMMA] = ACTIONS(4105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4105),
  },
  [1890] = {
    [aux_sym_object_type_repeat1] = STATE(2783),
    [sym__automatic_semicolon] = ACTIONS(5851),
    [anon_sym_RBRACE] = ACTIONS(5853),
    [anon_sym_SEMI] = ACTIONS(5851),
    [anon_sym_COMMA] = ACTIONS(5851),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5853),
    [sym_comment] = ACTIONS(3),
  },
  [1891] = {
    [aux_sym_implements_clause_repeat1] = STATE(2785),
    [anon_sym_AMP] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_COMMA] = ACTIONS(4165),
    [anon_sym_RBRACK] = ACTIONS(5855),
    [sym_comment] = ACTIONS(3),
  },
  [1892] = {
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [sym__automatic_semicolon] = ACTIONS(4173),
    [anon_sym_SEMI] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4173),
    [anon_sym_RBRACE] = ACTIONS(4173),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_COMMA] = ACTIONS(4173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4173),
  },
  [1893] = {
    [anon_sym_EQ] = ACTIONS(4177),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_AMP] = ACTIONS(4177),
    [anon_sym_SEMI] = ACTIONS(4177),
    [sym__automatic_semicolon] = ACTIONS(4177),
    [anon_sym_DOT] = ACTIONS(5857),
    [anon_sym_RBRACE] = ACTIONS(4177),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4177),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4177),
  },
  [1894] = {
    [anon_sym_EQ] = ACTIONS(4181),
    [anon_sym_LBRACK] = ACTIONS(4181),
    [anon_sym_AMP] = ACTIONS(4181),
    [anon_sym_SEMI] = ACTIONS(4181),
    [sym__automatic_semicolon] = ACTIONS(4181),
    [anon_sym_RBRACE] = ACTIONS(4181),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4181),
    [anon_sym_PIPE] = ACTIONS(4179),
    [anon_sym_COMMA] = ACTIONS(4181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4181),
  },
  [1895] = {
    [anon_sym_EQ] = ACTIONS(4185),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [anon_sym_AMP] = ACTIONS(4185),
    [anon_sym_SEMI] = ACTIONS(4185),
    [sym__automatic_semicolon] = ACTIONS(4185),
    [anon_sym_DOT] = ACTIONS(3983),
    [anon_sym_RBRACE] = ACTIONS(4185),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4185),
    [anon_sym_PIPE] = ACTIONS(4183),
    [anon_sym_COMMA] = ACTIONS(4185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4185),
  },
  [1896] = {
    [anon_sym_EQ] = ACTIONS(4191),
    [anon_sym_LBRACK] = ACTIONS(4191),
    [anon_sym_AMP] = ACTIONS(4191),
    [anon_sym_SEMI] = ACTIONS(4191),
    [sym__automatic_semicolon] = ACTIONS(4191),
    [anon_sym_RBRACE] = ACTIONS(4191),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4191),
    [anon_sym_PIPE] = ACTIONS(4189),
    [anon_sym_COMMA] = ACTIONS(4191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4191),
  },
  [1897] = {
    [sym_formal_parameters] = STATE(2787),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1898] = {
    [anon_sym_EQ_GT] = ACTIONS(5859),
    [sym_comment] = ACTIONS(3),
  },
  [1899] = {
    [anon_sym_AMP] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(5861),
    [anon_sym_PIPE] = ACTIONS(4221),
    [sym_comment] = ACTIONS(3),
  },
  [1900] = {
    [anon_sym_EQ] = ACTIONS(4227),
    [anon_sym_AMP] = ACTIONS(4227),
    [sym__automatic_semicolon] = ACTIONS(4227),
    [anon_sym_SEMI] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(4227),
    [anon_sym_RBRACE] = ACTIONS(4227),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4227),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_COMMA] = ACTIONS(4227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4227),
  },
  [1901] = {
    [sym_union_type] = STATE(2790),
    [sym__type] = STATE(2790),
    [sym_constructor_type] = STATE(2790),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1033),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2790),
    [sym_function_type] = STATE(2790),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1036),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2135),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [1902] = {
    [sym_union_type] = STATE(2791),
    [sym__type] = STATE(2791),
    [sym_constructor_type] = STATE(2791),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1033),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2791),
    [sym_function_type] = STATE(2791),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1036),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2135),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [1903] = {
    [sym_union_type] = STATE(2792),
    [sym__type] = STATE(2792),
    [sym_constructor_type] = STATE(2792),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1926),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2792),
    [sym_function_type] = STATE(2792),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1927),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4057),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1904] = {
    [anon_sym_EQ] = ACTIONS(4239),
    [anon_sym_LBRACK] = ACTIONS(4239),
    [anon_sym_AMP] = ACTIONS(4239),
    [anon_sym_SEMI] = ACTIONS(4239),
    [sym__automatic_semicolon] = ACTIONS(4239),
    [anon_sym_RBRACE] = ACTIONS(4239),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4239),
    [anon_sym_PIPE] = ACTIONS(4237),
    [anon_sym_COMMA] = ACTIONS(4239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4239),
  },
  [1905] = {
    [anon_sym_EQ_GT] = ACTIONS(5863),
    [sym_comment] = ACTIONS(3),
  },
  [1906] = {
    [anon_sym_RBRACK] = ACTIONS(5865),
    [sym_comment] = ACTIONS(3),
  },
  [1907] = {
    [sym_union_type] = STATE(2795),
    [sym__type] = STATE(2795),
    [sym_constructor_type] = STATE(2795),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1033),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2795),
    [sym_function_type] = STATE(2795),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1036),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2135),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [1908] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4676),
    [anon_sym_LBRACK] = ACTIONS(4676),
    [anon_sym_in] = ACTIONS(4678),
    [anon_sym_BQUOTE] = ACTIONS(4676),
    [anon_sym_PIPE] = ACTIONS(4678),
    [anon_sym_COMMA] = ACTIONS(4676),
    [anon_sym_DASH] = ACTIONS(4678),
    [anon_sym_STAR] = ACTIONS(4678),
    [anon_sym_GT_GT_GT] = ACTIONS(4676),
    [anon_sym_EQ] = ACTIONS(4678),
    [anon_sym_AMP_AMP] = ACTIONS(4676),
    [anon_sym_LT_LT] = ACTIONS(4676),
    [anon_sym_BANG_EQ] = ACTIONS(4678),
    [anon_sym_LT_EQ] = ACTIONS(4676),
    [anon_sym_LPAREN] = ACTIONS(4676),
    [anon_sym_RBRACK] = ACTIONS(4676),
    [anon_sym_GT_EQ] = ACTIONS(4676),
    [anon_sym_GT] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(4678),
    [anon_sym_of] = ACTIONS(4676),
    [anon_sym_AMP] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4676),
    [anon_sym_QMARK] = ACTIONS(4676),
    [anon_sym_RBRACE] = ACTIONS(4676),
    [anon_sym_as] = ACTIONS(4676),
    [anon_sym_PIPE_PIPE] = ACTIONS(4676),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4676),
    [anon_sym_DASH_DASH] = ACTIONS(4676),
    [anon_sym_EQ_EQ] = ACTIONS(4678),
    [anon_sym_instanceof] = ACTIONS(4676),
    [anon_sym_LT] = ACTIONS(4678),
    [anon_sym_RPAREN] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4676),
    [anon_sym_DOT] = ACTIONS(4676),
    [anon_sym_CARET] = ACTIONS(4676),
    [anon_sym_STAR_STAR] = ACTIONS(4676),
    [anon_sym_PLUS] = ACTIONS(4678),
    [anon_sym_implements] = ACTIONS(4676),
    [anon_sym_GT_GT] = ACTIONS(4678),
    [anon_sym_PLUS_PLUS] = ACTIONS(4676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4676),
    [anon_sym_BANG] = ACTIONS(4678),
  },
  [1909] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5026),
    [anon_sym_LBRACK] = ACTIONS(5026),
    [anon_sym_in] = ACTIONS(5028),
    [anon_sym_BQUOTE] = ACTIONS(5026),
    [anon_sym_PIPE] = ACTIONS(5028),
    [anon_sym_COMMA] = ACTIONS(5026),
    [anon_sym_DASH] = ACTIONS(5028),
    [anon_sym_STAR] = ACTIONS(5028),
    [anon_sym_GT_GT_GT] = ACTIONS(5026),
    [anon_sym_EQ] = ACTIONS(5028),
    [anon_sym_AMP_AMP] = ACTIONS(5026),
    [anon_sym_LT_LT] = ACTIONS(5026),
    [anon_sym_BANG_EQ] = ACTIONS(5028),
    [anon_sym_LT_EQ] = ACTIONS(5026),
    [anon_sym_LPAREN] = ACTIONS(5026),
    [anon_sym_RBRACK] = ACTIONS(5026),
    [anon_sym_GT_EQ] = ACTIONS(5026),
    [anon_sym_GT] = ACTIONS(5028),
    [anon_sym_LBRACE] = ACTIONS(5028),
    [anon_sym_of] = ACTIONS(5026),
    [anon_sym_AMP] = ACTIONS(5028),
    [anon_sym_PERCENT] = ACTIONS(5026),
    [anon_sym_QMARK] = ACTIONS(5026),
    [anon_sym_RBRACE] = ACTIONS(5026),
    [anon_sym_as] = ACTIONS(5026),
    [anon_sym_PIPE_PIPE] = ACTIONS(5026),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5026),
    [anon_sym_DASH_DASH] = ACTIONS(5026),
    [anon_sym_EQ_EQ] = ACTIONS(5028),
    [anon_sym_instanceof] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(5028),
    [anon_sym_RPAREN] = ACTIONS(5026),
    [anon_sym_SLASH] = ACTIONS(5028),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5026),
    [anon_sym_DOT] = ACTIONS(5026),
    [anon_sym_CARET] = ACTIONS(5026),
    [anon_sym_STAR_STAR] = ACTIONS(5026),
    [anon_sym_PLUS] = ACTIONS(5028),
    [anon_sym_implements] = ACTIONS(5026),
    [anon_sym_GT_GT] = ACTIONS(5028),
    [anon_sym_PLUS_PLUS] = ACTIONS(5026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5026),
    [anon_sym_BANG] = ACTIONS(5028),
  },
  [1910] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5094),
    [anon_sym_LBRACK] = ACTIONS(5094),
    [anon_sym_in] = ACTIONS(5096),
    [anon_sym_BQUOTE] = ACTIONS(5094),
    [anon_sym_PIPE] = ACTIONS(5096),
    [anon_sym_COMMA] = ACTIONS(5094),
    [anon_sym_DASH] = ACTIONS(5096),
    [anon_sym_STAR] = ACTIONS(5096),
    [anon_sym_GT_GT_GT] = ACTIONS(5094),
    [anon_sym_EQ] = ACTIONS(5096),
    [anon_sym_AMP_AMP] = ACTIONS(5094),
    [anon_sym_LT_LT] = ACTIONS(5094),
    [anon_sym_BANG_EQ] = ACTIONS(5096),
    [anon_sym_LT_EQ] = ACTIONS(5094),
    [anon_sym_LPAREN] = ACTIONS(5094),
    [anon_sym_RBRACK] = ACTIONS(5094),
    [anon_sym_GT_EQ] = ACTIONS(5094),
    [anon_sym_GT] = ACTIONS(5096),
    [anon_sym_LBRACE] = ACTIONS(5096),
    [anon_sym_of] = ACTIONS(5094),
    [anon_sym_AMP] = ACTIONS(5096),
    [anon_sym_PERCENT] = ACTIONS(5094),
    [anon_sym_QMARK] = ACTIONS(5094),
    [anon_sym_RBRACE] = ACTIONS(5094),
    [anon_sym_as] = ACTIONS(5094),
    [anon_sym_PIPE_PIPE] = ACTIONS(5094),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5094),
    [anon_sym_DASH_DASH] = ACTIONS(5094),
    [anon_sym_EQ_EQ] = ACTIONS(5096),
    [anon_sym_instanceof] = ACTIONS(5094),
    [anon_sym_LT] = ACTIONS(5096),
    [anon_sym_RPAREN] = ACTIONS(5094),
    [anon_sym_SLASH] = ACTIONS(5096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5094),
    [anon_sym_DOT] = ACTIONS(5094),
    [anon_sym_CARET] = ACTIONS(5094),
    [anon_sym_STAR_STAR] = ACTIONS(5094),
    [anon_sym_PLUS] = ACTIONS(5096),
    [anon_sym_implements] = ACTIONS(5094),
    [anon_sym_GT_GT] = ACTIONS(5096),
    [anon_sym_PLUS_PLUS] = ACTIONS(5094),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5094),
    [anon_sym_BANG] = ACTIONS(5096),
  },
  [1911] = {
    [aux_sym_object_repeat1] = STATE(699),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_RBRACE] = ACTIONS(5867),
    [sym_comment] = ACTIONS(3),
  },
  [1912] = {
    [sym_union_type] = STATE(2800),
    [sym__type] = STATE(2800),
    [sym_constructor_type] = STATE(2800),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2801),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2800),
    [sym_function_type] = STATE(2800),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2802),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2183),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5869),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5871),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1913] = {
    [sym_formal_parameters] = STATE(2803),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1914] = {
    [anon_sym_EQ_GT] = ACTIONS(5875),
    [sym_comment] = ACTIONS(3),
  },
  [1915] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1055),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1056),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2183),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1916] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1055),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1056),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2183),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1917] = {
    [anon_sym_EQ_GT] = ACTIONS(5877),
    [sym_comment] = ACTIONS(3),
  },
  [1918] = {
    [sym_union_type] = STATE(2806),
    [sym__type] = STATE(2806),
    [sym_constructor_type] = STATE(2806),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1055),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2806),
    [sym_function_type] = STATE(2806),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1056),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2183),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1919] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(945),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(2197),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(3622),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [1920] = {
    [sym_type_arguments] = STATE(1064),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_RBRACK] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(5879),
  },
  [1921] = {
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(433),
    [sym_array_type] = STATE(1066),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym_existential_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(1066),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(1066),
    [sym_string] = STATE(418),
    [sym_tuple_type] = STATE(1066),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [sym_true] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1922] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1926),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1927),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4057),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1923] = {
    [sym_type_parameters] = STATE(2808),
    [sym_formal_parameters] = STATE(2809),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1924] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1926),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1927),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4057),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1925] = {
    [anon_sym_AMP] = ACTIONS(5881),
    [anon_sym_PIPE] = ACTIONS(5883),
    [anon_sym_RBRACK] = ACTIONS(5885),
    [sym_comment] = ACTIONS(3),
  },
  [1926] = {
    [sym_formal_parameters] = STATE(2813),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1927] = {
    [anon_sym_EQ_GT] = ACTIONS(5887),
    [sym_comment] = ACTIONS(3),
  },
  [1928] = {
    [sym_identifier] = ACTIONS(5889),
    [anon_sym_BQUOTE] = ACTIONS(5891),
    [anon_sym_debugger] = ACTIONS(5889),
    [anon_sym_symbol] = ACTIONS(5889),
    [anon_sym_AT] = ACTIONS(5891),
    [anon_sym_PIPE] = ACTIONS(5891),
    [anon_sym_COMMA] = ACTIONS(5891),
    [anon_sym_DASH] = ACTIONS(5889),
    [anon_sym_EQ] = ACTIONS(5889),
    [anon_sym_void] = ACTIONS(5889),
    [anon_sym_break] = ACTIONS(5889),
    [anon_sym_const] = ACTIONS(5889),
    [sym_super] = ACTIONS(5889),
    [anon_sym_return] = ACTIONS(5889),
    [anon_sym_private] = ACTIONS(5889),
    [anon_sym_get] = ACTIONS(5889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5891),
    [anon_sym_RBRACE] = ACTIONS(5891),
    [anon_sym_interface] = ACTIONS(5889),
    [anon_sym_default] = ACTIONS(5889),
    [anon_sym_enum] = ACTIONS(5889),
    [anon_sym_delete] = ACTIONS(5889),
    [anon_sym_continue] = ACTIONS(5889),
    [anon_sym_DASH_DASH] = ACTIONS(5891),
    [anon_sym_if] = ACTIONS(5889),
    [anon_sym_this] = ACTIONS(5889),
    [anon_sym_yield] = ACTIONS(5889),
    [sym_true] = ACTIONS(5889),
    [anon_sym_throw] = ACTIONS(5889),
    [anon_sym_protected] = ACTIONS(5889),
    [anon_sym_abstract] = ACTIONS(5889),
    [anon_sym_DOT] = ACTIONS(4487),
    [anon_sym_set] = ACTIONS(5889),
    [anon_sym_type] = ACTIONS(5889),
    [anon_sym_import] = ACTIONS(5889),
    [anon_sym_namespace] = ACTIONS(5889),
    [anon_sym_PLUS_PLUS] = ACTIONS(5891),
    [anon_sym_await] = ACTIONS(5889),
    [anon_sym_DQUOTE] = ACTIONS(5891),
    [anon_sym_else] = ACTIONS(5889),
    [anon_sym_BANG] = ACTIONS(5891),
    [anon_sym_for] = ACTIONS(5889),
    [anon_sym_LBRACK] = ACTIONS(5891),
    [sym_false] = ACTIONS(5889),
    [anon_sym_SEMI] = ACTIONS(5891),
    [anon_sym_case] = ACTIONS(5889),
    [anon_sym_module] = ACTIONS(5889),
    [anon_sym_number] = ACTIONS(5889),
    [anon_sym_class] = ACTIONS(5889),
    [anon_sym_declare] = ACTIONS(5889),
    [anon_sym_typeof] = ACTIONS(5889),
    [anon_sym_LBRACE] = ACTIONS(5889),
    [anon_sym_switch] = ACTIONS(5889),
    [anon_sym_LPAREN] = ACTIONS(5891),
    [anon_sym_RBRACK] = ACTIONS(5891),
    [sym_null] = ACTIONS(5889),
    [anon_sym_GT] = ACTIONS(5891),
    [anon_sym_any] = ACTIONS(5889),
    [anon_sym_boolean] = ACTIONS(5889),
    [anon_sym_async] = ACTIONS(5889),
    [anon_sym_public] = ACTIONS(5889),
    [anon_sym_EQ_GT] = ACTIONS(5891),
    [anon_sym_AMP] = ACTIONS(5891),
    [anon_sym_var] = ACTIONS(5889),
    [anon_sym_while] = ACTIONS(5889),
    [anon_sym_SQUOTE] = ACTIONS(5891),
    [anon_sym_try] = ACTIONS(5889),
    [anon_sym_RPAREN] = ACTIONS(5891),
    [anon_sym_LT] = ACTIONS(5891),
    [sym_number] = ACTIONS(5891),
    [anon_sym_SLASH] = ACTIONS(5889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5889),
    [anon_sym_function] = ACTIONS(5889),
    [sym_undefined] = ACTIONS(5889),
    [anon_sym_new] = ACTIONS(5889),
    [ts_builtin_sym_end] = ACTIONS(5891),
    [anon_sym_let] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5889),
    [anon_sym_implements] = ACTIONS(5889),
    [anon_sym_export] = ACTIONS(5889),
    [anon_sym_do] = ACTIONS(5889),
    [anon_sym_TILDE] = ACTIONS(5891),
    [anon_sym_with] = ACTIONS(5889),
  },
  [1929] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1933),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1934),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4065),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4067),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1930] = {
    [sym_type_parameters] = STATE(2815),
    [sym_formal_parameters] = STATE(2816),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [1931] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1933),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1934),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4065),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4067),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1932] = {
    [anon_sym_GT] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(5895),
    [anon_sym_PIPE] = ACTIONS(5897),
    [anon_sym_COMMA] = ACTIONS(5893),
    [sym_comment] = ACTIONS(3),
  },
  [1933] = {
    [sym_formal_parameters] = STATE(2819),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1934] = {
    [anon_sym_EQ_GT] = ACTIONS(5899),
    [sym_comment] = ACTIONS(3),
  },
  [1935] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4787),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4787),
    [anon_sym_AMP_EQ] = ACTIONS(4787),
    [anon_sym_PLUS_EQ] = ACTIONS(4787),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4787),
    [anon_sym_STAR_EQ] = ACTIONS(4787),
    [anon_sym_PIPE_EQ] = ACTIONS(4787),
    [anon_sym_DASH_EQ] = ACTIONS(4787),
    [anon_sym_EQ_GT] = ACTIONS(4791),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4787),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5901),
    [anon_sym_SLASH_EQ] = ACTIONS(4787),
    [anon_sym_GT_GT_EQ] = ACTIONS(4787),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4787),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4795),
  },
  [1936] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_AMP_EQ] = ACTIONS(4797),
    [anon_sym_PLUS_EQ] = ACTIONS(4797),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4797),
    [anon_sym_STAR_EQ] = ACTIONS(4797),
    [anon_sym_PIPE_EQ] = ACTIONS(4797),
    [anon_sym_DASH_EQ] = ACTIONS(4797),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4797),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5903),
    [anon_sym_SLASH_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1937] = {
    [sym_new_expression] = STATE(2294),
    [sym_augmented_assignment_expression] = STATE(2294),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(2294),
    [sym_update_expression] = STATE(2294),
    [sym_regex] = STATE(2294),
    [sym_meta_property] = STATE(2294),
    [sym_call_signature] = STATE(1372),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2294),
    [sym_non_null_expression] = STATE(2294),
    [sym_yield_expression] = STATE(2294),
    [sym_jsx_fragment] = STATE(2294),
    [sym_jsx_element] = STATE(2294),
    [sym_as_expression] = STATE(2294),
    [sym_internal_module] = STATE(2294),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2294),
    [sym_await_expression] = STATE(2294),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(2294),
    [sym_this] = STATE(2294),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(2294),
    [sym_generator_function] = STATE(2294),
    [sym_call_expression] = STATE(2294),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(2294),
    [sym_ternary_expression] = STATE(2294),
    [sym_binary_expression] = STATE(2294),
    [sym_template_string] = STATE(2294),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2294),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2294),
    [sym_class] = STATE(2294),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2968),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4797),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_AMP_EQ] = ACTIONS(4797),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4797),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(4797),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_PIPE_EQ] = ACTIONS(4797),
    [anon_sym_DASH_EQ] = ACTIONS(4797),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4797),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(2839),
    [sym_true] = ACTIONS(4803),
    [anon_sym_COLON] = ACTIONS(5903),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4797),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(4803),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(135),
    [sym_null] = ACTIONS(4803),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_STAR_EQ] = ACTIONS(4797),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(4805),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4797),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4803),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1938] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_call_signature] = STATE(2296),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4811),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4797),
    [anon_sym_symbol] = ACTIONS(4813),
    [anon_sym_AMP_EQ] = ACTIONS(4797),
    [anon_sym_PLUS_EQ] = ACTIONS(4797),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_void] = ACTIONS(4813),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(4797),
    [anon_sym_private] = ACTIONS(4813),
    [anon_sym_PIPE_EQ] = ACTIONS(4797),
    [anon_sym_DASH_EQ] = ACTIONS(4797),
    [anon_sym_get] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4797),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(5903),
    [anon_sym_protected] = ACTIONS(4813),
    [anon_sym_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(4813),
    [anon_sym_type] = ACTIONS(4813),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(4813),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4797),
    [anon_sym_namespace] = ACTIONS(4813),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(4813),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_number] = ACTIONS(4813),
    [anon_sym_declare] = ACTIONS(4813),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(4813),
    [anon_sym_STAR_EQ] = ACTIONS(4797),
    [anon_sym_boolean] = ACTIONS(4813),
    [anon_sym_async] = ACTIONS(4813),
    [anon_sym_public] = ACTIONS(4813),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4797),
    [anon_sym_string] = ACTIONS(4813),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(4813),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1939] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_AMP_EQ] = ACTIONS(4797),
    [anon_sym_PLUS_EQ] = ACTIONS(4797),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(4797),
    [anon_sym_STAR_EQ] = ACTIONS(4797),
    [anon_sym_PIPE_EQ] = ACTIONS(4797),
    [anon_sym_DASH_EQ] = ACTIONS(4797),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4797),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5903),
    [anon_sym_SLASH_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [1940] = {
    [aux_sym_object_type_repeat1] = STATE(2825),
    [sym__automatic_semicolon] = ACTIONS(5905),
    [anon_sym_RBRACE] = ACTIONS(5907),
    [anon_sym_SEMI] = ACTIONS(5905),
    [anon_sym_COMMA] = ACTIONS(5905),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5907),
    [sym_comment] = ACTIONS(3),
  },
  [1941] = {
    [sym_type_parameters] = STATE(1082),
    [sym_formal_parameters] = STATE(1081),
    [sym_call_signature] = STATE(2827),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(5909),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [1942] = {
    [sym_string] = STATE(2828),
    [sym__property_name] = STATE(2828),
    [sym_computed_property_name] = STATE(2828),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(5911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [1943] = {
    [sym_string] = STATE(2832),
    [sym__property_name] = STATE(2832),
    [sym_computed_property_name] = STATE(2832),
    [anon_sym_get] = ACTIONS(5913),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(5913),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_async] = ACTIONS(5919),
  },
  [1944] = {
    [sym_string] = STATE(2828),
    [sym__property_name] = STATE(2828),
    [sym_computed_property_name] = STATE(2828),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(5911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [1945] = {
    [sym_string] = STATE(2828),
    [sym__property_name] = STATE(2828),
    [sym_computed_property_name] = STATE(2828),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(5921),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(5911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(5921),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [1946] = {
    [sym_type_parameters] = STATE(1082),
    [sym_type_annotation] = STATE(2835),
    [sym_formal_parameters] = STATE(1081),
    [sym_call_signature] = STATE(2827),
    [sym__automatic_semicolon] = ACTIONS(5923),
    [anon_sym_RBRACE] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(5923),
    [anon_sym_QMARK] = ACTIONS(5925),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(5923),
    [sym_comment] = ACTIONS(3),
  },
  [1947] = {
    [sym_string] = STATE(2828),
    [sym__property_name] = STATE(2828),
    [sym_computed_property_name] = STATE(2828),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(5911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [1948] = {
    [sym_formal_parameters] = STATE(2836),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [1949] = {
    [sym_type_annotation] = STATE(2837),
    [sym__automatic_semicolon] = ACTIONS(5927),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5927),
    [sym_comment] = ACTIONS(3),
  },
  [1950] = {
    [sym_variable_declarator] = STATE(2838),
    [sym_array] = STATE(98),
    [sym_object] = STATE(99),
    [sym_identifier] = ACTIONS(454),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [1951] = {
    [sym_identifier] = ACTIONS(5929),
    [sym_comment] = ACTIONS(3),
  },
  [1952] = {
    [sym_new_expression] = STATE(2840),
    [sym_augmented_assignment_expression] = STATE(2840),
    [sym_unary_expression] = STATE(2840),
    [sym_update_expression] = STATE(2840),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(2840),
    [sym_regex] = STATE(2840),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2840),
    [sym_non_null_expression] = STATE(2840),
    [sym_as_expression] = STATE(2840),
    [sym_jsx_fragment] = STATE(2840),
    [sym_yield_expression] = STATE(2840),
    [sym_jsx_element] = STATE(2840),
    [sym_internal_module] = STATE(2840),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2840),
    [sym_await_expression] = STATE(2840),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(2840),
    [sym_this] = STATE(2840),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(2840),
    [sym_generator_function] = STATE(2840),
    [sym_call_expression] = STATE(2840),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(2840),
    [sym_ternary_expression] = STATE(2840),
    [sym_binary_expression] = STATE(2840),
    [sym_template_string] = STATE(2840),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2840),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2840),
    [sym_class] = STATE(2840),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(5931),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5931),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5933),
    [sym_true] = ACTIONS(5931),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(5931),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [1953] = {
    [sym_identifier] = ACTIONS(5935),
    [sym_comment] = ACTIONS(3),
  },
  [1954] = {
    [sym_string] = STATE(129),
    [sym_nested_identifier] = STATE(127),
    [sym__module] = STATE(2842),
    [sym_identifier] = ACTIONS(5937),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(87),
  },
  [1955] = {
    [anon_sym_namespace] = ACTIONS(5939),
    [sym_comment] = ACTIONS(3),
  },
  [1956] = {
    [sym_identifier] = ACTIONS(5941),
    [sym_comment] = ACTIONS(3),
  },
  [1957] = {
    [sym_type_alias_declaration] = STATE(2846),
    [aux_sym_export_statement_repeat1] = STATE(1969),
    [sym__declaration] = STATE(2846),
    [sym_ambient_declaration] = STATE(2846),
    [sym_import_alias] = STATE(2846),
    [sym_export_statement] = STATE(2846),
    [sym_generator_function] = STATE(2846),
    [sym_lexical_declaration] = STATE(2846),
    [sym_internal_module] = STATE(2846),
    [sym_decorator] = STATE(1969),
    [sym_enum_declaration] = STATE(2846),
    [sym_function] = STATE(2846),
    [sym_function_signature] = STATE(2846),
    [sym_variable_declaration] = STATE(2846),
    [sym_abstract_class] = STATE(2846),
    [sym_module] = STATE(2846),
    [sym_interface_declaration] = STATE(2846),
    [sym_class] = STATE(2846),
    [anon_sym_var] = ACTIONS(4121),
    [anon_sym_interface] = ACTIONS(4123),
    [anon_sym_enum] = ACTIONS(4127),
    [anon_sym_module] = ACTIONS(5943),
    [anon_sym_class] = ACTIONS(4109),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4111),
    [anon_sym_global] = ACTIONS(5945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(4131),
    [anon_sym_const] = ACTIONS(4117),
    [anon_sym_abstract] = ACTIONS(4133),
    [anon_sym_type] = ACTIONS(4135),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_import] = ACTIONS(4139),
    [anon_sym_export] = ACTIONS(4141),
    [anon_sym_namespace] = ACTIONS(4143),
    [anon_sym_async] = ACTIONS(4119),
  },
  [1958] = {
    [sym__from_clause] = STATE(2847),
    [anon_sym_from] = ACTIONS(901),
    [sym_comment] = ACTIONS(3),
  },
  [1959] = {
    [sym_identifier] = ACTIONS(5947),
    [sym_comment] = ACTIONS(3),
  },
  [1960] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(275),
    [sym_identifier] = ACTIONS(5949),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(474),
    [anon_sym_STAR] = ACTIONS(476),
    [sym_comment] = ACTIONS(3),
  },
  [1961] = {
    [sym_variable_declarator] = STATE(2850),
    [sym_array] = STATE(98),
    [sym_object] = STATE(99),
    [sym_identifier] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_enum] = ACTIONS(5951),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [1962] = {
    [anon_sym_class] = ACTIONS(5953),
    [sym_comment] = ACTIONS(3),
  },
  [1963] = {
    [sym_identifier] = ACTIONS(5955),
    [sym_comment] = ACTIONS(3),
  },
  [1964] = {
    [sym_variable_declarator] = STATE(2850),
    [sym_array] = STATE(98),
    [sym_object] = STATE(99),
    [sym_identifier] = ACTIONS(454),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [1965] = {
    [sym_identifier] = ACTIONS(5957),
    [sym_comment] = ACTIONS(3),
  },
  [1966] = {
    [sym_type_alias_declaration] = STATE(1970),
    [aux_sym_export_statement_repeat1] = STATE(1969),
    [sym__declaration] = STATE(1970),
    [sym_ambient_declaration] = STATE(1970),
    [sym_import_alias] = STATE(1970),
    [sym_export_statement] = STATE(1970),
    [sym_generator_function] = STATE(1970),
    [sym_export_clause] = STATE(1971),
    [sym_lexical_declaration] = STATE(1970),
    [sym_internal_module] = STATE(1970),
    [sym_decorator] = STATE(1969),
    [sym_enum_declaration] = STATE(1970),
    [sym_function] = STATE(1970),
    [sym_function_signature] = STATE(1970),
    [sym_variable_declaration] = STATE(1970),
    [sym_abstract_class] = STATE(1970),
    [sym_module] = STATE(1970),
    [sym_interface_declaration] = STATE(1970),
    [sym_class] = STATE(1970),
    [anon_sym_var] = ACTIONS(4121),
    [anon_sym_default] = ACTIONS(4125),
    [anon_sym_interface] = ACTIONS(4123),
    [anon_sym_enum] = ACTIONS(4127),
    [anon_sym_module] = ACTIONS(4107),
    [anon_sym_as] = ACTIONS(4129),
    [anon_sym_class] = ACTIONS(4109),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4111),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_EQ] = ACTIONS(4115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(4131),
    [anon_sym_const] = ACTIONS(4117),
    [anon_sym_abstract] = ACTIONS(4133),
    [anon_sym_type] = ACTIONS(4135),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_import] = ACTIONS(4139),
    [anon_sym_export] = ACTIONS(4141),
    [anon_sym_namespace] = ACTIONS(4143),
    [anon_sym_async] = ACTIONS(4119),
  },
  [1967] = {
    [sym_string] = STATE(129),
    [sym_nested_identifier] = STATE(127),
    [sym__module] = STATE(128),
    [sym_identifier] = ACTIONS(5937),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(87),
  },
  [1968] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(5959),
  },
  [1969] = {
    [aux_sym_export_statement_repeat1] = STATE(320),
    [sym_decorator] = STATE(320),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(4145),
    [anon_sym_class] = ACTIONS(5961),
    [sym_comment] = ACTIONS(3),
  },
  [1970] = {
    [sym__automatic_semicolon] = ACTIONS(1635),
    [anon_sym_RBRACE] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym_COMMA] = ACTIONS(1635),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1635),
    [sym_comment] = ACTIONS(3),
  },
  [1971] = {
    [sym__from_clause] = STATE(2847),
    [sym__automatic_semicolon] = ACTIONS(5963),
    [anon_sym_SEMI] = ACTIONS(5963),
    [anon_sym_from] = ACTIONS(901),
    [sym_comment] = ACTIONS(3),
  },
  [1972] = {
    [sym_type_alias_declaration] = STATE(2856),
    [aux_sym_export_statement_repeat1] = STATE(1969),
    [sym__declaration] = STATE(2856),
    [sym_ambient_declaration] = STATE(2856),
    [sym_import_alias] = STATE(2856),
    [sym_export_statement] = STATE(2856),
    [sym_generator_function] = STATE(2856),
    [sym_lexical_declaration] = STATE(2856),
    [sym_internal_module] = STATE(2856),
    [sym_decorator] = STATE(1969),
    [sym_enum_declaration] = STATE(2856),
    [sym_function] = STATE(2856),
    [sym_function_signature] = STATE(2856),
    [sym_variable_declaration] = STATE(2856),
    [sym_abstract_class] = STATE(2856),
    [sym_module] = STATE(2856),
    [sym_interface_declaration] = STATE(2856),
    [sym_class] = STATE(2856),
    [anon_sym_var] = ACTIONS(4121),
    [anon_sym_default] = ACTIONS(5965),
    [anon_sym_interface] = ACTIONS(4123),
    [anon_sym_enum] = ACTIONS(4127),
    [anon_sym_module] = ACTIONS(4107),
    [anon_sym_class] = ACTIONS(4109),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(4131),
    [anon_sym_const] = ACTIONS(4117),
    [anon_sym_abstract] = ACTIONS(4133),
    [anon_sym_type] = ACTIONS(4135),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_import] = ACTIONS(4139),
    [anon_sym_export] = ACTIONS(4141),
    [anon_sym_namespace] = ACTIONS(4143),
    [anon_sym_async] = ACTIONS(4119),
  },
  [1973] = {
    [aux_sym_export_statement_repeat1] = STATE(1973),
    [sym_decorator] = STATE(1973),
    [anon_sym_export] = ACTIONS(1830),
    [anon_sym_AT] = ACTIONS(1832),
    [sym_comment] = ACTIONS(3),
  },
  [1974] = {
    [sym_union_type] = STATE(2863),
    [sym__type] = STATE(2863),
    [sym_constructor_type] = STATE(2863),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2864),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2863),
    [sym_function_type] = STATE(2863),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2865),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5967),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5971),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5973),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [1975] = {
    [sym_type_parameters] = STATE(1082),
    [sym_type_annotation] = STATE(2835),
    [sym_formal_parameters] = STATE(1081),
    [sym_call_signature] = STATE(2827),
    [sym__automatic_semicolon] = ACTIONS(5923),
    [anon_sym_RBRACE] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(5923),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(5923),
    [sym_comment] = ACTIONS(3),
  },
  [1976] = {
    [sym__automatic_semicolon] = ACTIONS(5923),
    [anon_sym_RBRACE] = ACTIONS(5923),
    [anon_sym_SEMI] = ACTIONS(5923),
    [anon_sym_COMMA] = ACTIONS(5923),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5923),
    [sym_comment] = ACTIONS(3),
  },
  [1977] = {
    [sym__automatic_semicolon] = ACTIONS(4897),
    [anon_sym_RBRACE] = ACTIONS(4897),
    [anon_sym_SEMI] = ACTIONS(4897),
    [anon_sym_COMMA] = ACTIONS(4897),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4897),
    [sym_comment] = ACTIONS(3),
  },
  [1978] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(2866),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(2866),
    [sym_call_signature] = STATE(2866),
    [sym_export_statement] = STATE(2866),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(2866),
    [sym_index_signature] = STATE(2866),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_RBRACE] = ACTIONS(5907),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5907),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [1979] = {
    [sym_identifier] = ACTIONS(5977),
    [anon_sym_BQUOTE] = ACTIONS(5979),
    [anon_sym_debugger] = ACTIONS(5977),
    [anon_sym_symbol] = ACTIONS(5977),
    [anon_sym_AT] = ACTIONS(5979),
    [anon_sym_PIPE] = ACTIONS(5979),
    [anon_sym_COMMA] = ACTIONS(5979),
    [anon_sym_DASH] = ACTIONS(5977),
    [anon_sym_EQ] = ACTIONS(5977),
    [anon_sym_void] = ACTIONS(5977),
    [anon_sym_break] = ACTIONS(5977),
    [anon_sym_const] = ACTIONS(5977),
    [sym_super] = ACTIONS(5977),
    [anon_sym_return] = ACTIONS(5977),
    [anon_sym_private] = ACTIONS(5977),
    [anon_sym_get] = ACTIONS(5977),
    [anon_sym_RBRACE] = ACTIONS(5979),
    [anon_sym_interface] = ACTIONS(5977),
    [anon_sym_default] = ACTIONS(5977),
    [anon_sym_enum] = ACTIONS(5977),
    [anon_sym_delete] = ACTIONS(5977),
    [anon_sym_continue] = ACTIONS(5977),
    [anon_sym_DASH_DASH] = ACTIONS(5979),
    [anon_sym_if] = ACTIONS(5977),
    [anon_sym_this] = ACTIONS(5977),
    [anon_sym_yield] = ACTIONS(5977),
    [sym_true] = ACTIONS(5977),
    [anon_sym_throw] = ACTIONS(5977),
    [anon_sym_protected] = ACTIONS(5977),
    [anon_sym_abstract] = ACTIONS(5977),
    [anon_sym_set] = ACTIONS(5977),
    [anon_sym_type] = ACTIONS(5977),
    [anon_sym_import] = ACTIONS(5977),
    [anon_sym_namespace] = ACTIONS(5977),
    [anon_sym_PLUS_PLUS] = ACTIONS(5979),
    [anon_sym_await] = ACTIONS(5977),
    [anon_sym_DQUOTE] = ACTIONS(5979),
    [anon_sym_else] = ACTIONS(5977),
    [anon_sym_BANG] = ACTIONS(5979),
    [anon_sym_for] = ACTIONS(5977),
    [anon_sym_LBRACK] = ACTIONS(5979),
    [sym_false] = ACTIONS(5977),
    [anon_sym_SEMI] = ACTIONS(5979),
    [anon_sym_case] = ACTIONS(5977),
    [anon_sym_module] = ACTIONS(5977),
    [anon_sym_number] = ACTIONS(5977),
    [anon_sym_class] = ACTIONS(5977),
    [anon_sym_declare] = ACTIONS(5977),
    [anon_sym_typeof] = ACTIONS(5977),
    [anon_sym_LBRACE] = ACTIONS(5979),
    [anon_sym_switch] = ACTIONS(5977),
    [anon_sym_LPAREN] = ACTIONS(5979),
    [anon_sym_RBRACK] = ACTIONS(5979),
    [sym_null] = ACTIONS(5977),
    [anon_sym_GT] = ACTIONS(5979),
    [anon_sym_any] = ACTIONS(5977),
    [anon_sym_boolean] = ACTIONS(5977),
    [anon_sym_async] = ACTIONS(5977),
    [anon_sym_public] = ACTIONS(5977),
    [anon_sym_EQ_GT] = ACTIONS(5979),
    [anon_sym_AMP] = ACTIONS(5979),
    [anon_sym_var] = ACTIONS(5977),
    [anon_sym_while] = ACTIONS(5977),
    [anon_sym_SQUOTE] = ACTIONS(5979),
    [anon_sym_try] = ACTIONS(5977),
    [anon_sym_RPAREN] = ACTIONS(5979),
    [anon_sym_LT] = ACTIONS(5979),
    [sym_number] = ACTIONS(5979),
    [anon_sym_SLASH] = ACTIONS(5977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5977),
    [anon_sym_function] = ACTIONS(5977),
    [sym_undefined] = ACTIONS(5977),
    [anon_sym_new] = ACTIONS(5977),
    [ts_builtin_sym_end] = ACTIONS(5979),
    [anon_sym_let] = ACTIONS(5977),
    [anon_sym_PLUS] = ACTIONS(5977),
    [anon_sym_export] = ACTIONS(5977),
    [anon_sym_do] = ACTIONS(5977),
    [anon_sym_TILDE] = ACTIONS(5979),
    [anon_sym_with] = ACTIONS(5977),
  },
  [1980] = {
    [aux_sym_object_type_repeat1] = STATE(2867),
    [sym__automatic_semicolon] = ACTIONS(5905),
    [anon_sym_RBRACE] = ACTIONS(5907),
    [anon_sym_SEMI] = ACTIONS(5905),
    [anon_sym_COMMA] = ACTIONS(5905),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5907),
    [sym_comment] = ACTIONS(3),
  },
  [1981] = {
    [sym_string] = STATE(2832),
    [sym__property_name] = STATE(2832),
    [sym_computed_property_name] = STATE(2832),
    [anon_sym_get] = ACTIONS(5913),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_async] = ACTIONS(5919),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5917),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(5913),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(5981),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [1982] = {
    [sym_type_annotation] = STATE(2523),
    [sym__automatic_semicolon] = ACTIONS(1669),
    [anon_sym_RBRACE] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(1669),
    [anon_sym_COMMA] = ACTIONS(1669),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
  },
  [1983] = {
    [sym_union_type] = STATE(2872),
    [sym__type] = STATE(2872),
    [sym_constructor_type] = STATE(2872),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2873),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2872),
    [sym_function_type] = STATE(2872),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2874),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5983),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5985),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1984] = {
    [sym_formal_parameters] = STATE(2875),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [1985] = {
    [anon_sym_EQ_GT] = ACTIONS(5989),
    [sym_comment] = ACTIONS(3),
  },
  [1986] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1089),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1090),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1987] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1089),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1090),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1988] = {
    [sym_union_type] = STATE(2877),
    [sym__type] = STATE(2877),
    [sym_constructor_type] = STATE(2877),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1089),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2877),
    [sym_function_type] = STATE(2877),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1090),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1989] = {
    [sym_identifier] = ACTIONS(5991),
    [anon_sym_BQUOTE] = ACTIONS(5993),
    [anon_sym_debugger] = ACTIONS(5991),
    [anon_sym_symbol] = ACTIONS(5991),
    [anon_sym_AT] = ACTIONS(5993),
    [anon_sym_PIPE] = ACTIONS(5993),
    [anon_sym_COMMA] = ACTIONS(5993),
    [anon_sym_DASH] = ACTIONS(5991),
    [anon_sym_EQ] = ACTIONS(5991),
    [anon_sym_void] = ACTIONS(5991),
    [anon_sym_break] = ACTIONS(5991),
    [anon_sym_const] = ACTIONS(5991),
    [sym_super] = ACTIONS(5991),
    [anon_sym_return] = ACTIONS(5991),
    [anon_sym_private] = ACTIONS(5991),
    [anon_sym_get] = ACTIONS(5991),
    [anon_sym_RBRACE] = ACTIONS(5993),
    [anon_sym_interface] = ACTIONS(5991),
    [anon_sym_default] = ACTIONS(5991),
    [anon_sym_enum] = ACTIONS(5991),
    [anon_sym_delete] = ACTIONS(5991),
    [anon_sym_continue] = ACTIONS(5991),
    [anon_sym_DASH_DASH] = ACTIONS(5993),
    [anon_sym_if] = ACTIONS(5991),
    [anon_sym_this] = ACTIONS(5991),
    [anon_sym_yield] = ACTIONS(5991),
    [sym_true] = ACTIONS(5991),
    [anon_sym_throw] = ACTIONS(5991),
    [anon_sym_protected] = ACTIONS(5991),
    [anon_sym_abstract] = ACTIONS(5991),
    [anon_sym_set] = ACTIONS(5991),
    [anon_sym_type] = ACTIONS(5991),
    [anon_sym_import] = ACTIONS(5991),
    [anon_sym_namespace] = ACTIONS(5991),
    [anon_sym_PLUS_PLUS] = ACTIONS(5993),
    [anon_sym_await] = ACTIONS(5991),
    [anon_sym_DQUOTE] = ACTIONS(5993),
    [anon_sym_else] = ACTIONS(5991),
    [anon_sym_BANG] = ACTIONS(5993),
    [anon_sym_for] = ACTIONS(5991),
    [anon_sym_LBRACK] = ACTIONS(5993),
    [sym_false] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(5993),
    [anon_sym_case] = ACTIONS(5991),
    [anon_sym_module] = ACTIONS(5991),
    [anon_sym_number] = ACTIONS(5991),
    [anon_sym_class] = ACTIONS(5991),
    [anon_sym_declare] = ACTIONS(5991),
    [anon_sym_typeof] = ACTIONS(5991),
    [anon_sym_LBRACE] = ACTIONS(5993),
    [anon_sym_switch] = ACTIONS(5991),
    [anon_sym_LPAREN] = ACTIONS(5993),
    [anon_sym_RBRACK] = ACTIONS(5993),
    [sym_null] = ACTIONS(5991),
    [anon_sym_GT] = ACTIONS(5993),
    [anon_sym_any] = ACTIONS(5991),
    [anon_sym_boolean] = ACTIONS(5991),
    [anon_sym_async] = ACTIONS(5991),
    [anon_sym_public] = ACTIONS(5991),
    [anon_sym_EQ_GT] = ACTIONS(5993),
    [anon_sym_AMP] = ACTIONS(5993),
    [anon_sym_var] = ACTIONS(5991),
    [anon_sym_while] = ACTIONS(5991),
    [anon_sym_SQUOTE] = ACTIONS(5993),
    [anon_sym_try] = ACTIONS(5991),
    [anon_sym_RPAREN] = ACTIONS(5993),
    [anon_sym_LT] = ACTIONS(5993),
    [sym_number] = ACTIONS(5993),
    [anon_sym_SLASH] = ACTIONS(5991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5991),
    [anon_sym_function] = ACTIONS(5991),
    [sym_undefined] = ACTIONS(5991),
    [anon_sym_new] = ACTIONS(5991),
    [ts_builtin_sym_end] = ACTIONS(5993),
    [anon_sym_let] = ACTIONS(5991),
    [anon_sym_PLUS] = ACTIONS(5991),
    [anon_sym_export] = ACTIONS(5991),
    [anon_sym_do] = ACTIONS(5991),
    [anon_sym_TILDE] = ACTIONS(5993),
    [anon_sym_with] = ACTIONS(5991),
  },
  [1990] = {
    [aux_sym_implements_clause_repeat1] = STATE(2879),
    [anon_sym_COMMA] = ACTIONS(4165),
    [anon_sym_RBRACK] = ACTIONS(5995),
    [sym_comment] = ACTIONS(3),
  },
  [1991] = {
    [anon_sym_EQ_GT] = ACTIONS(5997),
    [sym_comment] = ACTIONS(3),
  },
  [1992] = {
    [sym_union_type] = STATE(2881),
    [sym__type] = STATE(2881),
    [sym_constructor_type] = STATE(2881),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1089),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2881),
    [sym_function_type] = STATE(2881),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1090),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1993] = {
    [anon_sym_EQ_GT] = ACTIONS(5999),
    [sym_comment] = ACTIONS(3),
  },
  [1994] = {
    [sym_union_type] = STATE(2883),
    [sym__type] = STATE(2883),
    [sym_constructor_type] = STATE(2883),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2883),
    [sym_function_type] = STATE(2883),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1995] = {
    [sym_union_type] = STATE(2887),
    [sym__type] = STATE(2887),
    [sym_constructor_type] = STATE(2887),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2888),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2887),
    [sym_function_type] = STATE(2887),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2889),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6001),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6003),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6005),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [1996] = {
    [sym__initializer] = STATE(1010),
    [aux_sym_object_repeat1] = STATE(1042),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_EQ] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(362),
    [sym_comment] = ACTIONS(3),
  },
  [1997] = {
    [aux_sym_object_repeat1] = STATE(1042),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(362),
    [sym_comment] = ACTIONS(3),
  },
  [1998] = {
    [aux_sym_object_repeat1] = STATE(1042),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1238),
    [sym_identifier] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1236),
    [anon_sym_symbol] = ACTIONS(1236),
    [anon_sym_number] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1236),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_STAR] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1236),
    [anon_sym_private] = ACTIONS(1236),
    [anon_sym_boolean] = ACTIONS(1236),
    [anon_sym_async] = ACTIONS(1236),
    [anon_sym_public] = ACTIONS(1236),
    [anon_sym_get] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_static] = ACTIONS(1236),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(1238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1236),
    [anon_sym_string] = ACTIONS(1236),
    [anon_sym_set] = ACTIONS(1236),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1236),
    [anon_sym_import] = ACTIONS(1236),
    [anon_sym_export] = ACTIONS(1236),
    [anon_sym_namespace] = ACTIONS(1236),
    [sym_readonly] = ACTIONS(1236),
    [anon_sym_DQUOTE] = ACTIONS(1238),
  },
  [1999] = {
    [sym__property_name] = STATE(2705),
    [sym_string] = STATE(2705),
    [aux_sym_object_repeat1] = STATE(1042),
    [sym_computed_property_name] = STATE(2705),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_STAR] = ACTIONS(5695),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(5697),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(5693),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(5697),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [2000] = {
    [sym__property_name] = STATE(2705),
    [sym_string] = STATE(2705),
    [aux_sym_object_repeat1] = STATE(1042),
    [sym_computed_property_name] = STATE(2705),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(5693),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [2001] = {
    [anon_sym_EQ] = ACTIONS(1251),
    [anon_sym_COLON] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_QMARK] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_RPAREN] = ACTIONS(1251),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_COMMA] = ACTIONS(1251),
    [sym_comment] = ACTIONS(3),
  },
  [2002] = {
    [sym_type_alias_declaration] = STATE(1970),
    [aux_sym_export_statement_repeat1] = STATE(1969),
    [sym__declaration] = STATE(1970),
    [sym_ambient_declaration] = STATE(1970),
    [sym_import_alias] = STATE(1970),
    [sym_export_statement] = STATE(1970),
    [sym_generator_function] = STATE(1970),
    [sym_export_clause] = STATE(1971),
    [aux_sym_object_repeat1] = STATE(1042),
    [sym_lexical_declaration] = STATE(1970),
    [sym_internal_module] = STATE(1970),
    [sym_decorator] = STATE(1969),
    [sym_enum_declaration] = STATE(1970),
    [sym_function] = STATE(1970),
    [sym_function_signature] = STATE(1970),
    [sym_variable_declaration] = STATE(1970),
    [sym_abstract_class] = STATE(1970),
    [sym_module] = STATE(1970),
    [sym_interface_declaration] = STATE(1970),
    [sym_class] = STATE(1970),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(4107),
    [anon_sym_class] = ACTIONS(4109),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_EQ] = ACTIONS(4115),
    [anon_sym_const] = ACTIONS(4117),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(4119),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_var] = ACTIONS(4121),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_interface] = ACTIONS(4123),
    [anon_sym_default] = ACTIONS(4125),
    [anon_sym_enum] = ACTIONS(4127),
    [anon_sym_as] = ACTIONS(4129),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_function] = ACTIONS(4131),
    [anon_sym_abstract] = ACTIONS(4133),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(4135),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_import] = ACTIONS(4139),
    [anon_sym_export] = ACTIONS(4141),
    [anon_sym_namespace] = ACTIONS(4143),
  },
  [2003] = {
    [aux_sym_export_statement_repeat1] = STATE(1012),
    [sym__property_name] = STATE(707),
    [sym_decorator] = STATE(1012),
    [sym_string] = STATE(707),
    [sym_accessibility_modifier] = STATE(221),
    [sym_method_definition] = STATE(1043),
    [sym_computed_property_name] = STATE(707),
    [anon_sym_get] = ACTIONS(1320),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1318),
    [anon_sym_static] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [sym_number] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(364),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1316),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1320),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(5707),
    [sym_readonly] = ACTIONS(384),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1316),
    [anon_sym_public] = ACTIONS(1316),
  },
  [2004] = {
    [sym_formal_parameters] = STATE(2890),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2005] = {
    [anon_sym_EQ_GT] = ACTIONS(6007),
    [sym_comment] = ACTIONS(3),
  },
  [2006] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1108),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1109),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2282),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2007] = {
    [sym_identifier] = ACTIONS(6009),
    [anon_sym_BQUOTE] = ACTIONS(6011),
    [anon_sym_debugger] = ACTIONS(6009),
    [anon_sym_symbol] = ACTIONS(6009),
    [anon_sym_AT] = ACTIONS(6011),
    [anon_sym_PIPE] = ACTIONS(6011),
    [anon_sym_COMMA] = ACTIONS(6011),
    [anon_sym_DASH] = ACTIONS(6009),
    [anon_sym_EQ] = ACTIONS(6009),
    [anon_sym_void] = ACTIONS(6009),
    [anon_sym_break] = ACTIONS(6009),
    [anon_sym_const] = ACTIONS(6009),
    [sym_super] = ACTIONS(6009),
    [anon_sym_return] = ACTIONS(6009),
    [anon_sym_private] = ACTIONS(6009),
    [anon_sym_get] = ACTIONS(6009),
    [anon_sym_RBRACE] = ACTIONS(6011),
    [anon_sym_interface] = ACTIONS(6009),
    [anon_sym_default] = ACTIONS(6009),
    [anon_sym_enum] = ACTIONS(6009),
    [anon_sym_delete] = ACTIONS(6009),
    [anon_sym_continue] = ACTIONS(6009),
    [anon_sym_DASH_DASH] = ACTIONS(6011),
    [anon_sym_if] = ACTIONS(6009),
    [anon_sym_this] = ACTIONS(6009),
    [anon_sym_yield] = ACTIONS(6009),
    [sym_true] = ACTIONS(6009),
    [anon_sym_throw] = ACTIONS(6009),
    [anon_sym_protected] = ACTIONS(6009),
    [anon_sym_abstract] = ACTIONS(6009),
    [anon_sym_set] = ACTIONS(6009),
    [anon_sym_type] = ACTIONS(6009),
    [anon_sym_import] = ACTIONS(6009),
    [anon_sym_namespace] = ACTIONS(6009),
    [anon_sym_PLUS_PLUS] = ACTIONS(6011),
    [anon_sym_await] = ACTIONS(6009),
    [anon_sym_DQUOTE] = ACTIONS(6011),
    [anon_sym_else] = ACTIONS(6009),
    [anon_sym_BANG] = ACTIONS(6011),
    [anon_sym_for] = ACTIONS(6009),
    [anon_sym_LBRACK] = ACTIONS(6011),
    [sym_false] = ACTIONS(6009),
    [anon_sym_SEMI] = ACTIONS(6011),
    [anon_sym_case] = ACTIONS(6009),
    [anon_sym_module] = ACTIONS(6009),
    [anon_sym_number] = ACTIONS(6009),
    [anon_sym_class] = ACTIONS(6009),
    [anon_sym_declare] = ACTIONS(6009),
    [anon_sym_typeof] = ACTIONS(6009),
    [anon_sym_LBRACE] = ACTIONS(6011),
    [anon_sym_switch] = ACTIONS(6009),
    [anon_sym_LPAREN] = ACTIONS(6011),
    [anon_sym_RBRACK] = ACTIONS(6011),
    [sym_null] = ACTIONS(6009),
    [anon_sym_GT] = ACTIONS(6011),
    [anon_sym_any] = ACTIONS(6009),
    [anon_sym_boolean] = ACTIONS(6009),
    [anon_sym_async] = ACTIONS(6009),
    [anon_sym_public] = ACTIONS(6009),
    [anon_sym_EQ_GT] = ACTIONS(6011),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_var] = ACTIONS(6009),
    [anon_sym_while] = ACTIONS(6009),
    [anon_sym_SQUOTE] = ACTIONS(6011),
    [anon_sym_try] = ACTIONS(6009),
    [anon_sym_RPAREN] = ACTIONS(6011),
    [anon_sym_LT] = ACTIONS(6011),
    [sym_number] = ACTIONS(6011),
    [anon_sym_SLASH] = ACTIONS(6009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6009),
    [anon_sym_function] = ACTIONS(6009),
    [sym_undefined] = ACTIONS(6009),
    [anon_sym_new] = ACTIONS(6009),
    [ts_builtin_sym_end] = ACTIONS(6011),
    [anon_sym_let] = ACTIONS(6009),
    [anon_sym_PLUS] = ACTIONS(6009),
    [anon_sym_export] = ACTIONS(6009),
    [anon_sym_do] = ACTIONS(6009),
    [anon_sym_TILDE] = ACTIONS(6011),
    [anon_sym_with] = ACTIONS(6009),
  },
  [2008] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1108),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1109),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2282),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2009] = {
    [anon_sym_EQ_GT] = ACTIONS(6013),
    [sym_comment] = ACTIONS(3),
  },
  [2010] = {
    [sym_union_type] = STATE(2893),
    [sym__type] = STATE(2893),
    [sym_constructor_type] = STATE(2893),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1108),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2893),
    [sym_function_type] = STATE(2893),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1109),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2282),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2011] = {
    [sym_identifier] = ACTIONS(6015),
    [anon_sym_BQUOTE] = ACTIONS(6017),
    [anon_sym_debugger] = ACTIONS(6015),
    [anon_sym_symbol] = ACTIONS(6015),
    [anon_sym_AT] = ACTIONS(6017),
    [anon_sym_PIPE] = ACTIONS(6017),
    [anon_sym_COMMA] = ACTIONS(6017),
    [anon_sym_DASH] = ACTIONS(6015),
    [anon_sym_EQ] = ACTIONS(6015),
    [anon_sym_void] = ACTIONS(6015),
    [anon_sym_break] = ACTIONS(6015),
    [anon_sym_const] = ACTIONS(6015),
    [sym_super] = ACTIONS(6015),
    [anon_sym_return] = ACTIONS(6015),
    [anon_sym_private] = ACTIONS(6015),
    [anon_sym_get] = ACTIONS(6015),
    [anon_sym_RBRACE] = ACTIONS(6017),
    [anon_sym_interface] = ACTIONS(6015),
    [anon_sym_default] = ACTIONS(6015),
    [anon_sym_enum] = ACTIONS(6015),
    [anon_sym_delete] = ACTIONS(6015),
    [anon_sym_continue] = ACTIONS(6015),
    [anon_sym_DASH_DASH] = ACTIONS(6017),
    [anon_sym_if] = ACTIONS(6015),
    [anon_sym_this] = ACTIONS(6015),
    [anon_sym_yield] = ACTIONS(6015),
    [sym_true] = ACTIONS(6015),
    [anon_sym_throw] = ACTIONS(6015),
    [anon_sym_protected] = ACTIONS(6015),
    [anon_sym_abstract] = ACTIONS(6015),
    [anon_sym_set] = ACTIONS(6015),
    [anon_sym_type] = ACTIONS(6015),
    [anon_sym_import] = ACTIONS(6015),
    [anon_sym_namespace] = ACTIONS(6015),
    [anon_sym_PLUS_PLUS] = ACTIONS(6017),
    [anon_sym_await] = ACTIONS(6015),
    [anon_sym_DQUOTE] = ACTIONS(6017),
    [anon_sym_else] = ACTIONS(6015),
    [anon_sym_BANG] = ACTIONS(6017),
    [anon_sym_for] = ACTIONS(6015),
    [anon_sym_LBRACK] = ACTIONS(6017),
    [sym_false] = ACTIONS(6015),
    [anon_sym_SEMI] = ACTIONS(6017),
    [anon_sym_case] = ACTIONS(6015),
    [anon_sym_module] = ACTIONS(6015),
    [anon_sym_number] = ACTIONS(6015),
    [anon_sym_class] = ACTIONS(6015),
    [anon_sym_declare] = ACTIONS(6015),
    [anon_sym_typeof] = ACTIONS(6015),
    [anon_sym_LBRACE] = ACTIONS(6017),
    [anon_sym_switch] = ACTIONS(6015),
    [anon_sym_LPAREN] = ACTIONS(6017),
    [anon_sym_RBRACK] = ACTIONS(6017),
    [sym_null] = ACTIONS(6015),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_any] = ACTIONS(6015),
    [anon_sym_boolean] = ACTIONS(6015),
    [anon_sym_async] = ACTIONS(6015),
    [anon_sym_public] = ACTIONS(6015),
    [anon_sym_EQ_GT] = ACTIONS(6017),
    [anon_sym_AMP] = ACTIONS(6017),
    [anon_sym_var] = ACTIONS(6015),
    [anon_sym_while] = ACTIONS(6015),
    [anon_sym_SQUOTE] = ACTIONS(6017),
    [anon_sym_try] = ACTIONS(6015),
    [anon_sym_RPAREN] = ACTIONS(6017),
    [anon_sym_LT] = ACTIONS(6017),
    [sym_number] = ACTIONS(6017),
    [anon_sym_SLASH] = ACTIONS(6015),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6015),
    [anon_sym_function] = ACTIONS(6015),
    [sym_undefined] = ACTIONS(6015),
    [anon_sym_new] = ACTIONS(6015),
    [ts_builtin_sym_end] = ACTIONS(6017),
    [anon_sym_let] = ACTIONS(6015),
    [anon_sym_PLUS] = ACTIONS(6015),
    [anon_sym_export] = ACTIONS(6015),
    [anon_sym_do] = ACTIONS(6015),
    [anon_sym_TILDE] = ACTIONS(6017),
    [anon_sym_with] = ACTIONS(6015),
  },
  [2012] = {
    [sym_identifier] = ACTIONS(6019),
    [anon_sym_BQUOTE] = ACTIONS(6021),
    [anon_sym_debugger] = ACTIONS(6019),
    [anon_sym_symbol] = ACTIONS(6019),
    [anon_sym_AT] = ACTIONS(6021),
    [anon_sym_PIPE] = ACTIONS(6021),
    [anon_sym_COMMA] = ACTIONS(6021),
    [anon_sym_DASH] = ACTIONS(6019),
    [anon_sym_EQ] = ACTIONS(6019),
    [anon_sym_void] = ACTIONS(6019),
    [anon_sym_break] = ACTIONS(6019),
    [anon_sym_const] = ACTIONS(6019),
    [sym_super] = ACTIONS(6019),
    [anon_sym_return] = ACTIONS(6019),
    [anon_sym_private] = ACTIONS(6019),
    [anon_sym_get] = ACTIONS(6019),
    [anon_sym_RBRACE] = ACTIONS(6021),
    [anon_sym_interface] = ACTIONS(6019),
    [anon_sym_default] = ACTIONS(6019),
    [anon_sym_enum] = ACTIONS(6019),
    [anon_sym_delete] = ACTIONS(6019),
    [anon_sym_continue] = ACTIONS(6019),
    [anon_sym_DASH_DASH] = ACTIONS(6021),
    [anon_sym_if] = ACTIONS(6019),
    [anon_sym_this] = ACTIONS(6019),
    [anon_sym_yield] = ACTIONS(6019),
    [sym_true] = ACTIONS(6019),
    [anon_sym_throw] = ACTIONS(6019),
    [anon_sym_protected] = ACTIONS(6019),
    [anon_sym_abstract] = ACTIONS(6019),
    [anon_sym_set] = ACTIONS(6019),
    [anon_sym_type] = ACTIONS(6019),
    [anon_sym_import] = ACTIONS(6019),
    [anon_sym_namespace] = ACTIONS(6019),
    [anon_sym_PLUS_PLUS] = ACTIONS(6021),
    [anon_sym_await] = ACTIONS(6019),
    [anon_sym_DQUOTE] = ACTIONS(6021),
    [anon_sym_else] = ACTIONS(6019),
    [anon_sym_BANG] = ACTIONS(6021),
    [anon_sym_for] = ACTIONS(6019),
    [anon_sym_LBRACK] = ACTIONS(6021),
    [sym_false] = ACTIONS(6019),
    [anon_sym_SEMI] = ACTIONS(6021),
    [anon_sym_case] = ACTIONS(6019),
    [anon_sym_module] = ACTIONS(6019),
    [anon_sym_number] = ACTIONS(6019),
    [anon_sym_class] = ACTIONS(6019),
    [anon_sym_declare] = ACTIONS(6019),
    [anon_sym_typeof] = ACTIONS(6019),
    [anon_sym_LBRACE] = ACTIONS(6021),
    [anon_sym_switch] = ACTIONS(6019),
    [anon_sym_LPAREN] = ACTIONS(6021),
    [anon_sym_RBRACK] = ACTIONS(6021),
    [sym_null] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6021),
    [anon_sym_any] = ACTIONS(6019),
    [anon_sym_boolean] = ACTIONS(6019),
    [anon_sym_async] = ACTIONS(6019),
    [anon_sym_public] = ACTIONS(6019),
    [anon_sym_EQ_GT] = ACTIONS(6021),
    [anon_sym_AMP] = ACTIONS(6021),
    [anon_sym_var] = ACTIONS(6019),
    [anon_sym_while] = ACTIONS(6019),
    [anon_sym_SQUOTE] = ACTIONS(6021),
    [anon_sym_try] = ACTIONS(6019),
    [anon_sym_RPAREN] = ACTIONS(6021),
    [anon_sym_LT] = ACTIONS(6021),
    [sym_number] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6019),
    [anon_sym_function] = ACTIONS(6019),
    [sym_undefined] = ACTIONS(6019),
    [anon_sym_new] = ACTIONS(6019),
    [ts_builtin_sym_end] = ACTIONS(6021),
    [anon_sym_let] = ACTIONS(6019),
    [anon_sym_PLUS] = ACTIONS(6019),
    [anon_sym_export] = ACTIONS(6019),
    [anon_sym_do] = ACTIONS(6019),
    [anon_sym_TILDE] = ACTIONS(6021),
    [anon_sym_with] = ACTIONS(6019),
  },
  [2013] = {
    [anon_sym_EQ_GT] = ACTIONS(6023),
    [sym_identifier] = ACTIONS(6025),
    [anon_sym_LBRACK] = ACTIONS(6023),
    [anon_sym_BQUOTE] = ACTIONS(6023),
    [anon_sym_AMP] = ACTIONS(6023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6023),
    [anon_sym_while] = ACTIONS(6025),
    [anon_sym_RPAREN] = ACTIONS(6023),
    [anon_sym_PIPE] = ACTIONS(6023),
    [anon_sym_COMMA] = ACTIONS(6023),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6025),
    [anon_sym_EQ] = ACTIONS(6025),
    [anon_sym_LPAREN] = ACTIONS(6023),
    [anon_sym_RBRACK] = ACTIONS(6023),
    [sym_jsx_identifier] = ACTIONS(6023),
    [anon_sym_GT] = ACTIONS(6023),
  },
  [2014] = {
    [anon_sym_GT] = ACTIONS(6027),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_COMMA] = ACTIONS(6027),
    [sym_comment] = ACTIONS(3),
  },
  [2015] = {
    [sym_union_type] = STATE(2014),
    [sym__type] = STATE(2014),
    [sym_constructor_type] = STATE(2014),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2014),
    [sym_function_type] = STATE(2014),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(6029),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_boolean] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_this] = ACTIONS(765),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [2016] = {
    [aux_sym_implements_clause_repeat1] = STATE(2016),
    [anon_sym_COMMA] = ACTIONS(6031),
    [anon_sym_GT] = ACTIONS(6027),
    [sym_comment] = ACTIONS(3),
  },
  [2017] = {
    [anon_sym_AMP] = ACTIONS(5881),
    [anon_sym_PIPE] = ACTIONS(5883),
    [anon_sym_RBRACK] = ACTIONS(6034),
    [sym_comment] = ACTIONS(3),
  },
  [2018] = {
    [sym_union_type] = STATE(2897),
    [sym__type] = STATE(2897),
    [sym_constructor_type] = STATE(2897),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2897),
    [sym_function_type] = STATE(2897),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2019] = {
    [sym_identifier] = ACTIONS(6036),
    [anon_sym_BQUOTE] = ACTIONS(6038),
    [anon_sym_debugger] = ACTIONS(6036),
    [anon_sym_symbol] = ACTIONS(6036),
    [anon_sym_AT] = ACTIONS(6038),
    [anon_sym_PIPE] = ACTIONS(6038),
    [anon_sym_COMMA] = ACTIONS(6038),
    [anon_sym_DASH] = ACTIONS(6036),
    [anon_sym_EQ] = ACTIONS(6036),
    [anon_sym_void] = ACTIONS(6036),
    [anon_sym_break] = ACTIONS(6036),
    [anon_sym_const] = ACTIONS(6036),
    [sym_super] = ACTIONS(6036),
    [anon_sym_return] = ACTIONS(6036),
    [anon_sym_private] = ACTIONS(6036),
    [anon_sym_get] = ACTIONS(6036),
    [anon_sym_RBRACE] = ACTIONS(6038),
    [anon_sym_interface] = ACTIONS(6036),
    [anon_sym_default] = ACTIONS(6036),
    [anon_sym_enum] = ACTIONS(6036),
    [anon_sym_delete] = ACTIONS(6036),
    [anon_sym_continue] = ACTIONS(6036),
    [anon_sym_DASH_DASH] = ACTIONS(6038),
    [anon_sym_if] = ACTIONS(6036),
    [anon_sym_this] = ACTIONS(6036),
    [anon_sym_yield] = ACTIONS(6036),
    [sym_true] = ACTIONS(6036),
    [anon_sym_throw] = ACTIONS(6036),
    [anon_sym_protected] = ACTIONS(6036),
    [anon_sym_abstract] = ACTIONS(6036),
    [anon_sym_set] = ACTIONS(6036),
    [anon_sym_type] = ACTIONS(6036),
    [anon_sym_import] = ACTIONS(6036),
    [anon_sym_namespace] = ACTIONS(6036),
    [anon_sym_PLUS_PLUS] = ACTIONS(6038),
    [anon_sym_await] = ACTIONS(6036),
    [anon_sym_DQUOTE] = ACTIONS(6038),
    [anon_sym_else] = ACTIONS(6036),
    [anon_sym_BANG] = ACTIONS(6038),
    [anon_sym_for] = ACTIONS(6036),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [sym_false] = ACTIONS(6036),
    [anon_sym_SEMI] = ACTIONS(6038),
    [anon_sym_case] = ACTIONS(6036),
    [anon_sym_module] = ACTIONS(6036),
    [anon_sym_number] = ACTIONS(6036),
    [anon_sym_class] = ACTIONS(6036),
    [anon_sym_declare] = ACTIONS(6036),
    [anon_sym_typeof] = ACTIONS(6036),
    [anon_sym_LBRACE] = ACTIONS(6038),
    [anon_sym_switch] = ACTIONS(6036),
    [anon_sym_LPAREN] = ACTIONS(6038),
    [anon_sym_RBRACK] = ACTIONS(6038),
    [sym_null] = ACTIONS(6036),
    [anon_sym_GT] = ACTIONS(6038),
    [anon_sym_any] = ACTIONS(6036),
    [anon_sym_boolean] = ACTIONS(6036),
    [anon_sym_async] = ACTIONS(6036),
    [anon_sym_public] = ACTIONS(6036),
    [anon_sym_EQ_GT] = ACTIONS(6038),
    [anon_sym_AMP] = ACTIONS(6038),
    [anon_sym_var] = ACTIONS(6036),
    [anon_sym_while] = ACTIONS(6036),
    [anon_sym_SQUOTE] = ACTIONS(6038),
    [anon_sym_try] = ACTIONS(6036),
    [anon_sym_RPAREN] = ACTIONS(6038),
    [anon_sym_LT] = ACTIONS(6038),
    [sym_number] = ACTIONS(6038),
    [anon_sym_SLASH] = ACTIONS(6036),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6036),
    [anon_sym_function] = ACTIONS(6036),
    [sym_undefined] = ACTIONS(6036),
    [anon_sym_new] = ACTIONS(6036),
    [ts_builtin_sym_end] = ACTIONS(6038),
    [anon_sym_let] = ACTIONS(6036),
    [anon_sym_PLUS] = ACTIONS(6036),
    [anon_sym_export] = ACTIONS(6036),
    [anon_sym_do] = ACTIONS(6036),
    [anon_sym_TILDE] = ACTIONS(6038),
    [anon_sym_with] = ACTIONS(6036),
  },
  [2020] = {
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_COMMA] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
  },
  [2021] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_in] = ACTIONS(2311),
  },
  [2022] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2023] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(2003),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_RPAREN] = ACTIONS(2003),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_in] = ACTIONS(2311),
  },
  [2024] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(2101),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_RPAREN] = ACTIONS(2101),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_in] = ACTIONS(2311),
  },
  [2025] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_RPAREN] = ACTIONS(2105),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_in] = ACTIONS(2311),
  },
  [2026] = {
    [sym_new_expression] = STATE(2898),
    [sym_augmented_assignment_expression] = STATE(2898),
    [sym_unary_expression] = STATE(2898),
    [sym_update_expression] = STATE(2898),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(2898),
    [sym_regex] = STATE(2898),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2185),
    [sym__expression] = STATE(2898),
    [sym_non_null_expression] = STATE(2898),
    [sym_yield_expression] = STATE(2898),
    [sym_jsx_fragment] = STATE(2898),
    [sym_jsx_element] = STATE(2898),
    [sym_as_expression] = STATE(2898),
    [sym_internal_module] = STATE(2898),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2898),
    [sym_await_expression] = STATE(2898),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(2898),
    [sym_this] = STATE(2898),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(2898),
    [sym_generator_function] = STATE(2898),
    [sym_call_expression] = STATE(2898),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(2898),
    [sym_ternary_expression] = STATE(2898),
    [sym_binary_expression] = STATE(2898),
    [sym_template_string] = STATE(2898),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2898),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2898),
    [sym_class] = STATE(2898),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(6042),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6042),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6044),
    [sym_true] = ACTIONS(6042),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6042),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [2027] = {
    [sym_new_expression] = STATE(2899),
    [sym_augmented_assignment_expression] = STATE(2899),
    [sym_unary_expression] = STATE(2899),
    [sym_update_expression] = STATE(2899),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(2899),
    [sym_regex] = STATE(2899),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2187),
    [sym__expression] = STATE(2899),
    [sym_non_null_expression] = STATE(2899),
    [sym_yield_expression] = STATE(2899),
    [sym_jsx_fragment] = STATE(2899),
    [sym_jsx_element] = STATE(2899),
    [sym_as_expression] = STATE(2899),
    [sym_internal_module] = STATE(2899),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2899),
    [sym_await_expression] = STATE(2899),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(2899),
    [sym_this] = STATE(2899),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(2899),
    [sym_generator_function] = STATE(2899),
    [sym_call_expression] = STATE(2899),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(2899),
    [sym_ternary_expression] = STATE(2899),
    [sym_binary_expression] = STATE(2899),
    [sym_template_string] = STATE(2899),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2899),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2899),
    [sym_class] = STATE(2899),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(6046),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6046),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6048),
    [sym_true] = ACTIONS(6046),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6046),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [2028] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_in] = ACTIONS(2311),
  },
  [2029] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6050),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2030] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6050),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2031] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_in] = ACTIONS(2311),
  },
  [2032] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3630),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6053),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [2033] = {
    [sym_type_arguments] = STATE(2206),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(4638),
    [anon_sym_BANG] = ACTIONS(3699),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_GT_GT_GT] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_is] = ACTIONS(6055),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_RPAREN] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(4643),
    [anon_sym_instanceof] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4646),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_STAR_STAR] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2204),
    [anon_sym_in] = ACTIONS(3699),
  },
  [2034] = {
    [sym_index_type_query] = STATE(2208),
    [sym_lookup_type] = STATE(2208),
    [sym_flow_maybe_type] = STATE(2208),
    [sym_parenthesized_type] = STATE(2208),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_array_type] = STATE(2208),
    [sym_type_predicate] = STATE(2208),
    [sym_type_query] = STATE(2208),
    [sym_existential_type] = STATE(2208),
    [sym_this_type] = STATE(2208),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(2208),
    [sym__primary_type] = STATE(2208),
    [sym_generic_type] = STATE(2208),
    [sym_literal_type] = STATE(2208),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(2208),
    [sym_string] = STATE(1279),
    [sym_tuple_type] = STATE(2208),
    [sym_identifier] = ACTIONS(4292),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(4298),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [sym_true] = ACTIONS(2643),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(4648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2035] = {
    [sym_union_type] = STATE(2213),
    [sym__type] = STATE(2213),
    [sym_constructor_type] = STATE(2213),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2038),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2213),
    [sym_function_type] = STATE(2213),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2039),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(4292),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(4298),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(4296),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(4300),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(4294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2036] = {
    [sym_type_parameters] = STATE(2902),
    [sym_formal_parameters] = STATE(2903),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2037] = {
    [sym_union_type] = STATE(2221),
    [sym__type] = STATE(2221),
    [sym_constructor_type] = STATE(2221),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2038),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2221),
    [sym_function_type] = STATE(2221),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2039),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(4292),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(4298),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(4296),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(4300),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(4294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2038] = {
    [sym_formal_parameters] = STATE(2906),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2039] = {
    [anon_sym_EQ_GT] = ACTIONS(6057),
    [sym_comment] = ACTIONS(3),
  },
  [2040] = {
    [sym__initializer] = STATE(522),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2307),
    [anon_sym_AMP_EQ] = ACTIONS(2307),
    [anon_sym_PLUS_EQ] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_GT] = ACTIONS(3738),
    [anon_sym_CARET_EQ] = ACTIONS(2307),
    [anon_sym_STAR_EQ] = ACTIONS(2307),
    [anon_sym_PIPE_EQ] = ACTIONS(2307),
    [anon_sym_DASH_EQ] = ACTIONS(2307),
    [anon_sym_EQ_GT] = ACTIONS(2309),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2307),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT_EQ] = ACTIONS(2307),
    [anon_sym_DOT] = ACTIONS(4670),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2311),
  },
  [2041] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2313),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_AMP_EQ] = ACTIONS(2313),
    [anon_sym_PLUS_EQ] = ACTIONS(2313),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_CARET_EQ] = ACTIONS(2313),
    [anon_sym_STAR_EQ] = ACTIONS(2313),
    [anon_sym_PIPE_EQ] = ACTIONS(2313),
    [anon_sym_DASH_EQ] = ACTIONS(2313),
    [anon_sym_EQ_GT] = ACTIONS(2315),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(2313),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2313),
    [anon_sym_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2042] = {
    [sym_new_expression] = STATE(1126),
    [sym_augmented_assignment_expression] = STATE(1126),
    [sym_unary_expression] = STATE(1126),
    [sym_update_expression] = STATE(1126),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(1126),
    [sym_regex] = STATE(1126),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1126),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1126),
    [sym_jsx_fragment] = STATE(1126),
    [sym_yield_expression] = STATE(1126),
    [sym_jsx_element] = STATE(1126),
    [sym_internal_module] = STATE(1126),
    [sym_nested_identifier] = STATE(1092),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1126),
    [sym_await_expression] = STATE(1126),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(1126),
    [sym_this] = STATE(1126),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(1126),
    [sym_generator_function] = STATE(1126),
    [sym_call_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(1126),
    [sym_ternary_expression] = STATE(1126),
    [sym_binary_expression] = STATE(1126),
    [sym_template_string] = STATE(1126),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1126),
    [sym_class] = STATE(1126),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(6059),
    [sym_false] = ACTIONS(2317),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2317),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2319),
    [sym_true] = ACTIONS(2317),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2317),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [2043] = {
    [sym_new_expression] = STATE(1127),
    [sym_augmented_assignment_expression] = STATE(1127),
    [sym_unary_expression] = STATE(1127),
    [sym_update_expression] = STATE(1127),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(1127),
    [sym_regex] = STATE(1127),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1127),
    [sym_non_null_expression] = STATE(1127),
    [sym_as_expression] = STATE(1127),
    [sym_jsx_fragment] = STATE(1127),
    [sym_yield_expression] = STATE(1127),
    [sym_jsx_element] = STATE(1127),
    [sym_internal_module] = STATE(1127),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1127),
    [sym_await_expression] = STATE(1127),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(1127),
    [sym_this] = STATE(1127),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(1127),
    [sym_generator_function] = STATE(1127),
    [sym_call_expression] = STATE(1127),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(1127),
    [sym_ternary_expression] = STATE(1127),
    [sym_binary_expression] = STATE(1127),
    [sym_template_string] = STATE(1127),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1127),
    [sym_class] = STATE(1127),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2321),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4674),
    [sym_true] = ACTIONS(2321),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2321),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [2044] = {
    [sym_new_expression] = STATE(1126),
    [sym_augmented_assignment_expression] = STATE(1126),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(1126),
    [sym_update_expression] = STATE(1126),
    [sym_regex] = STATE(1126),
    [sym_meta_property] = STATE(1126),
    [sym_call_signature] = STATE(452),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1126),
    [sym_non_null_expression] = STATE(1126),
    [sym_yield_expression] = STATE(1126),
    [sym_jsx_fragment] = STATE(1126),
    [sym_jsx_element] = STATE(1126),
    [sym_as_expression] = STATE(1126),
    [sym_internal_module] = STATE(1126),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1126),
    [sym_await_expression] = STATE(1126),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(1126),
    [sym_this] = STATE(1126),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(1126),
    [sym_generator_function] = STATE(1126),
    [sym_call_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(1126),
    [sym_ternary_expression] = STATE(1126),
    [sym_binary_expression] = STATE(1126),
    [sym_template_string] = STATE(1126),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1126),
    [sym_class] = STATE(1126),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(787),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2313),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_AMP_EQ] = ACTIONS(2313),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2313),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(2313),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_PIPE_EQ] = ACTIONS(2313),
    [anon_sym_DASH_EQ] = ACTIONS(2313),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2313),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(811),
    [sym_true] = ACTIONS(2317),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2313),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2317),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2317),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_STAR_EQ] = ACTIONS(2313),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_EQ_GT] = ACTIONS(2315),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(2319),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2313),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2317),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2045] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(1819),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(1820),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(2349),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(2351),
    [anon_sym_symbol] = ACTIONS(2351),
    [anon_sym_number] = ACTIONS(2351),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2351),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2353),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2351),
    [anon_sym_private] = ACTIONS(2351),
    [anon_sym_boolean] = ACTIONS(2351),
    [anon_sym_async] = ACTIONS(2355),
    [anon_sym_public] = ACTIONS(2351),
    [anon_sym_get] = ACTIONS(2351),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2351),
    [anon_sym_string] = ACTIONS(2351),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(2351),
    [anon_sym_type] = ACTIONS(2351),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(2351),
    [anon_sym_export] = ACTIONS(2351),
    [anon_sym_namespace] = ACTIONS(2357),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [2046] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6050),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2047] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(6061),
    [anon_sym_BANG] = ACTIONS(6063),
    [anon_sym_SEMI] = ACTIONS(6061),
    [anon_sym_BQUOTE] = ACTIONS(6061),
    [sym__automatic_semicolon] = ACTIONS(6061),
    [anon_sym_PIPE] = ACTIONS(6063),
    [anon_sym_COMMA] = ACTIONS(6061),
    [anon_sym_LT_LT] = ACTIONS(6061),
    [anon_sym_STAR] = ACTIONS(6063),
    [anon_sym_GT_GT_GT] = ACTIONS(6061),
    [anon_sym_AMP_AMP] = ACTIONS(6061),
    [anon_sym_DASH] = ACTIONS(6063),
    [anon_sym_BANG_EQ] = ACTIONS(6063),
    [anon_sym_LT_EQ] = ACTIONS(6061),
    [anon_sym_LPAREN] = ACTIONS(6061),
    [anon_sym_GT_EQ] = ACTIONS(6061),
    [anon_sym_GT] = ACTIONS(6063),
    [anon_sym_AMP] = ACTIONS(6063),
    [anon_sym_PERCENT] = ACTIONS(6061),
    [anon_sym_QMARK] = ACTIONS(6061),
    [anon_sym_RBRACE] = ACTIONS(6061),
    [anon_sym_as] = ACTIONS(6061),
    [anon_sym_PIPE_PIPE] = ACTIONS(6061),
    [anon_sym_DASH_DASH] = ACTIONS(6061),
    [anon_sym_EQ_EQ] = ACTIONS(6063),
    [anon_sym_instanceof] = ACTIONS(6061),
    [anon_sym_LT] = ACTIONS(6063),
    [anon_sym_RPAREN] = ACTIONS(6061),
    [anon_sym_SLASH] = ACTIONS(6063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6061),
    [anon_sym_CARET] = ACTIONS(6061),
    [anon_sym_STAR_STAR] = ACTIONS(6061),
    [anon_sym_PLUS] = ACTIONS(6063),
    [anon_sym_GT_GT] = ACTIONS(6063),
    [anon_sym_PLUS_PLUS] = ACTIONS(6061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6061),
    [anon_sym_in] = ACTIONS(6063),
  },
  [2048] = {
    [sym_new_expression] = STATE(2909),
    [sym_augmented_assignment_expression] = STATE(2909),
    [sym_unary_expression] = STATE(2909),
    [sym_update_expression] = STATE(2909),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(2909),
    [sym_regex] = STATE(2909),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1233),
    [sym__expression] = STATE(2909),
    [sym_non_null_expression] = STATE(2909),
    [sym_yield_expression] = STATE(2909),
    [sym_jsx_fragment] = STATE(2909),
    [sym_jsx_element] = STATE(2909),
    [sym_as_expression] = STATE(2909),
    [sym_internal_module] = STATE(2909),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2909),
    [sym_await_expression] = STATE(2909),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(2909),
    [sym_this] = STATE(2909),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(2909),
    [sym_generator_function] = STATE(2909),
    [sym_call_expression] = STATE(2909),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2909),
    [sym_ternary_expression] = STATE(2909),
    [sym_binary_expression] = STATE(2909),
    [sym_template_string] = STATE(2909),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2909),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2909),
    [sym_class] = STATE(2909),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(4341),
    [sym_false] = ACTIONS(6065),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6065),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6067),
    [sym_true] = ACTIONS(6065),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6065),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [2049] = {
    [sym_new_expression] = STATE(2910),
    [sym_augmented_assignment_expression] = STATE(2910),
    [sym_unary_expression] = STATE(2910),
    [sym_update_expression] = STATE(2910),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(2910),
    [sym_regex] = STATE(2910),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2910),
    [sym_non_null_expression] = STATE(2910),
    [sym_as_expression] = STATE(2910),
    [sym_jsx_fragment] = STATE(2910),
    [sym_yield_expression] = STATE(2910),
    [sym_jsx_element] = STATE(2910),
    [sym_internal_module] = STATE(2910),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2910),
    [sym_await_expression] = STATE(2910),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(2910),
    [sym_this] = STATE(2910),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(2910),
    [sym_generator_function] = STATE(2910),
    [sym_call_expression] = STATE(2910),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2910),
    [sym_ternary_expression] = STATE(2910),
    [sym_binary_expression] = STATE(2910),
    [sym_template_string] = STATE(2910),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2910),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2910),
    [sym_class] = STATE(2910),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(4341),
    [sym_false] = ACTIONS(6069),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6069),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6071),
    [sym_true] = ACTIONS(6069),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6069),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [2050] = {
    [sym_new_expression] = STATE(2911),
    [sym_augmented_assignment_expression] = STATE(2911),
    [sym_unary_expression] = STATE(2911),
    [sym_update_expression] = STATE(2911),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(2911),
    [sym_regex] = STATE(2911),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2911),
    [sym_non_null_expression] = STATE(2911),
    [sym_as_expression] = STATE(2911),
    [sym_jsx_fragment] = STATE(2911),
    [sym_yield_expression] = STATE(2911),
    [sym_jsx_element] = STATE(2911),
    [sym_internal_module] = STATE(2911),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2911),
    [sym_await_expression] = STATE(2911),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(2911),
    [sym_this] = STATE(2911),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(2911),
    [sym_generator_function] = STATE(2911),
    [sym_call_expression] = STATE(2911),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2911),
    [sym_ternary_expression] = STATE(2911),
    [sym_binary_expression] = STATE(2911),
    [sym_template_string] = STATE(2911),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2911),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2911),
    [sym_class] = STATE(2911),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(4341),
    [sym_false] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6073),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6075),
    [sym_true] = ACTIONS(6073),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6073),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [2051] = {
    [sym_new_expression] = STATE(2912),
    [sym_augmented_assignment_expression] = STATE(2912),
    [sym_unary_expression] = STATE(2912),
    [sym_update_expression] = STATE(2912),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(2912),
    [sym_regex] = STATE(2912),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2912),
    [sym_non_null_expression] = STATE(2912),
    [sym_as_expression] = STATE(2912),
    [sym_jsx_fragment] = STATE(2912),
    [sym_yield_expression] = STATE(2912),
    [sym_jsx_element] = STATE(2912),
    [sym_internal_module] = STATE(2912),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2912),
    [sym_await_expression] = STATE(2912),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(2912),
    [sym_this] = STATE(2912),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(2912),
    [sym_generator_function] = STATE(2912),
    [sym_call_expression] = STATE(2912),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2912),
    [sym_ternary_expression] = STATE(2912),
    [sym_binary_expression] = STATE(2912),
    [sym_template_string] = STATE(2912),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2912),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2912),
    [sym_class] = STATE(2912),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(4341),
    [sym_false] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6077),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6079),
    [sym_true] = ACTIONS(6077),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6077),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [2052] = {
    [sym_new_expression] = STATE(2913),
    [sym_augmented_assignment_expression] = STATE(2913),
    [sym_unary_expression] = STATE(2913),
    [sym_update_expression] = STATE(2913),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(2913),
    [sym_regex] = STATE(2913),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1240),
    [sym__expression] = STATE(2913),
    [sym_non_null_expression] = STATE(2913),
    [sym_yield_expression] = STATE(2913),
    [sym_jsx_fragment] = STATE(2913),
    [sym_jsx_element] = STATE(2913),
    [sym_as_expression] = STATE(2913),
    [sym_internal_module] = STATE(2913),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2913),
    [sym_await_expression] = STATE(2913),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(2913),
    [sym_this] = STATE(2913),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(2913),
    [sym_generator_function] = STATE(2913),
    [sym_call_expression] = STATE(2913),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2913),
    [sym_ternary_expression] = STATE(2913),
    [sym_binary_expression] = STATE(2913),
    [sym_template_string] = STATE(2913),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2913),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2913),
    [sym_class] = STATE(2913),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(4341),
    [sym_false] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6081),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6083),
    [sym_true] = ACTIONS(6081),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6081),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [2053] = {
    [sym_new_expression] = STATE(2914),
    [sym_augmented_assignment_expression] = STATE(2914),
    [sym_unary_expression] = STATE(2914),
    [sym_update_expression] = STATE(2914),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(2914),
    [sym_regex] = STATE(2914),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2914),
    [sym_non_null_expression] = STATE(2914),
    [sym_as_expression] = STATE(2914),
    [sym_jsx_fragment] = STATE(2914),
    [sym_yield_expression] = STATE(2914),
    [sym_jsx_element] = STATE(2914),
    [sym_internal_module] = STATE(2914),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2914),
    [sym_await_expression] = STATE(2914),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(2914),
    [sym_this] = STATE(2914),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(2914),
    [sym_generator_function] = STATE(2914),
    [sym_call_expression] = STATE(2914),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2914),
    [sym_ternary_expression] = STATE(2914),
    [sym_binary_expression] = STATE(2914),
    [sym_template_string] = STATE(2914),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2914),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2914),
    [sym_class] = STATE(2914),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(4341),
    [sym_false] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6085),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6087),
    [sym_true] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6085),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [2054] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4327),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4327),
    [anon_sym_AMP_EQ] = ACTIONS(4327),
    [anon_sym_PLUS_EQ] = ACTIONS(4327),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4327),
    [anon_sym_STAR_EQ] = ACTIONS(4327),
    [anon_sym_PIPE_EQ] = ACTIONS(4327),
    [anon_sym_DASH_EQ] = ACTIONS(4327),
    [anon_sym_EQ_GT] = ACTIONS(4333),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4327),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4327),
    [anon_sym_GT_GT_EQ] = ACTIONS(4327),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4327),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4335),
  },
  [2055] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_LBRACE] = ACTIONS(704),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_LBRACE_PIPE] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(6089),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [2056] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_LBRACE] = ACTIONS(704),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_LBRACE_PIPE] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(6089),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [2057] = {
    [anon_sym_EQ_GT] = ACTIONS(6092),
    [sym_comment] = ACTIONS(3),
  },
  [2058] = {
    [anon_sym_EQ_GT] = ACTIONS(6094),
    [sym_comment] = ACTIONS(3),
  },
  [2059] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_BQUOTE] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_LBRACE_PIPE] = ACTIONS(839),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_instanceof] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_in] = ACTIONS(841),
  },
  [2060] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4379),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4381),
    [anon_sym_COMMA] = ACTIONS(871),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_STAR] = ACTIONS(4393),
    [anon_sym_LBRACE] = ACTIONS(6096),
    [anon_sym_AMP_AMP] = ACTIONS(4391),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4379),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(4379),
    [anon_sym_GT] = ACTIONS(4335),
    [anon_sym_AMP] = ACTIONS(4395),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_LBRACE_PIPE] = ACTIONS(871),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_PIPE_PIPE] = ACTIONS(4399),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_instanceof] = ACTIONS(4379),
    [anon_sym_LT] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4399),
    [anon_sym_STAR_STAR] = ACTIONS(4405),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_GT_GT] = ACTIONS(4393),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4379),
    [anon_sym_in] = ACTIONS(4335),
  },
  [2061] = {
    [sym__initializer] = STATE(522),
    [sym_arguments] = STATE(1268),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(4333),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1531),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1529),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [2062] = {
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(4339),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1539),
    [anon_sym_as] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [2063] = {
    [sym_new_expression] = STATE(836),
    [sym_augmented_assignment_expression] = STATE(836),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(836),
    [sym_update_expression] = STATE(836),
    [sym_regex] = STATE(836),
    [sym_meta_property] = STATE(836),
    [sym_call_signature] = STATE(835),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(836),
    [sym_non_null_expression] = STATE(836),
    [sym_yield_expression] = STATE(836),
    [sym_jsx_fragment] = STATE(836),
    [sym_jsx_element] = STATE(836),
    [sym_as_expression] = STATE(836),
    [sym_internal_module] = STATE(836),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(836),
    [sym_await_expression] = STATE(836),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(836),
    [sym_this] = STATE(836),
    [sym_arguments] = STATE(1270),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(836),
    [sym_generator_function] = STATE(836),
    [sym_call_expression] = STATE(836),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(836),
    [sym_ternary_expression] = STATE(836),
    [sym_binary_expression] = STATE(836),
    [sym_template_string] = STATE(836),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(836),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(836),
    [sym_class] = STATE(836),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1539),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(500),
    [sym_true] = ACTIONS(1545),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [sym_false] = ACTIONS(1545),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [sym_null] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(4339),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [sym_number] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [2064] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_arguments] = STATE(1270),
    [sym_call_signature] = STATE(2057),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(4353),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(4355),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(4355),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(4355),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(4355),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1539),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_protected] = ACTIONS(4355),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(4355),
    [anon_sym_type] = ACTIONS(4355),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(4355),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(4355),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(4355),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(4355),
    [anon_sym_declare] = ACTIONS(4355),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(4355),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(4355),
    [anon_sym_async] = ACTIONS(4355),
    [anon_sym_public] = ACTIONS(4355),
    [anon_sym_EQ_GT] = ACTIONS(4339),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(4355),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(4355),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [2065] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(4339),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1539),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [2066] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4379),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4381),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_STAR] = ACTIONS(4393),
    [anon_sym_LBRACE] = ACTIONS(6098),
    [anon_sym_AMP_AMP] = ACTIONS(4391),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4379),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(4379),
    [anon_sym_GT] = ACTIONS(4335),
    [anon_sym_AMP] = ACTIONS(4395),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_LBRACE_PIPE] = ACTIONS(915),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_PIPE_PIPE] = ACTIONS(4399),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_instanceof] = ACTIONS(4379),
    [anon_sym_LT] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4399),
    [anon_sym_STAR_STAR] = ACTIONS(4405),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_GT_GT] = ACTIONS(4393),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4379),
    [anon_sym_in] = ACTIONS(4335),
  },
  [2067] = {
    [sym_new_expression] = STATE(2917),
    [sym_augmented_assignment_expression] = STATE(2917),
    [sym_unary_expression] = STATE(2917),
    [sym_update_expression] = STATE(2917),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(2917),
    [sym_regex] = STATE(2917),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2917),
    [sym_non_null_expression] = STATE(2917),
    [sym_as_expression] = STATE(2917),
    [sym_jsx_fragment] = STATE(2917),
    [sym_yield_expression] = STATE(2917),
    [sym_jsx_element] = STATE(2917),
    [sym_internal_module] = STATE(2917),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2917),
    [sym_await_expression] = STATE(2917),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(2917),
    [sym_this] = STATE(2917),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(2917),
    [sym_generator_function] = STATE(2917),
    [sym_call_expression] = STATE(2917),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2917),
    [sym_ternary_expression] = STATE(2917),
    [sym_binary_expression] = STATE(2917),
    [sym_template_string] = STATE(2917),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2917),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2917),
    [sym_class] = STATE(2917),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(4341),
    [sym_false] = ACTIONS(6100),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6100),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6102),
    [sym_true] = ACTIONS(6100),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6100),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [2068] = {
    [sym_new_expression] = STATE(2918),
    [sym_augmented_assignment_expression] = STATE(2918),
    [sym_unary_expression] = STATE(2918),
    [sym_update_expression] = STATE(2918),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(2918),
    [sym_regex] = STATE(2918),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2918),
    [sym_non_null_expression] = STATE(2918),
    [sym_as_expression] = STATE(2918),
    [sym_jsx_fragment] = STATE(2918),
    [sym_yield_expression] = STATE(2918),
    [sym_jsx_element] = STATE(2918),
    [sym_internal_module] = STATE(2918),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2918),
    [sym_await_expression] = STATE(2918),
    [sym_member_expression] = STATE(1164),
    [sym_generic_type] = STATE(2253),
    [sym_string] = STATE(2918),
    [sym_this] = STATE(2918),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_nested_type_identifier] = STATE(1166),
    [sym_anonymous_class] = STATE(2918),
    [sym_generator_function] = STATE(2918),
    [sym_call_expression] = STATE(2918),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2918),
    [sym_ternary_expression] = STATE(2918),
    [sym_binary_expression] = STATE(2918),
    [sym_template_string] = STATE(2918),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2918),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2918),
    [sym__type_reference] = STATE(2253),
    [sym_class] = STATE(2918),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(2399),
    [sym_false] = ACTIONS(6104),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6104),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6106),
    [sym_true] = ACTIONS(6104),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6104),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [2069] = {
    [sym_new_expression] = STATE(2919),
    [sym_augmented_assignment_expression] = STATE(2919),
    [sym_unary_expression] = STATE(2919),
    [sym_update_expression] = STATE(2919),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(2919),
    [sym_regex] = STATE(2919),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2919),
    [sym_non_null_expression] = STATE(2919),
    [sym_as_expression] = STATE(2919),
    [sym_jsx_fragment] = STATE(2919),
    [sym_yield_expression] = STATE(2919),
    [sym_jsx_element] = STATE(2919),
    [sym_internal_module] = STATE(2919),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2919),
    [sym_await_expression] = STATE(2919),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(2919),
    [sym_this] = STATE(2919),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(2919),
    [sym_generator_function] = STATE(2919),
    [sym_call_expression] = STATE(2919),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2919),
    [sym_ternary_expression] = STATE(2919),
    [sym_binary_expression] = STATE(2919),
    [sym_template_string] = STATE(2919),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2919),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2919),
    [sym_class] = STATE(2919),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(4341),
    [sym_false] = ACTIONS(6108),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6108),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6110),
    [sym_true] = ACTIONS(6108),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6108),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [2070] = {
    [sym_new_expression] = STATE(2920),
    [sym_augmented_assignment_expression] = STATE(2920),
    [sym_unary_expression] = STATE(2920),
    [sym_update_expression] = STATE(2920),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(2920),
    [sym_regex] = STATE(2920),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2920),
    [sym_non_null_expression] = STATE(2920),
    [sym_as_expression] = STATE(2920),
    [sym_jsx_fragment] = STATE(2920),
    [sym_yield_expression] = STATE(2920),
    [sym_jsx_element] = STATE(2920),
    [sym_internal_module] = STATE(2920),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2920),
    [sym_await_expression] = STATE(2920),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(2920),
    [sym_this] = STATE(2920),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(2920),
    [sym_generator_function] = STATE(2920),
    [sym_call_expression] = STATE(2920),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2920),
    [sym_ternary_expression] = STATE(2920),
    [sym_binary_expression] = STATE(2920),
    [sym_template_string] = STATE(2920),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2920),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2920),
    [sym_class] = STATE(2920),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(4341),
    [sym_false] = ACTIONS(6112),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6112),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6114),
    [sym_true] = ACTIONS(6112),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6112),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [2071] = {
    [sym_new_expression] = STATE(2921),
    [sym_augmented_assignment_expression] = STATE(2921),
    [sym_unary_expression] = STATE(2921),
    [sym_update_expression] = STATE(2921),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(2921),
    [sym_regex] = STATE(2921),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2921),
    [sym_non_null_expression] = STATE(2921),
    [sym_as_expression] = STATE(2921),
    [sym_jsx_fragment] = STATE(2921),
    [sym_yield_expression] = STATE(2921),
    [sym_jsx_element] = STATE(2921),
    [sym_internal_module] = STATE(2921),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2921),
    [sym_await_expression] = STATE(2921),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(2921),
    [sym_this] = STATE(2921),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(2921),
    [sym_generator_function] = STATE(2921),
    [sym_call_expression] = STATE(2921),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2921),
    [sym_ternary_expression] = STATE(2921),
    [sym_binary_expression] = STATE(2921),
    [sym_template_string] = STATE(2921),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2921),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2921),
    [sym_class] = STATE(2921),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(4341),
    [sym_false] = ACTIONS(6116),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6116),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6118),
    [sym_true] = ACTIONS(6116),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6116),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [2072] = {
    [sym_new_expression] = STATE(2922),
    [sym_augmented_assignment_expression] = STATE(2922),
    [sym_unary_expression] = STATE(2922),
    [sym_update_expression] = STATE(2922),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(2922),
    [sym_regex] = STATE(2922),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2922),
    [sym_non_null_expression] = STATE(2922),
    [sym_as_expression] = STATE(2922),
    [sym_jsx_fragment] = STATE(2922),
    [sym_yield_expression] = STATE(2922),
    [sym_jsx_element] = STATE(2922),
    [sym_internal_module] = STATE(2922),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2922),
    [sym_await_expression] = STATE(2922),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(2922),
    [sym_this] = STATE(2922),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(2922),
    [sym_generator_function] = STATE(2922),
    [sym_call_expression] = STATE(2922),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(2922),
    [sym_ternary_expression] = STATE(2922),
    [sym_binary_expression] = STATE(2922),
    [sym_template_string] = STATE(2922),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2922),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2922),
    [sym_class] = STATE(2922),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(6120),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6120),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6122),
    [sym_true] = ACTIONS(6120),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6120),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [2073] = {
    [sym_union_type] = STATE(1293),
    [sym__type] = STATE(1293),
    [sym_constructor_type] = STATE(1293),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2928),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_template_string] = STATE(1297),
    [sym_intersection_type] = STATE(1293),
    [sym_function_type] = STATE(1293),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2929),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(6124),
    [sym_false] = ACTIONS(2643),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_PIPE] = ACTIONS(6126),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_boolean] = ACTIONS(2647),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(6128),
    [anon_sym_QMARK] = ACTIONS(6130),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2669),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_new] = ACTIONS(6132),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_DQUOTE] = ACTIONS(304),
  },
  [2074] = {
    [sym_new_expression] = STATE(2910),
    [sym_constructor_type] = STATE(432),
    [sym_augmented_assignment_expression] = STATE(2910),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(2910),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(2910),
    [sym_type_parameters] = STATE(959),
    [sym_array_type] = STATE(436),
    [sym_yield_expression] = STATE(2910),
    [sym_as_expression] = STATE(2910),
    [sym_jsx_fragment] = STATE(2910),
    [sym_internal_module] = STATE(2910),
    [sym_arrow_function] = STATE(2910),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(1164),
    [sym_literal_type] = STATE(436),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(1301),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(2910),
    [sym_subscript_expression] = STATE(1164),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(2910),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(2910),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(960),
    [sym_function_type] = STATE(432),
    [sym__type] = STATE(432),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(2910),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(2910),
    [sym__expression] = STATE(2910),
    [sym_non_null_expression] = STATE(2910),
    [sym_jsx_element] = STATE(2910),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_await_expression] = STATE(2910),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_this] = STATE(2910),
    [sym_union_type] = STATE(432),
    [sym_anonymous_class] = STATE(2910),
    [sym_call_expression] = STATE(2910),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(2910),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(2910),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(432),
    [sym_parenthesized_expression] = STATE(2910),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2910),
    [sym_class] = STATE(2910),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(6134),
    [sym_false] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(6136),
    [anon_sym_number] = ACTIONS(6136),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(6138),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_void] = ACTIONS(6142),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [sym_null] = ACTIONS(6069),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(6136),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(6136),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2691),
    [sym_true] = ACTIONS(2677),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(2693),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(6136),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6069),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(6144),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [2075] = {
    [sym_new_expression] = STATE(2936),
    [sym_augmented_assignment_expression] = STATE(2936),
    [sym_unary_expression] = STATE(2936),
    [sym_update_expression] = STATE(2936),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(2936),
    [sym_regex] = STATE(2936),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2936),
    [sym_non_null_expression] = STATE(2936),
    [sym_as_expression] = STATE(2936),
    [sym_jsx_fragment] = STATE(2936),
    [sym_yield_expression] = STATE(2936),
    [sym_jsx_element] = STATE(2936),
    [sym_internal_module] = STATE(2936),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2936),
    [sym_await_expression] = STATE(2936),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(2936),
    [sym_this] = STATE(2936),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(2936),
    [sym_generator_function] = STATE(2936),
    [sym_call_expression] = STATE(2936),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2936),
    [sym_ternary_expression] = STATE(2936),
    [sym_binary_expression] = STATE(2936),
    [sym_template_string] = STATE(2936),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2936),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2936),
    [sym_class] = STATE(2936),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(4341),
    [sym_false] = ACTIONS(6146),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6146),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6148),
    [sym_true] = ACTIONS(6146),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6146),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [2076] = {
    [aux_sym_extends_clause_repeat1] = STATE(2937),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4769),
    [anon_sym_COMMA] = ACTIONS(4385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6150),
  },
  [2077] = {
    [sym_identifier] = ACTIONS(6152),
    [anon_sym_BQUOTE] = ACTIONS(6154),
    [anon_sym_debugger] = ACTIONS(6152),
    [anon_sym_symbol] = ACTIONS(6152),
    [anon_sym_AT] = ACTIONS(6154),
    [anon_sym_DASH] = ACTIONS(6152),
    [anon_sym_void] = ACTIONS(6152),
    [anon_sym_break] = ACTIONS(6152),
    [anon_sym_const] = ACTIONS(6152),
    [sym_super] = ACTIONS(6152),
    [anon_sym_return] = ACTIONS(6152),
    [anon_sym_private] = ACTIONS(6152),
    [anon_sym_get] = ACTIONS(6152),
    [anon_sym_RBRACE] = ACTIONS(6154),
    [anon_sym_interface] = ACTIONS(6152),
    [anon_sym_default] = ACTIONS(6152),
    [anon_sym_enum] = ACTIONS(6152),
    [anon_sym_delete] = ACTIONS(6152),
    [anon_sym_continue] = ACTIONS(6152),
    [anon_sym_DASH_DASH] = ACTIONS(6154),
    [anon_sym_if] = ACTIONS(6152),
    [anon_sym_this] = ACTIONS(6152),
    [anon_sym_yield] = ACTIONS(6152),
    [sym_true] = ACTIONS(6152),
    [anon_sym_throw] = ACTIONS(6152),
    [anon_sym_protected] = ACTIONS(6152),
    [anon_sym_abstract] = ACTIONS(6152),
    [anon_sym_set] = ACTIONS(6152),
    [anon_sym_type] = ACTIONS(6152),
    [anon_sym_import] = ACTIONS(6152),
    [anon_sym_namespace] = ACTIONS(6152),
    [anon_sym_PLUS_PLUS] = ACTIONS(6154),
    [anon_sym_await] = ACTIONS(6152),
    [anon_sym_DQUOTE] = ACTIONS(6154),
    [anon_sym_else] = ACTIONS(6152),
    [anon_sym_BANG] = ACTIONS(6154),
    [anon_sym_for] = ACTIONS(6152),
    [anon_sym_LBRACK] = ACTIONS(6154),
    [sym_false] = ACTIONS(6152),
    [anon_sym_SEMI] = ACTIONS(6154),
    [anon_sym_case] = ACTIONS(6152),
    [anon_sym_module] = ACTIONS(6152),
    [anon_sym_number] = ACTIONS(6152),
    [anon_sym_class] = ACTIONS(6152),
    [anon_sym_declare] = ACTIONS(6152),
    [anon_sym_typeof] = ACTIONS(6152),
    [anon_sym_LBRACE] = ACTIONS(6154),
    [anon_sym_switch] = ACTIONS(6152),
    [anon_sym_LPAREN] = ACTIONS(6154),
    [sym_null] = ACTIONS(6152),
    [anon_sym_any] = ACTIONS(6152),
    [anon_sym_boolean] = ACTIONS(6152),
    [anon_sym_async] = ACTIONS(6152),
    [anon_sym_public] = ACTIONS(6152),
    [anon_sym_var] = ACTIONS(6152),
    [anon_sym_while] = ACTIONS(6152),
    [anon_sym_SQUOTE] = ACTIONS(6154),
    [anon_sym_try] = ACTIONS(6152),
    [anon_sym_LT] = ACTIONS(6154),
    [sym_number] = ACTIONS(6154),
    [anon_sym_SLASH] = ACTIONS(6152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6152),
    [anon_sym_function] = ACTIONS(6152),
    [sym_undefined] = ACTIONS(6152),
    [anon_sym_new] = ACTIONS(6152),
    [ts_builtin_sym_end] = ACTIONS(6154),
    [anon_sym_let] = ACTIONS(6152),
    [anon_sym_PLUS] = ACTIONS(6152),
    [anon_sym_export] = ACTIONS(6152),
    [anon_sym_do] = ACTIONS(6152),
    [anon_sym_TILDE] = ACTIONS(6154),
    [anon_sym_with] = ACTIONS(6152),
  },
  [2078] = {
    [anon_sym_COMMA] = ACTIONS(6156),
    [anon_sym_RBRACE] = ACTIONS(6156),
    [sym_comment] = ACTIONS(3),
  },
  [2079] = {
    [sym_computed_property_name] = STATE(1172),
    [sym__enum_member] = STATE(2939),
    [sym__property_name] = STATE(1172),
    [sym_string] = STATE(1172),
    [sym_enum_assignment] = STATE(2939),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACE] = ACTIONS(6158),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(2431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_async] = ACTIONS(1230),
  },
  [2080] = {
    [sym_identifier] = ACTIONS(6160),
    [anon_sym_BQUOTE] = ACTIONS(6162),
    [anon_sym_debugger] = ACTIONS(6160),
    [anon_sym_symbol] = ACTIONS(6160),
    [anon_sym_AT] = ACTIONS(6162),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_void] = ACTIONS(6160),
    [anon_sym_break] = ACTIONS(6160),
    [anon_sym_const] = ACTIONS(6160),
    [sym_super] = ACTIONS(6160),
    [anon_sym_return] = ACTIONS(6160),
    [anon_sym_private] = ACTIONS(6160),
    [anon_sym_get] = ACTIONS(6160),
    [anon_sym_RBRACE] = ACTIONS(6162),
    [anon_sym_interface] = ACTIONS(6160),
    [anon_sym_default] = ACTIONS(6160),
    [anon_sym_enum] = ACTIONS(6160),
    [anon_sym_delete] = ACTIONS(6160),
    [anon_sym_continue] = ACTIONS(6160),
    [anon_sym_DASH_DASH] = ACTIONS(6162),
    [anon_sym_if] = ACTIONS(6160),
    [anon_sym_this] = ACTIONS(6160),
    [anon_sym_yield] = ACTIONS(6160),
    [sym_true] = ACTIONS(6160),
    [anon_sym_throw] = ACTIONS(6160),
    [anon_sym_protected] = ACTIONS(6160),
    [anon_sym_abstract] = ACTIONS(6160),
    [anon_sym_set] = ACTIONS(6160),
    [anon_sym_type] = ACTIONS(6160),
    [anon_sym_import] = ACTIONS(6160),
    [anon_sym_namespace] = ACTIONS(6160),
    [anon_sym_PLUS_PLUS] = ACTIONS(6162),
    [anon_sym_await] = ACTIONS(6160),
    [anon_sym_DQUOTE] = ACTIONS(6162),
    [anon_sym_else] = ACTIONS(6160),
    [anon_sym_BANG] = ACTIONS(6162),
    [anon_sym_for] = ACTIONS(6160),
    [anon_sym_LBRACK] = ACTIONS(6162),
    [sym_false] = ACTIONS(6160),
    [anon_sym_SEMI] = ACTIONS(6162),
    [anon_sym_case] = ACTIONS(6160),
    [anon_sym_module] = ACTIONS(6160),
    [anon_sym_number] = ACTIONS(6160),
    [anon_sym_class] = ACTIONS(6160),
    [anon_sym_declare] = ACTIONS(6160),
    [anon_sym_typeof] = ACTIONS(6160),
    [anon_sym_LBRACE] = ACTIONS(6162),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_LPAREN] = ACTIONS(6162),
    [sym_null] = ACTIONS(6160),
    [anon_sym_any] = ACTIONS(6160),
    [anon_sym_boolean] = ACTIONS(6160),
    [anon_sym_async] = ACTIONS(6160),
    [anon_sym_public] = ACTIONS(6160),
    [anon_sym_var] = ACTIONS(6160),
    [anon_sym_while] = ACTIONS(6160),
    [anon_sym_SQUOTE] = ACTIONS(6162),
    [anon_sym_try] = ACTIONS(6160),
    [anon_sym_LT] = ACTIONS(6162),
    [sym_number] = ACTIONS(6162),
    [anon_sym_SLASH] = ACTIONS(6160),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6160),
    [anon_sym_function] = ACTIONS(6160),
    [sym_undefined] = ACTIONS(6160),
    [anon_sym_new] = ACTIONS(6160),
    [ts_builtin_sym_end] = ACTIONS(6162),
    [anon_sym_let] = ACTIONS(6160),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_export] = ACTIONS(6160),
    [anon_sym_do] = ACTIONS(6160),
    [anon_sym_TILDE] = ACTIONS(6162),
    [anon_sym_with] = ACTIONS(6160),
  },
  [2081] = {
    [aux_sym_enum_body_repeat1] = STATE(2941),
    [anon_sym_COMMA] = ACTIONS(6164),
    [anon_sym_RBRACE] = ACTIONS(6158),
    [sym_comment] = ACTIONS(3),
  },
  [2082] = {
    [sym_identifier] = ACTIONS(5210),
    [anon_sym_BQUOTE] = ACTIONS(5208),
    [anon_sym_debugger] = ACTIONS(5210),
    [anon_sym_symbol] = ACTIONS(5210),
    [anon_sym_AT] = ACTIONS(5208),
    [anon_sym_DASH] = ACTIONS(5210),
    [anon_sym_void] = ACTIONS(5210),
    [anon_sym_break] = ACTIONS(5210),
    [anon_sym_const] = ACTIONS(5210),
    [sym_super] = ACTIONS(5210),
    [anon_sym_return] = ACTIONS(5210),
    [anon_sym_private] = ACTIONS(5210),
    [anon_sym_get] = ACTIONS(5210),
    [anon_sym_interface] = ACTIONS(5210),
    [anon_sym_enum] = ACTIONS(5210),
    [anon_sym_delete] = ACTIONS(5210),
    [anon_sym_continue] = ACTIONS(5210),
    [anon_sym_DASH_DASH] = ACTIONS(5208),
    [anon_sym_if] = ACTIONS(5210),
    [anon_sym_this] = ACTIONS(5210),
    [anon_sym_yield] = ACTIONS(5210),
    [sym_true] = ACTIONS(5210),
    [anon_sym_throw] = ACTIONS(5210),
    [anon_sym_protected] = ACTIONS(5210),
    [anon_sym_abstract] = ACTIONS(5210),
    [anon_sym_set] = ACTIONS(5210),
    [anon_sym_type] = ACTIONS(5210),
    [anon_sym_import] = ACTIONS(5210),
    [anon_sym_namespace] = ACTIONS(5210),
    [anon_sym_PLUS_PLUS] = ACTIONS(5208),
    [anon_sym_await] = ACTIONS(5210),
    [anon_sym_DQUOTE] = ACTIONS(5208),
    [anon_sym_BANG] = ACTIONS(5208),
    [anon_sym_for] = ACTIONS(5210),
    [anon_sym_LBRACK] = ACTIONS(5208),
    [sym_false] = ACTIONS(5210),
    [anon_sym_SEMI] = ACTIONS(5208),
    [anon_sym_module] = ACTIONS(5210),
    [anon_sym_number] = ACTIONS(5210),
    [anon_sym_class] = ACTIONS(5210),
    [anon_sym_declare] = ACTIONS(5210),
    [anon_sym_typeof] = ACTIONS(5210),
    [anon_sym_LBRACE] = ACTIONS(5208),
    [anon_sym_switch] = ACTIONS(5210),
    [anon_sym_LPAREN] = ACTIONS(5208),
    [sym_null] = ACTIONS(5210),
    [anon_sym_any] = ACTIONS(5210),
    [anon_sym_boolean] = ACTIONS(5210),
    [anon_sym_async] = ACTIONS(5210),
    [anon_sym_public] = ACTIONS(5210),
    [anon_sym_var] = ACTIONS(5210),
    [anon_sym_while] = ACTIONS(5210),
    [anon_sym_SQUOTE] = ACTIONS(5208),
    [anon_sym_try] = ACTIONS(5210),
    [anon_sym_LT] = ACTIONS(5208),
    [sym_number] = ACTIONS(5208),
    [anon_sym_SLASH] = ACTIONS(5210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5210),
    [anon_sym_function] = ACTIONS(5210),
    [sym_undefined] = ACTIONS(5210),
    [anon_sym_new] = ACTIONS(5210),
    [anon_sym_let] = ACTIONS(5210),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_export] = ACTIONS(5210),
    [anon_sym_do] = ACTIONS(5210),
    [anon_sym_TILDE] = ACTIONS(5208),
    [anon_sym_with] = ACTIONS(5210),
  },
  [2083] = {
    [sym_identifier] = ACTIONS(2455),
    [anon_sym_BQUOTE] = ACTIONS(2457),
    [anon_sym_debugger] = ACTIONS(2455),
    [anon_sym_symbol] = ACTIONS(2455),
    [anon_sym_AT] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2455),
    [anon_sym_void] = ACTIONS(2455),
    [anon_sym_break] = ACTIONS(2455),
    [anon_sym_const] = ACTIONS(2455),
    [sym_super] = ACTIONS(2455),
    [anon_sym_return] = ACTIONS(2455),
    [anon_sym_private] = ACTIONS(2455),
    [anon_sym_get] = ACTIONS(2455),
    [anon_sym_interface] = ACTIONS(2455),
    [anon_sym_enum] = ACTIONS(2455),
    [anon_sym_delete] = ACTIONS(2455),
    [anon_sym_continue] = ACTIONS(2455),
    [anon_sym_DASH_DASH] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2455),
    [anon_sym_this] = ACTIONS(2455),
    [anon_sym_yield] = ACTIONS(2455),
    [sym_true] = ACTIONS(2455),
    [anon_sym_throw] = ACTIONS(2455),
    [anon_sym_protected] = ACTIONS(2455),
    [anon_sym_abstract] = ACTIONS(2455),
    [anon_sym_set] = ACTIONS(2455),
    [anon_sym_type] = ACTIONS(2455),
    [anon_sym_import] = ACTIONS(2455),
    [anon_sym_namespace] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2457),
    [anon_sym_await] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [anon_sym_else] = ACTIONS(6166),
    [anon_sym_BANG] = ACTIONS(2457),
    [anon_sym_for] = ACTIONS(2455),
    [anon_sym_LBRACK] = ACTIONS(2457),
    [sym_false] = ACTIONS(2455),
    [anon_sym_SEMI] = ACTIONS(2457),
    [anon_sym_module] = ACTIONS(2455),
    [anon_sym_number] = ACTIONS(2455),
    [anon_sym_class] = ACTIONS(2455),
    [anon_sym_declare] = ACTIONS(2455),
    [anon_sym_typeof] = ACTIONS(2455),
    [anon_sym_LBRACE] = ACTIONS(2457),
    [anon_sym_switch] = ACTIONS(2455),
    [anon_sym_LPAREN] = ACTIONS(2457),
    [sym_null] = ACTIONS(2455),
    [anon_sym_any] = ACTIONS(2455),
    [anon_sym_boolean] = ACTIONS(2455),
    [anon_sym_async] = ACTIONS(2455),
    [anon_sym_public] = ACTIONS(2455),
    [anon_sym_var] = ACTIONS(2455),
    [anon_sym_while] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_try] = ACTIONS(2455),
    [anon_sym_LT] = ACTIONS(2457),
    [sym_number] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2455),
    [anon_sym_function] = ACTIONS(2455),
    [sym_undefined] = ACTIONS(2455),
    [anon_sym_new] = ACTIONS(2455),
    [ts_builtin_sym_end] = ACTIONS(2457),
    [anon_sym_let] = ACTIONS(2455),
    [anon_sym_PLUS] = ACTIONS(2455),
    [anon_sym_export] = ACTIONS(2455),
    [anon_sym_do] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2457),
    [anon_sym_with] = ACTIONS(2455),
  },
  [2084] = {
    [sym_array] = STATE(2945),
    [sym_object] = STATE(2946),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(6168),
    [anon_sym_var] = ACTIONS(6170),
    [anon_sym_const] = ACTIONS(6170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_let] = ACTIONS(6170),
  },
  [2085] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(6172),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6174),
  },
  [2086] = {
    [sym_variable_declarator] = STATE(97),
    [sym_array] = STATE(2950),
    [sym_object] = STATE(2951),
    [sym_identifier] = ACTIONS(6176),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [2087] = {
    [sym_variable_declarator] = STATE(258),
    [sym_array] = STATE(2950),
    [sym_object] = STATE(2951),
    [sym_identifier] = ACTIONS(6176),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [2088] = {
    [sym_new_expression] = STATE(59),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_yield_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_internal_module] = STATE(59),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(59),
    [sym_await_expression] = STATE(59),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2952),
    [sym_sequence_expression] = STATE(62),
    [sym_string] = STATE(59),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(2952),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(59),
    [sym_generator_function] = STATE(59),
    [sym_call_expression] = STATE(59),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(59),
    [sym_ternary_expression] = STATE(59),
    [sym_binary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(59),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [2089] = {
    [sym__initializer] = STATE(321),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(6178),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6180),
  },
  [2090] = {
    [sym__initializer] = STATE(336),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(6182),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6184),
  },
  [2091] = {
    [sym_identifier] = ACTIONS(6186),
    [sym_comment] = ACTIONS(3),
  },
  [2092] = {
    [sym_identifier] = ACTIONS(6188),
    [anon_sym_BQUOTE] = ACTIONS(6190),
    [anon_sym_debugger] = ACTIONS(6188),
    [anon_sym_symbol] = ACTIONS(6188),
    [anon_sym_AT] = ACTIONS(6190),
    [anon_sym_DASH] = ACTIONS(6188),
    [anon_sym_void] = ACTIONS(6188),
    [anon_sym_break] = ACTIONS(6188),
    [anon_sym_const] = ACTIONS(6188),
    [sym_super] = ACTIONS(6188),
    [anon_sym_return] = ACTIONS(6188),
    [anon_sym_private] = ACTIONS(6188),
    [anon_sym_get] = ACTIONS(6188),
    [anon_sym_RBRACE] = ACTIONS(6190),
    [anon_sym_interface] = ACTIONS(6188),
    [anon_sym_default] = ACTIONS(6188),
    [anon_sym_enum] = ACTIONS(6188),
    [anon_sym_delete] = ACTIONS(6188),
    [anon_sym_continue] = ACTIONS(6188),
    [anon_sym_DASH_DASH] = ACTIONS(6190),
    [anon_sym_if] = ACTIONS(6188),
    [anon_sym_this] = ACTIONS(6188),
    [anon_sym_yield] = ACTIONS(6188),
    [sym_true] = ACTIONS(6188),
    [anon_sym_throw] = ACTIONS(6188),
    [anon_sym_protected] = ACTIONS(6188),
    [anon_sym_abstract] = ACTIONS(6188),
    [anon_sym_set] = ACTIONS(6188),
    [anon_sym_type] = ACTIONS(6188),
    [anon_sym_import] = ACTIONS(6188),
    [anon_sym_namespace] = ACTIONS(6188),
    [anon_sym_PLUS_PLUS] = ACTIONS(6190),
    [anon_sym_await] = ACTIONS(6188),
    [anon_sym_DQUOTE] = ACTIONS(6190),
    [anon_sym_else] = ACTIONS(6188),
    [anon_sym_BANG] = ACTIONS(6190),
    [anon_sym_for] = ACTIONS(6188),
    [anon_sym_LBRACK] = ACTIONS(6190),
    [sym_false] = ACTIONS(6188),
    [anon_sym_SEMI] = ACTIONS(6190),
    [anon_sym_case] = ACTIONS(6188),
    [anon_sym_module] = ACTIONS(6188),
    [anon_sym_number] = ACTIONS(6188),
    [anon_sym_class] = ACTIONS(6188),
    [anon_sym_declare] = ACTIONS(6188),
    [anon_sym_typeof] = ACTIONS(6188),
    [anon_sym_LBRACE] = ACTIONS(6190),
    [anon_sym_switch] = ACTIONS(6188),
    [anon_sym_LPAREN] = ACTIONS(6190),
    [sym_null] = ACTIONS(6188),
    [anon_sym_any] = ACTIONS(6188),
    [anon_sym_boolean] = ACTIONS(6188),
    [anon_sym_async] = ACTIONS(6188),
    [anon_sym_public] = ACTIONS(6188),
    [anon_sym_var] = ACTIONS(6188),
    [anon_sym_while] = ACTIONS(6188),
    [anon_sym_SQUOTE] = ACTIONS(6190),
    [anon_sym_try] = ACTIONS(6188),
    [anon_sym_LT] = ACTIONS(6190),
    [sym_number] = ACTIONS(6190),
    [anon_sym_SLASH] = ACTIONS(6188),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6188),
    [anon_sym_function] = ACTIONS(6188),
    [sym_undefined] = ACTIONS(6188),
    [anon_sym_new] = ACTIONS(6188),
    [ts_builtin_sym_end] = ACTIONS(6190),
    [anon_sym_let] = ACTIONS(6188),
    [anon_sym_PLUS] = ACTIONS(6188),
    [anon_sym_export] = ACTIONS(6188),
    [anon_sym_do] = ACTIONS(6188),
    [anon_sym_TILDE] = ACTIONS(6190),
    [anon_sym_with] = ACTIONS(6188),
  },
  [2093] = {
    [sym_identifier] = ACTIONS(2865),
    [anon_sym_BQUOTE] = ACTIONS(2863),
    [anon_sym_debugger] = ACTIONS(2865),
    [anon_sym_symbol] = ACTIONS(2865),
    [anon_sym_AT] = ACTIONS(2863),
    [anon_sym_DASH] = ACTIONS(2865),
    [anon_sym_void] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2865),
    [anon_sym_const] = ACTIONS(2865),
    [sym_super] = ACTIONS(2865),
    [anon_sym_return] = ACTIONS(2865),
    [anon_sym_private] = ACTIONS(2865),
    [anon_sym_get] = ACTIONS(2865),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [anon_sym_interface] = ACTIONS(2865),
    [anon_sym_default] = ACTIONS(2865),
    [anon_sym_enum] = ACTIONS(2865),
    [anon_sym_delete] = ACTIONS(2865),
    [anon_sym_continue] = ACTIONS(2865),
    [anon_sym_DASH_DASH] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2865),
    [anon_sym_this] = ACTIONS(2865),
    [anon_sym_yield] = ACTIONS(2865),
    [sym_true] = ACTIONS(2865),
    [anon_sym_throw] = ACTIONS(2865),
    [anon_sym_protected] = ACTIONS(2865),
    [anon_sym_abstract] = ACTIONS(2865),
    [anon_sym_set] = ACTIONS(2865),
    [anon_sym_type] = ACTIONS(2865),
    [anon_sym_import] = ACTIONS(2865),
    [anon_sym_namespace] = ACTIONS(2865),
    [anon_sym_PLUS_PLUS] = ACTIONS(2863),
    [anon_sym_await] = ACTIONS(2865),
    [anon_sym_DQUOTE] = ACTIONS(2863),
    [anon_sym_else] = ACTIONS(2865),
    [anon_sym_BANG] = ACTIONS(2863),
    [anon_sym_for] = ACTIONS(2865),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [sym_false] = ACTIONS(2865),
    [anon_sym_SEMI] = ACTIONS(2863),
    [anon_sym_case] = ACTIONS(2865),
    [anon_sym_module] = ACTIONS(2865),
    [anon_sym_number] = ACTIONS(2865),
    [anon_sym_class] = ACTIONS(2865),
    [anon_sym_declare] = ACTIONS(2865),
    [anon_sym_typeof] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(2863),
    [anon_sym_switch] = ACTIONS(2865),
    [anon_sym_LPAREN] = ACTIONS(2863),
    [sym_null] = ACTIONS(2865),
    [anon_sym_any] = ACTIONS(2865),
    [anon_sym_boolean] = ACTIONS(2865),
    [anon_sym_async] = ACTIONS(2865),
    [anon_sym_public] = ACTIONS(2865),
    [anon_sym_var] = ACTIONS(2865),
    [anon_sym_while] = ACTIONS(2865),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_try] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2863),
    [sym_number] = ACTIONS(2863),
    [anon_sym_SLASH] = ACTIONS(2865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2865),
    [anon_sym_function] = ACTIONS(2865),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_new] = ACTIONS(2865),
    [ts_builtin_sym_end] = ACTIONS(2863),
    [anon_sym_let] = ACTIONS(2865),
    [anon_sym_PLUS] = ACTIONS(2865),
    [anon_sym_export] = ACTIONS(2865),
    [anon_sym_do] = ACTIONS(2865),
    [anon_sym_TILDE] = ACTIONS(2863),
    [anon_sym_with] = ACTIONS(2865),
  },
  [2094] = {
    [sym_public_field_definition] = STATE(640),
    [sym__property_name] = STATE(641),
    [sym_decorator] = STATE(1404),
    [sym_method_signature] = STATE(640),
    [sym_accessibility_modifier] = STATE(642),
    [sym_abstract_method_signature] = STATE(640),
    [sym_computed_property_name] = STATE(641),
    [aux_sym_class_body_repeat1] = STATE(1404),
    [sym_index_signature] = STATE(640),
    [sym_string] = STATE(641),
    [sym_method_definition] = STATE(644),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1145),
    [anon_sym_get] = ACTIONS(1147),
    [anon_sym_RBRACE] = ACTIONS(6192),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [sym_number] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(1147),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [2095] = {
    [sym_identifier] = ACTIONS(6194),
    [anon_sym_BQUOTE] = ACTIONS(6196),
    [anon_sym_debugger] = ACTIONS(6194),
    [anon_sym_symbol] = ACTIONS(6194),
    [anon_sym_AT] = ACTIONS(6196),
    [anon_sym_DASH] = ACTIONS(6194),
    [anon_sym_void] = ACTIONS(6194),
    [anon_sym_break] = ACTIONS(6194),
    [anon_sym_const] = ACTIONS(6194),
    [sym_super] = ACTIONS(6194),
    [anon_sym_return] = ACTIONS(6194),
    [anon_sym_private] = ACTIONS(6194),
    [anon_sym_get] = ACTIONS(6194),
    [anon_sym_RBRACE] = ACTIONS(6196),
    [anon_sym_interface] = ACTIONS(6194),
    [anon_sym_default] = ACTIONS(6194),
    [anon_sym_enum] = ACTIONS(6194),
    [anon_sym_delete] = ACTIONS(6194),
    [anon_sym_continue] = ACTIONS(6194),
    [anon_sym_DASH_DASH] = ACTIONS(6196),
    [anon_sym_if] = ACTIONS(6194),
    [anon_sym_this] = ACTIONS(6194),
    [anon_sym_yield] = ACTIONS(6194),
    [sym_true] = ACTIONS(6194),
    [anon_sym_throw] = ACTIONS(6194),
    [anon_sym_protected] = ACTIONS(6194),
    [anon_sym_abstract] = ACTIONS(6194),
    [anon_sym_set] = ACTIONS(6194),
    [anon_sym_type] = ACTIONS(6194),
    [anon_sym_import] = ACTIONS(6194),
    [anon_sym_namespace] = ACTIONS(6194),
    [anon_sym_PLUS_PLUS] = ACTIONS(6196),
    [anon_sym_await] = ACTIONS(6194),
    [anon_sym_DQUOTE] = ACTIONS(6196),
    [anon_sym_else] = ACTIONS(6194),
    [anon_sym_BANG] = ACTIONS(6196),
    [anon_sym_for] = ACTIONS(6194),
    [anon_sym_LBRACK] = ACTIONS(6196),
    [sym_false] = ACTIONS(6194),
    [anon_sym_SEMI] = ACTIONS(6196),
    [anon_sym_case] = ACTIONS(6194),
    [anon_sym_module] = ACTIONS(6194),
    [anon_sym_number] = ACTIONS(6194),
    [anon_sym_class] = ACTIONS(6194),
    [anon_sym_declare] = ACTIONS(6194),
    [anon_sym_typeof] = ACTIONS(6194),
    [anon_sym_LBRACE] = ACTIONS(6196),
    [anon_sym_switch] = ACTIONS(6194),
    [anon_sym_LPAREN] = ACTIONS(6196),
    [sym_null] = ACTIONS(6194),
    [anon_sym_any] = ACTIONS(6194),
    [anon_sym_boolean] = ACTIONS(6194),
    [anon_sym_async] = ACTIONS(6194),
    [anon_sym_public] = ACTIONS(6194),
    [anon_sym_var] = ACTIONS(6194),
    [anon_sym_while] = ACTIONS(6194),
    [anon_sym_SQUOTE] = ACTIONS(6196),
    [anon_sym_try] = ACTIONS(6194),
    [anon_sym_LT] = ACTIONS(6196),
    [sym_number] = ACTIONS(6196),
    [anon_sym_SLASH] = ACTIONS(6194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6194),
    [anon_sym_function] = ACTIONS(6194),
    [sym_undefined] = ACTIONS(6194),
    [anon_sym_new] = ACTIONS(6194),
    [ts_builtin_sym_end] = ACTIONS(6196),
    [anon_sym_let] = ACTIONS(6194),
    [anon_sym_PLUS] = ACTIONS(6194),
    [anon_sym_export] = ACTIONS(6194),
    [anon_sym_do] = ACTIONS(6194),
    [anon_sym_TILDE] = ACTIONS(6196),
    [anon_sym_with] = ACTIONS(6194),
  },
  [2096] = {
    [sym_class_body] = STATE(2959),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2467),
  },
  [2097] = {
    [sym_union_type] = STATE(2963),
    [sym__type] = STATE(2963),
    [sym_constructor_type] = STATE(2963),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2964),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2963),
    [sym_function_type] = STATE(2963),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2965),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(6198),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(6202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [2098] = {
    [sym_formal_parameters] = STATE(2966),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2099] = {
    [anon_sym_EQ_GT] = ACTIONS(6204),
    [sym_comment] = ACTIONS(3),
  },
  [2100] = {
    [sym_identifier] = ACTIONS(6206),
    [anon_sym_BQUOTE] = ACTIONS(6208),
    [anon_sym_debugger] = ACTIONS(6206),
    [anon_sym_symbol] = ACTIONS(6206),
    [anon_sym_AT] = ACTIONS(6208),
    [anon_sym_DASH] = ACTIONS(6206),
    [anon_sym_void] = ACTIONS(6206),
    [anon_sym_break] = ACTIONS(6206),
    [anon_sym_const] = ACTIONS(6206),
    [sym_super] = ACTIONS(6206),
    [anon_sym_return] = ACTIONS(6206),
    [anon_sym_private] = ACTIONS(6206),
    [anon_sym_get] = ACTIONS(6206),
    [anon_sym_RBRACE] = ACTIONS(6208),
    [anon_sym_interface] = ACTIONS(6206),
    [anon_sym_default] = ACTIONS(6206),
    [anon_sym_enum] = ACTIONS(6206),
    [anon_sym_delete] = ACTIONS(6206),
    [anon_sym_continue] = ACTIONS(6206),
    [anon_sym_DASH_DASH] = ACTIONS(6208),
    [anon_sym_if] = ACTIONS(6206),
    [anon_sym_this] = ACTIONS(6206),
    [anon_sym_yield] = ACTIONS(6206),
    [sym_true] = ACTIONS(6206),
    [anon_sym_throw] = ACTIONS(6206),
    [anon_sym_protected] = ACTIONS(6206),
    [anon_sym_abstract] = ACTIONS(6206),
    [anon_sym_set] = ACTIONS(6206),
    [anon_sym_type] = ACTIONS(6206),
    [anon_sym_import] = ACTIONS(6206),
    [anon_sym_namespace] = ACTIONS(6206),
    [anon_sym_PLUS_PLUS] = ACTIONS(6208),
    [anon_sym_await] = ACTIONS(6206),
    [anon_sym_DQUOTE] = ACTIONS(6208),
    [anon_sym_else] = ACTIONS(6206),
    [anon_sym_BANG] = ACTIONS(6208),
    [anon_sym_for] = ACTIONS(6206),
    [anon_sym_LBRACK] = ACTIONS(6208),
    [sym_false] = ACTIONS(6206),
    [anon_sym_SEMI] = ACTIONS(6208),
    [anon_sym_case] = ACTIONS(6206),
    [anon_sym_module] = ACTIONS(6206),
    [anon_sym_number] = ACTIONS(6206),
    [anon_sym_class] = ACTIONS(6206),
    [anon_sym_declare] = ACTIONS(6206),
    [anon_sym_typeof] = ACTIONS(6206),
    [anon_sym_LBRACE] = ACTIONS(6208),
    [anon_sym_switch] = ACTIONS(6206),
    [anon_sym_LPAREN] = ACTIONS(6208),
    [sym_null] = ACTIONS(6206),
    [anon_sym_any] = ACTIONS(6206),
    [anon_sym_boolean] = ACTIONS(6206),
    [anon_sym_async] = ACTIONS(6206),
    [anon_sym_public] = ACTIONS(6206),
    [anon_sym_var] = ACTIONS(6206),
    [anon_sym_while] = ACTIONS(6206),
    [anon_sym_SQUOTE] = ACTIONS(6208),
    [anon_sym_try] = ACTIONS(6206),
    [anon_sym_LT] = ACTIONS(6208),
    [sym_number] = ACTIONS(6208),
    [anon_sym_SLASH] = ACTIONS(6206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6206),
    [anon_sym_function] = ACTIONS(6206),
    [sym_undefined] = ACTIONS(6206),
    [anon_sym_new] = ACTIONS(6206),
    [ts_builtin_sym_end] = ACTIONS(6208),
    [anon_sym_let] = ACTIONS(6206),
    [anon_sym_PLUS] = ACTIONS(6206),
    [anon_sym_export] = ACTIONS(6206),
    [anon_sym_do] = ACTIONS(6206),
    [anon_sym_TILDE] = ACTIONS(6208),
    [anon_sym_with] = ACTIONS(6206),
  },
  [2101] = {
    [sym_union_type] = STATE(2790),
    [sym__type] = STATE(2790),
    [sym_constructor_type] = STATE(2790),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1198),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2790),
    [sym_function_type] = STATE(2790),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1199),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2475),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [2102] = {
    [sym_union_type] = STATE(2791),
    [sym__type] = STATE(2791),
    [sym_constructor_type] = STATE(2791),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1198),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2791),
    [sym_function_type] = STATE(2791),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1199),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2475),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [2103] = {
    [anon_sym_EQ_GT] = ACTIONS(6210),
    [sym_comment] = ACTIONS(3),
  },
  [2104] = {
    [sym_union_type] = STATE(2969),
    [sym__type] = STATE(2969),
    [sym_constructor_type] = STATE(2969),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1198),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2969),
    [sym_function_type] = STATE(2969),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1199),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2475),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [2105] = {
    [sym__automatic_semicolon] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_PIPE] = ACTIONS(4447),
    [anon_sym_SEMI] = ACTIONS(6212),
    [sym_comment] = ACTIONS(3),
  },
  [2106] = {
    [sym_string] = STATE(2971),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(282),
  },
  [2107] = {
    [sym_identifier] = ACTIONS(6214),
    [anon_sym_BQUOTE] = ACTIONS(6216),
    [anon_sym_debugger] = ACTIONS(6214),
    [anon_sym_symbol] = ACTIONS(6214),
    [anon_sym_AT] = ACTIONS(6216),
    [anon_sym_DASH] = ACTIONS(6214),
    [anon_sym_void] = ACTIONS(6214),
    [anon_sym_break] = ACTIONS(6214),
    [anon_sym_const] = ACTIONS(6214),
    [sym_super] = ACTIONS(6214),
    [anon_sym_return] = ACTIONS(6214),
    [anon_sym_private] = ACTIONS(6214),
    [anon_sym_get] = ACTIONS(6214),
    [anon_sym_RBRACE] = ACTIONS(6216),
    [anon_sym_interface] = ACTIONS(6214),
    [anon_sym_default] = ACTIONS(6214),
    [anon_sym_enum] = ACTIONS(6214),
    [anon_sym_delete] = ACTIONS(6214),
    [anon_sym_continue] = ACTIONS(6214),
    [anon_sym_DASH_DASH] = ACTIONS(6216),
    [anon_sym_if] = ACTIONS(6214),
    [anon_sym_this] = ACTIONS(6214),
    [anon_sym_yield] = ACTIONS(6214),
    [sym_true] = ACTIONS(6214),
    [anon_sym_throw] = ACTIONS(6214),
    [anon_sym_protected] = ACTIONS(6214),
    [anon_sym_abstract] = ACTIONS(6214),
    [anon_sym_set] = ACTIONS(6214),
    [anon_sym_type] = ACTIONS(6214),
    [anon_sym_import] = ACTIONS(6214),
    [anon_sym_namespace] = ACTIONS(6214),
    [anon_sym_PLUS_PLUS] = ACTIONS(6216),
    [anon_sym_await] = ACTIONS(6214),
    [anon_sym_DQUOTE] = ACTIONS(6216),
    [anon_sym_else] = ACTIONS(6214),
    [anon_sym_BANG] = ACTIONS(6216),
    [anon_sym_for] = ACTIONS(6214),
    [anon_sym_LBRACK] = ACTIONS(6216),
    [sym_false] = ACTIONS(6214),
    [anon_sym_SEMI] = ACTIONS(6216),
    [anon_sym_case] = ACTIONS(6214),
    [anon_sym_module] = ACTIONS(6214),
    [anon_sym_number] = ACTIONS(6214),
    [anon_sym_class] = ACTIONS(6214),
    [anon_sym_declare] = ACTIONS(6214),
    [anon_sym_typeof] = ACTIONS(6214),
    [anon_sym_LBRACE] = ACTIONS(6216),
    [anon_sym_switch] = ACTIONS(6214),
    [anon_sym_LPAREN] = ACTIONS(6216),
    [sym_null] = ACTIONS(6214),
    [anon_sym_any] = ACTIONS(6214),
    [anon_sym_boolean] = ACTIONS(6214),
    [anon_sym_async] = ACTIONS(6214),
    [anon_sym_public] = ACTIONS(6214),
    [anon_sym_var] = ACTIONS(6214),
    [anon_sym_while] = ACTIONS(6214),
    [anon_sym_SQUOTE] = ACTIONS(6216),
    [anon_sym_try] = ACTIONS(6214),
    [anon_sym_LT] = ACTIONS(6216),
    [sym_number] = ACTIONS(6216),
    [anon_sym_SLASH] = ACTIONS(6214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6214),
    [anon_sym_function] = ACTIONS(6214),
    [sym_undefined] = ACTIONS(6214),
    [anon_sym_new] = ACTIONS(6214),
    [ts_builtin_sym_end] = ACTIONS(6216),
    [anon_sym_let] = ACTIONS(6214),
    [anon_sym_PLUS] = ACTIONS(6214),
    [anon_sym_export] = ACTIONS(6214),
    [anon_sym_do] = ACTIONS(6214),
    [anon_sym_TILDE] = ACTIONS(6216),
    [anon_sym_with] = ACTIONS(6214),
  },
  [2108] = {
    [sym_identifier] = ACTIONS(6218),
    [anon_sym_BQUOTE] = ACTIONS(6220),
    [anon_sym_debugger] = ACTIONS(6218),
    [anon_sym_symbol] = ACTIONS(6218),
    [anon_sym_AT] = ACTIONS(6220),
    [anon_sym_DASH] = ACTIONS(6218),
    [anon_sym_void] = ACTIONS(6218),
    [anon_sym_break] = ACTIONS(6218),
    [anon_sym_const] = ACTIONS(6218),
    [sym_super] = ACTIONS(6218),
    [anon_sym_return] = ACTIONS(6218),
    [anon_sym_private] = ACTIONS(6218),
    [anon_sym_get] = ACTIONS(6218),
    [anon_sym_RBRACE] = ACTIONS(6220),
    [anon_sym_interface] = ACTIONS(6218),
    [anon_sym_default] = ACTIONS(6218),
    [anon_sym_enum] = ACTIONS(6218),
    [anon_sym_delete] = ACTIONS(6218),
    [anon_sym_continue] = ACTIONS(6218),
    [anon_sym_DASH_DASH] = ACTIONS(6220),
    [anon_sym_if] = ACTIONS(6218),
    [anon_sym_this] = ACTIONS(6218),
    [anon_sym_yield] = ACTIONS(6218),
    [sym_true] = ACTIONS(6218),
    [anon_sym_throw] = ACTIONS(6218),
    [anon_sym_protected] = ACTIONS(6218),
    [anon_sym_abstract] = ACTIONS(6218),
    [anon_sym_set] = ACTIONS(6218),
    [anon_sym_type] = ACTIONS(6218),
    [anon_sym_import] = ACTIONS(6218),
    [anon_sym_namespace] = ACTIONS(6218),
    [anon_sym_PLUS_PLUS] = ACTIONS(6220),
    [anon_sym_await] = ACTIONS(6218),
    [anon_sym_DQUOTE] = ACTIONS(6220),
    [anon_sym_else] = ACTIONS(6218),
    [anon_sym_BANG] = ACTIONS(6220),
    [anon_sym_for] = ACTIONS(6218),
    [anon_sym_LBRACK] = ACTIONS(6220),
    [sym_false] = ACTIONS(6218),
    [anon_sym_SEMI] = ACTIONS(6220),
    [anon_sym_case] = ACTIONS(6218),
    [anon_sym_module] = ACTIONS(6218),
    [anon_sym_number] = ACTIONS(6218),
    [anon_sym_class] = ACTIONS(6218),
    [anon_sym_declare] = ACTIONS(6218),
    [anon_sym_typeof] = ACTIONS(6218),
    [anon_sym_LBRACE] = ACTIONS(6220),
    [anon_sym_switch] = ACTIONS(6218),
    [anon_sym_LPAREN] = ACTIONS(6220),
    [sym_null] = ACTIONS(6218),
    [anon_sym_any] = ACTIONS(6218),
    [anon_sym_boolean] = ACTIONS(6218),
    [anon_sym_async] = ACTIONS(6218),
    [anon_sym_public] = ACTIONS(6218),
    [anon_sym_var] = ACTIONS(6218),
    [anon_sym_while] = ACTIONS(6218),
    [anon_sym_SQUOTE] = ACTIONS(6220),
    [anon_sym_try] = ACTIONS(6218),
    [anon_sym_LT] = ACTIONS(6220),
    [sym_number] = ACTIONS(6220),
    [anon_sym_SLASH] = ACTIONS(6218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6218),
    [anon_sym_function] = ACTIONS(6218),
    [sym_undefined] = ACTIONS(6218),
    [anon_sym_new] = ACTIONS(6218),
    [ts_builtin_sym_end] = ACTIONS(6220),
    [anon_sym_let] = ACTIONS(6218),
    [anon_sym_PLUS] = ACTIONS(6218),
    [anon_sym_export] = ACTIONS(6218),
    [anon_sym_do] = ACTIONS(6218),
    [anon_sym_TILDE] = ACTIONS(6220),
    [anon_sym_with] = ACTIONS(6218),
  },
  [2109] = {
    [anon_sym_COMMA] = ACTIONS(6222),
    [anon_sym_RBRACE] = ACTIONS(6222),
    [sym_comment] = ACTIONS(3),
  },
  [2110] = {
    [sym_identifier] = ACTIONS(6224),
    [sym_comment] = ACTIONS(3),
  },
  [2111] = {
    [anon_sym_from] = ACTIONS(6226),
    [sym_comment] = ACTIONS(3),
  },
  [2112] = {
    [anon_sym_COMMA] = ACTIONS(6228),
    [anon_sym_RBRACE] = ACTIONS(6228),
    [sym_comment] = ACTIONS(3),
  },
  [2113] = {
    [sym__import_export_specifier] = STATE(2112),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(6230),
    [anon_sym_typeof] = ACTIONS(895),
    [anon_sym_type] = ACTIONS(895),
    [sym_comment] = ACTIONS(3),
  },
  [2114] = {
    [aux_sym_named_imports_repeat1] = STATE(2114),
    [anon_sym_COMMA] = ACTIONS(6232),
    [anon_sym_RBRACE] = ACTIONS(6235),
    [sym_comment] = ACTIONS(3),
  },
  [2115] = {
    [anon_sym_of] = ACTIONS(6237),
    [sym_comment] = ACTIONS(3),
  },
  [2116] = {
    [anon_sym_of] = ACTIONS(6239),
    [sym_comment] = ACTIONS(3),
  },
  [2117] = {
    [anon_sym_of] = ACTIONS(6241),
    [sym_comment] = ACTIONS(3),
  },
  [2118] = {
    [sym_new_expression] = STATE(2978),
    [sym_augmented_assignment_expression] = STATE(2978),
    [sym_unary_expression] = STATE(2978),
    [sym_update_expression] = STATE(2978),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(2978),
    [sym_regex] = STATE(2978),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2978),
    [sym_non_null_expression] = STATE(2978),
    [sym_as_expression] = STATE(2978),
    [sym_jsx_fragment] = STATE(2978),
    [sym_yield_expression] = STATE(2978),
    [sym_jsx_element] = STATE(2978),
    [sym_internal_module] = STATE(2978),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2978),
    [sym_await_expression] = STATE(2978),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(2978),
    [sym_this] = STATE(2978),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(2978),
    [sym_generator_function] = STATE(2978),
    [sym_call_expression] = STATE(2978),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(2978),
    [sym_ternary_expression] = STATE(2978),
    [sym_binary_expression] = STATE(2978),
    [sym_template_string] = STATE(2978),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2978),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2978),
    [sym_class] = STATE(2978),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(6243),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6243),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6245),
    [sym_true] = ACTIONS(6243),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6243),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [2119] = {
    [sym_new_expression] = STATE(2979),
    [sym_augmented_assignment_expression] = STATE(2979),
    [sym_unary_expression] = STATE(2979),
    [sym_update_expression] = STATE(2979),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(2979),
    [sym_regex] = STATE(2979),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2979),
    [sym_non_null_expression] = STATE(2979),
    [sym_as_expression] = STATE(2979),
    [sym_jsx_fragment] = STATE(2979),
    [sym_yield_expression] = STATE(2979),
    [sym_jsx_element] = STATE(2979),
    [sym_internal_module] = STATE(2979),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2979),
    [sym_await_expression] = STATE(2979),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(2979),
    [sym_this] = STATE(2979),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(2979),
    [sym_generator_function] = STATE(2979),
    [sym_call_expression] = STATE(2979),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(2979),
    [sym_ternary_expression] = STATE(2979),
    [sym_binary_expression] = STATE(2979),
    [sym_template_string] = STATE(2979),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2979),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2979),
    [sym_class] = STATE(2979),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(6247),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6247),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6249),
    [sym_true] = ACTIONS(6247),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6247),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [2120] = {
    [sym_new_expression] = STATE(2980),
    [sym_augmented_assignment_expression] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_update_expression] = STATE(2980),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(2980),
    [sym_regex] = STATE(2980),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2980),
    [sym_non_null_expression] = STATE(2980),
    [sym_as_expression] = STATE(2980),
    [sym_jsx_fragment] = STATE(2980),
    [sym_yield_expression] = STATE(2980),
    [sym_jsx_element] = STATE(2980),
    [sym_internal_module] = STATE(2980),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2980),
    [sym_await_expression] = STATE(2980),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(2980),
    [sym_this] = STATE(2980),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(2980),
    [sym_generator_function] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_template_string] = STATE(2980),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2980),
    [sym_class] = STATE(2980),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(6251),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6251),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6253),
    [sym_true] = ACTIONS(6251),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6251),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [2121] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6255),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6255),
    [anon_sym_AMP_EQ] = ACTIONS(6255),
    [anon_sym_PLUS_EQ] = ACTIONS(6255),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(6255),
    [anon_sym_STAR_EQ] = ACTIONS(6255),
    [anon_sym_PIPE_EQ] = ACTIONS(6255),
    [anon_sym_DASH_EQ] = ACTIONS(6255),
    [anon_sym_EQ_GT] = ACTIONS(6259),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6255),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6255),
    [anon_sym_GT_GT_EQ] = ACTIONS(6255),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6255),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6261),
  },
  [2122] = {
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6263),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6263),
    [anon_sym_AMP_EQ] = ACTIONS(6263),
    [anon_sym_PLUS_EQ] = ACTIONS(6263),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(6263),
    [anon_sym_STAR_EQ] = ACTIONS(6263),
    [anon_sym_PIPE_EQ] = ACTIONS(6263),
    [anon_sym_DASH_EQ] = ACTIONS(6263),
    [anon_sym_EQ_GT] = ACTIONS(6265),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6263),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6263),
    [anon_sym_GT_GT_EQ] = ACTIONS(6263),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6263),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2123] = {
    [sym_new_expression] = STATE(2987),
    [sym_augmented_assignment_expression] = STATE(2987),
    [sym_unary_expression] = STATE(2987),
    [sym_update_expression] = STATE(2987),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(2987),
    [sym_regex] = STATE(2987),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2987),
    [sym_non_null_expression] = STATE(2987),
    [sym_as_expression] = STATE(2987),
    [sym_jsx_fragment] = STATE(2987),
    [sym_yield_expression] = STATE(2987),
    [sym_jsx_element] = STATE(2987),
    [sym_internal_module] = STATE(2987),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2987),
    [sym_await_expression] = STATE(2987),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(2987),
    [sym_this] = STATE(2987),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(2987),
    [sym_generator_function] = STATE(2987),
    [sym_call_expression] = STATE(2987),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(2987),
    [sym_ternary_expression] = STATE(2987),
    [sym_binary_expression] = STATE(2987),
    [sym_template_string] = STATE(2987),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2987),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2987),
    [sym_class] = STATE(2987),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(6267),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6267),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(6269),
    [sym_true] = ACTIONS(6267),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6267),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [2124] = {
    [sym_new_expression] = STATE(2988),
    [sym_augmented_assignment_expression] = STATE(2988),
    [sym_unary_expression] = STATE(2988),
    [sym_update_expression] = STATE(2988),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(2988),
    [sym_regex] = STATE(2988),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2988),
    [sym_non_null_expression] = STATE(2988),
    [sym_as_expression] = STATE(2988),
    [sym_jsx_fragment] = STATE(2988),
    [sym_yield_expression] = STATE(2988),
    [sym_jsx_element] = STATE(2988),
    [sym_internal_module] = STATE(2988),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2988),
    [sym_await_expression] = STATE(2988),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(2988),
    [sym_this] = STATE(2988),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(2988),
    [sym_generator_function] = STATE(2988),
    [sym_call_expression] = STATE(2988),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(2988),
    [sym_ternary_expression] = STATE(2988),
    [sym_binary_expression] = STATE(2988),
    [sym_template_string] = STATE(2988),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2988),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2988),
    [sym_class] = STATE(2988),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(6271),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6271),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(6273),
    [sym_true] = ACTIONS(6271),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6271),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [2125] = {
    [sym_new_expression] = STATE(2987),
    [sym_augmented_assignment_expression] = STATE(2987),
    [sym__initializer] = STATE(79),
    [sym_unary_expression] = STATE(2987),
    [sym_update_expression] = STATE(2987),
    [sym_regex] = STATE(2987),
    [sym_meta_property] = STATE(2987),
    [sym_call_signature] = STATE(2132),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2987),
    [sym_non_null_expression] = STATE(2987),
    [sym_yield_expression] = STATE(2987),
    [sym_jsx_fragment] = STATE(2987),
    [sym_jsx_element] = STATE(2987),
    [sym_as_expression] = STATE(2987),
    [sym_internal_module] = STATE(2987),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2987),
    [sym_await_expression] = STATE(2987),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(2987),
    [sym_this] = STATE(2987),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(2987),
    [sym_generator_function] = STATE(2987),
    [sym_call_expression] = STATE(2987),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(2987),
    [sym_ternary_expression] = STATE(2987),
    [sym_binary_expression] = STATE(2987),
    [sym_template_string] = STATE(2987),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2987),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2987),
    [sym_class] = STATE(2987),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4499),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(6263),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_AMP_EQ] = ACTIONS(6263),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(6263),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(6263),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_PIPE_EQ] = ACTIONS(6263),
    [anon_sym_DASH_EQ] = ACTIONS(6263),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(6263),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(4517),
    [sym_true] = ACTIONS(6267),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_GT_GT_EQ] = ACTIONS(6263),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6263),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(4505),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(6267),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6263),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6267),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_STAR_EQ] = ACTIONS(6263),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_EQ_GT] = ACTIONS(6265),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(6269),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6263),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6267),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2126] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(79),
    [sym_formal_parameters] = STATE(57),
    [sym_call_signature] = STATE(2989),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(6275),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6263),
    [anon_sym_symbol] = ACTIONS(6277),
    [anon_sym_AMP_EQ] = ACTIONS(6263),
    [anon_sym_PLUS_EQ] = ACTIONS(6263),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_void] = ACTIONS(6277),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(6263),
    [anon_sym_private] = ACTIONS(6277),
    [anon_sym_PIPE_EQ] = ACTIONS(6263),
    [anon_sym_DASH_EQ] = ACTIONS(6263),
    [anon_sym_get] = ACTIONS(6277),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(6263),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(6277),
    [anon_sym_GT_GT_EQ] = ACTIONS(6263),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_set] = ACTIONS(6277),
    [anon_sym_type] = ACTIONS(6277),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(6277),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6263),
    [anon_sym_namespace] = ACTIONS(6277),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(6277),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6263),
    [anon_sym_number] = ACTIONS(6277),
    [anon_sym_declare] = ACTIONS(6277),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(6277),
    [anon_sym_STAR_EQ] = ACTIONS(6263),
    [anon_sym_boolean] = ACTIONS(6277),
    [anon_sym_async] = ACTIONS(6277),
    [anon_sym_public] = ACTIONS(6277),
    [anon_sym_EQ_GT] = ACTIONS(6265),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6263),
    [anon_sym_string] = ACTIONS(6277),
    [anon_sym_function] = ACTIONS(698),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(6277),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2127] = {
    [sym_new_expression] = STATE(2991),
    [sym_augmented_assignment_expression] = STATE(2991),
    [sym_unary_expression] = STATE(2991),
    [sym_update_expression] = STATE(2991),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(2991),
    [sym_regex] = STATE(2991),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2991),
    [sym_non_null_expression] = STATE(2991),
    [sym_as_expression] = STATE(2991),
    [sym_jsx_fragment] = STATE(2991),
    [sym_yield_expression] = STATE(2991),
    [sym_jsx_element] = STATE(2991),
    [sym_internal_module] = STATE(2991),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2991),
    [sym_await_expression] = STATE(2991),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(2991),
    [sym_this] = STATE(2991),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(2991),
    [sym_generator_function] = STATE(2991),
    [sym_call_expression] = STATE(2991),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(2991),
    [sym_ternary_expression] = STATE(2991),
    [sym_binary_expression] = STATE(2991),
    [sym_template_string] = STATE(2991),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2991),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2991),
    [sym_class] = STATE(2991),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(6279),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6279),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(6281),
    [sym_true] = ACTIONS(6279),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6279),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [2128] = {
    [sym_new_expression] = STATE(2992),
    [sym_augmented_assignment_expression] = STATE(2992),
    [sym_unary_expression] = STATE(2992),
    [sym_update_expression] = STATE(2992),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(2992),
    [sym_regex] = STATE(2992),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2992),
    [sym_non_null_expression] = STATE(2992),
    [sym_as_expression] = STATE(2992),
    [sym_jsx_fragment] = STATE(2992),
    [sym_yield_expression] = STATE(2992),
    [sym_jsx_element] = STATE(2992),
    [sym_internal_module] = STATE(2992),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2992),
    [sym_await_expression] = STATE(2992),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(2992),
    [sym_this] = STATE(2992),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(2992),
    [sym_generator_function] = STATE(2992),
    [sym_call_expression] = STATE(2992),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(2992),
    [sym_ternary_expression] = STATE(2992),
    [sym_binary_expression] = STATE(2992),
    [sym_template_string] = STATE(2992),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2992),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2992),
    [sym_class] = STATE(2992),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym__automatic_semicolon] = ACTIONS(211),
    [sym_identifier] = ACTIONS(4499),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(4517),
    [sym_true] = ACTIONS(6283),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(4505),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(6283),
    [anon_sym_SEMI] = ACTIONS(211),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6283),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_RPAREN] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(6285),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6283),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [2129] = {
    [sym_new_expression] = STATE(277),
    [sym_augmented_assignment_expression] = STATE(289),
    [sym_unary_expression] = STATE(289),
    [sym_update_expression] = STATE(289),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(277),
    [sym_regex] = STATE(277),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(289),
    [sym_non_null_expression] = STATE(289),
    [sym_as_expression] = STATE(289),
    [sym_jsx_fragment] = STATE(289),
    [sym_yield_expression] = STATE(289),
    [sym_jsx_element] = STATE(289),
    [sym_internal_module] = STATE(289),
    [sym_function] = STATE(290),
    [sym_arrow_function] = STATE(277),
    [sym_await_expression] = STATE(289),
    [sym_member_expression] = STATE(291),
    [sym_string] = STATE(277),
    [sym_this] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(292),
    [sym_anonymous_class] = STATE(277),
    [sym_generator_function] = STATE(277),
    [sym_call_expression] = STATE(289),
    [sym_subscript_expression] = STATE(291),
    [sym_assignment_expression] = STATE(289),
    [sym_ternary_expression] = STATE(289),
    [sym_binary_expression] = STATE(289),
    [sym_template_string] = STATE(277),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(277),
    [sym_array] = STATE(293),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(289),
    [sym_class] = STATE(277),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(6287),
    [sym_false] = ACTIONS(482),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(6289),
    [anon_sym_symbol] = ACTIONS(6289),
    [anon_sym_number] = ACTIONS(6289),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6289),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(482),
    [sym_super] = ACTIONS(494),
    [anon_sym_any] = ACTIONS(6289),
    [anon_sym_private] = ACTIONS(6289),
    [anon_sym_boolean] = ACTIONS(6289),
    [anon_sym_async] = ACTIONS(6293),
    [anon_sym_public] = ACTIONS(6289),
    [anon_sym_get] = ACTIONS(6289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(498),
    [sym_true] = ACTIONS(482),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(6289),
    [anon_sym_string] = ACTIONS(6289),
    [anon_sym_function] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(502),
    [sym_undefined] = ACTIONS(482),
    [anon_sym_set] = ACTIONS(6289),
    [anon_sym_type] = ACTIONS(6289),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(6289),
    [anon_sym_export] = ACTIONS(6289),
    [anon_sym_namespace] = ACTIONS(6295),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [2130] = {
    [sym_nested_identifier] = STATE(127),
    [sym__module] = STATE(128),
    [sym_string] = STATE(129),
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6263),
    [anon_sym_AMP_EQ] = ACTIONS(6263),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6263),
    [anon_sym_PLUS_EQ] = ACTIONS(6263),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(6263),
    [anon_sym_STAR_EQ] = ACTIONS(6263),
    [anon_sym_PIPE_EQ] = ACTIONS(6263),
    [anon_sym_DASH_EQ] = ACTIONS(6263),
    [anon_sym_EQ_GT] = ACTIONS(6265),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6263),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6263),
    [anon_sym_GT_GT_EQ] = ACTIONS(6263),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6263),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2131] = {
    [sym_new_expression] = STATE(2998),
    [sym_augmented_assignment_expression] = STATE(2998),
    [sym_unary_expression] = STATE(2998),
    [sym_update_expression] = STATE(2998),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(2998),
    [sym_regex] = STATE(2998),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2998),
    [sym_non_null_expression] = STATE(2998),
    [sym_as_expression] = STATE(2998),
    [sym_jsx_fragment] = STATE(2998),
    [sym_yield_expression] = STATE(2998),
    [sym_jsx_element] = STATE(2998),
    [sym_internal_module] = STATE(2998),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2998),
    [sym_await_expression] = STATE(2998),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(2998),
    [sym_this] = STATE(2998),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(2998),
    [sym_generator_function] = STATE(2998),
    [sym_call_expression] = STATE(2998),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(2998),
    [sym_ternary_expression] = STATE(2998),
    [sym_binary_expression] = STATE(2998),
    [sym_template_string] = STATE(2998),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2998),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2998),
    [sym_class] = STATE(2998),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(6297),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6297),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(6299),
    [sym_true] = ACTIONS(6297),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6297),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [2132] = {
    [anon_sym_EQ_GT] = ACTIONS(6259),
    [sym_comment] = ACTIONS(3),
  },
  [2133] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(6311),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2134] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6255),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6255),
    [anon_sym_AMP_EQ] = ACTIONS(6255),
    [anon_sym_PLUS_EQ] = ACTIONS(6255),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(6255),
    [anon_sym_STAR_EQ] = ACTIONS(6255),
    [anon_sym_PIPE_EQ] = ACTIONS(6255),
    [anon_sym_DASH_EQ] = ACTIONS(6255),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6255),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6255),
    [anon_sym_GT_GT_EQ] = ACTIONS(6255),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6255),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [2135] = {
    [anon_sym_RPAREN] = ACTIONS(6311),
    [sym_comment] = ACTIONS(3),
  },
  [2136] = {
    [sym__initializer] = STATE(321),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6261),
  },
  [2137] = {
    [sym__initializer] = STATE(336),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6261),
  },
  [2138] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6315),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6315),
    [anon_sym_AMP_EQ] = ACTIONS(6315),
    [anon_sym_PLUS_EQ] = ACTIONS(6315),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(6317),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(6315),
    [anon_sym_STAR_EQ] = ACTIONS(6315),
    [anon_sym_PIPE_EQ] = ACTIONS(6315),
    [anon_sym_DASH_EQ] = ACTIONS(6315),
    [anon_sym_EQ_GT] = ACTIONS(6319),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6315),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6315),
    [anon_sym_GT_GT_EQ] = ACTIONS(6315),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6315),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6321),
  },
  [2139] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6323),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6323),
    [anon_sym_AMP_EQ] = ACTIONS(6323),
    [anon_sym_PLUS_EQ] = ACTIONS(6323),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(6317),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(6323),
    [anon_sym_STAR_EQ] = ACTIONS(6323),
    [anon_sym_PIPE_EQ] = ACTIONS(6323),
    [anon_sym_DASH_EQ] = ACTIONS(6323),
    [anon_sym_EQ_GT] = ACTIONS(6325),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6323),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6323),
    [anon_sym_GT_GT_EQ] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6323),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2140] = {
    [sym_new_expression] = STATE(3014),
    [sym_augmented_assignment_expression] = STATE(3014),
    [sym_unary_expression] = STATE(3014),
    [sym_update_expression] = STATE(3014),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3014),
    [sym_regex] = STATE(3014),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3014),
    [sym_non_null_expression] = STATE(3014),
    [sym_as_expression] = STATE(3014),
    [sym_jsx_fragment] = STATE(3014),
    [sym_yield_expression] = STATE(3014),
    [sym_jsx_element] = STATE(3014),
    [sym_internal_module] = STATE(3014),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3014),
    [sym_await_expression] = STATE(3014),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3014),
    [sym_this] = STATE(3014),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3014),
    [sym_generator_function] = STATE(3014),
    [sym_call_expression] = STATE(3014),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3014),
    [sym_ternary_expression] = STATE(3014),
    [sym_binary_expression] = STATE(3014),
    [sym_template_string] = STATE(3014),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3014),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3014),
    [sym_class] = STATE(3014),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(6327),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6327),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6329),
    [sym_true] = ACTIONS(6327),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6327),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [2141] = {
    [sym_new_expression] = STATE(3015),
    [sym_augmented_assignment_expression] = STATE(3015),
    [sym_unary_expression] = STATE(3015),
    [sym_update_expression] = STATE(3015),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3015),
    [sym_regex] = STATE(3015),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3015),
    [sym_non_null_expression] = STATE(3015),
    [sym_as_expression] = STATE(3015),
    [sym_jsx_fragment] = STATE(3015),
    [sym_yield_expression] = STATE(3015),
    [sym_jsx_element] = STATE(3015),
    [sym_internal_module] = STATE(3015),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3015),
    [sym_await_expression] = STATE(3015),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3015),
    [sym_this] = STATE(3015),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3015),
    [sym_generator_function] = STATE(3015),
    [sym_call_expression] = STATE(3015),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3015),
    [sym_ternary_expression] = STATE(3015),
    [sym_binary_expression] = STATE(3015),
    [sym_template_string] = STATE(3015),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3015),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3015),
    [sym_class] = STATE(3015),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(6331),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6331),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6333),
    [sym_true] = ACTIONS(6331),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6331),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [2142] = {
    [sym_new_expression] = STATE(3014),
    [sym_augmented_assignment_expression] = STATE(3014),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(3014),
    [sym_update_expression] = STATE(3014),
    [sym_regex] = STATE(3014),
    [sym_meta_property] = STATE(3014),
    [sym_call_signature] = STATE(2149),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3014),
    [sym_non_null_expression] = STATE(3014),
    [sym_yield_expression] = STATE(3014),
    [sym_jsx_fragment] = STATE(3014),
    [sym_jsx_element] = STATE(3014),
    [sym_as_expression] = STATE(3014),
    [sym_internal_module] = STATE(3014),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3014),
    [sym_await_expression] = STATE(3014),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3014),
    [sym_this] = STATE(3014),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3014),
    [sym_generator_function] = STATE(3014),
    [sym_call_expression] = STATE(3014),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3014),
    [sym_ternary_expression] = STATE(3014),
    [sym_binary_expression] = STATE(3014),
    [sym_template_string] = STATE(3014),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3014),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3014),
    [sym_class] = STATE(3014),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4527),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(6323),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_AMP_EQ] = ACTIONS(6323),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(6323),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6317),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(6323),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_PIPE_EQ] = ACTIONS(6323),
    [anon_sym_DASH_EQ] = ACTIONS(6323),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(6323),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(4545),
    [sym_true] = ACTIONS(6327),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_GT_GT_EQ] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6323),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(4533),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(6327),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6323),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6327),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_STAR_EQ] = ACTIONS(6323),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_EQ_GT] = ACTIONS(6325),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(6329),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6323),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6327),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2143] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_call_signature] = STATE(3016),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(6335),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6323),
    [anon_sym_symbol] = ACTIONS(6337),
    [anon_sym_AMP_EQ] = ACTIONS(6323),
    [anon_sym_PLUS_EQ] = ACTIONS(6323),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6317),
    [anon_sym_void] = ACTIONS(6337),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(6323),
    [anon_sym_private] = ACTIONS(6337),
    [anon_sym_PIPE_EQ] = ACTIONS(6323),
    [anon_sym_DASH_EQ] = ACTIONS(6323),
    [anon_sym_get] = ACTIONS(6337),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(6323),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_protected] = ACTIONS(6337),
    [anon_sym_GT_GT_EQ] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(6337),
    [anon_sym_type] = ACTIONS(6337),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(6337),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6323),
    [anon_sym_namespace] = ACTIONS(6337),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(6337),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6323),
    [anon_sym_number] = ACTIONS(6337),
    [anon_sym_declare] = ACTIONS(6337),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(6337),
    [anon_sym_STAR_EQ] = ACTIONS(6323),
    [anon_sym_boolean] = ACTIONS(6337),
    [anon_sym_async] = ACTIONS(6337),
    [anon_sym_public] = ACTIONS(6337),
    [anon_sym_EQ_GT] = ACTIONS(6325),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6323),
    [anon_sym_string] = ACTIONS(6337),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(6337),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2144] = {
    [sym_new_expression] = STATE(3018),
    [sym_augmented_assignment_expression] = STATE(3018),
    [sym_unary_expression] = STATE(3018),
    [sym_update_expression] = STATE(3018),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3018),
    [sym_regex] = STATE(3018),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3018),
    [sym_non_null_expression] = STATE(3018),
    [sym_as_expression] = STATE(3018),
    [sym_jsx_fragment] = STATE(3018),
    [sym_yield_expression] = STATE(3018),
    [sym_jsx_element] = STATE(3018),
    [sym_internal_module] = STATE(3018),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3018),
    [sym_await_expression] = STATE(3018),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3018),
    [sym_this] = STATE(3018),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3018),
    [sym_generator_function] = STATE(3018),
    [sym_call_expression] = STATE(3018),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3018),
    [sym_ternary_expression] = STATE(3018),
    [sym_binary_expression] = STATE(3018),
    [sym_template_string] = STATE(3018),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3018),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3018),
    [sym_class] = STATE(3018),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(6339),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6339),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6341),
    [sym_true] = ACTIONS(6339),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6339),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [2145] = {
    [sym_new_expression] = STATE(3019),
    [sym_augmented_assignment_expression] = STATE(3019),
    [sym_unary_expression] = STATE(3019),
    [sym_update_expression] = STATE(3019),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3019),
    [sym_regex] = STATE(3019),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3019),
    [sym_non_null_expression] = STATE(3019),
    [sym_as_expression] = STATE(3019),
    [sym_jsx_fragment] = STATE(3019),
    [sym_yield_expression] = STATE(3019),
    [sym_jsx_element] = STATE(3019),
    [sym_internal_module] = STATE(3019),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3019),
    [sym_await_expression] = STATE(3019),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3019),
    [sym_this] = STATE(3019),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3019),
    [sym_generator_function] = STATE(3019),
    [sym_call_expression] = STATE(3019),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3019),
    [sym_ternary_expression] = STATE(3019),
    [sym_binary_expression] = STATE(3019),
    [sym_template_string] = STATE(3019),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3019),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3019),
    [sym_class] = STATE(3019),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(4527),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(4545),
    [sym_true] = ACTIONS(6343),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(4533),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(6343),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6343),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_RPAREN] = ACTIONS(211),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(6345),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6343),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [2146] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(6347),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(6349),
    [anon_sym_symbol] = ACTIONS(6349),
    [anon_sym_number] = ACTIONS(6349),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(6349),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(6351),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(6349),
    [anon_sym_private] = ACTIONS(6349),
    [anon_sym_boolean] = ACTIONS(6349),
    [anon_sym_async] = ACTIONS(6353),
    [anon_sym_public] = ACTIONS(6349),
    [anon_sym_get] = ACTIONS(6349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(6349),
    [anon_sym_string] = ACTIONS(6349),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(6349),
    [anon_sym_type] = ACTIONS(6349),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(6349),
    [anon_sym_export] = ACTIONS(6349),
    [anon_sym_namespace] = ACTIONS(6355),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [2147] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(6323),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6323),
    [anon_sym_AMP_EQ] = ACTIONS(6323),
    [anon_sym_PLUS_EQ] = ACTIONS(6323),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(6317),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(6323),
    [anon_sym_STAR_EQ] = ACTIONS(6323),
    [anon_sym_PIPE_EQ] = ACTIONS(6323),
    [anon_sym_DASH_EQ] = ACTIONS(6323),
    [anon_sym_EQ_GT] = ACTIONS(6325),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6323),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6323),
    [anon_sym_GT_GT_EQ] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6323),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2148] = {
    [sym_new_expression] = STATE(3025),
    [sym_augmented_assignment_expression] = STATE(3025),
    [sym_unary_expression] = STATE(3025),
    [sym_update_expression] = STATE(3025),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3025),
    [sym_regex] = STATE(3025),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3025),
    [sym_non_null_expression] = STATE(3025),
    [sym_as_expression] = STATE(3025),
    [sym_jsx_fragment] = STATE(3025),
    [sym_yield_expression] = STATE(3025),
    [sym_jsx_element] = STATE(3025),
    [sym_internal_module] = STATE(3025),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3025),
    [sym_await_expression] = STATE(3025),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3025),
    [sym_this] = STATE(3025),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3025),
    [sym_generator_function] = STATE(3025),
    [sym_call_expression] = STATE(3025),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3025),
    [sym_ternary_expression] = STATE(3025),
    [sym_binary_expression] = STATE(3025),
    [sym_template_string] = STATE(3025),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3025),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3025),
    [sym_class] = STATE(3025),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(6357),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6357),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6359),
    [sym_true] = ACTIONS(6357),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6357),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [2149] = {
    [anon_sym_EQ_GT] = ACTIONS(6319),
    [sym_comment] = ACTIONS(3),
  },
  [2150] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(6383),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [2151] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6315),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6315),
    [anon_sym_AMP_EQ] = ACTIONS(6315),
    [anon_sym_PLUS_EQ] = ACTIONS(6315),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(6317),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(6315),
    [anon_sym_STAR_EQ] = ACTIONS(6315),
    [anon_sym_PIPE_EQ] = ACTIONS(6315),
    [anon_sym_DASH_EQ] = ACTIONS(6315),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6315),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6315),
    [anon_sym_GT_GT_EQ] = ACTIONS(6315),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6315),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [2152] = {
    [sym__initializer] = STATE(587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(6317),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6321),
  },
  [2153] = {
    [sym__initializer] = STATE(589),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(6317),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6321),
  },
  [2154] = {
    [sym_new_expression] = STATE(3035),
    [sym_augmented_assignment_expression] = STATE(3035),
    [sym_unary_expression] = STATE(3035),
    [sym_update_expression] = STATE(3035),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(3035),
    [sym_regex] = STATE(3035),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3035),
    [sym_non_null_expression] = STATE(3035),
    [sym_as_expression] = STATE(3035),
    [sym_jsx_fragment] = STATE(3035),
    [sym_yield_expression] = STATE(3035),
    [sym_jsx_element] = STATE(3035),
    [sym_internal_module] = STATE(3035),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3035),
    [sym_await_expression] = STATE(3035),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(3036),
    [sym_string] = STATE(3035),
    [sym_this] = STATE(3035),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(3035),
    [sym_generator_function] = STATE(3035),
    [sym_call_expression] = STATE(3035),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(3035),
    [sym_ternary_expression] = STATE(3035),
    [sym_binary_expression] = STATE(3035),
    [sym_template_string] = STATE(3035),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3035),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3035),
    [sym_class] = STATE(3035),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(6387),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6387),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6389),
    [sym_true] = ACTIONS(6387),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6387),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [2155] = {
    [sym_new_expression] = STATE(3037),
    [sym_augmented_assignment_expression] = STATE(3037),
    [sym_unary_expression] = STATE(3037),
    [sym_update_expression] = STATE(3037),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(3037),
    [sym_regex] = STATE(3037),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3037),
    [sym_non_null_expression] = STATE(3037),
    [sym_as_expression] = STATE(3037),
    [sym_jsx_fragment] = STATE(3037),
    [sym_yield_expression] = STATE(3037),
    [sym_jsx_element] = STATE(3037),
    [sym_internal_module] = STATE(3037),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3037),
    [sym_await_expression] = STATE(3037),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(3038),
    [sym_string] = STATE(3037),
    [sym_this] = STATE(3037),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(3037),
    [sym_generator_function] = STATE(3037),
    [sym_call_expression] = STATE(3037),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(3037),
    [sym_ternary_expression] = STATE(3037),
    [sym_binary_expression] = STATE(3037),
    [sym_template_string] = STATE(3037),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3037),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3037),
    [sym_class] = STATE(3037),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(6391),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6391),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6393),
    [sym_true] = ACTIONS(6391),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6391),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [2156] = {
    [sym_new_expression] = STATE(3039),
    [sym_augmented_assignment_expression] = STATE(3039),
    [sym_unary_expression] = STATE(3039),
    [sym_update_expression] = STATE(3039),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(3039),
    [sym_regex] = STATE(3039),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3039),
    [sym_non_null_expression] = STATE(3039),
    [sym_as_expression] = STATE(3039),
    [sym_jsx_fragment] = STATE(3039),
    [sym_yield_expression] = STATE(3039),
    [sym_jsx_element] = STATE(3039),
    [sym_internal_module] = STATE(3039),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3039),
    [sym_await_expression] = STATE(3039),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(3040),
    [sym_string] = STATE(3039),
    [sym_this] = STATE(3039),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(3039),
    [sym_generator_function] = STATE(3039),
    [sym_call_expression] = STATE(3039),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(3039),
    [sym_ternary_expression] = STATE(3039),
    [sym_binary_expression] = STATE(3039),
    [sym_template_string] = STATE(3039),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3039),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3039),
    [sym_class] = STATE(3039),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(6395),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6395),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6397),
    [sym_true] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6395),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [2157] = {
    [sym_type_alias_declaration] = STATE(3041),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3041),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3041),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3041),
    [sym_return_statement] = STATE(3041),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3041),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3041),
    [sym_switch_statement] = STATE(3041),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3041),
    [sym_throw_statement] = STATE(3041),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3041),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3041),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(3041),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3041),
    [sym_abstract_class] = STATE(3041),
    [sym_interface_declaration] = STATE(3041),
    [sym_statement_block] = STATE(3041),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3041),
    [sym_debugger_statement] = STATE(3041),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3041),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3041),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3041),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3041),
    [sym_empty_statement] = STATE(3041),
    [sym_import_alias] = STATE(3041),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3041),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3041),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3041),
    [sym_break_statement] = STATE(3041),
    [sym_labeled_statement] = STATE(3041),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3041),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [2158] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(6399),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [2159] = {
    [anon_sym_RPAREN] = ACTIONS(6399),
    [sym_comment] = ACTIONS(3),
  },
  [2160] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(6401),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [2161] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(6403),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2162] = {
    [anon_sym_RPAREN] = ACTIONS(6403),
    [sym_comment] = ACTIONS(3),
  },
  [2163] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(6405),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [2164] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(6407),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2165] = {
    [anon_sym_RPAREN] = ACTIONS(6407),
    [sym_comment] = ACTIONS(3),
  },
  [2166] = {
    [sym__initializer] = STATE(661),
    [aux_sym_object_repeat1] = STATE(1042),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(1197),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(1197),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(1202),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1205),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [2167] = {
    [sym__initializer] = STATE(79),
    [aux_sym_object_repeat1] = STATE(1042),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2168] = {
    [sym_new_expression] = STATE(90),
    [sym_augmented_assignment_expression] = STATE(90),
    [sym__initializer] = STATE(79),
    [sym_unary_expression] = STATE(90),
    [sym_update_expression] = STATE(90),
    [sym_regex] = STATE(90),
    [sym_meta_property] = STATE(90),
    [sym_call_signature] = STATE(58),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(90),
    [sym_non_null_expression] = STATE(90),
    [sym_yield_expression] = STATE(90),
    [sym_jsx_fragment] = STATE(90),
    [sym_jsx_element] = STATE(90),
    [sym_as_expression] = STATE(90),
    [sym_internal_module] = STATE(90),
    [aux_sym_object_repeat1] = STATE(1042),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(90),
    [sym_await_expression] = STATE(90),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(90),
    [sym_this] = STATE(90),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(90),
    [sym_generator_function] = STATE(90),
    [sym_call_expression] = STATE(90),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(90),
    [sym_ternary_expression] = STATE(90),
    [sym_binary_expression] = STATE(90),
    [sym_template_string] = STATE(90),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(90),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(90),
    [sym_class] = STATE(90),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(161),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2169] = {
    [sym__initializer] = STATE(79),
    [aux_sym_object_repeat1] = STATE(1042),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1236),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(1236),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(1236),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(1236),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(1236),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(1236),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1236),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1236),
    [anon_sym_type] = ACTIONS(1236),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1236),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [sym_readonly] = ACTIONS(1236),
    [anon_sym_DQUOTE] = ACTIONS(1238),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1238),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1236),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1236),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1236),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(1236),
    [anon_sym_async] = ACTIONS(1236),
    [anon_sym_public] = ACTIONS(1236),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1211),
    [sym_number] = ACTIONS(1238),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(1236),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1236),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2170] = {
    [sym__property_name] = STATE(673),
    [sym_string] = STATE(673),
    [sym__initializer] = STATE(79),
    [aux_sym_object_repeat1] = STATE(1042),
    [sym_computed_property_name] = STATE(673),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1211),
    [sym_number] = ACTIONS(1234),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2171] = {
    [sym__initializer] = STATE(79),
    [aux_sym_object_repeat1] = STATE(1042),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(225),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2172] = {
    [sym_import_require_clause] = STATE(124),
    [sym_import_clause] = STATE(125),
    [sym_named_imports] = STATE(126),
    [sym_string] = STATE(124),
    [sym__initializer] = STATE(79),
    [aux_sym_object_repeat1] = STATE(1042),
    [sym_namespace_import] = STATE(126),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(227),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(232),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_typeof] = ACTIONS(232),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(234),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2173] = {
    [sym_nested_identifier] = STATE(127),
    [sym__module] = STATE(128),
    [sym_string] = STATE(129),
    [sym__initializer] = STATE(79),
    [aux_sym_object_repeat1] = STATE(1042),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(236),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2174] = {
    [sym_nested_identifier] = STATE(169),
    [sym__module] = STATE(172),
    [sym_string] = STATE(173),
    [sym__initializer] = STATE(79),
    [aux_sym_object_repeat1] = STATE(1042),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(310),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2175] = {
    [sym_type_alias_declaration] = STATE(193),
    [aux_sym_export_statement_repeat1] = STATE(685),
    [sym__declaration] = STATE(193),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(193),
    [sym_import_alias] = STATE(193),
    [sym_export_statement] = STATE(193),
    [sym_generator_function] = STATE(193),
    [aux_sym_object_repeat1] = STATE(1042),
    [sym_lexical_declaration] = STATE(193),
    [sym_internal_module] = STATE(193),
    [sym_decorator] = STATE(685),
    [sym_enum_declaration] = STATE(193),
    [sym_function] = STATE(193),
    [sym_function_signature] = STATE(193),
    [sym_variable_declaration] = STATE(193),
    [sym_abstract_class] = STATE(193),
    [sym_module] = STATE(193),
    [sym_interface_declaration] = STATE(193),
    [sym_class] = STATE(193),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(324),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1267),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_declare] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2176] = {
    [sym__property_name] = STATE(673),
    [sym__initializer] = STATE(79),
    [sym_formal_parameters] = STATE(57),
    [sym_computed_property_name] = STATE(673),
    [sym_type_parameters] = STATE(51),
    [sym_call_signature] = STATE(253),
    [sym_string] = STATE(673),
    [aux_sym_object_repeat1] = STATE(1042),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1277),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_symbol] = ACTIONS(1279),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(1281),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(1279),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(1279),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_get] = ACTIONS(1284),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1279),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1284),
    [anon_sym_type] = ACTIONS(1279),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1279),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1279),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1279),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_number] = ACTIONS(1279),
    [anon_sym_declare] = ACTIONS(1279),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1286),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(1279),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_boolean] = ACTIONS(1279),
    [anon_sym_async] = ACTIONS(1279),
    [anon_sym_public] = ACTIONS(1279),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1290),
    [sym_number] = ACTIONS(1234),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_string] = ACTIONS(1279),
    [anon_sym_function] = ACTIONS(452),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1279),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2177] = {
    [sym_type_alias_declaration] = STATE(300),
    [aux_sym_export_statement_repeat1] = STATE(685),
    [sym__declaration] = STATE(300),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(300),
    [sym_import_alias] = STATE(300),
    [sym_export_statement] = STATE(300),
    [sym_generator_function] = STATE(300),
    [sym_export_clause] = STATE(301),
    [aux_sym_object_repeat1] = STATE(1042),
    [sym_lexical_declaration] = STATE(300),
    [sym_internal_module] = STATE(300),
    [sym_decorator] = STATE(685),
    [sym_enum_declaration] = STATE(300),
    [sym_function] = STATE(300),
    [sym_function_signature] = STATE(300),
    [sym_variable_declaration] = STATE(300),
    [sym_abstract_class] = STATE(300),
    [sym_module] = STATE(300),
    [sym_interface_declaration] = STATE(300),
    [sym_class] = STATE(300),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(362),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(508),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(511),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_as] = ACTIONS(515),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_declare] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(1208),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2178] = {
    [sym_type_alias_declaration] = STATE(696),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(696),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(696),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(696),
    [sym_return_statement] = STATE(696),
    [aux_sym_program_repeat1] = STATE(696),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(696),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(696),
    [sym_switch_statement] = STATE(696),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(696),
    [sym_throw_statement] = STATE(696),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(696),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(696),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(696),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(696),
    [sym_abstract_class] = STATE(696),
    [sym_interface_declaration] = STATE(696),
    [sym_statement_block] = STATE(696),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(696),
    [sym_debugger_statement] = STATE(696),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(696),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(696),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(696),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(696),
    [sym_empty_statement] = STATE(696),
    [sym_import_alias] = STATE(696),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(696),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(696),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(696),
    [sym_break_statement] = STATE(696),
    [sym_labeled_statement] = STATE(696),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(696),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(6409),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [2179] = {
    [aux_sym_export_statement_repeat1] = STATE(706),
    [sym__property_name] = STATE(707),
    [sym_decorator] = STATE(706),
    [sym_string] = STATE(707),
    [sym_accessibility_modifier] = STATE(221),
    [sym_method_definition] = STATE(1043),
    [sym_computed_property_name] = STATE(707),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_class] = ACTIONS(1314),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_STAR] = ACTIONS(364),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1316),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1318),
    [anon_sym_static] = ACTIONS(370),
    [anon_sym_get] = ACTIONS(1320),
    [anon_sym_public] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [sym_number] = ACTIONS(1322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1316),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1320),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1324),
    [sym_readonly] = ACTIONS(384),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [2180] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4783),
    [anon_sym_LBRACK] = ACTIONS(4783),
    [anon_sym_BANG] = ACTIONS(4785),
    [anon_sym_BQUOTE] = ACTIONS(4783),
    [anon_sym_else] = ACTIONS(4783),
    [anon_sym_PIPE] = ACTIONS(4785),
    [anon_sym_COMMA] = ACTIONS(4783),
    [anon_sym_LT_LT] = ACTIONS(4783),
    [anon_sym_STAR] = ACTIONS(4785),
    [anon_sym_GT_GT_GT] = ACTIONS(4783),
    [anon_sym_AMP_AMP] = ACTIONS(4783),
    [anon_sym_DASH] = ACTIONS(4785),
    [anon_sym_LBRACE] = ACTIONS(4785),
    [anon_sym_BANG_EQ] = ACTIONS(4785),
    [anon_sym_LT_EQ] = ACTIONS(4783),
    [anon_sym_LPAREN] = ACTIONS(4783),
    [anon_sym_RBRACK] = ACTIONS(4783),
    [anon_sym_GT_EQ] = ACTIONS(4783),
    [anon_sym_GT] = ACTIONS(4785),
    [anon_sym_AMP] = ACTIONS(4785),
    [anon_sym_PERCENT] = ACTIONS(4783),
    [anon_sym_QMARK] = ACTIONS(4783),
    [anon_sym_RBRACE] = ACTIONS(4783),
    [anon_sym_as] = ACTIONS(4783),
    [anon_sym_PIPE_PIPE] = ACTIONS(4783),
    [anon_sym_while] = ACTIONS(4783),
    [anon_sym_DASH_DASH] = ACTIONS(4783),
    [anon_sym_EQ_EQ] = ACTIONS(4785),
    [anon_sym_instanceof] = ACTIONS(4783),
    [anon_sym_LT] = ACTIONS(4785),
    [anon_sym_RPAREN] = ACTIONS(4783),
    [anon_sym_SLASH] = ACTIONS(4785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4783),
    [anon_sym_COLON] = ACTIONS(4783),
    [anon_sym_DOT] = ACTIONS(4783),
    [anon_sym_CARET] = ACTIONS(4783),
    [anon_sym_STAR_STAR] = ACTIONS(4783),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_implements] = ACTIONS(4783),
    [anon_sym_GT_GT] = ACTIONS(4785),
    [anon_sym_PLUS_PLUS] = ACTIONS(4783),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4783),
    [anon_sym_in] = ACTIONS(4785),
  },
  [2181] = {
    [sym_class_body] = STATE(3048),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(959),
  },
  [2182] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4911),
    [anon_sym_LBRACK] = ACTIONS(4911),
    [anon_sym_BANG] = ACTIONS(4913),
    [anon_sym_BQUOTE] = ACTIONS(4911),
    [anon_sym_else] = ACTIONS(4911),
    [anon_sym_PIPE] = ACTIONS(4913),
    [anon_sym_COMMA] = ACTIONS(4911),
    [anon_sym_LT_LT] = ACTIONS(4911),
    [anon_sym_STAR] = ACTIONS(4913),
    [anon_sym_GT_GT_GT] = ACTIONS(4911),
    [anon_sym_AMP_AMP] = ACTIONS(4911),
    [anon_sym_DASH] = ACTIONS(4913),
    [anon_sym_LBRACE] = ACTIONS(4913),
    [anon_sym_BANG_EQ] = ACTIONS(4913),
    [anon_sym_LT_EQ] = ACTIONS(4911),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [anon_sym_RBRACK] = ACTIONS(4911),
    [anon_sym_GT_EQ] = ACTIONS(4911),
    [anon_sym_GT] = ACTIONS(4913),
    [anon_sym_AMP] = ACTIONS(4913),
    [anon_sym_PERCENT] = ACTIONS(4911),
    [anon_sym_QMARK] = ACTIONS(4911),
    [anon_sym_RBRACE] = ACTIONS(4911),
    [anon_sym_as] = ACTIONS(4911),
    [anon_sym_PIPE_PIPE] = ACTIONS(4911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4911),
    [anon_sym_DASH_DASH] = ACTIONS(4911),
    [anon_sym_EQ_EQ] = ACTIONS(4913),
    [anon_sym_instanceof] = ACTIONS(4911),
    [anon_sym_LT] = ACTIONS(4913),
    [anon_sym_RPAREN] = ACTIONS(4911),
    [anon_sym_SLASH] = ACTIONS(4913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(4911),
    [anon_sym_COLON] = ACTIONS(4911),
    [anon_sym_DOT] = ACTIONS(4911),
    [anon_sym_CARET] = ACTIONS(4911),
    [anon_sym_STAR_STAR] = ACTIONS(4911),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_implements] = ACTIONS(4911),
    [anon_sym_GT_GT] = ACTIONS(4913),
    [anon_sym_PLUS_PLUS] = ACTIONS(4911),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4911),
    [anon_sym_in] = ACTIONS(4913),
  },
  [2183] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5208),
    [anon_sym_LBRACK] = ACTIONS(5208),
    [anon_sym_BANG] = ACTIONS(5210),
    [anon_sym_BQUOTE] = ACTIONS(5208),
    [anon_sym_PIPE] = ACTIONS(5210),
    [anon_sym_COMMA] = ACTIONS(5208),
    [anon_sym_LT_LT] = ACTIONS(5208),
    [anon_sym_STAR] = ACTIONS(5210),
    [anon_sym_GT_GT_GT] = ACTIONS(5208),
    [anon_sym_AMP_AMP] = ACTIONS(5208),
    [anon_sym_DASH] = ACTIONS(5210),
    [anon_sym_LBRACE] = ACTIONS(5210),
    [anon_sym_BANG_EQ] = ACTIONS(5210),
    [anon_sym_LT_EQ] = ACTIONS(5208),
    [anon_sym_LPAREN] = ACTIONS(5208),
    [anon_sym_RBRACK] = ACTIONS(5208),
    [anon_sym_GT_EQ] = ACTIONS(5208),
    [anon_sym_GT] = ACTIONS(5210),
    [anon_sym_AMP] = ACTIONS(5210),
    [anon_sym_PERCENT] = ACTIONS(5208),
    [anon_sym_QMARK] = ACTIONS(5208),
    [anon_sym_RBRACE] = ACTIONS(5208),
    [anon_sym_as] = ACTIONS(5208),
    [anon_sym_PIPE_PIPE] = ACTIONS(5208),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5208),
    [anon_sym_DASH_DASH] = ACTIONS(5208),
    [anon_sym_EQ_EQ] = ACTIONS(5210),
    [anon_sym_instanceof] = ACTIONS(5208),
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym_RPAREN] = ACTIONS(5208),
    [anon_sym_SLASH] = ACTIONS(5210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5208),
    [anon_sym_DOT] = ACTIONS(5208),
    [anon_sym_CARET] = ACTIONS(5208),
    [anon_sym_STAR_STAR] = ACTIONS(5208),
    [anon_sym_PLUS] = ACTIONS(5210),
    [anon_sym_implements] = ACTIONS(5208),
    [anon_sym_GT_GT] = ACTIONS(5210),
    [anon_sym_PLUS_PLUS] = ACTIONS(5208),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5208),
    [anon_sym_in] = ACTIONS(5210),
  },
  [2184] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4049),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_BANG] = ACTIONS(4051),
    [anon_sym_BQUOTE] = ACTIONS(4049),
    [anon_sym_PERCENT_EQ] = ACTIONS(4049),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4049),
    [anon_sym_AMP_EQ] = ACTIONS(4049),
    [anon_sym_PLUS_EQ] = ACTIONS(4049),
    [anon_sym_PIPE] = ACTIONS(4051),
    [anon_sym_COMMA] = ACTIONS(4049),
    [anon_sym_LT_LT] = ACTIONS(4051),
    [anon_sym_STAR] = ACTIONS(4051),
    [anon_sym_GT_GT_GT] = ACTIONS(4051),
    [anon_sym_EQ] = ACTIONS(4051),
    [anon_sym_AMP_AMP] = ACTIONS(4049),
    [anon_sym_DASH] = ACTIONS(4051),
    [anon_sym_BANG_EQ] = ACTIONS(4051),
    [anon_sym_LT_EQ] = ACTIONS(4049),
    [anon_sym_LPAREN] = ACTIONS(4049),
    [anon_sym_RBRACK] = ACTIONS(4049),
    [anon_sym_GT_EQ] = ACTIONS(4049),
    [anon_sym_GT] = ACTIONS(4051),
    [anon_sym_LBRACE] = ACTIONS(4051),
    [anon_sym_CARET_EQ] = ACTIONS(4049),
    [anon_sym_STAR_EQ] = ACTIONS(4049),
    [anon_sym_PIPE_EQ] = ACTIONS(4049),
    [anon_sym_DASH_EQ] = ACTIONS(4049),
    [anon_sym_AMP] = ACTIONS(4051),
    [anon_sym_PERCENT] = ACTIONS(4051),
    [anon_sym_QMARK] = ACTIONS(4049),
    [anon_sym_LT_LT_EQ] = ACTIONS(4049),
    [anon_sym_as] = ACTIONS(4049),
    [anon_sym_PIPE_PIPE] = ACTIONS(4049),
    [anon_sym_RBRACE] = ACTIONS(4049),
    [anon_sym_DASH_DASH] = ACTIONS(4049),
    [anon_sym_EQ_EQ] = ACTIONS(4051),
    [anon_sym_instanceof] = ACTIONS(4049),
    [anon_sym_LT] = ACTIONS(4051),
    [anon_sym_RPAREN] = ACTIONS(4049),
    [anon_sym_SLASH] = ACTIONS(4051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4049),
    [anon_sym_COLON] = ACTIONS(4049),
    [anon_sym_SLASH_EQ] = ACTIONS(4049),
    [anon_sym_GT_GT_EQ] = ACTIONS(4049),
    [anon_sym_DOT] = ACTIONS(4049),
    [anon_sym_CARET] = ACTIONS(4051),
    [anon_sym_STAR_STAR] = ACTIONS(4051),
    [anon_sym_PLUS] = ACTIONS(4051),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4049),
    [anon_sym_GT_GT] = ACTIONS(4051),
    [anon_sym_PLUS_PLUS] = ACTIONS(4049),
    [anon_sym_implements] = ACTIONS(4049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4049),
    [anon_sym_in] = ACTIONS(4051),
  },
  [2185] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5236),
    [anon_sym_LBRACK] = ACTIONS(5236),
    [anon_sym_BANG] = ACTIONS(5238),
    [anon_sym_BQUOTE] = ACTIONS(5236),
    [anon_sym_PIPE] = ACTIONS(5238),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_LT_LT] = ACTIONS(5236),
    [anon_sym_STAR] = ACTIONS(5238),
    [anon_sym_GT_GT_GT] = ACTIONS(5236),
    [anon_sym_AMP_AMP] = ACTIONS(5236),
    [anon_sym_DASH] = ACTIONS(5238),
    [anon_sym_LBRACE] = ACTIONS(5238),
    [anon_sym_BANG_EQ] = ACTIONS(5238),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_LPAREN] = ACTIONS(5236),
    [anon_sym_RBRACK] = ACTIONS(5236),
    [anon_sym_GT_EQ] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5238),
    [anon_sym_AMP] = ACTIONS(5238),
    [anon_sym_PERCENT] = ACTIONS(5236),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [anon_sym_as] = ACTIONS(5236),
    [anon_sym_PIPE_PIPE] = ACTIONS(5236),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5236),
    [anon_sym_DASH_DASH] = ACTIONS(5236),
    [anon_sym_EQ_EQ] = ACTIONS(5238),
    [anon_sym_instanceof] = ACTIONS(5236),
    [anon_sym_LT] = ACTIONS(5238),
    [anon_sym_RPAREN] = ACTIONS(5236),
    [anon_sym_SLASH] = ACTIONS(5238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5236),
    [anon_sym_DOT] = ACTIONS(5236),
    [anon_sym_CARET] = ACTIONS(5236),
    [anon_sym_STAR_STAR] = ACTIONS(5236),
    [anon_sym_PLUS] = ACTIONS(5238),
    [anon_sym_implements] = ACTIONS(5236),
    [anon_sym_GT_GT] = ACTIONS(5238),
    [anon_sym_PLUS_PLUS] = ACTIONS(5236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5236),
    [anon_sym_in] = ACTIONS(5238),
  },
  [2186] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(5236),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_in] = ACTIONS(945),
  },
  [2187] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5240),
    [anon_sym_LBRACK] = ACTIONS(5240),
    [anon_sym_BANG] = ACTIONS(5242),
    [anon_sym_BQUOTE] = ACTIONS(5240),
    [anon_sym_PIPE] = ACTIONS(5242),
    [anon_sym_COMMA] = ACTIONS(5240),
    [anon_sym_LT_LT] = ACTIONS(5240),
    [anon_sym_STAR] = ACTIONS(5242),
    [anon_sym_GT_GT_GT] = ACTIONS(5240),
    [anon_sym_AMP_AMP] = ACTIONS(5240),
    [anon_sym_DASH] = ACTIONS(5242),
    [anon_sym_LBRACE] = ACTIONS(5242),
    [anon_sym_BANG_EQ] = ACTIONS(5242),
    [anon_sym_LT_EQ] = ACTIONS(5240),
    [anon_sym_LPAREN] = ACTIONS(5240),
    [anon_sym_RBRACK] = ACTIONS(5240),
    [anon_sym_GT_EQ] = ACTIONS(5240),
    [anon_sym_GT] = ACTIONS(5242),
    [anon_sym_AMP] = ACTIONS(5242),
    [anon_sym_PERCENT] = ACTIONS(5240),
    [anon_sym_QMARK] = ACTIONS(5240),
    [anon_sym_RBRACE] = ACTIONS(5240),
    [anon_sym_as] = ACTIONS(5240),
    [anon_sym_PIPE_PIPE] = ACTIONS(5240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5240),
    [anon_sym_DASH_DASH] = ACTIONS(5240),
    [anon_sym_EQ_EQ] = ACTIONS(5242),
    [anon_sym_instanceof] = ACTIONS(5240),
    [anon_sym_LT] = ACTIONS(5242),
    [anon_sym_RPAREN] = ACTIONS(5240),
    [anon_sym_SLASH] = ACTIONS(5242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5240),
    [anon_sym_DOT] = ACTIONS(5240),
    [anon_sym_CARET] = ACTIONS(5240),
    [anon_sym_STAR_STAR] = ACTIONS(5240),
    [anon_sym_PLUS] = ACTIONS(5242),
    [anon_sym_implements] = ACTIONS(5240),
    [anon_sym_GT_GT] = ACTIONS(5242),
    [anon_sym_PLUS_PLUS] = ACTIONS(5240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5240),
    [anon_sym_in] = ACTIONS(5242),
  },
  [2188] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(5240),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(5240),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_in] = ACTIONS(945),
  },
  [2189] = {
    [sym_statement_block] = STATE(3049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2609),
  },
  [2190] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5246),
    [anon_sym_LBRACK] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5248),
    [anon_sym_BQUOTE] = ACTIONS(5246),
    [anon_sym_else] = ACTIONS(5246),
    [anon_sym_PIPE] = ACTIONS(5248),
    [anon_sym_COMMA] = ACTIONS(5246),
    [anon_sym_LT_LT] = ACTIONS(5246),
    [anon_sym_STAR] = ACTIONS(5248),
    [anon_sym_GT_GT_GT] = ACTIONS(5246),
    [anon_sym_AMP_AMP] = ACTIONS(5246),
    [anon_sym_DASH] = ACTIONS(5248),
    [anon_sym_LBRACE] = ACTIONS(5248),
    [anon_sym_BANG_EQ] = ACTIONS(5248),
    [anon_sym_LT_EQ] = ACTIONS(5246),
    [anon_sym_LPAREN] = ACTIONS(5246),
    [anon_sym_RBRACK] = ACTIONS(5246),
    [anon_sym_GT_EQ] = ACTIONS(5246),
    [anon_sym_GT] = ACTIONS(5248),
    [anon_sym_AMP] = ACTIONS(5248),
    [anon_sym_PERCENT] = ACTIONS(5246),
    [anon_sym_QMARK] = ACTIONS(5246),
    [anon_sym_RBRACE] = ACTIONS(5246),
    [anon_sym_as] = ACTIONS(5246),
    [anon_sym_PIPE_PIPE] = ACTIONS(5246),
    [anon_sym_while] = ACTIONS(5246),
    [anon_sym_DASH_DASH] = ACTIONS(5246),
    [anon_sym_EQ_EQ] = ACTIONS(5248),
    [anon_sym_instanceof] = ACTIONS(5246),
    [anon_sym_LT] = ACTIONS(5248),
    [anon_sym_RPAREN] = ACTIONS(5246),
    [anon_sym_SLASH] = ACTIONS(5248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5246),
    [anon_sym_COLON] = ACTIONS(5246),
    [anon_sym_DOT] = ACTIONS(5246),
    [anon_sym_CARET] = ACTIONS(5246),
    [anon_sym_STAR_STAR] = ACTIONS(5246),
    [anon_sym_PLUS] = ACTIONS(5248),
    [anon_sym_implements] = ACTIONS(5246),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_PLUS_PLUS] = ACTIONS(5246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5246),
    [anon_sym_in] = ACTIONS(5248),
  },
  [2191] = {
    [anon_sym_GT] = ACTIONS(6411),
    [sym_comment] = ACTIONS(3),
  },
  [2192] = {
    [sym_nested_identifier] = STATE(965),
    [sym_jsx_namespace_name] = STATE(966),
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(6413),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1975),
  },
  [2193] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5299),
    [anon_sym_LBRACK] = ACTIONS(5299),
    [anon_sym_BANG] = ACTIONS(5301),
    [anon_sym_BQUOTE] = ACTIONS(5299),
    [anon_sym_PIPE] = ACTIONS(5301),
    [anon_sym_COMMA] = ACTIONS(5299),
    [anon_sym_LT_LT] = ACTIONS(5299),
    [anon_sym_STAR] = ACTIONS(5301),
    [anon_sym_GT_GT_GT] = ACTIONS(5299),
    [anon_sym_AMP_AMP] = ACTIONS(5299),
    [anon_sym_DASH] = ACTIONS(5301),
    [anon_sym_LBRACE] = ACTIONS(5301),
    [anon_sym_BANG_EQ] = ACTIONS(5301),
    [anon_sym_LT_EQ] = ACTIONS(5299),
    [anon_sym_LPAREN] = ACTIONS(5299),
    [anon_sym_RBRACK] = ACTIONS(5299),
    [anon_sym_GT_EQ] = ACTIONS(5299),
    [anon_sym_GT] = ACTIONS(5301),
    [anon_sym_AMP] = ACTIONS(5301),
    [anon_sym_PERCENT] = ACTIONS(5299),
    [anon_sym_QMARK] = ACTIONS(5299),
    [anon_sym_RBRACE] = ACTIONS(5299),
    [anon_sym_as] = ACTIONS(5299),
    [anon_sym_PIPE_PIPE] = ACTIONS(5299),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5299),
    [anon_sym_DASH_DASH] = ACTIONS(5299),
    [anon_sym_EQ_EQ] = ACTIONS(5301),
    [anon_sym_instanceof] = ACTIONS(5299),
    [anon_sym_LT] = ACTIONS(5301),
    [anon_sym_RPAREN] = ACTIONS(5299),
    [anon_sym_SLASH] = ACTIONS(5301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_DOT] = ACTIONS(5299),
    [anon_sym_CARET] = ACTIONS(5299),
    [anon_sym_STAR_STAR] = ACTIONS(5299),
    [anon_sym_PLUS] = ACTIONS(5301),
    [anon_sym_implements] = ACTIONS(5299),
    [anon_sym_GT_GT] = ACTIONS(5301),
    [anon_sym_PLUS_PLUS] = ACTIONS(5299),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5299),
    [anon_sym_in] = ACTIONS(5301),
  },
  [2194] = {
    [anon_sym_GT] = ACTIONS(6415),
    [sym_comment] = ACTIONS(3),
  },
  [2195] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5339),
    [anon_sym_LBRACK] = ACTIONS(5339),
    [anon_sym_BANG] = ACTIONS(5341),
    [anon_sym_BQUOTE] = ACTIONS(5339),
    [anon_sym_PIPE] = ACTIONS(5341),
    [anon_sym_COMMA] = ACTIONS(5339),
    [anon_sym_LT_LT] = ACTIONS(5339),
    [anon_sym_STAR] = ACTIONS(5341),
    [anon_sym_GT_GT_GT] = ACTIONS(5339),
    [anon_sym_AMP_AMP] = ACTIONS(5339),
    [anon_sym_DASH] = ACTIONS(5341),
    [anon_sym_LBRACE] = ACTIONS(5341),
    [anon_sym_BANG_EQ] = ACTIONS(5341),
    [anon_sym_LT_EQ] = ACTIONS(5339),
    [anon_sym_LPAREN] = ACTIONS(5339),
    [anon_sym_RBRACK] = ACTIONS(5339),
    [anon_sym_GT_EQ] = ACTIONS(5339),
    [anon_sym_GT] = ACTIONS(5341),
    [anon_sym_AMP] = ACTIONS(5341),
    [anon_sym_PERCENT] = ACTIONS(5339),
    [anon_sym_QMARK] = ACTIONS(5339),
    [anon_sym_RBRACE] = ACTIONS(5339),
    [anon_sym_as] = ACTIONS(5339),
    [anon_sym_PIPE_PIPE] = ACTIONS(5339),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5339),
    [anon_sym_DASH_DASH] = ACTIONS(5339),
    [anon_sym_EQ_EQ] = ACTIONS(5341),
    [anon_sym_instanceof] = ACTIONS(5339),
    [anon_sym_LT] = ACTIONS(5341),
    [anon_sym_RPAREN] = ACTIONS(5339),
    [anon_sym_SLASH] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5339),
    [anon_sym_DOT] = ACTIONS(5339),
    [anon_sym_CARET] = ACTIONS(5339),
    [anon_sym_STAR_STAR] = ACTIONS(5339),
    [anon_sym_PLUS] = ACTIONS(5341),
    [anon_sym_implements] = ACTIONS(5339),
    [anon_sym_GT_GT] = ACTIONS(5341),
    [anon_sym_PLUS_PLUS] = ACTIONS(5339),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5339),
    [anon_sym_in] = ACTIONS(5341),
  },
  [2196] = {
    [sym_statement_block] = STATE(3053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2609),
  },
  [2197] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5361),
    [anon_sym_BANG] = ACTIONS(5363),
    [anon_sym_BQUOTE] = ACTIONS(5361),
    [anon_sym_else] = ACTIONS(5361),
    [anon_sym_PIPE] = ACTIONS(5363),
    [anon_sym_COMMA] = ACTIONS(5361),
    [anon_sym_LT_LT] = ACTIONS(5361),
    [anon_sym_STAR] = ACTIONS(5363),
    [anon_sym_GT_GT_GT] = ACTIONS(5361),
    [anon_sym_AMP_AMP] = ACTIONS(5361),
    [anon_sym_DASH] = ACTIONS(5363),
    [anon_sym_LBRACE] = ACTIONS(5363),
    [anon_sym_BANG_EQ] = ACTIONS(5363),
    [anon_sym_LT_EQ] = ACTIONS(5361),
    [anon_sym_LPAREN] = ACTIONS(5361),
    [anon_sym_RBRACK] = ACTIONS(5361),
    [anon_sym_GT_EQ] = ACTIONS(5361),
    [anon_sym_GT] = ACTIONS(5363),
    [anon_sym_AMP] = ACTIONS(5363),
    [anon_sym_PERCENT] = ACTIONS(5361),
    [anon_sym_QMARK] = ACTIONS(5361),
    [anon_sym_RBRACE] = ACTIONS(5361),
    [anon_sym_as] = ACTIONS(5361),
    [anon_sym_PIPE_PIPE] = ACTIONS(5361),
    [anon_sym_while] = ACTIONS(5361),
    [anon_sym_DASH_DASH] = ACTIONS(5361),
    [anon_sym_EQ_EQ] = ACTIONS(5363),
    [anon_sym_instanceof] = ACTIONS(5361),
    [anon_sym_LT] = ACTIONS(5363),
    [anon_sym_RPAREN] = ACTIONS(5361),
    [anon_sym_SLASH] = ACTIONS(5363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5361),
    [anon_sym_COLON] = ACTIONS(5361),
    [anon_sym_DOT] = ACTIONS(5361),
    [anon_sym_CARET] = ACTIONS(5361),
    [anon_sym_STAR_STAR] = ACTIONS(5361),
    [anon_sym_PLUS] = ACTIONS(5363),
    [anon_sym_implements] = ACTIONS(5361),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_PLUS_PLUS] = ACTIONS(5361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5361),
    [anon_sym_in] = ACTIONS(5363),
  },
  [2198] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1255),
    [anon_sym_LBRACK] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_BQUOTE] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1253),
    [anon_sym_COMMA] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1255),
    [anon_sym_STAR] = ACTIONS(1253),
    [anon_sym_GT_GT_GT] = ACTIONS(1255),
    [anon_sym_AMP_AMP] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1253),
    [anon_sym_BANG_EQ] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_LPAREN] = ACTIONS(1255),
    [anon_sym_RBRACK] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_PERCENT] = ACTIONS(1255),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_RBRACE] = ACTIONS(1255),
    [anon_sym_as] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1255),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_EQ_EQ] = ACTIONS(1253),
    [anon_sym_instanceof] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_RPAREN] = ACTIONS(1255),
    [anon_sym_SLASH] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1255),
    [anon_sym_DOT] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_STAR_STAR] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_implements] = ACTIONS(1255),
    [anon_sym_GT_GT] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1255),
    [anon_sym_in] = ACTIONS(1253),
  },
  [2199] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2341),
    [anon_sym_LBRACK] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_BQUOTE] = ACTIONS(2341),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_COMMA] = ACTIONS(2341),
    [anon_sym_LT_LT] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_GT_GT_GT] = ACTIONS(2341),
    [anon_sym_AMP_AMP] = ACTIONS(2341),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_LBRACE] = ACTIONS(2343),
    [anon_sym_BANG_EQ] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2341),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [anon_sym_RBRACK] = ACTIONS(2341),
    [anon_sym_GT_EQ] = ACTIONS(2341),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_EQ_GT] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(2343),
    [anon_sym_PERCENT] = ACTIONS(2341),
    [anon_sym_QMARK] = ACTIONS(2341),
    [anon_sym_RBRACE] = ACTIONS(2341),
    [anon_sym_as] = ACTIONS(2341),
    [anon_sym_PIPE_PIPE] = ACTIONS(2341),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2341),
    [anon_sym_DASH_DASH] = ACTIONS(2341),
    [anon_sym_EQ_EQ] = ACTIONS(2343),
    [anon_sym_instanceof] = ACTIONS(2341),
    [anon_sym_LT] = ACTIONS(2343),
    [anon_sym_RPAREN] = ACTIONS(2341),
    [anon_sym_SLASH] = ACTIONS(2343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1384),
    [anon_sym_DOT] = ACTIONS(2341),
    [anon_sym_CARET] = ACTIONS(2341),
    [anon_sym_STAR_STAR] = ACTIONS(2341),
    [anon_sym_PLUS] = ACTIONS(2343),
    [anon_sym_implements] = ACTIONS(2341),
    [anon_sym_GT_GT] = ACTIONS(2343),
    [anon_sym_PLUS_PLUS] = ACTIONS(2341),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2341),
    [anon_sym_in] = ACTIONS(2343),
  },
  [2200] = {
    [sym_template_string] = STATE(542),
    [aux_sym_array_repeat1] = STATE(1878),
    [sym_type_arguments] = STATE(541),
    [sym_type_annotation] = STATE(1251),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(1347),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1410),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_COMMA] = ACTIONS(5379),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_PIPE_PIPE] = ACTIONS(1426),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1347),
    [anon_sym_instanceof] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_RPAREN] = ACTIONS(3976),
    [anon_sym_SLASH] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1434),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1426),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [2201] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4485),
    [anon_sym_LBRACK] = ACTIONS(4485),
    [anon_sym_BANG] = ACTIONS(4487),
    [anon_sym_BQUOTE] = ACTIONS(4485),
    [anon_sym_PIPE] = ACTIONS(4487),
    [anon_sym_COMMA] = ACTIONS(4485),
    [anon_sym_LT_LT] = ACTIONS(4485),
    [anon_sym_STAR] = ACTIONS(4487),
    [anon_sym_LBRACE] = ACTIONS(4487),
    [anon_sym_AMP_AMP] = ACTIONS(4485),
    [anon_sym_GT_GT_GT] = ACTIONS(4485),
    [anon_sym_DASH] = ACTIONS(4487),
    [anon_sym_BANG_EQ] = ACTIONS(4487),
    [anon_sym_LT_EQ] = ACTIONS(4485),
    [anon_sym_LPAREN] = ACTIONS(4485),
    [anon_sym_RBRACK] = ACTIONS(4485),
    [anon_sym_GT_EQ] = ACTIONS(4485),
    [anon_sym_GT] = ACTIONS(4487),
    [anon_sym_AMP] = ACTIONS(4487),
    [anon_sym_PERCENT] = ACTIONS(4485),
    [anon_sym_QMARK] = ACTIONS(4485),
    [anon_sym_RBRACE] = ACTIONS(4485),
    [anon_sym_as] = ACTIONS(4485),
    [anon_sym_PIPE_PIPE] = ACTIONS(4485),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4485),
    [anon_sym_DASH_DASH] = ACTIONS(4485),
    [anon_sym_EQ_EQ] = ACTIONS(4487),
    [anon_sym_instanceof] = ACTIONS(4485),
    [anon_sym_LT] = ACTIONS(4487),
    [anon_sym_RPAREN] = ACTIONS(4485),
    [anon_sym_SLASH] = ACTIONS(4487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4485),
    [anon_sym_DOT] = ACTIONS(4485),
    [anon_sym_CARET] = ACTIONS(4485),
    [anon_sym_STAR_STAR] = ACTIONS(4485),
    [anon_sym_PLUS] = ACTIONS(4487),
    [anon_sym_implements] = ACTIONS(4485),
    [anon_sym_GT_GT] = ACTIONS(4487),
    [anon_sym_PLUS_PLUS] = ACTIONS(4485),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4485),
    [anon_sym_in] = ACTIONS(4487),
  },
  [2202] = {
    [sym_new_expression] = STATE(3054),
    [sym_augmented_assignment_expression] = STATE(3054),
    [sym_unary_expression] = STATE(3054),
    [sym_update_expression] = STATE(3054),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(3054),
    [sym_regex] = STATE(3054),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3054),
    [sym_non_null_expression] = STATE(3054),
    [sym_as_expression] = STATE(3054),
    [sym_jsx_fragment] = STATE(3054),
    [sym_yield_expression] = STATE(3054),
    [sym_jsx_element] = STATE(3054),
    [sym_internal_module] = STATE(3054),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3054),
    [sym_await_expression] = STATE(3054),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(3054),
    [sym_this] = STATE(3054),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(3054),
    [sym_generator_function] = STATE(3054),
    [sym_call_expression] = STATE(3054),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(3054),
    [sym_ternary_expression] = STATE(3054),
    [sym_binary_expression] = STATE(3054),
    [sym_template_string] = STATE(3054),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3054),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3054),
    [sym_class] = STATE(3054),
    [anon_sym_BANG] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_false] = ACTIONS(6417),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6417),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6419),
    [sym_true] = ACTIONS(6417),
    [anon_sym_yield] = ACTIONS(290),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6417),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
  },
  [2203] = {
    [sym_union_type] = STATE(3055),
    [sym__type] = STATE(3055),
    [sym_constructor_type] = STATE(3055),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1926),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3055),
    [sym_function_type] = STATE(3055),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1927),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4057),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2204] = {
    [sym_identifier] = ACTIONS(6421),
    [sym_comment] = ACTIONS(3),
  },
  [2205] = {
    [sym_union_type] = STATE(3057),
    [sym__type] = STATE(3057),
    [sym_constructor_type] = STATE(3057),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1295),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3057),
    [sym_function_type] = STATE(3057),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1299),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(2641),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(2667),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2206] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4073),
    [anon_sym_LBRACK] = ACTIONS(4073),
    [anon_sym_BANG] = ACTIONS(4071),
    [anon_sym_BQUOTE] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_COMMA] = ACTIONS(4073),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(4071),
    [anon_sym_GT_GT_GT] = ACTIONS(4073),
    [anon_sym_AMP_AMP] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(4071),
    [anon_sym_LBRACE] = ACTIONS(4071),
    [anon_sym_BANG_EQ] = ACTIONS(4071),
    [anon_sym_LT_EQ] = ACTIONS(4073),
    [anon_sym_LPAREN] = ACTIONS(4073),
    [anon_sym_RBRACK] = ACTIONS(4073),
    [anon_sym_GT_EQ] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4071),
    [anon_sym_PERCENT] = ACTIONS(4073),
    [anon_sym_QMARK] = ACTIONS(4073),
    [anon_sym_RBRACE] = ACTIONS(4073),
    [anon_sym_as] = ACTIONS(4073),
    [anon_sym_PIPE_PIPE] = ACTIONS(4073),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4073),
    [anon_sym_DASH_DASH] = ACTIONS(4073),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_instanceof] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_RPAREN] = ACTIONS(4073),
    [anon_sym_SLASH] = ACTIONS(4071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4073),
    [anon_sym_DOT] = ACTIONS(4073),
    [anon_sym_CARET] = ACTIONS(4073),
    [anon_sym_STAR_STAR] = ACTIONS(4073),
    [anon_sym_PLUS] = ACTIONS(4071),
    [anon_sym_implements] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_PLUS_PLUS] = ACTIONS(4073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4073),
    [anon_sym_in] = ACTIONS(4071),
  },
  [2207] = {
    [sym_union_type] = STATE(2220),
    [sym__type] = STATE(2220),
    [sym_constructor_type] = STATE(2220),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1108),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2220),
    [sym_function_type] = STATE(2220),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1109),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2282),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2208] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4077),
    [anon_sym_LBRACK] = ACTIONS(4666),
    [anon_sym_BANG] = ACTIONS(4075),
    [anon_sym_BQUOTE] = ACTIONS(4077),
    [anon_sym_PIPE] = ACTIONS(4075),
    [anon_sym_COMMA] = ACTIONS(4077),
    [anon_sym_LT_LT] = ACTIONS(4077),
    [anon_sym_STAR] = ACTIONS(4075),
    [anon_sym_GT_GT_GT] = ACTIONS(4077),
    [anon_sym_AMP_AMP] = ACTIONS(4077),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_LBRACE] = ACTIONS(4075),
    [anon_sym_BANG_EQ] = ACTIONS(4075),
    [anon_sym_LT_EQ] = ACTIONS(4077),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_RBRACK] = ACTIONS(4077),
    [anon_sym_GT_EQ] = ACTIONS(4077),
    [anon_sym_GT] = ACTIONS(4075),
    [anon_sym_AMP] = ACTIONS(4075),
    [anon_sym_PERCENT] = ACTIONS(4077),
    [anon_sym_QMARK] = ACTIONS(4077),
    [anon_sym_RBRACE] = ACTIONS(4077),
    [anon_sym_as] = ACTIONS(4077),
    [anon_sym_PIPE_PIPE] = ACTIONS(4077),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4077),
    [anon_sym_DASH_DASH] = ACTIONS(4077),
    [anon_sym_EQ_EQ] = ACTIONS(4075),
    [anon_sym_instanceof] = ACTIONS(4077),
    [anon_sym_LT] = ACTIONS(4075),
    [anon_sym_RPAREN] = ACTIONS(4077),
    [anon_sym_SLASH] = ACTIONS(4075),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4077),
    [anon_sym_DOT] = ACTIONS(4077),
    [anon_sym_CARET] = ACTIONS(4077),
    [anon_sym_STAR_STAR] = ACTIONS(4077),
    [anon_sym_PLUS] = ACTIONS(4075),
    [anon_sym_implements] = ACTIONS(4077),
    [anon_sym_GT_GT] = ACTIONS(4075),
    [anon_sym_PLUS_PLUS] = ACTIONS(4077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4077),
    [anon_sym_in] = ACTIONS(4075),
  },
  [2209] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(3058),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(3058),
    [sym_call_signature] = STATE(3058),
    [sym_export_statement] = STATE(3058),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(3058),
    [sym_index_signature] = STATE(3058),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [2210] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_BANG] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4103),
    [anon_sym_COMMA] = ACTIONS(4105),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_STAR] = ACTIONS(4103),
    [anon_sym_GT_GT_GT] = ACTIONS(4105),
    [anon_sym_AMP_AMP] = ACTIONS(4105),
    [anon_sym_DASH] = ACTIONS(4103),
    [anon_sym_LBRACE] = ACTIONS(4103),
    [anon_sym_BANG_EQ] = ACTIONS(4103),
    [anon_sym_LT_EQ] = ACTIONS(4105),
    [anon_sym_LPAREN] = ACTIONS(4105),
    [anon_sym_RBRACK] = ACTIONS(4105),
    [anon_sym_GT_EQ] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4103),
    [anon_sym_PERCENT] = ACTIONS(4105),
    [anon_sym_QMARK] = ACTIONS(4105),
    [anon_sym_RBRACE] = ACTIONS(4105),
    [anon_sym_as] = ACTIONS(4105),
    [anon_sym_PIPE_PIPE] = ACTIONS(4105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4105),
    [anon_sym_DASH_DASH] = ACTIONS(4105),
    [anon_sym_EQ_EQ] = ACTIONS(4103),
    [anon_sym_instanceof] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(4103),
    [anon_sym_RPAREN] = ACTIONS(4105),
    [anon_sym_SLASH] = ACTIONS(4103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4105),
    [anon_sym_DOT] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(4105),
    [anon_sym_STAR_STAR] = ACTIONS(4105),
    [anon_sym_PLUS] = ACTIONS(4103),
    [anon_sym_implements] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_PLUS_PLUS] = ACTIONS(4105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4105),
    [anon_sym_in] = ACTIONS(4103),
  },
  [2211] = {
    [aux_sym_object_type_repeat1] = STATE(3061),
    [sym__automatic_semicolon] = ACTIONS(6423),
    [anon_sym_RBRACE] = ACTIONS(6425),
    [anon_sym_SEMI] = ACTIONS(6423),
    [anon_sym_COMMA] = ACTIONS(6423),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6425),
    [sym_comment] = ACTIONS(3),
  },
  [2212] = {
    [aux_sym_implements_clause_repeat1] = STATE(3063),
    [anon_sym_AMP] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_COMMA] = ACTIONS(4165),
    [anon_sym_RBRACK] = ACTIONS(6427),
    [sym_comment] = ACTIONS(3),
  },
  [2213] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4173),
    [anon_sym_BANG] = ACTIONS(4171),
    [anon_sym_BQUOTE] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4171),
    [anon_sym_COMMA] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4171),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_AMP_AMP] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4171),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4173),
    [anon_sym_LPAREN] = ACTIONS(4173),
    [anon_sym_RBRACK] = ACTIONS(4173),
    [anon_sym_GT_EQ] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4171),
    [anon_sym_AMP] = ACTIONS(4171),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_QMARK] = ACTIONS(4173),
    [anon_sym_RBRACE] = ACTIONS(4173),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_PIPE_PIPE] = ACTIONS(4173),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4173),
    [anon_sym_DASH_DASH] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_instanceof] = ACTIONS(4173),
    [anon_sym_LT] = ACTIONS(4171),
    [anon_sym_RPAREN] = ACTIONS(4173),
    [anon_sym_SLASH] = ACTIONS(4171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4173),
    [anon_sym_DOT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_STAR_STAR] = ACTIONS(4173),
    [anon_sym_PLUS] = ACTIONS(4171),
    [anon_sym_implements] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4171),
    [anon_sym_PLUS_PLUS] = ACTIONS(4173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4173),
    [anon_sym_in] = ACTIONS(4171),
  },
  [2214] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4177),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(4175),
    [anon_sym_BQUOTE] = ACTIONS(4177),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_LT_LT] = ACTIONS(4177),
    [anon_sym_STAR] = ACTIONS(4175),
    [anon_sym_GT_GT_GT] = ACTIONS(4177),
    [anon_sym_AMP_AMP] = ACTIONS(4177),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4177),
    [anon_sym_LPAREN] = ACTIONS(4177),
    [anon_sym_RBRACK] = ACTIONS(4177),
    [anon_sym_GT_EQ] = ACTIONS(4177),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(4177),
    [anon_sym_QMARK] = ACTIONS(4177),
    [anon_sym_RBRACE] = ACTIONS(4177),
    [anon_sym_as] = ACTIONS(4177),
    [anon_sym_PIPE_PIPE] = ACTIONS(4177),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4177),
    [anon_sym_DASH_DASH] = ACTIONS(4177),
    [anon_sym_EQ_EQ] = ACTIONS(4175),
    [anon_sym_instanceof] = ACTIONS(4177),
    [anon_sym_LT] = ACTIONS(4175),
    [anon_sym_RPAREN] = ACTIONS(4177),
    [anon_sym_SLASH] = ACTIONS(4175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4177),
    [anon_sym_DOT] = ACTIONS(2615),
    [anon_sym_CARET] = ACTIONS(4177),
    [anon_sym_STAR_STAR] = ACTIONS(4177),
    [anon_sym_PLUS] = ACTIONS(4175),
    [anon_sym_implements] = ACTIONS(4177),
    [anon_sym_GT_GT] = ACTIONS(4175),
    [anon_sym_PLUS_PLUS] = ACTIONS(4177),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4177),
    [anon_sym_in] = ACTIONS(4175),
  },
  [2215] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4185),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [anon_sym_BANG] = ACTIONS(4183),
    [anon_sym_BQUOTE] = ACTIONS(4185),
    [anon_sym_PIPE] = ACTIONS(4183),
    [anon_sym_COMMA] = ACTIONS(4185),
    [anon_sym_LT_LT] = ACTIONS(4185),
    [anon_sym_STAR] = ACTIONS(4183),
    [anon_sym_GT_GT_GT] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4185),
    [anon_sym_DASH] = ACTIONS(4183),
    [anon_sym_LBRACE] = ACTIONS(4183),
    [anon_sym_BANG_EQ] = ACTIONS(4183),
    [anon_sym_LT_EQ] = ACTIONS(4185),
    [anon_sym_LPAREN] = ACTIONS(4185),
    [anon_sym_RBRACK] = ACTIONS(4185),
    [anon_sym_GT_EQ] = ACTIONS(4185),
    [anon_sym_GT] = ACTIONS(4183),
    [anon_sym_AMP] = ACTIONS(4183),
    [anon_sym_PERCENT] = ACTIONS(4185),
    [anon_sym_QMARK] = ACTIONS(4185),
    [anon_sym_RBRACE] = ACTIONS(4185),
    [anon_sym_as] = ACTIONS(4185),
    [anon_sym_PIPE_PIPE] = ACTIONS(4185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4185),
    [anon_sym_DASH_DASH] = ACTIONS(4185),
    [anon_sym_EQ_EQ] = ACTIONS(4183),
    [anon_sym_instanceof] = ACTIONS(4185),
    [anon_sym_LT] = ACTIONS(4183),
    [anon_sym_RPAREN] = ACTIONS(4185),
    [anon_sym_SLASH] = ACTIONS(4183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4185),
    [anon_sym_DOT] = ACTIONS(4646),
    [anon_sym_CARET] = ACTIONS(4185),
    [anon_sym_STAR_STAR] = ACTIONS(4185),
    [anon_sym_PLUS] = ACTIONS(4183),
    [anon_sym_implements] = ACTIONS(4185),
    [anon_sym_GT_GT] = ACTIONS(4183),
    [anon_sym_PLUS_PLUS] = ACTIONS(4185),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4185),
    [anon_sym_in] = ACTIONS(4183),
  },
  [2216] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4191),
    [anon_sym_LBRACK] = ACTIONS(4191),
    [anon_sym_BANG] = ACTIONS(4189),
    [anon_sym_BQUOTE] = ACTIONS(4191),
    [anon_sym_PIPE] = ACTIONS(4189),
    [anon_sym_COMMA] = ACTIONS(4191),
    [anon_sym_LT_LT] = ACTIONS(4191),
    [anon_sym_STAR] = ACTIONS(4189),
    [anon_sym_GT_GT_GT] = ACTIONS(4191),
    [anon_sym_AMP_AMP] = ACTIONS(4191),
    [anon_sym_DASH] = ACTIONS(4189),
    [anon_sym_LBRACE] = ACTIONS(4189),
    [anon_sym_BANG_EQ] = ACTIONS(4189),
    [anon_sym_LT_EQ] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(4191),
    [anon_sym_RBRACK] = ACTIONS(4191),
    [anon_sym_GT_EQ] = ACTIONS(4191),
    [anon_sym_GT] = ACTIONS(4189),
    [anon_sym_AMP] = ACTIONS(4189),
    [anon_sym_PERCENT] = ACTIONS(4191),
    [anon_sym_QMARK] = ACTIONS(4191),
    [anon_sym_RBRACE] = ACTIONS(4191),
    [anon_sym_as] = ACTIONS(4191),
    [anon_sym_PIPE_PIPE] = ACTIONS(4191),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4191),
    [anon_sym_DASH_DASH] = ACTIONS(4191),
    [anon_sym_EQ_EQ] = ACTIONS(4189),
    [anon_sym_instanceof] = ACTIONS(4191),
    [anon_sym_LT] = ACTIONS(4189),
    [anon_sym_RPAREN] = ACTIONS(4191),
    [anon_sym_SLASH] = ACTIONS(4189),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4191),
    [anon_sym_DOT] = ACTIONS(4191),
    [anon_sym_CARET] = ACTIONS(4191),
    [anon_sym_STAR_STAR] = ACTIONS(4191),
    [anon_sym_PLUS] = ACTIONS(4189),
    [anon_sym_implements] = ACTIONS(4191),
    [anon_sym_GT_GT] = ACTIONS(4189),
    [anon_sym_PLUS_PLUS] = ACTIONS(4191),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4191),
    [anon_sym_in] = ACTIONS(4189),
  },
  [2217] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4181),
    [anon_sym_LBRACK] = ACTIONS(4181),
    [anon_sym_BANG] = ACTIONS(4179),
    [anon_sym_BQUOTE] = ACTIONS(4181),
    [anon_sym_PIPE] = ACTIONS(4179),
    [anon_sym_COMMA] = ACTIONS(4181),
    [anon_sym_LT_LT] = ACTIONS(4181),
    [anon_sym_STAR] = ACTIONS(4179),
    [anon_sym_GT_GT_GT] = ACTIONS(4181),
    [anon_sym_AMP_AMP] = ACTIONS(4181),
    [anon_sym_DASH] = ACTIONS(4179),
    [anon_sym_LBRACE] = ACTIONS(4179),
    [anon_sym_BANG_EQ] = ACTIONS(4179),
    [anon_sym_LT_EQ] = ACTIONS(4181),
    [anon_sym_LPAREN] = ACTIONS(4181),
    [anon_sym_RBRACK] = ACTIONS(4181),
    [anon_sym_GT_EQ] = ACTIONS(4181),
    [anon_sym_GT] = ACTIONS(4179),
    [anon_sym_AMP] = ACTIONS(4179),
    [anon_sym_PERCENT] = ACTIONS(4181),
    [anon_sym_QMARK] = ACTIONS(4181),
    [anon_sym_RBRACE] = ACTIONS(4181),
    [anon_sym_as] = ACTIONS(4181),
    [anon_sym_PIPE_PIPE] = ACTIONS(4181),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4181),
    [anon_sym_DASH_DASH] = ACTIONS(4181),
    [anon_sym_EQ_EQ] = ACTIONS(4179),
    [anon_sym_instanceof] = ACTIONS(4181),
    [anon_sym_LT] = ACTIONS(4179),
    [anon_sym_RPAREN] = ACTIONS(4181),
    [anon_sym_SLASH] = ACTIONS(4179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4181),
    [anon_sym_DOT] = ACTIONS(4181),
    [anon_sym_CARET] = ACTIONS(4181),
    [anon_sym_STAR_STAR] = ACTIONS(4181),
    [anon_sym_PLUS] = ACTIONS(4179),
    [anon_sym_implements] = ACTIONS(4181),
    [anon_sym_GT_GT] = ACTIONS(4179),
    [anon_sym_PLUS_PLUS] = ACTIONS(4181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4181),
    [anon_sym_in] = ACTIONS(4179),
  },
  [2218] = {
    [sym_formal_parameters] = STATE(3064),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2219] = {
    [anon_sym_EQ_GT] = ACTIONS(6429),
    [sym_comment] = ACTIONS(3),
  },
  [2220] = {
    [anon_sym_AMP] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(6431),
    [anon_sym_PIPE] = ACTIONS(4221),
    [sym_comment] = ACTIONS(3),
  },
  [2221] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4227),
    [anon_sym_LBRACK] = ACTIONS(4227),
    [anon_sym_BANG] = ACTIONS(4225),
    [anon_sym_BQUOTE] = ACTIONS(4227),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_COMMA] = ACTIONS(4227),
    [anon_sym_LT_LT] = ACTIONS(4227),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_GT_GT_GT] = ACTIONS(4227),
    [anon_sym_AMP_AMP] = ACTIONS(4227),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_LBRACE] = ACTIONS(4225),
    [anon_sym_BANG_EQ] = ACTIONS(4225),
    [anon_sym_LT_EQ] = ACTIONS(4227),
    [anon_sym_LPAREN] = ACTIONS(4227),
    [anon_sym_RBRACK] = ACTIONS(4227),
    [anon_sym_GT_EQ] = ACTIONS(4227),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4227),
    [anon_sym_QMARK] = ACTIONS(4227),
    [anon_sym_RBRACE] = ACTIONS(4227),
    [anon_sym_as] = ACTIONS(4227),
    [anon_sym_PIPE_PIPE] = ACTIONS(4227),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4227),
    [anon_sym_DASH_DASH] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4225),
    [anon_sym_instanceof] = ACTIONS(4227),
    [anon_sym_LT] = ACTIONS(4225),
    [anon_sym_RPAREN] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4227),
    [anon_sym_DOT] = ACTIONS(4227),
    [anon_sym_CARET] = ACTIONS(4227),
    [anon_sym_STAR_STAR] = ACTIONS(4227),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_implements] = ACTIONS(4227),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_PLUS_PLUS] = ACTIONS(4227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4227),
    [anon_sym_in] = ACTIONS(4225),
  },
  [2222] = {
    [sym_union_type] = STATE(3067),
    [sym__type] = STATE(3067),
    [sym_constructor_type] = STATE(3067),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1295),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3067),
    [sym_function_type] = STATE(3067),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1299),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(2641),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(2667),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2223] = {
    [sym_union_type] = STATE(3068),
    [sym__type] = STATE(3068),
    [sym_constructor_type] = STATE(3068),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1295),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3068),
    [sym_function_type] = STATE(3068),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1299),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(2641),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(2667),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2224] = {
    [sym_union_type] = STATE(3069),
    [sym__type] = STATE(3069),
    [sym_constructor_type] = STATE(3069),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1926),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3069),
    [sym_function_type] = STATE(3069),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1927),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4057),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2225] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4239),
    [anon_sym_LBRACK] = ACTIONS(4239),
    [anon_sym_BANG] = ACTIONS(4237),
    [anon_sym_BQUOTE] = ACTIONS(4239),
    [anon_sym_PIPE] = ACTIONS(4237),
    [anon_sym_COMMA] = ACTIONS(4239),
    [anon_sym_LT_LT] = ACTIONS(4239),
    [anon_sym_STAR] = ACTIONS(4237),
    [anon_sym_GT_GT_GT] = ACTIONS(4239),
    [anon_sym_AMP_AMP] = ACTIONS(4239),
    [anon_sym_DASH] = ACTIONS(4237),
    [anon_sym_LBRACE] = ACTIONS(4237),
    [anon_sym_BANG_EQ] = ACTIONS(4237),
    [anon_sym_LT_EQ] = ACTIONS(4239),
    [anon_sym_LPAREN] = ACTIONS(4239),
    [anon_sym_RBRACK] = ACTIONS(4239),
    [anon_sym_GT_EQ] = ACTIONS(4239),
    [anon_sym_GT] = ACTIONS(4237),
    [anon_sym_AMP] = ACTIONS(4237),
    [anon_sym_PERCENT] = ACTIONS(4239),
    [anon_sym_QMARK] = ACTIONS(4239),
    [anon_sym_RBRACE] = ACTIONS(4239),
    [anon_sym_as] = ACTIONS(4239),
    [anon_sym_PIPE_PIPE] = ACTIONS(4239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4239),
    [anon_sym_DASH_DASH] = ACTIONS(4239),
    [anon_sym_EQ_EQ] = ACTIONS(4237),
    [anon_sym_instanceof] = ACTIONS(4239),
    [anon_sym_LT] = ACTIONS(4237),
    [anon_sym_RPAREN] = ACTIONS(4239),
    [anon_sym_SLASH] = ACTIONS(4237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4239),
    [anon_sym_DOT] = ACTIONS(4239),
    [anon_sym_CARET] = ACTIONS(4239),
    [anon_sym_STAR_STAR] = ACTIONS(4239),
    [anon_sym_PLUS] = ACTIONS(4237),
    [anon_sym_implements] = ACTIONS(4239),
    [anon_sym_GT_GT] = ACTIONS(4237),
    [anon_sym_PLUS_PLUS] = ACTIONS(4239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4239),
    [anon_sym_in] = ACTIONS(4237),
  },
  [2226] = {
    [anon_sym_EQ_GT] = ACTIONS(6433),
    [sym_comment] = ACTIONS(3),
  },
  [2227] = {
    [anon_sym_RBRACK] = ACTIONS(6435),
    [sym_comment] = ACTIONS(3),
  },
  [2228] = {
    [sym_union_type] = STATE(3072),
    [sym__type] = STATE(3072),
    [sym_constructor_type] = STATE(3072),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1295),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3072),
    [sym_function_type] = STATE(3072),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1299),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(2641),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(2667),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2229] = {
    [sym_identifier] = ACTIONS(6437),
    [sym_comment] = ACTIONS(3),
  },
  [2230] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(937),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(937),
    [anon_sym_AMP_EQ] = ACTIONS(937),
    [anon_sym_PLUS_EQ] = ACTIONS(937),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_CARET_EQ] = ACTIONS(937),
    [anon_sym_STAR_EQ] = ACTIONS(937),
    [anon_sym_PIPE_EQ] = ACTIONS(937),
    [anon_sym_DASH_EQ] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(937),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(937),
    [anon_sym_GT_GT_EQ] = ACTIONS(937),
    [anon_sym_DOT] = ACTIONS(6439),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(945),
  },
  [2231] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4181),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(4179),
    [anon_sym_COMMA] = ACTIONS(4181),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(4179),
    [anon_sym_AMP] = ACTIONS(4179),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [2232] = {
    [sym_class_body] = STATE(3075),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(959),
  },
  [2233] = {
    [sym_class_heritage] = STATE(3076),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(3075),
    [anon_sym_extends] = ACTIONS(1131),
    [anon_sym_implements] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(959),
  },
  [2234] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5539),
    [anon_sym_LBRACK] = ACTIONS(5539),
    [anon_sym_BANG] = ACTIONS(5541),
    [anon_sym_BQUOTE] = ACTIONS(5539),
    [anon_sym_else] = ACTIONS(5539),
    [anon_sym_PIPE] = ACTIONS(5541),
    [anon_sym_COMMA] = ACTIONS(5539),
    [anon_sym_LT_LT] = ACTIONS(5539),
    [anon_sym_STAR] = ACTIONS(5541),
    [anon_sym_GT_GT_GT] = ACTIONS(5539),
    [anon_sym_AMP_AMP] = ACTIONS(5539),
    [anon_sym_DASH] = ACTIONS(5541),
    [anon_sym_LBRACE] = ACTIONS(5541),
    [anon_sym_BANG_EQ] = ACTIONS(5541),
    [anon_sym_LT_EQ] = ACTIONS(5539),
    [anon_sym_LPAREN] = ACTIONS(5539),
    [anon_sym_RBRACK] = ACTIONS(5539),
    [anon_sym_GT_EQ] = ACTIONS(5539),
    [anon_sym_GT] = ACTIONS(5541),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_PERCENT] = ACTIONS(5539),
    [anon_sym_QMARK] = ACTIONS(5539),
    [anon_sym_RBRACE] = ACTIONS(5539),
    [anon_sym_as] = ACTIONS(5539),
    [anon_sym_PIPE_PIPE] = ACTIONS(5539),
    [anon_sym_while] = ACTIONS(5539),
    [anon_sym_DASH_DASH] = ACTIONS(5539),
    [anon_sym_EQ_EQ] = ACTIONS(5541),
    [anon_sym_instanceof] = ACTIONS(5539),
    [anon_sym_LT] = ACTIONS(5541),
    [anon_sym_RPAREN] = ACTIONS(5539),
    [anon_sym_SLASH] = ACTIONS(5541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5539),
    [anon_sym_COLON] = ACTIONS(5539),
    [anon_sym_DOT] = ACTIONS(5539),
    [anon_sym_CARET] = ACTIONS(5539),
    [anon_sym_STAR_STAR] = ACTIONS(5539),
    [anon_sym_PLUS] = ACTIONS(5541),
    [anon_sym_implements] = ACTIONS(5539),
    [anon_sym_GT_GT] = ACTIONS(5541),
    [anon_sym_PLUS_PLUS] = ACTIONS(5539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5539),
    [anon_sym_in] = ACTIONS(5541),
  },
  [2235] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5543),
    [anon_sym_LBRACK] = ACTIONS(5543),
    [anon_sym_BANG] = ACTIONS(5545),
    [anon_sym_BQUOTE] = ACTIONS(5543),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_COMMA] = ACTIONS(5543),
    [anon_sym_LT_LT] = ACTIONS(5543),
    [anon_sym_STAR] = ACTIONS(5545),
    [anon_sym_GT_GT_GT] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_DASH] = ACTIONS(5545),
    [anon_sym_LBRACE] = ACTIONS(5545),
    [anon_sym_BANG_EQ] = ACTIONS(5545),
    [anon_sym_LT_EQ] = ACTIONS(5543),
    [anon_sym_LPAREN] = ACTIONS(5543),
    [anon_sym_RBRACK] = ACTIONS(5543),
    [anon_sym_GT_EQ] = ACTIONS(5543),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5545),
    [anon_sym_PERCENT] = ACTIONS(5543),
    [anon_sym_QMARK] = ACTIONS(5543),
    [anon_sym_RBRACE] = ACTIONS(5543),
    [anon_sym_as] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5543),
    [anon_sym_DASH_DASH] = ACTIONS(5543),
    [anon_sym_EQ_EQ] = ACTIONS(5545),
    [anon_sym_instanceof] = ACTIONS(5543),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_RPAREN] = ACTIONS(5543),
    [anon_sym_SLASH] = ACTIONS(5545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_DOT] = ACTIONS(5543),
    [anon_sym_CARET] = ACTIONS(5543),
    [anon_sym_STAR_STAR] = ACTIONS(5543),
    [anon_sym_PLUS] = ACTIONS(5545),
    [anon_sym_implements] = ACTIONS(5543),
    [anon_sym_GT_GT] = ACTIONS(5545),
    [anon_sym_PLUS_PLUS] = ACTIONS(5543),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5543),
    [anon_sym_in] = ACTIONS(5545),
  },
  [2236] = {
    [anon_sym_COLON] = ACTIONS(1513),
    [anon_sym_GT] = ACTIONS(6441),
    [anon_sym_DOT] = ACTIONS(5744),
    [sym_comment] = ACTIONS(3),
  },
  [2237] = {
    [anon_sym_COLON] = ACTIONS(1513),
    [anon_sym_GT] = ACTIONS(6441),
    [sym_comment] = ACTIONS(3),
  },
  [2238] = {
    [anon_sym_DOT] = ACTIONS(5744),
    [anon_sym_GT] = ACTIONS(6441),
    [sym_comment] = ACTIONS(3),
  },
  [2239] = {
    [anon_sym_GT] = ACTIONS(6441),
    [sym_comment] = ACTIONS(3),
  },
  [2240] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2773),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(1995),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_GT_GT_GT] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_BANG_EQ] = ACTIONS(2727),
    [anon_sym_LT_EQ] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_QMARK] = ACTIONS(2789),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2727),
    [anon_sym_instanceof] = ACTIONS(2771),
    [anon_sym_LT] = ACTIONS(2795),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_STAR_STAR] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_implements] = ACTIONS(1995),
    [anon_sym_GT_GT] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2771),
    [anon_sym_in] = ACTIONS(2727),
  },
  [2241] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_GT_GT_GT] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(2795),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_implements] = ACTIONS(1999),
    [anon_sym_GT_GT] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2242] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2773),
    [anon_sym_COMMA] = ACTIONS(2003),
    [anon_sym_LT_LT] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2003),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_GT_GT_GT] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_BANG_EQ] = ACTIONS(2727),
    [anon_sym_LT_EQ] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_QMARK] = ACTIONS(2789),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2727),
    [anon_sym_instanceof] = ACTIONS(2771),
    [anon_sym_LT] = ACTIONS(2795),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_STAR_STAR] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_implements] = ACTIONS(2003),
    [anon_sym_GT_GT] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2771),
    [anon_sym_in] = ACTIONS(2727),
  },
  [2243] = {
    [aux_sym_implements_clause_repeat1] = STATE(3080),
    [anon_sym_GT] = ACTIONS(6443),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_COMMA] = ACTIONS(6445),
    [sym_comment] = ACTIONS(3),
  },
  [2244] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2773),
    [anon_sym_COMMA] = ACTIONS(2005),
    [anon_sym_LT_LT] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2005),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_GT_GT_GT] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_BANG_EQ] = ACTIONS(2727),
    [anon_sym_LT_EQ] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_QMARK] = ACTIONS(2789),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2727),
    [anon_sym_instanceof] = ACTIONS(2771),
    [anon_sym_LT] = ACTIONS(2795),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_STAR_STAR] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_implements] = ACTIONS(2005),
    [anon_sym_GT_GT] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2771),
    [anon_sym_in] = ACTIONS(2727),
  },
  [2245] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [anon_sym_PERCENT_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_AMP_EQ] = ACTIONS(2011),
    [anon_sym_PLUS_EQ] = ACTIONS(2011),
    [anon_sym_PIPE] = ACTIONS(2013),
    [anon_sym_COMMA] = ACTIONS(6447),
    [anon_sym_LT_LT] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_LBRACE] = ACTIONS(6450),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2011),
    [anon_sym_GT_GT_GT] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_CARET_EQ] = ACTIONS(2011),
    [anon_sym_STAR_EQ] = ACTIONS(2011),
    [anon_sym_PIPE_EQ] = ACTIONS(2011),
    [anon_sym_DASH_EQ] = ACTIONS(2011),
    [anon_sym_AMP] = ACTIONS(2013),
    [anon_sym_PERCENT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_LT_LT_EQ] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6447),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_instanceof] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(6450),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_DOT] = ACTIONS(6453),
    [anon_sym_CARET] = ACTIONS(2013),
    [anon_sym_STAR_STAR] = ACTIONS(2013),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_implements] = ACTIONS(6447),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2013),
  },
  [2246] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2773),
    [anon_sym_COMMA] = ACTIONS(2101),
    [anon_sym_LT_LT] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2101),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_GT_GT_GT] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_BANG_EQ] = ACTIONS(2727),
    [anon_sym_LT_EQ] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_QMARK] = ACTIONS(2789),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2727),
    [anon_sym_instanceof] = ACTIONS(2771),
    [anon_sym_LT] = ACTIONS(2795),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_STAR_STAR] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_implements] = ACTIONS(2101),
    [anon_sym_GT_GT] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2771),
    [anon_sym_in] = ACTIONS(2727),
  },
  [2247] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2773),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(2105),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_GT_GT_GT] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_BANG_EQ] = ACTIONS(2727),
    [anon_sym_LT_EQ] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_QMARK] = ACTIONS(2789),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2727),
    [anon_sym_instanceof] = ACTIONS(2771),
    [anon_sym_LT] = ACTIONS(2795),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_STAR_STAR] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_implements] = ACTIONS(2105),
    [anon_sym_GT_GT] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2771),
    [anon_sym_in] = ACTIONS(2727),
  },
  [2248] = {
    [sym_new_expression] = STATE(3081),
    [sym_augmented_assignment_expression] = STATE(3081),
    [sym_unary_expression] = STATE(3081),
    [sym_update_expression] = STATE(3081),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(3081),
    [sym_regex] = STATE(3081),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2185),
    [sym__expression] = STATE(3081),
    [sym_non_null_expression] = STATE(3081),
    [sym_yield_expression] = STATE(3081),
    [sym_jsx_fragment] = STATE(3081),
    [sym_jsx_element] = STATE(3081),
    [sym_as_expression] = STATE(3081),
    [sym_internal_module] = STATE(3081),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3081),
    [sym_await_expression] = STATE(3081),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(3081),
    [sym_this] = STATE(3081),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(3081),
    [sym_generator_function] = STATE(3081),
    [sym_call_expression] = STATE(3081),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(3081),
    [sym_ternary_expression] = STATE(3081),
    [sym_binary_expression] = STATE(3081),
    [sym_template_string] = STATE(3081),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3081),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3081),
    [sym_class] = STATE(3081),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(2733),
    [sym_false] = ACTIONS(6456),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6456),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6458),
    [sym_true] = ACTIONS(6456),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6456),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [2249] = {
    [sym_new_expression] = STATE(3082),
    [sym_augmented_assignment_expression] = STATE(3082),
    [sym_unary_expression] = STATE(3082),
    [sym_update_expression] = STATE(3082),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(3082),
    [sym_regex] = STATE(3082),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2187),
    [sym__expression] = STATE(3082),
    [sym_non_null_expression] = STATE(3082),
    [sym_yield_expression] = STATE(3082),
    [sym_jsx_fragment] = STATE(3082),
    [sym_jsx_element] = STATE(3082),
    [sym_as_expression] = STATE(3082),
    [sym_internal_module] = STATE(3082),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3082),
    [sym_await_expression] = STATE(3082),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(3082),
    [sym_this] = STATE(3082),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(3082),
    [sym_generator_function] = STATE(3082),
    [sym_call_expression] = STATE(3082),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(3082),
    [sym_ternary_expression] = STATE(3082),
    [sym_binary_expression] = STATE(3082),
    [sym_template_string] = STATE(3082),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3082),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3082),
    [sym_class] = STATE(3082),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(2733),
    [sym_false] = ACTIONS(6460),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6460),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6462),
    [sym_true] = ACTIONS(6460),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6460),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [2250] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_BANG] = ACTIONS(3357),
    [anon_sym_BQUOTE] = ACTIONS(3355),
    [anon_sym_PIPE] = ACTIONS(3357),
    [anon_sym_COMMA] = ACTIONS(3355),
    [anon_sym_LT_LT] = ACTIONS(3355),
    [anon_sym_STAR] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_AMP_AMP] = ACTIONS(3355),
    [anon_sym_GT_GT_GT] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_BANG_EQ] = ACTIONS(3357),
    [anon_sym_LT_EQ] = ACTIONS(3355),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_GT_EQ] = ACTIONS(3355),
    [anon_sym_GT] = ACTIONS(3357),
    [anon_sym_AMP] = ACTIONS(3357),
    [anon_sym_PERCENT] = ACTIONS(3355),
    [anon_sym_QMARK] = ACTIONS(3355),
    [anon_sym_as] = ACTIONS(3357),
    [anon_sym_PIPE_PIPE] = ACTIONS(3355),
    [anon_sym_DASH_DASH] = ACTIONS(3355),
    [anon_sym_EQ_EQ] = ACTIONS(3357),
    [anon_sym_instanceof] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_SLASH] = ACTIONS(3357),
    [sym_comment] = ACTIONS(3),
    [sym_regex_flags] = ACTIONS(4627),
    [anon_sym_DOT] = ACTIONS(3355),
    [anon_sym_CARET] = ACTIONS(3355),
    [anon_sym_STAR_STAR] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_implements] = ACTIONS(3357),
    [anon_sym_GT_GT] = ACTIONS(3357),
    [anon_sym_PLUS_PLUS] = ACTIONS(3355),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3355),
    [anon_sym_in] = ACTIONS(3357),
  },
  [2251] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_GT_GT_GT] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_BANG_EQ] = ACTIONS(2727),
    [anon_sym_LT_EQ] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2727),
    [anon_sym_instanceof] = ACTIONS(2771),
    [anon_sym_LT] = ACTIONS(2795),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_implements] = ACTIONS(1999),
    [anon_sym_GT_GT] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2771),
    [anon_sym_in] = ACTIONS(2727),
  },
  [2252] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2727),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2773),
    [anon_sym_COMMA] = ACTIONS(6464),
    [anon_sym_LT_LT] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(6464),
    [anon_sym_GT_GT_GT] = ACTIONS(2775),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_BANG_EQ] = ACTIONS(2727),
    [anon_sym_LT_EQ] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_QMARK] = ACTIONS(2789),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2727),
    [anon_sym_instanceof] = ACTIONS(2771),
    [anon_sym_LT] = ACTIONS(2795),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_STAR_STAR] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_implements] = ACTIONS(6464),
    [anon_sym_GT_GT] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2771),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [2253] = {
    [anon_sym_implements] = ACTIONS(6464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6464),
    [anon_sym_COMMA] = ACTIONS(6464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6466),
  },
  [2254] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_GT_GT_GT] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6468),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_implements] = ACTIONS(1999),
    [anon_sym_GT_GT] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2255] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6468),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_implements] = ACTIONS(1999),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2256] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_GT_GT_GT] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_BANG_EQ] = ACTIONS(2727),
    [anon_sym_LT_EQ] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2727),
    [anon_sym_instanceof] = ACTIONS(2771),
    [anon_sym_LT] = ACTIONS(2795),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_implements] = ACTIONS(1999),
    [anon_sym_GT_GT] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2771),
    [anon_sym_in] = ACTIONS(2727),
  },
  [2257] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3630),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6471),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [2258] = {
    [sym_type_arguments] = STATE(2206),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(4638),
    [anon_sym_BANG] = ACTIONS(3699),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_GT_GT_GT] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(6473),
    [anon_sym_GT] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_instanceof] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(4643),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4646),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_STAR_STAR] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_implements] = ACTIONS(2204),
    [anon_sym_GT_GT] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2204),
    [anon_sym_in] = ACTIONS(3699),
  },
  [2259] = {
    [sym_index_type_query] = STATE(2208),
    [sym_lookup_type] = STATE(2208),
    [sym_flow_maybe_type] = STATE(2208),
    [sym_parenthesized_type] = STATE(2208),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_array_type] = STATE(2208),
    [sym_type_predicate] = STATE(2208),
    [sym_type_query] = STATE(2208),
    [sym_existential_type] = STATE(2208),
    [sym_this_type] = STATE(2208),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(2208),
    [sym__primary_type] = STATE(2208),
    [sym_generic_type] = STATE(2208),
    [sym_literal_type] = STATE(2208),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(2208),
    [sym_string] = STATE(1279),
    [sym_tuple_type] = STATE(2208),
    [sym_identifier] = ACTIONS(4743),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(4749),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [sym_true] = ACTIONS(2643),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(4648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2260] = {
    [sym_union_type] = STATE(2213),
    [sym__type] = STATE(2213),
    [sym_constructor_type] = STATE(2213),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2263),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2213),
    [sym_function_type] = STATE(2213),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2264),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(4743),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(4749),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(4747),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(4751),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(4745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2261] = {
    [sym_type_parameters] = STATE(3085),
    [sym_formal_parameters] = STATE(3086),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2262] = {
    [sym_union_type] = STATE(2221),
    [sym__type] = STATE(2221),
    [sym_constructor_type] = STATE(2221),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2263),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2221),
    [sym_function_type] = STATE(2221),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2264),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(4743),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(4749),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(4747),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(4751),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(4745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2263] = {
    [sym_formal_parameters] = STATE(3089),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2264] = {
    [anon_sym_EQ_GT] = ACTIONS(6475),
    [sym_comment] = ACTIONS(3),
  },
  [2265] = {
    [sym__initializer] = STATE(522),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2714),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2714),
    [anon_sym_AMP_EQ] = ACTIONS(2714),
    [anon_sym_PLUS_EQ] = ACTIONS(2714),
    [anon_sym_PIPE] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_is] = ACTIONS(2208),
    [anon_sym_GT] = ACTIONS(3738),
    [anon_sym_EQ] = ACTIONS(2718),
    [anon_sym_CARET_EQ] = ACTIONS(2714),
    [anon_sym_STAR_EQ] = ACTIONS(2714),
    [anon_sym_PIPE_EQ] = ACTIONS(2714),
    [anon_sym_DASH_EQ] = ACTIONS(2714),
    [anon_sym_EQ_GT] = ACTIONS(2720),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2714),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2714),
    [anon_sym_GT_GT_EQ] = ACTIONS(2714),
    [anon_sym_DOT] = ACTIONS(4670),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2714),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2727),
  },
  [2266] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(2718),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_EQ_GT] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_implements] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2267] = {
    [sym_new_expression] = STATE(1327),
    [sym_augmented_assignment_expression] = STATE(1327),
    [sym_unary_expression] = STATE(1327),
    [sym_update_expression] = STATE(1327),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(1327),
    [sym_regex] = STATE(1327),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1327),
    [sym_non_null_expression] = STATE(1327),
    [sym_as_expression] = STATE(1327),
    [sym_jsx_fragment] = STATE(1327),
    [sym_yield_expression] = STATE(1327),
    [sym_jsx_element] = STATE(1327),
    [sym_internal_module] = STATE(1327),
    [sym_nested_identifier] = STATE(1092),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1327),
    [sym_await_expression] = STATE(1327),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(1327),
    [sym_this] = STATE(1327),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(1327),
    [sym_generator_function] = STATE(1327),
    [sym_call_expression] = STATE(1327),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(1327),
    [sym_ternary_expression] = STATE(1327),
    [sym_binary_expression] = STATE(1327),
    [sym_template_string] = STATE(1327),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1327),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1327),
    [sym_class] = STATE(1327),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(6477),
    [sym_false] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2735),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2737),
    [sym_true] = ACTIONS(2735),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2735),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [2268] = {
    [sym_new_expression] = STATE(1328),
    [sym_augmented_assignment_expression] = STATE(1328),
    [sym_unary_expression] = STATE(1328),
    [sym_update_expression] = STATE(1328),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(1328),
    [sym_regex] = STATE(1328),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1328),
    [sym_non_null_expression] = STATE(1328),
    [sym_as_expression] = STATE(1328),
    [sym_jsx_fragment] = STATE(1328),
    [sym_yield_expression] = STATE(1328),
    [sym_jsx_element] = STATE(1328),
    [sym_internal_module] = STATE(1328),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1328),
    [sym_await_expression] = STATE(1328),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(1328),
    [sym_this] = STATE(1328),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(1328),
    [sym_generator_function] = STATE(1328),
    [sym_call_expression] = STATE(1328),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(1328),
    [sym_ternary_expression] = STATE(1328),
    [sym_binary_expression] = STATE(1328),
    [sym_template_string] = STATE(1328),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1328),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1328),
    [sym_class] = STATE(1328),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(2733),
    [sym_false] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2739),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4674),
    [sym_true] = ACTIONS(2739),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2739),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [2269] = {
    [sym_new_expression] = STATE(1327),
    [sym_augmented_assignment_expression] = STATE(1327),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(1327),
    [sym_update_expression] = STATE(1327),
    [sym_regex] = STATE(1327),
    [sym_meta_property] = STATE(1327),
    [sym_call_signature] = STATE(610),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1327),
    [sym_non_null_expression] = STATE(1327),
    [sym_yield_expression] = STATE(1327),
    [sym_jsx_fragment] = STATE(1327),
    [sym_jsx_element] = STATE(1327),
    [sym_as_expression] = STATE(1327),
    [sym_internal_module] = STATE(1327),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1327),
    [sym_await_expression] = STATE(1327),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(1327),
    [sym_this] = STATE(1327),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(1327),
    [sym_generator_function] = STATE(1327),
    [sym_call_expression] = STATE(1327),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(1327),
    [sym_ternary_expression] = STATE(1327),
    [sym_binary_expression] = STATE(1327),
    [sym_template_string] = STATE(1327),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1327),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1327),
    [sym_class] = STATE(1327),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2733),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2718),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(1111),
    [sym_true] = ACTIONS(2735),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2729),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2735),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2735),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_EQ_GT] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(2737),
    [anon_sym_SLASH] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2735),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_implements] = ACTIONS(137),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2270] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(1819),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(1820),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(2757),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(2759),
    [anon_sym_symbol] = ACTIONS(2759),
    [anon_sym_number] = ACTIONS(2759),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2759),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2761),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2759),
    [anon_sym_private] = ACTIONS(2759),
    [anon_sym_boolean] = ACTIONS(2759),
    [anon_sym_async] = ACTIONS(2763),
    [anon_sym_public] = ACTIONS(2759),
    [anon_sym_get] = ACTIONS(2759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2759),
    [anon_sym_string] = ACTIONS(2759),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(2759),
    [anon_sym_type] = ACTIONS(2759),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(2759),
    [anon_sym_export] = ACTIONS(2759),
    [anon_sym_namespace] = ACTIONS(2765),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [2271] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6468),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_implements] = ACTIONS(1999),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2272] = {
    [aux_sym_extends_clause_repeat1] = STATE(2272),
    [anon_sym_implements] = ACTIONS(6464),
    [anon_sym_COMMA] = ACTIONS(6479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6464),
  },
  [2273] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2277),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2278),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1121),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4771),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4773),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2274] = {
    [sym_type_parameters] = STATE(3092),
    [sym_formal_parameters] = STATE(3093),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2275] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2277),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2278),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1121),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4771),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4773),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2276] = {
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(6482),
    [anon_sym_PIPE] = ACTIONS(6484),
    [anon_sym_COMMA] = ACTIONS(5893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5893),
  },
  [2277] = {
    [sym_formal_parameters] = STATE(3096),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2278] = {
    [anon_sym_EQ_GT] = ACTIONS(6486),
    [sym_comment] = ACTIONS(3),
  },
  [2279] = {
    [anon_sym_EQ_GT] = ACTIONS(6488),
    [sym_comment] = ACTIONS(3),
  },
  [2280] = {
    [sym_union_type] = STATE(3099),
    [sym__type] = STATE(3099),
    [sym_constructor_type] = STATE(3099),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(623),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3099),
    [sym_function_type] = STATE(3099),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(624),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1121),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2281] = {
    [anon_sym_AMP] = ACTIONS(2805),
    [anon_sym_PIPE] = ACTIONS(2807),
    [anon_sym_COMMA] = ACTIONS(6027),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6027),
  },
  [2282] = {
    [aux_sym_implements_clause_repeat1] = STATE(2282),
    [anon_sym_COMMA] = ACTIONS(6490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6027),
  },
  [2283] = {
    [sym_union_type] = STATE(3100),
    [sym__type] = STATE(3100),
    [sym_constructor_type] = STATE(3100),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(623),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3100),
    [sym_function_type] = STATE(3100),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(624),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1121),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2284] = {
    [anon_sym_AMP] = ACTIONS(2805),
    [anon_sym_PIPE] = ACTIONS(2807),
    [anon_sym_COMMA] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6040),
  },
  [2285] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6493),
    [sym_identifier] = ACTIONS(6495),
    [sym__automatic_semicolon] = ACTIONS(6493),
    [anon_sym_BQUOTE] = ACTIONS(6493),
    [anon_sym_debugger] = ACTIONS(6495),
    [ts_builtin_sym_end] = ACTIONS(6493),
    [anon_sym_symbol] = ACTIONS(6495),
    [anon_sym_AT] = ACTIONS(6493),
    [anon_sym_PIPE] = ACTIONS(6495),
    [anon_sym_COMMA] = ACTIONS(6493),
    [anon_sym_DASH] = ACTIONS(6495),
    [anon_sym_STAR] = ACTIONS(6495),
    [anon_sym_GT_GT_GT] = ACTIONS(6493),
    [anon_sym_void] = ACTIONS(6495),
    [anon_sym_break] = ACTIONS(6495),
    [anon_sym_BANG_EQ] = ACTIONS(6495),
    [anon_sym_const] = ACTIONS(6495),
    [anon_sym_GT_EQ] = ACTIONS(6493),
    [sym_super] = ACTIONS(6495),
    [anon_sym_return] = ACTIONS(6495),
    [anon_sym_private] = ACTIONS(6495),
    [anon_sym_get] = ACTIONS(6495),
    [anon_sym_RBRACE] = ACTIONS(6493),
    [anon_sym_PERCENT] = ACTIONS(6493),
    [anon_sym_interface] = ACTIONS(6495),
    [anon_sym_default] = ACTIONS(6495),
    [anon_sym_as] = ACTIONS(6495),
    [anon_sym_delete] = ACTIONS(6495),
    [anon_sym_continue] = ACTIONS(6495),
    [anon_sym_DASH_DASH] = ACTIONS(6493),
    [anon_sym_if] = ACTIONS(6495),
    [anon_sym_instanceof] = ACTIONS(6495),
    [anon_sym_this] = ACTIONS(6495),
    [anon_sym_yield] = ACTIONS(6495),
    [sym_true] = ACTIONS(6495),
    [anon_sym_throw] = ACTIONS(6495),
    [anon_sym_enum] = ACTIONS(6495),
    [anon_sym_protected] = ACTIONS(6495),
    [anon_sym_abstract] = ACTIONS(6495),
    [anon_sym_DOT] = ACTIONS(6495),
    [anon_sym_set] = ACTIONS(6495),
    [anon_sym_type] = ACTIONS(6495),
    [anon_sym_STAR_STAR] = ACTIONS(6493),
    [anon_sym_import] = ACTIONS(6495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6493),
    [anon_sym_namespace] = ACTIONS(6495),
    [anon_sym_PLUS_PLUS] = ACTIONS(6493),
    [anon_sym_await] = ACTIONS(6495),
    [anon_sym_DQUOTE] = ACTIONS(6493),
    [anon_sym_else] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(6495),
    [anon_sym_for] = ACTIONS(6495),
    [anon_sym_LBRACK] = ACTIONS(6493),
    [sym_false] = ACTIONS(6495),
    [anon_sym_SEMI] = ACTIONS(6493),
    [anon_sym_case] = ACTIONS(6495),
    [anon_sym_module] = ACTIONS(6495),
    [anon_sym_number] = ACTIONS(6495),
    [anon_sym_class] = ACTIONS(6495),
    [anon_sym_declare] = ACTIONS(6495),
    [anon_sym_typeof] = ACTIONS(6495),
    [anon_sym_LT_LT] = ACTIONS(6493),
    [anon_sym_LBRACE] = ACTIONS(6493),
    [anon_sym_AMP_AMP] = ACTIONS(6493),
    [anon_sym_switch] = ACTIONS(6495),
    [anon_sym_LT_EQ] = ACTIONS(6493),
    [anon_sym_LPAREN] = ACTIONS(6493),
    [sym_null] = ACTIONS(6495),
    [anon_sym_GT] = ACTIONS(6495),
    [anon_sym_any] = ACTIONS(6495),
    [anon_sym_boolean] = ACTIONS(6495),
    [anon_sym_async] = ACTIONS(6495),
    [anon_sym_public] = ACTIONS(6495),
    [anon_sym_AMP] = ACTIONS(6495),
    [anon_sym_var] = ACTIONS(6495),
    [anon_sym_QMARK] = ACTIONS(6493),
    [anon_sym_PIPE_PIPE] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_SQUOTE] = ACTIONS(6493),
    [anon_sym_try] = ACTIONS(6495),
    [anon_sym_EQ_EQ] = ACTIONS(6495),
    [anon_sym_RPAREN] = ACTIONS(6493),
    [anon_sym_LT] = ACTIONS(6495),
    [sym_number] = ACTIONS(6493),
    [anon_sym_SLASH] = ACTIONS(6495),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6495),
    [anon_sym_function] = ACTIONS(6495),
    [sym_undefined] = ACTIONS(6495),
    [anon_sym_new] = ACTIONS(6495),
    [anon_sym_CARET] = ACTIONS(6493),
    [anon_sym_let] = ACTIONS(6495),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_export] = ACTIONS(6495),
    [anon_sym_GT_GT] = ACTIONS(6495),
    [anon_sym_do] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6493),
    [anon_sym_with] = ACTIONS(6495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6493),
    [anon_sym_in] = ACTIONS(6495),
  },
  [2286] = {
    [sym_new_expression] = STATE(3101),
    [sym_augmented_assignment_expression] = STATE(3101),
    [sym_unary_expression] = STATE(3101),
    [sym_update_expression] = STATE(3101),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(3101),
    [sym_regex] = STATE(3101),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1233),
    [sym__expression] = STATE(3101),
    [sym_non_null_expression] = STATE(3101),
    [sym_yield_expression] = STATE(3101),
    [sym_jsx_fragment] = STATE(3101),
    [sym_jsx_element] = STATE(3101),
    [sym_as_expression] = STATE(3101),
    [sym_internal_module] = STATE(3101),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3101),
    [sym_await_expression] = STATE(3101),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(3101),
    [sym_this] = STATE(3101),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(3101),
    [sym_generator_function] = STATE(3101),
    [sym_call_expression] = STATE(3101),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(3101),
    [sym_ternary_expression] = STATE(3101),
    [sym_binary_expression] = STATE(3101),
    [sym_template_string] = STATE(3101),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3101),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3101),
    [sym_class] = STATE(3101),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(6497),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6497),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6499),
    [sym_true] = ACTIONS(6497),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6497),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [2287] = {
    [sym_new_expression] = STATE(3102),
    [sym_augmented_assignment_expression] = STATE(3102),
    [sym_unary_expression] = STATE(3102),
    [sym_update_expression] = STATE(3102),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(3102),
    [sym_regex] = STATE(3102),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3102),
    [sym_non_null_expression] = STATE(3102),
    [sym_as_expression] = STATE(3102),
    [sym_jsx_fragment] = STATE(3102),
    [sym_yield_expression] = STATE(3102),
    [sym_jsx_element] = STATE(3102),
    [sym_internal_module] = STATE(3102),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3102),
    [sym_await_expression] = STATE(3102),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(3102),
    [sym_this] = STATE(3102),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(3102),
    [sym_generator_function] = STATE(3102),
    [sym_call_expression] = STATE(3102),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(3102),
    [sym_ternary_expression] = STATE(3102),
    [sym_binary_expression] = STATE(3102),
    [sym_template_string] = STATE(3102),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3102),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3102),
    [sym_class] = STATE(3102),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(6501),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6501),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6503),
    [sym_true] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6501),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [2288] = {
    [sym_new_expression] = STATE(3103),
    [sym_augmented_assignment_expression] = STATE(3103),
    [sym_unary_expression] = STATE(3103),
    [sym_update_expression] = STATE(3103),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(3103),
    [sym_regex] = STATE(3103),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3103),
    [sym_non_null_expression] = STATE(3103),
    [sym_as_expression] = STATE(3103),
    [sym_jsx_fragment] = STATE(3103),
    [sym_yield_expression] = STATE(3103),
    [sym_jsx_element] = STATE(3103),
    [sym_internal_module] = STATE(3103),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3103),
    [sym_await_expression] = STATE(3103),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(3103),
    [sym_this] = STATE(3103),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(3103),
    [sym_generator_function] = STATE(3103),
    [sym_call_expression] = STATE(3103),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(3103),
    [sym_ternary_expression] = STATE(3103),
    [sym_binary_expression] = STATE(3103),
    [sym_template_string] = STATE(3103),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3103),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3103),
    [sym_class] = STATE(3103),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(6505),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6505),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6507),
    [sym_true] = ACTIONS(6505),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6505),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [2289] = {
    [sym_new_expression] = STATE(3104),
    [sym_augmented_assignment_expression] = STATE(3104),
    [sym_unary_expression] = STATE(3104),
    [sym_update_expression] = STATE(3104),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(3104),
    [sym_regex] = STATE(3104),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3104),
    [sym_non_null_expression] = STATE(3104),
    [sym_as_expression] = STATE(3104),
    [sym_jsx_fragment] = STATE(3104),
    [sym_yield_expression] = STATE(3104),
    [sym_jsx_element] = STATE(3104),
    [sym_internal_module] = STATE(3104),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3104),
    [sym_await_expression] = STATE(3104),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(3104),
    [sym_this] = STATE(3104),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(3104),
    [sym_generator_function] = STATE(3104),
    [sym_call_expression] = STATE(3104),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(3104),
    [sym_ternary_expression] = STATE(3104),
    [sym_binary_expression] = STATE(3104),
    [sym_template_string] = STATE(3104),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3104),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3104),
    [sym_class] = STATE(3104),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(6509),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6509),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6511),
    [sym_true] = ACTIONS(6509),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6509),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [2290] = {
    [sym_predefined_type] = STATE(3105),
    [anon_sym_number] = ACTIONS(6513),
    [anon_sym_void] = ACTIONS(6513),
    [anon_sym_string] = ACTIONS(6513),
    [anon_sym_any] = ACTIONS(6513),
    [anon_sym_boolean] = ACTIONS(6513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_symbol] = ACTIONS(6513),
  },
  [2291] = {
    [sym_new_expression] = STATE(3106),
    [sym_augmented_assignment_expression] = STATE(3106),
    [sym_unary_expression] = STATE(3106),
    [sym_update_expression] = STATE(3106),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(3106),
    [sym_regex] = STATE(3106),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1240),
    [sym__expression] = STATE(3106),
    [sym_non_null_expression] = STATE(3106),
    [sym_yield_expression] = STATE(3106),
    [sym_jsx_fragment] = STATE(3106),
    [sym_jsx_element] = STATE(3106),
    [sym_as_expression] = STATE(3106),
    [sym_internal_module] = STATE(3106),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3106),
    [sym_await_expression] = STATE(3106),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(3106),
    [sym_this] = STATE(3106),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(3106),
    [sym_generator_function] = STATE(3106),
    [sym_call_expression] = STATE(3106),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(3106),
    [sym_ternary_expression] = STATE(3106),
    [sym_binary_expression] = STATE(3106),
    [sym_template_string] = STATE(3106),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3106),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3106),
    [sym_class] = STATE(3106),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(6515),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6515),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6517),
    [sym_true] = ACTIONS(6515),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6515),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [2292] = {
    [sym_new_expression] = STATE(3107),
    [sym_augmented_assignment_expression] = STATE(3107),
    [sym_unary_expression] = STATE(3107),
    [sym_update_expression] = STATE(3107),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(3107),
    [sym_regex] = STATE(3107),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3107),
    [sym_non_null_expression] = STATE(3107),
    [sym_as_expression] = STATE(3107),
    [sym_jsx_fragment] = STATE(3107),
    [sym_yield_expression] = STATE(3107),
    [sym_jsx_element] = STATE(3107),
    [sym_internal_module] = STATE(3107),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3107),
    [sym_await_expression] = STATE(3107),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(3107),
    [sym_this] = STATE(3107),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(3107),
    [sym_generator_function] = STATE(3107),
    [sym_call_expression] = STATE(3107),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(3107),
    [sym_ternary_expression] = STATE(3107),
    [sym_binary_expression] = STATE(3107),
    [sym_template_string] = STATE(3107),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3107),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3107),
    [sym_class] = STATE(3107),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(6519),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6519),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6521),
    [sym_true] = ACTIONS(6519),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6519),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [2293] = {
    [sym_predefined_type] = STATE(3108),
    [anon_sym_number] = ACTIONS(6513),
    [anon_sym_void] = ACTIONS(6513),
    [anon_sym_string] = ACTIONS(6513),
    [anon_sym_any] = ACTIONS(6513),
    [anon_sym_boolean] = ACTIONS(6513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_symbol] = ACTIONS(6513),
  },
  [2294] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(6523),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [2295] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(6523),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [2296] = {
    [anon_sym_EQ_GT] = ACTIONS(6526),
    [sym_comment] = ACTIONS(3),
  },
  [2297] = {
    [anon_sym_EQ_GT] = ACTIONS(6528),
    [sym_comment] = ACTIONS(3),
  },
  [2298] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_BQUOTE] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_RBRACK] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_instanceof] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_in] = ACTIONS(841),
  },
  [2299] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4839),
    [anon_sym_LT_LT] = ACTIONS(4841),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_GT_GT_GT] = ACTIONS(4841),
    [anon_sym_AMP_AMP] = ACTIONS(4847),
    [anon_sym_BANG_EQ] = ACTIONS(4795),
    [anon_sym_LT_EQ] = ACTIONS(4837),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(871),
    [anon_sym_GT_EQ] = ACTIONS(4837),
    [anon_sym_GT] = ACTIONS(4795),
    [anon_sym_AMP] = ACTIONS(4851),
    [anon_sym_PERCENT] = ACTIONS(4841),
    [anon_sym_QMARK] = ACTIONS(4853),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(4855),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4795),
    [anon_sym_instanceof] = ACTIONS(4837),
    [anon_sym_LT] = ACTIONS(4859),
    [anon_sym_SLASH] = ACTIONS(4845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4855),
    [anon_sym_STAR_STAR] = ACTIONS(4861),
    [anon_sym_PLUS] = ACTIONS(4843),
    [anon_sym_GT_GT] = ACTIONS(4845),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4837),
    [anon_sym_in] = ACTIONS(4795),
  },
  [2300] = {
    [sym__initializer] = STATE(522),
    [sym_arguments] = STATE(1268),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_RBRACK] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(4791),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1531),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [2301] = {
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_RBRACK] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [2302] = {
    [sym_new_expression] = STATE(836),
    [sym_augmented_assignment_expression] = STATE(836),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(836),
    [sym_update_expression] = STATE(836),
    [sym_regex] = STATE(836),
    [sym_meta_property] = STATE(836),
    [sym_call_signature] = STATE(835),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(836),
    [sym_non_null_expression] = STATE(836),
    [sym_yield_expression] = STATE(836),
    [sym_jsx_fragment] = STATE(836),
    [sym_jsx_element] = STATE(836),
    [sym_as_expression] = STATE(836),
    [sym_internal_module] = STATE(836),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(836),
    [sym_await_expression] = STATE(836),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(836),
    [sym_this] = STATE(836),
    [sym_arguments] = STATE(1270),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(836),
    [sym_generator_function] = STATE(836),
    [sym_call_expression] = STATE(836),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(836),
    [sym_ternary_expression] = STATE(836),
    [sym_binary_expression] = STATE(836),
    [sym_template_string] = STATE(836),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(836),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(836),
    [sym_class] = STATE(836),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(500),
    [sym_true] = ACTIONS(1545),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [sym_false] = ACTIONS(1545),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [anon_sym_RBRACK] = ACTIONS(1539),
    [sym_null] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [sym_number] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [2303] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_arguments] = STATE(1270),
    [sym_call_signature] = STATE(2296),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(4811),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(4813),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(4813),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(4813),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(4813),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_protected] = ACTIONS(4813),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(4813),
    [anon_sym_type] = ACTIONS(4813),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(4813),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(4813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(4813),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(4813),
    [anon_sym_declare] = ACTIONS(4813),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [anon_sym_RBRACK] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(4813),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(4813),
    [anon_sym_async] = ACTIONS(4813),
    [anon_sym_public] = ACTIONS(4813),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(4813),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(4813),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [2304] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_RBRACK] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [2305] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4839),
    [anon_sym_LT_LT] = ACTIONS(4841),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_GT_GT_GT] = ACTIONS(4841),
    [anon_sym_AMP_AMP] = ACTIONS(4847),
    [anon_sym_BANG_EQ] = ACTIONS(4795),
    [anon_sym_LT_EQ] = ACTIONS(4837),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(4837),
    [anon_sym_GT] = ACTIONS(4795),
    [anon_sym_AMP] = ACTIONS(4851),
    [anon_sym_PERCENT] = ACTIONS(4841),
    [anon_sym_QMARK] = ACTIONS(4853),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(4855),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4795),
    [anon_sym_instanceof] = ACTIONS(4837),
    [anon_sym_LT] = ACTIONS(4859),
    [anon_sym_SLASH] = ACTIONS(4845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4855),
    [anon_sym_STAR_STAR] = ACTIONS(4861),
    [anon_sym_PLUS] = ACTIONS(4843),
    [anon_sym_GT_GT] = ACTIONS(4845),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4837),
    [anon_sym_in] = ACTIONS(4795),
  },
  [2306] = {
    [sym_new_expression] = STATE(3111),
    [sym_augmented_assignment_expression] = STATE(3111),
    [sym_unary_expression] = STATE(3111),
    [sym_update_expression] = STATE(3111),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(3111),
    [sym_regex] = STATE(3111),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3111),
    [sym_non_null_expression] = STATE(3111),
    [sym_as_expression] = STATE(3111),
    [sym_jsx_fragment] = STATE(3111),
    [sym_yield_expression] = STATE(3111),
    [sym_jsx_element] = STATE(3111),
    [sym_internal_module] = STATE(3111),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3111),
    [sym_await_expression] = STATE(3111),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(3111),
    [sym_this] = STATE(3111),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(3111),
    [sym_generator_function] = STATE(3111),
    [sym_call_expression] = STATE(3111),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(3111),
    [sym_ternary_expression] = STATE(3111),
    [sym_binary_expression] = STATE(3111),
    [sym_template_string] = STATE(3111),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3111),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3111),
    [sym_class] = STATE(3111),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(6530),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6530),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6532),
    [sym_true] = ACTIONS(6530),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6530),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [2307] = {
    [sym_new_expression] = STATE(3112),
    [sym_augmented_assignment_expression] = STATE(3112),
    [sym_unary_expression] = STATE(3112),
    [sym_update_expression] = STATE(3112),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(3112),
    [sym_regex] = STATE(3112),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3112),
    [sym_non_null_expression] = STATE(3112),
    [sym_as_expression] = STATE(3112),
    [sym_jsx_fragment] = STATE(3112),
    [sym_yield_expression] = STATE(3112),
    [sym_jsx_element] = STATE(3112),
    [sym_internal_module] = STATE(3112),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3112),
    [sym_await_expression] = STATE(3112),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(3112),
    [sym_this] = STATE(3112),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(3112),
    [sym_generator_function] = STATE(3112),
    [sym_call_expression] = STATE(3112),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(3112),
    [sym_ternary_expression] = STATE(3112),
    [sym_binary_expression] = STATE(3112),
    [sym_template_string] = STATE(3112),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3112),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3112),
    [sym_class] = STATE(3112),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(6534),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6534),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6536),
    [sym_true] = ACTIONS(6534),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6534),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [2308] = {
    [sym_new_expression] = STATE(3113),
    [sym_augmented_assignment_expression] = STATE(3113),
    [sym_unary_expression] = STATE(3113),
    [sym_update_expression] = STATE(3113),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(3113),
    [sym_regex] = STATE(3113),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3113),
    [sym_non_null_expression] = STATE(3113),
    [sym_as_expression] = STATE(3113),
    [sym_jsx_fragment] = STATE(3113),
    [sym_yield_expression] = STATE(3113),
    [sym_jsx_element] = STATE(3113),
    [sym_internal_module] = STATE(3113),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3113),
    [sym_await_expression] = STATE(3113),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(3113),
    [sym_this] = STATE(3113),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(3113),
    [sym_generator_function] = STATE(3113),
    [sym_call_expression] = STATE(3113),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(3113),
    [sym_ternary_expression] = STATE(3113),
    [sym_binary_expression] = STATE(3113),
    [sym_template_string] = STATE(3113),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3113),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3113),
    [sym_class] = STATE(3113),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(6538),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6538),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6540),
    [sym_true] = ACTIONS(6538),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6538),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [2309] = {
    [sym_new_expression] = STATE(3114),
    [sym_augmented_assignment_expression] = STATE(3114),
    [sym_unary_expression] = STATE(3114),
    [sym_update_expression] = STATE(3114),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(3114),
    [sym_regex] = STATE(3114),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3114),
    [sym_non_null_expression] = STATE(3114),
    [sym_as_expression] = STATE(3114),
    [sym_jsx_fragment] = STATE(3114),
    [sym_yield_expression] = STATE(3114),
    [sym_jsx_element] = STATE(3114),
    [sym_internal_module] = STATE(3114),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3114),
    [sym_await_expression] = STATE(3114),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(3114),
    [sym_this] = STATE(3114),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(3114),
    [sym_generator_function] = STATE(3114),
    [sym_call_expression] = STATE(3114),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(3114),
    [sym_ternary_expression] = STATE(3114),
    [sym_binary_expression] = STATE(3114),
    [sym_template_string] = STATE(3114),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3114),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3114),
    [sym_class] = STATE(3114),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(6542),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6542),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6544),
    [sym_true] = ACTIONS(6542),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6542),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [2310] = {
    [anon_sym_EQ] = ACTIONS(5088),
    [anon_sym_COLON] = ACTIONS(5088),
    [sym__automatic_semicolon] = ACTIONS(5088),
    [anon_sym_SEMI] = ACTIONS(5088),
    [anon_sym_QMARK] = ACTIONS(5088),
    [anon_sym_LPAREN] = ACTIONS(5088),
    [anon_sym_RBRACE] = ACTIONS(5088),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5088),
    [anon_sym_LT] = ACTIONS(5088),
    [anon_sym_COMMA] = ACTIONS(5088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(5088),
  },
  [2311] = {
    [sym_new_expression] = STATE(3115),
    [sym_augmented_assignment_expression] = STATE(3115),
    [sym_unary_expression] = STATE(3115),
    [sym_update_expression] = STATE(3115),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(3115),
    [sym_regex] = STATE(3115),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3115),
    [sym_non_null_expression] = STATE(3115),
    [sym_as_expression] = STATE(3115),
    [sym_jsx_fragment] = STATE(3115),
    [sym_yield_expression] = STATE(3115),
    [sym_jsx_element] = STATE(3115),
    [sym_internal_module] = STATE(3115),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3115),
    [sym_await_expression] = STATE(3115),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(3115),
    [sym_this] = STATE(3115),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(3115),
    [sym_generator_function] = STATE(3115),
    [sym_call_expression] = STATE(3115),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(3115),
    [sym_ternary_expression] = STATE(3115),
    [sym_binary_expression] = STATE(3115),
    [sym_template_string] = STATE(3115),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3115),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3115),
    [sym_class] = STATE(3115),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(6546),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6546),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6548),
    [sym_true] = ACTIONS(6546),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6546),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [2312] = {
    [sym_union_type] = STATE(1293),
    [sym__type] = STATE(1293),
    [sym_constructor_type] = STATE(1293),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3121),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_template_string] = STATE(1297),
    [sym_intersection_type] = STATE(1293),
    [sym_function_type] = STATE(1293),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3122),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(6550),
    [sym_false] = ACTIONS(2643),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_PIPE] = ACTIONS(6552),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_boolean] = ACTIONS(2647),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(6554),
    [anon_sym_QMARK] = ACTIONS(6556),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2669),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_new] = ACTIONS(6558),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_DQUOTE] = ACTIONS(304),
  },
  [2313] = {
    [sym_new_expression] = STATE(3102),
    [sym_constructor_type] = STATE(432),
    [sym_augmented_assignment_expression] = STATE(3102),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(3102),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(3102),
    [sym_type_parameters] = STATE(959),
    [sym_array_type] = STATE(436),
    [sym_yield_expression] = STATE(3102),
    [sym_as_expression] = STATE(3102),
    [sym_jsx_fragment] = STATE(3102),
    [sym_internal_module] = STATE(3102),
    [sym_arrow_function] = STATE(3102),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(1374),
    [sym_literal_type] = STATE(436),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(1650),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(3102),
    [sym_subscript_expression] = STATE(1374),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(3102),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(3102),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(960),
    [sym_function_type] = STATE(432),
    [sym__type] = STATE(432),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(3102),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(3102),
    [sym__expression] = STATE(3102),
    [sym_non_null_expression] = STATE(3102),
    [sym_jsx_element] = STATE(3102),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_await_expression] = STATE(3102),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_this] = STATE(3102),
    [sym_union_type] = STATE(432),
    [sym_anonymous_class] = STATE(3102),
    [sym_call_expression] = STATE(3102),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(3102),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(3102),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(432),
    [sym_parenthesized_expression] = STATE(3102),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3102),
    [sym_class] = STATE(3102),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(6560),
    [sym_false] = ACTIONS(3450),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(6562),
    [anon_sym_number] = ACTIONS(6562),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(6564),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(6566),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_void] = ACTIONS(6568),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [sym_null] = ACTIONS(6501),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(6562),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(6562),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3462),
    [sym_true] = ACTIONS(3450),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(3464),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(6562),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6501),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(6570),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(6566),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [2314] = {
    [sym_new_expression] = STATE(3129),
    [sym_augmented_assignment_expression] = STATE(3129),
    [sym_unary_expression] = STATE(3129),
    [sym_update_expression] = STATE(3129),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(3129),
    [sym_regex] = STATE(3129),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3129),
    [sym_non_null_expression] = STATE(3129),
    [sym_as_expression] = STATE(3129),
    [sym_jsx_fragment] = STATE(3129),
    [sym_yield_expression] = STATE(3129),
    [sym_jsx_element] = STATE(3129),
    [sym_internal_module] = STATE(3129),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3129),
    [sym_await_expression] = STATE(3129),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(3129),
    [sym_this] = STATE(3129),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(3129),
    [sym_generator_function] = STATE(3129),
    [sym_call_expression] = STATE(3129),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(3129),
    [sym_ternary_expression] = STATE(3129),
    [sym_binary_expression] = STATE(3129),
    [sym_template_string] = STATE(3129),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3129),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3129),
    [sym_class] = STATE(3129),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(6572),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6572),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6574),
    [sym_true] = ACTIONS(6572),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6572),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [2315] = {
    [sym_type_parameters] = STATE(1395),
    [sym_formal_parameters] = STATE(1397),
    [sym_call_signature] = STATE(3130),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2316] = {
    [sym_statement_block] = STATE(3131),
    [sym__automatic_semicolon] = ACTIONS(6576),
    [anon_sym_SEMI] = ACTIONS(6576),
    [anon_sym_COMMA] = ACTIONS(6576),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4899),
  },
  [2317] = {
    [sym_type_parameters] = STATE(1395),
    [sym_formal_parameters] = STATE(1397),
    [sym_call_signature] = STATE(3130),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(6578),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [2318] = {
    [sym_string] = STATE(3133),
    [sym__property_name] = STATE(3133),
    [sym_computed_property_name] = STATE(3133),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_EQ] = ACTIONS(1214),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(6580),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_BANG] = ACTIONS(1214),
  },
  [2319] = {
    [sym_string] = STATE(3133),
    [sym__property_name] = STATE(3133),
    [sym_computed_property_name] = STATE(3133),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(6580),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [2320] = {
    [sym_string] = STATE(3133),
    [sym__property_name] = STATE(3133),
    [sym_computed_property_name] = STATE(3133),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(6582),
    [anon_sym_EQ] = ACTIONS(1214),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(6584),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(6580),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(6584),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_BANG] = ACTIONS(1214),
  },
  [2321] = {
    [sym_type_parameters] = STATE(1395),
    [sym__initializer] = STATE(3138),
    [sym_formal_parameters] = STATE(1397),
    [sym_type_annotation] = STATE(3139),
    [sym_call_signature] = STATE(3130),
    [sym__automatic_semicolon] = ACTIONS(6586),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(6586),
    [anon_sym_QMARK] = ACTIONS(6588),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(6586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(6590),
  },
  [2322] = {
    [sym_string] = STATE(3133),
    [sym__property_name] = STATE(3133),
    [sym_computed_property_name] = STATE(3133),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(6580),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [2323] = {
    [sym_type_parameters] = STATE(1395),
    [sym__initializer] = STATE(3138),
    [sym_formal_parameters] = STATE(1397),
    [sym_type_annotation] = STATE(3139),
    [sym_call_signature] = STATE(3130),
    [sym__automatic_semicolon] = ACTIONS(6586),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(6586),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(6586),
    [sym_comment] = ACTIONS(3),
  },
  [2324] = {
    [sym__initializer] = STATE(3138),
    [sym_type_annotation] = STATE(3139),
    [sym__automatic_semicolon] = ACTIONS(6586),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(6586),
    [anon_sym_COMMA] = ACTIONS(6586),
    [sym_comment] = ACTIONS(3),
  },
  [2325] = {
    [sym__automatic_semicolon] = ACTIONS(6586),
    [anon_sym_SEMI] = ACTIONS(6586),
    [anon_sym_COMMA] = ACTIONS(6586),
    [sym_comment] = ACTIONS(3),
  },
  [2326] = {
    [sym__initializer] = STATE(3138),
    [sym__automatic_semicolon] = ACTIONS(6586),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(6586),
    [anon_sym_COMMA] = ACTIONS(6586),
    [sym_comment] = ACTIONS(3),
  },
  [2327] = {
    [sym__automatic_semicolon] = ACTIONS(2517),
    [anon_sym_LBRACK] = ACTIONS(2517),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_SEMI] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(2517),
    [anon_sym_RBRACE] = ACTIONS(2517),
    [anon_sym_LT] = ACTIONS(2517),
    [anon_sym_COMMA] = ACTIONS(2517),
    [anon_sym_PIPE] = ACTIONS(2519),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2517),
    [anon_sym_EQ] = ACTIONS(2517),
    [anon_sym_COLON] = ACTIONS(2517),
    [anon_sym_LPAREN] = ACTIONS(2517),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2517),
    [anon_sym_BANG] = ACTIONS(2517),
  },
  [2328] = {
    [sym_type_parameters] = STATE(2331),
    [sym_formal_parameters] = STATE(2332),
    [sym_call_signature] = STATE(3141),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(6592),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [2329] = {
    [sym__initializer] = STATE(3138),
    [sym_type_annotation] = STATE(3139),
    [sym__automatic_semicolon] = ACTIONS(6586),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(6586),
    [anon_sym_QMARK] = ACTIONS(6590),
    [anon_sym_COMMA] = ACTIONS(6586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(6590),
  },
  [2330] = {
    [sym_type_parameters] = STATE(2331),
    [sym__initializer] = STATE(3138),
    [sym_formal_parameters] = STATE(2332),
    [sym_type_annotation] = STATE(3139),
    [sym_call_signature] = STATE(3141),
    [sym__automatic_semicolon] = ACTIONS(6586),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(6586),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(6586),
    [sym_comment] = ACTIONS(3),
  },
  [2331] = {
    [sym_formal_parameters] = STATE(3142),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [2332] = {
    [sym_type_annotation] = STATE(1603),
    [sym__automatic_semicolon] = ACTIONS(548),
    [anon_sym_COLON] = ACTIONS(6594),
    [anon_sym_SEMI] = ACTIONS(548),
    [anon_sym_COMMA] = ACTIONS(548),
    [sym_comment] = ACTIONS(3),
  },
  [2333] = {
    [sym__automatic_semicolon] = ACTIONS(6596),
    [anon_sym_SEMI] = ACTIONS(6596),
    [anon_sym_COMMA] = ACTIONS(6596),
    [sym_comment] = ACTIONS(3),
  },
  [2334] = {
    [sym_type_annotation] = STATE(2523),
    [sym__automatic_semicolon] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(4895),
    [anon_sym_SEMI] = ACTIONS(1669),
    [anon_sym_COMMA] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1669),
  },
  [2335] = {
    [sym_union_type] = STATE(3149),
    [sym__type] = STATE(3149),
    [sym_constructor_type] = STATE(3149),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3150),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(3149),
    [sym_function_type] = STATE(3149),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3151),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(6598),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(6600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(6602),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(6604),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(6606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [2336] = {
    [sym_type_alias_declaration] = STATE(3153),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3153),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3153),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3153),
    [sym_return_statement] = STATE(3153),
    [aux_sym_program_repeat1] = STATE(3153),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3153),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3153),
    [sym_switch_statement] = STATE(3153),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3153),
    [sym_throw_statement] = STATE(3153),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3153),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3153),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(3153),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3153),
    [sym_abstract_class] = STATE(3153),
    [sym_interface_declaration] = STATE(3153),
    [sym_statement_block] = STATE(3153),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3153),
    [sym_debugger_statement] = STATE(3153),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3153),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3153),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3153),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3153),
    [sym_empty_statement] = STATE(3153),
    [sym_import_alias] = STATE(3153),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3153),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3153),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3153),
    [sym_break_statement] = STATE(3153),
    [sym_labeled_statement] = STATE(3153),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3153),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(6608),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [2337] = {
    [sym__automatic_semicolon] = ACTIONS(5102),
    [anon_sym_LBRACK] = ACTIONS(5102),
    [sym_identifier] = ACTIONS(6610),
    [anon_sym_SEMI] = ACTIONS(5102),
    [anon_sym_module] = ACTIONS(6610),
    [anon_sym_symbol] = ACTIONS(6610),
    [anon_sym_number] = ACTIONS(6610),
    [anon_sym_AT] = ACTIONS(5102),
    [anon_sym_declare] = ACTIONS(6610),
    [anon_sym_STAR] = ACTIONS(5102),
    [anon_sym_void] = ACTIONS(6610),
    [anon_sym_any] = ACTIONS(6610),
    [anon_sym_private] = ACTIONS(6610),
    [anon_sym_boolean] = ACTIONS(6610),
    [anon_sym_async] = ACTIONS(6610),
    [anon_sym_public] = ACTIONS(6610),
    [anon_sym_get] = ACTIONS(6610),
    [anon_sym_RBRACE] = ACTIONS(5102),
    [anon_sym_static] = ACTIONS(6610),
    [anon_sym_SQUOTE] = ACTIONS(5102),
    [sym_number] = ACTIONS(5102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(6610),
    [anon_sym_string] = ACTIONS(6610),
    [anon_sym_abstract] = ACTIONS(6610),
    [anon_sym_set] = ACTIONS(6610),
    [anon_sym_type] = ACTIONS(6610),
    [anon_sym_import] = ACTIONS(6610),
    [anon_sym_export] = ACTIONS(6610),
    [anon_sym_namespace] = ACTIONS(6610),
    [sym_readonly] = ACTIONS(6610),
    [anon_sym_DQUOTE] = ACTIONS(5102),
  },
  [2338] = {
    [sym_string] = STATE(3156),
    [sym__property_name] = STATE(3156),
    [sym_computed_property_name] = STATE(3156),
    [anon_sym_get] = ACTIONS(6612),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(6614),
    [anon_sym_STAR] = ACTIONS(6582),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(6612),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_async] = ACTIONS(6616),
  },
  [2339] = {
    [sym_string] = STATE(3157),
    [sym__property_name] = STATE(3157),
    [sym_computed_property_name] = STATE(3157),
    [anon_sym_get] = ACTIONS(1135),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(6618),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_async] = ACTIONS(1135),
  },
  [2340] = {
    [sym_string] = STATE(3158),
    [sym__property_name] = STATE(3158),
    [sym_computed_property_name] = STATE(3158),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_EQ] = ACTIONS(1214),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(6620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_BANG] = ACTIONS(1214),
  },
  [2341] = {
    [sym_string] = STATE(3158),
    [sym__property_name] = STATE(3158),
    [sym_computed_property_name] = STATE(3158),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(6620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [2342] = {
    [sym_type_parameters] = STATE(2331),
    [sym__initializer] = STATE(3138),
    [sym_formal_parameters] = STATE(2332),
    [sym_type_annotation] = STATE(3139),
    [sym_call_signature] = STATE(3141),
    [sym__automatic_semicolon] = ACTIONS(6586),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(6586),
    [anon_sym_QMARK] = ACTIONS(6622),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(6586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(6590),
  },
  [2343] = {
    [sym_union_type] = STATE(3165),
    [sym__type] = STATE(3165),
    [sym_constructor_type] = STATE(3165),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(3167),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3165),
    [sym_function_type] = STATE(3165),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3168),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(6624),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(6626),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6628),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6630),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2344] = {
    [sym_identifier] = ACTIONS(4785),
    [anon_sym_BQUOTE] = ACTIONS(4783),
    [anon_sym_debugger] = ACTIONS(4785),
    [anon_sym_symbol] = ACTIONS(4785),
    [anon_sym_AT] = ACTIONS(4783),
    [anon_sym_DASH] = ACTIONS(4785),
    [anon_sym_void] = ACTIONS(4785),
    [anon_sym_break] = ACTIONS(4785),
    [anon_sym_const] = ACTIONS(4785),
    [sym_super] = ACTIONS(4785),
    [anon_sym_return] = ACTIONS(4785),
    [anon_sym_private] = ACTIONS(4785),
    [anon_sym_get] = ACTIONS(4785),
    [anon_sym_RBRACE] = ACTIONS(4783),
    [anon_sym_interface] = ACTIONS(4785),
    [anon_sym_default] = ACTIONS(4785),
    [anon_sym_enum] = ACTIONS(4785),
    [anon_sym_delete] = ACTIONS(4785),
    [anon_sym_continue] = ACTIONS(4785),
    [anon_sym_DASH_DASH] = ACTIONS(4783),
    [anon_sym_if] = ACTIONS(4785),
    [anon_sym_this] = ACTIONS(4785),
    [anon_sym_yield] = ACTIONS(4785),
    [sym_true] = ACTIONS(4785),
    [anon_sym_throw] = ACTIONS(4785),
    [anon_sym_protected] = ACTIONS(4785),
    [anon_sym_abstract] = ACTIONS(4785),
    [anon_sym_set] = ACTIONS(4785),
    [anon_sym_type] = ACTIONS(4785),
    [anon_sym_import] = ACTIONS(4785),
    [anon_sym_namespace] = ACTIONS(4785),
    [anon_sym_PLUS_PLUS] = ACTIONS(4783),
    [anon_sym_await] = ACTIONS(4785),
    [anon_sym_DQUOTE] = ACTIONS(4783),
    [anon_sym_else] = ACTIONS(4785),
    [anon_sym_BANG] = ACTIONS(4783),
    [anon_sym_for] = ACTIONS(4785),
    [anon_sym_LBRACK] = ACTIONS(4783),
    [sym_false] = ACTIONS(4785),
    [anon_sym_SEMI] = ACTIONS(4783),
    [anon_sym_case] = ACTIONS(4785),
    [anon_sym_module] = ACTIONS(4785),
    [anon_sym_number] = ACTIONS(4785),
    [anon_sym_class] = ACTIONS(4785),
    [anon_sym_declare] = ACTIONS(4785),
    [anon_sym_typeof] = ACTIONS(4785),
    [anon_sym_LBRACE] = ACTIONS(4783),
    [anon_sym_switch] = ACTIONS(4785),
    [anon_sym_LPAREN] = ACTIONS(4783),
    [sym_null] = ACTIONS(4785),
    [anon_sym_any] = ACTIONS(4785),
    [anon_sym_boolean] = ACTIONS(4785),
    [anon_sym_async] = ACTIONS(4785),
    [anon_sym_public] = ACTIONS(4785),
    [anon_sym_var] = ACTIONS(4785),
    [anon_sym_while] = ACTIONS(4785),
    [anon_sym_SQUOTE] = ACTIONS(4783),
    [anon_sym_try] = ACTIONS(4785),
    [anon_sym_LT] = ACTIONS(4783),
    [sym_number] = ACTIONS(4783),
    [anon_sym_SLASH] = ACTIONS(4785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4785),
    [anon_sym_function] = ACTIONS(4785),
    [sym_undefined] = ACTIONS(4785),
    [anon_sym_new] = ACTIONS(4785),
    [ts_builtin_sym_end] = ACTIONS(4783),
    [anon_sym_let] = ACTIONS(4785),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_export] = ACTIONS(4785),
    [anon_sym_do] = ACTIONS(4785),
    [anon_sym_TILDE] = ACTIONS(4783),
    [anon_sym_with] = ACTIONS(4785),
  },
  [2345] = {
    [sym_class_body] = STATE(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2467),
  },
  [2346] = {
    [sym_statement_block] = STATE(3170),
    [sym__automatic_semicolon] = ACTIONS(5244),
    [anon_sym_SEMI] = ACTIONS(5244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [2347] = {
    [sym_identifier] = ACTIONS(5248),
    [anon_sym_BQUOTE] = ACTIONS(5246),
    [anon_sym_debugger] = ACTIONS(5248),
    [anon_sym_symbol] = ACTIONS(5248),
    [anon_sym_AT] = ACTIONS(5246),
    [anon_sym_DASH] = ACTIONS(5248),
    [anon_sym_void] = ACTIONS(5248),
    [anon_sym_break] = ACTIONS(5248),
    [anon_sym_const] = ACTIONS(5248),
    [sym_super] = ACTIONS(5248),
    [anon_sym_return] = ACTIONS(5248),
    [anon_sym_private] = ACTIONS(5248),
    [anon_sym_get] = ACTIONS(5248),
    [anon_sym_RBRACE] = ACTIONS(5246),
    [anon_sym_interface] = ACTIONS(5248),
    [anon_sym_default] = ACTIONS(5248),
    [anon_sym_enum] = ACTIONS(5248),
    [anon_sym_delete] = ACTIONS(5248),
    [anon_sym_continue] = ACTIONS(5248),
    [anon_sym_DASH_DASH] = ACTIONS(5246),
    [anon_sym_if] = ACTIONS(5248),
    [anon_sym_this] = ACTIONS(5248),
    [anon_sym_yield] = ACTIONS(5248),
    [sym_true] = ACTIONS(5248),
    [anon_sym_throw] = ACTIONS(5248),
    [anon_sym_protected] = ACTIONS(5248),
    [anon_sym_abstract] = ACTIONS(5248),
    [anon_sym_set] = ACTIONS(5248),
    [anon_sym_type] = ACTIONS(5248),
    [anon_sym_import] = ACTIONS(5248),
    [anon_sym_namespace] = ACTIONS(5248),
    [anon_sym_PLUS_PLUS] = ACTIONS(5246),
    [anon_sym_await] = ACTIONS(5248),
    [anon_sym_DQUOTE] = ACTIONS(5246),
    [anon_sym_else] = ACTIONS(5248),
    [anon_sym_BANG] = ACTIONS(5246),
    [anon_sym_for] = ACTIONS(5248),
    [anon_sym_LBRACK] = ACTIONS(5246),
    [sym_false] = ACTIONS(5248),
    [anon_sym_SEMI] = ACTIONS(5246),
    [anon_sym_case] = ACTIONS(5248),
    [anon_sym_module] = ACTIONS(5248),
    [anon_sym_number] = ACTIONS(5248),
    [anon_sym_class] = ACTIONS(5248),
    [anon_sym_declare] = ACTIONS(5248),
    [anon_sym_typeof] = ACTIONS(5248),
    [anon_sym_LBRACE] = ACTIONS(5246),
    [anon_sym_switch] = ACTIONS(5248),
    [anon_sym_LPAREN] = ACTIONS(5246),
    [sym_null] = ACTIONS(5248),
    [anon_sym_any] = ACTIONS(5248),
    [anon_sym_boolean] = ACTIONS(5248),
    [anon_sym_async] = ACTIONS(5248),
    [anon_sym_public] = ACTIONS(5248),
    [anon_sym_var] = ACTIONS(5248),
    [anon_sym_while] = ACTIONS(5248),
    [anon_sym_SQUOTE] = ACTIONS(5246),
    [anon_sym_try] = ACTIONS(5248),
    [anon_sym_LT] = ACTIONS(5246),
    [sym_number] = ACTIONS(5246),
    [anon_sym_SLASH] = ACTIONS(5248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5248),
    [anon_sym_function] = ACTIONS(5248),
    [sym_undefined] = ACTIONS(5248),
    [anon_sym_new] = ACTIONS(5248),
    [ts_builtin_sym_end] = ACTIONS(5246),
    [anon_sym_let] = ACTIONS(5248),
    [anon_sym_PLUS] = ACTIONS(5248),
    [anon_sym_export] = ACTIONS(5248),
    [anon_sym_do] = ACTIONS(5248),
    [anon_sym_TILDE] = ACTIONS(5246),
    [anon_sym_with] = ACTIONS(5248),
  },
  [2348] = {
    [sym_statement_block] = STATE(3171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [2349] = {
    [sym_identifier] = ACTIONS(5363),
    [anon_sym_BQUOTE] = ACTIONS(5361),
    [anon_sym_debugger] = ACTIONS(5363),
    [anon_sym_symbol] = ACTIONS(5363),
    [anon_sym_AT] = ACTIONS(5361),
    [anon_sym_DASH] = ACTIONS(5363),
    [anon_sym_void] = ACTIONS(5363),
    [anon_sym_break] = ACTIONS(5363),
    [anon_sym_const] = ACTIONS(5363),
    [sym_super] = ACTIONS(5363),
    [anon_sym_return] = ACTIONS(5363),
    [anon_sym_private] = ACTIONS(5363),
    [anon_sym_get] = ACTIONS(5363),
    [anon_sym_RBRACE] = ACTIONS(5361),
    [anon_sym_interface] = ACTIONS(5363),
    [anon_sym_default] = ACTIONS(5363),
    [anon_sym_enum] = ACTIONS(5363),
    [anon_sym_delete] = ACTIONS(5363),
    [anon_sym_continue] = ACTIONS(5363),
    [anon_sym_DASH_DASH] = ACTIONS(5361),
    [anon_sym_if] = ACTIONS(5363),
    [anon_sym_this] = ACTIONS(5363),
    [anon_sym_yield] = ACTIONS(5363),
    [sym_true] = ACTIONS(5363),
    [anon_sym_throw] = ACTIONS(5363),
    [anon_sym_protected] = ACTIONS(5363),
    [anon_sym_abstract] = ACTIONS(5363),
    [anon_sym_set] = ACTIONS(5363),
    [anon_sym_type] = ACTIONS(5363),
    [anon_sym_import] = ACTIONS(5363),
    [anon_sym_namespace] = ACTIONS(5363),
    [anon_sym_PLUS_PLUS] = ACTIONS(5361),
    [anon_sym_await] = ACTIONS(5363),
    [anon_sym_DQUOTE] = ACTIONS(5361),
    [anon_sym_else] = ACTIONS(5363),
    [anon_sym_BANG] = ACTIONS(5361),
    [anon_sym_for] = ACTIONS(5363),
    [anon_sym_LBRACK] = ACTIONS(5361),
    [sym_false] = ACTIONS(5363),
    [anon_sym_SEMI] = ACTIONS(5361),
    [anon_sym_case] = ACTIONS(5363),
    [anon_sym_module] = ACTIONS(5363),
    [anon_sym_number] = ACTIONS(5363),
    [anon_sym_class] = ACTIONS(5363),
    [anon_sym_declare] = ACTIONS(5363),
    [anon_sym_typeof] = ACTIONS(5363),
    [anon_sym_LBRACE] = ACTIONS(5361),
    [anon_sym_switch] = ACTIONS(5363),
    [anon_sym_LPAREN] = ACTIONS(5361),
    [sym_null] = ACTIONS(5363),
    [anon_sym_any] = ACTIONS(5363),
    [anon_sym_boolean] = ACTIONS(5363),
    [anon_sym_async] = ACTIONS(5363),
    [anon_sym_public] = ACTIONS(5363),
    [anon_sym_var] = ACTIONS(5363),
    [anon_sym_while] = ACTIONS(5363),
    [anon_sym_SQUOTE] = ACTIONS(5361),
    [anon_sym_try] = ACTIONS(5363),
    [anon_sym_LT] = ACTIONS(5361),
    [sym_number] = ACTIONS(5361),
    [anon_sym_SLASH] = ACTIONS(5363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5363),
    [anon_sym_function] = ACTIONS(5363),
    [sym_undefined] = ACTIONS(5363),
    [anon_sym_new] = ACTIONS(5363),
    [ts_builtin_sym_end] = ACTIONS(5361),
    [anon_sym_let] = ACTIONS(5363),
    [anon_sym_PLUS] = ACTIONS(5363),
    [anon_sym_export] = ACTIONS(5363),
    [anon_sym_do] = ACTIONS(5363),
    [anon_sym_TILDE] = ACTIONS(5361),
    [anon_sym_with] = ACTIONS(5363),
  },
  [2350] = {
    [sym_class_body] = STATE(3172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2467),
  },
  [2351] = {
    [sym_class_heritage] = STATE(3173),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(3172),
    [anon_sym_extends] = ACTIONS(1131),
    [anon_sym_implements] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2467),
  },
  [2352] = {
    [sym_identifier] = ACTIONS(5541),
    [anon_sym_BQUOTE] = ACTIONS(5539),
    [anon_sym_debugger] = ACTIONS(5541),
    [anon_sym_symbol] = ACTIONS(5541),
    [anon_sym_AT] = ACTIONS(5539),
    [anon_sym_DASH] = ACTIONS(5541),
    [anon_sym_void] = ACTIONS(5541),
    [anon_sym_break] = ACTIONS(5541),
    [anon_sym_const] = ACTIONS(5541),
    [sym_super] = ACTIONS(5541),
    [anon_sym_return] = ACTIONS(5541),
    [anon_sym_private] = ACTIONS(5541),
    [anon_sym_get] = ACTIONS(5541),
    [anon_sym_RBRACE] = ACTIONS(5539),
    [anon_sym_interface] = ACTIONS(5541),
    [anon_sym_default] = ACTIONS(5541),
    [anon_sym_enum] = ACTIONS(5541),
    [anon_sym_delete] = ACTIONS(5541),
    [anon_sym_continue] = ACTIONS(5541),
    [anon_sym_DASH_DASH] = ACTIONS(5539),
    [anon_sym_if] = ACTIONS(5541),
    [anon_sym_this] = ACTIONS(5541),
    [anon_sym_yield] = ACTIONS(5541),
    [sym_true] = ACTIONS(5541),
    [anon_sym_throw] = ACTIONS(5541),
    [anon_sym_protected] = ACTIONS(5541),
    [anon_sym_abstract] = ACTIONS(5541),
    [anon_sym_set] = ACTIONS(5541),
    [anon_sym_type] = ACTIONS(5541),
    [anon_sym_import] = ACTIONS(5541),
    [anon_sym_namespace] = ACTIONS(5541),
    [anon_sym_PLUS_PLUS] = ACTIONS(5539),
    [anon_sym_await] = ACTIONS(5541),
    [anon_sym_DQUOTE] = ACTIONS(5539),
    [anon_sym_else] = ACTIONS(5541),
    [anon_sym_BANG] = ACTIONS(5539),
    [anon_sym_for] = ACTIONS(5541),
    [anon_sym_LBRACK] = ACTIONS(5539),
    [sym_false] = ACTIONS(5541),
    [anon_sym_SEMI] = ACTIONS(5539),
    [anon_sym_case] = ACTIONS(5541),
    [anon_sym_module] = ACTIONS(5541),
    [anon_sym_number] = ACTIONS(5541),
    [anon_sym_class] = ACTIONS(5541),
    [anon_sym_declare] = ACTIONS(5541),
    [anon_sym_typeof] = ACTIONS(5541),
    [anon_sym_LBRACE] = ACTIONS(5539),
    [anon_sym_switch] = ACTIONS(5541),
    [anon_sym_LPAREN] = ACTIONS(5539),
    [sym_null] = ACTIONS(5541),
    [anon_sym_any] = ACTIONS(5541),
    [anon_sym_boolean] = ACTIONS(5541),
    [anon_sym_async] = ACTIONS(5541),
    [anon_sym_public] = ACTIONS(5541),
    [anon_sym_var] = ACTIONS(5541),
    [anon_sym_while] = ACTIONS(5541),
    [anon_sym_SQUOTE] = ACTIONS(5539),
    [anon_sym_try] = ACTIONS(5541),
    [anon_sym_LT] = ACTIONS(5539),
    [sym_number] = ACTIONS(5539),
    [anon_sym_SLASH] = ACTIONS(5541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5541),
    [anon_sym_function] = ACTIONS(5541),
    [sym_undefined] = ACTIONS(5541),
    [anon_sym_new] = ACTIONS(5541),
    [ts_builtin_sym_end] = ACTIONS(5539),
    [anon_sym_let] = ACTIONS(5541),
    [anon_sym_PLUS] = ACTIONS(5541),
    [anon_sym_export] = ACTIONS(5541),
    [anon_sym_do] = ACTIONS(5541),
    [anon_sym_TILDE] = ACTIONS(5539),
    [anon_sym_with] = ACTIONS(5541),
  },
  [2353] = {
    [sym_new_expression] = STATE(3174),
    [sym_augmented_assignment_expression] = STATE(3174),
    [sym_unary_expression] = STATE(3174),
    [sym_update_expression] = STATE(3174),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(3174),
    [sym_regex] = STATE(3174),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(343),
    [sym__expression] = STATE(3174),
    [sym_non_null_expression] = STATE(3174),
    [sym_yield_expression] = STATE(3174),
    [sym_jsx_fragment] = STATE(3174),
    [sym_jsx_element] = STATE(3174),
    [sym_as_expression] = STATE(3174),
    [sym_internal_module] = STATE(3174),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3174),
    [sym_await_expression] = STATE(3174),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(3174),
    [sym_this] = STATE(3174),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(3174),
    [sym_generator_function] = STATE(3174),
    [sym_call_expression] = STATE(3174),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(3174),
    [sym_ternary_expression] = STATE(3174),
    [sym_binary_expression] = STATE(3174),
    [sym_template_string] = STATE(3174),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3174),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3174),
    [sym_class] = STATE(3174),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_false] = ACTIONS(6634),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6634),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(6636),
    [sym_true] = ACTIONS(6634),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6634),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [2354] = {
    [sym_new_expression] = STATE(3175),
    [sym_augmented_assignment_expression] = STATE(3175),
    [sym_unary_expression] = STATE(3175),
    [sym_update_expression] = STATE(3175),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(3175),
    [sym_regex] = STATE(3175),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3175),
    [sym_non_null_expression] = STATE(3175),
    [sym_as_expression] = STATE(3175),
    [sym_jsx_fragment] = STATE(3175),
    [sym_yield_expression] = STATE(3175),
    [sym_jsx_element] = STATE(3175),
    [sym_internal_module] = STATE(3175),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3175),
    [sym_await_expression] = STATE(3175),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(3175),
    [sym_this] = STATE(3175),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(3175),
    [sym_generator_function] = STATE(3175),
    [sym_call_expression] = STATE(3175),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(3175),
    [sym_ternary_expression] = STATE(3175),
    [sym_binary_expression] = STATE(3175),
    [sym_template_string] = STATE(3175),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3175),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3175),
    [sym_class] = STATE(3175),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_false] = ACTIONS(6638),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6638),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(6640),
    [sym_true] = ACTIONS(6638),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6638),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [2355] = {
    [sym_new_expression] = STATE(3176),
    [sym_augmented_assignment_expression] = STATE(3176),
    [sym_unary_expression] = STATE(3176),
    [sym_update_expression] = STATE(3176),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(3176),
    [sym_regex] = STATE(3176),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3176),
    [sym_non_null_expression] = STATE(3176),
    [sym_as_expression] = STATE(3176),
    [sym_jsx_fragment] = STATE(3176),
    [sym_yield_expression] = STATE(3176),
    [sym_jsx_element] = STATE(3176),
    [sym_internal_module] = STATE(3176),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3176),
    [sym_await_expression] = STATE(3176),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(3176),
    [sym_this] = STATE(3176),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(3176),
    [sym_generator_function] = STATE(3176),
    [sym_call_expression] = STATE(3176),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(3176),
    [sym_ternary_expression] = STATE(3176),
    [sym_binary_expression] = STATE(3176),
    [sym_template_string] = STATE(3176),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3176),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3176),
    [sym_class] = STATE(3176),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_false] = ACTIONS(6642),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6642),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(6644),
    [sym_true] = ACTIONS(6642),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6642),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [2356] = {
    [sym_new_expression] = STATE(3177),
    [sym_augmented_assignment_expression] = STATE(3177),
    [sym_unary_expression] = STATE(3177),
    [sym_update_expression] = STATE(3177),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(3177),
    [sym_regex] = STATE(3177),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(369),
    [sym__expression] = STATE(3177),
    [sym_non_null_expression] = STATE(3177),
    [sym_yield_expression] = STATE(3177),
    [sym_jsx_fragment] = STATE(3177),
    [sym_jsx_element] = STATE(3177),
    [sym_as_expression] = STATE(3177),
    [sym_internal_module] = STATE(3177),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3177),
    [sym_await_expression] = STATE(3177),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(3177),
    [sym_this] = STATE(3177),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(3177),
    [sym_generator_function] = STATE(3177),
    [sym_call_expression] = STATE(3177),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(3177),
    [sym_ternary_expression] = STATE(3177),
    [sym_binary_expression] = STATE(3177),
    [sym_template_string] = STATE(3177),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3177),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3177),
    [sym_class] = STATE(3177),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_false] = ACTIONS(6646),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6646),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(6648),
    [sym_true] = ACTIONS(6646),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6646),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [2357] = {
    [sym_new_expression] = STATE(3178),
    [sym_augmented_assignment_expression] = STATE(3178),
    [sym_unary_expression] = STATE(3178),
    [sym_update_expression] = STATE(3178),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(3178),
    [sym_regex] = STATE(3178),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3178),
    [sym_non_null_expression] = STATE(3178),
    [sym_as_expression] = STATE(3178),
    [sym_jsx_fragment] = STATE(3178),
    [sym_yield_expression] = STATE(3178),
    [sym_jsx_element] = STATE(3178),
    [sym_internal_module] = STATE(3178),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3178),
    [sym_await_expression] = STATE(3178),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(3178),
    [sym_this] = STATE(3178),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(3178),
    [sym_generator_function] = STATE(3178),
    [sym_call_expression] = STATE(3178),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(3178),
    [sym_ternary_expression] = STATE(3178),
    [sym_binary_expression] = STATE(3178),
    [sym_template_string] = STATE(3178),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3178),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3178),
    [sym_class] = STATE(3178),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_false] = ACTIONS(6650),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6650),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(6652),
    [sym_true] = ACTIONS(6650),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6650),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [2358] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(702),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_RBRACE] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(6654),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [2359] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_SEMI] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(702),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_RBRACE] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(6654),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [2360] = {
    [anon_sym_EQ_GT] = ACTIONS(6657),
    [sym_comment] = ACTIONS(3),
  },
  [2361] = {
    [anon_sym_EQ_GT] = ACTIONS(6659),
    [sym_comment] = ACTIONS(3),
  },
  [2362] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_SEMI] = ACTIONS(839),
    [anon_sym_BQUOTE] = ACTIONS(839),
    [sym__automatic_semicolon] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_RBRACE] = ACTIONS(839),
    [anon_sym_AMP] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_as] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_instanceof] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_in] = ACTIONS(841),
  },
  [2363] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(871),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(871),
    [anon_sym_PIPE] = ACTIONS(5004),
    [anon_sym_COMMA] = ACTIONS(871),
    [anon_sym_LT_LT] = ACTIONS(5006),
    [anon_sym_STAR] = ACTIONS(5008),
    [anon_sym_GT_GT_GT] = ACTIONS(5006),
    [anon_sym_AMP_AMP] = ACTIONS(5010),
    [anon_sym_DASH] = ACTIONS(5012),
    [anon_sym_BANG_EQ] = ACTIONS(4962),
    [anon_sym_LT_EQ] = ACTIONS(5002),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(5002),
    [anon_sym_GT] = ACTIONS(4962),
    [anon_sym_RBRACE] = ACTIONS(871),
    [anon_sym_AMP] = ACTIONS(5014),
    [anon_sym_QMARK] = ACTIONS(5016),
    [anon_sym_PERCENT] = ACTIONS(5006),
    [anon_sym_as] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(5020),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(4962),
    [anon_sym_instanceof] = ACTIONS(5002),
    [anon_sym_LT] = ACTIONS(5022),
    [anon_sym_SLASH] = ACTIONS(5008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(5020),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(5012),
    [anon_sym_GT_GT] = ACTIONS(5008),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5002),
    [anon_sym_in] = ACTIONS(4962),
  },
  [2364] = {
    [sym__initializer] = STATE(522),
    [sym_arguments] = STATE(826),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_SEMI] = ACTIONS(1529),
    [sym__automatic_semicolon] = ACTIONS(1529),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(4960),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1531),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_RBRACE] = ACTIONS(1529),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [2365] = {
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(828),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1539),
    [sym__automatic_semicolon] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(4966),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_RBRACE] = ACTIONS(1539),
    [anon_sym_as] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [2366] = {
    [sym_new_expression] = STATE(836),
    [sym_augmented_assignment_expression] = STATE(836),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(836),
    [sym_update_expression] = STATE(836),
    [sym_regex] = STATE(836),
    [sym_meta_property] = STATE(836),
    [sym_call_signature] = STATE(835),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(836),
    [sym_non_null_expression] = STATE(836),
    [sym_yield_expression] = STATE(836),
    [sym_jsx_fragment] = STATE(836),
    [sym_jsx_element] = STATE(836),
    [sym_as_expression] = STATE(836),
    [sym_internal_module] = STATE(836),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(836),
    [sym_await_expression] = STATE(836),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(836),
    [sym_this] = STATE(836),
    [sym_arguments] = STATE(828),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(836),
    [sym_generator_function] = STATE(836),
    [sym_call_expression] = STATE(836),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(836),
    [sym_ternary_expression] = STATE(836),
    [sym_binary_expression] = STATE(836),
    [sym_template_string] = STATE(836),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(836),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(836),
    [sym_class] = STATE(836),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym__automatic_semicolon] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_RBRACE] = ACTIONS(1539),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(500),
    [sym_true] = ACTIONS(1545),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [sym_false] = ACTIONS(1545),
    [anon_sym_SEMI] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [sym_null] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(4966),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [sym_number] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [2367] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_arguments] = STATE(828),
    [sym_call_signature] = STATE(2360),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym__automatic_semicolon] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(4976),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(4978),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(4978),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(4978),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(4978),
    [anon_sym_RBRACE] = ACTIONS(1539),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_protected] = ACTIONS(4978),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_set] = ACTIONS(4978),
    [anon_sym_type] = ACTIONS(4978),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(4978),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(4978),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(4978),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(4978),
    [anon_sym_declare] = ACTIONS(4978),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(4978),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(4978),
    [anon_sym_async] = ACTIONS(4978),
    [anon_sym_public] = ACTIONS(4978),
    [anon_sym_EQ_GT] = ACTIONS(4966),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(4978),
    [anon_sym_function] = ACTIONS(698),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(4978),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [2368] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(828),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1539),
    [sym__automatic_semicolon] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(4966),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_RBRACE] = ACTIONS(1539),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [2369] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(915),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(5004),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(5006),
    [anon_sym_STAR] = ACTIONS(5008),
    [anon_sym_GT_GT_GT] = ACTIONS(5006),
    [anon_sym_AMP_AMP] = ACTIONS(5010),
    [anon_sym_DASH] = ACTIONS(5012),
    [anon_sym_BANG_EQ] = ACTIONS(4962),
    [anon_sym_LT_EQ] = ACTIONS(5002),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(5002),
    [anon_sym_GT] = ACTIONS(4962),
    [anon_sym_RBRACE] = ACTIONS(915),
    [anon_sym_AMP] = ACTIONS(5014),
    [anon_sym_QMARK] = ACTIONS(5016),
    [anon_sym_PERCENT] = ACTIONS(5006),
    [anon_sym_as] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(5020),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(4962),
    [anon_sym_instanceof] = ACTIONS(5002),
    [anon_sym_LT] = ACTIONS(5022),
    [anon_sym_SLASH] = ACTIONS(5008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(5020),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(5012),
    [anon_sym_GT_GT] = ACTIONS(5008),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5002),
    [anon_sym_in] = ACTIONS(4962),
  },
  [2370] = {
    [sym_new_expression] = STATE(3181),
    [sym_augmented_assignment_expression] = STATE(3181),
    [sym_unary_expression] = STATE(3181),
    [sym_update_expression] = STATE(3181),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(3181),
    [sym_regex] = STATE(3181),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3181),
    [sym_non_null_expression] = STATE(3181),
    [sym_as_expression] = STATE(3181),
    [sym_jsx_fragment] = STATE(3181),
    [sym_yield_expression] = STATE(3181),
    [sym_jsx_element] = STATE(3181),
    [sym_internal_module] = STATE(3181),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3181),
    [sym_await_expression] = STATE(3181),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(3181),
    [sym_this] = STATE(3181),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(3181),
    [sym_generator_function] = STATE(3181),
    [sym_call_expression] = STATE(3181),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(3181),
    [sym_ternary_expression] = STATE(3181),
    [sym_binary_expression] = STATE(3181),
    [sym_template_string] = STATE(3181),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3181),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3181),
    [sym_class] = STATE(3181),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_false] = ACTIONS(6661),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6661),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(6663),
    [sym_true] = ACTIONS(6661),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6661),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [2371] = {
    [sym_new_expression] = STATE(3182),
    [sym_augmented_assignment_expression] = STATE(3182),
    [sym_unary_expression] = STATE(3182),
    [sym_update_expression] = STATE(3182),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(3182),
    [sym_regex] = STATE(3182),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3182),
    [sym_non_null_expression] = STATE(3182),
    [sym_as_expression] = STATE(3182),
    [sym_jsx_fragment] = STATE(3182),
    [sym_yield_expression] = STATE(3182),
    [sym_jsx_element] = STATE(3182),
    [sym_internal_module] = STATE(3182),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3182),
    [sym_await_expression] = STATE(3182),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(3182),
    [sym_this] = STATE(3182),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(3182),
    [sym_generator_function] = STATE(3182),
    [sym_call_expression] = STATE(3182),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(3182),
    [sym_ternary_expression] = STATE(3182),
    [sym_binary_expression] = STATE(3182),
    [sym_template_string] = STATE(3182),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3182),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3182),
    [sym_class] = STATE(3182),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_false] = ACTIONS(6665),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6665),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(6667),
    [sym_true] = ACTIONS(6665),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6665),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [2372] = {
    [sym_new_expression] = STATE(3183),
    [sym_augmented_assignment_expression] = STATE(3183),
    [sym_unary_expression] = STATE(3183),
    [sym_update_expression] = STATE(3183),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(3183),
    [sym_regex] = STATE(3183),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3183),
    [sym_non_null_expression] = STATE(3183),
    [sym_as_expression] = STATE(3183),
    [sym_jsx_fragment] = STATE(3183),
    [sym_yield_expression] = STATE(3183),
    [sym_jsx_element] = STATE(3183),
    [sym_internal_module] = STATE(3183),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3183),
    [sym_await_expression] = STATE(3183),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(3183),
    [sym_this] = STATE(3183),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(3183),
    [sym_generator_function] = STATE(3183),
    [sym_call_expression] = STATE(3183),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(3183),
    [sym_ternary_expression] = STATE(3183),
    [sym_binary_expression] = STATE(3183),
    [sym_template_string] = STATE(3183),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3183),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3183),
    [sym_class] = STATE(3183),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_false] = ACTIONS(6669),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6669),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(6671),
    [sym_true] = ACTIONS(6669),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6669),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [2373] = {
    [sym_new_expression] = STATE(3184),
    [sym_augmented_assignment_expression] = STATE(3184),
    [sym_unary_expression] = STATE(3184),
    [sym_update_expression] = STATE(3184),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(3184),
    [sym_regex] = STATE(3184),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3184),
    [sym_non_null_expression] = STATE(3184),
    [sym_as_expression] = STATE(3184),
    [sym_jsx_fragment] = STATE(3184),
    [sym_yield_expression] = STATE(3184),
    [sym_jsx_element] = STATE(3184),
    [sym_internal_module] = STATE(3184),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3184),
    [sym_await_expression] = STATE(3184),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(3184),
    [sym_this] = STATE(3184),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(3184),
    [sym_generator_function] = STATE(3184),
    [sym_call_expression] = STATE(3184),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(3184),
    [sym_ternary_expression] = STATE(3184),
    [sym_binary_expression] = STATE(3184),
    [sym_template_string] = STATE(3184),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3184),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3184),
    [sym_class] = STATE(3184),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_false] = ACTIONS(6673),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6673),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(6675),
    [sym_true] = ACTIONS(6673),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6673),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [2374] = {
    [sym_new_expression] = STATE(3185),
    [sym_augmented_assignment_expression] = STATE(3185),
    [sym_unary_expression] = STATE(3185),
    [sym_update_expression] = STATE(3185),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(3185),
    [sym_regex] = STATE(3185),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3185),
    [sym_non_null_expression] = STATE(3185),
    [sym_as_expression] = STATE(3185),
    [sym_jsx_fragment] = STATE(3185),
    [sym_yield_expression] = STATE(3185),
    [sym_jsx_element] = STATE(3185),
    [sym_internal_module] = STATE(3185),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3185),
    [sym_await_expression] = STATE(3185),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(3185),
    [sym_this] = STATE(3185),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(3185),
    [sym_generator_function] = STATE(3185),
    [sym_call_expression] = STATE(3185),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(3185),
    [sym_ternary_expression] = STATE(3185),
    [sym_binary_expression] = STATE(3185),
    [sym_template_string] = STATE(3185),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3185),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3185),
    [sym_class] = STATE(3185),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(6677),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6677),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6679),
    [sym_true] = ACTIONS(6677),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6677),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [2375] = {
    [sym_union_type] = STATE(941),
    [sym__type] = STATE(941),
    [sym_constructor_type] = STATE(941),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(3191),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_template_string] = STATE(945),
    [sym_intersection_type] = STATE(941),
    [sym_function_type] = STATE(941),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(3192),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(6681),
    [sym_false] = ACTIONS(1907),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_keyof] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_PIPE] = ACTIONS(6683),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_boolean] = ACTIONS(1911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(6685),
    [anon_sym_QMARK] = ACTIONS(6687),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1933),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_new] = ACTIONS(6689),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [2376] = {
    [sym_new_expression] = STATE(3175),
    [sym_constructor_type] = STATE(432),
    [sym_augmented_assignment_expression] = STATE(3175),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(3175),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(3175),
    [sym_type_parameters] = STATE(959),
    [sym_array_type] = STATE(436),
    [sym_yield_expression] = STATE(3175),
    [sym_as_expression] = STATE(3175),
    [sym_jsx_fragment] = STATE(3175),
    [sym_internal_module] = STATE(3175),
    [sym_arrow_function] = STATE(3175),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(1430),
    [sym_literal_type] = STATE(436),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(949),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(3175),
    [sym_subscript_expression] = STATE(1430),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(3175),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(3175),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(960),
    [sym_function_type] = STATE(432),
    [sym__type] = STATE(432),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(3175),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(3175),
    [sym__expression] = STATE(3175),
    [sym_non_null_expression] = STATE(3175),
    [sym_jsx_element] = STATE(3175),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(88),
    [sym_await_expression] = STATE(3175),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_this] = STATE(3175),
    [sym_union_type] = STATE(432),
    [sym_anonymous_class] = STATE(3175),
    [sym_call_expression] = STATE(3175),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(3175),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(3175),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(432),
    [sym_parenthesized_expression] = STATE(3175),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3175),
    [sym_class] = STATE(3175),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(6691),
    [sym_false] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(1943),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(6693),
    [anon_sym_number] = ACTIONS(6693),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(6695),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(6697),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_void] = ACTIONS(6699),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(1955),
    [sym_null] = ACTIONS(6638),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(6693),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(6693),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1957),
    [sym_true] = ACTIONS(1941),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(1959),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(6693),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6638),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(6701),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(6697),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [2377] = {
    [sym_new_expression] = STATE(3199),
    [sym_augmented_assignment_expression] = STATE(3199),
    [sym_unary_expression] = STATE(3199),
    [sym_update_expression] = STATE(3199),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(3199),
    [sym_regex] = STATE(3199),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3199),
    [sym_non_null_expression] = STATE(3199),
    [sym_as_expression] = STATE(3199),
    [sym_jsx_fragment] = STATE(3199),
    [sym_yield_expression] = STATE(3199),
    [sym_jsx_element] = STATE(3199),
    [sym_internal_module] = STATE(3199),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3199),
    [sym_await_expression] = STATE(3199),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(3199),
    [sym_this] = STATE(3199),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(3199),
    [sym_generator_function] = STATE(3199),
    [sym_call_expression] = STATE(3199),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(3199),
    [sym_ternary_expression] = STATE(3199),
    [sym_binary_expression] = STATE(3199),
    [sym_template_string] = STATE(3199),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3199),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3199),
    [sym_class] = STATE(3199),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_false] = ACTIONS(6703),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6703),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(6705),
    [sym_true] = ACTIONS(6703),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6703),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [2378] = {
    [anon_sym_LBRACK] = ACTIONS(2341),
    [sym_identifier] = ACTIONS(2343),
    [anon_sym_module] = ACTIONS(2343),
    [anon_sym_symbol] = ACTIONS(2343),
    [anon_sym_number] = ACTIONS(2343),
    [anon_sym_AT] = ACTIONS(2341),
    [anon_sym_class] = ACTIONS(2343),
    [anon_sym_declare] = ACTIONS(2343),
    [anon_sym_STAR] = ACTIONS(2341),
    [anon_sym_void] = ACTIONS(2343),
    [anon_sym_any] = ACTIONS(2343),
    [anon_sym_private] = ACTIONS(2343),
    [anon_sym_boolean] = ACTIONS(2343),
    [anon_sym_async] = ACTIONS(2343),
    [anon_sym_public] = ACTIONS(2343),
    [anon_sym_get] = ACTIONS(2343),
    [anon_sym_static] = ACTIONS(2343),
    [anon_sym_RBRACE] = ACTIONS(2341),
    [anon_sym_SQUOTE] = ACTIONS(2341),
    [sym_number] = ACTIONS(2341),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2343),
    [anon_sym_string] = ACTIONS(2343),
    [anon_sym_abstract] = ACTIONS(2343),
    [anon_sym_set] = ACTIONS(2343),
    [anon_sym_type] = ACTIONS(2343),
    [anon_sym_import] = ACTIONS(2343),
    [anon_sym_export] = ACTIONS(2343),
    [sym_readonly] = ACTIONS(2343),
    [anon_sym_namespace] = ACTIONS(2343),
    [anon_sym_DQUOTE] = ACTIONS(2341),
  },
  [2379] = {
    [sym_template_string] = STATE(542),
    [aux_sym_array_repeat1] = STATE(3201),
    [sym_type_arguments] = STATE(541),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(6707),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [2380] = {
    [aux_sym_array_repeat1] = STATE(3201),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_RPAREN] = ACTIONS(6707),
    [sym_comment] = ACTIONS(3),
  },
  [2381] = {
    [aux_sym_array_repeat1] = STATE(1150),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_RPAREN] = ACTIONS(6707),
    [sym_comment] = ACTIONS(3),
  },
  [2382] = {
    [anon_sym_EQ] = ACTIONS(5088),
    [anon_sym_RBRACE] = ACTIONS(5088),
    [anon_sym_QMARK] = ACTIONS(5088),
    [anon_sym_LT] = ACTIONS(5088),
    [anon_sym_LPAREN] = ACTIONS(5088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COMMA] = ACTIONS(5088),
  },
  [2383] = {
    [sym_statement_block] = STATE(3202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [2384] = {
    [anon_sym_COMMA] = ACTIONS(6709),
    [anon_sym_RBRACE] = ACTIONS(6709),
    [sym_comment] = ACTIONS(3),
  },
  [2385] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(3203),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2386] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(3203),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(6711),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2387] = {
    [sym_string] = STATE(3205),
    [sym__property_name] = STATE(3205),
    [sym_computed_property_name] = STATE(3205),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(6713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [2388] = {
    [sym_string] = STATE(3205),
    [sym__property_name] = STATE(3205),
    [sym_computed_property_name] = STATE(3205),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(6713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [2389] = {
    [sym_type_alias_declaration] = STATE(348),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(348),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(348),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(348),
    [sym_return_statement] = STATE(348),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(348),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(348),
    [sym_switch_statement] = STATE(348),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(348),
    [sym_throw_statement] = STATE(348),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(348),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(348),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(348),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(348),
    [sym_abstract_class] = STATE(348),
    [sym_interface_declaration] = STATE(348),
    [sym_statement_block] = STATE(348),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(348),
    [sym_debugger_statement] = STATE(348),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(348),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(348),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(348),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(348),
    [sym_empty_statement] = STATE(348),
    [sym_import_alias] = STATE(348),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(348),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(348),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(348),
    [sym_break_statement] = STATE(348),
    [sym_labeled_statement] = STATE(348),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(348),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [2390] = {
    [sym_type_alias_declaration] = STATE(3206),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3206),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3206),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3206),
    [sym_return_statement] = STATE(3206),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3206),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3206),
    [sym_switch_statement] = STATE(3206),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3206),
    [sym_throw_statement] = STATE(3206),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3206),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3206),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(3206),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3206),
    [sym_abstract_class] = STATE(3206),
    [sym_interface_declaration] = STATE(3206),
    [sym_statement_block] = STATE(3206),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3206),
    [sym_debugger_statement] = STATE(3206),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3206),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3206),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3206),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3206),
    [sym_empty_statement] = STATE(3206),
    [sym_import_alias] = STATE(3206),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3206),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3206),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3206),
    [sym_break_statement] = STATE(3206),
    [sym_labeled_statement] = STATE(3206),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3206),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [2391] = {
    [anon_sym_LPAREN] = ACTIONS(6715),
    [sym_comment] = ACTIONS(3),
  },
  [2392] = {
    [sym_new_expression] = STATE(59),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_yield_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_internal_module] = STATE(59),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(59),
    [sym_await_expression] = STATE(59),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3211),
    [sym_variable_declaration] = STATE(3211),
    [sym_sequence_expression] = STATE(62),
    [sym_string] = STATE(59),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(3211),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(3212),
    [sym_anonymous_class] = STATE(59),
    [sym_generator_function] = STATE(59),
    [sym_call_expression] = STATE(59),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(59),
    [sym_ternary_expression] = STATE(59),
    [sym_binary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_lexical_declaration] = STATE(3211),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(3213),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_identifier] = ACTIONS(6717),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(6719),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(6721),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(6719),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(15),
  },
  [2393] = {
    [sym_string] = STATE(173),
    [sym_nested_identifier] = STATE(169),
    [sym__module] = STATE(172),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(6723),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(312),
  },
  [2394] = {
    [sym_type_alias_declaration] = STATE(193),
    [aux_sym_export_statement_repeat1] = STATE(2396),
    [sym__declaration] = STATE(193),
    [sym_ambient_declaration] = STATE(193),
    [sym_import_alias] = STATE(193),
    [sym_export_statement] = STATE(193),
    [sym_generator_function] = STATE(193),
    [sym_lexical_declaration] = STATE(193),
    [sym_internal_module] = STATE(193),
    [sym_decorator] = STATE(2396),
    [sym_enum_declaration] = STATE(193),
    [sym_function] = STATE(193),
    [sym_function_signature] = STATE(193),
    [sym_variable_declaration] = STATE(193),
    [sym_abstract_class] = STATE(193),
    [sym_module] = STATE(193),
    [sym_interface_declaration] = STATE(193),
    [sym_class] = STATE(193),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(5054),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(5056),
    [anon_sym_global] = ACTIONS(324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(5058),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(346),
  },
  [2395] = {
    [sym_type_alias_declaration] = STATE(300),
    [aux_sym_export_statement_repeat1] = STATE(2396),
    [sym__declaration] = STATE(300),
    [sym_ambient_declaration] = STATE(300),
    [sym_import_alias] = STATE(300),
    [sym_export_statement] = STATE(300),
    [sym_generator_function] = STATE(300),
    [sym_export_clause] = STATE(301),
    [sym_lexical_declaration] = STATE(300),
    [sym_internal_module] = STATE(300),
    [sym_decorator] = STATE(2396),
    [sym_enum_declaration] = STATE(300),
    [sym_function] = STATE(300),
    [sym_function_signature] = STATE(300),
    [sym_variable_declaration] = STATE(300),
    [sym_abstract_class] = STATE(300),
    [sym_module] = STATE(300),
    [sym_interface_declaration] = STATE(300),
    [sym_class] = STATE(300),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_as] = ACTIONS(1183),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(5056),
    [anon_sym_STAR] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_EQ] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(5058),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(346),
  },
  [2396] = {
    [aux_sym_export_statement_repeat1] = STATE(320),
    [sym_decorator] = STATE(320),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(5062),
    [anon_sym_class] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
  },
  [2397] = {
    [sym_type_alias_declaration] = STATE(787),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(787),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(787),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(787),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(787),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(787),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(787),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(787),
    [sym_abstract_class] = STATE(787),
    [sym_interface_declaration] = STATE(787),
    [sym_statement_block] = STATE(787),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(787),
    [sym_debugger_statement] = STATE(787),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(787),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(787),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(787),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(787),
    [sym_empty_statement] = STATE(787),
    [sym_import_alias] = STATE(787),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(787),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(787),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_labeled_statement] = STATE(787),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(787),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [2398] = {
    [sym_type_alias_declaration] = STATE(891),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(891),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(891),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(891),
    [sym_return_statement] = STATE(891),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(891),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(891),
    [sym_switch_statement] = STATE(891),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(891),
    [sym_throw_statement] = STATE(891),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(891),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(891),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(891),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(891),
    [sym_abstract_class] = STATE(891),
    [sym_interface_declaration] = STATE(891),
    [sym_statement_block] = STATE(891),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(891),
    [sym_debugger_statement] = STATE(891),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(891),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(891),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(891),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(891),
    [sym_empty_statement] = STATE(891),
    [sym_import_alias] = STATE(891),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(891),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(891),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(891),
    [sym_break_statement] = STATE(891),
    [sym_labeled_statement] = STATE(891),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(891),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [2399] = {
    [sym_type_alias_declaration] = STATE(2092),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(2092),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(2092),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(2092),
    [sym_return_statement] = STATE(2092),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(2092),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2092),
    [sym_switch_statement] = STATE(2092),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(2092),
    [sym_throw_statement] = STATE(2092),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(2092),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(2092),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(2092),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(2092),
    [sym_abstract_class] = STATE(2092),
    [sym_interface_declaration] = STATE(2092),
    [sym_statement_block] = STATE(2092),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(2092),
    [sym_debugger_statement] = STATE(2092),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(2092),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(2092),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(2092),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(2092),
    [sym_empty_statement] = STATE(2092),
    [sym_import_alias] = STATE(2092),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(2092),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(2092),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(2092),
    [sym_break_statement] = STATE(2092),
    [sym_labeled_statement] = STATE(2092),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(2092),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [2400] = {
    [sym_type_alias_declaration] = STATE(872),
    [aux_sym_export_statement_repeat1] = STATE(2396),
    [sym__declaration] = STATE(872),
    [sym_ambient_declaration] = STATE(872),
    [sym_import_alias] = STATE(872),
    [sym_export_statement] = STATE(872),
    [sym_generator_function] = STATE(872),
    [sym_lexical_declaration] = STATE(872),
    [sym_internal_module] = STATE(872),
    [sym_decorator] = STATE(2396),
    [sym_enum_declaration] = STATE(872),
    [sym_function] = STATE(872),
    [sym_function_signature] = STATE(872),
    [sym_variable_declaration] = STATE(872),
    [sym_abstract_class] = STATE(872),
    [sym_module] = STATE(872),
    [sym_interface_declaration] = STATE(872),
    [sym_class] = STATE(872),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_default] = ACTIONS(1826),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(5056),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(5058),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(346),
  },
  [2401] = {
    [sym_array] = STATE(3216),
    [sym_object] = STATE(3217),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(6725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [2402] = {
    [anon_sym_of] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
  },
  [2403] = {
    [anon_sym_of] = ACTIONS(6729),
    [sym_comment] = ACTIONS(3),
  },
  [2404] = {
    [anon_sym_of] = ACTIONS(6731),
    [sym_comment] = ACTIONS(3),
  },
  [2405] = {
    [sym_new_expression] = STATE(3221),
    [sym_augmented_assignment_expression] = STATE(3221),
    [sym_unary_expression] = STATE(3221),
    [sym_update_expression] = STATE(3221),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3221),
    [sym_regex] = STATE(3221),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3221),
    [sym_non_null_expression] = STATE(3221),
    [sym_as_expression] = STATE(3221),
    [sym_jsx_fragment] = STATE(3221),
    [sym_yield_expression] = STATE(3221),
    [sym_jsx_element] = STATE(3221),
    [sym_internal_module] = STATE(3221),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3221),
    [sym_await_expression] = STATE(3221),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(3222),
    [sym_string] = STATE(3221),
    [sym_this] = STATE(3221),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(3221),
    [sym_generator_function] = STATE(3221),
    [sym_call_expression] = STATE(3221),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(3221),
    [sym_ternary_expression] = STATE(3221),
    [sym_binary_expression] = STATE(3221),
    [sym_template_string] = STATE(3221),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3221),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3221),
    [sym_class] = STATE(3221),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(6733),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6733),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(6735),
    [sym_true] = ACTIONS(6733),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6733),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [2406] = {
    [sym_new_expression] = STATE(3223),
    [sym_augmented_assignment_expression] = STATE(3223),
    [sym_unary_expression] = STATE(3223),
    [sym_update_expression] = STATE(3223),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3223),
    [sym_regex] = STATE(3223),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3223),
    [sym_non_null_expression] = STATE(3223),
    [sym_as_expression] = STATE(3223),
    [sym_jsx_fragment] = STATE(3223),
    [sym_yield_expression] = STATE(3223),
    [sym_jsx_element] = STATE(3223),
    [sym_internal_module] = STATE(3223),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3223),
    [sym_await_expression] = STATE(3223),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3223),
    [sym_this] = STATE(3223),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3223),
    [sym_generator_function] = STATE(3223),
    [sym_call_expression] = STATE(3223),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3223),
    [sym_ternary_expression] = STATE(3223),
    [sym_binary_expression] = STATE(3223),
    [sym_template_string] = STATE(3223),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3223),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3223),
    [sym_class] = STATE(3223),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(6737),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6737),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6739),
    [sym_true] = ACTIONS(6737),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6737),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [2407] = {
    [sym__initializer] = STATE(391),
    [sym_type_annotation] = STATE(392),
    [sym__automatic_semicolon] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(715),
    [anon_sym_of] = ACTIONS(6727),
    [anon_sym_COMMA] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(6741),
  },
  [2408] = {
    [sym__initializer] = STATE(411),
    [sym_type_annotation] = STATE(412),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(745),
    [anon_sym_of] = ACTIONS(6729),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(6743),
  },
  [2409] = {
    [sym__initializer] = STATE(413),
    [sym_type_annotation] = STATE(414),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(745),
    [anon_sym_of] = ACTIONS(6731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(6745),
  },
  [2410] = {
    [sym_new_expression] = STATE(3228),
    [sym_augmented_assignment_expression] = STATE(3228),
    [sym_unary_expression] = STATE(3228),
    [sym_update_expression] = STATE(3228),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(3228),
    [sym_regex] = STATE(3228),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3228),
    [sym_non_null_expression] = STATE(3228),
    [sym_as_expression] = STATE(3228),
    [sym_jsx_fragment] = STATE(3228),
    [sym_yield_expression] = STATE(3228),
    [sym_jsx_element] = STATE(3228),
    [sym_internal_module] = STATE(3228),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3228),
    [sym_await_expression] = STATE(3228),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(3229),
    [sym_string] = STATE(3228),
    [sym_this] = STATE(3228),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(3228),
    [sym_generator_function] = STATE(3228),
    [sym_call_expression] = STATE(3228),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(3228),
    [sym_ternary_expression] = STATE(3228),
    [sym_binary_expression] = STATE(3228),
    [sym_template_string] = STATE(3228),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3228),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3228),
    [sym_class] = STATE(3228),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(6747),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6747),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_RPAREN] = ACTIONS(6749),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6751),
    [sym_true] = ACTIONS(6747),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6747),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [2411] = {
    [sym_new_expression] = STATE(3230),
    [sym_augmented_assignment_expression] = STATE(3230),
    [sym_unary_expression] = STATE(3230),
    [sym_update_expression] = STATE(3230),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3230),
    [sym_regex] = STATE(3230),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3230),
    [sym_non_null_expression] = STATE(3230),
    [sym_as_expression] = STATE(3230),
    [sym_jsx_fragment] = STATE(3230),
    [sym_yield_expression] = STATE(3230),
    [sym_jsx_element] = STATE(3230),
    [sym_internal_module] = STATE(3230),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3230),
    [sym_await_expression] = STATE(3230),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3230),
    [sym_this] = STATE(3230),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3230),
    [sym_generator_function] = STATE(3230),
    [sym_call_expression] = STATE(3230),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3230),
    [sym_ternary_expression] = STATE(3230),
    [sym_binary_expression] = STATE(3230),
    [sym_template_string] = STATE(3230),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3230),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3230),
    [sym_class] = STATE(3230),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(6753),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6753),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6755),
    [sym_true] = ACTIONS(6753),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6753),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [2412] = {
    [sym_new_expression] = STATE(3231),
    [sym_augmented_assignment_expression] = STATE(3231),
    [sym_unary_expression] = STATE(3231),
    [sym_update_expression] = STATE(3231),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3231),
    [sym_regex] = STATE(3231),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3231),
    [sym_non_null_expression] = STATE(3231),
    [sym_as_expression] = STATE(3231),
    [sym_jsx_fragment] = STATE(3231),
    [sym_yield_expression] = STATE(3231),
    [sym_jsx_element] = STATE(3231),
    [sym_internal_module] = STATE(3231),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3231),
    [sym_await_expression] = STATE(3231),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(3232),
    [sym_string] = STATE(3231),
    [sym_this] = STATE(3231),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(3231),
    [sym_generator_function] = STATE(3231),
    [sym_call_expression] = STATE(3231),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(3231),
    [sym_ternary_expression] = STATE(3231),
    [sym_binary_expression] = STATE(3231),
    [sym_template_string] = STATE(3231),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3231),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3231),
    [sym_class] = STATE(3231),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(6757),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6757),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(6759),
    [sym_true] = ACTIONS(6757),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6757),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [2413] = {
    [sym_new_expression] = STATE(3233),
    [sym_augmented_assignment_expression] = STATE(3233),
    [sym_unary_expression] = STATE(3233),
    [sym_update_expression] = STATE(3233),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3233),
    [sym_regex] = STATE(3233),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3233),
    [sym_non_null_expression] = STATE(3233),
    [sym_as_expression] = STATE(3233),
    [sym_jsx_fragment] = STATE(3233),
    [sym_yield_expression] = STATE(3233),
    [sym_jsx_element] = STATE(3233),
    [sym_internal_module] = STATE(3233),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3233),
    [sym_await_expression] = STATE(3233),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3233),
    [sym_this] = STATE(3233),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3233),
    [sym_generator_function] = STATE(3233),
    [sym_call_expression] = STATE(3233),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3233),
    [sym_ternary_expression] = STATE(3233),
    [sym_binary_expression] = STATE(3233),
    [sym_template_string] = STATE(3233),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3233),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3233),
    [sym_class] = STATE(3233),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(6761),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6761),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6763),
    [sym_true] = ACTIONS(6761),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6761),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [2414] = {
    [sym_new_expression] = STATE(3234),
    [sym_augmented_assignment_expression] = STATE(3234),
    [sym_unary_expression] = STATE(3234),
    [sym_update_expression] = STATE(3234),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3234),
    [sym_regex] = STATE(3234),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3234),
    [sym_non_null_expression] = STATE(3234),
    [sym_as_expression] = STATE(3234),
    [sym_jsx_fragment] = STATE(3234),
    [sym_yield_expression] = STATE(3234),
    [sym_jsx_element] = STATE(3234),
    [sym_internal_module] = STATE(3234),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3234),
    [sym_await_expression] = STATE(3234),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(3235),
    [sym_string] = STATE(3234),
    [sym_this] = STATE(3234),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(3234),
    [sym_generator_function] = STATE(3234),
    [sym_call_expression] = STATE(3234),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(3234),
    [sym_ternary_expression] = STATE(3234),
    [sym_binary_expression] = STATE(3234),
    [sym_template_string] = STATE(3234),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3234),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3234),
    [sym_class] = STATE(3234),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(6765),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6765),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(6767),
    [sym_true] = ACTIONS(6765),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6765),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [2415] = {
    [anon_sym_COLON] = ACTIONS(6769),
    [sym_comment] = ACTIONS(3),
  },
  [2416] = {
    [sym_string] = STATE(3205),
    [sym__property_name] = STATE(3205),
    [sym_computed_property_name] = STATE(3205),
    [anon_sym_get] = ACTIONS(6771),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(6713),
    [anon_sym_STAR] = ACTIONS(6773),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(6771),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [2417] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6775),
    [anon_sym_LBRACK] = ACTIONS(6775),
    [anon_sym_BANG] = ACTIONS(6777),
    [anon_sym_SEMI] = ACTIONS(6775),
    [anon_sym_BQUOTE] = ACTIONS(6775),
    [sym__automatic_semicolon] = ACTIONS(6775),
    [anon_sym_PIPE] = ACTIONS(6777),
    [anon_sym_COMMA] = ACTIONS(6775),
    [anon_sym_LT_LT] = ACTIONS(6775),
    [anon_sym_STAR] = ACTIONS(6777),
    [anon_sym_GT_GT_GT] = ACTIONS(6775),
    [anon_sym_EQ] = ACTIONS(6777),
    [anon_sym_AMP_AMP] = ACTIONS(6775),
    [anon_sym_DASH] = ACTIONS(6777),
    [anon_sym_BANG_EQ] = ACTIONS(6777),
    [anon_sym_LT_EQ] = ACTIONS(6775),
    [anon_sym_LPAREN] = ACTIONS(6775),
    [anon_sym_GT_EQ] = ACTIONS(6775),
    [anon_sym_of] = ACTIONS(6775),
    [anon_sym_GT] = ACTIONS(6777),
    [anon_sym_AMP] = ACTIONS(6777),
    [anon_sym_PERCENT] = ACTIONS(6775),
    [anon_sym_QMARK] = ACTIONS(6775),
    [anon_sym_RBRACE] = ACTIONS(6775),
    [anon_sym_as] = ACTIONS(6775),
    [anon_sym_PIPE_PIPE] = ACTIONS(6775),
    [anon_sym_DASH_DASH] = ACTIONS(6775),
    [anon_sym_EQ_EQ] = ACTIONS(6777),
    [anon_sym_instanceof] = ACTIONS(6775),
    [anon_sym_LT] = ACTIONS(6777),
    [anon_sym_RPAREN] = ACTIONS(6775),
    [anon_sym_SLASH] = ACTIONS(6777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6775),
    [anon_sym_CARET] = ACTIONS(6775),
    [anon_sym_STAR_STAR] = ACTIONS(6775),
    [anon_sym_PLUS] = ACTIONS(6777),
    [anon_sym_GT_GT] = ACTIONS(6777),
    [anon_sym_PLUS_PLUS] = ACTIONS(6775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6775),
    [anon_sym_in] = ACTIONS(6777),
  },
  [2418] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6779),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6779),
    [anon_sym_AMP_EQ] = ACTIONS(6779),
    [anon_sym_PLUS_EQ] = ACTIONS(6779),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(6781),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(6779),
    [anon_sym_STAR_EQ] = ACTIONS(6779),
    [anon_sym_PIPE_EQ] = ACTIONS(6779),
    [anon_sym_DASH_EQ] = ACTIONS(6779),
    [anon_sym_EQ_GT] = ACTIONS(6783),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6779),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(6779),
    [anon_sym_GT_GT_EQ] = ACTIONS(6779),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6779),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6785),
  },
  [2419] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6787),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6787),
    [anon_sym_AMP_EQ] = ACTIONS(6787),
    [anon_sym_PLUS_EQ] = ACTIONS(6787),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6781),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(6787),
    [anon_sym_STAR_EQ] = ACTIONS(6787),
    [anon_sym_PIPE_EQ] = ACTIONS(6787),
    [anon_sym_DASH_EQ] = ACTIONS(6787),
    [anon_sym_EQ_GT] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6787),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_SLASH_EQ] = ACTIONS(6787),
    [anon_sym_GT_GT_EQ] = ACTIONS(6787),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6787),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2420] = {
    [sym_new_expression] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(3245),
    [sym_unary_expression] = STATE(3245),
    [sym_update_expression] = STATE(3245),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(3245),
    [sym_regex] = STATE(3245),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3245),
    [sym_non_null_expression] = STATE(3245),
    [sym_as_expression] = STATE(3245),
    [sym_jsx_fragment] = STATE(3245),
    [sym_yield_expression] = STATE(3245),
    [sym_jsx_element] = STATE(3245),
    [sym_internal_module] = STATE(3245),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3245),
    [sym_await_expression] = STATE(3245),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(3245),
    [sym_this] = STATE(3245),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3245),
    [sym_generator_function] = STATE(3245),
    [sym_call_expression] = STATE(3245),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3245),
    [sym_ternary_expression] = STATE(3245),
    [sym_binary_expression] = STATE(3245),
    [sym_template_string] = STATE(3245),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3245),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3245),
    [sym_class] = STATE(3245),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(6791),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6791),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6793),
    [sym_true] = ACTIONS(6791),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6791),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [2421] = {
    [sym_new_expression] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(3246),
    [sym_unary_expression] = STATE(3246),
    [sym_update_expression] = STATE(3246),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(3246),
    [sym_regex] = STATE(3246),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3246),
    [sym_non_null_expression] = STATE(3246),
    [sym_as_expression] = STATE(3246),
    [sym_jsx_fragment] = STATE(3246),
    [sym_yield_expression] = STATE(3246),
    [sym_jsx_element] = STATE(3246),
    [sym_internal_module] = STATE(3246),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3246),
    [sym_await_expression] = STATE(3246),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(3246),
    [sym_this] = STATE(3246),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3246),
    [sym_generator_function] = STATE(3246),
    [sym_call_expression] = STATE(3246),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3246),
    [sym_ternary_expression] = STATE(3246),
    [sym_binary_expression] = STATE(3246),
    [sym_template_string] = STATE(3246),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3246),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3246),
    [sym_class] = STATE(3246),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(6795),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6795),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6797),
    [sym_true] = ACTIONS(6795),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6795),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [2422] = {
    [sym_new_expression] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(3245),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(3245),
    [sym_update_expression] = STATE(3245),
    [sym_regex] = STATE(3245),
    [sym_meta_property] = STATE(3245),
    [sym_call_signature] = STATE(2429),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3245),
    [sym_non_null_expression] = STATE(3245),
    [sym_yield_expression] = STATE(3245),
    [sym_jsx_fragment] = STATE(3245),
    [sym_jsx_element] = STATE(3245),
    [sym_as_expression] = STATE(3245),
    [sym_internal_module] = STATE(3245),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3245),
    [sym_await_expression] = STATE(3245),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(3245),
    [sym_this] = STATE(3245),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3245),
    [sym_generator_function] = STATE(3245),
    [sym_call_expression] = STATE(3245),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3245),
    [sym_ternary_expression] = STATE(3245),
    [sym_binary_expression] = STATE(3245),
    [sym_template_string] = STATE(3245),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3245),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3245),
    [sym_class] = STATE(3245),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(5106),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(6787),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_AMP_EQ] = ACTIONS(6787),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(6787),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6781),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(6787),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_PIPE_EQ] = ACTIONS(6787),
    [anon_sym_DASH_EQ] = ACTIONS(6787),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(6787),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(5124),
    [sym_true] = ACTIONS(6791),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_GT_GT_EQ] = ACTIONS(6787),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6787),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(5112),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(6791),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6787),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6791),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_STAR_EQ] = ACTIONS(6787),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_EQ_GT] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(6793),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6787),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6791),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2423] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_call_signature] = STATE(3247),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(6799),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6787),
    [anon_sym_symbol] = ACTIONS(6801),
    [anon_sym_AMP_EQ] = ACTIONS(6787),
    [anon_sym_PLUS_EQ] = ACTIONS(6787),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6781),
    [anon_sym_void] = ACTIONS(6801),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(6787),
    [anon_sym_private] = ACTIONS(6801),
    [anon_sym_PIPE_EQ] = ACTIONS(6787),
    [anon_sym_DASH_EQ] = ACTIONS(6787),
    [anon_sym_get] = ACTIONS(6801),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(6787),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(6801),
    [anon_sym_GT_GT_EQ] = ACTIONS(6787),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(6801),
    [anon_sym_type] = ACTIONS(6801),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(6801),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6787),
    [anon_sym_namespace] = ACTIONS(6801),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(6801),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6787),
    [anon_sym_number] = ACTIONS(6801),
    [anon_sym_declare] = ACTIONS(6801),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(6801),
    [anon_sym_STAR_EQ] = ACTIONS(6787),
    [anon_sym_boolean] = ACTIONS(6801),
    [anon_sym_async] = ACTIONS(6801),
    [anon_sym_public] = ACTIONS(6801),
    [anon_sym_EQ_GT] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6787),
    [anon_sym_string] = ACTIONS(6801),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(6801),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2424] = {
    [sym_new_expression] = STATE(3249),
    [sym_augmented_assignment_expression] = STATE(3249),
    [sym_unary_expression] = STATE(3249),
    [sym_update_expression] = STATE(3249),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(3249),
    [sym_regex] = STATE(3249),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3249),
    [sym_non_null_expression] = STATE(3249),
    [sym_as_expression] = STATE(3249),
    [sym_jsx_fragment] = STATE(3249),
    [sym_yield_expression] = STATE(3249),
    [sym_jsx_element] = STATE(3249),
    [sym_internal_module] = STATE(3249),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3249),
    [sym_await_expression] = STATE(3249),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(3249),
    [sym_this] = STATE(3249),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3249),
    [sym_generator_function] = STATE(3249),
    [sym_call_expression] = STATE(3249),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3249),
    [sym_ternary_expression] = STATE(3249),
    [sym_binary_expression] = STATE(3249),
    [sym_template_string] = STATE(3249),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3249),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3249),
    [sym_class] = STATE(3249),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(6803),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6803),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6805),
    [sym_true] = ACTIONS(6803),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6803),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [2425] = {
    [sym_new_expression] = STATE(3250),
    [sym_augmented_assignment_expression] = STATE(3250),
    [sym_unary_expression] = STATE(3250),
    [sym_update_expression] = STATE(3250),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(3250),
    [sym_regex] = STATE(3250),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3250),
    [sym_non_null_expression] = STATE(3250),
    [sym_as_expression] = STATE(3250),
    [sym_jsx_fragment] = STATE(3250),
    [sym_yield_expression] = STATE(3250),
    [sym_jsx_element] = STATE(3250),
    [sym_internal_module] = STATE(3250),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3250),
    [sym_await_expression] = STATE(3250),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(3250),
    [sym_this] = STATE(3250),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3250),
    [sym_generator_function] = STATE(3250),
    [sym_call_expression] = STATE(3250),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3250),
    [sym_ternary_expression] = STATE(3250),
    [sym_binary_expression] = STATE(3250),
    [sym_template_string] = STATE(3250),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3250),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3250),
    [sym_class] = STATE(3250),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(211),
    [sym_identifier] = ACTIONS(5106),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_GT_GT_GT] = ACTIONS(211),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_BANG_EQ] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(211),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_PERCENT] = ACTIONS(211),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(5124),
    [sym_true] = ACTIONS(6807),
    [anon_sym_COLON] = ACTIONS(211),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_STAR_STAR] = ACTIONS(211),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(5112),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(6807),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_LT_LT] = ACTIONS(211),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(211),
    [anon_sym_LT_EQ] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6807),
    [anon_sym_GT] = ACTIONS(213),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_AMP] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(211),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(6809),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6807),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_CARET] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_GT_GT] = ACTIONS(213),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(211),
    [anon_sym_in] = ACTIONS(213),
  },
  [2426] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(6811),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(6813),
    [anon_sym_symbol] = ACTIONS(6813),
    [anon_sym_number] = ACTIONS(6813),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(6813),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(6815),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(6813),
    [anon_sym_private] = ACTIONS(6813),
    [anon_sym_boolean] = ACTIONS(6813),
    [anon_sym_async] = ACTIONS(6817),
    [anon_sym_public] = ACTIONS(6813),
    [anon_sym_get] = ACTIONS(6813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(6813),
    [anon_sym_string] = ACTIONS(6813),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(6813),
    [anon_sym_type] = ACTIONS(6813),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(6813),
    [anon_sym_export] = ACTIONS(6813),
    [anon_sym_namespace] = ACTIONS(6819),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [2427] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(6787),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6787),
    [anon_sym_AMP_EQ] = ACTIONS(6787),
    [anon_sym_PLUS_EQ] = ACTIONS(6787),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6781),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(6787),
    [anon_sym_STAR_EQ] = ACTIONS(6787),
    [anon_sym_PIPE_EQ] = ACTIONS(6787),
    [anon_sym_DASH_EQ] = ACTIONS(6787),
    [anon_sym_EQ_GT] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6787),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_SLASH_EQ] = ACTIONS(6787),
    [anon_sym_GT_GT_EQ] = ACTIONS(6787),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6787),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2428] = {
    [sym_new_expression] = STATE(3256),
    [sym_augmented_assignment_expression] = STATE(3256),
    [sym_unary_expression] = STATE(3256),
    [sym_update_expression] = STATE(3256),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(3256),
    [sym_regex] = STATE(3256),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3256),
    [sym_non_null_expression] = STATE(3256),
    [sym_as_expression] = STATE(3256),
    [sym_jsx_fragment] = STATE(3256),
    [sym_yield_expression] = STATE(3256),
    [sym_jsx_element] = STATE(3256),
    [sym_internal_module] = STATE(3256),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3256),
    [sym_await_expression] = STATE(3256),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(3256),
    [sym_this] = STATE(3256),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3256),
    [sym_generator_function] = STATE(3256),
    [sym_call_expression] = STATE(3256),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3256),
    [sym_ternary_expression] = STATE(3256),
    [sym_binary_expression] = STATE(3256),
    [sym_template_string] = STATE(3256),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3256),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3256),
    [sym_class] = STATE(3256),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(6821),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6821),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6823),
    [sym_true] = ACTIONS(6821),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6821),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [2429] = {
    [anon_sym_EQ_GT] = ACTIONS(6783),
    [sym_comment] = ACTIONS(3),
  },
  [2430] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6825),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6785),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6827),
    [anon_sym_COMMA] = ACTIONS(6829),
    [anon_sym_LT_LT] = ACTIONS(6831),
    [anon_sym_DASH] = ACTIONS(6833),
    [anon_sym_GT_GT_GT] = ACTIONS(6831),
    [anon_sym_AMP_AMP] = ACTIONS(6835),
    [anon_sym_STAR] = ACTIONS(6837),
    [anon_sym_BANG_EQ] = ACTIONS(6785),
    [anon_sym_LT_EQ] = ACTIONS(6825),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6825),
    [anon_sym_GT] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6839),
    [anon_sym_PERCENT] = ACTIONS(6831),
    [anon_sym_QMARK] = ACTIONS(6841),
    [anon_sym_PIPE_PIPE] = ACTIONS(6843),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6785),
    [anon_sym_instanceof] = ACTIONS(6825),
    [anon_sym_LT] = ACTIONS(6847),
    [anon_sym_SLASH] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6849),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6843),
    [anon_sym_STAR_STAR] = ACTIONS(6851),
    [anon_sym_PLUS] = ACTIONS(6833),
    [anon_sym_GT_GT] = ACTIONS(6837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6825),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [2431] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6779),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6779),
    [anon_sym_AMP_EQ] = ACTIONS(6779),
    [anon_sym_PLUS_EQ] = ACTIONS(6779),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(6781),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(6779),
    [anon_sym_STAR_EQ] = ACTIONS(6779),
    [anon_sym_PIPE_EQ] = ACTIONS(6779),
    [anon_sym_DASH_EQ] = ACTIONS(6779),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6779),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(6779),
    [anon_sym_GT_GT_EQ] = ACTIONS(6779),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6779),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [2432] = {
    [anon_sym_COLON] = ACTIONS(6849),
    [sym_comment] = ACTIONS(3),
  },
  [2433] = {
    [sym__initializer] = STATE(587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(6781),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6785),
  },
  [2434] = {
    [sym__initializer] = STATE(589),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(6781),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6785),
  },
  [2435] = {
    [sym_type_alias_declaration] = STATE(3274),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3274),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3274),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3274),
    [sym_return_statement] = STATE(3274),
    [aux_sym_program_repeat1] = STATE(3274),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3274),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3274),
    [sym_switch_statement] = STATE(3274),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3274),
    [sym_throw_statement] = STATE(3274),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3274),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3274),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(3274),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3274),
    [sym_abstract_class] = STATE(3274),
    [sym_interface_declaration] = STATE(3274),
    [sym_statement_block] = STATE(3274),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3274),
    [sym_debugger_statement] = STATE(3274),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3274),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3274),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3274),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3274),
    [sym_empty_statement] = STATE(3274),
    [sym_import_alias] = STATE(3274),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3274),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3274),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3274),
    [sym_break_statement] = STATE(3274),
    [sym_labeled_statement] = STATE(3274),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3274),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(6855),
    [anon_sym_default] = ACTIONS(6857),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(6857),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [2436] = {
    [sym_identifier] = ACTIONS(6871),
    [anon_sym_BQUOTE] = ACTIONS(6873),
    [anon_sym_debugger] = ACTIONS(6871),
    [anon_sym_symbol] = ACTIONS(6871),
    [anon_sym_AT] = ACTIONS(6873),
    [anon_sym_DASH] = ACTIONS(6871),
    [anon_sym_void] = ACTIONS(6871),
    [anon_sym_break] = ACTIONS(6871),
    [anon_sym_const] = ACTIONS(6871),
    [sym_super] = ACTIONS(6871),
    [anon_sym_return] = ACTIONS(6871),
    [anon_sym_private] = ACTIONS(6871),
    [anon_sym_get] = ACTIONS(6871),
    [anon_sym_RBRACE] = ACTIONS(6873),
    [anon_sym_interface] = ACTIONS(6871),
    [anon_sym_default] = ACTIONS(6871),
    [anon_sym_enum] = ACTIONS(6871),
    [anon_sym_delete] = ACTIONS(6871),
    [anon_sym_continue] = ACTIONS(6871),
    [anon_sym_DASH_DASH] = ACTIONS(6873),
    [anon_sym_if] = ACTIONS(6871),
    [anon_sym_this] = ACTIONS(6871),
    [anon_sym_yield] = ACTIONS(6871),
    [sym_true] = ACTIONS(6871),
    [anon_sym_throw] = ACTIONS(6871),
    [anon_sym_protected] = ACTIONS(6871),
    [anon_sym_abstract] = ACTIONS(6871),
    [anon_sym_set] = ACTIONS(6871),
    [anon_sym_type] = ACTIONS(6871),
    [anon_sym_import] = ACTIONS(6871),
    [anon_sym_namespace] = ACTIONS(6871),
    [anon_sym_PLUS_PLUS] = ACTIONS(6873),
    [anon_sym_await] = ACTIONS(6871),
    [anon_sym_DQUOTE] = ACTIONS(6873),
    [anon_sym_else] = ACTIONS(6871),
    [anon_sym_BANG] = ACTIONS(6873),
    [anon_sym_for] = ACTIONS(6871),
    [anon_sym_LBRACK] = ACTIONS(6873),
    [sym_false] = ACTIONS(6871),
    [anon_sym_SEMI] = ACTIONS(6873),
    [anon_sym_case] = ACTIONS(6871),
    [anon_sym_module] = ACTIONS(6871),
    [anon_sym_number] = ACTIONS(6871),
    [anon_sym_class] = ACTIONS(6871),
    [anon_sym_declare] = ACTIONS(6871),
    [anon_sym_typeof] = ACTIONS(6871),
    [anon_sym_LBRACE] = ACTIONS(6873),
    [anon_sym_switch] = ACTIONS(6871),
    [anon_sym_LPAREN] = ACTIONS(6873),
    [sym_null] = ACTIONS(6871),
    [anon_sym_any] = ACTIONS(6871),
    [anon_sym_boolean] = ACTIONS(6871),
    [anon_sym_async] = ACTIONS(6871),
    [anon_sym_public] = ACTIONS(6871),
    [anon_sym_var] = ACTIONS(6871),
    [anon_sym_while] = ACTIONS(6871),
    [anon_sym_SQUOTE] = ACTIONS(6873),
    [anon_sym_try] = ACTIONS(6871),
    [anon_sym_LT] = ACTIONS(6873),
    [sym_number] = ACTIONS(6873),
    [anon_sym_SLASH] = ACTIONS(6871),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6871),
    [anon_sym_function] = ACTIONS(6871),
    [sym_undefined] = ACTIONS(6871),
    [anon_sym_new] = ACTIONS(6871),
    [ts_builtin_sym_end] = ACTIONS(6873),
    [anon_sym_let] = ACTIONS(6871),
    [anon_sym_PLUS] = ACTIONS(6871),
    [anon_sym_export] = ACTIONS(6871),
    [anon_sym_do] = ACTIONS(6871),
    [anon_sym_TILDE] = ACTIONS(6873),
    [anon_sym_with] = ACTIONS(6871),
  },
  [2437] = {
    [sym_switch_default] = STATE(2437),
    [aux_sym_switch_body_repeat1] = STATE(2437),
    [sym_switch_case] = STATE(2437),
    [anon_sym_RBRACE] = ACTIONS(6875),
    [anon_sym_default] = ACTIONS(6877),
    [anon_sym_case] = ACTIONS(6880),
    [sym_comment] = ACTIONS(3),
  },
  [2438] = {
    [anon_sym_COMMA] = ACTIONS(6883),
    [anon_sym_RPAREN] = ACTIONS(6883),
    [sym_comment] = ACTIONS(3),
  },
  [2439] = {
    [sym_union_type] = STATE(3279),
    [sym__type] = STATE(3279),
    [sym_constructor_type] = STATE(3279),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3280),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3279),
    [sym_function_type] = STATE(3279),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3281),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3109),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6885),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6887),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2440] = {
    [sym_formal_parameters] = STATE(3282),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2441] = {
    [anon_sym_EQ_GT] = ACTIONS(6891),
    [sym_comment] = ACTIONS(3),
  },
  [2442] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1488),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1489),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3109),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3113),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2443] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1488),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1489),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3109),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3113),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2444] = {
    [anon_sym_EQ_GT] = ACTIONS(6893),
    [sym_comment] = ACTIONS(3),
  },
  [2445] = {
    [sym_union_type] = STATE(3285),
    [sym__type] = STATE(3285),
    [sym_constructor_type] = STATE(3285),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1488),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3285),
    [sym_function_type] = STATE(3285),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1489),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3109),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3113),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2446] = {
    [anon_sym_COMMA] = ACTIONS(6895),
    [anon_sym_RPAREN] = ACTIONS(6895),
    [sym_comment] = ACTIONS(3),
  },
  [2447] = {
    [sym__initializer] = STATE(3286),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(6895),
    [anon_sym_COMMA] = ACTIONS(6895),
    [sym_comment] = ACTIONS(3),
  },
  [2448] = {
    [anon_sym_COMMA] = ACTIONS(6897),
    [anon_sym_RPAREN] = ACTIONS(6897),
    [sym_comment] = ACTIONS(3),
  },
  [2449] = {
    [sym__initializer] = STATE(3287),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(6883),
    [anon_sym_COMMA] = ACTIONS(6883),
    [sym_comment] = ACTIONS(3),
  },
  [2450] = {
    [anon_sym_COMMA] = ACTIONS(6899),
    [anon_sym_RPAREN] = ACTIONS(6899),
    [sym_comment] = ACTIONS(3),
  },
  [2451] = {
    [anon_sym_COMMA] = ACTIONS(6901),
    [anon_sym_RPAREN] = ACTIONS(6901),
    [sym_comment] = ACTIONS(3),
  },
  [2452] = {
    [sym__initializer] = STATE(3288),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(6901),
    [anon_sym_COMMA] = ACTIONS(6901),
    [sym_comment] = ACTIONS(3),
  },
  [2453] = {
    [anon_sym_COMMA] = ACTIONS(6903),
    [anon_sym_RPAREN] = ACTIONS(6903),
    [sym_comment] = ACTIONS(3),
  },
  [2454] = {
    [anon_sym_COMMA] = ACTIONS(6905),
    [anon_sym_RPAREN] = ACTIONS(6905),
    [sym_comment] = ACTIONS(3),
  },
  [2455] = {
    [sym__initializer] = STATE(3289),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(6905),
    [anon_sym_COMMA] = ACTIONS(6905),
    [sym_comment] = ACTIONS(3),
  },
  [2456] = {
    [anon_sym_COMMA] = ACTIONS(6907),
    [anon_sym_RPAREN] = ACTIONS(6907),
    [sym_comment] = ACTIONS(3),
  },
  [2457] = {
    [anon_sym_COMMA] = ACTIONS(6909),
    [anon_sym_RPAREN] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
  },
  [2458] = {
    [sym_type_arguments] = STATE(1064),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_RPAREN] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(6911),
  },
  [2459] = {
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(433),
    [sym_array_type] = STATE(1066),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym_existential_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(1066),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(1066),
    [sym_string] = STATE(418),
    [sym_tuple_type] = STATE(1066),
    [sym_identifier] = ACTIONS(5168),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [sym_true] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2460] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2464),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2465),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(5168),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5172),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2461] = {
    [sym_type_parameters] = STATE(3291),
    [sym_formal_parameters] = STATE(3292),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2462] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2464),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2465),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(5168),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5172),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2463] = {
    [anon_sym_AMP] = ACTIONS(6913),
    [anon_sym_RPAREN] = ACTIONS(3611),
    [anon_sym_PIPE] = ACTIONS(6915),
    [anon_sym_COMMA] = ACTIONS(3611),
    [sym_comment] = ACTIONS(3),
  },
  [2464] = {
    [sym_formal_parameters] = STATE(3295),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2465] = {
    [anon_sym_EQ_GT] = ACTIONS(6917),
    [sym_comment] = ACTIONS(3),
  },
  [2466] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1410),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1426),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(5236),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_instanceof] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5236),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1426),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(1347),
  },
  [2467] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1410),
    [anon_sym_COMMA] = ACTIONS(5240),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1426),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(5240),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_instanceof] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5240),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1426),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(1347),
  },
  [2468] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2341),
    [anon_sym_LBRACK] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_BQUOTE] = ACTIONS(2341),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_COMMA] = ACTIONS(2341),
    [anon_sym_LT_LT] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_GT_GT_GT] = ACTIONS(2341),
    [anon_sym_AMP_AMP] = ACTIONS(2341),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_BANG_EQ] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2341),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [anon_sym_GT_EQ] = ACTIONS(2341),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_EQ_GT] = ACTIONS(1384),
    [anon_sym_AMP] = ACTIONS(2343),
    [anon_sym_PERCENT] = ACTIONS(2341),
    [anon_sym_QMARK] = ACTIONS(2341),
    [anon_sym_as] = ACTIONS(2341),
    [anon_sym_PIPE_PIPE] = ACTIONS(2341),
    [anon_sym_DASH_DASH] = ACTIONS(2341),
    [anon_sym_EQ_EQ] = ACTIONS(2343),
    [anon_sym_RPAREN] = ACTIONS(2341),
    [anon_sym_LT] = ACTIONS(2343),
    [anon_sym_instanceof] = ACTIONS(2341),
    [anon_sym_SLASH] = ACTIONS(2343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2341),
    [anon_sym_DOT] = ACTIONS(2341),
    [anon_sym_CARET] = ACTIONS(2341),
    [anon_sym_STAR_STAR] = ACTIONS(2341),
    [anon_sym_PLUS] = ACTIONS(2343),
    [anon_sym_GT_GT] = ACTIONS(2343),
    [anon_sym_PLUS_PLUS] = ACTIONS(2341),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2341),
    [anon_sym_in] = ACTIONS(2343),
  },
  [2469] = {
    [anon_sym_COMMA] = ACTIONS(6919),
    [anon_sym_RPAREN] = ACTIONS(6919),
    [sym_comment] = ACTIONS(3),
  },
  [2470] = {
    [anon_sym_COLON] = ACTIONS(6921),
    [anon_sym_EQ_GT] = ACTIONS(6921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6921),
  },
  [2471] = {
    [aux_sym_export_statement_repeat1] = STATE(1512),
    [sym_decorator] = STATE(1512),
    [sym_object] = STATE(769),
    [sym_accessibility_modifier] = STATE(247),
    [sym_required_parameter] = STATE(1513),
    [sym_array] = STATE(771),
    [sym_rest_parameter] = STATE(1513),
    [sym_optional_parameter] = STATE(1513),
    [sym_this] = STATE(772),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_public] = ACTIONS(1446),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(1442),
    [anon_sym_number] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1446),
    [anon_sym_void] = ACTIONS(1442),
    [anon_sym_string] = ACTIONS(1442),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_any] = ACTIONS(1442),
    [anon_sym_private] = ACTIONS(1446),
    [anon_sym_boolean] = ACTIONS(1442),
    [anon_sym_async] = ACTIONS(1442),
  },
  [2472] = {
    [sym_new_expression] = STATE(3297),
    [sym_augmented_assignment_expression] = STATE(3297),
    [sym_unary_expression] = STATE(3297),
    [sym_update_expression] = STATE(3297),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(3297),
    [sym_regex] = STATE(3297),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3297),
    [sym_non_null_expression] = STATE(3297),
    [sym_as_expression] = STATE(3297),
    [sym_jsx_fragment] = STATE(3297),
    [sym_yield_expression] = STATE(3297),
    [sym_jsx_element] = STATE(3297),
    [sym_internal_module] = STATE(3297),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3297),
    [sym_await_expression] = STATE(3297),
    [sym_member_expression] = STATE(246),
    [sym_string] = STATE(3297),
    [sym_this] = STATE(3297),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(475),
    [sym_anonymous_class] = STATE(3297),
    [sym_generator_function] = STATE(3297),
    [sym_call_expression] = STATE(3297),
    [sym_subscript_expression] = STATE(246),
    [sym_assignment_expression] = STATE(3297),
    [sym_ternary_expression] = STATE(3297),
    [sym_binary_expression] = STATE(3297),
    [sym_template_string] = STATE(3297),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3297),
    [sym_array] = STATE(476),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3297),
    [sym_class] = STATE(3297),
    [anon_sym_BANG] = ACTIONS(412),
    [sym_identifier] = ACTIONS(843),
    [sym_false] = ACTIONS(6923),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_symbol] = ACTIONS(847),
    [anon_sym_number] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_typeof] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(849),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6923),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_boolean] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_get] = ACTIONS(847),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6925),
    [sym_true] = ACTIONS(6923),
    [anon_sym_yield] = ACTIONS(432),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_string] = ACTIONS(847),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6923),
    [anon_sym_set] = ACTIONS(847),
    [anon_sym_type] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_export] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_PLUS] = ACTIONS(418),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
  },
  [2473] = {
    [sym_union_type] = STATE(3298),
    [sym__type] = STATE(3298),
    [sym_constructor_type] = STATE(3298),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1528),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3298),
    [sym_function_type] = STATE(3298),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1529),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3194),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2474] = {
    [sym_formal_parameters] = STATE(3299),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2475] = {
    [anon_sym_EQ_GT] = ACTIONS(6927),
    [sym_comment] = ACTIONS(3),
  },
  [2476] = {
    [sym_union_type] = STATE(3067),
    [sym__type] = STATE(3067),
    [sym_constructor_type] = STATE(3067),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1528),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3067),
    [sym_function_type] = STATE(3067),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1529),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3194),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2477] = {
    [sym_union_type] = STATE(3068),
    [sym__type] = STATE(3068),
    [sym_constructor_type] = STATE(3068),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1528),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3068),
    [sym_function_type] = STATE(3068),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1529),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3194),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2478] = {
    [anon_sym_EQ_GT] = ACTIONS(6929),
    [sym_comment] = ACTIONS(3),
  },
  [2479] = {
    [sym_union_type] = STATE(3302),
    [sym__type] = STATE(3302),
    [sym_constructor_type] = STATE(3302),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1528),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3302),
    [sym_function_type] = STATE(3302),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1529),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3194),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2480] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1332),
    [anon_sym_AMP_EQ] = ACTIONS(1332),
    [anon_sym_PLUS_EQ] = ACTIONS(1332),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_CARET_EQ] = ACTIONS(1332),
    [anon_sym_STAR_EQ] = ACTIONS(1332),
    [anon_sym_PIPE_EQ] = ACTIONS(1332),
    [anon_sym_DASH_EQ] = ACTIONS(1332),
    [anon_sym_EQ_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1332),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT_EQ] = ACTIONS(1332),
    [anon_sym_DOT] = ACTIONS(6439),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1347),
  },
  [2481] = {
    [sym__initializer] = STATE(3303),
    [sym_type_annotation] = STATE(3304),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(6931),
    [anon_sym_COMMA] = ACTIONS(6931),
    [sym_comment] = ACTIONS(3),
  },
  [2482] = {
    [anon_sym_COMMA] = ACTIONS(6933),
    [anon_sym_RPAREN] = ACTIONS(6933),
    [sym_comment] = ACTIONS(3),
  },
  [2483] = {
    [sym__initializer] = STATE(3305),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(6933),
    [anon_sym_COMMA] = ACTIONS(6933),
    [sym_comment] = ACTIONS(3),
  },
  [2484] = {
    [sym__initializer] = STATE(3287),
    [sym_type_annotation] = STATE(3306),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(6883),
    [anon_sym_COMMA] = ACTIONS(6883),
    [sym_comment] = ACTIONS(3),
  },
  [2485] = {
    [sym__initializer] = STATE(3307),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(6899),
    [anon_sym_COMMA] = ACTIONS(6899),
    [sym_comment] = ACTIONS(3),
  },
  [2486] = {
    [sym__initializer] = STATE(3308),
    [sym_type_annotation] = STATE(3309),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(6935),
    [anon_sym_COMMA] = ACTIONS(6935),
    [sym_comment] = ACTIONS(3),
  },
  [2487] = {
    [anon_sym_COMMA] = ACTIONS(6937),
    [anon_sym_RPAREN] = ACTIONS(6937),
    [sym_comment] = ACTIONS(3),
  },
  [2488] = {
    [sym__initializer] = STATE(3310),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(6937),
    [anon_sym_COMMA] = ACTIONS(6937),
    [sym_comment] = ACTIONS(3),
  },
  [2489] = {
    [sym__initializer] = STATE(3311),
    [sym_type_annotation] = STATE(3312),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(6939),
    [anon_sym_COMMA] = ACTIONS(6939),
    [sym_comment] = ACTIONS(3),
  },
  [2490] = {
    [anon_sym_COMMA] = ACTIONS(6941),
    [anon_sym_RPAREN] = ACTIONS(6941),
    [sym_comment] = ACTIONS(3),
  },
  [2491] = {
    [sym__initializer] = STATE(3313),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(6941),
    [anon_sym_COMMA] = ACTIONS(6941),
    [sym_comment] = ACTIONS(3),
  },
  [2492] = {
    [aux_sym_export_statement_repeat1] = STATE(1512),
    [sym_decorator] = STATE(1512),
    [sym_object] = STATE(769),
    [sym_accessibility_modifier] = STATE(247),
    [sym_required_parameter] = STATE(1513),
    [sym_array] = STATE(771),
    [sym_rest_parameter] = STATE(1513),
    [sym_optional_parameter] = STATE(1513),
    [sym_this] = STATE(772),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_public] = ACTIONS(1446),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(1442),
    [anon_sym_number] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_RPAREN] = ACTIONS(6943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1446),
    [anon_sym_void] = ACTIONS(1442),
    [anon_sym_string] = ACTIONS(1442),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_any] = ACTIONS(1442),
    [anon_sym_private] = ACTIONS(1446),
    [anon_sym_boolean] = ACTIONS(1442),
    [anon_sym_async] = ACTIONS(1442),
  },
  [2493] = {
    [anon_sym_COMMA] = ACTIONS(6945),
    [anon_sym_RPAREN] = ACTIONS(6945),
    [sym_comment] = ACTIONS(3),
  },
  [2494] = {
    [anon_sym_COMMA] = ACTIONS(6947),
    [anon_sym_RPAREN] = ACTIONS(6947),
    [sym_comment] = ACTIONS(3),
  },
  [2495] = {
    [sym_identifier] = ACTIONS(6949),
    [anon_sym_BQUOTE] = ACTIONS(6951),
    [anon_sym_debugger] = ACTIONS(6949),
    [anon_sym_symbol] = ACTIONS(6949),
    [anon_sym_AT] = ACTIONS(6951),
    [anon_sym_DASH] = ACTIONS(6949),
    [anon_sym_void] = ACTIONS(6949),
    [anon_sym_break] = ACTIONS(6949),
    [anon_sym_const] = ACTIONS(6949),
    [sym_super] = ACTIONS(6949),
    [anon_sym_return] = ACTIONS(6949),
    [anon_sym_private] = ACTIONS(6949),
    [anon_sym_get] = ACTIONS(6949),
    [anon_sym_RBRACE] = ACTIONS(6951),
    [anon_sym_interface] = ACTIONS(6949),
    [anon_sym_default] = ACTIONS(6949),
    [anon_sym_enum] = ACTIONS(6949),
    [anon_sym_delete] = ACTIONS(6949),
    [anon_sym_continue] = ACTIONS(6949),
    [anon_sym_DASH_DASH] = ACTIONS(6951),
    [anon_sym_if] = ACTIONS(6949),
    [anon_sym_this] = ACTIONS(6949),
    [anon_sym_yield] = ACTIONS(6949),
    [sym_true] = ACTIONS(6949),
    [anon_sym_throw] = ACTIONS(6949),
    [anon_sym_protected] = ACTIONS(6949),
    [anon_sym_abstract] = ACTIONS(6949),
    [anon_sym_set] = ACTIONS(6949),
    [anon_sym_type] = ACTIONS(6949),
    [anon_sym_import] = ACTIONS(6949),
    [anon_sym_namespace] = ACTIONS(6949),
    [anon_sym_PLUS_PLUS] = ACTIONS(6951),
    [anon_sym_await] = ACTIONS(6949),
    [anon_sym_DQUOTE] = ACTIONS(6951),
    [anon_sym_else] = ACTIONS(6949),
    [anon_sym_BANG] = ACTIONS(6951),
    [anon_sym_for] = ACTIONS(6949),
    [anon_sym_LBRACK] = ACTIONS(6951),
    [sym_false] = ACTIONS(6949),
    [anon_sym_SEMI] = ACTIONS(6951),
    [anon_sym_case] = ACTIONS(6949),
    [anon_sym_module] = ACTIONS(6949),
    [anon_sym_number] = ACTIONS(6949),
    [anon_sym_class] = ACTIONS(6949),
    [anon_sym_declare] = ACTIONS(6949),
    [anon_sym_typeof] = ACTIONS(6949),
    [anon_sym_LBRACE] = ACTIONS(6951),
    [anon_sym_switch] = ACTIONS(6949),
    [anon_sym_LPAREN] = ACTIONS(6951),
    [sym_null] = ACTIONS(6949),
    [anon_sym_any] = ACTIONS(6949),
    [anon_sym_boolean] = ACTIONS(6949),
    [anon_sym_async] = ACTIONS(6949),
    [anon_sym_public] = ACTIONS(6949),
    [anon_sym_var] = ACTIONS(6949),
    [anon_sym_while] = ACTIONS(6949),
    [anon_sym_SQUOTE] = ACTIONS(6951),
    [anon_sym_try] = ACTIONS(6949),
    [anon_sym_LT] = ACTIONS(6951),
    [sym_number] = ACTIONS(6951),
    [anon_sym_SLASH] = ACTIONS(6949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6949),
    [anon_sym_function] = ACTIONS(6949),
    [sym_undefined] = ACTIONS(6949),
    [anon_sym_new] = ACTIONS(6949),
    [ts_builtin_sym_end] = ACTIONS(6951),
    [anon_sym_let] = ACTIONS(6949),
    [anon_sym_PLUS] = ACTIONS(6949),
    [anon_sym_export] = ACTIONS(6949),
    [anon_sym_do] = ACTIONS(6949),
    [anon_sym_TILDE] = ACTIONS(6951),
    [anon_sym_with] = ACTIONS(6949),
  },
  [2496] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6953),
    [sym_identifier] = ACTIONS(6955),
    [sym__automatic_semicolon] = ACTIONS(6953),
    [anon_sym_BQUOTE] = ACTIONS(6953),
    [anon_sym_debugger] = ACTIONS(6955),
    [ts_builtin_sym_end] = ACTIONS(6953),
    [anon_sym_symbol] = ACTIONS(6955),
    [anon_sym_AT] = ACTIONS(6953),
    [anon_sym_PIPE] = ACTIONS(6955),
    [anon_sym_COMMA] = ACTIONS(6953),
    [anon_sym_DASH] = ACTIONS(6955),
    [anon_sym_STAR] = ACTIONS(6955),
    [anon_sym_GT_GT_GT] = ACTIONS(6953),
    [anon_sym_void] = ACTIONS(6955),
    [anon_sym_break] = ACTIONS(6955),
    [anon_sym_BANG_EQ] = ACTIONS(6955),
    [anon_sym_const] = ACTIONS(6955),
    [anon_sym_GT_EQ] = ACTIONS(6953),
    [sym_super] = ACTIONS(6955),
    [anon_sym_return] = ACTIONS(6955),
    [anon_sym_private] = ACTIONS(6955),
    [anon_sym_get] = ACTIONS(6955),
    [anon_sym_RBRACE] = ACTIONS(6953),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [anon_sym_interface] = ACTIONS(6955),
    [anon_sym_default] = ACTIONS(6955),
    [anon_sym_as] = ACTIONS(6955),
    [anon_sym_delete] = ACTIONS(6955),
    [anon_sym_continue] = ACTIONS(6955),
    [anon_sym_DASH_DASH] = ACTIONS(6953),
    [anon_sym_if] = ACTIONS(6955),
    [anon_sym_instanceof] = ACTIONS(6955),
    [anon_sym_this] = ACTIONS(6955),
    [anon_sym_yield] = ACTIONS(6955),
    [sym_true] = ACTIONS(6955),
    [anon_sym_throw] = ACTIONS(6955),
    [anon_sym_enum] = ACTIONS(6955),
    [anon_sym_protected] = ACTIONS(6955),
    [anon_sym_abstract] = ACTIONS(6955),
    [anon_sym_DOT] = ACTIONS(6955),
    [anon_sym_set] = ACTIONS(6955),
    [anon_sym_type] = ACTIONS(6955),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_import] = ACTIONS(6955),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6953),
    [anon_sym_namespace] = ACTIONS(6955),
    [anon_sym_PLUS_PLUS] = ACTIONS(6953),
    [anon_sym_await] = ACTIONS(6955),
    [anon_sym_DQUOTE] = ACTIONS(6953),
    [anon_sym_else] = ACTIONS(6955),
    [anon_sym_BANG] = ACTIONS(6955),
    [anon_sym_for] = ACTIONS(6955),
    [anon_sym_LBRACK] = ACTIONS(6953),
    [sym_false] = ACTIONS(6955),
    [anon_sym_SEMI] = ACTIONS(6953),
    [anon_sym_case] = ACTIONS(6955),
    [anon_sym_module] = ACTIONS(6955),
    [anon_sym_number] = ACTIONS(6955),
    [anon_sym_class] = ACTIONS(6955),
    [anon_sym_declare] = ACTIONS(6955),
    [anon_sym_typeof] = ACTIONS(6955),
    [anon_sym_LT_LT] = ACTIONS(6953),
    [anon_sym_LBRACE] = ACTIONS(6953),
    [anon_sym_AMP_AMP] = ACTIONS(6953),
    [anon_sym_switch] = ACTIONS(6955),
    [anon_sym_LT_EQ] = ACTIONS(6953),
    [anon_sym_LPAREN] = ACTIONS(6953),
    [sym_null] = ACTIONS(6955),
    [anon_sym_GT] = ACTIONS(6955),
    [anon_sym_any] = ACTIONS(6955),
    [anon_sym_boolean] = ACTIONS(6955),
    [anon_sym_async] = ACTIONS(6955),
    [anon_sym_public] = ACTIONS(6955),
    [anon_sym_AMP] = ACTIONS(6955),
    [anon_sym_var] = ACTIONS(6955),
    [anon_sym_QMARK] = ACTIONS(6953),
    [anon_sym_PIPE_PIPE] = ACTIONS(6953),
    [anon_sym_while] = ACTIONS(6955),
    [anon_sym_SQUOTE] = ACTIONS(6953),
    [anon_sym_try] = ACTIONS(6955),
    [anon_sym_EQ_EQ] = ACTIONS(6955),
    [anon_sym_RPAREN] = ACTIONS(6953),
    [anon_sym_LT] = ACTIONS(6955),
    [sym_number] = ACTIONS(6953),
    [anon_sym_SLASH] = ACTIONS(6955),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6955),
    [anon_sym_function] = ACTIONS(6955),
    [sym_undefined] = ACTIONS(6955),
    [anon_sym_new] = ACTIONS(6955),
    [anon_sym_CARET] = ACTIONS(6953),
    [anon_sym_let] = ACTIONS(6955),
    [anon_sym_PLUS] = ACTIONS(6955),
    [anon_sym_export] = ACTIONS(6955),
    [anon_sym_GT_GT] = ACTIONS(6955),
    [anon_sym_do] = ACTIONS(6955),
    [anon_sym_TILDE] = ACTIONS(6953),
    [anon_sym_with] = ACTIONS(6955),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6953),
    [anon_sym_in] = ACTIONS(6955),
  },
  [2497] = {
    [anon_sym_RPAREN] = ACTIONS(6957),
    [sym_comment] = ACTIONS(3),
  },
  [2498] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6959),
    [anon_sym_LBRACK] = ACTIONS(6959),
    [anon_sym_BANG] = ACTIONS(6961),
    [anon_sym_SEMI] = ACTIONS(6959),
    [anon_sym_BQUOTE] = ACTIONS(6959),
    [sym__automatic_semicolon] = ACTIONS(6959),
    [anon_sym_PIPE] = ACTIONS(6961),
    [anon_sym_COMMA] = ACTIONS(6959),
    [anon_sym_LT_LT] = ACTIONS(6959),
    [anon_sym_STAR] = ACTIONS(6961),
    [anon_sym_GT_GT_GT] = ACTIONS(6959),
    [anon_sym_AMP_AMP] = ACTIONS(6959),
    [anon_sym_DASH] = ACTIONS(6961),
    [anon_sym_BANG_EQ] = ACTIONS(6961),
    [anon_sym_LT_EQ] = ACTIONS(6959),
    [anon_sym_LPAREN] = ACTIONS(6959),
    [anon_sym_GT_EQ] = ACTIONS(6959),
    [anon_sym_GT] = ACTIONS(6961),
    [anon_sym_AMP] = ACTIONS(6961),
    [anon_sym_PERCENT] = ACTIONS(6959),
    [anon_sym_QMARK] = ACTIONS(6959),
    [anon_sym_RBRACE] = ACTIONS(6959),
    [anon_sym_as] = ACTIONS(6959),
    [anon_sym_PIPE_PIPE] = ACTIONS(6959),
    [anon_sym_DASH_DASH] = ACTIONS(6959),
    [anon_sym_EQ_EQ] = ACTIONS(6961),
    [anon_sym_instanceof] = ACTIONS(6959),
    [anon_sym_LT] = ACTIONS(6961),
    [anon_sym_RPAREN] = ACTIONS(6959),
    [anon_sym_SLASH] = ACTIONS(6961),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6959),
    [anon_sym_CARET] = ACTIONS(6959),
    [anon_sym_STAR_STAR] = ACTIONS(6959),
    [anon_sym_PLUS] = ACTIONS(6961),
    [anon_sym_GT_GT] = ACTIONS(6961),
    [anon_sym_PLUS_PLUS] = ACTIONS(6959),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6959),
    [anon_sym_in] = ACTIONS(6961),
  },
  [2499] = {
    [anon_sym_GT] = ACTIONS(6963),
    [sym_comment] = ACTIONS(3),
  },
  [2500] = {
    [aux_sym_string_repeat2] = STATE(3318),
    [sym_escape_sequence] = ACTIONS(6965),
    [aux_sym_string_token2] = ACTIONS(6965),
    [sym_comment] = ACTIONS(246),
    [anon_sym_SQUOTE] = ACTIONS(6967),
  },
  [2501] = {
    [sym_nested_identifier] = STATE(3322),
    [sym_jsx_namespace_name] = STATE(3323),
    [anon_sym_GT] = ACTIONS(6969),
    [sym_identifier] = ACTIONS(6971),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(6973),
  },
  [2502] = {
    [aux_sym_string_repeat1] = STATE(3324),
    [sym_escape_sequence] = ACTIONS(6975),
    [aux_sym_string_token1] = ACTIONS(6975),
    [anon_sym_DQUOTE] = ACTIONS(6967),
    [sym_comment] = ACTIONS(246),
  },
  [2503] = {
    [anon_sym_GT] = ACTIONS(6977),
    [sym_jsx_identifier] = ACTIONS(6977),
    [sym_identifier] = ACTIONS(6979),
    [anon_sym_SLASH] = ACTIONS(6979),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6977),
  },
  [2504] = {
    [sym_jsx_closing_element] = STATE(3326),
    [sym_jsx_opening_element] = STATE(340),
    [aux_sym_jsx_element_repeat1] = STATE(3327),
    [sym_jsx_expression] = STATE(3327),
    [sym_jsx_self_closing_element] = STATE(3327),
    [sym_jsx_element] = STATE(3327),
    [sym_jsx_text] = ACTIONS(6981),
    [anon_sym_LT] = ACTIONS(6983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(590),
  },
  [2505] = {
    [sym_union_type] = STATE(3331),
    [sym__type] = STATE(3331),
    [sym_constructor_type] = STATE(3331),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3332),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3331),
    [sym_function_type] = STATE(3331),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3333),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3319),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6985),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6987),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2506] = {
    [sym_formal_parameters] = STATE(3334),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2507] = {
    [anon_sym_EQ_GT] = ACTIONS(6991),
    [sym_comment] = ACTIONS(3),
  },
  [2508] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1579),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1580),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3319),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2509] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1579),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1580),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3319),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2510] = {
    [anon_sym_EQ_GT] = ACTIONS(6993),
    [sym_comment] = ACTIONS(3),
  },
  [2511] = {
    [sym_union_type] = STATE(3337),
    [sym__type] = STATE(3337),
    [sym_constructor_type] = STATE(3337),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1579),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3337),
    [sym_function_type] = STATE(3337),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1580),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3319),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2512] = {
    [anon_sym_GT] = ACTIONS(6995),
    [sym_jsx_identifier] = ACTIONS(6995),
    [sym_identifier] = ACTIONS(5816),
    [anon_sym_SLASH] = ACTIONS(5816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6995),
  },
  [2513] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6997),
    [anon_sym_LBRACK] = ACTIONS(6997),
    [anon_sym_BANG] = ACTIONS(6999),
    [anon_sym_SEMI] = ACTIONS(6997),
    [anon_sym_BQUOTE] = ACTIONS(6997),
    [sym__automatic_semicolon] = ACTIONS(6997),
    [anon_sym_PIPE] = ACTIONS(6999),
    [anon_sym_COMMA] = ACTIONS(6997),
    [anon_sym_LT_LT] = ACTIONS(6997),
    [anon_sym_STAR] = ACTIONS(6999),
    [anon_sym_GT_GT_GT] = ACTIONS(6997),
    [anon_sym_AMP_AMP] = ACTIONS(6997),
    [anon_sym_DASH] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(6997),
    [anon_sym_LPAREN] = ACTIONS(6997),
    [anon_sym_GT_EQ] = ACTIONS(6997),
    [anon_sym_GT] = ACTIONS(6999),
    [anon_sym_AMP] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(6997),
    [anon_sym_QMARK] = ACTIONS(6997),
    [anon_sym_RBRACE] = ACTIONS(6997),
    [anon_sym_as] = ACTIONS(6997),
    [anon_sym_PIPE_PIPE] = ACTIONS(6997),
    [anon_sym_DASH_DASH] = ACTIONS(6997),
    [anon_sym_EQ_EQ] = ACTIONS(6999),
    [anon_sym_instanceof] = ACTIONS(6997),
    [anon_sym_LT] = ACTIONS(6999),
    [anon_sym_RPAREN] = ACTIONS(6997),
    [anon_sym_SLASH] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6997),
    [anon_sym_CARET] = ACTIONS(6997),
    [anon_sym_STAR_STAR] = ACTIONS(6997),
    [anon_sym_PLUS] = ACTIONS(6999),
    [anon_sym_GT_GT] = ACTIONS(6999),
    [anon_sym_PLUS_PLUS] = ACTIONS(6997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6997),
    [anon_sym_in] = ACTIONS(6999),
  },
  [2514] = {
    [anon_sym_GT] = ACTIONS(7001),
    [sym_jsx_identifier] = ACTIONS(7001),
    [sym_identifier] = ACTIONS(7003),
    [anon_sym_SLASH] = ACTIONS(7003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7001),
  },
  [2515] = {
    [sym_jsx_text] = ACTIONS(7005),
    [anon_sym_LT] = ACTIONS(7005),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7005),
  },
  [2516] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(2516),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(2516),
    [sym_jsx_expression] = STATE(2516),
    [anon_sym_GT] = ACTIONS(5311),
    [anon_sym_LBRACE] = ACTIONS(5321),
    [sym_identifier] = ACTIONS(5316),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(5313),
  },
  [2517] = {
    [anon_sym_extends] = ACTIONS(7007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(7007),
    [anon_sym_EQ] = ACTIONS(7007),
    [anon_sym_implements] = ACTIONS(7007),
    [anon_sym_LPAREN] = ACTIONS(7007),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7009),
  },
  [2518] = {
    [sym_type_parameter] = STATE(1594),
    [sym_identifier] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
  },
  [2519] = {
    [aux_sym_formal_parameters_repeat1] = STATE(3340),
    [anon_sym_COMMA] = ACTIONS(7011),
    [anon_sym_RPAREN] = ACTIONS(7013),
    [sym_comment] = ACTIONS(3),
  },
  [2520] = {
    [aux_sym_export_statement_repeat1] = STATE(1512),
    [sym_decorator] = STATE(1512),
    [sym_object] = STATE(769),
    [sym_accessibility_modifier] = STATE(247),
    [sym_required_parameter] = STATE(1513),
    [sym_array] = STATE(771),
    [sym_rest_parameter] = STATE(1513),
    [sym_optional_parameter] = STATE(1513),
    [sym_this] = STATE(772),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_public] = ACTIONS(1446),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(1442),
    [anon_sym_number] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_RPAREN] = ACTIONS(7013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1446),
    [anon_sym_void] = ACTIONS(1442),
    [anon_sym_string] = ACTIONS(1442),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_any] = ACTIONS(1442),
    [anon_sym_private] = ACTIONS(1446),
    [anon_sym_boolean] = ACTIONS(1442),
    [anon_sym_async] = ACTIONS(1442),
  },
  [2521] = {
    [anon_sym_COLON] = ACTIONS(3166),
    [sym__automatic_semicolon] = ACTIONS(3166),
    [anon_sym_RBRACE] = ACTIONS(3166),
    [anon_sym_SEMI] = ACTIONS(3166),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3166),
    [anon_sym_COMMA] = ACTIONS(3166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3166),
  },
  [2522] = {
    [aux_sym_formal_parameters_repeat1] = STATE(1515),
    [anon_sym_COMMA] = ACTIONS(7011),
    [anon_sym_RPAREN] = ACTIONS(7013),
    [sym_comment] = ACTIONS(3),
  },
  [2523] = {
    [sym__automatic_semicolon] = ACTIONS(3603),
    [anon_sym_RBRACE] = ACTIONS(3603),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3603),
    [anon_sym_SEMI] = ACTIONS(3603),
    [anon_sym_COMMA] = ACTIONS(3603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3603),
  },
  [2524] = {
    [sym_type_arguments] = STATE(1885),
    [sym__automatic_semicolon] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(3983),
    [anon_sym_is] = ACTIONS(7015),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(3985),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2204),
  },
  [2525] = {
    [sym_index_type_query] = STATE(1887),
    [sym_lookup_type] = STATE(1887),
    [sym_flow_maybe_type] = STATE(1887),
    [sym_parenthesized_type] = STATE(1887),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_array_type] = STATE(1887),
    [sym_type_predicate] = STATE(1887),
    [sym_type_query] = STATE(1887),
    [sym_existential_type] = STATE(1887),
    [sym_this_type] = STATE(1887),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1887),
    [sym__primary_type] = STATE(1887),
    [sym_generic_type] = STATE(1887),
    [sym_literal_type] = STATE(1887),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1887),
    [sym_string] = STATE(1017),
    [sym_tuple_type] = STATE(1887),
    [sym_identifier] = ACTIONS(5347),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [sym_true] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_LPAREN] = ACTIONS(3989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [2526] = {
    [sym_union_type] = STATE(1892),
    [sym__type] = STATE(1892),
    [sym_constructor_type] = STATE(1892),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2530),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1892),
    [sym_function_type] = STATE(1892),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2531),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5347),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5353),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [2527] = {
    [sym_type_parameters] = STATE(3342),
    [sym_formal_parameters] = STATE(3343),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2528] = {
    [sym_union_type] = STATE(1900),
    [sym__type] = STATE(1900),
    [sym_constructor_type] = STATE(1900),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2530),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1900),
    [sym_function_type] = STATE(1900),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2531),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5347),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5353),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [2529] = {
    [sym__automatic_semicolon] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(7017),
    [anon_sym_SEMI] = ACTIONS(3611),
    [anon_sym_PIPE] = ACTIONS(7019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3611),
  },
  [2530] = {
    [sym_formal_parameters] = STATE(3346),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2531] = {
    [anon_sym_EQ_GT] = ACTIONS(7021),
    [sym_comment] = ACTIONS(3),
  },
  [2532] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7023),
    [sym_identifier] = ACTIONS(7025),
    [sym__automatic_semicolon] = ACTIONS(7023),
    [anon_sym_BQUOTE] = ACTIONS(7023),
    [anon_sym_debugger] = ACTIONS(7025),
    [ts_builtin_sym_end] = ACTIONS(7023),
    [anon_sym_symbol] = ACTIONS(7025),
    [anon_sym_AT] = ACTIONS(7023),
    [anon_sym_PIPE] = ACTIONS(7025),
    [anon_sym_COMMA] = ACTIONS(7023),
    [anon_sym_DASH] = ACTIONS(7025),
    [anon_sym_STAR] = ACTIONS(7025),
    [anon_sym_GT_GT_GT] = ACTIONS(7023),
    [anon_sym_void] = ACTIONS(7025),
    [anon_sym_break] = ACTIONS(7025),
    [anon_sym_BANG_EQ] = ACTIONS(7025),
    [anon_sym_const] = ACTIONS(7025),
    [anon_sym_GT_EQ] = ACTIONS(7023),
    [sym_super] = ACTIONS(7025),
    [anon_sym_return] = ACTIONS(7025),
    [anon_sym_private] = ACTIONS(7025),
    [anon_sym_get] = ACTIONS(7025),
    [anon_sym_RBRACE] = ACTIONS(7023),
    [anon_sym_PERCENT] = ACTIONS(7023),
    [anon_sym_interface] = ACTIONS(7025),
    [anon_sym_default] = ACTIONS(7025),
    [anon_sym_as] = ACTIONS(7025),
    [anon_sym_delete] = ACTIONS(7025),
    [anon_sym_continue] = ACTIONS(7025),
    [anon_sym_DASH_DASH] = ACTIONS(7023),
    [anon_sym_if] = ACTIONS(7025),
    [anon_sym_instanceof] = ACTIONS(7025),
    [anon_sym_this] = ACTIONS(7025),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_true] = ACTIONS(7025),
    [anon_sym_throw] = ACTIONS(7025),
    [anon_sym_enum] = ACTIONS(7025),
    [anon_sym_protected] = ACTIONS(7025),
    [anon_sym_abstract] = ACTIONS(7025),
    [anon_sym_DOT] = ACTIONS(7025),
    [anon_sym_set] = ACTIONS(7025),
    [anon_sym_type] = ACTIONS(7025),
    [anon_sym_STAR_STAR] = ACTIONS(7023),
    [anon_sym_import] = ACTIONS(7025),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7023),
    [anon_sym_namespace] = ACTIONS(7025),
    [anon_sym_PLUS_PLUS] = ACTIONS(7023),
    [anon_sym_await] = ACTIONS(7025),
    [anon_sym_DQUOTE] = ACTIONS(7023),
    [anon_sym_else] = ACTIONS(7025),
    [anon_sym_BANG] = ACTIONS(7025),
    [anon_sym_for] = ACTIONS(7025),
    [anon_sym_LBRACK] = ACTIONS(7023),
    [sym_false] = ACTIONS(7025),
    [anon_sym_SEMI] = ACTIONS(7023),
    [anon_sym_case] = ACTIONS(7025),
    [anon_sym_module] = ACTIONS(7025),
    [anon_sym_number] = ACTIONS(7025),
    [anon_sym_class] = ACTIONS(7025),
    [anon_sym_declare] = ACTIONS(7025),
    [anon_sym_typeof] = ACTIONS(7025),
    [anon_sym_LT_LT] = ACTIONS(7023),
    [anon_sym_LBRACE] = ACTIONS(7023),
    [anon_sym_AMP_AMP] = ACTIONS(7023),
    [anon_sym_switch] = ACTIONS(7025),
    [anon_sym_LT_EQ] = ACTIONS(7023),
    [anon_sym_LPAREN] = ACTIONS(7023),
    [sym_null] = ACTIONS(7025),
    [anon_sym_GT] = ACTIONS(7025),
    [anon_sym_any] = ACTIONS(7025),
    [anon_sym_boolean] = ACTIONS(7025),
    [anon_sym_async] = ACTIONS(7025),
    [anon_sym_public] = ACTIONS(7025),
    [anon_sym_AMP] = ACTIONS(7025),
    [anon_sym_var] = ACTIONS(7025),
    [anon_sym_QMARK] = ACTIONS(7023),
    [anon_sym_PIPE_PIPE] = ACTIONS(7023),
    [anon_sym_while] = ACTIONS(7025),
    [anon_sym_SQUOTE] = ACTIONS(7023),
    [anon_sym_try] = ACTIONS(7025),
    [anon_sym_EQ_EQ] = ACTIONS(7025),
    [anon_sym_RPAREN] = ACTIONS(7023),
    [anon_sym_LT] = ACTIONS(7025),
    [sym_number] = ACTIONS(7023),
    [anon_sym_SLASH] = ACTIONS(7025),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7025),
    [anon_sym_function] = ACTIONS(7025),
    [sym_undefined] = ACTIONS(7025),
    [anon_sym_new] = ACTIONS(7025),
    [anon_sym_CARET] = ACTIONS(7023),
    [anon_sym_let] = ACTIONS(7025),
    [anon_sym_PLUS] = ACTIONS(7025),
    [anon_sym_export] = ACTIONS(7025),
    [anon_sym_GT_GT] = ACTIONS(7025),
    [anon_sym_do] = ACTIONS(7025),
    [anon_sym_TILDE] = ACTIONS(7023),
    [anon_sym_with] = ACTIONS(7025),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7023),
    [anon_sym_in] = ACTIONS(7025),
  },
  [2533] = {
    [sym_union_type] = STATE(3351),
    [sym__type] = STATE(3351),
    [sym_constructor_type] = STATE(3351),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3352),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3351),
    [sym_function_type] = STATE(3351),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3353),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3367),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(7027),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(7029),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(7031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2534] = {
    [sym_formal_parameters] = STATE(3354),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2535] = {
    [anon_sym_EQ_GT] = ACTIONS(7033),
    [sym_comment] = ACTIONS(3),
  },
  [2536] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1613),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1614),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3367),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2537] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1613),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1614),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3367),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2538] = {
    [anon_sym_EQ_GT] = ACTIONS(7035),
    [sym_comment] = ACTIONS(3),
  },
  [2539] = {
    [sym_union_type] = STATE(3357),
    [sym__type] = STATE(3357),
    [sym_constructor_type] = STATE(3357),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1613),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3357),
    [sym_function_type] = STATE(3357),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1614),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3367),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2540] = {
    [sym_new_expression] = STATE(565),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(565),
    [sym_regex] = STATE(565),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2185),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(565),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(565),
    [sym_this] = STATE(565),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(565),
    [sym_generator_function] = STATE(565),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(565),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(565),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(565),
    [anon_sym_BANG] = ACTIONS(484),
    [sym_identifier] = ACTIONS(1543),
    [sym_false] = ACTIONS(1567),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1567),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1569),
    [sym_true] = ACTIONS(1567),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1567),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
  },
  [2541] = {
    [sym_new_expression] = STATE(565),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(565),
    [sym_regex] = STATE(565),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2187),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(565),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(565),
    [sym_this] = STATE(565),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(565),
    [sym_generator_function] = STATE(565),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(565),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(565),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(565),
    [anon_sym_BANG] = ACTIONS(484),
    [sym_identifier] = ACTIONS(1543),
    [sym_false] = ACTIONS(1567),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1567),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1569),
    [sym_true] = ACTIONS(1567),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1567),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
  },
  [2542] = {
    [sym__initializer] = STATE(522),
    [sym_type_annotation] = STATE(1508),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2307),
    [anon_sym_AMP_EQ] = ACTIONS(2307),
    [anon_sym_PLUS_EQ] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(7037),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2307),
    [anon_sym_STAR_EQ] = ACTIONS(2307),
    [anon_sym_PIPE_EQ] = ACTIONS(2307),
    [anon_sym_DASH_EQ] = ACTIONS(2307),
    [anon_sym_EQ_GT] = ACTIONS(2309),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2307),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(7037),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3156),
    [anon_sym_SLASH_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT_EQ] = ACTIONS(2307),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2311),
  },
  [2543] = {
    [sym_new_expression] = STATE(3358),
    [sym_augmented_assignment_expression] = STATE(3358),
    [sym_unary_expression] = STATE(3358),
    [sym_update_expression] = STATE(3358),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(3358),
    [sym_regex] = STATE(3358),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3358),
    [sym_non_null_expression] = STATE(3358),
    [sym_as_expression] = STATE(3358),
    [sym_jsx_fragment] = STATE(3358),
    [sym_yield_expression] = STATE(3358),
    [sym_jsx_element] = STATE(3358),
    [sym_internal_module] = STATE(3358),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3358),
    [sym_await_expression] = STATE(3358),
    [sym_member_expression] = STATE(454),
    [sym_spread_element] = STATE(537),
    [sym_sequence_expression] = STATE(1521),
    [sym_string] = STATE(3358),
    [sym_this] = STATE(3358),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(3358),
    [sym_generator_function] = STATE(3358),
    [sym_call_expression] = STATE(3358),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(3358),
    [sym_ternary_expression] = STATE(3358),
    [sym_binary_expression] = STATE(3358),
    [sym_template_string] = STATE(3358),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3358),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3358),
    [sym_class] = STATE(3358),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(7040),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_COMMA] = ACTIONS(975),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(797),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7040),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_RPAREN] = ACTIONS(975),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7042),
    [sym_true] = ACTIONS(7040),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7040),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [2544] = {
    [sym_new_expression] = STATE(565),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(835),
    [sym_meta_property] = STATE(565),
    [sym_regex] = STATE(565),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(565),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(565),
    [sym_this] = STATE(565),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(565),
    [sym_generator_function] = STATE(565),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(565),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(565),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(565),
    [anon_sym_BANG] = ACTIONS(484),
    [sym_identifier] = ACTIONS(1543),
    [sym_false] = ACTIONS(1567),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1567),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1569),
    [sym_true] = ACTIONS(1567),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1567),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
  },
  [2545] = {
    [sym_union_type] = STATE(3359),
    [sym__type] = STATE(3359),
    [sym_constructor_type] = STATE(3359),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1647),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3359),
    [sym_function_type] = STATE(3359),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1648),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3438),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3444),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3446),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2546] = {
    [sym_formal_parameters] = STATE(3360),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2547] = {
    [anon_sym_EQ_GT] = ACTIONS(7044),
    [sym_comment] = ACTIONS(3),
  },
  [2548] = {
    [sym_union_type] = STATE(3067),
    [sym__type] = STATE(3067),
    [sym_constructor_type] = STATE(3067),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1647),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3067),
    [sym_function_type] = STATE(3067),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1648),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3438),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3444),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3446),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2549] = {
    [sym_union_type] = STATE(3068),
    [sym__type] = STATE(3068),
    [sym_constructor_type] = STATE(3068),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1647),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3068),
    [sym_function_type] = STATE(3068),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1648),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3438),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3444),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3446),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2550] = {
    [anon_sym_EQ_GT] = ACTIONS(7046),
    [sym_comment] = ACTIONS(3),
  },
  [2551] = {
    [sym_union_type] = STATE(3363),
    [sym__type] = STATE(3363),
    [sym_constructor_type] = STATE(3363),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1647),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3363),
    [sym_function_type] = STATE(3363),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1648),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3438),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3444),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3446),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2552] = {
    [sym_identifier] = ACTIONS(7048),
    [sym_comment] = ACTIONS(3),
  },
  [2553] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(3397),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(7050),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1573),
  },
  [2554] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1251),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_GT_GT_GT] = ACTIONS(1251),
    [anon_sym_EQ] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1251),
    [anon_sym_COMMA] = ACTIONS(4105),
    [anon_sym_BANG_EQ] = ACTIONS(1257),
    [anon_sym_LT_EQ] = ACTIONS(1251),
    [anon_sym_LPAREN] = ACTIONS(1251),
    [anon_sym_GT_EQ] = ACTIONS(1251),
    [anon_sym_RBRACK] = ACTIONS(1251),
    [anon_sym_GT] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1257),
    [anon_sym_PERCENT] = ACTIONS(1251),
    [anon_sym_QMARK] = ACTIONS(1251),
    [anon_sym_RBRACE] = ACTIONS(1251),
    [anon_sym_as] = ACTIONS(1251),
    [anon_sym_PIPE_PIPE] = ACTIONS(1251),
    [anon_sym_DASH_DASH] = ACTIONS(1251),
    [anon_sym_EQ_EQ] = ACTIONS(1257),
    [anon_sym_instanceof] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1257),
    [anon_sym_RPAREN] = ACTIONS(1251),
    [anon_sym_SLASH] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1251),
    [anon_sym_CARET] = ACTIONS(1251),
    [anon_sym_STAR_STAR] = ACTIONS(1251),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS_PLUS] = ACTIONS(1251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1251),
    [anon_sym_in] = ACTIONS(1257),
  },
  [2555] = {
    [sym__automatic_semicolon] = ACTIONS(7052),
    [anon_sym_SEMI] = ACTIONS(7052),
    [anon_sym_from] = ACTIONS(7052),
    [sym_comment] = ACTIONS(3),
  },
  [2556] = {
    [anon_sym_COMMA] = ACTIONS(7054),
    [anon_sym_RBRACE] = ACTIONS(7054),
    [sym_comment] = ACTIONS(3),
  },
  [2557] = {
    [sym__import_export_specifier] = STATE(2556),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(7056),
    [anon_sym_typeof] = ACTIONS(895),
    [anon_sym_type] = ACTIONS(895),
    [sym_comment] = ACTIONS(3),
  },
  [2558] = {
    [aux_sym_export_clause_repeat1] = STATE(2558),
    [anon_sym_COMMA] = ACTIONS(7058),
    [anon_sym_RBRACE] = ACTIONS(7061),
    [sym_comment] = ACTIONS(3),
  },
  [2559] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1995),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_LT_LT] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_GT_GT_GT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_BANG_EQ] = ACTIONS(3491),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3545),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(3491),
    [anon_sym_instanceof] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3547),
    [anon_sym_STAR_STAR] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3491),
  },
  [2560] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_GT_GT_GT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2561] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(2003),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_LT_LT] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_GT_GT_GT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_BANG_EQ] = ACTIONS(3491),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3545),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(3491),
    [anon_sym_instanceof] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3547),
    [anon_sym_STAR_STAR] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3491),
  },
  [2562] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(2005),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2005),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_LT_LT] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_GT_GT_GT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_BANG_EQ] = ACTIONS(3491),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3545),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(3491),
    [anon_sym_instanceof] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3547),
    [anon_sym_STAR_STAR] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3491),
  },
  [2563] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(2101),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2101),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_LT_LT] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_GT_GT_GT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_BANG_EQ] = ACTIONS(3491),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3545),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(3491),
    [anon_sym_instanceof] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3547),
    [anon_sym_STAR_STAR] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3491),
  },
  [2564] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(2105),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2105),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_LT_LT] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_GT_GT_GT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_BANG_EQ] = ACTIONS(3491),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3545),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(3491),
    [anon_sym_instanceof] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3547),
    [anon_sym_STAR_STAR] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3491),
  },
  [2565] = {
    [sym_new_expression] = STATE(3368),
    [sym_augmented_assignment_expression] = STATE(3368),
    [sym_unary_expression] = STATE(3368),
    [sym_update_expression] = STATE(3368),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(3368),
    [sym_regex] = STATE(3368),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1556),
    [sym__expression] = STATE(3368),
    [sym_non_null_expression] = STATE(3368),
    [sym_yield_expression] = STATE(3368),
    [sym_jsx_fragment] = STATE(3368),
    [sym_jsx_element] = STATE(3368),
    [sym_as_expression] = STATE(3368),
    [sym_internal_module] = STATE(3368),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3368),
    [sym_await_expression] = STATE(3368),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(3368),
    [sym_this] = STATE(3368),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(3368),
    [sym_generator_function] = STATE(3368),
    [sym_call_expression] = STATE(3368),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(3368),
    [sym_ternary_expression] = STATE(3368),
    [sym_binary_expression] = STATE(3368),
    [sym_template_string] = STATE(3368),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3368),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3368),
    [sym_class] = STATE(3368),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(7063),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7063),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7065),
    [sym_true] = ACTIONS(7063),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7063),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [2566] = {
    [sym_new_expression] = STATE(3369),
    [sym_augmented_assignment_expression] = STATE(3369),
    [sym_unary_expression] = STATE(3369),
    [sym_update_expression] = STATE(3369),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(3369),
    [sym_regex] = STATE(3369),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1558),
    [sym__expression] = STATE(3369),
    [sym_non_null_expression] = STATE(3369),
    [sym_yield_expression] = STATE(3369),
    [sym_jsx_fragment] = STATE(3369),
    [sym_jsx_element] = STATE(3369),
    [sym_as_expression] = STATE(3369),
    [sym_internal_module] = STATE(3369),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3369),
    [sym_await_expression] = STATE(3369),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(3369),
    [sym_this] = STATE(3369),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(3369),
    [sym_generator_function] = STATE(3369),
    [sym_call_expression] = STATE(3369),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(3369),
    [sym_ternary_expression] = STATE(3369),
    [sym_binary_expression] = STATE(3369),
    [sym_template_string] = STATE(3369),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3369),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3369),
    [sym_class] = STATE(3369),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(7067),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7067),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7069),
    [sym_true] = ACTIONS(7067),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7067),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [2567] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_GT_GT_GT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_BANG_EQ] = ACTIONS(3491),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(3491),
    [anon_sym_instanceof] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3491),
  },
  [2568] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(7071),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2569] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_GT_GT_GT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(7071),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2570] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_GT_GT_GT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(3491),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(3491),
    [anon_sym_instanceof] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3491),
  },
  [2571] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3630),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7074),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [2572] = {
    [sym_type_arguments] = STATE(1759),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(3696),
    [anon_sym_BANG] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [sym__automatic_semicolon] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(3699),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_GT_GT_GT] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(7076),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_instanceof] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_STAR_STAR] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2204),
    [anon_sym_in] = ACTIONS(3699),
  },
  [2573] = {
    [sym_index_type_query] = STATE(1761),
    [sym_lookup_type] = STATE(1761),
    [sym_flow_maybe_type] = STATE(1761),
    [sym_parenthesized_type] = STATE(1761),
    [sym_nested_type_identifier] = STATE(942),
    [sym_array_type] = STATE(1761),
    [sym_type_predicate] = STATE(1761),
    [sym_type_query] = STATE(1761),
    [sym_existential_type] = STATE(1761),
    [sym_this_type] = STATE(1761),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(1761),
    [sym__primary_type] = STATE(1761),
    [sym_generic_type] = STATE(1761),
    [sym_literal_type] = STATE(1761),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(1761),
    [sym_string] = STATE(927),
    [sym_tuple_type] = STATE(1761),
    [sym_identifier] = ACTIONS(5459),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(5465),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [sym_true] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(3708),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [2574] = {
    [sym_union_type] = STATE(1766),
    [sym__type] = STATE(1766),
    [sym_constructor_type] = STATE(1766),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(2577),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(1766),
    [sym_function_type] = STATE(1766),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(2578),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(5459),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(5465),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(5463),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(5467),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(5461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [2575] = {
    [sym_type_parameters] = STATE(3372),
    [sym_formal_parameters] = STATE(3373),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2576] = {
    [sym_union_type] = STATE(1774),
    [sym__type] = STATE(1774),
    [sym_constructor_type] = STATE(1774),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(2577),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(1774),
    [sym_function_type] = STATE(1774),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(2578),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(5459),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(5465),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(5463),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(5467),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(5461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [2577] = {
    [sym_formal_parameters] = STATE(3376),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2578] = {
    [anon_sym_EQ_GT] = ACTIONS(7078),
    [sym_comment] = ACTIONS(3),
  },
  [2579] = {
    [sym__initializer] = STATE(71),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(3485),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3485),
    [anon_sym_AMP_EQ] = ACTIONS(3485),
    [anon_sym_PLUS_EQ] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(3738),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(3487),
    [anon_sym_GT] = ACTIONS(3738),
    [anon_sym_CARET_EQ] = ACTIONS(3485),
    [anon_sym_STAR_EQ] = ACTIONS(3485),
    [anon_sym_PIPE_EQ] = ACTIONS(3485),
    [anon_sym_DASH_EQ] = ACTIONS(3485),
    [anon_sym_EQ_GT] = ACTIONS(3489),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(3485),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3485),
    [anon_sym_GT_GT_EQ] = ACTIONS(3485),
    [anon_sym_DOT] = ACTIONS(7080),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3485),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3491),
  },
  [2580] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3749),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(2212),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3752),
    [anon_sym_AMP] = ACTIONS(3752),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [2581] = {
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(3493),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3493),
    [anon_sym_AMP_EQ] = ACTIONS(3493),
    [anon_sym_PLUS_EQ] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_CARET_EQ] = ACTIONS(3493),
    [anon_sym_STAR_EQ] = ACTIONS(3493),
    [anon_sym_PIPE_EQ] = ACTIONS(3493),
    [anon_sym_DASH_EQ] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(3493),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3493),
    [anon_sym_GT_GT_EQ] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3493),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2582] = {
    [sym_new_expression] = STATE(1670),
    [sym_augmented_assignment_expression] = STATE(1670),
    [sym_unary_expression] = STATE(1670),
    [sym_update_expression] = STATE(1670),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(1670),
    [sym_regex] = STATE(1670),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1670),
    [sym_non_null_expression] = STATE(1670),
    [sym_as_expression] = STATE(1670),
    [sym_jsx_fragment] = STATE(1670),
    [sym_yield_expression] = STATE(1670),
    [sym_jsx_element] = STATE(1670),
    [sym_internal_module] = STATE(1670),
    [sym_nested_identifier] = STATE(1092),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1670),
    [sym_await_expression] = STATE(1670),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(1670),
    [sym_this] = STATE(1670),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(1670),
    [sym_generator_function] = STATE(1670),
    [sym_call_expression] = STATE(1670),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(1670),
    [sym_ternary_expression] = STATE(1670),
    [sym_binary_expression] = STATE(1670),
    [sym_template_string] = STATE(1670),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1670),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(1670),
    [sym_class] = STATE(1670),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(7082),
    [sym_false] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3497),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3499),
    [sym_true] = ACTIONS(3497),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3497),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [2583] = {
    [sym_new_expression] = STATE(1671),
    [sym_augmented_assignment_expression] = STATE(1671),
    [sym_unary_expression] = STATE(1671),
    [sym_update_expression] = STATE(1671),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(1671),
    [sym_regex] = STATE(1671),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1671),
    [sym_non_null_expression] = STATE(1671),
    [sym_as_expression] = STATE(1671),
    [sym_jsx_fragment] = STATE(1671),
    [sym_yield_expression] = STATE(1671),
    [sym_jsx_element] = STATE(1671),
    [sym_internal_module] = STATE(1671),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1671),
    [sym_await_expression] = STATE(1671),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(1671),
    [sym_this] = STATE(1671),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(1671),
    [sym_generator_function] = STATE(1671),
    [sym_call_expression] = STATE(1671),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(1671),
    [sym_ternary_expression] = STATE(1671),
    [sym_binary_expression] = STATE(1671),
    [sym_template_string] = STATE(1671),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1671),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(1671),
    [sym_class] = STATE(1671),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3501),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3781),
    [sym_true] = ACTIONS(3501),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3501),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [2584] = {
    [aux_sym_export_statement_repeat1] = STATE(1806),
    [sym__property_name] = STATE(1807),
    [sym_object] = STATE(384),
    [sym_assignment_pattern] = STATE(222),
    [sym_pair] = STATE(222),
    [sym_method_signature] = STATE(1079),
    [sym_call_signature] = STATE(1079),
    [sym_type_parameters] = STATE(1082),
    [sym_index_signature] = STATE(1079),
    [sym_export_statement] = STATE(1079),
    [sym_method_definition] = STATE(222),
    [aux_sym_object_repeat1] = STATE(220),
    [sym_property_signature] = STATE(1079),
    [sym_decorator] = STATE(1806),
    [sym_construct_signature] = STATE(1079),
    [sym_accessibility_modifier] = STATE(1808),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1807),
    [sym_array] = STATE(385),
    [sym_spread_element] = STATE(222),
    [sym_string] = STATE(1807),
    [sym_identifier] = ACTIONS(3783),
    [anon_sym_LBRACK] = ACTIONS(3785),
    [anon_sym_SEMI] = ACTIONS(2218),
    [anon_sym_module] = ACTIONS(3787),
    [anon_sym_symbol] = ACTIONS(3787),
    [anon_sym_number] = ACTIONS(3787),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(3787),
    [anon_sym_COMMA] = ACTIONS(3789),
    [anon_sym_STAR] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_void] = ACTIONS(3787),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(3787),
    [anon_sym_private] = ACTIONS(3793),
    [anon_sym_boolean] = ACTIONS(3787),
    [anon_sym_static] = ACTIONS(3795),
    [anon_sym_async] = ACTIONS(3797),
    [anon_sym_get] = ACTIONS(3799),
    [anon_sym_RBRACE] = ACTIONS(7084),
    [anon_sym_public] = ACTIONS(3793),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(3801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3793),
    [anon_sym_string] = ACTIONS(3787),
    [anon_sym_set] = ACTIONS(3799),
    [anon_sym_type] = ACTIONS(3787),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(3787),
    [anon_sym_export] = ACTIONS(3803),
    [sym_readonly] = ACTIONS(3805),
    [anon_sym_namespace] = ACTIONS(3787),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [2585] = {
    [sym_new_expression] = STATE(1670),
    [sym_augmented_assignment_expression] = STATE(1670),
    [sym__initializer] = STATE(79),
    [sym_unary_expression] = STATE(1670),
    [sym_update_expression] = STATE(1670),
    [sym_regex] = STATE(1670),
    [sym_meta_property] = STATE(1670),
    [sym_call_signature] = STATE(866),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1670),
    [sym_non_null_expression] = STATE(1670),
    [sym_yield_expression] = STATE(1670),
    [sym_jsx_fragment] = STATE(1670),
    [sym_jsx_element] = STATE(1670),
    [sym_as_expression] = STATE(1670),
    [sym_internal_module] = STATE(1670),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(1670),
    [sym_await_expression] = STATE(1670),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(1670),
    [sym_this] = STATE(1670),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(1670),
    [sym_generator_function] = STATE(1670),
    [sym_call_expression] = STATE(1670),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(1670),
    [sym_ternary_expression] = STATE(1670),
    [sym_binary_expression] = STATE(1670),
    [sym_template_string] = STATE(1670),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1670),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(1670),
    [sym_class] = STATE(1670),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1605),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(3493),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_AMP_EQ] = ACTIONS(3493),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(3493),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(3487),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(3493),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_PIPE_EQ] = ACTIONS(3493),
    [anon_sym_DASH_EQ] = ACTIONS(3493),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(3493),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(1623),
    [sym_true] = ACTIONS(3497),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_GT_GT_EQ] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3493),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(3497),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3493),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3497),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_STAR_EQ] = ACTIONS(3493),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_EQ_GT] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(3499),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3493),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(3497),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2586] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_SEMI] = ACTIONS(207),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym__automatic_semicolon] = ACTIONS(207),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_LT_LT] = ACTIONS(207),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_GT_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_BANG_EQ] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(207),
    [anon_sym_GT_EQ] = ACTIONS(207),
    [anon_sym_GT] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(207),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_DASH_DASH] = ACTIONS(207),
    [anon_sym_EQ_EQ] = ACTIONS(209),
    [anon_sym_instanceof] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(207),
    [anon_sym_CARET] = ACTIONS(207),
    [anon_sym_STAR_STAR] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_GT_GT] = ACTIONS(209),
    [anon_sym_PLUS_PLUS] = ACTIONS(207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(209),
  },
  [2587] = {
    [sym_new_expression] = STATE(277),
    [sym_augmented_assignment_expression] = STATE(289),
    [sym_unary_expression] = STATE(289),
    [sym_update_expression] = STATE(289),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(277),
    [sym_regex] = STATE(277),
    [sym_type_parameters] = STATE(1819),
    [sym__expression] = STATE(289),
    [sym_non_null_expression] = STATE(289),
    [sym_as_expression] = STATE(289),
    [sym_jsx_fragment] = STATE(289),
    [sym_yield_expression] = STATE(289),
    [sym_jsx_element] = STATE(289),
    [sym_internal_module] = STATE(289),
    [sym_function] = STATE(290),
    [sym_arrow_function] = STATE(277),
    [sym_await_expression] = STATE(289),
    [sym_member_expression] = STATE(291),
    [sym_string] = STATE(277),
    [sym_this] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(292),
    [sym_anonymous_class] = STATE(277),
    [sym_generator_function] = STATE(277),
    [sym_call_expression] = STATE(289),
    [sym_subscript_expression] = STATE(291),
    [sym_assignment_expression] = STATE(289),
    [sym_ternary_expression] = STATE(289),
    [sym_binary_expression] = STATE(289),
    [sym_template_string] = STATE(277),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(1820),
    [sym_parenthesized_expression] = STATE(277),
    [sym_array] = STATE(293),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(289),
    [sym_class] = STATE(277),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(3517),
    [sym_false] = ACTIONS(482),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(3519),
    [anon_sym_symbol] = ACTIONS(3519),
    [anon_sym_number] = ACTIONS(3519),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3519),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(482),
    [sym_super] = ACTIONS(494),
    [anon_sym_any] = ACTIONS(3519),
    [anon_sym_private] = ACTIONS(3519),
    [anon_sym_boolean] = ACTIONS(3519),
    [anon_sym_async] = ACTIONS(3523),
    [anon_sym_public] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3519),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(498),
    [sym_true] = ACTIONS(482),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(3519),
    [anon_sym_string] = ACTIONS(3519),
    [anon_sym_function] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(502),
    [sym_undefined] = ACTIONS(482),
    [anon_sym_set] = ACTIONS(3519),
    [anon_sym_type] = ACTIONS(3519),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(3519),
    [anon_sym_export] = ACTIONS(3519),
    [anon_sym_namespace] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [2588] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(7071),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2589] = {
    [sym_identifier] = ACTIONS(7086),
    [anon_sym_BQUOTE] = ACTIONS(7088),
    [anon_sym_debugger] = ACTIONS(7086),
    [anon_sym_symbol] = ACTIONS(7086),
    [anon_sym_AT] = ACTIONS(7088),
    [anon_sym_DASH] = ACTIONS(7086),
    [anon_sym_void] = ACTIONS(7086),
    [anon_sym_break] = ACTIONS(7086),
    [anon_sym_const] = ACTIONS(7086),
    [sym_super] = ACTIONS(7086),
    [anon_sym_return] = ACTIONS(7086),
    [anon_sym_private] = ACTIONS(7086),
    [anon_sym_get] = ACTIONS(7086),
    [anon_sym_RBRACE] = ACTIONS(7088),
    [anon_sym_interface] = ACTIONS(7086),
    [anon_sym_default] = ACTIONS(7086),
    [anon_sym_enum] = ACTIONS(7086),
    [anon_sym_delete] = ACTIONS(7086),
    [anon_sym_continue] = ACTIONS(7086),
    [anon_sym_DASH_DASH] = ACTIONS(7088),
    [anon_sym_if] = ACTIONS(7086),
    [anon_sym_this] = ACTIONS(7086),
    [anon_sym_yield] = ACTIONS(7086),
    [sym_true] = ACTIONS(7086),
    [anon_sym_throw] = ACTIONS(7086),
    [anon_sym_protected] = ACTIONS(7086),
    [anon_sym_abstract] = ACTIONS(7086),
    [anon_sym_set] = ACTIONS(7086),
    [anon_sym_type] = ACTIONS(7086),
    [anon_sym_import] = ACTIONS(7086),
    [anon_sym_namespace] = ACTIONS(7086),
    [anon_sym_PLUS_PLUS] = ACTIONS(7088),
    [anon_sym_await] = ACTIONS(7086),
    [anon_sym_DQUOTE] = ACTIONS(7088),
    [anon_sym_else] = ACTIONS(7086),
    [anon_sym_BANG] = ACTIONS(7088),
    [anon_sym_for] = ACTIONS(7086),
    [anon_sym_LBRACK] = ACTIONS(7088),
    [sym_false] = ACTIONS(7086),
    [anon_sym_SEMI] = ACTIONS(7088),
    [anon_sym_case] = ACTIONS(7086),
    [anon_sym_module] = ACTIONS(7086),
    [anon_sym_number] = ACTIONS(7086),
    [anon_sym_class] = ACTIONS(7086),
    [anon_sym_declare] = ACTIONS(7086),
    [anon_sym_typeof] = ACTIONS(7086),
    [anon_sym_LBRACE] = ACTIONS(7088),
    [anon_sym_switch] = ACTIONS(7086),
    [anon_sym_LPAREN] = ACTIONS(7088),
    [sym_null] = ACTIONS(7086),
    [anon_sym_any] = ACTIONS(7086),
    [anon_sym_boolean] = ACTIONS(7086),
    [anon_sym_async] = ACTIONS(7086),
    [anon_sym_public] = ACTIONS(7086),
    [anon_sym_var] = ACTIONS(7086),
    [anon_sym_while] = ACTIONS(7086),
    [anon_sym_SQUOTE] = ACTIONS(7088),
    [anon_sym_try] = ACTIONS(7086),
    [anon_sym_LT] = ACTIONS(7088),
    [sym_number] = ACTIONS(7088),
    [anon_sym_SLASH] = ACTIONS(7086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7086),
    [anon_sym_function] = ACTIONS(7086),
    [sym_undefined] = ACTIONS(7086),
    [anon_sym_new] = ACTIONS(7086),
    [ts_builtin_sym_end] = ACTIONS(7088),
    [anon_sym_let] = ACTIONS(7086),
    [anon_sym_PLUS] = ACTIONS(7086),
    [anon_sym_export] = ACTIONS(7086),
    [anon_sym_do] = ACTIONS(7086),
    [anon_sym_TILDE] = ACTIONS(7088),
    [anon_sym_with] = ACTIONS(7086),
  },
  [2590] = {
    [sym_type_alias_declaration] = STATE(348),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(348),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(348),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(348),
    [sym_return_statement] = STATE(348),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(348),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(348),
    [sym_switch_statement] = STATE(348),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(348),
    [sym_throw_statement] = STATE(348),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(348),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(348),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(348),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(348),
    [sym_abstract_class] = STATE(348),
    [sym_interface_declaration] = STATE(348),
    [sym_statement_block] = STATE(348),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(348),
    [sym_debugger_statement] = STATE(348),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(348),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(348),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(348),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(348),
    [sym_empty_statement] = STATE(348),
    [sym_import_alias] = STATE(348),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(348),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(348),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(348),
    [sym_break_statement] = STATE(348),
    [sym_labeled_statement] = STATE(348),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(348),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [2591] = {
    [sym_type_alias_declaration] = STATE(3381),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3381),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3381),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3381),
    [sym_return_statement] = STATE(3381),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3381),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3381),
    [sym_switch_statement] = STATE(3381),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3381),
    [sym_throw_statement] = STATE(3381),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3381),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3381),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(3381),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3381),
    [sym_abstract_class] = STATE(3381),
    [sym_interface_declaration] = STATE(3381),
    [sym_statement_block] = STATE(3381),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3381),
    [sym_debugger_statement] = STATE(3381),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3381),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3381),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3381),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3381),
    [sym_empty_statement] = STATE(3381),
    [sym_import_alias] = STATE(3381),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3381),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3381),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3381),
    [sym_break_statement] = STATE(3381),
    [sym_labeled_statement] = STATE(3381),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3381),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [2592] = {
    [anon_sym_LPAREN] = ACTIONS(7090),
    [sym_comment] = ACTIONS(3),
  },
  [2593] = {
    [sym_new_expression] = STATE(59),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_yield_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_internal_module] = STATE(59),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(59),
    [sym_await_expression] = STATE(59),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3386),
    [sym_variable_declaration] = STATE(3386),
    [sym_sequence_expression] = STATE(62),
    [sym_string] = STATE(59),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(3386),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(3387),
    [sym_anonymous_class] = STATE(59),
    [sym_generator_function] = STATE(59),
    [sym_call_expression] = STATE(59),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(59),
    [sym_ternary_expression] = STATE(59),
    [sym_binary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_lexical_declaration] = STATE(3386),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(3388),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_identifier] = ACTIONS(7092),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(7094),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(7096),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(7094),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(15),
  },
  [2594] = {
    [sym_string] = STATE(173),
    [sym_nested_identifier] = STATE(169),
    [sym__module] = STATE(172),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(7098),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(282),
  },
  [2595] = {
    [sym_type_alias_declaration] = STATE(193),
    [aux_sym_export_statement_repeat1] = STATE(2597),
    [sym__declaration] = STATE(193),
    [sym_ambient_declaration] = STATE(193),
    [sym_import_alias] = STATE(193),
    [sym_export_statement] = STATE(193),
    [sym_generator_function] = STATE(193),
    [sym_lexical_declaration] = STATE(193),
    [sym_internal_module] = STATE(193),
    [sym_decorator] = STATE(2597),
    [sym_enum_declaration] = STATE(193),
    [sym_function] = STATE(193),
    [sym_function_signature] = STATE(193),
    [sym_variable_declaration] = STATE(193),
    [sym_abstract_class] = STATE(193),
    [sym_module] = STATE(193),
    [sym_interface_declaration] = STATE(193),
    [sym_class] = STATE(193),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(5501),
    [anon_sym_class] = ACTIONS(1653),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(5503),
    [anon_sym_global] = ACTIONS(324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(1659),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(1647),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(5505),
    [anon_sym_namespace] = ACTIONS(1649),
    [anon_sym_async] = ACTIONS(1657),
  },
  [2596] = {
    [sym_type_alias_declaration] = STATE(300),
    [aux_sym_export_statement_repeat1] = STATE(2597),
    [sym__declaration] = STATE(300),
    [sym_ambient_declaration] = STATE(300),
    [sym_import_alias] = STATE(300),
    [sym_export_statement] = STATE(300),
    [sym_generator_function] = STATE(300),
    [sym_export_clause] = STATE(301),
    [sym_lexical_declaration] = STATE(300),
    [sym_internal_module] = STATE(300),
    [sym_decorator] = STATE(2597),
    [sym_enum_declaration] = STATE(300),
    [sym_function] = STATE(300),
    [sym_function_signature] = STATE(300),
    [sym_variable_declaration] = STATE(300),
    [sym_abstract_class] = STATE(300),
    [sym_module] = STATE(300),
    [sym_interface_declaration] = STATE(300),
    [sym_class] = STATE(300),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(1663),
    [anon_sym_as] = ACTIONS(1183),
    [anon_sym_class] = ACTIONS(1653),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(5503),
    [anon_sym_STAR] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_EQ] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(1659),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(1647),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(5505),
    [anon_sym_namespace] = ACTIONS(1649),
    [anon_sym_async] = ACTIONS(1657),
  },
  [2597] = {
    [aux_sym_export_statement_repeat1] = STATE(320),
    [sym_decorator] = STATE(320),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(5509),
    [anon_sym_class] = ACTIONS(3595),
    [sym_comment] = ACTIONS(3),
  },
  [2598] = {
    [sym_type_alias_declaration] = STATE(787),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(787),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(787),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(787),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(787),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(787),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(787),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(787),
    [sym_abstract_class] = STATE(787),
    [sym_interface_declaration] = STATE(787),
    [sym_statement_block] = STATE(787),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(787),
    [sym_debugger_statement] = STATE(787),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(787),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(787),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(787),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(787),
    [sym_empty_statement] = STATE(787),
    [sym_import_alias] = STATE(787),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(787),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(787),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_labeled_statement] = STATE(787),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(787),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [2599] = {
    [sym_type_alias_declaration] = STATE(891),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(891),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(891),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(891),
    [sym_return_statement] = STATE(891),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(891),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(891),
    [sym_switch_statement] = STATE(891),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(891),
    [sym_throw_statement] = STATE(891),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(891),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(891),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(891),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(891),
    [sym_abstract_class] = STATE(891),
    [sym_interface_declaration] = STATE(891),
    [sym_statement_block] = STATE(891),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(891),
    [sym_debugger_statement] = STATE(891),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(891),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(891),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(891),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(891),
    [sym_empty_statement] = STATE(891),
    [sym_import_alias] = STATE(891),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(891),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(891),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(891),
    [sym_break_statement] = STATE(891),
    [sym_labeled_statement] = STATE(891),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(891),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [2600] = {
    [sym_type_alias_declaration] = STATE(2092),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(2092),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(2092),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(2092),
    [sym_return_statement] = STATE(2092),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(2092),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2092),
    [sym_switch_statement] = STATE(2092),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(2092),
    [sym_throw_statement] = STATE(2092),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(2092),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(2092),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(2092),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(2092),
    [sym_abstract_class] = STATE(2092),
    [sym_interface_declaration] = STATE(2092),
    [sym_statement_block] = STATE(2092),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(2092),
    [sym_debugger_statement] = STATE(2092),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(2092),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(2092),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(2092),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(2092),
    [sym_empty_statement] = STATE(2092),
    [sym_import_alias] = STATE(2092),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(2092),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(2092),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(2092),
    [sym_break_statement] = STATE(2092),
    [sym_labeled_statement] = STATE(2092),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(2092),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [2601] = {
    [sym_type_alias_declaration] = STATE(872),
    [aux_sym_export_statement_repeat1] = STATE(2597),
    [sym__declaration] = STATE(872),
    [sym_ambient_declaration] = STATE(872),
    [sym_import_alias] = STATE(872),
    [sym_export_statement] = STATE(872),
    [sym_generator_function] = STATE(872),
    [sym_lexical_declaration] = STATE(872),
    [sym_internal_module] = STATE(872),
    [sym_decorator] = STATE(2597),
    [sym_enum_declaration] = STATE(872),
    [sym_function] = STATE(872),
    [sym_function_signature] = STATE(872),
    [sym_variable_declaration] = STATE(872),
    [sym_abstract_class] = STATE(872),
    [sym_module] = STATE(872),
    [sym_interface_declaration] = STATE(872),
    [sym_class] = STATE(872),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_default] = ACTIONS(1826),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(1663),
    [anon_sym_class] = ACTIONS(1653),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(5503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(1659),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(1647),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(5505),
    [anon_sym_namespace] = ACTIONS(1649),
    [anon_sym_async] = ACTIONS(1657),
  },
  [2602] = {
    [sym_class_body] = STATE(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(959),
  },
  [2603] = {
    [sym_class_heritage] = STATE(3390),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(2095),
    [anon_sym_extends] = ACTIONS(1131),
    [anon_sym_implements] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(959),
  },
  [2604] = {
    [sym_array] = STATE(3392),
    [sym_object] = STATE(3393),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(7100),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [2605] = {
    [anon_sym_of] = ACTIONS(7102),
    [sym_comment] = ACTIONS(3),
  },
  [2606] = {
    [anon_sym_of] = ACTIONS(7104),
    [sym_comment] = ACTIONS(3),
  },
  [2607] = {
    [anon_sym_of] = ACTIONS(7106),
    [sym_comment] = ACTIONS(3),
  },
  [2608] = {
    [sym_new_expression] = STATE(3397),
    [sym_augmented_assignment_expression] = STATE(3397),
    [sym_unary_expression] = STATE(3397),
    [sym_update_expression] = STATE(3397),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3397),
    [sym_regex] = STATE(3397),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3397),
    [sym_non_null_expression] = STATE(3397),
    [sym_as_expression] = STATE(3397),
    [sym_jsx_fragment] = STATE(3397),
    [sym_yield_expression] = STATE(3397),
    [sym_jsx_element] = STATE(3397),
    [sym_internal_module] = STATE(3397),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3397),
    [sym_await_expression] = STATE(3397),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(3398),
    [sym_string] = STATE(3397),
    [sym_this] = STATE(3397),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(3397),
    [sym_generator_function] = STATE(3397),
    [sym_call_expression] = STATE(3397),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(3397),
    [sym_ternary_expression] = STATE(3397),
    [sym_binary_expression] = STATE(3397),
    [sym_template_string] = STATE(3397),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3397),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3397),
    [sym_class] = STATE(3397),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(7108),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7108),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7110),
    [sym_true] = ACTIONS(7108),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7108),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [2609] = {
    [sym_new_expression] = STATE(3399),
    [sym_augmented_assignment_expression] = STATE(3399),
    [sym_unary_expression] = STATE(3399),
    [sym_update_expression] = STATE(3399),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3399),
    [sym_regex] = STATE(3399),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3399),
    [sym_non_null_expression] = STATE(3399),
    [sym_as_expression] = STATE(3399),
    [sym_jsx_fragment] = STATE(3399),
    [sym_yield_expression] = STATE(3399),
    [sym_jsx_element] = STATE(3399),
    [sym_internal_module] = STATE(3399),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3399),
    [sym_await_expression] = STATE(3399),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3399),
    [sym_this] = STATE(3399),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3399),
    [sym_generator_function] = STATE(3399),
    [sym_call_expression] = STATE(3399),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3399),
    [sym_ternary_expression] = STATE(3399),
    [sym_binary_expression] = STATE(3399),
    [sym_template_string] = STATE(3399),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3399),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3399),
    [sym_class] = STATE(3399),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(7112),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7112),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7114),
    [sym_true] = ACTIONS(7112),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7112),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [2610] = {
    [sym__initializer] = STATE(391),
    [sym_type_annotation] = STATE(392),
    [sym__automatic_semicolon] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(715),
    [anon_sym_of] = ACTIONS(7102),
    [anon_sym_COMMA] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(7116),
  },
  [2611] = {
    [sym__initializer] = STATE(411),
    [sym_type_annotation] = STATE(412),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(745),
    [anon_sym_of] = ACTIONS(7104),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(7118),
  },
  [2612] = {
    [sym__initializer] = STATE(413),
    [sym_type_annotation] = STATE(414),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(745),
    [anon_sym_of] = ACTIONS(7106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(7120),
  },
  [2613] = {
    [sym_new_expression] = STATE(3404),
    [sym_augmented_assignment_expression] = STATE(3404),
    [sym_unary_expression] = STATE(3404),
    [sym_update_expression] = STATE(3404),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(3404),
    [sym_regex] = STATE(3404),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3404),
    [sym_non_null_expression] = STATE(3404),
    [sym_as_expression] = STATE(3404),
    [sym_jsx_fragment] = STATE(3404),
    [sym_yield_expression] = STATE(3404),
    [sym_jsx_element] = STATE(3404),
    [sym_internal_module] = STATE(3404),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3404),
    [sym_await_expression] = STATE(3404),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(3405),
    [sym_string] = STATE(3404),
    [sym_this] = STATE(3404),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(3404),
    [sym_generator_function] = STATE(3404),
    [sym_call_expression] = STATE(3404),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(3404),
    [sym_ternary_expression] = STATE(3404),
    [sym_binary_expression] = STATE(3404),
    [sym_template_string] = STATE(3404),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3404),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3404),
    [sym_class] = STATE(3404),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(7122),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7122),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_RPAREN] = ACTIONS(7124),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7126),
    [sym_true] = ACTIONS(7122),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7122),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [2614] = {
    [sym_new_expression] = STATE(3406),
    [sym_augmented_assignment_expression] = STATE(3406),
    [sym_unary_expression] = STATE(3406),
    [sym_update_expression] = STATE(3406),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3406),
    [sym_regex] = STATE(3406),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3406),
    [sym_non_null_expression] = STATE(3406),
    [sym_as_expression] = STATE(3406),
    [sym_jsx_fragment] = STATE(3406),
    [sym_yield_expression] = STATE(3406),
    [sym_jsx_element] = STATE(3406),
    [sym_internal_module] = STATE(3406),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3406),
    [sym_await_expression] = STATE(3406),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3406),
    [sym_this] = STATE(3406),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3406),
    [sym_generator_function] = STATE(3406),
    [sym_call_expression] = STATE(3406),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3406),
    [sym_ternary_expression] = STATE(3406),
    [sym_binary_expression] = STATE(3406),
    [sym_template_string] = STATE(3406),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3406),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3406),
    [sym_class] = STATE(3406),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(7128),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7128),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7130),
    [sym_true] = ACTIONS(7128),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7128),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [2615] = {
    [sym_new_expression] = STATE(3407),
    [sym_augmented_assignment_expression] = STATE(3407),
    [sym_unary_expression] = STATE(3407),
    [sym_update_expression] = STATE(3407),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3407),
    [sym_regex] = STATE(3407),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3407),
    [sym_non_null_expression] = STATE(3407),
    [sym_as_expression] = STATE(3407),
    [sym_jsx_fragment] = STATE(3407),
    [sym_yield_expression] = STATE(3407),
    [sym_jsx_element] = STATE(3407),
    [sym_internal_module] = STATE(3407),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3407),
    [sym_await_expression] = STATE(3407),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(3408),
    [sym_string] = STATE(3407),
    [sym_this] = STATE(3407),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(3407),
    [sym_generator_function] = STATE(3407),
    [sym_call_expression] = STATE(3407),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(3407),
    [sym_ternary_expression] = STATE(3407),
    [sym_binary_expression] = STATE(3407),
    [sym_template_string] = STATE(3407),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3407),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3407),
    [sym_class] = STATE(3407),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(7132),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7132),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7134),
    [sym_true] = ACTIONS(7132),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7132),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [2616] = {
    [sym_new_expression] = STATE(3409),
    [sym_augmented_assignment_expression] = STATE(3409),
    [sym_unary_expression] = STATE(3409),
    [sym_update_expression] = STATE(3409),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3409),
    [sym_regex] = STATE(3409),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3409),
    [sym_non_null_expression] = STATE(3409),
    [sym_as_expression] = STATE(3409),
    [sym_jsx_fragment] = STATE(3409),
    [sym_yield_expression] = STATE(3409),
    [sym_jsx_element] = STATE(3409),
    [sym_internal_module] = STATE(3409),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3409),
    [sym_await_expression] = STATE(3409),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3409),
    [sym_this] = STATE(3409),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3409),
    [sym_generator_function] = STATE(3409),
    [sym_call_expression] = STATE(3409),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3409),
    [sym_ternary_expression] = STATE(3409),
    [sym_binary_expression] = STATE(3409),
    [sym_template_string] = STATE(3409),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3409),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3409),
    [sym_class] = STATE(3409),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(7136),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7136),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7138),
    [sym_true] = ACTIONS(7136),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7136),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [2617] = {
    [sym_new_expression] = STATE(3410),
    [sym_augmented_assignment_expression] = STATE(3410),
    [sym_unary_expression] = STATE(3410),
    [sym_update_expression] = STATE(3410),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3410),
    [sym_regex] = STATE(3410),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3410),
    [sym_non_null_expression] = STATE(3410),
    [sym_as_expression] = STATE(3410),
    [sym_jsx_fragment] = STATE(3410),
    [sym_yield_expression] = STATE(3410),
    [sym_jsx_element] = STATE(3410),
    [sym_internal_module] = STATE(3410),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3410),
    [sym_await_expression] = STATE(3410),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(3411),
    [sym_string] = STATE(3410),
    [sym_this] = STATE(3410),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(3410),
    [sym_generator_function] = STATE(3410),
    [sym_call_expression] = STATE(3410),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(3410),
    [sym_ternary_expression] = STATE(3410),
    [sym_binary_expression] = STATE(3410),
    [sym_template_string] = STATE(3410),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3410),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3410),
    [sym_class] = STATE(3410),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(7140),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7140),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7142),
    [sym_true] = ACTIONS(7140),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7140),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [2618] = {
    [anon_sym_COLON] = ACTIONS(7144),
    [sym_comment] = ACTIONS(3),
  },
  [2619] = {
    [sym_type_parameters] = STATE(815),
    [sym_formal_parameters] = STATE(816),
    [sym_call_signature] = STATE(3413),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2620] = {
    [sym_statement_block] = STATE(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [2621] = {
    [sym_statement_block] = STATE(2190),
    [sym__automatic_semicolon] = ACTIONS(3365),
    [anon_sym_SEMI] = ACTIONS(3365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [2622] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(3414),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2623] = {
    [sym_statement_block] = STATE(2197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [2624] = {
    [sym_identifier] = ACTIONS(7146),
    [anon_sym_BQUOTE] = ACTIONS(7148),
    [anon_sym_debugger] = ACTIONS(7146),
    [anon_sym_symbol] = ACTIONS(7146),
    [anon_sym_AT] = ACTIONS(7148),
    [anon_sym_DASH] = ACTIONS(7146),
    [anon_sym_void] = ACTIONS(7146),
    [anon_sym_break] = ACTIONS(7146),
    [anon_sym_const] = ACTIONS(7146),
    [sym_super] = ACTIONS(7146),
    [anon_sym_return] = ACTIONS(7146),
    [anon_sym_private] = ACTIONS(7146),
    [anon_sym_get] = ACTIONS(7146),
    [anon_sym_RBRACE] = ACTIONS(7148),
    [anon_sym_interface] = ACTIONS(7146),
    [anon_sym_default] = ACTIONS(7146),
    [anon_sym_enum] = ACTIONS(7146),
    [anon_sym_delete] = ACTIONS(7146),
    [anon_sym_continue] = ACTIONS(7146),
    [anon_sym_DASH_DASH] = ACTIONS(7148),
    [anon_sym_if] = ACTIONS(7146),
    [anon_sym_this] = ACTIONS(7146),
    [anon_sym_yield] = ACTIONS(7146),
    [sym_true] = ACTIONS(7146),
    [anon_sym_throw] = ACTIONS(7146),
    [anon_sym_protected] = ACTIONS(7146),
    [anon_sym_abstract] = ACTIONS(7146),
    [anon_sym_set] = ACTIONS(7146),
    [anon_sym_type] = ACTIONS(7146),
    [anon_sym_import] = ACTIONS(7146),
    [anon_sym_namespace] = ACTIONS(7146),
    [anon_sym_PLUS_PLUS] = ACTIONS(7148),
    [anon_sym_await] = ACTIONS(7146),
    [anon_sym_DQUOTE] = ACTIONS(7148),
    [anon_sym_else] = ACTIONS(7146),
    [anon_sym_BANG] = ACTIONS(7148),
    [anon_sym_for] = ACTIONS(7146),
    [anon_sym_LBRACK] = ACTIONS(7148),
    [sym_false] = ACTIONS(7146),
    [anon_sym_SEMI] = ACTIONS(7148),
    [anon_sym_case] = ACTIONS(7146),
    [anon_sym_module] = ACTIONS(7146),
    [anon_sym_number] = ACTIONS(7146),
    [anon_sym_class] = ACTIONS(7146),
    [anon_sym_declare] = ACTIONS(7146),
    [anon_sym_typeof] = ACTIONS(7146),
    [anon_sym_LBRACE] = ACTIONS(7148),
    [anon_sym_switch] = ACTIONS(7146),
    [anon_sym_LPAREN] = ACTIONS(7148),
    [sym_null] = ACTIONS(7146),
    [anon_sym_any] = ACTIONS(7146),
    [anon_sym_boolean] = ACTIONS(7146),
    [anon_sym_async] = ACTIONS(7146),
    [anon_sym_public] = ACTIONS(7146),
    [anon_sym_var] = ACTIONS(7146),
    [anon_sym_while] = ACTIONS(7146),
    [anon_sym_SQUOTE] = ACTIONS(7148),
    [anon_sym_try] = ACTIONS(7146),
    [anon_sym_LT] = ACTIONS(7148),
    [sym_number] = ACTIONS(7148),
    [anon_sym_SLASH] = ACTIONS(7146),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7146),
    [anon_sym_function] = ACTIONS(7146),
    [sym_undefined] = ACTIONS(7146),
    [anon_sym_new] = ACTIONS(7146),
    [ts_builtin_sym_end] = ACTIONS(7148),
    [anon_sym_let] = ACTIONS(7146),
    [anon_sym_PLUS] = ACTIONS(7146),
    [anon_sym_export] = ACTIONS(7146),
    [anon_sym_do] = ACTIONS(7146),
    [anon_sym_TILDE] = ACTIONS(7148),
    [anon_sym_with] = ACTIONS(7146),
  },
  [2625] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7150),
    [sym_identifier] = ACTIONS(7152),
    [sym__automatic_semicolon] = ACTIONS(7150),
    [anon_sym_BQUOTE] = ACTIONS(7150),
    [anon_sym_debugger] = ACTIONS(7152),
    [ts_builtin_sym_end] = ACTIONS(7150),
    [anon_sym_symbol] = ACTIONS(7152),
    [anon_sym_AT] = ACTIONS(7150),
    [anon_sym_PIPE] = ACTIONS(7152),
    [anon_sym_COMMA] = ACTIONS(7150),
    [anon_sym_DASH] = ACTIONS(7152),
    [anon_sym_STAR] = ACTIONS(7152),
    [anon_sym_GT_GT_GT] = ACTIONS(7150),
    [anon_sym_void] = ACTIONS(7152),
    [anon_sym_break] = ACTIONS(7152),
    [anon_sym_BANG_EQ] = ACTIONS(7152),
    [anon_sym_const] = ACTIONS(7152),
    [anon_sym_GT_EQ] = ACTIONS(7150),
    [sym_super] = ACTIONS(7152),
    [anon_sym_return] = ACTIONS(7152),
    [anon_sym_private] = ACTIONS(7152),
    [anon_sym_get] = ACTIONS(7152),
    [anon_sym_RBRACE] = ACTIONS(7150),
    [anon_sym_PERCENT] = ACTIONS(7150),
    [anon_sym_interface] = ACTIONS(7152),
    [anon_sym_default] = ACTIONS(7152),
    [anon_sym_as] = ACTIONS(7152),
    [anon_sym_delete] = ACTIONS(7152),
    [anon_sym_continue] = ACTIONS(7152),
    [anon_sym_DASH_DASH] = ACTIONS(7150),
    [anon_sym_if] = ACTIONS(7152),
    [anon_sym_instanceof] = ACTIONS(7152),
    [anon_sym_this] = ACTIONS(7152),
    [anon_sym_yield] = ACTIONS(7152),
    [sym_true] = ACTIONS(7152),
    [anon_sym_throw] = ACTIONS(7152),
    [anon_sym_enum] = ACTIONS(7152),
    [anon_sym_protected] = ACTIONS(7152),
    [anon_sym_abstract] = ACTIONS(7152),
    [anon_sym_DOT] = ACTIONS(7152),
    [anon_sym_set] = ACTIONS(7152),
    [anon_sym_type] = ACTIONS(7152),
    [anon_sym_STAR_STAR] = ACTIONS(7150),
    [anon_sym_import] = ACTIONS(7152),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7150),
    [anon_sym_namespace] = ACTIONS(7152),
    [anon_sym_PLUS_PLUS] = ACTIONS(7150),
    [anon_sym_await] = ACTIONS(7152),
    [anon_sym_DQUOTE] = ACTIONS(7150),
    [anon_sym_else] = ACTIONS(7152),
    [anon_sym_BANG] = ACTIONS(7152),
    [anon_sym_for] = ACTIONS(7152),
    [anon_sym_LBRACK] = ACTIONS(7150),
    [sym_false] = ACTIONS(7152),
    [anon_sym_SEMI] = ACTIONS(7150),
    [anon_sym_case] = ACTIONS(7152),
    [anon_sym_module] = ACTIONS(7152),
    [anon_sym_number] = ACTIONS(7152),
    [anon_sym_class] = ACTIONS(7152),
    [anon_sym_declare] = ACTIONS(7152),
    [anon_sym_typeof] = ACTIONS(7152),
    [anon_sym_LT_LT] = ACTIONS(7150),
    [anon_sym_LBRACE] = ACTIONS(7150),
    [anon_sym_AMP_AMP] = ACTIONS(7150),
    [anon_sym_switch] = ACTIONS(7152),
    [anon_sym_LT_EQ] = ACTIONS(7150),
    [anon_sym_LPAREN] = ACTIONS(7150),
    [sym_null] = ACTIONS(7152),
    [anon_sym_GT] = ACTIONS(7152),
    [anon_sym_any] = ACTIONS(7152),
    [anon_sym_boolean] = ACTIONS(7152),
    [anon_sym_async] = ACTIONS(7152),
    [anon_sym_public] = ACTIONS(7152),
    [anon_sym_AMP] = ACTIONS(7152),
    [anon_sym_var] = ACTIONS(7152),
    [anon_sym_QMARK] = ACTIONS(7150),
    [anon_sym_PIPE_PIPE] = ACTIONS(7150),
    [anon_sym_while] = ACTIONS(7152),
    [anon_sym_SQUOTE] = ACTIONS(7150),
    [anon_sym_try] = ACTIONS(7152),
    [anon_sym_EQ_EQ] = ACTIONS(7152),
    [anon_sym_RPAREN] = ACTIONS(7150),
    [anon_sym_LT] = ACTIONS(7152),
    [sym_number] = ACTIONS(7150),
    [anon_sym_SLASH] = ACTIONS(7152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7152),
    [anon_sym_function] = ACTIONS(7152),
    [sym_undefined] = ACTIONS(7152),
    [anon_sym_new] = ACTIONS(7152),
    [anon_sym_CARET] = ACTIONS(7150),
    [anon_sym_let] = ACTIONS(7152),
    [anon_sym_PLUS] = ACTIONS(7152),
    [anon_sym_export] = ACTIONS(7152),
    [anon_sym_GT_GT] = ACTIONS(7152),
    [anon_sym_do] = ACTIONS(7152),
    [anon_sym_TILDE] = ACTIONS(7150),
    [anon_sym_with] = ACTIONS(7152),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7150),
    [anon_sym_in] = ACTIONS(7152),
  },
  [2626] = {
    [sym_class_body] = STATE(3415),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(322),
  },
  [2627] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2631),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2632),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1839),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5549),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2628] = {
    [sym_type_parameters] = STATE(3416),
    [sym_formal_parameters] = STATE(3417),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2629] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2631),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2632),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1839),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5549),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2630] = {
    [anon_sym_EQ_GT] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(7154),
    [anon_sym_PIPE] = ACTIONS(7156),
    [sym_comment] = ACTIONS(3),
  },
  [2631] = {
    [sym_formal_parameters] = STATE(3420),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2632] = {
    [anon_sym_EQ_GT] = ACTIONS(7158),
    [sym_comment] = ACTIONS(3),
  },
  [2633] = {
    [anon_sym_EQ_GT] = ACTIONS(7160),
    [sym_comment] = ACTIONS(3),
  },
  [2634] = {
    [sym_union_type] = STATE(3423),
    [sym__type] = STATE(3423),
    [sym_constructor_type] = STATE(3423),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(902),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3423),
    [sym_function_type] = STATE(3423),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(903),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1839),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(1845),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(1847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2635] = {
    [sym_union_type] = STATE(3424),
    [sym__type] = STATE(3424),
    [sym_constructor_type] = STATE(3424),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(902),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3424),
    [sym_function_type] = STATE(3424),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(903),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1839),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(1845),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(1847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2636] = {
    [anon_sym_EQ_GT] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_PIPE] = ACTIONS(3615),
    [sym_comment] = ACTIONS(3),
  },
  [2637] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3630),
  },
  [2638] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2639] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2003),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3630),
  },
  [2640] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2005),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3630),
  },
  [2641] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2101),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3630),
  },
  [2642] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2105),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3630),
  },
  [2643] = {
    [sym_new_expression] = STATE(3425),
    [sym_augmented_assignment_expression] = STATE(3425),
    [sym_unary_expression] = STATE(3425),
    [sym_update_expression] = STATE(3425),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(3425),
    [sym_regex] = STATE(3425),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2185),
    [sym__expression] = STATE(3425),
    [sym_non_null_expression] = STATE(3425),
    [sym_yield_expression] = STATE(3425),
    [sym_jsx_fragment] = STATE(3425),
    [sym_jsx_element] = STATE(3425),
    [sym_as_expression] = STATE(3425),
    [sym_internal_module] = STATE(3425),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3425),
    [sym_await_expression] = STATE(3425),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(3425),
    [sym_this] = STATE(3425),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(3425),
    [sym_generator_function] = STATE(3425),
    [sym_call_expression] = STATE(3425),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(3425),
    [sym_ternary_expression] = STATE(3425),
    [sym_binary_expression] = STATE(3425),
    [sym_template_string] = STATE(3425),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3425),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3425),
    [sym_class] = STATE(3425),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(7162),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7162),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7164),
    [sym_true] = ACTIONS(7162),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7162),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [2644] = {
    [sym_new_expression] = STATE(3426),
    [sym_augmented_assignment_expression] = STATE(3426),
    [sym_unary_expression] = STATE(3426),
    [sym_update_expression] = STATE(3426),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(3426),
    [sym_regex] = STATE(3426),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2187),
    [sym__expression] = STATE(3426),
    [sym_non_null_expression] = STATE(3426),
    [sym_yield_expression] = STATE(3426),
    [sym_jsx_fragment] = STATE(3426),
    [sym_jsx_element] = STATE(3426),
    [sym_as_expression] = STATE(3426),
    [sym_internal_module] = STATE(3426),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3426),
    [sym_await_expression] = STATE(3426),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(3426),
    [sym_this] = STATE(3426),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(3426),
    [sym_generator_function] = STATE(3426),
    [sym_call_expression] = STATE(3426),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(3426),
    [sym_ternary_expression] = STATE(3426),
    [sym_binary_expression] = STATE(3426),
    [sym_template_string] = STATE(3426),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3426),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3426),
    [sym_class] = STATE(3426),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(7166),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7166),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7168),
    [sym_true] = ACTIONS(7166),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7166),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [2645] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3630),
  },
  [2646] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(7170),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2647] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(7170),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2648] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3630),
  },
  [2649] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3630),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7173),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [2650] = {
    [sym_type_arguments] = STATE(2206),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(4638),
    [anon_sym_BANG] = ACTIONS(3699),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(3699),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_GT_GT_GT] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(7175),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_instanceof] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(4643),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(4646),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_STAR_STAR] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2204),
    [anon_sym_in] = ACTIONS(3699),
  },
  [2651] = {
    [sym_index_type_query] = STATE(2208),
    [sym_lookup_type] = STATE(2208),
    [sym_flow_maybe_type] = STATE(2208),
    [sym_parenthesized_type] = STATE(2208),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_array_type] = STATE(2208),
    [sym_type_predicate] = STATE(2208),
    [sym_type_query] = STATE(2208),
    [sym_existential_type] = STATE(2208),
    [sym_this_type] = STATE(2208),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(2208),
    [sym__primary_type] = STATE(2208),
    [sym_generic_type] = STATE(2208),
    [sym_literal_type] = STATE(2208),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(2208),
    [sym_string] = STATE(1279),
    [sym_tuple_type] = STATE(2208),
    [sym_identifier] = ACTIONS(5608),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(5614),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [sym_true] = ACTIONS(2643),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(4648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2652] = {
    [sym_union_type] = STATE(2213),
    [sym__type] = STATE(2213),
    [sym_constructor_type] = STATE(2213),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2655),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2213),
    [sym_function_type] = STATE(2213),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2656),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(5608),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(5614),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(5612),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(5616),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(5610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2653] = {
    [sym_type_parameters] = STATE(3429),
    [sym_formal_parameters] = STATE(3430),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2654] = {
    [sym_union_type] = STATE(2221),
    [sym__type] = STATE(2221),
    [sym_constructor_type] = STATE(2221),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2655),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2221),
    [sym_function_type] = STATE(2221),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2656),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(5608),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(5614),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(5612),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(5616),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(5610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2655] = {
    [sym_formal_parameters] = STATE(3433),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2656] = {
    [anon_sym_EQ_GT] = ACTIONS(7177),
    [sym_comment] = ACTIONS(3),
  },
  [2657] = {
    [sym__initializer] = STATE(522),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(3624),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3624),
    [anon_sym_AMP_EQ] = ACTIONS(3624),
    [anon_sym_PLUS_EQ] = ACTIONS(3624),
    [anon_sym_PIPE] = ACTIONS(3738),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_GT] = ACTIONS(3738),
    [anon_sym_CARET_EQ] = ACTIONS(3624),
    [anon_sym_STAR_EQ] = ACTIONS(3624),
    [anon_sym_PIPE_EQ] = ACTIONS(3624),
    [anon_sym_DASH_EQ] = ACTIONS(3624),
    [anon_sym_EQ_GT] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(3624),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(3624),
    [anon_sym_GT_GT_EQ] = ACTIONS(3624),
    [anon_sym_DOT] = ACTIONS(5390),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3624),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3630),
  },
  [2658] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(3632),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3632),
    [anon_sym_AMP_EQ] = ACTIONS(3632),
    [anon_sym_PLUS_EQ] = ACTIONS(3632),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_CARET_EQ] = ACTIONS(3632),
    [anon_sym_STAR_EQ] = ACTIONS(3632),
    [anon_sym_PIPE_EQ] = ACTIONS(3632),
    [anon_sym_DASH_EQ] = ACTIONS(3632),
    [anon_sym_EQ_GT] = ACTIONS(3634),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(3632),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_SLASH_EQ] = ACTIONS(3632),
    [anon_sym_GT_GT_EQ] = ACTIONS(3632),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3632),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2659] = {
    [sym_new_expression] = STATE(1734),
    [sym_augmented_assignment_expression] = STATE(1734),
    [sym_unary_expression] = STATE(1734),
    [sym_update_expression] = STATE(1734),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(1734),
    [sym_regex] = STATE(1734),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1734),
    [sym_non_null_expression] = STATE(1734),
    [sym_as_expression] = STATE(1734),
    [sym_jsx_fragment] = STATE(1734),
    [sym_yield_expression] = STATE(1734),
    [sym_jsx_element] = STATE(1734),
    [sym_internal_module] = STATE(1734),
    [sym_nested_identifier] = STATE(1092),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1734),
    [sym_await_expression] = STATE(1734),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(1734),
    [sym_this] = STATE(1734),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(1734),
    [sym_generator_function] = STATE(1734),
    [sym_call_expression] = STATE(1734),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1734),
    [sym_ternary_expression] = STATE(1734),
    [sym_binary_expression] = STATE(1734),
    [sym_template_string] = STATE(1734),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1734),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1734),
    [sym_class] = STATE(1734),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(7179),
    [sym_false] = ACTIONS(3636),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3636),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3638),
    [sym_true] = ACTIONS(3636),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3636),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [2660] = {
    [sym_new_expression] = STATE(1735),
    [sym_augmented_assignment_expression] = STATE(1735),
    [sym_unary_expression] = STATE(1735),
    [sym_update_expression] = STATE(1735),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(1735),
    [sym_regex] = STATE(1735),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1735),
    [sym_non_null_expression] = STATE(1735),
    [sym_as_expression] = STATE(1735),
    [sym_jsx_fragment] = STATE(1735),
    [sym_yield_expression] = STATE(1735),
    [sym_jsx_element] = STATE(1735),
    [sym_internal_module] = STATE(1735),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1735),
    [sym_await_expression] = STATE(1735),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(1735),
    [sym_this] = STATE(1735),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(1735),
    [sym_generator_function] = STATE(1735),
    [sym_call_expression] = STATE(1735),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1735),
    [sym_ternary_expression] = STATE(1735),
    [sym_binary_expression] = STATE(1735),
    [sym_template_string] = STATE(1735),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1735),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1735),
    [sym_class] = STATE(1735),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(3640),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3640),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4674),
    [sym_true] = ACTIONS(3640),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3640),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [2661] = {
    [sym_new_expression] = STATE(1734),
    [sym_augmented_assignment_expression] = STATE(1734),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(1734),
    [sym_update_expression] = STATE(1734),
    [sym_regex] = STATE(1734),
    [sym_meta_property] = STATE(1734),
    [sym_call_signature] = STATE(921),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(1734),
    [sym_non_null_expression] = STATE(1734),
    [sym_yield_expression] = STATE(1734),
    [sym_jsx_fragment] = STATE(1734),
    [sym_jsx_element] = STATE(1734),
    [sym_as_expression] = STATE(1734),
    [sym_internal_module] = STATE(1734),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(1734),
    [sym_await_expression] = STATE(1734),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(1734),
    [sym_this] = STATE(1734),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(1734),
    [sym_generator_function] = STATE(1734),
    [sym_call_expression] = STATE(1734),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(1734),
    [sym_ternary_expression] = STATE(1734),
    [sym_binary_expression] = STATE(1734),
    [sym_template_string] = STATE(1734),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(1734),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1734),
    [sym_class] = STATE(1734),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1879),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(3632),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_AMP_EQ] = ACTIONS(3632),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(3632),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(3632),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_PIPE_EQ] = ACTIONS(3632),
    [anon_sym_DASH_EQ] = ACTIONS(3632),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(3632),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(1897),
    [sym_true] = ACTIONS(3636),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_GT_GT_EQ] = ACTIONS(3632),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3632),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1885),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(3636),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3632),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(3636),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_STAR_EQ] = ACTIONS(3632),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_EQ_GT] = ACTIONS(3634),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(3638),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3632),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3636),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2662] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(1819),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(1820),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(3656),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(3658),
    [anon_sym_symbol] = ACTIONS(3658),
    [anon_sym_number] = ACTIONS(3658),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3658),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3660),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3658),
    [anon_sym_private] = ACTIONS(3658),
    [anon_sym_boolean] = ACTIONS(3658),
    [anon_sym_async] = ACTIONS(3662),
    [anon_sym_public] = ACTIONS(3658),
    [anon_sym_get] = ACTIONS(3658),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3658),
    [anon_sym_string] = ACTIONS(3658),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(3658),
    [anon_sym_type] = ACTIONS(3658),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(3658),
    [anon_sym_export] = ACTIONS(3658),
    [anon_sym_namespace] = ACTIONS(3664),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [2663] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(7181),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(7181),
    [anon_sym_PIPE] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(7181),
    [anon_sym_LT_LT] = ACTIONS(560),
    [anon_sym_STAR] = ACTIONS(566),
    [anon_sym_GT_GT_GT] = ACTIONS(560),
    [anon_sym_AMP_AMP] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(570),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(554),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_SLASH] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(580),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(554),
    [anon_sym_in] = ACTIONS(125),
  },
  [2664] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(7170),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2665] = {
    [anon_sym_AMP] = ACTIONS(5881),
    [anon_sym_PIPE] = ACTIONS(5883),
    [anon_sym_RBRACK] = ACTIONS(7183),
    [sym_comment] = ACTIONS(3),
  },
  [2666] = {
    [aux_sym_implements_clause_repeat1] = STATE(3439),
    [anon_sym_GT] = ACTIONS(7185),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_COMMA] = ACTIONS(7187),
    [sym_comment] = ACTIONS(3),
  },
  [2667] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5891),
    [anon_sym_LBRACK] = ACTIONS(5891),
    [anon_sym_BANG] = ACTIONS(5889),
    [anon_sym_SEMI] = ACTIONS(5891),
    [anon_sym_BQUOTE] = ACTIONS(5891),
    [sym__automatic_semicolon] = ACTIONS(5891),
    [anon_sym_PIPE] = ACTIONS(5889),
    [anon_sym_COMMA] = ACTIONS(5891),
    [anon_sym_LT_LT] = ACTIONS(5891),
    [anon_sym_STAR] = ACTIONS(5889),
    [anon_sym_GT_GT_GT] = ACTIONS(5891),
    [anon_sym_AMP_AMP] = ACTIONS(5891),
    [anon_sym_DASH] = ACTIONS(5889),
    [anon_sym_BANG_EQ] = ACTIONS(5889),
    [anon_sym_LT_EQ] = ACTIONS(5891),
    [anon_sym_LPAREN] = ACTIONS(5891),
    [anon_sym_GT_EQ] = ACTIONS(5891),
    [anon_sym_GT] = ACTIONS(5889),
    [anon_sym_AMP] = ACTIONS(5889),
    [anon_sym_PERCENT] = ACTIONS(5891),
    [anon_sym_QMARK] = ACTIONS(5891),
    [anon_sym_RBRACE] = ACTIONS(5891),
    [anon_sym_as] = ACTIONS(5891),
    [anon_sym_PIPE_PIPE] = ACTIONS(5891),
    [anon_sym_DASH_DASH] = ACTIONS(5891),
    [anon_sym_EQ_EQ] = ACTIONS(5889),
    [anon_sym_instanceof] = ACTIONS(5891),
    [anon_sym_LT] = ACTIONS(5889),
    [anon_sym_RPAREN] = ACTIONS(5891),
    [anon_sym_SLASH] = ACTIONS(5889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(5891),
    [anon_sym_STAR_STAR] = ACTIONS(5891),
    [anon_sym_PLUS] = ACTIONS(5889),
    [anon_sym_GT_GT] = ACTIONS(5889),
    [anon_sym_PLUS_PLUS] = ACTIONS(5891),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5891),
    [anon_sym_in] = ACTIONS(5889),
  },
  [2668] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(7192),
    [anon_sym_SEMI] = ACTIONS(5893),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [sym__automatic_semicolon] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(7194),
    [anon_sym_COMMA] = ACTIONS(5893),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_GT_GT_GT] = ACTIONS(5893),
    [anon_sym_AMP_AMP] = ACTIONS(5893),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_BANG_EQ] = ACTIONS(7192),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_PERCENT] = ACTIONS(5893),
    [anon_sym_QMARK] = ACTIONS(5893),
    [anon_sym_as] = ACTIONS(5893),
    [anon_sym_PIPE_PIPE] = ACTIONS(5893),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_EQ_EQ] = ACTIONS(7192),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5893),
    [anon_sym_CARET] = ACTIONS(5893),
    [anon_sym_STAR_STAR] = ACTIONS(5893),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_in] = ACTIONS(7192),
  },
  [2669] = {
    [aux_sym_object_type_repeat1] = STATE(3442),
    [sym__automatic_semicolon] = ACTIONS(7198),
    [anon_sym_RBRACE] = ACTIONS(7200),
    [anon_sym_SEMI] = ACTIONS(7198),
    [anon_sym_COMMA] = ACTIONS(7198),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7200),
    [sym_comment] = ACTIONS(3),
  },
  [2670] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(2866),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(2866),
    [sym_call_signature] = STATE(2866),
    [sym_export_statement] = STATE(2866),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(2866),
    [sym_index_signature] = STATE(2866),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_RBRACE] = ACTIONS(7200),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7200),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [2671] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5979),
    [anon_sym_LBRACK] = ACTIONS(5979),
    [anon_sym_BANG] = ACTIONS(5977),
    [anon_sym_SEMI] = ACTIONS(5979),
    [anon_sym_BQUOTE] = ACTIONS(5979),
    [sym__automatic_semicolon] = ACTIONS(5979),
    [anon_sym_PIPE] = ACTIONS(5977),
    [anon_sym_COMMA] = ACTIONS(5979),
    [anon_sym_LT_LT] = ACTIONS(5979),
    [anon_sym_STAR] = ACTIONS(5977),
    [anon_sym_GT_GT_GT] = ACTIONS(5979),
    [anon_sym_AMP_AMP] = ACTIONS(5979),
    [anon_sym_DASH] = ACTIONS(5977),
    [anon_sym_BANG_EQ] = ACTIONS(5977),
    [anon_sym_LT_EQ] = ACTIONS(5979),
    [anon_sym_LPAREN] = ACTIONS(5979),
    [anon_sym_GT_EQ] = ACTIONS(5979),
    [anon_sym_GT] = ACTIONS(5977),
    [anon_sym_AMP] = ACTIONS(5977),
    [anon_sym_PERCENT] = ACTIONS(5979),
    [anon_sym_QMARK] = ACTIONS(5979),
    [anon_sym_RBRACE] = ACTIONS(5979),
    [anon_sym_as] = ACTIONS(5979),
    [anon_sym_PIPE_PIPE] = ACTIONS(5979),
    [anon_sym_DASH_DASH] = ACTIONS(5979),
    [anon_sym_EQ_EQ] = ACTIONS(5977),
    [anon_sym_instanceof] = ACTIONS(5979),
    [anon_sym_LT] = ACTIONS(5977),
    [anon_sym_RPAREN] = ACTIONS(5979),
    [anon_sym_SLASH] = ACTIONS(5977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5979),
    [anon_sym_CARET] = ACTIONS(5979),
    [anon_sym_STAR_STAR] = ACTIONS(5979),
    [anon_sym_PLUS] = ACTIONS(5977),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5979),
    [anon_sym_GT_GT] = ACTIONS(5977),
    [anon_sym_PLUS_PLUS] = ACTIONS(5979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5979),
    [anon_sym_in] = ACTIONS(5977),
  },
  [2672] = {
    [aux_sym_object_type_repeat1] = STATE(2867),
    [sym__automatic_semicolon] = ACTIONS(7198),
    [anon_sym_RBRACE] = ACTIONS(7200),
    [anon_sym_SEMI] = ACTIONS(7198),
    [anon_sym_COMMA] = ACTIONS(7198),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7200),
    [sym_comment] = ACTIONS(3),
  },
  [2673] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5993),
    [anon_sym_LBRACK] = ACTIONS(5993),
    [anon_sym_BANG] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(5993),
    [anon_sym_BQUOTE] = ACTIONS(5993),
    [sym__automatic_semicolon] = ACTIONS(5993),
    [anon_sym_PIPE] = ACTIONS(5991),
    [anon_sym_COMMA] = ACTIONS(5993),
    [anon_sym_LT_LT] = ACTIONS(5993),
    [anon_sym_STAR] = ACTIONS(5991),
    [anon_sym_GT_GT_GT] = ACTIONS(5993),
    [anon_sym_AMP_AMP] = ACTIONS(5993),
    [anon_sym_DASH] = ACTIONS(5991),
    [anon_sym_BANG_EQ] = ACTIONS(5991),
    [anon_sym_LT_EQ] = ACTIONS(5993),
    [anon_sym_LPAREN] = ACTIONS(5993),
    [anon_sym_GT_EQ] = ACTIONS(5993),
    [anon_sym_GT] = ACTIONS(5991),
    [anon_sym_AMP] = ACTIONS(5991),
    [anon_sym_PERCENT] = ACTIONS(5993),
    [anon_sym_QMARK] = ACTIONS(5993),
    [anon_sym_RBRACE] = ACTIONS(5993),
    [anon_sym_as] = ACTIONS(5993),
    [anon_sym_PIPE_PIPE] = ACTIONS(5993),
    [anon_sym_DASH_DASH] = ACTIONS(5993),
    [anon_sym_EQ_EQ] = ACTIONS(5991),
    [anon_sym_instanceof] = ACTIONS(5993),
    [anon_sym_LT] = ACTIONS(5991),
    [anon_sym_RPAREN] = ACTIONS(5993),
    [anon_sym_SLASH] = ACTIONS(5991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5993),
    [anon_sym_CARET] = ACTIONS(5993),
    [anon_sym_STAR_STAR] = ACTIONS(5993),
    [anon_sym_PLUS] = ACTIONS(5991),
    [anon_sym_GT_GT] = ACTIONS(5991),
    [anon_sym_PLUS_PLUS] = ACTIONS(5993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5993),
    [anon_sym_in] = ACTIONS(5991),
  },
  [2674] = {
    [aux_sym_implements_clause_repeat1] = STATE(2879),
    [anon_sym_COMMA] = ACTIONS(4165),
    [anon_sym_RBRACK] = ACTIONS(7202),
    [sym_comment] = ACTIONS(3),
  },
  [2675] = {
    [anon_sym_EQ_GT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(3),
  },
  [2676] = {
    [sym_union_type] = STATE(3445),
    [sym__type] = STATE(3445),
    [sym_constructor_type] = STATE(3445),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(943),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(3445),
    [sym_function_type] = STATE(3445),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(947),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(1905),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(1931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1929),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(1937),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [2677] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6011),
    [anon_sym_LBRACK] = ACTIONS(6011),
    [anon_sym_BANG] = ACTIONS(6009),
    [anon_sym_SEMI] = ACTIONS(6011),
    [anon_sym_BQUOTE] = ACTIONS(6011),
    [sym__automatic_semicolon] = ACTIONS(6011),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_COMMA] = ACTIONS(6011),
    [anon_sym_LT_LT] = ACTIONS(6011),
    [anon_sym_STAR] = ACTIONS(6009),
    [anon_sym_GT_GT_GT] = ACTIONS(6011),
    [anon_sym_AMP_AMP] = ACTIONS(6011),
    [anon_sym_DASH] = ACTIONS(6009),
    [anon_sym_BANG_EQ] = ACTIONS(6009),
    [anon_sym_LT_EQ] = ACTIONS(6011),
    [anon_sym_LPAREN] = ACTIONS(6011),
    [anon_sym_GT_EQ] = ACTIONS(6011),
    [anon_sym_GT] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6009),
    [anon_sym_PERCENT] = ACTIONS(6011),
    [anon_sym_QMARK] = ACTIONS(6011),
    [anon_sym_RBRACE] = ACTIONS(6011),
    [anon_sym_as] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6011),
    [anon_sym_DASH_DASH] = ACTIONS(6011),
    [anon_sym_EQ_EQ] = ACTIONS(6009),
    [anon_sym_instanceof] = ACTIONS(6011),
    [anon_sym_LT] = ACTIONS(6009),
    [anon_sym_RPAREN] = ACTIONS(6011),
    [anon_sym_SLASH] = ACTIONS(6009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6011),
    [anon_sym_CARET] = ACTIONS(6011),
    [anon_sym_STAR_STAR] = ACTIONS(6011),
    [anon_sym_PLUS] = ACTIONS(6009),
    [anon_sym_GT_GT] = ACTIONS(6009),
    [anon_sym_PLUS_PLUS] = ACTIONS(6011),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6011),
    [anon_sym_in] = ACTIONS(6009),
  },
  [2678] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6017),
    [anon_sym_LBRACK] = ACTIONS(6017),
    [anon_sym_BANG] = ACTIONS(6015),
    [anon_sym_SEMI] = ACTIONS(6017),
    [anon_sym_BQUOTE] = ACTIONS(6017),
    [sym__automatic_semicolon] = ACTIONS(6017),
    [anon_sym_PIPE] = ACTIONS(6015),
    [anon_sym_COMMA] = ACTIONS(6017),
    [anon_sym_LT_LT] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(6015),
    [anon_sym_GT_GT_GT] = ACTIONS(6017),
    [anon_sym_AMP_AMP] = ACTIONS(6017),
    [anon_sym_DASH] = ACTIONS(6015),
    [anon_sym_BANG_EQ] = ACTIONS(6015),
    [anon_sym_LT_EQ] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6017),
    [anon_sym_GT] = ACTIONS(6015),
    [anon_sym_AMP] = ACTIONS(6015),
    [anon_sym_PERCENT] = ACTIONS(6017),
    [anon_sym_QMARK] = ACTIONS(6017),
    [anon_sym_RBRACE] = ACTIONS(6017),
    [anon_sym_as] = ACTIONS(6017),
    [anon_sym_PIPE_PIPE] = ACTIONS(6017),
    [anon_sym_DASH_DASH] = ACTIONS(6017),
    [anon_sym_EQ_EQ] = ACTIONS(6015),
    [anon_sym_instanceof] = ACTIONS(6017),
    [anon_sym_LT] = ACTIONS(6015),
    [anon_sym_RPAREN] = ACTIONS(6017),
    [anon_sym_SLASH] = ACTIONS(6015),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6017),
    [anon_sym_CARET] = ACTIONS(6017),
    [anon_sym_STAR_STAR] = ACTIONS(6017),
    [anon_sym_PLUS] = ACTIONS(6015),
    [anon_sym_GT_GT] = ACTIONS(6015),
    [anon_sym_PLUS_PLUS] = ACTIONS(6017),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6017),
    [anon_sym_in] = ACTIONS(6015),
  },
  [2679] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6021),
    [anon_sym_LBRACK] = ACTIONS(6021),
    [anon_sym_BANG] = ACTIONS(6019),
    [anon_sym_SEMI] = ACTIONS(6021),
    [anon_sym_BQUOTE] = ACTIONS(6021),
    [sym__automatic_semicolon] = ACTIONS(6021),
    [anon_sym_PIPE] = ACTIONS(6019),
    [anon_sym_COMMA] = ACTIONS(6021),
    [anon_sym_LT_LT] = ACTIONS(6021),
    [anon_sym_STAR] = ACTIONS(6019),
    [anon_sym_GT_GT_GT] = ACTIONS(6021),
    [anon_sym_AMP_AMP] = ACTIONS(6021),
    [anon_sym_DASH] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_LT_EQ] = ACTIONS(6021),
    [anon_sym_LPAREN] = ACTIONS(6021),
    [anon_sym_GT_EQ] = ACTIONS(6021),
    [anon_sym_GT] = ACTIONS(6019),
    [anon_sym_AMP] = ACTIONS(6019),
    [anon_sym_PERCENT] = ACTIONS(6021),
    [anon_sym_QMARK] = ACTIONS(6021),
    [anon_sym_RBRACE] = ACTIONS(6021),
    [anon_sym_as] = ACTIONS(6021),
    [anon_sym_PIPE_PIPE] = ACTIONS(6021),
    [anon_sym_DASH_DASH] = ACTIONS(6021),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_instanceof] = ACTIONS(6021),
    [anon_sym_LT] = ACTIONS(6019),
    [anon_sym_RPAREN] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6021),
    [anon_sym_CARET] = ACTIONS(6021),
    [anon_sym_STAR_STAR] = ACTIONS(6021),
    [anon_sym_PLUS] = ACTIONS(6019),
    [anon_sym_GT_GT] = ACTIONS(6019),
    [anon_sym_PLUS_PLUS] = ACTIONS(6021),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6021),
    [anon_sym_in] = ACTIONS(6019),
  },
  [2680] = {
    [anon_sym_AMP] = ACTIONS(5881),
    [anon_sym_PIPE] = ACTIONS(5883),
    [anon_sym_RBRACK] = ACTIONS(7206),
    [sym_comment] = ACTIONS(3),
  },
  [2681] = {
    [sym_union_type] = STATE(3447),
    [sym__type] = STATE(3447),
    [sym_constructor_type] = STATE(3447),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(943),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(3447),
    [sym_function_type] = STATE(3447),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(947),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(1905),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(1931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1929),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(1937),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [2682] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6038),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_BANG] = ACTIONS(6036),
    [anon_sym_SEMI] = ACTIONS(6038),
    [anon_sym_BQUOTE] = ACTIONS(6038),
    [sym__automatic_semicolon] = ACTIONS(6038),
    [anon_sym_PIPE] = ACTIONS(6036),
    [anon_sym_COMMA] = ACTIONS(6038),
    [anon_sym_LT_LT] = ACTIONS(6038),
    [anon_sym_STAR] = ACTIONS(6036),
    [anon_sym_GT_GT_GT] = ACTIONS(6038),
    [anon_sym_AMP_AMP] = ACTIONS(6038),
    [anon_sym_DASH] = ACTIONS(6036),
    [anon_sym_BANG_EQ] = ACTIONS(6036),
    [anon_sym_LT_EQ] = ACTIONS(6038),
    [anon_sym_LPAREN] = ACTIONS(6038),
    [anon_sym_GT_EQ] = ACTIONS(6038),
    [anon_sym_GT] = ACTIONS(6036),
    [anon_sym_AMP] = ACTIONS(6036),
    [anon_sym_PERCENT] = ACTIONS(6038),
    [anon_sym_QMARK] = ACTIONS(6038),
    [anon_sym_RBRACE] = ACTIONS(6038),
    [anon_sym_as] = ACTIONS(6038),
    [anon_sym_PIPE_PIPE] = ACTIONS(6038),
    [anon_sym_DASH_DASH] = ACTIONS(6038),
    [anon_sym_EQ_EQ] = ACTIONS(6036),
    [anon_sym_instanceof] = ACTIONS(6038),
    [anon_sym_LT] = ACTIONS(6036),
    [anon_sym_RPAREN] = ACTIONS(6038),
    [anon_sym_SLASH] = ACTIONS(6036),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6038),
    [anon_sym_CARET] = ACTIONS(6038),
    [anon_sym_STAR_STAR] = ACTIONS(6038),
    [anon_sym_PLUS] = ACTIONS(6036),
    [anon_sym_GT_GT] = ACTIONS(6036),
    [anon_sym_PLUS_PLUS] = ACTIONS(6038),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6038),
    [anon_sym_in] = ACTIONS(6036),
  },
  [2683] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_BANG] = ACTIONS(7208),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [sym__automatic_semicolon] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(7194),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_LT_LT] = ACTIONS(6040),
    [anon_sym_STAR] = ACTIONS(7208),
    [anon_sym_GT_GT_GT] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(6040),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_BANG_EQ] = ACTIONS(7208),
    [anon_sym_LT_EQ] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [anon_sym_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_PERCENT] = ACTIONS(6040),
    [anon_sym_QMARK] = ACTIONS(6040),
    [anon_sym_as] = ACTIONS(6040),
    [anon_sym_PIPE_PIPE] = ACTIONS(6040),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_instanceof] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6040),
    [anon_sym_CARET] = ACTIONS(6040),
    [anon_sym_STAR_STAR] = ACTIONS(6040),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6040),
    [anon_sym_in] = ACTIONS(7208),
  },
  [2684] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(6447),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_SEMI] = ACTIONS(2011),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [sym__automatic_semicolon] = ACTIONS(2011),
    [anon_sym_PERCENT_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_AMP_EQ] = ACTIONS(2011),
    [anon_sym_PLUS_EQ] = ACTIONS(2011),
    [anon_sym_PIPE] = ACTIONS(6450),
    [anon_sym_COMMA] = ACTIONS(6447),
    [anon_sym_LT_LT] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_GT_GT_GT] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(6450),
    [anon_sym_CARET_EQ] = ACTIONS(2011),
    [anon_sym_STAR_EQ] = ACTIONS(2011),
    [anon_sym_PIPE_EQ] = ACTIONS(2011),
    [anon_sym_DASH_EQ] = ACTIONS(2011),
    [anon_sym_AMP] = ACTIONS(6450),
    [anon_sym_PERCENT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_LT_LT_EQ] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2011),
    [anon_sym_RBRACE] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_instanceof] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(6450),
    [anon_sym_RPAREN] = ACTIONS(2011),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_DOT] = ACTIONS(6453),
    [anon_sym_CARET] = ACTIONS(2013),
    [anon_sym_STAR_STAR] = ACTIONS(2013),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2013),
  },
  [2685] = {
    [sym_identifier] = ACTIONS(7210),
    [sym_comment] = ACTIONS(3),
  },
  [2686] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4181),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(4179),
    [anon_sym_COMMA] = ACTIONS(4181),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(4181),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(4179),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [2687] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(937),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(937),
    [anon_sym_AMP_EQ] = ACTIONS(937),
    [anon_sym_PLUS_EQ] = ACTIONS(937),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(4177),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(937),
    [anon_sym_STAR_EQ] = ACTIONS(937),
    [anon_sym_PIPE_EQ] = ACTIONS(937),
    [anon_sym_DASH_EQ] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(937),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(937),
    [anon_sym_GT_GT_EQ] = ACTIONS(937),
    [anon_sym_DOT] = ACTIONS(7212),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(945),
  },
  [2688] = {
    [sym_formal_parameters] = STATE(3450),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2689] = {
    [sym_type_annotation] = STATE(323),
    [anon_sym_EQ_GT] = ACTIONS(7214),
    [anon_sym_COLON] = ACTIONS(550),
    [sym_comment] = ACTIONS(3),
  },
  [2690] = {
    [sym_type_annotation] = STATE(892),
    [anon_sym_EQ_GT] = ACTIONS(7217),
    [anon_sym_COLON] = ACTIONS(550),
    [sym_comment] = ACTIONS(3),
  },
  [2691] = {
    [sym_identifier] = ACTIONS(7220),
    [sym_comment] = ACTIONS(3),
  },
  [2692] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(937),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(937),
    [anon_sym_AMP_EQ] = ACTIONS(937),
    [anon_sym_PLUS_EQ] = ACTIONS(937),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(937),
    [anon_sym_STAR_EQ] = ACTIONS(937),
    [anon_sym_PIPE_EQ] = ACTIONS(937),
    [anon_sym_DASH_EQ] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(937),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5901),
    [anon_sym_SLASH_EQ] = ACTIONS(937),
    [anon_sym_GT_GT_EQ] = ACTIONS(937),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(945),
  },
  [2693] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(951),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_AMP_EQ] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(951),
    [anon_sym_STAR_EQ] = ACTIONS(951),
    [anon_sym_PIPE_EQ] = ACTIONS(951),
    [anon_sym_DASH_EQ] = ACTIONS(951),
    [anon_sym_EQ_GT] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(951),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5903),
    [anon_sym_SLASH_EQ] = ACTIONS(951),
    [anon_sym_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2694] = {
    [sym_new_expression] = STATE(533),
    [sym_augmented_assignment_expression] = STATE(533),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(533),
    [sym_update_expression] = STATE(533),
    [sym_regex] = STATE(533),
    [sym_meta_property] = STATE(533),
    [sym_call_signature] = STATE(159),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(533),
    [sym_non_null_expression] = STATE(533),
    [sym_yield_expression] = STATE(533),
    [sym_jsx_fragment] = STATE(533),
    [sym_jsx_element] = STATE(533),
    [sym_as_expression] = STATE(533),
    [sym_internal_module] = STATE(533),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(533),
    [sym_await_expression] = STATE(533),
    [sym_member_expression] = STATE(162),
    [sym_string] = STATE(533),
    [sym_this] = STATE(533),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [sym_anonymous_class] = STATE(533),
    [sym_generator_function] = STATE(533),
    [sym_call_expression] = STATE(533),
    [sym_subscript_expression] = STATE(162),
    [sym_assignment_expression] = STATE(533),
    [sym_ternary_expression] = STATE(533),
    [sym_binary_expression] = STATE(533),
    [sym_template_string] = STATE(533),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(533),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(533),
    [sym_class] = STATE(533),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(951),
    [anon_sym_symbol] = ACTIONS(260),
    [anon_sym_AMP_EQ] = ACTIONS(951),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(266),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_void] = ACTIONS(272),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(951),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_PIPE_EQ] = ACTIONS(951),
    [anon_sym_DASH_EQ] = ACTIONS(951),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(951),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(290),
    [sym_true] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(5903),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(951),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(961),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_number] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(264),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(135),
    [sym_null] = ACTIONS(961),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(260),
    [anon_sym_STAR_EQ] = ACTIONS(951),
    [anon_sym_boolean] = ACTIONS(260),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_EQ_GT] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(951),
    [anon_sym_string] = ACTIONS(260),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(961),
    [anon_sym_new] = ACTIONS(298),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(266),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2695] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_call_signature] = STATE(543),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(993),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(951),
    [anon_sym_symbol] = ACTIONS(995),
    [anon_sym_AMP_EQ] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_void] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(951),
    [anon_sym_private] = ACTIONS(995),
    [anon_sym_PIPE_EQ] = ACTIONS(951),
    [anon_sym_DASH_EQ] = ACTIONS(951),
    [anon_sym_get] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(951),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(5903),
    [anon_sym_protected] = ACTIONS(995),
    [anon_sym_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(995),
    [anon_sym_type] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(995),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(951),
    [anon_sym_namespace] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(995),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_number] = ACTIONS(995),
    [anon_sym_declare] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(995),
    [anon_sym_STAR_EQ] = ACTIONS(951),
    [anon_sym_boolean] = ACTIONS(995),
    [anon_sym_async] = ACTIONS(995),
    [anon_sym_public] = ACTIONS(995),
    [anon_sym_EQ_GT] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(951),
    [anon_sym_string] = ACTIONS(995),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2696] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(951),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_AMP_EQ] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(951),
    [anon_sym_STAR_EQ] = ACTIONS(951),
    [anon_sym_PIPE_EQ] = ACTIONS(951),
    [anon_sym_DASH_EQ] = ACTIONS(951),
    [anon_sym_EQ_GT] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(951),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5903),
    [anon_sym_SLASH_EQ] = ACTIONS(951),
    [anon_sym_GT_GT_EQ] = ACTIONS(951),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2697] = {
    [sym_template_string] = STATE(542),
    [aux_sym_array_repeat1] = STATE(1039),
    [sym_type_arguments] = STATE(541),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(945),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_RBRACK] = ACTIONS(7222),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [2698] = {
    [sym__initializer] = STATE(1010),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(7224),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_EQ] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(7224),
    [sym_comment] = ACTIONS(3),
  },
  [2699] = {
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(7224),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_COMMA] = ACTIONS(7224),
    [sym_comment] = ACTIONS(3),
  },
  [2700] = {
    [sym__automatic_semicolon] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(1238),
    [sym_identifier] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1236),
    [anon_sym_symbol] = ACTIONS(1236),
    [anon_sym_number] = ACTIONS(1236),
    [anon_sym_declare] = ACTIONS(1236),
    [anon_sym_COMMA] = ACTIONS(7224),
    [anon_sym_STAR] = ACTIONS(1238),
    [anon_sym_void] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1236),
    [anon_sym_private] = ACTIONS(1236),
    [anon_sym_boolean] = ACTIONS(1236),
    [anon_sym_async] = ACTIONS(1236),
    [anon_sym_public] = ACTIONS(1236),
    [anon_sym_get] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(7224),
    [anon_sym_static] = ACTIONS(1236),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(1238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1236),
    [anon_sym_string] = ACTIONS(1236),
    [anon_sym_set] = ACTIONS(1236),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1236),
    [anon_sym_import] = ACTIONS(1236),
    [anon_sym_export] = ACTIONS(1236),
    [anon_sym_namespace] = ACTIONS(1236),
    [sym_readonly] = ACTIONS(1236),
    [anon_sym_DQUOTE] = ACTIONS(1238),
  },
  [2701] = {
    [sym_string] = STATE(2705),
    [sym__property_name] = STATE(2705),
    [sym_computed_property_name] = STATE(2705),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(7224),
    [anon_sym_STAR] = ACTIONS(5695),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(5697),
    [anon_sym_RBRACE] = ACTIONS(7224),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(5693),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(5697),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [2702] = {
    [sym_string] = STATE(2705),
    [sym__property_name] = STATE(2705),
    [sym_computed_property_name] = STATE(2705),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(7224),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(7224),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(5693),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [2703] = {
    [sym_type_alias_declaration] = STATE(1970),
    [aux_sym_export_statement_repeat1] = STATE(1969),
    [sym__declaration] = STATE(1970),
    [sym_ambient_declaration] = STATE(1970),
    [sym_import_alias] = STATE(1970),
    [sym_export_statement] = STATE(1970),
    [sym_generator_function] = STATE(1970),
    [sym_export_clause] = STATE(1971),
    [sym_lexical_declaration] = STATE(1970),
    [sym_internal_module] = STATE(1970),
    [sym_decorator] = STATE(1969),
    [sym_enum_declaration] = STATE(1970),
    [sym_function] = STATE(1970),
    [sym_function_signature] = STATE(1970),
    [sym_variable_declaration] = STATE(1970),
    [sym_abstract_class] = STATE(1970),
    [sym_module] = STATE(1970),
    [sym_interface_declaration] = STATE(1970),
    [sym_class] = STATE(1970),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(4107),
    [anon_sym_class] = ACTIONS(4109),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(7224),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_EQ] = ACTIONS(4115),
    [anon_sym_const] = ACTIONS(4117),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_async] = ACTIONS(4119),
    [anon_sym_RBRACE] = ACTIONS(7224),
    [anon_sym_var] = ACTIONS(4121),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_interface] = ACTIONS(4123),
    [anon_sym_default] = ACTIONS(4125),
    [anon_sym_enum] = ACTIONS(4127),
    [anon_sym_as] = ACTIONS(4129),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_function] = ACTIONS(4131),
    [anon_sym_abstract] = ACTIONS(4133),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(4135),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_import] = ACTIONS(4139),
    [anon_sym_export] = ACTIONS(4141),
    [anon_sym_namespace] = ACTIONS(4143),
  },
  [2704] = {
    [aux_sym_export_statement_repeat1] = STATE(1012),
    [sym__property_name] = STATE(707),
    [sym_decorator] = STATE(1012),
    [sym_string] = STATE(707),
    [sym_accessibility_modifier] = STATE(221),
    [sym_method_definition] = STATE(1435),
    [sym_computed_property_name] = STATE(707),
    [anon_sym_get] = ACTIONS(1320),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1318),
    [anon_sym_static] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [sym_number] = ACTIONS(1322),
    [anon_sym_STAR] = ACTIONS(364),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1316),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1320),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(5707),
    [sym_readonly] = ACTIONS(384),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1316),
    [anon_sym_public] = ACTIONS(1316),
  },
  [2705] = {
    [sym_type_parameters] = STATE(2715),
    [sym_formal_parameters] = STATE(2716),
    [sym_call_signature] = STATE(3454),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(7227),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [2706] = {
    [sym_string] = STATE(3455),
    [sym__property_name] = STATE(3455),
    [sym_computed_property_name] = STATE(3455),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(7229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [2707] = {
    [sym_string] = STATE(3455),
    [sym__property_name] = STATE(3455),
    [sym_computed_property_name] = STATE(3455),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(7229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [2708] = {
    [sym_string] = STATE(3455),
    [sym__property_name] = STATE(3455),
    [sym_computed_property_name] = STATE(3455),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(7229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [2709] = {
    [sym_string] = STATE(3459),
    [sym__property_name] = STATE(3459),
    [sym_computed_property_name] = STATE(3459),
    [anon_sym_get] = ACTIONS(7231),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(7233),
    [anon_sym_STAR] = ACTIONS(7235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(7231),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_async] = ACTIONS(7237),
  },
  [2710] = {
    [sym_string] = STATE(3455),
    [sym__property_name] = STATE(3455),
    [sym_computed_property_name] = STATE(3455),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(7235),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(7239),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(7229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(7239),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [2711] = {
    [sym_type_parameters] = STATE(2715),
    [sym_type_annotation] = STATE(2835),
    [sym_formal_parameters] = STATE(2716),
    [sym_call_signature] = STATE(3454),
    [sym__automatic_semicolon] = ACTIONS(5923),
    [anon_sym_RBRACE] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(5923),
    [anon_sym_QMARK] = ACTIONS(7241),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(5923),
    [sym_comment] = ACTIONS(3),
  },
  [2712] = {
    [sym_type_alias_declaration] = STATE(2856),
    [aux_sym_export_statement_repeat1] = STATE(1969),
    [sym__declaration] = STATE(2856),
    [sym_ambient_declaration] = STATE(2856),
    [sym_import_alias] = STATE(2856),
    [sym_export_statement] = STATE(2856),
    [sym_generator_function] = STATE(2856),
    [sym_lexical_declaration] = STATE(2856),
    [sym_internal_module] = STATE(2856),
    [sym_decorator] = STATE(1969),
    [sym_enum_declaration] = STATE(2856),
    [sym_function] = STATE(2856),
    [sym_function_signature] = STATE(2856),
    [sym_variable_declaration] = STATE(2856),
    [sym_abstract_class] = STATE(2856),
    [sym_module] = STATE(2856),
    [sym_interface_declaration] = STATE(2856),
    [sym_class] = STATE(2856),
    [anon_sym_var] = ACTIONS(4121),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_interface] = ACTIONS(4123),
    [anon_sym_enum] = ACTIONS(4127),
    [anon_sym_default] = ACTIONS(5965),
    [anon_sym_module] = ACTIONS(4107),
    [anon_sym_class] = ACTIONS(4109),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_LT] = ACTIONS(1214),
    [anon_sym_declare] = ACTIONS(4111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(4131),
    [anon_sym_const] = ACTIONS(4117),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_abstract] = ACTIONS(4133),
    [anon_sym_type] = ACTIONS(4135),
    [anon_sym_let] = ACTIONS(4137),
    [anon_sym_import] = ACTIONS(4139),
    [anon_sym_export] = ACTIONS(4141),
    [anon_sym_namespace] = ACTIONS(4143),
    [anon_sym_async] = ACTIONS(4119),
  },
  [2713] = {
    [sym_new_expression] = STATE(1470),
    [sym_constructor_type] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1470),
    [sym_lookup_type] = STATE(1035),
    [sym_unary_expression] = STATE(1470),
    [sym_parenthesized_type] = STATE(1035),
    [sym_regex] = STATE(1470),
    [sym_type_parameters] = STATE(3473),
    [sym_array_type] = STATE(1035),
    [sym_yield_expression] = STATE(1470),
    [sym_as_expression] = STATE(1470),
    [sym_jsx_fragment] = STATE(1470),
    [sym_internal_module] = STATE(1470),
    [sym_arrow_function] = STATE(1470),
    [sym__primary_type] = STATE(1035),
    [sym_member_expression] = STATE(363),
    [sym_literal_type] = STATE(1035),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(3463),
    [sym_tuple_type] = STATE(1035),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_generator_function] = STATE(1470),
    [sym_subscript_expression] = STATE(363),
    [sym_type_query] = STATE(1035),
    [sym_ternary_expression] = STATE(1470),
    [sym_this_type] = STATE(1035),
    [sym_template_string] = STATE(1470),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(3474),
    [sym_function_type] = STATE(2863),
    [sym__type] = STATE(2863),
    [sym_index_type_query] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_update_expression] = STATE(1470),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(1470),
    [sym__expression] = STATE(1470),
    [sym_non_null_expression] = STATE(1470),
    [sym_jsx_element] = STATE(1470),
    [sym_nested_identifier] = STATE(1034),
    [sym_function] = STATE(161),
    [sym_await_expression] = STATE(1470),
    [sym_generic_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_this] = STATE(1470),
    [sym_union_type] = STATE(2863),
    [sym_anonymous_class] = STATE(1470),
    [sym_call_expression] = STATE(1470),
    [sym_type_predicate] = STATE(1035),
    [sym_assignment_expression] = STATE(1470),
    [sym_existential_type] = STATE(1035),
    [sym_binary_expression] = STATE(1470),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2863),
    [sym_parenthesized_expression] = STATE(1470),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(1470),
    [sym_class] = STATE(1470),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(7243),
    [sym_false] = ACTIONS(7245),
    [anon_sym_LBRACK] = ACTIONS(7247),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(7249),
    [anon_sym_number] = ACTIONS(7249),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(7251),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(7253),
    [anon_sym_keyof] = ACTIONS(2157),
    [anon_sym_LBRACE] = ACTIONS(7255),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_void] = ACTIONS(7257),
    [anon_sym_PIPE] = ACTIONS(5975),
    [anon_sym_LPAREN] = ACTIONS(7259),
    [sym_null] = ACTIONS(3063),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(7249),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(7249),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_AMP] = ACTIONS(5971),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7261),
    [sym_true] = ACTIONS(7245),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(7263),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(7249),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(3063),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(7265),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(7253),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [2714] = {
    [sym_type_parameters] = STATE(2715),
    [sym_type_annotation] = STATE(2835),
    [sym_formal_parameters] = STATE(2716),
    [sym_call_signature] = STATE(3454),
    [sym__automatic_semicolon] = ACTIONS(5923),
    [anon_sym_RBRACE] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(5923),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(5923),
    [sym_comment] = ACTIONS(3),
  },
  [2715] = {
    [sym_formal_parameters] = STATE(3475),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [2716] = {
    [sym_type_annotation] = STATE(1603),
    [sym__automatic_semicolon] = ACTIONS(548),
    [anon_sym_RBRACE] = ACTIONS(548),
    [anon_sym_COLON] = ACTIONS(7267),
    [anon_sym_SEMI] = ACTIONS(548),
    [anon_sym_PIPE_RBRACE] = ACTIONS(548),
    [anon_sym_COMMA] = ACTIONS(548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(548),
  },
  [2717] = {
    [sym_statement_block] = STATE(1471),
    [sym__automatic_semicolon] = ACTIONS(4897),
    [anon_sym_RBRACE] = ACTIONS(4897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4897),
    [anon_sym_COMMA] = ACTIONS(4897),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4897),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [2718] = {
    [sym_string] = STATE(3459),
    [sym__property_name] = STATE(3459),
    [sym_computed_property_name] = STATE(3459),
    [anon_sym_get] = ACTIONS(7231),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_async] = ACTIONS(7237),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(7233),
    [anon_sym_STAR] = ACTIONS(7235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(7231),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(7269),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [2719] = {
    [sym_identifier] = ACTIONS(7271),
    [sym_comment] = ACTIONS(3),
  },
  [2720] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4181),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(4179),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(4179),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(4181),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [2721] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1332),
    [anon_sym_AMP_EQ] = ACTIONS(1332),
    [anon_sym_PLUS_EQ] = ACTIONS(1332),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1332),
    [anon_sym_STAR_EQ] = ACTIONS(1332),
    [anon_sym_PIPE_EQ] = ACTIONS(1332),
    [anon_sym_DASH_EQ] = ACTIONS(1332),
    [anon_sym_EQ_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1332),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(4177),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT_EQ] = ACTIONS(1332),
    [anon_sym_DOT] = ACTIONS(7273),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1347),
  },
  [2722] = {
    [sym_formal_parameters] = STATE(3480),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2723] = {
    [sym_type_annotation] = STATE(323),
    [anon_sym_EQ_GT] = ACTIONS(7275),
    [anon_sym_COLON] = ACTIONS(550),
    [sym_comment] = ACTIONS(3),
  },
  [2724] = {
    [sym_type_annotation] = STATE(892),
    [anon_sym_EQ_GT] = ACTIONS(7278),
    [anon_sym_COLON] = ACTIONS(550),
    [sym_comment] = ACTIONS(3),
  },
  [2725] = {
    [sym_type_annotation] = STATE(892),
    [anon_sym_EQ_GT] = ACTIONS(7281),
    [anon_sym_COLON] = ACTIONS(550),
    [sym_comment] = ACTIONS(3),
  },
  [2726] = {
    [sym_jsx_text] = ACTIONS(5301),
    [anon_sym_LT] = ACTIONS(5301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5301),
  },
  [2727] = {
    [anon_sym_GT] = ACTIONS(7284),
    [sym_comment] = ACTIONS(3),
  },
  [2728] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7286),
    [anon_sym_LBRACK] = ACTIONS(7286),
    [anon_sym_BANG] = ACTIONS(7288),
    [anon_sym_SEMI] = ACTIONS(7286),
    [anon_sym_BQUOTE] = ACTIONS(7286),
    [sym__automatic_semicolon] = ACTIONS(7286),
    [anon_sym_PIPE] = ACTIONS(7288),
    [anon_sym_COMMA] = ACTIONS(7286),
    [anon_sym_LT_LT] = ACTIONS(7286),
    [anon_sym_STAR] = ACTIONS(7288),
    [anon_sym_GT_GT_GT] = ACTIONS(7286),
    [anon_sym_AMP_AMP] = ACTIONS(7286),
    [anon_sym_DASH] = ACTIONS(7288),
    [anon_sym_BANG_EQ] = ACTIONS(7288),
    [anon_sym_LT_EQ] = ACTIONS(7286),
    [anon_sym_LPAREN] = ACTIONS(7286),
    [anon_sym_GT_EQ] = ACTIONS(7286),
    [anon_sym_GT] = ACTIONS(7288),
    [anon_sym_AMP] = ACTIONS(7288),
    [anon_sym_PERCENT] = ACTIONS(7286),
    [anon_sym_QMARK] = ACTIONS(7286),
    [anon_sym_RBRACE] = ACTIONS(7286),
    [anon_sym_as] = ACTIONS(7286),
    [anon_sym_PIPE_PIPE] = ACTIONS(7286),
    [anon_sym_DASH_DASH] = ACTIONS(7286),
    [anon_sym_EQ_EQ] = ACTIONS(7288),
    [anon_sym_instanceof] = ACTIONS(7286),
    [anon_sym_LT] = ACTIONS(7288),
    [anon_sym_RPAREN] = ACTIONS(7286),
    [anon_sym_SLASH] = ACTIONS(7288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7286),
    [anon_sym_CARET] = ACTIONS(7286),
    [anon_sym_STAR_STAR] = ACTIONS(7286),
    [anon_sym_PLUS] = ACTIONS(7288),
    [anon_sym_GT_GT] = ACTIONS(7288),
    [anon_sym_PLUS_PLUS] = ACTIONS(7286),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7286),
    [anon_sym_in] = ACTIONS(7288),
  },
  [2729] = {
    [sym_new_expression] = STATE(3482),
    [sym_augmented_assignment_expression] = STATE(3482),
    [sym_unary_expression] = STATE(3482),
    [sym_update_expression] = STATE(3482),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(3482),
    [sym_regex] = STATE(3482),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1233),
    [sym__expression] = STATE(3482),
    [sym_non_null_expression] = STATE(3482),
    [sym_yield_expression] = STATE(3482),
    [sym_jsx_fragment] = STATE(3482),
    [sym_jsx_element] = STATE(3482),
    [sym_as_expression] = STATE(3482),
    [sym_internal_module] = STATE(3482),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3482),
    [sym_await_expression] = STATE(3482),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(3482),
    [sym_this] = STATE(3482),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(3482),
    [sym_generator_function] = STATE(3482),
    [sym_call_expression] = STATE(3482),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(3482),
    [sym_ternary_expression] = STATE(3482),
    [sym_binary_expression] = STATE(3482),
    [sym_template_string] = STATE(3482),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3482),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3482),
    [sym_class] = STATE(3482),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3842),
    [sym_false] = ACTIONS(7290),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7290),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7292),
    [sym_true] = ACTIONS(7290),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7290),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [2730] = {
    [sym_new_expression] = STATE(3483),
    [sym_augmented_assignment_expression] = STATE(3483),
    [sym_unary_expression] = STATE(3483),
    [sym_update_expression] = STATE(3483),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(3483),
    [sym_regex] = STATE(3483),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3483),
    [sym_non_null_expression] = STATE(3483),
    [sym_as_expression] = STATE(3483),
    [sym_jsx_fragment] = STATE(3483),
    [sym_yield_expression] = STATE(3483),
    [sym_jsx_element] = STATE(3483),
    [sym_internal_module] = STATE(3483),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3483),
    [sym_await_expression] = STATE(3483),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(3483),
    [sym_this] = STATE(3483),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(3483),
    [sym_generator_function] = STATE(3483),
    [sym_call_expression] = STATE(3483),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(3483),
    [sym_ternary_expression] = STATE(3483),
    [sym_binary_expression] = STATE(3483),
    [sym_template_string] = STATE(3483),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3483),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3483),
    [sym_class] = STATE(3483),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3842),
    [sym_false] = ACTIONS(7294),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7294),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7296),
    [sym_true] = ACTIONS(7294),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7294),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [2731] = {
    [sym_new_expression] = STATE(3484),
    [sym_augmented_assignment_expression] = STATE(3484),
    [sym_unary_expression] = STATE(3484),
    [sym_update_expression] = STATE(3484),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(3484),
    [sym_regex] = STATE(3484),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3484),
    [sym_non_null_expression] = STATE(3484),
    [sym_as_expression] = STATE(3484),
    [sym_jsx_fragment] = STATE(3484),
    [sym_yield_expression] = STATE(3484),
    [sym_jsx_element] = STATE(3484),
    [sym_internal_module] = STATE(3484),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3484),
    [sym_await_expression] = STATE(3484),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(3484),
    [sym_this] = STATE(3484),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(3484),
    [sym_generator_function] = STATE(3484),
    [sym_call_expression] = STATE(3484),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(3484),
    [sym_ternary_expression] = STATE(3484),
    [sym_binary_expression] = STATE(3484),
    [sym_template_string] = STATE(3484),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3484),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3484),
    [sym_class] = STATE(3484),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3842),
    [sym_false] = ACTIONS(7298),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7298),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7300),
    [sym_true] = ACTIONS(7298),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7298),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [2732] = {
    [sym_new_expression] = STATE(3485),
    [sym_augmented_assignment_expression] = STATE(3485),
    [sym_unary_expression] = STATE(3485),
    [sym_update_expression] = STATE(3485),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(3485),
    [sym_regex] = STATE(3485),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3485),
    [sym_non_null_expression] = STATE(3485),
    [sym_as_expression] = STATE(3485),
    [sym_jsx_fragment] = STATE(3485),
    [sym_yield_expression] = STATE(3485),
    [sym_jsx_element] = STATE(3485),
    [sym_internal_module] = STATE(3485),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3485),
    [sym_await_expression] = STATE(3485),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(3485),
    [sym_this] = STATE(3485),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(3485),
    [sym_generator_function] = STATE(3485),
    [sym_call_expression] = STATE(3485),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(3485),
    [sym_ternary_expression] = STATE(3485),
    [sym_binary_expression] = STATE(3485),
    [sym_template_string] = STATE(3485),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3485),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3485),
    [sym_class] = STATE(3485),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3842),
    [sym_false] = ACTIONS(7302),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7302),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7304),
    [sym_true] = ACTIONS(7302),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7302),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [2733] = {
    [sym_new_expression] = STATE(3486),
    [sym_augmented_assignment_expression] = STATE(3486),
    [sym_unary_expression] = STATE(3486),
    [sym_update_expression] = STATE(3486),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(3486),
    [sym_regex] = STATE(3486),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1240),
    [sym__expression] = STATE(3486),
    [sym_non_null_expression] = STATE(3486),
    [sym_yield_expression] = STATE(3486),
    [sym_jsx_fragment] = STATE(3486),
    [sym_jsx_element] = STATE(3486),
    [sym_as_expression] = STATE(3486),
    [sym_internal_module] = STATE(3486),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3486),
    [sym_await_expression] = STATE(3486),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(3486),
    [sym_this] = STATE(3486),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(3486),
    [sym_generator_function] = STATE(3486),
    [sym_call_expression] = STATE(3486),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(3486),
    [sym_ternary_expression] = STATE(3486),
    [sym_binary_expression] = STATE(3486),
    [sym_template_string] = STATE(3486),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3486),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3486),
    [sym_class] = STATE(3486),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3842),
    [sym_false] = ACTIONS(7306),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7306),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7308),
    [sym_true] = ACTIONS(7306),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7306),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [2734] = {
    [sym_new_expression] = STATE(3487),
    [sym_augmented_assignment_expression] = STATE(3487),
    [sym_unary_expression] = STATE(3487),
    [sym_update_expression] = STATE(3487),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(3487),
    [sym_regex] = STATE(3487),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3487),
    [sym_non_null_expression] = STATE(3487),
    [sym_as_expression] = STATE(3487),
    [sym_jsx_fragment] = STATE(3487),
    [sym_yield_expression] = STATE(3487),
    [sym_jsx_element] = STATE(3487),
    [sym_internal_module] = STATE(3487),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3487),
    [sym_await_expression] = STATE(3487),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(3487),
    [sym_this] = STATE(3487),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(3487),
    [sym_generator_function] = STATE(3487),
    [sym_call_expression] = STATE(3487),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(3487),
    [sym_ternary_expression] = STATE(3487),
    [sym_binary_expression] = STATE(3487),
    [sym_template_string] = STATE(3487),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3487),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3487),
    [sym_class] = STATE(3487),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3842),
    [sym_false] = ACTIONS(7310),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7310),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7312),
    [sym_true] = ACTIONS(7310),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7310),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [2735] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_RBRACE] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(7314),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [2736] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_RBRACE] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(7314),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [2737] = {
    [anon_sym_EQ_GT] = ACTIONS(7317),
    [sym_comment] = ACTIONS(3),
  },
  [2738] = {
    [anon_sym_EQ_GT] = ACTIONS(7319),
    [sym_comment] = ACTIONS(3),
  },
  [2739] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_BQUOTE] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_RBRACE] = ACTIONS(839),
    [anon_sym_AMP] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_as] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_instanceof] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_in] = ACTIONS(841),
  },
  [2740] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5792),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(5794),
    [anon_sym_LT_LT] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(5800),
    [anon_sym_GT_GT_GT] = ACTIONS(5796),
    [anon_sym_AMP_AMP] = ACTIONS(5802),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(5792),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_RBRACE] = ACTIONS(871),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_QMARK] = ACTIONS(5806),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [anon_sym_as] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_instanceof] = ACTIONS(5792),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(5808),
    [anon_sym_STAR_STAR] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5798),
    [anon_sym_GT_GT] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5792),
    [anon_sym_in] = ACTIONS(5752),
  },
  [2741] = {
    [sym__initializer] = STATE(522),
    [sym_arguments] = STATE(1268),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(5750),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1531),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_RBRACE] = ACTIONS(1529),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [2742] = {
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_RBRACE] = ACTIONS(1539),
    [anon_sym_as] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [2743] = {
    [sym_new_expression] = STATE(836),
    [sym_augmented_assignment_expression] = STATE(836),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(836),
    [sym_update_expression] = STATE(836),
    [sym_regex] = STATE(836),
    [sym_meta_property] = STATE(836),
    [sym_call_signature] = STATE(835),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(836),
    [sym_non_null_expression] = STATE(836),
    [sym_yield_expression] = STATE(836),
    [sym_jsx_fragment] = STATE(836),
    [sym_jsx_element] = STATE(836),
    [sym_as_expression] = STATE(836),
    [sym_internal_module] = STATE(836),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(836),
    [sym_await_expression] = STATE(836),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(836),
    [sym_this] = STATE(836),
    [sym_arguments] = STATE(1270),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(836),
    [sym_generator_function] = STATE(836),
    [sym_call_expression] = STATE(836),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(836),
    [sym_ternary_expression] = STATE(836),
    [sym_binary_expression] = STATE(836),
    [sym_template_string] = STATE(836),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(836),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(836),
    [sym_class] = STATE(836),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_RBRACE] = ACTIONS(1539),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(500),
    [sym_true] = ACTIONS(1545),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [sym_false] = ACTIONS(1545),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [sym_null] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [sym_number] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [2744] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_arguments] = STATE(1270),
    [sym_call_signature] = STATE(2737),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(5766),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(5768),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(5768),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(5768),
    [anon_sym_RBRACE] = ACTIONS(1539),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_protected] = ACTIONS(5768),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(5768),
    [anon_sym_type] = ACTIONS(5768),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(5768),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(5768),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(5768),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(5768),
    [anon_sym_declare] = ACTIONS(5768),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(5768),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(5768),
    [anon_sym_async] = ACTIONS(5768),
    [anon_sym_public] = ACTIONS(5768),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(5768),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(5768),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [2745] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_RBRACE] = ACTIONS(1539),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [2746] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5792),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(5794),
    [anon_sym_LT_LT] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(5800),
    [anon_sym_GT_GT_GT] = ACTIONS(5796),
    [anon_sym_AMP_AMP] = ACTIONS(5802),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(5792),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_RBRACE] = ACTIONS(915),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_QMARK] = ACTIONS(5806),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [anon_sym_as] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_instanceof] = ACTIONS(5792),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(5808),
    [anon_sym_STAR_STAR] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5798),
    [anon_sym_GT_GT] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5792),
    [anon_sym_in] = ACTIONS(5752),
  },
  [2747] = {
    [sym_new_expression] = STATE(3490),
    [sym_augmented_assignment_expression] = STATE(3490),
    [sym_unary_expression] = STATE(3490),
    [sym_update_expression] = STATE(3490),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(3490),
    [sym_regex] = STATE(3490),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3490),
    [sym_non_null_expression] = STATE(3490),
    [sym_as_expression] = STATE(3490),
    [sym_jsx_fragment] = STATE(3490),
    [sym_yield_expression] = STATE(3490),
    [sym_jsx_element] = STATE(3490),
    [sym_internal_module] = STATE(3490),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3490),
    [sym_await_expression] = STATE(3490),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(3490),
    [sym_this] = STATE(3490),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(3490),
    [sym_generator_function] = STATE(3490),
    [sym_call_expression] = STATE(3490),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(3490),
    [sym_ternary_expression] = STATE(3490),
    [sym_binary_expression] = STATE(3490),
    [sym_template_string] = STATE(3490),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3490),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3490),
    [sym_class] = STATE(3490),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3842),
    [sym_false] = ACTIONS(7321),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7321),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7323),
    [sym_true] = ACTIONS(7321),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7321),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [2748] = {
    [sym_new_expression] = STATE(3491),
    [sym_augmented_assignment_expression] = STATE(3491),
    [sym_unary_expression] = STATE(3491),
    [sym_update_expression] = STATE(3491),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(3491),
    [sym_regex] = STATE(3491),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3491),
    [sym_non_null_expression] = STATE(3491),
    [sym_as_expression] = STATE(3491),
    [sym_jsx_fragment] = STATE(3491),
    [sym_yield_expression] = STATE(3491),
    [sym_jsx_element] = STATE(3491),
    [sym_internal_module] = STATE(3491),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3491),
    [sym_await_expression] = STATE(3491),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(3491),
    [sym_this] = STATE(3491),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(3491),
    [sym_generator_function] = STATE(3491),
    [sym_call_expression] = STATE(3491),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(3491),
    [sym_ternary_expression] = STATE(3491),
    [sym_binary_expression] = STATE(3491),
    [sym_template_string] = STATE(3491),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3491),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3491),
    [sym_class] = STATE(3491),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3842),
    [sym_false] = ACTIONS(7325),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7325),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7327),
    [sym_true] = ACTIONS(7325),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7325),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [2749] = {
    [sym_new_expression] = STATE(3492),
    [sym_augmented_assignment_expression] = STATE(3492),
    [sym_unary_expression] = STATE(3492),
    [sym_update_expression] = STATE(3492),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(3492),
    [sym_regex] = STATE(3492),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3492),
    [sym_non_null_expression] = STATE(3492),
    [sym_as_expression] = STATE(3492),
    [sym_jsx_fragment] = STATE(3492),
    [sym_yield_expression] = STATE(3492),
    [sym_jsx_element] = STATE(3492),
    [sym_internal_module] = STATE(3492),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3492),
    [sym_await_expression] = STATE(3492),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(3492),
    [sym_this] = STATE(3492),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(3492),
    [sym_generator_function] = STATE(3492),
    [sym_call_expression] = STATE(3492),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(3492),
    [sym_ternary_expression] = STATE(3492),
    [sym_binary_expression] = STATE(3492),
    [sym_template_string] = STATE(3492),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3492),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3492),
    [sym_class] = STATE(3492),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3842),
    [sym_false] = ACTIONS(7329),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7329),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7331),
    [sym_true] = ACTIONS(7329),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7329),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [2750] = {
    [sym_new_expression] = STATE(3493),
    [sym_augmented_assignment_expression] = STATE(3493),
    [sym_unary_expression] = STATE(3493),
    [sym_update_expression] = STATE(3493),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(3493),
    [sym_regex] = STATE(3493),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3493),
    [sym_non_null_expression] = STATE(3493),
    [sym_as_expression] = STATE(3493),
    [sym_jsx_fragment] = STATE(3493),
    [sym_yield_expression] = STATE(3493),
    [sym_jsx_element] = STATE(3493),
    [sym_internal_module] = STATE(3493),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3493),
    [sym_await_expression] = STATE(3493),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(3493),
    [sym_this] = STATE(3493),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(3493),
    [sym_generator_function] = STATE(3493),
    [sym_call_expression] = STATE(3493),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(3493),
    [sym_ternary_expression] = STATE(3493),
    [sym_binary_expression] = STATE(3493),
    [sym_template_string] = STATE(3493),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3493),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3493),
    [sym_class] = STATE(3493),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3842),
    [sym_false] = ACTIONS(7333),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7333),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7335),
    [sym_true] = ACTIONS(7333),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7333),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [2751] = {
    [sym_new_expression] = STATE(3494),
    [sym_augmented_assignment_expression] = STATE(3494),
    [sym_unary_expression] = STATE(3494),
    [sym_update_expression] = STATE(3494),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(3494),
    [sym_regex] = STATE(3494),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3494),
    [sym_non_null_expression] = STATE(3494),
    [sym_as_expression] = STATE(3494),
    [sym_jsx_fragment] = STATE(3494),
    [sym_yield_expression] = STATE(3494),
    [sym_jsx_element] = STATE(3494),
    [sym_internal_module] = STATE(3494),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3494),
    [sym_await_expression] = STATE(3494),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(3494),
    [sym_this] = STATE(3494),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(3494),
    [sym_generator_function] = STATE(3494),
    [sym_call_expression] = STATE(3494),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(3494),
    [sym_ternary_expression] = STATE(3494),
    [sym_binary_expression] = STATE(3494),
    [sym_template_string] = STATE(3494),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3494),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3494),
    [sym_class] = STATE(3494),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(7337),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7337),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7339),
    [sym_true] = ACTIONS(7337),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7337),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [2752] = {
    [sym_union_type] = STATE(1293),
    [sym__type] = STATE(1293),
    [sym_constructor_type] = STATE(1293),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3500),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_template_string] = STATE(1297),
    [sym_intersection_type] = STATE(1293),
    [sym_function_type] = STATE(1293),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3501),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(7341),
    [sym_false] = ACTIONS(2643),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_PIPE] = ACTIONS(7343),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_boolean] = ACTIONS(2647),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(7345),
    [anon_sym_QMARK] = ACTIONS(7347),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2669),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_new] = ACTIONS(7349),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_DQUOTE] = ACTIONS(304),
  },
  [2753] = {
    [sym_new_expression] = STATE(3483),
    [sym_constructor_type] = STATE(432),
    [sym_augmented_assignment_expression] = STATE(3483),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(3483),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(3483),
    [sym_type_parameters] = STATE(959),
    [sym_array_type] = STATE(436),
    [sym_yield_expression] = STATE(3483),
    [sym_as_expression] = STATE(3483),
    [sym_jsx_fragment] = STATE(3483),
    [sym_internal_module] = STATE(3483),
    [sym_arrow_function] = STATE(3483),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(1841),
    [sym_literal_type] = STATE(436),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(1650),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(3483),
    [sym_subscript_expression] = STATE(1841),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(3483),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(3483),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(960),
    [sym_function_type] = STATE(432),
    [sym__type] = STATE(432),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(3483),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(3483),
    [sym__expression] = STATE(3483),
    [sym_non_null_expression] = STATE(3483),
    [sym_jsx_element] = STATE(3483),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_await_expression] = STATE(3483),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_this] = STATE(3483),
    [sym_union_type] = STATE(432),
    [sym_anonymous_class] = STATE(3483),
    [sym_call_expression] = STATE(3483),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(3483),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(3483),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(432),
    [sym_parenthesized_expression] = STATE(3483),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3483),
    [sym_class] = STATE(3483),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(7351),
    [sym_false] = ACTIONS(3450),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(7353),
    [anon_sym_number] = ACTIONS(7353),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(7355),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(7357),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_void] = ACTIONS(7359),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [sym_null] = ACTIONS(7294),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(7353),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(7353),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3462),
    [sym_true] = ACTIONS(3450),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(3464),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(7353),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7294),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(7361),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(7357),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [2754] = {
    [sym_new_expression] = STATE(3508),
    [sym_augmented_assignment_expression] = STATE(3508),
    [sym_unary_expression] = STATE(3508),
    [sym_update_expression] = STATE(3508),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(3508),
    [sym_regex] = STATE(3508),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3508),
    [sym_non_null_expression] = STATE(3508),
    [sym_as_expression] = STATE(3508),
    [sym_jsx_fragment] = STATE(3508),
    [sym_yield_expression] = STATE(3508),
    [sym_jsx_element] = STATE(3508),
    [sym_internal_module] = STATE(3508),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3508),
    [sym_await_expression] = STATE(3508),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(3508),
    [sym_this] = STATE(3508),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(3508),
    [sym_generator_function] = STATE(3508),
    [sym_call_expression] = STATE(3508),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(3508),
    [sym_ternary_expression] = STATE(3508),
    [sym_binary_expression] = STATE(3508),
    [sym_template_string] = STATE(3508),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3508),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3508),
    [sym_class] = STATE(3508),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3842),
    [sym_false] = ACTIONS(7363),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7363),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7365),
    [sym_true] = ACTIONS(7363),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7363),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [2755] = {
    [anon_sym_COLON] = ACTIONS(1513),
    [anon_sym_GT] = ACTIONS(7367),
    [anon_sym_DOT] = ACTIONS(5744),
    [sym_comment] = ACTIONS(3),
  },
  [2756] = {
    [anon_sym_COLON] = ACTIONS(1513),
    [anon_sym_GT] = ACTIONS(7367),
    [sym_comment] = ACTIONS(3),
  },
  [2757] = {
    [anon_sym_DOT] = ACTIONS(5744),
    [anon_sym_GT] = ACTIONS(7367),
    [sym_comment] = ACTIONS(3),
  },
  [2758] = {
    [anon_sym_GT] = ACTIONS(7367),
    [sym_comment] = ACTIONS(3),
  },
  [2759] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_BANG_EQ] = ACTIONS(2021),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2021),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_QMARK] = ACTIONS(2077),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2021),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2081),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2021),
  },
  [2760] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(5240),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_BANG_EQ] = ACTIONS(2021),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2021),
    [anon_sym_RBRACE] = ACTIONS(5240),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_QMARK] = ACTIONS(2077),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2021),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2081),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2021),
  },
  [2761] = {
    [sym_new_expression] = STATE(3510),
    [sym_augmented_assignment_expression] = STATE(3510),
    [sym_unary_expression] = STATE(3510),
    [sym_update_expression] = STATE(3510),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(3510),
    [sym_regex] = STATE(3510),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3510),
    [sym_non_null_expression] = STATE(3510),
    [sym_as_expression] = STATE(3510),
    [sym_jsx_fragment] = STATE(3510),
    [sym_yield_expression] = STATE(3510),
    [sym_jsx_element] = STATE(3510),
    [sym_internal_module] = STATE(3510),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3510),
    [sym_await_expression] = STATE(3510),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(3510),
    [sym_this] = STATE(3510),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(3510),
    [sym_generator_function] = STATE(3510),
    [sym_call_expression] = STATE(3510),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(3510),
    [sym_ternary_expression] = STATE(3510),
    [sym_binary_expression] = STATE(3510),
    [sym_template_string] = STATE(3510),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3510),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3510),
    [sym_class] = STATE(3510),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(7369),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7369),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7371),
    [sym_true] = ACTIONS(7369),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7369),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [2762] = {
    [sym_union_type] = STATE(3511),
    [sym__type] = STATE(3511),
    [sym_constructor_type] = STATE(3511),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1868),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3511),
    [sym_function_type] = STATE(3511),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1869),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3946),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3952),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2763] = {
    [sym_formal_parameters] = STATE(3512),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2764] = {
    [anon_sym_EQ_GT] = ACTIONS(7373),
    [sym_comment] = ACTIONS(3),
  },
  [2765] = {
    [sym_union_type] = STATE(3067),
    [sym__type] = STATE(3067),
    [sym_constructor_type] = STATE(3067),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1868),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3067),
    [sym_function_type] = STATE(3067),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1869),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3946),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3952),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2766] = {
    [sym_union_type] = STATE(3068),
    [sym__type] = STATE(3068),
    [sym_constructor_type] = STATE(3068),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1868),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3068),
    [sym_function_type] = STATE(3068),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1869),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3946),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3952),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2767] = {
    [anon_sym_EQ_GT] = ACTIONS(7375),
    [sym_comment] = ACTIONS(3),
  },
  [2768] = {
    [sym_union_type] = STATE(3515),
    [sym__type] = STATE(3515),
    [sym_constructor_type] = STATE(3515),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1868),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3515),
    [sym_function_type] = STATE(3515),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1869),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3946),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3952),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2769] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2015),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2015),
    [anon_sym_AMP_EQ] = ACTIONS(2015),
    [anon_sym_PLUS_EQ] = ACTIONS(2015),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(2017),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_CARET_EQ] = ACTIONS(2015),
    [anon_sym_STAR_EQ] = ACTIONS(2015),
    [anon_sym_PIPE_EQ] = ACTIONS(2015),
    [anon_sym_DASH_EQ] = ACTIONS(2015),
    [anon_sym_EQ_GT] = ACTIONS(2019),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2015),
    [anon_sym_GT_GT_EQ] = ACTIONS(2015),
    [anon_sym_DOT] = ACTIONS(6439),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2015),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2021),
  },
  [2770] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6061),
    [sym_identifier] = ACTIONS(6063),
    [anon_sym_BQUOTE] = ACTIONS(6061),
    [anon_sym_symbol] = ACTIONS(6063),
    [anon_sym_AT] = ACTIONS(6061),
    [anon_sym_PIPE] = ACTIONS(6063),
    [anon_sym_COMMA] = ACTIONS(6061),
    [anon_sym_DASH] = ACTIONS(6063),
    [anon_sym_STAR] = ACTIONS(6063),
    [anon_sym_GT_GT_GT] = ACTIONS(6061),
    [anon_sym_void] = ACTIONS(6063),
    [anon_sym_BANG_EQ] = ACTIONS(6063),
    [anon_sym_GT_EQ] = ACTIONS(6061),
    [anon_sym_private] = ACTIONS(6063),
    [anon_sym_get] = ACTIONS(6063),
    [anon_sym_RBRACE] = ACTIONS(6061),
    [anon_sym_PERCENT] = ACTIONS(6061),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6061),
    [anon_sym_as] = ACTIONS(6063),
    [anon_sym_DASH_DASH] = ACTIONS(6061),
    [anon_sym_instanceof] = ACTIONS(6063),
    [anon_sym_this] = ACTIONS(6063),
    [anon_sym_COLON] = ACTIONS(6061),
    [anon_sym_protected] = ACTIONS(6063),
    [anon_sym_DOT] = ACTIONS(6063),
    [anon_sym_set] = ACTIONS(6063),
    [anon_sym_type] = ACTIONS(6063),
    [anon_sym_STAR_STAR] = ACTIONS(6061),
    [anon_sym_import] = ACTIONS(6063),
    [sym_readonly] = ACTIONS(6063),
    [anon_sym_PLUS_PLUS] = ACTIONS(6061),
    [anon_sym_namespace] = ACTIONS(6063),
    [anon_sym_BANG] = ACTIONS(6063),
    [anon_sym_LBRACK] = ACTIONS(6061),
    [anon_sym_module] = ACTIONS(6063),
    [anon_sym_number] = ACTIONS(6063),
    [anon_sym_class] = ACTIONS(6063),
    [anon_sym_declare] = ACTIONS(6063),
    [anon_sym_LT_LT] = ACTIONS(6061),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6061),
    [anon_sym_LBRACE] = ACTIONS(6063),
    [anon_sym_AMP_AMP] = ACTIONS(6061),
    [anon_sym_LT_EQ] = ACTIONS(6061),
    [anon_sym_LPAREN] = ACTIONS(6061),
    [anon_sym_RBRACK] = ACTIONS(6061),
    [anon_sym_GT] = ACTIONS(6063),
    [anon_sym_any] = ACTIONS(6063),
    [anon_sym_boolean] = ACTIONS(6063),
    [anon_sym_async] = ACTIONS(6063),
    [anon_sym_public] = ACTIONS(6063),
    [anon_sym_AMP] = ACTIONS(6063),
    [anon_sym_QMARK] = ACTIONS(6061),
    [anon_sym_PIPE_PIPE] = ACTIONS(6061),
    [anon_sym_EQ_EQ] = ACTIONS(6063),
    [anon_sym_RPAREN] = ACTIONS(6061),
    [anon_sym_LT] = ACTIONS(6063),
    [anon_sym_SLASH] = ACTIONS(6063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6063),
    [anon_sym_CARET] = ACTIONS(6061),
    [anon_sym_PLUS] = ACTIONS(6063),
    [anon_sym_export] = ACTIONS(6063),
    [anon_sym_GT_GT] = ACTIONS(6063),
    [anon_sym_implements] = ACTIONS(6063),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6061),
    [anon_sym_in] = ACTIONS(6063),
  },
  [2771] = {
    [anon_sym_AMP] = ACTIONS(5881),
    [anon_sym_PIPE] = ACTIONS(5883),
    [anon_sym_RBRACK] = ACTIONS(7377),
    [sym_comment] = ACTIONS(3),
  },
  [2772] = {
    [aux_sym_implements_clause_repeat1] = STATE(3519),
    [anon_sym_GT] = ACTIONS(7379),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_COMMA] = ACTIONS(7381),
    [sym_comment] = ACTIONS(3),
  },
  [2773] = {
    [anon_sym_EQ] = ACTIONS(5891),
    [anon_sym_LBRACK] = ACTIONS(5891),
    [anon_sym_AMP] = ACTIONS(5891),
    [anon_sym_SEMI] = ACTIONS(5891),
    [anon_sym_DOT] = ACTIONS(4485),
    [sym__automatic_semicolon] = ACTIONS(5891),
    [anon_sym_RBRACE] = ACTIONS(5891),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5891),
    [anon_sym_LT] = ACTIONS(5891),
    [anon_sym_COMMA] = ACTIONS(5891),
    [anon_sym_PIPE] = ACTIONS(5889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5891),
  },
  [2774] = {
    [sym_union_type] = STATE(1892),
    [sym__type] = STATE(1892),
    [sym_constructor_type] = STATE(1892),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2778),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1892),
    [sym_function_type] = STATE(1892),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2779),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2135),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5845),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5847),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [2775] = {
    [sym_type_parameters] = STATE(3520),
    [sym_formal_parameters] = STATE(3521),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2776] = {
    [sym_union_type] = STATE(1900),
    [sym__type] = STATE(1900),
    [sym_constructor_type] = STATE(1900),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2778),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1900),
    [sym_function_type] = STATE(1900),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2779),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2135),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5845),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5847),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [2777] = {
    [anon_sym_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(7383),
    [anon_sym_SEMI] = ACTIONS(5893),
    [sym__automatic_semicolon] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(7385),
    [anon_sym_COMMA] = ACTIONS(5893),
    [sym_comment] = ACTIONS(3),
  },
  [2778] = {
    [sym_formal_parameters] = STATE(3524),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2779] = {
    [anon_sym_EQ_GT] = ACTIONS(7387),
    [sym_comment] = ACTIONS(3),
  },
  [2780] = {
    [aux_sym_object_type_repeat1] = STATE(3528),
    [sym__automatic_semicolon] = ACTIONS(7389),
    [anon_sym_RBRACE] = ACTIONS(7391),
    [anon_sym_SEMI] = ACTIONS(7389),
    [anon_sym_COMMA] = ACTIONS(7389),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7391),
    [sym_comment] = ACTIONS(3),
  },
  [2781] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(2866),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(2866),
    [sym_call_signature] = STATE(2866),
    [sym_export_statement] = STATE(2866),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(2866),
    [sym_index_signature] = STATE(2866),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_RBRACE] = ACTIONS(7391),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7391),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [2782] = {
    [anon_sym_EQ] = ACTIONS(5979),
    [anon_sym_LBRACK] = ACTIONS(5979),
    [anon_sym_AMP] = ACTIONS(5979),
    [anon_sym_SEMI] = ACTIONS(5979),
    [sym__automatic_semicolon] = ACTIONS(5979),
    [anon_sym_RBRACE] = ACTIONS(5979),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5979),
    [anon_sym_PIPE] = ACTIONS(5977),
    [anon_sym_COMMA] = ACTIONS(5979),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5979),
  },
  [2783] = {
    [aux_sym_object_type_repeat1] = STATE(2867),
    [sym__automatic_semicolon] = ACTIONS(7389),
    [anon_sym_RBRACE] = ACTIONS(7391),
    [anon_sym_SEMI] = ACTIONS(7389),
    [anon_sym_COMMA] = ACTIONS(7389),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7391),
    [sym_comment] = ACTIONS(3),
  },
  [2784] = {
    [anon_sym_EQ] = ACTIONS(5993),
    [anon_sym_LBRACK] = ACTIONS(5993),
    [anon_sym_AMP] = ACTIONS(5993),
    [anon_sym_SEMI] = ACTIONS(5993),
    [sym__automatic_semicolon] = ACTIONS(5993),
    [anon_sym_RBRACE] = ACTIONS(5993),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5993),
    [anon_sym_PIPE] = ACTIONS(5991),
    [anon_sym_COMMA] = ACTIONS(5993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5993),
  },
  [2785] = {
    [aux_sym_implements_clause_repeat1] = STATE(2879),
    [anon_sym_COMMA] = ACTIONS(4165),
    [anon_sym_RBRACK] = ACTIONS(7393),
    [sym_comment] = ACTIONS(3),
  },
  [2786] = {
    [sym_identifier] = ACTIONS(7395),
    [sym_comment] = ACTIONS(3),
  },
  [2787] = {
    [anon_sym_EQ_GT] = ACTIONS(7397),
    [sym_comment] = ACTIONS(3),
  },
  [2788] = {
    [sym_union_type] = STATE(3532),
    [sym__type] = STATE(3532),
    [sym_constructor_type] = STATE(3532),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1033),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(3532),
    [sym_function_type] = STATE(3532),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1036),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2135),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [2789] = {
    [anon_sym_EQ] = ACTIONS(6011),
    [anon_sym_LBRACK] = ACTIONS(6011),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_SEMI] = ACTIONS(6011),
    [sym__automatic_semicolon] = ACTIONS(6011),
    [anon_sym_RBRACE] = ACTIONS(6011),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6011),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_COMMA] = ACTIONS(6011),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6011),
  },
  [2790] = {
    [anon_sym_EQ] = ACTIONS(6017),
    [anon_sym_AMP] = ACTIONS(6017),
    [sym__automatic_semicolon] = ACTIONS(6017),
    [anon_sym_SEMI] = ACTIONS(6017),
    [anon_sym_LBRACK] = ACTIONS(6017),
    [anon_sym_RBRACE] = ACTIONS(6017),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6017),
    [anon_sym_PIPE] = ACTIONS(6015),
    [anon_sym_COMMA] = ACTIONS(6017),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6017),
  },
  [2791] = {
    [anon_sym_EQ] = ACTIONS(6021),
    [anon_sym_AMP] = ACTIONS(6021),
    [sym__automatic_semicolon] = ACTIONS(6021),
    [anon_sym_SEMI] = ACTIONS(6021),
    [anon_sym_LBRACK] = ACTIONS(6021),
    [anon_sym_RBRACE] = ACTIONS(6021),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6021),
    [anon_sym_PIPE] = ACTIONS(6019),
    [anon_sym_COMMA] = ACTIONS(6021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6021),
  },
  [2792] = {
    [anon_sym_AMP] = ACTIONS(5881),
    [anon_sym_PIPE] = ACTIONS(5883),
    [anon_sym_RBRACK] = ACTIONS(7399),
    [sym_comment] = ACTIONS(3),
  },
  [2793] = {
    [sym_union_type] = STATE(3534),
    [sym__type] = STATE(3534),
    [sym_constructor_type] = STATE(3534),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1033),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(3534),
    [sym_function_type] = STATE(3534),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1036),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2135),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [2794] = {
    [anon_sym_EQ] = ACTIONS(6038),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_AMP] = ACTIONS(6038),
    [anon_sym_SEMI] = ACTIONS(6038),
    [sym__automatic_semicolon] = ACTIONS(6038),
    [anon_sym_RBRACE] = ACTIONS(6038),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6038),
    [anon_sym_PIPE] = ACTIONS(6036),
    [anon_sym_COMMA] = ACTIONS(6038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6038),
  },
  [2795] = {
    [anon_sym_EQ] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(4001),
    [sym__automatic_semicolon] = ACTIONS(6040),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
  },
  [2796] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6775),
    [anon_sym_LBRACK] = ACTIONS(6775),
    [anon_sym_in] = ACTIONS(6777),
    [anon_sym_BQUOTE] = ACTIONS(6775),
    [anon_sym_PIPE] = ACTIONS(6777),
    [anon_sym_COMMA] = ACTIONS(6775),
    [anon_sym_DASH] = ACTIONS(6777),
    [anon_sym_STAR] = ACTIONS(6777),
    [anon_sym_GT_GT_GT] = ACTIONS(6775),
    [anon_sym_EQ] = ACTIONS(6777),
    [anon_sym_AMP_AMP] = ACTIONS(6775),
    [anon_sym_LT_LT] = ACTIONS(6775),
    [anon_sym_BANG_EQ] = ACTIONS(6777),
    [anon_sym_LT_EQ] = ACTIONS(6775),
    [anon_sym_LPAREN] = ACTIONS(6775),
    [anon_sym_RBRACK] = ACTIONS(6775),
    [anon_sym_GT_EQ] = ACTIONS(6775),
    [anon_sym_GT] = ACTIONS(6777),
    [anon_sym_LBRACE] = ACTIONS(6777),
    [anon_sym_of] = ACTIONS(6775),
    [anon_sym_AMP] = ACTIONS(6777),
    [anon_sym_PERCENT] = ACTIONS(6775),
    [anon_sym_QMARK] = ACTIONS(6775),
    [anon_sym_RBRACE] = ACTIONS(6775),
    [anon_sym_as] = ACTIONS(6775),
    [anon_sym_PIPE_PIPE] = ACTIONS(6775),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6775),
    [anon_sym_DASH_DASH] = ACTIONS(6775),
    [anon_sym_EQ_EQ] = ACTIONS(6777),
    [anon_sym_instanceof] = ACTIONS(6775),
    [anon_sym_LT] = ACTIONS(6777),
    [anon_sym_RPAREN] = ACTIONS(6775),
    [anon_sym_SLASH] = ACTIONS(6777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6775),
    [anon_sym_DOT] = ACTIONS(6775),
    [anon_sym_CARET] = ACTIONS(6775),
    [anon_sym_STAR_STAR] = ACTIONS(6775),
    [anon_sym_PLUS] = ACTIONS(6777),
    [anon_sym_implements] = ACTIONS(6775),
    [anon_sym_GT_GT] = ACTIONS(6777),
    [anon_sym_PLUS_PLUS] = ACTIONS(6775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6775),
    [anon_sym_BANG] = ACTIONS(6777),
  },
  [2797] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2801),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2802),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2183),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5869),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5871),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2798] = {
    [sym_type_parameters] = STATE(3535),
    [sym_formal_parameters] = STATE(3536),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2799] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2801),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2802),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2183),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5869),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5871),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2800] = {
    [anon_sym_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(7401),
    [anon_sym_PIPE] = ACTIONS(7403),
    [sym_comment] = ACTIONS(3),
  },
  [2801] = {
    [sym_formal_parameters] = STATE(3539),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2802] = {
    [anon_sym_EQ_GT] = ACTIONS(7405),
    [sym_comment] = ACTIONS(3),
  },
  [2803] = {
    [anon_sym_EQ_GT] = ACTIONS(7407),
    [sym_comment] = ACTIONS(3),
  },
  [2804] = {
    [sym_union_type] = STATE(3542),
    [sym__type] = STATE(3542),
    [sym_constructor_type] = STATE(3542),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1055),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3542),
    [sym_function_type] = STATE(3542),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1056),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2183),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2805] = {
    [sym_union_type] = STATE(3543),
    [sym__type] = STATE(3543),
    [sym_constructor_type] = STATE(3543),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1055),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3543),
    [sym_function_type] = STATE(3543),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1056),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2183),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2806] = {
    [anon_sym_EQ] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4037),
    [sym_comment] = ACTIONS(3),
  },
  [2807] = {
    [sym_union_type] = STATE(3547),
    [sym__type] = STATE(3547),
    [sym_constructor_type] = STATE(3547),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3548),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3547),
    [sym_function_type] = STATE(3547),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3549),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(7409),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(7411),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(7413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2808] = {
    [sym_formal_parameters] = STATE(3550),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2809] = {
    [anon_sym_EQ_GT] = ACTIONS(7415),
    [sym_comment] = ACTIONS(3),
  },
  [2810] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1926),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1927),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4057),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2811] = {
    [sym_identifier] = ACTIONS(7417),
    [anon_sym_BQUOTE] = ACTIONS(7419),
    [anon_sym_debugger] = ACTIONS(7417),
    [anon_sym_symbol] = ACTIONS(7417),
    [anon_sym_AT] = ACTIONS(7419),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_COMMA] = ACTIONS(7419),
    [anon_sym_DASH] = ACTIONS(7417),
    [anon_sym_EQ] = ACTIONS(7417),
    [anon_sym_void] = ACTIONS(7417),
    [anon_sym_break] = ACTIONS(7417),
    [anon_sym_const] = ACTIONS(7417),
    [sym_super] = ACTIONS(7417),
    [anon_sym_return] = ACTIONS(7417),
    [anon_sym_private] = ACTIONS(7417),
    [anon_sym_get] = ACTIONS(7417),
    [anon_sym_RBRACE] = ACTIONS(7419),
    [anon_sym_interface] = ACTIONS(7417),
    [anon_sym_default] = ACTIONS(7417),
    [anon_sym_enum] = ACTIONS(7417),
    [anon_sym_delete] = ACTIONS(7417),
    [anon_sym_continue] = ACTIONS(7417),
    [anon_sym_DASH_DASH] = ACTIONS(7419),
    [anon_sym_if] = ACTIONS(7417),
    [anon_sym_this] = ACTIONS(7417),
    [anon_sym_yield] = ACTIONS(7417),
    [sym_true] = ACTIONS(7417),
    [anon_sym_throw] = ACTIONS(7417),
    [anon_sym_protected] = ACTIONS(7417),
    [anon_sym_abstract] = ACTIONS(7417),
    [anon_sym_set] = ACTIONS(7417),
    [anon_sym_type] = ACTIONS(7417),
    [anon_sym_import] = ACTIONS(7417),
    [anon_sym_namespace] = ACTIONS(7417),
    [anon_sym_PLUS_PLUS] = ACTIONS(7419),
    [anon_sym_await] = ACTIONS(7417),
    [anon_sym_DQUOTE] = ACTIONS(7419),
    [anon_sym_else] = ACTIONS(7417),
    [anon_sym_BANG] = ACTIONS(7419),
    [anon_sym_for] = ACTIONS(7417),
    [anon_sym_LBRACK] = ACTIONS(7419),
    [sym_false] = ACTIONS(7417),
    [anon_sym_SEMI] = ACTIONS(7419),
    [anon_sym_case] = ACTIONS(7417),
    [anon_sym_module] = ACTIONS(7417),
    [anon_sym_number] = ACTIONS(7417),
    [anon_sym_class] = ACTIONS(7417),
    [anon_sym_declare] = ACTIONS(7417),
    [anon_sym_typeof] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(7419),
    [anon_sym_switch] = ACTIONS(7417),
    [anon_sym_LPAREN] = ACTIONS(7419),
    [anon_sym_RBRACK] = ACTIONS(7419),
    [sym_null] = ACTIONS(7417),
    [anon_sym_GT] = ACTIONS(7419),
    [anon_sym_any] = ACTIONS(7417),
    [anon_sym_boolean] = ACTIONS(7417),
    [anon_sym_async] = ACTIONS(7417),
    [anon_sym_public] = ACTIONS(7417),
    [anon_sym_EQ_GT] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_var] = ACTIONS(7417),
    [anon_sym_while] = ACTIONS(7417),
    [anon_sym_SQUOTE] = ACTIONS(7419),
    [anon_sym_try] = ACTIONS(7417),
    [anon_sym_RPAREN] = ACTIONS(7419),
    [anon_sym_LT] = ACTIONS(7419),
    [sym_number] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7417),
    [anon_sym_function] = ACTIONS(7417),
    [sym_undefined] = ACTIONS(7417),
    [anon_sym_new] = ACTIONS(7417),
    [ts_builtin_sym_end] = ACTIONS(7419),
    [anon_sym_let] = ACTIONS(7417),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_export] = ACTIONS(7417),
    [anon_sym_do] = ACTIONS(7417),
    [anon_sym_TILDE] = ACTIONS(7419),
    [anon_sym_with] = ACTIONS(7417),
  },
  [2812] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1926),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1927),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4057),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2813] = {
    [anon_sym_EQ_GT] = ACTIONS(7421),
    [sym_comment] = ACTIONS(3),
  },
  [2814] = {
    [sym_union_type] = STATE(3553),
    [sym__type] = STATE(3553),
    [sym_constructor_type] = STATE(3553),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1926),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3553),
    [sym_function_type] = STATE(3553),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1927),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4057),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2815] = {
    [sym_formal_parameters] = STATE(3554),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2816] = {
    [anon_sym_EQ_GT] = ACTIONS(7423),
    [sym_comment] = ACTIONS(3),
  },
  [2817] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1933),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1934),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4065),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4067),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2818] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1933),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1934),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4065),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4067),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2819] = {
    [anon_sym_EQ_GT] = ACTIONS(7425),
    [sym_comment] = ACTIONS(3),
  },
  [2820] = {
    [sym_union_type] = STATE(3557),
    [sym__type] = STATE(3557),
    [sym_constructor_type] = STATE(3557),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1933),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3557),
    [sym_function_type] = STATE(3557),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1934),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4065),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4067),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2821] = {
    [sym_predefined_type] = STATE(3558),
    [anon_sym_number] = ACTIONS(6513),
    [anon_sym_void] = ACTIONS(6513),
    [anon_sym_string] = ACTIONS(6513),
    [anon_sym_any] = ACTIONS(6513),
    [anon_sym_boolean] = ACTIONS(6513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_symbol] = ACTIONS(6513),
  },
  [2822] = {
    [sym_predefined_type] = STATE(3559),
    [anon_sym_number] = ACTIONS(6513),
    [anon_sym_void] = ACTIONS(6513),
    [anon_sym_string] = ACTIONS(6513),
    [anon_sym_any] = ACTIONS(6513),
    [anon_sym_boolean] = ACTIONS(6513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_symbol] = ACTIONS(6513),
  },
  [2823] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(2866),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(2866),
    [sym_call_signature] = STATE(2866),
    [sym_export_statement] = STATE(2866),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(2866),
    [sym_index_signature] = STATE(2866),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_RBRACE] = ACTIONS(7427),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7427),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [2824] = {
    [sym_identifier] = ACTIONS(7429),
    [anon_sym_BQUOTE] = ACTIONS(7431),
    [anon_sym_debugger] = ACTIONS(7429),
    [anon_sym_symbol] = ACTIONS(7429),
    [anon_sym_AT] = ACTIONS(7431),
    [anon_sym_PIPE] = ACTIONS(7431),
    [anon_sym_COMMA] = ACTIONS(7431),
    [anon_sym_DASH] = ACTIONS(7429),
    [anon_sym_EQ] = ACTIONS(7429),
    [anon_sym_void] = ACTIONS(7429),
    [anon_sym_break] = ACTIONS(7429),
    [anon_sym_const] = ACTIONS(7429),
    [sym_super] = ACTIONS(7429),
    [anon_sym_return] = ACTIONS(7429),
    [anon_sym_private] = ACTIONS(7429),
    [anon_sym_get] = ACTIONS(7429),
    [anon_sym_RBRACE] = ACTIONS(7431),
    [anon_sym_interface] = ACTIONS(7429),
    [anon_sym_default] = ACTIONS(7429),
    [anon_sym_enum] = ACTIONS(7429),
    [anon_sym_delete] = ACTIONS(7429),
    [anon_sym_continue] = ACTIONS(7429),
    [anon_sym_DASH_DASH] = ACTIONS(7431),
    [anon_sym_if] = ACTIONS(7429),
    [anon_sym_this] = ACTIONS(7429),
    [anon_sym_yield] = ACTIONS(7429),
    [sym_true] = ACTIONS(7429),
    [anon_sym_throw] = ACTIONS(7429),
    [anon_sym_protected] = ACTIONS(7429),
    [anon_sym_abstract] = ACTIONS(7429),
    [anon_sym_set] = ACTIONS(7429),
    [anon_sym_type] = ACTIONS(7429),
    [anon_sym_import] = ACTIONS(7429),
    [anon_sym_namespace] = ACTIONS(7429),
    [anon_sym_PLUS_PLUS] = ACTIONS(7431),
    [anon_sym_await] = ACTIONS(7429),
    [anon_sym_DQUOTE] = ACTIONS(7431),
    [anon_sym_else] = ACTIONS(7429),
    [anon_sym_BANG] = ACTIONS(7431),
    [anon_sym_for] = ACTIONS(7429),
    [anon_sym_LBRACK] = ACTIONS(7431),
    [sym_false] = ACTIONS(7429),
    [anon_sym_SEMI] = ACTIONS(7431),
    [anon_sym_case] = ACTIONS(7429),
    [anon_sym_module] = ACTIONS(7429),
    [anon_sym_number] = ACTIONS(7429),
    [anon_sym_class] = ACTIONS(7429),
    [anon_sym_declare] = ACTIONS(7429),
    [anon_sym_typeof] = ACTIONS(7429),
    [anon_sym_LBRACE] = ACTIONS(7431),
    [anon_sym_switch] = ACTIONS(7429),
    [anon_sym_LPAREN] = ACTIONS(7431),
    [anon_sym_RBRACK] = ACTIONS(7431),
    [sym_null] = ACTIONS(7429),
    [anon_sym_GT] = ACTIONS(7431),
    [anon_sym_any] = ACTIONS(7429),
    [anon_sym_boolean] = ACTIONS(7429),
    [anon_sym_async] = ACTIONS(7429),
    [anon_sym_public] = ACTIONS(7429),
    [anon_sym_EQ_GT] = ACTIONS(7431),
    [anon_sym_AMP] = ACTIONS(7431),
    [anon_sym_var] = ACTIONS(7429),
    [anon_sym_while] = ACTIONS(7429),
    [anon_sym_SQUOTE] = ACTIONS(7431),
    [anon_sym_try] = ACTIONS(7429),
    [anon_sym_RPAREN] = ACTIONS(7431),
    [anon_sym_LT] = ACTIONS(7431),
    [sym_number] = ACTIONS(7431),
    [anon_sym_SLASH] = ACTIONS(7429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7429),
    [anon_sym_function] = ACTIONS(7429),
    [sym_undefined] = ACTIONS(7429),
    [anon_sym_new] = ACTIONS(7429),
    [ts_builtin_sym_end] = ACTIONS(7431),
    [anon_sym_let] = ACTIONS(7429),
    [anon_sym_PLUS] = ACTIONS(7429),
    [anon_sym_export] = ACTIONS(7429),
    [anon_sym_do] = ACTIONS(7429),
    [anon_sym_TILDE] = ACTIONS(7431),
    [anon_sym_with] = ACTIONS(7429),
  },
  [2825] = {
    [aux_sym_object_type_repeat1] = STATE(2867),
    [sym__automatic_semicolon] = ACTIONS(7433),
    [anon_sym_RBRACE] = ACTIONS(7427),
    [anon_sym_SEMI] = ACTIONS(7433),
    [anon_sym_COMMA] = ACTIONS(7433),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7427),
    [sym_comment] = ACTIONS(3),
  },
  [2826] = {
    [sym_type_parameters] = STATE(1082),
    [sym_formal_parameters] = STATE(1081),
    [sym_call_signature] = STATE(3562),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2827] = {
    [sym__automatic_semicolon] = ACTIONS(6576),
    [anon_sym_RBRACE] = ACTIONS(6576),
    [anon_sym_SEMI] = ACTIONS(6576),
    [anon_sym_COMMA] = ACTIONS(6576),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6576),
    [sym_comment] = ACTIONS(3),
  },
  [2828] = {
    [sym_type_parameters] = STATE(1082),
    [sym_formal_parameters] = STATE(1081),
    [sym_call_signature] = STATE(3562),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(7435),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [2829] = {
    [sym_string] = STATE(3564),
    [sym__property_name] = STATE(3564),
    [sym_computed_property_name] = STATE(3564),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(7437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [2830] = {
    [sym_string] = STATE(3564),
    [sym__property_name] = STATE(3564),
    [sym_computed_property_name] = STATE(3564),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(7437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [2831] = {
    [sym_string] = STATE(3564),
    [sym__property_name] = STATE(3564),
    [sym_computed_property_name] = STATE(3564),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(7439),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(7441),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(7437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(7441),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [2832] = {
    [sym_type_parameters] = STATE(1082),
    [sym_type_annotation] = STATE(3568),
    [sym_formal_parameters] = STATE(1081),
    [sym_call_signature] = STATE(3562),
    [sym__automatic_semicolon] = ACTIONS(7443),
    [anon_sym_RBRACE] = ACTIONS(7443),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(7443),
    [anon_sym_QMARK] = ACTIONS(7445),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7443),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(7443),
    [sym_comment] = ACTIONS(3),
  },
  [2833] = {
    [sym_string] = STATE(3564),
    [sym__property_name] = STATE(3564),
    [sym_computed_property_name] = STATE(3564),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(7437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [2834] = {
    [sym_type_parameters] = STATE(1082),
    [sym_type_annotation] = STATE(3568),
    [sym_formal_parameters] = STATE(1081),
    [sym_call_signature] = STATE(3562),
    [sym__automatic_semicolon] = ACTIONS(7443),
    [anon_sym_RBRACE] = ACTIONS(7443),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(7443),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7443),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(7443),
    [sym_comment] = ACTIONS(3),
  },
  [2835] = {
    [sym__automatic_semicolon] = ACTIONS(7443),
    [anon_sym_RBRACE] = ACTIONS(7443),
    [anon_sym_SEMI] = ACTIONS(7443),
    [anon_sym_COMMA] = ACTIONS(7443),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7443),
    [sym_comment] = ACTIONS(3),
  },
  [2836] = {
    [sym_type_annotation] = STATE(3569),
    [sym__automatic_semicolon] = ACTIONS(7447),
    [anon_sym_RBRACE] = ACTIONS(7447),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(7447),
    [anon_sym_COMMA] = ACTIONS(7447),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7447),
    [sym_comment] = ACTIONS(3),
  },
  [2837] = {
    [sym__automatic_semicolon] = ACTIONS(7447),
    [anon_sym_RBRACE] = ACTIONS(7447),
    [anon_sym_SEMI] = ACTIONS(7447),
    [anon_sym_COMMA] = ACTIONS(7447),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7447),
    [sym_comment] = ACTIONS(3),
  },
  [2838] = {
    [aux_sym_variable_declaration_repeat1] = STATE(3571),
    [sym__automatic_semicolon] = ACTIONS(7449),
    [anon_sym_SEMI] = ACTIONS(7449),
    [anon_sym_COMMA] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
  },
  [2839] = {
    [sym_type_parameters] = STATE(3572),
    [sym_object_type] = STATE(3573),
    [sym_extends_clause] = STATE(3574),
    [anon_sym_extends] = ACTIONS(829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1921),
  },
  [2840] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym__automatic_semicolon] = ACTIONS(7451),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(7451),
    [anon_sym_in] = ACTIONS(3491),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_LT_LT] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_GT_GT_GT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_BANG_EQ] = ACTIONS(3491),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3545),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(3491),
    [anon_sym_instanceof] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3547),
    [anon_sym_STAR_STAR] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_BANG] = ACTIONS(582),
  },
  [2841] = {
    [sym_enum_body] = STATE(3577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7453),
  },
  [2842] = {
    [sym__automatic_semicolon] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1089),
    [sym_comment] = ACTIONS(3),
  },
  [2843] = {
    [sym_identifier] = ACTIONS(7455),
    [sym_comment] = ACTIONS(3),
  },
  [2844] = {
    [sym_string] = STATE(129),
    [sym_nested_identifier] = STATE(127),
    [sym__module] = STATE(2842),
    [sym_identifier] = ACTIONS(5937),
    [anon_sym_DOT] = ACTIONS(7457),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(87),
  },
  [2845] = {
    [sym_statement_block] = STATE(3580),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(909),
  },
  [2846] = {
    [sym__automatic_semicolon] = ACTIONS(1193),
    [anon_sym_RBRACE] = ACTIONS(1193),
    [anon_sym_SEMI] = ACTIONS(1193),
    [anon_sym_COMMA] = ACTIONS(1193),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1193),
    [sym_comment] = ACTIONS(3),
  },
  [2847] = {
    [sym__automatic_semicolon] = ACTIONS(7451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(7451),
  },
  [2848] = {
    [sym_type_parameters] = STATE(815),
    [sym_formal_parameters] = STATE(816),
    [sym_call_signature] = STATE(3581),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2849] = {
    [sym_identifier] = ACTIONS(7459),
    [sym_comment] = ACTIONS(3),
  },
  [2850] = {
    [aux_sym_variable_declaration_repeat1] = STATE(3584),
    [sym__automatic_semicolon] = ACTIONS(7461),
    [anon_sym_SEMI] = ACTIONS(7461),
    [anon_sym_COMMA] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
  },
  [2851] = {
    [sym_identifier] = ACTIONS(7463),
    [sym_comment] = ACTIONS(3),
  },
  [2852] = {
    [sym_type_parameters] = STATE(3587),
    [anon_sym_EQ] = ACTIONS(7465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2853] = {
    [anon_sym_EQ] = ACTIONS(7467),
    [sym_comment] = ACTIONS(3),
  },
  [2854] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(784),
    [sym_identifier] = ACTIONS(7469),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2855] = {
    [sym_identifier] = ACTIONS(7471),
    [sym_comment] = ACTIONS(3),
  },
  [2856] = {
    [sym__automatic_semicolon] = ACTIONS(3559),
    [anon_sym_RBRACE] = ACTIONS(3559),
    [anon_sym_SEMI] = ACTIONS(3559),
    [anon_sym_COMMA] = ACTIONS(3559),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3559),
    [sym_comment] = ACTIONS(3),
  },
  [2857] = {
    [sym_new_expression] = STATE(3590),
    [sym_augmented_assignment_expression] = STATE(3590),
    [sym_unary_expression] = STATE(3590),
    [sym_update_expression] = STATE(3590),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(3590),
    [sym_regex] = STATE(3590),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3590),
    [sym_non_null_expression] = STATE(3590),
    [sym_as_expression] = STATE(3590),
    [sym_jsx_fragment] = STATE(3590),
    [sym_yield_expression] = STATE(3590),
    [sym_jsx_element] = STATE(3590),
    [sym_internal_module] = STATE(3590),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3590),
    [sym_await_expression] = STATE(3590),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(3590),
    [sym_this] = STATE(3590),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(3590),
    [sym_generator_function] = STATE(3590),
    [sym_call_expression] = STATE(3590),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(3590),
    [sym_ternary_expression] = STATE(3590),
    [sym_binary_expression] = STATE(3590),
    [sym_template_string] = STATE(3590),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3590),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3590),
    [sym_class] = STATE(3590),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(7473),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7473),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7475),
    [sym_true] = ACTIONS(7473),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7473),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [2858] = {
    [sym_type_arguments] = STATE(1885),
    [sym__automatic_semicolon] = ACTIONS(2204),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(3983),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(3985),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(7477),
  },
  [2859] = {
    [sym_index_type_query] = STATE(1887),
    [sym_lookup_type] = STATE(1887),
    [sym_flow_maybe_type] = STATE(1887),
    [sym_parenthesized_type] = STATE(1887),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_array_type] = STATE(1887),
    [sym_type_predicate] = STATE(1887),
    [sym_type_query] = STATE(1887),
    [sym_existential_type] = STATE(1887),
    [sym_this_type] = STATE(1887),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1887),
    [sym__primary_type] = STATE(1887),
    [sym_generic_type] = STATE(1887),
    [sym_literal_type] = STATE(1887),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1887),
    [sym_string] = STATE(1017),
    [sym_tuple_type] = STATE(1887),
    [sym_identifier] = ACTIONS(5967),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [sym_true] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_LPAREN] = ACTIONS(3989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [2860] = {
    [sym_union_type] = STATE(1892),
    [sym__type] = STATE(1892),
    [sym_constructor_type] = STATE(1892),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2864),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1892),
    [sym_function_type] = STATE(1892),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2865),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5967),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5971),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5973),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [2861] = {
    [sym_type_parameters] = STATE(3592),
    [sym_formal_parameters] = STATE(3593),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2862] = {
    [sym_union_type] = STATE(1900),
    [sym__type] = STATE(1900),
    [sym_constructor_type] = STATE(1900),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2864),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1900),
    [sym_function_type] = STATE(1900),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2865),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5967),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5971),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5973),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [2863] = {
    [sym__automatic_semicolon] = ACTIONS(3611),
    [anon_sym_RBRACE] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(7479),
    [anon_sym_SEMI] = ACTIONS(3611),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3611),
    [anon_sym_PIPE] = ACTIONS(7481),
    [anon_sym_COMMA] = ACTIONS(3611),
    [sym_comment] = ACTIONS(3),
  },
  [2864] = {
    [sym_formal_parameters] = STATE(3596),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2865] = {
    [anon_sym_EQ_GT] = ACTIONS(7483),
    [sym_comment] = ACTIONS(3),
  },
  [2866] = {
    [sym__automatic_semicolon] = ACTIONS(7485),
    [anon_sym_RBRACE] = ACTIONS(7485),
    [anon_sym_SEMI] = ACTIONS(7485),
    [anon_sym_COMMA] = ACTIONS(7485),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7485),
    [sym_comment] = ACTIONS(3),
  },
  [2867] = {
    [aux_sym_object_type_repeat1] = STATE(2867),
    [sym__automatic_semicolon] = ACTIONS(7487),
    [anon_sym_RBRACE] = ACTIONS(7485),
    [anon_sym_SEMI] = ACTIONS(7487),
    [anon_sym_COMMA] = ACTIONS(7487),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7485),
    [sym_comment] = ACTIONS(3),
  },
  [2868] = {
    [sym_string] = STATE(3601),
    [sym__property_name] = STATE(3601),
    [sym_computed_property_name] = STATE(3601),
    [anon_sym_get] = ACTIONS(7490),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(7492),
    [anon_sym_STAR] = ACTIONS(7439),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(7490),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_async] = ACTIONS(7494),
  },
  [2869] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2873),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2874),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5983),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5985),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2870] = {
    [sym_type_parameters] = STATE(3602),
    [sym_formal_parameters] = STATE(3603),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2871] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2873),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2874),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5983),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5985),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2872] = {
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_COMMA] = ACTIONS(5893),
    [anon_sym_RBRACK] = ACTIONS(5893),
    [sym_comment] = ACTIONS(3),
  },
  [2873] = {
    [sym_formal_parameters] = STATE(3606),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2874] = {
    [anon_sym_EQ_GT] = ACTIONS(7500),
    [sym_comment] = ACTIONS(3),
  },
  [2875] = {
    [anon_sym_EQ_GT] = ACTIONS(7502),
    [sym_comment] = ACTIONS(3),
  },
  [2876] = {
    [sym_union_type] = STATE(3609),
    [sym__type] = STATE(3609),
    [sym_constructor_type] = STATE(3609),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1089),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3609),
    [sym_function_type] = STATE(3609),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1090),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2877] = {
    [anon_sym_AMP] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_COMMA] = ACTIONS(6027),
    [anon_sym_RBRACK] = ACTIONS(6027),
    [sym_comment] = ACTIONS(3),
  },
  [2878] = {
    [sym_identifier] = ACTIONS(7504),
    [anon_sym_BQUOTE] = ACTIONS(7506),
    [anon_sym_debugger] = ACTIONS(7504),
    [anon_sym_symbol] = ACTIONS(7504),
    [anon_sym_AT] = ACTIONS(7506),
    [anon_sym_PIPE] = ACTIONS(7506),
    [anon_sym_COMMA] = ACTIONS(7506),
    [anon_sym_DASH] = ACTIONS(7504),
    [anon_sym_EQ] = ACTIONS(7504),
    [anon_sym_void] = ACTIONS(7504),
    [anon_sym_break] = ACTIONS(7504),
    [anon_sym_const] = ACTIONS(7504),
    [sym_super] = ACTIONS(7504),
    [anon_sym_return] = ACTIONS(7504),
    [anon_sym_private] = ACTIONS(7504),
    [anon_sym_get] = ACTIONS(7504),
    [anon_sym_RBRACE] = ACTIONS(7506),
    [anon_sym_interface] = ACTIONS(7504),
    [anon_sym_default] = ACTIONS(7504),
    [anon_sym_enum] = ACTIONS(7504),
    [anon_sym_delete] = ACTIONS(7504),
    [anon_sym_continue] = ACTIONS(7504),
    [anon_sym_DASH_DASH] = ACTIONS(7506),
    [anon_sym_if] = ACTIONS(7504),
    [anon_sym_this] = ACTIONS(7504),
    [anon_sym_yield] = ACTIONS(7504),
    [sym_true] = ACTIONS(7504),
    [anon_sym_throw] = ACTIONS(7504),
    [anon_sym_protected] = ACTIONS(7504),
    [anon_sym_abstract] = ACTIONS(7504),
    [anon_sym_set] = ACTIONS(7504),
    [anon_sym_type] = ACTIONS(7504),
    [anon_sym_import] = ACTIONS(7504),
    [anon_sym_namespace] = ACTIONS(7504),
    [anon_sym_PLUS_PLUS] = ACTIONS(7506),
    [anon_sym_await] = ACTIONS(7504),
    [anon_sym_DQUOTE] = ACTIONS(7506),
    [anon_sym_else] = ACTIONS(7504),
    [anon_sym_BANG] = ACTIONS(7506),
    [anon_sym_for] = ACTIONS(7504),
    [anon_sym_LBRACK] = ACTIONS(7506),
    [sym_false] = ACTIONS(7504),
    [anon_sym_SEMI] = ACTIONS(7506),
    [anon_sym_case] = ACTIONS(7504),
    [anon_sym_module] = ACTIONS(7504),
    [anon_sym_number] = ACTIONS(7504),
    [anon_sym_class] = ACTIONS(7504),
    [anon_sym_declare] = ACTIONS(7504),
    [anon_sym_typeof] = ACTIONS(7504),
    [anon_sym_LBRACE] = ACTIONS(7506),
    [anon_sym_switch] = ACTIONS(7504),
    [anon_sym_LPAREN] = ACTIONS(7506),
    [anon_sym_RBRACK] = ACTIONS(7506),
    [sym_null] = ACTIONS(7504),
    [anon_sym_GT] = ACTIONS(7506),
    [anon_sym_any] = ACTIONS(7504),
    [anon_sym_boolean] = ACTIONS(7504),
    [anon_sym_async] = ACTIONS(7504),
    [anon_sym_public] = ACTIONS(7504),
    [anon_sym_EQ_GT] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_var] = ACTIONS(7504),
    [anon_sym_while] = ACTIONS(7504),
    [anon_sym_SQUOTE] = ACTIONS(7506),
    [anon_sym_try] = ACTIONS(7504),
    [anon_sym_RPAREN] = ACTIONS(7506),
    [anon_sym_LT] = ACTIONS(7506),
    [sym_number] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7504),
    [anon_sym_function] = ACTIONS(7504),
    [sym_undefined] = ACTIONS(7504),
    [anon_sym_new] = ACTIONS(7504),
    [ts_builtin_sym_end] = ACTIONS(7506),
    [anon_sym_let] = ACTIONS(7504),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_export] = ACTIONS(7504),
    [anon_sym_do] = ACTIONS(7504),
    [anon_sym_TILDE] = ACTIONS(7506),
    [anon_sym_with] = ACTIONS(7504),
  },
  [2879] = {
    [aux_sym_implements_clause_repeat1] = STATE(2879),
    [anon_sym_COMMA] = ACTIONS(7508),
    [anon_sym_RBRACK] = ACTIONS(6027),
    [sym_comment] = ACTIONS(3),
  },
  [2880] = {
    [sym_union_type] = STATE(3610),
    [sym__type] = STATE(3610),
    [sym_constructor_type] = STATE(3610),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1089),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3610),
    [sym_function_type] = STATE(3610),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1090),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2881] = {
    [anon_sym_AMP] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_RBRACK] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
  },
  [2882] = {
    [sym_union_type] = STATE(3611),
    [sym__type] = STATE(3611),
    [sym_constructor_type] = STATE(3611),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3611),
    [sym_function_type] = STATE(3611),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2883] = {
    [anon_sym_GT] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_COMMA] = ACTIONS(7511),
    [sym_comment] = ACTIONS(3),
  },
  [2884] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2888),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2889),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6001),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6003),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6005),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2885] = {
    [sym_type_parameters] = STATE(3612),
    [sym_formal_parameters] = STATE(3613),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2886] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2888),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2889),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6001),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6003),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6005),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2887] = {
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_RPAREN] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(7513),
    [anon_sym_PIPE] = ACTIONS(7515),
    [sym_comment] = ACTIONS(3),
  },
  [2888] = {
    [sym_formal_parameters] = STATE(3616),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2889] = {
    [anon_sym_EQ_GT] = ACTIONS(7517),
    [sym_comment] = ACTIONS(3),
  },
  [2890] = {
    [anon_sym_EQ_GT] = ACTIONS(7519),
    [sym_comment] = ACTIONS(3),
  },
  [2891] = {
    [sym_union_type] = STATE(3619),
    [sym__type] = STATE(3619),
    [sym_constructor_type] = STATE(3619),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1108),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3619),
    [sym_function_type] = STATE(3619),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1109),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2282),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2892] = {
    [sym_union_type] = STATE(3620),
    [sym__type] = STATE(3620),
    [sym_constructor_type] = STATE(3620),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1108),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3620),
    [sym_function_type] = STATE(3620),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1109),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2282),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2893] = {
    [anon_sym_AMP] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(4221),
    [sym_comment] = ACTIONS(3),
  },
  [2894] = {
    [anon_sym_EQ_GT] = ACTIONS(7521),
    [sym_identifier] = ACTIONS(7523),
    [anon_sym_LBRACK] = ACTIONS(7521),
    [anon_sym_BQUOTE] = ACTIONS(7521),
    [anon_sym_AMP] = ACTIONS(7521),
    [anon_sym_LBRACE_PIPE] = ACTIONS(7521),
    [anon_sym_while] = ACTIONS(7523),
    [anon_sym_RPAREN] = ACTIONS(7521),
    [anon_sym_PIPE] = ACTIONS(7521),
    [anon_sym_COMMA] = ACTIONS(7521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7523),
    [anon_sym_EQ] = ACTIONS(7523),
    [anon_sym_LPAREN] = ACTIONS(7521),
    [anon_sym_RBRACK] = ACTIONS(7521),
    [sym_jsx_identifier] = ACTIONS(7521),
    [anon_sym_GT] = ACTIONS(7521),
  },
  [2895] = {
    [sym_union_type] = STATE(2014),
    [sym__type] = STATE(2014),
    [sym_constructor_type] = STATE(2014),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2014),
    [sym_function_type] = STATE(2014),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [2896] = {
    [sym_identifier] = ACTIONS(7525),
    [anon_sym_BQUOTE] = ACTIONS(7527),
    [anon_sym_debugger] = ACTIONS(7525),
    [anon_sym_symbol] = ACTIONS(7525),
    [anon_sym_AT] = ACTIONS(7527),
    [anon_sym_PIPE] = ACTIONS(7527),
    [anon_sym_COMMA] = ACTIONS(7527),
    [anon_sym_DASH] = ACTIONS(7525),
    [anon_sym_EQ] = ACTIONS(7525),
    [anon_sym_void] = ACTIONS(7525),
    [anon_sym_break] = ACTIONS(7525),
    [anon_sym_const] = ACTIONS(7525),
    [sym_super] = ACTIONS(7525),
    [anon_sym_return] = ACTIONS(7525),
    [anon_sym_private] = ACTIONS(7525),
    [anon_sym_get] = ACTIONS(7525),
    [anon_sym_RBRACE] = ACTIONS(7527),
    [anon_sym_interface] = ACTIONS(7525),
    [anon_sym_default] = ACTIONS(7525),
    [anon_sym_enum] = ACTIONS(7525),
    [anon_sym_delete] = ACTIONS(7525),
    [anon_sym_continue] = ACTIONS(7525),
    [anon_sym_DASH_DASH] = ACTIONS(7527),
    [anon_sym_if] = ACTIONS(7525),
    [anon_sym_this] = ACTIONS(7525),
    [anon_sym_yield] = ACTIONS(7525),
    [sym_true] = ACTIONS(7525),
    [anon_sym_throw] = ACTIONS(7525),
    [anon_sym_protected] = ACTIONS(7525),
    [anon_sym_abstract] = ACTIONS(7525),
    [anon_sym_set] = ACTIONS(7525),
    [anon_sym_type] = ACTIONS(7525),
    [anon_sym_import] = ACTIONS(7525),
    [anon_sym_namespace] = ACTIONS(7525),
    [anon_sym_PLUS_PLUS] = ACTIONS(7527),
    [anon_sym_await] = ACTIONS(7525),
    [anon_sym_DQUOTE] = ACTIONS(7527),
    [anon_sym_else] = ACTIONS(7525),
    [anon_sym_BANG] = ACTIONS(7527),
    [anon_sym_for] = ACTIONS(7525),
    [anon_sym_LBRACK] = ACTIONS(7527),
    [sym_false] = ACTIONS(7525),
    [anon_sym_SEMI] = ACTIONS(7527),
    [anon_sym_case] = ACTIONS(7525),
    [anon_sym_module] = ACTIONS(7525),
    [anon_sym_number] = ACTIONS(7525),
    [anon_sym_class] = ACTIONS(7525),
    [anon_sym_declare] = ACTIONS(7525),
    [anon_sym_typeof] = ACTIONS(7525),
    [anon_sym_LBRACE] = ACTIONS(7527),
    [anon_sym_switch] = ACTIONS(7525),
    [anon_sym_LPAREN] = ACTIONS(7527),
    [anon_sym_RBRACK] = ACTIONS(7527),
    [sym_null] = ACTIONS(7525),
    [anon_sym_GT] = ACTIONS(7527),
    [anon_sym_any] = ACTIONS(7525),
    [anon_sym_boolean] = ACTIONS(7525),
    [anon_sym_async] = ACTIONS(7525),
    [anon_sym_public] = ACTIONS(7525),
    [anon_sym_EQ_GT] = ACTIONS(7527),
    [anon_sym_AMP] = ACTIONS(7527),
    [anon_sym_var] = ACTIONS(7525),
    [anon_sym_while] = ACTIONS(7525),
    [anon_sym_SQUOTE] = ACTIONS(7527),
    [anon_sym_try] = ACTIONS(7525),
    [anon_sym_RPAREN] = ACTIONS(7527),
    [anon_sym_LT] = ACTIONS(7527),
    [sym_number] = ACTIONS(7527),
    [anon_sym_SLASH] = ACTIONS(7525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7525),
    [anon_sym_function] = ACTIONS(7525),
    [sym_undefined] = ACTIONS(7525),
    [anon_sym_new] = ACTIONS(7525),
    [ts_builtin_sym_end] = ACTIONS(7527),
    [anon_sym_let] = ACTIONS(7525),
    [anon_sym_PLUS] = ACTIONS(7525),
    [anon_sym_export] = ACTIONS(7525),
    [anon_sym_do] = ACTIONS(7525),
    [anon_sym_TILDE] = ACTIONS(7527),
    [anon_sym_with] = ACTIONS(7525),
  },
  [2897] = {
    [anon_sym_GT] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_COMMA] = ACTIONS(7529),
    [sym_comment] = ACTIONS(3),
  },
  [2898] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_RPAREN] = ACTIONS(5236),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_in] = ACTIONS(2311),
  },
  [2899] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(5240),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_RPAREN] = ACTIONS(5240),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_in] = ACTIONS(2311),
  },
  [2900] = {
    [sym_new_expression] = STATE(3621),
    [sym_augmented_assignment_expression] = STATE(3621),
    [sym_unary_expression] = STATE(3621),
    [sym_update_expression] = STATE(3621),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(3621),
    [sym_regex] = STATE(3621),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3621),
    [sym_non_null_expression] = STATE(3621),
    [sym_as_expression] = STATE(3621),
    [sym_jsx_fragment] = STATE(3621),
    [sym_yield_expression] = STATE(3621),
    [sym_jsx_element] = STATE(3621),
    [sym_internal_module] = STATE(3621),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3621),
    [sym_await_expression] = STATE(3621),
    [sym_member_expression] = STATE(454),
    [sym_string] = STATE(3621),
    [sym_this] = STATE(3621),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(3621),
    [sym_generator_function] = STATE(3621),
    [sym_call_expression] = STATE(3621),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(3621),
    [sym_ternary_expression] = STATE(3621),
    [sym_binary_expression] = STATE(3621),
    [sym_template_string] = STATE(3621),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3621),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3621),
    [sym_class] = STATE(3621),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(7531),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7531),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7533),
    [sym_true] = ACTIONS(7531),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7531),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [2901] = {
    [sym_union_type] = STATE(3622),
    [sym__type] = STATE(3622),
    [sym_constructor_type] = STATE(3622),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2038),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3622),
    [sym_function_type] = STATE(3622),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2039),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(4292),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(4298),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(4296),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(4300),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(4294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2902] = {
    [sym_formal_parameters] = STATE(3623),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2903] = {
    [anon_sym_EQ_GT] = ACTIONS(7535),
    [sym_comment] = ACTIONS(3),
  },
  [2904] = {
    [sym_union_type] = STATE(3067),
    [sym__type] = STATE(3067),
    [sym_constructor_type] = STATE(3067),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2038),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3067),
    [sym_function_type] = STATE(3067),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2039),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(4292),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(4298),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(4296),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(4300),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(4294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2905] = {
    [sym_union_type] = STATE(3068),
    [sym__type] = STATE(3068),
    [sym_constructor_type] = STATE(3068),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2038),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3068),
    [sym_function_type] = STATE(3068),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2039),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(4292),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(4298),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(4296),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(4300),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(4294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2906] = {
    [anon_sym_EQ_GT] = ACTIONS(7537),
    [sym_comment] = ACTIONS(3),
  },
  [2907] = {
    [sym_union_type] = STATE(3626),
    [sym__type] = STATE(3626),
    [sym_constructor_type] = STATE(3626),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2038),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3626),
    [sym_function_type] = STATE(3626),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2039),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(4292),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(4298),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(4296),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(4300),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(4294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2908] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2307),
    [anon_sym_AMP_EQ] = ACTIONS(2307),
    [anon_sym_PLUS_EQ] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1440),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_CARET_EQ] = ACTIONS(2307),
    [anon_sym_STAR_EQ] = ACTIONS(2307),
    [anon_sym_PIPE_EQ] = ACTIONS(2307),
    [anon_sym_DASH_EQ] = ACTIONS(2307),
    [anon_sym_EQ_GT] = ACTIONS(2309),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2307),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT_EQ] = ACTIONS(2307),
    [anon_sym_DOT] = ACTIONS(6439),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2311),
  },
  [2909] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4379),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4381),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_STAR] = ACTIONS(4393),
    [anon_sym_LBRACE] = ACTIONS(1997),
    [anon_sym_AMP_AMP] = ACTIONS(4391),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4379),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(4379),
    [anon_sym_GT] = ACTIONS(4335),
    [anon_sym_AMP] = ACTIONS(4395),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1995),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_PIPE_PIPE] = ACTIONS(4399),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_instanceof] = ACTIONS(4379),
    [anon_sym_LT] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4399),
    [anon_sym_STAR_STAR] = ACTIONS(4405),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_GT_GT] = ACTIONS(4393),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4379),
    [anon_sym_in] = ACTIONS(4335),
  },
  [2910] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_STAR] = ACTIONS(4393),
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(4405),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_GT_GT] = ACTIONS(4393),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2911] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4379),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4381),
    [anon_sym_COMMA] = ACTIONS(2003),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_STAR] = ACTIONS(4393),
    [anon_sym_LBRACE] = ACTIONS(7539),
    [anon_sym_AMP_AMP] = ACTIONS(4391),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4379),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(4379),
    [anon_sym_GT] = ACTIONS(4335),
    [anon_sym_AMP] = ACTIONS(4395),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2003),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_PIPE_PIPE] = ACTIONS(4399),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_instanceof] = ACTIONS(4379),
    [anon_sym_LT] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4399),
    [anon_sym_STAR_STAR] = ACTIONS(4405),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_GT_GT] = ACTIONS(4393),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4379),
    [anon_sym_in] = ACTIONS(4335),
  },
  [2912] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4379),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4381),
    [anon_sym_COMMA] = ACTIONS(2005),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_STAR] = ACTIONS(4393),
    [anon_sym_LBRACE] = ACTIONS(7541),
    [anon_sym_AMP_AMP] = ACTIONS(4391),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4379),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(4379),
    [anon_sym_GT] = ACTIONS(4335),
    [anon_sym_AMP] = ACTIONS(4395),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2005),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_PIPE_PIPE] = ACTIONS(4399),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_instanceof] = ACTIONS(4379),
    [anon_sym_LT] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4399),
    [anon_sym_STAR_STAR] = ACTIONS(4405),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_GT_GT] = ACTIONS(4393),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4379),
    [anon_sym_in] = ACTIONS(4335),
  },
  [2913] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4379),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4381),
    [anon_sym_COMMA] = ACTIONS(2101),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_STAR] = ACTIONS(4393),
    [anon_sym_LBRACE] = ACTIONS(2103),
    [anon_sym_AMP_AMP] = ACTIONS(4391),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4379),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(4379),
    [anon_sym_GT] = ACTIONS(4335),
    [anon_sym_AMP] = ACTIONS(4395),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2101),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_PIPE_PIPE] = ACTIONS(4399),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_instanceof] = ACTIONS(4379),
    [anon_sym_LT] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4399),
    [anon_sym_STAR_STAR] = ACTIONS(4405),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_GT_GT] = ACTIONS(4393),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4379),
    [anon_sym_in] = ACTIONS(4335),
  },
  [2914] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4379),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4381),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_STAR] = ACTIONS(4393),
    [anon_sym_LBRACE] = ACTIONS(7543),
    [anon_sym_AMP_AMP] = ACTIONS(4391),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4379),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(4379),
    [anon_sym_GT] = ACTIONS(4335),
    [anon_sym_AMP] = ACTIONS(4395),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2105),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_PIPE_PIPE] = ACTIONS(4399),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_instanceof] = ACTIONS(4379),
    [anon_sym_LT] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4399),
    [anon_sym_STAR_STAR] = ACTIONS(4405),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_GT_GT] = ACTIONS(4393),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4379),
    [anon_sym_in] = ACTIONS(4335),
  },
  [2915] = {
    [sym_new_expression] = STATE(3627),
    [sym_augmented_assignment_expression] = STATE(3627),
    [sym_unary_expression] = STATE(3627),
    [sym_update_expression] = STATE(3627),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(3627),
    [sym_regex] = STATE(3627),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2185),
    [sym__expression] = STATE(3627),
    [sym_non_null_expression] = STATE(3627),
    [sym_yield_expression] = STATE(3627),
    [sym_jsx_fragment] = STATE(3627),
    [sym_jsx_element] = STATE(3627),
    [sym_as_expression] = STATE(3627),
    [sym_internal_module] = STATE(3627),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3627),
    [sym_await_expression] = STATE(3627),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(3627),
    [sym_this] = STATE(3627),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(3627),
    [sym_generator_function] = STATE(3627),
    [sym_call_expression] = STATE(3627),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(3627),
    [sym_ternary_expression] = STATE(3627),
    [sym_binary_expression] = STATE(3627),
    [sym_template_string] = STATE(3627),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3627),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3627),
    [sym_class] = STATE(3627),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(4341),
    [sym_false] = ACTIONS(7545),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7545),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7547),
    [sym_true] = ACTIONS(7545),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7545),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [2916] = {
    [sym_new_expression] = STATE(3628),
    [sym_augmented_assignment_expression] = STATE(3628),
    [sym_unary_expression] = STATE(3628),
    [sym_update_expression] = STATE(3628),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(3628),
    [sym_regex] = STATE(3628),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2187),
    [sym__expression] = STATE(3628),
    [sym_non_null_expression] = STATE(3628),
    [sym_yield_expression] = STATE(3628),
    [sym_jsx_fragment] = STATE(3628),
    [sym_jsx_element] = STATE(3628),
    [sym_as_expression] = STATE(3628),
    [sym_internal_module] = STATE(3628),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3628),
    [sym_await_expression] = STATE(3628),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(3628),
    [sym_this] = STATE(3628),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(3628),
    [sym_generator_function] = STATE(3628),
    [sym_call_expression] = STATE(3628),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(3628),
    [sym_ternary_expression] = STATE(3628),
    [sym_binary_expression] = STATE(3628),
    [sym_template_string] = STATE(3628),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3628),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3628),
    [sym_class] = STATE(3628),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(4341),
    [sym_false] = ACTIONS(7549),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7549),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7551),
    [sym_true] = ACTIONS(7549),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7549),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [2917] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4379),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_STAR] = ACTIONS(4393),
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_AMP_AMP] = ACTIONS(4391),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4379),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(4379),
    [anon_sym_GT] = ACTIONS(4335),
    [anon_sym_AMP] = ACTIONS(4395),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_instanceof] = ACTIONS(4379),
    [anon_sym_LT] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(4405),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_GT_GT] = ACTIONS(4393),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4379),
    [anon_sym_in] = ACTIONS(4335),
  },
  [2918] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4379),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(4335),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4381),
    [anon_sym_COMMA] = ACTIONS(6464),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_STAR] = ACTIONS(4393),
    [anon_sym_LBRACE] = ACTIONS(6466),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4391),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4379),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(4379),
    [anon_sym_GT] = ACTIONS(4335),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6464),
    [anon_sym_AMP] = ACTIONS(4395),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_PIPE_PIPE] = ACTIONS(4399),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_instanceof] = ACTIONS(4379),
    [anon_sym_LT] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4399),
    [anon_sym_STAR_STAR] = ACTIONS(4405),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_GT_GT] = ACTIONS(4393),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4379),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [2919] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_STAR] = ACTIONS(4393),
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(7553),
    [anon_sym_SLASH] = ACTIONS(4393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(4405),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(4393),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2920] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(7553),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(4405),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2921] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4379),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_STAR] = ACTIONS(4393),
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4379),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(4379),
    [anon_sym_GT] = ACTIONS(4335),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_instanceof] = ACTIONS(4379),
    [anon_sym_LT] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(4405),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_GT_GT] = ACTIONS(4393),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4379),
    [anon_sym_in] = ACTIONS(4335),
  },
  [2922] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3630),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7556),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [2923] = {
    [sym_type_arguments] = STATE(2206),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(4638),
    [anon_sym_BANG] = ACTIONS(3699),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3699),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_GT_GT_GT] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(7558),
    [anon_sym_GT] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_instanceof] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(4643),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4646),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_STAR_STAR] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2204),
    [anon_sym_in] = ACTIONS(3699),
  },
  [2924] = {
    [sym_index_type_query] = STATE(2208),
    [sym_lookup_type] = STATE(2208),
    [sym_flow_maybe_type] = STATE(2208),
    [sym_parenthesized_type] = STATE(2208),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_array_type] = STATE(2208),
    [sym_type_predicate] = STATE(2208),
    [sym_type_query] = STATE(2208),
    [sym_existential_type] = STATE(2208),
    [sym_this_type] = STATE(2208),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(2208),
    [sym__primary_type] = STATE(2208),
    [sym_generic_type] = STATE(2208),
    [sym_literal_type] = STATE(2208),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(2208),
    [sym_string] = STATE(1279),
    [sym_tuple_type] = STATE(2208),
    [sym_identifier] = ACTIONS(6124),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(6130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [sym_true] = ACTIONS(2643),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(4648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2925] = {
    [sym_union_type] = STATE(2213),
    [sym__type] = STATE(2213),
    [sym_constructor_type] = STATE(2213),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2928),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2213),
    [sym_function_type] = STATE(2213),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2929),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(6124),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(6130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(6128),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(6132),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(6126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2926] = {
    [sym_type_parameters] = STATE(3631),
    [sym_formal_parameters] = STATE(3632),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2927] = {
    [sym_union_type] = STATE(2221),
    [sym__type] = STATE(2221),
    [sym_constructor_type] = STATE(2221),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2928),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2221),
    [sym_function_type] = STATE(2221),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2929),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(6124),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(6130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(6128),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(6132),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(6126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [2928] = {
    [sym_formal_parameters] = STATE(3635),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2929] = {
    [anon_sym_EQ_GT] = ACTIONS(7560),
    [sym_comment] = ACTIONS(3),
  },
  [2930] = {
    [sym__initializer] = STATE(522),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4327),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4327),
    [anon_sym_AMP_EQ] = ACTIONS(4327),
    [anon_sym_PLUS_EQ] = ACTIONS(4327),
    [anon_sym_PIPE] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_is] = ACTIONS(2208),
    [anon_sym_GT] = ACTIONS(3738),
    [anon_sym_EQ] = ACTIONS(4331),
    [anon_sym_CARET_EQ] = ACTIONS(4327),
    [anon_sym_STAR_EQ] = ACTIONS(4327),
    [anon_sym_PIPE_EQ] = ACTIONS(4327),
    [anon_sym_DASH_EQ] = ACTIONS(4327),
    [anon_sym_EQ_GT] = ACTIONS(4333),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4327),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4327),
    [anon_sym_GT_GT_EQ] = ACTIONS(4327),
    [anon_sym_DOT] = ACTIONS(4670),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4327),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4335),
  },
  [2931] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4337),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4337),
    [anon_sym_AMP_EQ] = ACTIONS(4337),
    [anon_sym_PLUS_EQ] = ACTIONS(4337),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_CARET_EQ] = ACTIONS(4337),
    [anon_sym_STAR_EQ] = ACTIONS(4337),
    [anon_sym_PIPE_EQ] = ACTIONS(4337),
    [anon_sym_DASH_EQ] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4339),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4337),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4337),
    [anon_sym_GT_GT_EQ] = ACTIONS(4337),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4337),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2932] = {
    [sym_new_expression] = STATE(2055),
    [sym_augmented_assignment_expression] = STATE(2055),
    [sym_unary_expression] = STATE(2055),
    [sym_update_expression] = STATE(2055),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(2055),
    [sym_regex] = STATE(2055),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2055),
    [sym_non_null_expression] = STATE(2055),
    [sym_as_expression] = STATE(2055),
    [sym_jsx_fragment] = STATE(2055),
    [sym_yield_expression] = STATE(2055),
    [sym_jsx_element] = STATE(2055),
    [sym_internal_module] = STATE(2055),
    [sym_nested_identifier] = STATE(1092),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2055),
    [sym_await_expression] = STATE(2055),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(2055),
    [sym_this] = STATE(2055),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(2055),
    [sym_generator_function] = STATE(2055),
    [sym_call_expression] = STATE(2055),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2055),
    [sym_ternary_expression] = STATE(2055),
    [sym_binary_expression] = STATE(2055),
    [sym_template_string] = STATE(2055),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2055),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2055),
    [sym_class] = STATE(2055),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(7562),
    [sym_false] = ACTIONS(4343),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4343),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4345),
    [sym_true] = ACTIONS(4343),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4343),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [2933] = {
    [sym_new_expression] = STATE(2056),
    [sym_augmented_assignment_expression] = STATE(2056),
    [sym_unary_expression] = STATE(2056),
    [sym_update_expression] = STATE(2056),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(2056),
    [sym_regex] = STATE(2056),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2056),
    [sym_non_null_expression] = STATE(2056),
    [sym_as_expression] = STATE(2056),
    [sym_jsx_fragment] = STATE(2056),
    [sym_yield_expression] = STATE(2056),
    [sym_jsx_element] = STATE(2056),
    [sym_internal_module] = STATE(2056),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2056),
    [sym_await_expression] = STATE(2056),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(2056),
    [sym_this] = STATE(2056),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(2056),
    [sym_generator_function] = STATE(2056),
    [sym_call_expression] = STATE(2056),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2056),
    [sym_ternary_expression] = STATE(2056),
    [sym_binary_expression] = STATE(2056),
    [sym_template_string] = STATE(2056),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2056),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2056),
    [sym_class] = STATE(2056),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(4341),
    [sym_false] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4347),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4674),
    [sym_true] = ACTIONS(4347),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4347),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [2934] = {
    [sym_new_expression] = STATE(2055),
    [sym_augmented_assignment_expression] = STATE(2055),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(2055),
    [sym_update_expression] = STATE(2055),
    [sym_regex] = STATE(2055),
    [sym_meta_property] = STATE(2055),
    [sym_call_signature] = STATE(1162),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2055),
    [sym_non_null_expression] = STATE(2055),
    [sym_yield_expression] = STATE(2055),
    [sym_jsx_fragment] = STATE(2055),
    [sym_jsx_element] = STATE(2055),
    [sym_as_expression] = STATE(2055),
    [sym_internal_module] = STATE(2055),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2055),
    [sym_await_expression] = STATE(2055),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(2055),
    [sym_this] = STATE(2055),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(2055),
    [sym_generator_function] = STATE(2055),
    [sym_call_expression] = STATE(2055),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(2055),
    [sym_ternary_expression] = STATE(2055),
    [sym_binary_expression] = STATE(2055),
    [sym_template_string] = STATE(2055),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2055),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2055),
    [sym_class] = STATE(2055),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4341),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4337),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_AMP_EQ] = ACTIONS(4337),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4337),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4331),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(4337),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_PIPE_EQ] = ACTIONS(4337),
    [anon_sym_DASH_EQ] = ACTIONS(4337),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_LBRACE_PIPE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(2417),
    [sym_true] = ACTIONS(4343),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_GT_GT_EQ] = ACTIONS(4337),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4337),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(2405),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(4343),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4337),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(4351),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_STAR_EQ] = ACTIONS(4337),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_EQ_GT] = ACTIONS(4339),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(4345),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4337),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4343),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [2935] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(1819),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(1820),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(4365),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(4367),
    [anon_sym_symbol] = ACTIONS(4367),
    [anon_sym_number] = ACTIONS(4367),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4367),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4369),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4367),
    [anon_sym_private] = ACTIONS(4367),
    [anon_sym_boolean] = ACTIONS(4367),
    [anon_sym_async] = ACTIONS(4371),
    [anon_sym_public] = ACTIONS(4367),
    [anon_sym_get] = ACTIONS(4367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4367),
    [anon_sym_string] = ACTIONS(4367),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(4367),
    [anon_sym_type] = ACTIONS(4367),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(4367),
    [anon_sym_export] = ACTIONS(4367),
    [anon_sym_namespace] = ACTIONS(4373),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [2936] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(7553),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [2937] = {
    [aux_sym_extends_clause_repeat1] = STATE(2937),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6464),
    [anon_sym_COMMA] = ACTIONS(7564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6466),
  },
  [2938] = {
    [sym_identifier] = ACTIONS(7567),
    [anon_sym_BQUOTE] = ACTIONS(7569),
    [anon_sym_debugger] = ACTIONS(7567),
    [anon_sym_symbol] = ACTIONS(7567),
    [anon_sym_AT] = ACTIONS(7569),
    [anon_sym_DASH] = ACTIONS(7567),
    [anon_sym_void] = ACTIONS(7567),
    [anon_sym_break] = ACTIONS(7567),
    [anon_sym_const] = ACTIONS(7567),
    [sym_super] = ACTIONS(7567),
    [anon_sym_return] = ACTIONS(7567),
    [anon_sym_private] = ACTIONS(7567),
    [anon_sym_get] = ACTIONS(7567),
    [anon_sym_RBRACE] = ACTIONS(7569),
    [anon_sym_interface] = ACTIONS(7567),
    [anon_sym_default] = ACTIONS(7567),
    [anon_sym_enum] = ACTIONS(7567),
    [anon_sym_delete] = ACTIONS(7567),
    [anon_sym_continue] = ACTIONS(7567),
    [anon_sym_DASH_DASH] = ACTIONS(7569),
    [anon_sym_if] = ACTIONS(7567),
    [anon_sym_this] = ACTIONS(7567),
    [anon_sym_yield] = ACTIONS(7567),
    [sym_true] = ACTIONS(7567),
    [anon_sym_throw] = ACTIONS(7567),
    [anon_sym_protected] = ACTIONS(7567),
    [anon_sym_abstract] = ACTIONS(7567),
    [anon_sym_set] = ACTIONS(7567),
    [anon_sym_type] = ACTIONS(7567),
    [anon_sym_import] = ACTIONS(7567),
    [anon_sym_namespace] = ACTIONS(7567),
    [anon_sym_PLUS_PLUS] = ACTIONS(7569),
    [anon_sym_await] = ACTIONS(7567),
    [anon_sym_DQUOTE] = ACTIONS(7569),
    [anon_sym_else] = ACTIONS(7567),
    [anon_sym_BANG] = ACTIONS(7569),
    [anon_sym_for] = ACTIONS(7567),
    [anon_sym_LBRACK] = ACTIONS(7569),
    [sym_false] = ACTIONS(7567),
    [anon_sym_SEMI] = ACTIONS(7569),
    [anon_sym_case] = ACTIONS(7567),
    [anon_sym_module] = ACTIONS(7567),
    [anon_sym_number] = ACTIONS(7567),
    [anon_sym_class] = ACTIONS(7567),
    [anon_sym_declare] = ACTIONS(7567),
    [anon_sym_typeof] = ACTIONS(7567),
    [anon_sym_LBRACE] = ACTIONS(7569),
    [anon_sym_switch] = ACTIONS(7567),
    [anon_sym_LPAREN] = ACTIONS(7569),
    [sym_null] = ACTIONS(7567),
    [anon_sym_any] = ACTIONS(7567),
    [anon_sym_boolean] = ACTIONS(7567),
    [anon_sym_async] = ACTIONS(7567),
    [anon_sym_public] = ACTIONS(7567),
    [anon_sym_var] = ACTIONS(7567),
    [anon_sym_while] = ACTIONS(7567),
    [anon_sym_SQUOTE] = ACTIONS(7569),
    [anon_sym_try] = ACTIONS(7567),
    [anon_sym_LT] = ACTIONS(7569),
    [sym_number] = ACTIONS(7569),
    [anon_sym_SLASH] = ACTIONS(7567),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7567),
    [anon_sym_function] = ACTIONS(7567),
    [sym_undefined] = ACTIONS(7567),
    [anon_sym_new] = ACTIONS(7567),
    [ts_builtin_sym_end] = ACTIONS(7569),
    [anon_sym_let] = ACTIONS(7567),
    [anon_sym_PLUS] = ACTIONS(7567),
    [anon_sym_export] = ACTIONS(7567),
    [anon_sym_do] = ACTIONS(7567),
    [anon_sym_TILDE] = ACTIONS(7569),
    [anon_sym_with] = ACTIONS(7567),
  },
  [2939] = {
    [anon_sym_COMMA] = ACTIONS(7571),
    [anon_sym_RBRACE] = ACTIONS(7571),
    [sym_comment] = ACTIONS(3),
  },
  [2940] = {
    [sym_computed_property_name] = STATE(1172),
    [sym__enum_member] = STATE(2939),
    [sym__property_name] = STATE(1172),
    [sym_string] = STATE(1172),
    [sym_enum_assignment] = STATE(2939),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACE] = ACTIONS(7573),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(2431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_async] = ACTIONS(1230),
  },
  [2941] = {
    [aux_sym_enum_body_repeat1] = STATE(2941),
    [anon_sym_COMMA] = ACTIONS(7575),
    [anon_sym_RBRACE] = ACTIONS(7571),
    [sym_comment] = ACTIONS(3),
  },
  [2942] = {
    [sym_type_alias_declaration] = STATE(2092),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(2092),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(2092),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(2092),
    [sym_return_statement] = STATE(2092),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(2092),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2092),
    [sym_switch_statement] = STATE(2092),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(2092),
    [sym_throw_statement] = STATE(2092),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(2092),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(2092),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(2092),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(2092),
    [sym_abstract_class] = STATE(2092),
    [sym_interface_declaration] = STATE(2092),
    [sym_statement_block] = STATE(2092),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(2092),
    [sym_debugger_statement] = STATE(2092),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(2092),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(2092),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(2092),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(2092),
    [sym_empty_statement] = STATE(2092),
    [sym_import_alias] = STATE(2092),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(2092),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(2092),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(2092),
    [sym_break_statement] = STATE(2092),
    [sym_labeled_statement] = STATE(2092),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(2092),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [2943] = {
    [sym_array] = STATE(3641),
    [sym_object] = STATE(3642),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(7578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [2944] = {
    [anon_sym_of] = ACTIONS(7580),
    [sym_comment] = ACTIONS(3),
  },
  [2945] = {
    [anon_sym_of] = ACTIONS(7582),
    [sym_comment] = ACTIONS(3),
  },
  [2946] = {
    [anon_sym_of] = ACTIONS(7584),
    [sym_comment] = ACTIONS(3),
  },
  [2947] = {
    [sym_new_expression] = STATE(3646),
    [sym_augmented_assignment_expression] = STATE(3646),
    [sym_unary_expression] = STATE(3646),
    [sym_update_expression] = STATE(3646),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3646),
    [sym_regex] = STATE(3646),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3646),
    [sym_non_null_expression] = STATE(3646),
    [sym_as_expression] = STATE(3646),
    [sym_jsx_fragment] = STATE(3646),
    [sym_yield_expression] = STATE(3646),
    [sym_jsx_element] = STATE(3646),
    [sym_internal_module] = STATE(3646),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3646),
    [sym_await_expression] = STATE(3646),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(3647),
    [sym_string] = STATE(3646),
    [sym_this] = STATE(3646),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(3646),
    [sym_generator_function] = STATE(3646),
    [sym_call_expression] = STATE(3646),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(3646),
    [sym_ternary_expression] = STATE(3646),
    [sym_binary_expression] = STATE(3646),
    [sym_template_string] = STATE(3646),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3646),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3646),
    [sym_class] = STATE(3646),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(7586),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7586),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7588),
    [sym_true] = ACTIONS(7586),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7586),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [2948] = {
    [sym_new_expression] = STATE(3648),
    [sym_augmented_assignment_expression] = STATE(3648),
    [sym_unary_expression] = STATE(3648),
    [sym_update_expression] = STATE(3648),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3648),
    [sym_regex] = STATE(3648),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3648),
    [sym_non_null_expression] = STATE(3648),
    [sym_as_expression] = STATE(3648),
    [sym_jsx_fragment] = STATE(3648),
    [sym_yield_expression] = STATE(3648),
    [sym_jsx_element] = STATE(3648),
    [sym_internal_module] = STATE(3648),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3648),
    [sym_await_expression] = STATE(3648),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3648),
    [sym_this] = STATE(3648),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3648),
    [sym_generator_function] = STATE(3648),
    [sym_call_expression] = STATE(3648),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3648),
    [sym_ternary_expression] = STATE(3648),
    [sym_binary_expression] = STATE(3648),
    [sym_template_string] = STATE(3648),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3648),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3648),
    [sym_class] = STATE(3648),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(7590),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7590),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7592),
    [sym_true] = ACTIONS(7590),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7590),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [2949] = {
    [sym__initializer] = STATE(391),
    [sym_type_annotation] = STATE(392),
    [sym__automatic_semicolon] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(715),
    [anon_sym_of] = ACTIONS(7580),
    [anon_sym_COMMA] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(7594),
  },
  [2950] = {
    [sym__initializer] = STATE(411),
    [sym_type_annotation] = STATE(412),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(745),
    [anon_sym_of] = ACTIONS(7582),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(7596),
  },
  [2951] = {
    [sym__initializer] = STATE(413),
    [sym_type_annotation] = STATE(414),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(745),
    [anon_sym_of] = ACTIONS(7584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(7598),
  },
  [2952] = {
    [sym_new_expression] = STATE(3653),
    [sym_augmented_assignment_expression] = STATE(3653),
    [sym_unary_expression] = STATE(3653),
    [sym_update_expression] = STATE(3653),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(3653),
    [sym_regex] = STATE(3653),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3653),
    [sym_non_null_expression] = STATE(3653),
    [sym_as_expression] = STATE(3653),
    [sym_jsx_fragment] = STATE(3653),
    [sym_yield_expression] = STATE(3653),
    [sym_jsx_element] = STATE(3653),
    [sym_internal_module] = STATE(3653),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3653),
    [sym_await_expression] = STATE(3653),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(3654),
    [sym_string] = STATE(3653),
    [sym_this] = STATE(3653),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(3653),
    [sym_generator_function] = STATE(3653),
    [sym_call_expression] = STATE(3653),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(3653),
    [sym_ternary_expression] = STATE(3653),
    [sym_binary_expression] = STATE(3653),
    [sym_template_string] = STATE(3653),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3653),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3653),
    [sym_class] = STATE(3653),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(7600),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7600),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_RPAREN] = ACTIONS(7602),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7604),
    [sym_true] = ACTIONS(7600),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7600),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [2953] = {
    [sym_new_expression] = STATE(3655),
    [sym_augmented_assignment_expression] = STATE(3655),
    [sym_unary_expression] = STATE(3655),
    [sym_update_expression] = STATE(3655),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3655),
    [sym_regex] = STATE(3655),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3655),
    [sym_non_null_expression] = STATE(3655),
    [sym_as_expression] = STATE(3655),
    [sym_jsx_fragment] = STATE(3655),
    [sym_yield_expression] = STATE(3655),
    [sym_jsx_element] = STATE(3655),
    [sym_internal_module] = STATE(3655),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3655),
    [sym_await_expression] = STATE(3655),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3655),
    [sym_this] = STATE(3655),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3655),
    [sym_generator_function] = STATE(3655),
    [sym_call_expression] = STATE(3655),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3655),
    [sym_ternary_expression] = STATE(3655),
    [sym_binary_expression] = STATE(3655),
    [sym_template_string] = STATE(3655),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3655),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3655),
    [sym_class] = STATE(3655),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(7606),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7606),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7608),
    [sym_true] = ACTIONS(7606),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7606),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [2954] = {
    [sym_new_expression] = STATE(3656),
    [sym_augmented_assignment_expression] = STATE(3656),
    [sym_unary_expression] = STATE(3656),
    [sym_update_expression] = STATE(3656),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3656),
    [sym_regex] = STATE(3656),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3656),
    [sym_non_null_expression] = STATE(3656),
    [sym_as_expression] = STATE(3656),
    [sym_jsx_fragment] = STATE(3656),
    [sym_yield_expression] = STATE(3656),
    [sym_jsx_element] = STATE(3656),
    [sym_internal_module] = STATE(3656),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3656),
    [sym_await_expression] = STATE(3656),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(3657),
    [sym_string] = STATE(3656),
    [sym_this] = STATE(3656),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(3656),
    [sym_generator_function] = STATE(3656),
    [sym_call_expression] = STATE(3656),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(3656),
    [sym_ternary_expression] = STATE(3656),
    [sym_binary_expression] = STATE(3656),
    [sym_template_string] = STATE(3656),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3656),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3656),
    [sym_class] = STATE(3656),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(7610),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7610),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7612),
    [sym_true] = ACTIONS(7610),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7610),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [2955] = {
    [sym_new_expression] = STATE(3658),
    [sym_augmented_assignment_expression] = STATE(3658),
    [sym_unary_expression] = STATE(3658),
    [sym_update_expression] = STATE(3658),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3658),
    [sym_regex] = STATE(3658),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3658),
    [sym_non_null_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_jsx_fragment] = STATE(3658),
    [sym_yield_expression] = STATE(3658),
    [sym_jsx_element] = STATE(3658),
    [sym_internal_module] = STATE(3658),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3658),
    [sym_await_expression] = STATE(3658),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3658),
    [sym_this] = STATE(3658),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3658),
    [sym_generator_function] = STATE(3658),
    [sym_call_expression] = STATE(3658),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3658),
    [sym_ternary_expression] = STATE(3658),
    [sym_binary_expression] = STATE(3658),
    [sym_template_string] = STATE(3658),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3658),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3658),
    [sym_class] = STATE(3658),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(7614),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7614),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7616),
    [sym_true] = ACTIONS(7614),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7614),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [2956] = {
    [sym_new_expression] = STATE(3659),
    [sym_augmented_assignment_expression] = STATE(3659),
    [sym_unary_expression] = STATE(3659),
    [sym_update_expression] = STATE(3659),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3659),
    [sym_regex] = STATE(3659),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3659),
    [sym_non_null_expression] = STATE(3659),
    [sym_as_expression] = STATE(3659),
    [sym_jsx_fragment] = STATE(3659),
    [sym_yield_expression] = STATE(3659),
    [sym_jsx_element] = STATE(3659),
    [sym_internal_module] = STATE(3659),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3659),
    [sym_await_expression] = STATE(3659),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(3660),
    [sym_string] = STATE(3659),
    [sym_this] = STATE(3659),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(3659),
    [sym_generator_function] = STATE(3659),
    [sym_call_expression] = STATE(3659),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(3659),
    [sym_ternary_expression] = STATE(3659),
    [sym_binary_expression] = STATE(3659),
    [sym_template_string] = STATE(3659),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3659),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3659),
    [sym_class] = STATE(3659),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(7618),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7618),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7620),
    [sym_true] = ACTIONS(7618),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7618),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [2957] = {
    [anon_sym_COLON] = ACTIONS(7622),
    [sym_comment] = ACTIONS(3),
  },
  [2958] = {
    [sym_identifier] = ACTIONS(4913),
    [anon_sym_BQUOTE] = ACTIONS(4911),
    [anon_sym_debugger] = ACTIONS(4913),
    [anon_sym_symbol] = ACTIONS(4913),
    [anon_sym_AT] = ACTIONS(4911),
    [anon_sym_DASH] = ACTIONS(4913),
    [anon_sym_void] = ACTIONS(4913),
    [anon_sym_break] = ACTIONS(4913),
    [anon_sym_const] = ACTIONS(4913),
    [sym_super] = ACTIONS(4913),
    [anon_sym_return] = ACTIONS(4913),
    [anon_sym_private] = ACTIONS(4913),
    [anon_sym_get] = ACTIONS(4913),
    [anon_sym_RBRACE] = ACTIONS(4911),
    [anon_sym_interface] = ACTIONS(4913),
    [anon_sym_default] = ACTIONS(4913),
    [anon_sym_enum] = ACTIONS(4913),
    [anon_sym_delete] = ACTIONS(4913),
    [anon_sym_continue] = ACTIONS(4913),
    [anon_sym_DASH_DASH] = ACTIONS(4911),
    [anon_sym_if] = ACTIONS(4913),
    [anon_sym_this] = ACTIONS(4913),
    [anon_sym_yield] = ACTIONS(4913),
    [sym_true] = ACTIONS(4913),
    [anon_sym_throw] = ACTIONS(4913),
    [anon_sym_protected] = ACTIONS(4913),
    [anon_sym_abstract] = ACTIONS(4913),
    [anon_sym_set] = ACTIONS(4913),
    [anon_sym_type] = ACTIONS(4913),
    [anon_sym_import] = ACTIONS(4913),
    [anon_sym_namespace] = ACTIONS(4913),
    [anon_sym_PLUS_PLUS] = ACTIONS(4911),
    [anon_sym_await] = ACTIONS(4913),
    [anon_sym_DQUOTE] = ACTIONS(4911),
    [anon_sym_else] = ACTIONS(4913),
    [anon_sym_BANG] = ACTIONS(4911),
    [anon_sym_for] = ACTIONS(4913),
    [anon_sym_LBRACK] = ACTIONS(4911),
    [sym_false] = ACTIONS(4913),
    [anon_sym_SEMI] = ACTIONS(4911),
    [anon_sym_case] = ACTIONS(4913),
    [anon_sym_module] = ACTIONS(4913),
    [anon_sym_number] = ACTIONS(4913),
    [anon_sym_class] = ACTIONS(4913),
    [anon_sym_declare] = ACTIONS(4913),
    [anon_sym_typeof] = ACTIONS(4913),
    [anon_sym_LBRACE] = ACTIONS(4911),
    [anon_sym_switch] = ACTIONS(4913),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_null] = ACTIONS(4913),
    [anon_sym_any] = ACTIONS(4913),
    [anon_sym_boolean] = ACTIONS(4913),
    [anon_sym_async] = ACTIONS(4913),
    [anon_sym_public] = ACTIONS(4913),
    [anon_sym_var] = ACTIONS(4913),
    [anon_sym_while] = ACTIONS(4913),
    [anon_sym_SQUOTE] = ACTIONS(4911),
    [anon_sym_try] = ACTIONS(4913),
    [anon_sym_LT] = ACTIONS(4911),
    [sym_number] = ACTIONS(4911),
    [anon_sym_SLASH] = ACTIONS(4913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4913),
    [anon_sym_function] = ACTIONS(4913),
    [sym_undefined] = ACTIONS(4913),
    [anon_sym_new] = ACTIONS(4913),
    [ts_builtin_sym_end] = ACTIONS(4911),
    [anon_sym_let] = ACTIONS(4913),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_export] = ACTIONS(4913),
    [anon_sym_do] = ACTIONS(4913),
    [anon_sym_TILDE] = ACTIONS(4911),
    [anon_sym_with] = ACTIONS(4913),
  },
  [2959] = {
    [sym_identifier] = ACTIONS(7624),
    [anon_sym_BQUOTE] = ACTIONS(7626),
    [anon_sym_debugger] = ACTIONS(7624),
    [anon_sym_symbol] = ACTIONS(7624),
    [anon_sym_AT] = ACTIONS(7626),
    [anon_sym_DASH] = ACTIONS(7624),
    [anon_sym_void] = ACTIONS(7624),
    [anon_sym_break] = ACTIONS(7624),
    [anon_sym_const] = ACTIONS(7624),
    [sym_super] = ACTIONS(7624),
    [anon_sym_return] = ACTIONS(7624),
    [anon_sym_private] = ACTIONS(7624),
    [anon_sym_get] = ACTIONS(7624),
    [anon_sym_RBRACE] = ACTIONS(7626),
    [anon_sym_interface] = ACTIONS(7624),
    [anon_sym_default] = ACTIONS(7624),
    [anon_sym_enum] = ACTIONS(7624),
    [anon_sym_delete] = ACTIONS(7624),
    [anon_sym_continue] = ACTIONS(7624),
    [anon_sym_DASH_DASH] = ACTIONS(7626),
    [anon_sym_if] = ACTIONS(7624),
    [anon_sym_this] = ACTIONS(7624),
    [anon_sym_yield] = ACTIONS(7624),
    [sym_true] = ACTIONS(7624),
    [anon_sym_throw] = ACTIONS(7624),
    [anon_sym_protected] = ACTIONS(7624),
    [anon_sym_abstract] = ACTIONS(7624),
    [anon_sym_set] = ACTIONS(7624),
    [anon_sym_type] = ACTIONS(7624),
    [anon_sym_import] = ACTIONS(7624),
    [anon_sym_namespace] = ACTIONS(7624),
    [anon_sym_PLUS_PLUS] = ACTIONS(7626),
    [anon_sym_await] = ACTIONS(7624),
    [anon_sym_DQUOTE] = ACTIONS(7626),
    [anon_sym_else] = ACTIONS(7624),
    [anon_sym_BANG] = ACTIONS(7626),
    [anon_sym_for] = ACTIONS(7624),
    [anon_sym_LBRACK] = ACTIONS(7626),
    [sym_false] = ACTIONS(7624),
    [anon_sym_SEMI] = ACTIONS(7626),
    [anon_sym_case] = ACTIONS(7624),
    [anon_sym_module] = ACTIONS(7624),
    [anon_sym_number] = ACTIONS(7624),
    [anon_sym_class] = ACTIONS(7624),
    [anon_sym_declare] = ACTIONS(7624),
    [anon_sym_typeof] = ACTIONS(7624),
    [anon_sym_LBRACE] = ACTIONS(7626),
    [anon_sym_switch] = ACTIONS(7624),
    [anon_sym_LPAREN] = ACTIONS(7626),
    [sym_null] = ACTIONS(7624),
    [anon_sym_any] = ACTIONS(7624),
    [anon_sym_boolean] = ACTIONS(7624),
    [anon_sym_async] = ACTIONS(7624),
    [anon_sym_public] = ACTIONS(7624),
    [anon_sym_var] = ACTIONS(7624),
    [anon_sym_while] = ACTIONS(7624),
    [anon_sym_SQUOTE] = ACTIONS(7626),
    [anon_sym_try] = ACTIONS(7624),
    [anon_sym_LT] = ACTIONS(7626),
    [sym_number] = ACTIONS(7626),
    [anon_sym_SLASH] = ACTIONS(7624),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7624),
    [anon_sym_function] = ACTIONS(7624),
    [sym_undefined] = ACTIONS(7624),
    [anon_sym_new] = ACTIONS(7624),
    [ts_builtin_sym_end] = ACTIONS(7626),
    [anon_sym_let] = ACTIONS(7624),
    [anon_sym_PLUS] = ACTIONS(7624),
    [anon_sym_export] = ACTIONS(7624),
    [anon_sym_do] = ACTIONS(7624),
    [anon_sym_TILDE] = ACTIONS(7626),
    [anon_sym_with] = ACTIONS(7624),
  },
  [2960] = {
    [sym_union_type] = STATE(1892),
    [sym__type] = STATE(1892),
    [sym_constructor_type] = STATE(1892),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2964),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1892),
    [sym_function_type] = STATE(1892),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2965),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(6198),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(6202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [2961] = {
    [sym_type_parameters] = STATE(3662),
    [sym_formal_parameters] = STATE(3663),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [2962] = {
    [sym_union_type] = STATE(1900),
    [sym__type] = STATE(1900),
    [sym_constructor_type] = STATE(1900),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2964),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1900),
    [sym_function_type] = STATE(1900),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2965),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(6198),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(6202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [2963] = {
    [sym__automatic_semicolon] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(7628),
    [anon_sym_SEMI] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(7630),
    [sym_comment] = ACTIONS(3),
  },
  [2964] = {
    [sym_formal_parameters] = STATE(3666),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [2965] = {
    [anon_sym_EQ_GT] = ACTIONS(7632),
    [sym_comment] = ACTIONS(3),
  },
  [2966] = {
    [anon_sym_EQ_GT] = ACTIONS(7634),
    [sym_comment] = ACTIONS(3),
  },
  [2967] = {
    [sym_union_type] = STATE(3669),
    [sym__type] = STATE(3669),
    [sym_constructor_type] = STATE(3669),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1198),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(3669),
    [sym_function_type] = STATE(3669),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1199),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2475),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [2968] = {
    [sym_union_type] = STATE(3670),
    [sym__type] = STATE(3670),
    [sym_constructor_type] = STATE(3670),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1198),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(3670),
    [sym_function_type] = STATE(3670),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1199),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2475),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [2969] = {
    [sym__automatic_semicolon] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_PIPE] = ACTIONS(4447),
    [anon_sym_SEMI] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
  },
  [2970] = {
    [sym_identifier] = ACTIONS(7636),
    [anon_sym_BQUOTE] = ACTIONS(7638),
    [anon_sym_debugger] = ACTIONS(7636),
    [anon_sym_symbol] = ACTIONS(7636),
    [anon_sym_AT] = ACTIONS(7638),
    [anon_sym_DASH] = ACTIONS(7636),
    [anon_sym_void] = ACTIONS(7636),
    [anon_sym_break] = ACTIONS(7636),
    [anon_sym_const] = ACTIONS(7636),
    [sym_super] = ACTIONS(7636),
    [anon_sym_return] = ACTIONS(7636),
    [anon_sym_private] = ACTIONS(7636),
    [anon_sym_get] = ACTIONS(7636),
    [anon_sym_RBRACE] = ACTIONS(7638),
    [anon_sym_interface] = ACTIONS(7636),
    [anon_sym_default] = ACTIONS(7636),
    [anon_sym_enum] = ACTIONS(7636),
    [anon_sym_delete] = ACTIONS(7636),
    [anon_sym_continue] = ACTIONS(7636),
    [anon_sym_DASH_DASH] = ACTIONS(7638),
    [anon_sym_if] = ACTIONS(7636),
    [anon_sym_this] = ACTIONS(7636),
    [anon_sym_yield] = ACTIONS(7636),
    [sym_true] = ACTIONS(7636),
    [anon_sym_throw] = ACTIONS(7636),
    [anon_sym_protected] = ACTIONS(7636),
    [anon_sym_abstract] = ACTIONS(7636),
    [anon_sym_set] = ACTIONS(7636),
    [anon_sym_type] = ACTIONS(7636),
    [anon_sym_import] = ACTIONS(7636),
    [anon_sym_namespace] = ACTIONS(7636),
    [anon_sym_PLUS_PLUS] = ACTIONS(7638),
    [anon_sym_await] = ACTIONS(7636),
    [anon_sym_DQUOTE] = ACTIONS(7638),
    [anon_sym_else] = ACTIONS(7636),
    [anon_sym_BANG] = ACTIONS(7638),
    [anon_sym_for] = ACTIONS(7636),
    [anon_sym_LBRACK] = ACTIONS(7638),
    [sym_false] = ACTIONS(7636),
    [anon_sym_SEMI] = ACTIONS(7638),
    [anon_sym_case] = ACTIONS(7636),
    [anon_sym_module] = ACTIONS(7636),
    [anon_sym_number] = ACTIONS(7636),
    [anon_sym_class] = ACTIONS(7636),
    [anon_sym_declare] = ACTIONS(7636),
    [anon_sym_typeof] = ACTIONS(7636),
    [anon_sym_LBRACE] = ACTIONS(7638),
    [anon_sym_switch] = ACTIONS(7636),
    [anon_sym_LPAREN] = ACTIONS(7638),
    [sym_null] = ACTIONS(7636),
    [anon_sym_any] = ACTIONS(7636),
    [anon_sym_boolean] = ACTIONS(7636),
    [anon_sym_async] = ACTIONS(7636),
    [anon_sym_public] = ACTIONS(7636),
    [anon_sym_var] = ACTIONS(7636),
    [anon_sym_while] = ACTIONS(7636),
    [anon_sym_SQUOTE] = ACTIONS(7638),
    [anon_sym_try] = ACTIONS(7636),
    [anon_sym_LT] = ACTIONS(7638),
    [sym_number] = ACTIONS(7638),
    [anon_sym_SLASH] = ACTIONS(7636),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7636),
    [anon_sym_function] = ACTIONS(7636),
    [sym_undefined] = ACTIONS(7636),
    [anon_sym_new] = ACTIONS(7636),
    [ts_builtin_sym_end] = ACTIONS(7638),
    [anon_sym_let] = ACTIONS(7636),
    [anon_sym_PLUS] = ACTIONS(7636),
    [anon_sym_export] = ACTIONS(7636),
    [anon_sym_do] = ACTIONS(7636),
    [anon_sym_TILDE] = ACTIONS(7638),
    [anon_sym_with] = ACTIONS(7636),
  },
  [2971] = {
    [anon_sym_RPAREN] = ACTIONS(7640),
    [sym_comment] = ACTIONS(3),
  },
  [2972] = {
    [anon_sym_COMMA] = ACTIONS(7642),
    [anon_sym_RBRACE] = ACTIONS(7642),
    [sym_comment] = ACTIONS(3),
  },
  [2973] = {
    [anon_sym_from] = ACTIONS(7644),
    [sym_comment] = ACTIONS(3),
  },
  [2974] = {
    [sym__import_export_specifier] = STATE(2112),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(895),
    [anon_sym_type] = ACTIONS(895),
    [sym_comment] = ACTIONS(3),
  },
  [2975] = {
    [sym_new_expression] = STATE(3672),
    [sym_augmented_assignment_expression] = STATE(3672),
    [sym_unary_expression] = STATE(3672),
    [sym_update_expression] = STATE(3672),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3672),
    [sym_regex] = STATE(3672),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3672),
    [sym_non_null_expression] = STATE(3672),
    [sym_as_expression] = STATE(3672),
    [sym_jsx_fragment] = STATE(3672),
    [sym_yield_expression] = STATE(3672),
    [sym_jsx_element] = STATE(3672),
    [sym_internal_module] = STATE(3672),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3672),
    [sym_await_expression] = STATE(3672),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3672),
    [sym_this] = STATE(3672),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3672),
    [sym_generator_function] = STATE(3672),
    [sym_call_expression] = STATE(3672),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3672),
    [sym_ternary_expression] = STATE(3672),
    [sym_binary_expression] = STATE(3672),
    [sym_template_string] = STATE(3672),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3672),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3672),
    [sym_class] = STATE(3672),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7646),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7648),
    [sym_true] = ACTIONS(7646),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7646),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [2976] = {
    [sym_new_expression] = STATE(3673),
    [sym_augmented_assignment_expression] = STATE(3673),
    [sym_unary_expression] = STATE(3673),
    [sym_update_expression] = STATE(3673),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3673),
    [sym_regex] = STATE(3673),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3673),
    [sym_non_null_expression] = STATE(3673),
    [sym_as_expression] = STATE(3673),
    [sym_jsx_fragment] = STATE(3673),
    [sym_yield_expression] = STATE(3673),
    [sym_jsx_element] = STATE(3673),
    [sym_internal_module] = STATE(3673),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3673),
    [sym_await_expression] = STATE(3673),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3673),
    [sym_this] = STATE(3673),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3673),
    [sym_generator_function] = STATE(3673),
    [sym_call_expression] = STATE(3673),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3673),
    [sym_ternary_expression] = STATE(3673),
    [sym_binary_expression] = STATE(3673),
    [sym_template_string] = STATE(3673),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3673),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3673),
    [sym_class] = STATE(3673),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(7650),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7650),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7652),
    [sym_true] = ACTIONS(7650),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7650),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [2977] = {
    [sym_new_expression] = STATE(3674),
    [sym_augmented_assignment_expression] = STATE(3674),
    [sym_unary_expression] = STATE(3674),
    [sym_update_expression] = STATE(3674),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3674),
    [sym_regex] = STATE(3674),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3674),
    [sym_non_null_expression] = STATE(3674),
    [sym_as_expression] = STATE(3674),
    [sym_jsx_fragment] = STATE(3674),
    [sym_yield_expression] = STATE(3674),
    [sym_jsx_element] = STATE(3674),
    [sym_internal_module] = STATE(3674),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3674),
    [sym_await_expression] = STATE(3674),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3674),
    [sym_this] = STATE(3674),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3674),
    [sym_generator_function] = STATE(3674),
    [sym_call_expression] = STATE(3674),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3674),
    [sym_ternary_expression] = STATE(3674),
    [sym_binary_expression] = STATE(3674),
    [sym_template_string] = STATE(3674),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3674),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3674),
    [sym_class] = STATE(3674),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(7654),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7654),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7656),
    [sym_true] = ACTIONS(7654),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7654),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [2978] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(7658),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [2979] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(7660),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [2980] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(7662),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [2981] = {
    [sym_new_expression] = STATE(3678),
    [sym_augmented_assignment_expression] = STATE(3678),
    [sym_unary_expression] = STATE(3678),
    [sym_update_expression] = STATE(3678),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3678),
    [sym_regex] = STATE(3678),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(343),
    [sym__expression] = STATE(3678),
    [sym_non_null_expression] = STATE(3678),
    [sym_yield_expression] = STATE(3678),
    [sym_jsx_fragment] = STATE(3678),
    [sym_jsx_element] = STATE(3678),
    [sym_as_expression] = STATE(3678),
    [sym_internal_module] = STATE(3678),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3678),
    [sym_await_expression] = STATE(3678),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(3678),
    [sym_this] = STATE(3678),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(3678),
    [sym_generator_function] = STATE(3678),
    [sym_call_expression] = STATE(3678),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(3678),
    [sym_ternary_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_template_string] = STATE(3678),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3678),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3678),
    [sym_class] = STATE(3678),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(7664),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7664),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7666),
    [sym_true] = ACTIONS(7664),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7664),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [2982] = {
    [sym_new_expression] = STATE(3679),
    [sym_augmented_assignment_expression] = STATE(3679),
    [sym_unary_expression] = STATE(3679),
    [sym_update_expression] = STATE(3679),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3679),
    [sym_regex] = STATE(3679),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3679),
    [sym_non_null_expression] = STATE(3679),
    [sym_as_expression] = STATE(3679),
    [sym_jsx_fragment] = STATE(3679),
    [sym_yield_expression] = STATE(3679),
    [sym_jsx_element] = STATE(3679),
    [sym_internal_module] = STATE(3679),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3679),
    [sym_await_expression] = STATE(3679),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(3679),
    [sym_this] = STATE(3679),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(3679),
    [sym_generator_function] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(3679),
    [sym_ternary_expression] = STATE(3679),
    [sym_binary_expression] = STATE(3679),
    [sym_template_string] = STATE(3679),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3679),
    [sym_class] = STATE(3679),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(7668),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7668),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7670),
    [sym_true] = ACTIONS(7668),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7668),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [2983] = {
    [sym_new_expression] = STATE(3680),
    [sym_augmented_assignment_expression] = STATE(3680),
    [sym_unary_expression] = STATE(3680),
    [sym_update_expression] = STATE(3680),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3680),
    [sym_regex] = STATE(3680),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3680),
    [sym_non_null_expression] = STATE(3680),
    [sym_as_expression] = STATE(3680),
    [sym_jsx_fragment] = STATE(3680),
    [sym_yield_expression] = STATE(3680),
    [sym_jsx_element] = STATE(3680),
    [sym_internal_module] = STATE(3680),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3680),
    [sym_await_expression] = STATE(3680),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(3680),
    [sym_this] = STATE(3680),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(3680),
    [sym_generator_function] = STATE(3680),
    [sym_call_expression] = STATE(3680),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(3680),
    [sym_ternary_expression] = STATE(3680),
    [sym_binary_expression] = STATE(3680),
    [sym_template_string] = STATE(3680),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3680),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3680),
    [sym_class] = STATE(3680),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(7672),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7672),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7674),
    [sym_true] = ACTIONS(7672),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7672),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [2984] = {
    [sym_new_expression] = STATE(3681),
    [sym_augmented_assignment_expression] = STATE(3681),
    [sym_unary_expression] = STATE(3681),
    [sym_update_expression] = STATE(3681),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3681),
    [sym_regex] = STATE(3681),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3681),
    [sym_non_null_expression] = STATE(3681),
    [sym_as_expression] = STATE(3681),
    [sym_jsx_fragment] = STATE(3681),
    [sym_yield_expression] = STATE(3681),
    [sym_jsx_element] = STATE(3681),
    [sym_internal_module] = STATE(3681),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3681),
    [sym_await_expression] = STATE(3681),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(3681),
    [sym_this] = STATE(3681),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(3681),
    [sym_generator_function] = STATE(3681),
    [sym_call_expression] = STATE(3681),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(3681),
    [sym_ternary_expression] = STATE(3681),
    [sym_binary_expression] = STATE(3681),
    [sym_template_string] = STATE(3681),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3681),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3681),
    [sym_class] = STATE(3681),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(7676),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7676),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7678),
    [sym_true] = ACTIONS(7676),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7676),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [2985] = {
    [sym_new_expression] = STATE(3682),
    [sym_augmented_assignment_expression] = STATE(3682),
    [sym_unary_expression] = STATE(3682),
    [sym_update_expression] = STATE(3682),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3682),
    [sym_regex] = STATE(3682),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(369),
    [sym__expression] = STATE(3682),
    [sym_non_null_expression] = STATE(3682),
    [sym_yield_expression] = STATE(3682),
    [sym_jsx_fragment] = STATE(3682),
    [sym_jsx_element] = STATE(3682),
    [sym_as_expression] = STATE(3682),
    [sym_internal_module] = STATE(3682),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3682),
    [sym_await_expression] = STATE(3682),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(3682),
    [sym_this] = STATE(3682),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(3682),
    [sym_generator_function] = STATE(3682),
    [sym_call_expression] = STATE(3682),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(3682),
    [sym_ternary_expression] = STATE(3682),
    [sym_binary_expression] = STATE(3682),
    [sym_template_string] = STATE(3682),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3682),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3682),
    [sym_class] = STATE(3682),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(7680),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7680),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7682),
    [sym_true] = ACTIONS(7680),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7680),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [2986] = {
    [sym_new_expression] = STATE(3683),
    [sym_augmented_assignment_expression] = STATE(3683),
    [sym_unary_expression] = STATE(3683),
    [sym_update_expression] = STATE(3683),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3683),
    [sym_regex] = STATE(3683),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3683),
    [sym_non_null_expression] = STATE(3683),
    [sym_as_expression] = STATE(3683),
    [sym_jsx_fragment] = STATE(3683),
    [sym_yield_expression] = STATE(3683),
    [sym_jsx_element] = STATE(3683),
    [sym_internal_module] = STATE(3683),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3683),
    [sym_await_expression] = STATE(3683),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(3683),
    [sym_this] = STATE(3683),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(3683),
    [sym_generator_function] = STATE(3683),
    [sym_call_expression] = STATE(3683),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(3683),
    [sym_ternary_expression] = STATE(3683),
    [sym_binary_expression] = STATE(3683),
    [sym_template_string] = STATE(3683),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3683),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3683),
    [sym_class] = STATE(3683),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(7684),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7684),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7686),
    [sym_true] = ACTIONS(7684),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7684),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [2987] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(702),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_RPAREN] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(7688),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [2988] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_SEMI] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(702),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_RPAREN] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(7688),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [2989] = {
    [anon_sym_EQ_GT] = ACTIONS(7691),
    [sym_comment] = ACTIONS(3),
  },
  [2990] = {
    [anon_sym_EQ_GT] = ACTIONS(7693),
    [sym_comment] = ACTIONS(3),
  },
  [2991] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_SEMI] = ACTIONS(839),
    [anon_sym_BQUOTE] = ACTIONS(839),
    [sym__automatic_semicolon] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_RPAREN] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_instanceof] = ACTIONS(839),
    [anon_sym_SLASH] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_in] = ACTIONS(841),
  },
  [2992] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7695),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(871),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(871),
    [anon_sym_PIPE] = ACTIONS(7697),
    [anon_sym_COMMA] = ACTIONS(871),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(7699),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6261),
    [anon_sym_LT_EQ] = ACTIONS(7695),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7695),
    [anon_sym_GT] = ACTIONS(6261),
    [anon_sym_AMP] = ACTIONS(7701),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(7703),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(7705),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(6261),
    [anon_sym_RPAREN] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_instanceof] = ACTIONS(7695),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(7705),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7695),
    [anon_sym_in] = ACTIONS(6261),
  },
  [2993] = {
    [sym__initializer] = STATE(522),
    [sym_arguments] = STATE(826),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_SEMI] = ACTIONS(1529),
    [sym__automatic_semicolon] = ACTIONS(1529),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(6259),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1531),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1529),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [2994] = {
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(828),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1539),
    [sym__automatic_semicolon] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(6265),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_RPAREN] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [2995] = {
    [sym_new_expression] = STATE(836),
    [sym_augmented_assignment_expression] = STATE(836),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(836),
    [sym_update_expression] = STATE(836),
    [sym_regex] = STATE(836),
    [sym_meta_property] = STATE(836),
    [sym_call_signature] = STATE(835),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(836),
    [sym_non_null_expression] = STATE(836),
    [sym_yield_expression] = STATE(836),
    [sym_jsx_fragment] = STATE(836),
    [sym_jsx_element] = STATE(836),
    [sym_as_expression] = STATE(836),
    [sym_internal_module] = STATE(836),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(836),
    [sym_await_expression] = STATE(836),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(836),
    [sym_this] = STATE(836),
    [sym_arguments] = STATE(828),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(836),
    [sym_generator_function] = STATE(836),
    [sym_call_expression] = STATE(836),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(836),
    [sym_ternary_expression] = STATE(836),
    [sym_binary_expression] = STATE(836),
    [sym_template_string] = STATE(836),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(836),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(836),
    [sym_class] = STATE(836),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym__automatic_semicolon] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(500),
    [sym_true] = ACTIONS(1545),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [sym_false] = ACTIONS(1545),
    [anon_sym_SEMI] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [sym_null] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(6265),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_RPAREN] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [sym_number] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [2996] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_arguments] = STATE(828),
    [sym_call_signature] = STATE(2989),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym__automatic_semicolon] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(6275),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(6277),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(6277),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(6277),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(6277),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_protected] = ACTIONS(6277),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_set] = ACTIONS(6277),
    [anon_sym_type] = ACTIONS(6277),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(6277),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(6277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(6277),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(6277),
    [anon_sym_declare] = ACTIONS(6277),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(6277),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(6277),
    [anon_sym_async] = ACTIONS(6277),
    [anon_sym_public] = ACTIONS(6277),
    [anon_sym_EQ_GT] = ACTIONS(6265),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_RPAREN] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(6277),
    [anon_sym_function] = ACTIONS(698),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(6277),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [2997] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(828),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1539),
    [sym__automatic_semicolon] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(6265),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_RPAREN] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [2998] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7695),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(915),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(7697),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(7699),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6261),
    [anon_sym_LT_EQ] = ACTIONS(7695),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7695),
    [anon_sym_GT] = ACTIONS(6261),
    [anon_sym_AMP] = ACTIONS(7701),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(7703),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(7705),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(6261),
    [anon_sym_RPAREN] = ACTIONS(915),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_instanceof] = ACTIONS(7695),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(7705),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7695),
    [anon_sym_in] = ACTIONS(6261),
  },
  [2999] = {
    [sym_new_expression] = STATE(3686),
    [sym_augmented_assignment_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3686),
    [sym_update_expression] = STATE(3686),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3686),
    [sym_regex] = STATE(3686),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3686),
    [sym_non_null_expression] = STATE(3686),
    [sym_as_expression] = STATE(3686),
    [sym_jsx_fragment] = STATE(3686),
    [sym_yield_expression] = STATE(3686),
    [sym_jsx_element] = STATE(3686),
    [sym_internal_module] = STATE(3686),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3686),
    [sym_await_expression] = STATE(3686),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(3686),
    [sym_this] = STATE(3686),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(3686),
    [sym_generator_function] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(3686),
    [sym_ternary_expression] = STATE(3686),
    [sym_binary_expression] = STATE(3686),
    [sym_template_string] = STATE(3686),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3686),
    [sym_class] = STATE(3686),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(7707),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7707),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7709),
    [sym_true] = ACTIONS(7707),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7707),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [3000] = {
    [sym_new_expression] = STATE(3687),
    [sym_augmented_assignment_expression] = STATE(3687),
    [sym_unary_expression] = STATE(3687),
    [sym_update_expression] = STATE(3687),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3687),
    [sym_regex] = STATE(3687),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3687),
    [sym_non_null_expression] = STATE(3687),
    [sym_as_expression] = STATE(3687),
    [sym_jsx_fragment] = STATE(3687),
    [sym_yield_expression] = STATE(3687),
    [sym_jsx_element] = STATE(3687),
    [sym_internal_module] = STATE(3687),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3687),
    [sym_await_expression] = STATE(3687),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(3687),
    [sym_this] = STATE(3687),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(3687),
    [sym_generator_function] = STATE(3687),
    [sym_call_expression] = STATE(3687),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(3687),
    [sym_ternary_expression] = STATE(3687),
    [sym_binary_expression] = STATE(3687),
    [sym_template_string] = STATE(3687),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3687),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3687),
    [sym_class] = STATE(3687),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(7711),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7711),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7713),
    [sym_true] = ACTIONS(7711),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7711),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [3001] = {
    [sym_new_expression] = STATE(3688),
    [sym_augmented_assignment_expression] = STATE(3688),
    [sym_unary_expression] = STATE(3688),
    [sym_update_expression] = STATE(3688),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3688),
    [sym_regex] = STATE(3688),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3688),
    [sym_non_null_expression] = STATE(3688),
    [sym_as_expression] = STATE(3688),
    [sym_jsx_fragment] = STATE(3688),
    [sym_yield_expression] = STATE(3688),
    [sym_jsx_element] = STATE(3688),
    [sym_internal_module] = STATE(3688),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3688),
    [sym_await_expression] = STATE(3688),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(3688),
    [sym_this] = STATE(3688),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(3688),
    [sym_generator_function] = STATE(3688),
    [sym_call_expression] = STATE(3688),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(3688),
    [sym_ternary_expression] = STATE(3688),
    [sym_binary_expression] = STATE(3688),
    [sym_template_string] = STATE(3688),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3688),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3688),
    [sym_class] = STATE(3688),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(7715),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7715),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7717),
    [sym_true] = ACTIONS(7715),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7715),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [3002] = {
    [sym_new_expression] = STATE(3689),
    [sym_augmented_assignment_expression] = STATE(3689),
    [sym_unary_expression] = STATE(3689),
    [sym_update_expression] = STATE(3689),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3689),
    [sym_regex] = STATE(3689),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3689),
    [sym_non_null_expression] = STATE(3689),
    [sym_as_expression] = STATE(3689),
    [sym_jsx_fragment] = STATE(3689),
    [sym_yield_expression] = STATE(3689),
    [sym_jsx_element] = STATE(3689),
    [sym_internal_module] = STATE(3689),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3689),
    [sym_await_expression] = STATE(3689),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(3689),
    [sym_this] = STATE(3689),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(3689),
    [sym_generator_function] = STATE(3689),
    [sym_call_expression] = STATE(3689),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(3689),
    [sym_ternary_expression] = STATE(3689),
    [sym_binary_expression] = STATE(3689),
    [sym_template_string] = STATE(3689),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3689),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3689),
    [sym_class] = STATE(3689),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(7719),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7719),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7721),
    [sym_true] = ACTIONS(7719),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7719),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [3003] = {
    [sym_new_expression] = STATE(3690),
    [sym_augmented_assignment_expression] = STATE(3690),
    [sym_unary_expression] = STATE(3690),
    [sym_update_expression] = STATE(3690),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(3690),
    [sym_regex] = STATE(3690),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3690),
    [sym_non_null_expression] = STATE(3690),
    [sym_as_expression] = STATE(3690),
    [sym_jsx_fragment] = STATE(3690),
    [sym_yield_expression] = STATE(3690),
    [sym_jsx_element] = STATE(3690),
    [sym_internal_module] = STATE(3690),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3690),
    [sym_await_expression] = STATE(3690),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(3690),
    [sym_this] = STATE(3690),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(3690),
    [sym_generator_function] = STATE(3690),
    [sym_call_expression] = STATE(3690),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(3690),
    [sym_ternary_expression] = STATE(3690),
    [sym_binary_expression] = STATE(3690),
    [sym_template_string] = STATE(3690),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3690),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3690),
    [sym_class] = STATE(3690),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(7723),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7723),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7725),
    [sym_true] = ACTIONS(7723),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7723),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [3004] = {
    [sym_union_type] = STATE(941),
    [sym__type] = STATE(941),
    [sym_constructor_type] = STATE(941),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(3696),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_template_string] = STATE(945),
    [sym_intersection_type] = STATE(941),
    [sym_function_type] = STATE(941),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(3697),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(7727),
    [sym_false] = ACTIONS(1907),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_keyof] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_PIPE] = ACTIONS(7729),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_boolean] = ACTIONS(1911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_AMP] = ACTIONS(7731),
    [anon_sym_QMARK] = ACTIONS(7733),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1933),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_new] = ACTIONS(7735),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [3005] = {
    [sym_new_expression] = STATE(3679),
    [sym_constructor_type] = STATE(432),
    [sym_augmented_assignment_expression] = STATE(3679),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(3679),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(3679),
    [sym_type_parameters] = STATE(959),
    [sym_array_type] = STATE(436),
    [sym_yield_expression] = STATE(3679),
    [sym_as_expression] = STATE(3679),
    [sym_jsx_fragment] = STATE(3679),
    [sym_internal_module] = STATE(3679),
    [sym_arrow_function] = STATE(3679),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(2134),
    [sym_literal_type] = STATE(436),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(949),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(3679),
    [sym_subscript_expression] = STATE(2134),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(3679),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(3679),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(960),
    [sym_function_type] = STATE(432),
    [sym__type] = STATE(432),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(3679),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3679),
    [sym__expression] = STATE(3679),
    [sym_non_null_expression] = STATE(3679),
    [sym_jsx_element] = STATE(3679),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(88),
    [sym_await_expression] = STATE(3679),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_this] = STATE(3679),
    [sym_union_type] = STATE(432),
    [sym_anonymous_class] = STATE(3679),
    [sym_call_expression] = STATE(3679),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(3679),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(3679),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(432),
    [sym_parenthesized_expression] = STATE(3679),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3679),
    [sym_class] = STATE(3679),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(7737),
    [sym_false] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(1943),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(7739),
    [anon_sym_number] = ACTIONS(7739),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(7741),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(7743),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_void] = ACTIONS(7745),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(1955),
    [sym_null] = ACTIONS(7668),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(7739),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(7739),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1957),
    [sym_true] = ACTIONS(1941),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(1959),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(7739),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7668),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(7747),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(7743),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [3006] = {
    [sym_type_alias_declaration] = STATE(3704),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3704),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3704),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3704),
    [sym_return_statement] = STATE(3704),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3704),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3704),
    [sym_switch_statement] = STATE(3704),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3704),
    [sym_throw_statement] = STATE(3704),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3704),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3704),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(3704),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3704),
    [sym_abstract_class] = STATE(3704),
    [sym_interface_declaration] = STATE(3704),
    [sym_statement_block] = STATE(3704),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3704),
    [sym_debugger_statement] = STATE(3704),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3704),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3704),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3704),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3704),
    [sym_empty_statement] = STATE(3704),
    [sym_import_alias] = STATE(3704),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3704),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3704),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3704),
    [sym_break_statement] = STATE(3704),
    [sym_labeled_statement] = STATE(3704),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3704),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3007] = {
    [sym_new_expression] = STATE(3705),
    [sym_augmented_assignment_expression] = STATE(3705),
    [sym_unary_expression] = STATE(3705),
    [sym_update_expression] = STATE(3705),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(3705),
    [sym_regex] = STATE(3705),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3705),
    [sym_non_null_expression] = STATE(3705),
    [sym_as_expression] = STATE(3705),
    [sym_jsx_fragment] = STATE(3705),
    [sym_yield_expression] = STATE(3705),
    [sym_jsx_element] = STATE(3705),
    [sym_internal_module] = STATE(3705),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3705),
    [sym_await_expression] = STATE(3705),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(3705),
    [sym_this] = STATE(3705),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(3705),
    [sym_generator_function] = STATE(3705),
    [sym_call_expression] = STATE(3705),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(3705),
    [sym_ternary_expression] = STATE(3705),
    [sym_binary_expression] = STATE(3705),
    [sym_template_string] = STATE(3705),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3705),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3705),
    [sym_class] = STATE(3705),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(7749),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7749),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7751),
    [sym_true] = ACTIONS(7749),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7749),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [3008] = {
    [sym_new_expression] = STATE(3706),
    [sym_augmented_assignment_expression] = STATE(3706),
    [sym_unary_expression] = STATE(3706),
    [sym_update_expression] = STATE(3706),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3706),
    [sym_regex] = STATE(3706),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1233),
    [sym__expression] = STATE(3706),
    [sym_non_null_expression] = STATE(3706),
    [sym_yield_expression] = STATE(3706),
    [sym_jsx_fragment] = STATE(3706),
    [sym_jsx_element] = STATE(3706),
    [sym_as_expression] = STATE(3706),
    [sym_internal_module] = STATE(3706),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3706),
    [sym_await_expression] = STATE(3706),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3706),
    [sym_this] = STATE(3706),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3706),
    [sym_generator_function] = STATE(3706),
    [sym_call_expression] = STATE(3706),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3706),
    [sym_ternary_expression] = STATE(3706),
    [sym_binary_expression] = STATE(3706),
    [sym_template_string] = STATE(3706),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3706),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3706),
    [sym_class] = STATE(3706),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(7753),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7753),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7755),
    [sym_true] = ACTIONS(7753),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7753),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3009] = {
    [sym_new_expression] = STATE(3707),
    [sym_augmented_assignment_expression] = STATE(3707),
    [sym_unary_expression] = STATE(3707),
    [sym_update_expression] = STATE(3707),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3707),
    [sym_regex] = STATE(3707),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3707),
    [sym_non_null_expression] = STATE(3707),
    [sym_as_expression] = STATE(3707),
    [sym_jsx_fragment] = STATE(3707),
    [sym_yield_expression] = STATE(3707),
    [sym_jsx_element] = STATE(3707),
    [sym_internal_module] = STATE(3707),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3707),
    [sym_await_expression] = STATE(3707),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3707),
    [sym_this] = STATE(3707),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3707),
    [sym_generator_function] = STATE(3707),
    [sym_call_expression] = STATE(3707),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3707),
    [sym_ternary_expression] = STATE(3707),
    [sym_binary_expression] = STATE(3707),
    [sym_template_string] = STATE(3707),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3707),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3707),
    [sym_class] = STATE(3707),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(7757),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7757),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7759),
    [sym_true] = ACTIONS(7757),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7757),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3010] = {
    [sym_new_expression] = STATE(3708),
    [sym_augmented_assignment_expression] = STATE(3708),
    [sym_unary_expression] = STATE(3708),
    [sym_update_expression] = STATE(3708),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3708),
    [sym_regex] = STATE(3708),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3708),
    [sym_non_null_expression] = STATE(3708),
    [sym_as_expression] = STATE(3708),
    [sym_jsx_fragment] = STATE(3708),
    [sym_yield_expression] = STATE(3708),
    [sym_jsx_element] = STATE(3708),
    [sym_internal_module] = STATE(3708),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3708),
    [sym_await_expression] = STATE(3708),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3708),
    [sym_this] = STATE(3708),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3708),
    [sym_generator_function] = STATE(3708),
    [sym_call_expression] = STATE(3708),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3708),
    [sym_ternary_expression] = STATE(3708),
    [sym_binary_expression] = STATE(3708),
    [sym_template_string] = STATE(3708),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3708),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3708),
    [sym_class] = STATE(3708),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(7761),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7761),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7763),
    [sym_true] = ACTIONS(7761),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7761),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3011] = {
    [sym_new_expression] = STATE(3709),
    [sym_augmented_assignment_expression] = STATE(3709),
    [sym_unary_expression] = STATE(3709),
    [sym_update_expression] = STATE(3709),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3709),
    [sym_regex] = STATE(3709),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3709),
    [sym_non_null_expression] = STATE(3709),
    [sym_as_expression] = STATE(3709),
    [sym_jsx_fragment] = STATE(3709),
    [sym_yield_expression] = STATE(3709),
    [sym_jsx_element] = STATE(3709),
    [sym_internal_module] = STATE(3709),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3709),
    [sym_await_expression] = STATE(3709),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3709),
    [sym_this] = STATE(3709),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3709),
    [sym_generator_function] = STATE(3709),
    [sym_call_expression] = STATE(3709),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3709),
    [sym_ternary_expression] = STATE(3709),
    [sym_binary_expression] = STATE(3709),
    [sym_template_string] = STATE(3709),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3709),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3709),
    [sym_class] = STATE(3709),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(7765),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7765),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7767),
    [sym_true] = ACTIONS(7765),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7765),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3012] = {
    [sym_new_expression] = STATE(3710),
    [sym_augmented_assignment_expression] = STATE(3710),
    [sym_unary_expression] = STATE(3710),
    [sym_update_expression] = STATE(3710),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3710),
    [sym_regex] = STATE(3710),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1240),
    [sym__expression] = STATE(3710),
    [sym_non_null_expression] = STATE(3710),
    [sym_yield_expression] = STATE(3710),
    [sym_jsx_fragment] = STATE(3710),
    [sym_jsx_element] = STATE(3710),
    [sym_as_expression] = STATE(3710),
    [sym_internal_module] = STATE(3710),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3710),
    [sym_await_expression] = STATE(3710),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3710),
    [sym_this] = STATE(3710),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3710),
    [sym_generator_function] = STATE(3710),
    [sym_call_expression] = STATE(3710),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3710),
    [sym_ternary_expression] = STATE(3710),
    [sym_binary_expression] = STATE(3710),
    [sym_template_string] = STATE(3710),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3710),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3710),
    [sym_class] = STATE(3710),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(7769),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7769),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7771),
    [sym_true] = ACTIONS(7769),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7769),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3013] = {
    [sym_new_expression] = STATE(3711),
    [sym_augmented_assignment_expression] = STATE(3711),
    [sym_unary_expression] = STATE(3711),
    [sym_update_expression] = STATE(3711),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3711),
    [sym_regex] = STATE(3711),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3711),
    [sym_non_null_expression] = STATE(3711),
    [sym_as_expression] = STATE(3711),
    [sym_jsx_fragment] = STATE(3711),
    [sym_yield_expression] = STATE(3711),
    [sym_jsx_element] = STATE(3711),
    [sym_internal_module] = STATE(3711),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3711),
    [sym_await_expression] = STATE(3711),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3711),
    [sym_this] = STATE(3711),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3711),
    [sym_generator_function] = STATE(3711),
    [sym_call_expression] = STATE(3711),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3711),
    [sym_ternary_expression] = STATE(3711),
    [sym_binary_expression] = STATE(3711),
    [sym_template_string] = STATE(3711),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3711),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3711),
    [sym_class] = STATE(3711),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(7773),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7773),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7775),
    [sym_true] = ACTIONS(7773),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7773),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3014] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_RPAREN] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(7777),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [3015] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_RPAREN] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(7777),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [3016] = {
    [anon_sym_EQ_GT] = ACTIONS(7780),
    [sym_comment] = ACTIONS(3),
  },
  [3017] = {
    [anon_sym_EQ_GT] = ACTIONS(7782),
    [sym_comment] = ACTIONS(3),
  },
  [3018] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_BQUOTE] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_RPAREN] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_instanceof] = ACTIONS(839),
    [anon_sym_SLASH] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_in] = ACTIONS(841),
  },
  [3019] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_RPAREN] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_in] = ACTIONS(6321),
  },
  [3020] = {
    [sym__initializer] = STATE(522),
    [sym_arguments] = STATE(1268),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(6319),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1531),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1529),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [3021] = {
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(6325),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_RPAREN] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [3022] = {
    [sym_new_expression] = STATE(836),
    [sym_augmented_assignment_expression] = STATE(836),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(836),
    [sym_update_expression] = STATE(836),
    [sym_regex] = STATE(836),
    [sym_meta_property] = STATE(836),
    [sym_call_signature] = STATE(835),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(836),
    [sym_non_null_expression] = STATE(836),
    [sym_yield_expression] = STATE(836),
    [sym_jsx_fragment] = STATE(836),
    [sym_jsx_element] = STATE(836),
    [sym_as_expression] = STATE(836),
    [sym_internal_module] = STATE(836),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(836),
    [sym_await_expression] = STATE(836),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(836),
    [sym_this] = STATE(836),
    [sym_arguments] = STATE(1270),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(836),
    [sym_generator_function] = STATE(836),
    [sym_call_expression] = STATE(836),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(836),
    [sym_ternary_expression] = STATE(836),
    [sym_binary_expression] = STATE(836),
    [sym_template_string] = STATE(836),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(836),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(836),
    [sym_class] = STATE(836),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(500),
    [sym_true] = ACTIONS(1545),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [sym_false] = ACTIONS(1545),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [sym_null] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(6325),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_RPAREN] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [sym_number] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [3023] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_arguments] = STATE(1270),
    [sym_call_signature] = STATE(3016),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(6335),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(6337),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(6337),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(6337),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(6337),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_protected] = ACTIONS(6337),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(6337),
    [anon_sym_type] = ACTIONS(6337),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(6337),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(6337),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(6337),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(6337),
    [anon_sym_declare] = ACTIONS(6337),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(6337),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(6337),
    [anon_sym_async] = ACTIONS(6337),
    [anon_sym_public] = ACTIONS(6337),
    [anon_sym_EQ_GT] = ACTIONS(6325),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_RPAREN] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(6337),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(6337),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [3024] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(6325),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_RPAREN] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [3025] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_RPAREN] = ACTIONS(915),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_in] = ACTIONS(6321),
  },
  [3026] = {
    [sym_new_expression] = STATE(3714),
    [sym_augmented_assignment_expression] = STATE(3714),
    [sym_unary_expression] = STATE(3714),
    [sym_update_expression] = STATE(3714),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3714),
    [sym_regex] = STATE(3714),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3714),
    [sym_non_null_expression] = STATE(3714),
    [sym_as_expression] = STATE(3714),
    [sym_jsx_fragment] = STATE(3714),
    [sym_yield_expression] = STATE(3714),
    [sym_jsx_element] = STATE(3714),
    [sym_internal_module] = STATE(3714),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3714),
    [sym_await_expression] = STATE(3714),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3714),
    [sym_this] = STATE(3714),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3714),
    [sym_generator_function] = STATE(3714),
    [sym_call_expression] = STATE(3714),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3714),
    [sym_ternary_expression] = STATE(3714),
    [sym_binary_expression] = STATE(3714),
    [sym_template_string] = STATE(3714),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3714),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3714),
    [sym_class] = STATE(3714),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(7784),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7784),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7786),
    [sym_true] = ACTIONS(7784),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7784),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3027] = {
    [sym_new_expression] = STATE(3715),
    [sym_augmented_assignment_expression] = STATE(3715),
    [sym_unary_expression] = STATE(3715),
    [sym_update_expression] = STATE(3715),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3715),
    [sym_regex] = STATE(3715),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3715),
    [sym_non_null_expression] = STATE(3715),
    [sym_as_expression] = STATE(3715),
    [sym_jsx_fragment] = STATE(3715),
    [sym_yield_expression] = STATE(3715),
    [sym_jsx_element] = STATE(3715),
    [sym_internal_module] = STATE(3715),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3715),
    [sym_await_expression] = STATE(3715),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3715),
    [sym_this] = STATE(3715),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3715),
    [sym_generator_function] = STATE(3715),
    [sym_call_expression] = STATE(3715),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3715),
    [sym_ternary_expression] = STATE(3715),
    [sym_binary_expression] = STATE(3715),
    [sym_template_string] = STATE(3715),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3715),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3715),
    [sym_class] = STATE(3715),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(7788),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7788),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7790),
    [sym_true] = ACTIONS(7788),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7788),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3028] = {
    [sym_new_expression] = STATE(3716),
    [sym_augmented_assignment_expression] = STATE(3716),
    [sym_unary_expression] = STATE(3716),
    [sym_update_expression] = STATE(3716),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3716),
    [sym_regex] = STATE(3716),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3716),
    [sym_non_null_expression] = STATE(3716),
    [sym_as_expression] = STATE(3716),
    [sym_jsx_fragment] = STATE(3716),
    [sym_yield_expression] = STATE(3716),
    [sym_jsx_element] = STATE(3716),
    [sym_internal_module] = STATE(3716),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3716),
    [sym_await_expression] = STATE(3716),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3716),
    [sym_this] = STATE(3716),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3716),
    [sym_generator_function] = STATE(3716),
    [sym_call_expression] = STATE(3716),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3716),
    [sym_ternary_expression] = STATE(3716),
    [sym_binary_expression] = STATE(3716),
    [sym_template_string] = STATE(3716),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3716),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3716),
    [sym_class] = STATE(3716),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(7792),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7792),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7794),
    [sym_true] = ACTIONS(7792),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7792),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3029] = {
    [sym_new_expression] = STATE(3717),
    [sym_augmented_assignment_expression] = STATE(3717),
    [sym_unary_expression] = STATE(3717),
    [sym_update_expression] = STATE(3717),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3717),
    [sym_regex] = STATE(3717),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3717),
    [sym_non_null_expression] = STATE(3717),
    [sym_as_expression] = STATE(3717),
    [sym_jsx_fragment] = STATE(3717),
    [sym_yield_expression] = STATE(3717),
    [sym_jsx_element] = STATE(3717),
    [sym_internal_module] = STATE(3717),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3717),
    [sym_await_expression] = STATE(3717),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3717),
    [sym_this] = STATE(3717),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3717),
    [sym_generator_function] = STATE(3717),
    [sym_call_expression] = STATE(3717),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3717),
    [sym_ternary_expression] = STATE(3717),
    [sym_binary_expression] = STATE(3717),
    [sym_template_string] = STATE(3717),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3717),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3717),
    [sym_class] = STATE(3717),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(7796),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7796),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7798),
    [sym_true] = ACTIONS(7796),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7796),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3030] = {
    [sym_new_expression] = STATE(3718),
    [sym_augmented_assignment_expression] = STATE(3718),
    [sym_unary_expression] = STATE(3718),
    [sym_update_expression] = STATE(3718),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(3718),
    [sym_regex] = STATE(3718),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3718),
    [sym_non_null_expression] = STATE(3718),
    [sym_as_expression] = STATE(3718),
    [sym_jsx_fragment] = STATE(3718),
    [sym_yield_expression] = STATE(3718),
    [sym_jsx_element] = STATE(3718),
    [sym_internal_module] = STATE(3718),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3718),
    [sym_await_expression] = STATE(3718),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(3718),
    [sym_this] = STATE(3718),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(3718),
    [sym_generator_function] = STATE(3718),
    [sym_call_expression] = STATE(3718),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(3718),
    [sym_ternary_expression] = STATE(3718),
    [sym_binary_expression] = STATE(3718),
    [sym_template_string] = STATE(3718),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3718),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3718),
    [sym_class] = STATE(3718),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(7800),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7800),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7802),
    [sym_true] = ACTIONS(7800),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7800),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [3031] = {
    [sym_union_type] = STATE(1293),
    [sym__type] = STATE(1293),
    [sym_constructor_type] = STATE(1293),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3724),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_template_string] = STATE(1297),
    [sym_intersection_type] = STATE(1293),
    [sym_function_type] = STATE(1293),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3725),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(7804),
    [sym_false] = ACTIONS(2643),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_PIPE] = ACTIONS(7806),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_boolean] = ACTIONS(2647),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(7808),
    [anon_sym_QMARK] = ACTIONS(7810),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2669),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_new] = ACTIONS(7812),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_DQUOTE] = ACTIONS(304),
  },
  [3032] = {
    [sym_new_expression] = STATE(3707),
    [sym_constructor_type] = STATE(432),
    [sym_augmented_assignment_expression] = STATE(3707),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(3707),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(3707),
    [sym_type_parameters] = STATE(959),
    [sym_array_type] = STATE(436),
    [sym_yield_expression] = STATE(3707),
    [sym_as_expression] = STATE(3707),
    [sym_jsx_fragment] = STATE(3707),
    [sym_internal_module] = STATE(3707),
    [sym_arrow_function] = STATE(3707),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(2151),
    [sym_literal_type] = STATE(436),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(1650),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(3707),
    [sym_subscript_expression] = STATE(2151),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(3707),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(3707),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(960),
    [sym_function_type] = STATE(432),
    [sym__type] = STATE(432),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(3707),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3707),
    [sym__expression] = STATE(3707),
    [sym_non_null_expression] = STATE(3707),
    [sym_jsx_element] = STATE(3707),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_await_expression] = STATE(3707),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_this] = STATE(3707),
    [sym_union_type] = STATE(432),
    [sym_anonymous_class] = STATE(3707),
    [sym_call_expression] = STATE(3707),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(3707),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(3707),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(432),
    [sym_parenthesized_expression] = STATE(3707),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3707),
    [sym_class] = STATE(3707),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(7814),
    [sym_false] = ACTIONS(3450),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(7816),
    [anon_sym_number] = ACTIONS(7816),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(7818),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(7820),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_void] = ACTIONS(7822),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [sym_null] = ACTIONS(7757),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(7816),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(7816),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3462),
    [sym_true] = ACTIONS(3450),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(3464),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(7816),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7757),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(7824),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(7820),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3033] = {
    [sym_type_alias_declaration] = STATE(3732),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3732),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3732),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3732),
    [sym_return_statement] = STATE(3732),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3732),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3732),
    [sym_switch_statement] = STATE(3732),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3732),
    [sym_throw_statement] = STATE(3732),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3732),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3732),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(3732),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3732),
    [sym_abstract_class] = STATE(3732),
    [sym_interface_declaration] = STATE(3732),
    [sym_statement_block] = STATE(3732),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3732),
    [sym_debugger_statement] = STATE(3732),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3732),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3732),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3732),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3732),
    [sym_empty_statement] = STATE(3732),
    [sym_import_alias] = STATE(3732),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3732),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3732),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3732),
    [sym_break_statement] = STATE(3732),
    [sym_labeled_statement] = STATE(3732),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3732),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3034] = {
    [sym_new_expression] = STATE(3733),
    [sym_augmented_assignment_expression] = STATE(3733),
    [sym_unary_expression] = STATE(3733),
    [sym_update_expression] = STATE(3733),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3733),
    [sym_regex] = STATE(3733),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3733),
    [sym_non_null_expression] = STATE(3733),
    [sym_as_expression] = STATE(3733),
    [sym_jsx_fragment] = STATE(3733),
    [sym_yield_expression] = STATE(3733),
    [sym_jsx_element] = STATE(3733),
    [sym_internal_module] = STATE(3733),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3733),
    [sym_await_expression] = STATE(3733),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3733),
    [sym_this] = STATE(3733),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3733),
    [sym_generator_function] = STATE(3733),
    [sym_call_expression] = STATE(3733),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3733),
    [sym_ternary_expression] = STATE(3733),
    [sym_binary_expression] = STATE(3733),
    [sym_template_string] = STATE(3733),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3733),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3733),
    [sym_class] = STATE(3733),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(7826),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7826),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7828),
    [sym_true] = ACTIONS(7826),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7826),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3035] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(7830),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3036] = {
    [anon_sym_RPAREN] = ACTIONS(7830),
    [sym_comment] = ACTIONS(3),
  },
  [3037] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(7832),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3038] = {
    [anon_sym_RPAREN] = ACTIONS(7832),
    [sym_comment] = ACTIONS(3),
  },
  [3039] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(7834),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3040] = {
    [anon_sym_RPAREN] = ACTIONS(7834),
    [sym_comment] = ACTIONS(3),
  },
  [3041] = {
    [sym_identifier] = ACTIONS(7836),
    [anon_sym_BQUOTE] = ACTIONS(7838),
    [anon_sym_debugger] = ACTIONS(7836),
    [anon_sym_symbol] = ACTIONS(7836),
    [anon_sym_AT] = ACTIONS(7838),
    [anon_sym_DASH] = ACTIONS(7836),
    [anon_sym_void] = ACTIONS(7836),
    [anon_sym_break] = ACTIONS(7836),
    [anon_sym_const] = ACTIONS(7836),
    [sym_super] = ACTIONS(7836),
    [anon_sym_return] = ACTIONS(7836),
    [anon_sym_private] = ACTIONS(7836),
    [anon_sym_get] = ACTIONS(7836),
    [anon_sym_RBRACE] = ACTIONS(7838),
    [anon_sym_interface] = ACTIONS(7836),
    [anon_sym_default] = ACTIONS(7836),
    [anon_sym_enum] = ACTIONS(7836),
    [anon_sym_delete] = ACTIONS(7836),
    [anon_sym_continue] = ACTIONS(7836),
    [anon_sym_DASH_DASH] = ACTIONS(7838),
    [anon_sym_if] = ACTIONS(7836),
    [anon_sym_this] = ACTIONS(7836),
    [anon_sym_yield] = ACTIONS(7836),
    [sym_true] = ACTIONS(7836),
    [anon_sym_throw] = ACTIONS(7836),
    [anon_sym_protected] = ACTIONS(7836),
    [anon_sym_abstract] = ACTIONS(7836),
    [anon_sym_set] = ACTIONS(7836),
    [anon_sym_type] = ACTIONS(7836),
    [anon_sym_import] = ACTIONS(7836),
    [anon_sym_namespace] = ACTIONS(7836),
    [anon_sym_PLUS_PLUS] = ACTIONS(7838),
    [anon_sym_await] = ACTIONS(7836),
    [anon_sym_DQUOTE] = ACTIONS(7838),
    [anon_sym_else] = ACTIONS(7836),
    [anon_sym_BANG] = ACTIONS(7838),
    [anon_sym_for] = ACTIONS(7836),
    [anon_sym_LBRACK] = ACTIONS(7838),
    [sym_false] = ACTIONS(7836),
    [anon_sym_SEMI] = ACTIONS(7838),
    [anon_sym_case] = ACTIONS(7836),
    [anon_sym_module] = ACTIONS(7836),
    [anon_sym_number] = ACTIONS(7836),
    [anon_sym_class] = ACTIONS(7836),
    [anon_sym_declare] = ACTIONS(7836),
    [anon_sym_typeof] = ACTIONS(7836),
    [anon_sym_LBRACE] = ACTIONS(7838),
    [anon_sym_switch] = ACTIONS(7836),
    [anon_sym_LPAREN] = ACTIONS(7838),
    [sym_null] = ACTIONS(7836),
    [anon_sym_any] = ACTIONS(7836),
    [anon_sym_boolean] = ACTIONS(7836),
    [anon_sym_async] = ACTIONS(7836),
    [anon_sym_public] = ACTIONS(7836),
    [anon_sym_var] = ACTIONS(7836),
    [anon_sym_while] = ACTIONS(7836),
    [anon_sym_SQUOTE] = ACTIONS(7838),
    [anon_sym_try] = ACTIONS(7836),
    [anon_sym_LT] = ACTIONS(7838),
    [sym_number] = ACTIONS(7838),
    [anon_sym_SLASH] = ACTIONS(7836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7836),
    [anon_sym_function] = ACTIONS(7836),
    [sym_undefined] = ACTIONS(7836),
    [anon_sym_new] = ACTIONS(7836),
    [ts_builtin_sym_end] = ACTIONS(7838),
    [anon_sym_let] = ACTIONS(7836),
    [anon_sym_PLUS] = ACTIONS(7836),
    [anon_sym_export] = ACTIONS(7836),
    [anon_sym_do] = ACTIONS(7836),
    [anon_sym_TILDE] = ACTIONS(7838),
    [anon_sym_with] = ACTIONS(7836),
  },
  [3042] = {
    [sym_type_alias_declaration] = STATE(3737),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3737),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3737),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3737),
    [sym_return_statement] = STATE(3737),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3737),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3737),
    [sym_switch_statement] = STATE(3737),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3737),
    [sym_throw_statement] = STATE(3737),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3737),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3737),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(3737),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3737),
    [sym_abstract_class] = STATE(3737),
    [sym_interface_declaration] = STATE(3737),
    [sym_statement_block] = STATE(3737),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3737),
    [sym_debugger_statement] = STATE(3737),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3737),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3737),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3737),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3737),
    [sym_empty_statement] = STATE(3737),
    [sym_import_alias] = STATE(3737),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3737),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3737),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3737),
    [sym_break_statement] = STATE(3737),
    [sym_labeled_statement] = STATE(3737),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3737),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3043] = {
    [sym_type_alias_declaration] = STATE(3738),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3738),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3738),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3738),
    [sym_return_statement] = STATE(3738),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3738),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3738),
    [sym_switch_statement] = STATE(3738),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3738),
    [sym_throw_statement] = STATE(3738),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3738),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3738),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(3738),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3738),
    [sym_abstract_class] = STATE(3738),
    [sym_interface_declaration] = STATE(3738),
    [sym_statement_block] = STATE(3738),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3738),
    [sym_debugger_statement] = STATE(3738),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3738),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3738),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3738),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3738),
    [sym_empty_statement] = STATE(3738),
    [sym_import_alias] = STATE(3738),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3738),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3738),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3738),
    [sym_break_statement] = STATE(3738),
    [sym_labeled_statement] = STATE(3738),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3738),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3044] = {
    [sym_type_alias_declaration] = STATE(3739),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3739),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3739),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3739),
    [sym_return_statement] = STATE(3739),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3739),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3739),
    [sym_switch_statement] = STATE(3739),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3739),
    [sym_throw_statement] = STATE(3739),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3739),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3739),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(3739),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3739),
    [sym_abstract_class] = STATE(3739),
    [sym_interface_declaration] = STATE(3739),
    [sym_statement_block] = STATE(3739),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3739),
    [sym_debugger_statement] = STATE(3739),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3739),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3739),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3739),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3739),
    [sym_empty_statement] = STATE(3739),
    [sym_import_alias] = STATE(3739),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3739),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3739),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3739),
    [sym_break_statement] = STATE(3739),
    [sym_labeled_statement] = STATE(3739),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3739),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3045] = {
    [sym_type_alias_declaration] = STATE(3740),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3740),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3740),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3740),
    [sym_return_statement] = STATE(3740),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3740),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3740),
    [sym_switch_statement] = STATE(3740),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3740),
    [sym_throw_statement] = STATE(3740),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3740),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3740),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(3740),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3740),
    [sym_abstract_class] = STATE(3740),
    [sym_interface_declaration] = STATE(3740),
    [sym_statement_block] = STATE(3740),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3740),
    [sym_debugger_statement] = STATE(3740),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3740),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3740),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3740),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3740),
    [sym_empty_statement] = STATE(3740),
    [sym_import_alias] = STATE(3740),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3740),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3740),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3740),
    [sym_break_statement] = STATE(3740),
    [sym_labeled_statement] = STATE(3740),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3740),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3046] = {
    [sym_type_alias_declaration] = STATE(3741),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3741),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3741),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3741),
    [sym_return_statement] = STATE(3741),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3741),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3741),
    [sym_switch_statement] = STATE(3741),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3741),
    [sym_throw_statement] = STATE(3741),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3741),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3741),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(3741),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3741),
    [sym_abstract_class] = STATE(3741),
    [sym_interface_declaration] = STATE(3741),
    [sym_statement_block] = STATE(3741),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3741),
    [sym_debugger_statement] = STATE(3741),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3741),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3741),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3741),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3741),
    [sym_empty_statement] = STATE(3741),
    [sym_import_alias] = STATE(3741),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3741),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3741),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3741),
    [sym_break_statement] = STATE(3741),
    [sym_labeled_statement] = STATE(3741),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3741),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3047] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_BANG] = ACTIONS(3022),
    [anon_sym_BQUOTE] = ACTIONS(3024),
    [anon_sym_PIPE] = ACTIONS(3022),
    [anon_sym_COMMA] = ACTIONS(3024),
    [anon_sym_LT_LT] = ACTIONS(3024),
    [anon_sym_STAR] = ACTIONS(3022),
    [anon_sym_GT_GT_GT] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3022),
    [anon_sym_BANG_EQ] = ACTIONS(3022),
    [anon_sym_LT_EQ] = ACTIONS(3024),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_RBRACK] = ACTIONS(3024),
    [anon_sym_GT_EQ] = ACTIONS(3024),
    [anon_sym_GT] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3022),
    [anon_sym_PERCENT] = ACTIONS(3024),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_RBRACE] = ACTIONS(3024),
    [anon_sym_as] = ACTIONS(3024),
    [anon_sym_PIPE_PIPE] = ACTIONS(3024),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3024),
    [anon_sym_DASH_DASH] = ACTIONS(3024),
    [anon_sym_EQ_EQ] = ACTIONS(3022),
    [anon_sym_instanceof] = ACTIONS(3024),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_RPAREN] = ACTIONS(3024),
    [anon_sym_SLASH] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3024),
    [anon_sym_DOT] = ACTIONS(3024),
    [anon_sym_CARET] = ACTIONS(3024),
    [anon_sym_STAR_STAR] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3022),
    [anon_sym_implements] = ACTIONS(3024),
    [anon_sym_GT_GT] = ACTIONS(3022),
    [anon_sym_PLUS_PLUS] = ACTIONS(3024),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3024),
    [anon_sym_in] = ACTIONS(3022),
  },
  [3048] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6493),
    [anon_sym_LBRACK] = ACTIONS(6493),
    [anon_sym_BANG] = ACTIONS(6495),
    [anon_sym_BQUOTE] = ACTIONS(6493),
    [anon_sym_else] = ACTIONS(6493),
    [anon_sym_PIPE] = ACTIONS(6495),
    [anon_sym_COMMA] = ACTIONS(6493),
    [anon_sym_LT_LT] = ACTIONS(6493),
    [anon_sym_STAR] = ACTIONS(6495),
    [anon_sym_GT_GT_GT] = ACTIONS(6493),
    [anon_sym_AMP_AMP] = ACTIONS(6493),
    [anon_sym_DASH] = ACTIONS(6495),
    [anon_sym_LBRACE] = ACTIONS(6495),
    [anon_sym_BANG_EQ] = ACTIONS(6495),
    [anon_sym_LT_EQ] = ACTIONS(6493),
    [anon_sym_LPAREN] = ACTIONS(6493),
    [anon_sym_RBRACK] = ACTIONS(6493),
    [anon_sym_GT_EQ] = ACTIONS(6493),
    [anon_sym_GT] = ACTIONS(6495),
    [anon_sym_AMP] = ACTIONS(6495),
    [anon_sym_PERCENT] = ACTIONS(6493),
    [anon_sym_QMARK] = ACTIONS(6493),
    [anon_sym_RBRACE] = ACTIONS(6493),
    [anon_sym_as] = ACTIONS(6493),
    [anon_sym_PIPE_PIPE] = ACTIONS(6493),
    [anon_sym_while] = ACTIONS(6493),
    [anon_sym_DASH_DASH] = ACTIONS(6493),
    [anon_sym_EQ_EQ] = ACTIONS(6495),
    [anon_sym_instanceof] = ACTIONS(6493),
    [anon_sym_LT] = ACTIONS(6495),
    [anon_sym_RPAREN] = ACTIONS(6493),
    [anon_sym_SLASH] = ACTIONS(6495),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6493),
    [anon_sym_COLON] = ACTIONS(6493),
    [anon_sym_DOT] = ACTIONS(6493),
    [anon_sym_CARET] = ACTIONS(6493),
    [anon_sym_STAR_STAR] = ACTIONS(6493),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_implements] = ACTIONS(6493),
    [anon_sym_GT_GT] = ACTIONS(6495),
    [anon_sym_PLUS_PLUS] = ACTIONS(6493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6493),
    [anon_sym_in] = ACTIONS(6495),
  },
  [3049] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6953),
    [anon_sym_LBRACK] = ACTIONS(6953),
    [anon_sym_BANG] = ACTIONS(6955),
    [anon_sym_BQUOTE] = ACTIONS(6953),
    [anon_sym_else] = ACTIONS(6953),
    [anon_sym_PIPE] = ACTIONS(6955),
    [anon_sym_COMMA] = ACTIONS(6953),
    [anon_sym_LT_LT] = ACTIONS(6953),
    [anon_sym_STAR] = ACTIONS(6955),
    [anon_sym_GT_GT_GT] = ACTIONS(6953),
    [anon_sym_AMP_AMP] = ACTIONS(6953),
    [anon_sym_DASH] = ACTIONS(6955),
    [anon_sym_LBRACE] = ACTIONS(6955),
    [anon_sym_BANG_EQ] = ACTIONS(6955),
    [anon_sym_LT_EQ] = ACTIONS(6953),
    [anon_sym_LPAREN] = ACTIONS(6953),
    [anon_sym_RBRACK] = ACTIONS(6953),
    [anon_sym_GT_EQ] = ACTIONS(6953),
    [anon_sym_GT] = ACTIONS(6955),
    [anon_sym_AMP] = ACTIONS(6955),
    [anon_sym_PERCENT] = ACTIONS(6953),
    [anon_sym_QMARK] = ACTIONS(6953),
    [anon_sym_RBRACE] = ACTIONS(6953),
    [anon_sym_as] = ACTIONS(6953),
    [anon_sym_PIPE_PIPE] = ACTIONS(6953),
    [anon_sym_while] = ACTIONS(6953),
    [anon_sym_DASH_DASH] = ACTIONS(6953),
    [anon_sym_EQ_EQ] = ACTIONS(6955),
    [anon_sym_instanceof] = ACTIONS(6953),
    [anon_sym_LT] = ACTIONS(6955),
    [anon_sym_RPAREN] = ACTIONS(6953),
    [anon_sym_SLASH] = ACTIONS(6955),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6953),
    [anon_sym_COLON] = ACTIONS(6953),
    [anon_sym_DOT] = ACTIONS(6953),
    [anon_sym_CARET] = ACTIONS(6953),
    [anon_sym_STAR_STAR] = ACTIONS(6953),
    [anon_sym_PLUS] = ACTIONS(6955),
    [anon_sym_implements] = ACTIONS(6953),
    [anon_sym_GT_GT] = ACTIONS(6955),
    [anon_sym_PLUS_PLUS] = ACTIONS(6953),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6953),
    [anon_sym_in] = ACTIONS(6955),
  },
  [3050] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6959),
    [anon_sym_LBRACK] = ACTIONS(6959),
    [anon_sym_BANG] = ACTIONS(6961),
    [anon_sym_BQUOTE] = ACTIONS(6959),
    [anon_sym_PIPE] = ACTIONS(6961),
    [anon_sym_COMMA] = ACTIONS(6959),
    [anon_sym_LT_LT] = ACTIONS(6959),
    [anon_sym_STAR] = ACTIONS(6961),
    [anon_sym_GT_GT_GT] = ACTIONS(6959),
    [anon_sym_AMP_AMP] = ACTIONS(6959),
    [anon_sym_DASH] = ACTIONS(6961),
    [anon_sym_LBRACE] = ACTIONS(6961),
    [anon_sym_BANG_EQ] = ACTIONS(6961),
    [anon_sym_LT_EQ] = ACTIONS(6959),
    [anon_sym_LPAREN] = ACTIONS(6959),
    [anon_sym_RBRACK] = ACTIONS(6959),
    [anon_sym_GT_EQ] = ACTIONS(6959),
    [anon_sym_GT] = ACTIONS(6961),
    [anon_sym_AMP] = ACTIONS(6961),
    [anon_sym_PERCENT] = ACTIONS(6959),
    [anon_sym_QMARK] = ACTIONS(6959),
    [anon_sym_RBRACE] = ACTIONS(6959),
    [anon_sym_as] = ACTIONS(6959),
    [anon_sym_PIPE_PIPE] = ACTIONS(6959),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6959),
    [anon_sym_DASH_DASH] = ACTIONS(6959),
    [anon_sym_EQ_EQ] = ACTIONS(6961),
    [anon_sym_instanceof] = ACTIONS(6959),
    [anon_sym_LT] = ACTIONS(6961),
    [anon_sym_RPAREN] = ACTIONS(6959),
    [anon_sym_SLASH] = ACTIONS(6961),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6959),
    [anon_sym_DOT] = ACTIONS(6959),
    [anon_sym_CARET] = ACTIONS(6959),
    [anon_sym_STAR_STAR] = ACTIONS(6959),
    [anon_sym_PLUS] = ACTIONS(6961),
    [anon_sym_implements] = ACTIONS(6959),
    [anon_sym_GT_GT] = ACTIONS(6961),
    [anon_sym_PLUS_PLUS] = ACTIONS(6959),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6959),
    [anon_sym_in] = ACTIONS(6961),
  },
  [3051] = {
    [anon_sym_GT] = ACTIONS(7840),
    [sym_comment] = ACTIONS(3),
  },
  [3052] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6997),
    [anon_sym_LBRACK] = ACTIONS(6997),
    [anon_sym_BANG] = ACTIONS(6999),
    [anon_sym_BQUOTE] = ACTIONS(6997),
    [anon_sym_PIPE] = ACTIONS(6999),
    [anon_sym_COMMA] = ACTIONS(6997),
    [anon_sym_LT_LT] = ACTIONS(6997),
    [anon_sym_STAR] = ACTIONS(6999),
    [anon_sym_GT_GT_GT] = ACTIONS(6997),
    [anon_sym_AMP_AMP] = ACTIONS(6997),
    [anon_sym_DASH] = ACTIONS(6999),
    [anon_sym_LBRACE] = ACTIONS(6999),
    [anon_sym_BANG_EQ] = ACTIONS(6999),
    [anon_sym_LT_EQ] = ACTIONS(6997),
    [anon_sym_LPAREN] = ACTIONS(6997),
    [anon_sym_RBRACK] = ACTIONS(6997),
    [anon_sym_GT_EQ] = ACTIONS(6997),
    [anon_sym_GT] = ACTIONS(6999),
    [anon_sym_AMP] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(6997),
    [anon_sym_QMARK] = ACTIONS(6997),
    [anon_sym_RBRACE] = ACTIONS(6997),
    [anon_sym_as] = ACTIONS(6997),
    [anon_sym_PIPE_PIPE] = ACTIONS(6997),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6997),
    [anon_sym_DASH_DASH] = ACTIONS(6997),
    [anon_sym_EQ_EQ] = ACTIONS(6999),
    [anon_sym_instanceof] = ACTIONS(6997),
    [anon_sym_LT] = ACTIONS(6999),
    [anon_sym_RPAREN] = ACTIONS(6997),
    [anon_sym_SLASH] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6997),
    [anon_sym_DOT] = ACTIONS(6997),
    [anon_sym_CARET] = ACTIONS(6997),
    [anon_sym_STAR_STAR] = ACTIONS(6997),
    [anon_sym_PLUS] = ACTIONS(6999),
    [anon_sym_implements] = ACTIONS(6997),
    [anon_sym_GT_GT] = ACTIONS(6999),
    [anon_sym_PLUS_PLUS] = ACTIONS(6997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6997),
    [anon_sym_in] = ACTIONS(6999),
  },
  [3053] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7023),
    [anon_sym_LBRACK] = ACTIONS(7023),
    [anon_sym_BANG] = ACTIONS(7025),
    [anon_sym_BQUOTE] = ACTIONS(7023),
    [anon_sym_else] = ACTIONS(7023),
    [anon_sym_PIPE] = ACTIONS(7025),
    [anon_sym_COMMA] = ACTIONS(7023),
    [anon_sym_LT_LT] = ACTIONS(7023),
    [anon_sym_STAR] = ACTIONS(7025),
    [anon_sym_GT_GT_GT] = ACTIONS(7023),
    [anon_sym_AMP_AMP] = ACTIONS(7023),
    [anon_sym_DASH] = ACTIONS(7025),
    [anon_sym_LBRACE] = ACTIONS(7025),
    [anon_sym_BANG_EQ] = ACTIONS(7025),
    [anon_sym_LT_EQ] = ACTIONS(7023),
    [anon_sym_LPAREN] = ACTIONS(7023),
    [anon_sym_RBRACK] = ACTIONS(7023),
    [anon_sym_GT_EQ] = ACTIONS(7023),
    [anon_sym_GT] = ACTIONS(7025),
    [anon_sym_AMP] = ACTIONS(7025),
    [anon_sym_PERCENT] = ACTIONS(7023),
    [anon_sym_QMARK] = ACTIONS(7023),
    [anon_sym_RBRACE] = ACTIONS(7023),
    [anon_sym_as] = ACTIONS(7023),
    [anon_sym_PIPE_PIPE] = ACTIONS(7023),
    [anon_sym_while] = ACTIONS(7023),
    [anon_sym_DASH_DASH] = ACTIONS(7023),
    [anon_sym_EQ_EQ] = ACTIONS(7025),
    [anon_sym_instanceof] = ACTIONS(7023),
    [anon_sym_LT] = ACTIONS(7025),
    [anon_sym_RPAREN] = ACTIONS(7023),
    [anon_sym_SLASH] = ACTIONS(7025),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(7023),
    [anon_sym_COLON] = ACTIONS(7023),
    [anon_sym_DOT] = ACTIONS(7023),
    [anon_sym_CARET] = ACTIONS(7023),
    [anon_sym_STAR_STAR] = ACTIONS(7023),
    [anon_sym_PLUS] = ACTIONS(7025),
    [anon_sym_implements] = ACTIONS(7023),
    [anon_sym_GT_GT] = ACTIONS(7025),
    [anon_sym_PLUS_PLUS] = ACTIONS(7023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7023),
    [anon_sym_in] = ACTIONS(7025),
  },
  [3054] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(7181),
    [anon_sym_LT_LT] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_GT_GT_GT] = ACTIONS(1047),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1049),
    [anon_sym_BANG_EQ] = ACTIONS(945),
    [anon_sym_LT_EQ] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(7181),
    [anon_sym_GT_EQ] = ACTIONS(1043),
    [anon_sym_GT] = ACTIONS(945),
    [anon_sym_AMP] = ACTIONS(1057),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_as] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(945),
    [anon_sym_instanceof] = ACTIONS(1043),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1049),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1043),
    [anon_sym_in] = ACTIONS(945),
  },
  [3055] = {
    [anon_sym_AMP] = ACTIONS(5881),
    [anon_sym_PIPE] = ACTIONS(5883),
    [anon_sym_RBRACK] = ACTIONS(7842),
    [sym_comment] = ACTIONS(3),
  },
  [3056] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5891),
    [anon_sym_LBRACK] = ACTIONS(5891),
    [anon_sym_BANG] = ACTIONS(5889),
    [anon_sym_BQUOTE] = ACTIONS(5891),
    [anon_sym_PIPE] = ACTIONS(5889),
    [anon_sym_COMMA] = ACTIONS(5891),
    [anon_sym_LT_LT] = ACTIONS(5891),
    [anon_sym_STAR] = ACTIONS(5889),
    [anon_sym_GT_GT_GT] = ACTIONS(5891),
    [anon_sym_AMP_AMP] = ACTIONS(5891),
    [anon_sym_DASH] = ACTIONS(5889),
    [anon_sym_LBRACE] = ACTIONS(5889),
    [anon_sym_BANG_EQ] = ACTIONS(5889),
    [anon_sym_LT_EQ] = ACTIONS(5891),
    [anon_sym_LPAREN] = ACTIONS(5891),
    [anon_sym_RBRACK] = ACTIONS(5891),
    [anon_sym_GT_EQ] = ACTIONS(5891),
    [anon_sym_GT] = ACTIONS(5889),
    [anon_sym_AMP] = ACTIONS(5889),
    [anon_sym_PERCENT] = ACTIONS(5891),
    [anon_sym_QMARK] = ACTIONS(5891),
    [anon_sym_RBRACE] = ACTIONS(5891),
    [anon_sym_as] = ACTIONS(5891),
    [anon_sym_PIPE_PIPE] = ACTIONS(5891),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5891),
    [anon_sym_DASH_DASH] = ACTIONS(5891),
    [anon_sym_EQ_EQ] = ACTIONS(5889),
    [anon_sym_instanceof] = ACTIONS(5891),
    [anon_sym_LT] = ACTIONS(5889),
    [anon_sym_RPAREN] = ACTIONS(5891),
    [anon_sym_SLASH] = ACTIONS(5889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5891),
    [anon_sym_DOT] = ACTIONS(7189),
    [anon_sym_CARET] = ACTIONS(5891),
    [anon_sym_STAR_STAR] = ACTIONS(5891),
    [anon_sym_PLUS] = ACTIONS(5889),
    [anon_sym_implements] = ACTIONS(5891),
    [anon_sym_GT_GT] = ACTIONS(5889),
    [anon_sym_PLUS_PLUS] = ACTIONS(5891),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5891),
    [anon_sym_in] = ACTIONS(5889),
  },
  [3057] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(7192),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(7844),
    [anon_sym_COMMA] = ACTIONS(5893),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_GT_GT_GT] = ACTIONS(5893),
    [anon_sym_AMP_AMP] = ACTIONS(5893),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_BANG_EQ] = ACTIONS(7192),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [anon_sym_RBRACK] = ACTIONS(5893),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(5893),
    [anon_sym_QMARK] = ACTIONS(5893),
    [anon_sym_as] = ACTIONS(5893),
    [anon_sym_PIPE_PIPE] = ACTIONS(5893),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_EQ_EQ] = ACTIONS(7192),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5893),
    [anon_sym_CARET] = ACTIONS(5893),
    [anon_sym_STAR_STAR] = ACTIONS(5893),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_in] = ACTIONS(7192),
  },
  [3058] = {
    [aux_sym_object_type_repeat1] = STATE(3746),
    [sym__automatic_semicolon] = ACTIONS(7848),
    [anon_sym_RBRACE] = ACTIONS(7850),
    [anon_sym_SEMI] = ACTIONS(7848),
    [anon_sym_COMMA] = ACTIONS(7848),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7850),
    [sym_comment] = ACTIONS(3),
  },
  [3059] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(2866),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(2866),
    [sym_call_signature] = STATE(2866),
    [sym_export_statement] = STATE(2866),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(2866),
    [sym_index_signature] = STATE(2866),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_RBRACE] = ACTIONS(7850),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7850),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [3060] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5979),
    [anon_sym_LBRACK] = ACTIONS(5979),
    [anon_sym_BANG] = ACTIONS(5977),
    [anon_sym_BQUOTE] = ACTIONS(5979),
    [anon_sym_PIPE] = ACTIONS(5977),
    [anon_sym_COMMA] = ACTIONS(5979),
    [anon_sym_LT_LT] = ACTIONS(5979),
    [anon_sym_STAR] = ACTIONS(5977),
    [anon_sym_GT_GT_GT] = ACTIONS(5979),
    [anon_sym_AMP_AMP] = ACTIONS(5979),
    [anon_sym_DASH] = ACTIONS(5977),
    [anon_sym_LBRACE] = ACTIONS(5977),
    [anon_sym_BANG_EQ] = ACTIONS(5977),
    [anon_sym_LT_EQ] = ACTIONS(5979),
    [anon_sym_LPAREN] = ACTIONS(5979),
    [anon_sym_RBRACK] = ACTIONS(5979),
    [anon_sym_GT_EQ] = ACTIONS(5979),
    [anon_sym_GT] = ACTIONS(5977),
    [anon_sym_AMP] = ACTIONS(5977),
    [anon_sym_PERCENT] = ACTIONS(5979),
    [anon_sym_QMARK] = ACTIONS(5979),
    [anon_sym_RBRACE] = ACTIONS(5979),
    [anon_sym_as] = ACTIONS(5979),
    [anon_sym_PIPE_PIPE] = ACTIONS(5979),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5979),
    [anon_sym_DASH_DASH] = ACTIONS(5979),
    [anon_sym_EQ_EQ] = ACTIONS(5977),
    [anon_sym_instanceof] = ACTIONS(5979),
    [anon_sym_LT] = ACTIONS(5977),
    [anon_sym_RPAREN] = ACTIONS(5979),
    [anon_sym_SLASH] = ACTIONS(5977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5979),
    [anon_sym_DOT] = ACTIONS(5979),
    [anon_sym_CARET] = ACTIONS(5979),
    [anon_sym_STAR_STAR] = ACTIONS(5979),
    [anon_sym_PLUS] = ACTIONS(5977),
    [anon_sym_implements] = ACTIONS(5979),
    [anon_sym_GT_GT] = ACTIONS(5977),
    [anon_sym_PLUS_PLUS] = ACTIONS(5979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5979),
    [anon_sym_in] = ACTIONS(5977),
  },
  [3061] = {
    [aux_sym_object_type_repeat1] = STATE(2867),
    [sym__automatic_semicolon] = ACTIONS(7848),
    [anon_sym_RBRACE] = ACTIONS(7850),
    [anon_sym_SEMI] = ACTIONS(7848),
    [anon_sym_COMMA] = ACTIONS(7848),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7850),
    [sym_comment] = ACTIONS(3),
  },
  [3062] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5993),
    [anon_sym_LBRACK] = ACTIONS(5993),
    [anon_sym_BANG] = ACTIONS(5991),
    [anon_sym_BQUOTE] = ACTIONS(5993),
    [anon_sym_PIPE] = ACTIONS(5991),
    [anon_sym_COMMA] = ACTIONS(5993),
    [anon_sym_LT_LT] = ACTIONS(5993),
    [anon_sym_STAR] = ACTIONS(5991),
    [anon_sym_GT_GT_GT] = ACTIONS(5993),
    [anon_sym_AMP_AMP] = ACTIONS(5993),
    [anon_sym_DASH] = ACTIONS(5991),
    [anon_sym_LBRACE] = ACTIONS(5991),
    [anon_sym_BANG_EQ] = ACTIONS(5991),
    [anon_sym_LT_EQ] = ACTIONS(5993),
    [anon_sym_LPAREN] = ACTIONS(5993),
    [anon_sym_RBRACK] = ACTIONS(5993),
    [anon_sym_GT_EQ] = ACTIONS(5993),
    [anon_sym_GT] = ACTIONS(5991),
    [anon_sym_AMP] = ACTIONS(5991),
    [anon_sym_PERCENT] = ACTIONS(5993),
    [anon_sym_QMARK] = ACTIONS(5993),
    [anon_sym_RBRACE] = ACTIONS(5993),
    [anon_sym_as] = ACTIONS(5993),
    [anon_sym_PIPE_PIPE] = ACTIONS(5993),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5993),
    [anon_sym_DASH_DASH] = ACTIONS(5993),
    [anon_sym_EQ_EQ] = ACTIONS(5991),
    [anon_sym_instanceof] = ACTIONS(5993),
    [anon_sym_LT] = ACTIONS(5991),
    [anon_sym_RPAREN] = ACTIONS(5993),
    [anon_sym_SLASH] = ACTIONS(5991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5993),
    [anon_sym_DOT] = ACTIONS(5993),
    [anon_sym_CARET] = ACTIONS(5993),
    [anon_sym_STAR_STAR] = ACTIONS(5993),
    [anon_sym_PLUS] = ACTIONS(5991),
    [anon_sym_implements] = ACTIONS(5993),
    [anon_sym_GT_GT] = ACTIONS(5991),
    [anon_sym_PLUS_PLUS] = ACTIONS(5993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5993),
    [anon_sym_in] = ACTIONS(5991),
  },
  [3063] = {
    [aux_sym_implements_clause_repeat1] = STATE(2879),
    [anon_sym_COMMA] = ACTIONS(4165),
    [anon_sym_RBRACK] = ACTIONS(7852),
    [sym_comment] = ACTIONS(3),
  },
  [3064] = {
    [anon_sym_EQ_GT] = ACTIONS(7854),
    [sym_comment] = ACTIONS(3),
  },
  [3065] = {
    [sym_union_type] = STATE(3749),
    [sym__type] = STATE(3749),
    [sym_constructor_type] = STATE(3749),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1295),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3749),
    [sym_function_type] = STATE(3749),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1299),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(2641),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(2667),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3066] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6011),
    [anon_sym_LBRACK] = ACTIONS(6011),
    [anon_sym_BANG] = ACTIONS(6009),
    [anon_sym_BQUOTE] = ACTIONS(6011),
    [anon_sym_PIPE] = ACTIONS(6009),
    [anon_sym_COMMA] = ACTIONS(6011),
    [anon_sym_LT_LT] = ACTIONS(6011),
    [anon_sym_STAR] = ACTIONS(6009),
    [anon_sym_GT_GT_GT] = ACTIONS(6011),
    [anon_sym_AMP_AMP] = ACTIONS(6011),
    [anon_sym_DASH] = ACTIONS(6009),
    [anon_sym_LBRACE] = ACTIONS(6009),
    [anon_sym_BANG_EQ] = ACTIONS(6009),
    [anon_sym_LT_EQ] = ACTIONS(6011),
    [anon_sym_LPAREN] = ACTIONS(6011),
    [anon_sym_RBRACK] = ACTIONS(6011),
    [anon_sym_GT_EQ] = ACTIONS(6011),
    [anon_sym_GT] = ACTIONS(6009),
    [anon_sym_AMP] = ACTIONS(6009),
    [anon_sym_PERCENT] = ACTIONS(6011),
    [anon_sym_QMARK] = ACTIONS(6011),
    [anon_sym_RBRACE] = ACTIONS(6011),
    [anon_sym_as] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6011),
    [anon_sym_DASH_DASH] = ACTIONS(6011),
    [anon_sym_EQ_EQ] = ACTIONS(6009),
    [anon_sym_instanceof] = ACTIONS(6011),
    [anon_sym_LT] = ACTIONS(6009),
    [anon_sym_RPAREN] = ACTIONS(6011),
    [anon_sym_SLASH] = ACTIONS(6009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6011),
    [anon_sym_DOT] = ACTIONS(6011),
    [anon_sym_CARET] = ACTIONS(6011),
    [anon_sym_STAR_STAR] = ACTIONS(6011),
    [anon_sym_PLUS] = ACTIONS(6009),
    [anon_sym_implements] = ACTIONS(6011),
    [anon_sym_GT_GT] = ACTIONS(6009),
    [anon_sym_PLUS_PLUS] = ACTIONS(6011),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6011),
    [anon_sym_in] = ACTIONS(6009),
  },
  [3067] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6017),
    [anon_sym_LBRACK] = ACTIONS(6017),
    [anon_sym_BANG] = ACTIONS(6015),
    [anon_sym_BQUOTE] = ACTIONS(6017),
    [anon_sym_PIPE] = ACTIONS(6015),
    [anon_sym_COMMA] = ACTIONS(6017),
    [anon_sym_LT_LT] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(6015),
    [anon_sym_GT_GT_GT] = ACTIONS(6017),
    [anon_sym_AMP_AMP] = ACTIONS(6017),
    [anon_sym_DASH] = ACTIONS(6015),
    [anon_sym_LBRACE] = ACTIONS(6015),
    [anon_sym_BANG_EQ] = ACTIONS(6015),
    [anon_sym_LT_EQ] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(6017),
    [anon_sym_RBRACK] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6017),
    [anon_sym_GT] = ACTIONS(6015),
    [anon_sym_AMP] = ACTIONS(6015),
    [anon_sym_PERCENT] = ACTIONS(6017),
    [anon_sym_QMARK] = ACTIONS(6017),
    [anon_sym_RBRACE] = ACTIONS(6017),
    [anon_sym_as] = ACTIONS(6017),
    [anon_sym_PIPE_PIPE] = ACTIONS(6017),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6017),
    [anon_sym_DASH_DASH] = ACTIONS(6017),
    [anon_sym_EQ_EQ] = ACTIONS(6015),
    [anon_sym_instanceof] = ACTIONS(6017),
    [anon_sym_LT] = ACTIONS(6015),
    [anon_sym_RPAREN] = ACTIONS(6017),
    [anon_sym_SLASH] = ACTIONS(6015),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6017),
    [anon_sym_DOT] = ACTIONS(6017),
    [anon_sym_CARET] = ACTIONS(6017),
    [anon_sym_STAR_STAR] = ACTIONS(6017),
    [anon_sym_PLUS] = ACTIONS(6015),
    [anon_sym_implements] = ACTIONS(6017),
    [anon_sym_GT_GT] = ACTIONS(6015),
    [anon_sym_PLUS_PLUS] = ACTIONS(6017),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6017),
    [anon_sym_in] = ACTIONS(6015),
  },
  [3068] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6021),
    [anon_sym_LBRACK] = ACTIONS(6021),
    [anon_sym_BANG] = ACTIONS(6019),
    [anon_sym_BQUOTE] = ACTIONS(6021),
    [anon_sym_PIPE] = ACTIONS(6019),
    [anon_sym_COMMA] = ACTIONS(6021),
    [anon_sym_LT_LT] = ACTIONS(6021),
    [anon_sym_STAR] = ACTIONS(6019),
    [anon_sym_GT_GT_GT] = ACTIONS(6021),
    [anon_sym_AMP_AMP] = ACTIONS(6021),
    [anon_sym_DASH] = ACTIONS(6019),
    [anon_sym_LBRACE] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_LT_EQ] = ACTIONS(6021),
    [anon_sym_LPAREN] = ACTIONS(6021),
    [anon_sym_RBRACK] = ACTIONS(6021),
    [anon_sym_GT_EQ] = ACTIONS(6021),
    [anon_sym_GT] = ACTIONS(6019),
    [anon_sym_AMP] = ACTIONS(6019),
    [anon_sym_PERCENT] = ACTIONS(6021),
    [anon_sym_QMARK] = ACTIONS(6021),
    [anon_sym_RBRACE] = ACTIONS(6021),
    [anon_sym_as] = ACTIONS(6021),
    [anon_sym_PIPE_PIPE] = ACTIONS(6021),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6021),
    [anon_sym_DASH_DASH] = ACTIONS(6021),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_instanceof] = ACTIONS(6021),
    [anon_sym_LT] = ACTIONS(6019),
    [anon_sym_RPAREN] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6021),
    [anon_sym_DOT] = ACTIONS(6021),
    [anon_sym_CARET] = ACTIONS(6021),
    [anon_sym_STAR_STAR] = ACTIONS(6021),
    [anon_sym_PLUS] = ACTIONS(6019),
    [anon_sym_implements] = ACTIONS(6021),
    [anon_sym_GT_GT] = ACTIONS(6019),
    [anon_sym_PLUS_PLUS] = ACTIONS(6021),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6021),
    [anon_sym_in] = ACTIONS(6019),
  },
  [3069] = {
    [anon_sym_AMP] = ACTIONS(5881),
    [anon_sym_PIPE] = ACTIONS(5883),
    [anon_sym_RBRACK] = ACTIONS(7856),
    [sym_comment] = ACTIONS(3),
  },
  [3070] = {
    [sym_union_type] = STATE(3751),
    [sym__type] = STATE(3751),
    [sym_constructor_type] = STATE(3751),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1295),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3751),
    [sym_function_type] = STATE(3751),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1299),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(2641),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(2667),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3071] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6038),
    [anon_sym_LBRACK] = ACTIONS(6038),
    [anon_sym_BANG] = ACTIONS(6036),
    [anon_sym_BQUOTE] = ACTIONS(6038),
    [anon_sym_PIPE] = ACTIONS(6036),
    [anon_sym_COMMA] = ACTIONS(6038),
    [anon_sym_LT_LT] = ACTIONS(6038),
    [anon_sym_STAR] = ACTIONS(6036),
    [anon_sym_GT_GT_GT] = ACTIONS(6038),
    [anon_sym_AMP_AMP] = ACTIONS(6038),
    [anon_sym_DASH] = ACTIONS(6036),
    [anon_sym_LBRACE] = ACTIONS(6036),
    [anon_sym_BANG_EQ] = ACTIONS(6036),
    [anon_sym_LT_EQ] = ACTIONS(6038),
    [anon_sym_LPAREN] = ACTIONS(6038),
    [anon_sym_RBRACK] = ACTIONS(6038),
    [anon_sym_GT_EQ] = ACTIONS(6038),
    [anon_sym_GT] = ACTIONS(6036),
    [anon_sym_AMP] = ACTIONS(6036),
    [anon_sym_PERCENT] = ACTIONS(6038),
    [anon_sym_QMARK] = ACTIONS(6038),
    [anon_sym_RBRACE] = ACTIONS(6038),
    [anon_sym_as] = ACTIONS(6038),
    [anon_sym_PIPE_PIPE] = ACTIONS(6038),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6038),
    [anon_sym_DASH_DASH] = ACTIONS(6038),
    [anon_sym_EQ_EQ] = ACTIONS(6036),
    [anon_sym_instanceof] = ACTIONS(6038),
    [anon_sym_LT] = ACTIONS(6036),
    [anon_sym_RPAREN] = ACTIONS(6038),
    [anon_sym_SLASH] = ACTIONS(6036),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6038),
    [anon_sym_DOT] = ACTIONS(6038),
    [anon_sym_CARET] = ACTIONS(6038),
    [anon_sym_STAR_STAR] = ACTIONS(6038),
    [anon_sym_PLUS] = ACTIONS(6036),
    [anon_sym_implements] = ACTIONS(6038),
    [anon_sym_GT_GT] = ACTIONS(6036),
    [anon_sym_PLUS_PLUS] = ACTIONS(6038),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6038),
    [anon_sym_in] = ACTIONS(6036),
  },
  [3072] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_BANG] = ACTIONS(7208),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(7844),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_LT_LT] = ACTIONS(6040),
    [anon_sym_STAR] = ACTIONS(7208),
    [anon_sym_GT_GT_GT] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(6040),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_BANG_EQ] = ACTIONS(7208),
    [anon_sym_LT_EQ] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [anon_sym_RBRACK] = ACTIONS(6040),
    [anon_sym_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_AMP] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(6040),
    [anon_sym_QMARK] = ACTIONS(6040),
    [anon_sym_as] = ACTIONS(6040),
    [anon_sym_PIPE_PIPE] = ACTIONS(6040),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_instanceof] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6040),
    [anon_sym_CARET] = ACTIONS(6040),
    [anon_sym_STAR_STAR] = ACTIONS(6040),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6040),
    [anon_sym_in] = ACTIONS(7208),
  },
  [3073] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(6447),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [anon_sym_PERCENT_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_AMP_EQ] = ACTIONS(2011),
    [anon_sym_PLUS_EQ] = ACTIONS(2011),
    [anon_sym_PIPE] = ACTIONS(6450),
    [anon_sym_COMMA] = ACTIONS(6447),
    [anon_sym_LT_LT] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_GT_GT_GT] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_RBRACK] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(6450),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_CARET_EQ] = ACTIONS(2011),
    [anon_sym_STAR_EQ] = ACTIONS(2011),
    [anon_sym_PIPE_EQ] = ACTIONS(2011),
    [anon_sym_DASH_EQ] = ACTIONS(2011),
    [anon_sym_AMP] = ACTIONS(6450),
    [anon_sym_PERCENT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_LT_LT_EQ] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2011),
    [anon_sym_RBRACE] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_instanceof] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(6450),
    [anon_sym_RPAREN] = ACTIONS(2011),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2011),
    [anon_sym_COLON] = ACTIONS(2011),
    [anon_sym_SLASH_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_DOT] = ACTIONS(6453),
    [anon_sym_CARET] = ACTIONS(2013),
    [anon_sym_STAR_STAR] = ACTIONS(2013),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_implements] = ACTIONS(2011),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2013),
  },
  [3074] = {
    [sym_identifier] = ACTIONS(7858),
    [sym_comment] = ACTIONS(3),
  },
  [3075] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7150),
    [anon_sym_LBRACK] = ACTIONS(7150),
    [anon_sym_BANG] = ACTIONS(7152),
    [anon_sym_BQUOTE] = ACTIONS(7150),
    [anon_sym_else] = ACTIONS(7150),
    [anon_sym_PIPE] = ACTIONS(7152),
    [anon_sym_COMMA] = ACTIONS(7150),
    [anon_sym_LT_LT] = ACTIONS(7150),
    [anon_sym_STAR] = ACTIONS(7152),
    [anon_sym_GT_GT_GT] = ACTIONS(7150),
    [anon_sym_AMP_AMP] = ACTIONS(7150),
    [anon_sym_DASH] = ACTIONS(7152),
    [anon_sym_LBRACE] = ACTIONS(7152),
    [anon_sym_BANG_EQ] = ACTIONS(7152),
    [anon_sym_LT_EQ] = ACTIONS(7150),
    [anon_sym_LPAREN] = ACTIONS(7150),
    [anon_sym_RBRACK] = ACTIONS(7150),
    [anon_sym_GT_EQ] = ACTIONS(7150),
    [anon_sym_GT] = ACTIONS(7152),
    [anon_sym_AMP] = ACTIONS(7152),
    [anon_sym_PERCENT] = ACTIONS(7150),
    [anon_sym_QMARK] = ACTIONS(7150),
    [anon_sym_RBRACE] = ACTIONS(7150),
    [anon_sym_as] = ACTIONS(7150),
    [anon_sym_PIPE_PIPE] = ACTIONS(7150),
    [anon_sym_while] = ACTIONS(7150),
    [anon_sym_DASH_DASH] = ACTIONS(7150),
    [anon_sym_EQ_EQ] = ACTIONS(7152),
    [anon_sym_instanceof] = ACTIONS(7150),
    [anon_sym_LT] = ACTIONS(7152),
    [anon_sym_RPAREN] = ACTIONS(7150),
    [anon_sym_SLASH] = ACTIONS(7152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(7150),
    [anon_sym_COLON] = ACTIONS(7150),
    [anon_sym_DOT] = ACTIONS(7150),
    [anon_sym_CARET] = ACTIONS(7150),
    [anon_sym_STAR_STAR] = ACTIONS(7150),
    [anon_sym_PLUS] = ACTIONS(7152),
    [anon_sym_implements] = ACTIONS(7150),
    [anon_sym_GT_GT] = ACTIONS(7152),
    [anon_sym_PLUS_PLUS] = ACTIONS(7150),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7150),
    [anon_sym_in] = ACTIONS(7152),
  },
  [3076] = {
    [sym_class_body] = STATE(3753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(959),
  },
  [3077] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7286),
    [anon_sym_LBRACK] = ACTIONS(7286),
    [anon_sym_BANG] = ACTIONS(7288),
    [anon_sym_BQUOTE] = ACTIONS(7286),
    [anon_sym_PIPE] = ACTIONS(7288),
    [anon_sym_COMMA] = ACTIONS(7286),
    [anon_sym_LT_LT] = ACTIONS(7286),
    [anon_sym_STAR] = ACTIONS(7288),
    [anon_sym_GT_GT_GT] = ACTIONS(7286),
    [anon_sym_AMP_AMP] = ACTIONS(7286),
    [anon_sym_DASH] = ACTIONS(7288),
    [anon_sym_LBRACE] = ACTIONS(7288),
    [anon_sym_BANG_EQ] = ACTIONS(7288),
    [anon_sym_LT_EQ] = ACTIONS(7286),
    [anon_sym_LPAREN] = ACTIONS(7286),
    [anon_sym_RBRACK] = ACTIONS(7286),
    [anon_sym_GT_EQ] = ACTIONS(7286),
    [anon_sym_GT] = ACTIONS(7288),
    [anon_sym_AMP] = ACTIONS(7288),
    [anon_sym_PERCENT] = ACTIONS(7286),
    [anon_sym_QMARK] = ACTIONS(7286),
    [anon_sym_RBRACE] = ACTIONS(7286),
    [anon_sym_as] = ACTIONS(7286),
    [anon_sym_PIPE_PIPE] = ACTIONS(7286),
    [anon_sym_LBRACE_PIPE] = ACTIONS(7286),
    [anon_sym_DASH_DASH] = ACTIONS(7286),
    [anon_sym_EQ_EQ] = ACTIONS(7288),
    [anon_sym_instanceof] = ACTIONS(7286),
    [anon_sym_LT] = ACTIONS(7288),
    [anon_sym_RPAREN] = ACTIONS(7286),
    [anon_sym_SLASH] = ACTIONS(7288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7286),
    [anon_sym_DOT] = ACTIONS(7286),
    [anon_sym_CARET] = ACTIONS(7286),
    [anon_sym_STAR_STAR] = ACTIONS(7286),
    [anon_sym_PLUS] = ACTIONS(7288),
    [anon_sym_implements] = ACTIONS(7286),
    [anon_sym_GT_GT] = ACTIONS(7288),
    [anon_sym_PLUS_PLUS] = ACTIONS(7286),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7286),
    [anon_sym_in] = ACTIONS(7288),
  },
  [3078] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4229),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_in] = ACTIONS(4231),
    [anon_sym_BQUOTE] = ACTIONS(4229),
    [anon_sym_PIPE] = ACTIONS(4231),
    [anon_sym_COMMA] = ACTIONS(4229),
    [anon_sym_DASH] = ACTIONS(4231),
    [anon_sym_STAR] = ACTIONS(4231),
    [anon_sym_LBRACE] = ACTIONS(4231),
    [anon_sym_GT_GT_GT] = ACTIONS(4229),
    [anon_sym_AMP_AMP] = ACTIONS(4229),
    [anon_sym_LT_LT] = ACTIONS(4229),
    [anon_sym_BANG_EQ] = ACTIONS(4231),
    [anon_sym_LT_EQ] = ACTIONS(4229),
    [anon_sym_LPAREN] = ACTIONS(4229),
    [anon_sym_RBRACK] = ACTIONS(4229),
    [anon_sym_GT_EQ] = ACTIONS(4229),
    [anon_sym_GT] = ACTIONS(4231),
    [anon_sym_AMP] = ACTIONS(4231),
    [anon_sym_PERCENT] = ACTIONS(4229),
    [anon_sym_QMARK] = ACTIONS(4229),
    [anon_sym_RBRACE] = ACTIONS(4229),
    [anon_sym_as] = ACTIONS(4229),
    [anon_sym_PIPE_PIPE] = ACTIONS(4229),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4229),
    [anon_sym_DASH_DASH] = ACTIONS(4229),
    [anon_sym_EQ_EQ] = ACTIONS(4231),
    [anon_sym_instanceof] = ACTIONS(4229),
    [anon_sym_LT] = ACTIONS(4231),
    [anon_sym_RPAREN] = ACTIONS(4229),
    [anon_sym_SLASH] = ACTIONS(4231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4229),
    [anon_sym_DOT] = ACTIONS(4229),
    [anon_sym_CARET] = ACTIONS(4229),
    [anon_sym_STAR_STAR] = ACTIONS(4229),
    [anon_sym_PLUS] = ACTIONS(4231),
    [anon_sym_implements] = ACTIONS(4229),
    [anon_sym_GT_GT] = ACTIONS(4231),
    [anon_sym_PLUS_PLUS] = ACTIONS(4229),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4229),
    [anon_sym_BANG] = ACTIONS(4231),
  },
  [3079] = {
    [sym_union_type] = STATE(2014),
    [sym__type] = STATE(2014),
    [sym_constructor_type] = STATE(2014),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2014),
    [sym_function_type] = STATE(2014),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(7860),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_boolean] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_this] = ACTIONS(765),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [3080] = {
    [aux_sym_implements_clause_repeat1] = STATE(2016),
    [anon_sym_COMMA] = ACTIONS(7862),
    [anon_sym_GT] = ACTIONS(7860),
    [sym_comment] = ACTIONS(3),
  },
  [3081] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2773),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_LT_LT] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(5236),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_GT_GT_GT] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_BANG_EQ] = ACTIONS(2727),
    [anon_sym_LT_EQ] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_QMARK] = ACTIONS(2789),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2727),
    [anon_sym_instanceof] = ACTIONS(2771),
    [anon_sym_LT] = ACTIONS(2795),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_STAR_STAR] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_implements] = ACTIONS(5236),
    [anon_sym_GT_GT] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2771),
    [anon_sym_in] = ACTIONS(2727),
  },
  [3082] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2773),
    [anon_sym_COMMA] = ACTIONS(5240),
    [anon_sym_LT_LT] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(5240),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_GT_GT_GT] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_BANG_EQ] = ACTIONS(2727),
    [anon_sym_LT_EQ] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_QMARK] = ACTIONS(2789),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2727),
    [anon_sym_instanceof] = ACTIONS(2771),
    [anon_sym_LT] = ACTIONS(2795),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_STAR_STAR] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_implements] = ACTIONS(5240),
    [anon_sym_GT_GT] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2771),
    [anon_sym_in] = ACTIONS(2727),
  },
  [3083] = {
    [sym_new_expression] = STATE(3756),
    [sym_augmented_assignment_expression] = STATE(3756),
    [sym_unary_expression] = STATE(3756),
    [sym_update_expression] = STATE(3756),
    [sym_call_signature] = STATE(610),
    [sym_meta_property] = STATE(3756),
    [sym_regex] = STATE(3756),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3756),
    [sym_non_null_expression] = STATE(3756),
    [sym_as_expression] = STATE(3756),
    [sym_jsx_fragment] = STATE(3756),
    [sym_yield_expression] = STATE(3756),
    [sym_jsx_element] = STATE(3756),
    [sym_internal_module] = STATE(3756),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3756),
    [sym_await_expression] = STATE(3756),
    [sym_member_expression] = STATE(612),
    [sym_string] = STATE(3756),
    [sym_this] = STATE(3756),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(613),
    [sym_anonymous_class] = STATE(3756),
    [sym_generator_function] = STATE(3756),
    [sym_call_expression] = STATE(3756),
    [sym_subscript_expression] = STATE(612),
    [sym_assignment_expression] = STATE(3756),
    [sym_ternary_expression] = STATE(3756),
    [sym_binary_expression] = STATE(3756),
    [sym_template_string] = STATE(3756),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3756),
    [sym_array] = STATE(615),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3756),
    [sym_class] = STATE(3756),
    [anon_sym_BANG] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(2733),
    [sym_false] = ACTIONS(7864),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7864),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7866),
    [sym_true] = ACTIONS(7864),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7864),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
  },
  [3084] = {
    [sym_union_type] = STATE(3757),
    [sym__type] = STATE(3757),
    [sym_constructor_type] = STATE(3757),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2263),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3757),
    [sym_function_type] = STATE(3757),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2264),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(4743),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(4749),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(4747),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(4751),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(4745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3085] = {
    [sym_formal_parameters] = STATE(3758),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3086] = {
    [anon_sym_EQ_GT] = ACTIONS(7868),
    [sym_comment] = ACTIONS(3),
  },
  [3087] = {
    [sym_union_type] = STATE(3067),
    [sym__type] = STATE(3067),
    [sym_constructor_type] = STATE(3067),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2263),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3067),
    [sym_function_type] = STATE(3067),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2264),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(4743),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(4749),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(4747),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(4751),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(4745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3088] = {
    [sym_union_type] = STATE(3068),
    [sym__type] = STATE(3068),
    [sym_constructor_type] = STATE(3068),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2263),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3068),
    [sym_function_type] = STATE(3068),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2264),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(4743),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(4749),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(4747),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(4751),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(4745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3089] = {
    [anon_sym_EQ_GT] = ACTIONS(7870),
    [sym_comment] = ACTIONS(3),
  },
  [3090] = {
    [sym_union_type] = STATE(3761),
    [sym__type] = STATE(3761),
    [sym_constructor_type] = STATE(3761),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2263),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3761),
    [sym_function_type] = STATE(3761),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2264),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(4743),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(4749),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(4747),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(4751),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(4745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3091] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(2714),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2714),
    [anon_sym_AMP_EQ] = ACTIONS(2714),
    [anon_sym_PLUS_EQ] = ACTIONS(2714),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(2718),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_CARET_EQ] = ACTIONS(2714),
    [anon_sym_STAR_EQ] = ACTIONS(2714),
    [anon_sym_PIPE_EQ] = ACTIONS(2714),
    [anon_sym_DASH_EQ] = ACTIONS(2714),
    [anon_sym_EQ_GT] = ACTIONS(2720),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2714),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2714),
    [anon_sym_GT_GT_EQ] = ACTIONS(2714),
    [anon_sym_DOT] = ACTIONS(6439),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2714),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2727),
  },
  [3092] = {
    [sym_formal_parameters] = STATE(3762),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3093] = {
    [anon_sym_EQ_GT] = ACTIONS(7872),
    [sym_comment] = ACTIONS(3),
  },
  [3094] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2277),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2278),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1121),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4771),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4773),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3095] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2277),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2278),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1121),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4771),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4773),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3096] = {
    [anon_sym_EQ_GT] = ACTIONS(7874),
    [sym_comment] = ACTIONS(3),
  },
  [3097] = {
    [sym_union_type] = STATE(3765),
    [sym__type] = STATE(3765),
    [sym_constructor_type] = STATE(3765),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2277),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3765),
    [sym_function_type] = STATE(3765),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2278),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1121),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4771),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4773),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3098] = {
    [sym_union_type] = STATE(3766),
    [sym__type] = STATE(3766),
    [sym_constructor_type] = STATE(3766),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(623),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3766),
    [sym_function_type] = STATE(3766),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(624),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1121),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3099] = {
    [anon_sym_AMP] = ACTIONS(2805),
    [anon_sym_PIPE] = ACTIONS(2807),
    [anon_sym_COMMA] = ACTIONS(7511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7511),
  },
  [3100] = {
    [anon_sym_AMP] = ACTIONS(2805),
    [anon_sym_PIPE] = ACTIONS(2807),
    [anon_sym_COMMA] = ACTIONS(7529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7529),
  },
  [3101] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4839),
    [anon_sym_LT_LT] = ACTIONS(4841),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_GT_GT_GT] = ACTIONS(4841),
    [anon_sym_AMP_AMP] = ACTIONS(4847),
    [anon_sym_BANG_EQ] = ACTIONS(4795),
    [anon_sym_LT_EQ] = ACTIONS(4837),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(4837),
    [anon_sym_GT] = ACTIONS(4795),
    [anon_sym_AMP] = ACTIONS(4851),
    [anon_sym_PERCENT] = ACTIONS(4841),
    [anon_sym_QMARK] = ACTIONS(4853),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(4855),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4795),
    [anon_sym_instanceof] = ACTIONS(4837),
    [anon_sym_LT] = ACTIONS(4859),
    [anon_sym_SLASH] = ACTIONS(4845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4855),
    [anon_sym_STAR_STAR] = ACTIONS(4861),
    [anon_sym_PLUS] = ACTIONS(4843),
    [anon_sym_GT_GT] = ACTIONS(4845),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4837),
    [anon_sym_in] = ACTIONS(4795),
  },
  [3102] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(4841),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_GT_GT_GT] = ACTIONS(4841),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(4841),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(4859),
    [anon_sym_SLASH] = ACTIONS(4845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(4861),
    [anon_sym_PLUS] = ACTIONS(4843),
    [anon_sym_GT_GT] = ACTIONS(4845),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3103] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4839),
    [anon_sym_LT_LT] = ACTIONS(4841),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_GT_GT_GT] = ACTIONS(4841),
    [anon_sym_AMP_AMP] = ACTIONS(4847),
    [anon_sym_BANG_EQ] = ACTIONS(4795),
    [anon_sym_LT_EQ] = ACTIONS(4837),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(2003),
    [anon_sym_GT_EQ] = ACTIONS(4837),
    [anon_sym_GT] = ACTIONS(4795),
    [anon_sym_AMP] = ACTIONS(4851),
    [anon_sym_PERCENT] = ACTIONS(4841),
    [anon_sym_QMARK] = ACTIONS(4853),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(4855),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4795),
    [anon_sym_instanceof] = ACTIONS(4837),
    [anon_sym_LT] = ACTIONS(4859),
    [anon_sym_SLASH] = ACTIONS(4845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4855),
    [anon_sym_STAR_STAR] = ACTIONS(4861),
    [anon_sym_PLUS] = ACTIONS(4843),
    [anon_sym_GT_GT] = ACTIONS(4845),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4837),
    [anon_sym_in] = ACTIONS(4795),
  },
  [3104] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4839),
    [anon_sym_LT_LT] = ACTIONS(4841),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_GT_GT_GT] = ACTIONS(4841),
    [anon_sym_AMP_AMP] = ACTIONS(4847),
    [anon_sym_BANG_EQ] = ACTIONS(4795),
    [anon_sym_LT_EQ] = ACTIONS(4837),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(2005),
    [anon_sym_GT_EQ] = ACTIONS(4837),
    [anon_sym_GT] = ACTIONS(4795),
    [anon_sym_AMP] = ACTIONS(4851),
    [anon_sym_PERCENT] = ACTIONS(4841),
    [anon_sym_QMARK] = ACTIONS(4853),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(4855),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4795),
    [anon_sym_instanceof] = ACTIONS(4837),
    [anon_sym_LT] = ACTIONS(4859),
    [anon_sym_SLASH] = ACTIONS(4845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4855),
    [anon_sym_STAR_STAR] = ACTIONS(4861),
    [anon_sym_PLUS] = ACTIONS(4843),
    [anon_sym_GT_GT] = ACTIONS(4845),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4837),
    [anon_sym_in] = ACTIONS(4795),
  },
  [3105] = {
    [anon_sym_RBRACK] = ACTIONS(7876),
    [sym_comment] = ACTIONS(3),
  },
  [3106] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4839),
    [anon_sym_LT_LT] = ACTIONS(4841),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_GT_GT_GT] = ACTIONS(4841),
    [anon_sym_AMP_AMP] = ACTIONS(4847),
    [anon_sym_BANG_EQ] = ACTIONS(4795),
    [anon_sym_LT_EQ] = ACTIONS(4837),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(2101),
    [anon_sym_GT_EQ] = ACTIONS(4837),
    [anon_sym_GT] = ACTIONS(4795),
    [anon_sym_AMP] = ACTIONS(4851),
    [anon_sym_PERCENT] = ACTIONS(4841),
    [anon_sym_QMARK] = ACTIONS(4853),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(4855),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4795),
    [anon_sym_instanceof] = ACTIONS(4837),
    [anon_sym_LT] = ACTIONS(4859),
    [anon_sym_SLASH] = ACTIONS(4845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4855),
    [anon_sym_STAR_STAR] = ACTIONS(4861),
    [anon_sym_PLUS] = ACTIONS(4843),
    [anon_sym_GT_GT] = ACTIONS(4845),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4837),
    [anon_sym_in] = ACTIONS(4795),
  },
  [3107] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4839),
    [anon_sym_LT_LT] = ACTIONS(4841),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_GT_GT_GT] = ACTIONS(4841),
    [anon_sym_AMP_AMP] = ACTIONS(4847),
    [anon_sym_BANG_EQ] = ACTIONS(4795),
    [anon_sym_LT_EQ] = ACTIONS(4837),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(2105),
    [anon_sym_GT_EQ] = ACTIONS(4837),
    [anon_sym_GT] = ACTIONS(4795),
    [anon_sym_AMP] = ACTIONS(4851),
    [anon_sym_PERCENT] = ACTIONS(4841),
    [anon_sym_QMARK] = ACTIONS(4853),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(4855),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4795),
    [anon_sym_instanceof] = ACTIONS(4837),
    [anon_sym_LT] = ACTIONS(4859),
    [anon_sym_SLASH] = ACTIONS(4845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4855),
    [anon_sym_STAR_STAR] = ACTIONS(4861),
    [anon_sym_PLUS] = ACTIONS(4843),
    [anon_sym_GT_GT] = ACTIONS(4845),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4837),
    [anon_sym_in] = ACTIONS(4795),
  },
  [3108] = {
    [anon_sym_RBRACK] = ACTIONS(7878),
    [sym_comment] = ACTIONS(3),
  },
  [3109] = {
    [sym_new_expression] = STATE(3769),
    [sym_augmented_assignment_expression] = STATE(3769),
    [sym_unary_expression] = STATE(3769),
    [sym_update_expression] = STATE(3769),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(3769),
    [sym_regex] = STATE(3769),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2185),
    [sym__expression] = STATE(3769),
    [sym_non_null_expression] = STATE(3769),
    [sym_yield_expression] = STATE(3769),
    [sym_jsx_fragment] = STATE(3769),
    [sym_jsx_element] = STATE(3769),
    [sym_as_expression] = STATE(3769),
    [sym_internal_module] = STATE(3769),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3769),
    [sym_await_expression] = STATE(3769),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(3769),
    [sym_this] = STATE(3769),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(3769),
    [sym_generator_function] = STATE(3769),
    [sym_call_expression] = STATE(3769),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(3769),
    [sym_ternary_expression] = STATE(3769),
    [sym_binary_expression] = STATE(3769),
    [sym_template_string] = STATE(3769),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3769),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3769),
    [sym_class] = STATE(3769),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(7880),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7880),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7882),
    [sym_true] = ACTIONS(7880),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7880),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [3110] = {
    [sym_new_expression] = STATE(3770),
    [sym_augmented_assignment_expression] = STATE(3770),
    [sym_unary_expression] = STATE(3770),
    [sym_update_expression] = STATE(3770),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(3770),
    [sym_regex] = STATE(3770),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2187),
    [sym__expression] = STATE(3770),
    [sym_non_null_expression] = STATE(3770),
    [sym_yield_expression] = STATE(3770),
    [sym_jsx_fragment] = STATE(3770),
    [sym_jsx_element] = STATE(3770),
    [sym_as_expression] = STATE(3770),
    [sym_internal_module] = STATE(3770),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3770),
    [sym_await_expression] = STATE(3770),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(3770),
    [sym_this] = STATE(3770),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(3770),
    [sym_generator_function] = STATE(3770),
    [sym_call_expression] = STATE(3770),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(3770),
    [sym_ternary_expression] = STATE(3770),
    [sym_binary_expression] = STATE(3770),
    [sym_template_string] = STATE(3770),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3770),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3770),
    [sym_class] = STATE(3770),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(7884),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(7884),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(7886),
    [sym_true] = ACTIONS(7884),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(7884),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [3111] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(4841),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_GT_GT_GT] = ACTIONS(4841),
    [anon_sym_AMP_AMP] = ACTIONS(4847),
    [anon_sym_BANG_EQ] = ACTIONS(4795),
    [anon_sym_LT_EQ] = ACTIONS(4837),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(4837),
    [anon_sym_GT] = ACTIONS(4795),
    [anon_sym_AMP] = ACTIONS(4851),
    [anon_sym_PERCENT] = ACTIONS(4841),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4795),
    [anon_sym_instanceof] = ACTIONS(4837),
    [anon_sym_LT] = ACTIONS(4859),
    [anon_sym_SLASH] = ACTIONS(4845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(4861),
    [anon_sym_PLUS] = ACTIONS(4843),
    [anon_sym_GT_GT] = ACTIONS(4845),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4837),
    [anon_sym_in] = ACTIONS(4795),
  },
  [3112] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(4861),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3113] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(4841),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_GT_GT_GT] = ACTIONS(4841),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(4841),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(4845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(4861),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(4845),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3114] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(4841),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_GT_GT_GT] = ACTIONS(4841),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(4795),
    [anon_sym_LT_EQ] = ACTIONS(4837),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(4837),
    [anon_sym_GT] = ACTIONS(4795),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(4841),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4795),
    [anon_sym_instanceof] = ACTIONS(4837),
    [anon_sym_LT] = ACTIONS(4859),
    [anon_sym_SLASH] = ACTIONS(4845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(4861),
    [anon_sym_PLUS] = ACTIONS(4843),
    [anon_sym_GT_GT] = ACTIONS(4845),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4837),
    [anon_sym_in] = ACTIONS(4795),
  },
  [3115] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3630),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7891),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3116] = {
    [sym_type_arguments] = STATE(2206),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(4638),
    [anon_sym_BANG] = ACTIONS(3699),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(3699),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_GT_GT_GT] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_RBRACK] = ACTIONS(2204),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_instanceof] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(4643),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4646),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_STAR_STAR] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2204),
    [anon_sym_in] = ACTIONS(3699),
  },
  [3117] = {
    [sym_index_type_query] = STATE(2208),
    [sym_lookup_type] = STATE(2208),
    [sym_flow_maybe_type] = STATE(2208),
    [sym_parenthesized_type] = STATE(2208),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_array_type] = STATE(2208),
    [sym_type_predicate] = STATE(2208),
    [sym_type_query] = STATE(2208),
    [sym_existential_type] = STATE(2208),
    [sym_this_type] = STATE(2208),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(2208),
    [sym__primary_type] = STATE(2208),
    [sym_generic_type] = STATE(2208),
    [sym_literal_type] = STATE(2208),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(2208),
    [sym_string] = STATE(1279),
    [sym_tuple_type] = STATE(2208),
    [sym_identifier] = ACTIONS(6550),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(6556),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [sym_true] = ACTIONS(2643),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(4648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3118] = {
    [sym_union_type] = STATE(2213),
    [sym__type] = STATE(2213),
    [sym_constructor_type] = STATE(2213),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3121),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2213),
    [sym_function_type] = STATE(2213),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3122),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(6550),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(6556),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(6554),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(6558),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(6552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3119] = {
    [sym_type_parameters] = STATE(3773),
    [sym_formal_parameters] = STATE(3774),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3120] = {
    [sym_union_type] = STATE(2221),
    [sym__type] = STATE(2221),
    [sym_constructor_type] = STATE(2221),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3121),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2221),
    [sym_function_type] = STATE(2221),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3122),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(6550),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(6556),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(6554),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(6558),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(6552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3121] = {
    [sym_formal_parameters] = STATE(3777),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3122] = {
    [anon_sym_EQ_GT] = ACTIONS(7895),
    [sym_comment] = ACTIONS(3),
  },
  [3123] = {
    [sym__initializer] = STATE(522),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4787),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4787),
    [anon_sym_AMP_EQ] = ACTIONS(4787),
    [anon_sym_PLUS_EQ] = ACTIONS(4787),
    [anon_sym_PIPE] = ACTIONS(3738),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(3738),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_CARET_EQ] = ACTIONS(4787),
    [anon_sym_STAR_EQ] = ACTIONS(4787),
    [anon_sym_PIPE_EQ] = ACTIONS(4787),
    [anon_sym_DASH_EQ] = ACTIONS(4787),
    [anon_sym_EQ_GT] = ACTIONS(4791),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4787),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4787),
    [anon_sym_GT_GT_EQ] = ACTIONS(4787),
    [anon_sym_DOT] = ACTIONS(5390),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4787),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4795),
  },
  [3124] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_AMP_EQ] = ACTIONS(4797),
    [anon_sym_PLUS_EQ] = ACTIONS(4797),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_CARET_EQ] = ACTIONS(4797),
    [anon_sym_STAR_EQ] = ACTIONS(4797),
    [anon_sym_PIPE_EQ] = ACTIONS(4797),
    [anon_sym_DASH_EQ] = ACTIONS(4797),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4797),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4797),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3125] = {
    [sym_new_expression] = STATE(2294),
    [sym_augmented_assignment_expression] = STATE(2294),
    [sym_unary_expression] = STATE(2294),
    [sym_update_expression] = STATE(2294),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(2294),
    [sym_regex] = STATE(2294),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2294),
    [sym_non_null_expression] = STATE(2294),
    [sym_as_expression] = STATE(2294),
    [sym_jsx_fragment] = STATE(2294),
    [sym_yield_expression] = STATE(2294),
    [sym_jsx_element] = STATE(2294),
    [sym_internal_module] = STATE(2294),
    [sym_nested_identifier] = STATE(1092),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2294),
    [sym_await_expression] = STATE(2294),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(2294),
    [sym_this] = STATE(2294),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(2294),
    [sym_generator_function] = STATE(2294),
    [sym_call_expression] = STATE(2294),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(2294),
    [sym_ternary_expression] = STATE(2294),
    [sym_binary_expression] = STATE(2294),
    [sym_template_string] = STATE(2294),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2294),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2294),
    [sym_class] = STATE(2294),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(7897),
    [sym_false] = ACTIONS(4803),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4803),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4805),
    [sym_true] = ACTIONS(4803),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4803),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [3126] = {
    [sym_new_expression] = STATE(2295),
    [sym_augmented_assignment_expression] = STATE(2295),
    [sym_unary_expression] = STATE(2295),
    [sym_update_expression] = STATE(2295),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(2295),
    [sym_regex] = STATE(2295),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2295),
    [sym_non_null_expression] = STATE(2295),
    [sym_as_expression] = STATE(2295),
    [sym_jsx_fragment] = STATE(2295),
    [sym_yield_expression] = STATE(2295),
    [sym_jsx_element] = STATE(2295),
    [sym_internal_module] = STATE(2295),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2295),
    [sym_await_expression] = STATE(2295),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(2295),
    [sym_this] = STATE(2295),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(2295),
    [sym_generator_function] = STATE(2295),
    [sym_call_expression] = STATE(2295),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(2295),
    [sym_ternary_expression] = STATE(2295),
    [sym_binary_expression] = STATE(2295),
    [sym_template_string] = STATE(2295),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2295),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2295),
    [sym_class] = STATE(2295),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(4807),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(4807),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4674),
    [sym_true] = ACTIONS(4807),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4807),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [3127] = {
    [sym_new_expression] = STATE(2294),
    [sym_augmented_assignment_expression] = STATE(2294),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(2294),
    [sym_update_expression] = STATE(2294),
    [sym_regex] = STATE(2294),
    [sym_meta_property] = STATE(2294),
    [sym_call_signature] = STATE(1372),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2294),
    [sym_non_null_expression] = STATE(2294),
    [sym_yield_expression] = STATE(2294),
    [sym_jsx_fragment] = STATE(2294),
    [sym_jsx_element] = STATE(2294),
    [sym_as_expression] = STATE(2294),
    [sym_internal_module] = STATE(2294),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2294),
    [sym_await_expression] = STATE(2294),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(2294),
    [sym_this] = STATE(2294),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(2294),
    [sym_generator_function] = STATE(2294),
    [sym_call_expression] = STATE(2294),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(2294),
    [sym_ternary_expression] = STATE(2294),
    [sym_binary_expression] = STATE(2294),
    [sym_template_string] = STATE(2294),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2294),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2294),
    [sym_class] = STATE(2294),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2968),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(4797),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_AMP_EQ] = ACTIONS(4797),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4797),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(4797),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_PIPE_EQ] = ACTIONS(4797),
    [anon_sym_DASH_EQ] = ACTIONS(4797),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4797),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(2839),
    [sym_true] = ACTIONS(4803),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4797),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(4803),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4797),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_RBRACK] = ACTIONS(135),
    [sym_null] = ACTIONS(4803),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_STAR_EQ] = ACTIONS(4797),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(4805),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4797),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(4803),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3128] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(1819),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(1820),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(4823),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(4825),
    [anon_sym_symbol] = ACTIONS(4825),
    [anon_sym_number] = ACTIONS(4825),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4825),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4827),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4825),
    [anon_sym_private] = ACTIONS(4825),
    [anon_sym_boolean] = ACTIONS(4825),
    [anon_sym_async] = ACTIONS(4829),
    [anon_sym_public] = ACTIONS(4825),
    [anon_sym_get] = ACTIONS(4825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4825),
    [anon_sym_string] = ACTIONS(4825),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(4825),
    [anon_sym_type] = ACTIONS(4825),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(4825),
    [anon_sym_export] = ACTIONS(4825),
    [anon_sym_namespace] = ACTIONS(4831),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [3129] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3130] = {
    [sym_statement_block] = STATE(3780),
    [sym__automatic_semicolon] = ACTIONS(7899),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_COMMA] = ACTIONS(7899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4899),
  },
  [3131] = {
    [sym__automatic_semicolon] = ACTIONS(6709),
    [anon_sym_LBRACK] = ACTIONS(6709),
    [sym_identifier] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(6709),
    [anon_sym_module] = ACTIONS(7901),
    [anon_sym_symbol] = ACTIONS(7901),
    [anon_sym_number] = ACTIONS(7901),
    [anon_sym_AT] = ACTIONS(6709),
    [anon_sym_declare] = ACTIONS(7901),
    [anon_sym_STAR] = ACTIONS(6709),
    [anon_sym_void] = ACTIONS(7901),
    [anon_sym_any] = ACTIONS(7901),
    [anon_sym_private] = ACTIONS(7901),
    [anon_sym_boolean] = ACTIONS(7901),
    [anon_sym_async] = ACTIONS(7901),
    [anon_sym_public] = ACTIONS(7901),
    [anon_sym_get] = ACTIONS(7901),
    [anon_sym_RBRACE] = ACTIONS(6709),
    [anon_sym_static] = ACTIONS(7901),
    [anon_sym_SQUOTE] = ACTIONS(6709),
    [sym_number] = ACTIONS(6709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(7901),
    [anon_sym_string] = ACTIONS(7901),
    [anon_sym_abstract] = ACTIONS(7901),
    [anon_sym_set] = ACTIONS(7901),
    [anon_sym_type] = ACTIONS(7901),
    [anon_sym_import] = ACTIONS(7901),
    [anon_sym_export] = ACTIONS(7901),
    [anon_sym_namespace] = ACTIONS(7901),
    [sym_readonly] = ACTIONS(7901),
    [anon_sym_DQUOTE] = ACTIONS(6709),
  },
  [3132] = {
    [sym_type_parameters] = STATE(1395),
    [sym_formal_parameters] = STATE(1397),
    [sym_call_signature] = STATE(3781),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3133] = {
    [sym_type_parameters] = STATE(1395),
    [sym_formal_parameters] = STATE(1397),
    [sym_call_signature] = STATE(3781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [3134] = {
    [sym_string] = STATE(3783),
    [sym__property_name] = STATE(3783),
    [sym_computed_property_name] = STATE(3783),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(7905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [3135] = {
    [sym_string] = STATE(3783),
    [sym__property_name] = STATE(3783),
    [sym_computed_property_name] = STATE(3783),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(7905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [3136] = {
    [sym_type_parameters] = STATE(1395),
    [sym__initializer] = STATE(3784),
    [sym_formal_parameters] = STATE(1397),
    [sym_type_annotation] = STATE(3785),
    [sym_call_signature] = STATE(3781),
    [sym__automatic_semicolon] = ACTIONS(7907),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(7907),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(7907),
    [sym_comment] = ACTIONS(3),
  },
  [3137] = {
    [sym__initializer] = STATE(3784),
    [sym_type_annotation] = STATE(3785),
    [sym__automatic_semicolon] = ACTIONS(7907),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(7907),
    [anon_sym_COMMA] = ACTIONS(7907),
    [sym_comment] = ACTIONS(3),
  },
  [3138] = {
    [sym__automatic_semicolon] = ACTIONS(7907),
    [anon_sym_SEMI] = ACTIONS(7907),
    [anon_sym_COMMA] = ACTIONS(7907),
    [sym_comment] = ACTIONS(3),
  },
  [3139] = {
    [sym__initializer] = STATE(3784),
    [sym__automatic_semicolon] = ACTIONS(7907),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(7907),
    [anon_sym_COMMA] = ACTIONS(7907),
    [sym_comment] = ACTIONS(3),
  },
  [3140] = {
    [sym_type_parameters] = STATE(2331),
    [sym_formal_parameters] = STATE(2332),
    [sym_call_signature] = STATE(3786),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3141] = {
    [sym__automatic_semicolon] = ACTIONS(7909),
    [anon_sym_SEMI] = ACTIONS(7909),
    [anon_sym_COMMA] = ACTIONS(7909),
    [sym_comment] = ACTIONS(3),
  },
  [3142] = {
    [sym_type_annotation] = STATE(2523),
    [sym__automatic_semicolon] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(6594),
    [anon_sym_SEMI] = ACTIONS(1669),
    [anon_sym_COMMA] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
  },
  [3143] = {
    [sym_union_type] = STATE(3792),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3792),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3793),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(3792),
    [sym_function_type] = STATE(3792),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3794),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(7911),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(7913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(7915),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(7917),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(7919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3144] = {
    [sym_type_arguments] = STATE(1885),
    [sym__automatic_semicolon] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(3983),
    [anon_sym_is] = ACTIONS(7921),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(3985),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2204),
  },
  [3145] = {
    [sym_index_type_query] = STATE(1887),
    [sym_lookup_type] = STATE(1887),
    [sym_flow_maybe_type] = STATE(1887),
    [sym_parenthesized_type] = STATE(1887),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_array_type] = STATE(1887),
    [sym_type_predicate] = STATE(1887),
    [sym_type_query] = STATE(1887),
    [sym_existential_type] = STATE(1887),
    [sym_this_type] = STATE(1887),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1887),
    [sym__primary_type] = STATE(1887),
    [sym_generic_type] = STATE(1887),
    [sym_literal_type] = STATE(1887),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1887),
    [sym_string] = STATE(1017),
    [sym_tuple_type] = STATE(1887),
    [sym_identifier] = ACTIONS(6598),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(6600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [sym_true] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_LPAREN] = ACTIONS(3989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3146] = {
    [sym_union_type] = STATE(1892),
    [sym__type] = STATE(1892),
    [sym_constructor_type] = STATE(1892),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3150),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1892),
    [sym_function_type] = STATE(1892),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3151),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(6598),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(6600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(6602),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(6604),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(6606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3147] = {
    [sym_type_parameters] = STATE(3796),
    [sym_formal_parameters] = STATE(3797),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3148] = {
    [sym_union_type] = STATE(1900),
    [sym__type] = STATE(1900),
    [sym_constructor_type] = STATE(1900),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3150),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1900),
    [sym_function_type] = STATE(1900),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3151),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(6598),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(6600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(6602),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(6604),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(6606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3149] = {
    [sym__automatic_semicolon] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(7923),
    [anon_sym_SEMI] = ACTIONS(3611),
    [anon_sym_COMMA] = ACTIONS(3611),
    [anon_sym_PIPE] = ACTIONS(7925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3611),
  },
  [3150] = {
    [sym_formal_parameters] = STATE(3800),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3151] = {
    [anon_sym_EQ_GT] = ACTIONS(7927),
    [sym_comment] = ACTIONS(3),
  },
  [3152] = {
    [sym__automatic_semicolon] = ACTIONS(1255),
    [anon_sym_LBRACK] = ACTIONS(1255),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym_module] = ACTIONS(1253),
    [anon_sym_symbol] = ACTIONS(1253),
    [anon_sym_number] = ACTIONS(1253),
    [anon_sym_AT] = ACTIONS(1255),
    [anon_sym_declare] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_any] = ACTIONS(1253),
    [anon_sym_private] = ACTIONS(1253),
    [anon_sym_boolean] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_public] = ACTIONS(1253),
    [anon_sym_get] = ACTIONS(1253),
    [anon_sym_RBRACE] = ACTIONS(1255),
    [anon_sym_static] = ACTIONS(1253),
    [anon_sym_SQUOTE] = ACTIONS(1255),
    [sym_number] = ACTIONS(1255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1253),
    [anon_sym_string] = ACTIONS(1253),
    [anon_sym_abstract] = ACTIONS(1253),
    [anon_sym_set] = ACTIONS(1253),
    [anon_sym_type] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(1253),
    [anon_sym_export] = ACTIONS(1253),
    [anon_sym_namespace] = ACTIONS(1253),
    [sym_readonly] = ACTIONS(1253),
    [anon_sym_DQUOTE] = ACTIONS(1255),
  },
  [3153] = {
    [sym_type_alias_declaration] = STATE(696),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(696),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(696),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(696),
    [sym_return_statement] = STATE(696),
    [aux_sym_program_repeat1] = STATE(696),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(696),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(696),
    [sym_switch_statement] = STATE(696),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(696),
    [sym_throw_statement] = STATE(696),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(696),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(696),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(696),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(696),
    [sym_abstract_class] = STATE(696),
    [sym_interface_declaration] = STATE(696),
    [sym_statement_block] = STATE(696),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(696),
    [sym_debugger_statement] = STATE(696),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(696),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(696),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(696),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(696),
    [sym_empty_statement] = STATE(696),
    [sym_import_alias] = STATE(696),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(696),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(696),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(696),
    [sym_break_statement] = STATE(696),
    [sym_labeled_statement] = STATE(696),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(696),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(7929),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [3154] = {
    [sym_string] = STATE(3783),
    [sym__property_name] = STATE(3783),
    [sym_computed_property_name] = STATE(3783),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_EQ] = ACTIONS(1214),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(7905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_BANG] = ACTIONS(1214),
  },
  [3155] = {
    [sym_string] = STATE(3783),
    [sym__property_name] = STATE(3783),
    [sym_computed_property_name] = STATE(3783),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(7931),
    [anon_sym_EQ] = ACTIONS(1214),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(7933),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(7905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(7933),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_BANG] = ACTIONS(1214),
  },
  [3156] = {
    [sym_type_parameters] = STATE(1395),
    [sym__initializer] = STATE(3784),
    [sym_formal_parameters] = STATE(1397),
    [sym_type_annotation] = STATE(3785),
    [sym_call_signature] = STATE(3781),
    [sym__automatic_semicolon] = ACTIONS(7907),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(7907),
    [anon_sym_QMARK] = ACTIONS(7935),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(7907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(7937),
  },
  [3157] = {
    [sym__initializer] = STATE(3784),
    [sym_type_annotation] = STATE(3785),
    [sym__automatic_semicolon] = ACTIONS(7907),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(7907),
    [anon_sym_QMARK] = ACTIONS(7937),
    [anon_sym_COMMA] = ACTIONS(7907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(7937),
  },
  [3158] = {
    [sym_type_parameters] = STATE(2331),
    [sym_formal_parameters] = STATE(2332),
    [sym_call_signature] = STATE(3786),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(7939),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [3159] = {
    [sym_type_parameters] = STATE(2331),
    [sym__initializer] = STATE(3784),
    [sym_formal_parameters] = STATE(2332),
    [sym_type_annotation] = STATE(3785),
    [sym_call_signature] = STATE(3786),
    [sym__automatic_semicolon] = ACTIONS(7907),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(7907),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(7907),
    [sym_comment] = ACTIONS(3),
  },
  [3160] = {
    [sym_type_arguments] = STATE(1064),
    [sym_identifier] = ACTIONS(3699),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [anon_sym_debugger] = ACTIONS(3699),
    [anon_sym_symbol] = ACTIONS(3699),
    [anon_sym_AT] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_void] = ACTIONS(3699),
    [anon_sym_break] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [sym_super] = ACTIONS(3699),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_private] = ACTIONS(3699),
    [anon_sym_get] = ACTIONS(3699),
    [anon_sym_interface] = ACTIONS(3699),
    [anon_sym_enum] = ACTIONS(3699),
    [anon_sym_delete] = ACTIONS(3699),
    [anon_sym_continue] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(3699),
    [anon_sym_this] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3699),
    [sym_true] = ACTIONS(3699),
    [anon_sym_throw] = ACTIONS(3699),
    [anon_sym_protected] = ACTIONS(3699),
    [anon_sym_abstract] = ACTIONS(3699),
    [anon_sym_DOT] = ACTIONS(4187),
    [anon_sym_set] = ACTIONS(3699),
    [anon_sym_type] = ACTIONS(3699),
    [anon_sym_import] = ACTIONS(3699),
    [anon_sym_namespace] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_await] = ACTIONS(3699),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [sym_false] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_module] = ACTIONS(3699),
    [anon_sym_number] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_declare] = ACTIONS(3699),
    [anon_sym_typeof] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(7941),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [sym_null] = ACTIONS(3699),
    [anon_sym_any] = ACTIONS(3699),
    [anon_sym_boolean] = ACTIONS(3699),
    [anon_sym_async] = ACTIONS(3699),
    [anon_sym_public] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_var] = ACTIONS(3699),
    [anon_sym_while] = ACTIONS(3699),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_try] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(7943),
    [sym_number] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3699),
    [sym_undefined] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3699),
    [ts_builtin_sym_end] = ACTIONS(2204),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_export] = ACTIONS(3699),
    [anon_sym_do] = ACTIONS(3699),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_with] = ACTIONS(3699),
  },
  [3161] = {
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_array_type] = STATE(1066),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym_existential_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(1066),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(1066),
    [sym_string] = STATE(418),
    [sym_tuple_type] = STATE(1066),
    [sym_identifier] = ACTIONS(6624),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(6626),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [sym_true] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3162] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(3167),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3168),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(6624),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(6626),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6628),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6630),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3163] = {
    [sym_type_parameters] = STATE(3810),
    [sym_formal_parameters] = STATE(3811),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3164] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(3167),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3168),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(6624),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(6626),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6628),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6630),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3165] = {
    [sym_identifier] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7948),
    [anon_sym_debugger] = ACTIONS(7946),
    [anon_sym_symbol] = ACTIONS(7946),
    [anon_sym_AT] = ACTIONS(7948),
    [anon_sym_PIPE] = ACTIONS(7950),
    [anon_sym_DASH] = ACTIONS(7946),
    [anon_sym_void] = ACTIONS(7946),
    [anon_sym_break] = ACTIONS(7946),
    [anon_sym_const] = ACTIONS(7946),
    [sym_super] = ACTIONS(7946),
    [anon_sym_return] = ACTIONS(7946),
    [anon_sym_private] = ACTIONS(7946),
    [anon_sym_get] = ACTIONS(7946),
    [anon_sym_interface] = ACTIONS(7946),
    [anon_sym_enum] = ACTIONS(7946),
    [anon_sym_delete] = ACTIONS(7946),
    [anon_sym_continue] = ACTIONS(7946),
    [anon_sym_DASH_DASH] = ACTIONS(7948),
    [anon_sym_if] = ACTIONS(7946),
    [anon_sym_this] = ACTIONS(7946),
    [anon_sym_yield] = ACTIONS(7946),
    [sym_true] = ACTIONS(7946),
    [anon_sym_throw] = ACTIONS(7946),
    [anon_sym_protected] = ACTIONS(7946),
    [anon_sym_abstract] = ACTIONS(7946),
    [anon_sym_set] = ACTIONS(7946),
    [anon_sym_type] = ACTIONS(7946),
    [anon_sym_import] = ACTIONS(7946),
    [anon_sym_namespace] = ACTIONS(7946),
    [anon_sym_PLUS_PLUS] = ACTIONS(7948),
    [anon_sym_await] = ACTIONS(7946),
    [anon_sym_DQUOTE] = ACTIONS(7948),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_for] = ACTIONS(7946),
    [anon_sym_LBRACK] = ACTIONS(7948),
    [sym_false] = ACTIONS(7946),
    [anon_sym_SEMI] = ACTIONS(7948),
    [anon_sym_module] = ACTIONS(7946),
    [anon_sym_number] = ACTIONS(7946),
    [anon_sym_class] = ACTIONS(7946),
    [anon_sym_declare] = ACTIONS(7946),
    [anon_sym_typeof] = ACTIONS(7946),
    [anon_sym_LBRACE] = ACTIONS(7948),
    [anon_sym_switch] = ACTIONS(7946),
    [anon_sym_LPAREN] = ACTIONS(7948),
    [sym_null] = ACTIONS(7946),
    [anon_sym_any] = ACTIONS(7946),
    [anon_sym_boolean] = ACTIONS(7946),
    [anon_sym_async] = ACTIONS(7946),
    [anon_sym_public] = ACTIONS(7946),
    [anon_sym_AMP] = ACTIONS(7952),
    [anon_sym_var] = ACTIONS(7946),
    [anon_sym_while] = ACTIONS(7946),
    [anon_sym_SQUOTE] = ACTIONS(7948),
    [anon_sym_try] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(7948),
    [sym_number] = ACTIONS(7948),
    [anon_sym_SLASH] = ACTIONS(7946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7946),
    [anon_sym_function] = ACTIONS(7946),
    [sym_undefined] = ACTIONS(7946),
    [anon_sym_new] = ACTIONS(7946),
    [ts_builtin_sym_end] = ACTIONS(7948),
    [anon_sym_let] = ACTIONS(7946),
    [anon_sym_PLUS] = ACTIONS(7946),
    [anon_sym_export] = ACTIONS(7946),
    [anon_sym_do] = ACTIONS(7946),
    [anon_sym_TILDE] = ACTIONS(7948),
    [anon_sym_with] = ACTIONS(7946),
  },
  [3166] = {
    [sym_type_arguments] = STATE(1117),
    [sym_identifier] = ACTIONS(2297),
    [anon_sym_BQUOTE] = ACTIONS(2292),
    [anon_sym_debugger] = ACTIONS(2297),
    [anon_sym_symbol] = ACTIONS(2297),
    [anon_sym_AT] = ACTIONS(2292),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2297),
    [anon_sym_void] = ACTIONS(2297),
    [anon_sym_break] = ACTIONS(2297),
    [anon_sym_const] = ACTIONS(2297),
    [sym_super] = ACTIONS(2297),
    [anon_sym_return] = ACTIONS(2297),
    [anon_sym_private] = ACTIONS(2297),
    [anon_sym_get] = ACTIONS(2297),
    [anon_sym_RBRACE] = ACTIONS(2292),
    [anon_sym_interface] = ACTIONS(2297),
    [anon_sym_default] = ACTIONS(2297),
    [anon_sym_enum] = ACTIONS(2297),
    [anon_sym_delete] = ACTIONS(2297),
    [anon_sym_continue] = ACTIONS(2297),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2297),
    [anon_sym_this] = ACTIONS(2297),
    [anon_sym_yield] = ACTIONS(2297),
    [sym_true] = ACTIONS(2297),
    [anon_sym_throw] = ACTIONS(2297),
    [anon_sym_protected] = ACTIONS(2297),
    [anon_sym_abstract] = ACTIONS(2297),
    [anon_sym_set] = ACTIONS(2297),
    [anon_sym_type] = ACTIONS(2297),
    [anon_sym_import] = ACTIONS(2297),
    [anon_sym_namespace] = ACTIONS(2297),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_await] = ACTIONS(2297),
    [anon_sym_DQUOTE] = ACTIONS(2292),
    [anon_sym_else] = ACTIONS(2297),
    [anon_sym_BANG] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2297),
    [anon_sym_LBRACK] = ACTIONS(2294),
    [sym_false] = ACTIONS(2297),
    [anon_sym_SEMI] = ACTIONS(2292),
    [anon_sym_case] = ACTIONS(2297),
    [anon_sym_module] = ACTIONS(2297),
    [anon_sym_number] = ACTIONS(2297),
    [anon_sym_class] = ACTIONS(2297),
    [anon_sym_declare] = ACTIONS(2297),
    [anon_sym_typeof] = ACTIONS(2297),
    [anon_sym_LBRACE] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2297),
    [anon_sym_LPAREN] = ACTIONS(2292),
    [sym_null] = ACTIONS(2297),
    [anon_sym_any] = ACTIONS(2297),
    [anon_sym_boolean] = ACTIONS(2297),
    [anon_sym_async] = ACTIONS(2297),
    [anon_sym_public] = ACTIONS(2297),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_var] = ACTIONS(2297),
    [anon_sym_while] = ACTIONS(2297),
    [anon_sym_SQUOTE] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2297),
    [anon_sym_LT] = ACTIONS(7954),
    [sym_number] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2297),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2297),
    [anon_sym_function] = ACTIONS(2297),
    [sym_undefined] = ACTIONS(2297),
    [anon_sym_new] = ACTIONS(2297),
    [ts_builtin_sym_end] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2297),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_export] = ACTIONS(2297),
    [anon_sym_do] = ACTIONS(2297),
    [anon_sym_TILDE] = ACTIONS(2292),
    [anon_sym_with] = ACTIONS(2297),
  },
  [3167] = {
    [sym_formal_parameters] = STATE(3814),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3168] = {
    [anon_sym_EQ_GT] = ACTIONS(7957),
    [sym_comment] = ACTIONS(3),
  },
  [3169] = {
    [sym_identifier] = ACTIONS(6495),
    [anon_sym_BQUOTE] = ACTIONS(6493),
    [anon_sym_debugger] = ACTIONS(6495),
    [anon_sym_symbol] = ACTIONS(6495),
    [anon_sym_AT] = ACTIONS(6493),
    [anon_sym_DASH] = ACTIONS(6495),
    [anon_sym_void] = ACTIONS(6495),
    [anon_sym_break] = ACTIONS(6495),
    [anon_sym_const] = ACTIONS(6495),
    [sym_super] = ACTIONS(6495),
    [anon_sym_return] = ACTIONS(6495),
    [anon_sym_private] = ACTIONS(6495),
    [anon_sym_get] = ACTIONS(6495),
    [anon_sym_RBRACE] = ACTIONS(6493),
    [anon_sym_interface] = ACTIONS(6495),
    [anon_sym_default] = ACTIONS(6495),
    [anon_sym_enum] = ACTIONS(6495),
    [anon_sym_delete] = ACTIONS(6495),
    [anon_sym_continue] = ACTIONS(6495),
    [anon_sym_DASH_DASH] = ACTIONS(6493),
    [anon_sym_if] = ACTIONS(6495),
    [anon_sym_this] = ACTIONS(6495),
    [anon_sym_yield] = ACTIONS(6495),
    [sym_true] = ACTIONS(6495),
    [anon_sym_throw] = ACTIONS(6495),
    [anon_sym_protected] = ACTIONS(6495),
    [anon_sym_abstract] = ACTIONS(6495),
    [anon_sym_set] = ACTIONS(6495),
    [anon_sym_type] = ACTIONS(6495),
    [anon_sym_import] = ACTIONS(6495),
    [anon_sym_namespace] = ACTIONS(6495),
    [anon_sym_PLUS_PLUS] = ACTIONS(6493),
    [anon_sym_await] = ACTIONS(6495),
    [anon_sym_DQUOTE] = ACTIONS(6493),
    [anon_sym_else] = ACTIONS(6495),
    [anon_sym_BANG] = ACTIONS(6493),
    [anon_sym_for] = ACTIONS(6495),
    [anon_sym_LBRACK] = ACTIONS(6493),
    [sym_false] = ACTIONS(6495),
    [anon_sym_SEMI] = ACTIONS(6493),
    [anon_sym_case] = ACTIONS(6495),
    [anon_sym_module] = ACTIONS(6495),
    [anon_sym_number] = ACTIONS(6495),
    [anon_sym_class] = ACTIONS(6495),
    [anon_sym_declare] = ACTIONS(6495),
    [anon_sym_typeof] = ACTIONS(6495),
    [anon_sym_LBRACE] = ACTIONS(6493),
    [anon_sym_switch] = ACTIONS(6495),
    [anon_sym_LPAREN] = ACTIONS(6493),
    [sym_null] = ACTIONS(6495),
    [anon_sym_any] = ACTIONS(6495),
    [anon_sym_boolean] = ACTIONS(6495),
    [anon_sym_async] = ACTIONS(6495),
    [anon_sym_public] = ACTIONS(6495),
    [anon_sym_var] = ACTIONS(6495),
    [anon_sym_while] = ACTIONS(6495),
    [anon_sym_SQUOTE] = ACTIONS(6493),
    [anon_sym_try] = ACTIONS(6495),
    [anon_sym_LT] = ACTIONS(6493),
    [sym_number] = ACTIONS(6493),
    [anon_sym_SLASH] = ACTIONS(6495),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6495),
    [anon_sym_function] = ACTIONS(6495),
    [sym_undefined] = ACTIONS(6495),
    [anon_sym_new] = ACTIONS(6495),
    [ts_builtin_sym_end] = ACTIONS(6493),
    [anon_sym_let] = ACTIONS(6495),
    [anon_sym_PLUS] = ACTIONS(6495),
    [anon_sym_export] = ACTIONS(6495),
    [anon_sym_do] = ACTIONS(6495),
    [anon_sym_TILDE] = ACTIONS(6493),
    [anon_sym_with] = ACTIONS(6495),
  },
  [3170] = {
    [sym_identifier] = ACTIONS(6955),
    [anon_sym_BQUOTE] = ACTIONS(6953),
    [anon_sym_debugger] = ACTIONS(6955),
    [anon_sym_symbol] = ACTIONS(6955),
    [anon_sym_AT] = ACTIONS(6953),
    [anon_sym_DASH] = ACTIONS(6955),
    [anon_sym_void] = ACTIONS(6955),
    [anon_sym_break] = ACTIONS(6955),
    [anon_sym_const] = ACTIONS(6955),
    [sym_super] = ACTIONS(6955),
    [anon_sym_return] = ACTIONS(6955),
    [anon_sym_private] = ACTIONS(6955),
    [anon_sym_get] = ACTIONS(6955),
    [anon_sym_RBRACE] = ACTIONS(6953),
    [anon_sym_interface] = ACTIONS(6955),
    [anon_sym_default] = ACTIONS(6955),
    [anon_sym_enum] = ACTIONS(6955),
    [anon_sym_delete] = ACTIONS(6955),
    [anon_sym_continue] = ACTIONS(6955),
    [anon_sym_DASH_DASH] = ACTIONS(6953),
    [anon_sym_if] = ACTIONS(6955),
    [anon_sym_this] = ACTIONS(6955),
    [anon_sym_yield] = ACTIONS(6955),
    [sym_true] = ACTIONS(6955),
    [anon_sym_throw] = ACTIONS(6955),
    [anon_sym_protected] = ACTIONS(6955),
    [anon_sym_abstract] = ACTIONS(6955),
    [anon_sym_set] = ACTIONS(6955),
    [anon_sym_type] = ACTIONS(6955),
    [anon_sym_import] = ACTIONS(6955),
    [anon_sym_namespace] = ACTIONS(6955),
    [anon_sym_PLUS_PLUS] = ACTIONS(6953),
    [anon_sym_await] = ACTIONS(6955),
    [anon_sym_DQUOTE] = ACTIONS(6953),
    [anon_sym_else] = ACTIONS(6955),
    [anon_sym_BANG] = ACTIONS(6953),
    [anon_sym_for] = ACTIONS(6955),
    [anon_sym_LBRACK] = ACTIONS(6953),
    [sym_false] = ACTIONS(6955),
    [anon_sym_SEMI] = ACTIONS(6953),
    [anon_sym_case] = ACTIONS(6955),
    [anon_sym_module] = ACTIONS(6955),
    [anon_sym_number] = ACTIONS(6955),
    [anon_sym_class] = ACTIONS(6955),
    [anon_sym_declare] = ACTIONS(6955),
    [anon_sym_typeof] = ACTIONS(6955),
    [anon_sym_LBRACE] = ACTIONS(6953),
    [anon_sym_switch] = ACTIONS(6955),
    [anon_sym_LPAREN] = ACTIONS(6953),
    [sym_null] = ACTIONS(6955),
    [anon_sym_any] = ACTIONS(6955),
    [anon_sym_boolean] = ACTIONS(6955),
    [anon_sym_async] = ACTIONS(6955),
    [anon_sym_public] = ACTIONS(6955),
    [anon_sym_var] = ACTIONS(6955),
    [anon_sym_while] = ACTIONS(6955),
    [anon_sym_SQUOTE] = ACTIONS(6953),
    [anon_sym_try] = ACTIONS(6955),
    [anon_sym_LT] = ACTIONS(6953),
    [sym_number] = ACTIONS(6953),
    [anon_sym_SLASH] = ACTIONS(6955),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6955),
    [anon_sym_function] = ACTIONS(6955),
    [sym_undefined] = ACTIONS(6955),
    [anon_sym_new] = ACTIONS(6955),
    [ts_builtin_sym_end] = ACTIONS(6953),
    [anon_sym_let] = ACTIONS(6955),
    [anon_sym_PLUS] = ACTIONS(6955),
    [anon_sym_export] = ACTIONS(6955),
    [anon_sym_do] = ACTIONS(6955),
    [anon_sym_TILDE] = ACTIONS(6953),
    [anon_sym_with] = ACTIONS(6955),
  },
  [3171] = {
    [sym_identifier] = ACTIONS(7025),
    [anon_sym_BQUOTE] = ACTIONS(7023),
    [anon_sym_debugger] = ACTIONS(7025),
    [anon_sym_symbol] = ACTIONS(7025),
    [anon_sym_AT] = ACTIONS(7023),
    [anon_sym_DASH] = ACTIONS(7025),
    [anon_sym_void] = ACTIONS(7025),
    [anon_sym_break] = ACTIONS(7025),
    [anon_sym_const] = ACTIONS(7025),
    [sym_super] = ACTIONS(7025),
    [anon_sym_return] = ACTIONS(7025),
    [anon_sym_private] = ACTIONS(7025),
    [anon_sym_get] = ACTIONS(7025),
    [anon_sym_RBRACE] = ACTIONS(7023),
    [anon_sym_interface] = ACTIONS(7025),
    [anon_sym_default] = ACTIONS(7025),
    [anon_sym_enum] = ACTIONS(7025),
    [anon_sym_delete] = ACTIONS(7025),
    [anon_sym_continue] = ACTIONS(7025),
    [anon_sym_DASH_DASH] = ACTIONS(7023),
    [anon_sym_if] = ACTIONS(7025),
    [anon_sym_this] = ACTIONS(7025),
    [anon_sym_yield] = ACTIONS(7025),
    [sym_true] = ACTIONS(7025),
    [anon_sym_throw] = ACTIONS(7025),
    [anon_sym_protected] = ACTIONS(7025),
    [anon_sym_abstract] = ACTIONS(7025),
    [anon_sym_set] = ACTIONS(7025),
    [anon_sym_type] = ACTIONS(7025),
    [anon_sym_import] = ACTIONS(7025),
    [anon_sym_namespace] = ACTIONS(7025),
    [anon_sym_PLUS_PLUS] = ACTIONS(7023),
    [anon_sym_await] = ACTIONS(7025),
    [anon_sym_DQUOTE] = ACTIONS(7023),
    [anon_sym_else] = ACTIONS(7025),
    [anon_sym_BANG] = ACTIONS(7023),
    [anon_sym_for] = ACTIONS(7025),
    [anon_sym_LBRACK] = ACTIONS(7023),
    [sym_false] = ACTIONS(7025),
    [anon_sym_SEMI] = ACTIONS(7023),
    [anon_sym_case] = ACTIONS(7025),
    [anon_sym_module] = ACTIONS(7025),
    [anon_sym_number] = ACTIONS(7025),
    [anon_sym_class] = ACTIONS(7025),
    [anon_sym_declare] = ACTIONS(7025),
    [anon_sym_typeof] = ACTIONS(7025),
    [anon_sym_LBRACE] = ACTIONS(7023),
    [anon_sym_switch] = ACTIONS(7025),
    [anon_sym_LPAREN] = ACTIONS(7023),
    [sym_null] = ACTIONS(7025),
    [anon_sym_any] = ACTIONS(7025),
    [anon_sym_boolean] = ACTIONS(7025),
    [anon_sym_async] = ACTIONS(7025),
    [anon_sym_public] = ACTIONS(7025),
    [anon_sym_var] = ACTIONS(7025),
    [anon_sym_while] = ACTIONS(7025),
    [anon_sym_SQUOTE] = ACTIONS(7023),
    [anon_sym_try] = ACTIONS(7025),
    [anon_sym_LT] = ACTIONS(7023),
    [sym_number] = ACTIONS(7023),
    [anon_sym_SLASH] = ACTIONS(7025),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7025),
    [anon_sym_function] = ACTIONS(7025),
    [sym_undefined] = ACTIONS(7025),
    [anon_sym_new] = ACTIONS(7025),
    [ts_builtin_sym_end] = ACTIONS(7023),
    [anon_sym_let] = ACTIONS(7025),
    [anon_sym_PLUS] = ACTIONS(7025),
    [anon_sym_export] = ACTIONS(7025),
    [anon_sym_do] = ACTIONS(7025),
    [anon_sym_TILDE] = ACTIONS(7023),
    [anon_sym_with] = ACTIONS(7025),
  },
  [3172] = {
    [sym_identifier] = ACTIONS(7152),
    [anon_sym_BQUOTE] = ACTIONS(7150),
    [anon_sym_debugger] = ACTIONS(7152),
    [anon_sym_symbol] = ACTIONS(7152),
    [anon_sym_AT] = ACTIONS(7150),
    [anon_sym_DASH] = ACTIONS(7152),
    [anon_sym_void] = ACTIONS(7152),
    [anon_sym_break] = ACTIONS(7152),
    [anon_sym_const] = ACTIONS(7152),
    [sym_super] = ACTIONS(7152),
    [anon_sym_return] = ACTIONS(7152),
    [anon_sym_private] = ACTIONS(7152),
    [anon_sym_get] = ACTIONS(7152),
    [anon_sym_RBRACE] = ACTIONS(7150),
    [anon_sym_interface] = ACTIONS(7152),
    [anon_sym_default] = ACTIONS(7152),
    [anon_sym_enum] = ACTIONS(7152),
    [anon_sym_delete] = ACTIONS(7152),
    [anon_sym_continue] = ACTIONS(7152),
    [anon_sym_DASH_DASH] = ACTIONS(7150),
    [anon_sym_if] = ACTIONS(7152),
    [anon_sym_this] = ACTIONS(7152),
    [anon_sym_yield] = ACTIONS(7152),
    [sym_true] = ACTIONS(7152),
    [anon_sym_throw] = ACTIONS(7152),
    [anon_sym_protected] = ACTIONS(7152),
    [anon_sym_abstract] = ACTIONS(7152),
    [anon_sym_set] = ACTIONS(7152),
    [anon_sym_type] = ACTIONS(7152),
    [anon_sym_import] = ACTIONS(7152),
    [anon_sym_namespace] = ACTIONS(7152),
    [anon_sym_PLUS_PLUS] = ACTIONS(7150),
    [anon_sym_await] = ACTIONS(7152),
    [anon_sym_DQUOTE] = ACTIONS(7150),
    [anon_sym_else] = ACTIONS(7152),
    [anon_sym_BANG] = ACTIONS(7150),
    [anon_sym_for] = ACTIONS(7152),
    [anon_sym_LBRACK] = ACTIONS(7150),
    [sym_false] = ACTIONS(7152),
    [anon_sym_SEMI] = ACTIONS(7150),
    [anon_sym_case] = ACTIONS(7152),
    [anon_sym_module] = ACTIONS(7152),
    [anon_sym_number] = ACTIONS(7152),
    [anon_sym_class] = ACTIONS(7152),
    [anon_sym_declare] = ACTIONS(7152),
    [anon_sym_typeof] = ACTIONS(7152),
    [anon_sym_LBRACE] = ACTIONS(7150),
    [anon_sym_switch] = ACTIONS(7152),
    [anon_sym_LPAREN] = ACTIONS(7150),
    [sym_null] = ACTIONS(7152),
    [anon_sym_any] = ACTIONS(7152),
    [anon_sym_boolean] = ACTIONS(7152),
    [anon_sym_async] = ACTIONS(7152),
    [anon_sym_public] = ACTIONS(7152),
    [anon_sym_var] = ACTIONS(7152),
    [anon_sym_while] = ACTIONS(7152),
    [anon_sym_SQUOTE] = ACTIONS(7150),
    [anon_sym_try] = ACTIONS(7152),
    [anon_sym_LT] = ACTIONS(7150),
    [sym_number] = ACTIONS(7150),
    [anon_sym_SLASH] = ACTIONS(7152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7152),
    [anon_sym_function] = ACTIONS(7152),
    [sym_undefined] = ACTIONS(7152),
    [anon_sym_new] = ACTIONS(7152),
    [ts_builtin_sym_end] = ACTIONS(7150),
    [anon_sym_let] = ACTIONS(7152),
    [anon_sym_PLUS] = ACTIONS(7152),
    [anon_sym_export] = ACTIONS(7152),
    [anon_sym_do] = ACTIONS(7152),
    [anon_sym_TILDE] = ACTIONS(7150),
    [anon_sym_with] = ACTIONS(7152),
  },
  [3173] = {
    [sym_class_body] = STATE(3816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2467),
  },
  [3174] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1995),
    [anon_sym_PIPE] = ACTIONS(5004),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(5006),
    [anon_sym_STAR] = ACTIONS(5008),
    [anon_sym_GT_GT_GT] = ACTIONS(5006),
    [anon_sym_AMP_AMP] = ACTIONS(5010),
    [anon_sym_DASH] = ACTIONS(5012),
    [anon_sym_BANG_EQ] = ACTIONS(4962),
    [anon_sym_LT_EQ] = ACTIONS(5002),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(5002),
    [anon_sym_GT] = ACTIONS(4962),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(5014),
    [anon_sym_QMARK] = ACTIONS(5016),
    [anon_sym_PERCENT] = ACTIONS(5006),
    [anon_sym_as] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(5020),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(4962),
    [anon_sym_instanceof] = ACTIONS(5002),
    [anon_sym_LT] = ACTIONS(5022),
    [anon_sym_SLASH] = ACTIONS(5008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(5020),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(5012),
    [anon_sym_GT_GT] = ACTIONS(5008),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5002),
    [anon_sym_in] = ACTIONS(4962),
  },
  [3175] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(5006),
    [anon_sym_STAR] = ACTIONS(5008),
    [anon_sym_GT_GT_GT] = ACTIONS(5006),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(5012),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_PERCENT] = ACTIONS(5006),
    [anon_sym_as] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(5022),
    [anon_sym_SLASH] = ACTIONS(5008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(5012),
    [anon_sym_GT_GT] = ACTIONS(5008),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3176] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(2003),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(5004),
    [anon_sym_COMMA] = ACTIONS(2003),
    [anon_sym_LT_LT] = ACTIONS(5006),
    [anon_sym_STAR] = ACTIONS(5008),
    [anon_sym_GT_GT_GT] = ACTIONS(5006),
    [anon_sym_AMP_AMP] = ACTIONS(5010),
    [anon_sym_DASH] = ACTIONS(5012),
    [anon_sym_BANG_EQ] = ACTIONS(4962),
    [anon_sym_LT_EQ] = ACTIONS(5002),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(5002),
    [anon_sym_GT] = ACTIONS(4962),
    [anon_sym_RBRACE] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(5014),
    [anon_sym_QMARK] = ACTIONS(5016),
    [anon_sym_PERCENT] = ACTIONS(5006),
    [anon_sym_as] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(5020),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(4962),
    [anon_sym_instanceof] = ACTIONS(5002),
    [anon_sym_LT] = ACTIONS(5022),
    [anon_sym_SLASH] = ACTIONS(5008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(5020),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(5012),
    [anon_sym_GT_GT] = ACTIONS(5008),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5002),
    [anon_sym_in] = ACTIONS(4962),
  },
  [3177] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(2101),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2101),
    [anon_sym_PIPE] = ACTIONS(5004),
    [anon_sym_COMMA] = ACTIONS(2101),
    [anon_sym_LT_LT] = ACTIONS(5006),
    [anon_sym_STAR] = ACTIONS(5008),
    [anon_sym_GT_GT_GT] = ACTIONS(5006),
    [anon_sym_AMP_AMP] = ACTIONS(5010),
    [anon_sym_DASH] = ACTIONS(5012),
    [anon_sym_BANG_EQ] = ACTIONS(4962),
    [anon_sym_LT_EQ] = ACTIONS(5002),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(5002),
    [anon_sym_GT] = ACTIONS(4962),
    [anon_sym_RBRACE] = ACTIONS(2101),
    [anon_sym_AMP] = ACTIONS(5014),
    [anon_sym_QMARK] = ACTIONS(5016),
    [anon_sym_PERCENT] = ACTIONS(5006),
    [anon_sym_as] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(5020),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(4962),
    [anon_sym_instanceof] = ACTIONS(5002),
    [anon_sym_LT] = ACTIONS(5022),
    [anon_sym_SLASH] = ACTIONS(5008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(5020),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(5012),
    [anon_sym_GT_GT] = ACTIONS(5008),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5002),
    [anon_sym_in] = ACTIONS(4962),
  },
  [3178] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(2105),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2105),
    [anon_sym_PIPE] = ACTIONS(5004),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(5006),
    [anon_sym_STAR] = ACTIONS(5008),
    [anon_sym_GT_GT_GT] = ACTIONS(5006),
    [anon_sym_AMP_AMP] = ACTIONS(5010),
    [anon_sym_DASH] = ACTIONS(5012),
    [anon_sym_BANG_EQ] = ACTIONS(4962),
    [anon_sym_LT_EQ] = ACTIONS(5002),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(5002),
    [anon_sym_GT] = ACTIONS(4962),
    [anon_sym_RBRACE] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(5014),
    [anon_sym_QMARK] = ACTIONS(5016),
    [anon_sym_PERCENT] = ACTIONS(5006),
    [anon_sym_as] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(5020),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(4962),
    [anon_sym_instanceof] = ACTIONS(5002),
    [anon_sym_LT] = ACTIONS(5022),
    [anon_sym_SLASH] = ACTIONS(5008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(5020),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(5012),
    [anon_sym_GT_GT] = ACTIONS(5008),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5002),
    [anon_sym_in] = ACTIONS(4962),
  },
  [3179] = {
    [sym_new_expression] = STATE(3817),
    [sym_augmented_assignment_expression] = STATE(3817),
    [sym_unary_expression] = STATE(3817),
    [sym_update_expression] = STATE(3817),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(3817),
    [sym_regex] = STATE(3817),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1556),
    [sym__expression] = STATE(3817),
    [sym_non_null_expression] = STATE(3817),
    [sym_yield_expression] = STATE(3817),
    [sym_jsx_fragment] = STATE(3817),
    [sym_jsx_element] = STATE(3817),
    [sym_as_expression] = STATE(3817),
    [sym_internal_module] = STATE(3817),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3817),
    [sym_await_expression] = STATE(3817),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(3817),
    [sym_this] = STATE(3817),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(3817),
    [sym_generator_function] = STATE(3817),
    [sym_call_expression] = STATE(3817),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(3817),
    [sym_ternary_expression] = STATE(3817),
    [sym_binary_expression] = STATE(3817),
    [sym_template_string] = STATE(3817),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3817),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3817),
    [sym_class] = STATE(3817),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_false] = ACTIONS(7959),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7959),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7961),
    [sym_true] = ACTIONS(7959),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7959),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [3180] = {
    [sym_new_expression] = STATE(3818),
    [sym_augmented_assignment_expression] = STATE(3818),
    [sym_unary_expression] = STATE(3818),
    [sym_update_expression] = STATE(3818),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(3818),
    [sym_regex] = STATE(3818),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1558),
    [sym__expression] = STATE(3818),
    [sym_non_null_expression] = STATE(3818),
    [sym_yield_expression] = STATE(3818),
    [sym_jsx_fragment] = STATE(3818),
    [sym_jsx_element] = STATE(3818),
    [sym_as_expression] = STATE(3818),
    [sym_internal_module] = STATE(3818),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3818),
    [sym_await_expression] = STATE(3818),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(3818),
    [sym_this] = STATE(3818),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(3818),
    [sym_generator_function] = STATE(3818),
    [sym_call_expression] = STATE(3818),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(3818),
    [sym_ternary_expression] = STATE(3818),
    [sym_binary_expression] = STATE(3818),
    [sym_template_string] = STATE(3818),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3818),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3818),
    [sym_class] = STATE(3818),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_false] = ACTIONS(7963),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(7963),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(7965),
    [sym_true] = ACTIONS(7963),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(7963),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [3181] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(5006),
    [anon_sym_STAR] = ACTIONS(5008),
    [anon_sym_GT_GT_GT] = ACTIONS(5006),
    [anon_sym_AMP_AMP] = ACTIONS(5010),
    [anon_sym_DASH] = ACTIONS(5012),
    [anon_sym_BANG_EQ] = ACTIONS(4962),
    [anon_sym_LT_EQ] = ACTIONS(5002),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(5002),
    [anon_sym_GT] = ACTIONS(4962),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(5014),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_PERCENT] = ACTIONS(5006),
    [anon_sym_as] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(4962),
    [anon_sym_instanceof] = ACTIONS(5002),
    [anon_sym_LT] = ACTIONS(5022),
    [anon_sym_SLASH] = ACTIONS(5008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(5012),
    [anon_sym_GT_GT] = ACTIONS(5008),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5002),
    [anon_sym_in] = ACTIONS(4962),
  },
  [3182] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(7967),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3183] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(5006),
    [anon_sym_STAR] = ACTIONS(5008),
    [anon_sym_GT_GT_GT] = ACTIONS(5006),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_PERCENT] = ACTIONS(5006),
    [anon_sym_as] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(7967),
    [anon_sym_SLASH] = ACTIONS(5008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(5008),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3184] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(5006),
    [anon_sym_STAR] = ACTIONS(5008),
    [anon_sym_GT_GT_GT] = ACTIONS(5006),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(5012),
    [anon_sym_BANG_EQ] = ACTIONS(4962),
    [anon_sym_LT_EQ] = ACTIONS(5002),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(5002),
    [anon_sym_GT] = ACTIONS(4962),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_PERCENT] = ACTIONS(5006),
    [anon_sym_as] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(4962),
    [anon_sym_instanceof] = ACTIONS(5002),
    [anon_sym_LT] = ACTIONS(5022),
    [anon_sym_SLASH] = ACTIONS(5008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(5012),
    [anon_sym_GT_GT] = ACTIONS(5008),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5002),
    [anon_sym_in] = ACTIONS(4962),
  },
  [3185] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3630),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7970),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3186] = {
    [sym_type_arguments] = STATE(1759),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(3696),
    [anon_sym_BANG] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [sym__automatic_semicolon] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_GT_GT_GT] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_is] = ACTIONS(7972),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_instanceof] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_STAR_STAR] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2204),
    [anon_sym_in] = ACTIONS(3699),
  },
  [3187] = {
    [sym_index_type_query] = STATE(1761),
    [sym_lookup_type] = STATE(1761),
    [sym_flow_maybe_type] = STATE(1761),
    [sym_parenthesized_type] = STATE(1761),
    [sym_nested_type_identifier] = STATE(942),
    [sym_array_type] = STATE(1761),
    [sym_type_predicate] = STATE(1761),
    [sym_type_query] = STATE(1761),
    [sym_existential_type] = STATE(1761),
    [sym_this_type] = STATE(1761),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(1761),
    [sym__primary_type] = STATE(1761),
    [sym_generic_type] = STATE(1761),
    [sym_literal_type] = STATE(1761),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(1761),
    [sym_string] = STATE(927),
    [sym_tuple_type] = STATE(1761),
    [sym_identifier] = ACTIONS(6681),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(6687),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [sym_true] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(3708),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [3188] = {
    [sym_union_type] = STATE(1766),
    [sym__type] = STATE(1766),
    [sym_constructor_type] = STATE(1766),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(3191),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(1766),
    [sym_function_type] = STATE(1766),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(3192),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(6681),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(6687),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(6685),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(6689),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(6683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [3189] = {
    [sym_type_parameters] = STATE(3821),
    [sym_formal_parameters] = STATE(3822),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3190] = {
    [sym_union_type] = STATE(1774),
    [sym__type] = STATE(1774),
    [sym_constructor_type] = STATE(1774),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(3191),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(1774),
    [sym_function_type] = STATE(1774),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(3192),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(6681),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(6687),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(6685),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(6689),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(6683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [3191] = {
    [sym_formal_parameters] = STATE(3825),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3192] = {
    [anon_sym_EQ_GT] = ACTIONS(7974),
    [sym_comment] = ACTIONS(3),
  },
  [3193] = {
    [sym__initializer] = STATE(71),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4958),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4958),
    [anon_sym_AMP_EQ] = ACTIONS(4958),
    [anon_sym_PLUS_EQ] = ACTIONS(4958),
    [anon_sym_PIPE] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1195),
    [anon_sym_GT] = ACTIONS(3738),
    [anon_sym_CARET_EQ] = ACTIONS(4958),
    [anon_sym_STAR_EQ] = ACTIONS(4958),
    [anon_sym_PIPE_EQ] = ACTIONS(4958),
    [anon_sym_DASH_EQ] = ACTIONS(4958),
    [anon_sym_EQ_GT] = ACTIONS(4960),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4958),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4958),
    [anon_sym_GT_GT_EQ] = ACTIONS(4958),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4958),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4962),
  },
  [3194] = {
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4964),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4964),
    [anon_sym_AMP_EQ] = ACTIONS(4964),
    [anon_sym_PLUS_EQ] = ACTIONS(4964),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_CARET_EQ] = ACTIONS(4964),
    [anon_sym_STAR_EQ] = ACTIONS(4964),
    [anon_sym_PIPE_EQ] = ACTIONS(4964),
    [anon_sym_DASH_EQ] = ACTIONS(4964),
    [anon_sym_EQ_GT] = ACTIONS(4966),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4964),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4964),
    [anon_sym_GT_GT_EQ] = ACTIONS(4964),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4964),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3195] = {
    [sym_new_expression] = STATE(2358),
    [sym_augmented_assignment_expression] = STATE(2358),
    [sym_unary_expression] = STATE(2358),
    [sym_update_expression] = STATE(2358),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(2358),
    [sym_regex] = STATE(2358),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2358),
    [sym_non_null_expression] = STATE(2358),
    [sym_as_expression] = STATE(2358),
    [sym_jsx_fragment] = STATE(2358),
    [sym_yield_expression] = STATE(2358),
    [sym_jsx_element] = STATE(2358),
    [sym_internal_module] = STATE(2358),
    [sym_nested_identifier] = STATE(1092),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2358),
    [sym_await_expression] = STATE(2358),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(2358),
    [sym_this] = STATE(2358),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(2358),
    [sym_generator_function] = STATE(2358),
    [sym_call_expression] = STATE(2358),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(2358),
    [sym_ternary_expression] = STATE(2358),
    [sym_binary_expression] = STATE(2358),
    [sym_template_string] = STATE(2358),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2358),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2358),
    [sym_class] = STATE(2358),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(7976),
    [sym_false] = ACTIONS(4968),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4968),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4970),
    [sym_true] = ACTIONS(4968),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4968),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [3196] = {
    [sym_new_expression] = STATE(2359),
    [sym_augmented_assignment_expression] = STATE(2359),
    [sym_unary_expression] = STATE(2359),
    [sym_update_expression] = STATE(2359),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(2359),
    [sym_regex] = STATE(2359),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2359),
    [sym_non_null_expression] = STATE(2359),
    [sym_as_expression] = STATE(2359),
    [sym_jsx_fragment] = STATE(2359),
    [sym_yield_expression] = STATE(2359),
    [sym_jsx_element] = STATE(2359),
    [sym_internal_module] = STATE(2359),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2359),
    [sym_await_expression] = STATE(2359),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(2359),
    [sym_this] = STATE(2359),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(2359),
    [sym_generator_function] = STATE(2359),
    [sym_call_expression] = STATE(2359),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(2359),
    [sym_ternary_expression] = STATE(2359),
    [sym_binary_expression] = STATE(2359),
    [sym_template_string] = STATE(2359),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2359),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2359),
    [sym_class] = STATE(2359),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_false] = ACTIONS(4972),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4972),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3781),
    [sym_true] = ACTIONS(4972),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4972),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [3197] = {
    [sym_new_expression] = STATE(2358),
    [sym_augmented_assignment_expression] = STATE(2358),
    [sym__initializer] = STATE(79),
    [sym_unary_expression] = STATE(2358),
    [sym_update_expression] = STATE(2358),
    [sym_regex] = STATE(2358),
    [sym_meta_property] = STATE(2358),
    [sym_call_signature] = STATE(1428),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2358),
    [sym_non_null_expression] = STATE(2358),
    [sym_yield_expression] = STATE(2358),
    [sym_jsx_fragment] = STATE(2358),
    [sym_jsx_element] = STATE(2358),
    [sym_as_expression] = STATE(2358),
    [sym_internal_module] = STATE(2358),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2358),
    [sym_await_expression] = STATE(2358),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(2358),
    [sym_this] = STATE(2358),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(2358),
    [sym_generator_function] = STATE(2358),
    [sym_call_expression] = STATE(2358),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(2358),
    [sym_ternary_expression] = STATE(2358),
    [sym_binary_expression] = STATE(2358),
    [sym_template_string] = STATE(2358),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2358),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2358),
    [sym_class] = STATE(2358),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2929),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(4964),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_AMP_EQ] = ACTIONS(4964),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4964),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(1195),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(4964),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_PIPE_EQ] = ACTIONS(4964),
    [anon_sym_DASH_EQ] = ACTIONS(4964),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(4964),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(2947),
    [sym_true] = ACTIONS(4968),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_GT_GT_EQ] = ACTIONS(4964),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4964),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(4968),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4964),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4968),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_STAR_EQ] = ACTIONS(4964),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_EQ_GT] = ACTIONS(4966),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(4970),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4964),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(4968),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3198] = {
    [sym_new_expression] = STATE(277),
    [sym_augmented_assignment_expression] = STATE(289),
    [sym_unary_expression] = STATE(289),
    [sym_update_expression] = STATE(289),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(277),
    [sym_regex] = STATE(277),
    [sym_type_parameters] = STATE(1819),
    [sym__expression] = STATE(289),
    [sym_non_null_expression] = STATE(289),
    [sym_as_expression] = STATE(289),
    [sym_jsx_fragment] = STATE(289),
    [sym_yield_expression] = STATE(289),
    [sym_jsx_element] = STATE(289),
    [sym_internal_module] = STATE(289),
    [sym_function] = STATE(290),
    [sym_arrow_function] = STATE(277),
    [sym_await_expression] = STATE(289),
    [sym_member_expression] = STATE(291),
    [sym_string] = STATE(277),
    [sym_this] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(292),
    [sym_anonymous_class] = STATE(277),
    [sym_generator_function] = STATE(277),
    [sym_call_expression] = STATE(289),
    [sym_subscript_expression] = STATE(291),
    [sym_assignment_expression] = STATE(289),
    [sym_ternary_expression] = STATE(289),
    [sym_binary_expression] = STATE(289),
    [sym_template_string] = STATE(277),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(1820),
    [sym_parenthesized_expression] = STATE(277),
    [sym_array] = STATE(293),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(289),
    [sym_class] = STATE(277),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(4988),
    [sym_false] = ACTIONS(482),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(4990),
    [anon_sym_symbol] = ACTIONS(4990),
    [anon_sym_number] = ACTIONS(4990),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4990),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4992),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(482),
    [sym_super] = ACTIONS(494),
    [anon_sym_any] = ACTIONS(4990),
    [anon_sym_private] = ACTIONS(4990),
    [anon_sym_boolean] = ACTIONS(4990),
    [anon_sym_async] = ACTIONS(4994),
    [anon_sym_public] = ACTIONS(4990),
    [anon_sym_get] = ACTIONS(4990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(498),
    [sym_true] = ACTIONS(482),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4990),
    [anon_sym_string] = ACTIONS(4990),
    [anon_sym_function] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(502),
    [sym_undefined] = ACTIONS(482),
    [anon_sym_set] = ACTIONS(4990),
    [anon_sym_type] = ACTIONS(4990),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(4990),
    [anon_sym_export] = ACTIONS(4990),
    [anon_sym_namespace] = ACTIONS(4996),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [3199] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(7967),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3200] = {
    [anon_sym_LBRACK] = ACTIONS(4314),
    [sym_identifier] = ACTIONS(4316),
    [anon_sym_module] = ACTIONS(4316),
    [anon_sym_symbol] = ACTIONS(4316),
    [anon_sym_number] = ACTIONS(4316),
    [anon_sym_AT] = ACTIONS(4314),
    [anon_sym_class] = ACTIONS(4316),
    [anon_sym_declare] = ACTIONS(4316),
    [anon_sym_STAR] = ACTIONS(4314),
    [anon_sym_void] = ACTIONS(4316),
    [anon_sym_any] = ACTIONS(4316),
    [anon_sym_private] = ACTIONS(4316),
    [anon_sym_boolean] = ACTIONS(4316),
    [anon_sym_async] = ACTIONS(4316),
    [anon_sym_public] = ACTIONS(4316),
    [anon_sym_get] = ACTIONS(4316),
    [anon_sym_static] = ACTIONS(4316),
    [anon_sym_RBRACE] = ACTIONS(4314),
    [anon_sym_SQUOTE] = ACTIONS(4314),
    [sym_number] = ACTIONS(4314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4316),
    [anon_sym_string] = ACTIONS(4316),
    [anon_sym_abstract] = ACTIONS(4316),
    [anon_sym_set] = ACTIONS(4316),
    [anon_sym_type] = ACTIONS(4316),
    [anon_sym_import] = ACTIONS(4316),
    [anon_sym_export] = ACTIONS(4316),
    [sym_readonly] = ACTIONS(4316),
    [anon_sym_namespace] = ACTIONS(4316),
    [anon_sym_DQUOTE] = ACTIONS(4314),
  },
  [3201] = {
    [aux_sym_array_repeat1] = STATE(1150),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_RPAREN] = ACTIONS(7978),
    [sym_comment] = ACTIONS(3),
  },
  [3202] = {
    [anon_sym_COMMA] = ACTIONS(7980),
    [anon_sym_RBRACE] = ACTIONS(7980),
    [sym_comment] = ACTIONS(3),
  },
  [3203] = {
    [sym_statement_block] = STATE(3829),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [3204] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(3830),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3205] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(3830),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(7982),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3206] = {
    [sym_identifier] = ACTIONS(2455),
    [anon_sym_BQUOTE] = ACTIONS(2457),
    [anon_sym_debugger] = ACTIONS(2455),
    [anon_sym_symbol] = ACTIONS(2455),
    [anon_sym_AT] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2455),
    [anon_sym_void] = ACTIONS(2455),
    [anon_sym_break] = ACTIONS(2455),
    [anon_sym_const] = ACTIONS(2455),
    [sym_super] = ACTIONS(2455),
    [anon_sym_return] = ACTIONS(2455),
    [anon_sym_private] = ACTIONS(2455),
    [anon_sym_get] = ACTIONS(2455),
    [anon_sym_RBRACE] = ACTIONS(2457),
    [anon_sym_interface] = ACTIONS(2455),
    [anon_sym_enum] = ACTIONS(2455),
    [anon_sym_delete] = ACTIONS(2455),
    [anon_sym_continue] = ACTIONS(2455),
    [anon_sym_DASH_DASH] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2455),
    [anon_sym_this] = ACTIONS(2455),
    [anon_sym_yield] = ACTIONS(2455),
    [sym_true] = ACTIONS(2455),
    [anon_sym_throw] = ACTIONS(2455),
    [anon_sym_protected] = ACTIONS(2455),
    [anon_sym_abstract] = ACTIONS(2455),
    [anon_sym_set] = ACTIONS(2455),
    [anon_sym_type] = ACTIONS(2455),
    [anon_sym_import] = ACTIONS(2455),
    [anon_sym_namespace] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2457),
    [anon_sym_await] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [anon_sym_else] = ACTIONS(7984),
    [anon_sym_BANG] = ACTIONS(2457),
    [anon_sym_for] = ACTIONS(2455),
    [anon_sym_LBRACK] = ACTIONS(2457),
    [sym_false] = ACTIONS(2455),
    [anon_sym_SEMI] = ACTIONS(2457),
    [anon_sym_module] = ACTIONS(2455),
    [anon_sym_number] = ACTIONS(2455),
    [anon_sym_class] = ACTIONS(2455),
    [anon_sym_declare] = ACTIONS(2455),
    [anon_sym_typeof] = ACTIONS(2455),
    [anon_sym_LBRACE] = ACTIONS(2457),
    [anon_sym_switch] = ACTIONS(2455),
    [anon_sym_LPAREN] = ACTIONS(2457),
    [sym_null] = ACTIONS(2455),
    [anon_sym_any] = ACTIONS(2455),
    [anon_sym_boolean] = ACTIONS(2455),
    [anon_sym_async] = ACTIONS(2455),
    [anon_sym_public] = ACTIONS(2455),
    [anon_sym_var] = ACTIONS(2455),
    [anon_sym_while] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_try] = ACTIONS(2455),
    [anon_sym_LT] = ACTIONS(2457),
    [sym_number] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2455),
    [anon_sym_function] = ACTIONS(2455),
    [sym_undefined] = ACTIONS(2455),
    [anon_sym_new] = ACTIONS(2455),
    [anon_sym_let] = ACTIONS(2455),
    [anon_sym_PLUS] = ACTIONS(2455),
    [anon_sym_export] = ACTIONS(2455),
    [anon_sym_do] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2457),
    [anon_sym_with] = ACTIONS(2455),
  },
  [3207] = {
    [sym_array] = STATE(3835),
    [sym_object] = STATE(3836),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(7986),
    [anon_sym_var] = ACTIONS(7988),
    [anon_sym_const] = ACTIONS(7988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_let] = ACTIONS(7988),
  },
  [3208] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(7990),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(7992),
  },
  [3209] = {
    [sym_variable_declarator] = STATE(97),
    [sym_array] = STATE(3840),
    [sym_object] = STATE(3841),
    [sym_identifier] = ACTIONS(7994),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [3210] = {
    [sym_variable_declarator] = STATE(258),
    [sym_array] = STATE(3840),
    [sym_object] = STATE(3841),
    [sym_identifier] = ACTIONS(7994),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [3211] = {
    [sym_new_expression] = STATE(59),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_yield_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_internal_module] = STATE(59),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(59),
    [sym_await_expression] = STATE(59),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3842),
    [sym_sequence_expression] = STATE(62),
    [sym_string] = STATE(59),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(3842),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(59),
    [sym_generator_function] = STATE(59),
    [sym_call_expression] = STATE(59),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(59),
    [sym_ternary_expression] = STATE(59),
    [sym_binary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(59),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [3212] = {
    [sym__initializer] = STATE(321),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(7996),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(7998),
  },
  [3213] = {
    [sym__initializer] = STATE(336),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(8000),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(8002),
  },
  [3214] = {
    [sym_identifier] = ACTIONS(8004),
    [sym_comment] = ACTIONS(3),
  },
  [3215] = {
    [anon_sym_of] = ACTIONS(8006),
    [sym_comment] = ACTIONS(3),
  },
  [3216] = {
    [anon_sym_of] = ACTIONS(8008),
    [sym_comment] = ACTIONS(3),
  },
  [3217] = {
    [anon_sym_of] = ACTIONS(8010),
    [sym_comment] = ACTIONS(3),
  },
  [3218] = {
    [sym_new_expression] = STATE(3851),
    [sym_augmented_assignment_expression] = STATE(3851),
    [sym_unary_expression] = STATE(3851),
    [sym_update_expression] = STATE(3851),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3851),
    [sym_regex] = STATE(3851),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3851),
    [sym_non_null_expression] = STATE(3851),
    [sym_as_expression] = STATE(3851),
    [sym_jsx_fragment] = STATE(3851),
    [sym_yield_expression] = STATE(3851),
    [sym_jsx_element] = STATE(3851),
    [sym_internal_module] = STATE(3851),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3851),
    [sym_await_expression] = STATE(3851),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3851),
    [sym_this] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3851),
    [sym_generator_function] = STATE(3851),
    [sym_call_expression] = STATE(3851),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3851),
    [sym_ternary_expression] = STATE(3851),
    [sym_binary_expression] = STATE(3851),
    [sym_template_string] = STATE(3851),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3851),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3851),
    [sym_class] = STATE(3851),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(8012),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8012),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8014),
    [sym_true] = ACTIONS(8012),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8012),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3219] = {
    [sym_new_expression] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(3852),
    [sym_unary_expression] = STATE(3852),
    [sym_update_expression] = STATE(3852),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3852),
    [sym_regex] = STATE(3852),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3852),
    [sym_non_null_expression] = STATE(3852),
    [sym_as_expression] = STATE(3852),
    [sym_jsx_fragment] = STATE(3852),
    [sym_yield_expression] = STATE(3852),
    [sym_jsx_element] = STATE(3852),
    [sym_internal_module] = STATE(3852),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3852),
    [sym_await_expression] = STATE(3852),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3852),
    [sym_this] = STATE(3852),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3852),
    [sym_generator_function] = STATE(3852),
    [sym_call_expression] = STATE(3852),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3852),
    [sym_ternary_expression] = STATE(3852),
    [sym_binary_expression] = STATE(3852),
    [sym_template_string] = STATE(3852),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3852),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3852),
    [sym_class] = STATE(3852),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(8016),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8016),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8018),
    [sym_true] = ACTIONS(8016),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8016),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3220] = {
    [sym_new_expression] = STATE(3853),
    [sym_augmented_assignment_expression] = STATE(3853),
    [sym_unary_expression] = STATE(3853),
    [sym_update_expression] = STATE(3853),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3853),
    [sym_regex] = STATE(3853),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3853),
    [sym_non_null_expression] = STATE(3853),
    [sym_as_expression] = STATE(3853),
    [sym_jsx_fragment] = STATE(3853),
    [sym_yield_expression] = STATE(3853),
    [sym_jsx_element] = STATE(3853),
    [sym_internal_module] = STATE(3853),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3853),
    [sym_await_expression] = STATE(3853),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3853),
    [sym_this] = STATE(3853),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3853),
    [sym_generator_function] = STATE(3853),
    [sym_call_expression] = STATE(3853),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3853),
    [sym_ternary_expression] = STATE(3853),
    [sym_binary_expression] = STATE(3853),
    [sym_template_string] = STATE(3853),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3853),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3853),
    [sym_class] = STATE(3853),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(8020),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8020),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8022),
    [sym_true] = ACTIONS(8020),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8020),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3221] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(8024),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3222] = {
    [anon_sym_RPAREN] = ACTIONS(8024),
    [sym_comment] = ACTIONS(3),
  },
  [3223] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(8026),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3224] = {
    [sym_new_expression] = STATE(3856),
    [sym_augmented_assignment_expression] = STATE(3856),
    [sym_unary_expression] = STATE(3856),
    [sym_update_expression] = STATE(3856),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(3856),
    [sym_regex] = STATE(3856),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3856),
    [sym_non_null_expression] = STATE(3856),
    [sym_as_expression] = STATE(3856),
    [sym_jsx_fragment] = STATE(3856),
    [sym_yield_expression] = STATE(3856),
    [sym_jsx_element] = STATE(3856),
    [sym_internal_module] = STATE(3856),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3856),
    [sym_await_expression] = STATE(3856),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(3857),
    [sym_string] = STATE(3856),
    [sym_this] = STATE(3856),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(3856),
    [sym_generator_function] = STATE(3856),
    [sym_call_expression] = STATE(3856),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(3856),
    [sym_ternary_expression] = STATE(3856),
    [sym_binary_expression] = STATE(3856),
    [sym_template_string] = STATE(3856),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3856),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3856),
    [sym_class] = STATE(3856),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(8028),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8028),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8030),
    [sym_true] = ACTIONS(8028),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8028),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [3225] = {
    [sym_new_expression] = STATE(3858),
    [sym_augmented_assignment_expression] = STATE(3858),
    [sym_unary_expression] = STATE(3858),
    [sym_update_expression] = STATE(3858),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(3858),
    [sym_regex] = STATE(3858),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3858),
    [sym_non_null_expression] = STATE(3858),
    [sym_as_expression] = STATE(3858),
    [sym_jsx_fragment] = STATE(3858),
    [sym_yield_expression] = STATE(3858),
    [sym_jsx_element] = STATE(3858),
    [sym_internal_module] = STATE(3858),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3858),
    [sym_await_expression] = STATE(3858),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(3859),
    [sym_string] = STATE(3858),
    [sym_this] = STATE(3858),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(3858),
    [sym_generator_function] = STATE(3858),
    [sym_call_expression] = STATE(3858),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(3858),
    [sym_ternary_expression] = STATE(3858),
    [sym_binary_expression] = STATE(3858),
    [sym_template_string] = STATE(3858),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3858),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3858),
    [sym_class] = STATE(3858),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(8032),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8032),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8034),
    [sym_true] = ACTIONS(8032),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8032),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [3226] = {
    [sym_new_expression] = STATE(3860),
    [sym_augmented_assignment_expression] = STATE(3860),
    [sym_unary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(3860),
    [sym_regex] = STATE(3860),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3860),
    [sym_non_null_expression] = STATE(3860),
    [sym_as_expression] = STATE(3860),
    [sym_jsx_fragment] = STATE(3860),
    [sym_yield_expression] = STATE(3860),
    [sym_jsx_element] = STATE(3860),
    [sym_internal_module] = STATE(3860),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3860),
    [sym_await_expression] = STATE(3860),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(3861),
    [sym_string] = STATE(3860),
    [sym_this] = STATE(3860),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(3860),
    [sym_generator_function] = STATE(3860),
    [sym_call_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(3860),
    [sym_ternary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_template_string] = STATE(3860),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3860),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3860),
    [sym_class] = STATE(3860),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(8036),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8036),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8038),
    [sym_true] = ACTIONS(8036),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8036),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [3227] = {
    [sym_type_alias_declaration] = STATE(3041),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3041),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3041),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3041),
    [sym_return_statement] = STATE(3041),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3041),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3041),
    [sym_switch_statement] = STATE(3041),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3041),
    [sym_throw_statement] = STATE(3041),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3041),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3041),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(3041),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3041),
    [sym_abstract_class] = STATE(3041),
    [sym_interface_declaration] = STATE(3041),
    [sym_statement_block] = STATE(3041),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3041),
    [sym_debugger_statement] = STATE(3041),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3041),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3041),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3041),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3041),
    [sym_empty_statement] = STATE(3041),
    [sym_import_alias] = STATE(3041),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3041),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3041),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3041),
    [sym_break_statement] = STATE(3041),
    [sym_labeled_statement] = STATE(3041),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3041),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [3228] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(8040),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3229] = {
    [anon_sym_RPAREN] = ACTIONS(8040),
    [sym_comment] = ACTIONS(3),
  },
  [3230] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(8042),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3231] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(8044),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3232] = {
    [anon_sym_RPAREN] = ACTIONS(8044),
    [sym_comment] = ACTIONS(3),
  },
  [3233] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(8046),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3234] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(8048),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3235] = {
    [anon_sym_RPAREN] = ACTIONS(8048),
    [sym_comment] = ACTIONS(3),
  },
  [3236] = {
    [sym_union_type] = STATE(3872),
    [sym__type] = STATE(3872),
    [sym_constructor_type] = STATE(3872),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(3873),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3872),
    [sym_function_type] = STATE(3872),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3874),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8050),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8052),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8054),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8056),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3237] = {
    [sym_string] = STATE(3875),
    [sym__property_name] = STATE(3875),
    [sym_computed_property_name] = STATE(3875),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(8060),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [3238] = {
    [sym_string] = STATE(3875),
    [sym__property_name] = STATE(3875),
    [sym_computed_property_name] = STATE(3875),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(8060),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [3239] = {
    [sym_new_expression] = STATE(3876),
    [sym_augmented_assignment_expression] = STATE(3876),
    [sym_unary_expression] = STATE(3876),
    [sym_update_expression] = STATE(3876),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(3876),
    [sym_regex] = STATE(3876),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1233),
    [sym__expression] = STATE(3876),
    [sym_non_null_expression] = STATE(3876),
    [sym_yield_expression] = STATE(3876),
    [sym_jsx_fragment] = STATE(3876),
    [sym_jsx_element] = STATE(3876),
    [sym_as_expression] = STATE(3876),
    [sym_internal_module] = STATE(3876),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3876),
    [sym_await_expression] = STATE(3876),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(3876),
    [sym_this] = STATE(3876),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3876),
    [sym_generator_function] = STATE(3876),
    [sym_call_expression] = STATE(3876),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3876),
    [sym_ternary_expression] = STATE(3876),
    [sym_binary_expression] = STATE(3876),
    [sym_template_string] = STATE(3876),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3876),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3876),
    [sym_class] = STATE(3876),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(8062),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8062),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8064),
    [sym_true] = ACTIONS(8062),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8062),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [3240] = {
    [sym_new_expression] = STATE(3877),
    [sym_augmented_assignment_expression] = STATE(3877),
    [sym_unary_expression] = STATE(3877),
    [sym_update_expression] = STATE(3877),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(3877),
    [sym_regex] = STATE(3877),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3877),
    [sym_non_null_expression] = STATE(3877),
    [sym_as_expression] = STATE(3877),
    [sym_jsx_fragment] = STATE(3877),
    [sym_yield_expression] = STATE(3877),
    [sym_jsx_element] = STATE(3877),
    [sym_internal_module] = STATE(3877),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3877),
    [sym_await_expression] = STATE(3877),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(3877),
    [sym_this] = STATE(3877),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3877),
    [sym_generator_function] = STATE(3877),
    [sym_call_expression] = STATE(3877),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3877),
    [sym_ternary_expression] = STATE(3877),
    [sym_binary_expression] = STATE(3877),
    [sym_template_string] = STATE(3877),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3877),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3877),
    [sym_class] = STATE(3877),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(8066),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8066),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8068),
    [sym_true] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8066),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [3241] = {
    [sym_new_expression] = STATE(3878),
    [sym_augmented_assignment_expression] = STATE(3878),
    [sym_unary_expression] = STATE(3878),
    [sym_update_expression] = STATE(3878),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(3878),
    [sym_regex] = STATE(3878),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3878),
    [sym_non_null_expression] = STATE(3878),
    [sym_as_expression] = STATE(3878),
    [sym_jsx_fragment] = STATE(3878),
    [sym_yield_expression] = STATE(3878),
    [sym_jsx_element] = STATE(3878),
    [sym_internal_module] = STATE(3878),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3878),
    [sym_await_expression] = STATE(3878),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(3878),
    [sym_this] = STATE(3878),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3878),
    [sym_generator_function] = STATE(3878),
    [sym_call_expression] = STATE(3878),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3878),
    [sym_ternary_expression] = STATE(3878),
    [sym_binary_expression] = STATE(3878),
    [sym_template_string] = STATE(3878),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3878),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3878),
    [sym_class] = STATE(3878),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(8070),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8070),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8072),
    [sym_true] = ACTIONS(8070),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8070),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [3242] = {
    [sym_new_expression] = STATE(3879),
    [sym_augmented_assignment_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3879),
    [sym_update_expression] = STATE(3879),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(3879),
    [sym_regex] = STATE(3879),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3879),
    [sym_non_null_expression] = STATE(3879),
    [sym_as_expression] = STATE(3879),
    [sym_jsx_fragment] = STATE(3879),
    [sym_yield_expression] = STATE(3879),
    [sym_jsx_element] = STATE(3879),
    [sym_internal_module] = STATE(3879),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3879),
    [sym_await_expression] = STATE(3879),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(3879),
    [sym_this] = STATE(3879),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3879),
    [sym_generator_function] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3879),
    [sym_ternary_expression] = STATE(3879),
    [sym_binary_expression] = STATE(3879),
    [sym_template_string] = STATE(3879),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3879),
    [sym_class] = STATE(3879),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(8074),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8074),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8076),
    [sym_true] = ACTIONS(8074),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8074),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [3243] = {
    [sym_new_expression] = STATE(3880),
    [sym_augmented_assignment_expression] = STATE(3880),
    [sym_unary_expression] = STATE(3880),
    [sym_update_expression] = STATE(3880),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(3880),
    [sym_regex] = STATE(3880),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1240),
    [sym__expression] = STATE(3880),
    [sym_non_null_expression] = STATE(3880),
    [sym_yield_expression] = STATE(3880),
    [sym_jsx_fragment] = STATE(3880),
    [sym_jsx_element] = STATE(3880),
    [sym_as_expression] = STATE(3880),
    [sym_internal_module] = STATE(3880),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3880),
    [sym_await_expression] = STATE(3880),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(3880),
    [sym_this] = STATE(3880),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3880),
    [sym_generator_function] = STATE(3880),
    [sym_call_expression] = STATE(3880),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3880),
    [sym_ternary_expression] = STATE(3880),
    [sym_binary_expression] = STATE(3880),
    [sym_template_string] = STATE(3880),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3880),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3880),
    [sym_class] = STATE(3880),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(8078),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8078),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8080),
    [sym_true] = ACTIONS(8078),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8078),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [3244] = {
    [sym_new_expression] = STATE(3881),
    [sym_augmented_assignment_expression] = STATE(3881),
    [sym_unary_expression] = STATE(3881),
    [sym_update_expression] = STATE(3881),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(3881),
    [sym_regex] = STATE(3881),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3881),
    [sym_non_null_expression] = STATE(3881),
    [sym_as_expression] = STATE(3881),
    [sym_jsx_fragment] = STATE(3881),
    [sym_yield_expression] = STATE(3881),
    [sym_jsx_element] = STATE(3881),
    [sym_internal_module] = STATE(3881),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3881),
    [sym_await_expression] = STATE(3881),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(3881),
    [sym_this] = STATE(3881),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3881),
    [sym_generator_function] = STATE(3881),
    [sym_call_expression] = STATE(3881),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3881),
    [sym_ternary_expression] = STATE(3881),
    [sym_binary_expression] = STATE(3881),
    [sym_template_string] = STATE(3881),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3881),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3881),
    [sym_class] = STATE(3881),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(8082),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8082),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8084),
    [sym_true] = ACTIONS(8082),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8082),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [3245] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(8086),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(702),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [3246] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(704),
    [anon_sym_GT_GT_GT] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(704),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_LT_EQ] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(704),
    [anon_sym_AMP] = ACTIONS(704),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(702),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_PIPE_PIPE] = ACTIONS(702),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_instanceof] = ACTIONS(702),
    [anon_sym_LT] = ACTIONS(8086),
    [anon_sym_SLASH] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(702),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_STAR_STAR] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(704),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(702),
    [anon_sym_in] = ACTIONS(704),
  },
  [3247] = {
    [anon_sym_EQ_GT] = ACTIONS(8089),
    [sym_comment] = ACTIONS(3),
  },
  [3248] = {
    [anon_sym_EQ_GT] = ACTIONS(8091),
    [sym_comment] = ACTIONS(3),
  },
  [3249] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_BQUOTE] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_instanceof] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(839),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_in] = ACTIONS(841),
  },
  [3250] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6825),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6827),
    [anon_sym_COMMA] = ACTIONS(871),
    [anon_sym_LT_LT] = ACTIONS(6831),
    [anon_sym_STAR] = ACTIONS(6837),
    [anon_sym_GT_GT_GT] = ACTIONS(6831),
    [anon_sym_AMP_AMP] = ACTIONS(6835),
    [anon_sym_DASH] = ACTIONS(6833),
    [anon_sym_BANG_EQ] = ACTIONS(6785),
    [anon_sym_LT_EQ] = ACTIONS(6825),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6825),
    [anon_sym_GT] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6839),
    [anon_sym_PERCENT] = ACTIONS(6831),
    [anon_sym_QMARK] = ACTIONS(6841),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_PIPE_PIPE] = ACTIONS(6843),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6785),
    [anon_sym_instanceof] = ACTIONS(6825),
    [anon_sym_LT] = ACTIONS(6847),
    [anon_sym_SLASH] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(871),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6843),
    [anon_sym_STAR_STAR] = ACTIONS(6851),
    [anon_sym_PLUS] = ACTIONS(6833),
    [anon_sym_GT_GT] = ACTIONS(6837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6825),
    [anon_sym_in] = ACTIONS(6785),
  },
  [3251] = {
    [sym__initializer] = STATE(522),
    [sym_arguments] = STATE(1268),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_DASH] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1531),
    [anon_sym_GT_GT_GT] = ACTIONS(1531),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1531),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(6783),
    [anon_sym_AMP] = ACTIONS(1531),
    [anon_sym_PERCENT] = ACTIONS(1531),
    [anon_sym_QMARK] = ACTIONS(1529),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1531),
    [anon_sym_instanceof] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_SLASH] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1529),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1531),
    [anon_sym_STAR_STAR] = ACTIONS(1531),
    [anon_sym_PLUS] = ACTIONS(1531),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1531),
  },
  [3252] = {
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [3253] = {
    [sym_new_expression] = STATE(836),
    [sym_augmented_assignment_expression] = STATE(836),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(836),
    [sym_update_expression] = STATE(836),
    [sym_regex] = STATE(836),
    [sym_meta_property] = STATE(836),
    [sym_call_signature] = STATE(835),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(836),
    [sym_non_null_expression] = STATE(836),
    [sym_yield_expression] = STATE(836),
    [sym_jsx_fragment] = STATE(836),
    [sym_jsx_element] = STATE(836),
    [sym_as_expression] = STATE(836),
    [sym_internal_module] = STATE(836),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(836),
    [sym_await_expression] = STATE(836),
    [sym_member_expression] = STATE(837),
    [sym_string] = STATE(836),
    [sym_this] = STATE(836),
    [sym_arguments] = STATE(1270),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(838),
    [sym_anonymous_class] = STATE(836),
    [sym_generator_function] = STATE(836),
    [sym_call_expression] = STATE(836),
    [sym_subscript_expression] = STATE(837),
    [sym_assignment_expression] = STATE(836),
    [sym_ternary_expression] = STATE(836),
    [sym_binary_expression] = STATE(836),
    [sym_template_string] = STATE(836),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(836),
    [sym_array] = STATE(839),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(836),
    [sym_class] = STATE(836),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(500),
    [sym_true] = ACTIONS(1545),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [sym_false] = ACTIONS(1545),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [sym_null] = ACTIONS(1545),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_EQ_GT] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [sym_number] = ACTIONS(1553),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(1545),
    [anon_sym_new] = ACTIONS(1555),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [3254] = {
    [sym_type_parameters] = STATE(51),
    [sym__initializer] = STATE(528),
    [sym_formal_parameters] = STATE(57),
    [sym_arguments] = STATE(1270),
    [sym_call_signature] = STATE(3247),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(6799),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(6801),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(6801),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(6801),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(6801),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_protected] = ACTIONS(6801),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_set] = ACTIONS(6801),
    [anon_sym_type] = ACTIONS(6801),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_import] = ACTIONS(6801),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(6801),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(6801),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(6801),
    [anon_sym_declare] = ACTIONS(6801),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_any] = ACTIONS(6801),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(6801),
    [anon_sym_async] = ACTIONS(6801),
    [anon_sym_public] = ACTIONS(6801),
    [anon_sym_EQ_GT] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(6801),
    [anon_sym_function] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(6801),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [3255] = {
    [sym_nested_identifier] = STATE(570),
    [sym__module] = STATE(571),
    [sym_string] = STATE(572),
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(1270),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1539),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_BQUOTE] = ACTIONS(1539),
    [sym_identifier] = ACTIONS(1037),
    [anon_sym_PERCENT_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_AMP_EQ] = ACTIONS(1533),
    [anon_sym_PLUS_EQ] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_LT_LT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_GT_GT_GT] = ACTIONS(1541),
    [anon_sym_AMP_AMP] = ACTIONS(1539),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1541),
    [anon_sym_LT_EQ] = ACTIONS(1539),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1541),
    [anon_sym_CARET_EQ] = ACTIONS(1533),
    [anon_sym_STAR_EQ] = ACTIONS(1533),
    [anon_sym_PIPE_EQ] = ACTIONS(1533),
    [anon_sym_DASH_EQ] = ACTIONS(1533),
    [anon_sym_EQ_GT] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_PERCENT] = ACTIONS(1541),
    [anon_sym_QMARK] = ACTIONS(1539),
    [anon_sym_LT_LT_EQ] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1541),
    [anon_sym_PIPE_PIPE] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1539),
    [anon_sym_EQ_EQ] = ACTIONS(1541),
    [anon_sym_instanceof] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_SLASH] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1539),
    [anon_sym_SLASH_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT_EQ] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(1541),
    [anon_sym_STAR_STAR] = ACTIONS(1541),
    [anon_sym_PLUS] = ACTIONS(1541),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1533),
    [anon_sym_GT_GT] = ACTIONS(1541),
    [anon_sym_PLUS_PLUS] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1539),
    [anon_sym_in] = ACTIONS(1541),
  },
  [3256] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6825),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6827),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(6831),
    [anon_sym_STAR] = ACTIONS(6837),
    [anon_sym_GT_GT_GT] = ACTIONS(6831),
    [anon_sym_AMP_AMP] = ACTIONS(6835),
    [anon_sym_DASH] = ACTIONS(6833),
    [anon_sym_BANG_EQ] = ACTIONS(6785),
    [anon_sym_LT_EQ] = ACTIONS(6825),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6825),
    [anon_sym_GT] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6839),
    [anon_sym_PERCENT] = ACTIONS(6831),
    [anon_sym_QMARK] = ACTIONS(6841),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_PIPE_PIPE] = ACTIONS(6843),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6785),
    [anon_sym_instanceof] = ACTIONS(6825),
    [anon_sym_LT] = ACTIONS(6847),
    [anon_sym_SLASH] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6843),
    [anon_sym_STAR_STAR] = ACTIONS(6851),
    [anon_sym_PLUS] = ACTIONS(6833),
    [anon_sym_GT_GT] = ACTIONS(6837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6825),
    [anon_sym_in] = ACTIONS(6785),
  },
  [3257] = {
    [sym_new_expression] = STATE(3884),
    [sym_augmented_assignment_expression] = STATE(3884),
    [sym_unary_expression] = STATE(3884),
    [sym_update_expression] = STATE(3884),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(3884),
    [sym_regex] = STATE(3884),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3884),
    [sym_non_null_expression] = STATE(3884),
    [sym_as_expression] = STATE(3884),
    [sym_jsx_fragment] = STATE(3884),
    [sym_yield_expression] = STATE(3884),
    [sym_jsx_element] = STATE(3884),
    [sym_internal_module] = STATE(3884),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3884),
    [sym_await_expression] = STATE(3884),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(3884),
    [sym_this] = STATE(3884),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3884),
    [sym_generator_function] = STATE(3884),
    [sym_call_expression] = STATE(3884),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3884),
    [sym_ternary_expression] = STATE(3884),
    [sym_binary_expression] = STATE(3884),
    [sym_template_string] = STATE(3884),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3884),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3884),
    [sym_class] = STATE(3884),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(8093),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8093),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8095),
    [sym_true] = ACTIONS(8093),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8093),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [3258] = {
    [sym_new_expression] = STATE(3885),
    [sym_augmented_assignment_expression] = STATE(3885),
    [sym_unary_expression] = STATE(3885),
    [sym_update_expression] = STATE(3885),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(3885),
    [sym_regex] = STATE(3885),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3885),
    [sym_non_null_expression] = STATE(3885),
    [sym_as_expression] = STATE(3885),
    [sym_jsx_fragment] = STATE(3885),
    [sym_yield_expression] = STATE(3885),
    [sym_jsx_element] = STATE(3885),
    [sym_internal_module] = STATE(3885),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3885),
    [sym_await_expression] = STATE(3885),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(3885),
    [sym_this] = STATE(3885),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3885),
    [sym_generator_function] = STATE(3885),
    [sym_call_expression] = STATE(3885),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3885),
    [sym_ternary_expression] = STATE(3885),
    [sym_binary_expression] = STATE(3885),
    [sym_template_string] = STATE(3885),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3885),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3885),
    [sym_class] = STATE(3885),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(8097),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8097),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8099),
    [sym_true] = ACTIONS(8097),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8097),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [3259] = {
    [sym_new_expression] = STATE(3886),
    [sym_augmented_assignment_expression] = STATE(3886),
    [sym_unary_expression] = STATE(3886),
    [sym_update_expression] = STATE(3886),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(3886),
    [sym_regex] = STATE(3886),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3886),
    [sym_non_null_expression] = STATE(3886),
    [sym_as_expression] = STATE(3886),
    [sym_jsx_fragment] = STATE(3886),
    [sym_yield_expression] = STATE(3886),
    [sym_jsx_element] = STATE(3886),
    [sym_internal_module] = STATE(3886),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3886),
    [sym_await_expression] = STATE(3886),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(3886),
    [sym_this] = STATE(3886),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3886),
    [sym_generator_function] = STATE(3886),
    [sym_call_expression] = STATE(3886),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3886),
    [sym_ternary_expression] = STATE(3886),
    [sym_binary_expression] = STATE(3886),
    [sym_template_string] = STATE(3886),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3886),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3886),
    [sym_class] = STATE(3886),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(8101),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8101),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8103),
    [sym_true] = ACTIONS(8101),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8101),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [3260] = {
    [sym_new_expression] = STATE(3887),
    [sym_augmented_assignment_expression] = STATE(3887),
    [sym_unary_expression] = STATE(3887),
    [sym_update_expression] = STATE(3887),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(3887),
    [sym_regex] = STATE(3887),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3887),
    [sym_non_null_expression] = STATE(3887),
    [sym_as_expression] = STATE(3887),
    [sym_jsx_fragment] = STATE(3887),
    [sym_yield_expression] = STATE(3887),
    [sym_jsx_element] = STATE(3887),
    [sym_internal_module] = STATE(3887),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3887),
    [sym_await_expression] = STATE(3887),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(3887),
    [sym_this] = STATE(3887),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3887),
    [sym_generator_function] = STATE(3887),
    [sym_call_expression] = STATE(3887),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3887),
    [sym_ternary_expression] = STATE(3887),
    [sym_binary_expression] = STATE(3887),
    [sym_template_string] = STATE(3887),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3887),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3887),
    [sym_class] = STATE(3887),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(8105),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8105),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8107),
    [sym_true] = ACTIONS(8105),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8105),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [3261] = {
    [sym_new_expression] = STATE(3888),
    [sym_augmented_assignment_expression] = STATE(3888),
    [sym_unary_expression] = STATE(3888),
    [sym_update_expression] = STATE(3888),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(3888),
    [sym_regex] = STATE(3888),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3888),
    [sym_non_null_expression] = STATE(3888),
    [sym_as_expression] = STATE(3888),
    [sym_jsx_fragment] = STATE(3888),
    [sym_yield_expression] = STATE(3888),
    [sym_jsx_element] = STATE(3888),
    [sym_internal_module] = STATE(3888),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3888),
    [sym_await_expression] = STATE(3888),
    [sym_member_expression] = STATE(2431),
    [sym_sequence_expression] = STATE(1521),
    [sym_string] = STATE(3888),
    [sym_this] = STATE(3888),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3888),
    [sym_generator_function] = STATE(3888),
    [sym_call_expression] = STATE(3888),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3888),
    [sym_ternary_expression] = STATE(3888),
    [sym_binary_expression] = STATE(3888),
    [sym_template_string] = STATE(3888),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3888),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3888),
    [sym_class] = STATE(3888),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(8109),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8109),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8111),
    [sym_true] = ACTIONS(8109),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8109),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [3262] = {
    [sym_new_expression] = STATE(3889),
    [sym_augmented_assignment_expression] = STATE(3889),
    [sym_unary_expression] = STATE(3889),
    [sym_update_expression] = STATE(3889),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(3889),
    [sym_regex] = STATE(3889),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3889),
    [sym_non_null_expression] = STATE(3889),
    [sym_as_expression] = STATE(3889),
    [sym_jsx_fragment] = STATE(3889),
    [sym_yield_expression] = STATE(3889),
    [sym_jsx_element] = STATE(3889),
    [sym_internal_module] = STATE(3889),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3889),
    [sym_await_expression] = STATE(3889),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(3889),
    [sym_this] = STATE(3889),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(3889),
    [sym_generator_function] = STATE(3889),
    [sym_call_expression] = STATE(3889),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(3889),
    [sym_ternary_expression] = STATE(3889),
    [sym_binary_expression] = STATE(3889),
    [sym_template_string] = STATE(3889),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3889),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3889),
    [sym_class] = STATE(3889),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(8113),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8113),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8115),
    [sym_true] = ACTIONS(8113),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8113),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [3263] = {
    [sym_union_type] = STATE(1293),
    [sym__type] = STATE(1293),
    [sym_constructor_type] = STATE(1293),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3895),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_template_string] = STATE(1297),
    [sym_intersection_type] = STATE(1293),
    [sym_function_type] = STATE(1293),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3896),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(8117),
    [sym_false] = ACTIONS(2643),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_keyof] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_PIPE] = ACTIONS(8119),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_boolean] = ACTIONS(2647),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(8121),
    [anon_sym_QMARK] = ACTIONS(8123),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2669),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_new] = ACTIONS(8125),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_DQUOTE] = ACTIONS(304),
  },
  [3264] = {
    [sym_new_expression] = STATE(3877),
    [sym_constructor_type] = STATE(432),
    [sym_augmented_assignment_expression] = STATE(3877),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(3877),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(3877),
    [sym_type_parameters] = STATE(959),
    [sym_array_type] = STATE(436),
    [sym_yield_expression] = STATE(3877),
    [sym_as_expression] = STATE(3877),
    [sym_jsx_fragment] = STATE(3877),
    [sym_internal_module] = STATE(3877),
    [sym_arrow_function] = STATE(3877),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(2431),
    [sym_literal_type] = STATE(436),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(1301),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(3877),
    [sym_subscript_expression] = STATE(2431),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(3877),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(3877),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(960),
    [sym_function_type] = STATE(432),
    [sym__type] = STATE(432),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(3877),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(3877),
    [sym__expression] = STATE(3877),
    [sym_non_null_expression] = STATE(3877),
    [sym_jsx_element] = STATE(3877),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_await_expression] = STATE(3877),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_this] = STATE(3877),
    [sym_union_type] = STATE(432),
    [sym_anonymous_class] = STATE(3877),
    [sym_call_expression] = STATE(3877),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(3877),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(3877),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(432),
    [sym_parenthesized_expression] = STATE(3877),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3877),
    [sym_class] = STATE(3877),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(8127),
    [sym_false] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(8129),
    [anon_sym_number] = ACTIONS(8129),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(8131),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(8133),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_void] = ACTIONS(8135),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [sym_null] = ACTIONS(8066),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(8129),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(8129),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2691),
    [sym_true] = ACTIONS(2677),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(2693),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(8129),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8066),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(8137),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(8133),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [3265] = {
    [sym_type_alias_declaration] = STATE(3903),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3903),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3903),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3903),
    [sym_return_statement] = STATE(3903),
    [aux_sym_program_repeat1] = STATE(3903),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3903),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3903),
    [sym_switch_statement] = STATE(3903),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3903),
    [sym_throw_statement] = STATE(3903),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3903),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3903),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(3903),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3903),
    [sym_abstract_class] = STATE(3903),
    [sym_interface_declaration] = STATE(3903),
    [sym_statement_block] = STATE(3903),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3903),
    [sym_debugger_statement] = STATE(3903),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3903),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3903),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3903),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3903),
    [sym_empty_statement] = STATE(3903),
    [sym_import_alias] = STATE(3903),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3903),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3903),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3903),
    [sym_break_statement] = STATE(3903),
    [sym_labeled_statement] = STATE(3903),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3903),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(8139),
    [anon_sym_default] = ACTIONS(8141),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(8141),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [3266] = {
    [sym_new_expression] = STATE(3904),
    [sym_augmented_assignment_expression] = STATE(3904),
    [sym_unary_expression] = STATE(3904),
    [sym_update_expression] = STATE(3904),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(3904),
    [sym_regex] = STATE(3904),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3904),
    [sym_non_null_expression] = STATE(3904),
    [sym_as_expression] = STATE(3904),
    [sym_jsx_fragment] = STATE(3904),
    [sym_yield_expression] = STATE(3904),
    [sym_jsx_element] = STATE(3904),
    [sym_internal_module] = STATE(3904),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3904),
    [sym_await_expression] = STATE(3904),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(3904),
    [sym_this] = STATE(3904),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3904),
    [sym_generator_function] = STATE(3904),
    [sym_call_expression] = STATE(3904),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3904),
    [sym_ternary_expression] = STATE(3904),
    [sym_binary_expression] = STATE(3904),
    [sym_template_string] = STATE(3904),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3904),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3904),
    [sym_class] = STATE(3904),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(8143),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8143),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8145),
    [sym_true] = ACTIONS(8143),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8143),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [3267] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(8147),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [3268] = {
    [sym_parenthesized_expression] = STATE(3906),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [3269] = {
    [anon_sym_await] = ACTIONS(8149),
    [anon_sym_LPAREN] = ACTIONS(8151),
    [sym_comment] = ACTIONS(3),
  },
  [3270] = {
    [sym_type_alias_declaration] = STATE(193),
    [aux_sym_export_statement_repeat1] = STATE(3912),
    [sym__declaration] = STATE(193),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(193),
    [sym_import_alias] = STATE(193),
    [sym_export_statement] = STATE(193),
    [sym_generator_function] = STATE(193),
    [sym_lexical_declaration] = STATE(193),
    [sym_internal_module] = STATE(193),
    [sym_decorator] = STATE(3912),
    [sym_enum_declaration] = STATE(193),
    [sym_function] = STATE(193),
    [sym_function_signature] = STATE(193),
    [sym_variable_declaration] = STATE(193),
    [sym_abstract_class] = STATE(193),
    [sym_module] = STATE(193),
    [sym_interface_declaration] = STATE(193),
    [sym_class] = STATE(193),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(324),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(8153),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_declare] = ACTIONS(8155),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(8157),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3271] = {
    [sym_parenthesized_expression] = STATE(3913),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [3272] = {
    [sym_type_alias_declaration] = STATE(300),
    [aux_sym_export_statement_repeat1] = STATE(3912),
    [sym__declaration] = STATE(300),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(300),
    [sym_import_alias] = STATE(300),
    [sym_export_statement] = STATE(300),
    [sym_generator_function] = STATE(300),
    [sym_export_clause] = STATE(301),
    [sym_lexical_declaration] = STATE(300),
    [sym_internal_module] = STATE(300),
    [sym_decorator] = STATE(3912),
    [sym_enum_declaration] = STATE(300),
    [sym_function] = STATE(300),
    [sym_function_signature] = STATE(300),
    [sym_variable_declaration] = STATE(300),
    [sym_abstract_class] = STATE(300),
    [sym_module] = STATE(300),
    [sym_interface_declaration] = STATE(300),
    [sym_class] = STATE(300),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(508),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(511),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_as] = ACTIONS(515),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_declare] = ACTIONS(8155),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(8157),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3273] = {
    [sym_parenthesized_expression] = STATE(3914),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [3274] = {
    [sym_type_alias_declaration] = STATE(3915),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3915),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3915),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3915),
    [sym_return_statement] = STATE(3915),
    [aux_sym_program_repeat1] = STATE(3915),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3915),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3915),
    [sym_switch_statement] = STATE(3915),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3915),
    [sym_throw_statement] = STATE(3915),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3915),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3915),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(3915),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3915),
    [sym_abstract_class] = STATE(3915),
    [sym_interface_declaration] = STATE(3915),
    [sym_statement_block] = STATE(3915),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3915),
    [sym_debugger_statement] = STATE(3915),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3915),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3915),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3915),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3915),
    [sym_empty_statement] = STATE(3915),
    [sym_import_alias] = STATE(3915),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3915),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3915),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3915),
    [sym_break_statement] = STATE(3915),
    [sym_labeled_statement] = STATE(3915),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3915),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(8159),
    [anon_sym_default] = ACTIONS(8161),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(8161),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [3275] = {
    [aux_sym_export_statement_repeat1] = STATE(320),
    [sym_decorator] = STATE(320),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(8163),
    [anon_sym_class] = ACTIONS(546),
    [sym_comment] = ACTIONS(3),
  },
  [3276] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3280),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3281),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3109),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6885),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6887),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3277] = {
    [sym_type_parameters] = STATE(3917),
    [sym_formal_parameters] = STATE(3918),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3278] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3280),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3281),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3109),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6885),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6887),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3279] = {
    [anon_sym_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_RPAREN] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(8165),
    [anon_sym_COMMA] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(8167),
    [sym_comment] = ACTIONS(3),
  },
  [3280] = {
    [sym_formal_parameters] = STATE(3921),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3281] = {
    [anon_sym_EQ_GT] = ACTIONS(8169),
    [sym_comment] = ACTIONS(3),
  },
  [3282] = {
    [anon_sym_EQ_GT] = ACTIONS(8171),
    [sym_comment] = ACTIONS(3),
  },
  [3283] = {
    [sym_union_type] = STATE(3924),
    [sym__type] = STATE(3924),
    [sym_constructor_type] = STATE(3924),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1488),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3924),
    [sym_function_type] = STATE(3924),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1489),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3109),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3113),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3284] = {
    [sym_union_type] = STATE(3925),
    [sym__type] = STATE(3925),
    [sym_constructor_type] = STATE(3925),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1488),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3925),
    [sym_function_type] = STATE(3925),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1489),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3109),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3113),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3285] = {
    [anon_sym_EQ] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(5144),
    [anon_sym_RPAREN] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(5146),
    [anon_sym_COMMA] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
  },
  [3286] = {
    [anon_sym_COMMA] = ACTIONS(8173),
    [anon_sym_RPAREN] = ACTIONS(8173),
    [sym_comment] = ACTIONS(3),
  },
  [3287] = {
    [anon_sym_COMMA] = ACTIONS(8175),
    [anon_sym_RPAREN] = ACTIONS(8175),
    [sym_comment] = ACTIONS(3),
  },
  [3288] = {
    [anon_sym_COMMA] = ACTIONS(8177),
    [anon_sym_RPAREN] = ACTIONS(8177),
    [sym_comment] = ACTIONS(3),
  },
  [3289] = {
    [anon_sym_COMMA] = ACTIONS(8179),
    [anon_sym_RPAREN] = ACTIONS(8179),
    [sym_comment] = ACTIONS(3),
  },
  [3290] = {
    [sym_union_type] = STATE(3929),
    [sym__type] = STATE(3929),
    [sym_constructor_type] = STATE(3929),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3930),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3929),
    [sym_function_type] = STATE(3929),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3931),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(5168),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8181),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8183),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3291] = {
    [sym_formal_parameters] = STATE(3932),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3292] = {
    [anon_sym_EQ_GT] = ACTIONS(8187),
    [sym_comment] = ACTIONS(3),
  },
  [3293] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2464),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2465),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(5168),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5172),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3294] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2464),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2465),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(5168),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5172),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3295] = {
    [anon_sym_EQ_GT] = ACTIONS(8189),
    [sym_comment] = ACTIONS(3),
  },
  [3296] = {
    [sym_union_type] = STATE(3935),
    [sym__type] = STATE(3935),
    [sym_constructor_type] = STATE(3935),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2464),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3935),
    [sym_function_type] = STATE(3935),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2465),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(5168),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5172),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3297] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(1410),
    [anon_sym_COMMA] = ACTIONS(7181),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_BANG_EQ] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_as] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1426),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(7181),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_instanceof] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7181),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1426),
    [anon_sym_STAR_STAR] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_GT_GT] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(1347),
  },
  [3298] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(7192),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(8191),
    [anon_sym_COMMA] = ACTIONS(5893),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_GT_GT_GT] = ACTIONS(5893),
    [anon_sym_AMP_AMP] = ACTIONS(5893),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_BANG_EQ] = ACTIONS(7192),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(8193),
    [anon_sym_PERCENT] = ACTIONS(5893),
    [anon_sym_QMARK] = ACTIONS(5893),
    [anon_sym_as] = ACTIONS(5893),
    [anon_sym_PIPE_PIPE] = ACTIONS(5893),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_EQ_EQ] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5893),
    [anon_sym_DOT] = ACTIONS(5893),
    [anon_sym_CARET] = ACTIONS(5893),
    [anon_sym_STAR_STAR] = ACTIONS(5893),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_in] = ACTIONS(7192),
  },
  [3299] = {
    [anon_sym_EQ_GT] = ACTIONS(8195),
    [sym_comment] = ACTIONS(3),
  },
  [3300] = {
    [sym_union_type] = STATE(3937),
    [sym__type] = STATE(3937),
    [sym_constructor_type] = STATE(3937),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1528),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3937),
    [sym_function_type] = STATE(3937),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1529),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3194),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3301] = {
    [sym_union_type] = STATE(3938),
    [sym__type] = STATE(3938),
    [sym_constructor_type] = STATE(3938),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1528),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3938),
    [sym_function_type] = STATE(3938),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1529),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3194),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3302] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_BANG] = ACTIONS(7208),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(8191),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_LT_LT] = ACTIONS(6040),
    [anon_sym_STAR] = ACTIONS(7208),
    [anon_sym_GT_GT_GT] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(6040),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_BANG_EQ] = ACTIONS(7208),
    [anon_sym_LT_EQ] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [anon_sym_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_AMP] = ACTIONS(8193),
    [anon_sym_PERCENT] = ACTIONS(6040),
    [anon_sym_QMARK] = ACTIONS(6040),
    [anon_sym_as] = ACTIONS(6040),
    [anon_sym_PIPE_PIPE] = ACTIONS(6040),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_RPAREN] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_instanceof] = ACTIONS(6040),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6040),
    [anon_sym_DOT] = ACTIONS(6040),
    [anon_sym_CARET] = ACTIONS(6040),
    [anon_sym_STAR_STAR] = ACTIONS(6040),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6040),
    [anon_sym_in] = ACTIONS(7208),
  },
  [3303] = {
    [anon_sym_COMMA] = ACTIONS(8197),
    [anon_sym_RPAREN] = ACTIONS(8197),
    [sym_comment] = ACTIONS(3),
  },
  [3304] = {
    [sym__initializer] = STATE(3939),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(8197),
    [anon_sym_COMMA] = ACTIONS(8197),
    [sym_comment] = ACTIONS(3),
  },
  [3305] = {
    [anon_sym_COMMA] = ACTIONS(8199),
    [anon_sym_RPAREN] = ACTIONS(8199),
    [sym_comment] = ACTIONS(3),
  },
  [3306] = {
    [sym__initializer] = STATE(3940),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(8175),
    [anon_sym_COMMA] = ACTIONS(8175),
    [sym_comment] = ACTIONS(3),
  },
  [3307] = {
    [anon_sym_COMMA] = ACTIONS(8201),
    [anon_sym_RPAREN] = ACTIONS(8201),
    [sym_comment] = ACTIONS(3),
  },
  [3308] = {
    [anon_sym_COMMA] = ACTIONS(8203),
    [anon_sym_RPAREN] = ACTIONS(8203),
    [sym_comment] = ACTIONS(3),
  },
  [3309] = {
    [sym__initializer] = STATE(3941),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(8203),
    [anon_sym_COMMA] = ACTIONS(8203),
    [sym_comment] = ACTIONS(3),
  },
  [3310] = {
    [anon_sym_COMMA] = ACTIONS(8205),
    [anon_sym_RPAREN] = ACTIONS(8205),
    [sym_comment] = ACTIONS(3),
  },
  [3311] = {
    [anon_sym_COMMA] = ACTIONS(8207),
    [anon_sym_RPAREN] = ACTIONS(8207),
    [sym_comment] = ACTIONS(3),
  },
  [3312] = {
    [sym__initializer] = STATE(3942),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(8207),
    [anon_sym_COMMA] = ACTIONS(8207),
    [sym_comment] = ACTIONS(3),
  },
  [3313] = {
    [anon_sym_COMMA] = ACTIONS(8209),
    [anon_sym_RPAREN] = ACTIONS(8209),
    [sym_comment] = ACTIONS(3),
  },
  [3314] = {
    [anon_sym_COLON] = ACTIONS(8211),
    [anon_sym_EQ_GT] = ACTIONS(8211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8211),
  },
  [3315] = {
    [sym_statement_block] = STATE(3943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [3316] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8213),
    [anon_sym_LBRACK] = ACTIONS(8213),
    [anon_sym_BANG] = ACTIONS(8215),
    [anon_sym_SEMI] = ACTIONS(8213),
    [anon_sym_BQUOTE] = ACTIONS(8213),
    [sym__automatic_semicolon] = ACTIONS(8213),
    [anon_sym_PIPE] = ACTIONS(8215),
    [anon_sym_COMMA] = ACTIONS(8213),
    [anon_sym_LT_LT] = ACTIONS(8213),
    [anon_sym_STAR] = ACTIONS(8215),
    [anon_sym_GT_GT_GT] = ACTIONS(8213),
    [anon_sym_AMP_AMP] = ACTIONS(8213),
    [anon_sym_DASH] = ACTIONS(8215),
    [anon_sym_BANG_EQ] = ACTIONS(8215),
    [anon_sym_LT_EQ] = ACTIONS(8213),
    [anon_sym_LPAREN] = ACTIONS(8213),
    [anon_sym_GT_EQ] = ACTIONS(8213),
    [anon_sym_GT] = ACTIONS(8215),
    [anon_sym_AMP] = ACTIONS(8215),
    [anon_sym_PERCENT] = ACTIONS(8213),
    [anon_sym_QMARK] = ACTIONS(8213),
    [anon_sym_RBRACE] = ACTIONS(8213),
    [anon_sym_as] = ACTIONS(8213),
    [anon_sym_PIPE_PIPE] = ACTIONS(8213),
    [anon_sym_DASH_DASH] = ACTIONS(8213),
    [anon_sym_EQ_EQ] = ACTIONS(8215),
    [anon_sym_instanceof] = ACTIONS(8213),
    [anon_sym_LT] = ACTIONS(8215),
    [anon_sym_RPAREN] = ACTIONS(8213),
    [anon_sym_SLASH] = ACTIONS(8215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8213),
    [anon_sym_CARET] = ACTIONS(8213),
    [anon_sym_STAR_STAR] = ACTIONS(8213),
    [anon_sym_PLUS] = ACTIONS(8215),
    [anon_sym_GT_GT] = ACTIONS(8215),
    [anon_sym_PLUS_PLUS] = ACTIONS(8213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8213),
    [anon_sym_in] = ACTIONS(8215),
  },
  [3317] = {
    [anon_sym_GT] = ACTIONS(917),
    [sym_jsx_identifier] = ACTIONS(917),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_SLASH] = ACTIONS(919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(917),
  },
  [3318] = {
    [aux_sym_string_repeat2] = STATE(788),
    [sym_escape_sequence] = ACTIONS(1474),
    [aux_sym_string_token2] = ACTIONS(1474),
    [sym_comment] = ACTIONS(246),
    [anon_sym_SQUOTE] = ACTIONS(8217),
  },
  [3319] = {
    [sym_jsx_opening_element] = STATE(340),
    [aux_sym_jsx_element_repeat1] = STATE(3946),
    [sym_jsx_expression] = STATE(3946),
    [sym_jsx_self_closing_element] = STATE(3946),
    [sym_jsx_element] = STATE(3946),
    [sym_jsx_text] = ACTIONS(8219),
    [anon_sym_LT] = ACTIONS(8221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(590),
  },
  [3320] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(3948),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(3948),
    [sym_jsx_expression] = STATE(3948),
    [sym_type_arguments] = STATE(808),
    [anon_sym_COLON] = ACTIONS(1513),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_DOT] = ACTIONS(1498),
    [sym_jsx_identifier] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1515),
    [anon_sym_LT] = ACTIONS(1505),
    [anon_sym_SLASH] = ACTIONS(8223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [3321] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(3948),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(3948),
    [sym_jsx_expression] = STATE(3948),
    [anon_sym_COLON] = ACTIONS(1513),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_GT] = ACTIONS(1515),
    [sym_jsx_identifier] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(8223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [3322] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(3948),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(3948),
    [sym_jsx_expression] = STATE(3948),
    [sym_type_arguments] = STATE(808),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_DOT] = ACTIONS(1498),
    [sym_jsx_identifier] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1515),
    [anon_sym_LT] = ACTIONS(1505),
    [anon_sym_SLASH] = ACTIONS(8223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [3323] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(3948),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(3948),
    [sym_jsx_expression] = STATE(3948),
    [anon_sym_GT] = ACTIONS(1515),
    [sym_identifier] = ACTIONS(1492),
    [sym_jsx_identifier] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(8223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [3324] = {
    [aux_sym_string_repeat1] = STATE(507),
    [sym_escape_sequence] = ACTIONS(921),
    [aux_sym_string_token1] = ACTIONS(921),
    [anon_sym_DQUOTE] = ACTIONS(8217),
    [sym_comment] = ACTIONS(246),
  },
  [3325] = {
    [sym_nested_identifier] = STATE(965),
    [sym_jsx_namespace_name] = STATE(966),
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(8225),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1975),
  },
  [3326] = {
    [anon_sym_GT] = ACTIONS(1985),
    [sym_jsx_identifier] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1985),
  },
  [3327] = {
    [sym_jsx_closing_element] = STATE(3950),
    [sym_jsx_opening_element] = STATE(340),
    [aux_sym_jsx_element_repeat1] = STATE(975),
    [sym_jsx_expression] = STATE(975),
    [sym_jsx_self_closing_element] = STATE(975),
    [sym_jsx_element] = STATE(975),
    [sym_jsx_text] = ACTIONS(1993),
    [anon_sym_LT] = ACTIONS(6983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(590),
  },
  [3328] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3332),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3333),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3319),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6985),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6987),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3329] = {
    [sym_type_parameters] = STATE(3951),
    [sym_formal_parameters] = STATE(3952),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3330] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3332),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3333),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3319),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6985),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6987),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3331] = {
    [anon_sym_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(8227),
    [anon_sym_COMMA] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(8229),
    [sym_comment] = ACTIONS(3),
  },
  [3332] = {
    [sym_formal_parameters] = STATE(3955),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3333] = {
    [anon_sym_EQ_GT] = ACTIONS(8231),
    [sym_comment] = ACTIONS(3),
  },
  [3334] = {
    [anon_sym_EQ_GT] = ACTIONS(8233),
    [sym_comment] = ACTIONS(3),
  },
  [3335] = {
    [sym_union_type] = STATE(3958),
    [sym__type] = STATE(3958),
    [sym_constructor_type] = STATE(3958),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1579),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3958),
    [sym_function_type] = STATE(3958),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1580),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3319),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3336] = {
    [sym_union_type] = STATE(3959),
    [sym__type] = STATE(3959),
    [sym_constructor_type] = STATE(3959),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1579),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3959),
    [sym_function_type] = STATE(3959),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1580),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3319),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3337] = {
    [anon_sym_EQ] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(5291),
    [anon_sym_PIPE] = ACTIONS(5293),
    [anon_sym_COMMA] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
  },
  [3338] = {
    [aux_sym_export_statement_repeat1] = STATE(1512),
    [sym_decorator] = STATE(1512),
    [sym_object] = STATE(769),
    [sym_accessibility_modifier] = STATE(247),
    [sym_required_parameter] = STATE(1513),
    [sym_array] = STATE(771),
    [sym_rest_parameter] = STATE(1513),
    [sym_optional_parameter] = STATE(1513),
    [sym_this] = STATE(772),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_public] = ACTIONS(1446),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(1442),
    [anon_sym_number] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_RPAREN] = ACTIONS(8235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1446),
    [anon_sym_void] = ACTIONS(1442),
    [anon_sym_string] = ACTIONS(1442),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_any] = ACTIONS(1442),
    [anon_sym_private] = ACTIONS(1446),
    [anon_sym_boolean] = ACTIONS(1442),
    [anon_sym_async] = ACTIONS(1442),
  },
  [3339] = {
    [anon_sym_COLON] = ACTIONS(5188),
    [sym__automatic_semicolon] = ACTIONS(5188),
    [anon_sym_RBRACE] = ACTIONS(5188),
    [anon_sym_SEMI] = ACTIONS(5188),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5188),
    [anon_sym_COMMA] = ACTIONS(5188),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5188),
  },
  [3340] = {
    [aux_sym_formal_parameters_repeat1] = STATE(1515),
    [anon_sym_COMMA] = ACTIONS(8237),
    [anon_sym_RPAREN] = ACTIONS(8235),
    [sym_comment] = ACTIONS(3),
  },
  [3341] = {
    [sym_union_type] = STATE(3965),
    [sym__type] = STATE(3965),
    [sym_constructor_type] = STATE(3965),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3966),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(3965),
    [sym_function_type] = STATE(3965),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3967),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5347),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8239),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8241),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3342] = {
    [sym_formal_parameters] = STATE(3968),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3343] = {
    [anon_sym_EQ_GT] = ACTIONS(8245),
    [sym_comment] = ACTIONS(3),
  },
  [3344] = {
    [sym_union_type] = STATE(2790),
    [sym__type] = STATE(2790),
    [sym_constructor_type] = STATE(2790),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2530),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2790),
    [sym_function_type] = STATE(2790),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2531),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5347),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5353),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3345] = {
    [sym_union_type] = STATE(2791),
    [sym__type] = STATE(2791),
    [sym_constructor_type] = STATE(2791),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2530),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2791),
    [sym_function_type] = STATE(2791),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2531),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5347),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5353),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3346] = {
    [anon_sym_EQ_GT] = ACTIONS(8247),
    [sym_comment] = ACTIONS(3),
  },
  [3347] = {
    [sym_union_type] = STATE(3971),
    [sym__type] = STATE(3971),
    [sym_constructor_type] = STATE(3971),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2530),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(3971),
    [sym_function_type] = STATE(3971),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2531),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5347),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5353),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3348] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3352),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3353),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3367),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(7027),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(7029),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(7031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3349] = {
    [sym_type_parameters] = STATE(3972),
    [sym_formal_parameters] = STATE(3973),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3350] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3352),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3353),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3367),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(7027),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(7029),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(7031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3351] = {
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(8249),
    [anon_sym_PIPE] = ACTIONS(8251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5893),
  },
  [3352] = {
    [sym_formal_parameters] = STATE(3976),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3353] = {
    [anon_sym_EQ_GT] = ACTIONS(8253),
    [sym_comment] = ACTIONS(3),
  },
  [3354] = {
    [anon_sym_EQ_GT] = ACTIONS(8255),
    [sym_comment] = ACTIONS(3),
  },
  [3355] = {
    [sym_union_type] = STATE(3979),
    [sym__type] = STATE(3979),
    [sym_constructor_type] = STATE(3979),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1613),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3979),
    [sym_function_type] = STATE(3979),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1614),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3367),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3356] = {
    [sym_union_type] = STATE(3980),
    [sym__type] = STATE(3980),
    [sym_constructor_type] = STATE(3980),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1613),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(3980),
    [sym_function_type] = STATE(3980),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1614),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3367),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3357] = {
    [anon_sym_AMP] = ACTIONS(5367),
    [anon_sym_PIPE] = ACTIONS(5369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6040),
  },
  [3358] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(2585),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_RPAREN] = ACTIONS(2585),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3359] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(7192),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(8257),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_GT_GT_GT] = ACTIONS(5893),
    [anon_sym_AMP_AMP] = ACTIONS(5893),
    [anon_sym_BANG_EQ] = ACTIONS(7192),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(8259),
    [anon_sym_PERCENT] = ACTIONS(5893),
    [anon_sym_QMARK] = ACTIONS(5893),
    [anon_sym_as] = ACTIONS(5893),
    [anon_sym_PIPE_PIPE] = ACTIONS(5893),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_EQ_EQ] = ACTIONS(7192),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5893),
    [anon_sym_CARET] = ACTIONS(5893),
    [anon_sym_STAR_STAR] = ACTIONS(5893),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_in] = ACTIONS(7192),
  },
  [3360] = {
    [anon_sym_EQ_GT] = ACTIONS(8261),
    [sym_comment] = ACTIONS(3),
  },
  [3361] = {
    [sym_union_type] = STATE(3982),
    [sym__type] = STATE(3982),
    [sym_constructor_type] = STATE(3982),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1647),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3982),
    [sym_function_type] = STATE(3982),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1648),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3438),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3444),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3446),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3362] = {
    [sym_union_type] = STATE(3983),
    [sym__type] = STATE(3983),
    [sym_constructor_type] = STATE(3983),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1647),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3983),
    [sym_function_type] = STATE(3983),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1648),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3438),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3444),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3446),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3363] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_BANG] = ACTIONS(7208),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(8257),
    [anon_sym_LT_LT] = ACTIONS(6040),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_STAR] = ACTIONS(7208),
    [anon_sym_GT_GT_GT] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(6040),
    [anon_sym_BANG_EQ] = ACTIONS(7208),
    [anon_sym_LT_EQ] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [anon_sym_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_AMP] = ACTIONS(8259),
    [anon_sym_PERCENT] = ACTIONS(6040),
    [anon_sym_QMARK] = ACTIONS(6040),
    [anon_sym_as] = ACTIONS(6040),
    [anon_sym_PIPE_PIPE] = ACTIONS(6040),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_instanceof] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6040),
    [anon_sym_CARET] = ACTIONS(6040),
    [anon_sym_STAR_STAR] = ACTIONS(6040),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6040),
    [anon_sym_in] = ACTIONS(7208),
  },
  [3364] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(6447),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [anon_sym_PERCENT_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_AMP_EQ] = ACTIONS(2011),
    [anon_sym_PLUS_EQ] = ACTIONS(2011),
    [anon_sym_PIPE] = ACTIONS(6450),
    [anon_sym_LT_LT] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_GT_GT_GT] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2011),
    [anon_sym_COMMA] = ACTIONS(5891),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_RBRACK] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(6450),
    [anon_sym_CARET_EQ] = ACTIONS(2011),
    [anon_sym_STAR_EQ] = ACTIONS(2011),
    [anon_sym_PIPE_EQ] = ACTIONS(2011),
    [anon_sym_DASH_EQ] = ACTIONS(2011),
    [anon_sym_AMP] = ACTIONS(6450),
    [anon_sym_PERCENT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_LT_LT_EQ] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2011),
    [anon_sym_RBRACE] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_instanceof] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(6450),
    [anon_sym_RPAREN] = ACTIONS(2011),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2011),
    [anon_sym_SLASH_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_DOT] = ACTIONS(6453),
    [anon_sym_CARET] = ACTIONS(2013),
    [anon_sym_STAR_STAR] = ACTIONS(2013),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2013),
  },
  [3365] = {
    [sym_identifier] = ACTIONS(8263),
    [sym_comment] = ACTIONS(3),
  },
  [3366] = {
    [sym__automatic_semicolon] = ACTIONS(8265),
    [anon_sym_SEMI] = ACTIONS(8265),
    [anon_sym_from] = ACTIONS(8265),
    [sym_comment] = ACTIONS(3),
  },
  [3367] = {
    [sym__import_export_specifier] = STATE(2556),
    [sym_identifier] = ACTIONS(891),
    [anon_sym_typeof] = ACTIONS(895),
    [anon_sym_type] = ACTIONS(895),
    [sym_comment] = ACTIONS(3),
  },
  [3368] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(5236),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_LT_LT] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_GT_GT_GT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_BANG_EQ] = ACTIONS(3491),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3545),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(3491),
    [anon_sym_instanceof] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3547),
    [anon_sym_STAR_STAR] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3491),
  },
  [3369] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(5240),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(5240),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_LT_LT] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_GT_GT_GT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_BANG_EQ] = ACTIONS(3491),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3545),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(3491),
    [anon_sym_instanceof] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3547),
    [anon_sym_STAR_STAR] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3491),
  },
  [3370] = {
    [sym_new_expression] = STATE(3985),
    [sym_augmented_assignment_expression] = STATE(3985),
    [sym_unary_expression] = STATE(3985),
    [sym_update_expression] = STATE(3985),
    [sym_call_signature] = STATE(866),
    [sym_meta_property] = STATE(3985),
    [sym_regex] = STATE(3985),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3985),
    [sym_non_null_expression] = STATE(3985),
    [sym_as_expression] = STATE(3985),
    [sym_jsx_fragment] = STATE(3985),
    [sym_yield_expression] = STATE(3985),
    [sym_jsx_element] = STATE(3985),
    [sym_internal_module] = STATE(3985),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(3985),
    [sym_await_expression] = STATE(3985),
    [sym_member_expression] = STATE(868),
    [sym_string] = STATE(3985),
    [sym_this] = STATE(3985),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(869),
    [sym_anonymous_class] = STATE(3985),
    [sym_generator_function] = STATE(3985),
    [sym_call_expression] = STATE(3985),
    [sym_subscript_expression] = STATE(868),
    [sym_assignment_expression] = STATE(3985),
    [sym_ternary_expression] = STATE(3985),
    [sym_binary_expression] = STATE(3985),
    [sym_template_string] = STATE(3985),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3985),
    [sym_array] = STATE(870),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(3985),
    [sym_class] = STATE(3985),
    [anon_sym_BANG] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1605),
    [sym_false] = ACTIONS(8267),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(8267),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1617),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(8269),
    [sym_true] = ACTIONS(8267),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(8267),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1625),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
  },
  [3371] = {
    [sym_union_type] = STATE(3986),
    [sym__type] = STATE(3986),
    [sym_constructor_type] = STATE(3986),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(2577),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(3986),
    [sym_function_type] = STATE(3986),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(2578),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(5459),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(5465),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(5463),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(5467),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(5461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [3372] = {
    [sym_formal_parameters] = STATE(3987),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3373] = {
    [anon_sym_EQ_GT] = ACTIONS(8271),
    [sym_comment] = ACTIONS(3),
  },
  [3374] = {
    [sym_union_type] = STATE(2678),
    [sym__type] = STATE(2678),
    [sym_constructor_type] = STATE(2678),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(2577),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(2678),
    [sym_function_type] = STATE(2678),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(2578),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(5459),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(5465),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(5463),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(5467),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(5461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [3375] = {
    [sym_union_type] = STATE(2679),
    [sym__type] = STATE(2679),
    [sym_constructor_type] = STATE(2679),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(2577),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(2679),
    [sym_function_type] = STATE(2679),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(2578),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(5459),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(5465),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(5463),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(5467),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(5461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [3376] = {
    [anon_sym_EQ_GT] = ACTIONS(8273),
    [sym_comment] = ACTIONS(3),
  },
  [3377] = {
    [sym_union_type] = STATE(3990),
    [sym__type] = STATE(3990),
    [sym_constructor_type] = STATE(3990),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(2577),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(3990),
    [sym_function_type] = STATE(3990),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(2578),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(5459),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(5465),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(5463),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(5467),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(5461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [3378] = {
    [sym_identifier] = ACTIONS(8275),
    [sym_comment] = ACTIONS(3),
  },
  [3379] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(3485),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3485),
    [anon_sym_AMP_EQ] = ACTIONS(3485),
    [anon_sym_PLUS_EQ] = ACTIONS(3485),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_EQ] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_CARET_EQ] = ACTIONS(3485),
    [anon_sym_STAR_EQ] = ACTIONS(3485),
    [anon_sym_PIPE_EQ] = ACTIONS(3485),
    [anon_sym_DASH_EQ] = ACTIONS(3485),
    [anon_sym_EQ_GT] = ACTIONS(3489),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(3485),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3485),
    [anon_sym_GT_GT_EQ] = ACTIONS(3485),
    [anon_sym_DOT] = ACTIONS(8277),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3485),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3491),
  },
  [3380] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym_BQUOTE] = ACTIONS(1251),
    [sym__automatic_semicolon] = ACTIONS(1251),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_GT_GT_GT] = ACTIONS(1251),
    [anon_sym_EQ] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1251),
    [anon_sym_COMMA] = ACTIONS(4105),
    [anon_sym_BANG_EQ] = ACTIONS(1257),
    [anon_sym_LT_EQ] = ACTIONS(1251),
    [anon_sym_LPAREN] = ACTIONS(1251),
    [anon_sym_GT_EQ] = ACTIONS(1251),
    [anon_sym_GT] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1257),
    [anon_sym_PERCENT] = ACTIONS(1251),
    [anon_sym_QMARK] = ACTIONS(1251),
    [anon_sym_as] = ACTIONS(1251),
    [anon_sym_PIPE_PIPE] = ACTIONS(1251),
    [anon_sym_DASH_DASH] = ACTIONS(1251),
    [anon_sym_EQ_EQ] = ACTIONS(1257),
    [anon_sym_instanceof] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1257),
    [anon_sym_SLASH] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1251),
    [anon_sym_CARET] = ACTIONS(1251),
    [anon_sym_STAR_STAR] = ACTIONS(1251),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS_PLUS] = ACTIONS(1251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1251),
    [anon_sym_in] = ACTIONS(1257),
  },
  [3381] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(8279),
    [anon_sym_while] = ACTIONS(2457),
  },
  [3382] = {
    [sym_array] = STATE(3996),
    [sym_object] = STATE(3997),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(8281),
    [anon_sym_var] = ACTIONS(8283),
    [anon_sym_const] = ACTIONS(8283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_let] = ACTIONS(8283),
  },
  [3383] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(8285),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(8287),
  },
  [3384] = {
    [sym_variable_declarator] = STATE(97),
    [sym_array] = STATE(4001),
    [sym_object] = STATE(4002),
    [sym_identifier] = ACTIONS(8289),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [3385] = {
    [sym_variable_declarator] = STATE(258),
    [sym_array] = STATE(4001),
    [sym_object] = STATE(4002),
    [sym_identifier] = ACTIONS(8289),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [3386] = {
    [sym_new_expression] = STATE(59),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_yield_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_internal_module] = STATE(59),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(59),
    [sym_await_expression] = STATE(59),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4003),
    [sym_sequence_expression] = STATE(62),
    [sym_string] = STATE(59),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(4003),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(59),
    [sym_generator_function] = STATE(59),
    [sym_call_expression] = STATE(59),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(59),
    [sym_ternary_expression] = STATE(59),
    [sym_binary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(59),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [3387] = {
    [sym__initializer] = STATE(321),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(8291),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(8293),
  },
  [3388] = {
    [sym__initializer] = STATE(336),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(8295),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(8297),
  },
  [3389] = {
    [sym_identifier] = ACTIONS(8299),
    [sym_comment] = ACTIONS(3),
  },
  [3390] = {
    [sym_class_body] = STATE(2959),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(959),
  },
  [3391] = {
    [anon_sym_of] = ACTIONS(8301),
    [sym_comment] = ACTIONS(3),
  },
  [3392] = {
    [anon_sym_of] = ACTIONS(8303),
    [sym_comment] = ACTIONS(3),
  },
  [3393] = {
    [anon_sym_of] = ACTIONS(8305),
    [sym_comment] = ACTIONS(3),
  },
  [3394] = {
    [sym_new_expression] = STATE(4012),
    [sym_augmented_assignment_expression] = STATE(4012),
    [sym_unary_expression] = STATE(4012),
    [sym_update_expression] = STATE(4012),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4012),
    [sym_regex] = STATE(4012),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4012),
    [sym_non_null_expression] = STATE(4012),
    [sym_as_expression] = STATE(4012),
    [sym_jsx_fragment] = STATE(4012),
    [sym_yield_expression] = STATE(4012),
    [sym_jsx_element] = STATE(4012),
    [sym_internal_module] = STATE(4012),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4012),
    [sym_await_expression] = STATE(4012),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4012),
    [sym_this] = STATE(4012),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4012),
    [sym_generator_function] = STATE(4012),
    [sym_call_expression] = STATE(4012),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4012),
    [sym_ternary_expression] = STATE(4012),
    [sym_binary_expression] = STATE(4012),
    [sym_template_string] = STATE(4012),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4012),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4012),
    [sym_class] = STATE(4012),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(8307),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8307),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8309),
    [sym_true] = ACTIONS(8307),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8307),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3395] = {
    [sym_new_expression] = STATE(4013),
    [sym_augmented_assignment_expression] = STATE(4013),
    [sym_unary_expression] = STATE(4013),
    [sym_update_expression] = STATE(4013),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4013),
    [sym_regex] = STATE(4013),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4013),
    [sym_non_null_expression] = STATE(4013),
    [sym_as_expression] = STATE(4013),
    [sym_jsx_fragment] = STATE(4013),
    [sym_yield_expression] = STATE(4013),
    [sym_jsx_element] = STATE(4013),
    [sym_internal_module] = STATE(4013),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4013),
    [sym_await_expression] = STATE(4013),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4013),
    [sym_this] = STATE(4013),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4013),
    [sym_generator_function] = STATE(4013),
    [sym_call_expression] = STATE(4013),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4013),
    [sym_ternary_expression] = STATE(4013),
    [sym_binary_expression] = STATE(4013),
    [sym_template_string] = STATE(4013),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4013),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4013),
    [sym_class] = STATE(4013),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(8311),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8311),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8313),
    [sym_true] = ACTIONS(8311),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8311),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3396] = {
    [sym_new_expression] = STATE(4014),
    [sym_augmented_assignment_expression] = STATE(4014),
    [sym_unary_expression] = STATE(4014),
    [sym_update_expression] = STATE(4014),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4014),
    [sym_regex] = STATE(4014),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4014),
    [sym_non_null_expression] = STATE(4014),
    [sym_as_expression] = STATE(4014),
    [sym_jsx_fragment] = STATE(4014),
    [sym_yield_expression] = STATE(4014),
    [sym_jsx_element] = STATE(4014),
    [sym_internal_module] = STATE(4014),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4014),
    [sym_await_expression] = STATE(4014),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4014),
    [sym_this] = STATE(4014),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4014),
    [sym_generator_function] = STATE(4014),
    [sym_call_expression] = STATE(4014),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4014),
    [sym_ternary_expression] = STATE(4014),
    [sym_binary_expression] = STATE(4014),
    [sym_template_string] = STATE(4014),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4014),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4014),
    [sym_class] = STATE(4014),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(8315),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8315),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8317),
    [sym_true] = ACTIONS(8315),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8315),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3397] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(8319),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3398] = {
    [anon_sym_RPAREN] = ACTIONS(8319),
    [sym_comment] = ACTIONS(3),
  },
  [3399] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(8321),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3400] = {
    [sym_new_expression] = STATE(4017),
    [sym_augmented_assignment_expression] = STATE(4017),
    [sym_unary_expression] = STATE(4017),
    [sym_update_expression] = STATE(4017),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(4017),
    [sym_regex] = STATE(4017),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4017),
    [sym_non_null_expression] = STATE(4017),
    [sym_as_expression] = STATE(4017),
    [sym_jsx_fragment] = STATE(4017),
    [sym_yield_expression] = STATE(4017),
    [sym_jsx_element] = STATE(4017),
    [sym_internal_module] = STATE(4017),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4017),
    [sym_await_expression] = STATE(4017),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(4018),
    [sym_string] = STATE(4017),
    [sym_this] = STATE(4017),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(4017),
    [sym_generator_function] = STATE(4017),
    [sym_call_expression] = STATE(4017),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(4017),
    [sym_ternary_expression] = STATE(4017),
    [sym_binary_expression] = STATE(4017),
    [sym_template_string] = STATE(4017),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4017),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4017),
    [sym_class] = STATE(4017),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(8323),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8323),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8325),
    [sym_true] = ACTIONS(8323),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8323),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [3401] = {
    [sym_new_expression] = STATE(4019),
    [sym_augmented_assignment_expression] = STATE(4019),
    [sym_unary_expression] = STATE(4019),
    [sym_update_expression] = STATE(4019),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(4019),
    [sym_regex] = STATE(4019),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4019),
    [sym_non_null_expression] = STATE(4019),
    [sym_as_expression] = STATE(4019),
    [sym_jsx_fragment] = STATE(4019),
    [sym_yield_expression] = STATE(4019),
    [sym_jsx_element] = STATE(4019),
    [sym_internal_module] = STATE(4019),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4019),
    [sym_await_expression] = STATE(4019),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(4020),
    [sym_string] = STATE(4019),
    [sym_this] = STATE(4019),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(4019),
    [sym_generator_function] = STATE(4019),
    [sym_call_expression] = STATE(4019),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(4019),
    [sym_ternary_expression] = STATE(4019),
    [sym_binary_expression] = STATE(4019),
    [sym_template_string] = STATE(4019),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4019),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4019),
    [sym_class] = STATE(4019),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(8327),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8327),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8329),
    [sym_true] = ACTIONS(8327),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8327),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [3402] = {
    [sym_new_expression] = STATE(4021),
    [sym_augmented_assignment_expression] = STATE(4021),
    [sym_unary_expression] = STATE(4021),
    [sym_update_expression] = STATE(4021),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(4021),
    [sym_regex] = STATE(4021),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4021),
    [sym_non_null_expression] = STATE(4021),
    [sym_as_expression] = STATE(4021),
    [sym_jsx_fragment] = STATE(4021),
    [sym_yield_expression] = STATE(4021),
    [sym_jsx_element] = STATE(4021),
    [sym_internal_module] = STATE(4021),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4021),
    [sym_await_expression] = STATE(4021),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(4022),
    [sym_string] = STATE(4021),
    [sym_this] = STATE(4021),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(4021),
    [sym_generator_function] = STATE(4021),
    [sym_call_expression] = STATE(4021),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(4021),
    [sym_ternary_expression] = STATE(4021),
    [sym_binary_expression] = STATE(4021),
    [sym_template_string] = STATE(4021),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4021),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4021),
    [sym_class] = STATE(4021),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(8331),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8331),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8333),
    [sym_true] = ACTIONS(8331),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8331),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [3403] = {
    [sym_type_alias_declaration] = STATE(3041),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3041),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3041),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3041),
    [sym_return_statement] = STATE(3041),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3041),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3041),
    [sym_switch_statement] = STATE(3041),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3041),
    [sym_throw_statement] = STATE(3041),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3041),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3041),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(3041),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3041),
    [sym_abstract_class] = STATE(3041),
    [sym_interface_declaration] = STATE(3041),
    [sym_statement_block] = STATE(3041),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3041),
    [sym_debugger_statement] = STATE(3041),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3041),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3041),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3041),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3041),
    [sym_empty_statement] = STATE(3041),
    [sym_import_alias] = STATE(3041),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3041),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3041),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3041),
    [sym_break_statement] = STATE(3041),
    [sym_labeled_statement] = STATE(3041),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3041),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [3404] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(8335),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3405] = {
    [anon_sym_RPAREN] = ACTIONS(8335),
    [sym_comment] = ACTIONS(3),
  },
  [3406] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(8337),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3407] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(8339),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3408] = {
    [anon_sym_RPAREN] = ACTIONS(8339),
    [sym_comment] = ACTIONS(3),
  },
  [3409] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(8341),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3410] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(8343),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3411] = {
    [anon_sym_RPAREN] = ACTIONS(8343),
    [sym_comment] = ACTIONS(3),
  },
  [3412] = {
    [sym_union_type] = STATE(4033),
    [sym__type] = STATE(4033),
    [sym_constructor_type] = STATE(4033),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4033),
    [sym_function_type] = STATE(4033),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4035),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8345),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8349),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8351),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3413] = {
    [sym_statement_block] = STATE(3049),
    [sym__automatic_semicolon] = ACTIONS(5244),
    [anon_sym_SEMI] = ACTIONS(5244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [3414] = {
    [sym_statement_block] = STATE(3053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [3415] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8355),
    [sym_identifier] = ACTIONS(8357),
    [sym__automatic_semicolon] = ACTIONS(8355),
    [anon_sym_BQUOTE] = ACTIONS(8355),
    [anon_sym_debugger] = ACTIONS(8357),
    [ts_builtin_sym_end] = ACTIONS(8355),
    [anon_sym_symbol] = ACTIONS(8357),
    [anon_sym_AT] = ACTIONS(8355),
    [anon_sym_PIPE] = ACTIONS(8357),
    [anon_sym_COMMA] = ACTIONS(8355),
    [anon_sym_DASH] = ACTIONS(8357),
    [anon_sym_STAR] = ACTIONS(8357),
    [anon_sym_GT_GT_GT] = ACTIONS(8355),
    [anon_sym_void] = ACTIONS(8357),
    [anon_sym_break] = ACTIONS(8357),
    [anon_sym_BANG_EQ] = ACTIONS(8357),
    [anon_sym_const] = ACTIONS(8357),
    [anon_sym_GT_EQ] = ACTIONS(8355),
    [sym_super] = ACTIONS(8357),
    [anon_sym_return] = ACTIONS(8357),
    [anon_sym_private] = ACTIONS(8357),
    [anon_sym_get] = ACTIONS(8357),
    [anon_sym_RBRACE] = ACTIONS(8355),
    [anon_sym_PERCENT] = ACTIONS(8355),
    [anon_sym_interface] = ACTIONS(8357),
    [anon_sym_default] = ACTIONS(8357),
    [anon_sym_as] = ACTIONS(8357),
    [anon_sym_delete] = ACTIONS(8357),
    [anon_sym_continue] = ACTIONS(8357),
    [anon_sym_DASH_DASH] = ACTIONS(8355),
    [anon_sym_if] = ACTIONS(8357),
    [anon_sym_instanceof] = ACTIONS(8357),
    [anon_sym_this] = ACTIONS(8357),
    [anon_sym_yield] = ACTIONS(8357),
    [sym_true] = ACTIONS(8357),
    [anon_sym_throw] = ACTIONS(8357),
    [anon_sym_enum] = ACTIONS(8357),
    [anon_sym_protected] = ACTIONS(8357),
    [anon_sym_abstract] = ACTIONS(8357),
    [anon_sym_DOT] = ACTIONS(8357),
    [anon_sym_set] = ACTIONS(8357),
    [anon_sym_type] = ACTIONS(8357),
    [anon_sym_STAR_STAR] = ACTIONS(8355),
    [anon_sym_import] = ACTIONS(8357),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8355),
    [anon_sym_namespace] = ACTIONS(8357),
    [anon_sym_PLUS_PLUS] = ACTIONS(8355),
    [anon_sym_await] = ACTIONS(8357),
    [anon_sym_DQUOTE] = ACTIONS(8355),
    [anon_sym_else] = ACTIONS(8357),
    [anon_sym_BANG] = ACTIONS(8357),
    [anon_sym_for] = ACTIONS(8357),
    [anon_sym_LBRACK] = ACTIONS(8355),
    [sym_false] = ACTIONS(8357),
    [anon_sym_SEMI] = ACTIONS(8355),
    [anon_sym_case] = ACTIONS(8357),
    [anon_sym_module] = ACTIONS(8357),
    [anon_sym_number] = ACTIONS(8357),
    [anon_sym_class] = ACTIONS(8357),
    [anon_sym_declare] = ACTIONS(8357),
    [anon_sym_typeof] = ACTIONS(8357),
    [anon_sym_LT_LT] = ACTIONS(8355),
    [anon_sym_LBRACE] = ACTIONS(8355),
    [anon_sym_AMP_AMP] = ACTIONS(8355),
    [anon_sym_switch] = ACTIONS(8357),
    [anon_sym_LT_EQ] = ACTIONS(8355),
    [anon_sym_LPAREN] = ACTIONS(8355),
    [sym_null] = ACTIONS(8357),
    [anon_sym_GT] = ACTIONS(8357),
    [anon_sym_any] = ACTIONS(8357),
    [anon_sym_boolean] = ACTIONS(8357),
    [anon_sym_async] = ACTIONS(8357),
    [anon_sym_public] = ACTIONS(8357),
    [anon_sym_AMP] = ACTIONS(8357),
    [anon_sym_var] = ACTIONS(8357),
    [anon_sym_QMARK] = ACTIONS(8355),
    [anon_sym_PIPE_PIPE] = ACTIONS(8355),
    [anon_sym_while] = ACTIONS(8357),
    [anon_sym_SQUOTE] = ACTIONS(8355),
    [anon_sym_try] = ACTIONS(8357),
    [anon_sym_EQ_EQ] = ACTIONS(8357),
    [anon_sym_RPAREN] = ACTIONS(8355),
    [anon_sym_LT] = ACTIONS(8357),
    [sym_number] = ACTIONS(8355),
    [anon_sym_SLASH] = ACTIONS(8357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8357),
    [anon_sym_function] = ACTIONS(8357),
    [sym_undefined] = ACTIONS(8357),
    [anon_sym_new] = ACTIONS(8357),
    [anon_sym_CARET] = ACTIONS(8355),
    [anon_sym_let] = ACTIONS(8357),
    [anon_sym_PLUS] = ACTIONS(8357),
    [anon_sym_export] = ACTIONS(8357),
    [anon_sym_GT_GT] = ACTIONS(8357),
    [anon_sym_do] = ACTIONS(8357),
    [anon_sym_TILDE] = ACTIONS(8355),
    [anon_sym_with] = ACTIONS(8357),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8355),
    [anon_sym_in] = ACTIONS(8357),
  },
  [3416] = {
    [sym_formal_parameters] = STATE(4036),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3417] = {
    [anon_sym_EQ_GT] = ACTIONS(8359),
    [sym_comment] = ACTIONS(3),
  },
  [3418] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2631),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2632),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1839),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5549),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3419] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2631),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2632),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1839),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5549),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3420] = {
    [anon_sym_EQ_GT] = ACTIONS(8361),
    [sym_comment] = ACTIONS(3),
  },
  [3421] = {
    [sym_union_type] = STATE(4039),
    [sym__type] = STATE(4039),
    [sym_constructor_type] = STATE(4039),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2631),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4039),
    [sym_function_type] = STATE(4039),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2632),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1839),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5549),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3422] = {
    [sym_union_type] = STATE(4040),
    [sym__type] = STATE(4040),
    [sym_constructor_type] = STATE(4040),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(902),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4040),
    [sym_function_type] = STATE(4040),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(903),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1839),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(1845),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(1847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3423] = {
    [anon_sym_EQ_GT] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_PIPE] = ACTIONS(3615),
    [sym_comment] = ACTIONS(3),
  },
  [3424] = {
    [anon_sym_EQ_GT] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_PIPE] = ACTIONS(3615),
    [sym_comment] = ACTIONS(3),
  },
  [3425] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5236),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3630),
  },
  [3426] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5240),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3630),
  },
  [3427] = {
    [sym_new_expression] = STATE(4041),
    [sym_augmented_assignment_expression] = STATE(4041),
    [sym_unary_expression] = STATE(4041),
    [sym_update_expression] = STATE(4041),
    [sym_call_signature] = STATE(921),
    [sym_meta_property] = STATE(4041),
    [sym_regex] = STATE(4041),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4041),
    [sym_non_null_expression] = STATE(4041),
    [sym_as_expression] = STATE(4041),
    [sym_jsx_fragment] = STATE(4041),
    [sym_yield_expression] = STATE(4041),
    [sym_jsx_element] = STATE(4041),
    [sym_internal_module] = STATE(4041),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4041),
    [sym_await_expression] = STATE(4041),
    [sym_member_expression] = STATE(923),
    [sym_string] = STATE(4041),
    [sym_this] = STATE(4041),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(924),
    [sym_anonymous_class] = STATE(4041),
    [sym_generator_function] = STATE(4041),
    [sym_call_expression] = STATE(4041),
    [sym_subscript_expression] = STATE(923),
    [sym_assignment_expression] = STATE(4041),
    [sym_ternary_expression] = STATE(4041),
    [sym_binary_expression] = STATE(4041),
    [sym_template_string] = STATE(4041),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4041),
    [sym_array] = STATE(925),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4041),
    [sym_class] = STATE(4041),
    [anon_sym_BANG] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [sym_false] = ACTIONS(8363),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1883),
    [anon_sym_symbol] = ACTIONS(1883),
    [anon_sym_number] = ACTIONS(1883),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(1883),
    [anon_sym_typeof] = ACTIONS(1885),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8363),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1883),
    [anon_sym_private] = ACTIONS(1883),
    [anon_sym_boolean] = ACTIONS(1883),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_public] = ACTIONS(1883),
    [anon_sym_get] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8365),
    [sym_true] = ACTIONS(8363),
    [anon_sym_yield] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(1883),
    [anon_sym_string] = ACTIONS(1883),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8363),
    [anon_sym_set] = ACTIONS(1883),
    [anon_sym_type] = ACTIONS(1883),
    [anon_sym_new] = ACTIONS(1899),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_export] = ACTIONS(1883),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1887),
    [anon_sym_await] = ACTIONS(1903),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(1877),
    [anon_sym_PLUS_PLUS] = ACTIONS(1893),
  },
  [3428] = {
    [sym_union_type] = STATE(4042),
    [sym__type] = STATE(4042),
    [sym_constructor_type] = STATE(4042),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2655),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4042),
    [sym_function_type] = STATE(4042),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2656),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(5608),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(5614),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(5612),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(5616),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(5610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3429] = {
    [sym_formal_parameters] = STATE(4043),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3430] = {
    [anon_sym_EQ_GT] = ACTIONS(8367),
    [sym_comment] = ACTIONS(3),
  },
  [3431] = {
    [sym_union_type] = STATE(3067),
    [sym__type] = STATE(3067),
    [sym_constructor_type] = STATE(3067),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2655),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3067),
    [sym_function_type] = STATE(3067),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2656),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(5608),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(5614),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(5612),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(5616),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(5610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3432] = {
    [sym_union_type] = STATE(3068),
    [sym__type] = STATE(3068),
    [sym_constructor_type] = STATE(3068),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2655),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3068),
    [sym_function_type] = STATE(3068),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2656),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(5608),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(5614),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(5612),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(5616),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(5610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3433] = {
    [anon_sym_EQ_GT] = ACTIONS(8369),
    [sym_comment] = ACTIONS(3),
  },
  [3434] = {
    [sym_union_type] = STATE(4046),
    [sym__type] = STATE(4046),
    [sym_constructor_type] = STATE(4046),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2655),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4046),
    [sym_function_type] = STATE(4046),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2656),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(5608),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(5614),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(5612),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(5616),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(5610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3435] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(3624),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3624),
    [anon_sym_AMP_EQ] = ACTIONS(3624),
    [anon_sym_PLUS_EQ] = ACTIONS(3624),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_EQ] = ACTIONS(3626),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_CARET_EQ] = ACTIONS(3624),
    [anon_sym_STAR_EQ] = ACTIONS(3624),
    [anon_sym_PIPE_EQ] = ACTIONS(3624),
    [anon_sym_DASH_EQ] = ACTIONS(3624),
    [anon_sym_EQ_GT] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(3624),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(3624),
    [anon_sym_GT_GT_EQ] = ACTIONS(3624),
    [anon_sym_DOT] = ACTIONS(7050),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3624),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3630),
  },
  [3436] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7419),
    [anon_sym_LBRACK] = ACTIONS(7419),
    [anon_sym_BANG] = ACTIONS(7417),
    [anon_sym_SEMI] = ACTIONS(7419),
    [anon_sym_BQUOTE] = ACTIONS(7419),
    [sym__automatic_semicolon] = ACTIONS(7419),
    [anon_sym_PIPE] = ACTIONS(7417),
    [anon_sym_COMMA] = ACTIONS(7419),
    [anon_sym_LT_LT] = ACTIONS(7419),
    [anon_sym_STAR] = ACTIONS(7417),
    [anon_sym_GT_GT_GT] = ACTIONS(7419),
    [anon_sym_AMP_AMP] = ACTIONS(7419),
    [anon_sym_DASH] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_LT_EQ] = ACTIONS(7419),
    [anon_sym_LPAREN] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7419),
    [anon_sym_GT] = ACTIONS(7417),
    [anon_sym_AMP] = ACTIONS(7417),
    [anon_sym_PERCENT] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7419),
    [anon_sym_RBRACE] = ACTIONS(7419),
    [anon_sym_as] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7419),
    [anon_sym_DASH_DASH] = ACTIONS(7419),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_instanceof] = ACTIONS(7419),
    [anon_sym_LT] = ACTIONS(7417),
    [anon_sym_RPAREN] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7419),
    [anon_sym_CARET] = ACTIONS(7419),
    [anon_sym_STAR_STAR] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_GT_GT] = ACTIONS(7417),
    [anon_sym_PLUS_PLUS] = ACTIONS(7419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7419),
    [anon_sym_in] = ACTIONS(7417),
  },
  [3437] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4229),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_BANG] = ACTIONS(4231),
    [anon_sym_SEMI] = ACTIONS(4229),
    [anon_sym_BQUOTE] = ACTIONS(4229),
    [sym__automatic_semicolon] = ACTIONS(4229),
    [anon_sym_PIPE] = ACTIONS(4231),
    [anon_sym_COMMA] = ACTIONS(4229),
    [anon_sym_LT_LT] = ACTIONS(4229),
    [anon_sym_STAR] = ACTIONS(4231),
    [anon_sym_GT_GT_GT] = ACTIONS(4229),
    [anon_sym_AMP_AMP] = ACTIONS(4229),
    [anon_sym_DASH] = ACTIONS(4231),
    [anon_sym_BANG_EQ] = ACTIONS(4231),
    [anon_sym_LT_EQ] = ACTIONS(4229),
    [anon_sym_LPAREN] = ACTIONS(4229),
    [anon_sym_GT_EQ] = ACTIONS(4229),
    [anon_sym_GT] = ACTIONS(4231),
    [anon_sym_AMP] = ACTIONS(4231),
    [anon_sym_PERCENT] = ACTIONS(4229),
    [anon_sym_QMARK] = ACTIONS(4229),
    [anon_sym_RBRACE] = ACTIONS(4229),
    [anon_sym_as] = ACTIONS(4229),
    [anon_sym_PIPE_PIPE] = ACTIONS(4229),
    [anon_sym_DASH_DASH] = ACTIONS(4229),
    [anon_sym_EQ_EQ] = ACTIONS(4231),
    [anon_sym_instanceof] = ACTIONS(4229),
    [anon_sym_LT] = ACTIONS(4231),
    [anon_sym_RPAREN] = ACTIONS(4229),
    [anon_sym_SLASH] = ACTIONS(4231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4229),
    [anon_sym_CARET] = ACTIONS(4229),
    [anon_sym_STAR_STAR] = ACTIONS(4229),
    [anon_sym_PLUS] = ACTIONS(4231),
    [anon_sym_GT_GT] = ACTIONS(4231),
    [anon_sym_PLUS_PLUS] = ACTIONS(4229),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4229),
    [anon_sym_in] = ACTIONS(4231),
  },
  [3438] = {
    [sym_union_type] = STATE(2014),
    [sym__type] = STATE(2014),
    [sym_constructor_type] = STATE(2014),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2014),
    [sym_function_type] = STATE(2014),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(8371),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_boolean] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_this] = ACTIONS(765),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [3439] = {
    [aux_sym_implements_clause_repeat1] = STATE(2016),
    [anon_sym_COMMA] = ACTIONS(8373),
    [anon_sym_GT] = ACTIONS(8371),
    [sym_comment] = ACTIONS(3),
  },
  [3440] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(2866),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(2866),
    [sym_call_signature] = STATE(2866),
    [sym_export_statement] = STATE(2866),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(2866),
    [sym_index_signature] = STATE(2866),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_RBRACE] = ACTIONS(8375),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8375),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [3441] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7431),
    [anon_sym_LBRACK] = ACTIONS(7431),
    [anon_sym_BANG] = ACTIONS(7429),
    [anon_sym_SEMI] = ACTIONS(7431),
    [anon_sym_BQUOTE] = ACTIONS(7431),
    [sym__automatic_semicolon] = ACTIONS(7431),
    [anon_sym_PIPE] = ACTIONS(7429),
    [anon_sym_COMMA] = ACTIONS(7431),
    [anon_sym_LT_LT] = ACTIONS(7431),
    [anon_sym_STAR] = ACTIONS(7429),
    [anon_sym_GT_GT_GT] = ACTIONS(7431),
    [anon_sym_AMP_AMP] = ACTIONS(7431),
    [anon_sym_DASH] = ACTIONS(7429),
    [anon_sym_BANG_EQ] = ACTIONS(7429),
    [anon_sym_LT_EQ] = ACTIONS(7431),
    [anon_sym_LPAREN] = ACTIONS(7431),
    [anon_sym_GT_EQ] = ACTIONS(7431),
    [anon_sym_GT] = ACTIONS(7429),
    [anon_sym_AMP] = ACTIONS(7429),
    [anon_sym_PERCENT] = ACTIONS(7431),
    [anon_sym_QMARK] = ACTIONS(7431),
    [anon_sym_RBRACE] = ACTIONS(7431),
    [anon_sym_as] = ACTIONS(7431),
    [anon_sym_PIPE_PIPE] = ACTIONS(7431),
    [anon_sym_DASH_DASH] = ACTIONS(7431),
    [anon_sym_EQ_EQ] = ACTIONS(7429),
    [anon_sym_instanceof] = ACTIONS(7431),
    [anon_sym_LT] = ACTIONS(7429),
    [anon_sym_RPAREN] = ACTIONS(7431),
    [anon_sym_SLASH] = ACTIONS(7429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7431),
    [anon_sym_CARET] = ACTIONS(7431),
    [anon_sym_STAR_STAR] = ACTIONS(7431),
    [anon_sym_PLUS] = ACTIONS(7429),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7431),
    [anon_sym_GT_GT] = ACTIONS(7429),
    [anon_sym_PLUS_PLUS] = ACTIONS(7431),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7431),
    [anon_sym_in] = ACTIONS(7429),
  },
  [3442] = {
    [aux_sym_object_type_repeat1] = STATE(2867),
    [sym__automatic_semicolon] = ACTIONS(8377),
    [anon_sym_RBRACE] = ACTIONS(8375),
    [anon_sym_SEMI] = ACTIONS(8377),
    [anon_sym_COMMA] = ACTIONS(8377),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8375),
    [sym_comment] = ACTIONS(3),
  },
  [3443] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7506),
    [anon_sym_LBRACK] = ACTIONS(7506),
    [anon_sym_BANG] = ACTIONS(7504),
    [anon_sym_SEMI] = ACTIONS(7506),
    [anon_sym_BQUOTE] = ACTIONS(7506),
    [sym__automatic_semicolon] = ACTIONS(7506),
    [anon_sym_PIPE] = ACTIONS(7504),
    [anon_sym_COMMA] = ACTIONS(7506),
    [anon_sym_LT_LT] = ACTIONS(7506),
    [anon_sym_STAR] = ACTIONS(7504),
    [anon_sym_GT_GT_GT] = ACTIONS(7506),
    [anon_sym_AMP_AMP] = ACTIONS(7506),
    [anon_sym_DASH] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_LT_EQ] = ACTIONS(7506),
    [anon_sym_LPAREN] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7506),
    [anon_sym_GT] = ACTIONS(7504),
    [anon_sym_AMP] = ACTIONS(7504),
    [anon_sym_PERCENT] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7506),
    [anon_sym_RBRACE] = ACTIONS(7506),
    [anon_sym_as] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7506),
    [anon_sym_DASH_DASH] = ACTIONS(7506),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_instanceof] = ACTIONS(7506),
    [anon_sym_LT] = ACTIONS(7504),
    [anon_sym_RPAREN] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7506),
    [anon_sym_CARET] = ACTIONS(7506),
    [anon_sym_STAR_STAR] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_GT_GT] = ACTIONS(7504),
    [anon_sym_PLUS_PLUS] = ACTIONS(7506),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7506),
    [anon_sym_in] = ACTIONS(7504),
  },
  [3444] = {
    [sym_union_type] = STATE(4051),
    [sym__type] = STATE(4051),
    [sym_constructor_type] = STATE(4051),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(943),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(4051),
    [sym_function_type] = STATE(4051),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(947),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(1905),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(1931),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1929),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(1937),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [3445] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_BANG] = ACTIONS(8379),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [sym__automatic_semicolon] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(7194),
    [anon_sym_COMMA] = ACTIONS(7511),
    [anon_sym_LT_LT] = ACTIONS(7511),
    [anon_sym_STAR] = ACTIONS(8379),
    [anon_sym_GT_GT_GT] = ACTIONS(7511),
    [anon_sym_AMP_AMP] = ACTIONS(7511),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_BANG_EQ] = ACTIONS(8379),
    [anon_sym_LT_EQ] = ACTIONS(7511),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [anon_sym_GT_EQ] = ACTIONS(7511),
    [anon_sym_GT] = ACTIONS(8379),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_PERCENT] = ACTIONS(7511),
    [anon_sym_QMARK] = ACTIONS(7511),
    [anon_sym_as] = ACTIONS(7511),
    [anon_sym_PIPE_PIPE] = ACTIONS(7511),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_EQ_EQ] = ACTIONS(8379),
    [anon_sym_instanceof] = ACTIONS(7511),
    [anon_sym_LT] = ACTIONS(8379),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7511),
    [anon_sym_CARET] = ACTIONS(7511),
    [anon_sym_STAR_STAR] = ACTIONS(7511),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_GT_GT] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7511),
    [anon_sym_in] = ACTIONS(8379),
  },
  [3446] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7527),
    [anon_sym_LBRACK] = ACTIONS(7527),
    [anon_sym_BANG] = ACTIONS(7525),
    [anon_sym_SEMI] = ACTIONS(7527),
    [anon_sym_BQUOTE] = ACTIONS(7527),
    [sym__automatic_semicolon] = ACTIONS(7527),
    [anon_sym_PIPE] = ACTIONS(7525),
    [anon_sym_COMMA] = ACTIONS(7527),
    [anon_sym_LT_LT] = ACTIONS(7527),
    [anon_sym_STAR] = ACTIONS(7525),
    [anon_sym_GT_GT_GT] = ACTIONS(7527),
    [anon_sym_AMP_AMP] = ACTIONS(7527),
    [anon_sym_DASH] = ACTIONS(7525),
    [anon_sym_BANG_EQ] = ACTIONS(7525),
    [anon_sym_LT_EQ] = ACTIONS(7527),
    [anon_sym_LPAREN] = ACTIONS(7527),
    [anon_sym_GT_EQ] = ACTIONS(7527),
    [anon_sym_GT] = ACTIONS(7525),
    [anon_sym_AMP] = ACTIONS(7525),
    [anon_sym_PERCENT] = ACTIONS(7527),
    [anon_sym_QMARK] = ACTIONS(7527),
    [anon_sym_RBRACE] = ACTIONS(7527),
    [anon_sym_as] = ACTIONS(7527),
    [anon_sym_PIPE_PIPE] = ACTIONS(7527),
    [anon_sym_DASH_DASH] = ACTIONS(7527),
    [anon_sym_EQ_EQ] = ACTIONS(7525),
    [anon_sym_instanceof] = ACTIONS(7527),
    [anon_sym_LT] = ACTIONS(7525),
    [anon_sym_RPAREN] = ACTIONS(7527),
    [anon_sym_SLASH] = ACTIONS(7525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7527),
    [anon_sym_CARET] = ACTIONS(7527),
    [anon_sym_STAR_STAR] = ACTIONS(7527),
    [anon_sym_PLUS] = ACTIONS(7525),
    [anon_sym_GT_GT] = ACTIONS(7525),
    [anon_sym_PLUS_PLUS] = ACTIONS(7527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7527),
    [anon_sym_in] = ACTIONS(7525),
  },
  [3447] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_BANG] = ACTIONS(8381),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [sym__automatic_semicolon] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(7194),
    [anon_sym_COMMA] = ACTIONS(7529),
    [anon_sym_LT_LT] = ACTIONS(7529),
    [anon_sym_STAR] = ACTIONS(8381),
    [anon_sym_GT_GT_GT] = ACTIONS(7529),
    [anon_sym_AMP_AMP] = ACTIONS(7529),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_BANG_EQ] = ACTIONS(8381),
    [anon_sym_LT_EQ] = ACTIONS(7529),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [anon_sym_GT_EQ] = ACTIONS(7529),
    [anon_sym_GT] = ACTIONS(8381),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_PERCENT] = ACTIONS(7529),
    [anon_sym_QMARK] = ACTIONS(7529),
    [anon_sym_as] = ACTIONS(7529),
    [anon_sym_PIPE_PIPE] = ACTIONS(7529),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_EQ_EQ] = ACTIONS(8381),
    [anon_sym_instanceof] = ACTIONS(7529),
    [anon_sym_LT] = ACTIONS(8381),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7529),
    [anon_sym_CARET] = ACTIONS(7529),
    [anon_sym_STAR_STAR] = ACTIONS(7529),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_GT_GT] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7529),
    [anon_sym_in] = ACTIONS(8381),
  },
  [3448] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(6447),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [anon_sym_PERCENT_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_AMP_EQ] = ACTIONS(2011),
    [anon_sym_PLUS_EQ] = ACTIONS(2011),
    [anon_sym_PIPE] = ACTIONS(6450),
    [anon_sym_COMMA] = ACTIONS(6447),
    [anon_sym_LT_LT] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_GT_GT_GT] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_RBRACK] = ACTIONS(6447),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_CARET_EQ] = ACTIONS(2011),
    [anon_sym_STAR_EQ] = ACTIONS(2011),
    [anon_sym_PIPE_EQ] = ACTIONS(2011),
    [anon_sym_DASH_EQ] = ACTIONS(2011),
    [anon_sym_AMP] = ACTIONS(6450),
    [anon_sym_PERCENT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_LT_LT_EQ] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_instanceof] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(6450),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_DOT] = ACTIONS(6453),
    [anon_sym_CARET] = ACTIONS(2013),
    [anon_sym_STAR_STAR] = ACTIONS(2013),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2013),
  },
  [3449] = {
    [sym_identifier] = ACTIONS(8383),
    [sym_comment] = ACTIONS(3),
  },
  [3450] = {
    [sym_type_annotation] = STATE(892),
    [anon_sym_EQ_GT] = ACTIONS(8385),
    [anon_sym_COLON] = ACTIONS(550),
    [sym_comment] = ACTIONS(3),
  },
  [3451] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(6453),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_SEMI] = ACTIONS(2011),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [sym__automatic_semicolon] = ACTIONS(2011),
    [anon_sym_PERCENT_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_AMP_EQ] = ACTIONS(2011),
    [anon_sym_PLUS_EQ] = ACTIONS(2011),
    [anon_sym_PIPE] = ACTIONS(8388),
    [anon_sym_COMMA] = ACTIONS(6453),
    [anon_sym_LT_LT] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_GT_GT_GT] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(8388),
    [anon_sym_CARET_EQ] = ACTIONS(2011),
    [anon_sym_STAR_EQ] = ACTIONS(2011),
    [anon_sym_PIPE_EQ] = ACTIONS(2011),
    [anon_sym_DASH_EQ] = ACTIONS(2011),
    [anon_sym_AMP] = ACTIONS(8388),
    [anon_sym_PERCENT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_LT_LT_EQ] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2011),
    [anon_sym_RBRACE] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_instanceof] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_RPAREN] = ACTIONS(2011),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_DOT] = ACTIONS(6453),
    [anon_sym_CARET] = ACTIONS(2013),
    [anon_sym_STAR_STAR] = ACTIONS(2013),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2013),
  },
  [3452] = {
    [anon_sym_EQ] = ACTIONS(2633),
    [anon_sym_RBRACE] = ACTIONS(5088),
    [anon_sym_COLON] = ACTIONS(5088),
    [anon_sym_SEMI] = ACTIONS(5088),
    [anon_sym_QMARK] = ACTIONS(5088),
    [anon_sym_LPAREN] = ACTIONS(5088),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5088),
    [sym__automatic_semicolon] = ACTIONS(5088),
    [anon_sym_LT] = ACTIONS(5088),
    [anon_sym_COMMA] = ACTIONS(5088),
    [sym_comment] = ACTIONS(3),
  },
  [3453] = {
    [sym_type_parameters] = STATE(2715),
    [sym_formal_parameters] = STATE(2716),
    [sym_call_signature] = STATE(4053),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3454] = {
    [sym_statement_block] = STATE(2384),
    [sym__automatic_semicolon] = ACTIONS(6576),
    [anon_sym_RBRACE] = ACTIONS(6576),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(6576),
    [anon_sym_COMMA] = ACTIONS(6576),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [3455] = {
    [sym_type_parameters] = STATE(2715),
    [sym_formal_parameters] = STATE(2716),
    [sym_call_signature] = STATE(4053),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(8391),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [3456] = {
    [sym_string] = STATE(4055),
    [sym__property_name] = STATE(4055),
    [sym_computed_property_name] = STATE(4055),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(8393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [3457] = {
    [sym_string] = STATE(4055),
    [sym__property_name] = STATE(4055),
    [sym_computed_property_name] = STATE(4055),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(8393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [3458] = {
    [sym_string] = STATE(4055),
    [sym__property_name] = STATE(4055),
    [sym_computed_property_name] = STATE(4055),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(8395),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(8397),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(8393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(8397),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [3459] = {
    [sym_type_parameters] = STATE(2715),
    [sym_type_annotation] = STATE(3568),
    [sym_formal_parameters] = STATE(2716),
    [sym_call_signature] = STATE(4053),
    [sym__automatic_semicolon] = ACTIONS(7443),
    [anon_sym_RBRACE] = ACTIONS(7443),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(7443),
    [anon_sym_QMARK] = ACTIONS(8399),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7443),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(7443),
    [sym_comment] = ACTIONS(3),
  },
  [3460] = {
    [sym_string] = STATE(4055),
    [sym__property_name] = STATE(4055),
    [sym_computed_property_name] = STATE(4055),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(8393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [3461] = {
    [sym_type_parameters] = STATE(2715),
    [sym_type_annotation] = STATE(3568),
    [sym_formal_parameters] = STATE(2716),
    [sym_call_signature] = STATE(4053),
    [sym__automatic_semicolon] = ACTIONS(7443),
    [anon_sym_RBRACE] = ACTIONS(7443),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(7443),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7443),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(7443),
    [sym_comment] = ACTIONS(3),
  },
  [3462] = {
    [sym__initializer] = STATE(522),
    [sym_type_arguments] = STATE(1885),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(8401),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(2204),
    [sym__automatic_semicolon] = ACTIONS(2204),
    [anon_sym_PERCENT_EQ] = ACTIONS(2015),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2015),
    [anon_sym_AMP_EQ] = ACTIONS(2015),
    [anon_sym_PLUS_EQ] = ACTIONS(2015),
    [anon_sym_PIPE] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(7477),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(2017),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2015),
    [anon_sym_STAR_EQ] = ACTIONS(2015),
    [anon_sym_PIPE_EQ] = ACTIONS(2015),
    [anon_sym_DASH_EQ] = ACTIONS(2015),
    [anon_sym_EQ_GT] = ACTIONS(2019),
    [anon_sym_RBRACE] = ACTIONS(3741),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(8405),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2015),
    [anon_sym_GT_GT_EQ] = ACTIONS(2015),
    [anon_sym_DOT] = ACTIONS(8408),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2204),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2015),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2021),
  },
  [3463] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3749),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(2212),
    [sym__automatic_semicolon] = ACTIONS(2212),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_COMMA] = ACTIONS(3749),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(3749),
    [anon_sym_AMP] = ACTIONS(3752),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2212),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [3464] = {
    [sym_new_expression] = STATE(394),
    [sym_constructor_type] = STATE(1891),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(394),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(394),
    [sym_type_parameters] = STATE(1791),
    [sym_array_type] = STATE(436),
    [sym_yield_expression] = STATE(394),
    [sym_as_expression] = STATE(394),
    [sym_jsx_fragment] = STATE(394),
    [sym_internal_module] = STATE(394),
    [sym_arrow_function] = STATE(394),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(162),
    [sym_literal_type] = STATE(436),
    [sym_spread_element] = STATE(395),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(1788),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(165),
    [aux_sym_array_repeat1] = STATE(396),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(394),
    [sym_subscript_expression] = STATE(162),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(394),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(394),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(1792),
    [sym_function_type] = STATE(1891),
    [sym__type] = STATE(1891),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(394),
    [sym_call_signature] = STATE(159),
    [sym_meta_property] = STATE(394),
    [sym__expression] = STATE(394),
    [sym_non_null_expression] = STATE(394),
    [sym_jsx_element] = STATE(394),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_await_expression] = STATE(394),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_this] = STATE(394),
    [sym_union_type] = STATE(1891),
    [sym_anonymous_class] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(394),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(394),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1891),
    [sym_parenthesized_expression] = STATE(394),
    [sym_array] = STATE(167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(394),
    [sym_class] = STATE(394),
    [sym_identifier] = ACTIONS(3755),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(3757),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(2246),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_COMMA] = ACTIONS(270),
    [anon_sym_void] = ACTIONS(3761),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(260),
    [anon_sym_get] = ACTIONS(260),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_delete] = ACTIONS(264),
    [anon_sym_DASH_DASH] = ACTIONS(284),
    [anon_sym_this] = ACTIONS(3763),
    [anon_sym_yield] = ACTIONS(290),
    [sym_true] = ACTIONS(3765),
    [anon_sym_protected] = ACTIONS(260),
    [anon_sym_set] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(260),
    [anon_sym_import] = ACTIONS(260),
    [anon_sym_namespace] = ACTIONS(300),
    [anon_sym_PLUS_PLUS] = ACTIONS(284),
    [anon_sym_await] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [sym_false] = ACTIONS(3765),
    [anon_sym_module] = ACTIONS(260),
    [anon_sym_number] = ACTIONS(3757),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(260),
    [anon_sym_typeof] = ACTIONS(3767),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(268),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [anon_sym_RBRACK] = ACTIONS(723),
    [sym_null] = ACTIONS(721),
    [anon_sym_any] = ACTIONS(3757),
    [anon_sym_boolean] = ACTIONS(3757),
    [anon_sym_async] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(260),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(721),
    [anon_sym_new] = ACTIONS(3771),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_export] = ACTIONS(260),
    [anon_sym_TILDE] = ACTIONS(252),
  },
  [3465] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(2250),
    [sym__automatic_semicolon] = ACTIONS(2250),
    [anon_sym_PERCENT_EQ] = ACTIONS(2023),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2023),
    [anon_sym_AMP_EQ] = ACTIONS(2023),
    [anon_sym_PLUS_EQ] = ACTIONS(2023),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2017),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_CARET_EQ] = ACTIONS(2023),
    [anon_sym_STAR_EQ] = ACTIONS(2023),
    [anon_sym_PIPE_EQ] = ACTIONS(2023),
    [anon_sym_DASH_EQ] = ACTIONS(2023),
    [anon_sym_EQ_GT] = ACTIONS(2025),
    [anon_sym_RBRACE] = ACTIONS(3773),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(2023),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2023),
    [anon_sym_GT_GT_EQ] = ACTIONS(2023),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2250),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3466] = {
    [sym_new_expression] = STATE(983),
    [sym_augmented_assignment_expression] = STATE(983),
    [sym_unary_expression] = STATE(983),
    [sym_update_expression] = STATE(983),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(983),
    [sym_regex] = STATE(983),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(983),
    [sym_non_null_expression] = STATE(983),
    [sym_as_expression] = STATE(983),
    [sym_jsx_fragment] = STATE(983),
    [sym_yield_expression] = STATE(983),
    [sym_jsx_element] = STATE(983),
    [sym_internal_module] = STATE(983),
    [sym_nested_identifier] = STATE(1893),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(983),
    [sym_await_expression] = STATE(983),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(983),
    [sym_this] = STATE(983),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(983),
    [sym_generator_function] = STATE(983),
    [sym_call_expression] = STATE(983),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(983),
    [sym_ternary_expression] = STATE(983),
    [sym_binary_expression] = STATE(983),
    [sym_template_string] = STATE(983),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(983),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(983),
    [sym_class] = STATE(983),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(8410),
    [sym_false] = ACTIONS(2027),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2027),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(2029),
    [sym_true] = ACTIONS(2027),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2027),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [3467] = {
    [sym_new_expression] = STATE(984),
    [sym_augmented_assignment_expression] = STATE(984),
    [sym_unary_expression] = STATE(984),
    [sym_update_expression] = STATE(984),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(984),
    [sym_regex] = STATE(984),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(984),
    [sym_non_null_expression] = STATE(984),
    [sym_as_expression] = STATE(984),
    [sym_jsx_fragment] = STATE(984),
    [sym_yield_expression] = STATE(984),
    [sym_jsx_element] = STATE(984),
    [sym_internal_module] = STATE(984),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(984),
    [sym_await_expression] = STATE(984),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(984),
    [sym_this] = STATE(984),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(984),
    [sym_generator_function] = STATE(984),
    [sym_call_expression] = STATE(984),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(984),
    [sym_ternary_expression] = STATE(984),
    [sym_binary_expression] = STATE(984),
    [sym_template_string] = STATE(984),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(984),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(984),
    [sym_class] = STATE(984),
    [anon_sym_BANG] = ACTIONS(616),
    [sym_identifier] = ACTIONS(618),
    [sym_false] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2031),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8412),
    [sym_true] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
  },
  [3468] = {
    [aux_sym_export_statement_repeat1] = STATE(2003),
    [sym__property_name] = STATE(1807),
    [sym_object] = STATE(384),
    [sym_assignment_pattern] = STATE(405),
    [sym_pair] = STATE(405),
    [sym_method_signature] = STATE(1890),
    [sym_call_signature] = STATE(1890),
    [sym_type_parameters] = STATE(1082),
    [sym_index_signature] = STATE(1890),
    [sym_export_statement] = STATE(1890),
    [sym_method_definition] = STATE(405),
    [aux_sym_object_repeat1] = STATE(406),
    [sym_property_signature] = STATE(1890),
    [sym_decorator] = STATE(2003),
    [sym_construct_signature] = STATE(1890),
    [sym_accessibility_modifier] = STATE(1808),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1807),
    [sym_array] = STATE(385),
    [sym_spread_element] = STATE(405),
    [sym_string] = STATE(1807),
    [sym_identifier] = ACTIONS(4203),
    [anon_sym_LBRACK] = ACTIONS(3785),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_module] = ACTIONS(4205),
    [anon_sym_symbol] = ACTIONS(4205),
    [anon_sym_number] = ACTIONS(4205),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(4205),
    [anon_sym_COMMA] = ACTIONS(8414),
    [anon_sym_STAR] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_void] = ACTIONS(4205),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(4205),
    [anon_sym_private] = ACTIONS(4207),
    [anon_sym_boolean] = ACTIONS(4205),
    [anon_sym_static] = ACTIONS(3795),
    [anon_sym_async] = ACTIONS(4209),
    [anon_sym_get] = ACTIONS(4211),
    [anon_sym_RBRACE] = ACTIONS(8416),
    [anon_sym_public] = ACTIONS(4207),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(3801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4207),
    [anon_sym_string] = ACTIONS(4205),
    [anon_sym_set] = ACTIONS(4211),
    [anon_sym_type] = ACTIONS(4205),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(4205),
    [anon_sym_export] = ACTIONS(4215),
    [sym_readonly] = ACTIONS(3805),
    [anon_sym_namespace] = ACTIONS(4205),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3993),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [3469] = {
    [sym_new_expression] = STATE(983),
    [sym_augmented_assignment_expression] = STATE(983),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(983),
    [sym_update_expression] = STATE(983),
    [sym_regex] = STATE(983),
    [sym_meta_property] = STATE(983),
    [sym_call_signature] = STATE(361),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(983),
    [sym_non_null_expression] = STATE(983),
    [sym_yield_expression] = STATE(983),
    [sym_jsx_fragment] = STATE(983),
    [sym_jsx_element] = STATE(983),
    [sym_as_expression] = STATE(983),
    [sym_internal_module] = STATE(983),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(983),
    [sym_await_expression] = STATE(983),
    [sym_member_expression] = STATE(363),
    [sym_string] = STATE(983),
    [sym_this] = STATE(983),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(365),
    [sym_anonymous_class] = STATE(983),
    [sym_generator_function] = STATE(983),
    [sym_call_expression] = STATE(983),
    [sym_subscript_expression] = STATE(363),
    [sym_assignment_expression] = STATE(983),
    [sym_ternary_expression] = STATE(983),
    [sym_binary_expression] = STATE(983),
    [sym_template_string] = STATE(983),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(983),
    [sym_array] = STATE(366),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(983),
    [sym_class] = STATE(983),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(2250),
    [sym_identifier] = ACTIONS(618),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(2023),
    [anon_sym_symbol] = ACTIONS(622),
    [anon_sym_AMP_EQ] = ACTIONS(2023),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2023),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(2017),
    [anon_sym_void] = ACTIONS(628),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(2023),
    [anon_sym_private] = ACTIONS(622),
    [anon_sym_PIPE_EQ] = ACTIONS(2023),
    [anon_sym_DASH_EQ] = ACTIONS(2023),
    [anon_sym_get] = ACTIONS(622),
    [anon_sym_RBRACE] = ACTIONS(3773),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(2023),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(624),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(636),
    [sym_true] = ACTIONS(2027),
    [anon_sym_protected] = ACTIONS(622),
    [anon_sym_GT_GT_EQ] = ACTIONS(2023),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(622),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2250),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(622),
    [anon_sym_import] = ACTIONS(622),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2023),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_namespace] = ACTIONS(640),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(624),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(2027),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym_module] = ACTIONS(622),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2023),
    [anon_sym_number] = ACTIONS(622),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(622),
    [anon_sym_typeof] = ACTIONS(624),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(2027),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_any] = ACTIONS(622),
    [anon_sym_STAR_EQ] = ACTIONS(2023),
    [anon_sym_boolean] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_public] = ACTIONS(622),
    [anon_sym_EQ_GT] = ACTIONS(2025),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(2029),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2023),
    [anon_sym_string] = ACTIONS(622),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(2027),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_export] = ACTIONS(622),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(616),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3470] = {
    [sym_new_expression] = STATE(538),
    [sym_constructor_type] = STATE(1899),
    [sym_augmented_assignment_expression] = STATE(538),
    [sym_lookup_type] = STATE(436),
    [sym_unary_expression] = STATE(538),
    [sym_parenthesized_type] = STATE(436),
    [sym_regex] = STATE(538),
    [sym_type_parameters] = STATE(1817),
    [sym_array_type] = STATE(436),
    [sym_rest_parameter] = STATE(244),
    [sym_yield_expression] = STATE(538),
    [sym_as_expression] = STATE(538),
    [sym_jsx_fragment] = STATE(538),
    [sym_internal_module] = STATE(538),
    [sym_accessibility_modifier] = STATE(247),
    [sym_arrow_function] = STATE(538),
    [sym__primary_type] = STATE(436),
    [sym_member_expression] = STATE(246),
    [sym_literal_type] = STATE(436),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(1814),
    [sym_tuple_type] = STATE(436),
    [aux_sym_export_statement_repeat1] = STATE(250),
    [sym_object] = STATE(251),
    [sym_nested_type_identifier] = STATE(433),
    [sym_generator_function] = STATE(538),
    [sym_subscript_expression] = STATE(246),
    [sym_type_query] = STATE(436),
    [sym_ternary_expression] = STATE(538),
    [sym_this_type] = STATE(436),
    [sym_template_string] = STATE(538),
    [sym_decorator] = STATE(250),
    [sym_formal_parameters] = STATE(1818),
    [sym_function_type] = STATE(1899),
    [sym__type] = STATE(1899),
    [sym_index_type_query] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_update_expression] = STATE(538),
    [sym_call_signature] = STATE(243),
    [sym_meta_property] = STATE(538),
    [sym__expression] = STATE(538),
    [sym_non_null_expression] = STATE(538),
    [sym_jsx_element] = STATE(538),
    [sym_nested_identifier] = STATE(435),
    [sym_function] = STATE(161),
    [sym_required_parameter] = STATE(244),
    [sym_await_expression] = STATE(538),
    [sym_generic_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_sequence_expression] = STATE(539),
    [sym_this] = STATE(249),
    [sym_union_type] = STATE(1899),
    [sym_anonymous_class] = STATE(538),
    [sym_optional_parameter] = STATE(244),
    [sym_call_expression] = STATE(538),
    [sym_type_predicate] = STATE(436),
    [sym_assignment_expression] = STATE(538),
    [sym_existential_type] = STATE(436),
    [sym_binary_expression] = STATE(538),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1899),
    [sym_parenthesized_expression] = STATE(538),
    [sym_array] = STATE(252),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(538),
    [sym_class] = STATE(538),
    [sym_identifier] = ACTIONS(3807),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_symbol] = ACTIONS(3809),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(2274),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_void] = ACTIONS(3813),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(424),
    [anon_sym_get] = ACTIONS(414),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_DASH_DASH] = ACTIONS(406),
    [anon_sym_this] = ACTIONS(3815),
    [anon_sym_yield] = ACTIONS(432),
    [sym_true] = ACTIONS(3817),
    [anon_sym_protected] = ACTIONS(424),
    [anon_sym_set] = ACTIONS(414),
    [anon_sym_type] = ACTIONS(414),
    [anon_sym_import] = ACTIONS(414),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(438),
    [anon_sym_await] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_PLUS_PLUS] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(412),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [sym_false] = ACTIONS(3817),
    [anon_sym_module] = ACTIONS(414),
    [anon_sym_number] = ACTIONS(3809),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(414),
    [anon_sym_typeof] = ACTIONS(3819),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(2689),
    [sym_null] = ACTIONS(983),
    [anon_sym_any] = ACTIONS(3809),
    [anon_sym_boolean] = ACTIONS(3809),
    [anon_sym_async] = ACTIONS(426),
    [anon_sym_public] = ACTIONS(424),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_RPAREN] = ACTIONS(428),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(3821),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3809),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(983),
    [anon_sym_new] = ACTIONS(3823),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_export] = ACTIONS(414),
    [anon_sym_TILDE] = ACTIONS(412),
  },
  [3471] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_BANG] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [anon_sym_SEMI] = ACTIONS(2254),
    [sym__automatic_semicolon] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3825),
    [anon_sym_LT_LT] = ACTIONS(207),
    [anon_sym_STAR] = ACTIONS(209),
    [anon_sym_GT_GT_GT] = ACTIONS(207),
    [anon_sym_AMP_AMP] = ACTIONS(207),
    [anon_sym_DASH] = ACTIONS(209),
    [anon_sym_BANG_EQ] = ACTIONS(209),
    [anon_sym_LT_EQ] = ACTIONS(207),
    [anon_sym_LPAREN] = ACTIONS(207),
    [anon_sym_GT_EQ] = ACTIONS(207),
    [anon_sym_GT] = ACTIONS(209),
    [anon_sym_RBRACE] = ACTIONS(3825),
    [anon_sym_AMP] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PERCENT] = ACTIONS(207),
    [anon_sym_as] = ACTIONS(207),
    [anon_sym_PIPE_PIPE] = ACTIONS(207),
    [anon_sym_DASH_DASH] = ACTIONS(207),
    [anon_sym_EQ_EQ] = ACTIONS(209),
    [anon_sym_instanceof] = ACTIONS(207),
    [anon_sym_LT] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(207),
    [anon_sym_CARET] = ACTIONS(207),
    [anon_sym_STAR_STAR] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(209),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2254),
    [anon_sym_GT_GT] = ACTIONS(209),
    [anon_sym_PLUS_PLUS] = ACTIONS(207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(207),
    [anon_sym_in] = ACTIONS(209),
  },
  [3472] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(361),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(4064),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(4065),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(2047),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(2049),
    [anon_sym_symbol] = ACTIONS(2049),
    [anon_sym_number] = ACTIONS(2049),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2049),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2051),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2049),
    [anon_sym_private] = ACTIONS(2049),
    [anon_sym_boolean] = ACTIONS(2049),
    [anon_sym_async] = ACTIONS(2053),
    [anon_sym_public] = ACTIONS(2049),
    [anon_sym_get] = ACTIONS(2049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2049),
    [anon_sym_string] = ACTIONS(2049),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(2049),
    [anon_sym_type] = ACTIONS(2049),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_import] = ACTIONS(2049),
    [anon_sym_export] = ACTIONS(2049),
    [anon_sym_namespace] = ACTIONS(2055),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [3473] = {
    [sym_formal_parameters] = STATE(4066),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3474] = {
    [sym_type_annotation] = STATE(323),
    [anon_sym_EQ_GT] = ACTIONS(8418),
    [anon_sym_COLON] = ACTIONS(550),
    [sym_comment] = ACTIONS(3),
  },
  [3475] = {
    [sym_type_annotation] = STATE(2523),
    [sym__automatic_semicolon] = ACTIONS(1669),
    [anon_sym_RBRACE] = ACTIONS(1669),
    [anon_sym_COLON] = ACTIONS(7267),
    [anon_sym_SEMI] = ACTIONS(1669),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1669),
    [anon_sym_COMMA] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1669),
  },
  [3476] = {
    [sym_union_type] = STATE(4072),
    [sym__type] = STATE(4072),
    [sym_constructor_type] = STATE(4072),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4073),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4072),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4074),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(8421),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(8423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8425),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8427),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3477] = {
    [sym_string] = STATE(4077),
    [sym__property_name] = STATE(4077),
    [sym_computed_property_name] = STATE(4077),
    [anon_sym_get] = ACTIONS(8431),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_number] = ACTIONS(8433),
    [anon_sym_STAR] = ACTIONS(8395),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(8431),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_async] = ACTIONS(8435),
  },
  [3478] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(6447),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [anon_sym_PERCENT_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_AMP_EQ] = ACTIONS(2011),
    [anon_sym_PLUS_EQ] = ACTIONS(2011),
    [anon_sym_PIPE] = ACTIONS(6450),
    [anon_sym_COMMA] = ACTIONS(2011),
    [anon_sym_LT_LT] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_GT_GT_GT] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_CARET_EQ] = ACTIONS(2011),
    [anon_sym_STAR_EQ] = ACTIONS(2011),
    [anon_sym_PIPE_EQ] = ACTIONS(2011),
    [anon_sym_DASH_EQ] = ACTIONS(2011),
    [anon_sym_AMP] = ACTIONS(6450),
    [anon_sym_PERCENT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_LT_LT_EQ] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_RPAREN] = ACTIONS(6447),
    [anon_sym_LT] = ACTIONS(6450),
    [anon_sym_instanceof] = ACTIONS(2011),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2011),
    [anon_sym_SLASH_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_DOT] = ACTIONS(6453),
    [anon_sym_CARET] = ACTIONS(2013),
    [anon_sym_STAR_STAR] = ACTIONS(2013),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2013),
  },
  [3479] = {
    [sym_identifier] = ACTIONS(8437),
    [sym_comment] = ACTIONS(3),
  },
  [3480] = {
    [sym_type_annotation] = STATE(892),
    [anon_sym_EQ_GT] = ACTIONS(8439),
    [anon_sym_COLON] = ACTIONS(550),
    [sym_comment] = ACTIONS(3),
  },
  [3481] = {
    [sym_jsx_text] = ACTIONS(6999),
    [anon_sym_LT] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6999),
  },
  [3482] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5792),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(5794),
    [anon_sym_LT_LT] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(5800),
    [anon_sym_GT_GT_GT] = ACTIONS(5796),
    [anon_sym_AMP_AMP] = ACTIONS(5802),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(5792),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_QMARK] = ACTIONS(5806),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [anon_sym_as] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_instanceof] = ACTIONS(5792),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(5808),
    [anon_sym_STAR_STAR] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5798),
    [anon_sym_GT_GT] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5792),
    [anon_sym_in] = ACTIONS(5752),
  },
  [3483] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(5800),
    [anon_sym_GT_GT_GT] = ACTIONS(5796),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [anon_sym_as] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5798),
    [anon_sym_GT_GT] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3484] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5792),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(5794),
    [anon_sym_LT_LT] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(5800),
    [anon_sym_GT_GT_GT] = ACTIONS(5796),
    [anon_sym_AMP_AMP] = ACTIONS(5802),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(5792),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_RBRACE] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_QMARK] = ACTIONS(5806),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [anon_sym_as] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_instanceof] = ACTIONS(5792),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(5808),
    [anon_sym_STAR_STAR] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5798),
    [anon_sym_GT_GT] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5792),
    [anon_sym_in] = ACTIONS(5752),
  },
  [3485] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5792),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(5794),
    [anon_sym_LT_LT] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(5800),
    [anon_sym_GT_GT_GT] = ACTIONS(5796),
    [anon_sym_AMP_AMP] = ACTIONS(5802),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(5792),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_RBRACE] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_QMARK] = ACTIONS(5806),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [anon_sym_as] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_instanceof] = ACTIONS(5792),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(5808),
    [anon_sym_STAR_STAR] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5798),
    [anon_sym_GT_GT] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5792),
    [anon_sym_in] = ACTIONS(5752),
  },
  [3486] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5792),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(5794),
    [anon_sym_LT_LT] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(5800),
    [anon_sym_GT_GT_GT] = ACTIONS(5796),
    [anon_sym_AMP_AMP] = ACTIONS(5802),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(5792),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_RBRACE] = ACTIONS(2101),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_QMARK] = ACTIONS(5806),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [anon_sym_as] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_instanceof] = ACTIONS(5792),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(5808),
    [anon_sym_STAR_STAR] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5798),
    [anon_sym_GT_GT] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5792),
    [anon_sym_in] = ACTIONS(5752),
  },
  [3487] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5792),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(5794),
    [anon_sym_LT_LT] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(5800),
    [anon_sym_GT_GT_GT] = ACTIONS(5796),
    [anon_sym_AMP_AMP] = ACTIONS(5802),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(5792),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_RBRACE] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_QMARK] = ACTIONS(5806),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [anon_sym_as] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_instanceof] = ACTIONS(5792),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(5808),
    [anon_sym_STAR_STAR] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5798),
    [anon_sym_GT_GT] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5792),
    [anon_sym_in] = ACTIONS(5752),
  },
  [3488] = {
    [sym_new_expression] = STATE(4079),
    [sym_augmented_assignment_expression] = STATE(4079),
    [sym_unary_expression] = STATE(4079),
    [sym_update_expression] = STATE(4079),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(4079),
    [sym_regex] = STATE(4079),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2185),
    [sym__expression] = STATE(4079),
    [sym_non_null_expression] = STATE(4079),
    [sym_yield_expression] = STATE(4079),
    [sym_jsx_fragment] = STATE(4079),
    [sym_jsx_element] = STATE(4079),
    [sym_as_expression] = STATE(4079),
    [sym_internal_module] = STATE(4079),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4079),
    [sym_await_expression] = STATE(4079),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(4079),
    [sym_this] = STATE(4079),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(4079),
    [sym_generator_function] = STATE(4079),
    [sym_call_expression] = STATE(4079),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(4079),
    [sym_ternary_expression] = STATE(4079),
    [sym_binary_expression] = STATE(4079),
    [sym_template_string] = STATE(4079),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4079),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4079),
    [sym_class] = STATE(4079),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3842),
    [sym_false] = ACTIONS(8442),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8442),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8444),
    [sym_true] = ACTIONS(8442),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8442),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [3489] = {
    [sym_new_expression] = STATE(4080),
    [sym_augmented_assignment_expression] = STATE(4080),
    [sym_unary_expression] = STATE(4080),
    [sym_update_expression] = STATE(4080),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(4080),
    [sym_regex] = STATE(4080),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2187),
    [sym__expression] = STATE(4080),
    [sym_non_null_expression] = STATE(4080),
    [sym_yield_expression] = STATE(4080),
    [sym_jsx_fragment] = STATE(4080),
    [sym_jsx_element] = STATE(4080),
    [sym_as_expression] = STATE(4080),
    [sym_internal_module] = STATE(4080),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4080),
    [sym_await_expression] = STATE(4080),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(4080),
    [sym_this] = STATE(4080),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(4080),
    [sym_generator_function] = STATE(4080),
    [sym_call_expression] = STATE(4080),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(4080),
    [sym_ternary_expression] = STATE(4080),
    [sym_binary_expression] = STATE(4080),
    [sym_template_string] = STATE(4080),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4080),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4080),
    [sym_class] = STATE(4080),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3842),
    [sym_false] = ACTIONS(8446),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8446),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8448),
    [sym_true] = ACTIONS(8446),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8446),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [3490] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5792),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(5800),
    [anon_sym_GT_GT_GT] = ACTIONS(5796),
    [anon_sym_AMP_AMP] = ACTIONS(5802),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(5792),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [anon_sym_as] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_instanceof] = ACTIONS(5792),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5798),
    [anon_sym_GT_GT] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5792),
    [anon_sym_in] = ACTIONS(5752),
  },
  [3491] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(8450),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3492] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(5800),
    [anon_sym_GT_GT_GT] = ACTIONS(5796),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [anon_sym_as] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(8450),
    [anon_sym_SLASH] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3493] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5792),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(5800),
    [anon_sym_GT_GT_GT] = ACTIONS(5796),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(5792),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [anon_sym_as] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_instanceof] = ACTIONS(5792),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5798),
    [anon_sym_GT_GT] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5792),
    [anon_sym_in] = ACTIONS(5752),
  },
  [3494] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3630),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(8453),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3495] = {
    [sym_type_arguments] = STATE(2206),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(4638),
    [anon_sym_BANG] = ACTIONS(3699),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(3699),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_GT_GT_GT] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(8455),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_instanceof] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(4643),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4646),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_STAR_STAR] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2204),
    [anon_sym_in] = ACTIONS(3699),
  },
  [3496] = {
    [sym_index_type_query] = STATE(2208),
    [sym_lookup_type] = STATE(2208),
    [sym_flow_maybe_type] = STATE(2208),
    [sym_parenthesized_type] = STATE(2208),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_array_type] = STATE(2208),
    [sym_type_predicate] = STATE(2208),
    [sym_type_query] = STATE(2208),
    [sym_existential_type] = STATE(2208),
    [sym_this_type] = STATE(2208),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(2208),
    [sym__primary_type] = STATE(2208),
    [sym_generic_type] = STATE(2208),
    [sym_literal_type] = STATE(2208),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(2208),
    [sym_string] = STATE(1279),
    [sym_tuple_type] = STATE(2208),
    [sym_identifier] = ACTIONS(7341),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(7347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [sym_true] = ACTIONS(2643),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(4648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3497] = {
    [sym_union_type] = STATE(2213),
    [sym__type] = STATE(2213),
    [sym_constructor_type] = STATE(2213),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3500),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2213),
    [sym_function_type] = STATE(2213),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3501),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(7341),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(7347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(7345),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(7349),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(7343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3498] = {
    [sym_type_parameters] = STATE(4083),
    [sym_formal_parameters] = STATE(4084),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3499] = {
    [sym_union_type] = STATE(2221),
    [sym__type] = STATE(2221),
    [sym_constructor_type] = STATE(2221),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3500),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2221),
    [sym_function_type] = STATE(2221),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3501),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(7341),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(7347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(7345),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(7349),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(7343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3500] = {
    [sym_formal_parameters] = STATE(4087),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3501] = {
    [anon_sym_EQ_GT] = ACTIONS(8457),
    [sym_comment] = ACTIONS(3),
  },
  [3502] = {
    [sym__initializer] = STATE(522),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(5746),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5746),
    [anon_sym_AMP_EQ] = ACTIONS(5746),
    [anon_sym_PLUS_EQ] = ACTIONS(5746),
    [anon_sym_PIPE] = ACTIONS(3738),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(5748),
    [anon_sym_GT] = ACTIONS(3738),
    [anon_sym_CARET_EQ] = ACTIONS(5746),
    [anon_sym_STAR_EQ] = ACTIONS(5746),
    [anon_sym_PIPE_EQ] = ACTIONS(5746),
    [anon_sym_DASH_EQ] = ACTIONS(5746),
    [anon_sym_EQ_GT] = ACTIONS(5750),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(5746),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5746),
    [anon_sym_GT_GT_EQ] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5390),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5746),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5752),
  },
  [3503] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(5754),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5754),
    [anon_sym_AMP_EQ] = ACTIONS(5754),
    [anon_sym_PLUS_EQ] = ACTIONS(5754),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(5748),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_CARET_EQ] = ACTIONS(5754),
    [anon_sym_STAR_EQ] = ACTIONS(5754),
    [anon_sym_PIPE_EQ] = ACTIONS(5754),
    [anon_sym_DASH_EQ] = ACTIONS(5754),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(5754),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5754),
    [anon_sym_GT_GT_EQ] = ACTIONS(5754),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3504] = {
    [sym_new_expression] = STATE(2735),
    [sym_augmented_assignment_expression] = STATE(2735),
    [sym_unary_expression] = STATE(2735),
    [sym_update_expression] = STATE(2735),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(2735),
    [sym_regex] = STATE(2735),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2735),
    [sym_non_null_expression] = STATE(2735),
    [sym_as_expression] = STATE(2735),
    [sym_jsx_fragment] = STATE(2735),
    [sym_yield_expression] = STATE(2735),
    [sym_jsx_element] = STATE(2735),
    [sym_internal_module] = STATE(2735),
    [sym_nested_identifier] = STATE(1092),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2735),
    [sym_await_expression] = STATE(2735),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(2735),
    [sym_this] = STATE(2735),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(2735),
    [sym_generator_function] = STATE(2735),
    [sym_call_expression] = STATE(2735),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(2735),
    [sym_ternary_expression] = STATE(2735),
    [sym_binary_expression] = STATE(2735),
    [sym_template_string] = STATE(2735),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2735),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2735),
    [sym_class] = STATE(2735),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(8459),
    [sym_false] = ACTIONS(5758),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5758),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(5760),
    [sym_true] = ACTIONS(5758),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5758),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [3505] = {
    [sym_new_expression] = STATE(2736),
    [sym_augmented_assignment_expression] = STATE(2736),
    [sym_unary_expression] = STATE(2736),
    [sym_update_expression] = STATE(2736),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(2736),
    [sym_regex] = STATE(2736),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2736),
    [sym_non_null_expression] = STATE(2736),
    [sym_as_expression] = STATE(2736),
    [sym_jsx_fragment] = STATE(2736),
    [sym_yield_expression] = STATE(2736),
    [sym_jsx_element] = STATE(2736),
    [sym_internal_module] = STATE(2736),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2736),
    [sym_await_expression] = STATE(2736),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(2736),
    [sym_this] = STATE(2736),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(2736),
    [sym_generator_function] = STATE(2736),
    [sym_call_expression] = STATE(2736),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(2736),
    [sym_ternary_expression] = STATE(2736),
    [sym_binary_expression] = STATE(2736),
    [sym_template_string] = STATE(2736),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2736),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2736),
    [sym_class] = STATE(2736),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3842),
    [sym_false] = ACTIONS(5762),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5762),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4674),
    [sym_true] = ACTIONS(5762),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5762),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [3506] = {
    [sym_new_expression] = STATE(2735),
    [sym_augmented_assignment_expression] = STATE(2735),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(2735),
    [sym_update_expression] = STATE(2735),
    [sym_regex] = STATE(2735),
    [sym_meta_property] = STATE(2735),
    [sym_call_signature] = STATE(1839),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2735),
    [sym_non_null_expression] = STATE(2735),
    [sym_yield_expression] = STATE(2735),
    [sym_jsx_fragment] = STATE(2735),
    [sym_jsx_element] = STATE(2735),
    [sym_as_expression] = STATE(2735),
    [sym_internal_module] = STATE(2735),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(2735),
    [sym_await_expression] = STATE(2735),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(2735),
    [sym_this] = STATE(2735),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(2735),
    [sym_generator_function] = STATE(2735),
    [sym_call_expression] = STATE(2735),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(2735),
    [sym_ternary_expression] = STATE(2735),
    [sym_binary_expression] = STATE(2735),
    [sym_template_string] = STATE(2735),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2735),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(2735),
    [sym_class] = STATE(2735),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(3842),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(5754),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_AMP_EQ] = ACTIONS(5754),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(5754),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(5748),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(5754),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_PIPE_EQ] = ACTIONS(5754),
    [anon_sym_DASH_EQ] = ACTIONS(5754),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(5754),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(3860),
    [sym_true] = ACTIONS(5758),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_GT_GT_EQ] = ACTIONS(5754),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5754),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(3848),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(5758),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5754),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(5758),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_STAR_EQ] = ACTIONS(5754),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_EQ_GT] = ACTIONS(5756),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(5760),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5754),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(5758),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3507] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(1819),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(1820),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(5778),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(5780),
    [anon_sym_symbol] = ACTIONS(5780),
    [anon_sym_number] = ACTIONS(5780),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5780),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(5782),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5780),
    [anon_sym_private] = ACTIONS(5780),
    [anon_sym_boolean] = ACTIONS(5780),
    [anon_sym_async] = ACTIONS(5784),
    [anon_sym_public] = ACTIONS(5780),
    [anon_sym_get] = ACTIONS(5780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5780),
    [anon_sym_string] = ACTIONS(5780),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(5780),
    [anon_sym_type] = ACTIONS(5780),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(5780),
    [anon_sym_export] = ACTIONS(5780),
    [anon_sym_namespace] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [3508] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(8450),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3509] = {
    [sym_jsx_text] = ACTIONS(7288),
    [anon_sym_LT] = ACTIONS(7288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7288),
  },
  [3510] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2063),
    [anon_sym_COMMA] = ACTIONS(7181),
    [anon_sym_LT_LT] = ACTIONS(2067),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_GT_GT_GT] = ACTIONS(2067),
    [anon_sym_AMP_AMP] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2069),
    [anon_sym_BANG_EQ] = ACTIONS(2021),
    [anon_sym_LT_EQ] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2061),
    [anon_sym_GT] = ACTIONS(2021),
    [anon_sym_RBRACE] = ACTIONS(7181),
    [anon_sym_AMP] = ACTIONS(2075),
    [anon_sym_QMARK] = ACTIONS(2077),
    [anon_sym_PERCENT] = ACTIONS(2067),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2021),
    [anon_sym_instanceof] = ACTIONS(2061),
    [anon_sym_LT] = ACTIONS(2085),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2081),
    [anon_sym_STAR_STAR] = ACTIONS(2087),
    [anon_sym_PLUS] = ACTIONS(2069),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2061),
    [anon_sym_in] = ACTIONS(2021),
  },
  [3511] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(7192),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(8461),
    [anon_sym_COMMA] = ACTIONS(5893),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_GT_GT_GT] = ACTIONS(5893),
    [anon_sym_AMP_AMP] = ACTIONS(5893),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_BANG_EQ] = ACTIONS(7192),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_RBRACE] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(8463),
    [anon_sym_QMARK] = ACTIONS(5893),
    [anon_sym_PERCENT] = ACTIONS(5893),
    [anon_sym_as] = ACTIONS(5893),
    [anon_sym_PIPE_PIPE] = ACTIONS(5893),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_EQ_EQ] = ACTIONS(7192),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5893),
    [anon_sym_CARET] = ACTIONS(5893),
    [anon_sym_STAR_STAR] = ACTIONS(5893),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_in] = ACTIONS(7192),
  },
  [3512] = {
    [anon_sym_EQ_GT] = ACTIONS(8465),
    [sym_comment] = ACTIONS(3),
  },
  [3513] = {
    [sym_union_type] = STATE(4091),
    [sym__type] = STATE(4091),
    [sym_constructor_type] = STATE(4091),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1868),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4091),
    [sym_function_type] = STATE(4091),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1869),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3946),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3952),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3514] = {
    [sym_union_type] = STATE(4092),
    [sym__type] = STATE(4092),
    [sym_constructor_type] = STATE(4092),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1868),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4092),
    [sym_function_type] = STATE(4092),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1869),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3946),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3952),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3515] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_BANG] = ACTIONS(7208),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(8461),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_LT_LT] = ACTIONS(6040),
    [anon_sym_STAR] = ACTIONS(7208),
    [anon_sym_GT_GT_GT] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(6040),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_BANG_EQ] = ACTIONS(7208),
    [anon_sym_LT_EQ] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [anon_sym_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_RBRACE] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(8463),
    [anon_sym_QMARK] = ACTIONS(6040),
    [anon_sym_PERCENT] = ACTIONS(6040),
    [anon_sym_as] = ACTIONS(6040),
    [anon_sym_PIPE_PIPE] = ACTIONS(6040),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_instanceof] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6040),
    [anon_sym_CARET] = ACTIONS(6040),
    [anon_sym_STAR_STAR] = ACTIONS(6040),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6040),
    [anon_sym_in] = ACTIONS(7208),
  },
  [3516] = {
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_LBRACK] = ACTIONS(7419),
    [anon_sym_AMP] = ACTIONS(7419),
    [anon_sym_SEMI] = ACTIONS(7419),
    [sym__automatic_semicolon] = ACTIONS(7419),
    [anon_sym_RBRACE] = ACTIONS(7419),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7419),
    [anon_sym_PIPE] = ACTIONS(7417),
    [anon_sym_COMMA] = ACTIONS(7419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7419),
  },
  [3517] = {
    [anon_sym_EQ] = ACTIONS(4229),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [anon_sym_AMP] = ACTIONS(4229),
    [anon_sym_SEMI] = ACTIONS(4229),
    [sym__automatic_semicolon] = ACTIONS(4229),
    [anon_sym_RBRACE] = ACTIONS(4229),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4229),
    [anon_sym_PIPE] = ACTIONS(4231),
    [anon_sym_COMMA] = ACTIONS(4229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4229),
  },
  [3518] = {
    [sym_union_type] = STATE(2014),
    [sym__type] = STATE(2014),
    [sym_constructor_type] = STATE(2014),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2014),
    [sym_function_type] = STATE(2014),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(8467),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_boolean] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_this] = ACTIONS(765),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [3519] = {
    [aux_sym_implements_clause_repeat1] = STATE(2016),
    [anon_sym_COMMA] = ACTIONS(8469),
    [anon_sym_GT] = ACTIONS(8467),
    [sym_comment] = ACTIONS(3),
  },
  [3520] = {
    [sym_formal_parameters] = STATE(4095),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3521] = {
    [anon_sym_EQ_GT] = ACTIONS(8471),
    [sym_comment] = ACTIONS(3),
  },
  [3522] = {
    [sym_union_type] = STATE(2790),
    [sym__type] = STATE(2790),
    [sym_constructor_type] = STATE(2790),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2778),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2790),
    [sym_function_type] = STATE(2790),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2779),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2135),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5845),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5847),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3523] = {
    [sym_union_type] = STATE(2791),
    [sym__type] = STATE(2791),
    [sym_constructor_type] = STATE(2791),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2778),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2791),
    [sym_function_type] = STATE(2791),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2779),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2135),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5845),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5847),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3524] = {
    [anon_sym_EQ_GT] = ACTIONS(8473),
    [sym_comment] = ACTIONS(3),
  },
  [3525] = {
    [sym_union_type] = STATE(4098),
    [sym__type] = STATE(4098),
    [sym_constructor_type] = STATE(4098),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2778),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4098),
    [sym_function_type] = STATE(4098),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2779),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2135),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5845),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5847),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3526] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(2866),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(2866),
    [sym_call_signature] = STATE(2866),
    [sym_export_statement] = STATE(2866),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(2866),
    [sym_index_signature] = STATE(2866),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_RBRACE] = ACTIONS(8475),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8475),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [3527] = {
    [anon_sym_EQ] = ACTIONS(7431),
    [anon_sym_LBRACK] = ACTIONS(7431),
    [anon_sym_AMP] = ACTIONS(7431),
    [anon_sym_SEMI] = ACTIONS(7431),
    [sym__automatic_semicolon] = ACTIONS(7431),
    [anon_sym_RBRACE] = ACTIONS(7431),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7431),
    [anon_sym_PIPE] = ACTIONS(7429),
    [anon_sym_COMMA] = ACTIONS(7431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7431),
  },
  [3528] = {
    [aux_sym_object_type_repeat1] = STATE(2867),
    [sym__automatic_semicolon] = ACTIONS(8477),
    [anon_sym_RBRACE] = ACTIONS(8475),
    [anon_sym_SEMI] = ACTIONS(8477),
    [anon_sym_COMMA] = ACTIONS(8477),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8475),
    [sym_comment] = ACTIONS(3),
  },
  [3529] = {
    [anon_sym_EQ] = ACTIONS(7506),
    [anon_sym_LBRACK] = ACTIONS(7506),
    [anon_sym_AMP] = ACTIONS(7506),
    [anon_sym_SEMI] = ACTIONS(7506),
    [sym__automatic_semicolon] = ACTIONS(7506),
    [anon_sym_RBRACE] = ACTIONS(7506),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7506),
    [anon_sym_PIPE] = ACTIONS(7504),
    [anon_sym_COMMA] = ACTIONS(7506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7506),
  },
  [3530] = {
    [anon_sym_EQ] = ACTIONS(4485),
    [anon_sym_LBRACK] = ACTIONS(4485),
    [anon_sym_AMP] = ACTIONS(4485),
    [anon_sym_SEMI] = ACTIONS(4485),
    [anon_sym_DOT] = ACTIONS(4485),
    [sym__automatic_semicolon] = ACTIONS(4485),
    [anon_sym_RBRACE] = ACTIONS(4485),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4485),
    [anon_sym_PIPE] = ACTIONS(4487),
    [anon_sym_COMMA] = ACTIONS(4485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4485),
  },
  [3531] = {
    [sym_union_type] = STATE(4101),
    [sym__type] = STATE(4101),
    [sym_constructor_type] = STATE(4101),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1033),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4101),
    [sym_function_type] = STATE(4101),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1036),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2135),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3532] = {
    [anon_sym_EQ] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(4001),
    [sym__automatic_semicolon] = ACTIONS(7511),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_COMMA] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
  },
  [3533] = {
    [anon_sym_EQ] = ACTIONS(7527),
    [anon_sym_LBRACK] = ACTIONS(7527),
    [anon_sym_AMP] = ACTIONS(7527),
    [anon_sym_SEMI] = ACTIONS(7527),
    [sym__automatic_semicolon] = ACTIONS(7527),
    [anon_sym_RBRACE] = ACTIONS(7527),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7527),
    [anon_sym_PIPE] = ACTIONS(7525),
    [anon_sym_COMMA] = ACTIONS(7527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7527),
  },
  [3534] = {
    [anon_sym_EQ] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(4001),
    [sym__automatic_semicolon] = ACTIONS(7529),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_COMMA] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
  },
  [3535] = {
    [sym_formal_parameters] = STATE(4102),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3536] = {
    [anon_sym_EQ_GT] = ACTIONS(8479),
    [sym_comment] = ACTIONS(3),
  },
  [3537] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2801),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2802),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2183),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5869),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5871),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3538] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2801),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2802),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2183),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5869),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5871),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3539] = {
    [anon_sym_EQ_GT] = ACTIONS(8481),
    [sym_comment] = ACTIONS(3),
  },
  [3540] = {
    [sym_union_type] = STATE(4105),
    [sym__type] = STATE(4105),
    [sym_constructor_type] = STATE(4105),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2801),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4105),
    [sym_function_type] = STATE(4105),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2802),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2183),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5869),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5871),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3541] = {
    [sym_union_type] = STATE(4106),
    [sym__type] = STATE(4106),
    [sym_constructor_type] = STATE(4106),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1055),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4106),
    [sym_function_type] = STATE(4106),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1056),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2183),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3542] = {
    [anon_sym_EQ] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4037),
    [sym_comment] = ACTIONS(3),
  },
  [3543] = {
    [anon_sym_EQ] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4037),
    [sym_comment] = ACTIONS(3),
  },
  [3544] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3548),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3549),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(7409),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(7411),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(7413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3545] = {
    [sym_type_parameters] = STATE(4107),
    [sym_formal_parameters] = STATE(4108),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3546] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3548),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3549),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(7409),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(7411),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(7413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3547] = {
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(8483),
    [anon_sym_PIPE] = ACTIONS(8485),
    [anon_sym_RBRACK] = ACTIONS(5893),
    [sym_comment] = ACTIONS(3),
  },
  [3548] = {
    [sym_formal_parameters] = STATE(4111),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3549] = {
    [anon_sym_EQ_GT] = ACTIONS(8487),
    [sym_comment] = ACTIONS(3),
  },
  [3550] = {
    [anon_sym_EQ_GT] = ACTIONS(8489),
    [sym_comment] = ACTIONS(3),
  },
  [3551] = {
    [sym_union_type] = STATE(4114),
    [sym__type] = STATE(4114),
    [sym_constructor_type] = STATE(4114),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1926),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4114),
    [sym_function_type] = STATE(4114),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1927),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4057),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3552] = {
    [sym_union_type] = STATE(4115),
    [sym__type] = STATE(4115),
    [sym_constructor_type] = STATE(4115),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1926),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4115),
    [sym_function_type] = STATE(4115),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1927),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4057),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3553] = {
    [anon_sym_AMP] = ACTIONS(5881),
    [anon_sym_PIPE] = ACTIONS(5883),
    [anon_sym_RBRACK] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
  },
  [3554] = {
    [anon_sym_EQ_GT] = ACTIONS(8491),
    [sym_comment] = ACTIONS(3),
  },
  [3555] = {
    [sym_union_type] = STATE(4117),
    [sym__type] = STATE(4117),
    [sym_constructor_type] = STATE(4117),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1933),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4117),
    [sym_function_type] = STATE(4117),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1934),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4065),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4067),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3556] = {
    [sym_union_type] = STATE(4118),
    [sym__type] = STATE(4118),
    [sym_constructor_type] = STATE(4118),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1933),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4118),
    [sym_function_type] = STATE(4118),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1934),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4065),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4067),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3557] = {
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(5895),
    [anon_sym_PIPE] = ACTIONS(5897),
    [anon_sym_COMMA] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
  },
  [3558] = {
    [anon_sym_RBRACK] = ACTIONS(8493),
    [sym_comment] = ACTIONS(3),
  },
  [3559] = {
    [anon_sym_RBRACK] = ACTIONS(8495),
    [sym_comment] = ACTIONS(3),
  },
  [3560] = {
    [sym_identifier] = ACTIONS(8497),
    [anon_sym_BQUOTE] = ACTIONS(8499),
    [anon_sym_debugger] = ACTIONS(8497),
    [anon_sym_symbol] = ACTIONS(8497),
    [anon_sym_AT] = ACTIONS(8499),
    [anon_sym_PIPE] = ACTIONS(8499),
    [anon_sym_COMMA] = ACTIONS(8499),
    [anon_sym_DASH] = ACTIONS(8497),
    [anon_sym_EQ] = ACTIONS(8497),
    [anon_sym_void] = ACTIONS(8497),
    [anon_sym_break] = ACTIONS(8497),
    [anon_sym_const] = ACTIONS(8497),
    [sym_super] = ACTIONS(8497),
    [anon_sym_return] = ACTIONS(8497),
    [anon_sym_private] = ACTIONS(8497),
    [anon_sym_get] = ACTIONS(8497),
    [anon_sym_RBRACE] = ACTIONS(8499),
    [anon_sym_interface] = ACTIONS(8497),
    [anon_sym_default] = ACTIONS(8497),
    [anon_sym_enum] = ACTIONS(8497),
    [anon_sym_delete] = ACTIONS(8497),
    [anon_sym_continue] = ACTIONS(8497),
    [anon_sym_DASH_DASH] = ACTIONS(8499),
    [anon_sym_if] = ACTIONS(8497),
    [anon_sym_this] = ACTIONS(8497),
    [anon_sym_yield] = ACTIONS(8497),
    [sym_true] = ACTIONS(8497),
    [anon_sym_throw] = ACTIONS(8497),
    [anon_sym_protected] = ACTIONS(8497),
    [anon_sym_abstract] = ACTIONS(8497),
    [anon_sym_set] = ACTIONS(8497),
    [anon_sym_type] = ACTIONS(8497),
    [anon_sym_import] = ACTIONS(8497),
    [anon_sym_namespace] = ACTIONS(8497),
    [anon_sym_PLUS_PLUS] = ACTIONS(8499),
    [anon_sym_await] = ACTIONS(8497),
    [anon_sym_DQUOTE] = ACTIONS(8499),
    [anon_sym_else] = ACTIONS(8497),
    [anon_sym_BANG] = ACTIONS(8499),
    [anon_sym_for] = ACTIONS(8497),
    [anon_sym_LBRACK] = ACTIONS(8499),
    [sym_false] = ACTIONS(8497),
    [anon_sym_SEMI] = ACTIONS(8499),
    [anon_sym_case] = ACTIONS(8497),
    [anon_sym_module] = ACTIONS(8497),
    [anon_sym_number] = ACTIONS(8497),
    [anon_sym_class] = ACTIONS(8497),
    [anon_sym_declare] = ACTIONS(8497),
    [anon_sym_typeof] = ACTIONS(8497),
    [anon_sym_LBRACE] = ACTIONS(8499),
    [anon_sym_switch] = ACTIONS(8497),
    [anon_sym_LPAREN] = ACTIONS(8499),
    [anon_sym_RBRACK] = ACTIONS(8499),
    [sym_null] = ACTIONS(8497),
    [anon_sym_GT] = ACTIONS(8499),
    [anon_sym_any] = ACTIONS(8497),
    [anon_sym_boolean] = ACTIONS(8497),
    [anon_sym_async] = ACTIONS(8497),
    [anon_sym_public] = ACTIONS(8497),
    [anon_sym_EQ_GT] = ACTIONS(8499),
    [anon_sym_AMP] = ACTIONS(8499),
    [anon_sym_var] = ACTIONS(8497),
    [anon_sym_while] = ACTIONS(8497),
    [anon_sym_SQUOTE] = ACTIONS(8499),
    [anon_sym_try] = ACTIONS(8497),
    [anon_sym_RPAREN] = ACTIONS(8499),
    [anon_sym_LT] = ACTIONS(8499),
    [sym_number] = ACTIONS(8499),
    [anon_sym_SLASH] = ACTIONS(8497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8497),
    [anon_sym_function] = ACTIONS(8497),
    [sym_undefined] = ACTIONS(8497),
    [anon_sym_new] = ACTIONS(8497),
    [ts_builtin_sym_end] = ACTIONS(8499),
    [anon_sym_let] = ACTIONS(8497),
    [anon_sym_PLUS] = ACTIONS(8497),
    [anon_sym_export] = ACTIONS(8497),
    [anon_sym_do] = ACTIONS(8497),
    [anon_sym_TILDE] = ACTIONS(8499),
    [anon_sym_with] = ACTIONS(8497),
  },
  [3561] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(2866),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(2866),
    [sym_call_signature] = STATE(2866),
    [sym_export_statement] = STATE(2866),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(2866),
    [sym_index_signature] = STATE(2866),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_RBRACE] = ACTIONS(8501),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8501),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [3562] = {
    [sym__automatic_semicolon] = ACTIONS(7899),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_COMMA] = ACTIONS(7899),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7899),
    [sym_comment] = ACTIONS(3),
  },
  [3563] = {
    [sym_type_parameters] = STATE(1082),
    [sym_formal_parameters] = STATE(1081),
    [sym_call_signature] = STATE(4122),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3564] = {
    [sym_type_parameters] = STATE(1082),
    [sym_formal_parameters] = STATE(1081),
    [sym_call_signature] = STATE(4122),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(8503),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [3565] = {
    [sym_string] = STATE(4124),
    [sym__property_name] = STATE(4124),
    [sym_computed_property_name] = STATE(4124),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(8505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [3566] = {
    [sym_string] = STATE(4124),
    [sym__property_name] = STATE(4124),
    [sym_computed_property_name] = STATE(4124),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(8505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [3567] = {
    [sym_type_parameters] = STATE(1082),
    [sym_type_annotation] = STATE(4125),
    [sym_formal_parameters] = STATE(1081),
    [sym_call_signature] = STATE(4122),
    [sym__automatic_semicolon] = ACTIONS(8507),
    [anon_sym_RBRACE] = ACTIONS(8507),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(8507),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8507),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(8507),
    [sym_comment] = ACTIONS(3),
  },
  [3568] = {
    [sym__automatic_semicolon] = ACTIONS(8507),
    [anon_sym_RBRACE] = ACTIONS(8507),
    [anon_sym_SEMI] = ACTIONS(8507),
    [anon_sym_COMMA] = ACTIONS(8507),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8507),
    [sym_comment] = ACTIONS(3),
  },
  [3569] = {
    [sym__automatic_semicolon] = ACTIONS(8509),
    [anon_sym_RBRACE] = ACTIONS(8509),
    [anon_sym_SEMI] = ACTIONS(8509),
    [anon_sym_COMMA] = ACTIONS(8509),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8509),
    [sym_comment] = ACTIONS(3),
  },
  [3570] = {
    [sym__automatic_semicolon] = ACTIONS(3278),
    [anon_sym_RBRACE] = ACTIONS(3278),
    [anon_sym_SEMI] = ACTIONS(3278),
    [anon_sym_COMMA] = ACTIONS(3278),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3278),
    [sym_comment] = ACTIONS(3),
  },
  [3571] = {
    [aux_sym_variable_declaration_repeat1] = STATE(1048),
    [sym__automatic_semicolon] = ACTIONS(8511),
    [anon_sym_SEMI] = ACTIONS(8511),
    [anon_sym_COMMA] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
  },
  [3572] = {
    [sym_object_type] = STATE(4127),
    [sym_extends_clause] = STATE(4128),
    [anon_sym_extends] = ACTIONS(829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1921),
  },
  [3573] = {
    [sym__automatic_semicolon] = ACTIONS(2427),
    [anon_sym_RBRACE] = ACTIONS(2427),
    [anon_sym_SEMI] = ACTIONS(2427),
    [anon_sym_COMMA] = ACTIONS(2427),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2427),
    [sym_comment] = ACTIONS(3),
  },
  [3574] = {
    [sym_object_type] = STATE(4127),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1921),
  },
  [3575] = {
    [sym__automatic_semicolon] = ACTIONS(5398),
    [anon_sym_RBRACE] = ACTIONS(5398),
    [anon_sym_SEMI] = ACTIONS(5398),
    [anon_sym_COMMA] = ACTIONS(5398),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5398),
    [sym_comment] = ACTIONS(3),
  },
  [3576] = {
    [sym_computed_property_name] = STATE(1172),
    [sym__enum_member] = STATE(4130),
    [sym__property_name] = STATE(1172),
    [sym_string] = STATE(1172),
    [sym_enum_assignment] = STATE(4130),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACE] = ACTIONS(8513),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(2431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_async] = ACTIONS(1230),
  },
  [3577] = {
    [sym__automatic_semicolon] = ACTIONS(2435),
    [anon_sym_RBRACE] = ACTIONS(2435),
    [anon_sym_SEMI] = ACTIONS(2435),
    [anon_sym_COMMA] = ACTIONS(2435),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2435),
    [sym_comment] = ACTIONS(3),
  },
  [3578] = {
    [sym__automatic_semicolon] = ACTIONS(8515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(8515),
  },
  [3579] = {
    [sym_identifier] = ACTIONS(8517),
    [sym_comment] = ACTIONS(3),
  },
  [3580] = {
    [sym__automatic_semicolon] = ACTIONS(2911),
    [anon_sym_RBRACE] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2911),
    [anon_sym_COMMA] = ACTIONS(2911),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
  },
  [3581] = {
    [sym_statement_block] = STATE(1562),
    [sym__automatic_semicolon] = ACTIONS(8519),
    [anon_sym_SEMI] = ACTIONS(8519),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(909),
  },
  [3582] = {
    [sym_enum_body] = STATE(4134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7453),
  },
  [3583] = {
    [sym__automatic_semicolon] = ACTIONS(2179),
    [anon_sym_RBRACE] = ACTIONS(2179),
    [anon_sym_SEMI] = ACTIONS(2179),
    [anon_sym_COMMA] = ACTIONS(2179),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2179),
    [sym_comment] = ACTIONS(3),
  },
  [3584] = {
    [aux_sym_variable_declaration_repeat1] = STATE(1048),
    [sym__automatic_semicolon] = ACTIONS(8521),
    [anon_sym_SEMI] = ACTIONS(8521),
    [anon_sym_COMMA] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
  },
  [3585] = {
    [sym_class_heritage] = STATE(4136),
    [sym_type_parameters] = STATE(4137),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(4138),
    [anon_sym_extends] = ACTIONS(1131),
    [anon_sym_implements] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(322),
  },
  [3586] = {
    [sym_union_type] = STATE(4139),
    [sym__type] = STATE(4139),
    [sym_constructor_type] = STATE(4139),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1198),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4139),
    [sym_function_type] = STATE(4139),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1199),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2475),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3587] = {
    [anon_sym_EQ] = ACTIONS(8523),
    [sym_comment] = ACTIONS(3),
  },
  [3588] = {
    [sym_nested_identifier] = STATE(4141),
    [sym_identifier] = ACTIONS(8525),
    [sym_comment] = ACTIONS(3),
  },
  [3589] = {
    [sym_type_parameters] = STATE(815),
    [sym_formal_parameters] = STATE(816),
    [sym_call_signature] = STATE(4142),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3590] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym__automatic_semicolon] = ACTIONS(8515),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(8515),
    [anon_sym_in] = ACTIONS(3491),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_LT_LT] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_GT_GT_GT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_BANG_EQ] = ACTIONS(3491),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3545),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(3491),
    [anon_sym_instanceof] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3547),
    [anon_sym_STAR_STAR] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_BANG] = ACTIONS(582),
  },
  [3591] = {
    [sym_union_type] = STATE(4146),
    [sym__type] = STATE(4146),
    [sym_constructor_type] = STATE(4146),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4147),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4146),
    [sym_function_type] = STATE(4146),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4148),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5967),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8527),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8529),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3592] = {
    [sym_formal_parameters] = STATE(4149),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3593] = {
    [anon_sym_EQ_GT] = ACTIONS(8533),
    [sym_comment] = ACTIONS(3),
  },
  [3594] = {
    [sym_union_type] = STATE(2790),
    [sym__type] = STATE(2790),
    [sym_constructor_type] = STATE(2790),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2864),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2790),
    [sym_function_type] = STATE(2790),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2865),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5967),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5971),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5973),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3595] = {
    [sym_union_type] = STATE(2791),
    [sym__type] = STATE(2791),
    [sym_constructor_type] = STATE(2791),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2864),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2791),
    [sym_function_type] = STATE(2791),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2865),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5967),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5971),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5973),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3596] = {
    [anon_sym_EQ_GT] = ACTIONS(8535),
    [sym_comment] = ACTIONS(3),
  },
  [3597] = {
    [sym_union_type] = STATE(4152),
    [sym__type] = STATE(4152),
    [sym_constructor_type] = STATE(4152),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2864),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4152),
    [sym_function_type] = STATE(4152),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2865),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5967),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5971),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5973),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3598] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(2866),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(2866),
    [sym_call_signature] = STATE(2866),
    [sym_export_statement] = STATE(2866),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(2866),
    [sym_index_signature] = STATE(2866),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [3599] = {
    [sym_string] = STATE(4124),
    [sym__property_name] = STATE(4124),
    [sym_computed_property_name] = STATE(4124),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(8505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [3600] = {
    [sym_string] = STATE(4124),
    [sym__property_name] = STATE(4124),
    [sym_computed_property_name] = STATE(4124),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(8537),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(8539),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(8505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(8539),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [3601] = {
    [sym_type_parameters] = STATE(1082),
    [sym_type_annotation] = STATE(4125),
    [sym_formal_parameters] = STATE(1081),
    [sym_call_signature] = STATE(4122),
    [sym__automatic_semicolon] = ACTIONS(8507),
    [anon_sym_RBRACE] = ACTIONS(8507),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(8507),
    [anon_sym_QMARK] = ACTIONS(8541),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8507),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(8507),
    [sym_comment] = ACTIONS(3),
  },
  [3602] = {
    [sym_formal_parameters] = STATE(4156),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3603] = {
    [anon_sym_EQ_GT] = ACTIONS(8543),
    [sym_comment] = ACTIONS(3),
  },
  [3604] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2873),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2874),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5983),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5985),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3605] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2873),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2874),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5983),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5985),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3606] = {
    [anon_sym_EQ_GT] = ACTIONS(8545),
    [sym_comment] = ACTIONS(3),
  },
  [3607] = {
    [sym_union_type] = STATE(4159),
    [sym__type] = STATE(4159),
    [sym_constructor_type] = STATE(4159),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2873),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4159),
    [sym_function_type] = STATE(4159),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2874),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5983),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5985),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3608] = {
    [sym_union_type] = STATE(4160),
    [sym__type] = STATE(4160),
    [sym_constructor_type] = STATE(4160),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1089),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4160),
    [sym_function_type] = STATE(4160),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1090),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3609] = {
    [anon_sym_AMP] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_COMMA] = ACTIONS(7511),
    [anon_sym_RBRACK] = ACTIONS(7511),
    [sym_comment] = ACTIONS(3),
  },
  [3610] = {
    [anon_sym_AMP] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_COMMA] = ACTIONS(7529),
    [anon_sym_RBRACK] = ACTIONS(7529),
    [sym_comment] = ACTIONS(3),
  },
  [3611] = {
    [anon_sym_GT] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_COMMA] = ACTIONS(8547),
    [sym_comment] = ACTIONS(3),
  },
  [3612] = {
    [sym_formal_parameters] = STATE(4161),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3613] = {
    [anon_sym_EQ_GT] = ACTIONS(8549),
    [sym_comment] = ACTIONS(3),
  },
  [3614] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2888),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2889),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6001),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6003),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6005),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3615] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2888),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2889),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6001),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6003),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6005),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3616] = {
    [anon_sym_EQ_GT] = ACTIONS(8551),
    [sym_comment] = ACTIONS(3),
  },
  [3617] = {
    [sym_union_type] = STATE(4164),
    [sym__type] = STATE(4164),
    [sym_constructor_type] = STATE(4164),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2888),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4164),
    [sym_function_type] = STATE(4164),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2889),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6001),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6003),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6005),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3618] = {
    [sym_union_type] = STATE(4165),
    [sym__type] = STATE(4165),
    [sym_constructor_type] = STATE(4165),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1108),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4165),
    [sym_function_type] = STATE(4165),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1109),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(2282),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3619] = {
    [anon_sym_AMP] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(4221),
    [sym_comment] = ACTIONS(3),
  },
  [3620] = {
    [anon_sym_AMP] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(4221),
    [sym_comment] = ACTIONS(3),
  },
  [3621] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(7181),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_RPAREN] = ACTIONS(7181),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_in] = ACTIONS(2311),
  },
  [3622] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(7192),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(8553),
    [anon_sym_COMMA] = ACTIONS(5893),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_GT_GT_GT] = ACTIONS(5893),
    [anon_sym_AMP_AMP] = ACTIONS(5893),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_BANG_EQ] = ACTIONS(7192),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(8555),
    [anon_sym_PERCENT] = ACTIONS(5893),
    [anon_sym_QMARK] = ACTIONS(5893),
    [anon_sym_as] = ACTIONS(5893),
    [anon_sym_PIPE_PIPE] = ACTIONS(5893),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_EQ_EQ] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5893),
    [anon_sym_CARET] = ACTIONS(5893),
    [anon_sym_STAR_STAR] = ACTIONS(5893),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_in] = ACTIONS(7192),
  },
  [3623] = {
    [anon_sym_EQ_GT] = ACTIONS(8557),
    [sym_comment] = ACTIONS(3),
  },
  [3624] = {
    [sym_union_type] = STATE(4167),
    [sym__type] = STATE(4167),
    [sym_constructor_type] = STATE(4167),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2038),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4167),
    [sym_function_type] = STATE(4167),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2039),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(4292),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(4298),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(4296),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(4300),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(4294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3625] = {
    [sym_union_type] = STATE(4168),
    [sym__type] = STATE(4168),
    [sym_constructor_type] = STATE(4168),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2038),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4168),
    [sym_function_type] = STATE(4168),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2039),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(4292),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(4298),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(4296),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(4300),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(4294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3626] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_BANG] = ACTIONS(7208),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(8553),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_LT_LT] = ACTIONS(6040),
    [anon_sym_STAR] = ACTIONS(7208),
    [anon_sym_GT_GT_GT] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(6040),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_BANG_EQ] = ACTIONS(7208),
    [anon_sym_LT_EQ] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [anon_sym_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_AMP] = ACTIONS(8555),
    [anon_sym_PERCENT] = ACTIONS(6040),
    [anon_sym_QMARK] = ACTIONS(6040),
    [anon_sym_as] = ACTIONS(6040),
    [anon_sym_PIPE_PIPE] = ACTIONS(6040),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_RPAREN] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_instanceof] = ACTIONS(6040),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6040),
    [anon_sym_CARET] = ACTIONS(6040),
    [anon_sym_STAR_STAR] = ACTIONS(6040),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6040),
    [anon_sym_in] = ACTIONS(7208),
  },
  [3627] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4379),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4381),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_STAR] = ACTIONS(4393),
    [anon_sym_LBRACE] = ACTIONS(5238),
    [anon_sym_AMP_AMP] = ACTIONS(4391),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4379),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(4379),
    [anon_sym_GT] = ACTIONS(4335),
    [anon_sym_AMP] = ACTIONS(4395),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5236),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_PIPE_PIPE] = ACTIONS(4399),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_instanceof] = ACTIONS(4379),
    [anon_sym_LT] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4399),
    [anon_sym_STAR_STAR] = ACTIONS(4405),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_GT_GT] = ACTIONS(4393),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4379),
    [anon_sym_in] = ACTIONS(4335),
  },
  [3628] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4379),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4381),
    [anon_sym_COMMA] = ACTIONS(5240),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_STAR] = ACTIONS(4393),
    [anon_sym_LBRACE] = ACTIONS(5242),
    [anon_sym_AMP_AMP] = ACTIONS(4391),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4379),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(4379),
    [anon_sym_GT] = ACTIONS(4335),
    [anon_sym_AMP] = ACTIONS(4395),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5240),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_PIPE_PIPE] = ACTIONS(4399),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_instanceof] = ACTIONS(4379),
    [anon_sym_LT] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4399),
    [anon_sym_STAR_STAR] = ACTIONS(4405),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_GT_GT] = ACTIONS(4393),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4379),
    [anon_sym_in] = ACTIONS(4335),
  },
  [3629] = {
    [sym_new_expression] = STATE(4169),
    [sym_augmented_assignment_expression] = STATE(4169),
    [sym_unary_expression] = STATE(4169),
    [sym_update_expression] = STATE(4169),
    [sym_call_signature] = STATE(1162),
    [sym_meta_property] = STATE(4169),
    [sym_regex] = STATE(4169),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4169),
    [sym_non_null_expression] = STATE(4169),
    [sym_as_expression] = STATE(4169),
    [sym_jsx_fragment] = STATE(4169),
    [sym_yield_expression] = STATE(4169),
    [sym_jsx_element] = STATE(4169),
    [sym_internal_module] = STATE(4169),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4169),
    [sym_await_expression] = STATE(4169),
    [sym_member_expression] = STATE(1164),
    [sym_string] = STATE(4169),
    [sym_this] = STATE(4169),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1165),
    [sym_anonymous_class] = STATE(4169),
    [sym_generator_function] = STATE(4169),
    [sym_call_expression] = STATE(4169),
    [sym_subscript_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(4169),
    [sym_ternary_expression] = STATE(4169),
    [sym_binary_expression] = STATE(4169),
    [sym_template_string] = STATE(4169),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4169),
    [sym_array] = STATE(1167),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4169),
    [sym_class] = STATE(4169),
    [anon_sym_BANG] = ACTIONS(2397),
    [sym_identifier] = ACTIONS(4341),
    [sym_false] = ACTIONS(8559),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2403),
    [anon_sym_symbol] = ACTIONS(2403),
    [anon_sym_number] = ACTIONS(2403),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2403),
    [anon_sym_typeof] = ACTIONS(2405),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8559),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2403),
    [anon_sym_private] = ACTIONS(2403),
    [anon_sym_boolean] = ACTIONS(2403),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2403),
    [anon_sym_get] = ACTIONS(2403),
    [anon_sym_delete] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8561),
    [sym_true] = ACTIONS(8559),
    [anon_sym_yield] = ACTIONS(2417),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2403),
    [anon_sym_string] = ACTIONS(2403),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8559),
    [anon_sym_set] = ACTIONS(2403),
    [anon_sym_type] = ACTIONS(2403),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2403),
    [anon_sym_export] = ACTIONS(2403),
    [anon_sym_namespace] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2407),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2397),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
  },
  [3630] = {
    [sym_union_type] = STATE(4170),
    [sym__type] = STATE(4170),
    [sym_constructor_type] = STATE(4170),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2928),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4170),
    [sym_function_type] = STATE(4170),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2929),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(6124),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(6130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(6128),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(6132),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(6126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3631] = {
    [sym_formal_parameters] = STATE(4171),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3632] = {
    [anon_sym_EQ_GT] = ACTIONS(8563),
    [sym_comment] = ACTIONS(3),
  },
  [3633] = {
    [sym_union_type] = STATE(3067),
    [sym__type] = STATE(3067),
    [sym_constructor_type] = STATE(3067),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2928),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3067),
    [sym_function_type] = STATE(3067),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2929),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(6124),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(6130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(6128),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(6132),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(6126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3634] = {
    [sym_union_type] = STATE(3068),
    [sym__type] = STATE(3068),
    [sym_constructor_type] = STATE(3068),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2928),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3068),
    [sym_function_type] = STATE(3068),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2929),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(6124),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(6130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(6128),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(6132),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(6126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3635] = {
    [anon_sym_EQ_GT] = ACTIONS(8565),
    [sym_comment] = ACTIONS(3),
  },
  [3636] = {
    [sym_union_type] = STATE(4174),
    [sym__type] = STATE(4174),
    [sym_constructor_type] = STATE(4174),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2928),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4174),
    [sym_function_type] = STATE(4174),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2929),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(6124),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(6130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(6128),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(6132),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(6126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3637] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4327),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4327),
    [anon_sym_AMP_EQ] = ACTIONS(4327),
    [anon_sym_PLUS_EQ] = ACTIONS(4327),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4331),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_CARET_EQ] = ACTIONS(4327),
    [anon_sym_STAR_EQ] = ACTIONS(4327),
    [anon_sym_PIPE_EQ] = ACTIONS(4327),
    [anon_sym_DASH_EQ] = ACTIONS(4327),
    [anon_sym_EQ_GT] = ACTIONS(4333),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4327),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4327),
    [anon_sym_GT_GT_EQ] = ACTIONS(4327),
    [anon_sym_DOT] = ACTIONS(6439),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4327),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4335),
  },
  [3638] = {
    [sym_identifier] = ACTIONS(8567),
    [anon_sym_BQUOTE] = ACTIONS(8569),
    [anon_sym_debugger] = ACTIONS(8567),
    [anon_sym_symbol] = ACTIONS(8567),
    [anon_sym_AT] = ACTIONS(8569),
    [anon_sym_DASH] = ACTIONS(8567),
    [anon_sym_void] = ACTIONS(8567),
    [anon_sym_break] = ACTIONS(8567),
    [anon_sym_const] = ACTIONS(8567),
    [sym_super] = ACTIONS(8567),
    [anon_sym_return] = ACTIONS(8567),
    [anon_sym_private] = ACTIONS(8567),
    [anon_sym_get] = ACTIONS(8567),
    [anon_sym_RBRACE] = ACTIONS(8569),
    [anon_sym_interface] = ACTIONS(8567),
    [anon_sym_default] = ACTIONS(8567),
    [anon_sym_enum] = ACTIONS(8567),
    [anon_sym_delete] = ACTIONS(8567),
    [anon_sym_continue] = ACTIONS(8567),
    [anon_sym_DASH_DASH] = ACTIONS(8569),
    [anon_sym_if] = ACTIONS(8567),
    [anon_sym_this] = ACTIONS(8567),
    [anon_sym_yield] = ACTIONS(8567),
    [sym_true] = ACTIONS(8567),
    [anon_sym_throw] = ACTIONS(8567),
    [anon_sym_protected] = ACTIONS(8567),
    [anon_sym_abstract] = ACTIONS(8567),
    [anon_sym_set] = ACTIONS(8567),
    [anon_sym_type] = ACTIONS(8567),
    [anon_sym_import] = ACTIONS(8567),
    [anon_sym_namespace] = ACTIONS(8567),
    [anon_sym_PLUS_PLUS] = ACTIONS(8569),
    [anon_sym_await] = ACTIONS(8567),
    [anon_sym_DQUOTE] = ACTIONS(8569),
    [anon_sym_else] = ACTIONS(8567),
    [anon_sym_BANG] = ACTIONS(8569),
    [anon_sym_for] = ACTIONS(8567),
    [anon_sym_LBRACK] = ACTIONS(8569),
    [sym_false] = ACTIONS(8567),
    [anon_sym_SEMI] = ACTIONS(8569),
    [anon_sym_case] = ACTIONS(8567),
    [anon_sym_module] = ACTIONS(8567),
    [anon_sym_number] = ACTIONS(8567),
    [anon_sym_class] = ACTIONS(8567),
    [anon_sym_declare] = ACTIONS(8567),
    [anon_sym_typeof] = ACTIONS(8567),
    [anon_sym_LBRACE] = ACTIONS(8569),
    [anon_sym_switch] = ACTIONS(8567),
    [anon_sym_LPAREN] = ACTIONS(8569),
    [sym_null] = ACTIONS(8567),
    [anon_sym_any] = ACTIONS(8567),
    [anon_sym_boolean] = ACTIONS(8567),
    [anon_sym_async] = ACTIONS(8567),
    [anon_sym_public] = ACTIONS(8567),
    [anon_sym_var] = ACTIONS(8567),
    [anon_sym_while] = ACTIONS(8567),
    [anon_sym_SQUOTE] = ACTIONS(8569),
    [anon_sym_try] = ACTIONS(8567),
    [anon_sym_LT] = ACTIONS(8569),
    [sym_number] = ACTIONS(8569),
    [anon_sym_SLASH] = ACTIONS(8567),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8567),
    [anon_sym_function] = ACTIONS(8567),
    [sym_undefined] = ACTIONS(8567),
    [anon_sym_new] = ACTIONS(8567),
    [ts_builtin_sym_end] = ACTIONS(8569),
    [anon_sym_let] = ACTIONS(8567),
    [anon_sym_PLUS] = ACTIONS(8567),
    [anon_sym_export] = ACTIONS(8567),
    [anon_sym_do] = ACTIONS(8567),
    [anon_sym_TILDE] = ACTIONS(8569),
    [anon_sym_with] = ACTIONS(8567),
  },
  [3639] = {
    [sym_computed_property_name] = STATE(1172),
    [sym__enum_member] = STATE(2939),
    [sym__property_name] = STATE(1172),
    [sym_string] = STATE(1172),
    [sym_enum_assignment] = STATE(2939),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(2431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_async] = ACTIONS(1230),
  },
  [3640] = {
    [anon_sym_of] = ACTIONS(8571),
    [sym_comment] = ACTIONS(3),
  },
  [3641] = {
    [anon_sym_of] = ACTIONS(8573),
    [sym_comment] = ACTIONS(3),
  },
  [3642] = {
    [anon_sym_of] = ACTIONS(8575),
    [sym_comment] = ACTIONS(3),
  },
  [3643] = {
    [sym_new_expression] = STATE(4178),
    [sym_augmented_assignment_expression] = STATE(4178),
    [sym_unary_expression] = STATE(4178),
    [sym_update_expression] = STATE(4178),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4178),
    [sym_regex] = STATE(4178),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4178),
    [sym_non_null_expression] = STATE(4178),
    [sym_as_expression] = STATE(4178),
    [sym_jsx_fragment] = STATE(4178),
    [sym_yield_expression] = STATE(4178),
    [sym_jsx_element] = STATE(4178),
    [sym_internal_module] = STATE(4178),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4178),
    [sym_await_expression] = STATE(4178),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4178),
    [sym_this] = STATE(4178),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4178),
    [sym_generator_function] = STATE(4178),
    [sym_call_expression] = STATE(4178),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4178),
    [sym_ternary_expression] = STATE(4178),
    [sym_binary_expression] = STATE(4178),
    [sym_template_string] = STATE(4178),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4178),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4178),
    [sym_class] = STATE(4178),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(8577),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8577),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8579),
    [sym_true] = ACTIONS(8577),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8577),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3644] = {
    [sym_new_expression] = STATE(4179),
    [sym_augmented_assignment_expression] = STATE(4179),
    [sym_unary_expression] = STATE(4179),
    [sym_update_expression] = STATE(4179),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4179),
    [sym_regex] = STATE(4179),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4179),
    [sym_non_null_expression] = STATE(4179),
    [sym_as_expression] = STATE(4179),
    [sym_jsx_fragment] = STATE(4179),
    [sym_yield_expression] = STATE(4179),
    [sym_jsx_element] = STATE(4179),
    [sym_internal_module] = STATE(4179),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4179),
    [sym_await_expression] = STATE(4179),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4179),
    [sym_this] = STATE(4179),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4179),
    [sym_generator_function] = STATE(4179),
    [sym_call_expression] = STATE(4179),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4179),
    [sym_ternary_expression] = STATE(4179),
    [sym_binary_expression] = STATE(4179),
    [sym_template_string] = STATE(4179),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4179),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4179),
    [sym_class] = STATE(4179),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(8581),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8581),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8583),
    [sym_true] = ACTIONS(8581),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8581),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3645] = {
    [sym_new_expression] = STATE(4180),
    [sym_augmented_assignment_expression] = STATE(4180),
    [sym_unary_expression] = STATE(4180),
    [sym_update_expression] = STATE(4180),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4180),
    [sym_regex] = STATE(4180),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4180),
    [sym_non_null_expression] = STATE(4180),
    [sym_as_expression] = STATE(4180),
    [sym_jsx_fragment] = STATE(4180),
    [sym_yield_expression] = STATE(4180),
    [sym_jsx_element] = STATE(4180),
    [sym_internal_module] = STATE(4180),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4180),
    [sym_await_expression] = STATE(4180),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4180),
    [sym_this] = STATE(4180),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4180),
    [sym_generator_function] = STATE(4180),
    [sym_call_expression] = STATE(4180),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4180),
    [sym_ternary_expression] = STATE(4180),
    [sym_binary_expression] = STATE(4180),
    [sym_template_string] = STATE(4180),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4180),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4180),
    [sym_class] = STATE(4180),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(8585),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8585),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8587),
    [sym_true] = ACTIONS(8585),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8585),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3646] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(8589),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3647] = {
    [anon_sym_RPAREN] = ACTIONS(8589),
    [sym_comment] = ACTIONS(3),
  },
  [3648] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(8591),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3649] = {
    [sym_new_expression] = STATE(4183),
    [sym_augmented_assignment_expression] = STATE(4183),
    [sym_unary_expression] = STATE(4183),
    [sym_update_expression] = STATE(4183),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(4183),
    [sym_regex] = STATE(4183),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4183),
    [sym_non_null_expression] = STATE(4183),
    [sym_as_expression] = STATE(4183),
    [sym_jsx_fragment] = STATE(4183),
    [sym_yield_expression] = STATE(4183),
    [sym_jsx_element] = STATE(4183),
    [sym_internal_module] = STATE(4183),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4183),
    [sym_await_expression] = STATE(4183),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(4184),
    [sym_string] = STATE(4183),
    [sym_this] = STATE(4183),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(4183),
    [sym_generator_function] = STATE(4183),
    [sym_call_expression] = STATE(4183),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(4183),
    [sym_ternary_expression] = STATE(4183),
    [sym_binary_expression] = STATE(4183),
    [sym_template_string] = STATE(4183),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4183),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4183),
    [sym_class] = STATE(4183),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(8593),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8593),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8595),
    [sym_true] = ACTIONS(8593),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8593),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [3650] = {
    [sym_new_expression] = STATE(4185),
    [sym_augmented_assignment_expression] = STATE(4185),
    [sym_unary_expression] = STATE(4185),
    [sym_update_expression] = STATE(4185),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(4185),
    [sym_regex] = STATE(4185),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4185),
    [sym_non_null_expression] = STATE(4185),
    [sym_as_expression] = STATE(4185),
    [sym_jsx_fragment] = STATE(4185),
    [sym_yield_expression] = STATE(4185),
    [sym_jsx_element] = STATE(4185),
    [sym_internal_module] = STATE(4185),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4185),
    [sym_await_expression] = STATE(4185),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(4186),
    [sym_string] = STATE(4185),
    [sym_this] = STATE(4185),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(4185),
    [sym_generator_function] = STATE(4185),
    [sym_call_expression] = STATE(4185),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(4185),
    [sym_ternary_expression] = STATE(4185),
    [sym_binary_expression] = STATE(4185),
    [sym_template_string] = STATE(4185),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4185),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4185),
    [sym_class] = STATE(4185),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(8597),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8597),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8599),
    [sym_true] = ACTIONS(8597),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8597),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [3651] = {
    [sym_new_expression] = STATE(4187),
    [sym_augmented_assignment_expression] = STATE(4187),
    [sym_unary_expression] = STATE(4187),
    [sym_update_expression] = STATE(4187),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(4187),
    [sym_regex] = STATE(4187),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4187),
    [sym_non_null_expression] = STATE(4187),
    [sym_as_expression] = STATE(4187),
    [sym_jsx_fragment] = STATE(4187),
    [sym_yield_expression] = STATE(4187),
    [sym_jsx_element] = STATE(4187),
    [sym_internal_module] = STATE(4187),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4187),
    [sym_await_expression] = STATE(4187),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(4188),
    [sym_string] = STATE(4187),
    [sym_this] = STATE(4187),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(4187),
    [sym_generator_function] = STATE(4187),
    [sym_call_expression] = STATE(4187),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(4187),
    [sym_ternary_expression] = STATE(4187),
    [sym_binary_expression] = STATE(4187),
    [sym_template_string] = STATE(4187),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4187),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4187),
    [sym_class] = STATE(4187),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(8601),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8601),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8603),
    [sym_true] = ACTIONS(8601),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8601),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [3652] = {
    [sym_type_alias_declaration] = STATE(3041),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3041),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3041),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3041),
    [sym_return_statement] = STATE(3041),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3041),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3041),
    [sym_switch_statement] = STATE(3041),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3041),
    [sym_throw_statement] = STATE(3041),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3041),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3041),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(3041),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3041),
    [sym_abstract_class] = STATE(3041),
    [sym_interface_declaration] = STATE(3041),
    [sym_statement_block] = STATE(3041),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3041),
    [sym_debugger_statement] = STATE(3041),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3041),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3041),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3041),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3041),
    [sym_empty_statement] = STATE(3041),
    [sym_import_alias] = STATE(3041),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3041),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3041),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3041),
    [sym_break_statement] = STATE(3041),
    [sym_labeled_statement] = STATE(3041),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3041),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [3653] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(8605),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3654] = {
    [anon_sym_RPAREN] = ACTIONS(8605),
    [sym_comment] = ACTIONS(3),
  },
  [3655] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(8607),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3656] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(8609),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3657] = {
    [anon_sym_RPAREN] = ACTIONS(8609),
    [sym_comment] = ACTIONS(3),
  },
  [3658] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(8611),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3659] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(8613),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3660] = {
    [anon_sym_RPAREN] = ACTIONS(8613),
    [sym_comment] = ACTIONS(3),
  },
  [3661] = {
    [sym_union_type] = STATE(4199),
    [sym__type] = STATE(4199),
    [sym_constructor_type] = STATE(4199),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4200),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4199),
    [sym_function_type] = STATE(4199),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4201),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8615),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8619),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8621),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3662] = {
    [sym_formal_parameters] = STATE(4202),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3663] = {
    [anon_sym_EQ_GT] = ACTIONS(8625),
    [sym_comment] = ACTIONS(3),
  },
  [3664] = {
    [sym_union_type] = STATE(2790),
    [sym__type] = STATE(2790),
    [sym_constructor_type] = STATE(2790),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2964),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2790),
    [sym_function_type] = STATE(2790),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2965),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(6198),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(6202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3665] = {
    [sym_union_type] = STATE(2791),
    [sym__type] = STATE(2791),
    [sym_constructor_type] = STATE(2791),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2964),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2791),
    [sym_function_type] = STATE(2791),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2965),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(6198),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(6202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3666] = {
    [anon_sym_EQ_GT] = ACTIONS(8627),
    [sym_comment] = ACTIONS(3),
  },
  [3667] = {
    [sym_union_type] = STATE(4205),
    [sym__type] = STATE(4205),
    [sym_constructor_type] = STATE(4205),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2964),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4205),
    [sym_function_type] = STATE(4205),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2965),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(6198),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(6202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3668] = {
    [sym_union_type] = STATE(4206),
    [sym__type] = STATE(4206),
    [sym_constructor_type] = STATE(4206),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1198),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4206),
    [sym_function_type] = STATE(4206),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1199),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2475),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3669] = {
    [sym__automatic_semicolon] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_PIPE] = ACTIONS(4447),
    [anon_sym_SEMI] = ACTIONS(7511),
    [sym_comment] = ACTIONS(3),
  },
  [3670] = {
    [sym__automatic_semicolon] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_PIPE] = ACTIONS(4447),
    [anon_sym_SEMI] = ACTIONS(7529),
    [sym_comment] = ACTIONS(3),
  },
  [3671] = {
    [sym__automatic_semicolon] = ACTIONS(8629),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(8629),
  },
  [3672] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(8631),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3673] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(8633),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3674] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(8635),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3675] = {
    [sym_type_alias_declaration] = STATE(4210),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4210),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4210),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4210),
    [sym_return_statement] = STATE(4210),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4210),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4210),
    [sym_switch_statement] = STATE(4210),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4210),
    [sym_throw_statement] = STATE(4210),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4210),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4210),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(4210),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4210),
    [sym_abstract_class] = STATE(4210),
    [sym_interface_declaration] = STATE(4210),
    [sym_statement_block] = STATE(4210),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4210),
    [sym_debugger_statement] = STATE(4210),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4210),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4210),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4210),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4210),
    [sym_empty_statement] = STATE(4210),
    [sym_import_alias] = STATE(4210),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4210),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4210),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4210),
    [sym_break_statement] = STATE(4210),
    [sym_labeled_statement] = STATE(4210),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4210),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3676] = {
    [sym_type_alias_declaration] = STATE(4211),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4211),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4211),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4211),
    [sym_return_statement] = STATE(4211),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4211),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4211),
    [sym_switch_statement] = STATE(4211),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4211),
    [sym_throw_statement] = STATE(4211),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4211),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4211),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(4211),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4211),
    [sym_abstract_class] = STATE(4211),
    [sym_interface_declaration] = STATE(4211),
    [sym_statement_block] = STATE(4211),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4211),
    [sym_debugger_statement] = STATE(4211),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4211),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4211),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4211),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4211),
    [sym_empty_statement] = STATE(4211),
    [sym_import_alias] = STATE(4211),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4211),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4211),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4211),
    [sym_break_statement] = STATE(4211),
    [sym_labeled_statement] = STATE(4211),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4211),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3677] = {
    [sym_type_alias_declaration] = STATE(4212),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4212),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4212),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4212),
    [sym_return_statement] = STATE(4212),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4212),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4212),
    [sym_switch_statement] = STATE(4212),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4212),
    [sym_throw_statement] = STATE(4212),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4212),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4212),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(4212),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4212),
    [sym_abstract_class] = STATE(4212),
    [sym_interface_declaration] = STATE(4212),
    [sym_statement_block] = STATE(4212),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4212),
    [sym_debugger_statement] = STATE(4212),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4212),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4212),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4212),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4212),
    [sym_empty_statement] = STATE(4212),
    [sym_import_alias] = STATE(4212),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4212),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4212),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4212),
    [sym_break_statement] = STATE(4212),
    [sym_labeled_statement] = STATE(4212),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4212),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3678] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7695),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1995),
    [anon_sym_PIPE] = ACTIONS(7697),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(7699),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6261),
    [anon_sym_LT_EQ] = ACTIONS(7695),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7695),
    [anon_sym_GT] = ACTIONS(6261),
    [anon_sym_AMP] = ACTIONS(7701),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(7703),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(7705),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(6261),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_instanceof] = ACTIONS(7695),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(7705),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7695),
    [anon_sym_in] = ACTIONS(6261),
  },
  [3679] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3680] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7695),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(2003),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(7697),
    [anon_sym_COMMA] = ACTIONS(2003),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(7699),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6261),
    [anon_sym_LT_EQ] = ACTIONS(7695),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7695),
    [anon_sym_GT] = ACTIONS(6261),
    [anon_sym_AMP] = ACTIONS(7701),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(7703),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(7705),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(6261),
    [anon_sym_RPAREN] = ACTIONS(2003),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_instanceof] = ACTIONS(7695),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(7705),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7695),
    [anon_sym_in] = ACTIONS(6261),
  },
  [3681] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7695),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(2005),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2005),
    [anon_sym_PIPE] = ACTIONS(7697),
    [anon_sym_COMMA] = ACTIONS(2005),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(7699),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6261),
    [anon_sym_LT_EQ] = ACTIONS(7695),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7695),
    [anon_sym_GT] = ACTIONS(6261),
    [anon_sym_AMP] = ACTIONS(7701),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(7703),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(7705),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(6261),
    [anon_sym_RPAREN] = ACTIONS(2005),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_instanceof] = ACTIONS(7695),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(7705),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7695),
    [anon_sym_in] = ACTIONS(6261),
  },
  [3682] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7695),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(2101),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2101),
    [anon_sym_PIPE] = ACTIONS(7697),
    [anon_sym_COMMA] = ACTIONS(2101),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(7699),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6261),
    [anon_sym_LT_EQ] = ACTIONS(7695),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7695),
    [anon_sym_GT] = ACTIONS(6261),
    [anon_sym_AMP] = ACTIONS(7701),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(7703),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(7705),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(6261),
    [anon_sym_RPAREN] = ACTIONS(2101),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_instanceof] = ACTIONS(7695),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(7705),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7695),
    [anon_sym_in] = ACTIONS(6261),
  },
  [3683] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7695),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(2105),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2105),
    [anon_sym_PIPE] = ACTIONS(7697),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(7699),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6261),
    [anon_sym_LT_EQ] = ACTIONS(7695),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7695),
    [anon_sym_GT] = ACTIONS(6261),
    [anon_sym_AMP] = ACTIONS(7701),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(7703),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(7705),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(6261),
    [anon_sym_RPAREN] = ACTIONS(2105),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_instanceof] = ACTIONS(7695),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(7705),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7695),
    [anon_sym_in] = ACTIONS(6261),
  },
  [3684] = {
    [sym_new_expression] = STATE(4213),
    [sym_augmented_assignment_expression] = STATE(4213),
    [sym_unary_expression] = STATE(4213),
    [sym_update_expression] = STATE(4213),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(4213),
    [sym_regex] = STATE(4213),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1556),
    [sym__expression] = STATE(4213),
    [sym_non_null_expression] = STATE(4213),
    [sym_yield_expression] = STATE(4213),
    [sym_jsx_fragment] = STATE(4213),
    [sym_jsx_element] = STATE(4213),
    [sym_as_expression] = STATE(4213),
    [sym_internal_module] = STATE(4213),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4213),
    [sym_await_expression] = STATE(4213),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(4213),
    [sym_this] = STATE(4213),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(4213),
    [sym_generator_function] = STATE(4213),
    [sym_call_expression] = STATE(4213),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(4213),
    [sym_ternary_expression] = STATE(4213),
    [sym_binary_expression] = STATE(4213),
    [sym_template_string] = STATE(4213),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4213),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(4213),
    [sym_class] = STATE(4213),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(8637),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(8637),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(8639),
    [sym_true] = ACTIONS(8637),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(8637),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [3685] = {
    [sym_new_expression] = STATE(4214),
    [sym_augmented_assignment_expression] = STATE(4214),
    [sym_unary_expression] = STATE(4214),
    [sym_update_expression] = STATE(4214),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(4214),
    [sym_regex] = STATE(4214),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(1558),
    [sym__expression] = STATE(4214),
    [sym_non_null_expression] = STATE(4214),
    [sym_yield_expression] = STATE(4214),
    [sym_jsx_fragment] = STATE(4214),
    [sym_jsx_element] = STATE(4214),
    [sym_as_expression] = STATE(4214),
    [sym_internal_module] = STATE(4214),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4214),
    [sym_await_expression] = STATE(4214),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(4214),
    [sym_this] = STATE(4214),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(4214),
    [sym_generator_function] = STATE(4214),
    [sym_call_expression] = STATE(4214),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(4214),
    [sym_ternary_expression] = STATE(4214),
    [sym_binary_expression] = STATE(4214),
    [sym_template_string] = STATE(4214),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4214),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(4214),
    [sym_class] = STATE(4214),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(8641),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(594),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(8641),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(8643),
    [sym_true] = ACTIONS(8641),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(8641),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [3686] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7695),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(7699),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6261),
    [anon_sym_LT_EQ] = ACTIONS(7695),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7695),
    [anon_sym_GT] = ACTIONS(6261),
    [anon_sym_AMP] = ACTIONS(7701),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(6261),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_instanceof] = ACTIONS(7695),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7695),
    [anon_sym_in] = ACTIONS(6261),
  },
  [3687] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(8645),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3688] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(8645),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3689] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7695),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6261),
    [anon_sym_LT_EQ] = ACTIONS(7695),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7695),
    [anon_sym_GT] = ACTIONS(6261),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(6261),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_instanceof] = ACTIONS(7695),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7695),
    [anon_sym_in] = ACTIONS(6261),
  },
  [3690] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3630),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(8648),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3691] = {
    [sym_type_arguments] = STATE(1759),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(3696),
    [anon_sym_BANG] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [sym__automatic_semicolon] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_GT_GT_GT] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_is] = ACTIONS(8650),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_RPAREN] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_instanceof] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_STAR_STAR] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2204),
    [anon_sym_in] = ACTIONS(3699),
  },
  [3692] = {
    [sym_index_type_query] = STATE(1761),
    [sym_lookup_type] = STATE(1761),
    [sym_flow_maybe_type] = STATE(1761),
    [sym_parenthesized_type] = STATE(1761),
    [sym_nested_type_identifier] = STATE(942),
    [sym_array_type] = STATE(1761),
    [sym_type_predicate] = STATE(1761),
    [sym_type_query] = STATE(1761),
    [sym_existential_type] = STATE(1761),
    [sym_this_type] = STATE(1761),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(1761),
    [sym__primary_type] = STATE(1761),
    [sym_generic_type] = STATE(1761),
    [sym_literal_type] = STATE(1761),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(1761),
    [sym_string] = STATE(927),
    [sym_tuple_type] = STATE(1761),
    [sym_identifier] = ACTIONS(7727),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(7733),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [sym_true] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(3708),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [3693] = {
    [sym_union_type] = STATE(1766),
    [sym__type] = STATE(1766),
    [sym_constructor_type] = STATE(1766),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(3696),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(1766),
    [sym_function_type] = STATE(1766),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(3697),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(7727),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(7733),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(7731),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(7735),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(7729),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [3694] = {
    [sym_type_parameters] = STATE(4217),
    [sym_formal_parameters] = STATE(4218),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3695] = {
    [sym_union_type] = STATE(1774),
    [sym__type] = STATE(1774),
    [sym_constructor_type] = STATE(1774),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(3696),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(1774),
    [sym_function_type] = STATE(1774),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(3697),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(7727),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(7733),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(7731),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(7735),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(7729),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [3696] = {
    [sym_formal_parameters] = STATE(4221),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3697] = {
    [anon_sym_EQ_GT] = ACTIONS(8652),
    [sym_comment] = ACTIONS(3),
  },
  [3698] = {
    [sym__initializer] = STATE(71),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6255),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6255),
    [anon_sym_AMP_EQ] = ACTIONS(6255),
    [anon_sym_PLUS_EQ] = ACTIONS(6255),
    [anon_sym_PIPE] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(3738),
    [anon_sym_CARET_EQ] = ACTIONS(6255),
    [anon_sym_STAR_EQ] = ACTIONS(6255),
    [anon_sym_PIPE_EQ] = ACTIONS(6255),
    [anon_sym_DASH_EQ] = ACTIONS(6255),
    [anon_sym_EQ_GT] = ACTIONS(6259),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6255),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6255),
    [anon_sym_GT_GT_EQ] = ACTIONS(6255),
    [anon_sym_DOT] = ACTIONS(3747),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6255),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6261),
  },
  [3699] = {
    [sym__initializer] = STATE(79),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6263),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6263),
    [anon_sym_AMP_EQ] = ACTIONS(6263),
    [anon_sym_PLUS_EQ] = ACTIONS(6263),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_CARET_EQ] = ACTIONS(6263),
    [anon_sym_STAR_EQ] = ACTIONS(6263),
    [anon_sym_PIPE_EQ] = ACTIONS(6263),
    [anon_sym_DASH_EQ] = ACTIONS(6263),
    [anon_sym_EQ_GT] = ACTIONS(6265),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6263),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6263),
    [anon_sym_GT_GT_EQ] = ACTIONS(6263),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6263),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3700] = {
    [sym_new_expression] = STATE(2987),
    [sym_augmented_assignment_expression] = STATE(2987),
    [sym_unary_expression] = STATE(2987),
    [sym_update_expression] = STATE(2987),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(2987),
    [sym_regex] = STATE(2987),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2987),
    [sym_non_null_expression] = STATE(2987),
    [sym_as_expression] = STATE(2987),
    [sym_jsx_fragment] = STATE(2987),
    [sym_yield_expression] = STATE(2987),
    [sym_jsx_element] = STATE(2987),
    [sym_internal_module] = STATE(2987),
    [sym_nested_identifier] = STATE(1092),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2987),
    [sym_await_expression] = STATE(2987),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(2987),
    [sym_this] = STATE(2987),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(2987),
    [sym_generator_function] = STATE(2987),
    [sym_call_expression] = STATE(2987),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(2987),
    [sym_ternary_expression] = STATE(2987),
    [sym_binary_expression] = STATE(2987),
    [sym_template_string] = STATE(2987),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2987),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2987),
    [sym_class] = STATE(2987),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(8654),
    [sym_false] = ACTIONS(6267),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6267),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(6269),
    [sym_true] = ACTIONS(6267),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6267),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [3701] = {
    [sym_new_expression] = STATE(2988),
    [sym_augmented_assignment_expression] = STATE(2988),
    [sym_unary_expression] = STATE(2988),
    [sym_update_expression] = STATE(2988),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(2988),
    [sym_regex] = STATE(2988),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2988),
    [sym_non_null_expression] = STATE(2988),
    [sym_as_expression] = STATE(2988),
    [sym_jsx_fragment] = STATE(2988),
    [sym_yield_expression] = STATE(2988),
    [sym_jsx_element] = STATE(2988),
    [sym_internal_module] = STATE(2988),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2988),
    [sym_await_expression] = STATE(2988),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(2988),
    [sym_this] = STATE(2988),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(2988),
    [sym_generator_function] = STATE(2988),
    [sym_call_expression] = STATE(2988),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(2988),
    [sym_ternary_expression] = STATE(2988),
    [sym_binary_expression] = STATE(2988),
    [sym_template_string] = STATE(2988),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2988),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2988),
    [sym_class] = STATE(2988),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(6271),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6271),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3781),
    [sym_true] = ACTIONS(6271),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6271),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [3702] = {
    [sym_new_expression] = STATE(2987),
    [sym_augmented_assignment_expression] = STATE(2987),
    [sym__initializer] = STATE(79),
    [sym_unary_expression] = STATE(2987),
    [sym_update_expression] = STATE(2987),
    [sym_regex] = STATE(2987),
    [sym_meta_property] = STATE(2987),
    [sym_call_signature] = STATE(2132),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(2987),
    [sym_non_null_expression] = STATE(2987),
    [sym_yield_expression] = STATE(2987),
    [sym_jsx_fragment] = STATE(2987),
    [sym_jsx_element] = STATE(2987),
    [sym_as_expression] = STATE(2987),
    [sym_internal_module] = STATE(2987),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(2987),
    [sym_await_expression] = STATE(2987),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(2987),
    [sym_this] = STATE(2987),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(2987),
    [sym_generator_function] = STATE(2987),
    [sym_call_expression] = STATE(2987),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(2987),
    [sym_ternary_expression] = STATE(2987),
    [sym_binary_expression] = STATE(2987),
    [sym_template_string] = STATE(2987),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(2987),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(2987),
    [sym_class] = STATE(2987),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4499),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(6263),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_AMP_EQ] = ACTIONS(6263),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(6263),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(6263),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_PIPE_EQ] = ACTIONS(6263),
    [anon_sym_DASH_EQ] = ACTIONS(6263),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(6263),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(4517),
    [sym_true] = ACTIONS(6267),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_GT_GT_EQ] = ACTIONS(6263),
    [anon_sym_DOT] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6263),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(4505),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(6267),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6263),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(6267),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_STAR_EQ] = ACTIONS(6263),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_EQ_GT] = ACTIONS(6265),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(165),
    [sym_number] = ACTIONS(6269),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6263),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(6267),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3703] = {
    [sym_new_expression] = STATE(277),
    [sym_augmented_assignment_expression] = STATE(289),
    [sym_unary_expression] = STATE(289),
    [sym_update_expression] = STATE(289),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(277),
    [sym_regex] = STATE(277),
    [sym_type_parameters] = STATE(1819),
    [sym__expression] = STATE(289),
    [sym_non_null_expression] = STATE(289),
    [sym_as_expression] = STATE(289),
    [sym_jsx_fragment] = STATE(289),
    [sym_yield_expression] = STATE(289),
    [sym_jsx_element] = STATE(289),
    [sym_internal_module] = STATE(289),
    [sym_function] = STATE(290),
    [sym_arrow_function] = STATE(277),
    [sym_await_expression] = STATE(289),
    [sym_member_expression] = STATE(291),
    [sym_string] = STATE(277),
    [sym_this] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(292),
    [sym_anonymous_class] = STATE(277),
    [sym_generator_function] = STATE(277),
    [sym_call_expression] = STATE(289),
    [sym_subscript_expression] = STATE(291),
    [sym_assignment_expression] = STATE(289),
    [sym_ternary_expression] = STATE(289),
    [sym_binary_expression] = STATE(289),
    [sym_template_string] = STATE(277),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(1820),
    [sym_parenthesized_expression] = STATE(277),
    [sym_array] = STATE(293),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(289),
    [sym_class] = STATE(277),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(6287),
    [sym_false] = ACTIONS(482),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(6289),
    [anon_sym_symbol] = ACTIONS(6289),
    [anon_sym_number] = ACTIONS(6289),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6289),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(482),
    [sym_super] = ACTIONS(494),
    [anon_sym_any] = ACTIONS(6289),
    [anon_sym_private] = ACTIONS(6289),
    [anon_sym_boolean] = ACTIONS(6289),
    [anon_sym_async] = ACTIONS(6293),
    [anon_sym_public] = ACTIONS(6289),
    [anon_sym_get] = ACTIONS(6289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(498),
    [sym_true] = ACTIONS(482),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(6289),
    [anon_sym_string] = ACTIONS(6289),
    [anon_sym_function] = ACTIONS(159),
    [anon_sym_DOT] = ACTIONS(502),
    [sym_undefined] = ACTIONS(482),
    [anon_sym_set] = ACTIONS(6289),
    [anon_sym_type] = ACTIONS(6289),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(6289),
    [anon_sym_export] = ACTIONS(6289),
    [anon_sym_namespace] = ACTIONS(6295),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [3704] = {
    [sym_identifier] = ACTIONS(8656),
    [anon_sym_BQUOTE] = ACTIONS(8658),
    [anon_sym_debugger] = ACTIONS(8656),
    [anon_sym_symbol] = ACTIONS(8656),
    [anon_sym_AT] = ACTIONS(8658),
    [anon_sym_DASH] = ACTIONS(8656),
    [anon_sym_void] = ACTIONS(8656),
    [anon_sym_break] = ACTIONS(8656),
    [anon_sym_const] = ACTIONS(8656),
    [sym_super] = ACTIONS(8656),
    [anon_sym_return] = ACTIONS(8656),
    [anon_sym_private] = ACTIONS(8656),
    [anon_sym_get] = ACTIONS(8656),
    [anon_sym_RBRACE] = ACTIONS(8658),
    [anon_sym_interface] = ACTIONS(8656),
    [anon_sym_default] = ACTIONS(8656),
    [anon_sym_enum] = ACTIONS(8656),
    [anon_sym_delete] = ACTIONS(8656),
    [anon_sym_continue] = ACTIONS(8656),
    [anon_sym_DASH_DASH] = ACTIONS(8658),
    [anon_sym_if] = ACTIONS(8656),
    [anon_sym_this] = ACTIONS(8656),
    [anon_sym_yield] = ACTIONS(8656),
    [sym_true] = ACTIONS(8656),
    [anon_sym_throw] = ACTIONS(8656),
    [anon_sym_protected] = ACTIONS(8656),
    [anon_sym_abstract] = ACTIONS(8656),
    [anon_sym_set] = ACTIONS(8656),
    [anon_sym_type] = ACTIONS(8656),
    [anon_sym_import] = ACTIONS(8656),
    [anon_sym_namespace] = ACTIONS(8656),
    [anon_sym_PLUS_PLUS] = ACTIONS(8658),
    [anon_sym_await] = ACTIONS(8656),
    [anon_sym_DQUOTE] = ACTIONS(8658),
    [anon_sym_else] = ACTIONS(8656),
    [anon_sym_BANG] = ACTIONS(8658),
    [anon_sym_for] = ACTIONS(8656),
    [anon_sym_LBRACK] = ACTIONS(8658),
    [sym_false] = ACTIONS(8656),
    [anon_sym_SEMI] = ACTIONS(8658),
    [anon_sym_case] = ACTIONS(8656),
    [anon_sym_module] = ACTIONS(8656),
    [anon_sym_number] = ACTIONS(8656),
    [anon_sym_class] = ACTIONS(8656),
    [anon_sym_declare] = ACTIONS(8656),
    [anon_sym_typeof] = ACTIONS(8656),
    [anon_sym_LBRACE] = ACTIONS(8658),
    [anon_sym_switch] = ACTIONS(8656),
    [anon_sym_LPAREN] = ACTIONS(8658),
    [sym_null] = ACTIONS(8656),
    [anon_sym_any] = ACTIONS(8656),
    [anon_sym_boolean] = ACTIONS(8656),
    [anon_sym_async] = ACTIONS(8656),
    [anon_sym_public] = ACTIONS(8656),
    [anon_sym_var] = ACTIONS(8656),
    [anon_sym_while] = ACTIONS(8656),
    [anon_sym_SQUOTE] = ACTIONS(8658),
    [anon_sym_try] = ACTIONS(8656),
    [anon_sym_LT] = ACTIONS(8658),
    [sym_number] = ACTIONS(8658),
    [anon_sym_SLASH] = ACTIONS(8656),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8656),
    [anon_sym_function] = ACTIONS(8656),
    [sym_undefined] = ACTIONS(8656),
    [anon_sym_new] = ACTIONS(8656),
    [ts_builtin_sym_end] = ACTIONS(8658),
    [anon_sym_let] = ACTIONS(8656),
    [anon_sym_PLUS] = ACTIONS(8656),
    [anon_sym_export] = ACTIONS(8656),
    [anon_sym_do] = ACTIONS(8656),
    [anon_sym_TILDE] = ACTIONS(8658),
    [anon_sym_with] = ACTIONS(8656),
  },
  [3705] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(8645),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3706] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_RPAREN] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_in] = ACTIONS(6321),
  },
  [3707] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3708] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_RPAREN] = ACTIONS(2003),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_in] = ACTIONS(6321),
  },
  [3709] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_RPAREN] = ACTIONS(2005),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_in] = ACTIONS(6321),
  },
  [3710] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_RPAREN] = ACTIONS(2101),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_in] = ACTIONS(6321),
  },
  [3711] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_RPAREN] = ACTIONS(2105),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_in] = ACTIONS(6321),
  },
  [3712] = {
    [sym_new_expression] = STATE(4224),
    [sym_augmented_assignment_expression] = STATE(4224),
    [sym_unary_expression] = STATE(4224),
    [sym_update_expression] = STATE(4224),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4224),
    [sym_regex] = STATE(4224),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2185),
    [sym__expression] = STATE(4224),
    [sym_non_null_expression] = STATE(4224),
    [sym_yield_expression] = STATE(4224),
    [sym_jsx_fragment] = STATE(4224),
    [sym_jsx_element] = STATE(4224),
    [sym_as_expression] = STATE(4224),
    [sym_internal_module] = STATE(4224),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4224),
    [sym_await_expression] = STATE(4224),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4224),
    [sym_this] = STATE(4224),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4224),
    [sym_generator_function] = STATE(4224),
    [sym_call_expression] = STATE(4224),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4224),
    [sym_ternary_expression] = STATE(4224),
    [sym_binary_expression] = STATE(4224),
    [sym_template_string] = STATE(4224),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4224),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4224),
    [sym_class] = STATE(4224),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(8660),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8660),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8662),
    [sym_true] = ACTIONS(8660),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8660),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3713] = {
    [sym_new_expression] = STATE(4225),
    [sym_augmented_assignment_expression] = STATE(4225),
    [sym_unary_expression] = STATE(4225),
    [sym_update_expression] = STATE(4225),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4225),
    [sym_regex] = STATE(4225),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2187),
    [sym__expression] = STATE(4225),
    [sym_non_null_expression] = STATE(4225),
    [sym_yield_expression] = STATE(4225),
    [sym_jsx_fragment] = STATE(4225),
    [sym_jsx_element] = STATE(4225),
    [sym_as_expression] = STATE(4225),
    [sym_internal_module] = STATE(4225),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4225),
    [sym_await_expression] = STATE(4225),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4225),
    [sym_this] = STATE(4225),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4225),
    [sym_generator_function] = STATE(4225),
    [sym_call_expression] = STATE(4225),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4225),
    [sym_ternary_expression] = STATE(4225),
    [sym_binary_expression] = STATE(4225),
    [sym_template_string] = STATE(4225),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4225),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4225),
    [sym_class] = STATE(4225),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(8664),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8664),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8666),
    [sym_true] = ACTIONS(8664),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8664),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3714] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_in] = ACTIONS(6321),
  },
  [3715] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(8668),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3716] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(8668),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3717] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_in] = ACTIONS(6321),
  },
  [3718] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3630),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(8671),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3719] = {
    [sym_type_arguments] = STATE(2206),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(4638),
    [anon_sym_BANG] = ACTIONS(3699),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(3699),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_GT_GT_GT] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(8673),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_RPAREN] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(4643),
    [anon_sym_instanceof] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4646),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_STAR_STAR] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2204),
    [anon_sym_in] = ACTIONS(3699),
  },
  [3720] = {
    [sym_index_type_query] = STATE(2208),
    [sym_lookup_type] = STATE(2208),
    [sym_flow_maybe_type] = STATE(2208),
    [sym_parenthesized_type] = STATE(2208),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_array_type] = STATE(2208),
    [sym_type_predicate] = STATE(2208),
    [sym_type_query] = STATE(2208),
    [sym_existential_type] = STATE(2208),
    [sym_this_type] = STATE(2208),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(2208),
    [sym__primary_type] = STATE(2208),
    [sym_generic_type] = STATE(2208),
    [sym_literal_type] = STATE(2208),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(2208),
    [sym_string] = STATE(1279),
    [sym_tuple_type] = STATE(2208),
    [sym_identifier] = ACTIONS(7804),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(7810),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [sym_true] = ACTIONS(2643),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(4648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3721] = {
    [sym_union_type] = STATE(2213),
    [sym__type] = STATE(2213),
    [sym_constructor_type] = STATE(2213),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3724),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2213),
    [sym_function_type] = STATE(2213),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3725),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(7804),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(7810),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(7808),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(7812),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(7806),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3722] = {
    [sym_type_parameters] = STATE(4228),
    [sym_formal_parameters] = STATE(4229),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3723] = {
    [sym_union_type] = STATE(2221),
    [sym__type] = STATE(2221),
    [sym_constructor_type] = STATE(2221),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3724),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2221),
    [sym_function_type] = STATE(2221),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3725),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(7804),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(7810),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(7808),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(7812),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(7806),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3724] = {
    [sym_formal_parameters] = STATE(4232),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3725] = {
    [anon_sym_EQ_GT] = ACTIONS(8675),
    [sym_comment] = ACTIONS(3),
  },
  [3726] = {
    [sym__initializer] = STATE(522),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6315),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6315),
    [anon_sym_AMP_EQ] = ACTIONS(6315),
    [anon_sym_PLUS_EQ] = ACTIONS(6315),
    [anon_sym_PIPE] = ACTIONS(3738),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(6317),
    [anon_sym_GT] = ACTIONS(3738),
    [anon_sym_CARET_EQ] = ACTIONS(6315),
    [anon_sym_STAR_EQ] = ACTIONS(6315),
    [anon_sym_PIPE_EQ] = ACTIONS(6315),
    [anon_sym_DASH_EQ] = ACTIONS(6315),
    [anon_sym_EQ_GT] = ACTIONS(6319),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6315),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6315),
    [anon_sym_GT_GT_EQ] = ACTIONS(6315),
    [anon_sym_DOT] = ACTIONS(5390),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6315),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6321),
  },
  [3727] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6323),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6323),
    [anon_sym_AMP_EQ] = ACTIONS(6323),
    [anon_sym_PLUS_EQ] = ACTIONS(6323),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(6317),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_CARET_EQ] = ACTIONS(6323),
    [anon_sym_STAR_EQ] = ACTIONS(6323),
    [anon_sym_PIPE_EQ] = ACTIONS(6323),
    [anon_sym_DASH_EQ] = ACTIONS(6323),
    [anon_sym_EQ_GT] = ACTIONS(6325),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6323),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6323),
    [anon_sym_GT_GT_EQ] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6323),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3728] = {
    [sym_new_expression] = STATE(3014),
    [sym_augmented_assignment_expression] = STATE(3014),
    [sym_unary_expression] = STATE(3014),
    [sym_update_expression] = STATE(3014),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3014),
    [sym_regex] = STATE(3014),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3014),
    [sym_non_null_expression] = STATE(3014),
    [sym_as_expression] = STATE(3014),
    [sym_jsx_fragment] = STATE(3014),
    [sym_yield_expression] = STATE(3014),
    [sym_jsx_element] = STATE(3014),
    [sym_internal_module] = STATE(3014),
    [sym_nested_identifier] = STATE(1092),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3014),
    [sym_await_expression] = STATE(3014),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3014),
    [sym_this] = STATE(3014),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3014),
    [sym_generator_function] = STATE(3014),
    [sym_call_expression] = STATE(3014),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3014),
    [sym_ternary_expression] = STATE(3014),
    [sym_binary_expression] = STATE(3014),
    [sym_template_string] = STATE(3014),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3014),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3014),
    [sym_class] = STATE(3014),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(8677),
    [sym_false] = ACTIONS(6327),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6327),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6329),
    [sym_true] = ACTIONS(6327),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6327),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3729] = {
    [sym_new_expression] = STATE(3015),
    [sym_augmented_assignment_expression] = STATE(3015),
    [sym_unary_expression] = STATE(3015),
    [sym_update_expression] = STATE(3015),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(3015),
    [sym_regex] = STATE(3015),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3015),
    [sym_non_null_expression] = STATE(3015),
    [sym_as_expression] = STATE(3015),
    [sym_jsx_fragment] = STATE(3015),
    [sym_yield_expression] = STATE(3015),
    [sym_jsx_element] = STATE(3015),
    [sym_internal_module] = STATE(3015),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3015),
    [sym_await_expression] = STATE(3015),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3015),
    [sym_this] = STATE(3015),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3015),
    [sym_generator_function] = STATE(3015),
    [sym_call_expression] = STATE(3015),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3015),
    [sym_ternary_expression] = STATE(3015),
    [sym_binary_expression] = STATE(3015),
    [sym_template_string] = STATE(3015),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3015),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3015),
    [sym_class] = STATE(3015),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(6331),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6331),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4674),
    [sym_true] = ACTIONS(6331),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6331),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3730] = {
    [sym_new_expression] = STATE(3014),
    [sym_augmented_assignment_expression] = STATE(3014),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(3014),
    [sym_update_expression] = STATE(3014),
    [sym_regex] = STATE(3014),
    [sym_meta_property] = STATE(3014),
    [sym_call_signature] = STATE(2149),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3014),
    [sym_non_null_expression] = STATE(3014),
    [sym_yield_expression] = STATE(3014),
    [sym_jsx_fragment] = STATE(3014),
    [sym_jsx_element] = STATE(3014),
    [sym_as_expression] = STATE(3014),
    [sym_internal_module] = STATE(3014),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3014),
    [sym_await_expression] = STATE(3014),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(3014),
    [sym_this] = STATE(3014),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(3014),
    [sym_generator_function] = STATE(3014),
    [sym_call_expression] = STATE(3014),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(3014),
    [sym_ternary_expression] = STATE(3014),
    [sym_binary_expression] = STATE(3014),
    [sym_template_string] = STATE(3014),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3014),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3014),
    [sym_class] = STATE(3014),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4527),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(6323),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_AMP_EQ] = ACTIONS(6323),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(6323),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6317),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(6323),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_PIPE_EQ] = ACTIONS(6323),
    [anon_sym_DASH_EQ] = ACTIONS(6323),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(6323),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(4545),
    [sym_true] = ACTIONS(6327),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_GT_GT_EQ] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6323),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(4533),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(6327),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6323),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6327),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_STAR_EQ] = ACTIONS(6323),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_EQ_GT] = ACTIONS(6325),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(6329),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6323),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6327),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3731] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(1819),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(1820),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(6347),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(6349),
    [anon_sym_symbol] = ACTIONS(6349),
    [anon_sym_number] = ACTIONS(6349),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(6349),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(6351),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(6349),
    [anon_sym_private] = ACTIONS(6349),
    [anon_sym_boolean] = ACTIONS(6349),
    [anon_sym_async] = ACTIONS(6353),
    [anon_sym_public] = ACTIONS(6349),
    [anon_sym_get] = ACTIONS(6349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(6349),
    [anon_sym_string] = ACTIONS(6349),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(6349),
    [anon_sym_type] = ACTIONS(6349),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(6349),
    [anon_sym_export] = ACTIONS(6349),
    [anon_sym_namespace] = ACTIONS(6355),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [3732] = {
    [sym_identifier] = ACTIONS(8679),
    [anon_sym_BQUOTE] = ACTIONS(8681),
    [anon_sym_debugger] = ACTIONS(8679),
    [anon_sym_symbol] = ACTIONS(8679),
    [anon_sym_AT] = ACTIONS(8681),
    [anon_sym_DASH] = ACTIONS(8679),
    [anon_sym_void] = ACTIONS(8679),
    [anon_sym_break] = ACTIONS(8679),
    [anon_sym_const] = ACTIONS(8679),
    [sym_super] = ACTIONS(8679),
    [anon_sym_return] = ACTIONS(8679),
    [anon_sym_private] = ACTIONS(8679),
    [anon_sym_get] = ACTIONS(8679),
    [anon_sym_RBRACE] = ACTIONS(8681),
    [anon_sym_interface] = ACTIONS(8679),
    [anon_sym_default] = ACTIONS(8679),
    [anon_sym_enum] = ACTIONS(8679),
    [anon_sym_delete] = ACTIONS(8679),
    [anon_sym_continue] = ACTIONS(8679),
    [anon_sym_DASH_DASH] = ACTIONS(8681),
    [anon_sym_if] = ACTIONS(8679),
    [anon_sym_this] = ACTIONS(8679),
    [anon_sym_yield] = ACTIONS(8679),
    [sym_true] = ACTIONS(8679),
    [anon_sym_throw] = ACTIONS(8679),
    [anon_sym_protected] = ACTIONS(8679),
    [anon_sym_abstract] = ACTIONS(8679),
    [anon_sym_set] = ACTIONS(8679),
    [anon_sym_type] = ACTIONS(8679),
    [anon_sym_import] = ACTIONS(8679),
    [anon_sym_namespace] = ACTIONS(8679),
    [anon_sym_PLUS_PLUS] = ACTIONS(8681),
    [anon_sym_await] = ACTIONS(8679),
    [anon_sym_DQUOTE] = ACTIONS(8681),
    [anon_sym_else] = ACTIONS(8679),
    [anon_sym_BANG] = ACTIONS(8681),
    [anon_sym_for] = ACTIONS(8679),
    [anon_sym_LBRACK] = ACTIONS(8681),
    [sym_false] = ACTIONS(8679),
    [anon_sym_SEMI] = ACTIONS(8681),
    [anon_sym_case] = ACTIONS(8679),
    [anon_sym_module] = ACTIONS(8679),
    [anon_sym_number] = ACTIONS(8679),
    [anon_sym_class] = ACTIONS(8679),
    [anon_sym_declare] = ACTIONS(8679),
    [anon_sym_typeof] = ACTIONS(8679),
    [anon_sym_LBRACE] = ACTIONS(8681),
    [anon_sym_switch] = ACTIONS(8679),
    [anon_sym_LPAREN] = ACTIONS(8681),
    [sym_null] = ACTIONS(8679),
    [anon_sym_any] = ACTIONS(8679),
    [anon_sym_boolean] = ACTIONS(8679),
    [anon_sym_async] = ACTIONS(8679),
    [anon_sym_public] = ACTIONS(8679),
    [anon_sym_var] = ACTIONS(8679),
    [anon_sym_while] = ACTIONS(8679),
    [anon_sym_SQUOTE] = ACTIONS(8681),
    [anon_sym_try] = ACTIONS(8679),
    [anon_sym_LT] = ACTIONS(8681),
    [sym_number] = ACTIONS(8681),
    [anon_sym_SLASH] = ACTIONS(8679),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8679),
    [anon_sym_function] = ACTIONS(8679),
    [sym_undefined] = ACTIONS(8679),
    [anon_sym_new] = ACTIONS(8679),
    [ts_builtin_sym_end] = ACTIONS(8681),
    [anon_sym_let] = ACTIONS(8679),
    [anon_sym_PLUS] = ACTIONS(8679),
    [anon_sym_export] = ACTIONS(8679),
    [anon_sym_do] = ACTIONS(8679),
    [anon_sym_TILDE] = ACTIONS(8681),
    [anon_sym_with] = ACTIONS(8679),
  },
  [3733] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(8668),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3734] = {
    [sym_type_alias_declaration] = STATE(4235),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4235),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4235),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4235),
    [sym_return_statement] = STATE(4235),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4235),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4235),
    [sym_switch_statement] = STATE(4235),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4235),
    [sym_throw_statement] = STATE(4235),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4235),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4235),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(4235),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4235),
    [sym_abstract_class] = STATE(4235),
    [sym_interface_declaration] = STATE(4235),
    [sym_statement_block] = STATE(4235),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4235),
    [sym_debugger_statement] = STATE(4235),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4235),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4235),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4235),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4235),
    [sym_empty_statement] = STATE(4235),
    [sym_import_alias] = STATE(4235),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4235),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4235),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4235),
    [sym_break_statement] = STATE(4235),
    [sym_labeled_statement] = STATE(4235),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4235),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3735] = {
    [sym_type_alias_declaration] = STATE(4236),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4236),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4236),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4236),
    [sym_return_statement] = STATE(4236),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4236),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4236),
    [sym_switch_statement] = STATE(4236),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4236),
    [sym_throw_statement] = STATE(4236),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4236),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4236),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(4236),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4236),
    [sym_abstract_class] = STATE(4236),
    [sym_interface_declaration] = STATE(4236),
    [sym_statement_block] = STATE(4236),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4236),
    [sym_debugger_statement] = STATE(4236),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4236),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4236),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4236),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4236),
    [sym_empty_statement] = STATE(4236),
    [sym_import_alias] = STATE(4236),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4236),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4236),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4236),
    [sym_break_statement] = STATE(4236),
    [sym_labeled_statement] = STATE(4236),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4236),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3736] = {
    [sym_type_alias_declaration] = STATE(4237),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4237),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4237),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4237),
    [sym_return_statement] = STATE(4237),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4237),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4237),
    [sym_switch_statement] = STATE(4237),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4237),
    [sym_throw_statement] = STATE(4237),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4237),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4237),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(4237),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4237),
    [sym_abstract_class] = STATE(4237),
    [sym_interface_declaration] = STATE(4237),
    [sym_statement_block] = STATE(4237),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4237),
    [sym_debugger_statement] = STATE(4237),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4237),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4237),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4237),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4237),
    [sym_empty_statement] = STATE(4237),
    [sym_import_alias] = STATE(4237),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4237),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4237),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4237),
    [sym_break_statement] = STATE(4237),
    [sym_labeled_statement] = STATE(4237),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4237),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [3737] = {
    [sym_identifier] = ACTIONS(8683),
    [anon_sym_BQUOTE] = ACTIONS(8685),
    [anon_sym_debugger] = ACTIONS(8683),
    [anon_sym_symbol] = ACTIONS(8683),
    [anon_sym_AT] = ACTIONS(8685),
    [anon_sym_DASH] = ACTIONS(8683),
    [anon_sym_void] = ACTIONS(8683),
    [anon_sym_break] = ACTIONS(8683),
    [anon_sym_const] = ACTIONS(8683),
    [sym_super] = ACTIONS(8683),
    [anon_sym_return] = ACTIONS(8683),
    [anon_sym_private] = ACTIONS(8683),
    [anon_sym_get] = ACTIONS(8683),
    [anon_sym_RBRACE] = ACTIONS(8685),
    [anon_sym_interface] = ACTIONS(8683),
    [anon_sym_default] = ACTIONS(8683),
    [anon_sym_enum] = ACTIONS(8683),
    [anon_sym_delete] = ACTIONS(8683),
    [anon_sym_continue] = ACTIONS(8683),
    [anon_sym_DASH_DASH] = ACTIONS(8685),
    [anon_sym_if] = ACTIONS(8683),
    [anon_sym_this] = ACTIONS(8683),
    [anon_sym_yield] = ACTIONS(8683),
    [sym_true] = ACTIONS(8683),
    [anon_sym_throw] = ACTIONS(8683),
    [anon_sym_protected] = ACTIONS(8683),
    [anon_sym_abstract] = ACTIONS(8683),
    [anon_sym_set] = ACTIONS(8683),
    [anon_sym_type] = ACTIONS(8683),
    [anon_sym_import] = ACTIONS(8683),
    [anon_sym_namespace] = ACTIONS(8683),
    [anon_sym_PLUS_PLUS] = ACTIONS(8685),
    [anon_sym_await] = ACTIONS(8683),
    [anon_sym_DQUOTE] = ACTIONS(8685),
    [anon_sym_else] = ACTIONS(8683),
    [anon_sym_BANG] = ACTIONS(8685),
    [anon_sym_for] = ACTIONS(8683),
    [anon_sym_LBRACK] = ACTIONS(8685),
    [sym_false] = ACTIONS(8683),
    [anon_sym_SEMI] = ACTIONS(8685),
    [anon_sym_case] = ACTIONS(8683),
    [anon_sym_module] = ACTIONS(8683),
    [anon_sym_number] = ACTIONS(8683),
    [anon_sym_class] = ACTIONS(8683),
    [anon_sym_declare] = ACTIONS(8683),
    [anon_sym_typeof] = ACTIONS(8683),
    [anon_sym_LBRACE] = ACTIONS(8685),
    [anon_sym_switch] = ACTIONS(8683),
    [anon_sym_LPAREN] = ACTIONS(8685),
    [sym_null] = ACTIONS(8683),
    [anon_sym_any] = ACTIONS(8683),
    [anon_sym_boolean] = ACTIONS(8683),
    [anon_sym_async] = ACTIONS(8683),
    [anon_sym_public] = ACTIONS(8683),
    [anon_sym_var] = ACTIONS(8683),
    [anon_sym_while] = ACTIONS(8683),
    [anon_sym_SQUOTE] = ACTIONS(8685),
    [anon_sym_try] = ACTIONS(8683),
    [anon_sym_LT] = ACTIONS(8685),
    [sym_number] = ACTIONS(8685),
    [anon_sym_SLASH] = ACTIONS(8683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8683),
    [anon_sym_function] = ACTIONS(8683),
    [sym_undefined] = ACTIONS(8683),
    [anon_sym_new] = ACTIONS(8683),
    [ts_builtin_sym_end] = ACTIONS(8685),
    [anon_sym_let] = ACTIONS(8683),
    [anon_sym_PLUS] = ACTIONS(8683),
    [anon_sym_export] = ACTIONS(8683),
    [anon_sym_do] = ACTIONS(8683),
    [anon_sym_TILDE] = ACTIONS(8685),
    [anon_sym_with] = ACTIONS(8683),
  },
  [3738] = {
    [sym_identifier] = ACTIONS(8687),
    [anon_sym_BQUOTE] = ACTIONS(8689),
    [anon_sym_debugger] = ACTIONS(8687),
    [anon_sym_symbol] = ACTIONS(8687),
    [anon_sym_AT] = ACTIONS(8689),
    [anon_sym_DASH] = ACTIONS(8687),
    [anon_sym_void] = ACTIONS(8687),
    [anon_sym_break] = ACTIONS(8687),
    [anon_sym_const] = ACTIONS(8687),
    [sym_super] = ACTIONS(8687),
    [anon_sym_return] = ACTIONS(8687),
    [anon_sym_private] = ACTIONS(8687),
    [anon_sym_get] = ACTIONS(8687),
    [anon_sym_RBRACE] = ACTIONS(8689),
    [anon_sym_interface] = ACTIONS(8687),
    [anon_sym_default] = ACTIONS(8687),
    [anon_sym_enum] = ACTIONS(8687),
    [anon_sym_delete] = ACTIONS(8687),
    [anon_sym_continue] = ACTIONS(8687),
    [anon_sym_DASH_DASH] = ACTIONS(8689),
    [anon_sym_if] = ACTIONS(8687),
    [anon_sym_this] = ACTIONS(8687),
    [anon_sym_yield] = ACTIONS(8687),
    [sym_true] = ACTIONS(8687),
    [anon_sym_throw] = ACTIONS(8687),
    [anon_sym_protected] = ACTIONS(8687),
    [anon_sym_abstract] = ACTIONS(8687),
    [anon_sym_set] = ACTIONS(8687),
    [anon_sym_type] = ACTIONS(8687),
    [anon_sym_import] = ACTIONS(8687),
    [anon_sym_namespace] = ACTIONS(8687),
    [anon_sym_PLUS_PLUS] = ACTIONS(8689),
    [anon_sym_await] = ACTIONS(8687),
    [anon_sym_DQUOTE] = ACTIONS(8689),
    [anon_sym_else] = ACTIONS(8687),
    [anon_sym_BANG] = ACTIONS(8689),
    [anon_sym_for] = ACTIONS(8687),
    [anon_sym_LBRACK] = ACTIONS(8689),
    [sym_false] = ACTIONS(8687),
    [anon_sym_SEMI] = ACTIONS(8689),
    [anon_sym_case] = ACTIONS(8687),
    [anon_sym_module] = ACTIONS(8687),
    [anon_sym_number] = ACTIONS(8687),
    [anon_sym_class] = ACTIONS(8687),
    [anon_sym_declare] = ACTIONS(8687),
    [anon_sym_typeof] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(8689),
    [anon_sym_switch] = ACTIONS(8687),
    [anon_sym_LPAREN] = ACTIONS(8689),
    [sym_null] = ACTIONS(8687),
    [anon_sym_any] = ACTIONS(8687),
    [anon_sym_boolean] = ACTIONS(8687),
    [anon_sym_async] = ACTIONS(8687),
    [anon_sym_public] = ACTIONS(8687),
    [anon_sym_var] = ACTIONS(8687),
    [anon_sym_while] = ACTIONS(8687),
    [anon_sym_SQUOTE] = ACTIONS(8689),
    [anon_sym_try] = ACTIONS(8687),
    [anon_sym_LT] = ACTIONS(8689),
    [sym_number] = ACTIONS(8689),
    [anon_sym_SLASH] = ACTIONS(8687),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8687),
    [anon_sym_function] = ACTIONS(8687),
    [sym_undefined] = ACTIONS(8687),
    [anon_sym_new] = ACTIONS(8687),
    [ts_builtin_sym_end] = ACTIONS(8689),
    [anon_sym_let] = ACTIONS(8687),
    [anon_sym_PLUS] = ACTIONS(8687),
    [anon_sym_export] = ACTIONS(8687),
    [anon_sym_do] = ACTIONS(8687),
    [anon_sym_TILDE] = ACTIONS(8689),
    [anon_sym_with] = ACTIONS(8687),
  },
  [3739] = {
    [sym_identifier] = ACTIONS(8691),
    [anon_sym_BQUOTE] = ACTIONS(8693),
    [anon_sym_debugger] = ACTIONS(8691),
    [anon_sym_symbol] = ACTIONS(8691),
    [anon_sym_AT] = ACTIONS(8693),
    [anon_sym_DASH] = ACTIONS(8691),
    [anon_sym_void] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8691),
    [anon_sym_const] = ACTIONS(8691),
    [sym_super] = ACTIONS(8691),
    [anon_sym_return] = ACTIONS(8691),
    [anon_sym_private] = ACTIONS(8691),
    [anon_sym_get] = ACTIONS(8691),
    [anon_sym_RBRACE] = ACTIONS(8693),
    [anon_sym_interface] = ACTIONS(8691),
    [anon_sym_default] = ACTIONS(8691),
    [anon_sym_enum] = ACTIONS(8691),
    [anon_sym_delete] = ACTIONS(8691),
    [anon_sym_continue] = ACTIONS(8691),
    [anon_sym_DASH_DASH] = ACTIONS(8693),
    [anon_sym_if] = ACTIONS(8691),
    [anon_sym_this] = ACTIONS(8691),
    [anon_sym_yield] = ACTIONS(8691),
    [sym_true] = ACTIONS(8691),
    [anon_sym_throw] = ACTIONS(8691),
    [anon_sym_protected] = ACTIONS(8691),
    [anon_sym_abstract] = ACTIONS(8691),
    [anon_sym_set] = ACTIONS(8691),
    [anon_sym_type] = ACTIONS(8691),
    [anon_sym_import] = ACTIONS(8691),
    [anon_sym_namespace] = ACTIONS(8691),
    [anon_sym_PLUS_PLUS] = ACTIONS(8693),
    [anon_sym_await] = ACTIONS(8691),
    [anon_sym_DQUOTE] = ACTIONS(8693),
    [anon_sym_else] = ACTIONS(8691),
    [anon_sym_BANG] = ACTIONS(8693),
    [anon_sym_for] = ACTIONS(8691),
    [anon_sym_LBRACK] = ACTIONS(8693),
    [sym_false] = ACTIONS(8691),
    [anon_sym_SEMI] = ACTIONS(8693),
    [anon_sym_case] = ACTIONS(8691),
    [anon_sym_module] = ACTIONS(8691),
    [anon_sym_number] = ACTIONS(8691),
    [anon_sym_class] = ACTIONS(8691),
    [anon_sym_declare] = ACTIONS(8691),
    [anon_sym_typeof] = ACTIONS(8691),
    [anon_sym_LBRACE] = ACTIONS(8693),
    [anon_sym_switch] = ACTIONS(8691),
    [anon_sym_LPAREN] = ACTIONS(8693),
    [sym_null] = ACTIONS(8691),
    [anon_sym_any] = ACTIONS(8691),
    [anon_sym_boolean] = ACTIONS(8691),
    [anon_sym_async] = ACTIONS(8691),
    [anon_sym_public] = ACTIONS(8691),
    [anon_sym_var] = ACTIONS(8691),
    [anon_sym_while] = ACTIONS(8691),
    [anon_sym_SQUOTE] = ACTIONS(8693),
    [anon_sym_try] = ACTIONS(8691),
    [anon_sym_LT] = ACTIONS(8693),
    [sym_number] = ACTIONS(8693),
    [anon_sym_SLASH] = ACTIONS(8691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8691),
    [anon_sym_function] = ACTIONS(8691),
    [sym_undefined] = ACTIONS(8691),
    [anon_sym_new] = ACTIONS(8691),
    [ts_builtin_sym_end] = ACTIONS(8693),
    [anon_sym_let] = ACTIONS(8691),
    [anon_sym_PLUS] = ACTIONS(8691),
    [anon_sym_export] = ACTIONS(8691),
    [anon_sym_do] = ACTIONS(8691),
    [anon_sym_TILDE] = ACTIONS(8693),
    [anon_sym_with] = ACTIONS(8691),
  },
  [3740] = {
    [sym_identifier] = ACTIONS(8695),
    [anon_sym_BQUOTE] = ACTIONS(8697),
    [anon_sym_debugger] = ACTIONS(8695),
    [anon_sym_symbol] = ACTIONS(8695),
    [anon_sym_AT] = ACTIONS(8697),
    [anon_sym_DASH] = ACTIONS(8695),
    [anon_sym_void] = ACTIONS(8695),
    [anon_sym_break] = ACTIONS(8695),
    [anon_sym_const] = ACTIONS(8695),
    [sym_super] = ACTIONS(8695),
    [anon_sym_return] = ACTIONS(8695),
    [anon_sym_private] = ACTIONS(8695),
    [anon_sym_get] = ACTIONS(8695),
    [anon_sym_RBRACE] = ACTIONS(8697),
    [anon_sym_interface] = ACTIONS(8695),
    [anon_sym_default] = ACTIONS(8695),
    [anon_sym_enum] = ACTIONS(8695),
    [anon_sym_delete] = ACTIONS(8695),
    [anon_sym_continue] = ACTIONS(8695),
    [anon_sym_DASH_DASH] = ACTIONS(8697),
    [anon_sym_if] = ACTIONS(8695),
    [anon_sym_this] = ACTIONS(8695),
    [anon_sym_yield] = ACTIONS(8695),
    [sym_true] = ACTIONS(8695),
    [anon_sym_throw] = ACTIONS(8695),
    [anon_sym_protected] = ACTIONS(8695),
    [anon_sym_abstract] = ACTIONS(8695),
    [anon_sym_set] = ACTIONS(8695),
    [anon_sym_type] = ACTIONS(8695),
    [anon_sym_import] = ACTIONS(8695),
    [anon_sym_namespace] = ACTIONS(8695),
    [anon_sym_PLUS_PLUS] = ACTIONS(8697),
    [anon_sym_await] = ACTIONS(8695),
    [anon_sym_DQUOTE] = ACTIONS(8697),
    [anon_sym_else] = ACTIONS(8695),
    [anon_sym_BANG] = ACTIONS(8697),
    [anon_sym_for] = ACTIONS(8695),
    [anon_sym_LBRACK] = ACTIONS(8697),
    [sym_false] = ACTIONS(8695),
    [anon_sym_SEMI] = ACTIONS(8697),
    [anon_sym_case] = ACTIONS(8695),
    [anon_sym_module] = ACTIONS(8695),
    [anon_sym_number] = ACTIONS(8695),
    [anon_sym_class] = ACTIONS(8695),
    [anon_sym_declare] = ACTIONS(8695),
    [anon_sym_typeof] = ACTIONS(8695),
    [anon_sym_LBRACE] = ACTIONS(8697),
    [anon_sym_switch] = ACTIONS(8695),
    [anon_sym_LPAREN] = ACTIONS(8697),
    [sym_null] = ACTIONS(8695),
    [anon_sym_any] = ACTIONS(8695),
    [anon_sym_boolean] = ACTIONS(8695),
    [anon_sym_async] = ACTIONS(8695),
    [anon_sym_public] = ACTIONS(8695),
    [anon_sym_var] = ACTIONS(8695),
    [anon_sym_while] = ACTIONS(8695),
    [anon_sym_SQUOTE] = ACTIONS(8697),
    [anon_sym_try] = ACTIONS(8695),
    [anon_sym_LT] = ACTIONS(8697),
    [sym_number] = ACTIONS(8697),
    [anon_sym_SLASH] = ACTIONS(8695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8695),
    [anon_sym_function] = ACTIONS(8695),
    [sym_undefined] = ACTIONS(8695),
    [anon_sym_new] = ACTIONS(8695),
    [ts_builtin_sym_end] = ACTIONS(8697),
    [anon_sym_let] = ACTIONS(8695),
    [anon_sym_PLUS] = ACTIONS(8695),
    [anon_sym_export] = ACTIONS(8695),
    [anon_sym_do] = ACTIONS(8695),
    [anon_sym_TILDE] = ACTIONS(8697),
    [anon_sym_with] = ACTIONS(8695),
  },
  [3741] = {
    [sym_identifier] = ACTIONS(8699),
    [anon_sym_BQUOTE] = ACTIONS(8701),
    [anon_sym_debugger] = ACTIONS(8699),
    [anon_sym_symbol] = ACTIONS(8699),
    [anon_sym_AT] = ACTIONS(8701),
    [anon_sym_DASH] = ACTIONS(8699),
    [anon_sym_void] = ACTIONS(8699),
    [anon_sym_break] = ACTIONS(8699),
    [anon_sym_const] = ACTIONS(8699),
    [sym_super] = ACTIONS(8699),
    [anon_sym_return] = ACTIONS(8699),
    [anon_sym_private] = ACTIONS(8699),
    [anon_sym_get] = ACTIONS(8699),
    [anon_sym_RBRACE] = ACTIONS(8701),
    [anon_sym_interface] = ACTIONS(8699),
    [anon_sym_default] = ACTIONS(8699),
    [anon_sym_enum] = ACTIONS(8699),
    [anon_sym_delete] = ACTIONS(8699),
    [anon_sym_continue] = ACTIONS(8699),
    [anon_sym_DASH_DASH] = ACTIONS(8701),
    [anon_sym_if] = ACTIONS(8699),
    [anon_sym_this] = ACTIONS(8699),
    [anon_sym_yield] = ACTIONS(8699),
    [sym_true] = ACTIONS(8699),
    [anon_sym_throw] = ACTIONS(8699),
    [anon_sym_protected] = ACTIONS(8699),
    [anon_sym_abstract] = ACTIONS(8699),
    [anon_sym_set] = ACTIONS(8699),
    [anon_sym_type] = ACTIONS(8699),
    [anon_sym_import] = ACTIONS(8699),
    [anon_sym_namespace] = ACTIONS(8699),
    [anon_sym_PLUS_PLUS] = ACTIONS(8701),
    [anon_sym_await] = ACTIONS(8699),
    [anon_sym_DQUOTE] = ACTIONS(8701),
    [anon_sym_else] = ACTIONS(8699),
    [anon_sym_BANG] = ACTIONS(8701),
    [anon_sym_for] = ACTIONS(8699),
    [anon_sym_LBRACK] = ACTIONS(8701),
    [sym_false] = ACTIONS(8699),
    [anon_sym_SEMI] = ACTIONS(8701),
    [anon_sym_case] = ACTIONS(8699),
    [anon_sym_module] = ACTIONS(8699),
    [anon_sym_number] = ACTIONS(8699),
    [anon_sym_class] = ACTIONS(8699),
    [anon_sym_declare] = ACTIONS(8699),
    [anon_sym_typeof] = ACTIONS(8699),
    [anon_sym_LBRACE] = ACTIONS(8701),
    [anon_sym_switch] = ACTIONS(8699),
    [anon_sym_LPAREN] = ACTIONS(8701),
    [sym_null] = ACTIONS(8699),
    [anon_sym_any] = ACTIONS(8699),
    [anon_sym_boolean] = ACTIONS(8699),
    [anon_sym_async] = ACTIONS(8699),
    [anon_sym_public] = ACTIONS(8699),
    [anon_sym_var] = ACTIONS(8699),
    [anon_sym_while] = ACTIONS(8699),
    [anon_sym_SQUOTE] = ACTIONS(8701),
    [anon_sym_try] = ACTIONS(8699),
    [anon_sym_LT] = ACTIONS(8701),
    [sym_number] = ACTIONS(8701),
    [anon_sym_SLASH] = ACTIONS(8699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8699),
    [anon_sym_function] = ACTIONS(8699),
    [sym_undefined] = ACTIONS(8699),
    [anon_sym_new] = ACTIONS(8699),
    [ts_builtin_sym_end] = ACTIONS(8701),
    [anon_sym_let] = ACTIONS(8699),
    [anon_sym_PLUS] = ACTIONS(8699),
    [anon_sym_export] = ACTIONS(8699),
    [anon_sym_do] = ACTIONS(8699),
    [anon_sym_TILDE] = ACTIONS(8701),
    [anon_sym_with] = ACTIONS(8699),
  },
  [3742] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8213),
    [anon_sym_LBRACK] = ACTIONS(8213),
    [anon_sym_BANG] = ACTIONS(8215),
    [anon_sym_BQUOTE] = ACTIONS(8213),
    [anon_sym_PIPE] = ACTIONS(8215),
    [anon_sym_COMMA] = ACTIONS(8213),
    [anon_sym_LT_LT] = ACTIONS(8213),
    [anon_sym_STAR] = ACTIONS(8215),
    [anon_sym_GT_GT_GT] = ACTIONS(8213),
    [anon_sym_AMP_AMP] = ACTIONS(8213),
    [anon_sym_DASH] = ACTIONS(8215),
    [anon_sym_LBRACE] = ACTIONS(8215),
    [anon_sym_BANG_EQ] = ACTIONS(8215),
    [anon_sym_LT_EQ] = ACTIONS(8213),
    [anon_sym_LPAREN] = ACTIONS(8213),
    [anon_sym_RBRACK] = ACTIONS(8213),
    [anon_sym_GT_EQ] = ACTIONS(8213),
    [anon_sym_GT] = ACTIONS(8215),
    [anon_sym_AMP] = ACTIONS(8215),
    [anon_sym_PERCENT] = ACTIONS(8213),
    [anon_sym_QMARK] = ACTIONS(8213),
    [anon_sym_RBRACE] = ACTIONS(8213),
    [anon_sym_as] = ACTIONS(8213),
    [anon_sym_PIPE_PIPE] = ACTIONS(8213),
    [anon_sym_LBRACE_PIPE] = ACTIONS(8213),
    [anon_sym_DASH_DASH] = ACTIONS(8213),
    [anon_sym_EQ_EQ] = ACTIONS(8215),
    [anon_sym_instanceof] = ACTIONS(8213),
    [anon_sym_LT] = ACTIONS(8215),
    [anon_sym_RPAREN] = ACTIONS(8213),
    [anon_sym_SLASH] = ACTIONS(8215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(8213),
    [anon_sym_DOT] = ACTIONS(8213),
    [anon_sym_CARET] = ACTIONS(8213),
    [anon_sym_STAR_STAR] = ACTIONS(8213),
    [anon_sym_PLUS] = ACTIONS(8215),
    [anon_sym_implements] = ACTIONS(8213),
    [anon_sym_GT_GT] = ACTIONS(8215),
    [anon_sym_PLUS_PLUS] = ACTIONS(8213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8213),
    [anon_sym_in] = ACTIONS(8215),
  },
  [3743] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7419),
    [anon_sym_LBRACK] = ACTIONS(7419),
    [anon_sym_BANG] = ACTIONS(7417),
    [anon_sym_BQUOTE] = ACTIONS(7419),
    [anon_sym_PIPE] = ACTIONS(7417),
    [anon_sym_COMMA] = ACTIONS(7419),
    [anon_sym_LT_LT] = ACTIONS(7419),
    [anon_sym_STAR] = ACTIONS(7417),
    [anon_sym_GT_GT_GT] = ACTIONS(7419),
    [anon_sym_AMP_AMP] = ACTIONS(7419),
    [anon_sym_DASH] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(7417),
    [anon_sym_BANG_EQ] = ACTIONS(7417),
    [anon_sym_LT_EQ] = ACTIONS(7419),
    [anon_sym_LPAREN] = ACTIONS(7419),
    [anon_sym_RBRACK] = ACTIONS(7419),
    [anon_sym_GT_EQ] = ACTIONS(7419),
    [anon_sym_GT] = ACTIONS(7417),
    [anon_sym_AMP] = ACTIONS(7417),
    [anon_sym_PERCENT] = ACTIONS(7419),
    [anon_sym_QMARK] = ACTIONS(7419),
    [anon_sym_RBRACE] = ACTIONS(7419),
    [anon_sym_as] = ACTIONS(7419),
    [anon_sym_PIPE_PIPE] = ACTIONS(7419),
    [anon_sym_LBRACE_PIPE] = ACTIONS(7419),
    [anon_sym_DASH_DASH] = ACTIONS(7419),
    [anon_sym_EQ_EQ] = ACTIONS(7417),
    [anon_sym_instanceof] = ACTIONS(7419),
    [anon_sym_LT] = ACTIONS(7417),
    [anon_sym_RPAREN] = ACTIONS(7419),
    [anon_sym_SLASH] = ACTIONS(7417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_DOT] = ACTIONS(7419),
    [anon_sym_CARET] = ACTIONS(7419),
    [anon_sym_STAR_STAR] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7417),
    [anon_sym_implements] = ACTIONS(7419),
    [anon_sym_GT_GT] = ACTIONS(7417),
    [anon_sym_PLUS_PLUS] = ACTIONS(7419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7419),
    [anon_sym_in] = ACTIONS(7417),
  },
  [3744] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(2866),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(2866),
    [sym_call_signature] = STATE(2866),
    [sym_export_statement] = STATE(2866),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(2866),
    [sym_index_signature] = STATE(2866),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_RBRACE] = ACTIONS(8703),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8703),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [3745] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7431),
    [anon_sym_LBRACK] = ACTIONS(7431),
    [anon_sym_BANG] = ACTIONS(7429),
    [anon_sym_BQUOTE] = ACTIONS(7431),
    [anon_sym_PIPE] = ACTIONS(7429),
    [anon_sym_COMMA] = ACTIONS(7431),
    [anon_sym_LT_LT] = ACTIONS(7431),
    [anon_sym_STAR] = ACTIONS(7429),
    [anon_sym_GT_GT_GT] = ACTIONS(7431),
    [anon_sym_AMP_AMP] = ACTIONS(7431),
    [anon_sym_DASH] = ACTIONS(7429),
    [anon_sym_LBRACE] = ACTIONS(7429),
    [anon_sym_BANG_EQ] = ACTIONS(7429),
    [anon_sym_LT_EQ] = ACTIONS(7431),
    [anon_sym_LPAREN] = ACTIONS(7431),
    [anon_sym_RBRACK] = ACTIONS(7431),
    [anon_sym_GT_EQ] = ACTIONS(7431),
    [anon_sym_GT] = ACTIONS(7429),
    [anon_sym_AMP] = ACTIONS(7429),
    [anon_sym_PERCENT] = ACTIONS(7431),
    [anon_sym_QMARK] = ACTIONS(7431),
    [anon_sym_RBRACE] = ACTIONS(7431),
    [anon_sym_as] = ACTIONS(7431),
    [anon_sym_PIPE_PIPE] = ACTIONS(7431),
    [anon_sym_LBRACE_PIPE] = ACTIONS(7431),
    [anon_sym_DASH_DASH] = ACTIONS(7431),
    [anon_sym_EQ_EQ] = ACTIONS(7429),
    [anon_sym_instanceof] = ACTIONS(7431),
    [anon_sym_LT] = ACTIONS(7429),
    [anon_sym_RPAREN] = ACTIONS(7431),
    [anon_sym_SLASH] = ACTIONS(7429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7431),
    [anon_sym_DOT] = ACTIONS(7431),
    [anon_sym_CARET] = ACTIONS(7431),
    [anon_sym_STAR_STAR] = ACTIONS(7431),
    [anon_sym_PLUS] = ACTIONS(7429),
    [anon_sym_implements] = ACTIONS(7431),
    [anon_sym_GT_GT] = ACTIONS(7429),
    [anon_sym_PLUS_PLUS] = ACTIONS(7431),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7431),
    [anon_sym_in] = ACTIONS(7429),
  },
  [3746] = {
    [aux_sym_object_type_repeat1] = STATE(2867),
    [sym__automatic_semicolon] = ACTIONS(8705),
    [anon_sym_RBRACE] = ACTIONS(8703),
    [anon_sym_SEMI] = ACTIONS(8705),
    [anon_sym_COMMA] = ACTIONS(8705),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8703),
    [sym_comment] = ACTIONS(3),
  },
  [3747] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7506),
    [anon_sym_LBRACK] = ACTIONS(7506),
    [anon_sym_BANG] = ACTIONS(7504),
    [anon_sym_BQUOTE] = ACTIONS(7506),
    [anon_sym_PIPE] = ACTIONS(7504),
    [anon_sym_COMMA] = ACTIONS(7506),
    [anon_sym_LT_LT] = ACTIONS(7506),
    [anon_sym_STAR] = ACTIONS(7504),
    [anon_sym_GT_GT_GT] = ACTIONS(7506),
    [anon_sym_AMP_AMP] = ACTIONS(7506),
    [anon_sym_DASH] = ACTIONS(7504),
    [anon_sym_LBRACE] = ACTIONS(7504),
    [anon_sym_BANG_EQ] = ACTIONS(7504),
    [anon_sym_LT_EQ] = ACTIONS(7506),
    [anon_sym_LPAREN] = ACTIONS(7506),
    [anon_sym_RBRACK] = ACTIONS(7506),
    [anon_sym_GT_EQ] = ACTIONS(7506),
    [anon_sym_GT] = ACTIONS(7504),
    [anon_sym_AMP] = ACTIONS(7504),
    [anon_sym_PERCENT] = ACTIONS(7506),
    [anon_sym_QMARK] = ACTIONS(7506),
    [anon_sym_RBRACE] = ACTIONS(7506),
    [anon_sym_as] = ACTIONS(7506),
    [anon_sym_PIPE_PIPE] = ACTIONS(7506),
    [anon_sym_LBRACE_PIPE] = ACTIONS(7506),
    [anon_sym_DASH_DASH] = ACTIONS(7506),
    [anon_sym_EQ_EQ] = ACTIONS(7504),
    [anon_sym_instanceof] = ACTIONS(7506),
    [anon_sym_LT] = ACTIONS(7504),
    [anon_sym_RPAREN] = ACTIONS(7506),
    [anon_sym_SLASH] = ACTIONS(7504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7506),
    [anon_sym_DOT] = ACTIONS(7506),
    [anon_sym_CARET] = ACTIONS(7506),
    [anon_sym_STAR_STAR] = ACTIONS(7506),
    [anon_sym_PLUS] = ACTIONS(7504),
    [anon_sym_implements] = ACTIONS(7506),
    [anon_sym_GT_GT] = ACTIONS(7504),
    [anon_sym_PLUS_PLUS] = ACTIONS(7506),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7506),
    [anon_sym_in] = ACTIONS(7504),
  },
  [3748] = {
    [sym_union_type] = STATE(4240),
    [sym__type] = STATE(4240),
    [sym_constructor_type] = STATE(4240),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1295),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4240),
    [sym_function_type] = STATE(4240),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1299),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(2641),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(2667),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(2659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3749] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_BANG] = ACTIONS(8379),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(7844),
    [anon_sym_COMMA] = ACTIONS(7511),
    [anon_sym_LT_LT] = ACTIONS(7511),
    [anon_sym_STAR] = ACTIONS(8379),
    [anon_sym_GT_GT_GT] = ACTIONS(7511),
    [anon_sym_AMP_AMP] = ACTIONS(7511),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_BANG_EQ] = ACTIONS(8379),
    [anon_sym_LT_EQ] = ACTIONS(7511),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [anon_sym_RBRACK] = ACTIONS(7511),
    [anon_sym_GT_EQ] = ACTIONS(7511),
    [anon_sym_GT] = ACTIONS(8379),
    [anon_sym_AMP] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(7511),
    [anon_sym_QMARK] = ACTIONS(7511),
    [anon_sym_as] = ACTIONS(7511),
    [anon_sym_PIPE_PIPE] = ACTIONS(7511),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_EQ_EQ] = ACTIONS(8379),
    [anon_sym_instanceof] = ACTIONS(7511),
    [anon_sym_LT] = ACTIONS(8379),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7511),
    [anon_sym_CARET] = ACTIONS(7511),
    [anon_sym_STAR_STAR] = ACTIONS(7511),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_GT_GT] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7511),
    [anon_sym_in] = ACTIONS(8379),
  },
  [3750] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7527),
    [anon_sym_LBRACK] = ACTIONS(7527),
    [anon_sym_BANG] = ACTIONS(7525),
    [anon_sym_BQUOTE] = ACTIONS(7527),
    [anon_sym_PIPE] = ACTIONS(7525),
    [anon_sym_COMMA] = ACTIONS(7527),
    [anon_sym_LT_LT] = ACTIONS(7527),
    [anon_sym_STAR] = ACTIONS(7525),
    [anon_sym_GT_GT_GT] = ACTIONS(7527),
    [anon_sym_AMP_AMP] = ACTIONS(7527),
    [anon_sym_DASH] = ACTIONS(7525),
    [anon_sym_LBRACE] = ACTIONS(7525),
    [anon_sym_BANG_EQ] = ACTIONS(7525),
    [anon_sym_LT_EQ] = ACTIONS(7527),
    [anon_sym_LPAREN] = ACTIONS(7527),
    [anon_sym_RBRACK] = ACTIONS(7527),
    [anon_sym_GT_EQ] = ACTIONS(7527),
    [anon_sym_GT] = ACTIONS(7525),
    [anon_sym_AMP] = ACTIONS(7525),
    [anon_sym_PERCENT] = ACTIONS(7527),
    [anon_sym_QMARK] = ACTIONS(7527),
    [anon_sym_RBRACE] = ACTIONS(7527),
    [anon_sym_as] = ACTIONS(7527),
    [anon_sym_PIPE_PIPE] = ACTIONS(7527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(7527),
    [anon_sym_DASH_DASH] = ACTIONS(7527),
    [anon_sym_EQ_EQ] = ACTIONS(7525),
    [anon_sym_instanceof] = ACTIONS(7527),
    [anon_sym_LT] = ACTIONS(7525),
    [anon_sym_RPAREN] = ACTIONS(7527),
    [anon_sym_SLASH] = ACTIONS(7525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7527),
    [anon_sym_DOT] = ACTIONS(7527),
    [anon_sym_CARET] = ACTIONS(7527),
    [anon_sym_STAR_STAR] = ACTIONS(7527),
    [anon_sym_PLUS] = ACTIONS(7525),
    [anon_sym_implements] = ACTIONS(7527),
    [anon_sym_GT_GT] = ACTIONS(7525),
    [anon_sym_PLUS_PLUS] = ACTIONS(7527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7527),
    [anon_sym_in] = ACTIONS(7525),
  },
  [3751] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_BANG] = ACTIONS(8381),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(7844),
    [anon_sym_COMMA] = ACTIONS(7529),
    [anon_sym_LT_LT] = ACTIONS(7529),
    [anon_sym_STAR] = ACTIONS(8381),
    [anon_sym_GT_GT_GT] = ACTIONS(7529),
    [anon_sym_AMP_AMP] = ACTIONS(7529),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_BANG_EQ] = ACTIONS(8381),
    [anon_sym_LT_EQ] = ACTIONS(7529),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [anon_sym_RBRACK] = ACTIONS(7529),
    [anon_sym_GT_EQ] = ACTIONS(7529),
    [anon_sym_GT] = ACTIONS(8381),
    [anon_sym_AMP] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(7529),
    [anon_sym_QMARK] = ACTIONS(7529),
    [anon_sym_as] = ACTIONS(7529),
    [anon_sym_PIPE_PIPE] = ACTIONS(7529),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_EQ_EQ] = ACTIONS(8381),
    [anon_sym_instanceof] = ACTIONS(7529),
    [anon_sym_LT] = ACTIONS(8381),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7529),
    [anon_sym_CARET] = ACTIONS(7529),
    [anon_sym_STAR_STAR] = ACTIONS(7529),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_GT_GT] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7529),
    [anon_sym_in] = ACTIONS(8381),
  },
  [3752] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(6453),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [anon_sym_PERCENT_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_AMP_EQ] = ACTIONS(2011),
    [anon_sym_PLUS_EQ] = ACTIONS(2011),
    [anon_sym_PIPE] = ACTIONS(8388),
    [anon_sym_COMMA] = ACTIONS(6453),
    [anon_sym_LT_LT] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_GT_GT_GT] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_RBRACK] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_CARET_EQ] = ACTIONS(2011),
    [anon_sym_STAR_EQ] = ACTIONS(2011),
    [anon_sym_PIPE_EQ] = ACTIONS(2011),
    [anon_sym_DASH_EQ] = ACTIONS(2011),
    [anon_sym_AMP] = ACTIONS(8388),
    [anon_sym_PERCENT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_LT_LT_EQ] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2011),
    [anon_sym_RBRACE] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_instanceof] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_RPAREN] = ACTIONS(2011),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2011),
    [anon_sym_COLON] = ACTIONS(2011),
    [anon_sym_SLASH_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_DOT] = ACTIONS(6453),
    [anon_sym_CARET] = ACTIONS(2013),
    [anon_sym_STAR_STAR] = ACTIONS(2013),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_implements] = ACTIONS(2011),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2013),
  },
  [3753] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8355),
    [anon_sym_LBRACK] = ACTIONS(8355),
    [anon_sym_BANG] = ACTIONS(8357),
    [anon_sym_BQUOTE] = ACTIONS(8355),
    [anon_sym_else] = ACTIONS(8355),
    [anon_sym_PIPE] = ACTIONS(8357),
    [anon_sym_COMMA] = ACTIONS(8355),
    [anon_sym_LT_LT] = ACTIONS(8355),
    [anon_sym_STAR] = ACTIONS(8357),
    [anon_sym_GT_GT_GT] = ACTIONS(8355),
    [anon_sym_AMP_AMP] = ACTIONS(8355),
    [anon_sym_DASH] = ACTIONS(8357),
    [anon_sym_LBRACE] = ACTIONS(8357),
    [anon_sym_BANG_EQ] = ACTIONS(8357),
    [anon_sym_LT_EQ] = ACTIONS(8355),
    [anon_sym_LPAREN] = ACTIONS(8355),
    [anon_sym_RBRACK] = ACTIONS(8355),
    [anon_sym_GT_EQ] = ACTIONS(8355),
    [anon_sym_GT] = ACTIONS(8357),
    [anon_sym_AMP] = ACTIONS(8357),
    [anon_sym_PERCENT] = ACTIONS(8355),
    [anon_sym_QMARK] = ACTIONS(8355),
    [anon_sym_RBRACE] = ACTIONS(8355),
    [anon_sym_as] = ACTIONS(8355),
    [anon_sym_PIPE_PIPE] = ACTIONS(8355),
    [anon_sym_while] = ACTIONS(8355),
    [anon_sym_DASH_DASH] = ACTIONS(8355),
    [anon_sym_EQ_EQ] = ACTIONS(8357),
    [anon_sym_instanceof] = ACTIONS(8355),
    [anon_sym_LT] = ACTIONS(8357),
    [anon_sym_RPAREN] = ACTIONS(8355),
    [anon_sym_SLASH] = ACTIONS(8357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(8355),
    [anon_sym_COLON] = ACTIONS(8355),
    [anon_sym_DOT] = ACTIONS(8355),
    [anon_sym_CARET] = ACTIONS(8355),
    [anon_sym_STAR_STAR] = ACTIONS(8355),
    [anon_sym_PLUS] = ACTIONS(8357),
    [anon_sym_implements] = ACTIONS(8355),
    [anon_sym_GT_GT] = ACTIONS(8357),
    [anon_sym_PLUS_PLUS] = ACTIONS(8355),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8355),
    [anon_sym_in] = ACTIONS(8357),
  },
  [3754] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6023),
    [anon_sym_LBRACK] = ACTIONS(6023),
    [anon_sym_in] = ACTIONS(6025),
    [anon_sym_BQUOTE] = ACTIONS(6023),
    [anon_sym_PIPE] = ACTIONS(6025),
    [anon_sym_COMMA] = ACTIONS(6023),
    [anon_sym_DASH] = ACTIONS(6025),
    [anon_sym_STAR] = ACTIONS(6025),
    [anon_sym_LBRACE] = ACTIONS(6025),
    [anon_sym_GT_GT_GT] = ACTIONS(6023),
    [anon_sym_AMP_AMP] = ACTIONS(6023),
    [anon_sym_LT_LT] = ACTIONS(6023),
    [anon_sym_BANG_EQ] = ACTIONS(6025),
    [anon_sym_LT_EQ] = ACTIONS(6023),
    [anon_sym_LPAREN] = ACTIONS(6023),
    [anon_sym_RBRACK] = ACTIONS(6023),
    [anon_sym_GT_EQ] = ACTIONS(6023),
    [anon_sym_GT] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6023),
    [anon_sym_QMARK] = ACTIONS(6023),
    [anon_sym_RBRACE] = ACTIONS(6023),
    [anon_sym_as] = ACTIONS(6023),
    [anon_sym_PIPE_PIPE] = ACTIONS(6023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6023),
    [anon_sym_DASH_DASH] = ACTIONS(6023),
    [anon_sym_EQ_EQ] = ACTIONS(6025),
    [anon_sym_instanceof] = ACTIONS(6023),
    [anon_sym_LT] = ACTIONS(6025),
    [anon_sym_RPAREN] = ACTIONS(6023),
    [anon_sym_SLASH] = ACTIONS(6025),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6023),
    [anon_sym_DOT] = ACTIONS(6023),
    [anon_sym_CARET] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6023),
    [anon_sym_PLUS] = ACTIONS(6025),
    [anon_sym_implements] = ACTIONS(6023),
    [anon_sym_GT_GT] = ACTIONS(6025),
    [anon_sym_PLUS_PLUS] = ACTIONS(6023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6023),
    [anon_sym_BANG] = ACTIONS(6025),
  },
  [3755] = {
    [sym_union_type] = STATE(2014),
    [sym__type] = STATE(2014),
    [sym_constructor_type] = STATE(2014),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2014),
    [sym_function_type] = STATE(2014),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(8707),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_boolean] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_this] = ACTIONS(765),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [3756] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2773),
    [anon_sym_COMMA] = ACTIONS(7181),
    [anon_sym_LT_LT] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2785),
    [anon_sym_LBRACE] = ACTIONS(7181),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_GT_GT_GT] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2779),
    [anon_sym_BANG_EQ] = ACTIONS(2727),
    [anon_sym_LT_EQ] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2727),
    [anon_sym_AMP] = ACTIONS(2787),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_QMARK] = ACTIONS(2789),
    [anon_sym_as] = ACTIONS(2793),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2727),
    [anon_sym_instanceof] = ACTIONS(2771),
    [anon_sym_LT] = ACTIONS(2795),
    [anon_sym_SLASH] = ACTIONS(2785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2791),
    [anon_sym_STAR_STAR] = ACTIONS(2797),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_implements] = ACTIONS(7181),
    [anon_sym_GT_GT] = ACTIONS(2785),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2771),
    [anon_sym_in] = ACTIONS(2727),
  },
  [3757] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(7192),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(8709),
    [anon_sym_COMMA] = ACTIONS(5893),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_LBRACE] = ACTIONS(5893),
    [anon_sym_AMP_AMP] = ACTIONS(5893),
    [anon_sym_GT_GT_GT] = ACTIONS(5893),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_BANG_EQ] = ACTIONS(7192),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(8711),
    [anon_sym_PERCENT] = ACTIONS(5893),
    [anon_sym_QMARK] = ACTIONS(5893),
    [anon_sym_as] = ACTIONS(5893),
    [anon_sym_PIPE_PIPE] = ACTIONS(5893),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_EQ_EQ] = ACTIONS(7192),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5893),
    [anon_sym_CARET] = ACTIONS(5893),
    [anon_sym_STAR_STAR] = ACTIONS(5893),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_implements] = ACTIONS(5893),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_in] = ACTIONS(7192),
  },
  [3758] = {
    [anon_sym_EQ_GT] = ACTIONS(8713),
    [sym_comment] = ACTIONS(3),
  },
  [3759] = {
    [sym_union_type] = STATE(4243),
    [sym__type] = STATE(4243),
    [sym_constructor_type] = STATE(4243),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2263),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4243),
    [sym_function_type] = STATE(4243),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2264),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(4743),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(4749),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(4747),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(4751),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(4745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3760] = {
    [sym_union_type] = STATE(4244),
    [sym__type] = STATE(4244),
    [sym_constructor_type] = STATE(4244),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2263),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4244),
    [sym_function_type] = STATE(4244),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2264),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(4743),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(4749),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(4747),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(4751),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(4745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3761] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_BANG] = ACTIONS(7208),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(8709),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_LT_LT] = ACTIONS(6040),
    [anon_sym_STAR] = ACTIONS(7208),
    [anon_sym_LBRACE] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(6040),
    [anon_sym_GT_GT_GT] = ACTIONS(6040),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_BANG_EQ] = ACTIONS(7208),
    [anon_sym_LT_EQ] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [anon_sym_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_AMP] = ACTIONS(8711),
    [anon_sym_PERCENT] = ACTIONS(6040),
    [anon_sym_QMARK] = ACTIONS(6040),
    [anon_sym_as] = ACTIONS(6040),
    [anon_sym_PIPE_PIPE] = ACTIONS(6040),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_instanceof] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6040),
    [anon_sym_CARET] = ACTIONS(6040),
    [anon_sym_STAR_STAR] = ACTIONS(6040),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_implements] = ACTIONS(6040),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6040),
    [anon_sym_in] = ACTIONS(7208),
  },
  [3762] = {
    [anon_sym_EQ_GT] = ACTIONS(8715),
    [sym_comment] = ACTIONS(3),
  },
  [3763] = {
    [sym_union_type] = STATE(4246),
    [sym__type] = STATE(4246),
    [sym_constructor_type] = STATE(4246),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2277),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4246),
    [sym_function_type] = STATE(4246),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2278),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1121),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4771),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4773),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3764] = {
    [sym_union_type] = STATE(4247),
    [sym__type] = STATE(4247),
    [sym_constructor_type] = STATE(4247),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2277),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4247),
    [sym_function_type] = STATE(4247),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2278),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1121),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4771),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4773),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3765] = {
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(6482),
    [anon_sym_PIPE] = ACTIONS(6484),
    [anon_sym_COMMA] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6040),
  },
  [3766] = {
    [anon_sym_AMP] = ACTIONS(2805),
    [anon_sym_PIPE] = ACTIONS(2807),
    [anon_sym_COMMA] = ACTIONS(8547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8547),
  },
  [3767] = {
    [sym_type_annotation] = STATE(4248),
    [anon_sym_COLON] = ACTIONS(6594),
    [sym_comment] = ACTIONS(3),
  },
  [3768] = {
    [sym_type_annotation] = STATE(4249),
    [anon_sym_COLON] = ACTIONS(6594),
    [sym_comment] = ACTIONS(3),
  },
  [3769] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4839),
    [anon_sym_LT_LT] = ACTIONS(4841),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_GT_GT_GT] = ACTIONS(4841),
    [anon_sym_AMP_AMP] = ACTIONS(4847),
    [anon_sym_BANG_EQ] = ACTIONS(4795),
    [anon_sym_LT_EQ] = ACTIONS(4837),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(5236),
    [anon_sym_GT_EQ] = ACTIONS(4837),
    [anon_sym_GT] = ACTIONS(4795),
    [anon_sym_AMP] = ACTIONS(4851),
    [anon_sym_PERCENT] = ACTIONS(4841),
    [anon_sym_QMARK] = ACTIONS(4853),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(4855),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4795),
    [anon_sym_instanceof] = ACTIONS(4837),
    [anon_sym_LT] = ACTIONS(4859),
    [anon_sym_SLASH] = ACTIONS(4845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4855),
    [anon_sym_STAR_STAR] = ACTIONS(4861),
    [anon_sym_PLUS] = ACTIONS(4843),
    [anon_sym_GT_GT] = ACTIONS(4845),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4837),
    [anon_sym_in] = ACTIONS(4795),
  },
  [3770] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4839),
    [anon_sym_LT_LT] = ACTIONS(4841),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_GT_GT_GT] = ACTIONS(4841),
    [anon_sym_AMP_AMP] = ACTIONS(4847),
    [anon_sym_BANG_EQ] = ACTIONS(4795),
    [anon_sym_LT_EQ] = ACTIONS(4837),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(5240),
    [anon_sym_GT_EQ] = ACTIONS(4837),
    [anon_sym_GT] = ACTIONS(4795),
    [anon_sym_AMP] = ACTIONS(4851),
    [anon_sym_PERCENT] = ACTIONS(4841),
    [anon_sym_QMARK] = ACTIONS(4853),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(4855),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4795),
    [anon_sym_instanceof] = ACTIONS(4837),
    [anon_sym_LT] = ACTIONS(4859),
    [anon_sym_SLASH] = ACTIONS(4845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4855),
    [anon_sym_STAR_STAR] = ACTIONS(4861),
    [anon_sym_PLUS] = ACTIONS(4843),
    [anon_sym_GT_GT] = ACTIONS(4845),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4837),
    [anon_sym_in] = ACTIONS(4795),
  },
  [3771] = {
    [sym_new_expression] = STATE(4250),
    [sym_augmented_assignment_expression] = STATE(4250),
    [sym_unary_expression] = STATE(4250),
    [sym_update_expression] = STATE(4250),
    [sym_call_signature] = STATE(1372),
    [sym_meta_property] = STATE(4250),
    [sym_regex] = STATE(4250),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4250),
    [sym_non_null_expression] = STATE(4250),
    [sym_as_expression] = STATE(4250),
    [sym_jsx_fragment] = STATE(4250),
    [sym_yield_expression] = STATE(4250),
    [sym_jsx_element] = STATE(4250),
    [sym_internal_module] = STATE(4250),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4250),
    [sym_await_expression] = STATE(4250),
    [sym_member_expression] = STATE(1374),
    [sym_string] = STATE(4250),
    [sym_this] = STATE(4250),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1375),
    [sym_anonymous_class] = STATE(4250),
    [sym_generator_function] = STATE(4250),
    [sym_call_expression] = STATE(4250),
    [sym_subscript_expression] = STATE(1374),
    [sym_assignment_expression] = STATE(4250),
    [sym_ternary_expression] = STATE(4250),
    [sym_binary_expression] = STATE(4250),
    [sym_template_string] = STATE(4250),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4250),
    [sym_array] = STATE(1376),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4250),
    [sym_class] = STATE(4250),
    [anon_sym_BANG] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2968),
    [sym_false] = ACTIONS(8717),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8717),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_private] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2972),
    [anon_sym_get] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8719),
    [sym_true] = ACTIONS(8717),
    [anon_sym_yield] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8717),
    [anon_sym_set] = ACTIONS(2972),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2829),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
  },
  [3772] = {
    [sym_union_type] = STATE(4251),
    [sym__type] = STATE(4251),
    [sym_constructor_type] = STATE(4251),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3121),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4251),
    [sym_function_type] = STATE(4251),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3122),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(6550),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(6556),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(6554),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(6558),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(6552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3773] = {
    [sym_formal_parameters] = STATE(4252),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3774] = {
    [anon_sym_EQ_GT] = ACTIONS(8721),
    [sym_comment] = ACTIONS(3),
  },
  [3775] = {
    [sym_union_type] = STATE(3067),
    [sym__type] = STATE(3067),
    [sym_constructor_type] = STATE(3067),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3121),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3067),
    [sym_function_type] = STATE(3067),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3122),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(6550),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(6556),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(6554),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(6558),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(6552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3776] = {
    [sym_union_type] = STATE(3068),
    [sym__type] = STATE(3068),
    [sym_constructor_type] = STATE(3068),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3121),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3068),
    [sym_function_type] = STATE(3068),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3122),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(6550),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(6556),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(6554),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(6558),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(6552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3777] = {
    [anon_sym_EQ_GT] = ACTIONS(8723),
    [sym_comment] = ACTIONS(3),
  },
  [3778] = {
    [sym_union_type] = STATE(4255),
    [sym__type] = STATE(4255),
    [sym_constructor_type] = STATE(4255),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3121),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4255),
    [sym_function_type] = STATE(4255),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3122),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(6550),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(6556),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(6554),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(6558),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(6552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3779] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4787),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4787),
    [anon_sym_AMP_EQ] = ACTIONS(4787),
    [anon_sym_PLUS_EQ] = ACTIONS(4787),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_EQ] = ACTIONS(4789),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_CARET_EQ] = ACTIONS(4787),
    [anon_sym_STAR_EQ] = ACTIONS(4787),
    [anon_sym_PIPE_EQ] = ACTIONS(4787),
    [anon_sym_DASH_EQ] = ACTIONS(4787),
    [anon_sym_EQ_GT] = ACTIONS(4791),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4787),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4787),
    [anon_sym_GT_GT_EQ] = ACTIONS(4787),
    [anon_sym_DOT] = ACTIONS(7050),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4787),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4795),
  },
  [3780] = {
    [sym__automatic_semicolon] = ACTIONS(7980),
    [anon_sym_LBRACK] = ACTIONS(7980),
    [sym_identifier] = ACTIONS(8725),
    [anon_sym_SEMI] = ACTIONS(7980),
    [anon_sym_module] = ACTIONS(8725),
    [anon_sym_symbol] = ACTIONS(8725),
    [anon_sym_number] = ACTIONS(8725),
    [anon_sym_AT] = ACTIONS(7980),
    [anon_sym_declare] = ACTIONS(8725),
    [anon_sym_STAR] = ACTIONS(7980),
    [anon_sym_void] = ACTIONS(8725),
    [anon_sym_any] = ACTIONS(8725),
    [anon_sym_private] = ACTIONS(8725),
    [anon_sym_boolean] = ACTIONS(8725),
    [anon_sym_async] = ACTIONS(8725),
    [anon_sym_public] = ACTIONS(8725),
    [anon_sym_get] = ACTIONS(8725),
    [anon_sym_RBRACE] = ACTIONS(7980),
    [anon_sym_static] = ACTIONS(8725),
    [anon_sym_SQUOTE] = ACTIONS(7980),
    [sym_number] = ACTIONS(7980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(8725),
    [anon_sym_string] = ACTIONS(8725),
    [anon_sym_abstract] = ACTIONS(8725),
    [anon_sym_set] = ACTIONS(8725),
    [anon_sym_type] = ACTIONS(8725),
    [anon_sym_import] = ACTIONS(8725),
    [anon_sym_export] = ACTIONS(8725),
    [anon_sym_namespace] = ACTIONS(8725),
    [sym_readonly] = ACTIONS(8725),
    [anon_sym_DQUOTE] = ACTIONS(7980),
  },
  [3781] = {
    [sym_statement_block] = STATE(4256),
    [sym__automatic_semicolon] = ACTIONS(8727),
    [anon_sym_SEMI] = ACTIONS(8727),
    [anon_sym_COMMA] = ACTIONS(8727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4899),
  },
  [3782] = {
    [sym_type_parameters] = STATE(1395),
    [sym_formal_parameters] = STATE(1397),
    [sym_call_signature] = STATE(4257),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3783] = {
    [sym_type_parameters] = STATE(1395),
    [sym_formal_parameters] = STATE(1397),
    [sym_call_signature] = STATE(4257),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(8729),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [3784] = {
    [sym__automatic_semicolon] = ACTIONS(8731),
    [anon_sym_SEMI] = ACTIONS(8731),
    [anon_sym_COMMA] = ACTIONS(8731),
    [sym_comment] = ACTIONS(3),
  },
  [3785] = {
    [sym__initializer] = STATE(4259),
    [sym__automatic_semicolon] = ACTIONS(8731),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(8731),
    [anon_sym_COMMA] = ACTIONS(8731),
    [sym_comment] = ACTIONS(3),
  },
  [3786] = {
    [sym__automatic_semicolon] = ACTIONS(8733),
    [anon_sym_SEMI] = ACTIONS(8733),
    [anon_sym_COMMA] = ACTIONS(8733),
    [sym_comment] = ACTIONS(3),
  },
  [3787] = {
    [sym_type_arguments] = STATE(1885),
    [sym__automatic_semicolon] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(3983),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(3985),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(8735),
  },
  [3788] = {
    [sym_index_type_query] = STATE(1887),
    [sym_lookup_type] = STATE(1887),
    [sym_flow_maybe_type] = STATE(1887),
    [sym_parenthesized_type] = STATE(1887),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_array_type] = STATE(1887),
    [sym_type_predicate] = STATE(1887),
    [sym_type_query] = STATE(1887),
    [sym_existential_type] = STATE(1887),
    [sym_this_type] = STATE(1887),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1887),
    [sym__primary_type] = STATE(1887),
    [sym_generic_type] = STATE(1887),
    [sym_literal_type] = STATE(1887),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1887),
    [sym_string] = STATE(1017),
    [sym_tuple_type] = STATE(1887),
    [sym_identifier] = ACTIONS(7911),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(7913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [sym_true] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_LPAREN] = ACTIONS(3989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3789] = {
    [sym_union_type] = STATE(1892),
    [sym__type] = STATE(1892),
    [sym_constructor_type] = STATE(1892),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3793),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1892),
    [sym_function_type] = STATE(1892),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3794),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(7911),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(7913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(7915),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(7917),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(7919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3790] = {
    [sym_type_parameters] = STATE(4261),
    [sym_formal_parameters] = STATE(4262),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3791] = {
    [sym_union_type] = STATE(1900),
    [sym__type] = STATE(1900),
    [sym_constructor_type] = STATE(1900),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3793),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1900),
    [sym_function_type] = STATE(1900),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3794),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(7911),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(7913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(7915),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(7917),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(7919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3792] = {
    [sym__automatic_semicolon] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(8737),
    [anon_sym_SEMI] = ACTIONS(3611),
    [anon_sym_COMMA] = ACTIONS(3611),
    [anon_sym_PIPE] = ACTIONS(8739),
    [sym_comment] = ACTIONS(3),
  },
  [3793] = {
    [sym_formal_parameters] = STATE(4265),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3794] = {
    [anon_sym_EQ_GT] = ACTIONS(8741),
    [sym_comment] = ACTIONS(3),
  },
  [3795] = {
    [sym_union_type] = STATE(4270),
    [sym__type] = STATE(4270),
    [sym_constructor_type] = STATE(4270),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4271),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4270),
    [sym_function_type] = STATE(4270),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4272),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(6598),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(6600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8743),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8745),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3796] = {
    [sym_formal_parameters] = STATE(4273),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3797] = {
    [anon_sym_EQ_GT] = ACTIONS(8749),
    [sym_comment] = ACTIONS(3),
  },
  [3798] = {
    [sym_union_type] = STATE(2790),
    [sym__type] = STATE(2790),
    [sym_constructor_type] = STATE(2790),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3150),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2790),
    [sym_function_type] = STATE(2790),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3151),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(6598),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(6600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(6602),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(6604),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(6606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3799] = {
    [sym_union_type] = STATE(2791),
    [sym__type] = STATE(2791),
    [sym_constructor_type] = STATE(2791),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3150),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2791),
    [sym_function_type] = STATE(2791),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3151),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(6598),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(6600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(6602),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(6604),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(6606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3800] = {
    [anon_sym_EQ_GT] = ACTIONS(8751),
    [sym_comment] = ACTIONS(3),
  },
  [3801] = {
    [sym_union_type] = STATE(4276),
    [sym__type] = STATE(4276),
    [sym_constructor_type] = STATE(4276),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3150),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4276),
    [sym_function_type] = STATE(4276),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3151),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(6598),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(6600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(6602),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(6604),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(6606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3802] = {
    [sym__automatic_semicolon] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [sym_identifier] = ACTIONS(3022),
    [anon_sym_SEMI] = ACTIONS(3024),
    [anon_sym_module] = ACTIONS(3022),
    [anon_sym_symbol] = ACTIONS(3022),
    [anon_sym_number] = ACTIONS(3022),
    [anon_sym_AT] = ACTIONS(3024),
    [anon_sym_declare] = ACTIONS(3022),
    [anon_sym_STAR] = ACTIONS(3024),
    [anon_sym_void] = ACTIONS(3022),
    [anon_sym_any] = ACTIONS(3022),
    [anon_sym_private] = ACTIONS(3022),
    [anon_sym_boolean] = ACTIONS(3022),
    [anon_sym_async] = ACTIONS(3022),
    [anon_sym_public] = ACTIONS(3022),
    [anon_sym_get] = ACTIONS(3022),
    [anon_sym_RBRACE] = ACTIONS(3024),
    [anon_sym_static] = ACTIONS(3022),
    [anon_sym_SQUOTE] = ACTIONS(3024),
    [sym_number] = ACTIONS(3024),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3022),
    [anon_sym_string] = ACTIONS(3022),
    [anon_sym_abstract] = ACTIONS(3022),
    [anon_sym_set] = ACTIONS(3022),
    [anon_sym_type] = ACTIONS(3022),
    [anon_sym_import] = ACTIONS(3022),
    [anon_sym_export] = ACTIONS(3022),
    [anon_sym_namespace] = ACTIONS(3022),
    [sym_readonly] = ACTIONS(3022),
    [anon_sym_DQUOTE] = ACTIONS(3024),
  },
  [3803] = {
    [sym_string] = STATE(4277),
    [sym__property_name] = STATE(4277),
    [sym_computed_property_name] = STATE(4277),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(8753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [3804] = {
    [sym_string] = STATE(4277),
    [sym__property_name] = STATE(4277),
    [sym_computed_property_name] = STATE(4277),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(8753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [3805] = {
    [sym_type_parameters] = STATE(1395),
    [sym__initializer] = STATE(4259),
    [sym_formal_parameters] = STATE(1397),
    [sym_type_annotation] = STATE(4278),
    [sym_call_signature] = STATE(4257),
    [sym__automatic_semicolon] = ACTIONS(8731),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(8731),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(8731),
    [sym_comment] = ACTIONS(3),
  },
  [3806] = {
    [sym__initializer] = STATE(4259),
    [sym_type_annotation] = STATE(4278),
    [sym__automatic_semicolon] = ACTIONS(8731),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(8731),
    [anon_sym_COMMA] = ACTIONS(8731),
    [sym_comment] = ACTIONS(3),
  },
  [3807] = {
    [sym_type_parameters] = STATE(2331),
    [sym_formal_parameters] = STATE(2332),
    [sym_call_signature] = STATE(4279),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3808] = {
    [sym_union_type] = STATE(4280),
    [sym__type] = STATE(4280),
    [sym_constructor_type] = STATE(4280),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4280),
    [sym_function_type] = STATE(4280),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3809] = {
    [sym_union_type] = STATE(4281),
    [sym__type] = STATE(4281),
    [sym_constructor_type] = STATE(4281),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(3167),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4281),
    [sym_function_type] = STATE(4281),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3168),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(6624),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(6626),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6628),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6630),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3810] = {
    [sym_formal_parameters] = STATE(4282),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3811] = {
    [anon_sym_EQ_GT] = ACTIONS(8755),
    [sym_comment] = ACTIONS(3),
  },
  [3812] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(3167),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3168),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(6624),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(6626),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6628),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6630),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3813] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(3167),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3168),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(6624),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(6626),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6628),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6630),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3814] = {
    [anon_sym_EQ_GT] = ACTIONS(8757),
    [sym_comment] = ACTIONS(3),
  },
  [3815] = {
    [sym_union_type] = STATE(4285),
    [sym__type] = STATE(4285),
    [sym_constructor_type] = STATE(4285),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(3167),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4285),
    [sym_function_type] = STATE(4285),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3168),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(6624),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(6626),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6628),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6630),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3816] = {
    [sym_identifier] = ACTIONS(8357),
    [anon_sym_BQUOTE] = ACTIONS(8355),
    [anon_sym_debugger] = ACTIONS(8357),
    [anon_sym_symbol] = ACTIONS(8357),
    [anon_sym_AT] = ACTIONS(8355),
    [anon_sym_DASH] = ACTIONS(8357),
    [anon_sym_void] = ACTIONS(8357),
    [anon_sym_break] = ACTIONS(8357),
    [anon_sym_const] = ACTIONS(8357),
    [sym_super] = ACTIONS(8357),
    [anon_sym_return] = ACTIONS(8357),
    [anon_sym_private] = ACTIONS(8357),
    [anon_sym_get] = ACTIONS(8357),
    [anon_sym_RBRACE] = ACTIONS(8355),
    [anon_sym_interface] = ACTIONS(8357),
    [anon_sym_default] = ACTIONS(8357),
    [anon_sym_enum] = ACTIONS(8357),
    [anon_sym_delete] = ACTIONS(8357),
    [anon_sym_continue] = ACTIONS(8357),
    [anon_sym_DASH_DASH] = ACTIONS(8355),
    [anon_sym_if] = ACTIONS(8357),
    [anon_sym_this] = ACTIONS(8357),
    [anon_sym_yield] = ACTIONS(8357),
    [sym_true] = ACTIONS(8357),
    [anon_sym_throw] = ACTIONS(8357),
    [anon_sym_protected] = ACTIONS(8357),
    [anon_sym_abstract] = ACTIONS(8357),
    [anon_sym_set] = ACTIONS(8357),
    [anon_sym_type] = ACTIONS(8357),
    [anon_sym_import] = ACTIONS(8357),
    [anon_sym_namespace] = ACTIONS(8357),
    [anon_sym_PLUS_PLUS] = ACTIONS(8355),
    [anon_sym_await] = ACTIONS(8357),
    [anon_sym_DQUOTE] = ACTIONS(8355),
    [anon_sym_else] = ACTIONS(8357),
    [anon_sym_BANG] = ACTIONS(8355),
    [anon_sym_for] = ACTIONS(8357),
    [anon_sym_LBRACK] = ACTIONS(8355),
    [sym_false] = ACTIONS(8357),
    [anon_sym_SEMI] = ACTIONS(8355),
    [anon_sym_case] = ACTIONS(8357),
    [anon_sym_module] = ACTIONS(8357),
    [anon_sym_number] = ACTIONS(8357),
    [anon_sym_class] = ACTIONS(8357),
    [anon_sym_declare] = ACTIONS(8357),
    [anon_sym_typeof] = ACTIONS(8357),
    [anon_sym_LBRACE] = ACTIONS(8355),
    [anon_sym_switch] = ACTIONS(8357),
    [anon_sym_LPAREN] = ACTIONS(8355),
    [sym_null] = ACTIONS(8357),
    [anon_sym_any] = ACTIONS(8357),
    [anon_sym_boolean] = ACTIONS(8357),
    [anon_sym_async] = ACTIONS(8357),
    [anon_sym_public] = ACTIONS(8357),
    [anon_sym_var] = ACTIONS(8357),
    [anon_sym_while] = ACTIONS(8357),
    [anon_sym_SQUOTE] = ACTIONS(8355),
    [anon_sym_try] = ACTIONS(8357),
    [anon_sym_LT] = ACTIONS(8355),
    [sym_number] = ACTIONS(8355),
    [anon_sym_SLASH] = ACTIONS(8357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8357),
    [anon_sym_function] = ACTIONS(8357),
    [sym_undefined] = ACTIONS(8357),
    [anon_sym_new] = ACTIONS(8357),
    [ts_builtin_sym_end] = ACTIONS(8355),
    [anon_sym_let] = ACTIONS(8357),
    [anon_sym_PLUS] = ACTIONS(8357),
    [anon_sym_export] = ACTIONS(8357),
    [anon_sym_do] = ACTIONS(8357),
    [anon_sym_TILDE] = ACTIONS(8355),
    [anon_sym_with] = ACTIONS(8357),
  },
  [3817] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(5236),
    [anon_sym_PIPE] = ACTIONS(5004),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_LT_LT] = ACTIONS(5006),
    [anon_sym_STAR] = ACTIONS(5008),
    [anon_sym_GT_GT_GT] = ACTIONS(5006),
    [anon_sym_AMP_AMP] = ACTIONS(5010),
    [anon_sym_DASH] = ACTIONS(5012),
    [anon_sym_BANG_EQ] = ACTIONS(4962),
    [anon_sym_LT_EQ] = ACTIONS(5002),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(5002),
    [anon_sym_GT] = ACTIONS(4962),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(5014),
    [anon_sym_QMARK] = ACTIONS(5016),
    [anon_sym_PERCENT] = ACTIONS(5006),
    [anon_sym_as] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(5020),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(4962),
    [anon_sym_instanceof] = ACTIONS(5002),
    [anon_sym_LT] = ACTIONS(5022),
    [anon_sym_SLASH] = ACTIONS(5008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(5020),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(5012),
    [anon_sym_GT_GT] = ACTIONS(5008),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5002),
    [anon_sym_in] = ACTIONS(4962),
  },
  [3818] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(5240),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(5240),
    [anon_sym_PIPE] = ACTIONS(5004),
    [anon_sym_COMMA] = ACTIONS(5240),
    [anon_sym_LT_LT] = ACTIONS(5006),
    [anon_sym_STAR] = ACTIONS(5008),
    [anon_sym_GT_GT_GT] = ACTIONS(5006),
    [anon_sym_AMP_AMP] = ACTIONS(5010),
    [anon_sym_DASH] = ACTIONS(5012),
    [anon_sym_BANG_EQ] = ACTIONS(4962),
    [anon_sym_LT_EQ] = ACTIONS(5002),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(5002),
    [anon_sym_GT] = ACTIONS(4962),
    [anon_sym_RBRACE] = ACTIONS(5240),
    [anon_sym_AMP] = ACTIONS(5014),
    [anon_sym_QMARK] = ACTIONS(5016),
    [anon_sym_PERCENT] = ACTIONS(5006),
    [anon_sym_as] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(5020),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(4962),
    [anon_sym_instanceof] = ACTIONS(5002),
    [anon_sym_LT] = ACTIONS(5022),
    [anon_sym_SLASH] = ACTIONS(5008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(5020),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(5012),
    [anon_sym_GT_GT] = ACTIONS(5008),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5002),
    [anon_sym_in] = ACTIONS(4962),
  },
  [3819] = {
    [sym_new_expression] = STATE(4286),
    [sym_augmented_assignment_expression] = STATE(4286),
    [sym_unary_expression] = STATE(4286),
    [sym_update_expression] = STATE(4286),
    [sym_call_signature] = STATE(1428),
    [sym_meta_property] = STATE(4286),
    [sym_regex] = STATE(4286),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4286),
    [sym_non_null_expression] = STATE(4286),
    [sym_as_expression] = STATE(4286),
    [sym_jsx_fragment] = STATE(4286),
    [sym_yield_expression] = STATE(4286),
    [sym_jsx_element] = STATE(4286),
    [sym_internal_module] = STATE(4286),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4286),
    [sym_await_expression] = STATE(4286),
    [sym_member_expression] = STATE(1430),
    [sym_string] = STATE(4286),
    [sym_this] = STATE(4286),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(1431),
    [sym_anonymous_class] = STATE(4286),
    [sym_generator_function] = STATE(4286),
    [sym_call_expression] = STATE(4286),
    [sym_subscript_expression] = STATE(1430),
    [sym_assignment_expression] = STATE(4286),
    [sym_ternary_expression] = STATE(4286),
    [sym_binary_expression] = STATE(4286),
    [sym_template_string] = STATE(4286),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4286),
    [sym_array] = STATE(1432),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(4286),
    [sym_class] = STATE(4286),
    [anon_sym_BANG] = ACTIONS(2927),
    [sym_identifier] = ACTIONS(2929),
    [sym_false] = ACTIONS(8759),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(2933),
    [anon_sym_symbol] = ACTIONS(2933),
    [anon_sym_number] = ACTIONS(2933),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2933),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(8759),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(2933),
    [anon_sym_private] = ACTIONS(2933),
    [anon_sym_boolean] = ACTIONS(2933),
    [anon_sym_async] = ACTIONS(2941),
    [anon_sym_public] = ACTIONS(2933),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(8761),
    [sym_true] = ACTIONS(8759),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(2933),
    [anon_sym_string] = ACTIONS(2933),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(8759),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2933),
    [anon_sym_new] = ACTIONS(2949),
    [anon_sym_import] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(2933),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
  },
  [3820] = {
    [sym_union_type] = STATE(4287),
    [sym__type] = STATE(4287),
    [sym_constructor_type] = STATE(4287),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(3191),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(4287),
    [sym_function_type] = STATE(4287),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(3192),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(6681),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(6687),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(6685),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(6689),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(6683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [3821] = {
    [sym_formal_parameters] = STATE(4288),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3822] = {
    [anon_sym_EQ_GT] = ACTIONS(8763),
    [sym_comment] = ACTIONS(3),
  },
  [3823] = {
    [sym_union_type] = STATE(2678),
    [sym__type] = STATE(2678),
    [sym_constructor_type] = STATE(2678),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(3191),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(2678),
    [sym_function_type] = STATE(2678),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(3192),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(6681),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(6687),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(6685),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(6689),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(6683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [3824] = {
    [sym_union_type] = STATE(2679),
    [sym__type] = STATE(2679),
    [sym_constructor_type] = STATE(2679),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(3191),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(2679),
    [sym_function_type] = STATE(2679),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(3192),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(6681),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(6687),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(6685),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(6689),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(6683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [3825] = {
    [anon_sym_EQ_GT] = ACTIONS(8765),
    [sym_comment] = ACTIONS(3),
  },
  [3826] = {
    [sym_union_type] = STATE(4291),
    [sym__type] = STATE(4291),
    [sym_constructor_type] = STATE(4291),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(3191),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(4291),
    [sym_function_type] = STATE(4291),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(3192),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(6681),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(6687),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(6685),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(6689),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(6683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [3827] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4958),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4958),
    [anon_sym_AMP_EQ] = ACTIONS(4958),
    [anon_sym_PLUS_EQ] = ACTIONS(4958),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_CARET_EQ] = ACTIONS(4958),
    [anon_sym_STAR_EQ] = ACTIONS(4958),
    [anon_sym_PIPE_EQ] = ACTIONS(4958),
    [anon_sym_DASH_EQ] = ACTIONS(4958),
    [anon_sym_EQ_GT] = ACTIONS(4960),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4958),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4958),
    [anon_sym_GT_GT_EQ] = ACTIONS(4958),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4958),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4962),
  },
  [3828] = {
    [anon_sym_LBRACK] = ACTIONS(6061),
    [sym_identifier] = ACTIONS(6063),
    [anon_sym_module] = ACTIONS(6063),
    [anon_sym_symbol] = ACTIONS(6063),
    [anon_sym_number] = ACTIONS(6063),
    [anon_sym_AT] = ACTIONS(6061),
    [anon_sym_class] = ACTIONS(6063),
    [anon_sym_declare] = ACTIONS(6063),
    [anon_sym_STAR] = ACTIONS(6061),
    [anon_sym_void] = ACTIONS(6063),
    [anon_sym_any] = ACTIONS(6063),
    [anon_sym_private] = ACTIONS(6063),
    [anon_sym_boolean] = ACTIONS(6063),
    [anon_sym_async] = ACTIONS(6063),
    [anon_sym_public] = ACTIONS(6063),
    [anon_sym_get] = ACTIONS(6063),
    [anon_sym_static] = ACTIONS(6063),
    [anon_sym_RBRACE] = ACTIONS(6061),
    [anon_sym_SQUOTE] = ACTIONS(6061),
    [sym_number] = ACTIONS(6061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(6063),
    [anon_sym_string] = ACTIONS(6063),
    [anon_sym_abstract] = ACTIONS(6063),
    [anon_sym_set] = ACTIONS(6063),
    [anon_sym_type] = ACTIONS(6063),
    [anon_sym_import] = ACTIONS(6063),
    [anon_sym_export] = ACTIONS(6063),
    [sym_readonly] = ACTIONS(6063),
    [anon_sym_namespace] = ACTIONS(6063),
    [anon_sym_DQUOTE] = ACTIONS(6061),
  },
  [3829] = {
    [anon_sym_COMMA] = ACTIONS(8767),
    [anon_sym_RBRACE] = ACTIONS(8767),
    [sym_comment] = ACTIONS(3),
  },
  [3830] = {
    [sym_statement_block] = STATE(4292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [3831] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(4293),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3832] = {
    [sym_type_alias_declaration] = STATE(2092),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(2092),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(2092),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(2092),
    [sym_return_statement] = STATE(2092),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(2092),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2092),
    [sym_switch_statement] = STATE(2092),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(2092),
    [sym_throw_statement] = STATE(2092),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(2092),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(2092),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(2092),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(2092),
    [sym_abstract_class] = STATE(2092),
    [sym_interface_declaration] = STATE(2092),
    [sym_statement_block] = STATE(2092),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(2092),
    [sym_debugger_statement] = STATE(2092),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(2092),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(2092),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(2092),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(2092),
    [sym_empty_statement] = STATE(2092),
    [sym_import_alias] = STATE(2092),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(2092),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(2092),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(2092),
    [sym_break_statement] = STATE(2092),
    [sym_labeled_statement] = STATE(2092),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(2092),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [3833] = {
    [sym_array] = STATE(4295),
    [sym_object] = STATE(4296),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(8769),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [3834] = {
    [anon_sym_of] = ACTIONS(8771),
    [sym_comment] = ACTIONS(3),
  },
  [3835] = {
    [anon_sym_of] = ACTIONS(8773),
    [sym_comment] = ACTIONS(3),
  },
  [3836] = {
    [anon_sym_of] = ACTIONS(8775),
    [sym_comment] = ACTIONS(3),
  },
  [3837] = {
    [sym_new_expression] = STATE(4300),
    [sym_augmented_assignment_expression] = STATE(4300),
    [sym_unary_expression] = STATE(4300),
    [sym_update_expression] = STATE(4300),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(4300),
    [sym_regex] = STATE(4300),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4300),
    [sym_non_null_expression] = STATE(4300),
    [sym_as_expression] = STATE(4300),
    [sym_jsx_fragment] = STATE(4300),
    [sym_yield_expression] = STATE(4300),
    [sym_jsx_element] = STATE(4300),
    [sym_internal_module] = STATE(4300),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4300),
    [sym_await_expression] = STATE(4300),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(4301),
    [sym_string] = STATE(4300),
    [sym_this] = STATE(4300),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(4300),
    [sym_generator_function] = STATE(4300),
    [sym_call_expression] = STATE(4300),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(4300),
    [sym_ternary_expression] = STATE(4300),
    [sym_binary_expression] = STATE(4300),
    [sym_template_string] = STATE(4300),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4300),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(4300),
    [sym_class] = STATE(4300),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(8777),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(8777),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(8779),
    [sym_true] = ACTIONS(8777),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(8777),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [3838] = {
    [sym_new_expression] = STATE(4302),
    [sym_augmented_assignment_expression] = STATE(4302),
    [sym_unary_expression] = STATE(4302),
    [sym_update_expression] = STATE(4302),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4302),
    [sym_regex] = STATE(4302),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4302),
    [sym_non_null_expression] = STATE(4302),
    [sym_as_expression] = STATE(4302),
    [sym_jsx_fragment] = STATE(4302),
    [sym_yield_expression] = STATE(4302),
    [sym_jsx_element] = STATE(4302),
    [sym_internal_module] = STATE(4302),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4302),
    [sym_await_expression] = STATE(4302),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4302),
    [sym_this] = STATE(4302),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4302),
    [sym_generator_function] = STATE(4302),
    [sym_call_expression] = STATE(4302),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4302),
    [sym_ternary_expression] = STATE(4302),
    [sym_binary_expression] = STATE(4302),
    [sym_template_string] = STATE(4302),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4302),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4302),
    [sym_class] = STATE(4302),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(8781),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8781),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8783),
    [sym_true] = ACTIONS(8781),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8781),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3839] = {
    [sym__initializer] = STATE(391),
    [sym_type_annotation] = STATE(392),
    [sym__automatic_semicolon] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(715),
    [anon_sym_of] = ACTIONS(8771),
    [anon_sym_COMMA] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(8785),
  },
  [3840] = {
    [sym__initializer] = STATE(411),
    [sym_type_annotation] = STATE(412),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(745),
    [anon_sym_of] = ACTIONS(8773),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(8787),
  },
  [3841] = {
    [sym__initializer] = STATE(413),
    [sym_type_annotation] = STATE(414),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(745),
    [anon_sym_of] = ACTIONS(8775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(8789),
  },
  [3842] = {
    [sym_new_expression] = STATE(4307),
    [sym_augmented_assignment_expression] = STATE(4307),
    [sym_unary_expression] = STATE(4307),
    [sym_update_expression] = STATE(4307),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(4307),
    [sym_regex] = STATE(4307),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4307),
    [sym_non_null_expression] = STATE(4307),
    [sym_as_expression] = STATE(4307),
    [sym_jsx_fragment] = STATE(4307),
    [sym_yield_expression] = STATE(4307),
    [sym_jsx_element] = STATE(4307),
    [sym_internal_module] = STATE(4307),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4307),
    [sym_await_expression] = STATE(4307),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(4308),
    [sym_string] = STATE(4307),
    [sym_this] = STATE(4307),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(4307),
    [sym_generator_function] = STATE(4307),
    [sym_call_expression] = STATE(4307),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(4307),
    [sym_ternary_expression] = STATE(4307),
    [sym_binary_expression] = STATE(4307),
    [sym_template_string] = STATE(4307),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4307),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4307),
    [sym_class] = STATE(4307),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(8791),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8791),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_RPAREN] = ACTIONS(8793),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8795),
    [sym_true] = ACTIONS(8791),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8791),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [3843] = {
    [sym_new_expression] = STATE(4309),
    [sym_augmented_assignment_expression] = STATE(4309),
    [sym_unary_expression] = STATE(4309),
    [sym_update_expression] = STATE(4309),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4309),
    [sym_regex] = STATE(4309),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4309),
    [sym_non_null_expression] = STATE(4309),
    [sym_as_expression] = STATE(4309),
    [sym_jsx_fragment] = STATE(4309),
    [sym_yield_expression] = STATE(4309),
    [sym_jsx_element] = STATE(4309),
    [sym_internal_module] = STATE(4309),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4309),
    [sym_await_expression] = STATE(4309),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4309),
    [sym_this] = STATE(4309),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4309),
    [sym_generator_function] = STATE(4309),
    [sym_call_expression] = STATE(4309),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4309),
    [sym_ternary_expression] = STATE(4309),
    [sym_binary_expression] = STATE(4309),
    [sym_template_string] = STATE(4309),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4309),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4309),
    [sym_class] = STATE(4309),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(8797),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8797),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8799),
    [sym_true] = ACTIONS(8797),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8797),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3844] = {
    [sym_new_expression] = STATE(4310),
    [sym_augmented_assignment_expression] = STATE(4310),
    [sym_unary_expression] = STATE(4310),
    [sym_update_expression] = STATE(4310),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(4310),
    [sym_regex] = STATE(4310),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4310),
    [sym_non_null_expression] = STATE(4310),
    [sym_as_expression] = STATE(4310),
    [sym_jsx_fragment] = STATE(4310),
    [sym_yield_expression] = STATE(4310),
    [sym_jsx_element] = STATE(4310),
    [sym_internal_module] = STATE(4310),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4310),
    [sym_await_expression] = STATE(4310),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(4311),
    [sym_string] = STATE(4310),
    [sym_this] = STATE(4310),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(4310),
    [sym_generator_function] = STATE(4310),
    [sym_call_expression] = STATE(4310),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(4310),
    [sym_ternary_expression] = STATE(4310),
    [sym_binary_expression] = STATE(4310),
    [sym_template_string] = STATE(4310),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4310),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(4310),
    [sym_class] = STATE(4310),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(8801),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(8801),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(8803),
    [sym_true] = ACTIONS(8801),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(8801),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [3845] = {
    [sym_new_expression] = STATE(4312),
    [sym_augmented_assignment_expression] = STATE(4312),
    [sym_unary_expression] = STATE(4312),
    [sym_update_expression] = STATE(4312),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4312),
    [sym_regex] = STATE(4312),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4312),
    [sym_non_null_expression] = STATE(4312),
    [sym_as_expression] = STATE(4312),
    [sym_jsx_fragment] = STATE(4312),
    [sym_yield_expression] = STATE(4312),
    [sym_jsx_element] = STATE(4312),
    [sym_internal_module] = STATE(4312),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4312),
    [sym_await_expression] = STATE(4312),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4312),
    [sym_this] = STATE(4312),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4312),
    [sym_generator_function] = STATE(4312),
    [sym_call_expression] = STATE(4312),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4312),
    [sym_ternary_expression] = STATE(4312),
    [sym_binary_expression] = STATE(4312),
    [sym_template_string] = STATE(4312),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4312),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4312),
    [sym_class] = STATE(4312),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(8805),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8805),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8807),
    [sym_true] = ACTIONS(8805),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8805),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3846] = {
    [sym_new_expression] = STATE(4313),
    [sym_augmented_assignment_expression] = STATE(4313),
    [sym_unary_expression] = STATE(4313),
    [sym_update_expression] = STATE(4313),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(4313),
    [sym_regex] = STATE(4313),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4313),
    [sym_non_null_expression] = STATE(4313),
    [sym_as_expression] = STATE(4313),
    [sym_jsx_fragment] = STATE(4313),
    [sym_yield_expression] = STATE(4313),
    [sym_jsx_element] = STATE(4313),
    [sym_internal_module] = STATE(4313),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4313),
    [sym_await_expression] = STATE(4313),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(4314),
    [sym_string] = STATE(4313),
    [sym_this] = STATE(4313),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(4313),
    [sym_generator_function] = STATE(4313),
    [sym_call_expression] = STATE(4313),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(4313),
    [sym_ternary_expression] = STATE(4313),
    [sym_binary_expression] = STATE(4313),
    [sym_template_string] = STATE(4313),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4313),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(4313),
    [sym_class] = STATE(4313),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(8809),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(8809),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(8811),
    [sym_true] = ACTIONS(8809),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(8809),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [3847] = {
    [anon_sym_COLON] = ACTIONS(8813),
    [sym_comment] = ACTIONS(3),
  },
  [3848] = {
    [sym_new_expression] = STATE(4316),
    [sym_augmented_assignment_expression] = STATE(4316),
    [sym_unary_expression] = STATE(4316),
    [sym_update_expression] = STATE(4316),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4316),
    [sym_regex] = STATE(4316),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4316),
    [sym_non_null_expression] = STATE(4316),
    [sym_as_expression] = STATE(4316),
    [sym_jsx_fragment] = STATE(4316),
    [sym_yield_expression] = STATE(4316),
    [sym_jsx_element] = STATE(4316),
    [sym_internal_module] = STATE(4316),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4316),
    [sym_await_expression] = STATE(4316),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4316),
    [sym_this] = STATE(4316),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4316),
    [sym_generator_function] = STATE(4316),
    [sym_call_expression] = STATE(4316),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4316),
    [sym_ternary_expression] = STATE(4316),
    [sym_binary_expression] = STATE(4316),
    [sym_template_string] = STATE(4316),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4316),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4316),
    [sym_class] = STATE(4316),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(8815),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8815),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8817),
    [sym_true] = ACTIONS(8815),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8815),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3849] = {
    [sym_new_expression] = STATE(4317),
    [sym_augmented_assignment_expression] = STATE(4317),
    [sym_unary_expression] = STATE(4317),
    [sym_update_expression] = STATE(4317),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4317),
    [sym_regex] = STATE(4317),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4317),
    [sym_non_null_expression] = STATE(4317),
    [sym_as_expression] = STATE(4317),
    [sym_jsx_fragment] = STATE(4317),
    [sym_yield_expression] = STATE(4317),
    [sym_jsx_element] = STATE(4317),
    [sym_internal_module] = STATE(4317),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4317),
    [sym_await_expression] = STATE(4317),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4317),
    [sym_this] = STATE(4317),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4317),
    [sym_generator_function] = STATE(4317),
    [sym_call_expression] = STATE(4317),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4317),
    [sym_ternary_expression] = STATE(4317),
    [sym_binary_expression] = STATE(4317),
    [sym_template_string] = STATE(4317),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4317),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4317),
    [sym_class] = STATE(4317),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(8819),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8819),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8821),
    [sym_true] = ACTIONS(8819),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8819),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3850] = {
    [sym_new_expression] = STATE(4318),
    [sym_augmented_assignment_expression] = STATE(4318),
    [sym_unary_expression] = STATE(4318),
    [sym_update_expression] = STATE(4318),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4318),
    [sym_regex] = STATE(4318),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4318),
    [sym_non_null_expression] = STATE(4318),
    [sym_as_expression] = STATE(4318),
    [sym_jsx_fragment] = STATE(4318),
    [sym_yield_expression] = STATE(4318),
    [sym_jsx_element] = STATE(4318),
    [sym_internal_module] = STATE(4318),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4318),
    [sym_await_expression] = STATE(4318),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4318),
    [sym_this] = STATE(4318),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4318),
    [sym_generator_function] = STATE(4318),
    [sym_call_expression] = STATE(4318),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4318),
    [sym_ternary_expression] = STATE(4318),
    [sym_binary_expression] = STATE(4318),
    [sym_template_string] = STATE(4318),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4318),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4318),
    [sym_class] = STATE(4318),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(8823),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8823),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8825),
    [sym_true] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8823),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [3851] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(8827),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3852] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(8829),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3853] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(8831),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3854] = {
    [sym_type_alias_declaration] = STATE(3704),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3704),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3704),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3704),
    [sym_return_statement] = STATE(3704),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3704),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3704),
    [sym_switch_statement] = STATE(3704),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3704),
    [sym_throw_statement] = STATE(3704),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3704),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3704),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(3704),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3704),
    [sym_abstract_class] = STATE(3704),
    [sym_interface_declaration] = STATE(3704),
    [sym_statement_block] = STATE(3704),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3704),
    [sym_debugger_statement] = STATE(3704),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3704),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3704),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3704),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3704),
    [sym_empty_statement] = STATE(3704),
    [sym_import_alias] = STATE(3704),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3704),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3704),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3704),
    [sym_break_statement] = STATE(3704),
    [sym_labeled_statement] = STATE(3704),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3704),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [3855] = {
    [sym_type_alias_declaration] = STATE(3732),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3732),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3732),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3732),
    [sym_return_statement] = STATE(3732),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3732),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3732),
    [sym_switch_statement] = STATE(3732),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3732),
    [sym_throw_statement] = STATE(3732),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3732),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3732),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(3732),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3732),
    [sym_abstract_class] = STATE(3732),
    [sym_interface_declaration] = STATE(3732),
    [sym_statement_block] = STATE(3732),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3732),
    [sym_debugger_statement] = STATE(3732),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3732),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3732),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3732),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3732),
    [sym_empty_statement] = STATE(3732),
    [sym_import_alias] = STATE(3732),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3732),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3732),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3732),
    [sym_break_statement] = STATE(3732),
    [sym_labeled_statement] = STATE(3732),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3732),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [3856] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(8833),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3857] = {
    [anon_sym_RPAREN] = ACTIONS(8833),
    [sym_comment] = ACTIONS(3),
  },
  [3858] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(8835),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3859] = {
    [anon_sym_RPAREN] = ACTIONS(8835),
    [sym_comment] = ACTIONS(3),
  },
  [3860] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(8837),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3861] = {
    [anon_sym_RPAREN] = ACTIONS(8837),
    [sym_comment] = ACTIONS(3),
  },
  [3862] = {
    [sym_type_alias_declaration] = STATE(3737),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3737),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3737),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3737),
    [sym_return_statement] = STATE(3737),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3737),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3737),
    [sym_switch_statement] = STATE(3737),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3737),
    [sym_throw_statement] = STATE(3737),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3737),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3737),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(3737),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3737),
    [sym_abstract_class] = STATE(3737),
    [sym_interface_declaration] = STATE(3737),
    [sym_statement_block] = STATE(3737),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3737),
    [sym_debugger_statement] = STATE(3737),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3737),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3737),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3737),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3737),
    [sym_empty_statement] = STATE(3737),
    [sym_import_alias] = STATE(3737),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3737),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3737),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3737),
    [sym_break_statement] = STATE(3737),
    [sym_labeled_statement] = STATE(3737),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3737),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [3863] = {
    [sym_type_alias_declaration] = STATE(3738),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3738),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3738),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3738),
    [sym_return_statement] = STATE(3738),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3738),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3738),
    [sym_switch_statement] = STATE(3738),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3738),
    [sym_throw_statement] = STATE(3738),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3738),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3738),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(3738),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3738),
    [sym_abstract_class] = STATE(3738),
    [sym_interface_declaration] = STATE(3738),
    [sym_statement_block] = STATE(3738),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3738),
    [sym_debugger_statement] = STATE(3738),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3738),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3738),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3738),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3738),
    [sym_empty_statement] = STATE(3738),
    [sym_import_alias] = STATE(3738),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3738),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3738),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3738),
    [sym_break_statement] = STATE(3738),
    [sym_labeled_statement] = STATE(3738),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3738),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [3864] = {
    [sym_type_alias_declaration] = STATE(3739),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3739),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3739),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3739),
    [sym_return_statement] = STATE(3739),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3739),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3739),
    [sym_switch_statement] = STATE(3739),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3739),
    [sym_throw_statement] = STATE(3739),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3739),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3739),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(3739),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3739),
    [sym_abstract_class] = STATE(3739),
    [sym_interface_declaration] = STATE(3739),
    [sym_statement_block] = STATE(3739),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3739),
    [sym_debugger_statement] = STATE(3739),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3739),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3739),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3739),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3739),
    [sym_empty_statement] = STATE(3739),
    [sym_import_alias] = STATE(3739),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3739),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3739),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3739),
    [sym_break_statement] = STATE(3739),
    [sym_labeled_statement] = STATE(3739),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3739),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [3865] = {
    [sym_type_alias_declaration] = STATE(3740),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3740),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3740),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3740),
    [sym_return_statement] = STATE(3740),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3740),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3740),
    [sym_switch_statement] = STATE(3740),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3740),
    [sym_throw_statement] = STATE(3740),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3740),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3740),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(3740),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3740),
    [sym_abstract_class] = STATE(3740),
    [sym_interface_declaration] = STATE(3740),
    [sym_statement_block] = STATE(3740),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3740),
    [sym_debugger_statement] = STATE(3740),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3740),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3740),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3740),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3740),
    [sym_empty_statement] = STATE(3740),
    [sym_import_alias] = STATE(3740),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3740),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3740),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3740),
    [sym_break_statement] = STATE(3740),
    [sym_labeled_statement] = STATE(3740),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3740),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [3866] = {
    [sym_type_alias_declaration] = STATE(3741),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3741),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3741),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3741),
    [sym_return_statement] = STATE(3741),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3741),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3741),
    [sym_switch_statement] = STATE(3741),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3741),
    [sym_throw_statement] = STATE(3741),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3741),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3741),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(3741),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3741),
    [sym_abstract_class] = STATE(3741),
    [sym_interface_declaration] = STATE(3741),
    [sym_statement_block] = STATE(3741),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3741),
    [sym_debugger_statement] = STATE(3741),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3741),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3741),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3741),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3741),
    [sym_empty_statement] = STATE(3741),
    [sym_import_alias] = STATE(3741),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3741),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3741),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3741),
    [sym_break_statement] = STATE(3741),
    [sym_labeled_statement] = STATE(3741),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3741),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [3867] = {
    [sym_type_arguments] = STATE(1064),
    [sym_identifier] = ACTIONS(3699),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [anon_sym_debugger] = ACTIONS(3699),
    [anon_sym_symbol] = ACTIONS(3699),
    [anon_sym_AT] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_void] = ACTIONS(3699),
    [anon_sym_break] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [sym_super] = ACTIONS(3699),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_private] = ACTIONS(3699),
    [anon_sym_get] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_interface] = ACTIONS(3699),
    [anon_sym_enum] = ACTIONS(3699),
    [anon_sym_delete] = ACTIONS(3699),
    [anon_sym_continue] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(3699),
    [anon_sym_this] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3699),
    [sym_true] = ACTIONS(3699),
    [anon_sym_throw] = ACTIONS(3699),
    [anon_sym_protected] = ACTIONS(3699),
    [anon_sym_abstract] = ACTIONS(3699),
    [anon_sym_DOT] = ACTIONS(4187),
    [anon_sym_set] = ACTIONS(3699),
    [anon_sym_type] = ACTIONS(3699),
    [anon_sym_import] = ACTIONS(3699),
    [anon_sym_namespace] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_await] = ACTIONS(3699),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [sym_false] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_module] = ACTIONS(3699),
    [anon_sym_number] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_declare] = ACTIONS(3699),
    [anon_sym_typeof] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(8839),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [sym_null] = ACTIONS(3699),
    [anon_sym_any] = ACTIONS(3699),
    [anon_sym_boolean] = ACTIONS(3699),
    [anon_sym_async] = ACTIONS(3699),
    [anon_sym_public] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_var] = ACTIONS(3699),
    [anon_sym_while] = ACTIONS(3699),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_try] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(7943),
    [sym_number] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3699),
    [sym_undefined] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_export] = ACTIONS(3699),
    [anon_sym_do] = ACTIONS(3699),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_with] = ACTIONS(3699),
  },
  [3868] = {
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_array_type] = STATE(1066),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym_existential_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(1066),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(1066),
    [sym_string] = STATE(418),
    [sym_tuple_type] = STATE(1066),
    [sym_identifier] = ACTIONS(8050),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8052),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [sym_true] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3869] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(3873),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3874),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8050),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8052),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8054),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8056),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3870] = {
    [sym_type_parameters] = STATE(4326),
    [sym_formal_parameters] = STATE(4327),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3871] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(3873),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3874),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8050),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8052),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8054),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8056),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3872] = {
    [sym_identifier] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7948),
    [anon_sym_debugger] = ACTIONS(7946),
    [anon_sym_symbol] = ACTIONS(7946),
    [anon_sym_AT] = ACTIONS(7948),
    [anon_sym_PIPE] = ACTIONS(8841),
    [anon_sym_DASH] = ACTIONS(7946),
    [anon_sym_void] = ACTIONS(7946),
    [anon_sym_break] = ACTIONS(7946),
    [anon_sym_const] = ACTIONS(7946),
    [sym_super] = ACTIONS(7946),
    [anon_sym_return] = ACTIONS(7946),
    [anon_sym_private] = ACTIONS(7946),
    [anon_sym_get] = ACTIONS(7946),
    [anon_sym_RBRACE] = ACTIONS(7948),
    [anon_sym_interface] = ACTIONS(7946),
    [anon_sym_enum] = ACTIONS(7946),
    [anon_sym_delete] = ACTIONS(7946),
    [anon_sym_continue] = ACTIONS(7946),
    [anon_sym_DASH_DASH] = ACTIONS(7948),
    [anon_sym_if] = ACTIONS(7946),
    [anon_sym_this] = ACTIONS(7946),
    [anon_sym_yield] = ACTIONS(7946),
    [sym_true] = ACTIONS(7946),
    [anon_sym_throw] = ACTIONS(7946),
    [anon_sym_protected] = ACTIONS(7946),
    [anon_sym_abstract] = ACTIONS(7946),
    [anon_sym_set] = ACTIONS(7946),
    [anon_sym_type] = ACTIONS(7946),
    [anon_sym_import] = ACTIONS(7946),
    [anon_sym_namespace] = ACTIONS(7946),
    [anon_sym_PLUS_PLUS] = ACTIONS(7948),
    [anon_sym_await] = ACTIONS(7946),
    [anon_sym_DQUOTE] = ACTIONS(7948),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_for] = ACTIONS(7946),
    [anon_sym_LBRACK] = ACTIONS(7948),
    [sym_false] = ACTIONS(7946),
    [anon_sym_SEMI] = ACTIONS(7948),
    [anon_sym_module] = ACTIONS(7946),
    [anon_sym_number] = ACTIONS(7946),
    [anon_sym_class] = ACTIONS(7946),
    [anon_sym_declare] = ACTIONS(7946),
    [anon_sym_typeof] = ACTIONS(7946),
    [anon_sym_LBRACE] = ACTIONS(7948),
    [anon_sym_switch] = ACTIONS(7946),
    [anon_sym_LPAREN] = ACTIONS(7948),
    [sym_null] = ACTIONS(7946),
    [anon_sym_any] = ACTIONS(7946),
    [anon_sym_boolean] = ACTIONS(7946),
    [anon_sym_async] = ACTIONS(7946),
    [anon_sym_public] = ACTIONS(7946),
    [anon_sym_AMP] = ACTIONS(8843),
    [anon_sym_var] = ACTIONS(7946),
    [anon_sym_while] = ACTIONS(7946),
    [anon_sym_SQUOTE] = ACTIONS(7948),
    [anon_sym_try] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(7948),
    [sym_number] = ACTIONS(7948),
    [anon_sym_SLASH] = ACTIONS(7946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7946),
    [anon_sym_function] = ACTIONS(7946),
    [sym_undefined] = ACTIONS(7946),
    [anon_sym_new] = ACTIONS(7946),
    [anon_sym_let] = ACTIONS(7946),
    [anon_sym_PLUS] = ACTIONS(7946),
    [anon_sym_export] = ACTIONS(7946),
    [anon_sym_do] = ACTIONS(7946),
    [anon_sym_TILDE] = ACTIONS(7948),
    [anon_sym_with] = ACTIONS(7946),
  },
  [3873] = {
    [sym_formal_parameters] = STATE(4330),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3874] = {
    [anon_sym_EQ_GT] = ACTIONS(8845),
    [sym_comment] = ACTIONS(3),
  },
  [3875] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(4293),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(8847),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3876] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6825),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6827),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(6831),
    [anon_sym_STAR] = ACTIONS(6837),
    [anon_sym_GT_GT_GT] = ACTIONS(6831),
    [anon_sym_AMP_AMP] = ACTIONS(6835),
    [anon_sym_DASH] = ACTIONS(6833),
    [anon_sym_BANG_EQ] = ACTIONS(6785),
    [anon_sym_LT_EQ] = ACTIONS(6825),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6825),
    [anon_sym_GT] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6839),
    [anon_sym_PERCENT] = ACTIONS(6831),
    [anon_sym_QMARK] = ACTIONS(6841),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_PIPE_PIPE] = ACTIONS(6843),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6785),
    [anon_sym_instanceof] = ACTIONS(6825),
    [anon_sym_LT] = ACTIONS(6847),
    [anon_sym_SLASH] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6843),
    [anon_sym_STAR_STAR] = ACTIONS(6851),
    [anon_sym_PLUS] = ACTIONS(6833),
    [anon_sym_GT_GT] = ACTIONS(6837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6825),
    [anon_sym_in] = ACTIONS(6785),
  },
  [3877] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6831),
    [anon_sym_STAR] = ACTIONS(6837),
    [anon_sym_GT_GT_GT] = ACTIONS(6831),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6833),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6831),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6847),
    [anon_sym_SLASH] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6851),
    [anon_sym_PLUS] = ACTIONS(6833),
    [anon_sym_GT_GT] = ACTIONS(6837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3878] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6825),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6827),
    [anon_sym_COMMA] = ACTIONS(2003),
    [anon_sym_LT_LT] = ACTIONS(6831),
    [anon_sym_STAR] = ACTIONS(6837),
    [anon_sym_GT_GT_GT] = ACTIONS(6831),
    [anon_sym_AMP_AMP] = ACTIONS(6835),
    [anon_sym_DASH] = ACTIONS(6833),
    [anon_sym_BANG_EQ] = ACTIONS(6785),
    [anon_sym_LT_EQ] = ACTIONS(6825),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6825),
    [anon_sym_GT] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6839),
    [anon_sym_PERCENT] = ACTIONS(6831),
    [anon_sym_QMARK] = ACTIONS(6841),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_PIPE_PIPE] = ACTIONS(6843),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6785),
    [anon_sym_instanceof] = ACTIONS(6825),
    [anon_sym_LT] = ACTIONS(6847),
    [anon_sym_SLASH] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2003),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6843),
    [anon_sym_STAR_STAR] = ACTIONS(6851),
    [anon_sym_PLUS] = ACTIONS(6833),
    [anon_sym_GT_GT] = ACTIONS(6837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6825),
    [anon_sym_in] = ACTIONS(6785),
  },
  [3879] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6825),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6827),
    [anon_sym_COMMA] = ACTIONS(2005),
    [anon_sym_LT_LT] = ACTIONS(6831),
    [anon_sym_STAR] = ACTIONS(6837),
    [anon_sym_GT_GT_GT] = ACTIONS(6831),
    [anon_sym_AMP_AMP] = ACTIONS(6835),
    [anon_sym_DASH] = ACTIONS(6833),
    [anon_sym_BANG_EQ] = ACTIONS(6785),
    [anon_sym_LT_EQ] = ACTIONS(6825),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6825),
    [anon_sym_GT] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6839),
    [anon_sym_PERCENT] = ACTIONS(6831),
    [anon_sym_QMARK] = ACTIONS(6841),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_PIPE_PIPE] = ACTIONS(6843),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6785),
    [anon_sym_instanceof] = ACTIONS(6825),
    [anon_sym_LT] = ACTIONS(6847),
    [anon_sym_SLASH] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2005),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6843),
    [anon_sym_STAR_STAR] = ACTIONS(6851),
    [anon_sym_PLUS] = ACTIONS(6833),
    [anon_sym_GT_GT] = ACTIONS(6837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6825),
    [anon_sym_in] = ACTIONS(6785),
  },
  [3880] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6825),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6827),
    [anon_sym_COMMA] = ACTIONS(2101),
    [anon_sym_LT_LT] = ACTIONS(6831),
    [anon_sym_STAR] = ACTIONS(6837),
    [anon_sym_GT_GT_GT] = ACTIONS(6831),
    [anon_sym_AMP_AMP] = ACTIONS(6835),
    [anon_sym_DASH] = ACTIONS(6833),
    [anon_sym_BANG_EQ] = ACTIONS(6785),
    [anon_sym_LT_EQ] = ACTIONS(6825),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6825),
    [anon_sym_GT] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6839),
    [anon_sym_PERCENT] = ACTIONS(6831),
    [anon_sym_QMARK] = ACTIONS(6841),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_PIPE_PIPE] = ACTIONS(6843),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6785),
    [anon_sym_instanceof] = ACTIONS(6825),
    [anon_sym_LT] = ACTIONS(6847),
    [anon_sym_SLASH] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2101),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6843),
    [anon_sym_STAR_STAR] = ACTIONS(6851),
    [anon_sym_PLUS] = ACTIONS(6833),
    [anon_sym_GT_GT] = ACTIONS(6837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6825),
    [anon_sym_in] = ACTIONS(6785),
  },
  [3881] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6825),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6827),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(6831),
    [anon_sym_STAR] = ACTIONS(6837),
    [anon_sym_GT_GT_GT] = ACTIONS(6831),
    [anon_sym_AMP_AMP] = ACTIONS(6835),
    [anon_sym_DASH] = ACTIONS(6833),
    [anon_sym_BANG_EQ] = ACTIONS(6785),
    [anon_sym_LT_EQ] = ACTIONS(6825),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6825),
    [anon_sym_GT] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6839),
    [anon_sym_PERCENT] = ACTIONS(6831),
    [anon_sym_QMARK] = ACTIONS(6841),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_PIPE_PIPE] = ACTIONS(6843),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6785),
    [anon_sym_instanceof] = ACTIONS(6825),
    [anon_sym_LT] = ACTIONS(6847),
    [anon_sym_SLASH] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2105),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6843),
    [anon_sym_STAR_STAR] = ACTIONS(6851),
    [anon_sym_PLUS] = ACTIONS(6833),
    [anon_sym_GT_GT] = ACTIONS(6837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6825),
    [anon_sym_in] = ACTIONS(6785),
  },
  [3882] = {
    [sym_new_expression] = STATE(4333),
    [sym_augmented_assignment_expression] = STATE(4333),
    [sym_unary_expression] = STATE(4333),
    [sym_update_expression] = STATE(4333),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(4333),
    [sym_regex] = STATE(4333),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2185),
    [sym__expression] = STATE(4333),
    [sym_non_null_expression] = STATE(4333),
    [sym_yield_expression] = STATE(4333),
    [sym_jsx_fragment] = STATE(4333),
    [sym_jsx_element] = STATE(4333),
    [sym_as_expression] = STATE(4333),
    [sym_internal_module] = STATE(4333),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4333),
    [sym_await_expression] = STATE(4333),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(4333),
    [sym_this] = STATE(4333),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(4333),
    [sym_generator_function] = STATE(4333),
    [sym_call_expression] = STATE(4333),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(4333),
    [sym_ternary_expression] = STATE(4333),
    [sym_binary_expression] = STATE(4333),
    [sym_template_string] = STATE(4333),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4333),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4333),
    [sym_class] = STATE(4333),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(8849),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8849),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8851),
    [sym_true] = ACTIONS(8849),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8849),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [3883] = {
    [sym_new_expression] = STATE(4334),
    [sym_augmented_assignment_expression] = STATE(4334),
    [sym_unary_expression] = STATE(4334),
    [sym_update_expression] = STATE(4334),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(4334),
    [sym_regex] = STATE(4334),
    [sym_type_parameters] = STATE(51),
    [sym_statement_block] = STATE(2187),
    [sym__expression] = STATE(4334),
    [sym_non_null_expression] = STATE(4334),
    [sym_yield_expression] = STATE(4334),
    [sym_jsx_fragment] = STATE(4334),
    [sym_jsx_element] = STATE(4334),
    [sym_as_expression] = STATE(4334),
    [sym_internal_module] = STATE(4334),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4334),
    [sym_await_expression] = STATE(4334),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(4334),
    [sym_this] = STATE(4334),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(4334),
    [sym_generator_function] = STATE(4334),
    [sym_call_expression] = STATE(4334),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(4334),
    [sym_ternary_expression] = STATE(4334),
    [sym_binary_expression] = STATE(4334),
    [sym_template_string] = STATE(4334),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4334),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4334),
    [sym_class] = STATE(4334),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(8853),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8853),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8855),
    [sym_true] = ACTIONS(8853),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8853),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [3884] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6825),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6831),
    [anon_sym_STAR] = ACTIONS(6837),
    [anon_sym_GT_GT_GT] = ACTIONS(6831),
    [anon_sym_AMP_AMP] = ACTIONS(6835),
    [anon_sym_DASH] = ACTIONS(6833),
    [anon_sym_BANG_EQ] = ACTIONS(6785),
    [anon_sym_LT_EQ] = ACTIONS(6825),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6825),
    [anon_sym_GT] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6839),
    [anon_sym_PERCENT] = ACTIONS(6831),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6785),
    [anon_sym_instanceof] = ACTIONS(6825),
    [anon_sym_LT] = ACTIONS(6847),
    [anon_sym_SLASH] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6851),
    [anon_sym_PLUS] = ACTIONS(6833),
    [anon_sym_GT_GT] = ACTIONS(6837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6825),
    [anon_sym_in] = ACTIONS(6785),
  },
  [3885] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(8857),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6851),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3886] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6831),
    [anon_sym_STAR] = ACTIONS(6837),
    [anon_sym_GT_GT_GT] = ACTIONS(6831),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6831),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(8857),
    [anon_sym_SLASH] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6851),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(6837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3887] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6825),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6831),
    [anon_sym_STAR] = ACTIONS(6837),
    [anon_sym_GT_GT_GT] = ACTIONS(6831),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6833),
    [anon_sym_BANG_EQ] = ACTIONS(6785),
    [anon_sym_LT_EQ] = ACTIONS(6825),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6825),
    [anon_sym_GT] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6831),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6785),
    [anon_sym_instanceof] = ACTIONS(6825),
    [anon_sym_LT] = ACTIONS(6847),
    [anon_sym_SLASH] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6851),
    [anon_sym_PLUS] = ACTIONS(6833),
    [anon_sym_GT_GT] = ACTIONS(6837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6825),
    [anon_sym_in] = ACTIONS(6785),
  },
  [3888] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6825),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6785),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6827),
    [anon_sym_COMMA] = ACTIONS(6829),
    [anon_sym_LT_LT] = ACTIONS(6831),
    [anon_sym_DASH] = ACTIONS(6833),
    [anon_sym_GT_GT_GT] = ACTIONS(6831),
    [anon_sym_AMP_AMP] = ACTIONS(6835),
    [anon_sym_STAR] = ACTIONS(6837),
    [anon_sym_BANG_EQ] = ACTIONS(6785),
    [anon_sym_LT_EQ] = ACTIONS(6825),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6825),
    [anon_sym_GT] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6839),
    [anon_sym_PERCENT] = ACTIONS(6831),
    [anon_sym_QMARK] = ACTIONS(6841),
    [anon_sym_PIPE_PIPE] = ACTIONS(6843),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6785),
    [anon_sym_instanceof] = ACTIONS(6825),
    [anon_sym_LT] = ACTIONS(6847),
    [anon_sym_SLASH] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3622),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6843),
    [anon_sym_STAR_STAR] = ACTIONS(6851),
    [anon_sym_PLUS] = ACTIONS(6833),
    [anon_sym_GT_GT] = ACTIONS(6837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6825),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3889] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3630),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(8860),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [3890] = {
    [sym_type_arguments] = STATE(2206),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(4638),
    [anon_sym_BANG] = ACTIONS(3699),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT_LT] = ACTIONS(2204),
    [anon_sym_STAR] = ACTIONS(3699),
    [anon_sym_GT_GT_GT] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_is] = ACTIONS(8862),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_LT_EQ] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_GT_EQ] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_QMARK] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_instanceof] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(4643),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(4646),
    [anon_sym_CARET] = ACTIONS(2204),
    [anon_sym_STAR_STAR] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_GT_GT] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2204),
    [anon_sym_in] = ACTIONS(3699),
  },
  [3891] = {
    [sym_index_type_query] = STATE(2208),
    [sym_lookup_type] = STATE(2208),
    [sym_flow_maybe_type] = STATE(2208),
    [sym_parenthesized_type] = STATE(2208),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_array_type] = STATE(2208),
    [sym_type_predicate] = STATE(2208),
    [sym_type_query] = STATE(2208),
    [sym_existential_type] = STATE(2208),
    [sym_this_type] = STATE(2208),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(2208),
    [sym__primary_type] = STATE(2208),
    [sym_generic_type] = STATE(2208),
    [sym_literal_type] = STATE(2208),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(2208),
    [sym_string] = STATE(1279),
    [sym_tuple_type] = STATE(2208),
    [sym_identifier] = ACTIONS(8117),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(8123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [sym_true] = ACTIONS(2643),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(4648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3892] = {
    [sym_union_type] = STATE(2213),
    [sym__type] = STATE(2213),
    [sym_constructor_type] = STATE(2213),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3895),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2213),
    [sym_function_type] = STATE(2213),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3896),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(8117),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(8123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(8121),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(8125),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(8119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3893] = {
    [sym_type_parameters] = STATE(4337),
    [sym_formal_parameters] = STATE(4338),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3894] = {
    [sym_union_type] = STATE(2221),
    [sym__type] = STATE(2221),
    [sym_constructor_type] = STATE(2221),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3895),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(2221),
    [sym_function_type] = STATE(2221),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3896),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(8117),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(8123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(8121),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(8125),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(8119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3895] = {
    [sym_formal_parameters] = STATE(4341),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3896] = {
    [anon_sym_EQ_GT] = ACTIONS(8864),
    [sym_comment] = ACTIONS(3),
  },
  [3897] = {
    [sym__initializer] = STATE(522),
    [sym_type_arguments] = STATE(1064),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6779),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6779),
    [anon_sym_AMP_EQ] = ACTIONS(6779),
    [anon_sym_PLUS_EQ] = ACTIONS(6779),
    [anon_sym_PIPE] = ACTIONS(3738),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(2208),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(6781),
    [anon_sym_GT] = ACTIONS(3738),
    [anon_sym_CARET_EQ] = ACTIONS(6779),
    [anon_sym_STAR_EQ] = ACTIONS(6779),
    [anon_sym_PIPE_EQ] = ACTIONS(6779),
    [anon_sym_DASH_EQ] = ACTIONS(6779),
    [anon_sym_EQ_GT] = ACTIONS(6783),
    [anon_sym_AMP] = ACTIONS(3738),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6779),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(6779),
    [anon_sym_GT_GT_EQ] = ACTIONS(6779),
    [anon_sym_DOT] = ACTIONS(4670),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6779),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6785),
  },
  [3898] = {
    [sym__initializer] = STATE(528),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6787),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6787),
    [anon_sym_AMP_EQ] = ACTIONS(6787),
    [anon_sym_PLUS_EQ] = ACTIONS(6787),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6781),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_CARET_EQ] = ACTIONS(6787),
    [anon_sym_STAR_EQ] = ACTIONS(6787),
    [anon_sym_PIPE_EQ] = ACTIONS(6787),
    [anon_sym_DASH_EQ] = ACTIONS(6787),
    [anon_sym_EQ_GT] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6787),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_SLASH_EQ] = ACTIONS(6787),
    [anon_sym_GT_GT_EQ] = ACTIONS(6787),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6787),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3899] = {
    [sym_new_expression] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(3245),
    [sym_unary_expression] = STATE(3245),
    [sym_update_expression] = STATE(3245),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(3245),
    [sym_regex] = STATE(3245),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3245),
    [sym_non_null_expression] = STATE(3245),
    [sym_as_expression] = STATE(3245),
    [sym_jsx_fragment] = STATE(3245),
    [sym_yield_expression] = STATE(3245),
    [sym_jsx_element] = STATE(3245),
    [sym_internal_module] = STATE(3245),
    [sym_nested_identifier] = STATE(1092),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3245),
    [sym_await_expression] = STATE(3245),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(3245),
    [sym_this] = STATE(3245),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3245),
    [sym_generator_function] = STATE(3245),
    [sym_call_expression] = STATE(3245),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3245),
    [sym_ternary_expression] = STATE(3245),
    [sym_binary_expression] = STATE(3245),
    [sym_template_string] = STATE(3245),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3245),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3245),
    [sym_class] = STATE(3245),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(8866),
    [sym_false] = ACTIONS(6791),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6791),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(6793),
    [sym_true] = ACTIONS(6791),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6791),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [3900] = {
    [sym_new_expression] = STATE(3246),
    [sym_augmented_assignment_expression] = STATE(3246),
    [sym_unary_expression] = STATE(3246),
    [sym_update_expression] = STATE(3246),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(3246),
    [sym_regex] = STATE(3246),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3246),
    [sym_non_null_expression] = STATE(3246),
    [sym_as_expression] = STATE(3246),
    [sym_jsx_fragment] = STATE(3246),
    [sym_yield_expression] = STATE(3246),
    [sym_jsx_element] = STATE(3246),
    [sym_internal_module] = STATE(3246),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3246),
    [sym_await_expression] = STATE(3246),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(3246),
    [sym_this] = STATE(3246),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3246),
    [sym_generator_function] = STATE(3246),
    [sym_call_expression] = STATE(3246),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3246),
    [sym_ternary_expression] = STATE(3246),
    [sym_binary_expression] = STATE(3246),
    [sym_template_string] = STATE(3246),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3246),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3246),
    [sym_class] = STATE(3246),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(6795),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6795),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(4674),
    [sym_true] = ACTIONS(6795),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6795),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [3901] = {
    [sym_new_expression] = STATE(3245),
    [sym_augmented_assignment_expression] = STATE(3245),
    [sym__initializer] = STATE(528),
    [sym_unary_expression] = STATE(3245),
    [sym_update_expression] = STATE(3245),
    [sym_regex] = STATE(3245),
    [sym_meta_property] = STATE(3245),
    [sym_call_signature] = STATE(2429),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(3245),
    [sym_non_null_expression] = STATE(3245),
    [sym_yield_expression] = STATE(3245),
    [sym_jsx_fragment] = STATE(3245),
    [sym_jsx_element] = STATE(3245),
    [sym_as_expression] = STATE(3245),
    [sym_internal_module] = STATE(3245),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(3245),
    [sym_await_expression] = STATE(3245),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(3245),
    [sym_this] = STATE(3245),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(3245),
    [sym_generator_function] = STATE(3245),
    [sym_call_expression] = STATE(3245),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(3245),
    [sym_ternary_expression] = STATE(3245),
    [sym_binary_expression] = STATE(3245),
    [sym_template_string] = STATE(3245),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(3245),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(3245),
    [sym_class] = STATE(3245),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(5106),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PERCENT_EQ] = ACTIONS(6787),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_AMP_EQ] = ACTIONS(6787),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(6787),
    [anon_sym_PIPE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3773),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(6781),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(6787),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_PIPE_EQ] = ACTIONS(6787),
    [anon_sym_DASH_EQ] = ACTIONS(6787),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_LT_LT_EQ] = ACTIONS(6787),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_instanceof] = ACTIONS(137),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(5124),
    [sym_true] = ACTIONS(6791),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_GT_GT_EQ] = ACTIONS(6787),
    [anon_sym_DOT] = ACTIONS(979),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6787),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_BANG] = ACTIONS(5112),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_false] = ACTIONS(6791),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6787),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(6791),
    [anon_sym_GT] = ACTIONS(3776),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_STAR_EQ] = ACTIONS(6787),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_EQ_GT] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(981),
    [sym_number] = ACTIONS(6793),
    [anon_sym_SLASH] = ACTIONS(292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6787),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(6791),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [3902] = {
    [sym_new_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_type_parameters] = STATE(1819),
    [sym__expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_jsx_element] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(566),
    [sym_arrow_function] = STATE(559),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(567),
    [sym_string] = STATE(559),
    [sym_this] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(568),
    [sym_anonymous_class] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(559),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(1820),
    [sym_parenthesized_expression] = STATE(559),
    [sym_array] = STATE(569),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(559),
    [anon_sym_PLUS_PLUS] = ACTIONS(478),
    [sym_identifier] = ACTIONS(6811),
    [sym_false] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_module] = ACTIONS(6813),
    [anon_sym_symbol] = ACTIONS(6813),
    [anon_sym_number] = ACTIONS(6813),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(6813),
    [anon_sym_typeof] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(6815),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(1023),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(6813),
    [anon_sym_private] = ACTIONS(6813),
    [anon_sym_boolean] = ACTIONS(6813),
    [anon_sym_async] = ACTIONS(6817),
    [anon_sym_public] = ACTIONS(6813),
    [anon_sym_get] = ACTIONS(6813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(478),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(1031),
    [sym_true] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(500),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(6813),
    [anon_sym_string] = ACTIONS(6813),
    [anon_sym_function] = ACTIONS(296),
    [anon_sym_DOT] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_set] = ACTIONS(6813),
    [anon_sym_type] = ACTIONS(6813),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(6813),
    [anon_sym_export] = ACTIONS(6813),
    [anon_sym_namespace] = ACTIONS(6819),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(484),
  },
  [3903] = {
    [sym_type_alias_declaration] = STATE(3915),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3915),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3915),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3915),
    [sym_return_statement] = STATE(3915),
    [aux_sym_program_repeat1] = STATE(3915),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3915),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3915),
    [sym_switch_statement] = STATE(3915),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3915),
    [sym_throw_statement] = STATE(3915),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3915),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3915),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(3915),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3915),
    [sym_abstract_class] = STATE(3915),
    [sym_interface_declaration] = STATE(3915),
    [sym_statement_block] = STATE(3915),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3915),
    [sym_debugger_statement] = STATE(3915),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3915),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3915),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3915),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3915),
    [sym_empty_statement] = STATE(3915),
    [sym_import_alias] = STATE(3915),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3915),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3915),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3915),
    [sym_break_statement] = STATE(3915),
    [sym_labeled_statement] = STATE(3915),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3915),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(8868),
    [anon_sym_default] = ACTIONS(8870),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(8870),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [3904] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_GT_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(8857),
    [anon_sym_SLASH] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [3905] = {
    [sym_type_alias_declaration] = STATE(348),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(348),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(348),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(348),
    [sym_return_statement] = STATE(348),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(348),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(348),
    [sym_switch_statement] = STATE(348),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(348),
    [sym_throw_statement] = STATE(348),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(348),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(348),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(348),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(348),
    [sym_abstract_class] = STATE(348),
    [sym_interface_declaration] = STATE(348),
    [sym_statement_block] = STATE(348),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(348),
    [sym_debugger_statement] = STATE(348),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(348),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(348),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(348),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(348),
    [sym_empty_statement] = STATE(348),
    [sym_import_alias] = STATE(348),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(348),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(348),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(348),
    [sym_break_statement] = STATE(348),
    [sym_labeled_statement] = STATE(348),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(348),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [3906] = {
    [sym_type_alias_declaration] = STATE(4351),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4351),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4351),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4351),
    [sym_return_statement] = STATE(4351),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4351),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4351),
    [sym_switch_statement] = STATE(4351),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4351),
    [sym_throw_statement] = STATE(4351),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4351),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4351),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(4351),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4351),
    [sym_abstract_class] = STATE(4351),
    [sym_interface_declaration] = STATE(4351),
    [sym_statement_block] = STATE(4351),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4351),
    [sym_debugger_statement] = STATE(4351),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4351),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4351),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4351),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4351),
    [sym_empty_statement] = STATE(4351),
    [sym_import_alias] = STATE(4351),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4351),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4351),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4351),
    [sym_break_statement] = STATE(4351),
    [sym_labeled_statement] = STATE(4351),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4351),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [3907] = {
    [anon_sym_LPAREN] = ACTIONS(8886),
    [sym_comment] = ACTIONS(3),
  },
  [3908] = {
    [sym_new_expression] = STATE(59),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_yield_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_internal_module] = STATE(59),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(59),
    [sym_await_expression] = STATE(59),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4357),
    [sym_variable_declaration] = STATE(4357),
    [sym_sequence_expression] = STATE(62),
    [sym_string] = STATE(59),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(4357),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(4358),
    [sym_anonymous_class] = STATE(59),
    [sym_generator_function] = STATE(59),
    [sym_call_expression] = STATE(59),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(59),
    [sym_ternary_expression] = STATE(59),
    [sym_binary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_lexical_declaration] = STATE(4357),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(4359),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_identifier] = ACTIONS(8888),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(8890),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(8892),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(8890),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(15),
  },
  [3909] = {
    [sym_string] = STATE(173),
    [sym_nested_identifier] = STATE(169),
    [sym__module] = STATE(172),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(8894),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(312),
  },
  [3910] = {
    [sym_type_alias_declaration] = STATE(193),
    [aux_sym_export_statement_repeat1] = STATE(3912),
    [sym__declaration] = STATE(193),
    [sym_ambient_declaration] = STATE(193),
    [sym_import_alias] = STATE(193),
    [sym_export_statement] = STATE(193),
    [sym_generator_function] = STATE(193),
    [sym_lexical_declaration] = STATE(193),
    [sym_internal_module] = STATE(193),
    [sym_decorator] = STATE(3912),
    [sym_enum_declaration] = STATE(193),
    [sym_function] = STATE(193),
    [sym_function_signature] = STATE(193),
    [sym_variable_declaration] = STATE(193),
    [sym_abstract_class] = STATE(193),
    [sym_module] = STATE(193),
    [sym_interface_declaration] = STATE(193),
    [sym_class] = STATE(193),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(8153),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(8155),
    [anon_sym_global] = ACTIONS(324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(8157),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(346),
  },
  [3911] = {
    [sym_type_alias_declaration] = STATE(300),
    [aux_sym_export_statement_repeat1] = STATE(3912),
    [sym__declaration] = STATE(300),
    [sym_ambient_declaration] = STATE(300),
    [sym_import_alias] = STATE(300),
    [sym_export_statement] = STATE(300),
    [sym_generator_function] = STATE(300),
    [sym_export_clause] = STATE(301),
    [sym_lexical_declaration] = STATE(300),
    [sym_internal_module] = STATE(300),
    [sym_decorator] = STATE(3912),
    [sym_enum_declaration] = STATE(300),
    [sym_function] = STATE(300),
    [sym_function_signature] = STATE(300),
    [sym_variable_declaration] = STATE(300),
    [sym_abstract_class] = STATE(300),
    [sym_module] = STATE(300),
    [sym_interface_declaration] = STATE(300),
    [sym_class] = STATE(300),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_as] = ACTIONS(1183),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(8155),
    [anon_sym_STAR] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_EQ] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(8157),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(346),
  },
  [3912] = {
    [aux_sym_export_statement_repeat1] = STATE(320),
    [sym_decorator] = STATE(320),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(8163),
    [anon_sym_class] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
  },
  [3913] = {
    [sym_type_alias_declaration] = STATE(787),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(787),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(787),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(787),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(787),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(787),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(787),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(787),
    [sym_abstract_class] = STATE(787),
    [sym_interface_declaration] = STATE(787),
    [sym_statement_block] = STATE(787),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(787),
    [sym_debugger_statement] = STATE(787),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(787),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(787),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(787),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(787),
    [sym_empty_statement] = STATE(787),
    [sym_import_alias] = STATE(787),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(787),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(787),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_labeled_statement] = STATE(787),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(787),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [3914] = {
    [sym_type_alias_declaration] = STATE(891),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(891),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(891),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(891),
    [sym_return_statement] = STATE(891),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(891),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(891),
    [sym_switch_statement] = STATE(891),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(891),
    [sym_throw_statement] = STATE(891),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(891),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(891),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(891),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(891),
    [sym_abstract_class] = STATE(891),
    [sym_interface_declaration] = STATE(891),
    [sym_statement_block] = STATE(891),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(891),
    [sym_debugger_statement] = STATE(891),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(891),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(891),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(891),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(891),
    [sym_empty_statement] = STATE(891),
    [sym_import_alias] = STATE(891),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(891),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(891),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(891),
    [sym_break_statement] = STATE(891),
    [sym_labeled_statement] = STATE(891),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(891),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [3915] = {
    [sym_type_alias_declaration] = STATE(3915),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3915),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3915),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3915),
    [sym_return_statement] = STATE(3915),
    [aux_sym_program_repeat1] = STATE(3915),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3915),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3915),
    [sym_switch_statement] = STATE(3915),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3915),
    [sym_throw_statement] = STATE(3915),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3915),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3915),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(3915),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3915),
    [sym_abstract_class] = STATE(3915),
    [sym_interface_declaration] = STATE(3915),
    [sym_statement_block] = STATE(3915),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3915),
    [sym_debugger_statement] = STATE(3915),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3915),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3915),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3915),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3915),
    [sym_empty_statement] = STATE(3915),
    [sym_import_alias] = STATE(3915),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3915),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3915),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3915),
    [sym_break_statement] = STATE(3915),
    [sym_labeled_statement] = STATE(3915),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3915),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8896),
    [anon_sym_BQUOTE] = ACTIONS(1674),
    [anon_sym_debugger] = ACTIONS(1677),
    [anon_sym_symbol] = ACTIONS(1680),
    [anon_sym_AT] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1686),
    [anon_sym_void] = ACTIONS(1689),
    [anon_sym_break] = ACTIONS(1692),
    [anon_sym_const] = ACTIONS(1695),
    [sym_super] = ACTIONS(1698),
    [anon_sym_return] = ACTIONS(1701),
    [anon_sym_private] = ACTIONS(1680),
    [anon_sym_get] = ACTIONS(1680),
    [anon_sym_RBRACE] = ACTIONS(1812),
    [anon_sym_default] = ACTIONS(8899),
    [anon_sym_interface] = ACTIONS(1704),
    [anon_sym_enum] = ACTIONS(1707),
    [anon_sym_delete] = ACTIONS(1710),
    [anon_sym_continue] = ACTIONS(1713),
    [anon_sym_DASH_DASH] = ACTIONS(1716),
    [anon_sym_if] = ACTIONS(8901),
    [anon_sym_this] = ACTIONS(1722),
    [anon_sym_yield] = ACTIONS(1725),
    [sym_true] = ACTIONS(1728),
    [anon_sym_throw] = ACTIONS(1731),
    [anon_sym_protected] = ACTIONS(1680),
    [anon_sym_abstract] = ACTIONS(1734),
    [anon_sym_set] = ACTIONS(1680),
    [anon_sym_type] = ACTIONS(1737),
    [anon_sym_import] = ACTIONS(1740),
    [anon_sym_namespace] = ACTIONS(1743),
    [anon_sym_PLUS_PLUS] = ACTIONS(1716),
    [anon_sym_await] = ACTIONS(1746),
    [anon_sym_DQUOTE] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1752),
    [anon_sym_for] = ACTIONS(8904),
    [anon_sym_LBRACK] = ACTIONS(1758),
    [sym_false] = ACTIONS(1728),
    [anon_sym_SEMI] = ACTIONS(1761),
    [anon_sym_case] = ACTIONS(8899),
    [anon_sym_module] = ACTIONS(1764),
    [anon_sym_number] = ACTIONS(1680),
    [anon_sym_class] = ACTIONS(1767),
    [anon_sym_declare] = ACTIONS(8907),
    [anon_sym_typeof] = ACTIONS(1710),
    [anon_sym_LBRACE] = ACTIONS(1773),
    [anon_sym_switch] = ACTIONS(1776),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [sym_null] = ACTIONS(1728),
    [anon_sym_any] = ACTIONS(1680),
    [anon_sym_boolean] = ACTIONS(1680),
    [anon_sym_async] = ACTIONS(1782),
    [anon_sym_public] = ACTIONS(1680),
    [anon_sym_var] = ACTIONS(1785),
    [anon_sym_while] = ACTIONS(8910),
    [anon_sym_SQUOTE] = ACTIONS(1791),
    [anon_sym_try] = ACTIONS(1794),
    [anon_sym_LT] = ACTIONS(1797),
    [sym_number] = ACTIONS(1800),
    [anon_sym_SLASH] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1680),
    [anon_sym_function] = ACTIONS(1806),
    [sym_undefined] = ACTIONS(1728),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_let] = ACTIONS(1814),
    [anon_sym_PLUS] = ACTIONS(1686),
    [anon_sym_export] = ACTIONS(8913),
    [anon_sym_do] = ACTIONS(1820),
    [anon_sym_TILDE] = ACTIONS(1752),
    [anon_sym_with] = ACTIONS(8916),
  },
  [3916] = {
    [sym_type_alias_declaration] = STATE(872),
    [aux_sym_export_statement_repeat1] = STATE(3912),
    [sym__declaration] = STATE(872),
    [sym_ambient_declaration] = STATE(872),
    [sym_import_alias] = STATE(872),
    [sym_export_statement] = STATE(872),
    [sym_generator_function] = STATE(872),
    [sym_lexical_declaration] = STATE(872),
    [sym_internal_module] = STATE(872),
    [sym_decorator] = STATE(3912),
    [sym_enum_declaration] = STATE(872),
    [sym_function] = STATE(872),
    [sym_function_signature] = STATE(872),
    [sym_variable_declaration] = STATE(872),
    [sym_abstract_class] = STATE(872),
    [sym_module] = STATE(872),
    [sym_interface_declaration] = STATE(872),
    [sym_class] = STATE(872),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_default] = ACTIONS(1826),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(8155),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(8157),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(346),
  },
  [3917] = {
    [sym_formal_parameters] = STATE(4361),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3918] = {
    [anon_sym_EQ_GT] = ACTIONS(8919),
    [sym_comment] = ACTIONS(3),
  },
  [3919] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3280),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3281),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3109),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6885),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6887),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3920] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3280),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3281),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3109),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6885),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6887),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3921] = {
    [anon_sym_EQ_GT] = ACTIONS(8921),
    [sym_comment] = ACTIONS(3),
  },
  [3922] = {
    [sym_union_type] = STATE(4364),
    [sym__type] = STATE(4364),
    [sym_constructor_type] = STATE(4364),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3280),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4364),
    [sym_function_type] = STATE(4364),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3281),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3109),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6885),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6887),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3923] = {
    [sym_union_type] = STATE(4365),
    [sym__type] = STATE(4365),
    [sym_constructor_type] = STATE(4365),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1488),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4365),
    [sym_function_type] = STATE(4365),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1489),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3109),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3113),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3924] = {
    [anon_sym_EQ] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(5144),
    [anon_sym_RPAREN] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(5146),
    [anon_sym_COMMA] = ACTIONS(7511),
    [sym_comment] = ACTIONS(3),
  },
  [3925] = {
    [anon_sym_EQ] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(5144),
    [anon_sym_RPAREN] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(5146),
    [anon_sym_COMMA] = ACTIONS(7529),
    [sym_comment] = ACTIONS(3),
  },
  [3926] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3930),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3931),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(5168),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8181),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8183),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3927] = {
    [sym_type_parameters] = STATE(4366),
    [sym_formal_parameters] = STATE(4367),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3928] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3930),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3931),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(5168),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8181),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8183),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3929] = {
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_RPAREN] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(8923),
    [anon_sym_COMMA] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(8925),
    [sym_comment] = ACTIONS(3),
  },
  [3930] = {
    [sym_formal_parameters] = STATE(4370),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3931] = {
    [anon_sym_EQ_GT] = ACTIONS(8927),
    [sym_comment] = ACTIONS(3),
  },
  [3932] = {
    [anon_sym_EQ_GT] = ACTIONS(8929),
    [sym_comment] = ACTIONS(3),
  },
  [3933] = {
    [sym_union_type] = STATE(4373),
    [sym__type] = STATE(4373),
    [sym_constructor_type] = STATE(4373),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2464),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4373),
    [sym_function_type] = STATE(4373),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2465),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(5168),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5172),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3934] = {
    [sym_union_type] = STATE(4374),
    [sym__type] = STATE(4374),
    [sym_constructor_type] = STATE(4374),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2464),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4374),
    [sym_function_type] = STATE(4374),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2465),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(5168),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5172),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3935] = {
    [anon_sym_AMP] = ACTIONS(6913),
    [anon_sym_RPAREN] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(6915),
    [anon_sym_COMMA] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
  },
  [3936] = {
    [sym_union_type] = STATE(4375),
    [sym__type] = STATE(4375),
    [sym_constructor_type] = STATE(4375),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1528),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4375),
    [sym_function_type] = STATE(4375),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1529),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3194),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3200),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3937] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_BANG] = ACTIONS(8379),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(8191),
    [anon_sym_COMMA] = ACTIONS(7511),
    [anon_sym_LT_LT] = ACTIONS(7511),
    [anon_sym_STAR] = ACTIONS(8379),
    [anon_sym_GT_GT_GT] = ACTIONS(7511),
    [anon_sym_AMP_AMP] = ACTIONS(7511),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_BANG_EQ] = ACTIONS(8379),
    [anon_sym_LT_EQ] = ACTIONS(7511),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [anon_sym_GT_EQ] = ACTIONS(7511),
    [anon_sym_GT] = ACTIONS(8379),
    [anon_sym_AMP] = ACTIONS(8193),
    [anon_sym_PERCENT] = ACTIONS(7511),
    [anon_sym_QMARK] = ACTIONS(7511),
    [anon_sym_as] = ACTIONS(7511),
    [anon_sym_PIPE_PIPE] = ACTIONS(7511),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_EQ_EQ] = ACTIONS(8379),
    [anon_sym_RPAREN] = ACTIONS(7511),
    [anon_sym_LT] = ACTIONS(8379),
    [anon_sym_instanceof] = ACTIONS(7511),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7511),
    [anon_sym_DOT] = ACTIONS(7511),
    [anon_sym_CARET] = ACTIONS(7511),
    [anon_sym_STAR_STAR] = ACTIONS(7511),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_GT_GT] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7511),
    [anon_sym_in] = ACTIONS(8379),
  },
  [3938] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_BANG] = ACTIONS(8381),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(8191),
    [anon_sym_COMMA] = ACTIONS(7529),
    [anon_sym_LT_LT] = ACTIONS(7529),
    [anon_sym_STAR] = ACTIONS(8381),
    [anon_sym_GT_GT_GT] = ACTIONS(7529),
    [anon_sym_AMP_AMP] = ACTIONS(7529),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_BANG_EQ] = ACTIONS(8381),
    [anon_sym_LT_EQ] = ACTIONS(7529),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [anon_sym_GT_EQ] = ACTIONS(7529),
    [anon_sym_GT] = ACTIONS(8381),
    [anon_sym_AMP] = ACTIONS(8193),
    [anon_sym_PERCENT] = ACTIONS(7529),
    [anon_sym_QMARK] = ACTIONS(7529),
    [anon_sym_as] = ACTIONS(7529),
    [anon_sym_PIPE_PIPE] = ACTIONS(7529),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_EQ_EQ] = ACTIONS(8381),
    [anon_sym_RPAREN] = ACTIONS(7529),
    [anon_sym_LT] = ACTIONS(8381),
    [anon_sym_instanceof] = ACTIONS(7529),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7529),
    [anon_sym_DOT] = ACTIONS(7529),
    [anon_sym_CARET] = ACTIONS(7529),
    [anon_sym_STAR_STAR] = ACTIONS(7529),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_GT_GT] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7529),
    [anon_sym_in] = ACTIONS(8381),
  },
  [3939] = {
    [anon_sym_COMMA] = ACTIONS(8931),
    [anon_sym_RPAREN] = ACTIONS(8931),
    [sym_comment] = ACTIONS(3),
  },
  [3940] = {
    [anon_sym_COMMA] = ACTIONS(8933),
    [anon_sym_RPAREN] = ACTIONS(8933),
    [sym_comment] = ACTIONS(3),
  },
  [3941] = {
    [anon_sym_COMMA] = ACTIONS(8935),
    [anon_sym_RPAREN] = ACTIONS(8935),
    [sym_comment] = ACTIONS(3),
  },
  [3942] = {
    [anon_sym_COMMA] = ACTIONS(8937),
    [anon_sym_RPAREN] = ACTIONS(8937),
    [sym_comment] = ACTIONS(3),
  },
  [3943] = {
    [sym_identifier] = ACTIONS(8939),
    [anon_sym_BQUOTE] = ACTIONS(8941),
    [anon_sym_debugger] = ACTIONS(8939),
    [anon_sym_symbol] = ACTIONS(8939),
    [anon_sym_AT] = ACTIONS(8941),
    [anon_sym_DASH] = ACTIONS(8939),
    [anon_sym_void] = ACTIONS(8939),
    [anon_sym_break] = ACTIONS(8939),
    [anon_sym_const] = ACTIONS(8939),
    [sym_super] = ACTIONS(8939),
    [anon_sym_return] = ACTIONS(8939),
    [anon_sym_private] = ACTIONS(8939),
    [anon_sym_get] = ACTIONS(8939),
    [anon_sym_RBRACE] = ACTIONS(8941),
    [anon_sym_interface] = ACTIONS(8939),
    [anon_sym_default] = ACTIONS(8939),
    [anon_sym_enum] = ACTIONS(8939),
    [anon_sym_delete] = ACTIONS(8939),
    [anon_sym_continue] = ACTIONS(8939),
    [anon_sym_DASH_DASH] = ACTIONS(8941),
    [anon_sym_if] = ACTIONS(8939),
    [anon_sym_this] = ACTIONS(8939),
    [anon_sym_yield] = ACTIONS(8939),
    [sym_true] = ACTIONS(8939),
    [anon_sym_throw] = ACTIONS(8939),
    [anon_sym_protected] = ACTIONS(8939),
    [anon_sym_abstract] = ACTIONS(8939),
    [anon_sym_set] = ACTIONS(8939),
    [anon_sym_type] = ACTIONS(8939),
    [anon_sym_import] = ACTIONS(8939),
    [anon_sym_namespace] = ACTIONS(8939),
    [anon_sym_PLUS_PLUS] = ACTIONS(8941),
    [anon_sym_await] = ACTIONS(8939),
    [anon_sym_DQUOTE] = ACTIONS(8941),
    [anon_sym_else] = ACTIONS(8939),
    [anon_sym_BANG] = ACTIONS(8941),
    [anon_sym_for] = ACTIONS(8939),
    [anon_sym_LBRACK] = ACTIONS(8941),
    [sym_false] = ACTIONS(8939),
    [anon_sym_SEMI] = ACTIONS(8941),
    [anon_sym_case] = ACTIONS(8939),
    [anon_sym_module] = ACTIONS(8939),
    [anon_sym_number] = ACTIONS(8939),
    [anon_sym_class] = ACTIONS(8939),
    [anon_sym_declare] = ACTIONS(8939),
    [anon_sym_typeof] = ACTIONS(8939),
    [anon_sym_LBRACE] = ACTIONS(8941),
    [anon_sym_switch] = ACTIONS(8939),
    [anon_sym_LPAREN] = ACTIONS(8941),
    [sym_null] = ACTIONS(8939),
    [anon_sym_any] = ACTIONS(8939),
    [anon_sym_boolean] = ACTIONS(8939),
    [anon_sym_async] = ACTIONS(8939),
    [anon_sym_public] = ACTIONS(8939),
    [anon_sym_var] = ACTIONS(8939),
    [anon_sym_while] = ACTIONS(8939),
    [anon_sym_SQUOTE] = ACTIONS(8941),
    [anon_sym_try] = ACTIONS(8939),
    [anon_sym_LT] = ACTIONS(8941),
    [sym_number] = ACTIONS(8941),
    [anon_sym_SLASH] = ACTIONS(8939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(8939),
    [anon_sym_string] = ACTIONS(8939),
    [anon_sym_function] = ACTIONS(8939),
    [sym_undefined] = ACTIONS(8939),
    [anon_sym_new] = ACTIONS(8939),
    [ts_builtin_sym_end] = ACTIONS(8941),
    [anon_sym_let] = ACTIONS(8939),
    [anon_sym_PLUS] = ACTIONS(8939),
    [anon_sym_export] = ACTIONS(8939),
    [anon_sym_do] = ACTIONS(8939),
    [anon_sym_TILDE] = ACTIONS(8941),
    [anon_sym_with] = ACTIONS(8939),
  },
  [3944] = {
    [anon_sym_GT] = ACTIONS(2517),
    [sym_jsx_identifier] = ACTIONS(2517),
    [sym_identifier] = ACTIONS(2519),
    [anon_sym_SLASH] = ACTIONS(2519),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2517),
  },
  [3945] = {
    [sym_nested_identifier] = STATE(965),
    [sym_jsx_namespace_name] = STATE(966),
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(8943),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1975),
  },
  [3946] = {
    [sym_jsx_opening_element] = STATE(340),
    [aux_sym_jsx_element_repeat1] = STATE(975),
    [sym_jsx_expression] = STATE(975),
    [sym_jsx_self_closing_element] = STATE(975),
    [sym_jsx_element] = STATE(975),
    [sym_jsx_text] = ACTIONS(1993),
    [anon_sym_LT] = ACTIONS(8945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(590),
  },
  [3947] = {
    [anon_sym_GT] = ACTIONS(8947),
    [sym_comment] = ACTIONS(3),
  },
  [3948] = {
    [aux_sym_jsx_opening_element_repeat1] = STATE(1589),
    [sym_jsx_namespace_name] = STATE(805),
    [sym_jsx_attribute] = STATE(1589),
    [sym_jsx_expression] = STATE(1589),
    [anon_sym_GT] = ACTIONS(3333),
    [sym_identifier] = ACTIONS(1492),
    [sym_jsx_identifier] = ACTIONS(1500),
    [anon_sym_SLASH] = ACTIONS(8949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1511),
  },
  [3949] = {
    [sym_nested_identifier] = STATE(4382),
    [sym_jsx_namespace_name] = STATE(4383),
    [sym_identifier] = ACTIONS(8951),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(8953),
  },
  [3950] = {
    [anon_sym_GT] = ACTIONS(3874),
    [sym_jsx_identifier] = ACTIONS(3874),
    [sym_identifier] = ACTIONS(3876),
    [anon_sym_SLASH] = ACTIONS(3876),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3874),
  },
  [3951] = {
    [sym_formal_parameters] = STATE(4384),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3952] = {
    [anon_sym_EQ_GT] = ACTIONS(8955),
    [sym_comment] = ACTIONS(3),
  },
  [3953] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3332),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3333),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3319),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6985),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6987),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3954] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3332),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3333),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3319),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6985),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6987),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3955] = {
    [anon_sym_EQ_GT] = ACTIONS(8957),
    [sym_comment] = ACTIONS(3),
  },
  [3956] = {
    [sym_union_type] = STATE(4387),
    [sym__type] = STATE(4387),
    [sym_constructor_type] = STATE(4387),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3332),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4387),
    [sym_function_type] = STATE(4387),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3333),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3319),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6985),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6987),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3957] = {
    [sym_union_type] = STATE(4388),
    [sym__type] = STATE(4388),
    [sym_constructor_type] = STATE(4388),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1579),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4388),
    [sym_function_type] = STATE(4388),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1580),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3319),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3958] = {
    [anon_sym_EQ] = ACTIONS(7511),
    [anon_sym_GT] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(5291),
    [anon_sym_PIPE] = ACTIONS(5293),
    [anon_sym_COMMA] = ACTIONS(7511),
    [sym_comment] = ACTIONS(3),
  },
  [3959] = {
    [anon_sym_EQ] = ACTIONS(7529),
    [anon_sym_GT] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(5291),
    [anon_sym_PIPE] = ACTIONS(5293),
    [anon_sym_COMMA] = ACTIONS(7529),
    [sym_comment] = ACTIONS(3),
  },
  [3960] = {
    [anon_sym_COLON] = ACTIONS(6921),
    [sym__automatic_semicolon] = ACTIONS(6921),
    [anon_sym_RBRACE] = ACTIONS(6921),
    [anon_sym_SEMI] = ACTIONS(6921),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6921),
    [anon_sym_COMMA] = ACTIONS(6921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6921),
  },
  [3961] = {
    [aux_sym_export_statement_repeat1] = STATE(1512),
    [sym_decorator] = STATE(1512),
    [sym_object] = STATE(769),
    [sym_accessibility_modifier] = STATE(247),
    [sym_required_parameter] = STATE(1513),
    [sym_array] = STATE(771),
    [sym_rest_parameter] = STATE(1513),
    [sym_optional_parameter] = STATE(1513),
    [sym_this] = STATE(772),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_public] = ACTIONS(1446),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(1442),
    [anon_sym_number] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_RPAREN] = ACTIONS(8959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(420),
    [anon_sym_LBRACE] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1446),
    [anon_sym_void] = ACTIONS(1442),
    [anon_sym_string] = ACTIONS(1442),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [sym_readonly] = ACTIONS(436),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_any] = ACTIONS(1442),
    [anon_sym_private] = ACTIONS(1446),
    [anon_sym_boolean] = ACTIONS(1442),
    [anon_sym_async] = ACTIONS(1442),
  },
  [3962] = {
    [sym_union_type] = STATE(1892),
    [sym__type] = STATE(1892),
    [sym_constructor_type] = STATE(1892),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3966),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1892),
    [sym_function_type] = STATE(1892),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3967),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5347),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8239),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8241),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3963] = {
    [sym_type_parameters] = STATE(4390),
    [sym_formal_parameters] = STATE(4391),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [3964] = {
    [sym_union_type] = STATE(1900),
    [sym__type] = STATE(1900),
    [sym_constructor_type] = STATE(1900),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3966),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1900),
    [sym_function_type] = STATE(1900),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3967),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5347),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8239),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8241),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3965] = {
    [sym__automatic_semicolon] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(8961),
    [anon_sym_SEMI] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(8963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5893),
  },
  [3966] = {
    [sym_formal_parameters] = STATE(4394),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3967] = {
    [anon_sym_EQ_GT] = ACTIONS(8965),
    [sym_comment] = ACTIONS(3),
  },
  [3968] = {
    [anon_sym_EQ_GT] = ACTIONS(8967),
    [sym_comment] = ACTIONS(3),
  },
  [3969] = {
    [sym_union_type] = STATE(4397),
    [sym__type] = STATE(4397),
    [sym_constructor_type] = STATE(4397),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2530),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4397),
    [sym_function_type] = STATE(4397),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2531),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5347),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5353),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3970] = {
    [sym_union_type] = STATE(4398),
    [sym__type] = STATE(4398),
    [sym_constructor_type] = STATE(4398),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2530),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4398),
    [sym_function_type] = STATE(4398),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2531),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5347),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5353),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [3971] = {
    [sym__automatic_semicolon] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(7017),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(7019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6040),
  },
  [3972] = {
    [sym_formal_parameters] = STATE(4399),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [3973] = {
    [anon_sym_EQ_GT] = ACTIONS(8969),
    [sym_comment] = ACTIONS(3),
  },
  [3974] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3352),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3353),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3367),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(7027),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(7029),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(7031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3975] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3352),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3353),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3367),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(7027),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(7029),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(7031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3976] = {
    [anon_sym_EQ_GT] = ACTIONS(8971),
    [sym_comment] = ACTIONS(3),
  },
  [3977] = {
    [sym_union_type] = STATE(4402),
    [sym__type] = STATE(4402),
    [sym_constructor_type] = STATE(4402),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3352),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4402),
    [sym_function_type] = STATE(4402),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3353),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3367),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(7027),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(7029),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(7031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3978] = {
    [sym_union_type] = STATE(4403),
    [sym__type] = STATE(4403),
    [sym_constructor_type] = STATE(4403),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1613),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4403),
    [sym_function_type] = STATE(4403),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1614),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3367),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(3375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [3979] = {
    [anon_sym_AMP] = ACTIONS(5367),
    [anon_sym_PIPE] = ACTIONS(5369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7511),
  },
  [3980] = {
    [anon_sym_AMP] = ACTIONS(5367),
    [anon_sym_PIPE] = ACTIONS(5369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7529),
  },
  [3981] = {
    [sym_union_type] = STATE(4404),
    [sym__type] = STATE(4404),
    [sym_constructor_type] = STATE(4404),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1647),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4404),
    [sym_function_type] = STATE(4404),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1648),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3438),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3444),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3446),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [3982] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_BANG] = ACTIONS(8379),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(8257),
    [anon_sym_LT_LT] = ACTIONS(7511),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_STAR] = ACTIONS(8379),
    [anon_sym_GT_GT_GT] = ACTIONS(7511),
    [anon_sym_AMP_AMP] = ACTIONS(7511),
    [anon_sym_BANG_EQ] = ACTIONS(8379),
    [anon_sym_LT_EQ] = ACTIONS(7511),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [anon_sym_GT_EQ] = ACTIONS(7511),
    [anon_sym_GT] = ACTIONS(8379),
    [anon_sym_AMP] = ACTIONS(8259),
    [anon_sym_PERCENT] = ACTIONS(7511),
    [anon_sym_QMARK] = ACTIONS(7511),
    [anon_sym_as] = ACTIONS(7511),
    [anon_sym_PIPE_PIPE] = ACTIONS(7511),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_EQ_EQ] = ACTIONS(8379),
    [anon_sym_instanceof] = ACTIONS(7511),
    [anon_sym_LT] = ACTIONS(8379),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7511),
    [anon_sym_CARET] = ACTIONS(7511),
    [anon_sym_STAR_STAR] = ACTIONS(7511),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_GT_GT] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7511),
    [anon_sym_in] = ACTIONS(8379),
  },
  [3983] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_BANG] = ACTIONS(8381),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(8257),
    [anon_sym_LT_LT] = ACTIONS(7529),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_STAR] = ACTIONS(8381),
    [anon_sym_GT_GT_GT] = ACTIONS(7529),
    [anon_sym_AMP_AMP] = ACTIONS(7529),
    [anon_sym_BANG_EQ] = ACTIONS(8381),
    [anon_sym_LT_EQ] = ACTIONS(7529),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [anon_sym_GT_EQ] = ACTIONS(7529),
    [anon_sym_GT] = ACTIONS(8381),
    [anon_sym_AMP] = ACTIONS(8259),
    [anon_sym_PERCENT] = ACTIONS(7529),
    [anon_sym_QMARK] = ACTIONS(7529),
    [anon_sym_as] = ACTIONS(7529),
    [anon_sym_PIPE_PIPE] = ACTIONS(7529),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_EQ_EQ] = ACTIONS(8381),
    [anon_sym_instanceof] = ACTIONS(7529),
    [anon_sym_LT] = ACTIONS(8381),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7529),
    [anon_sym_CARET] = ACTIONS(7529),
    [anon_sym_STAR_STAR] = ACTIONS(7529),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_GT_GT] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7529),
    [anon_sym_in] = ACTIONS(8381),
  },
  [3984] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(6453),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [anon_sym_PERCENT_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_AMP_EQ] = ACTIONS(2011),
    [anon_sym_PLUS_EQ] = ACTIONS(2011),
    [anon_sym_PIPE] = ACTIONS(8388),
    [anon_sym_COMMA] = ACTIONS(4485),
    [anon_sym_LT_LT] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_GT_GT_GT] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_RBRACK] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(8388),
    [anon_sym_CARET_EQ] = ACTIONS(2011),
    [anon_sym_STAR_EQ] = ACTIONS(2011),
    [anon_sym_PIPE_EQ] = ACTIONS(2011),
    [anon_sym_DASH_EQ] = ACTIONS(2011),
    [anon_sym_AMP] = ACTIONS(8388),
    [anon_sym_PERCENT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_LT_LT_EQ] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2011),
    [anon_sym_RBRACE] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_instanceof] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_RPAREN] = ACTIONS(2011),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2011),
    [anon_sym_SLASH_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_DOT] = ACTIONS(6453),
    [anon_sym_CARET] = ACTIONS(2013),
    [anon_sym_STAR_STAR] = ACTIONS(2013),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2013),
  },
  [3985] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(7181),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(7181),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_LT_LT] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3539),
    [anon_sym_GT_GT_GT] = ACTIONS(3535),
    [anon_sym_AMP_AMP] = ACTIONS(3541),
    [anon_sym_BANG_EQ] = ACTIONS(3491),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_QMARK] = ACTIONS(3545),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(3491),
    [anon_sym_instanceof] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3551),
    [anon_sym_SLASH] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(3547),
    [anon_sym_STAR_STAR] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_GT_GT] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3491),
  },
  [3986] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(7192),
    [anon_sym_SEMI] = ACTIONS(5893),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [sym__automatic_semicolon] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(8973),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_GT_GT_GT] = ACTIONS(5893),
    [anon_sym_AMP_AMP] = ACTIONS(5893),
    [anon_sym_BANG_EQ] = ACTIONS(7192),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(8975),
    [anon_sym_PERCENT] = ACTIONS(5893),
    [anon_sym_QMARK] = ACTIONS(5893),
    [anon_sym_as] = ACTIONS(5893),
    [anon_sym_PIPE_PIPE] = ACTIONS(5893),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_EQ_EQ] = ACTIONS(7192),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5893),
    [anon_sym_CARET] = ACTIONS(5893),
    [anon_sym_STAR_STAR] = ACTIONS(5893),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_in] = ACTIONS(7192),
  },
  [3987] = {
    [anon_sym_EQ_GT] = ACTIONS(8977),
    [sym_comment] = ACTIONS(3),
  },
  [3988] = {
    [sym_union_type] = STATE(4406),
    [sym__type] = STATE(4406),
    [sym_constructor_type] = STATE(4406),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(2577),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(4406),
    [sym_function_type] = STATE(4406),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(2578),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(5459),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(5465),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(5463),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(5467),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(5461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [3989] = {
    [sym_union_type] = STATE(4407),
    [sym__type] = STATE(4407),
    [sym_constructor_type] = STATE(4407),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(2577),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(4407),
    [sym_function_type] = STATE(4407),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(2578),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(5459),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(5465),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(5463),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(5467),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(5461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [3990] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_BANG] = ACTIONS(7208),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [sym__automatic_semicolon] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(8973),
    [anon_sym_LT_LT] = ACTIONS(6040),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_STAR] = ACTIONS(7208),
    [anon_sym_GT_GT_GT] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(6040),
    [anon_sym_BANG_EQ] = ACTIONS(7208),
    [anon_sym_LT_EQ] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [anon_sym_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_AMP] = ACTIONS(8975),
    [anon_sym_PERCENT] = ACTIONS(6040),
    [anon_sym_QMARK] = ACTIONS(6040),
    [anon_sym_as] = ACTIONS(6040),
    [anon_sym_PIPE_PIPE] = ACTIONS(6040),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_instanceof] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6040),
    [anon_sym_CARET] = ACTIONS(6040),
    [anon_sym_STAR_STAR] = ACTIONS(6040),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6040),
    [anon_sym_in] = ACTIONS(7208),
  },
  [3991] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(6447),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_SEMI] = ACTIONS(2011),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [sym__automatic_semicolon] = ACTIONS(2011),
    [anon_sym_PERCENT_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_AMP_EQ] = ACTIONS(2011),
    [anon_sym_PLUS_EQ] = ACTIONS(2011),
    [anon_sym_PIPE] = ACTIONS(6450),
    [anon_sym_LT_LT] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_GT_GT_GT] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2011),
    [anon_sym_COMMA] = ACTIONS(5891),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(6450),
    [anon_sym_CARET_EQ] = ACTIONS(2011),
    [anon_sym_STAR_EQ] = ACTIONS(2011),
    [anon_sym_PIPE_EQ] = ACTIONS(2011),
    [anon_sym_DASH_EQ] = ACTIONS(2011),
    [anon_sym_AMP] = ACTIONS(6450),
    [anon_sym_PERCENT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_LT_LT_EQ] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_instanceof] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(6450),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_DOT] = ACTIONS(6453),
    [anon_sym_CARET] = ACTIONS(2013),
    [anon_sym_STAR_STAR] = ACTIONS(2013),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2013),
  },
  [3992] = {
    [sym_identifier] = ACTIONS(8979),
    [sym_comment] = ACTIONS(3),
  },
  [3993] = {
    [sym_type_alias_declaration] = STATE(2092),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(2092),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(2092),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(2092),
    [sym_return_statement] = STATE(2092),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(2092),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2092),
    [sym_switch_statement] = STATE(2092),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(2092),
    [sym_throw_statement] = STATE(2092),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(2092),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(2092),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(2092),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(2092),
    [sym_abstract_class] = STATE(2092),
    [sym_interface_declaration] = STATE(2092),
    [sym_statement_block] = STATE(2092),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(2092),
    [sym_debugger_statement] = STATE(2092),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(2092),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(2092),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(2092),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(2092),
    [sym_empty_statement] = STATE(2092),
    [sym_import_alias] = STATE(2092),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(2092),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(2092),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(2092),
    [sym_break_statement] = STATE(2092),
    [sym_labeled_statement] = STATE(2092),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(2092),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [3994] = {
    [sym_array] = STATE(4410),
    [sym_object] = STATE(4411),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(8981),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [3995] = {
    [anon_sym_of] = ACTIONS(8983),
    [sym_comment] = ACTIONS(3),
  },
  [3996] = {
    [anon_sym_of] = ACTIONS(8985),
    [sym_comment] = ACTIONS(3),
  },
  [3997] = {
    [anon_sym_of] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
  },
  [3998] = {
    [sym_new_expression] = STATE(4415),
    [sym_augmented_assignment_expression] = STATE(4415),
    [sym_unary_expression] = STATE(4415),
    [sym_update_expression] = STATE(4415),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(4415),
    [sym_regex] = STATE(4415),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4415),
    [sym_non_null_expression] = STATE(4415),
    [sym_as_expression] = STATE(4415),
    [sym_jsx_fragment] = STATE(4415),
    [sym_yield_expression] = STATE(4415),
    [sym_jsx_element] = STATE(4415),
    [sym_internal_module] = STATE(4415),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4415),
    [sym_await_expression] = STATE(4415),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(4416),
    [sym_string] = STATE(4415),
    [sym_this] = STATE(4415),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(4415),
    [sym_generator_function] = STATE(4415),
    [sym_call_expression] = STATE(4415),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(4415),
    [sym_ternary_expression] = STATE(4415),
    [sym_binary_expression] = STATE(4415),
    [sym_template_string] = STATE(4415),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4415),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(4415),
    [sym_class] = STATE(4415),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(8989),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(8989),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(8991),
    [sym_true] = ACTIONS(8989),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(8989),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [3999] = {
    [sym_new_expression] = STATE(4417),
    [sym_augmented_assignment_expression] = STATE(4417),
    [sym_unary_expression] = STATE(4417),
    [sym_update_expression] = STATE(4417),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4417),
    [sym_regex] = STATE(4417),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4417),
    [sym_non_null_expression] = STATE(4417),
    [sym_as_expression] = STATE(4417),
    [sym_jsx_fragment] = STATE(4417),
    [sym_yield_expression] = STATE(4417),
    [sym_jsx_element] = STATE(4417),
    [sym_internal_module] = STATE(4417),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4417),
    [sym_await_expression] = STATE(4417),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4417),
    [sym_this] = STATE(4417),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4417),
    [sym_generator_function] = STATE(4417),
    [sym_call_expression] = STATE(4417),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4417),
    [sym_ternary_expression] = STATE(4417),
    [sym_binary_expression] = STATE(4417),
    [sym_template_string] = STATE(4417),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4417),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4417),
    [sym_class] = STATE(4417),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(8993),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(8993),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(8995),
    [sym_true] = ACTIONS(8993),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(8993),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4000] = {
    [sym__initializer] = STATE(391),
    [sym_type_annotation] = STATE(392),
    [sym__automatic_semicolon] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(715),
    [anon_sym_of] = ACTIONS(8983),
    [anon_sym_COMMA] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(8997),
  },
  [4001] = {
    [sym__initializer] = STATE(411),
    [sym_type_annotation] = STATE(412),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(745),
    [anon_sym_of] = ACTIONS(8985),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(8999),
  },
  [4002] = {
    [sym__initializer] = STATE(413),
    [sym_type_annotation] = STATE(414),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(745),
    [anon_sym_of] = ACTIONS(8987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(9001),
  },
  [4003] = {
    [sym_new_expression] = STATE(4422),
    [sym_augmented_assignment_expression] = STATE(4422),
    [sym_unary_expression] = STATE(4422),
    [sym_update_expression] = STATE(4422),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(4422),
    [sym_regex] = STATE(4422),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4422),
    [sym_non_null_expression] = STATE(4422),
    [sym_as_expression] = STATE(4422),
    [sym_jsx_fragment] = STATE(4422),
    [sym_yield_expression] = STATE(4422),
    [sym_jsx_element] = STATE(4422),
    [sym_internal_module] = STATE(4422),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4422),
    [sym_await_expression] = STATE(4422),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(4423),
    [sym_string] = STATE(4422),
    [sym_this] = STATE(4422),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(4422),
    [sym_generator_function] = STATE(4422),
    [sym_call_expression] = STATE(4422),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(4422),
    [sym_ternary_expression] = STATE(4422),
    [sym_binary_expression] = STATE(4422),
    [sym_template_string] = STATE(4422),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4422),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4422),
    [sym_class] = STATE(4422),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(9003),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9003),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_RPAREN] = ACTIONS(9005),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9007),
    [sym_true] = ACTIONS(9003),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9003),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [4004] = {
    [sym_new_expression] = STATE(4424),
    [sym_augmented_assignment_expression] = STATE(4424),
    [sym_unary_expression] = STATE(4424),
    [sym_update_expression] = STATE(4424),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4424),
    [sym_regex] = STATE(4424),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4424),
    [sym_non_null_expression] = STATE(4424),
    [sym_as_expression] = STATE(4424),
    [sym_jsx_fragment] = STATE(4424),
    [sym_yield_expression] = STATE(4424),
    [sym_jsx_element] = STATE(4424),
    [sym_internal_module] = STATE(4424),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4424),
    [sym_await_expression] = STATE(4424),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4424),
    [sym_this] = STATE(4424),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4424),
    [sym_generator_function] = STATE(4424),
    [sym_call_expression] = STATE(4424),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4424),
    [sym_ternary_expression] = STATE(4424),
    [sym_binary_expression] = STATE(4424),
    [sym_template_string] = STATE(4424),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4424),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4424),
    [sym_class] = STATE(4424),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9009),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9009),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9011),
    [sym_true] = ACTIONS(9009),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9009),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4005] = {
    [sym_new_expression] = STATE(4425),
    [sym_augmented_assignment_expression] = STATE(4425),
    [sym_unary_expression] = STATE(4425),
    [sym_update_expression] = STATE(4425),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(4425),
    [sym_regex] = STATE(4425),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4425),
    [sym_non_null_expression] = STATE(4425),
    [sym_as_expression] = STATE(4425),
    [sym_jsx_fragment] = STATE(4425),
    [sym_yield_expression] = STATE(4425),
    [sym_jsx_element] = STATE(4425),
    [sym_internal_module] = STATE(4425),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4425),
    [sym_await_expression] = STATE(4425),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(4426),
    [sym_string] = STATE(4425),
    [sym_this] = STATE(4425),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(4425),
    [sym_generator_function] = STATE(4425),
    [sym_call_expression] = STATE(4425),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(4425),
    [sym_ternary_expression] = STATE(4425),
    [sym_binary_expression] = STATE(4425),
    [sym_template_string] = STATE(4425),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4425),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(4425),
    [sym_class] = STATE(4425),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(9013),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(9013),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(9015),
    [sym_true] = ACTIONS(9013),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(9013),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [4006] = {
    [sym_new_expression] = STATE(4427),
    [sym_augmented_assignment_expression] = STATE(4427),
    [sym_unary_expression] = STATE(4427),
    [sym_update_expression] = STATE(4427),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4427),
    [sym_regex] = STATE(4427),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4427),
    [sym_non_null_expression] = STATE(4427),
    [sym_as_expression] = STATE(4427),
    [sym_jsx_fragment] = STATE(4427),
    [sym_yield_expression] = STATE(4427),
    [sym_jsx_element] = STATE(4427),
    [sym_internal_module] = STATE(4427),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4427),
    [sym_await_expression] = STATE(4427),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4427),
    [sym_this] = STATE(4427),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4427),
    [sym_generator_function] = STATE(4427),
    [sym_call_expression] = STATE(4427),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4427),
    [sym_ternary_expression] = STATE(4427),
    [sym_binary_expression] = STATE(4427),
    [sym_template_string] = STATE(4427),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4427),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4427),
    [sym_class] = STATE(4427),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9017),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9017),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9019),
    [sym_true] = ACTIONS(9017),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9017),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4007] = {
    [sym_new_expression] = STATE(4428),
    [sym_augmented_assignment_expression] = STATE(4428),
    [sym_unary_expression] = STATE(4428),
    [sym_update_expression] = STATE(4428),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(4428),
    [sym_regex] = STATE(4428),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4428),
    [sym_non_null_expression] = STATE(4428),
    [sym_as_expression] = STATE(4428),
    [sym_jsx_fragment] = STATE(4428),
    [sym_yield_expression] = STATE(4428),
    [sym_jsx_element] = STATE(4428),
    [sym_internal_module] = STATE(4428),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4428),
    [sym_await_expression] = STATE(4428),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(4429),
    [sym_string] = STATE(4428),
    [sym_this] = STATE(4428),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(4428),
    [sym_generator_function] = STATE(4428),
    [sym_call_expression] = STATE(4428),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(4428),
    [sym_ternary_expression] = STATE(4428),
    [sym_binary_expression] = STATE(4428),
    [sym_template_string] = STATE(4428),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4428),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(4428),
    [sym_class] = STATE(4428),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(9021),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(9021),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(9023),
    [sym_true] = ACTIONS(9021),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(9021),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [4008] = {
    [anon_sym_COLON] = ACTIONS(9025),
    [sym_comment] = ACTIONS(3),
  },
  [4009] = {
    [sym_new_expression] = STATE(4431),
    [sym_augmented_assignment_expression] = STATE(4431),
    [sym_unary_expression] = STATE(4431),
    [sym_update_expression] = STATE(4431),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4431),
    [sym_regex] = STATE(4431),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4431),
    [sym_non_null_expression] = STATE(4431),
    [sym_as_expression] = STATE(4431),
    [sym_jsx_fragment] = STATE(4431),
    [sym_yield_expression] = STATE(4431),
    [sym_jsx_element] = STATE(4431),
    [sym_internal_module] = STATE(4431),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4431),
    [sym_await_expression] = STATE(4431),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4431),
    [sym_this] = STATE(4431),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4431),
    [sym_generator_function] = STATE(4431),
    [sym_call_expression] = STATE(4431),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4431),
    [sym_ternary_expression] = STATE(4431),
    [sym_binary_expression] = STATE(4431),
    [sym_template_string] = STATE(4431),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4431),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4431),
    [sym_class] = STATE(4431),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9027),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9027),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9029),
    [sym_true] = ACTIONS(9027),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9027),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4010] = {
    [sym_new_expression] = STATE(4432),
    [sym_augmented_assignment_expression] = STATE(4432),
    [sym_unary_expression] = STATE(4432),
    [sym_update_expression] = STATE(4432),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4432),
    [sym_regex] = STATE(4432),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4432),
    [sym_non_null_expression] = STATE(4432),
    [sym_as_expression] = STATE(4432),
    [sym_jsx_fragment] = STATE(4432),
    [sym_yield_expression] = STATE(4432),
    [sym_jsx_element] = STATE(4432),
    [sym_internal_module] = STATE(4432),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4432),
    [sym_await_expression] = STATE(4432),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4432),
    [sym_this] = STATE(4432),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4432),
    [sym_generator_function] = STATE(4432),
    [sym_call_expression] = STATE(4432),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4432),
    [sym_ternary_expression] = STATE(4432),
    [sym_binary_expression] = STATE(4432),
    [sym_template_string] = STATE(4432),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4432),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4432),
    [sym_class] = STATE(4432),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9031),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9031),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9033),
    [sym_true] = ACTIONS(9031),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9031),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4011] = {
    [sym_new_expression] = STATE(4433),
    [sym_augmented_assignment_expression] = STATE(4433),
    [sym_unary_expression] = STATE(4433),
    [sym_update_expression] = STATE(4433),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4433),
    [sym_regex] = STATE(4433),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4433),
    [sym_non_null_expression] = STATE(4433),
    [sym_as_expression] = STATE(4433),
    [sym_jsx_fragment] = STATE(4433),
    [sym_yield_expression] = STATE(4433),
    [sym_jsx_element] = STATE(4433),
    [sym_internal_module] = STATE(4433),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4433),
    [sym_await_expression] = STATE(4433),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4433),
    [sym_this] = STATE(4433),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4433),
    [sym_generator_function] = STATE(4433),
    [sym_call_expression] = STATE(4433),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4433),
    [sym_ternary_expression] = STATE(4433),
    [sym_binary_expression] = STATE(4433),
    [sym_template_string] = STATE(4433),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4433),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4433),
    [sym_class] = STATE(4433),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9035),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9035),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9037),
    [sym_true] = ACTIONS(9035),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9035),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4012] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9039),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4013] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9041),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4014] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9043),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4015] = {
    [sym_type_alias_declaration] = STATE(3704),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3704),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3704),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3704),
    [sym_return_statement] = STATE(3704),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3704),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3704),
    [sym_switch_statement] = STATE(3704),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3704),
    [sym_throw_statement] = STATE(3704),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3704),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3704),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(3704),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3704),
    [sym_abstract_class] = STATE(3704),
    [sym_interface_declaration] = STATE(3704),
    [sym_statement_block] = STATE(3704),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3704),
    [sym_debugger_statement] = STATE(3704),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3704),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3704),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3704),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3704),
    [sym_empty_statement] = STATE(3704),
    [sym_import_alias] = STATE(3704),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3704),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3704),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3704),
    [sym_break_statement] = STATE(3704),
    [sym_labeled_statement] = STATE(3704),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3704),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [4016] = {
    [sym_type_alias_declaration] = STATE(3732),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3732),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3732),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3732),
    [sym_return_statement] = STATE(3732),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3732),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3732),
    [sym_switch_statement] = STATE(3732),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3732),
    [sym_throw_statement] = STATE(3732),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3732),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3732),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(3732),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3732),
    [sym_abstract_class] = STATE(3732),
    [sym_interface_declaration] = STATE(3732),
    [sym_statement_block] = STATE(3732),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3732),
    [sym_debugger_statement] = STATE(3732),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3732),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3732),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3732),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3732),
    [sym_empty_statement] = STATE(3732),
    [sym_import_alias] = STATE(3732),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3732),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3732),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3732),
    [sym_break_statement] = STATE(3732),
    [sym_labeled_statement] = STATE(3732),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3732),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [4017] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(9045),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4018] = {
    [anon_sym_RPAREN] = ACTIONS(9045),
    [sym_comment] = ACTIONS(3),
  },
  [4019] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(9047),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4020] = {
    [anon_sym_RPAREN] = ACTIONS(9047),
    [sym_comment] = ACTIONS(3),
  },
  [4021] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(9049),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4022] = {
    [anon_sym_RPAREN] = ACTIONS(9049),
    [sym_comment] = ACTIONS(3),
  },
  [4023] = {
    [sym_type_alias_declaration] = STATE(3737),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3737),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3737),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3737),
    [sym_return_statement] = STATE(3737),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3737),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3737),
    [sym_switch_statement] = STATE(3737),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3737),
    [sym_throw_statement] = STATE(3737),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3737),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3737),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(3737),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3737),
    [sym_abstract_class] = STATE(3737),
    [sym_interface_declaration] = STATE(3737),
    [sym_statement_block] = STATE(3737),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3737),
    [sym_debugger_statement] = STATE(3737),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3737),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3737),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3737),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3737),
    [sym_empty_statement] = STATE(3737),
    [sym_import_alias] = STATE(3737),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3737),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3737),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3737),
    [sym_break_statement] = STATE(3737),
    [sym_labeled_statement] = STATE(3737),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3737),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [4024] = {
    [sym_type_alias_declaration] = STATE(3738),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3738),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3738),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3738),
    [sym_return_statement] = STATE(3738),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3738),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3738),
    [sym_switch_statement] = STATE(3738),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3738),
    [sym_throw_statement] = STATE(3738),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3738),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3738),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(3738),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3738),
    [sym_abstract_class] = STATE(3738),
    [sym_interface_declaration] = STATE(3738),
    [sym_statement_block] = STATE(3738),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3738),
    [sym_debugger_statement] = STATE(3738),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3738),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3738),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3738),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3738),
    [sym_empty_statement] = STATE(3738),
    [sym_import_alias] = STATE(3738),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3738),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3738),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3738),
    [sym_break_statement] = STATE(3738),
    [sym_labeled_statement] = STATE(3738),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3738),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [4025] = {
    [sym_type_alias_declaration] = STATE(3739),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3739),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3739),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3739),
    [sym_return_statement] = STATE(3739),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3739),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3739),
    [sym_switch_statement] = STATE(3739),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3739),
    [sym_throw_statement] = STATE(3739),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3739),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3739),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(3739),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3739),
    [sym_abstract_class] = STATE(3739),
    [sym_interface_declaration] = STATE(3739),
    [sym_statement_block] = STATE(3739),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3739),
    [sym_debugger_statement] = STATE(3739),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3739),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3739),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3739),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3739),
    [sym_empty_statement] = STATE(3739),
    [sym_import_alias] = STATE(3739),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3739),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3739),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3739),
    [sym_break_statement] = STATE(3739),
    [sym_labeled_statement] = STATE(3739),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3739),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [4026] = {
    [sym_type_alias_declaration] = STATE(3740),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3740),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3740),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3740),
    [sym_return_statement] = STATE(3740),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3740),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3740),
    [sym_switch_statement] = STATE(3740),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3740),
    [sym_throw_statement] = STATE(3740),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3740),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3740),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(3740),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3740),
    [sym_abstract_class] = STATE(3740),
    [sym_interface_declaration] = STATE(3740),
    [sym_statement_block] = STATE(3740),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3740),
    [sym_debugger_statement] = STATE(3740),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3740),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3740),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3740),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3740),
    [sym_empty_statement] = STATE(3740),
    [sym_import_alias] = STATE(3740),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3740),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3740),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3740),
    [sym_break_statement] = STATE(3740),
    [sym_labeled_statement] = STATE(3740),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3740),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [4027] = {
    [sym_type_alias_declaration] = STATE(3741),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3741),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3741),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3741),
    [sym_return_statement] = STATE(3741),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3741),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3741),
    [sym_switch_statement] = STATE(3741),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3741),
    [sym_throw_statement] = STATE(3741),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3741),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3741),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(3741),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3741),
    [sym_abstract_class] = STATE(3741),
    [sym_interface_declaration] = STATE(3741),
    [sym_statement_block] = STATE(3741),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3741),
    [sym_debugger_statement] = STATE(3741),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3741),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3741),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3741),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3741),
    [sym_empty_statement] = STATE(3741),
    [sym_import_alias] = STATE(3741),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3741),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3741),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3741),
    [sym_break_statement] = STATE(3741),
    [sym_labeled_statement] = STATE(3741),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3741),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [4028] = {
    [sym_type_arguments] = STATE(1064),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_while] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(9051),
  },
  [4029] = {
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(433),
    [sym_array_type] = STATE(1066),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym_existential_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(1066),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(1066),
    [sym_string] = STATE(418),
    [sym_tuple_type] = STATE(1066),
    [sym_identifier] = ACTIONS(8345),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [sym_true] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4030] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4035),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8345),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8349),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8351),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4031] = {
    [sym_type_parameters] = STATE(4441),
    [sym_formal_parameters] = STATE(4442),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4032] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4035),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8345),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8349),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8351),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4033] = {
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_PIPE] = ACTIONS(9055),
    [anon_sym_while] = ACTIONS(7948),
    [sym_comment] = ACTIONS(3),
  },
  [4034] = {
    [sym_formal_parameters] = STATE(4445),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4035] = {
    [anon_sym_EQ_GT] = ACTIONS(9057),
    [sym_comment] = ACTIONS(3),
  },
  [4036] = {
    [anon_sym_EQ_GT] = ACTIONS(9059),
    [sym_comment] = ACTIONS(3),
  },
  [4037] = {
    [sym_union_type] = STATE(4448),
    [sym__type] = STATE(4448),
    [sym_constructor_type] = STATE(4448),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2631),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4448),
    [sym_function_type] = STATE(4448),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2632),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1839),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5549),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4038] = {
    [sym_union_type] = STATE(4449),
    [sym__type] = STATE(4449),
    [sym_constructor_type] = STATE(4449),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2631),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4449),
    [sym_function_type] = STATE(4449),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2632),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1839),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5549),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4039] = {
    [anon_sym_EQ_GT] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(7154),
    [anon_sym_PIPE] = ACTIONS(7156),
    [sym_comment] = ACTIONS(3),
  },
  [4040] = {
    [anon_sym_EQ_GT] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_PIPE] = ACTIONS(3615),
    [sym_comment] = ACTIONS(3),
  },
  [4041] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3674),
    [anon_sym_DASH] = ACTIONS(3676),
    [anon_sym_STAR] = ACTIONS(3678),
    [anon_sym_GT_GT_GT] = ACTIONS(3674),
    [anon_sym_AMP_AMP] = ACTIONS(3680),
    [anon_sym_BANG_EQ] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_GT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3682),
    [anon_sym_PERCENT] = ACTIONS(3674),
    [anon_sym_QMARK] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3688),
    [anon_sym_PIPE_PIPE] = ACTIONS(3686),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3670),
    [anon_sym_LT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7181),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(3686),
    [anon_sym_STAR_STAR] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3676),
    [anon_sym_GT_GT] = ACTIONS(3678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3630),
  },
  [4042] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(7192),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(9061),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_GT_GT_GT] = ACTIONS(5893),
    [anon_sym_AMP_AMP] = ACTIONS(5893),
    [anon_sym_BANG_EQ] = ACTIONS(7192),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(9063),
    [anon_sym_PERCENT] = ACTIONS(5893),
    [anon_sym_QMARK] = ACTIONS(5893),
    [anon_sym_as] = ACTIONS(5893),
    [anon_sym_PIPE_PIPE] = ACTIONS(5893),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_EQ_EQ] = ACTIONS(7192),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5893),
    [anon_sym_DOT] = ACTIONS(5893),
    [anon_sym_CARET] = ACTIONS(5893),
    [anon_sym_STAR_STAR] = ACTIONS(5893),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_in] = ACTIONS(7192),
  },
  [4043] = {
    [anon_sym_EQ_GT] = ACTIONS(9065),
    [sym_comment] = ACTIONS(3),
  },
  [4044] = {
    [sym_union_type] = STATE(4451),
    [sym__type] = STATE(4451),
    [sym_constructor_type] = STATE(4451),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2655),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4451),
    [sym_function_type] = STATE(4451),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2656),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(5608),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(5614),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(5612),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(5616),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(5610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4045] = {
    [sym_union_type] = STATE(4452),
    [sym__type] = STATE(4452),
    [sym_constructor_type] = STATE(4452),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2655),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4452),
    [sym_function_type] = STATE(4452),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2656),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(5608),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(5614),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(5612),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(5616),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(5610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4046] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_BANG] = ACTIONS(7208),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(9061),
    [anon_sym_LT_LT] = ACTIONS(6040),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_STAR] = ACTIONS(7208),
    [anon_sym_GT_GT_GT] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(6040),
    [anon_sym_BANG_EQ] = ACTIONS(7208),
    [anon_sym_LT_EQ] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [anon_sym_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_AMP] = ACTIONS(9063),
    [anon_sym_PERCENT] = ACTIONS(6040),
    [anon_sym_QMARK] = ACTIONS(6040),
    [anon_sym_as] = ACTIONS(6040),
    [anon_sym_PIPE_PIPE] = ACTIONS(6040),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_instanceof] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6040),
    [anon_sym_DOT] = ACTIONS(6040),
    [anon_sym_CARET] = ACTIONS(6040),
    [anon_sym_STAR_STAR] = ACTIONS(6040),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6040),
    [anon_sym_in] = ACTIONS(7208),
  },
  [4047] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6023),
    [anon_sym_LBRACK] = ACTIONS(6023),
    [anon_sym_BANG] = ACTIONS(6025),
    [anon_sym_SEMI] = ACTIONS(6023),
    [anon_sym_BQUOTE] = ACTIONS(6023),
    [sym__automatic_semicolon] = ACTIONS(6023),
    [anon_sym_PIPE] = ACTIONS(6025),
    [anon_sym_COMMA] = ACTIONS(6023),
    [anon_sym_LT_LT] = ACTIONS(6023),
    [anon_sym_STAR] = ACTIONS(6025),
    [anon_sym_GT_GT_GT] = ACTIONS(6023),
    [anon_sym_AMP_AMP] = ACTIONS(6023),
    [anon_sym_DASH] = ACTIONS(6025),
    [anon_sym_BANG_EQ] = ACTIONS(6025),
    [anon_sym_LT_EQ] = ACTIONS(6023),
    [anon_sym_LPAREN] = ACTIONS(6023),
    [anon_sym_GT_EQ] = ACTIONS(6023),
    [anon_sym_GT] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(6025),
    [anon_sym_PERCENT] = ACTIONS(6023),
    [anon_sym_QMARK] = ACTIONS(6023),
    [anon_sym_RBRACE] = ACTIONS(6023),
    [anon_sym_as] = ACTIONS(6023),
    [anon_sym_PIPE_PIPE] = ACTIONS(6023),
    [anon_sym_DASH_DASH] = ACTIONS(6023),
    [anon_sym_EQ_EQ] = ACTIONS(6025),
    [anon_sym_instanceof] = ACTIONS(6023),
    [anon_sym_LT] = ACTIONS(6025),
    [anon_sym_RPAREN] = ACTIONS(6023),
    [anon_sym_SLASH] = ACTIONS(6025),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6023),
    [anon_sym_CARET] = ACTIONS(6023),
    [anon_sym_STAR_STAR] = ACTIONS(6023),
    [anon_sym_PLUS] = ACTIONS(6025),
    [anon_sym_GT_GT] = ACTIONS(6025),
    [anon_sym_PLUS_PLUS] = ACTIONS(6023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6023),
    [anon_sym_in] = ACTIONS(6025),
  },
  [4048] = {
    [sym_union_type] = STATE(2014),
    [sym__type] = STATE(2014),
    [sym_constructor_type] = STATE(2014),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2014),
    [sym_function_type] = STATE(2014),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(9067),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_boolean] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_this] = ACTIONS(765),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [4049] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8499),
    [anon_sym_LBRACK] = ACTIONS(8499),
    [anon_sym_BANG] = ACTIONS(8497),
    [anon_sym_SEMI] = ACTIONS(8499),
    [anon_sym_BQUOTE] = ACTIONS(8499),
    [sym__automatic_semicolon] = ACTIONS(8499),
    [anon_sym_PIPE] = ACTIONS(8497),
    [anon_sym_COMMA] = ACTIONS(8499),
    [anon_sym_LT_LT] = ACTIONS(8499),
    [anon_sym_STAR] = ACTIONS(8497),
    [anon_sym_GT_GT_GT] = ACTIONS(8499),
    [anon_sym_AMP_AMP] = ACTIONS(8499),
    [anon_sym_DASH] = ACTIONS(8497),
    [anon_sym_BANG_EQ] = ACTIONS(8497),
    [anon_sym_LT_EQ] = ACTIONS(8499),
    [anon_sym_LPAREN] = ACTIONS(8499),
    [anon_sym_GT_EQ] = ACTIONS(8499),
    [anon_sym_GT] = ACTIONS(8497),
    [anon_sym_AMP] = ACTIONS(8497),
    [anon_sym_PERCENT] = ACTIONS(8499),
    [anon_sym_QMARK] = ACTIONS(8499),
    [anon_sym_RBRACE] = ACTIONS(8499),
    [anon_sym_as] = ACTIONS(8499),
    [anon_sym_PIPE_PIPE] = ACTIONS(8499),
    [anon_sym_DASH_DASH] = ACTIONS(8499),
    [anon_sym_EQ_EQ] = ACTIONS(8497),
    [anon_sym_instanceof] = ACTIONS(8499),
    [anon_sym_LT] = ACTIONS(8497),
    [anon_sym_RPAREN] = ACTIONS(8499),
    [anon_sym_SLASH] = ACTIONS(8497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8499),
    [anon_sym_CARET] = ACTIONS(8499),
    [anon_sym_STAR_STAR] = ACTIONS(8499),
    [anon_sym_PLUS] = ACTIONS(8497),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8499),
    [anon_sym_GT_GT] = ACTIONS(8497),
    [anon_sym_PLUS_PLUS] = ACTIONS(8499),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8499),
    [anon_sym_in] = ACTIONS(8497),
  },
  [4050] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(2866),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(2866),
    [sym_call_signature] = STATE(2866),
    [sym_export_statement] = STATE(2866),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(2866),
    [sym_index_signature] = STATE(2866),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_RBRACE] = ACTIONS(9069),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9069),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [4051] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(9071),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [sym__automatic_semicolon] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(7194),
    [anon_sym_COMMA] = ACTIONS(8547),
    [anon_sym_LT_LT] = ACTIONS(8547),
    [anon_sym_STAR] = ACTIONS(9071),
    [anon_sym_GT_GT_GT] = ACTIONS(8547),
    [anon_sym_AMP_AMP] = ACTIONS(8547),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_BANG_EQ] = ACTIONS(9071),
    [anon_sym_LT_EQ] = ACTIONS(8547),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [anon_sym_GT_EQ] = ACTIONS(8547),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_AMP] = ACTIONS(7196),
    [anon_sym_PERCENT] = ACTIONS(8547),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_as] = ACTIONS(8547),
    [anon_sym_PIPE_PIPE] = ACTIONS(8547),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_EQ_EQ] = ACTIONS(9071),
    [anon_sym_instanceof] = ACTIONS(8547),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8547),
    [anon_sym_CARET] = ACTIONS(8547),
    [anon_sym_STAR_STAR] = ACTIONS(8547),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_GT_GT] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8547),
    [anon_sym_in] = ACTIONS(9071),
  },
  [4052] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(6453),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [anon_sym_PERCENT_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_AMP_EQ] = ACTIONS(2011),
    [anon_sym_PLUS_EQ] = ACTIONS(2011),
    [anon_sym_PIPE] = ACTIONS(8388),
    [anon_sym_COMMA] = ACTIONS(6453),
    [anon_sym_LT_LT] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_GT_GT_GT] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_RBRACK] = ACTIONS(6453),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_CARET_EQ] = ACTIONS(2011),
    [anon_sym_STAR_EQ] = ACTIONS(2011),
    [anon_sym_PIPE_EQ] = ACTIONS(2011),
    [anon_sym_DASH_EQ] = ACTIONS(2011),
    [anon_sym_AMP] = ACTIONS(8388),
    [anon_sym_PERCENT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_LT_LT_EQ] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_instanceof] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_DOT] = ACTIONS(6453),
    [anon_sym_CARET] = ACTIONS(2013),
    [anon_sym_STAR_STAR] = ACTIONS(2013),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2013),
  },
  [4053] = {
    [sym_statement_block] = STATE(3202),
    [sym__automatic_semicolon] = ACTIONS(7899),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_COMMA] = ACTIONS(7899),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [4054] = {
    [sym_type_parameters] = STATE(2715),
    [sym_formal_parameters] = STATE(2716),
    [sym_call_signature] = STATE(4455),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4055] = {
    [sym_type_parameters] = STATE(2715),
    [sym_formal_parameters] = STATE(2716),
    [sym_call_signature] = STATE(4455),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(9073),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [4056] = {
    [sym_string] = STATE(4457),
    [sym__property_name] = STATE(4457),
    [sym_computed_property_name] = STATE(4457),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(9075),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [4057] = {
    [sym_string] = STATE(4457),
    [sym__property_name] = STATE(4457),
    [sym_computed_property_name] = STATE(4457),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(9075),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [4058] = {
    [sym_type_parameters] = STATE(2715),
    [sym_type_annotation] = STATE(4125),
    [sym_formal_parameters] = STATE(2716),
    [sym_call_signature] = STATE(4455),
    [sym__automatic_semicolon] = ACTIONS(8507),
    [anon_sym_RBRACE] = ACTIONS(8507),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(8507),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8507),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(8507),
    [sym_comment] = ACTIONS(3),
  },
  [4059] = {
    [sym_identifier] = ACTIONS(9077),
    [sym_comment] = ACTIONS(3),
  },
  [4060] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(4177),
    [sym__automatic_semicolon] = ACTIONS(4177),
    [anon_sym_PERCENT_EQ] = ACTIONS(2015),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2015),
    [anon_sym_AMP_EQ] = ACTIONS(2015),
    [anon_sym_PLUS_EQ] = ACTIONS(2015),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(2017),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2015),
    [anon_sym_STAR_EQ] = ACTIONS(2015),
    [anon_sym_PIPE_EQ] = ACTIONS(2015),
    [anon_sym_DASH_EQ] = ACTIONS(2015),
    [anon_sym_EQ_GT] = ACTIONS(2019),
    [anon_sym_RBRACE] = ACTIONS(4177),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(2015),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2015),
    [anon_sym_GT_GT_EQ] = ACTIONS(2015),
    [anon_sym_DOT] = ACTIONS(9079),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4177),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2015),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2021),
  },
  [4061] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4181),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(4181),
    [sym__automatic_semicolon] = ACTIONS(4181),
    [anon_sym_PIPE] = ACTIONS(4179),
    [anon_sym_COMMA] = ACTIONS(4181),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(4181),
    [anon_sym_AMP] = ACTIONS(4179),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4181),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(113),
  },
  [4062] = {
    [aux_sym_export_statement_repeat1] = STATE(2704),
    [sym__property_name] = STATE(1807),
    [sym_object] = STATE(384),
    [sym_assignment_pattern] = STATE(670),
    [sym_pair] = STATE(670),
    [sym_method_signature] = STATE(2780),
    [sym_call_signature] = STATE(2780),
    [sym_type_parameters] = STATE(1082),
    [sym_index_signature] = STATE(2780),
    [sym_export_statement] = STATE(2780),
    [sym_method_definition] = STATE(670),
    [sym_property_signature] = STATE(2780),
    [sym_decorator] = STATE(2704),
    [sym_construct_signature] = STATE(2780),
    [sym_accessibility_modifier] = STATE(1808),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1807),
    [sym_array] = STATE(385),
    [sym_spread_element] = STATE(670),
    [sym_string] = STATE(1807),
    [sym_identifier] = ACTIONS(5681),
    [anon_sym_LBRACK] = ACTIONS(3785),
    [anon_sym_module] = ACTIONS(5683),
    [anon_sym_symbol] = ACTIONS(5683),
    [anon_sym_number] = ACTIONS(5683),
    [anon_sym_AT] = ACTIONS(360),
    [anon_sym_declare] = ACTIONS(5683),
    [anon_sym_COMMA] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_void] = ACTIONS(5683),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(5683),
    [anon_sym_private] = ACTIONS(5685),
    [anon_sym_boolean] = ACTIONS(5683),
    [anon_sym_static] = ACTIONS(3795),
    [anon_sym_async] = ACTIONS(5687),
    [anon_sym_get] = ACTIONS(5689),
    [anon_sym_RBRACE] = ACTIONS(1222),
    [anon_sym_public] = ACTIONS(5685),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(3801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(5685),
    [anon_sym_string] = ACTIONS(5683),
    [anon_sym_set] = ACTIONS(5689),
    [anon_sym_type] = ACTIONS(5683),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(5683),
    [anon_sym_export] = ACTIONS(5691),
    [sym_readonly] = ACTIONS(3805),
    [anon_sym_namespace] = ACTIONS(5683),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [4063] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_BQUOTE] = ACTIONS(1251),
    [anon_sym_SEMI] = ACTIONS(4105),
    [sym__automatic_semicolon] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(1257),
    [anon_sym_COMMA] = ACTIONS(1251),
    [anon_sym_LT_LT] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_GT_GT_GT] = ACTIONS(1251),
    [anon_sym_EQ] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_BANG_EQ] = ACTIONS(1257),
    [anon_sym_LT_EQ] = ACTIONS(1251),
    [anon_sym_LPAREN] = ACTIONS(1251),
    [anon_sym_GT_EQ] = ACTIONS(1251),
    [anon_sym_GT] = ACTIONS(1257),
    [anon_sym_RBRACE] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1257),
    [anon_sym_QMARK] = ACTIONS(1251),
    [anon_sym_PERCENT] = ACTIONS(1251),
    [anon_sym_as] = ACTIONS(1251),
    [anon_sym_PIPE_PIPE] = ACTIONS(1251),
    [anon_sym_DASH_DASH] = ACTIONS(1251),
    [anon_sym_EQ_EQ] = ACTIONS(1257),
    [anon_sym_instanceof] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1257),
    [anon_sym_SLASH] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1251),
    [anon_sym_CARET] = ACTIONS(1251),
    [anon_sym_STAR_STAR] = ACTIONS(1251),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_PLUS_PLUS] = ACTIONS(1251),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1251),
    [anon_sym_in] = ACTIONS(1257),
  },
  [4064] = {
    [sym_formal_parameters] = STATE(4460),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4065] = {
    [sym_type_annotation] = STATE(323),
    [anon_sym_EQ_GT] = ACTIONS(9081),
    [anon_sym_COLON] = ACTIONS(550),
    [sym_comment] = ACTIONS(3),
  },
  [4066] = {
    [sym_type_annotation] = STATE(892),
    [anon_sym_EQ_GT] = ACTIONS(9084),
    [anon_sym_COLON] = ACTIONS(550),
    [sym_comment] = ACTIONS(3),
  },
  [4067] = {
    [sym_type_arguments] = STATE(1885),
    [sym__automatic_semicolon] = ACTIONS(2204),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(3983),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(9087),
    [anon_sym_PIPE] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(3985),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2204),
  },
  [4068] = {
    [sym_index_type_query] = STATE(1887),
    [sym_lookup_type] = STATE(1887),
    [sym_flow_maybe_type] = STATE(1887),
    [sym_parenthesized_type] = STATE(1887),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_array_type] = STATE(1887),
    [sym_type_predicate] = STATE(1887),
    [sym_type_query] = STATE(1887),
    [sym_existential_type] = STATE(1887),
    [sym_this_type] = STATE(1887),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1887),
    [sym__primary_type] = STATE(1887),
    [sym_generic_type] = STATE(1887),
    [sym_literal_type] = STATE(1887),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1887),
    [sym_string] = STATE(1017),
    [sym_tuple_type] = STATE(1887),
    [sym_identifier] = ACTIONS(8421),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(8423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [sym_true] = ACTIONS(2137),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_LPAREN] = ACTIONS(3989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4069] = {
    [sym_union_type] = STATE(1892),
    [sym__type] = STATE(1892),
    [sym_constructor_type] = STATE(1892),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4073),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1892),
    [sym_function_type] = STATE(1892),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4074),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(8421),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(8423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8425),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8427),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4070] = {
    [sym_type_parameters] = STATE(4462),
    [sym_formal_parameters] = STATE(4463),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4071] = {
    [sym_union_type] = STATE(1900),
    [sym__type] = STATE(1900),
    [sym_constructor_type] = STATE(1900),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4073),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1900),
    [sym_function_type] = STATE(1900),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4074),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(8421),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(8423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8425),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8427),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4072] = {
    [sym__automatic_semicolon] = ACTIONS(3611),
    [anon_sym_RBRACE] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(9089),
    [anon_sym_SEMI] = ACTIONS(3611),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3611),
    [anon_sym_PIPE] = ACTIONS(9091),
    [anon_sym_COMMA] = ACTIONS(3611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3611),
  },
  [4073] = {
    [sym_formal_parameters] = STATE(4466),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4074] = {
    [anon_sym_EQ_GT] = ACTIONS(9093),
    [sym_comment] = ACTIONS(3),
  },
  [4075] = {
    [sym_string] = STATE(4457),
    [sym__property_name] = STATE(4457),
    [sym_computed_property_name] = STATE(4457),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(9075),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [4076] = {
    [sym_string] = STATE(4457),
    [sym__property_name] = STATE(4457),
    [sym_computed_property_name] = STATE(4457),
    [sym__automatic_semicolon] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1214),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_COMMA] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(9095),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1230),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_get] = ACTIONS(9097),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(9075),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1214),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(9097),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1214),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [4077] = {
    [sym_type_parameters] = STATE(2715),
    [sym_type_annotation] = STATE(4125),
    [sym_formal_parameters] = STATE(2716),
    [sym_call_signature] = STATE(4455),
    [sym__automatic_semicolon] = ACTIONS(8507),
    [anon_sym_RBRACE] = ACTIONS(8507),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(8507),
    [anon_sym_QMARK] = ACTIONS(9099),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8507),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(8507),
    [sym_comment] = ACTIONS(3),
  },
  [4078] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(6453),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [anon_sym_PERCENT_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_AMP_EQ] = ACTIONS(2011),
    [anon_sym_PLUS_EQ] = ACTIONS(2011),
    [anon_sym_PIPE] = ACTIONS(8388),
    [anon_sym_COMMA] = ACTIONS(2011),
    [anon_sym_LT_LT] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_GT_GT_GT] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_CARET_EQ] = ACTIONS(2011),
    [anon_sym_STAR_EQ] = ACTIONS(2011),
    [anon_sym_PIPE_EQ] = ACTIONS(2011),
    [anon_sym_DASH_EQ] = ACTIONS(2011),
    [anon_sym_AMP] = ACTIONS(8388),
    [anon_sym_PERCENT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_LT_LT_EQ] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_RPAREN] = ACTIONS(6453),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_instanceof] = ACTIONS(2011),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2011),
    [anon_sym_SLASH_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_DOT] = ACTIONS(6453),
    [anon_sym_CARET] = ACTIONS(2013),
    [anon_sym_STAR_STAR] = ACTIONS(2013),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2013),
  },
  [4079] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5792),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(5794),
    [anon_sym_LT_LT] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(5800),
    [anon_sym_GT_GT_GT] = ACTIONS(5796),
    [anon_sym_AMP_AMP] = ACTIONS(5802),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(5792),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_QMARK] = ACTIONS(5806),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [anon_sym_as] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_instanceof] = ACTIONS(5792),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(5808),
    [anon_sym_STAR_STAR] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5798),
    [anon_sym_GT_GT] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5792),
    [anon_sym_in] = ACTIONS(5752),
  },
  [4080] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5792),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(5794),
    [anon_sym_LT_LT] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(5800),
    [anon_sym_GT_GT_GT] = ACTIONS(5796),
    [anon_sym_AMP_AMP] = ACTIONS(5802),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(5792),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_RBRACE] = ACTIONS(5240),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_QMARK] = ACTIONS(5806),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [anon_sym_as] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_instanceof] = ACTIONS(5792),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(5808),
    [anon_sym_STAR_STAR] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5798),
    [anon_sym_GT_GT] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5792),
    [anon_sym_in] = ACTIONS(5752),
  },
  [4081] = {
    [sym_new_expression] = STATE(4471),
    [sym_augmented_assignment_expression] = STATE(4471),
    [sym_unary_expression] = STATE(4471),
    [sym_update_expression] = STATE(4471),
    [sym_call_signature] = STATE(1839),
    [sym_meta_property] = STATE(4471),
    [sym_regex] = STATE(4471),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4471),
    [sym_non_null_expression] = STATE(4471),
    [sym_as_expression] = STATE(4471),
    [sym_jsx_fragment] = STATE(4471),
    [sym_yield_expression] = STATE(4471),
    [sym_jsx_element] = STATE(4471),
    [sym_internal_module] = STATE(4471),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4471),
    [sym_await_expression] = STATE(4471),
    [sym_member_expression] = STATE(1841),
    [sym_string] = STATE(4471),
    [sym_this] = STATE(4471),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(1842),
    [sym_anonymous_class] = STATE(4471),
    [sym_generator_function] = STATE(4471),
    [sym_call_expression] = STATE(4471),
    [sym_subscript_expression] = STATE(1841),
    [sym_assignment_expression] = STATE(4471),
    [sym_ternary_expression] = STATE(4471),
    [sym_binary_expression] = STATE(4471),
    [sym_template_string] = STATE(4471),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4471),
    [sym_array] = STATE(1843),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4471),
    [sym_class] = STATE(4471),
    [anon_sym_BANG] = ACTIONS(3840),
    [sym_identifier] = ACTIONS(3842),
    [sym_false] = ACTIONS(9101),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3848),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(3852),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9101),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3854),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9103),
    [sym_true] = ACTIONS(9101),
    [anon_sym_yield] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9101),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_await] = ACTIONS(3866),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_PLUS_PLUS] = ACTIONS(3856),
  },
  [4082] = {
    [sym_union_type] = STATE(4472),
    [sym__type] = STATE(4472),
    [sym_constructor_type] = STATE(4472),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3500),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4472),
    [sym_function_type] = STATE(4472),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3501),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(7341),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(7347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(7345),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(7349),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(7343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4083] = {
    [sym_formal_parameters] = STATE(4473),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4084] = {
    [anon_sym_EQ_GT] = ACTIONS(9105),
    [sym_comment] = ACTIONS(3),
  },
  [4085] = {
    [sym_union_type] = STATE(3067),
    [sym__type] = STATE(3067),
    [sym_constructor_type] = STATE(3067),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3500),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3067),
    [sym_function_type] = STATE(3067),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3501),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(7341),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(7347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(7345),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(7349),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(7343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4086] = {
    [sym_union_type] = STATE(3068),
    [sym__type] = STATE(3068),
    [sym_constructor_type] = STATE(3068),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3500),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3068),
    [sym_function_type] = STATE(3068),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3501),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(7341),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(7347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(7345),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(7349),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(7343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4087] = {
    [anon_sym_EQ_GT] = ACTIONS(9107),
    [sym_comment] = ACTIONS(3),
  },
  [4088] = {
    [sym_union_type] = STATE(4476),
    [sym__type] = STATE(4476),
    [sym_constructor_type] = STATE(4476),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3500),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4476),
    [sym_function_type] = STATE(4476),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3501),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(7341),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(7347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(7345),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(7349),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(7343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4089] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(5746),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5746),
    [anon_sym_AMP_EQ] = ACTIONS(5746),
    [anon_sym_PLUS_EQ] = ACTIONS(5746),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_EQ] = ACTIONS(5748),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_CARET_EQ] = ACTIONS(5746),
    [anon_sym_STAR_EQ] = ACTIONS(5746),
    [anon_sym_PIPE_EQ] = ACTIONS(5746),
    [anon_sym_DASH_EQ] = ACTIONS(5746),
    [anon_sym_EQ_GT] = ACTIONS(5750),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(5746),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5746),
    [anon_sym_GT_GT_EQ] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(7050),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5746),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5752),
  },
  [4090] = {
    [sym_union_type] = STATE(4477),
    [sym__type] = STATE(4477),
    [sym_constructor_type] = STATE(4477),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(1868),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4477),
    [sym_function_type] = STATE(4477),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(1869),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(3946),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(3952),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(3950),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(3948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4091] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_BANG] = ACTIONS(8379),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(8461),
    [anon_sym_COMMA] = ACTIONS(7511),
    [anon_sym_LT_LT] = ACTIONS(7511),
    [anon_sym_STAR] = ACTIONS(8379),
    [anon_sym_GT_GT_GT] = ACTIONS(7511),
    [anon_sym_AMP_AMP] = ACTIONS(7511),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_BANG_EQ] = ACTIONS(8379),
    [anon_sym_LT_EQ] = ACTIONS(7511),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [anon_sym_GT_EQ] = ACTIONS(7511),
    [anon_sym_GT] = ACTIONS(8379),
    [anon_sym_RBRACE] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(8463),
    [anon_sym_QMARK] = ACTIONS(7511),
    [anon_sym_PERCENT] = ACTIONS(7511),
    [anon_sym_as] = ACTIONS(7511),
    [anon_sym_PIPE_PIPE] = ACTIONS(7511),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_EQ_EQ] = ACTIONS(8379),
    [anon_sym_instanceof] = ACTIONS(7511),
    [anon_sym_LT] = ACTIONS(8379),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7511),
    [anon_sym_CARET] = ACTIONS(7511),
    [anon_sym_STAR_STAR] = ACTIONS(7511),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_GT_GT] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7511),
    [anon_sym_in] = ACTIONS(8379),
  },
  [4092] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_BANG] = ACTIONS(8381),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(8461),
    [anon_sym_COMMA] = ACTIONS(7529),
    [anon_sym_LT_LT] = ACTIONS(7529),
    [anon_sym_STAR] = ACTIONS(8381),
    [anon_sym_GT_GT_GT] = ACTIONS(7529),
    [anon_sym_AMP_AMP] = ACTIONS(7529),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_BANG_EQ] = ACTIONS(8381),
    [anon_sym_LT_EQ] = ACTIONS(7529),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [anon_sym_GT_EQ] = ACTIONS(7529),
    [anon_sym_GT] = ACTIONS(8381),
    [anon_sym_RBRACE] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(8463),
    [anon_sym_QMARK] = ACTIONS(7529),
    [anon_sym_PERCENT] = ACTIONS(7529),
    [anon_sym_as] = ACTIONS(7529),
    [anon_sym_PIPE_PIPE] = ACTIONS(7529),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_EQ_EQ] = ACTIONS(8381),
    [anon_sym_instanceof] = ACTIONS(7529),
    [anon_sym_LT] = ACTIONS(8381),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7529),
    [anon_sym_CARET] = ACTIONS(7529),
    [anon_sym_STAR_STAR] = ACTIONS(7529),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_GT_GT] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7529),
    [anon_sym_in] = ACTIONS(8381),
  },
  [4093] = {
    [anon_sym_EQ] = ACTIONS(6023),
    [anon_sym_LBRACK] = ACTIONS(6023),
    [anon_sym_AMP] = ACTIONS(6023),
    [anon_sym_SEMI] = ACTIONS(6023),
    [sym__automatic_semicolon] = ACTIONS(6023),
    [anon_sym_RBRACE] = ACTIONS(6023),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6023),
    [anon_sym_PIPE] = ACTIONS(6025),
    [anon_sym_COMMA] = ACTIONS(6023),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6023),
  },
  [4094] = {
    [sym_union_type] = STATE(2014),
    [sym__type] = STATE(2014),
    [sym_constructor_type] = STATE(2014),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2014),
    [sym_function_type] = STATE(2014),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(9109),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_boolean] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_this] = ACTIONS(765),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [4095] = {
    [anon_sym_EQ_GT] = ACTIONS(9111),
    [sym_comment] = ACTIONS(3),
  },
  [4096] = {
    [sym_union_type] = STATE(4480),
    [sym__type] = STATE(4480),
    [sym_constructor_type] = STATE(4480),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2778),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4480),
    [sym_function_type] = STATE(4480),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2779),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2135),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5845),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5847),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4097] = {
    [sym_union_type] = STATE(4481),
    [sym__type] = STATE(4481),
    [sym_constructor_type] = STATE(4481),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2778),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4481),
    [sym_function_type] = STATE(4481),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2779),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2135),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5845),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5847),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4098] = {
    [anon_sym_EQ] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(7383),
    [anon_sym_SEMI] = ACTIONS(6040),
    [sym__automatic_semicolon] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(7385),
    [anon_sym_COMMA] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
  },
  [4099] = {
    [anon_sym_EQ] = ACTIONS(8499),
    [anon_sym_LBRACK] = ACTIONS(8499),
    [anon_sym_AMP] = ACTIONS(8499),
    [anon_sym_SEMI] = ACTIONS(8499),
    [sym__automatic_semicolon] = ACTIONS(8499),
    [anon_sym_RBRACE] = ACTIONS(8499),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8499),
    [anon_sym_PIPE] = ACTIONS(8497),
    [anon_sym_COMMA] = ACTIONS(8499),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8499),
  },
  [4100] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(2866),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(2866),
    [sym_call_signature] = STATE(2866),
    [sym_export_statement] = STATE(2866),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(2866),
    [sym_index_signature] = STATE(2866),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_RBRACE] = ACTIONS(9113),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9113),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [4101] = {
    [anon_sym_EQ] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(4001),
    [sym__automatic_semicolon] = ACTIONS(8547),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_COMMA] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
  },
  [4102] = {
    [anon_sym_EQ_GT] = ACTIONS(9115),
    [sym_comment] = ACTIONS(3),
  },
  [4103] = {
    [sym_union_type] = STATE(4484),
    [sym__type] = STATE(4484),
    [sym_constructor_type] = STATE(4484),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2801),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4484),
    [sym_function_type] = STATE(4484),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2802),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2183),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5869),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5871),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4104] = {
    [sym_union_type] = STATE(4485),
    [sym__type] = STATE(4485),
    [sym_constructor_type] = STATE(4485),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2801),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4485),
    [sym_function_type] = STATE(4485),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2802),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2183),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5869),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5871),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4105] = {
    [anon_sym_EQ] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(7401),
    [anon_sym_PIPE] = ACTIONS(7403),
    [sym_comment] = ACTIONS(3),
  },
  [4106] = {
    [anon_sym_EQ] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4037),
    [sym_comment] = ACTIONS(3),
  },
  [4107] = {
    [sym_formal_parameters] = STATE(4486),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4108] = {
    [anon_sym_EQ_GT] = ACTIONS(9117),
    [sym_comment] = ACTIONS(3),
  },
  [4109] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3548),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3549),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(7409),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(7411),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(7413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4110] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3548),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3549),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(7409),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(7411),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(7413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4111] = {
    [anon_sym_EQ_GT] = ACTIONS(9119),
    [sym_comment] = ACTIONS(3),
  },
  [4112] = {
    [sym_union_type] = STATE(4489),
    [sym__type] = STATE(4489),
    [sym_constructor_type] = STATE(4489),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3548),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4489),
    [sym_function_type] = STATE(4489),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3549),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(7409),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(7411),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(7413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4113] = {
    [sym_union_type] = STATE(4490),
    [sym__type] = STATE(4490),
    [sym_constructor_type] = STATE(4490),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1926),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4490),
    [sym_function_type] = STATE(4490),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1927),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4057),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4114] = {
    [anon_sym_AMP] = ACTIONS(5881),
    [anon_sym_PIPE] = ACTIONS(5883),
    [anon_sym_RBRACK] = ACTIONS(7511),
    [sym_comment] = ACTIONS(3),
  },
  [4115] = {
    [anon_sym_AMP] = ACTIONS(5881),
    [anon_sym_PIPE] = ACTIONS(5883),
    [anon_sym_RBRACK] = ACTIONS(7529),
    [sym_comment] = ACTIONS(3),
  },
  [4116] = {
    [sym_union_type] = STATE(4491),
    [sym__type] = STATE(4491),
    [sym_constructor_type] = STATE(4491),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(1933),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4491),
    [sym_function_type] = STATE(4491),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(1934),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4065),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4067),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4117] = {
    [anon_sym_GT] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(5895),
    [anon_sym_PIPE] = ACTIONS(5897),
    [anon_sym_COMMA] = ACTIONS(7511),
    [sym_comment] = ACTIONS(3),
  },
  [4118] = {
    [anon_sym_GT] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(5895),
    [anon_sym_PIPE] = ACTIONS(5897),
    [anon_sym_COMMA] = ACTIONS(7529),
    [sym_comment] = ACTIONS(3),
  },
  [4119] = {
    [sym_type_annotation] = STATE(4248),
    [anon_sym_COLON] = ACTIONS(4149),
    [sym_comment] = ACTIONS(3),
  },
  [4120] = {
    [sym_type_annotation] = STATE(4249),
    [anon_sym_COLON] = ACTIONS(4149),
    [sym_comment] = ACTIONS(3),
  },
  [4121] = {
    [sym_identifier] = ACTIONS(9121),
    [anon_sym_BQUOTE] = ACTIONS(9123),
    [anon_sym_debugger] = ACTIONS(9121),
    [anon_sym_symbol] = ACTIONS(9121),
    [anon_sym_AT] = ACTIONS(9123),
    [anon_sym_PIPE] = ACTIONS(9123),
    [anon_sym_COMMA] = ACTIONS(9123),
    [anon_sym_DASH] = ACTIONS(9121),
    [anon_sym_EQ] = ACTIONS(9121),
    [anon_sym_void] = ACTIONS(9121),
    [anon_sym_break] = ACTIONS(9121),
    [anon_sym_const] = ACTIONS(9121),
    [sym_super] = ACTIONS(9121),
    [anon_sym_return] = ACTIONS(9121),
    [anon_sym_private] = ACTIONS(9121),
    [anon_sym_get] = ACTIONS(9121),
    [anon_sym_RBRACE] = ACTIONS(9123),
    [anon_sym_interface] = ACTIONS(9121),
    [anon_sym_default] = ACTIONS(9121),
    [anon_sym_enum] = ACTIONS(9121),
    [anon_sym_delete] = ACTIONS(9121),
    [anon_sym_continue] = ACTIONS(9121),
    [anon_sym_DASH_DASH] = ACTIONS(9123),
    [anon_sym_if] = ACTIONS(9121),
    [anon_sym_this] = ACTIONS(9121),
    [anon_sym_yield] = ACTIONS(9121),
    [sym_true] = ACTIONS(9121),
    [anon_sym_throw] = ACTIONS(9121),
    [anon_sym_protected] = ACTIONS(9121),
    [anon_sym_abstract] = ACTIONS(9121),
    [anon_sym_set] = ACTIONS(9121),
    [anon_sym_type] = ACTIONS(9121),
    [anon_sym_import] = ACTIONS(9121),
    [anon_sym_namespace] = ACTIONS(9121),
    [anon_sym_PLUS_PLUS] = ACTIONS(9123),
    [anon_sym_await] = ACTIONS(9121),
    [anon_sym_DQUOTE] = ACTIONS(9123),
    [anon_sym_else] = ACTIONS(9121),
    [anon_sym_BANG] = ACTIONS(9123),
    [anon_sym_for] = ACTIONS(9121),
    [anon_sym_LBRACK] = ACTIONS(9123),
    [sym_false] = ACTIONS(9121),
    [anon_sym_SEMI] = ACTIONS(9123),
    [anon_sym_case] = ACTIONS(9121),
    [anon_sym_module] = ACTIONS(9121),
    [anon_sym_number] = ACTIONS(9121),
    [anon_sym_class] = ACTIONS(9121),
    [anon_sym_declare] = ACTIONS(9121),
    [anon_sym_typeof] = ACTIONS(9121),
    [anon_sym_LBRACE] = ACTIONS(9123),
    [anon_sym_switch] = ACTIONS(9121),
    [anon_sym_LPAREN] = ACTIONS(9123),
    [anon_sym_RBRACK] = ACTIONS(9123),
    [sym_null] = ACTIONS(9121),
    [anon_sym_GT] = ACTIONS(9123),
    [anon_sym_any] = ACTIONS(9121),
    [anon_sym_boolean] = ACTIONS(9121),
    [anon_sym_async] = ACTIONS(9121),
    [anon_sym_public] = ACTIONS(9121),
    [anon_sym_EQ_GT] = ACTIONS(9123),
    [anon_sym_AMP] = ACTIONS(9123),
    [anon_sym_var] = ACTIONS(9121),
    [anon_sym_while] = ACTIONS(9121),
    [anon_sym_SQUOTE] = ACTIONS(9123),
    [anon_sym_try] = ACTIONS(9121),
    [anon_sym_RPAREN] = ACTIONS(9123),
    [anon_sym_LT] = ACTIONS(9123),
    [sym_number] = ACTIONS(9123),
    [anon_sym_SLASH] = ACTIONS(9121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9121),
    [anon_sym_function] = ACTIONS(9121),
    [sym_undefined] = ACTIONS(9121),
    [anon_sym_new] = ACTIONS(9121),
    [ts_builtin_sym_end] = ACTIONS(9123),
    [anon_sym_let] = ACTIONS(9121),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_export] = ACTIONS(9121),
    [anon_sym_do] = ACTIONS(9121),
    [anon_sym_TILDE] = ACTIONS(9123),
    [anon_sym_with] = ACTIONS(9121),
  },
  [4122] = {
    [sym__automatic_semicolon] = ACTIONS(8727),
    [anon_sym_RBRACE] = ACTIONS(8727),
    [anon_sym_SEMI] = ACTIONS(8727),
    [anon_sym_COMMA] = ACTIONS(8727),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8727),
    [sym_comment] = ACTIONS(3),
  },
  [4123] = {
    [sym_type_parameters] = STATE(1082),
    [sym_formal_parameters] = STATE(1081),
    [sym_call_signature] = STATE(4492),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4124] = {
    [sym_type_parameters] = STATE(1082),
    [sym_formal_parameters] = STATE(1081),
    [sym_call_signature] = STATE(4492),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(9125),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [4125] = {
    [sym__automatic_semicolon] = ACTIONS(9127),
    [anon_sym_RBRACE] = ACTIONS(9127),
    [anon_sym_SEMI] = ACTIONS(9127),
    [anon_sym_COMMA] = ACTIONS(9127),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9127),
    [sym_comment] = ACTIONS(3),
  },
  [4126] = {
    [sym__automatic_semicolon] = ACTIONS(5252),
    [anon_sym_RBRACE] = ACTIONS(5252),
    [anon_sym_SEMI] = ACTIONS(5252),
    [anon_sym_COMMA] = ACTIONS(5252),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5252),
    [sym_comment] = ACTIONS(3),
  },
  [4127] = {
    [sym__automatic_semicolon] = ACTIONS(4411),
    [anon_sym_RBRACE] = ACTIONS(4411),
    [anon_sym_SEMI] = ACTIONS(4411),
    [anon_sym_COMMA] = ACTIONS(4411),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4411),
    [sym_comment] = ACTIONS(3),
  },
  [4128] = {
    [sym_object_type] = STATE(4494),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1921),
  },
  [4129] = {
    [sym__automatic_semicolon] = ACTIONS(4415),
    [anon_sym_RBRACE] = ACTIONS(4415),
    [anon_sym_SEMI] = ACTIONS(4415),
    [anon_sym_COMMA] = ACTIONS(4415),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4415),
    [sym_comment] = ACTIONS(3),
  },
  [4130] = {
    [aux_sym_enum_body_repeat1] = STATE(4497),
    [anon_sym_COMMA] = ACTIONS(9129),
    [anon_sym_RBRACE] = ACTIONS(9131),
    [sym_comment] = ACTIONS(3),
  },
  [4131] = {
    [sym__automatic_semicolon] = ACTIONS(7088),
    [anon_sym_RBRACE] = ACTIONS(7088),
    [anon_sym_SEMI] = ACTIONS(7088),
    [anon_sym_COMMA] = ACTIONS(7088),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7088),
    [sym_comment] = ACTIONS(3),
  },
  [4132] = {
    [anon_sym_COLON] = ACTIONS(9133),
    [sym_comment] = ACTIONS(3),
  },
  [4133] = {
    [sym__automatic_semicolon] = ACTIONS(5359),
    [anon_sym_RBRACE] = ACTIONS(5359),
    [anon_sym_SEMI] = ACTIONS(5359),
    [anon_sym_COMMA] = ACTIONS(5359),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5359),
    [sym_comment] = ACTIONS(3),
  },
  [4134] = {
    [sym__automatic_semicolon] = ACTIONS(4018),
    [anon_sym_RBRACE] = ACTIONS(4018),
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_COMMA] = ACTIONS(4018),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4018),
    [sym_comment] = ACTIONS(3),
  },
  [4135] = {
    [sym__automatic_semicolon] = ACTIONS(4028),
    [anon_sym_RBRACE] = ACTIONS(4028),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_COMMA] = ACTIONS(4028),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4028),
    [sym_comment] = ACTIONS(3),
  },
  [4136] = {
    [sym_class_body] = STATE(4499),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(322),
  },
  [4137] = {
    [sym_class_heritage] = STATE(4500),
    [sym_extends_clause] = STATE(179),
    [sym_implements_clause] = STATE(180),
    [sym_class_body] = STATE(4499),
    [anon_sym_extends] = ACTIONS(1131),
    [anon_sym_implements] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(322),
  },
  [4138] = {
    [sym__automatic_semicolon] = ACTIONS(4439),
    [anon_sym_RBRACE] = ACTIONS(4439),
    [anon_sym_SEMI] = ACTIONS(4439),
    [anon_sym_COMMA] = ACTIONS(4439),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4439),
    [sym_comment] = ACTIONS(3),
  },
  [4139] = {
    [sym__automatic_semicolon] = ACTIONS(9135),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_PIPE] = ACTIONS(4447),
    [anon_sym_SEMI] = ACTIONS(9135),
    [sym_comment] = ACTIONS(3),
  },
  [4140] = {
    [sym_union_type] = STATE(4502),
    [sym__type] = STATE(4502),
    [sym_constructor_type] = STATE(4502),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(1198),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4502),
    [sym_function_type] = STATE(4502),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(1199),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(2475),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4141] = {
    [sym__automatic_semicolon] = ACTIONS(9137),
    [anon_sym_SEMI] = ACTIONS(9137),
    [anon_sym_DOT] = ACTIONS(4457),
    [sym_comment] = ACTIONS(3),
  },
  [4142] = {
    [sym_statement_block] = STATE(2496),
    [sym__automatic_semicolon] = ACTIONS(9139),
    [anon_sym_SEMI] = ACTIONS(9139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(909),
  },
  [4143] = {
    [sym_union_type] = STATE(1892),
    [sym__type] = STATE(1892),
    [sym_constructor_type] = STATE(1892),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4147),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1892),
    [sym_function_type] = STATE(1892),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4148),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5967),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8527),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8529),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4144] = {
    [sym_type_parameters] = STATE(4505),
    [sym_formal_parameters] = STATE(4506),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4145] = {
    [sym_union_type] = STATE(1900),
    [sym__type] = STATE(1900),
    [sym_constructor_type] = STATE(1900),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4147),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1900),
    [sym_function_type] = STATE(1900),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4148),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5967),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8527),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8529),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4146] = {
    [sym__automatic_semicolon] = ACTIONS(5893),
    [anon_sym_RBRACE] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_SEMI] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(9141),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(9143),
    [anon_sym_COMMA] = ACTIONS(5893),
    [sym_comment] = ACTIONS(3),
  },
  [4147] = {
    [sym_formal_parameters] = STATE(4509),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4148] = {
    [anon_sym_EQ_GT] = ACTIONS(9145),
    [sym_comment] = ACTIONS(3),
  },
  [4149] = {
    [anon_sym_EQ_GT] = ACTIONS(9147),
    [sym_comment] = ACTIONS(3),
  },
  [4150] = {
    [sym_union_type] = STATE(4512),
    [sym__type] = STATE(4512),
    [sym_constructor_type] = STATE(4512),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2864),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4512),
    [sym_function_type] = STATE(4512),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2865),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5967),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5971),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5973),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4151] = {
    [sym_union_type] = STATE(4513),
    [sym__type] = STATE(4513),
    [sym_constructor_type] = STATE(4513),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2864),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4513),
    [sym_function_type] = STATE(4513),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2865),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5967),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5971),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5973),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4152] = {
    [sym__automatic_semicolon] = ACTIONS(6040),
    [anon_sym_RBRACE] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(7479),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(7481),
    [anon_sym_COMMA] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
  },
  [4153] = {
    [sym_string] = STATE(4514),
    [sym__property_name] = STATE(4514),
    [sym_computed_property_name] = STATE(4514),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(9149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [4154] = {
    [sym_string] = STATE(4514),
    [sym__property_name] = STATE(4514),
    [sym_computed_property_name] = STATE(4514),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(9149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [4155] = {
    [sym_type_parameters] = STATE(1082),
    [sym_type_annotation] = STATE(4515),
    [sym_formal_parameters] = STATE(1081),
    [sym_call_signature] = STATE(4492),
    [sym__automatic_semicolon] = ACTIONS(9127),
    [anon_sym_RBRACE] = ACTIONS(9127),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(9127),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9127),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(9127),
    [sym_comment] = ACTIONS(3),
  },
  [4156] = {
    [anon_sym_EQ_GT] = ACTIONS(9151),
    [sym_comment] = ACTIONS(3),
  },
  [4157] = {
    [sym_union_type] = STATE(4517),
    [sym__type] = STATE(4517),
    [sym_constructor_type] = STATE(4517),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2873),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4517),
    [sym_function_type] = STATE(4517),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2874),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5983),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5985),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4158] = {
    [sym_union_type] = STATE(4518),
    [sym__type] = STATE(4518),
    [sym_constructor_type] = STATE(4518),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2873),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4518),
    [sym_function_type] = STATE(4518),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2874),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5983),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5985),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4159] = {
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_RBRACK] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
  },
  [4160] = {
    [anon_sym_AMP] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4163),
    [anon_sym_COMMA] = ACTIONS(8547),
    [anon_sym_RBRACK] = ACTIONS(8547),
    [sym_comment] = ACTIONS(3),
  },
  [4161] = {
    [anon_sym_EQ_GT] = ACTIONS(9153),
    [sym_comment] = ACTIONS(3),
  },
  [4162] = {
    [sym_union_type] = STATE(4520),
    [sym__type] = STATE(4520),
    [sym_constructor_type] = STATE(4520),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2888),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4520),
    [sym_function_type] = STATE(4520),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2889),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6001),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6003),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6005),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4163] = {
    [sym_union_type] = STATE(4521),
    [sym__type] = STATE(4521),
    [sym_constructor_type] = STATE(4521),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2888),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4521),
    [sym_function_type] = STATE(4521),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2889),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6001),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6003),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6005),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4164] = {
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_RPAREN] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(7513),
    [anon_sym_PIPE] = ACTIONS(7515),
    [sym_comment] = ACTIONS(3),
  },
  [4165] = {
    [anon_sym_AMP] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(4221),
    [sym_comment] = ACTIONS(3),
  },
  [4166] = {
    [sym_union_type] = STATE(4522),
    [sym__type] = STATE(4522),
    [sym_constructor_type] = STATE(4522),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2038),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4522),
    [sym_function_type] = STATE(4522),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2039),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(4292),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(4298),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(4296),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(4300),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(4294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4167] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_BANG] = ACTIONS(8379),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(8553),
    [anon_sym_COMMA] = ACTIONS(7511),
    [anon_sym_LT_LT] = ACTIONS(7511),
    [anon_sym_STAR] = ACTIONS(8379),
    [anon_sym_GT_GT_GT] = ACTIONS(7511),
    [anon_sym_AMP_AMP] = ACTIONS(7511),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_BANG_EQ] = ACTIONS(8379),
    [anon_sym_LT_EQ] = ACTIONS(7511),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [anon_sym_GT_EQ] = ACTIONS(7511),
    [anon_sym_GT] = ACTIONS(8379),
    [anon_sym_AMP] = ACTIONS(8555),
    [anon_sym_PERCENT] = ACTIONS(7511),
    [anon_sym_QMARK] = ACTIONS(7511),
    [anon_sym_as] = ACTIONS(7511),
    [anon_sym_PIPE_PIPE] = ACTIONS(7511),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_EQ_EQ] = ACTIONS(8379),
    [anon_sym_RPAREN] = ACTIONS(7511),
    [anon_sym_LT] = ACTIONS(8379),
    [anon_sym_instanceof] = ACTIONS(7511),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7511),
    [anon_sym_CARET] = ACTIONS(7511),
    [anon_sym_STAR_STAR] = ACTIONS(7511),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_GT_GT] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7511),
    [anon_sym_in] = ACTIONS(8379),
  },
  [4168] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_BANG] = ACTIONS(8381),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(8553),
    [anon_sym_COMMA] = ACTIONS(7529),
    [anon_sym_LT_LT] = ACTIONS(7529),
    [anon_sym_STAR] = ACTIONS(8381),
    [anon_sym_GT_GT_GT] = ACTIONS(7529),
    [anon_sym_AMP_AMP] = ACTIONS(7529),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_BANG_EQ] = ACTIONS(8381),
    [anon_sym_LT_EQ] = ACTIONS(7529),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [anon_sym_GT_EQ] = ACTIONS(7529),
    [anon_sym_GT] = ACTIONS(8381),
    [anon_sym_AMP] = ACTIONS(8555),
    [anon_sym_PERCENT] = ACTIONS(7529),
    [anon_sym_QMARK] = ACTIONS(7529),
    [anon_sym_as] = ACTIONS(7529),
    [anon_sym_PIPE_PIPE] = ACTIONS(7529),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_EQ_EQ] = ACTIONS(8381),
    [anon_sym_RPAREN] = ACTIONS(7529),
    [anon_sym_LT] = ACTIONS(8381),
    [anon_sym_instanceof] = ACTIONS(7529),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7529),
    [anon_sym_CARET] = ACTIONS(7529),
    [anon_sym_STAR_STAR] = ACTIONS(7529),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_GT_GT] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7529),
    [anon_sym_in] = ACTIONS(8381),
  },
  [4169] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4379),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4381),
    [anon_sym_COMMA] = ACTIONS(7181),
    [anon_sym_LT_LT] = ACTIONS(4383),
    [anon_sym_STAR] = ACTIONS(4393),
    [anon_sym_LBRACE] = ACTIONS(9155),
    [anon_sym_AMP_AMP] = ACTIONS(4391),
    [anon_sym_GT_GT_GT] = ACTIONS(4383),
    [anon_sym_DASH] = ACTIONS(4387),
    [anon_sym_BANG_EQ] = ACTIONS(4335),
    [anon_sym_LT_EQ] = ACTIONS(4379),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(4379),
    [anon_sym_GT] = ACTIONS(4335),
    [anon_sym_AMP] = ACTIONS(4395),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_LBRACE_PIPE] = ACTIONS(7181),
    [anon_sym_as] = ACTIONS(4401),
    [anon_sym_PIPE_PIPE] = ACTIONS(4399),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4335),
    [anon_sym_instanceof] = ACTIONS(4379),
    [anon_sym_LT] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4393),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4399),
    [anon_sym_STAR_STAR] = ACTIONS(4405),
    [anon_sym_PLUS] = ACTIONS(4387),
    [anon_sym_GT_GT] = ACTIONS(4393),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4379),
    [anon_sym_in] = ACTIONS(4335),
  },
  [4170] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(7192),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(9157),
    [anon_sym_COMMA] = ACTIONS(5893),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_LBRACE] = ACTIONS(7192),
    [anon_sym_AMP_AMP] = ACTIONS(5893),
    [anon_sym_GT_GT_GT] = ACTIONS(5893),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_BANG_EQ] = ACTIONS(7192),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(9159),
    [anon_sym_PERCENT] = ACTIONS(5893),
    [anon_sym_QMARK] = ACTIONS(5893),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5893),
    [anon_sym_as] = ACTIONS(5893),
    [anon_sym_PIPE_PIPE] = ACTIONS(5893),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_EQ_EQ] = ACTIONS(7192),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5893),
    [anon_sym_CARET] = ACTIONS(5893),
    [anon_sym_STAR_STAR] = ACTIONS(5893),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_in] = ACTIONS(7192),
  },
  [4171] = {
    [anon_sym_EQ_GT] = ACTIONS(9161),
    [sym_comment] = ACTIONS(3),
  },
  [4172] = {
    [sym_union_type] = STATE(4524),
    [sym__type] = STATE(4524),
    [sym_constructor_type] = STATE(4524),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2928),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4524),
    [sym_function_type] = STATE(4524),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2929),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(6124),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(6130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(6128),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(6132),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(6126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4173] = {
    [sym_union_type] = STATE(4525),
    [sym__type] = STATE(4525),
    [sym_constructor_type] = STATE(4525),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2928),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4525),
    [sym_function_type] = STATE(4525),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2929),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(6124),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(6130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(6128),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(6132),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(6126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4174] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_BANG] = ACTIONS(7208),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(9157),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_LT_LT] = ACTIONS(6040),
    [anon_sym_STAR] = ACTIONS(7208),
    [anon_sym_LBRACE] = ACTIONS(7208),
    [anon_sym_AMP_AMP] = ACTIONS(6040),
    [anon_sym_GT_GT_GT] = ACTIONS(6040),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_BANG_EQ] = ACTIONS(7208),
    [anon_sym_LT_EQ] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [anon_sym_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_AMP] = ACTIONS(9159),
    [anon_sym_PERCENT] = ACTIONS(6040),
    [anon_sym_QMARK] = ACTIONS(6040),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6040),
    [anon_sym_as] = ACTIONS(6040),
    [anon_sym_PIPE_PIPE] = ACTIONS(6040),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_instanceof] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6040),
    [anon_sym_CARET] = ACTIONS(6040),
    [anon_sym_STAR_STAR] = ACTIONS(6040),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6040),
    [anon_sym_in] = ACTIONS(7208),
  },
  [4175] = {
    [sym_new_expression] = STATE(4526),
    [sym_augmented_assignment_expression] = STATE(4526),
    [sym_unary_expression] = STATE(4526),
    [sym_update_expression] = STATE(4526),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4526),
    [sym_regex] = STATE(4526),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4526),
    [sym_non_null_expression] = STATE(4526),
    [sym_as_expression] = STATE(4526),
    [sym_jsx_fragment] = STATE(4526),
    [sym_yield_expression] = STATE(4526),
    [sym_jsx_element] = STATE(4526),
    [sym_internal_module] = STATE(4526),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4526),
    [sym_await_expression] = STATE(4526),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4526),
    [sym_this] = STATE(4526),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4526),
    [sym_generator_function] = STATE(4526),
    [sym_call_expression] = STATE(4526),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4526),
    [sym_ternary_expression] = STATE(4526),
    [sym_binary_expression] = STATE(4526),
    [sym_template_string] = STATE(4526),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4526),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4526),
    [sym_class] = STATE(4526),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9163),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9163),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9165),
    [sym_true] = ACTIONS(9163),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9163),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4176] = {
    [sym_new_expression] = STATE(4527),
    [sym_augmented_assignment_expression] = STATE(4527),
    [sym_unary_expression] = STATE(4527),
    [sym_update_expression] = STATE(4527),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4527),
    [sym_regex] = STATE(4527),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4527),
    [sym_non_null_expression] = STATE(4527),
    [sym_as_expression] = STATE(4527),
    [sym_jsx_fragment] = STATE(4527),
    [sym_yield_expression] = STATE(4527),
    [sym_jsx_element] = STATE(4527),
    [sym_internal_module] = STATE(4527),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4527),
    [sym_await_expression] = STATE(4527),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4527),
    [sym_this] = STATE(4527),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4527),
    [sym_generator_function] = STATE(4527),
    [sym_call_expression] = STATE(4527),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4527),
    [sym_ternary_expression] = STATE(4527),
    [sym_binary_expression] = STATE(4527),
    [sym_template_string] = STATE(4527),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4527),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4527),
    [sym_class] = STATE(4527),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9167),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9167),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9169),
    [sym_true] = ACTIONS(9167),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9167),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4177] = {
    [sym_new_expression] = STATE(4528),
    [sym_augmented_assignment_expression] = STATE(4528),
    [sym_unary_expression] = STATE(4528),
    [sym_update_expression] = STATE(4528),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4528),
    [sym_regex] = STATE(4528),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4528),
    [sym_non_null_expression] = STATE(4528),
    [sym_as_expression] = STATE(4528),
    [sym_jsx_fragment] = STATE(4528),
    [sym_yield_expression] = STATE(4528),
    [sym_jsx_element] = STATE(4528),
    [sym_internal_module] = STATE(4528),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4528),
    [sym_await_expression] = STATE(4528),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4528),
    [sym_this] = STATE(4528),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4528),
    [sym_generator_function] = STATE(4528),
    [sym_call_expression] = STATE(4528),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4528),
    [sym_ternary_expression] = STATE(4528),
    [sym_binary_expression] = STATE(4528),
    [sym_template_string] = STATE(4528),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4528),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4528),
    [sym_class] = STATE(4528),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9171),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9173),
    [sym_true] = ACTIONS(9171),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9171),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4178] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9175),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4179] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9177),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4180] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9179),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4181] = {
    [sym_type_alias_declaration] = STATE(3704),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3704),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3704),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3704),
    [sym_return_statement] = STATE(3704),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3704),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3704),
    [sym_switch_statement] = STATE(3704),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3704),
    [sym_throw_statement] = STATE(3704),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3704),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3704),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(3704),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3704),
    [sym_abstract_class] = STATE(3704),
    [sym_interface_declaration] = STATE(3704),
    [sym_statement_block] = STATE(3704),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3704),
    [sym_debugger_statement] = STATE(3704),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3704),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3704),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3704),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3704),
    [sym_empty_statement] = STATE(3704),
    [sym_import_alias] = STATE(3704),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3704),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3704),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3704),
    [sym_break_statement] = STATE(3704),
    [sym_labeled_statement] = STATE(3704),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3704),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [4182] = {
    [sym_type_alias_declaration] = STATE(3732),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3732),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3732),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3732),
    [sym_return_statement] = STATE(3732),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3732),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3732),
    [sym_switch_statement] = STATE(3732),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3732),
    [sym_throw_statement] = STATE(3732),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3732),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3732),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(3732),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3732),
    [sym_abstract_class] = STATE(3732),
    [sym_interface_declaration] = STATE(3732),
    [sym_statement_block] = STATE(3732),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3732),
    [sym_debugger_statement] = STATE(3732),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3732),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3732),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3732),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3732),
    [sym_empty_statement] = STATE(3732),
    [sym_import_alias] = STATE(3732),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3732),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3732),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3732),
    [sym_break_statement] = STATE(3732),
    [sym_labeled_statement] = STATE(3732),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3732),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [4183] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(9181),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4184] = {
    [anon_sym_RPAREN] = ACTIONS(9181),
    [sym_comment] = ACTIONS(3),
  },
  [4185] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(9183),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4186] = {
    [anon_sym_RPAREN] = ACTIONS(9183),
    [sym_comment] = ACTIONS(3),
  },
  [4187] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(9185),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4188] = {
    [anon_sym_RPAREN] = ACTIONS(9185),
    [sym_comment] = ACTIONS(3),
  },
  [4189] = {
    [sym_type_alias_declaration] = STATE(3737),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3737),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3737),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3737),
    [sym_return_statement] = STATE(3737),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3737),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3737),
    [sym_switch_statement] = STATE(3737),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3737),
    [sym_throw_statement] = STATE(3737),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3737),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3737),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(3737),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3737),
    [sym_abstract_class] = STATE(3737),
    [sym_interface_declaration] = STATE(3737),
    [sym_statement_block] = STATE(3737),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3737),
    [sym_debugger_statement] = STATE(3737),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3737),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3737),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3737),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3737),
    [sym_empty_statement] = STATE(3737),
    [sym_import_alias] = STATE(3737),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3737),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3737),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3737),
    [sym_break_statement] = STATE(3737),
    [sym_labeled_statement] = STATE(3737),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3737),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [4190] = {
    [sym_type_alias_declaration] = STATE(3738),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3738),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3738),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3738),
    [sym_return_statement] = STATE(3738),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3738),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3738),
    [sym_switch_statement] = STATE(3738),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3738),
    [sym_throw_statement] = STATE(3738),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3738),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3738),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(3738),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3738),
    [sym_abstract_class] = STATE(3738),
    [sym_interface_declaration] = STATE(3738),
    [sym_statement_block] = STATE(3738),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3738),
    [sym_debugger_statement] = STATE(3738),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3738),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3738),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3738),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3738),
    [sym_empty_statement] = STATE(3738),
    [sym_import_alias] = STATE(3738),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3738),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3738),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3738),
    [sym_break_statement] = STATE(3738),
    [sym_labeled_statement] = STATE(3738),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3738),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [4191] = {
    [sym_type_alias_declaration] = STATE(3739),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3739),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3739),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3739),
    [sym_return_statement] = STATE(3739),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3739),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3739),
    [sym_switch_statement] = STATE(3739),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3739),
    [sym_throw_statement] = STATE(3739),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3739),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3739),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(3739),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3739),
    [sym_abstract_class] = STATE(3739),
    [sym_interface_declaration] = STATE(3739),
    [sym_statement_block] = STATE(3739),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3739),
    [sym_debugger_statement] = STATE(3739),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3739),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3739),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3739),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3739),
    [sym_empty_statement] = STATE(3739),
    [sym_import_alias] = STATE(3739),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3739),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3739),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3739),
    [sym_break_statement] = STATE(3739),
    [sym_labeled_statement] = STATE(3739),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3739),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [4192] = {
    [sym_type_alias_declaration] = STATE(3740),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3740),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3740),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3740),
    [sym_return_statement] = STATE(3740),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3740),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3740),
    [sym_switch_statement] = STATE(3740),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3740),
    [sym_throw_statement] = STATE(3740),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3740),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3740),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(3740),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3740),
    [sym_abstract_class] = STATE(3740),
    [sym_interface_declaration] = STATE(3740),
    [sym_statement_block] = STATE(3740),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3740),
    [sym_debugger_statement] = STATE(3740),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3740),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3740),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3740),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3740),
    [sym_empty_statement] = STATE(3740),
    [sym_import_alias] = STATE(3740),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3740),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3740),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3740),
    [sym_break_statement] = STATE(3740),
    [sym_labeled_statement] = STATE(3740),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3740),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [4193] = {
    [sym_type_alias_declaration] = STATE(3741),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3741),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3741),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3741),
    [sym_return_statement] = STATE(3741),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3741),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3741),
    [sym_switch_statement] = STATE(3741),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3741),
    [sym_throw_statement] = STATE(3741),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3741),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3741),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(3741),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3741),
    [sym_abstract_class] = STATE(3741),
    [sym_interface_declaration] = STATE(3741),
    [sym_statement_block] = STATE(3741),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3741),
    [sym_debugger_statement] = STATE(3741),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3741),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3741),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3741),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3741),
    [sym_empty_statement] = STATE(3741),
    [sym_import_alias] = STATE(3741),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3741),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3741),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3741),
    [sym_break_statement] = STATE(3741),
    [sym_labeled_statement] = STATE(3741),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3741),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [4194] = {
    [sym_type_arguments] = STATE(1064),
    [sym_identifier] = ACTIONS(3699),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [anon_sym_debugger] = ACTIONS(3699),
    [anon_sym_symbol] = ACTIONS(3699),
    [anon_sym_AT] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_void] = ACTIONS(3699),
    [anon_sym_break] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [sym_super] = ACTIONS(3699),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_private] = ACTIONS(3699),
    [anon_sym_get] = ACTIONS(3699),
    [anon_sym_interface] = ACTIONS(3699),
    [anon_sym_enum] = ACTIONS(3699),
    [anon_sym_delete] = ACTIONS(3699),
    [anon_sym_continue] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(3699),
    [anon_sym_this] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3699),
    [sym_true] = ACTIONS(3699),
    [anon_sym_throw] = ACTIONS(3699),
    [anon_sym_protected] = ACTIONS(3699),
    [anon_sym_abstract] = ACTIONS(3699),
    [anon_sym_DOT] = ACTIONS(4187),
    [anon_sym_set] = ACTIONS(3699),
    [anon_sym_type] = ACTIONS(3699),
    [anon_sym_import] = ACTIONS(3699),
    [anon_sym_namespace] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_await] = ACTIONS(3699),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [anon_sym_else] = ACTIONS(3699),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [sym_false] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_module] = ACTIONS(3699),
    [anon_sym_number] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_declare] = ACTIONS(3699),
    [anon_sym_typeof] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(9187),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [sym_null] = ACTIONS(3699),
    [anon_sym_any] = ACTIONS(3699),
    [anon_sym_boolean] = ACTIONS(3699),
    [anon_sym_async] = ACTIONS(3699),
    [anon_sym_public] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_var] = ACTIONS(3699),
    [anon_sym_while] = ACTIONS(3699),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_try] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(7943),
    [sym_number] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3699),
    [sym_undefined] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3699),
    [ts_builtin_sym_end] = ACTIONS(2204),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_export] = ACTIONS(3699),
    [anon_sym_do] = ACTIONS(3699),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_with] = ACTIONS(3699),
  },
  [4195] = {
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_array_type] = STATE(1066),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym_existential_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(1066),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(1066),
    [sym_string] = STATE(418),
    [sym_tuple_type] = STATE(1066),
    [sym_identifier] = ACTIONS(8615),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [sym_true] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4196] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4200),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4201),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8615),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8619),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8621),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4197] = {
    [sym_type_parameters] = STATE(4536),
    [sym_formal_parameters] = STATE(4537),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4198] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4200),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4201),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8615),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8619),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8621),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4199] = {
    [sym_identifier] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7948),
    [anon_sym_debugger] = ACTIONS(7946),
    [anon_sym_symbol] = ACTIONS(7946),
    [anon_sym_AT] = ACTIONS(7948),
    [anon_sym_PIPE] = ACTIONS(9189),
    [anon_sym_DASH] = ACTIONS(7946),
    [anon_sym_void] = ACTIONS(7946),
    [anon_sym_break] = ACTIONS(7946),
    [anon_sym_const] = ACTIONS(7946),
    [sym_super] = ACTIONS(7946),
    [anon_sym_return] = ACTIONS(7946),
    [anon_sym_private] = ACTIONS(7946),
    [anon_sym_get] = ACTIONS(7946),
    [anon_sym_interface] = ACTIONS(7946),
    [anon_sym_enum] = ACTIONS(7946),
    [anon_sym_delete] = ACTIONS(7946),
    [anon_sym_continue] = ACTIONS(7946),
    [anon_sym_DASH_DASH] = ACTIONS(7948),
    [anon_sym_if] = ACTIONS(7946),
    [anon_sym_this] = ACTIONS(7946),
    [anon_sym_yield] = ACTIONS(7946),
    [sym_true] = ACTIONS(7946),
    [anon_sym_throw] = ACTIONS(7946),
    [anon_sym_protected] = ACTIONS(7946),
    [anon_sym_abstract] = ACTIONS(7946),
    [anon_sym_set] = ACTIONS(7946),
    [anon_sym_type] = ACTIONS(7946),
    [anon_sym_import] = ACTIONS(7946),
    [anon_sym_namespace] = ACTIONS(7946),
    [anon_sym_PLUS_PLUS] = ACTIONS(7948),
    [anon_sym_await] = ACTIONS(7946),
    [anon_sym_DQUOTE] = ACTIONS(7948),
    [anon_sym_else] = ACTIONS(7946),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_for] = ACTIONS(7946),
    [anon_sym_LBRACK] = ACTIONS(7948),
    [sym_false] = ACTIONS(7946),
    [anon_sym_SEMI] = ACTIONS(7948),
    [anon_sym_module] = ACTIONS(7946),
    [anon_sym_number] = ACTIONS(7946),
    [anon_sym_class] = ACTIONS(7946),
    [anon_sym_declare] = ACTIONS(7946),
    [anon_sym_typeof] = ACTIONS(7946),
    [anon_sym_LBRACE] = ACTIONS(7948),
    [anon_sym_switch] = ACTIONS(7946),
    [anon_sym_LPAREN] = ACTIONS(7948),
    [sym_null] = ACTIONS(7946),
    [anon_sym_any] = ACTIONS(7946),
    [anon_sym_boolean] = ACTIONS(7946),
    [anon_sym_async] = ACTIONS(7946),
    [anon_sym_public] = ACTIONS(7946),
    [anon_sym_AMP] = ACTIONS(9191),
    [anon_sym_var] = ACTIONS(7946),
    [anon_sym_while] = ACTIONS(7946),
    [anon_sym_SQUOTE] = ACTIONS(7948),
    [anon_sym_try] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(7948),
    [sym_number] = ACTIONS(7948),
    [anon_sym_SLASH] = ACTIONS(7946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7946),
    [anon_sym_function] = ACTIONS(7946),
    [sym_undefined] = ACTIONS(7946),
    [anon_sym_new] = ACTIONS(7946),
    [ts_builtin_sym_end] = ACTIONS(7948),
    [anon_sym_let] = ACTIONS(7946),
    [anon_sym_PLUS] = ACTIONS(7946),
    [anon_sym_export] = ACTIONS(7946),
    [anon_sym_do] = ACTIONS(7946),
    [anon_sym_TILDE] = ACTIONS(7948),
    [anon_sym_with] = ACTIONS(7946),
  },
  [4200] = {
    [sym_formal_parameters] = STATE(4540),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4201] = {
    [anon_sym_EQ_GT] = ACTIONS(9193),
    [sym_comment] = ACTIONS(3),
  },
  [4202] = {
    [anon_sym_EQ_GT] = ACTIONS(9195),
    [sym_comment] = ACTIONS(3),
  },
  [4203] = {
    [sym_union_type] = STATE(4543),
    [sym__type] = STATE(4543),
    [sym_constructor_type] = STATE(4543),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2964),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4543),
    [sym_function_type] = STATE(4543),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2965),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(6198),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(6202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4204] = {
    [sym_union_type] = STATE(4544),
    [sym__type] = STATE(4544),
    [sym_constructor_type] = STATE(4544),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2964),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4544),
    [sym_function_type] = STATE(4544),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2965),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(6198),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(6202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4205] = {
    [sym__automatic_semicolon] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(7628),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(7630),
    [sym_comment] = ACTIONS(3),
  },
  [4206] = {
    [sym__automatic_semicolon] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_PIPE] = ACTIONS(4447),
    [anon_sym_SEMI] = ACTIONS(8547),
    [sym_comment] = ACTIONS(3),
  },
  [4207] = {
    [sym_type_alias_declaration] = STATE(4545),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4545),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4545),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4545),
    [sym_return_statement] = STATE(4545),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4545),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4545),
    [sym_switch_statement] = STATE(4545),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4545),
    [sym_throw_statement] = STATE(4545),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4545),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4545),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(4545),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4545),
    [sym_abstract_class] = STATE(4545),
    [sym_interface_declaration] = STATE(4545),
    [sym_statement_block] = STATE(4545),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4545),
    [sym_debugger_statement] = STATE(4545),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4545),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4545),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4545),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4545),
    [sym_empty_statement] = STATE(4545),
    [sym_import_alias] = STATE(4545),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4545),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4545),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4545),
    [sym_break_statement] = STATE(4545),
    [sym_labeled_statement] = STATE(4545),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4545),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [4208] = {
    [sym_type_alias_declaration] = STATE(4546),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4546),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4546),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4546),
    [sym_return_statement] = STATE(4546),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4546),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4546),
    [sym_switch_statement] = STATE(4546),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4546),
    [sym_throw_statement] = STATE(4546),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4546),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4546),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(4546),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4546),
    [sym_abstract_class] = STATE(4546),
    [sym_interface_declaration] = STATE(4546),
    [sym_statement_block] = STATE(4546),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4546),
    [sym_debugger_statement] = STATE(4546),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4546),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4546),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4546),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4546),
    [sym_empty_statement] = STATE(4546),
    [sym_import_alias] = STATE(4546),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4546),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4546),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4546),
    [sym_break_statement] = STATE(4546),
    [sym_labeled_statement] = STATE(4546),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4546),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [4209] = {
    [sym_type_alias_declaration] = STATE(4547),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4547),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4547),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4547),
    [sym_return_statement] = STATE(4547),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4547),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4547),
    [sym_switch_statement] = STATE(4547),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4547),
    [sym_throw_statement] = STATE(4547),
    [aux_sym_export_statement_repeat1] = STATE(55),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4547),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4547),
    [sym_decorator] = STATE(55),
    [sym_continue_statement] = STATE(4547),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4547),
    [sym_abstract_class] = STATE(4547),
    [sym_interface_declaration] = STATE(4547),
    [sym_statement_block] = STATE(4547),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4547),
    [sym_debugger_statement] = STATE(4547),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4547),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4547),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4547),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4547),
    [sym_empty_statement] = STATE(4547),
    [sym_import_alias] = STATE(4547),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4547),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4547),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4547),
    [sym_break_statement] = STATE(4547),
    [sym_labeled_statement] = STATE(4547),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4547),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [4210] = {
    [sym_identifier] = ACTIONS(9197),
    [anon_sym_BQUOTE] = ACTIONS(9199),
    [anon_sym_debugger] = ACTIONS(9197),
    [anon_sym_symbol] = ACTIONS(9197),
    [anon_sym_AT] = ACTIONS(9199),
    [anon_sym_DASH] = ACTIONS(9197),
    [anon_sym_void] = ACTIONS(9197),
    [anon_sym_break] = ACTIONS(9197),
    [anon_sym_const] = ACTIONS(9197),
    [sym_super] = ACTIONS(9197),
    [anon_sym_return] = ACTIONS(9197),
    [anon_sym_private] = ACTIONS(9197),
    [anon_sym_get] = ACTIONS(9197),
    [anon_sym_RBRACE] = ACTIONS(9199),
    [anon_sym_interface] = ACTIONS(9197),
    [anon_sym_default] = ACTIONS(9197),
    [anon_sym_enum] = ACTIONS(9197),
    [anon_sym_delete] = ACTIONS(9197),
    [anon_sym_continue] = ACTIONS(9197),
    [anon_sym_DASH_DASH] = ACTIONS(9199),
    [anon_sym_if] = ACTIONS(9197),
    [anon_sym_this] = ACTIONS(9197),
    [anon_sym_yield] = ACTIONS(9197),
    [sym_true] = ACTIONS(9197),
    [anon_sym_throw] = ACTIONS(9197),
    [anon_sym_protected] = ACTIONS(9197),
    [anon_sym_abstract] = ACTIONS(9197),
    [anon_sym_set] = ACTIONS(9197),
    [anon_sym_type] = ACTIONS(9197),
    [anon_sym_import] = ACTIONS(9197),
    [anon_sym_namespace] = ACTIONS(9197),
    [anon_sym_PLUS_PLUS] = ACTIONS(9199),
    [anon_sym_await] = ACTIONS(9197),
    [anon_sym_DQUOTE] = ACTIONS(9199),
    [anon_sym_else] = ACTIONS(9197),
    [anon_sym_BANG] = ACTIONS(9199),
    [anon_sym_for] = ACTIONS(9197),
    [anon_sym_LBRACK] = ACTIONS(9199),
    [sym_false] = ACTIONS(9197),
    [anon_sym_SEMI] = ACTIONS(9199),
    [anon_sym_case] = ACTIONS(9197),
    [anon_sym_module] = ACTIONS(9197),
    [anon_sym_number] = ACTIONS(9197),
    [anon_sym_class] = ACTIONS(9197),
    [anon_sym_declare] = ACTIONS(9197),
    [anon_sym_typeof] = ACTIONS(9197),
    [anon_sym_LBRACE] = ACTIONS(9199),
    [anon_sym_switch] = ACTIONS(9197),
    [anon_sym_LPAREN] = ACTIONS(9199),
    [sym_null] = ACTIONS(9197),
    [anon_sym_any] = ACTIONS(9197),
    [anon_sym_boolean] = ACTIONS(9197),
    [anon_sym_async] = ACTIONS(9197),
    [anon_sym_public] = ACTIONS(9197),
    [anon_sym_var] = ACTIONS(9197),
    [anon_sym_while] = ACTIONS(9197),
    [anon_sym_SQUOTE] = ACTIONS(9199),
    [anon_sym_try] = ACTIONS(9197),
    [anon_sym_LT] = ACTIONS(9199),
    [sym_number] = ACTIONS(9199),
    [anon_sym_SLASH] = ACTIONS(9197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9197),
    [anon_sym_function] = ACTIONS(9197),
    [sym_undefined] = ACTIONS(9197),
    [anon_sym_new] = ACTIONS(9197),
    [ts_builtin_sym_end] = ACTIONS(9199),
    [anon_sym_let] = ACTIONS(9197),
    [anon_sym_PLUS] = ACTIONS(9197),
    [anon_sym_export] = ACTIONS(9197),
    [anon_sym_do] = ACTIONS(9197),
    [anon_sym_TILDE] = ACTIONS(9199),
    [anon_sym_with] = ACTIONS(9197),
  },
  [4211] = {
    [sym_identifier] = ACTIONS(9201),
    [anon_sym_BQUOTE] = ACTIONS(9203),
    [anon_sym_debugger] = ACTIONS(9201),
    [anon_sym_symbol] = ACTIONS(9201),
    [anon_sym_AT] = ACTIONS(9203),
    [anon_sym_DASH] = ACTIONS(9201),
    [anon_sym_void] = ACTIONS(9201),
    [anon_sym_break] = ACTIONS(9201),
    [anon_sym_const] = ACTIONS(9201),
    [sym_super] = ACTIONS(9201),
    [anon_sym_return] = ACTIONS(9201),
    [anon_sym_private] = ACTIONS(9201),
    [anon_sym_get] = ACTIONS(9201),
    [anon_sym_RBRACE] = ACTIONS(9203),
    [anon_sym_interface] = ACTIONS(9201),
    [anon_sym_default] = ACTIONS(9201),
    [anon_sym_enum] = ACTIONS(9201),
    [anon_sym_delete] = ACTIONS(9201),
    [anon_sym_continue] = ACTIONS(9201),
    [anon_sym_DASH_DASH] = ACTIONS(9203),
    [anon_sym_if] = ACTIONS(9201),
    [anon_sym_this] = ACTIONS(9201),
    [anon_sym_yield] = ACTIONS(9201),
    [sym_true] = ACTIONS(9201),
    [anon_sym_throw] = ACTIONS(9201),
    [anon_sym_protected] = ACTIONS(9201),
    [anon_sym_abstract] = ACTIONS(9201),
    [anon_sym_set] = ACTIONS(9201),
    [anon_sym_type] = ACTIONS(9201),
    [anon_sym_import] = ACTIONS(9201),
    [anon_sym_namespace] = ACTIONS(9201),
    [anon_sym_PLUS_PLUS] = ACTIONS(9203),
    [anon_sym_await] = ACTIONS(9201),
    [anon_sym_DQUOTE] = ACTIONS(9203),
    [anon_sym_else] = ACTIONS(9201),
    [anon_sym_BANG] = ACTIONS(9203),
    [anon_sym_for] = ACTIONS(9201),
    [anon_sym_LBRACK] = ACTIONS(9203),
    [sym_false] = ACTIONS(9201),
    [anon_sym_SEMI] = ACTIONS(9203),
    [anon_sym_case] = ACTIONS(9201),
    [anon_sym_module] = ACTIONS(9201),
    [anon_sym_number] = ACTIONS(9201),
    [anon_sym_class] = ACTIONS(9201),
    [anon_sym_declare] = ACTIONS(9201),
    [anon_sym_typeof] = ACTIONS(9201),
    [anon_sym_LBRACE] = ACTIONS(9203),
    [anon_sym_switch] = ACTIONS(9201),
    [anon_sym_LPAREN] = ACTIONS(9203),
    [sym_null] = ACTIONS(9201),
    [anon_sym_any] = ACTIONS(9201),
    [anon_sym_boolean] = ACTIONS(9201),
    [anon_sym_async] = ACTIONS(9201),
    [anon_sym_public] = ACTIONS(9201),
    [anon_sym_var] = ACTIONS(9201),
    [anon_sym_while] = ACTIONS(9201),
    [anon_sym_SQUOTE] = ACTIONS(9203),
    [anon_sym_try] = ACTIONS(9201),
    [anon_sym_LT] = ACTIONS(9203),
    [sym_number] = ACTIONS(9203),
    [anon_sym_SLASH] = ACTIONS(9201),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9201),
    [anon_sym_function] = ACTIONS(9201),
    [sym_undefined] = ACTIONS(9201),
    [anon_sym_new] = ACTIONS(9201),
    [ts_builtin_sym_end] = ACTIONS(9203),
    [anon_sym_let] = ACTIONS(9201),
    [anon_sym_PLUS] = ACTIONS(9201),
    [anon_sym_export] = ACTIONS(9201),
    [anon_sym_do] = ACTIONS(9201),
    [anon_sym_TILDE] = ACTIONS(9203),
    [anon_sym_with] = ACTIONS(9201),
  },
  [4212] = {
    [sym_identifier] = ACTIONS(9205),
    [anon_sym_BQUOTE] = ACTIONS(9207),
    [anon_sym_debugger] = ACTIONS(9205),
    [anon_sym_symbol] = ACTIONS(9205),
    [anon_sym_AT] = ACTIONS(9207),
    [anon_sym_DASH] = ACTIONS(9205),
    [anon_sym_void] = ACTIONS(9205),
    [anon_sym_break] = ACTIONS(9205),
    [anon_sym_const] = ACTIONS(9205),
    [sym_super] = ACTIONS(9205),
    [anon_sym_return] = ACTIONS(9205),
    [anon_sym_private] = ACTIONS(9205),
    [anon_sym_get] = ACTIONS(9205),
    [anon_sym_RBRACE] = ACTIONS(9207),
    [anon_sym_interface] = ACTIONS(9205),
    [anon_sym_default] = ACTIONS(9205),
    [anon_sym_enum] = ACTIONS(9205),
    [anon_sym_delete] = ACTIONS(9205),
    [anon_sym_continue] = ACTIONS(9205),
    [anon_sym_DASH_DASH] = ACTIONS(9207),
    [anon_sym_if] = ACTIONS(9205),
    [anon_sym_this] = ACTIONS(9205),
    [anon_sym_yield] = ACTIONS(9205),
    [sym_true] = ACTIONS(9205),
    [anon_sym_throw] = ACTIONS(9205),
    [anon_sym_protected] = ACTIONS(9205),
    [anon_sym_abstract] = ACTIONS(9205),
    [anon_sym_set] = ACTIONS(9205),
    [anon_sym_type] = ACTIONS(9205),
    [anon_sym_import] = ACTIONS(9205),
    [anon_sym_namespace] = ACTIONS(9205),
    [anon_sym_PLUS_PLUS] = ACTIONS(9207),
    [anon_sym_await] = ACTIONS(9205),
    [anon_sym_DQUOTE] = ACTIONS(9207),
    [anon_sym_else] = ACTIONS(9205),
    [anon_sym_BANG] = ACTIONS(9207),
    [anon_sym_for] = ACTIONS(9205),
    [anon_sym_LBRACK] = ACTIONS(9207),
    [sym_false] = ACTIONS(9205),
    [anon_sym_SEMI] = ACTIONS(9207),
    [anon_sym_case] = ACTIONS(9205),
    [anon_sym_module] = ACTIONS(9205),
    [anon_sym_number] = ACTIONS(9205),
    [anon_sym_class] = ACTIONS(9205),
    [anon_sym_declare] = ACTIONS(9205),
    [anon_sym_typeof] = ACTIONS(9205),
    [anon_sym_LBRACE] = ACTIONS(9207),
    [anon_sym_switch] = ACTIONS(9205),
    [anon_sym_LPAREN] = ACTIONS(9207),
    [sym_null] = ACTIONS(9205),
    [anon_sym_any] = ACTIONS(9205),
    [anon_sym_boolean] = ACTIONS(9205),
    [anon_sym_async] = ACTIONS(9205),
    [anon_sym_public] = ACTIONS(9205),
    [anon_sym_var] = ACTIONS(9205),
    [anon_sym_while] = ACTIONS(9205),
    [anon_sym_SQUOTE] = ACTIONS(9207),
    [anon_sym_try] = ACTIONS(9205),
    [anon_sym_LT] = ACTIONS(9207),
    [sym_number] = ACTIONS(9207),
    [anon_sym_SLASH] = ACTIONS(9205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9205),
    [anon_sym_function] = ACTIONS(9205),
    [sym_undefined] = ACTIONS(9205),
    [anon_sym_new] = ACTIONS(9205),
    [ts_builtin_sym_end] = ACTIONS(9207),
    [anon_sym_let] = ACTIONS(9205),
    [anon_sym_PLUS] = ACTIONS(9205),
    [anon_sym_export] = ACTIONS(9205),
    [anon_sym_do] = ACTIONS(9205),
    [anon_sym_TILDE] = ACTIONS(9207),
    [anon_sym_with] = ACTIONS(9205),
  },
  [4213] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7695),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(5236),
    [anon_sym_PIPE] = ACTIONS(7697),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(7699),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6261),
    [anon_sym_LT_EQ] = ACTIONS(7695),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7695),
    [anon_sym_GT] = ACTIONS(6261),
    [anon_sym_AMP] = ACTIONS(7701),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(7703),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(7705),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(6261),
    [anon_sym_RPAREN] = ACTIONS(5236),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_instanceof] = ACTIONS(7695),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(7705),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7695),
    [anon_sym_in] = ACTIONS(6261),
  },
  [4214] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7695),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(5240),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(5240),
    [anon_sym_PIPE] = ACTIONS(7697),
    [anon_sym_COMMA] = ACTIONS(5240),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(7699),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6261),
    [anon_sym_LT_EQ] = ACTIONS(7695),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7695),
    [anon_sym_GT] = ACTIONS(6261),
    [anon_sym_AMP] = ACTIONS(7701),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(7703),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(7705),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(6261),
    [anon_sym_RPAREN] = ACTIONS(5240),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_instanceof] = ACTIONS(7695),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(7705),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7695),
    [anon_sym_in] = ACTIONS(6261),
  },
  [4215] = {
    [sym_new_expression] = STATE(4548),
    [sym_augmented_assignment_expression] = STATE(4548),
    [sym_unary_expression] = STATE(4548),
    [sym_update_expression] = STATE(4548),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(4548),
    [sym_regex] = STATE(4548),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4548),
    [sym_non_null_expression] = STATE(4548),
    [sym_as_expression] = STATE(4548),
    [sym_jsx_fragment] = STATE(4548),
    [sym_yield_expression] = STATE(4548),
    [sym_jsx_element] = STATE(4548),
    [sym_internal_module] = STATE(4548),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4548),
    [sym_await_expression] = STATE(4548),
    [sym_member_expression] = STATE(2134),
    [sym_string] = STATE(4548),
    [sym_this] = STATE(4548),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(4548),
    [sym_generator_function] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(4548),
    [sym_ternary_expression] = STATE(4548),
    [sym_binary_expression] = STATE(4548),
    [sym_template_string] = STATE(4548),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(4548),
    [sym_class] = STATE(4548),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(9209),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(9209),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(9211),
    [sym_true] = ACTIONS(9209),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(9209),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [4216] = {
    [sym_union_type] = STATE(4549),
    [sym__type] = STATE(4549),
    [sym_constructor_type] = STATE(4549),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(3696),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(4549),
    [sym_function_type] = STATE(4549),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(3697),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(7727),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(7733),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(7731),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(7735),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(7729),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [4217] = {
    [sym_formal_parameters] = STATE(4550),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4218] = {
    [anon_sym_EQ_GT] = ACTIONS(9213),
    [sym_comment] = ACTIONS(3),
  },
  [4219] = {
    [sym_union_type] = STATE(2678),
    [sym__type] = STATE(2678),
    [sym_constructor_type] = STATE(2678),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(3696),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(2678),
    [sym_function_type] = STATE(2678),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(3697),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(7727),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(7733),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(7731),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(7735),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(7729),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [4220] = {
    [sym_union_type] = STATE(2679),
    [sym__type] = STATE(2679),
    [sym_constructor_type] = STATE(2679),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(3696),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(2679),
    [sym_function_type] = STATE(2679),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(3697),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(7727),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(7733),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(7731),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(7735),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(7729),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [4221] = {
    [anon_sym_EQ_GT] = ACTIONS(9215),
    [sym_comment] = ACTIONS(3),
  },
  [4222] = {
    [sym_union_type] = STATE(4553),
    [sym__type] = STATE(4553),
    [sym_constructor_type] = STATE(4553),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(3696),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(4553),
    [sym_function_type] = STATE(4553),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(3697),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(7727),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(7733),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(7731),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(7735),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(7729),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [4223] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6255),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6255),
    [anon_sym_AMP_EQ] = ACTIONS(6255),
    [anon_sym_PLUS_EQ] = ACTIONS(6255),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_CARET_EQ] = ACTIONS(6255),
    [anon_sym_STAR_EQ] = ACTIONS(6255),
    [anon_sym_PIPE_EQ] = ACTIONS(6255),
    [anon_sym_DASH_EQ] = ACTIONS(6255),
    [anon_sym_EQ_GT] = ACTIONS(6259),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6255),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6255),
    [anon_sym_GT_GT_EQ] = ACTIONS(6255),
    [anon_sym_DOT] = ACTIONS(5665),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6255),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6261),
  },
  [4224] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_RPAREN] = ACTIONS(5236),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_in] = ACTIONS(6321),
  },
  [4225] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_RPAREN] = ACTIONS(5240),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_in] = ACTIONS(6321),
  },
  [4226] = {
    [sym_new_expression] = STATE(4554),
    [sym_augmented_assignment_expression] = STATE(4554),
    [sym_unary_expression] = STATE(4554),
    [sym_update_expression] = STATE(4554),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4554),
    [sym_regex] = STATE(4554),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4554),
    [sym_non_null_expression] = STATE(4554),
    [sym_as_expression] = STATE(4554),
    [sym_jsx_fragment] = STATE(4554),
    [sym_yield_expression] = STATE(4554),
    [sym_jsx_element] = STATE(4554),
    [sym_internal_module] = STATE(4554),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4554),
    [sym_await_expression] = STATE(4554),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4554),
    [sym_this] = STATE(4554),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4554),
    [sym_generator_function] = STATE(4554),
    [sym_call_expression] = STATE(4554),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4554),
    [sym_ternary_expression] = STATE(4554),
    [sym_binary_expression] = STATE(4554),
    [sym_template_string] = STATE(4554),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4554),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4554),
    [sym_class] = STATE(4554),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9217),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9217),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9219),
    [sym_true] = ACTIONS(9217),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9217),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4227] = {
    [sym_union_type] = STATE(4555),
    [sym__type] = STATE(4555),
    [sym_constructor_type] = STATE(4555),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3724),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4555),
    [sym_function_type] = STATE(4555),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3725),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(7804),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(7810),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(7808),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(7812),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(7806),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4228] = {
    [sym_formal_parameters] = STATE(4556),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4229] = {
    [anon_sym_EQ_GT] = ACTIONS(9221),
    [sym_comment] = ACTIONS(3),
  },
  [4230] = {
    [sym_union_type] = STATE(3067),
    [sym__type] = STATE(3067),
    [sym_constructor_type] = STATE(3067),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3724),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3067),
    [sym_function_type] = STATE(3067),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3725),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(7804),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(7810),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(7808),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(7812),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(7806),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4231] = {
    [sym_union_type] = STATE(3068),
    [sym__type] = STATE(3068),
    [sym_constructor_type] = STATE(3068),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3724),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3068),
    [sym_function_type] = STATE(3068),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3725),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(7804),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(7810),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(7808),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(7812),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(7806),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4232] = {
    [anon_sym_EQ_GT] = ACTIONS(9223),
    [sym_comment] = ACTIONS(3),
  },
  [4233] = {
    [sym_union_type] = STATE(4559),
    [sym__type] = STATE(4559),
    [sym_constructor_type] = STATE(4559),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3724),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4559),
    [sym_function_type] = STATE(4559),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3725),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(7804),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(7810),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(7808),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(7812),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(7806),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4234] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6315),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6315),
    [anon_sym_AMP_EQ] = ACTIONS(6315),
    [anon_sym_PLUS_EQ] = ACTIONS(6315),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_EQ] = ACTIONS(6317),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_CARET_EQ] = ACTIONS(6315),
    [anon_sym_STAR_EQ] = ACTIONS(6315),
    [anon_sym_PIPE_EQ] = ACTIONS(6315),
    [anon_sym_DASH_EQ] = ACTIONS(6315),
    [anon_sym_EQ_GT] = ACTIONS(6319),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6315),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(6315),
    [anon_sym_GT_GT_EQ] = ACTIONS(6315),
    [anon_sym_DOT] = ACTIONS(7050),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6315),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6321),
  },
  [4235] = {
    [sym_identifier] = ACTIONS(9225),
    [anon_sym_BQUOTE] = ACTIONS(9227),
    [anon_sym_debugger] = ACTIONS(9225),
    [anon_sym_symbol] = ACTIONS(9225),
    [anon_sym_AT] = ACTIONS(9227),
    [anon_sym_DASH] = ACTIONS(9225),
    [anon_sym_void] = ACTIONS(9225),
    [anon_sym_break] = ACTIONS(9225),
    [anon_sym_const] = ACTIONS(9225),
    [sym_super] = ACTIONS(9225),
    [anon_sym_return] = ACTIONS(9225),
    [anon_sym_private] = ACTIONS(9225),
    [anon_sym_get] = ACTIONS(9225),
    [anon_sym_RBRACE] = ACTIONS(9227),
    [anon_sym_interface] = ACTIONS(9225),
    [anon_sym_default] = ACTIONS(9225),
    [anon_sym_enum] = ACTIONS(9225),
    [anon_sym_delete] = ACTIONS(9225),
    [anon_sym_continue] = ACTIONS(9225),
    [anon_sym_DASH_DASH] = ACTIONS(9227),
    [anon_sym_if] = ACTIONS(9225),
    [anon_sym_this] = ACTIONS(9225),
    [anon_sym_yield] = ACTIONS(9225),
    [sym_true] = ACTIONS(9225),
    [anon_sym_throw] = ACTIONS(9225),
    [anon_sym_protected] = ACTIONS(9225),
    [anon_sym_abstract] = ACTIONS(9225),
    [anon_sym_set] = ACTIONS(9225),
    [anon_sym_type] = ACTIONS(9225),
    [anon_sym_import] = ACTIONS(9225),
    [anon_sym_namespace] = ACTIONS(9225),
    [anon_sym_PLUS_PLUS] = ACTIONS(9227),
    [anon_sym_await] = ACTIONS(9225),
    [anon_sym_DQUOTE] = ACTIONS(9227),
    [anon_sym_else] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_for] = ACTIONS(9225),
    [anon_sym_LBRACK] = ACTIONS(9227),
    [sym_false] = ACTIONS(9225),
    [anon_sym_SEMI] = ACTIONS(9227),
    [anon_sym_case] = ACTIONS(9225),
    [anon_sym_module] = ACTIONS(9225),
    [anon_sym_number] = ACTIONS(9225),
    [anon_sym_class] = ACTIONS(9225),
    [anon_sym_declare] = ACTIONS(9225),
    [anon_sym_typeof] = ACTIONS(9225),
    [anon_sym_LBRACE] = ACTIONS(9227),
    [anon_sym_switch] = ACTIONS(9225),
    [anon_sym_LPAREN] = ACTIONS(9227),
    [sym_null] = ACTIONS(9225),
    [anon_sym_any] = ACTIONS(9225),
    [anon_sym_boolean] = ACTIONS(9225),
    [anon_sym_async] = ACTIONS(9225),
    [anon_sym_public] = ACTIONS(9225),
    [anon_sym_var] = ACTIONS(9225),
    [anon_sym_while] = ACTIONS(9225),
    [anon_sym_SQUOTE] = ACTIONS(9227),
    [anon_sym_try] = ACTIONS(9225),
    [anon_sym_LT] = ACTIONS(9227),
    [sym_number] = ACTIONS(9227),
    [anon_sym_SLASH] = ACTIONS(9225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9225),
    [anon_sym_function] = ACTIONS(9225),
    [sym_undefined] = ACTIONS(9225),
    [anon_sym_new] = ACTIONS(9225),
    [ts_builtin_sym_end] = ACTIONS(9227),
    [anon_sym_let] = ACTIONS(9225),
    [anon_sym_PLUS] = ACTIONS(9225),
    [anon_sym_export] = ACTIONS(9225),
    [anon_sym_do] = ACTIONS(9225),
    [anon_sym_TILDE] = ACTIONS(9227),
    [anon_sym_with] = ACTIONS(9225),
  },
  [4236] = {
    [sym_identifier] = ACTIONS(9229),
    [anon_sym_BQUOTE] = ACTIONS(9231),
    [anon_sym_debugger] = ACTIONS(9229),
    [anon_sym_symbol] = ACTIONS(9229),
    [anon_sym_AT] = ACTIONS(9231),
    [anon_sym_DASH] = ACTIONS(9229),
    [anon_sym_void] = ACTIONS(9229),
    [anon_sym_break] = ACTIONS(9229),
    [anon_sym_const] = ACTIONS(9229),
    [sym_super] = ACTIONS(9229),
    [anon_sym_return] = ACTIONS(9229),
    [anon_sym_private] = ACTIONS(9229),
    [anon_sym_get] = ACTIONS(9229),
    [anon_sym_RBRACE] = ACTIONS(9231),
    [anon_sym_interface] = ACTIONS(9229),
    [anon_sym_default] = ACTIONS(9229),
    [anon_sym_enum] = ACTIONS(9229),
    [anon_sym_delete] = ACTIONS(9229),
    [anon_sym_continue] = ACTIONS(9229),
    [anon_sym_DASH_DASH] = ACTIONS(9231),
    [anon_sym_if] = ACTIONS(9229),
    [anon_sym_this] = ACTIONS(9229),
    [anon_sym_yield] = ACTIONS(9229),
    [sym_true] = ACTIONS(9229),
    [anon_sym_throw] = ACTIONS(9229),
    [anon_sym_protected] = ACTIONS(9229),
    [anon_sym_abstract] = ACTIONS(9229),
    [anon_sym_set] = ACTIONS(9229),
    [anon_sym_type] = ACTIONS(9229),
    [anon_sym_import] = ACTIONS(9229),
    [anon_sym_namespace] = ACTIONS(9229),
    [anon_sym_PLUS_PLUS] = ACTIONS(9231),
    [anon_sym_await] = ACTIONS(9229),
    [anon_sym_DQUOTE] = ACTIONS(9231),
    [anon_sym_else] = ACTIONS(9229),
    [anon_sym_BANG] = ACTIONS(9231),
    [anon_sym_for] = ACTIONS(9229),
    [anon_sym_LBRACK] = ACTIONS(9231),
    [sym_false] = ACTIONS(9229),
    [anon_sym_SEMI] = ACTIONS(9231),
    [anon_sym_case] = ACTIONS(9229),
    [anon_sym_module] = ACTIONS(9229),
    [anon_sym_number] = ACTIONS(9229),
    [anon_sym_class] = ACTIONS(9229),
    [anon_sym_declare] = ACTIONS(9229),
    [anon_sym_typeof] = ACTIONS(9229),
    [anon_sym_LBRACE] = ACTIONS(9231),
    [anon_sym_switch] = ACTIONS(9229),
    [anon_sym_LPAREN] = ACTIONS(9231),
    [sym_null] = ACTIONS(9229),
    [anon_sym_any] = ACTIONS(9229),
    [anon_sym_boolean] = ACTIONS(9229),
    [anon_sym_async] = ACTIONS(9229),
    [anon_sym_public] = ACTIONS(9229),
    [anon_sym_var] = ACTIONS(9229),
    [anon_sym_while] = ACTIONS(9229),
    [anon_sym_SQUOTE] = ACTIONS(9231),
    [anon_sym_try] = ACTIONS(9229),
    [anon_sym_LT] = ACTIONS(9231),
    [sym_number] = ACTIONS(9231),
    [anon_sym_SLASH] = ACTIONS(9229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9229),
    [anon_sym_function] = ACTIONS(9229),
    [sym_undefined] = ACTIONS(9229),
    [anon_sym_new] = ACTIONS(9229),
    [ts_builtin_sym_end] = ACTIONS(9231),
    [anon_sym_let] = ACTIONS(9229),
    [anon_sym_PLUS] = ACTIONS(9229),
    [anon_sym_export] = ACTIONS(9229),
    [anon_sym_do] = ACTIONS(9229),
    [anon_sym_TILDE] = ACTIONS(9231),
    [anon_sym_with] = ACTIONS(9229),
  },
  [4237] = {
    [sym_identifier] = ACTIONS(9233),
    [anon_sym_BQUOTE] = ACTIONS(9235),
    [anon_sym_debugger] = ACTIONS(9233),
    [anon_sym_symbol] = ACTIONS(9233),
    [anon_sym_AT] = ACTIONS(9235),
    [anon_sym_DASH] = ACTIONS(9233),
    [anon_sym_void] = ACTIONS(9233),
    [anon_sym_break] = ACTIONS(9233),
    [anon_sym_const] = ACTIONS(9233),
    [sym_super] = ACTIONS(9233),
    [anon_sym_return] = ACTIONS(9233),
    [anon_sym_private] = ACTIONS(9233),
    [anon_sym_get] = ACTIONS(9233),
    [anon_sym_RBRACE] = ACTIONS(9235),
    [anon_sym_interface] = ACTIONS(9233),
    [anon_sym_default] = ACTIONS(9233),
    [anon_sym_enum] = ACTIONS(9233),
    [anon_sym_delete] = ACTIONS(9233),
    [anon_sym_continue] = ACTIONS(9233),
    [anon_sym_DASH_DASH] = ACTIONS(9235),
    [anon_sym_if] = ACTIONS(9233),
    [anon_sym_this] = ACTIONS(9233),
    [anon_sym_yield] = ACTIONS(9233),
    [sym_true] = ACTIONS(9233),
    [anon_sym_throw] = ACTIONS(9233),
    [anon_sym_protected] = ACTIONS(9233),
    [anon_sym_abstract] = ACTIONS(9233),
    [anon_sym_set] = ACTIONS(9233),
    [anon_sym_type] = ACTIONS(9233),
    [anon_sym_import] = ACTIONS(9233),
    [anon_sym_namespace] = ACTIONS(9233),
    [anon_sym_PLUS_PLUS] = ACTIONS(9235),
    [anon_sym_await] = ACTIONS(9233),
    [anon_sym_DQUOTE] = ACTIONS(9235),
    [anon_sym_else] = ACTIONS(9233),
    [anon_sym_BANG] = ACTIONS(9235),
    [anon_sym_for] = ACTIONS(9233),
    [anon_sym_LBRACK] = ACTIONS(9235),
    [sym_false] = ACTIONS(9233),
    [anon_sym_SEMI] = ACTIONS(9235),
    [anon_sym_case] = ACTIONS(9233),
    [anon_sym_module] = ACTIONS(9233),
    [anon_sym_number] = ACTIONS(9233),
    [anon_sym_class] = ACTIONS(9233),
    [anon_sym_declare] = ACTIONS(9233),
    [anon_sym_typeof] = ACTIONS(9233),
    [anon_sym_LBRACE] = ACTIONS(9235),
    [anon_sym_switch] = ACTIONS(9233),
    [anon_sym_LPAREN] = ACTIONS(9235),
    [sym_null] = ACTIONS(9233),
    [anon_sym_any] = ACTIONS(9233),
    [anon_sym_boolean] = ACTIONS(9233),
    [anon_sym_async] = ACTIONS(9233),
    [anon_sym_public] = ACTIONS(9233),
    [anon_sym_var] = ACTIONS(9233),
    [anon_sym_while] = ACTIONS(9233),
    [anon_sym_SQUOTE] = ACTIONS(9235),
    [anon_sym_try] = ACTIONS(9233),
    [anon_sym_LT] = ACTIONS(9235),
    [sym_number] = ACTIONS(9235),
    [anon_sym_SLASH] = ACTIONS(9233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9233),
    [anon_sym_function] = ACTIONS(9233),
    [sym_undefined] = ACTIONS(9233),
    [anon_sym_new] = ACTIONS(9233),
    [ts_builtin_sym_end] = ACTIONS(9235),
    [anon_sym_let] = ACTIONS(9233),
    [anon_sym_PLUS] = ACTIONS(9233),
    [anon_sym_export] = ACTIONS(9233),
    [anon_sym_do] = ACTIONS(9233),
    [anon_sym_TILDE] = ACTIONS(9235),
    [anon_sym_with] = ACTIONS(9233),
  },
  [4238] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8499),
    [anon_sym_LBRACK] = ACTIONS(8499),
    [anon_sym_BANG] = ACTIONS(8497),
    [anon_sym_BQUOTE] = ACTIONS(8499),
    [anon_sym_PIPE] = ACTIONS(8497),
    [anon_sym_COMMA] = ACTIONS(8499),
    [anon_sym_LT_LT] = ACTIONS(8499),
    [anon_sym_STAR] = ACTIONS(8497),
    [anon_sym_GT_GT_GT] = ACTIONS(8499),
    [anon_sym_AMP_AMP] = ACTIONS(8499),
    [anon_sym_DASH] = ACTIONS(8497),
    [anon_sym_LBRACE] = ACTIONS(8497),
    [anon_sym_BANG_EQ] = ACTIONS(8497),
    [anon_sym_LT_EQ] = ACTIONS(8499),
    [anon_sym_LPAREN] = ACTIONS(8499),
    [anon_sym_RBRACK] = ACTIONS(8499),
    [anon_sym_GT_EQ] = ACTIONS(8499),
    [anon_sym_GT] = ACTIONS(8497),
    [anon_sym_AMP] = ACTIONS(8497),
    [anon_sym_PERCENT] = ACTIONS(8499),
    [anon_sym_QMARK] = ACTIONS(8499),
    [anon_sym_RBRACE] = ACTIONS(8499),
    [anon_sym_as] = ACTIONS(8499),
    [anon_sym_PIPE_PIPE] = ACTIONS(8499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(8499),
    [anon_sym_DASH_DASH] = ACTIONS(8499),
    [anon_sym_EQ_EQ] = ACTIONS(8497),
    [anon_sym_instanceof] = ACTIONS(8499),
    [anon_sym_LT] = ACTIONS(8497),
    [anon_sym_RPAREN] = ACTIONS(8499),
    [anon_sym_SLASH] = ACTIONS(8497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(8499),
    [anon_sym_DOT] = ACTIONS(8499),
    [anon_sym_CARET] = ACTIONS(8499),
    [anon_sym_STAR_STAR] = ACTIONS(8499),
    [anon_sym_PLUS] = ACTIONS(8497),
    [anon_sym_implements] = ACTIONS(8499),
    [anon_sym_GT_GT] = ACTIONS(8497),
    [anon_sym_PLUS_PLUS] = ACTIONS(8499),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8499),
    [anon_sym_in] = ACTIONS(8497),
  },
  [4239] = {
    [aux_sym_export_statement_repeat1] = STATE(1077),
    [sym__property_name] = STATE(1078),
    [sym_decorator] = STATE(1077),
    [sym_method_signature] = STATE(2866),
    [sym_accessibility_modifier] = STATE(1080),
    [sym_formal_parameters] = STATE(1081),
    [sym_computed_property_name] = STATE(1078),
    [sym_type_parameters] = STATE(1082),
    [sym_property_signature] = STATE(2866),
    [sym_call_signature] = STATE(2866),
    [sym_export_statement] = STATE(2866),
    [sym_string] = STATE(1078),
    [sym_construct_signature] = STATE(2866),
    [sym_index_signature] = STATE(2866),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_RBRACE] = ACTIONS(9237),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(472),
    [sym_number] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(2234),
    [sym_readonly] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9237),
    [anon_sym_DQUOTE] = ACTIONS(1159),
  },
  [4240] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(9071),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(7844),
    [anon_sym_COMMA] = ACTIONS(8547),
    [anon_sym_LT_LT] = ACTIONS(8547),
    [anon_sym_STAR] = ACTIONS(9071),
    [anon_sym_GT_GT_GT] = ACTIONS(8547),
    [anon_sym_AMP_AMP] = ACTIONS(8547),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_BANG_EQ] = ACTIONS(9071),
    [anon_sym_LT_EQ] = ACTIONS(8547),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [anon_sym_RBRACK] = ACTIONS(8547),
    [anon_sym_GT_EQ] = ACTIONS(8547),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_AMP] = ACTIONS(7846),
    [anon_sym_PERCENT] = ACTIONS(8547),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_as] = ACTIONS(8547),
    [anon_sym_PIPE_PIPE] = ACTIONS(8547),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_EQ_EQ] = ACTIONS(9071),
    [anon_sym_instanceof] = ACTIONS(8547),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8547),
    [anon_sym_CARET] = ACTIONS(8547),
    [anon_sym_STAR_STAR] = ACTIONS(8547),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_GT_GT] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8547),
    [anon_sym_in] = ACTIONS(9071),
  },
  [4241] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7521),
    [anon_sym_LBRACK] = ACTIONS(7521),
    [anon_sym_in] = ACTIONS(7523),
    [anon_sym_BQUOTE] = ACTIONS(7521),
    [anon_sym_PIPE] = ACTIONS(7523),
    [anon_sym_COMMA] = ACTIONS(7521),
    [anon_sym_DASH] = ACTIONS(7523),
    [anon_sym_STAR] = ACTIONS(7523),
    [anon_sym_LBRACE] = ACTIONS(7523),
    [anon_sym_GT_GT_GT] = ACTIONS(7521),
    [anon_sym_AMP_AMP] = ACTIONS(7521),
    [anon_sym_LT_LT] = ACTIONS(7521),
    [anon_sym_BANG_EQ] = ACTIONS(7523),
    [anon_sym_LT_EQ] = ACTIONS(7521),
    [anon_sym_LPAREN] = ACTIONS(7521),
    [anon_sym_RBRACK] = ACTIONS(7521),
    [anon_sym_GT_EQ] = ACTIONS(7521),
    [anon_sym_GT] = ACTIONS(7523),
    [anon_sym_AMP] = ACTIONS(7523),
    [anon_sym_PERCENT] = ACTIONS(7521),
    [anon_sym_QMARK] = ACTIONS(7521),
    [anon_sym_RBRACE] = ACTIONS(7521),
    [anon_sym_as] = ACTIONS(7521),
    [anon_sym_PIPE_PIPE] = ACTIONS(7521),
    [anon_sym_LBRACE_PIPE] = ACTIONS(7521),
    [anon_sym_DASH_DASH] = ACTIONS(7521),
    [anon_sym_EQ_EQ] = ACTIONS(7523),
    [anon_sym_instanceof] = ACTIONS(7521),
    [anon_sym_LT] = ACTIONS(7523),
    [anon_sym_RPAREN] = ACTIONS(7521),
    [anon_sym_SLASH] = ACTIONS(7523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7521),
    [anon_sym_DOT] = ACTIONS(7521),
    [anon_sym_CARET] = ACTIONS(7521),
    [anon_sym_STAR_STAR] = ACTIONS(7521),
    [anon_sym_PLUS] = ACTIONS(7523),
    [anon_sym_implements] = ACTIONS(7521),
    [anon_sym_GT_GT] = ACTIONS(7523),
    [anon_sym_PLUS_PLUS] = ACTIONS(7521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7521),
    [anon_sym_BANG] = ACTIONS(7523),
  },
  [4242] = {
    [sym_union_type] = STATE(4561),
    [sym__type] = STATE(4561),
    [sym_constructor_type] = STATE(4561),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2263),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4561),
    [sym_function_type] = STATE(4561),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2264),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(4743),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(4749),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(4747),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(4751),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(4745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4243] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_BANG] = ACTIONS(8379),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(8709),
    [anon_sym_COMMA] = ACTIONS(7511),
    [anon_sym_LT_LT] = ACTIONS(7511),
    [anon_sym_STAR] = ACTIONS(8379),
    [anon_sym_LBRACE] = ACTIONS(7511),
    [anon_sym_AMP_AMP] = ACTIONS(7511),
    [anon_sym_GT_GT_GT] = ACTIONS(7511),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_BANG_EQ] = ACTIONS(8379),
    [anon_sym_LT_EQ] = ACTIONS(7511),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [anon_sym_GT_EQ] = ACTIONS(7511),
    [anon_sym_GT] = ACTIONS(8379),
    [anon_sym_AMP] = ACTIONS(8711),
    [anon_sym_PERCENT] = ACTIONS(7511),
    [anon_sym_QMARK] = ACTIONS(7511),
    [anon_sym_as] = ACTIONS(7511),
    [anon_sym_PIPE_PIPE] = ACTIONS(7511),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_EQ_EQ] = ACTIONS(8379),
    [anon_sym_instanceof] = ACTIONS(7511),
    [anon_sym_LT] = ACTIONS(8379),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7511),
    [anon_sym_CARET] = ACTIONS(7511),
    [anon_sym_STAR_STAR] = ACTIONS(7511),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_implements] = ACTIONS(7511),
    [anon_sym_GT_GT] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7511),
    [anon_sym_in] = ACTIONS(8379),
  },
  [4244] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_BANG] = ACTIONS(8381),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(8709),
    [anon_sym_COMMA] = ACTIONS(7529),
    [anon_sym_LT_LT] = ACTIONS(7529),
    [anon_sym_STAR] = ACTIONS(8381),
    [anon_sym_LBRACE] = ACTIONS(7529),
    [anon_sym_AMP_AMP] = ACTIONS(7529),
    [anon_sym_GT_GT_GT] = ACTIONS(7529),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_BANG_EQ] = ACTIONS(8381),
    [anon_sym_LT_EQ] = ACTIONS(7529),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [anon_sym_GT_EQ] = ACTIONS(7529),
    [anon_sym_GT] = ACTIONS(8381),
    [anon_sym_AMP] = ACTIONS(8711),
    [anon_sym_PERCENT] = ACTIONS(7529),
    [anon_sym_QMARK] = ACTIONS(7529),
    [anon_sym_as] = ACTIONS(7529),
    [anon_sym_PIPE_PIPE] = ACTIONS(7529),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_EQ_EQ] = ACTIONS(8381),
    [anon_sym_instanceof] = ACTIONS(7529),
    [anon_sym_LT] = ACTIONS(8381),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7529),
    [anon_sym_CARET] = ACTIONS(7529),
    [anon_sym_STAR_STAR] = ACTIONS(7529),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_implements] = ACTIONS(7529),
    [anon_sym_GT_GT] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7529),
    [anon_sym_in] = ACTIONS(8381),
  },
  [4245] = {
    [sym_union_type] = STATE(4562),
    [sym__type] = STATE(4562),
    [sym_constructor_type] = STATE(4562),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2277),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4562),
    [sym_function_type] = STATE(4562),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2278),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1121),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(4771),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(4773),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(4775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4246] = {
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(6482),
    [anon_sym_PIPE] = ACTIONS(6484),
    [anon_sym_COMMA] = ACTIONS(7511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7511),
  },
  [4247] = {
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(6482),
    [anon_sym_PIPE] = ACTIONS(6484),
    [anon_sym_COMMA] = ACTIONS(7529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7529),
  },
  [4248] = {
    [sym__automatic_semicolon] = ACTIONS(9239),
    [anon_sym_RBRACE] = ACTIONS(9239),
    [anon_sym_SEMI] = ACTIONS(9239),
    [anon_sym_COMMA] = ACTIONS(9239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9239),
  },
  [4249] = {
    [sym__automatic_semicolon] = ACTIONS(9241),
    [anon_sym_RBRACE] = ACTIONS(9241),
    [anon_sym_SEMI] = ACTIONS(9241),
    [anon_sym_COMMA] = ACTIONS(9241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9241),
  },
  [4250] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(4839),
    [anon_sym_LT_LT] = ACTIONS(4841),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_GT_GT_GT] = ACTIONS(4841),
    [anon_sym_AMP_AMP] = ACTIONS(4847),
    [anon_sym_BANG_EQ] = ACTIONS(4795),
    [anon_sym_LT_EQ] = ACTIONS(4837),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_RBRACK] = ACTIONS(7181),
    [anon_sym_GT_EQ] = ACTIONS(4837),
    [anon_sym_GT] = ACTIONS(4795),
    [anon_sym_AMP] = ACTIONS(4851),
    [anon_sym_PERCENT] = ACTIONS(4841),
    [anon_sym_QMARK] = ACTIONS(4853),
    [anon_sym_as] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(4855),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(4795),
    [anon_sym_instanceof] = ACTIONS(4837),
    [anon_sym_LT] = ACTIONS(4859),
    [anon_sym_SLASH] = ACTIONS(4845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(4855),
    [anon_sym_STAR_STAR] = ACTIONS(4861),
    [anon_sym_PLUS] = ACTIONS(4843),
    [anon_sym_GT_GT] = ACTIONS(4845),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4837),
    [anon_sym_in] = ACTIONS(4795),
  },
  [4251] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(7192),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(9243),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_GT_GT_GT] = ACTIONS(5893),
    [anon_sym_AMP_AMP] = ACTIONS(5893),
    [anon_sym_BANG_EQ] = ACTIONS(7192),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [anon_sym_RBRACK] = ACTIONS(5893),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(9245),
    [anon_sym_PERCENT] = ACTIONS(5893),
    [anon_sym_QMARK] = ACTIONS(5893),
    [anon_sym_as] = ACTIONS(5893),
    [anon_sym_PIPE_PIPE] = ACTIONS(5893),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_EQ_EQ] = ACTIONS(7192),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5893),
    [anon_sym_CARET] = ACTIONS(5893),
    [anon_sym_STAR_STAR] = ACTIONS(5893),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_in] = ACTIONS(7192),
  },
  [4252] = {
    [anon_sym_EQ_GT] = ACTIONS(9247),
    [sym_comment] = ACTIONS(3),
  },
  [4253] = {
    [sym_union_type] = STATE(4564),
    [sym__type] = STATE(4564),
    [sym_constructor_type] = STATE(4564),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3121),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4564),
    [sym_function_type] = STATE(4564),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3122),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(6550),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(6556),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(6554),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(6558),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(6552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4254] = {
    [sym_union_type] = STATE(4565),
    [sym__type] = STATE(4565),
    [sym_constructor_type] = STATE(4565),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3121),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4565),
    [sym_function_type] = STATE(4565),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3122),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(6550),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(6556),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(6554),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(6558),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(6552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4255] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_BANG] = ACTIONS(7208),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(9243),
    [anon_sym_LT_LT] = ACTIONS(6040),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_STAR] = ACTIONS(7208),
    [anon_sym_GT_GT_GT] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(6040),
    [anon_sym_BANG_EQ] = ACTIONS(7208),
    [anon_sym_LT_EQ] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [anon_sym_RBRACK] = ACTIONS(6040),
    [anon_sym_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_AMP] = ACTIONS(9245),
    [anon_sym_PERCENT] = ACTIONS(6040),
    [anon_sym_QMARK] = ACTIONS(6040),
    [anon_sym_as] = ACTIONS(6040),
    [anon_sym_PIPE_PIPE] = ACTIONS(6040),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_instanceof] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6040),
    [anon_sym_CARET] = ACTIONS(6040),
    [anon_sym_STAR_STAR] = ACTIONS(6040),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6040),
    [anon_sym_in] = ACTIONS(7208),
  },
  [4256] = {
    [sym__automatic_semicolon] = ACTIONS(8767),
    [anon_sym_LBRACK] = ACTIONS(8767),
    [sym_identifier] = ACTIONS(9249),
    [anon_sym_SEMI] = ACTIONS(8767),
    [anon_sym_module] = ACTIONS(9249),
    [anon_sym_symbol] = ACTIONS(9249),
    [anon_sym_number] = ACTIONS(9249),
    [anon_sym_AT] = ACTIONS(8767),
    [anon_sym_declare] = ACTIONS(9249),
    [anon_sym_STAR] = ACTIONS(8767),
    [anon_sym_void] = ACTIONS(9249),
    [anon_sym_any] = ACTIONS(9249),
    [anon_sym_private] = ACTIONS(9249),
    [anon_sym_boolean] = ACTIONS(9249),
    [anon_sym_async] = ACTIONS(9249),
    [anon_sym_public] = ACTIONS(9249),
    [anon_sym_get] = ACTIONS(9249),
    [anon_sym_RBRACE] = ACTIONS(8767),
    [anon_sym_static] = ACTIONS(9249),
    [anon_sym_SQUOTE] = ACTIONS(8767),
    [sym_number] = ACTIONS(8767),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(9249),
    [anon_sym_string] = ACTIONS(9249),
    [anon_sym_abstract] = ACTIONS(9249),
    [anon_sym_set] = ACTIONS(9249),
    [anon_sym_type] = ACTIONS(9249),
    [anon_sym_import] = ACTIONS(9249),
    [anon_sym_export] = ACTIONS(9249),
    [anon_sym_namespace] = ACTIONS(9249),
    [sym_readonly] = ACTIONS(9249),
    [anon_sym_DQUOTE] = ACTIONS(8767),
  },
  [4257] = {
    [sym_statement_block] = STATE(4566),
    [sym__automatic_semicolon] = ACTIONS(9251),
    [anon_sym_SEMI] = ACTIONS(9251),
    [anon_sym_COMMA] = ACTIONS(9251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4899),
  },
  [4258] = {
    [sym_type_parameters] = STATE(1395),
    [sym_formal_parameters] = STATE(1397),
    [sym_call_signature] = STATE(4567),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4259] = {
    [sym__automatic_semicolon] = ACTIONS(9253),
    [anon_sym_SEMI] = ACTIONS(9253),
    [anon_sym_COMMA] = ACTIONS(9253),
    [sym_comment] = ACTIONS(3),
  },
  [4260] = {
    [sym_union_type] = STATE(4571),
    [sym__type] = STATE(4571),
    [sym_constructor_type] = STATE(4571),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4572),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4571),
    [sym_function_type] = STATE(4571),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4573),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(7911),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(7913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(9255),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(9257),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(9259),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4261] = {
    [sym_formal_parameters] = STATE(4574),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4262] = {
    [anon_sym_EQ_GT] = ACTIONS(9261),
    [sym_comment] = ACTIONS(3),
  },
  [4263] = {
    [sym_union_type] = STATE(2790),
    [sym__type] = STATE(2790),
    [sym_constructor_type] = STATE(2790),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3793),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2790),
    [sym_function_type] = STATE(2790),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3794),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(7911),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(7913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(7915),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(7917),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(7919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4264] = {
    [sym_union_type] = STATE(2791),
    [sym__type] = STATE(2791),
    [sym_constructor_type] = STATE(2791),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3793),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2791),
    [sym_function_type] = STATE(2791),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3794),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(7911),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(7913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(7915),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(7917),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(7919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4265] = {
    [anon_sym_EQ_GT] = ACTIONS(9263),
    [sym_comment] = ACTIONS(3),
  },
  [4266] = {
    [sym_union_type] = STATE(4577),
    [sym__type] = STATE(4577),
    [sym_constructor_type] = STATE(4577),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3793),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4577),
    [sym_function_type] = STATE(4577),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3794),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(7911),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(7913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(7915),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(7917),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(7919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4267] = {
    [sym_union_type] = STATE(1892),
    [sym__type] = STATE(1892),
    [sym_constructor_type] = STATE(1892),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4271),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1892),
    [sym_function_type] = STATE(1892),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4272),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(6598),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(6600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8743),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8745),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4268] = {
    [sym_type_parameters] = STATE(4578),
    [sym_formal_parameters] = STATE(4579),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4269] = {
    [sym_union_type] = STATE(1900),
    [sym__type] = STATE(1900),
    [sym_constructor_type] = STATE(1900),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4271),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1900),
    [sym_function_type] = STATE(1900),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4272),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(6598),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(6600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8743),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8745),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4270] = {
    [sym__automatic_semicolon] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(9265),
    [anon_sym_SEMI] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(9267),
    [anon_sym_COMMA] = ACTIONS(5893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5893),
  },
  [4271] = {
    [sym_formal_parameters] = STATE(4582),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4272] = {
    [anon_sym_EQ_GT] = ACTIONS(9269),
    [sym_comment] = ACTIONS(3),
  },
  [4273] = {
    [anon_sym_EQ_GT] = ACTIONS(9271),
    [sym_comment] = ACTIONS(3),
  },
  [4274] = {
    [sym_union_type] = STATE(4585),
    [sym__type] = STATE(4585),
    [sym_constructor_type] = STATE(4585),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3150),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4585),
    [sym_function_type] = STATE(4585),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3151),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(6598),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(6600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(6602),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(6604),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(6606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4275] = {
    [sym_union_type] = STATE(4586),
    [sym__type] = STATE(4586),
    [sym_constructor_type] = STATE(4586),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3150),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4586),
    [sym_function_type] = STATE(4586),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3151),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(6598),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(6600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(6602),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(6604),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(6606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4276] = {
    [sym__automatic_semicolon] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(7923),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(7925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6040),
  },
  [4277] = {
    [sym_type_parameters] = STATE(1395),
    [sym_formal_parameters] = STATE(1397),
    [sym_call_signature] = STATE(4567),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(9273),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [4278] = {
    [sym__initializer] = STATE(4588),
    [sym__automatic_semicolon] = ACTIONS(9253),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(9253),
    [anon_sym_COMMA] = ACTIONS(9253),
    [sym_comment] = ACTIONS(3),
  },
  [4279] = {
    [sym__automatic_semicolon] = ACTIONS(9275),
    [anon_sym_SEMI] = ACTIONS(9275),
    [anon_sym_COMMA] = ACTIONS(9275),
    [sym_comment] = ACTIONS(3),
  },
  [4280] = {
    [aux_sym_implements_clause_repeat1] = STATE(4591),
    [anon_sym_GT] = ACTIONS(9277),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_COMMA] = ACTIONS(9279),
    [sym_comment] = ACTIONS(3),
  },
  [4281] = {
    [sym_identifier] = ACTIONS(7192),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [anon_sym_debugger] = ACTIONS(7192),
    [anon_sym_symbol] = ACTIONS(7192),
    [anon_sym_AT] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(7950),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_void] = ACTIONS(7192),
    [anon_sym_break] = ACTIONS(7192),
    [anon_sym_const] = ACTIONS(7192),
    [sym_super] = ACTIONS(7192),
    [anon_sym_return] = ACTIONS(7192),
    [anon_sym_private] = ACTIONS(7192),
    [anon_sym_get] = ACTIONS(7192),
    [anon_sym_interface] = ACTIONS(7192),
    [anon_sym_enum] = ACTIONS(7192),
    [anon_sym_delete] = ACTIONS(7192),
    [anon_sym_continue] = ACTIONS(7192),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_if] = ACTIONS(7192),
    [anon_sym_this] = ACTIONS(7192),
    [anon_sym_yield] = ACTIONS(7192),
    [sym_true] = ACTIONS(7192),
    [anon_sym_throw] = ACTIONS(7192),
    [anon_sym_protected] = ACTIONS(7192),
    [anon_sym_abstract] = ACTIONS(7192),
    [anon_sym_set] = ACTIONS(7192),
    [anon_sym_type] = ACTIONS(7192),
    [anon_sym_import] = ACTIONS(7192),
    [anon_sym_namespace] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_await] = ACTIONS(7192),
    [anon_sym_DQUOTE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5893),
    [anon_sym_for] = ACTIONS(7192),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [sym_false] = ACTIONS(7192),
    [anon_sym_SEMI] = ACTIONS(5893),
    [anon_sym_module] = ACTIONS(7192),
    [anon_sym_number] = ACTIONS(7192),
    [anon_sym_class] = ACTIONS(7192),
    [anon_sym_declare] = ACTIONS(7192),
    [anon_sym_typeof] = ACTIONS(7192),
    [anon_sym_LBRACE] = ACTIONS(5893),
    [anon_sym_switch] = ACTIONS(7192),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [sym_null] = ACTIONS(7192),
    [anon_sym_any] = ACTIONS(7192),
    [anon_sym_boolean] = ACTIONS(7192),
    [anon_sym_async] = ACTIONS(7192),
    [anon_sym_public] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(7952),
    [anon_sym_var] = ACTIONS(7192),
    [anon_sym_while] = ACTIONS(7192),
    [anon_sym_SQUOTE] = ACTIONS(5893),
    [anon_sym_try] = ACTIONS(7192),
    [anon_sym_LT] = ACTIONS(5893),
    [sym_number] = ACTIONS(5893),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7192),
    [anon_sym_function] = ACTIONS(7192),
    [sym_undefined] = ACTIONS(7192),
    [anon_sym_new] = ACTIONS(7192),
    [ts_builtin_sym_end] = ACTIONS(5893),
    [anon_sym_let] = ACTIONS(7192),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_export] = ACTIONS(7192),
    [anon_sym_do] = ACTIONS(7192),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_with] = ACTIONS(7192),
  },
  [4282] = {
    [anon_sym_EQ_GT] = ACTIONS(9281),
    [sym_comment] = ACTIONS(3),
  },
  [4283] = {
    [sym_union_type] = STATE(4593),
    [sym__type] = STATE(4593),
    [sym_constructor_type] = STATE(4593),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(3167),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4593),
    [sym_function_type] = STATE(4593),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3168),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(6624),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(6626),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6628),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6630),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4284] = {
    [sym_union_type] = STATE(4594),
    [sym__type] = STATE(4594),
    [sym_constructor_type] = STATE(4594),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(3167),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4594),
    [sym_function_type] = STATE(4594),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3168),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(6624),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(6626),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6628),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6630),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4285] = {
    [sym_identifier] = ACTIONS(7208),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [anon_sym_debugger] = ACTIONS(7208),
    [anon_sym_symbol] = ACTIONS(7208),
    [anon_sym_AT] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(7950),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_void] = ACTIONS(7208),
    [anon_sym_break] = ACTIONS(7208),
    [anon_sym_const] = ACTIONS(7208),
    [sym_super] = ACTIONS(7208),
    [anon_sym_return] = ACTIONS(7208),
    [anon_sym_private] = ACTIONS(7208),
    [anon_sym_get] = ACTIONS(7208),
    [anon_sym_interface] = ACTIONS(7208),
    [anon_sym_enum] = ACTIONS(7208),
    [anon_sym_delete] = ACTIONS(7208),
    [anon_sym_continue] = ACTIONS(7208),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_if] = ACTIONS(7208),
    [anon_sym_this] = ACTIONS(7208),
    [anon_sym_yield] = ACTIONS(7208),
    [sym_true] = ACTIONS(7208),
    [anon_sym_throw] = ACTIONS(7208),
    [anon_sym_protected] = ACTIONS(7208),
    [anon_sym_abstract] = ACTIONS(7208),
    [anon_sym_set] = ACTIONS(7208),
    [anon_sym_type] = ACTIONS(7208),
    [anon_sym_import] = ACTIONS(7208),
    [anon_sym_namespace] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_await] = ACTIONS(7208),
    [anon_sym_DQUOTE] = ACTIONS(6040),
    [anon_sym_BANG] = ACTIONS(6040),
    [anon_sym_for] = ACTIONS(7208),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [sym_false] = ACTIONS(7208),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_module] = ACTIONS(7208),
    [anon_sym_number] = ACTIONS(7208),
    [anon_sym_class] = ACTIONS(7208),
    [anon_sym_declare] = ACTIONS(7208),
    [anon_sym_typeof] = ACTIONS(7208),
    [anon_sym_LBRACE] = ACTIONS(6040),
    [anon_sym_switch] = ACTIONS(7208),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [sym_null] = ACTIONS(7208),
    [anon_sym_any] = ACTIONS(7208),
    [anon_sym_boolean] = ACTIONS(7208),
    [anon_sym_async] = ACTIONS(7208),
    [anon_sym_public] = ACTIONS(7208),
    [anon_sym_AMP] = ACTIONS(7952),
    [anon_sym_var] = ACTIONS(7208),
    [anon_sym_while] = ACTIONS(7208),
    [anon_sym_SQUOTE] = ACTIONS(6040),
    [anon_sym_try] = ACTIONS(7208),
    [anon_sym_LT] = ACTIONS(6040),
    [sym_number] = ACTIONS(6040),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7208),
    [anon_sym_function] = ACTIONS(7208),
    [sym_undefined] = ACTIONS(7208),
    [anon_sym_new] = ACTIONS(7208),
    [ts_builtin_sym_end] = ACTIONS(6040),
    [anon_sym_let] = ACTIONS(7208),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_export] = ACTIONS(7208),
    [anon_sym_do] = ACTIONS(7208),
    [anon_sym_TILDE] = ACTIONS(6040),
    [anon_sym_with] = ACTIONS(7208),
  },
  [4286] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(7181),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(7181),
    [anon_sym_PIPE] = ACTIONS(5004),
    [anon_sym_COMMA] = ACTIONS(7181),
    [anon_sym_LT_LT] = ACTIONS(5006),
    [anon_sym_STAR] = ACTIONS(5008),
    [anon_sym_GT_GT_GT] = ACTIONS(5006),
    [anon_sym_AMP_AMP] = ACTIONS(5010),
    [anon_sym_DASH] = ACTIONS(5012),
    [anon_sym_BANG_EQ] = ACTIONS(4962),
    [anon_sym_LT_EQ] = ACTIONS(5002),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(5002),
    [anon_sym_GT] = ACTIONS(4962),
    [anon_sym_RBRACE] = ACTIONS(7181),
    [anon_sym_AMP] = ACTIONS(5014),
    [anon_sym_QMARK] = ACTIONS(5016),
    [anon_sym_PERCENT] = ACTIONS(5006),
    [anon_sym_as] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(5020),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(4962),
    [anon_sym_instanceof] = ACTIONS(5002),
    [anon_sym_LT] = ACTIONS(5022),
    [anon_sym_SLASH] = ACTIONS(5008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(5020),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(5012),
    [anon_sym_GT_GT] = ACTIONS(5008),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5002),
    [anon_sym_in] = ACTIONS(4962),
  },
  [4287] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(7192),
    [anon_sym_SEMI] = ACTIONS(5893),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [sym__automatic_semicolon] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(9283),
    [anon_sym_COMMA] = ACTIONS(5893),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_GT_GT_GT] = ACTIONS(5893),
    [anon_sym_AMP_AMP] = ACTIONS(5893),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_BANG_EQ] = ACTIONS(7192),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_RBRACE] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(9285),
    [anon_sym_QMARK] = ACTIONS(5893),
    [anon_sym_PERCENT] = ACTIONS(5893),
    [anon_sym_as] = ACTIONS(5893),
    [anon_sym_PIPE_PIPE] = ACTIONS(5893),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_EQ_EQ] = ACTIONS(7192),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5893),
    [anon_sym_CARET] = ACTIONS(5893),
    [anon_sym_STAR_STAR] = ACTIONS(5893),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_in] = ACTIONS(7192),
  },
  [4288] = {
    [anon_sym_EQ_GT] = ACTIONS(9287),
    [sym_comment] = ACTIONS(3),
  },
  [4289] = {
    [sym_union_type] = STATE(4596),
    [sym__type] = STATE(4596),
    [sym_constructor_type] = STATE(4596),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(3191),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(4596),
    [sym_function_type] = STATE(4596),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(3192),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(6681),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(6687),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(6685),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(6689),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(6683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [4290] = {
    [sym_union_type] = STATE(4597),
    [sym__type] = STATE(4597),
    [sym_constructor_type] = STATE(4597),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(3191),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(4597),
    [sym_function_type] = STATE(4597),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(3192),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(6681),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(6687),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(6685),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(6689),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(6683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [4291] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_BANG] = ACTIONS(7208),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [sym__automatic_semicolon] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(9283),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_LT_LT] = ACTIONS(6040),
    [anon_sym_STAR] = ACTIONS(7208),
    [anon_sym_GT_GT_GT] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(6040),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_BANG_EQ] = ACTIONS(7208),
    [anon_sym_LT_EQ] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [anon_sym_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_RBRACE] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(9285),
    [anon_sym_QMARK] = ACTIONS(6040),
    [anon_sym_PERCENT] = ACTIONS(6040),
    [anon_sym_as] = ACTIONS(6040),
    [anon_sym_PIPE_PIPE] = ACTIONS(6040),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_instanceof] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6040),
    [anon_sym_CARET] = ACTIONS(6040),
    [anon_sym_STAR_STAR] = ACTIONS(6040),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6040),
    [anon_sym_in] = ACTIONS(7208),
  },
  [4292] = {
    [anon_sym_COMMA] = ACTIONS(9289),
    [anon_sym_RBRACE] = ACTIONS(9289),
    [sym_comment] = ACTIONS(3),
  },
  [4293] = {
    [sym_statement_block] = STATE(4598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [4294] = {
    [anon_sym_of] = ACTIONS(9291),
    [sym_comment] = ACTIONS(3),
  },
  [4295] = {
    [anon_sym_of] = ACTIONS(9293),
    [sym_comment] = ACTIONS(3),
  },
  [4296] = {
    [anon_sym_of] = ACTIONS(9295),
    [sym_comment] = ACTIONS(3),
  },
  [4297] = {
    [sym_new_expression] = STATE(4602),
    [sym_augmented_assignment_expression] = STATE(4602),
    [sym_unary_expression] = STATE(4602),
    [sym_update_expression] = STATE(4602),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4602),
    [sym_regex] = STATE(4602),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4602),
    [sym_non_null_expression] = STATE(4602),
    [sym_as_expression] = STATE(4602),
    [sym_jsx_fragment] = STATE(4602),
    [sym_yield_expression] = STATE(4602),
    [sym_jsx_element] = STATE(4602),
    [sym_internal_module] = STATE(4602),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4602),
    [sym_await_expression] = STATE(4602),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4602),
    [sym_this] = STATE(4602),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4602),
    [sym_generator_function] = STATE(4602),
    [sym_call_expression] = STATE(4602),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4602),
    [sym_ternary_expression] = STATE(4602),
    [sym_binary_expression] = STATE(4602),
    [sym_template_string] = STATE(4602),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4602),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4602),
    [sym_class] = STATE(4602),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9297),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9297),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9299),
    [sym_true] = ACTIONS(9297),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9297),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4298] = {
    [sym_new_expression] = STATE(4603),
    [sym_augmented_assignment_expression] = STATE(4603),
    [sym_unary_expression] = STATE(4603),
    [sym_update_expression] = STATE(4603),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4603),
    [sym_regex] = STATE(4603),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4603),
    [sym_non_null_expression] = STATE(4603),
    [sym_as_expression] = STATE(4603),
    [sym_jsx_fragment] = STATE(4603),
    [sym_yield_expression] = STATE(4603),
    [sym_jsx_element] = STATE(4603),
    [sym_internal_module] = STATE(4603),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4603),
    [sym_await_expression] = STATE(4603),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4603),
    [sym_this] = STATE(4603),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4603),
    [sym_generator_function] = STATE(4603),
    [sym_call_expression] = STATE(4603),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4603),
    [sym_ternary_expression] = STATE(4603),
    [sym_binary_expression] = STATE(4603),
    [sym_template_string] = STATE(4603),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4603),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4603),
    [sym_class] = STATE(4603),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9301),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9301),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9303),
    [sym_true] = ACTIONS(9301),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9301),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4299] = {
    [sym_new_expression] = STATE(4604),
    [sym_augmented_assignment_expression] = STATE(4604),
    [sym_unary_expression] = STATE(4604),
    [sym_update_expression] = STATE(4604),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4604),
    [sym_regex] = STATE(4604),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4604),
    [sym_non_null_expression] = STATE(4604),
    [sym_as_expression] = STATE(4604),
    [sym_jsx_fragment] = STATE(4604),
    [sym_yield_expression] = STATE(4604),
    [sym_jsx_element] = STATE(4604),
    [sym_internal_module] = STATE(4604),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4604),
    [sym_await_expression] = STATE(4604),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4604),
    [sym_this] = STATE(4604),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4604),
    [sym_generator_function] = STATE(4604),
    [sym_call_expression] = STATE(4604),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4604),
    [sym_ternary_expression] = STATE(4604),
    [sym_binary_expression] = STATE(4604),
    [sym_template_string] = STATE(4604),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4604),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4604),
    [sym_class] = STATE(4604),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9305),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9305),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9307),
    [sym_true] = ACTIONS(9305),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9305),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4300] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(9309),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [4301] = {
    [anon_sym_RPAREN] = ACTIONS(9309),
    [sym_comment] = ACTIONS(3),
  },
  [4302] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9311),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4303] = {
    [sym_new_expression] = STATE(4607),
    [sym_augmented_assignment_expression] = STATE(4607),
    [sym_unary_expression] = STATE(4607),
    [sym_update_expression] = STATE(4607),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(4607),
    [sym_regex] = STATE(4607),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4607),
    [sym_non_null_expression] = STATE(4607),
    [sym_as_expression] = STATE(4607),
    [sym_jsx_fragment] = STATE(4607),
    [sym_yield_expression] = STATE(4607),
    [sym_jsx_element] = STATE(4607),
    [sym_internal_module] = STATE(4607),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4607),
    [sym_await_expression] = STATE(4607),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(4608),
    [sym_string] = STATE(4607),
    [sym_this] = STATE(4607),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(4607),
    [sym_generator_function] = STATE(4607),
    [sym_call_expression] = STATE(4607),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(4607),
    [sym_ternary_expression] = STATE(4607),
    [sym_binary_expression] = STATE(4607),
    [sym_template_string] = STATE(4607),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4607),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4607),
    [sym_class] = STATE(4607),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(9313),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9313),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9315),
    [sym_true] = ACTIONS(9313),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9313),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [4304] = {
    [sym_new_expression] = STATE(4609),
    [sym_augmented_assignment_expression] = STATE(4609),
    [sym_unary_expression] = STATE(4609),
    [sym_update_expression] = STATE(4609),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(4609),
    [sym_regex] = STATE(4609),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4609),
    [sym_non_null_expression] = STATE(4609),
    [sym_as_expression] = STATE(4609),
    [sym_jsx_fragment] = STATE(4609),
    [sym_yield_expression] = STATE(4609),
    [sym_jsx_element] = STATE(4609),
    [sym_internal_module] = STATE(4609),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4609),
    [sym_await_expression] = STATE(4609),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(4610),
    [sym_string] = STATE(4609),
    [sym_this] = STATE(4609),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(4609),
    [sym_generator_function] = STATE(4609),
    [sym_call_expression] = STATE(4609),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(4609),
    [sym_ternary_expression] = STATE(4609),
    [sym_binary_expression] = STATE(4609),
    [sym_template_string] = STATE(4609),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4609),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4609),
    [sym_class] = STATE(4609),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(9317),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9317),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9319),
    [sym_true] = ACTIONS(9317),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9317),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [4305] = {
    [sym_new_expression] = STATE(4611),
    [sym_augmented_assignment_expression] = STATE(4611),
    [sym_unary_expression] = STATE(4611),
    [sym_update_expression] = STATE(4611),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(4611),
    [sym_regex] = STATE(4611),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4611),
    [sym_non_null_expression] = STATE(4611),
    [sym_as_expression] = STATE(4611),
    [sym_jsx_fragment] = STATE(4611),
    [sym_yield_expression] = STATE(4611),
    [sym_jsx_element] = STATE(4611),
    [sym_internal_module] = STATE(4611),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4611),
    [sym_await_expression] = STATE(4611),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(4612),
    [sym_string] = STATE(4611),
    [sym_this] = STATE(4611),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(4611),
    [sym_generator_function] = STATE(4611),
    [sym_call_expression] = STATE(4611),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(4611),
    [sym_ternary_expression] = STATE(4611),
    [sym_binary_expression] = STATE(4611),
    [sym_template_string] = STATE(4611),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4611),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4611),
    [sym_class] = STATE(4611),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(9321),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9321),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9323),
    [sym_true] = ACTIONS(9321),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9321),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [4306] = {
    [sym_type_alias_declaration] = STATE(3041),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3041),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3041),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3041),
    [sym_return_statement] = STATE(3041),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3041),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3041),
    [sym_switch_statement] = STATE(3041),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3041),
    [sym_throw_statement] = STATE(3041),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3041),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3041),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(3041),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3041),
    [sym_abstract_class] = STATE(3041),
    [sym_interface_declaration] = STATE(3041),
    [sym_statement_block] = STATE(3041),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3041),
    [sym_debugger_statement] = STATE(3041),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3041),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3041),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3041),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3041),
    [sym_empty_statement] = STATE(3041),
    [sym_import_alias] = STATE(3041),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3041),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3041),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3041),
    [sym_break_statement] = STATE(3041),
    [sym_labeled_statement] = STATE(3041),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3041),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [4307] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(9325),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4308] = {
    [anon_sym_RPAREN] = ACTIONS(9325),
    [sym_comment] = ACTIONS(3),
  },
  [4309] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9327),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4310] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(9329),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [4311] = {
    [anon_sym_RPAREN] = ACTIONS(9329),
    [sym_comment] = ACTIONS(3),
  },
  [4312] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9331),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4313] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(9333),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [4314] = {
    [anon_sym_RPAREN] = ACTIONS(9333),
    [sym_comment] = ACTIONS(3),
  },
  [4315] = {
    [sym_union_type] = STATE(4623),
    [sym__type] = STATE(4623),
    [sym_constructor_type] = STATE(4623),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4624),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4623),
    [sym_function_type] = STATE(4623),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4625),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9335),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9339),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9341),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4316] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9345),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4317] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9347),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4318] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9349),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4319] = {
    [sym_type_alias_declaration] = STATE(4210),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4210),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4210),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4210),
    [sym_return_statement] = STATE(4210),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4210),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4210),
    [sym_switch_statement] = STATE(4210),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4210),
    [sym_throw_statement] = STATE(4210),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4210),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4210),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(4210),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4210),
    [sym_abstract_class] = STATE(4210),
    [sym_interface_declaration] = STATE(4210),
    [sym_statement_block] = STATE(4210),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4210),
    [sym_debugger_statement] = STATE(4210),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4210),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4210),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4210),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4210),
    [sym_empty_statement] = STATE(4210),
    [sym_import_alias] = STATE(4210),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4210),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4210),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4210),
    [sym_break_statement] = STATE(4210),
    [sym_labeled_statement] = STATE(4210),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4210),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [4320] = {
    [sym_type_alias_declaration] = STATE(4211),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4211),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4211),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4211),
    [sym_return_statement] = STATE(4211),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4211),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4211),
    [sym_switch_statement] = STATE(4211),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4211),
    [sym_throw_statement] = STATE(4211),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4211),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4211),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(4211),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4211),
    [sym_abstract_class] = STATE(4211),
    [sym_interface_declaration] = STATE(4211),
    [sym_statement_block] = STATE(4211),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4211),
    [sym_debugger_statement] = STATE(4211),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4211),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4211),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4211),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4211),
    [sym_empty_statement] = STATE(4211),
    [sym_import_alias] = STATE(4211),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4211),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4211),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4211),
    [sym_break_statement] = STATE(4211),
    [sym_labeled_statement] = STATE(4211),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4211),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [4321] = {
    [sym_type_alias_declaration] = STATE(4212),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4212),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4212),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4212),
    [sym_return_statement] = STATE(4212),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4212),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4212),
    [sym_switch_statement] = STATE(4212),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4212),
    [sym_throw_statement] = STATE(4212),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4212),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4212),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(4212),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4212),
    [sym_abstract_class] = STATE(4212),
    [sym_interface_declaration] = STATE(4212),
    [sym_statement_block] = STATE(4212),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4212),
    [sym_debugger_statement] = STATE(4212),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4212),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4212),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4212),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4212),
    [sym_empty_statement] = STATE(4212),
    [sym_import_alias] = STATE(4212),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4212),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4212),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4212),
    [sym_break_statement] = STATE(4212),
    [sym_labeled_statement] = STATE(4212),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4212),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [4322] = {
    [sym_type_alias_declaration] = STATE(4235),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4235),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4235),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4235),
    [sym_return_statement] = STATE(4235),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4235),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4235),
    [sym_switch_statement] = STATE(4235),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4235),
    [sym_throw_statement] = STATE(4235),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4235),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4235),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(4235),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4235),
    [sym_abstract_class] = STATE(4235),
    [sym_interface_declaration] = STATE(4235),
    [sym_statement_block] = STATE(4235),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4235),
    [sym_debugger_statement] = STATE(4235),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4235),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4235),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4235),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4235),
    [sym_empty_statement] = STATE(4235),
    [sym_import_alias] = STATE(4235),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4235),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4235),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4235),
    [sym_break_statement] = STATE(4235),
    [sym_labeled_statement] = STATE(4235),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4235),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [4323] = {
    [sym_type_alias_declaration] = STATE(4236),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4236),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4236),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4236),
    [sym_return_statement] = STATE(4236),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4236),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4236),
    [sym_switch_statement] = STATE(4236),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4236),
    [sym_throw_statement] = STATE(4236),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4236),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4236),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(4236),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4236),
    [sym_abstract_class] = STATE(4236),
    [sym_interface_declaration] = STATE(4236),
    [sym_statement_block] = STATE(4236),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4236),
    [sym_debugger_statement] = STATE(4236),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4236),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4236),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4236),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4236),
    [sym_empty_statement] = STATE(4236),
    [sym_import_alias] = STATE(4236),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4236),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4236),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4236),
    [sym_break_statement] = STATE(4236),
    [sym_labeled_statement] = STATE(4236),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4236),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [4324] = {
    [sym_type_alias_declaration] = STATE(4237),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4237),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4237),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4237),
    [sym_return_statement] = STATE(4237),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4237),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4237),
    [sym_switch_statement] = STATE(4237),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4237),
    [sym_throw_statement] = STATE(4237),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4237),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4237),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(4237),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4237),
    [sym_abstract_class] = STATE(4237),
    [sym_interface_declaration] = STATE(4237),
    [sym_statement_block] = STATE(4237),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4237),
    [sym_debugger_statement] = STATE(4237),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4237),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4237),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4237),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4237),
    [sym_empty_statement] = STATE(4237),
    [sym_import_alias] = STATE(4237),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4237),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4237),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4237),
    [sym_break_statement] = STATE(4237),
    [sym_labeled_statement] = STATE(4237),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4237),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [4325] = {
    [sym_union_type] = STATE(4629),
    [sym__type] = STATE(4629),
    [sym_constructor_type] = STATE(4629),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(3873),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4629),
    [sym_function_type] = STATE(4629),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3874),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8050),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8052),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8054),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8056),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4326] = {
    [sym_formal_parameters] = STATE(4630),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4327] = {
    [anon_sym_EQ_GT] = ACTIONS(9351),
    [sym_comment] = ACTIONS(3),
  },
  [4328] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(3873),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3874),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8050),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8052),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8054),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8056),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4329] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(3873),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3874),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8050),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8052),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8054),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8056),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4330] = {
    [anon_sym_EQ_GT] = ACTIONS(9353),
    [sym_comment] = ACTIONS(3),
  },
  [4331] = {
    [sym_union_type] = STATE(4633),
    [sym__type] = STATE(4633),
    [sym_constructor_type] = STATE(4633),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(3873),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4633),
    [sym_function_type] = STATE(4633),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3874),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8050),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8052),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8054),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8056),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4332] = {
    [sym_type_parameters] = STATE(273),
    [sym_formal_parameters] = STATE(274),
    [sym_call_signature] = STATE(4634),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4333] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6825),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6827),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_LT_LT] = ACTIONS(6831),
    [anon_sym_STAR] = ACTIONS(6837),
    [anon_sym_GT_GT_GT] = ACTIONS(6831),
    [anon_sym_AMP_AMP] = ACTIONS(6835),
    [anon_sym_DASH] = ACTIONS(6833),
    [anon_sym_BANG_EQ] = ACTIONS(6785),
    [anon_sym_LT_EQ] = ACTIONS(6825),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6825),
    [anon_sym_GT] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6839),
    [anon_sym_PERCENT] = ACTIONS(6831),
    [anon_sym_QMARK] = ACTIONS(6841),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_PIPE_PIPE] = ACTIONS(6843),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6785),
    [anon_sym_instanceof] = ACTIONS(6825),
    [anon_sym_LT] = ACTIONS(6847),
    [anon_sym_SLASH] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5236),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6843),
    [anon_sym_STAR_STAR] = ACTIONS(6851),
    [anon_sym_PLUS] = ACTIONS(6833),
    [anon_sym_GT_GT] = ACTIONS(6837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6825),
    [anon_sym_in] = ACTIONS(6785),
  },
  [4334] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6825),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6827),
    [anon_sym_COMMA] = ACTIONS(5240),
    [anon_sym_LT_LT] = ACTIONS(6831),
    [anon_sym_STAR] = ACTIONS(6837),
    [anon_sym_GT_GT_GT] = ACTIONS(6831),
    [anon_sym_AMP_AMP] = ACTIONS(6835),
    [anon_sym_DASH] = ACTIONS(6833),
    [anon_sym_BANG_EQ] = ACTIONS(6785),
    [anon_sym_LT_EQ] = ACTIONS(6825),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6825),
    [anon_sym_GT] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6839),
    [anon_sym_PERCENT] = ACTIONS(6831),
    [anon_sym_QMARK] = ACTIONS(6841),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_PIPE_PIPE] = ACTIONS(6843),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6785),
    [anon_sym_instanceof] = ACTIONS(6825),
    [anon_sym_LT] = ACTIONS(6847),
    [anon_sym_SLASH] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5240),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6843),
    [anon_sym_STAR_STAR] = ACTIONS(6851),
    [anon_sym_PLUS] = ACTIONS(6833),
    [anon_sym_GT_GT] = ACTIONS(6837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6825),
    [anon_sym_in] = ACTIONS(6785),
  },
  [4335] = {
    [sym_new_expression] = STATE(4635),
    [sym_augmented_assignment_expression] = STATE(4635),
    [sym_unary_expression] = STATE(4635),
    [sym_update_expression] = STATE(4635),
    [sym_call_signature] = STATE(2429),
    [sym_meta_property] = STATE(4635),
    [sym_regex] = STATE(4635),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4635),
    [sym_non_null_expression] = STATE(4635),
    [sym_as_expression] = STATE(4635),
    [sym_jsx_fragment] = STATE(4635),
    [sym_yield_expression] = STATE(4635),
    [sym_jsx_element] = STATE(4635),
    [sym_internal_module] = STATE(4635),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4635),
    [sym_await_expression] = STATE(4635),
    [sym_member_expression] = STATE(2431),
    [sym_string] = STATE(4635),
    [sym_this] = STATE(4635),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2433),
    [sym_anonymous_class] = STATE(4635),
    [sym_generator_function] = STATE(4635),
    [sym_call_expression] = STATE(4635),
    [sym_subscript_expression] = STATE(2431),
    [sym_assignment_expression] = STATE(4635),
    [sym_ternary_expression] = STATE(4635),
    [sym_binary_expression] = STATE(4635),
    [sym_template_string] = STATE(4635),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4635),
    [sym_array] = STATE(2434),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4635),
    [sym_class] = STATE(4635),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_identifier] = ACTIONS(5106),
    [sym_false] = ACTIONS(9355),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5110),
    [anon_sym_symbol] = ACTIONS(5110),
    [anon_sym_number] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(5110),
    [anon_sym_typeof] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(5116),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9355),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_boolean] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_delete] = ACTIONS(5112),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(5120),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9357),
    [sym_true] = ACTIONS(9355),
    [anon_sym_yield] = ACTIONS(5124),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_string] = ACTIONS(5110),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9355),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_type] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_import] = ACTIONS(5110),
    [anon_sym_export] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5128),
    [anon_sym_PLUS] = ACTIONS(5114),
    [anon_sym_await] = ACTIONS(5130),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_PLUS_PLUS] = ACTIONS(5120),
  },
  [4336] = {
    [sym_union_type] = STATE(4636),
    [sym__type] = STATE(4636),
    [sym_constructor_type] = STATE(4636),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3895),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4636),
    [sym_function_type] = STATE(4636),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3896),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(8117),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(8123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(8121),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(8125),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(8119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4337] = {
    [sym_formal_parameters] = STATE(4637),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4338] = {
    [anon_sym_EQ_GT] = ACTIONS(9359),
    [sym_comment] = ACTIONS(3),
  },
  [4339] = {
    [sym_union_type] = STATE(3067),
    [sym__type] = STATE(3067),
    [sym_constructor_type] = STATE(3067),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3895),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3067),
    [sym_function_type] = STATE(3067),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3896),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(8117),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(8123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(8121),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(8125),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(8119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4340] = {
    [sym_union_type] = STATE(3068),
    [sym__type] = STATE(3068),
    [sym_constructor_type] = STATE(3068),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3895),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(3068),
    [sym_function_type] = STATE(3068),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3896),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(8117),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(8123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(8121),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(8125),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(8119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4341] = {
    [anon_sym_EQ_GT] = ACTIONS(9361),
    [sym_comment] = ACTIONS(3),
  },
  [4342] = {
    [sym_union_type] = STATE(4640),
    [sym__type] = STATE(4640),
    [sym_constructor_type] = STATE(4640),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3895),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4640),
    [sym_function_type] = STATE(4640),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3896),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(8117),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(8123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(8121),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(8125),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(8119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4343] = {
    [sym__initializer] = STATE(522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4177),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(6779),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6779),
    [anon_sym_AMP_EQ] = ACTIONS(6779),
    [anon_sym_PLUS_EQ] = ACTIONS(6779),
    [anon_sym_PIPE] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4177),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(6781),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(4175),
    [anon_sym_CARET_EQ] = ACTIONS(6779),
    [anon_sym_STAR_EQ] = ACTIONS(6779),
    [anon_sym_PIPE_EQ] = ACTIONS(6779),
    [anon_sym_DASH_EQ] = ACTIONS(6779),
    [anon_sym_EQ_GT] = ACTIONS(6783),
    [anon_sym_AMP] = ACTIONS(4175),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(6779),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_SLASH_EQ] = ACTIONS(6779),
    [anon_sym_GT_GT_EQ] = ACTIONS(6779),
    [anon_sym_DOT] = ACTIONS(6439),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6779),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(6785),
  },
  [4344] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(9363),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [4345] = {
    [sym_parenthesized_expression] = STATE(4642),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [4346] = {
    [anon_sym_await] = ACTIONS(9365),
    [anon_sym_LPAREN] = ACTIONS(9367),
    [sym_comment] = ACTIONS(3),
  },
  [4347] = {
    [sym_type_alias_declaration] = STATE(193),
    [aux_sym_export_statement_repeat1] = STATE(4648),
    [sym__declaration] = STATE(193),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(193),
    [sym_import_alias] = STATE(193),
    [sym_export_statement] = STATE(193),
    [sym_generator_function] = STATE(193),
    [sym_lexical_declaration] = STATE(193),
    [sym_internal_module] = STATE(193),
    [sym_decorator] = STATE(4648),
    [sym_enum_declaration] = STATE(193),
    [sym_function] = STATE(193),
    [sym_function_signature] = STATE(193),
    [sym_variable_declaration] = STATE(193),
    [sym_abstract_class] = STATE(193),
    [sym_module] = STATE(193),
    [sym_interface_declaration] = STATE(193),
    [sym_class] = STATE(193),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(324),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(137),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(9369),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_declare] = ACTIONS(9371),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(9373),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [4348] = {
    [sym_parenthesized_expression] = STATE(4649),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [4349] = {
    [sym_type_alias_declaration] = STATE(300),
    [aux_sym_export_statement_repeat1] = STATE(4648),
    [sym__declaration] = STATE(300),
    [sym__initializer] = STATE(79),
    [sym_ambient_declaration] = STATE(300),
    [sym_import_alias] = STATE(300),
    [sym_export_statement] = STATE(300),
    [sym_generator_function] = STATE(300),
    [sym_export_clause] = STATE(301),
    [sym_lexical_declaration] = STATE(300),
    [sym_internal_module] = STATE(300),
    [sym_decorator] = STATE(4648),
    [sym_enum_declaration] = STATE(300),
    [sym_function] = STATE(300),
    [sym_function_signature] = STATE(300),
    [sym_variable_declaration] = STATE(300),
    [sym_abstract_class] = STATE(300),
    [sym_module] = STATE(300),
    [sym_interface_declaration] = STATE(300),
    [sym_class] = STATE(300),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(139),
    [anon_sym_AMP_EQ] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(508),
    [anon_sym_GT_GT_GT] = ACTIONS(137),
    [anon_sym_EQ] = ACTIONS(511),
    [anon_sym_BANG_EQ] = ACTIONS(137),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(139),
    [anon_sym_DASH_EQ] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(137),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_as] = ACTIONS(515),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_LT_LT_EQ] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_STAR_STAR] = ACTIONS(137),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(139),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_declare] = ACTIONS(9371),
    [anon_sym_LT_LT] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_STAR_EQ] = ACTIONS(139),
    [anon_sym_async] = ACTIONS(346),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(137),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(137),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_SLASH] = ACTIONS(137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(139),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_CARET] = ACTIONS(137),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_PLUS] = ACTIONS(137),
    [anon_sym_export] = ACTIONS(9373),
    [anon_sym_GT_GT] = ACTIONS(137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(137),
  },
  [4350] = {
    [sym_parenthesized_expression] = STATE(4650),
    [anon_sym_LPAREN] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
  },
  [4351] = {
    [sym_identifier] = ACTIONS(2455),
    [anon_sym_BQUOTE] = ACTIONS(2457),
    [anon_sym_debugger] = ACTIONS(2455),
    [anon_sym_symbol] = ACTIONS(2455),
    [anon_sym_AT] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2455),
    [anon_sym_void] = ACTIONS(2455),
    [anon_sym_break] = ACTIONS(2455),
    [anon_sym_const] = ACTIONS(2455),
    [sym_super] = ACTIONS(2455),
    [anon_sym_return] = ACTIONS(2455),
    [anon_sym_private] = ACTIONS(2455),
    [anon_sym_get] = ACTIONS(2455),
    [anon_sym_RBRACE] = ACTIONS(2457),
    [anon_sym_default] = ACTIONS(2455),
    [anon_sym_interface] = ACTIONS(2455),
    [anon_sym_enum] = ACTIONS(2455),
    [anon_sym_delete] = ACTIONS(2455),
    [anon_sym_continue] = ACTIONS(2455),
    [anon_sym_DASH_DASH] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2455),
    [anon_sym_this] = ACTIONS(2455),
    [anon_sym_yield] = ACTIONS(2455),
    [sym_true] = ACTIONS(2455),
    [anon_sym_throw] = ACTIONS(2455),
    [anon_sym_protected] = ACTIONS(2455),
    [anon_sym_abstract] = ACTIONS(2455),
    [anon_sym_set] = ACTIONS(2455),
    [anon_sym_type] = ACTIONS(2455),
    [anon_sym_import] = ACTIONS(2455),
    [anon_sym_namespace] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2457),
    [anon_sym_await] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [anon_sym_else] = ACTIONS(9375),
    [anon_sym_BANG] = ACTIONS(2457),
    [anon_sym_for] = ACTIONS(2455),
    [anon_sym_LBRACK] = ACTIONS(2457),
    [sym_false] = ACTIONS(2455),
    [anon_sym_SEMI] = ACTIONS(2457),
    [anon_sym_case] = ACTIONS(2455),
    [anon_sym_module] = ACTIONS(2455),
    [anon_sym_number] = ACTIONS(2455),
    [anon_sym_class] = ACTIONS(2455),
    [anon_sym_declare] = ACTIONS(2455),
    [anon_sym_typeof] = ACTIONS(2455),
    [anon_sym_LBRACE] = ACTIONS(2457),
    [anon_sym_switch] = ACTIONS(2455),
    [anon_sym_LPAREN] = ACTIONS(2457),
    [sym_null] = ACTIONS(2455),
    [anon_sym_any] = ACTIONS(2455),
    [anon_sym_boolean] = ACTIONS(2455),
    [anon_sym_async] = ACTIONS(2455),
    [anon_sym_public] = ACTIONS(2455),
    [anon_sym_var] = ACTIONS(2455),
    [anon_sym_while] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_try] = ACTIONS(2455),
    [anon_sym_LT] = ACTIONS(2457),
    [sym_number] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2455),
    [anon_sym_function] = ACTIONS(2455),
    [sym_undefined] = ACTIONS(2455),
    [anon_sym_new] = ACTIONS(2455),
    [anon_sym_let] = ACTIONS(2455),
    [anon_sym_PLUS] = ACTIONS(2455),
    [anon_sym_export] = ACTIONS(2455),
    [anon_sym_do] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2457),
    [anon_sym_with] = ACTIONS(2455),
  },
  [4352] = {
    [aux_sym_export_statement_repeat1] = STATE(320),
    [sym_decorator] = STATE(320),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(9377),
    [anon_sym_class] = ACTIONS(546),
    [sym_comment] = ACTIONS(3),
  },
  [4353] = {
    [sym_array] = STATE(4655),
    [sym_object] = STATE(4656),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(9379),
    [anon_sym_var] = ACTIONS(9381),
    [anon_sym_const] = ACTIONS(9381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_let] = ACTIONS(9381),
  },
  [4354] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(9383),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(9385),
  },
  [4355] = {
    [sym_variable_declarator] = STATE(97),
    [sym_array] = STATE(4660),
    [sym_object] = STATE(4661),
    [sym_identifier] = ACTIONS(9387),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [4356] = {
    [sym_variable_declarator] = STATE(258),
    [sym_array] = STATE(4660),
    [sym_object] = STATE(4661),
    [sym_identifier] = ACTIONS(9387),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [4357] = {
    [sym_new_expression] = STATE(59),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_yield_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_internal_module] = STATE(59),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(59),
    [sym_await_expression] = STATE(59),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4662),
    [sym_sequence_expression] = STATE(62),
    [sym_string] = STATE(59),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(4662),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(59),
    [sym_generator_function] = STATE(59),
    [sym_call_expression] = STATE(59),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(59),
    [sym_ternary_expression] = STATE(59),
    [sym_binary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(59),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [4358] = {
    [sym__initializer] = STATE(321),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(9389),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(9391),
  },
  [4359] = {
    [sym__initializer] = STATE(336),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(9393),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(9395),
  },
  [4360] = {
    [sym_identifier] = ACTIONS(9397),
    [sym_comment] = ACTIONS(3),
  },
  [4361] = {
    [anon_sym_EQ_GT] = ACTIONS(9399),
    [sym_comment] = ACTIONS(3),
  },
  [4362] = {
    [sym_union_type] = STATE(4669),
    [sym__type] = STATE(4669),
    [sym_constructor_type] = STATE(4669),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3280),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4669),
    [sym_function_type] = STATE(4669),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3281),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3109),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6885),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6887),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4363] = {
    [sym_union_type] = STATE(4670),
    [sym__type] = STATE(4670),
    [sym_constructor_type] = STATE(4670),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3280),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4670),
    [sym_function_type] = STATE(4670),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3281),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3109),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6885),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6887),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4364] = {
    [anon_sym_EQ] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_RPAREN] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(8165),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(8167),
    [sym_comment] = ACTIONS(3),
  },
  [4365] = {
    [anon_sym_EQ] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(5144),
    [anon_sym_RPAREN] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(5146),
    [anon_sym_COMMA] = ACTIONS(8547),
    [sym_comment] = ACTIONS(3),
  },
  [4366] = {
    [sym_formal_parameters] = STATE(4671),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4367] = {
    [anon_sym_EQ_GT] = ACTIONS(9401),
    [sym_comment] = ACTIONS(3),
  },
  [4368] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3930),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3931),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(5168),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8181),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8183),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4369] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3930),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3931),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(5168),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8181),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8183),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4370] = {
    [anon_sym_EQ_GT] = ACTIONS(9403),
    [sym_comment] = ACTIONS(3),
  },
  [4371] = {
    [sym_union_type] = STATE(4674),
    [sym__type] = STATE(4674),
    [sym_constructor_type] = STATE(4674),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3930),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4674),
    [sym_function_type] = STATE(4674),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3931),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(5168),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8181),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8183),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4372] = {
    [sym_union_type] = STATE(4675),
    [sym__type] = STATE(4675),
    [sym_constructor_type] = STATE(4675),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2464),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4675),
    [sym_function_type] = STATE(4675),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2465),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(5168),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5172),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4373] = {
    [anon_sym_AMP] = ACTIONS(6913),
    [anon_sym_RPAREN] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(6915),
    [anon_sym_COMMA] = ACTIONS(7511),
    [sym_comment] = ACTIONS(3),
  },
  [4374] = {
    [anon_sym_AMP] = ACTIONS(6913),
    [anon_sym_RPAREN] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(6915),
    [anon_sym_COMMA] = ACTIONS(7529),
    [sym_comment] = ACTIONS(3),
  },
  [4375] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(9071),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(8191),
    [anon_sym_COMMA] = ACTIONS(8547),
    [anon_sym_LT_LT] = ACTIONS(8547),
    [anon_sym_STAR] = ACTIONS(9071),
    [anon_sym_GT_GT_GT] = ACTIONS(8547),
    [anon_sym_AMP_AMP] = ACTIONS(8547),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_BANG_EQ] = ACTIONS(9071),
    [anon_sym_LT_EQ] = ACTIONS(8547),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [anon_sym_GT_EQ] = ACTIONS(8547),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_AMP] = ACTIONS(8193),
    [anon_sym_PERCENT] = ACTIONS(8547),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_as] = ACTIONS(8547),
    [anon_sym_PIPE_PIPE] = ACTIONS(8547),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_EQ_EQ] = ACTIONS(9071),
    [anon_sym_RPAREN] = ACTIONS(8547),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_instanceof] = ACTIONS(8547),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(8547),
    [anon_sym_DOT] = ACTIONS(8547),
    [anon_sym_CARET] = ACTIONS(8547),
    [anon_sym_STAR_STAR] = ACTIONS(8547),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_GT_GT] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8547),
    [anon_sym_in] = ACTIONS(9071),
  },
  [4376] = {
    [anon_sym_GT] = ACTIONS(9405),
    [sym_comment] = ACTIONS(3),
  },
  [4377] = {
    [sym_nested_identifier] = STATE(965),
    [sym_jsx_namespace_name] = STATE(966),
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(9407),
    [sym_comment] = ACTIONS(3),
    [sym_jsx_identifier] = ACTIONS(1975),
  },
  [4378] = {
    [anon_sym_GT] = ACTIONS(5299),
    [sym_jsx_identifier] = ACTIONS(5299),
    [sym_identifier] = ACTIONS(5301),
    [anon_sym_SLASH] = ACTIONS(5301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5299),
  },
  [4379] = {
    [anon_sym_GT] = ACTIONS(9409),
    [sym_comment] = ACTIONS(3),
  },
  [4380] = {
    [anon_sym_COLON] = ACTIONS(1513),
    [anon_sym_GT] = ACTIONS(9411),
    [anon_sym_DOT] = ACTIONS(5744),
    [sym_comment] = ACTIONS(3),
  },
  [4381] = {
    [anon_sym_COLON] = ACTIONS(1513),
    [anon_sym_GT] = ACTIONS(9411),
    [sym_comment] = ACTIONS(3),
  },
  [4382] = {
    [anon_sym_DOT] = ACTIONS(5744),
    [anon_sym_GT] = ACTIONS(9411),
    [sym_comment] = ACTIONS(3),
  },
  [4383] = {
    [anon_sym_GT] = ACTIONS(9411),
    [sym_comment] = ACTIONS(3),
  },
  [4384] = {
    [anon_sym_EQ_GT] = ACTIONS(9413),
    [sym_comment] = ACTIONS(3),
  },
  [4385] = {
    [sym_union_type] = STATE(4681),
    [sym__type] = STATE(4681),
    [sym_constructor_type] = STATE(4681),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3332),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4681),
    [sym_function_type] = STATE(4681),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3333),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3319),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6985),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6987),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4386] = {
    [sym_union_type] = STATE(4682),
    [sym__type] = STATE(4682),
    [sym_constructor_type] = STATE(4682),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3332),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4682),
    [sym_function_type] = STATE(4682),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3333),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3319),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6985),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6987),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4387] = {
    [anon_sym_EQ] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(8227),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(8229),
    [sym_comment] = ACTIONS(3),
  },
  [4388] = {
    [anon_sym_EQ] = ACTIONS(8547),
    [anon_sym_GT] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(5291),
    [anon_sym_PIPE] = ACTIONS(5293),
    [anon_sym_COMMA] = ACTIONS(8547),
    [sym_comment] = ACTIONS(3),
  },
  [4389] = {
    [anon_sym_COLON] = ACTIONS(8211),
    [sym__automatic_semicolon] = ACTIONS(8211),
    [anon_sym_RBRACE] = ACTIONS(8211),
    [anon_sym_SEMI] = ACTIONS(8211),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8211),
    [anon_sym_COMMA] = ACTIONS(8211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8211),
  },
  [4390] = {
    [sym_formal_parameters] = STATE(4683),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4391] = {
    [anon_sym_EQ_GT] = ACTIONS(9415),
    [sym_comment] = ACTIONS(3),
  },
  [4392] = {
    [sym_union_type] = STATE(2790),
    [sym__type] = STATE(2790),
    [sym_constructor_type] = STATE(2790),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3966),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2790),
    [sym_function_type] = STATE(2790),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3967),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5347),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8239),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8241),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4393] = {
    [sym_union_type] = STATE(2791),
    [sym__type] = STATE(2791),
    [sym_constructor_type] = STATE(2791),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3966),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2791),
    [sym_function_type] = STATE(2791),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3967),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5347),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8239),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8241),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4394] = {
    [anon_sym_EQ_GT] = ACTIONS(9417),
    [sym_comment] = ACTIONS(3),
  },
  [4395] = {
    [sym_union_type] = STATE(4686),
    [sym__type] = STATE(4686),
    [sym_constructor_type] = STATE(4686),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3966),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4686),
    [sym_function_type] = STATE(4686),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3967),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5347),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8239),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8241),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4396] = {
    [sym_union_type] = STATE(4687),
    [sym__type] = STATE(4687),
    [sym_constructor_type] = STATE(4687),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2530),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4687),
    [sym_function_type] = STATE(4687),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2531),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5347),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5351),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5353),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4397] = {
    [sym__automatic_semicolon] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(7017),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(7019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7511),
  },
  [4398] = {
    [sym__automatic_semicolon] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(7017),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(7019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7529),
  },
  [4399] = {
    [anon_sym_EQ_GT] = ACTIONS(9419),
    [sym_comment] = ACTIONS(3),
  },
  [4400] = {
    [sym_union_type] = STATE(4689),
    [sym__type] = STATE(4689),
    [sym_constructor_type] = STATE(4689),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3352),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4689),
    [sym_function_type] = STATE(4689),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3353),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3367),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(7027),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(7029),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(7031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4401] = {
    [sym_union_type] = STATE(4690),
    [sym__type] = STATE(4690),
    [sym_constructor_type] = STATE(4690),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3352),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4690),
    [sym_function_type] = STATE(4690),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3353),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3367),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(7027),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(7029),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(7031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4402] = {
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(8249),
    [anon_sym_PIPE] = ACTIONS(8251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6040),
  },
  [4403] = {
    [anon_sym_AMP] = ACTIONS(5367),
    [anon_sym_PIPE] = ACTIONS(5369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8547),
  },
  [4404] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(9071),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(8257),
    [anon_sym_LT_LT] = ACTIONS(8547),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_STAR] = ACTIONS(9071),
    [anon_sym_GT_GT_GT] = ACTIONS(8547),
    [anon_sym_AMP_AMP] = ACTIONS(8547),
    [anon_sym_BANG_EQ] = ACTIONS(9071),
    [anon_sym_LT_EQ] = ACTIONS(8547),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [anon_sym_GT_EQ] = ACTIONS(8547),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_AMP] = ACTIONS(8259),
    [anon_sym_PERCENT] = ACTIONS(8547),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_as] = ACTIONS(8547),
    [anon_sym_PIPE_PIPE] = ACTIONS(8547),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_EQ_EQ] = ACTIONS(9071),
    [anon_sym_instanceof] = ACTIONS(8547),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8547),
    [anon_sym_CARET] = ACTIONS(8547),
    [anon_sym_STAR_STAR] = ACTIONS(8547),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_GT_GT] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8547),
    [anon_sym_in] = ACTIONS(9071),
  },
  [4405] = {
    [sym_union_type] = STATE(4691),
    [sym__type] = STATE(4691),
    [sym_constructor_type] = STATE(4691),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(2577),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(4691),
    [sym_function_type] = STATE(4691),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(2578),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(5459),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(5465),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(5463),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(5467),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(5461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [4406] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_BANG] = ACTIONS(8379),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [sym__automatic_semicolon] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(8973),
    [anon_sym_LT_LT] = ACTIONS(7511),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_STAR] = ACTIONS(8379),
    [anon_sym_GT_GT_GT] = ACTIONS(7511),
    [anon_sym_AMP_AMP] = ACTIONS(7511),
    [anon_sym_BANG_EQ] = ACTIONS(8379),
    [anon_sym_LT_EQ] = ACTIONS(7511),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [anon_sym_GT_EQ] = ACTIONS(7511),
    [anon_sym_GT] = ACTIONS(8379),
    [anon_sym_AMP] = ACTIONS(8975),
    [anon_sym_PERCENT] = ACTIONS(7511),
    [anon_sym_QMARK] = ACTIONS(7511),
    [anon_sym_as] = ACTIONS(7511),
    [anon_sym_PIPE_PIPE] = ACTIONS(7511),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_EQ_EQ] = ACTIONS(8379),
    [anon_sym_instanceof] = ACTIONS(7511),
    [anon_sym_LT] = ACTIONS(8379),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7511),
    [anon_sym_CARET] = ACTIONS(7511),
    [anon_sym_STAR_STAR] = ACTIONS(7511),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_GT_GT] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7511),
    [anon_sym_in] = ACTIONS(8379),
  },
  [4407] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_BANG] = ACTIONS(8381),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [sym__automatic_semicolon] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(8973),
    [anon_sym_LT_LT] = ACTIONS(7529),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_STAR] = ACTIONS(8381),
    [anon_sym_GT_GT_GT] = ACTIONS(7529),
    [anon_sym_AMP_AMP] = ACTIONS(7529),
    [anon_sym_BANG_EQ] = ACTIONS(8381),
    [anon_sym_LT_EQ] = ACTIONS(7529),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [anon_sym_GT_EQ] = ACTIONS(7529),
    [anon_sym_GT] = ACTIONS(8381),
    [anon_sym_AMP] = ACTIONS(8975),
    [anon_sym_PERCENT] = ACTIONS(7529),
    [anon_sym_QMARK] = ACTIONS(7529),
    [anon_sym_as] = ACTIONS(7529),
    [anon_sym_PIPE_PIPE] = ACTIONS(7529),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_EQ_EQ] = ACTIONS(8381),
    [anon_sym_instanceof] = ACTIONS(7529),
    [anon_sym_LT] = ACTIONS(8381),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7529),
    [anon_sym_CARET] = ACTIONS(7529),
    [anon_sym_STAR_STAR] = ACTIONS(7529),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_GT_GT] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7529),
    [anon_sym_in] = ACTIONS(8381),
  },
  [4408] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(6453),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_SEMI] = ACTIONS(2011),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [sym__automatic_semicolon] = ACTIONS(2011),
    [anon_sym_PERCENT_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_AMP_EQ] = ACTIONS(2011),
    [anon_sym_PLUS_EQ] = ACTIONS(2011),
    [anon_sym_PIPE] = ACTIONS(8388),
    [anon_sym_COMMA] = ACTIONS(4485),
    [anon_sym_LT_LT] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_GT_GT_GT] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(8388),
    [anon_sym_CARET_EQ] = ACTIONS(2011),
    [anon_sym_STAR_EQ] = ACTIONS(2011),
    [anon_sym_PIPE_EQ] = ACTIONS(2011),
    [anon_sym_DASH_EQ] = ACTIONS(2011),
    [anon_sym_AMP] = ACTIONS(8388),
    [anon_sym_PERCENT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_LT_LT_EQ] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_instanceof] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_DOT] = ACTIONS(6453),
    [anon_sym_CARET] = ACTIONS(2013),
    [anon_sym_STAR_STAR] = ACTIONS(2013),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2013),
  },
  [4409] = {
    [anon_sym_of] = ACTIONS(9421),
    [sym_comment] = ACTIONS(3),
  },
  [4410] = {
    [anon_sym_of] = ACTIONS(9423),
    [sym_comment] = ACTIONS(3),
  },
  [4411] = {
    [anon_sym_of] = ACTIONS(9425),
    [sym_comment] = ACTIONS(3),
  },
  [4412] = {
    [sym_new_expression] = STATE(4695),
    [sym_augmented_assignment_expression] = STATE(4695),
    [sym_unary_expression] = STATE(4695),
    [sym_update_expression] = STATE(4695),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4695),
    [sym_regex] = STATE(4695),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4695),
    [sym_non_null_expression] = STATE(4695),
    [sym_as_expression] = STATE(4695),
    [sym_jsx_fragment] = STATE(4695),
    [sym_yield_expression] = STATE(4695),
    [sym_jsx_element] = STATE(4695),
    [sym_internal_module] = STATE(4695),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4695),
    [sym_await_expression] = STATE(4695),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4695),
    [sym_this] = STATE(4695),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4695),
    [sym_generator_function] = STATE(4695),
    [sym_call_expression] = STATE(4695),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4695),
    [sym_ternary_expression] = STATE(4695),
    [sym_binary_expression] = STATE(4695),
    [sym_template_string] = STATE(4695),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4695),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4695),
    [sym_class] = STATE(4695),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9427),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9427),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9429),
    [sym_true] = ACTIONS(9427),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9427),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4413] = {
    [sym_new_expression] = STATE(4696),
    [sym_augmented_assignment_expression] = STATE(4696),
    [sym_unary_expression] = STATE(4696),
    [sym_update_expression] = STATE(4696),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4696),
    [sym_regex] = STATE(4696),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4696),
    [sym_non_null_expression] = STATE(4696),
    [sym_as_expression] = STATE(4696),
    [sym_jsx_fragment] = STATE(4696),
    [sym_yield_expression] = STATE(4696),
    [sym_jsx_element] = STATE(4696),
    [sym_internal_module] = STATE(4696),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4696),
    [sym_await_expression] = STATE(4696),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4696),
    [sym_this] = STATE(4696),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4696),
    [sym_generator_function] = STATE(4696),
    [sym_call_expression] = STATE(4696),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4696),
    [sym_ternary_expression] = STATE(4696),
    [sym_binary_expression] = STATE(4696),
    [sym_template_string] = STATE(4696),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4696),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4696),
    [sym_class] = STATE(4696),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9431),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9431),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9433),
    [sym_true] = ACTIONS(9431),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9431),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4414] = {
    [sym_new_expression] = STATE(4697),
    [sym_augmented_assignment_expression] = STATE(4697),
    [sym_unary_expression] = STATE(4697),
    [sym_update_expression] = STATE(4697),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4697),
    [sym_regex] = STATE(4697),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4697),
    [sym_non_null_expression] = STATE(4697),
    [sym_as_expression] = STATE(4697),
    [sym_jsx_fragment] = STATE(4697),
    [sym_yield_expression] = STATE(4697),
    [sym_jsx_element] = STATE(4697),
    [sym_internal_module] = STATE(4697),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4697),
    [sym_await_expression] = STATE(4697),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4697),
    [sym_this] = STATE(4697),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4697),
    [sym_generator_function] = STATE(4697),
    [sym_call_expression] = STATE(4697),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4697),
    [sym_ternary_expression] = STATE(4697),
    [sym_binary_expression] = STATE(4697),
    [sym_template_string] = STATE(4697),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4697),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4697),
    [sym_class] = STATE(4697),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9435),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9435),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9437),
    [sym_true] = ACTIONS(9435),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9435),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4415] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(9439),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [4416] = {
    [anon_sym_RPAREN] = ACTIONS(9439),
    [sym_comment] = ACTIONS(3),
  },
  [4417] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9441),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4418] = {
    [sym_new_expression] = STATE(4700),
    [sym_augmented_assignment_expression] = STATE(4700),
    [sym_unary_expression] = STATE(4700),
    [sym_update_expression] = STATE(4700),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(4700),
    [sym_regex] = STATE(4700),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4700),
    [sym_non_null_expression] = STATE(4700),
    [sym_as_expression] = STATE(4700),
    [sym_jsx_fragment] = STATE(4700),
    [sym_yield_expression] = STATE(4700),
    [sym_jsx_element] = STATE(4700),
    [sym_internal_module] = STATE(4700),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4700),
    [sym_await_expression] = STATE(4700),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(4701),
    [sym_string] = STATE(4700),
    [sym_this] = STATE(4700),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(4700),
    [sym_generator_function] = STATE(4700),
    [sym_call_expression] = STATE(4700),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(4700),
    [sym_ternary_expression] = STATE(4700),
    [sym_binary_expression] = STATE(4700),
    [sym_template_string] = STATE(4700),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4700),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4700),
    [sym_class] = STATE(4700),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(9443),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9443),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9445),
    [sym_true] = ACTIONS(9443),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9443),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [4419] = {
    [sym_new_expression] = STATE(4702),
    [sym_augmented_assignment_expression] = STATE(4702),
    [sym_unary_expression] = STATE(4702),
    [sym_update_expression] = STATE(4702),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(4702),
    [sym_regex] = STATE(4702),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4702),
    [sym_non_null_expression] = STATE(4702),
    [sym_as_expression] = STATE(4702),
    [sym_jsx_fragment] = STATE(4702),
    [sym_yield_expression] = STATE(4702),
    [sym_jsx_element] = STATE(4702),
    [sym_internal_module] = STATE(4702),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4702),
    [sym_await_expression] = STATE(4702),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(4703),
    [sym_string] = STATE(4702),
    [sym_this] = STATE(4702),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(4702),
    [sym_generator_function] = STATE(4702),
    [sym_call_expression] = STATE(4702),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(4702),
    [sym_ternary_expression] = STATE(4702),
    [sym_binary_expression] = STATE(4702),
    [sym_template_string] = STATE(4702),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4702),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4702),
    [sym_class] = STATE(4702),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(9447),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9447),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9449),
    [sym_true] = ACTIONS(9447),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9447),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [4420] = {
    [sym_new_expression] = STATE(4704),
    [sym_augmented_assignment_expression] = STATE(4704),
    [sym_unary_expression] = STATE(4704),
    [sym_update_expression] = STATE(4704),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(4704),
    [sym_regex] = STATE(4704),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4704),
    [sym_non_null_expression] = STATE(4704),
    [sym_as_expression] = STATE(4704),
    [sym_jsx_fragment] = STATE(4704),
    [sym_yield_expression] = STATE(4704),
    [sym_jsx_element] = STATE(4704),
    [sym_internal_module] = STATE(4704),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4704),
    [sym_await_expression] = STATE(4704),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(4705),
    [sym_string] = STATE(4704),
    [sym_this] = STATE(4704),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(4704),
    [sym_generator_function] = STATE(4704),
    [sym_call_expression] = STATE(4704),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(4704),
    [sym_ternary_expression] = STATE(4704),
    [sym_binary_expression] = STATE(4704),
    [sym_template_string] = STATE(4704),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4704),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4704),
    [sym_class] = STATE(4704),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(9451),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9451),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9453),
    [sym_true] = ACTIONS(9451),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9451),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [4421] = {
    [sym_type_alias_declaration] = STATE(3041),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3041),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3041),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3041),
    [sym_return_statement] = STATE(3041),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3041),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3041),
    [sym_switch_statement] = STATE(3041),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3041),
    [sym_throw_statement] = STATE(3041),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3041),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3041),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(3041),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3041),
    [sym_abstract_class] = STATE(3041),
    [sym_interface_declaration] = STATE(3041),
    [sym_statement_block] = STATE(3041),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3041),
    [sym_debugger_statement] = STATE(3041),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3041),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3041),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3041),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3041),
    [sym_empty_statement] = STATE(3041),
    [sym_import_alias] = STATE(3041),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3041),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3041),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3041),
    [sym_break_statement] = STATE(3041),
    [sym_labeled_statement] = STATE(3041),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3041),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [4422] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(9455),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4423] = {
    [anon_sym_RPAREN] = ACTIONS(9455),
    [sym_comment] = ACTIONS(3),
  },
  [4424] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9457),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4425] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(9459),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [4426] = {
    [anon_sym_RPAREN] = ACTIONS(9459),
    [sym_comment] = ACTIONS(3),
  },
  [4427] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9461),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4428] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(9463),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [4429] = {
    [anon_sym_RPAREN] = ACTIONS(9463),
    [sym_comment] = ACTIONS(3),
  },
  [4430] = {
    [sym_union_type] = STATE(4716),
    [sym__type] = STATE(4716),
    [sym_constructor_type] = STATE(4716),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(4717),
    [sym_type_parameters] = STATE(4718),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4716),
    [sym_function_type] = STATE(4716),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4719),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9465),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9469),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9471),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4431] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9475),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4432] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9477),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4433] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9479),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4434] = {
    [sym_type_alias_declaration] = STATE(4210),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4210),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4210),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4210),
    [sym_return_statement] = STATE(4210),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4210),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4210),
    [sym_switch_statement] = STATE(4210),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4210),
    [sym_throw_statement] = STATE(4210),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4210),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4210),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(4210),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4210),
    [sym_abstract_class] = STATE(4210),
    [sym_interface_declaration] = STATE(4210),
    [sym_statement_block] = STATE(4210),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4210),
    [sym_debugger_statement] = STATE(4210),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4210),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4210),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4210),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4210),
    [sym_empty_statement] = STATE(4210),
    [sym_import_alias] = STATE(4210),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4210),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4210),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4210),
    [sym_break_statement] = STATE(4210),
    [sym_labeled_statement] = STATE(4210),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4210),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [4435] = {
    [sym_type_alias_declaration] = STATE(4211),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4211),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4211),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4211),
    [sym_return_statement] = STATE(4211),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4211),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4211),
    [sym_switch_statement] = STATE(4211),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4211),
    [sym_throw_statement] = STATE(4211),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4211),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4211),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(4211),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4211),
    [sym_abstract_class] = STATE(4211),
    [sym_interface_declaration] = STATE(4211),
    [sym_statement_block] = STATE(4211),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4211),
    [sym_debugger_statement] = STATE(4211),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4211),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4211),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4211),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4211),
    [sym_empty_statement] = STATE(4211),
    [sym_import_alias] = STATE(4211),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4211),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4211),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4211),
    [sym_break_statement] = STATE(4211),
    [sym_labeled_statement] = STATE(4211),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4211),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [4436] = {
    [sym_type_alias_declaration] = STATE(4212),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4212),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4212),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4212),
    [sym_return_statement] = STATE(4212),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4212),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4212),
    [sym_switch_statement] = STATE(4212),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4212),
    [sym_throw_statement] = STATE(4212),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4212),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4212),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(4212),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4212),
    [sym_abstract_class] = STATE(4212),
    [sym_interface_declaration] = STATE(4212),
    [sym_statement_block] = STATE(4212),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4212),
    [sym_debugger_statement] = STATE(4212),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4212),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4212),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4212),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4212),
    [sym_empty_statement] = STATE(4212),
    [sym_import_alias] = STATE(4212),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4212),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4212),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4212),
    [sym_break_statement] = STATE(4212),
    [sym_labeled_statement] = STATE(4212),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4212),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [4437] = {
    [sym_type_alias_declaration] = STATE(4235),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4235),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4235),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4235),
    [sym_return_statement] = STATE(4235),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4235),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4235),
    [sym_switch_statement] = STATE(4235),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4235),
    [sym_throw_statement] = STATE(4235),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4235),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4235),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(4235),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4235),
    [sym_abstract_class] = STATE(4235),
    [sym_interface_declaration] = STATE(4235),
    [sym_statement_block] = STATE(4235),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4235),
    [sym_debugger_statement] = STATE(4235),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4235),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4235),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4235),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4235),
    [sym_empty_statement] = STATE(4235),
    [sym_import_alias] = STATE(4235),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4235),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4235),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4235),
    [sym_break_statement] = STATE(4235),
    [sym_labeled_statement] = STATE(4235),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4235),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [4438] = {
    [sym_type_alias_declaration] = STATE(4236),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4236),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4236),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4236),
    [sym_return_statement] = STATE(4236),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4236),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4236),
    [sym_switch_statement] = STATE(4236),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4236),
    [sym_throw_statement] = STATE(4236),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4236),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4236),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(4236),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4236),
    [sym_abstract_class] = STATE(4236),
    [sym_interface_declaration] = STATE(4236),
    [sym_statement_block] = STATE(4236),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4236),
    [sym_debugger_statement] = STATE(4236),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4236),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4236),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4236),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4236),
    [sym_empty_statement] = STATE(4236),
    [sym_import_alias] = STATE(4236),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4236),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4236),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4236),
    [sym_break_statement] = STATE(4236),
    [sym_labeled_statement] = STATE(4236),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4236),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [4439] = {
    [sym_type_alias_declaration] = STATE(4237),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4237),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4237),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4237),
    [sym_return_statement] = STATE(4237),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4237),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4237),
    [sym_switch_statement] = STATE(4237),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4237),
    [sym_throw_statement] = STATE(4237),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4237),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4237),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(4237),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4237),
    [sym_abstract_class] = STATE(4237),
    [sym_interface_declaration] = STATE(4237),
    [sym_statement_block] = STATE(4237),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4237),
    [sym_debugger_statement] = STATE(4237),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4237),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4237),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4237),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4237),
    [sym_empty_statement] = STATE(4237),
    [sym_import_alias] = STATE(4237),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4237),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4237),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4237),
    [sym_break_statement] = STATE(4237),
    [sym_labeled_statement] = STATE(4237),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4237),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [4440] = {
    [sym_union_type] = STATE(4726),
    [sym__type] = STATE(4726),
    [sym_constructor_type] = STATE(4726),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(4727),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4726),
    [sym_function_type] = STATE(4726),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4728),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8345),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9481),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9483),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4441] = {
    [sym_formal_parameters] = STATE(4729),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4442] = {
    [anon_sym_EQ_GT] = ACTIONS(9487),
    [sym_comment] = ACTIONS(3),
  },
  [4443] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4035),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8345),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8349),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8351),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4444] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4035),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8345),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8349),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8351),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4445] = {
    [anon_sym_EQ_GT] = ACTIONS(9489),
    [sym_comment] = ACTIONS(3),
  },
  [4446] = {
    [sym_union_type] = STATE(4732),
    [sym__type] = STATE(4732),
    [sym_constructor_type] = STATE(4732),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4732),
    [sym_function_type] = STATE(4732),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4035),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8345),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8349),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8351),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4447] = {
    [sym_union_type] = STATE(4733),
    [sym__type] = STATE(4733),
    [sym_constructor_type] = STATE(4733),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2631),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4733),
    [sym_function_type] = STATE(4733),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2632),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(1839),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(1841),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5549),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4448] = {
    [anon_sym_EQ_GT] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(7154),
    [anon_sym_PIPE] = ACTIONS(7156),
    [sym_comment] = ACTIONS(3),
  },
  [4449] = {
    [anon_sym_EQ_GT] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(7154),
    [anon_sym_PIPE] = ACTIONS(7156),
    [sym_comment] = ACTIONS(3),
  },
  [4450] = {
    [sym_union_type] = STATE(4734),
    [sym__type] = STATE(4734),
    [sym_constructor_type] = STATE(4734),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2655),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4734),
    [sym_function_type] = STATE(4734),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2656),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(5608),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(5614),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(5612),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(5616),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(5610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4451] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_BANG] = ACTIONS(8379),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(9061),
    [anon_sym_LT_LT] = ACTIONS(7511),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_STAR] = ACTIONS(8379),
    [anon_sym_GT_GT_GT] = ACTIONS(7511),
    [anon_sym_AMP_AMP] = ACTIONS(7511),
    [anon_sym_BANG_EQ] = ACTIONS(8379),
    [anon_sym_LT_EQ] = ACTIONS(7511),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [anon_sym_GT_EQ] = ACTIONS(7511),
    [anon_sym_GT] = ACTIONS(8379),
    [anon_sym_AMP] = ACTIONS(9063),
    [anon_sym_PERCENT] = ACTIONS(7511),
    [anon_sym_QMARK] = ACTIONS(7511),
    [anon_sym_as] = ACTIONS(7511),
    [anon_sym_PIPE_PIPE] = ACTIONS(7511),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_EQ_EQ] = ACTIONS(8379),
    [anon_sym_instanceof] = ACTIONS(7511),
    [anon_sym_LT] = ACTIONS(8379),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7511),
    [anon_sym_DOT] = ACTIONS(7511),
    [anon_sym_CARET] = ACTIONS(7511),
    [anon_sym_STAR_STAR] = ACTIONS(7511),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_GT_GT] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7511),
    [anon_sym_in] = ACTIONS(8379),
  },
  [4452] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_BANG] = ACTIONS(8381),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(9061),
    [anon_sym_LT_LT] = ACTIONS(7529),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_STAR] = ACTIONS(8381),
    [anon_sym_GT_GT_GT] = ACTIONS(7529),
    [anon_sym_AMP_AMP] = ACTIONS(7529),
    [anon_sym_BANG_EQ] = ACTIONS(8381),
    [anon_sym_LT_EQ] = ACTIONS(7529),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [anon_sym_GT_EQ] = ACTIONS(7529),
    [anon_sym_GT] = ACTIONS(8381),
    [anon_sym_AMP] = ACTIONS(9063),
    [anon_sym_PERCENT] = ACTIONS(7529),
    [anon_sym_QMARK] = ACTIONS(7529),
    [anon_sym_as] = ACTIONS(7529),
    [anon_sym_PIPE_PIPE] = ACTIONS(7529),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_EQ_EQ] = ACTIONS(8381),
    [anon_sym_instanceof] = ACTIONS(7529),
    [anon_sym_LT] = ACTIONS(8381),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7529),
    [anon_sym_DOT] = ACTIONS(7529),
    [anon_sym_CARET] = ACTIONS(7529),
    [anon_sym_STAR_STAR] = ACTIONS(7529),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_GT_GT] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7529),
    [anon_sym_in] = ACTIONS(8381),
  },
  [4453] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7521),
    [anon_sym_LBRACK] = ACTIONS(7521),
    [anon_sym_BANG] = ACTIONS(7523),
    [anon_sym_SEMI] = ACTIONS(7521),
    [anon_sym_BQUOTE] = ACTIONS(7521),
    [sym__automatic_semicolon] = ACTIONS(7521),
    [anon_sym_PIPE] = ACTIONS(7523),
    [anon_sym_COMMA] = ACTIONS(7521),
    [anon_sym_LT_LT] = ACTIONS(7521),
    [anon_sym_STAR] = ACTIONS(7523),
    [anon_sym_GT_GT_GT] = ACTIONS(7521),
    [anon_sym_AMP_AMP] = ACTIONS(7521),
    [anon_sym_DASH] = ACTIONS(7523),
    [anon_sym_BANG_EQ] = ACTIONS(7523),
    [anon_sym_LT_EQ] = ACTIONS(7521),
    [anon_sym_LPAREN] = ACTIONS(7521),
    [anon_sym_GT_EQ] = ACTIONS(7521),
    [anon_sym_GT] = ACTIONS(7523),
    [anon_sym_AMP] = ACTIONS(7523),
    [anon_sym_PERCENT] = ACTIONS(7521),
    [anon_sym_QMARK] = ACTIONS(7521),
    [anon_sym_RBRACE] = ACTIONS(7521),
    [anon_sym_as] = ACTIONS(7521),
    [anon_sym_PIPE_PIPE] = ACTIONS(7521),
    [anon_sym_DASH_DASH] = ACTIONS(7521),
    [anon_sym_EQ_EQ] = ACTIONS(7523),
    [anon_sym_instanceof] = ACTIONS(7521),
    [anon_sym_LT] = ACTIONS(7523),
    [anon_sym_RPAREN] = ACTIONS(7521),
    [anon_sym_SLASH] = ACTIONS(7523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7521),
    [anon_sym_CARET] = ACTIONS(7521),
    [anon_sym_STAR_STAR] = ACTIONS(7521),
    [anon_sym_PLUS] = ACTIONS(7523),
    [anon_sym_GT_GT] = ACTIONS(7523),
    [anon_sym_PLUS_PLUS] = ACTIONS(7521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7521),
    [anon_sym_in] = ACTIONS(7523),
  },
  [4454] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(9123),
    [anon_sym_LBRACK] = ACTIONS(9123),
    [anon_sym_BANG] = ACTIONS(9121),
    [anon_sym_SEMI] = ACTIONS(9123),
    [anon_sym_BQUOTE] = ACTIONS(9123),
    [sym__automatic_semicolon] = ACTIONS(9123),
    [anon_sym_PIPE] = ACTIONS(9121),
    [anon_sym_COMMA] = ACTIONS(9123),
    [anon_sym_LT_LT] = ACTIONS(9123),
    [anon_sym_STAR] = ACTIONS(9121),
    [anon_sym_GT_GT_GT] = ACTIONS(9123),
    [anon_sym_AMP_AMP] = ACTIONS(9123),
    [anon_sym_DASH] = ACTIONS(9121),
    [anon_sym_BANG_EQ] = ACTIONS(9121),
    [anon_sym_LT_EQ] = ACTIONS(9123),
    [anon_sym_LPAREN] = ACTIONS(9123),
    [anon_sym_GT_EQ] = ACTIONS(9123),
    [anon_sym_GT] = ACTIONS(9121),
    [anon_sym_AMP] = ACTIONS(9121),
    [anon_sym_PERCENT] = ACTIONS(9123),
    [anon_sym_QMARK] = ACTIONS(9123),
    [anon_sym_RBRACE] = ACTIONS(9123),
    [anon_sym_as] = ACTIONS(9123),
    [anon_sym_PIPE_PIPE] = ACTIONS(9123),
    [anon_sym_DASH_DASH] = ACTIONS(9123),
    [anon_sym_EQ_EQ] = ACTIONS(9121),
    [anon_sym_instanceof] = ACTIONS(9123),
    [anon_sym_LT] = ACTIONS(9121),
    [anon_sym_RPAREN] = ACTIONS(9123),
    [anon_sym_SLASH] = ACTIONS(9121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(9123),
    [anon_sym_CARET] = ACTIONS(9123),
    [anon_sym_STAR_STAR] = ACTIONS(9123),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9123),
    [anon_sym_GT_GT] = ACTIONS(9121),
    [anon_sym_PLUS_PLUS] = ACTIONS(9123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9123),
    [anon_sym_in] = ACTIONS(9121),
  },
  [4455] = {
    [sym_statement_block] = STATE(3829),
    [sym__automatic_semicolon] = ACTIONS(8727),
    [anon_sym_RBRACE] = ACTIONS(8727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(8727),
    [anon_sym_COMMA] = ACTIONS(8727),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8727),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [4456] = {
    [sym_type_parameters] = STATE(2715),
    [sym_formal_parameters] = STATE(2716),
    [sym_call_signature] = STATE(4735),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4457] = {
    [sym_type_parameters] = STATE(2715),
    [sym_formal_parameters] = STATE(2716),
    [sym_call_signature] = STATE(4735),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(9491),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [4458] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(6447),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [anon_sym_SEMI] = ACTIONS(5891),
    [sym__automatic_semicolon] = ACTIONS(5891),
    [anon_sym_PERCENT_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_AMP_EQ] = ACTIONS(2011),
    [anon_sym_PLUS_EQ] = ACTIONS(2011),
    [anon_sym_PIPE] = ACTIONS(6450),
    [anon_sym_COMMA] = ACTIONS(6447),
    [anon_sym_LT_LT] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_GT_GT_GT] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_CARET_EQ] = ACTIONS(2011),
    [anon_sym_STAR_EQ] = ACTIONS(2011),
    [anon_sym_PIPE_EQ] = ACTIONS(2011),
    [anon_sym_DASH_EQ] = ACTIONS(2011),
    [anon_sym_RBRACE] = ACTIONS(6447),
    [anon_sym_AMP] = ACTIONS(6450),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_LT_LT_EQ] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2011),
    [anon_sym_PERCENT] = ACTIONS(2013),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_instanceof] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(6450),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_DOT] = ACTIONS(6453),
    [anon_sym_CARET] = ACTIONS(2013),
    [anon_sym_STAR_STAR] = ACTIONS(2013),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5891),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2013),
  },
  [4459] = {
    [sym_identifier] = ACTIONS(9493),
    [sym_comment] = ACTIONS(3),
  },
  [4460] = {
    [sym_type_annotation] = STATE(892),
    [anon_sym_EQ_GT] = ACTIONS(9495),
    [anon_sym_COLON] = ACTIONS(550),
    [sym_comment] = ACTIONS(3),
  },
  [4461] = {
    [sym_union_type] = STATE(4741),
    [sym__type] = STATE(4741),
    [sym_constructor_type] = STATE(4741),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4742),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4741),
    [sym_function_type] = STATE(4741),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4743),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(8421),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(8423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(9498),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(9500),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(9502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4462] = {
    [sym_formal_parameters] = STATE(4744),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4463] = {
    [anon_sym_EQ_GT] = ACTIONS(9504),
    [sym_comment] = ACTIONS(3),
  },
  [4464] = {
    [sym_union_type] = STATE(2790),
    [sym__type] = STATE(2790),
    [sym_constructor_type] = STATE(2790),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4073),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2790),
    [sym_function_type] = STATE(2790),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4074),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(8421),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(8423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8425),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8427),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4465] = {
    [sym_union_type] = STATE(2791),
    [sym__type] = STATE(2791),
    [sym_constructor_type] = STATE(2791),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4073),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2791),
    [sym_function_type] = STATE(2791),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4074),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(8421),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(8423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8425),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8427),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4466] = {
    [anon_sym_EQ_GT] = ACTIONS(9506),
    [sym_comment] = ACTIONS(3),
  },
  [4467] = {
    [sym_union_type] = STATE(4747),
    [sym__type] = STATE(4747),
    [sym_constructor_type] = STATE(4747),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4073),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4747),
    [sym_function_type] = STATE(4747),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4074),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(8421),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(8423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8425),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8427),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4468] = {
    [sym_string] = STATE(4748),
    [sym__property_name] = STATE(4748),
    [sym_computed_property_name] = STATE(4748),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_QMARK] = ACTIONS(1214),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [anon_sym_LT] = ACTIONS(1214),
    [sym_number] = ACTIONS(9508),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [4469] = {
    [sym_string] = STATE(4748),
    [sym__property_name] = STATE(4748),
    [sym_computed_property_name] = STATE(4748),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(9508),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_async] = ACTIONS(1230),
  },
  [4470] = {
    [sym_type_parameters] = STATE(2715),
    [sym_type_annotation] = STATE(4515),
    [sym_formal_parameters] = STATE(2716),
    [sym_call_signature] = STATE(4735),
    [sym__automatic_semicolon] = ACTIONS(9127),
    [anon_sym_RBRACE] = ACTIONS(9127),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(9127),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9127),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(9127),
    [sym_comment] = ACTIONS(3),
  },
  [4471] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5792),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(5794),
    [anon_sym_LT_LT] = ACTIONS(5796),
    [anon_sym_DASH] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(5800),
    [anon_sym_GT_GT_GT] = ACTIONS(5796),
    [anon_sym_AMP_AMP] = ACTIONS(5802),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(5792),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_RBRACE] = ACTIONS(7181),
    [anon_sym_AMP] = ACTIONS(5804),
    [anon_sym_QMARK] = ACTIONS(5806),
    [anon_sym_PERCENT] = ACTIONS(5796),
    [anon_sym_as] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_instanceof] = ACTIONS(5792),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(5808),
    [anon_sym_STAR_STAR] = ACTIONS(5814),
    [anon_sym_PLUS] = ACTIONS(5798),
    [anon_sym_GT_GT] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5792),
    [anon_sym_in] = ACTIONS(5752),
  },
  [4472] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(7192),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(9510),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_GT_GT_GT] = ACTIONS(5893),
    [anon_sym_AMP_AMP] = ACTIONS(5893),
    [anon_sym_BANG_EQ] = ACTIONS(7192),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_RBRACE] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(9512),
    [anon_sym_QMARK] = ACTIONS(5893),
    [anon_sym_PERCENT] = ACTIONS(5893),
    [anon_sym_as] = ACTIONS(5893),
    [anon_sym_PIPE_PIPE] = ACTIONS(5893),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_EQ_EQ] = ACTIONS(7192),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5893),
    [anon_sym_CARET] = ACTIONS(5893),
    [anon_sym_STAR_STAR] = ACTIONS(5893),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_in] = ACTIONS(7192),
  },
  [4473] = {
    [anon_sym_EQ_GT] = ACTIONS(9514),
    [sym_comment] = ACTIONS(3),
  },
  [4474] = {
    [sym_union_type] = STATE(4750),
    [sym__type] = STATE(4750),
    [sym_constructor_type] = STATE(4750),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3500),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4750),
    [sym_function_type] = STATE(4750),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3501),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(7341),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(7347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(7345),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(7349),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(7343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4475] = {
    [sym_union_type] = STATE(4751),
    [sym__type] = STATE(4751),
    [sym_constructor_type] = STATE(4751),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3500),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4751),
    [sym_function_type] = STATE(4751),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3501),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(7341),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(7347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(7345),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(7349),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(7343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4476] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_BANG] = ACTIONS(7208),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(9510),
    [anon_sym_LT_LT] = ACTIONS(6040),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_STAR] = ACTIONS(7208),
    [anon_sym_GT_GT_GT] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(6040),
    [anon_sym_BANG_EQ] = ACTIONS(7208),
    [anon_sym_LT_EQ] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [anon_sym_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_RBRACE] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(9512),
    [anon_sym_QMARK] = ACTIONS(6040),
    [anon_sym_PERCENT] = ACTIONS(6040),
    [anon_sym_as] = ACTIONS(6040),
    [anon_sym_PIPE_PIPE] = ACTIONS(6040),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_instanceof] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6040),
    [anon_sym_CARET] = ACTIONS(6040),
    [anon_sym_STAR_STAR] = ACTIONS(6040),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6040),
    [anon_sym_in] = ACTIONS(7208),
  },
  [4477] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(9071),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(8461),
    [anon_sym_COMMA] = ACTIONS(8547),
    [anon_sym_LT_LT] = ACTIONS(8547),
    [anon_sym_STAR] = ACTIONS(9071),
    [anon_sym_GT_GT_GT] = ACTIONS(8547),
    [anon_sym_AMP_AMP] = ACTIONS(8547),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_BANG_EQ] = ACTIONS(9071),
    [anon_sym_LT_EQ] = ACTIONS(8547),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [anon_sym_GT_EQ] = ACTIONS(8547),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_RBRACE] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(8463),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_PERCENT] = ACTIONS(8547),
    [anon_sym_as] = ACTIONS(8547),
    [anon_sym_PIPE_PIPE] = ACTIONS(8547),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_EQ_EQ] = ACTIONS(9071),
    [anon_sym_instanceof] = ACTIONS(8547),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8547),
    [anon_sym_CARET] = ACTIONS(8547),
    [anon_sym_STAR_STAR] = ACTIONS(8547),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_GT_GT] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8547),
    [anon_sym_in] = ACTIONS(9071),
  },
  [4478] = {
    [anon_sym_EQ] = ACTIONS(7521),
    [anon_sym_LBRACK] = ACTIONS(7521),
    [anon_sym_AMP] = ACTIONS(7521),
    [anon_sym_SEMI] = ACTIONS(7521),
    [sym__automatic_semicolon] = ACTIONS(7521),
    [anon_sym_RBRACE] = ACTIONS(7521),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7521),
    [anon_sym_PIPE] = ACTIONS(7523),
    [anon_sym_COMMA] = ACTIONS(7521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7521),
  },
  [4479] = {
    [sym_union_type] = STATE(4752),
    [sym__type] = STATE(4752),
    [sym_constructor_type] = STATE(4752),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2778),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4752),
    [sym_function_type] = STATE(4752),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2779),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2135),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5845),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5847),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4480] = {
    [anon_sym_EQ] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(7383),
    [anon_sym_SEMI] = ACTIONS(7511),
    [sym__automatic_semicolon] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(7385),
    [anon_sym_COMMA] = ACTIONS(7511),
    [sym_comment] = ACTIONS(3),
  },
  [4481] = {
    [anon_sym_EQ] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(7383),
    [anon_sym_SEMI] = ACTIONS(7529),
    [sym__automatic_semicolon] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(7385),
    [anon_sym_COMMA] = ACTIONS(7529),
    [sym_comment] = ACTIONS(3),
  },
  [4482] = {
    [anon_sym_EQ] = ACTIONS(9123),
    [anon_sym_LBRACK] = ACTIONS(9123),
    [anon_sym_AMP] = ACTIONS(9123),
    [anon_sym_SEMI] = ACTIONS(9123),
    [sym__automatic_semicolon] = ACTIONS(9123),
    [anon_sym_RBRACE] = ACTIONS(9123),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9123),
    [anon_sym_PIPE] = ACTIONS(9121),
    [anon_sym_COMMA] = ACTIONS(9123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(9123),
  },
  [4483] = {
    [sym_union_type] = STATE(4753),
    [sym__type] = STATE(4753),
    [sym_constructor_type] = STATE(4753),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2801),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4753),
    [sym_function_type] = STATE(4753),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2802),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2183),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5869),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5871),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4484] = {
    [anon_sym_EQ] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(7401),
    [anon_sym_PIPE] = ACTIONS(7403),
    [sym_comment] = ACTIONS(3),
  },
  [4485] = {
    [anon_sym_EQ] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(7401),
    [anon_sym_PIPE] = ACTIONS(7403),
    [sym_comment] = ACTIONS(3),
  },
  [4486] = {
    [anon_sym_EQ_GT] = ACTIONS(9516),
    [sym_comment] = ACTIONS(3),
  },
  [4487] = {
    [sym_union_type] = STATE(4755),
    [sym__type] = STATE(4755),
    [sym_constructor_type] = STATE(4755),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3548),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4755),
    [sym_function_type] = STATE(4755),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3549),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(7409),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(7411),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(7413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4488] = {
    [sym_union_type] = STATE(4756),
    [sym__type] = STATE(4756),
    [sym_constructor_type] = STATE(4756),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3548),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4756),
    [sym_function_type] = STATE(4756),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3549),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(7409),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(7411),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(7413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4489] = {
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(8483),
    [anon_sym_PIPE] = ACTIONS(8485),
    [anon_sym_RBRACK] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
  },
  [4490] = {
    [anon_sym_AMP] = ACTIONS(5881),
    [anon_sym_PIPE] = ACTIONS(5883),
    [anon_sym_RBRACK] = ACTIONS(8547),
    [sym_comment] = ACTIONS(3),
  },
  [4491] = {
    [anon_sym_GT] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(5895),
    [anon_sym_PIPE] = ACTIONS(5897),
    [anon_sym_COMMA] = ACTIONS(8547),
    [sym_comment] = ACTIONS(3),
  },
  [4492] = {
    [sym__automatic_semicolon] = ACTIONS(9251),
    [anon_sym_RBRACE] = ACTIONS(9251),
    [anon_sym_SEMI] = ACTIONS(9251),
    [anon_sym_COMMA] = ACTIONS(9251),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9251),
    [sym_comment] = ACTIONS(3),
  },
  [4493] = {
    [sym_type_parameters] = STATE(1082),
    [sym_formal_parameters] = STATE(1081),
    [sym_call_signature] = STATE(4757),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4494] = {
    [sym__automatic_semicolon] = ACTIONS(6154),
    [anon_sym_RBRACE] = ACTIONS(6154),
    [anon_sym_SEMI] = ACTIONS(6154),
    [anon_sym_COMMA] = ACTIONS(6154),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6154),
    [sym_comment] = ACTIONS(3),
  },
  [4495] = {
    [sym_computed_property_name] = STATE(1172),
    [sym__enum_member] = STATE(2939),
    [sym__property_name] = STATE(1172),
    [sym_string] = STATE(1172),
    [sym_enum_assignment] = STATE(2939),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACE] = ACTIONS(9518),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(2431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_async] = ACTIONS(1230),
  },
  [4496] = {
    [sym__automatic_semicolon] = ACTIONS(6162),
    [anon_sym_RBRACE] = ACTIONS(6162),
    [anon_sym_SEMI] = ACTIONS(6162),
    [anon_sym_COMMA] = ACTIONS(6162),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6162),
    [sym_comment] = ACTIONS(3),
  },
  [4497] = {
    [aux_sym_enum_body_repeat1] = STATE(2941),
    [anon_sym_COMMA] = ACTIONS(9520),
    [anon_sym_RBRACE] = ACTIONS(9518),
    [sym_comment] = ACTIONS(3),
  },
  [4498] = {
    [sym_union_type] = STATE(4760),
    [sym__type] = STATE(4760),
    [sym_constructor_type] = STATE(4760),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2864),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4760),
    [sym_function_type] = STATE(4760),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2865),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5967),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5971),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5973),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4499] = {
    [sym__automatic_semicolon] = ACTIONS(6196),
    [anon_sym_RBRACE] = ACTIONS(6196),
    [anon_sym_SEMI] = ACTIONS(6196),
    [anon_sym_COMMA] = ACTIONS(6196),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6196),
    [sym_comment] = ACTIONS(3),
  },
  [4500] = {
    [sym_class_body] = STATE(4761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(322),
  },
  [4501] = {
    [sym__automatic_semicolon] = ACTIONS(6208),
    [anon_sym_RBRACE] = ACTIONS(6208),
    [anon_sym_SEMI] = ACTIONS(6208),
    [anon_sym_COMMA] = ACTIONS(6208),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6208),
    [sym_comment] = ACTIONS(3),
  },
  [4502] = {
    [sym__automatic_semicolon] = ACTIONS(9522),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_PIPE] = ACTIONS(4447),
    [anon_sym_SEMI] = ACTIONS(9522),
    [sym_comment] = ACTIONS(3),
  },
  [4503] = {
    [sym__automatic_semicolon] = ACTIONS(6216),
    [anon_sym_RBRACE] = ACTIONS(6216),
    [anon_sym_SEMI] = ACTIONS(6216),
    [anon_sym_COMMA] = ACTIONS(6216),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6216),
    [sym_comment] = ACTIONS(3),
  },
  [4504] = {
    [sym__automatic_semicolon] = ACTIONS(6951),
    [anon_sym_RBRACE] = ACTIONS(6951),
    [anon_sym_SEMI] = ACTIONS(6951),
    [anon_sym_COMMA] = ACTIONS(6951),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6951),
    [sym_comment] = ACTIONS(3),
  },
  [4505] = {
    [sym_formal_parameters] = STATE(4763),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4506] = {
    [anon_sym_EQ_GT] = ACTIONS(9524),
    [sym_comment] = ACTIONS(3),
  },
  [4507] = {
    [sym_union_type] = STATE(2790),
    [sym__type] = STATE(2790),
    [sym_constructor_type] = STATE(2790),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4147),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2790),
    [sym_function_type] = STATE(2790),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4148),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5967),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8527),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8529),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4508] = {
    [sym_union_type] = STATE(2791),
    [sym__type] = STATE(2791),
    [sym_constructor_type] = STATE(2791),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4147),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2791),
    [sym_function_type] = STATE(2791),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4148),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5967),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8527),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8529),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4509] = {
    [anon_sym_EQ_GT] = ACTIONS(9526),
    [sym_comment] = ACTIONS(3),
  },
  [4510] = {
    [sym_union_type] = STATE(4766),
    [sym__type] = STATE(4766),
    [sym_constructor_type] = STATE(4766),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4147),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4766),
    [sym_function_type] = STATE(4766),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4148),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5967),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8527),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8529),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4511] = {
    [sym_union_type] = STATE(4767),
    [sym__type] = STATE(4767),
    [sym_constructor_type] = STATE(4767),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2864),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4767),
    [sym_function_type] = STATE(4767),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2865),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5967),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(5971),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(5973),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(5975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4512] = {
    [sym__automatic_semicolon] = ACTIONS(7511),
    [anon_sym_RBRACE] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(7479),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(7481),
    [anon_sym_COMMA] = ACTIONS(7511),
    [sym_comment] = ACTIONS(3),
  },
  [4513] = {
    [sym__automatic_semicolon] = ACTIONS(7529),
    [anon_sym_RBRACE] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(7479),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(7481),
    [anon_sym_COMMA] = ACTIONS(7529),
    [sym_comment] = ACTIONS(3),
  },
  [4514] = {
    [sym_type_parameters] = STATE(1082),
    [sym_formal_parameters] = STATE(1081),
    [sym_call_signature] = STATE(4757),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(9528),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [4515] = {
    [sym__automatic_semicolon] = ACTIONS(9530),
    [anon_sym_RBRACE] = ACTIONS(9530),
    [anon_sym_SEMI] = ACTIONS(9530),
    [anon_sym_COMMA] = ACTIONS(9530),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9530),
    [sym_comment] = ACTIONS(3),
  },
  [4516] = {
    [sym_union_type] = STATE(4769),
    [sym__type] = STATE(4769),
    [sym_constructor_type] = STATE(4769),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2873),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4769),
    [sym_function_type] = STATE(4769),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2874),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(2238),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(5983),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(5985),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(5987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4517] = {
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_COMMA] = ACTIONS(7511),
    [anon_sym_RBRACK] = ACTIONS(7511),
    [sym_comment] = ACTIONS(3),
  },
  [4518] = {
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_COMMA] = ACTIONS(7529),
    [anon_sym_RBRACK] = ACTIONS(7529),
    [sym_comment] = ACTIONS(3),
  },
  [4519] = {
    [sym_union_type] = STATE(4770),
    [sym__type] = STATE(4770),
    [sym_constructor_type] = STATE(4770),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(2888),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4770),
    [sym_function_type] = STATE(4770),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(2889),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3220),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(2278),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6001),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6003),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6005),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4520] = {
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_RPAREN] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(7513),
    [anon_sym_PIPE] = ACTIONS(7515),
    [sym_comment] = ACTIONS(3),
  },
  [4521] = {
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_RPAREN] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(7513),
    [anon_sym_PIPE] = ACTIONS(7515),
    [sym_comment] = ACTIONS(3),
  },
  [4522] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(9071),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(8553),
    [anon_sym_COMMA] = ACTIONS(8547),
    [anon_sym_LT_LT] = ACTIONS(8547),
    [anon_sym_STAR] = ACTIONS(9071),
    [anon_sym_GT_GT_GT] = ACTIONS(8547),
    [anon_sym_AMP_AMP] = ACTIONS(8547),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_BANG_EQ] = ACTIONS(9071),
    [anon_sym_LT_EQ] = ACTIONS(8547),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [anon_sym_GT_EQ] = ACTIONS(8547),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_AMP] = ACTIONS(8555),
    [anon_sym_PERCENT] = ACTIONS(8547),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_as] = ACTIONS(8547),
    [anon_sym_PIPE_PIPE] = ACTIONS(8547),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_EQ_EQ] = ACTIONS(9071),
    [anon_sym_RPAREN] = ACTIONS(8547),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_instanceof] = ACTIONS(8547),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8547),
    [anon_sym_CARET] = ACTIONS(8547),
    [anon_sym_STAR_STAR] = ACTIONS(8547),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_GT_GT] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8547),
    [anon_sym_in] = ACTIONS(9071),
  },
  [4523] = {
    [sym_union_type] = STATE(4771),
    [sym__type] = STATE(4771),
    [sym_constructor_type] = STATE(4771),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(2928),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4771),
    [sym_function_type] = STATE(4771),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(2929),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(6124),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(6130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(6128),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(6132),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(6126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4524] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_BANG] = ACTIONS(8379),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(9157),
    [anon_sym_COMMA] = ACTIONS(7511),
    [anon_sym_LT_LT] = ACTIONS(7511),
    [anon_sym_STAR] = ACTIONS(8379),
    [anon_sym_LBRACE] = ACTIONS(8379),
    [anon_sym_AMP_AMP] = ACTIONS(7511),
    [anon_sym_GT_GT_GT] = ACTIONS(7511),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_BANG_EQ] = ACTIONS(8379),
    [anon_sym_LT_EQ] = ACTIONS(7511),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [anon_sym_GT_EQ] = ACTIONS(7511),
    [anon_sym_GT] = ACTIONS(8379),
    [anon_sym_AMP] = ACTIONS(9159),
    [anon_sym_PERCENT] = ACTIONS(7511),
    [anon_sym_QMARK] = ACTIONS(7511),
    [anon_sym_LBRACE_PIPE] = ACTIONS(7511),
    [anon_sym_as] = ACTIONS(7511),
    [anon_sym_PIPE_PIPE] = ACTIONS(7511),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_EQ_EQ] = ACTIONS(8379),
    [anon_sym_instanceof] = ACTIONS(7511),
    [anon_sym_LT] = ACTIONS(8379),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7511),
    [anon_sym_CARET] = ACTIONS(7511),
    [anon_sym_STAR_STAR] = ACTIONS(7511),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_GT_GT] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7511),
    [anon_sym_in] = ACTIONS(8379),
  },
  [4525] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_BANG] = ACTIONS(8381),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(9157),
    [anon_sym_COMMA] = ACTIONS(7529),
    [anon_sym_LT_LT] = ACTIONS(7529),
    [anon_sym_STAR] = ACTIONS(8381),
    [anon_sym_LBRACE] = ACTIONS(8381),
    [anon_sym_AMP_AMP] = ACTIONS(7529),
    [anon_sym_GT_GT_GT] = ACTIONS(7529),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_BANG_EQ] = ACTIONS(8381),
    [anon_sym_LT_EQ] = ACTIONS(7529),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [anon_sym_GT_EQ] = ACTIONS(7529),
    [anon_sym_GT] = ACTIONS(8381),
    [anon_sym_AMP] = ACTIONS(9159),
    [anon_sym_PERCENT] = ACTIONS(7529),
    [anon_sym_QMARK] = ACTIONS(7529),
    [anon_sym_LBRACE_PIPE] = ACTIONS(7529),
    [anon_sym_as] = ACTIONS(7529),
    [anon_sym_PIPE_PIPE] = ACTIONS(7529),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_EQ_EQ] = ACTIONS(8381),
    [anon_sym_instanceof] = ACTIONS(7529),
    [anon_sym_LT] = ACTIONS(8381),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7529),
    [anon_sym_CARET] = ACTIONS(7529),
    [anon_sym_STAR_STAR] = ACTIONS(7529),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_GT_GT] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7529),
    [anon_sym_in] = ACTIONS(8381),
  },
  [4526] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9532),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4527] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9534),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4528] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9536),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4529] = {
    [sym_type_alias_declaration] = STATE(4210),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4210),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4210),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4210),
    [sym_return_statement] = STATE(4210),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4210),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4210),
    [sym_switch_statement] = STATE(4210),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4210),
    [sym_throw_statement] = STATE(4210),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4210),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4210),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(4210),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4210),
    [sym_abstract_class] = STATE(4210),
    [sym_interface_declaration] = STATE(4210),
    [sym_statement_block] = STATE(4210),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4210),
    [sym_debugger_statement] = STATE(4210),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4210),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4210),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4210),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4210),
    [sym_empty_statement] = STATE(4210),
    [sym_import_alias] = STATE(4210),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4210),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4210),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4210),
    [sym_break_statement] = STATE(4210),
    [sym_labeled_statement] = STATE(4210),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4210),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [4530] = {
    [sym_type_alias_declaration] = STATE(4211),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4211),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4211),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4211),
    [sym_return_statement] = STATE(4211),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4211),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4211),
    [sym_switch_statement] = STATE(4211),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4211),
    [sym_throw_statement] = STATE(4211),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4211),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4211),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(4211),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4211),
    [sym_abstract_class] = STATE(4211),
    [sym_interface_declaration] = STATE(4211),
    [sym_statement_block] = STATE(4211),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4211),
    [sym_debugger_statement] = STATE(4211),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4211),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4211),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4211),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4211),
    [sym_empty_statement] = STATE(4211),
    [sym_import_alias] = STATE(4211),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4211),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4211),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4211),
    [sym_break_statement] = STATE(4211),
    [sym_labeled_statement] = STATE(4211),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4211),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [4531] = {
    [sym_type_alias_declaration] = STATE(4212),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4212),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4212),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4212),
    [sym_return_statement] = STATE(4212),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4212),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4212),
    [sym_switch_statement] = STATE(4212),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4212),
    [sym_throw_statement] = STATE(4212),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4212),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4212),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(4212),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4212),
    [sym_abstract_class] = STATE(4212),
    [sym_interface_declaration] = STATE(4212),
    [sym_statement_block] = STATE(4212),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4212),
    [sym_debugger_statement] = STATE(4212),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4212),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4212),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4212),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4212),
    [sym_empty_statement] = STATE(4212),
    [sym_import_alias] = STATE(4212),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4212),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4212),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4212),
    [sym_break_statement] = STATE(4212),
    [sym_labeled_statement] = STATE(4212),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4212),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [4532] = {
    [sym_type_alias_declaration] = STATE(4235),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4235),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4235),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4235),
    [sym_return_statement] = STATE(4235),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4235),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4235),
    [sym_switch_statement] = STATE(4235),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4235),
    [sym_throw_statement] = STATE(4235),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4235),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4235),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(4235),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4235),
    [sym_abstract_class] = STATE(4235),
    [sym_interface_declaration] = STATE(4235),
    [sym_statement_block] = STATE(4235),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4235),
    [sym_debugger_statement] = STATE(4235),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4235),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4235),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4235),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4235),
    [sym_empty_statement] = STATE(4235),
    [sym_import_alias] = STATE(4235),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4235),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4235),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4235),
    [sym_break_statement] = STATE(4235),
    [sym_labeled_statement] = STATE(4235),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4235),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [4533] = {
    [sym_type_alias_declaration] = STATE(4236),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4236),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4236),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4236),
    [sym_return_statement] = STATE(4236),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4236),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4236),
    [sym_switch_statement] = STATE(4236),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4236),
    [sym_throw_statement] = STATE(4236),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4236),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4236),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(4236),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4236),
    [sym_abstract_class] = STATE(4236),
    [sym_interface_declaration] = STATE(4236),
    [sym_statement_block] = STATE(4236),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4236),
    [sym_debugger_statement] = STATE(4236),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4236),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4236),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4236),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4236),
    [sym_empty_statement] = STATE(4236),
    [sym_import_alias] = STATE(4236),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4236),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4236),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4236),
    [sym_break_statement] = STATE(4236),
    [sym_labeled_statement] = STATE(4236),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4236),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [4534] = {
    [sym_type_alias_declaration] = STATE(4237),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4237),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4237),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4237),
    [sym_return_statement] = STATE(4237),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4237),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4237),
    [sym_switch_statement] = STATE(4237),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4237),
    [sym_throw_statement] = STATE(4237),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4237),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4237),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(4237),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4237),
    [sym_abstract_class] = STATE(4237),
    [sym_interface_declaration] = STATE(4237),
    [sym_statement_block] = STATE(4237),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4237),
    [sym_debugger_statement] = STATE(4237),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4237),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4237),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4237),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4237),
    [sym_empty_statement] = STATE(4237),
    [sym_import_alias] = STATE(4237),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4237),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4237),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4237),
    [sym_break_statement] = STATE(4237),
    [sym_labeled_statement] = STATE(4237),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4237),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [4535] = {
    [sym_union_type] = STATE(4775),
    [sym__type] = STATE(4775),
    [sym_constructor_type] = STATE(4775),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4200),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4775),
    [sym_function_type] = STATE(4775),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4201),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8615),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8619),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8621),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4536] = {
    [sym_formal_parameters] = STATE(4776),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4537] = {
    [anon_sym_EQ_GT] = ACTIONS(9538),
    [sym_comment] = ACTIONS(3),
  },
  [4538] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4200),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4201),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8615),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8619),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8621),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4539] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4200),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4201),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8615),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8619),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8621),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4540] = {
    [anon_sym_EQ_GT] = ACTIONS(9540),
    [sym_comment] = ACTIONS(3),
  },
  [4541] = {
    [sym_union_type] = STATE(4779),
    [sym__type] = STATE(4779),
    [sym_constructor_type] = STATE(4779),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4200),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4779),
    [sym_function_type] = STATE(4779),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4201),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8615),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8619),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8621),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4542] = {
    [sym_union_type] = STATE(4780),
    [sym__type] = STATE(4780),
    [sym_constructor_type] = STATE(4780),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(2964),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4780),
    [sym_function_type] = STATE(4780),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(2965),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(2469),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(2471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(6198),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(6202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4543] = {
    [sym__automatic_semicolon] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(7628),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(7630),
    [sym_comment] = ACTIONS(3),
  },
  [4544] = {
    [sym__automatic_semicolon] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(7628),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(7630),
    [sym_comment] = ACTIONS(3),
  },
  [4545] = {
    [sym_identifier] = ACTIONS(9542),
    [anon_sym_BQUOTE] = ACTIONS(9544),
    [anon_sym_debugger] = ACTIONS(9542),
    [anon_sym_symbol] = ACTIONS(9542),
    [anon_sym_AT] = ACTIONS(9544),
    [anon_sym_DASH] = ACTIONS(9542),
    [anon_sym_void] = ACTIONS(9542),
    [anon_sym_break] = ACTIONS(9542),
    [anon_sym_const] = ACTIONS(9542),
    [sym_super] = ACTIONS(9542),
    [anon_sym_return] = ACTIONS(9542),
    [anon_sym_private] = ACTIONS(9542),
    [anon_sym_get] = ACTIONS(9542),
    [anon_sym_RBRACE] = ACTIONS(9544),
    [anon_sym_interface] = ACTIONS(9542),
    [anon_sym_default] = ACTIONS(9542),
    [anon_sym_enum] = ACTIONS(9542),
    [anon_sym_delete] = ACTIONS(9542),
    [anon_sym_continue] = ACTIONS(9542),
    [anon_sym_DASH_DASH] = ACTIONS(9544),
    [anon_sym_if] = ACTIONS(9542),
    [anon_sym_this] = ACTIONS(9542),
    [anon_sym_yield] = ACTIONS(9542),
    [sym_true] = ACTIONS(9542),
    [anon_sym_throw] = ACTIONS(9542),
    [anon_sym_protected] = ACTIONS(9542),
    [anon_sym_abstract] = ACTIONS(9542),
    [anon_sym_set] = ACTIONS(9542),
    [anon_sym_type] = ACTIONS(9542),
    [anon_sym_import] = ACTIONS(9542),
    [anon_sym_namespace] = ACTIONS(9542),
    [anon_sym_PLUS_PLUS] = ACTIONS(9544),
    [anon_sym_await] = ACTIONS(9542),
    [anon_sym_DQUOTE] = ACTIONS(9544),
    [anon_sym_else] = ACTIONS(9542),
    [anon_sym_BANG] = ACTIONS(9544),
    [anon_sym_for] = ACTIONS(9542),
    [anon_sym_LBRACK] = ACTIONS(9544),
    [sym_false] = ACTIONS(9542),
    [anon_sym_SEMI] = ACTIONS(9544),
    [anon_sym_case] = ACTIONS(9542),
    [anon_sym_module] = ACTIONS(9542),
    [anon_sym_number] = ACTIONS(9542),
    [anon_sym_class] = ACTIONS(9542),
    [anon_sym_declare] = ACTIONS(9542),
    [anon_sym_typeof] = ACTIONS(9542),
    [anon_sym_LBRACE] = ACTIONS(9544),
    [anon_sym_switch] = ACTIONS(9542),
    [anon_sym_LPAREN] = ACTIONS(9544),
    [sym_null] = ACTIONS(9542),
    [anon_sym_any] = ACTIONS(9542),
    [anon_sym_boolean] = ACTIONS(9542),
    [anon_sym_async] = ACTIONS(9542),
    [anon_sym_public] = ACTIONS(9542),
    [anon_sym_var] = ACTIONS(9542),
    [anon_sym_while] = ACTIONS(9542),
    [anon_sym_SQUOTE] = ACTIONS(9544),
    [anon_sym_try] = ACTIONS(9542),
    [anon_sym_LT] = ACTIONS(9544),
    [sym_number] = ACTIONS(9544),
    [anon_sym_SLASH] = ACTIONS(9542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9542),
    [anon_sym_function] = ACTIONS(9542),
    [sym_undefined] = ACTIONS(9542),
    [anon_sym_new] = ACTIONS(9542),
    [ts_builtin_sym_end] = ACTIONS(9544),
    [anon_sym_let] = ACTIONS(9542),
    [anon_sym_PLUS] = ACTIONS(9542),
    [anon_sym_export] = ACTIONS(9542),
    [anon_sym_do] = ACTIONS(9542),
    [anon_sym_TILDE] = ACTIONS(9544),
    [anon_sym_with] = ACTIONS(9542),
  },
  [4546] = {
    [sym_identifier] = ACTIONS(9546),
    [anon_sym_BQUOTE] = ACTIONS(9548),
    [anon_sym_debugger] = ACTIONS(9546),
    [anon_sym_symbol] = ACTIONS(9546),
    [anon_sym_AT] = ACTIONS(9548),
    [anon_sym_DASH] = ACTIONS(9546),
    [anon_sym_void] = ACTIONS(9546),
    [anon_sym_break] = ACTIONS(9546),
    [anon_sym_const] = ACTIONS(9546),
    [sym_super] = ACTIONS(9546),
    [anon_sym_return] = ACTIONS(9546),
    [anon_sym_private] = ACTIONS(9546),
    [anon_sym_get] = ACTIONS(9546),
    [anon_sym_RBRACE] = ACTIONS(9548),
    [anon_sym_interface] = ACTIONS(9546),
    [anon_sym_default] = ACTIONS(9546),
    [anon_sym_enum] = ACTIONS(9546),
    [anon_sym_delete] = ACTIONS(9546),
    [anon_sym_continue] = ACTIONS(9546),
    [anon_sym_DASH_DASH] = ACTIONS(9548),
    [anon_sym_if] = ACTIONS(9546),
    [anon_sym_this] = ACTIONS(9546),
    [anon_sym_yield] = ACTIONS(9546),
    [sym_true] = ACTIONS(9546),
    [anon_sym_throw] = ACTIONS(9546),
    [anon_sym_protected] = ACTIONS(9546),
    [anon_sym_abstract] = ACTIONS(9546),
    [anon_sym_set] = ACTIONS(9546),
    [anon_sym_type] = ACTIONS(9546),
    [anon_sym_import] = ACTIONS(9546),
    [anon_sym_namespace] = ACTIONS(9546),
    [anon_sym_PLUS_PLUS] = ACTIONS(9548),
    [anon_sym_await] = ACTIONS(9546),
    [anon_sym_DQUOTE] = ACTIONS(9548),
    [anon_sym_else] = ACTIONS(9546),
    [anon_sym_BANG] = ACTIONS(9548),
    [anon_sym_for] = ACTIONS(9546),
    [anon_sym_LBRACK] = ACTIONS(9548),
    [sym_false] = ACTIONS(9546),
    [anon_sym_SEMI] = ACTIONS(9548),
    [anon_sym_case] = ACTIONS(9546),
    [anon_sym_module] = ACTIONS(9546),
    [anon_sym_number] = ACTIONS(9546),
    [anon_sym_class] = ACTIONS(9546),
    [anon_sym_declare] = ACTIONS(9546),
    [anon_sym_typeof] = ACTIONS(9546),
    [anon_sym_LBRACE] = ACTIONS(9548),
    [anon_sym_switch] = ACTIONS(9546),
    [anon_sym_LPAREN] = ACTIONS(9548),
    [sym_null] = ACTIONS(9546),
    [anon_sym_any] = ACTIONS(9546),
    [anon_sym_boolean] = ACTIONS(9546),
    [anon_sym_async] = ACTIONS(9546),
    [anon_sym_public] = ACTIONS(9546),
    [anon_sym_var] = ACTIONS(9546),
    [anon_sym_while] = ACTIONS(9546),
    [anon_sym_SQUOTE] = ACTIONS(9548),
    [anon_sym_try] = ACTIONS(9546),
    [anon_sym_LT] = ACTIONS(9548),
    [sym_number] = ACTIONS(9548),
    [anon_sym_SLASH] = ACTIONS(9546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9546),
    [anon_sym_function] = ACTIONS(9546),
    [sym_undefined] = ACTIONS(9546),
    [anon_sym_new] = ACTIONS(9546),
    [ts_builtin_sym_end] = ACTIONS(9548),
    [anon_sym_let] = ACTIONS(9546),
    [anon_sym_PLUS] = ACTIONS(9546),
    [anon_sym_export] = ACTIONS(9546),
    [anon_sym_do] = ACTIONS(9546),
    [anon_sym_TILDE] = ACTIONS(9548),
    [anon_sym_with] = ACTIONS(9546),
  },
  [4547] = {
    [sym_identifier] = ACTIONS(9550),
    [anon_sym_BQUOTE] = ACTIONS(9552),
    [anon_sym_debugger] = ACTIONS(9550),
    [anon_sym_symbol] = ACTIONS(9550),
    [anon_sym_AT] = ACTIONS(9552),
    [anon_sym_DASH] = ACTIONS(9550),
    [anon_sym_void] = ACTIONS(9550),
    [anon_sym_break] = ACTIONS(9550),
    [anon_sym_const] = ACTIONS(9550),
    [sym_super] = ACTIONS(9550),
    [anon_sym_return] = ACTIONS(9550),
    [anon_sym_private] = ACTIONS(9550),
    [anon_sym_get] = ACTIONS(9550),
    [anon_sym_RBRACE] = ACTIONS(9552),
    [anon_sym_interface] = ACTIONS(9550),
    [anon_sym_default] = ACTIONS(9550),
    [anon_sym_enum] = ACTIONS(9550),
    [anon_sym_delete] = ACTIONS(9550),
    [anon_sym_continue] = ACTIONS(9550),
    [anon_sym_DASH_DASH] = ACTIONS(9552),
    [anon_sym_if] = ACTIONS(9550),
    [anon_sym_this] = ACTIONS(9550),
    [anon_sym_yield] = ACTIONS(9550),
    [sym_true] = ACTIONS(9550),
    [anon_sym_throw] = ACTIONS(9550),
    [anon_sym_protected] = ACTIONS(9550),
    [anon_sym_abstract] = ACTIONS(9550),
    [anon_sym_set] = ACTIONS(9550),
    [anon_sym_type] = ACTIONS(9550),
    [anon_sym_import] = ACTIONS(9550),
    [anon_sym_namespace] = ACTIONS(9550),
    [anon_sym_PLUS_PLUS] = ACTIONS(9552),
    [anon_sym_await] = ACTIONS(9550),
    [anon_sym_DQUOTE] = ACTIONS(9552),
    [anon_sym_else] = ACTIONS(9550),
    [anon_sym_BANG] = ACTIONS(9552),
    [anon_sym_for] = ACTIONS(9550),
    [anon_sym_LBRACK] = ACTIONS(9552),
    [sym_false] = ACTIONS(9550),
    [anon_sym_SEMI] = ACTIONS(9552),
    [anon_sym_case] = ACTIONS(9550),
    [anon_sym_module] = ACTIONS(9550),
    [anon_sym_number] = ACTIONS(9550),
    [anon_sym_class] = ACTIONS(9550),
    [anon_sym_declare] = ACTIONS(9550),
    [anon_sym_typeof] = ACTIONS(9550),
    [anon_sym_LBRACE] = ACTIONS(9552),
    [anon_sym_switch] = ACTIONS(9550),
    [anon_sym_LPAREN] = ACTIONS(9552),
    [sym_null] = ACTIONS(9550),
    [anon_sym_any] = ACTIONS(9550),
    [anon_sym_boolean] = ACTIONS(9550),
    [anon_sym_async] = ACTIONS(9550),
    [anon_sym_public] = ACTIONS(9550),
    [anon_sym_var] = ACTIONS(9550),
    [anon_sym_while] = ACTIONS(9550),
    [anon_sym_SQUOTE] = ACTIONS(9552),
    [anon_sym_try] = ACTIONS(9550),
    [anon_sym_LT] = ACTIONS(9552),
    [sym_number] = ACTIONS(9552),
    [anon_sym_SLASH] = ACTIONS(9550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9550),
    [anon_sym_function] = ACTIONS(9550),
    [sym_undefined] = ACTIONS(9550),
    [anon_sym_new] = ACTIONS(9550),
    [ts_builtin_sym_end] = ACTIONS(9552),
    [anon_sym_let] = ACTIONS(9550),
    [anon_sym_PLUS] = ACTIONS(9550),
    [anon_sym_export] = ACTIONS(9550),
    [anon_sym_do] = ACTIONS(9550),
    [anon_sym_TILDE] = ACTIONS(9552),
    [anon_sym_with] = ACTIONS(9550),
  },
  [4548] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7695),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(7181),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(7181),
    [anon_sym_PIPE] = ACTIONS(7697),
    [anon_sym_COMMA] = ACTIONS(7181),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(7699),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6261),
    [anon_sym_LT_EQ] = ACTIONS(7695),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(7695),
    [anon_sym_GT] = ACTIONS(6261),
    [anon_sym_AMP] = ACTIONS(7701),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(7703),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(7705),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(6261),
    [anon_sym_RPAREN] = ACTIONS(7181),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_instanceof] = ACTIONS(7695),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(7705),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7695),
    [anon_sym_in] = ACTIONS(6261),
  },
  [4549] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(7192),
    [anon_sym_SEMI] = ACTIONS(5893),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [sym__automatic_semicolon] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(9554),
    [anon_sym_COMMA] = ACTIONS(5893),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_GT_GT_GT] = ACTIONS(5893),
    [anon_sym_AMP_AMP] = ACTIONS(5893),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_BANG_EQ] = ACTIONS(7192),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(9556),
    [anon_sym_PERCENT] = ACTIONS(5893),
    [anon_sym_QMARK] = ACTIONS(5893),
    [anon_sym_as] = ACTIONS(5893),
    [anon_sym_PIPE_PIPE] = ACTIONS(5893),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_EQ_EQ] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5893),
    [anon_sym_CARET] = ACTIONS(5893),
    [anon_sym_STAR_STAR] = ACTIONS(5893),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_in] = ACTIONS(7192),
  },
  [4550] = {
    [anon_sym_EQ_GT] = ACTIONS(9558),
    [sym_comment] = ACTIONS(3),
  },
  [4551] = {
    [sym_union_type] = STATE(4782),
    [sym__type] = STATE(4782),
    [sym_constructor_type] = STATE(4782),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(3696),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(4782),
    [sym_function_type] = STATE(4782),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(3697),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(7727),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(7733),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(7731),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(7735),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(7729),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [4552] = {
    [sym_union_type] = STATE(4783),
    [sym__type] = STATE(4783),
    [sym_constructor_type] = STATE(4783),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(3696),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(4783),
    [sym_function_type] = STATE(4783),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(3697),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(7727),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(7733),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(7731),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(7735),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(7729),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [4553] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_BANG] = ACTIONS(7208),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [sym__automatic_semicolon] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(9554),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_LT_LT] = ACTIONS(6040),
    [anon_sym_STAR] = ACTIONS(7208),
    [anon_sym_GT_GT_GT] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(6040),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_BANG_EQ] = ACTIONS(7208),
    [anon_sym_LT_EQ] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [anon_sym_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_AMP] = ACTIONS(9556),
    [anon_sym_PERCENT] = ACTIONS(6040),
    [anon_sym_QMARK] = ACTIONS(6040),
    [anon_sym_as] = ACTIONS(6040),
    [anon_sym_PIPE_PIPE] = ACTIONS(6040),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_RPAREN] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_instanceof] = ACTIONS(6040),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6040),
    [anon_sym_CARET] = ACTIONS(6040),
    [anon_sym_STAR_STAR] = ACTIONS(6040),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6040),
    [anon_sym_in] = ACTIONS(7208),
  },
  [4554] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_RPAREN] = ACTIONS(7181),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_in] = ACTIONS(6321),
  },
  [4555] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(7192),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(9560),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_GT_GT_GT] = ACTIONS(5893),
    [anon_sym_AMP_AMP] = ACTIONS(5893),
    [anon_sym_BANG_EQ] = ACTIONS(7192),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(9562),
    [anon_sym_PERCENT] = ACTIONS(5893),
    [anon_sym_QMARK] = ACTIONS(5893),
    [anon_sym_as] = ACTIONS(5893),
    [anon_sym_PIPE_PIPE] = ACTIONS(5893),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_EQ_EQ] = ACTIONS(7192),
    [anon_sym_RPAREN] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(5893),
    [anon_sym_CARET] = ACTIONS(5893),
    [anon_sym_STAR_STAR] = ACTIONS(5893),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_in] = ACTIONS(7192),
  },
  [4556] = {
    [anon_sym_EQ_GT] = ACTIONS(9564),
    [sym_comment] = ACTIONS(3),
  },
  [4557] = {
    [sym_union_type] = STATE(4785),
    [sym__type] = STATE(4785),
    [sym_constructor_type] = STATE(4785),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3724),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4785),
    [sym_function_type] = STATE(4785),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3725),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(7804),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(7810),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(7808),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(7812),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(7806),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4558] = {
    [sym_union_type] = STATE(4786),
    [sym__type] = STATE(4786),
    [sym_constructor_type] = STATE(4786),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3724),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4786),
    [sym_function_type] = STATE(4786),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3725),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(7804),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(7810),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(7808),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(7812),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(7806),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4559] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_BANG] = ACTIONS(7208),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(9560),
    [anon_sym_LT_LT] = ACTIONS(6040),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_STAR] = ACTIONS(7208),
    [anon_sym_GT_GT_GT] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(6040),
    [anon_sym_BANG_EQ] = ACTIONS(7208),
    [anon_sym_LT_EQ] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [anon_sym_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_AMP] = ACTIONS(9562),
    [anon_sym_PERCENT] = ACTIONS(6040),
    [anon_sym_QMARK] = ACTIONS(6040),
    [anon_sym_as] = ACTIONS(6040),
    [anon_sym_PIPE_PIPE] = ACTIONS(6040),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_RPAREN] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_instanceof] = ACTIONS(6040),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(6040),
    [anon_sym_CARET] = ACTIONS(6040),
    [anon_sym_STAR_STAR] = ACTIONS(6040),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6040),
    [anon_sym_in] = ACTIONS(7208),
  },
  [4560] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(9123),
    [anon_sym_LBRACK] = ACTIONS(9123),
    [anon_sym_BANG] = ACTIONS(9121),
    [anon_sym_BQUOTE] = ACTIONS(9123),
    [anon_sym_PIPE] = ACTIONS(9121),
    [anon_sym_COMMA] = ACTIONS(9123),
    [anon_sym_LT_LT] = ACTIONS(9123),
    [anon_sym_STAR] = ACTIONS(9121),
    [anon_sym_GT_GT_GT] = ACTIONS(9123),
    [anon_sym_AMP_AMP] = ACTIONS(9123),
    [anon_sym_DASH] = ACTIONS(9121),
    [anon_sym_LBRACE] = ACTIONS(9121),
    [anon_sym_BANG_EQ] = ACTIONS(9121),
    [anon_sym_LT_EQ] = ACTIONS(9123),
    [anon_sym_LPAREN] = ACTIONS(9123),
    [anon_sym_RBRACK] = ACTIONS(9123),
    [anon_sym_GT_EQ] = ACTIONS(9123),
    [anon_sym_GT] = ACTIONS(9121),
    [anon_sym_AMP] = ACTIONS(9121),
    [anon_sym_PERCENT] = ACTIONS(9123),
    [anon_sym_QMARK] = ACTIONS(9123),
    [anon_sym_RBRACE] = ACTIONS(9123),
    [anon_sym_as] = ACTIONS(9123),
    [anon_sym_PIPE_PIPE] = ACTIONS(9123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(9123),
    [anon_sym_DASH_DASH] = ACTIONS(9123),
    [anon_sym_EQ_EQ] = ACTIONS(9121),
    [anon_sym_instanceof] = ACTIONS(9123),
    [anon_sym_LT] = ACTIONS(9121),
    [anon_sym_RPAREN] = ACTIONS(9123),
    [anon_sym_SLASH] = ACTIONS(9121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(9123),
    [anon_sym_DOT] = ACTIONS(9123),
    [anon_sym_CARET] = ACTIONS(9123),
    [anon_sym_STAR_STAR] = ACTIONS(9123),
    [anon_sym_PLUS] = ACTIONS(9121),
    [anon_sym_implements] = ACTIONS(9123),
    [anon_sym_GT_GT] = ACTIONS(9121),
    [anon_sym_PLUS_PLUS] = ACTIONS(9123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9123),
    [anon_sym_in] = ACTIONS(9121),
  },
  [4561] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(9071),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(8709),
    [anon_sym_COMMA] = ACTIONS(8547),
    [anon_sym_LT_LT] = ACTIONS(8547),
    [anon_sym_STAR] = ACTIONS(9071),
    [anon_sym_LBRACE] = ACTIONS(8547),
    [anon_sym_AMP_AMP] = ACTIONS(8547),
    [anon_sym_GT_GT_GT] = ACTIONS(8547),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_BANG_EQ] = ACTIONS(9071),
    [anon_sym_LT_EQ] = ACTIONS(8547),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [anon_sym_GT_EQ] = ACTIONS(8547),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_AMP] = ACTIONS(8711),
    [anon_sym_PERCENT] = ACTIONS(8547),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_as] = ACTIONS(8547),
    [anon_sym_PIPE_PIPE] = ACTIONS(8547),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_EQ_EQ] = ACTIONS(9071),
    [anon_sym_instanceof] = ACTIONS(8547),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8547),
    [anon_sym_CARET] = ACTIONS(8547),
    [anon_sym_STAR_STAR] = ACTIONS(8547),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_implements] = ACTIONS(8547),
    [anon_sym_GT_GT] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8547),
    [anon_sym_in] = ACTIONS(9071),
  },
  [4562] = {
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(6482),
    [anon_sym_PIPE] = ACTIONS(6484),
    [anon_sym_COMMA] = ACTIONS(8547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8547),
  },
  [4563] = {
    [sym_union_type] = STATE(4787),
    [sym__type] = STATE(4787),
    [sym_constructor_type] = STATE(4787),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3121),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4787),
    [sym_function_type] = STATE(4787),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3122),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(6550),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(6556),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(6554),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(6558),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(6552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4564] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_BANG] = ACTIONS(8379),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(9243),
    [anon_sym_LT_LT] = ACTIONS(7511),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_STAR] = ACTIONS(8379),
    [anon_sym_GT_GT_GT] = ACTIONS(7511),
    [anon_sym_AMP_AMP] = ACTIONS(7511),
    [anon_sym_BANG_EQ] = ACTIONS(8379),
    [anon_sym_LT_EQ] = ACTIONS(7511),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [anon_sym_RBRACK] = ACTIONS(7511),
    [anon_sym_GT_EQ] = ACTIONS(7511),
    [anon_sym_GT] = ACTIONS(8379),
    [anon_sym_AMP] = ACTIONS(9245),
    [anon_sym_PERCENT] = ACTIONS(7511),
    [anon_sym_QMARK] = ACTIONS(7511),
    [anon_sym_as] = ACTIONS(7511),
    [anon_sym_PIPE_PIPE] = ACTIONS(7511),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_EQ_EQ] = ACTIONS(8379),
    [anon_sym_instanceof] = ACTIONS(7511),
    [anon_sym_LT] = ACTIONS(8379),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7511),
    [anon_sym_CARET] = ACTIONS(7511),
    [anon_sym_STAR_STAR] = ACTIONS(7511),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_GT_GT] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7511),
    [anon_sym_in] = ACTIONS(8379),
  },
  [4565] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_BANG] = ACTIONS(8381),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(9243),
    [anon_sym_LT_LT] = ACTIONS(7529),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_STAR] = ACTIONS(8381),
    [anon_sym_GT_GT_GT] = ACTIONS(7529),
    [anon_sym_AMP_AMP] = ACTIONS(7529),
    [anon_sym_BANG_EQ] = ACTIONS(8381),
    [anon_sym_LT_EQ] = ACTIONS(7529),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [anon_sym_RBRACK] = ACTIONS(7529),
    [anon_sym_GT_EQ] = ACTIONS(7529),
    [anon_sym_GT] = ACTIONS(8381),
    [anon_sym_AMP] = ACTIONS(9245),
    [anon_sym_PERCENT] = ACTIONS(7529),
    [anon_sym_QMARK] = ACTIONS(7529),
    [anon_sym_as] = ACTIONS(7529),
    [anon_sym_PIPE_PIPE] = ACTIONS(7529),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_EQ_EQ] = ACTIONS(8381),
    [anon_sym_instanceof] = ACTIONS(7529),
    [anon_sym_LT] = ACTIONS(8381),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7529),
    [anon_sym_CARET] = ACTIONS(7529),
    [anon_sym_STAR_STAR] = ACTIONS(7529),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_GT_GT] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7529),
    [anon_sym_in] = ACTIONS(8381),
  },
  [4566] = {
    [sym__automatic_semicolon] = ACTIONS(9289),
    [anon_sym_LBRACK] = ACTIONS(9289),
    [sym_identifier] = ACTIONS(9566),
    [anon_sym_SEMI] = ACTIONS(9289),
    [anon_sym_module] = ACTIONS(9566),
    [anon_sym_symbol] = ACTIONS(9566),
    [anon_sym_number] = ACTIONS(9566),
    [anon_sym_AT] = ACTIONS(9289),
    [anon_sym_declare] = ACTIONS(9566),
    [anon_sym_STAR] = ACTIONS(9289),
    [anon_sym_void] = ACTIONS(9566),
    [anon_sym_any] = ACTIONS(9566),
    [anon_sym_private] = ACTIONS(9566),
    [anon_sym_boolean] = ACTIONS(9566),
    [anon_sym_async] = ACTIONS(9566),
    [anon_sym_public] = ACTIONS(9566),
    [anon_sym_get] = ACTIONS(9566),
    [anon_sym_RBRACE] = ACTIONS(9289),
    [anon_sym_static] = ACTIONS(9566),
    [anon_sym_SQUOTE] = ACTIONS(9289),
    [sym_number] = ACTIONS(9289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(9566),
    [anon_sym_string] = ACTIONS(9566),
    [anon_sym_abstract] = ACTIONS(9566),
    [anon_sym_set] = ACTIONS(9566),
    [anon_sym_type] = ACTIONS(9566),
    [anon_sym_import] = ACTIONS(9566),
    [anon_sym_export] = ACTIONS(9566),
    [anon_sym_namespace] = ACTIONS(9566),
    [sym_readonly] = ACTIONS(9566),
    [anon_sym_DQUOTE] = ACTIONS(9289),
  },
  [4567] = {
    [sym_statement_block] = STATE(4788),
    [sym__automatic_semicolon] = ACTIONS(9568),
    [anon_sym_SEMI] = ACTIONS(9568),
    [anon_sym_COMMA] = ACTIONS(9568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4899),
  },
  [4568] = {
    [sym_union_type] = STATE(1892),
    [sym__type] = STATE(1892),
    [sym_constructor_type] = STATE(1892),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4572),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1892),
    [sym_function_type] = STATE(1892),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4573),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(7911),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(7913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(9255),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(9257),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(9259),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4569] = {
    [sym_type_parameters] = STATE(4789),
    [sym_formal_parameters] = STATE(4790),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4570] = {
    [sym_union_type] = STATE(1900),
    [sym__type] = STATE(1900),
    [sym_constructor_type] = STATE(1900),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4572),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1900),
    [sym_function_type] = STATE(1900),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4573),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(7911),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(7913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(9255),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(9257),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(9259),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4571] = {
    [sym__automatic_semicolon] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(9570),
    [anon_sym_SEMI] = ACTIONS(5893),
    [anon_sym_COMMA] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(9572),
    [sym_comment] = ACTIONS(3),
  },
  [4572] = {
    [sym_formal_parameters] = STATE(4793),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4573] = {
    [anon_sym_EQ_GT] = ACTIONS(9574),
    [sym_comment] = ACTIONS(3),
  },
  [4574] = {
    [anon_sym_EQ_GT] = ACTIONS(9576),
    [sym_comment] = ACTIONS(3),
  },
  [4575] = {
    [sym_union_type] = STATE(4796),
    [sym__type] = STATE(4796),
    [sym_constructor_type] = STATE(4796),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3793),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4796),
    [sym_function_type] = STATE(4796),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3794),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(7911),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(7913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(7915),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(7917),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(7919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4576] = {
    [sym_union_type] = STATE(4797),
    [sym__type] = STATE(4797),
    [sym_constructor_type] = STATE(4797),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3793),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4797),
    [sym_function_type] = STATE(4797),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3794),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(7911),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(7913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(7915),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(7917),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(7919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4577] = {
    [sym__automatic_semicolon] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(8737),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(8739),
    [sym_comment] = ACTIONS(3),
  },
  [4578] = {
    [sym_formal_parameters] = STATE(4798),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4579] = {
    [anon_sym_EQ_GT] = ACTIONS(9578),
    [sym_comment] = ACTIONS(3),
  },
  [4580] = {
    [sym_union_type] = STATE(2790),
    [sym__type] = STATE(2790),
    [sym_constructor_type] = STATE(2790),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4271),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2790),
    [sym_function_type] = STATE(2790),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4272),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(6598),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(6600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8743),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8745),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4581] = {
    [sym_union_type] = STATE(2791),
    [sym__type] = STATE(2791),
    [sym_constructor_type] = STATE(2791),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4271),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2791),
    [sym_function_type] = STATE(2791),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4272),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(6598),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(6600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8743),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8745),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4582] = {
    [anon_sym_EQ_GT] = ACTIONS(9580),
    [sym_comment] = ACTIONS(3),
  },
  [4583] = {
    [sym_union_type] = STATE(4801),
    [sym__type] = STATE(4801),
    [sym_constructor_type] = STATE(4801),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4271),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4801),
    [sym_function_type] = STATE(4801),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4272),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(6598),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(6600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8743),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8745),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4584] = {
    [sym_union_type] = STATE(4802),
    [sym__type] = STATE(4802),
    [sym_constructor_type] = STATE(4802),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3150),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4802),
    [sym_function_type] = STATE(4802),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3151),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(6598),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(6600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(6602),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(6604),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(6606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4585] = {
    [sym__automatic_semicolon] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(7923),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_COMMA] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(7925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7511),
  },
  [4586] = {
    [sym__automatic_semicolon] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(7923),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_COMMA] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(7925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7529),
  },
  [4587] = {
    [sym_type_parameters] = STATE(1395),
    [sym_formal_parameters] = STATE(1397),
    [sym_call_signature] = STATE(4803),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4588] = {
    [sym__automatic_semicolon] = ACTIONS(9582),
    [anon_sym_SEMI] = ACTIONS(9582),
    [anon_sym_COMMA] = ACTIONS(9582),
    [sym_comment] = ACTIONS(3),
  },
  [4589] = {
    [sym_identifier] = ACTIONS(4231),
    [anon_sym_BQUOTE] = ACTIONS(4229),
    [anon_sym_debugger] = ACTIONS(4231),
    [anon_sym_symbol] = ACTIONS(4231),
    [anon_sym_AT] = ACTIONS(4229),
    [anon_sym_PIPE] = ACTIONS(4229),
    [anon_sym_DASH] = ACTIONS(4231),
    [anon_sym_void] = ACTIONS(4231),
    [anon_sym_break] = ACTIONS(4231),
    [anon_sym_const] = ACTIONS(4231),
    [sym_super] = ACTIONS(4231),
    [anon_sym_return] = ACTIONS(4231),
    [anon_sym_private] = ACTIONS(4231),
    [anon_sym_get] = ACTIONS(4231),
    [anon_sym_RBRACE] = ACTIONS(4229),
    [anon_sym_interface] = ACTIONS(4231),
    [anon_sym_default] = ACTIONS(4231),
    [anon_sym_enum] = ACTIONS(4231),
    [anon_sym_delete] = ACTIONS(4231),
    [anon_sym_continue] = ACTIONS(4231),
    [anon_sym_DASH_DASH] = ACTIONS(4229),
    [anon_sym_if] = ACTIONS(4231),
    [anon_sym_this] = ACTIONS(4231),
    [anon_sym_yield] = ACTIONS(4231),
    [sym_true] = ACTIONS(4231),
    [anon_sym_throw] = ACTIONS(4231),
    [anon_sym_protected] = ACTIONS(4231),
    [anon_sym_abstract] = ACTIONS(4231),
    [anon_sym_set] = ACTIONS(4231),
    [anon_sym_type] = ACTIONS(4231),
    [anon_sym_import] = ACTIONS(4231),
    [anon_sym_namespace] = ACTIONS(4231),
    [anon_sym_PLUS_PLUS] = ACTIONS(4229),
    [anon_sym_await] = ACTIONS(4231),
    [anon_sym_DQUOTE] = ACTIONS(4229),
    [anon_sym_else] = ACTIONS(4231),
    [anon_sym_BANG] = ACTIONS(4229),
    [anon_sym_for] = ACTIONS(4231),
    [anon_sym_LBRACK] = ACTIONS(4229),
    [sym_false] = ACTIONS(4231),
    [anon_sym_SEMI] = ACTIONS(4229),
    [anon_sym_case] = ACTIONS(4231),
    [anon_sym_module] = ACTIONS(4231),
    [anon_sym_number] = ACTIONS(4231),
    [anon_sym_class] = ACTIONS(4231),
    [anon_sym_declare] = ACTIONS(4231),
    [anon_sym_typeof] = ACTIONS(4231),
    [anon_sym_LBRACE] = ACTIONS(4229),
    [anon_sym_switch] = ACTIONS(4231),
    [anon_sym_LPAREN] = ACTIONS(4229),
    [sym_null] = ACTIONS(4231),
    [anon_sym_any] = ACTIONS(4231),
    [anon_sym_boolean] = ACTIONS(4231),
    [anon_sym_async] = ACTIONS(4231),
    [anon_sym_public] = ACTIONS(4231),
    [anon_sym_AMP] = ACTIONS(4229),
    [anon_sym_var] = ACTIONS(4231),
    [anon_sym_while] = ACTIONS(4231),
    [anon_sym_SQUOTE] = ACTIONS(4229),
    [anon_sym_try] = ACTIONS(4231),
    [anon_sym_LT] = ACTIONS(4229),
    [sym_number] = ACTIONS(4229),
    [anon_sym_SLASH] = ACTIONS(4231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4231),
    [anon_sym_function] = ACTIONS(4231),
    [sym_undefined] = ACTIONS(4231),
    [anon_sym_new] = ACTIONS(4231),
    [ts_builtin_sym_end] = ACTIONS(4229),
    [anon_sym_let] = ACTIONS(4231),
    [anon_sym_PLUS] = ACTIONS(4231),
    [anon_sym_export] = ACTIONS(4231),
    [anon_sym_do] = ACTIONS(4231),
    [anon_sym_TILDE] = ACTIONS(4229),
    [anon_sym_with] = ACTIONS(4231),
  },
  [4590] = {
    [sym_union_type] = STATE(2014),
    [sym__type] = STATE(2014),
    [sym_constructor_type] = STATE(2014),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2014),
    [sym_function_type] = STATE(2014),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(9584),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_boolean] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_this] = ACTIONS(765),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [4591] = {
    [aux_sym_implements_clause_repeat1] = STATE(2016),
    [anon_sym_COMMA] = ACTIONS(9586),
    [anon_sym_GT] = ACTIONS(9584),
    [sym_comment] = ACTIONS(3),
  },
  [4592] = {
    [sym_union_type] = STATE(4806),
    [sym__type] = STATE(4806),
    [sym_constructor_type] = STATE(4806),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(3167),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4806),
    [sym_function_type] = STATE(4806),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3168),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(6624),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(6626),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6628),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6630),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4593] = {
    [sym_identifier] = ACTIONS(8379),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [anon_sym_debugger] = ACTIONS(8379),
    [anon_sym_symbol] = ACTIONS(8379),
    [anon_sym_AT] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(7950),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_void] = ACTIONS(8379),
    [anon_sym_break] = ACTIONS(8379),
    [anon_sym_const] = ACTIONS(8379),
    [sym_super] = ACTIONS(8379),
    [anon_sym_return] = ACTIONS(8379),
    [anon_sym_private] = ACTIONS(8379),
    [anon_sym_get] = ACTIONS(8379),
    [anon_sym_interface] = ACTIONS(8379),
    [anon_sym_enum] = ACTIONS(8379),
    [anon_sym_delete] = ACTIONS(8379),
    [anon_sym_continue] = ACTIONS(8379),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_if] = ACTIONS(8379),
    [anon_sym_this] = ACTIONS(8379),
    [anon_sym_yield] = ACTIONS(8379),
    [sym_true] = ACTIONS(8379),
    [anon_sym_throw] = ACTIONS(8379),
    [anon_sym_protected] = ACTIONS(8379),
    [anon_sym_abstract] = ACTIONS(8379),
    [anon_sym_set] = ACTIONS(8379),
    [anon_sym_type] = ACTIONS(8379),
    [anon_sym_import] = ACTIONS(8379),
    [anon_sym_namespace] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_await] = ACTIONS(8379),
    [anon_sym_DQUOTE] = ACTIONS(7511),
    [anon_sym_BANG] = ACTIONS(7511),
    [anon_sym_for] = ACTIONS(8379),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [sym_false] = ACTIONS(8379),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_module] = ACTIONS(8379),
    [anon_sym_number] = ACTIONS(8379),
    [anon_sym_class] = ACTIONS(8379),
    [anon_sym_declare] = ACTIONS(8379),
    [anon_sym_typeof] = ACTIONS(8379),
    [anon_sym_LBRACE] = ACTIONS(7511),
    [anon_sym_switch] = ACTIONS(8379),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [sym_null] = ACTIONS(8379),
    [anon_sym_any] = ACTIONS(8379),
    [anon_sym_boolean] = ACTIONS(8379),
    [anon_sym_async] = ACTIONS(8379),
    [anon_sym_public] = ACTIONS(8379),
    [anon_sym_AMP] = ACTIONS(7952),
    [anon_sym_var] = ACTIONS(8379),
    [anon_sym_while] = ACTIONS(8379),
    [anon_sym_SQUOTE] = ACTIONS(7511),
    [anon_sym_try] = ACTIONS(8379),
    [anon_sym_LT] = ACTIONS(7511),
    [sym_number] = ACTIONS(7511),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8379),
    [anon_sym_function] = ACTIONS(8379),
    [sym_undefined] = ACTIONS(8379),
    [anon_sym_new] = ACTIONS(8379),
    [ts_builtin_sym_end] = ACTIONS(7511),
    [anon_sym_let] = ACTIONS(8379),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_export] = ACTIONS(8379),
    [anon_sym_do] = ACTIONS(8379),
    [anon_sym_TILDE] = ACTIONS(7511),
    [anon_sym_with] = ACTIONS(8379),
  },
  [4594] = {
    [sym_identifier] = ACTIONS(8381),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [anon_sym_debugger] = ACTIONS(8381),
    [anon_sym_symbol] = ACTIONS(8381),
    [anon_sym_AT] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(7950),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_void] = ACTIONS(8381),
    [anon_sym_break] = ACTIONS(8381),
    [anon_sym_const] = ACTIONS(8381),
    [sym_super] = ACTIONS(8381),
    [anon_sym_return] = ACTIONS(8381),
    [anon_sym_private] = ACTIONS(8381),
    [anon_sym_get] = ACTIONS(8381),
    [anon_sym_interface] = ACTIONS(8381),
    [anon_sym_enum] = ACTIONS(8381),
    [anon_sym_delete] = ACTIONS(8381),
    [anon_sym_continue] = ACTIONS(8381),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_if] = ACTIONS(8381),
    [anon_sym_this] = ACTIONS(8381),
    [anon_sym_yield] = ACTIONS(8381),
    [sym_true] = ACTIONS(8381),
    [anon_sym_throw] = ACTIONS(8381),
    [anon_sym_protected] = ACTIONS(8381),
    [anon_sym_abstract] = ACTIONS(8381),
    [anon_sym_set] = ACTIONS(8381),
    [anon_sym_type] = ACTIONS(8381),
    [anon_sym_import] = ACTIONS(8381),
    [anon_sym_namespace] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_await] = ACTIONS(8381),
    [anon_sym_DQUOTE] = ACTIONS(7529),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_for] = ACTIONS(8381),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [sym_false] = ACTIONS(8381),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_module] = ACTIONS(8381),
    [anon_sym_number] = ACTIONS(8381),
    [anon_sym_class] = ACTIONS(8381),
    [anon_sym_declare] = ACTIONS(8381),
    [anon_sym_typeof] = ACTIONS(8381),
    [anon_sym_LBRACE] = ACTIONS(7529),
    [anon_sym_switch] = ACTIONS(8381),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [sym_null] = ACTIONS(8381),
    [anon_sym_any] = ACTIONS(8381),
    [anon_sym_boolean] = ACTIONS(8381),
    [anon_sym_async] = ACTIONS(8381),
    [anon_sym_public] = ACTIONS(8381),
    [anon_sym_AMP] = ACTIONS(7952),
    [anon_sym_var] = ACTIONS(8381),
    [anon_sym_while] = ACTIONS(8381),
    [anon_sym_SQUOTE] = ACTIONS(7529),
    [anon_sym_try] = ACTIONS(8381),
    [anon_sym_LT] = ACTIONS(7529),
    [sym_number] = ACTIONS(7529),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8381),
    [anon_sym_function] = ACTIONS(8381),
    [sym_undefined] = ACTIONS(8381),
    [anon_sym_new] = ACTIONS(8381),
    [ts_builtin_sym_end] = ACTIONS(7529),
    [anon_sym_let] = ACTIONS(8381),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_export] = ACTIONS(8381),
    [anon_sym_do] = ACTIONS(8381),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_with] = ACTIONS(8381),
  },
  [4595] = {
    [sym_union_type] = STATE(4807),
    [sym__type] = STATE(4807),
    [sym_constructor_type] = STATE(4807),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(3191),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(4807),
    [sym_function_type] = STATE(4807),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(3192),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(6681),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(6687),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(6685),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(6689),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(6683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [4596] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_BANG] = ACTIONS(8379),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [sym__automatic_semicolon] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(9283),
    [anon_sym_COMMA] = ACTIONS(7511),
    [anon_sym_LT_LT] = ACTIONS(7511),
    [anon_sym_STAR] = ACTIONS(8379),
    [anon_sym_GT_GT_GT] = ACTIONS(7511),
    [anon_sym_AMP_AMP] = ACTIONS(7511),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_BANG_EQ] = ACTIONS(8379),
    [anon_sym_LT_EQ] = ACTIONS(7511),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [anon_sym_GT_EQ] = ACTIONS(7511),
    [anon_sym_GT] = ACTIONS(8379),
    [anon_sym_RBRACE] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(9285),
    [anon_sym_QMARK] = ACTIONS(7511),
    [anon_sym_PERCENT] = ACTIONS(7511),
    [anon_sym_as] = ACTIONS(7511),
    [anon_sym_PIPE_PIPE] = ACTIONS(7511),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_EQ_EQ] = ACTIONS(8379),
    [anon_sym_instanceof] = ACTIONS(7511),
    [anon_sym_LT] = ACTIONS(8379),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7511),
    [anon_sym_CARET] = ACTIONS(7511),
    [anon_sym_STAR_STAR] = ACTIONS(7511),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_GT_GT] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7511),
    [anon_sym_in] = ACTIONS(8379),
  },
  [4597] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_BANG] = ACTIONS(8381),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [sym__automatic_semicolon] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(9283),
    [anon_sym_COMMA] = ACTIONS(7529),
    [anon_sym_LT_LT] = ACTIONS(7529),
    [anon_sym_STAR] = ACTIONS(8381),
    [anon_sym_GT_GT_GT] = ACTIONS(7529),
    [anon_sym_AMP_AMP] = ACTIONS(7529),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_BANG_EQ] = ACTIONS(8381),
    [anon_sym_LT_EQ] = ACTIONS(7529),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [anon_sym_GT_EQ] = ACTIONS(7529),
    [anon_sym_GT] = ACTIONS(8381),
    [anon_sym_RBRACE] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(9285),
    [anon_sym_QMARK] = ACTIONS(7529),
    [anon_sym_PERCENT] = ACTIONS(7529),
    [anon_sym_as] = ACTIONS(7529),
    [anon_sym_PIPE_PIPE] = ACTIONS(7529),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_EQ_EQ] = ACTIONS(8381),
    [anon_sym_instanceof] = ACTIONS(7529),
    [anon_sym_LT] = ACTIONS(8381),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7529),
    [anon_sym_CARET] = ACTIONS(7529),
    [anon_sym_STAR_STAR] = ACTIONS(7529),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_GT_GT] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7529),
    [anon_sym_in] = ACTIONS(8381),
  },
  [4598] = {
    [anon_sym_COMMA] = ACTIONS(9588),
    [anon_sym_RBRACE] = ACTIONS(9588),
    [sym_comment] = ACTIONS(3),
  },
  [4599] = {
    [sym_new_expression] = STATE(4808),
    [sym_augmented_assignment_expression] = STATE(4808),
    [sym_unary_expression] = STATE(4808),
    [sym_update_expression] = STATE(4808),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4808),
    [sym_regex] = STATE(4808),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4808),
    [sym_non_null_expression] = STATE(4808),
    [sym_as_expression] = STATE(4808),
    [sym_jsx_fragment] = STATE(4808),
    [sym_yield_expression] = STATE(4808),
    [sym_jsx_element] = STATE(4808),
    [sym_internal_module] = STATE(4808),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4808),
    [sym_await_expression] = STATE(4808),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4808),
    [sym_this] = STATE(4808),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4808),
    [sym_generator_function] = STATE(4808),
    [sym_call_expression] = STATE(4808),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4808),
    [sym_ternary_expression] = STATE(4808),
    [sym_binary_expression] = STATE(4808),
    [sym_template_string] = STATE(4808),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4808),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4808),
    [sym_class] = STATE(4808),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9590),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9590),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9592),
    [sym_true] = ACTIONS(9590),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9590),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4600] = {
    [sym_new_expression] = STATE(4809),
    [sym_augmented_assignment_expression] = STATE(4809),
    [sym_unary_expression] = STATE(4809),
    [sym_update_expression] = STATE(4809),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4809),
    [sym_regex] = STATE(4809),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4809),
    [sym_non_null_expression] = STATE(4809),
    [sym_as_expression] = STATE(4809),
    [sym_jsx_fragment] = STATE(4809),
    [sym_yield_expression] = STATE(4809),
    [sym_jsx_element] = STATE(4809),
    [sym_internal_module] = STATE(4809),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4809),
    [sym_await_expression] = STATE(4809),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4809),
    [sym_this] = STATE(4809),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4809),
    [sym_generator_function] = STATE(4809),
    [sym_call_expression] = STATE(4809),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4809),
    [sym_ternary_expression] = STATE(4809),
    [sym_binary_expression] = STATE(4809),
    [sym_template_string] = STATE(4809),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4809),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4809),
    [sym_class] = STATE(4809),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9594),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9594),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9596),
    [sym_true] = ACTIONS(9594),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9594),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4601] = {
    [sym_new_expression] = STATE(4810),
    [sym_augmented_assignment_expression] = STATE(4810),
    [sym_unary_expression] = STATE(4810),
    [sym_update_expression] = STATE(4810),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4810),
    [sym_regex] = STATE(4810),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4810),
    [sym_non_null_expression] = STATE(4810),
    [sym_as_expression] = STATE(4810),
    [sym_jsx_fragment] = STATE(4810),
    [sym_yield_expression] = STATE(4810),
    [sym_jsx_element] = STATE(4810),
    [sym_internal_module] = STATE(4810),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4810),
    [sym_await_expression] = STATE(4810),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4810),
    [sym_this] = STATE(4810),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4810),
    [sym_generator_function] = STATE(4810),
    [sym_call_expression] = STATE(4810),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4810),
    [sym_ternary_expression] = STATE(4810),
    [sym_binary_expression] = STATE(4810),
    [sym_template_string] = STATE(4810),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4810),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4810),
    [sym_class] = STATE(4810),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9598),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9598),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9600),
    [sym_true] = ACTIONS(9598),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9598),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4602] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9602),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4603] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9604),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4604] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9606),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4605] = {
    [sym_type_alias_declaration] = STATE(3704),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3704),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3704),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3704),
    [sym_return_statement] = STATE(3704),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3704),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3704),
    [sym_switch_statement] = STATE(3704),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3704),
    [sym_throw_statement] = STATE(3704),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3704),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3704),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(3704),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3704),
    [sym_abstract_class] = STATE(3704),
    [sym_interface_declaration] = STATE(3704),
    [sym_statement_block] = STATE(3704),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3704),
    [sym_debugger_statement] = STATE(3704),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3704),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3704),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3704),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3704),
    [sym_empty_statement] = STATE(3704),
    [sym_import_alias] = STATE(3704),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3704),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3704),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3704),
    [sym_break_statement] = STATE(3704),
    [sym_labeled_statement] = STATE(3704),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3704),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [4606] = {
    [sym_type_alias_declaration] = STATE(3732),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3732),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3732),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3732),
    [sym_return_statement] = STATE(3732),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3732),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3732),
    [sym_switch_statement] = STATE(3732),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3732),
    [sym_throw_statement] = STATE(3732),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3732),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3732),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(3732),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3732),
    [sym_abstract_class] = STATE(3732),
    [sym_interface_declaration] = STATE(3732),
    [sym_statement_block] = STATE(3732),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3732),
    [sym_debugger_statement] = STATE(3732),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3732),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3732),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3732),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3732),
    [sym_empty_statement] = STATE(3732),
    [sym_import_alias] = STATE(3732),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3732),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3732),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3732),
    [sym_break_statement] = STATE(3732),
    [sym_labeled_statement] = STATE(3732),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3732),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [4607] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(9608),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4608] = {
    [anon_sym_RPAREN] = ACTIONS(9608),
    [sym_comment] = ACTIONS(3),
  },
  [4609] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(9610),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4610] = {
    [anon_sym_RPAREN] = ACTIONS(9610),
    [sym_comment] = ACTIONS(3),
  },
  [4611] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(9612),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4612] = {
    [anon_sym_RPAREN] = ACTIONS(9612),
    [sym_comment] = ACTIONS(3),
  },
  [4613] = {
    [sym_type_alias_declaration] = STATE(3737),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3737),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3737),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3737),
    [sym_return_statement] = STATE(3737),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3737),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3737),
    [sym_switch_statement] = STATE(3737),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3737),
    [sym_throw_statement] = STATE(3737),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3737),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3737),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(3737),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3737),
    [sym_abstract_class] = STATE(3737),
    [sym_interface_declaration] = STATE(3737),
    [sym_statement_block] = STATE(3737),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3737),
    [sym_debugger_statement] = STATE(3737),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3737),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3737),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3737),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3737),
    [sym_empty_statement] = STATE(3737),
    [sym_import_alias] = STATE(3737),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3737),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3737),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3737),
    [sym_break_statement] = STATE(3737),
    [sym_labeled_statement] = STATE(3737),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3737),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [4614] = {
    [sym_type_alias_declaration] = STATE(3738),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3738),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3738),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3738),
    [sym_return_statement] = STATE(3738),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3738),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3738),
    [sym_switch_statement] = STATE(3738),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3738),
    [sym_throw_statement] = STATE(3738),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3738),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3738),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(3738),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3738),
    [sym_abstract_class] = STATE(3738),
    [sym_interface_declaration] = STATE(3738),
    [sym_statement_block] = STATE(3738),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3738),
    [sym_debugger_statement] = STATE(3738),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3738),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3738),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3738),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3738),
    [sym_empty_statement] = STATE(3738),
    [sym_import_alias] = STATE(3738),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3738),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3738),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3738),
    [sym_break_statement] = STATE(3738),
    [sym_labeled_statement] = STATE(3738),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3738),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [4615] = {
    [sym_type_alias_declaration] = STATE(3739),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3739),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3739),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3739),
    [sym_return_statement] = STATE(3739),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3739),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3739),
    [sym_switch_statement] = STATE(3739),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3739),
    [sym_throw_statement] = STATE(3739),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3739),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3739),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(3739),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3739),
    [sym_abstract_class] = STATE(3739),
    [sym_interface_declaration] = STATE(3739),
    [sym_statement_block] = STATE(3739),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3739),
    [sym_debugger_statement] = STATE(3739),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3739),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3739),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3739),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3739),
    [sym_empty_statement] = STATE(3739),
    [sym_import_alias] = STATE(3739),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3739),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3739),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3739),
    [sym_break_statement] = STATE(3739),
    [sym_labeled_statement] = STATE(3739),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3739),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [4616] = {
    [sym_type_alias_declaration] = STATE(3740),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3740),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3740),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3740),
    [sym_return_statement] = STATE(3740),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3740),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3740),
    [sym_switch_statement] = STATE(3740),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3740),
    [sym_throw_statement] = STATE(3740),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3740),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3740),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(3740),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3740),
    [sym_abstract_class] = STATE(3740),
    [sym_interface_declaration] = STATE(3740),
    [sym_statement_block] = STATE(3740),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3740),
    [sym_debugger_statement] = STATE(3740),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3740),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3740),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3740),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3740),
    [sym_empty_statement] = STATE(3740),
    [sym_import_alias] = STATE(3740),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3740),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3740),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3740),
    [sym_break_statement] = STATE(3740),
    [sym_labeled_statement] = STATE(3740),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3740),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [4617] = {
    [sym_type_alias_declaration] = STATE(3741),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3741),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3741),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3741),
    [sym_return_statement] = STATE(3741),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3741),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3741),
    [sym_switch_statement] = STATE(3741),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3741),
    [sym_throw_statement] = STATE(3741),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3741),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3741),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(3741),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3741),
    [sym_abstract_class] = STATE(3741),
    [sym_interface_declaration] = STATE(3741),
    [sym_statement_block] = STATE(3741),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3741),
    [sym_debugger_statement] = STATE(3741),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3741),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3741),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3741),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3741),
    [sym_empty_statement] = STATE(3741),
    [sym_import_alias] = STATE(3741),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3741),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3741),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3741),
    [sym_break_statement] = STATE(3741),
    [sym_labeled_statement] = STATE(3741),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3741),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [4618] = {
    [sym_type_arguments] = STATE(1064),
    [sym_identifier] = ACTIONS(3699),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [anon_sym_debugger] = ACTIONS(3699),
    [anon_sym_symbol] = ACTIONS(3699),
    [anon_sym_AT] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_void] = ACTIONS(3699),
    [anon_sym_break] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [sym_super] = ACTIONS(3699),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_private] = ACTIONS(3699),
    [anon_sym_get] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_interface] = ACTIONS(3699),
    [anon_sym_enum] = ACTIONS(3699),
    [anon_sym_delete] = ACTIONS(3699),
    [anon_sym_continue] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(3699),
    [anon_sym_this] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3699),
    [sym_true] = ACTIONS(3699),
    [anon_sym_throw] = ACTIONS(3699),
    [anon_sym_protected] = ACTIONS(3699),
    [anon_sym_abstract] = ACTIONS(3699),
    [anon_sym_DOT] = ACTIONS(4187),
    [anon_sym_set] = ACTIONS(3699),
    [anon_sym_type] = ACTIONS(3699),
    [anon_sym_import] = ACTIONS(3699),
    [anon_sym_namespace] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_await] = ACTIONS(3699),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [anon_sym_else] = ACTIONS(3699),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [sym_false] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_module] = ACTIONS(3699),
    [anon_sym_number] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_declare] = ACTIONS(3699),
    [anon_sym_typeof] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(9614),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [sym_null] = ACTIONS(3699),
    [anon_sym_any] = ACTIONS(3699),
    [anon_sym_boolean] = ACTIONS(3699),
    [anon_sym_async] = ACTIONS(3699),
    [anon_sym_public] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_var] = ACTIONS(3699),
    [anon_sym_while] = ACTIONS(3699),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_try] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(7943),
    [sym_number] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3699),
    [sym_undefined] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_export] = ACTIONS(3699),
    [anon_sym_do] = ACTIONS(3699),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_with] = ACTIONS(3699),
  },
  [4619] = {
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_array_type] = STATE(1066),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym_existential_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(1066),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(1066),
    [sym_string] = STATE(418),
    [sym_tuple_type] = STATE(1066),
    [sym_identifier] = ACTIONS(9335),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [sym_true] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4620] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4624),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4625),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9335),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9339),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9341),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4621] = {
    [sym_type_parameters] = STATE(4818),
    [sym_formal_parameters] = STATE(4819),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4622] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4624),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4625),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9335),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9339),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9341),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4623] = {
    [sym_identifier] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7948),
    [anon_sym_debugger] = ACTIONS(7946),
    [anon_sym_symbol] = ACTIONS(7946),
    [anon_sym_AT] = ACTIONS(7948),
    [anon_sym_PIPE] = ACTIONS(9616),
    [anon_sym_DASH] = ACTIONS(7946),
    [anon_sym_void] = ACTIONS(7946),
    [anon_sym_break] = ACTIONS(7946),
    [anon_sym_const] = ACTIONS(7946),
    [sym_super] = ACTIONS(7946),
    [anon_sym_return] = ACTIONS(7946),
    [anon_sym_private] = ACTIONS(7946),
    [anon_sym_get] = ACTIONS(7946),
    [anon_sym_RBRACE] = ACTIONS(7948),
    [anon_sym_interface] = ACTIONS(7946),
    [anon_sym_enum] = ACTIONS(7946),
    [anon_sym_delete] = ACTIONS(7946),
    [anon_sym_continue] = ACTIONS(7946),
    [anon_sym_DASH_DASH] = ACTIONS(7948),
    [anon_sym_if] = ACTIONS(7946),
    [anon_sym_this] = ACTIONS(7946),
    [anon_sym_yield] = ACTIONS(7946),
    [sym_true] = ACTIONS(7946),
    [anon_sym_throw] = ACTIONS(7946),
    [anon_sym_protected] = ACTIONS(7946),
    [anon_sym_abstract] = ACTIONS(7946),
    [anon_sym_set] = ACTIONS(7946),
    [anon_sym_type] = ACTIONS(7946),
    [anon_sym_import] = ACTIONS(7946),
    [anon_sym_namespace] = ACTIONS(7946),
    [anon_sym_PLUS_PLUS] = ACTIONS(7948),
    [anon_sym_await] = ACTIONS(7946),
    [anon_sym_DQUOTE] = ACTIONS(7948),
    [anon_sym_else] = ACTIONS(7946),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_for] = ACTIONS(7946),
    [anon_sym_LBRACK] = ACTIONS(7948),
    [sym_false] = ACTIONS(7946),
    [anon_sym_SEMI] = ACTIONS(7948),
    [anon_sym_module] = ACTIONS(7946),
    [anon_sym_number] = ACTIONS(7946),
    [anon_sym_class] = ACTIONS(7946),
    [anon_sym_declare] = ACTIONS(7946),
    [anon_sym_typeof] = ACTIONS(7946),
    [anon_sym_LBRACE] = ACTIONS(7948),
    [anon_sym_switch] = ACTIONS(7946),
    [anon_sym_LPAREN] = ACTIONS(7948),
    [sym_null] = ACTIONS(7946),
    [anon_sym_any] = ACTIONS(7946),
    [anon_sym_boolean] = ACTIONS(7946),
    [anon_sym_async] = ACTIONS(7946),
    [anon_sym_public] = ACTIONS(7946),
    [anon_sym_AMP] = ACTIONS(9618),
    [anon_sym_var] = ACTIONS(7946),
    [anon_sym_while] = ACTIONS(7946),
    [anon_sym_SQUOTE] = ACTIONS(7948),
    [anon_sym_try] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(7948),
    [sym_number] = ACTIONS(7948),
    [anon_sym_SLASH] = ACTIONS(7946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7946),
    [anon_sym_function] = ACTIONS(7946),
    [sym_undefined] = ACTIONS(7946),
    [anon_sym_new] = ACTIONS(7946),
    [anon_sym_let] = ACTIONS(7946),
    [anon_sym_PLUS] = ACTIONS(7946),
    [anon_sym_export] = ACTIONS(7946),
    [anon_sym_do] = ACTIONS(7946),
    [anon_sym_TILDE] = ACTIONS(7948),
    [anon_sym_with] = ACTIONS(7946),
  },
  [4624] = {
    [sym_formal_parameters] = STATE(4822),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4625] = {
    [anon_sym_EQ_GT] = ACTIONS(9620),
    [sym_comment] = ACTIONS(3),
  },
  [4626] = {
    [sym_type_alias_declaration] = STATE(4545),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4545),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4545),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4545),
    [sym_return_statement] = STATE(4545),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4545),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4545),
    [sym_switch_statement] = STATE(4545),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4545),
    [sym_throw_statement] = STATE(4545),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4545),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4545),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(4545),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4545),
    [sym_abstract_class] = STATE(4545),
    [sym_interface_declaration] = STATE(4545),
    [sym_statement_block] = STATE(4545),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4545),
    [sym_debugger_statement] = STATE(4545),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4545),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4545),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4545),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4545),
    [sym_empty_statement] = STATE(4545),
    [sym_import_alias] = STATE(4545),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4545),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4545),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4545),
    [sym_break_statement] = STATE(4545),
    [sym_labeled_statement] = STATE(4545),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4545),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [4627] = {
    [sym_type_alias_declaration] = STATE(4546),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4546),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4546),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4546),
    [sym_return_statement] = STATE(4546),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4546),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4546),
    [sym_switch_statement] = STATE(4546),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4546),
    [sym_throw_statement] = STATE(4546),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4546),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4546),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(4546),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4546),
    [sym_abstract_class] = STATE(4546),
    [sym_interface_declaration] = STATE(4546),
    [sym_statement_block] = STATE(4546),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4546),
    [sym_debugger_statement] = STATE(4546),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4546),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4546),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4546),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4546),
    [sym_empty_statement] = STATE(4546),
    [sym_import_alias] = STATE(4546),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4546),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4546),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4546),
    [sym_break_statement] = STATE(4546),
    [sym_labeled_statement] = STATE(4546),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4546),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [4628] = {
    [sym_type_alias_declaration] = STATE(4547),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4547),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4547),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4547),
    [sym_return_statement] = STATE(4547),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4547),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4547),
    [sym_switch_statement] = STATE(4547),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4547),
    [sym_throw_statement] = STATE(4547),
    [aux_sym_export_statement_repeat1] = STATE(697),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4547),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4547),
    [sym_decorator] = STATE(697),
    [sym_continue_statement] = STATE(4547),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4547),
    [sym_abstract_class] = STATE(4547),
    [sym_interface_declaration] = STATE(4547),
    [sym_statement_block] = STATE(4547),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4547),
    [sym_debugger_statement] = STATE(4547),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4547),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4547),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4547),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4547),
    [sym_empty_statement] = STATE(4547),
    [sym_import_alias] = STATE(4547),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4547),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4547),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4547),
    [sym_break_statement] = STATE(4547),
    [sym_labeled_statement] = STATE(4547),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4547),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(376),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(1306),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(398),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(404),
  },
  [4629] = {
    [sym_identifier] = ACTIONS(7192),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [anon_sym_debugger] = ACTIONS(7192),
    [anon_sym_symbol] = ACTIONS(7192),
    [anon_sym_AT] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(8841),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_void] = ACTIONS(7192),
    [anon_sym_break] = ACTIONS(7192),
    [anon_sym_const] = ACTIONS(7192),
    [sym_super] = ACTIONS(7192),
    [anon_sym_return] = ACTIONS(7192),
    [anon_sym_private] = ACTIONS(7192),
    [anon_sym_get] = ACTIONS(7192),
    [anon_sym_RBRACE] = ACTIONS(5893),
    [anon_sym_interface] = ACTIONS(7192),
    [anon_sym_enum] = ACTIONS(7192),
    [anon_sym_delete] = ACTIONS(7192),
    [anon_sym_continue] = ACTIONS(7192),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_if] = ACTIONS(7192),
    [anon_sym_this] = ACTIONS(7192),
    [anon_sym_yield] = ACTIONS(7192),
    [sym_true] = ACTIONS(7192),
    [anon_sym_throw] = ACTIONS(7192),
    [anon_sym_protected] = ACTIONS(7192),
    [anon_sym_abstract] = ACTIONS(7192),
    [anon_sym_set] = ACTIONS(7192),
    [anon_sym_type] = ACTIONS(7192),
    [anon_sym_import] = ACTIONS(7192),
    [anon_sym_namespace] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_await] = ACTIONS(7192),
    [anon_sym_DQUOTE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5893),
    [anon_sym_for] = ACTIONS(7192),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [sym_false] = ACTIONS(7192),
    [anon_sym_SEMI] = ACTIONS(5893),
    [anon_sym_module] = ACTIONS(7192),
    [anon_sym_number] = ACTIONS(7192),
    [anon_sym_class] = ACTIONS(7192),
    [anon_sym_declare] = ACTIONS(7192),
    [anon_sym_typeof] = ACTIONS(7192),
    [anon_sym_LBRACE] = ACTIONS(5893),
    [anon_sym_switch] = ACTIONS(7192),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [sym_null] = ACTIONS(7192),
    [anon_sym_any] = ACTIONS(7192),
    [anon_sym_boolean] = ACTIONS(7192),
    [anon_sym_async] = ACTIONS(7192),
    [anon_sym_public] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(8843),
    [anon_sym_var] = ACTIONS(7192),
    [anon_sym_while] = ACTIONS(7192),
    [anon_sym_SQUOTE] = ACTIONS(5893),
    [anon_sym_try] = ACTIONS(7192),
    [anon_sym_LT] = ACTIONS(5893),
    [sym_number] = ACTIONS(5893),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7192),
    [anon_sym_function] = ACTIONS(7192),
    [sym_undefined] = ACTIONS(7192),
    [anon_sym_new] = ACTIONS(7192),
    [anon_sym_let] = ACTIONS(7192),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_export] = ACTIONS(7192),
    [anon_sym_do] = ACTIONS(7192),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_with] = ACTIONS(7192),
  },
  [4630] = {
    [anon_sym_EQ_GT] = ACTIONS(9622),
    [sym_comment] = ACTIONS(3),
  },
  [4631] = {
    [sym_union_type] = STATE(4825),
    [sym__type] = STATE(4825),
    [sym_constructor_type] = STATE(4825),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(3873),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4825),
    [sym_function_type] = STATE(4825),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3874),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8050),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8052),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8054),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8056),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4632] = {
    [sym_union_type] = STATE(4826),
    [sym__type] = STATE(4826),
    [sym_constructor_type] = STATE(4826),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(3873),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4826),
    [sym_function_type] = STATE(4826),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3874),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8050),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8052),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8054),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8056),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4633] = {
    [sym_identifier] = ACTIONS(7208),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [anon_sym_debugger] = ACTIONS(7208),
    [anon_sym_symbol] = ACTIONS(7208),
    [anon_sym_AT] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(8841),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_void] = ACTIONS(7208),
    [anon_sym_break] = ACTIONS(7208),
    [anon_sym_const] = ACTIONS(7208),
    [sym_super] = ACTIONS(7208),
    [anon_sym_return] = ACTIONS(7208),
    [anon_sym_private] = ACTIONS(7208),
    [anon_sym_get] = ACTIONS(7208),
    [anon_sym_RBRACE] = ACTIONS(6040),
    [anon_sym_interface] = ACTIONS(7208),
    [anon_sym_enum] = ACTIONS(7208),
    [anon_sym_delete] = ACTIONS(7208),
    [anon_sym_continue] = ACTIONS(7208),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_if] = ACTIONS(7208),
    [anon_sym_this] = ACTIONS(7208),
    [anon_sym_yield] = ACTIONS(7208),
    [sym_true] = ACTIONS(7208),
    [anon_sym_throw] = ACTIONS(7208),
    [anon_sym_protected] = ACTIONS(7208),
    [anon_sym_abstract] = ACTIONS(7208),
    [anon_sym_set] = ACTIONS(7208),
    [anon_sym_type] = ACTIONS(7208),
    [anon_sym_import] = ACTIONS(7208),
    [anon_sym_namespace] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_await] = ACTIONS(7208),
    [anon_sym_DQUOTE] = ACTIONS(6040),
    [anon_sym_BANG] = ACTIONS(6040),
    [anon_sym_for] = ACTIONS(7208),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [sym_false] = ACTIONS(7208),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_module] = ACTIONS(7208),
    [anon_sym_number] = ACTIONS(7208),
    [anon_sym_class] = ACTIONS(7208),
    [anon_sym_declare] = ACTIONS(7208),
    [anon_sym_typeof] = ACTIONS(7208),
    [anon_sym_LBRACE] = ACTIONS(6040),
    [anon_sym_switch] = ACTIONS(7208),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [sym_null] = ACTIONS(7208),
    [anon_sym_any] = ACTIONS(7208),
    [anon_sym_boolean] = ACTIONS(7208),
    [anon_sym_async] = ACTIONS(7208),
    [anon_sym_public] = ACTIONS(7208),
    [anon_sym_AMP] = ACTIONS(8843),
    [anon_sym_var] = ACTIONS(7208),
    [anon_sym_while] = ACTIONS(7208),
    [anon_sym_SQUOTE] = ACTIONS(6040),
    [anon_sym_try] = ACTIONS(7208),
    [anon_sym_LT] = ACTIONS(6040),
    [sym_number] = ACTIONS(6040),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7208),
    [anon_sym_function] = ACTIONS(7208),
    [sym_undefined] = ACTIONS(7208),
    [anon_sym_new] = ACTIONS(7208),
    [anon_sym_let] = ACTIONS(7208),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_export] = ACTIONS(7208),
    [anon_sym_do] = ACTIONS(7208),
    [anon_sym_TILDE] = ACTIONS(6040),
    [anon_sym_with] = ACTIONS(7208),
  },
  [4634] = {
    [sym_statement_block] = STATE(4827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [4635] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6825),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6827),
    [anon_sym_COMMA] = ACTIONS(7181),
    [anon_sym_LT_LT] = ACTIONS(6831),
    [anon_sym_STAR] = ACTIONS(6837),
    [anon_sym_GT_GT_GT] = ACTIONS(6831),
    [anon_sym_AMP_AMP] = ACTIONS(6835),
    [anon_sym_DASH] = ACTIONS(6833),
    [anon_sym_BANG_EQ] = ACTIONS(6785),
    [anon_sym_LT_EQ] = ACTIONS(6825),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6825),
    [anon_sym_GT] = ACTIONS(6785),
    [anon_sym_AMP] = ACTIONS(6839),
    [anon_sym_PERCENT] = ACTIONS(6831),
    [anon_sym_QMARK] = ACTIONS(6841),
    [anon_sym_as] = ACTIONS(6845),
    [anon_sym_PIPE_PIPE] = ACTIONS(6843),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6785),
    [anon_sym_instanceof] = ACTIONS(6825),
    [anon_sym_LT] = ACTIONS(6847),
    [anon_sym_SLASH] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7181),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6843),
    [anon_sym_STAR_STAR] = ACTIONS(6851),
    [anon_sym_PLUS] = ACTIONS(6833),
    [anon_sym_GT_GT] = ACTIONS(6837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6825),
    [anon_sym_in] = ACTIONS(6785),
  },
  [4636] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(7192),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(9624),
    [anon_sym_COMMA] = ACTIONS(5893),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_STAR] = ACTIONS(7192),
    [anon_sym_GT_GT_GT] = ACTIONS(5893),
    [anon_sym_AMP_AMP] = ACTIONS(5893),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_BANG_EQ] = ACTIONS(7192),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(9626),
    [anon_sym_PERCENT] = ACTIONS(5893),
    [anon_sym_QMARK] = ACTIONS(5893),
    [anon_sym_as] = ACTIONS(5893),
    [anon_sym_PIPE_PIPE] = ACTIONS(5893),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_EQ_EQ] = ACTIONS(7192),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(7192),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5893),
    [anon_sym_DOT] = ACTIONS(5893),
    [anon_sym_CARET] = ACTIONS(5893),
    [anon_sym_STAR_STAR] = ACTIONS(5893),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_GT_GT] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_in] = ACTIONS(7192),
  },
  [4637] = {
    [anon_sym_EQ_GT] = ACTIONS(9628),
    [sym_comment] = ACTIONS(3),
  },
  [4638] = {
    [sym_union_type] = STATE(4829),
    [sym__type] = STATE(4829),
    [sym_constructor_type] = STATE(4829),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3895),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4829),
    [sym_function_type] = STATE(4829),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3896),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(8117),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(8123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(8121),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(8125),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(8119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4639] = {
    [sym_union_type] = STATE(4830),
    [sym__type] = STATE(4830),
    [sym_constructor_type] = STATE(4830),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3895),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4830),
    [sym_function_type] = STATE(4830),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3896),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(8117),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(8123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(8121),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(8125),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(8119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4640] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_BANG] = ACTIONS(7208),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(9624),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_LT_LT] = ACTIONS(6040),
    [anon_sym_STAR] = ACTIONS(7208),
    [anon_sym_GT_GT_GT] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(6040),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_BANG_EQ] = ACTIONS(7208),
    [anon_sym_LT_EQ] = ACTIONS(6040),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [anon_sym_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_AMP] = ACTIONS(9626),
    [anon_sym_PERCENT] = ACTIONS(6040),
    [anon_sym_QMARK] = ACTIONS(6040),
    [anon_sym_as] = ACTIONS(6040),
    [anon_sym_PIPE_PIPE] = ACTIONS(6040),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_EQ_EQ] = ACTIONS(7208),
    [anon_sym_instanceof] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(6040),
    [anon_sym_DOT] = ACTIONS(6040),
    [anon_sym_CARET] = ACTIONS(6040),
    [anon_sym_STAR_STAR] = ACTIONS(6040),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_GT_GT] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6040),
    [anon_sym_in] = ACTIONS(7208),
  },
  [4641] = {
    [sym_type_alias_declaration] = STATE(348),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(348),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(348),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(348),
    [sym_return_statement] = STATE(348),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(348),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(348),
    [sym_switch_statement] = STATE(348),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(348),
    [sym_throw_statement] = STATE(348),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(348),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(348),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(348),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(348),
    [sym_abstract_class] = STATE(348),
    [sym_interface_declaration] = STATE(348),
    [sym_statement_block] = STATE(348),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(348),
    [sym_debugger_statement] = STATE(348),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(348),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(348),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(348),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(348),
    [sym_empty_statement] = STATE(348),
    [sym_import_alias] = STATE(348),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(348),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(348),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(348),
    [sym_break_statement] = STATE(348),
    [sym_labeled_statement] = STATE(348),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(348),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [4642] = {
    [sym_type_alias_declaration] = STATE(4831),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4831),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4831),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4831),
    [sym_return_statement] = STATE(4831),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4831),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4831),
    [sym_switch_statement] = STATE(4831),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4831),
    [sym_throw_statement] = STATE(4831),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4831),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4831),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(4831),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4831),
    [sym_abstract_class] = STATE(4831),
    [sym_interface_declaration] = STATE(4831),
    [sym_statement_block] = STATE(4831),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4831),
    [sym_debugger_statement] = STATE(4831),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4831),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4831),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4831),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4831),
    [sym_empty_statement] = STATE(4831),
    [sym_import_alias] = STATE(4831),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4831),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4831),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4831),
    [sym_break_statement] = STATE(4831),
    [sym_labeled_statement] = STATE(4831),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4831),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [4643] = {
    [anon_sym_LPAREN] = ACTIONS(9630),
    [sym_comment] = ACTIONS(3),
  },
  [4644] = {
    [sym_new_expression] = STATE(59),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_yield_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_internal_module] = STATE(59),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(59),
    [sym_await_expression] = STATE(59),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4836),
    [sym_variable_declaration] = STATE(4836),
    [sym_sequence_expression] = STATE(62),
    [sym_string] = STATE(59),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(4836),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(4837),
    [sym_anonymous_class] = STATE(59),
    [sym_generator_function] = STATE(59),
    [sym_call_expression] = STATE(59),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(59),
    [sym_ternary_expression] = STATE(59),
    [sym_binary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_lexical_declaration] = STATE(4836),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(4838),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(59),
    [anon_sym_TILDE] = ACTIONS(59),
    [sym_identifier] = ACTIONS(9632),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(9634),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_var] = ACTIONS(9636),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_let] = ACTIONS(9634),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(15),
  },
  [4645] = {
    [sym_string] = STATE(173),
    [sym_nested_identifier] = STATE(169),
    [sym__module] = STATE(172),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(9638),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(312),
  },
  [4646] = {
    [sym_type_alias_declaration] = STATE(193),
    [aux_sym_export_statement_repeat1] = STATE(4648),
    [sym__declaration] = STATE(193),
    [sym_ambient_declaration] = STATE(193),
    [sym_import_alias] = STATE(193),
    [sym_export_statement] = STATE(193),
    [sym_generator_function] = STATE(193),
    [sym_lexical_declaration] = STATE(193),
    [sym_internal_module] = STATE(193),
    [sym_decorator] = STATE(4648),
    [sym_enum_declaration] = STATE(193),
    [sym_function] = STATE(193),
    [sym_function_signature] = STATE(193),
    [sym_variable_declaration] = STATE(193),
    [sym_abstract_class] = STATE(193),
    [sym_module] = STATE(193),
    [sym_interface_declaration] = STATE(193),
    [sym_class] = STATE(193),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(9369),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(9371),
    [anon_sym_global] = ACTIONS(324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(9373),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(346),
  },
  [4647] = {
    [sym_type_alias_declaration] = STATE(300),
    [aux_sym_export_statement_repeat1] = STATE(4648),
    [sym__declaration] = STATE(300),
    [sym_ambient_declaration] = STATE(300),
    [sym_import_alias] = STATE(300),
    [sym_export_statement] = STATE(300),
    [sym_generator_function] = STATE(300),
    [sym_export_clause] = STATE(301),
    [sym_lexical_declaration] = STATE(300),
    [sym_internal_module] = STATE(300),
    [sym_decorator] = STATE(4648),
    [sym_enum_declaration] = STATE(300),
    [sym_function] = STATE(300),
    [sym_function_signature] = STATE(300),
    [sym_variable_declaration] = STATE(300),
    [sym_abstract_class] = STATE(300),
    [sym_module] = STATE(300),
    [sym_interface_declaration] = STATE(300),
    [sym_class] = STATE(300),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_as] = ACTIONS(1183),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(9371),
    [anon_sym_STAR] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_EQ] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(9373),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(346),
  },
  [4648] = {
    [aux_sym_export_statement_repeat1] = STATE(320),
    [sym_decorator] = STATE(320),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(9377),
    [anon_sym_class] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
  },
  [4649] = {
    [sym_type_alias_declaration] = STATE(787),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(787),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(787),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(787),
    [sym_return_statement] = STATE(787),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(787),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(787),
    [sym_switch_statement] = STATE(787),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(787),
    [sym_throw_statement] = STATE(787),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(787),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(787),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(787),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(787),
    [sym_abstract_class] = STATE(787),
    [sym_interface_declaration] = STATE(787),
    [sym_statement_block] = STATE(787),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(787),
    [sym_debugger_statement] = STATE(787),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(787),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(787),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(787),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(787),
    [sym_empty_statement] = STATE(787),
    [sym_import_alias] = STATE(787),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(787),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(787),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(787),
    [sym_break_statement] = STATE(787),
    [sym_labeled_statement] = STATE(787),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(787),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [4650] = {
    [sym_type_alias_declaration] = STATE(891),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(891),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(891),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(891),
    [sym_return_statement] = STATE(891),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(891),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(891),
    [sym_switch_statement] = STATE(891),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(891),
    [sym_throw_statement] = STATE(891),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(891),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(891),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(891),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(891),
    [sym_abstract_class] = STATE(891),
    [sym_interface_declaration] = STATE(891),
    [sym_statement_block] = STATE(891),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(891),
    [sym_debugger_statement] = STATE(891),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(891),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(891),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(891),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(891),
    [sym_empty_statement] = STATE(891),
    [sym_import_alias] = STATE(891),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(891),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(891),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(891),
    [sym_break_statement] = STATE(891),
    [sym_labeled_statement] = STATE(891),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(891),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [4651] = {
    [sym_type_alias_declaration] = STATE(2092),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(2092),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(2092),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(2092),
    [sym_return_statement] = STATE(2092),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(2092),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2092),
    [sym_switch_statement] = STATE(2092),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(2092),
    [sym_throw_statement] = STATE(2092),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(2092),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(2092),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(2092),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(2092),
    [sym_abstract_class] = STATE(2092),
    [sym_interface_declaration] = STATE(2092),
    [sym_statement_block] = STATE(2092),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(2092),
    [sym_debugger_statement] = STATE(2092),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(2092),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(2092),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(2092),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(2092),
    [sym_empty_statement] = STATE(2092),
    [sym_import_alias] = STATE(2092),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(2092),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(2092),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(2092),
    [sym_break_statement] = STATE(2092),
    [sym_labeled_statement] = STATE(2092),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(2092),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [4652] = {
    [sym_type_alias_declaration] = STATE(872),
    [aux_sym_export_statement_repeat1] = STATE(4648),
    [sym__declaration] = STATE(872),
    [sym_ambient_declaration] = STATE(872),
    [sym_import_alias] = STATE(872),
    [sym_export_statement] = STATE(872),
    [sym_generator_function] = STATE(872),
    [sym_lexical_declaration] = STATE(872),
    [sym_internal_module] = STATE(872),
    [sym_decorator] = STATE(4648),
    [sym_enum_declaration] = STATE(872),
    [sym_function] = STATE(872),
    [sym_function_signature] = STATE(872),
    [sym_variable_declaration] = STATE(872),
    [sym_abstract_class] = STATE(872),
    [sym_module] = STATE(872),
    [sym_interface_declaration] = STATE(872),
    [sym_class] = STATE(872),
    [anon_sym_var] = ACTIONS(348),
    [anon_sym_default] = ACTIONS(1826),
    [anon_sym_interface] = ACTIONS(328),
    [anon_sym_enum] = ACTIONS(330),
    [anon_sym_module] = ACTIONS(518),
    [anon_sym_class] = ACTIONS(342),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(9371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(350),
    [anon_sym_const] = ACTIONS(326),
    [anon_sym_abstract] = ACTIONS(332),
    [anon_sym_type] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(352),
    [anon_sym_import] = ACTIONS(336),
    [anon_sym_export] = ACTIONS(9373),
    [anon_sym_namespace] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(346),
  },
  [4653] = {
    [sym_array] = STATE(4841),
    [sym_object] = STATE(4842),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(9640),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [4654] = {
    [anon_sym_of] = ACTIONS(9642),
    [sym_comment] = ACTIONS(3),
  },
  [4655] = {
    [anon_sym_of] = ACTIONS(9644),
    [sym_comment] = ACTIONS(3),
  },
  [4656] = {
    [anon_sym_of] = ACTIONS(9646),
    [sym_comment] = ACTIONS(3),
  },
  [4657] = {
    [sym_new_expression] = STATE(4846),
    [sym_augmented_assignment_expression] = STATE(4846),
    [sym_unary_expression] = STATE(4846),
    [sym_update_expression] = STATE(4846),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(4846),
    [sym_regex] = STATE(4846),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4846),
    [sym_non_null_expression] = STATE(4846),
    [sym_as_expression] = STATE(4846),
    [sym_jsx_fragment] = STATE(4846),
    [sym_yield_expression] = STATE(4846),
    [sym_jsx_element] = STATE(4846),
    [sym_internal_module] = STATE(4846),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4846),
    [sym_await_expression] = STATE(4846),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(4847),
    [sym_string] = STATE(4846),
    [sym_this] = STATE(4846),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(4846),
    [sym_generator_function] = STATE(4846),
    [sym_call_expression] = STATE(4846),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(4846),
    [sym_ternary_expression] = STATE(4846),
    [sym_binary_expression] = STATE(4846),
    [sym_template_string] = STATE(4846),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4846),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(4846),
    [sym_class] = STATE(4846),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(9648),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(9648),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(9650),
    [sym_true] = ACTIONS(9648),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(9648),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [4658] = {
    [sym_new_expression] = STATE(4848),
    [sym_augmented_assignment_expression] = STATE(4848),
    [sym_unary_expression] = STATE(4848),
    [sym_update_expression] = STATE(4848),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4848),
    [sym_regex] = STATE(4848),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4848),
    [sym_non_null_expression] = STATE(4848),
    [sym_as_expression] = STATE(4848),
    [sym_jsx_fragment] = STATE(4848),
    [sym_yield_expression] = STATE(4848),
    [sym_jsx_element] = STATE(4848),
    [sym_internal_module] = STATE(4848),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4848),
    [sym_await_expression] = STATE(4848),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4848),
    [sym_this] = STATE(4848),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4848),
    [sym_generator_function] = STATE(4848),
    [sym_call_expression] = STATE(4848),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4848),
    [sym_ternary_expression] = STATE(4848),
    [sym_binary_expression] = STATE(4848),
    [sym_template_string] = STATE(4848),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4848),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4848),
    [sym_class] = STATE(4848),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9652),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9652),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9654),
    [sym_true] = ACTIONS(9652),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9652),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4659] = {
    [sym__initializer] = STATE(391),
    [sym_type_annotation] = STATE(392),
    [sym__automatic_semicolon] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(715),
    [anon_sym_of] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(9656),
  },
  [4660] = {
    [sym__initializer] = STATE(411),
    [sym_type_annotation] = STATE(412),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(745),
    [anon_sym_of] = ACTIONS(9644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(9658),
  },
  [4661] = {
    [sym__initializer] = STATE(413),
    [sym_type_annotation] = STATE(414),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(745),
    [anon_sym_of] = ACTIONS(9646),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(9660),
  },
  [4662] = {
    [sym_new_expression] = STATE(4853),
    [sym_augmented_assignment_expression] = STATE(4853),
    [sym_unary_expression] = STATE(4853),
    [sym_update_expression] = STATE(4853),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(4853),
    [sym_regex] = STATE(4853),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4853),
    [sym_non_null_expression] = STATE(4853),
    [sym_as_expression] = STATE(4853),
    [sym_jsx_fragment] = STATE(4853),
    [sym_yield_expression] = STATE(4853),
    [sym_jsx_element] = STATE(4853),
    [sym_internal_module] = STATE(4853),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4853),
    [sym_await_expression] = STATE(4853),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(4854),
    [sym_string] = STATE(4853),
    [sym_this] = STATE(4853),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(4853),
    [sym_generator_function] = STATE(4853),
    [sym_call_expression] = STATE(4853),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(4853),
    [sym_ternary_expression] = STATE(4853),
    [sym_binary_expression] = STATE(4853),
    [sym_template_string] = STATE(4853),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4853),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4853),
    [sym_class] = STATE(4853),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9662),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_RPAREN] = ACTIONS(9664),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9666),
    [sym_true] = ACTIONS(9662),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9662),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [4663] = {
    [sym_new_expression] = STATE(4855),
    [sym_augmented_assignment_expression] = STATE(4855),
    [sym_unary_expression] = STATE(4855),
    [sym_update_expression] = STATE(4855),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4855),
    [sym_regex] = STATE(4855),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4855),
    [sym_non_null_expression] = STATE(4855),
    [sym_as_expression] = STATE(4855),
    [sym_jsx_fragment] = STATE(4855),
    [sym_yield_expression] = STATE(4855),
    [sym_jsx_element] = STATE(4855),
    [sym_internal_module] = STATE(4855),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4855),
    [sym_await_expression] = STATE(4855),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4855),
    [sym_this] = STATE(4855),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4855),
    [sym_generator_function] = STATE(4855),
    [sym_call_expression] = STATE(4855),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4855),
    [sym_ternary_expression] = STATE(4855),
    [sym_binary_expression] = STATE(4855),
    [sym_template_string] = STATE(4855),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4855),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4855),
    [sym_class] = STATE(4855),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9668),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9668),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9670),
    [sym_true] = ACTIONS(9668),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9668),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4664] = {
    [sym_new_expression] = STATE(4856),
    [sym_augmented_assignment_expression] = STATE(4856),
    [sym_unary_expression] = STATE(4856),
    [sym_update_expression] = STATE(4856),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(4856),
    [sym_regex] = STATE(4856),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4856),
    [sym_non_null_expression] = STATE(4856),
    [sym_as_expression] = STATE(4856),
    [sym_jsx_fragment] = STATE(4856),
    [sym_yield_expression] = STATE(4856),
    [sym_jsx_element] = STATE(4856),
    [sym_internal_module] = STATE(4856),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4856),
    [sym_await_expression] = STATE(4856),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(4857),
    [sym_string] = STATE(4856),
    [sym_this] = STATE(4856),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(4856),
    [sym_generator_function] = STATE(4856),
    [sym_call_expression] = STATE(4856),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(4856),
    [sym_ternary_expression] = STATE(4856),
    [sym_binary_expression] = STATE(4856),
    [sym_template_string] = STATE(4856),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4856),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(4856),
    [sym_class] = STATE(4856),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(9672),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(9672),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(9674),
    [sym_true] = ACTIONS(9672),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(9672),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [4665] = {
    [sym_new_expression] = STATE(4858),
    [sym_augmented_assignment_expression] = STATE(4858),
    [sym_unary_expression] = STATE(4858),
    [sym_update_expression] = STATE(4858),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4858),
    [sym_regex] = STATE(4858),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4858),
    [sym_non_null_expression] = STATE(4858),
    [sym_as_expression] = STATE(4858),
    [sym_jsx_fragment] = STATE(4858),
    [sym_yield_expression] = STATE(4858),
    [sym_jsx_element] = STATE(4858),
    [sym_internal_module] = STATE(4858),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4858),
    [sym_await_expression] = STATE(4858),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4858),
    [sym_this] = STATE(4858),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4858),
    [sym_generator_function] = STATE(4858),
    [sym_call_expression] = STATE(4858),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4858),
    [sym_ternary_expression] = STATE(4858),
    [sym_binary_expression] = STATE(4858),
    [sym_template_string] = STATE(4858),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4858),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4858),
    [sym_class] = STATE(4858),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9676),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9676),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9678),
    [sym_true] = ACTIONS(9676),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9676),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4666] = {
    [sym_new_expression] = STATE(4859),
    [sym_augmented_assignment_expression] = STATE(4859),
    [sym_unary_expression] = STATE(4859),
    [sym_update_expression] = STATE(4859),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(4859),
    [sym_regex] = STATE(4859),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4859),
    [sym_non_null_expression] = STATE(4859),
    [sym_as_expression] = STATE(4859),
    [sym_jsx_fragment] = STATE(4859),
    [sym_yield_expression] = STATE(4859),
    [sym_jsx_element] = STATE(4859),
    [sym_internal_module] = STATE(4859),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(4859),
    [sym_await_expression] = STATE(4859),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(4860),
    [sym_string] = STATE(4859),
    [sym_this] = STATE(4859),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(4859),
    [sym_generator_function] = STATE(4859),
    [sym_call_expression] = STATE(4859),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(4859),
    [sym_ternary_expression] = STATE(4859),
    [sym_binary_expression] = STATE(4859),
    [sym_template_string] = STATE(4859),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4859),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(4859),
    [sym_class] = STATE(4859),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(9680),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(9682),
    [sym_true] = ACTIONS(9680),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(9680),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [4667] = {
    [anon_sym_COLON] = ACTIONS(9684),
    [sym_comment] = ACTIONS(3),
  },
  [4668] = {
    [sym_union_type] = STATE(4862),
    [sym__type] = STATE(4862),
    [sym_constructor_type] = STATE(4862),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3280),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4862),
    [sym_function_type] = STATE(4862),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3281),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3109),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6885),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6887),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4669] = {
    [anon_sym_EQ] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_RPAREN] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(8165),
    [anon_sym_COMMA] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(8167),
    [sym_comment] = ACTIONS(3),
  },
  [4670] = {
    [anon_sym_EQ] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_RPAREN] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(8165),
    [anon_sym_COMMA] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(8167),
    [sym_comment] = ACTIONS(3),
  },
  [4671] = {
    [anon_sym_EQ_GT] = ACTIONS(9686),
    [sym_comment] = ACTIONS(3),
  },
  [4672] = {
    [sym_union_type] = STATE(4864),
    [sym__type] = STATE(4864),
    [sym_constructor_type] = STATE(4864),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3930),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4864),
    [sym_function_type] = STATE(4864),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3931),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(5168),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8181),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8183),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4673] = {
    [sym_union_type] = STATE(4865),
    [sym__type] = STATE(4865),
    [sym_constructor_type] = STATE(4865),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3930),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4865),
    [sym_function_type] = STATE(4865),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3931),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(5168),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8181),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8183),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4674] = {
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_RPAREN] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(8923),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(8925),
    [sym_comment] = ACTIONS(3),
  },
  [4675] = {
    [anon_sym_AMP] = ACTIONS(6913),
    [anon_sym_RPAREN] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(6915),
    [anon_sym_COMMA] = ACTIONS(8547),
    [sym_comment] = ACTIONS(3),
  },
  [4676] = {
    [anon_sym_GT] = ACTIONS(6959),
    [sym_jsx_identifier] = ACTIONS(6959),
    [sym_identifier] = ACTIONS(6961),
    [anon_sym_SLASH] = ACTIONS(6961),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6959),
  },
  [4677] = {
    [anon_sym_GT] = ACTIONS(9688),
    [sym_comment] = ACTIONS(3),
  },
  [4678] = {
    [anon_sym_GT] = ACTIONS(6997),
    [sym_jsx_identifier] = ACTIONS(6997),
    [sym_identifier] = ACTIONS(6999),
    [anon_sym_SLASH] = ACTIONS(6999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6997),
  },
  [4679] = {
    [anon_sym_GT] = ACTIONS(7286),
    [sym_jsx_identifier] = ACTIONS(7286),
    [sym_identifier] = ACTIONS(7288),
    [anon_sym_SLASH] = ACTIONS(7288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7286),
  },
  [4680] = {
    [sym_union_type] = STATE(4867),
    [sym__type] = STATE(4867),
    [sym_constructor_type] = STATE(4867),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3332),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4867),
    [sym_function_type] = STATE(4867),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3333),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3319),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(6985),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(6987),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(6989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4681] = {
    [anon_sym_EQ] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_GT] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(8227),
    [anon_sym_COMMA] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(8229),
    [sym_comment] = ACTIONS(3),
  },
  [4682] = {
    [anon_sym_EQ] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_GT] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(8227),
    [anon_sym_COMMA] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(8229),
    [sym_comment] = ACTIONS(3),
  },
  [4683] = {
    [anon_sym_EQ_GT] = ACTIONS(9690),
    [sym_comment] = ACTIONS(3),
  },
  [4684] = {
    [sym_union_type] = STATE(4869),
    [sym__type] = STATE(4869),
    [sym_constructor_type] = STATE(4869),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3966),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4869),
    [sym_function_type] = STATE(4869),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3967),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5347),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8239),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8241),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4685] = {
    [sym_union_type] = STATE(4870),
    [sym__type] = STATE(4870),
    [sym_constructor_type] = STATE(4870),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3966),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4870),
    [sym_function_type] = STATE(4870),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3967),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5347),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8239),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8241),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4686] = {
    [sym__automatic_semicolon] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(8961),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(8963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6040),
  },
  [4687] = {
    [sym__automatic_semicolon] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(7017),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(7019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8547),
  },
  [4688] = {
    [sym_union_type] = STATE(4871),
    [sym__type] = STATE(4871),
    [sym_constructor_type] = STATE(4871),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3352),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4871),
    [sym_function_type] = STATE(4871),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3353),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(3367),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(3369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(7027),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(7029),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(7031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4689] = {
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(8249),
    [anon_sym_PIPE] = ACTIONS(8251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7511),
  },
  [4690] = {
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(8249),
    [anon_sym_PIPE] = ACTIONS(8251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7529),
  },
  [4691] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(9071),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [sym__automatic_semicolon] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(8973),
    [anon_sym_LT_LT] = ACTIONS(8547),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_STAR] = ACTIONS(9071),
    [anon_sym_GT_GT_GT] = ACTIONS(8547),
    [anon_sym_AMP_AMP] = ACTIONS(8547),
    [anon_sym_BANG_EQ] = ACTIONS(9071),
    [anon_sym_LT_EQ] = ACTIONS(8547),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [anon_sym_GT_EQ] = ACTIONS(8547),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_AMP] = ACTIONS(8975),
    [anon_sym_PERCENT] = ACTIONS(8547),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_as] = ACTIONS(8547),
    [anon_sym_PIPE_PIPE] = ACTIONS(8547),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_EQ_EQ] = ACTIONS(9071),
    [anon_sym_instanceof] = ACTIONS(8547),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8547),
    [anon_sym_CARET] = ACTIONS(8547),
    [anon_sym_STAR_STAR] = ACTIONS(8547),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_GT_GT] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8547),
    [anon_sym_in] = ACTIONS(9071),
  },
  [4692] = {
    [sym_new_expression] = STATE(4872),
    [sym_augmented_assignment_expression] = STATE(4872),
    [sym_unary_expression] = STATE(4872),
    [sym_update_expression] = STATE(4872),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4872),
    [sym_regex] = STATE(4872),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4872),
    [sym_non_null_expression] = STATE(4872),
    [sym_as_expression] = STATE(4872),
    [sym_jsx_fragment] = STATE(4872),
    [sym_yield_expression] = STATE(4872),
    [sym_jsx_element] = STATE(4872),
    [sym_internal_module] = STATE(4872),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4872),
    [sym_await_expression] = STATE(4872),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4872),
    [sym_this] = STATE(4872),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4872),
    [sym_generator_function] = STATE(4872),
    [sym_call_expression] = STATE(4872),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4872),
    [sym_ternary_expression] = STATE(4872),
    [sym_binary_expression] = STATE(4872),
    [sym_template_string] = STATE(4872),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4872),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4872),
    [sym_class] = STATE(4872),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9692),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9692),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9694),
    [sym_true] = ACTIONS(9692),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9692),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4693] = {
    [sym_new_expression] = STATE(4873),
    [sym_augmented_assignment_expression] = STATE(4873),
    [sym_unary_expression] = STATE(4873),
    [sym_update_expression] = STATE(4873),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4873),
    [sym_regex] = STATE(4873),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4873),
    [sym_non_null_expression] = STATE(4873),
    [sym_as_expression] = STATE(4873),
    [sym_jsx_fragment] = STATE(4873),
    [sym_yield_expression] = STATE(4873),
    [sym_jsx_element] = STATE(4873),
    [sym_internal_module] = STATE(4873),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4873),
    [sym_await_expression] = STATE(4873),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4873),
    [sym_this] = STATE(4873),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4873),
    [sym_generator_function] = STATE(4873),
    [sym_call_expression] = STATE(4873),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4873),
    [sym_ternary_expression] = STATE(4873),
    [sym_binary_expression] = STATE(4873),
    [sym_template_string] = STATE(4873),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4873),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4873),
    [sym_class] = STATE(4873),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9696),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9698),
    [sym_true] = ACTIONS(9696),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9696),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4694] = {
    [sym_new_expression] = STATE(4874),
    [sym_augmented_assignment_expression] = STATE(4874),
    [sym_unary_expression] = STATE(4874),
    [sym_update_expression] = STATE(4874),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4874),
    [sym_regex] = STATE(4874),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4874),
    [sym_non_null_expression] = STATE(4874),
    [sym_as_expression] = STATE(4874),
    [sym_jsx_fragment] = STATE(4874),
    [sym_yield_expression] = STATE(4874),
    [sym_jsx_element] = STATE(4874),
    [sym_internal_module] = STATE(4874),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4874),
    [sym_await_expression] = STATE(4874),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4874),
    [sym_this] = STATE(4874),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4874),
    [sym_generator_function] = STATE(4874),
    [sym_call_expression] = STATE(4874),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4874),
    [sym_ternary_expression] = STATE(4874),
    [sym_binary_expression] = STATE(4874),
    [sym_template_string] = STATE(4874),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4874),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4874),
    [sym_class] = STATE(4874),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9700),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9700),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9702),
    [sym_true] = ACTIONS(9700),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9700),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4695] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9704),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4696] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9706),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4697] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9708),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4698] = {
    [sym_type_alias_declaration] = STATE(3704),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3704),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3704),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3704),
    [sym_return_statement] = STATE(3704),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3704),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3704),
    [sym_switch_statement] = STATE(3704),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3704),
    [sym_throw_statement] = STATE(3704),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3704),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3704),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(3704),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3704),
    [sym_abstract_class] = STATE(3704),
    [sym_interface_declaration] = STATE(3704),
    [sym_statement_block] = STATE(3704),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3704),
    [sym_debugger_statement] = STATE(3704),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3704),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3704),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3704),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3704),
    [sym_empty_statement] = STATE(3704),
    [sym_import_alias] = STATE(3704),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3704),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3704),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3704),
    [sym_break_statement] = STATE(3704),
    [sym_labeled_statement] = STATE(3704),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3704),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [4699] = {
    [sym_type_alias_declaration] = STATE(3732),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3732),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3732),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3732),
    [sym_return_statement] = STATE(3732),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3732),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3732),
    [sym_switch_statement] = STATE(3732),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3732),
    [sym_throw_statement] = STATE(3732),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3732),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3732),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(3732),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3732),
    [sym_abstract_class] = STATE(3732),
    [sym_interface_declaration] = STATE(3732),
    [sym_statement_block] = STATE(3732),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3732),
    [sym_debugger_statement] = STATE(3732),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3732),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3732),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3732),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3732),
    [sym_empty_statement] = STATE(3732),
    [sym_import_alias] = STATE(3732),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3732),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3732),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3732),
    [sym_break_statement] = STATE(3732),
    [sym_labeled_statement] = STATE(3732),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3732),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [4700] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(9710),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4701] = {
    [anon_sym_RPAREN] = ACTIONS(9710),
    [sym_comment] = ACTIONS(3),
  },
  [4702] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(9712),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4703] = {
    [anon_sym_RPAREN] = ACTIONS(9712),
    [sym_comment] = ACTIONS(3),
  },
  [4704] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(9714),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4705] = {
    [anon_sym_RPAREN] = ACTIONS(9714),
    [sym_comment] = ACTIONS(3),
  },
  [4706] = {
    [sym_type_alias_declaration] = STATE(3737),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3737),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3737),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3737),
    [sym_return_statement] = STATE(3737),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3737),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3737),
    [sym_switch_statement] = STATE(3737),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3737),
    [sym_throw_statement] = STATE(3737),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3737),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3737),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(3737),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3737),
    [sym_abstract_class] = STATE(3737),
    [sym_interface_declaration] = STATE(3737),
    [sym_statement_block] = STATE(3737),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3737),
    [sym_debugger_statement] = STATE(3737),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3737),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3737),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3737),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3737),
    [sym_empty_statement] = STATE(3737),
    [sym_import_alias] = STATE(3737),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3737),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3737),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3737),
    [sym_break_statement] = STATE(3737),
    [sym_labeled_statement] = STATE(3737),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3737),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [4707] = {
    [sym_type_alias_declaration] = STATE(3738),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3738),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3738),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3738),
    [sym_return_statement] = STATE(3738),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3738),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3738),
    [sym_switch_statement] = STATE(3738),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3738),
    [sym_throw_statement] = STATE(3738),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3738),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3738),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(3738),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3738),
    [sym_abstract_class] = STATE(3738),
    [sym_interface_declaration] = STATE(3738),
    [sym_statement_block] = STATE(3738),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3738),
    [sym_debugger_statement] = STATE(3738),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3738),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3738),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3738),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3738),
    [sym_empty_statement] = STATE(3738),
    [sym_import_alias] = STATE(3738),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3738),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3738),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3738),
    [sym_break_statement] = STATE(3738),
    [sym_labeled_statement] = STATE(3738),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3738),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [4708] = {
    [sym_type_alias_declaration] = STATE(3739),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3739),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3739),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3739),
    [sym_return_statement] = STATE(3739),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3739),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3739),
    [sym_switch_statement] = STATE(3739),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3739),
    [sym_throw_statement] = STATE(3739),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3739),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3739),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(3739),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3739),
    [sym_abstract_class] = STATE(3739),
    [sym_interface_declaration] = STATE(3739),
    [sym_statement_block] = STATE(3739),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3739),
    [sym_debugger_statement] = STATE(3739),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3739),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3739),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3739),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3739),
    [sym_empty_statement] = STATE(3739),
    [sym_import_alias] = STATE(3739),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3739),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3739),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3739),
    [sym_break_statement] = STATE(3739),
    [sym_labeled_statement] = STATE(3739),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3739),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [4709] = {
    [sym_type_alias_declaration] = STATE(3740),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3740),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3740),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3740),
    [sym_return_statement] = STATE(3740),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3740),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3740),
    [sym_switch_statement] = STATE(3740),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3740),
    [sym_throw_statement] = STATE(3740),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3740),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3740),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(3740),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3740),
    [sym_abstract_class] = STATE(3740),
    [sym_interface_declaration] = STATE(3740),
    [sym_statement_block] = STATE(3740),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3740),
    [sym_debugger_statement] = STATE(3740),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3740),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3740),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3740),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3740),
    [sym_empty_statement] = STATE(3740),
    [sym_import_alias] = STATE(3740),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3740),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3740),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3740),
    [sym_break_statement] = STATE(3740),
    [sym_labeled_statement] = STATE(3740),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3740),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [4710] = {
    [sym_type_alias_declaration] = STATE(3741),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3741),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3741),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3741),
    [sym_return_statement] = STATE(3741),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3741),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3741),
    [sym_switch_statement] = STATE(3741),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3741),
    [sym_throw_statement] = STATE(3741),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3741),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3741),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(3741),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3741),
    [sym_abstract_class] = STATE(3741),
    [sym_interface_declaration] = STATE(3741),
    [sym_statement_block] = STATE(3741),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3741),
    [sym_debugger_statement] = STATE(3741),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3741),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3741),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3741),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3741),
    [sym_empty_statement] = STATE(3741),
    [sym_import_alias] = STATE(3741),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3741),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3741),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3741),
    [sym_break_statement] = STATE(3741),
    [sym_labeled_statement] = STATE(3741),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3741),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [4711] = {
    [sym_type_arguments] = STATE(1064),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_while] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(9716),
    [anon_sym_else] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(9718),
  },
  [4712] = {
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(4717),
    [sym_array_type] = STATE(1066),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym_existential_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(1066),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(1066),
    [sym_string] = STATE(418),
    [sym_tuple_type] = STATE(1066),
    [sym_identifier] = ACTIONS(9465),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [sym_true] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4713] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(4717),
    [sym_type_parameters] = STATE(4718),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4719),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9465),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9469),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9471),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4714] = {
    [sym_type_parameters] = STATE(4882),
    [sym_formal_parameters] = STATE(4883),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4715] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(4717),
    [sym_type_parameters] = STATE(4718),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4719),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9465),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9469),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9471),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4716] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(9720),
    [anon_sym_PIPE] = ACTIONS(9722),
    [anon_sym_else] = ACTIONS(7948),
    [anon_sym_while] = ACTIONS(7948),
  },
  [4717] = {
    [sym_type_arguments] = STATE(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(9716),
    [anon_sym_else] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
  },
  [4718] = {
    [sym_formal_parameters] = STATE(4886),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4719] = {
    [anon_sym_EQ_GT] = ACTIONS(9724),
    [sym_comment] = ACTIONS(3),
  },
  [4720] = {
    [sym_type_alias_declaration] = STATE(4545),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4545),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4545),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4545),
    [sym_return_statement] = STATE(4545),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4545),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4545),
    [sym_switch_statement] = STATE(4545),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4545),
    [sym_throw_statement] = STATE(4545),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4545),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4545),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(4545),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4545),
    [sym_abstract_class] = STATE(4545),
    [sym_interface_declaration] = STATE(4545),
    [sym_statement_block] = STATE(4545),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4545),
    [sym_debugger_statement] = STATE(4545),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4545),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4545),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4545),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4545),
    [sym_empty_statement] = STATE(4545),
    [sym_import_alias] = STATE(4545),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4545),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4545),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4545),
    [sym_break_statement] = STATE(4545),
    [sym_labeled_statement] = STATE(4545),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4545),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [4721] = {
    [sym_type_alias_declaration] = STATE(4546),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4546),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4546),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4546),
    [sym_return_statement] = STATE(4546),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4546),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4546),
    [sym_switch_statement] = STATE(4546),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4546),
    [sym_throw_statement] = STATE(4546),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4546),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4546),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(4546),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4546),
    [sym_abstract_class] = STATE(4546),
    [sym_interface_declaration] = STATE(4546),
    [sym_statement_block] = STATE(4546),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4546),
    [sym_debugger_statement] = STATE(4546),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4546),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4546),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4546),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4546),
    [sym_empty_statement] = STATE(4546),
    [sym_import_alias] = STATE(4546),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4546),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4546),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4546),
    [sym_break_statement] = STATE(4546),
    [sym_labeled_statement] = STATE(4546),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4546),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [4722] = {
    [sym_type_alias_declaration] = STATE(4547),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4547),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4547),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4547),
    [sym_return_statement] = STATE(4547),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4547),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4547),
    [sym_switch_statement] = STATE(4547),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4547),
    [sym_throw_statement] = STATE(4547),
    [aux_sym_export_statement_repeat1] = STATE(313),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4547),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4547),
    [sym_decorator] = STATE(313),
    [sym_continue_statement] = STATE(4547),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4547),
    [sym_abstract_class] = STATE(4547),
    [sym_interface_declaration] = STATE(4547),
    [sym_statement_block] = STATE(4547),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4547),
    [sym_debugger_statement] = STATE(4547),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4547),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4547),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4547),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4547),
    [sym_empty_statement] = STATE(4547),
    [sym_import_alias] = STATE(4547),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4547),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4547),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4547),
    [sym_break_statement] = STATE(4547),
    [sym_labeled_statement] = STATE(4547),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4547),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(522),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(538),
  },
  [4723] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(4727),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4728),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8345),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9481),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9483),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4724] = {
    [sym_type_parameters] = STATE(4888),
    [sym_formal_parameters] = STATE(4889),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4725] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(4727),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4728),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8345),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9481),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9483),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4726] = {
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(9726),
    [anon_sym_PIPE] = ACTIONS(9728),
    [anon_sym_while] = ACTIONS(5893),
    [sym_comment] = ACTIONS(3),
  },
  [4727] = {
    [sym_formal_parameters] = STATE(4892),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4728] = {
    [anon_sym_EQ_GT] = ACTIONS(9730),
    [sym_comment] = ACTIONS(3),
  },
  [4729] = {
    [anon_sym_EQ_GT] = ACTIONS(9732),
    [sym_comment] = ACTIONS(3),
  },
  [4730] = {
    [sym_union_type] = STATE(4895),
    [sym__type] = STATE(4895),
    [sym_constructor_type] = STATE(4895),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4895),
    [sym_function_type] = STATE(4895),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4035),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8345),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8349),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8351),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4731] = {
    [sym_union_type] = STATE(4896),
    [sym__type] = STATE(4896),
    [sym_constructor_type] = STATE(4896),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4896),
    [sym_function_type] = STATE(4896),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4035),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8345),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8349),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8351),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4732] = {
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_PIPE] = ACTIONS(9055),
    [anon_sym_while] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
  },
  [4733] = {
    [anon_sym_EQ_GT] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(7154),
    [anon_sym_PIPE] = ACTIONS(7156),
    [sym_comment] = ACTIONS(3),
  },
  [4734] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(9071),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(9061),
    [anon_sym_LT_LT] = ACTIONS(8547),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_STAR] = ACTIONS(9071),
    [anon_sym_GT_GT_GT] = ACTIONS(8547),
    [anon_sym_AMP_AMP] = ACTIONS(8547),
    [anon_sym_BANG_EQ] = ACTIONS(9071),
    [anon_sym_LT_EQ] = ACTIONS(8547),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [anon_sym_GT_EQ] = ACTIONS(8547),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_AMP] = ACTIONS(9063),
    [anon_sym_PERCENT] = ACTIONS(8547),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_as] = ACTIONS(8547),
    [anon_sym_PIPE_PIPE] = ACTIONS(8547),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_EQ_EQ] = ACTIONS(9071),
    [anon_sym_instanceof] = ACTIONS(8547),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(8547),
    [anon_sym_DOT] = ACTIONS(8547),
    [anon_sym_CARET] = ACTIONS(8547),
    [anon_sym_STAR_STAR] = ACTIONS(8547),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_GT_GT] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8547),
    [anon_sym_in] = ACTIONS(9071),
  },
  [4735] = {
    [sym_statement_block] = STATE(4292),
    [sym__automatic_semicolon] = ACTIONS(9251),
    [anon_sym_RBRACE] = ACTIONS(9251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(9251),
    [anon_sym_COMMA] = ACTIONS(9251),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [4736] = {
    [sym_type_parameters] = STATE(2715),
    [sym_formal_parameters] = STATE(2716),
    [sym_call_signature] = STATE(4897),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4737] = {
    [sym__automatic_semicolon] = ACTIONS(4485),
    [anon_sym_LBRACK] = ACTIONS(6453),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2011),
    [anon_sym_SEMI] = ACTIONS(4485),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [anon_sym_PERCENT_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_AMP_EQ] = ACTIONS(2011),
    [anon_sym_PLUS_EQ] = ACTIONS(2011),
    [anon_sym_PIPE] = ACTIONS(8388),
    [anon_sym_COMMA] = ACTIONS(6453),
    [anon_sym_LT_LT] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_GT_GT_GT] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_CARET_EQ] = ACTIONS(2011),
    [anon_sym_STAR_EQ] = ACTIONS(2011),
    [anon_sym_PIPE_EQ] = ACTIONS(2011),
    [anon_sym_DASH_EQ] = ACTIONS(2011),
    [anon_sym_RBRACE] = ACTIONS(6453),
    [anon_sym_AMP] = ACTIONS(8388),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_LT_LT_EQ] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2011),
    [anon_sym_PERCENT] = ACTIONS(2013),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_instanceof] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT_EQ] = ACTIONS(2011),
    [anon_sym_DOT] = ACTIONS(6453),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4485),
    [anon_sym_CARET] = ACTIONS(2013),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2011),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_STAR_STAR] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2013),
  },
  [4738] = {
    [sym_union_type] = STATE(1892),
    [sym__type] = STATE(1892),
    [sym_constructor_type] = STATE(1892),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4742),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1892),
    [sym_function_type] = STATE(1892),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4743),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(8421),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(8423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(9498),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(9500),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(9502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4739] = {
    [sym_type_parameters] = STATE(4898),
    [sym_formal_parameters] = STATE(4899),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4740] = {
    [sym_union_type] = STATE(1900),
    [sym__type] = STATE(1900),
    [sym_constructor_type] = STATE(1900),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4742),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(1900),
    [sym_function_type] = STATE(1900),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4743),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(8421),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(8423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(9498),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(9500),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(9502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4741] = {
    [sym__automatic_semicolon] = ACTIONS(5893),
    [anon_sym_RBRACE] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_SEMI] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(9734),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(5893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5893),
  },
  [4742] = {
    [sym_formal_parameters] = STATE(4902),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4743] = {
    [anon_sym_EQ_GT] = ACTIONS(9738),
    [sym_comment] = ACTIONS(3),
  },
  [4744] = {
    [anon_sym_EQ_GT] = ACTIONS(9740),
    [sym_comment] = ACTIONS(3),
  },
  [4745] = {
    [sym_union_type] = STATE(4905),
    [sym__type] = STATE(4905),
    [sym_constructor_type] = STATE(4905),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4073),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4905),
    [sym_function_type] = STATE(4905),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4074),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(8421),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(8423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8425),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8427),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4746] = {
    [sym_union_type] = STATE(4906),
    [sym__type] = STATE(4906),
    [sym_constructor_type] = STATE(4906),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4073),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4906),
    [sym_function_type] = STATE(4906),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4074),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(8421),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(8423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8425),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8427),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4747] = {
    [sym__automatic_semicolon] = ACTIONS(6040),
    [anon_sym_RBRACE] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(9089),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(9091),
    [anon_sym_COMMA] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6040),
  },
  [4748] = {
    [sym_type_parameters] = STATE(2715),
    [sym_formal_parameters] = STATE(2716),
    [sym_call_signature] = STATE(4897),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [4749] = {
    [sym_union_type] = STATE(4908),
    [sym__type] = STATE(4908),
    [sym_constructor_type] = STATE(4908),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3500),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4908),
    [sym_function_type] = STATE(4908),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3501),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(7341),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(7347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(7345),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(7349),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(7343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4750] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_BANG] = ACTIONS(8379),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(9510),
    [anon_sym_LT_LT] = ACTIONS(7511),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_STAR] = ACTIONS(8379),
    [anon_sym_GT_GT_GT] = ACTIONS(7511),
    [anon_sym_AMP_AMP] = ACTIONS(7511),
    [anon_sym_BANG_EQ] = ACTIONS(8379),
    [anon_sym_LT_EQ] = ACTIONS(7511),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [anon_sym_GT_EQ] = ACTIONS(7511),
    [anon_sym_GT] = ACTIONS(8379),
    [anon_sym_RBRACE] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(9512),
    [anon_sym_QMARK] = ACTIONS(7511),
    [anon_sym_PERCENT] = ACTIONS(7511),
    [anon_sym_as] = ACTIONS(7511),
    [anon_sym_PIPE_PIPE] = ACTIONS(7511),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_EQ_EQ] = ACTIONS(8379),
    [anon_sym_instanceof] = ACTIONS(7511),
    [anon_sym_LT] = ACTIONS(8379),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7511),
    [anon_sym_CARET] = ACTIONS(7511),
    [anon_sym_STAR_STAR] = ACTIONS(7511),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_GT_GT] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7511),
    [anon_sym_in] = ACTIONS(8379),
  },
  [4751] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_BANG] = ACTIONS(8381),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(9510),
    [anon_sym_LT_LT] = ACTIONS(7529),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_STAR] = ACTIONS(8381),
    [anon_sym_GT_GT_GT] = ACTIONS(7529),
    [anon_sym_AMP_AMP] = ACTIONS(7529),
    [anon_sym_BANG_EQ] = ACTIONS(8381),
    [anon_sym_LT_EQ] = ACTIONS(7529),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [anon_sym_GT_EQ] = ACTIONS(7529),
    [anon_sym_GT] = ACTIONS(8381),
    [anon_sym_RBRACE] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(9512),
    [anon_sym_QMARK] = ACTIONS(7529),
    [anon_sym_PERCENT] = ACTIONS(7529),
    [anon_sym_as] = ACTIONS(7529),
    [anon_sym_PIPE_PIPE] = ACTIONS(7529),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_EQ_EQ] = ACTIONS(8381),
    [anon_sym_instanceof] = ACTIONS(7529),
    [anon_sym_LT] = ACTIONS(8381),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7529),
    [anon_sym_CARET] = ACTIONS(7529),
    [anon_sym_STAR_STAR] = ACTIONS(7529),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_GT_GT] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7529),
    [anon_sym_in] = ACTIONS(8381),
  },
  [4752] = {
    [anon_sym_EQ] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(7383),
    [anon_sym_SEMI] = ACTIONS(8547),
    [sym__automatic_semicolon] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(7385),
    [anon_sym_COMMA] = ACTIONS(8547),
    [sym_comment] = ACTIONS(3),
  },
  [4753] = {
    [anon_sym_EQ] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(7401),
    [anon_sym_PIPE] = ACTIONS(7403),
    [sym_comment] = ACTIONS(3),
  },
  [4754] = {
    [sym_union_type] = STATE(4909),
    [sym__type] = STATE(4909),
    [sym_constructor_type] = STATE(4909),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3548),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4909),
    [sym_function_type] = STATE(4909),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3549),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(4053),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(7409),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(7411),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(7413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4755] = {
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(8483),
    [anon_sym_PIPE] = ACTIONS(8485),
    [anon_sym_RBRACK] = ACTIONS(7511),
    [sym_comment] = ACTIONS(3),
  },
  [4756] = {
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(8483),
    [anon_sym_PIPE] = ACTIONS(8485),
    [anon_sym_RBRACK] = ACTIONS(7529),
    [sym_comment] = ACTIONS(3),
  },
  [4757] = {
    [sym__automatic_semicolon] = ACTIONS(9568),
    [anon_sym_RBRACE] = ACTIONS(9568),
    [anon_sym_SEMI] = ACTIONS(9568),
    [anon_sym_COMMA] = ACTIONS(9568),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9568),
    [sym_comment] = ACTIONS(3),
  },
  [4758] = {
    [sym__automatic_semicolon] = ACTIONS(7569),
    [anon_sym_RBRACE] = ACTIONS(7569),
    [anon_sym_SEMI] = ACTIONS(7569),
    [anon_sym_COMMA] = ACTIONS(7569),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7569),
    [sym_comment] = ACTIONS(3),
  },
  [4759] = {
    [sym_computed_property_name] = STATE(1172),
    [sym__enum_member] = STATE(2939),
    [sym__property_name] = STATE(1172),
    [sym_string] = STATE(1172),
    [sym_enum_assignment] = STATE(2939),
    [anon_sym_get] = ACTIONS(1230),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(1232),
    [anon_sym_RBRACE] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(1230),
    [anon_sym_module] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(1230),
    [anon_sym_symbol] = ACTIONS(1230),
    [anon_sym_declare] = ACTIONS(1230),
    [sym_number] = ACTIONS(2431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1230),
    [anon_sym_protected] = ACTIONS(1230),
    [anon_sym_string] = ACTIONS(1230),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(1230),
    [anon_sym_import] = ACTIONS(1230),
    [anon_sym_export] = ACTIONS(1230),
    [anon_sym_namespace] = ACTIONS(1230),
    [anon_sym_any] = ACTIONS(1230),
    [anon_sym_private] = ACTIONS(1230),
    [anon_sym_boolean] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_async] = ACTIONS(1230),
  },
  [4760] = {
    [sym__automatic_semicolon] = ACTIONS(7948),
    [anon_sym_RBRACE] = ACTIONS(7948),
    [anon_sym_AMP] = ACTIONS(7479),
    [anon_sym_SEMI] = ACTIONS(7948),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7948),
    [anon_sym_PIPE] = ACTIONS(7481),
    [anon_sym_COMMA] = ACTIONS(7948),
    [sym_comment] = ACTIONS(3),
  },
  [4761] = {
    [sym__automatic_semicolon] = ACTIONS(7626),
    [anon_sym_RBRACE] = ACTIONS(7626),
    [anon_sym_SEMI] = ACTIONS(7626),
    [anon_sym_COMMA] = ACTIONS(7626),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7626),
    [sym_comment] = ACTIONS(3),
  },
  [4762] = {
    [sym__automatic_semicolon] = ACTIONS(7638),
    [anon_sym_RBRACE] = ACTIONS(7638),
    [anon_sym_SEMI] = ACTIONS(7638),
    [anon_sym_COMMA] = ACTIONS(7638),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7638),
    [sym_comment] = ACTIONS(3),
  },
  [4763] = {
    [anon_sym_EQ_GT] = ACTIONS(9746),
    [sym_comment] = ACTIONS(3),
  },
  [4764] = {
    [sym_union_type] = STATE(4912),
    [sym__type] = STATE(4912),
    [sym_constructor_type] = STATE(4912),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4147),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4912),
    [sym_function_type] = STATE(4912),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4148),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5967),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8527),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8529),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4765] = {
    [sym_union_type] = STATE(4913),
    [sym__type] = STATE(4913),
    [sym_constructor_type] = STATE(4913),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4147),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4913),
    [sym_function_type] = STATE(4913),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4148),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5967),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8527),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8529),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4766] = {
    [sym__automatic_semicolon] = ACTIONS(6040),
    [anon_sym_RBRACE] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(9141),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(9143),
    [anon_sym_COMMA] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
  },
  [4767] = {
    [sym__automatic_semicolon] = ACTIONS(8547),
    [anon_sym_RBRACE] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(7479),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(7481),
    [anon_sym_COMMA] = ACTIONS(8547),
    [sym_comment] = ACTIONS(3),
  },
  [4768] = {
    [sym_type_parameters] = STATE(1082),
    [sym_formal_parameters] = STATE(1081),
    [sym_call_signature] = STATE(4914),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4769] = {
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_COMMA] = ACTIONS(8547),
    [anon_sym_RBRACK] = ACTIONS(8547),
    [sym_comment] = ACTIONS(3),
  },
  [4770] = {
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_RPAREN] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(7513),
    [anon_sym_PIPE] = ACTIONS(7515),
    [sym_comment] = ACTIONS(3),
  },
  [4771] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(9071),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(9157),
    [anon_sym_COMMA] = ACTIONS(8547),
    [anon_sym_LT_LT] = ACTIONS(8547),
    [anon_sym_STAR] = ACTIONS(9071),
    [anon_sym_LBRACE] = ACTIONS(9071),
    [anon_sym_AMP_AMP] = ACTIONS(8547),
    [anon_sym_GT_GT_GT] = ACTIONS(8547),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_BANG_EQ] = ACTIONS(9071),
    [anon_sym_LT_EQ] = ACTIONS(8547),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [anon_sym_GT_EQ] = ACTIONS(8547),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_AMP] = ACTIONS(9159),
    [anon_sym_PERCENT] = ACTIONS(8547),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_LBRACE_PIPE] = ACTIONS(8547),
    [anon_sym_as] = ACTIONS(8547),
    [anon_sym_PIPE_PIPE] = ACTIONS(8547),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_EQ_EQ] = ACTIONS(9071),
    [anon_sym_instanceof] = ACTIONS(8547),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8547),
    [anon_sym_CARET] = ACTIONS(8547),
    [anon_sym_STAR_STAR] = ACTIONS(8547),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_GT_GT] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8547),
    [anon_sym_in] = ACTIONS(9071),
  },
  [4772] = {
    [sym_type_alias_declaration] = STATE(4545),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4545),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4545),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4545),
    [sym_return_statement] = STATE(4545),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4545),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4545),
    [sym_switch_statement] = STATE(4545),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4545),
    [sym_throw_statement] = STATE(4545),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4545),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4545),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(4545),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4545),
    [sym_abstract_class] = STATE(4545),
    [sym_interface_declaration] = STATE(4545),
    [sym_statement_block] = STATE(4545),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4545),
    [sym_debugger_statement] = STATE(4545),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4545),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4545),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4545),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4545),
    [sym_empty_statement] = STATE(4545),
    [sym_import_alias] = STATE(4545),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4545),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4545),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4545),
    [sym_break_statement] = STATE(4545),
    [sym_labeled_statement] = STATE(4545),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4545),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [4773] = {
    [sym_type_alias_declaration] = STATE(4546),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4546),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4546),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4546),
    [sym_return_statement] = STATE(4546),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4546),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4546),
    [sym_switch_statement] = STATE(4546),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4546),
    [sym_throw_statement] = STATE(4546),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4546),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4546),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(4546),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4546),
    [sym_abstract_class] = STATE(4546),
    [sym_interface_declaration] = STATE(4546),
    [sym_statement_block] = STATE(4546),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4546),
    [sym_debugger_statement] = STATE(4546),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4546),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4546),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4546),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4546),
    [sym_empty_statement] = STATE(4546),
    [sym_import_alias] = STATE(4546),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4546),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4546),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4546),
    [sym_break_statement] = STATE(4546),
    [sym_labeled_statement] = STATE(4546),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4546),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [4774] = {
    [sym_type_alias_declaration] = STATE(4547),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4547),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4547),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4547),
    [sym_return_statement] = STATE(4547),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4547),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4547),
    [sym_switch_statement] = STATE(4547),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4547),
    [sym_throw_statement] = STATE(4547),
    [aux_sym_export_statement_repeat1] = STATE(485),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4547),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4547),
    [sym_decorator] = STATE(485),
    [sym_continue_statement] = STATE(4547),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4547),
    [sym_abstract_class] = STATE(4547),
    [sym_interface_declaration] = STATE(4547),
    [sym_statement_block] = STATE(4547),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4547),
    [sym_debugger_statement] = STATE(4547),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4547),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4547),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4547),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4547),
    [sym_empty_statement] = STATE(4547),
    [sym_import_alias] = STATE(4547),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4547),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4547),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4547),
    [sym_break_statement] = STATE(4547),
    [sym_labeled_statement] = STATE(4547),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4547),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(869),
  },
  [4775] = {
    [sym_identifier] = ACTIONS(7192),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [anon_sym_debugger] = ACTIONS(7192),
    [anon_sym_symbol] = ACTIONS(7192),
    [anon_sym_AT] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(9189),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_void] = ACTIONS(7192),
    [anon_sym_break] = ACTIONS(7192),
    [anon_sym_const] = ACTIONS(7192),
    [sym_super] = ACTIONS(7192),
    [anon_sym_return] = ACTIONS(7192),
    [anon_sym_private] = ACTIONS(7192),
    [anon_sym_get] = ACTIONS(7192),
    [anon_sym_interface] = ACTIONS(7192),
    [anon_sym_enum] = ACTIONS(7192),
    [anon_sym_delete] = ACTIONS(7192),
    [anon_sym_continue] = ACTIONS(7192),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_if] = ACTIONS(7192),
    [anon_sym_this] = ACTIONS(7192),
    [anon_sym_yield] = ACTIONS(7192),
    [sym_true] = ACTIONS(7192),
    [anon_sym_throw] = ACTIONS(7192),
    [anon_sym_protected] = ACTIONS(7192),
    [anon_sym_abstract] = ACTIONS(7192),
    [anon_sym_set] = ACTIONS(7192),
    [anon_sym_type] = ACTIONS(7192),
    [anon_sym_import] = ACTIONS(7192),
    [anon_sym_namespace] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_await] = ACTIONS(7192),
    [anon_sym_DQUOTE] = ACTIONS(5893),
    [anon_sym_else] = ACTIONS(7192),
    [anon_sym_BANG] = ACTIONS(5893),
    [anon_sym_for] = ACTIONS(7192),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [sym_false] = ACTIONS(7192),
    [anon_sym_SEMI] = ACTIONS(5893),
    [anon_sym_module] = ACTIONS(7192),
    [anon_sym_number] = ACTIONS(7192),
    [anon_sym_class] = ACTIONS(7192),
    [anon_sym_declare] = ACTIONS(7192),
    [anon_sym_typeof] = ACTIONS(7192),
    [anon_sym_LBRACE] = ACTIONS(5893),
    [anon_sym_switch] = ACTIONS(7192),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [sym_null] = ACTIONS(7192),
    [anon_sym_any] = ACTIONS(7192),
    [anon_sym_boolean] = ACTIONS(7192),
    [anon_sym_async] = ACTIONS(7192),
    [anon_sym_public] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(9191),
    [anon_sym_var] = ACTIONS(7192),
    [anon_sym_while] = ACTIONS(7192),
    [anon_sym_SQUOTE] = ACTIONS(5893),
    [anon_sym_try] = ACTIONS(7192),
    [anon_sym_LT] = ACTIONS(5893),
    [sym_number] = ACTIONS(5893),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7192),
    [anon_sym_function] = ACTIONS(7192),
    [sym_undefined] = ACTIONS(7192),
    [anon_sym_new] = ACTIONS(7192),
    [ts_builtin_sym_end] = ACTIONS(5893),
    [anon_sym_let] = ACTIONS(7192),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_export] = ACTIONS(7192),
    [anon_sym_do] = ACTIONS(7192),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_with] = ACTIONS(7192),
  },
  [4776] = {
    [anon_sym_EQ_GT] = ACTIONS(9748),
    [sym_comment] = ACTIONS(3),
  },
  [4777] = {
    [sym_union_type] = STATE(4916),
    [sym__type] = STATE(4916),
    [sym_constructor_type] = STATE(4916),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4200),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4916),
    [sym_function_type] = STATE(4916),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4201),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8615),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8619),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8621),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4778] = {
    [sym_union_type] = STATE(4917),
    [sym__type] = STATE(4917),
    [sym_constructor_type] = STATE(4917),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4200),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4917),
    [sym_function_type] = STATE(4917),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4201),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8615),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8619),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8621),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4779] = {
    [sym_identifier] = ACTIONS(7208),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [anon_sym_debugger] = ACTIONS(7208),
    [anon_sym_symbol] = ACTIONS(7208),
    [anon_sym_AT] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(9189),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_void] = ACTIONS(7208),
    [anon_sym_break] = ACTIONS(7208),
    [anon_sym_const] = ACTIONS(7208),
    [sym_super] = ACTIONS(7208),
    [anon_sym_return] = ACTIONS(7208),
    [anon_sym_private] = ACTIONS(7208),
    [anon_sym_get] = ACTIONS(7208),
    [anon_sym_interface] = ACTIONS(7208),
    [anon_sym_enum] = ACTIONS(7208),
    [anon_sym_delete] = ACTIONS(7208),
    [anon_sym_continue] = ACTIONS(7208),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_if] = ACTIONS(7208),
    [anon_sym_this] = ACTIONS(7208),
    [anon_sym_yield] = ACTIONS(7208),
    [sym_true] = ACTIONS(7208),
    [anon_sym_throw] = ACTIONS(7208),
    [anon_sym_protected] = ACTIONS(7208),
    [anon_sym_abstract] = ACTIONS(7208),
    [anon_sym_set] = ACTIONS(7208),
    [anon_sym_type] = ACTIONS(7208),
    [anon_sym_import] = ACTIONS(7208),
    [anon_sym_namespace] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_await] = ACTIONS(7208),
    [anon_sym_DQUOTE] = ACTIONS(6040),
    [anon_sym_else] = ACTIONS(7208),
    [anon_sym_BANG] = ACTIONS(6040),
    [anon_sym_for] = ACTIONS(7208),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [sym_false] = ACTIONS(7208),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_module] = ACTIONS(7208),
    [anon_sym_number] = ACTIONS(7208),
    [anon_sym_class] = ACTIONS(7208),
    [anon_sym_declare] = ACTIONS(7208),
    [anon_sym_typeof] = ACTIONS(7208),
    [anon_sym_LBRACE] = ACTIONS(6040),
    [anon_sym_switch] = ACTIONS(7208),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [sym_null] = ACTIONS(7208),
    [anon_sym_any] = ACTIONS(7208),
    [anon_sym_boolean] = ACTIONS(7208),
    [anon_sym_async] = ACTIONS(7208),
    [anon_sym_public] = ACTIONS(7208),
    [anon_sym_AMP] = ACTIONS(9191),
    [anon_sym_var] = ACTIONS(7208),
    [anon_sym_while] = ACTIONS(7208),
    [anon_sym_SQUOTE] = ACTIONS(6040),
    [anon_sym_try] = ACTIONS(7208),
    [anon_sym_LT] = ACTIONS(6040),
    [sym_number] = ACTIONS(6040),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7208),
    [anon_sym_function] = ACTIONS(7208),
    [sym_undefined] = ACTIONS(7208),
    [anon_sym_new] = ACTIONS(7208),
    [ts_builtin_sym_end] = ACTIONS(6040),
    [anon_sym_let] = ACTIONS(7208),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_export] = ACTIONS(7208),
    [anon_sym_do] = ACTIONS(7208),
    [anon_sym_TILDE] = ACTIONS(6040),
    [anon_sym_with] = ACTIONS(7208),
  },
  [4780] = {
    [sym__automatic_semicolon] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(7628),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(7630),
    [sym_comment] = ACTIONS(3),
  },
  [4781] = {
    [sym_union_type] = STATE(4918),
    [sym__type] = STATE(4918),
    [sym_constructor_type] = STATE(4918),
    [sym_index_type_query] = STATE(946),
    [sym_lookup_type] = STATE(946),
    [sym_flow_maybe_type] = STATE(946),
    [sym_parenthesized_type] = STATE(946),
    [sym_nested_type_identifier] = STATE(942),
    [sym_type_parameters] = STATE(3696),
    [sym_array_type] = STATE(946),
    [sym_type_predicate] = STATE(946),
    [sym_type_query] = STATE(946),
    [sym_existential_type] = STATE(946),
    [sym_this_type] = STATE(946),
    [sym_nested_identifier] = STATE(944),
    [sym_object_type] = STATE(946),
    [sym_intersection_type] = STATE(4918),
    [sym_function_type] = STATE(4918),
    [sym__primary_type] = STATE(946),
    [sym_generic_type] = STATE(946),
    [sym_literal_type] = STATE(946),
    [sym__number] = STATE(927),
    [sym_predefined_type] = STATE(946),
    [sym_string] = STATE(927),
    [sym_formal_parameters] = STATE(3697),
    [sym_tuple_type] = STATE(946),
    [sym_identifier] = ACTIONS(7727),
    [sym_false] = ACTIONS(1907),
    [anon_sym_QMARK] = ACTIONS(7733),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(7731),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_number] = ACTIONS(1911),
    [anon_sym_symbol] = ACTIONS(1911),
    [anon_sym_this] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_keyof] = ACTIONS(1915),
    [sym_number] = ACTIONS(1935),
    [sym_true] = ACTIONS(1907),
    [anon_sym_void] = ACTIONS(1911),
    [anon_sym_string] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_new] = ACTIONS(7735),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(7729),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_boolean] = ACTIONS(1911),
  },
  [4782] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_BANG] = ACTIONS(8379),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [sym__automatic_semicolon] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(9554),
    [anon_sym_COMMA] = ACTIONS(7511),
    [anon_sym_LT_LT] = ACTIONS(7511),
    [anon_sym_STAR] = ACTIONS(8379),
    [anon_sym_GT_GT_GT] = ACTIONS(7511),
    [anon_sym_AMP_AMP] = ACTIONS(7511),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_BANG_EQ] = ACTIONS(8379),
    [anon_sym_LT_EQ] = ACTIONS(7511),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [anon_sym_GT_EQ] = ACTIONS(7511),
    [anon_sym_GT] = ACTIONS(8379),
    [anon_sym_AMP] = ACTIONS(9556),
    [anon_sym_PERCENT] = ACTIONS(7511),
    [anon_sym_QMARK] = ACTIONS(7511),
    [anon_sym_as] = ACTIONS(7511),
    [anon_sym_PIPE_PIPE] = ACTIONS(7511),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_EQ_EQ] = ACTIONS(8379),
    [anon_sym_RPAREN] = ACTIONS(7511),
    [anon_sym_LT] = ACTIONS(8379),
    [anon_sym_instanceof] = ACTIONS(7511),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7511),
    [anon_sym_CARET] = ACTIONS(7511),
    [anon_sym_STAR_STAR] = ACTIONS(7511),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_GT_GT] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7511),
    [anon_sym_in] = ACTIONS(8379),
  },
  [4783] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_BANG] = ACTIONS(8381),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [sym__automatic_semicolon] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(9554),
    [anon_sym_COMMA] = ACTIONS(7529),
    [anon_sym_LT_LT] = ACTIONS(7529),
    [anon_sym_STAR] = ACTIONS(8381),
    [anon_sym_GT_GT_GT] = ACTIONS(7529),
    [anon_sym_AMP_AMP] = ACTIONS(7529),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_BANG_EQ] = ACTIONS(8381),
    [anon_sym_LT_EQ] = ACTIONS(7529),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [anon_sym_GT_EQ] = ACTIONS(7529),
    [anon_sym_GT] = ACTIONS(8381),
    [anon_sym_AMP] = ACTIONS(9556),
    [anon_sym_PERCENT] = ACTIONS(7529),
    [anon_sym_QMARK] = ACTIONS(7529),
    [anon_sym_as] = ACTIONS(7529),
    [anon_sym_PIPE_PIPE] = ACTIONS(7529),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_EQ_EQ] = ACTIONS(8381),
    [anon_sym_RPAREN] = ACTIONS(7529),
    [anon_sym_LT] = ACTIONS(8381),
    [anon_sym_instanceof] = ACTIONS(7529),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7529),
    [anon_sym_CARET] = ACTIONS(7529),
    [anon_sym_STAR_STAR] = ACTIONS(7529),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_GT_GT] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7529),
    [anon_sym_in] = ACTIONS(8381),
  },
  [4784] = {
    [sym_union_type] = STATE(4919),
    [sym__type] = STATE(4919),
    [sym_constructor_type] = STATE(4919),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3724),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4919),
    [sym_function_type] = STATE(4919),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3725),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(7804),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(7810),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(7808),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(7812),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(7806),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4785] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_BANG] = ACTIONS(8379),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(9560),
    [anon_sym_LT_LT] = ACTIONS(7511),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_STAR] = ACTIONS(8379),
    [anon_sym_GT_GT_GT] = ACTIONS(7511),
    [anon_sym_AMP_AMP] = ACTIONS(7511),
    [anon_sym_BANG_EQ] = ACTIONS(8379),
    [anon_sym_LT_EQ] = ACTIONS(7511),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [anon_sym_GT_EQ] = ACTIONS(7511),
    [anon_sym_GT] = ACTIONS(8379),
    [anon_sym_AMP] = ACTIONS(9562),
    [anon_sym_PERCENT] = ACTIONS(7511),
    [anon_sym_QMARK] = ACTIONS(7511),
    [anon_sym_as] = ACTIONS(7511),
    [anon_sym_PIPE_PIPE] = ACTIONS(7511),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_EQ_EQ] = ACTIONS(8379),
    [anon_sym_RPAREN] = ACTIONS(7511),
    [anon_sym_LT] = ACTIONS(8379),
    [anon_sym_instanceof] = ACTIONS(7511),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7511),
    [anon_sym_CARET] = ACTIONS(7511),
    [anon_sym_STAR_STAR] = ACTIONS(7511),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_GT_GT] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7511),
    [anon_sym_in] = ACTIONS(8379),
  },
  [4786] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_BANG] = ACTIONS(8381),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(9560),
    [anon_sym_LT_LT] = ACTIONS(7529),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_STAR] = ACTIONS(8381),
    [anon_sym_GT_GT_GT] = ACTIONS(7529),
    [anon_sym_AMP_AMP] = ACTIONS(7529),
    [anon_sym_BANG_EQ] = ACTIONS(8381),
    [anon_sym_LT_EQ] = ACTIONS(7529),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [anon_sym_GT_EQ] = ACTIONS(7529),
    [anon_sym_GT] = ACTIONS(8381),
    [anon_sym_AMP] = ACTIONS(9562),
    [anon_sym_PERCENT] = ACTIONS(7529),
    [anon_sym_QMARK] = ACTIONS(7529),
    [anon_sym_as] = ACTIONS(7529),
    [anon_sym_PIPE_PIPE] = ACTIONS(7529),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_EQ_EQ] = ACTIONS(8381),
    [anon_sym_RPAREN] = ACTIONS(7529),
    [anon_sym_LT] = ACTIONS(8381),
    [anon_sym_instanceof] = ACTIONS(7529),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(7529),
    [anon_sym_CARET] = ACTIONS(7529),
    [anon_sym_STAR_STAR] = ACTIONS(7529),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_GT_GT] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7529),
    [anon_sym_in] = ACTIONS(8381),
  },
  [4787] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(9071),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(9243),
    [anon_sym_LT_LT] = ACTIONS(8547),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_STAR] = ACTIONS(9071),
    [anon_sym_GT_GT_GT] = ACTIONS(8547),
    [anon_sym_AMP_AMP] = ACTIONS(8547),
    [anon_sym_BANG_EQ] = ACTIONS(9071),
    [anon_sym_LT_EQ] = ACTIONS(8547),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [anon_sym_RBRACK] = ACTIONS(8547),
    [anon_sym_GT_EQ] = ACTIONS(8547),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_AMP] = ACTIONS(9245),
    [anon_sym_PERCENT] = ACTIONS(8547),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_as] = ACTIONS(8547),
    [anon_sym_PIPE_PIPE] = ACTIONS(8547),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_EQ_EQ] = ACTIONS(9071),
    [anon_sym_instanceof] = ACTIONS(8547),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8547),
    [anon_sym_CARET] = ACTIONS(8547),
    [anon_sym_STAR_STAR] = ACTIONS(8547),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_GT_GT] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8547),
    [anon_sym_in] = ACTIONS(9071),
  },
  [4788] = {
    [sym__automatic_semicolon] = ACTIONS(9588),
    [anon_sym_LBRACK] = ACTIONS(9588),
    [sym_identifier] = ACTIONS(9750),
    [anon_sym_SEMI] = ACTIONS(9588),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_symbol] = ACTIONS(9750),
    [anon_sym_number] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9588),
    [anon_sym_declare] = ACTIONS(9750),
    [anon_sym_STAR] = ACTIONS(9588),
    [anon_sym_void] = ACTIONS(9750),
    [anon_sym_any] = ACTIONS(9750),
    [anon_sym_private] = ACTIONS(9750),
    [anon_sym_boolean] = ACTIONS(9750),
    [anon_sym_async] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_get] = ACTIONS(9750),
    [anon_sym_RBRACE] = ACTIONS(9588),
    [anon_sym_static] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9588),
    [sym_number] = ACTIONS(9588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(9750),
    [anon_sym_string] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_set] = ACTIONS(9750),
    [anon_sym_type] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_namespace] = ACTIONS(9750),
    [sym_readonly] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9588),
  },
  [4789] = {
    [sym_formal_parameters] = STATE(4920),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4790] = {
    [anon_sym_EQ_GT] = ACTIONS(9752),
    [sym_comment] = ACTIONS(3),
  },
  [4791] = {
    [sym_union_type] = STATE(2790),
    [sym__type] = STATE(2790),
    [sym_constructor_type] = STATE(2790),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4572),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2790),
    [sym_function_type] = STATE(2790),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4573),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(7911),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(7913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(9255),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(9257),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(9259),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4792] = {
    [sym_union_type] = STATE(2791),
    [sym__type] = STATE(2791),
    [sym_constructor_type] = STATE(2791),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4572),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2791),
    [sym_function_type] = STATE(2791),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4573),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(7911),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(7913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(9255),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(9257),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(9259),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4793] = {
    [anon_sym_EQ_GT] = ACTIONS(9754),
    [sym_comment] = ACTIONS(3),
  },
  [4794] = {
    [sym_union_type] = STATE(4923),
    [sym__type] = STATE(4923),
    [sym_constructor_type] = STATE(4923),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4572),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4923),
    [sym_function_type] = STATE(4923),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4573),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(7911),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(7913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(9255),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(9257),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(9259),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4795] = {
    [sym_union_type] = STATE(4924),
    [sym__type] = STATE(4924),
    [sym_constructor_type] = STATE(4924),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3793),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4924),
    [sym_function_type] = STATE(4924),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3794),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(7911),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(7913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(7915),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(7917),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(7919),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4796] = {
    [sym__automatic_semicolon] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(8737),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_COMMA] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(8739),
    [sym_comment] = ACTIONS(3),
  },
  [4797] = {
    [sym__automatic_semicolon] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(8737),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_COMMA] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(8739),
    [sym_comment] = ACTIONS(3),
  },
  [4798] = {
    [anon_sym_EQ_GT] = ACTIONS(9756),
    [sym_comment] = ACTIONS(3),
  },
  [4799] = {
    [sym_union_type] = STATE(4926),
    [sym__type] = STATE(4926),
    [sym_constructor_type] = STATE(4926),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4271),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4926),
    [sym_function_type] = STATE(4926),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4272),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(6598),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(6600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8743),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8745),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4800] = {
    [sym_union_type] = STATE(4927),
    [sym__type] = STATE(4927),
    [sym_constructor_type] = STATE(4927),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4271),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4927),
    [sym_function_type] = STATE(4927),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4272),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(6598),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(6600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8743),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8745),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4801] = {
    [sym__automatic_semicolon] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(9265),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(9267),
    [anon_sym_COMMA] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6040),
  },
  [4802] = {
    [sym__automatic_semicolon] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(7923),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_COMMA] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(7925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8547),
  },
  [4803] = {
    [sym_statement_block] = STATE(4928),
    [sym__automatic_semicolon] = ACTIONS(9758),
    [anon_sym_SEMI] = ACTIONS(9758),
    [anon_sym_COMMA] = ACTIONS(9758),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4899),
  },
  [4804] = {
    [sym_identifier] = ACTIONS(6025),
    [anon_sym_BQUOTE] = ACTIONS(6023),
    [anon_sym_debugger] = ACTIONS(6025),
    [anon_sym_symbol] = ACTIONS(6025),
    [anon_sym_AT] = ACTIONS(6023),
    [anon_sym_PIPE] = ACTIONS(6023),
    [anon_sym_DASH] = ACTIONS(6025),
    [anon_sym_void] = ACTIONS(6025),
    [anon_sym_break] = ACTIONS(6025),
    [anon_sym_const] = ACTIONS(6025),
    [sym_super] = ACTIONS(6025),
    [anon_sym_return] = ACTIONS(6025),
    [anon_sym_private] = ACTIONS(6025),
    [anon_sym_get] = ACTIONS(6025),
    [anon_sym_RBRACE] = ACTIONS(6023),
    [anon_sym_interface] = ACTIONS(6025),
    [anon_sym_default] = ACTIONS(6025),
    [anon_sym_enum] = ACTIONS(6025),
    [anon_sym_delete] = ACTIONS(6025),
    [anon_sym_continue] = ACTIONS(6025),
    [anon_sym_DASH_DASH] = ACTIONS(6023),
    [anon_sym_if] = ACTIONS(6025),
    [anon_sym_this] = ACTIONS(6025),
    [anon_sym_yield] = ACTIONS(6025),
    [sym_true] = ACTIONS(6025),
    [anon_sym_throw] = ACTIONS(6025),
    [anon_sym_protected] = ACTIONS(6025),
    [anon_sym_abstract] = ACTIONS(6025),
    [anon_sym_set] = ACTIONS(6025),
    [anon_sym_type] = ACTIONS(6025),
    [anon_sym_import] = ACTIONS(6025),
    [anon_sym_namespace] = ACTIONS(6025),
    [anon_sym_PLUS_PLUS] = ACTIONS(6023),
    [anon_sym_await] = ACTIONS(6025),
    [anon_sym_DQUOTE] = ACTIONS(6023),
    [anon_sym_else] = ACTIONS(6025),
    [anon_sym_BANG] = ACTIONS(6023),
    [anon_sym_for] = ACTIONS(6025),
    [anon_sym_LBRACK] = ACTIONS(6023),
    [sym_false] = ACTIONS(6025),
    [anon_sym_SEMI] = ACTIONS(6023),
    [anon_sym_case] = ACTIONS(6025),
    [anon_sym_module] = ACTIONS(6025),
    [anon_sym_number] = ACTIONS(6025),
    [anon_sym_class] = ACTIONS(6025),
    [anon_sym_declare] = ACTIONS(6025),
    [anon_sym_typeof] = ACTIONS(6025),
    [anon_sym_LBRACE] = ACTIONS(6023),
    [anon_sym_switch] = ACTIONS(6025),
    [anon_sym_LPAREN] = ACTIONS(6023),
    [sym_null] = ACTIONS(6025),
    [anon_sym_any] = ACTIONS(6025),
    [anon_sym_boolean] = ACTIONS(6025),
    [anon_sym_async] = ACTIONS(6025),
    [anon_sym_public] = ACTIONS(6025),
    [anon_sym_AMP] = ACTIONS(6023),
    [anon_sym_var] = ACTIONS(6025),
    [anon_sym_while] = ACTIONS(6025),
    [anon_sym_SQUOTE] = ACTIONS(6023),
    [anon_sym_try] = ACTIONS(6025),
    [anon_sym_LT] = ACTIONS(6023),
    [sym_number] = ACTIONS(6023),
    [anon_sym_SLASH] = ACTIONS(6025),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(6025),
    [anon_sym_function] = ACTIONS(6025),
    [sym_undefined] = ACTIONS(6025),
    [anon_sym_new] = ACTIONS(6025),
    [ts_builtin_sym_end] = ACTIONS(6023),
    [anon_sym_let] = ACTIONS(6025),
    [anon_sym_PLUS] = ACTIONS(6025),
    [anon_sym_export] = ACTIONS(6025),
    [anon_sym_do] = ACTIONS(6025),
    [anon_sym_TILDE] = ACTIONS(6023),
    [anon_sym_with] = ACTIONS(6025),
  },
  [4805] = {
    [sym_union_type] = STATE(2014),
    [sym__type] = STATE(2014),
    [sym_constructor_type] = STATE(2014),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(434),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2014),
    [sym_function_type] = STATE(2014),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(437),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(751),
    [sym_false] = ACTIONS(753),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_keyof] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_PIPE] = ACTIONS(783),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_GT] = ACTIONS(9760),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_boolean] = ACTIONS(763),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(755),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_this] = ACTIONS(765),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_LT] = ACTIONS(472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(314),
  },
  [4806] = {
    [sym_identifier] = ACTIONS(9071),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [anon_sym_debugger] = ACTIONS(9071),
    [anon_sym_symbol] = ACTIONS(9071),
    [anon_sym_AT] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(7950),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_void] = ACTIONS(9071),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_const] = ACTIONS(9071),
    [sym_super] = ACTIONS(9071),
    [anon_sym_return] = ACTIONS(9071),
    [anon_sym_private] = ACTIONS(9071),
    [anon_sym_get] = ACTIONS(9071),
    [anon_sym_interface] = ACTIONS(9071),
    [anon_sym_enum] = ACTIONS(9071),
    [anon_sym_delete] = ACTIONS(9071),
    [anon_sym_continue] = ACTIONS(9071),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_if] = ACTIONS(9071),
    [anon_sym_this] = ACTIONS(9071),
    [anon_sym_yield] = ACTIONS(9071),
    [sym_true] = ACTIONS(9071),
    [anon_sym_throw] = ACTIONS(9071),
    [anon_sym_protected] = ACTIONS(9071),
    [anon_sym_abstract] = ACTIONS(9071),
    [anon_sym_set] = ACTIONS(9071),
    [anon_sym_type] = ACTIONS(9071),
    [anon_sym_import] = ACTIONS(9071),
    [anon_sym_namespace] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_await] = ACTIONS(9071),
    [anon_sym_DQUOTE] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8547),
    [anon_sym_for] = ACTIONS(9071),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [sym_false] = ACTIONS(9071),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_module] = ACTIONS(9071),
    [anon_sym_number] = ACTIONS(9071),
    [anon_sym_class] = ACTIONS(9071),
    [anon_sym_declare] = ACTIONS(9071),
    [anon_sym_typeof] = ACTIONS(9071),
    [anon_sym_LBRACE] = ACTIONS(8547),
    [anon_sym_switch] = ACTIONS(9071),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [sym_null] = ACTIONS(9071),
    [anon_sym_any] = ACTIONS(9071),
    [anon_sym_boolean] = ACTIONS(9071),
    [anon_sym_async] = ACTIONS(9071),
    [anon_sym_public] = ACTIONS(9071),
    [anon_sym_AMP] = ACTIONS(7952),
    [anon_sym_var] = ACTIONS(9071),
    [anon_sym_while] = ACTIONS(9071),
    [anon_sym_SQUOTE] = ACTIONS(8547),
    [anon_sym_try] = ACTIONS(9071),
    [anon_sym_LT] = ACTIONS(8547),
    [sym_number] = ACTIONS(8547),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9071),
    [anon_sym_function] = ACTIONS(9071),
    [sym_undefined] = ACTIONS(9071),
    [anon_sym_new] = ACTIONS(9071),
    [ts_builtin_sym_end] = ACTIONS(8547),
    [anon_sym_let] = ACTIONS(9071),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_export] = ACTIONS(9071),
    [anon_sym_do] = ACTIONS(9071),
    [anon_sym_TILDE] = ACTIONS(8547),
    [anon_sym_with] = ACTIONS(9071),
  },
  [4807] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(9071),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [sym__automatic_semicolon] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(9283),
    [anon_sym_COMMA] = ACTIONS(8547),
    [anon_sym_LT_LT] = ACTIONS(8547),
    [anon_sym_STAR] = ACTIONS(9071),
    [anon_sym_GT_GT_GT] = ACTIONS(8547),
    [anon_sym_AMP_AMP] = ACTIONS(8547),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_BANG_EQ] = ACTIONS(9071),
    [anon_sym_LT_EQ] = ACTIONS(8547),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [anon_sym_GT_EQ] = ACTIONS(8547),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_RBRACE] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(9285),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_PERCENT] = ACTIONS(8547),
    [anon_sym_as] = ACTIONS(8547),
    [anon_sym_PIPE_PIPE] = ACTIONS(8547),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_EQ_EQ] = ACTIONS(9071),
    [anon_sym_instanceof] = ACTIONS(8547),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8547),
    [anon_sym_CARET] = ACTIONS(8547),
    [anon_sym_STAR_STAR] = ACTIONS(8547),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_GT_GT] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8547),
    [anon_sym_in] = ACTIONS(9071),
  },
  [4808] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9762),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4809] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9764),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4810] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9766),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4811] = {
    [sym_type_alias_declaration] = STATE(4210),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4210),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4210),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4210),
    [sym_return_statement] = STATE(4210),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4210),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4210),
    [sym_switch_statement] = STATE(4210),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4210),
    [sym_throw_statement] = STATE(4210),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4210),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4210),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(4210),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4210),
    [sym_abstract_class] = STATE(4210),
    [sym_interface_declaration] = STATE(4210),
    [sym_statement_block] = STATE(4210),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4210),
    [sym_debugger_statement] = STATE(4210),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4210),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4210),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4210),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4210),
    [sym_empty_statement] = STATE(4210),
    [sym_import_alias] = STATE(4210),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4210),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4210),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4210),
    [sym_break_statement] = STATE(4210),
    [sym_labeled_statement] = STATE(4210),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4210),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [4812] = {
    [sym_type_alias_declaration] = STATE(4211),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4211),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4211),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4211),
    [sym_return_statement] = STATE(4211),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4211),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4211),
    [sym_switch_statement] = STATE(4211),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4211),
    [sym_throw_statement] = STATE(4211),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4211),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4211),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(4211),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4211),
    [sym_abstract_class] = STATE(4211),
    [sym_interface_declaration] = STATE(4211),
    [sym_statement_block] = STATE(4211),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4211),
    [sym_debugger_statement] = STATE(4211),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4211),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4211),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4211),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4211),
    [sym_empty_statement] = STATE(4211),
    [sym_import_alias] = STATE(4211),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4211),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4211),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4211),
    [sym_break_statement] = STATE(4211),
    [sym_labeled_statement] = STATE(4211),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4211),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [4813] = {
    [sym_type_alias_declaration] = STATE(4212),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4212),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4212),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4212),
    [sym_return_statement] = STATE(4212),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4212),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4212),
    [sym_switch_statement] = STATE(4212),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4212),
    [sym_throw_statement] = STATE(4212),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4212),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4212),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(4212),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4212),
    [sym_abstract_class] = STATE(4212),
    [sym_interface_declaration] = STATE(4212),
    [sym_statement_block] = STATE(4212),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4212),
    [sym_debugger_statement] = STATE(4212),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4212),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4212),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4212),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4212),
    [sym_empty_statement] = STATE(4212),
    [sym_import_alias] = STATE(4212),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4212),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4212),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4212),
    [sym_break_statement] = STATE(4212),
    [sym_labeled_statement] = STATE(4212),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4212),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [4814] = {
    [sym_type_alias_declaration] = STATE(4235),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4235),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4235),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4235),
    [sym_return_statement] = STATE(4235),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4235),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4235),
    [sym_switch_statement] = STATE(4235),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4235),
    [sym_throw_statement] = STATE(4235),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4235),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4235),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(4235),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4235),
    [sym_abstract_class] = STATE(4235),
    [sym_interface_declaration] = STATE(4235),
    [sym_statement_block] = STATE(4235),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4235),
    [sym_debugger_statement] = STATE(4235),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4235),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4235),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4235),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4235),
    [sym_empty_statement] = STATE(4235),
    [sym_import_alias] = STATE(4235),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4235),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4235),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4235),
    [sym_break_statement] = STATE(4235),
    [sym_labeled_statement] = STATE(4235),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4235),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [4815] = {
    [sym_type_alias_declaration] = STATE(4236),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4236),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4236),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4236),
    [sym_return_statement] = STATE(4236),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4236),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4236),
    [sym_switch_statement] = STATE(4236),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4236),
    [sym_throw_statement] = STATE(4236),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4236),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4236),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(4236),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4236),
    [sym_abstract_class] = STATE(4236),
    [sym_interface_declaration] = STATE(4236),
    [sym_statement_block] = STATE(4236),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4236),
    [sym_debugger_statement] = STATE(4236),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4236),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4236),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4236),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4236),
    [sym_empty_statement] = STATE(4236),
    [sym_import_alias] = STATE(4236),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4236),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4236),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4236),
    [sym_break_statement] = STATE(4236),
    [sym_labeled_statement] = STATE(4236),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4236),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [4816] = {
    [sym_type_alias_declaration] = STATE(4237),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4237),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4237),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4237),
    [sym_return_statement] = STATE(4237),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4237),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4237),
    [sym_switch_statement] = STATE(4237),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4237),
    [sym_throw_statement] = STATE(4237),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4237),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4237),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(4237),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4237),
    [sym_abstract_class] = STATE(4237),
    [sym_interface_declaration] = STATE(4237),
    [sym_statement_block] = STATE(4237),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4237),
    [sym_debugger_statement] = STATE(4237),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4237),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4237),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4237),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4237),
    [sym_empty_statement] = STATE(4237),
    [sym_import_alias] = STATE(4237),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4237),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4237),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4237),
    [sym_break_statement] = STATE(4237),
    [sym_labeled_statement] = STATE(4237),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4237),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [4817] = {
    [sym_union_type] = STATE(4933),
    [sym__type] = STATE(4933),
    [sym_constructor_type] = STATE(4933),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4624),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4933),
    [sym_function_type] = STATE(4933),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4625),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9335),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9339),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9341),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4818] = {
    [sym_formal_parameters] = STATE(4934),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4819] = {
    [anon_sym_EQ_GT] = ACTIONS(9768),
    [sym_comment] = ACTIONS(3),
  },
  [4820] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4624),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4625),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9335),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9339),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9341),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4821] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4624),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4625),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9335),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9339),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9341),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4822] = {
    [anon_sym_EQ_GT] = ACTIONS(9770),
    [sym_comment] = ACTIONS(3),
  },
  [4823] = {
    [sym_union_type] = STATE(4937),
    [sym__type] = STATE(4937),
    [sym_constructor_type] = STATE(4937),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4624),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4937),
    [sym_function_type] = STATE(4937),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4625),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9335),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9339),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9341),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4824] = {
    [sym_union_type] = STATE(4938),
    [sym__type] = STATE(4938),
    [sym_constructor_type] = STATE(4938),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(3873),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4938),
    [sym_function_type] = STATE(4938),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3874),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8050),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8052),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8054),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8056),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4825] = {
    [sym_identifier] = ACTIONS(8379),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [anon_sym_debugger] = ACTIONS(8379),
    [anon_sym_symbol] = ACTIONS(8379),
    [anon_sym_AT] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(8841),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_void] = ACTIONS(8379),
    [anon_sym_break] = ACTIONS(8379),
    [anon_sym_const] = ACTIONS(8379),
    [sym_super] = ACTIONS(8379),
    [anon_sym_return] = ACTIONS(8379),
    [anon_sym_private] = ACTIONS(8379),
    [anon_sym_get] = ACTIONS(8379),
    [anon_sym_RBRACE] = ACTIONS(7511),
    [anon_sym_interface] = ACTIONS(8379),
    [anon_sym_enum] = ACTIONS(8379),
    [anon_sym_delete] = ACTIONS(8379),
    [anon_sym_continue] = ACTIONS(8379),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_if] = ACTIONS(8379),
    [anon_sym_this] = ACTIONS(8379),
    [anon_sym_yield] = ACTIONS(8379),
    [sym_true] = ACTIONS(8379),
    [anon_sym_throw] = ACTIONS(8379),
    [anon_sym_protected] = ACTIONS(8379),
    [anon_sym_abstract] = ACTIONS(8379),
    [anon_sym_set] = ACTIONS(8379),
    [anon_sym_type] = ACTIONS(8379),
    [anon_sym_import] = ACTIONS(8379),
    [anon_sym_namespace] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_await] = ACTIONS(8379),
    [anon_sym_DQUOTE] = ACTIONS(7511),
    [anon_sym_BANG] = ACTIONS(7511),
    [anon_sym_for] = ACTIONS(8379),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [sym_false] = ACTIONS(8379),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_module] = ACTIONS(8379),
    [anon_sym_number] = ACTIONS(8379),
    [anon_sym_class] = ACTIONS(8379),
    [anon_sym_declare] = ACTIONS(8379),
    [anon_sym_typeof] = ACTIONS(8379),
    [anon_sym_LBRACE] = ACTIONS(7511),
    [anon_sym_switch] = ACTIONS(8379),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [sym_null] = ACTIONS(8379),
    [anon_sym_any] = ACTIONS(8379),
    [anon_sym_boolean] = ACTIONS(8379),
    [anon_sym_async] = ACTIONS(8379),
    [anon_sym_public] = ACTIONS(8379),
    [anon_sym_AMP] = ACTIONS(8843),
    [anon_sym_var] = ACTIONS(8379),
    [anon_sym_while] = ACTIONS(8379),
    [anon_sym_SQUOTE] = ACTIONS(7511),
    [anon_sym_try] = ACTIONS(8379),
    [anon_sym_LT] = ACTIONS(7511),
    [sym_number] = ACTIONS(7511),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8379),
    [anon_sym_function] = ACTIONS(8379),
    [sym_undefined] = ACTIONS(8379),
    [anon_sym_new] = ACTIONS(8379),
    [anon_sym_let] = ACTIONS(8379),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_export] = ACTIONS(8379),
    [anon_sym_do] = ACTIONS(8379),
    [anon_sym_TILDE] = ACTIONS(7511),
    [anon_sym_with] = ACTIONS(8379),
  },
  [4826] = {
    [sym_identifier] = ACTIONS(8381),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [anon_sym_debugger] = ACTIONS(8381),
    [anon_sym_symbol] = ACTIONS(8381),
    [anon_sym_AT] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(8841),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_void] = ACTIONS(8381),
    [anon_sym_break] = ACTIONS(8381),
    [anon_sym_const] = ACTIONS(8381),
    [sym_super] = ACTIONS(8381),
    [anon_sym_return] = ACTIONS(8381),
    [anon_sym_private] = ACTIONS(8381),
    [anon_sym_get] = ACTIONS(8381),
    [anon_sym_RBRACE] = ACTIONS(7529),
    [anon_sym_interface] = ACTIONS(8381),
    [anon_sym_enum] = ACTIONS(8381),
    [anon_sym_delete] = ACTIONS(8381),
    [anon_sym_continue] = ACTIONS(8381),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_if] = ACTIONS(8381),
    [anon_sym_this] = ACTIONS(8381),
    [anon_sym_yield] = ACTIONS(8381),
    [sym_true] = ACTIONS(8381),
    [anon_sym_throw] = ACTIONS(8381),
    [anon_sym_protected] = ACTIONS(8381),
    [anon_sym_abstract] = ACTIONS(8381),
    [anon_sym_set] = ACTIONS(8381),
    [anon_sym_type] = ACTIONS(8381),
    [anon_sym_import] = ACTIONS(8381),
    [anon_sym_namespace] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_await] = ACTIONS(8381),
    [anon_sym_DQUOTE] = ACTIONS(7529),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_for] = ACTIONS(8381),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [sym_false] = ACTIONS(8381),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_module] = ACTIONS(8381),
    [anon_sym_number] = ACTIONS(8381),
    [anon_sym_class] = ACTIONS(8381),
    [anon_sym_declare] = ACTIONS(8381),
    [anon_sym_typeof] = ACTIONS(8381),
    [anon_sym_LBRACE] = ACTIONS(7529),
    [anon_sym_switch] = ACTIONS(8381),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [sym_null] = ACTIONS(8381),
    [anon_sym_any] = ACTIONS(8381),
    [anon_sym_boolean] = ACTIONS(8381),
    [anon_sym_async] = ACTIONS(8381),
    [anon_sym_public] = ACTIONS(8381),
    [anon_sym_AMP] = ACTIONS(8843),
    [anon_sym_var] = ACTIONS(8381),
    [anon_sym_while] = ACTIONS(8381),
    [anon_sym_SQUOTE] = ACTIONS(7529),
    [anon_sym_try] = ACTIONS(8381),
    [anon_sym_LT] = ACTIONS(7529),
    [sym_number] = ACTIONS(7529),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8381),
    [anon_sym_function] = ACTIONS(8381),
    [sym_undefined] = ACTIONS(8381),
    [anon_sym_new] = ACTIONS(8381),
    [anon_sym_let] = ACTIONS(8381),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_export] = ACTIONS(8381),
    [anon_sym_do] = ACTIONS(8381),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_with] = ACTIONS(8381),
  },
  [4827] = {
    [anon_sym_COMMA] = ACTIONS(9772),
    [anon_sym_RBRACE] = ACTIONS(9772),
    [sym_comment] = ACTIONS(3),
  },
  [4828] = {
    [sym_union_type] = STATE(4939),
    [sym__type] = STATE(4939),
    [sym_constructor_type] = STATE(4939),
    [sym_index_type_query] = STATE(1298),
    [sym_lookup_type] = STATE(1298),
    [sym_flow_maybe_type] = STATE(1298),
    [sym_parenthesized_type] = STATE(1298),
    [sym_nested_type_identifier] = STATE(1294),
    [sym_type_parameters] = STATE(3895),
    [sym_array_type] = STATE(1298),
    [sym_type_predicate] = STATE(1298),
    [sym_type_query] = STATE(1298),
    [sym_existential_type] = STATE(1298),
    [sym_this_type] = STATE(1298),
    [sym_nested_identifier] = STATE(1296),
    [sym_object_type] = STATE(1298),
    [sym_intersection_type] = STATE(4939),
    [sym_function_type] = STATE(4939),
    [sym__primary_type] = STATE(1298),
    [sym_generic_type] = STATE(1298),
    [sym_literal_type] = STATE(1298),
    [sym__number] = STATE(1279),
    [sym_predefined_type] = STATE(1298),
    [sym_string] = STATE(1279),
    [sym_formal_parameters] = STATE(3896),
    [sym_tuple_type] = STATE(1298),
    [sym_identifier] = ACTIONS(8117),
    [sym_false] = ACTIONS(2643),
    [anon_sym_QMARK] = ACTIONS(8123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2663),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_AMP] = ACTIONS(8121),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_number] = ACTIONS(2647),
    [anon_sym_symbol] = ACTIONS(2647),
    [anon_sym_this] = ACTIONS(2669),
    [anon_sym_typeof] = ACTIONS(2649),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_keyof] = ACTIONS(2651),
    [sym_number] = ACTIONS(2671),
    [sym_true] = ACTIONS(2643),
    [anon_sym_void] = ACTIONS(2647),
    [anon_sym_string] = ACTIONS(2647),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(8125),
    [anon_sym_LPAREN] = ACTIONS(2661),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_PIPE] = ACTIONS(8119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_boolean] = ACTIONS(2647),
  },
  [4829] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_BANG] = ACTIONS(8379),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(9624),
    [anon_sym_COMMA] = ACTIONS(7511),
    [anon_sym_LT_LT] = ACTIONS(7511),
    [anon_sym_STAR] = ACTIONS(8379),
    [anon_sym_GT_GT_GT] = ACTIONS(7511),
    [anon_sym_AMP_AMP] = ACTIONS(7511),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_BANG_EQ] = ACTIONS(8379),
    [anon_sym_LT_EQ] = ACTIONS(7511),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [anon_sym_GT_EQ] = ACTIONS(7511),
    [anon_sym_GT] = ACTIONS(8379),
    [anon_sym_AMP] = ACTIONS(9626),
    [anon_sym_PERCENT] = ACTIONS(7511),
    [anon_sym_QMARK] = ACTIONS(7511),
    [anon_sym_as] = ACTIONS(7511),
    [anon_sym_PIPE_PIPE] = ACTIONS(7511),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_EQ_EQ] = ACTIONS(8379),
    [anon_sym_instanceof] = ACTIONS(7511),
    [anon_sym_LT] = ACTIONS(8379),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7511),
    [anon_sym_DOT] = ACTIONS(7511),
    [anon_sym_CARET] = ACTIONS(7511),
    [anon_sym_STAR_STAR] = ACTIONS(7511),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_GT_GT] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7511),
    [anon_sym_in] = ACTIONS(8379),
  },
  [4830] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_BANG] = ACTIONS(8381),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(9624),
    [anon_sym_COMMA] = ACTIONS(7529),
    [anon_sym_LT_LT] = ACTIONS(7529),
    [anon_sym_STAR] = ACTIONS(8381),
    [anon_sym_GT_GT_GT] = ACTIONS(7529),
    [anon_sym_AMP_AMP] = ACTIONS(7529),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_BANG_EQ] = ACTIONS(8381),
    [anon_sym_LT_EQ] = ACTIONS(7529),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [anon_sym_GT_EQ] = ACTIONS(7529),
    [anon_sym_GT] = ACTIONS(8381),
    [anon_sym_AMP] = ACTIONS(9626),
    [anon_sym_PERCENT] = ACTIONS(7529),
    [anon_sym_QMARK] = ACTIONS(7529),
    [anon_sym_as] = ACTIONS(7529),
    [anon_sym_PIPE_PIPE] = ACTIONS(7529),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_EQ_EQ] = ACTIONS(8381),
    [anon_sym_instanceof] = ACTIONS(7529),
    [anon_sym_LT] = ACTIONS(8381),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(7529),
    [anon_sym_DOT] = ACTIONS(7529),
    [anon_sym_CARET] = ACTIONS(7529),
    [anon_sym_STAR_STAR] = ACTIONS(7529),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_GT_GT] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7529),
    [anon_sym_in] = ACTIONS(8381),
  },
  [4831] = {
    [sym_identifier] = ACTIONS(2455),
    [anon_sym_BQUOTE] = ACTIONS(2457),
    [anon_sym_debugger] = ACTIONS(2455),
    [anon_sym_symbol] = ACTIONS(2455),
    [anon_sym_AT] = ACTIONS(2457),
    [anon_sym_DASH] = ACTIONS(2455),
    [anon_sym_void] = ACTIONS(2455),
    [anon_sym_break] = ACTIONS(2455),
    [anon_sym_const] = ACTIONS(2455),
    [sym_super] = ACTIONS(2455),
    [anon_sym_return] = ACTIONS(2455),
    [anon_sym_private] = ACTIONS(2455),
    [anon_sym_get] = ACTIONS(2455),
    [anon_sym_RBRACE] = ACTIONS(2457),
    [anon_sym_default] = ACTIONS(2455),
    [anon_sym_interface] = ACTIONS(2455),
    [anon_sym_enum] = ACTIONS(2455),
    [anon_sym_delete] = ACTIONS(2455),
    [anon_sym_continue] = ACTIONS(2455),
    [anon_sym_DASH_DASH] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2455),
    [anon_sym_this] = ACTIONS(2455),
    [anon_sym_yield] = ACTIONS(2455),
    [sym_true] = ACTIONS(2455),
    [anon_sym_throw] = ACTIONS(2455),
    [anon_sym_protected] = ACTIONS(2455),
    [anon_sym_abstract] = ACTIONS(2455),
    [anon_sym_set] = ACTIONS(2455),
    [anon_sym_type] = ACTIONS(2455),
    [anon_sym_import] = ACTIONS(2455),
    [anon_sym_namespace] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2457),
    [anon_sym_await] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [anon_sym_else] = ACTIONS(9774),
    [anon_sym_BANG] = ACTIONS(2457),
    [anon_sym_for] = ACTIONS(2455),
    [anon_sym_LBRACK] = ACTIONS(2457),
    [sym_false] = ACTIONS(2455),
    [anon_sym_SEMI] = ACTIONS(2457),
    [anon_sym_case] = ACTIONS(2455),
    [anon_sym_module] = ACTIONS(2455),
    [anon_sym_number] = ACTIONS(2455),
    [anon_sym_class] = ACTIONS(2455),
    [anon_sym_declare] = ACTIONS(2455),
    [anon_sym_typeof] = ACTIONS(2455),
    [anon_sym_LBRACE] = ACTIONS(2457),
    [anon_sym_switch] = ACTIONS(2455),
    [anon_sym_LPAREN] = ACTIONS(2457),
    [sym_null] = ACTIONS(2455),
    [anon_sym_any] = ACTIONS(2455),
    [anon_sym_boolean] = ACTIONS(2455),
    [anon_sym_async] = ACTIONS(2455),
    [anon_sym_public] = ACTIONS(2455),
    [anon_sym_var] = ACTIONS(2455),
    [anon_sym_while] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2457),
    [anon_sym_try] = ACTIONS(2455),
    [anon_sym_LT] = ACTIONS(2457),
    [sym_number] = ACTIONS(2457),
    [anon_sym_SLASH] = ACTIONS(2455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2455),
    [anon_sym_function] = ACTIONS(2455),
    [sym_undefined] = ACTIONS(2455),
    [anon_sym_new] = ACTIONS(2455),
    [anon_sym_let] = ACTIONS(2455),
    [anon_sym_PLUS] = ACTIONS(2455),
    [anon_sym_export] = ACTIONS(2455),
    [anon_sym_do] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2457),
    [anon_sym_with] = ACTIONS(2455),
  },
  [4832] = {
    [sym_array] = STATE(4943),
    [sym_object] = STATE(4944),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(9776),
    [anon_sym_var] = ACTIONS(9778),
    [anon_sym_const] = ACTIONS(9778),
    [sym_comment] = ACTIONS(3),
    [anon_sym_let] = ACTIONS(9778),
  },
  [4833] = {
    [sym__initializer] = STATE(71),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_AMP_EQ] = ACTIONS(115),
    [anon_sym_PLUS_EQ] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(9780),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(115),
    [anon_sym_PIPE_EQ] = ACTIONS(115),
    [anon_sym_DASH_EQ] = ACTIONS(115),
    [anon_sym_EQ_GT] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(115),
    [anon_sym_GT_GT_EQ] = ACTIONS(115),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(9782),
  },
  [4834] = {
    [sym_variable_declarator] = STATE(97),
    [sym_array] = STATE(4948),
    [sym_object] = STATE(4949),
    [sym_identifier] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [4835] = {
    [sym_variable_declarator] = STATE(258),
    [sym_array] = STATE(4948),
    [sym_object] = STATE(4949),
    [sym_identifier] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [4836] = {
    [sym_new_expression] = STATE(59),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_yield_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_internal_module] = STATE(59),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(59),
    [sym_await_expression] = STATE(59),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4950),
    [sym_sequence_expression] = STATE(62),
    [sym_string] = STATE(59),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(4950),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(56),
    [sym_anonymous_class] = STATE(59),
    [sym_generator_function] = STATE(59),
    [sym_call_expression] = STATE(59),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(59),
    [sym_ternary_expression] = STATE(59),
    [sym_binary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(59),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(155),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_true] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [4837] = {
    [sym__initializer] = STATE(321),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(9786),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(9788),
  },
  [4838] = {
    [sym__initializer] = STATE(336),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(9790),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(9792),
  },
  [4839] = {
    [sym_identifier] = ACTIONS(9794),
    [sym_comment] = ACTIONS(3),
  },
  [4840] = {
    [anon_sym_of] = ACTIONS(9796),
    [sym_comment] = ACTIONS(3),
  },
  [4841] = {
    [anon_sym_of] = ACTIONS(9798),
    [sym_comment] = ACTIONS(3),
  },
  [4842] = {
    [anon_sym_of] = ACTIONS(9800),
    [sym_comment] = ACTIONS(3),
  },
  [4843] = {
    [sym_new_expression] = STATE(4959),
    [sym_augmented_assignment_expression] = STATE(4959),
    [sym_unary_expression] = STATE(4959),
    [sym_update_expression] = STATE(4959),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4959),
    [sym_regex] = STATE(4959),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4959),
    [sym_non_null_expression] = STATE(4959),
    [sym_as_expression] = STATE(4959),
    [sym_jsx_fragment] = STATE(4959),
    [sym_yield_expression] = STATE(4959),
    [sym_jsx_element] = STATE(4959),
    [sym_internal_module] = STATE(4959),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4959),
    [sym_await_expression] = STATE(4959),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4959),
    [sym_this] = STATE(4959),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4959),
    [sym_generator_function] = STATE(4959),
    [sym_call_expression] = STATE(4959),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4959),
    [sym_ternary_expression] = STATE(4959),
    [sym_binary_expression] = STATE(4959),
    [sym_template_string] = STATE(4959),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4959),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4959),
    [sym_class] = STATE(4959),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9802),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9802),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9804),
    [sym_true] = ACTIONS(9802),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9802),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4844] = {
    [sym_new_expression] = STATE(4960),
    [sym_augmented_assignment_expression] = STATE(4960),
    [sym_unary_expression] = STATE(4960),
    [sym_update_expression] = STATE(4960),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4960),
    [sym_regex] = STATE(4960),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4960),
    [sym_non_null_expression] = STATE(4960),
    [sym_as_expression] = STATE(4960),
    [sym_jsx_fragment] = STATE(4960),
    [sym_yield_expression] = STATE(4960),
    [sym_jsx_element] = STATE(4960),
    [sym_internal_module] = STATE(4960),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4960),
    [sym_await_expression] = STATE(4960),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4960),
    [sym_this] = STATE(4960),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4960),
    [sym_generator_function] = STATE(4960),
    [sym_call_expression] = STATE(4960),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4960),
    [sym_ternary_expression] = STATE(4960),
    [sym_binary_expression] = STATE(4960),
    [sym_template_string] = STATE(4960),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4960),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4960),
    [sym_class] = STATE(4960),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9806),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9806),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9808),
    [sym_true] = ACTIONS(9806),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9806),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4845] = {
    [sym_new_expression] = STATE(4961),
    [sym_augmented_assignment_expression] = STATE(4961),
    [sym_unary_expression] = STATE(4961),
    [sym_update_expression] = STATE(4961),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(4961),
    [sym_regex] = STATE(4961),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4961),
    [sym_non_null_expression] = STATE(4961),
    [sym_as_expression] = STATE(4961),
    [sym_jsx_fragment] = STATE(4961),
    [sym_yield_expression] = STATE(4961),
    [sym_jsx_element] = STATE(4961),
    [sym_internal_module] = STATE(4961),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4961),
    [sym_await_expression] = STATE(4961),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(4961),
    [sym_this] = STATE(4961),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(4961),
    [sym_generator_function] = STATE(4961),
    [sym_call_expression] = STATE(4961),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(4961),
    [sym_ternary_expression] = STATE(4961),
    [sym_binary_expression] = STATE(4961),
    [sym_template_string] = STATE(4961),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4961),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4961),
    [sym_class] = STATE(4961),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9810),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9812),
    [sym_true] = ACTIONS(9810),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9810),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4846] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(9814),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [4847] = {
    [anon_sym_RPAREN] = ACTIONS(9814),
    [sym_comment] = ACTIONS(3),
  },
  [4848] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9816),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4849] = {
    [sym_new_expression] = STATE(4964),
    [sym_augmented_assignment_expression] = STATE(4964),
    [sym_unary_expression] = STATE(4964),
    [sym_update_expression] = STATE(4964),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(4964),
    [sym_regex] = STATE(4964),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4964),
    [sym_non_null_expression] = STATE(4964),
    [sym_as_expression] = STATE(4964),
    [sym_jsx_fragment] = STATE(4964),
    [sym_yield_expression] = STATE(4964),
    [sym_jsx_element] = STATE(4964),
    [sym_internal_module] = STATE(4964),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4964),
    [sym_await_expression] = STATE(4964),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(4965),
    [sym_string] = STATE(4964),
    [sym_this] = STATE(4964),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(4964),
    [sym_generator_function] = STATE(4964),
    [sym_call_expression] = STATE(4964),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(4964),
    [sym_ternary_expression] = STATE(4964),
    [sym_binary_expression] = STATE(4964),
    [sym_template_string] = STATE(4964),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4964),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4964),
    [sym_class] = STATE(4964),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9818),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9820),
    [sym_true] = ACTIONS(9818),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9818),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [4850] = {
    [sym_new_expression] = STATE(4966),
    [sym_augmented_assignment_expression] = STATE(4966),
    [sym_unary_expression] = STATE(4966),
    [sym_update_expression] = STATE(4966),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(4966),
    [sym_regex] = STATE(4966),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4966),
    [sym_non_null_expression] = STATE(4966),
    [sym_as_expression] = STATE(4966),
    [sym_jsx_fragment] = STATE(4966),
    [sym_yield_expression] = STATE(4966),
    [sym_jsx_element] = STATE(4966),
    [sym_internal_module] = STATE(4966),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4966),
    [sym_await_expression] = STATE(4966),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(4967),
    [sym_string] = STATE(4966),
    [sym_this] = STATE(4966),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(4966),
    [sym_generator_function] = STATE(4966),
    [sym_call_expression] = STATE(4966),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(4966),
    [sym_ternary_expression] = STATE(4966),
    [sym_binary_expression] = STATE(4966),
    [sym_template_string] = STATE(4966),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4966),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4966),
    [sym_class] = STATE(4966),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(9822),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9822),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9824),
    [sym_true] = ACTIONS(9822),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9822),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [4851] = {
    [sym_new_expression] = STATE(4968),
    [sym_augmented_assignment_expression] = STATE(4968),
    [sym_unary_expression] = STATE(4968),
    [sym_update_expression] = STATE(4968),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(4968),
    [sym_regex] = STATE(4968),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(4968),
    [sym_non_null_expression] = STATE(4968),
    [sym_as_expression] = STATE(4968),
    [sym_jsx_fragment] = STATE(4968),
    [sym_yield_expression] = STATE(4968),
    [sym_jsx_element] = STATE(4968),
    [sym_internal_module] = STATE(4968),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(4968),
    [sym_await_expression] = STATE(4968),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(4969),
    [sym_string] = STATE(4968),
    [sym_this] = STATE(4968),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(4968),
    [sym_generator_function] = STATE(4968),
    [sym_call_expression] = STATE(4968),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(4968),
    [sym_ternary_expression] = STATE(4968),
    [sym_binary_expression] = STATE(4968),
    [sym_template_string] = STATE(4968),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(4968),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(4968),
    [sym_class] = STATE(4968),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(9826),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9826),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9828),
    [sym_true] = ACTIONS(9826),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9826),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [4852] = {
    [sym_type_alias_declaration] = STATE(3041),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3041),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3041),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3041),
    [sym_return_statement] = STATE(3041),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3041),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3041),
    [sym_switch_statement] = STATE(3041),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3041),
    [sym_throw_statement] = STATE(3041),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3041),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3041),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(3041),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3041),
    [sym_abstract_class] = STATE(3041),
    [sym_interface_declaration] = STATE(3041),
    [sym_statement_block] = STATE(3041),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3041),
    [sym_debugger_statement] = STATE(3041),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3041),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3041),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3041),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3041),
    [sym_empty_statement] = STATE(3041),
    [sym_import_alias] = STATE(3041),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3041),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3041),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3041),
    [sym_break_statement] = STATE(3041),
    [sym_labeled_statement] = STATE(3041),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3041),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [4853] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(9830),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4854] = {
    [anon_sym_RPAREN] = ACTIONS(9830),
    [sym_comment] = ACTIONS(3),
  },
  [4855] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9832),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4856] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(9834),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [4857] = {
    [anon_sym_RPAREN] = ACTIONS(9834),
    [sym_comment] = ACTIONS(3),
  },
  [4858] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9836),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4859] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(9838),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [4860] = {
    [anon_sym_RPAREN] = ACTIONS(9838),
    [sym_comment] = ACTIONS(3),
  },
  [4861] = {
    [sym_union_type] = STATE(4980),
    [sym__type] = STATE(4980),
    [sym_constructor_type] = STATE(4980),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4981),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4980),
    [sym_function_type] = STATE(4980),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4982),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9840),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9842),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9844),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9846),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4862] = {
    [anon_sym_EQ] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_RPAREN] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(8165),
    [anon_sym_COMMA] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(8167),
    [sym_comment] = ACTIONS(3),
  },
  [4863] = {
    [sym_union_type] = STATE(4983),
    [sym__type] = STATE(4983),
    [sym_constructor_type] = STATE(4983),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(3930),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4983),
    [sym_function_type] = STATE(4983),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(3931),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(5168),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(5170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8181),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8183),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4864] = {
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_RPAREN] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(8923),
    [anon_sym_COMMA] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(8925),
    [sym_comment] = ACTIONS(3),
  },
  [4865] = {
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_RPAREN] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(8923),
    [anon_sym_COMMA] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(8925),
    [sym_comment] = ACTIONS(3),
  },
  [4866] = {
    [anon_sym_GT] = ACTIONS(8213),
    [sym_jsx_identifier] = ACTIONS(8213),
    [sym_identifier] = ACTIONS(8215),
    [anon_sym_SLASH] = ACTIONS(8215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8213),
  },
  [4867] = {
    [anon_sym_EQ] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_GT] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(8227),
    [anon_sym_COMMA] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(8229),
    [sym_comment] = ACTIONS(3),
  },
  [4868] = {
    [sym_union_type] = STATE(4984),
    [sym__type] = STATE(4984),
    [sym_constructor_type] = STATE(4984),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(3966),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(4984),
    [sym_function_type] = STATE(4984),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(3967),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5347),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5349),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8239),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8241),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4869] = {
    [sym__automatic_semicolon] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(8961),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(8963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7511),
  },
  [4870] = {
    [sym__automatic_semicolon] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(8961),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(8963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7529),
  },
  [4871] = {
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(8249),
    [anon_sym_PIPE] = ACTIONS(8251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8547),
  },
  [4872] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9850),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4873] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9852),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4874] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9854),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4875] = {
    [sym_type_alias_declaration] = STATE(4210),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4210),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4210),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4210),
    [sym_return_statement] = STATE(4210),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4210),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4210),
    [sym_switch_statement] = STATE(4210),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4210),
    [sym_throw_statement] = STATE(4210),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4210),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4210),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(4210),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4210),
    [sym_abstract_class] = STATE(4210),
    [sym_interface_declaration] = STATE(4210),
    [sym_statement_block] = STATE(4210),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4210),
    [sym_debugger_statement] = STATE(4210),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4210),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4210),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4210),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4210),
    [sym_empty_statement] = STATE(4210),
    [sym_import_alias] = STATE(4210),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4210),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4210),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4210),
    [sym_break_statement] = STATE(4210),
    [sym_labeled_statement] = STATE(4210),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4210),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [4876] = {
    [sym_type_alias_declaration] = STATE(4211),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4211),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4211),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4211),
    [sym_return_statement] = STATE(4211),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4211),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4211),
    [sym_switch_statement] = STATE(4211),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4211),
    [sym_throw_statement] = STATE(4211),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4211),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4211),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(4211),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4211),
    [sym_abstract_class] = STATE(4211),
    [sym_interface_declaration] = STATE(4211),
    [sym_statement_block] = STATE(4211),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4211),
    [sym_debugger_statement] = STATE(4211),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4211),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4211),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4211),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4211),
    [sym_empty_statement] = STATE(4211),
    [sym_import_alias] = STATE(4211),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4211),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4211),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4211),
    [sym_break_statement] = STATE(4211),
    [sym_labeled_statement] = STATE(4211),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4211),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [4877] = {
    [sym_type_alias_declaration] = STATE(4212),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4212),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4212),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4212),
    [sym_return_statement] = STATE(4212),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4212),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4212),
    [sym_switch_statement] = STATE(4212),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4212),
    [sym_throw_statement] = STATE(4212),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4212),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4212),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(4212),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4212),
    [sym_abstract_class] = STATE(4212),
    [sym_interface_declaration] = STATE(4212),
    [sym_statement_block] = STATE(4212),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4212),
    [sym_debugger_statement] = STATE(4212),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4212),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4212),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4212),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4212),
    [sym_empty_statement] = STATE(4212),
    [sym_import_alias] = STATE(4212),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4212),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4212),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4212),
    [sym_break_statement] = STATE(4212),
    [sym_labeled_statement] = STATE(4212),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4212),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [4878] = {
    [sym_type_alias_declaration] = STATE(4235),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4235),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4235),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4235),
    [sym_return_statement] = STATE(4235),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4235),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4235),
    [sym_switch_statement] = STATE(4235),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4235),
    [sym_throw_statement] = STATE(4235),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4235),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4235),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(4235),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4235),
    [sym_abstract_class] = STATE(4235),
    [sym_interface_declaration] = STATE(4235),
    [sym_statement_block] = STATE(4235),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4235),
    [sym_debugger_statement] = STATE(4235),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4235),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4235),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4235),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4235),
    [sym_empty_statement] = STATE(4235),
    [sym_import_alias] = STATE(4235),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4235),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4235),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4235),
    [sym_break_statement] = STATE(4235),
    [sym_labeled_statement] = STATE(4235),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4235),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [4879] = {
    [sym_type_alias_declaration] = STATE(4236),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4236),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4236),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4236),
    [sym_return_statement] = STATE(4236),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4236),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4236),
    [sym_switch_statement] = STATE(4236),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4236),
    [sym_throw_statement] = STATE(4236),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4236),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4236),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(4236),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4236),
    [sym_abstract_class] = STATE(4236),
    [sym_interface_declaration] = STATE(4236),
    [sym_statement_block] = STATE(4236),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4236),
    [sym_debugger_statement] = STATE(4236),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4236),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4236),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4236),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4236),
    [sym_empty_statement] = STATE(4236),
    [sym_import_alias] = STATE(4236),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4236),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4236),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4236),
    [sym_break_statement] = STATE(4236),
    [sym_labeled_statement] = STATE(4236),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4236),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [4880] = {
    [sym_type_alias_declaration] = STATE(4237),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4237),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4237),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4237),
    [sym_return_statement] = STATE(4237),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4237),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4237),
    [sym_switch_statement] = STATE(4237),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4237),
    [sym_throw_statement] = STATE(4237),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4237),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4237),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(4237),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4237),
    [sym_abstract_class] = STATE(4237),
    [sym_interface_declaration] = STATE(4237),
    [sym_statement_block] = STATE(4237),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4237),
    [sym_debugger_statement] = STATE(4237),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4237),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4237),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4237),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4237),
    [sym_empty_statement] = STATE(4237),
    [sym_import_alias] = STATE(4237),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4237),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4237),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4237),
    [sym_break_statement] = STATE(4237),
    [sym_labeled_statement] = STATE(4237),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4237),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [4881] = {
    [sym_union_type] = STATE(4991),
    [sym__type] = STATE(4991),
    [sym_constructor_type] = STATE(4991),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(4717),
    [sym_type_parameters] = STATE(4992),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4991),
    [sym_function_type] = STATE(4991),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4993),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9465),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9856),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9858),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4882] = {
    [sym_formal_parameters] = STATE(4994),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4883] = {
    [anon_sym_EQ_GT] = ACTIONS(9862),
    [sym_comment] = ACTIONS(3),
  },
  [4884] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(4717),
    [sym_type_parameters] = STATE(4718),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4719),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9465),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9469),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9471),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4885] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(4717),
    [sym_type_parameters] = STATE(4718),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4719),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9465),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9469),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9471),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4886] = {
    [anon_sym_EQ_GT] = ACTIONS(9864),
    [sym_comment] = ACTIONS(3),
  },
  [4887] = {
    [sym_union_type] = STATE(4997),
    [sym__type] = STATE(4997),
    [sym_constructor_type] = STATE(4997),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(4717),
    [sym_type_parameters] = STATE(4718),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(4997),
    [sym_function_type] = STATE(4997),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4719),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9465),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9469),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9471),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4888] = {
    [sym_formal_parameters] = STATE(4998),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4889] = {
    [anon_sym_EQ_GT] = ACTIONS(9866),
    [sym_comment] = ACTIONS(3),
  },
  [4890] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(4727),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4728),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8345),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9481),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9483),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4891] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(4727),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4728),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8345),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9481),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9483),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4892] = {
    [anon_sym_EQ_GT] = ACTIONS(9868),
    [sym_comment] = ACTIONS(3),
  },
  [4893] = {
    [sym_union_type] = STATE(5001),
    [sym__type] = STATE(5001),
    [sym_constructor_type] = STATE(5001),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(4727),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5001),
    [sym_function_type] = STATE(5001),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4728),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8345),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9481),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9483),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4894] = {
    [sym_union_type] = STATE(5002),
    [sym__type] = STATE(5002),
    [sym_constructor_type] = STATE(5002),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(4034),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5002),
    [sym_function_type] = STATE(5002),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4035),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8345),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8349),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8351),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4895] = {
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_PIPE] = ACTIONS(9055),
    [anon_sym_while] = ACTIONS(7511),
    [sym_comment] = ACTIONS(3),
  },
  [4896] = {
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_PIPE] = ACTIONS(9055),
    [anon_sym_while] = ACTIONS(7529),
    [sym_comment] = ACTIONS(3),
  },
  [4897] = {
    [sym_statement_block] = STATE(4598),
    [sym__automatic_semicolon] = ACTIONS(9568),
    [anon_sym_RBRACE] = ACTIONS(9568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(9568),
    [anon_sym_COMMA] = ACTIONS(9568),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9568),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [4898] = {
    [sym_formal_parameters] = STATE(5003),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4899] = {
    [anon_sym_EQ_GT] = ACTIONS(9870),
    [sym_comment] = ACTIONS(3),
  },
  [4900] = {
    [sym_union_type] = STATE(2790),
    [sym__type] = STATE(2790),
    [sym_constructor_type] = STATE(2790),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4742),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2790),
    [sym_function_type] = STATE(2790),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4743),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(8421),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(8423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(9498),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(9500),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(9502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4901] = {
    [sym_union_type] = STATE(2791),
    [sym__type] = STATE(2791),
    [sym_constructor_type] = STATE(2791),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4742),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(2791),
    [sym_function_type] = STATE(2791),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4743),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(8421),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(8423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(9498),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(9500),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(9502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4902] = {
    [anon_sym_EQ_GT] = ACTIONS(9872),
    [sym_comment] = ACTIONS(3),
  },
  [4903] = {
    [sym_union_type] = STATE(5006),
    [sym__type] = STATE(5006),
    [sym_constructor_type] = STATE(5006),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4742),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(5006),
    [sym_function_type] = STATE(5006),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4743),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(8421),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(8423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(9498),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(9500),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(9502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4904] = {
    [sym_union_type] = STATE(5007),
    [sym__type] = STATE(5007),
    [sym_constructor_type] = STATE(5007),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4073),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(5007),
    [sym_function_type] = STATE(5007),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4074),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(8421),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(8423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8425),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8427),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4905] = {
    [sym__automatic_semicolon] = ACTIONS(7511),
    [anon_sym_RBRACE] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(9089),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(9091),
    [anon_sym_COMMA] = ACTIONS(7511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7511),
  },
  [4906] = {
    [sym__automatic_semicolon] = ACTIONS(7529),
    [anon_sym_RBRACE] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(9089),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(9091),
    [anon_sym_COMMA] = ACTIONS(7529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7529),
  },
  [4907] = {
    [sym_type_parameters] = STATE(2715),
    [sym_formal_parameters] = STATE(2716),
    [sym_call_signature] = STATE(5008),
    [anon_sym_LPAREN] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4908] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(9071),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(9510),
    [anon_sym_LT_LT] = ACTIONS(8547),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_STAR] = ACTIONS(9071),
    [anon_sym_GT_GT_GT] = ACTIONS(8547),
    [anon_sym_AMP_AMP] = ACTIONS(8547),
    [anon_sym_BANG_EQ] = ACTIONS(9071),
    [anon_sym_LT_EQ] = ACTIONS(8547),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [anon_sym_GT_EQ] = ACTIONS(8547),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_RBRACE] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(9512),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_PERCENT] = ACTIONS(8547),
    [anon_sym_as] = ACTIONS(8547),
    [anon_sym_PIPE_PIPE] = ACTIONS(8547),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_EQ_EQ] = ACTIONS(9071),
    [anon_sym_instanceof] = ACTIONS(8547),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8547),
    [anon_sym_CARET] = ACTIONS(8547),
    [anon_sym_STAR_STAR] = ACTIONS(8547),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_GT_GT] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8547),
    [anon_sym_in] = ACTIONS(9071),
  },
  [4909] = {
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(8483),
    [anon_sym_PIPE] = ACTIONS(8485),
    [anon_sym_RBRACK] = ACTIONS(8547),
    [sym_comment] = ACTIONS(3),
  },
  [4910] = {
    [sym__automatic_semicolon] = ACTIONS(8569),
    [anon_sym_RBRACE] = ACTIONS(8569),
    [anon_sym_SEMI] = ACTIONS(8569),
    [anon_sym_COMMA] = ACTIONS(8569),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8569),
    [sym_comment] = ACTIONS(3),
  },
  [4911] = {
    [sym_union_type] = STATE(5009),
    [sym__type] = STATE(5009),
    [sym_constructor_type] = STATE(5009),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4147),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(5009),
    [sym_function_type] = STATE(5009),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4148),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(5967),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(5969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8527),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8529),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4912] = {
    [sym__automatic_semicolon] = ACTIONS(7511),
    [anon_sym_RBRACE] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(9141),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(9143),
    [anon_sym_COMMA] = ACTIONS(7511),
    [sym_comment] = ACTIONS(3),
  },
  [4913] = {
    [sym__automatic_semicolon] = ACTIONS(7529),
    [anon_sym_RBRACE] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(9141),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(9143),
    [anon_sym_COMMA] = ACTIONS(7529),
    [sym_comment] = ACTIONS(3),
  },
  [4914] = {
    [sym__automatic_semicolon] = ACTIONS(9758),
    [anon_sym_RBRACE] = ACTIONS(9758),
    [anon_sym_SEMI] = ACTIONS(9758),
    [anon_sym_COMMA] = ACTIONS(9758),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9758),
    [sym_comment] = ACTIONS(3),
  },
  [4915] = {
    [sym_union_type] = STATE(5010),
    [sym__type] = STATE(5010),
    [sym_constructor_type] = STATE(5010),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4200),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5010),
    [sym_function_type] = STATE(5010),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4201),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8615),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(8619),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(8621),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(8623),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4916] = {
    [sym_identifier] = ACTIONS(8379),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [anon_sym_debugger] = ACTIONS(8379),
    [anon_sym_symbol] = ACTIONS(8379),
    [anon_sym_AT] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(9189),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_void] = ACTIONS(8379),
    [anon_sym_break] = ACTIONS(8379),
    [anon_sym_const] = ACTIONS(8379),
    [sym_super] = ACTIONS(8379),
    [anon_sym_return] = ACTIONS(8379),
    [anon_sym_private] = ACTIONS(8379),
    [anon_sym_get] = ACTIONS(8379),
    [anon_sym_interface] = ACTIONS(8379),
    [anon_sym_enum] = ACTIONS(8379),
    [anon_sym_delete] = ACTIONS(8379),
    [anon_sym_continue] = ACTIONS(8379),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_if] = ACTIONS(8379),
    [anon_sym_this] = ACTIONS(8379),
    [anon_sym_yield] = ACTIONS(8379),
    [sym_true] = ACTIONS(8379),
    [anon_sym_throw] = ACTIONS(8379),
    [anon_sym_protected] = ACTIONS(8379),
    [anon_sym_abstract] = ACTIONS(8379),
    [anon_sym_set] = ACTIONS(8379),
    [anon_sym_type] = ACTIONS(8379),
    [anon_sym_import] = ACTIONS(8379),
    [anon_sym_namespace] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_await] = ACTIONS(8379),
    [anon_sym_DQUOTE] = ACTIONS(7511),
    [anon_sym_else] = ACTIONS(8379),
    [anon_sym_BANG] = ACTIONS(7511),
    [anon_sym_for] = ACTIONS(8379),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [sym_false] = ACTIONS(8379),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_module] = ACTIONS(8379),
    [anon_sym_number] = ACTIONS(8379),
    [anon_sym_class] = ACTIONS(8379),
    [anon_sym_declare] = ACTIONS(8379),
    [anon_sym_typeof] = ACTIONS(8379),
    [anon_sym_LBRACE] = ACTIONS(7511),
    [anon_sym_switch] = ACTIONS(8379),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [sym_null] = ACTIONS(8379),
    [anon_sym_any] = ACTIONS(8379),
    [anon_sym_boolean] = ACTIONS(8379),
    [anon_sym_async] = ACTIONS(8379),
    [anon_sym_public] = ACTIONS(8379),
    [anon_sym_AMP] = ACTIONS(9191),
    [anon_sym_var] = ACTIONS(8379),
    [anon_sym_while] = ACTIONS(8379),
    [anon_sym_SQUOTE] = ACTIONS(7511),
    [anon_sym_try] = ACTIONS(8379),
    [anon_sym_LT] = ACTIONS(7511),
    [sym_number] = ACTIONS(7511),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8379),
    [anon_sym_function] = ACTIONS(8379),
    [sym_undefined] = ACTIONS(8379),
    [anon_sym_new] = ACTIONS(8379),
    [ts_builtin_sym_end] = ACTIONS(7511),
    [anon_sym_let] = ACTIONS(8379),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_export] = ACTIONS(8379),
    [anon_sym_do] = ACTIONS(8379),
    [anon_sym_TILDE] = ACTIONS(7511),
    [anon_sym_with] = ACTIONS(8379),
  },
  [4917] = {
    [sym_identifier] = ACTIONS(8381),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [anon_sym_debugger] = ACTIONS(8381),
    [anon_sym_symbol] = ACTIONS(8381),
    [anon_sym_AT] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(9189),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_void] = ACTIONS(8381),
    [anon_sym_break] = ACTIONS(8381),
    [anon_sym_const] = ACTIONS(8381),
    [sym_super] = ACTIONS(8381),
    [anon_sym_return] = ACTIONS(8381),
    [anon_sym_private] = ACTIONS(8381),
    [anon_sym_get] = ACTIONS(8381),
    [anon_sym_interface] = ACTIONS(8381),
    [anon_sym_enum] = ACTIONS(8381),
    [anon_sym_delete] = ACTIONS(8381),
    [anon_sym_continue] = ACTIONS(8381),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_if] = ACTIONS(8381),
    [anon_sym_this] = ACTIONS(8381),
    [anon_sym_yield] = ACTIONS(8381),
    [sym_true] = ACTIONS(8381),
    [anon_sym_throw] = ACTIONS(8381),
    [anon_sym_protected] = ACTIONS(8381),
    [anon_sym_abstract] = ACTIONS(8381),
    [anon_sym_set] = ACTIONS(8381),
    [anon_sym_type] = ACTIONS(8381),
    [anon_sym_import] = ACTIONS(8381),
    [anon_sym_namespace] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_await] = ACTIONS(8381),
    [anon_sym_DQUOTE] = ACTIONS(7529),
    [anon_sym_else] = ACTIONS(8381),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_for] = ACTIONS(8381),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [sym_false] = ACTIONS(8381),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_module] = ACTIONS(8381),
    [anon_sym_number] = ACTIONS(8381),
    [anon_sym_class] = ACTIONS(8381),
    [anon_sym_declare] = ACTIONS(8381),
    [anon_sym_typeof] = ACTIONS(8381),
    [anon_sym_LBRACE] = ACTIONS(7529),
    [anon_sym_switch] = ACTIONS(8381),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [sym_null] = ACTIONS(8381),
    [anon_sym_any] = ACTIONS(8381),
    [anon_sym_boolean] = ACTIONS(8381),
    [anon_sym_async] = ACTIONS(8381),
    [anon_sym_public] = ACTIONS(8381),
    [anon_sym_AMP] = ACTIONS(9191),
    [anon_sym_var] = ACTIONS(8381),
    [anon_sym_while] = ACTIONS(8381),
    [anon_sym_SQUOTE] = ACTIONS(7529),
    [anon_sym_try] = ACTIONS(8381),
    [anon_sym_LT] = ACTIONS(7529),
    [sym_number] = ACTIONS(7529),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8381),
    [anon_sym_function] = ACTIONS(8381),
    [sym_undefined] = ACTIONS(8381),
    [anon_sym_new] = ACTIONS(8381),
    [ts_builtin_sym_end] = ACTIONS(7529),
    [anon_sym_let] = ACTIONS(8381),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_export] = ACTIONS(8381),
    [anon_sym_do] = ACTIONS(8381),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_with] = ACTIONS(8381),
  },
  [4918] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(9071),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [sym__automatic_semicolon] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(9554),
    [anon_sym_COMMA] = ACTIONS(8547),
    [anon_sym_LT_LT] = ACTIONS(8547),
    [anon_sym_STAR] = ACTIONS(9071),
    [anon_sym_GT_GT_GT] = ACTIONS(8547),
    [anon_sym_AMP_AMP] = ACTIONS(8547),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_BANG_EQ] = ACTIONS(9071),
    [anon_sym_LT_EQ] = ACTIONS(8547),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [anon_sym_GT_EQ] = ACTIONS(8547),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_AMP] = ACTIONS(9556),
    [anon_sym_PERCENT] = ACTIONS(8547),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_as] = ACTIONS(8547),
    [anon_sym_PIPE_PIPE] = ACTIONS(8547),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_EQ_EQ] = ACTIONS(9071),
    [anon_sym_RPAREN] = ACTIONS(8547),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_instanceof] = ACTIONS(8547),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8547),
    [anon_sym_CARET] = ACTIONS(8547),
    [anon_sym_STAR_STAR] = ACTIONS(8547),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_GT_GT] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8547),
    [anon_sym_in] = ACTIONS(9071),
  },
  [4919] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(9071),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(9560),
    [anon_sym_LT_LT] = ACTIONS(8547),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_STAR] = ACTIONS(9071),
    [anon_sym_GT_GT_GT] = ACTIONS(8547),
    [anon_sym_AMP_AMP] = ACTIONS(8547),
    [anon_sym_BANG_EQ] = ACTIONS(9071),
    [anon_sym_LT_EQ] = ACTIONS(8547),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [anon_sym_GT_EQ] = ACTIONS(8547),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_AMP] = ACTIONS(9562),
    [anon_sym_PERCENT] = ACTIONS(8547),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_as] = ACTIONS(8547),
    [anon_sym_PIPE_PIPE] = ACTIONS(8547),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_EQ_EQ] = ACTIONS(9071),
    [anon_sym_RPAREN] = ACTIONS(8547),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_instanceof] = ACTIONS(8547),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(8547),
    [anon_sym_CARET] = ACTIONS(8547),
    [anon_sym_STAR_STAR] = ACTIONS(8547),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_GT_GT] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8547),
    [anon_sym_in] = ACTIONS(9071),
  },
  [4920] = {
    [anon_sym_EQ_GT] = ACTIONS(9874),
    [sym_comment] = ACTIONS(3),
  },
  [4921] = {
    [sym_union_type] = STATE(5012),
    [sym__type] = STATE(5012),
    [sym_constructor_type] = STATE(5012),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4572),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(5012),
    [sym_function_type] = STATE(5012),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4573),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(7911),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(7913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(9255),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(9257),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(9259),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4922] = {
    [sym_union_type] = STATE(5013),
    [sym__type] = STATE(5013),
    [sym_constructor_type] = STATE(5013),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4572),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(5013),
    [sym_function_type] = STATE(5013),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4573),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(7911),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(7913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(9255),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(9257),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(9259),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4923] = {
    [sym__automatic_semicolon] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(9570),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(9572),
    [sym_comment] = ACTIONS(3),
  },
  [4924] = {
    [sym__automatic_semicolon] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(8737),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_COMMA] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(8739),
    [sym_comment] = ACTIONS(3),
  },
  [4925] = {
    [sym_union_type] = STATE(5014),
    [sym__type] = STATE(5014),
    [sym_constructor_type] = STATE(5014),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4271),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(5014),
    [sym_function_type] = STATE(5014),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4272),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(6598),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(6600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(8743),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(8745),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(8747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [4926] = {
    [sym__automatic_semicolon] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(9265),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(9267),
    [anon_sym_COMMA] = ACTIONS(7511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7511),
  },
  [4927] = {
    [sym__automatic_semicolon] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(9265),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(9267),
    [anon_sym_COMMA] = ACTIONS(7529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7529),
  },
  [4928] = {
    [sym__automatic_semicolon] = ACTIONS(9772),
    [anon_sym_LBRACK] = ACTIONS(9772),
    [sym_identifier] = ACTIONS(9876),
    [anon_sym_SEMI] = ACTIONS(9772),
    [anon_sym_module] = ACTIONS(9876),
    [anon_sym_symbol] = ACTIONS(9876),
    [anon_sym_number] = ACTIONS(9876),
    [anon_sym_AT] = ACTIONS(9772),
    [anon_sym_declare] = ACTIONS(9876),
    [anon_sym_STAR] = ACTIONS(9772),
    [anon_sym_void] = ACTIONS(9876),
    [anon_sym_any] = ACTIONS(9876),
    [anon_sym_private] = ACTIONS(9876),
    [anon_sym_boolean] = ACTIONS(9876),
    [anon_sym_async] = ACTIONS(9876),
    [anon_sym_public] = ACTIONS(9876),
    [anon_sym_get] = ACTIONS(9876),
    [anon_sym_RBRACE] = ACTIONS(9772),
    [anon_sym_static] = ACTIONS(9876),
    [anon_sym_SQUOTE] = ACTIONS(9772),
    [sym_number] = ACTIONS(9772),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(9876),
    [anon_sym_string] = ACTIONS(9876),
    [anon_sym_abstract] = ACTIONS(9876),
    [anon_sym_set] = ACTIONS(9876),
    [anon_sym_type] = ACTIONS(9876),
    [anon_sym_import] = ACTIONS(9876),
    [anon_sym_export] = ACTIONS(9876),
    [anon_sym_namespace] = ACTIONS(9876),
    [sym_readonly] = ACTIONS(9876),
    [anon_sym_DQUOTE] = ACTIONS(9772),
  },
  [4929] = {
    [sym_identifier] = ACTIONS(7523),
    [anon_sym_BQUOTE] = ACTIONS(7521),
    [anon_sym_debugger] = ACTIONS(7523),
    [anon_sym_symbol] = ACTIONS(7523),
    [anon_sym_AT] = ACTIONS(7521),
    [anon_sym_PIPE] = ACTIONS(7521),
    [anon_sym_DASH] = ACTIONS(7523),
    [anon_sym_void] = ACTIONS(7523),
    [anon_sym_break] = ACTIONS(7523),
    [anon_sym_const] = ACTIONS(7523),
    [sym_super] = ACTIONS(7523),
    [anon_sym_return] = ACTIONS(7523),
    [anon_sym_private] = ACTIONS(7523),
    [anon_sym_get] = ACTIONS(7523),
    [anon_sym_RBRACE] = ACTIONS(7521),
    [anon_sym_interface] = ACTIONS(7523),
    [anon_sym_default] = ACTIONS(7523),
    [anon_sym_enum] = ACTIONS(7523),
    [anon_sym_delete] = ACTIONS(7523),
    [anon_sym_continue] = ACTIONS(7523),
    [anon_sym_DASH_DASH] = ACTIONS(7521),
    [anon_sym_if] = ACTIONS(7523),
    [anon_sym_this] = ACTIONS(7523),
    [anon_sym_yield] = ACTIONS(7523),
    [sym_true] = ACTIONS(7523),
    [anon_sym_throw] = ACTIONS(7523),
    [anon_sym_protected] = ACTIONS(7523),
    [anon_sym_abstract] = ACTIONS(7523),
    [anon_sym_set] = ACTIONS(7523),
    [anon_sym_type] = ACTIONS(7523),
    [anon_sym_import] = ACTIONS(7523),
    [anon_sym_namespace] = ACTIONS(7523),
    [anon_sym_PLUS_PLUS] = ACTIONS(7521),
    [anon_sym_await] = ACTIONS(7523),
    [anon_sym_DQUOTE] = ACTIONS(7521),
    [anon_sym_else] = ACTIONS(7523),
    [anon_sym_BANG] = ACTIONS(7521),
    [anon_sym_for] = ACTIONS(7523),
    [anon_sym_LBRACK] = ACTIONS(7521),
    [sym_false] = ACTIONS(7523),
    [anon_sym_SEMI] = ACTIONS(7521),
    [anon_sym_case] = ACTIONS(7523),
    [anon_sym_module] = ACTIONS(7523),
    [anon_sym_number] = ACTIONS(7523),
    [anon_sym_class] = ACTIONS(7523),
    [anon_sym_declare] = ACTIONS(7523),
    [anon_sym_typeof] = ACTIONS(7523),
    [anon_sym_LBRACE] = ACTIONS(7521),
    [anon_sym_switch] = ACTIONS(7523),
    [anon_sym_LPAREN] = ACTIONS(7521),
    [sym_null] = ACTIONS(7523),
    [anon_sym_any] = ACTIONS(7523),
    [anon_sym_boolean] = ACTIONS(7523),
    [anon_sym_async] = ACTIONS(7523),
    [anon_sym_public] = ACTIONS(7523),
    [anon_sym_AMP] = ACTIONS(7521),
    [anon_sym_var] = ACTIONS(7523),
    [anon_sym_while] = ACTIONS(7523),
    [anon_sym_SQUOTE] = ACTIONS(7521),
    [anon_sym_try] = ACTIONS(7523),
    [anon_sym_LT] = ACTIONS(7521),
    [sym_number] = ACTIONS(7521),
    [anon_sym_SLASH] = ACTIONS(7523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7523),
    [anon_sym_function] = ACTIONS(7523),
    [sym_undefined] = ACTIONS(7523),
    [anon_sym_new] = ACTIONS(7523),
    [ts_builtin_sym_end] = ACTIONS(7521),
    [anon_sym_let] = ACTIONS(7523),
    [anon_sym_PLUS] = ACTIONS(7523),
    [anon_sym_export] = ACTIONS(7523),
    [anon_sym_do] = ACTIONS(7523),
    [anon_sym_TILDE] = ACTIONS(7521),
    [anon_sym_with] = ACTIONS(7523),
  },
  [4930] = {
    [sym_type_alias_declaration] = STATE(4545),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4545),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4545),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4545),
    [sym_return_statement] = STATE(4545),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4545),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4545),
    [sym_switch_statement] = STATE(4545),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4545),
    [sym_throw_statement] = STATE(4545),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4545),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4545),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(4545),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4545),
    [sym_abstract_class] = STATE(4545),
    [sym_interface_declaration] = STATE(4545),
    [sym_statement_block] = STATE(4545),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4545),
    [sym_debugger_statement] = STATE(4545),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4545),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4545),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4545),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4545),
    [sym_empty_statement] = STATE(4545),
    [sym_import_alias] = STATE(4545),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4545),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4545),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4545),
    [sym_break_statement] = STATE(4545),
    [sym_labeled_statement] = STATE(4545),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4545),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [4931] = {
    [sym_type_alias_declaration] = STATE(4546),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4546),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4546),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4546),
    [sym_return_statement] = STATE(4546),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4546),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4546),
    [sym_switch_statement] = STATE(4546),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4546),
    [sym_throw_statement] = STATE(4546),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4546),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4546),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(4546),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4546),
    [sym_abstract_class] = STATE(4546),
    [sym_interface_declaration] = STATE(4546),
    [sym_statement_block] = STATE(4546),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4546),
    [sym_debugger_statement] = STATE(4546),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4546),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4546),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4546),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4546),
    [sym_empty_statement] = STATE(4546),
    [sym_import_alias] = STATE(4546),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4546),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4546),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4546),
    [sym_break_statement] = STATE(4546),
    [sym_labeled_statement] = STATE(4546),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4546),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [4932] = {
    [sym_type_alias_declaration] = STATE(4547),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4547),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4547),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4547),
    [sym_return_statement] = STATE(4547),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4547),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4547),
    [sym_switch_statement] = STATE(4547),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4547),
    [sym_throw_statement] = STATE(4547),
    [aux_sym_export_statement_repeat1] = STATE(1456),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4547),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4547),
    [sym_decorator] = STATE(1456),
    [sym_continue_statement] = STATE(4547),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4547),
    [sym_abstract_class] = STATE(4547),
    [sym_interface_declaration] = STATE(4547),
    [sym_statement_block] = STATE(4547),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4547),
    [sym_debugger_statement] = STATE(4547),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4547),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4547),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4547),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4547),
    [sym_empty_statement] = STATE(4547),
    [sym_import_alias] = STATE(4547),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4547),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4547),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4547),
    [sym_break_statement] = STATE(4547),
    [sym_labeled_statement] = STATE(4547),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4547),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(2992),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(2996),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3004),
  },
  [4933] = {
    [sym_identifier] = ACTIONS(7192),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [anon_sym_debugger] = ACTIONS(7192),
    [anon_sym_symbol] = ACTIONS(7192),
    [anon_sym_AT] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(9616),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_void] = ACTIONS(7192),
    [anon_sym_break] = ACTIONS(7192),
    [anon_sym_const] = ACTIONS(7192),
    [sym_super] = ACTIONS(7192),
    [anon_sym_return] = ACTIONS(7192),
    [anon_sym_private] = ACTIONS(7192),
    [anon_sym_get] = ACTIONS(7192),
    [anon_sym_RBRACE] = ACTIONS(5893),
    [anon_sym_interface] = ACTIONS(7192),
    [anon_sym_enum] = ACTIONS(7192),
    [anon_sym_delete] = ACTIONS(7192),
    [anon_sym_continue] = ACTIONS(7192),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_if] = ACTIONS(7192),
    [anon_sym_this] = ACTIONS(7192),
    [anon_sym_yield] = ACTIONS(7192),
    [sym_true] = ACTIONS(7192),
    [anon_sym_throw] = ACTIONS(7192),
    [anon_sym_protected] = ACTIONS(7192),
    [anon_sym_abstract] = ACTIONS(7192),
    [anon_sym_set] = ACTIONS(7192),
    [anon_sym_type] = ACTIONS(7192),
    [anon_sym_import] = ACTIONS(7192),
    [anon_sym_namespace] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_await] = ACTIONS(7192),
    [anon_sym_DQUOTE] = ACTIONS(5893),
    [anon_sym_else] = ACTIONS(7192),
    [anon_sym_BANG] = ACTIONS(5893),
    [anon_sym_for] = ACTIONS(7192),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [sym_false] = ACTIONS(7192),
    [anon_sym_SEMI] = ACTIONS(5893),
    [anon_sym_module] = ACTIONS(7192),
    [anon_sym_number] = ACTIONS(7192),
    [anon_sym_class] = ACTIONS(7192),
    [anon_sym_declare] = ACTIONS(7192),
    [anon_sym_typeof] = ACTIONS(7192),
    [anon_sym_LBRACE] = ACTIONS(5893),
    [anon_sym_switch] = ACTIONS(7192),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [sym_null] = ACTIONS(7192),
    [anon_sym_any] = ACTIONS(7192),
    [anon_sym_boolean] = ACTIONS(7192),
    [anon_sym_async] = ACTIONS(7192),
    [anon_sym_public] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(9618),
    [anon_sym_var] = ACTIONS(7192),
    [anon_sym_while] = ACTIONS(7192),
    [anon_sym_SQUOTE] = ACTIONS(5893),
    [anon_sym_try] = ACTIONS(7192),
    [anon_sym_LT] = ACTIONS(5893),
    [sym_number] = ACTIONS(5893),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7192),
    [anon_sym_function] = ACTIONS(7192),
    [sym_undefined] = ACTIONS(7192),
    [anon_sym_new] = ACTIONS(7192),
    [anon_sym_let] = ACTIONS(7192),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_export] = ACTIONS(7192),
    [anon_sym_do] = ACTIONS(7192),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_with] = ACTIONS(7192),
  },
  [4934] = {
    [anon_sym_EQ_GT] = ACTIONS(9878),
    [sym_comment] = ACTIONS(3),
  },
  [4935] = {
    [sym_union_type] = STATE(5016),
    [sym__type] = STATE(5016),
    [sym_constructor_type] = STATE(5016),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4624),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5016),
    [sym_function_type] = STATE(5016),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4625),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9335),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9339),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9341),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4936] = {
    [sym_union_type] = STATE(5017),
    [sym__type] = STATE(5017),
    [sym_constructor_type] = STATE(5017),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4624),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5017),
    [sym_function_type] = STATE(5017),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4625),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9335),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9339),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9341),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4937] = {
    [sym_identifier] = ACTIONS(7208),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [anon_sym_debugger] = ACTIONS(7208),
    [anon_sym_symbol] = ACTIONS(7208),
    [anon_sym_AT] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(9616),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_void] = ACTIONS(7208),
    [anon_sym_break] = ACTIONS(7208),
    [anon_sym_const] = ACTIONS(7208),
    [sym_super] = ACTIONS(7208),
    [anon_sym_return] = ACTIONS(7208),
    [anon_sym_private] = ACTIONS(7208),
    [anon_sym_get] = ACTIONS(7208),
    [anon_sym_RBRACE] = ACTIONS(6040),
    [anon_sym_interface] = ACTIONS(7208),
    [anon_sym_enum] = ACTIONS(7208),
    [anon_sym_delete] = ACTIONS(7208),
    [anon_sym_continue] = ACTIONS(7208),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_if] = ACTIONS(7208),
    [anon_sym_this] = ACTIONS(7208),
    [anon_sym_yield] = ACTIONS(7208),
    [sym_true] = ACTIONS(7208),
    [anon_sym_throw] = ACTIONS(7208),
    [anon_sym_protected] = ACTIONS(7208),
    [anon_sym_abstract] = ACTIONS(7208),
    [anon_sym_set] = ACTIONS(7208),
    [anon_sym_type] = ACTIONS(7208),
    [anon_sym_import] = ACTIONS(7208),
    [anon_sym_namespace] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_await] = ACTIONS(7208),
    [anon_sym_DQUOTE] = ACTIONS(6040),
    [anon_sym_else] = ACTIONS(7208),
    [anon_sym_BANG] = ACTIONS(6040),
    [anon_sym_for] = ACTIONS(7208),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [sym_false] = ACTIONS(7208),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_module] = ACTIONS(7208),
    [anon_sym_number] = ACTIONS(7208),
    [anon_sym_class] = ACTIONS(7208),
    [anon_sym_declare] = ACTIONS(7208),
    [anon_sym_typeof] = ACTIONS(7208),
    [anon_sym_LBRACE] = ACTIONS(6040),
    [anon_sym_switch] = ACTIONS(7208),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [sym_null] = ACTIONS(7208),
    [anon_sym_any] = ACTIONS(7208),
    [anon_sym_boolean] = ACTIONS(7208),
    [anon_sym_async] = ACTIONS(7208),
    [anon_sym_public] = ACTIONS(7208),
    [anon_sym_AMP] = ACTIONS(9618),
    [anon_sym_var] = ACTIONS(7208),
    [anon_sym_while] = ACTIONS(7208),
    [anon_sym_SQUOTE] = ACTIONS(6040),
    [anon_sym_try] = ACTIONS(7208),
    [anon_sym_LT] = ACTIONS(6040),
    [sym_number] = ACTIONS(6040),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7208),
    [anon_sym_function] = ACTIONS(7208),
    [sym_undefined] = ACTIONS(7208),
    [anon_sym_new] = ACTIONS(7208),
    [anon_sym_let] = ACTIONS(7208),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_export] = ACTIONS(7208),
    [anon_sym_do] = ACTIONS(7208),
    [anon_sym_TILDE] = ACTIONS(6040),
    [anon_sym_with] = ACTIONS(7208),
  },
  [4938] = {
    [sym_identifier] = ACTIONS(9071),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [anon_sym_debugger] = ACTIONS(9071),
    [anon_sym_symbol] = ACTIONS(9071),
    [anon_sym_AT] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(8841),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_void] = ACTIONS(9071),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_const] = ACTIONS(9071),
    [sym_super] = ACTIONS(9071),
    [anon_sym_return] = ACTIONS(9071),
    [anon_sym_private] = ACTIONS(9071),
    [anon_sym_get] = ACTIONS(9071),
    [anon_sym_RBRACE] = ACTIONS(8547),
    [anon_sym_interface] = ACTIONS(9071),
    [anon_sym_enum] = ACTIONS(9071),
    [anon_sym_delete] = ACTIONS(9071),
    [anon_sym_continue] = ACTIONS(9071),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_if] = ACTIONS(9071),
    [anon_sym_this] = ACTIONS(9071),
    [anon_sym_yield] = ACTIONS(9071),
    [sym_true] = ACTIONS(9071),
    [anon_sym_throw] = ACTIONS(9071),
    [anon_sym_protected] = ACTIONS(9071),
    [anon_sym_abstract] = ACTIONS(9071),
    [anon_sym_set] = ACTIONS(9071),
    [anon_sym_type] = ACTIONS(9071),
    [anon_sym_import] = ACTIONS(9071),
    [anon_sym_namespace] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_await] = ACTIONS(9071),
    [anon_sym_DQUOTE] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8547),
    [anon_sym_for] = ACTIONS(9071),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [sym_false] = ACTIONS(9071),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_module] = ACTIONS(9071),
    [anon_sym_number] = ACTIONS(9071),
    [anon_sym_class] = ACTIONS(9071),
    [anon_sym_declare] = ACTIONS(9071),
    [anon_sym_typeof] = ACTIONS(9071),
    [anon_sym_LBRACE] = ACTIONS(8547),
    [anon_sym_switch] = ACTIONS(9071),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [sym_null] = ACTIONS(9071),
    [anon_sym_any] = ACTIONS(9071),
    [anon_sym_boolean] = ACTIONS(9071),
    [anon_sym_async] = ACTIONS(9071),
    [anon_sym_public] = ACTIONS(9071),
    [anon_sym_AMP] = ACTIONS(8843),
    [anon_sym_var] = ACTIONS(9071),
    [anon_sym_while] = ACTIONS(9071),
    [anon_sym_SQUOTE] = ACTIONS(8547),
    [anon_sym_try] = ACTIONS(9071),
    [anon_sym_LT] = ACTIONS(8547),
    [sym_number] = ACTIONS(8547),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9071),
    [anon_sym_function] = ACTIONS(9071),
    [sym_undefined] = ACTIONS(9071),
    [anon_sym_new] = ACTIONS(9071),
    [anon_sym_let] = ACTIONS(9071),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_export] = ACTIONS(9071),
    [anon_sym_do] = ACTIONS(9071),
    [anon_sym_TILDE] = ACTIONS(8547),
    [anon_sym_with] = ACTIONS(9071),
  },
  [4939] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(9071),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(9624),
    [anon_sym_COMMA] = ACTIONS(8547),
    [anon_sym_LT_LT] = ACTIONS(8547),
    [anon_sym_STAR] = ACTIONS(9071),
    [anon_sym_GT_GT_GT] = ACTIONS(8547),
    [anon_sym_AMP_AMP] = ACTIONS(8547),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_BANG_EQ] = ACTIONS(9071),
    [anon_sym_LT_EQ] = ACTIONS(8547),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [anon_sym_GT_EQ] = ACTIONS(8547),
    [anon_sym_GT] = ACTIONS(9071),
    [anon_sym_AMP] = ACTIONS(9626),
    [anon_sym_PERCENT] = ACTIONS(8547),
    [anon_sym_QMARK] = ACTIONS(8547),
    [anon_sym_as] = ACTIONS(8547),
    [anon_sym_PIPE_PIPE] = ACTIONS(8547),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_EQ_EQ] = ACTIONS(9071),
    [anon_sym_instanceof] = ACTIONS(8547),
    [anon_sym_LT] = ACTIONS(9071),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(8547),
    [anon_sym_DOT] = ACTIONS(8547),
    [anon_sym_CARET] = ACTIONS(8547),
    [anon_sym_STAR_STAR] = ACTIONS(8547),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_GT_GT] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8547),
    [anon_sym_in] = ACTIONS(9071),
  },
  [4940] = {
    [sym_type_alias_declaration] = STATE(2092),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(2092),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(2092),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(2092),
    [sym_return_statement] = STATE(2092),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(2092),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2092),
    [sym_switch_statement] = STATE(2092),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(2092),
    [sym_throw_statement] = STATE(2092),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(2092),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(2092),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(2092),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(2092),
    [sym_abstract_class] = STATE(2092),
    [sym_interface_declaration] = STATE(2092),
    [sym_statement_block] = STATE(2092),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(2092),
    [sym_debugger_statement] = STATE(2092),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(2092),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(2092),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(2092),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(2092),
    [sym_empty_statement] = STATE(2092),
    [sym_import_alias] = STATE(2092),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(2092),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(2092),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(2092),
    [sym_break_statement] = STATE(2092),
    [sym_labeled_statement] = STATE(2092),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(2092),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [4941] = {
    [sym_array] = STATE(5019),
    [sym_object] = STATE(5020),
    [anon_sym_LBRACK] = ACTIONS(175),
    [sym_identifier] = ACTIONS(9880),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(179),
  },
  [4942] = {
    [anon_sym_of] = ACTIONS(9882),
    [sym_comment] = ACTIONS(3),
  },
  [4943] = {
    [anon_sym_of] = ACTIONS(9884),
    [sym_comment] = ACTIONS(3),
  },
  [4944] = {
    [anon_sym_of] = ACTIONS(9886),
    [sym_comment] = ACTIONS(3),
  },
  [4945] = {
    [sym_new_expression] = STATE(5024),
    [sym_augmented_assignment_expression] = STATE(5024),
    [sym_unary_expression] = STATE(5024),
    [sym_update_expression] = STATE(5024),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(5024),
    [sym_regex] = STATE(5024),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(5024),
    [sym_non_null_expression] = STATE(5024),
    [sym_as_expression] = STATE(5024),
    [sym_jsx_fragment] = STATE(5024),
    [sym_yield_expression] = STATE(5024),
    [sym_jsx_element] = STATE(5024),
    [sym_internal_module] = STATE(5024),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(5024),
    [sym_await_expression] = STATE(5024),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(5025),
    [sym_string] = STATE(5024),
    [sym_this] = STATE(5024),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(5024),
    [sym_generator_function] = STATE(5024),
    [sym_call_expression] = STATE(5024),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(5024),
    [sym_ternary_expression] = STATE(5024),
    [sym_binary_expression] = STATE(5024),
    [sym_template_string] = STATE(5024),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5024),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(5024),
    [sym_class] = STATE(5024),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(9888),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(9888),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(9890),
    [sym_true] = ACTIONS(9888),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(9888),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [4946] = {
    [sym_new_expression] = STATE(5026),
    [sym_augmented_assignment_expression] = STATE(5026),
    [sym_unary_expression] = STATE(5026),
    [sym_update_expression] = STATE(5026),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(5026),
    [sym_regex] = STATE(5026),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(5026),
    [sym_non_null_expression] = STATE(5026),
    [sym_as_expression] = STATE(5026),
    [sym_jsx_fragment] = STATE(5026),
    [sym_yield_expression] = STATE(5026),
    [sym_jsx_element] = STATE(5026),
    [sym_internal_module] = STATE(5026),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(5026),
    [sym_await_expression] = STATE(5026),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(5026),
    [sym_this] = STATE(5026),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(5026),
    [sym_generator_function] = STATE(5026),
    [sym_call_expression] = STATE(5026),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(5026),
    [sym_ternary_expression] = STATE(5026),
    [sym_binary_expression] = STATE(5026),
    [sym_template_string] = STATE(5026),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5026),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(5026),
    [sym_class] = STATE(5026),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9892),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9892),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9894),
    [sym_true] = ACTIONS(9892),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9892),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4947] = {
    [sym__initializer] = STATE(391),
    [sym_type_annotation] = STATE(392),
    [sym__automatic_semicolon] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(715),
    [anon_sym_of] = ACTIONS(9882),
    [anon_sym_COMMA] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(9896),
  },
  [4948] = {
    [sym__initializer] = STATE(411),
    [sym_type_annotation] = STATE(412),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(745),
    [anon_sym_of] = ACTIONS(9884),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(9898),
  },
  [4949] = {
    [sym__initializer] = STATE(413),
    [sym_type_annotation] = STATE(414),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(745),
    [anon_sym_of] = ACTIONS(9886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(9900),
  },
  [4950] = {
    [sym_new_expression] = STATE(5031),
    [sym_augmented_assignment_expression] = STATE(5031),
    [sym_unary_expression] = STATE(5031),
    [sym_update_expression] = STATE(5031),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(5031),
    [sym_regex] = STATE(5031),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(5031),
    [sym_non_null_expression] = STATE(5031),
    [sym_as_expression] = STATE(5031),
    [sym_jsx_fragment] = STATE(5031),
    [sym_yield_expression] = STATE(5031),
    [sym_jsx_element] = STATE(5031),
    [sym_internal_module] = STATE(5031),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(5031),
    [sym_await_expression] = STATE(5031),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(5032),
    [sym_string] = STATE(5031),
    [sym_this] = STATE(5031),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(5031),
    [sym_generator_function] = STATE(5031),
    [sym_call_expression] = STATE(5031),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(5031),
    [sym_ternary_expression] = STATE(5031),
    [sym_binary_expression] = STATE(5031),
    [sym_template_string] = STATE(5031),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5031),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(5031),
    [sym_class] = STATE(5031),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(9902),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9902),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_RPAREN] = ACTIONS(9904),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9906),
    [sym_true] = ACTIONS(9902),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9902),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [4951] = {
    [sym_new_expression] = STATE(5033),
    [sym_augmented_assignment_expression] = STATE(5033),
    [sym_unary_expression] = STATE(5033),
    [sym_update_expression] = STATE(5033),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(5033),
    [sym_regex] = STATE(5033),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(5033),
    [sym_non_null_expression] = STATE(5033),
    [sym_as_expression] = STATE(5033),
    [sym_jsx_fragment] = STATE(5033),
    [sym_yield_expression] = STATE(5033),
    [sym_jsx_element] = STATE(5033),
    [sym_internal_module] = STATE(5033),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(5033),
    [sym_await_expression] = STATE(5033),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(5033),
    [sym_this] = STATE(5033),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(5033),
    [sym_generator_function] = STATE(5033),
    [sym_call_expression] = STATE(5033),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(5033),
    [sym_ternary_expression] = STATE(5033),
    [sym_binary_expression] = STATE(5033),
    [sym_template_string] = STATE(5033),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5033),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(5033),
    [sym_class] = STATE(5033),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9908),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9908),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9910),
    [sym_true] = ACTIONS(9908),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9908),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4952] = {
    [sym_new_expression] = STATE(5034),
    [sym_augmented_assignment_expression] = STATE(5034),
    [sym_unary_expression] = STATE(5034),
    [sym_update_expression] = STATE(5034),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(5034),
    [sym_regex] = STATE(5034),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(5034),
    [sym_non_null_expression] = STATE(5034),
    [sym_as_expression] = STATE(5034),
    [sym_jsx_fragment] = STATE(5034),
    [sym_yield_expression] = STATE(5034),
    [sym_jsx_element] = STATE(5034),
    [sym_internal_module] = STATE(5034),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(5034),
    [sym_await_expression] = STATE(5034),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(5035),
    [sym_string] = STATE(5034),
    [sym_this] = STATE(5034),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(5034),
    [sym_generator_function] = STATE(5034),
    [sym_call_expression] = STATE(5034),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(5034),
    [sym_ternary_expression] = STATE(5034),
    [sym_binary_expression] = STATE(5034),
    [sym_template_string] = STATE(5034),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5034),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(5034),
    [sym_class] = STATE(5034),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(9912),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(9914),
    [sym_true] = ACTIONS(9912),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(9912),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [4953] = {
    [sym_new_expression] = STATE(5036),
    [sym_augmented_assignment_expression] = STATE(5036),
    [sym_unary_expression] = STATE(5036),
    [sym_update_expression] = STATE(5036),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(5036),
    [sym_regex] = STATE(5036),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(5036),
    [sym_non_null_expression] = STATE(5036),
    [sym_as_expression] = STATE(5036),
    [sym_jsx_fragment] = STATE(5036),
    [sym_yield_expression] = STATE(5036),
    [sym_jsx_element] = STATE(5036),
    [sym_internal_module] = STATE(5036),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(5036),
    [sym_await_expression] = STATE(5036),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(5036),
    [sym_this] = STATE(5036),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(5036),
    [sym_generator_function] = STATE(5036),
    [sym_call_expression] = STATE(5036),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(5036),
    [sym_ternary_expression] = STATE(5036),
    [sym_binary_expression] = STATE(5036),
    [sym_template_string] = STATE(5036),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5036),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(5036),
    [sym_class] = STATE(5036),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9916),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9918),
    [sym_true] = ACTIONS(9916),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9916),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4954] = {
    [sym_new_expression] = STATE(5037),
    [sym_augmented_assignment_expression] = STATE(5037),
    [sym_unary_expression] = STATE(5037),
    [sym_update_expression] = STATE(5037),
    [sym_call_signature] = STATE(2132),
    [sym_meta_property] = STATE(5037),
    [sym_regex] = STATE(5037),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(5037),
    [sym_non_null_expression] = STATE(5037),
    [sym_as_expression] = STATE(5037),
    [sym_jsx_fragment] = STATE(5037),
    [sym_yield_expression] = STATE(5037),
    [sym_jsx_element] = STATE(5037),
    [sym_internal_module] = STATE(5037),
    [sym_function] = STATE(88),
    [sym_arrow_function] = STATE(5037),
    [sym_await_expression] = STATE(5037),
    [sym_member_expression] = STATE(2134),
    [sym_sequence_expression] = STATE(5038),
    [sym_string] = STATE(5037),
    [sym_this] = STATE(5037),
    [aux_sym_export_statement_repeat1] = STATE(89),
    [sym_object] = STATE(2136),
    [sym_anonymous_class] = STATE(5037),
    [sym_generator_function] = STATE(5037),
    [sym_call_expression] = STATE(5037),
    [sym_subscript_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(5037),
    [sym_ternary_expression] = STATE(5037),
    [sym_binary_expression] = STATE(5037),
    [sym_template_string] = STATE(5037),
    [sym_decorator] = STATE(89),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5037),
    [sym_array] = STATE(2137),
    [sym_jsx_opening_element] = STATE(64),
    [sym_jsx_self_closing_element] = STATE(5037),
    [sym_class] = STATE(5037),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_identifier] = ACTIONS(4499),
    [sym_false] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4503),
    [anon_sym_symbol] = ACTIONS(4503),
    [anon_sym_number] = ACTIONS(4503),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4503),
    [anon_sym_typeof] = ACTIONS(4505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(4509),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(9920),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4503),
    [anon_sym_private] = ACTIONS(4503),
    [anon_sym_boolean] = ACTIONS(4503),
    [anon_sym_async] = ACTIONS(4511),
    [anon_sym_public] = ACTIONS(4503),
    [anon_sym_get] = ACTIONS(4503),
    [anon_sym_delete] = ACTIONS(4505),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(4513),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(9922),
    [sym_true] = ACTIONS(9920),
    [anon_sym_yield] = ACTIONS(4517),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(4503),
    [anon_sym_string] = ACTIONS(4503),
    [anon_sym_function] = ACTIONS(159),
    [sym_undefined] = ACTIONS(9920),
    [anon_sym_set] = ACTIONS(4503),
    [anon_sym_type] = ACTIONS(4503),
    [anon_sym_new] = ACTIONS(4519),
    [anon_sym_import] = ACTIONS(4503),
    [anon_sym_export] = ACTIONS(4503),
    [anon_sym_namespace] = ACTIONS(4521),
    [anon_sym_PLUS] = ACTIONS(4507),
    [anon_sym_await] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(4497),
    [anon_sym_PLUS_PLUS] = ACTIONS(4513),
  },
  [4955] = {
    [anon_sym_COLON] = ACTIONS(9924),
    [sym_comment] = ACTIONS(3),
  },
  [4956] = {
    [sym_new_expression] = STATE(5040),
    [sym_augmented_assignment_expression] = STATE(5040),
    [sym_unary_expression] = STATE(5040),
    [sym_update_expression] = STATE(5040),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(5040),
    [sym_regex] = STATE(5040),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(5040),
    [sym_non_null_expression] = STATE(5040),
    [sym_as_expression] = STATE(5040),
    [sym_jsx_fragment] = STATE(5040),
    [sym_yield_expression] = STATE(5040),
    [sym_jsx_element] = STATE(5040),
    [sym_internal_module] = STATE(5040),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(5040),
    [sym_await_expression] = STATE(5040),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(5040),
    [sym_this] = STATE(5040),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(5040),
    [sym_generator_function] = STATE(5040),
    [sym_call_expression] = STATE(5040),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(5040),
    [sym_ternary_expression] = STATE(5040),
    [sym_binary_expression] = STATE(5040),
    [sym_template_string] = STATE(5040),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5040),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(5040),
    [sym_class] = STATE(5040),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9926),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9928),
    [sym_true] = ACTIONS(9926),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9926),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4957] = {
    [sym_new_expression] = STATE(5041),
    [sym_augmented_assignment_expression] = STATE(5041),
    [sym_unary_expression] = STATE(5041),
    [sym_update_expression] = STATE(5041),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(5041),
    [sym_regex] = STATE(5041),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(5041),
    [sym_non_null_expression] = STATE(5041),
    [sym_as_expression] = STATE(5041),
    [sym_jsx_fragment] = STATE(5041),
    [sym_yield_expression] = STATE(5041),
    [sym_jsx_element] = STATE(5041),
    [sym_internal_module] = STATE(5041),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(5041),
    [sym_await_expression] = STATE(5041),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(5041),
    [sym_this] = STATE(5041),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(5041),
    [sym_generator_function] = STATE(5041),
    [sym_call_expression] = STATE(5041),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(5041),
    [sym_ternary_expression] = STATE(5041),
    [sym_binary_expression] = STATE(5041),
    [sym_template_string] = STATE(5041),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5041),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(5041),
    [sym_class] = STATE(5041),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9930),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9930),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9932),
    [sym_true] = ACTIONS(9930),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9930),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4958] = {
    [sym_new_expression] = STATE(5042),
    [sym_augmented_assignment_expression] = STATE(5042),
    [sym_unary_expression] = STATE(5042),
    [sym_update_expression] = STATE(5042),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(5042),
    [sym_regex] = STATE(5042),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(5042),
    [sym_non_null_expression] = STATE(5042),
    [sym_as_expression] = STATE(5042),
    [sym_jsx_fragment] = STATE(5042),
    [sym_yield_expression] = STATE(5042),
    [sym_jsx_element] = STATE(5042),
    [sym_internal_module] = STATE(5042),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(5042),
    [sym_await_expression] = STATE(5042),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(5042),
    [sym_this] = STATE(5042),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(5042),
    [sym_generator_function] = STATE(5042),
    [sym_call_expression] = STATE(5042),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(5042),
    [sym_ternary_expression] = STATE(5042),
    [sym_binary_expression] = STATE(5042),
    [sym_template_string] = STATE(5042),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5042),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(5042),
    [sym_class] = STATE(5042),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9934),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9934),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9936),
    [sym_true] = ACTIONS(9934),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9934),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [4959] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9938),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4960] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9940),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4961] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9942),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4962] = {
    [sym_type_alias_declaration] = STATE(3704),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3704),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3704),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3704),
    [sym_return_statement] = STATE(3704),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3704),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3704),
    [sym_switch_statement] = STATE(3704),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3704),
    [sym_throw_statement] = STATE(3704),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3704),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3704),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(3704),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3704),
    [sym_abstract_class] = STATE(3704),
    [sym_interface_declaration] = STATE(3704),
    [sym_statement_block] = STATE(3704),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3704),
    [sym_debugger_statement] = STATE(3704),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3704),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3704),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3704),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3704),
    [sym_empty_statement] = STATE(3704),
    [sym_import_alias] = STATE(3704),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3704),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3704),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3704),
    [sym_break_statement] = STATE(3704),
    [sym_labeled_statement] = STATE(3704),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3704),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [4963] = {
    [sym_type_alias_declaration] = STATE(3732),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3732),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3732),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3732),
    [sym_return_statement] = STATE(3732),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3732),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3732),
    [sym_switch_statement] = STATE(3732),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3732),
    [sym_throw_statement] = STATE(3732),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3732),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3732),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(3732),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3732),
    [sym_abstract_class] = STATE(3732),
    [sym_interface_declaration] = STATE(3732),
    [sym_statement_block] = STATE(3732),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3732),
    [sym_debugger_statement] = STATE(3732),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3732),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3732),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3732),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3732),
    [sym_empty_statement] = STATE(3732),
    [sym_import_alias] = STATE(3732),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3732),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3732),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3732),
    [sym_break_statement] = STATE(3732),
    [sym_labeled_statement] = STATE(3732),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3732),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [4964] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(9944),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4965] = {
    [anon_sym_RPAREN] = ACTIONS(9944),
    [sym_comment] = ACTIONS(3),
  },
  [4966] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(9946),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4967] = {
    [anon_sym_RPAREN] = ACTIONS(9946),
    [sym_comment] = ACTIONS(3),
  },
  [4968] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(9948),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [4969] = {
    [anon_sym_RPAREN] = ACTIONS(9948),
    [sym_comment] = ACTIONS(3),
  },
  [4970] = {
    [sym_type_alias_declaration] = STATE(3737),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3737),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3737),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3737),
    [sym_return_statement] = STATE(3737),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3737),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3737),
    [sym_switch_statement] = STATE(3737),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3737),
    [sym_throw_statement] = STATE(3737),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3737),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3737),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(3737),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3737),
    [sym_abstract_class] = STATE(3737),
    [sym_interface_declaration] = STATE(3737),
    [sym_statement_block] = STATE(3737),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3737),
    [sym_debugger_statement] = STATE(3737),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3737),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3737),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3737),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3737),
    [sym_empty_statement] = STATE(3737),
    [sym_import_alias] = STATE(3737),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3737),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3737),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3737),
    [sym_break_statement] = STATE(3737),
    [sym_labeled_statement] = STATE(3737),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3737),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [4971] = {
    [sym_type_alias_declaration] = STATE(3738),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3738),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3738),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3738),
    [sym_return_statement] = STATE(3738),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3738),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3738),
    [sym_switch_statement] = STATE(3738),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3738),
    [sym_throw_statement] = STATE(3738),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3738),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3738),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(3738),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3738),
    [sym_abstract_class] = STATE(3738),
    [sym_interface_declaration] = STATE(3738),
    [sym_statement_block] = STATE(3738),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3738),
    [sym_debugger_statement] = STATE(3738),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3738),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3738),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3738),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3738),
    [sym_empty_statement] = STATE(3738),
    [sym_import_alias] = STATE(3738),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3738),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3738),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3738),
    [sym_break_statement] = STATE(3738),
    [sym_labeled_statement] = STATE(3738),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3738),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [4972] = {
    [sym_type_alias_declaration] = STATE(3739),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3739),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3739),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3739),
    [sym_return_statement] = STATE(3739),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3739),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3739),
    [sym_switch_statement] = STATE(3739),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3739),
    [sym_throw_statement] = STATE(3739),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3739),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3739),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(3739),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3739),
    [sym_abstract_class] = STATE(3739),
    [sym_interface_declaration] = STATE(3739),
    [sym_statement_block] = STATE(3739),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3739),
    [sym_debugger_statement] = STATE(3739),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3739),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3739),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3739),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3739),
    [sym_empty_statement] = STATE(3739),
    [sym_import_alias] = STATE(3739),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3739),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3739),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3739),
    [sym_break_statement] = STATE(3739),
    [sym_labeled_statement] = STATE(3739),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3739),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [4973] = {
    [sym_type_alias_declaration] = STATE(3740),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3740),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3740),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3740),
    [sym_return_statement] = STATE(3740),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3740),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3740),
    [sym_switch_statement] = STATE(3740),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3740),
    [sym_throw_statement] = STATE(3740),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3740),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3740),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(3740),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3740),
    [sym_abstract_class] = STATE(3740),
    [sym_interface_declaration] = STATE(3740),
    [sym_statement_block] = STATE(3740),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3740),
    [sym_debugger_statement] = STATE(3740),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3740),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3740),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3740),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3740),
    [sym_empty_statement] = STATE(3740),
    [sym_import_alias] = STATE(3740),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3740),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3740),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3740),
    [sym_break_statement] = STATE(3740),
    [sym_labeled_statement] = STATE(3740),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3740),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [4974] = {
    [sym_type_alias_declaration] = STATE(3741),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3741),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3741),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3741),
    [sym_return_statement] = STATE(3741),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3741),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3741),
    [sym_switch_statement] = STATE(3741),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3741),
    [sym_throw_statement] = STATE(3741),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3741),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3741),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(3741),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3741),
    [sym_abstract_class] = STATE(3741),
    [sym_interface_declaration] = STATE(3741),
    [sym_statement_block] = STATE(3741),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3741),
    [sym_debugger_statement] = STATE(3741),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3741),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3741),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3741),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3741),
    [sym_empty_statement] = STATE(3741),
    [sym_import_alias] = STATE(3741),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3741),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3741),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3741),
    [sym_break_statement] = STATE(3741),
    [sym_labeled_statement] = STATE(3741),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3741),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [4975] = {
    [sym_type_arguments] = STATE(1064),
    [sym_identifier] = ACTIONS(3699),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [anon_sym_debugger] = ACTIONS(3699),
    [anon_sym_symbol] = ACTIONS(3699),
    [anon_sym_AT] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_void] = ACTIONS(3699),
    [anon_sym_break] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [sym_super] = ACTIONS(3699),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_private] = ACTIONS(3699),
    [anon_sym_get] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_default] = ACTIONS(3699),
    [anon_sym_interface] = ACTIONS(3699),
    [anon_sym_enum] = ACTIONS(3699),
    [anon_sym_delete] = ACTIONS(3699),
    [anon_sym_continue] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(3699),
    [anon_sym_this] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3699),
    [sym_true] = ACTIONS(3699),
    [anon_sym_throw] = ACTIONS(3699),
    [anon_sym_protected] = ACTIONS(3699),
    [anon_sym_abstract] = ACTIONS(3699),
    [anon_sym_DOT] = ACTIONS(4187),
    [anon_sym_set] = ACTIONS(3699),
    [anon_sym_type] = ACTIONS(3699),
    [anon_sym_import] = ACTIONS(3699),
    [anon_sym_namespace] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_await] = ACTIONS(3699),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [sym_false] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_case] = ACTIONS(3699),
    [anon_sym_module] = ACTIONS(3699),
    [anon_sym_number] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_declare] = ACTIONS(3699),
    [anon_sym_typeof] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(9950),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [sym_null] = ACTIONS(3699),
    [anon_sym_any] = ACTIONS(3699),
    [anon_sym_boolean] = ACTIONS(3699),
    [anon_sym_async] = ACTIONS(3699),
    [anon_sym_public] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_var] = ACTIONS(3699),
    [anon_sym_while] = ACTIONS(3699),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_try] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(7943),
    [sym_number] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3699),
    [sym_undefined] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_export] = ACTIONS(3699),
    [anon_sym_do] = ACTIONS(3699),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_with] = ACTIONS(3699),
  },
  [4976] = {
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_array_type] = STATE(1066),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym_existential_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(1066),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(1066),
    [sym_string] = STATE(418),
    [sym_tuple_type] = STATE(1066),
    [sym_identifier] = ACTIONS(9840),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9842),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [sym_true] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4977] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4981),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4982),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9840),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9842),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9844),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9846),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4978] = {
    [sym_type_parameters] = STATE(5050),
    [sym_formal_parameters] = STATE(5051),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4979] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4981),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4982),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9840),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9842),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9844),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9846),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4980] = {
    [sym_identifier] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7948),
    [anon_sym_debugger] = ACTIONS(7946),
    [anon_sym_symbol] = ACTIONS(7946),
    [anon_sym_AT] = ACTIONS(7948),
    [anon_sym_PIPE] = ACTIONS(9952),
    [anon_sym_DASH] = ACTIONS(7946),
    [anon_sym_void] = ACTIONS(7946),
    [anon_sym_break] = ACTIONS(7946),
    [anon_sym_const] = ACTIONS(7946),
    [sym_super] = ACTIONS(7946),
    [anon_sym_return] = ACTIONS(7946),
    [anon_sym_private] = ACTIONS(7946),
    [anon_sym_get] = ACTIONS(7946),
    [anon_sym_RBRACE] = ACTIONS(7948),
    [anon_sym_default] = ACTIONS(7946),
    [anon_sym_interface] = ACTIONS(7946),
    [anon_sym_enum] = ACTIONS(7946),
    [anon_sym_delete] = ACTIONS(7946),
    [anon_sym_continue] = ACTIONS(7946),
    [anon_sym_DASH_DASH] = ACTIONS(7948),
    [anon_sym_if] = ACTIONS(7946),
    [anon_sym_this] = ACTIONS(7946),
    [anon_sym_yield] = ACTIONS(7946),
    [sym_true] = ACTIONS(7946),
    [anon_sym_throw] = ACTIONS(7946),
    [anon_sym_protected] = ACTIONS(7946),
    [anon_sym_abstract] = ACTIONS(7946),
    [anon_sym_set] = ACTIONS(7946),
    [anon_sym_type] = ACTIONS(7946),
    [anon_sym_import] = ACTIONS(7946),
    [anon_sym_namespace] = ACTIONS(7946),
    [anon_sym_PLUS_PLUS] = ACTIONS(7948),
    [anon_sym_await] = ACTIONS(7946),
    [anon_sym_DQUOTE] = ACTIONS(7948),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_for] = ACTIONS(7946),
    [anon_sym_LBRACK] = ACTIONS(7948),
    [sym_false] = ACTIONS(7946),
    [anon_sym_SEMI] = ACTIONS(7948),
    [anon_sym_case] = ACTIONS(7946),
    [anon_sym_module] = ACTIONS(7946),
    [anon_sym_number] = ACTIONS(7946),
    [anon_sym_class] = ACTIONS(7946),
    [anon_sym_declare] = ACTIONS(7946),
    [anon_sym_typeof] = ACTIONS(7946),
    [anon_sym_LBRACE] = ACTIONS(7948),
    [anon_sym_switch] = ACTIONS(7946),
    [anon_sym_LPAREN] = ACTIONS(7948),
    [sym_null] = ACTIONS(7946),
    [anon_sym_any] = ACTIONS(7946),
    [anon_sym_boolean] = ACTIONS(7946),
    [anon_sym_async] = ACTIONS(7946),
    [anon_sym_public] = ACTIONS(7946),
    [anon_sym_AMP] = ACTIONS(9954),
    [anon_sym_var] = ACTIONS(7946),
    [anon_sym_while] = ACTIONS(7946),
    [anon_sym_SQUOTE] = ACTIONS(7948),
    [anon_sym_try] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(7948),
    [sym_number] = ACTIONS(7948),
    [anon_sym_SLASH] = ACTIONS(7946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7946),
    [anon_sym_function] = ACTIONS(7946),
    [sym_undefined] = ACTIONS(7946),
    [anon_sym_new] = ACTIONS(7946),
    [anon_sym_let] = ACTIONS(7946),
    [anon_sym_PLUS] = ACTIONS(7946),
    [anon_sym_export] = ACTIONS(7946),
    [anon_sym_do] = ACTIONS(7946),
    [anon_sym_TILDE] = ACTIONS(7948),
    [anon_sym_with] = ACTIONS(7946),
  },
  [4981] = {
    [sym_formal_parameters] = STATE(5054),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4982] = {
    [anon_sym_EQ_GT] = ACTIONS(9956),
    [sym_comment] = ACTIONS(3),
  },
  [4983] = {
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_RPAREN] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(8923),
    [anon_sym_COMMA] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(8925),
    [sym_comment] = ACTIONS(3),
  },
  [4984] = {
    [sym__automatic_semicolon] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(8961),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(8963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8547),
  },
  [4985] = {
    [sym_type_alias_declaration] = STATE(4545),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4545),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4545),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4545),
    [sym_return_statement] = STATE(4545),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4545),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4545),
    [sym_switch_statement] = STATE(4545),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4545),
    [sym_throw_statement] = STATE(4545),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4545),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4545),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(4545),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4545),
    [sym_abstract_class] = STATE(4545),
    [sym_interface_declaration] = STATE(4545),
    [sym_statement_block] = STATE(4545),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4545),
    [sym_debugger_statement] = STATE(4545),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4545),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4545),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4545),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4545),
    [sym_empty_statement] = STATE(4545),
    [sym_import_alias] = STATE(4545),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4545),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4545),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4545),
    [sym_break_statement] = STATE(4545),
    [sym_labeled_statement] = STATE(4545),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4545),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [4986] = {
    [sym_type_alias_declaration] = STATE(4546),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4546),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4546),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4546),
    [sym_return_statement] = STATE(4546),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4546),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4546),
    [sym_switch_statement] = STATE(4546),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4546),
    [sym_throw_statement] = STATE(4546),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4546),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4546),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(4546),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4546),
    [sym_abstract_class] = STATE(4546),
    [sym_interface_declaration] = STATE(4546),
    [sym_statement_block] = STATE(4546),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4546),
    [sym_debugger_statement] = STATE(4546),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4546),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4546),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4546),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4546),
    [sym_empty_statement] = STATE(4546),
    [sym_import_alias] = STATE(4546),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4546),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4546),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4546),
    [sym_break_statement] = STATE(4546),
    [sym_labeled_statement] = STATE(4546),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4546),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [4987] = {
    [sym_type_alias_declaration] = STATE(4547),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4547),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4547),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4547),
    [sym_return_statement] = STATE(4547),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(312),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4547),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4547),
    [sym_switch_statement] = STATE(4547),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4547),
    [sym_throw_statement] = STATE(4547),
    [aux_sym_export_statement_repeat1] = STATE(1699),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4547),
    [sym_generator_function] = STATE(312),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4547),
    [sym_decorator] = STATE(1699),
    [sym_continue_statement] = STATE(4547),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4547),
    [sym_abstract_class] = STATE(4547),
    [sym_interface_declaration] = STATE(4547),
    [sym_statement_block] = STATE(4547),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4547),
    [sym_debugger_statement] = STATE(4547),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4547),
    [sym_function] = STATE(314),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4547),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4547),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4547),
    [sym_empty_statement] = STATE(4547),
    [sym_import_alias] = STATE(4547),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4547),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4547),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4547),
    [sym_break_statement] = STATE(4547),
    [sym_labeled_statement] = STATE(4547),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4547),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(312),
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(526),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(530),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(3569),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(3573),
  },
  [4988] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(4717),
    [sym_type_parameters] = STATE(4992),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4993),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9465),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9856),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9858),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4989] = {
    [sym_type_parameters] = STATE(5056),
    [sym_formal_parameters] = STATE(5057),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [4990] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(4717),
    [sym_type_parameters] = STATE(4992),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4993),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9465),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9856),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9858),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4991] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_AMP] = ACTIONS(9958),
    [anon_sym_PIPE] = ACTIONS(9960),
    [anon_sym_else] = ACTIONS(5893),
    [anon_sym_while] = ACTIONS(5893),
  },
  [4992] = {
    [sym_formal_parameters] = STATE(5060),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [4993] = {
    [anon_sym_EQ_GT] = ACTIONS(9962),
    [sym_comment] = ACTIONS(3),
  },
  [4994] = {
    [anon_sym_EQ_GT] = ACTIONS(9964),
    [sym_comment] = ACTIONS(3),
  },
  [4995] = {
    [sym_union_type] = STATE(5063),
    [sym__type] = STATE(5063),
    [sym_constructor_type] = STATE(5063),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(4717),
    [sym_type_parameters] = STATE(4718),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5063),
    [sym_function_type] = STATE(5063),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4719),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9465),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9469),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9471),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4996] = {
    [sym_union_type] = STATE(5064),
    [sym__type] = STATE(5064),
    [sym_constructor_type] = STATE(5064),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(4717),
    [sym_type_parameters] = STATE(4718),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5064),
    [sym_function_type] = STATE(5064),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4719),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9465),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9469),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9471),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [4997] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(9720),
    [anon_sym_PIPE] = ACTIONS(9722),
    [anon_sym_else] = ACTIONS(6040),
    [anon_sym_while] = ACTIONS(6040),
  },
  [4998] = {
    [anon_sym_EQ_GT] = ACTIONS(9966),
    [sym_comment] = ACTIONS(3),
  },
  [4999] = {
    [sym_union_type] = STATE(5066),
    [sym__type] = STATE(5066),
    [sym_constructor_type] = STATE(5066),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(4727),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5066),
    [sym_function_type] = STATE(5066),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4728),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8345),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9481),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9483),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5000] = {
    [sym_union_type] = STATE(5067),
    [sym__type] = STATE(5067),
    [sym_constructor_type] = STATE(5067),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(4727),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5067),
    [sym_function_type] = STATE(5067),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4728),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8345),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9481),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9483),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5001] = {
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(9726),
    [anon_sym_PIPE] = ACTIONS(9728),
    [anon_sym_while] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
  },
  [5002] = {
    [anon_sym_AMP] = ACTIONS(9053),
    [anon_sym_PIPE] = ACTIONS(9055),
    [anon_sym_while] = ACTIONS(8547),
    [sym_comment] = ACTIONS(3),
  },
  [5003] = {
    [anon_sym_EQ_GT] = ACTIONS(9968),
    [sym_comment] = ACTIONS(3),
  },
  [5004] = {
    [sym_union_type] = STATE(5069),
    [sym__type] = STATE(5069),
    [sym_constructor_type] = STATE(5069),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4742),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(5069),
    [sym_function_type] = STATE(5069),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4743),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(8421),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(8423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(9498),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(9500),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(9502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [5005] = {
    [sym_union_type] = STATE(5070),
    [sym__type] = STATE(5070),
    [sym_constructor_type] = STATE(5070),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4742),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(5070),
    [sym_function_type] = STATE(5070),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4743),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(8421),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(8423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(9498),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(9500),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(9502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [5006] = {
    [sym__automatic_semicolon] = ACTIONS(6040),
    [anon_sym_RBRACE] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(9734),
    [anon_sym_PIPE_RBRACE] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(6040),
  },
  [5007] = {
    [sym__automatic_semicolon] = ACTIONS(8547),
    [anon_sym_RBRACE] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(9089),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(9091),
    [anon_sym_COMMA] = ACTIONS(8547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8547),
  },
  [5008] = {
    [sym_statement_block] = STATE(4827),
    [sym__automatic_semicolon] = ACTIONS(9758),
    [anon_sym_RBRACE] = ACTIONS(9758),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(9758),
    [anon_sym_COMMA] = ACTIONS(9758),
    [anon_sym_PIPE_RBRACE] = ACTIONS(9758),
    [anon_sym_LBRACE] = ACTIONS(460),
  },
  [5009] = {
    [sym__automatic_semicolon] = ACTIONS(8547),
    [anon_sym_RBRACE] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(9141),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(9143),
    [anon_sym_COMMA] = ACTIONS(8547),
    [sym_comment] = ACTIONS(3),
  },
  [5010] = {
    [sym_identifier] = ACTIONS(9071),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [anon_sym_debugger] = ACTIONS(9071),
    [anon_sym_symbol] = ACTIONS(9071),
    [anon_sym_AT] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(9189),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_void] = ACTIONS(9071),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_const] = ACTIONS(9071),
    [sym_super] = ACTIONS(9071),
    [anon_sym_return] = ACTIONS(9071),
    [anon_sym_private] = ACTIONS(9071),
    [anon_sym_get] = ACTIONS(9071),
    [anon_sym_interface] = ACTIONS(9071),
    [anon_sym_enum] = ACTIONS(9071),
    [anon_sym_delete] = ACTIONS(9071),
    [anon_sym_continue] = ACTIONS(9071),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_if] = ACTIONS(9071),
    [anon_sym_this] = ACTIONS(9071),
    [anon_sym_yield] = ACTIONS(9071),
    [sym_true] = ACTIONS(9071),
    [anon_sym_throw] = ACTIONS(9071),
    [anon_sym_protected] = ACTIONS(9071),
    [anon_sym_abstract] = ACTIONS(9071),
    [anon_sym_set] = ACTIONS(9071),
    [anon_sym_type] = ACTIONS(9071),
    [anon_sym_import] = ACTIONS(9071),
    [anon_sym_namespace] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_await] = ACTIONS(9071),
    [anon_sym_DQUOTE] = ACTIONS(8547),
    [anon_sym_else] = ACTIONS(9071),
    [anon_sym_BANG] = ACTIONS(8547),
    [anon_sym_for] = ACTIONS(9071),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [sym_false] = ACTIONS(9071),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_module] = ACTIONS(9071),
    [anon_sym_number] = ACTIONS(9071),
    [anon_sym_class] = ACTIONS(9071),
    [anon_sym_declare] = ACTIONS(9071),
    [anon_sym_typeof] = ACTIONS(9071),
    [anon_sym_LBRACE] = ACTIONS(8547),
    [anon_sym_switch] = ACTIONS(9071),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [sym_null] = ACTIONS(9071),
    [anon_sym_any] = ACTIONS(9071),
    [anon_sym_boolean] = ACTIONS(9071),
    [anon_sym_async] = ACTIONS(9071),
    [anon_sym_public] = ACTIONS(9071),
    [anon_sym_AMP] = ACTIONS(9191),
    [anon_sym_var] = ACTIONS(9071),
    [anon_sym_while] = ACTIONS(9071),
    [anon_sym_SQUOTE] = ACTIONS(8547),
    [anon_sym_try] = ACTIONS(9071),
    [anon_sym_LT] = ACTIONS(8547),
    [sym_number] = ACTIONS(8547),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9071),
    [anon_sym_function] = ACTIONS(9071),
    [sym_undefined] = ACTIONS(9071),
    [anon_sym_new] = ACTIONS(9071),
    [ts_builtin_sym_end] = ACTIONS(8547),
    [anon_sym_let] = ACTIONS(9071),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_export] = ACTIONS(9071),
    [anon_sym_do] = ACTIONS(9071),
    [anon_sym_TILDE] = ACTIONS(8547),
    [anon_sym_with] = ACTIONS(9071),
  },
  [5011] = {
    [sym_union_type] = STATE(5071),
    [sym__type] = STATE(5071),
    [sym_constructor_type] = STATE(5071),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4572),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(5071),
    [sym_function_type] = STATE(5071),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4573),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(7911),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(7913),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(9255),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(9257),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(9259),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [5012] = {
    [sym__automatic_semicolon] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(9570),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_COMMA] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(9572),
    [sym_comment] = ACTIONS(3),
  },
  [5013] = {
    [sym__automatic_semicolon] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(9570),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_COMMA] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(9572),
    [sym_comment] = ACTIONS(3),
  },
  [5014] = {
    [sym__automatic_semicolon] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(9265),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(9267),
    [anon_sym_COMMA] = ACTIONS(8547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8547),
  },
  [5015] = {
    [sym_union_type] = STATE(5072),
    [sym__type] = STATE(5072),
    [sym_constructor_type] = STATE(5072),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4624),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5072),
    [sym_function_type] = STATE(5072),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4625),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9335),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9337),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9339),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9341),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5016] = {
    [sym_identifier] = ACTIONS(8379),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [anon_sym_debugger] = ACTIONS(8379),
    [anon_sym_symbol] = ACTIONS(8379),
    [anon_sym_AT] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(9616),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_void] = ACTIONS(8379),
    [anon_sym_break] = ACTIONS(8379),
    [anon_sym_const] = ACTIONS(8379),
    [sym_super] = ACTIONS(8379),
    [anon_sym_return] = ACTIONS(8379),
    [anon_sym_private] = ACTIONS(8379),
    [anon_sym_get] = ACTIONS(8379),
    [anon_sym_RBRACE] = ACTIONS(7511),
    [anon_sym_interface] = ACTIONS(8379),
    [anon_sym_enum] = ACTIONS(8379),
    [anon_sym_delete] = ACTIONS(8379),
    [anon_sym_continue] = ACTIONS(8379),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_if] = ACTIONS(8379),
    [anon_sym_this] = ACTIONS(8379),
    [anon_sym_yield] = ACTIONS(8379),
    [sym_true] = ACTIONS(8379),
    [anon_sym_throw] = ACTIONS(8379),
    [anon_sym_protected] = ACTIONS(8379),
    [anon_sym_abstract] = ACTIONS(8379),
    [anon_sym_set] = ACTIONS(8379),
    [anon_sym_type] = ACTIONS(8379),
    [anon_sym_import] = ACTIONS(8379),
    [anon_sym_namespace] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_await] = ACTIONS(8379),
    [anon_sym_DQUOTE] = ACTIONS(7511),
    [anon_sym_else] = ACTIONS(8379),
    [anon_sym_BANG] = ACTIONS(7511),
    [anon_sym_for] = ACTIONS(8379),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [sym_false] = ACTIONS(8379),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_module] = ACTIONS(8379),
    [anon_sym_number] = ACTIONS(8379),
    [anon_sym_class] = ACTIONS(8379),
    [anon_sym_declare] = ACTIONS(8379),
    [anon_sym_typeof] = ACTIONS(8379),
    [anon_sym_LBRACE] = ACTIONS(7511),
    [anon_sym_switch] = ACTIONS(8379),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [sym_null] = ACTIONS(8379),
    [anon_sym_any] = ACTIONS(8379),
    [anon_sym_boolean] = ACTIONS(8379),
    [anon_sym_async] = ACTIONS(8379),
    [anon_sym_public] = ACTIONS(8379),
    [anon_sym_AMP] = ACTIONS(9618),
    [anon_sym_var] = ACTIONS(8379),
    [anon_sym_while] = ACTIONS(8379),
    [anon_sym_SQUOTE] = ACTIONS(7511),
    [anon_sym_try] = ACTIONS(8379),
    [anon_sym_LT] = ACTIONS(7511),
    [sym_number] = ACTIONS(7511),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8379),
    [anon_sym_function] = ACTIONS(8379),
    [sym_undefined] = ACTIONS(8379),
    [anon_sym_new] = ACTIONS(8379),
    [anon_sym_let] = ACTIONS(8379),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_export] = ACTIONS(8379),
    [anon_sym_do] = ACTIONS(8379),
    [anon_sym_TILDE] = ACTIONS(7511),
    [anon_sym_with] = ACTIONS(8379),
  },
  [5017] = {
    [sym_identifier] = ACTIONS(8381),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [anon_sym_debugger] = ACTIONS(8381),
    [anon_sym_symbol] = ACTIONS(8381),
    [anon_sym_AT] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(9616),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_void] = ACTIONS(8381),
    [anon_sym_break] = ACTIONS(8381),
    [anon_sym_const] = ACTIONS(8381),
    [sym_super] = ACTIONS(8381),
    [anon_sym_return] = ACTIONS(8381),
    [anon_sym_private] = ACTIONS(8381),
    [anon_sym_get] = ACTIONS(8381),
    [anon_sym_RBRACE] = ACTIONS(7529),
    [anon_sym_interface] = ACTIONS(8381),
    [anon_sym_enum] = ACTIONS(8381),
    [anon_sym_delete] = ACTIONS(8381),
    [anon_sym_continue] = ACTIONS(8381),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_if] = ACTIONS(8381),
    [anon_sym_this] = ACTIONS(8381),
    [anon_sym_yield] = ACTIONS(8381),
    [sym_true] = ACTIONS(8381),
    [anon_sym_throw] = ACTIONS(8381),
    [anon_sym_protected] = ACTIONS(8381),
    [anon_sym_abstract] = ACTIONS(8381),
    [anon_sym_set] = ACTIONS(8381),
    [anon_sym_type] = ACTIONS(8381),
    [anon_sym_import] = ACTIONS(8381),
    [anon_sym_namespace] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_await] = ACTIONS(8381),
    [anon_sym_DQUOTE] = ACTIONS(7529),
    [anon_sym_else] = ACTIONS(8381),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_for] = ACTIONS(8381),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [sym_false] = ACTIONS(8381),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_module] = ACTIONS(8381),
    [anon_sym_number] = ACTIONS(8381),
    [anon_sym_class] = ACTIONS(8381),
    [anon_sym_declare] = ACTIONS(8381),
    [anon_sym_typeof] = ACTIONS(8381),
    [anon_sym_LBRACE] = ACTIONS(7529),
    [anon_sym_switch] = ACTIONS(8381),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [sym_null] = ACTIONS(8381),
    [anon_sym_any] = ACTIONS(8381),
    [anon_sym_boolean] = ACTIONS(8381),
    [anon_sym_async] = ACTIONS(8381),
    [anon_sym_public] = ACTIONS(8381),
    [anon_sym_AMP] = ACTIONS(9618),
    [anon_sym_var] = ACTIONS(8381),
    [anon_sym_while] = ACTIONS(8381),
    [anon_sym_SQUOTE] = ACTIONS(7529),
    [anon_sym_try] = ACTIONS(8381),
    [anon_sym_LT] = ACTIONS(7529),
    [sym_number] = ACTIONS(7529),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8381),
    [anon_sym_function] = ACTIONS(8381),
    [sym_undefined] = ACTIONS(8381),
    [anon_sym_new] = ACTIONS(8381),
    [anon_sym_let] = ACTIONS(8381),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_export] = ACTIONS(8381),
    [anon_sym_do] = ACTIONS(8381),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_with] = ACTIONS(8381),
  },
  [5018] = {
    [anon_sym_of] = ACTIONS(9970),
    [sym_comment] = ACTIONS(3),
  },
  [5019] = {
    [anon_sym_of] = ACTIONS(9972),
    [sym_comment] = ACTIONS(3),
  },
  [5020] = {
    [anon_sym_of] = ACTIONS(9974),
    [sym_comment] = ACTIONS(3),
  },
  [5021] = {
    [sym_new_expression] = STATE(5076),
    [sym_augmented_assignment_expression] = STATE(5076),
    [sym_unary_expression] = STATE(5076),
    [sym_update_expression] = STATE(5076),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(5076),
    [sym_regex] = STATE(5076),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(5076),
    [sym_non_null_expression] = STATE(5076),
    [sym_as_expression] = STATE(5076),
    [sym_jsx_fragment] = STATE(5076),
    [sym_yield_expression] = STATE(5076),
    [sym_jsx_element] = STATE(5076),
    [sym_internal_module] = STATE(5076),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(5076),
    [sym_await_expression] = STATE(5076),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(5076),
    [sym_this] = STATE(5076),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(5076),
    [sym_generator_function] = STATE(5076),
    [sym_call_expression] = STATE(5076),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(5076),
    [sym_ternary_expression] = STATE(5076),
    [sym_binary_expression] = STATE(5076),
    [sym_template_string] = STATE(5076),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5076),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(5076),
    [sym_class] = STATE(5076),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9976),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9976),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9978),
    [sym_true] = ACTIONS(9976),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9976),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [5022] = {
    [sym_new_expression] = STATE(5077),
    [sym_augmented_assignment_expression] = STATE(5077),
    [sym_unary_expression] = STATE(5077),
    [sym_update_expression] = STATE(5077),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(5077),
    [sym_regex] = STATE(5077),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(5077),
    [sym_non_null_expression] = STATE(5077),
    [sym_as_expression] = STATE(5077),
    [sym_jsx_fragment] = STATE(5077),
    [sym_yield_expression] = STATE(5077),
    [sym_jsx_element] = STATE(5077),
    [sym_internal_module] = STATE(5077),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(5077),
    [sym_await_expression] = STATE(5077),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(5077),
    [sym_this] = STATE(5077),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(5077),
    [sym_generator_function] = STATE(5077),
    [sym_call_expression] = STATE(5077),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(5077),
    [sym_ternary_expression] = STATE(5077),
    [sym_binary_expression] = STATE(5077),
    [sym_template_string] = STATE(5077),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5077),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(5077),
    [sym_class] = STATE(5077),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9980),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9980),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9982),
    [sym_true] = ACTIONS(9980),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9980),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [5023] = {
    [sym_new_expression] = STATE(5078),
    [sym_augmented_assignment_expression] = STATE(5078),
    [sym_unary_expression] = STATE(5078),
    [sym_update_expression] = STATE(5078),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(5078),
    [sym_regex] = STATE(5078),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(5078),
    [sym_non_null_expression] = STATE(5078),
    [sym_as_expression] = STATE(5078),
    [sym_jsx_fragment] = STATE(5078),
    [sym_yield_expression] = STATE(5078),
    [sym_jsx_element] = STATE(5078),
    [sym_internal_module] = STATE(5078),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(5078),
    [sym_await_expression] = STATE(5078),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(5078),
    [sym_this] = STATE(5078),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(5078),
    [sym_generator_function] = STATE(5078),
    [sym_call_expression] = STATE(5078),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(5078),
    [sym_ternary_expression] = STATE(5078),
    [sym_binary_expression] = STATE(5078),
    [sym_template_string] = STATE(5078),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5078),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(5078),
    [sym_class] = STATE(5078),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(9984),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9984),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9986),
    [sym_true] = ACTIONS(9984),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9984),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [5024] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(9988),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [5025] = {
    [anon_sym_RPAREN] = ACTIONS(9988),
    [sym_comment] = ACTIONS(3),
  },
  [5026] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(9990),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [5027] = {
    [sym_new_expression] = STATE(5081),
    [sym_augmented_assignment_expression] = STATE(5081),
    [sym_unary_expression] = STATE(5081),
    [sym_update_expression] = STATE(5081),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(5081),
    [sym_regex] = STATE(5081),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(5081),
    [sym_non_null_expression] = STATE(5081),
    [sym_as_expression] = STATE(5081),
    [sym_jsx_fragment] = STATE(5081),
    [sym_yield_expression] = STATE(5081),
    [sym_jsx_element] = STATE(5081),
    [sym_internal_module] = STATE(5081),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(5081),
    [sym_await_expression] = STATE(5081),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(5082),
    [sym_string] = STATE(5081),
    [sym_this] = STATE(5081),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(5081),
    [sym_generator_function] = STATE(5081),
    [sym_call_expression] = STATE(5081),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(5081),
    [sym_ternary_expression] = STATE(5081),
    [sym_binary_expression] = STATE(5081),
    [sym_template_string] = STATE(5081),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5081),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(5081),
    [sym_class] = STATE(5081),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(9992),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9992),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9994),
    [sym_true] = ACTIONS(9992),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9992),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [5028] = {
    [sym_new_expression] = STATE(5083),
    [sym_augmented_assignment_expression] = STATE(5083),
    [sym_unary_expression] = STATE(5083),
    [sym_update_expression] = STATE(5083),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(5083),
    [sym_regex] = STATE(5083),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(5083),
    [sym_non_null_expression] = STATE(5083),
    [sym_as_expression] = STATE(5083),
    [sym_jsx_fragment] = STATE(5083),
    [sym_yield_expression] = STATE(5083),
    [sym_jsx_element] = STATE(5083),
    [sym_internal_module] = STATE(5083),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(5083),
    [sym_await_expression] = STATE(5083),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(5084),
    [sym_string] = STATE(5083),
    [sym_this] = STATE(5083),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(5083),
    [sym_generator_function] = STATE(5083),
    [sym_call_expression] = STATE(5083),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(5083),
    [sym_ternary_expression] = STATE(5083),
    [sym_binary_expression] = STATE(5083),
    [sym_template_string] = STATE(5083),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5083),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(5083),
    [sym_class] = STATE(5083),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(9996),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(9996),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(9998),
    [sym_true] = ACTIONS(9996),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(9996),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [5029] = {
    [sym_new_expression] = STATE(5085),
    [sym_augmented_assignment_expression] = STATE(5085),
    [sym_unary_expression] = STATE(5085),
    [sym_update_expression] = STATE(5085),
    [sym_call_signature] = STATE(452),
    [sym_meta_property] = STATE(5085),
    [sym_regex] = STATE(5085),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(5085),
    [sym_non_null_expression] = STATE(5085),
    [sym_as_expression] = STATE(5085),
    [sym_jsx_fragment] = STATE(5085),
    [sym_yield_expression] = STATE(5085),
    [sym_jsx_element] = STATE(5085),
    [sym_internal_module] = STATE(5085),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(5085),
    [sym_await_expression] = STATE(5085),
    [sym_member_expression] = STATE(454),
    [sym_sequence_expression] = STATE(5086),
    [sym_string] = STATE(5085),
    [sym_this] = STATE(5085),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(456),
    [sym_anonymous_class] = STATE(5085),
    [sym_generator_function] = STATE(5085),
    [sym_call_expression] = STATE(5085),
    [sym_subscript_expression] = STATE(454),
    [sym_assignment_expression] = STATE(5085),
    [sym_ternary_expression] = STATE(5085),
    [sym_binary_expression] = STATE(5085),
    [sym_template_string] = STATE(5085),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5085),
    [sym_array] = STATE(458),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(5085),
    [sym_class] = STATE(5085),
    [anon_sym_BANG] = ACTIONS(785),
    [sym_identifier] = ACTIONS(787),
    [sym_false] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(791),
    [anon_sym_symbol] = ACTIONS(791),
    [anon_sym_number] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_typeof] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(10000),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_boolean] = ACTIONS(791),
    [anon_sym_async] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_get] = ACTIONS(791),
    [anon_sym_delete] = ACTIONS(793),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(10002),
    [sym_true] = ACTIONS(10000),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(10000),
    [anon_sym_set] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(791),
    [anon_sym_export] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
  },
  [5030] = {
    [sym_type_alias_declaration] = STATE(3041),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3041),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3041),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3041),
    [sym_return_statement] = STATE(3041),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3041),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3041),
    [sym_switch_statement] = STATE(3041),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3041),
    [sym_throw_statement] = STATE(3041),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3041),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3041),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(3041),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3041),
    [sym_abstract_class] = STATE(3041),
    [sym_interface_declaration] = STATE(3041),
    [sym_statement_block] = STATE(3041),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3041),
    [sym_debugger_statement] = STATE(3041),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3041),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3041),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3041),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3041),
    [sym_empty_statement] = STATE(3041),
    [sym_import_alias] = STATE(3041),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3041),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3041),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3041),
    [sym_break_statement] = STATE(3041),
    [sym_labeled_statement] = STATE(3041),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3041),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [5031] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(10004),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [5032] = {
    [anon_sym_RPAREN] = ACTIONS(10004),
    [sym_comment] = ACTIONS(3),
  },
  [5033] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(10006),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [5034] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(10008),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [5035] = {
    [anon_sym_RPAREN] = ACTIONS(10008),
    [sym_comment] = ACTIONS(3),
  },
  [5036] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(10010),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [5037] = {
    [sym_type_arguments] = STATE(103),
    [sym_template_string] = STATE(104),
    [sym_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BANG] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(6301),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_GT_GT_GT] = ACTIONS(6301),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(183),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_as] = ACTIONS(6307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_DASH_DASH] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(2001),
    [anon_sym_instanceof] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(6309),
    [anon_sym_RPAREN] = ACTIONS(10012),
    [anon_sym_SLASH] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(6313),
    [anon_sym_PLUS] = ACTIONS(6305),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(2001),
  },
  [5038] = {
    [anon_sym_RPAREN] = ACTIONS(10012),
    [sym_comment] = ACTIONS(3),
  },
  [5039] = {
    [sym_union_type] = STATE(5097),
    [sym__type] = STATE(5097),
    [sym_constructor_type] = STATE(5097),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(5098),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5097),
    [sym_function_type] = STATE(5097),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(5099),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(10014),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(10020),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(10022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5040] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(10024),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [5041] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(10026),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [5042] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(10028),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [5043] = {
    [sym_type_alias_declaration] = STATE(4210),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4210),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4210),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4210),
    [sym_return_statement] = STATE(4210),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4210),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4210),
    [sym_switch_statement] = STATE(4210),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4210),
    [sym_throw_statement] = STATE(4210),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4210),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4210),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(4210),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4210),
    [sym_abstract_class] = STATE(4210),
    [sym_interface_declaration] = STATE(4210),
    [sym_statement_block] = STATE(4210),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4210),
    [sym_debugger_statement] = STATE(4210),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4210),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4210),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4210),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4210),
    [sym_empty_statement] = STATE(4210),
    [sym_import_alias] = STATE(4210),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4210),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4210),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4210),
    [sym_break_statement] = STATE(4210),
    [sym_labeled_statement] = STATE(4210),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4210),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [5044] = {
    [sym_type_alias_declaration] = STATE(4211),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4211),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4211),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4211),
    [sym_return_statement] = STATE(4211),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4211),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4211),
    [sym_switch_statement] = STATE(4211),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4211),
    [sym_throw_statement] = STATE(4211),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4211),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4211),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(4211),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4211),
    [sym_abstract_class] = STATE(4211),
    [sym_interface_declaration] = STATE(4211),
    [sym_statement_block] = STATE(4211),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4211),
    [sym_debugger_statement] = STATE(4211),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4211),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4211),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4211),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4211),
    [sym_empty_statement] = STATE(4211),
    [sym_import_alias] = STATE(4211),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4211),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4211),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4211),
    [sym_break_statement] = STATE(4211),
    [sym_labeled_statement] = STATE(4211),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4211),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [5045] = {
    [sym_type_alias_declaration] = STATE(4212),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4212),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4212),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4212),
    [sym_return_statement] = STATE(4212),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4212),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4212),
    [sym_switch_statement] = STATE(4212),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4212),
    [sym_throw_statement] = STATE(4212),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4212),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4212),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(4212),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4212),
    [sym_abstract_class] = STATE(4212),
    [sym_interface_declaration] = STATE(4212),
    [sym_statement_block] = STATE(4212),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4212),
    [sym_debugger_statement] = STATE(4212),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4212),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4212),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4212),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4212),
    [sym_empty_statement] = STATE(4212),
    [sym_import_alias] = STATE(4212),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4212),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4212),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4212),
    [sym_break_statement] = STATE(4212),
    [sym_labeled_statement] = STATE(4212),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4212),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [5046] = {
    [sym_type_alias_declaration] = STATE(4235),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4235),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4235),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4235),
    [sym_return_statement] = STATE(4235),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4235),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4235),
    [sym_switch_statement] = STATE(4235),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4235),
    [sym_throw_statement] = STATE(4235),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4235),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4235),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(4235),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4235),
    [sym_abstract_class] = STATE(4235),
    [sym_interface_declaration] = STATE(4235),
    [sym_statement_block] = STATE(4235),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4235),
    [sym_debugger_statement] = STATE(4235),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4235),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4235),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4235),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4235),
    [sym_empty_statement] = STATE(4235),
    [sym_import_alias] = STATE(4235),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4235),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4235),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4235),
    [sym_break_statement] = STATE(4235),
    [sym_labeled_statement] = STATE(4235),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4235),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [5047] = {
    [sym_type_alias_declaration] = STATE(4236),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4236),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4236),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4236),
    [sym_return_statement] = STATE(4236),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4236),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4236),
    [sym_switch_statement] = STATE(4236),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4236),
    [sym_throw_statement] = STATE(4236),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4236),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4236),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(4236),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4236),
    [sym_abstract_class] = STATE(4236),
    [sym_interface_declaration] = STATE(4236),
    [sym_statement_block] = STATE(4236),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4236),
    [sym_debugger_statement] = STATE(4236),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4236),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4236),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4236),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4236),
    [sym_empty_statement] = STATE(4236),
    [sym_import_alias] = STATE(4236),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4236),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4236),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4236),
    [sym_break_statement] = STATE(4236),
    [sym_labeled_statement] = STATE(4236),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4236),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [5048] = {
    [sym_type_alias_declaration] = STATE(4237),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4237),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4237),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4237),
    [sym_return_statement] = STATE(4237),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4237),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4237),
    [sym_switch_statement] = STATE(4237),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4237),
    [sym_throw_statement] = STATE(4237),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4237),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4237),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(4237),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4237),
    [sym_abstract_class] = STATE(4237),
    [sym_interface_declaration] = STATE(4237),
    [sym_statement_block] = STATE(4237),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4237),
    [sym_debugger_statement] = STATE(4237),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4237),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4237),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4237),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4237),
    [sym_empty_statement] = STATE(4237),
    [sym_import_alias] = STATE(4237),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4237),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4237),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4237),
    [sym_break_statement] = STATE(4237),
    [sym_labeled_statement] = STATE(4237),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4237),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [5049] = {
    [sym_union_type] = STATE(5103),
    [sym__type] = STATE(5103),
    [sym_constructor_type] = STATE(5103),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4981),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5103),
    [sym_function_type] = STATE(5103),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4982),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9840),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9842),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9844),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9846),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5050] = {
    [sym_formal_parameters] = STATE(5104),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [5051] = {
    [anon_sym_EQ_GT] = ACTIONS(10030),
    [sym_comment] = ACTIONS(3),
  },
  [5052] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4981),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4982),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9840),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9842),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9844),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9846),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5053] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4981),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4982),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9840),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9842),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9844),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9846),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5054] = {
    [anon_sym_EQ_GT] = ACTIONS(10032),
    [sym_comment] = ACTIONS(3),
  },
  [5055] = {
    [sym_union_type] = STATE(5107),
    [sym__type] = STATE(5107),
    [sym_constructor_type] = STATE(5107),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4981),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5107),
    [sym_function_type] = STATE(5107),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4982),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9840),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9842),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9844),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9846),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5056] = {
    [sym_formal_parameters] = STATE(5108),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [5057] = {
    [anon_sym_EQ_GT] = ACTIONS(10034),
    [sym_comment] = ACTIONS(3),
  },
  [5058] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(4717),
    [sym_type_parameters] = STATE(4992),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4993),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9465),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9856),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9858),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5059] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(4717),
    [sym_type_parameters] = STATE(4992),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4993),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9465),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9856),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9858),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5060] = {
    [anon_sym_EQ_GT] = ACTIONS(10036),
    [sym_comment] = ACTIONS(3),
  },
  [5061] = {
    [sym_union_type] = STATE(5111),
    [sym__type] = STATE(5111),
    [sym_constructor_type] = STATE(5111),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(4717),
    [sym_type_parameters] = STATE(4992),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5111),
    [sym_function_type] = STATE(5111),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4993),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9465),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9856),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9858),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5062] = {
    [sym_union_type] = STATE(5112),
    [sym__type] = STATE(5112),
    [sym_constructor_type] = STATE(5112),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(4717),
    [sym_type_parameters] = STATE(4718),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5112),
    [sym_function_type] = STATE(5112),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4719),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9465),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9469),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9471),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5063] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(9720),
    [anon_sym_PIPE] = ACTIONS(9722),
    [anon_sym_else] = ACTIONS(7511),
    [anon_sym_while] = ACTIONS(7511),
  },
  [5064] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(9720),
    [anon_sym_PIPE] = ACTIONS(9722),
    [anon_sym_else] = ACTIONS(7529),
    [anon_sym_while] = ACTIONS(7529),
  },
  [5065] = {
    [sym_union_type] = STATE(5113),
    [sym__type] = STATE(5113),
    [sym_constructor_type] = STATE(5113),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(433),
    [sym_type_parameters] = STATE(4727),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5113),
    [sym_function_type] = STATE(5113),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4728),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(8345),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(8347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9481),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9483),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5066] = {
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(9726),
    [anon_sym_PIPE] = ACTIONS(9728),
    [anon_sym_while] = ACTIONS(7511),
    [sym_comment] = ACTIONS(3),
  },
  [5067] = {
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(9726),
    [anon_sym_PIPE] = ACTIONS(9728),
    [anon_sym_while] = ACTIONS(7529),
    [sym_comment] = ACTIONS(3),
  },
  [5068] = {
    [sym_union_type] = STATE(5114),
    [sym__type] = STATE(5114),
    [sym_constructor_type] = STATE(5114),
    [sym_index_type_query] = STATE(1035),
    [sym_lookup_type] = STATE(1035),
    [sym_flow_maybe_type] = STATE(1035),
    [sym_parenthesized_type] = STATE(1035),
    [sym_nested_type_identifier] = STATE(1032),
    [sym_type_parameters] = STATE(4742),
    [sym_array_type] = STATE(1035),
    [sym_type_predicate] = STATE(1035),
    [sym_type_query] = STATE(1035),
    [sym_existential_type] = STATE(1035),
    [sym_this_type] = STATE(1035),
    [sym_nested_identifier] = STATE(1034),
    [sym_object_type] = STATE(1035),
    [sym_intersection_type] = STATE(5114),
    [sym_function_type] = STATE(5114),
    [sym__primary_type] = STATE(1035),
    [sym_generic_type] = STATE(1035),
    [sym_literal_type] = STATE(1035),
    [sym__number] = STATE(1017),
    [sym_predefined_type] = STATE(1035),
    [sym_string] = STATE(1017),
    [sym_formal_parameters] = STATE(4743),
    [sym_tuple_type] = STATE(1035),
    [sym_identifier] = ACTIONS(8421),
    [sym_false] = ACTIONS(2137),
    [anon_sym_QMARK] = ACTIONS(8423),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(9498),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(2147),
    [anon_sym_symbol] = ACTIONS(2147),
    [anon_sym_this] = ACTIONS(2149),
    [anon_sym_typeof] = ACTIONS(2151),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_STAR] = ACTIONS(2155),
    [anon_sym_keyof] = ACTIONS(2157),
    [sym_number] = ACTIONS(2159),
    [sym_true] = ACTIONS(2137),
    [anon_sym_void] = ACTIONS(2147),
    [anon_sym_string] = ACTIONS(2147),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_new] = ACTIONS(9500),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_PIPE] = ACTIONS(9502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_boolean] = ACTIONS(2147),
  },
  [5069] = {
    [sym__automatic_semicolon] = ACTIONS(7511),
    [anon_sym_RBRACE] = ACTIONS(7511),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(9734),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(7511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7511),
  },
  [5070] = {
    [sym__automatic_semicolon] = ACTIONS(7529),
    [anon_sym_RBRACE] = ACTIONS(7529),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(9734),
    [anon_sym_PIPE_RBRACE] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(7529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(7529),
  },
  [5071] = {
    [sym__automatic_semicolon] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(9570),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_COMMA] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(9572),
    [sym_comment] = ACTIONS(3),
  },
  [5072] = {
    [sym_identifier] = ACTIONS(9071),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [anon_sym_debugger] = ACTIONS(9071),
    [anon_sym_symbol] = ACTIONS(9071),
    [anon_sym_AT] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(9616),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_void] = ACTIONS(9071),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_const] = ACTIONS(9071),
    [sym_super] = ACTIONS(9071),
    [anon_sym_return] = ACTIONS(9071),
    [anon_sym_private] = ACTIONS(9071),
    [anon_sym_get] = ACTIONS(9071),
    [anon_sym_RBRACE] = ACTIONS(8547),
    [anon_sym_interface] = ACTIONS(9071),
    [anon_sym_enum] = ACTIONS(9071),
    [anon_sym_delete] = ACTIONS(9071),
    [anon_sym_continue] = ACTIONS(9071),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_if] = ACTIONS(9071),
    [anon_sym_this] = ACTIONS(9071),
    [anon_sym_yield] = ACTIONS(9071),
    [sym_true] = ACTIONS(9071),
    [anon_sym_throw] = ACTIONS(9071),
    [anon_sym_protected] = ACTIONS(9071),
    [anon_sym_abstract] = ACTIONS(9071),
    [anon_sym_set] = ACTIONS(9071),
    [anon_sym_type] = ACTIONS(9071),
    [anon_sym_import] = ACTIONS(9071),
    [anon_sym_namespace] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_await] = ACTIONS(9071),
    [anon_sym_DQUOTE] = ACTIONS(8547),
    [anon_sym_else] = ACTIONS(9071),
    [anon_sym_BANG] = ACTIONS(8547),
    [anon_sym_for] = ACTIONS(9071),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [sym_false] = ACTIONS(9071),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_module] = ACTIONS(9071),
    [anon_sym_number] = ACTIONS(9071),
    [anon_sym_class] = ACTIONS(9071),
    [anon_sym_declare] = ACTIONS(9071),
    [anon_sym_typeof] = ACTIONS(9071),
    [anon_sym_LBRACE] = ACTIONS(8547),
    [anon_sym_switch] = ACTIONS(9071),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [sym_null] = ACTIONS(9071),
    [anon_sym_any] = ACTIONS(9071),
    [anon_sym_boolean] = ACTIONS(9071),
    [anon_sym_async] = ACTIONS(9071),
    [anon_sym_public] = ACTIONS(9071),
    [anon_sym_AMP] = ACTIONS(9618),
    [anon_sym_var] = ACTIONS(9071),
    [anon_sym_while] = ACTIONS(9071),
    [anon_sym_SQUOTE] = ACTIONS(8547),
    [anon_sym_try] = ACTIONS(9071),
    [anon_sym_LT] = ACTIONS(8547),
    [sym_number] = ACTIONS(8547),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9071),
    [anon_sym_function] = ACTIONS(9071),
    [sym_undefined] = ACTIONS(9071),
    [anon_sym_new] = ACTIONS(9071),
    [anon_sym_let] = ACTIONS(9071),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_export] = ACTIONS(9071),
    [anon_sym_do] = ACTIONS(9071),
    [anon_sym_TILDE] = ACTIONS(8547),
    [anon_sym_with] = ACTIONS(9071),
  },
  [5073] = {
    [sym_new_expression] = STATE(5115),
    [sym_augmented_assignment_expression] = STATE(5115),
    [sym_unary_expression] = STATE(5115),
    [sym_update_expression] = STATE(5115),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(5115),
    [sym_regex] = STATE(5115),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(5115),
    [sym_non_null_expression] = STATE(5115),
    [sym_as_expression] = STATE(5115),
    [sym_jsx_fragment] = STATE(5115),
    [sym_yield_expression] = STATE(5115),
    [sym_jsx_element] = STATE(5115),
    [sym_internal_module] = STATE(5115),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(5115),
    [sym_await_expression] = STATE(5115),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(5115),
    [sym_this] = STATE(5115),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(5115),
    [sym_generator_function] = STATE(5115),
    [sym_call_expression] = STATE(5115),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(5115),
    [sym_ternary_expression] = STATE(5115),
    [sym_binary_expression] = STATE(5115),
    [sym_template_string] = STATE(5115),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5115),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(5115),
    [sym_class] = STATE(5115),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(10038),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(10038),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(10040),
    [sym_true] = ACTIONS(10038),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(10038),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [5074] = {
    [sym_new_expression] = STATE(5116),
    [sym_augmented_assignment_expression] = STATE(5116),
    [sym_unary_expression] = STATE(5116),
    [sym_update_expression] = STATE(5116),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(5116),
    [sym_regex] = STATE(5116),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(5116),
    [sym_non_null_expression] = STATE(5116),
    [sym_as_expression] = STATE(5116),
    [sym_jsx_fragment] = STATE(5116),
    [sym_yield_expression] = STATE(5116),
    [sym_jsx_element] = STATE(5116),
    [sym_internal_module] = STATE(5116),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(5116),
    [sym_await_expression] = STATE(5116),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(5116),
    [sym_this] = STATE(5116),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(5116),
    [sym_generator_function] = STATE(5116),
    [sym_call_expression] = STATE(5116),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(5116),
    [sym_ternary_expression] = STATE(5116),
    [sym_binary_expression] = STATE(5116),
    [sym_template_string] = STATE(5116),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5116),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(5116),
    [sym_class] = STATE(5116),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(10042),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(10042),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(10044),
    [sym_true] = ACTIONS(10042),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(10042),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [5075] = {
    [sym_new_expression] = STATE(5117),
    [sym_augmented_assignment_expression] = STATE(5117),
    [sym_unary_expression] = STATE(5117),
    [sym_update_expression] = STATE(5117),
    [sym_call_signature] = STATE(2149),
    [sym_meta_property] = STATE(5117),
    [sym_regex] = STATE(5117),
    [sym_type_parameters] = STATE(51),
    [sym__expression] = STATE(5117),
    [sym_non_null_expression] = STATE(5117),
    [sym_as_expression] = STATE(5117),
    [sym_jsx_fragment] = STATE(5117),
    [sym_yield_expression] = STATE(5117),
    [sym_jsx_element] = STATE(5117),
    [sym_internal_module] = STATE(5117),
    [sym_function] = STATE(161),
    [sym_arrow_function] = STATE(5117),
    [sym_await_expression] = STATE(5117),
    [sym_member_expression] = STATE(2151),
    [sym_string] = STATE(5117),
    [sym_this] = STATE(5117),
    [aux_sym_export_statement_repeat1] = STATE(164),
    [sym_object] = STATE(2152),
    [sym_anonymous_class] = STATE(5117),
    [sym_generator_function] = STATE(5117),
    [sym_call_expression] = STATE(5117),
    [sym_subscript_expression] = STATE(2151),
    [sym_assignment_expression] = STATE(5117),
    [sym_ternary_expression] = STATE(5117),
    [sym_binary_expression] = STATE(5117),
    [sym_template_string] = STATE(5117),
    [sym_decorator] = STATE(164),
    [sym_formal_parameters] = STATE(57),
    [sym_parenthesized_expression] = STATE(5117),
    [sym_array] = STATE(2153),
    [sym_jsx_opening_element] = STATE(168),
    [sym_jsx_self_closing_element] = STATE(5117),
    [sym_class] = STATE(5117),
    [anon_sym_BANG] = ACTIONS(4525),
    [sym_identifier] = ACTIONS(4527),
    [sym_false] = ACTIONS(10046),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(4531),
    [anon_sym_symbol] = ACTIONS(4531),
    [anon_sym_number] = ACTIONS(4531),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_declare] = ACTIONS(4531),
    [anon_sym_typeof] = ACTIONS(4533),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4535),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_void] = ACTIONS(4537),
    [anon_sym_LPAREN] = ACTIONS(274),
    [sym_null] = ACTIONS(10046),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4531),
    [anon_sym_private] = ACTIONS(4531),
    [anon_sym_boolean] = ACTIONS(4531),
    [anon_sym_async] = ACTIONS(4539),
    [anon_sym_public] = ACTIONS(4531),
    [anon_sym_get] = ACTIONS(4531),
    [anon_sym_delete] = ACTIONS(4533),
    [anon_sym_SQUOTE] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(4541),
    [anon_sym_LT] = ACTIONS(286),
    [sym_number] = ACTIONS(10048),
    [sym_true] = ACTIONS(10046),
    [anon_sym_yield] = ACTIONS(4545),
    [anon_sym_SLASH] = ACTIONS(292),
    [anon_sym_this] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(4531),
    [anon_sym_string] = ACTIONS(4531),
    [anon_sym_function] = ACTIONS(296),
    [sym_undefined] = ACTIONS(10046),
    [anon_sym_set] = ACTIONS(4531),
    [anon_sym_type] = ACTIONS(4531),
    [anon_sym_new] = ACTIONS(4547),
    [anon_sym_import] = ACTIONS(4531),
    [anon_sym_export] = ACTIONS(4531),
    [anon_sym_namespace] = ACTIONS(4549),
    [anon_sym_PLUS] = ACTIONS(4535),
    [anon_sym_await] = ACTIONS(4551),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(4525),
    [anon_sym_PLUS_PLUS] = ACTIONS(4541),
  },
  [5076] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(10050),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [5077] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(10052),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [5078] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(10054),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [5079] = {
    [sym_type_alias_declaration] = STATE(3704),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3704),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3704),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3704),
    [sym_return_statement] = STATE(3704),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3704),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3704),
    [sym_switch_statement] = STATE(3704),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3704),
    [sym_throw_statement] = STATE(3704),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3704),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3704),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(3704),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3704),
    [sym_abstract_class] = STATE(3704),
    [sym_interface_declaration] = STATE(3704),
    [sym_statement_block] = STATE(3704),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3704),
    [sym_debugger_statement] = STATE(3704),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3704),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3704),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3704),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3704),
    [sym_empty_statement] = STATE(3704),
    [sym_import_alias] = STATE(3704),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3704),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3704),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3704),
    [sym_break_statement] = STATE(3704),
    [sym_labeled_statement] = STATE(3704),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3704),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [5080] = {
    [sym_type_alias_declaration] = STATE(3732),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3732),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3732),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3732),
    [sym_return_statement] = STATE(3732),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3732),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3732),
    [sym_switch_statement] = STATE(3732),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3732),
    [sym_throw_statement] = STATE(3732),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3732),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3732),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(3732),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3732),
    [sym_abstract_class] = STATE(3732),
    [sym_interface_declaration] = STATE(3732),
    [sym_statement_block] = STATE(3732),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3732),
    [sym_debugger_statement] = STATE(3732),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3732),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3732),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3732),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3732),
    [sym_empty_statement] = STATE(3732),
    [sym_import_alias] = STATE(3732),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3732),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3732),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3732),
    [sym_break_statement] = STATE(3732),
    [sym_labeled_statement] = STATE(3732),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3732),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [5081] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(10056),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [5082] = {
    [anon_sym_RPAREN] = ACTIONS(10056),
    [sym_comment] = ACTIONS(3),
  },
  [5083] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(10058),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [5084] = {
    [anon_sym_RPAREN] = ACTIONS(10058),
    [sym_comment] = ACTIONS(3),
  },
  [5085] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(2365),
    [anon_sym_COMMA] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2371),
    [anon_sym_STAR] = ACTIONS(2373),
    [anon_sym_BANG_EQ] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(2363),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2375),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2379),
    [anon_sym_as] = ACTIONS(2381),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(10060),
    [anon_sym_SLASH] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_STAR_STAR] = ACTIONS(2387),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_GT_GT] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [5086] = {
    [anon_sym_RPAREN] = ACTIONS(10060),
    [sym_comment] = ACTIONS(3),
  },
  [5087] = {
    [sym_type_alias_declaration] = STATE(3737),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3737),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3737),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3737),
    [sym_return_statement] = STATE(3737),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3737),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3737),
    [sym_switch_statement] = STATE(3737),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3737),
    [sym_throw_statement] = STATE(3737),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3737),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3737),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(3737),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3737),
    [sym_abstract_class] = STATE(3737),
    [sym_interface_declaration] = STATE(3737),
    [sym_statement_block] = STATE(3737),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3737),
    [sym_debugger_statement] = STATE(3737),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3737),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3737),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3737),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3737),
    [sym_empty_statement] = STATE(3737),
    [sym_import_alias] = STATE(3737),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3737),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3737),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3737),
    [sym_break_statement] = STATE(3737),
    [sym_labeled_statement] = STATE(3737),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3737),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [5088] = {
    [sym_type_alias_declaration] = STATE(3738),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3738),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3738),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3738),
    [sym_return_statement] = STATE(3738),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3738),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3738),
    [sym_switch_statement] = STATE(3738),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3738),
    [sym_throw_statement] = STATE(3738),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3738),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3738),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(3738),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3738),
    [sym_abstract_class] = STATE(3738),
    [sym_interface_declaration] = STATE(3738),
    [sym_statement_block] = STATE(3738),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3738),
    [sym_debugger_statement] = STATE(3738),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3738),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3738),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3738),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3738),
    [sym_empty_statement] = STATE(3738),
    [sym_import_alias] = STATE(3738),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3738),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3738),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3738),
    [sym_break_statement] = STATE(3738),
    [sym_labeled_statement] = STATE(3738),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3738),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [5089] = {
    [sym_type_alias_declaration] = STATE(3739),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3739),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3739),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3739),
    [sym_return_statement] = STATE(3739),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3739),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3739),
    [sym_switch_statement] = STATE(3739),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3739),
    [sym_throw_statement] = STATE(3739),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3739),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3739),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(3739),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3739),
    [sym_abstract_class] = STATE(3739),
    [sym_interface_declaration] = STATE(3739),
    [sym_statement_block] = STATE(3739),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3739),
    [sym_debugger_statement] = STATE(3739),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3739),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3739),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3739),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3739),
    [sym_empty_statement] = STATE(3739),
    [sym_import_alias] = STATE(3739),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3739),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3739),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3739),
    [sym_break_statement] = STATE(3739),
    [sym_labeled_statement] = STATE(3739),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3739),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [5090] = {
    [sym_type_alias_declaration] = STATE(3740),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3740),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3740),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3740),
    [sym_return_statement] = STATE(3740),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3740),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3740),
    [sym_switch_statement] = STATE(3740),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3740),
    [sym_throw_statement] = STATE(3740),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3740),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3740),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(3740),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3740),
    [sym_abstract_class] = STATE(3740),
    [sym_interface_declaration] = STATE(3740),
    [sym_statement_block] = STATE(3740),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3740),
    [sym_debugger_statement] = STATE(3740),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3740),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3740),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3740),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3740),
    [sym_empty_statement] = STATE(3740),
    [sym_import_alias] = STATE(3740),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3740),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3740),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3740),
    [sym_break_statement] = STATE(3740),
    [sym_labeled_statement] = STATE(3740),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3740),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [5091] = {
    [sym_type_alias_declaration] = STATE(3741),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(3741),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(3741),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(3741),
    [sym_return_statement] = STATE(3741),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(3741),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(3741),
    [sym_switch_statement] = STATE(3741),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(3741),
    [sym_throw_statement] = STATE(3741),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(3741),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(3741),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(3741),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(3741),
    [sym_abstract_class] = STATE(3741),
    [sym_interface_declaration] = STATE(3741),
    [sym_statement_block] = STATE(3741),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(3741),
    [sym_debugger_statement] = STATE(3741),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(3741),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(3741),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(3741),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(3741),
    [sym_empty_statement] = STATE(3741),
    [sym_import_alias] = STATE(3741),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(3741),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(3741),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(3741),
    [sym_break_statement] = STATE(3741),
    [sym_labeled_statement] = STATE(3741),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(3741),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [5092] = {
    [sym_type_arguments] = STATE(1064),
    [sym_identifier] = ACTIONS(3699),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [anon_sym_debugger] = ACTIONS(3699),
    [anon_sym_symbol] = ACTIONS(3699),
    [anon_sym_AT] = ACTIONS(2204),
    [anon_sym_PIPE] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_void] = ACTIONS(3699),
    [anon_sym_break] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [sym_super] = ACTIONS(3699),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_private] = ACTIONS(3699),
    [anon_sym_get] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_default] = ACTIONS(3699),
    [anon_sym_interface] = ACTIONS(3699),
    [anon_sym_enum] = ACTIONS(3699),
    [anon_sym_delete] = ACTIONS(3699),
    [anon_sym_continue] = ACTIONS(3699),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(3699),
    [anon_sym_this] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3699),
    [sym_true] = ACTIONS(3699),
    [anon_sym_throw] = ACTIONS(3699),
    [anon_sym_protected] = ACTIONS(3699),
    [anon_sym_abstract] = ACTIONS(3699),
    [anon_sym_DOT] = ACTIONS(4187),
    [anon_sym_set] = ACTIONS(3699),
    [anon_sym_type] = ACTIONS(3699),
    [anon_sym_import] = ACTIONS(3699),
    [anon_sym_namespace] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_await] = ACTIONS(3699),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [anon_sym_else] = ACTIONS(3699),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(2201),
    [sym_false] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_case] = ACTIONS(3699),
    [anon_sym_module] = ACTIONS(3699),
    [anon_sym_number] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_declare] = ACTIONS(3699),
    [anon_sym_typeof] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_is] = ACTIONS(10062),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [sym_null] = ACTIONS(3699),
    [anon_sym_any] = ACTIONS(3699),
    [anon_sym_boolean] = ACTIONS(3699),
    [anon_sym_async] = ACTIONS(3699),
    [anon_sym_public] = ACTIONS(3699),
    [anon_sym_AMP] = ACTIONS(2204),
    [anon_sym_var] = ACTIONS(3699),
    [anon_sym_while] = ACTIONS(3699),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_try] = ACTIONS(3699),
    [anon_sym_LT] = ACTIONS(7943),
    [sym_number] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3699),
    [sym_undefined] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_export] = ACTIONS(3699),
    [anon_sym_do] = ACTIONS(3699),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_with] = ACTIONS(3699),
  },
  [5093] = {
    [sym_index_type_query] = STATE(1066),
    [sym_lookup_type] = STATE(1066),
    [sym_flow_maybe_type] = STATE(1066),
    [sym_parenthesized_type] = STATE(1066),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_array_type] = STATE(1066),
    [sym_type_predicate] = STATE(1066),
    [sym_type_query] = STATE(1066),
    [sym_existential_type] = STATE(1066),
    [sym_this_type] = STATE(1066),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(1066),
    [sym__primary_type] = STATE(1066),
    [sym_generic_type] = STATE(1066),
    [sym_literal_type] = STATE(1066),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(1066),
    [sym_string] = STATE(418),
    [sym_tuple_type] = STATE(1066),
    [sym_identifier] = ACTIONS(10014),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [sym_true] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5094] = {
    [sym_union_type] = STATE(1091),
    [sym__type] = STATE(1091),
    [sym_constructor_type] = STATE(1091),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(5098),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1091),
    [sym_function_type] = STATE(1091),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(5099),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(10014),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(10020),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(10022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5095] = {
    [sym_type_parameters] = STATE(5125),
    [sym_formal_parameters] = STATE(5126),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(472),
  },
  [5096] = {
    [sym_union_type] = STATE(1110),
    [sym__type] = STATE(1110),
    [sym_constructor_type] = STATE(1110),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(5098),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(1110),
    [sym_function_type] = STATE(1110),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(5099),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(10014),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(10020),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(10022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5097] = {
    [sym_identifier] = ACTIONS(7946),
    [anon_sym_BQUOTE] = ACTIONS(7948),
    [anon_sym_debugger] = ACTIONS(7946),
    [anon_sym_symbol] = ACTIONS(7946),
    [anon_sym_AT] = ACTIONS(7948),
    [anon_sym_PIPE] = ACTIONS(10064),
    [anon_sym_DASH] = ACTIONS(7946),
    [anon_sym_void] = ACTIONS(7946),
    [anon_sym_break] = ACTIONS(7946),
    [anon_sym_const] = ACTIONS(7946),
    [sym_super] = ACTIONS(7946),
    [anon_sym_return] = ACTIONS(7946),
    [anon_sym_private] = ACTIONS(7946),
    [anon_sym_get] = ACTIONS(7946),
    [anon_sym_RBRACE] = ACTIONS(7948),
    [anon_sym_default] = ACTIONS(7946),
    [anon_sym_interface] = ACTIONS(7946),
    [anon_sym_enum] = ACTIONS(7946),
    [anon_sym_delete] = ACTIONS(7946),
    [anon_sym_continue] = ACTIONS(7946),
    [anon_sym_DASH_DASH] = ACTIONS(7948),
    [anon_sym_if] = ACTIONS(7946),
    [anon_sym_this] = ACTIONS(7946),
    [anon_sym_yield] = ACTIONS(7946),
    [sym_true] = ACTIONS(7946),
    [anon_sym_throw] = ACTIONS(7946),
    [anon_sym_protected] = ACTIONS(7946),
    [anon_sym_abstract] = ACTIONS(7946),
    [anon_sym_set] = ACTIONS(7946),
    [anon_sym_type] = ACTIONS(7946),
    [anon_sym_import] = ACTIONS(7946),
    [anon_sym_namespace] = ACTIONS(7946),
    [anon_sym_PLUS_PLUS] = ACTIONS(7948),
    [anon_sym_await] = ACTIONS(7946),
    [anon_sym_DQUOTE] = ACTIONS(7948),
    [anon_sym_else] = ACTIONS(7946),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_for] = ACTIONS(7946),
    [anon_sym_LBRACK] = ACTIONS(7948),
    [sym_false] = ACTIONS(7946),
    [anon_sym_SEMI] = ACTIONS(7948),
    [anon_sym_case] = ACTIONS(7946),
    [anon_sym_module] = ACTIONS(7946),
    [anon_sym_number] = ACTIONS(7946),
    [anon_sym_class] = ACTIONS(7946),
    [anon_sym_declare] = ACTIONS(7946),
    [anon_sym_typeof] = ACTIONS(7946),
    [anon_sym_LBRACE] = ACTIONS(7948),
    [anon_sym_switch] = ACTIONS(7946),
    [anon_sym_LPAREN] = ACTIONS(7948),
    [sym_null] = ACTIONS(7946),
    [anon_sym_any] = ACTIONS(7946),
    [anon_sym_boolean] = ACTIONS(7946),
    [anon_sym_async] = ACTIONS(7946),
    [anon_sym_public] = ACTIONS(7946),
    [anon_sym_AMP] = ACTIONS(10066),
    [anon_sym_var] = ACTIONS(7946),
    [anon_sym_while] = ACTIONS(7946),
    [anon_sym_SQUOTE] = ACTIONS(7948),
    [anon_sym_try] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(7948),
    [sym_number] = ACTIONS(7948),
    [anon_sym_SLASH] = ACTIONS(7946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7946),
    [anon_sym_function] = ACTIONS(7946),
    [sym_undefined] = ACTIONS(7946),
    [anon_sym_new] = ACTIONS(7946),
    [anon_sym_let] = ACTIONS(7946),
    [anon_sym_PLUS] = ACTIONS(7946),
    [anon_sym_export] = ACTIONS(7946),
    [anon_sym_do] = ACTIONS(7946),
    [anon_sym_TILDE] = ACTIONS(7948),
    [anon_sym_with] = ACTIONS(7946),
  },
  [5098] = {
    [sym_formal_parameters] = STATE(5129),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [5099] = {
    [anon_sym_EQ_GT] = ACTIONS(10068),
    [sym_comment] = ACTIONS(3),
  },
  [5100] = {
    [sym_type_alias_declaration] = STATE(4545),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4545),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4545),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4545),
    [sym_return_statement] = STATE(4545),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4545),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4545),
    [sym_switch_statement] = STATE(4545),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4545),
    [sym_throw_statement] = STATE(4545),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4545),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4545),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(4545),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4545),
    [sym_abstract_class] = STATE(4545),
    [sym_interface_declaration] = STATE(4545),
    [sym_statement_block] = STATE(4545),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4545),
    [sym_debugger_statement] = STATE(4545),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4545),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4545),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4545),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4545),
    [sym_empty_statement] = STATE(4545),
    [sym_import_alias] = STATE(4545),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4545),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4545),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4545),
    [sym_break_statement] = STATE(4545),
    [sym_labeled_statement] = STATE(4545),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4545),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [5101] = {
    [sym_type_alias_declaration] = STATE(4546),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4546),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4546),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4546),
    [sym_return_statement] = STATE(4546),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4546),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4546),
    [sym_switch_statement] = STATE(4546),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4546),
    [sym_throw_statement] = STATE(4546),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4546),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4546),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(4546),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4546),
    [sym_abstract_class] = STATE(4546),
    [sym_interface_declaration] = STATE(4546),
    [sym_statement_block] = STATE(4546),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4546),
    [sym_debugger_statement] = STATE(4546),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4546),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4546),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4546),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4546),
    [sym_empty_statement] = STATE(4546),
    [sym_import_alias] = STATE(4546),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4546),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4546),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4546),
    [sym_break_statement] = STATE(4546),
    [sym_labeled_statement] = STATE(4546),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4546),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [5102] = {
    [sym_type_alias_declaration] = STATE(4547),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4547),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4547),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4547),
    [sym_return_statement] = STATE(4547),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4547),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4547),
    [sym_switch_statement] = STATE(4547),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4547),
    [sym_throw_statement] = STATE(4547),
    [aux_sym_export_statement_repeat1] = STATE(3275),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4547),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4547),
    [sym_decorator] = STATE(3275),
    [sym_continue_statement] = STATE(4547),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4547),
    [sym_abstract_class] = STATE(4547),
    [sym_interface_declaration] = STATE(4547),
    [sym_statement_block] = STATE(4547),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4547),
    [sym_debugger_statement] = STATE(4547),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4547),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4547),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4547),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4547),
    [sym_empty_statement] = STATE(4547),
    [sym_import_alias] = STATE(4547),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4547),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4547),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4547),
    [sym_break_statement] = STATE(4547),
    [sym_labeled_statement] = STATE(4547),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4547),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(6853),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(6859),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(6861),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(6863),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(6865),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(6867),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(6869),
  },
  [5103] = {
    [sym_identifier] = ACTIONS(7192),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [anon_sym_debugger] = ACTIONS(7192),
    [anon_sym_symbol] = ACTIONS(7192),
    [anon_sym_AT] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(9952),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_void] = ACTIONS(7192),
    [anon_sym_break] = ACTIONS(7192),
    [anon_sym_const] = ACTIONS(7192),
    [sym_super] = ACTIONS(7192),
    [anon_sym_return] = ACTIONS(7192),
    [anon_sym_private] = ACTIONS(7192),
    [anon_sym_get] = ACTIONS(7192),
    [anon_sym_RBRACE] = ACTIONS(5893),
    [anon_sym_default] = ACTIONS(7192),
    [anon_sym_interface] = ACTIONS(7192),
    [anon_sym_enum] = ACTIONS(7192),
    [anon_sym_delete] = ACTIONS(7192),
    [anon_sym_continue] = ACTIONS(7192),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_if] = ACTIONS(7192),
    [anon_sym_this] = ACTIONS(7192),
    [anon_sym_yield] = ACTIONS(7192),
    [sym_true] = ACTIONS(7192),
    [anon_sym_throw] = ACTIONS(7192),
    [anon_sym_protected] = ACTIONS(7192),
    [anon_sym_abstract] = ACTIONS(7192),
    [anon_sym_set] = ACTIONS(7192),
    [anon_sym_type] = ACTIONS(7192),
    [anon_sym_import] = ACTIONS(7192),
    [anon_sym_namespace] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_await] = ACTIONS(7192),
    [anon_sym_DQUOTE] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(5893),
    [anon_sym_for] = ACTIONS(7192),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [sym_false] = ACTIONS(7192),
    [anon_sym_SEMI] = ACTIONS(5893),
    [anon_sym_case] = ACTIONS(7192),
    [anon_sym_module] = ACTIONS(7192),
    [anon_sym_number] = ACTIONS(7192),
    [anon_sym_class] = ACTIONS(7192),
    [anon_sym_declare] = ACTIONS(7192),
    [anon_sym_typeof] = ACTIONS(7192),
    [anon_sym_LBRACE] = ACTIONS(5893),
    [anon_sym_switch] = ACTIONS(7192),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [sym_null] = ACTIONS(7192),
    [anon_sym_any] = ACTIONS(7192),
    [anon_sym_boolean] = ACTIONS(7192),
    [anon_sym_async] = ACTIONS(7192),
    [anon_sym_public] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(9954),
    [anon_sym_var] = ACTIONS(7192),
    [anon_sym_while] = ACTIONS(7192),
    [anon_sym_SQUOTE] = ACTIONS(5893),
    [anon_sym_try] = ACTIONS(7192),
    [anon_sym_LT] = ACTIONS(5893),
    [sym_number] = ACTIONS(5893),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7192),
    [anon_sym_function] = ACTIONS(7192),
    [sym_undefined] = ACTIONS(7192),
    [anon_sym_new] = ACTIONS(7192),
    [anon_sym_let] = ACTIONS(7192),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_export] = ACTIONS(7192),
    [anon_sym_do] = ACTIONS(7192),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_with] = ACTIONS(7192),
  },
  [5104] = {
    [anon_sym_EQ_GT] = ACTIONS(10070),
    [sym_comment] = ACTIONS(3),
  },
  [5105] = {
    [sym_union_type] = STATE(5132),
    [sym__type] = STATE(5132),
    [sym_constructor_type] = STATE(5132),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4981),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5132),
    [sym_function_type] = STATE(5132),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4982),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9840),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9842),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9844),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9846),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5106] = {
    [sym_union_type] = STATE(5133),
    [sym__type] = STATE(5133),
    [sym_constructor_type] = STATE(5133),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4981),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5133),
    [sym_function_type] = STATE(5133),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4982),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9840),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9842),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9844),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9846),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5107] = {
    [sym_identifier] = ACTIONS(7208),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [anon_sym_debugger] = ACTIONS(7208),
    [anon_sym_symbol] = ACTIONS(7208),
    [anon_sym_AT] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(9952),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_void] = ACTIONS(7208),
    [anon_sym_break] = ACTIONS(7208),
    [anon_sym_const] = ACTIONS(7208),
    [sym_super] = ACTIONS(7208),
    [anon_sym_return] = ACTIONS(7208),
    [anon_sym_private] = ACTIONS(7208),
    [anon_sym_get] = ACTIONS(7208),
    [anon_sym_RBRACE] = ACTIONS(6040),
    [anon_sym_default] = ACTIONS(7208),
    [anon_sym_interface] = ACTIONS(7208),
    [anon_sym_enum] = ACTIONS(7208),
    [anon_sym_delete] = ACTIONS(7208),
    [anon_sym_continue] = ACTIONS(7208),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_if] = ACTIONS(7208),
    [anon_sym_this] = ACTIONS(7208),
    [anon_sym_yield] = ACTIONS(7208),
    [sym_true] = ACTIONS(7208),
    [anon_sym_throw] = ACTIONS(7208),
    [anon_sym_protected] = ACTIONS(7208),
    [anon_sym_abstract] = ACTIONS(7208),
    [anon_sym_set] = ACTIONS(7208),
    [anon_sym_type] = ACTIONS(7208),
    [anon_sym_import] = ACTIONS(7208),
    [anon_sym_namespace] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_await] = ACTIONS(7208),
    [anon_sym_DQUOTE] = ACTIONS(6040),
    [anon_sym_BANG] = ACTIONS(6040),
    [anon_sym_for] = ACTIONS(7208),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [sym_false] = ACTIONS(7208),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_case] = ACTIONS(7208),
    [anon_sym_module] = ACTIONS(7208),
    [anon_sym_number] = ACTIONS(7208),
    [anon_sym_class] = ACTIONS(7208),
    [anon_sym_declare] = ACTIONS(7208),
    [anon_sym_typeof] = ACTIONS(7208),
    [anon_sym_LBRACE] = ACTIONS(6040),
    [anon_sym_switch] = ACTIONS(7208),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [sym_null] = ACTIONS(7208),
    [anon_sym_any] = ACTIONS(7208),
    [anon_sym_boolean] = ACTIONS(7208),
    [anon_sym_async] = ACTIONS(7208),
    [anon_sym_public] = ACTIONS(7208),
    [anon_sym_AMP] = ACTIONS(9954),
    [anon_sym_var] = ACTIONS(7208),
    [anon_sym_while] = ACTIONS(7208),
    [anon_sym_SQUOTE] = ACTIONS(6040),
    [anon_sym_try] = ACTIONS(7208),
    [anon_sym_LT] = ACTIONS(6040),
    [sym_number] = ACTIONS(6040),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7208),
    [anon_sym_function] = ACTIONS(7208),
    [sym_undefined] = ACTIONS(7208),
    [anon_sym_new] = ACTIONS(7208),
    [anon_sym_let] = ACTIONS(7208),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_export] = ACTIONS(7208),
    [anon_sym_do] = ACTIONS(7208),
    [anon_sym_TILDE] = ACTIONS(6040),
    [anon_sym_with] = ACTIONS(7208),
  },
  [5108] = {
    [anon_sym_EQ_GT] = ACTIONS(10072),
    [sym_comment] = ACTIONS(3),
  },
  [5109] = {
    [sym_union_type] = STATE(5135),
    [sym__type] = STATE(5135),
    [sym_constructor_type] = STATE(5135),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(4717),
    [sym_type_parameters] = STATE(4992),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5135),
    [sym_function_type] = STATE(5135),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4993),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9465),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9856),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9858),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5110] = {
    [sym_union_type] = STATE(5136),
    [sym__type] = STATE(5136),
    [sym_constructor_type] = STATE(5136),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(4717),
    [sym_type_parameters] = STATE(4992),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5136),
    [sym_function_type] = STATE(5136),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4993),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9465),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9856),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9858),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5111] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [anon_sym_AMP] = ACTIONS(9958),
    [anon_sym_PIPE] = ACTIONS(9960),
    [anon_sym_else] = ACTIONS(6040),
    [anon_sym_while] = ACTIONS(6040),
  },
  [5112] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(9720),
    [anon_sym_PIPE] = ACTIONS(9722),
    [anon_sym_else] = ACTIONS(8547),
    [anon_sym_while] = ACTIONS(8547),
  },
  [5113] = {
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(9726),
    [anon_sym_PIPE] = ACTIONS(9728),
    [anon_sym_while] = ACTIONS(8547),
    [sym_comment] = ACTIONS(3),
  },
  [5114] = {
    [sym__automatic_semicolon] = ACTIONS(8547),
    [anon_sym_RBRACE] = ACTIONS(8547),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(9734),
    [anon_sym_PIPE_RBRACE] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(8547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(8547),
  },
  [5115] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(10074),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [5116] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(10076),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [5117] = {
    [sym_type_arguments] = STATE(541),
    [sym_template_string] = STATE(542),
    [sym_arguments] = STATE(542),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(6321),
    [anon_sym_BQUOTE] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(6363),
    [anon_sym_LT_LT] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_STAR] = ACTIONS(6369),
    [anon_sym_GT_GT_GT] = ACTIONS(6365),
    [anon_sym_AMP_AMP] = ACTIONS(6371),
    [anon_sym_BANG_EQ] = ACTIONS(6321),
    [anon_sym_LT_EQ] = ACTIONS(6361),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_GT_EQ] = ACTIONS(6361),
    [anon_sym_GT] = ACTIONS(6321),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_PERCENT] = ACTIONS(6365),
    [anon_sym_QMARK] = ACTIONS(6375),
    [anon_sym_PIPE_PIPE] = ACTIONS(6377),
    [anon_sym_as] = ACTIONS(6379),
    [anon_sym_DASH_DASH] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(6321),
    [anon_sym_instanceof] = ACTIONS(6361),
    [anon_sym_LT] = ACTIONS(6381),
    [anon_sym_RPAREN] = ACTIONS(10078),
    [anon_sym_SLASH] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(6377),
    [anon_sym_STAR_STAR] = ACTIONS(6385),
    [anon_sym_PLUS] = ACTIONS(6367),
    [anon_sym_GT_GT] = ACTIONS(6369),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6361),
    [anon_sym_BANG] = ACTIONS(1071),
  },
  [5118] = {
    [sym_type_alias_declaration] = STATE(4210),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4210),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4210),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4210),
    [sym_return_statement] = STATE(4210),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4210),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4210),
    [sym_switch_statement] = STATE(4210),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4210),
    [sym_throw_statement] = STATE(4210),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4210),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4210),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(4210),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4210),
    [sym_abstract_class] = STATE(4210),
    [sym_interface_declaration] = STATE(4210),
    [sym_statement_block] = STATE(4210),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4210),
    [sym_debugger_statement] = STATE(4210),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4210),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4210),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4210),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4210),
    [sym_empty_statement] = STATE(4210),
    [sym_import_alias] = STATE(4210),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4210),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4210),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4210),
    [sym_break_statement] = STATE(4210),
    [sym_labeled_statement] = STATE(4210),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4210),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [5119] = {
    [sym_type_alias_declaration] = STATE(4211),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4211),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4211),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4211),
    [sym_return_statement] = STATE(4211),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4211),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4211),
    [sym_switch_statement] = STATE(4211),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4211),
    [sym_throw_statement] = STATE(4211),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4211),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4211),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(4211),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4211),
    [sym_abstract_class] = STATE(4211),
    [sym_interface_declaration] = STATE(4211),
    [sym_statement_block] = STATE(4211),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4211),
    [sym_debugger_statement] = STATE(4211),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4211),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4211),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4211),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4211),
    [sym_empty_statement] = STATE(4211),
    [sym_import_alias] = STATE(4211),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4211),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4211),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4211),
    [sym_break_statement] = STATE(4211),
    [sym_labeled_statement] = STATE(4211),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4211),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [5120] = {
    [sym_type_alias_declaration] = STATE(4212),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4212),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4212),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4212),
    [sym_return_statement] = STATE(4212),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4212),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4212),
    [sym_switch_statement] = STATE(4212),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4212),
    [sym_throw_statement] = STATE(4212),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4212),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4212),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(4212),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4212),
    [sym_abstract_class] = STATE(4212),
    [sym_interface_declaration] = STATE(4212),
    [sym_statement_block] = STATE(4212),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4212),
    [sym_debugger_statement] = STATE(4212),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4212),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4212),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4212),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4212),
    [sym_empty_statement] = STATE(4212),
    [sym_import_alias] = STATE(4212),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4212),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4212),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4212),
    [sym_break_statement] = STATE(4212),
    [sym_labeled_statement] = STATE(4212),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4212),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [5121] = {
    [sym_type_alias_declaration] = STATE(4235),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4235),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4235),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4235),
    [sym_return_statement] = STATE(4235),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4235),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4235),
    [sym_switch_statement] = STATE(4235),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4235),
    [sym_throw_statement] = STATE(4235),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4235),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4235),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(4235),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4235),
    [sym_abstract_class] = STATE(4235),
    [sym_interface_declaration] = STATE(4235),
    [sym_statement_block] = STATE(4235),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4235),
    [sym_debugger_statement] = STATE(4235),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4235),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4235),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4235),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4235),
    [sym_empty_statement] = STATE(4235),
    [sym_import_alias] = STATE(4235),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4235),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4235),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4235),
    [sym_break_statement] = STATE(4235),
    [sym_labeled_statement] = STATE(4235),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4235),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [5122] = {
    [sym_type_alias_declaration] = STATE(4236),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4236),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4236),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4236),
    [sym_return_statement] = STATE(4236),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4236),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4236),
    [sym_switch_statement] = STATE(4236),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4236),
    [sym_throw_statement] = STATE(4236),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4236),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4236),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(4236),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4236),
    [sym_abstract_class] = STATE(4236),
    [sym_interface_declaration] = STATE(4236),
    [sym_statement_block] = STATE(4236),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4236),
    [sym_debugger_statement] = STATE(4236),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4236),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4236),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4236),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4236),
    [sym_empty_statement] = STATE(4236),
    [sym_import_alias] = STATE(4236),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4236),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4236),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4236),
    [sym_break_statement] = STATE(4236),
    [sym_labeled_statement] = STATE(4236),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4236),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [5123] = {
    [sym_type_alias_declaration] = STATE(4237),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4237),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4237),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4237),
    [sym_return_statement] = STATE(4237),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4237),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4237),
    [sym_switch_statement] = STATE(4237),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4237),
    [sym_throw_statement] = STATE(4237),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4237),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4237),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(4237),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4237),
    [sym_abstract_class] = STATE(4237),
    [sym_interface_declaration] = STATE(4237),
    [sym_statement_block] = STATE(4237),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4237),
    [sym_debugger_statement] = STATE(4237),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4237),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4237),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4237),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4237),
    [sym_empty_statement] = STATE(4237),
    [sym_import_alias] = STATE(4237),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4237),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4237),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4237),
    [sym_break_statement] = STATE(4237),
    [sym_labeled_statement] = STATE(4237),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4237),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [5124] = {
    [sym_union_type] = STATE(5140),
    [sym__type] = STATE(5140),
    [sym_constructor_type] = STATE(5140),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(5098),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5140),
    [sym_function_type] = STATE(5140),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(5099),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(10014),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(10020),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(10022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5125] = {
    [sym_formal_parameters] = STATE(5141),
    [anon_sym_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [5126] = {
    [anon_sym_EQ_GT] = ACTIONS(10080),
    [sym_comment] = ACTIONS(3),
  },
  [5127] = {
    [sym_union_type] = STATE(2011),
    [sym__type] = STATE(2011),
    [sym_constructor_type] = STATE(2011),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(5098),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2011),
    [sym_function_type] = STATE(2011),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(5099),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(10014),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(10020),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(10022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5128] = {
    [sym_union_type] = STATE(2012),
    [sym__type] = STATE(2012),
    [sym_constructor_type] = STATE(2012),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(5098),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(2012),
    [sym_function_type] = STATE(2012),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(5099),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(10014),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(10020),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(10022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5129] = {
    [anon_sym_EQ_GT] = ACTIONS(10082),
    [sym_comment] = ACTIONS(3),
  },
  [5130] = {
    [sym_union_type] = STATE(5144),
    [sym__type] = STATE(5144),
    [sym_constructor_type] = STATE(5144),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(5098),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5144),
    [sym_function_type] = STATE(5144),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(5099),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(10014),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(10020),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(10022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5131] = {
    [sym_union_type] = STATE(5145),
    [sym__type] = STATE(5145),
    [sym_constructor_type] = STATE(5145),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(4981),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5145),
    [sym_function_type] = STATE(5145),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4982),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9840),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9842),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9844),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9846),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5132] = {
    [sym_identifier] = ACTIONS(8379),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [anon_sym_debugger] = ACTIONS(8379),
    [anon_sym_symbol] = ACTIONS(8379),
    [anon_sym_AT] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(9952),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_void] = ACTIONS(8379),
    [anon_sym_break] = ACTIONS(8379),
    [anon_sym_const] = ACTIONS(8379),
    [sym_super] = ACTIONS(8379),
    [anon_sym_return] = ACTIONS(8379),
    [anon_sym_private] = ACTIONS(8379),
    [anon_sym_get] = ACTIONS(8379),
    [anon_sym_RBRACE] = ACTIONS(7511),
    [anon_sym_default] = ACTIONS(8379),
    [anon_sym_interface] = ACTIONS(8379),
    [anon_sym_enum] = ACTIONS(8379),
    [anon_sym_delete] = ACTIONS(8379),
    [anon_sym_continue] = ACTIONS(8379),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_if] = ACTIONS(8379),
    [anon_sym_this] = ACTIONS(8379),
    [anon_sym_yield] = ACTIONS(8379),
    [sym_true] = ACTIONS(8379),
    [anon_sym_throw] = ACTIONS(8379),
    [anon_sym_protected] = ACTIONS(8379),
    [anon_sym_abstract] = ACTIONS(8379),
    [anon_sym_set] = ACTIONS(8379),
    [anon_sym_type] = ACTIONS(8379),
    [anon_sym_import] = ACTIONS(8379),
    [anon_sym_namespace] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_await] = ACTIONS(8379),
    [anon_sym_DQUOTE] = ACTIONS(7511),
    [anon_sym_BANG] = ACTIONS(7511),
    [anon_sym_for] = ACTIONS(8379),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [sym_false] = ACTIONS(8379),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_case] = ACTIONS(8379),
    [anon_sym_module] = ACTIONS(8379),
    [anon_sym_number] = ACTIONS(8379),
    [anon_sym_class] = ACTIONS(8379),
    [anon_sym_declare] = ACTIONS(8379),
    [anon_sym_typeof] = ACTIONS(8379),
    [anon_sym_LBRACE] = ACTIONS(7511),
    [anon_sym_switch] = ACTIONS(8379),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [sym_null] = ACTIONS(8379),
    [anon_sym_any] = ACTIONS(8379),
    [anon_sym_boolean] = ACTIONS(8379),
    [anon_sym_async] = ACTIONS(8379),
    [anon_sym_public] = ACTIONS(8379),
    [anon_sym_AMP] = ACTIONS(9954),
    [anon_sym_var] = ACTIONS(8379),
    [anon_sym_while] = ACTIONS(8379),
    [anon_sym_SQUOTE] = ACTIONS(7511),
    [anon_sym_try] = ACTIONS(8379),
    [anon_sym_LT] = ACTIONS(7511),
    [sym_number] = ACTIONS(7511),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8379),
    [anon_sym_function] = ACTIONS(8379),
    [sym_undefined] = ACTIONS(8379),
    [anon_sym_new] = ACTIONS(8379),
    [anon_sym_let] = ACTIONS(8379),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_export] = ACTIONS(8379),
    [anon_sym_do] = ACTIONS(8379),
    [anon_sym_TILDE] = ACTIONS(7511),
    [anon_sym_with] = ACTIONS(8379),
  },
  [5133] = {
    [sym_identifier] = ACTIONS(8381),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [anon_sym_debugger] = ACTIONS(8381),
    [anon_sym_symbol] = ACTIONS(8381),
    [anon_sym_AT] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(9952),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_void] = ACTIONS(8381),
    [anon_sym_break] = ACTIONS(8381),
    [anon_sym_const] = ACTIONS(8381),
    [sym_super] = ACTIONS(8381),
    [anon_sym_return] = ACTIONS(8381),
    [anon_sym_private] = ACTIONS(8381),
    [anon_sym_get] = ACTIONS(8381),
    [anon_sym_RBRACE] = ACTIONS(7529),
    [anon_sym_default] = ACTIONS(8381),
    [anon_sym_interface] = ACTIONS(8381),
    [anon_sym_enum] = ACTIONS(8381),
    [anon_sym_delete] = ACTIONS(8381),
    [anon_sym_continue] = ACTIONS(8381),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_if] = ACTIONS(8381),
    [anon_sym_this] = ACTIONS(8381),
    [anon_sym_yield] = ACTIONS(8381),
    [sym_true] = ACTIONS(8381),
    [anon_sym_throw] = ACTIONS(8381),
    [anon_sym_protected] = ACTIONS(8381),
    [anon_sym_abstract] = ACTIONS(8381),
    [anon_sym_set] = ACTIONS(8381),
    [anon_sym_type] = ACTIONS(8381),
    [anon_sym_import] = ACTIONS(8381),
    [anon_sym_namespace] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_await] = ACTIONS(8381),
    [anon_sym_DQUOTE] = ACTIONS(7529),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_for] = ACTIONS(8381),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [sym_false] = ACTIONS(8381),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_case] = ACTIONS(8381),
    [anon_sym_module] = ACTIONS(8381),
    [anon_sym_number] = ACTIONS(8381),
    [anon_sym_class] = ACTIONS(8381),
    [anon_sym_declare] = ACTIONS(8381),
    [anon_sym_typeof] = ACTIONS(8381),
    [anon_sym_LBRACE] = ACTIONS(7529),
    [anon_sym_switch] = ACTIONS(8381),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [sym_null] = ACTIONS(8381),
    [anon_sym_any] = ACTIONS(8381),
    [anon_sym_boolean] = ACTIONS(8381),
    [anon_sym_async] = ACTIONS(8381),
    [anon_sym_public] = ACTIONS(8381),
    [anon_sym_AMP] = ACTIONS(9954),
    [anon_sym_var] = ACTIONS(8381),
    [anon_sym_while] = ACTIONS(8381),
    [anon_sym_SQUOTE] = ACTIONS(7529),
    [anon_sym_try] = ACTIONS(8381),
    [anon_sym_LT] = ACTIONS(7529),
    [sym_number] = ACTIONS(7529),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8381),
    [anon_sym_function] = ACTIONS(8381),
    [sym_undefined] = ACTIONS(8381),
    [anon_sym_new] = ACTIONS(8381),
    [anon_sym_let] = ACTIONS(8381),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_export] = ACTIONS(8381),
    [anon_sym_do] = ACTIONS(8381),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_with] = ACTIONS(8381),
  },
  [5134] = {
    [sym_union_type] = STATE(5146),
    [sym__type] = STATE(5146),
    [sym_constructor_type] = STATE(5146),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(4717),
    [sym_type_parameters] = STATE(4992),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5146),
    [sym_function_type] = STATE(5146),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(4993),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(9465),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(9467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(9856),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(9858),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(9860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5135] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [anon_sym_AMP] = ACTIONS(9958),
    [anon_sym_PIPE] = ACTIONS(9960),
    [anon_sym_else] = ACTIONS(7511),
    [anon_sym_while] = ACTIONS(7511),
  },
  [5136] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [anon_sym_AMP] = ACTIONS(9958),
    [anon_sym_PIPE] = ACTIONS(9960),
    [anon_sym_else] = ACTIONS(7529),
    [anon_sym_while] = ACTIONS(7529),
  },
  [5137] = {
    [sym_type_alias_declaration] = STATE(4545),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4545),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4545),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4545),
    [sym_return_statement] = STATE(4545),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4545),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4545),
    [sym_switch_statement] = STATE(4545),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4545),
    [sym_throw_statement] = STATE(4545),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4545),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4545),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(4545),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4545),
    [sym_abstract_class] = STATE(4545),
    [sym_interface_declaration] = STATE(4545),
    [sym_statement_block] = STATE(4545),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4545),
    [sym_debugger_statement] = STATE(4545),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4545),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4545),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4545),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4545),
    [sym_empty_statement] = STATE(4545),
    [sym_import_alias] = STATE(4545),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4545),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4545),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4545),
    [sym_break_statement] = STATE(4545),
    [sym_labeled_statement] = STATE(4545),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4545),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [5138] = {
    [sym_type_alias_declaration] = STATE(4546),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4546),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4546),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4546),
    [sym_return_statement] = STATE(4546),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4546),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4546),
    [sym_switch_statement] = STATE(4546),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4546),
    [sym_throw_statement] = STATE(4546),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4546),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4546),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(4546),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4546),
    [sym_abstract_class] = STATE(4546),
    [sym_interface_declaration] = STATE(4546),
    [sym_statement_block] = STATE(4546),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4546),
    [sym_debugger_statement] = STATE(4546),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4546),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4546),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4546),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4546),
    [sym_empty_statement] = STATE(4546),
    [sym_import_alias] = STATE(4546),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4546),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4546),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4546),
    [sym_break_statement] = STATE(4546),
    [sym_labeled_statement] = STATE(4546),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4546),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [5139] = {
    [sym_type_alias_declaration] = STATE(4547),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(4547),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(4547),
    [sym_regex] = STATE(59),
    [sym_type_parameters] = STATE(51),
    [sym_do_statement] = STATE(4547),
    [sym_return_statement] = STATE(4547),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_jsx_fragment] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(4547),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(4547),
    [sym_switch_statement] = STATE(4547),
    [sym_string] = STATE(59),
    [sym_try_statement] = STATE(4547),
    [sym_throw_statement] = STATE(4547),
    [aux_sym_export_statement_repeat1] = STATE(4352),
    [sym_object] = STATE(56),
    [sym_ambient_declaration] = STATE(4547),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(4547),
    [sym_decorator] = STATE(4352),
    [sym_continue_statement] = STATE(4547),
    [sym_formal_parameters] = STATE(57),
    [sym_function_signature] = STATE(4547),
    [sym_abstract_class] = STATE(4547),
    [sym_interface_declaration] = STATE(4547),
    [sym_statement_block] = STATE(4547),
    [sym_update_expression] = STATE(59),
    [sym_call_signature] = STATE(58),
    [sym_meta_property] = STATE(59),
    [sym_while_statement] = STATE(4547),
    [sym_debugger_statement] = STATE(4547),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_jsx_element] = STATE(59),
    [sym_enum_declaration] = STATE(4547),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(4547),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(4547),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(4547),
    [sym_empty_statement] = STATE(4547),
    [sym_import_alias] = STATE(4547),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(4547),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(4547),
    [sym_binary_expression] = STATE(59),
    [sym_for_in_statement] = STATE(4547),
    [sym_break_statement] = STATE(4547),
    [sym_labeled_statement] = STATE(4547),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(63),
    [sym_jsx_opening_element] = STATE(64),
    [sym_module] = STATE(4547),
    [sym_jsx_self_closing_element] = STATE(59),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(8872),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(8874),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(8876),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(8878),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(8882),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(8884),
  },
  [5140] = {
    [sym_identifier] = ACTIONS(7192),
    [anon_sym_BQUOTE] = ACTIONS(5893),
    [anon_sym_debugger] = ACTIONS(7192),
    [anon_sym_symbol] = ACTIONS(7192),
    [anon_sym_AT] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(10064),
    [anon_sym_DASH] = ACTIONS(7192),
    [anon_sym_void] = ACTIONS(7192),
    [anon_sym_break] = ACTIONS(7192),
    [anon_sym_const] = ACTIONS(7192),
    [sym_super] = ACTIONS(7192),
    [anon_sym_return] = ACTIONS(7192),
    [anon_sym_private] = ACTIONS(7192),
    [anon_sym_get] = ACTIONS(7192),
    [anon_sym_RBRACE] = ACTIONS(5893),
    [anon_sym_default] = ACTIONS(7192),
    [anon_sym_interface] = ACTIONS(7192),
    [anon_sym_enum] = ACTIONS(7192),
    [anon_sym_delete] = ACTIONS(7192),
    [anon_sym_continue] = ACTIONS(7192),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_if] = ACTIONS(7192),
    [anon_sym_this] = ACTIONS(7192),
    [anon_sym_yield] = ACTIONS(7192),
    [sym_true] = ACTIONS(7192),
    [anon_sym_throw] = ACTIONS(7192),
    [anon_sym_protected] = ACTIONS(7192),
    [anon_sym_abstract] = ACTIONS(7192),
    [anon_sym_set] = ACTIONS(7192),
    [anon_sym_type] = ACTIONS(7192),
    [anon_sym_import] = ACTIONS(7192),
    [anon_sym_namespace] = ACTIONS(7192),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_await] = ACTIONS(7192),
    [anon_sym_DQUOTE] = ACTIONS(5893),
    [anon_sym_else] = ACTIONS(7192),
    [anon_sym_BANG] = ACTIONS(5893),
    [anon_sym_for] = ACTIONS(7192),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [sym_false] = ACTIONS(7192),
    [anon_sym_SEMI] = ACTIONS(5893),
    [anon_sym_case] = ACTIONS(7192),
    [anon_sym_module] = ACTIONS(7192),
    [anon_sym_number] = ACTIONS(7192),
    [anon_sym_class] = ACTIONS(7192),
    [anon_sym_declare] = ACTIONS(7192),
    [anon_sym_typeof] = ACTIONS(7192),
    [anon_sym_LBRACE] = ACTIONS(5893),
    [anon_sym_switch] = ACTIONS(7192),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [sym_null] = ACTIONS(7192),
    [anon_sym_any] = ACTIONS(7192),
    [anon_sym_boolean] = ACTIONS(7192),
    [anon_sym_async] = ACTIONS(7192),
    [anon_sym_public] = ACTIONS(7192),
    [anon_sym_AMP] = ACTIONS(10066),
    [anon_sym_var] = ACTIONS(7192),
    [anon_sym_while] = ACTIONS(7192),
    [anon_sym_SQUOTE] = ACTIONS(5893),
    [anon_sym_try] = ACTIONS(7192),
    [anon_sym_LT] = ACTIONS(5893),
    [sym_number] = ACTIONS(5893),
    [anon_sym_SLASH] = ACTIONS(7192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7192),
    [anon_sym_function] = ACTIONS(7192),
    [sym_undefined] = ACTIONS(7192),
    [anon_sym_new] = ACTIONS(7192),
    [anon_sym_let] = ACTIONS(7192),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_export] = ACTIONS(7192),
    [anon_sym_do] = ACTIONS(7192),
    [anon_sym_TILDE] = ACTIONS(5893),
    [anon_sym_with] = ACTIONS(7192),
  },
  [5141] = {
    [anon_sym_EQ_GT] = ACTIONS(10084),
    [sym_comment] = ACTIONS(3),
  },
  [5142] = {
    [sym_union_type] = STATE(5148),
    [sym__type] = STATE(5148),
    [sym_constructor_type] = STATE(5148),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(5098),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5148),
    [sym_function_type] = STATE(5148),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(5099),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(10014),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(10020),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(10022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5143] = {
    [sym_union_type] = STATE(5149),
    [sym__type] = STATE(5149),
    [sym_constructor_type] = STATE(5149),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(5098),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5149),
    [sym_function_type] = STATE(5149),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(5099),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(10014),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(10020),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(10022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5144] = {
    [sym_identifier] = ACTIONS(7208),
    [anon_sym_BQUOTE] = ACTIONS(6040),
    [anon_sym_debugger] = ACTIONS(7208),
    [anon_sym_symbol] = ACTIONS(7208),
    [anon_sym_AT] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(10064),
    [anon_sym_DASH] = ACTIONS(7208),
    [anon_sym_void] = ACTIONS(7208),
    [anon_sym_break] = ACTIONS(7208),
    [anon_sym_const] = ACTIONS(7208),
    [sym_super] = ACTIONS(7208),
    [anon_sym_return] = ACTIONS(7208),
    [anon_sym_private] = ACTIONS(7208),
    [anon_sym_get] = ACTIONS(7208),
    [anon_sym_RBRACE] = ACTIONS(6040),
    [anon_sym_default] = ACTIONS(7208),
    [anon_sym_interface] = ACTIONS(7208),
    [anon_sym_enum] = ACTIONS(7208),
    [anon_sym_delete] = ACTIONS(7208),
    [anon_sym_continue] = ACTIONS(7208),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_if] = ACTIONS(7208),
    [anon_sym_this] = ACTIONS(7208),
    [anon_sym_yield] = ACTIONS(7208),
    [sym_true] = ACTIONS(7208),
    [anon_sym_throw] = ACTIONS(7208),
    [anon_sym_protected] = ACTIONS(7208),
    [anon_sym_abstract] = ACTIONS(7208),
    [anon_sym_set] = ACTIONS(7208),
    [anon_sym_type] = ACTIONS(7208),
    [anon_sym_import] = ACTIONS(7208),
    [anon_sym_namespace] = ACTIONS(7208),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_await] = ACTIONS(7208),
    [anon_sym_DQUOTE] = ACTIONS(6040),
    [anon_sym_else] = ACTIONS(7208),
    [anon_sym_BANG] = ACTIONS(6040),
    [anon_sym_for] = ACTIONS(7208),
    [anon_sym_LBRACK] = ACTIONS(6040),
    [sym_false] = ACTIONS(7208),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_case] = ACTIONS(7208),
    [anon_sym_module] = ACTIONS(7208),
    [anon_sym_number] = ACTIONS(7208),
    [anon_sym_class] = ACTIONS(7208),
    [anon_sym_declare] = ACTIONS(7208),
    [anon_sym_typeof] = ACTIONS(7208),
    [anon_sym_LBRACE] = ACTIONS(6040),
    [anon_sym_switch] = ACTIONS(7208),
    [anon_sym_LPAREN] = ACTIONS(6040),
    [sym_null] = ACTIONS(7208),
    [anon_sym_any] = ACTIONS(7208),
    [anon_sym_boolean] = ACTIONS(7208),
    [anon_sym_async] = ACTIONS(7208),
    [anon_sym_public] = ACTIONS(7208),
    [anon_sym_AMP] = ACTIONS(10066),
    [anon_sym_var] = ACTIONS(7208),
    [anon_sym_while] = ACTIONS(7208),
    [anon_sym_SQUOTE] = ACTIONS(6040),
    [anon_sym_try] = ACTIONS(7208),
    [anon_sym_LT] = ACTIONS(6040),
    [sym_number] = ACTIONS(6040),
    [anon_sym_SLASH] = ACTIONS(7208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(7208),
    [anon_sym_function] = ACTIONS(7208),
    [sym_undefined] = ACTIONS(7208),
    [anon_sym_new] = ACTIONS(7208),
    [anon_sym_let] = ACTIONS(7208),
    [anon_sym_PLUS] = ACTIONS(7208),
    [anon_sym_export] = ACTIONS(7208),
    [anon_sym_do] = ACTIONS(7208),
    [anon_sym_TILDE] = ACTIONS(6040),
    [anon_sym_with] = ACTIONS(7208),
  },
  [5145] = {
    [sym_identifier] = ACTIONS(9071),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [anon_sym_debugger] = ACTIONS(9071),
    [anon_sym_symbol] = ACTIONS(9071),
    [anon_sym_AT] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(9952),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_void] = ACTIONS(9071),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_const] = ACTIONS(9071),
    [sym_super] = ACTIONS(9071),
    [anon_sym_return] = ACTIONS(9071),
    [anon_sym_private] = ACTIONS(9071),
    [anon_sym_get] = ACTIONS(9071),
    [anon_sym_RBRACE] = ACTIONS(8547),
    [anon_sym_default] = ACTIONS(9071),
    [anon_sym_interface] = ACTIONS(9071),
    [anon_sym_enum] = ACTIONS(9071),
    [anon_sym_delete] = ACTIONS(9071),
    [anon_sym_continue] = ACTIONS(9071),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_if] = ACTIONS(9071),
    [anon_sym_this] = ACTIONS(9071),
    [anon_sym_yield] = ACTIONS(9071),
    [sym_true] = ACTIONS(9071),
    [anon_sym_throw] = ACTIONS(9071),
    [anon_sym_protected] = ACTIONS(9071),
    [anon_sym_abstract] = ACTIONS(9071),
    [anon_sym_set] = ACTIONS(9071),
    [anon_sym_type] = ACTIONS(9071),
    [anon_sym_import] = ACTIONS(9071),
    [anon_sym_namespace] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_await] = ACTIONS(9071),
    [anon_sym_DQUOTE] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8547),
    [anon_sym_for] = ACTIONS(9071),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [sym_false] = ACTIONS(9071),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_case] = ACTIONS(9071),
    [anon_sym_module] = ACTIONS(9071),
    [anon_sym_number] = ACTIONS(9071),
    [anon_sym_class] = ACTIONS(9071),
    [anon_sym_declare] = ACTIONS(9071),
    [anon_sym_typeof] = ACTIONS(9071),
    [anon_sym_LBRACE] = ACTIONS(8547),
    [anon_sym_switch] = ACTIONS(9071),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [sym_null] = ACTIONS(9071),
    [anon_sym_any] = ACTIONS(9071),
    [anon_sym_boolean] = ACTIONS(9071),
    [anon_sym_async] = ACTIONS(9071),
    [anon_sym_public] = ACTIONS(9071),
    [anon_sym_AMP] = ACTIONS(9954),
    [anon_sym_var] = ACTIONS(9071),
    [anon_sym_while] = ACTIONS(9071),
    [anon_sym_SQUOTE] = ACTIONS(8547),
    [anon_sym_try] = ACTIONS(9071),
    [anon_sym_LT] = ACTIONS(8547),
    [sym_number] = ACTIONS(8547),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9071),
    [anon_sym_function] = ACTIONS(9071),
    [sym_undefined] = ACTIONS(9071),
    [anon_sym_new] = ACTIONS(9071),
    [anon_sym_let] = ACTIONS(9071),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_export] = ACTIONS(9071),
    [anon_sym_do] = ACTIONS(9071),
    [anon_sym_TILDE] = ACTIONS(8547),
    [anon_sym_with] = ACTIONS(9071),
  },
  [5146] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [anon_sym_AMP] = ACTIONS(9958),
    [anon_sym_PIPE] = ACTIONS(9960),
    [anon_sym_else] = ACTIONS(8547),
    [anon_sym_while] = ACTIONS(8547),
  },
  [5147] = {
    [sym_union_type] = STATE(5150),
    [sym__type] = STATE(5150),
    [sym_constructor_type] = STATE(5150),
    [sym_index_type_query] = STATE(436),
    [sym_lookup_type] = STATE(436),
    [sym_flow_maybe_type] = STATE(436),
    [sym_parenthesized_type] = STATE(436),
    [sym_nested_type_identifier] = STATE(3166),
    [sym_type_parameters] = STATE(5098),
    [sym_array_type] = STATE(436),
    [sym_type_predicate] = STATE(436),
    [sym_type_query] = STATE(436),
    [sym_existential_type] = STATE(436),
    [sym_this_type] = STATE(436),
    [sym_nested_identifier] = STATE(435),
    [sym_object_type] = STATE(436),
    [sym_intersection_type] = STATE(5150),
    [sym_function_type] = STATE(5150),
    [sym__primary_type] = STATE(436),
    [sym_generic_type] = STATE(436),
    [sym_literal_type] = STATE(436),
    [sym__number] = STATE(418),
    [sym_predefined_type] = STATE(436),
    [sym_string] = STATE(418),
    [sym_formal_parameters] = STATE(5099),
    [sym_tuple_type] = STATE(436),
    [sym_identifier] = ACTIONS(10014),
    [sym_false] = ACTIONS(753),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_LBRACE_PIPE] = ACTIONS(757),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_AMP] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_number] = ACTIONS(763),
    [anon_sym_symbol] = ACTIONS(763),
    [anon_sym_this] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_STAR] = ACTIONS(771),
    [anon_sym_keyof] = ACTIONS(773),
    [sym_number] = ACTIONS(775),
    [sym_true] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(763),
    [anon_sym_string] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_new] = ACTIONS(10020),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_PIPE] = ACTIONS(10022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(763),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_boolean] = ACTIONS(763),
  },
  [5148] = {
    [sym_identifier] = ACTIONS(8379),
    [anon_sym_BQUOTE] = ACTIONS(7511),
    [anon_sym_debugger] = ACTIONS(8379),
    [anon_sym_symbol] = ACTIONS(8379),
    [anon_sym_AT] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(10064),
    [anon_sym_DASH] = ACTIONS(8379),
    [anon_sym_void] = ACTIONS(8379),
    [anon_sym_break] = ACTIONS(8379),
    [anon_sym_const] = ACTIONS(8379),
    [sym_super] = ACTIONS(8379),
    [anon_sym_return] = ACTIONS(8379),
    [anon_sym_private] = ACTIONS(8379),
    [anon_sym_get] = ACTIONS(8379),
    [anon_sym_RBRACE] = ACTIONS(7511),
    [anon_sym_default] = ACTIONS(8379),
    [anon_sym_interface] = ACTIONS(8379),
    [anon_sym_enum] = ACTIONS(8379),
    [anon_sym_delete] = ACTIONS(8379),
    [anon_sym_continue] = ACTIONS(8379),
    [anon_sym_DASH_DASH] = ACTIONS(7511),
    [anon_sym_if] = ACTIONS(8379),
    [anon_sym_this] = ACTIONS(8379),
    [anon_sym_yield] = ACTIONS(8379),
    [sym_true] = ACTIONS(8379),
    [anon_sym_throw] = ACTIONS(8379),
    [anon_sym_protected] = ACTIONS(8379),
    [anon_sym_abstract] = ACTIONS(8379),
    [anon_sym_set] = ACTIONS(8379),
    [anon_sym_type] = ACTIONS(8379),
    [anon_sym_import] = ACTIONS(8379),
    [anon_sym_namespace] = ACTIONS(8379),
    [anon_sym_PLUS_PLUS] = ACTIONS(7511),
    [anon_sym_await] = ACTIONS(8379),
    [anon_sym_DQUOTE] = ACTIONS(7511),
    [anon_sym_else] = ACTIONS(8379),
    [anon_sym_BANG] = ACTIONS(7511),
    [anon_sym_for] = ACTIONS(8379),
    [anon_sym_LBRACK] = ACTIONS(7511),
    [sym_false] = ACTIONS(8379),
    [anon_sym_SEMI] = ACTIONS(7511),
    [anon_sym_case] = ACTIONS(8379),
    [anon_sym_module] = ACTIONS(8379),
    [anon_sym_number] = ACTIONS(8379),
    [anon_sym_class] = ACTIONS(8379),
    [anon_sym_declare] = ACTIONS(8379),
    [anon_sym_typeof] = ACTIONS(8379),
    [anon_sym_LBRACE] = ACTIONS(7511),
    [anon_sym_switch] = ACTIONS(8379),
    [anon_sym_LPAREN] = ACTIONS(7511),
    [sym_null] = ACTIONS(8379),
    [anon_sym_any] = ACTIONS(8379),
    [anon_sym_boolean] = ACTIONS(8379),
    [anon_sym_async] = ACTIONS(8379),
    [anon_sym_public] = ACTIONS(8379),
    [anon_sym_AMP] = ACTIONS(10066),
    [anon_sym_var] = ACTIONS(8379),
    [anon_sym_while] = ACTIONS(8379),
    [anon_sym_SQUOTE] = ACTIONS(7511),
    [anon_sym_try] = ACTIONS(8379),
    [anon_sym_LT] = ACTIONS(7511),
    [sym_number] = ACTIONS(7511),
    [anon_sym_SLASH] = ACTIONS(8379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8379),
    [anon_sym_function] = ACTIONS(8379),
    [sym_undefined] = ACTIONS(8379),
    [anon_sym_new] = ACTIONS(8379),
    [anon_sym_let] = ACTIONS(8379),
    [anon_sym_PLUS] = ACTIONS(8379),
    [anon_sym_export] = ACTIONS(8379),
    [anon_sym_do] = ACTIONS(8379),
    [anon_sym_TILDE] = ACTIONS(7511),
    [anon_sym_with] = ACTIONS(8379),
  },
  [5149] = {
    [sym_identifier] = ACTIONS(8381),
    [anon_sym_BQUOTE] = ACTIONS(7529),
    [anon_sym_debugger] = ACTIONS(8381),
    [anon_sym_symbol] = ACTIONS(8381),
    [anon_sym_AT] = ACTIONS(7529),
    [anon_sym_PIPE] = ACTIONS(10064),
    [anon_sym_DASH] = ACTIONS(8381),
    [anon_sym_void] = ACTIONS(8381),
    [anon_sym_break] = ACTIONS(8381),
    [anon_sym_const] = ACTIONS(8381),
    [sym_super] = ACTIONS(8381),
    [anon_sym_return] = ACTIONS(8381),
    [anon_sym_private] = ACTIONS(8381),
    [anon_sym_get] = ACTIONS(8381),
    [anon_sym_RBRACE] = ACTIONS(7529),
    [anon_sym_default] = ACTIONS(8381),
    [anon_sym_interface] = ACTIONS(8381),
    [anon_sym_enum] = ACTIONS(8381),
    [anon_sym_delete] = ACTIONS(8381),
    [anon_sym_continue] = ACTIONS(8381),
    [anon_sym_DASH_DASH] = ACTIONS(7529),
    [anon_sym_if] = ACTIONS(8381),
    [anon_sym_this] = ACTIONS(8381),
    [anon_sym_yield] = ACTIONS(8381),
    [sym_true] = ACTIONS(8381),
    [anon_sym_throw] = ACTIONS(8381),
    [anon_sym_protected] = ACTIONS(8381),
    [anon_sym_abstract] = ACTIONS(8381),
    [anon_sym_set] = ACTIONS(8381),
    [anon_sym_type] = ACTIONS(8381),
    [anon_sym_import] = ACTIONS(8381),
    [anon_sym_namespace] = ACTIONS(8381),
    [anon_sym_PLUS_PLUS] = ACTIONS(7529),
    [anon_sym_await] = ACTIONS(8381),
    [anon_sym_DQUOTE] = ACTIONS(7529),
    [anon_sym_else] = ACTIONS(8381),
    [anon_sym_BANG] = ACTIONS(7529),
    [anon_sym_for] = ACTIONS(8381),
    [anon_sym_LBRACK] = ACTIONS(7529),
    [sym_false] = ACTIONS(8381),
    [anon_sym_SEMI] = ACTIONS(7529),
    [anon_sym_case] = ACTIONS(8381),
    [anon_sym_module] = ACTIONS(8381),
    [anon_sym_number] = ACTIONS(8381),
    [anon_sym_class] = ACTIONS(8381),
    [anon_sym_declare] = ACTIONS(8381),
    [anon_sym_typeof] = ACTIONS(8381),
    [anon_sym_LBRACE] = ACTIONS(7529),
    [anon_sym_switch] = ACTIONS(8381),
    [anon_sym_LPAREN] = ACTIONS(7529),
    [sym_null] = ACTIONS(8381),
    [anon_sym_any] = ACTIONS(8381),
    [anon_sym_boolean] = ACTIONS(8381),
    [anon_sym_async] = ACTIONS(8381),
    [anon_sym_public] = ACTIONS(8381),
    [anon_sym_AMP] = ACTIONS(10066),
    [anon_sym_var] = ACTIONS(8381),
    [anon_sym_while] = ACTIONS(8381),
    [anon_sym_SQUOTE] = ACTIONS(7529),
    [anon_sym_try] = ACTIONS(8381),
    [anon_sym_LT] = ACTIONS(7529),
    [sym_number] = ACTIONS(7529),
    [anon_sym_SLASH] = ACTIONS(8381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(8381),
    [anon_sym_function] = ACTIONS(8381),
    [sym_undefined] = ACTIONS(8381),
    [anon_sym_new] = ACTIONS(8381),
    [anon_sym_let] = ACTIONS(8381),
    [anon_sym_PLUS] = ACTIONS(8381),
    [anon_sym_export] = ACTIONS(8381),
    [anon_sym_do] = ACTIONS(8381),
    [anon_sym_TILDE] = ACTIONS(7529),
    [anon_sym_with] = ACTIONS(8381),
  },
  [5150] = {
    [sym_identifier] = ACTIONS(9071),
    [anon_sym_BQUOTE] = ACTIONS(8547),
    [anon_sym_debugger] = ACTIONS(9071),
    [anon_sym_symbol] = ACTIONS(9071),
    [anon_sym_AT] = ACTIONS(8547),
    [anon_sym_PIPE] = ACTIONS(10064),
    [anon_sym_DASH] = ACTIONS(9071),
    [anon_sym_void] = ACTIONS(9071),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_const] = ACTIONS(9071),
    [sym_super] = ACTIONS(9071),
    [anon_sym_return] = ACTIONS(9071),
    [anon_sym_private] = ACTIONS(9071),
    [anon_sym_get] = ACTIONS(9071),
    [anon_sym_RBRACE] = ACTIONS(8547),
    [anon_sym_default] = ACTIONS(9071),
    [anon_sym_interface] = ACTIONS(9071),
    [anon_sym_enum] = ACTIONS(9071),
    [anon_sym_delete] = ACTIONS(9071),
    [anon_sym_continue] = ACTIONS(9071),
    [anon_sym_DASH_DASH] = ACTIONS(8547),
    [anon_sym_if] = ACTIONS(9071),
    [anon_sym_this] = ACTIONS(9071),
    [anon_sym_yield] = ACTIONS(9071),
    [sym_true] = ACTIONS(9071),
    [anon_sym_throw] = ACTIONS(9071),
    [anon_sym_protected] = ACTIONS(9071),
    [anon_sym_abstract] = ACTIONS(9071),
    [anon_sym_set] = ACTIONS(9071),
    [anon_sym_type] = ACTIONS(9071),
    [anon_sym_import] = ACTIONS(9071),
    [anon_sym_namespace] = ACTIONS(9071),
    [anon_sym_PLUS_PLUS] = ACTIONS(8547),
    [anon_sym_await] = ACTIONS(9071),
    [anon_sym_DQUOTE] = ACTIONS(8547),
    [anon_sym_else] = ACTIONS(9071),
    [anon_sym_BANG] = ACTIONS(8547),
    [anon_sym_for] = ACTIONS(9071),
    [anon_sym_LBRACK] = ACTIONS(8547),
    [sym_false] = ACTIONS(9071),
    [anon_sym_SEMI] = ACTIONS(8547),
    [anon_sym_case] = ACTIONS(9071),
    [anon_sym_module] = ACTIONS(9071),
    [anon_sym_number] = ACTIONS(9071),
    [anon_sym_class] = ACTIONS(9071),
    [anon_sym_declare] = ACTIONS(9071),
    [anon_sym_typeof] = ACTIONS(9071),
    [anon_sym_LBRACE] = ACTIONS(8547),
    [anon_sym_switch] = ACTIONS(9071),
    [anon_sym_LPAREN] = ACTIONS(8547),
    [sym_null] = ACTIONS(9071),
    [anon_sym_any] = ACTIONS(9071),
    [anon_sym_boolean] = ACTIONS(9071),
    [anon_sym_async] = ACTIONS(9071),
    [anon_sym_public] = ACTIONS(9071),
    [anon_sym_AMP] = ACTIONS(10066),
    [anon_sym_var] = ACTIONS(9071),
    [anon_sym_while] = ACTIONS(9071),
    [anon_sym_SQUOTE] = ACTIONS(8547),
    [anon_sym_try] = ACTIONS(9071),
    [anon_sym_LT] = ACTIONS(8547),
    [sym_number] = ACTIONS(8547),
    [anon_sym_SLASH] = ACTIONS(9071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(9071),
    [anon_sym_function] = ACTIONS(9071),
    [sym_undefined] = ACTIONS(9071),
    [anon_sym_new] = ACTIONS(9071),
    [anon_sym_let] = ACTIONS(9071),
    [anon_sym_PLUS] = ACTIONS(9071),
    [anon_sym_export] = ACTIONS(9071),
    [anon_sym_do] = ACTIONS(9071),
    [anon_sym_TILDE] = ACTIONS(8547),
    [anon_sym_with] = ACTIONS(9071),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = false}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, SHIFT(3),
  [9] = {.count = 1, .reusable = false}, SHIFT(4),
  [11] = {.count = 1, .reusable = false}, SHIFT(5),
  [13] = {.count = 1, .reusable = true}, SHIFT(6),
  [15] = {.count = 1, .reusable = false}, SHIFT(7),
  [17] = {.count = 1, .reusable = false}, SHIFT(8),
  [19] = {.count = 1, .reusable = false}, SHIFT(9),
  [21] = {.count = 1, .reusable = false}, SHIFT(10),
  [23] = {.count = 1, .reusable = false}, SHIFT(11),
  [25] = {.count = 1, .reusable = false}, SHIFT(12),
  [27] = {.count = 1, .reusable = false}, SHIFT(13),
  [29] = {.count = 1, .reusable = false}, SHIFT(14),
  [31] = {.count = 1, .reusable = false}, SHIFT(15),
  [33] = {.count = 1, .reusable = false}, SHIFT(16),
  [35] = {.count = 1, .reusable = true}, SHIFT(17),
  [37] = {.count = 1, .reusable = false}, SHIFT(18),
  [39] = {.count = 1, .reusable = false}, SHIFT(19),
  [41] = {.count = 1, .reusable = false}, SHIFT(20),
  [43] = {.count = 1, .reusable = false}, SHIFT(59),
  [45] = {.count = 1, .reusable = false}, SHIFT(21),
  [47] = {.count = 1, .reusable = false}, SHIFT(22),
  [49] = {.count = 1, .reusable = false}, SHIFT(23),
  [51] = {.count = 1, .reusable = false}, SHIFT(24),
  [53] = {.count = 1, .reusable = false}, SHIFT(25),
  [55] = {.count = 1, .reusable = false}, SHIFT(26),
  [57] = {.count = 1, .reusable = true}, SHIFT(27),
  [59] = {.count = 1, .reusable = true}, SHIFT(15),
  [61] = {.count = 1, .reusable = false}, SHIFT(28),
  [63] = {.count = 1, .reusable = true}, SHIFT(29),
  [65] = {.count = 1, .reusable = true}, SHIFT(30),
  [67] = {.count = 1, .reusable = false}, SHIFT(31),
  [69] = {.count = 1, .reusable = false}, SHIFT(32),
  [71] = {.count = 1, .reusable = false}, SHIFT(33),
  [73] = {.count = 1, .reusable = true}, SHIFT(34),
  [75] = {.count = 1, .reusable = false}, SHIFT(35),
  [77] = {.count = 1, .reusable = true}, SHIFT(36),
  [79] = {.count = 1, .reusable = false}, SHIFT(37),
  [81] = {.count = 1, .reusable = false}, SHIFT(38),
  [83] = {.count = 1, .reusable = true}, SHIFT(39),
  [85] = {.count = 1, .reusable = false}, SHIFT(40),
  [87] = {.count = 1, .reusable = true}, SHIFT(41),
  [89] = {.count = 1, .reusable = false}, SHIFT(42),
  [91] = {.count = 1, .reusable = true}, SHIFT(43),
  [93] = {.count = 1, .reusable = true}, SHIFT(59),
  [95] = {.count = 1, .reusable = false}, SHIFT(44),
  [97] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [99] = {.count = 1, .reusable = false}, SHIFT(45),
  [101] = {.count = 1, .reusable = false}, SHIFT(46),
  [103] = {.count = 1, .reusable = false}, SHIFT(47),
  [105] = {.count = 1, .reusable = false}, SHIFT(48),
  [107] = {.count = 1, .reusable = false}, SHIFT(49),
  [109] = {.count = 1, .reusable = false}, SHIFT(50),
  [111] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [113] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [115] = {.count = 1, .reusable = true}, SHIFT(67),
  [117] = {.count = 1, .reusable = false}, SHIFT(68),
  [119] = {.count = 1, .reusable = true}, SHIFT(65),
  [121] = {.count = 1, .reusable = true}, SHIFT(69),
  [123] = {.count = 1, .reusable = true}, SHIFT(70),
  [125] = {.count = 1, .reusable = false}, SHIFT(66),
  [127] = {.count = 1, .reusable = true}, SHIFT(72),
  [129] = {.count = 1, .reusable = true}, SHIFT(74),
  [131] = {.count = 1, .reusable = true}, SHIFT(73),
  [133] = {.count = 1, .reusable = true}, SHIFT(75),
  [135] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [137] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [139] = {.count = 1, .reusable = true}, SHIFT(77),
  [141] = {.count = 1, .reusable = true}, SHIFT(76),
  [143] = {.count = 1, .reusable = true}, SHIFT(78),
  [145] = {.count = 1, .reusable = false}, SHIFT(80),
  [147] = {.count = 1, .reusable = false}, SHIFT(81),
  [149] = {.count = 1, .reusable = false}, SHIFT(83),
  [151] = {.count = 1, .reusable = false}, SHIFT(87),
  [153] = {.count = 1, .reusable = true}, SHIFT(84),
  [155] = {.count = 1, .reusable = false}, SHIFT(85),
  [157] = {.count = 1, .reusable = true}, SHIFT(87),
  [159] = {.count = 1, .reusable = false}, SHIFT(86),
  [161] = {.count = 1, .reusable = false}, SHIFT(90),
  [163] = {.count = 1, .reusable = false}, SHIFT(78),
  [165] = {.count = 1, .reusable = false}, SHIFT(43),
  [167] = {.count = 1, .reusable = true}, SHIFT(90),
  [169] = {.count = 1, .reusable = true}, SHIFT(91),
  [171] = {.count = 1, .reusable = true}, SHIFT(92),
  [173] = {.count = 1, .reusable = false}, SHIFT(93),
  [175] = {.count = 1, .reusable = true}, SHIFT(94),
  [177] = {.count = 1, .reusable = false}, SHIFT(95),
  [179] = {.count = 1, .reusable = true}, SHIFT(96),
  [181] = {.count = 1, .reusable = true}, SHIFT(100),
  [183] = {.count = 1, .reusable = true}, SHIFT(102),
  [185] = {.count = 1, .reusable = false}, SHIFT(101),
  [187] = {.count = 1, .reusable = true}, SHIFT(105),
  [189] = {.count = 1, .reusable = false}, SHIFT(106),
  [191] = {.count = 1, .reusable = true}, SHIFT(106),
  [193] = {.count = 1, .reusable = true}, SHIFT(108),
  [195] = {.count = 1, .reusable = true}, SHIFT(109),
  [197] = {.count = 1, .reusable = true}, SHIFT(110),
  [199] = {.count = 1, .reusable = true}, SHIFT(111),
  [201] = {.count = 1, .reusable = false}, SHIFT(112),
  [203] = {.count = 1, .reusable = true}, SHIFT(112),
  [205] = {.count = 1, .reusable = true}, SHIFT(113),
  [207] = {.count = 1, .reusable = true}, REDUCE(sym_this, 1),
  [209] = {.count = 1, .reusable = false}, REDUCE(sym_this, 1),
  [211] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 1),
  [213] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 1),
  [215] = {.count = 1, .reusable = false}, SHIFT(115),
  [217] = {.count = 1, .reusable = true}, SHIFT(115),
  [219] = {.count = 1, .reusable = false}, SHIFT(116),
  [221] = {.count = 1, .reusable = true}, SHIFT(116),
  [223] = {.count = 1, .reusable = true}, SHIFT(118),
  [225] = {.count = 1, .reusable = false}, SHIFT(119),
  [227] = {.count = 1, .reusable = false}, SHIFT(120),
  [229] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(122),
  [232] = {.count = 1, .reusable = false}, SHIFT(121),
  [234] = {.count = 1, .reusable = true}, SHIFT(123),
  [236] = {.count = 1, .reusable = false}, SHIFT(127),
  [238] = {.count = 1, .reusable = false}, SHIFT(130),
  [240] = {.count = 1, .reusable = true}, SHIFT(130),
  [242] = {.count = 1, .reusable = true}, SHIFT(132),
  [244] = {.count = 1, .reusable = false}, SHIFT(131),
  [246] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [248] = {.count = 1, .reusable = true}, SHIFT(133),
  [250] = {.count = 1, .reusable = true}, SHIFT(134),
  [252] = {.count = 1, .reusable = true}, SHIFT(140),
  [254] = {.count = 1, .reusable = false}, SHIFT(136),
  [256] = {.count = 1, .reusable = false}, SHIFT(160),
  [258] = {.count = 1, .reusable = true}, SHIFT(137),
  [260] = {.count = 1, .reusable = false}, SHIFT(138),
  [262] = {.count = 1, .reusable = false}, SHIFT(139),
  [264] = {.count = 1, .reusable = false}, SHIFT(140),
  [266] = {.count = 1, .reusable = false}, SHIFT(141),
  [268] = {.count = 1, .reusable = true}, SHIFT(142),
  [270] = {.count = 1, .reusable = true}, SHIFT(143),
  [272] = {.count = 1, .reusable = false}, SHIFT(144),
  [274] = {.count = 1, .reusable = true}, SHIFT(145),
  [276] = {.count = 1, .reusable = true}, SHIFT(146),
  [278] = {.count = 1, .reusable = false}, SHIFT(147),
  [280] = {.count = 1, .reusable = false}, SHIFT(148),
  [282] = {.count = 1, .reusable = true}, SHIFT(149),
  [284] = {.count = 1, .reusable = true}, SHIFT(150),
  [286] = {.count = 1, .reusable = true}, SHIFT(151),
  [288] = {.count = 1, .reusable = true}, SHIFT(160),
  [290] = {.count = 1, .reusable = false}, SHIFT(152),
  [292] = {.count = 1, .reusable = false}, SHIFT(153),
  [294] = {.count = 1, .reusable = false}, SHIFT(154),
  [296] = {.count = 1, .reusable = false}, SHIFT(155),
  [298] = {.count = 1, .reusable = false}, SHIFT(156),
  [300] = {.count = 1, .reusable = false}, SHIFT(157),
  [302] = {.count = 1, .reusable = false}, SHIFT(158),
  [304] = {.count = 1, .reusable = true}, SHIFT(135),
  [306] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [308] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [310] = {.count = 1, .reusable = false}, SHIFT(169),
  [312] = {.count = 1, .reusable = true}, SHIFT(170),
  [314] = {.count = 1, .reusable = true}, SHIFT(171),
  [316] = {.count = 1, .reusable = false}, SHIFT(174),
  [318] = {.count = 1, .reusable = false}, SHIFT(175),
  [320] = {.count = 1, .reusable = false}, SHIFT(176),
  [322] = {.count = 1, .reusable = true}, SHIFT(177),
  [324] = {.count = 1, .reusable = true}, SHIFT(185),
  [326] = {.count = 1, .reusable = true}, SHIFT(10),
  [328] = {.count = 1, .reusable = true}, SHIFT(13),
  [330] = {.count = 1, .reusable = true}, SHIFT(14),
  [332] = {.count = 1, .reusable = true}, SHIFT(22),
  [334] = {.count = 1, .reusable = true}, SHIFT(188),
  [336] = {.count = 1, .reusable = true}, SHIFT(189),
  [338] = {.count = 1, .reusable = true}, SHIFT(191),
  [340] = {.count = 1, .reusable = true}, SHIFT(182),
  [342] = {.count = 1, .reusable = true}, SHIFT(183),
  [344] = {.count = 1, .reusable = true}, SHIFT(184),
  [346] = {.count = 1, .reusable = true}, SHIFT(186),
  [348] = {.count = 1, .reusable = true}, SHIFT(38),
  [350] = {.count = 1, .reusable = true}, SHIFT(187),
  [352] = {.count = 1, .reusable = true}, SHIFT(47),
  [354] = {.count = 1, .reusable = true}, SHIFT(190),
  [356] = {.count = 1, .reusable = false}, SHIFT(194),
  [358] = {.count = 1, .reusable = false}, SHIFT(195),
  [360] = {.count = 1, .reusable = true}, SHIFT(196),
  [362] = {.count = 1, .reusable = true}, SHIFT(197),
  [364] = {.count = 1, .reusable = true}, SHIFT(198),
  [366] = {.count = 1, .reusable = false}, SHIFT(199),
  [368] = {.count = 1, .reusable = false}, SHIFT(200),
  [370] = {.count = 1, .reusable = false}, SHIFT(201),
  [372] = {.count = 1, .reusable = false}, SHIFT(202),
  [374] = {.count = 1, .reusable = true}, SHIFT(203),
  [376] = {.count = 1, .reusable = false}, SHIFT(204),
  [378] = {.count = 1, .reusable = false}, SHIFT(205),
  [380] = {.count = 1, .reusable = false}, SHIFT(206),
  [382] = {.count = 1, .reusable = false}, SHIFT(207),
  [384] = {.count = 1, .reusable = false}, SHIFT(208),
  [386] = {.count = 1, .reusable = false}, SHIFT(209),
  [388] = {.count = 1, .reusable = true}, SHIFT(210),
  [390] = {.count = 1, .reusable = false}, SHIFT(211),
  [392] = {.count = 1, .reusable = false}, SHIFT(212),
  [394] = {.count = 1, .reusable = true}, SHIFT(213),
  [396] = {.count = 1, .reusable = false}, SHIFT(214),
  [398] = {.count = 1, .reusable = false}, SHIFT(215),
  [400] = {.count = 1, .reusable = true}, SHIFT(216),
  [402] = {.count = 1, .reusable = false}, SHIFT(217),
  [404] = {.count = 1, .reusable = false}, SHIFT(218),
  [406] = {.count = 1, .reusable = true}, SHIFT(237),
  [408] = {.count = 1, .reusable = false}, SHIFT(228),
  [410] = {.count = 1, .reusable = false}, SHIFT(245),
  [412] = {.count = 1, .reusable = true}, SHIFT(231),
  [414] = {.count = 1, .reusable = false}, SHIFT(230),
  [416] = {.count = 1, .reusable = false}, SHIFT(231),
  [418] = {.count = 1, .reusable = false}, SHIFT(232),
  [420] = {.count = 1, .reusable = true}, SHIFT(233),
  [422] = {.count = 1, .reusable = false}, SHIFT(234),
  [424] = {.count = 1, .reusable = false}, SHIFT(235),
  [426] = {.count = 1, .reusable = false}, SHIFT(236),
  [428] = {.count = 1, .reusable = true}, SHIFT(238),
  [430] = {.count = 1, .reusable = true}, SHIFT(245),
  [432] = {.count = 1, .reusable = false}, SHIFT(239),
  [434] = {.count = 1, .reusable = false}, SHIFT(240),
  [436] = {.count = 1, .reusable = false}, SHIFT(229),
  [438] = {.count = 1, .reusable = false}, SHIFT(241),
  [440] = {.count = 1, .reusable = false}, SHIFT(242),
  [442] = {.count = 1, .reusable = false}, SHIFT(253),
  [444] = {.count = 1, .reusable = false}, SHIFT(254),
  [446] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(255),
  [449] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(256),
  [452] = {.count = 1, .reusable = false}, SHIFT(257),
  [454] = {.count = 1, .reusable = true}, SHIFT(93),
  [456] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [458] = {.count = 1, .reusable = true}, SHIFT(261),
  [460] = {.count = 1, .reusable = true}, SHIFT(262),
  [462] = {.count = 1, .reusable = true}, SHIFT(264),
  [464] = {.count = 1, .reusable = false}, SHIFT(265),
  [466] = {.count = 1, .reusable = true}, SHIFT(266),
  [468] = {.count = 1, .reusable = false}, SHIFT(270),
  [470] = {.count = 1, .reusable = true}, SHIFT(271),
  [472] = {.count = 1, .reusable = true}, SHIFT(256),
  [474] = {.count = 1, .reusable = true}, SHIFT(255),
  [476] = {.count = 1, .reusable = true}, SHIFT(272),
  [478] = {.count = 1, .reusable = true}, SHIFT(285),
  [480] = {.count = 1, .reusable = false}, SHIFT(276),
  [482] = {.count = 1, .reusable = false}, SHIFT(277),
  [484] = {.count = 1, .reusable = true}, SHIFT(280),
  [486] = {.count = 1, .reusable = false}, SHIFT(279),
  [488] = {.count = 1, .reusable = false}, SHIFT(280),
  [490] = {.count = 1, .reusable = false}, SHIFT(281),
  [492] = {.count = 1, .reusable = false}, SHIFT(282),
  [494] = {.count = 1, .reusable = false}, SHIFT(283),
  [496] = {.count = 1, .reusable = false}, SHIFT(284),
  [498] = {.count = 1, .reusable = true}, SHIFT(277),
  [500] = {.count = 1, .reusable = false}, SHIFT(286),
  [502] = {.count = 1, .reusable = false}, SHIFT(278),
  [504] = {.count = 1, .reusable = false}, SHIFT(287),
  [506] = {.count = 1, .reusable = false}, SHIFT(288),
  [508] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(295),
  [511] = {.count = 1, .reusable = false}, SHIFT(297),
  [513] = {.count = 1, .reusable = true}, SHIFT(298),
  [515] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(299),
  [518] = {.count = 1, .reusable = true}, SHIFT(294),
  [520] = {.count = 1, .reusable = true}, SHIFT(296),
  [522] = {.count = 1, .reusable = false}, SHIFT(302),
  [524] = {.count = 1, .reusable = false}, SHIFT(303),
  [526] = {.count = 1, .reusable = false}, SHIFT(304),
  [528] = {.count = 1, .reusable = false}, SHIFT(305),
  [530] = {.count = 1, .reusable = false}, SHIFT(306),
  [532] = {.count = 1, .reusable = false}, SHIFT(307),
  [534] = {.count = 1, .reusable = false}, SHIFT(308),
  [536] = {.count = 1, .reusable = false}, SHIFT(309),
  [538] = {.count = 1, .reusable = false}, SHIFT(310),
  [540] = {.count = 1, .reusable = false}, REDUCE(sym__declaration, 1),
  [542] = {.count = 1, .reusable = true}, REDUCE(sym__declaration, 1),
  [544] = {.count = 1, .reusable = true}, SHIFT(318),
  [546] = {.count = 1, .reusable = true}, SHIFT(319),
  [548] = {.count = 1, .reusable = true}, REDUCE(sym_call_signature, 1),
  [550] = {.count = 1, .reusable = true}, SHIFT(322),
  [552] = {.count = 1, .reusable = true}, SHIFT(324),
  [554] = {.count = 1, .reusable = true}, SHIFT(66),
  [556] = {.count = 1, .reusable = false}, SHIFT(326),
  [558] = {.count = 1, .reusable = true}, SHIFT(330),
  [560] = {.count = 1, .reusable = true}, SHIFT(327),
  [562] = {.count = 1, .reusable = false}, SHIFT(328),
  [564] = {.count = 1, .reusable = true}, SHIFT(329),
  [566] = {.count = 1, .reusable = false}, SHIFT(327),
  [568] = {.count = 1, .reusable = false}, SHIFT(329),
  [570] = {.count = 1, .reusable = true}, SHIFT(331),
  [572] = {.count = 1, .reusable = true}, SHIFT(326),
  [574] = {.count = 1, .reusable = true}, SHIFT(332),
  [576] = {.count = 1, .reusable = true}, SHIFT(333),
  [578] = {.count = 1, .reusable = false}, SHIFT(334),
  [580] = {.count = 1, .reusable = true}, SHIFT(335),
  [582] = {.count = 1, .reusable = false}, SHIFT(325),
  [584] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [586] = {.count = 1, .reusable = false}, SHIFT(341),
  [588] = {.count = 1, .reusable = false}, SHIFT(337),
  [590] = {.count = 1, .reusable = false}, SHIFT(338),
  [592] = {.count = 1, .reusable = false}, SHIFT(344),
  [594] = {.count = 1, .reusable = true}, SHIFT(342),
  [596] = {.count = 1, .reusable = true}, SHIFT(344),
  [598] = {.count = 1, .reusable = false}, SHIFT(345),
  [600] = {.count = 1, .reusable = true}, SHIFT(345),
  [602] = {.count = 1, .reusable = false}, SHIFT(346),
  [604] = {.count = 1, .reusable = true}, SHIFT(346),
  [606] = {.count = 1, .reusable = false}, SHIFT(347),
  [608] = {.count = 1, .reusable = true}, SHIFT(347),
  [610] = {.count = 1, .reusable = true}, SHIFT(349),
  [612] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 2),
  [614] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 2),
  [616] = {.count = 1, .reusable = true}, SHIFT(352),
  [618] = {.count = 1, .reusable = false}, SHIFT(350),
  [620] = {.count = 1, .reusable = false}, SHIFT(362),
  [622] = {.count = 1, .reusable = false}, SHIFT(351),
  [624] = {.count = 1, .reusable = false}, SHIFT(352),
  [626] = {.count = 1, .reusable = false}, SHIFT(353),
  [628] = {.count = 1, .reusable = false}, SHIFT(354),
  [630] = {.count = 1, .reusable = false}, SHIFT(355),
  [632] = {.count = 1, .reusable = true}, SHIFT(356),
  [634] = {.count = 1, .reusable = true}, SHIFT(362),
  [636] = {.count = 1, .reusable = false}, SHIFT(357),
  [638] = {.count = 1, .reusable = false}, SHIFT(358),
  [640] = {.count = 1, .reusable = false}, SHIFT(359),
  [642] = {.count = 1, .reusable = false}, SHIFT(360),
  [644] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 2),
  [646] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 2),
  [648] = {.count = 1, .reusable = true}, SHIFT(368),
  [650] = {.count = 1, .reusable = true}, SHIFT(367),
  [652] = {.count = 1, .reusable = false}, REDUCE(sym_debugger_statement, 2),
  [654] = {.count = 1, .reusable = true}, REDUCE(sym_debugger_statement, 2),
  [656] = {.count = 1, .reusable = false}, SHIFT(370),
  [658] = {.count = 1, .reusable = true}, SHIFT(370),
  [660] = {.count = 1, .reusable = false}, SHIFT(371),
  [662] = {.count = 1, .reusable = true}, SHIFT(371),
  [664] = {.count = 1, .reusable = true}, SHIFT(372),
  [666] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 1),
  [668] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 1),
  [670] = {.count = 1, .reusable = true}, REDUCE(sym__identifier_reference, 1, .alias_sequence_id = 1),
  [672] = {.count = 1, .reusable = false}, REDUCE(sym__identifier_reference, 1, .alias_sequence_id = 1),
  [674] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 2),
  [676] = {.count = 1, .reusable = false}, REDUCE(sym_decorator, 2),
  [678] = {.count = 1, .reusable = true}, SHIFT(374),
  [680] = {.count = 1, .reusable = false}, SHIFT(373),
  [682] = {.count = 1, .reusable = false}, SHIFT(376),
  [684] = {.count = 1, .reusable = true}, SHIFT(377),
  [686] = {.count = 1, .reusable = false}, SHIFT(378),
  [688] = {.count = 1, .reusable = false}, SHIFT(379),
  [690] = {.count = 1, .reusable = false}, SHIFT(380),
  [692] = {.count = 1, .reusable = false}, SHIFT(381),
  [694] = {.count = 1, .reusable = true}, SHIFT(382),
  [696] = {.count = 1, .reusable = true}, SHIFT(224),
  [698] = {.count = 1, .reusable = false}, SHIFT(386),
  [700] = {.count = 1, .reusable = true}, SHIFT(387),
  [702] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2),
  [704] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2),
  [706] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(334),
  [709] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 2),
  [711] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 2),
  [713] = {.count = 1, .reusable = true}, SHIFT(389),
  [715] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1),
  [717] = {.count = 1, .reusable = true}, SHIFT(68),
  [719] = {.count = 1, .reusable = true}, SHIFT(390),
  [721] = {.count = 1, .reusable = false}, SHIFT(394),
  [723] = {.count = 1, .reusable = true}, SHIFT(393),
  [725] = {.count = 1, .reusable = true}, SHIFT(394),
  [727] = {.count = 1, .reusable = true}, SHIFT(397),
  [729] = {.count = 1, .reusable = false}, SHIFT(398),
  [731] = {.count = 1, .reusable = false}, SHIFT(399),
  [733] = {.count = 1, .reusable = false}, SHIFT(400),
  [735] = {.count = 1, .reusable = false}, SHIFT(401),
  [737] = {.count = 1, .reusable = false}, SHIFT(402),
  [739] = {.count = 1, .reusable = true}, SHIFT(403),
  [741] = {.count = 1, .reusable = true}, SHIFT(408),
  [743] = {.count = 1, .reusable = true}, SHIFT(407),
  [745] = {.count = 1, .reusable = true}, SHIFT(410),
  [747] = {.count = 1, .reusable = false}, SHIFT(415),
  [749] = {.count = 1, .reusable = true}, SHIFT(415),
  [751] = {.count = 1, .reusable = false}, SHIFT(417),
  [753] = {.count = 1, .reusable = false}, SHIFT(418),
  [755] = {.count = 1, .reusable = true}, SHIFT(419),
  [757] = {.count = 1, .reusable = true}, SHIFT(420),
  [759] = {.count = 1, .reusable = true}, SHIFT(421),
  [761] = {.count = 1, .reusable = true}, SHIFT(422),
  [763] = {.count = 1, .reusable = false}, SHIFT(423),
  [765] = {.count = 1, .reusable = false}, SHIFT(424),
  [767] = {.count = 1, .reusable = false}, SHIFT(425),
  [769] = {.count = 1, .reusable = true}, SHIFT(426),
  [771] = {.count = 1, .reusable = true}, SHIFT(427),
  [773] = {.count = 1, .reusable = false}, SHIFT(428),
  [775] = {.count = 1, .reusable = true}, SHIFT(418),
  [777] = {.count = 1, .reusable = false}, SHIFT(420),
  [779] = {.count = 1, .reusable = false}, SHIFT(429),
  [781] = {.count = 1, .reusable = true}, SHIFT(430),
  [783] = {.count = 1, .reusable = true}, SHIFT(431),
  [785] = {.count = 1, .reusable = true}, SHIFT(440),
  [787] = {.count = 1, .reusable = false}, SHIFT(438),
  [789] = {.count = 1, .reusable = false}, SHIFT(453),
  [791] = {.count = 1, .reusable = false}, SHIFT(439),
  [793] = {.count = 1, .reusable = false}, SHIFT(440),
  [795] = {.count = 1, .reusable = false}, SHIFT(441),
  [797] = {.count = 1, .reusable = true}, SHIFT(442),
  [799] = {.count = 1, .reusable = true}, SHIFT(443),
  [801] = {.count = 1, .reusable = false}, SHIFT(444),
  [803] = {.count = 1, .reusable = false}, SHIFT(445),
  [805] = {.count = 1, .reusable = true}, SHIFT(446),
  [807] = {.count = 1, .reusable = true}, SHIFT(447),
  [809] = {.count = 1, .reusable = true}, SHIFT(453),
  [811] = {.count = 1, .reusable = false}, SHIFT(448),
  [813] = {.count = 1, .reusable = false}, SHIFT(449),
  [815] = {.count = 1, .reusable = false}, SHIFT(450),
  [817] = {.count = 1, .reusable = false}, SHIFT(451),
  [819] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 2),
  [821] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 2),
  [823] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 2),
  [825] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [827] = {.count = 1, .reusable = true}, SHIFT(460),
  [829] = {.count = 1, .reusable = true}, SHIFT(461),
  [831] = {.count = 1, .reusable = true}, SHIFT(465),
  [833] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 2),
  [835] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 2),
  [837] = {.count = 1, .reusable = true}, SHIFT(467),
  [839] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2),
  [841] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2),
  [843] = {.count = 1, .reusable = false}, SHIFT(468),
  [845] = {.count = 1, .reusable = false}, SHIFT(473),
  [847] = {.count = 1, .reusable = false}, SHIFT(469),
  [849] = {.count = 1, .reusable = false}, SHIFT(470),
  [851] = {.count = 1, .reusable = false}, SHIFT(471),
  [853] = {.count = 1, .reusable = true}, SHIFT(473),
  [855] = {.count = 1, .reusable = false}, SHIFT(472),
  [857] = {.count = 1, .reusable = false}, SHIFT(477),
  [859] = {.count = 1, .reusable = false}, SHIFT(478),
  [861] = {.count = 1, .reusable = false}, SHIFT(479),
  [863] = {.count = 1, .reusable = false}, SHIFT(480),
  [865] = {.count = 1, .reusable = false}, SHIFT(481),
  [867] = {.count = 1, .reusable = false}, SHIFT(482),
  [869] = {.count = 1, .reusable = false}, SHIFT(483),
  [871] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 2),
  [873] = {.count = 1, .reusable = true}, SHIFT(486),
  [875] = {.count = 1, .reusable = true}, SHIFT(487),
  [877] = {.count = 1, .reusable = true}, SHIFT(488),
  [879] = {.count = 1, .reusable = true}, SHIFT(491),
  [881] = {.count = 1, .reusable = true}, SHIFT(490),
  [883] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 1),
  [885] = {.count = 1, .reusable = true}, SHIFT(492),
  [887] = {.count = 1, .reusable = true}, SHIFT(122),
  [889] = {.count = 1, .reusable = true}, SHIFT(495),
  [891] = {.count = 1, .reusable = false}, SHIFT(496),
  [893] = {.count = 1, .reusable = true}, SHIFT(497),
  [895] = {.count = 1, .reusable = false}, SHIFT(498),
  [897] = {.count = 1, .reusable = true}, SHIFT(499),
  [899] = {.count = 1, .reusable = true}, SHIFT(501),
  [901] = {.count = 1, .reusable = true}, SHIFT(502),
  [903] = {.count = 1, .reusable = true}, REDUCE(sym__module, 1),
  [905] = {.count = 1, .reusable = false}, REDUCE(sym__module, 1),
  [907] = {.count = 1, .reusable = false}, SHIFT(503),
  [909] = {.count = 1, .reusable = true}, SHIFT(504),
  [911] = {.count = 1, .reusable = true}, REDUCE(sym_internal_module, 2),
  [913] = {.count = 1, .reusable = false}, REDUCE(sym_internal_module, 2),
  [915] = {.count = 1, .reusable = true}, REDUCE(sym_await_expression, 2),
  [917] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [919] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [921] = {.count = 1, .reusable = true}, SHIFT(507),
  [923] = {.count = 1, .reusable = false}, SHIFT(506),
  [925] = {.count = 1, .reusable = true}, SHIFT(508),
  [927] = {.count = 1, .reusable = false}, SHIFT(509),
  [929] = {.count = 1, .reusable = false}, SHIFT(510),
  [931] = {.count = 1, .reusable = false}, SHIFT(511),
  [933] = {.count = 1, .reusable = true}, SHIFT(516),
  [935] = {.count = 1, .reusable = false}, SHIFT(515),
  [937] = {.count = 1, .reusable = true}, SHIFT(519),
  [939] = {.count = 1, .reusable = false}, SHIFT(520),
  [941] = {.count = 1, .reusable = true}, SHIFT(517),
  [943] = {.count = 1, .reusable = true}, SHIFT(521),
  [945] = {.count = 1, .reusable = false}, SHIFT(518),
  [947] = {.count = 1, .reusable = true}, SHIFT(524),
  [949] = {.count = 1, .reusable = true}, SHIFT(523),
  [951] = {.count = 1, .reusable = true}, SHIFT(526),
  [953] = {.count = 1, .reusable = true}, SHIFT(525),
  [955] = {.count = 1, .reusable = true}, SHIFT(527),
  [957] = {.count = 1, .reusable = false}, SHIFT(529),
  [959] = {.count = 1, .reusable = true}, SHIFT(530),
  [961] = {.count = 1, .reusable = false}, SHIFT(533),
  [963] = {.count = 1, .reusable = true}, SHIFT(533),
  [965] = {.count = 1, .reusable = false}, SHIFT(534),
  [967] = {.count = 1, .reusable = true}, SHIFT(534),
  [969] = {.count = 1, .reusable = false}, SHIFT(535),
  [971] = {.count = 1, .reusable = true}, SHIFT(535),
  [973] = {.count = 1, .reusable = false}, SHIFT(536),
  [975] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 1),
  [977] = {.count = 1, .reusable = true}, SHIFT(536),
  [979] = {.count = 1, .reusable = false}, SHIFT(527),
  [981] = {.count = 1, .reusable = false}, SHIFT(151),
  [983] = {.count = 1, .reusable = false}, SHIFT(538),
  [985] = {.count = 1, .reusable = true}, SHIFT(538),
  [987] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [989] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [991] = {.count = 1, .reusable = true}, SHIFT(540),
  [993] = {.count = 1, .reusable = false}, SHIFT(543),
  [995] = {.count = 1, .reusable = false}, SHIFT(544),
  [997] = {.count = 1, .reusable = false}, SHIFT(545),
  [999] = {.count = 1, .reusable = true}, SHIFT(546),
  [1001] = {.count = 1, .reusable = false}, SHIFT(547),
  [1003] = {.count = 1, .reusable = true}, SHIFT(547),
  [1005] = {.count = 1, .reusable = true}, SHIFT(548),
  [1007] = {.count = 1, .reusable = false}, SHIFT(549),
  [1009] = {.count = 1, .reusable = true}, SHIFT(550),
  [1011] = {.count = 1, .reusable = false}, SHIFT(553),
  [1013] = {.count = 1, .reusable = true}, SHIFT(553),
  [1015] = {.count = 1, .reusable = false}, SHIFT(554),
  [1017] = {.count = 1, .reusable = true}, SHIFT(555),
  [1019] = {.count = 1, .reusable = true}, SHIFT(556),
  [1021] = {.count = 1, .reusable = false}, SHIFT(558),
  [1023] = {.count = 1, .reusable = false}, SHIFT(559),
  [1025] = {.count = 1, .reusable = false}, SHIFT(561),
  [1027] = {.count = 1, .reusable = false}, SHIFT(562),
  [1029] = {.count = 1, .reusable = false}, SHIFT(563),
  [1031] = {.count = 1, .reusable = true}, SHIFT(559),
  [1033] = {.count = 1, .reusable = false}, SHIFT(560),
  [1035] = {.count = 1, .reusable = false}, SHIFT(564),
  [1037] = {.count = 1, .reusable = false}, SHIFT(570),
  [1039] = {.count = 1, .reusable = false}, SHIFT(573),
  [1041] = {.count = 1, .reusable = true}, SHIFT(573),
  [1043] = {.count = 1, .reusable = true}, SHIFT(518),
  [1045] = {.count = 1, .reusable = false}, SHIFT(575),
  [1047] = {.count = 1, .reusable = true}, SHIFT(577),
  [1049] = {.count = 1, .reusable = false}, SHIFT(576),
  [1051] = {.count = 1, .reusable = true}, SHIFT(578),
  [1053] = {.count = 1, .reusable = false}, SHIFT(577),
  [1055] = {.count = 1, .reusable = true}, SHIFT(579),
  [1057] = {.count = 1, .reusable = false}, SHIFT(578),
  [1059] = {.count = 1, .reusable = true}, SHIFT(580),
  [1061] = {.count = 1, .reusable = true}, SHIFT(575),
  [1063] = {.count = 1, .reusable = true}, SHIFT(581),
  [1065] = {.count = 1, .reusable = true}, SHIFT(582),
  [1067] = {.count = 1, .reusable = false}, SHIFT(583),
  [1069] = {.count = 1, .reusable = true}, SHIFT(584),
  [1071] = {.count = 1, .reusable = false}, SHIFT(574),
  [1073] = {.count = 1, .reusable = true}, SHIFT(586),
  [1075] = {.count = 1, .reusable = false}, SHIFT(592),
  [1077] = {.count = 1, .reusable = false}, SHIFT(590),
  [1079] = {.count = 1, .reusable = false}, SHIFT(593),
  [1081] = {.count = 1, .reusable = true}, SHIFT(596),
  [1083] = {.count = 1, .reusable = false}, SHIFT(595),
  [1085] = {.count = 1, .reusable = true}, SHIFT(597),
  [1087] = {.count = 1, .reusable = false}, REDUCE(sym_module, 2),
  [1089] = {.count = 1, .reusable = true}, REDUCE(sym_module, 2),
  [1091] = {.count = 1, .reusable = true}, SHIFT(600),
  [1093] = {.count = 1, .reusable = false}, SHIFT(598),
  [1095] = {.count = 1, .reusable = false}, SHIFT(611),
  [1097] = {.count = 1, .reusable = false}, SHIFT(599),
  [1099] = {.count = 1, .reusable = false}, SHIFT(600),
  [1101] = {.count = 1, .reusable = false}, SHIFT(601),
  [1103] = {.count = 1, .reusable = false}, SHIFT(602),
  [1105] = {.count = 1, .reusable = false}, SHIFT(603),
  [1107] = {.count = 1, .reusable = true}, SHIFT(604),
  [1109] = {.count = 1, .reusable = true}, SHIFT(611),
  [1111] = {.count = 1, .reusable = false}, SHIFT(605),
  [1113] = {.count = 1, .reusable = false}, SHIFT(606),
  [1115] = {.count = 1, .reusable = false}, SHIFT(607),
  [1117] = {.count = 1, .reusable = false}, SHIFT(608),
  [1119] = {.count = 1, .reusable = false}, SHIFT(609),
  [1121] = {.count = 1, .reusable = false}, SHIFT(617),
  [1123] = {.count = 1, .reusable = true}, SHIFT(618),
  [1125] = {.count = 1, .reusable = true}, SHIFT(619),
  [1127] = {.count = 1, .reusable = false}, SHIFT(620),
  [1129] = {.count = 1, .reusable = true}, SHIFT(621),
  [1131] = {.count = 1, .reusable = true}, SHIFT(174),
  [1133] = {.count = 1, .reusable = true}, SHIFT(175),
  [1135] = {.count = 1, .reusable = false}, SHIFT(628),
  [1137] = {.count = 1, .reusable = true}, SHIFT(629),
  [1139] = {.count = 1, .reusable = true}, SHIFT(630),
  [1141] = {.count = 1, .reusable = false}, SHIFT(631),
  [1143] = {.count = 1, .reusable = false}, SHIFT(634),
  [1145] = {.count = 1, .reusable = false}, SHIFT(632),
  [1147] = {.count = 1, .reusable = false}, SHIFT(633),
  [1149] = {.count = 1, .reusable = true}, SHIFT(635),
  [1151] = {.count = 1, .reusable = true}, SHIFT(636),
  [1153] = {.count = 1, .reusable = true}, SHIFT(641),
  [1155] = {.count = 1, .reusable = false}, SHIFT(637),
  [1157] = {.count = 1, .reusable = false}, SHIFT(638),
  [1159] = {.count = 1, .reusable = true}, SHIFT(639),
  [1161] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 1),
  [1163] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_class, 2),
  [1165] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_class, 2),
  [1167] = {.count = 1, .reusable = true}, SHIFT(169),
  [1169] = {.count = 1, .reusable = true}, SHIFT(647),
  [1171] = {.count = 1, .reusable = true}, SHIFT(648),
  [1173] = {.count = 1, .reusable = true}, SHIFT(650),
  [1175] = {.count = 1, .reusable = true}, SHIFT(651),
  [1177] = {.count = 1, .reusable = true}, SHIFT(652),
  [1179] = {.count = 1, .reusable = true}, SHIFT(119),
  [1181] = {.count = 1, .reusable = true}, SHIFT(654),
  [1183] = {.count = 1, .reusable = false}, SHIFT(299),
  [1185] = {.count = 1, .reusable = true}, SHIFT(295),
  [1187] = {.count = 1, .reusable = true}, SHIFT(655),
  [1189] = {.count = 1, .reusable = true}, SHIFT(657),
  [1191] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 2),
  [1193] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 2),
  [1195] = {.count = 1, .reusable = false}, SHIFT(659),
  [1197] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .alias_sequence_id = 2),
  [1200] = {.count = 1, .reusable = true}, SHIFT(658),
  [1202] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .alias_sequence_id = 2),
  [1205] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .alias_sequence_id = 2), SHIFT(660),
  [1208] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(sym__property_name, 1, .alias_sequence_id = 2),
  [1211] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(sym__property_name, 1, .alias_sequence_id = 2),
  [1214] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1, .alias_sequence_id = 2),
  [1216] = {.count = 1, .reusable = false}, SHIFT(663),
  [1218] = {.count = 1, .reusable = false}, SHIFT(664),
  [1220] = {.count = 1, .reusable = false}, SHIFT(665),
  [1222] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 1),
  [1224] = {.count = 1, .reusable = false}, SHIFT(666),
  [1226] = {.count = 1, .reusable = false}, SHIFT(667),
  [1228] = {.count = 1, .reusable = false}, SHIFT(668),
  [1230] = {.count = 1, .reusable = false}, SHIFT(671),
  [1232] = {.count = 1, .reusable = true}, SHIFT(672),
  [1234] = {.count = 1, .reusable = true}, SHIFT(673),
  [1236] = {.count = 1, .reusable = false}, REDUCE(sym_accessibility_modifier, 1),
  [1238] = {.count = 1, .reusable = true}, REDUCE(sym_accessibility_modifier, 1),
  [1240] = {.count = 1, .reusable = false}, SHIFT(674),
  [1242] = {.count = 1, .reusable = false}, SHIFT(677),
  [1244] = {.count = 1, .reusable = true}, SHIFT(676),
  [1246] = {.count = 1, .reusable = false}, SHIFT(675),
  [1248] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(672),
  [1251] = {.count = 1, .reusable = true}, REDUCE(sym_object, 2),
  [1253] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 2),
  [1255] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 2),
  [1257] = {.count = 1, .reusable = false}, REDUCE(sym_object, 2),
  [1259] = {.count = 1, .reusable = true}, SHIFT(679),
  [1261] = {.count = 1, .reusable = true}, SHIFT(680),
  [1263] = {.count = 1, .reusable = false}, SHIFT(681),
  [1265] = {.count = 1, .reusable = true}, SHIFT(681),
  [1267] = {.count = 1, .reusable = true}, SHIFT(682),
  [1269] = {.count = 1, .reusable = true}, SHIFT(683),
  [1271] = {.count = 1, .reusable = true}, SHIFT(684),
  [1273] = {.count = 1, .reusable = false}, SHIFT(686),
  [1275] = {.count = 1, .reusable = true}, SHIFT(686),
  [1277] = {.count = 1, .reusable = false}, SHIFT(687),
  [1279] = {.count = 1, .reusable = false}, SHIFT(688),
  [1281] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(676),
  [1284] = {.count = 1, .reusable = false}, SHIFT(689),
  [1286] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(sym__property_name, 1, .alias_sequence_id = 2), SHIFT(255),
  [1290] = {.count = 3, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(sym__property_name, 1, .alias_sequence_id = 2), SHIFT(256),
  [1294] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [1297] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [1300] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1),
  [1302] = {.count = 1, .reusable = false}, SHIFT(692),
  [1304] = {.count = 1, .reusable = true}, SHIFT(693),
  [1306] = {.count = 1, .reusable = false}, SHIFT(694),
  [1308] = {.count = 1, .reusable = false}, SHIFT(695),
  [1310] = {.count = 1, .reusable = true}, SHIFT(698),
  [1312] = {.count = 1, .reusable = false}, SHIFT(700),
  [1314] = {.count = 1, .reusable = false}, SHIFT(319),
  [1316] = {.count = 1, .reusable = false}, SHIFT(703),
  [1318] = {.count = 1, .reusable = false}, SHIFT(705),
  [1320] = {.count = 1, .reusable = false}, SHIFT(702),
  [1322] = {.count = 1, .reusable = true}, SHIFT(707),
  [1324] = {.count = 1, .reusable = false}, SHIFT(704),
  [1326] = {.count = 1, .reusable = true}, SHIFT(709),
  [1328] = {.count = 1, .reusable = true}, SHIFT(710),
  [1330] = {.count = 1, .reusable = true}, SHIFT(714),
  [1332] = {.count = 1, .reusable = true}, SHIFT(719),
  [1334] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_required_parameter, 1),
  [1337] = {.count = 1, .reusable = false}, SHIFT(720),
  [1339] = {.count = 1, .reusable = true}, SHIFT(716),
  [1341] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), SHIFT(718),
  [1344] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), SHIFT(721),
  [1347] = {.count = 1, .reusable = false}, SHIFT(717),
  [1349] = {.count = 1, .reusable = false}, SHIFT(724),
  [1351] = {.count = 1, .reusable = false}, SHIFT(725),
  [1353] = {.count = 1, .reusable = true}, SHIFT(731),
  [1355] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(sym_required_parameter, 1, .alias_sequence_id = 1),
  [1358] = {.count = 1, .reusable = true}, SHIFT(729),
  [1360] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(730),
  [1363] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(721),
  [1366] = {.count = 1, .reusable = false}, SHIFT(734),
  [1368] = {.count = 1, .reusable = true}, SHIFT(734),
  [1370] = {.count = 1, .reusable = false}, SHIFT(735),
  [1372] = {.count = 1, .reusable = true}, SHIFT(735),
  [1374] = {.count = 1, .reusable = true}, SHIFT(736),
  [1376] = {.count = 1, .reusable = false}, SHIFT(737),
  [1378] = {.count = 1, .reusable = false}, SHIFT(738),
  [1380] = {.count = 1, .reusable = false}, SHIFT(739),
  [1382] = {.count = 1, .reusable = true}, SHIFT(739),
  [1384] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 2),
  [1386] = {.count = 1, .reusable = false}, SHIFT(740),
  [1388] = {.count = 1, .reusable = true}, SHIFT(740),
  [1390] = {.count = 1, .reusable = false}, SHIFT(741),
  [1392] = {.count = 1, .reusable = false}, SHIFT(742),
  [1394] = {.count = 1, .reusable = false}, SHIFT(743),
  [1396] = {.count = 1, .reusable = false}, SHIFT(744),
  [1398] = {.count = 1, .reusable = false}, SHIFT(745),
  [1400] = {.count = 1, .reusable = false}, SHIFT(746),
  [1402] = {.count = 1, .reusable = true}, SHIFT(746),
  [1404] = {.count = 1, .reusable = true}, SHIFT(747),
  [1406] = {.count = 1, .reusable = true}, SHIFT(748),
  [1408] = {.count = 1, .reusable = true}, SHIFT(717),
  [1410] = {.count = 1, .reusable = false}, SHIFT(750),
  [1412] = {.count = 1, .reusable = true}, SHIFT(754),
  [1414] = {.count = 1, .reusable = true}, SHIFT(751),
  [1416] = {.count = 1, .reusable = false}, SHIFT(752),
  [1418] = {.count = 1, .reusable = true}, SHIFT(753),
  [1420] = {.count = 1, .reusable = false}, SHIFT(751),
  [1422] = {.count = 1, .reusable = false}, SHIFT(753),
  [1424] = {.count = 1, .reusable = true}, SHIFT(755),
  [1426] = {.count = 1, .reusable = true}, SHIFT(750),
  [1428] = {.count = 1, .reusable = true}, SHIFT(756),
  [1430] = {.count = 1, .reusable = false}, SHIFT(757),
  [1432] = {.count = 1, .reusable = true}, SHIFT(758),
  [1434] = {.count = 1, .reusable = true}, SHIFT(759),
  [1436] = {.count = 1, .reusable = true}, SHIFT(760),
  [1438] = {.count = 1, .reusable = false}, SHIFT(762),
  [1440] = {.count = 1, .reusable = false}, SHIFT(763),
  [1442] = {.count = 1, .reusable = false}, SHIFT(765),
  [1444] = {.count = 1, .reusable = false}, SHIFT(766),
  [1446] = {.count = 1, .reusable = false}, SHIFT(767),
  [1448] = {.count = 1, .reusable = false}, SHIFT(586),
  [1450] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_required_parameter, 1, .alias_sequence_id = 3),
  [1453] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), SHIFT(773),
  [1456] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_required_parameter, 1, .alias_sequence_id = 4),
  [1459] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), SHIFT(776),
  [1462] = {.count = 1, .reusable = true}, SHIFT(779),
  [1464] = {.count = 1, .reusable = true}, SHIFT(780),
  [1466] = {.count = 1, .reusable = true}, SHIFT(782),
  [1468] = {.count = 1, .reusable = true}, SHIFT(783),
  [1470] = {.count = 1, .reusable = true}, SHIFT(785),
  [1472] = {.count = 1, .reusable = true}, REDUCE(sym_program, 2),
  [1474] = {.count = 1, .reusable = true}, SHIFT(788),
  [1476] = {.count = 1, .reusable = true}, SHIFT(789),
  [1478] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 2),
  [1480] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 2),
  [1482] = {.count = 1, .reusable = false}, SHIFT(790),
  [1484] = {.count = 1, .reusable = false}, SHIFT(791),
  [1486] = {.count = 1, .reusable = false}, SHIFT(795),
  [1488] = {.count = 1, .reusable = false}, SHIFT(794),
  [1490] = {.count = 1, .reusable = true}, SHIFT(796),
  [1492] = {.count = 1, .reusable = false}, SHIFT(797),
  [1494] = {.count = 1, .reusable = true}, SHIFT(798),
  [1496] = {.count = 1, .reusable = false}, SHIFT(799),
  [1498] = {.count = 1, .reusable = true}, SHIFT(800),
  [1500] = {.count = 1, .reusable = true}, SHIFT(797),
  [1502] = {.count = 2, .reusable = true}, REDUCE(sym_type_parameter, 1, .alias_sequence_id = 5), SHIFT(801),
  [1505] = {.count = 1, .reusable = true}, SHIFT(101),
  [1507] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 1, .alias_sequence_id = 5),
  [1509] = {.count = 1, .reusable = false}, SHIFT(802),
  [1511] = {.count = 1, .reusable = true}, SHIFT(803),
  [1513] = {.count = 1, .reusable = true}, SHIFT(809),
  [1515] = {.count = 1, .reusable = true}, SHIFT(801),
  [1517] = {.count = 1, .reusable = true}, SHIFT(810),
  [1519] = {.count = 1, .reusable = true}, SHIFT(811),
  [1521] = {.count = 1, .reusable = false}, SHIFT(813),
  [1523] = {.count = 1, .reusable = true}, SHIFT(814),
  [1525] = {.count = 1, .reusable = true}, SHIFT(818),
  [1527] = {.count = 1, .reusable = true}, SHIFT(821),
  [1529] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2),
  [1531] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2),
  [1533] = {.count = 1, .reusable = true}, SHIFT(824),
  [1535] = {.count = 1, .reusable = false}, SHIFT(825),
  [1537] = {.count = 1, .reusable = true}, SHIFT(827),
  [1539] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2, .alias_sequence_id = 6),
  [1541] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2, .alias_sequence_id = 6),
  [1543] = {.count = 1, .reusable = false}, SHIFT(829),
  [1545] = {.count = 1, .reusable = false}, SHIFT(836),
  [1547] = {.count = 1, .reusable = false}, SHIFT(830),
  [1549] = {.count = 1, .reusable = false}, SHIFT(831),
  [1551] = {.count = 1, .reusable = false}, SHIFT(832),
  [1553] = {.count = 1, .reusable = true}, SHIFT(836),
  [1555] = {.count = 1, .reusable = false}, SHIFT(833),
  [1557] = {.count = 1, .reusable = false}, SHIFT(834),
  [1559] = {.count = 1, .reusable = false}, SHIFT(840),
  [1561] = {.count = 1, .reusable = true}, SHIFT(840),
  [1563] = {.count = 1, .reusable = false}, SHIFT(841),
  [1565] = {.count = 1, .reusable = true}, SHIFT(841),
  [1567] = {.count = 1, .reusable = false}, SHIFT(565),
  [1569] = {.count = 1, .reusable = true}, SHIFT(565),
  [1571] = {.count = 1, .reusable = true}, SHIFT(823),
  [1573] = {.count = 1, .reusable = false}, SHIFT(823),
  [1575] = {.count = 1, .reusable = false}, SHIFT(842),
  [1577] = {.count = 1, .reusable = true}, SHIFT(843),
  [1579] = {.count = 1, .reusable = false}, SHIFT(844),
  [1581] = {.count = 1, .reusable = false}, SHIFT(843),
  [1583] = {.count = 1, .reusable = true}, SHIFT(845),
  [1585] = {.count = 1, .reusable = false}, SHIFT(845),
  [1587] = {.count = 1, .reusable = true}, SHIFT(846),
  [1589] = {.count = 1, .reusable = true}, SHIFT(842),
  [1591] = {.count = 1, .reusable = true}, SHIFT(847),
  [1593] = {.count = 1, .reusable = false}, SHIFT(848),
  [1595] = {.count = 1, .reusable = true}, SHIFT(849),
  [1597] = {.count = 1, .reusable = true}, SHIFT(851),
  [1599] = {.count = 1, .reusable = true}, SHIFT(852),
  [1601] = {.count = 1, .reusable = false}, SHIFT(854),
  [1603] = {.count = 1, .reusable = true}, SHIFT(857),
  [1605] = {.count = 1, .reusable = false}, SHIFT(855),
  [1607] = {.count = 1, .reusable = false}, SHIFT(867),
  [1609] = {.count = 1, .reusable = false}, SHIFT(856),
  [1611] = {.count = 1, .reusable = false}, SHIFT(857),
  [1613] = {.count = 1, .reusable = false}, SHIFT(858),
  [1615] = {.count = 1, .reusable = false}, SHIFT(859),
  [1617] = {.count = 1, .reusable = false}, SHIFT(860),
  [1619] = {.count = 1, .reusable = true}, SHIFT(861),
  [1621] = {.count = 1, .reusable = true}, SHIFT(867),
  [1623] = {.count = 1, .reusable = false}, SHIFT(862),
  [1625] = {.count = 1, .reusable = false}, SHIFT(863),
  [1627] = {.count = 1, .reusable = false}, SHIFT(864),
  [1629] = {.count = 1, .reusable = false}, SHIFT(865),
  [1631] = {.count = 1, .reusable = true}, SHIFT(871),
  [1633] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 2),
  [1635] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 2),
  [1637] = {.count = 1, .reusable = true}, SHIFT(872),
  [1639] = {.count = 1, .reusable = true}, SHIFT(873),
  [1641] = {.count = 1, .reusable = true}, SHIFT(875),
  [1643] = {.count = 1, .reusable = true}, SHIFT(876),
  [1645] = {.count = 1, .reusable = true}, SHIFT(877),
  [1647] = {.count = 1, .reusable = true}, SHIFT(304),
  [1649] = {.count = 1, .reusable = true}, SHIFT(884),
  [1651] = {.count = 1, .reusable = true}, SHIFT(878),
  [1653] = {.count = 1, .reusable = true}, SHIFT(879),
  [1655] = {.count = 1, .reusable = true}, SHIFT(880),
  [1657] = {.count = 1, .reusable = true}, SHIFT(881),
  [1659] = {.count = 1, .reusable = true}, SHIFT(882),
  [1661] = {.count = 1, .reusable = true}, SHIFT(883),
  [1663] = {.count = 1, .reusable = true}, SHIFT(887),
  [1665] = {.count = 1, .reusable = true}, SHIFT(889),
  [1667] = {.count = 1, .reusable = true}, SHIFT(890),
  [1669] = {.count = 1, .reusable = true}, REDUCE(sym_call_signature, 2),
  [1671] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2),
  [1674] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3),
  [1677] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [1680] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [1683] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(6),
  [1686] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(7),
  [1689] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(8),
  [1692] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(9),
  [1695] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(10),
  [1698] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(11),
  [1701] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(12),
  [1704] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(13),
  [1707] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(14),
  [1710] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(15),
  [1713] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(16),
  [1716] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(17),
  [1719] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(18),
  [1722] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(19),
  [1725] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(20),
  [1728] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(59),
  [1731] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(21),
  [1734] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(22),
  [1737] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(23),
  [1740] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(24),
  [1743] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(25),
  [1746] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(26),
  [1749] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(27),
  [1752] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(15),
  [1755] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(28),
  [1758] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(29),
  [1761] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(30),
  [1764] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(31),
  [1767] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(32),
  [1770] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(33),
  [1773] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(34),
  [1776] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(35),
  [1779] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(36),
  [1782] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(37),
  [1785] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(38),
  [1788] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(40),
  [1791] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(41),
  [1794] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(42),
  [1797] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(43),
  [1800] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(59),
  [1803] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(44),
  [1806] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(45),
  [1809] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(46),
  [1812] = {.count = 1, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2),
  [1814] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(47),
  [1817] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(48),
  [1820] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(49),
  [1823] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(50),
  [1826] = {.count = 1, .reusable = true}, SHIFT(893),
  [1828] = {.count = 1, .reusable = false}, SHIFT(894),
  [1830] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2),
  [1832] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2), SHIFT_REPEAT(6),
  [1835] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 3),
  [1837] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 3),
  [1839] = {.count = 1, .reusable = false}, SHIFT(896),
  [1841] = {.count = 1, .reusable = true}, SHIFT(897),
  [1843] = {.count = 1, .reusable = true}, SHIFT(898),
  [1845] = {.count = 1, .reusable = false}, SHIFT(899),
  [1847] = {.count = 1, .reusable = true}, SHIFT(900),
  [1849] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 2),
  [1851] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [1853] = {.count = 1, .reusable = true}, REDUCE(sym_non_null_expression, 2),
  [1855] = {.count = 1, .reusable = false}, REDUCE(sym_non_null_expression, 2),
  [1857] = {.count = 1, .reusable = false}, SHIFT(904),
  [1859] = {.count = 1, .reusable = true}, SHIFT(904),
  [1861] = {.count = 1, .reusable = false}, SHIFT(905),
  [1863] = {.count = 1, .reusable = true}, SHIFT(905),
  [1865] = {.count = 1, .reusable = false}, SHIFT(906),
  [1867] = {.count = 1, .reusable = true}, SHIFT(906),
  [1869] = {.count = 1, .reusable = false}, SHIFT(907),
  [1871] = {.count = 1, .reusable = true}, SHIFT(907),
  [1873] = {.count = 1, .reusable = false}, SHIFT(908),
  [1875] = {.count = 1, .reusable = true}, SHIFT(908),
  [1877] = {.count = 1, .reusable = true}, SHIFT(912),
  [1879] = {.count = 1, .reusable = false}, SHIFT(910),
  [1881] = {.count = 1, .reusable = false}, SHIFT(922),
  [1883] = {.count = 1, .reusable = false}, SHIFT(911),
  [1885] = {.count = 1, .reusable = false}, SHIFT(912),
  [1887] = {.count = 1, .reusable = false}, SHIFT(913),
  [1889] = {.count = 1, .reusable = false}, SHIFT(914),
  [1891] = {.count = 1, .reusable = false}, SHIFT(915),
  [1893] = {.count = 1, .reusable = true}, SHIFT(916),
  [1895] = {.count = 1, .reusable = true}, SHIFT(922),
  [1897] = {.count = 1, .reusable = false}, SHIFT(917),
  [1899] = {.count = 1, .reusable = false}, SHIFT(918),
  [1901] = {.count = 1, .reusable = false}, SHIFT(919),
  [1903] = {.count = 1, .reusable = false}, SHIFT(920),
  [1905] = {.count = 1, .reusable = false}, SHIFT(926),
  [1907] = {.count = 1, .reusable = false}, SHIFT(927),
  [1909] = {.count = 1, .reusable = true}, SHIFT(930),
  [1911] = {.count = 1, .reusable = false}, SHIFT(931),
  [1913] = {.count = 1, .reusable = false}, SHIFT(933),
  [1915] = {.count = 1, .reusable = false}, SHIFT(934),
  [1917] = {.count = 1, .reusable = true}, SHIFT(935),
  [1919] = {.count = 1, .reusable = true}, SHIFT(936),
  [1921] = {.count = 1, .reusable = false}, SHIFT(929),
  [1923] = {.count = 1, .reusable = true}, SHIFT(940),
  [1925] = {.count = 1, .reusable = true}, SHIFT(939),
  [1927] = {.count = 1, .reusable = true}, SHIFT(929),
  [1929] = {.count = 1, .reusable = true}, SHIFT(932),
  [1931] = {.count = 1, .reusable = true}, SHIFT(928),
  [1933] = {.count = 1, .reusable = false}, SHIFT(937),
  [1935] = {.count = 1, .reusable = true}, SHIFT(927),
  [1937] = {.count = 1, .reusable = false}, SHIFT(938),
  [1939] = {.count = 1, .reusable = false}, SHIFT(948),
  [1941] = {.count = 1, .reusable = false}, SHIFT(949),
  [1943] = {.count = 1, .reusable = true}, SHIFT(950),
  [1945] = {.count = 1, .reusable = false}, SHIFT(951),
  [1947] = {.count = 1, .reusable = false}, SHIFT(952),
  [1949] = {.count = 1, .reusable = false}, SHIFT(953),
  [1951] = {.count = 1, .reusable = false}, SHIFT(954),
  [1953] = {.count = 1, .reusable = false}, SHIFT(955),
  [1955] = {.count = 1, .reusable = true}, SHIFT(956),
  [1957] = {.count = 1, .reusable = true}, SHIFT(949),
  [1959] = {.count = 1, .reusable = false}, SHIFT(957),
  [1961] = {.count = 1, .reusable = false}, SHIFT(958),
  [1963] = {.count = 1, .reusable = false}, SHIFT(961),
  [1965] = {.count = 1, .reusable = true}, SHIFT(961),
  [1967] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 4),
  [1969] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 4),
  [1971] = {.count = 1, .reusable = false}, SHIFT(962),
  [1973] = {.count = 1, .reusable = false}, SHIFT(963),
  [1975] = {.count = 1, .reusable = true}, SHIFT(964),
  [1977] = {.count = 1, .reusable = false}, SHIFT(969),
  [1979] = {.count = 1, .reusable = true}, SHIFT(967),
  [1981] = {.count = 1, .reusable = true}, SHIFT(968),
  [1983] = {.count = 1, .reusable = true}, SHIFT(969),
  [1985] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_element, 2),
  [1987] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_element, 2),
  [1989] = {.count = 1, .reusable = false}, SHIFT(973),
  [1991] = {.count = 1, .reusable = false}, SHIFT(971),
  [1993] = {.count = 1, .reusable = false}, SHIFT(975),
  [1995] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3),
  [1997] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3),
  [1999] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3),
  [2001] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3),
  [2003] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3),
  [2005] = {.count = 1, .reusable = true}, REDUCE(sym__initializer, 2),
  [2007] = {.count = 1, .reusable = false}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .alias_sequence_id = 7),
  [2009] = {.count = 1, .reusable = true}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .alias_sequence_id = 7),
  [2011] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .alias_sequence_id = 8),
  [2013] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .alias_sequence_id = 8),
  [2015] = {.count = 1, .reusable = true}, SHIFT(979),
  [2017] = {.count = 1, .reusable = false}, SHIFT(980),
  [2019] = {.count = 1, .reusable = true}, SHIFT(977),
  [2021] = {.count = 1, .reusable = false}, SHIFT(978),
  [2023] = {.count = 1, .reusable = true}, SHIFT(982),
  [2025] = {.count = 1, .reusable = true}, SHIFT(981),
  [2027] = {.count = 1, .reusable = false}, SHIFT(983),
  [2029] = {.count = 1, .reusable = true}, SHIFT(983),
  [2031] = {.count = 1, .reusable = false}, SHIFT(984),
  [2033] = {.count = 1, .reusable = true}, SHIFT(984),
  [2035] = {.count = 1, .reusable = false}, SHIFT(985),
  [2037] = {.count = 1, .reusable = false}, SHIFT(986),
  [2039] = {.count = 1, .reusable = false}, SHIFT(987),
  [2041] = {.count = 1, .reusable = true}, SHIFT(987),
  [2043] = {.count = 1, .reusable = false}, SHIFT(988),
  [2045] = {.count = 1, .reusable = true}, SHIFT(988),
  [2047] = {.count = 1, .reusable = false}, SHIFT(989),
  [2049] = {.count = 1, .reusable = false}, SHIFT(990),
  [2051] = {.count = 1, .reusable = false}, SHIFT(991),
  [2053] = {.count = 1, .reusable = false}, SHIFT(992),
  [2055] = {.count = 1, .reusable = false}, SHIFT(993),
  [2057] = {.count = 1, .reusable = false}, SHIFT(994),
  [2059] = {.count = 1, .reusable = true}, SHIFT(994),
  [2061] = {.count = 1, .reusable = true}, SHIFT(978),
  [2063] = {.count = 1, .reusable = false}, SHIFT(995),
  [2065] = {.count = 1, .reusable = true}, SHIFT(999),
  [2067] = {.count = 1, .reusable = true}, SHIFT(996),
  [2069] = {.count = 1, .reusable = false}, SHIFT(997),
  [2071] = {.count = 1, .reusable = true}, SHIFT(998),
  [2073] = {.count = 1, .reusable = false}, SHIFT(996),
  [2075] = {.count = 1, .reusable = false}, SHIFT(998),
  [2077] = {.count = 1, .reusable = true}, SHIFT(1000),
  [2079] = {.count = 1, .reusable = true}, SHIFT(1001),
  [2081] = {.count = 1, .reusable = true}, SHIFT(995),
  [2083] = {.count = 1, .reusable = true}, SHIFT(1002),
  [2085] = {.count = 1, .reusable = false}, SHIFT(1003),
  [2087] = {.count = 1, .reusable = true}, SHIFT(1004),
  [2089] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 3),
  [2091] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 3),
  [2093] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(72),
  [2096] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(368),
  [2099] = {.count = 1, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2),
  [2101] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .alias_sequence_id = 1),
  [2103] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .alias_sequence_id = 1),
  [2105] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .alias_sequence_id = 1),
  [2107] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .alias_sequence_id = 9),
  [2109] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .alias_sequence_id = 9),
  [2111] = {.count = 1, .reusable = true}, SHIFT(1005),
  [2113] = {.count = 1, .reusable = false}, SHIFT(1007),
  [2115] = {.count = 1, .reusable = true}, SHIFT(1006),
  [2117] = {.count = 1, .reusable = true}, SHIFT(1007),
  [2119] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_call_expression, 2),
  [2121] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_call_expression, 2),
  [2123] = {.count = 1, .reusable = true}, SHIFT(980),
  [2125] = {.count = 1, .reusable = false}, SHIFT(1011),
  [2127] = {.count = 1, .reusable = true}, SHIFT(1011),
  [2129] = {.count = 1, .reusable = true}, SHIFT(1015),
  [2131] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 3, .alias_sequence_id = 10),
  [2133] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 3, .alias_sequence_id = 10),
  [2135] = {.count = 1, .reusable = false}, SHIFT(1016),
  [2137] = {.count = 1, .reusable = false}, SHIFT(1017),
  [2139] = {.count = 1, .reusable = true}, SHIFT(1018),
  [2141] = {.count = 1, .reusable = true}, SHIFT(1019),
  [2143] = {.count = 1, .reusable = true}, SHIFT(1020),
  [2145] = {.count = 1, .reusable = true}, SHIFT(1021),
  [2147] = {.count = 1, .reusable = false}, SHIFT(1022),
  [2149] = {.count = 1, .reusable = false}, SHIFT(1023),
  [2151] = {.count = 1, .reusable = false}, SHIFT(1024),
  [2153] = {.count = 1, .reusable = true}, SHIFT(1025),
  [2155] = {.count = 1, .reusable = true}, SHIFT(1026),
  [2157] = {.count = 1, .reusable = false}, SHIFT(1027),
  [2159] = {.count = 1, .reusable = true}, SHIFT(1017),
  [2161] = {.count = 1, .reusable = false}, SHIFT(1019),
  [2163] = {.count = 1, .reusable = false}, SHIFT(1028),
  [2165] = {.count = 1, .reusable = true}, SHIFT(1029),
  [2167] = {.count = 1, .reusable = true}, SHIFT(1030),
  [2169] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2),
  [2171] = {.count = 1, .reusable = true}, SHIFT(1038),
  [2173] = {.count = 1, .reusable = true}, SHIFT(1041),
  [2175] = {.count = 1, .reusable = true}, SHIFT(1044),
  [2177] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 3),
  [2179] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 3),
  [2181] = {.count = 1, .reusable = true}, SHIFT(1047),
  [2183] = {.count = 1, .reusable = false}, SHIFT(1049),
  [2185] = {.count = 1, .reusable = true}, SHIFT(1050),
  [2187] = {.count = 1, .reusable = true}, SHIFT(1051),
  [2189] = {.count = 1, .reusable = false}, SHIFT(1052),
  [2191] = {.count = 1, .reusable = true}, SHIFT(1053),
  [2193] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .alias_sequence_id = 4),
  [2195] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .alias_sequence_id = 3),
  [2197] = {.count = 1, .reusable = true}, SHIFT(1059),
  [2199] = {.count = 1, .reusable = true}, SHIFT(1060),
  [2201] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(1061),
  [2204] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5),
  [2206] = {.count = 1, .reusable = true}, SHIFT(1062),
  [2208] = {.count = 1, .reusable = true}, SHIFT(1063),
  [2210] = {.count = 1, .reusable = false}, REDUCE(sym_literal_type, 1),
  [2212] = {.count = 1, .reusable = true}, REDUCE(sym_literal_type, 1),
  [2214] = {.count = 1, .reusable = true}, SHIFT(1065),
  [2216] = {.count = 1, .reusable = true}, SHIFT(1067),
  [2218] = {.count = 1, .reusable = true}, SHIFT(1068),
  [2220] = {.count = 1, .reusable = true}, SHIFT(1069),
  [2222] = {.count = 1, .reusable = false}, SHIFT(1070),
  [2224] = {.count = 1, .reusable = false}, SHIFT(1072),
  [2226] = {.count = 1, .reusable = true}, SHIFT(1073),
  [2228] = {.count = 1, .reusable = false}, SHIFT(1071),
  [2230] = {.count = 1, .reusable = true}, SHIFT(1078),
  [2232] = {.count = 1, .reusable = false}, SHIFT(1074),
  [2234] = {.count = 1, .reusable = false}, SHIFT(1075),
  [2236] = {.count = 1, .reusable = false}, SHIFT(1076),
  [2238] = {.count = 1, .reusable = false}, SHIFT(1083),
  [2240] = {.count = 1, .reusable = true}, SHIFT(1084),
  [2242] = {.count = 1, .reusable = true}, SHIFT(1085),
  [2244] = {.count = 1, .reusable = false}, SHIFT(1086),
  [2246] = {.count = 1, .reusable = true}, SHIFT(1087),
  [2248] = {.count = 1, .reusable = false}, REDUCE(sym_predefined_type, 1),
  [2250] = {.count = 1, .reusable = true}, REDUCE(sym_predefined_type, 1),
  [2252] = {.count = 1, .reusable = false}, REDUCE(sym_this_type, 1),
  [2254] = {.count = 1, .reusable = true}, REDUCE(sym_this_type, 1),
  [2256] = {.count = 1, .reusable = true}, SHIFT(1092),
  [2258] = {.count = 1, .reusable = true}, SHIFT(1093),
  [2260] = {.count = 1, .reusable = false}, REDUCE(sym_existential_type, 1),
  [2262] = {.count = 1, .reusable = true}, REDUCE(sym_existential_type, 1),
  [2264] = {.count = 1, .reusable = true}, SHIFT(1094),
  [2266] = {.count = 1, .reusable = true}, SHIFT(1098),
  [2268] = {.count = 1, .reusable = false}, SHIFT(1099),
  [2270] = {.count = 1, .reusable = false}, SHIFT(1100),
  [2272] = {.count = 1, .reusable = false}, SHIFT(1101),
  [2274] = {.count = 1, .reusable = true}, SHIFT(1102),
  [2276] = {.count = 1, .reusable = true}, SHIFT(1103),
  [2278] = {.count = 1, .reusable = true}, SHIFT(1104),
  [2280] = {.count = 1, .reusable = false}, SHIFT(1105),
  [2282] = {.count = 1, .reusable = false}, SHIFT(1106),
  [2284] = {.count = 1, .reusable = true}, SHIFT(1111),
  [2286] = {.count = 1, .reusable = true}, SHIFT(1112),
  [2288] = {.count = 1, .reusable = true}, SHIFT(1113),
  [2290] = {.count = 1, .reusable = true}, SHIFT(1114),
  [2292] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1),
  [2294] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(1116),
  [2297] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1),
  [2299] = {.count = 1, .reusable = false}, REDUCE(sym__type, 1),
  [2301] = {.count = 1, .reusable = true}, REDUCE(sym__type, 1),
  [2303] = {.count = 1, .reusable = true}, SHIFT(1119),
  [2305] = {.count = 1, .reusable = true}, SHIFT(1120),
  [2307] = {.count = 1, .reusable = true}, SHIFT(1123),
  [2309] = {.count = 1, .reusable = true}, SHIFT(1121),
  [2311] = {.count = 1, .reusable = false}, SHIFT(1122),
  [2313] = {.count = 1, .reusable = true}, SHIFT(1125),
  [2315] = {.count = 1, .reusable = true}, SHIFT(1124),
  [2317] = {.count = 1, .reusable = false}, SHIFT(1126),
  [2319] = {.count = 1, .reusable = true}, SHIFT(1126),
  [2321] = {.count = 1, .reusable = false}, SHIFT(1127),
  [2323] = {.count = 1, .reusable = true}, SHIFT(1127),
  [2325] = {.count = 1, .reusable = false}, SHIFT(1128),
  [2327] = {.count = 1, .reusable = true}, SHIFT(1128),
  [2329] = {.count = 1, .reusable = false}, SHIFT(1129),
  [2331] = {.count = 1, .reusable = true}, SHIFT(1129),
  [2333] = {.count = 1, .reusable = false}, SHIFT(1130),
  [2335] = {.count = 1, .reusable = false}, SHIFT(1131),
  [2337] = {.count = 1, .reusable = false}, SHIFT(1132),
  [2339] = {.count = 1, .reusable = true}, SHIFT(1132),
  [2341] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 2),
  [2343] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 2),
  [2345] = {.count = 1, .reusable = false}, SHIFT(1133),
  [2347] = {.count = 1, .reusable = true}, SHIFT(1133),
  [2349] = {.count = 1, .reusable = false}, SHIFT(1134),
  [2351] = {.count = 1, .reusable = false}, SHIFT(1135),
  [2353] = {.count = 1, .reusable = false}, SHIFT(1136),
  [2355] = {.count = 1, .reusable = false}, SHIFT(1137),
  [2357] = {.count = 1, .reusable = false}, SHIFT(1138),
  [2359] = {.count = 1, .reusable = false}, SHIFT(1139),
  [2361] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2363] = {.count = 1, .reusable = true}, SHIFT(1122),
  [2365] = {.count = 1, .reusable = false}, SHIFT(1140),
  [2367] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2369] = {.count = 1, .reusable = false}, SHIFT(1141),
  [2371] = {.count = 1, .reusable = true}, SHIFT(1143),
  [2373] = {.count = 1, .reusable = false}, SHIFT(1142),
  [2375] = {.count = 1, .reusable = false}, SHIFT(1143),
  [2377] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2379] = {.count = 1, .reusable = true}, SHIFT(1140),
  [2381] = {.count = 1, .reusable = true}, SHIFT(1145),
  [2383] = {.count = 1, .reusable = false}, SHIFT(1146),
  [2385] = {.count = 1, .reusable = true}, SHIFT(1147),
  [2387] = {.count = 1, .reusable = true}, SHIFT(1148),
  [2389] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 3),
  [2391] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 3),
  [2393] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 3),
  [2395] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 3),
  [2397] = {.count = 1, .reusable = true}, SHIFT(1153),
  [2399] = {.count = 1, .reusable = false}, SHIFT(1151),
  [2401] = {.count = 1, .reusable = false}, SHIFT(1163),
  [2403] = {.count = 1, .reusable = false}, SHIFT(1152),
  [2405] = {.count = 1, .reusable = false}, SHIFT(1153),
  [2407] = {.count = 1, .reusable = false}, SHIFT(1154),
  [2409] = {.count = 1, .reusable = false}, SHIFT(1155),
  [2411] = {.count = 1, .reusable = false}, SHIFT(1156),
  [2413] = {.count = 1, .reusable = true}, SHIFT(1157),
  [2415] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2417] = {.count = 1, .reusable = false}, SHIFT(1158),
  [2419] = {.count = 1, .reusable = false}, SHIFT(1159),
  [2421] = {.count = 1, .reusable = false}, SHIFT(1160),
  [2423] = {.count = 1, .reusable = false}, SHIFT(1161),
  [2425] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 3, .alias_sequence_id = 11),
  [2427] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 3, .alias_sequence_id = 11),
  [2429] = {.count = 1, .reusable = true}, SHIFT(1171),
  [2431] = {.count = 1, .reusable = true}, SHIFT(1172),
  [2433] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 3),
  [2435] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 3),
  [2437] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 3, .alias_sequence_id = 10),
  [2439] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 3, .alias_sequence_id = 10),
  [2441] = {.count = 1, .reusable = true}, SHIFT(1174),
  [2443] = {.count = 1, .reusable = true}, SHIFT(1176),
  [2445] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2447] = {.count = 1, .reusable = true}, SHIFT(1179),
  [2449] = {.count = 1, .reusable = true}, SHIFT(1180),
  [2451] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2453] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2455] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 3),
  [2457] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 3),
  [2459] = {.count = 1, .reusable = false}, SHIFT(1186),
  [2461] = {.count = 1, .reusable = true}, SHIFT(1187),
  [2463] = {.count = 1, .reusable = false}, REDUCE(sym_throw_statement, 3),
  [2465] = {.count = 1, .reusable = true}, REDUCE(sym_throw_statement, 3),
  [2467] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2469] = {.count = 1, .reusable = false}, SHIFT(1192),
  [2471] = {.count = 1, .reusable = true}, SHIFT(1193),
  [2473] = {.count = 1, .reusable = true}, SHIFT(1194),
  [2475] = {.count = 1, .reusable = false}, SHIFT(1195),
  [2477] = {.count = 1, .reusable = true}, SHIFT(1196),
  [2479] = {.count = 1, .reusable = true}, SHIFT(1200),
  [2481] = {.count = 1, .reusable = false}, SHIFT(1202),
  [2483] = {.count = 1, .reusable = false}, SHIFT(1203),
  [2485] = {.count = 1, .reusable = true}, SHIFT(1204),
  [2487] = {.count = 1, .reusable = true}, SHIFT(1205),
  [2489] = {.count = 1, .reusable = true}, SHIFT(1207),
  [2491] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 1),
  [2493] = {.count = 1, .reusable = true}, SHIFT(1208),
  [2495] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 2),
  [2497] = {.count = 1, .reusable = true}, SHIFT(1209),
  [2499] = {.count = 1, .reusable = true}, SHIFT(1210),
  [2501] = {.count = 1, .reusable = true}, SHIFT(1211),
  [2503] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2505] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 3),
  [2507] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 3),
  [2509] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2511] = {.count = 1, .reusable = true}, SHIFT(1216),
  [2513] = {.count = 1, .reusable = true}, REDUCE(sym__module, 2),
  [2515] = {.count = 1, .reusable = false}, REDUCE(sym__module, 2),
  [2517] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [2519] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [2521] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(507),
  [2524] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [2526] = {.count = 1, .reusable = false}, SHIFT(1218),
  [2528] = {.count = 1, .reusable = false}, SHIFT(1217),
  [2530] = {.count = 1, .reusable = true}, SHIFT(1222),
  [2532] = {.count = 1, .reusable = false}, SHIFT(1221),
  [2534] = {.count = 1, .reusable = true}, SHIFT(1223),
  [2536] = {.count = 1, .reusable = true}, SHIFT(1227),
  [2538] = {.count = 1, .reusable = false}, SHIFT(1228),
  [2540] = {.count = 1, .reusable = true}, SHIFT(1229),
  [2542] = {.count = 1, .reusable = false}, SHIFT(1230),
  [2544] = {.count = 1, .reusable = false}, SHIFT(1231),
  [2546] = {.count = 1, .reusable = false}, SHIFT(1234),
  [2548] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2550] = {.count = 1, .reusable = true}, SHIFT(1234),
  [2552] = {.count = 1, .reusable = false}, SHIFT(1235),
  [2554] = {.count = 1, .reusable = true}, SHIFT(1235),
  [2556] = {.count = 1, .reusable = false}, SHIFT(1236),
  [2558] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2560] = {.count = 1, .reusable = false}, SHIFT(1237),
  [2562] = {.count = 1, .reusable = true}, SHIFT(1237),
  [2564] = {.count = 1, .reusable = true}, SHIFT(1238),
  [2566] = {.count = 1, .reusable = true}, SHIFT(1239),
  [2568] = {.count = 1, .reusable = false}, SHIFT(1241),
  [2570] = {.count = 1, .reusable = true}, SHIFT(1241),
  [2572] = {.count = 1, .reusable = false}, SHIFT(1242),
  [2574] = {.count = 1, .reusable = true}, SHIFT(1242),
  [2576] = {.count = 1, .reusable = true}, SHIFT(1243),
  [2578] = {.count = 1, .reusable = true}, SHIFT(1247),
  [2580] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(583),
  [2583] = {.count = 1, .reusable = true}, REDUCE(sym_spread_element, 2),
  [2585] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2),
  [2587] = {.count = 1, .reusable = true}, SHIFT(1250),
  [2589] = {.count = 1, .reusable = false}, SHIFT(1252),
  [2591] = {.count = 1, .reusable = true}, SHIFT(1252),
  [2593] = {.count = 1, .reusable = true}, SHIFT(1255),
  [2595] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2597] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2599] = {.count = 1, .reusable = false}, SHIFT(1260),
  [2601] = {.count = 1, .reusable = false}, SHIFT(1259),
  [2603] = {.count = 1, .reusable = false}, SHIFT(1261),
  [2605] = {.count = 1, .reusable = false}, SHIFT(1263),
  [2607] = {.count = 1, .reusable = true}, SHIFT(1264),
  [2609] = {.count = 1, .reusable = true}, SHIFT(1266),
  [2611] = {.count = 1, .reusable = true}, SHIFT(1269),
  [2613] = {.count = 1, .reusable = false}, SHIFT(1266),
  [2615] = {.count = 1, .reusable = true}, SHIFT(1271),
  [2617] = {.count = 1, .reusable = false}, SHIFT(1273),
  [2619] = {.count = 1, .reusable = true}, SHIFT(1273),
  [2621] = {.count = 1, .reusable = false}, SHIFT(1274),
  [2623] = {.count = 1, .reusable = true}, SHIFT(1274),
  [2625] = {.count = 1, .reusable = false}, SHIFT(1275),
  [2627] = {.count = 1, .reusable = true}, SHIFT(1275),
  [2629] = {.count = 1, .reusable = false}, SHIFT(1276),
  [2631] = {.count = 1, .reusable = true}, SHIFT(1276),
  [2633] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [2635] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [2637] = {.count = 1, .reusable = false}, SHIFT(1277),
  [2639] = {.count = 1, .reusable = true}, SHIFT(1277),
  [2641] = {.count = 1, .reusable = false}, SHIFT(1278),
  [2643] = {.count = 1, .reusable = false}, SHIFT(1279),
  [2645] = {.count = 1, .reusable = true}, SHIFT(1282),
  [2647] = {.count = 1, .reusable = false}, SHIFT(1283),
  [2649] = {.count = 1, .reusable = false}, SHIFT(1285),
  [2651] = {.count = 1, .reusable = false}, SHIFT(1286),
  [2653] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2655] = {.count = 1, .reusable = true}, SHIFT(1288),
  [2657] = {.count = 1, .reusable = false}, SHIFT(1281),
  [2659] = {.count = 1, .reusable = true}, SHIFT(1292),
  [2661] = {.count = 1, .reusable = true}, SHIFT(1291),
  [2663] = {.count = 1, .reusable = true}, SHIFT(1281),
  [2665] = {.count = 1, .reusable = true}, SHIFT(1284),
  [2667] = {.count = 1, .reusable = true}, SHIFT(1280),
  [2669] = {.count = 1, .reusable = false}, SHIFT(1289),
  [2671] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2673] = {.count = 1, .reusable = false}, SHIFT(1290),
  [2675] = {.count = 1, .reusable = false}, SHIFT(1300),
  [2677] = {.count = 1, .reusable = false}, SHIFT(1301),
  [2679] = {.count = 1, .reusable = false}, SHIFT(1302),
  [2681] = {.count = 1, .reusable = false}, SHIFT(1303),
  [2683] = {.count = 1, .reusable = false}, SHIFT(1304),
  [2685] = {.count = 1, .reusable = false}, SHIFT(1305),
  [2687] = {.count = 1, .reusable = false}, SHIFT(1306),
  [2689] = {.count = 1, .reusable = true}, SHIFT(1307),
  [2691] = {.count = 1, .reusable = true}, SHIFT(1301),
  [2693] = {.count = 1, .reusable = false}, SHIFT(1308),
  [2695] = {.count = 1, .reusable = false}, SHIFT(1309),
  [2697] = {.count = 1, .reusable = false}, SHIFT(1310),
  [2699] = {.count = 1, .reusable = true}, SHIFT(1310),
  [2701] = {.count = 1, .reusable = true}, SHIFT(1311),
  [2703] = {.count = 1, .reusable = false}, SHIFT(1312),
  [2705] = {.count = 2, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(143),
  [2708] = {.count = 1, .reusable = false}, SHIFT(1314),
  [2710] = {.count = 1, .reusable = true}, SHIFT(1316),
  [2712] = {.count = 1, .reusable = false}, SHIFT(1317),
  [2714] = {.count = 1, .reusable = true}, SHIFT(1320),
  [2716] = {.count = 1, .reusable = true}, REDUCE(sym__type_reference, 1, .alias_sequence_id = 5),
  [2718] = {.count = 1, .reusable = false}, SHIFT(1322),
  [2720] = {.count = 1, .reusable = true}, SHIFT(1318),
  [2722] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(1321),
  [2725] = {.count = 1, .reusable = true}, SHIFT(1323),
  [2727] = {.count = 1, .reusable = false}, SHIFT(1319),
  [2729] = {.count = 1, .reusable = true}, SHIFT(1325),
  [2731] = {.count = 1, .reusable = true}, SHIFT(1324),
  [2733] = {.count = 1, .reusable = false}, SHIFT(1326),
  [2735] = {.count = 1, .reusable = false}, SHIFT(1327),
  [2737] = {.count = 1, .reusable = true}, SHIFT(1327),
  [2739] = {.count = 1, .reusable = false}, SHIFT(1328),
  [2741] = {.count = 1, .reusable = true}, SHIFT(1328),
  [2743] = {.count = 1, .reusable = false}, SHIFT(1329),
  [2745] = {.count = 1, .reusable = false}, SHIFT(1330),
  [2747] = {.count = 1, .reusable = false}, SHIFT(1331),
  [2749] = {.count = 1, .reusable = true}, SHIFT(1331),
  [2751] = {.count = 1, .reusable = false}, SHIFT(1332),
  [2753] = {.count = 1, .reusable = true}, SHIFT(1332),
  [2755] = {.count = 1, .reusable = false}, SHIFT(1333),
  [2757] = {.count = 1, .reusable = false}, SHIFT(1334),
  [2759] = {.count = 1, .reusable = false}, SHIFT(1335),
  [2761] = {.count = 1, .reusable = false}, SHIFT(1336),
  [2763] = {.count = 1, .reusable = false}, SHIFT(1337),
  [2765] = {.count = 1, .reusable = false}, SHIFT(1338),
  [2767] = {.count = 1, .reusable = false}, SHIFT(1339),
  [2769] = {.count = 1, .reusable = true}, SHIFT(1339),
  [2771] = {.count = 1, .reusable = true}, SHIFT(1319),
  [2773] = {.count = 1, .reusable = false}, SHIFT(1340),
  [2775] = {.count = 1, .reusable = true}, SHIFT(1343),
  [2777] = {.count = 1, .reusable = true}, SHIFT(1341),
  [2779] = {.count = 1, .reusable = false}, SHIFT(1342),
  [2781] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 2),
  [2783] = {.count = 1, .reusable = true}, SHIFT(1344),
  [2785] = {.count = 1, .reusable = false}, SHIFT(1343),
  [2787] = {.count = 1, .reusable = false}, SHIFT(1344),
  [2789] = {.count = 1, .reusable = true}, SHIFT(1345),
  [2791] = {.count = 1, .reusable = true}, SHIFT(1340),
  [2793] = {.count = 1, .reusable = true}, SHIFT(1346),
  [2795] = {.count = 1, .reusable = false}, SHIFT(1347),
  [2797] = {.count = 1, .reusable = true}, SHIFT(1348),
  [2799] = {.count = 1, .reusable = true}, REDUCE(sym__type_reference, 1),
  [2801] = {.count = 1, .reusable = true}, SHIFT(1321),
  [2803] = {.count = 1, .reusable = true}, SHIFT(1350),
  [2805] = {.count = 1, .reusable = true}, SHIFT(1354),
  [2807] = {.count = 1, .reusable = true}, SHIFT(1355),
  [2809] = {.count = 1, .reusable = true}, SHIFT(1353),
  [2811] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 2),
  [2813] = {.count = 1, .reusable = true}, SHIFT(1358),
  [2815] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .alias_sequence_id = 11),
  [2817] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .alias_sequence_id = 11),
  [2819] = {.count = 1, .reusable = true}, SHIFT(1363),
  [2821] = {.count = 1, .reusable = false}, SHIFT(1361),
  [2823] = {.count = 1, .reusable = false}, SHIFT(1373),
  [2825] = {.count = 1, .reusable = false}, SHIFT(1362),
  [2827] = {.count = 1, .reusable = false}, SHIFT(1363),
  [2829] = {.count = 1, .reusable = false}, SHIFT(1364),
  [2831] = {.count = 1, .reusable = false}, SHIFT(1365),
  [2833] = {.count = 1, .reusable = false}, SHIFT(1366),
  [2835] = {.count = 1, .reusable = true}, SHIFT(1367),
  [2837] = {.count = 1, .reusable = true}, SHIFT(1373),
  [2839] = {.count = 1, .reusable = false}, SHIFT(1368),
  [2841] = {.count = 1, .reusable = false}, SHIFT(1369),
  [2843] = {.count = 1, .reusable = false}, SHIFT(1370),
  [2845] = {.count = 1, .reusable = false}, SHIFT(1371),
  [2847] = {.count = 1, .reusable = true}, SHIFT(1377),
  [2849] = {.count = 1, .reusable = true}, SHIFT(1379),
  [2851] = {.count = 1, .reusable = false}, SHIFT(1378),
  [2853] = {.count = 1, .reusable = false}, SHIFT(1380),
  [2855] = {.count = 1, .reusable = true}, SHIFT(1381),
  [2857] = {.count = 1, .reusable = false}, SHIFT(1383),
  [2859] = {.count = 1, .reusable = true}, SHIFT(1384),
  [2861] = {.count = 1, .reusable = false}, SHIFT(1382),
  [2863] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 2),
  [2865] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 2),
  [2867] = {.count = 1, .reusable = true}, SHIFT(1386),
  [2869] = {.count = 1, .reusable = false}, SHIFT(1385),
  [2871] = {.count = 1, .reusable = false}, SHIFT(1387),
  [2873] = {.count = 1, .reusable = true}, SHIFT(1390),
  [2875] = {.count = 1, .reusable = true}, SHIFT(1389),
  [2877] = {.count = 1, .reusable = false}, SHIFT(1388),
  [2879] = {.count = 1, .reusable = true}, SHIFT(1391),
  [2881] = {.count = 1, .reusable = true}, SHIFT(1392),
  [2883] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 1),
  [2885] = {.count = 1, .reusable = true}, SHIFT(1393),
  [2887] = {.count = 1, .reusable = true}, SHIFT(1394),
  [2889] = {.count = 1, .reusable = false}, SHIFT(1402),
  [2891] = {.count = 1, .reusable = false}, SHIFT(1401),
  [2893] = {.count = 1, .reusable = false}, SHIFT(1400),
  [2895] = {.count = 1, .reusable = true}, SHIFT(1403),
  [2897] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 1),
  [2899] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 1),
  [2901] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_class, 3),
  [2903] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_class, 3),
  [2905] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 2),
  [2907] = {.count = 1, .reusable = true}, SHIFT(1405),
  [2909] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 3),
  [2911] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 3),
  [2913] = {.count = 1, .reusable = true}, SHIFT(1409),
  [2915] = {.count = 1, .reusable = true}, SHIFT(1412),
  [2917] = {.count = 1, .reusable = true}, SHIFT(1415),
  [2919] = {.count = 1, .reusable = true}, SHIFT(850),
  [2921] = {.count = 1, .reusable = true}, SHIFT(1416),
  [2923] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3, .alias_sequence_id = 12),
  [2925] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3, .alias_sequence_id = 12),
  [2927] = {.count = 1, .reusable = true}, SHIFT(1419),
  [2929] = {.count = 1, .reusable = false}, SHIFT(1417),
  [2931] = {.count = 1, .reusable = false}, SHIFT(1429),
  [2933] = {.count = 1, .reusable = false}, SHIFT(1418),
  [2935] = {.count = 1, .reusable = false}, SHIFT(1419),
  [2937] = {.count = 1, .reusable = false}, SHIFT(1420),
  [2939] = {.count = 1, .reusable = false}, SHIFT(1421),
  [2941] = {.count = 1, .reusable = false}, SHIFT(1422),
  [2943] = {.count = 1, .reusable = true}, SHIFT(1423),
  [2945] = {.count = 1, .reusable = true}, SHIFT(1429),
  [2947] = {.count = 1, .reusable = false}, SHIFT(1424),
  [2949] = {.count = 1, .reusable = false}, SHIFT(1425),
  [2951] = {.count = 1, .reusable = false}, SHIFT(1426),
  [2953] = {.count = 1, .reusable = false}, SHIFT(1427),
  [2955] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .alias_sequence_id = 13), REDUCE(sym_assignment_expression, 2),
  [2958] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .alias_sequence_id = 13),
  [2960] = {.count = 1, .reusable = true}, SHIFT(1433),
  [2962] = {.count = 1, .reusable = true}, SHIFT(1434),
  [2964] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2, .alias_sequence_id = 12),
  [2966] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2),
  [2968] = {.count = 1, .reusable = false}, SHIFT(1436),
  [2970] = {.count = 1, .reusable = false}, SHIFT(1441),
  [2972] = {.count = 1, .reusable = false}, SHIFT(1437),
  [2974] = {.count = 1, .reusable = false}, SHIFT(1438),
  [2976] = {.count = 1, .reusable = false}, SHIFT(1439),
  [2978] = {.count = 1, .reusable = true}, SHIFT(1441),
  [2980] = {.count = 1, .reusable = false}, SHIFT(1440),
  [2982] = {.count = 1, .reusable = true}, SHIFT(1442),
  [2984] = {.count = 1, .reusable = true}, SHIFT(1444),
  [2986] = {.count = 1, .reusable = false}, SHIFT(1445),
  [2988] = {.count = 1, .reusable = true}, SHIFT(1446),
  [2990] = {.count = 1, .reusable = false}, SHIFT(1447),
  [2992] = {.count = 1, .reusable = false}, SHIFT(1448),
  [2994] = {.count = 1, .reusable = false}, SHIFT(1449),
  [2996] = {.count = 1, .reusable = false}, SHIFT(1450),
  [2998] = {.count = 1, .reusable = false}, SHIFT(1451),
  [3000] = {.count = 1, .reusable = false}, SHIFT(1452),
  [3002] = {.count = 1, .reusable = false}, SHIFT(1453),
  [3004] = {.count = 1, .reusable = false}, SHIFT(1454),
  [3006] = {.count = 1, .reusable = true}, SHIFT(1457),
  [3008] = {.count = 1, .reusable = false}, SHIFT(1458),
  [3010] = {.count = 1, .reusable = false}, SHIFT(1459),
  [3012] = {.count = 1, .reusable = false}, SHIFT(1460),
  [3014] = {.count = 1, .reusable = true}, SHIFT(1464),
  [3016] = {.count = 1, .reusable = true}, SHIFT(1465),
  [3018] = {.count = 1, .reusable = true}, SHIFT(1466),
  [3020] = {.count = 1, .reusable = true}, SHIFT(660),
  [3022] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 3),
  [3024] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 3),
  [3026] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(692),
  [3029] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(204),
  [3032] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(209),
  [3035] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(694),
  [3038] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(215),
  [3041] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(695),
  [3044] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(218),
  [3047] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3),
  [3049] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3),
  [3051] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(197),
  [3054] = {.count = 1, .reusable = false}, SHIFT(1467),
  [3056] = {.count = 1, .reusable = true}, SHIFT(1468),
  [3058] = {.count = 1, .reusable = false}, REDUCE(aux_sym_export_statement_repeat1, 2),
  [3060] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2), SHIFT_REPEAT(196),
  [3063] = {.count = 1, .reusable = false}, SHIFT(1470),
  [3065] = {.count = 1, .reusable = true}, SHIFT(1470),
  [3067] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .alias_sequence_id = 3), REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 3),
  [3070] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .alias_sequence_id = 3),
  [3072] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .alias_sequence_id = 4), REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 4),
  [3075] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .alias_sequence_id = 4),
  [3077] = {.count = 1, .reusable = true}, SHIFT(1473),
  [3079] = {.count = 1, .reusable = true}, SHIFT(1474),
  [3081] = {.count = 1, .reusable = true}, SHIFT(1472),
  [3083] = {.count = 1, .reusable = false}, REDUCE(sym_switch_statement, 3),
  [3085] = {.count = 1, .reusable = true}, REDUCE(sym_switch_statement, 3),
  [3087] = {.count = 1, .reusable = false}, SHIFT(1476),
  [3089] = {.count = 1, .reusable = true}, SHIFT(1476),
  [3091] = {.count = 1, .reusable = false}, SHIFT(1477),
  [3093] = {.count = 1, .reusable = true}, SHIFT(1477),
  [3095] = {.count = 1, .reusable = true}, SHIFT(763),
  [3097] = {.count = 1, .reusable = true}, SHIFT(721),
  [3099] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 2),
  [3101] = {.count = 1, .reusable = false}, SHIFT(1480),
  [3103] = {.count = 1, .reusable = true}, SHIFT(1480),
  [3105] = {.count = 1, .reusable = false}, SHIFT(1481),
  [3107] = {.count = 1, .reusable = true}, SHIFT(1481),
  [3109] = {.count = 1, .reusable = false}, SHIFT(1482),
  [3111] = {.count = 1, .reusable = true}, SHIFT(1483),
  [3113] = {.count = 1, .reusable = true}, SHIFT(1484),
  [3115] = {.count = 1, .reusable = false}, SHIFT(1485),
  [3117] = {.count = 1, .reusable = true}, SHIFT(1486),
  [3119] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_expression, 2), REDUCE(sym_required_parameter, 2),
  [3122] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2),
  [3124] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .alias_sequence_id = 6),
  [3126] = {.count = 1, .reusable = true}, SHIFT(1491),
  [3128] = {.count = 1, .reusable = true}, SHIFT(1494),
  [3130] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .alias_sequence_id = 14),
  [3132] = {.count = 1, .reusable = true}, SHIFT(1496),
  [3134] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .alias_sequence_id = 15),
  [3136] = {.count = 1, .reusable = true}, SHIFT(1499),
  [3138] = {.count = 1, .reusable = false}, SHIFT(1502),
  [3140] = {.count = 1, .reusable = true}, SHIFT(1502),
  [3142] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 2, .alias_sequence_id = 1),
  [3144] = {.count = 1, .reusable = false}, SHIFT(1505),
  [3146] = {.count = 1, .reusable = true}, SHIFT(1505),
  [3148] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 1), REDUCE(sym_required_parameter, 2, .alias_sequence_id = 1),
  [3151] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .alias_sequence_id = 1),
  [3153] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(757),
  [3156] = {.count = 1, .reusable = true}, SHIFT(1507),
  [3158] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 2),
  [3160] = {.count = 1, .reusable = true}, SHIFT(1509),
  [3162] = {.count = 1, .reusable = true}, SHIFT(1510),
  [3164] = {.count = 1, .reusable = true}, SHIFT(1511),
  [3166] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 3),
  [3168] = {.count = 1, .reusable = true}, SHIFT(1514),
  [3170] = {.count = 1, .reusable = false}, SHIFT(1516),
  [3172] = {.count = 1, .reusable = true}, SHIFT(1516),
  [3174] = {.count = 1, .reusable = false}, SHIFT(1517),
  [3176] = {.count = 1, .reusable = true}, SHIFT(1517),
  [3178] = {.count = 1, .reusable = false}, SHIFT(1518),
  [3180] = {.count = 1, .reusable = true}, SHIFT(1518),
  [3182] = {.count = 1, .reusable = false}, SHIFT(1519),
  [3184] = {.count = 1, .reusable = true}, SHIFT(1519),
  [3186] = {.count = 1, .reusable = false}, SHIFT(1520),
  [3188] = {.count = 1, .reusable = true}, SHIFT(1520),
  [3190] = {.count = 1, .reusable = false}, SHIFT(1522),
  [3192] = {.count = 1, .reusable = true}, SHIFT(1522),
  [3194] = {.count = 1, .reusable = false}, SHIFT(1523),
  [3196] = {.count = 1, .reusable = true}, SHIFT(1527),
  [3198] = {.count = 1, .reusable = true}, SHIFT(1525),
  [3200] = {.count = 1, .reusable = true}, SHIFT(1524),
  [3202] = {.count = 1, .reusable = false}, SHIFT(1526),
  [3204] = {.count = 1, .reusable = false}, SHIFT(1530),
  [3206] = {.count = 1, .reusable = false}, SHIFT(1531),
  [3208] = {.count = 1, .reusable = false}, SHIFT(1532),
  [3210] = {.count = 1, .reusable = false}, SHIFT(1533),
  [3212] = {.count = 1, .reusable = false}, SHIFT(1534),
  [3214] = {.count = 1, .reusable = false}, SHIFT(1535),
  [3216] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [3218] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [3220] = {.count = 1, .reusable = false}, SHIFT(1536),
  [3222] = {.count = 1, .reusable = false}, SHIFT(1538),
  [3224] = {.count = 1, .reusable = true}, SHIFT(1538),
  [3226] = {.count = 1, .reusable = true}, SHIFT(1539),
  [3228] = {.count = 1, .reusable = false}, SHIFT(1540),
  [3230] = {.count = 1, .reusable = false}, SHIFT(1541),
  [3232] = {.count = 1, .reusable = false}, SHIFT(1545),
  [3234] = {.count = 1, .reusable = true}, SHIFT(1545),
  [3236] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 1, .alias_sequence_id = 1),
  [3238] = {.count = 1, .reusable = true}, SHIFT(730),
  [3240] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 1),
  [3242] = {.count = 1, .reusable = true}, SHIFT(718),
  [3244] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 1, .alias_sequence_id = 3),
  [3246] = {.count = 1, .reusable = true}, SHIFT(773),
  [3248] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 1, .alias_sequence_id = 4),
  [3250] = {.count = 1, .reusable = true}, SHIFT(776),
  [3252] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 2, .alias_sequence_id = 3),
  [3254] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 3), REDUCE(sym_required_parameter, 2, .alias_sequence_id = 3),
  [3257] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .alias_sequence_id = 3),
  [3259] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 2, .alias_sequence_id = 4),
  [3261] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 4), REDUCE(sym_required_parameter, 2, .alias_sequence_id = 4),
  [3264] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .alias_sequence_id = 4),
  [3266] = {.count = 1, .reusable = false}, SHIFT(1557),
  [3268] = {.count = 1, .reusable = true}, SHIFT(1557),
  [3270] = {.count = 1, .reusable = false}, SHIFT(1559),
  [3272] = {.count = 1, .reusable = true}, SHIFT(1559),
  [3274] = {.count = 1, .reusable = true}, SHIFT(799),
  [3276] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 3),
  [3278] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 3),
  [3280] = {.count = 1, .reusable = true}, SHIFT(1563),
  [3282] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3),
  [3284] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3),
  [3286] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(788),
  [3289] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat2, 2),
  [3291] = {.count = 1, .reusable = true}, SHIFT(1564),
  [3293] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3),
  [3295] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3),
  [3297] = {.count = 1, .reusable = false}, SHIFT(1568),
  [3299] = {.count = 1, .reusable = false}, SHIFT(1569),
  [3301] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 1, .alias_sequence_id = 2),
  [3303] = {.count = 1, .reusable = true}, SHIFT(1571),
  [3305] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 1, .alias_sequence_id = 2),
  [3307] = {.count = 1, .reusable = false}, SHIFT(1572),
  [3309] = {.count = 1, .reusable = true}, SHIFT(1576),
  [3311] = {.count = 1, .reusable = true}, SHIFT(1577),
  [3313] = {.count = 1, .reusable = true}, SHIFT(1574),
  [3315] = {.count = 1, .reusable = true}, SHIFT(1573),
  [3317] = {.count = 1, .reusable = false}, SHIFT(1575),
  [3319] = {.count = 1, .reusable = false}, SHIFT(1581),
  [3321] = {.count = 1, .reusable = true}, SHIFT(1582),
  [3323] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 3, .dynamic_precedence = -1),
  [3325] = {.count = 1, .reusable = true}, SHIFT(1583),
  [3327] = {.count = 1, .reusable = false}, SHIFT(1585),
  [3329] = {.count = 1, .reusable = true}, SHIFT(1584),
  [3331] = {.count = 1, .reusable = true}, SHIFT(1585),
  [3333] = {.count = 1, .reusable = true}, SHIFT(1587),
  [3335] = {.count = 1, .reusable = false}, SHIFT(1588),
  [3337] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 1),
  [3339] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 1),
  [3341] = {.count = 1, .reusable = true}, SHIFT(1590),
  [3343] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 2, .alias_sequence_id = 5),
  [3345] = {.count = 1, .reusable = false}, SHIFT(1577),
  [3347] = {.count = 1, .reusable = true}, SHIFT(1593),
  [3349] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 3),
  [3351] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 3),
  [3353] = {.count = 1, .reusable = true}, SHIFT(1595),
  [3355] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 3),
  [3357] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 3),
  [3359] = {.count = 1, .reusable = false}, SHIFT(1597),
  [3361] = {.count = 1, .reusable = true}, SHIFT(1598),
  [3363] = {.count = 1, .reusable = true}, SHIFT(1602),
  [3365] = {.count = 1, .reusable = true}, SHIFT(1604),
  [3367] = {.count = 1, .reusable = false}, SHIFT(1607),
  [3369] = {.count = 1, .reusable = true}, SHIFT(1608),
  [3371] = {.count = 1, .reusable = true}, SHIFT(1609),
  [3373] = {.count = 1, .reusable = false}, SHIFT(1610),
  [3375] = {.count = 1, .reusable = true}, SHIFT(1611),
  [3377] = {.count = 1, .reusable = true}, REDUCE(sym_function, 3),
  [3379] = {.count = 1, .reusable = false}, REDUCE(sym_function, 3),
  [3381] = {.count = 1, .reusable = false}, SHIFT(1615),
  [3383] = {.count = 1, .reusable = true}, SHIFT(1615),
  [3385] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3),
  [3387] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3),
  [3389] = {.count = 1, .reusable = true}, REDUCE(sym_meta_property, 3),
  [3391] = {.count = 1, .reusable = false}, REDUCE(sym_meta_property, 3),
  [3393] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .alias_sequence_id = 6),
  [3395] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .alias_sequence_id = 6),
  [3397] = {.count = 1, .reusable = true}, SHIFT(1616),
  [3399] = {.count = 1, .reusable = true}, SHIFT(1617),
  [3401] = {.count = 1, .reusable = false}, SHIFT(1618),
  [3403] = {.count = 1, .reusable = false}, SHIFT(1619),
  [3405] = {.count = 1, .reusable = false}, SHIFT(1620),
  [3407] = {.count = 1, .reusable = false}, SHIFT(1621),
  [3409] = {.count = 1, .reusable = false}, SHIFT(1622),
  [3411] = {.count = 1, .reusable = false}, SHIFT(1623),
  [3413] = {.count = 1, .reusable = false}, SHIFT(1624),
  [3415] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(848),
  [3418] = {.count = 1, .reusable = false}, SHIFT(1637),
  [3420] = {.count = 1, .reusable = true}, SHIFT(1637),
  [3422] = {.count = 1, .reusable = false}, SHIFT(1638),
  [3424] = {.count = 1, .reusable = true}, SHIFT(1638),
  [3426] = {.count = 1, .reusable = false}, SHIFT(1639),
  [3428] = {.count = 1, .reusable = true}, SHIFT(1639),
  [3430] = {.count = 1, .reusable = false}, SHIFT(1640),
  [3432] = {.count = 1, .reusable = true}, SHIFT(1640),
  [3434] = {.count = 1, .reusable = false}, SHIFT(1641),
  [3436] = {.count = 1, .reusable = true}, SHIFT(1641),
  [3438] = {.count = 1, .reusable = false}, SHIFT(1642),
  [3440] = {.count = 1, .reusable = true}, SHIFT(1646),
  [3442] = {.count = 1, .reusable = true}, SHIFT(1644),
  [3444] = {.count = 1, .reusable = true}, SHIFT(1643),
  [3446] = {.count = 1, .reusable = false}, SHIFT(1645),
  [3448] = {.count = 1, .reusable = false}, SHIFT(1649),
  [3450] = {.count = 1, .reusable = false}, SHIFT(1650),
  [3452] = {.count = 1, .reusable = false}, SHIFT(1651),
  [3454] = {.count = 1, .reusable = false}, SHIFT(1652),
  [3456] = {.count = 1, .reusable = false}, SHIFT(1653),
  [3458] = {.count = 1, .reusable = false}, SHIFT(1654),
  [3460] = {.count = 1, .reusable = false}, SHIFT(1655),
  [3462] = {.count = 1, .reusable = true}, SHIFT(1650),
  [3464] = {.count = 1, .reusable = false}, SHIFT(1656),
  [3466] = {.count = 1, .reusable = false}, SHIFT(1657),
  [3468] = {.count = 1, .reusable = false}, SHIFT(1658),
  [3470] = {.count = 1, .reusable = true}, SHIFT(1658),
  [3472] = {.count = 1, .reusable = true}, SHIFT(1659),
  [3474] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 2),
  [3476] = {.count = 1, .reusable = true}, SHIFT(1660),
  [3478] = {.count = 1, .reusable = true}, SHIFT(1661),
  [3480] = {.count = 1, .reusable = true}, SHIFT(1662),
  [3482] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), SHIFT(1659),
  [3485] = {.count = 1, .reusable = true}, SHIFT(1666),
  [3487] = {.count = 1, .reusable = false}, SHIFT(1667),
  [3489] = {.count = 1, .reusable = true}, SHIFT(1664),
  [3491] = {.count = 1, .reusable = false}, SHIFT(1665),
  [3493] = {.count = 1, .reusable = true}, SHIFT(1669),
  [3495] = {.count = 1, .reusable = true}, SHIFT(1668),
  [3497] = {.count = 1, .reusable = false}, SHIFT(1670),
  [3499] = {.count = 1, .reusable = true}, SHIFT(1670),
  [3501] = {.count = 1, .reusable = false}, SHIFT(1671),
  [3503] = {.count = 1, .reusable = true}, SHIFT(1671),
  [3505] = {.count = 1, .reusable = false}, SHIFT(1672),
  [3507] = {.count = 1, .reusable = false}, SHIFT(1673),
  [3509] = {.count = 1, .reusable = false}, SHIFT(1674),
  [3511] = {.count = 1, .reusable = true}, SHIFT(1674),
  [3513] = {.count = 1, .reusable = false}, SHIFT(1675),
  [3515] = {.count = 1, .reusable = true}, SHIFT(1675),
  [3517] = {.count = 1, .reusable = false}, SHIFT(1676),
  [3519] = {.count = 1, .reusable = false}, SHIFT(1677),
  [3521] = {.count = 1, .reusable = false}, SHIFT(1678),
  [3523] = {.count = 1, .reusable = false}, SHIFT(1679),
  [3525] = {.count = 1, .reusable = false}, SHIFT(1680),
  [3527] = {.count = 1, .reusable = false}, SHIFT(1681),
  [3529] = {.count = 1, .reusable = true}, SHIFT(1681),
  [3531] = {.count = 1, .reusable = true}, SHIFT(1665),
  [3533] = {.count = 1, .reusable = false}, SHIFT(1682),
  [3535] = {.count = 1, .reusable = true}, SHIFT(1683),
  [3537] = {.count = 1, .reusable = false}, SHIFT(1684),
  [3539] = {.count = 1, .reusable = false}, SHIFT(1683),
  [3541] = {.count = 1, .reusable = true}, SHIFT(1685),
  [3543] = {.count = 1, .reusable = false}, SHIFT(1685),
  [3545] = {.count = 1, .reusable = true}, SHIFT(1686),
  [3547] = {.count = 1, .reusable = true}, SHIFT(1682),
  [3549] = {.count = 1, .reusable = true}, SHIFT(1687),
  [3551] = {.count = 1, .reusable = false}, SHIFT(1688),
  [3553] = {.count = 1, .reusable = true}, SHIFT(1689),
  [3555] = {.count = 1, .reusable = true}, SHIFT(1690),
  [3557] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 3),
  [3559] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 3),
  [3561] = {.count = 1, .reusable = false}, SHIFT(1691),
  [3563] = {.count = 1, .reusable = false}, SHIFT(1692),
  [3565] = {.count = 1, .reusable = false}, SHIFT(1693),
  [3567] = {.count = 1, .reusable = false}, SHIFT(1694),
  [3569] = {.count = 1, .reusable = false}, SHIFT(1695),
  [3571] = {.count = 1, .reusable = false}, SHIFT(1696),
  [3573] = {.count = 1, .reusable = false}, SHIFT(1697),
  [3575] = {.count = 1, .reusable = true}, SHIFT(1700),
  [3577] = {.count = 1, .reusable = true}, SHIFT(1701),
  [3579] = {.count = 1, .reusable = false}, SHIFT(1702),
  [3581] = {.count = 1, .reusable = false}, SHIFT(1703),
  [3583] = {.count = 1, .reusable = false}, SHIFT(1704),
  [3585] = {.count = 1, .reusable = true}, SHIFT(1708),
  [3587] = {.count = 1, .reusable = true}, SHIFT(529),
  [3589] = {.count = 1, .reusable = true}, SHIFT(1709),
  [3591] = {.count = 1, .reusable = true}, SHIFT(1710),
  [3593] = {.count = 1, .reusable = true}, SHIFT(1711),
  [3595] = {.count = 1, .reusable = true}, SHIFT(1713),
  [3597] = {.count = 1, .reusable = true}, SHIFT(1714),
  [3599] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 3),
  [3601] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 3),
  [3603] = {.count = 1, .reusable = true}, REDUCE(sym_call_signature, 3),
  [3605] = {.count = 1, .reusable = false}, SHIFT(1716),
  [3607] = {.count = 1, .reusable = true}, SHIFT(1716),
  [3609] = {.count = 1, .reusable = true}, SHIFT(1721),
  [3611] = {.count = 1, .reusable = true}, REDUCE(sym_type_annotation, 2),
  [3613] = {.count = 1, .reusable = true}, SHIFT(1724),
  [3615] = {.count = 1, .reusable = true}, SHIFT(1725),
  [3617] = {.count = 1, .reusable = true}, SHIFT(1727),
  [3619] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(334),
  [3622] = {.count = 1, .reusable = true}, REDUCE(sym_sequence_expression, 3),
  [3624] = {.count = 1, .reusable = true}, SHIFT(1730),
  [3626] = {.count = 1, .reusable = false}, SHIFT(1731),
  [3628] = {.count = 1, .reusable = true}, SHIFT(1728),
  [3630] = {.count = 1, .reusable = false}, SHIFT(1729),
  [3632] = {.count = 1, .reusable = true}, SHIFT(1733),
  [3634] = {.count = 1, .reusable = true}, SHIFT(1732),
  [3636] = {.count = 1, .reusable = false}, SHIFT(1734),
  [3638] = {.count = 1, .reusable = true}, SHIFT(1734),
  [3640] = {.count = 1, .reusable = false}, SHIFT(1735),
  [3642] = {.count = 1, .reusable = true}, SHIFT(1735),
  [3644] = {.count = 1, .reusable = false}, SHIFT(1736),
  [3646] = {.count = 1, .reusable = false}, SHIFT(1737),
  [3648] = {.count = 1, .reusable = false}, SHIFT(1738),
  [3650] = {.count = 1, .reusable = true}, SHIFT(1738),
  [3652] = {.count = 1, .reusable = false}, SHIFT(1739),
  [3654] = {.count = 1, .reusable = true}, SHIFT(1739),
  [3656] = {.count = 1, .reusable = false}, SHIFT(1740),
  [3658] = {.count = 1, .reusable = false}, SHIFT(1741),
  [3660] = {.count = 1, .reusable = false}, SHIFT(1742),
  [3662] = {.count = 1, .reusable = false}, SHIFT(1743),
  [3664] = {.count = 1, .reusable = false}, SHIFT(1744),
  [3666] = {.count = 1, .reusable = false}, SHIFT(1745),
  [3668] = {.count = 1, .reusable = true}, SHIFT(1745),
  [3670] = {.count = 1, .reusable = true}, SHIFT(1729),
  [3672] = {.count = 1, .reusable = false}, SHIFT(1746),
  [3674] = {.count = 1, .reusable = true}, SHIFT(1747),
  [3676] = {.count = 1, .reusable = false}, SHIFT(1748),
  [3678] = {.count = 1, .reusable = false}, SHIFT(1747),
  [3680] = {.count = 1, .reusable = true}, SHIFT(1749),
  [3682] = {.count = 1, .reusable = false}, SHIFT(1749),
  [3684] = {.count = 1, .reusable = true}, SHIFT(1750),
  [3686] = {.count = 1, .reusable = true}, SHIFT(1746),
  [3688] = {.count = 1, .reusable = true}, SHIFT(1751),
  [3690] = {.count = 1, .reusable = false}, SHIFT(1752),
  [3692] = {.count = 1, .reusable = true}, SHIFT(1753),
  [3694] = {.count = 1, .reusable = true}, SHIFT(1754),
  [3696] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(1755),
  [3699] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5),
  [3701] = {.count = 1, .reusable = true}, SHIFT(1758),
  [3703] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(1756),
  [3706] = {.count = 1, .reusable = true}, SHIFT(1757),
  [3708] = {.count = 1, .reusable = true}, SHIFT(1760),
  [3710] = {.count = 1, .reusable = true}, SHIFT(1762),
  [3712] = {.count = 1, .reusable = true}, SHIFT(1763),
  [3714] = {.count = 1, .reusable = true}, SHIFT(1767),
  [3716] = {.count = 1, .reusable = true}, SHIFT(1768),
  [3718] = {.count = 1, .reusable = true}, SHIFT(1770),
  [3720] = {.count = 1, .reusable = true}, REDUCE(sym_as_expression, 3),
  [3722] = {.count = 1, .reusable = false}, REDUCE(sym_as_expression, 3),
  [3724] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(1777),
  [3727] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(1756),
  [3730] = {.count = 1, .reusable = true}, SHIFT(1780),
  [3732] = {.count = 1, .reusable = true}, SHIFT(1781),
  [3734] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(1061),
  [3738] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .alias_sequence_id = 5),
  [3741] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .alias_sequence_id = 5),
  [3744] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(101),
  [3747] = {.count = 1, .reusable = true}, SHIFT(1782),
  [3749] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [3752] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [3755] = {.count = 1, .reusable = false}, SHIFT(1783),
  [3757] = {.count = 1, .reusable = false}, SHIFT(1784),
  [3759] = {.count = 1, .reusable = false}, SHIFT(1785),
  [3761] = {.count = 1, .reusable = false}, SHIFT(1786),
  [3763] = {.count = 1, .reusable = false}, SHIFT(1787),
  [3765] = {.count = 1, .reusable = false}, SHIFT(1788),
  [3767] = {.count = 1, .reusable = false}, SHIFT(1789),
  [3769] = {.count = 1, .reusable = true}, SHIFT(1788),
  [3771] = {.count = 1, .reusable = false}, SHIFT(1790),
  [3773] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(sym_predefined_type, 1),
  [3776] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(sym_predefined_type, 1),
  [3779] = {.count = 1, .reusable = false}, SHIFT(1793),
  [3781] = {.count = 1, .reusable = true}, SHIFT(1794),
  [3783] = {.count = 1, .reusable = false}, SHIFT(1795),
  [3785] = {.count = 1, .reusable = true}, SHIFT(1796),
  [3787] = {.count = 1, .reusable = false}, SHIFT(1797),
  [3789] = {.count = 1, .reusable = true}, SHIFT(1798),
  [3791] = {.count = 1, .reusable = true}, SHIFT(1799),
  [3793] = {.count = 1, .reusable = false}, SHIFT(1800),
  [3795] = {.count = 1, .reusable = false}, SHIFT(1803),
  [3797] = {.count = 1, .reusable = false}, SHIFT(1801),
  [3799] = {.count = 1, .reusable = false}, SHIFT(1802),
  [3801] = {.count = 1, .reusable = true}, SHIFT(1807),
  [3803] = {.count = 1, .reusable = false}, SHIFT(1804),
  [3805] = {.count = 1, .reusable = false}, SHIFT(1805),
  [3807] = {.count = 1, .reusable = false}, SHIFT(1809),
  [3809] = {.count = 1, .reusable = false}, SHIFT(1810),
  [3811] = {.count = 1, .reusable = false}, SHIFT(1811),
  [3813] = {.count = 1, .reusable = false}, SHIFT(1812),
  [3815] = {.count = 1, .reusable = false}, SHIFT(1813),
  [3817] = {.count = 1, .reusable = false}, SHIFT(1814),
  [3819] = {.count = 1, .reusable = false}, SHIFT(1815),
  [3821] = {.count = 1, .reusable = true}, SHIFT(1814),
  [3823] = {.count = 1, .reusable = false}, SHIFT(1816),
  [3825] = {.count = 2, .reusable = true}, REDUCE(sym_this, 1), REDUCE(sym_this_type, 1),
  [3828] = {.count = 2, .reusable = false}, REDUCE(sym_this, 1), REDUCE(sym_this_type, 1),
  [3831] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(1120),
  [3834] = {.count = 1, .reusable = false}, SHIFT(1822),
  [3836] = {.count = 1, .reusable = false}, SHIFT(1824),
  [3838] = {.count = 1, .reusable = true}, SHIFT(1825),
  [3840] = {.count = 1, .reusable = true}, SHIFT(1830),
  [3842] = {.count = 1, .reusable = false}, SHIFT(1828),
  [3844] = {.count = 1, .reusable = false}, SHIFT(1840),
  [3846] = {.count = 1, .reusable = false}, SHIFT(1829),
  [3848] = {.count = 1, .reusable = false}, SHIFT(1830),
  [3850] = {.count = 1, .reusable = false}, SHIFT(1831),
  [3852] = {.count = 1, .reusable = false}, SHIFT(1832),
  [3854] = {.count = 1, .reusable = false}, SHIFT(1833),
  [3856] = {.count = 1, .reusable = true}, SHIFT(1834),
  [3858] = {.count = 1, .reusable = true}, SHIFT(1840),
  [3860] = {.count = 1, .reusable = false}, SHIFT(1835),
  [3862] = {.count = 1, .reusable = false}, SHIFT(1836),
  [3864] = {.count = 1, .reusable = false}, SHIFT(1837),
  [3866] = {.count = 1, .reusable = false}, SHIFT(1838),
  [3868] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_expression, 2),
  [3870] = {.count = 1, .reusable = true}, SHIFT(1844),
  [3872] = {.count = 1, .reusable = false}, SHIFT(1845),
  [3874] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_element, 3),
  [3876] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_element, 3),
  [3878] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(975),
  [3881] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(1847),
  [3884] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(338),
  [3887] = {.count = 1, .reusable = true}, SHIFT(1848),
  [3889] = {.count = 1, .reusable = false}, SHIFT(1849),
  [3891] = {.count = 1, .reusable = true}, SHIFT(1849),
  [3893] = {.count = 1, .reusable = false}, SHIFT(1850),
  [3895] = {.count = 1, .reusable = true}, SHIFT(1850),
  [3897] = {.count = 1, .reusable = false}, SHIFT(1851),
  [3899] = {.count = 1, .reusable = true}, SHIFT(1851),
  [3901] = {.count = 1, .reusable = false}, SHIFT(1852),
  [3903] = {.count = 1, .reusable = true}, SHIFT(1852),
  [3905] = {.count = 1, .reusable = false}, SHIFT(1853),
  [3907] = {.count = 1, .reusable = true}, SHIFT(1853),
  [3909] = {.count = 1, .reusable = false}, SHIFT(1854),
  [3911] = {.count = 1, .reusable = true}, SHIFT(1854),
  [3913] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(1003),
  [3916] = {.count = 1, .reusable = true}, SHIFT(1855),
  [3918] = {.count = 1, .reusable = true}, SHIFT(1856),
  [3920] = {.count = 1, .reusable = false}, SHIFT(1857),
  [3922] = {.count = 1, .reusable = true}, SHIFT(1857),
  [3924] = {.count = 1, .reusable = false}, SHIFT(1858),
  [3926] = {.count = 1, .reusable = true}, SHIFT(1858),
  [3928] = {.count = 1, .reusable = false}, SHIFT(1859),
  [3930] = {.count = 1, .reusable = true}, SHIFT(1859),
  [3932] = {.count = 1, .reusable = false}, SHIFT(1860),
  [3934] = {.count = 1, .reusable = true}, SHIFT(1860),
  [3936] = {.count = 1, .reusable = false}, SHIFT(1861),
  [3938] = {.count = 1, .reusable = true}, SHIFT(1861),
  [3940] = {.count = 1, .reusable = false}, SHIFT(1862),
  [3942] = {.count = 1, .reusable = true}, SHIFT(1862),
  [3944] = {.count = 1, .reusable = true}, REDUCE(sym_template_substitution, 3),
  [3946] = {.count = 1, .reusable = false}, SHIFT(1863),
  [3948] = {.count = 1, .reusable = true}, SHIFT(1867),
  [3950] = {.count = 1, .reusable = true}, SHIFT(1865),
  [3952] = {.count = 1, .reusable = true}, SHIFT(1864),
  [3954] = {.count = 1, .reusable = false}, SHIFT(1866),
  [3956] = {.count = 1, .reusable = false}, SHIFT(1870),
  [3958] = {.count = 1, .reusable = false}, SHIFT(1871),
  [3960] = {.count = 1, .reusable = false}, SHIFT(1872),
  [3962] = {.count = 1, .reusable = false}, SHIFT(1873),
  [3964] = {.count = 1, .reusable = false}, SHIFT(1874),
  [3966] = {.count = 1, .reusable = false}, SHIFT(1875),
  [3968] = {.count = 1, .reusable = false}, SHIFT(1876),
  [3970] = {.count = 1, .reusable = true}, SHIFT(1876),
  [3972] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_member_expression, 3, .alias_sequence_id = 8),
  [3974] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_member_expression, 3, .alias_sequence_id = 8),
  [3976] = {.count = 1, .reusable = true}, SHIFT(1877),
  [3978] = {.count = 1, .reusable = true}, SHIFT(1879),
  [3980] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(1881),
  [3983] = {.count = 1, .reusable = true}, SHIFT(1883),
  [3985] = {.count = 1, .reusable = true}, SHIFT(1882),
  [3987] = {.count = 1, .reusable = true}, SHIFT(1884),
  [3989] = {.count = 1, .reusable = true}, SHIFT(1886),
  [3991] = {.count = 1, .reusable = true}, SHIFT(1888),
  [3993] = {.count = 1, .reusable = true}, SHIFT(1889),
  [3995] = {.count = 1, .reusable = true}, SHIFT(1893),
  [3997] = {.count = 1, .reusable = true}, SHIFT(1894),
  [3999] = {.count = 1, .reusable = true}, SHIFT(1895),
  [4001] = {.count = 1, .reusable = true}, SHIFT(1901),
  [4003] = {.count = 1, .reusable = true}, SHIFT(1902),
  [4005] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(1903),
  [4008] = {.count = 1, .reusable = true}, SHIFT(1906),
  [4010] = {.count = 1, .reusable = true}, SHIFT(1907),
  [4012] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3),
  [4014] = {.count = 1, .reusable = true}, SHIFT(1908),
  [4016] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 4),
  [4018] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 4),
  [4020] = {.count = 1, .reusable = true}, SHIFT(1909),
  [4022] = {.count = 1, .reusable = true}, SHIFT(1910),
  [4024] = {.count = 1, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [4026] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 4),
  [4028] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 4),
  [4030] = {.count = 2, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(407),
  [4033] = {.count = 1, .reusable = true}, SHIFT(1912),
  [4035] = {.count = 1, .reusable = true}, SHIFT(1915),
  [4037] = {.count = 1, .reusable = true}, SHIFT(1916),
  [4039] = {.count = 1, .reusable = true}, SHIFT(1918),
  [4041] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .alias_sequence_id = 4),
  [4043] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .alias_sequence_id = 3),
  [4045] = {.count = 1, .reusable = false}, SHIFT(1919),
  [4047] = {.count = 1, .reusable = true}, SHIFT(1919),
  [4049] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_expression, 4),
  [4051] = {.count = 1, .reusable = false}, REDUCE(sym_subscript_expression, 4),
  [4053] = {.count = 1, .reusable = false}, SHIFT(1920),
  [4055] = {.count = 1, .reusable = true}, SHIFT(1921),
  [4057] = {.count = 1, .reusable = true}, SHIFT(1922),
  [4059] = {.count = 1, .reusable = false}, SHIFT(1923),
  [4061] = {.count = 1, .reusable = true}, SHIFT(1924),
  [4063] = {.count = 1, .reusable = true}, SHIFT(1928),
  [4065] = {.count = 1, .reusable = true}, SHIFT(1929),
  [4067] = {.count = 1, .reusable = false}, SHIFT(1930),
  [4069] = {.count = 1, .reusable = true}, SHIFT(1931),
  [4071] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2, .alias_sequence_id = 5),
  [4073] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2, .alias_sequence_id = 5),
  [4075] = {.count = 1, .reusable = false}, REDUCE(sym_flow_maybe_type, 2),
  [4077] = {.count = 1, .reusable = true}, REDUCE(sym_flow_maybe_type, 2),
  [4079] = {.count = 1, .reusable = false}, SHIFT(1935),
  [4081] = {.count = 1, .reusable = false}, SHIFT(1936),
  [4083] = {.count = 1, .reusable = false}, SHIFT(1937),
  [4085] = {.count = 1, .reusable = false}, SHIFT(1938),
  [4087] = {.count = 1, .reusable = false}, SHIFT(1939),
  [4089] = {.count = 1, .reusable = true}, SHIFT(1941),
  [4091] = {.count = 1, .reusable = false}, SHIFT(1942),
  [4093] = {.count = 1, .reusable = false}, SHIFT(1945),
  [4095] = {.count = 1, .reusable = true}, SHIFT(1946),
  [4097] = {.count = 1, .reusable = true}, SHIFT(1944),
  [4099] = {.count = 1, .reusable = false}, SHIFT(1943),
  [4101] = {.count = 1, .reusable = false}, SHIFT(1947),
  [4103] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 2),
  [4105] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 2),
  [4107] = {.count = 1, .reusable = true}, SHIFT(1954),
  [4109] = {.count = 1, .reusable = true}, SHIFT(1956),
  [4111] = {.count = 1, .reusable = true}, SHIFT(1957),
  [4113] = {.count = 1, .reusable = true}, SHIFT(1958),
  [4115] = {.count = 1, .reusable = true}, SHIFT(1959),
  [4117] = {.count = 1, .reusable = true}, SHIFT(1961),
  [4119] = {.count = 1, .reusable = true}, SHIFT(1968),
  [4121] = {.count = 1, .reusable = true}, SHIFT(1950),
  [4123] = {.count = 1, .reusable = true}, SHIFT(1951),
  [4125] = {.count = 1, .reusable = true}, SHIFT(1952),
  [4127] = {.count = 1, .reusable = true}, SHIFT(1953),
  [4129] = {.count = 1, .reusable = false}, SHIFT(1955),
  [4131] = {.count = 1, .reusable = true}, SHIFT(1960),
  [4133] = {.count = 1, .reusable = true}, SHIFT(1962),
  [4135] = {.count = 1, .reusable = true}, SHIFT(1963),
  [4137] = {.count = 1, .reusable = true}, SHIFT(1964),
  [4139] = {.count = 1, .reusable = true}, SHIFT(1965),
  [4141] = {.count = 1, .reusable = true}, SHIFT(1966),
  [4143] = {.count = 1, .reusable = true}, SHIFT(1967),
  [4145] = {.count = 1, .reusable = true}, SHIFT(1972),
  [4147] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 1),
  [4149] = {.count = 1, .reusable = true}, SHIFT(1974),
  [4151] = {.count = 1, .reusable = true}, SHIFT(1975),
  [4153] = {.count = 1, .reusable = true}, SHIFT(1978),
  [4155] = {.count = 1, .reusable = true}, SHIFT(1979),
  [4157] = {.count = 1, .reusable = false}, SHIFT(1981),
  [4159] = {.count = 1, .reusable = true}, SHIFT(1983),
  [4161] = {.count = 1, .reusable = true}, SHIFT(1986),
  [4163] = {.count = 1, .reusable = true}, SHIFT(1987),
  [4165] = {.count = 1, .reusable = true}, SHIFT(1988),
  [4167] = {.count = 1, .reusable = true}, SHIFT(1989),
  [4169] = {.count = 1, .reusable = true}, SHIFT(1992),
  [4171] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 2),
  [4173] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 2),
  [4175] = {.count = 1, .reusable = false}, REDUCE(sym_type_query, 2),
  [4177] = {.count = 1, .reusable = true}, REDUCE(sym_type_query, 2),
  [4179] = {.count = 1, .reusable = false}, REDUCE(sym__number, 2),
  [4181] = {.count = 1, .reusable = true}, REDUCE(sym__number, 2),
  [4183] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2, .alias_sequence_id = 11),
  [4185] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2, .alias_sequence_id = 11),
  [4187] = {.count = 1, .reusable = false}, SHIFT(1062),
  [4189] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2),
  [4191] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2),
  [4193] = {.count = 1, .reusable = true}, SHIFT(1994),
  [4195] = {.count = 2, .reusable = true}, REDUCE(sym_required_parameter, 1), REDUCE(sym__primary_type, 1, .alias_sequence_id = 5),
  [4198] = {.count = 1, .reusable = true}, SHIFT(1995),
  [4200] = {.count = 2, .reusable = true}, REDUCE(sym_required_parameter, 1, .alias_sequence_id = 1), REDUCE(sym_predefined_type, 1),
  [4203] = {.count = 1, .reusable = false}, SHIFT(1996),
  [4205] = {.count = 1, .reusable = false}, SHIFT(1997),
  [4207] = {.count = 1, .reusable = false}, SHIFT(1998),
  [4209] = {.count = 1, .reusable = false}, SHIFT(1999),
  [4211] = {.count = 1, .reusable = false}, SHIFT(2000),
  [4213] = {.count = 1, .reusable = true}, SHIFT(2001),
  [4215] = {.count = 1, .reusable = false}, SHIFT(2002),
  [4217] = {.count = 1, .reusable = true}, SHIFT(2006),
  [4219] = {.count = 1, .reusable = true}, SHIFT(2007),
  [4221] = {.count = 1, .reusable = true}, SHIFT(2008),
  [4223] = {.count = 1, .reusable = true}, SHIFT(2010),
  [4225] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 2),
  [4227] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 2),
  [4229] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 3),
  [4231] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 3),
  [4233] = {.count = 1, .reusable = true}, SHIFT(2013),
  [4235] = {.count = 1, .reusable = true}, SHIFT(2015),
  [4237] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2),
  [4239] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2),
  [4241] = {.count = 1, .reusable = true}, SHIFT(2018),
  [4243] = {.count = 1, .reusable = true}, SHIFT(2019),
  [4245] = {.count = 1, .reusable = false}, SHIFT(2021),
  [4247] = {.count = 1, .reusable = true}, SHIFT(2021),
  [4249] = {.count = 1, .reusable = false}, SHIFT(2022),
  [4251] = {.count = 1, .reusable = true}, SHIFT(2022),
  [4253] = {.count = 1, .reusable = false}, SHIFT(2023),
  [4255] = {.count = 1, .reusable = true}, SHIFT(2023),
  [4257] = {.count = 1, .reusable = false}, SHIFT(2024),
  [4259] = {.count = 1, .reusable = true}, SHIFT(2024),
  [4261] = {.count = 1, .reusable = false}, SHIFT(2025),
  [4263] = {.count = 1, .reusable = true}, SHIFT(2025),
  [4265] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(1146),
  [4268] = {.count = 1, .reusable = true}, SHIFT(2026),
  [4270] = {.count = 1, .reusable = true}, SHIFT(2027),
  [4272] = {.count = 1, .reusable = false}, SHIFT(2028),
  [4274] = {.count = 1, .reusable = true}, SHIFT(2028),
  [4276] = {.count = 1, .reusable = false}, SHIFT(2029),
  [4278] = {.count = 1, .reusable = true}, SHIFT(2029),
  [4280] = {.count = 1, .reusable = false}, SHIFT(2030),
  [4282] = {.count = 1, .reusable = true}, SHIFT(2030),
  [4284] = {.count = 1, .reusable = false}, SHIFT(2031),
  [4286] = {.count = 1, .reusable = true}, SHIFT(2031),
  [4288] = {.count = 1, .reusable = false}, SHIFT(2032),
  [4290] = {.count = 1, .reusable = true}, SHIFT(2032),
  [4292] = {.count = 1, .reusable = false}, SHIFT(2033),
  [4294] = {.count = 1, .reusable = true}, SHIFT(2037),
  [4296] = {.count = 1, .reusable = true}, SHIFT(2035),
  [4298] = {.count = 1, .reusable = true}, SHIFT(2034),
  [4300] = {.count = 1, .reusable = false}, SHIFT(2036),
  [4302] = {.count = 1, .reusable = false}, SHIFT(2040),
  [4304] = {.count = 1, .reusable = false}, SHIFT(2041),
  [4306] = {.count = 1, .reusable = false}, SHIFT(2042),
  [4308] = {.count = 1, .reusable = false}, SHIFT(2043),
  [4310] = {.count = 1, .reusable = false}, SHIFT(2044),
  [4312] = {.count = 1, .reusable = false}, SHIFT(2045),
  [4314] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 3),
  [4316] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 3),
  [4318] = {.count = 1, .reusable = false}, SHIFT(2046),
  [4320] = {.count = 1, .reusable = true}, SHIFT(2046),
  [4322] = {.count = 1, .reusable = true}, SHIFT(2047),
  [4324] = {.count = 2, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(443),
  [4327] = {.count = 1, .reusable = true}, SHIFT(2050),
  [4329] = {.count = 1, .reusable = false}, REDUCE(sym__type_reference, 1, .alias_sequence_id = 5),
  [4331] = {.count = 1, .reusable = false}, SHIFT(2051),
  [4333] = {.count = 1, .reusable = true}, SHIFT(2048),
  [4335] = {.count = 1, .reusable = false}, SHIFT(2049),
  [4337] = {.count = 1, .reusable = true}, SHIFT(2053),
  [4339] = {.count = 1, .reusable = true}, SHIFT(2052),
  [4341] = {.count = 1, .reusable = false}, SHIFT(2054),
  [4343] = {.count = 1, .reusable = false}, SHIFT(2055),
  [4345] = {.count = 1, .reusable = true}, SHIFT(2055),
  [4347] = {.count = 1, .reusable = false}, SHIFT(2056),
  [4349] = {.count = 1, .reusable = true}, SHIFT(2056),
  [4351] = {.count = 1, .reusable = false}, SHIFT(96),
  [4353] = {.count = 1, .reusable = false}, SHIFT(2057),
  [4355] = {.count = 1, .reusable = false}, SHIFT(2058),
  [4357] = {.count = 1, .reusable = false}, SHIFT(2059),
  [4359] = {.count = 1, .reusable = true}, SHIFT(2059),
  [4361] = {.count = 1, .reusable = false}, SHIFT(2060),
  [4363] = {.count = 1, .reusable = true}, SHIFT(2060),
  [4365] = {.count = 1, .reusable = false}, SHIFT(2061),
  [4367] = {.count = 1, .reusable = false}, SHIFT(2062),
  [4369] = {.count = 1, .reusable = false}, SHIFT(2063),
  [4371] = {.count = 1, .reusable = false}, SHIFT(2064),
  [4373] = {.count = 1, .reusable = false}, SHIFT(2065),
  [4375] = {.count = 1, .reusable = false}, SHIFT(2066),
  [4377] = {.count = 1, .reusable = true}, SHIFT(2066),
  [4379] = {.count = 1, .reusable = true}, SHIFT(2049),
  [4381] = {.count = 1, .reusable = false}, SHIFT(2067),
  [4383] = {.count = 1, .reusable = true}, SHIFT(2070),
  [4385] = {.count = 1, .reusable = true}, SHIFT(2068),
  [4387] = {.count = 1, .reusable = false}, SHIFT(2069),
  [4389] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 2),
  [4391] = {.count = 1, .reusable = true}, SHIFT(2071),
  [4393] = {.count = 1, .reusable = false}, SHIFT(2070),
  [4395] = {.count = 1, .reusable = false}, SHIFT(2071),
  [4397] = {.count = 1, .reusable = true}, SHIFT(2072),
  [4399] = {.count = 1, .reusable = true}, SHIFT(2067),
  [4401] = {.count = 1, .reusable = true}, SHIFT(2073),
  [4403] = {.count = 1, .reusable = false}, SHIFT(2074),
  [4405] = {.count = 1, .reusable = true}, SHIFT(2075),
  [4407] = {.count = 1, .reusable = false}, REDUCE(sym__type_reference, 1),
  [4409] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4, .alias_sequence_id = 11),
  [4411] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4, .alias_sequence_id = 11),
  [4413] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 2),
  [4415] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 2),
  [4417] = {.count = 1, .reusable = true}, REDUCE(sym__enum_member, 1),
  [4419] = {.count = 1, .reusable = true}, SHIFT(2079),
  [4421] = {.count = 1, .reusable = true}, SHIFT(2080),
  [4423] = {.count = 1, .reusable = true}, SHIFT(2082),
  [4425] = {.count = 1, .reusable = true}, SHIFT(2084),
  [4427] = {.count = 1, .reusable = false}, SHIFT(2085),
  [4429] = {.count = 1, .reusable = false}, SHIFT(2086),
  [4431] = {.count = 1, .reusable = false}, SHIFT(2087),
  [4433] = {.count = 1, .reusable = true}, SHIFT(2091),
  [4435] = {.count = 1, .reusable = true}, SHIFT(2093),
  [4437] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class, 4, .alias_sequence_id = 16),
  [4439] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class, 4, .alias_sequence_id = 16),
  [4441] = {.count = 1, .reusable = true}, SHIFT(2097),
  [4443] = {.count = 1, .reusable = true}, SHIFT(2100),
  [4445] = {.count = 1, .reusable = true}, SHIFT(2101),
  [4447] = {.count = 1, .reusable = true}, SHIFT(2102),
  [4449] = {.count = 1, .reusable = true}, SHIFT(2104),
  [4451] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 3),
  [4453] = {.count = 1, .reusable = true}, SHIFT(2106),
  [4455] = {.count = 1, .reusable = true}, SHIFT(2107),
  [4457] = {.count = 1, .reusable = true}, SHIFT(503),
  [4459] = {.count = 1, .reusable = true}, SHIFT(1202),
  [4461] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 4),
  [4463] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 4),
  [4465] = {.count = 1, .reusable = true}, SHIFT(2108),
  [4467] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_import, 3),
  [4469] = {.count = 1, .reusable = true}, SHIFT(2109),
  [4471] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 2),
  [4473] = {.count = 1, .reusable = true}, SHIFT(2110),
  [4475] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3),
  [4477] = {.count = 1, .reusable = true}, SHIFT(2111),
  [4479] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3, .alias_sequence_id = 17),
  [4481] = {.count = 1, .reusable = true}, SHIFT(2113),
  [4483] = {.count = 1, .reusable = true}, REDUCE(sym__from_clause, 2),
  [4485] = {.count = 1, .reusable = true}, REDUCE(sym_nested_identifier, 3),
  [4487] = {.count = 1, .reusable = false}, REDUCE(sym_nested_identifier, 3),
  [4489] = {.count = 1, .reusable = true}, SHIFT(2115),
  [4491] = {.count = 1, .reusable = true}, SHIFT(2118),
  [4493] = {.count = 1, .reusable = true}, SHIFT(2119),
  [4495] = {.count = 1, .reusable = true}, SHIFT(2120),
  [4497] = {.count = 1, .reusable = true}, SHIFT(2123),
  [4499] = {.count = 1, .reusable = false}, SHIFT(2121),
  [4501] = {.count = 1, .reusable = false}, SHIFT(2133),
  [4503] = {.count = 1, .reusable = false}, SHIFT(2122),
  [4505] = {.count = 1, .reusable = false}, SHIFT(2123),
  [4507] = {.count = 1, .reusable = false}, SHIFT(2124),
  [4509] = {.count = 1, .reusable = false}, SHIFT(2125),
  [4511] = {.count = 1, .reusable = false}, SHIFT(2126),
  [4513] = {.count = 1, .reusable = true}, SHIFT(2127),
  [4515] = {.count = 1, .reusable = true}, SHIFT(2133),
  [4517] = {.count = 1, .reusable = false}, SHIFT(2128),
  [4519] = {.count = 1, .reusable = false}, SHIFT(2129),
  [4521] = {.count = 1, .reusable = false}, SHIFT(2130),
  [4523] = {.count = 1, .reusable = false}, SHIFT(2131),
  [4525] = {.count = 1, .reusable = true}, SHIFT(2140),
  [4527] = {.count = 1, .reusable = false}, SHIFT(2138),
  [4529] = {.count = 1, .reusable = false}, SHIFT(2150),
  [4531] = {.count = 1, .reusable = false}, SHIFT(2139),
  [4533] = {.count = 1, .reusable = false}, SHIFT(2140),
  [4535] = {.count = 1, .reusable = false}, SHIFT(2141),
  [4537] = {.count = 1, .reusable = false}, SHIFT(2142),
  [4539] = {.count = 1, .reusable = false}, SHIFT(2143),
  [4541] = {.count = 1, .reusable = true}, SHIFT(2144),
  [4543] = {.count = 1, .reusable = true}, SHIFT(2150),
  [4545] = {.count = 1, .reusable = false}, SHIFT(2145),
  [4547] = {.count = 1, .reusable = false}, SHIFT(2146),
  [4549] = {.count = 1, .reusable = false}, SHIFT(2147),
  [4551] = {.count = 1, .reusable = false}, SHIFT(2148),
  [4553] = {.count = 1, .reusable = true}, SHIFT(2154),
  [4555] = {.count = 1, .reusable = true}, SHIFT(2155),
  [4557] = {.count = 1, .reusable = true}, SHIFT(2156),
  [4559] = {.count = 1, .reusable = false}, SHIFT(2158),
  [4561] = {.count = 1, .reusable = true}, SHIFT(2157),
  [4563] = {.count = 1, .reusable = true}, SHIFT(2158),
  [4565] = {.count = 1, .reusable = false}, SHIFT(2160),
  [4567] = {.count = 1, .reusable = true}, SHIFT(2160),
  [4569] = {.count = 1, .reusable = false}, SHIFT(2161),
  [4571] = {.count = 1, .reusable = true}, SHIFT(2161),
  [4573] = {.count = 1, .reusable = false}, SHIFT(2163),
  [4575] = {.count = 1, .reusable = true}, SHIFT(2163),
  [4577] = {.count = 1, .reusable = false}, SHIFT(2164),
  [4579] = {.count = 1, .reusable = true}, SHIFT(2164),
  [4581] = {.count = 1, .reusable = false}, SHIFT(2166),
  [4583] = {.count = 1, .reusable = false}, SHIFT(2167),
  [4585] = {.count = 1, .reusable = false}, SHIFT(2168),
  [4587] = {.count = 1, .reusable = false}, SHIFT(2169),
  [4589] = {.count = 1, .reusable = false}, SHIFT(2170),
  [4591] = {.count = 1, .reusable = false}, SHIFT(2171),
  [4593] = {.count = 1, .reusable = false}, SHIFT(2172),
  [4595] = {.count = 1, .reusable = false}, SHIFT(2173),
  [4597] = {.count = 1, .reusable = false}, SHIFT(2174),
  [4599] = {.count = 1, .reusable = false}, SHIFT(2175),
  [4601] = {.count = 1, .reusable = false}, SHIFT(2176),
  [4603] = {.count = 1, .reusable = false}, SHIFT(2177),
  [4605] = {.count = 1, .reusable = true}, SHIFT(2182),
  [4607] = {.count = 1, .reusable = true}, SHIFT(2183),
  [4609] = {.count = 1, .reusable = true}, SHIFT(2184),
  [4611] = {.count = 1, .reusable = false}, SHIFT(2186),
  [4613] = {.count = 1, .reusable = true}, SHIFT(2186),
  [4615] = {.count = 1, .reusable = false}, SHIFT(2188),
  [4617] = {.count = 1, .reusable = true}, SHIFT(2188),
  [4619] = {.count = 1, .reusable = false}, SHIFT(2191),
  [4621] = {.count = 1, .reusable = false}, SHIFT(2192),
  [4623] = {.count = 1, .reusable = true}, SHIFT(2193),
  [4625] = {.count = 1, .reusable = false}, SHIFT(2194),
  [4627] = {.count = 1, .reusable = false}, SHIFT(2195),
  [4629] = {.count = 1, .reusable = true}, SHIFT(2198),
  [4631] = {.count = 1, .reusable = true}, SHIFT(2201),
  [4633] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(583),
  [4636] = {.count = 1, .reusable = true}, SHIFT(2202),
  [4638] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(2203),
  [4641] = {.count = 1, .reusable = true}, SHIFT(2205),
  [4643] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(1321),
  [4646] = {.count = 1, .reusable = true}, SHIFT(2204),
  [4648] = {.count = 1, .reusable = true}, SHIFT(2207),
  [4650] = {.count = 1, .reusable = true}, SHIFT(2209),
  [4652] = {.count = 1, .reusable = true}, SHIFT(2210),
  [4654] = {.count = 1, .reusable = true}, SHIFT(2214),
  [4656] = {.count = 1, .reusable = true}, SHIFT(2215),
  [4658] = {.count = 1, .reusable = true}, SHIFT(2217),
  [4660] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(2224),
  [4663] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(1321),
  [4666] = {.count = 1, .reusable = true}, SHIFT(2227),
  [4668] = {.count = 1, .reusable = true}, SHIFT(2228),
  [4670] = {.count = 1, .reusable = true}, SHIFT(2229),
  [4672] = {.count = 1, .reusable = false}, SHIFT(2230),
  [4674] = {.count = 1, .reusable = true}, SHIFT(2231),
  [4676] = {.count = 1, .reusable = true}, REDUCE(sym_array, 4),
  [4678] = {.count = 1, .reusable = false}, REDUCE(sym_array, 4),
  [4680] = {.count = 1, .reusable = false}, SHIFT(2236),
  [4682] = {.count = 1, .reusable = true}, SHIFT(2237),
  [4684] = {.count = 1, .reusable = false}, SHIFT(2240),
  [4686] = {.count = 1, .reusable = true}, SHIFT(2240),
  [4688] = {.count = 1, .reusable = false}, SHIFT(2241),
  [4690] = {.count = 1, .reusable = true}, SHIFT(2241),
  [4692] = {.count = 1, .reusable = false}, SHIFT(2242),
  [4694] = {.count = 1, .reusable = true}, SHIFT(2242),
  [4696] = {.count = 1, .reusable = false}, SHIFT(2244),
  [4698] = {.count = 1, .reusable = true}, SHIFT(2244),
  [4700] = {.count = 1, .reusable = true}, SHIFT(2245),
  [4702] = {.count = 1, .reusable = false}, SHIFT(2246),
  [4704] = {.count = 1, .reusable = true}, SHIFT(2246),
  [4706] = {.count = 1, .reusable = false}, SHIFT(2247),
  [4708] = {.count = 1, .reusable = true}, SHIFT(2247),
  [4710] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(1347),
  [4713] = {.count = 1, .reusable = true}, SHIFT(2248),
  [4715] = {.count = 1, .reusable = true}, SHIFT(2249),
  [4717] = {.count = 1, .reusable = false}, SHIFT(2250),
  [4719] = {.count = 1, .reusable = false}, SHIFT(2251),
  [4721] = {.count = 1, .reusable = true}, SHIFT(2251),
  [4723] = {.count = 1, .reusable = false}, SHIFT(2252),
  [4725] = {.count = 1, .reusable = true}, SHIFT(2252),
  [4727] = {.count = 1, .reusable = false}, SHIFT(2254),
  [4729] = {.count = 1, .reusable = true}, SHIFT(2254),
  [4731] = {.count = 1, .reusable = false}, SHIFT(2255),
  [4733] = {.count = 1, .reusable = true}, SHIFT(2255),
  [4735] = {.count = 1, .reusable = false}, SHIFT(2256),
  [4737] = {.count = 1, .reusable = true}, SHIFT(2256),
  [4739] = {.count = 1, .reusable = false}, SHIFT(2257),
  [4741] = {.count = 1, .reusable = true}, SHIFT(2257),
  [4743] = {.count = 1, .reusable = false}, SHIFT(2258),
  [4745] = {.count = 1, .reusable = true}, SHIFT(2262),
  [4747] = {.count = 1, .reusable = true}, SHIFT(2260),
  [4749] = {.count = 1, .reusable = true}, SHIFT(2259),
  [4751] = {.count = 1, .reusable = false}, SHIFT(2261),
  [4753] = {.count = 1, .reusable = false}, SHIFT(2265),
  [4755] = {.count = 1, .reusable = false}, SHIFT(2266),
  [4757] = {.count = 1, .reusable = false}, SHIFT(2267),
  [4759] = {.count = 1, .reusable = false}, SHIFT(2268),
  [4761] = {.count = 1, .reusable = false}, SHIFT(2269),
  [4763] = {.count = 1, .reusable = false}, SHIFT(2270),
  [4765] = {.count = 1, .reusable = false}, SHIFT(2271),
  [4767] = {.count = 1, .reusable = true}, SHIFT(2271),
  [4769] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 3),
  [4771] = {.count = 1, .reusable = true}, SHIFT(2273),
  [4773] = {.count = 1, .reusable = false}, SHIFT(2274),
  [4775] = {.count = 1, .reusable = true}, SHIFT(2275),
  [4777] = {.count = 1, .reusable = true}, SHIFT(2280),
  [4779] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 3),
  [4781] = {.count = 1, .reusable = true}, SHIFT(2283),
  [4783] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .alias_sequence_id = 11),
  [4785] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .alias_sequence_id = 11),
  [4787] = {.count = 1, .reusable = true}, SHIFT(2288),
  [4789] = {.count = 1, .reusable = false}, SHIFT(2289),
  [4791] = {.count = 1, .reusable = true}, SHIFT(2286),
  [4793] = {.count = 1, .reusable = true}, SHIFT(2290),
  [4795] = {.count = 1, .reusable = false}, SHIFT(2287),
  [4797] = {.count = 1, .reusable = true}, SHIFT(2292),
  [4799] = {.count = 1, .reusable = true}, SHIFT(2291),
  [4801] = {.count = 1, .reusable = true}, SHIFT(2293),
  [4803] = {.count = 1, .reusable = false}, SHIFT(2294),
  [4805] = {.count = 1, .reusable = true}, SHIFT(2294),
  [4807] = {.count = 1, .reusable = false}, SHIFT(2295),
  [4809] = {.count = 1, .reusable = true}, SHIFT(2295),
  [4811] = {.count = 1, .reusable = false}, SHIFT(2296),
  [4813] = {.count = 1, .reusable = false}, SHIFT(2297),
  [4815] = {.count = 1, .reusable = false}, SHIFT(2298),
  [4817] = {.count = 1, .reusable = true}, SHIFT(2298),
  [4819] = {.count = 1, .reusable = false}, SHIFT(2299),
  [4821] = {.count = 1, .reusable = true}, SHIFT(2299),
  [4823] = {.count = 1, .reusable = false}, SHIFT(2300),
  [4825] = {.count = 1, .reusable = false}, SHIFT(2301),
  [4827] = {.count = 1, .reusable = false}, SHIFT(2302),
  [4829] = {.count = 1, .reusable = false}, SHIFT(2303),
  [4831] = {.count = 1, .reusable = false}, SHIFT(2304),
  [4833] = {.count = 1, .reusable = false}, SHIFT(2305),
  [4835] = {.count = 1, .reusable = true}, SHIFT(2305),
  [4837] = {.count = 1, .reusable = true}, SHIFT(2287),
  [4839] = {.count = 1, .reusable = false}, SHIFT(2306),
  [4841] = {.count = 1, .reusable = true}, SHIFT(2307),
  [4843] = {.count = 1, .reusable = false}, SHIFT(2308),
  [4845] = {.count = 1, .reusable = false}, SHIFT(2307),
  [4847] = {.count = 1, .reusable = true}, SHIFT(2309),
  [4849] = {.count = 1, .reusable = true}, SHIFT(2310),
  [4851] = {.count = 1, .reusable = false}, SHIFT(2309),
  [4853] = {.count = 1, .reusable = true}, SHIFT(2311),
  [4855] = {.count = 1, .reusable = true}, SHIFT(2306),
  [4857] = {.count = 1, .reusable = true}, SHIFT(2312),
  [4859] = {.count = 1, .reusable = false}, SHIFT(2313),
  [4861] = {.count = 1, .reusable = true}, SHIFT(2314),
  [4863] = {.count = 1, .reusable = true}, SHIFT(2315),
  [4865] = {.count = 1, .reusable = true}, SHIFT(2317),
  [4867] = {.count = 1, .reusable = false}, SHIFT(2318),
  [4869] = {.count = 1, .reusable = true}, SHIFT(2321),
  [4871] = {.count = 1, .reusable = true}, SHIFT(2319),
  [4873] = {.count = 1, .reusable = false}, SHIFT(2320),
  [4875] = {.count = 1, .reusable = false}, SHIFT(2322),
  [4877] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2),
  [4879] = {.count = 1, .reusable = true}, SHIFT(2323),
  [4881] = {.count = 1, .reusable = true}, SHIFT(2324),
  [4883] = {.count = 1, .reusable = false}, SHIFT(2327),
  [4885] = {.count = 1, .reusable = true}, SHIFT(2328),
  [4887] = {.count = 1, .reusable = true}, SHIFT(2329),
  [4889] = {.count = 1, .reusable = true}, SHIFT(2330),
  [4891] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4893] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4895] = {.count = 1, .reusable = true}, SHIFT(2335),
  [4897] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 2),
  [4899] = {.count = 1, .reusable = true}, SHIFT(2336),
  [4901] = {.count = 1, .reusable = false}, SHIFT(2338),
  [4903] = {.count = 1, .reusable = false}, SHIFT(2339),
  [4905] = {.count = 1, .reusable = false}, SHIFT(2340),
  [4907] = {.count = 1, .reusable = true}, SHIFT(2342),
  [4909] = {.count = 1, .reusable = true}, SHIFT(2341),
  [4911] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 3),
  [4913] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 3),
  [4915] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(629),
  [4918] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(628),
  [4921] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(196),
  [4924] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(630),
  [4927] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(631),
  [4930] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(632),
  [4933] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(633),
  [4936] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(634),
  [4939] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(636),
  [4942] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(641),
  [4945] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(637),
  [4948] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(638),
  [4951] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(639),
  [4954] = {.count = 1, .reusable = true}, SHIFT(2343),
  [4956] = {.count = 1, .reusable = true}, SHIFT(1203),
  [4958] = {.count = 1, .reusable = true}, SHIFT(2355),
  [4960] = {.count = 1, .reusable = true}, SHIFT(2353),
  [4962] = {.count = 1, .reusable = false}, SHIFT(2354),
  [4964] = {.count = 1, .reusable = true}, SHIFT(2357),
  [4966] = {.count = 1, .reusable = true}, SHIFT(2356),
  [4968] = {.count = 1, .reusable = false}, SHIFT(2358),
  [4970] = {.count = 1, .reusable = true}, SHIFT(2358),
  [4972] = {.count = 1, .reusable = false}, SHIFT(2359),
  [4974] = {.count = 1, .reusable = true}, SHIFT(2359),
  [4976] = {.count = 1, .reusable = false}, SHIFT(2360),
  [4978] = {.count = 1, .reusable = false}, SHIFT(2361),
  [4980] = {.count = 1, .reusable = false}, SHIFT(2362),
  [4982] = {.count = 1, .reusable = true}, SHIFT(2362),
  [4984] = {.count = 1, .reusable = false}, SHIFT(2363),
  [4986] = {.count = 1, .reusable = true}, SHIFT(2363),
  [4988] = {.count = 1, .reusable = false}, SHIFT(2364),
  [4990] = {.count = 1, .reusable = false}, SHIFT(2365),
  [4992] = {.count = 1, .reusable = false}, SHIFT(2366),
  [4994] = {.count = 1, .reusable = false}, SHIFT(2367),
  [4996] = {.count = 1, .reusable = false}, SHIFT(2368),
  [4998] = {.count = 1, .reusable = false}, SHIFT(2369),
  [5000] = {.count = 1, .reusable = true}, SHIFT(2369),
  [5002] = {.count = 1, .reusable = true}, SHIFT(2354),
  [5004] = {.count = 1, .reusable = false}, SHIFT(2370),
  [5006] = {.count = 1, .reusable = true}, SHIFT(2371),
  [5008] = {.count = 1, .reusable = false}, SHIFT(2371),
  [5010] = {.count = 1, .reusable = true}, SHIFT(2373),
  [5012] = {.count = 1, .reusable = false}, SHIFT(2372),
  [5014] = {.count = 1, .reusable = false}, SHIFT(2373),
  [5016] = {.count = 1, .reusable = true}, SHIFT(2374),
  [5018] = {.count = 1, .reusable = true}, SHIFT(2375),
  [5020] = {.count = 1, .reusable = true}, SHIFT(2370),
  [5022] = {.count = 1, .reusable = false}, SHIFT(2376),
  [5024] = {.count = 1, .reusable = true}, SHIFT(2377),
  [5026] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4, .alias_sequence_id = 12),
  [5028] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4, .alias_sequence_id = 12),
  [5030] = {.count = 1, .reusable = false}, SHIFT(2379),
  [5032] = {.count = 1, .reusable = true}, SHIFT(2378),
  [5034] = {.count = 1, .reusable = true}, SHIFT(2379),
  [5036] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 3),
  [5038] = {.count = 1, .reusable = true}, SHIFT(2382),
  [5040] = {.count = 1, .reusable = true}, SHIFT(2385),
  [5042] = {.count = 1, .reusable = true}, SHIFT(2386),
  [5044] = {.count = 1, .reusable = false}, SHIFT(2387),
  [5046] = {.count = 1, .reusable = true}, SHIFT(2388),
  [5048] = {.count = 1, .reusable = true}, SHIFT(2389),
  [5050] = {.count = 1, .reusable = true}, SHIFT(2391),
  [5052] = {.count = 1, .reusable = true}, SHIFT(2392),
  [5054] = {.count = 1, .reusable = true}, SHIFT(2393),
  [5056] = {.count = 1, .reusable = true}, SHIFT(2394),
  [5058] = {.count = 1, .reusable = true}, SHIFT(2395),
  [5060] = {.count = 1, .reusable = false}, SHIFT(2399),
  [5062] = {.count = 1, .reusable = true}, SHIFT(2400),
  [5064] = {.count = 1, .reusable = false}, SHIFT(2402),
  [5066] = {.count = 1, .reusable = false}, SHIFT(2401),
  [5068] = {.count = 1, .reusable = true}, SHIFT(2406),
  [5070] = {.count = 1, .reusable = false}, SHIFT(2405),
  [5072] = {.count = 1, .reusable = true}, SHIFT(2407),
  [5074] = {.count = 1, .reusable = true}, SHIFT(2411),
  [5076] = {.count = 1, .reusable = false}, SHIFT(2412),
  [5078] = {.count = 1, .reusable = true}, SHIFT(2413),
  [5080] = {.count = 1, .reusable = false}, SHIFT(2414),
  [5082] = {.count = 2, .reusable = true}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [5085] = {.count = 2, .reusable = false}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [5088] = {.count = 1, .reusable = true}, REDUCE(sym_computed_property_name, 3),
  [5090] = {.count = 1, .reusable = true}, SHIFT(2415),
  [5092] = {.count = 1, .reusable = false}, SHIFT(2416),
  [5094] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4),
  [5096] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4),
  [5098] = {.count = 1, .reusable = true}, SHIFT(2417),
  [5100] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3),
  [5102] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 3),
  [5104] = {.count = 1, .reusable = true}, SHIFT(2420),
  [5106] = {.count = 1, .reusable = false}, SHIFT(2418),
  [5108] = {.count = 1, .reusable = false}, SHIFT(2430),
  [5110] = {.count = 1, .reusable = false}, SHIFT(2419),
  [5112] = {.count = 1, .reusable = false}, SHIFT(2420),
  [5114] = {.count = 1, .reusable = false}, SHIFT(2421),
  [5116] = {.count = 1, .reusable = false}, SHIFT(2422),
  [5118] = {.count = 1, .reusable = false}, SHIFT(2423),
  [5120] = {.count = 1, .reusable = true}, SHIFT(2424),
  [5122] = {.count = 1, .reusable = true}, SHIFT(2430),
  [5124] = {.count = 1, .reusable = false}, SHIFT(2425),
  [5126] = {.count = 1, .reusable = false}, SHIFT(2426),
  [5128] = {.count = 1, .reusable = false}, SHIFT(2427),
  [5130] = {.count = 1, .reusable = false}, SHIFT(2428),
  [5132] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 2),
  [5134] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 2),
  [5136] = {.count = 1, .reusable = true}, SHIFT(2435),
  [5138] = {.count = 1, .reusable = true}, SHIFT(2436),
  [5140] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3),
  [5142] = {.count = 1, .reusable = true}, SHIFT(2439),
  [5144] = {.count = 1, .reusable = true}, SHIFT(2442),
  [5146] = {.count = 1, .reusable = true}, SHIFT(2443),
  [5148] = {.count = 1, .reusable = true}, SHIFT(2445),
  [5150] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3),
  [5152] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .alias_sequence_id = 6),
  [5154] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .alias_sequence_id = 6),
  [5156] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .alias_sequence_id = 14),
  [5158] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .alias_sequence_id = 14),
  [5160] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .alias_sequence_id = 15),
  [5162] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .alias_sequence_id = 15),
  [5164] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .alias_sequence_id = 1),
  [5166] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .alias_sequence_id = 1),
  [5168] = {.count = 1, .reusable = false}, SHIFT(2458),
  [5170] = {.count = 1, .reusable = true}, SHIFT(2459),
  [5172] = {.count = 1, .reusable = true}, SHIFT(2460),
  [5174] = {.count = 1, .reusable = false}, SHIFT(2461),
  [5176] = {.count = 1, .reusable = true}, SHIFT(2462),
  [5178] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 3),
  [5180] = {.count = 1, .reusable = false}, SHIFT(2466),
  [5182] = {.count = 1, .reusable = true}, SHIFT(2466),
  [5184] = {.count = 1, .reusable = false}, SHIFT(2467),
  [5186] = {.count = 1, .reusable = true}, SHIFT(2467),
  [5188] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 4),
  [5190] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [5192] = {.count = 1, .reusable = true}, SHIFT(2470),
  [5194] = {.count = 2, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(2471),
  [5197] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(757),
  [5200] = {.count = 1, .reusable = true}, SHIFT(2472),
  [5202] = {.count = 1, .reusable = true}, SHIFT(2473),
  [5204] = {.count = 1, .reusable = true}, SHIFT(2479),
  [5206] = {.count = 1, .reusable = false}, SHIFT(2480),
  [5208] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 4),
  [5210] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 4),
  [5212] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .alias_sequence_id = 18),
  [5214] = {.count = 1, .reusable = true}, SHIFT(2481),
  [5216] = {.count = 1, .reusable = true}, SHIFT(2484),
  [5218] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .alias_sequence_id = 19),
  [5220] = {.count = 1, .reusable = true}, SHIFT(2486),
  [5222] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .alias_sequence_id = 20),
  [5224] = {.count = 1, .reusable = true}, SHIFT(2489),
  [5226] = {.count = 1, .reusable = true}, SHIFT(2492),
  [5228] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .alias_sequence_id = 3),
  [5230] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .alias_sequence_id = 3),
  [5232] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .alias_sequence_id = 4),
  [5234] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .alias_sequence_id = 4),
  [5236] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4),
  [5238] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4),
  [5240] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .alias_sequence_id = 6),
  [5242] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .alias_sequence_id = 6),
  [5244] = {.count = 1, .reusable = true}, SHIFT(2495),
  [5246] = {.count = 1, .reusable = true}, REDUCE(sym_function, 4),
  [5248] = {.count = 1, .reusable = false}, REDUCE(sym_function, 4),
  [5250] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 4),
  [5252] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 4),
  [5254] = {.count = 1, .reusable = true}, SHIFT(2497),
  [5256] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 2),
  [5258] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 2),
  [5260] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 2),
  [5262] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 2),
  [5264] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 4),
  [5266] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 4),
  [5268] = {.count = 1, .reusable = true}, SHIFT(2498),
  [5270] = {.count = 1, .reusable = false}, SHIFT(2499),
  [5272] = {.count = 1, .reusable = true}, REDUCE(sym_default_type, 2),
  [5274] = {.count = 1, .reusable = true}, SHIFT(2501),
  [5276] = {.count = 1, .reusable = true}, SHIFT(2502),
  [5278] = {.count = 1, .reusable = true}, SHIFT(2500),
  [5280] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_namespace_name, 3),
  [5282] = {.count = 1, .reusable = false}, SHIFT(2505),
  [5284] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_namespace_name, 3),
  [5286] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), REDUCE(sym_jsx_namespace_name, 3),
  [5289] = {.count = 1, .reusable = true}, REDUCE(sym_constraint, 2),
  [5291] = {.count = 1, .reusable = true}, SHIFT(2508),
  [5293] = {.count = 1, .reusable = true}, SHIFT(2509),
  [5295] = {.count = 1, .reusable = true}, SHIFT(2511),
  [5297] = {.count = 1, .reusable = true}, SHIFT(2505),
  [5299] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_self_closing_element, 4),
  [5301] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_self_closing_element, 4),
  [5303] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_expression, 2),
  [5305] = {.count = 1, .reusable = true}, SHIFT(2512),
  [5307] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 4, .dynamic_precedence = -1),
  [5309] = {.count = 1, .reusable = true}, SHIFT(2513),
  [5311] = {.count = 1, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2),
  [5313] = {.count = 2, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2), SHIFT_REPEAT(797),
  [5316] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2), SHIFT_REPEAT(797),
  [5319] = {.count = 1, .reusable = false}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2),
  [5321] = {.count = 2, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2), SHIFT_REPEAT(803),
  [5324] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 3, .alias_sequence_id = 5),
  [5326] = {.count = 1, .reusable = true}, SHIFT(2515),
  [5328] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 4),
  [5330] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 4),
  [5332] = {.count = 1, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [5334] = {.count = 1, .reusable = true}, SHIFT(2517),
  [5336] = {.count = 2, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(2518),
  [5339] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 4),
  [5341] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 4),
  [5343] = {.count = 1, .reusable = true}, SHIFT(2520),
  [5345] = {.count = 1, .reusable = true}, SHIFT(2521),
  [5347] = {.count = 1, .reusable = false}, SHIFT(2524),
  [5349] = {.count = 1, .reusable = true}, SHIFT(2525),
  [5351] = {.count = 1, .reusable = true}, SHIFT(2526),
  [5353] = {.count = 1, .reusable = false}, SHIFT(2527),
  [5355] = {.count = 1, .reusable = true}, SHIFT(2528),
  [5357] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 4),
  [5359] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 4),
  [5361] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 4),
  [5363] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 4),
  [5365] = {.count = 1, .reusable = true}, SHIFT(2533),
  [5367] = {.count = 1, .reusable = true}, SHIFT(2536),
  [5369] = {.count = 1, .reusable = true}, SHIFT(2537),
  [5371] = {.count = 1, .reusable = true}, SHIFT(2539),
  [5373] = {.count = 1, .reusable = true}, SHIFT(2540),
  [5375] = {.count = 1, .reusable = true}, SHIFT(2541),
  [5377] = {.count = 1, .reusable = false}, SHIFT(2542),
  [5379] = {.count = 1, .reusable = true}, SHIFT(2543),
  [5381] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(848),
  [5384] = {.count = 1, .reusable = true}, SHIFT(2544),
  [5386] = {.count = 1, .reusable = true}, SHIFT(2545),
  [5388] = {.count = 1, .reusable = true}, SHIFT(2551),
  [5390] = {.count = 1, .reusable = true}, SHIFT(2552),
  [5392] = {.count = 1, .reusable = false}, SHIFT(2553),
  [5394] = {.count = 1, .reusable = true}, SHIFT(2554),
  [5396] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 4),
  [5398] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 4),
  [5400] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3),
  [5402] = {.count = 1, .reusable = true}, SHIFT(2555),
  [5404] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3, .alias_sequence_id = 21),
  [5406] = {.count = 1, .reusable = true}, SHIFT(2557),
  [5408] = {.count = 1, .reusable = false}, SHIFT(2559),
  [5410] = {.count = 1, .reusable = true}, SHIFT(2559),
  [5412] = {.count = 1, .reusable = false}, SHIFT(2560),
  [5414] = {.count = 1, .reusable = true}, SHIFT(2560),
  [5416] = {.count = 1, .reusable = false}, SHIFT(2561),
  [5418] = {.count = 1, .reusable = true}, SHIFT(2561),
  [5420] = {.count = 1, .reusable = false}, SHIFT(2562),
  [5422] = {.count = 1, .reusable = true}, SHIFT(2562),
  [5424] = {.count = 1, .reusable = false}, SHIFT(2563),
  [5426] = {.count = 1, .reusable = true}, SHIFT(2563),
  [5428] = {.count = 1, .reusable = false}, SHIFT(2564),
  [5430] = {.count = 1, .reusable = true}, SHIFT(2564),
  [5432] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(1688),
  [5435] = {.count = 1, .reusable = true}, SHIFT(2565),
  [5437] = {.count = 1, .reusable = true}, SHIFT(2566),
  [5439] = {.count = 1, .reusable = false}, SHIFT(2567),
  [5441] = {.count = 1, .reusable = true}, SHIFT(2567),
  [5443] = {.count = 1, .reusable = false}, SHIFT(2568),
  [5445] = {.count = 1, .reusable = true}, SHIFT(2568),
  [5447] = {.count = 1, .reusable = false}, SHIFT(2569),
  [5449] = {.count = 1, .reusable = true}, SHIFT(2569),
  [5451] = {.count = 1, .reusable = false}, SHIFT(2570),
  [5453] = {.count = 1, .reusable = true}, SHIFT(2570),
  [5455] = {.count = 1, .reusable = false}, SHIFT(2571),
  [5457] = {.count = 1, .reusable = true}, SHIFT(2571),
  [5459] = {.count = 1, .reusable = false}, SHIFT(2572),
  [5461] = {.count = 1, .reusable = true}, SHIFT(2576),
  [5463] = {.count = 1, .reusable = true}, SHIFT(2574),
  [5465] = {.count = 1, .reusable = true}, SHIFT(2573),
  [5467] = {.count = 1, .reusable = false}, SHIFT(2575),
  [5469] = {.count = 1, .reusable = false}, SHIFT(2579),
  [5471] = {.count = 1, .reusable = false}, SHIFT(2580),
  [5473] = {.count = 1, .reusable = false}, SHIFT(2581),
  [5475] = {.count = 1, .reusable = false}, SHIFT(2582),
  [5477] = {.count = 1, .reusable = false}, SHIFT(2583),
  [5479] = {.count = 1, .reusable = false}, SHIFT(2584),
  [5481] = {.count = 1, .reusable = false}, SHIFT(2585),
  [5483] = {.count = 1, .reusable = true}, SHIFT(2580),
  [5485] = {.count = 1, .reusable = false}, SHIFT(2586),
  [5487] = {.count = 1, .reusable = false}, SHIFT(2587),
  [5489] = {.count = 1, .reusable = false}, SHIFT(2588),
  [5491] = {.count = 1, .reusable = true}, SHIFT(2588),
  [5493] = {.count = 1, .reusable = true}, SHIFT(2589),
  [5495] = {.count = 1, .reusable = true}, SHIFT(2590),
  [5497] = {.count = 1, .reusable = true}, SHIFT(2592),
  [5499] = {.count = 1, .reusable = true}, SHIFT(2593),
  [5501] = {.count = 1, .reusable = true}, SHIFT(2594),
  [5503] = {.count = 1, .reusable = true}, SHIFT(2595),
  [5505] = {.count = 1, .reusable = true}, SHIFT(2596),
  [5507] = {.count = 1, .reusable = true}, SHIFT(2600),
  [5509] = {.count = 1, .reusable = true}, SHIFT(2601),
  [5511] = {.count = 1, .reusable = false}, SHIFT(2605),
  [5513] = {.count = 1, .reusable = false}, SHIFT(2604),
  [5515] = {.count = 1, .reusable = true}, SHIFT(2609),
  [5517] = {.count = 1, .reusable = false}, SHIFT(2608),
  [5519] = {.count = 1, .reusable = true}, SHIFT(2610),
  [5521] = {.count = 1, .reusable = true}, SHIFT(2614),
  [5523] = {.count = 1, .reusable = false}, SHIFT(2615),
  [5525] = {.count = 1, .reusable = true}, SHIFT(2616),
  [5527] = {.count = 1, .reusable = false}, SHIFT(2617),
  [5529] = {.count = 1, .reusable = true}, SHIFT(2618),
  [5531] = {.count = 1, .reusable = true}, SHIFT(2619),
  [5533] = {.count = 1, .reusable = true}, SHIFT(2622),
  [5535] = {.count = 1, .reusable = true}, SHIFT(1312),
  [5537] = {.count = 1, .reusable = true}, SHIFT(2624),
  [5539] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .alias_sequence_id = 16),
  [5541] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .alias_sequence_id = 16),
  [5543] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_class, 4),
  [5545] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_class, 4),
  [5547] = {.count = 1, .reusable = true}, SHIFT(2627),
  [5549] = {.count = 1, .reusable = false}, SHIFT(2628),
  [5551] = {.count = 1, .reusable = true}, SHIFT(2629),
  [5553] = {.count = 1, .reusable = true}, SHIFT(2634),
  [5555] = {.count = 1, .reusable = true}, SHIFT(2635),
  [5557] = {.count = 1, .reusable = false}, SHIFT(2637),
  [5559] = {.count = 1, .reusable = true}, SHIFT(2637),
  [5561] = {.count = 1, .reusable = false}, SHIFT(2638),
  [5563] = {.count = 1, .reusable = true}, SHIFT(2638),
  [5565] = {.count = 1, .reusable = false}, SHIFT(2639),
  [5567] = {.count = 1, .reusable = true}, SHIFT(2639),
  [5569] = {.count = 1, .reusable = false}, SHIFT(2640),
  [5571] = {.count = 1, .reusable = true}, SHIFT(2640),
  [5573] = {.count = 1, .reusable = false}, SHIFT(2641),
  [5575] = {.count = 1, .reusable = true}, SHIFT(2641),
  [5577] = {.count = 1, .reusable = false}, SHIFT(2642),
  [5579] = {.count = 1, .reusable = true}, SHIFT(2642),
  [5581] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(1752),
  [5584] = {.count = 1, .reusable = true}, SHIFT(2643),
  [5586] = {.count = 1, .reusable = true}, SHIFT(2644),
  [5588] = {.count = 1, .reusable = false}, SHIFT(2645),
  [5590] = {.count = 1, .reusable = true}, SHIFT(2645),
  [5592] = {.count = 1, .reusable = false}, SHIFT(2646),
  [5594] = {.count = 1, .reusable = true}, SHIFT(2646),
  [5596] = {.count = 1, .reusable = false}, SHIFT(2647),
  [5598] = {.count = 1, .reusable = true}, SHIFT(2647),
  [5600] = {.count = 1, .reusable = false}, SHIFT(2648),
  [5602] = {.count = 1, .reusable = true}, SHIFT(2648),
  [5604] = {.count = 1, .reusable = false}, SHIFT(2649),
  [5606] = {.count = 1, .reusable = true}, SHIFT(2649),
  [5608] = {.count = 1, .reusable = false}, SHIFT(2650),
  [5610] = {.count = 1, .reusable = true}, SHIFT(2654),
  [5612] = {.count = 1, .reusable = true}, SHIFT(2652),
  [5614] = {.count = 1, .reusable = true}, SHIFT(2651),
  [5616] = {.count = 1, .reusable = false}, SHIFT(2653),
  [5618] = {.count = 1, .reusable = false}, SHIFT(2657),
  [5620] = {.count = 1, .reusable = false}, SHIFT(2658),
  [5622] = {.count = 1, .reusable = false}, SHIFT(2659),
  [5624] = {.count = 1, .reusable = false}, SHIFT(2660),
  [5626] = {.count = 1, .reusable = false}, SHIFT(2661),
  [5628] = {.count = 1, .reusable = false}, SHIFT(2662),
  [5630] = {.count = 1, .reusable = false}, SHIFT(2663),
  [5632] = {.count = 1, .reusable = true}, SHIFT(2663),
  [5634] = {.count = 1, .reusable = false}, SHIFT(2664),
  [5636] = {.count = 1, .reusable = true}, SHIFT(2664),
  [5638] = {.count = 1, .reusable = true}, SHIFT(2667),
  [5640] = {.count = 1, .reusable = true}, SHIFT(2670),
  [5642] = {.count = 1, .reusable = true}, SHIFT(2671),
  [5644] = {.count = 1, .reusable = true}, SHIFT(2673),
  [5646] = {.count = 1, .reusable = true}, SHIFT(2676),
  [5648] = {.count = 1, .reusable = true}, SHIFT(2677),
  [5650] = {.count = 1, .reusable = true}, SHIFT(2681),
  [5652] = {.count = 1, .reusable = true}, SHIFT(2682),
  [5654] = {.count = 1, .reusable = true}, SHIFT(2684),
  [5656] = {.count = 1, .reusable = true}, SHIFT(2685),
  [5658] = {.count = 1, .reusable = true}, SHIFT(2686),
  [5660] = {.count = 1, .reusable = false}, SHIFT(2687),
  [5662] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(1992),
  [5665] = {.count = 1, .reusable = true}, SHIFT(2691),
  [5667] = {.count = 1, .reusable = false}, SHIFT(2692),
  [5669] = {.count = 1, .reusable = false}, SHIFT(2697),
  [5671] = {.count = 1, .reusable = false}, SHIFT(2693),
  [5673] = {.count = 1, .reusable = false}, SHIFT(2694),
  [5675] = {.count = 1, .reusable = false}, SHIFT(2695),
  [5677] = {.count = 1, .reusable = true}, SHIFT(2697),
  [5679] = {.count = 1, .reusable = false}, SHIFT(2696),
  [5681] = {.count = 1, .reusable = false}, SHIFT(2698),
  [5683] = {.count = 1, .reusable = false}, SHIFT(2699),
  [5685] = {.count = 1, .reusable = false}, SHIFT(2700),
  [5687] = {.count = 1, .reusable = false}, SHIFT(2701),
  [5689] = {.count = 1, .reusable = false}, SHIFT(2702),
  [5691] = {.count = 1, .reusable = false}, SHIFT(2703),
  [5693] = {.count = 1, .reusable = true}, SHIFT(2705),
  [5695] = {.count = 1, .reusable = true}, SHIFT(2707),
  [5697] = {.count = 1, .reusable = false}, SHIFT(2706),
  [5699] = {.count = 1, .reusable = false}, SHIFT(2708),
  [5701] = {.count = 1, .reusable = false}, SHIFT(2710),
  [5703] = {.count = 1, .reusable = true}, SHIFT(2711),
  [5705] = {.count = 1, .reusable = false}, SHIFT(2709),
  [5707] = {.count = 1, .reusable = false}, SHIFT(2712),
  [5709] = {.count = 1, .reusable = true}, SHIFT(2713),
  [5711] = {.count = 1, .reusable = true}, SHIFT(2714),
  [5713] = {.count = 1, .reusable = false}, SHIFT(2718),
  [5715] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_required_parameter, 1), REDUCE(sym__primary_type, 1, .alias_sequence_id = 5),
  [5719] = {.count = 1, .reusable = true}, SHIFT(2719),
  [5721] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(sym_required_parameter, 1, .alias_sequence_id = 1), REDUCE(sym_predefined_type, 1),
  [5725] = {.count = 1, .reusable = true}, SHIFT(2720),
  [5727] = {.count = 1, .reusable = false}, SHIFT(2721),
  [5729] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(2010),
  [5732] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(1994),
  [5735] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(2018),
  [5738] = {.count = 1, .reusable = true}, SHIFT(2726),
  [5740] = {.count = 1, .reusable = false}, SHIFT(2727),
  [5742] = {.count = 1, .reusable = true}, SHIFT(2728),
  [5744] = {.count = 1, .reusable = true}, SHIFT(593),
  [5746] = {.count = 1, .reusable = true}, SHIFT(2731),
  [5748] = {.count = 1, .reusable = false}, SHIFT(2732),
  [5750] = {.count = 1, .reusable = true}, SHIFT(2729),
  [5752] = {.count = 1, .reusable = false}, SHIFT(2730),
  [5754] = {.count = 1, .reusable = true}, SHIFT(2734),
  [5756] = {.count = 1, .reusable = true}, SHIFT(2733),
  [5758] = {.count = 1, .reusable = false}, SHIFT(2735),
  [5760] = {.count = 1, .reusable = true}, SHIFT(2735),
  [5762] = {.count = 1, .reusable = false}, SHIFT(2736),
  [5764] = {.count = 1, .reusable = true}, SHIFT(2736),
  [5766] = {.count = 1, .reusable = false}, SHIFT(2737),
  [5768] = {.count = 1, .reusable = false}, SHIFT(2738),
  [5770] = {.count = 1, .reusable = false}, SHIFT(2739),
  [5772] = {.count = 1, .reusable = true}, SHIFT(2739),
  [5774] = {.count = 1, .reusable = false}, SHIFT(2740),
  [5776] = {.count = 1, .reusable = true}, SHIFT(2740),
  [5778] = {.count = 1, .reusable = false}, SHIFT(2741),
  [5780] = {.count = 1, .reusable = false}, SHIFT(2742),
  [5782] = {.count = 1, .reusable = false}, SHIFT(2743),
  [5784] = {.count = 1, .reusable = false}, SHIFT(2744),
  [5786] = {.count = 1, .reusable = false}, SHIFT(2745),
  [5788] = {.count = 1, .reusable = false}, SHIFT(2746),
  [5790] = {.count = 1, .reusable = true}, SHIFT(2746),
  [5792] = {.count = 1, .reusable = true}, SHIFT(2730),
  [5794] = {.count = 1, .reusable = false}, SHIFT(2747),
  [5796] = {.count = 1, .reusable = true}, SHIFT(2748),
  [5798] = {.count = 1, .reusable = false}, SHIFT(2749),
  [5800] = {.count = 1, .reusable = false}, SHIFT(2748),
  [5802] = {.count = 1, .reusable = true}, SHIFT(2750),
  [5804] = {.count = 1, .reusable = false}, SHIFT(2750),
  [5806] = {.count = 1, .reusable = true}, SHIFT(2751),
  [5808] = {.count = 1, .reusable = true}, SHIFT(2747),
  [5810] = {.count = 1, .reusable = true}, SHIFT(2752),
  [5812] = {.count = 1, .reusable = false}, SHIFT(2753),
  [5814] = {.count = 1, .reusable = true}, SHIFT(2754),
  [5816] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_expression, 3),
  [5818] = {.count = 1, .reusable = false}, SHIFT(2755),
  [5820] = {.count = 1, .reusable = true}, SHIFT(2756),
  [5822] = {.count = 1, .reusable = false}, SHIFT(2759),
  [5824] = {.count = 1, .reusable = true}, SHIFT(2759),
  [5826] = {.count = 1, .reusable = false}, SHIFT(2760),
  [5828] = {.count = 1, .reusable = true}, SHIFT(2760),
  [5830] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(1003),
  [5833] = {.count = 1, .reusable = true}, SHIFT(2761),
  [5835] = {.count = 1, .reusable = true}, SHIFT(2762),
  [5837] = {.count = 1, .reusable = true}, SHIFT(2768),
  [5839] = {.count = 1, .reusable = false}, SHIFT(2769),
  [5841] = {.count = 1, .reusable = true}, SHIFT(2770),
  [5843] = {.count = 1, .reusable = true}, SHIFT(2773),
  [5845] = {.count = 1, .reusable = true}, SHIFT(2774),
  [5847] = {.count = 1, .reusable = false}, SHIFT(2775),
  [5849] = {.count = 1, .reusable = true}, SHIFT(2776),
  [5851] = {.count = 1, .reusable = true}, SHIFT(2781),
  [5853] = {.count = 1, .reusable = true}, SHIFT(2782),
  [5855] = {.count = 1, .reusable = true}, SHIFT(2784),
  [5857] = {.count = 1, .reusable = true}, SHIFT(2786),
  [5859] = {.count = 1, .reusable = true}, SHIFT(2788),
  [5861] = {.count = 1, .reusable = true}, SHIFT(2789),
  [5863] = {.count = 1, .reusable = true}, SHIFT(2793),
  [5865] = {.count = 1, .reusable = true}, SHIFT(2794),
  [5867] = {.count = 1, .reusable = true}, SHIFT(2796),
  [5869] = {.count = 1, .reusable = true}, SHIFT(2797),
  [5871] = {.count = 1, .reusable = false}, SHIFT(2798),
  [5873] = {.count = 1, .reusable = true}, SHIFT(2799),
  [5875] = {.count = 1, .reusable = true}, SHIFT(2804),
  [5877] = {.count = 1, .reusable = true}, SHIFT(2805),
  [5879] = {.count = 1, .reusable = true}, SHIFT(2807),
  [5881] = {.count = 1, .reusable = true}, SHIFT(2810),
  [5883] = {.count = 1, .reusable = true}, SHIFT(2812),
  [5885] = {.count = 1, .reusable = true}, SHIFT(2811),
  [5887] = {.count = 1, .reusable = true}, SHIFT(2814),
  [5889] = {.count = 1, .reusable = false}, REDUCE(sym_nested_type_identifier, 3, .alias_sequence_id = 16),
  [5891] = {.count = 1, .reusable = true}, REDUCE(sym_nested_type_identifier, 3, .alias_sequence_id = 16),
  [5893] = {.count = 1, .reusable = true}, REDUCE(sym_type_predicate, 3),
  [5895] = {.count = 1, .reusable = true}, SHIFT(2817),
  [5897] = {.count = 1, .reusable = true}, SHIFT(2818),
  [5899] = {.count = 1, .reusable = true}, SHIFT(2820),
  [5901] = {.count = 1, .reusable = true}, SHIFT(2821),
  [5903] = {.count = 1, .reusable = true}, SHIFT(2822),
  [5905] = {.count = 1, .reusable = true}, SHIFT(2823),
  [5907] = {.count = 1, .reusable = true}, SHIFT(2824),
  [5909] = {.count = 1, .reusable = true}, SHIFT(2826),
  [5911] = {.count = 1, .reusable = true}, SHIFT(2828),
  [5913] = {.count = 1, .reusable = false}, SHIFT(2829),
  [5915] = {.count = 1, .reusable = true}, SHIFT(2832),
  [5917] = {.count = 1, .reusable = true}, SHIFT(2830),
  [5919] = {.count = 1, .reusable = false}, SHIFT(2831),
  [5921] = {.count = 1, .reusable = false}, SHIFT(2833),
  [5923] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2),
  [5925] = {.count = 1, .reusable = true}, SHIFT(2834),
  [5927] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 2),
  [5929] = {.count = 1, .reusable = true}, SHIFT(2839),
  [5931] = {.count = 1, .reusable = false}, SHIFT(2840),
  [5933] = {.count = 1, .reusable = true}, SHIFT(2840),
  [5935] = {.count = 1, .reusable = true}, SHIFT(2841),
  [5937] = {.count = 1, .reusable = true}, SHIFT(127),
  [5939] = {.count = 1, .reusable = true}, SHIFT(2843),
  [5941] = {.count = 1, .reusable = true}, SHIFT(176),
  [5943] = {.count = 1, .reusable = true}, SHIFT(2844),
  [5945] = {.count = 1, .reusable = true}, SHIFT(2845),
  [5947] = {.count = 1, .reusable = true}, SHIFT(2847),
  [5949] = {.count = 1, .reusable = true}, SHIFT(2848),
  [5951] = {.count = 1, .reusable = false}, SHIFT(2849),
  [5953] = {.count = 1, .reusable = true}, SHIFT(2851),
  [5955] = {.count = 1, .reusable = true}, SHIFT(2852),
  [5957] = {.count = 1, .reusable = true}, SHIFT(2853),
  [5959] = {.count = 1, .reusable = true}, SHIFT(2854),
  [5961] = {.count = 1, .reusable = true}, SHIFT(2855),
  [5963] = {.count = 1, .reusable = true}, SHIFT(2856),
  [5965] = {.count = 1, .reusable = true}, SHIFT(2857),
  [5967] = {.count = 1, .reusable = false}, SHIFT(2858),
  [5969] = {.count = 1, .reusable = true}, SHIFT(2859),
  [5971] = {.count = 1, .reusable = true}, SHIFT(2860),
  [5973] = {.count = 1, .reusable = false}, SHIFT(2861),
  [5975] = {.count = 1, .reusable = true}, SHIFT(2862),
  [5977] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 3),
  [5979] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 3),
  [5981] = {.count = 1, .reusable = false}, SHIFT(2868),
  [5983] = {.count = 1, .reusable = true}, SHIFT(2869),
  [5985] = {.count = 1, .reusable = false}, SHIFT(2870),
  [5987] = {.count = 1, .reusable = true}, SHIFT(2871),
  [5989] = {.count = 1, .reusable = true}, SHIFT(2876),
  [5991] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 3),
  [5993] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 3),
  [5995] = {.count = 1, .reusable = true}, SHIFT(2878),
  [5997] = {.count = 1, .reusable = true}, SHIFT(2880),
  [5999] = {.count = 1, .reusable = true}, SHIFT(2882),
  [6001] = {.count = 1, .reusable = true}, SHIFT(2884),
  [6003] = {.count = 1, .reusable = false}, SHIFT(2885),
  [6005] = {.count = 1, .reusable = true}, SHIFT(2886),
  [6007] = {.count = 1, .reusable = true}, SHIFT(2891),
  [6009] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_type, 3),
  [6011] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_type, 3),
  [6013] = {.count = 1, .reusable = true}, SHIFT(2892),
  [6015] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 3),
  [6017] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 3),
  [6019] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 3),
  [6021] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 3),
  [6023] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 4),
  [6025] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 4),
  [6027] = {.count = 1, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [6029] = {.count = 1, .reusable = true}, SHIFT(2894),
  [6031] = {.count = 2, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(2895),
  [6034] = {.count = 1, .reusable = true}, SHIFT(2896),
  [6036] = {.count = 1, .reusable = false}, REDUCE(sym_array_type, 3),
  [6038] = {.count = 1, .reusable = true}, REDUCE(sym_array_type, 3),
  [6040] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 3),
  [6042] = {.count = 1, .reusable = false}, SHIFT(2898),
  [6044] = {.count = 1, .reusable = true}, SHIFT(2898),
  [6046] = {.count = 1, .reusable = false}, SHIFT(2899),
  [6048] = {.count = 1, .reusable = true}, SHIFT(2899),
  [6050] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(1146),
  [6053] = {.count = 1, .reusable = true}, SHIFT(2900),
  [6055] = {.count = 1, .reusable = true}, SHIFT(2901),
  [6057] = {.count = 1, .reusable = true}, SHIFT(2907),
  [6059] = {.count = 1, .reusable = false}, SHIFT(2908),
  [6061] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 4),
  [6063] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 4),
  [6065] = {.count = 1, .reusable = false}, SHIFT(2909),
  [6067] = {.count = 1, .reusable = true}, SHIFT(2909),
  [6069] = {.count = 1, .reusable = false}, SHIFT(2910),
  [6071] = {.count = 1, .reusable = true}, SHIFT(2910),
  [6073] = {.count = 1, .reusable = false}, SHIFT(2911),
  [6075] = {.count = 1, .reusable = true}, SHIFT(2911),
  [6077] = {.count = 1, .reusable = false}, SHIFT(2912),
  [6079] = {.count = 1, .reusable = true}, SHIFT(2912),
  [6081] = {.count = 1, .reusable = false}, SHIFT(2913),
  [6083] = {.count = 1, .reusable = true}, SHIFT(2913),
  [6085] = {.count = 1, .reusable = false}, SHIFT(2914),
  [6087] = {.count = 1, .reusable = true}, SHIFT(2914),
  [6089] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(2074),
  [6092] = {.count = 1, .reusable = true}, SHIFT(2915),
  [6094] = {.count = 1, .reusable = true}, SHIFT(2916),
  [6096] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 2),
  [6098] = {.count = 1, .reusable = false}, REDUCE(sym_await_expression, 2),
  [6100] = {.count = 1, .reusable = false}, SHIFT(2917),
  [6102] = {.count = 1, .reusable = true}, SHIFT(2917),
  [6104] = {.count = 1, .reusable = false}, SHIFT(2918),
  [6106] = {.count = 1, .reusable = true}, SHIFT(2918),
  [6108] = {.count = 1, .reusable = false}, SHIFT(2919),
  [6110] = {.count = 1, .reusable = true}, SHIFT(2919),
  [6112] = {.count = 1, .reusable = false}, SHIFT(2920),
  [6114] = {.count = 1, .reusable = true}, SHIFT(2920),
  [6116] = {.count = 1, .reusable = false}, SHIFT(2921),
  [6118] = {.count = 1, .reusable = true}, SHIFT(2921),
  [6120] = {.count = 1, .reusable = false}, SHIFT(2922),
  [6122] = {.count = 1, .reusable = true}, SHIFT(2922),
  [6124] = {.count = 1, .reusable = false}, SHIFT(2923),
  [6126] = {.count = 1, .reusable = true}, SHIFT(2927),
  [6128] = {.count = 1, .reusable = true}, SHIFT(2925),
  [6130] = {.count = 1, .reusable = true}, SHIFT(2924),
  [6132] = {.count = 1, .reusable = false}, SHIFT(2926),
  [6134] = {.count = 1, .reusable = false}, SHIFT(2930),
  [6136] = {.count = 1, .reusable = false}, SHIFT(2931),
  [6138] = {.count = 1, .reusable = false}, SHIFT(2932),
  [6140] = {.count = 1, .reusable = false}, SHIFT(2933),
  [6142] = {.count = 1, .reusable = false}, SHIFT(2934),
  [6144] = {.count = 1, .reusable = false}, SHIFT(2935),
  [6146] = {.count = 1, .reusable = false}, SHIFT(2936),
  [6148] = {.count = 1, .reusable = true}, SHIFT(2936),
  [6150] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 3),
  [6152] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 5, .alias_sequence_id = 11),
  [6154] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 5, .alias_sequence_id = 11),
  [6156] = {.count = 1, .reusable = true}, REDUCE(sym_enum_assignment, 2),
  [6158] = {.count = 1, .reusable = true}, SHIFT(2938),
  [6160] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 3),
  [6162] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 3),
  [6164] = {.count = 1, .reusable = true}, SHIFT(2940),
  [6166] = {.count = 1, .reusable = false}, SHIFT(2942),
  [6168] = {.count = 1, .reusable = false}, SHIFT(2944),
  [6170] = {.count = 1, .reusable = false}, SHIFT(2943),
  [6172] = {.count = 1, .reusable = true}, SHIFT(2948),
  [6174] = {.count = 1, .reusable = false}, SHIFT(2947),
  [6176] = {.count = 1, .reusable = true}, SHIFT(2949),
  [6178] = {.count = 1, .reusable = true}, SHIFT(2953),
  [6180] = {.count = 1, .reusable = false}, SHIFT(2954),
  [6182] = {.count = 1, .reusable = true}, SHIFT(2955),
  [6184] = {.count = 1, .reusable = false}, SHIFT(2956),
  [6186] = {.count = 1, .reusable = true}, SHIFT(2957),
  [6188] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [6190] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [6192] = {.count = 1, .reusable = true}, SHIFT(2958),
  [6194] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class, 5, .alias_sequence_id = 16),
  [6196] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class, 5, .alias_sequence_id = 16),
  [6198] = {.count = 1, .reusable = true}, SHIFT(2960),
  [6200] = {.count = 1, .reusable = false}, SHIFT(2961),
  [6202] = {.count = 1, .reusable = true}, SHIFT(2962),
  [6204] = {.count = 1, .reusable = true}, SHIFT(2967),
  [6206] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 5, .alias_sequence_id = 11),
  [6208] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 5, .alias_sequence_id = 11),
  [6210] = {.count = 1, .reusable = true}, SHIFT(2968),
  [6212] = {.count = 1, .reusable = true}, SHIFT(2970),
  [6214] = {.count = 1, .reusable = false}, REDUCE(sym_import_alias, 5),
  [6216] = {.count = 1, .reusable = true}, REDUCE(sym_import_alias, 5),
  [6218] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 5),
  [6220] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 5),
  [6222] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 3),
  [6224] = {.count = 1, .reusable = true}, SHIFT(2972),
  [6226] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 4, .alias_sequence_id = 17),
  [6228] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2, .alias_sequence_id = 17),
  [6230] = {.count = 1, .reusable = true}, SHIFT(2973),
  [6232] = {.count = 2, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(2974),
  [6235] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [6237] = {.count = 1, .reusable = true}, SHIFT(2975),
  [6239] = {.count = 1, .reusable = true}, SHIFT(2976),
  [6241] = {.count = 1, .reusable = true}, SHIFT(2977),
  [6243] = {.count = 1, .reusable = false}, SHIFT(2978),
  [6245] = {.count = 1, .reusable = true}, SHIFT(2978),
  [6247] = {.count = 1, .reusable = false}, SHIFT(2979),
  [6249] = {.count = 1, .reusable = true}, SHIFT(2979),
  [6251] = {.count = 1, .reusable = false}, SHIFT(2980),
  [6253] = {.count = 1, .reusable = true}, SHIFT(2980),
  [6255] = {.count = 1, .reusable = true}, SHIFT(2983),
  [6257] = {.count = 1, .reusable = false}, SHIFT(2984),
  [6259] = {.count = 1, .reusable = true}, SHIFT(2981),
  [6261] = {.count = 1, .reusable = false}, SHIFT(2982),
  [6263] = {.count = 1, .reusable = true}, SHIFT(2986),
  [6265] = {.count = 1, .reusable = true}, SHIFT(2985),
  [6267] = {.count = 1, .reusable = false}, SHIFT(2987),
  [6269] = {.count = 1, .reusable = true}, SHIFT(2987),
  [6271] = {.count = 1, .reusable = false}, SHIFT(2988),
  [6273] = {.count = 1, .reusable = true}, SHIFT(2988),
  [6275] = {.count = 1, .reusable = false}, SHIFT(2989),
  [6277] = {.count = 1, .reusable = false}, SHIFT(2990),
  [6279] = {.count = 1, .reusable = false}, SHIFT(2991),
  [6281] = {.count = 1, .reusable = true}, SHIFT(2991),
  [6283] = {.count = 1, .reusable = false}, SHIFT(2992),
  [6285] = {.count = 1, .reusable = true}, SHIFT(2992),
  [6287] = {.count = 1, .reusable = false}, SHIFT(2993),
  [6289] = {.count = 1, .reusable = false}, SHIFT(2994),
  [6291] = {.count = 1, .reusable = false}, SHIFT(2995),
  [6293] = {.count = 1, .reusable = false}, SHIFT(2996),
  [6295] = {.count = 1, .reusable = false}, SHIFT(2997),
  [6297] = {.count = 1, .reusable = false}, SHIFT(2998),
  [6299] = {.count = 1, .reusable = true}, SHIFT(2998),
  [6301] = {.count = 1, .reusable = true}, SHIFT(3000),
  [6303] = {.count = 1, .reusable = false}, SHIFT(3000),
  [6305] = {.count = 1, .reusable = false}, SHIFT(3001),
  [6307] = {.count = 1, .reusable = true}, SHIFT(3004),
  [6309] = {.count = 1, .reusable = false}, SHIFT(3005),
  [6311] = {.count = 1, .reusable = true}, SHIFT(3006),
  [6313] = {.count = 1, .reusable = true}, SHIFT(3007),
  [6315] = {.count = 1, .reusable = true}, SHIFT(3010),
  [6317] = {.count = 1, .reusable = false}, SHIFT(3011),
  [6319] = {.count = 1, .reusable = true}, SHIFT(3008),
  [6321] = {.count = 1, .reusable = false}, SHIFT(3009),
  [6323] = {.count = 1, .reusable = true}, SHIFT(3013),
  [6325] = {.count = 1, .reusable = true}, SHIFT(3012),
  [6327] = {.count = 1, .reusable = false}, SHIFT(3014),
  [6329] = {.count = 1, .reusable = true}, SHIFT(3014),
  [6331] = {.count = 1, .reusable = false}, SHIFT(3015),
  [6333] = {.count = 1, .reusable = true}, SHIFT(3015),
  [6335] = {.count = 1, .reusable = false}, SHIFT(3016),
  [6337] = {.count = 1, .reusable = false}, SHIFT(3017),
  [6339] = {.count = 1, .reusable = false}, SHIFT(3018),
  [6341] = {.count = 1, .reusable = true}, SHIFT(3018),
  [6343] = {.count = 1, .reusable = false}, SHIFT(3019),
  [6345] = {.count = 1, .reusable = true}, SHIFT(3019),
  [6347] = {.count = 1, .reusable = false}, SHIFT(3020),
  [6349] = {.count = 1, .reusable = false}, SHIFT(3021),
  [6351] = {.count = 1, .reusable = false}, SHIFT(3022),
  [6353] = {.count = 1, .reusable = false}, SHIFT(3023),
  [6355] = {.count = 1, .reusable = false}, SHIFT(3024),
  [6357] = {.count = 1, .reusable = false}, SHIFT(3025),
  [6359] = {.count = 1, .reusable = true}, SHIFT(3025),
  [6361] = {.count = 1, .reusable = true}, SHIFT(3009),
  [6363] = {.count = 1, .reusable = false}, SHIFT(3026),
  [6365] = {.count = 1, .reusable = true}, SHIFT(3027),
  [6367] = {.count = 1, .reusable = false}, SHIFT(3028),
  [6369] = {.count = 1, .reusable = false}, SHIFT(3027),
  [6371] = {.count = 1, .reusable = true}, SHIFT(3029),
  [6373] = {.count = 1, .reusable = false}, SHIFT(3029),
  [6375] = {.count = 1, .reusable = true}, SHIFT(3030),
  [6377] = {.count = 1, .reusable = true}, SHIFT(3026),
  [6379] = {.count = 1, .reusable = true}, SHIFT(3031),
  [6381] = {.count = 1, .reusable = false}, SHIFT(3032),
  [6383] = {.count = 1, .reusable = true}, SHIFT(3033),
  [6385] = {.count = 1, .reusable = true}, SHIFT(3034),
  [6387] = {.count = 1, .reusable = false}, SHIFT(3035),
  [6389] = {.count = 1, .reusable = true}, SHIFT(3035),
  [6391] = {.count = 1, .reusable = false}, SHIFT(3037),
  [6393] = {.count = 1, .reusable = true}, SHIFT(3037),
  [6395] = {.count = 1, .reusable = false}, SHIFT(3039),
  [6397] = {.count = 1, .reusable = true}, SHIFT(3039),
  [6399] = {.count = 1, .reusable = true}, SHIFT(3042),
  [6401] = {.count = 1, .reusable = true}, SHIFT(3043),
  [6403] = {.count = 1, .reusable = true}, SHIFT(3044),
  [6405] = {.count = 1, .reusable = true}, SHIFT(3045),
  [6407] = {.count = 1, .reusable = true}, SHIFT(3046),
  [6409] = {.count = 1, .reusable = true}, SHIFT(3047),
  [6411] = {.count = 1, .reusable = true}, SHIFT(3050),
  [6413] = {.count = 1, .reusable = false}, SHIFT(3051),
  [6415] = {.count = 1, .reusable = true}, SHIFT(3052),
  [6417] = {.count = 1, .reusable = false}, SHIFT(3054),
  [6419] = {.count = 1, .reusable = true}, SHIFT(3054),
  [6421] = {.count = 1, .reusable = true}, SHIFT(3056),
  [6423] = {.count = 1, .reusable = true}, SHIFT(3059),
  [6425] = {.count = 1, .reusable = true}, SHIFT(3060),
  [6427] = {.count = 1, .reusable = true}, SHIFT(3062),
  [6429] = {.count = 1, .reusable = true}, SHIFT(3065),
  [6431] = {.count = 1, .reusable = true}, SHIFT(3066),
  [6433] = {.count = 1, .reusable = true}, SHIFT(3070),
  [6435] = {.count = 1, .reusable = true}, SHIFT(3071),
  [6437] = {.count = 1, .reusable = true}, SHIFT(3073),
  [6439] = {.count = 1, .reusable = true}, SHIFT(3074),
  [6441] = {.count = 1, .reusable = true}, SHIFT(3077),
  [6443] = {.count = 1, .reusable = true}, SHIFT(3078),
  [6445] = {.count = 1, .reusable = true}, SHIFT(3079),
  [6447] = {.count = 2, .reusable = true}, REDUCE(sym_member_expression, 3, .alias_sequence_id = 8), REDUCE(sym_nested_type_identifier, 3, .alias_sequence_id = 16),
  [6450] = {.count = 2, .reusable = false}, REDUCE(sym_member_expression, 3, .alias_sequence_id = 8), REDUCE(sym_nested_type_identifier, 3, .alias_sequence_id = 16),
  [6453] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .alias_sequence_id = 8),
  [6456] = {.count = 1, .reusable = false}, SHIFT(3081),
  [6458] = {.count = 1, .reusable = true}, SHIFT(3081),
  [6460] = {.count = 1, .reusable = false}, SHIFT(3082),
  [6462] = {.count = 1, .reusable = true}, SHIFT(3082),
  [6464] = {.count = 1, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [6466] = {.count = 1, .reusable = false}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [6468] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(1347),
  [6471] = {.count = 1, .reusable = true}, SHIFT(3083),
  [6473] = {.count = 1, .reusable = true}, SHIFT(3084),
  [6475] = {.count = 1, .reusable = true}, SHIFT(3090),
  [6477] = {.count = 1, .reusable = false}, SHIFT(3091),
  [6479] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(1341),
  [6482] = {.count = 1, .reusable = true}, SHIFT(3094),
  [6484] = {.count = 1, .reusable = true}, SHIFT(3095),
  [6486] = {.count = 1, .reusable = true}, SHIFT(3097),
  [6488] = {.count = 1, .reusable = true}, SHIFT(3098),
  [6490] = {.count = 2, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(1353),
  [6493] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .alias_sequence_id = 11),
  [6495] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .alias_sequence_id = 11),
  [6497] = {.count = 1, .reusable = false}, SHIFT(3101),
  [6499] = {.count = 1, .reusable = true}, SHIFT(3101),
  [6501] = {.count = 1, .reusable = false}, SHIFT(3102),
  [6503] = {.count = 1, .reusable = true}, SHIFT(3102),
  [6505] = {.count = 1, .reusable = false}, SHIFT(3103),
  [6507] = {.count = 1, .reusable = true}, SHIFT(3103),
  [6509] = {.count = 1, .reusable = false}, SHIFT(3104),
  [6511] = {.count = 1, .reusable = true}, SHIFT(3104),
  [6513] = {.count = 1, .reusable = true}, SHIFT(423),
  [6515] = {.count = 1, .reusable = false}, SHIFT(3106),
  [6517] = {.count = 1, .reusable = true}, SHIFT(3106),
  [6519] = {.count = 1, .reusable = false}, SHIFT(3107),
  [6521] = {.count = 1, .reusable = true}, SHIFT(3107),
  [6523] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(2313),
  [6526] = {.count = 1, .reusable = true}, SHIFT(3109),
  [6528] = {.count = 1, .reusable = true}, SHIFT(3110),
  [6530] = {.count = 1, .reusable = false}, SHIFT(3111),
  [6532] = {.count = 1, .reusable = true}, SHIFT(3111),
  [6534] = {.count = 1, .reusable = false}, SHIFT(3112),
  [6536] = {.count = 1, .reusable = true}, SHIFT(3112),
  [6538] = {.count = 1, .reusable = false}, SHIFT(3113),
  [6540] = {.count = 1, .reusable = true}, SHIFT(3113),
  [6542] = {.count = 1, .reusable = false}, SHIFT(3114),
  [6544] = {.count = 1, .reusable = true}, SHIFT(3114),
  [6546] = {.count = 1, .reusable = false}, SHIFT(3115),
  [6548] = {.count = 1, .reusable = true}, SHIFT(3115),
  [6550] = {.count = 1, .reusable = false}, SHIFT(3116),
  [6552] = {.count = 1, .reusable = true}, SHIFT(3120),
  [6554] = {.count = 1, .reusable = true}, SHIFT(3118),
  [6556] = {.count = 1, .reusable = true}, SHIFT(3117),
  [6558] = {.count = 1, .reusable = false}, SHIFT(3119),
  [6560] = {.count = 1, .reusable = false}, SHIFT(3123),
  [6562] = {.count = 1, .reusable = false}, SHIFT(3124),
  [6564] = {.count = 1, .reusable = false}, SHIFT(3125),
  [6566] = {.count = 1, .reusable = false}, SHIFT(3126),
  [6568] = {.count = 1, .reusable = false}, SHIFT(3127),
  [6570] = {.count = 1, .reusable = false}, SHIFT(3128),
  [6572] = {.count = 1, .reusable = false}, SHIFT(3129),
  [6574] = {.count = 1, .reusable = true}, SHIFT(3129),
  [6576] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 3),
  [6578] = {.count = 1, .reusable = true}, SHIFT(3132),
  [6580] = {.count = 1, .reusable = true}, SHIFT(3133),
  [6582] = {.count = 1, .reusable = true}, SHIFT(3135),
  [6584] = {.count = 1, .reusable = false}, SHIFT(3134),
  [6586] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3),
  [6588] = {.count = 1, .reusable = true}, SHIFT(3136),
  [6590] = {.count = 1, .reusable = true}, SHIFT(3137),
  [6592] = {.count = 1, .reusable = true}, SHIFT(3140),
  [6594] = {.count = 1, .reusable = true}, SHIFT(3143),
  [6596] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 3),
  [6598] = {.count = 1, .reusable = false}, SHIFT(3144),
  [6600] = {.count = 1, .reusable = true}, SHIFT(3145),
  [6602] = {.count = 1, .reusable = true}, SHIFT(3146),
  [6604] = {.count = 1, .reusable = false}, SHIFT(3147),
  [6606] = {.count = 1, .reusable = true}, SHIFT(3148),
  [6608] = {.count = 1, .reusable = true}, SHIFT(3152),
  [6610] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 3),
  [6612] = {.count = 1, .reusable = false}, SHIFT(3154),
  [6614] = {.count = 1, .reusable = true}, SHIFT(3156),
  [6616] = {.count = 1, .reusable = false}, SHIFT(3155),
  [6618] = {.count = 1, .reusable = true}, SHIFT(3157),
  [6620] = {.count = 1, .reusable = true}, SHIFT(3158),
  [6622] = {.count = 1, .reusable = true}, SHIFT(3159),
  [6624] = {.count = 1, .reusable = false}, SHIFT(3160),
  [6626] = {.count = 1, .reusable = true}, SHIFT(3161),
  [6628] = {.count = 1, .reusable = true}, SHIFT(3162),
  [6630] = {.count = 1, .reusable = false}, SHIFT(3163),
  [6632] = {.count = 1, .reusable = true}, SHIFT(3164),
  [6634] = {.count = 1, .reusable = false}, SHIFT(3174),
  [6636] = {.count = 1, .reusable = true}, SHIFT(3174),
  [6638] = {.count = 1, .reusable = false}, SHIFT(3175),
  [6640] = {.count = 1, .reusable = true}, SHIFT(3175),
  [6642] = {.count = 1, .reusable = false}, SHIFT(3176),
  [6644] = {.count = 1, .reusable = true}, SHIFT(3176),
  [6646] = {.count = 1, .reusable = false}, SHIFT(3177),
  [6648] = {.count = 1, .reusable = true}, SHIFT(3177),
  [6650] = {.count = 1, .reusable = false}, SHIFT(3178),
  [6652] = {.count = 1, .reusable = true}, SHIFT(3178),
  [6654] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(2376),
  [6657] = {.count = 1, .reusable = true}, SHIFT(3179),
  [6659] = {.count = 1, .reusable = true}, SHIFT(3180),
  [6661] = {.count = 1, .reusable = false}, SHIFT(3181),
  [6663] = {.count = 1, .reusable = true}, SHIFT(3181),
  [6665] = {.count = 1, .reusable = false}, SHIFT(3182),
  [6667] = {.count = 1, .reusable = true}, SHIFT(3182),
  [6669] = {.count = 1, .reusable = false}, SHIFT(3183),
  [6671] = {.count = 1, .reusable = true}, SHIFT(3183),
  [6673] = {.count = 1, .reusable = false}, SHIFT(3184),
  [6675] = {.count = 1, .reusable = true}, SHIFT(3184),
  [6677] = {.count = 1, .reusable = false}, SHIFT(3185),
  [6679] = {.count = 1, .reusable = true}, SHIFT(3185),
  [6681] = {.count = 1, .reusable = false}, SHIFT(3186),
  [6683] = {.count = 1, .reusable = true}, SHIFT(3190),
  [6685] = {.count = 1, .reusable = true}, SHIFT(3188),
  [6687] = {.count = 1, .reusable = true}, SHIFT(3187),
  [6689] = {.count = 1, .reusable = false}, SHIFT(3189),
  [6691] = {.count = 1, .reusable = false}, SHIFT(3193),
  [6693] = {.count = 1, .reusable = false}, SHIFT(3194),
  [6695] = {.count = 1, .reusable = false}, SHIFT(3195),
  [6697] = {.count = 1, .reusable = false}, SHIFT(3196),
  [6699] = {.count = 1, .reusable = false}, SHIFT(3197),
  [6701] = {.count = 1, .reusable = false}, SHIFT(3198),
  [6703] = {.count = 1, .reusable = false}, SHIFT(3199),
  [6705] = {.count = 1, .reusable = true}, SHIFT(3199),
  [6707] = {.count = 1, .reusable = true}, SHIFT(3200),
  [6709] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 4),
  [6711] = {.count = 1, .reusable = true}, SHIFT(3204),
  [6713] = {.count = 1, .reusable = true}, SHIFT(3205),
  [6715] = {.count = 1, .reusable = true}, SHIFT(3207),
  [6717] = {.count = 1, .reusable = false}, SHIFT(3208),
  [6719] = {.count = 1, .reusable = false}, SHIFT(3209),
  [6721] = {.count = 1, .reusable = false}, SHIFT(3210),
  [6723] = {.count = 1, .reusable = true}, SHIFT(3214),
  [6725] = {.count = 1, .reusable = true}, SHIFT(3215),
  [6727] = {.count = 1, .reusable = true}, SHIFT(3218),
  [6729] = {.count = 1, .reusable = true}, SHIFT(3219),
  [6731] = {.count = 1, .reusable = true}, SHIFT(3220),
  [6733] = {.count = 1, .reusable = false}, SHIFT(3221),
  [6735] = {.count = 1, .reusable = true}, SHIFT(3221),
  [6737] = {.count = 1, .reusable = false}, SHIFT(3223),
  [6739] = {.count = 1, .reusable = true}, SHIFT(3223),
  [6741] = {.count = 1, .reusable = true}, SHIFT(3224),
  [6743] = {.count = 1, .reusable = true}, SHIFT(3225),
  [6745] = {.count = 1, .reusable = true}, SHIFT(3226),
  [6747] = {.count = 1, .reusable = false}, SHIFT(3228),
  [6749] = {.count = 1, .reusable = true}, SHIFT(3227),
  [6751] = {.count = 1, .reusable = true}, SHIFT(3228),
  [6753] = {.count = 1, .reusable = false}, SHIFT(3230),
  [6755] = {.count = 1, .reusable = true}, SHIFT(3230),
  [6757] = {.count = 1, .reusable = false}, SHIFT(3231),
  [6759] = {.count = 1, .reusable = true}, SHIFT(3231),
  [6761] = {.count = 1, .reusable = false}, SHIFT(3233),
  [6763] = {.count = 1, .reusable = true}, SHIFT(3233),
  [6765] = {.count = 1, .reusable = false}, SHIFT(3234),
  [6767] = {.count = 1, .reusable = true}, SHIFT(3234),
  [6769] = {.count = 1, .reusable = true}, SHIFT(3236),
  [6771] = {.count = 1, .reusable = false}, SHIFT(3237),
  [6773] = {.count = 1, .reusable = true}, SHIFT(3238),
  [6775] = {.count = 1, .reusable = true}, REDUCE(sym_object, 5),
  [6777] = {.count = 1, .reusable = false}, REDUCE(sym_object, 5),
  [6779] = {.count = 1, .reusable = true}, SHIFT(3241),
  [6781] = {.count = 1, .reusable = false}, SHIFT(3242),
  [6783] = {.count = 1, .reusable = true}, SHIFT(3239),
  [6785] = {.count = 1, .reusable = false}, SHIFT(3240),
  [6787] = {.count = 1, .reusable = true}, SHIFT(3244),
  [6789] = {.count = 1, .reusable = true}, SHIFT(3243),
  [6791] = {.count = 1, .reusable = false}, SHIFT(3245),
  [6793] = {.count = 1, .reusable = true}, SHIFT(3245),
  [6795] = {.count = 1, .reusable = false}, SHIFT(3246),
  [6797] = {.count = 1, .reusable = true}, SHIFT(3246),
  [6799] = {.count = 1, .reusable = false}, SHIFT(3247),
  [6801] = {.count = 1, .reusable = false}, SHIFT(3248),
  [6803] = {.count = 1, .reusable = false}, SHIFT(3249),
  [6805] = {.count = 1, .reusable = true}, SHIFT(3249),
  [6807] = {.count = 1, .reusable = false}, SHIFT(3250),
  [6809] = {.count = 1, .reusable = true}, SHIFT(3250),
  [6811] = {.count = 1, .reusable = false}, SHIFT(3251),
  [6813] = {.count = 1, .reusable = false}, SHIFT(3252),
  [6815] = {.count = 1, .reusable = false}, SHIFT(3253),
  [6817] = {.count = 1, .reusable = false}, SHIFT(3254),
  [6819] = {.count = 1, .reusable = false}, SHIFT(3255),
  [6821] = {.count = 1, .reusable = false}, SHIFT(3256),
  [6823] = {.count = 1, .reusable = true}, SHIFT(3256),
  [6825] = {.count = 1, .reusable = true}, SHIFT(3240),
  [6827] = {.count = 1, .reusable = false}, SHIFT(3257),
  [6829] = {.count = 1, .reusable = true}, SHIFT(3261),
  [6831] = {.count = 1, .reusable = true}, SHIFT(3258),
  [6833] = {.count = 1, .reusable = false}, SHIFT(3259),
  [6835] = {.count = 1, .reusable = true}, SHIFT(3260),
  [6837] = {.count = 1, .reusable = false}, SHIFT(3258),
  [6839] = {.count = 1, .reusable = false}, SHIFT(3260),
  [6841] = {.count = 1, .reusable = true}, SHIFT(3262),
  [6843] = {.count = 1, .reusable = true}, SHIFT(3257),
  [6845] = {.count = 1, .reusable = true}, SHIFT(3263),
  [6847] = {.count = 1, .reusable = false}, SHIFT(3264),
  [6849] = {.count = 1, .reusable = true}, SHIFT(3265),
  [6851] = {.count = 1, .reusable = true}, SHIFT(3266),
  [6853] = {.count = 1, .reusable = false}, SHIFT(3267),
  [6855] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 2),
  [6857] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 2),
  [6859] = {.count = 1, .reusable = false}, SHIFT(3268),
  [6861] = {.count = 1, .reusable = false}, SHIFT(3269),
  [6863] = {.count = 1, .reusable = false}, SHIFT(3270),
  [6865] = {.count = 1, .reusable = false}, SHIFT(3271),
  [6867] = {.count = 1, .reusable = false}, SHIFT(3272),
  [6869] = {.count = 1, .reusable = false}, SHIFT(3273),
  [6871] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 3),
  [6873] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 3),
  [6875] = {.count = 1, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [6877] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(1474),
  [6880] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(1472),
  [6883] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4),
  [6885] = {.count = 1, .reusable = true}, SHIFT(3276),
  [6887] = {.count = 1, .reusable = false}, SHIFT(3277),
  [6889] = {.count = 1, .reusable = true}, SHIFT(3278),
  [6891] = {.count = 1, .reusable = true}, SHIFT(3283),
  [6893] = {.count = 1, .reusable = true}, SHIFT(3284),
  [6895] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .alias_sequence_id = 6),
  [6897] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4, .alias_sequence_id = 6),
  [6899] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4),
  [6901] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .alias_sequence_id = 14),
  [6903] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4, .alias_sequence_id = 14),
  [6905] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .alias_sequence_id = 15),
  [6907] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4, .alias_sequence_id = 15),
  [6909] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .alias_sequence_id = 1),
  [6911] = {.count = 1, .reusable = true}, SHIFT(3290),
  [6913] = {.count = 1, .reusable = true}, SHIFT(3293),
  [6915] = {.count = 1, .reusable = true}, SHIFT(3294),
  [6917] = {.count = 1, .reusable = true}, SHIFT(3296),
  [6919] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 3),
  [6921] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 5),
  [6923] = {.count = 1, .reusable = false}, SHIFT(3297),
  [6925] = {.count = 1, .reusable = true}, SHIFT(3297),
  [6927] = {.count = 1, .reusable = true}, SHIFT(3300),
  [6929] = {.count = 1, .reusable = true}, SHIFT(3301),
  [6931] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .alias_sequence_id = 18),
  [6933] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4, .alias_sequence_id = 18),
  [6935] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .alias_sequence_id = 19),
  [6937] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4, .alias_sequence_id = 19),
  [6939] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .alias_sequence_id = 20),
  [6941] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4, .alias_sequence_id = 20),
  [6943] = {.count = 1, .reusable = true}, SHIFT(3314),
  [6945] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .alias_sequence_id = 3),
  [6947] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .alias_sequence_id = 4),
  [6949] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 5),
  [6951] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 5),
  [6953] = {.count = 1, .reusable = true}, REDUCE(sym_function, 5),
  [6955] = {.count = 1, .reusable = false}, REDUCE(sym_function, 5),
  [6957] = {.count = 1, .reusable = true}, SHIFT(3315),
  [6959] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_fragment, 5),
  [6961] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_fragment, 5),
  [6963] = {.count = 1, .reusable = true}, SHIFT(3316),
  [6965] = {.count = 1, .reusable = true}, SHIFT(3318),
  [6967] = {.count = 1, .reusable = false}, SHIFT(3317),
  [6969] = {.count = 1, .reusable = true}, SHIFT(3319),
  [6971] = {.count = 1, .reusable = false}, SHIFT(3320),
  [6973] = {.count = 1, .reusable = true}, SHIFT(3321),
  [6975] = {.count = 1, .reusable = true}, SHIFT(3324),
  [6977] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 3, .alias_sequence_id = 2),
  [6979] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 3, .alias_sequence_id = 2),
  [6981] = {.count = 1, .reusable = false}, SHIFT(3327),
  [6983] = {.count = 1, .reusable = false}, SHIFT(3325),
  [6985] = {.count = 1, .reusable = true}, SHIFT(3328),
  [6987] = {.count = 1, .reusable = false}, SHIFT(3329),
  [6989] = {.count = 1, .reusable = true}, SHIFT(3330),
  [6991] = {.count = 1, .reusable = true}, SHIFT(3335),
  [6993] = {.count = 1, .reusable = true}, SHIFT(3336),
  [6995] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_expression, 3),
  [6997] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_self_closing_element, 5),
  [6999] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_self_closing_element, 5),
  [7001] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 3),
  [7003] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 3),
  [7005] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 5, .dynamic_precedence = -1),
  [7007] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 5),
  [7009] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 5),
  [7011] = {.count = 1, .reusable = true}, SHIFT(3338),
  [7013] = {.count = 1, .reusable = true}, SHIFT(3339),
  [7015] = {.count = 1, .reusable = true}, SHIFT(3341),
  [7017] = {.count = 1, .reusable = true}, SHIFT(3344),
  [7019] = {.count = 1, .reusable = true}, SHIFT(3345),
  [7021] = {.count = 1, .reusable = true}, SHIFT(3347),
  [7023] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 5),
  [7025] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 5),
  [7027] = {.count = 1, .reusable = true}, SHIFT(3348),
  [7029] = {.count = 1, .reusable = false}, SHIFT(3349),
  [7031] = {.count = 1, .reusable = true}, SHIFT(3350),
  [7033] = {.count = 1, .reusable = true}, SHIFT(3355),
  [7035] = {.count = 1, .reusable = true}, SHIFT(3356),
  [7037] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_rest_parameter, 2),
  [7040] = {.count = 1, .reusable = false}, SHIFT(3358),
  [7042] = {.count = 1, .reusable = true}, SHIFT(3358),
  [7044] = {.count = 1, .reusable = true}, SHIFT(3361),
  [7046] = {.count = 1, .reusable = true}, SHIFT(3362),
  [7048] = {.count = 1, .reusable = true}, SHIFT(3364),
  [7050] = {.count = 1, .reusable = true}, SHIFT(3365),
  [7052] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 4, .alias_sequence_id = 21),
  [7054] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2, .alias_sequence_id = 21),
  [7056] = {.count = 1, .reusable = true}, SHIFT(3366),
  [7058] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(3367),
  [7061] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [7063] = {.count = 1, .reusable = false}, SHIFT(3368),
  [7065] = {.count = 1, .reusable = true}, SHIFT(3368),
  [7067] = {.count = 1, .reusable = false}, SHIFT(3369),
  [7069] = {.count = 1, .reusable = true}, SHIFT(3369),
  [7071] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(1688),
  [7074] = {.count = 1, .reusable = true}, SHIFT(3370),
  [7076] = {.count = 1, .reusable = true}, SHIFT(3371),
  [7078] = {.count = 1, .reusable = true}, SHIFT(3377),
  [7080] = {.count = 1, .reusable = true}, SHIFT(3378),
  [7082] = {.count = 1, .reusable = false}, SHIFT(3379),
  [7084] = {.count = 1, .reusable = true}, SHIFT(3380),
  [7086] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 5),
  [7088] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 5),
  [7090] = {.count = 1, .reusable = true}, SHIFT(3382),
  [7092] = {.count = 1, .reusable = false}, SHIFT(3383),
  [7094] = {.count = 1, .reusable = false}, SHIFT(3384),
  [7096] = {.count = 1, .reusable = false}, SHIFT(3385),
  [7098] = {.count = 1, .reusable = true}, SHIFT(3389),
  [7100] = {.count = 1, .reusable = true}, SHIFT(3391),
  [7102] = {.count = 1, .reusable = true}, SHIFT(3394),
  [7104] = {.count = 1, .reusable = true}, SHIFT(3395),
  [7106] = {.count = 1, .reusable = true}, SHIFT(3396),
  [7108] = {.count = 1, .reusable = false}, SHIFT(3397),
  [7110] = {.count = 1, .reusable = true}, SHIFT(3397),
  [7112] = {.count = 1, .reusable = false}, SHIFT(3399),
  [7114] = {.count = 1, .reusable = true}, SHIFT(3399),
  [7116] = {.count = 1, .reusable = true}, SHIFT(3400),
  [7118] = {.count = 1, .reusable = true}, SHIFT(3401),
  [7120] = {.count = 1, .reusable = true}, SHIFT(3402),
  [7122] = {.count = 1, .reusable = false}, SHIFT(3404),
  [7124] = {.count = 1, .reusable = true}, SHIFT(3403),
  [7126] = {.count = 1, .reusable = true}, SHIFT(3404),
  [7128] = {.count = 1, .reusable = false}, SHIFT(3406),
  [7130] = {.count = 1, .reusable = true}, SHIFT(3406),
  [7132] = {.count = 1, .reusable = false}, SHIFT(3407),
  [7134] = {.count = 1, .reusable = true}, SHIFT(3407),
  [7136] = {.count = 1, .reusable = false}, SHIFT(3409),
  [7138] = {.count = 1, .reusable = true}, SHIFT(3409),
  [7140] = {.count = 1, .reusable = false}, SHIFT(3410),
  [7142] = {.count = 1, .reusable = true}, SHIFT(3410),
  [7144] = {.count = 1, .reusable = true}, SHIFT(3412),
  [7146] = {.count = 1, .reusable = false}, REDUCE(sym_do_statement, 5),
  [7148] = {.count = 1, .reusable = true}, REDUCE(sym_do_statement, 5),
  [7150] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .alias_sequence_id = 16),
  [7152] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .alias_sequence_id = 16),
  [7154] = {.count = 1, .reusable = true}, SHIFT(3418),
  [7156] = {.count = 1, .reusable = true}, SHIFT(3419),
  [7158] = {.count = 1, .reusable = true}, SHIFT(3421),
  [7160] = {.count = 1, .reusable = true}, SHIFT(3422),
  [7162] = {.count = 1, .reusable = false}, SHIFT(3425),
  [7164] = {.count = 1, .reusable = true}, SHIFT(3425),
  [7166] = {.count = 1, .reusable = false}, SHIFT(3426),
  [7168] = {.count = 1, .reusable = true}, SHIFT(3426),
  [7170] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(1752),
  [7173] = {.count = 1, .reusable = true}, SHIFT(3427),
  [7175] = {.count = 1, .reusable = true}, SHIFT(3428),
  [7177] = {.count = 1, .reusable = true}, SHIFT(3434),
  [7179] = {.count = 1, .reusable = false}, SHIFT(3435),
  [7181] = {.count = 1, .reusable = true}, REDUCE(sym_ternary_expression, 5),
  [7183] = {.count = 1, .reusable = true}, SHIFT(3436),
  [7185] = {.count = 1, .reusable = true}, SHIFT(3437),
  [7187] = {.count = 1, .reusable = true}, SHIFT(3438),
  [7189] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .alias_sequence_id = 16),
  [7192] = {.count = 1, .reusable = false}, REDUCE(sym_type_predicate, 3),
  [7194] = {.count = 1, .reusable = false}, SHIFT(1776),
  [7196] = {.count = 1, .reusable = false}, SHIFT(1775),
  [7198] = {.count = 1, .reusable = true}, SHIFT(3440),
  [7200] = {.count = 1, .reusable = true}, SHIFT(3441),
  [7202] = {.count = 1, .reusable = true}, SHIFT(3443),
  [7204] = {.count = 1, .reusable = true}, SHIFT(3444),
  [7206] = {.count = 1, .reusable = true}, SHIFT(3446),
  [7208] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 3),
  [7210] = {.count = 1, .reusable = true}, SHIFT(3448),
  [7212] = {.count = 1, .reusable = true}, SHIFT(3449),
  [7214] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(2876),
  [7217] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(2880),
  [7220] = {.count = 1, .reusable = true}, SHIFT(3451),
  [7222] = {.count = 1, .reusable = true}, SHIFT(3452),
  [7224] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .alias_sequence_id = 2), REDUCE(aux_sym_object_repeat1, 2, .alias_sequence_id = 12),
  [7227] = {.count = 1, .reusable = true}, SHIFT(3453),
  [7229] = {.count = 1, .reusable = true}, SHIFT(3455),
  [7231] = {.count = 1, .reusable = false}, SHIFT(3456),
  [7233] = {.count = 1, .reusable = true}, SHIFT(3459),
  [7235] = {.count = 1, .reusable = true}, SHIFT(3457),
  [7237] = {.count = 1, .reusable = false}, SHIFT(3458),
  [7239] = {.count = 1, .reusable = false}, SHIFT(3460),
  [7241] = {.count = 1, .reusable = true}, SHIFT(3461),
  [7243] = {.count = 1, .reusable = false}, SHIFT(3462),
  [7245] = {.count = 1, .reusable = false}, SHIFT(3463),
  [7247] = {.count = 1, .reusable = true}, SHIFT(3464),
  [7249] = {.count = 1, .reusable = false}, SHIFT(3465),
  [7251] = {.count = 1, .reusable = false}, SHIFT(3466),
  [7253] = {.count = 1, .reusable = false}, SHIFT(3467),
  [7255] = {.count = 1, .reusable = false}, SHIFT(3468),
  [7257] = {.count = 1, .reusable = false}, SHIFT(3469),
  [7259] = {.count = 1, .reusable = true}, SHIFT(3470),
  [7261] = {.count = 1, .reusable = true}, SHIFT(3463),
  [7263] = {.count = 1, .reusable = false}, SHIFT(3471),
  [7265] = {.count = 1, .reusable = false}, SHIFT(3472),
  [7267] = {.count = 1, .reusable = true}, SHIFT(3476),
  [7269] = {.count = 1, .reusable = false}, SHIFT(3477),
  [7271] = {.count = 1, .reusable = true}, SHIFT(3478),
  [7273] = {.count = 1, .reusable = true}, SHIFT(3479),
  [7275] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(2891),
  [7278] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(2892),
  [7281] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(2882),
  [7284] = {.count = 1, .reusable = true}, SHIFT(3481),
  [7286] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_closing_element, 4),
  [7288] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_closing_element, 4),
  [7290] = {.count = 1, .reusable = false}, SHIFT(3482),
  [7292] = {.count = 1, .reusable = true}, SHIFT(3482),
  [7294] = {.count = 1, .reusable = false}, SHIFT(3483),
  [7296] = {.count = 1, .reusable = true}, SHIFT(3483),
  [7298] = {.count = 1, .reusable = false}, SHIFT(3484),
  [7300] = {.count = 1, .reusable = true}, SHIFT(3484),
  [7302] = {.count = 1, .reusable = false}, SHIFT(3485),
  [7304] = {.count = 1, .reusable = true}, SHIFT(3485),
  [7306] = {.count = 1, .reusable = false}, SHIFT(3486),
  [7308] = {.count = 1, .reusable = true}, SHIFT(3486),
  [7310] = {.count = 1, .reusable = false}, SHIFT(3487),
  [7312] = {.count = 1, .reusable = true}, SHIFT(3487),
  [7314] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(2753),
  [7317] = {.count = 1, .reusable = true}, SHIFT(3488),
  [7319] = {.count = 1, .reusable = true}, SHIFT(3489),
  [7321] = {.count = 1, .reusable = false}, SHIFT(3490),
  [7323] = {.count = 1, .reusable = true}, SHIFT(3490),
  [7325] = {.count = 1, .reusable = false}, SHIFT(3491),
  [7327] = {.count = 1, .reusable = true}, SHIFT(3491),
  [7329] = {.count = 1, .reusable = false}, SHIFT(3492),
  [7331] = {.count = 1, .reusable = true}, SHIFT(3492),
  [7333] = {.count = 1, .reusable = false}, SHIFT(3493),
  [7335] = {.count = 1, .reusable = true}, SHIFT(3493),
  [7337] = {.count = 1, .reusable = false}, SHIFT(3494),
  [7339] = {.count = 1, .reusable = true}, SHIFT(3494),
  [7341] = {.count = 1, .reusable = false}, SHIFT(3495),
  [7343] = {.count = 1, .reusable = true}, SHIFT(3499),
  [7345] = {.count = 1, .reusable = true}, SHIFT(3497),
  [7347] = {.count = 1, .reusable = true}, SHIFT(3496),
  [7349] = {.count = 1, .reusable = false}, SHIFT(3498),
  [7351] = {.count = 1, .reusable = false}, SHIFT(3502),
  [7353] = {.count = 1, .reusable = false}, SHIFT(3503),
  [7355] = {.count = 1, .reusable = false}, SHIFT(3504),
  [7357] = {.count = 1, .reusable = false}, SHIFT(3505),
  [7359] = {.count = 1, .reusable = false}, SHIFT(3506),
  [7361] = {.count = 1, .reusable = false}, SHIFT(3507),
  [7363] = {.count = 1, .reusable = false}, SHIFT(3508),
  [7365] = {.count = 1, .reusable = true}, SHIFT(3508),
  [7367] = {.count = 1, .reusable = true}, SHIFT(3509),
  [7369] = {.count = 1, .reusable = false}, SHIFT(3510),
  [7371] = {.count = 1, .reusable = true}, SHIFT(3510),
  [7373] = {.count = 1, .reusable = true}, SHIFT(3513),
  [7375] = {.count = 1, .reusable = true}, SHIFT(3514),
  [7377] = {.count = 1, .reusable = true}, SHIFT(3516),
  [7379] = {.count = 1, .reusable = true}, SHIFT(3517),
  [7381] = {.count = 1, .reusable = true}, SHIFT(3518),
  [7383] = {.count = 1, .reusable = true}, SHIFT(3522),
  [7385] = {.count = 1, .reusable = true}, SHIFT(3523),
  [7387] = {.count = 1, .reusable = true}, SHIFT(3525),
  [7389] = {.count = 1, .reusable = true}, SHIFT(3526),
  [7391] = {.count = 1, .reusable = true}, SHIFT(3527),
  [7393] = {.count = 1, .reusable = true}, SHIFT(3529),
  [7395] = {.count = 1, .reusable = true}, SHIFT(3530),
  [7397] = {.count = 1, .reusable = true}, SHIFT(3531),
  [7399] = {.count = 1, .reusable = true}, SHIFT(3533),
  [7401] = {.count = 1, .reusable = true}, SHIFT(3537),
  [7403] = {.count = 1, .reusable = true}, SHIFT(3538),
  [7405] = {.count = 1, .reusable = true}, SHIFT(3540),
  [7407] = {.count = 1, .reusable = true}, SHIFT(3541),
  [7409] = {.count = 1, .reusable = true}, SHIFT(3544),
  [7411] = {.count = 1, .reusable = false}, SHIFT(3545),
  [7413] = {.count = 1, .reusable = true}, SHIFT(3546),
  [7415] = {.count = 1, .reusable = true}, SHIFT(3551),
  [7417] = {.count = 1, .reusable = false}, REDUCE(sym_lookup_type, 4, .alias_sequence_id = 5),
  [7419] = {.count = 1, .reusable = true}, REDUCE(sym_lookup_type, 4, .alias_sequence_id = 5),
  [7421] = {.count = 1, .reusable = true}, SHIFT(3552),
  [7423] = {.count = 1, .reusable = true}, SHIFT(3555),
  [7425] = {.count = 1, .reusable = true}, SHIFT(3556),
  [7427] = {.count = 1, .reusable = true}, SHIFT(3560),
  [7429] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 4),
  [7431] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 4),
  [7433] = {.count = 1, .reusable = true}, SHIFT(3561),
  [7435] = {.count = 1, .reusable = true}, SHIFT(3563),
  [7437] = {.count = 1, .reusable = true}, SHIFT(3564),
  [7439] = {.count = 1, .reusable = true}, SHIFT(3566),
  [7441] = {.count = 1, .reusable = false}, SHIFT(3565),
  [7443] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3),
  [7445] = {.count = 1, .reusable = true}, SHIFT(3567),
  [7447] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 3),
  [7449] = {.count = 1, .reusable = true}, SHIFT(3570),
  [7451] = {.count = 1, .reusable = true}, SHIFT(3575),
  [7453] = {.count = 1, .reusable = true}, SHIFT(3576),
  [7455] = {.count = 1, .reusable = true}, SHIFT(3578),
  [7457] = {.count = 1, .reusable = true}, SHIFT(3579),
  [7459] = {.count = 1, .reusable = true}, SHIFT(3582),
  [7461] = {.count = 1, .reusable = true}, SHIFT(3583),
  [7463] = {.count = 1, .reusable = true}, SHIFT(3585),
  [7465] = {.count = 1, .reusable = true}, SHIFT(3586),
  [7467] = {.count = 1, .reusable = true}, SHIFT(3588),
  [7469] = {.count = 1, .reusable = true}, SHIFT(3589),
  [7471] = {.count = 1, .reusable = true}, SHIFT(894),
  [7473] = {.count = 1, .reusable = false}, SHIFT(3590),
  [7475] = {.count = 1, .reusable = true}, SHIFT(3590),
  [7477] = {.count = 1, .reusable = true}, SHIFT(3591),
  [7479] = {.count = 1, .reusable = true}, SHIFT(3594),
  [7481] = {.count = 1, .reusable = false}, SHIFT(3595),
  [7483] = {.count = 1, .reusable = true}, SHIFT(3597),
  [7485] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2),
  [7487] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(3598),
  [7490] = {.count = 1, .reusable = false}, SHIFT(3599),
  [7492] = {.count = 1, .reusable = true}, SHIFT(3601),
  [7494] = {.count = 1, .reusable = false}, SHIFT(3600),
  [7496] = {.count = 1, .reusable = true}, SHIFT(3604),
  [7498] = {.count = 1, .reusable = true}, SHIFT(3605),
  [7500] = {.count = 1, .reusable = true}, SHIFT(3607),
  [7502] = {.count = 1, .reusable = true}, SHIFT(3608),
  [7504] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 4),
  [7506] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 4),
  [7508] = {.count = 2, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(1988),
  [7511] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 4),
  [7513] = {.count = 1, .reusable = true}, SHIFT(3614),
  [7515] = {.count = 1, .reusable = true}, SHIFT(3615),
  [7517] = {.count = 1, .reusable = true}, SHIFT(3617),
  [7519] = {.count = 1, .reusable = true}, SHIFT(3618),
  [7521] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 5),
  [7523] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 5),
  [7525] = {.count = 1, .reusable = false}, REDUCE(sym_lookup_type, 4),
  [7527] = {.count = 1, .reusable = true}, REDUCE(sym_lookup_type, 4),
  [7529] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 4),
  [7531] = {.count = 1, .reusable = false}, SHIFT(3621),
  [7533] = {.count = 1, .reusable = true}, SHIFT(3621),
  [7535] = {.count = 1, .reusable = true}, SHIFT(3624),
  [7537] = {.count = 1, .reusable = true}, SHIFT(3625),
  [7539] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3),
  [7541] = {.count = 1, .reusable = false}, REDUCE(sym__initializer, 2),
  [7543] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3, .alias_sequence_id = 1),
  [7545] = {.count = 1, .reusable = false}, SHIFT(3627),
  [7547] = {.count = 1, .reusable = true}, SHIFT(3627),
  [7549] = {.count = 1, .reusable = false}, SHIFT(3628),
  [7551] = {.count = 1, .reusable = true}, SHIFT(3628),
  [7553] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(2074),
  [7556] = {.count = 1, .reusable = true}, SHIFT(3629),
  [7558] = {.count = 1, .reusable = true}, SHIFT(3630),
  [7560] = {.count = 1, .reusable = true}, SHIFT(3636),
  [7562] = {.count = 1, .reusable = false}, SHIFT(3637),
  [7564] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(2068),
  [7567] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 4),
  [7569] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 4),
  [7571] = {.count = 1, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [7573] = {.count = 1, .reusable = true}, SHIFT(3638),
  [7575] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(3639),
  [7578] = {.count = 1, .reusable = true}, SHIFT(3640),
  [7580] = {.count = 1, .reusable = true}, SHIFT(3643),
  [7582] = {.count = 1, .reusable = true}, SHIFT(3644),
  [7584] = {.count = 1, .reusable = true}, SHIFT(3645),
  [7586] = {.count = 1, .reusable = false}, SHIFT(3646),
  [7588] = {.count = 1, .reusable = true}, SHIFT(3646),
  [7590] = {.count = 1, .reusable = false}, SHIFT(3648),
  [7592] = {.count = 1, .reusable = true}, SHIFT(3648),
  [7594] = {.count = 1, .reusable = true}, SHIFT(3649),
  [7596] = {.count = 1, .reusable = true}, SHIFT(3650),
  [7598] = {.count = 1, .reusable = true}, SHIFT(3651),
  [7600] = {.count = 1, .reusable = false}, SHIFT(3653),
  [7602] = {.count = 1, .reusable = true}, SHIFT(3652),
  [7604] = {.count = 1, .reusable = true}, SHIFT(3653),
  [7606] = {.count = 1, .reusable = false}, SHIFT(3655),
  [7608] = {.count = 1, .reusable = true}, SHIFT(3655),
  [7610] = {.count = 1, .reusable = false}, SHIFT(3656),
  [7612] = {.count = 1, .reusable = true}, SHIFT(3656),
  [7614] = {.count = 1, .reusable = false}, SHIFT(3658),
  [7616] = {.count = 1, .reusable = true}, SHIFT(3658),
  [7618] = {.count = 1, .reusable = false}, SHIFT(3659),
  [7620] = {.count = 1, .reusable = true}, SHIFT(3659),
  [7622] = {.count = 1, .reusable = true}, SHIFT(3661),
  [7624] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class, 6, .alias_sequence_id = 16),
  [7626] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class, 6, .alias_sequence_id = 16),
  [7628] = {.count = 1, .reusable = true}, SHIFT(3664),
  [7630] = {.count = 1, .reusable = true}, SHIFT(3665),
  [7632] = {.count = 1, .reusable = true}, SHIFT(3667),
  [7634] = {.count = 1, .reusable = true}, SHIFT(3668),
  [7636] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 6, .alias_sequence_id = 11),
  [7638] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 6, .alias_sequence_id = 11),
  [7640] = {.count = 1, .reusable = true}, SHIFT(3671),
  [7642] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 4),
  [7644] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 5, .alias_sequence_id = 17),
  [7646] = {.count = 1, .reusable = false}, SHIFT(3672),
  [7648] = {.count = 1, .reusable = true}, SHIFT(3672),
  [7650] = {.count = 1, .reusable = false}, SHIFT(3673),
  [7652] = {.count = 1, .reusable = true}, SHIFT(3673),
  [7654] = {.count = 1, .reusable = false}, SHIFT(3674),
  [7656] = {.count = 1, .reusable = true}, SHIFT(3674),
  [7658] = {.count = 1, .reusable = true}, SHIFT(3675),
  [7660] = {.count = 1, .reusable = true}, SHIFT(3676),
  [7662] = {.count = 1, .reusable = true}, SHIFT(3677),
  [7664] = {.count = 1, .reusable = false}, SHIFT(3678),
  [7666] = {.count = 1, .reusable = true}, SHIFT(3678),
  [7668] = {.count = 1, .reusable = false}, SHIFT(3679),
  [7670] = {.count = 1, .reusable = true}, SHIFT(3679),
  [7672] = {.count = 1, .reusable = false}, SHIFT(3680),
  [7674] = {.count = 1, .reusable = true}, SHIFT(3680),
  [7676] = {.count = 1, .reusable = false}, SHIFT(3681),
  [7678] = {.count = 1, .reusable = true}, SHIFT(3681),
  [7680] = {.count = 1, .reusable = false}, SHIFT(3682),
  [7682] = {.count = 1, .reusable = true}, SHIFT(3682),
  [7684] = {.count = 1, .reusable = false}, SHIFT(3683),
  [7686] = {.count = 1, .reusable = true}, SHIFT(3683),
  [7688] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(3005),
  [7691] = {.count = 1, .reusable = true}, SHIFT(3684),
  [7693] = {.count = 1, .reusable = true}, SHIFT(3685),
  [7695] = {.count = 1, .reusable = true}, SHIFT(2982),
  [7697] = {.count = 1, .reusable = false}, SHIFT(2999),
  [7699] = {.count = 1, .reusable = true}, SHIFT(3002),
  [7701] = {.count = 1, .reusable = false}, SHIFT(3002),
  [7703] = {.count = 1, .reusable = true}, SHIFT(3003),
  [7705] = {.count = 1, .reusable = true}, SHIFT(2999),
  [7707] = {.count = 1, .reusable = false}, SHIFT(3686),
  [7709] = {.count = 1, .reusable = true}, SHIFT(3686),
  [7711] = {.count = 1, .reusable = false}, SHIFT(3687),
  [7713] = {.count = 1, .reusable = true}, SHIFT(3687),
  [7715] = {.count = 1, .reusable = false}, SHIFT(3688),
  [7717] = {.count = 1, .reusable = true}, SHIFT(3688),
  [7719] = {.count = 1, .reusable = false}, SHIFT(3689),
  [7721] = {.count = 1, .reusable = true}, SHIFT(3689),
  [7723] = {.count = 1, .reusable = false}, SHIFT(3690),
  [7725] = {.count = 1, .reusable = true}, SHIFT(3690),
  [7727] = {.count = 1, .reusable = false}, SHIFT(3691),
  [7729] = {.count = 1, .reusable = true}, SHIFT(3695),
  [7731] = {.count = 1, .reusable = true}, SHIFT(3693),
  [7733] = {.count = 1, .reusable = true}, SHIFT(3692),
  [7735] = {.count = 1, .reusable = false}, SHIFT(3694),
  [7737] = {.count = 1, .reusable = false}, SHIFT(3698),
  [7739] = {.count = 1, .reusable = false}, SHIFT(3699),
  [7741] = {.count = 1, .reusable = false}, SHIFT(3700),
  [7743] = {.count = 1, .reusable = false}, SHIFT(3701),
  [7745] = {.count = 1, .reusable = false}, SHIFT(3702),
  [7747] = {.count = 1, .reusable = false}, SHIFT(3703),
  [7749] = {.count = 1, .reusable = false}, SHIFT(3705),
  [7751] = {.count = 1, .reusable = true}, SHIFT(3705),
  [7753] = {.count = 1, .reusable = false}, SHIFT(3706),
  [7755] = {.count = 1, .reusable = true}, SHIFT(3706),
  [7757] = {.count = 1, .reusable = false}, SHIFT(3707),
  [7759] = {.count = 1, .reusable = true}, SHIFT(3707),
  [7761] = {.count = 1, .reusable = false}, SHIFT(3708),
  [7763] = {.count = 1, .reusable = true}, SHIFT(3708),
  [7765] = {.count = 1, .reusable = false}, SHIFT(3709),
  [7767] = {.count = 1, .reusable = true}, SHIFT(3709),
  [7769] = {.count = 1, .reusable = false}, SHIFT(3710),
  [7771] = {.count = 1, .reusable = true}, SHIFT(3710),
  [7773] = {.count = 1, .reusable = false}, SHIFT(3711),
  [7775] = {.count = 1, .reusable = true}, SHIFT(3711),
  [7777] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(3032),
  [7780] = {.count = 1, .reusable = true}, SHIFT(3712),
  [7782] = {.count = 1, .reusable = true}, SHIFT(3713),
  [7784] = {.count = 1, .reusable = false}, SHIFT(3714),
  [7786] = {.count = 1, .reusable = true}, SHIFT(3714),
  [7788] = {.count = 1, .reusable = false}, SHIFT(3715),
  [7790] = {.count = 1, .reusable = true}, SHIFT(3715),
  [7792] = {.count = 1, .reusable = false}, SHIFT(3716),
  [7794] = {.count = 1, .reusable = true}, SHIFT(3716),
  [7796] = {.count = 1, .reusable = false}, SHIFT(3717),
  [7798] = {.count = 1, .reusable = true}, SHIFT(3717),
  [7800] = {.count = 1, .reusable = false}, SHIFT(3718),
  [7802] = {.count = 1, .reusable = true}, SHIFT(3718),
  [7804] = {.count = 1, .reusable = false}, SHIFT(3719),
  [7806] = {.count = 1, .reusable = true}, SHIFT(3723),
  [7808] = {.count = 1, .reusable = true}, SHIFT(3721),
  [7810] = {.count = 1, .reusable = true}, SHIFT(3720),
  [7812] = {.count = 1, .reusable = false}, SHIFT(3722),
  [7814] = {.count = 1, .reusable = false}, SHIFT(3726),
  [7816] = {.count = 1, .reusable = false}, SHIFT(3727),
  [7818] = {.count = 1, .reusable = false}, SHIFT(3728),
  [7820] = {.count = 1, .reusable = false}, SHIFT(3729),
  [7822] = {.count = 1, .reusable = false}, SHIFT(3730),
  [7824] = {.count = 1, .reusable = false}, SHIFT(3731),
  [7826] = {.count = 1, .reusable = false}, SHIFT(3733),
  [7828] = {.count = 1, .reusable = true}, SHIFT(3733),
  [7830] = {.count = 1, .reusable = true}, SHIFT(3734),
  [7832] = {.count = 1, .reusable = true}, SHIFT(3735),
  [7834] = {.count = 1, .reusable = true}, SHIFT(3736),
  [7836] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [7838] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [7840] = {.count = 1, .reusable = true}, SHIFT(3742),
  [7842] = {.count = 1, .reusable = true}, SHIFT(3743),
  [7844] = {.count = 1, .reusable = false}, SHIFT(2223),
  [7846] = {.count = 1, .reusable = false}, SHIFT(2222),
  [7848] = {.count = 1, .reusable = true}, SHIFT(3744),
  [7850] = {.count = 1, .reusable = true}, SHIFT(3745),
  [7852] = {.count = 1, .reusable = true}, SHIFT(3747),
  [7854] = {.count = 1, .reusable = true}, SHIFT(3748),
  [7856] = {.count = 1, .reusable = true}, SHIFT(3750),
  [7858] = {.count = 1, .reusable = true}, SHIFT(3752),
  [7860] = {.count = 1, .reusable = true}, SHIFT(3754),
  [7862] = {.count = 1, .reusable = true}, SHIFT(3755),
  [7864] = {.count = 1, .reusable = false}, SHIFT(3756),
  [7866] = {.count = 1, .reusable = true}, SHIFT(3756),
  [7868] = {.count = 1, .reusable = true}, SHIFT(3759),
  [7870] = {.count = 1, .reusable = true}, SHIFT(3760),
  [7872] = {.count = 1, .reusable = true}, SHIFT(3763),
  [7874] = {.count = 1, .reusable = true}, SHIFT(3764),
  [7876] = {.count = 1, .reusable = true}, SHIFT(3767),
  [7878] = {.count = 1, .reusable = true}, SHIFT(3768),
  [7880] = {.count = 1, .reusable = false}, SHIFT(3769),
  [7882] = {.count = 1, .reusable = true}, SHIFT(3769),
  [7884] = {.count = 1, .reusable = false}, SHIFT(3770),
  [7886] = {.count = 1, .reusable = true}, SHIFT(3770),
  [7888] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(2313),
  [7891] = {.count = 1, .reusable = true}, SHIFT(3771),
  [7893] = {.count = 1, .reusable = true}, SHIFT(3772),
  [7895] = {.count = 1, .reusable = true}, SHIFT(3778),
  [7897] = {.count = 1, .reusable = false}, SHIFT(3779),
  [7899] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 4),
  [7901] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 4),
  [7903] = {.count = 1, .reusable = true}, SHIFT(3782),
  [7905] = {.count = 1, .reusable = true}, SHIFT(3783),
  [7907] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4),
  [7909] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 4),
  [7911] = {.count = 1, .reusable = false}, SHIFT(3787),
  [7913] = {.count = 1, .reusable = true}, SHIFT(3788),
  [7915] = {.count = 1, .reusable = true}, SHIFT(3789),
  [7917] = {.count = 1, .reusable = false}, SHIFT(3790),
  [7919] = {.count = 1, .reusable = true}, SHIFT(3791),
  [7921] = {.count = 1, .reusable = true}, SHIFT(3795),
  [7923] = {.count = 1, .reusable = true}, SHIFT(3798),
  [7925] = {.count = 1, .reusable = true}, SHIFT(3799),
  [7927] = {.count = 1, .reusable = true}, SHIFT(3801),
  [7929] = {.count = 1, .reusable = true}, SHIFT(3802),
  [7931] = {.count = 1, .reusable = true}, SHIFT(3804),
  [7933] = {.count = 1, .reusable = false}, SHIFT(3803),
  [7935] = {.count = 1, .reusable = true}, SHIFT(3805),
  [7937] = {.count = 1, .reusable = true}, SHIFT(3806),
  [7939] = {.count = 1, .reusable = true}, SHIFT(3807),
  [7941] = {.count = 1, .reusable = false}, SHIFT(3809),
  [7943] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(3808),
  [7946] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 6, .alias_sequence_id = 22),
  [7948] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 6, .alias_sequence_id = 22),
  [7950] = {.count = 1, .reusable = true}, SHIFT(3813),
  [7952] = {.count = 1, .reusable = true}, SHIFT(3812),
  [7954] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(3808),
  [7957] = {.count = 1, .reusable = true}, SHIFT(3815),
  [7959] = {.count = 1, .reusable = false}, SHIFT(3817),
  [7961] = {.count = 1, .reusable = true}, SHIFT(3817),
  [7963] = {.count = 1, .reusable = false}, SHIFT(3818),
  [7965] = {.count = 1, .reusable = true}, SHIFT(3818),
  [7967] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(2376),
  [7970] = {.count = 1, .reusable = true}, SHIFT(3819),
  [7972] = {.count = 1, .reusable = true}, SHIFT(3820),
  [7974] = {.count = 1, .reusable = true}, SHIFT(3826),
  [7976] = {.count = 1, .reusable = false}, SHIFT(3827),
  [7978] = {.count = 1, .reusable = true}, SHIFT(3828),
  [7980] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 5),
  [7982] = {.count = 1, .reusable = true}, SHIFT(3831),
  [7984] = {.count = 1, .reusable = false}, SHIFT(3832),
  [7986] = {.count = 1, .reusable = false}, SHIFT(3834),
  [7988] = {.count = 1, .reusable = false}, SHIFT(3833),
  [7990] = {.count = 1, .reusable = true}, SHIFT(3838),
  [7992] = {.count = 1, .reusable = false}, SHIFT(3837),
  [7994] = {.count = 1, .reusable = true}, SHIFT(3839),
  [7996] = {.count = 1, .reusable = true}, SHIFT(3843),
  [7998] = {.count = 1, .reusable = false}, SHIFT(3844),
  [8000] = {.count = 1, .reusable = true}, SHIFT(3845),
  [8002] = {.count = 1, .reusable = false}, SHIFT(3846),
  [8004] = {.count = 1, .reusable = true}, SHIFT(3847),
  [8006] = {.count = 1, .reusable = true}, SHIFT(3848),
  [8008] = {.count = 1, .reusable = true}, SHIFT(3849),
  [8010] = {.count = 1, .reusable = true}, SHIFT(3850),
  [8012] = {.count = 1, .reusable = false}, SHIFT(3851),
  [8014] = {.count = 1, .reusable = true}, SHIFT(3851),
  [8016] = {.count = 1, .reusable = false}, SHIFT(3852),
  [8018] = {.count = 1, .reusable = true}, SHIFT(3852),
  [8020] = {.count = 1, .reusable = false}, SHIFT(3853),
  [8022] = {.count = 1, .reusable = true}, SHIFT(3853),
  [8024] = {.count = 1, .reusable = true}, SHIFT(3854),
  [8026] = {.count = 1, .reusable = true}, SHIFT(3855),
  [8028] = {.count = 1, .reusable = false}, SHIFT(3856),
  [8030] = {.count = 1, .reusable = true}, SHIFT(3856),
  [8032] = {.count = 1, .reusable = false}, SHIFT(3858),
  [8034] = {.count = 1, .reusable = true}, SHIFT(3858),
  [8036] = {.count = 1, .reusable = false}, SHIFT(3860),
  [8038] = {.count = 1, .reusable = true}, SHIFT(3860),
  [8040] = {.count = 1, .reusable = true}, SHIFT(3862),
  [8042] = {.count = 1, .reusable = true}, SHIFT(3863),
  [8044] = {.count = 1, .reusable = true}, SHIFT(3864),
  [8046] = {.count = 1, .reusable = true}, SHIFT(3865),
  [8048] = {.count = 1, .reusable = true}, SHIFT(3866),
  [8050] = {.count = 1, .reusable = false}, SHIFT(3867),
  [8052] = {.count = 1, .reusable = true}, SHIFT(3868),
  [8054] = {.count = 1, .reusable = true}, SHIFT(3869),
  [8056] = {.count = 1, .reusable = false}, SHIFT(3870),
  [8058] = {.count = 1, .reusable = true}, SHIFT(3871),
  [8060] = {.count = 1, .reusable = true}, SHIFT(3875),
  [8062] = {.count = 1, .reusable = false}, SHIFT(3876),
  [8064] = {.count = 1, .reusable = true}, SHIFT(3876),
  [8066] = {.count = 1, .reusable = false}, SHIFT(3877),
  [8068] = {.count = 1, .reusable = true}, SHIFT(3877),
  [8070] = {.count = 1, .reusable = false}, SHIFT(3878),
  [8072] = {.count = 1, .reusable = true}, SHIFT(3878),
  [8074] = {.count = 1, .reusable = false}, SHIFT(3879),
  [8076] = {.count = 1, .reusable = true}, SHIFT(3879),
  [8078] = {.count = 1, .reusable = false}, SHIFT(3880),
  [8080] = {.count = 1, .reusable = true}, SHIFT(3880),
  [8082] = {.count = 1, .reusable = false}, SHIFT(3881),
  [8084] = {.count = 1, .reusable = true}, SHIFT(3881),
  [8086] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(3264),
  [8089] = {.count = 1, .reusable = true}, SHIFT(3882),
  [8091] = {.count = 1, .reusable = true}, SHIFT(3883),
  [8093] = {.count = 1, .reusable = false}, SHIFT(3884),
  [8095] = {.count = 1, .reusable = true}, SHIFT(3884),
  [8097] = {.count = 1, .reusable = false}, SHIFT(3885),
  [8099] = {.count = 1, .reusable = true}, SHIFT(3885),
  [8101] = {.count = 1, .reusable = false}, SHIFT(3886),
  [8103] = {.count = 1, .reusable = true}, SHIFT(3886),
  [8105] = {.count = 1, .reusable = false}, SHIFT(3887),
  [8107] = {.count = 1, .reusable = true}, SHIFT(3887),
  [8109] = {.count = 1, .reusable = false}, SHIFT(3888),
  [8111] = {.count = 1, .reusable = true}, SHIFT(3888),
  [8113] = {.count = 1, .reusable = false}, SHIFT(3889),
  [8115] = {.count = 1, .reusable = true}, SHIFT(3889),
  [8117] = {.count = 1, .reusable = false}, SHIFT(3890),
  [8119] = {.count = 1, .reusable = true}, SHIFT(3894),
  [8121] = {.count = 1, .reusable = true}, SHIFT(3892),
  [8123] = {.count = 1, .reusable = true}, SHIFT(3891),
  [8125] = {.count = 1, .reusable = false}, SHIFT(3893),
  [8127] = {.count = 1, .reusable = false}, SHIFT(3897),
  [8129] = {.count = 1, .reusable = false}, SHIFT(3898),
  [8131] = {.count = 1, .reusable = false}, SHIFT(3899),
  [8133] = {.count = 1, .reusable = false}, SHIFT(3900),
  [8135] = {.count = 1, .reusable = false}, SHIFT(3901),
  [8137] = {.count = 1, .reusable = false}, SHIFT(3902),
  [8139] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 3),
  [8141] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 3),
  [8143] = {.count = 1, .reusable = false}, SHIFT(3904),
  [8145] = {.count = 1, .reusable = true}, SHIFT(3904),
  [8147] = {.count = 1, .reusable = true}, SHIFT(3905),
  [8149] = {.count = 1, .reusable = true}, SHIFT(3907),
  [8151] = {.count = 1, .reusable = true}, SHIFT(3908),
  [8153] = {.count = 1, .reusable = true}, SHIFT(3909),
  [8155] = {.count = 1, .reusable = true}, SHIFT(3910),
  [8157] = {.count = 1, .reusable = true}, SHIFT(3911),
  [8159] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 3),
  [8161] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 3),
  [8163] = {.count = 1, .reusable = true}, SHIFT(3916),
  [8165] = {.count = 1, .reusable = true}, SHIFT(3919),
  [8167] = {.count = 1, .reusable = true}, SHIFT(3920),
  [8169] = {.count = 1, .reusable = true}, SHIFT(3922),
  [8171] = {.count = 1, .reusable = true}, SHIFT(3923),
  [8173] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5, .alias_sequence_id = 6),
  [8175] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5),
  [8177] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5, .alias_sequence_id = 14),
  [8179] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5, .alias_sequence_id = 15),
  [8181] = {.count = 1, .reusable = true}, SHIFT(3926),
  [8183] = {.count = 1, .reusable = false}, SHIFT(3927),
  [8185] = {.count = 1, .reusable = true}, SHIFT(3928),
  [8187] = {.count = 1, .reusable = true}, SHIFT(3933),
  [8189] = {.count = 1, .reusable = true}, SHIFT(3934),
  [8191] = {.count = 1, .reusable = false}, SHIFT(2477),
  [8193] = {.count = 1, .reusable = false}, SHIFT(2476),
  [8195] = {.count = 1, .reusable = true}, SHIFT(3936),
  [8197] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5, .alias_sequence_id = 18),
  [8199] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 5, .alias_sequence_id = 18),
  [8201] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 5),
  [8203] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5, .alias_sequence_id = 19),
  [8205] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 5, .alias_sequence_id = 19),
  [8207] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5, .alias_sequence_id = 20),
  [8209] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 5, .alias_sequence_id = 20),
  [8211] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 6),
  [8213] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_fragment, 6),
  [8215] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_fragment, 6),
  [8217] = {.count = 1, .reusable = false}, SHIFT(3944),
  [8219] = {.count = 1, .reusable = false}, SHIFT(3946),
  [8221] = {.count = 1, .reusable = false}, SHIFT(3945),
  [8223] = {.count = 1, .reusable = false}, SHIFT(3947),
  [8225] = {.count = 1, .reusable = false}, SHIFT(3949),
  [8227] = {.count = 1, .reusable = true}, SHIFT(3953),
  [8229] = {.count = 1, .reusable = true}, SHIFT(3954),
  [8231] = {.count = 1, .reusable = true}, SHIFT(3956),
  [8233] = {.count = 1, .reusable = true}, SHIFT(3957),
  [8235] = {.count = 1, .reusable = true}, SHIFT(3960),
  [8237] = {.count = 1, .reusable = true}, SHIFT(3961),
  [8239] = {.count = 1, .reusable = true}, SHIFT(3962),
  [8241] = {.count = 1, .reusable = false}, SHIFT(3963),
  [8243] = {.count = 1, .reusable = true}, SHIFT(3964),
  [8245] = {.count = 1, .reusable = true}, SHIFT(3969),
  [8247] = {.count = 1, .reusable = true}, SHIFT(3970),
  [8249] = {.count = 1, .reusable = true}, SHIFT(3974),
  [8251] = {.count = 1, .reusable = true}, SHIFT(3975),
  [8253] = {.count = 1, .reusable = true}, SHIFT(3977),
  [8255] = {.count = 1, .reusable = true}, SHIFT(3978),
  [8257] = {.count = 1, .reusable = false}, SHIFT(2549),
  [8259] = {.count = 1, .reusable = false}, SHIFT(2548),
  [8261] = {.count = 1, .reusable = true}, SHIFT(3981),
  [8263] = {.count = 1, .reusable = true}, SHIFT(3984),
  [8265] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 5, .alias_sequence_id = 21),
  [8267] = {.count = 1, .reusable = false}, SHIFT(3985),
  [8269] = {.count = 1, .reusable = true}, SHIFT(3985),
  [8271] = {.count = 1, .reusable = true}, SHIFT(3988),
  [8273] = {.count = 1, .reusable = true}, SHIFT(3989),
  [8275] = {.count = 1, .reusable = true}, SHIFT(3991),
  [8277] = {.count = 1, .reusable = true}, SHIFT(3992),
  [8279] = {.count = 1, .reusable = true}, SHIFT(3993),
  [8281] = {.count = 1, .reusable = false}, SHIFT(3995),
  [8283] = {.count = 1, .reusable = false}, SHIFT(3994),
  [8285] = {.count = 1, .reusable = true}, SHIFT(3999),
  [8287] = {.count = 1, .reusable = false}, SHIFT(3998),
  [8289] = {.count = 1, .reusable = true}, SHIFT(4000),
  [8291] = {.count = 1, .reusable = true}, SHIFT(4004),
  [8293] = {.count = 1, .reusable = false}, SHIFT(4005),
  [8295] = {.count = 1, .reusable = true}, SHIFT(4006),
  [8297] = {.count = 1, .reusable = false}, SHIFT(4007),
  [8299] = {.count = 1, .reusable = true}, SHIFT(4008),
  [8301] = {.count = 1, .reusable = true}, SHIFT(4009),
  [8303] = {.count = 1, .reusable = true}, SHIFT(4010),
  [8305] = {.count = 1, .reusable = true}, SHIFT(4011),
  [8307] = {.count = 1, .reusable = false}, SHIFT(4012),
  [8309] = {.count = 1, .reusable = true}, SHIFT(4012),
  [8311] = {.count = 1, .reusable = false}, SHIFT(4013),
  [8313] = {.count = 1, .reusable = true}, SHIFT(4013),
  [8315] = {.count = 1, .reusable = false}, SHIFT(4014),
  [8317] = {.count = 1, .reusable = true}, SHIFT(4014),
  [8319] = {.count = 1, .reusable = true}, SHIFT(4015),
  [8321] = {.count = 1, .reusable = true}, SHIFT(4016),
  [8323] = {.count = 1, .reusable = false}, SHIFT(4017),
  [8325] = {.count = 1, .reusable = true}, SHIFT(4017),
  [8327] = {.count = 1, .reusable = false}, SHIFT(4019),
  [8329] = {.count = 1, .reusable = true}, SHIFT(4019),
  [8331] = {.count = 1, .reusable = false}, SHIFT(4021),
  [8333] = {.count = 1, .reusable = true}, SHIFT(4021),
  [8335] = {.count = 1, .reusable = true}, SHIFT(4023),
  [8337] = {.count = 1, .reusable = true}, SHIFT(4024),
  [8339] = {.count = 1, .reusable = true}, SHIFT(4025),
  [8341] = {.count = 1, .reusable = true}, SHIFT(4026),
  [8343] = {.count = 1, .reusable = true}, SHIFT(4027),
  [8345] = {.count = 1, .reusable = false}, SHIFT(4028),
  [8347] = {.count = 1, .reusable = true}, SHIFT(4029),
  [8349] = {.count = 1, .reusable = true}, SHIFT(4030),
  [8351] = {.count = 1, .reusable = false}, SHIFT(4031),
  [8353] = {.count = 1, .reusable = true}, SHIFT(4032),
  [8355] = {.count = 1, .reusable = true}, REDUCE(sym_class, 6, .alias_sequence_id = 16),
  [8357] = {.count = 1, .reusable = false}, REDUCE(sym_class, 6, .alias_sequence_id = 16),
  [8359] = {.count = 1, .reusable = true}, SHIFT(4037),
  [8361] = {.count = 1, .reusable = true}, SHIFT(4038),
  [8363] = {.count = 1, .reusable = false}, SHIFT(4041),
  [8365] = {.count = 1, .reusable = true}, SHIFT(4041),
  [8367] = {.count = 1, .reusable = true}, SHIFT(4044),
  [8369] = {.count = 1, .reusable = true}, SHIFT(4045),
  [8371] = {.count = 1, .reusable = true}, SHIFT(4047),
  [8373] = {.count = 1, .reusable = true}, SHIFT(4048),
  [8375] = {.count = 1, .reusable = true}, SHIFT(4049),
  [8377] = {.count = 1, .reusable = true}, SHIFT(4050),
  [8379] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 4),
  [8381] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 4),
  [8383] = {.count = 1, .reusable = true}, SHIFT(4052),
  [8385] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(3608),
  [8388] = {.count = 2, .reusable = false}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .alias_sequence_id = 8),
  [8391] = {.count = 1, .reusable = true}, SHIFT(4054),
  [8393] = {.count = 1, .reusable = true}, SHIFT(4055),
  [8395] = {.count = 1, .reusable = true}, SHIFT(4057),
  [8397] = {.count = 1, .reusable = false}, SHIFT(4056),
  [8399] = {.count = 1, .reusable = true}, SHIFT(4058),
  [8401] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .alias_sequence_id = 5), SHIFT(1881),
  [8405] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(1882),
  [8408] = {.count = 1, .reusable = true}, SHIFT(4059),
  [8410] = {.count = 1, .reusable = false}, SHIFT(4060),
  [8412] = {.count = 1, .reusable = true}, SHIFT(4061),
  [8414] = {.count = 1, .reusable = true}, SHIFT(4062),
  [8416] = {.count = 1, .reusable = true}, SHIFT(4063),
  [8418] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(3597),
  [8421] = {.count = 1, .reusable = false}, SHIFT(4067),
  [8423] = {.count = 1, .reusable = true}, SHIFT(4068),
  [8425] = {.count = 1, .reusable = true}, SHIFT(4069),
  [8427] = {.count = 1, .reusable = false}, SHIFT(4070),
  [8429] = {.count = 1, .reusable = true}, SHIFT(4071),
  [8431] = {.count = 1, .reusable = false}, SHIFT(4075),
  [8433] = {.count = 1, .reusable = true}, SHIFT(4077),
  [8435] = {.count = 1, .reusable = false}, SHIFT(4076),
  [8437] = {.count = 1, .reusable = true}, SHIFT(4078),
  [8439] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(3618),
  [8442] = {.count = 1, .reusable = false}, SHIFT(4079),
  [8444] = {.count = 1, .reusable = true}, SHIFT(4079),
  [8446] = {.count = 1, .reusable = false}, SHIFT(4080),
  [8448] = {.count = 1, .reusable = true}, SHIFT(4080),
  [8450] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(2753),
  [8453] = {.count = 1, .reusable = true}, SHIFT(4081),
  [8455] = {.count = 1, .reusable = true}, SHIFT(4082),
  [8457] = {.count = 1, .reusable = true}, SHIFT(4088),
  [8459] = {.count = 1, .reusable = false}, SHIFT(4089),
  [8461] = {.count = 1, .reusable = false}, SHIFT(2766),
  [8463] = {.count = 1, .reusable = false}, SHIFT(2765),
  [8465] = {.count = 1, .reusable = true}, SHIFT(4090),
  [8467] = {.count = 1, .reusable = true}, SHIFT(4093),
  [8469] = {.count = 1, .reusable = true}, SHIFT(4094),
  [8471] = {.count = 1, .reusable = true}, SHIFT(4096),
  [8473] = {.count = 1, .reusable = true}, SHIFT(4097),
  [8475] = {.count = 1, .reusable = true}, SHIFT(4099),
  [8477] = {.count = 1, .reusable = true}, SHIFT(4100),
  [8479] = {.count = 1, .reusable = true}, SHIFT(4103),
  [8481] = {.count = 1, .reusable = true}, SHIFT(4104),
  [8483] = {.count = 1, .reusable = true}, SHIFT(4109),
  [8485] = {.count = 1, .reusable = true}, SHIFT(4110),
  [8487] = {.count = 1, .reusable = true}, SHIFT(4112),
  [8489] = {.count = 1, .reusable = true}, SHIFT(4113),
  [8491] = {.count = 1, .reusable = true}, SHIFT(4116),
  [8493] = {.count = 1, .reusable = true}, SHIFT(4119),
  [8495] = {.count = 1, .reusable = true}, SHIFT(4120),
  [8497] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 5),
  [8499] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 5),
  [8501] = {.count = 1, .reusable = true}, SHIFT(4121),
  [8503] = {.count = 1, .reusable = true}, SHIFT(4123),
  [8505] = {.count = 1, .reusable = true}, SHIFT(4124),
  [8507] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4),
  [8509] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 4),
  [8511] = {.count = 1, .reusable = true}, SHIFT(4126),
  [8513] = {.count = 1, .reusable = true}, SHIFT(4129),
  [8515] = {.count = 1, .reusable = true}, SHIFT(4131),
  [8517] = {.count = 1, .reusable = true}, SHIFT(4132),
  [8519] = {.count = 1, .reusable = true}, SHIFT(4133),
  [8521] = {.count = 1, .reusable = true}, SHIFT(4135),
  [8523] = {.count = 1, .reusable = true}, SHIFT(4140),
  [8525] = {.count = 1, .reusable = true}, SHIFT(4141),
  [8527] = {.count = 1, .reusable = true}, SHIFT(4143),
  [8529] = {.count = 1, .reusable = false}, SHIFT(4144),
  [8531] = {.count = 1, .reusable = true}, SHIFT(4145),
  [8533] = {.count = 1, .reusable = true}, SHIFT(4150),
  [8535] = {.count = 1, .reusable = true}, SHIFT(4151),
  [8537] = {.count = 1, .reusable = true}, SHIFT(4154),
  [8539] = {.count = 1, .reusable = false}, SHIFT(4153),
  [8541] = {.count = 1, .reusable = true}, SHIFT(4155),
  [8543] = {.count = 1, .reusable = true}, SHIFT(4157),
  [8545] = {.count = 1, .reusable = true}, SHIFT(4158),
  [8547] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 5),
  [8549] = {.count = 1, .reusable = true}, SHIFT(4162),
  [8551] = {.count = 1, .reusable = true}, SHIFT(4163),
  [8553] = {.count = 1, .reusable = false}, SHIFT(2905),
  [8555] = {.count = 1, .reusable = false}, SHIFT(2904),
  [8557] = {.count = 1, .reusable = true}, SHIFT(4166),
  [8559] = {.count = 1, .reusable = false}, SHIFT(4169),
  [8561] = {.count = 1, .reusable = true}, SHIFT(4169),
  [8563] = {.count = 1, .reusable = true}, SHIFT(4172),
  [8565] = {.count = 1, .reusable = true}, SHIFT(4173),
  [8567] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 5),
  [8569] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 5),
  [8571] = {.count = 1, .reusable = true}, SHIFT(4175),
  [8573] = {.count = 1, .reusable = true}, SHIFT(4176),
  [8575] = {.count = 1, .reusable = true}, SHIFT(4177),
  [8577] = {.count = 1, .reusable = false}, SHIFT(4178),
  [8579] = {.count = 1, .reusable = true}, SHIFT(4178),
  [8581] = {.count = 1, .reusable = false}, SHIFT(4179),
  [8583] = {.count = 1, .reusable = true}, SHIFT(4179),
  [8585] = {.count = 1, .reusable = false}, SHIFT(4180),
  [8587] = {.count = 1, .reusable = true}, SHIFT(4180),
  [8589] = {.count = 1, .reusable = true}, SHIFT(4181),
  [8591] = {.count = 1, .reusable = true}, SHIFT(4182),
  [8593] = {.count = 1, .reusable = false}, SHIFT(4183),
  [8595] = {.count = 1, .reusable = true}, SHIFT(4183),
  [8597] = {.count = 1, .reusable = false}, SHIFT(4185),
  [8599] = {.count = 1, .reusable = true}, SHIFT(4185),
  [8601] = {.count = 1, .reusable = false}, SHIFT(4187),
  [8603] = {.count = 1, .reusable = true}, SHIFT(4187),
  [8605] = {.count = 1, .reusable = true}, SHIFT(4189),
  [8607] = {.count = 1, .reusable = true}, SHIFT(4190),
  [8609] = {.count = 1, .reusable = true}, SHIFT(4191),
  [8611] = {.count = 1, .reusable = true}, SHIFT(4192),
  [8613] = {.count = 1, .reusable = true}, SHIFT(4193),
  [8615] = {.count = 1, .reusable = false}, SHIFT(4194),
  [8617] = {.count = 1, .reusable = true}, SHIFT(4195),
  [8619] = {.count = 1, .reusable = true}, SHIFT(4196),
  [8621] = {.count = 1, .reusable = false}, SHIFT(4197),
  [8623] = {.count = 1, .reusable = true}, SHIFT(4198),
  [8625] = {.count = 1, .reusable = true}, SHIFT(4203),
  [8627] = {.count = 1, .reusable = true}, SHIFT(4204),
  [8629] = {.count = 1, .reusable = true}, REDUCE(sym_import_require_clause, 6),
  [8631] = {.count = 1, .reusable = true}, SHIFT(4207),
  [8633] = {.count = 1, .reusable = true}, SHIFT(4208),
  [8635] = {.count = 1, .reusable = true}, SHIFT(4209),
  [8637] = {.count = 1, .reusable = false}, SHIFT(4213),
  [8639] = {.count = 1, .reusable = true}, SHIFT(4213),
  [8641] = {.count = 1, .reusable = false}, SHIFT(4214),
  [8643] = {.count = 1, .reusable = true}, SHIFT(4214),
  [8645] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(3005),
  [8648] = {.count = 1, .reusable = true}, SHIFT(4215),
  [8650] = {.count = 1, .reusable = true}, SHIFT(4216),
  [8652] = {.count = 1, .reusable = true}, SHIFT(4222),
  [8654] = {.count = 1, .reusable = false}, SHIFT(4223),
  [8656] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 7),
  [8658] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 7),
  [8660] = {.count = 1, .reusable = false}, SHIFT(4224),
  [8662] = {.count = 1, .reusable = true}, SHIFT(4224),
  [8664] = {.count = 1, .reusable = false}, SHIFT(4225),
  [8666] = {.count = 1, .reusable = true}, SHIFT(4225),
  [8668] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(3032),
  [8671] = {.count = 1, .reusable = true}, SHIFT(4226),
  [8673] = {.count = 1, .reusable = true}, SHIFT(4227),
  [8675] = {.count = 1, .reusable = true}, SHIFT(4233),
  [8677] = {.count = 1, .reusable = false}, SHIFT(4234),
  [8679] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 7),
  [8681] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 7),
  [8683] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7),
  [8685] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7),
  [8687] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 7, .alias_sequence_id = 20),
  [8689] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 7, .alias_sequence_id = 20),
  [8691] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 7, .alias_sequence_id = 20),
  [8693] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 7, .alias_sequence_id = 20),
  [8695] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 7, .alias_sequence_id = 19),
  [8697] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 7, .alias_sequence_id = 19),
  [8699] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 7, .alias_sequence_id = 19),
  [8701] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 7, .alias_sequence_id = 19),
  [8703] = {.count = 1, .reusable = true}, SHIFT(4238),
  [8705] = {.count = 1, .reusable = true}, SHIFT(4239),
  [8707] = {.count = 1, .reusable = true}, SHIFT(4241),
  [8709] = {.count = 1, .reusable = false}, SHIFT(3088),
  [8711] = {.count = 1, .reusable = false}, SHIFT(3087),
  [8713] = {.count = 1, .reusable = true}, SHIFT(4242),
  [8715] = {.count = 1, .reusable = true}, SHIFT(4245),
  [8717] = {.count = 1, .reusable = false}, SHIFT(4250),
  [8719] = {.count = 1, .reusable = true}, SHIFT(4250),
  [8721] = {.count = 1, .reusable = true}, SHIFT(4253),
  [8723] = {.count = 1, .reusable = true}, SHIFT(4254),
  [8725] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 5),
  [8727] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 5),
  [8729] = {.count = 1, .reusable = true}, SHIFT(4258),
  [8731] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5),
  [8733] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 5),
  [8735] = {.count = 1, .reusable = true}, SHIFT(4260),
  [8737] = {.count = 1, .reusable = true}, SHIFT(4263),
  [8739] = {.count = 1, .reusable = true}, SHIFT(4264),
  [8741] = {.count = 1, .reusable = true}, SHIFT(4266),
  [8743] = {.count = 1, .reusable = true}, SHIFT(4267),
  [8745] = {.count = 1, .reusable = false}, SHIFT(4268),
  [8747] = {.count = 1, .reusable = true}, SHIFT(4269),
  [8749] = {.count = 1, .reusable = true}, SHIFT(4274),
  [8751] = {.count = 1, .reusable = true}, SHIFT(4275),
  [8753] = {.count = 1, .reusable = true}, SHIFT(4277),
  [8755] = {.count = 1, .reusable = true}, SHIFT(4283),
  [8757] = {.count = 1, .reusable = true}, SHIFT(4284),
  [8759] = {.count = 1, .reusable = false}, SHIFT(4286),
  [8761] = {.count = 1, .reusable = true}, SHIFT(4286),
  [8763] = {.count = 1, .reusable = true}, SHIFT(4289),
  [8765] = {.count = 1, .reusable = true}, SHIFT(4290),
  [8767] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 6),
  [8769] = {.count = 1, .reusable = true}, SHIFT(4294),
  [8771] = {.count = 1, .reusable = true}, SHIFT(4297),
  [8773] = {.count = 1, .reusable = true}, SHIFT(4298),
  [8775] = {.count = 1, .reusable = true}, SHIFT(4299),
  [8777] = {.count = 1, .reusable = false}, SHIFT(4300),
  [8779] = {.count = 1, .reusable = true}, SHIFT(4300),
  [8781] = {.count = 1, .reusable = false}, SHIFT(4302),
  [8783] = {.count = 1, .reusable = true}, SHIFT(4302),
  [8785] = {.count = 1, .reusable = true}, SHIFT(4303),
  [8787] = {.count = 1, .reusable = true}, SHIFT(4304),
  [8789] = {.count = 1, .reusable = true}, SHIFT(4305),
  [8791] = {.count = 1, .reusable = false}, SHIFT(4307),
  [8793] = {.count = 1, .reusable = true}, SHIFT(4306),
  [8795] = {.count = 1, .reusable = true}, SHIFT(4307),
  [8797] = {.count = 1, .reusable = false}, SHIFT(4309),
  [8799] = {.count = 1, .reusable = true}, SHIFT(4309),
  [8801] = {.count = 1, .reusable = false}, SHIFT(4310),
  [8803] = {.count = 1, .reusable = true}, SHIFT(4310),
  [8805] = {.count = 1, .reusable = false}, SHIFT(4312),
  [8807] = {.count = 1, .reusable = true}, SHIFT(4312),
  [8809] = {.count = 1, .reusable = false}, SHIFT(4313),
  [8811] = {.count = 1, .reusable = true}, SHIFT(4313),
  [8813] = {.count = 1, .reusable = true}, SHIFT(4315),
  [8815] = {.count = 1, .reusable = false}, SHIFT(4316),
  [8817] = {.count = 1, .reusable = true}, SHIFT(4316),
  [8819] = {.count = 1, .reusable = false}, SHIFT(4317),
  [8821] = {.count = 1, .reusable = true}, SHIFT(4317),
  [8823] = {.count = 1, .reusable = false}, SHIFT(4318),
  [8825] = {.count = 1, .reusable = true}, SHIFT(4318),
  [8827] = {.count = 1, .reusable = true}, SHIFT(4319),
  [8829] = {.count = 1, .reusable = true}, SHIFT(4320),
  [8831] = {.count = 1, .reusable = true}, SHIFT(4321),
  [8833] = {.count = 1, .reusable = true}, SHIFT(4322),
  [8835] = {.count = 1, .reusable = true}, SHIFT(4323),
  [8837] = {.count = 1, .reusable = true}, SHIFT(4324),
  [8839] = {.count = 1, .reusable = false}, SHIFT(4325),
  [8841] = {.count = 1, .reusable = true}, SHIFT(4329),
  [8843] = {.count = 1, .reusable = true}, SHIFT(4328),
  [8845] = {.count = 1, .reusable = true}, SHIFT(4331),
  [8847] = {.count = 1, .reusable = true}, SHIFT(4332),
  [8849] = {.count = 1, .reusable = false}, SHIFT(4333),
  [8851] = {.count = 1, .reusable = true}, SHIFT(4333),
  [8853] = {.count = 1, .reusable = false}, SHIFT(4334),
  [8855] = {.count = 1, .reusable = true}, SHIFT(4334),
  [8857] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(3264),
  [8860] = {.count = 1, .reusable = true}, SHIFT(4335),
  [8862] = {.count = 1, .reusable = true}, SHIFT(4336),
  [8864] = {.count = 1, .reusable = true}, SHIFT(4342),
  [8866] = {.count = 1, .reusable = false}, SHIFT(4343),
  [8868] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 4),
  [8870] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 4),
  [8872] = {.count = 1, .reusable = false}, SHIFT(4344),
  [8874] = {.count = 1, .reusable = false}, SHIFT(4345),
  [8876] = {.count = 1, .reusable = false}, SHIFT(4346),
  [8878] = {.count = 1, .reusable = false}, SHIFT(4347),
  [8880] = {.count = 1, .reusable = false}, SHIFT(4348),
  [8882] = {.count = 1, .reusable = false}, SHIFT(4349),
  [8884] = {.count = 1, .reusable = false}, SHIFT(4350),
  [8886] = {.count = 1, .reusable = true}, SHIFT(4353),
  [8888] = {.count = 1, .reusable = false}, SHIFT(4354),
  [8890] = {.count = 1, .reusable = false}, SHIFT(4355),
  [8892] = {.count = 1, .reusable = false}, SHIFT(4356),
  [8894] = {.count = 1, .reusable = true}, SHIFT(4360),
  [8896] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3267),
  [8899] = {.count = 1, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2),
  [8901] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3268),
  [8904] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3269),
  [8907] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3270),
  [8910] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3271),
  [8913] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3272),
  [8916] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3273),
  [8919] = {.count = 1, .reusable = true}, SHIFT(4362),
  [8921] = {.count = 1, .reusable = true}, SHIFT(4363),
  [8923] = {.count = 1, .reusable = true}, SHIFT(4368),
  [8925] = {.count = 1, .reusable = true}, SHIFT(4369),
  [8927] = {.count = 1, .reusable = true}, SHIFT(4371),
  [8929] = {.count = 1, .reusable = true}, SHIFT(4372),
  [8931] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 6, .alias_sequence_id = 18),
  [8933] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 6),
  [8935] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 6, .alias_sequence_id = 19),
  [8937] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 6, .alias_sequence_id = 20),
  [8939] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5),
  [8941] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5),
  [8943] = {.count = 1, .reusable = false}, SHIFT(4376),
  [8945] = {.count = 1, .reusable = false}, SHIFT(4377),
  [8947] = {.count = 1, .reusable = true}, SHIFT(4378),
  [8949] = {.count = 1, .reusable = false}, SHIFT(4379),
  [8951] = {.count = 1, .reusable = false}, SHIFT(4380),
  [8953] = {.count = 1, .reusable = true}, SHIFT(4381),
  [8955] = {.count = 1, .reusable = true}, SHIFT(4385),
  [8957] = {.count = 1, .reusable = true}, SHIFT(4386),
  [8959] = {.count = 1, .reusable = true}, SHIFT(4389),
  [8961] = {.count = 1, .reusable = true}, SHIFT(4392),
  [8963] = {.count = 1, .reusable = true}, SHIFT(4393),
  [8965] = {.count = 1, .reusable = true}, SHIFT(4395),
  [8967] = {.count = 1, .reusable = true}, SHIFT(4396),
  [8969] = {.count = 1, .reusable = true}, SHIFT(4400),
  [8971] = {.count = 1, .reusable = true}, SHIFT(4401),
  [8973] = {.count = 1, .reusable = false}, SHIFT(3375),
  [8975] = {.count = 1, .reusable = false}, SHIFT(3374),
  [8977] = {.count = 1, .reusable = true}, SHIFT(4405),
  [8979] = {.count = 1, .reusable = true}, SHIFT(4408),
  [8981] = {.count = 1, .reusable = true}, SHIFT(4409),
  [8983] = {.count = 1, .reusable = true}, SHIFT(4412),
  [8985] = {.count = 1, .reusable = true}, SHIFT(4413),
  [8987] = {.count = 1, .reusable = true}, SHIFT(4414),
  [8989] = {.count = 1, .reusable = false}, SHIFT(4415),
  [8991] = {.count = 1, .reusable = true}, SHIFT(4415),
  [8993] = {.count = 1, .reusable = false}, SHIFT(4417),
  [8995] = {.count = 1, .reusable = true}, SHIFT(4417),
  [8997] = {.count = 1, .reusable = true}, SHIFT(4418),
  [8999] = {.count = 1, .reusable = true}, SHIFT(4419),
  [9001] = {.count = 1, .reusable = true}, SHIFT(4420),
  [9003] = {.count = 1, .reusable = false}, SHIFT(4422),
  [9005] = {.count = 1, .reusable = true}, SHIFT(4421),
  [9007] = {.count = 1, .reusable = true}, SHIFT(4422),
  [9009] = {.count = 1, .reusable = false}, SHIFT(4424),
  [9011] = {.count = 1, .reusable = true}, SHIFT(4424),
  [9013] = {.count = 1, .reusable = false}, SHIFT(4425),
  [9015] = {.count = 1, .reusable = true}, SHIFT(4425),
  [9017] = {.count = 1, .reusable = false}, SHIFT(4427),
  [9019] = {.count = 1, .reusable = true}, SHIFT(4427),
  [9021] = {.count = 1, .reusable = false}, SHIFT(4428),
  [9023] = {.count = 1, .reusable = true}, SHIFT(4428),
  [9025] = {.count = 1, .reusable = true}, SHIFT(4430),
  [9027] = {.count = 1, .reusable = false}, SHIFT(4431),
  [9029] = {.count = 1, .reusable = true}, SHIFT(4431),
  [9031] = {.count = 1, .reusable = false}, SHIFT(4432),
  [9033] = {.count = 1, .reusable = true}, SHIFT(4432),
  [9035] = {.count = 1, .reusable = false}, SHIFT(4433),
  [9037] = {.count = 1, .reusable = true}, SHIFT(4433),
  [9039] = {.count = 1, .reusable = true}, SHIFT(4434),
  [9041] = {.count = 1, .reusable = true}, SHIFT(4435),
  [9043] = {.count = 1, .reusable = true}, SHIFT(4436),
  [9045] = {.count = 1, .reusable = true}, SHIFT(4437),
  [9047] = {.count = 1, .reusable = true}, SHIFT(4438),
  [9049] = {.count = 1, .reusable = true}, SHIFT(4439),
  [9051] = {.count = 1, .reusable = true}, SHIFT(4440),
  [9053] = {.count = 1, .reusable = true}, SHIFT(4443),
  [9055] = {.count = 1, .reusable = true}, SHIFT(4444),
  [9057] = {.count = 1, .reusable = true}, SHIFT(4446),
  [9059] = {.count = 1, .reusable = true}, SHIFT(4447),
  [9061] = {.count = 1, .reusable = false}, SHIFT(3432),
  [9063] = {.count = 1, .reusable = false}, SHIFT(3431),
  [9065] = {.count = 1, .reusable = true}, SHIFT(4450),
  [9067] = {.count = 1, .reusable = true}, SHIFT(4453),
  [9069] = {.count = 1, .reusable = true}, SHIFT(4454),
  [9071] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 5),
  [9073] = {.count = 1, .reusable = true}, SHIFT(4456),
  [9075] = {.count = 1, .reusable = true}, SHIFT(4457),
  [9077] = {.count = 1, .reusable = true}, SHIFT(4458),
  [9079] = {.count = 1, .reusable = true}, SHIFT(4459),
  [9081] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(4150),
  [9084] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(4151),
  [9087] = {.count = 1, .reusable = true}, SHIFT(4461),
  [9089] = {.count = 1, .reusable = true}, SHIFT(4464),
  [9091] = {.count = 1, .reusable = false}, SHIFT(4465),
  [9093] = {.count = 1, .reusable = true}, SHIFT(4467),
  [9095] = {.count = 1, .reusable = true}, SHIFT(4469),
  [9097] = {.count = 1, .reusable = false}, SHIFT(4468),
  [9099] = {.count = 1, .reusable = true}, SHIFT(4470),
  [9101] = {.count = 1, .reusable = false}, SHIFT(4471),
  [9103] = {.count = 1, .reusable = true}, SHIFT(4471),
  [9105] = {.count = 1, .reusable = true}, SHIFT(4474),
  [9107] = {.count = 1, .reusable = true}, SHIFT(4475),
  [9109] = {.count = 1, .reusable = true}, SHIFT(4478),
  [9111] = {.count = 1, .reusable = true}, SHIFT(4479),
  [9113] = {.count = 1, .reusable = true}, SHIFT(4482),
  [9115] = {.count = 1, .reusable = true}, SHIFT(4483),
  [9117] = {.count = 1, .reusable = true}, SHIFT(4487),
  [9119] = {.count = 1, .reusable = true}, SHIFT(4488),
  [9121] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 6),
  [9123] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 6),
  [9125] = {.count = 1, .reusable = true}, SHIFT(4493),
  [9127] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5),
  [9129] = {.count = 1, .reusable = true}, SHIFT(4495),
  [9131] = {.count = 1, .reusable = true}, SHIFT(4496),
  [9133] = {.count = 1, .reusable = true}, SHIFT(4498),
  [9135] = {.count = 1, .reusable = true}, SHIFT(4501),
  [9137] = {.count = 1, .reusable = true}, SHIFT(4503),
  [9139] = {.count = 1, .reusable = true}, SHIFT(4504),
  [9141] = {.count = 1, .reusable = true}, SHIFT(4507),
  [9143] = {.count = 1, .reusable = false}, SHIFT(4508),
  [9145] = {.count = 1, .reusable = true}, SHIFT(4510),
  [9147] = {.count = 1, .reusable = true}, SHIFT(4511),
  [9149] = {.count = 1, .reusable = true}, SHIFT(4514),
  [9151] = {.count = 1, .reusable = true}, SHIFT(4516),
  [9153] = {.count = 1, .reusable = true}, SHIFT(4519),
  [9155] = {.count = 1, .reusable = false}, REDUCE(sym_ternary_expression, 5),
  [9157] = {.count = 1, .reusable = false}, SHIFT(3634),
  [9159] = {.count = 1, .reusable = false}, SHIFT(3633),
  [9161] = {.count = 1, .reusable = true}, SHIFT(4523),
  [9163] = {.count = 1, .reusable = false}, SHIFT(4526),
  [9165] = {.count = 1, .reusable = true}, SHIFT(4526),
  [9167] = {.count = 1, .reusable = false}, SHIFT(4527),
  [9169] = {.count = 1, .reusable = true}, SHIFT(4527),
  [9171] = {.count = 1, .reusable = false}, SHIFT(4528),
  [9173] = {.count = 1, .reusable = true}, SHIFT(4528),
  [9175] = {.count = 1, .reusable = true}, SHIFT(4529),
  [9177] = {.count = 1, .reusable = true}, SHIFT(4530),
  [9179] = {.count = 1, .reusable = true}, SHIFT(4531),
  [9181] = {.count = 1, .reusable = true}, SHIFT(4532),
  [9183] = {.count = 1, .reusable = true}, SHIFT(4533),
  [9185] = {.count = 1, .reusable = true}, SHIFT(4534),
  [9187] = {.count = 1, .reusable = false}, SHIFT(4535),
  [9189] = {.count = 1, .reusable = true}, SHIFT(4539),
  [9191] = {.count = 1, .reusable = true}, SHIFT(4538),
  [9193] = {.count = 1, .reusable = true}, SHIFT(4541),
  [9195] = {.count = 1, .reusable = true}, SHIFT(4542),
  [9197] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 8),
  [9199] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 8),
  [9201] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 8, .alias_sequence_id = 23),
  [9203] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 8, .alias_sequence_id = 23),
  [9205] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 8, .alias_sequence_id = 24),
  [9207] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 8, .alias_sequence_id = 24),
  [9209] = {.count = 1, .reusable = false}, SHIFT(4548),
  [9211] = {.count = 1, .reusable = true}, SHIFT(4548),
  [9213] = {.count = 1, .reusable = true}, SHIFT(4551),
  [9215] = {.count = 1, .reusable = true}, SHIFT(4552),
  [9217] = {.count = 1, .reusable = false}, SHIFT(4554),
  [9219] = {.count = 1, .reusable = true}, SHIFT(4554),
  [9221] = {.count = 1, .reusable = true}, SHIFT(4557),
  [9223] = {.count = 1, .reusable = true}, SHIFT(4558),
  [9225] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 8),
  [9227] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 8),
  [9229] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 8, .alias_sequence_id = 23),
  [9231] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 8, .alias_sequence_id = 23),
  [9233] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 8, .alias_sequence_id = 24),
  [9235] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 8, .alias_sequence_id = 24),
  [9237] = {.count = 1, .reusable = true}, SHIFT(4560),
  [9239] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6),
  [9241] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6, .alias_sequence_id = 6),
  [9243] = {.count = 1, .reusable = false}, SHIFT(3776),
  [9245] = {.count = 1, .reusable = false}, SHIFT(3775),
  [9247] = {.count = 1, .reusable = true}, SHIFT(4563),
  [9249] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 6),
  [9251] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 6),
  [9253] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6),
  [9255] = {.count = 1, .reusable = true}, SHIFT(4568),
  [9257] = {.count = 1, .reusable = false}, SHIFT(4569),
  [9259] = {.count = 1, .reusable = true}, SHIFT(4570),
  [9261] = {.count = 1, .reusable = true}, SHIFT(4575),
  [9263] = {.count = 1, .reusable = true}, SHIFT(4576),
  [9265] = {.count = 1, .reusable = true}, SHIFT(4580),
  [9267] = {.count = 1, .reusable = true}, SHIFT(4581),
  [9269] = {.count = 1, .reusable = true}, SHIFT(4583),
  [9271] = {.count = 1, .reusable = true}, SHIFT(4584),
  [9273] = {.count = 1, .reusable = true}, SHIFT(4587),
  [9275] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 6),
  [9277] = {.count = 1, .reusable = true}, SHIFT(4589),
  [9279] = {.count = 1, .reusable = true}, SHIFT(4590),
  [9281] = {.count = 1, .reusable = true}, SHIFT(4592),
  [9283] = {.count = 1, .reusable = false}, SHIFT(3824),
  [9285] = {.count = 1, .reusable = false}, SHIFT(3823),
  [9287] = {.count = 1, .reusable = true}, SHIFT(4595),
  [9289] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 7),
  [9291] = {.count = 1, .reusable = true}, SHIFT(4599),
  [9293] = {.count = 1, .reusable = true}, SHIFT(4600),
  [9295] = {.count = 1, .reusable = true}, SHIFT(4601),
  [9297] = {.count = 1, .reusable = false}, SHIFT(4602),
  [9299] = {.count = 1, .reusable = true}, SHIFT(4602),
  [9301] = {.count = 1, .reusable = false}, SHIFT(4603),
  [9303] = {.count = 1, .reusable = true}, SHIFT(4603),
  [9305] = {.count = 1, .reusable = false}, SHIFT(4604),
  [9307] = {.count = 1, .reusable = true}, SHIFT(4604),
  [9309] = {.count = 1, .reusable = true}, SHIFT(4605),
  [9311] = {.count = 1, .reusable = true}, SHIFT(4606),
  [9313] = {.count = 1, .reusable = false}, SHIFT(4607),
  [9315] = {.count = 1, .reusable = true}, SHIFT(4607),
  [9317] = {.count = 1, .reusable = false}, SHIFT(4609),
  [9319] = {.count = 1, .reusable = true}, SHIFT(4609),
  [9321] = {.count = 1, .reusable = false}, SHIFT(4611),
  [9323] = {.count = 1, .reusable = true}, SHIFT(4611),
  [9325] = {.count = 1, .reusable = true}, SHIFT(4613),
  [9327] = {.count = 1, .reusable = true}, SHIFT(4614),
  [9329] = {.count = 1, .reusable = true}, SHIFT(4615),
  [9331] = {.count = 1, .reusable = true}, SHIFT(4616),
  [9333] = {.count = 1, .reusable = true}, SHIFT(4617),
  [9335] = {.count = 1, .reusable = false}, SHIFT(4618),
  [9337] = {.count = 1, .reusable = true}, SHIFT(4619),
  [9339] = {.count = 1, .reusable = true}, SHIFT(4620),
  [9341] = {.count = 1, .reusable = false}, SHIFT(4621),
  [9343] = {.count = 1, .reusable = true}, SHIFT(4622),
  [9345] = {.count = 1, .reusable = true}, SHIFT(4626),
  [9347] = {.count = 1, .reusable = true}, SHIFT(4627),
  [9349] = {.count = 1, .reusable = true}, SHIFT(4628),
  [9351] = {.count = 1, .reusable = true}, SHIFT(4631),
  [9353] = {.count = 1, .reusable = true}, SHIFT(4632),
  [9355] = {.count = 1, .reusable = false}, SHIFT(4635),
  [9357] = {.count = 1, .reusable = true}, SHIFT(4635),
  [9359] = {.count = 1, .reusable = true}, SHIFT(4638),
  [9361] = {.count = 1, .reusable = true}, SHIFT(4639),
  [9363] = {.count = 1, .reusable = true}, SHIFT(4641),
  [9365] = {.count = 1, .reusable = true}, SHIFT(4643),
  [9367] = {.count = 1, .reusable = true}, SHIFT(4644),
  [9369] = {.count = 1, .reusable = true}, SHIFT(4645),
  [9371] = {.count = 1, .reusable = true}, SHIFT(4646),
  [9373] = {.count = 1, .reusable = true}, SHIFT(4647),
  [9375] = {.count = 1, .reusable = false}, SHIFT(4651),
  [9377] = {.count = 1, .reusable = true}, SHIFT(4652),
  [9379] = {.count = 1, .reusable = false}, SHIFT(4654),
  [9381] = {.count = 1, .reusable = false}, SHIFT(4653),
  [9383] = {.count = 1, .reusable = true}, SHIFT(4658),
  [9385] = {.count = 1, .reusable = false}, SHIFT(4657),
  [9387] = {.count = 1, .reusable = true}, SHIFT(4659),
  [9389] = {.count = 1, .reusable = true}, SHIFT(4663),
  [9391] = {.count = 1, .reusable = false}, SHIFT(4664),
  [9393] = {.count = 1, .reusable = true}, SHIFT(4665),
  [9395] = {.count = 1, .reusable = false}, SHIFT(4666),
  [9397] = {.count = 1, .reusable = true}, SHIFT(4667),
  [9399] = {.count = 1, .reusable = true}, SHIFT(4668),
  [9401] = {.count = 1, .reusable = true}, SHIFT(4672),
  [9403] = {.count = 1, .reusable = true}, SHIFT(4673),
  [9405] = {.count = 1, .reusable = true}, SHIFT(4676),
  [9407] = {.count = 1, .reusable = false}, SHIFT(4677),
  [9409] = {.count = 1, .reusable = true}, SHIFT(4678),
  [9411] = {.count = 1, .reusable = true}, SHIFT(4679),
  [9413] = {.count = 1, .reusable = true}, SHIFT(4680),
  [9415] = {.count = 1, .reusable = true}, SHIFT(4684),
  [9417] = {.count = 1, .reusable = true}, SHIFT(4685),
  [9419] = {.count = 1, .reusable = true}, SHIFT(4688),
  [9421] = {.count = 1, .reusable = true}, SHIFT(4692),
  [9423] = {.count = 1, .reusable = true}, SHIFT(4693),
  [9425] = {.count = 1, .reusable = true}, SHIFT(4694),
  [9427] = {.count = 1, .reusable = false}, SHIFT(4695),
  [9429] = {.count = 1, .reusable = true}, SHIFT(4695),
  [9431] = {.count = 1, .reusable = false}, SHIFT(4696),
  [9433] = {.count = 1, .reusable = true}, SHIFT(4696),
  [9435] = {.count = 1, .reusable = false}, SHIFT(4697),
  [9437] = {.count = 1, .reusable = true}, SHIFT(4697),
  [9439] = {.count = 1, .reusable = true}, SHIFT(4698),
  [9441] = {.count = 1, .reusable = true}, SHIFT(4699),
  [9443] = {.count = 1, .reusable = false}, SHIFT(4700),
  [9445] = {.count = 1, .reusable = true}, SHIFT(4700),
  [9447] = {.count = 1, .reusable = false}, SHIFT(4702),
  [9449] = {.count = 1, .reusable = true}, SHIFT(4702),
  [9451] = {.count = 1, .reusable = false}, SHIFT(4704),
  [9453] = {.count = 1, .reusable = true}, SHIFT(4704),
  [9455] = {.count = 1, .reusable = true}, SHIFT(4706),
  [9457] = {.count = 1, .reusable = true}, SHIFT(4707),
  [9459] = {.count = 1, .reusable = true}, SHIFT(4708),
  [9461] = {.count = 1, .reusable = true}, SHIFT(4709),
  [9463] = {.count = 1, .reusable = true}, SHIFT(4710),
  [9465] = {.count = 1, .reusable = false}, SHIFT(4711),
  [9467] = {.count = 1, .reusable = true}, SHIFT(4712),
  [9469] = {.count = 1, .reusable = true}, SHIFT(4713),
  [9471] = {.count = 1, .reusable = false}, SHIFT(4714),
  [9473] = {.count = 1, .reusable = true}, SHIFT(4715),
  [9475] = {.count = 1, .reusable = true}, SHIFT(4720),
  [9477] = {.count = 1, .reusable = true}, SHIFT(4721),
  [9479] = {.count = 1, .reusable = true}, SHIFT(4722),
  [9481] = {.count = 1, .reusable = true}, SHIFT(4723),
  [9483] = {.count = 1, .reusable = false}, SHIFT(4724),
  [9485] = {.count = 1, .reusable = true}, SHIFT(4725),
  [9487] = {.count = 1, .reusable = true}, SHIFT(4730),
  [9489] = {.count = 1, .reusable = true}, SHIFT(4731),
  [9491] = {.count = 1, .reusable = true}, SHIFT(4736),
  [9493] = {.count = 1, .reusable = true}, SHIFT(4737),
  [9495] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(4511),
  [9498] = {.count = 1, .reusable = true}, SHIFT(4738),
  [9500] = {.count = 1, .reusable = false}, SHIFT(4739),
  [9502] = {.count = 1, .reusable = true}, SHIFT(4740),
  [9504] = {.count = 1, .reusable = true}, SHIFT(4745),
  [9506] = {.count = 1, .reusable = true}, SHIFT(4746),
  [9508] = {.count = 1, .reusable = true}, SHIFT(4748),
  [9510] = {.count = 1, .reusable = false}, SHIFT(4086),
  [9512] = {.count = 1, .reusable = false}, SHIFT(4085),
  [9514] = {.count = 1, .reusable = true}, SHIFT(4749),
  [9516] = {.count = 1, .reusable = true}, SHIFT(4754),
  [9518] = {.count = 1, .reusable = true}, SHIFT(4758),
  [9520] = {.count = 1, .reusable = true}, SHIFT(4759),
  [9522] = {.count = 1, .reusable = true}, SHIFT(4762),
  [9524] = {.count = 1, .reusable = true}, SHIFT(4764),
  [9526] = {.count = 1, .reusable = true}, SHIFT(4765),
  [9528] = {.count = 1, .reusable = true}, SHIFT(4768),
  [9530] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 6),
  [9532] = {.count = 1, .reusable = true}, SHIFT(4772),
  [9534] = {.count = 1, .reusable = true}, SHIFT(4773),
  [9536] = {.count = 1, .reusable = true}, SHIFT(4774),
  [9538] = {.count = 1, .reusable = true}, SHIFT(4777),
  [9540] = {.count = 1, .reusable = true}, SHIFT(4778),
  [9542] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 9),
  [9544] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 9),
  [9546] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 9, .alias_sequence_id = 25),
  [9548] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 9, .alias_sequence_id = 25),
  [9550] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 9, .alias_sequence_id = 26),
  [9552] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 9, .alias_sequence_id = 26),
  [9554] = {.count = 1, .reusable = false}, SHIFT(4220),
  [9556] = {.count = 1, .reusable = false}, SHIFT(4219),
  [9558] = {.count = 1, .reusable = true}, SHIFT(4781),
  [9560] = {.count = 1, .reusable = false}, SHIFT(4231),
  [9562] = {.count = 1, .reusable = false}, SHIFT(4230),
  [9564] = {.count = 1, .reusable = true}, SHIFT(4784),
  [9566] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 7),
  [9568] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 7),
  [9570] = {.count = 1, .reusable = true}, SHIFT(4791),
  [9572] = {.count = 1, .reusable = true}, SHIFT(4792),
  [9574] = {.count = 1, .reusable = true}, SHIFT(4794),
  [9576] = {.count = 1, .reusable = true}, SHIFT(4795),
  [9578] = {.count = 1, .reusable = true}, SHIFT(4799),
  [9580] = {.count = 1, .reusable = true}, SHIFT(4800),
  [9582] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 7),
  [9584] = {.count = 1, .reusable = true}, SHIFT(4804),
  [9586] = {.count = 1, .reusable = true}, SHIFT(4805),
  [9588] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 8),
  [9590] = {.count = 1, .reusable = false}, SHIFT(4808),
  [9592] = {.count = 1, .reusable = true}, SHIFT(4808),
  [9594] = {.count = 1, .reusable = false}, SHIFT(4809),
  [9596] = {.count = 1, .reusable = true}, SHIFT(4809),
  [9598] = {.count = 1, .reusable = false}, SHIFT(4810),
  [9600] = {.count = 1, .reusable = true}, SHIFT(4810),
  [9602] = {.count = 1, .reusable = true}, SHIFT(4811),
  [9604] = {.count = 1, .reusable = true}, SHIFT(4812),
  [9606] = {.count = 1, .reusable = true}, SHIFT(4813),
  [9608] = {.count = 1, .reusable = true}, SHIFT(4814),
  [9610] = {.count = 1, .reusable = true}, SHIFT(4815),
  [9612] = {.count = 1, .reusable = true}, SHIFT(4816),
  [9614] = {.count = 1, .reusable = false}, SHIFT(4817),
  [9616] = {.count = 1, .reusable = true}, SHIFT(4821),
  [9618] = {.count = 1, .reusable = true}, SHIFT(4820),
  [9620] = {.count = 1, .reusable = true}, SHIFT(4823),
  [9622] = {.count = 1, .reusable = true}, SHIFT(4824),
  [9624] = {.count = 1, .reusable = false}, SHIFT(4340),
  [9626] = {.count = 1, .reusable = false}, SHIFT(4339),
  [9628] = {.count = 1, .reusable = true}, SHIFT(4828),
  [9630] = {.count = 1, .reusable = true}, SHIFT(4832),
  [9632] = {.count = 1, .reusable = false}, SHIFT(4833),
  [9634] = {.count = 1, .reusable = false}, SHIFT(4834),
  [9636] = {.count = 1, .reusable = false}, SHIFT(4835),
  [9638] = {.count = 1, .reusable = true}, SHIFT(4839),
  [9640] = {.count = 1, .reusable = true}, SHIFT(4840),
  [9642] = {.count = 1, .reusable = true}, SHIFT(4843),
  [9644] = {.count = 1, .reusable = true}, SHIFT(4844),
  [9646] = {.count = 1, .reusable = true}, SHIFT(4845),
  [9648] = {.count = 1, .reusable = false}, SHIFT(4846),
  [9650] = {.count = 1, .reusable = true}, SHIFT(4846),
  [9652] = {.count = 1, .reusable = false}, SHIFT(4848),
  [9654] = {.count = 1, .reusable = true}, SHIFT(4848),
  [9656] = {.count = 1, .reusable = true}, SHIFT(4849),
  [9658] = {.count = 1, .reusable = true}, SHIFT(4850),
  [9660] = {.count = 1, .reusable = true}, SHIFT(4851),
  [9662] = {.count = 1, .reusable = false}, SHIFT(4853),
  [9664] = {.count = 1, .reusable = true}, SHIFT(4852),
  [9666] = {.count = 1, .reusable = true}, SHIFT(4853),
  [9668] = {.count = 1, .reusable = false}, SHIFT(4855),
  [9670] = {.count = 1, .reusable = true}, SHIFT(4855),
  [9672] = {.count = 1, .reusable = false}, SHIFT(4856),
  [9674] = {.count = 1, .reusable = true}, SHIFT(4856),
  [9676] = {.count = 1, .reusable = false}, SHIFT(4858),
  [9678] = {.count = 1, .reusable = true}, SHIFT(4858),
  [9680] = {.count = 1, .reusable = false}, SHIFT(4859),
  [9682] = {.count = 1, .reusable = true}, SHIFT(4859),
  [9684] = {.count = 1, .reusable = true}, SHIFT(4861),
  [9686] = {.count = 1, .reusable = true}, SHIFT(4863),
  [9688] = {.count = 1, .reusable = true}, SHIFT(4866),
  [9690] = {.count = 1, .reusable = true}, SHIFT(4868),
  [9692] = {.count = 1, .reusable = false}, SHIFT(4872),
  [9694] = {.count = 1, .reusable = true}, SHIFT(4872),
  [9696] = {.count = 1, .reusable = false}, SHIFT(4873),
  [9698] = {.count = 1, .reusable = true}, SHIFT(4873),
  [9700] = {.count = 1, .reusable = false}, SHIFT(4874),
  [9702] = {.count = 1, .reusable = true}, SHIFT(4874),
  [9704] = {.count = 1, .reusable = true}, SHIFT(4875),
  [9706] = {.count = 1, .reusable = true}, SHIFT(4876),
  [9708] = {.count = 1, .reusable = true}, SHIFT(4877),
  [9710] = {.count = 1, .reusable = true}, SHIFT(4878),
  [9712] = {.count = 1, .reusable = true}, SHIFT(4879),
  [9714] = {.count = 1, .reusable = true}, SHIFT(4880),
  [9716] = {.count = 1, .reusable = true}, SHIFT(3808),
  [9718] = {.count = 1, .reusable = true}, SHIFT(4881),
  [9720] = {.count = 1, .reusable = true}, SHIFT(4884),
  [9722] = {.count = 1, .reusable = true}, SHIFT(4885),
  [9724] = {.count = 1, .reusable = true}, SHIFT(4887),
  [9726] = {.count = 1, .reusable = true}, SHIFT(4890),
  [9728] = {.count = 1, .reusable = true}, SHIFT(4891),
  [9730] = {.count = 1, .reusable = true}, SHIFT(4893),
  [9732] = {.count = 1, .reusable = true}, SHIFT(4894),
  [9734] = {.count = 1, .reusable = true}, SHIFT(4900),
  [9736] = {.count = 1, .reusable = false}, SHIFT(4901),
  [9738] = {.count = 1, .reusable = true}, SHIFT(4903),
  [9740] = {.count = 1, .reusable = true}, SHIFT(4904),
  [9742] = {.count = 1, .reusable = true}, SHIFT(4907),
  [9744] = {.count = 1, .reusable = true}, SHIFT(4910),
  [9746] = {.count = 1, .reusable = true}, SHIFT(4911),
  [9748] = {.count = 1, .reusable = true}, SHIFT(4915),
  [9750] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 8),
  [9752] = {.count = 1, .reusable = true}, SHIFT(4921),
  [9754] = {.count = 1, .reusable = true}, SHIFT(4922),
  [9756] = {.count = 1, .reusable = true}, SHIFT(4925),
  [9758] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 8),
  [9760] = {.count = 1, .reusable = true}, SHIFT(4929),
  [9762] = {.count = 1, .reusable = true}, SHIFT(4930),
  [9764] = {.count = 1, .reusable = true}, SHIFT(4931),
  [9766] = {.count = 1, .reusable = true}, SHIFT(4932),
  [9768] = {.count = 1, .reusable = true}, SHIFT(4935),
  [9770] = {.count = 1, .reusable = true}, SHIFT(4936),
  [9772] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 9),
  [9774] = {.count = 1, .reusable = false}, SHIFT(4940),
  [9776] = {.count = 1, .reusable = false}, SHIFT(4942),
  [9778] = {.count = 1, .reusable = false}, SHIFT(4941),
  [9780] = {.count = 1, .reusable = true}, SHIFT(4946),
  [9782] = {.count = 1, .reusable = false}, SHIFT(4945),
  [9784] = {.count = 1, .reusable = true}, SHIFT(4947),
  [9786] = {.count = 1, .reusable = true}, SHIFT(4951),
  [9788] = {.count = 1, .reusable = false}, SHIFT(4952),
  [9790] = {.count = 1, .reusable = true}, SHIFT(4953),
  [9792] = {.count = 1, .reusable = false}, SHIFT(4954),
  [9794] = {.count = 1, .reusable = true}, SHIFT(4955),
  [9796] = {.count = 1, .reusable = true}, SHIFT(4956),
  [9798] = {.count = 1, .reusable = true}, SHIFT(4957),
  [9800] = {.count = 1, .reusable = true}, SHIFT(4958),
  [9802] = {.count = 1, .reusable = false}, SHIFT(4959),
  [9804] = {.count = 1, .reusable = true}, SHIFT(4959),
  [9806] = {.count = 1, .reusable = false}, SHIFT(4960),
  [9808] = {.count = 1, .reusable = true}, SHIFT(4960),
  [9810] = {.count = 1, .reusable = false}, SHIFT(4961),
  [9812] = {.count = 1, .reusable = true}, SHIFT(4961),
  [9814] = {.count = 1, .reusable = true}, SHIFT(4962),
  [9816] = {.count = 1, .reusable = true}, SHIFT(4963),
  [9818] = {.count = 1, .reusable = false}, SHIFT(4964),
  [9820] = {.count = 1, .reusable = true}, SHIFT(4964),
  [9822] = {.count = 1, .reusable = false}, SHIFT(4966),
  [9824] = {.count = 1, .reusable = true}, SHIFT(4966),
  [9826] = {.count = 1, .reusable = false}, SHIFT(4968),
  [9828] = {.count = 1, .reusable = true}, SHIFT(4968),
  [9830] = {.count = 1, .reusable = true}, SHIFT(4970),
  [9832] = {.count = 1, .reusable = true}, SHIFT(4971),
  [9834] = {.count = 1, .reusable = true}, SHIFT(4972),
  [9836] = {.count = 1, .reusable = true}, SHIFT(4973),
  [9838] = {.count = 1, .reusable = true}, SHIFT(4974),
  [9840] = {.count = 1, .reusable = false}, SHIFT(4975),
  [9842] = {.count = 1, .reusable = true}, SHIFT(4976),
  [9844] = {.count = 1, .reusable = true}, SHIFT(4977),
  [9846] = {.count = 1, .reusable = false}, SHIFT(4978),
  [9848] = {.count = 1, .reusable = true}, SHIFT(4979),
  [9850] = {.count = 1, .reusable = true}, SHIFT(4985),
  [9852] = {.count = 1, .reusable = true}, SHIFT(4986),
  [9854] = {.count = 1, .reusable = true}, SHIFT(4987),
  [9856] = {.count = 1, .reusable = true}, SHIFT(4988),
  [9858] = {.count = 1, .reusable = false}, SHIFT(4989),
  [9860] = {.count = 1, .reusable = true}, SHIFT(4990),
  [9862] = {.count = 1, .reusable = true}, SHIFT(4995),
  [9864] = {.count = 1, .reusable = true}, SHIFT(4996),
  [9866] = {.count = 1, .reusable = true}, SHIFT(4999),
  [9868] = {.count = 1, .reusable = true}, SHIFT(5000),
  [9870] = {.count = 1, .reusable = true}, SHIFT(5004),
  [9872] = {.count = 1, .reusable = true}, SHIFT(5005),
  [9874] = {.count = 1, .reusable = true}, SHIFT(5011),
  [9876] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 9),
  [9878] = {.count = 1, .reusable = true}, SHIFT(5015),
  [9880] = {.count = 1, .reusable = true}, SHIFT(5018),
  [9882] = {.count = 1, .reusable = true}, SHIFT(5021),
  [9884] = {.count = 1, .reusable = true}, SHIFT(5022),
  [9886] = {.count = 1, .reusable = true}, SHIFT(5023),
  [9888] = {.count = 1, .reusable = false}, SHIFT(5024),
  [9890] = {.count = 1, .reusable = true}, SHIFT(5024),
  [9892] = {.count = 1, .reusable = false}, SHIFT(5026),
  [9894] = {.count = 1, .reusable = true}, SHIFT(5026),
  [9896] = {.count = 1, .reusable = true}, SHIFT(5027),
  [9898] = {.count = 1, .reusable = true}, SHIFT(5028),
  [9900] = {.count = 1, .reusable = true}, SHIFT(5029),
  [9902] = {.count = 1, .reusable = false}, SHIFT(5031),
  [9904] = {.count = 1, .reusable = true}, SHIFT(5030),
  [9906] = {.count = 1, .reusable = true}, SHIFT(5031),
  [9908] = {.count = 1, .reusable = false}, SHIFT(5033),
  [9910] = {.count = 1, .reusable = true}, SHIFT(5033),
  [9912] = {.count = 1, .reusable = false}, SHIFT(5034),
  [9914] = {.count = 1, .reusable = true}, SHIFT(5034),
  [9916] = {.count = 1, .reusable = false}, SHIFT(5036),
  [9918] = {.count = 1, .reusable = true}, SHIFT(5036),
  [9920] = {.count = 1, .reusable = false}, SHIFT(5037),
  [9922] = {.count = 1, .reusable = true}, SHIFT(5037),
  [9924] = {.count = 1, .reusable = true}, SHIFT(5039),
  [9926] = {.count = 1, .reusable = false}, SHIFT(5040),
  [9928] = {.count = 1, .reusable = true}, SHIFT(5040),
  [9930] = {.count = 1, .reusable = false}, SHIFT(5041),
  [9932] = {.count = 1, .reusable = true}, SHIFT(5041),
  [9934] = {.count = 1, .reusable = false}, SHIFT(5042),
  [9936] = {.count = 1, .reusable = true}, SHIFT(5042),
  [9938] = {.count = 1, .reusable = true}, SHIFT(5043),
  [9940] = {.count = 1, .reusable = true}, SHIFT(5044),
  [9942] = {.count = 1, .reusable = true}, SHIFT(5045),
  [9944] = {.count = 1, .reusable = true}, SHIFT(5046),
  [9946] = {.count = 1, .reusable = true}, SHIFT(5047),
  [9948] = {.count = 1, .reusable = true}, SHIFT(5048),
  [9950] = {.count = 1, .reusable = false}, SHIFT(5049),
  [9952] = {.count = 1, .reusable = true}, SHIFT(5053),
  [9954] = {.count = 1, .reusable = true}, SHIFT(5052),
  [9956] = {.count = 1, .reusable = true}, SHIFT(5055),
  [9958] = {.count = 1, .reusable = true}, SHIFT(5058),
  [9960] = {.count = 1, .reusable = true}, SHIFT(5059),
  [9962] = {.count = 1, .reusable = true}, SHIFT(5061),
  [9964] = {.count = 1, .reusable = true}, SHIFT(5062),
  [9966] = {.count = 1, .reusable = true}, SHIFT(5065),
  [9968] = {.count = 1, .reusable = true}, SHIFT(5068),
  [9970] = {.count = 1, .reusable = true}, SHIFT(5073),
  [9972] = {.count = 1, .reusable = true}, SHIFT(5074),
  [9974] = {.count = 1, .reusable = true}, SHIFT(5075),
  [9976] = {.count = 1, .reusable = false}, SHIFT(5076),
  [9978] = {.count = 1, .reusable = true}, SHIFT(5076),
  [9980] = {.count = 1, .reusable = false}, SHIFT(5077),
  [9982] = {.count = 1, .reusable = true}, SHIFT(5077),
  [9984] = {.count = 1, .reusable = false}, SHIFT(5078),
  [9986] = {.count = 1, .reusable = true}, SHIFT(5078),
  [9988] = {.count = 1, .reusable = true}, SHIFT(5079),
  [9990] = {.count = 1, .reusable = true}, SHIFT(5080),
  [9992] = {.count = 1, .reusable = false}, SHIFT(5081),
  [9994] = {.count = 1, .reusable = true}, SHIFT(5081),
  [9996] = {.count = 1, .reusable = false}, SHIFT(5083),
  [9998] = {.count = 1, .reusable = true}, SHIFT(5083),
  [10000] = {.count = 1, .reusable = false}, SHIFT(5085),
  [10002] = {.count = 1, .reusable = true}, SHIFT(5085),
  [10004] = {.count = 1, .reusable = true}, SHIFT(5087),
  [10006] = {.count = 1, .reusable = true}, SHIFT(5088),
  [10008] = {.count = 1, .reusable = true}, SHIFT(5089),
  [10010] = {.count = 1, .reusable = true}, SHIFT(5090),
  [10012] = {.count = 1, .reusable = true}, SHIFT(5091),
  [10014] = {.count = 1, .reusable = false}, SHIFT(5092),
  [10016] = {.count = 1, .reusable = true}, SHIFT(5093),
  [10018] = {.count = 1, .reusable = true}, SHIFT(5094),
  [10020] = {.count = 1, .reusable = false}, SHIFT(5095),
  [10022] = {.count = 1, .reusable = true}, SHIFT(5096),
  [10024] = {.count = 1, .reusable = true}, SHIFT(5100),
  [10026] = {.count = 1, .reusable = true}, SHIFT(5101),
  [10028] = {.count = 1, .reusable = true}, SHIFT(5102),
  [10030] = {.count = 1, .reusable = true}, SHIFT(5105),
  [10032] = {.count = 1, .reusable = true}, SHIFT(5106),
  [10034] = {.count = 1, .reusable = true}, SHIFT(5109),
  [10036] = {.count = 1, .reusable = true}, SHIFT(5110),
  [10038] = {.count = 1, .reusable = false}, SHIFT(5115),
  [10040] = {.count = 1, .reusable = true}, SHIFT(5115),
  [10042] = {.count = 1, .reusable = false}, SHIFT(5116),
  [10044] = {.count = 1, .reusable = true}, SHIFT(5116),
  [10046] = {.count = 1, .reusable = false}, SHIFT(5117),
  [10048] = {.count = 1, .reusable = true}, SHIFT(5117),
  [10050] = {.count = 1, .reusable = true}, SHIFT(5118),
  [10052] = {.count = 1, .reusable = true}, SHIFT(5119),
  [10054] = {.count = 1, .reusable = true}, SHIFT(5120),
  [10056] = {.count = 1, .reusable = true}, SHIFT(5121),
  [10058] = {.count = 1, .reusable = true}, SHIFT(5122),
  [10060] = {.count = 1, .reusable = true}, SHIFT(5123),
  [10062] = {.count = 1, .reusable = false}, SHIFT(5124),
  [10064] = {.count = 1, .reusable = true}, SHIFT(5128),
  [10066] = {.count = 1, .reusable = true}, SHIFT(5127),
  [10068] = {.count = 1, .reusable = true}, SHIFT(5130),
  [10070] = {.count = 1, .reusable = true}, SHIFT(5131),
  [10072] = {.count = 1, .reusable = true}, SHIFT(5134),
  [10074] = {.count = 1, .reusable = true}, SHIFT(5137),
  [10076] = {.count = 1, .reusable = true}, SHIFT(5138),
  [10078] = {.count = 1, .reusable = true}, SHIFT(5139),
  [10080] = {.count = 1, .reusable = true}, SHIFT(5142),
  [10082] = {.count = 1, .reusable = true}, SHIFT(5143),
  [10084] = {.count = 1, .reusable = true}, SHIFT(5147),
};

void *tree_sitter_tsx_external_scanner_create();
void tree_sitter_tsx_external_scanner_destroy(void *);
bool tree_sitter_tsx_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_tsx_external_scanner_serialize(void *, char *);
void tree_sitter_tsx_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_tsx() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_tsx_external_scanner_create,
      tree_sitter_tsx_external_scanner_destroy,
      tree_sitter_tsx_external_scanner_scan,
      tree_sitter_tsx_external_scanner_serialize,
      tree_sitter_tsx_external_scanner_deserialize,
    },
  };
  return &language;
}
